prompt --application/set_environment
set define off verify off feedback off
whenever sqlerror exit sql.sqlcode rollback
--------------------------------------------------------------------------------
--
-- Oracle APEX export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_220100 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_imp.import_begin (
 p_version_yyyy_mm_dd=>'2022.04.12'
,p_release=>'22.1.11'
,p_default_workspace_id=>2400405578329584
,p_default_application_id=>984343
,p_default_id_offset=>0
,p_default_owner=>'FLOWS4APEX'
);
end;
/
 
prompt APPLICATION 984343 - Simple Process Starter
--
-- Application Export:
--   Application:     984343
--   Name:            Simple Process Starter
--   Date and Time:   05:59 Tuesday October 8, 2024
--   Exported By:     NIELSDEBR@GMAIL.COM
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                     14
--       Items:                   41
--       Computations:            10
--       Validations:              1
--       Processes:               23
--       Regions:                 44
--       Buttons:                 22
--       Dynamic Actions:         18
--     Shared Components:
--       Logic:
--         Items:                  3
--         Build Options:          1
--       Navigation:
--         Lists:                  2
--         Breadcrumbs:            1
--           Entries:              2
--       Security:
--         Authentication:         1
--         Authorization:          1
--         ACL Roles:              1
--       User Interface:
--         Themes:                 1
--         Templates:
--           Page:                10
--           Region:              19
--           Label:                7
--           List:                13
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               3
--           Report:              12
--         LOVs:                   3
--         Shortcuts:              1
--         Plug-ins:               5
--       Globalization:
--       Reports:
--       E-Mail:
--     Supporting Objects:  Included
--       Install scripts:          6
--       Validations:              1
--   Version:         22.1.11
--   Instance ID:     204275825414274
--

prompt --application/delete_application
begin
wwv_flow_imp.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_imp.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'FLOWS4APEX')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Simple Process Starter')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'PROCESS-STARTER')
,p_page_view_logging=>'YES'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt=>'84BE2113EDBE0D3B5396AA0BD2CB61A6F9B59D86E1240948AC6C7ECA50DA5FD6'
,p_bookmark_checksum_function=>'SH512'
,p_compatibility_mode=>'21.2'
,p_flow_language=>'en'
,p_flow_language_derived_from=>'FLOW_PRIMARY_LANGUAGE'
,p_allow_feedback_yn=>'Y'
,p_date_format=>'DS'
,p_timestamp_format=>'DS'
,p_timestamp_tz_format=>'DS'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_documentation_banner=>'Application created from create application wizard 2024.05.23.'
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_imp.id(34415582036496647)
,p_application_tab_set=>1
,p_logo_type=>'T'
,p_logo_text=>'Flows for APEX - Simple Process Starter'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'Release 24.1'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_referrer_policy=>'no-referrer'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_tokenize_row_search=>'N'
,p_substitution_string_01=>'APP_NAME'
,p_substitution_value_01=>'Process Starter'
,p_last_updated_by=>'NIELSDEBR@GMAIL.COM'
,p_last_upd_yyyymmddhh24miss=>'20241008055831'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_files_version=>13
,p_ui_type_name => null
,p_print_server_type=>'NATIVE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/workflow/task_definitions/approval
begin
wwv_flow_imp_shared.create_task_def(
 p_id=>wwv_flow_imp.id(8817659088768002)
,p_name=>'Approval'
,p_static_id=>'APPROVAL'
,p_subject=>'Approve Order &PROCESS_ID.'
,p_priority=>3
,p_details_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:RP,6:P6_TASK_ID:&TASK_ID.'
);
wwv_flow_imp_shared.create_task_def_param(
 p_id=>wwv_flow_imp.id(8819034262773068)
,p_task_def_id=>wwv_flow_imp.id(8817659088768002)
,p_label=>'Process Id'
,p_static_id=>'PROCESS_ID'
,p_data_type=>'VARCHAR2'
,p_is_required=>true
,p_is_visible=>true
);
wwv_flow_imp_shared.create_task_def_action(
 p_id=>wwv_flow_imp.id(8820005348786747)
,p_task_def_id=>wwv_flow_imp.id(8817659088768002)
,p_name=>'Return to Flows for APEX (approved)'
,p_execution_sequence=>10
,p_outcome=>'APPROVED'
,p_on_event=>'COMPLETE'
,p_action_type=>'PLUGIN_COM.FLOWS4APEX.RETURN.TO.FLOWS.PROCESS'
,p_attribute_01=>'PROCESS_ID'
,p_location=>'LOCAL'
,p_success_message=>'Approved'
,p_stop_execution_on_error=>true
);
wwv_flow_imp_shared.create_task_def_action(
 p_id=>wwv_flow_imp.id(8820379998807358)
,p_task_def_id=>wwv_flow_imp.id(8817659088768002)
,p_name=>'Return to Flows for APEX (rejected)'
,p_execution_sequence=>20
,p_outcome=>'REJECTED'
,p_on_event=>'COMPLETE'
,p_action_type=>'PLUGIN_COM.FLOWS4APEX.RETURN.TO.FLOWS.PROCESS'
,p_attribute_01=>'PROCESS_ID'
,p_location=>'LOCAL'
,p_success_message=>'Rejected'
,p_stop_execution_on_error=>true
);
wwv_flow_imp_shared.create_task_def_participant(
 p_id=>wwv_flow_imp.id(8817940566768002)
,p_task_def_id=>wwv_flow_imp.id(8817659088768002)
,p_participant_type=>'POTENTIAL_OWNER'
,p_identity_type=>'USER'
,p_value_type=>'SQL_QUERY'
,p_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  USER_NAME',
'from',
'  APEX_WORKSPACE_APEX_USERS'))
);
wwv_flow_imp_shared.create_task_def_participant(
 p_id=>wwv_flow_imp.id(8818375915768003)
,p_task_def_id=>wwv_flow_imp.id(8817659088768002)
,p_participant_type=>'BUSINESS_ADMIN'
,p_identity_type=>'USER'
,p_value_type=>'SQL_QUERY'
,p_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  USER_NAME',
'from',
'  APEX_WORKSPACE_APEX_USERS'))
);
end;
/
prompt --application/shared_components/navigation/lists/desktop_navigation_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(34416398515496650)
,p_name=>'Desktop Navigation Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34732049455459384)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'My Processes'
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-workflow'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1,5,8'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5116458879716982)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'My Tasks'
,p_list_item_link_target=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-clipboard-user'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34716633299196110)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Administration'
,p_list_item_icon=>'fa-user-secret'
,p_security_scheme=>wwv_flow_imp.id(34558694639496789)
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34593937045699245)
,p_list_item_display_sequence=>31
,p_list_item_link_text=>'Form Data'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-table'
,p_parent_list_item_id=>wwv_flow_imp.id(34716633299196110)
,p_security_scheme=>wwv_flow_imp.id(34558694639496789)
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34635709362930604)
,p_list_item_display_sequence=>32
,p_list_item_link_text=>'Process Trigger'
,p_list_item_link_target=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'fa-forms'
,p_parent_list_item_id=>wwv_flow_imp.id(34716633299196110)
,p_security_scheme=>wwv_flow_imp.id(34558694639496789)
,p_list_item_current_type=>'ALWAYS'
);
end;
/
prompt --application/shared_components/navigation/lists/desktop_navigation_bar
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(34555717686496760)
,p_name=>'Desktop Navigation Bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34567568582496825)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'&APP_USER.'
,p_list_item_link_target=>'#'
,p_list_item_icon=>'fa-user'
,p_list_text_02=>'has-username'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34568001650496826)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(34567568582496825)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34568470280496826)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Sign Out'
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_item_icon=>'fa-sign-out'
,p_parent_list_item_id=>wwv_flow_imp.id(34567568582496825)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/files/icons_app_icon_32_png
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000020000000200806000000737A7AF4000000017352474200AECE1CE900000214494441545847ED95B14B1B6118C69F8BC95DA26943B03A9C9E514B6C4F87A6A8044128148A4310443A38F40F2842A1ED5427';
wwv_flow_imp.g_varchar2_table(2) := '3B7577912E851617057173702988B1604B5BAD94D894A4916B525BD39A684872B92427DF574C4D71B83B7A48E1DEE55B0E9EDFFBBCCFBD2FF37AE2998A732CC602B01CB01CF8AF1D48173270D8ECF0706EC39BC4F01E20E2EDC11EC8650599F792610843';
wwv_flow_imp.g_varchar2_table(3) := '004AB50CB5BD11FC151FED3CF56917CCD73C75436F190288659310C4AE3AAD6F892478BB5737846E00D2FDD54723F0887C1D403692C2F6936534DA9DBA4CD00D205F64303473878A449EAFD2B73BD40FAEC58DB57B2FD094B3990BE00AB641BC7B13A4E3';
wwv_flow_imp.g_varchar2_table(4) := 'FDCD042A6A159DB7021420F2F4250A1B4973013CA11E5CBE1DA4220482D4C938B666575079F3C35C8086C1565C9B1C395324B6B881EC72D43C807CB908AEB7058353635444DECFD197D84F2A3C3D0FC48F740551730849FA2F04781CA633B87E3F4445FF';
wwv_flow_imp.g_varchar2_table(5) := '1EC1FAC339B0DE26C8D19F9A2134031C3915740DF5A25490218CFF4EFD6900E286B4F416AC8BC3E7F50FF0965C9A46A119A0C4B3B5CD27ED7CC1C0835114D387B510861F2FA0A3FBCF66645325F300E2EF76200C8BB8D4275091F447097BAFA21002FEDA';
wwv_flow_imp.g_varchar2_table(6) := '6A360D80D8CBE519E49522F81B222A6A05BFC271381AEC70FABC68F6F3F81E95F0CF010ED8021C651BDC55AE662DF92BC8013A394224A8399B0CC5A1A255D176A2356740D3400D7C6401580E580E9CBB03C715180DF0372336D80000000049454E44AE42';
wwv_flow_imp.g_varchar2_table(7) := '6082';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(8549333588684315)
,p_file_name=>'icons/app-icon-32.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/icons_app_icon_192_png
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '89504E470D0A1A0A0000000D49484452000000C0000000C0080600000052DC6C07000000017352474200AECE1CE900000E7749444154785EED9D4D6C55C715C70FC48EF1077D2ECF916313DC804B6DC7452104872A724AAA122125525984058A944D5555';
wwv_flow_imp.g_varchar2_table(2) := '4D37A9BAEAA25255B58BAEAAAE922E9A6E22B55D248B544AA4945429810D503E52070C051B61028E554370F007C606AA79CEBB3E6F7CDFBD33E7CE7BCE9BF9B34B3C73E79EFF39BF3B67CECCBB77CDB1036FDC27FC8302812AB0060004EA79985D500000';
wwv_flow_imp.g_varchar2_table(3) := '20108256000004ED7E180F001003412B000082763F8C07008881A015000041BB1FC60300C440D00A0080A0DD0FE30100622068050040D0EE87F100003110B402002068F7C378008018085A010010B4FB613C00400C04AD000008DAFD301E002006825600';
wwv_flow_imp.g_varchar2_table(4) := '0004ED7E180F001003412B000082763F8C07008881A015000041BB1FC60300C440D00A0080A0DD0FE30100622068050040D0EE87F100003110B402002068F7C378008018085A010010B4FB613C00400C04AD000008DAFD301E0020068256000004ED7E18';
wwv_flow_imp.g_varchar2_table(5) := '0F001003412B000082763F8C07008881A015000041BB1FC60300C440D00A0080A0DD0FE30100622068050040D0EE87F100003110B402002068F7C378008018085A010010B4FB613C0058A51858B8B74863B7260AA377AD6FA7FAB575AB7427610F0B0056';
wwv_flow_imp.g_varchar2_table(6) := 'C1FFB38BB769EC8BA5E057FFEA1FA8A38EE63C35D5AD5B85BB097B48005065FFEBC10F08AAEC006D38005045FDF5E06F6C692A8C3E373D8B99A08A7EE04301802A091F17FC3D3BFBE9C1A67534F4D1094050253FE8C300802A081F97F66C7F76805AF2B9';
wwv_flow_imp.g_varchar2_table(7) := 'C2E877E6E6E9D87B87B126A8822F0040954556D59E919B574B46E5C15FFC431C04A80E55DE5998012AA871B1D4B97077311A252EF88B7FBC3E3641C3C7874A660240504107111100A8A0BE63B73EA3D98579A3E04F82A03BB7B1827719F6A5014085FCAF';
wwv_flow_imp.g_varchar2_table(8) := '077FDFC036CA77B51B8D76EDFC651AFDE442D436D7D04C1DCD6D467DD1C84E010060A79751EBC9B99B34393715B5B509FE62271D82B6C61CB535B61A8D8F46E60A000073AD8C5AEA159F2DDFDE4A9D3DDF30EAAB37D221E8FA5A3B768B454A96EF04001C';
wwv_flow_imp.g_varchar2_table(9) := '0B3A3275958A8BDE0DED797A6CF009F108AA3274F1C459BA3171BD700D756402EB01B19CB11D0180433D258BDEB4E1F5F228D603698AD9FD1D00D8E955B6B5CBD4471F442F8FAA8373B9861647771EF665008003FFEB9B5D59531FFD96E25221EC0F3870';
wwv_flow_imp.g_varchar2_table(10) := '1CF601DC885889D4270E027E5CA2A9BE81BAD63FECC68080AF821920A3F32B99FAA4A542A80A65741E6680EC02F2A7BFEBD4C724154255289B0F310364D06F6A7E9AC667964A94EA5FD2399F0CC39474D5AB4258106753160064D08FD7FCB36C78D9DE02';
wwv_flow_imp.g_varchar2_table(11) := 'AF0A616FC056BDD2F60040A89F7EDC41781927DDB0372097110008B53B77E3B2B0A7FB6E9805E49A020081767AEE2FB884F32E382C279314000874E3B9FFF77EBE9F3A76F70AAE92BDCBF8A173F4E1EFDF2A5C08B3804C4F0060A99BFEF47FE99D5F5A5E';
wwv_flow_imp.g_varchar2_table(12) := 'C15DF3F9FF4DD3DB3FFA437441EC0BD86B0B002C35E375FFFEBD03F4F84FF75A5EC16DF391B78ED2D1370F162E8ADD617B6D01808566FA999F17FFF4336A7868750FA56116B070604C530060A1DFF8CC244DCDCF147A7C159EFEC55B3FF2ABBFD1D8E98B';
wwv_flow_imp.g_varchar2_table(13) := '85FF4449D4C2A1380A6127165FFCBEF0BB1F52AEAFD3EE02156A3D357C8DDEFDC59FB11816E88B19C042345EFB972E7E55CAF2E9A133343E74A9F0D4CE75E429D7FE756A7DB88DB6EEFF8E28A5421A64E144AD290030D48E577FA4E90F7F52C70DAB60E8';
wwv_flow_imp.g_varchar2_table(14) := 'DDB383BAF7EF32BCABE5663C0DC29E80B97C00C0502B5EFD91D4FE79B5266DC85D2F3F670D01870BD5A0348597FF0E000CB5E2E98F6DF5477FF2B77577D0969D7DD4BAE921BA77FF1ECD5CFB9C2E1C3B439323E34B0BD98E3C0DBEBACF6A8DC1D3206C8A';
wwv_flow_imp.g_varchar2_table(15) := '193A158B6033A1B2A63F3C3DD9F47837F53DB773C5C00A84F31F9CA42B1F8F4410BCF0C757CC6EF0CB567C1C6C8A99498719C040275EFE94A43F7FD9F7DBA50A4D5303ED7EE507B476CDDAD8511504875EFF3B2DCC2EBD4ED176A6E16916D601068EC50C';
wwv_flow_imp.g_varchar2_table(16) := '60265296FC9F9FD7D9FCC4B768EBF793DF13347CF0DFD12C605B6AC53AC0CC9FBC15660003CD78FD3FCB53B9EF99EDB469574FE288578E9EA7E1C3A70B6D6C17C358071838536B02000C34CB52FFE74FE572F93FBF850BFF3C45974EFDB7F0BFB2A45BAA';
wwv_flow_imp.g_varchar2_table(17) := '7F77EB467C7D32C5BF00204520BE00EEDAFE4D1AFCF5010364969BF0A772D3FA667AFAC7CF27AF015E7B8716E6EE88D600AA1316C256EEC1F701D2E4CA5A01D28332691618FEC771BAF29FD1C22D496053FD3E7EED7D3AF3FEF1C235B0104EF32E3E9091';
wwv_flow_imp.g_varchar2_table(18) := 'AA50D60A901A403FAAA0F601B63ED54FEB37E60BFB00D3573FA78B6A1F6074691F40FDB35D0017FBF14A100EC6A5BA1733409A442E005063547A27B868072A41691E2DFD3BD600297AF112A8F4A95C1C4295444FFEF5439A1A5F7E97101F5EB203ACDF3E';
wwv_flow_imp.g_varchar2_table(19) := '000000760AA4B4767D04BADC69D08E6D9BADCFFFC4DD3A00B0733F66000B006CF700EC5CE1A635F602EC74040000C02E623C6B0D00521C9A65136CB562A578F6488DDFBB41F67DB2D5BAF76A8F0B000040B563EE2B351E00F02C0552E644A74FF151BD54';
wwv_flow_imp.g_varchar2_table(20) := 'D80080670060119C1AF3250D004015F701EC5C236B8D32A89D6E00C063007014221D060090A2113F0A91752738DD1DD95BF01FE00080743D0180C50C60FB039574F9DDB7C0BB42ED340500097AF1A7BF6A263DA26CE7926CADF9716875251C894ED61300';
wwv_flow_imp.g_varchar2_table(21) := '94D1470FFE5A01E0DD9FBCBEE2B01D20280F010088D1262EF85533755AD3F6552549CF1F15ACEADF9EDFBC2C7A2562DCB5E300C04C00008CF30A3DF83B373F42D72E7D1AF57775208E2F565DAE2DF83108F5E5CAD14F2E44F78E996065186006609AC405';
wwv_flow_imp.g_varchar2_table(22) := 'FF961DBD74F6C829BA31B17486DF5525882F565D01C0A152E0AA7BBF76FE32204878FC01802FC52917FCEACF3C885C056B2500E00B60FEDD624080142831054A0A7ED571FAFA149DFED7D20FCD5DAD032A0100CFFFFB06B651BEAB3DB21B10C48740F033';
wwv_flow_imp.g_varchar2_table(23) := '405AF02BD9EECCCDD3B1F70E470A4ABF0DC05D50090078FE3FF8E29E151E070458039428A07FEDBD9837C73D2B5CAF035C03C0F3FF0DED797A6C30FE158C80A0D4BBC1CE00B38BB769EC8B89488DA4A0D1D7012E36C45C03502EFF8F839943A05EA5DED1';
wwv_flow_imp.g_varchar2_table(24) := '9CA7A6BA75C695329F1A060B00FFB17B5AF0EB69908B75806B0078FAF3D4F3CFD0838D0D65E354A574174F9C8D2A5B217F4F204800F48F5DC7E5CB954E835C02609AFE709B1404431F9DA0B9E9D9C2FF56B340AE61753FF9BA1A334B9000F0A7BF5E2D49';
wwv_flow_imp.g_varchar2_table(25) := '72024F1DB2A6412E01E0E98F8D3DD7C72668F8F850C1E4506781E000903EFD5DA7412E01B0497F92668110BF2A131C00BCEC9954F5293713F06A50964D315700C4EDFEDAA412A327CF45473D423C2A111C00FC558736E94231A85C6D8AB902806F7E6D7F';
wwv_flow_imp.g_varchar2_table(26) := '76805AF2399BF82FD9E40BF1EB92C101C0F3FFB46A495C24E91514E9D9201700F0A77F634B133DB9F769ABE0D7D3BA10D7010020A15C582E9AF8E251BA18760100FF188664360300017E1F80BFE9CDB4FCA983A0971025B3405600F46F0F4B6D51B61D79';
wwv_flow_imp.g_varchar2_table(27) := 'FB83C8C4D0DE2417DC0CE00200152D7C16906C8C6505803FFDF9C94FEB1C0800BC715F225AADF67105803E0BD87ED02E0B003CF7577EC8F2F4C70C7000004861CE320B640120E9D8B3C416A44012D56AB48FAB19A0B880E4676A6CF605A400F07E266798';
wwv_flow_imp.g_varchar2_table(28) := '4CDC04004C54F2A48D4B00E27687075FDD47B9BECE54B52400E81FDB93D4FDE36E0C00A4BACB9F06AE0150CAF0DD54D305B10400BEF095EC6297F32200F027BE532DA93400EA064C52215B00F4AF4C66ADFC70A100406AD8F8D3C03500FCE95F54C9E46B';
wwv_flow_imp.g_varchar2_table(29) := '8F3600E835FFE238AE200000FEC477AA25AE00D08F44E803A7A5423600F0D4471D5758B8BB180D273D0281196049016C84A522B3B2415CF0AB3731B735B6D2D8AD892840938E499802A0077FD7FA765247BA27E7A64A20D8F6DD27137F05966426660041';
wwv_flow_imp.g_varchar2_table(30) := '10D46A97AC33003F0D5AD4801F235EB8B7482337AF46F2945B0F9800A0E7FDFCBCBEFE837E3513F4ECECB73E0DAA6E1400D46A340BEE3B0B0071C11FF72312FD47377110A401A0E7FD713F59D4C75110743CBA913A7BECBE0C0900048154AB5DA400E8AF';
wwv_flow_imp.g_varchar2_table(31) := '13497B9B027F42ABF540EF9E1DF4C8EEFEE825B8E500287E49FEE89B07238993CEE9AB1987A75DAA93EDE21800D46A340BEE5B02805EE951C1AF72F1FAB57565EF4005A6FAF5D9ECC2BCE02E97BB989CD1CF0A0100C8E4A2DAEA6C0340DC62D7E657532A';
wwv_flow_imp.g_varchar2_table(32) := '30F505AB8D5AB663A959676A7EC6BA4204006CBC52E36D4D012857E9E9686EB3564041A05EC435BB385F52C28CBB907AE237D5351466175555B2F917079C5A17A4558800808DCA35DED60480B44A8F0B09F81AC1F58FD16D2B4400C085476BE41A6900F0';
wwv_flow_imp.g_varchar2_table(33) := '23CE45932AF1BA904A02A0EEDBA64204006A24785DDC661C002ADDB9337B9BC68647A3D705AAB1D22A3D59EEA7D200A87B8B5B1CAB94E8D1BE6E6A685E17ED1900802C9EACB1BE1C80A45B37A9F46431BD1A00948320E9BEF19BE02C5EAD81BE2600B8CE';
wwv_flow_imp.g_varchar2_table(34) := 'C9E364E10054FABD9C36D528005003419CE516F5056231D5A95FFB40E115E1B69517E9BD14F70916EEDD4DDD53908EA1F75363CE2EA86AD4ED427AC4F728D48CD7B62E17DC0B72833B0CE72A98701D3F1400007EF811560815000042E1D0CD0F0500801F';
wwv_flow_imp.g_varchar2_table(35) := '7E841542050080503874F3430100E0871F618550010020140EDDFC500000F8E1475821540000088543373F1400007EF811560815000042E1D0CD0F0500801F7E841542050080503874F3430100E0871F618550010020140EDDFC500000F8E14758215400';
wwv_flow_imp.g_varchar2_table(36) := '00088543373F1400007EF811560815000042E1D0CD0F0500801F7E841542050080503874F3430100E0871F618550010020140EDDFC500000F8E1475821540000088543373F1400007EF811560815000042E1D0CD0F0500801F7E841542050080503874F3';
wwv_flow_imp.g_varchar2_table(37) := '430100E0871F618550010020140EDDFC500000F8E1475821540000088543373F1400007EF811560815000042E1D0CD0F0500801F7E841542050080503874F3430100E0871F618550010020140EDDFC500000F8E1475821540000088543373F1400007EF8';
wwv_flow_imp.g_varchar2_table(38) := '11560815000042E1D0CD0F0500801F7E841542050080503874F3430100E0871F618550010020140EDDFC500000F8E147582154E0FF5F6C8CC86EF69D910000000049454E44AE426082';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(8549548651684324)
,p_file_name=>'icons/app-icon-192.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/icons_app_icon_512_png
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '89504E470D0A1A0A0000000D4948445200000200000002000806000000F478D4FA000000017352474200AECE1CE90000200049444154785EEDDD7F8C5ED59DDFF12FD8C3783CB61F7B3CF630FE315E6C0CC606D660BC0EC4E18702F1765929696155844A';
wwv_flow_imp.g_varchar2_table(2) := 'D4D26D15B6699B46FD833F5245D1EE4AFCD1462B354DA22D8DD42245A916BA415A5A1C48F9B1CE02E69731E01F809D78C01EC61E1B3FC633F63063521DC3B31D8679EE39F7D7B9DF73CF1B29CA1FBEF79E735EDFF3CCF379EE3DF7DE0B76DEF5DF7E2BFC';
wwv_flow_imp.g_varchar2_table(3) := '870002082080000251095C400088AADE0C16010410400081F30204002602020820800002110A1000222C3A434600010410408000C01C4000010410402042010240844567C8082080000208100098030820800002084428400088B0E80C19010410400001';
wwv_flow_imp.g_varchar2_table(4) := '020073000104104000810805080011169D212380000208204000600E20800002082010A1000120C2A233640410400001040800CC0104104000010422142000445874868C0002082080000180398000020820804084020480088BCE901140000104102000';
wwv_flow_imp.g_varchar2_table(5) := '3007104000010410885080001061D119320208208000020400E600020820800002110A1000222C3A434600010410408000C01C4000010410402042010240844567C8082080000208100098030820800002084428400088B0E80C19010410400001020073';
wwv_flow_imp.g_varchar2_table(6) := '000104104000810805080011169D212380000208204000600E20800002082010A1000120C2A233640410400001040800CC0104104000010422142000445874868C0002082080000180398000020820804084020480088BCE901140000104102000300710';
wwv_flow_imp.g_varchar2_table(7) := '4000010410885080001061D119320208208000020400E600020820800002110A1000222C3A434600010410408000C01C4000010410402042010240844567C8082080000208100098030820800002084428400088B0E80C19010410400001020073000104';
wwv_flow_imp.g_varchar2_table(8) := '104000810805080011169D212380000208204000600E20800002082010A1000120C2A233640410400001040800CC0104104000010422142000445874868C0002082080000180398000020820804084020480088BCE901140000104102000300710400001';
wwv_flow_imp.g_varchar2_table(9) := '0410885080001061D119320208208000020400E600020820800002110A1000222C3A434600010410408000C01C4000010410402042010240844567C8082080000208100098030820800002084428400088B0E80C19010410400001020073000104104000';
wwv_flow_imp.g_varchar2_table(10) := '810805080011169D212380000208204000600E20800002082010A1000120C2A233640410400001040800CC0104104000010422142000445874868C0002082080000180398000020820804084020480088BCE901140000104102000300710400001041088';
wwv_flow_imp.g_varchar2_table(11) := '5080001061D119320208208000020400E600020820800002110A1000222C3A434600010410408000C01C4000010410402042010240844567C8082080000208100098030820800002084428400088B0E80C19010410400001020073000104104000810805';
wwv_flow_imp.g_varchar2_table(12) := '080011169D212380000208204000600E20800002082010A1000120C2A233640410400001040800CC0104104000010422142000445874868C0002082080000180398000020820804084020480088BCE901140000104102000300710400001041088508000';
wwv_flow_imp.g_varchar2_table(13) := '1061D119320208208000020400E600020820800002110A1000222C3A434600010410408000C01C4000010410402042010240844567C8082080000208100098030820800002084428400088B0E80C19010410400001020073000104104000810805080011';
wwv_flow_imp.g_varchar2_table(14) := '169D212380000208204000600E20800002082010A1000120C2A233640410400001040800CC0104104000010422142000445874868C0002082080000180398000020820804084020480088BCE9011400001041020003007104000010410885080001061D1';
wwv_flow_imp.g_varchar2_table(15) := '19320208208000020400E600020820800002110A1000222C3A434600010410408000C01C4000010410402042010240844567C8082080000208100098030820800002084428400088B0E80C19010410400001020073000104104000810805080011169D21';
wwv_flow_imp.g_varchar2_table(16) := '2380000208204000600E20800002082010A1000120C2A233640410400001040800CC0104104000010422142000445874868C0002082080000180398000020820804084020480088BCE9011400001041020003007104000010410885080001061D1193202';
wwv_flow_imp.g_varchar2_table(17) := '08208000020400E600020820800002110A1000222C3A434600010410408000C01C4000010410402042010240844567C8082080000208100098030820800002084428400088B0E80C19010410400001020073000104104000810805080011169D21238000';
wwv_flow_imp.g_varchar2_table(18) := '0208204000600E20800002082010A1000120C2A233640410400001040800CC0104104000010422142000445874868C0002082080000180398000020820804084020480088BCE901140000104102000300710884C60E2E34919397352C626C7CF8FBCE3C2';
wwv_flow_imp.g_varchar2_table(19) := '59D2DFDD2B1D17CE8E4C82E12210B7000120EEFA33FAC804C626CFCAE0A9E11947BD66E172424064F381E1C62D400088BBFE8C3E2281A42FFF16437FF7626974CE8B4885A12210AF000120DEDA33F288045CBEFC0901114D08868A80881000980608D45C';
wwv_flow_imp.g_varchar2_table(20) := 'A0397E5A86468FA71A656F57437ABB16A6DA878D1140202C01024058F5A2B708A412308BFD46CE3453EDD3DA981090898D9D1008468000104CA9E82802E904864647A4393E9A6EA7695B130272F1B13302AA050800AACB43E710C82630F8E1FB3236F1C9';
wwv_flow_imp.g_varchar2_table(21) := '6D7E79FF3321C02C0CE436C1BC92EC8F802E010280AE7AD01B04720B14F9E5DFEA0C21207759380002EA040800EA4A428710C82E90E6CBBF6BDEDCF30D9D393DE6D42021C089898D1008468000104CA9E82802C90269AEF9F7F42D96F55BAF91736727E5';
wwv_flow_imp.g_varchar2_table(22) := 'CD9DBBE4D4B1934EBCAC097062622304821020000451263A8940F15FFEAD231202985D08C429400088B3EE8CBA4602597EF94F1F3E21A0461382A120E02840007084623304340A14F1E5CF99008D95A54F08942F400028DF9816102845A0C82F7F424029';
wwv_flow_imp.g_varchar2_table(23) := '25E2A008A8162000A82E0F9D43606681348FF76D2DF873B5E47280AB14DB2110B6000120ECFAD1FB0805D2BCD827ED977FD63301BC4530C289C89083172000045F42061093808F2FFFA921E0F0AF076570CF4127E2350B97F3B440272936424087000140';
wwv_flow_imp.g_varchar2_table(24) := '471DE805025681898F27E5C0C9C3D6EDCC06597FF94F3FB8B91C40087022672304821320000457323A1CA340155FFE59CE0474CC9A2D03F3FB381310E32465CCC1091000822B191D8E4DC07CF99B15FF2E2FF729EA97FF4C67025C9F184808886D8632DE';
wwv_flow_imp.g_varchar2_table(25) := '50050800A1568E7E4723E0FA7C7FF36CFF4DDB6E28CDE5A333E3F2FAB32F3BBD3B606E47A7F477F77226A0B46A706004F20B1000F21B7204044A1370BDD7DFFCEADEF0A56B64DEE246697D31074E1302786F40A9A5E0E008E4162000E426E40008942330';
wwv_flow_imp.g_varchar2_table(26) := '72E6A48C9C693A1D7CE3CD9B4BFFF26F75E4CCE898EC7E62A74C9C9BB4F68D1060256203042A13200054464FC308B4174873BB9FCF2FFF568F870F1D91B75FDAE354426E0F7462622304BC0B1000BC93D32002C9026956FCAFBE72AD2CBB7C5525A447F6';
wwv_flow_imp.g_varchar2_table(27) := '1F92836FBC6D6D9B458156223640A01201024025EC348A407B01D7457F7D172F95B55FBCBA524A4240A5FC348E402E0102402E3E7646A05801D72FFFB26EF74B3B9A34EF0D603D405A5DB647A05C010240B9BE1C1D016701D7457F65DFEEE7DCE14F3734';
wwv_flow_imp.g_varchar2_table(28) := '2160D7333B9D6E0F2404A4D5657B04CA1320009467CB91117016705DF467BEFCAFBA71935CD4D5E97C6C1F1BA6B93D9045813E2A421B08D80508007623B640A05481348BFEAA58F1EF3A7813025EDDFE9CF5F6401605BA8AB21D02E50A1000CAF5E5E808';
wwv_flow_imp.g_varchar2_table(29) := '58055CAFFB6BFEF26F0DD2F5F6402E0558A7051B2050BA0001A074621A40A0BD80EB757F0D2BFE5DEBE87A670021C05594ED1028478000508E2B4745C02AE07AEA5FDBA23FDBC0D22C0A643D804D937F47A03C01024079B61C1981448103CDC3D6EBE5E6';
wwv_flow_imp.g_varchar2_table(30) := '00219CFA9F3E50D60330F911D02F4000D05F237A584301D797FC54F9A4BFBCECAC07C82BC8FE08942B400028D797A323F03981E6F869191A3D6E95D1F2B01F6B471336D8B3E35539316C1F2BEB01F228B32F02D9040800D9DCD80B814C0275BDEEDF0E83';
wwv_flow_imp.g_varchar2_table(31) := 'E703649A26EC84801701028017661A41E013813ADDF2E75AD393C74EC8FE5FEDB6AE77E02C80AB28DB21508C0001A018478E828055C0F5697F215FF76F87E07A6B607FF7626974CEB35AB2010208E4172000E437E4080858055C4FFDD7E1BAFF4C18AE2F';
wwv_flow_imp.g_varchar2_table(32) := '0DE22981D6A9C4060814264000288C920321D05EC0E5D4BFF9F2BB66DBF5EA9EF35F545D5D6F0DE4524051E21C07816401020033048192055C4FFD8778BF7F5A3AD75B030716F4C9DCD973D21E9EED1140208500012005169B229056C0F5D4FFB24B56C8';
wwv_flow_imp.g_varchar2_table(33) := 'EA6BD7A53D7C90DBBFBBEB6D3974E05062DFB914106469E97460020480C00A4677C3127079D6BFF9B2DBF2B59BC31A588EDE722920071EBB2250A00001A0404C0E85C05401D75FFF6BAF5B2F7DAB964585E77A2980770544352D18AC6701028067709A8B';
wwv_flow_imp.g_varchar2_table(34) := '47C065E1DF82250BE5EA1BAF8B0765CA48773FFB929C3A763271EC733B3A6560FEC551FA306804CA162000942DCCF1A314707DDC6F0C0BFFDA4D8033A363B2FB899DD60704F16C80283F420CDA830001C003324DC427B0EF44F2223723B26ACD2A59B971';
wwv_flow_imp.g_varchar2_table(35) := '6D7C385346ECF280201604463D45187C89020480127139749C022CFC73AFBB7940D0AE6776CA99D363893BF16C007753B644C0558000E02AC576083808B82EFCBBF2C66B65E1921E8723D67F131604D6BFC68C50A7000140675DE855A0022E0BFFEAFAB8';
wwv_flow_imp.g_varchar2_table(36) := 'DF3C25735910C859803CC2EC8BC0E7050800CC0A040A1270FDF5BFE9962F48570F2FBC99CAEEFA6C006E0B2C68B2721804448400C03440A02001975FFF757CD35F417CE2B22090DB028BD2E6380810009803081422E0F2BCFFAE797365D3B61B0A69AF8E';
wwv_flow_imp.g_varchar2_table(37) := '07715D10C87B02EA587DC65485006700AA50A7CDDA091C681EB6DECF1EF33DFFAE053F79EC84BCF1EC2B899B7316C05593ED1048162000304310C829E0F2EB3F6713EC3E4D808703312510C82F4000C86FC811221770F9F51F3951E1C3E72C40E1A41C30';
wwv_flow_imp.g_varchar2_table(38) := '42010240844567C8C509B83EF2B7B81639524B80B300CC0504F2091000F2F9B177E402FCFAAF6E02F088E0EAEC69B91E0204807AD491515420E0F2C8DF0ABA1555939C0588AADC0CB660010240C1A01C2E1E017EFD575F6BD602545F037A10AE000120DC';
wwv_flow_imp.g_varchar2_table(39) := 'DAD1F30A055C9FFA576117A3699AA70346536A065AB00001A060500E1787C0D0E88834C747E318ACF251363ABBA5BFBB57792FE91E02FA040800FA6A428F940BB8FCFADF72CF6DB2E6CE2DCA471246F75EFBE1767973FB8B899DE52C4018B5A497BA0408';
wwv_flow_imp.g_varchar2_table(40) := '00BAEA416F02107059FC77C783DF92CE25BCF0A7887236F71E91C7EEFF49E2A178536011D21C23360102406C1567BCB9045C7EFD37FA17CBED3FBE2F573BECFC5981C7BEF123690E1DE72C0013038102050800056272A8FA0BB8FCFABFE5DB774AFF4DEB';
wwv_flow_imp.g_varchar2_table(41) := 'EA8FE171849C05F0884D53D1081000A22935032D4260DF89438987E1D77F11CA331F83B300E5D972E43805080071D69D5167107079EC2F8BFF32C03AEE72E0E117E485879E48DC9A07033962B21902224200601A20E02860BBF58F5FFF8E903936B39D05';
wwv_flow_imp.g_varchar2_table(42) := 'E096C01CB8EC1A9D000120BA9233E02C022E8BFFF8F59F4536DD3E2E6701B825309D295BC72B400088B7F68C3C8580CBE2BFBB1FFD4E8A23B2691681F163A7E5C9FFF050E21D01DC129845967D62142000C45875C69C5AC0F6DC7F4EFFA726CDBC83EDC1';
wwv_flow_imp.g_varchar2_table(43) := '40E62D816B1ACB331F9F1D1188458000104BA51967660197D3FFDCFA979937F58E43CFEC93A7BEFF70E27E5C0648CDCA0E110A1000222C3A434E27603BFDCFAFFF749E456CCD62C022143946EC020480D86700E34F1470F9F5CFE23FFF9388C580FECD69';
wwv_flow_imp.g_varchar2_table(44) := 'B17E020480FAD59411152860FBF56F9AE2B9FF05823B1ECAE5C9803C13C01193CDA2152000445B7A06EE22C0BDFF2E4AD56CC365806ADC69B53E020480FAD49291142CC0E9FF82410B3E1C8B010B06E570D1091000A22B39037615189B3C2B83A7861337';
wwv_flow_imp.g_varchar2_table(45) := '0FE9DEFFC34FEF95913D83F2E1F007D234FF1B3A2EE696B9B94B1BD2E85B24B32F9825AB6EB94A16AD5F2E7396CC7765AA743BDB59002E03545A1E1A572E4000505E20BA579D80EDFA7F08ABFFCD62B97D4FBE627D95EE74E56557AF96B55FBE46965CB9';
wwv_flow_imp.g_varchar2_table(46) := '522EEA9D575D112C2DEFF8EECF6470D73B6DB7E2D1C06A4B47C7140810001414812EE814B0BDF94FF3EA7F9755F22EEAE60CC10DFFE6AB6A8380CB387926804BA5D926460102408C5567CC5681504FFF9BD5F14F7FFF11193DDAB48E31CD06E66CC7C6BB';
wwv_flow_imp.g_varchar2_table(47) := '6E96E5375F9166B7D2B7358F067EE48FFF22B11D2E03945E061A085480001068E1E876B902219EFE77F9359C47CD9C0DB8F6EE5B64CD9D5BF21CA6F07D6DEB00B80C50383907AC890001A026856418C50A8476FADF762DBC481D73E963E5CD1BD4AC0D70';
wwv_flow_imp.g_varchar2_table(48) := '093EEB7A561549C0B110A8850001A016656410450AB8DCFEA7E9E13F3EBFFC5BCED7FD932FCB657F747D91EC998FE5F25020D60164E665C71A0B10006A5C5C86964D20A4D3FF2EBF7EB329D8F7D2B408D27619807500F67AB2457C020480F86ACE882D02';
wwv_flow_imp.g_varchar2_table(49) := '831FBE2F6313E36DB7D2F2C5E7F2CB77EA201A7D3DB2ECF20159B86289CC59D42D1D5D9DF2F16F3F96736727E4EC07A372FCDD61197EEB3D690E9F709A23664DC057FEFCEBD2B86299D3F6656E647B45F0DC8E4E19987F71995DE0D8080427400008AE64';
wwv_flow_imp.g_varchar2_table(50) := '74B86C01DBF5FFDB1FB8B7F22FBD8F464ECBA3FFF20732716ED2CAB160E922597DFD7A59BA7685755B130846DE3922079FDB23A78E7E60DDDEDC1D70DB9FDD53F97A009E0A682D151B20F03901020093028129022ED7FF353CFDCFF5D4FFCA8D6BE48A5B';
wwv_flow_imp.g_varchar2_table(51) := 'AF4B5D6313040E3DFD86BCFDF25EEBBE5AD603D82E03B00EC05A4A36884C80001059C1196EB24008D7FFCDAFFF87FF79F2BDEF6694975EBF41567FF1CACC253721E0BDE7F7CBBE5FED4E3C86B914F0D5BFFC66E567016C01A0B7AB21BD5D0B337BB02302';
wwv_flow_imp.g_varchar2_table(52) := '75132000D4ADA28C27974008D7FF5D7EFD67FDE53F1DCF8480FDBF7C45DEDD7520D155C3BA08D601E49AFAEC1CA1000120C2A233E4F602215CFFB7FDD2ED5A3C5FBEF4CFFEA0B0329B10B0F3A12713D704987707DCFCA77717D6669603B92C8AE4324016';
wwv_flow_imp.g_varchar2_table(53) := '59F6A9AB0001A0AE95655CA90542B8FEEF72FA7FD33FBC5116AFE94F3DFEA41D8E1F189297FFFAD9C463FEA307FF6DE56F11B485230240A1D38283052E400008BC8074BF388110AEFFFFFA9117E5B9FFB1BDEDA0E7F62E90ADFFF41F1487F2E991CC5980';
wwv_flow_imp.g_varchar2_table(54) := '577FFA941C1F1A697BEC9BFEDD1D95BF2BC0F650249E0750F8D4E080010B1000022E1E5D2F56C0160042B8CE7DD997AE96DFD952CE0B7BDEDDB95FF63EBBAB2DFABADB36C9B5DF2C3E7CA4A9B26D1D00EF0548A3C9B675172000D4BDC28CCF5920840580';
wwv_flow_imp.g_varchar2_table(55) := 'B65FB8BF77D79765E18A5EE731A7D9F0C32327E4B99F3ED17697818D97CAD6EFDD95E690856F6B7B1E000F042A9C9C03062C400008B87874BD388110AEFF9BD1DAAE71DFF2AFBE76FE097F65FC3771665C9EFA2F3F6F7B68F350A0DB7F7C5F194D3B1F93';
wwv_flow_imp.g_varchar2_table(56) := '8580CE546C8880100098040888882D0068F8723385FAE957FF2CB15E5FF9F7FFB8B47A9A75004FFEA7BF6A7B7CF33C803FFA5FF797D6BEEB816D216960419FCC9D3DC7F5706C87406D050800B52D2D034B2360BBFEAFE1F4B619CFA3FFE23FCBE8D166DB';
wwv_flow_imp.g_varchar2_table(57) := 'A19519004CA3BFF88FFFB36DDBDD4B1BF2D5FFFAAFD3B097B2ADED32090B014B61E7A0010A1000022C1A5D2E5EC01600342C0034A3B6FDBA8DFD128031622160F19F0F8E584F0102403DEBCAA8520AD81600DEF2ED3BA5FFA675298F5AFCE6B65FB7D7DF';
wwv_flow_imp.g_varchar2_table(58) := '7D9BCC5FD6537CC32272F2BD63B2F367FFB7EDB1B59C2561216029E5E7A035142000D4B0A80C29BD80ED0980773CF82DE95C322FFD810BDEE3951FFC1FD9F7C4CB6D8F5AE66D80BF797E8FBCB5E3F5B66D6FD8B6597EF74FB6153CE2F487735908B8AE67';
wwv_flow_imp.g_varchar2_table(59) := '55FA03B3070235132000D4ACA00C27BD806D01A039A28637009A7ED87EDD36FA7AC45CAE28E3BFE71FFA859C1A6EFF8AE0EBBFBE4D2EB96373194DA73EA6ED52094F044C4DCA0E35142000D4B0A80C299DC0D8E459193C35DC76272D7700980E9EDAFBBE';
wwv_flow_imp.g_varchar2_table(60) := 'FCCDFD0F260EB0944701BF73445EFEF9DF26B6AB2524994EDA02007702A4FB8CB0753D050800F5AC2BA34A21605B00A8E5DA766B48BFB8EF2F65E4C8D1B6235CB074917CE1EB5F492160DFF4F9FFBE5D4E1D3BD976432D7700B43A685B2BC19D00F69AB3';
wwv_flow_imp.g_varchar2_table(61) := '45FD050800F5AF3123B408D80280963B005AC3B0BD0FC06C57D4EB80CDB1F63EF192BCFB9AFED7014F2D337702F0B147C02E4000B01BB145CD056C7700680B00A61CB6E701986DD67DF16A19B83EDF7B010EEE7843DE79FECDC419A0EDD7BFE9AC75AD44';
wwv_flow_imp.g_varchar2_table(62) := '67B7F47797F3C8E49A7F5C185E8D040800352A2643C926600B00B73F70AF34AE5896EDE025EDE5721620CF9900F3D4BFFD4FBE62FDE56FDAD018906C7702F04E80922626870D4A80001054B9E86C1902A1DC02387DECB6856EADEDCD9A80D5D7AF97A56B';
wwv_flow_imp.g_varchar2_table(63) := '5738F11D7DFB3DD9BF63B79C39FEA1757B8DBFFE4DA7C78F9D9647FEF82F12FBCFAD80D6F2B241CD050800352F30C34B1608E916C0E923316701763FFE7CE2A381A7EE636E11ECBB6C852C5ED9277316759F7F6990F9A57FEEEC849CFDE0B49C7C6F440E';
wwv_flow_imp.g_varchar2_table(64) := 'ED39286323A79CA78DC6B323ADCEDBDE9BC0AD80CE6566C39A0A10006A5A5886E526600B009A6E019C6944071E7E415E78A8FD2B7ADD14B26DA5F1D4FFD491D8CE901000B2D59DBDEA234000A84F2D19490681909E01D06E786FFCE8C9F367027CFEA7ED';
wwv_flow_imp.g_varchar2_table(65) := 'D6C899C66E0B003C0BC0E78CA12D8D0204008D55A14FDE049AE3A76568F478DBF642F8A2339DF719024231E15900DE3E463414A8000120D0C2D1ED62046CCF00D0F27C7B97D19ACB016F6CDFE9BC26C0E598D3B7D17EDA7F6A7F6DCF02E06140596600FB';
wwv_flow_imp.g_varchar2_table(66) := 'D449800050A76A3296D402B60010D2179E19FCF0B36FC94B3FFDA53487DA9FD5488D24221DB366CB57FEFCEBEA6E874C1A8B2D00F47635A4B76B61160EF641A0160204805A9491416415A85B006839984B02075ED99BFB6C80F9E2BFF6EE5B64CD9D5BB2';
wwv_flow_imp.g_varchar2_table(67) := '1257B61F0F03AA8C9E8603112000045228BA598EC0D0E88834C747DB1EFC966FDF29FD37AD2BA7710F473597050EFCF2B5C47707CCD48D90BFF85BE321007898603411B4000120E8F2D1F9BC02213E0530CB98CD5B048FEF7957865FFF8D4CFEF69C3487';
wwv_flow_imp.g_varchar2_table(68) := '3F90C97393F2D1F15199BBB4218DBE4532BF6F91F4AE1F902557AE948B7AE7656946D53E3C0D505539E88C42010280C2A2D0257F02B104007FA27A5A2200E8A9053DD1294000D059177AE5498000E009BA8266080015A0D36450020480A0CA45678B1638';
wwv_flow_imp.g_varchar2_table(69) := 'D03C2C13E726DB1EF68E07BF259D4BC23F1D5EB45B08C7B3BD0FC0AC7358D3581EC250E82302A50810004A61E5A0A108100042A954FA7E1200D29BB1475C020480B8EACD68A7091000EA3B250800F5AD2D232B468000508C2347095420D4570107CAEDB5';
wwv_flow_imp.g_varchar2_table(70) := 'DB0400AFDC3416A0000120C0A2D1E5E2046C01E0EE47BF535C631CC9BB80ED95C0EB7A5679EF130D22A0458000A0A512F4A31201024025ECDE1A250078A3A6A10005080001168D2E1727400028CE52E39108001AAB429FB4081000B454827E5422C022C0';
wwv_flow_imp.g_varchar2_table(71) := '4AD8BD346A5B03603AC125002FA5A011A5020400A585A15B7E0408007E9CAB68C51600780E401555A14D4D0204004DD5A02FDE056C01E0F607EE0DEA15B8DE0115374800505C1CBAA6428000A0A20C74A22A01024055F2E5B76B7B14306700CAAF012DE8';
wwv_flow_imp.g_varchar2_table(72) := '162000E8AE0FBD2B59C01600427F1D70C97CAA0F4F00505D1E3AA7408000A0A00874A13A01DBCB800800D5D5266FCB43CFEC93A7BEFF70DBC3CCEDE89481F917E76D86FD1108568000106CE9E878110204802214751EE3C0C32FC80B0F3D4100D0591E7A';
wwv_flow_imp.g_varchar2_table(73) := 'A5408000A0A00874A13A015B00D872CF6DB2E6CE2DD5759096330B100032D3B16324020480480ACD306716181A1D91E6F8685B1E0240B833C716001A9DDDD2DFDD1BEE00E93902390508003901D93D6C015B00D8B06DB3FCEE9F6C0B7B9091F6FEB51F6E';
wwv_flow_imp.g_varchar2_table(74) := '9737B7BFD876F4BD5D0DE9ED5A18A90EC346408400C02C885AA0397E5A86468FB7352000843B3D0800E1D68E9EFB112000F871A615A502B60030B0F152D9FABDBB94F69E6E2509ECF8EECF6470D73B6D37E9EF5E2C8DCE79202210AD000120DAD2337023';
wwv_flow_imp.g_varchar2_table(75) := '30367956064F0DB7C52000843B4F6C016060419FCC9D3D27DC01D27304720A10007202B27BD802131F4FCA819387DB0EA2D1BF586EFFF17D610F32D2DEDBDE04B866E172E9B87076A43A0C1B01D60030071010DB2B81EF78F05BD2B98453C5214D15DB7B';
wwv_flow_imp.g_varchar2_table(76) := '00CC587813604815A5AF65087006A00C558E199480ED71C00480A0CA79BEB30480F06A468FFD0B1000FC9BD3A22201DB1A00D3551E07ACA8608E5DB13D06D81C864B008E986C565B0102406D4BCBC06C022E5FFE04009BA2CE7FB73D04A8D56B4280CEFA';
wwv_flow_imp.g_varchar2_table(77) := 'D12B3F0204003FCEB4A24CC0F5CBDF749B6701282B9E43776CCF00987A08428003289BD452800050CBB232A82481345FFEE638DC0A18DE7CB2DD02387D448480F06A4C8FF30B1000F21B72848004D27EF9B78676F7A3DF09689474D5760BE04C428400E6';
wwv_flow_imp.g_varchar2_table(78) := '4D6C020480D82A1EF178B37EF91B32EE040867E2B8DC01D06E34848070EA4C4FF30B1000F21B72840004F27CF99BE1DDFEC0BDD2B862590023A58B790280D12304308762112000C452E988C799F7CBDFD0D5E95640F305B9EFAF7E25EFED3E787E5634FA';
wwv_flow_imp.g_varchar2_table(79) := '16C9E66FFE616D1E76E4720BA0EDE34008B009F1EF75102000D4A18A8CA1AD40115FFEE6E05BEEB94DD6DCB92578E9A45FC775B9CCE17A0BA0AD9884009B10FF1EBA000120F40AD2FFD2BFFC4D0375B91530E9F6B8BA849C34B700DA3E3E84009B10FF1E';
wwv_flow_imp.g_varchar2_table(80) := 'B2000120E4EAD1F7C2BEFCFB2E5E2AC3EF1F6D7BBCBADC0A685B1D5F87BB1D6CB7000EAC5F2D43FB0765E2DCA4D3278810E0C4C446010A1000022C1A5D4E16487BDA7FE3CD9B65D69C0E79F9F1BF4B3C701D4E91D73D00B82C00DCF4FB379CAFF3EE2776';
wwv_flow_imp.g_varchar2_table(81) := '1202F86312B5000120EAF2D76FF059BEFCE72D6E9C8778E1E74F277E21D4E14E80BA0780E6DE23F2D8FD3F693BB13B66CD962D5FBBF9FCBF9F191D2304D4EF4F00234A2140004881C5A6BA05F27CF99B91EDD9F1AA9C183EDE769075B8465EF700605B00';
wwv_flow_imp.g_varchar2_table(82) := 'B87455BF5C76DD86BFAF312140F7679ADE952B400028D797A37B12C8FBE56FBA7964FF2139F8C6DB6D7B5C877500750F00B6EBFF6BAF5B2F7DAB3EFB3C074280A70F29CDA8132000A82B091D4A2B50C497BF69F3F4F1A6EC7AFAC5C4E6435F0750F70060';
wwv_flow_imp.g_varchar2_table(83) := '1B9FB9FEDFD53DF773352604A4FDD4B17D1D04080075A862C46328EACBDF109E3B3B292F3DBEA3D6EB006C5F9021C8C8277B00001A3949444154DF05E0B20070EB1DB7B6FDB4100222FE4312E9D009009116BE0EC32EF2CBBFE551F77500750E00B6EBFF';
wwv_flow_imp.g_varchar2_table(84) := '3D034B65FDE6AB13A73E21A00E7F191883AB0001C0558AED540994F1E56F0638B8F7A00CEEF9E411B933FD17FA3A803A0700DBF5FFD557AE956597AFB2CE63428095880D6A224000A84921631A46595FFEC6B0EEEB00EA1C006C63BBEA0B1BA5B1BCD7E9';
wwv_flow_imp.g_varchar2_table(85) := 'A34208706262A3C0050800811730B6EE97F9E56F2C5DD60184BC10D0F62519EA1A80BCD7FF67FA1C110262FBEB12DF780900F1D53CD8114F7C3C29074E1E76EEBF79C25FEB213FCE3B9927C43DFB929C3A76B2ED2E21BF19B0AE01A088EBFF8480349F12';
wwv_flow_imp.g_varchar2_table(86) := 'B6AD830001A00E558C600CBEBEFC0DA56D1D40C82F06AA6B00B05DFF5FB56695ACDCB836D32725CD9900F3A4C181F97DD271E1EC4C6DB113023E0508003EB5692BB3C0E087EFCBD8C4B8D3FE597FF9B70E7EF2D80979E3D95712DB0AF554795D03806D5C';
wwv_flow_imp.g_varchar2_table(87) := '69AEFFE73D13400870FA98B291020102808222D08564019F5FFEA627661DC0738F3D9DD8A950D701D8BE28430C362ED7FFAFBFFD66993527DFAFF23467027ABB1AD2DBB5908F3602AA050800AACB43E746CE9C9491334D2788BCBFFCA736625B0710EA7B';
wwv_flow_imp.g_varchar2_table(88) := '01EA18006CD7FFA7BE00C86922256C4408C82BC8FE9A0408009AAA415F3E239066C57F915FFEA613B6F70234FA17CBED3FBE2FB88AD53100D8C694E7FA7FDECB01FDDD8BA5D1392FB8794287E3102000C451E7E0469966D15FD15FFE06CBFCD27BF9F1BF';
wwv_flow_imp.g_varchar2_table(89) := 'ABDD6500DB97656897005C4EFFFFDE1F7C492EEAEA2CF43390E64CC09A85CB591458A83E072B4A8000509424C72954606874449AE3A3D6635E79E3B5B270498F75BB2C1BD4F13240DD0280EDF4FF82250BE5EA1BAFCB527EEB3EC3878EC8DB2FEDB16ED7';
wwv_flow_imp.g_varchar2_table(90) := 'E8EC96FE6EB70710590FC6060814284000281093431523E0FAEBDFF5D1AE597B55C7CB00750B00B6F1CCF4FADFACF361A6FD6C73A4B50F67018A54E758450910008A92E4388509B8ACFAEFE95B2CEBB75E53589B331DA88E97016C5F98215D027039FD5F';
wwv_flow_imp.g_varchar2_table(91) := 'C4EAFFA44966EE1839F0C67E397A6828712ECEEDE89481F917973A5F3938026905080069C5D8BE540197857F5DF3E6CAA66D3794DA8FD6C1EB7619A04E01C076FADFE5ED7F454C221302763DB353CE9C1E4B3C1C0B028BD0E618450A10008AD4E458B905';
wwv_flow_imp.g_varchar2_table(92) := '0E340FCBC4B9C9C4E36CBAE50BD2D5E36765B5CB75DE909E0950A700601B4BD9A7FFA74E5297B3453C2028F79F070E50B00001A060500E975DC0E59EFFA5ABFAE5B2EB36646F24E59E1F9D19979DFFFB6F13F7BAFD817BA571C5B29447AE6673DB976628';
wwv_flow_imp.g_varchar2_table(93) := '9700349CFE9F5EC183AFEC9323BF7E8FB300D54C6D5ACD204000C880C62EE508EC3B71C87AE0326EE9B2356ABB0C10D2BB01EA1200B49CFE9F3A774C587C75FB738967B0380B60FBB4F1EF3E0508003EB569ABAD80CBCAFFA21FE8E25A8EE383C3B2F7C5';
wwv_flow_imp.g_varchar2_table(94) := 'D713370FE532405D02806D1C3E4FFF4F9D18EFEE7A5B0E1D480EB2030BFA64EEEC39AED38FED10284D8000501A2D074E23E072FABFEC15DDEDFA6B1679BDF4F88EC45F76A15C06B07D7186700940E3E9FFD6DC71390BC07B02D2FC6560DB3205080065EA';
wwv_flow_imp.g_varchar2_table(95) := '726C6701DBE2BFB2EFF9B77574CF8E57E5C4F0F1B69B857219A00E01C076FADFF73A91E993C2F66C006E09B47DDAF8775F0204005FD2B493EBF47F15D7FEA776D8E515C1215C06083D00B8FCFAAFEAF47F6BBEB8DC11C08381F883A8418000A0A10A91F7';
wwv_flow_imp.g_varchar2_table(96) := 'C176FABFC8B7B965A576B90C10C21B02430F00B65FFFA6BE5BEFB8356B990BDBCFB6709467021446CD817208100072E0B16B3102B627FF55B5F86FFAE8DEFED56E197EFF68E2A0B59F05083D00D8FAAF65AE0CEE3D28837B0EB69D2B5C0628E66F0747C9';
wwv_flow_imp.g_varchar2_table(97) := '274000C8E7C7DE39055C56FF97F1B6BF2CDD3E7DBC29BB9E7E3171D75BBE7DA7F4DFB42ECBE1BDEC63FB02D5BC08D0E5D7BFCF87442515CC65AE7019C0CB94A79104010200D3A35201DBA37F359CFE9F0A643BB53BB0F152D9FABDBB2A354D6A3CE400F0';
wwv_flow_imp.g_varchar2_table(98) := 'D8377E24CDA1F60B31CB7CF35FDA82BA5C32E276C0B4AA6C5FB40001A068518E974AA0397E5A8646DBFF515F76C90A597DAD9E5FD42E8B01359F05083500B82CFE2BF3D5D0A926F5A71BDB2E19B10E208B2AFB1429400028529363A516B02D00ACFAF6BF';
wwv_flow_imp.g_varchar2_table(99) := '990614F259805003C06B3FDC2E6F6E6F7FF9C5E70BA25C27B9ED76409E07E02AC97665091000CA92E5B84E02B60050F52D5D330D22E417048518005C7EFD6B9C2747DF7A4FDE7A7D5FDBCF41A3B35BFABB7B9D3E276C844019020480325439A6B3C0D0E8';
wwv_flow_imp.g_varchar2_table(100) := '8834C747DB6E7FC5E6AB64F1409FF3F17C6CE8F2FA57ADB7048618006C8BFFB4AD1369CD41DBE52202808F4F2B6D24091000981F950AD86E01D47207C074A450CF0284160042FDF56FE68BED4E006E05ACF44F0F8D8B0801806950A980ED11C0553F01B0';
wwv_flow_imp.g_varchar2_table(101) := '1D8ECB2A6F8D6701420B00A1FEFA37F3C6F62A6973E6624D6379A59F3F1A8F5B80001077FD2B1FBDED15C01A9EEAD60EC9F6E6B746FF62B9F54FEF91CE25F32A776E7520B40060EBAF9607FFCC546013129F7BECE9C4DAAFEB59A5666ED091F8040800F1';
wwv_flow_imp.g_varchar2_table(102) := 'D55CD588430E002E6F7ED37616C0F685AAE94140B65FFF662257F58648D70FD18E479E2400B862B19D7701028077721A9C2A10720030E338F8CA3E39F2EBF7DA1655DB5980500280CBB57FCDBFFE5B138200C0DF3BCD020400CDD589A06FA107009737BF';
wwv_flow_imp.g_varchar2_table(103) := '693A0B104A0070F9F5AF757DC8D48F2D0120823F62010F91001070F1EAD0F5D00380A981ED896F661B2D2F090A2100B8FCFAEF19582AEB375FADFE234000505FA2A83B480088BAFCD50FBE0E01C076BB9751D67216208400E0F2EB5FEBEDA1D33F510480';
wwv_flow_imp.g_varchar2_table(104) := 'EAFFC6D083F60204006647A50275080006D0F678602D6701B40700975FFF9A5EFA63FBF010006C42FC7B950204802AF5695BEA1200CC5A80DD4FEC948973936DABAAE14D81DA03C08EEFFE4C0677BD93F8C9D0F2CA5F978F2F01C045896DAA1220005425';
wwv_flow_imp.g_varchar2_table(105) := '4FBBE705EA1200CC586CCF0530DB54FDA640CD01A0B9F7883C76FF4F123F1921ACFC9F3A0002007FE8340B100034572782BED52900B83C17A0EADB02350780C7BEF123690EB57F35B4D667FE277D4C090011FC110B78880480808B5787AED72900987AB8';
wwv_flow_imp.g_varchar2_table(106) := 'BC23A0CA05815A0380CBC23F8D6FFCB37D0609003621FEBD4A01024095FAB45DAB4B00A69CE6F1AF6FEEDC25A78E9D6C5BDD2ACF02680C00755BF8C72500FEB08522400008A55235ED67DDCE00983269BE2D50630070F9F51FCA6D7FD33FA69C01A8E91F';
wwv_flow_imp.g_varchar2_table(107) := 'AE9A0C8B00509342863A8C3A0600530BDB2382CD36553C1C485B0070F9F5BF7455BF5C76DD8620A7380120C8B245D369024034A5D639D0BA0600970581E6B6C0CDDFFC43AF6F0BD416005C6EFBD3FEC21F1601EAFCDB42AFEC020400BB115B942850D700';
wwv_flow_imp.g_varchar2_table(108) := '60C8342E08D414005C4EFDAFBE72AD2CBB3CDC57E67206A0C43F1E1C3AB7000120372107C82350E700601604EE7A66A79C393D9648E4F352809600E072EABF6BDE5CD9B4ED863CD3ABF27D09009597800E24081000981E950AD4390018D8E3C323B277C7';
wwv_flow_imp.g_varchar2_table(109) := 'AE44639F9702B404009753FFA12EFC9B5A6C0240A57F5E68DC224000608A542A50F70060705DDE13E0EBD9001A0280CBA9FF9EBEC5B27EEB3595CECD221A270014A1C831CA1220009425CB719D046208002E0B020D968F4B015507009753FFC622A4E7FD';
wwv_flow_imp.g_varchar2_table(110) := '274D740280D39F0136AA48800050113CCD7E22104300383E382C7B5F7CDD5A721F0F08AA3A00B89CFAEFE8BA482EB974B52CBD6C85D54CFB060400ED158ABB7F0480B8EB5FF9E8EB1E0006F71E94C13D079D9DCBBE145065007039F53F15CADC01D077D9';
wwv_flow_imp.g_varchar2_table(111) := '4A9975C185CE7EDA36240068AB08FD992A4000603E542A50E700B067C7AB7262B8FDCB6DDAC1977929A0AA00E07AEA7FBAC9B24B56C8AA6B2E0B360410002AFDF342E31601020053A452813A060073CDFF9D97F764FAF237C528F352405501C0F6A6BFA4';
wwv_flow_imp.g_varchar2_table(112) := '49B860C17C59B775A35CD4D559E95CCDD23801208B1AFBF8122000F892A69D1905EA16005C17FCD9A643599702AA0800694FFDCF64639E0970D58D9B820B010400DB4CE7DFAB14200054A94FDBB55A04E8F212A034252F2304F80E00CDBD47E4B1FB7F92';
wwv_flow_imp.g_varchar2_table(113) := '66D86DB7358B03D75EBE567AD6F417723C1F072100F850A68DAC020480AC72EC5788405DCE00B8AEF46FA175CC9A2D13E726AD8645AF07F01900B25EF74F4209ED0E010280758AB341850204800AF169BA1EB701A65DE93FB7A35306E65F2C079A87AD21';
wwv_flow_imp.g_varchar2_table(114) := 'A0E8F500BE0280EB97BF09426B1ACB656874449AE3A3CE1F8950EE1020003897940D2B10200054804E93FF5F20F433006957FAF77635A4B76BE17980898F2765F0C3616B0828F251C1BE0280D3FDFE9F7EF9B766C3C899933272A6E9FCF108E10E010280';
wwv_flow_imp.g_varchar2_table(115) := '7339D9B00201024005E834197E00C8B2D2BFBF7BB1343AE77DA6FCAE5F7A45AD07F011005EFBE1767973FB8BD6693EB0A04FE6CE9EF3398FE647A3D650D4DA49FB1D020400EB3460830A05080015E2D374989700B2ACF49FE9CB2EED2FDF224240D90160';
wwv_flow_imp.g_varchar2_table(116) := 'E8997DF2D4F71FB64EEDA96742A66F3C36795686468F3B8700CD77081000AC53810D2A14200054884FD3E10580B42BFDCD356EF3CB7FFA2FDDE9B577590F60F6C9BB28B0CC00E0BAE2BFB5062269FEA70D015AEF102000F0574EB3000140737522E85B48';
wwv_flow_imp.g_varchar2_table(117) := '6B00D2AEF477F9A26B95D8753D40DE4581650580B48BFE5CA6B6AB49EB581AEF102000B8549A6DAA12200054254FBBE7054209005957FAA729B3EB7A803C21A0AC00E0B2E8CF58245D0A696715F21D020480349F00B6F52D4000F02D4E7B9F11082100E4';
wwv_flow_imp.g_varchar2_table(118) := '59E99FB6DCAE2120EB7A80320280EB97FF4C8B205D7D5C5D5AC7D372870001C0B5C26C57850001A00A75DAFC7B01CD01A0A895FE69CBEDBA1EC0848015376D90CE259FBDB320A9BDA20380EB977FA3B35BFABB7BD3527C667B130242BB43800090ABE4EC';
wwv_flow_imp.g_varchar2_table(119) := '5CB20001A064600E9F2CA0350014BDD23FCD3C4873ED3BED33028A0A00E69AFF8B3FF81B19DCF58E7568AD87FD583774D820EDE2C0AAEF1020003814954D2A13200054464FC346406300286BA57F9A8AA70901E6B81BB66D96A51B5649CFFA15E79B6977';
wwv_flow_imp.g_varchar2_table(120) := '56204F0030ABFCC78E9E92A36F1E72BACFDFF4C37CF90FCCEF938E0B67A7197EE2B669434095770810000A2B3B072A41800050022A877417D01600CA5CE9EFAEF2C99669AF7BA73DBE8FEDB32CFA73E957DA8054D51D020400976AB24D55020480AAE469';
wwv_flow_imp.g_varchar2_table(121) := 'F7BC80A600E063A57FDAB2871C02921EF693D6A1DDF6DAEF1020001455698E53860001A00C558EE92CA02500F85CE9EF8CF3E98669BFE4D21EBF8CEDD33C03216FFB694392CF3B04080079ABCBFE650A1000CAD4E5D85681AA0340552BFDAD30D3360829';
wwv_flow_imp.g_varchar2_table(122) := '04F8FCF26F3169BD4380009076A6B3BD4F0102804F6DDAFA9C409501A0CA95FE59A642DA5FBA59DAC8BB8F8FD3FEEDFA987671A08F3B040800796714FB97294000285397635B05AA0A001A56FA5B7166D820ED975C9636B2ECE3FACE832CC74EB34F5A9F';
wwv_flow_imp.g_varchar2_table(123) := 'B2EF102000A4A91EDBFA162000F816A7BDCF0854110034ADF4CF3A1D9AE3A765E46CD3F98D7959DBB1ED674EF7372E9AF7B9D71CDBF62BF3DF35DD21400028B3D21C3BAF000120AF20FBE712F01D0034AEF4CF03687EF18E4D9C15F3FF131F9F3B7FA889';
wwv_flow_imp.g_varchar2_table(124) := '7393790E99B8AFF9C237F7F49BB71BCEED9853E8FDFD45773AEDBA89D557AE95BECB56CAAC0B2E2CAC2B0480C228395009020480125039A4BB80CF00A079A5BFBB58BE2D6DDEEB7A56E56B40D9DE69D74D147D87000140D984A03B9F11200030212A15B0';
wwv_flow_imp.g_varchar2_table(125) := '7D216DBDE3D6DCFD0B65A57FEE813A1CC0E65DB7006048AABC438000E03029D9A43201024065F4346C046C5F48790340682BFDCB9E1536EF3A0600639A7671605177081000CA9ED11C3F8F0001208F1EFBE616B07D21E50900A1AEF4CF8D9A70009B775D';
wwv_flow_imp.g_varchar2_table(126) := '0340961050C41D020480326733C7CE2B4000C82BC8FEB9046C5F485903C091FD87E4E01B6F3BF7AD8A87D73877AEC00D6DDE750E008631CB1D022BD7ACCABC38900050E0E4E550850B10000A27E58069046C5F4869034096EBFDB17CF9BB5C72A97B0068';
wwv_flow_imp.g_varchar2_table(127) := 'CDCDB477082C58305FD66DDD28177575A699DE420048C5C5C69E0508009EC169EEB302450500F3C5FFFE6F0ECBE09E83A988AB7C725DAA8E16B4B1CD3B96006038D3DE21602E092CB978A9F4FFCE0AE9EA99E75411028013131B55244000A8089E663F11';
wwv_flow_imp.g_varchar2_table(128) := 'B07D21CD7406E0DCD94939F7DB7332767A544E8D9C9493C74EC8A963275393F6772F56F5009BD403C8B083CD3BA600D00A01CD8F46533F3BC19C1158B4A44716AD5C2AB32E9825B3BA3A663C3B4000C83049D9C59B0001C01B350DCD2460FB422A4BADAC';
wwv_flow_imp.g_varchar2_table(129) := 'F7D497D5DFA28E6BF38E2D0018D7B4770814550B739C18BD8BF4E358F9040800F9FCD83BA780ED0B29E7E13FB7BB9667D6173D2ED7E3D9BC63FD42AA2A04C4EAED3A5FD9AE5C010240B9BE1CDD2260FB422A1230A6C57EEDDC6CDE317F21993B04CCE2C0';
wwv_flow_imp.g_varchar2_table(130) := 'B189F122A75DE2B162F6F6864C436D0508004C8E4A056C5F4845752EB6C57E0480EC3327ED9303B3B7C425803C76EC9B5F800090DF9023E41038D03C9C7A01569AE6CCAFFEDEAE85E75F5EC37F2249DEE6F2C89AC672983CAD0BC09BA956B50001A0EA0A';
wwv_flow_imp.g_varchar2_table(131) := '44DE7EDAFBB15DB9F8E29F592AC9BBD1D92DFDDDBDAEC4516C67D606983302655C16C03B8A29A47A900400D5E5A97FE7D23E99CD2662FEA8363AE7F18BBF0D543B6F7E8D26CFAC561030AF5C2EE275CB78DB3EC9FCBB0F0102800F65DA4814682DBE4AF3';
wwv_flow_imp.g_varchar2_table(132) := 'C7D5FC01EDB8705630EFA6D73405A67B9BD0642E93745C385B5337D5F6C58481B189B3E76F1F34FF99797BFEFFCF4D3AF5196F272636F2204000F0804C130820800002086813200068AB08FD410001041040C0830001C003324D208000020820A04D8000';
wwv_flow_imp.g_varchar2_table(133) := 'A0AD22F4070104104000010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F0204000F0804C130820800002086813200068AB08FD410001041040C0830001C0';
wwv_flow_imp.g_varchar2_table(134) := '03324D208000020820A04D8000A0AD22F4070104104000010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F0204000F0804C130820800002086813200068AB';
wwv_flow_imp.g_varchar2_table(135) := '08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F4070104104000010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F0204000F0804C';
wwv_flow_imp.g_varchar2_table(136) := '130820800002086813200068AB08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F4070104104000010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800DA2A427F';
wwv_flow_imp.g_varchar2_table(137) := '104000010410F0204000F0804C130820800002086813200068AB08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F4070104104000010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C20D30402';
wwv_flow_imp.g_varchar2_table(138) := '0820800002DA040800DA2A427F104000010410F0204000F0804C130820800002086813200068AB08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F4070104104000010F0204000FC8348100020820808036010280B68AD01F0410';
wwv_flow_imp.g_varchar2_table(139) := '400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F0204000F0804C130820800002086813200068AB08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F4070104104000010F0204000FC83481000208';
wwv_flow_imp.g_varchar2_table(140) := '20808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F0204000F0804C130820800002086813200068AB08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F40701041040';
wwv_flow_imp.g_varchar2_table(141) := '00010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F0204000F0804C130820800002086813200068AB08FD410001041040C0830001C003324D208000020820';
wwv_flow_imp.g_varchar2_table(142) := 'A04D8000A0AD22F4070104104000010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F0204000F0804C130820800002086813200068AB08FD410001041040C0';
wwv_flow_imp.g_varchar2_table(143) := '830001C003324D208000020820A04D8000A0AD22F4070104104000010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F0204000F0804C130820800002086813';
wwv_flow_imp.g_varchar2_table(144) := '200068AB08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F4070104104000010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F02040';
wwv_flow_imp.g_varchar2_table(145) := '00F0804C130820800002086813200068AB08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F4070104104000010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800';
wwv_flow_imp.g_varchar2_table(146) := 'DA2A427F104000010410F0204000F0804C130820800002086813200068AB08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F4070104104000010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C';
wwv_flow_imp.g_varchar2_table(147) := '20D304020820800002DA040800DA2A427F104000010410F0204000F0804C130820800002086813200068AB08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F4070104104000010F0204000FC8348100020820808036010280B68A';
wwv_flow_imp.g_varchar2_table(148) := 'D01F0410400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F0204000F0804C130820800002086813200068AB08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F4070104104000010F0204000FC834';
wwv_flow_imp.g_varchar2_table(149) := '8100020820808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F0204000F0804C130820800002086813200068AB08FD410001041040C0830001C003324D208000020820A04D8000A0AD22F407';
wwv_flow_imp.g_varchar2_table(150) := '0104104000010F0204000FC8348100020820808036010280B68AD01F0410400001043C0810003C20D304020820800002DA040800DA2A427F104000010410F020F0FF002EC81478BD42689B0000000049454E44AE426082';
null;
end;
/
begin
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(8549897230684333)
,p_file_name=>'icons/app-icon-512.png'
,p_mime_type=>'image/png'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/files/app_icon_min_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E6170702D69636F6E7B6261636B67726F756E642D696D6167653A75726C286170702D69636F6E2E737667293B6261636B67726F756E642D7265706561743A6E6F2D7265706561743B6261636B67726F756E642D73697A653A636F7665723B6261636B67';
wwv_flow_imp.g_varchar2_table(2) := '726F756E642D706F736974696F6E3A3530253B6261636B67726F756E642D636F6C6F723A236361353839647D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(9251779331086504)
,p_file_name=>'app-icon.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/app_icon_svg
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222076696577426F783D22302030203634203634222077696474683D22363422206865696768743D223634223E3C726563742077696474683D2231303025';
wwv_flow_imp.g_varchar2_table(2) := '22206865696768743D2231303025222066696C6C3D222343413538394422202F3E3C67206F7061636974793D222E32223E3C7061746820643D224D333220323661322E3520322E3520302031203020322E3520322E3541322E35303320322E3530332030';
wwv_flow_imp.g_varchar2_table(3) := '203020302033322032367A6D30203461312E3520312E3520302031203120312E352D312E3541312E35303220312E3530322030203020312033322033307A222F3E3C7061746820643D224D34322E3533362033362E3832386C2D322E3637332D322E3637';
wwv_flow_imp.g_varchar2_table(4) := '324131382E3937332031382E39373320302030203020343020333263302D352E3835352D322E3732332D31312E3439332D372E3636382D31352E383734612E352E352030203020302D2E36363420304332362E3732332032302E3530372032342032362E';
wwv_flow_imp.g_varchar2_table(5) := '3134352032342033326131382E3937332031382E393733203020302030202E31333720322E3135366C2D322E36373320322E36373341342E39363720342E3936372030203020302032302034302E3336345634372E35612E352E35203020302030202E35';
wwv_flow_imp.g_varchar2_table(6) := '2E3568312E30373561332E30303220332E30303220302030203020312E3935322D2E3732326C342E332D332E363835632E3431312E3538322E38343720312E31353520312E33323220312E37313261322E30303120322E30303120302030203020312E35';
wwv_flow_imp.g_varchar2_table(7) := '32372E363935682E38323476312E35612E352E3520302030203020312030563436682E38323461322E30303120322E30303120302030203020312E3532372D2E3639352032332E37382032332E373820302030203020312E3332332D312E3731326C342E';
wwv_flow_imp.g_varchar2_table(8) := '32393820332E36383461332E30303220332E30303220302030203020312E3935332E3732334834332E35612E352E35203020302030202E352D2E35762D372E31333661342E393720342E39372030203020302D312E3436342D332E3533367A4D33322031';
wwv_flow_imp.g_varchar2_table(9) := '372E3137334132322E3839372032322E3839372030203020312033362E363237203233682D392E3235344132322E3839372032322E3839372030203020312033322031372E3137337A4D32322E3837362034362E3532613220322030203020312D312E33';
wwv_flow_imp.g_varchar2_table(10) := '2E343831483231762D362E36333661332E39373320332E39373320302030203120312E3137312D322E3832386C322E31342D322E31346132302E3330312032302E33303120302030203020322E39353920372E3335377A6D31312E3231342D312E383633';
wwv_flow_imp.g_varchar2_table(11) := '61312E30313420312E3031342030203020312D2E3736362E3334344833322E35762D392E35612E352E352030203020302D312030563435682D2E38323461312E30313420312E3031342030203020312D2E3736362D2E3334344131392E342031392E3420';
wwv_flow_imp.g_varchar2_table(12) := '30203020312032352033326131382E3434362031382E34343620302030203120312E3835382D386831302E3238344131382E3434362031382E3434362030203020312033392033326131392E342031392E342030203020312D342E39312031322E363536';
wwv_flow_imp.g_varchar2_table(13) := '7A4D3433203437682D2E353735613220322030203020312D312E3330322D2E3438326C2D342E3339332D332E3736356132302E332032302E3320302030203020322E3935382D372E3335386C322E313420322E313441332E39373520332E393735203020';
wwv_flow_imp.g_varchar2_table(14) := '3020312034332034302E3336347A222F3E3C2F673E3C7061746820643D224D33322031372E3137334132322E3839372032322E3839372030203020312033362E363237203233682D392E3235344132322E3839372032322E383937203020302031203332';
wwv_flow_imp.g_varchar2_table(15) := '2031372E3137337A4D32322E3837362034362E3532613220322030203020312D312E332E343831483231762D362E36333661332E39373320332E39373320302030203120312E3137312D322E3832386C322E31342D322E31346132302E3330312032302E';
wwv_flow_imp.g_varchar2_table(16) := '33303120302030203020322E39353920372E3335377A4D3433203437682D2E353735613220322030203020312D312E3330322D2E3438326C2D342E3339332D332E3736356132302E332032302E3320302030203020322E3935382D372E3335386C322E31';
wwv_flow_imp.g_varchar2_table(17) := '3420322E313441332E39373520332E3937352030203020312034332034302E3336347A222066696C6C3D222366636662666122206F7061636974793D222E34222F3E3C7061746820643D224D33372E3134322032344832362E3835384131382E34343620';
wwv_flow_imp.g_varchar2_table(18) := '31382E3434362030203020302032352033326131392E342031392E3420302030203020342E39312031322E36353620312E30313420312E303134203020302030202E3736362E333434682E383234762D392E35612E352E35203020302031203120305634';
wwv_flow_imp.g_varchar2_table(19) := '35682E38323461312E30313420312E303134203020302030202E3736362D2E3334344131392E342031392E342030203020302033392033326131382E3434362031382E3434362030203020302D312E3835382D387A4D333220333161322E3520322E3520';
wwv_flow_imp.g_varchar2_table(20) := '302031203120322E352D322E3541322E35303320322E3530332030203020312033322033317A222066696C6C3D222366666622206F7061636974793D222E3935222F3E3C7061746820643D224D333220333061312E3520312E3520302031203120312E35';
wwv_flow_imp.g_varchar2_table(21) := '2D312E3541312E35303220312E3530322030203020312033322033307A222066696C6C3D222366636662666122206F7061636974793D222E36222F3E3C2F7376673E';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(34557024964496788)
,p_file_name=>'app-icon.svg'
,p_mime_type=>'image/svg+xml'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/files/app_icon_css
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E6170702D69636F6E207B0A202020206261636B67726F756E642D696D6167653A2075726C286170702D69636F6E2E737667293B0A202020206261636B67726F756E642D7265706561743A206E6F2D7265706561743B0A202020206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(2) := '642D73697A653A20636F7665723B0A202020206261636B67726F756E642D706F736974696F6E3A203530253B0A202020206261636B67726F756E642D636F6C6F723A20234341353839443B0A7D';
wwv_flow_imp_shared.create_app_static_file(
 p_id=>wwv_flow_imp.id(34557327677496789)
,p_file_name=>'app-icon.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1639391754428832)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1639431068428832)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(34413275234496644)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(34413520478496646)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(34413856563496646)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(34414176033496646)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(34414313154496646)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(34414603333496646)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'Y'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(34414977599496646)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(34415279172496646)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(36257928837302989)
,p_plugin_type=>'PROCESS TYPE'
,p_plugin=>'PLUGIN_COM.FLOWS4APEX.MANAGE_INSTANCE.PROCESS'
);
end;
/
prompt --application/shared_components/security/authorizations/administration_rights
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(34558694639496789)
,p_name=>'Administration Rights'
,p_scheme_type=>'NATIVE_IS_IN_GROUP'
,p_attribute_01=>'ADMIN'
,p_attribute_02=>'A'
,p_error_message=>'Insufficient privileges, user is not an Administrator'
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/app_access_control/admin
begin
wwv_flow_imp_shared.create_acl_role(
 p_id=>wwv_flow_imp.id(36982766541009212)
,p_static_id=>'ADMIN'
,p_name=>'ADMIN'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_items/process_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(5468592592804935)
,p_name=>'PROCESS_ID'
,p_protection_level=>'S'
);
end;
/
prompt --application/shared_components/logic/application_items/step_key
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(5468973476806214)
,p_name=>'STEP_KEY'
,p_protection_level=>'S'
);
end;
/
prompt --application/shared_components/logic/application_items/subflow_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(5468720920805386)
,p_name=>'SUBFLOW_ID'
,p_protection_level=>'S'
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/form_startable_diagrams_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(36245565367568167)
,p_lov_name=>'FORM_STARTABLE_DIAGRAMS_LOV'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dgrm_id',
'     , dgrm_name || '' ('' || dgrm_version || '' - '' || dgrm_status || '')'' as display_value',
'  from flow_startable_diagrams_vw',
' where (',
'            (',
'                potential_starting_users is null',
'                or',
'                (',
'                    potential_starting_users is not null',
'                    and',
'                    lower(:APP_USER) member of apex_string.split(lower(potential_starting_users),'':'')',
'                )',
'            )',
'            and',
'            (',
'                potential_starting_groups is null',
'                or',
'                (',
'                    potential_starting_groups is not null',
'                    and',
'                    exists',
'                    (',
'                        select 1 ',
'                          from apex_string.split(lower(potential_starting_groups),'':'') sg',
'                             , apex_appl_acl_users au ',
'                         where lower(au.USER_NAME) = lower(:APP_USER) ',
'                           and sg.column_value member of apex_string.split(lower(au.role_names),'','')',
'                    )',
'                )',
'            )',
'            and',
'            (',
'                excluded_starting_users is null',
'                or',
'                (',
'                    excluded_starting_users is not null',
'                    and',
'                    lower(:APP_USER) not member of apex_string.split(lower(excluded_starting_users),'':'')',
'                )',
'            )',
'       )',
' order by dgrm_name asc, dgrm_version asc'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_query_table=>'FLOW_STARTABLE_DIAGRAMS_VW'
,p_return_column_name=>'DGRM_ID'
,p_display_column_name=>'DISPLAY_VALUE'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_templates_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(34621746513754638)
,p_lov_name=>'FORM_TEMPLATES_LOV'
,p_source_type=>'TABLE'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_query_table=>'FORM_TEMPLATES_LOV'
,p_return_column_name=>'SFTE_ID'
,p_display_column_name=>'SFTE_NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'SFTE_NAME'
,p_default_sort_direction=>'ASC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_remember_username
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(34561202579496804)
,p_lov_name=>'LOGIN_REMEMBER_USERNAME'
,p_lov_query=>'.'||wwv_flow_imp.id(34561202579496804)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34561622953496805)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Remember username'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/pages/page_groups
begin
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(34559284360496791)
,p_group_name=>'Administration'
);
end;
/
prompt --application/comments
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_imp_shared.create_menu(
 p_id=>wwv_flow_imp.id(34415839139496648)
,p_name=>'Breadcrumb'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5117366166716982)
,p_short_name=>'My Tasks'
,p_link=>'f?p=&APP_ID.:3:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>3
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7164214372997664)
,p_short_name=>'Starting Process'
,p_link=>'f?p=&APP_ID.:8:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>8
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/drawer
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(4547911793880930)
,p_theme_id=>42
,p_name=>'Drawer'
,p_internal_name=>'DRAWER'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.theme42.initializePage.modalDialog();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-Drawer-page t-PageTemplate--drawer #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Drawer" role="dialog" aria-label="#TITLE#">',
'  <div class="t-Drawer-header">#REGION_POSITION_01#</div>',
'  <div class="t-Drawer-bodyWrapperOut">',
'    <div class="t-Drawer-bodyWrapperIn">',
'      <div class="t-Drawer-body" role="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</div>',
'    </div>',
'  </div>',
'  <div class="t-Drawer-footer">#REGION_POSITION_03#</div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>11
,p_preset_template_options=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.theme42.dialog(#PAGE_URL#,{title:#TITLE#,w:#DIALOG_WIDTH#,mxw:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,dlgCls:''t-Drawer-page--standard ''+#DIALOG_CSS_CLASSES#,#DIALOG_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#)'
,p_dialog_js_close_code=>'apex.theme42.dialog.close(#IS_MODAL#,#TARGET#)'
,p_dialog_js_cancel_code=>'apex.theme42.dialog.cancel(#IS_MODAL#)'
,p_dialog_height=>'auto'
,p_dialog_width=>'720'
,p_dialog_max_width=>'960'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>1659739787629394056
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4548407728880930)
,p_page_template_id=>wwv_flow_imp.id(4547911793880930)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4548987034880930)
,p_page_template_id=>wwv_flow_imp.id(4547911793880930)
,p_name=>'Dialog Header'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4549415193880931)
,p_page_template_id=>wwv_flow_imp.id(4547911793880930)
,p_name=>'Dialog Footer'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/master_detail
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(34416610173496657)
,p_theme_id=>42
,p_name=>'Marquee'
,p_internal_name=>'MASTER_DETAIL'
,p_is_popup=>false
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.stickyTableHeader#MIN#.js?v=#APEX_VERSION#',
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#'))
,p_javascript_code_onload=>'apex.theme42.initializePage.masterDetail();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--masterDetail t-PageBody--hideLeft no-anim t-PageTemplate--marquee #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<script>(sessionStorage.getItem("right.&APP_ID..&APP_PAGE_ID..preferenceForExpanded") === "true") ? document.getElementById(''t_PageBody'').classList.add(''js-rightExpanded'') : document.getElementById(''t_PageBody'').classList.add(''js-rightCollapsed'')</sc'
||'ript>',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-info" id="t_Body_info">#REGION_POSITION_02#</div>',
'        <div class="t-Body-contentInner" role="main">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Body-actionsToggle" title="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" id="t_Button_rightControlButton" type="button"><span class="t-Body-actionsControlsIcon" aria-hidden="true"></span></button>',
'    <div class="t-Body-actionsContent" role="complementary">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>1996914646461572319
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4483194919880915)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4483649431880915)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4484156591880915)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4484661005880915)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4485111141880916)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4485669287880916)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'Master Detail'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4486119526880916)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'Right Side Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4486633004880916)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4487119254880916)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4487629203880916)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4488162468880916)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4488646113880916)
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
end;
/
prompt --application/shared_components/user_interface/templates/page/modal_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(34419794295496671)
,p_theme_id=>42
,p_name=>'Modal Dialog'
,p_internal_name=>'MODAL_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.theme42.initializePage.modalDialog();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-Dialog-page t-Dialog-page--standard t-PageTemplate--dialog #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="t-Dialog-header">#REGION_POSITION_01#</div>',
'  <div class="t-Dialog-bodyWrapperOut">',
'    <div class="t-Dialog-bodyWrapperIn">',
'      <div class="t-Dialog-body" role="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</div>',
'    </div>',
'  </div>',
'  <div class="t-Dialog-footer">#REGION_POSITION_03#</div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.theme42.dialog(#PAGE_URL#,{title:#TITLE#,h:#DIALOG_HEIGHT#,w:#DIALOG_WIDTH#,mxw:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,dlgCls:''t-Dialog-page--standard ''+#DIALOG_CSS_CLASSES#,#DIALOG_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMEN'
||'T#)'
,p_dialog_js_close_code=>'apex.theme42.dialog.close(#IS_MODAL#,#TARGET#)'
,p_dialog_js_cancel_code=>'apex.theme42.dialog.cancel(#IS_MODAL#)'
,p_dialog_height=>'auto'
,p_dialog_width=>'720'
,p_dialog_max_width=>'960'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2098960803539086924
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4490930444880917)
,p_page_template_id=>wwv_flow_imp.id(34419794295496671)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4491418159880917)
,p_page_template_id=>wwv_flow_imp.id(34419794295496671)
,p_name=>'Dialog Header'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4491920438880917)
,p_page_template_id=>wwv_flow_imp.id(34419794295496671)
,p_name=>'Dialog Footer'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/login
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(34421292387496672)
,p_theme_id=>42
,p_name=>'Login'
,p_internal_name=>'LOGIN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.appLogin();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody--login t-PageTemplate--login no-anim #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#',
'<div class="t-Login-bg">',
'  #BACKGROUND_IMAGE#',
'  <div class="t-Login-bgImg"></div>',
'</div>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Login-container">',
'  <header class="t-Login-containerHeader">#REGION_POSITION_01#</header>',
'  <main class="t-Login-containerBody" id="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</main>',
'  <footer class="t-Login-containerFooter">#REGION_POSITION_02#</footer>',
'</div>',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>6
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2099711150063350616
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4494577417880918)
,p_page_template_id=>wwv_flow_imp.id(34421292387496672)
,p_name=>'Background Image'
,p_placeholder=>'BACKGROUND_IMAGE'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4495079109880918)
,p_page_template_id=>wwv_flow_imp.id(34421292387496672)
,p_name=>'Content Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4495521804880918)
,p_page_template_id=>wwv_flow_imp.id(34421292387496672)
,p_name=>'Body Header'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4496011266880918)
,p_page_template_id=>wwv_flow_imp.id(34421292387496672)
,p_name=>'Body Footer'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/wizard_modal_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(34423569196496674)
,p_theme_id=>42
,p_name=>'Wizard Modal Dialog'
,p_internal_name=>'WIZARD_MODAL_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.theme42.initializePage.wizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-Dialog-page t-Dialog-page--wizard t-PageTemplate--wizard #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD#>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="t-Dialog-header">#REGION_POSITION_01#</div>',
'  <div class="t-Dialog-bodyWrapperOut">',
'    <div class="t-Dialog-bodyWrapperIn">',
'      <div class="t-Dialog-body" role="main">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION##BODY#</div>',
'    </div>',
'  </div>',
'  <div class="t-Dialog-footer">#REGION_POSITION_03#</div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>3
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_js_init_code=>'apex.theme42.dialog(#PAGE_URL#,{title:#TITLE#,h:#DIALOG_HEIGHT#,w:#DIALOG_WIDTH#,mxw:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,dlgCls:''t-Dialog-page--wizard ''+#DIALOG_CSS_CLASSES#,#DIALOG_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#'
||')'
,p_dialog_js_close_code=>'apex.theme42.dialog.close(#IS_MODAL#,#TARGET#)'
,p_dialog_js_cancel_code=>'apex.theme42.dialog.cancel(#IS_MODAL#)'
,p_dialog_height=>'auto'
,p_dialog_width=>'720'
,p_dialog_max_width=>'960'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2120348229686426515
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4500498973880919)
,p_page_template_id=>wwv_flow_imp.id(34423569196496674)
,p_name=>'Wizard Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4500962285880919)
,p_page_template_id=>wwv_flow_imp.id(34423569196496674)
,p_name=>'Wizard Progress Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4501462867880920)
,p_page_template_id=>wwv_flow_imp.id(34423569196496674)
,p_name=>'Wizard Buttons'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/left_side_column
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(34425087266496675)
,p_theme_id=>42
,p_name=>'Left Side Column'
,p_internal_name=>'LEFT_SIDE_COLUMN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.leftSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--showLeft t-PageBody--hideActions no-anim t-PageTemplate--leftCol #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-side" id="t_Body_side">#REGION_POSITION_02#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main class="t-Body-mainContent" id="main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2525196570560608698
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4506024272880921)
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4506586547880921)
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4507011959880921)
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4507510110880921)
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4508012912880921)
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4508580511880921)
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_name=>'Left Column'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4509001544880921)
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4509565901880921)
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4510018609880921)
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4510548665880921)
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4511068970880921)
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>8
);
end;
/
prompt --application/shared_components/user_interface/templates/page/right_side_column
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(34427830536496676)
,p_theme_id=>42
,p_name=>'Right Side Column'
,p_internal_name=>'RIGHT_SIDE_COLUMN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.rightSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8"> ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft no-anim t-PageTemplate--rightSideCol #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<script>(sessionStorage.getItem("right.&APP_ID..&APP_PAGE_ID..preferenceForExpanded") === "true") ? document.getElementById(''t_PageBody'').classList.add(''js-rightExpanded'') : document.getElementById(''t_PageBody'').classList.add(''js-rightCollapsed'')</sc'
||'ript>',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Body-actionsToggle" aria-label="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" title="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" id="t_Button_rightControlButton" type="button"><span class="t-Body-actionsControlsIcon" aria-hidden="true"></span></button'
||'>',
'    <div class="t-Body-actionsContent" role="complementary">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2525200116240651575
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4515361502880923)
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4515814006880923)
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4516305440880923)
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4516851042880923)
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4517303937880923)
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4517812408880923)
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_name=>'Right Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4518341710880923)
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4518859527880923)
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4519396009880924)
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4519842428880924)
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4520326077880924)
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>8
);
end;
/
prompt --application/shared_components/user_interface/templates/page/left_and_right_side_columns
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(34430628506496677)
,p_theme_id=>42
,p_name=>'Left and Right Side Columns'
,p_internal_name=>'LEFT_AND_RIGHT_SIDE_COLUMNS'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.bothSideCols();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">  ',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0"/>',
'</head>',
'<body class="t-PageBody t-PageBody--showLeft no-anim t-PageTemplate--leftRightCol #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<script>(sessionStorage.getItem("right.&APP_ID..&APP_PAGE_ID..preferenceForExpanded") === "true") ? document.getElementById(''t_PageBody'').classList.add(''js-rightExpanded'') : document.getElementById(''t_PageBody'').classList.add(''js-rightCollapsed'')</sc'
||'ript>',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-side" id="t_Body_side">#REGION_POSITION_02#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'  <div class="t-Body-actions" id="t_Body_actions">',
'    <button class="t-Body-actionsToggle" title="#EXPAND_COLLAPSE_SIDE_COL_LABEL#" id="t_Button_rightControlButton" type="button"><span class="t-Body-actionsControlsIcon" aria-hidden="true"></span></button>',
'    <div class="t-Body-actionsContent" role="complementary">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Success'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" onclick="apex.jQuery(''#t_Alert_Notification'').remove();" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>17
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2525203692562657055
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4525041077880925)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4525551627880925)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4526084008880925)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4526550958880926)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>6
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4527006293880926)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4527516423880926)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'Left Column'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>3
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4528016806880926)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'Right Column'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>3
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4528579010880926)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4528908976880926)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>6
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4529499388880926)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4529928784880926)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4530461663880926)
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>6
);
end;
/
prompt --application/shared_components/user_interface/templates/page/minimal_no_navigation
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(34433764173496678)
,p_theme_id=>42
,p_name=>'Minimal (No Navigation)'
,p_internal_name=>'MINIMAL_NO_NAVIGATION'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.noSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#  ',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft t-PageBody--hideActions no-anim #PAGE_CSS_CLASSES# t-PageBody--noNav t-PageTemplate--minimal" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="#EXPAND_COLLAPSE_NAV_LABEL#" title="#EXPAND_COLLAPSE_NAV_LABEL#" id="t_Button_navControl" type="button"><span class="t-Icon fa fa-bars" aria-hidden="true"'
||'></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'</header>',
'    '))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>',
''))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar t-NavigationBar--classic" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>2977628563533209425
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4534397094880927)
,p_page_template_id=>wwv_flow_imp.id(34433764173496678)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4534817986880927)
,p_page_template_id=>wwv_flow_imp.id(34433764173496678)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4535386668880927)
,p_page_template_id=>wwv_flow_imp.id(34433764173496678)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4535844501880927)
,p_page_template_id=>wwv_flow_imp.id(34433764173496678)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4536349264880928)
,p_page_template_id=>wwv_flow_imp.id(34433764173496678)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4536874533880928)
,p_page_template_id=>wwv_flow_imp.id(34433764173496678)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4537367663880928)
,p_page_template_id=>wwv_flow_imp.id(34433764173496678)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4537800058880928)
,p_page_template_id=>wwv_flow_imp.id(34433764173496678)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4538311351880928)
,p_page_template_id=>wwv_flow_imp.id(34433764173496678)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4538877430880928)
,p_page_template_id=>wwv_flow_imp.id(34433764173496678)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/page/standard
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(34436267275496679)
,p_theme_id=>42
,p_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.theme42.initializePage.noSideCol();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js #RTL_CLASS# page-&APP_PAGE_ID. app-&APP_ALIAS." lang="&BROWSER_LANGUAGE." #TEXT_DIRECTION#>',
'<head>',
'  <meta http-equiv="x-ua-compatible" content="IE=edge" />',
'  <meta charset="utf-8">',
'  <title>#TITLE#</title>',
'  #APEX_CSS#',
'  #THEME_CSS#',
'  #TEMPLATE_CSS#',
'  #THEME_STYLE_CSS#',
'  #APPLICATION_CSS#',
'  #PAGE_CSS#',
'  #FAVICONS#',
'  #HEAD#',
'  <meta name="viewport" content="width=device-width, initial-scale=1.0" />',
'</head>',
'<body class="t-PageBody t-PageBody--hideLeft t-PageBody--hideActions no-anim t-PageTemplate--standard #PAGE_CSS_CLASSES#" #TEXT_DIRECTION# #ONLOAD# id="t_PageBody">',
'<a href="#main" id="t_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#FORM_OPEN#',
'<header class="t-Header" id="t_Header" role="banner">',
'  #REGION_POSITION_07#',
'  <div class="t-Header-branding">',
'    <div class="t-Header-controls">',
'      <button class="t-Button t-Button--icon t-Button--header t-Button--headerTree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." title="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL"." id="t_Button_navControl" type="button"><span class="t-Header-'
||'controlsIcon" aria-hidden="true"></span></button>',
'    </div>',
'    <div class="t-Header-logo">',
'      <a href="#HOME_LINK#" class="t-Header-logo-link">#LOGO#</a>',
'      #AFTER_LOGO#',
'    </div>',
'    <div class="t-Header-navBar">',
'      <div class="t-Header-navBar--start">#BEFORE_NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--center">#NAVIGATION_BAR#</div>',
'      <div class="t-Header-navBar--end">#AFTER_NAVIGATION_BAR#</div>',
'    </div>',
'  </div>',
'  <div class="t-Header-nav">#TOP_GLOBAL_NAVIGATION_LIST##REGION_POSITION_06#</div>',
'</header>',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body">',
'  #SIDE_GLOBAL_NAVIGATION_LIST#',
'  <div class="t-Body-main">',
'    <div class="t-Body-title" id="t_Body_title">#REGION_POSITION_01#</div>',
'    <div class="t-Body-content" id="t_Body_content">',
'      <main id="main" class="t-Body-mainContent">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        <div class="t-Body-fullContent">#REGION_POSITION_08#</div>',
'        <div class="t-Body-contentInner">#BODY#</div>',
'      </main>',
'      <footer class="t-Footer" id="t_Footer" role="contentinfo">',
'        <div class="t-Footer-body">',
'          <div class="t-Footer-content">#REGION_POSITION_05#</div>',
'          <div class="t-Footer-apex">',
'            <div class="t-Footer-version">#APP_VERSION#</div>',
'            <div class="t-Footer-customize">#CUSTOMIZE#</div>',
'            #BUILT_WITH_LOVE_USING_APEX#',
'          </div>',
'        </div>',
'        <div class="t-Footer-top">',
'          <a href="#top" class="t-Footer-topButton" id="t_Footer_topButton"><span class="a-Icon icon-up-chevron"></span></a>',
'        </div>',
'      </footer>',
'    </div>',
'  </div>',
'</div>',
'<div class="t-Body-inlineDialogs" id="t_Body_inlineDialogs">#REGION_POSITION_04#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#  ',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>',
''))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--success t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Success" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-header">',
'          <h2 class="t-Alert-title">#SUCCESS_MESSAGE#</h2>',
'        </div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-alert">',
'  <div class="t-Alert t-Alert--defaultIcons t-Alert--warning t-Alert--horizontal t-Alert--page t-Alert--colorBG" id="t_Alert_Notification" role="alert">',
'    <div class="t-Alert-wrap">',
'      <div class="t-Alert-icon">',
'        <span class="t-Icon"></span>',
'      </div>',
'      <div class="t-Alert-content">',
'        <div class="t-Alert-body">#MESSAGE#</div>',
'      </div>',
'      <div class="t-Alert-buttons">',
'        <button class="t-Button t-Button--noUI t-Button--icon t-Button--closeAlert" type="button" title="#CLOSE_NOTIFICATION#"><span class="t-Icon icon-close"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-NavigationBar t-NavigationBar--classic" data-mode="classic">',
'  <li class="t-NavigationBar-item">',
'    <span class="t-Button t-Button--icon t-Button--noUI t-Button--header t-Button--navBar t-Button--headerUser">',
'      <span class="t-Icon a-Icon icon-user"></span>',
'      <span class="t-Button-label">&APP_USER.</span>',
'    </span>',
'  </li>#BAR_BODY#',
'</ul>'))
,p_navbar_entry=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item">',
'  <a class="t-Button t-Button--icon t-Button--header" href="#LINK#">',
'    <span class="t-Icon #IMAGE#"></span>',
'    <span class="t-Button-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--danger t-Alert--wizard t-Alert--defaultIcons">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-body">',
'        <h3>#MESSAGE#</h3>',
'        <p>#ADDITIONAL_INFO#</p>',
'        <div class="t-Alert-inset">#TECHNICAL_INFO#</div>',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      <button onclick="#BACK_LINK#" class="t-Button t-Button--hot w50p t-Button--large" type="button">#OK#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_default_label_col_span=>2
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="row #CSS_CLASSES#">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>'<div class="col col-#COLUMN_SPAN_NUMBER# #CSS_CLASSES# #FIRST_LAST_COLUMN_ATTRIBUTES#" #ATTRIBUTES#>#CONTENT#</div>'
,p_grid_first_column_attributes=>'col-start'
,p_grid_last_column_attributes=>'col-end'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>4070909157481059304
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4542754025880929)
,p_page_template_id=>wwv_flow_imp.id(34436267275496679)
,p_name=>'After Logo'
,p_placeholder=>'AFTER_LOGO'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4543226480880929)
,p_page_template_id=>wwv_flow_imp.id(34436267275496679)
,p_name=>'After Navigation Bar'
,p_placeholder=>'AFTER_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4543746152880929)
,p_page_template_id=>wwv_flow_imp.id(34436267275496679)
,p_name=>'Before Navigation Bar'
,p_placeholder=>'BEFORE_NAVIGATION_BAR'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
,p_max_fixed_grid_columns=>4
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4544251342880929)
,p_page_template_id=>wwv_flow_imp.id(34436267275496679)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4544798737880929)
,p_page_template_id=>wwv_flow_imp.id(34436267275496679)
,p_name=>'Breadcrumb Bar'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4545245791880929)
,p_page_template_id=>wwv_flow_imp.id(34436267275496679)
,p_name=>'Dialogs, Drawers and Popups'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4545727853880930)
,p_page_template_id=>wwv_flow_imp.id(34436267275496679)
,p_name=>'Footer'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4546219308880930)
,p_page_template_id=>wwv_flow_imp.id(34436267275496679)
,p_name=>'Top Navigation'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4546798756880930)
,p_page_template_id=>wwv_flow_imp.id(34436267275496679)
,p_name=>'Banner'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4547294724880930)
,p_page_template_id=>wwv_flow_imp.id(34436267275496679)
,p_name=>'Full Width Content'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/button/icon
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(34532675072496731)
,p_template_name=>'Icon'
,p_internal_name=>'ICON'
,p_template=>'<button class="t-Button t-Button--noLabel t-Button--icon #BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidde'
||'n="true"></span></button>'
,p_hot_template=>'<button class="t-Button t-Button--noLabel t-Button--icon #BUTTON_CSS_CLASSES# t-Button--hot" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#"><span class="t-Icon #ICON_CSS_CLASSE'
||'S#" aria-hidden="true"></span></button>'
,p_reference_id=>2347660919680321258
,p_translate_this_template=>'N'
,p_theme_class_id=>5
,p_theme_id=>42
);
end;
/
prompt --application/shared_components/user_interface/templates/button/text
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(34533308970496733)
,p_template_name=>'Text'
,p_internal_name=>'TEXT'
,p_template=>'<button onclick="#JAVASCRIPT#" class="t-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><span class="t-Button-label">#LABEL#</span></button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="t-Button t-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><span class="t-Button-label">#LABEL#</span></button>'
,p_reference_id=>4070916158035059322
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>42
);
end;
/
prompt --application/shared_components/user_interface/templates/button/text_with_icon
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(34533432746496733)
,p_template_name=>'Text with Icon'
,p_internal_name=>'TEXT_WITH_ICON'
,p_template=>'<button class="t-Button t-Button--icon #BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#"><span class="t-Icon t-Icon--left #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="t-Button-label">#LABEL#'
||'</span><span class="t-Icon t-Icon--right #ICON_CSS_CLASSES#" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="t-Button t-Button--icon #BUTTON_CSS_CLASSES# t-Button--hot" #BUTTON_ATTRIBUTES# onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#"><span class="t-Icon t-Icon--left #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="t-Button-'
||'label">#LABEL#</span><span class="t-Icon t-Icon--right #ICON_CSS_CLASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>2081382742158699622
,p_translate_this_template=>'N'
,p_theme_class_id=>4
,p_preset_template_options=>'t-Button--iconLeft'
,p_theme_id=>42
);
end;
/
prompt --application/shared_components/user_interface/templates/region/inline_drawer
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(4759614622880980)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#_parent">',
'  <div id="#REGION_STATIC_ID#" class="t-DrawerRegion js-dialog-class-ui-dialog--drawer #REGION_CSS_CLASSES# js-regionDialog" #REGION_ATTRIBUTES# style="display:none" title="#TITLE!ATTR#">',
'    <div class="t-DrawerRegion-wrap">',
'      <div class="t-DrawerRegion-bodyWrapperOut">',
'        <div class="t-DrawerRegion-bodyWrapperIn">',
'          <div class="t-DrawerRegion-body">#BODY##SUB_REGIONS#</div>',
'        </div>',
'      </div>',
'      <div class="t-DrawerRegion-buttons">',
'        <div class="t-ButtonRegion t-ButtonRegion--dialogRegion">',
'          <div class="t-ButtonRegion-wrap">',
'            <div class="t-ButtonRegion-col t-ButtonRegion-col--left">',
'              <div class="t-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div>',
'            </div>',
'            <div class="t-ButtonRegion-col t-ButtonRegion-col--right">',
'              <div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div>',
'            </div>',
'          </div>',
'        </div>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Inline Drawer'
,p_internal_name=>'INLINE_DRAWER'
,p_theme_id=>42
,p_theme_class_id=>24
,p_default_template_options=>'js-modal'
,p_preset_template_options=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1659526333647509386
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4760150615880980)
,p_plug_template_id=>wwv_flow_imp.id(4759614622880980)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4760676550880981)
,p_plug_template_id=>wwv_flow_imp.id(4759614622880980)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4761191119880981)
,p_plug_template_id=>wwv_flow_imp.id(4759614622880980)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4761649839880981)
,p_plug_template_id=>wwv_flow_imp.id(4759614622880980)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4762163177880981)
,p_plug_template_id=>wwv_flow_imp.id(4759614622880980)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4762664231880981)
,p_plug_template_id=>wwv_flow_imp.id(4759614622880980)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4763173428880981)
,p_plug_template_id=>wwv_flow_imp.id(4759614622880980)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4763661556880981)
,p_plug_template_id=>wwv_flow_imp.id(4759614622880980)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/image
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(4767674643880982)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="t-ImageRegion #REGION_CSS_CLASSES#"><img src="#REGION_IMAGE_URL#" alt="#REGION_IMAGE_ALT_TEXT#" #REGION_IMAGE_ATTRIBUTES# /></div>'
,p_page_plug_template_name=>'Image'
,p_internal_name=>'IMAGE'
,p_theme_id=>42
,p_theme_class_id=>21
,p_preset_template_options=>'t-ImageRegion--noFilter:t-ImageRegion--auto:t-ImageRegion--cover:t-ImageRegion--square'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1673953645642781634
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4768161699880982)
,p_plug_template_id=>wwv_flow_imp.id(4767674643880982)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4768602388880982)
,p_plug_template_id=>wwv_flow_imp.id(4767674643880982)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/alert
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34438790691496680)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-header">',
'        <h2 class="t-Alert-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h2>',
'      </div>',
'      <div class="t-Alert-body">#BODY##SUB_REGIONS#</div>',
'    </div>',
'    <div class="t-Alert-buttons">#PREVIOUS##CLOSE##CREATE##NEXT#</div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Alert'
,p_internal_name=>'ALERT'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>21
,p_preset_template_options=>'t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--warning'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2039236646100190748
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4569588788880935)
,p_plug_template_id=>wwv_flow_imp.id(34438790691496680)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4570013433880935)
,p_plug_template_id=>wwv_flow_imp.id(34438790691496680)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4570580497880935)
,p_plug_template_id=>wwv_flow_imp.id(34438790691496680)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4571057534880935)
,p_plug_template_id=>wwv_flow_imp.id(34438790691496680)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4571551054880935)
,p_plug_template_id=>wwv_flow_imp.id(34438790691496680)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4572094599880935)
,p_plug_template_id=>wwv_flow_imp.id(34438790691496680)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/blank_with_attributes
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34442442131496686)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="#REGION_CSS_CLASSES#">#PREVIOUS##BODY##SUB_REGIONS##NEXT#</div>'
,p_page_plug_template_name=>'Blank with Attributes'
,p_internal_name=>'BLANK_WITH_ATTRIBUTES'
,p_theme_id=>42
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>4499993862448380551
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4757719362880980)
,p_plug_template_id=>wwv_flow_imp.id(34442442131496686)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4758201247880980)
,p_plug_template_id=>wwv_flow_imp.id(34442442131496686)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4758732392880980)
,p_plug_template_id=>wwv_flow_imp.id(34442442131496686)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4759273542880980)
,p_plug_template_id=>wwv_flow_imp.id(34442442131496686)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/blank_with_attributes_no_grid
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34442668667496687)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="#REGION_CSS_CLASSES#">#PREVIOUS##BODY##SUB_REGIONS##NEXT#</div>'
,p_page_plug_template_name=>'Blank with Attributes (No Grid)'
,p_internal_name=>'BLANK_WITH_ATTRIBUTES_NO_GRID'
,p_theme_id=>42
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>3369790999010910123
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4722735057880972)
,p_plug_template_id=>wwv_flow_imp.id(34442668667496687)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4723242908880972)
,p_plug_template_id=>wwv_flow_imp.id(34442668667496687)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4723704527880972)
,p_plug_template_id=>wwv_flow_imp.id(34442668667496687)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4724274577880972)
,p_plug_template_id=>wwv_flow_imp.id(34442668667496687)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/buttons_container
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34443487668496687)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-ButtonRegion t-Form--floatLeft #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-ButtonRegion-wrap">',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--left"><div class="t-ButtonRegion-buttons">#PREVIOUS##CLOSE##DELETE#</div></div>',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--content">',
'      #BODY#',
'      <div class="t-ButtonRegion-buttons">#CHANGE#</div>',
'      #SUB_REGIONS#',
'    </div>',
'    <div class="t-ButtonRegion-col t-ButtonRegion-col--right"><div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'Buttons Container'
,p_internal_name=>'BUTTONS_CONTAINER'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>17
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2124982336649579661
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4599391830880942)
,p_plug_template_id=>wwv_flow_imp.id(34443487668496687)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4599845404880942)
,p_plug_template_id=>wwv_flow_imp.id(34443487668496687)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4600317958880942)
,p_plug_template_id=>wwv_flow_imp.id(34443487668496687)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4600888904880942)
,p_plug_template_id=>wwv_flow_imp.id(34443487668496687)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4601325681880942)
,p_plug_template_id=>wwv_flow_imp.id(34443487668496687)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4601861830880942)
,p_plug_template_id=>wwv_flow_imp.id(34443487668496687)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4602347280880942)
,p_plug_template_id=>wwv_flow_imp.id(34443487668496687)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4602844885880942)
,p_plug_template_id=>wwv_flow_imp.id(34443487668496687)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4603311581880942)
,p_plug_template_id=>wwv_flow_imp.id(34443487668496687)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/cards_container
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34445609432496688)
,p_layout=>'TABLE'
,p_template=>'<div role="region" aria-label="#TITLE!ATTR#" class="t-CardsRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#ORDER_BY_ITEM##BODY##SUB_REGIONS#</div>'
,p_page_plug_template_name=>'Cards Container'
,p_internal_name=>'CARDS_CONTAINER'
,p_theme_id=>42
,p_theme_class_id=>21
,p_default_template_options=>'u-colors'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2071277712695139743
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4580591133880938)
,p_plug_template_id=>wwv_flow_imp.id(34445609432496688)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4581040845880938)
,p_plug_template_id=>wwv_flow_imp.id(34445609432496688)
,p_name=>'Sort Order'
,p_placeholder=>'ORDER_BY_ITEM'
,p_has_grid_support=>true
,p_has_region_support=>false
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4581565690880938)
,p_plug_template_id=>wwv_flow_imp.id(34445609432496688)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/carousel_container
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34446604670496689)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Region t-Region--carousel #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Region-header">',
'    <div class="t-Region-headerItems t-Region-headerItems--title">',
'      <span class="t-Region-headerIcon"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span></span>',
'      <h2 class="t-Region-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h2>',
'    </div>',
'    <div class="t-Region-headerItems t-Region-headerItems--buttons">#COPY##EDIT#<span class="js-maximizeButtonContainer"></span></div>',
'  </div>',
'  <div role="region" aria-label="#TITLE#" class="t-Region-bodyWrap">',
'    <div class="t-Region-buttons t-Region-buttons--top">',
'      <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'      <div class="t-Region-buttons-right">#NEXT#</div>',
'    </div>',
'    <div class="t-Region-body">',
'      #BODY#',
'      <div class="t-Region-carouselRegions">#SUB_REGIONS#</div>',
'    </div>',
'    <div class="t-Region-buttons t-Region-buttons--bottom">',
'      <div class="t-Region-buttons-left">#CLOSE##HELP#</div>',
'      <div class="t-Region-buttons-right">#DELETE##CHANGE##CREATE#</div>',
'    </div>',
'  </div>',
'</div>'))
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div data-label="#SUB_REGION_TITLE#" id="SR_#SUB_REGION_ID#">',
'  #SUB_REGION#',
'</div>'))
,p_page_plug_template_name=>'Carousel Container'
,p_internal_name=>'CAROUSEL_CONTAINER'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#',
'#APEX_FILES#plugins/com.oracle.apex.carousel/1.1/com.oracle.apex.carousel#MIN#.js?v=#APEX_VERSION#'))
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>5
,p_default_template_options=>'t-Region--showCarouselControls'
,p_preset_template_options=>'t-Region--hiddenOverflow'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2865840475322558786
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4695851664880964)
,p_plug_template_id=>wwv_flow_imp.id(34446604670496689)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4696391723880964)
,p_plug_template_id=>wwv_flow_imp.id(34446604670496689)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4696818089880964)
,p_plug_template_id=>wwv_flow_imp.id(34446604670496689)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4697386273880964)
,p_plug_template_id=>wwv_flow_imp.id(34446604670496689)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4697887941880964)
,p_plug_template_id=>wwv_flow_imp.id(34446604670496689)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4698373223880964)
,p_plug_template_id=>wwv_flow_imp.id(34446604670496689)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4698839410880964)
,p_plug_template_id=>wwv_flow_imp.id(34446604670496689)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4699366320880965)
,p_plug_template_id=>wwv_flow_imp.id(34446604670496689)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4699897258880965)
,p_plug_template_id=>wwv_flow_imp.id(34446604670496689)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4700396689880965)
,p_plug_template_id=>wwv_flow_imp.id(34446604670496689)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4700812084880965)
,p_plug_template_id=>wwv_flow_imp.id(34446604670496689)
,p_name=>'Slides'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/collapsible
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34453825801496693)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!HTML#" class="t-Region t-Region--hideShow #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
' <div class="t-Region-header">',
'  <div class="t-Region-headerItems t-Region-headerItems--controls"><span class="t-Button t-Button--icon t-Button--hideShow"><span class="a-Icon _a-Collapsible-icon" aria-hidden="true"></span></span></div>',
'  <div class="t-Region-headerItems t-Region-headerItems--title">',
'    <h2 class="t-Region-title" data-apex-heading><button class="t-Region-titleButton" type="button">#TITLE#</button></h2>',
'  </div>',
'  <div class="t-Region-headerItems t-Region-headerItems--buttons">#EDIT#</div>',
' </div>',
' <div class="t-Region-bodyWrap">',
'   <div class="t-Region-buttons t-Region-buttons--top">',
'    <div class="t-Region-buttons-left">#CLOSE#</div>',
'    <div class="t-Region-buttons-right">#CREATE#</div>',
'   </div>',
'   <div class="t-Region-body">',
'     #COPY#',
'     #BODY#',
'     #SUB_REGIONS#',
'     #CHANGE#',
'   </div>',
'   <div class="t-Region-buttons t-Region-buttons--bottom">',
'    <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'    <div class="t-Region-buttons-right">#NEXT#</div>',
'   </div>',
' </div>',
'</div>'))
,p_page_plug_template_name=>'Collapsible'
,p_internal_name=>'COLLAPSIBLE'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>1
,p_preset_template_options=>'is-expanded:t-Region--scrollBody'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2662888092628347716
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4634832645880949)
,p_plug_template_id=>wwv_flow_imp.id(34453825801496693)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4635392047880949)
,p_plug_template_id=>wwv_flow_imp.id(34453825801496693)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4635896869880949)
,p_plug_template_id=>wwv_flow_imp.id(34453825801496693)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4636351550880949)
,p_plug_template_id=>wwv_flow_imp.id(34453825801496693)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4636847682880949)
,p_plug_template_id=>wwv_flow_imp.id(34453825801496693)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4637390232880949)
,p_plug_template_id=>wwv_flow_imp.id(34453825801496693)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4637874325880949)
,p_plug_template_id=>wwv_flow_imp.id(34453825801496693)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4638377347880949)
,p_plug_template_id=>wwv_flow_imp.id(34453825801496693)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4638855235880950)
,p_plug_template_id=>wwv_flow_imp.id(34453825801496693)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/content_block
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34459258426496695)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-ContentBlock #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-ContentBlock-header">',
'    <div class="t-ContentBlock-headerItems t-ContentBlock-headerItems--title">',
'      <span class="t-ContentBlock-headerIcon"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span></span>',
'      <h1 class="t-ContentBlock-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h1>',
'      #EDIT#',
'    </div>',
'    <div class="t-ContentBlock-headerItems t-ContentBlock-headerItems--buttons">#CHANGE#</div>',
'  </div>',
'  <div class="t-ContentBlock-body">#BODY##SUB_REGIONS#</div>',
'  <div class="t-ContentBlock-buttons">#PREVIOUS##NEXT#</div>',
'</div>',
''))
,p_page_plug_template_name=>'Content Block'
,p_internal_name=>'CONTENT_BLOCK'
,p_theme_id=>42
,p_theme_class_id=>21
,p_preset_template_options=>'t-ContentBlock--h1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2320668864738842174
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4609251718880944)
,p_plug_template_id=>wwv_flow_imp.id(34459258426496695)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4609774703880944)
,p_plug_template_id=>wwv_flow_imp.id(34459258426496695)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4610245211880944)
,p_plug_template_id=>wwv_flow_imp.id(34459258426496695)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4610765624880944)
,p_plug_template_id=>wwv_flow_imp.id(34459258426496695)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4611296809880944)
,p_plug_template_id=>wwv_flow_imp.id(34459258426496695)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4611766528880944)
,p_plug_template_id=>wwv_flow_imp.id(34459258426496695)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/hero
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34461241212496696)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-HeroRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-HeroRegion-top">',
'    <div class="t-HeroRegion-wrap">',
'      <div class="t-HeroRegion-col t-HeroRegion-col--left">#REGION_IMAGE#<span class="t-HeroRegion-icon t-Icon #ICON_CSS_CLASSES#"></span></div>',
'      <div class="t-HeroRegion-col t-HeroRegion-col--content">',
'        <h1 class="t-HeroRegion-title" data-apex-heading>#TITLE#</h1>',
'        #BODY#',
'      </div>',
'      <div class="t-HeroRegion-col t-HeroRegion-col--right"><div class="t-HeroRegion-form">#SUB_REGIONS#</div><div class="t-HeroRegion-buttons">#NEXT#</div></div>',
'    </div>',
'  </div>',
'  <div class="t-HeroRegion-bottom">#SMART_FILTERS#</div>',
'</div>',
''))
,p_page_plug_template_name=>'Hero'
,p_internal_name=>'HERO'
,p_image_template=>'<img class="t-HeroRegion-icon" src="#REGION_IMAGE_URL#" alt="" />'
,p_theme_id=>42
,p_theme_class_id=>22
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2672571031438297268
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4677362310880958)
,p_plug_template_id=>wwv_flow_imp.id(34461241212496696)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>false
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4677809643880959)
,p_plug_template_id=>wwv_flow_imp.id(34461241212496696)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4678323457880959)
,p_plug_template_id=>wwv_flow_imp.id(34461241212496696)
,p_name=>'Smart Filters'
,p_placeholder=>'SMART_FILTERS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4678822109880959)
,p_plug_template_id=>wwv_flow_imp.id(34461241212496696)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/inline_dialog
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34463394363496697)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#_parent">',
'<div id="#REGION_STATIC_ID#" class="t-DialogRegion #REGION_CSS_CLASSES# js-regionDialog" #REGION_ATTRIBUTES# style="display:none" title="#TITLE!ATTR#">',
'  <div class="t-DialogRegion-wrap">',
'    <div class="t-DialogRegion-bodyWrapperOut"><div class="t-DialogRegion-bodyWrapperIn"><div class="t-DialogRegion-body">#BODY##SUB_REGIONS#</div></div></div>',
'    <div class="t-DialogRegion-buttons">',
'       <div class="t-ButtonRegion t-ButtonRegion--dialogRegion">',
'         <div class="t-ButtonRegion-wrap">',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--left"><div class="t-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--right"><div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'         </div>',
'       </div>',
'    </div>',
'  </div>',
'</div>',
'</div>'))
,p_page_plug_template_name=>'Inline Dialog'
,p_internal_name=>'INLINE_DIALOG'
,p_theme_id=>42
,p_theme_class_id=>24
,p_default_template_options=>'js-modal:js-draggable:js-resizable'
,p_preset_template_options=>'js-dialog-size600x400'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2671226943886536762
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4667207123880956)
,p_plug_template_id=>wwv_flow_imp.id(34463394363496697)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4667779046880956)
,p_plug_template_id=>wwv_flow_imp.id(34463394363496697)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4668297030880956)
,p_plug_template_id=>wwv_flow_imp.id(34463394363496697)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4668773006880957)
,p_plug_template_id=>wwv_flow_imp.id(34463394363496697)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4669219040880957)
,p_plug_template_id=>wwv_flow_imp.id(34463394363496697)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4669701198880957)
,p_plug_template_id=>wwv_flow_imp.id(34463394363496697)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4670232577880957)
,p_plug_template_id=>wwv_flow_imp.id(34463394363496697)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4670762389880957)
,p_plug_template_id=>wwv_flow_imp.id(34463394363496697)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/inline_popup
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34465699375496697)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#_parent">',
'<div id="#REGION_STATIC_ID#" class="t-DialogRegion #REGION_CSS_CLASSES# js-regionPopup" #REGION_ATTRIBUTES# style="display:none" title="#TITLE!ATTR#">',
'  <div class="t-DialogRegion-wrap">',
'    <div class="t-DialogRegion-bodyWrapperOut"><div class="t-DialogRegion-bodyWrapperIn"><div class="t-DialogRegion-body">#BODY##SUB_REGIONS#</div></div></div>',
'    <div class="t-DialogRegion-buttons">',
'       <div class="t-ButtonRegion t-ButtonRegion--dialogRegion">',
'         <div class="t-ButtonRegion-wrap">',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--left"><div class="t-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'           <div class="t-ButtonRegion-col t-ButtonRegion-col--right"><div class="t-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'         </div>',
'       </div>',
'    </div>',
'  </div>',
'</div>',
'</div>'))
,p_page_plug_template_name=>'Inline Popup'
,p_internal_name=>'INLINE_POPUP'
,p_theme_id=>42
,p_theme_class_id=>24
,p_preset_template_options=>'js-dialog-size600x400'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1483922538999385230
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4556280319880932)
,p_plug_template_id=>wwv_flow_imp.id(34465699375496697)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4556797499880932)
,p_plug_template_id=>wwv_flow_imp.id(34465699375496697)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4557225849880932)
,p_plug_template_id=>wwv_flow_imp.id(34465699375496697)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4557776789880932)
,p_plug_template_id=>wwv_flow_imp.id(34465699375496697)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4558269717880932)
,p_plug_template_id=>wwv_flow_imp.id(34465699375496697)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4558785831880933)
,p_plug_template_id=>wwv_flow_imp.id(34465699375496697)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4559273043880933)
,p_plug_template_id=>wwv_flow_imp.id(34465699375496697)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4559799601880933)
,p_plug_template_id=>wwv_flow_imp.id(34465699375496697)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/interactive_report
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34468943637496698)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="t-IRR-region #REGION_CSS_CLASSES#">#PREVIOUS##ORDER_BY_ITEM##BODY##SUB_REGIONS##NEXT#</div>',
''))
,p_page_plug_template_name=>'Interactive Report'
,p_internal_name=>'INTERACTIVE_REPORT'
,p_theme_id=>42
,p_theme_class_id=>9
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2099079838218790610
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4586038041880939)
,p_plug_template_id=>wwv_flow_imp.id(34468943637496698)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4586506463880939)
,p_plug_template_id=>wwv_flow_imp.id(34468943637496698)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4587071139880939)
,p_plug_template_id=>wwv_flow_imp.id(34468943637496698)
,p_name=>'Sort Order'
,p_placeholder=>'ORDER_BY_ITEM'
,p_has_grid_support=>true
,p_has_region_support=>false
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4587511059880939)
,p_plug_template_id=>wwv_flow_imp.id(34468943637496698)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4588058339880939)
,p_plug_template_id=>wwv_flow_imp.id(34468943637496698)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/login
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34469502279496699)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Login-region t-Form--stretchInputs t-Form--labelsAbove #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Login-header">',
'    #REGION_IMAGE#',
'    <span class="t-Login-logo #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <h1 class="t-Login-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h1>',
'  </div>',
'  <div class="t-Login-body">#BODY#</div>',
'  <div class="t-Login-buttons">#NEXT#</div>',
'  <div class="t-Login-links">#EDIT##CREATE#</div>',
'  <div class="t-Login-subRegions">#SUB_REGIONS#</div>',
'</div>'))
,p_page_plug_template_name=>'Login'
,p_internal_name=>'LOGIN'
,p_image_template=>'<img class="t-Login-logo" src="#REGION_IMAGE_URL#" alt="" data-app-icon />'
,p_theme_id=>42
,p_theme_class_id=>23
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2672711194551076376
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4686263709880961)
,p_plug_template_id=>wwv_flow_imp.id(34469502279496699)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4686775505880961)
,p_plug_template_id=>wwv_flow_imp.id(34469502279496699)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4687242121880961)
,p_plug_template_id=>wwv_flow_imp.id(34469502279496699)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4687741985880961)
,p_plug_template_id=>wwv_flow_imp.id(34469502279496699)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4688253918880961)
,p_plug_template_id=>wwv_flow_imp.id(34469502279496699)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/standard
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34470894408496699)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Region #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
' <div class="t-Region-header">',
'  <div class="t-Region-headerItems t-Region-headerItems--title">',
'    <span class="t-Region-headerIcon"><span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span></span>',
'    <h2 class="t-Region-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h2>',
'  </div>',
'  <div class="t-Region-headerItems t-Region-headerItems--buttons">#COPY##EDIT#<span class="js-maximizeButtonContainer"></span></div>',
' </div>',
' <div class="t-Region-bodyWrap">',
'   <div class="t-Region-buttons t-Region-buttons--top">',
'    <div class="t-Region-buttons-left">#PREVIOUS#</div>',
'    <div class="t-Region-buttons-right">#NEXT#</div>',
'   </div>',
'   <div class="t-Region-body">',
'     #ORDER_BY_ITEM#',
'     #BODY#',
'     #SUB_REGIONS#',
'   </div>',
'   <div class="t-Region-buttons t-Region-buttons--bottom">',
'    <div class="t-Region-buttons-left">#CLOSE##HELP#</div>',
'    <div class="t-Region-buttons-right">#DELETE##CHANGE##CREATE#</div>',
'   </div>',
' </div>',
'</div>',
''))
,p_page_plug_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>42
,p_theme_class_id=>8
,p_preset_template_options=>'t-Region--scrollBody'
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>4070912133526059312
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4729442477880973)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4729982965880973)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4730419665880973)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4730961807880973)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4731406790880973)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4731924733880974)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4732458843880974)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4732917241880974)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4733412167880974)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4733992032880974)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Sort Order'
,p_placeholder=>'ORDER_BY_ITEM'
,p_has_grid_support=>true
,p_has_region_support=>false
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4734402912880974)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4734961441880974)
,p_plug_template_id=>wwv_flow_imp.id(34470894408496699)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>12
);
end;
/
prompt --application/shared_components/user_interface/templates/region/tabs_container
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34477636372496701)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-TabsRegion #REGION_CSS_CLASSES# apex-tabs-region" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'  <div class="t-TabsRegion-items">#SUB_REGIONS#</div>',
'</div>'))
,p_sub_plug_template=>'<div data-label="#SUB_REGION_TITLE#" id="SR_#SUB_REGION_ID#">#SUB_REGION#</div>'
,p_page_plug_template_name=>'Tabs Container'
,p_internal_name=>'TABS_CONTAINER'
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#'
,p_theme_id=>42
,p_theme_class_id=>5
,p_preset_template_options=>'t-TabsRegion-mod--simple'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>3221725015618492759
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4716584445880970)
,p_plug_template_id=>wwv_flow_imp.id(34477636372496701)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4717015166880970)
,p_plug_template_id=>wwv_flow_imp.id(34477636372496701)
,p_name=>'Tabs'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/title_bar
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34480263758496702)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<nav aria-label="#TITLE!ATTR#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="t-BreadcrumbRegion #REGION_CSS_CLASSES#">',
'  <div class="t-BreadcrumbRegion-top">',
'    <div class="t-BreadcrumbRegion-body">',
'      <div class="t-BreadcrumbRegion-breadcrumb">#BODY#</div>',
'        <div class="t-BreadcrumbRegion-title">',
'        <h1 id="#REGION_STATIC_ID#_heading" class="t-BreadcrumbRegion-titleText" data-apex-heading>#TITLE#</h1>',
'      </div>',
'    </div>',
'    <div class="t-BreadcrumbRegion-buttons">#PREVIOUS##CLOSE##DELETE##HELP##CHANGE##EDIT##COPY##CREATE##NEXT#</div>',
'  </div>',
'  <div class="t-BreadcrumbRegion-bottom">#SMART_FILTERS#</div>',
'</nav>',
''))
,p_page_plug_template_name=>'Title Bar'
,p_internal_name=>'TITLE_BAR'
,p_theme_id=>42
,p_theme_class_id=>6
,p_default_template_options=>'t-BreadcrumbRegion--showBreadcrumb'
,p_preset_template_options=>'t-BreadcrumbRegion--useBreadcrumbTitle'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2530016523834132090
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4621836774880946)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4622309525880946)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4622880256880946)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4623300572880947)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4623807404880947)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4624311538880947)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4624819870880947)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4625377017880947)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4625828817880947)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4626317841880947)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4626881513880947)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Smart Filters'
,p_placeholder=>'SMART_FILTERS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4627384036880947)
,p_plug_template_id=>wwv_flow_imp.id(34480263758496702)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/wizard_container
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(34481214685496703)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="region" aria-label="#TITLE!ATTR#" class="t-Wizard #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="t-Wizard-header">',
'    <h1 class="t-Wizard-title" id="#REGION_STATIC_ID#_heading" data-apex-heading>#TITLE#</h1>',
'    <div class="u-Table t-Wizard-controls">',
'      <div class="u-Table-fit t-Wizard-buttons">#PREVIOUS##CLOSE#</div>',
'      <div class="u-Table-fill t-Wizard-steps">#BODY#</div>',
'      <div class="u-Table-fit t-Wizard-buttons">#NEXT#</div>',
'    </div>',
'  </div>',
'  <div class="t-Wizard-body">#SUB_REGIONS#</div>',
'</div>'))
,p_page_plug_template_name=>'Wizard Container'
,p_internal_name=>'WIZARD_CONTAINER'
,p_theme_id=>42
,p_theme_class_id=>8
,p_preset_template_options=>'t-Wizard--hideStepsXSmall'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2117602213152591491
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4591479361880940)
,p_plug_template_id=>wwv_flow_imp.id(34481214685496703)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4591940647880940)
,p_plug_template_id=>wwv_flow_imp.id(34481214685496703)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4592454042880940)
,p_plug_template_id=>wwv_flow_imp.id(34481214685496703)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4592977475880940)
,p_plug_template_id=>wwv_flow_imp.id(34481214685496703)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4593459148880940)
,p_plug_template_id=>wwv_flow_imp.id(34481214685496703)
,p_name=>'Wizard Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>false
);
end;
/
prompt --application/shared_components/user_interface/templates/list/top_navigation_tabs
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34506500773496715)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavTabs-item #A03# is-active" aria-current="page" id="#A01#">',
'  <a href="#LINK#" class="t-NavTabs-link #A04# " title="#TEXT_ESC_SC#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-NavTabs-label">#TEXT_ESC_SC#</span>',
'    <span class="t-NavTabs-badge #A05#">#A02#</span>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavTabs-item #A03#" id="#A01#">',
'  <a href="#LINK#" class="t-NavTabs-link #A04# " title="#TEXT_ESC_SC#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-NavTabs-label">#TEXT_ESC_SC#</span>',
'    <span class="t-NavTabs-badge #A05#">#A02#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Top Navigation Tabs'
,p_internal_name=>'TOP_NAVIGATION_TABS'
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-NavTabs--inlineLabels-lg:t-NavTabs--displayLabels-sm'
,p_list_template_before_rows=>'<ul class="t-NavTabs #COMPONENT_CSS_CLASSES#" id="#PARENT_STATIC_ID#_navtabs">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'List Item ID'
,p_a02_label=>'Badge Value'
,p_a03_label=>'List Item Class'
,p_a04_label=>'Link Class'
,p_a05_label=>'Badge Class'
,p_reference_id=>1453011561172885578
);
end;
/
prompt --application/shared_components/user_interface/templates/list/top_navigation_mega_menu
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34508146556496717)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--noSub is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--noSub #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_list_template_name=>'Top Navigation Mega Menu'
,p_internal_name=>'TOP_NAVIGATION_MEGA_MENU'
,p_theme_id=>42
,p_theme_class_id=>20
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-MegaMenu #COMPONENT_CSS_CLASSES#" id="t_MenuNav" style="display:none;">',
'  <div class="a-Menu-content t-MegaMenu-container">',
'    <div class="t-MegaMenu-body">',
'    <ul class="t-MegaMenu-list t-MegaMenu-list--top">'))
,p_list_template_after_rows=>' </ul></div></div></div>'
,p_before_sub_list=>'<ul class="t-MegaMenu-list t-MegaMenu-list--sub">'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--hasSub is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item t-MegaMenu-item--top t-MegaMenu-item--hasSub #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>',
'</li>'))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item is-active #A04#" data-current="true" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>'))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MegaMenu-item #A04#" data-current="false" data-id="#A01#" data-shortcut="#A05#">',
'  <span class="a-Menu-item t-MegaMenu-itemBody #A08#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#"></span>',
'    <a class="a-Menu-label t-MegaMenu-labelWrap" href="#LINK#" target="#A06#">',
'      <span class="t-MegaMenu-label">#TEXT_ESC_SC#</span>',
'      <span class="t-MegaMenu-desc">#A03#</span>',
'    </a>',
'    <span class="t-MegaMenu-badge #A07#">#A02#</span>',
'  </span>'))
,p_a01_label=>'ID Attribute'
,p_a02_label=>'Badge Value'
,p_a03_label=>'Description'
,p_a04_label=>'List Item Class'
,p_a05_label=>'Shortcut Key'
,p_a06_label=>'Link Target'
,p_a07_label=>'Badge Class'
,p_a08_label=>'Menu Item Class'
,p_reference_id=>1665447133514362075
);
end;
/
prompt --application/shared_components/user_interface/templates/list/wizard_progress
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34510365144496718)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-WizardSteps-step is-active" aria-current="step" id="#LIST_ITEM_ID#">',
'  <div class="t-WizardSteps-wrap" data-link="#LINK#">',
'    <span class="t-WizardSteps-marker" aria-hidden="true"></span>',
'    <span class="t-WizardSteps-label">#TEXT# <span aria-hidden="true" class="t-WizardSteps-labelState"></span></span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-WizardSteps-step" id="#LIST_ITEM_ID#">',
'  <div class="t-WizardSteps-wrap" data-link="#LINK#">',
'    <span class="t-WizardSteps-marker" aria-hidden="true"></span>',
'    <span class="t-WizardSteps-label">#TEXT# <span aria-hidden="true" class="t-WizardSteps-labelState"></span></span>',
'  </div>',
'</li>'))
,p_list_template_name=>'Wizard Progress'
,p_internal_name=>'WIZARD_PROGRESS'
,p_javascript_code_onload=>'apex.theme.initWizardProgressBar();'
,p_theme_id=>42
,p_theme_class_id=>17
,p_preset_template_options=>'t-WizardSteps--displayLabels'
,p_list_template_before_rows=>'<ul aria-label="#CURRENT_PROGRESS#" class="t-WizardSteps #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>2008702338707394488
);
end;
/
prompt --application/shared_components/user_interface/templates/list/menu_bar
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34511796491496719)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'Menu Bar'
,p_internal_name=>'MENU_BAR'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menubar", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup( e );',
'}',
'e.menu({',
'  behaveLikeTabs: e.hasClass("js-tabLike"),',
'  menubarShowSubMenuIcon: e.hasClass("js-showSubMenuIcons") || null,',
'  iconType: ''fa'',',
'  menubar: true,',
'  menubarOverflow: true,',
'  callout: e.hasClass("js-menu-callout")',
'});'))
,p_theme_id=>42
,p_theme_class_id=>20
,p_default_template_options=>'js-showSubMenuIcons'
,p_list_template_before_rows=>'<div class="t-MenuBar #COMPONENT_CSS_CLASSES#" id="#PARENT_STATIC_ID#_menubar"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'Menu Item ID / Action Name'
,p_a02_label=>'Disabled (True/False)'
,p_a03_label=>'Hidden (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut'
,p_a06_label=>'Link Target'
,p_reference_id=>2008709236185638887
);
end;
/
prompt --application/shared_components/user_interface/templates/list/badge_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34512758622496720)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item #A02# is-current" aria-current="page">',
'  <a class="t-BadgeList-wrap u-color #A04#" href="#LINK#" #A03#>',
'    <span class="t-BadgeList-label">#TEXT#</span>',
'    <span class="t-BadgeList-value">#A01#</span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item #A02#">',
'  <a class="t-BadgeList-wrap u-color #A04#" href="#LINK#" #A03#>',
'    <span class="t-BadgeList-label">#TEXT#</span>',
'    <span class="t-BadgeList-value">#A01#</span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'Badge List'
,p_internal_name=>'BADGE_LIST'
,p_theme_id=>42
,p_theme_class_id=>3
,p_preset_template_options=>'t-BadgeList--large:t-BadgeList--cols t-BadgeList--3cols:t-BadgeList--circular'
,p_list_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Value'
,p_a02_label=>'List item CSS Classes'
,p_a03_label=>'Link Attributes'
,p_a04_label=>'Link Classes'
,p_reference_id=>2062482847268086664
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A01: Large Number',
'A02: List Item Classes',
'A03: Link Attributes'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/media_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34516580138496722)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item is-active #A04#">',
'  <a href="#LINK#" class="t-MediaList-itemWrap #A05#" #A03#>',
'    <div class="t-MediaList-iconWrap" aria-hidden="true">',
'      <span class="t-MediaList-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#" #IMAGE_ATTR#></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title" aria-current="page">#TEXT#</h3>',
'      <p class="t-MediaList-desc">#A01#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#A02#</span>',
'    </div>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item  #A04#">',
'  <a href="#LINK#" class="t-MediaList-itemWrap #A05#" #A03#>',
'    <div class="t-MediaList-iconWrap" aria-hidden="true">',
'      <span class="t-MediaList-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#" #IMAGE_ATTR#></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title">#TEXT#</h3>',
'      <p class="t-MediaList-desc">#A01#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#A02#</span>',
'    </div>',
'  </a>',
'</li>'))
,p_list_template_name=>'Media List'
,p_internal_name=>'MEDIA_LIST'
,p_theme_id=>42
,p_theme_class_id=>5
,p_default_template_options=>'t-MediaList--showIcons:t-MediaList--showDesc'
,p_list_template_before_rows=>'<ul class="t-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Description'
,p_a02_label=>'Badge Value'
,p_a03_label=>'Link Attributes'
,p_a04_label=>'List Item CSS Classes'
,p_a05_label=>'Link Class'
,p_a06_label=>'Icon Color Class'
,p_reference_id=>2066548068783481421
);
end;
/
prompt --application/shared_components/user_interface/templates/list/side_navigation_menu
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34519500245496723)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#">',
'  <a href="#LINK#" title="#A04#" style="display: none" target="#A06#">#TEXT_ESC_SC#</a>',
'  <div class="a-TreeView-node a-TreeView-node--topLevel" aria-hidden="true">',
'    <div role="none" class="a-TreeView-row is-selected is-current--top"></div>',
'    <div role="none" class="a-TreeView-content is-selected is-current--top">',
'      <span class="fa fa-file-o #ICON_CSS_CLASSES#"></span>',
'      <span class="a-TreeView-label">#TEXT_ESC_SC#</span>',
'    </div>',
'  </div>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="false" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#">',
'  <a href="#LINK#" title="#A04#" style="display: none" target="#A06#">#TEXT_ESC_SC#</a>',
'  <div class="a-TreeView-node a-TreeView-node--topLevel" aria-hidden="true">',
'    <div role="none" class="a-TreeView-row"></div>',
'    <div role="none" class="a-TreeView-content">',
'      <span class="fa fa-file-o #ICON_CSS_CLASSES#"></span>',
'      <span class="a-TreeView-label">#TEXT_ESC_SC#</span>',
'    </div>',
'  </div>',
'</li>'))
,p_list_template_name=>'Side Navigation Menu'
,p_internal_name=>'SIDE_NAVIGATION_MENU'
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.treeView#MIN#.js?v=#APEX_VERSION#'
,p_javascript_code_onload=>'apex.jQuery(''body'').addClass(''t-PageBody--leftNav'');'
,p_theme_id=>42
,p_theme_class_id=>19
,p_default_template_options=>'js-defaultCollapsed'
,p_preset_template_options=>'js-navCollapsed--hidden:t-TreeNav--styleA'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Body-nav" id="t_Body_nav" role="navigation" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL".">',
'  <div class="a-TreeView t-TreeNav #COMPONENT_CSS_CLASSES#" id="t_TreeNav" data-id="#PARENT_STATIC_ID#_tree" aria-label="&"APP_TEXT$APEX.TEMPLATE.MAIN_NAV_LABEL".">',
'    <ul>',
''))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    </ul>',
'  </div>',
'</div>',
'<script>(sessionStorage.getItem("nav.&APP_ID..preferenceForExpanded") === "true" && window.matchMedia("(min-width: " + getComputedStyle(document.documentElement).getPropertyValue("--js-mq-lg") + ")").matches) && document.getElementById(''t_PageBody'').'
||'classList.add(''js-navExpanded'');</script>',
'<script>',
'    const labels = document.querySelectorAll(".a-TreeView .a-TreeView-label");',
'    for (const label of labels) {',
'        label.textContent = label.textContent.replaceAll(/\[(.*?)\]/ig, '''');',
'    }',
'</script>'))
,p_before_sub_list=>'<ul style="display:none">'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#">',
'  <a href="#LINK#" title="#A04#" style="display: none" target="#A06#">#TEXT_ESC_SC#</a>',
'  <div class="a-TreeView-node a-TreeView-node--topLevel" aria-hidden="true">',
'    <div role="none" class="a-TreeView-row is-selected is-current--top"></div>',
'    <div role="none" class="a-TreeView-content is-selected is-current--top">',
'      <span class="fa fa-file-o #ICON_CSS_CLASSES#"></span>',
'      <span class="a-TreeView-label">#TEXT_ESC_SC#</span>',
'    </div>',
'  </div>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="false" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#">',
'  <a href="#LINK#" title="#A04#" style="display: none" target="#A06#">#TEXT_ESC_SC#</a>',
'  <div class="a-TreeView-node a-TreeView-node--topLevel" aria-hidden="true">',
'    <div role="none" class="a-TreeView-row"></div>',
'    <div role="none" class="a-TreeView-content">',
'      <span class="fa fa-file-o #ICON_CSS_CLASSES#"></span>',
'      <span class="a-TreeView-label">#TEXT_ESC_SC#</span>',
'    </div>',
'  </div>',
''))
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-icon="#ICON_CSS_CLASSES#" data-shortcut="#A05#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'ID Attribute'
,p_a02_label=>'Disabled (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut Key'
,p_a06_label=>'Link Target'
,p_reference_id=>2466292414354694776
);
end;
/
prompt --application/shared_components/user_interface/templates/list/top_navigation_menu
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34521386518496724)
,p_list_template_current=>'<li class="a-MenuBar-item a-Menu--current" data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ES'
||'C_SC#</a></li>'
,p_list_template_noncurrent=>'<li class="a-MenuBar-item" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_name=>'Top Navigation Menu'
,p_internal_name=>'TOP_NAVIGATION_MENU'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("#t_MenuNav", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup( e );',
'}',
'e.menu({',
'  behaveLikeTabs: e.hasClass("js-tabLike"),',
'  menubarShowSubMenuIcon: e.hasClass("js-showSubMenuIcons") || null,',
'  menubar: true,',
'  menubarOverflow: true,',
'  callout: e.hasClass("js-menu-callout")',
'});',
''))
,p_theme_id=>42
,p_theme_class_id=>20
,p_default_template_options=>'js-tabLike'
,p_list_template_before_rows=>'<div class="t-Header-nav-list #COMPONENT_CSS_CLASSES#" id="t_MenuNav"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul style="display: none">'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li class="a-MenuBar-item a-Menu--current" data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ES'
||'C_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li class="a-MenuBar-item" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a class="a-MenuBar-label" href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'Menu Item ID / Action Name'
,p_a02_label=>'Disabled (True/False)'
,p_a03_label=>'Hidden (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut Key'
,p_a06_label=>'Link Target'
,p_reference_id=>2525307901300239072
);
end;
/
prompt --application/shared_components/user_interface/templates/list/navigation_bar
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34522355271496725)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item is-active #A02#" aria-current="page">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#" title="#A04#" target="#A06#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item #A02#">',
'  <a class="t-Button t-Button--icon t-Button--header t-Button--navBar" href="#LINK#" title="#A04#" target="#A06#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Navigation Bar'
,p_internal_name=>'NAVIGATION_BAR'
,p_theme_id=>42
,p_theme_class_id=>20
,p_list_template_before_rows=>'<ul class="t-NavigationBar #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<div class="t-NavigationBar-menu" style="display: none" id="menu_#PARENT_LIST_ITEM_ID#"><ul>'
,p_after_sub_list=>'</ul></div></li>'
,p_sub_list_item_current=>'<li class="#A02#" data-current="true" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li class="#A02#" data-current="false" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item is-active #A02#" aria-current="page">',
'  <button class="t-Button t-Button--icon t-Button t-Button--header t-Button--navBar js-menuButton" type="button" id="#LIST_ITEM_ID#" data-menu="menu_#LIST_ITEM_ID#" title="#A04#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span><span class="a-Icon icon-down-arrow" aria-hidden="true"></span>',
'  </button>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-NavigationBar-item #A02#">',
'  <button class="t-Button t-Button--icon t-Button t-Button--header t-Button--navBar js-menuButton" type="button" id="#LIST_ITEM_ID#" data-menu="menu_#LIST_ITEM_ID#" title="#A04#">',
'      <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true" #IMAGE_ATTR#></span><span class="t-Button-label">#TEXT_ESC_SC#</span><span class="t-Button-badge">#A01#</span><span class="a-Icon icon-down-arrow" aria-hidden="true"></span>',
'  </button>'))
,p_sub_templ_curr_w_child=>'<li class="#A02#" data-current="true" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_templ_noncurr_w_child=>'<li class="#A02#" data-current="false" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_a01_label=>'Badge Value'
,p_a02_label=>'List  Item CSS Classes'
,p_a04_label=>'Title Attribute'
,p_a06_label=>'Link Target'
,p_reference_id=>2846096252961119197
);
end;
/
prompt --application/shared_components/user_interface/templates/list/cards
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34522739135496725)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item is-active #A04#" aria-current="page">',
'  <div class="t-Card">',
'    <a href="#LINK#" class="t-Card-wrap" #A05#>',
'      <div class="t-Card-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#"><span class="t-Card-initials" role="presentation">#A03#</span></span></div>',
'      <div class="t-Card-titleWrap">',
'        <h3 class="t-Card-title">#TEXT#</h3>',
'        <h4 class="t-Card-subtitle">#A07#</h4>',
'      </div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#A01#</div>',
'        <div class="t-Card-info">#A02#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #A06#" aria-hidden="true"></span>',
'    </a>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #A04#">',
'  <div class="t-Card">',
'    <a href="#LINK#" class="t-Card-wrap" #A05#>',
'      <div class="t-Card-icon u-color #A06#"><span class="t-Icon #ICON_CSS_CLASSES#"><span class="t-Card-initials" role="presentation">#A03#</span></span></div>',
'      <div class="t-Card-titleWrap">',
'        <h3 class="t-Card-title">#TEXT#</h3>',
'        <h4 class="t-Card-subtitle">#A07#</h4>',
'      </div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#A01#</div>',
'        <div class="t-Card-info">#A02#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #A06#" aria-hidden="true"></span>',
'    </a>',
'  </div>',
'</li>'))
,p_list_template_name=>'Cards'
,p_internal_name=>'CARDS'
,p_theme_id=>42
,p_theme_class_id=>4
,p_preset_template_options=>'t-Cards--animColorFill:t-Cards--3cols:t-Cards--basic'
,p_list_template_before_rows=>'<ul class="t-Cards #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'Description'
,p_a02_label=>'Secondary Information'
,p_a03_label=>'Initials'
,p_a04_label=>'List Item CSS Classes'
,p_a05_label=>'Link Attributes'
,p_a06_label=>'Card Color Class'
,p_a07_label=>'Subtitle'
,p_reference_id=>2885322685880632508
);
end;
/
prompt --application/shared_components/user_interface/templates/list/tabs
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34528194309496727)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Tabs-item is-active #A03#" aria-current="page" id="#A01#">',
'  <a href="#LINK#" class="t-Tabs-link #A04#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-Tabs-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Tabs-item #A03#" id="#A01#">',
'  <a href="#LINK#" class="t-Tabs-link #A04#">',
'    <span class="t-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    <span class="t-Tabs-label">#TEXT#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Tabs'
,p_internal_name=>'TABS'
,p_javascript_file_urls=>'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.apexTabs#MIN#.js?v=#APEX_VERSION#'
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-Tabs--simple'
,p_list_template_before_rows=>'<ul class="t-Tabs #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_a01_label=>'List Item ID'
,p_a03_label=>'List Item Class'
,p_a04_label=>'Link Class'
,p_reference_id=>3288206686691809997
);
end;
/
prompt --application/shared_components/user_interface/templates/list/menu_popup
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34529706267496727)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'Menu Popup'
,p_internal_name=>'MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup( e );',
'}',
'e.menu({ iconType: ''fa'', callout: e.hasClass("js-menu-callout")});'))
,p_theme_id=>42
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#ICON_CSS_CLASSES#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a01_label=>'Menu Item ID / Action Name'
,p_a02_label=>'Disabled (True/False)'
,p_a03_label=>'Hidden (True/False)'
,p_a04_label=>'Title Attribute (Used By Actions Only)'
,p_a05_label=>'Shortcut'
,p_a06_label=>'Link Target'
,p_reference_id=>3492264004432431646
);
end;
/
prompt --application/shared_components/user_interface/templates/list/links_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(34530385364496728)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item #A03#">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_list_template_name=>'Links List'
,p_internal_name=>'LINKS_LIST'
,p_theme_id=>42
,p_theme_class_id=>18
,p_list_template_before_rows=>'<ul class="t-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul class="t-LinksList-list">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item #A03#">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-LinksList-item #A03#">',
'  <a href="#LINK#" class="t-LinksList-link" #A02#>',
'    <span class="t-LinksList-icon" aria-hidden="true"><span class="t-Icon #ICON_CSS_CLASSES#"></span></span>',
'    <span class="t-LinksList-label">#TEXT#</span>',
'    <span class="t-LinksList-badge">#A01#</span>',
'  </a>',
'</li>'))
,p_a01_label=>'Badge Value'
,p_a02_label=>'Link Attributes'
,p_a03_label=>'List Item CSS Classes'
,p_reference_id=>4070914341144059318
);
end;
/
prompt --application/shared_components/user_interface/templates/report/contextual_info
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(4887390925881013)
,p_row_template_name=>'Contextual Info'
,p_internal_name=>'CONTEXTUAL_INFO'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ContextualInfo-item">',
'  <span class="t-ContextualInfo-label">#COLUMN_HEADER#</span>',
'  <span class="t-ContextualInfo-value">#COLUMN_VALUE#</span>',
'</div>'))
,p_row_template_before_rows=>' <div class="t-ContextualInfo #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES# data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>6
,p_reference_id=>2114325881116323585
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/timeline
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(34482593254496704)
,p_row_template_name=>'Timeline'
,p_internal_name=>'TIMELINE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Timeline-item #EVENT_MODIFIERS#" #EVENT_ATTRIBUTES#>',
'  <div class="t-Timeline-wrap">',
'    <div class="t-Timeline-user">',
'      <div class="t-Timeline-avatar #USER_COLOR#" role="presentation">',
'        #USER_AVATAR#',
'      </div>',
'      <div class="t-Timeline-userinfo">',
'        <span class="t-Timeline-username">#USER_NAME#</span>',
'        <span class="t-Timeline-date">#EVENT_DATE#</span>',
'      </div>',
'    </div>',
'    <div class="t-Timeline-content">',
'      <div class="t-Timeline-typeWrap">',
'        <div class="t-Timeline-type #EVENT_STATUS#">',
'          <span class="t-Icon #EVENT_ICON#"></span>',
'          <span class="t-Timeline-typename">#EVENT_TYPE#</span>',
'        </div>',
'      </div>',
'      <div class="t-Timeline-body">',
'        <h3 class="t-Timeline-title">#EVENT_TITLE#</h3>',
'        <p class="t-Timeline-desc">#EVENT_DESC#</p>',
'      </div>',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':EVENT_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Timeline-item #EVENT_MODIFIERS#" #EVENT_ATTRIBUTES#>',
'  <a href="#EVENT_LINK#" class="t-Timeline-wrap">',
'    <div class="t-Timeline-user">',
'      <div class="t-Timeline-avatar #USER_COLOR#" role="presentation">',
'        #USER_AVATAR#',
'      </div>',
'      <div class="t-Timeline-userinfo">',
'        <span class="t-Timeline-username">#USER_NAME#</span>',
'        <span class="t-Timeline-date">#EVENT_DATE#</span>',
'      </div>',
'    </div>',
'    <div class="t-Timeline-content">',
'      <div class="t-Timeline-typeWrap">',
'        <div class="t-Timeline-type #EVENT_STATUS#">',
'          <span class="t-Icon #EVENT_ICON#"></span>',
'          <span class="t-Timeline-typename">#EVENT_TYPE#</span>',
'        </div>',
'      </div>',
'      <div class="t-Timeline-body">',
'        <h3 class="t-Timeline-title">#EVENT_TITLE#</h3>',
'        <p class="t-Timeline-desc">#EVENT_DESC#</p>',
'      </div>',
'    </div>',
'  </a>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="t-Timeline #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_timeline" data-region-id="#REGION_STATIC_ID#">',
''))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_reference_id=>1513373588340069864
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/content_row
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(34483175886496705)
,p_row_template_name=>'Content Row'
,p_internal_name=>'CONTENT_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-ContentRow-item #ITEM_CLASSES#">',
'  <div class="t-ContentRow-wrap">',
'    <div class="t-ContentRow-selection">#SELECTION#</div>',
'    <div class="t-ContentRow-iconWrap">',
'      <span class="t-ContentRow-icon #ICON_CLASS#">#ICON_HTML#</span>',
'    </div>',
'    <div class="t-ContentRow-body">',
'      <div class="t-ContentRow-content">',
'        <h3 class="t-ContentRow-title">#TITLE#</h3>',
'        <div class="t-ContentRow-description">#DESCRIPTION#</div>',
'      </div>',
'      <div class="t-ContentRow-misc">#MISC#</div>',
'      <div class="t-ContentRow-actions">#ACTIONS#</div>',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-ContentRow #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>4
,p_reference_id=>1797843454948280151
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/media_list
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(34486308002496706)
,p_row_template_name=>'Media List'
,p_internal_name=>'MEDIA_LIST'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item #LIST_CLASS#">',
'  <a href="#LINK#" class="t-MediaList-itemWrap #LINK_CLASS#" #LINK_ATTR#>',
'    <div class="t-MediaList-iconWrap" aria-hidden"true">',
'      <span class="t-MediaList-icon u-color #ICON_COLOR_CLASS#"><span class="t-Icon #ICON_CLASS#"></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title">#LIST_TITLE#</h3>',
'      <p class="t-MediaList-desc">#LIST_TEXT#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#LIST_BADGE#</span>',
'    </div>',
'  </a>',
'</li>',
''))
,p_row_template_condition1=>':LINK is not null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-MediaList-item #LIST_CLASS#">',
'  <div class="t-MediaList-itemWrap #LINK_CLASS#" #LINK_ATTR#>',
'    <div class="t-MediaList-iconWrap" aria-hidden"true">',
'      <span class="t-MediaList-icon u-color #ICON_COLOR_CLASS#"><span class="t-Icon #ICON_CLASS#"></span></span>',
'    </div>',
'    <div class="t-MediaList-body">',
'      <h3 class="t-MediaList-title">#LIST_TITLE#</h3>',
'      <p class="t-MediaList-desc">#LIST_TEXT#</p>',
'    </div>',
'    <div class="t-MediaList-badgeWrap">',
'      <span class="t-MediaList-badge">#LIST_BADGE#</span>',
'    </div>',
'  </div>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="t-MediaList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>1
,p_default_template_options=>'t-MediaList--showDesc:t-MediaList--showIcons'
,p_preset_template_options=>'t-MediaList--stack'
,p_reference_id=>2092157460408299055
,p_translate_this_template=>'N'
,p_row_template_comment=>' (SELECT link_text, link_target, detail1, detail2, last_modified)'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/value_attribute_pairs_row
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(34489733747496708)
,p_row_template_name=>'Value Attribute Pairs - Row'
,p_internal_name=>'VALUE_ATTRIBUTE_PAIRS_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt class="t-AVPList-label">',
'  #1#',
'</dt>',
'<dd class="t-AVPList-value">',
'  #2#',
'</dd>'))
,p_row_template_before_rows=>'<dl class="t-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="report_#REGION_STATIC_ID#" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</dl>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-AVPList--leftAligned'
,p_reference_id=>2099068321678681753
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/value_attribute_pairs_column
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(34491737799496709)
,p_row_template_name=>'Value Attribute Pairs - Column'
,p_internal_name=>'VALUE_ATTRIBUTE_PAIRS_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt class="t-AVPList-label">',
'  #COLUMN_HEADER#',
'</dt>',
'<dd class="t-AVPList-value">',
'  #COLUMN_VALUE#',
'</dd>'))
,p_row_template_before_rows=>'<dl class="t-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</dl>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>6
,p_preset_template_options=>'t-AVPList--leftAligned'
,p_reference_id=>2099068636272681754
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/badge_list
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(34493537954496709)
,p_row_template_name=>'Badge List'
,p_internal_name=>'BADGE_LIST'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-wrap u-color">',
'    <span class="t-BadgeList-label">#COLUMN_HEADER#</span>',
'    <span class="t-BadgeList-value">#COLUMN_VALUE#</span>',
'  </span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>6
,p_preset_template_options=>'t-BadgeList--large:t-BadgeList--fixed:t-BadgeList--circular'
,p_reference_id=>2103197159775914759
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(34497185132496711)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td class="t-Report-cell" #ALIGNMENT# #ACCESSIBLE_HEADERS#>#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES# data-region-id="#REGION_STATIC_ID#">',
'  <div class="t-Report-wrap">',
'    <table class="t-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="t-Report-tableWrap">',
'    <table class="t-Report-report" id="report_table_#REGION_STATIC_ID#" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="t-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="t-Report-pagination t-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="t-Report-colHead" #ARIA_SORT# #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</thead>',
'<tbody>'))
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>4
,p_preset_template_options=>'t-Report--altRowsDefault:t-Report--rowHighlight'
,p_reference_id=>2537207537838287671
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/comments
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(34499723622496712)
,p_row_template_name=>'Comments'
,p_internal_name=>'COMMENTS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Comments-item #COMMENT_MODIFIERS#">',
'  <div class="t-Comments-icon">',
'    <div class="t-Comments-userIcon #ICON_MODIFIER#" aria-hidden="true">#USER_ICON#</div>',
'  </div>',
'  <div class="t-Comments-body">',
'    <div class="t-Comments-info">',
'      #USER_NAME# <span class="t-Comments-date">#COMMENT_DATE#</span> <span class="t-Comments-actions">#ACTIONS#</span>',
'    </div>',
'    <div class="t-Comments-comment">',
'      #COMMENT_TEXT##ATTRIBUTE_1##ATTRIBUTE_2##ATTRIBUTE_3##ATTRIBUTE_4#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-Comments #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>',
''))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-Comments--chat'
,p_reference_id=>2611722012730764232
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/alerts
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(34500967496496712)
,p_row_template_name=>'Alerts'
,p_internal_name=>'ALERTS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Alert t-Alert--horizontal t-Alert--colorBG t-Alert--defaultIcons t-Alert--#ALERT_TYPE#" role="alert">',
'  <div class="t-Alert-wrap">',
'    <div class="t-Alert-icon">',
'      <span class="t-Icon" aria-hidden="true"></span>',
'    </div>',
'    <div class="t-Alert-content">',
'      <div class="t-Alert-header">',
'        <h2 class="t-Alert-title">#ALERT_TITLE#</h2>',
'      </div>',
'      <div class="t-Alert-body">',
'        #ALERT_DESC#',
'      </div>',
'    </div>',
'    <div class="t-Alert-buttons">',
'      #ALERT_ACTION#',
'    </div>',
'  </div>',
'</div>'))
,p_row_template_before_rows=>'<div class="t-Alerts #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_alerts" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>14
,p_reference_id=>2881456138952347027
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/cards
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(34501116948496712)
,p_row_template_name=>'Cards'
,p_internal_name=>'CARDS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #CARD_MODIFIERS#">',
'  <div class="t-Card">',
'    <a href="#CARD_LINK#" class="t-Card-wrap">',
'      <div class="t-Card-icon u-color #CARD_COLOR#"><span class="t-Icon fa #CARD_ICON#"><span class="t-Card-initials" role="presentation">#CARD_INITIALS#</span></span></div>',
'      <div class="t-Card-titleWrap"><h3 class="t-Card-title">#CARD_TITLE#</h3><h4 class="t-Card-subtitle">#CARD_SUBTITLE#</h4></div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#CARD_TEXT#</div>',
'        <div class="t-Card-info">#CARD_SUBTEXT#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #CARD_COLOR#"></span>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is not null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-Cards-item #CARD_MODIFIERS#">',
'  <div class="t-Card">',
'    <div class="t-Card-wrap">',
'      <div class="t-Card-icon u-color #CARD_COLOR#"><span class="t-Icon fa #CARD_ICON#"><span class="t-Card-initials" role="presentation">#CARD_INITIALS#</span></span></div>',
'      <div class="t-Card-titleWrap"><h3 class="t-Card-title">#CARD_TITLE#</h3><h4 class="t-Card-subtitle">#CARD_SUBTITLE#</h4></div>',
'      <div class="t-Card-body">',
'        <div class="t-Card-desc">#CARD_TEXT#</div>',
'        <div class="t-Card-info">#CARD_SUBTEXT#</div>',
'      </div>',
'      <span class="t-Card-colorFill u-color #CARD_COLOR#"></span>',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-Cards #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_cards" data-region-id="#REGION_STATIC_ID#">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>7
,p_preset_template_options=>'t-Cards--animColorFill:t-Cards--3cols:t-Cards--basic'
,p_reference_id=>2973535649510699732
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/search_results
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(34506344026496714)
,p_row_template_name=>'Search Results'
,p_internal_name=>'SEARCH_RESULTS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition1=>':LABEL_02 is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition2=>':LABEL_03 is null'
,p_row_template3=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'      <span class="t-SearchResults-misc">#LABEL_03#: #VALUE_03#</span>',
'    </div>',
'  </li>'))
,p_row_template_condition3=>':LABEL_04 is null'
,p_row_template4=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-SearchResults-item">',
'    <h3 class="t-SearchResults-title"><a href="#SEARCH_LINK#">#SEARCH_TITLE#</a></h3>',
'    <div class="t-SearchResults-info">',
'      <p class="t-SearchResults-desc">#SEARCH_DESC#</p>',
'      <span class="t-SearchResults-misc">#LABEL_01#: #VALUE_01#</span>',
'      <span class="t-SearchResults-misc">#LABEL_02#: #VALUE_02#</span>',
'      <span class="t-SearchResults-misc">#LABEL_03#: #VALUE_03#</span>',
'      <span class="t-SearchResults-misc">#LABEL_04#: #VALUE_04#</span>',
'    </div>',
'  </li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-SearchResults #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_STATIC_ID#_report" data-region-id="#REGION_STATIC_ID#">',
'<ul class="t-SearchResults-list">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'<table class="t-Report-pagination" role="presentation">#PAGINATION#</table>',
'</div>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_pagination_template=>'<span class="t-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--next">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow" aria-hidden="true"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="t-Button t-Button--small t-Button--noUI t-Report-paginationLink t-Report-paginationLink--prev">',
'  <span class="a-Icon icon-left-arrow" aria-hidden="true"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>4070913431524059316
,p_translate_this_template=>'N'
,p_row_template_comment=>' (SELECT link_text, link_target, detail1, detail2, last_modified)'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(34531916603496729)
,p_template_name=>'Hidden'
,p_internal_name=>'HIDDEN'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer t-Form-labelContainer--hiddenLabel col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label u-VisuallyHidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--hiddenLabel rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT##HELP_TEMPLATE#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>13
,p_reference_id=>2039339104148359505
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(34532086320496730)
,p_template_name=>'Optional'
,p_internal_name=>'OPTIONAL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>',
''))
,p_before_item=>'<div class="t-Form-fieldContainer rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT##HELP_TEMPLATE#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>3
,p_reference_id=>2317154212072806530
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(34532126285496730)
,p_template_name=>'Optional - Above'
,p_internal_name=>'OPTIONAL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>3
,p_reference_id=>3030114864004968404
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_floating
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(34532284141496730)
,p_template_name=>'Optional - Floating'
,p_internal_name=>'OPTIONAL_FLOATING'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--floatingLabel #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>'<div class="t-Form-inputContainer"><div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'
,p_after_element=>'#ITEM_POST_TEXT##HELP_TEMPLATE#</div>#INLINE_HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<span class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</span>'
,p_error_template=>'<span class="t-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>42
,p_theme_class_id=>3
,p_reference_id=>1607675164727151865
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/required
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(34532318618496730)
,p_template_name=>'Required'
,p_internal_name=>'REQUIRED'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer col col-#LABEL_COLUMN_SPAN_NUMBER#">',
'  <label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer is-required rel-col #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-inputContainer col col-#ITEM_COLUMN_SPAN_NUMBER#">',
'  <div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#ITEM_POST_TEXT##HELP_TEMPLATE#',
'  </div>',
'  <div class="t-Form-itemAssistance">',
'    #ERROR_TEMPLATE#',
'    <div class="t-Form-itemRequired" aria-hidden="true">#REQUIRED#</div>',
'  </div>',
'  #INLINE_HELP_TEMPLATE#',
'</div>'))
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<div class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="t-Form-error">#ERROR_MESSAGE#</div>'
,p_theme_id=>42
,p_theme_class_id=>4
,p_reference_id=>2525313812251712801
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/required_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(34532413378496730)
,p_template_name=>'Required - Above'
,p_internal_name=>'REQUIRED_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'  <label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label> #HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--stacked is-required #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-inputContainer">',
'  <div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#ITEM_POST_TEXT##HELP_TEMPLATE#',
'  </div>',
'  <div class="t-Form-itemAssistance">',
'    #ERROR_TEMPLATE#',
'    <div class="t-Form-itemRequired" aria-hidden="true">#REQUIRED#</div>',
'  </div>',
'  #INLINE_HELP_TEMPLATE#',
'</div>'))
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<div class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="t-Form-error">#ERROR_MESSAGE#</div>'
,p_theme_id=>42
,p_theme_class_id=>4
,p_reference_id=>3030115129444970113
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/required_floating
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(34532592841496730)
,p_template_name=>'Required - Floating'
,p_internal_name=>'REQUIRED_FLOATING'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-labelContainer">',
'  <label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="t-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="t-Form-fieldContainer t-Form-fieldContainer--floatingLabel is-required #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_item_pre_text=>'<span class="t-Form-itemText t-Form-itemText--pre">#CURRENT_ITEM_PRE_TEXT#</span>'
,p_item_post_text=>'<span class="t-Form-itemText t-Form-itemText--post">#CURRENT_ITEM_POST_TEXT#</span>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-Form-inputContainer">',
'  <div class="t-Form-itemRequired-marker" aria-hidden="true"></div>',
'  <div class="t-Form-itemWrapper">#ITEM_PRE_TEXT#'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#ITEM_POST_TEXT##HELP_TEMPLATE#',
'  </div>',
'  <div class="t-Form-itemAssistance">',
'    #ERROR_TEMPLATE#',
'    <div class="t-Form-itemRequired" aria-hidden="true">#REQUIRED#</div>',
'  </div>',
'  #INLINE_HELP_TEMPLATE#',
'</div>'))
,p_help_link=>'<button class="t-Form-helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span></button>'
,p_inline_help_text=>'<div class="t-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="t-Form-error">#ERROR_MESSAGE#</div>'
,p_theme_id=>42
,p_theme_class_id=>4
,p_reference_id=>1607675344320152883
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(34534701325496733)
,p_name=>'Breadcrumb'
,p_internal_name=>'BREADCRUMB'
,p_before_first=>'<ul class="t-Breadcrumb #COMPONENT_CSS_CLASSES#">'
,p_current_page_option=>'<li class="t-Breadcrumb-item is-active" aria-current="page"><h1 class="t-Breadcrumb-label">#NAME#</h1></li>'
,p_non_current_page_option=>'<li class="t-Breadcrumb-item"><a href="#LINK#" class="t-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>4070916542570059325
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_imp_shared.create_popup_lov_template(
 p_id=>wwv_flow_imp.id(34534911487496737)
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#THEME_STYLE_CSS#',
'#FAVICONS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="t-Page t-Page--popupLOV"'
,p_before_field_text=>'<div class="t-PopupLOV-actions t-Form--large">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="apex-item-text"'
,p_find_button_text=>'Search'
,p_find_button_attr=>'class="t-Button t-Button--hot t-Button--padLeft"'
,p_close_button_text=>'Close'
,p_close_button_attr=>'class="t-Button u-pullRight"'
,p_next_button_text=>'Next &gt;'
,p_next_button_attr=>'class="t-Button t-PopupLOV-button"'
,p_prev_button_text=>'&lt; Previous'
,p_prev_button_attr=>'class="t-Button t-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_result_row_x_of_y=>'<div class="t-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>100
,p_before_result_set=>'<div class="t-PopupLOV-links">'
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>2885398517835871876
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(34534824800496735)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th id="#DY#" scope="col" class="t-ClassicCalendar-dayColumn">',
'  <span class="visible-md visible-lg">#IDAY#</span>',
'  <span class="hidden-md hidden-lg">#IDY#</span>',
'</th>'))
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar">',
'<h1 class="t-ClassicCalendar-title">#IMONTH# #YYYY#</h1>'))
,p_month_open_format=>'<table class="t-ClassicCalendar-calendar" cellpadding="0" cellspacing="0" border="0" aria-label="#IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>',
''))
,p_day_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_weekend_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_weekend_open_format=>'<td class="t-ClassicCalendar-day is-weekend" headers="#DY#">#TITLE_FORMAT#<div class="t-ClassicCalendar-dayEvents">#DATA#</div>'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_nonday_open_format=>'<td class="t-ClassicCalendar-day is-inactive" headers="#DY#">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--weekly">',
'<h1 class="t-ClassicCalendar-title">#WTITLE#</h1>'))
,p_weekly_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th scope="col" class="t-ClassicCalendar-dayColumn" id="#DY#">',
'  <span class="visible-md visible-lg">#DD# #IDAY#</span>',
'  <span class="hidden-md hidden-lg">#DD# #IDY#</span>',
'</th>'))
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" aria-label="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t-ClassicCalendar-calendar">'
,p_weekly_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_weekly_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_day_close_format=>'</div></td>'
,p_weekly_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_weekend_open_format=>'<td class="t-ClassicCalendar-day is-weekend" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_weekly_weekend_close_format=>'</div></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t-ClassicCalendar-day t-ClassicCalendar-timeCol">'
,p_weekly_time_close_format=>'</th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" id="#DY#" class="t-ClassicCalendar-dayColumn">#IDAY#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--daily">',
'<h1 class="t-ClassicCalendar-title">#IMONTH# #DD#, #YYYY#</h1>'))
,p_daily_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" aria-label="#CALENDAR_TITLE# #START_DL#" class="t-ClassicCalendar-calendar">'
,p_daily_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_daily_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_daily_day_close_format=>'</div></td>'
,p_daily_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_daily_time_open_format=>'<th scope="row" class="t-ClassicCalendar-day t-ClassicCalendar-timeCol" id="#TIME#">'
,p_daily_time_close_format=>'</th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_cust_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar">',
'<h1 class="t-ClassicCalendar-title">#IMONTH# #YYYY#</h1>'))
,p_cust_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th id="#DY#" scope="col" class="t-ClassicCalendar-dayColumn">',
'  <span class="visible-md visible-lg">#IDAY#</span>',
'  <span class="hidden-md hidden-lg">#IDY#</span>',
'</th>'))
,p_cust_month_open_format=>'<table class="t-ClassicCalendar-calendar" cellpadding="0" cellspacing="0" border="0" aria-label="#IMONTH# #YYYY#">'
,p_cust_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_cust_week_open_format=>'<tr>'
,p_cust_week_close_format=>'</tr> '
,p_cust_day_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_cust_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#">'
,p_cust_day_close_format=>'</td>'
,p_cust_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#">'
,p_cust_nonday_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_cust_nonday_open_format=>'<td class="t-ClassicCalendar-day is-inactive" headers="#DY#">'
,p_cust_nonday_close_format=>'</td>'
,p_cust_weekend_title_format=>'<span class="t-ClassicCalendar-date">#DD#</span>'
,p_cust_weekend_open_format=>'<td class="t-ClassicCalendar-day is-weekend" headers="#DY#">'
,p_cust_weekend_close_format=>'</td>'
,p_cust_hour_open_format=>'<tr>'
,p_cust_hour_close_format=>'</tr>'
,p_cust_time_title_format=>'#TIME#'
,p_cust_time_open_format=>'<th scope="row" class="t-ClassicCalendar-day t-ClassicCalendar-timeCol">'
,p_cust_time_close_format=>'</th>'
,p_cust_wk_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar">',
'<h1 class="t-ClassicCalendar-title">#WTITLE#</h1>'))
,p_cust_wk_day_of_week_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<th scope="col" class="t-ClassicCalendar-dayColumn" id="#DY#">',
'  <span class="visible-md visible-lg">#DD# #IDAY#</span>',
'  <span class="hidden-md hidden-lg">#DD# #IDY#</span>',
'</th>'))
,p_cust_wk_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t-ClassicCalendar-calendar">'
,p_cust_wk_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table>',
'</div>'))
,p_cust_wk_week_open_format=>'<tr>'
,p_cust_wk_week_close_format=>'</tr> '
,p_cust_wk_day_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_cust_wk_day_close_format=>'</div></td>'
,p_cust_wk_today_open_format=>'<td class="t-ClassicCalendar-day is-today" headers="#DY#"><div class="t-ClassicCalendar-dayEvents">'
,p_cust_wk_weekend_open_format=>'<td class="t-ClassicCalendar-day" headers="#DY#">'
,p_cust_wk_weekend_close_format=>'</td>'
,p_agenda_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="t-ClassicCalendar t-ClassicCalendar--list">',
'  <div class="t-ClassicCalendar-title">#IMONTH# #YYYY#</div>',
'  <ul class="t-ClassicCalendar-list">',
'    #DAYS#',
'  </ul>',
'</div>'))
,p_agenda_past_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-past">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_today_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-today">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_future_day_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  <li class="t-ClassicCalendar-listTitle is-future">',
'    <span class="t-ClassicCalendar-listDayTitle">#IDAY#</span><span class="t-ClassicCalendar-listDayDate">#IMONTH# #DD#</span>',
'  </li>'))
,p_agenda_past_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-past">#DATA#</li>'
,p_agenda_today_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-today">#DATA#</li>'
,p_agenda_future_entry_format=>'  <li class="t-ClassicCalendar-listEvent is-future">#DATA#</li>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'<span class="t-ClassicCalendar-event">#DATA#</span>'
,p_theme_id=>42
,p_theme_class_id=>1
,p_reference_id=>4070916747979059326
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
wwv_flow_imp_shared.create_theme(
 p_id=>wwv_flow_imp.id(34536328399496744)
,p_theme_id=>42
,p_theme_name=>'Universal Theme'
,p_theme_internal_name=>'UNIVERSAL_THEME'
,p_ui_type_name=>'DESKTOP'
,p_navigation_type=>'L'
,p_nav_bar_type=>'LIST'
,p_reference_id=>4070917134413059350
,p_is_locked=>false
,p_default_page_template=>wwv_flow_imp.id(34436267275496679)
,p_default_dialog_template=>wwv_flow_imp.id(34419794295496671)
,p_error_template=>wwv_flow_imp.id(34421292387496672)
,p_printer_friendly_template=>wwv_flow_imp.id(34436267275496679)
,p_breadcrumb_display_point=>'REGION_POSITION_01'
,p_sidebar_display_point=>'REGION_POSITION_02'
,p_login_template=>wwv_flow_imp.id(34421292387496672)
,p_default_button_template=>wwv_flow_imp.id(34533308970496733)
,p_default_region_template=>wwv_flow_imp.id(34470894408496699)
,p_default_chart_template=>wwv_flow_imp.id(34470894408496699)
,p_default_form_template=>wwv_flow_imp.id(34470894408496699)
,p_default_reportr_template=>wwv_flow_imp.id(34470894408496699)
,p_default_tabform_template=>wwv_flow_imp.id(34470894408496699)
,p_default_wizard_template=>wwv_flow_imp.id(34470894408496699)
,p_default_menur_template=>wwv_flow_imp.id(34480263758496702)
,p_default_listr_template=>wwv_flow_imp.id(34470894408496699)
,p_default_irr_template=>wwv_flow_imp.id(34468943637496698)
,p_default_report_template=>wwv_flow_imp.id(34497185132496711)
,p_default_label_template=>wwv_flow_imp.id(34532284141496730)
,p_default_menu_template=>wwv_flow_imp.id(34534701325496733)
,p_default_calendar_template=>wwv_flow_imp.id(34534824800496735)
,p_default_list_template=>wwv_flow_imp.id(34530385364496728)
,p_default_nav_list_template=>wwv_flow_imp.id(34521386518496724)
,p_default_top_nav_list_temp=>wwv_flow_imp.id(34521386518496724)
,p_default_side_nav_list_temp=>wwv_flow_imp.id(34519500245496723)
,p_default_nav_list_position=>'SIDE'
,p_default_dialogbtnr_template=>wwv_flow_imp.id(34443487668496687)
,p_default_dialogr_template=>wwv_flow_imp.id(34442442131496686)
,p_default_option_label=>wwv_flow_imp.id(34532284141496730)
,p_default_required_label=>wwv_flow_imp.id(34532592841496730)
,p_default_page_transition=>'NONE'
,p_default_popup_transition=>'NONE'
,p_default_navbar_list_template=>wwv_flow_imp.id(34522355271496725)
,p_file_prefix => nvl(wwv_flow_application_install.get_static_theme_file_prefix(42),'#APEX_FILES#themes/theme_42/22.1/')
,p_files_version=>65
,p_icon_library=>'FONTAPEX'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.stickyWidget#MIN#.js?v=#APEX_VERSION#',
'#THEME_FILES#js/theme42#MIN#.js?v=#APEX_VERSION#'))
,p_css_file_urls=>'#THEME_FILES#css/Core#MIN#.css?v=#APEX_VERSION#'
);
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(4228224590880860)
,p_theme_id=>42
,p_name=>'Redwood Light'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#libraries/oracle-fonts/oraclesans-apex#MIN#.css?v=#APEX_VERSION#',
'#THEME_FILES#css/Redwood#MIN#.css?v=#APEX_VERSION#'))
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_FILES#less/theme/Redwood-Theme.less'
,p_theme_roller_output_file_url=>'#THEME_FILES#css/Redwood-Theme#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>2596426436825065489
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(4228676570880861)
,p_theme_id=>42
,p_name=>'Vita'
,p_is_current=>true
,p_is_public=>true
,p_is_accessible=>true
,p_theme_roller_input_file_urls=>'#THEME_FILES#less/theme/Vita.less'
,p_theme_roller_output_file_url=>'#THEME_FILES#css/Vita#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>2719875314571594493
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(4229027229880861)
,p_theme_id=>42
,p_name=>'Vita - Dark'
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_FILES#less/theme/Vita-Dark.less'
,p_theme_roller_output_file_url=>'#THEME_FILES#css/Vita-Dark#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>3543348412015319650
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(4229466846880861)
,p_theme_id=>42
,p_name=>'Vita - Red'
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_FILES#less/theme/Vita-Red.less'
,p_theme_roller_output_file_url=>'#THEME_FILES#css/Vita-Red#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>1938457712423918173
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(4229884196880861)
,p_theme_id=>42
,p_name=>'Vita - Slate'
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>false
,p_theme_roller_input_file_urls=>'#THEME_FILES#less/theme/Vita-Slate.less'
,p_theme_roller_output_file_url=>'#THEME_FILES#css/Vita-Slate#MIN#.css?v=#APEX_VERSION#'
,p_theme_roller_read_only=>true
,p_reference_id=>3291983347983194966
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(9247337283048331)
,p_theme_id=>42
,p_name=>'Vita (copy_1)'
,p_is_current=>false
,p_is_public=>true
,p_is_accessible=>true
,p_theme_roller_input_file_urls=>'#THEME_FILES#less/theme/Vita.less'
,p_theme_roller_config=>'{"classes":[],"vars":{},"customCSS":"#t_TreeNav_2 ul{\n    display: block !important;\n}","useCustomLess":"N"}'
,p_theme_roller_output_file_url=>'#THEME_DB_FILES#9247337283048331.css'
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '3A726F6F74207B0D0A20202D2D612D626173652D666F6E742D7765696768742D73656D69626F6C643A203630303B0D0A20202D2D612D69636F6E2D73697A653A203172656D3B0D0A20202D2D612D627574746F6E2D626F726465722D7261646975733A20';
wwv_flow_imp.g_varchar2_table(2) := '302E31323572656D3B0D0A20202D2D612D627574746F6E2D70616464696E672D793A20302E3572656D3B0D0A20202D2D612D627574746F6E2D70616464696E672D783A20302E373572656D3B0D0A20202D2D612D627574746F6E2D666F6E742D73697A65';
wwv_flow_imp.g_varchar2_table(3) := '3A20302E373572656D3B0D0A20202D2D612D627574746F6E2D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D627574746F6E2D6761702D783A20302E323572656D3B0D0A20202D2D612D627574746F6E2D69636F6E2D73706163696E67';
wwv_flow_imp.g_varchar2_table(4) := '3A20302E33373572656D3B0D0A20202D2D612D627574746F6E2D69636F6E2D73697A653A203172656D3B0D0A20202D2D612D63762D677269642D6761703A203172656D3B0D0A20202D2D612D63762D6974656D2D77696474683A20323072656D3B0D0A20';
wwv_flow_imp.g_varchar2_table(5) := '202D2D612D63762D626F726465722D7261646975733A20302E323572656D3B0D0A20202D2D612D63762D736861646F773A20766172282D2D75742D736861646F772D736D293B0D0A20202D2D612D63762D6865616465722D70616464696E672D793A2031';
wwv_flow_imp.g_varchar2_table(6) := '72656D3B0D0A20202D2D612D63762D6865616465722D70616464696E672D783A203172656D3B0D0A20202D2D612D63762D6865616465722D6974656D2D73706163696E672D783A20302E373572656D3B0D0A20202D2D612D63762D69636F6E2D73697A65';
wwv_flow_imp.g_varchar2_table(7) := '3A203172656D3B0D0A20202D2D612D63762D69636F6E2D636F6E7461696E65722D73697A653A203272656D3B0D0A20202D2D612D63762D69636F6E2D70616464696E673A20302E3572656D3B0D0A20202D2D612D63762D69636F6E2D7370616365723A20';
wwv_flow_imp.g_varchar2_table(8) := '63616C6328766172282D2D612D63762D69636F6E2D636F6E7461696E65722D73697A652C203172656D29202B20766172282D2D612D63762D6865616465722D6974656D2D73706163696E672D782C20302E373572656D29293B0D0A20202D2D612D63762D';
wwv_flow_imp.g_varchar2_table(9) := '696E697469616C732D73697A653A203272656D3B0D0A20202D2D612D63762D696E697469616C732D666F6E742D73697A653A20302E38373572656D3B0D0A20202D2D612D63762D7469746C652D666F6E742D73697A653A203172656D3B0D0A20202D2D61';
wwv_flow_imp.g_varchar2_table(10) := '2D63762D7469746C652D6C696E652D6865696768743A20312E323572656D3B0D0A20202D2D612D63762D7375627469746C652D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D612D63762D7375627469746C652D6C696E652D6865696768';
wwv_flow_imp.g_varchar2_table(11) := '743A203172656D3B0D0A20202D2D612D63762D62616467652D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D612D63762D62616467652D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A';
wwv_flow_imp.g_varchar2_table(12) := '20202D2D612D63762D626F64792D70616464696E672D783A203172656D3B0D0A20202D2D612D63762D626F64792D70616464696E672D793A203172656D3B0D0A20202D2D612D63762D6D61696E636F6E74656E742D666F6E742D73697A653A20302E3837';
wwv_flow_imp.g_varchar2_table(13) := '3572656D3B0D0A20202D2D612D63762D6D61696E636F6E74656E742D6C696E652D6865696768743A20312E323572656D3B0D0A20202D2D612D63762D737562636F6E74656E742D666F6E742D73697A653A20302E3638373572656D3B0D0A20202D2D612D';
wwv_flow_imp.g_varchar2_table(14) := '63762D737562636F6E74656E742D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D63762D616374696F6E732D70616464696E672D793A203172656D3B0D0A20202D2D612D63762D616374696F6E732D70616464696E672D783A20317265';
wwv_flow_imp.g_varchar2_table(15) := '6D3B0D0A20202D2D612D636865636B626F782D73697A653A203172656D3B0D0A20202D2D612D636865636B626F782D6C6162656C2D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D612D636865636B626F782D626F726465722D72616469';
wwv_flow_imp.g_varchar2_table(16) := '75733A20302E31323572656D3B0D0A20202D2D612D636865636B626F782D69636F6E2D73697A653A20302E373572656D3B0D0A20202D2D612D636865636B626F782D696E64657465726D696E6174652D77696474683A20302E36323572656D3B0D0A2020';
wwv_flow_imp.g_varchar2_table(17) := '2D2D612D636865636B626F782D696E64657465726D696E6174652D6865696768743A20302E31323572656D3B0D0A20202D2D612D636865636B626F782D6C6162656C2D73706163696E672D793A20302E31323572656D3B0D0A20202D2D612D636865636B';
wwv_flow_imp.g_varchar2_table(18) := '626F782D6C6162656C2D73706163696E672D783A20302E33373572656D3B0D0A20202D2D612D636F6D626F2D626F782D70616464696E672D793A20302E323572656D3B0D0A20202D2D612D636F6D626F2D626F782D70616464696E672D783A20302E3572';
wwv_flow_imp.g_varchar2_table(19) := '656D3B0D0A20202D2D612D6465762D746F6F6C6261722D6261636B67726F756E642D636F6C6F723A20233636363B0D0A20202D2D612D6465762D746F6F6C6261722D6261636B64726F702D66696C7465723A206E6F6E653B0D0A20202D2D612D66732D63';
wwv_flow_imp.g_varchar2_table(20) := '6F6E74726F6C2D736570657261746F722D626F726465722D77696474683A20766172282D2D75742D636F6D706F6E656E742D626F726465722D77696474682C20317078293B0D0A20202D2D612D66732D636F6E74726F6C2D736570657261746F722D626F';
wwv_flow_imp.g_varchar2_table(21) := '726465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A20202D2D612D66732D636F6E74726F6C2D6865616465722D70616464696E672D793A20302E373572656D3B0D0A20202D2D612D6673';
wwv_flow_imp.g_varchar2_table(22) := '2D636F6E74726F6C2D6865616465722D70616464696E672D783A20302E373572656D3B0D0A20202D2D612D66732D636F6E74726F6C2D6865616465722D666F6E742D73697A653A203172656D3B0D0A20202D2D612D66732D636F6E74726F6C2D68656164';
wwv_flow_imp.g_varchar2_table(23) := '65722D6C696E652D6865696768743A20312E323572656D3B0D0A20202D2D612D66732D636F6E74726F6C2D626F64792D70616464696E672D793A20302E373572656D3B0D0A20202D2D612D66732D636F6E74726F6C2D626F64792D70616464696E672D78';
wwv_flow_imp.g_varchar2_table(24) := '3A20302E373572656D3B0D0A20202D2D612D66732D636F6E74726F6C2D616374696F6E732D70616464696E672D793A20302E373572656D3B0D0A20202D2D612D66732D636F6E74726F6C2D616374696F6E732D70616464696E672D783A203072656D3B0D';
wwv_flow_imp.g_varchar2_table(25) := '0A20202D2D612D66732D636F6E74726F6C2D6974656D2D73706163696E673A20302E373572656D3B0D0A20202D2D612D66732D66696C7465722D67726F75702D626F726465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F72';
wwv_flow_imp.g_varchar2_table(26) := '6465722D636F6C6F72293B0D0A20202D2D612D66732D66696C7465722D67726F75702D626F726465722D77696474683A20766172282D2D75742D636F6D706F6E656E742D626F726465722D77696474682C20317078293B0D0A20202D2D612D66732D6669';
wwv_flow_imp.g_varchar2_table(27) := '6C7465722D67726F75702D6C6162656C2D746578742D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D6D757465642D636F6C6F72293B0D0A20202D2D612D66732D6974656D2D7375622D67726F75702D73706163696E673A';
wwv_flow_imp.g_varchar2_table(28) := '20302E3572656D3B0D0A20202D2D612D66732D63686172742D70616464696E672D793A203172656D3B0D0A20202D2D612D66732D63686172742D70616464696E672D783A203172656D3B0D0A20202D2D612D66732D63686172742D626F726465722D7769';
wwv_flow_imp.g_varchar2_table(29) := '6474683A20766172282D2D75742D726567696F6E2D626F726465722D77696474682C20766172282D2D75742D636F6D706F6E656E742D626F726465722D77696474682C2031707829293B0D0A20202D2D612D66732D63686172742D626F726465722D636F';
wwv_flow_imp.g_varchar2_table(30) := '6C6F723A20766172282D2D75742D726567696F6E2D626F726465722D636F6C6F722C20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F7229293B0D0A20202D2D612D66732D63686172742D626F726465722D7261646975733A';
wwv_flow_imp.g_varchar2_table(31) := '20766172282D2D75742D726567696F6E2D626F726465722D7261646975732C20766172282D2D75742D636F6D706F6E656E742D626F726465722D72616469757329293B0D0A20202D2D612D66732D63686172742D6261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(32) := '3A20766172282D2D75742D636F6D706F6E656E742D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D66732D63686172742D736861646F773A20766172282D2D75742D726567696F6E2D626F782D736861646F77293B0D0A20202D2D612D';
wwv_flow_imp.g_varchar2_table(33) := '66696C6564726F702D70616464696E672D793A203172656D3B0D0A20202D2D612D66696C6564726F702D70616464696E672D783A203172656D3B0D0A20202D2D612D66696C6564726F702D626F726465722D7261646975733A20302E31323572656D3B0D';
wwv_flow_imp.g_varchar2_table(34) := '0A20202D2D612D66696C6564726F702D626F726465722D636F6C6F723A20766172282D2D612D6669656C642D696E7075742D626F726465722D636F6C6F72293B0D0A20202D2D612D66696C6564726F702D746578742D636F6C6F723A20766172282D2D75';
wwv_flow_imp.g_varchar2_table(35) := '742D636F6D706F6E656E742D746578742D6D757465642D636F6C6F72293B0D0A20202D2D612D66696C6564726F702D666F6375732D626F726465722D636F6C6F723A20766172282D2D612D6669656C642D696E7075742D666F6375732D626F726465722D';
wwv_flow_imp.g_varchar2_table(36) := '636F6C6F72293B0D0A20202D2D612D66696C6564726F702D6974656D2D73706163696E673A20302E323572656D3B0D0A20202D2D612D66696C6564726F702D69636F6E2D73697A653A203272656D3B0D0A20202D2D612D66696C6564726F702D68656164';
wwv_flow_imp.g_varchar2_table(37) := '696E672D666F6E742D73697A653A20312E323572656D3B0D0A20202D2D612D66696C6564726F702D68656164696E672D6C696E652D6865696768743A20312E373572656D3B0D0A20202D2D612D66696C6564726F702D68656164696E672D746578742D63';
wwv_flow_imp.g_varchar2_table(38) := '6F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D7469746C652D636F6C6F72293B0D0A20202D2D612D66696C6564726F702D666F6E742D73697A653A20302E38373572656D3B0D0A20202D2D612D66696C6564726F702D6C696E';
wwv_flow_imp.g_varchar2_table(39) := '652D6865696768743A203172656D3B0D0A20202D2D612D66696C6564726F702D70726F67726573732D77696474683A20313572656D3B0D0A20202D2D612D66696C6564726F702D70726F67726573732D6865696768743A20302E373572656D3B0D0A2020';
wwv_flow_imp.g_varchar2_table(40) := '2D2D612D66696C6564726F702D70726F67726573732D626F726465722D7261646975733A20302E33373572656D3B0D0A20202D2D612D66696C6564726F702D70726F67726573732D6261722D77696474683A203372656D3B0D0A20202D2D612D6669656C';
wwv_flow_imp.g_varchar2_table(41) := '642D696E7075742D626F726465722D7261646975733A20302E31323572656D3B0D0A20202D2D612D6669656C642D73656C6563742D6261636B67726F756E642D73697A653A203272656D203172656D3B0D0A20202D2D612D6669656C642D73656C656374';
wwv_flow_imp.g_varchar2_table(42) := '2D6172726F772D70616464696E673A203272656D3B0D0A20202D2D612D67762D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D612D67762D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D67762D626F726465722D636F';
wwv_flow_imp.g_varchar2_table(43) := '6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A20202D2D612D67762D63656C6C2D70616464696E672D793A20302E323572656D3B0D0A20202D2D612D67762D63656C6C2D70616464696E672D783A20';
wwv_flow_imp.g_varchar2_table(44) := '302E3572656D3B0D0A20202D2D612D67762D63656C6C2D6865696768743A203272656D3B0D0A20202D2D612D67762D726F772D686F7665722D6261636B67726F756E642D636F6C6F723A20236639663966393B0D0A20202D2D612D67762D696E73657274';
wwv_flow_imp.g_varchar2_table(45) := '65642D6261636B67726F756E642D636F6C6F723A20766172282D2D612D70616C657474652D737563636573732D7368616465293B0D0A20202D2D612D67762D64656C657465642D6261636B67726F756E642D636F6C6F723A20236632663266323B0D0A20';
wwv_flow_imp.g_varchar2_table(46) := '202D2D612D67762D6772616E64746F74616C2D6261636B67726F756E642D636F6C6F723A20236536653665363B0D0A20202D2D612D67762D757064617465642D6261636B67726F756E642D636F6C6F723A20766172282D2D612D70616C657474652D696E';
wwv_flow_imp.g_varchar2_table(47) := '666F2D7368616465293B0D0A20202D2D612D67762D6865616465722D63656C6C2D70616464696E672D793A20302E323572656D3B0D0A20202D2D612D67762D6865616465722D63656C6C2D70616464696E672D783A20302E3572656D3B0D0A20202D2D61';
wwv_flow_imp.g_varchar2_table(48) := '2D67762D6865616465722D63656C6C2D6865696768743A20322E3572656D3B0D0A20202D2D612D67762D666F6F7465722D70616464696E672D793A20302E3572656D3B0D0A20202D2D612D67762D666F6F7465722D70616464696E672D783A20302E3735';
wwv_flow_imp.g_varchar2_table(49) := '72656D3B0D0A20202D2D612D67762D706167696E6174696F6E2D627574746F6E2D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D67762D706167696E6174696F6E2D627574746F6E2D746578742D636F6C';
wwv_flow_imp.g_varchar2_table(50) := '6F723A20766172282D2D612D627574746F6E2D746578742D636F6C6F72293B0D0A20202D2D612D67762D706167696E6174696F6E2D627574746F6E2D70616464696E672D793A20302E323572656D3B0D0A20202D2D612D67762D706167696E6174696F6E';
wwv_flow_imp.g_varchar2_table(51) := '2D627574746F6E2D70616464696E672D783A20302E323572656D3B0D0A20202D2D612D67762D706167696E6174696F6E2D627574746F6E2D6761702D783A20302E323572656D3B0D0A20202D2D612D67762D706167696E6174696F6E2D627574746F6E2D';
wwv_flow_imp.g_varchar2_table(52) := '686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D67762D706167696E6174696F6E2D627574746F6E2D686F7665722D7465';
wwv_flow_imp.g_varchar2_table(53) := '78742D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D746578742D636F6C6F72293B0D0A20202D2D612D67762D6E6F646174612D6D6573736167652D70616464696E672D793A203172656D3B0D0A20202D2D612D67762D6E6F6461';
wwv_flow_imp.g_varchar2_table(54) := '74612D6D6573736167652D70616464696E672D783A203172656D3B0D0A20202D2D612D67762D6E6F646174612D6D6573736167652D746578742D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D6D757465642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(55) := '293B0D0A20202D2D612D67762D6E6F646174612D6D6573736167652D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D612D67762D6E6F646174612D6D6573736167652D69636F6E2D73697A653A203272656D3B0D0A20202D2D612D67762D';
wwv_flow_imp.g_varchar2_table(56) := '6E6F646174612D6D6573736167652D69636F6E2D73706163696E673A20302E373572656D3B0D0A20202D2D612D68656C702D6469616C6F672D636F64652D746578742D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D6D75';
wwv_flow_imp.g_varchar2_table(57) := '7465642D636F6C6F72293B0D0A20202D2D612D6D64656469746F722D6261636B67726F756E642D636F6C6F723A20766172282D2D612D6669656C642D696E7075742D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D6D64656469746F72';
wwv_flow_imp.g_varchar2_table(58) := '2D626F726465722D636F6C6F723A20766172282D2D612D6669656C642D696E7075742D626F726465722D636F6C6F72293B0D0A20202D2D612D6D64656469746F722D626F726465722D77696474683A20766172282D2D612D6669656C642D696E7075742D';
wwv_flow_imp.g_varchar2_table(59) := '626F726465722D7769647468293B0D0A20202D2D612D6D64656469746F722D666F6375732D626F726465722D636F6C6F723A20766172282D2D612D6669656C642D696E7075742D666F6375732D626F726465722D636F6C6F72293B0D0A20202D2D612D6D';
wwv_flow_imp.g_varchar2_table(60) := '656E756261722D6974656D2D70616464696E672D793A20302E3572656D3B0D0A20202D2D612D6D656E756261722D6974656D2D70616464696E672D783A20302E3572656D3B0D0A20202D2D612D6D656E756261722D6974656D2D73706C69742D69636F6E';
wwv_flow_imp.g_varchar2_table(61) := '2D73697A653A203172656D3B0D0A20202D2D612D6D656E756261722D6974656D2D73706C69742D69636F6E2D73706163696E673A20302E3572656D3B0D0A20202D2D612D6D656E752D70616464696E672D793A20302E3572656D3B0D0A20202D2D612D6D';
wwv_flow_imp.g_varchar2_table(62) := '656E752D70616464696E672D783A203072656D3B0D0A20202D2D612D6D656E752D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D612D6D656E752D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D6D656E752D626F7264';
wwv_flow_imp.g_varchar2_table(63) := '65722D7261646975733A20302E323572656D3B0D0A20202D2D612D6D656E752D7365702D626F726465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A20202D2D612D6D656E752D7365702D';
wwv_flow_imp.g_varchar2_table(64) := '73706163696E672D793A20302E323572656D3B0D0A20202D2D612D6D656E752D69636F6E2D73697A653A203172656D3B0D0A20202D2D612D6D656E752D69636F6E2D73706163696E672D793A20302E3572656D3B0D0A20202D2D612D6D656E752D69636F';
wwv_flow_imp.g_varchar2_table(65) := '6E2D73706163696E672D783A20302E3572656D3B0D0A20202D2D612D6D656E752D6974656D2D67656E657269632D70616464696E672D793A20302E3572656D3B0D0A20202D2D612D6D656E752D6974656D2D67656E657269632D70616464696E672D783A';
wwv_flow_imp.g_varchar2_table(66) := '20302E3572656D3B0D0A20202D2D612D6D656E752D63616C6C6F75742D73697A653A20302E373572656D3B0D0A20202D2D612D6D656E752D63616C6C6F75742D626F726465722D7261646975733A203072656D3B0D0A20202D2D612D6D656E752D63616C';
wwv_flow_imp.g_varchar2_table(67) := '6C6F75742D736861646F773A2030203020302E323572656D2030207267626128302C20302C20302C20302E31293B0D0A20202D2D612D706F7075706C6F762D7365617263682D6261722D70616464696E672D793A20302E3572656D3B0D0A20202D2D612D';
wwv_flow_imp.g_varchar2_table(68) := '706F7075706C6F762D7365617263682D6261722D70616464696E672D783A20766172282D2D612D706F7075706C6F762D7365617263682D6261722D70616464696E672D79293B0D0A20202D2D612D72762D666F6E742D73697A653A20302E373572656D3B';
wwv_flow_imp.g_varchar2_table(69) := '0D0A20202D2D612D72762D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D72762D626F64792D70616464696E672D793A20302E323572656D3B0D0A20202D2D612D72762D626F64792D70616464696E672D783A203072656D3B0D0A2020';
wwv_flow_imp.g_varchar2_table(70) := '2D2D612D70657263656E742D63686172742D6865696768743A203172656D3B0D0A20202D2D612D70657263656E742D63686172742D6261636B67726F756E642D636F6C6F723A20766172282D2D75742D70616C657474652D7072696D6172792D73686164';
wwv_flow_imp.g_varchar2_table(71) := '65293B0D0A20202D2D612D70657263656E742D63686172742D626F726465722D7261646975733A20302E31323572656D3B0D0A20202D2D612D70657263656E742D63686172742D626F726465722D636F6C6F723A20766172282D2D75742D636F6D706F6E';
wwv_flow_imp.g_varchar2_table(72) := '656E742D626F726465722D636F6C6F72293B0D0A20202D2D612D70657263656E742D63686172742D6261722D6261636B67726F756E642D636F6C6F723A20766172282D2D75742D70616C657474652D7072696D617279293B0D0A20202D2D612D70657263';
wwv_flow_imp.g_varchar2_table(73) := '656E742D63686172742D6261722D746578742D636F6C6F723A20766172282D2D75742D70616C657474652D7072696D6172792D636F6E7472617374293B0D0A20202D2D612D70657263656E742D63686172742D6261722D626F726465722D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(74) := '20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D70616464696E672D793A20302E3572656D3B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D';
wwv_flow_imp.g_varchar2_table(75) := '70616464696E672D783A20302E3572656D3B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D626F726465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A20202D2D612D726570';
wwv_flow_imp.g_varchar2_table(76) := '6F72742D636F6E74726F6C732D626F726465722D77696474683A20766172282D2D75742D636F6D706F6E656E742D626F726465722D7769647468293B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D6974656D2D73706163696E673A20302E';
wwv_flow_imp.g_varchar2_table(77) := '323572656D3B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D73706163696E673A20302E3572656D3B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D626F726465722D7261646975733A20302E313235';
wwv_flow_imp.g_varchar2_table(78) := '72656D3B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D77696474683A2031382E373572656D3B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D666F6E742D73697A653A';
wwv_flow_imp.g_varchar2_table(79) := '20302E373572656D3B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D626F72';
wwv_flow_imp.g_varchar2_table(80) := '6465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D626F726465722D77696474683A20766172282D2D75';
wwv_flow_imp.g_varchar2_table(81) := '742D636F6D706F6E656E742D626F726465722D7769647468293B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D696E7075742D626F726465722D77696474683A20766172282D2D612D6669656C642D696E7075742D626F726465722D776964';
wwv_flow_imp.g_varchar2_table(82) := '7468293B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D696E7075742D626F726465722D636F6C6F723A20766172282D2D612D6669656C642D696E7075742D626F726465722D636F6C6F72293B0D0A20202D2D612D7265706F72742D636F6E';
wwv_flow_imp.g_varchar2_table(83) := '74726F6C732D696E7075742D626F726465722D7261646975733A20766172282D2D612D6669656C642D696E7075742D626F726465722D726164697573293B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D696E7075742D666F6375732D626F';
wwv_flow_imp.g_varchar2_table(84) := '726465722D636F6C6F723A20766172282D2D612D6669656C642D696E7075742D666F6375732D626F726465722D636F6C6F72293B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D696E7075742D70616464696E672D793A20302E3572656D3B';
wwv_flow_imp.g_varchar2_table(85) := '0D0A20202D2D612D7265706F72742D636F6E74726F6C732D696E7075742D70616464696E672D783A20302E3572656D3B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D696E7075742D666F6E742D73697A653A20302E373572656D3B0D0A20';
wwv_flow_imp.g_varchar2_table(86) := '202D2D612D7265706F72742D636F6E74726F6C732D696E7075742D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D73706C69747465722D6261722D77696474683A20302E3572656D3B0D0A20202D2D612D73706C69747465722D746875';
wwv_flow_imp.g_varchar2_table(87) := '6D622D77696474683A20302E3572656D3B0D0A20202D2D612D73706C69747465722D7468756D622D6865696768743A203372656D3B0D0A20202D2D612D73706C69747465722D7468756D622D626F726465722D7261646975733A203072656D3B0D0A2020';
wwv_flow_imp.g_varchar2_table(88) := '2D2D612D73746172726174696E672D73746172732D70616464696E672D793A20302E323572656D3B0D0A20202D2D612D73746172726174696E672D73746172732D62672D636F6C6F723A207267626128302C20302C20302C20302E3135293B0D0A20202D';
wwv_flow_imp.g_varchar2_table(89) := '2D612D73746172726174696E672D76616C75652D73706163696E673A20302E3572656D3B0D0A20202D2D612D7377697463682D77696474683A20322E373572656D3B0D0A20202D2D612D7377697463682D70616464696E672D793A20302E31323572656D';
wwv_flow_imp.g_varchar2_table(90) := '3B0D0A20202D2D612D7377697463682D70616464696E672D783A20302E31323572656D3B0D0A20202D2D612D7377697463682D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D612D7377697463682D6261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(91) := '2D636F6C6F72293B0D0A20202D2D612D7377697463682D6163746976652D6261636B67726F756E642D636F6C6F723A20766172282D2D612D7377697463682D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D7377697463';
wwv_flow_imp.g_varchar2_table(92) := '682D636865636B65642D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D612D7377697463682D636865636B65642D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D7377697463682D636865636B65642D6163';
wwv_flow_imp.g_varchar2_table(93) := '746976652D6261636B67726F756E642D636F6C6F723A20766172282D2D612D7377697463682D636865636B65642D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D7377697463682D746F67676C652D77696474683A2031';
wwv_flow_imp.g_varchar2_table(94) := '2E323572656D3B0D0A20202D2D612D7377697463682D746F67676C652D6865696768743A20312E323572656D3B0D0A20202D2D612D746F6F6C6261722D6261636B67726F756E642D636F6C6F723A20766172282D2D75742D726567696F6E2D6865616465';
wwv_flow_imp.g_varchar2_table(95) := '722D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D746F6F6C6261722D626F726465722D77696474683A20766172282D2D75742D636F6D706F6E656E742D626F726465722D77696474682C20317078293B0D0A20202D2D612D746F6F6C';
wwv_flow_imp.g_varchar2_table(96) := '6261722D626F726465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A20202D2D612D746F6F6C6261722D6974656D2D73706163696E673A20302E3572656D3B0D0A20202D2D612D746F6F6C';
wwv_flow_imp.g_varchar2_table(97) := '6261722D7365702D626F726465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D696E6E65722D626F726465722D636F6C6F72293B0D0A20202D2D612D746F6F6C6261722D736D616C6C2D627574746F6E2D70616464696E672D793A';
wwv_flow_imp.g_varchar2_table(98) := '20302E323572656D3B0D0A20202D2D612D746F6F6C6261722D736D616C6C2D627574746F6E2D70616464696E672D783A20302E3572656D3B0D0A20202D2D612D74726565766965772D746F67676C652D73697A653A203172656D3B0D0A20202D2D612D74';
wwv_flow_imp.g_varchar2_table(99) := '726565766965772D6E6F64652D69636F6E2D73697A653A203172656D3B0D0A20202D2D612D74726565766965772D6E6F64652D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D612D74726565766965772D6E6F64652D6C696E652D686569';
wwv_flow_imp.g_varchar2_table(100) := '6768743A203172656D3B0D0A20202D2D612D74726565766965772D6E6F64652D70616464696E672D793A20302E323572656D3B0D0A20202D2D612D74726565766965772D6E6F64652D70616464696E672D783A20302E323572656D3B0D0A20202D2D612D';
wwv_flow_imp.g_varchar2_table(101) := '74726565766965772D6E6F64652D746578742D636F6C6F723A20696E68657269743B0D0A20202D2D612D74726565766965772D6E6F64652D666F63757365642D736861646F773A20696E7365742030203020302031707820726762612835372C20313535';
wwv_flow_imp.g_varchar2_table(102) := '2C203233342C20302E35293B0D0A20202D2D612D74726565766965772D6E6F64652D706C616365686F6C6465722D626F726465722D7261646975733A20302E31323572656D3B0D0A20202D2D612D74726565766965772D647261672D68656C7065722D62';
wwv_flow_imp.g_varchar2_table(103) := '6F726465722D7261646975733A20302E31323572656D3B0D0A20202D2D612D636869702D70616464696E672D793A20302E31323572656D3B0D0A20202D2D612D636869702D70616464696E672D783A20302E31323572656D3B0D0A20202D2D612D636869';
wwv_flow_imp.g_varchar2_table(104) := '702D73706163696E673A20302E323572656D3B0D0A20202D2D612D636869702D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D612D636869702D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D636869702D6C6162656C';
wwv_flow_imp.g_varchar2_table(105) := '2D73706163696E673A20302E323572656D3B0D0A20202D2D612D636869702D626F726465722D7261646975733A20302E31323572656D3B0D0A20202D2D612D636869702D626F726465722D77696474683A20766172282D2D612D6669656C642D696E7075';
wwv_flow_imp.g_varchar2_table(106) := '742D626F726465722D7769647468293B0D0A20202D2D612D636869702D626F726465722D636F6C6F723A20766172282D2D612D6669656C642D696E7075742D626F726465722D636F6C6F72293B0D0A20202D2D612D636869702D686F7665722D6261636B';
wwv_flow_imp.g_varchar2_table(107) := '67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303235293B0D0A20202D2D612D636869702D6163746976652D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A20202D2D61';
wwv_flow_imp.g_varchar2_table(108) := '2D636869702D6170706C6965642D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A20202D2D612D636869702D6170706C6965642D686F7665722D6261636B67726F756E642D636F6C6F723A207267';
wwv_flow_imp.g_varchar2_table(109) := '626128302C20302C20302C20302E31293B0D0A20202D2D612D636869702D72656D6F76652D686F7665722D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A20202D2D612D636869702D72656D6F7665';
wwv_flow_imp.g_varchar2_table(110) := '2D6163746976652D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A20202D2D612D636869702D6170706C6965642D69732D6163746976652D72656D6F76652D686F7665722D6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(111) := '642D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A20202D2D612D636869702D6170706C6965642D69732D6163746976652D72656D6F76652D6163746976652D6261636B67726F756E642D636F6C6F723A20726762';
wwv_flow_imp.g_varchar2_table(112) := '61283235352C203235352C203235352C20302E32293B0D0A20202D2D612D636869702D696E7075742D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D612D636869702D696E7075742D6C696E652D6865696768743A203172656D3B0D0A20';
wwv_flow_imp.g_varchar2_table(113) := '202D2D612D636F6D626F2D73656C6563742D69636F6E2D73697A653A203172656D3B0D0A20202D2D612D746F6F6C7469702D666F6E742D73697A653A20302E3638373572656D3B0D0A20202D2D612D7370696E6E65722D73697A653A203272656D3B0D0A';
wwv_flow_imp.g_varchar2_table(114) := '20202D2D612D7370696E6E65722D626F726465722D77696474683A20302E323572656D3B0D0A20202D2D612D7370696E6E65722D636F6E7461696E65722D70616464696E673A20302E3572656D3B0D0A20202D2D612D6C6F76652D617065782D6D617267';
wwv_flow_imp.g_varchar2_table(115) := '696E3A203020302E31323572656D3B0D0A20202D2D612D6C6F76652D617065782D686F7665722D746578742D636F6C6F723A20766172282D2D612D70616C657474652D64616E6765722C2023463030293B0D0A20202D2D6A75692D6469616C6F672D6261';
wwv_flow_imp.g_varchar2_table(116) := '636B67726F756E642D636F6C6F723A20766172282D2D75742D726567696F6E2D6261636B67726F756E642D636F6C6F722C20766172282D2D75742D636F6D706F6E656E742D6261636B67726F756E642D636F6C6F7229293B0D0A20202D2D6A75692D6469';
wwv_flow_imp.g_varchar2_table(117) := '616C6F672D746578742D636F6C6F723A20766172282D2D75742D726567696F6E2D746578742D636F6C6F722C20766172282D2D75742D636F6D706F6E656E742D746578742D64656661756C742D636F6C6F7229293B0D0A20202D2D6A75692D6469616C6F';
wwv_flow_imp.g_varchar2_table(118) := '672D626F726465722D636F6C6F723A20766172282D2D75742D726567696F6E2D626F726465722D636F6C6F722C20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F7229293B0D0A20202D2D6A75692D6469616C6F672D626F72';
wwv_flow_imp.g_varchar2_table(119) := '6465722D77696474683A20303B0D0A20202D2D6A75692D6469616C6F672D626F726465722D7261646975733A20766172282D2D75742D726567696F6E2D626F726465722D7261646975732C20766172282D2D75742D636F6D706F6E656E742D626F726465';
wwv_flow_imp.g_varchar2_table(120) := '722D72616469757329293B0D0A20202D2D6A75692D6469616C6F672D736861646F773A20766172282D2D75742D736861646F772D6C67292C2030203020302031707820766172282D2D75742D726567696F6E2D626F726465722D636F6C6F722C20766172';
wwv_flow_imp.g_varchar2_table(121) := '282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F7229293B0D0A20202D2D6A75692D6469616C6F672D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D6A75692D6469616C6F672D7469746C656261722D70616464696E67';
wwv_flow_imp.g_varchar2_table(122) := '2D793A20302E373572656D3B0D0A20202D2D6A75692D6469616C6F672D7469746C656261722D70616464696E672D783A203172656D3B0D0A20202D2D6A75692D6469616C6F672D7469746C656261722D6261636B67726F756E642D636F6C6F723A207472';
wwv_flow_imp.g_varchar2_table(123) := '616E73706172656E743B0D0A20202D2D6A75692D6469616C6F672D7469746C656261722D746578742D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D7469746C652D636F6C6F72293B0D0A20202D2D6A75692D6469616C6F';
wwv_flow_imp.g_varchar2_table(124) := '672D7469746C656261722D626F726465722D77696474683A20766172282D2D75742D726567696F6E2D626F726465722D77696474682C20766172282D2D75742D636F6D706F6E656E742D626F726465722D77696474682C2031707829293B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(125) := '6A75692D6469616C6F672D7469746C656261722D626F726465722D636F6C6F723A20766172282D2D75742D726567696F6E2D626F726465722D636F6C6F722C20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F7229293B0D0A';
wwv_flow_imp.g_varchar2_table(126) := '20202D2D6A75692D6469616C6F672D7469746C652D666F6E742D73697A653A203172656D3B0D0A20202D2D6A75692D6469616C6F672D7469746C652D6C696E652D6865696768743A20312E3572656D3B0D0A20202D2D6A75692D6469616C6F672D746974';
wwv_flow_imp.g_varchar2_table(127) := '6C652D636C6F73652D77696474683A20312E3572656D3B0D0A20202D2D6A75692D6469616C6F672D7469746C652D636C6F73652D6865696768743A20312E3572656D3B0D0A20202D2D6A75692D6469616C6F672D7469746C652D636C6F73652D70616464';
wwv_flow_imp.g_varchar2_table(128) := '696E672D793A20302E3572656D3B0D0A20202D2D6A75692D6469616C6F672D7469746C652D636C6F73652D70616464696E672D783A20302E3572656D3B0D0A20202D2D6A75692D6469616C6F672D7469746C652D636C6F73652D626F726465722D726164';
wwv_flow_imp.g_varchar2_table(129) := '6975733A20766172282D2D612D627574746F6E2D626F726465722D7261646975732C20302E31323572656D293B0D0A20202D2D6A75692D6469616C6F672D7469746C652D636C6F73652D626F726465722D636F6C6F723A20766172282D2D612D62757474';
wwv_flow_imp.g_varchar2_table(130) := '6F6E2D626F726465722D636F6C6F72293B0D0A20202D2D6A75692D6469616C6F672D7469746C652D636C6F73652D69636F6E2D73697A653A203172656D3B0D0A20202D2D6A75692D6469616C6F672D636F6E74656E742D70616464696E672D793A203072';
wwv_flow_imp.g_varchar2_table(131) := '656D3B0D0A20202D2D6A75692D6469616C6F672D636F6E74656E742D70616464696E672D783A203072656D3B0D0A20202D2D6A75692D6469616C6F672D627574746F6E70616E652D636F6E74656E742D70616464696E672D793A20302E373572656D3B0D';
wwv_flow_imp.g_varchar2_table(132) := '0A20202D2D6A75692D6469616C6F672D627574746F6E70616E652D636F6E74656E742D70616464696E672D783A203172656D3B0D0A20202D2D6A75692D6469616C6F672D627574746F6E70616E652D626F726465722D636F6C6F723A20766172282D2D75';
wwv_flow_imp.g_varchar2_table(133) := '742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A20202D2D6A75692D646174657069636B65722D77696474683A2031372E3572656D3B0D0A20202D2D6A75692D646174657069636B65722D6261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(134) := '20766172282D2D75742D636F6D706F6E656E742D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D6A75692D646174657069636B65722D626F726465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D63';
wwv_flow_imp.g_varchar2_table(135) := '6F6C6F72293B0D0A20202D2D6A75692D646174657069636B65722D626F726465722D7261646975733A20302E3572656D3B0D0A20202D2D6A75692D646174657069636B65722D70616464696E673A20302E3572656D3B0D0A20202D2D6A75692D746F6F6C';
wwv_flow_imp.g_varchar2_table(136) := '7469702D626F726465722D7261646975733A20302E31323572656D3B0D0A20202D2D6A75692D746F6F6C7469702D70616464696E673A20302E3572656D3B0D0A20202D2D6F6A65742D666F6E742D73697A653A20302E38373572656D3B0D0A20202D2D6F';
wwv_flow_imp.g_varchar2_table(137) := '6A65742D736D616C6C2D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D6F6A65742D6D656469756D2D666F6E742D73697A653A203172656D3B0D0A20202D2D6F6A65742D6C617267652D666F6E742D73697A653A20312E31323572656D3B';
wwv_flow_imp.g_varchar2_table(138) := '0D0A20202D2D6F6A65742D6C61726765722D666F6E742D73697A653A20312E323572656D3B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D636F6C6F722D736368656D653A206C696768743B0D0A20202D2D75742D70616C657474652D67656E6572';
wwv_flow_imp.g_varchar2_table(139) := '69633A20236632663266323B0D0A20202D2D75742D70616C657474652D67656E657269632D636F6E74726173743A20233030303B0D0A20202D2D75742D70616C657474652D67656E657269632D73686164653A20236639663966393B0D0A20202D2D7574';
wwv_flow_imp.g_varchar2_table(140) := '2D70616C657474652D67656E657269632D746578743A20233030303B0D0A20202D2D612D67762D6865616465722D6261636B67726F756E642D636F6C6F723A20766172282D2D75742D726567696F6E2D6865616465722D6261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(141) := '6C6F72293B0D0A20202D2D75742D7265706F72742D63656C6C2D616C742D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A20202D2D75742D7265706F72742D6865616465722D6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(142) := '642D636F6C6F723A207267626128302C20302C20302C20302E303235293B0D0A20202D2D75742D6865616465722D626F726465722D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A20202D2D75742D6865616465722D626F782D73';
wwv_flow_imp.g_varchar2_table(143) := '6861646F773A20766172282D2D75742D736861646F772D736D293B0D0A20202D2D75742D666F6F7465722D6261636B67726F756E642D636F6C6F723A20236632663266323B0D0A20202D2D75742D666F6F7465722D626F726465722D636F6C6F723A2072';
wwv_flow_imp.g_varchar2_table(144) := '67626128302C20302C20302C20302E3035293B0D0A20202D2D75742D666F6F7465722D6974656D2D73706163696E673A20302E373572656D3B0D0A20202D2D75742D6E6176746162732D6974656D2D626F726465722D77696474683A203170783B0D0A20';
wwv_flow_imp.g_varchar2_table(145) := '202D2D75742D6E6176746162732D6974656D2D686967686C696768742D636F6C6F723A207472616E73706172656E743B0D0A20202D2D75742D6E6176746162732D6974656D2D686967686C696768742D77696474683A203072656D3B0D0A20202D2D7574';
wwv_flow_imp.g_varchar2_table(146) := '2D6E6176746162732D6974656D2D6163746976652D686967686C696768742D636F6C6F723A20766172282D2D75742D70616C657474652D7072696D617279293B0D0A20202D2D75742D6E61766261722D627574746F6E2D62616467652D6261636B67726F';
wwv_flow_imp.g_varchar2_table(147) := '756E642D636F6C6F723A207267626128302C20302C20302C20302E33293B0D0A20202D2D75742D6E61766261722D627574746F6E2D62616467652D626F726465722D7261646975733A20313670783B0D0A20202D2D75742D626F64792D6E61762D626F72';
wwv_flow_imp.g_varchar2_table(148) := '6465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A20202D2D75742D626F64792D7469746C652D626F726465722D77696474683A203070783B0D0A20202D2D75742D626F64792D7469746C';
wwv_flow_imp.g_varchar2_table(149) := '652D626F782D736861646F773A20302031707820302030207267626128302C20302C20302C20302E31293B0D0A20202D2D75742D626F64792D7469746C652D6261636B64726F702D66696C7465723A20736174757261746528313830252920626C757228';
wwv_flow_imp.g_varchar2_table(150) := '387078293B0D0A20202D2D75742D62726561646372756D622D726567696F6E2D73706163696E673A20302E3572656D3B0D0A20202D2D75742D62726561646372756D622D6974656D2D6163746976652D746578742D636F6C6F723A20766172282D2D7574';
wwv_flow_imp.g_varchar2_table(151) := '2D626F64792D7469746C652D746578742D636F6C6F72293B0D0A20202D2D75742D736D6172742D66696C7465722D6D61782D77696474683A20333072656D3B0D0A20202D2D75742D6865726F2D726567696F6E2D7469746C652D746578742D636F6C6F72';
wwv_flow_imp.g_varchar2_table(152) := '3A20766172282D2D75742D626F64792D7469746C652D746578742D636F6C6F72293B0D0A20202D2D75742D726567696F6E2D626F726465722D77696474683A203170783B0D0A20202D2D75742D726567696F6E2D626F782D736861646F773A2076617228';
wwv_flow_imp.g_varchar2_table(153) := '2D2D75742D736861646F772D736D293B0D0A20202D2D75742D726567696F6E2D6D617267696E3A203172656D3B0D0A20202D2D75742D726567696F6E2D666F6E742D73697A653A20302E38373572656D3B0D0A20202D2D75742D726567696F6E2D6C696E';
wwv_flow_imp.g_varchar2_table(154) := '652D6865696768743A20312E323572656D3B0D0A20202D2D75742D726567696F6E2D6865616465722D626F726465722D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A20202D2D75742D726567696F6E2D626F64792D706164';
wwv_flow_imp.g_varchar2_table(155) := '64696E672D793A203172656D3B0D0A20202D2D75742D726567696F6E2D626F64792D70616464696E672D783A203172656D3B0D0A20202D2D75742D726567696F6E2D627574746F6E732D70616464696E672D793A20302E3572656D3B0D0A20202D2D7574';
wwv_flow_imp.g_varchar2_table(156) := '2D726567696F6E2D627574746F6E732D70616464696E672D783A20302E373572656D3B0D0A20202D2D75742D627574746F6E2D726567696F6E2D626F782D736861646F773A20766172282D2D75742D736861646F772D736D293B0D0A20202D2D75742D63';
wwv_flow_imp.g_varchar2_table(157) := '6865636B626F782D6974656D2D73706163696E673A203172656D3B0D0A20202D2D75742D78732D6669656C642D696E7075742D666F6E742D73697A653A203172656D3B0D0A20202D2D75742D78732D6669656C642D696E7075742D6C696E652D68656967';
wwv_flow_imp.g_varchar2_table(158) := '68743A20312E323572656D3B0D0A20202D2D75742D6C6F67696E2D706167652D6261636B67726F756E642D636F6C6F723A20236536653665363B0D0A20202D2D75742D6C6F67696E2D726567696F6E2D6261636B67726F756E642D636F6C6F723A207267';
wwv_flow_imp.g_varchar2_table(159) := '6261283235352C203235352C203235352C20302E3635293B0D0A20202D2D75742D6C6F67696E2D726567696F6E2D66696C7465723A20626C757228347078293B0D0A20202D2D75742D6C6F67696E2D726567696F6E2D626F782D736861646F773A207661';
wwv_flow_imp.g_varchar2_table(160) := '72282D2D75742D736861646F772D6C67293B0D0A20202D2D612D66732D746F67676C652D626F726465722D636F6C6F723A20766172282D2D612D627574746F6E2D626F726465722D636F6C6F72293B0D0A20202D2D612D66732D746F67676C652D626F72';
wwv_flow_imp.g_varchar2_table(161) := '6465722D77696474683A20766172282D2D612D627574746F6E2D626F726465722D7769647468293B0D0A20202D2D612D66732D746F67676C652D626F726465722D7261646975733A20766172282D2D612D627574746F6E2D626F726465722D7261646975';
wwv_flow_imp.g_varchar2_table(162) := '73293B0D0A20202D2D612D66732D746F67676C652D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D746578742D636F6C6F72293B0D0A20202D2D612D66732D746F67676C652D6261636B67726F756E642D636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(163) := '2D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D66732D7365617263682D636F6E7461696E65722D626F726465722D77696474683A20766172282D2D612D627574746F6E2D626F726465722D7769647468293B';
wwv_flow_imp.g_varchar2_table(164) := '0D0A20202D2D612D66732D7365617263682D636F6E7461696E65722D626F726465722D636F6C6F723A20766172282D2D612D627574746F6E2D626F726465722D636F6C6F72293B0D0A20202D2D75742D616C6572742D7469746C652D666F6E742D776569';
wwv_flow_imp.g_varchar2_table(165) := '6768743A20766172282D2D612D626173652D666F6E742D7765696768742D73656D69626F6C642C20353030293B0D0A20202D2D75742D616C6572742D626F782D736861646F773A20766172282D2D75742D736861646F772D736D293B0D0A20202D2D6D67';
wwv_flow_imp.g_varchar2_table(166) := '2D6374726C2D67726F75702D627574746F6E2D746578742D636F6C6F723A20233030303B0D0A20202D2D6D672D706F7075702D636F6E74656E742D626F782D736861646F773A20766172282D2D75742D736861646F772D6C67293B0D0A20202D2D612D6D';
wwv_flow_imp.g_varchar2_table(167) := '61702D6C6567656E642D7469746C652D746578742D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D6D757465642D636F6C6F72293B0D0A20202D2D75742D636172646C6973742D626F782D736861646F773A20766172282D';
wwv_flow_imp.g_varchar2_table(168) := '2D75742D736861646F772D736D293B0D0A20202D2D75742D6C696E6B736C6973742D6172726F772D636F6C6F723A207267626128302C20302C20302C20302E32293B0D0A20202D2D75742D746162732D6974656D2D746578742D636F6C6F723A20766172';
wwv_flow_imp.g_varchar2_table(169) := '282D2D75742D636F6D706F6E656E742D746578742D64656661756C742D636F6C6F72293B0D0A20202D2D75742D746162732D6974656D2D6163746976652D746578742D636F6C6F723A20766172282D2D75742D6C696E6B2D746578742D636F6C6F72293B';
wwv_flow_imp.g_varchar2_table(170) := '0D0A20202D2D75742D746162732D6974656D2D68696E742D686967686C696768742D636F6C6F723A207267626128302C20302C20302C20302E32293B0D0A20202D2D75742D746162732D6974656D2D6163746976652D666F6E742D7765696768743A2076';
wwv_flow_imp.g_varchar2_table(171) := '6172282D2D612D626173652D666F6E742D7765696768742D626F6C642C20373030293B0D0A20202D2D75742D636F6D6D656E742D636861742D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A20202D';
wwv_flow_imp.g_varchar2_table(172) := '2D75742D77702D6D61726B65722D636F6C6F723A20236439643964393B0D0A20202D2D75742D77702D747261636B2D636F6C6F723A20236439643964393B0D0A20202D2D66632D6E65757472616C2D62672D636F6C6F723A207267626128302C20302C20';
wwv_flow_imp.g_varchar2_table(173) := '302C20302E32293B0D0A20202D2D66632D6E65757472616C2D746578742D636F6C6F723A20233030303B0D0A20202D2D66632D6576656E742D73656C65637465642D6F7665726C61792D636F6C6F723A207267626128302C20302C20302C20302E32293B';
wwv_flow_imp.g_varchar2_table(174) := '0D0A20202D2D66632D6E6F6E2D627573696E6573732D636F6C6F723A207267626128302C20302C20302C20302E32293B0D0A20202D2D75742D616C7465726E6174652D68656164696E672D666F6E742D66616D696C793A20766172282D2D612D62617365';
wwv_flow_imp.g_varchar2_table(175) := '2D666F6E742D66616D696C792D7365726966293B0D0A20202D2D75742D616C7465726E6174652D68656164696E672D666F6E742D7765696768743A20766172282D2D612D626173652D666F6E742D7765696768742D6E6F726D616C293B0D0A20202D2D75';
wwv_flow_imp.g_varchar2_table(176) := '742D636F6D706F6E656E742D626F726465722D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A20202D2D75742D636F6D706F6E656E742D626F726465722D77696474683A203170783B0D0A20202D2D75742D636F6D706F6E656E74';
wwv_flow_imp.g_varchar2_table(177) := '2D626F726465722D7261646975733A20302E323572656D3B0D0A20202D2D75742D636F6D706F6E656E742D626F782D736861646F773A20766172282D2D75742D736861646F772D6C67293B0D0A20202D2D75742D636F6D706F6E656E742D686967686C69';
wwv_flow_imp.g_varchar2_table(178) := '6768742D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303235293B0D0A20202D2D75742D636F6D706F6E656E742D746F6F6C6261722D6261636B67726F756E642D636F6C6F723A207267626128302C20302C2030';
wwv_flow_imp.g_varchar2_table(179) := '2C20302E303235293B0D0A20202D2D75742D636F6D706F6E656E742D696E6E65722D626F726465722D77696474683A20766172282D2D75742D636F6D706F6E656E742D626F726465722D7769647468293B0D0A20202D2D75742D636F6D706F6E656E742D';
wwv_flow_imp.g_varchar2_table(180) := '696E6E65722D626F726465722D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A20202D2D75742D636F6D706F6E656E742D746578742D64656661756C742D636F6C6F723A20233030303B0D0A20202D2D75742D636F6D706F6E65';
wwv_flow_imp.g_varchar2_table(181) := '6E742D746578742D7469746C652D636F6C6F723A20233030303B0D0A20202D2D75742D636F6D706F6E656E742D746578742D7375627469746C652D636F6C6F723A207267626128302C20302C20302C20302E3835293B0D0A20202D2D75742D636F6D706F';
wwv_flow_imp.g_varchar2_table(182) := '6E656E742D746578742D6D757465642D636F6C6F723A207267626128302C20302C20302C20302E3635293B0D0A20202D2D75742D636F6D706F6E656E742D69636F6E2D6261636B67726F756E642D636F6C6F723A20766172282D2D75742D70616C657474';
wwv_flow_imp.g_varchar2_table(183) := '652D7072696D617279293B0D0A20202D2D75742D636F6D706F6E656E742D69636F6E2D636F6C6F723A20766172282D2D75742D70616C657474652D7072696D6172792D636F6E7472617374293B0D0A20202D2D75742D636F6D706F6E656E742D62616467';
wwv_flow_imp.g_varchar2_table(184) := '652D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A20202D2D75742D636F6D706F6E656E742D62616467652D746578742D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D74657874';
wwv_flow_imp.g_varchar2_table(185) := '2D64656661756C742D636F6C6F72293B0D0A20202D2D75742D636F6D706F6E656E742D62616467652D626F726465722D7261646975733A20302E323572656D3B0D0A20202D2D75742D736861646F772D736D3A203020302E31323572656D20302E323572';
wwv_flow_imp.g_varchar2_table(186) := '656D202D302E31323572656D207267626128302C20302C20302C20302E31293B0D0A20202D2D75742D736861646F772D6D643A203020302E373572656D20312E3572656D202D302E373572656D207267626128302C20302C20302C20302E33293B0D0A20';
wwv_flow_imp.g_varchar2_table(187) := '202D2D75742D736861646F772D6C673A203020312E3572656D203372656D202D312E3572656D207267626128302C20302C20302C20302E33293B0D0A20202D2D75742D626F726465722D7261646975732D736D3A20302E31323572656D3B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(188) := '75742D626F726465722D7261646975732D6D643A20302E323572656D3B0D0A20202D2D75742D626F726465722D7261646975732D6C673A20302E3572656D3B0D0A20202D2D75742D626F726465722D7261646975733A20766172282D2D75742D626F7264';
wwv_flow_imp.g_varchar2_table(189) := '65722D7261646975732D6D64293B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D70616C657474652D7072696D6172793A20233035364143383B0D0A20202D2D75742D70616C657474652D7072696D6172792D636F6E74726173743A202366666666';
wwv_flow_imp.g_varchar2_table(190) := '66663B0D0A20202D2D75742D70616C657474652D7072696D6172792D73686164653A20236536663066613B0D0A20202D2D75742D70616C657474652D7072696D6172792D746578743A20766172282D2D612D70616C657474652D7072696D617279293B0D';
wwv_flow_imp.g_varchar2_table(191) := '0A7D0D0A3A726F6F74207B0D0A20202D2D75742D6C696E6B2D746578742D636F6C6F723A20233035364143383B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D666F6375732D6F75746C696E652D636F6C6F723A20233035364143383B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(192) := '3A726F6F74207B0D0A20202D2D75742D636F6D706F6E656E742D626F726465722D7261646975733A20302E31323572656D3B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D6865616465722D6261636B67726F756E642D636F6C6F723A2023303536';
wwv_flow_imp.g_varchar2_table(193) := '4143383B0D0A20202D2D75742D6865616465722D746578742D636F6C6F723A20236666666666663B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D626F64792D6261636B67726F756E642D636F6C6F723A20234644464446443B0D0A20202D2D7574';
wwv_flow_imp.g_varchar2_table(194) := '2D626F64792D746578742D636F6C6F723A20233030303030303B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D626F64792D616374696F6E732D6261636B67726F756E642D636F6C6F723A20236639663966393B0D0A20202D2D75742D626F64792D';
wwv_flow_imp.g_varchar2_table(195) := '616374696F6E732D746578742D636F6C6F723A20233030303030303B0D0A20202D2D75742D626F64792D616374696F6E73746F67676C652D6261636B67726F756E642D636F6C6F723A20236639663966393B0D0A20202D2D75742D626F64792D61637469';
wwv_flow_imp.g_varchar2_table(196) := '6F6E73746F67676C652D686F7665722D6261636B67726F756E642D636F6C6F723A20236530653065303B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D626F64792D7469746C652D6261636B67726F756E642D636F6C6F723A20236666666666663B';
wwv_flow_imp.g_varchar2_table(197) := '0D0A20202D2D75742D626F64792D7469746C652D746578742D636F6C6F723A20233030303030303B0D0A20202D2D75742D62726561646372756D622D6974656D2D746578742D636F6C6F723A207267626128302C20302C20302C20302E3635293B0D0A7D';
wwv_flow_imp.g_varchar2_table(198) := '0D0A3A726F6F74207B0D0A20202D2D75742D626F64792D736964656261722D6261636B67726F756E642D636F6C6F723A20236666666666663B0D0A20202D2D75742D626F64792D736964656261722D746578742D636F6C6F723A20233030303030303B0D';
wwv_flow_imp.g_varchar2_table(199) := '0A7D0D0A3A726F6F74207B0D0A20202D2D75742D626F64792D6E61762D6261636B67726F756E642D636F6C6F723A20233265333433393B0D0A20202D2D75742D626F64792D6E61762D746578742D636F6C6F723A20236666666666663B0D0A20202D2D75';
wwv_flow_imp.g_varchar2_table(200) := '742D626F64792D6E61762D7363726F6C6C6261722D7468756D622D6261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E32293B0D0A20202D2D75742D626F64792D6E61762D7363726F6C6C6261722D7472';
wwv_flow_imp.g_varchar2_table(201) := '61636B2D6261636B67726F756E642D636F6C6F723A20233265333433393B0D0A20202D2D75742D6E6176746162732D6261636B67726F756E642D636F6C6F723A20233265333433393B0D0A20202D2D75742D6E6176746162732D746578742D636F6C6F72';
wwv_flow_imp.g_varchar2_table(202) := '3A20236666666666663B0D0A20202D2D75742D6E6176746162732D6974656D2D626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A20202D2D75742D6E6176746162732D6974656D2D6163746976652D';
wwv_flow_imp.g_varchar2_table(203) := '6261636B67726F756E642D636F6C6F723A20233137316131643B0D0A20202D2D75742D6E6176746162732D6974656D2D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D75742D6E6176746162732D6974656D2D616374697665';
wwv_flow_imp.g_varchar2_table(204) := '2D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D75742D6865616465722D6D656E756261722D6261636B67726F756E642D636F6C6F723A20233265333433393B0D0A20202D2D75742D6865616465722D6D656E756261722D6974656D2D7465';
wwv_flow_imp.g_varchar2_table(205) := '78742D636F6C6F723A20236666666666663B0D0A20202D2D75742D6865616465722D6D656E756261722D6974656D2D63757272656E742D6261636B67726F756E642D636F6C6F723A20233137316131643B0D0A20202D2D75742D6865616465722D6D656E';
wwv_flow_imp.g_varchar2_table(206) := '756261722D6974656D2D63757272656E742D746578742D636F6C6F723A20236666666666663B0D0A20202D2D75742D6865616465722D6D656E756261722D6974656D2D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D75742D';
wwv_flow_imp.g_varchar2_table(207) := '6865616465722D6D656E756261722D6974656D2D63757272656E742D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D75742D6865616465722D6D656E756261722D6974656D2D686F7665722D746578742D636F6C6F723A20766172282D2D75';
wwv_flow_imp.g_varchar2_table(208) := '742D6865616465722D6D656E756261722D6974656D2D63757272656E742D746578742D636F6C6F72293B0D0A20202D2D75742D6865616465722D6D656E756261722D6974656D2D626F726465722D636F6C6F723A2072676261283235352C203235352C20';
wwv_flow_imp.g_varchar2_table(209) := '3235352C20302E31293B0D0A20202D2D75742D6865616465722D6D656E756261722D6974656D2D73706C69742D69636F6E2D636F6C6F723A20236666666666663B0D0A20202D2D75742D6865616465722D6D656E756261722D6974656D2D73706C69742D';
wwv_flow_imp.g_varchar2_table(210) := '626F726465722D636F6C6F723A2072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A3A726F6F74207B0D0A20202D2D612D74726565766965772D6E6F64652D73656C65637465642D6261636B67726F756E642D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(211) := '233137316131643B0D0A20202D2D612D74726565766965772D6E6F64652D73656C65637465642D746578742D636F6C6F723A20236666666666663B0D0A20202D2D612D74726565766965772D6E6F64652D666F63757365642D6261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(212) := '636F6C6F723A20233137316131643B0D0A20202D2D612D74726565766965772D6E6F64652D666F63757365642D746578742D636F6C6F723A20236666666666663B0D0A7D0D0A3A726F6F74207B0D0A20202D2D612D74726565766965772D6E6F64652D73';
wwv_flow_imp.g_varchar2_table(213) := '656C65637465642D69636F6E2D636F6C6F723A20236666666666663B0D0A20202D2D612D74726565766965772D6E6F64652D69636F6E2D636F6C6F723A20696E68657269743B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D74726565766965772D';
wwv_flow_imp.g_varchar2_table(214) := '62616467652D6261636B67726F756E642D636F6C6F723A20233035364143383B0D0A20202D2D75742D74726565766965772D62616467652D746578742D636F6C6F723A20236666666666663B0D0A7D0D0A3A726F6F74207B0D0A20202D2D612D6D656E75';
wwv_flow_imp.g_varchar2_table(215) := '2D6261636B67726F756E642D636F6C6F723A20234646464646463B0D0A20202D2D612D6D656E752D746578742D636F6C6F723A20233236323632363B0D0A20202D2D612D6D656E752D64656661756C742D746578742D636F6C6F723A20766172282D2D61';
wwv_flow_imp.g_varchar2_table(216) := '2D6D656E752D746578742D636F6C6F72293B0D0A20202D2D612D6D656E752D616363656C2D746578742D636F6C6F723A20766172282D2D612D6D656E752D746578742D636F6C6F72293B0D0A7D0D0A3A726F6F74207B0D0A20202D2D612D6D656E752D66';
wwv_flow_imp.g_varchar2_table(217) := '6F63757365642D6261636B67726F756E642D636F6C6F723A20233035364143383B0D0A20202D2D612D6D656E752D666F63757365642D746578742D636F6C6F723A20236666666666663B0D0A20202D2D612D6D656E752D666F63757365642D616363656C';
wwv_flow_imp.g_varchar2_table(218) := '2D746578742D636F6C6F723A20766172282D2D612D6D656E752D666F63757365642D746578742D636F6C6F72293B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D726567696F6E2D6865616465722D6261636B67726F756E642D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(219) := '6666666666663B0D0A20202D2D75742D726567696F6E2D6865616465722D746578742D636F6C6F723A20233236323632363B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D726567696F6E2D6261636B67726F756E642D636F6C6F723A2023666666';
wwv_flow_imp.g_varchar2_table(220) := '6666663B0D0A20202D2D75742D726567696F6E2D746578742D636F6C6F723A20233236323632363B0D0A20202D2D75742D636F6D706F6E656E742D6261636B67726F756E642D636F6C6F723A20236666666666663B0D0A20202D2D75742D77697A617264';
wwv_flow_imp.g_varchar2_table(221) := '2D6865616465722D6261636B67726F756E642D636F6C6F723A20236661666166613B0D0A20202D2D75742D7265706F72742D63656C6C2D626F726465722D636F6C6F723A20236536653665363B0D0A20202D2D75742D7265706F72742D63656C6C2D686F';
wwv_flow_imp.g_varchar2_table(222) := '7665722D6261636B67726F756E642D636F6C6F723A20236661666166613B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D70616C657474652D7072696D6172792D616C743A20233963636566643B0D0A20202D2D75742D70616C657474652D707269';
wwv_flow_imp.g_varchar2_table(223) := '6D6172792D616C742D636F6E74726173743A20233031306531613B0D0A20202D2D75742D70616C657474652D7072696D6172792D616C742D73686164653A20236661666466663B0D0A20202D2D75742D70616C657474652D7072696D6172792D616C742D';
wwv_flow_imp.g_varchar2_table(224) := '746578743A20233466373539383B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D70616C657474652D737563636573733A20233237383730313B0D0A20202D2D75742D70616C657474652D737563636573732D636F6E74726173743A20234646463B';
wwv_flow_imp.g_varchar2_table(225) := '0D0A20202D2D75742D70616C657474652D737563636573732D73686164653A20236634663966323B0D0A20202D2D75742D70616C657474652D737563636573732D746578743A20233464376433613B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D';
wwv_flow_imp.g_varchar2_table(226) := '70616C657474652D696E666F3A20233035364143383B0D0A20202D2D75742D70616C657474652D696E666F2D636F6E74726173743A20234646463B0D0A20202D2D75742D70616C657474652D696E666F2D73686164653A20236633663866633B0D0A2020';
wwv_flow_imp.g_varchar2_table(227) := '2D2D75742D70616C657474652D696E666F2D746578743A20233432373561343B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D70616C657474652D7761726E696E673A20234646433632383B0D0A20202D2D75742D70616C657474652D7761726E69';
wwv_flow_imp.g_varchar2_table(228) := '6E672D636F6E74726173743A20233030303B0D0A20202D2D75742D70616C657474652D7761726E696E672D73686164653A20236666663664663B0D0A20202D2D75742D70616C657474652D7761726E696E672D746578743A20233863373032313B0D0A7D';
wwv_flow_imp.g_varchar2_table(229) := '0D0A3A726F6F74207B0D0A20202D2D75742D70616C657474652D64616E6765723A20234342313130303B0D0A20202D2D75742D70616C657474652D64616E6765722D636F6E74726173743A20234646463B0D0A20202D2D75742D70616C657474652D6461';
wwv_flow_imp.g_varchar2_table(230) := '6E6765722D73686164653A20236662656565643B0D0A20202D2D75742D70616C657474652D64616E6765722D746578743A20236135343834303B0D0A7D0D0A3A726F6F74207B0D0A20202D2D752D636F6C6F722D313A20233330394644423B0D0A20202D';
wwv_flow_imp.g_varchar2_table(231) := '2D752D636F6C6F722D312D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D323A20233133423643463B0D0A20202D2D752D636F6C6F722D322D636F6E74726173743A20236534663966643B0D0A20202D2D752D636F6C6F';
wwv_flow_imp.g_varchar2_table(232) := '722D333A20233245424642433B0D0A20202D2D752D636F6C6F722D332D636F6E74726173743A20236630666366623B0D0A20202D2D752D636F6C6F722D343A20233343414638353B0D0A20202D2D752D636F6C6F722D342D636F6E74726173743A202366';
wwv_flow_imp.g_varchar2_table(233) := '30666166363B0D0A20202D2D752D636F6C6F722D353A20233831424235463B0D0A20202D2D752D636F6C6F722D352D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D363A20234444444535333B0D0A20202D2D752D636F';
wwv_flow_imp.g_varchar2_table(234) := '6C6F722D362D636F6E74726173743A20233261326130383B0D0A20202D2D752D636F6C6F722D373A20234642434534413B0D0A20202D2D752D636F6C6F722D372D636F6E74726173743A20233434333330323B0D0A20202D2D752D636F6C6F722D383A20';
wwv_flow_imp.g_varchar2_table(235) := '234544383133453B0D0A20202D2D752D636F6C6F722D382D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D393A20234539354235343B0D0A20202D2D752D636F6C6F722D392D636F6E74726173743A2023666666666666';
wwv_flow_imp.g_varchar2_table(236) := '3B0D0A20202D2D752D636F6C6F722D31303A20234538354438383B0D0A20202D2D752D636F6C6F722D31302D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D31313A20234341353839443B0D0A20202D2D752D636F6C6F';
wwv_flow_imp.g_varchar2_table(237) := '722D31312D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D31323A20233835344539423B0D0A20202D2D752D636F6C6F722D31322D636F6E74726173743A20236636663066383B0D0A20202D2D752D636F6C6F722D3133';
wwv_flow_imp.g_varchar2_table(238) := '3A20233541363841443B0D0A20202D2D752D636F6C6F722D31332D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D31343A20234146424143353B0D0A20202D2D752D636F6C6F722D31342D636F6E74726173743A202333';
wwv_flow_imp.g_varchar2_table(239) := '31336134343B0D0A20202D2D752D636F6C6F722D31353A20233645383539383B0D0A20202D2D752D636F6C6F722D31352D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D31363A20233539623265323B0D0A20202D2D75';
wwv_flow_imp.g_varchar2_table(240) := '2D636F6C6F722D31362D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D31373A20233432633564393B0D0A20202D2D752D636F6C6F722D31372D636F6E74726173743A20233035313531373B0D0A20202D2D752D636F6C';
wwv_flow_imp.g_varchar2_table(241) := '6F722D31383A20233538636363393B0D0A20202D2D752D636F6C6F722D31382D636F6E74726173743A20233039316331633B0D0A20202D2D752D636F6C6F722D31393A20233633626639643B0D0A20202D2D752D636F6C6F722D31392D636F6E74726173';
wwv_flow_imp.g_varchar2_table(242) := '743A20236666666666663B0D0A20202D2D752D636F6C6F722D32303A20233961633937663B0D0A20202D2D752D636F6C6F722D32302D636F6E74726173743A20233230333331363B0D0A20202D2D752D636F6C6F722D32313A20236534653537353B0D0A';
wwv_flow_imp.g_varchar2_table(243) := '20202D2D752D636F6C6F722D32312D636F6E74726173743A20233463346330663B0D0A20202D2D752D636F6C6F722D32323A20236663643836653B0D0A20202D2D752D636F6C6F722D32322D636F6E74726173743A20233639346630323B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(244) := '752D636F6C6F722D32333A20236631396136353B0D0A20202D2D752D636F6C6F722D32332D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D32343A20236564376337363B0D0A20202D2D752D636F6C6F722D32342D636F';
wwv_flow_imp.g_varchar2_table(245) := '6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D32353A20236564376461303B0D0A20202D2D752D636F6C6F722D32352D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D32363A202364353739';
wwv_flow_imp.g_varchar2_table(246) := '62313B0D0A20202D2D752D636F6C6F722D32362D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D32373A20233964373161663B0D0A20202D2D752D636F6C6F722D32372D636F6E74726173743A20236666666666663B0D';
wwv_flow_imp.g_varchar2_table(247) := '0A20202D2D752D636F6C6F722D32383A20233762383662643B0D0A20202D2D752D636F6C6F722D32382D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D32393A20236266633864313B0D0A20202D2D752D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(248) := '32392D636F6E74726173743A20233364343835343B0D0A20202D2D752D636F6C6F722D33303A20233862396461643B0D0A20202D2D752D636F6C6F722D33302D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D33313A20';
wwv_flow_imp.g_varchar2_table(249) := '233139386363613B0D0A20202D2D752D636F6C6F722D33312D636F6E74726173743A20236536663466633B0D0A20202D2D752D636F6C6F722D33323A20233032613562653B0D0A20202D2D752D636F6C6F722D33322D636F6E74726173743A2023633166';
wwv_flow_imp.g_varchar2_table(250) := '3666653B0D0A20202D2D752D636F6C6F722D33333A20233138623161653B0D0A20202D2D752D636F6C6F722D33332D636F6E74726173743A20236430663966383B0D0A20202D2D752D636F6C6F722D33343A20233234613437353B0D0A20202D2D752D63';
wwv_flow_imp.g_varchar2_table(251) := '6F6C6F722D33342D636F6E74726173743A20236432663565383B0D0A20202D2D752D636F6C6F722D33353A20233661616434323B0D0A20202D2D752D636F6C6F722D33352D636F6E74726173743A20236636666266343B0D0A20202D2D752D636F6C6F72';
wwv_flow_imp.g_varchar2_table(252) := '2D33363A20236339636133393B0D0A20202D2D752D636F6C6F722D33362D636F6E74726173743A20233033303330313B0D0A20202D2D752D636F6C6F722D33373A20236439623133623B0D0A20202D2D752D636F6C6F722D33372D636F6E74726173743A';
wwv_flow_imp.g_varchar2_table(253) := '20233132306530333B0D0A20202D2D752D636F6C6F722D33383A20236437366132373B0D0A20202D2D752D636F6C6F722D33382D636F6E74726173743A20236666666666653B0D0A20202D2D752D636F6C6F722D33393A20236432343233623B0D0A2020';
wwv_flow_imp.g_varchar2_table(254) := '2D2D752D636F6C6F722D33392D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D34303A20236431343336663B0D0A20202D2D752D636F6C6F722D34302D636F6E74726173743A20236666666666663B0D0A20202D2D752D';
wwv_flow_imp.g_varchar2_table(255) := '636F6C6F722D34313A20236261336438383B0D0A20202D2D752D636F6C6F722D34312D636F6E74726173743A20236664663966623B0D0A20202D2D752D636F6C6F722D34323A20233737333339333B0D0A20202D2D752D636F6C6F722D34322D636F6E74';
wwv_flow_imp.g_varchar2_table(256) := '726173743A20236538643566303B0D0A20202D2D752D636F6C6F722D34333A20233364346561333B0D0A20202D2D752D636F6C6F722D34332D636F6E74726173743A20236538656266363B0D0A20202D2D752D636F6C6F722D34343A2023386339656230';
wwv_flow_imp.g_varchar2_table(257) := '3B0D0A20202D2D752D636F6C6F722D34342D636F6E74726173743A20236666666666663B0D0A20202D2D752D636F6C6F722D34353A20233465373339313B0D0A20202D2D752D636F6C6F722D34352D636F6E74726173743A20236561656666343B0D0A7D';
wwv_flow_imp.g_varchar2_table(258) := '0D0A3A726F6F74207B0D0A20202D2D612D627574746F6E2D626F726465722D7261646975733A20302E31323572656D3B0D0A7D0D0A3A726F6F74207B0D0A20202D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F723A2023663866386638';
wwv_flow_imp.g_varchar2_table(259) := '3B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20233338333833383B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D6669656C642D6C6162656C2D746578742D636F6C6F723A20233236323632363B0D0A7D0D0A3A726F6F7420';
wwv_flow_imp.g_varchar2_table(260) := '7B0D0A20202D2D612D6669656C642D696E7075742D626F726465722D7261646975733A20302E31323572656D3B0D0A20202D2D612D66696C6564726F702D626F726465722D7261646975733A20302E31323572656D3B0D0A7D0D0A3A726F6F74207B0D0A';
wwv_flow_imp.g_varchar2_table(261) := '20202D2D612D6669656C642D696E7075742D6261636B67726F756E642D636F6C6F723A20236639663966393B0D0A20202D2D612D6669656C642D696E7075742D746578742D636F6C6F723A20233230323032303B0D0A20202D2D612D6669656C642D696E';
wwv_flow_imp.g_varchar2_table(262) := '7075742D626F726465722D636F6C6F723A20236466646664663B0D0A20202D2D612D6669656C642D696E7075742D686F7665722D6261636B67726F756E642D636F6C6F723A20236666666666663B0D0A20202D2D612D6669656C642D696E7075742D666F';
wwv_flow_imp.g_varchar2_table(263) := '6375732D6261636B67726F756E642D636F6C6F723A20236666666666663B0D0A20202D2D612D6669656C642D696E7075742D666F6375732D626F726465722D636F6C6F723A20233035364143383B0D0A20202D2D75742D6669656C642D696E7075742D66';
wwv_flow_imp.g_varchar2_table(264) := '6F6375732D69636F6E2D636F6C6F723A20233035364143383B0D0A20202D2D75742D6669656C642D666C2D696E7075742D666F6375732D69636F6E2D6261636B67726F756E642D636F6C6F723A20233035364143383B0D0A20202D2D75742D6669656C64';
wwv_flow_imp.g_varchar2_table(265) := '2D666C2D696E7075742D666F6375732D69636F6E2D636F6C6F723A20236666666666663B0D0A20202D2D612D636865636B626F782D6261636B67726F756E642D636F6C6F723A20236639663966393B0D0A20202D2D612D636865636B626F782D626F7264';
wwv_flow_imp.g_varchar2_table(266) := '65722D636F6C6F723A207267626128302C20302C20302C20302E3135293B0D0A20202D2D612D636865636B626F782D746578742D636F6C6F723A20236666666666663B0D0A20202D2D612D636865636B626F782D636865636B65642D6261636B67726F75';
wwv_flow_imp.g_varchar2_table(267) := '6E642D636F6C6F723A20233035364143383B0D0A20202D2D612D636865636B626F782D636865636B65642D746578742D636F6C6F723A20236666666666663B0D0A20202D2D612D636865636B626F782D686F7665722D6261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(268) := '6F723A207267626128302C20302C20302C20302E3035293B0D0A7D0D0A3A726F6F74207B0D0A20202D2D612D67762D6261636B67726F756E642D636F6C6F723A20236666666666663B0D0A20202D2D612D67762D63656C6C2D626F726465722D636F6C6F';
wwv_flow_imp.g_varchar2_table(269) := '723A20236536653665363B0D0A20202D2D612D67762D6865616465722D63656C6C2D626F726465722D636F6C6F723A20236536653665363B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D746578742D636F6C6F';
wwv_flow_imp.g_varchar2_table(270) := '723A20233236323632363B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D6261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D6865616465722D';
wwv_flow_imp.g_varchar2_table(271) := '6865696768743A203372656D3B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D6E61762D77696474683A20313572656D3B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D626F64792D616374696F6E732D77696474683A2031322E3572656D3B';
wwv_flow_imp.g_varchar2_table(272) := '0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D626F64792D736964656261722D77696474683A20313572656D3B0D0A7D0D0A3A726F6F74207B0D0A20202D2D75742D626F64792D636F6E74656E742D6D61782D77696474683A20313030253B0D0A7D';
wwv_flow_imp.g_varchar2_table(273) := '0D0A2E742D427574746F6E2D2D686561646572207B0D0A20202D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20696E697469616C';
wwv_flow_imp.g_varchar2_table(274) := '3B0D0A20202D2D612D627574746F6E2D626F726465722D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D736861646F773A206E6F6E653B0D0A20202D2D612D627574746F6E2D686F7665722D6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(275) := '642D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A20202D2D612D627574746F6E2D686F7665722D626F726465722D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D6163746976652D626163';
wwv_flow_imp.g_varchar2_table(276) := '6B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3135293B0D0A20202D2D612D627574746F6E2D6163746976652D626F726465722D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D6163';
wwv_flow_imp.g_varchar2_table(277) := '746976652D736861646F773A206E6F6E653B0D0A20202D2D612D627574746F6E2D666F6375732D6261636B67726F756E642D636F6C6F723A20766172282D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A2E742D4275';
wwv_flow_imp.g_varchar2_table(278) := '74746F6E2D2D6865616465722E69732D616374697665207B0D0A20202D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E3235293B0D0A7D0D0A3A726F6F74207B0D0A20202D2D612D627574';
wwv_flow_imp.g_varchar2_table(279) := '746F6E2D626F726465722D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D0A20202D2D612D627574746F6E2D736861646F773A20302032707820347078202D337078207267626128302C20302C20302C20302E31293B0D0A2020';
wwv_flow_imp.g_varchar2_table(280) := '2D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C6F723A20236666666666663B0D0A20202D2D612D627574746F6E2D686F7665722D626F726465722D636F6C6F723A207267626128302C20302C20302C20302E303735293B0D';
wwv_flow_imp.g_varchar2_table(281) := '0A20202D2D612D627574746F6E2D686F7665722D736861646F773A20302032707820347078202D327078207267626128302C20302C20302C20302E31293B0D0A20202D2D612D627574746F6E2D6163746976652D6261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(282) := '3A20236536653665363B0D0A20202D2D612D627574746F6E2D6163746976652D736861646F773A20302032707820327078202D317078207267626128302C20302C20302C20302E31352920696E7365743B0D0A20202D2D612D627574746F6E2D666F6375';
wwv_flow_imp.g_varchar2_table(283) := '732D6261636B67726F756E642D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D627574746F6E2D666F6375732D626F726465722D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(284) := '75742D70616C657474652D7072696D617279293B0D0A7D0D0A2E742D427574746F6E2D2D73696D706C65207B0D0A20202D2D612D627574746F6E2D747970652D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(285) := '612D627574746F6E2D747970652D626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D427574746F6E2D2D6C696E6B207B0D0A2020626F726465722D636F6C6F723A207472616E73706172656E743B0D0A20206261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(286) := '6C6F723A207472616E73706172656E743B0D0A2020626F782D736861646F773A206E6F6E653B0D0A7D0D0A2E742D427574746F6E2D2D6E6F55492C0D0A2E742D427574746F6E2D2D6E6F55493A686F7665722C0D0A2E742D427574746F6E2D2D6E6F5549';
wwv_flow_imp.g_varchar2_table(287) := '3A6163746976652C0D0A2E612D427574746F6E2D2D6E6F55492C0D0A2E612D427574746F6E2D2D6E6F55493A686F7665722C0D0A2E612D427574746F6E2D2D6E6F55493A616374697665207B0D0A20202D2D612D627574746F6E2D747970652D73686164';
wwv_flow_imp.g_varchar2_table(288) := '6F773A206E6F6E653B0D0A20202D2D612D627574746F6E2D747970652D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D747970652D626F726465722D636F6C6F723A207472616E737061';
wwv_flow_imp.g_varchar2_table(289) := '72656E743B0D0A20202D2D612D627574746F6E2D747970652D746578742D636F6C6F723A20696E68657269743B0D0A2020636F6C6F723A20696E68657269743B0D0A20206261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A';
wwv_flow_imp.g_varchar2_table(290) := '2020746578742D736861646F773A206E6F6E653B0D0A7D0D0A2E742D427574746F6E2D2D686F742C0D0A2E612D427574746F6E2D2D686F742C0D0A2E75692D627574746F6E2D2D686F742C0D0A2E612D43617264566965772D627574746F6E2D2D686F74';
wwv_flow_imp.g_varchar2_table(291) := '2C0D0A2E617065782D627574746F6E2D67726F757020696E7075743A636865636B6564202B206C6162656C2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D6772';
wwv_flow_imp.g_varchar2_table(292) := '6F75702D2D726320696E7075743A636865636B6564202B206C6162656C207B0D0A20202D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F723A20233035364143383B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A2023';
wwv_flow_imp.g_varchar2_table(293) := '6666666666663B0D0A20202D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C6F723A20233037383466393B0D0A20202D2D612D627574746F6E2D686F7665722D746578742D636F6C6F723A20766172282D2D612D627574746F';
wwv_flow_imp.g_varchar2_table(294) := '6E2D746578742D636F6C6F72293B0D0A20202D2D612D627574746F6E2D6163746976652D6261636B67726F756E642D636F6C6F723A20233034356461663B0D0A20202D2D612D627574746F6E2D6163746976652D746578742D636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(295) := '2D2D612D627574746F6E2D686F7665722D746578742D636F6C6F72293B0D0A20202D2D612D627574746F6E2D666F6375732D6261636B67726F756E642D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(296) := '636F6C6F72293B0D0A20202D2D612D627574746F6E2D666F6375732D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D746578742D636F6C6F72293B0D0A7D0D0A2E742D427574746F6E2D2D686F742E742D427574746F';
wwv_flow_imp.g_varchar2_table(297) := '6E2D2D73696D706C652C0D0A2E612D427574746F6E2D2D686F742E742D427574746F6E2D2D73696D706C652C0D0A2E75692D627574746F6E2D2D686F742E742D427574746F6E2D2D73696D706C652C0D0A2E612D43617264566965772D627574746F6E2D';
wwv_flow_imp.g_varchar2_table(298) := '2D686F742E742D427574746F6E2D2D73696D706C652C0D0A2E617065782D627574746F6E2D67726F757020696E7075743A636865636B6564202B206C6162656C2E742D427574746F6E2D2D73696D706C652C0D0A2E742D466F726D2D6669656C64436F6E';
wwv_flow_imp.g_varchar2_table(299) := '7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E7075743A636865636B6564202B206C6162656C2E742D427574746F6E2D2D73696D706C65207B0D0A20202D2D612D627574746F6E';
wwv_flow_imp.g_varchar2_table(300) := '2D626F726465722D636F6C6F723A20233035364143383B0D0A20202D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A202334323735';
wwv_flow_imp.g_varchar2_table(301) := '61343B0D0A20202D2D612D627574746F6E2D686F7665722D746578742D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D686F742E742D427574746F6E2D2D6C696E6B2C0D0A2E612D427574746F6E2D2D686F742E742D4275';
wwv_flow_imp.g_varchar2_table(302) := '74746F6E2D2D6C696E6B2C0D0A2E75692D627574746F6E2D2D686F742E742D427574746F6E2D2D6C696E6B2C0D0A2E612D43617264566965772D627574746F6E2D2D686F742E742D427574746F6E2D2D6C696E6B2C0D0A2E617065782D627574746F6E2D';
wwv_flow_imp.g_varchar2_table(303) := '67726F757020696E7075743A636865636B6564202B206C6162656C2E742D427574746F6E2D2D6C696E6B2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F';
wwv_flow_imp.g_varchar2_table(304) := '75702D2D726320696E7075743A636865636B6564202B206C6162656C2E742D427574746F6E2D2D6C696E6B207B0D0A20202D2D612D627574746F6E2D626F726465722D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E';
wwv_flow_imp.g_varchar2_table(305) := '2D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D626F782D736861646F773A206E6F6E653B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20233432373561343B0D0A';
wwv_flow_imp.g_varchar2_table(306) := '7D0D0A2E742D427574746F6E2D2D686F742E742D427574746F6E2D2D6E6F55492C0D0A2E612D427574746F6E2D2D686F742E742D427574746F6E2D2D6E6F55492C0D0A2E75692D627574746F6E2D2D686F742E742D427574746F6E2D2D6E6F55492C0D0A';
wwv_flow_imp.g_varchar2_table(307) := '2E612D43617264566965772D627574746F6E2D2D686F742E742D427574746F6E2D2D6E6F55492C0D0A2E617065782D627574746F6E2D67726F757020696E7075743A636865636B6564202B206C6162656C2E742D427574746F6E2D2D6E6F55492C0D0A2E';
wwv_flow_imp.g_varchar2_table(308) := '742D466F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E7075743A636865636B6564202B206C6162656C2E742D427574746F6E2D2D6E6F55492C0D0A';
wwv_flow_imp.g_varchar2_table(309) := '2E742D427574746F6E2D2D686F742E612D427574746F6E2D2D6E6F55492C0D0A2E612D427574746F6E2D2D686F742E612D427574746F6E2D2D6E6F55492C0D0A2E75692D627574746F6E2D2D686F742E612D427574746F6E2D2D6E6F55492C0D0A2E612D';
wwv_flow_imp.g_varchar2_table(310) := '43617264566965772D627574746F6E2D2D686F742E612D427574746F6E2D2D6E6F55492C0D0A2E617065782D627574746F6E2D67726F757020696E7075743A636865636B6564202B206C6162656C2E612D427574746F6E2D2D6E6F55492C0D0A2E742D46';
wwv_flow_imp.g_varchar2_table(311) := '6F726D2D6669656C64436F6E7461696E65722D2D726164696F427574746F6E47726F7570202E617065782D6974656D2D67726F75702D2D726320696E7075743A636865636B6564202B206C6162656C2E612D427574746F6E2D2D6E6F5549207B0D0A2020';
wwv_flow_imp.g_varchar2_table(312) := '2D2D612D627574746F6E2D746578742D636F6C6F723A20233432373561343B0D0A2020636F6C6F723A20233432373561343B0D0A7D0D0A2E742D427574746F6E2D2D7761726E696E67207B0D0A20202D2D612D627574746F6E2D6261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(313) := '2D636F6C6F723A20234646433632383B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20233030303B0D0A20202D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C6F723A20236666643435623B0D0A20202D';
wwv_flow_imp.g_varchar2_table(314) := '2D612D627574746F6E2D686F7665722D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D746578742D636F6C6F72293B0D0A20202D2D612D627574746F6E2D6163746976652D6261636B67726F756E642D636F6C6F723A202366666266';
wwv_flow_imp.g_varchar2_table(315) := '30653B0D0A20202D2D612D627574746F6E2D6163746976652D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D746578742D636F6C6F72293B0D0A20202D2D612D627574746F6E2D666F6375732D6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(316) := '642D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D627574746F6E2D666F6375732D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665';
wwv_flow_imp.g_varchar2_table(317) := '722D746578742D636F6C6F72293B0D0A7D0D0A2E742D427574746F6E2D2D7761726E696E672E742D427574746F6E2D2D73696D706C65207B0D0A20202D2D612D627574746F6E2D626F726465722D636F6C6F723A20234646433632383B0D0A20202D2D61';
wwv_flow_imp.g_varchar2_table(318) := '2D627574746F6E2D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20233863373032313B0D0A20202D2D612D627574746F6E2D686F7665722D746578742D63';
wwv_flow_imp.g_varchar2_table(319) := '6F6C6F723A20233030303B0D0A7D0D0A2E742D427574746F6E2D2D7761726E696E672E742D427574746F6E2D2D6C696E6B207B0D0A20202D2D612D627574746F6E2D626F726465722D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D';
wwv_flow_imp.g_varchar2_table(320) := '627574746F6E2D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D626F782D736861646F773A206E6F6E653B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A2023386337';
wwv_flow_imp.g_varchar2_table(321) := '3032313B0D0A7D0D0A2E742D427574746F6E2D2D7761726E696E672E742D427574746F6E2D2D6E6F55492C0D0A2E742D427574746F6E2D2D7761726E696E672E612D427574746F6E2D2D6E6F5549207B0D0A20202D2D612D627574746F6E2D746578742D';
wwv_flow_imp.g_varchar2_table(322) := '636F6C6F723A20233863373032313B0D0A2020636F6C6F723A20233863373032313B0D0A7D0D0A2E742D427574746F6E2D2D73756363657373207B0D0A20202D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F723A20233237383730313B';
wwv_flow_imp.g_varchar2_table(323) := '0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20234646463B0D0A20202D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C6F723A20233336626130313B0D0A20202D2D612D627574746F6E2D686F7665722D';
wwv_flow_imp.g_varchar2_table(324) := '746578742D636F6C6F723A20766172282D2D612D627574746F6E2D746578742D636F6C6F72293B0D0A20202D2D612D627574746F6E2D6163746976652D6261636B67726F756E642D636F6C6F723A20233230366530313B0D0A20202D2D612D627574746F';
wwv_flow_imp.g_varchar2_table(325) := '6E2D6163746976652D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D746578742D636F6C6F72293B0D0A20202D2D612D627574746F6E2D666F6375732D6261636B67726F756E642D636F6C6F723A20766172282D2D61';
wwv_flow_imp.g_varchar2_table(326) := '2D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D627574746F6E2D666F6375732D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D746578742D636F6C6F72293B0D0A';
wwv_flow_imp.g_varchar2_table(327) := '7D0D0A2E742D427574746F6E2D2D737563636573732E742D427574746F6E2D2D73696D706C65207B0D0A20202D2D612D627574746F6E2D626F726465722D636F6C6F723A20233237383730313B0D0A20202D2D612D627574746F6E2D6261636B67726F75';
wwv_flow_imp.g_varchar2_table(328) := '6E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20233464376433613B0D0A20202D2D612D627574746F6E2D686F7665722D746578742D636F6C6F723A20234646463B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(329) := '2E742D427574746F6E2D2D737563636573732E742D427574746F6E2D2D6C696E6B207B0D0A20202D2D612D627574746F6E2D626F726465722D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(330) := '642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D626F782D736861646F773A206E6F6E653B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20233464376433613B0D0A7D0D0A2E742D42757474';
wwv_flow_imp.g_varchar2_table(331) := '6F6E2D2D737563636573732E742D427574746F6E2D2D6E6F55492C0D0A2E742D427574746F6E2D2D737563636573732E612D427574746F6E2D2D6E6F5549207B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20233464376433613B0D';
wwv_flow_imp.g_varchar2_table(332) := '0A2020636F6C6F723A20233464376433613B0D0A7D0D0A2E75692D627574746F6E2D2D64616E6765722C0D0A2E742D427574746F6E2D2D64616E676572207B0D0A20202D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F723A2023434231';
wwv_flow_imp.g_varchar2_table(333) := '3130303B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20234646463B0D0A20202D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C6F723A20236665313530303B0D0A20202D2D612D627574746F6E2D686F';
wwv_flow_imp.g_varchar2_table(334) := '7665722D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D746578742D636F6C6F72293B0D0A20202D2D612D627574746F6E2D6163746976652D6261636B67726F756E642D636F6C6F723A20236232306630303B0D0A20202D2D612D62';
wwv_flow_imp.g_varchar2_table(335) := '7574746F6E2D6163746976652D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D746578742D636F6C6F72293B0D0A20202D2D612D627574746F6E2D666F6375732D6261636B67726F756E642D636F6C6F723A20766172';
wwv_flow_imp.g_varchar2_table(336) := '282D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D627574746F6E2D666F6375732D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D746578742D636F6C6F72';
wwv_flow_imp.g_varchar2_table(337) := '293B0D0A7D0D0A2E75692D627574746F6E2D2D64616E6765722E742D427574746F6E2D2D73696D706C652C0D0A2E742D427574746F6E2D2D64616E6765722E742D427574746F6E2D2D73696D706C65207B0D0A20202D2D612D627574746F6E2D626F7264';
wwv_flow_imp.g_varchar2_table(338) := '65722D636F6C6F723A20234342313130303B0D0A20202D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20236135343834303B0D0A';
wwv_flow_imp.g_varchar2_table(339) := '20202D2D612D627574746F6E2D686F7665722D746578742D636F6C6F723A20234646463B0D0A7D0D0A2E75692D627574746F6E2D2D64616E6765722E742D427574746F6E2D2D6C696E6B2C0D0A2E742D427574746F6E2D2D64616E6765722E742D427574';
wwv_flow_imp.g_varchar2_table(340) := '746F6E2D2D6C696E6B207B0D0A20202D2D612D627574746F6E2D626F726465722D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20';
wwv_flow_imp.g_varchar2_table(341) := '202D2D612D627574746F6E2D626F782D736861646F773A206E6F6E653B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20236135343834303B0D0A7D0D0A2E75692D627574746F6E2D2D64616E6765722E742D427574746F6E2D2D6E6F';
wwv_flow_imp.g_varchar2_table(342) := '55492C0D0A2E742D427574746F6E2D2D64616E6765722E742D427574746F6E2D2D6E6F55492C0D0A2E75692D627574746F6E2D2D64616E6765722E612D427574746F6E2D2D6E6F55492C0D0A2E742D427574746F6E2D2D64616E6765722E612D42757474';
wwv_flow_imp.g_varchar2_table(343) := '6F6E2D2D6E6F5549207B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20236135343834303B0D0A2020636F6C6F723A20236135343834303B0D0A7D0D0A2E742D427574746F6E2D2D7072696D617279207B0D0A20202D2D612D627574';
wwv_flow_imp.g_varchar2_table(344) := '746F6E2D6261636B67726F756E642D636F6C6F723A20233963636566643B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20233031306531613B0D0A20202D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(345) := '6F723A20236235646266643B0D0A20202D2D612D627574746F6E2D686F7665722D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D746578742D636F6C6F72293B0D0A20202D2D612D627574746F6E2D6163746976652D6261636B6772';
wwv_flow_imp.g_varchar2_table(346) := '6F756E642D636F6C6F723A20233834633266633B0D0A20202D2D612D627574746F6E2D6163746976652D746578742D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D746578742D636F6C6F72293B0D0A20202D2D612D627574746F';
wwv_flow_imp.g_varchar2_table(347) := '6E2D666F6375732D6261636B67726F756E642D636F6C6F723A20766172282D2D612D627574746F6E2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D627574746F6E2D666F6375732D746578742D636F6C6F723A207661';
wwv_flow_imp.g_varchar2_table(348) := '72282D2D612D627574746F6E2D686F7665722D746578742D636F6C6F72293B0D0A7D0D0A2E742D427574746F6E2D2D7072696D6172792E742D427574746F6E2D2D73696D706C65207B0D0A20202D2D612D627574746F6E2D626F726465722D636F6C6F72';
wwv_flow_imp.g_varchar2_table(349) := '3A20766172282D2D75742D70616C657474652D7072696D6172792D616C74293B0D0A20202D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D746578742D636F6C';
wwv_flow_imp.g_varchar2_table(350) := '6F723A20766172282D2D75742D70616C657474652D7072696D6172792D616C742D74657874293B0D0A20202D2D612D627574746F6E2D686F7665722D746578742D636F6C6F723A20233031306531613B0D0A7D0D0A2E742D427574746F6E2D2D7072696D';
wwv_flow_imp.g_varchar2_table(351) := '6172792E742D427574746F6E2D2D6C696E6B207B0D0A20202D2D612D627574746F6E2D626F726465722D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D6261636B67726F756E642D636F6C6F723A207472616E7370';
wwv_flow_imp.g_varchar2_table(352) := '6172656E743B0D0A20202D2D612D627574746F6E2D626F782D736861646F773A206E6F6E653B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20766172282D2D75742D70616C657474652D7072696D6172792D616C742D74657874293B';
wwv_flow_imp.g_varchar2_table(353) := '0D0A7D0D0A2E742D427574746F6E2D2D7072696D6172792E742D427574746F6E2D2D6E6F55492C0D0A2E742D427574746F6E2D2D7072696D6172792E612D427574746F6E2D2D6E6F5549207B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F';
wwv_flow_imp.g_varchar2_table(354) := '723A20766172282D2D75742D70616C657474652D7072696D6172792D616C742D74657874293B0D0A2020636F6C6F723A20766172282D2D75742D70616C657474652D7072696D6172792D616C742D74657874293B0D0A7D0D0A2E742D466F726D2D68656C';
wwv_flow_imp.g_varchar2_table(355) := '70427574746F6E207B0D0A20202D2D612D627574746F6E2D70616464696E672D793A20302E323572656D3B0D0A20202D2D612D627574746F6E2D70616464696E672D783A20302E323572656D3B0D0A20202D2D612D627574746F6E2D747970652D626163';
wwv_flow_imp.g_varchar2_table(356) := '6B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D747970652D626F726465722D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D627574746F6E2D747970652D626F782D736861';
wwv_flow_imp.g_varchar2_table(357) := '646F773A206E6F6E653B0D0A20202D2D612D627574746F6E2D746578742D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D6D757465642D636F6C6F72293B0D0A20202D2D612D627574746F6E2D686F7665722D746578742D';
wwv_flow_imp.g_varchar2_table(358) := '636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D64656661756C742D636F6C6F72293B0D0A7D0D0A2E742D427574746F6E2E742D427574746F6E2D2D6E6F5549202E66613A61667465722C0D0A2E742D427574746F6E2E742D';
wwv_flow_imp.g_varchar2_table(359) := '427574746F6E2D2D6C696E6B202E66613A61667465722C0D0A2E742D427574746F6E2E742D427574746F6E2D2D73696D706C65202E66613A61667465722C0D0A2E612D427574746F6E2E612D427574746F6E2D2D6E6F5549202E66613A6166746572207B';
wwv_flow_imp.g_varchar2_table(360) := '0D0A20206261636B67726F756E642D636F6C6F723A20236666666666663B0D0A7D0D0A2E742D427574746F6E2D2D64616E676572202E66613A61667465722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D64616E6765723A';
wwv_flow_imp.g_varchar2_table(361) := '686F766572202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20234342313130303B0D0A7D0D0A2E742D427574746F6E2D2D73756363657373202E66613A61667465722C0D0A2E742D427574746F6E2D2D73696D706C65';
wwv_flow_imp.g_varchar2_table(362) := '2E742D427574746F6E2D2D737563636573733A686F766572202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20233237383730313B0D0A7D0D0A2E742D427574746F6E2D2D7072696D617279202E66613A61667465722C';
wwv_flow_imp.g_varchar2_table(363) := '0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7072696D6172793A686F766572202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A20233963636566643B0D0A7D0D0A2E742D427574746F6E2D';
wwv_flow_imp.g_varchar2_table(364) := '2D7761726E696E67202E66613A61667465722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D7761726E696E673A686F766572202E66613A6166746572207B0D0A20206261636B67726F756E642D636F6C6F723A2023464643';
wwv_flow_imp.g_varchar2_table(365) := '3632383B0D0A7D0D0A2E742D427574746F6E2D2D686F74202E66613A61667465722C0D0A2E742D427574746F6E2D2D73696D706C652E742D427574746F6E2D2D686F743A686F766572202E66613A6166746572207B0D0A20206261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(366) := '636F6C6F723A20233035364143383B0D0A7D0D0A3A726F6F74207B0D0A20202D2D612D63762D6974656D2D77696474683A20313972656D3B0D0A20202D2D612D63762D666F6375732D6F75746C696E653A206E6F6E653B0D0A20202D2D612D63762D626F';
wwv_flow_imp.g_varchar2_table(367) := '726465722D77696474683A203170783B0D0A20202D2D612D63762D626F726465722D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A20202D2D612D63762D626F726465722D7261646975733A20302E3138373572656D3B0D0A2020';
wwv_flow_imp.g_varchar2_table(368) := '2D2D612D63762D6261636B67726F756E642D636F6C6F723A20236666666666663B0D0A20202D2D612D63762D736861646F773A20302032707820347078202D327078207267626128302C20302C20302C20302E303735293B0D0A20202D2D612D63762D68';
wwv_flow_imp.g_varchar2_table(369) := '6F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D612D63762D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D63762D686F7665722D746578742D636F6C6F723A20766172282D2D612D63762D746578742D636F6C';
wwv_flow_imp.g_varchar2_table(370) := '6F72293B0D0A20202D2D612D63762D686F7665722D626F726465722D636F6C6F723A20766172282D2D612D63762D626F726465722D636F6C6F72293B0D0A20202D2D612D63762D686F7665722D736861646F773A20302034707820302E3572656D203020';
wwv_flow_imp.g_varchar2_table(371) := '7267626128302C20302C20302C20302E31293B0D0A20202D2D612D63762D6163746976652D6261636B67726F756E642D636F6C6F723A20766172282D2D612D63762D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D63762D6163746976';
wwv_flow_imp.g_varchar2_table(372) := '652D746578742D636F6C6F723A20766172282D2D612D63762D746578742D636F6C6F72293B0D0A20202D2D612D63762D6163746976652D626F726465722D636F6C6F723A20766172282D2D612D63762D626F726465722D636F6C6F72293B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(373) := '612D63762D6163746976652D736861646F773A20766172282D2D612D63762D736861646F77293B0D0A20202D2D612D63762D666F6375732D626F726465722D636F6C6F723A20233035364143383B0D0A20202D2D612D63762D6D656469612D7061646469';
wwv_flow_imp.g_varchar2_table(374) := '6E672D793A203172656D3B0D0A20202D2D612D63762D6D656469612D70616464696E672D783A203172656D3B0D0A20202D2D612D63762D6865616465722D70616464696E672D793A203172656D3B0D0A20202D2D612D63762D6865616465722D70616464';
wwv_flow_imp.g_varchar2_table(375) := '696E672D783A203172656D3B0D0A20202D2D612D63762D6865616465722D626F726465722D77696474683A203170783B0D0A20202D2D612D63762D6865616465722D626F726465722D636F6C6F723A207267626128302C20302C20302C20302E3035293B';
wwv_flow_imp.g_varchar2_table(376) := '0D0A20202D2D612D63762D69636F6E2D6261636B67726F756E642D636F6C6F723A20233035364143383B0D0A20202D2D612D63762D69636F6E2D746578742D636F6C6F723A20236666666666663B0D0A20202D2D612D63762D69636F6E2D626F72646572';
wwv_flow_imp.g_varchar2_table(377) := '2D7261646975733A20313030253B0D0A20202D2D612D63762D69636F6E2D73697A653A203172656D3B0D0A20202D2D612D63762D69636F6E2D636F6E7461696E65722D73697A653A203272656D3B0D0A20202D2D612D63762D69636F6E2D70616464696E';
wwv_flow_imp.g_varchar2_table(378) := '673A20302E3572656D3B0D0A20202D2D612D63762D696E697469616C732D666F6E742D7765696768743A203730303B0D0A20202D2D612D63762D696E697469616C732D746578742D636F6C6F723A20236666666666663B0D0A20202D2D612D63762D696E';
wwv_flow_imp.g_varchar2_table(379) := '697469616C732D6261636B67726F756E642D636F6C6F723A20233035364143383B0D0A20202D2D612D63762D7375627469746C652D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D612D63762D7375627469746C652D666F6E742D776569';
wwv_flow_imp.g_varchar2_table(380) := '6768743A203430303B0D0A20202D2D612D63762D7375627469746C652D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D63762D7375627469746C652D746578742D636F6C6F723A20233636363636363B0D0A20202D2D612D63762D626F';
wwv_flow_imp.g_varchar2_table(381) := '64792D70616464696E672D783A203172656D3B0D0A20202D2D612D63762D626F64792D70616464696E672D793A203172656D3B0D0A20202D2D612D63762D6D61696E636F6E74656E742D666F6E742D73697A653A20302E38373572656D3B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(382) := '612D63762D6D61696E636F6E74656E742D6C696E652D6865696768743A20312E323572656D3B0D0A20202D2D612D63762D737562636F6E74656E742D666F6E742D73697A653A20302E3638373572656D3B0D0A20202D2D612D63762D737562636F6E7465';
wwv_flow_imp.g_varchar2_table(383) := '6E742D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D63762D737562636F6E74656E742D746578742D636F6C6F723A20233636363636363B0D0A20202D2D612D63762D616374696F6E732D626F726465722D77696474683A203170783B';
wwv_flow_imp.g_varchar2_table(384) := '0D0A20202D2D612D63762D616374696F6E732D626F726465722D636F6C6F723A207267626128302C20302C20302C20302E3035293B0D0A20202D2D612D63762D616374696F6E732D70616464696E672D793A203172656D3B0D0A20202D2D612D63762D61';
wwv_flow_imp.g_varchar2_table(385) := '6374696F6E732D70616464696E672D783A203172656D3B0D0A7D0D0A2E612D544D562D2D6361726473202E612D47562D666F6F746572207B0D0A20206D696E2D6865696768743A20756E7365743B0D0A202070616464696E672D626C6F636B2D73746172';
wwv_flow_imp.g_varchar2_table(386) := '743A20303B0D0A202070616464696E672D626C6F636B2D656E643A20303B0D0A7D0D0A2E612D544D562D2D6361726473202E612D47562D666F6F746572202E6A732D72616E6765446973706C6179207B0D0A20206D617267696E2D626C6F636B2D737461';
wwv_flow_imp.g_varchar2_table(387) := '72743A20766172282D2D612D67762D666F6F7465722D70616464696E672D79293B0D0A20206D617267696E2D626C6F636B2D656E643A20766172282D2D612D67762D666F6F7465722D70616464696E672D79293B0D0A7D0D0A2E612D4361726456696577';
wwv_flow_imp.g_varchar2_table(388) := '2D66756C6C4C696E6B3A666F637573207B0D0A2020626F782D736861646F773A20696E73657420302030203020766172282D2D612D63762D626F726465722D77696474682C20302920766172282D2D612D63762D666F6375732D626F726465722D636F6C';
wwv_flow_imp.g_varchar2_table(389) := '6F72293B0D0A7D0D0A2E612D43617264566965772D6D65646961207B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A7D0D0A2E612D43617264566965772D6D6564';
wwv_flow_imp.g_varchar2_table(390) := '69612061207B0D0A20207472616E736974696F6E3A206F70616369747920302E327320656173653B0D0A7D0D0A2E612D43617264566965772D6D6564696120613A666F637573207B0D0A20206F7061636974793A20302E353B0D0A7D0D0A2E612D436172';
wwv_flow_imp.g_varchar2_table(391) := '64566965772D6865616465723A6C6173742D6368696C64207B0D0A20202D2D612D63762D6865616465722D626F726465722D77696474683A203070783B0D0A7D0D0A2E6861732D6D656469612D2D6669727374207B0D0A20202D2D612D63762D6D656469';
wwv_flow_imp.g_varchar2_table(392) := '612D70616464696E672D793A20303B0D0A20202D2D612D63762D6D656469612D70616464696E672D783A20303B0D0A7D0D0A2E6861732D6D656469612D2D6261636B67726F756E64207B0D0A20202D2D612D63762D6D656469612D70616464696E672D79';
wwv_flow_imp.g_varchar2_table(393) := '3A203072656D3B0D0A20202D2D612D63762D6D656469612D70616464696E672D783A203072656D3B0D0A20202D2D612D63762D746578742D636F6C6F723A20236666663B0D0A20202D2D612D63762D7375627469746C652D746578742D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(394) := '72676261283235352C203235352C203235352C20302E3635293B0D0A20202D2D612D63762D737562636F6E74656E742D746578742D636F6C6F723A2072676261283235352C203235352C203235352C20302E3635293B0D0A20202D2D612D63762D626164';
wwv_flow_imp.g_varchar2_table(395) := '67652D6261636B67726F756E642D636F6C6F723A2072676261283235352C203235352C203235352C20302E3235293B0D0A7D0D0A2E6861732D6D656469612D2D6261636B67726F756E6420613A6E6F74285B636C6173735D29207B0D0A2020636F6C6F72';
wwv_flow_imp.g_varchar2_table(396) := '3A20696E68657269743B0D0A7D0D0A2E6861732D6D656469612D2D6261636B67726F756E6420613A6E6F74285B636C6173735D293A686F7665722C0D0A2E6861732D6D656469612D2D6261636B67726F756E6420613A6E6F74285B636C6173735D293A66';
wwv_flow_imp.g_varchar2_table(397) := '6F637573207B0D0A2020746578742D6465636F726174696F6E3A20756E6465726C696E653B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6541207B0D0A20202D2D612D63762D6F766572666C6F773A2068696464656E3B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(398) := '612D63762D6D656469612D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303235293B0D0A20202D2D612D63762D6D656469612D6F7665726C61792D636F6C6F723A207267626128302C20302C20302C20302E3735';
wwv_flow_imp.g_varchar2_table(399) := '293B0D0A20202D2D612D63762D6865616465722D626F726465722D77696474683A203070783B0D0A20202D2D612D63762D6865616465722D6261636B67726F756E642D636F6C6F723A20756E7365743B0D0A20202D2D612D63762D616374696F6E732D62';
wwv_flow_imp.g_varchar2_table(400) := '6F726465722D77696474683A203070783B0D0A20202D2D612D63762D616374696F6E732D6261636B67726F756E642D636F6C6F723A20756E7365743B0D0A20202D2D612D63762D69636F6E2D636F6E7461696E65722D73697A653A20322E3572656D3B0D';
wwv_flow_imp.g_varchar2_table(401) := '0A20202D2D612D63762D69636F6E2D73697A653A20312E323572656D3B0D0A20202D2D612D63762D69636F6E2D626F726465722D7261646975733A20302E3138373572656D3B0D0A20202D2D612D63762D69636F6E2D696D6167652D73697A653A207661';
wwv_flow_imp.g_varchar2_table(402) := '72282D2D612D63762D69636F6E2D636F6E7461696E65722D73697A65293B0D0A20202D2D612D63762D69636F6E2D696D6167652D626F726465722D7261646975733A20766172282D2D612D63762D69636F6E2D626F726465722D726164697573293B0D0A';
wwv_flow_imp.g_varchar2_table(403) := '20202D2D612D63762D696E697469616C732D626F726465722D7261646975733A20766172282D2D612D63762D69636F6E2D626F726465722D726164697573293B0D0A20202D2D612D63762D696E697469616C732D73697A653A20766172282D2D612D6376';
wwv_flow_imp.g_varchar2_table(404) := '2D69636F6E2D636F6E7461696E65722D73697A65293B0D0A20202D2D612D63762D696E697469616C732D666F6E742D73697A653A20312E323572656D3B0D0A20202D2D612D63762D696E697469616C732D666F6E742D7765696768743A203430303B0D0A';
wwv_flow_imp.g_varchar2_table(405) := '20202D2D612D63762D62616467652D70616464696E673A20302E323572656D20302E3572656D3B0D0A20202D2D612D63762D62616467652D626F726465722D7261646975733A20312E323572656D3B0D0A7D0D0A2E742D4361726473526567696F6E2D2D';
wwv_flow_imp.g_varchar2_table(406) := '7374796C6541202E6861732D6D656469612D2D626F64792C0D0A2E742D4361726473526567696F6E2D2D7374796C6541202E6861732D6D656469612D2D6669727374207B0D0A20202D2D612D63762D6D656469612D626F726465722D7261646975733A20';
wwv_flow_imp.g_varchar2_table(407) := '302E3138373572656D3B0D0A20202D2D612D63762D6D656469612D70616464696E672D793A203172656D3B0D0A20202D2D612D63762D6D656469612D70616464696E672D783A203172656D3B0D0A7D0D0A2E742D4361726473526567696F6E2D2D737479';
wwv_flow_imp.g_varchar2_table(408) := '6C6541202E6861732D6D656469612D2D626F6479202E612D43617264566965772D6D656469612C0D0A2E742D4361726473526567696F6E2D2D7374796C6541202E6861732D6D656469612D2D6669727374202E612D43617264566965772D6D6564696120';
wwv_flow_imp.g_varchar2_table(409) := '7B0D0A20206D617267696E2D696E6C696E652D73746172743A20766172282D2D612D63762D6D656469612D70616464696E672D78293B0D0A20206D617267696E2D696E6C696E652D656E643A20766172282D2D612D63762D6D656469612D70616464696E';
wwv_flow_imp.g_varchar2_table(410) := '672D78293B0D0A202070616464696E673A20303B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6541202E6861732D6D656469612D2D6669727374202E612D43617264566965772D6D65646961207B0D0A20206D617267696E2D626C6F63';
wwv_flow_imp.g_varchar2_table(411) := '6B2D73746172743A20766172282D2D612D63762D6D656469612D70616464696E672D79293B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6541202E6861732D69636F6E2D2D746F70207B0D0A20202D2D612D63762D69636F6E2D636F6E';
wwv_flow_imp.g_varchar2_table(412) := '7461696E65722D73697A653A203672656D3B0D0A20202D2D612D63762D69636F6E2D73697A653A203372656D3B0D0A20202D2D612D63762D69636F6E2D626F726465722D7261646975733A20302E3572656D3B0D0A20202D2D612D63762D69636F6E2D69';
wwv_flow_imp.g_varchar2_table(413) := '6D6167652D73697A653A20766172282D2D612D63762D69636F6E2D636F6E7461696E65722D73697A65293B0D0A20202D2D612D63762D69636F6E2D696D6167652D626F726465722D7261646975733A20766172282D2D612D63762D69636F6E2D626F7264';
wwv_flow_imp.g_varchar2_table(414) := '65722D726164697573293B0D0A20202D2D612D63762D696E697469616C732D626F726465722D7261646975733A20766172282D2D612D63762D69636F6E2D626F726465722D726164697573293B0D0A20202D2D612D63762D696E697469616C732D73697A';
wwv_flow_imp.g_varchar2_table(415) := '653A20766172282D2D612D63762D69636F6E2D636F6E7461696E65722D73697A65293B0D0A20202D2D612D63762D696E697469616C732D666F6E742D73697A653A20312E3572656D3B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6541';
wwv_flow_imp.g_varchar2_table(416) := '202E6861732D6D656469612D2D6669727374202E612D43617264566965772D686561646572202B202E612D43617264566965772D626F64792C0D0A2E742D4361726473526567696F6E2D2D7374796C6541202E6861732D6D656469612D2D6261636B6772';
wwv_flow_imp.g_varchar2_table(417) := '6F756E64202E612D43617264566965772D686561646572202B202E612D43617264566965772D626F64792C0D0A2E742D4361726473526567696F6E2D2D7374796C6541202E612D43617264566965772D626F6479202B202E612D43617264566965772D61';
wwv_flow_imp.g_varchar2_table(418) := '6374696F6E73207B0D0A202070616464696E672D626C6F636B2D73746172743A20303B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6541202E612D43617264566965772D6974656D732D2D726F77202E742D4361726473526567696F6E';
wwv_flow_imp.g_varchar2_table(419) := '2D2D7374796C6541202E612D43617264566965772D616374696F6E73207B0D0A2020666C65782D646972656374696F6E3A20636F6C756D6E3B0D0A2020616C69676E2D6974656D733A20666C65782D656E643B0D0A2020677269642D636F6C756D6E3A20';
wwv_flow_imp.g_varchar2_table(420) := '343B0D0A2020677269642D726F772D73746172743A20313B0D0A2020677269642D726F772D656E643A20343B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6541202E612D43617264566965772D6974656D732D2D726F77202E612D4361';
wwv_flow_imp.g_varchar2_table(421) := '7264566965772D6D65646961207B0D0A20206D617267696E2D626C6F636B2D73746172743A20766172282D2D612D63762D6D656469612D70616464696E672D79293B0D0A20206D617267696E2D626C6F636B2D656E643A20766172282D2D612D63762D6D';
wwv_flow_imp.g_varchar2_table(422) := '656469612D70616464696E672D79293B0D0A20206D617267696E2D696E6C696E652D656E643A20303B0D0A7D0D0A2E752D52544C202E742D4361726473526567696F6E2D2D7374796C6541202E612D43617264566965772D6974656D732D2D726F77202E';
wwv_flow_imp.g_varchar2_table(423) := '612D43617264566965772D6D65646961207B0D0A20206D617267696E2D696E6C696E652D656E643A20766172282D2D612D63762D6D656469612D70616464696E672D78293B0D0A20206D617267696E2D696E6C696E652D73746172743A20303B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(424) := '0A2E742D4361726473526567696F6E2D2D7374796C6542207B0D0A20202D2D612D63762D6F766572666C6F773A2068696464656E3B0D0A20202D2D612D63762D6D656469612D6261636B67726F756E642D636F6C6F723A207267626128302C20302C2030';
wwv_flow_imp.g_varchar2_table(425) := '2C20302E303235293B0D0A20202D2D612D63762D6D656469612D6F7665726C61792D636F6C6F723A207267626128302C20302C20302C20302E3735293B0D0A20202D2D612D63762D69636F6E2D636F6E7461696E65722D73697A653A203472656D3B0D0A';
wwv_flow_imp.g_varchar2_table(426) := '20202D2D612D63762D69636F6E2D73697A653A203272656D3B0D0A20202D2D612D63762D69636F6E2D626F726465722D7261646975733A20302E323572656D3B0D0A20202D2D612D63762D69636F6E2D696D6167652D73697A653A20766172282D2D612D';
wwv_flow_imp.g_varchar2_table(427) := '63762D69636F6E2D636F6E7461696E65722D73697A65293B0D0A20202D2D612D63762D69636F6E2D696D6167652D626F726465722D7261646975733A20766172282D2D612D63762D69636F6E2D626F726465722D726164697573293B0D0A20202D2D612D';
wwv_flow_imp.g_varchar2_table(428) := '63762D696E697469616C732D626F726465722D7261646975733A20766172282D2D612D63762D69636F6E2D626F726465722D726164697573293B0D0A20202D2D612D63762D696E697469616C732D73697A653A20766172282D2D612D63762D69636F6E2D';
wwv_flow_imp.g_varchar2_table(429) := '636F6E7461696E65722D73697A65293B0D0A20202D2D612D63762D696E697469616C732D666F6E742D73697A653A203272656D3B0D0A20202D2D612D63762D696E697469616C732D666F6E742D7765696768743A203430303B0D0A20202D2D612D63762D';
wwv_flow_imp.g_varchar2_table(430) := '6D656469612D70616464696E672D793A203072656D3B0D0A20202D2D612D63762D6D656469612D70616464696E672D783A203072656D3B0D0A20202D2D612D63762D6865616465722D626F726465722D77696474683A203070783B0D0A20202D2D612D63';
wwv_flow_imp.g_varchar2_table(431) := '762D6865616465722D6261636B67726F756E642D636F6C6F723A20756E7365743B0D0A20202D2D612D63762D616374696F6E732D626F726465722D77696474683A203070783B0D0A20202D2D612D63762D616374696F6E732D6261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(432) := '636F6C6F723A20756E7365743B0D0A20202D2D612D63762D7469746C652D666F6E742D73697A653A20312E323572656D3B0D0A20202D2D612D63762D7469746C652D6C696E652D6865696768743A20312E373572656D3B0D0A20202D2D612D63762D6261';
wwv_flow_imp.g_varchar2_table(433) := '6467652D70616464696E673A20302E323572656D20302E373572656D3B0D0A20202D2D612D63762D62616467652D626F726465722D7261646975733A20312E323572656D3B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E6861';
wwv_flow_imp.g_varchar2_table(434) := '732D69636F6E2D2D746F70207B0D0A20202D2D612D63762D69636F6E2D636F6E7461696E65722D73697A653A203772656D3B0D0A20202D2D612D63762D69636F6E2D73697A653A203272656D3B0D0A20202D2D612D63762D69636F6E2D626F726465722D';
wwv_flow_imp.g_varchar2_table(435) := '7261646975733A20302E323572656D3B0D0A20202D2D612D63762D69636F6E2D696D6167652D73697A653A20766172282D2D612D63762D69636F6E2D636F6E7461696E65722D73697A65293B0D0A20202D2D612D63762D69636F6E2D696D6167652D626F';
wwv_flow_imp.g_varchar2_table(436) := '726465722D7261646975733A20766172282D2D612D63762D69636F6E2D626F726465722D726164697573293B0D0A20202D2D612D63762D696E697469616C732D626F726465722D7261646975733A20766172282D2D612D63762D69636F6E2D626F726465';
wwv_flow_imp.g_varchar2_table(437) := '722D726164697573293B0D0A20202D2D612D63762D696E697469616C732D73697A653A20766172282D2D612D63762D69636F6E2D636F6E7461696E65722D73697A65293B0D0A20202D2D612D63762D696E697469616C732D666F6E742D73697A653A2032';
wwv_flow_imp.g_varchar2_table(438) := '72656D3B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E6861732D69636F6E2D2D746F70202E612D43617264566965772D69636F6E57726170207B0D0A20206D617267696E2D696E6C696E652D73746172743A2063616C632876';
wwv_flow_imp.g_varchar2_table(439) := '6172282D2D612D63762D6865616465722D70616464696E672D7829202A202D31293B0D0A20206D617267696E2D696E6C696E652D656E643A2063616C6328766172282D2D612D63762D6865616465722D70616464696E672D7829202A202D31293B0D0A20';
wwv_flow_imp.g_varchar2_table(440) := '206D617267696E2D626C6F636B2D73746172743A2063616C6328766172282D2D612D63762D6865616465722D70616464696E672D7929202A202D31293B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E6861732D69636F6E2D2D';
wwv_flow_imp.g_varchar2_table(441) := '746F70202E612D43617264566965772D69636F6E57726170202E612D43617264566965772D696E697469616C732C0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E6861732D69636F6E2D2D746F70202E612D43617264566965772D6963';
wwv_flow_imp.g_varchar2_table(442) := '6F6E57726170202E612D43617264566965772D69636F6E2C0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E6861732D69636F6E2D2D746F70202E612D43617264566965772D69636F6E57726170202E612D43617264566965772D69636F';
wwv_flow_imp.g_varchar2_table(443) := '6E496D67207B0D0A202077696474683A20313030253B0D0A2020626F726465722D7261646975733A20303B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E6861732D69636F6E2D2D746F70202E612D43617264566965772D6963';
wwv_flow_imp.g_varchar2_table(444) := '6F6E3A6265666F7265207B0D0A2020626F726465722D7261646975733A20313030253B0D0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E31293B0D0A2020746578742D736861646F773A2030203170782031';
wwv_flow_imp.g_varchar2_table(445) := '7078207267626128302C20302C20302C20302E31293B0D0A20206D617267696E3A206175746F3B0D0A202070616464696E673A2063616C6328766172282D2D612D63762D69636F6E2D73697A6529202F2032293B0D0A7D0D0A2E742D4361726473526567';
wwv_flow_imp.g_varchar2_table(446) := '696F6E2D2D7374796C6542202E6861732D69636F6E2D2D7374617274202E612D43617264566965772D69636F6E57726170207B0D0A20206D617267696E2D626C6F636B2D656E643A20766172282D2D612D63762D6865616465722D6974656D2D73706163';
wwv_flow_imp.g_varchar2_table(447) := '696E672D782C20302E373572656D293B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E6861732D69636F6E2D2D656E64202E612D43617264566965772D69636F6E57726170207B0D0A20206D617267696E2D626C6F636B2D7374';
wwv_flow_imp.g_varchar2_table(448) := '6172743A20766172282D2D612D63762D6865616465722D6974656D2D73706163696E672D782C20302E373572656D293B0D0A2020677269642D617265613A2062616467652D626F74746F6D3B0D0A7D0D0A2E742D4361726473526567696F6E2D2D737479';
wwv_flow_imp.g_varchar2_table(449) := '6C6542202E6861732D69636F6E2D2D656E64202E612D43617264566965772D686561646572426F6479207B0D0A2020677269642D617265613A2069636F6E2D746F703B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E6861732D';
wwv_flow_imp.g_varchar2_table(450) := '69636F6E2D2D656E64202E612D43617264566965772D6261646765207B0D0A2020677269642D617265613A20626F64793B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E612D43617264566965772D69636F6E57726170207B0D';
wwv_flow_imp.g_varchar2_table(451) := '0A2020677269642D617265613A2069636F6E2D746F703B0D0A20206D617267696E2D696E6C696E652D656E643A20756E7365743B0D0A20206D617267696E2D696E6C696E652D73746172743A20756E7365743B0D0A2020646973706C61793A20666C6578';
wwv_flow_imp.g_varchar2_table(452) := '3B0D0A20206A7573746966792D636F6E74656E743A2063656E7465723B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E612D43617264566965772D686561646572426F6479207B0D0A2020746578742D616C69676E3A2063656E';
wwv_flow_imp.g_varchar2_table(453) := '7465723B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E612D43617264566965772D6261646765207B0D0A20206D617267696E2D696E6C696E652D73746172743A206175746F3B0D0A20206D617267696E2D696E6C696E652D65';
wwv_flow_imp.g_varchar2_table(454) := '6E643A206175746F3B0D0A2020677269642D617265613A2062616467652D626F74746F6D3B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E612D43617264566965772D62616467653A6E6F74283A66697273742D6368696C6429';
wwv_flow_imp.g_varchar2_table(455) := '207B0D0A20206D617267696E2D626C6F636B2D73746172743A20766172282D2D612D63762D6865616465722D6974656D2D73706163696E672D782C20302E373572656D293B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E612D';
wwv_flow_imp.g_varchar2_table(456) := '43617264566965772D62616467654C6162656C207B0D0A2020626F726465723A20756E7365743B0D0A2020636C69703A20756E7365743B0D0A2020636C69702D706174683A20756E7365743B0D0A20206865696768743A20756E7365743B0D0A20206D61';
wwv_flow_imp.g_varchar2_table(457) := '7267696E3A20756E7365743B0D0A20206F766572666C6F773A20756E7365743B0D0A202070616464696E673A20756E7365743B0D0A2020706F736974696F6E3A20756E7365743B0D0A202077696474683A20756E7365743B0D0A7D0D0A2E742D43617264';
wwv_flow_imp.g_varchar2_table(458) := '73526567696F6E2D2D7374796C6542202E612D43617264566965772D616374696F6E73207B0D0A2020666C65782D646972656374696F6E3A20636F6C756D6E3B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E612D4361726456';
wwv_flow_imp.g_varchar2_table(459) := '6965772D616374696F6E735072696D617279202E612D43617264566965772D627574746F6E207B0D0A202077696474683A20313030253B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E612D43617264566965772D616374696F';
wwv_flow_imp.g_varchar2_table(460) := '6E735072696D617279202E612D43617264566965772D627574746F6E202B202E612D43617264566965772D627574746F6E207B0D0A20206D617267696E2D626C6F636B2D73746172743A20302E323572656D3B0D0A7D0D0A2E742D436172647352656769';
wwv_flow_imp.g_varchar2_table(461) := '6F6E2D2D7374796C6542202E612D43617264566965772D616374696F6E735365636F6E64617279207B0D0A2020746578742D616C69676E3A2063656E7465723B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6542202E612D4361726456';
wwv_flow_imp.g_varchar2_table(462) := '6965772D616374696F6E735365636F6E646172793A6E6F74283A6F6E6C792D6368696C6429207B0D0A20206D617267696E2D626C6F636B2D73746172743A20302E3572656D3B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6543207B0D';
wwv_flow_imp.g_varchar2_table(463) := '0A20202D2D612D63762D6F766572666C6F773A2068696464656E3B0D0A20202D2D612D63762D6D656469612D6261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E303235293B0D0A20202D2D612D63762D6D656469612D';
wwv_flow_imp.g_varchar2_table(464) := '6F7665726C61792D636F6C6F723A207267626128302C20302C20302C20302E3735293B0D0A20202D2D612D63762D6D656469612D70616464696E672D793A203072656D3B0D0A20202D2D612D63762D6D656469612D70616464696E672D783A203072656D';
wwv_flow_imp.g_varchar2_table(465) := '3B0D0A20202D2D612D63762D6865616465722D626F726465722D77696474683A203070783B0D0A20202D2D612D63762D6865616465722D6261636B67726F756E642D636F6C6F723A20756E7365743B0D0A20202D2D612D63762D616374696F6E732D626F';
wwv_flow_imp.g_varchar2_table(466) := '726465722D77696474683A203070783B0D0A20202D2D612D63762D616374696F6E732D6261636B67726F756E642D636F6C6F723A20756E7365743B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E6861732D7469746C652E6861';
wwv_flow_imp.g_varchar2_table(467) := '732D626F64793A6E6F74282E6861732D6D656469612D2D626F647929202E612D43617264566965772D626F64792C0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E6861732D7469746C652E6861732D7365636F6E646172793A6E6F7428';
wwv_flow_imp.g_varchar2_table(468) := '2E6861732D6D656469612D2D626F647929202E612D43617264566965772D626F64792C0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E6861732D7375627469746C652E6861732D626F64793A6E6F74282E6861732D6D656469612D2D62';
wwv_flow_imp.g_varchar2_table(469) := '6F647929202E612D43617264566965772D626F64792C0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E6861732D7375627469746C652E6861732D7365636F6E646172793A6E6F74282E6861732D6D656469612D2D626F647929202E612D';
wwv_flow_imp.g_varchar2_table(470) := '43617264566965772D626F64792C0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E6861732D69636F6E2E6861732D626F64793A6E6F74282E6861732D6D656469612D2D626F647929202E612D43617264566965772D626F64792C0D0A2E';
wwv_flow_imp.g_varchar2_table(471) := '742D4361726473526567696F6E2D2D7374796C6543202E6861732D69636F6E2E6861732D7365636F6E646172793A6E6F74282E6861732D6D656469612D2D626F647929202E612D43617264566965772D626F64792C0D0A2E742D4361726473526567696F';
wwv_flow_imp.g_varchar2_table(472) := '6E2D2D7374796C6543202E6861732D62616467652E6861732D626F64793A6E6F74282E6861732D6D656469612D2D626F647929202E612D43617264566965772D626F64792C0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E6861732D62';
wwv_flow_imp.g_varchar2_table(473) := '616467652E6861732D7365636F6E646172793A6E6F74282E6861732D6D656469612D2D626F647929202E612D43617264566965772D626F6479207B0D0A202070616464696E672D626C6F636B2D73746172743A20303B0D0A7D0D0A406D6564696120286D';
wwv_flow_imp.g_varchar2_table(474) := '61782D77696474683A20373637707829207B0D0A20202E742D4361726473526567696F6E2D2D7374796C6543202E612D43617264566965772D6974656D732D2D726F77202E612D4361726456696577207B0D0A20202020646973706C61793A20666C6578';
wwv_flow_imp.g_varchar2_table(475) := '3B0D0A20207D0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E612D43617264566965772D6974656D732D2D726F77202E6861732D69636F6E2D2D7374617274202E612D43617264566965772D626F6479207B0D0A202067726964';
wwv_flow_imp.g_varchar2_table(476) := '2D636F6C756D6E2D73746172743A20323B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E612D43617264566965772D6974656D732D2D726F77202E6861732D6D656469612D2D6669727374202E612D43617264566965772D626F';
wwv_flow_imp.g_varchar2_table(477) := '6479207B0D0A2020677269642D636F6C756D6E2D73746172743A20323B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E612D43617264566965772D6974656D732D2D726F77202E6861732D6D656469612D2D66697273742E6861';
wwv_flow_imp.g_varchar2_table(478) := '732D69636F6E2D2D7374617274202E612D43617264566965772D626F6479207B0D0A2020677269642D636F6C756D6E2D73746172743A20333B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E612D43617264566965772D697465';
wwv_flow_imp.g_varchar2_table(479) := '6D732D2D726F77202E612D43617264566965772D616374696F6E73207B0D0A2020666C65782D646972656374696F6E3A20636F6C756D6E3B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A2020677269642D636F6C756D6E3A20343B0D';
wwv_flow_imp.g_varchar2_table(480) := '0A2020677269642D726F772D73746172743A20313B0D0A2020677269642D726F772D656E643A20323B0D0A2020616C69676E2D73656C663A2063656E7465723B0D0A7D0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E612D4361726456';
wwv_flow_imp.g_varchar2_table(481) := '6965772D6974656D732D2D726F77202E6861732D626F6479202E612D43617264566965772D616374696F6E73207B0D0A2020616C69676E2D6974656D733A20666C65782D656E643B0D0A2020677269642D726F772D656E643A20343B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(482) := '4361726473526567696F6E2D2D7374796C6543202E612D43617264566965772D6974656D732D2D726F77202E612D43617264566965773A6E6F74282E6861732D69636F6E292C0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E612D4361';
wwv_flow_imp.g_varchar2_table(483) := '7264566965772D6974656D732D2D726F77202E6861732D69636F6E2D2D746F702C0D0A2E742D4361726473526567696F6E2D2D7374796C6543202E612D43617264566965772D6974656D732D2D726F77202E6861732D69636F6E2D2D656E64207B0D0A20';
wwv_flow_imp.g_varchar2_table(484) := '202D2D612D63762D69636F6E2D7370616365723A203072656D3B0D0A7D0D0A406D6564696120286D61782D77696474683A20373637707829207B0D0A20202E742D4361726473526567696F6E2D2D7374796C6543202E612D43617264566965772D697465';
wwv_flow_imp.g_varchar2_table(485) := '6D732D2D726F77202E6861732D6D65646961207B0D0A20202020677269642D74656D706C6174652D636F6C756D6E733A206D696E6D617828312E323572656D2C203572656D29206D696E6D617828302C20766172282D2D612D63762D69636F6E2D737061';
wwv_flow_imp.g_varchar2_table(486) := '6365722C20322E373572656D292920316672206D696E6D617828302C206175746F293B0D0A20207D0D0A7D0D0A2E742D466F726D2D2D6C617267652C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D6C61726765207B0D0A20202D2D75';
wwv_flow_imp.g_varchar2_table(487) := '742D6669656C642D6C6162656C2D666F6E742D73697A653A20302E38373572656D3B0D0A20202D2D75742D6669656C642D6C6162656C2D70616464696E672D793A20302E3572656D3B0D0A20202D2D612D6669656C642D696E7075742D666F6E742D7369';
wwv_flow_imp.g_varchar2_table(488) := '7A653A20302E38373572656D3B0D0A20202D2D612D6669656C642D696E7075742D70616464696E672D793A20302E3572656D3B0D0A20202D2D612D6669656C642D696E7075742D70616464696E672D783A20302E3572656D3B0D0A20202D2D75742D6669';
wwv_flow_imp.g_varchar2_table(489) := '656C642D696E7075742D69636F6E2D70616464696E672D783A20302E3572656D3B0D0A20202D2D75742D6669656C642D696E7075742D69636F6E2D70616464696E672D793A20302E3572656D3B0D0A20202D2D612D636865636B626F782D73697A653A20';
wwv_flow_imp.g_varchar2_table(490) := '312E323572656D3B0D0A20202D2D612D636865636B626F782D69636F6E2D73697A653A20312E31323572656D3B0D0A20202D2D612D636865636B626F782D6C6162656C2D666F6E742D73697A653A20302E38373572656D3B0D0A20202D2D612D63686563';
wwv_flow_imp.g_varchar2_table(491) := '6B626F782D6C6162656C2D6C696E652D6865696768743A20312E323572656D3B0D0A20202D2D75742D70696C6C627574746F6E2D70616464696E672D793A20302E3572656D3B0D0A20202D2D75742D70696C6C627574746F6E2D70616464696E672D783A';
wwv_flow_imp.g_varchar2_table(492) := '20302E373572656D3B0D0A20202D2D75742D70696C6C627574746F6E2D666F6E742D73697A653A20302E373572656D3B0D0A20202D2D75742D70696C6C627574746F6E2D6C696E652D6865696768743A203172656D3B0D0A20202D2D75742D70696C6C62';
wwv_flow_imp.g_varchar2_table(493) := '7574746F6E2D636865636B626F782D6F66667365743A20302E33373572656D3B0D0A20202D2D75742D70696C6C627574746F6E2D636865636B626F782D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D706F7075706C6F762D63686970';
wwv_flow_imp.g_varchar2_table(494) := '2D6D617267696E2D783A20302E31323572656D3B0D0A20202D2D612D706F7075706C6F762D636869702D6D617267696E2D793A20302E31323572656D3B0D0A20202D2D612D706F7075706C6F762D636869702D666F6E742D73697A653A20302E38373572';
wwv_flow_imp.g_varchar2_table(495) := '656D3B0D0A20202D2D612D706F7075706C6F762D636869702D6C696E652D6865696768743A20312E323572656D3B0D0A20202D2D612D706F7075706C6F762D636869702D70616464696E672D793A20302E31323572656D3B0D0A20202D2D612D706F7075';
wwv_flow_imp.g_varchar2_table(496) := '706C6F762D636869702D70616464696E672D783A20302E33373572656D3B0D0A20202D2D612D7377697463682D77696474683A20332E373572656D3B0D0A20202D2D612D7377697463682D70616464696E672D793A20302E3138373572656D3B0D0A2020';
wwv_flow_imp.g_varchar2_table(497) := '2D2D612D7377697463682D70616464696E672D783A20302E3138373572656D3B0D0A20202D2D612D7377697463682D746F67676C652D77696474683A20312E36323572656D3B0D0A20202D2D612D7377697463682D746F67676C652D6865696768743A20';
wwv_flow_imp.g_varchar2_table(498) := '312E36323572656D3B0D0A7D0D0A2E742D466F726D2D2D6C61726765202E742D466F726D2D6974656D546578742C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D6C61726765202E742D466F726D2D6974656D54657874207B0D0A2020';
wwv_flow_imp.g_varchar2_table(499) := '6C696E652D6865696768743A203272656D3B0D0A2020666F6E742D73697A653A20302E38373572656D3B0D0A7D0D0A2E742D466F726D2D2D6C61726765202E617065782D6974656D2D69636F6E2C0D0A2E742D466F726D2D6669656C64436F6E7461696E';
wwv_flow_imp.g_varchar2_table(500) := '65722D2D6C61726765202E617065782D6974656D2D69636F6E2C0D0A2E742D466F726D2D2D6C617267652E617065782D6974656D2D777261707065722D2D636F6C6F722D7069636B65722C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D';
wwv_flow_imp.g_varchar2_table(501) := '2D6C617267652E617065782D6974656D2D777261707065722D2D636F6C6F722D7069636B6572207B0D0A20202D2D612D69636F6E2D70616464696E673A20302E3572656D3B0D0A7D0D0A2E742D466F726D2D2D6C617267652E617065782D6974656D2D77';
wwv_flow_imp.g_varchar2_table(502) := '7261707065722D2D636F6C6F722D7069636B65722C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D6C617267652E617065782D6974656D2D777261707065722D2D636F6C6F722D7069636B6572207B0D0A20202D2D612D69636F6E2D73';
wwv_flow_imp.g_varchar2_table(503) := '697A653A20312E323572656D3B0D0A20202D2D612D6974656D2D69636F6E2D6F66667365743A2063616C6328766172282D2D612D69636F6E2D73697A652C203172656D29202B20766172282D2D612D69636F6E2D70616464696E6729293B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(504) := '742D466F726D2D2D6C61726765202E617065782D6974656D2D67726F75702D2D636F6C6F722D7069636B6572202E612D427574746F6E2D2D636F6C6F725069636B65724F6E6C792C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D6C61';
wwv_flow_imp.g_varchar2_table(505) := '726765202E617065782D6974656D2D67726F75702D2D636F6C6F722D7069636B6572202E612D427574746F6E2D2D636F6C6F725069636B65724F6E6C79207B0D0A20202D2D612D636F6C6F722D7069636B65722D636F6C6F722D6F6E6C792D6865696768';
wwv_flow_imp.g_varchar2_table(506) := '743A203172656D3B0D0A20202D2D612D636F6C6F722D7069636B65722D636F6C6F722D6F6E6C792D77696474683A203272656D3B0D0A20202D2D612D627574746F6E2D70616464696E673A20302E3572656D3B0D0A7D0D0A2E742D466F726D2D2D6C6172';
wwv_flow_imp.g_varchar2_table(507) := '67652E617065782D6974656D2D777261707065722D2D6861732D69636F6E2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D6C617267652E617065782D6974656D2D777261707065722D2D6861732D69636F6E207B0D0A20202D2D612D';
wwv_flow_imp.g_varchar2_table(508) := '69636F6E2D70616464696E673A20302E3572656D3B0D0A20202D2D612D6974656D2D69636F6E2D6F66667365743A2063616C6328766172282D2D612D69636F6E2D73697A652C203172656D29202B20766172282D2D612D69636F6E2D70616464696E6729';
wwv_flow_imp.g_varchar2_table(509) := '293B0D0A7D0D0A2E742D466F726D2D2D6C61726765202E742D466F726D2D6974656D57726170706572202E612D427574746F6E2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D6C61726765202E742D466F726D2D6974656D57726170';
wwv_flow_imp.g_varchar2_table(510) := '706572202E612D427574746F6E2C0D0A2E742D466F726D2D2D6C61726765202E742D466F726D2D6974656D57726170706572202E6F6A2D696E7075746461746574696D652D696E7075742D747269676765722C0D0A2E742D466F726D2D6669656C64436F';
wwv_flow_imp.g_varchar2_table(511) := '6E7461696E65722D2D6C61726765202E742D466F726D2D6974656D57726170706572202E6F6A2D696E7075746461746574696D652D696E7075742D747269676765722C0D0A2E742D466F726D2D2D6C61726765202E742D466F726D2D6974656D57726170';
wwv_flow_imp.g_varchar2_table(512) := '706572202E742D466F726D2D68656C70427574746F6E2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D6C61726765202E742D466F726D2D6974656D57726170706572202E742D466F726D2D68656C70427574746F6E2C0D0A2E742D46';
wwv_flow_imp.g_varchar2_table(513) := '6F726D2D2D6C61726765202E617065782D6974656D2D66696C652D2D6E61746976653A3A2D7765626B69742D66696C652D75706C6F61642D627574746F6E2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D6C61726765202E61706578';
wwv_flow_imp.g_varchar2_table(514) := '2D6974656D2D66696C652D2D6E61746976653A3A2D7765626B69742D66696C652D75706C6F61642D627574746F6E207B0D0A20202D2D612D627574746F6E2D70616464696E672D793A20302E3572656D3B0D0A20202D2D612D627574746F6E2D70616464';
wwv_flow_imp.g_varchar2_table(515) := '696E672D783A20302E373572656D3B0D0A20202D2D612D69636F6E2D73697A653A203172656D3B0D0A7D0D0A2E742D466F726D2D2D6C61726765202E617065782D6974656D2D67726F75702D2D73687574746C652073656C6563742E73687574746C655F';
wwv_flow_imp.g_varchar2_table(516) := '6C6566742C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D6C61726765202E617065782D6974656D2D67726F75702D2D73687574746C652073656C6563742E73687574746C655F6C6566742C0D0A2E742D466F726D2D2D6C6172676520';
wwv_flow_imp.g_varchar2_table(517) := '2E617065782D6974656D2D67726F75702D2D73687574746C652073656C6563742E73687574746C655F72696768742C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D6C61726765202E617065782D6974656D2D67726F75702D2D736875';
wwv_flow_imp.g_varchar2_table(518) := '74746C652073656C6563742E73687574746C655F7269676874207B0D0A20206D696E2D6865696768743A2031312E323572656D3B0D0A7D0D0A2E742D466F726D2D2D786C617267652C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D78';
wwv_flow_imp.g_varchar2_table(519) := '6C61726765207B0D0A20202D2D75742D6669656C642D6C6162656C2D666F6E742D73697A653A203172656D3B0D0A20202D2D75742D6669656C642D6C6162656C2D70616464696E672D793A20302E373572656D3B0D0A20202D2D612D6669656C642D696E';
wwv_flow_imp.g_varchar2_table(520) := '7075742D666F6E742D73697A653A203172656D3B0D0A20202D2D612D6669656C642D696E7075742D6C696E652D6865696768743A20312E323572656D3B0D0A20202D2D612D6669656C642D696E7075742D70616464696E672D793A20302E36323572656D';
wwv_flow_imp.g_varchar2_table(521) := '3B0D0A20202D2D612D6669656C642D696E7075742D70616464696E672D783A20302E36323572656D3B0D0A20202D2D75742D6669656C642D696E7075742D69636F6E2D70616464696E672D783A20302E3572656D3B0D0A20202D2D75742D6669656C642D';
wwv_flow_imp.g_varchar2_table(522) := '696E7075742D69636F6E2D70616464696E672D793A20302E373572656D3B0D0A20202D2D612D636865636B626F782D73697A653A20312E3572656D3B0D0A20202D2D612D636865636B626F782D69636F6E2D73697A653A20312E31323572656D3B0D0A20';
wwv_flow_imp.g_varchar2_table(523) := '202D2D612D636865636B626F782D6C6162656C2D666F6E742D73697A653A203172656D3B0D0A20202D2D612D636865636B626F782D6C6162656C2D6C696E652D6865696768743A20312E3572656D3B0D0A20202D2D75742D70696C6C627574746F6E2D70';
wwv_flow_imp.g_varchar2_table(524) := '616464696E672D793A20302E373572656D3B0D0A20202D2D75742D70696C6C627574746F6E2D70616464696E672D783A20302E373572656D3B0D0A20202D2D75742D70696C6C627574746F6E2D666F6E742D73697A653A20302E38373572656D3B0D0A20';
wwv_flow_imp.g_varchar2_table(525) := '202D2D75742D70696C6C627574746F6E2D6C696E652D6865696768743A203172656D3B0D0A20202D2D75742D70696C6C627574746F6E2D636865636B626F782D6F66667365743A20302E3572656D3B0D0A20202D2D75742D70696C6C627574746F6E2D63';
wwv_flow_imp.g_varchar2_table(526) := '6865636B626F782D6C696E652D6865696768743A203172656D3B0D0A20202D2D612D706F7075706C6F762D636869702D6D617267696E2D783A20302E31323572656D3B0D0A20202D2D612D706F7075706C6F762D636869702D6D617267696E2D793A2030';
wwv_flow_imp.g_varchar2_table(527) := '2E31323572656D3B0D0A20202D2D612D706F7075706C6F762D636869702D666F6E742D73697A653A203172656D3B0D0A20202D2D612D706F7075706C6F762D636869702D6C696E652D6865696768743A20312E3572656D3B0D0A20202D2D612D706F7075';
wwv_flow_imp.g_varchar2_table(528) := '706C6F762D636869702D70616464696E672D793A20302E323572656D3B0D0A20202D2D612D706F7075706C6F762D636869702D70616464696E672D783A20302E3572656D3B0D0A20202D2D612D7377697463682D77696474683A20342E373572656D3B0D';
wwv_flow_imp.g_varchar2_table(529) := '0A20202D2D612D7377697463682D70616464696E672D793A20302E323572656D3B0D0A20202D2D612D7377697463682D70616464696E672D783A20302E323572656D3B0D0A20202D2D612D7377697463682D746F67676C652D77696474683A203272656D';
wwv_flow_imp.g_varchar2_table(530) := '3B0D0A20202D2D612D7377697463682D746F67676C652D6865696768743A203272656D3B0D0A7D0D0A2E742D466F726D2D2D786C61726765202E742D466F726D2D6974656D546578742C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D';
wwv_flow_imp.g_varchar2_table(531) := '786C61726765202E742D466F726D2D6974656D54657874207B0D0A20206C696E652D6865696768743A20322E3572656D3B0D0A2020666F6E742D73697A653A203172656D3B0D0A7D0D0A2E742D466F726D2D2D786C61726765202E617065782D6974656D';
wwv_flow_imp.g_varchar2_table(532) := '2D69636F6E2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D786C61726765202E617065782D6974656D2D69636F6E2C0D0A2E742D466F726D2D2D786C617267652E617065782D6974656D2D777261707065722D2D636F6C6F722D7069';
wwv_flow_imp.g_varchar2_table(533) := '636B65722C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D786C617267652E617065782D6974656D2D777261707065722D2D636F6C6F722D7069636B6572207B0D0A20202D2D612D69636F6E2D70616464696E673A20302E3572656D3B';
wwv_flow_imp.g_varchar2_table(534) := '0D0A7D0D0A2E742D466F726D2D2D786C617267652E617065782D6974656D2D777261707065722D2D636F6C6F722D7069636B65722C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D786C617267652E617065782D6974656D2D77726170';
wwv_flow_imp.g_varchar2_table(535) := '7065722D2D636F6C6F722D7069636B6572207B0D0A20202D2D612D69636F6E2D73697A653A20312E323572656D3B0D0A20202D2D612D6974656D2D69636F6E2D6F66667365743A2063616C6328766172282D2D612D69636F6E2D73697A652C203172656D';
wwv_flow_imp.g_varchar2_table(536) := '29202B20766172282D2D612D69636F6E2D70616464696E6729293B0D0A7D0D0A2E742D466F726D2D2D786C61726765202E617065782D6974656D2D67726F75702D2D636F6C6F722D7069636B6572202E612D427574746F6E2D2D636F6C6F725069636B65';
wwv_flow_imp.g_varchar2_table(537) := '724F6E6C792C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D786C61726765202E617065782D6974656D2D67726F75702D2D636F6C6F722D7069636B6572202E612D427574746F6E2D2D636F6C6F725069636B65724F6E6C79207B0D0A';
wwv_flow_imp.g_varchar2_table(538) := '20202D2D612D636F6C6F722D7069636B65722D636F6C6F722D6F6E6C792D6865696768743A20312E3572656D3B0D0A20202D2D612D636F6C6F722D7069636B65722D636F6C6F722D6F6E6C792D77696474683A203272656D3B0D0A20202D2D612D627574';
wwv_flow_imp.g_varchar2_table(539) := '746F6E2D70616464696E673A20302E3572656D3B0D0A7D0D0A2E742D466F726D2D2D786C61726765202E742D466F726D2D6974656D57726170706572202E612D427574746F6E2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D786C61';
wwv_flow_imp.g_varchar2_table(540) := '726765202E742D466F726D2D6974656D57726170706572202E612D427574746F6E2C0D0A2E742D466F726D2D2D786C61726765202E742D466F726D2D6974656D57726170706572202E6F6A2D696E7075746461746574696D652D696E7075742D74726967';
wwv_flow_imp.g_varchar2_table(541) := '6765722C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D786C61726765202E742D466F726D2D6974656D57726170706572202E6F6A2D696E7075746461746574696D652D696E7075742D747269676765722C0D0A2E742D466F726D2D2D';
wwv_flow_imp.g_varchar2_table(542) := '786C61726765202E742D466F726D2D6974656D57726170706572202E742D466F726D2D68656C70427574746F6E2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D786C61726765202E742D466F726D2D6974656D57726170706572202E';
wwv_flow_imp.g_varchar2_table(543) := '742D466F726D2D68656C70427574746F6E2C0D0A2E742D466F726D2D2D786C61726765202E617065782D6974656D2D66696C652D2D6E61746976653A3A2D7765626B69742D66696C652D75706C6F61642D627574746F6E2C0D0A2E742D466F726D2D6669';
wwv_flow_imp.g_varchar2_table(544) := '656C64436F6E7461696E65722D2D786C61726765202E617065782D6974656D2D66696C652D2D6E61746976653A3A2D7765626B69742D66696C652D75706C6F61642D627574746F6E207B0D0A20202D2D612D627574746F6E2D70616464696E672D793A20';
wwv_flow_imp.g_varchar2_table(545) := '302E3638373572656D3B0D0A20202D2D612D627574746F6E2D70616464696E672D783A20302E373572656D3B0D0A20202D2D612D69636F6E2D73697A653A203172656D3B0D0A7D0D0A2E742D466F726D2D2D786C617267652E617065782D6974656D2D77';
wwv_flow_imp.g_varchar2_table(546) := '7261707065722D2D6861732D69636F6E2C0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D786C617267652E617065782D6974656D2D777261707065722D2D6861732D69636F6E207B0D0A20202D2D612D69636F6E2D70616464696E673A';
wwv_flow_imp.g_varchar2_table(547) := '20302E3572656D3B0D0A20202D2D612D6974656D2D69636F6E2D6F66667365743A2063616C6328766172282D2D612D69636F6E2D73697A652C203172656D29202B20766172282D2D612D69636F6E2D70616464696E6729293B0D0A7D0D0A2E742D466F72';
wwv_flow_imp.g_varchar2_table(548) := '6D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C2E742D466F726D2D6669656C64436F6E7461696E65722D2D6C617267652C0D0A2E742D466F726D2D2D6C61726765202E742D466F726D2D6669656C64436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(549) := '2D2D666C6F6174696E674C6162656C207B0D0A20202D2D75742D6669656C642D6C6162656C2D666F6E742D73697A653A203172656D3B0D0A20202D2D612D6669656C642D696E7075742D70616464696E672D783A20302E373572656D3B0D0A20202D2D61';
wwv_flow_imp.g_varchar2_table(550) := '2D6669656C642D696E7075742D70616464696E672D793A20302E36323572656D3B0D0A20202D2D612D6669656C642D696E7075742D666F6E742D73697A653A203172656D3B0D0A20202D2D75742D6669656C642D666C2D6C6162656C2D6C696E652D6865';
wwv_flow_imp.g_varchar2_table(551) := '696768743A20312E323572656D3B0D0A20202D2D75742D6669656C642D666C2D6C6162656C2D666F6E742D73697A653A20302E373572656D3B0D0A7D0D0A2E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C2E';
wwv_flow_imp.g_varchar2_table(552) := '742D466F726D2D6669656C64436F6E7461696E65722D2D786C617267652C0D0A2E742D466F726D2D2D786C61726765202E742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C207B0D0A20202D2D75742D6669656C';
wwv_flow_imp.g_varchar2_table(553) := '642D6C6162656C2D666F6E742D73697A653A203172656D3B0D0A20202D2D612D6669656C642D696E7075742D70616464696E672D783A20302E373572656D3B0D0A20202D2D612D6669656C642D696E7075742D70616464696E672D793A20302E37357265';
wwv_flow_imp.g_varchar2_table(554) := '6D3B0D0A20202D2D612D6669656C642D696E7075742D666F6E742D73697A653A203172656D3B0D0A20202D2D75742D6669656C642D666C2D6C6162656C2D6C696E652D6865696768743A20312E33373572656D3B0D0A20202D2D75742D6669656C642D66';
wwv_flow_imp.g_varchar2_table(555) := '6C2D6C6162656C2D666F6E742D73697A653A20302E38373572656D3B0D0A20202D2D75742D6669656C642D696E7075742D69636F6E2D70616464696E672D783A20302E36323572656D3B0D0A7D0D0A2E726F2D636865636B626F782C0D0A2E752D636865';
wwv_flow_imp.g_varchar2_table(556) := '636B626F783A6265666F72652C0D0A2E752D726164696F3A6265666F7265207B0D0A20207472616E73666F726D2D6F726967696E3A2063656E7465722063656E7465723B0D0A20207472616E736974696F6E3A207472616E73666F726D20302E31323573';
wwv_flow_imp.g_varchar2_table(557) := '20656173652C206261636B67726F756E642D636F6C6F7220302E31357320656173652C20626F782D736861646F7720302E31357320656173652C20626F726465722D636F6C6F7220302E31357320656173653B0D0A7D0D0A2E726F2D636865636B626F78';
wwv_flow_imp.g_varchar2_table(558) := '3A6265666F72652C0D0A2E752D636865636B626F783A61667465722C0D0A2E752D726164696F3A6166746572207B0D0A20207472616E73666F726D2D6F726967696E3A2063656E7465722063656E7465723B0D0A20207472616E73666F726D3A20736361';
wwv_flow_imp.g_varchar2_table(559) := '6C652830293B0D0A20207472616E736974696F6E3A206F70616369747920302E31357320656173652C207472616E73666F726D20302E327320656173653B0D0A7D0D0A2E726F2D636865636B626F783A6163746976652C0D0A2E726F2D636865636B626F';
wwv_flow_imp.g_varchar2_table(560) := '783A6163746976653A6265666F72652C0D0A2E752D636865636B626F783A6163746976653A6265666F72652C0D0A2E752D636865636B626F783A6163746976653A61667465722C0D0A696E7075743A636865636B6564202B202E752D636865636B626F78';
wwv_flow_imp.g_varchar2_table(561) := '3A6163746976653A61667465722C0D0A2E752D726164696F3A6163746976653A6265666F72652C0D0A2E752D726164696F3A6163746976653A61667465722C0D0A696E7075743A636865636B6564202B202E752D726164696F3A6163746976653A616674';
wwv_flow_imp.g_varchar2_table(562) := '6572207B0D0A20207472616E73666F726D3A207363616C6528302E3735293B0D0A7D0D0A2E726F2D636865636B626F782E69732D636865636B65643A6265666F72652C0D0A2E752D636865636B626F782E69732D636865636B65643A61667465722C0D0A';
wwv_flow_imp.g_varchar2_table(563) := '696E7075743A636865636B6564202B202E752D636865636B626F783A61667465722C0D0A696E7075743A636865636B6564202B202E752D726164696F3A6166746572207B0D0A20207472616E73666F726D3A207363616C652831293B0D0A7D0D0A2E742D';
wwv_flow_imp.g_varchar2_table(564) := '4D6567614D656E75207B0D0A20202D2D612D6D656E752D666F63757365642D6261636B67726F756E642D636F6C6F723A207472616E73706172656E743B0D0A20202D2D612D6D656E752D666F63757365642D746578742D636F6C6F723A20696E69746961';
wwv_flow_imp.g_varchar2_table(565) := '6C3B0D0A7D0D0A2E742D4D6567614D656E752D6974656D426F64792E69732D666F6375736564202E742D4D6567614D656E752D6C6162656C2C0D0A2E742D4D6567614D656E752D6974656D426F64793A686F766572202E742D4D6567614D656E752D6C61';
wwv_flow_imp.g_varchar2_table(566) := '62656C207B0D0A2020636F6C6F723A20766172282D2D75742D6C696E6B2D746578742D636F6C6F72293B0D0A7D0D0A2E742D4865616465722D6E6176202E742D4865616465722D6E61762D6C697374207B0D0A20206261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(567) := '723A20766172282D2D612D6D656E756261722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E75426172207B0D0A2020626F782D736861646F773A20696E73657420302063616C6328766172';
wwv_flow_imp.g_varchar2_table(568) := '282D2D612D6D656E756261722D6974656D2D626F726465722D77696474682C2031707829202A202D3129203020766172282D2D612D6D656E756261722D6974656D2D626F726465722D636F6C6F72293B0D0A7D0D0A2E742D4865616465722D6E6176202E';
wwv_flow_imp.g_varchar2_table(569) := '612D4D656E754261722D6974656D207B0D0A2020626F726465722D746F702D77696474683A20303B0D0A2020626F726465722D626F74746F6D2D77696474683A20303B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D697465';
wwv_flow_imp.g_varchar2_table(570) := '6D3A666F6375732D77697468696E207B0D0A20206F75746C696E653A20766172282D2D75742D666F6375732D6F75746C696E652C206175746F2031707820766172282D2D75742D666F6375732D6F75746C696E652D636F6C6F722C202D7765626B69742D';
wwv_flow_imp.g_varchar2_table(571) := '666F6375732D72696E672D636F6C6F7229293B0D0A20206F75746C696E652D6F66667365743A202D3170783B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D202E612D4D656E754261722D6C6162656C207B0D0A20';
wwv_flow_imp.g_varchar2_table(572) := '206F75746C696E653A206E6F6E653B0D0A202077686974652D73706163653A206E6F777261703B0D0A20206D696E2D6865696768743A2063616C632863616C6328766172282D2D612D6D656E756261722D6974656D2D70616464696E672D792C20387078';
wwv_flow_imp.g_varchar2_table(573) := '29202A203229202B20766172282D2D612D6D656E756261722D6974656D2D6C696E652D6865696768742C203136707829293B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E752D2D73706C6974202E612D4D656E754261722D6C6162656C';
wwv_flow_imp.g_varchar2_table(574) := '207B0D0A202070616464696E672D696E6C696E652D656E643A20303B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E752D2D73706C6974202E612D4D656E752D7375624D656E75436F6C207B0D0A20202D2D612D6D656E752D69636F6E2D';
wwv_flow_imp.g_varchar2_table(575) := '73697A653A203172656D3B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E752D2D63757272656E74207B0D0A20202D2D612D6D656E756261722D6974656D2D666F6E742D7765696768743A20766172282D2D612D626173652D666F6E742D';
wwv_flow_imp.g_varchar2_table(576) := '7765696768742D626F6C642C20373030293B0D0A7D0D0A2E742D4865616465722D6E6176202E612D4D656E754261722D6974656D2E69732D666F6375736564207B0D0A20202D2D612D6D656E756261722D6974656D2D6261636B67726F756E642D636F6C';
wwv_flow_imp.g_varchar2_table(577) := '6F723A20766172282D2D612D6D656E756261722D6974656D2D666F63757365642D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D612D6D656E756261722D6974656D2D746578742D636F6C6F723A20766172282D2D612D6D656E756261722D';
wwv_flow_imp.g_varchar2_table(578) := '6974656D2D666F63757365642D746578742D636F6C6F72293B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742C0D0A2E742D';
wwv_flow_imp.g_varchar2_table(579) := '547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D73656C65637465642C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576';
wwv_flow_imp.g_varchar2_table(580) := '656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D73656C6563746564207B0D0A20206261636B67726F756E642D636F6C6F723A20233165323232353B0D0A7D0D0A2E742D547265654E6176202E612D547265';
wwv_flow_imp.g_varchar2_table(581) := '65566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C';
wwv_flow_imp.g_varchar2_table(582) := '61707369626C65203E202E612D54726565566965772D726F772C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C20756C207B0D0A20206261636B67726F756E642D636F6C6F723A20233137316131643B';
wwv_flow_imp.g_varchar2_table(583) := '0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D686F766572207B0D0A20206261636B67726F75';
wwv_flow_imp.g_varchar2_table(584) := '6E642D636F6C6F723A20233235323932642021696D706F7274616E743B0D0A7D0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D686F766572202B202E';
wwv_flow_imp.g_varchar2_table(585) := '612D54726565566965772D746F67676C652C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D686F766572202B202E612D54726565566965772D636F6E';
wwv_flow_imp.g_varchar2_table(586) := '74656E742C0D0A2E742D547265654E6176202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D686F766572202B202E612D54726565566965772D746F67676C65202B202E612D54726565';
wwv_flow_imp.g_varchar2_table(587) := '566965772D636F6E74656E74207B0D0A2020636F6C6F723A20766172282D2D612D74726565766965772D6E6F64652D73656C65637465642D746578742D636F6C6F72293B0D0A7D0D0A2E612D54726565566965772D636F6E74656E742E69732D73656C65';
wwv_flow_imp.g_varchar2_table(588) := '63746564203E202E6661207B0D0A20202D2D75742D74726565766965772D69636F6E2D6F7061636974793A20313B0D0A7D0D0A2E742D547265654E61762D2D7374796C65412C0D0A2E742D547265654E61762D2D7374796C6542207B0D0A20202D2D7574';
wwv_flow_imp.g_varchar2_table(589) := '2D74726565766965772D62616467652D626F726465722D7261646975733A20312E323572656D3B0D0A20202D2D75742D74726565766965772D62616467652D666F6E742D7765696768743A20766172282D2D612D626173652D666F6E742D776569676874';
wwv_flow_imp.g_varchar2_table(590) := '2D73656D69626F6C642C20353030293B0D0A20202D2D75742D74726565766965772D69636F6E2D73697A653A20312E323572656D3B0D0A20202D2D75742D74726565766965772D746F706C6576656C2D69636F6E2D636F6E7461696E65722D7769647468';
wwv_flow_imp.g_varchar2_table(591) := '3A20312E373572656D3B0D0A20202D2D75742D74726565766965772D6E6F64652D69636F6E2D73697A653A203172656D3B0D0A20202D2D75742D74726565766965772D6E6F64652D69636F6E2D636F6E7461696E65722D77696474683A20766172282D2D';
wwv_flow_imp.g_varchar2_table(592) := '75742D74726565766965772D746F706C6576656C2D69636F6E2D636F6E7461696E65722D77696474682C20312E373572656D293B0D0A20202D2D75742D74726565766965772D6E6F64652D696E64656E743A203072656D3B0D0A20202D2D75742D747265';
wwv_flow_imp.g_varchar2_table(593) := '65766965772D6C6561662D6E6F64652D696E64656E743A20302E36323572656D3B0D0A20202D2D75742D74726565766965772D746F706C6576656C2D6C6561662D70616464696E672D793A203072656D3B0D0A20202D2D612D74726565766965772D6E6F';
wwv_flow_imp.g_varchar2_table(594) := '64652D70616464696E672D793A20302E36323572656D3B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C20756C2C0D0A2E742D547265654E61762D2D7374796C6542202E61';
wwv_flow_imp.g_varchar2_table(595) := '2D54726565566965772D6E6F64652D2D746F704C6576656C20756C207B0D0A20202D2D612D74726565766965772D6E6F64652D70616464696E672D793A20302E373572656D3B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D547265';
wwv_flow_imp.g_varchar2_table(596) := '65566965772D6E6F64652D2D746F704C6576656C207B0D0A2020626F726465722D626F74746F6D3A2031707820736F6C69642072676261283235352C203235352C203235352C20302E31293B0D0A7D0D0A2E742D547265654E61762D2D7374796C654120';
wwv_flow_imp.g_varchar2_table(597) := '2E612D54726565566965772D6E6F64652D2D746F704C6576656C2E69732D636F6C6C61707369626C65207B0D0A2020636F6C6F723A20766172282D2D612D74726565766965772D6E6F64652D73656C65637465642D746578742D636F6C6F72293B0D0A7D';
wwv_flow_imp.g_varchar2_table(598) := '0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E742D547265654E61762D2D7374796C6541';
wwv_flow_imp.g_varchar2_table(599) := '202E612D54726565566965772D6E6F64652D2D746F704C6576656C20756C207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D612D74726565766965772D6E6F64652D73656C65637465642D6261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(600) := '72293B0D0A2020636F6C6F723A20766172282D2D612D74726565766965772D6E6F64652D73656C65637465642D746578742D636F6C6F72293B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D74';
wwv_flow_imp.g_varchar2_table(601) := '6F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F70202E612D54726565566965772D726F772E69732D73656C65637465642C0D0A2E742D547265654E61762D2D7374796C6541202E612D5472656556696577';
wwv_flow_imp.g_varchar2_table(602) := '2D6E6F64652D2D746F704C6576656C20756C202E612D54726565566965772D726F772E69732D73656C6563746564207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D75742D626F64792D6E61762D6261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(603) := '6F6C6F72293B0D0A2020636F6C6F723A20766172282D2D612D74726565766965772D6E6F64652D73656C65637465642D746578742D636F6C6F72293B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F6465';
wwv_flow_imp.g_varchar2_table(604) := '2D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D547265655669';
wwv_flow_imp.g_varchar2_table(605) := '65772D726F772E69732D63757272656E742D2D746F70207E20756C202E612D54726565566965772D726F77207B0D0A2020626F782D736861646F773A20696E73657420766172282D2D75742D70616C657474652D7072696D617279292034707820302030';
wwv_flow_imp.g_varchar2_table(606) := '3B0D0A7D0D0A2E752D52544C202E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E752D52544C20';
wwv_flow_imp.g_varchar2_table(607) := '2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F70207E20756C202E612D54726565566965772D726F77207B';
wwv_flow_imp.g_varchar2_table(608) := '0D0A2020626F782D736861646F773A20696E73657420766172282D2D75742D70616C657474652D7072696D61727929202D347078203020303B0D0A7D0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D74';
wwv_flow_imp.g_varchar2_table(609) := '6F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D666F63757365642C0D0A2E742D547265654E61762D2D7374796C6541202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E';
wwv_flow_imp.g_varchar2_table(610) := '612D54726565566965772D726F772E69732D63757272656E742D2D746F70207E20756C202E612D54726565566965772D726F772E69732D666F6375736564207B0D0A2020626F782D736861646F773A20696E73657420766172282D2D75742D70616C6574';
wwv_flow_imp.g_varchar2_table(611) := '74652D7072696D6172792920347078203020302C2030203020302031707820766172282D2D75742D70616C657474652D7072696D6172792920696E7365743B0D0A7D0D0A2E752D52544C202E742D547265654E61762D2D7374796C6541202E612D547265';
wwv_flow_imp.g_varchar2_table(612) := '65566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D666F63757365642C0D0A2E752D52544C202E742D547265654E61762D2D7374796C6541202E612D5472656556';
wwv_flow_imp.g_varchar2_table(613) := '6965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F70207E20756C202E612D54726565566965772D726F772E69732D666F6375736564207B0D0A2020626F782D736861646F773A20';
wwv_flow_imp.g_varchar2_table(614) := '696E73657420766172282D2D75742D70616C657474652D7072696D61727929202D347078203020302C2030203020302031707820766172282D2D75742D70616C657474652D7072696D6172792920696E7365743B0D0A7D0D0A2E742D547265654E61762D';
wwv_flow_imp.g_varchar2_table(615) := '2D7374796C6542203E20756C207B0D0A20207472616E736974696F6E3A206D617267696E20766172282D2D75742D6C61796F75742D7472616E736974696F6E2C20302E31732920656173653B0D0A20206D617267696E3A20302E323572656D3B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(616) := '0A4061742D726F6F74202E6A732D6E6176436F6C6C61707365642026207B0D0A20202D2D612D74726565766965772D6E6F64652D70616464696E672D793A20302E3572656D3B0D0A2020203E20756C207B0D0A202020206D617267696E3A20303B0D0A20';
wwv_flow_imp.g_varchar2_table(617) := '207D0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F6465207B0D0A20206D617267696E2D626C6F636B2D73746172743A20302E323572656D3B0D0A20206D617267696E2D626C6F636B2D656E643A20302E';
wwv_flow_imp.g_varchar2_table(618) := '323572656D3B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C207B0D0A20206D617267696E2D696E6C696E652D73746172743A20302E323572656D3B0D0A20206D61726769';
wwv_flow_imp.g_varchar2_table(619) := '6E2D696E6C696E652D656E643A20302E323572656D3B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C20756C207B0D0A20206261636B67726F756E642D636F6C6F723A2074';
wwv_flow_imp.g_varchar2_table(620) := '72616E73706172656E743B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702C0D0A2E742D54';
wwv_flow_imp.g_varchar2_table(621) := '7265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D73656C6563746564207B0D0A20206261636B67726F756E';
wwv_flow_imp.g_varchar2_table(622) := '642D636F6C6F723A20233035364143383B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E';
wwv_flow_imp.g_varchar2_table(623) := '69732D73656C6563746564202B202E612D54726565566965772D746F67676C652C0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D636F6E74656E74';
wwv_flow_imp.g_varchar2_table(624) := '2E69732D63757272656E742D2D746F70207B0D0A2020636F6C6F723A20236666666666663B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D';
wwv_flow_imp.g_varchar2_table(625) := '636F6E74656E742E69732D63757272656E742D2D746F702E69732D686F766572207B0D0A2020636F6C6F723A20236666666666662021696D706F7274616E743B0D0A7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D';
wwv_flow_imp.g_varchar2_table(626) := '6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F772E69732D63757272656E742D2D746F702E69732D686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20233035366463642021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(627) := '7D0D0A2E742D547265654E61762D2D7374796C6542202E612D54726565566965772D6E6F64652D2D746F704C6576656C202E612D54726565566965772D726F77207B0D0A2020626F726465722D7261646975733A20302E323572656D3B0D0A7D0D0A2E61';
wwv_flow_imp.g_varchar2_table(628) := '2D4952522D6469616C6F672D2D646F776E6C6F61642C0D0A2E612D4952522D6469616C6F672D2D737562736372697074696F6E207B0D0A20202D2D612D69636F6E6C6973742D6974656D2D6261636B67726F756E642D636F6C6F723A20766172282D2D75';
wwv_flow_imp.g_varchar2_table(629) := '742D636F6D706F6E656E742D746F6F6C6261722D6261636B67726F756E642D636F6C6F722C207267626128302C20302C20302C20302E30323529293B0D0A20202D2D612D69636F6E6C6973742D6974656D2D746578742D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(630) := '75742D636F6D706F6E656E742D746578742D64656661756C742D636F6C6F72293B0D0A20202D2D612D69636F6E6C6973742D6974656D2D686F7665722D746578742D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D646566';
wwv_flow_imp.g_varchar2_table(631) := '61756C742D636F6C6F72293B0D0A20202D2D612D69636F6E6C6973742D6974656D2D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D6261636B67726F756E642D636F6C6F72293B0D0A20202D';
wwv_flow_imp.g_varchar2_table(632) := '2D612D69636F6E6C6973742D6974656D2D73656C65637465642D746578742D636F6C6F723A20766172282D2D612D69636F6E6C6973742D6974656D2D686F7665722D746578742D636F6C6F72293B0D0A20202D2D612D69636F6E6C6973742D6974656D2D';
wwv_flow_imp.g_varchar2_table(633) := '73656C65637465642D6261636B67726F756E642D636F6C6F723A20766172282D2D612D69636F6E6C6973742D6974656D2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A2E612D4952522D6469616C6F672D2D646F776E6C6F61';
wwv_flow_imp.g_varchar2_table(634) := '64202E612D49636F6E4C6973742D6974656D2C0D0A2E612D4952522D6469616C6F672D2D737562736372697074696F6E202E612D49636F6E4C6973742D6974656D207B0D0A2020626F782D736861646F773A20696E73657420766172282D2D75742D636F';
wwv_flow_imp.g_varchar2_table(635) := '6D706F6E656E742D696E6E65722D626F726465722D636F6C6F72292030202D317078203020303B0D0A7D0D0A2E612D4952522D6469616C6F672D2D646F776E6C6F6164202E612D49636F6E4C6973742D6974656D2E69732D73656C65637465642C0D0A2E';
wwv_flow_imp.g_varchar2_table(636) := '612D4952522D6469616C6F672D2D737562736372697074696F6E202E612D49636F6E4C6973742D6974656D2E69732D73656C6563746564207B0D0A2020626F782D736861646F773A20696E73657420766172282D2D75742D70616C657474652D7072696D';
wwv_flow_imp.g_varchar2_table(637) := '61727929203020327078203020303B0D0A7D0D0A2E612D4952522D69636F6E4C6973742D6974656D202B202E612D4952522D69636F6E4C6973742D6974656D207B0D0A2020626F726465722D6C6566742D636F6C6F723A20766172282D2D75742D636F6D';
wwv_flow_imp.g_varchar2_table(638) := '706F6E656E742D696E6E65722D626F726465722D636F6C6F72293B0D0A7D0D0A2E752D52544C202E612D4952522D69636F6E4C6973742D6974656D202B202E612D4952522D69636F6E4C6973742D6974656D207B0D0A2020626F726465722D7269676874';
wwv_flow_imp.g_varchar2_table(639) := '2D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D696E6E65722D626F726465722D636F6C6F72293B0D0A7D0D0A2E612D4952522D726164696F49636F6E4C697374207B0D0A20202D2D612D69636F6E6C6973742D6974656D2D6261636B';
wwv_flow_imp.g_varchar2_table(640) := '67726F756E642D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746F6F6C6261722D6261636B67726F756E642D636F6C6F722C207267626128302C20302C20302C20302E30323529293B0D0A20202D2D612D69636F6E6C6973742D6974';
wwv_flow_imp.g_varchar2_table(641) := '656D2D746578742D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D64656661756C742D636F6C6F72293B0D0A20202D2D612D69636F6E6C6973742D6974656D2D686F7665722D746578742D636F6C6F723A20766172282D2D';
wwv_flow_imp.g_varchar2_table(642) := '75742D636F6D706F6E656E742D746578742D64656661756C742D636F6C6F72293B0D0A20202D2D612D69636F6E6C6973742D6974656D2D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D6261';
wwv_flow_imp.g_varchar2_table(643) := '636B67726F756E642D636F6C6F72293B0D0A20202D2D612D69636F6E6C6973742D6974656D2D73656C65637465642D746578742D636F6C6F723A20766172282D2D612D69636F6E6C6973742D6974656D2D686F7665722D746578742D636F6C6F72293B0D';
wwv_flow_imp.g_varchar2_table(644) := '0A20202D2D612D69636F6E6C6973742D6974656D2D73656C65637465642D6261636B67726F756E642D636F6C6F723A20766172282D2D612D69636F6E6C6973742D6974656D2D686F7665722D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(645) := '612D4952522D726164696F49636F6E4C6973742D6974656D202B202E612D4952522D726164696F49636F6E4C6973742D6974656D207B0D0A2020626F726465722D6C6566742D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D696E6E65';
wwv_flow_imp.g_varchar2_table(646) := '722D626F726465722D636F6C6F72293B0D0A7D0D0A2E752D52544C202E612D4952522D726164696F49636F6E4C6973742D6974656D202B202E612D4952522D726164696F49636F6E4C6973742D6974656D207B0D0A2020626F726465722D72696768742D';
wwv_flow_imp.g_varchar2_table(647) := '636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D696E6E65722D626F726465722D636F6C6F72293B0D0A7D0D0A2E612D4952522D726164696F49636F6E4C6973742D6974656D20696E7075745B747970653D726164696F5D202B206C6162';
wwv_flow_imp.g_varchar2_table(648) := '656C207B0D0A2020626F782D736861646F773A20696E73657420766172282D2D75742D636F6D706F6E656E742D696E6E65722D626F726465722D636F6C6F72292030202D317078203020303B0D0A7D0D0A2E612D4952522D726164696F49636F6E4C6973';
wwv_flow_imp.g_varchar2_table(649) := '742D6974656D20696E7075745B747970653D726164696F5D3A636865636B6564202B206C6162656C207B0D0A2020626F782D736861646F773A20696E73657420766172282D2D75742D70616C657474652D7072696D61727929203020327078203020303B';
wwv_flow_imp.g_varchar2_table(650) := '0D0A7D0D0A2E612D4952522D6469616C6F67496E666F3A66697273742D6368696C64207B0D0A2020626F726465722D626F74746F6D2D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D696E6E65722D626F726465722D636F6C6F72293B';
wwv_flow_imp.g_varchar2_table(651) := '0D0A7D0D0A2E612D49472D627574746F6E2E612D49472D627574746F6E2D2D636F6E74726F6C732C0D0A2E612D4952522D627574746F6E2E612D4952522D627574746F6E2D2D636F6E74726F6C73207B0D0A20202D2D612D627574746F6E2D6261636B67';
wwv_flow_imp.g_varchar2_table(652) := '726F756E642D636F6C6F723A20236638663866383B0D0A7D0D0A2E612D4952522D6469616C6F67526F772D2D6865616465722C0D0A2E612D4952522D6469616C6F674C6973742061207B0D0A2020636F6C6F723A20766172282D2D75742D636F6D706F6E';
wwv_flow_imp.g_varchar2_table(653) := '656E742D746578742D64656661756C742D636F6C6F72293B0D0A7D0D0A2E612D4952522D6469616C6F674C697374207B0D0A2020626F726465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D';
wwv_flow_imp.g_varchar2_table(654) := '0A7D0D0A2E612D4952522D686967686C6967687450726576696577207B0D0A2020626F782D736861646F773A20696E73657420766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F7229203020302030203170783B0D0A7D0D0A2E';
wwv_flow_imp.g_varchar2_table(655) := '612D4952522D686561646572207B0D0A20206261636B67726F756E642D636F6C6F723A20236661666166613B0D0A7D0D0A2E612D4952522D6865616465723A686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20236632663266323B';
wwv_flow_imp.g_varchar2_table(656) := '0D0A7D0D0A2E612D4952522D6865616465722E69732D6163746976652C0D0A2E612D47562D6865616465722E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D612D6D656E752D6261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(657) := '2D636F6C6F72293B0D0A2020636F6C6F723A20766172282D2D612D6D656E752D746578742D636F6C6F72293B0D0A7D0D0A2E612D4952522D6865616465722D2D67726F7570207B0D0A20206261636B67726F756E642D636F6C6F723A2023663566356635';
wwv_flow_imp.g_varchar2_table(658) := '3B0D0A7D0D0A2E612D4952522D736F72745769646765742D7365617263684C6162656C3A6265666F7265207B0D0A2020636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D6D757465642D636F6C6F72293B0D0A7D0D0A2E612D';
wwv_flow_imp.g_varchar2_table(659) := '4952522D736F72745769646765742D736561726368203E202E612D4952522D736F72745769646765742D7365617263684669656C645B747970653D2274657874225D207B0D0A2020636F6C6F723A20766172282D2D612D6669656C642D696E7075742D73';
wwv_flow_imp.g_varchar2_table(660) := '746174652D746578742D636F6C6F722C20766172282D2D612D6669656C642D696E7075742D746578742D636F6C6F7229293B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D612D6669656C642D696E7075742D73746174652D6261';
wwv_flow_imp.g_varchar2_table(661) := '636B67726F756E642D636F6C6F722C20766172282D2D612D6669656C642D696E7075742D6261636B67726F756E642D636F6C6F7229293B0D0A7D0D0A2E612D47562D7461626C652074682E612D47562D636F6E74726F6C427265616B486561646572207B';
wwv_flow_imp.g_varchar2_table(662) := '0D0A20206261636B67726F756E642D636F6C6F723A20236635663566353B0D0A2020626F726465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A2020636F6C6F723A20766172282D2D7574';
wwv_flow_imp.g_varchar2_table(663) := '2D636F6D706F6E656E742D746578742D6D757465642D636F6C6F72293B0D0A7D0D0A2E612D49472D7265706F727453756D6D6172792D6974656D2D2D73617665645265706F72742C0D0A2E612D49472D636F6E74726F6C732D6974656D2D2D7361766564';
wwv_flow_imp.g_varchar2_table(664) := '5265706F72742C0D0A2E612D4952522D7265706F727453756D6D6172792D6974656D2D2D73617665645265706F72742C0D0A2E612D4952522D636F6E74726F6C732D6974656D2D2D73617665645265706F7274207B0D0A20202D2D612D7265706F72742D';
wwv_flow_imp.g_varchar2_table(665) := '636F6E74726F6C732D63656C6C2D6C6162656C2D69636F6E2D6261636B67726F756E642D636F6C6F723A20233441413445433B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D686F7665722D6261636B67726F75';
wwv_flow_imp.g_varchar2_table(666) := '6E642D636F6C6F723A20236563663566643B0D0A7D0D0A2E612D49472D7265706F727453756D6D6172792D6974656D2D2D7365617263682C0D0A2E612D49472D636F6E74726F6C732D6974656D2D2D7365617263682C0D0A2E612D4952522D7265706F72';
wwv_flow_imp.g_varchar2_table(667) := '7453756D6D6172792D6974656D2D2D7365617263682C0D0A2E612D4952522D636F6E74726F6C732D6974656D2D2D736561726368207B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D69636F6E2D6261636B6772';
wwv_flow_imp.g_varchar2_table(668) := '6F756E642D636F6C6F723A20233441413445433B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D686F7665722D6261636B67726F756E642D636F6C6F723A20236563663566643B0D0A7D0D0A2E612D49472D7265';
wwv_flow_imp.g_varchar2_table(669) := '706F727453756D6D6172792D6974656D2D2D66696C7465722C0D0A2E612D49472D636F6E74726F6C732D6974656D2D2D66696C7465722C0D0A2E612D4952522D7265706F727453756D6D6172792D6974656D2D2D66696C7465722C0D0A2E612D4952522D';
wwv_flow_imp.g_varchar2_table(670) := '636F6E74726F6C732D6974656D2D2D66696C746572207B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D69636F6E2D6261636B67726F756E642D636F6C6F723A20233234434237463B0D0A20202D2D612D726570';
wwv_flow_imp.g_varchar2_table(671) := '6F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D686F7665722D6261636B67726F756E642D636F6C6F723A20236463663965633B0D0A7D0D0A2E612D49472D7265706F727453756D6D6172792D6974656D2D2D636F6E74726F6C427265616B2C';
wwv_flow_imp.g_varchar2_table(672) := '0D0A2E612D49472D636F6E74726F6C732D6974656D2D2D636F6E74726F6C427265616B2C0D0A2E612D4952522D7265706F727453756D6D6172792D6974656D2D2D636F6E74726F6C427265616B2C0D0A2E612D4952522D636F6E74726F6C732D6974656D';
wwv_flow_imp.g_varchar2_table(673) := '2D2D636F6E74726F6C427265616B207B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D69636F6E2D6261636B67726F756E642D636F6C6F723A20233342383342443B0D0A20202D2D612D7265706F72742D636F6E';
wwv_flow_imp.g_varchar2_table(674) := '74726F6C732D63656C6C2D6C6162656C2D686F7665722D6261636B67726F756E642D636F6C6F723A20236536663066373B0D0A7D0D0A2E612D49472D7265706F727453756D6D6172792D6974656D2D2D67726F757042792C0D0A2E612D49472D636F6E74';
wwv_flow_imp.g_varchar2_table(675) := '726F6C732D6974656D2D2D67726F757042792C0D0A2E612D4952522D7265706F727453756D6D6172792D6974656D2D2D67726F757042792C0D0A2E612D4952522D636F6E74726F6C732D6974656D2D2D67726F75704279207B0D0A20202D2D612D726570';
wwv_flow_imp.g_varchar2_table(676) := '6F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D69636F6E2D6261636B67726F756E642D636F6C6F723A20233342383342443B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D686F7665722D6261636B';
wwv_flow_imp.g_varchar2_table(677) := '67726F756E642D636F6C6F723A20236536663066373B0D0A7D0D0A2E612D49472D7265706F727453756D6D6172792D6974656D2D2D6167677265676174652C0D0A2E612D49472D636F6E74726F6C732D6974656D2D2D6167677265676174652C0D0A2E61';
wwv_flow_imp.g_varchar2_table(678) := '2D4952522D7265706F727453756D6D6172792D6974656D2D2D6167677265676174652C0D0A2E612D4952522D636F6E74726F6C732D6974656D2D2D616767726567617465207B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C';
wwv_flow_imp.g_varchar2_table(679) := '6162656C2D69636F6E2D6261636B67726F756E642D636F6C6F723A20233342383342443B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D686F7665722D6261636B67726F756E642D636F6C6F723A202365366630';
wwv_flow_imp.g_varchar2_table(680) := '66373B0D0A7D0D0A2E612D49472D7265706F727453756D6D6172792D6974656D2D2D686967686C696768742C0D0A2E612D49472D636F6E74726F6C732D6974656D2D2D686967686C696768742C0D0A2E612D4952522D7265706F727453756D6D6172792D';
wwv_flow_imp.g_varchar2_table(681) := '6974656D2D2D686967686C696768742C0D0A2E612D4952522D636F6E74726F6C732D6974656D2D2D686967686C69676874207B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D69636F6E2D6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(682) := '642D636F6C6F723A20234646424532413B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D686F7665722D6261636B67726F756E642D636F6C6F723A20236666663063643B0D0A7D0D0A2E612D49472D7265706F72';
wwv_flow_imp.g_varchar2_table(683) := '7453756D6D6172792D6974656D2D2D666C6173686261636B2C0D0A2E612D49472D636F6E74726F6C732D6974656D2D2D666C6173686261636B2C0D0A2E612D4952522D7265706F727453756D6D6172792D6974656D2D2D666C6173686261636B2C0D0A2E';
wwv_flow_imp.g_varchar2_table(684) := '612D4952522D636F6E74726F6C732D6974656D2D2D666C6173686261636B207B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D69636F6E2D6261636B67726F756E642D636F6C6F723A20233945413741443B0D0A';
wwv_flow_imp.g_varchar2_table(685) := '20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D686F7665722D6261636B67726F756E642D636F6C6F723A20236435643964633B0D0A7D0D0A2E612D49472D7265706F727453756D6D6172792D6974656D2D2D63686172';
wwv_flow_imp.g_varchar2_table(686) := '742C0D0A2E612D49472D636F6E74726F6C732D6974656D2D2D63686172742C0D0A2E612D4952522D7265706F727453756D6D6172792D6974656D2D2D63686172742C0D0A2E612D4952522D636F6E74726F6C732D6974656D2D2D6368617274207B0D0A20';
wwv_flow_imp.g_varchar2_table(687) := '202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D69636F6E2D6261636B67726F756E642D636F6C6F723A20233342383342443B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D686F';
wwv_flow_imp.g_varchar2_table(688) := '7665722D6261636B67726F756E642D636F6C6F723A20233835623464393B0D0A7D0D0A2E612D49472D7265706F727453756D6D6172792D6974656D2D2D7069766F742C0D0A2E612D49472D636F6E74726F6C732D6974656D2D2D7069766F742C0D0A2E61';
wwv_flow_imp.g_varchar2_table(689) := '2D4952522D7265706F727453756D6D6172792D6974656D2D2D7069766F742C0D0A2E612D4952522D636F6E74726F6C732D6974656D2D2D7069766F74207B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D69636F';
wwv_flow_imp.g_varchar2_table(690) := '6E2D6261636B67726F756E642D636F6C6F723A20233945413741443B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D686F7665722D6261636B67726F756E642D636F6C6F723A20236435643964633B0D0A7D0D0A';
wwv_flow_imp.g_varchar2_table(691) := '2E612D49472D7265706F727453756D6D6172792D6974656D2D2D696E76616C696453657474696E67732C0D0A2E612D49472D636F6E74726F6C732D6974656D2D2D696E76616C696453657474696E67732C0D0A2E612D4952522D7265706F727453756D6D';
wwv_flow_imp.g_varchar2_table(692) := '6172792D6974656D2D2D696E76616C696453657474696E67732C0D0A2E612D4952522D636F6E74726F6C732D6974656D2D2D696E76616C696453657474696E6773207B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C616265';
wwv_flow_imp.g_varchar2_table(693) := '6C2D69636F6E2D6261636B67726F756E642D636F6C6F723A20234244433343373B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D686F7665722D6261636B67726F756E642D636F6C6F723A20236634663566363B';
wwv_flow_imp.g_varchar2_table(694) := '0D0A7D0D0A2E612D49472D7265706F727453756D6D6172792D6974656D2D2D696E61637469766553657474696E67732C0D0A2E612D49472D636F6E74726F6C732D6974656D2D2D696E61637469766553657474696E67732C0D0A2E612D4952522D726570';
wwv_flow_imp.g_varchar2_table(695) := '6F727453756D6D6172792D6974656D2D2D696E61637469766553657474696E67732C0D0A2E612D4952522D636F6E74726F6C732D6974656D2D2D696E61637469766553657474696E6773207B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D';
wwv_flow_imp.g_varchar2_table(696) := '63656C6C2D6C6162656C2D69636F6E2D6261636B67726F756E642D636F6C6F723A20234244433343373B0D0A20202D2D612D7265706F72742D636F6E74726F6C732D63656C6C2D6C6162656C2D686F7665722D6261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(697) := '20236634663566363B0D0A7D0D0A2E612D47562D7461626C65202E612D47562D63656C6C2E69732D616374697665207B0D0A20206261636B67726F756E642D636F6C6F723A20236536653665363B0D0A7D0D0A2E612D47562D2D656469744D6F6465202E';
wwv_flow_imp.g_varchar2_table(698) := '612D47562D726F772E69732D726561646F6E6C79202E612D47562D63656C6C2C0D0A2E612D47562D2D656469744D6F6465202E612D47562D63656C6C2E69732D726561646F6E6C79207B0D0A20206261636B67726F756E642D636F6C6F723A2023663266';
wwv_flow_imp.g_varchar2_table(699) := '3266323B0D0A2020636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D6D757465642D636F6C6F72293B0D0A7D0D0A2E612D47562D63656C6C202E612D47562D636F6C756D6E4974656D20696E7075743A6E6F74285B74797065';
wwv_flow_imp.g_varchar2_table(700) := '3D22726164696F225D293A6E6F74285B747970653D22636865636B626F78225D293A666F6375732C0D0A2E612D47562D63656C6C202E612D47562D636F6C756D6E4974656D2073656C6563745B73697A653D2731275D3A666F637573207B0D0A20206261';
wwv_flow_imp.g_varchar2_table(701) := '636B67726F756E642D636F6C6F723A20236666663B0D0A7D0D0A2E612D436869702D72656D6F7665207B0D0A20206D617267696E2D696E6C696E652D656E643A2063616C6328766172282D2D612D636869702D6C6162656C2D73706163696E672C203470';
wwv_flow_imp.g_varchar2_table(702) := '7829202F2032293B0D0A7D0D0A3A726F6F74207B0D0A20202D2D6F6A2D636F72652D746578742D636F6C6F722D7072696D6172793A20766172282D2D75742D636F6D706F6E656E742D746578742D64656661756C742D636F6C6F72293B0D0A20202D2D6F';
wwv_flow_imp.g_varchar2_table(703) := '6A2D636F72652D746578742D636F6C6F722D7365636F6E646172793A20766172282D2D75742D636F6D706F6E656E742D746578742D6D757465642D636F6C6F72293B0D0A20202D2D6F6A2D636F72652D746578742D636F6C6F722D6272616E643A207661';
wwv_flow_imp.g_varchar2_table(704) := '72282D2D75742D70616C657474652D7072696D6172792D74657874293B0D0A20202D2D6F6A2D636F72652D746578742D636F6C6F722D64616E6765723A20766172282D2D75742D70616C657474652D64616E6765722D74657874293B0D0A20202D2D6F6A';
wwv_flow_imp.g_varchar2_table(705) := '2D636F72652D746578742D636F6C6F722D7761726E696E673A20766172282D2D75742D70616C657474652D7761726E696E672D74657874293B0D0A20202D2D6F6A2D636F72652D746578742D636F6C6F722D737563636573733A20766172282D2D75742D';
wwv_flow_imp.g_varchar2_table(706) := '70616C657474652D737563636573732D74657874293B0D0A20202D2D6F6A2D636F72652D69636F6E2D73697A652D6C673A20312E3572656D3B0D0A20202D2D6F6A2D636F72652D69636F6E2D73697A652D736D3A203172656D3B0D0A20202D2D6F6A2D63';
wwv_flow_imp.g_varchar2_table(707) := '6F72652D646976696465722D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A20202D2D6F6A2D636F72652D646976696465722D6D617267696E3A20302E3572656D3B0D0A20202D2D6F6A2D636F';
wwv_flow_imp.g_varchar2_table(708) := '72652D666F6375732D626F726465722D636F6C6F723A20766172282D2D75742D666F6375732D6F75746C696E652D636F6C6F72293B0D0A20202D2D6F6A2D636F6C6F722D737065637472756D2D626F726465722D636F6C6F723A20236363636363633B0D';
wwv_flow_imp.g_varchar2_table(709) := '0A20202D2D6F6A2D706F7075702D62672D636F6C6F723A20766172282D2D612D6D656E752D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D6F6A2D636F72652D62672D636F6C6F722D686F7665723A20766172282D2D612D6D656E752D666F';
wwv_flow_imp.g_varchar2_table(710) := '63757365642D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D6F6A2D636F72652D626F782D736861646F773A20766172282D2D75742D736861646F772D736D293B0D0A20202D2D6F6A2D6C696E6B2D746578742D636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(711) := '2D2D75742D6C696E6B2D746578742D636F6C6F72293B0D0A20202D2D6F6A2D746578742D6669656C642D62672D636F6C6F723A20766172282D2D612D6669656C642D696E7075742D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D6F6A2D74';
wwv_flow_imp.g_varchar2_table(712) := '6578742D6669656C642D626F726465722D636F6C6F723A20766172282D2D612D6669656C642D696E7075742D626F726465722D636F6C6F72293B0D0A20202D2D6F6A2D746578742D6669656C642D746578742D636F6C6F723A20766172282D2D612D6669';
wwv_flow_imp.g_varchar2_table(713) := '656C642D696E7075742D746578742D636F6C6F72293B0D0A20202D2D6F6A2D636F6C6C656374696F6E2D667265652D73706163652D62672D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D6261636B67726F756E642D636F6C6F72293B';
wwv_flow_imp.g_varchar2_table(714) := '0D0A20202D2D6F6A2D636F6C6C656374696F6E2D6865616465722D62672D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D6261636B67726F756E642D636F6C6F72293B0D0A20202D2D6F6A2D636F6C6C656374696F6E2D626F72646572';
wwv_flow_imp.g_varchar2_table(715) := '2D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D626F726465722D636F6C6F72293B0D0A20202D2D6F6A2D636F6C6C656374696F6E2D62672D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D6261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(716) := '2D636F6C6F72293B0D0A20202D2D6F6A2D707269766174652D67616E74742D6D696C6573746F6E652D62672D636F6C6F723A20766172282D2D752D636F6C6F722D3135293B0D0A20202D2D6F6A2D707269766174652D67616E74742D7461736B2D62672D';
wwv_flow_imp.g_varchar2_table(717) := '636F6C6F723A20766172282D2D752D636F6C6F722D31293B0D0A20202D2D6F6A2D707269766174652D67616E74742D7461736B2D70726F67726573732D62672D636F6C6F723A20766172282D2D752D636F6C6F722D31293B0D0A20202D2D6F6A2D627574';
wwv_flow_imp.g_varchar2_table(718) := '746F6E2D6F75746C696E65642D6368726F6D652D62672D636F6C6F722D686F7665723A20766172282D2D75742D70616C657474652D7072696D617279293B0D0A20202D2D6F6A2D627574746F6E2D6F75746C696E65642D6368726F6D652D626F72646572';
wwv_flow_imp.g_varchar2_table(719) := '2D636F6C6F722D686F7665723A20766172282D2D75742D70616C657474652D7072696D617279293B0D0A20202D2D6F6A2D627574746F6E2D6F75746C696E65642D6368726F6D652D746578742D636F6C6F722D686F7665723A20766172282D2D75742D70';
wwv_flow_imp.g_varchar2_table(720) := '616C657474652D7072696D6172792D636F6E7472617374293B0D0A20202D2D6F6A2D627574746F6E2D626F726465726C6573732D6368726F6D652D62672D636F6C6F722D686F7665723A20766172282D2D75742D70616C657474652D7072696D61727929';
wwv_flow_imp.g_varchar2_table(721) := '3B0D0A20202D2D6F6A2D627574746F6E2D626F726465726C6573732D6368726F6D652D746578742D636F6C6F722D686F7665723A20766172282D2D75742D70616C657474652D7072696D6172792D636F6E7472617374293B0D0A20202D2D6F6A2D686561';
wwv_flow_imp.g_varchar2_table(722) := '64696E672D746578742D636F6C6F723A20766172282D2D75742D636F6D706F6E656E742D746578742D7469746C652D636F6C6F72293B0D0A7D0D0A2E6F6A2D6C697374626F782D64726F703A6E6F74282E6F6A2D6C697374626F782D686964652D686F76';
wwv_flow_imp.g_varchar2_table(723) := '657229202E6F6A2D6C697374626F782D726573756C7473202E6F6A2D686F766572207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D612D6D656E752D666F63757365642D6261636B67726F756E642D636F6C6F72293B0D0A2020';
wwv_flow_imp.g_varchar2_table(724) := '636F6C6F723A20766172282D2D612D6D656E752D666F63757365642D746578742D636F6C6F72293B0D0A7D0D0A2E6F6A2D6C697374626F782D726573756C74732C0D0A2E6F6A2D6C697374626F782D726573756C74732D626173652C0D0A2E6F6A2D7365';
wwv_flow_imp.g_varchar2_table(725) := '6C6563742D726573756C7473207B0D0A20206D617267696E3A20303B0D0A7D0D0A2E6F6A2D6C697374626F782D64726F70207B0D0A202070616464696E672D626C6F636B2D73746172743A2063616C6328766172282D2D612D6D656E752D70616464696E';
wwv_flow_imp.g_varchar2_table(726) := '672D792C20302E3572656D29202D20766172282D2D612D6D656E752D626F726465722D77696474682C2031707829293B0D0A202070616464696E672D626C6F636B2D656E643A2063616C6328766172282D2D612D6D656E752D70616464696E672D792C20';
wwv_flow_imp.g_varchar2_table(727) := '302E3572656D29202D20766172282D2D612D6D656E752D626F726465722D77696474682C2031707829293B0D0A202070616464696E672D696E6C696E652D73746172743A2063616C6328766172282D2D612D6D656E752D70616464696E672D782C203072';
wwv_flow_imp.g_varchar2_table(728) := '656D29202D20766172282D2D612D6D656E752D626F726465722D77696474682C2031707829293B0D0A202070616464696E672D696E6C696E652D656E643A2063616C6328766172282D2D612D6D656E752D70616464696E672D782C203072656D29202D20';
wwv_flow_imp.g_varchar2_table(729) := '766172282D2D612D6D656E752D626F726465722D77696474682C2031707829293B0D0A2020626F726465722D7261646975733A20766172282D2D612D6D656E752D626F726465722D7261646975732C20302E323572656D293B0D0A2020626F726465722D';
wwv_flow_imp.g_varchar2_table(730) := '636F6C6F723A20766172282D2D612D6D656E752D626F726465722D636F6C6F72293B0D0A2020626F726465722D77696474683A20766172282D2D612D6D656E752D626F726465722D77696474682C20317078293B0D0A2020626F726465722D7374796C65';
wwv_flow_imp.g_varchar2_table(731) := '3A20736F6C69643B0D0A2020626F782D736861646F773A20766172282D2D612D6D656E752D736861646F77293B0D0A20206D696E2D6865696768743A2063616C6328766172282D2D612D6D656E752D6C696E652D6865696768742C203172656D29202B20';
wwv_flow_imp.g_varchar2_table(732) := '28766172282D2D612D6D656E752D70616464696E672D792C20302E3572656D29202A203229293B0D0A2020636F6C6F723A20766172282D2D612D6D656E752D746578742D636F6C6F72293B0D0A20206261636B67726F756E642D636F6C6F723A20766172';
wwv_flow_imp.g_varchar2_table(733) := '282D2D612D6D656E752D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A2E6F6A2D646174657069636B65722D63616C656E646172207B0D0A2020666F6E742D73697A653A20766172282D2D6A75692D646174657069636B65722D666F6E742D73';
wwv_flow_imp.g_varchar2_table(734) := '697A652C20302E3638373572656D293B0D0A7D0D0A2E6F6A2D646174657069636B65722D63616C656E646172207468207B0D0A2020636F6C6F723A20766172282D2D6A75692D646174657069636B65722D6865616465722C2023363636293B0D0A202062';
wwv_flow_imp.g_varchar2_table(735) := '6F726465722D626F74746F6D2D7374796C653A20736F6C69643B0D0A2020626F726465722D626F74746F6D2D77696474683A20766172282D2D6A75692D646174657069636B65722D626F726465722D77696474682C20317078293B0D0A2020626F726465';
wwv_flow_imp.g_varchar2_table(736) := '722D626F74746F6D2D636F6C6F723A20766172282D2D75742D646174657069636B65722D626F726465722D636F6C6F722C207267626128302C20302C20302C20302E3129293B0D0A202070616464696E672D626C6F636B2D73746172743A20766172282D';
wwv_flow_imp.g_varchar2_table(737) := '2D6A75692D646174657069636B65722D70616464696E672D792C20302E3572656D293B0D0A202070616464696E672D696E6C696E652D656E643A20766172282D2D6A75692D646174657069636B65722D70616464696E672D782C20302E3572656D293B0D';
wwv_flow_imp.g_varchar2_table(738) := '0A202070616464696E672D626C6F636B2D656E643A20766172282D2D6A75692D646174657069636B65722D70616464696E672D792C20302E3572656D293B0D0A202070616464696E672D696E6C696E652D73746172743A20766172282D2D6A75692D6461';
wwv_flow_imp.g_varchar2_table(739) := '74657069636B65722D70616464696E672D782C20302E3572656D293B0D0A7D0D0A2E6F6A2D646174657069636B65722D63616C656E646172207464207B0D0A202077696474683A20766172282D2D6A75692D646174657069636B65722D646174652D7369';
wwv_flow_imp.g_varchar2_table(740) := '7A652C203372656D293B0D0A20206865696768743A20766172282D2D6A75692D646174657069636B65722D646174652D73697A652C203372656D293B0D0A20206D617267696E3A20766172282D2D6A75692D646174657069636B65722D646174652D6D61';
wwv_flow_imp.g_varchar2_table(741) := '7267696E2C20302E31323572656D293B0D0A20206C696E652D6865696768743A20766172282D2D6A75692D646174657069636B65722D646174652D73697A652C203372656D293B0D0A2020626F726465722D7261646975733A20766172282D2D6A75692D';
wwv_flow_imp.g_varchar2_table(742) := '646174657069636B65722D646174652D626F726465722D7261646975732C2031303025293B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D6A75692D646174657069636B65722D646174652D6261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(743) := '722C207472616E73706172656E74293B0D0A2020636F6C6F723A20766172282D2D6A75692D646174657069636B65722D646174652D636F6C6F722C20766172282D2D75742D636F6D706F6E656E742D746578742D64656661756C742D636F6C6F7229293B';
wwv_flow_imp.g_varchar2_table(744) := '0D0A20207472616E736974696F6E3A20766172282D2D6A75692D646174657069636B65722D646174652D7472616E736974696F6E2C206261636B67726F756E642D636F6C6F7220302E31732C20636F6C6F7220302E3173293B0D0A7D0D0A2E6F6A2D6461';
wwv_flow_imp.g_varchar2_table(745) := '74657069636B65722D63616C656E6461722074643A666F637573207B0D0A20206F75746C696E653A20303B0D0A2020626F782D736861646F773A20766172282D2D6A75692D646174657069636B65722D646174652D666F6375732D626F782D736861646F';
wwv_flow_imp.g_varchar2_table(746) := '772C2033352030203020317078202330303736646620696E7365742C203020302031707820327078207267626128302C203131382C203232332C20302E323529292021696D706F7274616E743B0D0A7D0D0A2E6F6A2D646174657069636B65722D63616C';
wwv_flow_imp.g_varchar2_table(747) := '656E64617220746420612E6F6A2D73656C65637465642C0D0A2E6F6A2D646174657069636B65722D63616C656E6461722074642E6F6A2D646174657069636B65722D746F64617920612E6F6A2D73656C6563746564207B0D0A20202D2D6A75692D646174';
wwv_flow_imp.g_varchar2_table(748) := '657069636B65722D646174652D6261636B67726F756E642D636F6C6F723A20766172282D2D75742D70616C657474652D7072696D617279293B0D0A20202D2D6A75692D646174657069636B65722D646174652D636F6C6F723A20766172282D2D75742D70';
wwv_flow_imp.g_varchar2_table(749) := '616C657474652D7072696D6172792D636F6E7472617374293B0D0A2020666F6E742D7765696768743A20766172282D2D6A75692D646174657069636B65722D73656C65637465642D666F6E742D7765696768742C20373030293B0D0A2020666F6E742D73';
wwv_flow_imp.g_varchar2_table(750) := '697A653A20766172282D2D6A75692D646174657069636B65722D6163746976652D666F6E742D73697A652C20302E38373572656D293B0D0A7D0D0A2E6F6A2D646174657069636B65722D63616C656E646172202E6F6A2D656E61626C65642E6F6A2D686F';
wwv_flow_imp.g_varchar2_table(751) := '766572207B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D6A75692D646174657069636B65722D686F7665722D6261636B67726F756E642D636F6C6F722C2023653865386538293B0D0A2020636F6C6F723A20766172282D2D6A75';
wwv_flow_imp.g_varchar2_table(752) := '692D646174657069636B65722D686F7665722D636F6C6F722C20626C61636B293B0D0A7D0D0A2E6F6A2D646174657069636B65722D63616C656E646172202E6F6A2D646174657069636B65722D6E6578742D69636F6E3A6E6F74282E6F6A2D6469736162';
wwv_flow_imp.g_varchar2_table(753) := '6C6564292E6F6A2D686F7665722C0D0A2E6F6A2D646174657069636B65722D63616C656E646172202E6F6A2D646174657069636B65722D707265762D69636F6E3A6E6F74282E6F6A2D64697361626C6564292E6F6A2D686F766572207B0D0A2020626163';
wwv_flow_imp.g_varchar2_table(754) := '6B67726F756E642D636F6C6F723A20766172282D2D6A75692D646174657069636B65722D686F7665722D6261636B67726F756E642D636F6C6F722C2023653865386538293B0D0A2020636F6C6F723A20766172282D2D6A75692D646174657069636B6572';
wwv_flow_imp.g_varchar2_table(755) := '2D686F7665722D636F6C6F722C20626C61636B293B0D0A7D0D0A0D0A23745F547265654E61765F3220756C7B0D0A20202020646973706C61793A20626C6F636B2021696D706F7274616E743B0D0A7D';
null;
end;
/
begin
wwv_flow_imp_shared.create_theme_file(
 p_id=>wwv_flow_imp.id(9247737152048334)
,p_theme_id=>42
,p_file_name=>'9247337283048331.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content => wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4361951280880890)
,p_theme_id=>42
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>40
,p_template_types=>'BUTTON'
,p_help_text=>'Enables you to group many buttons together into a pill. You can use this option to specify where the button is within this set. Set the option to Default if this button is not part of a button set.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4362333366880890)
,p_theme_id=>42
,p_name=>'ICON_HOVER_ANIMATION'
,p_display_name=>'Icon Hover Animation'
,p_display_sequence=>55
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4362767724880890)
,p_theme_id=>42
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>50
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the position of the icon relative to the label.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4363190727880890)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>10
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the size of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4363567715880890)
,p_theme_id=>42
,p_name=>'SPACING_BOTTOM'
,p_display_name=>'Spacing Bottom'
,p_display_sequence=>100
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the bottom of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4363944234880890)
,p_theme_id=>42
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing Left'
,p_display_sequence=>70
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the left of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4364372161880890)
,p_theme_id=>42
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>80
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the right of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4364757921880890)
,p_theme_id=>42
,p_name=>'SPACING_TOP'
,p_display_name=>'Spacing Top'
,p_display_sequence=>90
,p_template_types=>'BUTTON'
,p_help_text=>'Controls the spacing to the top of the button.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4365165264880890)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>30
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the style of the button. Use the "Simple" option for secondary actions or sets of buttons. Use the "Remove UI Decoration" option to make the button appear as text.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4365504733880890)
,p_theme_id=>42
,p_name=>'TYPE'
,p_display_name=>'Type'
,p_display_sequence=>20
,p_template_types=>'BUTTON'
,p_null_text=>'Normal'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4365990162880890)
,p_theme_id=>42
,p_name=>'WIDTH'
,p_display_name=>'Width'
,p_display_sequence=>60
,p_template_types=>'BUTTON'
,p_help_text=>'Sets the width of the button.'
,p_null_text=>'Auto - Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4366379240880891)
,p_theme_id=>42
,p_name=>'BOTTOM_MARGIN'
,p_display_name=>'Bottom Margin'
,p_display_sequence=>220
,p_template_types=>'FIELD'
,p_help_text=>'Set the bottom margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4366717467880891)
,p_theme_id=>42
,p_name=>'ITEM_POST_TEXT'
,p_display_name=>'Item Post Text'
,p_display_sequence=>30
,p_template_types=>'FIELD'
,p_help_text=>'Adjust the display of the Item Post Text'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4367180830880891)
,p_theme_id=>42
,p_name=>'ITEM_PRE_TEXT'
,p_display_name=>'Item Pre Text'
,p_display_sequence=>20
,p_template_types=>'FIELD'
,p_help_text=>'Adjust the display of the Item Pre Text'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4367534437880891)
,p_theme_id=>42
,p_name=>'LEFT_MARGIN'
,p_display_name=>'Left Margin'
,p_display_sequence=>220
,p_template_types=>'FIELD'
,p_help_text=>'Set the left margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4367961304880891)
,p_theme_id=>42
,p_name=>'PRESERVE_LABEL_SPACING'
,p_display_name=>'Preserve Label Spacing'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_help_text=>'Preserves the label space and enables use of the Label Column Span property.'
,p_null_text=>'Yes'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4368383246880891)
,p_theme_id=>42
,p_name=>'RADIO_GROUP_DISPLAY'
,p_display_name=>'Item Group Display'
,p_display_sequence=>300
,p_template_types=>'FIELD'
,p_help_text=>'Determines the display style for radio and check box items.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4368778249880891)
,p_theme_id=>42
,p_name=>'REQUIRED_INDICATOR'
,p_display_name=>'Required Indicator'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4369191573880891)
,p_theme_id=>42
,p_name=>'RIGHT_MARGIN'
,p_display_name=>'Right Margin'
,p_display_sequence=>230
,p_template_types=>'FIELD'
,p_help_text=>'Set the right margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4369519777880891)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>10
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4369948240880891)
,p_theme_id=>42
,p_name=>'TOP_MARGIN'
,p_display_name=>'Top Margin'
,p_display_sequence=>200
,p_template_types=>'FIELD'
,p_help_text=>'Set the top margin for this field.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4370329229880891)
,p_theme_id=>42
,p_name=>'ANIMATION'
,p_display_name=>'Animation'
,p_display_sequence=>80
,p_template_types=>'LIST'
,p_help_text=>'Sets the hover and focus animation.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4370702768880891)
,p_theme_id=>42
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>70
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4371104084880891)
,p_theme_id=>42
,p_name=>'BODY_TEXT'
,p_display_name=>'Body Text'
,p_display_sequence=>40
,p_template_types=>'LIST'
,p_help_text=>'Determines the height of the card body.'
,p_null_text=>'Auto'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4371503256880891)
,p_theme_id=>42
,p_name=>'COLLAPSE_STYLE'
,p_display_name=>'Collapse Mode'
,p_display_sequence=>30
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4371996941880891)
,p_theme_id=>42
,p_name=>'COLOR_ACCENTS'
,p_display_name=>'Color Accents'
,p_display_sequence=>50
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4372342136880892)
,p_theme_id=>42
,p_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_sequence=>90
,p_template_types=>'LIST'
,p_help_text=>'Determines the display for a desktop-sized screen'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4372712227880892)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>30
,p_template_types=>'LIST'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4373171111880892)
,p_theme_id=>42
,p_name=>'ICONS'
,p_display_name=>'Icons'
,p_display_sequence=>20
,p_template_types=>'LIST'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4373558498880892)
,p_theme_id=>42
,p_name=>'ICON_SHAPE'
,p_display_name=>'Icon Shape'
,p_display_sequence=>60
,p_template_types=>'LIST'
,p_help_text=>'Determines the shape of the icon.'
,p_null_text=>'Circle'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4373993190880892)
,p_theme_id=>42
,p_name=>'ICON_STYLE'
,p_display_name=>'Icon Style'
,p_display_sequence=>35
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4374322786880892)
,p_theme_id=>42
,p_name=>'LABEL_DISPLAY'
,p_display_name=>'Label Display'
,p_display_sequence=>50
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4374735857880892)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>30
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4375156122880892)
,p_theme_id=>42
,p_name=>'MOBILE'
,p_display_name=>'Mobile'
,p_display_sequence=>100
,p_template_types=>'LIST'
,p_help_text=>'Determines the display for a mobile-sized screen'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4375562439880892)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4375917671880892)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>10
,p_template_types=>'LIST'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4376368327880892)
,p_theme_id=>42
,p_name=>'CONTENT_PADDING'
,p_display_name=>'Content Padding'
,p_display_sequence=>1
,p_template_types=>'PAGE'
,p_help_text=>'Sets the Content Body padding for the page.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4376754813880892)
,p_theme_id=>42
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Size'
,p_display_sequence=>1
,p_template_types=>'PAGE'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4377155119880892)
,p_theme_id=>42
,p_name=>'DISPLAY_MODE'
,p_display_name=>'Display Mode'
,p_display_sequence=>30
,p_template_types=>'PAGE'
,p_help_text=>'Determines the default display appearance and positioning of the dialog. The default opens a floating dialog position at the center of the screen.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4377520617880892)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND'
,p_display_name=>'Page Background'
,p_display_sequence=>20
,p_template_types=>'PAGE'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4377918136880892)
,p_theme_id=>42
,p_name=>'PAGE_LAYOUT'
,p_display_name=>'Page Layout'
,p_display_sequence=>10
,p_template_types=>'PAGE'
,p_null_text=>'Floating (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4378315531880893)
,p_theme_id=>42
,p_name=>'PAGE_POSITION'
,p_display_name=>'Position'
,p_display_sequence=>1
,p_template_types=>'PAGE'
,p_help_text=>'Sets the position of the page.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4378746899880893)
,p_theme_id=>42
,p_name=>'ACCENT'
,p_display_name=>'Accent'
,p_display_sequence=>30
,p_template_types=>'REGION'
,p_help_text=>'Set the Region''s accent. This accent corresponds to a Theme-Rollable color and sets the background of the Region''s Header.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4379113221880893)
,p_theme_id=>42
,p_name=>'ALERT_DISPLAY'
,p_display_name=>'Alert Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the layout of the Alert Region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4379540440880893)
,p_theme_id=>42
,p_name=>'ALERT_ICONS'
,p_display_name=>'Alert Icons'
,p_display_sequence=>2
,p_template_types=>'REGION'
,p_help_text=>'Sets how icons are handled for the Alert Region.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4379940305880893)
,p_theme_id=>42
,p_name=>'ALERT_TITLE'
,p_display_name=>'Alert Title'
,p_display_sequence=>40
,p_template_types=>'REGION'
,p_help_text=>'Determines how the title of the alert is displayed.'
,p_null_text=>'Visible - Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4380330758880893)
,p_theme_id=>42
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>3
,p_template_types=>'REGION'
,p_help_text=>'Sets the type of alert which can be used to determine the icon, icon color, and the background color.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4380706983880893)
,p_theme_id=>42
,p_name=>'ANIMATION'
,p_display_name=>'Animation'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Sets the animation when navigating within the Carousel Region.'
,p_null_text=>'Fade'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4381192344880893)
,p_theme_id=>42
,p_name=>'BODY_HEIGHT'
,p_display_name=>'Body Height'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Sets the Region Body height. You can also specify a custom height by modifying the Region''s CSS Classes and using the height helper classes "i-hXXX" where XXX is any increment of 10 from 100 to 800.'
,p_null_text=>'Auto - Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4381517600880893)
,p_theme_id=>42
,p_name=>'BODY_OVERFLOW'
,p_display_name=>'Body Overflow'
,p_display_sequence=>2
,p_template_types=>'REGION'
,p_help_text=>'Determines the scroll behavior when the region contents are larger than their container.'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4381961400880893)
,p_theme_id=>42
,p_name=>'BODY_PADDING'
,p_display_name=>'Body Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the Region Body padding for the region.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4382305873880893)
,p_theme_id=>42
,p_name=>'BODY_STYLE'
,p_display_name=>'Body Style'
,p_display_sequence=>20
,p_template_types=>'REGION'
,p_help_text=>'Controls the display of the region''s body container.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4382786191880893)
,p_theme_id=>42
,p_name=>'CALLOUT_POSITION'
,p_display_name=>'Callout Position'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Determines where the callout for the popup will be positioned relative to its parent.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4383164010880893)
,p_theme_id=>42
,p_name=>'COLLAPSIBLE_BUTTON_ICONS'
,p_display_name=>'Collapsible Button Icons'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Determines which arrows to use to represent the icons for the collapse and expand button.'
,p_null_text=>'Arrows'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4383514281880893)
,p_theme_id=>42
,p_name=>'COLLAPSIBLE_ICON_POSITION'
,p_display_name=>'Collapsible Icon Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Determines the position of the expand and collapse toggle for the region.'
,p_null_text=>'Start'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4383974852880893)
,p_theme_id=>42
,p_name=>'DEFAULT_STATE'
,p_display_name=>'Default State'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the default state of the region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4384391075880894)
,p_theme_id=>42
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4384783221880894)
,p_theme_id=>42
,p_name=>'DISPLAY_ICON'
,p_display_name=>'Display Icon'
,p_display_sequence=>50
,p_template_types=>'REGION'
,p_help_text=>'Display the Hero Region icon.'
,p_null_text=>'Yes (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4385145863880894)
,p_theme_id=>42
,p_name=>'DISPLAY_MODE'
,p_display_name=>'Display Mode'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Determines the default display appearance and positioning of the dialog. The default opens a floating dialog position at the center of the screen.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4385555254880894)
,p_theme_id=>42
,p_name=>'HEADER'
,p_display_name=>'Header'
,p_display_sequence=>20
,p_template_types=>'REGION'
,p_help_text=>'Determines the display of the Region Header which also contains the Region Title.'
,p_null_text=>'Visible - Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4385970674880894)
,p_theme_id=>42
,p_name=>'HEADING_FONT'
,p_display_name=>'Heading Font'
,p_display_sequence=>100
,p_template_types=>'REGION'
,p_help_text=>'Sets the font-family of the heading for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4386344553880894)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL'
,p_display_name=>'Heading Level'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4386713098880894)
,p_theme_id=>42
,p_name=>'HIDE_STEPS_FOR'
,p_display_name=>'Hide Steps For'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4387195497880894)
,p_theme_id=>42
,p_name=>'ICON_SHAPE'
,p_display_name=>'Icon Shape'
,p_display_sequence=>60
,p_template_types=>'REGION'
,p_help_text=>'Determines the shape of the icon.'
,p_null_text=>'Rounded Corners'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4387531457880894)
,p_theme_id=>42
,p_name=>'IMAGE_FILTER'
,p_display_name=>'Filter'
,p_display_sequence=>40
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4387931388880894)
,p_theme_id=>42
,p_name=>'IMAGE_RATIO'
,p_display_name=>'Ratio'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4388360117880894)
,p_theme_id=>42
,p_name=>'IMAGE_SCALE'
,p_display_name=>'Scale'
,p_display_sequence=>20
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4388723439880894)
,p_theme_id=>42
,p_name=>'IMAGE_SHAPE'
,p_display_name=>'Shape'
,p_display_sequence=>30
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4389141333880894)
,p_theme_id=>42
,p_name=>'ITEM_PADDING'
,p_display_name=>'Item Spacing'
,p_display_sequence=>100
,p_template_types=>'REGION'
,p_help_text=>'Sets the padding around items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4389552116880894)
,p_theme_id=>42
,p_name=>'ITEM_SIZE'
,p_display_name=>'Item Size'
,p_display_sequence=>110
,p_template_types=>'REGION'
,p_help_text=>'Sets the size of the form items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4389976397880894)
,p_theme_id=>42
,p_name=>'ITEM_WIDTH'
,p_display_name=>'Item Width'
,p_display_sequence=>120
,p_template_types=>'REGION'
,p_help_text=>'Sets the width of the form items within this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4390349453880895)
,p_theme_id=>42
,p_name=>'LABEL_ALIGNMENT'
,p_display_name=>'Label Alignment'
,p_display_sequence=>130
,p_template_types=>'REGION'
,p_help_text=>'Set the label text alignment for items within this region.'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4390723862880895)
,p_theme_id=>42
,p_name=>'LABEL_POSITION'
,p_display_name=>'Label Position'
,p_display_sequence=>140
,p_template_types=>'REGION'
,p_help_text=>'Sets the position of the label relative to the form item.'
,p_null_text=>'Inline - Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4391118877880895)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4391520859880895)
,p_theme_id=>42
,p_name=>'LOGIN_HEADER'
,p_display_name=>'Login Header'
,p_display_sequence=>10
,p_template_types=>'REGION'
,p_help_text=>'Controls the display of the Login region header.'
,p_null_text=>'Icon and Title (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4391976860880895)
,p_theme_id=>42
,p_name=>'REGION_BOTTOM_MARGIN'
,p_display_name=>'Bottom Margin'
,p_display_sequence=>210
,p_template_types=>'REGION'
,p_help_text=>'Set the bottom margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4392307620880895)
,p_theme_id=>42
,p_name=>'REGION_LEFT_MARGIN'
,p_display_name=>'Left Margin'
,p_display_sequence=>220
,p_template_types=>'REGION'
,p_help_text=>'Set the left margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4392710772880895)
,p_theme_id=>42
,p_name=>'REGION_POSITION'
,p_display_name=>'Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the position of the region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4393170264880895)
,p_theme_id=>42
,p_name=>'REGION_RIGHT_MARGIN'
,p_display_name=>'Right Margin'
,p_display_sequence=>230
,p_template_types=>'REGION'
,p_help_text=>'Set the right margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4393509813880895)
,p_theme_id=>42
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Sets the source of the Title Bar region''s title.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4393957495880895)
,p_theme_id=>42
,p_name=>'REGION_TOP_MARGIN'
,p_display_name=>'Top Margin'
,p_display_sequence=>200
,p_template_types=>'REGION'
,p_help_text=>'Set the top margin for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4394399631880895)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>40
,p_template_types=>'REGION'
,p_help_text=>'Determines how the region is styled. Use the "Remove Borders" template option to remove the region''s borders and shadows.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4394751244880895)
,p_theme_id=>42
,p_name=>'TABS_SIZE'
,p_display_name=>'Tabs Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4395153472880895)
,p_theme_id=>42
,p_name=>'TAB_STYLE'
,p_display_name=>'Tab Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4395552459880895)
,p_theme_id=>42
,p_name=>'TIMER'
,p_display_name=>'Timer'
,p_display_sequence=>2
,p_template_types=>'REGION'
,p_help_text=>'Sets the timer for when to automatically navigate to the next region within the Carousel Region.'
,p_null_text=>'No Timer'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4395956793880895)
,p_theme_id=>42
,p_name=>'ALTERNATING_ROWS'
,p_display_name=>'Alternating Rows'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Shades alternate rows in the report with slightly different background colors.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4396327358880896)
,p_theme_id=>42
,p_name=>'ANIMATION'
,p_display_name=>'Animation'
,p_display_sequence=>70
,p_template_types=>'REPORT'
,p_help_text=>'Sets the hover and focus animation.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4396753725880896)
,p_theme_id=>42
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4397167182880896)
,p_theme_id=>42
,p_name=>'BODY_TEXT'
,p_display_name=>'Body Text'
,p_display_sequence=>40
,p_template_types=>'REPORT'
,p_help_text=>'Determines the height of the card body.'
,p_null_text=>'Auto'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4397512166880896)
,p_theme_id=>42
,p_name=>'COLOR_ACCENTS'
,p_display_name=>'Color Accents'
,p_display_sequence=>50
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4397946337880896)
,p_theme_id=>42
,p_name=>'COL_ACTIONS'
,p_display_name=>'Actions'
,p_display_sequence=>150
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4398351284880896)
,p_theme_id=>42
,p_name=>'COL_CONTENT_DESCRIPTION'
,p_display_name=>'Description'
,p_display_sequence=>130
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4398788782880896)
,p_theme_id=>42
,p_name=>'COL_CONTENT_TITLE'
,p_display_name=>'Title'
,p_display_sequence=>120
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4399101338880896)
,p_theme_id=>42
,p_name=>'COL_ICON'
,p_display_name=>'Icon'
,p_display_sequence=>110
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4399503657880896)
,p_theme_id=>42
,p_name=>'COL_MISC'
,p_display_name=>'Misc'
,p_display_sequence=>140
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4399958774880896)
,p_theme_id=>42
,p_name=>'COL_SELECTION'
,p_display_name=>'Selection'
,p_display_sequence=>100
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4400319458880896)
,p_theme_id=>42
,p_name=>'COMMENTS_STYLE'
,p_display_name=>'Comments Style'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Determines the style in which comments are displayed.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4400733285880896)
,p_theme_id=>42
,p_name=>'CONTENT_ALIGNMENT'
,p_display_name=>'Content Alignment'
,p_display_sequence=>90
,p_template_types=>'REPORT'
,p_null_text=>'Center (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4401189010880896)
,p_theme_id=>42
,p_name=>'DISPLAY_ITEMS'
,p_display_name=>'Display Items'
,p_display_sequence=>20
,p_template_types=>'REPORT'
,p_null_text=>'Inline (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4401598651880897)
,p_theme_id=>42
,p_name=>'DISPLAY_LABELS'
,p_display_name=>'Display Labels'
,p_display_sequence=>30
,p_template_types=>'REPORT'
,p_null_text=>'Inline (Default)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4401986340880897)
,p_theme_id=>42
,p_name=>'ICONS'
,p_display_name=>'Icons'
,p_display_sequence=>20
,p_template_types=>'REPORT'
,p_help_text=>'Controls how to handle icons in the report.'
,p_null_text=>'No Icons'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4402311321880897)
,p_theme_id=>42
,p_name=>'ICON_SHAPE'
,p_display_name=>'Icon Shape'
,p_display_sequence=>60
,p_template_types=>'REPORT'
,p_help_text=>'Determines the shape of the icon.'
,p_null_text=>'Circle'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4402753334880897)
,p_theme_id=>42
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4403190791880897)
,p_theme_id=>42
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>30
,p_template_types=>'REPORT'
,p_help_text=>'Determines the layout of Cards in the report.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4403501219880897)
,p_theme_id=>42
,p_name=>'PAGINATION_DISPLAY'
,p_display_name=>'Pagination Display'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Controls the display of pagination for this region.'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4403941480880897)
,p_theme_id=>42
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>30
,p_template_types=>'REPORT'
,p_help_text=>'Controls the display of the Report''s borders.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4404340748880897)
,p_theme_id=>42
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>20
,p_template_types=>'REPORT'
,p_help_text=>'Determines whether you want the row to be highlighted on hover.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4404780661880897)
,p_theme_id=>42
,p_name=>'SIZE'
,p_display_name=>'Size'
,p_display_sequence=>35
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(4405129962880897)
,p_theme_id=>42
,p_name=>'STYLE'
,p_display_name=>'Style'
,p_display_sequence=>10
,p_template_types=>'REPORT'
,p_help_text=>'Determines the overall style for the component.'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4426277153880903)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H1'
,p_display_name=>'H1'
,p_display_sequence=>10
,p_css_classes=>'js-headingLevel-1'
,p_group_id=>wwv_flow_imp.id(4386344553880894)
,p_template_types=>'REGION'
,p_help_text=>'H1'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4426965202880903)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H2'
,p_display_name=>'H2'
,p_display_sequence=>20
,p_css_classes=>'js-headingLevel-2'
,p_group_id=>wwv_flow_imp.id(4386344553880894)
,p_template_types=>'REGION'
,p_help_text=>'H2'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4427660262880903)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H3'
,p_display_name=>'H3'
,p_display_sequence=>30
,p_css_classes=>'js-headingLevel-3'
,p_group_id=>wwv_flow_imp.id(4386344553880894)
,p_template_types=>'REGION'
,p_help_text=>'H3'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4428396443880903)
,p_theme_id=>42
,p_name=>'H4'
,p_display_name=>'H4'
,p_display_sequence=>40
,p_css_classes=>'js-headingLevel-4'
,p_group_id=>wwv_flow_imp.id(4386344553880894)
,p_template_types=>'REGION'
,p_help_text=>'H4'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4429022915880903)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H5'
,p_display_name=>'H5'
,p_display_sequence=>50
,p_css_classes=>'js-headingLevel-5'
,p_group_id=>wwv_flow_imp.id(4386344553880894)
,p_template_types=>'REGION'
,p_help_text=>'H5'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4429765005880903)
,p_theme_id=>42
,p_name=>'HEADING_LEVEL_H6'
,p_display_name=>'H6'
,p_display_sequence=>60
,p_css_classes=>'js-headingLevel-6'
,p_group_id=>wwv_flow_imp.id(4386344553880894)
,p_template_types=>'REGION'
,p_help_text=>'H6'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4430450292880904)
,p_theme_id=>42
,p_name=>'FBM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-bottom-lg'
,p_group_id=>wwv_flow_imp.id(4366379240880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large bottom margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4431169237880904)
,p_theme_id=>42
,p_name=>'RBM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-bottom-lg'
,p_group_id=>wwv_flow_imp.id(4391976860880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large bottom margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4431817948880904)
,p_theme_id=>42
,p_name=>'FBM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-bottom-md'
,p_group_id=>wwv_flow_imp.id(4366379240880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium bottom margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4432561788880904)
,p_theme_id=>42
,p_name=>'RBM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-bottom-md'
,p_group_id=>wwv_flow_imp.id(4391976860880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium bottom margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4433244037880904)
,p_theme_id=>42
,p_name=>'FBM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-bottom-none'
,p_group_id=>wwv_flow_imp.id(4366379240880891)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the bottom margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4433986433880905)
,p_theme_id=>42
,p_name=>'RBM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-bottom-none'
,p_group_id=>wwv_flow_imp.id(4391976860880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes the bottom margin for this region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4434676542880905)
,p_theme_id=>42
,p_name=>'FBM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-bottom-sm'
,p_group_id=>wwv_flow_imp.id(4366379240880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small bottom margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4435326499880905)
,p_theme_id=>42
,p_name=>'RBM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-bottom-sm'
,p_group_id=>wwv_flow_imp.id(4391976860880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small bottom margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4436053728880905)
,p_theme_id=>42
,p_name=>'FLM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-left-lg'
,p_group_id=>wwv_flow_imp.id(4367534437880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large left margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4436752939880905)
,p_theme_id=>42
,p_name=>'RLM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-left-lg'
,p_group_id=>wwv_flow_imp.id(4392307620880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large right margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4437469998880905)
,p_theme_id=>42
,p_name=>'FLM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-left-md'
,p_group_id=>wwv_flow_imp.id(4367534437880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium left margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4438125431880905)
,p_theme_id=>42
,p_name=>'RLM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-left-md'
,p_group_id=>wwv_flow_imp.id(4392307620880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium right margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4438851849880906)
,p_theme_id=>42
,p_name=>'FLM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-left-none'
,p_group_id=>wwv_flow_imp.id(4367534437880891)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the left margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4439500260880906)
,p_theme_id=>42
,p_name=>'RLM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-left-none'
,p_group_id=>wwv_flow_imp.id(4392307620880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes the left margin from the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4440286676880906)
,p_theme_id=>42
,p_name=>'FLM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-left-sm'
,p_group_id=>wwv_flow_imp.id(4367534437880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small left margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4440942117880906)
,p_theme_id=>42
,p_name=>'RLM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-left-sm'
,p_group_id=>wwv_flow_imp.id(4392307620880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small left margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4441698732880906)
,p_theme_id=>42
,p_name=>'FRM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-right-lg'
,p_group_id=>wwv_flow_imp.id(4369191573880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large right margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4442328934880906)
,p_theme_id=>42
,p_name=>'RRM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-right-lg'
,p_group_id=>wwv_flow_imp.id(4393170264880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large right margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4443037795880907)
,p_theme_id=>42
,p_name=>'FRM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-right-md'
,p_group_id=>wwv_flow_imp.id(4369191573880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium right margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4443793982880907)
,p_theme_id=>42
,p_name=>'RRM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-right-md'
,p_group_id=>wwv_flow_imp.id(4393170264880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium right margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4444460602880907)
,p_theme_id=>42
,p_name=>'FRM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-right-none'
,p_group_id=>wwv_flow_imp.id(4369191573880891)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the right margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4445181511880907)
,p_theme_id=>42
,p_name=>'RRM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-right-none'
,p_group_id=>wwv_flow_imp.id(4393170264880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes the right margin from the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4445845615880907)
,p_theme_id=>42
,p_name=>'FRM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-right-sm'
,p_group_id=>wwv_flow_imp.id(4369191573880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small right margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4446519386880907)
,p_theme_id=>42
,p_name=>'RRM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-right-sm'
,p_group_id=>wwv_flow_imp.id(4393170264880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small right margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4447209228880907)
,p_theme_id=>42
,p_name=>'FTM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-top-lg'
,p_group_id=>wwv_flow_imp.id(4369948240880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a large top margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4447987429880908)
,p_theme_id=>42
,p_name=>'RTM_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>40
,p_css_classes=>'margin-top-lg'
,p_group_id=>wwv_flow_imp.id(4393957495880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a large top margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4448617637880908)
,p_theme_id=>42
,p_name=>'FTM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-top-md'
,p_group_id=>wwv_flow_imp.id(4369948240880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a medium top margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4449306443880908)
,p_theme_id=>42
,p_name=>'RTM_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>30
,p_css_classes=>'margin-top-md'
,p_group_id=>wwv_flow_imp.id(4393957495880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a medium top margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4450025311880908)
,p_theme_id=>42
,p_name=>'FTM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-top-none'
,p_group_id=>wwv_flow_imp.id(4369948240880891)
,p_template_types=>'FIELD'
,p_help_text=>'Removes the top margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4450784493880908)
,p_theme_id=>42
,p_name=>'RTM_NONE'
,p_display_name=>'None'
,p_display_sequence=>10
,p_css_classes=>'margin-top-none'
,p_group_id=>wwv_flow_imp.id(4393957495880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes the top margin for this region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4451460168880908)
,p_theme_id=>42
,p_name=>'FTM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-top-sm'
,p_group_id=>wwv_flow_imp.id(4369948240880891)
,p_template_types=>'FIELD'
,p_help_text=>'Adds a small top margin for this field.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4452128482880908)
,p_theme_id=>42
,p_name=>'RTM_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'margin-top-sm'
,p_group_id=>wwv_flow_imp.id(4393957495880895)
,p_template_types=>'REGION'
,p_help_text=>'Adds a small top margin to the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4452863300880909)
,p_theme_id=>42
,p_name=>'DANGER'
,p_display_name=>'Danger'
,p_display_sequence=>30
,p_css_classes=>'t-Button--danger'
,p_group_id=>wwv_flow_imp.id(4365504733880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4453523302880909)
,p_theme_id=>42
,p_name=>'LARGEBOTTOMMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapBottom'
,p_group_id=>wwv_flow_imp.id(4363567715880890)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4454227605880909)
,p_theme_id=>42
,p_name=>'LARGELEFTMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapLeft'
,p_group_id=>wwv_flow_imp.id(4363944234880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4454959662880909)
,p_theme_id=>42
,p_name=>'LARGERIGHTMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapRight'
,p_group_id=>wwv_flow_imp.id(4364372161880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4455620903880909)
,p_theme_id=>42
,p_name=>'LARGETOPMARGIN'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_css_classes=>'t-Button--gapTop'
,p_group_id=>wwv_flow_imp.id(4364757921880890)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4456388347880909)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>30
,p_css_classes=>'t-Button--large'
,p_group_id=>wwv_flow_imp.id(4363190727880890)
,p_template_types=>'BUTTON'
,p_help_text=>'A large button.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4457092877880910)
,p_theme_id=>42
,p_name=>'DISPLAY_AS_LINK'
,p_display_name=>'Display as Link'
,p_display_sequence=>30
,p_css_classes=>'t-Button--link'
,p_group_id=>wwv_flow_imp.id(4365165264880890)
,p_template_types=>'BUTTON'
,p_help_text=>'This option makes the button appear as a text link.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4457709019880910)
,p_theme_id=>42
,p_name=>'NOUI'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>20
,p_css_classes=>'t-Button--noUI'
,p_group_id=>wwv_flow_imp.id(4365165264880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4458457796880910)
,p_theme_id=>42
,p_name=>'SMALLBOTTOMMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padBottom'
,p_group_id=>wwv_flow_imp.id(4363567715880890)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4459151562880910)
,p_theme_id=>42
,p_name=>'SMALLLEFTMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padLeft'
,p_group_id=>wwv_flow_imp.id(4363944234880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4459857602880910)
,p_theme_id=>42
,p_name=>'SMALLRIGHTMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padRight'
,p_group_id=>wwv_flow_imp.id(4364372161880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4460577509880910)
,p_theme_id=>42
,p_name=>'SMALLTOPMARGIN'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_css_classes=>'t-Button--padTop'
,p_group_id=>wwv_flow_imp.id(4364757921880890)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4461294170880910)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Inner Button'
,p_display_sequence=>20
,p_css_classes=>'t-Button--pill'
,p_group_id=>wwv_flow_imp.id(4361951280880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4461919378880911)
,p_theme_id=>42
,p_name=>'PILLEND'
,p_display_name=>'Last Button'
,p_display_sequence=>30
,p_css_classes=>'t-Button--pillEnd'
,p_group_id=>wwv_flow_imp.id(4361951280880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4462635563880911)
,p_theme_id=>42
,p_name=>'PILLSTART'
,p_display_name=>'First Button'
,p_display_sequence=>10
,p_css_classes=>'t-Button--pillStart'
,p_group_id=>wwv_flow_imp.id(4361951280880890)
,p_template_types=>'BUTTON'
,p_help_text=>'Use this for the start of a pill button.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4463394312880911)
,p_theme_id=>42
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>10
,p_css_classes=>'t-Button--primary'
,p_group_id=>wwv_flow_imp.id(4365504733880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4464058861880911)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_css_classes=>'t-Button--simple'
,p_group_id=>wwv_flow_imp.id(4365165264880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4464770096880911)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>20
,p_css_classes=>'t-Button--small'
,p_group_id=>wwv_flow_imp.id(4363190727880890)
,p_template_types=>'BUTTON'
,p_help_text=>'A small button.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4465448032880911)
,p_theme_id=>42
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>10
,p_css_classes=>'t-Button--stretch'
,p_group_id=>wwv_flow_imp.id(4365990162880890)
,p_template_types=>'BUTTON'
,p_help_text=>'Stretches button to fill container'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4466137444880912)
,p_theme_id=>42
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>40
,p_css_classes=>'t-Button--success'
,p_group_id=>wwv_flow_imp.id(4365504733880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4466832285880912)
,p_theme_id=>42
,p_name=>'TINY'
,p_display_name=>'Tiny'
,p_display_sequence=>10
,p_css_classes=>'t-Button--tiny'
,p_group_id=>wwv_flow_imp.id(4363190727880890)
,p_template_types=>'BUTTON'
,p_help_text=>'A very small button.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4467591197880912)
,p_theme_id=>42
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>20
,p_css_classes=>'t-Button--warning'
,p_group_id=>wwv_flow_imp.id(4365504733880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4467961499880912)
,p_theme_id=>42
,p_name=>'DEFERRED_PAGE_RENDERING'
,p_display_name=>'Deferred Page Rendering'
,p_display_sequence=>1
,p_css_classes=>'t-DeferredRendering'
,p_template_types=>'PAGE'
,p_help_text=>'Defer page rendering until all page components have finished loading.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4468659112880912)
,p_theme_id=>42
,p_name=>'SHOWFORMLABELSABOVE'
,p_display_name=>'Show Form Labels Above'
,p_display_sequence=>10
,p_css_classes=>'t-Form--labelsAbove'
,p_group_id=>wwv_flow_imp.id(4390723862880895)
,p_template_types=>'REGION'
,p_help_text=>'Show form labels above input fields.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4469363686880912)
,p_theme_id=>42
,p_name=>'FORMSIZELARGE'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_css_classes=>'t-Form--large'
,p_group_id=>wwv_flow_imp.id(4389552116880894)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4470065227880912)
,p_theme_id=>42
,p_name=>'FORMLEFTLABELS'
,p_display_name=>'Left'
,p_display_sequence=>20
,p_css_classes=>'t-Form--leftLabels'
,p_group_id=>wwv_flow_imp.id(4390349453880895)
,p_template_types=>'REGION'
,p_help_text=>'Align form labels to left.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4470708672880912)
,p_theme_id=>42
,p_name=>'FORMREMOVEPADDING'
,p_display_name=>'None'
,p_display_sequence=>20
,p_css_classes=>'t-Form--noPadding'
,p_group_id=>wwv_flow_imp.id(4389141333880894)
,p_template_types=>'REGION'
,p_help_text=>'Removes spacing between items.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4471421448880913)
,p_theme_id=>42
,p_name=>'FORMSLIMPADDING'
,p_display_name=>'Slim'
,p_display_sequence=>10
,p_css_classes=>'t-Form--slimPadding'
,p_group_id=>wwv_flow_imp.id(4389141333880894)
,p_template_types=>'REGION'
,p_help_text=>'Reduces form item spacing.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4472146732880913)
,p_theme_id=>42
,p_name=>'FORMSTANDARDPADDING'
,p_display_name=>'Standard'
,p_display_sequence=>5
,p_css_classes=>'t-Form--standardPadding'
,p_group_id=>wwv_flow_imp.id(4389141333880894)
,p_template_types=>'REGION'
,p_help_text=>'Uses the standard spacing between items.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4472847415880913)
,p_theme_id=>42
,p_name=>'STRETCH_FORM_FIELDS'
,p_display_name=>'Stretch Form Fields'
,p_display_sequence=>10
,p_css_classes=>'t-Form--stretchInputs'
,p_group_id=>wwv_flow_imp.id(4389976397880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4473557223880913)
,p_theme_id=>42
,p_name=>'FORMSIZEXLARGE'
,p_display_name=>'X Large'
,p_display_sequence=>20
,p_css_classes=>'t-Form--xlarge'
,p_group_id=>wwv_flow_imp.id(4389552116880894)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4474212599880913)
,p_theme_id=>42
,p_name=>'LARGE_FIELD'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--large'
,p_group_id=>wwv_flow_imp.id(4369519777880891)
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4474966570880913)
,p_theme_id=>42
,p_name=>'POST_TEXT_BLOCK'
,p_display_name=>'Display as Block'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--postTextBlock'
,p_group_id=>wwv_flow_imp.id(4366717467880891)
,p_template_types=>'FIELD'
,p_help_text=>'Displays the Item Post Text in a block style immediately after the item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4475642359880913)
,p_theme_id=>42
,p_name=>'PRE_TEXT_BLOCK'
,p_display_name=>'Display as Block'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--preTextBlock'
,p_group_id=>wwv_flow_imp.id(4367180830880891)
,p_template_types=>'FIELD'
,p_help_text=>'Displays the Item Pre Text in a block style immediately before the item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4476373848880914)
,p_theme_id=>42
,p_name=>'DISPLAY_AS_PILL_BUTTON'
,p_display_name=>'Display as Pill Button'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--radioButtonGroup'
,p_group_id=>wwv_flow_imp.id(4368383246880891)
,p_template_types=>'FIELD'
,p_help_text=>'Displays the radio buttons to look like a button set / pill button.  Note that the the radio buttons must all be in the same row for this option to work.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4476711046880914)
,p_theme_id=>42
,p_name=>'STRETCH_FORM_ITEM'
,p_display_name=>'Stretch Form Item'
,p_display_sequence=>10
,p_css_classes=>'t-Form-fieldContainer--stretchInputs'
,p_template_types=>'FIELD'
,p_help_text=>'Stretches the form item to fill its container.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4477464991880914)
,p_theme_id=>42
,p_name=>'X_LARGE_SIZE'
,p_display_name=>'X Large'
,p_display_sequence=>20
,p_css_classes=>'t-Form-fieldContainer--xlarge'
,p_group_id=>wwv_flow_imp.id(4369519777880891)
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4478144792880914)
,p_theme_id=>42
,p_name=>'REMOVE_PADDING'
,p_display_name=>'Remove Padding'
,p_display_sequence=>1
,p_css_classes=>'t-PageBody--noContentPadding'
,p_group_id=>wwv_flow_imp.id(4376368327880892)
,p_template_types=>'PAGE'
,p_help_text=>'Removes padding from the content region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4478850108880914)
,p_theme_id=>42
,p_name=>'HIDE_WHEN_ALL_ROWS_DISPLAYED'
,p_display_name=>'Hide when all rows displayed'
,p_display_sequence=>10
,p_css_classes=>'t-Report--hideNoPagination'
,p_group_id=>wwv_flow_imp.id(4403501219880897)
,p_template_types=>'REPORT'
,p_help_text=>'This option will hide the pagination when all rows are displayed.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4549922305880931)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_EXTRA_LARGE'
,p_display_name=>'Extra Large'
,p_display_sequence=>40
,p_page_template_id=>wwv_flow_imp.id(4547911793880930)
,p_css_classes=>'js-dialog-class-t-Drawer--xl'
,p_group_id=>wwv_flow_imp.id(4376754813880892)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4550360727880931)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>30
,p_page_template_id=>wwv_flow_imp.id(4547911793880930)
,p_css_classes=>'js-dialog-class-t-Drawer--lg'
,p_group_id=>wwv_flow_imp.id(4376754813880892)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4550778602880931)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(4547911793880930)
,p_css_classes=>'js-dialog-class-t-Drawer--md'
,p_group_id=>wwv_flow_imp.id(4376754813880892)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4551188289880931)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_imp.id(4547911793880930)
,p_css_classes=>'js-dialog-class-t-Drawer--sm'
,p_group_id=>wwv_flow_imp.id(4376754813880892)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4551599812880931)
,p_theme_id=>42
,p_name=>'POSITION_END'
,p_display_name=>'End'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(4547911793880930)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_group_id=>wwv_flow_imp.id(4378315531880893)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4551948188880931)
,p_theme_id=>42
,p_name=>'POSITION_START'
,p_display_name=>'Start'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_imp.id(4547911793880930)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutStart'
,p_group_id=>wwv_flow_imp.id(4378315531880893)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4552308742880931)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(4547911793880930)
,p_css_classes=>'t-Dialog--noPadding'
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4612528913880944)
,p_theme_id=>42
,p_name=>'HEADING_FONT_ALTERNATIVE'
,p_display_name=>'Alternative'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34459258426496695)
,p_css_classes=>'t-ContentBlock--headingFontAlt'
,p_group_id=>wwv_flow_imp.id(4385970674880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4628180122880947)
,p_theme_id=>42
,p_name=>'HEADING_FONT_ALTERNATIVE'
,p_display_name=>'Alternative'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34480263758496702)
,p_css_classes=>'t-BreadcrumbRegion--headingFontAlt'
,p_group_id=>wwv_flow_imp.id(4385970674880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4639667636880950)
,p_theme_id=>42
,p_name=>'ACCENT_12'
,p_display_name=>'Accent 12'
,p_display_sequence=>120
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent12'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4640325796880950)
,p_theme_id=>42
,p_name=>'ACCENT_15'
,p_display_name=>'Accent 15'
,p_display_sequence=>150
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent15'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4641027314880950)
,p_theme_id=>42
,p_name=>'ACCENT_14'
,p_display_name=>'Accent 14'
,p_display_sequence=>140
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent14'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4641744781880950)
,p_theme_id=>42
,p_name=>'ACCENT_8'
,p_display_name=>'Accent 8'
,p_display_sequence=>80
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent8'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4642439434880950)
,p_theme_id=>42
,p_name=>'ACCENT_9'
,p_display_name=>'Accent 9'
,p_display_sequence=>90
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent9'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4643104040880951)
,p_theme_id=>42
,p_name=>'ACCENT_7'
,p_display_name=>'Accent 7'
,p_display_sequence=>70
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent7'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4643814011880951)
,p_theme_id=>42
,p_name=>'ACCENT_13'
,p_display_name=>'Accent 13'
,p_display_sequence=>130
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent13'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4644547935880951)
,p_theme_id=>42
,p_name=>'ACCENT_10'
,p_display_name=>'Accent 10'
,p_display_sequence=>100
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent10'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4645299770880951)
,p_theme_id=>42
,p_name=>'ACCENT_6'
,p_display_name=>'Accent 6'
,p_display_sequence=>60
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent6'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
end;
/
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4645949706880951)
,p_theme_id=>42
,p_name=>'ACCENT_11'
,p_display_name=>'Accent 11'
,p_display_sequence=>110
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent11'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4671590252880957)
,p_theme_id=>42
,p_name=>'NONE'
,p_display_name=>'None'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_imp.id(34463394363496697)
,p_css_classes=>'js-dialog-nosize'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4679630417880959)
,p_theme_id=>42
,p_name=>'HEADING_FONT_ALTERNATIVE'
,p_display_name=>'Alternative'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34461241212496696)
,p_css_classes=>'t-HeroRegion--headingFontAlt'
,p_group_id=>wwv_flow_imp.id(4385970674880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4764162872880981)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_EXTRA_LARGE'
,p_display_name=>'Extra Large'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(4759614622880980)
,p_css_classes=>'js-dialog-class-t-Drawer--xl'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4764598024880981)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(4759614622880980)
,p_css_classes=>'js-dialog-class-t-Drawer--lg'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4764930178880981)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_MEDIUM'
,p_display_name=>'Medium'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(4759614622880980)
,p_css_classes=>'js-dialog-class-t-Drawer--md'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4765327611880981)
,p_theme_id=>42
,p_name=>'DRAWER_SIZE_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(4759614622880980)
,p_css_classes=>'js-dialog-class-t-Drawer--sm'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4765722736880982)
,p_theme_id=>42
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(4759614622880980)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4766140292880982)
,p_theme_id=>42
,p_name=>'NONE'
,p_display_name=>'None (Auto)'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_imp.id(4759614622880980)
,p_css_classes=>'js-dialog-nosize'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4766510206880982)
,p_theme_id=>42
,p_name=>'POSITION_END'
,p_display_name=>'End'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(4759614622880980)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutEnd'
,p_group_id=>wwv_flow_imp.id(4392710772880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4766971845880982)
,p_theme_id=>42
,p_name=>'POSITION_START'
,p_display_name=>'Start'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(4759614622880980)
,p_css_classes=>'js-dialog-class-t-Drawer--pullOutStart'
,p_group_id=>wwv_flow_imp.id(4392710772880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4767306546880982)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_imp.id(4759614622880980)
,p_css_classes=>'t-DialogRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the region body.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4769189444880982)
,p_theme_id=>42
,p_name=>'FILTER_BLUR'
,p_display_name=>'Blur'
,p_display_sequence=>430
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--blur'
,p_group_id=>wwv_flow_imp.id(4387531457880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4769545147880982)
,p_theme_id=>42
,p_name=>'FILTER_GRAYSCALE'
,p_display_name=>'Grayscale'
,p_display_sequence=>410
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--grayscale'
,p_group_id=>wwv_flow_imp.id(4387531457880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4769971640880982)
,p_theme_id=>42
,p_name=>'FILTER_INVERT'
,p_display_name=>'Invert'
,p_display_sequence=>440
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--invert'
,p_group_id=>wwv_flow_imp.id(4387531457880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4770307360880982)
,p_theme_id=>42
,p_name=>'FILTER_NONE'
,p_display_name=>'None'
,p_display_sequence=>400
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--noFilter'
,p_group_id=>wwv_flow_imp.id(4387531457880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4770761208880982)
,p_theme_id=>42
,p_name=>'FILTER_SATURATE'
,p_display_name=>'Saturate'
,p_display_sequence=>450
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--saturate'
,p_group_id=>wwv_flow_imp.id(4387531457880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4771108123880983)
,p_theme_id=>42
,p_name=>'FILTER_SEPIA'
,p_display_name=>'Sepia'
,p_display_sequence=>420
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--sepia'
,p_group_id=>wwv_flow_imp.id(4387531457880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4771508495880983)
,p_theme_id=>42
,p_name=>'IMAGE_STRETCH'
,p_display_name=>'Image Stretch'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--stretch'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4771982943880983)
,p_theme_id=>42
,p_name=>'RATIO_16_9'
,p_display_name=>'16:9 (Widescreen)'
,p_display_sequence=>120
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--16x9'
,p_group_id=>wwv_flow_imp.id(4387931388880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4772376737880983)
,p_theme_id=>42
,p_name=>'RATIO_1_1'
,p_display_name=>'1:1 (Square)'
,p_display_sequence=>110
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--1x1'
,p_group_id=>wwv_flow_imp.id(4387931388880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4772741770880983)
,p_theme_id=>42
,p_name=>'RATIO_2_1'
,p_display_name=>'2:1 (Univisium)'
,p_display_sequence=>140
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--2x1'
,p_group_id=>wwv_flow_imp.id(4387931388880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4773109111880983)
,p_theme_id=>42
,p_name=>'RATIO_4_3'
,p_display_name=>'4:3 (Standard)'
,p_display_sequence=>130
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--4x3'
,p_group_id=>wwv_flow_imp.id(4387931388880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4773553987880983)
,p_theme_id=>42
,p_name=>'RATIO_AUTO'
,p_display_name=>'Auto'
,p_display_sequence=>100
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--auto'
,p_group_id=>wwv_flow_imp.id(4387931388880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4773972605880983)
,p_theme_id=>42
,p_name=>'SCALE_CONTAIN'
,p_display_name=>'Contain'
,p_display_sequence=>200
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--contain'
,p_group_id=>wwv_flow_imp.id(4388360117880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4774354332880983)
,p_theme_id=>42
,p_name=>'SCALE_COVER'
,p_display_name=>'Cover'
,p_display_sequence=>210
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--cover'
,p_group_id=>wwv_flow_imp.id(4388360117880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4774782476880983)
,p_theme_id=>42
,p_name=>'SCALE_DOWN'
,p_display_name=>'Scale Down'
,p_display_sequence=>230
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--scale-down'
,p_group_id=>wwv_flow_imp.id(4388360117880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4775187447880984)
,p_theme_id=>42
,p_name=>'SCALE_FILL'
,p_display_name=>'Fill'
,p_display_sequence=>220
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--fill'
,p_group_id=>wwv_flow_imp.id(4388360117880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4775542939880984)
,p_theme_id=>42
,p_name=>'SHAPE_CIRCLE'
,p_display_name=>'Circle'
,p_display_sequence=>320
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--circle'
,p_group_id=>wwv_flow_imp.id(4388723439880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4775975352880984)
,p_theme_id=>42
,p_name=>'SHAPE_ROUNDED'
,p_display_name=>'Rounded'
,p_display_sequence=>310
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--rounded'
,p_group_id=>wwv_flow_imp.id(4388723439880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4776304630880984)
,p_theme_id=>42
,p_name=>'SHAPE_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>300
,p_region_template_id=>wwv_flow_imp.id(4767674643880982)
,p_css_classes=>'t-ImageRegion--square'
,p_group_id=>wwv_flow_imp.id(4388723439880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4887824278881013)
,p_theme_id=>42
,p_name=>'DISPLAY_ITEMS_STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(4887390925881013)
,p_css_classes=>'t-ContextualInfo-item--stacked'
,p_group_id=>wwv_flow_imp.id(4401189010880896)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4888212207881013)
,p_theme_id=>42
,p_name=>'DISPLAY_LABELS_STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(4887390925881013)
,p_css_classes=>'t-ContextualInfo-label--stacked'
,p_group_id=>wwv_flow_imp.id(4401598651880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4889976944881014)
,p_theme_id=>42
,p_name=>'INDICATOR_ASTERISK'
,p_display_name=>'Asterisk'
,p_display_sequence=>10
,p_field_template_id=>wwv_flow_imp.id(34532318618496730)
,p_css_classes=>'t-Form-fieldContainer--indicatorAsterisk'
,p_group_id=>wwv_flow_imp.id(4368778249880891)
,p_template_types=>'FIELD'
,p_help_text=>'Displays an asterisk * on required items.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4890663168881014)
,p_theme_id=>42
,p_name=>'INDICATOR_LABEL'
,p_display_name=>'Inline Label'
,p_display_sequence=>20
,p_field_template_id=>wwv_flow_imp.id(34532318618496730)
,p_css_classes=>'t-Form-fieldContainer--indicatorLabel'
,p_group_id=>wwv_flow_imp.id(4368778249880891)
,p_template_types=>'FIELD'
,p_help_text=>'Displays "Required" inline.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4892771271881015)
,p_theme_id=>42
,p_name=>'INDICATOR_ASTERISK'
,p_display_name=>'Asterisk'
,p_display_sequence=>10
,p_field_template_id=>wwv_flow_imp.id(34532413378496730)
,p_css_classes=>'t-Form-fieldContainer--indicatorAsterisk'
,p_group_id=>wwv_flow_imp.id(4368778249880891)
,p_template_types=>'FIELD'
,p_help_text=>'Displays an asterisk * on required items.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4893421825881015)
,p_theme_id=>42
,p_name=>'INDICATOR_LABEL'
,p_display_name=>'Inline Label'
,p_display_sequence=>20
,p_field_template_id=>wwv_flow_imp.id(34532413378496730)
,p_css_classes=>'t-Form-fieldContainer--indicatorLabel'
,p_group_id=>wwv_flow_imp.id(4368778249880891)
,p_template_types=>'FIELD'
,p_help_text=>'Displays "Required" inline.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4895506015881015)
,p_theme_id=>42
,p_name=>'INDICATOR_ASTERISK'
,p_display_name=>'Asterisk'
,p_display_sequence=>10
,p_field_template_id=>wwv_flow_imp.id(34532592841496730)
,p_css_classes=>'t-Form-fieldContainer--indicatorAsterisk'
,p_group_id=>wwv_flow_imp.id(4368778249880891)
,p_template_types=>'FIELD'
,p_help_text=>'Displays an asterisk * on required items.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4896299476881016)
,p_theme_id=>42
,p_name=>'INDICATOR_LABEL'
,p_display_name=>'Inline Label'
,p_display_sequence=>20
,p_field_template_id=>wwv_flow_imp.id(34532592841496730)
,p_css_classes=>'t-Form-fieldContainer--indicatorLabel'
,p_group_id=>wwv_flow_imp.id(4368778249880891)
,p_template_types=>'FIELD'
,p_help_text=>'Displays "Required" inline.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(4900098306881017)
,p_theme_id=>42
,p_name=>'HIDE_ICON_ON_DESKTOP'
,p_display_name=>'Hide Icon on Desktop'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_imp.id(34533432746496733)
,p_css_classes=>'t-Button--desktopHideIcon'
,p_template_types=>'BUTTON'
,p_help_text=>'This template options hides the button icon on large screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34419648759496671)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(34416610173496657)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34420918810496672)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(34419794295496671)
,p_css_classes=>'t-Dialog--noPadding'
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34421101328496672)
,p_theme_id=>42
,p_name=>'STRETCH_TO_FIT_WINDOW'
,p_display_name=>'Stretch to Fit Window'
,p_display_sequence=>1
,p_page_template_id=>wwv_flow_imp.id(34419794295496671)
,p_css_classes=>'ui-dialog--stretch'
,p_template_types=>'PAGE'
,p_help_text=>'Stretch the dialog to fit the browser window.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34422679464496674)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND_1'
,p_display_name=>'Background 1'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_imp.id(34421292387496672)
,p_css_classes=>'t-LoginPage--bg1'
,p_group_id=>wwv_flow_imp.id(4377520617880892)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34422859801496674)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND_2'
,p_display_name=>'Background 2'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(34421292387496672)
,p_css_classes=>'t-LoginPage--bg2'
,p_group_id=>wwv_flow_imp.id(4377520617880892)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34423029503496674)
,p_theme_id=>42
,p_name=>'PAGE_BACKGROUND_3'
,p_display_name=>'Background 3'
,p_display_sequence=>30
,p_page_template_id=>wwv_flow_imp.id(34421292387496672)
,p_css_classes=>'t-LoginPage--bg3'
,p_group_id=>wwv_flow_imp.id(4377520617880892)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34423423442496674)
,p_theme_id=>42
,p_name=>'PAGE_LAYOUT_SPLIT'
,p_display_name=>'Split'
,p_display_sequence=>1
,p_page_template_id=>wwv_flow_imp.id(34421292387496672)
,p_css_classes=>'t-LoginPage--split'
,p_group_id=>wwv_flow_imp.id(4377918136880892)
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34424723363496674)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_page_template_id=>wwv_flow_imp.id(34423569196496674)
,p_css_classes=>'t-Dialog--noPadding'
,p_template_types=>'PAGE'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34424958255496675)
,p_theme_id=>42
,p_name=>'STRETCH_TO_FIT_WINDOW'
,p_display_name=>'Stretch to Fit Window'
,p_display_sequence=>10
,p_page_template_id=>wwv_flow_imp.id(34423569196496674)
,p_css_classes=>'ui-dialog--stretch'
,p_template_types=>'PAGE'
,p_help_text=>'Stretch the dialog to fit the browser window.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34427788085496675)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(34425087266496675)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34430575502496677)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(34427830536496676)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34433657666496678)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(34430628506496677)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34436159784496679)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(34433764173496678)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34438653936496680)
,p_theme_id=>42
,p_name=>'STICKY_HEADER_ON_MOBILE'
,p_display_name=>'Sticky Header on Mobile'
,p_display_sequence=>100
,p_page_template_id=>wwv_flow_imp.id(34436267275496679)
,p_css_classes=>'js-pageStickyMobileHeader'
,p_template_types=>'PAGE'
,p_help_text=>'This will position the contents of the Breadcrumb Bar region position so it sticks to the top of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34439302523496685)
,p_theme_id=>42
,p_name=>'COLOREDBACKGROUND'
,p_display_name=>'Highlight Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--colorBG'
,p_template_types=>'REGION'
,p_help_text=>'Set alert background color to that of the alert type (warning, success, etc.)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34439773668496685)
,p_theme_id=>42
,p_name=>'DANGER'
,p_display_name=>'Danger'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--danger'
,p_group_id=>wwv_flow_imp.id(4380330758880893)
,p_template_types=>'REGION'
,p_help_text=>'Show an error or danger alert.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34440191784496685)
,p_theme_id=>42
,p_name=>'HIDDENHEADER'
,p_display_name=>'Hidden but Accessible'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--accessibleHeading'
,p_group_id=>wwv_flow_imp.id(4379940305880893)
,p_template_types=>'REGION'
,p_help_text=>'Visually hides the alert title, but assistive technologies can still read it.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34440360164496685)
,p_theme_id=>42
,p_name=>'HIDDENHEADERNOAT'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--removeHeading js-removeLandmark'
,p_group_id=>wwv_flow_imp.id(4379940305880893)
,p_template_types=>'REGION'
,p_help_text=>'Hides the Alert Title from being displayed.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34440775971496685)
,p_theme_id=>42
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--horizontal'
,p_group_id=>wwv_flow_imp.id(4379113221880893)
,p_template_types=>'REGION'
,p_help_text=>'Show horizontal alert with buttons to the right.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34440951474496686)
,p_theme_id=>42
,p_name=>'INFORMATION'
,p_display_name=>'Information'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--info'
,p_group_id=>wwv_flow_imp.id(4380330758880893)
,p_template_types=>'REGION'
,p_help_text=>'Show informational alert.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34441141132496686)
,p_theme_id=>42
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--success'
,p_group_id=>wwv_flow_imp.id(4380330758880893)
,p_template_types=>'REGION'
,p_help_text=>'Show success alert.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34441542533496686)
,p_theme_id=>42
,p_name=>'USEDEFAULTICONS'
,p_display_name=>'Show Default Icons'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--defaultIcons'
,p_group_id=>wwv_flow_imp.id(4379540440880893)
,p_template_types=>'REGION'
,p_help_text=>'Uses default icons for alert types.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34441716813496686)
,p_theme_id=>42
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--warning'
,p_group_id=>wwv_flow_imp.id(4380330758880893)
,p_template_types=>'REGION'
,p_help_text=>'Show a warning alert.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34441953652496686)
,p_theme_id=>42
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--wizard'
,p_group_id=>wwv_flow_imp.id(4379113221880893)
,p_template_types=>'REGION'
,p_help_text=>'Show the alert in a wizard style region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34442101022496686)
,p_theme_id=>42
,p_name=>'SHOW_CUSTOM_ICONS'
,p_display_name=>'Show Custom Icons'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--customIcons'
,p_group_id=>wwv_flow_imp.id(4379540440880893)
,p_template_types=>'REGION'
,p_help_text=>'Set custom icons by modifying the Alert Region''s Icon CSS Classes property.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34442368647496686)
,p_theme_id=>42
,p_name=>'HIDE_ICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34438790691496680)
,p_css_classes=>'t-Alert--noIcon'
,p_group_id=>wwv_flow_imp.id(4379540440880893)
,p_template_types=>'REGION'
,p_help_text=>'Hides alert icons'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34444509316496688)
,p_theme_id=>42
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34443487668496687)
,p_css_classes=>'t-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34444905414496688)
,p_theme_id=>42
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_imp.id(34443487668496687)
,p_css_classes=>'t-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_imp.id(4381961400880893)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34445180173496688)
,p_theme_id=>42
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>4
,p_region_template_id=>wwv_flow_imp.id(34443487668496687)
,p_css_classes=>'t-ButtonRegion--noUI'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34445328681496688)
,p_theme_id=>42
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_imp.id(34443487668496687)
,p_css_classes=>'t-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_imp.id(4381961400880893)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34445570716496688)
,p_theme_id=>42
,p_name=>'STICK_TO_BOTTOM'
,p_display_name=>'Stick to Bottom for Mobile'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34443487668496687)
,p_css_classes=>'t-ButtonRegion--stickToBottom'
,p_template_types=>'REGION'
,p_help_text=>'This will position the button container region to the bottom of the screen for small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34445915114496688)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34445609432496688)
,p_css_classes=>'u-colors'
,p_template_types=>'REGION'
,p_help_text=>'Applies the colors from the theme''s color palette to the icons or initials within cards.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34446110343496688)
,p_theme_id=>42
,p_name=>'STYLE_A'
,p_display_name=>'Style A'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34445609432496688)
,p_css_classes=>'t-CardsRegion--styleA'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34446325276496688)
,p_theme_id=>42
,p_name=>'STYLE_B'
,p_display_name=>'Style B'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34445609432496688)
,p_css_classes=>'t-CardsRegion--styleB'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34446520516496688)
,p_theme_id=>42
,p_name=>'STYLE_C'
,p_display_name=>'Style C'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34445609432496688)
,p_css_classes=>'t-CardsRegion--styleC'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34447701317496690)
,p_theme_id=>42
,p_name=>'10_SECONDS'
,p_display_name=>'10 Seconds'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'js-cycle10s'
,p_group_id=>wwv_flow_imp.id(4395552459880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34447986747496690)
,p_theme_id=>42
,p_name=>'15_SECONDS'
,p_display_name=>'15 Seconds'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'js-cycle15s'
,p_group_id=>wwv_flow_imp.id(4395552459880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34448186235496690)
,p_theme_id=>42
,p_name=>'20_SECONDS'
,p_display_name=>'20 Seconds'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'js-cycle20s'
,p_group_id=>wwv_flow_imp.id(4395552459880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34448525003496690)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34448793387496690)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34448950609496690)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34449111690496691)
,p_theme_id=>42
,p_name=>'5_SECONDS'
,p_display_name=>'5 Seconds'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'js-cycle5s'
,p_group_id=>wwv_flow_imp.id(4395552459880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34449356386496691)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34449793666496691)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34449992256496691)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
end;
/
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34450101016496691)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34450395137496691)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34450595253496691)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34450972951496691)
,p_theme_id=>42
,p_name=>'HIDDENHEADERNOAT'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--removeHeader'
,p_group_id=>wwv_flow_imp.id(4385555254880894)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34451310220496691)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_imp.id(4381517600880893)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34451509023496692)
,p_theme_id=>42
,p_name=>'HIDEREGIONHEADER'
,p_display_name=>'Hidden but accessible'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(4385555254880894)
,p_template_types=>'REGION'
,p_help_text=>'This option will hide the region header.  Note that the region title will still be audible for Screen Readers. Buttons placed in the region header will be hidden and inaccessible.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34451701802496692)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34451945038496692)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34452115577496692)
,p_theme_id=>42
,p_name=>'REMEMBER_CAROUSEL_SLIDE'
,p_display_name=>'Remember Carousel Slide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'js-useLocalStorage'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34452384123496692)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_imp.id(4381517600880893)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34452554183496692)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Region Header to maximize the region. Clicking this button will toggle the maximize state and stretch the region to fill the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34452790672496693)
,p_theme_id=>42
,p_name=>'SHOW_NEXT_AND_PREVIOUS_BUTTONS'
,p_display_name=>'Show Next and Previous Buttons'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--showCarouselControls'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34453192523496693)
,p_theme_id=>42
,p_name=>'SLIDE'
,p_display_name=>'Slide'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--carouselSlide'
,p_group_id=>wwv_flow_imp.id(4380706983880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34453392018496693)
,p_theme_id=>42
,p_name=>'SPIN'
,p_display_name=>'Spin'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--carouselSpin'
,p_group_id=>wwv_flow_imp.id(4380706983880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34453553257496693)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34453732913496693)
,p_theme_id=>42
,p_name=>'SHOW_REGION_ICON'
,p_display_name=>'Show Region Icon'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_imp.id(34446604670496689)
,p_css_classes=>'t-Region--showIcon'
,p_template_types=>'REGION'
,p_help_text=>'Displays the region icon in the region header beside the region title'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34454764049496693)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34454908320496693)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34455190634496694)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
,p_help_text=>'Sets body height to 480px.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34455382183496694)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
,p_help_text=>'Sets body height to 640px.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34455515809496694)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34455758723496694)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34455998639496694)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34456143398496694)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34456399979496694)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34456733991496694)
,p_theme_id=>42
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_imp.id(4383974852880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34457127447496694)
,p_theme_id=>42
,p_name=>'CONRTOLS_POSITION_END'
,p_display_name=>'End'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--controlsPosEnd'
,p_group_id=>wwv_flow_imp.id(4383514281880893)
,p_template_types=>'REGION'
,p_help_text=>'Position the expand / collapse button to the end of the region header.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34457379002496694)
,p_theme_id=>42
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_imp.id(4383974852880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34457531343496694)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_imp.id(4381517600880893)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34457986600496694)
,p_theme_id=>42
,p_name=>'ICONS_PLUS_OR_MINUS'
,p_display_name=>'Plus or Minus'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--hideShowIconsMath'
,p_group_id=>wwv_flow_imp.id(4383164010880893)
,p_template_types=>'REGION'
,p_help_text=>'Use the plus and minus icons for the expand and collapse button.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34458132756496695)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34458370116496695)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34458597691496695)
,p_theme_id=>42
,p_name=>'REMEMBER_COLLAPSIBLE_STATE'
,p_display_name=>'Remember Collapsible State'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'js-useLocalStorage'
,p_template_types=>'REGION'
,p_help_text=>'This option saves the current state of the collapsible region for the duration of the session.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34458775124496695)
,p_theme_id=>42
,p_name=>'REMOVE_UI_DECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--noUI'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes UI decoration (borders, backgrounds, shadows, etc) from the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34458969644496695)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll - Default'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_imp.id(4381517600880893)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34459108806496695)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34453825801496693)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34459553261496695)
,p_theme_id=>42
,p_name=>'ADD_BODY_PADDING'
,p_display_name=>'Add Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34459258426496695)
,p_css_classes=>'t-ContentBlock--padded'
,p_template_types=>'REGION'
,p_help_text=>'Adds padding to the region''s body container.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34459934494496695)
,p_theme_id=>42
,p_name=>'CONTENT_TITLE_H1'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34459258426496695)
,p_css_classes=>'t-ContentBlock--h1'
,p_group_id=>wwv_flow_imp.id(4393509813880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34460187234496695)
,p_theme_id=>42
,p_name=>'CONTENT_TITLE_H2'
,p_display_name=>'Medium'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34459258426496695)
,p_css_classes=>'t-ContentBlock--h2'
,p_group_id=>wwv_flow_imp.id(4393509813880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34460317298496695)
,p_theme_id=>42
,p_name=>'CONTENT_TITLE_H3'
,p_display_name=>'Small'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34459258426496695)
,p_css_classes=>'t-ContentBlock--h3'
,p_group_id=>wwv_flow_imp.id(4393509813880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34460708046496696)
,p_theme_id=>42
,p_name=>'LIGHT_BACKGROUND'
,p_display_name=>'Light Background'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34459258426496695)
,p_css_classes=>'t-ContentBlock--lightBG'
,p_group_id=>wwv_flow_imp.id(4382305873880893)
,p_template_types=>'REGION'
,p_help_text=>'Gives the region body a slightly lighter background.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34460903488496696)
,p_theme_id=>42
,p_name=>'SHADOW_BACKGROUND'
,p_display_name=>'Shadow Background'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34459258426496695)
,p_css_classes=>'t-ContentBlock--shadowBG'
,p_group_id=>wwv_flow_imp.id(4382305873880893)
,p_template_types=>'REGION'
,p_help_text=>'Gives the region body a slightly darker background.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34461114351496696)
,p_theme_id=>42
,p_name=>'SHOW_REGION_ICON'
,p_display_name=>'Show Region Icon'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34459258426496695)
,p_css_classes=>'t-ContentBlock--showIcon'
,p_template_types=>'REGION'
,p_help_text=>'Displays the region icon in the region header beside the region title'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34462009994496696)
,p_theme_id=>42
,p_name=>'DISPLAY_ICON_NO'
,p_display_name=>'No'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34461241212496696)
,p_css_classes=>'t-HeroRegion--hideIcon'
,p_group_id=>wwv_flow_imp.id(4384783221880894)
,p_template_types=>'REGION'
,p_help_text=>'Hide the Hero Region icon.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34462250314496696)
,p_theme_id=>42
,p_name=>'FEATURED'
,p_display_name=>'Featured'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34461241212496696)
,p_css_classes=>'t-HeroRegion--featured'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34462640639496697)
,p_theme_id=>42
,p_name=>'ICONS_CIRCULAR'
,p_display_name=>'Circle'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34461241212496696)
,p_css_classes=>'t-HeroRegion--iconsCircle'
,p_group_id=>wwv_flow_imp.id(4387195497880894)
,p_template_types=>'REGION'
,p_help_text=>'The icons are displayed within a circle.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34462880844496697)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34461241212496696)
,p_css_classes=>'t-HeroRegion--iconsSquare'
,p_group_id=>wwv_flow_imp.id(4387195497880894)
,p_template_types=>'REGION'
,p_help_text=>'The icons are displayed within a square.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34463069683496697)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34461241212496696)
,p_css_classes=>'t-HeroRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the hero region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34463248102496697)
,p_theme_id=>42
,p_name=>'STACKED_FEATURED'
,p_display_name=>'Stacked Featured'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34461241212496696)
,p_css_classes=>'t-HeroRegion--featured t-HeroRegion--centered'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34463929335496697)
,p_theme_id=>42
,p_name=>'AUTO_HEIGHT_INLINE_DIALOG'
,p_display_name=>'Auto Height'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34463394363496697)
,p_css_classes=>'js-dialog-autoheight'
,p_template_types=>'REGION'
,p_help_text=>'This option will set the height of the dialog to fit its contents.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34464118591496697)
,p_theme_id=>42
,p_name=>'DRAGGABLE'
,p_display_name=>'Draggable'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34463394363496697)
,p_css_classes=>'js-draggable'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34464539098496697)
,p_theme_id=>42
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34463394363496697)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34464718710496697)
,p_theme_id=>42
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34463394363496697)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34464954772496697)
,p_theme_id=>42
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34463394363496697)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34465153287496697)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>5
,p_region_template_id=>wwv_flow_imp.id(34463394363496697)
,p_css_classes=>'t-DialogRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the region body.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34465392821496697)
,p_theme_id=>42
,p_name=>'RESIZABLE'
,p_display_name=>'Resizable'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34463394363496697)
,p_css_classes=>'js-resizable'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34465509496496697)
,p_theme_id=>42
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34463394363496697)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34466441282496698)
,p_theme_id=>42
,p_name=>'ABOVE'
,p_display_name=>'Above'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-popup-pos-above'
,p_group_id=>wwv_flow_imp.id(4382786191880893)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout above or typically on top of the parent.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34466655713496698)
,p_theme_id=>42
,p_name=>'AFTER'
,p_display_name=>'After'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-popup-pos-after'
,p_group_id=>wwv_flow_imp.id(4382786191880893)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout after or typically to the right of the parent.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34466864071496698)
,p_theme_id=>42
,p_name=>'AUTO_HEIGHT_INLINE_DIALOG'
,p_display_name=>'Auto Height'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-dialog-autoheight'
,p_template_types=>'REGION'
,p_help_text=>'This option will set the height of the dialog to fit its contents.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34467055486496698)
,p_theme_id=>42
,p_name=>'BEFORE'
,p_display_name=>'Before'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-popup-pos-before'
,p_group_id=>wwv_flow_imp.id(4382786191880893)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout before or typically to the left of the parent.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34467286421496698)
,p_theme_id=>42
,p_name=>'BELOW'
,p_display_name=>'Below'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-popup-pos-below'
,p_group_id=>wwv_flow_imp.id(4382786191880893)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout below or typically to the bottom of the parent.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34467454184496698)
,p_theme_id=>42
,p_name=>'DISPLAY_POPUP_CALLOUT'
,p_display_name=>'Display Popup Callout'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-popup-callout'
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add display a callout for the popup. Note that callout will only be displayed if the data-parent-element custom attribute is defined.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34467629367496698)
,p_theme_id=>42
,p_name=>'INSIDE'
,p_display_name=>'Inside'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-popup-pos-inside'
,p_group_id=>wwv_flow_imp.id(4382786191880893)
,p_template_types=>'REGION'
,p_help_text=>'Positions the callout inside of the parent. This is useful when the parent is sufficiently large, such as a report or large region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34467848242496698)
,p_theme_id=>42
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34468016302496698)
,p_theme_id=>42
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34468274005496698)
,p_theme_id=>42
,p_name=>'NONE'
,p_display_name=>'None'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-dialog-nosize'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34468430113496698)
,p_theme_id=>42
,p_name=>'REMOVE_BODY_PADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'t-DialogRegion--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes the padding around the region body.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34468629300496698)
,p_theme_id=>42
,p_name=>'REMOVE_PAGE_OVERLAY'
,p_display_name=>'Remove Page Overlay'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-popup-noOverlay'
,p_template_types=>'REGION'
,p_help_text=>'This option will display the inline dialog without an overlay on the background.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34468849017496698)
,p_theme_id=>42
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34465699375496697)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_imp.id(4384391075880894)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34469219586496699)
,p_theme_id=>42
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34468943637496698)
,p_css_classes=>'t-IRR-region--noBorders'
,p_template_types=>'REGION'
,p_help_text=>'Removes borders around the Interactive Report'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34469427710496699)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34468943637496698)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Interactive Reports toolbar to maximize the report. Clicking this button will toggle the maximize state and stretch the report to fill the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34470358433496699)
,p_theme_id=>42
,p_name=>'LOGIN_HEADER_ICON'
,p_display_name=>'Icon'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34469502279496699)
,p_css_classes=>'t-Login-region--headerIcon'
,p_group_id=>wwv_flow_imp.id(4391520859880895)
,p_template_types=>'REGION'
,p_help_text=>'Displays only the Region Icon in the Login region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34470540820496699)
,p_theme_id=>42
,p_name=>'LOGIN_HEADER_TITLE'
,p_display_name=>'Title'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34469502279496699)
,p_css_classes=>'t-Login-region--headerTitle js-removeLandmark'
,p_group_id=>wwv_flow_imp.id(4391520859880895)
,p_template_types=>'REGION'
,p_help_text=>'Displays only the Region Title in the Login region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34470764143496699)
,p_theme_id=>42
,p_name=>'LOGO_HEADER_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34469502279496699)
,p_css_classes=>'t-Login-region--headerHidden js-removeLandmark'
,p_group_id=>wwv_flow_imp.id(4391520859880895)
,p_template_types=>'REGION'
,p_help_text=>'Hides both the Region Icon and Title from the Login region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34471760274496700)
,p_theme_id=>42
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'i-h240'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 240px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34471927462496700)
,p_theme_id=>42
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'i-h320'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
,p_help_text=>'Sets region body height to 320px.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34472162076496700)
,p_theme_id=>42
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'i-h480'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34472375762496700)
,p_theme_id=>42
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'i-h640'
,p_group_id=>wwv_flow_imp.id(4381192344880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34472552039496700)
,p_theme_id=>42
,p_name=>'ACCENT_1'
,p_display_name=>'Accent 1'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent1'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34472748683496700)
,p_theme_id=>42
,p_name=>'ACCENT_10'
,p_display_name=>'Accent 10'
,p_display_sequence=>100
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent10'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34472934675496700)
,p_theme_id=>42
,p_name=>'ACCENT_11'
,p_display_name=>'Accent 11'
,p_display_sequence=>110
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent11'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
end;
/
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34473129831496700)
,p_theme_id=>42
,p_name=>'ACCENT_12'
,p_display_name=>'Accent 12'
,p_display_sequence=>120
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent12'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34473336914496700)
,p_theme_id=>42
,p_name=>'ACCENT_13'
,p_display_name=>'Accent 13'
,p_display_sequence=>130
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent13'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34473548685496700)
,p_theme_id=>42
,p_name=>'ACCENT_14'
,p_display_name=>'Accent 14'
,p_display_sequence=>140
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent14'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34473755851496700)
,p_theme_id=>42
,p_name=>'ACCENT_15'
,p_display_name=>'Accent 15'
,p_display_sequence=>150
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent15'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34473993512496700)
,p_theme_id=>42
,p_name=>'ACCENT_2'
,p_display_name=>'Accent 2'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent2'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34474174563496700)
,p_theme_id=>42
,p_name=>'ACCENT_3'
,p_display_name=>'Accent 3'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent3'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34474350268496700)
,p_theme_id=>42
,p_name=>'ACCENT_4'
,p_display_name=>'Accent 4'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent4'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34474518377496700)
,p_theme_id=>42
,p_name=>'ACCENT_5'
,p_display_name=>'Accent 5'
,p_display_sequence=>50
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent5'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34474772793496701)
,p_theme_id=>42
,p_name=>'ACCENT_6'
,p_display_name=>'Accent 6'
,p_display_sequence=>60
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent6'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34474905485496701)
,p_theme_id=>42
,p_name=>'ACCENT_7'
,p_display_name=>'Accent 7'
,p_display_sequence=>70
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent7'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34475199861496701)
,p_theme_id=>42
,p_name=>'ACCENT_8'
,p_display_name=>'Accent 8'
,p_display_sequence=>80
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent8'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34475367323496701)
,p_theme_id=>42
,p_name=>'ACCENT_9'
,p_display_name=>'Accent 9'
,p_display_sequence=>90
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--accent9'
,p_group_id=>wwv_flow_imp.id(4378746899880893)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34475568530496701)
,p_theme_id=>42
,p_name=>'HIDDENHEADERNOAT'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--removeHeader js-removeLandmark'
,p_group_id=>wwv_flow_imp.id(4385555254880894)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34475795783496701)
,p_theme_id=>42
,p_name=>'HIDEOVERFLOW'
,p_display_name=>'Hide'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--hiddenOverflow'
,p_group_id=>wwv_flow_imp.id(4381517600880893)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34475992219496701)
,p_theme_id=>42
,p_name=>'HIDEREGIONHEADER'
,p_display_name=>'Hidden but accessible'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(4385555254880894)
,p_template_types=>'REGION'
,p_help_text=>'This option will hide the region header.  Note that the region title will still be audible for Screen Readers. Buttons placed in the region header will be hidden and inaccessible.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34476114379496701)
,p_theme_id=>42
,p_name=>'NOBODYPADDING'
,p_display_name=>'Remove Body Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--noPadding'
,p_template_types=>'REGION'
,p_help_text=>'Removes padding from region body.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34476347104496701)
,p_theme_id=>42
,p_name=>'NOBORDER'
,p_display_name=>'Remove Borders'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes borders from the region.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34476547424496701)
,p_theme_id=>42
,p_name=>'REMOVE_UI_DECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--noUI'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes UI decoration (borders, backgrounds, shadows, etc) from the region.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34476784475496701)
,p_theme_id=>42
,p_name=>'SCROLLBODY'
,p_display_name=>'Scroll - Default'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--scrollBody'
,p_group_id=>wwv_flow_imp.id(4381517600880893)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34476941402496701)
,p_theme_id=>42
,p_name=>'SHOW_MAXIMIZE_BUTTON'
,p_display_name=>'Show Maximize Button'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'js-showMaximizeButton'
,p_template_types=>'REGION'
,p_help_text=>'Displays a button in the Region Header to maximize the region. Clicking this button will toggle the maximize state and stretch the region to fill the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34477168969496701)
,p_theme_id=>42
,p_name=>'SHOW_REGION_ICON'
,p_display_name=>'Show Region Icon'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--showIcon'
,p_template_types=>'REGION'
,p_help_text=>'Displays the region icon in the region header beside the region title'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34477378278496701)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stack Region'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--stacked'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
,p_help_text=>'Removes side borders and shadows, and can be useful for accordions and regions that need to be grouped together vertically.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34477574448496701)
,p_theme_id=>42
,p_name=>'TEXT_CONTENT'
,p_display_name=>'Text Content'
,p_display_sequence=>40
,p_region_template_id=>wwv_flow_imp.id(34470894408496699)
,p_css_classes=>'t-Region--textContent'
,p_group_id=>wwv_flow_imp.id(4394399631880895)
,p_template_types=>'REGION'
,p_help_text=>'Useful for displaying primarily text-based content, such as FAQs and more.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34478797573496702)
,p_theme_id=>42
,p_name=>'FILL_TAB_LABELS'
,p_display_name=>'Fill Tab Labels'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34477636372496701)
,p_css_classes=>'t-TabsRegion-mod--fillLabels'
,p_group_id=>wwv_flow_imp.id(4391118877880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34479136471496702)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Pill'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34477636372496701)
,p_css_classes=>'t-TabsRegion-mod--pill'
,p_group_id=>wwv_flow_imp.id(4395153472880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34479334347496702)
,p_theme_id=>42
,p_name=>'REMEMBER_ACTIVE_TAB'
,p_display_name=>'Remember Active Tab'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34477636372496701)
,p_css_classes=>'js-useLocalStorage'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34479583583496702)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34477636372496701)
,p_css_classes=>'t-TabsRegion-mod--simple'
,p_group_id=>wwv_flow_imp.id(4395153472880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34479924932496702)
,p_theme_id=>42
,p_name=>'TABSLARGE'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34477636372496701)
,p_css_classes=>'t-TabsRegion-mod--large'
,p_group_id=>wwv_flow_imp.id(4394751244880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34480157006496702)
,p_theme_id=>42
,p_name=>'TABS_SMALL'
,p_display_name=>'Small'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34477636372496701)
,p_css_classes=>'t-TabsRegion-mod--small'
,p_group_id=>wwv_flow_imp.id(4394751244880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34480522222496703)
,p_theme_id=>42
,p_name=>'GET_TITLE_FROM_BREADCRUMB'
,p_display_name=>'Use Current Breadcrumb Entry'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34480263758496702)
,p_css_classes=>'t-BreadcrumbRegion--useBreadcrumbTitle'
,p_group_id=>wwv_flow_imp.id(4393509813880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34480791438496703)
,p_theme_id=>42
,p_name=>'HIDE_BREADCRUMB'
,p_display_name=>'Show Breadcrumbs'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34480263758496702)
,p_css_classes=>'t-BreadcrumbRegion--showBreadcrumb'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34480969397496703)
,p_theme_id=>42
,p_name=>'REGION_HEADER_VISIBLE'
,p_display_name=>'Use Region Title'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(34480263758496702)
,p_css_classes=>'t-BreadcrumbRegion--useRegionTitle'
,p_group_id=>wwv_flow_imp.id(4393509813880895)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34481132541496703)
,p_theme_id=>42
,p_name=>'USE_COMPACT_STYLE'
,p_display_name=>'Use Compact Style'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34480263758496702)
,p_css_classes=>'t-BreadcrumbRegion--compactTitle'
,p_template_types=>'REGION'
,p_help_text=>'Uses a compact style for the breadcrumbs.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34482053272496703)
,p_theme_id=>42
,p_name=>'HIDESMALLSCREENS'
,p_display_name=>'Small Screens (Tablet)'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(34481214685496703)
,p_css_classes=>'t-Wizard--hideStepsSmall'
,p_group_id=>wwv_flow_imp.id(4386713098880894)
,p_template_types=>'REGION'
,p_help_text=>'Hides the wizard progress steps for screens that are smaller than 768px wide.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34482228190496703)
,p_theme_id=>42
,p_name=>'HIDEXSMALLSCREENS'
,p_display_name=>'X Small Screens (Mobile)'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34481214685496703)
,p_css_classes=>'t-Wizard--hideStepsXSmall'
,p_group_id=>wwv_flow_imp.id(4386713098880894)
,p_template_types=>'REGION'
,p_help_text=>'Hides the wizard progress steps for screens that are smaller than 768px wide.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34482411627496703)
,p_theme_id=>42
,p_name=>'SHOW_TITLE'
,p_display_name=>'Show Title'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(34481214685496703)
,p_css_classes=>'t-Wizard--showTitle'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34483004585496705)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(34482593254496704)
,p_css_classes=>'t-Timeline--compact'
,p_group_id=>wwv_flow_imp.id(4405129962880897)
,p_template_types=>'REPORT'
,p_help_text=>'Displays a compact version of timeline with smaller text and fewer columns.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34483691274496705)
,p_theme_id=>42
,p_name=>'ACTIONS_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_imp.id(34483175886496705)
,p_css_classes=>'t-ContentRow--hideActions'
,p_group_id=>wwv_flow_imp.id(4397946337880896)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Actions column from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34484011825496705)
,p_theme_id=>42
,p_name=>'ALIGNMENT_TOP'
,p_display_name=>'Top'
,p_display_sequence=>100
,p_report_template_id=>wwv_flow_imp.id(34483175886496705)
,p_css_classes=>'t-ContentRow--alignTop'
,p_group_id=>wwv_flow_imp.id(4400733285880896)
,p_template_types=>'REPORT'
,p_help_text=>'Aligns the content to the top of the row. This is useful when you expect that yours rows will vary in height (e.g. some rows will have longer descriptions than others).'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34484413908496706)
,p_theme_id=>42
,p_name=>'DESCRIPTION_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(34483175886496705)
,p_css_classes=>'t-ContentRow--hideDescription'
,p_group_id=>wwv_flow_imp.id(4398351284880896)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Description from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34484857962496706)
,p_theme_id=>42
,p_name=>'ICON_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34483175886496705)
,p_css_classes=>'t-ContentRow--hideIcon'
,p_group_id=>wwv_flow_imp.id(4399101338880896)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Icon from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34485215330496706)
,p_theme_id=>42
,p_name=>'MISC_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(34483175886496705)
,p_css_classes=>'t-ContentRow--hideMisc'
,p_group_id=>wwv_flow_imp.id(4399503657880896)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Misc column from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34485637878496706)
,p_theme_id=>42
,p_name=>'SELECTION_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34483175886496705)
,p_css_classes=>'t-ContentRow--hideSelection'
,p_group_id=>wwv_flow_imp.id(4399958774880896)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Selection column from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34485805958496706)
,p_theme_id=>42
,p_name=>'STYLE_COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(34483175886496705)
,p_css_classes=>'t-ContentRow--styleCompact'
,p_group_id=>wwv_flow_imp.id(4405129962880897)
,p_template_types=>'REPORT'
,p_help_text=>'This option reduces the padding and font sizes to present a compact display of the same information.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34486276687496706)
,p_theme_id=>42
,p_name=>'TITLE_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34483175886496705)
,p_css_classes=>'t-ContentRow--hideTitle'
,p_group_id=>wwv_flow_imp.id(4398788782880896)
,p_template_types=>'REPORT'
,p_help_text=>'Hides the Title from being rendered on the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34486860631496707)
,p_theme_id=>42
,p_name=>'2_COLUMN_GRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--cols t-MediaList--2cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34487071180496707)
,p_theme_id=>42
,p_name=>'3_COLUMN_GRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--cols t-MediaList--3cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34487280831496707)
,p_theme_id=>42
,p_name=>'4_COLUMN_GRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--cols t-MediaList--4cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34487413484496707)
,p_theme_id=>42
,p_name=>'5_COLUMN_GRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--cols t-MediaList--5cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34487625602496707)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'u-colors'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34488036789496708)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--iconsRounded'
,p_group_id=>wwv_flow_imp.id(4402311321880897)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34488297237496708)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--iconsSquare'
,p_group_id=>wwv_flow_imp.id(4402311321880897)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34488649472496708)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--large force-fa-lg'
,p_group_id=>wwv_flow_imp.id(4404780661880897)
,p_template_types=>'REPORT'
,p_help_text=>'Increases the size of the text and icons in the list.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34488819691496708)
,p_theme_id=>42
,p_name=>'SHOW_BADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--showBadges'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34489000193496708)
,p_theme_id=>42
,p_name=>'SHOW_DESCRIPTION'
,p_display_name=>'Show Description'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--showDesc'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34489232965496708)
,p_theme_id=>42
,p_name=>'SHOW_ICONS'
,p_display_name=>'Show Icons'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--showIcons'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34489460870496708)
,p_theme_id=>42
,p_name=>'SPAN_HORIZONTAL'
,p_display_name=>'Span Horizontal'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--horizontal'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34489662193496708)
,p_theme_id=>42
,p_name=>'STACK'
,p_display_name=>'Stack'
,p_display_sequence=>5
,p_report_template_id=>wwv_flow_imp.id(34486308002496706)
,p_css_classes=>'t-MediaList--stack'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34490254889496708)
,p_theme_id=>42
,p_name=>'FIXED_LARGE'
,p_display_name=>'Fixed - Large'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34489733747496708)
,p_css_classes=>'t-AVPList--fixedLabelLarge'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34490412329496708)
,p_theme_id=>42
,p_name=>'FIXED_MEDIUM'
,p_display_name=>'Fixed - Medium'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34489733747496708)
,p_css_classes=>'t-AVPList--fixedLabelMedium'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34490692951496709)
,p_theme_id=>42
,p_name=>'FIXED_SMALL'
,p_display_name=>'Fixed - Small'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34489733747496708)
,p_css_classes=>'t-AVPList--fixedLabelSmall'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34490802085496709)
,p_theme_id=>42
,p_name=>'LEFT_ALIGNED_DETAILS'
,p_display_name=>'Left Aligned Details'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34489733747496708)
,p_css_classes=>'t-AVPList--leftAligned'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34491089133496709)
,p_theme_id=>42
,p_name=>'RIGHT_ALIGNED_DETAILS'
,p_display_name=>'Right Aligned Details'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34489733747496708)
,p_css_classes=>'t-AVPList--rightAligned'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34491295068496709)
,p_theme_id=>42
,p_name=>'VARIABLE_LARGE'
,p_display_name=>'Variable - Large'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_imp.id(34489733747496708)
,p_css_classes=>'t-AVPList--variableLabelLarge'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34491457972496709)
,p_theme_id=>42
,p_name=>'VARIABLE_MEDIUM'
,p_display_name=>'Variable - Medium'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(34489733747496708)
,p_css_classes=>'t-AVPList--variableLabelMedium'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34491630934496709)
,p_theme_id=>42
,p_name=>'VARIABLE_SMALL'
,p_display_name=>'Variable - Small'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(34489733747496708)
,p_css_classes=>'t-AVPList--variableLabelSmall'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34492041172496709)
,p_theme_id=>42
,p_name=>'FIXED_LARGE'
,p_display_name=>'Fixed - Large'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34491737799496709)
,p_css_classes=>'t-AVPList--fixedLabelLarge'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34492255676496709)
,p_theme_id=>42
,p_name=>'FIXED_MEDIUM'
,p_display_name=>'Fixed - Medium'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34491737799496709)
,p_css_classes=>'t-AVPList--fixedLabelMedium'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34492494894496709)
,p_theme_id=>42
,p_name=>'FIXED_SMALL'
,p_display_name=>'Fixed - Small'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34491737799496709)
,p_css_classes=>'t-AVPList--fixedLabelSmall'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34492628603496709)
,p_theme_id=>42
,p_name=>'LEFT_ALIGNED_DETAILS'
,p_display_name=>'Left Aligned Details'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34491737799496709)
,p_css_classes=>'t-AVPList--leftAligned'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34492872263496709)
,p_theme_id=>42
,p_name=>'RIGHT_ALIGNED_DETAILS'
,p_display_name=>'Right Aligned Details'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34491737799496709)
,p_css_classes=>'t-AVPList--rightAligned'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34493094051496709)
,p_theme_id=>42
,p_name=>'VARIABLE_LARGE'
,p_display_name=>'Variable - Large'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_imp.id(34491737799496709)
,p_css_classes=>'t-AVPList--variableLabelLarge'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34493285162496709)
,p_theme_id=>42
,p_name=>'VARIABLE_MEDIUM'
,p_display_name=>'Variable - Medium'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(34491737799496709)
,p_css_classes=>'t-AVPList--variableLabelMedium'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34493487868496709)
,p_theme_id=>42
,p_name=>'VARIABLE_SMALL'
,p_display_name=>'Variable - Small'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(34491737799496709)
,p_css_classes=>'t-AVPList--variableLabelSmall'
,p_group_id=>wwv_flow_imp.id(4402753334880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34494067469496710)
,p_theme_id=>42
,p_name=>'128PX'
,p_display_name=>'128px'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--xxlarge'
,p_group_id=>wwv_flow_imp.id(4396753725880896)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34494256132496710)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
,p_help_text=>'Arrange badges in a two column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34494433720496710)
,p_theme_id=>42
,p_name=>'32PX'
,p_display_name=>'32px'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--small'
,p_group_id=>wwv_flow_imp.id(4396753725880896)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34494675872496710)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--3cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
,p_help_text=>'Arrange badges in a 3 column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34494842666496710)
,p_theme_id=>42
,p_name=>'48PX'
,p_display_name=>'48px'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--medium'
,p_group_id=>wwv_flow_imp.id(4396753725880896)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34495099613496710)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--4cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34495238448496710)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--5cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34495414595496710)
,p_theme_id=>42
,p_name=>'64PX'
,p_display_name=>'64px'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--large'
,p_group_id=>wwv_flow_imp.id(4396753725880896)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34495675067496710)
,p_theme_id=>42
,p_name=>'96PX'
,p_display_name=>'96px'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--xlarge'
,p_group_id=>wwv_flow_imp.id(4396753725880896)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34495851400496710)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'u-colors'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34496094751496710)
,p_theme_id=>42
,p_name=>'CIRCULAR'
,p_display_name=>'Circular'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--circular'
,p_group_id=>wwv_flow_imp.id(4405129962880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34496244688496710)
,p_theme_id=>42
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--fixed'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34496455140496710)
,p_theme_id=>42
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>80
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--flex'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34496697072496710)
,p_theme_id=>42
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>70
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--float'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34496876215496710)
,p_theme_id=>42
,p_name=>'GRID'
,p_display_name=>'Grid'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--dash'
,p_group_id=>wwv_flow_imp.id(4405129962880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34497046577496711)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34493537954496709)
,p_css_classes=>'t-BadgeList--stacked'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34497656497496711)
,p_theme_id=>42
,p_name=>'ALTROWCOLORSDISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34497185132496711)
,p_css_classes=>'t-Report--staticRowColors'
,p_group_id=>wwv_flow_imp.id(4395956793880895)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34497840106496711)
,p_theme_id=>42
,p_name=>'ALTROWCOLORSENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34497185132496711)
,p_css_classes=>'t-Report--altRowsDefault'
,p_group_id=>wwv_flow_imp.id(4395956793880895)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34498238235496711)
,p_theme_id=>42
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34497185132496711)
,p_css_classes=>'t-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(4404340748880897)
,p_template_types=>'REPORT'
,p_help_text=>'Enable row highlighting on mouse over'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34498686241496711)
,p_theme_id=>42
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Only'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34497185132496711)
,p_css_classes=>'t-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(4403941480880897)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34498840995496711)
,p_theme_id=>42
,p_name=>'REMOVEALLBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34497185132496711)
,p_css_classes=>'t-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(4403941480880897)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34499058633496711)
,p_theme_id=>42
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'No Outer Borders'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(34497185132496711)
,p_css_classes=>'t-Report--inline'
,p_group_id=>wwv_flow_imp.id(4403941480880897)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34499286126496711)
,p_theme_id=>42
,p_name=>'ROWHIGHLIGHTDISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34497185132496711)
,p_css_classes=>'t-Report--rowHighlightOff'
,p_group_id=>wwv_flow_imp.id(4404340748880897)
,p_template_types=>'REPORT'
,p_help_text=>'Disable row highlighting on mouse over'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34499401468496712)
,p_theme_id=>42
,p_name=>'STRETCHREPORT'
,p_display_name=>'Stretch Report'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34497185132496711)
,p_css_classes=>'t-Report--stretch'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34499645219496712)
,p_theme_id=>42
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Only'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34497185132496711)
,p_css_classes=>'t-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(4403941480880897)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34500226094496712)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34499723622496712)
,p_css_classes=>'t-Comments--basic'
,p_group_id=>wwv_flow_imp.id(4400319458880896)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34500463989496712)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34499723622496712)
,p_css_classes=>'t-Comments--iconsRounded'
,p_group_id=>wwv_flow_imp.id(4402311321880897)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34500661544496712)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34499723622496712)
,p_css_classes=>'t-Comments--iconsSquare'
,p_group_id=>wwv_flow_imp.id(4402311321880897)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34500805697496712)
,p_theme_id=>42
,p_name=>'SPEECH_BUBBLES'
,p_display_name=>'Speech Bubbles'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34499723622496712)
,p_css_classes=>'t-Comments--chat'
,p_group_id=>wwv_flow_imp.id(4400319458880896)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34501412950496713)
,p_theme_id=>42
,p_name=>'2_COLUMNS'
,p_display_name=>'2 Columns'
,p_display_sequence=>15
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34501838741496713)
,p_theme_id=>42
,p_name=>'2_LINES'
,p_display_name=>'2 Lines'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--desc-2ln'
,p_group_id=>wwv_flow_imp.id(4397167182880896)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34502065596496713)
,p_theme_id=>42
,p_name=>'3_COLUMNS'
,p_display_name=>'3 Columns'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--3cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34502260450496713)
,p_theme_id=>42
,p_name=>'3_LINES'
,p_display_name=>'3 Lines'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--desc-3ln'
,p_group_id=>wwv_flow_imp.id(4397167182880896)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34502419820496713)
,p_theme_id=>42
,p_name=>'4_COLUMNS'
,p_display_name=>'4 Columns'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--4cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34502699045496713)
,p_theme_id=>42
,p_name=>'4_LINES'
,p_display_name=>'4 Lines'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--desc-4ln'
,p_group_id=>wwv_flow_imp.id(4397167182880896)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34502831727496713)
,p_theme_id=>42
,p_name=>'5_COLUMNS'
,p_display_name=>'5 Columns'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--5cols'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34503001086496713)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--basic'
,p_group_id=>wwv_flow_imp.id(4405129962880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34503257528496713)
,p_theme_id=>42
,p_name=>'BLOCK'
,p_display_name=>'Block'
,p_display_sequence=>40
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--featured t-Cards--block force-fa-lg'
,p_group_id=>wwv_flow_imp.id(4405129962880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34503600635496713)
,p_theme_id=>42
,p_name=>'CARDS_COLOR_FILL'
,p_display_name=>'Color Fill'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--animColorFill'
,p_group_id=>wwv_flow_imp.id(4396327358880896)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34503882157496713)
,p_theme_id=>42
,p_name=>'CARD_RAISE_CARD'
,p_display_name=>'Raise Card'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--animRaiseCard'
,p_group_id=>wwv_flow_imp.id(4396327358880896)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34504058197496713)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--compact'
,p_group_id=>wwv_flow_imp.id(4405129962880897)
,p_template_types=>'REPORT'
,p_help_text=>'Use this option when you want to show smaller cards.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34504454995496714)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--displayIcons'
,p_group_id=>wwv_flow_imp.id(4401986340880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34504658511496714)
,p_theme_id=>42
,p_name=>'DISPLAY_INITIALS'
,p_display_name=>'Display Initials'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--displayInitials'
,p_group_id=>wwv_flow_imp.id(4401986340880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34504866079496714)
,p_theme_id=>42
,p_name=>'DISPLAY_SUBTITLE'
,p_display_name=>'Display Subtitle'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--displaySubtitle'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34505031415496714)
,p_theme_id=>42
,p_name=>'FEATURED'
,p_display_name=>'Featured'
,p_display_sequence=>30
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--featured force-fa-lg'
,p_group_id=>wwv_flow_imp.id(4405129962880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34505255052496714)
,p_theme_id=>42
,p_name=>'FLOAT'
,p_display_name=>'Float'
,p_display_sequence=>60
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--float'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34505438189496714)
,p_theme_id=>42
,p_name=>'HIDDEN_BODY_TEXT'
,p_display_name=>'Hidden'
,p_display_sequence=>50
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--hideBody'
,p_group_id=>wwv_flow_imp.id(4397167182880896)
,p_template_types=>'REPORT'
,p_help_text=>'This option hides the card body which contains description and subtext.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34505612626496714)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--iconsRounded'
,p_group_id=>wwv_flow_imp.id(4402311321880897)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34505875284496714)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--iconsSquare'
,p_group_id=>wwv_flow_imp.id(4402311321880897)
,p_template_types=>'REPORT'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34506050968496714)
,p_theme_id=>42
,p_name=>'SPAN_HORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>70
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'t-Cards--spanHorizontally'
,p_group_id=>wwv_flow_imp.id(4403190791880897)
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34506295326496714)
,p_theme_id=>42
,p_name=>'USE_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_report_template_id=>wwv_flow_imp.id(34501116948496712)
,p_css_classes=>'u-colors'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34507021644496717)
,p_theme_id=>42
,p_name=>'DISPLAY_LABELS_SM'
,p_display_name=>'Display labels'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(34506500773496715)
,p_css_classes=>'t-NavTabs--displayLabels-sm'
,p_group_id=>wwv_flow_imp.id(4375156122880892)
,p_template_types=>'LIST'
,p_help_text=>'Displays the label for the list items below the icon'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34507249161496717)
,p_theme_id=>42
,p_name=>'HIDE_LABELS_SM'
,p_display_name=>'Do not display labels'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(34506500773496715)
,p_css_classes=>'t-NavTabs--hiddenLabels-sm'
,p_group_id=>wwv_flow_imp.id(4375156122880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34507630625496717)
,p_theme_id=>42
,p_name=>'LABEL_ABOVE_LG'
,p_display_name=>'Display labels above'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34506500773496715)
,p_css_classes=>'t-NavTabs--stacked'
,p_group_id=>wwv_flow_imp.id(4372342136880892)
,p_template_types=>'LIST'
,p_help_text=>'Display the label stacked above the icon and badge'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34507836712496717)
,p_theme_id=>42
,p_name=>'LABEL_INLINE_LG'
,p_display_name=>'Display labels inline'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34506500773496715)
,p_css_classes=>'t-NavTabs--inlineLabels-lg'
,p_group_id=>wwv_flow_imp.id(4372342136880892)
,p_template_types=>'LIST'
,p_help_text=>'Display the label inline with the icon and badge'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34508057599496717)
,p_theme_id=>42
,p_name=>'NO_LABEL_LG'
,p_display_name=>'Do not display labels'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34506500773496715)
,p_css_classes=>'t-NavTabs--hiddenLabels-lg'
,p_group_id=>wwv_flow_imp.id(4372342136880892)
,p_template_types=>'LIST'
,p_help_text=>'Hides the label for the list item'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34508687225496718)
,p_theme_id=>42
,p_name=>'2_COLUMNS'
,p_display_name=>'2 Columns'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34508146556496717)
,p_css_classes=>'t-MegaMenu--layout2Cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34508811240496718)
,p_theme_id=>42
,p_name=>'3_COLUMNS'
,p_display_name=>'3 Columns'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34508146556496717)
,p_css_classes=>'t-MegaMenu--layout3Cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34509056575496718)
,p_theme_id=>42
,p_name=>'4_COLUMNS'
,p_display_name=>'4 Columns'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34508146556496717)
,p_css_classes=>'t-MegaMenu--layout4Cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34509239616496718)
,p_theme_id=>42
,p_name=>'5_COLUMNS'
,p_display_name=>'5 Columns'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(34508146556496717)
,p_css_classes=>'t-MegaMenu--layout5Cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34509488236496718)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(34508146556496717)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34509683891496718)
,p_theme_id=>42
,p_name=>'CUSTOM'
,p_display_name=>'Custom'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_imp.id(34508146556496717)
,p_css_classes=>'t-MegaMenu--layoutCustom'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34509841935496718)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34508146556496717)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Displays a callout arrow that points to where the menu was activated from.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34510092901496718)
,p_theme_id=>42
,p_name=>'FULL_WIDTH'
,p_display_name=>'Full Width'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34508146556496717)
,p_css_classes=>'t-MegaMenu--fullWidth'
,p_template_types=>'LIST'
,p_help_text=>'Stretches the menu to fill the width of the screen.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34510231437496718)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_imp.id(34508146556496717)
,p_css_classes=>'t-MegaMenu--layoutStacked'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34510884173496719)
,p_theme_id=>42
,p_name=>'ALLSTEPS'
,p_display_name=>'All Steps'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34510365144496718)
,p_css_classes=>'t-WizardSteps--displayLabels'
,p_group_id=>wwv_flow_imp.id(4374322786880892)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34511059384496719)
,p_theme_id=>42
,p_name=>'CURRENTSTEPONLY'
,p_display_name=>'Current Step Only'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34510365144496718)
,p_css_classes=>'t-WizardSteps--displayCurrentLabelOnly'
,p_group_id=>wwv_flow_imp.id(4374322786880892)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34511255400496719)
,p_theme_id=>42
,p_name=>'HIDELABELS'
,p_display_name=>'Hide Labels'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34510365144496718)
,p_css_classes=>'t-WizardSteps--hideLabels'
,p_group_id=>wwv_flow_imp.id(4374322786880892)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34511415903496719)
,p_theme_id=>42
,p_name=>'VERTICAL_LIST'
,p_display_name=>'Vertical Orientation'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34510365144496718)
,p_css_classes=>'t-WizardSteps--vertical'
,p_template_types=>'LIST'
,p_help_text=>'Displays the wizard progress list in a vertical orientation and is suitable for displaying within a side column of a page.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34511620639496719)
,p_theme_id=>42
,p_name=>'WIZARD_PROGRESS_LINKS'
,p_display_name=>'Make Wizard Steps Clickable'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(34510365144496718)
,p_css_classes=>'js-wizardProgressLinks'
,p_template_types=>'LIST'
,p_help_text=>'This option will make the wizard steps clickable links.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34512049299496720)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(34511796491496719)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34512252928496720)
,p_theme_id=>42
,p_name=>'BEHAVE_LIKE_TABS'
,p_display_name=>'Behave Like Tabs'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34511796491496719)
,p_css_classes=>'js-tabLike'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34512417501496720)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(34511796491496719)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34512671069496720)
,p_theme_id=>42
,p_name=>'SHOW_SUB_MENU_ICONS'
,p_display_name=>'Show Sub Menu Icons'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34511796491496719)
,p_css_classes=>'js-showSubMenuIcons'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34513014588496720)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a two column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34513228070496721)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--3cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a 3 column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34513403719496721)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--4cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in 4 column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34513624648496721)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--cols t-BadgeList--5cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_help_text=>'Arrange badges in a 5 column grid'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34513866640496721)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'u-colors'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34514221006496721)
,p_theme_id=>42
,p_name=>'CIRCULAR'
,p_display_name=>'Circular'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--circular'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34514405321496721)
,p_theme_id=>42
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--fixed'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_help_text=>'Span badges horizontally'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34514680603496721)
,p_theme_id=>42
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>80
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--flex'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_help_text=>'Use flexbox to arrange items'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34514896616496721)
,p_theme_id=>42
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>70
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--float'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_help_text=>'Float badges to left'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34515011389496721)
,p_theme_id=>42
,p_name=>'GRID'
,p_display_name=>'Grid'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--dash'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34515440646496722)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--large'
,p_group_id=>wwv_flow_imp.id(4370702768880891)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34515669238496722)
,p_theme_id=>42
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--medium'
,p_group_id=>wwv_flow_imp.id(4370702768880891)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34515811839496722)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--small'
,p_group_id=>wwv_flow_imp.id(4370702768880891)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34516071856496722)
,p_theme_id=>42
,p_name=>'STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--stacked'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_help_text=>'Stack badges on top of each other'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34516257580496722)
,p_theme_id=>42
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--xlarge'
,p_group_id=>wwv_flow_imp.id(4370702768880891)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34516439759496722)
,p_theme_id=>42
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(34512758622496720)
,p_css_classes=>'t-BadgeList--xxlarge'
,p_group_id=>wwv_flow_imp.id(4370702768880891)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34516860591496722)
,p_theme_id=>42
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'t-MediaList--cols t-MediaList--2cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34517085674496722)
,p_theme_id=>42
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'t-MediaList--cols t-MediaList--3cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34517265597496722)
,p_theme_id=>42
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'t-MediaList--cols t-MediaList--4cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34517466432496722)
,p_theme_id=>42
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'t-MediaList--cols t-MediaList--5cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34517694993496722)
,p_theme_id=>42
,p_name=>'APPLY_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'u-colors'
,p_template_types=>'LIST'
,p_help_text=>'Applies colors from the Theme''s color palette to icons in the list.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34518015044496723)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'t-MediaList--iconsRounded'
,p_group_id=>wwv_flow_imp.id(4373558498880892)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34518261197496723)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'t-MediaList--iconsSquare'
,p_group_id=>wwv_flow_imp.id(4373558498880892)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34518690511496723)
,p_theme_id=>42
,p_name=>'LIST_SIZE_LARGE'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'t-MediaList--large force-fa-lg'
,p_group_id=>wwv_flow_imp.id(4375562439880892)
,p_template_types=>'LIST'
,p_help_text=>'Increases the size of the text and icons in the list.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34518845064496723)
,p_theme_id=>42
,p_name=>'SHOW_BADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'t-MediaList--showBadges'
,p_template_types=>'LIST'
,p_help_text=>'Show a badge (Attribute 2) to the right of the list item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34519026901496723)
,p_theme_id=>42
,p_name=>'SHOW_DESCRIPTION'
,p_display_name=>'Show Description'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'t-MediaList--showDesc'
,p_template_types=>'LIST'
,p_help_text=>'Shows the description (Attribute 1) for each list item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34519298041496723)
,p_theme_id=>42
,p_name=>'SHOW_ICONS'
,p_display_name=>'Show Icons'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'t-MediaList--showIcons'
,p_template_types=>'LIST'
,p_help_text=>'Display an icon next to the list item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34519415648496723)
,p_theme_id=>42
,p_name=>'SPANHORIZONTAL'
,p_display_name=>'Span Horizontal'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(34516580138496722)
,p_css_classes=>'t-MediaList--horizontal'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_help_text=>'Show all list items in one horizontal row.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34519849913496724)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(34519500245496723)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34520004604496724)
,p_theme_id=>42
,p_name=>'COLLAPSED_DEFAULT'
,p_display_name=>'Collapsed by Default'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34519500245496723)
,p_css_classes=>'js-defaultCollapsed'
,p_template_types=>'LIST'
,p_help_text=>'This option will load the side navigation menu in a collapsed state by default.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34520426914496724)
,p_theme_id=>42
,p_name=>'COLLAPSE_STYLE_HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34519500245496723)
,p_css_classes=>'js-navCollapsed--hidden'
,p_group_id=>wwv_flow_imp.id(4371503256880891)
,p_template_types=>'LIST'
,p_help_text=>'Completely hide the navigation menu when it is collapsed.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34520656998496724)
,p_theme_id=>42
,p_name=>'ICON_DEFAULT'
,p_display_name=>'Icon'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34519500245496723)
,p_css_classes=>'js-navCollapsed--default'
,p_group_id=>wwv_flow_imp.id(4371503256880891)
,p_template_types=>'LIST'
,p_help_text=>'Display icons when the navigation menu is collapsed for large screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34520851364496724)
,p_theme_id=>42
,p_name=>'STYLE_A'
,p_display_name=>'Style A'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34519500245496723)
,p_css_classes=>'t-TreeNav--styleA'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
,p_help_text=>'Style Variation A'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34521018621496724)
,p_theme_id=>42
,p_name=>'STYLE_B'
,p_display_name=>'Style B'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34519500245496723)
,p_css_classes=>'t-TreeNav--styleB'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
,p_help_text=>'Style Variation B'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34521252584496724)
,p_theme_id=>42
,p_name=>'STYLE_C'
,p_display_name=>'Classic'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34519500245496723)
,p_css_classes=>'t-TreeNav--classic'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
,p_help_text=>'Classic Style'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34521608977496725)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(34521386518496724)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add shortcuts for menu items. Note that actions.js must be included on your page to support this functionality.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34521864842496725)
,p_theme_id=>42
,p_name=>'BEHAVE_LIKE_TABS'
,p_display_name=>'Behave Like Tabs'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(34521386518496724)
,p_css_classes=>'js-tabLike'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34522064215496725)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(34521386518496724)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34522243950496725)
,p_theme_id=>42
,p_name=>'SHOW_SUB_MENU_ICONS'
,p_display_name=>'Show Sub Menu Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(34521386518496724)
,p_css_classes=>'js-showSubMenuIcons'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34522639616496725)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34522355271496725)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34523076304496725)
,p_theme_id=>42
,p_name=>'2_COLUMNS'
,p_display_name=>'2 Columns'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34523426877496725)
,p_theme_id=>42
,p_name=>'2_LINES'
,p_display_name=>'2 Lines'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--desc-2ln'
,p_group_id=>wwv_flow_imp.id(4371104084880891)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34523668596496725)
,p_theme_id=>42
,p_name=>'3_COLUMNS'
,p_display_name=>'3 Columns'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--3cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34523894578496725)
,p_theme_id=>42
,p_name=>'3_LINES'
,p_display_name=>'3 Lines'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--desc-3ln'
,p_group_id=>wwv_flow_imp.id(4371104084880891)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34524051760496726)
,p_theme_id=>42
,p_name=>'4_COLUMNS'
,p_display_name=>'4 Columns'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--4cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34524270444496726)
,p_theme_id=>42
,p_name=>'4_LINES'
,p_display_name=>'4 Lines'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--desc-4ln'
,p_group_id=>wwv_flow_imp.id(4371104084880891)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34524436005496726)
,p_theme_id=>42
,p_name=>'5_COLUMNS'
,p_display_name=>'5 Columns'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--5cols'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34524652613496726)
,p_theme_id=>42
,p_name=>'BASIC'
,p_display_name=>'Basic'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--basic'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34524868526496726)
,p_theme_id=>42
,p_name=>'BLOCK'
,p_display_name=>'Block'
,p_display_sequence=>40
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--featured t-Cards--block force-fa-lg'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34525071896496726)
,p_theme_id=>42
,p_name=>'CARDS_STACKED'
,p_display_name=>'Stacked'
,p_display_sequence=>5
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--stacked'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_help_text=>'Stacks the cards on top of each other.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34525475694496726)
,p_theme_id=>42
,p_name=>'COLOR_FILL'
,p_display_name=>'Color Fill'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--animColorFill'
,p_group_id=>wwv_flow_imp.id(4370329229880891)
,p_template_types=>'LIST'
,p_help_text=>'Fills the card background with the color of the icon or default link style.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34525697563496726)
,p_theme_id=>42
,p_name=>'COMPACT'
,p_display_name=>'Compact'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--compact'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
,p_help_text=>'Use this option when you want to show smaller cards.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34526086241496726)
,p_theme_id=>42
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--displayIcons'
,p_group_id=>wwv_flow_imp.id(4373171111880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34526206462496726)
,p_theme_id=>42
,p_name=>'DISPLAY_INITIALS'
,p_display_name=>'Display Initials'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--displayInitials'
,p_group_id=>wwv_flow_imp.id(4373171111880892)
,p_template_types=>'LIST'
,p_help_text=>'Initials come from List Attribute 3'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34526409164496726)
,p_theme_id=>42
,p_name=>'DISPLAY_SUBTITLE'
,p_display_name=>'Display Subtitle'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--displaySubtitle'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34526675104496726)
,p_theme_id=>42
,p_name=>'FEATURED'
,p_display_name=>'Featured'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--featured force-fa-lg'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34526813448496726)
,p_theme_id=>42
,p_name=>'FLOAT'
,p_display_name=>'Float'
,p_display_sequence=>60
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--float'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34527016074496726)
,p_theme_id=>42
,p_name=>'HIDDEN_BODY_TEXT'
,p_display_name=>'Hidden'
,p_display_sequence=>50
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--hideBody'
,p_group_id=>wwv_flow_imp.id(4371104084880891)
,p_template_types=>'LIST'
,p_help_text=>'This option hides the card body which contains description and subtext.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34527205405496726)
,p_theme_id=>42
,p_name=>'ICONS_ROUNDED'
,p_display_name=>'Rounded Corners'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--iconsRounded'
,p_group_id=>wwv_flow_imp.id(4373558498880892)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square with rounded corners.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34527448408496727)
,p_theme_id=>42
,p_name=>'ICONS_SQUARE'
,p_display_name=>'Square'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--iconsSquare'
,p_group_id=>wwv_flow_imp.id(4373558498880892)
,p_template_types=>'LIST'
,p_help_text=>'The icons are displayed within a square shape.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34527683765496727)
,p_theme_id=>42
,p_name=>'RAISE_CARD'
,p_display_name=>'Raise Card'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--animRaiseCard'
,p_group_id=>wwv_flow_imp.id(4370329229880891)
,p_template_types=>'LIST'
,p_help_text=>'Raises the card so it pops up.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34527845031496727)
,p_theme_id=>42
,p_name=>'SPAN_HORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>70
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'t-Cards--spanHorizontally'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34528045571496727)
,p_theme_id=>42
,p_name=>'USE_THEME_COLORS'
,p_display_name=>'Apply Theme Colors'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34522739135496725)
,p_css_classes=>'u-colors'
,p_template_types=>'LIST'
,p_help_text=>'Applies the colors from the theme''s color palette to the icons or initials within cards.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34528407529496727)
,p_theme_id=>42
,p_name=>'ABOVE_LABEL'
,p_display_name=>'Above Label'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34528194309496727)
,p_css_classes=>'t-Tabs--iconsAbove'
,p_group_id=>wwv_flow_imp.id(4373171111880892)
,p_template_types=>'LIST'
,p_help_text=>'Places icons above tab label.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34528636640496727)
,p_theme_id=>42
,p_name=>'FILL_LABELS'
,p_display_name=>'Fill Labels'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(34528194309496727)
,p_css_classes=>'t-Tabs--fillLabels'
,p_group_id=>wwv_flow_imp.id(4374735857880892)
,p_template_types=>'LIST'
,p_help_text=>'Stretch tabs to fill to the width of the tabs container.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34528850617496727)
,p_theme_id=>42
,p_name=>'INLINE_WITH_LABEL'
,p_display_name=>'Inline with Label'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34528194309496727)
,p_css_classes=>'t-Tabs--inlineIcons'
,p_group_id=>wwv_flow_imp.id(4373171111880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34529096289496727)
,p_theme_id=>42
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34528194309496727)
,p_css_classes=>'t-Tabs--large'
,p_group_id=>wwv_flow_imp.id(4375562439880892)
,p_template_types=>'LIST'
,p_help_text=>'Increases font size and white space around tab items.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34529229252496727)
,p_theme_id=>42
,p_name=>'PILL'
,p_display_name=>'Pill'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34528194309496727)
,p_css_classes=>'t-Tabs--pill'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
,p_help_text=>'Displays tabs in a pill container.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34529464706496727)
,p_theme_id=>42
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34528194309496727)
,p_css_classes=>'t-Tabs--simple'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
,p_help_text=>'A very simplistic tab UI.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34529644683496727)
,p_theme_id=>42
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>5
,p_list_template_id=>wwv_flow_imp.id(34528194309496727)
,p_css_classes=>'t-Tabs--small'
,p_group_id=>wwv_flow_imp.id(4375562439880892)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34530060262496728)
,p_theme_id=>42
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34529706267496727)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
,p_help_text=>'Enables you to define a keyboard shortcut to activate the menu item.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34530238986496728)
,p_theme_id=>42
,p_name=>'DISPLAY_MENU_CALLOUT'
,p_display_name=>'Display Menu Callout'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34529706267496727)
,p_css_classes=>'js-menu-callout'
,p_template_types=>'LIST'
,p_help_text=>'Use this option to add display a callout for the menu. Note that callout will only be displayed if the data-parent-element custom attribute is defined.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34530695854496728)
,p_theme_id=>42
,p_name=>'ACTIONS'
,p_display_name=>'Actions'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34530385364496728)
,p_css_classes=>'t-LinksList--actions'
,p_group_id=>wwv_flow_imp.id(4375917671880892)
,p_template_types=>'LIST'
,p_help_text=>'Render as actions to be placed on the right side column.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34530836877496728)
,p_theme_id=>42
,p_name=>'DISABLETEXTWRAPPING'
,p_display_name=>'Disable Text Wrapping'
,p_display_sequence=>30
,p_list_template_id=>wwv_flow_imp.id(34530385364496728)
,p_css_classes=>'t-LinksList--nowrap'
,p_template_types=>'LIST'
,p_help_text=>'Do not allow link text to wrap to new lines. Truncate with ellipsis.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34531099823496728)
,p_theme_id=>42
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34530385364496728)
,p_css_classes=>'t-LinksList--showBadge'
,p_template_types=>'LIST'
,p_help_text=>'Show badge to right of link (requires Attribute 1 to be populated)'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34531264944496728)
,p_theme_id=>42
,p_name=>'SHOWGOTOARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34530385364496728)
,p_css_classes=>'t-LinksList--showArrow'
,p_template_types=>'LIST'
,p_help_text=>'Show arrow to the right of link'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34531667837496728)
,p_theme_id=>42
,p_name=>'SHOWICONS'
,p_display_name=>'For All Items'
,p_display_sequence=>20
,p_list_template_id=>wwv_flow_imp.id(34530385364496728)
,p_css_classes=>'t-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(4372712227880892)
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34531897467496728)
,p_theme_id=>42
,p_name=>'SHOWTOPICONS'
,p_display_name=>'For Top Level Items Only'
,p_display_sequence=>10
,p_list_template_id=>wwv_flow_imp.id(34530385364496728)
,p_css_classes=>'t-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(4372712227880892)
,p_template_types=>'LIST'
,p_help_text=>'This will show icons for top level items of the list only. It will not show icons for sub lists.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34533024723496733)
,p_theme_id=>42
,p_name=>'PUSH'
,p_display_name=>'Push'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_imp.id(34532675072496731)
,p_css_classes=>'t-Button--hoverIconPush'
,p_group_id=>wwv_flow_imp.id(4362333366880890)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will animate to the right or left on button hover or focus.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34533276566496733)
,p_theme_id=>42
,p_name=>'SPIN'
,p_display_name=>'Spin'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_imp.id(34532675072496731)
,p_css_classes=>'t-Button--hoverIconSpin'
,p_group_id=>wwv_flow_imp.id(4362333366880890)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will spin on button hover or focus.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34533631036496733)
,p_theme_id=>42
,p_name=>'HIDE_LABEL_ON_MOBILE'
,p_display_name=>'Hide Label on Mobile'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_imp.id(34533432746496733)
,p_css_classes=>'t-Button--mobileHideLabel'
,p_template_types=>'BUTTON'
,p_help_text=>'This template options hides the button label on small screens.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34534026674496733)
,p_theme_id=>42
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_imp.id(34533432746496733)
,p_css_classes=>'t-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(4362767724880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34534231001496733)
,p_theme_id=>42
,p_name=>'PUSH'
,p_display_name=>'Push'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_imp.id(34533432746496733)
,p_css_classes=>'t-Button--hoverIconPush'
,p_group_id=>wwv_flow_imp.id(4362333366880890)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will animate to the right or left on button hover or focus.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34534481300496733)
,p_theme_id=>42
,p_name=>'RIGHTICON'
,p_display_name=>'Right'
,p_display_sequence=>20
,p_button_template_id=>wwv_flow_imp.id(34533432746496733)
,p_css_classes=>'t-Button--iconRight'
,p_group_id=>wwv_flow_imp.id(4362767724880890)
,p_template_types=>'BUTTON'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(34534689420496733)
,p_theme_id=>42
,p_name=>'SPIN'
,p_display_name=>'Spin'
,p_display_sequence=>10
,p_button_template_id=>wwv_flow_imp.id(34533432746496733)
,p_css_classes=>'t-Button--hoverIconSpin'
,p_group_id=>wwv_flow_imp.id(4362333366880890)
,p_template_types=>'BUTTON'
,p_help_text=>'The icon will spin on button hover or focus.'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/globalization/translations
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(34625475702888566)
,p_build_option_name=>'Exclude'
,p_build_option_status=>'EXCLUDE'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(34559066147496791)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>'Would you like to perform this delete action?'
);
end;
/
prompt --application/shared_components/security/authentications/application_express_accounts
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(34415582036496647)
,p_name=>'Application Express Accounts'
,p_scheme_type=>'NATIVE_APEX_ACCOUNTS'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/shared_components/plugins/process_type/com_flows4apex_manage_step_process
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(11433973545235127)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'COM.FLOWS4APEX.MANAGE_STEP.PROCESS'
,p_display_name=>'Flows for APEX - Manage Flow Instance Step'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','COM.FLOWS4APEX.MANAGE_STEP.PROCESS'),'')
,p_api_version=>2
,p_execution_function=>'flow_plugin_manage_instance_step.execution'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process used to Manage a <i>Flows for APEX</i> Flow Instance Step. This plug-in allows you to either complete, reserve or release a Flow Instance Step.'
,p_version_identifier=>'23.1'
,p_about_url=>'https://github.com/flowsforapex/apex-flowsforapex'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11434207122235128)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Flow Instance info'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'item'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When a <i>Flows for APEX</i> task is completed, the application needs to send a <i> flow_step_complete </i> call to move the Flow Instance onto its next task / next step.  The call needs to provide the current context to the engine, so that the fl'
||'ow engine knows which task you were completing.  The context is made up of the process_id and subflow_id of the current task.</p>',
'',
'<p>Typically a <i>Flows for APEX </i> userTask (a page in APEX) will download its context when the page loads.  This download is defined in the Flow Modeller, using the Flow Modeller Properties Panel -- once you have created your userTask on your dia'
||'gram, click on the APEX tab in the Properties Panel, define the Page Items to set, and set them to the Process ID and Subflow ID.  </p>',
'',
'<p>For example, one way to do this is to define Application Level items in your application named PROCESS_ID and SUBFLOW_ID.  Then in the Flow Modeller Properties Panel for your userTask, specify that the page call sets variables PROCESS_ID, SUBFLOW_'
||'ID with values of &F4A$process_id.,&F4A$subflow_id.</p>',
'',
'<p>Alternatively, you could retrieve the Flow context (process_id and subflow_id) by retrieving these in a SQL Query.</p>',
'',
'<p>Specify which method you will use to supply the Flow Instance context (process_id and subflow_id)?</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(11434642278235128)
,p_plugin_attribute_id=>wwv_flow_imp.id(11434207122235128)
,p_display_sequence=>10
,p_display_value=>'In Page Items'
,p_return_value=>'item'
,p_help_text=>'Use this when the Flow Instance context (process_id and subflow_id) are stored in APEX Page Items.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(11435127482235129)
,p_plugin_attribute_id=>wwv_flow_imp.id(11434207122235128)
,p_display_sequence=>20
,p_display_value=>'from SQL Query'
,p_return_value=>'sql'
,p_help_text=>'Use this when the Flow Instance context (process_id and subflow_id) are to be returned by a SQL Query.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11435635367235129)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Process ID Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(11434207122235128)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>APEX Item that contains the Flow Instance process_id.</p>',
'',
'<p>This could typically be: </p>',
'<ul>',
'<li>An Application Item, often named PROCESS_ID.</li>',
'<li>A Global Page Item, for example P0_PROCESS_ID.</li>',
'<li>A Page Item on your page.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11435979117235129)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Subflow ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(11434207122235128)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>APEX Item that contains the Flow Instance subflow_id.</p>',
'',
'<p>This could typically be: </p>',
'<ul>',
'<li>An Application Item, often named SUBFLOW_ID.</li>',
'<li>A Global Page Item, for example P0_SUBFLOW_ID.</li>',
'<li>A Page Item on your page.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11436432315235129)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>2
,p_sql_max_column_count=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(11434207122235128)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'sql'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>SQL Query which returns one row with two or three columns:</p>',
'<ul>',
'<li>First column needs to contain the Instance Id (prcs_id)</li>',
'<li>Second column needs to contain the Subflow Id (sbfl_id)</li>',
'<li>Third column can contain the Step Key (step_key)</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11436822525235129)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>'Action'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'complete'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Allows you to define the action you want to apply to the Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(11437194196235129)
,p_plugin_attribute_id=>wwv_flow_imp.id(11436822525235129)
,p_display_sequence=>10
,p_display_value=>'Complete Step'
,p_return_value=>'complete'
,p_help_text=>'This option is used to complete a Flow Instance Step.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(11437682665235129)
,p_plugin_attribute_id=>wwv_flow_imp.id(11436822525235129)
,p_display_sequence=>20
,p_display_value=>'Reserve Step'
,p_return_value=>'reserve'
,p_help_text=>'This option is used to reserve a Flow Instance Step.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(11438195133235129)
,p_plugin_attribute_id=>wwv_flow_imp.id(11436822525235129)
,p_display_sequence=>30
,p_display_value=>'Release Step'
,p_return_value=>'release'
,p_help_text=>'This option is used to release a Flow Instance Step.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11438722975235129)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Set Gateway Routing?'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(11436822525235129)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'complete'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this Process to also set up the routing for a data driven Gateway?</p>',
'<p>BPMN Flow Diagrams contain two gateway types that are data-driven gateways.  These are ',
'<ul>',
'<li>Exclusive Gateways - which choose 1 forward route from several options.</li>',
'<li>Inclusive Gateways - which choose 1 or more routes from several options.</li>',
'</ul></p>',
'<p>In <i>Flows for APEX,</i> the routing instruction for a gateway is set up by creating a Process Variable (named <gateway_bpmn_name>||'':route'') with the BPMN name of the paths to be chosen.</p>',
'<p>If you want this APEX process to set up routing for a forward gateway using information that is known on this page, you can get up the gateway routing here.</p>',
'<p>Set the switch to ''On'' to set up routing for a future Inclusive Gateway or Exclusive Gateway.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11439146212235129)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Gateway ID'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(11438722975235129)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Gateway ID of the Gateway to set.  If the field is empty, the plugin will automatically fill it with the next object id, if it is an Inclusive or Exclusive Gateway.</p>',
'',
'<p>Note that BPMN objects have an Object ID and an Object Name -  the routing variable needs the Object ID.</p>',
'<p>The plug-in will create a Flows for APEX Process Variable with a name of this field with '':route'' appended to it, as required by the gateway.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11439499413235130)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Route ID'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(11438722975235129)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><b>Example 1:</b>  Inclusive Gateway with required route in Page Item named ''approval_decision'':</p>',
'',
'<pre>&approval_decision.</pre>',
'',
'<p> Page Item approval_decision contains the approval decision route, ''Flow_yes'' or ''Flow_no''. </p>',
'<p><b>Example 2:</b>  Exclusive Gateway with required route in Page Item named ''ship_modes'':</p>',
'',
'<pre>&ship_modes.</pre>',
'',
'<p> Page Item ship_modes contains the required shipping modes for the order.  In this case, the order is to ship by ''air'' and ''sea'', the routes for which have IDs of ''Flow_air'' and ''Flow_sea''.  The contents of Page Item ship_modes would have been set'
||' to ''Flow_air:Flow_sea''. </p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the ID of the route(s) that you want the Flow Instance to take at the Gateway.</p>',
'',
'<p>The Route ID is the ID (not the name) of the sequence Flow leaving the gateway.  To get this from your Flow diagram, open your Flow diagram with the Flow Modeller, select the outbound path (line) from the gateway object.  The Properties Panel will'
||' show its ID and name.  </p>',
'<ul>',
'<li>An Exclusive Gateway (+ sign) allows only 1 forward path.  Set the Routing field to the ID of the path you want, or a substitution variable for a Page Item containing the required link ID.</li>',
'<li>An Inclusive Gateway (o sign) allows multiple forward paths.  If there are more than 1 desired paths, these should be colon (:) delimited.  Set the Routing field to a colon delimited list of the paths you want, or a substitution variable for a Pa'
||'ge Item containing the list IDs of the required links.</li>',
'<ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11439906653235130)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Auto-Branching?'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(11436822525235129)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'complete'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>After issuing the step_complete instruction to the Flow engine, Auto Branching will then branch your APEX application to the application page required for the next userTask in the Flow -- without the user needing to return to a task inbox.',
'<p>Auto Branching will only occur when:',
'<ul>',
'<li>the next object in the Flow is also a userTask</li>',
'<li>if Lanes are defined for the Flow, both the last and next task are in the same lane</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11440288136235130)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Reservation'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(11436822525235129)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'reserve'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Reserve with the connected user name</p>',
'<pre>&APP_USER.</pre>'))
,p_help_text=>'Use this to define the value for the reservation.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11440670820235130)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Return  Flow Instance and Subflow ID [deprecated]'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'This attribute is deprecated starting from Flows for APEX 22.2 and will probably be removed in a future release.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(11441085815235130)
,p_plugin_id=>wwv_flow_imp.id(11433973545235127)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>35
,p_prompt=>'Step Key'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(11434207122235128)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>APEX Item that contains the Flow Instance step_key.</p>',
'',
'<p>This could typically be: </p>',
'<ul>',
'<li>An Application Item, often named STEP_KEY.</li>',
'<li>A Global Page Item, for example P0_STEP_KEY.</li>',
'<li>A Page Item on your page.</li>',
'</ul>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/json_region_uwesimon_selfhost_e
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(59392068835395563)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JSON_REGION.UWESIMON.SELFHOST.E'
,p_display_name=>'Json-Region'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JSON_REGION.UWESIMON.SELFHOST.E'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.starRating#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.pctGraph#MIN#.js',
'#PLUGIN_FILES#json-region.js'))
,p_css_file_urls=>'#PLUGIN_FILES#json-region.css'
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
' * JSON-region-plugin',
' * (c) Uwe Simon 2023,2024',
' * Apache License Version 2.0',
'*/',
'',
'/*',
' * Read the JSON-schema from database. The query must return a single row and the first column must be the JSON-schema.',
' */ ',
'FUNCTION readschema(pQuery IN VARCHAR2) ',
'  RETURN CLOB IS ',
'  l_json                CLOB;',
'  l_column_value_list   apex_plugin_util.t_column_value_list;',
'BEGIN',
'  l_column_value_list := apex_plugin_util.get_data (',
'            p_sql_statement    => pQuery,',
'            p_min_columns      => 1,',
'            p_max_columns      => 1,',
'            p_component_name   => ''1'');',
'  IF(l_column_value_list.count=1 AND l_column_value_list(1).count=1 AND l_column_value_list(1)(1) IS NOT NULL) THEN',
'    APEX_DEBUG.INFO(''readschema: %s %s'', l_column_value_list(1).count, l_column_value_list(1)(1));',
'    l_json := l_column_value_list(1)(1);',
'  END IF;',
'  RETURN l_json;',
'END readschema;',
'',
'/*',
' * Read the JSON-schema from database dictionary. ',
' * The query must return a single row and the first column must be the JSON-schema.',
' * This works only with Oracle >=23x',
' * Hack, use SYS_DBURIGEN to convert LONG to CLOB!!!!',
' */',
'FUNCTION readschemafromdictionary(pItem IN VARCHAR2) ',
'  RETURN CLOB IS ',
'  l_json                CLOB;',
'  l_table_name          all_tab_columns.table_name%TYPE;',
'  l_owner               all_tab_columns.owner%TYPE;',
'  l_column_name         all_tab_columns.column_name%TYPE;',
'BEGIN',
'  $IF DBMS_DB_VERSION.VERSION>=23',
'  $THEN',
'    BEGIN',
'      APEX_DEBUG.INFO(''readschemafromdictionary for database version %d'', DBMS_DB_VERSION.VERSION);',
'      SELECT table_name, item_source',
'      INTO l_table_name, l_column_name',
'      FROM apex_application_page_items i ',
'      JOIN apex_application_page_regions r ON (r.region_id=i.region_id)',
'      WHERE i.application_id=NV(''APP_ID'') AND item_name=pItem;',
'',
'      APEX_DEBUG.INFO(''readschemafromdictionary: %s %s %s'', l_owner, l_table_name, l_column_name);',
'',
'      SELECT REGEXP_SUBSTR(text, ''({.+})'',1,1,''n'',1) AS json_schema',
'      INTO l_json',
'      FROM (',
'        SELECT table_name, constraint_name,',
'          SYS_DBURIGEN(table_name, constraint_name, search_condition, ''text()'').getclob() as text ',
'        FROM user_constraints WHERE UPPER(search_condition_vc) like ''%IS JSON%'' AND constraint_type=''C''',
'      ) c ',
'      JOIN user_cons_columns cc ON(c.table_name=cc.table_name AND c.constraint_name=cc.constraint_name)',
'      WHERE c.table_name=l_table_name AND column_name=l_column_name;',
'    EXCEPTION WHEN NO_DATA_FOUND THEN',
'    SELECT json_serialize(DBMS_JSON_SCHEMA.describe(l_table_name, l_owner))',
'      INTO l_json;',
'    END;',
'    APEX_DEBUG.INFO(''JSON %s'', substr(l_json,1,1000));',
'  $ELSE',
'    APEX_DEBUG.ERROR(''readschemafromdictionary not supported for database version %d'', DBMS_DB_VERSION.VERSION);',
'  $END',
'  RETURN l_json;',
'END readschemafromdictionary;',
'/*',
' * Called when the plugin is to be rendered',
' */',
'FUNCTION render_region(p_region              IN apex_plugin.t_region,',
'                       p_plugin              IN apex_plugin.t_plugin,',
'                       p_is_printer_friendly IN BOOLEAN)',
'  RETURN apex_plugin.t_region_render_result IS',
'  -- plugin attributes',
'  l_apex_version        apex_release.version_no%TYPE;',
'  l_result              apex_plugin.t_region_render_result;',
'  l_name                p_region.name%TYPE         := p_region.name;',
'  l_dataitem            p_region.source%TYPE       := UPPER(NVL(p_region.attribute_10, p_region.source));',
'  l_source              p_region.attribute_02%TYPE := p_region.attribute_02;                            -- source the for JSON-Schema (0: generate, 1: static, others SQL-query)',
'  l_schema              p_region.attribute_03%TYPE := p_region.attribute_03;                            -- The fixed JSON-schema',
'  l_query               p_region.attribute_04%TYPE := p_region.attribute_04;                            -- The SQL-query to retrieve the JSON-schema',
'  l_colwidth            p_region.attribute_05%TYPE := p_region.attribute_05;                            -- The column width for the field items in universal theme 1,2,3,4,6,12',
'  l_template            p_region.attribute_11%TYPE :=  NVL(p_region.attribute_11, ''floating'');          -- Template used for input items        ',
'  l_textareawidth       p_region.attribute_01%TYPE :=  NVL(p_region.attribute_01, 250);                 -- The limit when textarea is used for long tex inputs',
'  l_keepattributes      p_region.attribute_06%TYPE :=  NVL(p_region.attribute_06, ''N'');                 -- keep additional attributes not mentioned in JSON-schema',
'  l_headers             p_region.attribute_07%TYPE :=  NVL(p_region.attribute_07, ''N'');                 -- Show headers when sub-objects are in the JSON-schema',
'  l_hide                boolean                    :=  NVL(p_region.attribute_08, ''Y'')=''Y'';             -- Hide the JSON-field (default is true)',
'  l_removenulls         BOOLEAN                    :=  NVL(p_region.attribute_09, ''Y'')=''Y'';             -- Remove attributed from JSON with a NULL-value  ',
'  l_queryitems          varchar2(4000);',
'  l_delimiter           varchar2(1);',
'  l_binds               DBMS_SQL.varchar2_table;',
'--  l_columun     apex_plugin.t_region_column := p_region.region_columns(0);',
'  l_readonly    BOOLEAN;',
'BEGIN',
'  apex_plugin_util.debug_region(p_plugin => p_plugin, p_region => p_region, p_is_printer_friendly =>true);',
'  SELECT VERSION_NO INTO l_apex_version FROM APEX_RELEASE;',
'  BEGIN',
'    IF(l_query IS NOT NULL) THEN -- dynamic json-schema from configured query',
'      l_schema:=readSchema(l_query);  ',
'    -- Build a list of queryitems required for AJAX-callback',
'      l_binds := wwv_flow_utilities.get_binds(l_query);',
'      FOR i IN 1 .. l_binds.count',
'      LOOP',
'        l_queryitems := l_queryitems||l_delimiter||''#''||substr(l_binds(i),2);',
'        l_delimiter:='','';',
'      END LOOP;',
'    END IF;',
'',
'    IF(l_schema IS NULL OR LENGTH(l_schema)=0) THEN',
'      l_schema:=readschemafromdictionary(l_dataitem);',
'    END IF;',
'',
'    EXCEPTION WHEN NO_DATA_FOUND THEN',
'      l_schema:=NULL;',
'  END;',
'  ',
'  l_schema:=NVL(l_schema, ''{"type": "object", "properties": {}}'');',
'  -- escape input',
'  l_dataitem  := NVL(apex_escape.html(l_dataitem), ''{}'');',
'  --l_schema    := apex_escape.json(l_schema);',
'  l_readonly  := APEX_REGION.IS_READ_ONLY;',
'',
'$if wwv_flow_api.c_current<20231031 $then   -- apex_barcode is only available in APEX >=23.2 (20231031), so conditional compile',
'    APEX_JAVASCRIPT.ADD_REQUIREJS();',
'$end',
'--  APEX_JAVASCRIPT.ADD_ONLOAD_CODE(',
'    -- execute the code directly not via add_onload_code. Hack to enable the handlers for text-/number-items',
'  APEX_JAVASCRIPT.ADD_INLINE_CODE (',
'       p_key=> ''json-region'', ',
'       p_code => ''initJsonRegion('' ||',
'       apex_javascript.add_value(p_region.static_id) || ',
'       apex_javascript.add_value(p_region.name) ||        ',
'       apex_javascript.add_value(apex_plugin.get_ajax_identifier) ||       ',
'                                ''{'' ||',
'         apex_javascript.add_attribute(''isDynamic'', l_query IS NOT NULL AND LENGTH(l_query)>0) ||                                ',
'         apex_javascript.add_attribute(''generateSchema'', (l_source = ''0''))||                                ',
'         apex_javascript.add_attribute(''queryitems'',     l_queryitems) ||',
'         apex_javascript.add_attribute(''dataitem'',       l_dataitem) ||',
'         apex_javascript.add_attribute(''name'',           l_name) ||',
'         apex_javascript.add_attribute(''colwidth'',       l_colwidth) ||',
'         apex_javascript.add_attribute(''readonly'',       l_readonly) ||',
'         apex_javascript.add_attribute(''textareawidth'',  l_textareawidth) ||',
'         apex_javascript.add_attribute(''keepAttributes'', l_keepattributes!=''N'') ||',
'         apex_javascript.add_attribute(''headers'',        l_headers!=''N'') ||',
'         apex_javascript.add_attribute(''hide'',           l_hide) || ',
'         apex_javascript.add_attribute(''removeNulls'',    l_removenulls) || ',
'         apex_javascript.add_attribute(''template'',       l_template) || ',
'         apex_javascript.add_attribute(''schema'',         l_schema) ||',
'         apex_javascript.add_attribute(''apex_files'',     APEX_APPLICATION.G_IMAGE_PREFIX) ||',
'         apex_javascript.add_attribute(''nls_date_format'',V(''APP_NLS_DATE_FORMAT'')) ||',
'         apex_javascript.add_attribute(''apex_version'',   l_apex_version, false,false) ||',
'                                ''});''',
'  );                                 ',
'  RETURN l_result;',
'  --',
'END render_region;',
'',
'/*',
' * The AJAX callback called from inside Javascript in the browser.',
' * Must return a JSON',
' */',
'FUNCTION ajax_region(p_region IN apex_plugin.t_region,',
'                     p_plugin IN apex_plugin.t_plugin)',
'  RETURN apex_plugin.t_region_ajax_result IS',
'  l_sqlquery p_region.attribute_04%TYPE :=p_region.attribute_04;  -- the SQLquery entered in page designer is passed in attribute_04;',
'  l_result   apex_plugin.t_region_ajax_result;',
'  l_json     VARCHAR2(32000);',
'  l_j        APEX_JSON.T_VALUES;',
'  l_svg      clob;',
'BEGIN',
'  APEX_DEBUG.TRACE(''ajax_region %s'', APEX_APPLICATION.g_x01);',
'  apex_plugin_util.debug_region(p_plugin => p_plugin, p_region => p_region);',
'  BEGIN',
'    IF(APEX_APPLICATION.g_x01 IS NOT NULL) THEN  -- generate a QR-code ',
'$if wwv_flow_api.c_current>=20231031 $then   -- apex_barcode is only available in APEX >=23.2 (20231031), so conditional compile',
'      l_svg := apex_barcode.get_qrcode_svg(p_value => APEX_APPLICATION.g_x01); ',
'      apex_json.open_object;',
'      apex_json.write(''QR'', l_svg);',
'      apex_json.close_all();',
'$else',
'      apex_json.open_object;',
'$end',
'    ELSE   -- read JSON-schema',
'      l_json := readschema(l_sqlquery);',
'      apex_json.parse(l_j , l_json);',
'      apex_json.write(l_j);',
'    END IF;',
'  EXCEPTION WHEN NO_DATA_FOUND THEN',
'    apex_json.open_object();',
'    apex_json.close_all();  ',
'  END;',
'  RETURN l_result;',
'END ajax_region;'))
,p_api_version=>2
,p_render_function=>'render_region'
,p_ajax_function=>'ajax_region'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'This plug-in was downloaded from https://github.com/simonuwe/oracle-apex-json-region and backported to APEX 20.2.'
,p_version_identifier=>'0.9.5'
,p_about_url=>'https://github.com/simonuwe/oracle-apex-json-region'
,p_files_version=>179
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(59394926727435223)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>50
,p_prompt=>'Textarealimit'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'250'
,p_is_translatable=>false
,p_help_text=>'The maximal length of a simple text input field. When the maxLength of the field is longer a textarea is used to display the field.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(59392844587409506)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Source'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The source for the JSON-schema.',
'This could be a static schema or a schema retrieved by a SQL-query.'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(59393162429410623)
,p_plugin_attribute_id=>wwv_flow_imp.id(59392844587409506)
,p_display_sequence=>10
,p_display_value=>'Static'
,p_return_value=>'1'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(59393623192411869)
,p_plugin_attribute_id=>wwv_flow_imp.id(59392844587409506)
,p_display_sequence=>20
,p_display_value=>'SQL-Query'
,p_return_value=>'SQL-Query'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22607698757969854)
,p_plugin_attribute_id=>wwv_flow_imp.id(59392844587409506)
,p_display_sequence=>30
,p_display_value=>'Generate Schema'
,p_return_value=>'0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(59393999745421123)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Static Schema'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(59392844587409506)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'1'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(59394242530426838)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>'SQL-Query'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(59392844587409506)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'1'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Query to retrieve the JSON-schema. It must return exactly one row with the JSON-schema-column.',
'',
'The schema must contain the attributes',
'type, properties and optionally required.',
'For a detailed JSON-schema description see https://json-schema.org/'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(59394559631430919)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>'Column Width'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'3'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The width of a column.',
'The default universal-theme supports here 1 (12 columns), 2, 3, 4, 6, 12(1 column)'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(59395230657439402)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Keep additional attributes'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'When the JSON contains more attributes than defined in the JSON-schema the additional attributes are kept when updating the data.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(59395532584443895)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Headers'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'When the JSON-schema contains "sub-objects" headers for each sub-object are shown.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(59395802031446996)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Hide JSON-item'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Automatically hide the related JSON-item. This is the default.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(59396101619449832)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Remove NULLS from JSON'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Remove NULL values from JSON. This is useful to compact JSON-data with only a few attributes set.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(59392557774404862)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>5
,p_prompt=>'JSON-item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The JSON-item the region is linked to. All data shown/edited in the region is read/written to this field-item. ',
'This field-item should be a textarea.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(24922382470947443)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>55
,p_prompt=>'Template'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'floating'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24922688411951809)
,p_plugin_attribute_id=>wwv_flow_imp.id(24922382470947443)
,p_display_sequence=>10
,p_display_value=>'Header Floating'
,p_return_value=>'floating'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24923070443953649)
,p_plugin_attribute_id=>wwv_flow_imp.id(24922382470947443)
,p_display_sequence=>20
,p_display_value=>'Label Above'
,p_return_value=>'above'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24923493192954714)
,p_plugin_attribute_id=>wwv_flow_imp.id(24922382470947443)
,p_display_sequence=>30
,p_display_value=>'Label Left'
,p_return_value=>'left'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(24923916270956497)
,p_plugin_attribute_id=>wwv_flow_imp.id(24922382470947443)
,p_display_sequence=>40
,p_display_value=>'Label Hidden'
,p_return_value=>'hidden'
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A0A202A2041504558204A534F4E2D726567696F6E20706C7567696E0A202A20286329205577652053696D6F6E20323032332C323032340A202A20417061636865204C6963656E73652056657273696F6E20322E300A2A2F0A0A2F2F20666F72204F72';
wwv_flow_imp.g_varchar2_table(2) := '61636C65203C2032312E310A2F2F20617065782E656E7620646F6573206E6F74206E6F74206578697374732C20617065782E6C6F63616C65206F6E6C79207061727469616C6C790A617065782E6C6F63616C652E746F4E756D626572203D20617065782E';
wwv_flow_imp.g_varchar2_table(3) := '6C6F63616C652E746F4E756D626572207C7C2066756E6374696F6E287056616C75652C2070466F726D617429207B200A20207056616C7565203D20282727202B207056616C7565292E7265706C61636528617065782E6C6F63616C652E67657443757272';
wwv_flow_imp.g_varchar2_table(4) := '656E637928292C202727293B20202F2F2072656D6F76652063757272656E63792024E282AC2E2E2E0A20207056616C7565203D20282727202B207056616C7565292E7265706C61636528617065782E6C6F63616C652E67657449534F43757272656E6379';
wwv_flow_imp.g_varchar2_table(5) := '28292C202727293B202F2F2072656D6F7665204555522F5553442F2E2E2E0A20207056616C7565203D20282727202B207056616C7565292E7265706C61636528617065782E6C6F63616C652E67657447726F7570536570617261746F7228292C20272729';
wwv_flow_imp.g_varchar2_table(6) := '3B20202F2F2072656D6F76652047726F7570736570657261746F720A20207056616C7565203D20282727202B207056616C7565292E7265706C61636528617065782E6C6F63616C652E676574446563696D616C536570617261746F7228292C20272E2729';
wwv_flow_imp.g_varchar2_table(7) := '3B20202F2F2072656D6F766520636F6E76657220446563696D616C536570657261746F7220746F202E0A202072657475726E204E756D626572287056616C7565290A7D3B200A617065782E64617465203D20617065782E646174657C7C7B0A2020706172';
wwv_flow_imp.g_varchar2_table(8) := '73653A2066756E6374696F6E2870446174652C2070466F726D617429207B0A202020206C6574206C5F726574203D6E756C6C3B0A2020202069662870446174652E696E636C756465732827202729297B20202F2F20636F6E7461696E732074696D650A20';
wwv_flow_imp.g_varchar2_table(9) := '20202020207044617465203D2070446174652E7265706C616365282754272C20272027293B202F2F20657863657074206461746574696D65207769746820222022206F7220225422206265747765656E206461746520616E642074696D652C2041504558';
wwv_flow_imp.g_varchar2_table(10) := '3C32322E31202220222064656C696D697465720A2020202020206C5F726574203D20242E646174657069636B65722E7061727365446174652870466F726D61742E6D6174636828275B5E205D2B27295B305D2C207044617465293B0A2020202020206C5F';
wwv_flow_imp.g_varchar2_table(11) := '726574203D206E65772044617465286C5F7265742E67657454696D652829202D206C5F7265742E67657454696D657A6F6E654F666673657428292A3630303030293B0A2020202020206C5F726574203D206E65772044617465286C5F7265742E746F4953';
wwv_flow_imp.g_varchar2_table(12) := '4F537472696E6728292E737562737472696E6728302C313029202B20272027202B2070446174652E6D61746368282F5B5C645D7B327D3A5B5C645D7B327D283A5B5C645D7B327D293F2F67295B305D202B20275A27293B0A202020207D20656C7365207B';
wwv_flow_imp.g_varchar2_table(13) := '202F2F2064617465206F6E6C790A2020202020206C5F726574203D20242E646174657069636B65722E7061727365446174652870466F726D61742C207044617465293B0A2020202020206C5F726574203D206E65772044617465286C5F7265742E676574';
wwv_flow_imp.g_varchar2_table(14) := '54696D652829202D206C5F7265742E67657454696D657A6F6E654F666673657428292A3630303030293B0A202020207D0A2020202072657475726E286C5F726574293B0A202020202F2F202870446174652E7265706C616365282754272C202720272929';
wwv_flow_imp.g_varchar2_table(15) := '3B0A20207D2C0A2020746F49534F537472696E673A2066756E6374696F6E28704461746529207B200A2020202072657475726E20286E65772044617465287044617465292E746F49534F537472696E6728292E737562737472696E6728302C313929293B';
wwv_flow_imp.g_varchar2_table(16) := '0A20207D0A7D3B0A0A2275736520737472696374223B0A0A0A2F2A0A20202020696628216E616D652E6D61746368282F5E5B412D5A612D7A5F302D395D2B242F6729297B202F2F20636F6E7461696E7320736F6D65207370656369616C20636861726163';
wwv_flow_imp.g_varchar2_table(17) := '7465727320616E6420656E636C6F73656420627920222C207265706C616365206279205F0A202020202020636F6E7374206C5F6E616D65203D206E616D653B0A2020202020206E616D65203D206E616D652E7265706C616365282F222F672C2727292E72';
wwv_flow_imp.g_varchar2_table(18) := '65706C616365282F5B5E412D5A612D7A5F302D395D2F672C20275F27293B20200A202020202020617065782E64656275672E6572726F722827696E76616C69642070726F7065727479206B6579272C206C5F6E616D652C20277265706C61636564206279';
wwv_flow_imp.g_varchar2_table(19) := '272C206E616D65293B0A202020207D0A2A2F0A0A2F2A0A202A20696E697469616C697A6520746865204A534F4E2D726567696F6E20706C7567696E2C2063616C6C20666F726D20696E7369646520504C2F53514C207768656E20706C7567696E20697374';
wwv_flow_imp.g_varchar2_table(20) := '20696E697469616C697A65640A2A2F0A2F2F206173796E632066756E6374696F6E20696E69744A736F6E526567696F6E282070526567696F6E49642C20704E616D652C2070416A61784964656E7469666965722C20704F7074696F6E7329207B0A66756E';
wwv_flow_imp.g_varchar2_table(21) := '6374696F6E20696E69744A736F6E526567696F6E282070526567696F6E49642C20704E616D652C2070416A61784964656E7469666965722C20704F7074696F6E7329207B0A2020636F6E737420435F415045585F56455253494F4E5F32303031203D2022';
wwv_flow_imp.g_varchar2_table(22) := '32302E31220A2020636F6E737420435F415045585F56455253494F4E5F32303032203D202232302E32220A2020636F6E737420435F415045585F56455253494F4E5F32313031203D202232312E31220A2020636F6E737420435F415045585F5645525349';
wwv_flow_imp.g_varchar2_table(23) := '4F4E5F32313032203D202232312E32220A2020636F6E737420435F415045585F56455253494F4E5F32323031203D202232322E31220A2020636F6E737420435F415045585F56455253494F4E5F32323032203D202232322E32220A2020636F6E73742043';
wwv_flow_imp.g_varchar2_table(24) := '5F415045585F56455253494F4E5F32333031203D202232332E31220A2020636F6E737420435F415045585F56455253494F4E5F32333032203D202232332E32220A2020636F6E737420435F415045585F56455253494F4E5F32343031203D202232342E31';
wwv_flow_imp.g_varchar2_table(25) := '220A0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202F2F204A534F4E202274797065223A20222E2E2E220A2020636F6E737420435F4A534F4E5F4F424A454354202020';
wwv_flow_imp.g_varchar2_table(26) := '20202020202020203D20276F626A656374273B0A2020636F6E737420435F4A534F4E5F41525241592020202020202020202020203D20276172726179273B0A2020636F6E737420435F4A534F4E5F50524F50455254494553202020202020203D20277072';
wwv_flow_imp.g_varchar2_table(27) := '6F70657274696573273B0A2020636F6E737420435F4A534F4E5F52455155495245442020202020202020203D20277265717569726564273B0A2020636F6E737420435F4A534F4E5F52454620202020202020202020202020203D202724726566273B0A20';
wwv_flow_imp.g_varchar2_table(28) := '20636F6E737420435F4A534F4E5F535452494E4720202020202020202020203D2027737472696E67273B0A2020636F6E737420435F4A534F4E5F494E5445474552202020202020202020203D2027696E7465676572273B0A2020636F6E737420435F4A53';
wwv_flow_imp.g_varchar2_table(29) := '4F4E5F4E554D42455220202020202020202020203D20276E756D626572273B0A2020636F6E737420435F4A534F4E5F424F4F4C45414E202020202020202020203D2027626F6F6C65616E273B0A2020636F6E737420435F4A534F4E5F434F4E5354202020';
wwv_flow_imp.g_varchar2_table(30) := '2020202020202020203D2027636F6E7374273B0A2020636F6E737420435F4A534F4E5F464F524D41545F444154452020202020203D202764617465273B0A2020636F6E737420435F4A534F4E5F464F524D41545F4441544554494D4520203D2027646174';
wwv_flow_imp.g_varchar2_table(31) := '652D74696D65273B0A2020636F6E737420435F4A534F4E5F464F524D41545F54494D452020202020203D202774696D65273B0A2020636F6E737420435F4A534F4E5F464F524D41545F454D41494C20202020203D2027656D61696C273B0A2020636F6E73';
wwv_flow_imp.g_varchar2_table(32) := '7420435F4A534F4E5F464F524D41545F555249202020202020203D2027757269273B0A2020636F6E737420435F4A534F4E5F464F524D41545F495056342020202020203D202769707634273B0A2020636F6E737420435F4A534F4E5F464F524D41545F49';
wwv_flow_imp.g_varchar2_table(33) := '5056362020202020203D202769707636273B0A2020636F6E737420435F4A534F4E5F464F524D41545F555549442020202020203D202775756964273B0A0A2020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(34) := '2020202020202F2F20636F6E646974696F6E616C206B6579776F7264730A2020636F6E737420435F4A534F4E5F434F4E445F414C4C5F4F462020202020203D2027616C6C4F66273B0A2020636F6E737420435F4A534F4E5F434F4E445F414E595F4F4620';
wwv_flow_imp.g_varchar2_table(35) := '20202020203D2027616E794F66273B0A2020636F6E737420435F4A534F4E5F434F4E445F4E4F542020202020202020203D20276E6F74273B0A20200A20202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(36) := '20202020202020202020202F2F204A534F4E20656E636F64656420737472696E67730A2020636F6E737420435F4A534F4E5F494D4147455F504E4720202020202020203D2027696D6167652F706E67273B0A2020636F6E737420435F4A534F4E5F494D41';
wwv_flow_imp.g_varchar2_table(37) := '47455F4A504720202020202020203D2027696D6167652F6A7067273B0A2020636F6E737420435F4A534F4E5F494D4147455F47494620202020202020203D2027696D6167652F676966273B0A2020636F6E737420435F4A534F4E5F424153453634202020';
wwv_flow_imp.g_varchar2_table(38) := '20202020202020203D2027626173653634273B0A0A2020636F6E737420435F44454C494D495445522020202020202020203D20275F272020202020202020202020202020202020202F2F2064656C696D6974657220666F722070617468206F66206E6573';
wwv_flow_imp.g_varchar2_table(39) := '746564206F626A656374730A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202F2F202261706578223A207B226974656D74797065223A20222E2E2E222C202E2E2E7D200A';
wwv_flow_imp.g_varchar2_table(40) := '2020636F6E737420435F415045585F535749544348202020202020203D2027737769746368273B2020202020202020202020202F2F206974656D74797065207377697463680A2020636F6E737420435F415045585F524943485445585420202020203D20';
wwv_flow_imp.g_varchar2_table(41) := '277269636874657874273B202020202020202020202F2F206974656D7479706520726963687465787420656469746F720A2020636F6E737420435F415045585F544558544152454120202020203D20277465787461726561273B0A2020636F6E73742043';
wwv_flow_imp.g_varchar2_table(42) := '5F415045585F434F4D424F20202020202020203D2027636F6D626F626F78273B202020202020202020202F2F206974656D7479706520636F6D626F626F780A2020636F6E737420435F415045585F524144494F20202020202020203D2027726164696F27';
wwv_flow_imp.g_varchar2_table(43) := '3B0A2020636F6E737420435F415045585F434845434B424F5820202020203D2027636865636B626F78273B0A2020636F6E737420435F415045585F53454C454354202020202020203D202773656C656374273B2020202020202020202020202F2F206974';
wwv_flow_imp.g_varchar2_table(44) := '656D747970652073656C6563740A2020636F6E737420435F415045585F50415353574F524420202020203D202770617373776F7264273B0A2020636F6E737420435F415045585F53544152524154494E472020203D202773746172726174696E67273B0A';
wwv_flow_imp.g_varchar2_table(45) := '2020636F6E737420435F415045585F5152434F4445202020202020203D20277172636F6465273B0A2020636F6E737420435F415045585F494D41474520202020202020203D2027696D616765273B0A2020636F6E737420435F415045585F43555252454E';
wwv_flow_imp.g_varchar2_table(46) := '435920202020203D202763757272656E6379273B0A2020636F6E737420435F415045585F484F52495A4F4E54414C2020203D2027686F72697A6F6E74616C273B0A2020636F6E737420435F415045585F564552544943414C20202020203D202776657274';
wwv_flow_imp.g_varchar2_table(47) := '6963616C273B0A2020636F6E737420435F415045585F504354475241504820202020203D20277063746772617068273B0A2020636F6E737420435F415045585F4C4142454C20202020202020203D20276C6162656C273B0A2020636F6E737420435F4150';
wwv_flow_imp.g_varchar2_table(48) := '45585F53454C4543544F4E45202020203D202773656C6563746F6E65273B0A2020636F6E737420435F415045585F53454C4543544D414E592020203D202773656C6563746D616E79270A0A2020636F6E737420435F415045585F414C49474E2020202020';
wwv_flow_imp.g_varchar2_table(49) := '2020203D2027616C69676E273B0A2020636F6E737420435F415045585F4C4546542020202020202020203D20276C656674273B0A2020636F6E737420435F415045585F43454E544552202020202020203D202763656E746572273B0A2020636F6E737420';
wwv_flow_imp.g_varchar2_table(50) := '435F415045585F524947485420202020202020203D20277269676874273B0A0A2020636F6E737420435F415045585F54454D504C4154455F4C4142454C5F48494444454E2020203D202768696464656E273B0A2020636F6E737420435F415045585F5445';
wwv_flow_imp.g_varchar2_table(51) := '4D504C4154455F4C4142454C5F4C45465420202020203D20276C656674273B0A2020636F6E737420435F415045585F54454D504C4154455F4C4142454C5F41424F5645202020203D202761626F7665273B0A2020636F6E737420435F415045585F54454D';
wwv_flow_imp.g_varchar2_table(52) := '504C4154455F4C4142454C5F464C4F4154494E47203D2027666C6F6174696E67273B0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202F2F20457874656E646564204F72';
wwv_flow_imp.g_varchar2_table(53) := '61636C65207479706573200A2020636F6E737420435F4F5241434C455F54494D455354414D5020203D202774696D657374616D70273B2020202020200A0A2020636F6E737420435F56414C5545534550415241544F52202020203D20277C273B0A0A2020';
wwv_flow_imp.g_varchar2_table(54) := '2020202020202F2F20676574207468652064617461742D74656D706C6174652D696420666F7220696E6C696E65206572726F72732066726F6D20616E6F7468657220696E707574206669656C640A2F2F20636F6E736F6C652E6572726F72284A534F4E2E';
wwv_flow_imp.g_varchar2_table(55) := '737472696E6769667928704F7074696F6E7329293B0A20206C6574206744617461203D207B7D3B20202F2F20686F6C647320746865204A534F4E2D6461746120617320616E206F626A65637420686965726172636869650A20206C657420674461746546';
wwv_flow_imp.g_varchar2_table(56) := '6F726D6174203D20617065782E6C6F63616C652E67657444617465466F726D61743F617065782E6C6F63616C652E67657444617465466F726D617428293A6E756C6C3B0A0A2020704F7074696F6E732E6E6C735F646174655F666F726D6174203D20704F';
wwv_flow_imp.g_varchar2_table(57) := '7074696F6E732E6E6C735F646174655F666F726D61742E746F4C6F7765724361736528292E7265706C616365282F72722F672C27797927293B0A2020696628216744617465466F726D617429207B0A202020206744617465466F726D6174203D20704F70';
wwv_flow_imp.g_varchar2_table(58) := '74696F6E732E6E6C735F646174655F666F726D61742E746F4C6F7765724361736528292E7265706C616365282F79792F672C277927293B0A20207D20656C7365207B0A20202020696628704F7074696F6E732E617065785F76657273696F6E203C20435F';
wwv_flow_imp.g_varchar2_table(59) := '415045585F56455253494F4E5F32323031297B0A2020202020206744617465466F726D6174203D20704F7074696F6E732E6E6C735F646174655F666F726D61742E746F4C6F7765724361736528292E7265706C61636528276D6D272C20274D4D27293B0A';
wwv_flow_imp.g_varchar2_table(60) := '202020207D0A20207D0A20206C6574206754696D65466F726D6174203D206E756C6C3B0A2020696628704F7074696F6E732E617065785F76657273696F6E203E3D20435F415045585F56455253494F4E5F3232303129207B0A202020206754696D65466F';
wwv_flow_imp.g_varchar2_table(61) := '726D6174203D2027484832343A4D49273B0A20207D20656C736520696628704F7074696F6E732E617065785F76657273696F6E203E3D20435F415045585F56455253494F4E5F3231303229207B0A202020206754696D65466F726D6174203D202248483A';
wwv_flow_imp.g_varchar2_table(62) := '6D6D223B0A20207D20656C7365207B0A202020206754696D65466F726D6174203D202248483A6969223B0A20207D0A0A20202F2F206744617465466F726D6174203D202764642E4D4D2E79797979273B0A20202F2F206754696D65466F726D6174203D20';
wwv_flow_imp.g_varchar2_table(63) := '2748483A6D6D273B0A0A2020704F7074696F6E732E617065785F76657273696F6E203D20704F7074696F6E732E617065785F76657273696F6E2E6D61746368282F5C642B5C2E5C642B2F295B305D3B20202F2F206F6E6C792066697273742032206E756D';
wwv_flow_imp.g_varchar2_table(64) := '62657273206F662076657273696F6E0A2020704F7074696F6E732E6461746174656D706C6174654554203D2024282428272E612D466F726D2D6572726F725B646174612D74656D706C6174652D69645D27295B305D292E617474722827646174612D7465';
wwv_flow_imp.g_varchar2_table(65) := '6D706C6174652D69642729207C7C202778785F4554273B0A636F6E736F6C652E6C6F6728704F7074696F6E73293B0A20202F2A0A2020202A202073657420626F6F6C65616E2076616C3120776F2076616C32207768656E2076616C31206973206E6F7420';
wwv_flow_imp.g_varchar2_table(66) := '7365740A20202A2F0A202066756E6374696F6E20626F6F6C65616E49664E6F745365742876616C312C2076616C32297B0A202020202072657475726E202828747970656F662076616C31203D3D2027626F6F6C65616E27293F76616C313A76616C32290A';
wwv_flow_imp.g_varchar2_table(67) := '20207D0A0A20202F2A0A2020202A204C6F67204A534F4E2D736368656D612072656C61746564206572726F726D657373616765730A20202A2F0A202066756E6374696F6E206C6F67536368656D614572726F72286D73672C202E2E2E61726773297B0A20';
wwv_flow_imp.g_varchar2_table(68) := '20202069662841727261792E6973417272617928617267732920262620617267732E6C656E6774683E30297B0A202020202020617065782E64656275672E6572726F7228274A534F4E2D736368656D6120696E76616C69643A20272B206D73672C202E2E';
wwv_flow_imp.g_varchar2_table(69) := '2E61726773290A202020207D20656C7365207B0A202020202020617065782E64656275672E6572726F7228274A534F4E2D736368656D6120696E76616C69643A20272B206D7367290A202020207D0A20207D0A0A20202F2A0A2020202A20536F6D652068';
wwv_flow_imp.g_varchar2_table(70) := '61636B730A2020202A205761697420666F72205269636874746578742D456469746F7220746F20626520696E697469616C697A65640A2020202A206F746865727769736520617065782E6974656D282772696368746578742D4954454D27292E73657456';
wwv_flow_imp.g_varchar2_table(71) := '616C7565282E2E2E292077696C6C20636175736520756E646566696E6564206572726F72200A20202A2F0A202066756E6374696F6E2077616974466F72456469746F722829207B0A2020202072657475726E206E65772050726F6D6973652866756E6374';
wwv_flow_imp.g_varchar2_table(72) := '696F6E20287265736F6C76652C2072656A65637429207B0A2020202020202020636865636B456469746F72287265736F6C7665293B0A202020207D293B0A20207D0A0A20202F2A0A2020202A20436865636B207768657468657220746865207269636874';
wwv_flow_imp.g_varchar2_table(73) := '6578742D656469746F7220697320696E697469616C697A65640A20202A2F0A202066756E6374696F6E20636865636B456469746F72287265736F6C766529207B0A202020206C657420656469746F72456C656D656E74203D20242827612D726963682D74';
wwv_flow_imp.g_varchar2_table(74) := '6578742D656469746F7227293B0A20202020696620282128656469746F72456C656D656E7420262620656469746F72456C656D656E745B305D20262620656469746F72456C656D656E745B305D2E676574456469746F7228292929207B0A202020202020';
wwv_flow_imp.g_varchar2_table(75) := '73657454696D656F757428636865636B456469746F722E62696E6428746869732C207265736F6C7665292C203330293B0A202020207D2020656C7365207B0A2020202020207265736F6C766528293B0A202020207D0A20207D0A0A20202F2A0A2020202A';
wwv_flow_imp.g_varchar2_table(76) := '205761697420756E74696C207468652072696368746578742D656469746F7220697320696E697469616C697A65640A20202A2F0A20206173796E632066756E6374696F6E2072696368746578744861636B28297B0A202020206C657420656469746F7245';
wwv_flow_imp.g_varchar2_table(77) := '6C656D656E74203D20242827612D726963682D746578742D656469746F7227293B0A20202020696628656469746F72456C656D656E7420262620656469746F72456C656D656E745B305D297B0A202020202020617065782E64656275672E747261636520';
wwv_flow_imp.g_varchar2_table(78) := '28277761697420666F722072696368746578742D656469746F72206265656F6E20696E697469616C697A656427293B0A20202020202061776169742077616974466F72456469746F7228293B0A202020207D0A20207D0A0A0A20202F2A0A2020202A2043';
wwv_flow_imp.g_varchar2_table(79) := '6865636B207768657468657220616E206F626A65637420697320656D7074792C20636F6E7461696E73206E6F2070726F70657274696573206F7220616C6C2070726F7065727469657320617265206E756C6C0A20202A2F0A202066756E6374696F6E2069';
wwv_flow_imp.g_varchar2_table(80) := '734F626A656374456D7074792864617461297B0A202020206C6574206C5F656D707479203D20747275653B0A20202020617065782E64656275672E747261636528273E3E6A736F6E526567696F6E2E69734F626A656374456D707479272C206461746129';
wwv_flow_imp.g_varchar2_table(81) := '3B0A202020206966286461746120262620747970656F662064617461203D3D20276F626A65637427297B0A202020202020666F7228636F6E7374205B6C5F6B65792C206C5F646174615D206F66204F626A6563742E656E7472696573286461746129297B';
wwv_flow_imp.g_varchar2_table(82) := '0A20202020202020206966286C5F64617461297B0A202020202020202020206C5F656D707479203D2066616C73653B0A20202020202020207D0A2020202020207D0A202020207D20656C73652069662864617461297B0A2020202020206C5F656D707479';
wwv_flow_imp.g_varchar2_table(83) := '203D2066616C73653B0A202020207D0A20202020617065782E64656275672E747261636528273C3C6A736F6E526567696F6E2E69734F626A656374456D707479272C206C5F656D707479293B0A2020202072657475726E286C5F656D707479293B0A2020';
wwv_flow_imp.g_varchar2_table(84) := '7D200A20202F2A0A2020202A20736F6D65204861636B7320746F206D616B652074686520706C7567696E20776F726B0A20202A2F0A202066756E6374696F6E20617065784861636B7328297B0A0A202020202F2F204861636B20746F2061747461636820';
wwv_flow_imp.g_varchar2_table(85) := '616C6C2048616E646C657220746F20746865206669656C647320696E20746865206A736F6E2D726567696F6E20200A20202020617065782E64656275672E747261636528273E3E6A736F6E526567696F6E2E617065784861636B7327293B0A2020202020';
wwv_flow_imp.g_varchar2_table(86) := '20202F2F20617065782E6974656D2E617474616368282428272327202B2070526567696F6E496429293B0A202020202020202020202F2F206861636B20746F20737570706F727420666C6F6174696E67206C61626C657320666F7220756E697665727361';
wwv_flow_imp.g_varchar2_table(87) := '6C2D7468656D612034320A20202020696628617065782E7468656D653432297B0A202020202020617065782E64656275672E696E666F28275468656D65343220706174636827293B0A202020202020617065782E6576656E742E74726967676572286170';
wwv_flow_imp.g_varchar2_table(88) := '65782E6750616765436F6E74657874242C2027617065787265616479656E6427293B0A202020207D0A0A20202020617065782E64656275672E747261636528273C3C6A736F6E526567696F6E2E617065784861636B7327293B0A20207D0A0A202020202F';
wwv_flow_imp.g_varchar2_table(89) := '2F204861636B20746F2072656D6F766520626F726465722066726F6D20726567696F6E0A20202428272327202B2070526567696F6E4964292E6373732822626F72646572222C20226E6F6E6522293B0A0A0A202020202F2F206D617070696E672066726F';
wwv_flow_imp.g_varchar2_table(90) := '6D2066696C652D657874696F6E73696F6E73206C696B65202E6A7320746F2068746D6C2D7461677320726571756972656420746F206F706164207468652066696C650A2020636F6E737420634D617054797065203D207B0A202020202273637269707422';
wwv_flow_imp.g_varchar2_table(91) := '3A207B7461673A2022736372697074222C2072656C3A206E756C6C2C202020202020202020617474723A2022737263222C20207072656669783A20223F763D22202B20704F7074696F6E732E617065785F76657273696F6E2C20747970653A2022746578';
wwv_flow_imp.g_varchar2_table(92) := '742F6A617661736372697074227D2C0A2020202022637373223A202020207B7461673A20226C696E6B222C20202072656C3A20227374796C657368656574222C20617474723A202268726566222C207072656669783A2022222C20202020202020202020';
wwv_flow_imp.g_varchar2_table(93) := '202020202020202020202020202020202020747970653A2022746578742F637373227D0A20207D3B0A0A2020636F6E73742063416C69676E203D207B0A2020202020206C6566743A2022752D746578745374617274222C0A20202020202063656E746572';
wwv_flow_imp.g_varchar2_table(94) := '3A2022752D7465787443656E746572222C0A20202020202072696768743A2022752D74657874456E64220A20207D0A0A20202F2A0A2020202A202067656E65726174652061204A534F4E2D736368656D612066726F6D204A534F4E2D646174610A20202A';
wwv_flow_imp.g_varchar2_table(95) := '2F0A202066756E6374696F6E2067656E6572617465536368656D6128736368656D612C2064617461297B0A202020202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E67656E6572617465536368656D61222C20736368';
wwv_flow_imp.g_varchar2_table(96) := '656D612C2064617461293B0A2020202020206966286461746120262620747970656F662064617461203D3D20276F626A65637427297B20202F2F206D75737420676F20646F776E2072656375727369766C790A202020202020202069662841727261792E';
wwv_flow_imp.g_varchar2_table(97) := '69734172726179286461746129297B0A20202020202020202020736368656D61203D207B747970653A20226172726179222C206974656D733A207B7D7D3B0A20202020202020202020666F7228636F6E7374206C5F64617461206F66206461746129207B';
wwv_flow_imp.g_varchar2_table(98) := '0A202020202020202020202020736368656D612E6974656D73203D2067656E6572617465536368656D6128736368656D612E6974656D732C206C5F64617461293B0A202020202020202020207D0A20202020202020207D20656C7365207B20202F2F2061';
wwv_flow_imp.g_varchar2_table(99) := '2073696D706C65206F626A6563740A20202020202020202020736368656D612E74797065203D20226F626A656374223B0A20202020202020202020736368656D612E70726F70657274696573203D20736368656D612E70726F70657274696573207C7C7B';
wwv_flow_imp.g_varchar2_table(100) := '7D3B0A20202020202020202020666F722028636F6E7374205B6C5F6B65792C206C5F646174615D206F66204F626A6563742E656E7472696573286461746129297B0A202020202020202020202020736368656D612E70726F706572746965735B6C5F6B65';
wwv_flow_imp.g_varchar2_table(101) := '795D203D20736368656D612E70726F706572746965735B6C5F6B65795D207C7C7B7D3B0A202020202020202020202020736368656D612E70726F706572746965735B6C5F6B65795D203D2067656E6572617465536368656D6128736368656D612E70726F';
wwv_flow_imp.g_varchar2_table(102) := '706572746965735B6C5F6B65795D2C206C5F64617461293B0A202020202020202020207D0A20202020202020207D0A2020202020207D20656C7365207B0A20202020202020206C6574206C5F74797065203D206E756C6C3B0A20202020202020206C6574';
wwv_flow_imp.g_varchar2_table(103) := '206C5F666F726D6174203D206E756C6C3B0A202020202020202073776974636828747970656F662064617461297B0A20202020202020202020636173652027626F6F6C65616E273A0A2020202020202020202020206C5F74797065203D20435F4A534F4E';
wwv_flow_imp.g_varchar2_table(104) := '5F424F4F4C45414E3B0A20202020202020202020627265616B3B0A202020202020202020206361736520276E756D626572273A0A2020202020202020202020206966284E756D6265722E6973496E7465676572286461746129297B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(105) := '2020202020206C5F74797065203D20435F4A534F4E5F494E54454745523B0A2020202020202020202020207D20656C7365207B0A20202020202020202020202020206C5F74797065203D20435F4A534F4E5F4E554D4245520A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(106) := '207D0A20202020202020202020627265616B3B0A20202020202020202020636173652027737472696E67273A0A2020202020202020202020206C5F74797065203D20435F4A534F4E5F535452494E473B0A202020202020202020202020202020202F2F20';
wwv_flow_imp.g_varchar2_table(107) := '63616C6320666F726D617420746F6F0A202020202020202020202020696628646174612E6D61746368282F5E5C647B347D5C2D5C647B327D5C2D5C647B327D242F29297B0A20202020202020202020202020206C5F666F726D6174203D20276461746527';
wwv_flow_imp.g_varchar2_table(108) := '3B0A2020202020202020202020207D20656C736520696628646174612E6D61746368282F5E5C647B347D5C2D5C647B327D5C2D5C647B327D28547C20295C647B327D285C3A5C647B327D297B312C327D285C2E5C642B293F242F29297B0A202020202020';
wwv_flow_imp.g_varchar2_table(109) := '20202020202020206C5F666F726D6174203D2027646174652D74696D65273B0A2020202020202020202020207D20656C736520696628646174612E6D61746368282F5E5C647B327D285C3A5C647B327D297B312C327D285C2E5C642B293F242F29297B0A';
wwv_flow_imp.g_varchar2_table(110) := '20202020202020202020202020206C5F666F726D6174203D202774696D65273B0A2020202020202020202020207D0A2020202020202020202020627265616B3B0A202020202020202020202064656661756C743A0A202020202020202020202020206966';
wwv_flow_imp.g_varchar2_table(111) := '2864617461297B20202F2F206E756C6C206973204F4B0A2020202020202020202020202020206C6F67536368656D614572726F722827756E6B6E6F776E206461746174797065272C20747970656F6620646174612C2064617461293B0A20202020202020';
wwv_flow_imp.g_varchar2_table(112) := '2020202020207D0A202020202020202020202020206C5F74797065203D20435F4A534F4E5F535452494E473B20202F2F20636F6E74696E7565206173206120737472696E670A20202020202020207D0A2020202020202020736368656D61203D207B7479';
wwv_flow_imp.g_varchar2_table(113) := '70653A206C5F747970657D3B0A20202020202020206966286C5F666F726D6174297B0A20202020202020202020736368656D612E666F726D6174203D206C5F666F726D61743B0A20202020202020207D0A2020202020207D0A202020202020617065782E';
wwv_flow_imp.g_varchar2_table(114) := '64656275672E747261636528223C3C6A736F6E526567696F6E2E67656E6572617465536368656D61222C20736368656D61293B0A20202020202072657475726E20736368656D613B0A20207D0A20202F2A0A2020202A206275696C6420746865206E616D';
wwv_flow_imp.g_varchar2_table(115) := '65206F6620616E206974656D20696E20746865204A534F4E2D726567696F6E2066726F6D20746861200A20202A2F0A202066756E6374696F6E2067656E4974656D6E616D6528646174616974656D2C206669656C64297B0A2020202020206C6574206C5F';
wwv_flow_imp.g_varchar2_table(116) := '6E616D65203D2027273B0A202020202020696628646174616974656D29207B0A20202020202020206C5F6E616D65203D20646174616974656D3B0A20202020202020206966286669656C64297B0A202020202020202020206C5F6E616D65202B3D20435F';
wwv_flow_imp.g_varchar2_table(117) := '44454C494D49544552202B206669656C643B0A20202020202020207D0A2020202020207D20656C7365207B0A20202020202020206C5F6E616D653D6669656C643B0A2020202020207D0A20202020202072657475726E206C5F6E616D653B0A20207D0A0A';
wwv_flow_imp.g_varchar2_table(118) := '20202F2A200A2020202A206576616C7561746573207468652069662D65787072657373696F6E206F66206120636F6E646974696F6E616C20736368656D61207573696E67207468652076616C756573206F6620746865204A534F4E2D646174610A20202A';
wwv_flow_imp.g_varchar2_table(119) := '2F0A202066756E6374696F6E206576616C45787072657373696F6E28736368656D612C2064617461297B0A202020206C6574206C5F726574203D20747275653B0A20202020736368656D61203D20736368656D617C7C7B7D3B0A20202020617065782E64';
wwv_flow_imp.g_varchar2_table(120) := '656275672E747261636528223E3E6A736F6E526567696F6E2E6576616C45787072657373696F6E222C20736368656D612C2064617461293B0A2020202020202020202020202F2F20636865636B20776865746865722076616C75657320617265206E6F74';
wwv_flow_imp.g_varchar2_table(121) := '20656D7074790A20202020666F7228636F6E7374205B6C5F6669656C642C206C5F636F6D705D206F66204F626A6563742E656E747269657328736368656D6129297B0A20202020636F6E736F6C652E6C6F6728274556414C272C206C5F6669656C642C20';
wwv_flow_imp.g_varchar2_table(122) := '6C5F636F6D70293B0A20202020737769746368286C5F6669656C64297B0A202020206361736520435F4A534F4E5F52455155495245443A0A202020202020617065782E64656275672E747261636528276576616C45787072657373696F6E3A20272C2073';
wwv_flow_imp.g_varchar2_table(123) := '6368656D612E72657175697265642C20276E6F7420656D707479272C2064617461293B0A20202020202069662841727261792E69734172726179286C5F636F6D7029297B0A2020202020202020666F7228636F6E7374206C5F6669656C64206F66206C5F';
wwv_flow_imp.g_varchar2_table(124) := '636F6D70297B0A2020202020202020202069662828646174615B6C5F6669656C645D3D3D6E756C6C29207C7C2028646174615B6C5F6669656C645D2E6C656E6774683D3D3029297B20202F2F206669656C6420697320656D7074790A2020202020202020';
wwv_flow_imp.g_varchar2_table(125) := '202020206C5F726574203D2066616C73653B0A202020202020202020207D0A20202020202020207D0A2020202020207D20656C7365207B0A20202020202020206C6F67536368656D614572726F722827636F6E646974696F6E616C20736368656D61272C';
wwv_flow_imp.g_varchar2_table(126) := '206C5F6669656C642C20276D75737420626520616E20617272617927293B200A2020202020207D0A20202020627265616B3B0A202020206361736520435F4A534F4E5F434F4E445F414C4C5F4F463A0A202020202020666F7228636F6E7374206C5F656E';
wwv_flow_imp.g_varchar2_table(127) := '747279206F66206C5F636F6D70297B0A20202020202020206C5F726574203D206C5F726574202626206576616C45787072657373696F6E286C5F656E7472792C2064617461293B0A2020202020207D0A20202020627265616B3B0A202020206361736520';
wwv_flow_imp.g_varchar2_table(128) := '435F4A534F4E5F434F4E445F414E595F4F463A0A202020202020617065782E64656275672E747261636528276576616C45787072657373696F6E3A20272C206C5F6669656C642C206C5F636F6D702C20274F5227293B0A2020202020206C6574206C5F72';
wwv_flow_imp.g_varchar2_table(129) := '657432203D2066616C73653B0A202020202020666F7228636F6E7374206C5F656E747279206F66206C5F636F6D70297B0A20202020202020206C5F72657432203D206C5F72657432207C7C206576616C45787072657373696F6E286C5F656E7472792C20';
wwv_flow_imp.g_varchar2_table(130) := '64617461293B0A2020202020207D0A2020202020206C5F726574203D206C5F726574202626206C5F726574323B0A20202020627265616B3B0A202020206361736520435F4A534F4E5F434F4E445F4E4F543A0A202020202020617065782E64656275672E';
wwv_flow_imp.g_varchar2_table(131) := '747261636528276576616C45787072657373696F6E3A20272C206C5F636F6D702C20274E4F5427293B0A2020202020206C5F726574203D20216576616C45787072657373696F6E286C5F636F6D702C2064617461293B0A20202020627265616B3B0A2020';
wwv_flow_imp.g_varchar2_table(132) := '20206361736520435F4A534F4E5F50524F504552544945533A0A2020202020206C5F726574203D206576616C45787072657373696F6E28736368656D612E70726F706572746965732C2064617461293B0A20202020627265616B3B0A2020202064656661';
wwv_flow_imp.g_varchar2_table(133) := '756C743A20202F2F20612073696D7072652070726F7065727479207769746368203D3D206F7220494E0A20202020202069662841727261792E69734172726179286C5F636F6D702E656E756D29297B0A2020202020202020617065782E64656275672E74';
wwv_flow_imp.g_varchar2_table(134) := '7261636528276576616C45787072657373696F6E3A272C206C5F6669656C642C2022696E20222C206C5F636F6D702C20646174615B6C5F6669656C645D290A2020202020202020696628216C5F636F6D702E656E756D2E696E636C756465732864617461';
wwv_flow_imp.g_varchar2_table(135) := '5B6C5F6669656C645D29297B0A2020202020202020202020206C5F7265743D66616C73653B0A202020202020202020207D0A20202020202020207D20656C736520696628747970656F66206C5F636F6D7020213D2027756E646566696E656427297B0A20';
wwv_flow_imp.g_varchar2_table(136) := '202020202020202020617065782E64656275672E747261636528276576616C45787072657373696F6E3A272C206C5F6669656C642C20223D3D222C206C5F636F6D702C20646174615B6C5F6669656C645D290A202020202020202020206966286C5F636F';
wwv_flow_imp.g_varchar2_table(137) := '6D702E636F6E7374213D646174615B6C5F6669656C645D297B0A2020202020202020202020206C5F7265743D66616C73653B0A202020202020202020207D0A20202020202020207D0A2020202020207D0A20202020627265616B3B0A202020207D0A2020';
wwv_flow_imp.g_varchar2_table(138) := '2020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E6576616C45787072657373696F6E222C20736368656D612C206C5F726574293B0A2020202072657475726E286C5F726574293B0A20207D0A0A20202F2A0A2020202A20';
wwv_flow_imp.g_varchar2_table(139) := '66696C6C2061206D6170207769746820616C6C206974656D7479706573207573656420696E20746865204A534F4E2D536368656D610A20202A2F0A202066756E6374696F6E206765744974656D747970657328736368656D612C206974656D7479706573';
wwv_flow_imp.g_varchar2_table(140) := '297B0A202020206974656D7479706573203D206974656D7479706573207C7C207B747970653A207B7D2C206974656D747970653A207B7D2C20666F726D61743A207B7D7D3B0A20202020617065782E64656275672E747261636528223E3E6A736F6E5265';
wwv_flow_imp.g_varchar2_table(141) := '67696F6E2E6765744974656D7479706573222C20736368656D612C206974656D7479706573293B0A0A202020206974656D74797065732E747970655B736368656D612E747970655D3D747275653B0A2020202073776974636828736368656D612E747970';
wwv_flow_imp.g_varchar2_table(142) := '65297B0A202020206361736520435F4A534F4E5F4F424A4543543A0A202020202020666F72286C6574205B6C5F6E616D652C206C5F70726F70657274795D206F66204F626A6563742E656E747269657328736368656D612E70726F706572746965732929';
wwv_flow_imp.g_varchar2_table(143) := '7B0A20202020202020206974656D7479706573203D206765744974656D7479706573286C5F70726F70657274792C206974656D7479706573293B0A2020202020207D0A20202020627265616B3B0A202020206361736520435F4A534F4E5F41525241593A';
wwv_flow_imp.g_varchar2_table(144) := '0A2020202020206974656D7479706573203D206765744974656D747970657328736368656D612E6974656D732C206974656D7479706573293B0A202020202020696628736368656D612E61706578297B0A20202020202020206974656D74797065732E69';
wwv_flow_imp.g_varchar2_table(145) := '74656D747970655B736368656D612E617065782E6974656D747970655D203D20747275653B0A2020202020207D0A20202020627265616B3B0A2020202064656661756C743A0A202020202020696628736368656D612E666F726D6174297B0A2020202020';
wwv_flow_imp.g_varchar2_table(146) := '2020206974656D74797065732E666F726D61745B736368656D612E666F726D61745D203D20747275653B0A2020202020207D0A202020202020696628736368656D612E61706578297B0A20202020202020206974656D74797065732E6974656D74797065';
wwv_flow_imp.g_varchar2_table(147) := '5B736368656D612E617065782E6974656D747970655D203D20747275653B0A2020202020207D0A20202020627265616B3B0A202020207D0A200A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E6765744974656D';
wwv_flow_imp.g_varchar2_table(148) := '7479706573222C206974656D7479706573293B0A2020202072657475726E286974656D7479706573293B0A20207D0A0A20202F2A0A2020202A207365742073686F772F6869646520617474726962757465206279206D6F646520666F7220616C6C206669';
wwv_flow_imp.g_varchar2_table(149) := '656C7320696E20736368656D612C20746F2073686F772F6869646520636F6E646974696F6E616C207061727473206F66207468652055490A20202A2F0A202066756E6374696F6E2070726F70616761746553686F7728646174616974656D2C2073636865';
wwv_flow_imp.g_varchar2_table(150) := '6D612C206D6F6465297B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E70726F70616761746553686F77222C20646174616974656D2C20736368656D612C206D6F6465293B0A20202020696628736368656D61';
wwv_flow_imp.g_varchar2_table(151) := '2E747970653D3D435F4A534F4E5F4F424A454354297B0A202020202020666F72286C6574205B6C5F6E616D652C206C5F6974656D5D206F66204F626A6563742E656E747269657328736368656D612E70726F7065727469657329297B0A20202020202020';
wwv_flow_imp.g_varchar2_table(152) := '20696628704F7074696F6E732E68656164657273297B0A2020202020202020202020202F2F20636F6E736F6C652E6C6F6728277377697463682068656164657273272C20646174616974656D293B0A2020202020202020202020206966286D6F64653D3D';
wwv_flow_imp.g_varchar2_table(153) := '747275652920207B200A20202020202020202020202020202428272327202B20646174616974656D202B20275F68656164696E6727292E73686F7728293B200A2020202020202020202020207D0A2020202020202020202020206966286D6F64653D3D66';
wwv_flow_imp.g_varchar2_table(154) := '616C736529207B200A20202020202020202020202020202428272327202B20646174616974656D202B20275F68656164696E6727292E6869646528293B200A2020202020202020202020207D0A20202020202020207D0A202020202020202070726F7061';
wwv_flow_imp.g_varchar2_table(155) := '6761746553686F772867656E4974656D6E616D6528646174616974656D2C206C5F6E616D65292C206C5F6974656D2C206D6F6465293B0A2020202020207D0A202020207D20656C7365207B0A2020202020206966286D6F64653D3D747275652920207B20';
wwv_flow_imp.g_varchar2_table(156) := '0A20202020202020202428272327202B20646174616974656D202B20275F434F4E5441494E455227292E73686F7728293B200A20202020202020202428272327202B20646174616974656D292E70726F7028277265717569726564272C736368656D612E';
wwv_flow_imp.g_varchar2_table(157) := '69735265717569726564293B202020202020202020200A2020202020207D0A2020202020206966286D6F64653D3D66616C736529207B200A20202020202020202428272327202B20646174616974656D202B20275F434F4E5441494E455227292E686964';
wwv_flow_imp.g_varchar2_table(158) := '6528293B200A20202020202020202428272327202B20646174616974656D292E70726F7028277265717569726564272C66616C7365293B0A2020202020207D0A202020207D0A20202020617065782E64656275672E747261636528223C3C6A736F6E5265';
wwv_flow_imp.g_varchar2_table(159) := '67696F6E2E70726F70616761746553686F7722293B0A20207D0A0A20202F2A0A20202A20736574207468652072657175697265642061747472696275746520616E64205549206D61726B657220666F7220612055492D6974656D0A20202A2F0A20206675';
wwv_flow_imp.g_varchar2_table(160) := '6E6374696F6E2070726F706167617465526571756972656428646174616974656D2C20736368656D612C206D6F6465297B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E70726F706167617465526571756972';
wwv_flow_imp.g_varchar2_table(161) := '6564222C20646174616974656D2C20736368656D612C206D6F6465293B0A202020206C6574206974656D203D202428272327202B20646174616974656D293B0A202020206974656D2E70726F7028227265717569726564222C6D6F6465293B0A20202020';
wwv_flow_imp.g_varchar2_table(162) := '6966286D6F64653D3D74727565297B0A2020202020206974656D2E636C6F7365737428222E742D466F726D2D6669656C64436F6E7461696E657222292E616464436C617373282269732D726571756972656422293B0A202020207D20656C7365207B0A20';
wwv_flow_imp.g_varchar2_table(163) := '20202020206974656D2E636C6F7365737428222E742D466F726D2D6669656C64436F6E7461696E657222292E72656D6F7665436C617373282269732D726571756972656422293B0A202020207D0A20202020617065782E64656275672E74726163652822';
wwv_flow_imp.g_varchar2_table(164) := '3C3C6A736F6E526567696F6E2E70726F706167617465526571756972656422293B0A20207D0A0A20202F2A0A20202A207365742074686520726561644F6E6C7920617474726962757465207265637572736976656C790A20202A2F0A202066756E637469';
wwv_flow_imp.g_varchar2_table(165) := '6F6E2070726F706167617465526561644F6E6C7928736368656D612C20726561644F6E6C79297B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E70726F706167617465526561644F6E6C79222C20736368656D';
wwv_flow_imp.g_varchar2_table(166) := '612C20726561644F6E6C79293B0A20202020736368656D612E726561644F6E6C79203D20726561644F6E6C793B0A20202020696628736368656D612E747970653D3D435F4A534F4E5F4F424A454354297B0A202020202020666F72286C6574205B6C5F6E';
wwv_flow_imp.g_varchar2_table(167) := '616D652C206C5F736368656D615D206F66204F626A6563742E656E747269657328736368656D612E70726F7065727469657329297B0A202020202020202070726F706167617465526561644F6E6C79286C5F736368656D612C20726561644F6E6C79293B';
wwv_flow_imp.g_varchar2_table(168) := '0A2020202020207D0A202020207D0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E70726F706167617465526561644F6E6C7922293B0A20207D0A0A20202F2A0A2020202A20636F6E7665727420616E20697465';
wwv_flow_imp.g_varchar2_table(169) := '6D2D76616C7565206F662074686520415045582D554920696E746F206A736F6E2D76616C7565206E656564656420666F722073746F72696E672069740A20202A2F0A202066756E6374696F6E206974656D56616C7565324A736F6E28736368656D612C20';
wwv_flow_imp.g_varchar2_table(170) := '76616C7565297B0A2020202069662876616C7565203D3D3D20222229207B2076616C75653D6E756C6C3B207D3B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E6974656D56616C7565324A736F6E222C207363';
wwv_flow_imp.g_varchar2_table(171) := '68656D612C2076616C7565293B202020200A202020206C6574206C5F76616C7565203D2076616C75653B0A2020202069662876616C7565213D6E756C6C297B0A2020202020207472797B0A202020202020202073776974636828736368656D612E747970';
wwv_flow_imp.g_varchar2_table(172) := '65297B0A202020202020202020206361736520435F4A534F4E5F535452494E473A0A20202020202020202020202073776974636828736368656D612E666F726D6174297B0A20202020202020202020202020206361736520435F4A534F4E5F464F524D41';
wwv_flow_imp.g_varchar2_table(173) := '545F444154453A0A202020202020202020202020202020206C5F76616C7565203D20617065782E646174652E746F49534F537472696E6728617065782E646174652E70617273652876616C75652C206744617465466F726D617429292E73756273747269';
wwv_flow_imp.g_varchar2_table(174) := '6E6728302C3130293B0A2020202020202020202020202020627265616B3B0A20202020202020202020202020206361736520435F4A534F4E5F464F524D41545F4441544554494D453A0A20202020202020202020202020202020696628704F7074696F6E';
wwv_flow_imp.g_varchar2_table(175) := '732E617065785F76657273696F6E3E3D435F415045585F56455253494F4E5F3231303229207B0A2020202020202020202020202020202020206C5F76616C7565203D20617065782E646174652E746F49534F537472696E6728617065782E646174652E70';
wwv_flow_imp.g_varchar2_table(176) := '617273652876616C75652C206744617465466F726D6174202B20272027202B206754696D65466F726D61742E7265706C61636528276D6D272C274D4927292E7265706C616365282748483234272C27484827292E7265706C61636528274848272C274848';
wwv_flow_imp.g_varchar2_table(177) := '3234272929293B0A202020202020202020202020202020207D20656C7365207B0A2020202020202020202020202020202020206C5F76616C7565203D20617065782E646174652E746F49534F537472696E6728617065782E646174652E70617273652876';
wwv_flow_imp.g_varchar2_table(178) := '616C75652C206744617465466F726D6174202B20272027202B206754696D65466F726D617429293B0A202020202020202020202020202020207D0A2020202020202020202020202020627265616B3B20200A202020202020202020202020202063617365';
wwv_flow_imp.g_varchar2_table(179) := '20435F4A534F4E5F464F524D41545F54494D453A0A202020202020202020202020202020206C5F76616C7565203D2076616C75653B0A2020202020202020202020202020627265616B3B0A2020202020202020202020207D0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(180) := '206C5F76616C7565203D206C5F76616C75652E6C656E6774683E303F6C5F76616C75653A6E756C6C3B0A20202020202020202020627265616B3B20200A202020202020202020206361736520435F4A534F4E5F424F4F4C45414E3A0A2020202020202020';
wwv_flow_imp.g_varchar2_table(181) := '202020206C5F76616C7565203D202876616C75653D3D225922293B0A20202020202020202020627265616B3B0A202020202020202020206361736520435F4A534F4E5F494E54454745523A0A202020202020202020206361736520435F4A534F4E5F4E55';
wwv_flow_imp.g_varchar2_table(182) := '4D4245523A0A20202020202020202020202069662876616C7565213D6E756C6C29207B0A2020202020202020202020202020696628736368656D612E617065782E666F726D6174297B0A202020202020202020202020202020206C5F76616C7565203D20';
wwv_flow_imp.g_varchar2_table(183) := '617065782E6C6F63616C652E746F4E756D6265722876616C75652C20736368656D612E617065782E666F726D6174293B0A20202020202020202020202020207D20656C7365207B0A202020202020202020202020202020206C5F76616C7565203D206170';
wwv_flow_imp.g_varchar2_table(184) := '65782E6C6F63616C652E746F4E756D6265722876616C7565293B0A20202020202020202020202020207D0A2020202020202020202020207D0A20202020202020202020627265616B3B20200A20202020202020207D0A2020202020207D20636174636828';
wwv_flow_imp.g_varchar2_table(185) := '65297B0A2020202020202020617065782E64656275672E6572726F722827496E76616C696420696E7075742064617461272C20736368656D612E617065782E666F726D61742C2076616C75652C2065293B0A2020202020207D0A202020207D0A20202020';
wwv_flow_imp.g_varchar2_table(186) := '617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E6974656D56616C7565324A736F6E222C206C5F76616C7565293B0A2020202072657475726E206C5F76616C75653B0A20207D0A0A20202F2A0A2020202A2067657420746865';
wwv_flow_imp.g_varchar2_table(187) := '2056616C7565206F66206120636F6E7374616E742022636F6E7374223A202E2E2E0A2020202A207573656420746F20636F6E766572742074686520636F6E7374616E74204E4F572F6E657720696E7420746F2063757272656E7420646174652F64617465';
wwv_flow_imp.g_varchar2_table(188) := '74696D650A20202A2F0A202066756E6374696F6E20676574436F6E7374616E7428666F726D61742C207374722C20697344656661756C74297B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E676574436F6E73';
wwv_flow_imp.g_varchar2_table(189) := '74616E74222C20666F726D61742C207374722C20697344656661756C74293B0A202020206C6574206C5F76616C7565203D207374723B0A2020202069662828747970656F6628737472293D3D27737472696E67272920262620287374722E746F55707065';
wwv_flow_imp.g_varchar2_table(190) := '72436173652829203D3D20274E4F572729297B0A2020202020206C6574206C5F6E6F77203D206E6577204461746528293B0A2020202020206C5F6E6F77203D206E65772044617465286C5F6E6F77202D206C5F6E6F772E67657454696D657A6F6E654F66';
wwv_flow_imp.g_varchar2_table(191) := '6673657428292A3630303030292E746F49534F537472696E6728293B0A20202020202073776974636828666F726D6174297B0A2020202020206361736520435F4A534F4E5F464F524D41545F444154453A0A202020202020202020206C5F76616C756520';
wwv_flow_imp.g_varchar2_table(192) := '3D206C5F6E6F772E737562737472696E6728302C3130293B202F2F20617065782E646174652E666F726D6174286E6577204461746528292C2027595959592D4D4D2D444427293B0A202020202020627265616B3B0A2020202020206361736520435F4A53';
wwv_flow_imp.g_varchar2_table(193) := '4F4E5F464F524D41545F4441544554494D453A0A202020202020202020206C5F76616C7565203D206C5F6E6F772E737562737472696E6728302C3139293B202F2F20617065782E646174652E666F726D6174286E6577204461746528292C202759595959';
wwv_flow_imp.g_varchar2_table(194) := '2D4D4D2D444454484832343A4D493A535327293B0A202020202020627265616B3B0A2020202020206361736520435F4A534F4E5F464F524D41545F54494D453A0A202020202020202020206C5F76616C7565203D206C5F6E6F772E737562737472696E67';
wwv_flow_imp.g_varchar2_table(195) := '2831312C3136293B202F2F20617065782E646174652E666F726D6174286E6577204461746528292C2027484832343A4D4927293B0A202020202020627265616B3B0A20202020202064656661756C743A0A202020202020202020206C5F76616C7565203D';
wwv_flow_imp.g_varchar2_table(196) := '207374723B0A202020202020627265616B3B0A2020202020207D0A20202020202069662821697344656661756C7420262620666F726D61743D3D435F4A534F4E5F464F524D41545F4441544529207B20200A202020202020202020202F2F20616C776179';
wwv_flow_imp.g_varchar2_table(197) := '7320616464202068683A6D6D3A737320746F2064617465207768656E206E6F742064656661756C740A20202020202020206C5F76616C7565202B3D20275430303A30303A3030273B0A2020202020207D0A200A202020207D0A20202020617065782E6465';
wwv_flow_imp.g_varchar2_table(198) := '6275672E747261636528223C3C6A736F6E526567696F6E2E676574436F6E7374616E74222C206C5F76616C7565293B0A2020202072657475726E20286C5F76616C7565293B0A20207D0A0A20202F2A0A2020202A20636F6E76657274206A736F6E2D7661';
wwv_flow_imp.g_varchar2_table(199) := '6C756520696E746F206974656D2D76616C756520726571756972656420696E2074686520415045582D55490A20202A2F0A202066756E6374696F6E206A736F6E56616C7565324974656D28736368656D612C2076616C75652C206E65774974656D297B0A';
wwv_flow_imp.g_varchar2_table(200) := '202020206C6574206C5F76616C7565203D2076616C75653B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E6A736F6E56616C7565324974656D222C20736368656D61293B0A202020206966286E65774974656D';
wwv_flow_imp.g_varchar2_table(201) := '202626202176616C756520262620736368656D612E64656661756C7429207B0A2020202020202F2F205768656E20612064656661756C7420697320636F6E666967757265642C2075736520697420666F72207768656E2061206E6577206974656D206973';
wwv_flow_imp.g_varchar2_table(202) := '20696E207573650A20202020202076616C7565203D20676574436F6E7374616E7428736368656D612E666F726D61742C20736368656D612E64656661756C742C2074727565293B0A202020207D0A0A20202020696628736368656D612E77726974654F6E';
wwv_flow_imp.g_varchar2_table(203) := '6C79297B2020202F2F20646F206E6F742073686F77207468652063757272656E742076616C7565207768656E20697420697320612077726974654F6E6C792055492D6974656D0A20202020202076616C7565203D206E756C6C3B0A2020202020206C5F76';
wwv_flow_imp.g_varchar2_table(204) := '616C7565203D20206E756C6C3B0A202020207D0A0A2020202069662876616C7565207C7C2076616C75653D3D66616C7365207C7C2076616C75653D3D30207C7C2076616C75653D3D302E30297B0A2020202020206C5F76616C7565203D2076616C75653B';
wwv_flow_imp.g_varchar2_table(205) := '0A202020202020747279207B202020200A202020202020202073776974636828736368656D612E74797065297B0A202020202020202020206361736520435F4A534F4E5F494E54454745523A0A202020202020202020206361736520435F4A534F4E5F4E';
wwv_flow_imp.g_varchar2_table(206) := '554D4245523A0A202020202020202020202020696628215B435F415045585F53544152524154494E472C20435F415045585F50435447524150485D2E696E636C7564657328736368656D612E617065782E6974656D7479706529297B0A20202020202020';
wwv_flow_imp.g_varchar2_table(207) := '20202020202020696628736368656D612E617065782E666F726D6174297B0A202020202020202020202020202020206C5F76616C7565203D20617065782E6C6F63616C652E666F726D61744E756D626572286C5F76616C75652C20736368656D612E6170';
wwv_flow_imp.g_varchar2_table(208) := '65782E666F726D6174293B0A20202020202020202020202020207D20656C7365207B0A20202020202020202020202020202020696628704F7074696F6E732E617065785F76657273696F6E3C435F415045585F56455253494F4E5F32313032297B20202F';
wwv_flow_imp.g_varchar2_table(209) := '2F206F6C646572207468616E2032312E322C207468616E20666F726D61744E756D62657220646F6573206E6F7420657863616E676520736570657261746F72730A2020202020202020202020202020202020206C5F76616C7565203D202827272B6C5F76';
wwv_flow_imp.g_varchar2_table(210) := '616C7565292E7265706C61636528272E272C20617065782E6C6F63616C652E676574446563696D616C536570617261746F722829293B0A202020202020202020202020202020207D20656C7365207B0A2020202020202020202020202020202020206C5F';
wwv_flow_imp.g_varchar2_table(211) := '76616C7565203D20617065782E6C6F63616C652E666F726D61744E756D626572286C5F76616C7565293B0A202020202020202020202020202020207D0A20202020202020202020202020207D0A20202020202020202020202020206966286C5F76616C75';
wwv_flow_imp.g_varchar2_table(212) := '65202626206C5F76616C75652E73746172747357697468282720272929207B206C5F76616C75653D6C5F76616C75652E737562737472696E672831297D20202F2F207768656E206E756D6572696320737472696E67207374617274732077697468202720';
wwv_flow_imp.g_varchar2_table(213) := '272072656D6F76652069740A2020202020202020202020207D0A20202020202020202020627265616B3B0A202020202020202020206361736520435F4A534F4E5F535452494E473A0A20202020202020202020202073776974636828736368656D612E66';
wwv_flow_imp.g_varchar2_table(214) := '6F726D6174297B0A20202020202020202020202020206361736520435F4A534F4E5F464F524D41545F444154453A0A2020202020202020202020202020202073776974636828704F7074696F6E732E617065785F76657273696F6E297B0A202020202020';
wwv_flow_imp.g_varchar2_table(215) := '202020202020202020206361736520435F415045585F56455253494F4E5F323030313A0A202020202020202020202020202020206361736520435F415045585F56455253494F4E5F323030323A0A2020202020202020202020202020202020206C5F7661';
wwv_flow_imp.g_varchar2_table(216) := '6C7565203D20242E646174657069636B65722E666F726D617444617465286744617465466F726D61742C206E657720446174652876616C756529293B0A20202020202020202020202020202020627265616B3B0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(217) := '6361736520435F415045585F56455253494F4E5F323130313A0A202020202020202020202020202020206361736520435F415045585F56455253494F4E5F323130323A0A202020202020202020202020202020206361736520435F415045585F56455253';
wwv_flow_imp.g_varchar2_table(218) := '494F4E5F323230323A0A202020202020202020202020202020206361736520435F415045585F56455253494F4E5F323330313A0A202020202020202020202020202020206361736520435F415045585F56455253494F4E5F323330323A0A202020202020';
wwv_flow_imp.g_varchar2_table(219) := '2020202020202020202064656661756C743A0A2020202020202020202020202020202020206C5F76616C7565203D20617065782E646174652E666F726D617428617065782E646174652E70617273652876616C75652C27595959592D4D4D2D444427292C';
wwv_flow_imp.g_varchar2_table(220) := '206744617465466F726D6174293B0A20202020202020202020202020202020627265616B3B0A202020202020202020202020202020206361736520435F415045585F56455253494F4E5F323230313A0A2020202020202020202020202020202020202F2F';
wwv_flow_imp.g_varchar2_table(221) := '206B656570207468652049534F2D666F726D61740A2020202020202020202020202020202020206C5F76616C7565203D2076616C75653B0A20202020202020202020202020202020627265616B3B0A202020202020202020202020202020207D0A202020';
wwv_flow_imp.g_varchar2_table(222) := '2020202020202020202020627265616B3B0A20202020202020202020202020206361736520435F4A534F4E5F464F524D41545F4441544554494D453A0A2020202020202020202020202020202073776974636828704F7074696F6E732E617065785F7665';
wwv_flow_imp.g_varchar2_table(223) := '7273696F6E297B0A202020202020202020202020202020206361736520435F415045585F56455253494F4E5F323030313A0A202020202020202020202020202020206361736520435F415045585F56455253494F4E5F323030323A0A2020202020202020';
wwv_flow_imp.g_varchar2_table(224) := '20202020202020206361736520435F415045585F56455253494F4E5F323130313A0A202020202020202020202020202020202020202076616C7565203D2076616C75652E7265706C616365282754272C20272027293B202F2F2065786365707420646174';
wwv_flow_imp.g_varchar2_table(225) := '6574696D65207769746820222022206F7220225422206265747765656E206461746520616E642074696D652C20415045583C32322E31202220222064656C696D697465720A2020202020202020202020202020202020206C5F76616C7565203D20242E64';
wwv_flow_imp.g_varchar2_table(226) := '6174657069636B65722E666F726D617444617465286744617465466F726D61742C206E657720446174652876616C75652929202B20272027202B2076616C75652E6D61746368282F5B5C645D7B327D3A5B5C645D7B327D283A5B5C645D7B327D293F2F67';
wwv_flow_imp.g_varchar2_table(227) := '293B0A20202020202020202020202020202020627265616B3B0A202020202020202020202020202020206361736520435F415045585F56455253494F4E5F323130323A0A2020202020202020202020202020202020206C5F76616C7565203D2061706578';
wwv_flow_imp.g_varchar2_table(228) := '2E646174652E666F726D6174286E657720446174652876616C7565292C206744617465466F726D6174202B20272027202B206754696D65466F726D61742E7265706C61636528276D6D272C274D4927292E7265706C616365282748483234272C2727292E';
wwv_flow_imp.g_varchar2_table(229) := '7265706C61636528274848272C27484832342729293B0A20202020202020202020202020202020627265616B3B0A202020202020202020202020202020206361736520435F415045585F56455253494F4E5F323230323A0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(230) := '202020206361736520435F415045585F56455253494F4E5F323330313A0A202020202020202020202020202020206361736520435F415045585F56455253494F4E5F323330323A0A2020202020202020202020202020202064656661756C743A0A202020';
wwv_flow_imp.g_varchar2_table(231) := '2020202020202020202020202020206C5F76616C7565203D20617065782E646174652E666F726D6174286E657720446174652876616C7565292C206744617465466F726D6174202B20272027202B206754696D65466F726D6174293B0A20202020202020';
wwv_flow_imp.g_varchar2_table(232) := '202020202020202020627265616B3B0A202020202020202020202020202020206361736520435F415045585F56455253494F4E5F323230313A0A20202020202020202020202020202020202020202F2F206B656570207468652049534F2D666F726D6174';
wwv_flow_imp.g_varchar2_table(233) := '0A2020202020202020202020202020202020206C5F76616C7565203D2076616C75653B0A20202020202020202020202020202020627265616B3B0A202020202020202020202020202020207D0A2020202020202020202020202020627265616B3B0A2020';
wwv_flow_imp.g_varchar2_table(234) := '2020202020202020202020206361736520435F4A534F4E5F464F524D41545F54494D453A0A202020202020202020202020202020206C5F76616C7565203D2076616C75652E737562737472696E6728302C35293B0A202020202020202020202020202062';
wwv_flow_imp.g_varchar2_table(235) := '7265616B3B0A202020202020202020202020202064656661756C743A0A20202020202020202020202020202020696628736368656D612E726561644F6E6C79297B0A20202020202020202020202020202020202073776974636828736368656D612E6170';
wwv_flow_imp.g_varchar2_table(236) := '65782E6974656D74797065297B0A2020202020202020202020202020202020206361736520435F415045585F54455854415245413A0A20202020202020202020202020202020202020206C5F76616C75653D206C5F76616C75653F6C5F76616C75652E72';
wwv_flow_imp.g_varchar2_table(237) := '65706C616365416C6C28273C272C2027266C743B27292E7265706C616365416C6C28275C6E272C20273C62722F3E27293A27273B0A202020202020202020202020202020202020627265616B3B0A20202020202020202020202020202020202063617365';
wwv_flow_imp.g_varchar2_table(238) := '20435F415045585F52494348544558543A0A202020202020202020202020202020202020627265616B3B202020200A2020202020202020202020202020202020207D20200A202020202020202020202020202020207D20200A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(239) := '207D0A20202020202020202020627265616B3B20200A202020202020202020206361736520435F4A534F4E5F424F4F4C45414E3A0A2020202020202020202020206C5F76616C7565203D202876616C75653F2259223A224E22293B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(240) := '2020627265616B3B0A202020202020202020206361736520435F4A534F4E5F494E54454745523A0A202020202020202020206361736520435F4A534F4E5F4E554D4245523A0A20202020202020202020206C5F76616C7565203D20617065782E6C6F6361';
wwv_flow_imp.g_varchar2_table(241) := '6C652E666F726D61744E756D6265722876616C75652C20736368656D612E6170657820262620736368656D612E617065782E666F726D6174207C7C6E756C6C293B0A20202020202020202020627265616B3B0A20202020202020207D0A2020202020207D';
wwv_flow_imp.g_varchar2_table(242) := '2063617463682865297B0A2020202020202020617065782E64656275672E6572726F722827496E76616C6964204A534F4E2D64617461272C2076616C75652C2065293B0A2020202020207D0A202020207D20200A20202020617065782E64656275672E74';
wwv_flow_imp.g_varchar2_table(243) := '7261636528223C3C6A736F6E526567696F6E2E6A736F6E56616C7565324974656D222C206C5F76616C7565293B0A2020202072657475726E286C5F76616C7565293B0A20207D0A0A20202F2A0A2020202A2020616464206120726F7720746F20616E2061';
wwv_flow_imp.g_varchar2_table(244) := '727261790A20202A2F0A202066756E6374696F6E2064656C4172726179526F7728646174616974656D297B0A202020206C6574206C5F726F776964203D202827272B646174616974656D292E7265706C616365282F44454C455445242F2C2027434F4E54';
wwv_flow_imp.g_varchar2_table(245) := '41494E455227290A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E64656C4172726179526F77222C20646174616974656D2C206C5F726F776964293B0A202020202428272327202B206C5F726F776964292E7265';
wwv_flow_imp.g_varchar2_table(246) := '6D6F766528290A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E64656C4172726179526F7722293B0A20207D0A0A20202F2A0A2020202A2020616464206120726F7720746F20616E2061727261790A20202A2F0A';
wwv_flow_imp.g_varchar2_table(247) := '202066756E6374696F6E206164644172726179526F7728646174616974656D2C20736368656D612C2061744C617374297B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E6164644172726179526F77222C2064';
wwv_flow_imp.g_varchar2_table(248) := '6174616974656D2C20736368656D612C2061744C617374293B0A202020206C6574206C5F6974656D73203D202428222322202B2070526567696F6E4964202B2027205B69645E3D2227202B20646174616974656D202B20275F225D2E726F7727293B0A20';
wwv_flow_imp.g_varchar2_table(249) := '202020636F6E7374206C5F6964203D2061744C6173743F6C5F6974656D732E6C656E6774682D313A303B0A20202020636F6E7374206C5F6974656D203D206C5F6974656D735B6C5F69645D2E69643B0A0A20202020202F2F2063616C63206E6578742049';
wwv_flow_imp.g_varchar2_table(250) := '4420666F7220746865206E657720726F772C2067726561746572207468616E204D4158206F6620746865206578697374696E6720726F77730A20202020636F6E7374206C5F6E65774964203D204D6174682E6D6178282E2E2E6C5F6974656D732E6D6170';
wwv_flow_imp.g_varchar2_table(251) := '28202869642C206974656D293D3E207B0A2020202020202020636F6E73742076616C203D206974656D2E69642E7265706C616365282F2E2B5F285C642B295F434F4E5441494E4552242F2C2027243127293B200A202020202020202072657475726E2069';
wwv_flow_imp.g_varchar2_table(252) := '734E614E2876616C293F303A76616C0A2020202020207D292E746F417272617928290A20202020292B313B202020200A202020202F2F20636F6E736F6C652E6572726F7228646174616974656D2C206C5F6E65774964293B0A2020202070726F70616761';
wwv_flow_imp.g_varchar2_table(253) := '7465526561644F6E6C7928736368656D612E6974656D732C2066616C7365293B20202F2F207768656E20616464206973207065726D69747465642C2061646420726F772077697468200A202020206C6574206C5F67656E657261746564203D2067656E65';
wwv_flow_imp.g_varchar2_table(254) := '72617465466F724F626A65637428736368656D612E6974656D732C207B7D2C20646174616974656D2C2027272B206C5F6E657749642C2066616C73652C20747275652C20747275652C2074727565293B0A202020206C5F67656E6572617465642E68746D';
wwv_flow_imp.g_varchar2_table(255) := '6C203D20273C64697620636C6173733D22726F77206A736F6E726567696F6E223E27202B206C5F67656E6572617465642E68746D6C202B20273C2F6469763E273B0A0A2020202069662861744C617374297B0A2020202020202428272327202B206C5F69';
wwv_flow_imp.g_varchar2_table(256) := '74656D20292E6166746572286C5F67656E6572617465642E68746D6C293B0A202020207D20656C7365207B0A2020202020202428272327202B206C5F6974656D20292E6265666F7265286C5F67656E6572617465642E68746D6C293B0A202020207D0A20';
wwv_flow_imp.g_varchar2_table(257) := '2020206174746163684F626A65637428646174616974656D202B20275F27202B206C5F6E657749642C2027272C20736368656D612E6974656D732C2066616C73652C207B7D2C2074727565293B0A20202020617065782E6974656D2E6174746163682824';
wwv_flow_imp.g_varchar2_table(258) := '28272327202B2070526567696F6E496429293B0A20202020616464417272617944656C6574654576656E7428293B0A20202020617065784861636B7328293B0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E61';
wwv_flow_imp.g_varchar2_table(259) := '64644172726179526F7722293B0A20207D0A20202F2A0A2020202A20617474616368207468652067656E657261746564206669656C6473206F6620616E20617272617920696E20746865204A534F4E2D736368656D6120746F20415045580A20202A2F0A';
wwv_flow_imp.g_varchar2_table(260) := '202066756E6374696F6E20617474616368417272617928646174616974656D2C20707265766974656D2C20736368656D612C20726561646F6E6C792C20646174612C206E65774974656D297B200A20202020617065782E64656275672E74726163652822';
wwv_flow_imp.g_varchar2_table(261) := '3E3E6A736F6E526567696F6E2E6174746163684172726179222C20646174616974656D2C20736368656D612C20726561646F6E6C792C2064617461293B0A202020206C6574206C5F76616C7565203D206A736F6E56616C7565324974656D28736368656D';
wwv_flow_imp.g_varchar2_table(262) := '612C20646174612C206E65774974656D293B0A20202020736368656D61203D20736368656D617C7C7B7D3B0A20202020736368656D612E61706578203D20736368656D612E61706578207C7C207B7D3B0A202020206C6574206974656D203D2073636865';
wwv_flow_imp.g_varchar2_table(263) := '6D612E6974656D737C7C7B7D3B0A2020202069662841727261792E69734172726179286974656D2E656E756D29297B20202F2F5B435F4A534F4E5F535452494E472C20435F4A534F4E5F494E54454745522C20435F4A534F4E5F4E554D4245525D2E696E';
wwv_flow_imp.g_varchar2_table(264) := '636C75646573286974656D2E7479706529297B0A202020202020696628736368656D612E617065782E6974656D747970653D3D435F415045585F53454C4543544D414E59297B0A2020202020202020617065782E6974656D2E6372656174652864617461';
wwv_flow_imp.g_varchar2_table(265) := '6974656D2C207B6974656D5F747970653A202773656C6563746D616E79277D293B0A2020202020207D20656C736520696628704F7074696F6E732E617065785F76657273696F6E203E3D435F415045585F56455253494F4E5F3233303220262620287363';
wwv_flow_imp.g_varchar2_table(266) := '68656D612E617065782E6974656D74797065203D3D20435F415045585F434F4D424F207C7C20286974656D2E61706578202626206974656D2E617065782E6974656D74797065203D3D20435F415045585F434F4D424F2929297B0A202020202020202061';
wwv_flow_imp.g_varchar2_table(267) := '7065782E6974656D2E63726561746528646174616974656D2C207B6974656D5F747970653A20435F415045585F434F4D424F7D293B0A2020202020207D20656C7365207B0A2020202020202020617065782E7769646765742E636865636B626F78416E64';
wwv_flow_imp.g_varchar2_table(268) := '526164696F282723272B20646174616974656D2C20435F415045585F434845434B424F58293B0A2020202020207D3B0A202020207D20656C7365207B0A20202020202064617461203D2064617461207C7C205B5D3B0A2020202020206966284172726179';
wwv_flow_imp.g_varchar2_table(269) := '2E69734172726179286461746129297B0A2020202020202020696628736368656D612E617065782E686173496E7365727420213D20276E6F6E6527297B0A202020202020202020202428272327202B20646174616974656D202B20275F43524541544527';
wwv_flow_imp.g_varchar2_table(270) := '292E6F6E2827636C69636B272C2066756E6374696F6E286576297B206164644172726179526F7728646174616974656D2C20736368656D612C20736368656D612E617065782E686173496E73657274213D27626567696E27293B7D293B0A202020202020';
wwv_flow_imp.g_varchar2_table(271) := '20207D0A2020202020202020666F7228636F6E7374206920696E2064617461297B0A202020202020202020206174746163684F626A65637428646174616974656D202B20435F44454C494D49544552202B2069202C20707265766974656D2C206974656D';
wwv_flow_imp.g_varchar2_table(272) := '2C20726561646F6E6C792C20646174615B695D2C206E65774974656D29200A20202020202020207D0A2020202020207D0A202020207D0A20202020696628726561646F6E6C7929207B0A202020202020617065782E6974656D28646174616974656D292E';
wwv_flow_imp.g_varchar2_table(273) := '64697361626C6528293B200A202020207D0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E617474616368417272617922293B0A20207D0A0A20202F2A0A2020202A20736574207468652056616C756573206F66';
wwv_flow_imp.g_varchar2_table(274) := '20616E20617272617920696E20746865204A534F4E2D736368656D610A20202A2F0A202066756E6374696F6E20736574417272617956616C75657328646174616974656D2C20707265766974656D2C20736368656D612C20726561646F6E6C792C206461';
wwv_flow_imp.g_varchar2_table(275) := '7461297B200A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E736574417272617956616C756573222C20646174616974656D2C20707265766974656D2C20736368656D612C20726561646F6E6C792C2064617461';
wwv_flow_imp.g_varchar2_table(276) := '293B0A202020206C6574206C5F76616C7565203D206A736F6E56616C7565324974656D28736368656D612C20646174612C206E65774974656D293B0A20202020736368656D612E61706578203D20736368656D612E61706578207C7C207B7D3B0A202020';
wwv_flow_imp.g_varchar2_table(277) := '206C6574206974656D203D20736368656D612E6974656D737C7C7B7D3B0A2020202064617461203D20646174617C7C5B5D3B0A2020202069662841727261792E69734172726179286461746129297B0A2020202020206966282041727261792E69734172';
wwv_flow_imp.g_varchar2_table(278) := '726179286974656D2E656E756D29297B20202F2F207768656E20746865726520697320616E20656E756D2C207468697320617272617920666F722061206D756C746973656C656374696F6E0A20202020202020206966285B435F4A534F4E5F535452494E';
wwv_flow_imp.g_varchar2_table(279) := '472C20435F4A534F4E5F494E54454745522C20435F4A534F4E5F4E554D4245525D2E696E636C75646573286974656D2E7479706529297B0A202020202020202020206C5F76616C7565203D20286C5F76616C75657C7C5B5D292E6D617028783D3E202727';
wwv_flow_imp.g_varchar2_table(280) := '2B78293B2020202F2F636F6E7665727420746F20737472696E672061727261790A20202020202020202020617065782E64656275672E74726163652827736574417272617956616C7565733A272C206C5F76616C7565293B0A2020202020202020202061';
wwv_flow_imp.g_varchar2_table(281) := '7065782E6974656D28646174616974656D292E73657456616C7565286C5F76616C75657C7C5B5D293B0A20202020202020202020696628726561646F6E6C7929207B0A202020202020202020202020617065782E6974656D28646174616974656D292E64';
wwv_flow_imp.g_varchar2_table(282) := '697361626C6528293B0A202020202020202020207D200A20202020202020207D0A2020202020207D20656C7365207B0A2020202020202020666F7228636F6E7374206920696E2064617461297B0A202020202020202020207365744F626A65637456616C';
wwv_flow_imp.g_varchar2_table(283) := '75657328646174616974656D202B20435F44454C494D49544552202B20692C20707265766974656D2C206974656D2C20726561646F6E6C792C20646174615B695D293B0A20202020202020207D0A2020202020207D0A202020207D20656C7365207B0A20';
wwv_flow_imp.g_varchar2_table(284) := '20202020206C6F67536368656D614572726F72282764617461206D75737420626520616E206172726179272C2064617461293B0A202020207D0A0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E736574417272';
wwv_flow_imp.g_varchar2_table(285) := '617956616C75657322293B0A20207D0A0A20202F2A0A2020202A20736574207468652056616C756573206F66206120616C6C206669656C647320696E20746865204A534F4E2D736368656D610A20202A2F0A202066756E6374696F6E207365744F626A65';
wwv_flow_imp.g_varchar2_table(286) := '637456616C75657328646174616974656D2C20707265766974656D2C20736368656D612C20726561646F6E6C792C2064617461297B200A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E7365744F626A65637456';
wwv_flow_imp.g_varchar2_table(287) := '616C756573222C20646174616974656D2C20707265766974656D2C20736368656D612C20726561646F6E6C792C2064617461293B0A20202020736368656D612E61706578203D20736368656D612E61706578207C7C207B7D3B0A202020206C6574206C5F';
wwv_flow_imp.g_varchar2_table(288) := '76616C7565203D206A736F6E56616C7565324974656D28736368656D612C20646174612C206E65774974656D293B0A2020202073776974636828736368656D612E74797065297B0A2020202063617365206E756C6C3A0A202020206361736520756E6465';
wwv_flow_imp.g_varchar2_table(289) := '66696E65643A0A2020202020206966282127636F6E73742720696E20736368656D6129207B20202F2F20636F6E737420686173206E6F20747970650A20202020202020206C6F67536368656D614572726F7228276D697373696E67202274797065222061';
wwv_flow_imp.g_varchar2_table(290) := '74272C20646174616974656D293B0A2020202020207D0A20202020627265616B3B0A202020206361736520435F4A534F4E5F4F424A4543543A0A202020202020696628747970656F6620736368656D612E70726F70657274696573203D3D20276F626A65';
wwv_flow_imp.g_varchar2_table(291) := '637427297B0A202020202020202064617461203D2064617461207C7C7B7D3B0A2020202020202020666F72286C6574205B6C5F6E616D652C206C5F736368656D615D206F66204F626A6563742E656E747269657328736368656D612E70726F7065727469';
wwv_flow_imp.g_varchar2_table(292) := '657329297B0A20202020202020202020696628212827272B6C5F6E616D65292E7374617274735769746828275F2729297B2020202F2F2069676E6F72652070726F7065727469657320686176696E67206E616D6573207374617274696E67207769746820';
wwv_flow_imp.g_varchar2_table(293) := '225F220A2020202020202020202020207365744F626A65637456616C7565732867656E4974656D6E616D6528646174616974656D2C206C5F6E616D65292C20646174616974656D2C206C5F736368656D612C20736368656D612E726561644F6E6C792C20';
wwv_flow_imp.g_varchar2_table(294) := '646174615B6C5F6E616D655D293B0A202020202020202020207D0A20202020202020207D0A2020202020207D0A20202020627265616B3B0A202020206361736520435F4A534F4E5F41525241593A2020200A202020202020736574417272617956616C75';
wwv_flow_imp.g_varchar2_table(295) := '657328646174616974656D2C20646174616974656D2C20736368656D612C20736368656D612E726561644F6E6C792C2064617461293B0A20202020627265616B3B0A20202020636173652027636F6E7374273A20202F2F206120636F6E73742076616C75';
wwv_flow_imp.g_varchar2_table(296) := '650A202020206361736520276E756C6C273A20202F2F20656D707479206F626A65637420646F206E6F7468696E670A20202020627265616B3B0A202020206361736520435F4A534F4E5F424F4F4C45414E3A0A202020202020617065782E6974656D2864';
wwv_flow_imp.g_varchar2_table(297) := '6174616974656D292E73657456616C7565286C5F76616C7565293B0A202020202020696628736368656D612E726561644F6E6C7929207B0A2020202020202020617065782E6974656D28646174616974656D292E64697361626C6528293B200A20202020';
wwv_flow_imp.g_varchar2_table(298) := '20207D0A20202020627265616B3B0A2020202064656661756C743A0A202020202020696628736368656D612E726561644F6E6C79297B0A20202020202020206966285B435F415045585F53544152524154494E475D2E696E636C7564657328736368656D';
wwv_flow_imp.g_varchar2_table(299) := '612E617065782E6974656D747970652929207B0A20202020202020202020617065782E6974656D28646174616974656D292E64697361626C6528293B0A20202020202020207D0A0A202020202020202069662821617065782E7769646765742E70637447';
wwv_flow_imp.g_varchar2_table(300) := '72617068202626205B435F415045585F50435447524150485D2E696E636C7564657328736368656D612E617065782E6974656D7479706529297B0A202020202020202020202428272327202B20646174616974656D292E68746D6C28617065782E697465';
wwv_flow_imp.g_varchar2_table(301) := '6D28646174616974656D292E646973706C617956616C7565466F72286C5F76616C756529293B0A20202020202020207D0A20202020202020200A20202020202020206966285B435F415045585F52494348544558545D2E696E636C756465732873636865';
wwv_flow_imp.g_varchar2_table(302) := '6D612E617065782E6974656D7479706529297B0A202020202020202020206C5F76616C7565203D2077696E646F772E6D61726B65642E706172736528206C5F76616C75652C207B0A20202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(303) := '202067666D3A20747275652C0A202020202020202020202020202020202020202020202020202020202020627265616B733A20747275652C0A2020202020202020202020202020202020202020202020202020202020207461626C65733A20747275652C';
wwv_flow_imp.g_varchar2_table(304) := '0A2020202020202020202020202020202020202020202020202020202020206D616E676C653A2066616C73652C0A2020202020202020202020202020202020202020202020202020202020207868746D6C3A2066616C73652C0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(305) := '20202020202020202020202020202020202020206865616465724964733A2066616C73650A202020202020202020202020202020202020202020202020202020207D293B0A202020202020202020202428272327202B20646174616974656D202B20275F';
wwv_flow_imp.g_varchar2_table(306) := '444953504C415927292E68746D6C286C5F76616C7565293B0A20202020202020207D0A2020202020207D0A20202020202069662821736368656D612E726561644F6E6C79207C7C205B435F415045585F5152434F44455D2E696E636C7564657328736368';
wwv_flow_imp.g_varchar2_table(307) := '656D612E617065782E6974656D7479706529297B0A2020202020202020696628704F7074696F6E732E617065785F76657273696F6E3E3D435F415045585F56455253494F4E5F32323032207C7C2028200A20202020202020202020202020215B435F4A53';
wwv_flow_imp.g_varchar2_table(308) := '4F4E5F464F524D41545F4441544554494D452C20435F4A534F4E5F464F524D41545F444154455D2E696E636C7564657328736368656D612E666F726D6174292026260A20202020202020202020202020215B435F415045585F53544152524154494E475D';
wwv_flow_imp.g_varchar2_table(309) := '2E696E636C7564657328736368656D612E617065782E6974656D74797065290A2020202020202020202020290A2020202020202020297B20202F2F206861636B20666F72206F6C64206A65742D646174612D7069636B65722C2073746172726174696E67';
wwv_flow_imp.g_varchar2_table(310) := '0A20202020202020202020617065782E6974656D28646174616974656D292E73657456616C7565286C5F76616C7565293B0A20202020202020207D0A2020202020207D0A20202020627265616B3B0A202020207D0A0A20202020696628736368656D612E';
wwv_flow_imp.g_varchar2_table(311) := '6966297B0A202020202020696628736368656D612E7468656E29207B20202F2F20636F6E646974696F6E616C20736368656D61207468656E0A20202020202020206C65742070726F70657274696573203D20736368656D612E7468656E2E70726F706572';
wwv_flow_imp.g_varchar2_table(312) := '746965737C7C7B7D3B0A20202020202020207365744F626A65637456616C75657328646174616974656D2C20646174616974656D2C207B747970653A20435F4A534F4E5F4F424A4543542C2070726F706572746965733A2070726F706572746965737D2C';
wwv_flow_imp.g_varchar2_table(313) := '20736368656D612E726561644F6E6C792C2064617461293B0A2020202020207D0A0A202020202020696628736368656D612E656C736529207B202F2F20636F6E646974696F6E616C20736368656D6120656C73650A20202020202020206C65742070726F';
wwv_flow_imp.g_varchar2_table(314) := '70657274696573203D20736368656D612E656C73652E70726F706572746965737C7C7B7D3B0A20202020202020207365744F626A65637456616C75657328646174616974656D2C20646174616974656D2C207B747970653A20435F4A534F4E5F4F424A45';
wwv_flow_imp.g_varchar2_table(315) := '43542C2070726F706572746965733A2070726F706572746965737D2C20736368656D612E726561644F6E6C792C2064617461293B0A2020202020207D0A202020207D0A0A0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567';
wwv_flow_imp.g_varchar2_table(316) := '696F6E2E7365744F626A65637456616C75657322293B0A20207D0A0A20202F2A0A2020202A20204275696C642072656375736976656C792061206C697374206F6620616C6C206974656D73207573656420696E2074686520736368656D612E6966207072';
wwv_flow_imp.g_varchar2_table(317) := '6F70657274790A20202A2F0A202066756E6374696F6E20676574436F6E646974696F6E616C4974656D7328636F6E646974696F6E297B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E676574436F6E64697469';
wwv_flow_imp.g_varchar2_table(318) := '6F6E616C4974656D73222C20636F6E646974696F6E293B0A202020206C6574206C5F6974656D73203D205B5D3B0A20202020666F7228636F6E7374205B6C5F6669656C642C206C5F636F6D705D206F66204F626A6563742E656E747269657328636F6E64';
wwv_flow_imp.g_varchar2_table(319) := '6974696F6E29297B0A202020202020737769746368286C5F6669656C64297B0A2020202020206361736520435F4A534F4E5F52455155495245443A0A202020202020202069662841727261792E69734172726179286C5F636F6D7029297B0A2020202020';
wwv_flow_imp.g_varchar2_table(320) := '20202020206C5F6974656D73203D206C5F636F6D703B0A20202020202020207D20656C7365207B0A20202020202020202020206C6F67536368656D614572726F722827636F6E646974696F6E616C20736368656D61272C206C5F6669656C642C20276D75';
wwv_flow_imp.g_varchar2_table(321) := '737420626520616E20617272617927293B200A20202020202020207D0A202020202020627265616B3B0A2020202020206361736520435F4A534F4E5F434F4E445F414C4C5F4F463A0A2020202020206361736520435F4A534F4E5F434F4E445F414E595F';
wwv_flow_imp.g_varchar2_table(322) := '4F463A0A2020202020202020666F7228636F6E7374206C5F736368656D61206F66206C5F636F6D70297B0A202020202020202020206C5F6974656D73203D206C5F6974656D732E636F6E63617428676574436F6E646974696F6E616C4974656D73286C5F';
wwv_flow_imp.g_varchar2_table(323) := '736368656D6129293B0A20202020202020207D0A202020202020627265616B3B0A2020202020206361736520435F4A534F4E5F434F4E445F4E4F543A0A2020202020206361736520435F4A534F4E5F50524F504552544945533A0A20202020202020206C';
wwv_flow_imp.g_varchar2_table(324) := '5F6974656D73203D206C5F6974656D732E636F6E63617428676574436F6E646974696F6E616C4974656D7328636F6E646974696F6E5B6C5F6669656C645D29293B0A202020202020627265616B3B0A20202020202064656661756C743A20202F2F206120';
wwv_flow_imp.g_varchar2_table(325) := '73696D7072652070726F7065727479207769746368203D3D206F7220494E0A20202020202020206C5F6974656D732E70757368286C5F6669656C64293B0A202020202020627265616B3B0A2020202020207D0A202020207D0A0A202020206C5F6974656D';
wwv_flow_imp.g_varchar2_table(326) := '73203D2041727261792E66726F6D286E657720536574286C5F6974656D7329293B202F2F2072656D6F7665206475706C6963617465730A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E676574436F6E64697469';
wwv_flow_imp.g_varchar2_table(327) := '6F6E616C4974656D73222C206C5F6974656D73293B0A2020202072657475726E286C5F6974656D73293B0A20207D0A20202F2A0A2020202A20617474616368207468652067656E657261746564206669656C6473206F6620746865204A534F4E2D736368';
wwv_flow_imp.g_varchar2_table(328) := '6D6120746F20415045580A20202A2F0A202066756E6374696F6E206174746163684F626A65637428646174616974656D2C20707265766974656D2C20736368656D612C20726561646F6E6C792C20646174612C206E65774974656D297B200A2020202061';
wwv_flow_imp.g_varchar2_table(329) := '7065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E6174746163684F626A656374222C20646174616974656D2C20707265766974656D2C20736368656D612C20726561646F6E6C792C20646174612C206E65774974656D293B0A20';
wwv_flow_imp.g_varchar2_table(330) := '202020736368656D61203D20736368656D617C7C7B7D3B0A20202020736368656D612E61706578203D20736368656D612E61706578207C7C207B7D3B0A0A2020202073776974636828736368656D612E74797065297B0A2020202063617365206E756C6C';
wwv_flow_imp.g_varchar2_table(331) := '3A0A202020206361736520756E646566696E65643A0A2020202020206966282127636F6E73742720696E20736368656D6129207B20202F2F20636F6E737420686173206E6F20747970650A20202020202020206C6F67536368656D614572726F7228276D';
wwv_flow_imp.g_varchar2_table(332) := '697373696E6720227479706522206174272C20646174616974656D293B0A2020202020207D0A20202020627265616B3B0A202020206361736520435F4A534F4E5F4F424A4543543A0A202020202020696628747970656F6620736368656D612E70726F70';
wwv_flow_imp.g_varchar2_table(333) := '657274696573203D3D20276F626A65637427297B0A202020202020202064617461203D2064617461207C7C7B7D3B0A2020202020202020666F72286C6574205B6C5F6E616D652C206C5F736368656D615D206F66204F626A6563742E656E747269657328';
wwv_flow_imp.g_varchar2_table(334) := '736368656D612E70726F7065727469657329297B0A20202020202020202020696628212827272B6C5F6E616D65292E7374617274735769746828275F2729297B2020202F2F2069676E6F72652070726F7065727469657320686176696E67206E616D6573';
wwv_flow_imp.g_varchar2_table(335) := '207374617274696E67207769746820225F220A2020202020202020202020206174746163684F626A6563742867656E4974656D6E616D6528646174616974656D2C206C5F6E616D65292C20646174616974656D2C206C5F736368656D612C20736368656D';
wwv_flow_imp.g_varchar2_table(336) := '612E726561644F6E6C792C20646174615B6C5F6E616D655D2C206E65774974656D293B0A202020202020202020207D0A20202020202020207D0A2020202020207D0A20202020627265616B3B0A202020206361736520435F4A534F4E5F41525241593A20';
wwv_flow_imp.g_varchar2_table(337) := '20200A202020202020617474616368417272617928646174616974656D2C20646174616974656D2C20736368656D612C20736368656D612E726561644F6E6C792C20646174612C206E65774974656D293B0A20202020627265616B3B0A20202020636173';
wwv_flow_imp.g_varchar2_table(338) := '6520276E756C6C273A20202F2F20656D707479206F626A65637420646F206E6F7468696E670A20202020627265616B3B0A202020206361736520435F4A534F4E5F535452494E473A0A20202020202069662821736368656D612E726561644F6E6C79297B';
wwv_flow_imp.g_varchar2_table(339) := '0A20202020202020207377697463682028736368656D612E666F726D6174297B0A20202020202020206361736520435F4A534F4E5F464F524D41545F444154453A0A20202020202020206361736520435F4A534F4E5F464F524D41545F4441544554494D';
wwv_flow_imp.g_varchar2_table(340) := '453A0A20202020202020202020696628704F7074696F6E732E617065785F76657273696F6E203C435F415045585F56455253494F4E5F32313032297B0A202020202020202020202020617065782E7769646765742E646174657069636B6572282723272B';
wwv_flow_imp.g_varchar2_table(341) := '20646174616974656D2C207B200A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022627574746F6E496D6167654F6E6C79223A66616C73652C0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(342) := '20202020202020202020202020202020202020202020202020202020202020202020202020202022627574746F6E54657874223A225C75303033437370616E20636C6173733D5C7530303232612D49636F6E2069636F6E2D63616C656E6461725C753030';
wwv_flow_imp.g_varchar2_table(343) := '32325C75303033455C75303033435C75303032467370616E5C75303033455C75303033437370616E20636C6173733D5C7530303232752D56697375616C6C7948696464656E5C75303032325C7530303345506F7075702043616C656E6461723A20437265';
wwv_flow_imp.g_varchar2_table(344) := '617465642041745C75303033437370616E5C7530303345222C0A20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202273686F7754696D65223A2020202020202020736368656D';
wwv_flow_imp.g_varchar2_table(345) := '612E666F726D61743D3D20435F4A534F4E5F464F524D41545F4441544554494D452C0A20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202274696D65323468223A2020202020';
wwv_flow_imp.g_varchar2_table(346) := '20202020747275652C0A20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202264656661756C7444617465223A20202020206E657720446174652864617461292C0A2020202020';
wwv_flow_imp.g_varchar2_table(347) := '2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202273686F774F6E223A22627574746F6E222C0A202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(348) := '20202020202020202020202020202273686F774F746865724D6F6E746873223A20747275652C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020226368616E67654D6F6E74';
wwv_flow_imp.g_varchar2_table(349) := '68223A2020202020747275652C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020226368616E676559656172223A202020202020747275652C0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(350) := '202020202020202020202020202020202020202020202020202020202020202020202020202020226D696E44617465223A20736368656D612E6D696E696D756D3F6E6577204461746528736368656D612E6D696E696D756D293A6E756C6C2C0A20202020';
wwv_flow_imp.g_varchar2_table(351) := '20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020226D617844617465223A20736368656D612E6D6178696D756D3F6E6577204461746528736368656D612E6D6178696D756D293A6E756C';
wwv_flow_imp.g_varchar2_table(352) := '6C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207D2C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(353) := '20736368656D612E617065782E666F726D61742C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020617065782E6C6F63616C652E6765744C616E67756167652829293B0A202020';
wwv_flow_imp.g_varchar2_table(354) := '202020202020202020617065782E6A5175657279282723272B20646174616974656D2C292E6E6578742827627574746F6E27292E616464436C6173732827612D427574746F6E20612D427574746F6E2D2D63616C656E64617227293B0A20202020202020';
wwv_flow_imp.g_varchar2_table(355) := '2020207D0A2020202020202020627265616B3B20200A20202020202020207D0A0A20202020202020207377697463682028736368656D612E617065782E6974656D74797065297B0A20202020202020206361736520435F415045585F524144494F3A0A20';
wwv_flow_imp.g_varchar2_table(356) := '202020202020202020617065782E7769646765742E636865636B626F78416E64526164696F282723272B20646174616974656D2C20435F415045585F524144494F293B0A2020202020202020627265616B3B0A20202020202020206361736520435F4150';
wwv_flow_imp.g_varchar2_table(357) := '45585F494D4147453A20202F2F20646973706C6179206F6E6C790A20202020202020206361736520435F415045585F5152434F44453A202F2F20646973706C6179206F6E6C790A2020202020202020627265616B3B0A202020202020202064656661756C';
wwv_flow_imp.g_varchar2_table(358) := '743A0A20202020202020202020617065782E6974656D2E63726561746528646174616974656D2C207B7D293B0A2020202020202020627265616B3B0A20202020202020207D0A2020202020207D0A20202020627265616B3B0A202020206361736520435F';
wwv_flow_imp.g_varchar2_table(359) := '4A534F4E5F424F4F4C45414E3A0A20202020202073776974636828736368656D612E617065782E6974656D74797065297B0A2020202020206361736520435F415045585F5357495443483A0A2020202020202020617065782E7769646765742E7965734E';
wwv_flow_imp.g_varchar2_table(360) := '6F28646174616974656D2C20275357495443485F434227293B200A202020202020627265616B3B0A2020202020206361736520435F415045585F524144494F3A0A2020202020202020617065782E7769646765742E636865636B626F78416E6452616469';
wwv_flow_imp.g_varchar2_table(361) := '6F282723272B20646174616974656D2C20435F415045585F524144494F293B0A202020202020627265616B3B0A2020202020206361736520435F415045585F53454C4543543A0A2020202020202020617065782E6974656D2E6372656174652864617461';
wwv_flow_imp.g_varchar2_table(362) := '6974656D2C207B7D293B200A202020202020627265616B3B0A20202020202064656661756C743A0A2020202020202020617065782E6974656D2E63726561746528646174616974656D2C207B7D293B200A202020202020627265616B3B0A202020202020';
wwv_flow_imp.g_varchar2_table(363) := '7D0A0A202020202020696628736368656D612E726561644F6E6C7929207B0A2020202020202020617065782E6974656D28646174616974656D292E64697361626C6528293B200A2020202020207D0A20202020627265616B3B0A20202020636173652043';
wwv_flow_imp.g_varchar2_table(364) := '5F4A534F4E5F4E554D4245523A0A202020206361736520435F4A534F4E5F494E54454745523A0A20202020202073776974636828736368656D612E617065782E6974656D74797065297B0A2020202020206361736520435F415045585F50435447524150';
wwv_flow_imp.g_varchar2_table(365) := '483A0A2020202020202020696628617065782E7769646765742E706374477261706829207B0A20202020202020202020617065782E7769646765742E706374477261706828646174616974656D293B0A20202020202020207D20656C7365207B0A2F2F20';
wwv_flow_imp.g_varchar2_table(366) := '202020202020202020617065782E6974656D2E63726561746528646174616974656D2C207B7D293B0A20202020202020207D0A202020202020627265616B3B0A2020202020206361736520435F415045585F53544152524154494E473A0A202020202020';
wwv_flow_imp.g_varchar2_table(367) := '2020617065782E7769646765742E73746172526174696E6728646174616974656D2C207B73686F77436C656172427574746F6E3A2066616C73652C206E756D53746172733A20736368656D612E6D6178696D756D7D293B200A202020202020627265616B';
wwv_flow_imp.g_varchar2_table(368) := '3B0A20202020202064656661756C743A202020202020200A202020202020202069662821736368656D612E726561644F6E6C79297B0A20202020202020202020617065782E6974656D2E63726561746528646174616974656D2C207B7D293B0A20202020';
wwv_flow_imp.g_varchar2_table(369) := '202020207D0A202020202020627265616B3B0A2020202020207D0A20202020627265616B3B0A2020202064656661756C743A0A20202020202069662821435F4A534F4E5F434F4E535420696E20736368656D6129207B20202F2F206120636F6E73742076';
wwv_flow_imp.g_varchar2_table(370) := '616C756520646F6573206E2774206E656564206120747970652C200A2020202020202020617065782E64656275672E6572726F7228276974656D207769746820756E646566696E65642074797065272C20646174616974656D2C20736368656D612E7479';
wwv_flow_imp.g_varchar2_table(371) := '7065293B0A2020202020207D0A20202020627265616B3B0A202020207D0A0A20202020696628736368656D612E6966297B0A2020202020206C6574206C5F6576616C203D206576616C45787072657373696F6E28736368656D612E69662C206461746129';
wwv_flow_imp.g_varchar2_table(372) := '3B0A202020202020696628736368656D612E7468656E29207B20202F2F20636F6E646974696F6E616C20736368656D61207468656E0A20202020202020206C65742070726F70657274696573203D20736368656D612E7468656E2E70726F706572746965';
wwv_flow_imp.g_varchar2_table(373) := '737C7C7B7D3B0A20202020202020206174746163684F626A65637428646174616974656D2C20646174616974656D2C207B747970653A20435F4A534F4E5F4F424A4543542C2070726F706572746965733A2070726F706572746965737D2C20736368656D';
wwv_flow_imp.g_varchar2_table(374) := '612E726561644F6E6C792C20646174612C206E65774974656D293B0A2020202020202020666F7228636F6E7374205B6C5F6E616D652C206C5F6974656D5D206F66204F626A6563742E656E74726965732870726F7065727469657329297B0A2020202020';
wwv_flow_imp.g_varchar2_table(375) := '202020202070726F70616761746553686F772867656E4974656D6E616D6528646174616974656D2C206C5F6E616D65292C206C5F6974656D2C206C5F6576616C3D3D3D74727565293B0A20202020202020207D0A2020202020207D0A0A20202020202069';
wwv_flow_imp.g_varchar2_table(376) := '6628736368656D612E656C736529207B202F2F20636F6E646974696F6E616C20736368656D6120656C73650A20202020202020206C65742070726F70657274696573203D20736368656D612E656C73652E70726F706572746965737C7C7B7D3B0A202020';
wwv_flow_imp.g_varchar2_table(377) := '20202020206174746163684F626A65637428646174616974656D2C20646174616974656D2C207B747970653A20435F4A534F4E5F4F424A4543542C2070726F706572746965733A2070726F706572746965737D2C20736368656D612E726561644F6E6C79';
wwv_flow_imp.g_varchar2_table(378) := '2C20646174612C206E65774974656D293B0A2020202020202020666F7228636F6E7374205B6C5F6E616D652C206C5F6974656D5D206F66204F626A6563742E656E74726965732870726F7065727469657329297B0A2020202020202020202070726F7061';
wwv_flow_imp.g_varchar2_table(379) := '6761746553686F772867656E4974656D6E616D6528646174616974656D2C206C5F6E616D65292C206C5F6974656D2C206C5F6576616C3D3D3D66616C7365293B0A20202020202020207D0A2020202020207D0A202020207D0A0A20202020696628736368';
wwv_flow_imp.g_varchar2_table(380) := '656D612E6966297B20202F2F20636F6E646974696F6E616C20736368656D612C20616464206576656E74206F6E206974656D730A2020202020206C6574206C5F646570656E644F6E203D20676574436F6E646974696F6E616C4974656D7328736368656D';
wwv_flow_imp.g_varchar2_table(381) := '612E6966293B0A2020202020202F2F204F626A6563742E6B65797328736368656D612E69662E70726F70657274696573293B0A202020202020666F72286C6574206C5F6E616D65206F66206C5F646570656E644F6E297B0A2020202020202020636F6E73';
wwv_flow_imp.g_varchar2_table(382) := '6F6C652E6C6F6728276F6E4368616E6765272C20646174616974656D2C206C5F6E616D65293B0A20202020202020202428222322202B2067656E4974656D6E616D6528646174616974656D2C206C5F6E616D6529292E6F6E28276368616E6765272C2066';
wwv_flow_imp.g_varchar2_table(383) := '756E6374696F6E28297B0A20202020202020202020636F6E736F6C652E6C6F672827636C69636B6564206F6E272C20646174616974656D2C206C5F6E616D65293B0A20202020202020202020696628736368656D612E6966297B20202F2F20636C69636B';
wwv_flow_imp.g_varchar2_table(384) := '206F6E206120636F6E646974696F6E616C206974656D0A2020202020202020202020206C6574206C5F6A736F6E203D206765744F626A65637456616C75657328646174616974656D2C2027272C20736368656D612C207B7D293B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(385) := '202020636F6E736F6C652E6C6F6728274556414C272C206C5F6A736F6E293B0A2020202020202020202020206C6574206C5F6576616C203D206576616C45787072657373696F6E28736368656D612E69662C206C5F6A736F6E293B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(386) := '20202020696628736368656D612E7468656E297B200A20202020202020202020202020206C65742070726F70657274696573203D20736368656D612E7468656E2E70726F706572746965737C7C7B7D3B0A2020202020202020202020202020666F722863';
wwv_flow_imp.g_varchar2_table(387) := '6F6E7374205B6C5F6E616D652C6C5F6974656D5D206F66204F626A6563742E656E74726965732870726F7065727469657329297B0A2020202020202020202020202020202070726F70616761746553686F772867656E4974656D6E616D65286461746169';
wwv_flow_imp.g_varchar2_table(388) := '74656D2C206C5F6E616D65292C206C5F6974656D2C206C5F6576616C3D3D74727565293B0A20202020202020202020202020207D0A2020202020202020202020207D0A0A202020202020202020202020696628736368656D612E656C7365297B200A2020';
wwv_flow_imp.g_varchar2_table(389) := '2020202020202020202020206C65742070726F70657274696573203D20736368656D612E656C73652E70726F706572746965737C7C7B7D3B0A2020202020202020202020202020666F7228636F6E7374205B6C5F6E616D652C206C5F6974656D5D206F66';
wwv_flow_imp.g_varchar2_table(390) := '204F626A6563742E656E74726965732870726F7065727469657329297B0A2020202020202020202020202020202070726F70616761746553686F772867656E4974656D6E616D6528646174616974656D2C206C5F6E616D65292C206C5F6974656D2C206C';
wwv_flow_imp.g_varchar2_table(391) := '5F6576616C3D3D66616C7365293B0A20202020202020202020202020207D0A2020202020202020202020207D2020202020202020202020202020202020202020202020202020202020200A202020202020202020207D0A20202020202020207D293B0A20';
wwv_flow_imp.g_varchar2_table(392) := '20202020207D0A202020207D0A2020202069662841727261792E6973417272617928736368656D612E646570656E64656E7452657175697265642929207B200A2020202020202020202020202F2F20746865206974656D2068617320646570656E64656E';
wwv_flow_imp.g_varchar2_table(393) := '74206974656D732C20736F206164642063616C6C6261636B206F6E2064617461206368616E67650A2020202020202020666F7228636F6E7374206974656D206F6620736368656D612E646570656E64656E74526571756972656429207B0A202020202020';
wwv_flow_imp.g_varchar2_table(394) := '202020206C6574206C5F6974656D203D2067656E4974656D6E616D6528707265766974656D2C206974656D293B0A202020202020202020206C6574206C5F76616C7565203D20646174613B0A2020202020202020202070726F7061676174655265717569';
wwv_flow_imp.g_varchar2_table(395) := '726564286C5F6974656D2C20736368656D615B6974656D5D2C206C5F76616C7565202626206C5F76616C75652E6C656E6774683E30293B0A20202020202020207D0A20202020202020202428222322202B20646174616974656D292E6F6E28276368616E';
wwv_flow_imp.g_varchar2_table(396) := '6765272C2066756E6374696F6E28297B0A20202020202020202020666F7228636F6E7374206974656D206F6620736368656D612E646570656E64656E74526571756972656429207B0A2020202020202020202020206C6574206C5F6974656D203D206765';
wwv_flow_imp.g_varchar2_table(397) := '6E4974656D6E616D6528707265766974656D2C206974656D290A2020202020202020202020206C6574206C5F76616C7565203D20242874686973292E76616C28293B0A202020202020202020202020636F6E736F6C652E7761726E2827646570656E6473';
wwv_flow_imp.g_varchar2_table(398) := '272C20736368656D615B6974656D5D2C206C5F76616C7565293B0A20202020202020202020202070726F7061676174655265717569726564286C5F6974656D2C20736368656D615B6974656D5D2C206C5F76616C7565202626206C5F76616C75652E6C65';
wwv_flow_imp.g_varchar2_table(399) := '6E6774683E30293B0A202020202020202020207D3B0A20202020202020207D293B0A202020207D0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E6174746163684F626A65637422293B0A20207D0A0A20202F2A';
wwv_flow_imp.g_varchar2_table(400) := '0A2020202A207265747269657665206461746120666F722055492D6669656C6473206F66204A534F4E2D736368656D6120616E64206275696C64204A534F4E2C206F6C644A736F6E20697320726571756972656420746F20737570706F7274206669656C';
wwv_flow_imp.g_varchar2_table(401) := '647769736520726561646F6E6C790A20202A2F0A202066756E6374696F6E206765744F626A65637456616C75657328646174616974656D2C206E616D652C20736368656D612C206F6C644A736F6E297B200A20202020617065782E64656275672E747261';
wwv_flow_imp.g_varchar2_table(402) := '636528223E3E6A736F6E526567696F6E2E6765744F626A65637456616C756573222C20646174616974656D2C206E616D652C20736368656D612C206F6C644A736F6E293B0A202020206C6574206C5F6A736F6E203D207B7D3B0A20202020736368656D61';
wwv_flow_imp.g_varchar2_table(403) := '2E61706578203D20736368656D612E617065787C7C7B7D3B0A20202020696628215B435F4A534F4E5F41525241592C20435F4A534F4E5F4F424A4543545D2E696E636C7564657328736368656D612E747970652920262620736368656D612E726561644F';
wwv_flow_imp.g_varchar2_table(404) := '6E6C79297B202F2F207768656E2073696D706C652061747472696275746520616E6420726561646F6E6C79206E6F206461746120636F756C6420626520726561642C206B65657020746865206F6C6420646174610A2020202020206C5F6A736F6E203D20';
wwv_flow_imp.g_varchar2_table(405) := '6F6C644A736F6E3B0A202020207D20656C7365207B0A2020202020206C5F6A736F6E203D20736368656D612E6164646974696F6E616C50726F706572746965733F6F6C644A736F6E3A7B7D3B20202F2F207768656E207468657265206172652061646469';
wwv_flow_imp.g_varchar2_table(406) := '74696F6E616C50726F706572746965732C206B6565702074686572652076616C7565730A20202020202073776974636828736368656D612E74797065297B0A2020202020206361736520435F4A534F4E5F4F424A4543543A0A2020202020202020696628';
wwv_flow_imp.g_varchar2_table(407) := '21286F6C644A736F6E20696E7374616E63656F66204F626A6563742929207B0A20202020202020202020617065782E64656275672E74726163652827536368656D61206D69736D617463683A272C20736368656D612E747970652C20274A534F4E3A272C';
wwv_flow_imp.g_varchar2_table(408) := '206F6C644A736F6E2C20276D75737420626520616E206F626A65637427293B0A202020202020202020206C5F6A736F6E203D207B7D3B0A202020202020202020206F6C644A736F6E203D7B7D3B0A20202020202020207D0A202020202020202069662873';
wwv_flow_imp.g_varchar2_table(409) := '6368656D612E70726F70657274696573297B0A20202020202020202020666F72286C6574205B6C5F6E616D652C206C5F736368656D615D206F66204F626A6563742E656E747269657328736368656D612E70726F7065727469657329297B0A2020202020';
wwv_flow_imp.g_varchar2_table(410) := '202020202020206C5F6A736F6E5B6C5F6E616D655D3D6765744F626A65637456616C7565732867656E4974656D6E616D6528646174616974656D2C206C5F6E616D65292C206C5F6E616D652C206C5F736368656D612C206F6C644A736F6E5B6C5F6E616D';
wwv_flow_imp.g_varchar2_table(411) := '655D293B0A202020202020202020207D0A20202020202020207D0A202020202020627265616B3B0A2020202020206361736520276E756C6C273A0A20202020202020206C5F6A736F6E203D206E756C6C3B0A202020202020627265616B3B0A2020202020';
wwv_flow_imp.g_varchar2_table(412) := '206361736520435F4A534F4E5F41525241593A207B200A20202020202020202020736368656D612E6974656D73203D20736368656D612E6974656D73207C7C207B7D3B0A202020202020202069662841727261792E6973417272617928736368656D612E';
wwv_flow_imp.g_varchar2_table(413) := '6974656D732E656E756D29297B20202F2F20617272617920666F72206D756C7469706C652073656C656374696F6E0A202020202020202020206C6574206C5F64617461203D20617065782E6974656D28646174616974656D292E67657456616C75652829';
wwv_flow_imp.g_varchar2_table(414) := '3B0A202020202020202020206C5F6A736F6E203D206974656D56616C7565324A736F6E28736368656D612C206C5F64617461293B0A202020202020202020206966285B435F4A534F4E5F494E54454745522C20435F4A534F4E5F4E554D4245525D2E696E';
wwv_flow_imp.g_varchar2_table(415) := '636C7564657328736368656D612E6974656D732E747970652929207B202F2F207768656E206E756D657269632C20636F6E7765727420737472696E6720746F206E756D657269630A2020202020202020202020206C5F6A736F6E203D206C5F6A736F6E2E';
wwv_flow_imp.g_varchar2_table(416) := '6D61702820783D3E204E756D626572287829293B0A202020202020202020207D0A20202020202020207D20656C7365207B0A202020202020202020206C657420693D303B0A202020202020202020206C6574206C5F666F756E64203D2066616C73653B0A';
wwv_flow_imp.g_varchar2_table(417) := '202020202020202020206C5F6A736F6E203D205B5D3B0A202020202020202020206F6C644A736F6E203D206F6C644A736F6E7C7C5B5D3B0A202020202020202020206C6574206C5F726F7773203D202428222322202B2070526567696F6E4964202B2027';
wwv_flow_imp.g_varchar2_table(418) := '205B69645E3D2227202B20646174616974656D202B20275F225D2E726F7727293B0A20202020202020202020666F7228636F6E7374206C5F726F77206F66206C5F726F7773297B0A202020202020202020202020636F6E7374206C5F6964203D2024286C';
wwv_flow_imp.g_varchar2_table(419) := '5F726F77295B305D2E69642E7265706C616365282F5F434F4E5441494E4552242F2C2727293B0A202020202020202020202020636F6E7374206C5F64617461203D206765744F626A65637456616C756573286C5F69642C2027272C20736368656D612E69';
wwv_flow_imp.g_varchar2_table(420) := '74656D732C207B7D293B0A2020202020202020202020206966282169734F626A656374456D707479286C5F6461746129297B20202F2F20646F6E27742061646420656D70747920726F77730A20202020202020202020202020206C5F6A736F6E2E707573';
wwv_flow_imp.g_varchar2_table(421) := '68286C5F64617461293B0A2020202020202020202020207D0A202020202020202020207D0A20202020202020202020696628736368656D612E726561644F6E6C7929207B20202F2F20617272617920697320726561644F6E6C790A202020202020202020';
wwv_flow_imp.g_varchar2_table(422) := '202020696628736368656D612E617065782E686173496E73657274203D3D2027626567696E2729207B20202F2F20696E73657274732061742074686520626567696E2C20736F206172726179203D206E6577202B206F6C640A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(423) := '2020206C5F6A736F6E203D206C5F6A736F6E2E636F6E636174286F6C644A736F6E293B0A2020202020202020202020207D20656C7365207B202F2F20696E73657274732061742074686520656E642C20736F206172726179203D206F6C64202B206E6577';
wwv_flow_imp.g_varchar2_table(424) := '0A20202020202020202020202020206C5F6A736F6E203D206F6C644A736F6E2E636F6E636174286C5F6A736F6E293B0A2020202020202020202020207D0A202020202020202020207D0A20202020202020207D0A2020202020207D0A2020202020206272';
wwv_flow_imp.g_varchar2_table(425) := '65616B3B0A2020202020206361736520435F4A534F4E5F535452494E473A0A2020202020206361736520435F4A534F4E5F494E54454745523A0A2020202020206361736520435F4A534F4E5F4E554D4245523A0A2020202020206361736520435F4A534F';
wwv_flow_imp.g_varchar2_table(426) := '4E5F424F4F4C45414E3A7B0A20202020202020206C6574206C5F64617461203D20617065782E6974656D28646174616974656D292E67657456616C756528293B0A20202020202020206C6574206C5F76616C7565203D206974656D56616C7565324A736F';
wwv_flow_imp.g_varchar2_table(427) := '6E28736368656D612C206C5F64617461293B0A20202020202020206966286C5F76616C7565213D6E756C6C297B0A202020202020202020206C5F6A736F6E203D206C5F76616C75653B0A20202020202020207D20656C7365207B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(428) := '206C5F6A736F6E203D206E756C6C3B0A20202020202020207D0A2F2F202D2D2D2D204841434B20202D2D2D2D2D2D2D0A20202020202020206966282827272B6E616D65292E7374617274735769746828275F2729297B0A202020202020202020206C5F6A';
wwv_flow_imp.g_varchar2_table(429) := '736F6E203D206F6C644A736F6E3B200A20202020202020207D0A2020202020207D0A202020202020627265616B3B0A20202020202064656661756C743A0A2020202020202020696628435F4A534F4E5F434F4E535420696E20736368656D6129207B2020';
wwv_flow_imp.g_varchar2_table(430) := '2F2F206120636F6E737420646F65736E277420686176652061206974656D20696E207468652055490A202020202020202020206C5F6A736F6E203D20736368656D612E636F6E73743B0A20202020202020207D0A202020202020627265616B3B0A202020';
wwv_flow_imp.g_varchar2_table(431) := '2020207D0A202020207D0A0A20202020696628736368656D612E6966297B20202F2F207468657265206973206120636F6E646974696F6E616C20736368656D610A20202020202020202F2F2067657474696E6720746865206461746120646570656E6473';
wwv_flow_imp.g_varchar2_table(432) := '206F6E20746865206576616C756174696F6E206F662074686520696620636C617573652E0A2020202020206C6574206C5F6576616C203D206576616C45787072657373696F6E28736368656D612E69662C206C5F6A736F6E293B0A202020202020696628';
wwv_flow_imp.g_varchar2_table(433) := '736368656D612E7468656E202626206C5F6576616C3D3D74727565297B0A20202020202020206C65742070726F70657274696573203D20736368656D612E7468656E2E70726F706572746965737C7C7B7D3B0A20202020202020206C6574206C5F6E6577';
wwv_flow_imp.g_varchar2_table(434) := '4A736F6E203D206765744F626A65637456616C75657328646174616974656D2C2027272C207B747970653A20435F4A534F4E5F4F424A4543542C2070726F706572746965733A2070726F706572746965737D2C206F6C644A736F6E293B0A202020202020';
wwv_flow_imp.g_varchar2_table(435) := '20202F2F20636F6E736F6C652E646972286C5F6E65774A736F6E293B0A20202020202020202F2F206D6572676520636F6E646974696F6E616C20696E70757420696E746F2063757272656E7420726573756C740A20202020202020206C5F6A736F6E203D';
wwv_flow_imp.g_varchar2_table(436) := '207B2E2E2E6C5F6A736F6E2C202E2E2E6C5F6E65774A736F6E7D3B0A2020202020207D0A0A202020202020696628736368656D612E656C7365202626206C5F6576616C3D3D66616C7365297B0A20202020202020206C65742070726F7065727469657320';
wwv_flow_imp.g_varchar2_table(437) := '3D20736368656D612E656C73652E70726F706572746965737C7C7B7D3B0A20202020202020206C6574206C5F6E65774A736F6E203D206765744F626A65637456616C75657328646174616974656D2C2027272C207B747970653A20435F4A534F4E5F4F42';
wwv_flow_imp.g_varchar2_table(438) := '4A4543542C2070726F706572746965733A2070726F706572746965737D2C206F6C644A736F6E293B0A20202020202020202F2F20636F6E736F6C652E646972286C5F6E65774A736F6E293B0A20202020202020202F2F206D6572676520636F6E64697469';
wwv_flow_imp.g_varchar2_table(439) := '6F6E616C20696E70757420696E746F2063757272656E7420726573756C740A20202020202020206C5F6A736F6E203D207B2E2E2E6C5F6A736F6E2C202E2E2E6C5F6E65774A736F6E7D3B0A2020202020207D0A0A202020207D0A20202020617065782E64';
wwv_flow_imp.g_varchar2_table(440) := '656275672E747261636528223C3C6A736F6E526567696F6E2E6765744F626A65637456616C756573222C206C5F6A736F6E293B0A2020202072657475726E286C5F6A736F6E293B0A20207D0A0A20202F2A0A2020202A2067656E65726174657320746865';
wwv_flow_imp.g_varchar2_table(441) := '206C6162656C2066726F6D20746865206F626A6563746E616D65206F722075736520616E206578697374696E67206C6162656C0A20202A2F0A202066756E6374696F6E2067656E65726174654C6162656C286E616D652C20736368656D61297B0A202020';
wwv_flow_imp.g_varchar2_table(442) := '206C6574206C5F6C6162656C3D27273B0A20202020696628736368656D612E6170657820262620435F415045585F4C4142454C20696E20736368656D612E61706578297B0A2020202020206C5F6C6162656C203D20736368656D612E617065782E6C6162';
wwv_flow_imp.g_varchar2_table(443) := '656C7C7C27273B0A202020207D20656C7365207B20200A2020202020202F2F20666F722064656661756C74206C6162656C207265706C616365202D5F206279206120626C616E6B20616E64207365742066697273742063686172206F6620656163682077';
wwv_flow_imp.g_varchar2_table(444) := '6F726420696E207570706572636173650A2020202020206C5F6C6162656C203D20206E616D652E746F4C6F7765724361736528290A2020202020202020202020202020202020202020202E73706C6974282F207C5C2D7C5F2F290A202020202020202020';
wwv_flow_imp.g_varchar2_table(445) := '2020202020202020202020202E6D617028287329203D3E20732E6368617241742830292E746F5570706572436173652829202B20732E737562737472696E67283129290A2020202020202020202020202020202020202020202E6A6F696E28272027293B';
wwv_flow_imp.g_varchar2_table(446) := '0A202020207D0A2020202072657475726E286C5F6C6162656C293B0A20207D0A0A20202F2A0A2020202A2070726F7061676174652074686520737562736368656D617320666F72202224726566220A20202A2F0A202066756E6374696F6E2070726F7061';
wwv_flow_imp.g_varchar2_table(447) := '676174655265667328736368656D61297B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E70726F70616761746552656673222C20736368656D61293B0A20202020696628736368656D6120262620747970656F';
wwv_flow_imp.g_varchar2_table(448) := '6620736368656D61203D3D20276F626A65637427297B0A202020202020696628736368656D615B435F4A534F4E5F5245465D20262620747970656F6620736368656D615B435F4A534F4E5F5245465D203D3D2027737472696E6727297B0A202020202020';
wwv_flow_imp.g_varchar2_table(449) := '20206C6574206A736F6E706174683D736368656D615B435F4A534F4E5F5245465D3B0A20202020202020206966286A736F6E706174682E737562737472696E6728302C3229203D3D27232F27297B0A202020202020202020206C65742067657456616C75';
wwv_flow_imp.g_varchar2_table(450) := '65203D20286F2C207029203D3E20702E7265706C6163652827232F272C2727292E73706C697428272F27292E7265647563652828722C206B29203D3E20725B6B5D2C206F293B0A202020202020202020207472797B0A2020202020202020202020206C65';
wwv_flow_imp.g_varchar2_table(451) := '74206E6577536368656D61203D2067657456616C756528704F7074696F6E732E736368656D612C206A736F6E70617468293B0A2020202020202020202020206966286E6577536368656D61297B0A20202020202020202020202020204F626A6563742E61';
wwv_flow_imp.g_varchar2_table(452) := '737369676E28736368656D612C206E6577536368656D61293B0A2020202020202020202020207D20656C7365207B0A20202020202020202020202020206C6F67536368656D614572726F722827756E6B6E6F776E272C20435F4A534F4E5F5245462C2073';
wwv_flow_imp.g_varchar2_table(453) := '6368656D615B435F4A534F4E5F5245465D290A2020202020202020202020207D0A20202020202020202020202064656C65746528736368656D615B435F4A534F4E5F5245465D293B0A202020202020202020207D2063617463682865297B0A2020202020';
wwv_flow_imp.g_varchar2_table(454) := '202020202020206C6F67536368656D614572726F722827746172676574206F662024726566206E6F7420666F756E643A20272C206A736F6E70617468293B0A202020202020202020207D0A20202020202020207D0A2020202020207D20656C7365207B0A';
wwv_flow_imp.g_varchar2_table(455) := '20202020202020202F2F2070726F63657373207265637572736976656C79200A202020202020202069662841727261792E6973417272617928736368656D6129297B200A20202020202020202020666F7228636F6E7374206920696E20736368656D6129';
wwv_flow_imp.g_varchar2_table(456) := '7B0A202020202020202020202020736368656D615B695D203D2070726F7061676174655265667328736368656D615B695D293B0A202020202020202020207D2020200A20202020202020207D20656C7365207B0A20202020202020202020666F7228636F';
wwv_flow_imp.g_varchar2_table(457) := '6E7374205B6C5F6B65792C206C5F736368656D615D206F66204F626A6563742E656E747269657328736368656D6129297B0A202020202020202020202020736368656D615B6C5F6B65795D203D2070726F70616761746552656673286C5F736368656D61';
wwv_flow_imp.g_varchar2_table(458) := '293B0A202020202020202020207D0A20202020202020207D0A2020202020207D0A202020207D0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E70726F70616761746552656673222C204A534F4E2E737472696E';
wwv_flow_imp.g_varchar2_table(459) := '6769667928736368656D6129293B0A2020202072657475726E20736368656D613B0A20207D0A20202F2A0A2020202A2070726F7061676174652076616C756573206F66204A534F4E2D736368656D612070726F7065727469657320726563757369766520';
wwv_flow_imp.g_varchar2_table(460) := '696E746F2070726F706572746965732F6974656D730A2020202A2053657420736F6D652070726F7065727469657320646570656E64696E67206F6E206F74686572730A2020202A20536574206D697373696E672070726F7065727469657320746F207265';
wwv_flow_imp.g_varchar2_table(461) := '61736F6E61626C652076616C75657320746F2061766F6964206572726F727320696E206C61746572207374616765730A20202A2F0A202066756E6374696F6E2070726F70616761746550726F7065727469657328736368656D612C206C6576656C2C2072';
wwv_flow_imp.g_varchar2_table(462) := '6561646F6E6C792C2077726974656F6E6C792C206164646974696F6E616C50726F706572746965732C20636F6E646974696F6E616C297B200A20202020736368656D61203D20736368656D61207C7C207B7D3B0A20202020736368656D612E6170657820';
wwv_flow_imp.g_varchar2_table(463) := '3D20736368656D612E617065787C7C7B7D3B0A20202020736368656D612E617065782E636F6E646974696F6E616C203D20636F6E646974696F6E616C3B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E70726F';
wwv_flow_imp.g_varchar2_table(464) := '70616761746550726F70657274696573222C206C6576656C2C20736368656D612C20726561646F6E6C792C2077726974656F6E6C792C206164646974696F6E616C50726F706572746965732C20636F6E646974696F6E616C293B0A202020206C6576656C';
wwv_flow_imp.g_varchar2_table(465) := '2B2B3B0A202020206966286C6576656C3E3230297B0A202020202020617065782E64656275672E6572726F72282770726F70616761746550726F7065727469657320726563757273696F6E272C206C6576656C2C2027746F206465657027290A20202020';
wwv_flow_imp.g_varchar2_table(466) := '202072657475726E3B0A202020207D0A0A20202020696628736368656D612E646570656E64656E74536368656D6173297B202F2F20636F6E7665727420646570656E64656E7420736368656D617320746F2049462F454C53452C20726571756972656420';
wwv_flow_imp.g_varchar2_table(467) := '70726F706572747920746F20646570656E64656E7452657175697265640A2020202020206C6574206C5F6B657973203D204F626A6563742E6B65797328736368656D612E646570656E64656E74536368656D6173293B0A2020202020206966286C5F6B65';
wwv_flow_imp.g_varchar2_table(468) := '79732E6C656E6774683D3D31297B0A2020202020202020736368656D612E6966203D207B202270726F70657274696573223A207B7D7D3B0A2020202020202020736368656D612E69662E70726F706572746965735B6C5F6B6579735B305D5D203D207B22';
wwv_flow_imp.g_varchar2_table(469) := '636F6E7374223A206E756C6C7D3B0A2020202020202020736368656D612E656C7365203D207B202270726F70657274696573223A207B7D7D3B0A2020202020202020736368656D612E656C73652E70726F70657274696573203D20736368656D612E6465';
wwv_flow_imp.g_varchar2_table(470) := '70656E64656E74536368656D61735B6C5F6B6579735B305D5D2E70726F706572746965733B0A2020202020202020636F6E7374206C5F7265717569726564203D20736368656D612E646570656E64656E74536368656D61735B6C5F6B6579735B305D5D2E';
wwv_flow_imp.g_varchar2_table(471) := '72657175697265643B0A202020202020202069662841727261792E69734172726179286C5F726571756972656429297B0A20202020202020202020736368656D612E646570656E64656E7452657175697265643D5B5D3B0A202020202020202020207363';
wwv_flow_imp.g_varchar2_table(472) := '68656D612E646570656E64656E7452657175697265645B6C5F6B6579735B305D5D203D206C5F72657175697265643B0A20202020202020207D0A202020202020202064656C65746520736368656D612E646570656E64656E74536368656D61733B0A2020';
wwv_flow_imp.g_varchar2_table(473) := '202020207D20656C7365207B0A2020202020202020617065782E64656275672E6572726F722827646570656E64656E74536368656D61733A206E756D626572206F66206F626A6563747320213D203127293B0A2020202020207D0A202020207D0A0A2020';
wwv_flow_imp.g_varchar2_table(474) := '2020202020202F2F2070726F7061676174652074686520646570656E64656E745265717569726564206469726563746C7920746F207468652070726F70657274696573200A20202020696628736368656D612E747970653D3D435F4A534F4E5F41525241';
wwv_flow_imp.g_varchar2_table(475) := '59297B200A202020202020696628736368656D612E6974656D73297B0A2020202020202020206966284F626A6563742E6B65797328736368656D612E6974656D73292E6C656E6774683D3D30297B20202F2F206974656D732073686F756C642068617665';
wwv_flow_imp.g_varchar2_table(476) := '206174206C65617374206F6E6520656E7472790A2020202020202020202020617065782E64656275672E7761726E282761727261792073686F756C642068617665206174206C656173742031206974656D7327290A2020202020202020207D0A20202020';
wwv_flow_imp.g_varchar2_table(477) := '2020207D20656C7365207B0A20202020202020206C6F67536368656D614572726F7228276D697373696E6720226974656D732220666F72202274797065223A2022617272617922272920200A2020202020202020736368656D612E6974656D733D7B7D3B';
wwv_flow_imp.g_varchar2_table(478) := '0A2020202020207D0A202020207D0A0A20202020202020202F2F2070726F7061676174652074686520646570656E64656E745265717569726564206469726563746C7920746F207468652070726F70657274696573200A20202020696628736368656D61';
wwv_flow_imp.g_varchar2_table(479) := '2E747970653D3D435F4A534F4E5F4F424A454354297B200A202020202020696628736368656D612E70726F70657274696573297B0A20202020202020206966284F626A6563742E6B65797328736368656D612E70726F70657274696573292E6C656E6774';
wwv_flow_imp.g_varchar2_table(480) := '683D3D30297B20202F2F206974656D732073686F756C642068617665206174206C65617374206F6E6520656E7472790A20202020202020202020617065782E64656275672E7761726E28276F626A6563742073686F756C642068617665206174206C6561';
wwv_flow_imp.g_varchar2_table(481) := '737420312070726F706572747927290A20202020202020207D0A2020202020207D20656C7365207B0A20202020202020206C6F67536368656D614572726F7228276D697373696E67202270726F706572746965732220666F72202274797065223A20226F';
wwv_flow_imp.g_varchar2_table(482) := '626A6563742227293B0A2020202020202020736368656D612E70726F706572746965733D7B7D3B200A2020202020207D0A202020202020736368656D612E6164646974696F6E616C50726F70657274696573203D20626F6F6C65616E49664E6F74536574';
wwv_flow_imp.g_varchar2_table(483) := '28736368656D612E6164646974696F6E616C50726F706572746965732C206164646974696F6E616C50726F70657274696573293B0A202020202020696628736368656D612E646570656E64656E745265717569726564297B0A2020202020202020666F72';
wwv_flow_imp.g_varchar2_table(484) := '286C6574205B6C5F6E616D652C206C5F736368656D615D206F66204F626A6563742E656E747269657328736368656D612E646570656E64656E74526571756972656429297B0A202020202020202020207472797B0A202020202020202020202020736368';
wwv_flow_imp.g_varchar2_table(485) := '656D612E70726F706572746965735B6C5F6E616D655D2E646570656E64656E745265717569726564203D206C5F736368656D613B0A202020202020202020207D63617463682865297B0A202020202020202020202020617065782E64656275672E657272';
wwv_flow_imp.g_varchar2_table(486) := '6F722827646570656E64656E745265717569726564206E6F7420666F756E643A20272C206C5F6E616D652C2065293B2020202020202020202020200A202020202020202020207D0A20202020202020207D0A2020202020207D20200A202020207D0A0A0A';
wwv_flow_imp.g_varchar2_table(487) := '202020202F2F2063616C63206D696E696D756D2F6D6178696D756D0A20202020696628736368656D612E6D696E696D756D297B0A202020202020736368656D612E6D696E696D756D203D20676574436F6E7374616E7428736368656D612E666F726D6174';
wwv_flow_imp.g_varchar2_table(488) := '2C20736368656D612E6D696E696D756D2C2066616C7365293B0A202020207D0A20202020696628736368656D612E6D6178696D756D297B0A202020202020736368656D612E6D6178696D756D203D20676574436F6E7374616E7428736368656D612E666F';
wwv_flow_imp.g_varchar2_table(489) := '726D61742C20736368656D612E6D6178696D756D2C2066616C7365293B0A202020207D0A202020200A20202020696628736368656D612E7061747465726E20262621736368656D612E7479706529207B20202F2F207768656E207061747465726E206973';
wwv_flow_imp.g_varchar2_table(490) := '207365742074797065207468652064656661756C74206973202274797065223A2022737472696E67220A202020202020736368656D612E74797065203D20435F4A534F4E5F535452494E473B0A202020207D0A0A202020202F2F2068616E646C65207370';
wwv_flow_imp.g_varchar2_table(491) := '656369616C20666F726D617473206173207061747465726E0A2020202073776974636828736368656D612E666F726D6174297B0A202020206361736520435F4A534F4E5F464F524D41545F495056343A2020202F2F206578616D706C65733A203132332E';
wwv_flow_imp.g_varchar2_table(492) := '3132332E3132332E313233206F72203132332E3132332E3132332E3132332F33320A202020202020736368656D612E6D61784C656E677468203D2031383B0A202020202020736368656D612E7061747465726E2020203D2022285C5C647B312C337D5C5C';
wwv_flow_imp.g_varchar2_table(493) := '2E297B337D5C5C647B312C337D282F5C5C647B312C327D293F223B0A20202020627265616B3B0A202020206361736520435F4A534F4E5F464F524D41545F495056363A0A202020202020736368656D612E6D61784C656E677468203D2034333B0A202020';
wwv_flow_imp.g_varchar2_table(494) := '202020736368656D612E7061747465726E2020203D2022285B302D39612D66412D465D7B312C347D3A297B377D5B302D39612D66412D465D7B312C347D282F5C5C647B312C337D293F223B0A20202020627265616B3B0A202020206361736520435F4A53';
wwv_flow_imp.g_varchar2_table(495) := '4F4E5F464F524D41545F555549443A2020202F2F206578616D706C653A2031323334353637382D616263642D616263642D616263642D3132333435363738393061620A202020202020736368656D612E6D61784C656E677468203D2033363B0A20202020';
wwv_flow_imp.g_varchar2_table(496) := '2020736368656D612E7061747465726E2020203D20225B302D39612D66412D465D7B387D2D285B302D39612D66412D465D7B347D2D297B337D5B302D39612D66412D465D7B31327D223B0A20202020627265616B3B0A202020207D0A0A202020202F2F20';
wwv_flow_imp.g_varchar2_table(497) := '4F7261636C6520737065636966696320534348454D4120657874656E73696F6E730A20202020696628736368656D612E70726F7065727469657320262620736368656D612E70726F706572746965732E64625072696D6172794B6579297B20202F2F2072';
wwv_flow_imp.g_varchar2_table(498) := '656D6F76652064625072696D6172794B65792C206974277320612070726F706572747920616E6420776F756C6420736F2062652068616E646C656420617320656E20696E707574206974656D0A20202020202064656C65746520736368656D612E70726F';
wwv_flow_imp.g_varchar2_table(499) := '706572746965732E64625072696D6172794B65793B0A202020207D0A0A20202020696628736368656D612E657874656E6465645479706529207B2020202F2F204F7261636C652073706563696669632064617461747970650A2020202020206966284172';
wwv_flow_imp.g_varchar2_table(500) := '7261792E6973417272617928736368656D612E657874656E6465645479706529297B202020202F2F20666F72206E756C6C61626C65202070726F70657274696573206974206973205B2274797065222C206E756C6C5D0A20202020202020206966287363';
wwv_flow_imp.g_varchar2_table(501) := '68656D612E657874656E646564547970652E696E636C75646573286E756C6C29297B20202F2F200A202020202020202020202F2F20636F6E736F6C652E6C6F67282752656D6F7665206E756C6C2066726F6D272C20736368656D612E657874656E646564';
wwv_flow_imp.g_varchar2_table(502) := '54797065293B0A20202020202020207D0A2020202020202020696628736368656D612E657874656E646564547970652E6C656E677468203D3D2031297B0A20202020202020202020736368656D612E657874656E64656454797065203D20736368656D61';
wwv_flow_imp.g_varchar2_table(503) := '2E657874656E646564547970655B305D3B0A20202020202020207D0A2020202020207D0A2020202020207377697463682028736368656D612E657874656E6465645479706529207B2020202F2F204F7261636C652D7370636966696320657874656E7369';
wwv_flow_imp.g_varchar2_table(504) := '6F6E2C20636F6E7665727420696E746F206A736F6E2D736368656D61207265706573656E746174696F6E0A2020202020206361736520435F4A534F4E5F464F524D41545F444154453A0A2020202020202020736368656D612E74797065203D20435F4A53';
wwv_flow_imp.g_varchar2_table(505) := '4F4E5F535452494E473B0A2020202020202020736368656D612E666F726D61743D20736368656D612E666F726D61747C7C20435F4A534F4E5F464F524D41545F444154453B202F2F20646F206E6F74206F7665727772697465206578697374696E672066';
wwv_flow_imp.g_varchar2_table(506) := '6F726D6174730A202020202020627265616B3B0A2020202020206361736520435F4F5241434C455F54494D455354414D503A0A2020202020202020736368656D612E74797065203D20435F4A534F4E5F535452494E473B0A202020202020202073636865';
wwv_flow_imp.g_varchar2_table(507) := '6D612E666F726D61743D736368656D612E666F726D61747C7C20435F4A534F4E5F464F524D41545F4441544554494D453B0A202020202020627265616B3B0A2020202020206361736520435F4A534F4E5F535452494E473A0A2020202020206361736520';
wwv_flow_imp.g_varchar2_table(508) := '435F4A534F4E5F424F4F4C45414E3A0A2020202020202020736368656D612E74797065203D20736368656D612E657874656E646564547970653B0A202020202020627265616B3B0A2020202020206361736520435F4A534F4E5F494E54454745523A0A20';
wwv_flow_imp.g_varchar2_table(509) := '20202020206361736520435F4A534F4E5F4E554D4245523A0A2020202020202020696628736368656D612E73716C5363616C653D3D30297B20202F2F206E6F20646967697420626568696E6420222E222C20736F20696E74656765720A20202020202020';
wwv_flow_imp.g_varchar2_table(510) := '202020736368656D612E74797065203D20435F4A534F4E5F494E54454745523B0A20202020202020207D20656C7365207B0A20202020202020202020736368656D612E74797065203D20736368656D612E657874656E646564547970653B0A2020202020';
wwv_flow_imp.g_varchar2_table(511) := '2020207D0A202020202020627265616B3B0A20202020202064656661756C743A0A2020202020202020617065782E64656275672E6572726F722827536368656D6120636F6E7461696E7320756E737570706F727420657874656E64656454797065202573';
wwv_flow_imp.g_varchar2_table(512) := '272C20736368656D612E657874656E64656454797065293B0A2020202020207D0A202020207D0A0A20202020736368656D612E617065782E726561646F6E6C79203D20626F6F6C65616E49664E6F7453657428736368656D612E617065782E726561646F';
wwv_flow_imp.g_varchar2_table(513) := '6E6C792C20726561646F6E6C79293B0A20202020736368656D612E726561644F6E6C79203D20626F6F6C65616E49664E6F7453657428736368656D612E726561644F6E6C792C20736368656D612E617065782E726561646F6E6C79293B0A202020207363';
wwv_flow_imp.g_varchar2_table(514) := '68656D612E77726974654F6E6C79203D20626F6F6C65616E49664E6F7453657428736368656D612E77726974654F6E6C792C2077726974656F6E6C79293B0A0A2020202073776974636828736368656D612E74797065297B0A2020202020206361736520';
wwv_flow_imp.g_varchar2_table(515) := '435F4A534F4E5F4E554D4245523A0A2020202020202020736368656D612E617065782E666F726D6174203D2028736368656D612E617065782E666F726D61743D3D435F415045585F43555252454E4359293F27464D4C3939394739393947393939473939';
wwv_flow_imp.g_varchar2_table(516) := '3947393939443939273A28736368656D612E617065782E666F726D6174293B0A202020202020627265616B3B0A2020202020206361736520435F4A534F4E5F494E54454745523A0A2020202020202020736368656D612E617065782E666F726D6174203D';
wwv_flow_imp.g_varchar2_table(517) := '2028736368656D612E617065782E666F726D61743D3D435F415045585F43555252454E4359293F27464D4C39393947393939473939394739393947393939273A28736368656D612E617065782E666F726D61747C7C273939393939393939393939393939';
wwv_flow_imp.g_varchar2_table(518) := '39393939393939393927293B0A2020202020202020696628736368656D612E617065782E6974656D747970653D3D435F415045585F5043544752415048297B0A20202020202020202020736368656D612E726561644F6E6C79203D20747275653B0A2020';
wwv_flow_imp.g_varchar2_table(519) := '2020202020207D0A202020202020627265616B3B0A2020202020206361736520435F4A534F4E5F535452494E473A0A20202020202020206966285B435F415045585F5152434F44452C20435F415045585F494D4147455D2E696E636C7564657328736368';
wwv_flow_imp.g_varchar2_table(520) := '656D612E617065782E6974656D7479706529207C7C20736368656D612E636F6E74656E74456E636F64696E67203D3D20435F4A534F4E5F424153453634297B0A20202020202020202020736368656D612E726561644F6E6C792020203D20747275653B20';
wwv_flow_imp.g_varchar2_table(521) := '202F2F2063616E206E6F74206265206368616E6765640A20202020202020202020736368656D612E69735265717569726564203D2066616C73653B202F2F206E6F742072657175697265640A20202020202020207D3B0A0A202020202020202069662873';
wwv_flow_imp.g_varchar2_table(522) := '6368656D612E636F6E74656E74456E636F64696E67297B2020202F2F20656E636F64656420737472696E670A20202020202020202020696628736368656D612E636F6E74656E74456E636F64696E673D3D20435F4A534F4E5F424153453634297B0A2020';
wwv_flow_imp.g_varchar2_table(523) := '20202020202020202020736368656D612E617065782E696D6167653D736368656D612E636F6E74656E744D65646961547970653B0A202020202020202020202020736368656D612E617065782E6974656D74797065203D20435F415045585F494D414745';
wwv_flow_imp.g_varchar2_table(524) := '3B0A202020202020202020202020696628215B435F4A534F4E5F494D4147455F4749462C20435F4A534F4E5F494D4147455F4A50472C20435F4A534F4E5F494D4147455F504E475D2E696E636C7564657328736368656D612E636F6E74656E744D656469';
wwv_flow_imp.g_varchar2_table(525) := '615479706529297B20202F2F0A2020202020202020202020202020617065782E64656275672E6572726F722827756E6B6E6F776E20737472696E6720636F6E74656E744D65646961547970652022257322272C20736368656D612E636F6E74656E744D65';
wwv_flow_imp.g_varchar2_table(526) := '64696154797065293B0A20202020202020202020202020202F2F2064656661756C74206973204A50470A2020202020202020202020202020736368656D612E636F6E74656E744D6564696154797065203D20435F4A534F4E5F494D4147455F4A50473B0A';
wwv_flow_imp.g_varchar2_table(527) := '2020202020202020202020207D0A202020202020202020207D20656C7365207B0A202020202020202020202020617065782E64656275672E6572726F722827756E6B6E6F776E20737472696E6720656E636F64696E672022257322272C20736368656D61';
wwv_flow_imp.g_varchar2_table(528) := '2E636F6E74656E74456E636F64696E67293B20200A202020202020202020202020736368656D612E636F6E74656E74456E636F64696E67203D20435F4A534F4E5F4241534536343B0A202020202020202020207D0A20202020202020207D20656C736520';
wwv_flow_imp.g_varchar2_table(529) := '7B20202F2F20706C61696E20737472696E672C20636865636B20666F726D6174730A2020202020202020202073776974636828736368656D612E666F726D6174297B0A20202020202020202020206361736520435F4A534F4E5F464F524D41545F444154';
wwv_flow_imp.g_varchar2_table(530) := '453A0A20202020202020202020202020736368656D612E617065782E666F726D6174203D20736368656D612E617065782E666F726D6174207C7C206744617465466F726D61743B0A2020202020202020202020627265616B3B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(531) := '206361736520435F4A534F4E5F464F524D41545F4441544554494D453A0A20202020202020202020202020736368656D612E617065782E666F726D6174203D20736368656D612E617065782E666F726D6174207C7C20286744617465466F726D6174202B';
wwv_flow_imp.g_varchar2_table(532) := '20272027202B206754696D65466F726D6174293B0A2020202020202020202020627265616B3B0A20202020202020202020206361736520435F4A534F4E5F464F524D41545F54494D453A0A20202020202020202020202020736368656D612E617065782E';
wwv_flow_imp.g_varchar2_table(533) := '666F726D6174203D206754696D65466F726D61743B0A2020202020202020202020627265616B3B0A202020202020202020202064656661756C743A0A20202020202020202020202020696628736368656D612E6D61784C656E6774682026262073636865';
wwv_flow_imp.g_varchar2_table(534) := '6D612E6D61784C656E6774683E704F7074696F6E732E7465787461726561776964746820262620736368656D612E617065782E6974656D7479706520213D435F415045585F5249434854455854297B0A202020202020202020202020202020736368656D';
wwv_flow_imp.g_varchar2_table(535) := '612E617065782E6974656D747970653D435F415045585F54455854415245413B20200A202020202020202020202020207D0A2020202020202020202020627265616B3B2020200A202020202020202020207D0A20202020202020207D0A20202020202062';
wwv_flow_imp.g_varchar2_table(536) := '7265616B3B202020200A202020207D0A0A20202020202020202F2F2073657420617065782E666F726D6174730A20202020696628704F7074696F6E732E617065785F76657273696F6E203C435F415045585F56455253494F4E5F32343031297B202F2F20';
wwv_flow_imp.g_varchar2_table(537) := '636865636B20666F72206E6577206974656D7479706520696E206F6C642072656C65617365732C2072656D6F7665207468656D20616E64206C6F67206572726F720A2020202020206966285B435F415045585F53454C4543544F4E452C20435F41504558';
wwv_flow_imp.g_varchar2_table(538) := '5F53454C4543544D414E595D2E696E636C7564657328736368656D612E617065782E6974656D7479706529297B0A20202020202020206C6F67536368656D614572726F7228276974656D74797065206E6F7420737570706F7274656420696E2041504558';
wwv_flow_imp.g_varchar2_table(539) := '2D76657273696F6E272C20736368656D612E617065782E6974656D747970652C20704F7074696F6E732E617065785F76657273696F6E293B0A202020202020202064656C65746520736368656D612E617065782E6974656D747970653B0A202020202020';
wwv_flow_imp.g_varchar2_table(540) := '7D0A202020207D0A0A20202020202020202F2F2073657420617065782E666F726D6174730A20202020696628704F7074696F6E732E617065785F76657273696F6E203C435F415045585F56455253494F4E5F32333032297B202F2F20636865636B20666F';
wwv_flow_imp.g_varchar2_table(541) := '72206E6577206974656D7479706520696E206F6C642072656C65617365732C2072656D6F7665207468656D20616E64206C6F67206572726F720A2020202020206966285B435F415045585F5152434F44452C20435F415045585F52494348544558542C20';
wwv_flow_imp.g_varchar2_table(542) := '435F415045585F434F4D424F2C205D2E696E636C7564657328736368656D612E617065782E6974656D7479706529297B0A20202020202020206C6F67536368656D614572726F7228276974656D74797065206E6F7420737570706F7274656420696E2041';
wwv_flow_imp.g_varchar2_table(543) := '5045582D76657273696F6E272C20736368656D612E617065782E6974656D747970652C20704F7074696F6E732E617065785F76657273696F6E293B0A2020202020202020696628736368656D612E617065782E6974656D74797065203D3D20435F415045';
wwv_flow_imp.g_varchar2_table(544) := '585F5249434854455854297B20202F2F207573652074657874617265610A20202020202020202020736368656D612E617065782E6974656D74797065203D20435F415045585F54455854415245413B0A20202020202020207D20656C7365207B0A202020';
wwv_flow_imp.g_varchar2_table(545) := '2020202020202064656C65746520736368656D612E617065782E6974656D747970653B0A20202020202020207D0A2020202020207D0A202020207D0A0A2020202020202F2F2064656661756C742066C3BC722022656E756D220A20202020696628736368';
wwv_flow_imp.g_varchar2_table(546) := '656D612E656E756D297B0A202020202020736368656D612E617065782E6974656D74797065203D20736368656D612E617065782E6974656D747970657C7C20435F415045585F53454C4543543B0A202020207D202020200A2020202020200A2020202020';
wwv_flow_imp.g_varchar2_table(547) := '2020202F2F2070726F70616761746520726571756972656420746F20656163682070726F706572746965730A2020202069662841727261792E6973417272617928736368656D612E726571756972656429297B0A202020202020666F72286C6574206C5F';
wwv_flow_imp.g_varchar2_table(548) := '736368656D61206F6620736368656D612E7265717569726564297B0A2020202020202020696628736368656D612E70726F7065727469657320262620736368656D612E70726F706572746965735B6C5F736368656D615D297B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(549) := '736368656D612E70726F706572746965735B6C5F736368656D615D2E697352657175697265643D747275653B0A20202020202020207D0A2020202020202020696628736368656D612E6974656D7320262620736368656D612E6974656D735B6C5F736368';
wwv_flow_imp.g_varchar2_table(550) := '656D615D297B0A20202020202020202020736368656D612E6974656D735B6C5F736368656D615D2E697352657175697265643D747275653B0A20202020202020207D0A2020202020207D0A202020207D0A0A20202020696628736368656D612E7468656E';
wwv_flow_imp.g_varchar2_table(551) := '297B0A20202020202070726F70616761746550726F70657274696573287B747970653A20435F4A534F4E5F4F424A4543542C2072657175697265643A20736368656D612E7468656E2E72657175697265647C7C5B5D2C2070726F706572746965733A2073';
wwv_flow_imp.g_varchar2_table(552) := '6368656D612E7468656E2E70726F706572746965737D2C206C6576656C2C20736368656D612E726561644F6E6C792C20736368656D612E77726974654F6E6C792C20736368656D612E6164646974696F6E616C50726F706572746965732C207472756529';
wwv_flow_imp.g_varchar2_table(553) := '3B0A202020207D0A0A20202020696628736368656D612E656C7365297B0A20202020202070726F70616761746550726F70657274696573287B747970653A20435F4A534F4E5F4F424A4543542C2072657175697265643A20736368656D612E656C73652E';
wwv_flow_imp.g_varchar2_table(554) := '72657175697265647C7C5B5D2C2070726F706572746965733A20736368656D612E656C73652E70726F706572746965737D2C206C6576656C2C20736368656D612E726561644F6E6C792C20736368656D612E77726974654F6E6C792C20736368656D612E';
wwv_flow_imp.g_varchar2_table(555) := '6164646974696F6E616C50726F706572746965732C2074727565293B0A202020207D0A0A20202020666F72286C6574205B6C5F6E616D652C206C5F736368656D615D206F66204F626A6563742E656E747269657328736368656D612E70726F7065727469';
wwv_flow_imp.g_varchar2_table(556) := '65737C7C7B7D29297B0A20202020202070726F70616761746550726F70657274696573286C5F736368656D612C206C6576656C2C20736368656D612E726561644F6E6C792C20736368656D612E77726974654F6E6C792C20736368656D612E6164646974';
wwv_flow_imp.g_varchar2_table(557) := '696F6E616C50726F706572746965732C2066616C7365293B0A202020207D0A0A20202020696628736368656D612E6974656D73297B20202F2F20746865726520697320616E206974656D20646566696E6974696F6E2C2070726F6365737320746869730A';
wwv_flow_imp.g_varchar2_table(558) := '202020202020736368656D612E617065782E68617344656C657465203D20626F6F6C65616E49664E6F7453657428736368656D612E617065782E68617344656C6574652C2021736368656D612E726561644F6E6C79293B0A202020202020736368656D61';
wwv_flow_imp.g_varchar2_table(559) := '2E6974656D732E6164646974696F6E616C50726F70657274696573203D20626F6F6C65616E49664E6F7453657428736368656D612E6974656D732E6164646974696F6E616C50726F706572746965732C206164646974696F6E616C50726F706572746965';
wwv_flow_imp.g_varchar2_table(560) := '73293B0A20202020202070726F70616761746550726F7065727469657328736368656D612E6974656D732C206C6576656C2C20736368656D612E726561644F6E6C792C20736368656D612E77726974654F6E6C792C20736368656D612E6164646974696F';
wwv_flow_imp.g_varchar2_table(561) := '6E616C50726F706572746965732C2066616C7365293B0A202020207D0A0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E70726F70616761746550726F70657274696573222C206C6576656C293B0A20207D0A0A';
wwv_flow_imp.g_varchar2_table(562) := '20202F2A0A2020202A2067656E6572617465207468652055492048544D4C20666F722032332E3220436F6D626F626F78200A2020202A2072657475726E73207B6974656D733A20302C2077726170706572747970653A2022787878222C2068746D6C3A20';
wwv_flow_imp.g_varchar2_table(563) := '22787878227D0A20202A2F0A202066756E6374696F6E2067656E6572617465466F72436F6D626F28736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C206974656D747970652C20736368656D6141706578297B';
wwv_flow_imp.g_varchar2_table(564) := '0A202020206C6574206C5F67656E657261746564203D207B6974656D733A20302C2077726170706572747970653A206E756C6C2C2068746D6C3A2027277D3B0A202020206C6574206C5F76616C756573203D2028646174617C7C5B5D292E6A6F696E2843';
wwv_flow_imp.g_varchar2_table(565) := '5F56414C5545534550415241544F52293B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E67656E6572617465466F72436F6D626F222C20736368656D612C20646174612C207072656669782C206E616D652C20';
wwv_flow_imp.g_varchar2_table(566) := '7374617274656E642C206974656D74797065293B0A202020206C5F67656E657261746564203D207B0A20202020202020206974656D733A20202020202020312C0A202020202020202077726170706572747970653A2027617065782D6974656D2D777261';
wwv_flow_imp.g_varchar2_table(567) := '707065722D2D636F6D626F626F7820617065782D6974656D2D777261707065722D2D636F6D626F626F782D6D616E79272C0A202020202020202068746D6C3A2020202020202020617065782E7574696C2E6170706C7954656D706C61746528600A3C612D';
wwv_flow_imp.g_varchar2_table(568) := '636F6D626F626F782069643D222349442322206E616D653D22234944232220235245515549524544232023504C414345484F4C444552232076616C75653D222356414C5545532322206D756C74692D76616C75653D2274727565222072657475726E2D64';
wwv_flow_imp.g_varchar2_table(569) := '6973706C61793D2266616C7365222076616C75652D736570617261746F72733D222356414C5545534550415241544F522322206D61782D726573756C74733D223722206D696E2D636861726163746572732D7365617263683D223022206D617463682D74';
wwv_flow_imp.g_varchar2_table(570) := '7970653D22636F6E7461696E7322206D61786C656E6774683D2231303022206D756C74692D73656C6563743D22747275652220706172656E74732D72657175697265643D2274727565223E0A20203C64697620636C6173733D22617065782D6974656D2D';
wwv_flow_imp.g_varchar2_table(571) := '636F6D626F73656C656374223E0A202020203C756C20636C6173733D22612D436869707320612D43686970732D2D6170706C69656420612D43686970732D2D777261702220726F6C653D2270726573656E746174696F6E223E0A602C0A20202020202020';
wwv_flow_imp.g_varchar2_table(572) := '20202020202020202020202020202020202020202020202020202020202020202020202020202020207B0A20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020706C616365';
wwv_flow_imp.g_varchar2_table(573) := '686F6C646572733A207B0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202256414C554553223A206C5F76616C7565732C0A202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(574) := '2020202020202020202020202020202020202020202020202020202020202020202020202020202256414C5545534550415241544F52223A20435F56414C5545534550415241544F520A2020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(575) := '202020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207D290A202020207D3B0A0A202020206C5F67656E6572617465';
wwv_flow_imp.g_varchar2_table(576) := '642E68746D6C202B3D20617065782E7574696C2E6170706C7954656D706C61746528600A2020202020203C6C6920636C6173733D22612D4368697020612D436869702D2D696E7075742069732D656D707479223E0A20202020202020203C696E70757420';
wwv_flow_imp.g_varchar2_table(577) := '747970653D22746578742220636C6173733D22617065782D6974656D2D746578742220617269612D6C6162656C6C656462793D22234944235F4C4142454C222076616C75653D222356414C55455323222023504C414345484F4C44455223206D61786C65';
wwv_flow_imp.g_varchar2_table(578) := '6E6774683D223130302220726F6C653D22636F6D626F626F782220617269612D657870616E6465643D2266616C736522206175746F636F6D706C6574653D226F666622206175746F636F72726563743D226F666622206175746F6361706974616C697A65';
wwv_flow_imp.g_varchar2_table(579) := '3D226E6F6E6522207370656C6C636865636B3D2266616C73652220617269612D6175746F636F6D706C6574653D226C6973742220617269612D64657363726962656462793D22234944235F646573632220617269612D627573793D2266616C7365223E0A';
wwv_flow_imp.g_varchar2_table(580) := '20202020202020203C7370616E20636C6173733D22612D436869702D636C656172206A732D636C656172496E707574223E3C7370616E20636C6173733D22612D49636F6E2069636F6E2D6D756C74692D72656D6F76652220617269612D68696464656E3D';
wwv_flow_imp.g_varchar2_table(581) := '2274727565223E3C2F7370616E3E3C2F7370616E3E0A2020202020203C2F6C693E0A202020203C2F756C3E0A20203C2F6469763E0A20203C612D636F6C756D6E2D6D65746164617461206E616D653D2223494423222073656172636861626C653D227472';
wwv_flow_imp.g_varchar2_table(582) := '75652220696E6465783D2230223E3C2F612D636F6C756D6E2D6D657461646174613E0A602C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(583) := '20202020202020202020202020202020202020202020202020202020202020202020202020202020706C616365686F6C646572733A207B0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(584) := '202020202020202020202256414C554553223A20617065782E7574696C2E65736361706548544D4C2827272B6C5F76616C756573290A20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(585) := '20202020207D0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207D293B0A20202020666F7228636F6E7374206C5F6F7074696F6E206F6620736368656D612E656E756D207C7C5B';
wwv_flow_imp.g_varchar2_table(586) := '5D297B0A2020202020206C5F67656E6572617465642E68746D6C202B3D20617065782E7574696C2E6170706C7954656D706C61746528600A20203C612D6F7074696F6E2076616C75653D2231223E234F5054494F4E233C612D6F7074696F6E2D636F6C75';
wwv_flow_imp.g_varchar2_table(587) := '6D6E2D76616C75653E234F5054494F4E233C2F612D6F7074696F6E2D636F6C756D6E2D76616C75653E3C2F612D6F7074696F6E3E0A602C202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(588) := '202020207B0A20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020706C616365686F6C646572733A207B0A2020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(589) := '20202020202020202020202020202020202020202020202020202020224F5054494F4E223A20617065782E7574696C2E65736361706548544D4C2827272B6C5F6F7074696F6E290A20202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(590) := '20202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207D293B0A202020207D0A202020206C5F67656E6572617465642E68';
wwv_flow_imp.g_varchar2_table(591) := '746D6C202B3D20600A3C2F612D636F6D626F626F783E0A603B0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E67656E6572617465466F72436F6D626F222C206C5F67656E657261746564293B0A202020207265';
wwv_flow_imp.g_varchar2_table(592) := '7475726E286C5F67656E657261746564293B0A20207D0A0A20202F2A0A2020202A2067656E6572617465207468652055492D6974656D20666F722073656C6563744F6E652F73656C6563744D616E79206974656D7320646570656E64696E67206F6E2069';
wwv_flow_imp.g_varchar2_table(593) := '74656D747970650A2020202A2072657475726E73207B6974656D733A20302C2077726170706572747970653A2022787878222C2068746D6C3A2022787878227D0A20202A2F0A202066756E6374696F6E2067656E6572617465466F7253656C6563744F6E';
wwv_flow_imp.g_varchar2_table(594) := '654D616E7928736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C206974656D747970652C20736368656D6141706578297B0A202020206C6574206C5F67656E657261746564203D207B206974656D733A302C20';
wwv_flow_imp.g_varchar2_table(595) := '77726170706572747970653A206E756C6C2C2068746D6C3A2027277D3B0A20202020736368656D612E61706578203D20736368656D612E617065787C7C7B7D3B0A20202020736368656D612E617065782E656E756D203D20736368656D612E617065782E';
wwv_flow_imp.g_varchar2_table(596) := '656E756D7C7C7B7D3B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E67656E6572617465466F7253656C6563744F6E654D616E79222C20736368656D612C20646174612C207072656669782C206E616D652C20';
wwv_flow_imp.g_varchar2_table(597) := '7374617274656E642C206974656D747970652C20736368656D6141706578293B0A202020206C6574206C5F76616C756573203D20286974656D747970653D3D435F415045585F53454C4543544D414E59293F28646174617C7C5B5D292E6A6F696E28435F';
wwv_flow_imp.g_varchar2_table(598) := '56414C5545534550415241544F52293A646174613B0A202020206C5F67656E657261746564203D207B0A20202020202020206974656D733A20202020202020312C0A202020202020202077726170706572747970653A20286974656D747970653D3D435F';
wwv_flow_imp.g_varchar2_table(599) := '415045585F53454C4543544D414E59293F27617065782D6974656D2D777261707065722D2D73656C6563742D6D616E79273A27617065782D6974656D2D777261707065722D2D73656C6563742D6F6E65272C0A202020202020202068746D6C3A20202020';
wwv_flow_imp.g_varchar2_table(600) := '20202020617065782E7574696C2E6170706C7954656D706C61746528600A3C612D73656C6563742069643D222349442322206E616D653D22234944232220235245515549524544232023504C414345484F4C444552232076616C75653D222356414C5545';
wwv_flow_imp.g_varchar2_table(601) := '232272657475726E2D646973706C61793D227472756522206D756C74692D73656C6563743D22234D554C544953454C4543542322206D756C74692D76616C75653D22234D554C544956414C55452322202356414C5545534550415241544F522320206D61';
wwv_flow_imp.g_varchar2_table(602) := '782D726573756C74733D2232353022206D696E2D636861726163746572732D7365617263683D223022206D617463682D747970653D22636F6E7461696E732220706172656E74732D72657175697265643D22747275652220646973706C61792D76616C75';
wwv_flow_imp.g_varchar2_table(603) := '65732D61733D2223444953504C4159415323223E0A602C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207B0A2020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(604) := '2020202020202020202020202020202020202020202020202020706C616365686F6C646572733A207B0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202256414C';
wwv_flow_imp.g_varchar2_table(605) := '5545534550415241544F52223A20276D756C74692D76616C75652D73746F726167653D2273657061726174656422206D756C74692D76616C75652D736570617261746F723D22272B20435F56414C5545534550415241544F522B2722272C0A2020202020';
wwv_flow_imp.g_varchar2_table(606) := '20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020224D554C544956414C5545223A2020286974656D747970653D3D435F415045585F53454C4543544D414E59293F277472756527';
wwv_flow_imp.g_varchar2_table(607) := '3A2766616C7365272C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020224D554C544953454C454354223A20286974656D747970653D3D435F415045585F53454C';
wwv_flow_imp.g_varchar2_table(608) := '4543544D414E59293F2774727565273A2766616C7365272C0A20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022444953504C41594153223A202020736368656D61';
wwv_flow_imp.g_varchar2_table(609) := '417065782E617343686970733F276368697073273A27736570617261746564272C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202256414C554553223A202020';
wwv_flow_imp.g_varchar2_table(610) := '2020206C5F76616C7565730A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(611) := '202020202020202020202020207D290A202020207D3B0A20202020666F7228636F6E7374206C5F76616C7565206F6620736368656D612E656E756D207C7C5B5D297B0A2020202020206C5F67656E6572617465642E68746D6C202B3D20617065782E7574';
wwv_flow_imp.g_varchar2_table(612) := '696C2E6170706C7954656D706C61746528600A3C612D6F7074696F6E2076616C75653D222356414C554523223E0A202023444953504C415956414C5545230A3C2F612D6F7074696F6E3E0A602C2020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(613) := '20202020202020202020202020202020202020202020202020207B0A20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020706C616365686F6C646572733A207B0A20202020';
wwv_flow_imp.g_varchar2_table(614) := '20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202256414C5545223A2020202020202020617065782E7574696C2E65736361706548544D4C2827272B6C5F76616C7565292C0A';
wwv_flow_imp.g_varchar2_table(615) := '20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022444953504C415956414C5545223A205B27626F6F6C65616E272C20276E756D626572275D2E696E636C75646573';
wwv_flow_imp.g_varchar2_table(616) := '28747970656F6620736368656D612E617065782E656E756D5B6C5F76616C75655D293F6A736F6E56616C7565324974656D28736368656D612C20736368656D612E617065782E656E756D5B6C5F76616C75655D293A28736368656D612E617065782E656E';
wwv_flow_imp.g_varchar2_table(617) := '756D5B6C5F76616C75655D7C7C6C5F76616C7565290A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(618) := '20202020202020202020202020202020202020202020207D293B0A202020207D0A0A202020206C5F67656E6572617465642E68746D6C202B3D20600A3C2F612D73656C6563743E0A603B0A20202020617065782E64656275672E747261636528223C3C6A';
wwv_flow_imp.g_varchar2_table(619) := '736F6E526567696F6E2E67656E6572617465466F7253656C6563744F6E654D616E79222C206C5F67656E657261746564293B0A2020202072657475726E286C5F67656E657261746564293B0A20207D0A0A20202F2A0A2020202A2067656E657261746520';
wwv_flow_imp.g_varchar2_table(620) := '7468652055492D6974656D20666F7220612070756C6C646F776E2F726164696F2F636865636B626F782070726F706572747920646570656E64696E67206F6E206974656D747970650A2020202A2072657475726E73207B6974656D733A20302C20777261';
wwv_flow_imp.g_varchar2_table(621) := '70706572747970653A2022787878222C2068746D6C3A2022787878227D0A20202A2F0A202066756E6374696F6E2067656E6572617465466F7253656C65637428736368656D612C20646174612C207072656669782C206E616D652C207374617274656E64';
wwv_flow_imp.g_varchar2_table(622) := '2C206974656D747970652C20736368656D6141706578297B0A202020206C6574206C5F67656E657261746564203D207B206974656D733A302C2077726170706572747970653A206E756C6C2C2068746D6C3A2027277D3B0A20202020736368656D612E61';
wwv_flow_imp.g_varchar2_table(623) := '706578203D20736368656D612E617065787C7C7B7D3B0A20202020736368656D612E617065782E656E756D203D20736368656D612E617065782E656E756D7C7C7B7D3B0A20202020617065782E64656275672E747261636528223E3E6A736F6E52656769';
wwv_flow_imp.g_varchar2_table(624) := '6F6E2E67656E6572617465466F7253656C656374222C20736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C206974656D74797065293B0A2020202073776974636820286974656D74797065297B0A2020202063';
wwv_flow_imp.g_varchar2_table(625) := '61736520435F415045585F53454C4543543A0A2020202020206C5F67656E657261746564203D207B0A20202020202020206974656D733A20312C0A202020202020202068746D6C3A20600A3C73656C6563742069643D222349442322206E616D653D2223';
wwv_flow_imp.g_varchar2_table(626) := '49442322202352455155495245442320636C6173733D2273656C6563746C69737420617065782D6974656D2D73656C6563742220646174612D6E61746976652D6D656E753D2266616C7365222073697A653D2231223E0A607D3B20202020202020202020';
wwv_flow_imp.g_varchar2_table(627) := '200A20202020202069662821736368656D612E6973526571756972656429207B0A20202020202020206C5F67656E6572617465642E68746D6C2B3D273C6F7074696F6E2076616C75653D22223E3C2F6F7074696F6E3E273B0A2020202020207D0A202020';
wwv_flow_imp.g_varchar2_table(628) := '202020666F7228636F6E7374206C5F76616C7565206F6620736368656D612E656E756D297B0A20202020202020206C5F67656E6572617465642E68746D6C202B3D20617065782E7574696C2E6170706C7954656D706C61746528600A20203C6F7074696F';
wwv_flow_imp.g_varchar2_table(629) := '6E2076616C75653D222356414C554523223E23444953504C415956414C5545233C2F6F7074696F6E3E0A602C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207B0A2020202020';
wwv_flow_imp.g_varchar2_table(630) := '2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020706C616365686F6C646572733A207B0A20202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(631) := '20202020202020202020202020202020202256414C5545223A20202020202020206A736F6E56616C7565324974656D28736368656D612C206C5F76616C7565292C0A20202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(632) := '202020202020202020202020202020202020202022444953504C415956414C5545223A205B27626F6F6C65616E272C20276E756D626572275D2E696E636C7564657328747970656F6620736368656D612E617065782E656E756D5B6C5F76616C75655D29';
wwv_flow_imp.g_varchar2_table(633) := '3F6A736F6E56616C7565324974656D28736368656D612C20736368656D612E617065782E656E756D5B6C5F76616C75655D293A28736368656D612E617065782E656E756D5B6C5F76616C75655D7C7C6C5F76616C7565290A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(634) := '2020202020202020202020202020202020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207D293B0A2020202020207D';
wwv_flow_imp.g_varchar2_table(635) := '0A2020202020206C5F67656E6572617465642E68746D6C202B3D0A600A3C2F73656C6563743E0A603B0A20202020627265616B3B0A2020202064656661756C743A0A2020202020206C5F67656E657261746564203D207B0A20202020202020206974656D';
wwv_flow_imp.g_varchar2_table(636) := '733A20312C0A202020202020202068746D6C3A20617065782E7574696C2E6170706C7954656D706C61746528600A3C64697620746162696E6465783D222D31222069643D22234944232220617269612D6C6162656C6C656462793D22234944235F4C4142';
wwv_flow_imp.g_varchar2_table(637) := '454C22202352455155495245442320636C6173733D22202354595045235F67726F757020617065782D6974656D2D67726F757020617065782D6974656D2D67726F75702D2D726320617065782D6974656D2D2354595045232220726F6C653D2223545950';
wwv_flow_imp.g_varchar2_table(638) := '452367726F7570223E0A602C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207B0A20202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(639) := '202020202020202020202020202020706C616365686F6C646572733A207B0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202254595045223A20206974656D7479';
wwv_flow_imp.g_varchar2_table(640) := '70650A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(641) := '202020207D290A2020202020207D3B0A2020202020206C6574206C5F6E723D303B0A2020202020200A202020202020666F7228636F6E7374206C5F76616C7565206F6620736368656D612E656E756D297B0A20202020202020206C5F67656E6572617465';
wwv_flow_imp.g_varchar2_table(642) := '642E68746D6C202B3D20617065782E7574696C2E6170706C7954656D706C61746528600A20203C64697620636C6173733D22617065782D6974656D2D6F7074696F6E222023444952233E0A202020203C696E70757420747970653D222354595045232220';
wwv_flow_imp.g_varchar2_table(643) := '69643D22234944235F234E522322206E616D653D22234944232220646174612D646973706C61793D222356414C554523222076616C75653D222356414C554523222023504C414345484F4C44455223202352455155495245442320617269612D6C616265';
wwv_flow_imp.g_varchar2_table(644) := '6C3D222356414C5545232220636C6173733D22223E0A202020203C6C6162656C20636C6173733D22752D2354595045232220666F723D22234944235F234E52232220617269612D68696464656E3D2274727565223E23444953504C415956414C5545233C';
wwv_flow_imp.g_varchar2_table(645) := '2F6C6162656C3E0A20203C2F6469763E0A602C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207B0A202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(646) := '20202020202020202020202020202020202020202020706C616365686F6C646572733A207B0A20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022444952223A2020';
wwv_flow_imp.g_varchar2_table(647) := '202020202020202028736368656D61417065782E646972656374696F6E3D3D435F415045585F484F52495A4F4E54414C293F277374796C653D22666C6F61743A206C65667422273A22222C0A202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(648) := '2020202020202020202020202020202020202020202020202020202020202254595045223A2020202020202020206974656D747970652C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(649) := '202020202020202020202256414C5545223A20202020202020206A736F6E56616C7565324974656D28736368656D612C206C5F76616C7565292C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(650) := '2020202020202020202020202022444953504C415956414C5545223A205B27626F6F6C65616E272C20276E756D626572275D2E696E636C7564657328747970656F6620736368656D612E617065782E656E756D5B6C5F76616C75655D293F6A736F6E5661';
wwv_flow_imp.g_varchar2_table(651) := '6C7565324974656D28736368656D612C20736368656D612E617065782E656E756D5B6C5F76616C75655D293A28736368656D612E617065782E656E756D5B6C5F76616C75655D7C7C6C5F76616C7565292C0A202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(652) := '202020202020202020202020202020202020202020202020202020202020202020202020224E52223A20202020202020202020206C5F6E722B2B0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(653) := '202020202020202020207D0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207D293B0A2020202020207D0A0A2020202020206C5F67656E6572617465642E68746D6C202B3D2060';
wwv_flow_imp.g_varchar2_table(654) := '0A3C2F6469763E0A603B0A20202020627265616B3B0A202020207D0A2020202073776974636820286974656D74797065297B0A202020206361736520435F415045585F53454C4543543A200A2020202020206C5F67656E6572617465642E777261707065';
wwv_flow_imp.g_varchar2_table(655) := '7274797065203D2027617065782D6974656D2D777261707065722D2D73656C6563742D6C697374273B0A20202020627265616B3B0A202020206361736520435F415045585F524144494F3A0A2020202020206C5F67656E6572617465642E777261707065';
wwv_flow_imp.g_varchar2_table(656) := '7274797065203D2027617065782D6974656D2D777261707065722D2D726164696F67726F7570273B0A20202020627265616B3B0A202020206361736520435F415045585F434845434B424F583A0A2020202020206C5F67656E6572617465642E77726170';
wwv_flow_imp.g_varchar2_table(657) := '70657274797065203D2027617065782D6974656D2D777261707065722D2D636865636B626F78273B0A20202020627265616B3B0A202020207D0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E67656E65726174';
wwv_flow_imp.g_varchar2_table(658) := '65466F7253656C656374222C206C5F67656E657261746564293B0A2020202072657475726E286C5F67656E657261746564293B0A20207D0A0A20202F2A0A2020202A2067656E6572617465207468652055492D6974656D20666F72206120737472696E67';
wwv_flow_imp.g_varchar2_table(659) := '2070726F706572747920646570656E64696E67206F6E20666F726D61742C202E2E2E0A2020202A2072657475726E73207B6974656D733A20302C2077726170706572747970653A2022787878222C2068746D6C3A2022787878227D0A20202A2F0A202066';
wwv_flow_imp.g_varchar2_table(660) := '756E6374696F6E2067656E6572617465466F72537472696E6728736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C206E65774974656D297B0A202020206C6574206C5F67656E657261746564203D207B697465';
wwv_flow_imp.g_varchar2_table(661) := '6D733A302C2077726170706572747970653A206E756C6C2C2068746D6C3A2027277D3B0A20202020736368656D612E61706578203D20736368656D612E617065787C7C7B7D3B0A20202020736368656D612E617065782E656E756D203D20736368656D61';
wwv_flow_imp.g_varchar2_table(662) := '2E617065782E656E756D7C7C7B7D3B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E67656E6572617465466F72537472696E67222C20736368656D612C20646174612C207072656669782C206E616D652C2073';
wwv_flow_imp.g_varchar2_table(663) := '74617274656E642C206E65774974656D293B0A20202020696628736368656D612E726561644F6E6C79297B0A20202020202073776974636828736368656D612E617065782E6974656D74797065297B0A2020202020206361736520435F415045585F494D';
wwv_flow_imp.g_varchar2_table(664) := '4147453A0A2020202020202020696628736368656D612E666F726D61743D3D435F4A534F4E5F464F524D41545F555249297B20202F2F7573652075726C20666F722074686520696D6167650A202020202020202020206C5F67656E657261746564203D20';
wwv_flow_imp.g_varchar2_table(665) := '7B0A2020202020202020202020206974656D733A20312C0A20202020202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D746578742D6669656C64272C0A20202020202020202020202068746D6C3A20';
wwv_flow_imp.g_varchar2_table(666) := '600A3C7370616E20636C6173733D22646973706C61795F6F6E6C7920617065782D6974656D2D646973706C61792D6F6E6C79223E0A20203C696D67207372633D222356414C5545232220616C743D222356414C554523223E0A3C2F7370616E3E0A3C696E';
wwv_flow_imp.g_varchar2_table(667) := '70757420747970653D2268696464656E222069643D2223494423222076616C75653D222356414C554523222F3E0A607D3B0A20202020202020207D20656C7365207B20202F2F20696D6167656461746120697320696E636C7564656420696E204A534F4E';
wwv_flow_imp.g_varchar2_table(668) := '0A202020202020202020206C5F67656E657261746564203D207B0A2020202020202020202020206974656D733A20312C0A20202020202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D746578742D66';
wwv_flow_imp.g_varchar2_table(669) := '69656C64272C0A20202020202020202020202068746D6C3A20600A3C7370616E20636C6173733D22646973706C61795F6F6E6C7920617065782D6974656D2D646973706C61792D6F6E6C79223E0A20203C696D67207372633D22646174613A23494D4147';
wwv_flow_imp.g_varchar2_table(670) := '45233B6261736536342C2356414C554523223E0A3C2F7370616E3E0A3C696E70757420747970653D2268696464656E222069643D2223494423222076616C75653D222356414C554523222F3E0A607D3B0A0A20202020202020207D0A2020202020206272';
wwv_flow_imp.g_varchar2_table(671) := '65616B3B0A2020202020206361736520435F415045585F5152434F44453A0A20202020202020206C5F67656E657261746564203D207B0A202020202020202020206974656D733A20312C0A2020202020202020202077726170706572747970653A202761';
wwv_flow_imp.g_varchar2_table(672) := '7065782D6974656D2D777261707065722D2D7172636F6465272C0A2020202020202020202068746D6C3A20600A3C612D7172636F64652069643D22234944232220636C6173733D22612D5152436F64652220616A61782D6964656E7469666965723D2223';
wwv_flow_imp.g_varchar2_table(673) := '414A41584944454E54494649455223222076616C75653D222356414C554523223E203C2F612D7172636F64653E0A607D3B0A202020202020627265616B3B0A20202020202064656661756C743A0A20202020202020206C5F67656E657261746564203D20';
wwv_flow_imp.g_varchar2_table(674) := '7B0A202020202020202020206974656D733A20312C0A2020202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D746578742D6669656C64272C0A2020202020202020202068746D6C3A20273C7370616E';
wwv_flow_imp.g_varchar2_table(675) := '2069643D22234944235F444953504C415922202352455155495245442320636C6173733D22646973706C61795F6F6E6C7920617065782D6974656D2D646973706C61792D6F6E6C792220646174612D6573636170653D2274727565223E2356414C554523';
wwv_flow_imp.g_varchar2_table(676) := '3C2F7370616E3E270A20202020202020207D3B0A202020202020627265616B3B0A2020202020207D0A202020207D20656C7365207B0A20202020202069662841727261792E6973417272617928736368656D612E656E756D29297B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(677) := '73776974636828736368656D612E617065782E6974656D74797065297B0A20202020202020206361736520435F415045585F53454C4543544F4E453A0A202020202020202020206C5F67656E657261746564203D2067656E6572617465466F7253656C65';
wwv_flow_imp.g_varchar2_table(678) := '63744F6E654D616E7928736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C20435F415045585F53454C4543544F4E452C20736368656D612E61706578293B0A2020202020202020627265616B3B0A2020202020';
wwv_flow_imp.g_varchar2_table(679) := '2020206361736520435F415045585F53454C4543543A0A20202020202020206361736520435F415045585F524144494F3A0A202020202020202020206C5F67656E657261746564203D2067656E6572617465466F7253656C65637428736368656D612C20';
wwv_flow_imp.g_varchar2_table(680) := '646174612C207072656669782C206E616D652C207374617274656E642C20736368656D612E617065782E6974656D747970652C20736368656D612E61706578293B0A2020202020202020627265616B3B0A202020202020202064656661756C743A0A2020';
wwv_flow_imp.g_varchar2_table(681) := '20202020202020206C6F67536368656D614572726F722827656E756D206E6F7420737570706F7274656420666F72272C20736368656D612E617065782E6974656D74797065293B20200A20202020202020207D0A2020202020207D20656C7365207B0A20';
wwv_flow_imp.g_varchar2_table(682) := '2020202020202073776974636828736368656D612E666F726D6174297B0A20202020202020206361736520435F4A534F4E5F464F524D41545F495056343A0A20202020202020206361736520435F4A534F4E5F464F524D41545F495056363A0A20202020';
wwv_flow_imp.g_varchar2_table(683) := '202020206361736520435F4A534F4E5F464F524D41545F555549443A0A2020202020202020202020206C5F67656E657261746564203D207B0A20202020202020202020202020206974656D733A20312C0A20202020202020202020202020207772617070';
wwv_flow_imp.g_varchar2_table(684) := '6572747970653A2027617065782D6974656D2D777261707065722D2D746578742D6669656C64272C0A202020202020202020202020202068746D6C3A20600A20203C696E70757420747970653D2274657874222069643D222349442322206E616D653D22';
wwv_flow_imp.g_varchar2_table(685) := '234944232220235245515549524544232023504C414345484F4C4445522320235041545445524E23202354455854434153452320636C6173733D2223414C49474E2320746578745F6669656C6420617065782D6974656D2D74657874222073697A653D22';
wwv_flow_imp.g_varchar2_table(686) := '33322220234D494E4C454E4754482320234D41584C454E4754482320646174612D7472696D2D7370616365733D22235452494D535041434553232220617269612D64657363726962656462793D22234944235F6572726F72223E0A2020607D3B0A202020';
wwv_flow_imp.g_varchar2_table(687) := '2020202020627265616B3B0A20202020202020206361736520435F4A534F4E5F464F524D41545F454D41494C3A0A202020202020202020206C5F67656E657261746564203D207B0A2020202020202020202020206974656D733A20312C0A202020202020';
wwv_flow_imp.g_varchar2_table(688) := '20202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D746578742D6669656C64272C0A20202020202020202020202068746D6C3A20600A3C696E70757420747970653D22656D61696C222069643D2223494423';
wwv_flow_imp.g_varchar2_table(689) := '22206E616D653D22234944232220235245515549524544232023504C414345484F4C4445522320235041545445524E23202354455854434153452320636C6173733D2223414C49474E2320746578745F6669656C6420617065782D6974656D2D74657874';
wwv_flow_imp.g_varchar2_table(690) := '222073697A653D2233322220234D494E4C454E4754482320234D41584C454E4754482320646174612D7472696D2D7370616365733D22235452494D535041434553232220617269612D64657363726962656462793D22234944235F6572726F72223E0A60';
wwv_flow_imp.g_varchar2_table(691) := '7D3B0A2020202020202020627265616B3B0A20202020202020206361736520435F4A534F4E5F464F524D41545F5552493A0A202020202020202020206C5F67656E657261746564203D207B0A2020202020202020202020206974656D733A20312C0A2020';
wwv_flow_imp.g_varchar2_table(692) := '2020202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D746578742D6669656C64272C0A20202020202020202020202068746D6C3A20600A3C696E70757420747970653D2275726C222069643D222349';
wwv_flow_imp.g_varchar2_table(693) := '442322206E616D653D22234944232220235245515549524544232023504C414345484F4C4445522320235041545445524E23202354455854434153452320636C6173733D2223414C49474E2320746578745F6669656C6420617065782D6974656D2D7465';
wwv_flow_imp.g_varchar2_table(694) := '7874222073697A653D2233322220234D494E4C454E4754482320234D41584C454E4754482320646174612D7472696D2D7370616365733D22235452494D535041434553232220617269612D64657363726962656462793D22234944235F6572726F72223E';
wwv_flow_imp.g_varchar2_table(695) := '0A607D3B0A2020202020202020627265616B3B0A20202020202020206361736520435F4A534F4E5F464F524D41545F444154453A0A20202020202020202020696628704F7074696F6E732E617065785F76657273696F6E203E3D435F415045585F564552';
wwv_flow_imp.g_varchar2_table(696) := '53494F4E5F32323032297B0A2020202020202020202020206C5F67656E657261746564203D207B0A20202020202020202020202020206974656D733A20312C0A202020202020202020202020202077726170706572747970653A2027617065782D697465';
wwv_flow_imp.g_varchar2_table(697) := '6D2D777261707065722D2D646174652D7069636B65722D6170657820617065782D6974656D2D777261707065722D2D646174652D7069636B65722D617065782D706F707570272C0A202020202020202020202020202068746D6C3A20600A3C612D646174';
wwv_flow_imp.g_varchar2_table(698) := '652D7069636B65722069643D2223494423222023524551554952454423206368616E67652D6D6F6E74683D227472756522206368616E67652D796561723D22747275652220646973706C61792D61733D22706F7075702220646973706C61792D7765656B';
wwv_flow_imp.g_varchar2_table(699) := '733D226E756D626572222020234D494E2320234D4158232070726576696F75732D6E6578742D64697374616E63653D226F6E652D6D6F6E7468222073686F772D646179732D6F7574736964652D6D6F6E74683D2276697369626C65222073686F772D6F6E';
wwv_flow_imp.g_varchar2_table(700) := '3D22666F6375732220746F6461792D627574746F6E3D22747275652220666F726D61743D2223464F524D415423222076616C69642D6578616D706C653D22234558414D504C45232220796561722D73656C656374696F6E2D72616E67653D22352220636C';
wwv_flow_imp.g_varchar2_table(701) := '6173733D22617065782D6974656D2D646174657069636B65722D2D706F707570223E0A20203C696E70757420617269612D686173706F7075703D226469616C6F672220636C6173733D2220617065782D6974656D2D7465787420617065782D6974656D2D';
wwv_flow_imp.g_varchar2_table(702) := '646174657069636B657222206E616D653D2223494423222073697A653D22323022206D61786C656E6774683D223230222023504C414345484F4C4445522320747970653D2274657874222069643D22234944235F696E707574222072657175697265643D';
wwv_flow_imp.g_varchar2_table(703) := '222220617269612D6C6162656C6C656462793D22234944235F4C4142454C22206D61786C656E6774683D22323535222076616C75653D222356414C554523223E0A20203C627574746F6E20617269612D686173706F7075703D226469616C6F6722206172';
wwv_flow_imp.g_varchar2_table(704) := '69612D6C6162656C3D2223494E464F232220636C6173733D22612D427574746F6E20612D427574746F6E2D2D63616C656E6461722220746162696E6465783D222D312220747970653D22627574746F6E2220617269612D64657363726962656462793D22';
wwv_flow_imp.g_varchar2_table(705) := '234944235F4C4142454C2220617269612D636F6E74726F6C733D22234944235F696E707574223E0A202020203C7370616E20636C6173733D22612D49636F6E2069636F6E2D63616C656E646172223E0A202020203C2F7370616E3E0A20203C2F62757474';
wwv_flow_imp.g_varchar2_table(706) := '6F6E3E0A3C2F612D646174652D7069636B65723E0A607D3B0A202020202020202020207D20656C736520696628704F7074696F6E732E617065785F76657273696F6E203E3D435F415045585F56455253494F4E5F32313032297B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(707) := '2020206C5F67656E657261746564203D207B0A202020202020202020202020202069746D65733A20312C0A202020202020202020202020202077726170706572747970653A2027617065782D6974656D2D7772617070657220617065782D6974656D2D77';
wwv_flow_imp.g_varchar2_table(708) := '7261707065722D2D646174652D7069636B65722D6A6574272C0A202020202020202020202020202068746D6C3A20600A3C6F6A2D696E7075742D646174652069643D222349442322202352455155495245442320636C6173733D22617065782D6A65742D';
wwv_flow_imp.g_varchar2_table(709) := '636F6D706F6E656E7420617065782D6974656D2D646174657069636B65722D6A6574206F6A2D696E7075746461746574696D652D646174652D6F6E6C79206F6A2D636F6D706F6E656E74206F6A2D696E7075746461746574696D65206F6A2D666F726D2D';
wwv_flow_imp.g_varchar2_table(710) := '636F6E74726F6C206F6A2D746578742D6669656C64222020234D494E2320234D41582320646174612D666F726D61743D2223464F524D415423222020646174612D6A65742D7061747465726E3D2223464F524D4154232220646174612D6D61786C656E67';
wwv_flow_imp.g_varchar2_table(711) := '74683D223235352220646174612D6E616D653D22234944232220646174612D6F7261636C652D646174652D76616C75653D222356414C5545232220646174612D73697A653D2233322220646174612D76616C69642D6578616D706C653D22234558414D50';
wwv_flow_imp.g_varchar2_table(712) := '4C45232220646174652D7069636B65722E6368616E67652D6D6F6E74683D2273656C6563742220646174652D7069636B65722E6368616E67652D796561723D2273656C6563742220646174652D7069636B65722E646179732D6F7574736964652D6D6F6E';
wwv_flow_imp.g_varchar2_table(713) := '74683D2276697369626C652220646174652D7069636B65722E73686F772D6F6E3D22666F6375732220646174652D7069636B65722E7765656B2D646973706C61793D226E6F6E652220646973706C61792D6F7074696F6E732E636F6E7665727465722D68';
wwv_flow_imp.g_varchar2_table(714) := '696E743D226E6F6E652220646973706C61792D6F7074696F6E732E6D657373616765733D226E6F6E652220646973706C61792D6F7074696F6E732E76616C696461746F722D68696E743D226E6F6E65222074696D652D7069636B65722E74696D652D696E';
wwv_flow_imp.g_varchar2_table(715) := '6372656D656E743D2230303A31353A30303A303022207472616E736C6174696F6E732E6E6578742D746578743D224E65787422207472616E736C6174696F6E732E707265762D746578743D2250726576696F7573222076616C75653D222356414C554523';
wwv_flow_imp.g_varchar2_table(716) := '223E0A3C2F6F6A2D696E7075742D646174653E0A607D3B0A202020202020202020207D20656C7365207B0A2020202020202020202020206C5F67656E657261746564203D207B0A202020202020202020202020202069746D65733A20312C0A2020202020';
wwv_flow_imp.g_varchar2_table(717) := '20202020202020202077726170706572747970653A2027617065782D6974656D2D77726170706572272C0A202020202020202020202020202068746D6C3A20600A20203C696E70757420747970653D227465787422202352455155495245442320617269';
wwv_flow_imp.g_varchar2_table(718) := '612D64657363726962656462793D22234944235F666F726D61745F68656C702220636C6173733D22646174657069636B657220617065782D6974656D2D7465787420617065782D6974656D2D646174657069636B6572222069643D222349442322206E61';
wwv_flow_imp.g_varchar2_table(719) := '6D653D222349442322206D61786C656E6774683D22323535222073697A653D223332222076616C75653D222356414C55452322206175746F636F6D706C6574653D226F6666223E0A20203C7370616E20636C6173733D22752D56697375616C6C79486964';
wwv_flow_imp.g_varchar2_table(720) := '64656E222069643D22234944235F666F726D61745F68656C70223E457870656374656420666F726D61743A2023464F524D4154233C2F7370616E3E0A607D3B0A202020202020202020207D0A2020202020202020627265616B3B0A202020202020202063';
wwv_flow_imp.g_varchar2_table(721) := '61736520435F4A534F4E5F464F524D41545F4441544554494D453A0A20202020202020202020696628704F7074696F6E732E617065785F76657273696F6E203E3D435F415045585F56455253494F4E5F32323032297B0A2020202020202020202020206C';
wwv_flow_imp.g_varchar2_table(722) := '5F67656E657261746564203D207B0A202020202020202020202020202069746D65733A20312C0A202020202020202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D646174652D7069636B65722D6170';
wwv_flow_imp.g_varchar2_table(723) := '657820617065782D6974656D2D777261707065722D2D646174652D7069636B65722D617065782D706F707570272C0A202020202020202020202020202068746D6C3A20600A3C612D646174652D7069636B65722069643D22234944232220235245515549';
wwv_flow_imp.g_varchar2_table(724) := '52454423206368616E67652D6D6F6E74683D227472756522206368616E67652D796561723D22747275652220646973706C61792D61733D22706F7075702220646973706C61792D7765656B733D226E756D6265722220234D494E2320234D415823207072';
wwv_flow_imp.g_varchar2_table(725) := '6576696F75732D6E6578742D64697374616E63653D226F6E652D6D6F6E7468222073686F772D646179732D6F7574736964652D6D6F6E74683D2276697369626C65222073686F772D6F6E3D22666F637573222073686F772D74696D653D22747275652220';
wwv_flow_imp.g_varchar2_table(726) := '74696D652D696E6372656D656E742D6D696E7574653D2231352220746F6461792D627574746F6E3D22747275652220666F726D61743D2223464F524D415423222076616C69642D6578616D706C653D22234558414D504C45232220796561722D73656C65';
wwv_flow_imp.g_varchar2_table(727) := '6374696F6E2D72616E67653D22352220636C6173733D22617065782D6974656D2D646174657069636B65722D2D706F707570223E0A20203C696E70757420617269612D686173706F7075703D226469616C6F672220636C6173733D2220617065782D6974';
wwv_flow_imp.g_varchar2_table(728) := '656D2D7465787420617065782D6974656D2D646174657069636B657222206E616D653D2223494423222073697A653D22333022206D61786C656E6774683D223330222023504C414345484F4C4445522320747970653D2274657874222069643D22234944';
wwv_flow_imp.g_varchar2_table(729) := '235F696E707574222072657175697265643D222220617269612D6C6162656C6C656462793D22234944235F4C4142454C22206D61786C656E6774683D22323535222076616C75653D222356414C554523223E0A20203C627574746F6E20617269612D6861';
wwv_flow_imp.g_varchar2_table(730) := '73706F7075703D226469616C6F672220617269612D6C6162656C3D2223494E464F232220636C6173733D22612D427574746F6E20612D427574746F6E2D2D63616C656E6461722220746162696E6465783D222D312220747970653D22627574746F6E2220';
wwv_flow_imp.g_varchar2_table(731) := '617269612D64657363726962656462793D22234944235F4C4142454C2220617269612D636F6E74726F6C733D22234944235F696E707574223E0A202020203C7370616E20636C6173733D22612D49636F6E2069636F6E2D63616C656E6461722D74696D65';
wwv_flow_imp.g_varchar2_table(732) := '223E0A202020203C2F7370616E3E0A20203C2F627574746F6E3E0A3C2F612D646174652D7069636B65723E0A607D3B0A202020202020202020207D20656C736520696628704F7074696F6E732E617065785F76657273696F6E203E3D435F415045585F56';
wwv_flow_imp.g_varchar2_table(733) := '455253494F4E5F32313032297B0A2020202020202020202020206C5F67656E657261746564203D207B0A20202020202020202020202020206974656D733A20312C0A202020202020202020202020202077726170706572747970653A2027617065782D69';
wwv_flow_imp.g_varchar2_table(734) := '74656D2D7772617070657220617065782D6974656D2D777261707065722D2D646174652D7069636B65722D6A6574272C0A202020202020202020202020202068746D6C3A20600A3C6F6A2D696E7075742D646174652D74696D652069643D222349442322';
wwv_flow_imp.g_varchar2_table(735) := '202352455155495245442320636C6173733D22617065782D6A65742D636F6D706F6E656E7420617065782D6974656D2D646174657069636B65722D6A6574206F6A2D696E7075746461746574696D652D646174652D74696D65206F6A2D636F6D706F6E65';
wwv_flow_imp.g_varchar2_table(736) := '6E74206F6A2D696E7075746461746574696D65206F6A2D666F726D2D636F6E74726F6C206F6A2D746578742D6669656C642220234D494E2320234D41582320646174612D666F726D61743D2223464F524D415423222020646174612D6A65742D70617474';
wwv_flow_imp.g_varchar2_table(737) := '65726E3D2223464F524D4154232220646174612D6D61786C656E6774683D223235352220646174612D6E616D653D22234944232220646174612D6F7261636C652D646174652D76616C75653D222356414C5545232220646174612D73697A653D22333222';
wwv_flow_imp.g_varchar2_table(738) := '20646174612D76616C69642D6578616D706C653D22234558414D504C45232220646174652D7069636B65722E6368616E67652D6D6F6E74683D2273656C6563742220646174652D7069636B65722E6368616E67652D796561723D2273656C656374222064';
wwv_flow_imp.g_varchar2_table(739) := '6174652D7069636B65722E646179732D6F7574736964652D6D6F6E74683D2276697369626C652220646174652D7069636B65722E73686F772D6F6E3D22666F6375732220646174652D7069636B65722E7765656B2D646973706C61793D226E6F6E652220';
wwv_flow_imp.g_varchar2_table(740) := '646973706C61792D6F7074696F6E732E636F6E7665727465722D68696E743D226E6F6E652220646973706C61792D6F7074696F6E732E6D657373616765733D226E6F6E652220646973706C61792D6F7074696F6E732E76616C696461746F722D68696E74';
wwv_flow_imp.g_varchar2_table(741) := '3D226E6F6E6522207472616E736C6174696F6E732E6E6578742D746578743D224E65787422207472616E736C6174696F6E732E707265762D746578743D2250726576696F7573222076616C75653D222356414C554523223E0A3C2F6F6A2D696E7075742D';
wwv_flow_imp.g_varchar2_table(742) := '646174652D74696D653E0A607D3B0A202020202020202020207D20656C7365207B0A2020202020202020202020206C5F67656E657261746564203D207B0A20202020202020202020202020206974656D733A20312C0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(743) := '77726170706572747970653A2027617065782D6974656D2D7772617070657220617065782D6974656D2D777261707065722D2D646174652D7069636B65722D6A6574272C0A202020202020202020202020202068746D6C3A20600A20203C696E70757420';
wwv_flow_imp.g_varchar2_table(744) := '747970653D227465787422202352455155495245442320617269612D64657363726962656462793D22234944235F666F726D61745F68656C702220636C6173733D22646174657069636B657220617065782D6974656D2D7465787420617065782D697465';
wwv_flow_imp.g_varchar2_table(745) := '6D2D646174657069636B6572222069643D222349442322206E616D653D222349442322206D61786C656E6774683D22323535222073697A653D223332222076616C75653D222356414C55452322206175746F636F6D706C6574653D226F6666223E0A2020';
wwv_flow_imp.g_varchar2_table(746) := '3C7370616E20636C6173733D22752D56697375616C6C7948696464656E222069643D22234944235F666F726D61745F68656C70223E457870656374656420666F726D61743A2023464F524D4154233C2F7370616E3E0A607D3B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(747) := '7D0A2020202020202020627265616B3B0A20202020202020206361736520435F4A534F4E5F464F524D41545F54494D453A0A202020202020202020206C5F67656E657261746564203D207B0A2020202020202020202020206974656D733A20312C0A2020';
wwv_flow_imp.g_varchar2_table(748) := '2020202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D746578742D6669656C64272C0A20202020202020202020202068746D6C3A20600A3C696E70757420747970653D2274696D65222069643D2223';
wwv_flow_imp.g_varchar2_table(749) := '49442322206E616D653D222349442322202352455155495245442320234D494E2320234D41582320636C6173733D22746578745F6669656C6420617065782D6974656D2D7465787422202023504C414345484F4C444552232073697A653D223522206461';
wwv_flow_imp.g_varchar2_table(750) := '74612D7472696D2D7370616365733D22235452494D535041434553232220617269612D64657363726962656462793D22234944235F6572726F72222F3E0A607D3B0A2020202020202020627265616B3B0A202020202020202064656661756C743A0A2020';
wwv_flow_imp.g_varchar2_table(751) := '20202020202020206C5F67656E657261746564203D207B0A20202020202020202020206974656D733A20312C0A202020202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D746578742D6669656C6427';
wwv_flow_imp.g_varchar2_table(752) := '2C0A202020202020202020202068746D6C3A20600A3C696E70757420747970653D2274657874222069643D222349442322206E616D653D222349442322202352455155495245442320234D494E4C454E4754482320234D41584C454E475448232023504C';
wwv_flow_imp.g_varchar2_table(753) := '414345484F4C4445522320235041545445524E23202354455854434153452320636C6173733D2223414C49474E2320746578745F6669656C6420617065782D6974656D2D74657874222073697A653D2233322220646174612D7472696D2D737061636573';
wwv_flow_imp.g_varchar2_table(754) := '3D22235452494D535041434553232220617269612D64657363726962656462793D22234944235F6572726F72223E0A607D3B0A202020202020202020207377697463682028736368656D612E617065782E6974656D74797065297B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(755) := '20206361736520435F415045585F50415353574F52443A0A2020202020202020202020206C5F67656E657261746564203D207B0A20202020202020202020202020206974656D733A20312C202020202020202020202020202020200A2020202020202020';
wwv_flow_imp.g_varchar2_table(756) := '20202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D70617373776F7264272C0A202020202020202020202020202068746D6C3A20600A3C696E70757420747970653D2270617373776F726422206E616D653D';
wwv_flow_imp.g_varchar2_table(757) := '222349442322222073697A653D2233302220235041545445524E23202352455155495245442320234D494E4C454E4754482320234D41584C454E47544823206175746F636F6D706C6574653D2270617373776F7264222076616C75653D22222069643D22';
wwv_flow_imp.g_varchar2_table(758) := '234944232220636C6173733D2270617373776F726420617065782D6974656D2D74657874223E0A607D3B0A20202020202020202020627265616B3B202020200A202020202020202020206361736520435F415045585F52494348544558543A0A20202020';
wwv_flow_imp.g_varchar2_table(759) := '20202020202020206C5F67656E657261746564203D207B0A20202020202020202020202020206974656D733A20312C0A202020202020202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D726963682D';
wwv_flow_imp.g_varchar2_table(760) := '746578742D656469746F72272C0A202020202020202020202020202068746D6C3A20600A3C612D726963682D746578742D656469746F722069643D222349442322206E616D653D222349442322206D6F64653D226D61726B646F776E2220235245515549';
wwv_flow_imp.g_varchar2_table(761) := '5245442320726561642D6F6E6C793D2223524541444F4E4C59232220646973706C61792D76616C75652D6D6F64653D22706C61696E2D74657874222076697375616C2D6D6F64653D22696E6C696E65222076616C75653D222351554F544556414C554523';
wwv_flow_imp.g_varchar2_table(762) := '223E0A3C2F612D726963682D746578742D656469746F723E0A607D3B0A202020202020202020627265616B3B0A202020202020202020206361736520435F415045585F54455854415245413A0A2020202020202020202020206C5F67656E657261746564';
wwv_flow_imp.g_varchar2_table(763) := '203D207B0A20202020202020202020202020206974656D733A20312C0A202020202020202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D7465787461726561272C0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(764) := '2068746D6C3A20600A3C64697620636C6173733D22617065782D6974656D2D67726F757020617065782D6974656D2D67726F75702D2D7465787461726561223E0A20203C7465787461726561206E616D653D22234E414D45232220726F77733D2223524F';
wwv_flow_imp.g_varchar2_table(765) := '5753232220636F6C733D22313030222069643D222349442322202352455155495245442320636C6173733D22746578746172656120617065782D6974656D2D74657874617265612220646174612D726573697A61626C653D227472756522207374796C65';
wwv_flow_imp.g_varchar2_table(766) := '3D22726573697A653A20626F74683B223E2351554F544556414C5545233C2F74657874617265613E0A3C2F6469763E0A20607D3B0A20202020202020202020627265616B3B0A202020202020202020207D0A2020202020202020627265616B3B0A202020';
wwv_flow_imp.g_varchar2_table(767) := '20202020207D0A2020202020207D0A202020207D0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E67656E6572617465466F72537472696E67222C206C5F67656E657261746564293B0A2020202072657475726E';
wwv_flow_imp.g_varchar2_table(768) := '286C5F67656E657261746564293B0A20207D3B0A0A20202F2A0A2020202A2067656E6572617465207468652055492D6974656D20666F72206120696E74656765722F6E756D6265722070726F706572747920646570656E64696E67206F6E20666F726D61';
wwv_flow_imp.g_varchar2_table(769) := '742C202E2E2E0A2020202A2072657475726E73207B6974656D733A20302C2077726170706572747970653A2022787878222C2068746D6C3A2022787878227D0A20202A2F0A202066756E6374696F6E2067656E6572617465466F724E756D657269632873';
wwv_flow_imp.g_varchar2_table(770) := '6368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C206E65774974656D297B0A20202020736368656D612E61706578203D20736368656D612E617065787C7C7B7D3B0A202020206C6574206C5F67656E6572617465';
wwv_flow_imp.g_varchar2_table(771) := '64203D207B6974656D733A20302C2077726170706572747970653A206E756C6C2C2068746D6C3A2027277D3B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E67656E6572617465466F724E756D65726963222C';
wwv_flow_imp.g_varchar2_table(772) := '20736368656D612C20646174612C207072656669782C206E616D652C207374617274656E64293B0A2020202069662841727261792E6973417272617928736368656D612E656E756D29297B20202F2F206E756D657269632050756C6C646F776E0A202020';
wwv_flow_imp.g_varchar2_table(773) := '2020206C5F67656E657261746564203D2067656E6572617465466F7253656C65637428736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C20435F415045585F53454C4543542C20736368656D612E6170657829';
wwv_flow_imp.g_varchar2_table(774) := '3B0A202020207D20656C7365207B0A20202020202020202020696628736368656D612E617065782E6974656D747970653D3D435F415045585F5043544752415048297B0A2020202020202020202020206C5F67656E657261746564203D207B0A20202020';
wwv_flow_imp.g_varchar2_table(775) := '202020202020202020206974656D733A20312C0A202020202020202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D7063742D6772617068272C0A202020202020202020202020202068746D6C3A600A';
wwv_flow_imp.g_varchar2_table(776) := '3C64697620636C6173733D22617065782D6974656D2D7063742D6772617068222069643D22234944232220646174612D73686F772D76616C75653D227472756522223E2356414C5545233C2F6469763E0A607D3B0A202020202020202020207D20656C73';
wwv_flow_imp.g_varchar2_table(777) := '6520696628736368656D612E617065782E6974656D747970653D3D435F415045585F53544152524154494E47297B0A20202020202020202020202020206C5F67656E657261746564203D207B0A202020202020202020202020202020206974656D733A20';
wwv_flow_imp.g_varchar2_table(778) := '312C0A2020202020202020202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D737461722D726174696E67272C0A2020202020202020202020202020202068746D6C3A20600A3C6469762069643D2223';
wwv_flow_imp.g_varchar2_table(779) := '4944232220636C6173733D22612D53746172526174696E6720617065782D6974656D2D73746172726174696E67223E0A20203C64697620636C6173733D22612D53746172526174696E67222076616C75653D222356414C554523223E0A202020203C696E';
wwv_flow_imp.g_varchar2_table(780) := '70757420747970653D22746578742220617269612D6C6162656C6C656462793D22234944235F4C4142454C222069643D22234944235F494E505554222076616C75653D222356414C55452322206E616D653D222349442220636C6173733D2220752D7668';
wwv_flow_imp.g_varchar2_table(781) := '2069732D666F63757361626C652220726F6C653D227370696E627574746F6E2220617269612D76616C75656E6F773D222356414C5545232220617269612D76616C75656D61783D22234D4158232220617269612D76616C7565746578743D222356414C55';
wwv_flow_imp.g_varchar2_table(782) := '4523223E200A202020203C64697620636C6173733D22612D53746172526174696E672D7374617273223E200A202020203C2F6469763E0A20203C2F6469763E0A3C2F6469763E0A607D3B0A202020202020202020207D20656C7365207B0A202020202020';
wwv_flow_imp.g_varchar2_table(783) := '202020202020696628736368656D612E726561644F6E6C79297B0A20202020202020202020202020206C5F67656E657261746564203D207B0A202020202020202020202020202020206974656D733A20312C0A2020202020202020202020202020202077';
wwv_flow_imp.g_varchar2_table(784) := '726170706572747970653A2027617065782D6974656D2D777261707065722D2D746578742D6669656C64272C0A2020202020202020202020202020202068746D6C3A20273C7370616E2069643D22234944235F444953504C415922202352455155495245';
wwv_flow_imp.g_varchar2_table(785) := '442320636C6173733D22646973706C61795F6F6E6C7920617065782D6974656D2D646973706C61792D6F6E6C792220646174612D6573636170653D2274727565223E2356414C5545233C2F7370616E3E277D3B0A2020202020202020202020207D20656C';
wwv_flow_imp.g_varchar2_table(786) := '7365207B0A20202020202020202020202020206C5F67656E657261746564203D207B0A202020202020202020202020202020206974656D733A20312C0A2020202020202020202020202020202077726170706572747970653A2027617065782D6974656D';
wwv_flow_imp.g_varchar2_table(787) := '2D777261707065722D2D6E756D6265722D6669656C64272C0A2020202020202020202020202020202068746D6C3A20600A3C696E70757420747970653D2274657874222069643D222349442322206E616D653D2223494423222023524551554952454423';
wwv_flow_imp.g_varchar2_table(788) := '2023504C414345484F4C4445522320636C6173733D2223414C49474E23206E756D6265725F6669656C6420617065782D6974656D2D7465787420617065782D6974656D2D6E756D626572222073697A653D2233302220234D494E2320234D415823206461';
wwv_flow_imp.g_varchar2_table(789) := '74612D666F726D61743D2223464F524D4154232220696E7075746D6F64653D22646563696D616C223E0A607D3B0A202020202020202020207D0A20202020202020207D0A202020207D0A20202020617065782E64656275672E747261636528223C3C6A73';
wwv_flow_imp.g_varchar2_table(790) := '6F6E526567696F6E2E67656E6572617465466F724E756D65726963222C206C5F67656E657261746564293B0A2020202072657475726E286C5F67656E657261746564293B0A20207D3B0A0A20202F2A0A2020202A2067656E657261746520746865205549';
wwv_flow_imp.g_varchar2_table(791) := '2D6974656D20666F72206120737472696E672070726F706572747920646570656E64696E67206F6E206974656D747970652E0A2020202A2072657475726E73207B6974656D733A20302C2077726170706572747970653A2022787878222C2068746D6C3A';
wwv_flow_imp.g_varchar2_table(792) := '2022787878227D0A20202A2F202020200A202066756E6374696F6E2067656E6572617465466F72426F6F6C65616E28736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C206E65774974656D297B0A202020206C';
wwv_flow_imp.g_varchar2_table(793) := '6574206C5F67656E657261746564203D207B6974656D733A20302C2077726170706572747970653A206E756C6C2C2068746D6C3A2027277D3B0A20202020736368656D612E61706578203D20736368656D612E617065787C7C7B7D3B0A20202020617065';
wwv_flow_imp.g_varchar2_table(794) := '782E64656275672E747261636528223E3E6A736F6E526567696F6E2E67656E6572617465466F72426F6F6C65616E222C20736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C206E65774974656D293B0A202020';
wwv_flow_imp.g_varchar2_table(795) := '2073776974636828736368656D612E617065782E6974656D74797065297B0A202020206361736520435F415045585F5357495443483A0A2020202020206C5F67656E657261746564203D207B0A20202020202020206974656D733A20312C0A2020202020';
wwv_flow_imp.g_varchar2_table(796) := '20202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D7965732D6E6F272C0A202020202020202068746D6C3A20600A3C7370616E20636C6173733D22612D537769746368223E0A20203C696E70757420747970653D22';
wwv_flow_imp.g_varchar2_table(797) := '636865636B626F78222069643D222349442322206E616D653D22234944232220636C6173733D22222076616C75653D22592220646174612D6F6E2D6C6162656C3D224F6E2220646174612D6F66662D76616C75653D224E2220646174612D6F66662D6C61';
wwv_flow_imp.g_varchar2_table(798) := '62656C3D224F6666223E0A20203C7370616E20636C6173733D22612D5377697463682D746F67676C65223E3C2F7370616E3E0A3C2F7370616E3E0A607D3B20200A20202020627265616B3B0A202020206361736520435F415045585F53454C4543543A0A';
wwv_flow_imp.g_varchar2_table(799) := '202020206361736520435F415045585F524144494F3A0A2020202020206C6574206C5F61706578203D207B2E2E2E736368656D612E617065787D3B0A2020202020206C5F617065782E656E756D203D207B4E3A20224E6F222C20593A2022596573227D3B';
wwv_flow_imp.g_varchar2_table(800) := '0A2020202020206C6574206C5F67656E203D2067656E6572617465466F72537472696E67287B2274797065223A2022737472696E67222C202269735265717569726564223A20736368656D612E697352657175697265642C2022656E756D223A205B224E';
wwv_flow_imp.g_varchar2_table(801) := '222C202259225D2C202261706578223A206C5F617065787D2C20646174612C207072656669782C206E616D652C207374617274656E642C206E65774974656D293B0A2020202020206C5F67656E657261746564203D207B0A20202020202020206974656D';
wwv_flow_imp.g_varchar2_table(802) := '733A20312C0A202020202020202077726170706572747970653A2028736368656D612E617065782E6974656D747970653D3D435F415045585F53454C454354293F27617065782D6974656D2D777261707065722D2D73696E676C652D636865636B626F78';
wwv_flow_imp.g_varchar2_table(803) := '273A27617065782D6974656D2D777261707065722D2D726164696F67726F7570272C0A202020202020202068746D6C3A206C5F67656E2E68746D6C0A2020202020207D3B0A20202020627265616B3B0A2020202064656661756C743A0A2020202020206C';
wwv_flow_imp.g_varchar2_table(804) := '5F67656E657261746564203D207B0A20202020202020206974656D733A20312C0A202020202020202077726170706572747970653A2027617065782D6974656D2D777261707065722D2D73696E676C652D636865636B626F78272C0A2020202020202020';
wwv_flow_imp.g_varchar2_table(805) := '68746D6C3A20600A3C64697620636C6173733D22617065782D6974656D2D73696E676C652D636865636B626F78223E0A20203C696E70757420747970653D2268696464656E22206E616D653D22234944232220636C6173733D22222069643D2223494423';
wwv_flow_imp.g_varchar2_table(806) := '5F48494444454E56414C5545222076616C75653D222356414C554523223E0A20203C696E70757420747970653D22636865636B626F78222023434845434B45442320235245515549524544232069643D22234944232220617269612D6C6162656C3D2223';
wwv_flow_imp.g_varchar2_table(807) := '4C4142454C232220646174612D756E636865636B65642D76616C75653D224E222076616C75653D2259223E0A20203C6C6162656C20666F723D2223494423222069643D22234944235F4C4142454C2220636C6173733D2220752D636865636B626F782220';
wwv_flow_imp.g_varchar2_table(808) := '617269612D68696464656E3D2274727565223E234C4142454C233C2F6C6162656C3E0A3C2F6469763E0A607D3B202020200A202020207D0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E67656E657261746546';
wwv_flow_imp.g_varchar2_table(809) := '6F72426F6F6C65616E222C206C5F67656E657261746564293B0A2020202072657475726E20286C5F67656E657261746564293B0A20207D0A0A20202F2A0A2020202A2067656E6572617465207468652055492D6974656D20666F72206120737472696E67';
wwv_flow_imp.g_varchar2_table(810) := '2070726F706572747920646570656E64696E67206F6E206974656D747970652E0A2020202A2043757272656E746C79206F6E6C7920617272617973206F662073696D706C6520747970657320776974682022656E756D220A2020202A2072657475726E73';
wwv_flow_imp.g_varchar2_table(811) := '207B6974656D733A20302C2077726170706572747970653A2022787878222C2068746D6C3A2022787878227D200A20202A2F20200A202066756E6374696F6E2067656E6572617465466F72417272617928736368656D612C20646174612C207072656669';
wwv_flow_imp.g_varchar2_table(812) := '782C206E616D652C207374617274656E642C20696E41727261792C2068617344656C6574652C206E65774974656D297B0A202020206C6574206C5F67656E657261746564203D207B6974656D733A20302C2077726170706572747970653A206E756C6C2C';
wwv_flow_imp.g_varchar2_table(813) := '2068746D6C3A2027277D3B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E67656E6572617465466F724172726179222C20736368656D612C20646174612C207072656669782C206E616D652C20737461727465';
wwv_flow_imp.g_varchar2_table(814) := '6E642C20696E41727261792C2068617344656C6574652C206E65774974656D293B0A202020206C6574206974656D203D20736368656D612E6974656D737C7C7B7D3B0A2020202064617461203D2064617461207C7C205B5D3B0A20202020696628417272';
wwv_flow_imp.g_varchar2_table(815) := '61792E69734172726179286461746129297B0A2020202020206966282041727261792E69734172726179286974656D2E656E756D29297B20202F2F207768656E20746865726520697320616E20656E756D2C207468697320617272617920666F72206120';
wwv_flow_imp.g_varchar2_table(816) := '6D756C746973656C656374696F6E0A20202020202020206966285B435F4A534F4E5F424F4F4C45414E2C20435F4A534F4E5F535452494E472C20435F4A534F4E5F494E54454745522C20435F4A534F4E5F4E554D4245525D2E696E636C75646573286974';
wwv_flow_imp.g_varchar2_table(817) := '656D2E7479706529297B0A202020202020202020206C5F67656E6572617465642E6974656D73203D313B0A2020202020202020202073776974636828736368656D612E617065782E6974656D74797065297B0A202020202020202020206361736520435F';
wwv_flow_imp.g_varchar2_table(818) := '415045585F434F4D424F3A0A2020202020202020202020206C5F67656E657261746564203D2067656E6572617465466F72436F6D626F286974656D2C20646174612C207072656669782C206E616D652C207374617274656E642C20736368656D612E6170';
wwv_flow_imp.g_varchar2_table(819) := '65782E6974656D747970652C20736368656D612E61706578293B0A20202020202020202020627265616B3B20200A202020202020202020206361736520435F415045585F53454C4543544D414E593A0A2020202020202020202020206C5F67656E657261';
wwv_flow_imp.g_varchar2_table(820) := '746564203D2067656E6572617465466F7253656C6563744F6E654D616E79286974656D2C20646174612C207072656669782C206E616D652C207374617274656E642C20736368656D612E617065782E6974656D747970652C20736368656D612E61706578';
wwv_flow_imp.g_varchar2_table(821) := '293B0A20202020202020202020627265616B3B20200A2020202020202020202064656661756C743A0A2020202020202020202020206C5F67656E657261746564203D202067656E6572617465466F7253656C656374286974656D2C20646174612C207072';
wwv_flow_imp.g_varchar2_table(822) := '656669782C206E616D652C207374617274656E642C20435F415045585F434845434B424F582C20736368656D612E61706578293B0A20202020202020202020627265616B3B20200A202020202020202020207D0A20202020202020207D20656C7365207B';
wwv_flow_imp.g_varchar2_table(823) := '0A202020202020202020206C6F67536368656D614572726F7228272274797065223A3A20226172726179222073696D706C65207479706520737472696E67207769746820656E756D206F6E6C79272C20736368656D612C20646174612C20707265666978';
wwv_flow_imp.g_varchar2_table(824) := '2C206E616D652C207374617274656E64293B0A20202020202020207D0A0A2020202020207D20656C7365207B20202F2F206C6F6F70207468726F7567682074686520617272617920616E642067656E657261746520616E206F626A65637420666F722065';
wwv_flow_imp.g_varchar2_table(825) := '61636820726F770A2020202020202020696628704F7074696F6E732E68656164657273297B0A202020202020202020206C5F67656E6572617465642E68746D6C203D2067656E6572617465536570617261746F7228736368656D612C2067656E65726174';
wwv_flow_imp.g_varchar2_table(826) := '654C6162656C286E616D652C20736368656D61292C207072656669782C2066616C73652C202743524541544527293B0A20202020202020207D0A2020202020202020666F7228636F6E737420206920696E206461746129207B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(827) := '636F6E7374206C5F67656E203D2067656E6572617465466F724F626A656374286974656D2C20646174615B695D2C207072656669782C202727202B692C207374617274656E642C20747275652C2068617344656C6574652C206E65774974656D293B0A20';
wwv_flow_imp.g_varchar2_table(828) := '2020202020202020206C5F67656E6572617465642E68746D6C202B3D206C5F67656E2E68746D6C3B0A20202020202020207D0A0A0A2020202020207D0A202020207D20656C7365207B0A2020202020206C6F67536368656D614572726F72282764617461';
wwv_flow_imp.g_varchar2_table(829) := '206D75737420626520616E206172726179272C2064617461293B0A202020207D0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E67656E6572617465466F724172726179222C206C5F67656E657261746564293B';
wwv_flow_imp.g_varchar2_table(830) := '2020200A2020202072657475726E286C5F67656E657261746564293B0A20207D0A0A0A20202F2A0A2020202A0A20202A2F0A202066756E6374696F6E20636865636B436F6E646974696F6E28736368656D61297B0A20202020617065782E64656275672E';
wwv_flow_imp.g_varchar2_table(831) := '747261636528223E3E6A736F6E526567696F6E2E636865636B436F6E646974696F6E222C20736368656D61293B0A0A202020206C6574206C5F726574203D2028747970656F6620736368656D61203D3D276F626A65637427202626202141727261792E69';
wwv_flow_imp.g_varchar2_table(832) := '73417272617928736368656D6129293B0A202020206966286C5F72657420262620736368656D612E616C6C4F66297B202020200A2020202020206C5F726574203D2041727261792E6973417272617928736368656D612E616C6C4F66293B0A2020202020';
wwv_flow_imp.g_varchar2_table(833) := '206966286C5F726574297B202020202F2F20616C6C4F6620697320646566696E656420616E6420616E2061727261790A2020202020202020666F7228636F6E7374206C5F736368656D61206F6620736368656D612E616C6C4F66297B0A20202020202020';
wwv_flow_imp.g_varchar2_table(834) := '2020206C5F726574203D206C5F72657420262620636865636B436F6E646974696F6E286C5F736368656D61293B0A20202020202020207D20200A2020202020207D2020200A202020207D0A202020206966286C5F72657420262620736368656D612E616E';
wwv_flow_imp.g_varchar2_table(835) := '794F66297B202020200A2020202020206C5F726574203D2041727261792E6973417272617928736368656D612E616E794F66293B2020200A2020202020206966286C5F726574297B20202020202F2F20616E794F6620697320646566696E656420616E64';
wwv_flow_imp.g_varchar2_table(836) := '20616E2061727261790A2020202020202020666F7228636F6E7374206C5F736368656D61206F6620736368656D612E616E794F66297B0A202020202020202020206C5F726574203D206C5F72657420262620636865636B436F6E646974696F6E286C5F73';
wwv_flow_imp.g_varchar2_table(837) := '6368656D61293B0A20202020202020207D0A2020202020207D20200A202020207D0A0A202020206966286C5F72657420262620736368656D612E6E6F74297B20202F2F206E6F7420697320646566696E656420616E6420616E206F626A656374200A2020';
wwv_flow_imp.g_varchar2_table(838) := '202020206C5F726574203D2028747970656F6620736368656D612E6E6F74203D3D20276F626A65637427293B2020200A2020202020206C5F726574203D206C5F72657420262620636865636B436F6E646974696F6E28736368656D612E6E6F74293B200A';
wwv_flow_imp.g_varchar2_table(839) := '202020207D0A202020200A202020206966286C5F72657420262620736368656D612E7265717569726564297B20202F2F20726571756972656420697320646566696E656420616E6420616E206172726179200A2020202020206C5F726574203D20284172';
wwv_flow_imp.g_varchar2_table(840) := '7261792E6973417272617928736368656D612E726571756972656429293B2020200A202020207D0A0A202020206966286C5F72657420262620736368656D612E70726F70657274696573297B20202F2F206E6F7420697320646566696E656420616E6420';
wwv_flow_imp.g_varchar2_table(841) := '616E206F626A656374200A2020202020206C5F726574203D2028747970656F6620736368656D612E70726F70657274696573203D3D20276F626A65637427293B200A2020202020206C5F726574203D206C5F72657420262620636865636B436F6E646974';
wwv_flow_imp.g_varchar2_table(842) := '696F6E28736368656D612E70726F70657274696573293B20200A202020207D0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E636865636B436F6E646974696F6E222C206C5F726574293B0A2020202072657475';
wwv_flow_imp.g_varchar2_table(843) := '726E206C5F7265743B0A20207D0A0A20202F2A0A2020202A2067656E657261746520554920666F7220636F6E646974696F6E616C20736368656D6120776974682069662F7468656E2F656C73650A2020202A2072657475726E73207B6974656D733A302C';
wwv_flow_imp.g_varchar2_table(844) := '2077726170706572747970653A2022787878222C2068746D6C3A2022787878227D200A20202A2F0A202066756E6374696F6E2067656E6572617465466F72436F6E646974696F6E616C28736368656D612C20646174612C207072656669782C206E616D65';
wwv_flow_imp.g_varchar2_table(845) := '2C207374617274656E642C20696E41727261792C206E65774974656D297B0A202020206C6574206C5F67656E657261746564203D207B6974656D733A20302C2077726170706572747970653A206E756C6C2C2068746D6C3A2027277D3B0A202020206170';
wwv_flow_imp.g_varchar2_table(846) := '65782E64656275672E747261636528223E3E6A736F6E526567696F6E2E67656E6572617465466F72436F6E646974696F6E616C222C20736368656D612C20646174612C207072656669782C206E616D652C20696E41727261792C207374617274656E6429';
wwv_flow_imp.g_varchar2_table(847) := '3B0A0A20202020696628747970656F6620736368656D612E6966203D3D20276F626A65637427297B20202F2F207468657265206973206120636F6E646974696F6E616C20736368656D610A2020202020202F2F2055492069732067656E65726174656420';
wwv_flow_imp.g_varchar2_table(848) := '666F72205448454E20616E6420454C53452C2073657420746F2068696464656E20646570656E64696E67206F6E2069662D636C617573650A202020202020696628636865636B436F6E646974696F6E28736368656D612E696629297B0A20202020202020';
wwv_flow_imp.g_varchar2_table(849) := '20696628736368656D612E7468656E297B0A20202020202020202020696628736368656D612E7468656E2E70726F70657274696573297B0A202020202020202020202020666F72286C6574205B6C5F6E616D652C206C5F736368656D615D206F66204F62';
wwv_flow_imp.g_varchar2_table(850) := '6A6563742E656E747269657328736368656D612E7468656E2E70726F706572746965737C7C7B7D29297B0A20202020202020202020202020206C6574206C5F67656E203D2067656E6572617465466F724F626A656374286C5F736368656D612C20646174';
wwv_flow_imp.g_varchar2_table(851) := '615B6C5F6E616D655D2C20287072656669783F7072656669782B435F44454C494D495445523A2727292B6E616D652C206C5F6E616D652C207374617274656E642C2066616C73652C2066616C73652C206E65774974656D293B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(852) := '202020206C5F67656E6572617465642E68746D6C202B3D206C5F67656E2E68746D6C3B0A2020202020202020202020207D0A202020202020202020207D0A20202020202020207D0A0A2020202020202020696628736368656D612E656C7365297B20202F';
wwv_flow_imp.g_varchar2_table(853) := '2F207769746820656C73650A20202020202020202020696628736368656D612E656C73652E70726F70657274696573297B0A202020202020202020202020666F72286C6574205B6C5F6E616D652C206C5F736368656D615D206F66204F626A6563742E65';
wwv_flow_imp.g_varchar2_table(854) := '6E747269657328736368656D612E656C73652E70726F706572746965737C7C7B7D29297B0A20202020202020202020202020206C6574206C5F67656E203D2067656E6572617465466F724F626A656374286C5F736368656D612C20646174615B6C5F6E61';
wwv_flow_imp.g_varchar2_table(855) := '6D655D2C20287072656669783F7072656669782B435F44454C494D495445523A2727292B6E616D652C206C5F6E616D652C207374617274656E642C2066616C73652C2066616C73652C206E65774974656D293B0A20202020202020202020202020206C5F';
wwv_flow_imp.g_varchar2_table(856) := '67656E6572617465642E68746D6C202B3D206C5F67656E2E68746D6C3B0A2020202020202020202020207D0A202020202020202020207D0A20202020202020207D0A2020202020207D20656C7365207B0A20202020202020206C6F67536368656D614572';
wwv_flow_imp.g_varchar2_table(857) := '726F722827696E76616C696420636F6E646974696F6E272C20736368656D612E69662920200A2020202020207D0A202020207D0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E67656E6572617465466F72436F';
wwv_flow_imp.g_varchar2_table(858) := '6E646974696F6E616C222C206C5F67656E657261746564293B200A2020202072657475726E286C5F67656E657261746564293B0A20207D0A0A20202F2A0A2020202A2047656E6572617465206120736570617261746F72206C696E6520286E657720726F';
wwv_flow_imp.g_varchar2_table(859) := '772920696E2074686520415045582D55490A2020202A205768656E2061206C6162656C20697320676976656E2061646420697420746F20746865206C696E650A2020202A2054686520696420697320726571756972656420746F2073686F772F68696465';
wwv_flow_imp.g_varchar2_table(860) := '2074686520636F6E74656E74206F662074686520726F7720666F7220636F6E646974696F6E616C20736368656D610A2020202A2072657475726E73207468652068746D6C200A20202A2F0A202066756E6374696F6E2067656E6572617465536570617261';
wwv_flow_imp.g_varchar2_table(861) := '746F7228736368656D612C206C6162656C2C2069642C20696E41727261792C20627574746F6E297B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E67656E6572617465536570617261746F72222C206C616265';
wwv_flow_imp.g_varchar2_table(862) := '6C2C2069642C20696E41727261792C20627574746F6E293B200A202020206C6574206C5F68746D6C203D27273B0A2020202069662821696E4172726179202626206C6162656C29207B202020202F2F2054686572652069732061206C6162656C2C207075';
wwv_flow_imp.g_varchar2_table(863) := '742061206C696E6520776974682074686520746578740A2020202020206C5F68746D6C202B3D20600A3C2F6469763E0A3C64697620636C6173733D22726F77206A736F6E726567696F6E223E0A20203C64697620636C6173733D22742D526567696F6E2D';
wwv_flow_imp.g_varchar2_table(864) := '686561646572223E0A202020203C64697620636C6173733D22742D526567696F6E2D6865616465724974656D7320742D526567696F6E2D6865616465724974656D732D2D7469746C65223E0A2020202020203C683220636C6173733D22742D526567696F';
wwv_flow_imp.g_varchar2_table(865) := '6E2D7469746C65222069643D22234944235F68656164696E672220646174612D617065782D68656164696E673D22223E234C4142454C233C2F68323E0A202020203C2F6469763E0A20603B0A202020207D0A200A20202020696628627574746F6E202626';
wwv_flow_imp.g_varchar2_table(866) := '20736368656D612E617065782E686173496E7365727420213D20276E6F6E6527297B20202F2F200A2020202020206C5F68746D6C202B3D20600A202020203C64697620636C6173733D22742D526567696F6E2D6865616465724974656D7320742D526567';
wwv_flow_imp.g_varchar2_table(867) := '696F6E2D6865616465724974656D732D2D627574746F6E73223E0A2020202020203C627574746F6E2069643D22234944235F4352454154452220747970653D22627574746F6E2220636C6173733D22742D427574746F6E20742D427574746F6E2D2D6E6F';
wwv_flow_imp.g_varchar2_table(868) := '4C6162656C20742D427574746F6E2D2D69636F6E206A732D69676E6F72654368616E6765206C746F33333135333836393834383630343539325F3022207469746C653D224372656174652220617269612D6C6162656C3D22437265617465223E0A202020';
wwv_flow_imp.g_varchar2_table(869) := '20202020203C7370616E20636C6173733D22612D49636F6E2069636F6E2D69672D6164642D726F772220617269612D68696464656E3D2274727565223E3C2F7370616E3E0A2020202020203C2F627574746F6E3E0A202020203C2F6469763E0A20203C2F';
wwv_flow_imp.g_varchar2_table(870) := '6469763E0A603B0A202020207D20656C7365207B0A2020202020206C5F68746D6C202B3D20600A20203C2F6469763E0A603B0A202020207D0A0A202020206C5F68746D6C202B3D20600A3C2F6469763E0A3C6469762069643D22234944235F434F4E5441';
wwv_flow_imp.g_varchar2_table(871) := '494E45522220636C6173733D22726F77206A736F6E726567696F6E202343535323223E0A20603B0A0A202020206C5F68746D6C203D20617065782E7574696C2E6170706C7954656D706C617465286C5F68746D6C2C200A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(872) := '202020202020202020202020202020202020202020202020207B200A20202020202020202020202020202020202020202020202020202020202020202020202020202020706C616365686F6C646572733A207B0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(873) := '2020202020202020202020202020202020202020202020202020224C4142454C223A206C6162656C2C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020224944223A2020202069642C0A202020';
wwv_flow_imp.g_varchar2_table(874) := '20202020202020202020202020202020202020202020202020202020202020202020202020202022435353223A20202028736368656D612E747970653D3D435F4A534F4E5F4F424A454354293F28736368656D612E617065782E6373737C7C2727293A27';
wwv_flow_imp.g_varchar2_table(875) := '270A202020202020202020202020202020202020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020202020202020202020202020202020202020202020207D293B0A0A20202020617065782E64656275';
wwv_flow_imp.g_varchar2_table(876) := '672E747261636528223C3C6A736F6E526567696F6E2E67656E6572617465536570617261746F7222293B200A2020202072657475726E286C5F68746D6C293B0A20207D0A0A202066756E6374696F6E20616464417272617944656C6574654576656E7428';
wwv_flow_imp.g_varchar2_table(877) := '297B0A20202020242827627574746F6E2E6A736F6E5F726567696F6E5F64656C5F726F7727292E6F6E2827636C69636B272C2066756E6374696F6E286576297B2064656C4172726179526F7728242874686973295B305D2E6964293B207D293B0A2F2F20';
wwv_flow_imp.g_varchar2_table(878) := '202020242827627574746F6E2E67656E5F64656C6574655F6576656E7427292E72656D6F7665436C61737328293B0A20207D0A2020200A202066756E6374696F6E2067656E6572617465417272617944656C657465427574746F6E28646174616974656D';
wwv_flow_imp.g_varchar2_table(879) := '297B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E67656E6572617465417272617944656C657465427574746F6E222C20646174616974656D293B200A202020206C6574206C5F68746D6C203D20600A3C6469';
wwv_flow_imp.g_varchar2_table(880) := '7620636C6173733D22742D526567696F6E2D6865616465724974656D7320742D526567696F6E2D6865616465724974656D732D2D627574746F6E73223E0A20203C627574746F6E2069643D22234944235F44454C4554452220747970653D22627574746F';
wwv_flow_imp.g_varchar2_table(881) := '6E2220636C6173733D226A736F6E5F726567696F6E5F64656C5F726F7720742D427574746F6E20742D427574746F6E2D2D6E6F4C6162656C20742D427574746F6E2D2D69636F6E206A732D69676E6F72654368616E6765206C746F333331353338363938';
wwv_flow_imp.g_varchar2_table(882) := '34383630343539325F3022207469746C653D2244656C6574652220617269612D6C6162656C3D2244656C657465223E0A202020203C7370616E20636C6173733D22612D49636F6E2069636F6E2D69672D64656C6574652220617269612D68696464656E3D';
wwv_flow_imp.g_varchar2_table(883) := '2274727565223E3C2F7370616E3E0A20203C2F627574746F6E3E0A3C2F6469763E0A603B0A202020206C5F68746D6C203D20617065782E7574696C2E6170706C7954656D706C617465286C5F68746D6C2C207B20706C616365686F6C646572733A207B22';
wwv_flow_imp.g_varchar2_table(884) := '4944223A20646174616974656D7D207D20293B0A0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E67656E6572617465417272617944656C657465427574746F6E22293B200A2020202072657475726E206C5F68';
wwv_flow_imp.g_varchar2_table(885) := '746D6C3B0A20207D0A0A20202F2A0A2020202A2067656E657261746520666F722061207461656D706C6174652074686520636C617373657320666F7220737461636B6C65642C20666C6F6174696E672C2072656C2D636F6C2C2068696464656E0A202020';
wwv_flow_imp.g_varchar2_table(886) := '2A2052657475726E73203A7B636F6E7461696E65723A2027616161272C206C6162656C3A2027626262272C20696E7075743A2027636363277D0A2020202A2054686520636C617373657320666F7220746865206974656D20636F6E7461696E65722C2066';
wwv_flow_imp.g_varchar2_table(887) := '6F72206C6162656C20616E6420696E7075740A20202A2F0A202066756E6374696F6E2067656E54656D706C6174652874656D706C6174652C20636F6C77696474682C20736368656D61297B0A20202020617065782E64656275672E747261636528223E3E';
wwv_flow_imp.g_varchar2_table(888) := '6A736F6E526567696F6E2E67656E54656D706C617465222C2074656D706C6174652C20636F6C77696474682C20736368656D61293B200A202020206C6574206C5F726574203D207B7D3B0A2020202073776974636828736368656D612E617065782E7465';
wwv_flow_imp.g_varchar2_table(889) := '6D706C6174657C7C74656D706C617465297B0A202020206361736520435F415045585F54454D504C4154455F4C4142454C5F48494444454E3A0A2020202020206C5F726574203D207B0A20202020202020202020202020202020636F6E7461696E65723A';
wwv_flow_imp.g_varchar2_table(890) := '2027742D466F726D2D6669656C64436F6E7461696E65722D2D68696464656E4C6162656C2072656C2D636F6C272C0A202020202020202020202020202020206C6162656C3A2027742D466F726D2D6669656C64436F6E7461696E65722D2D68696464656E';
wwv_flow_imp.g_varchar2_table(891) := '4C6162656C20636F6C20636F6C2D32272C0A20202020202020202020202020202020696E7075743A2027636F6C20636F6C2D27202B204D6174682E6D617828312C20636F6C77696474682D32292C0A202020202020202020202020202020206869646465';
wwv_flow_imp.g_varchar2_table(892) := '6E3A2027752D56697375616C6C7948696464656E270A20202020202020202020202020207D3B20200A20202020627265616B3B200A202020206361736520435F415045585F54454D504C4154455F4C4142454C5F4C4546543A200A2020202020206C5F72';
wwv_flow_imp.g_varchar2_table(893) := '6574203D207B0A20202020202020202020202020202020636F6E7461696E65723A202772656C2D636F6C272C0A202020202020202020202020202020206C6162656C3A2027636F6C20636F6C2D32272C0A20202020202020202020202020202020696E70';
wwv_flow_imp.g_varchar2_table(894) := '75743A2027636F6C20636F6C2D27202B204D6174682E6D617828312C20636F6C77696474682D32292C0A2020202020202020202020202020202068696464656E3A2027270A20202020202020202020202020207D3B0A20202020627265616B3B0A202020';
wwv_flow_imp.g_varchar2_table(895) := '206361736520435F415045585F54454D504C4154455F4C4142454C5F41424F56453A200A2020202020206C5F726574203D207B0A20202020202020202020202020202020636F6E7461696E65723A2027742D466F726D2D6669656C64436F6E7461696E65';
wwv_flow_imp.g_varchar2_table(896) := '722D2D737461636B6564272C0A202020202020202020202020202020206C6162656C3A2027272C0A20202020202020202020202020202020696E7075743A2027272C0A2020202020202020202020202020202068696464656E3A2027270A202020202020';
wwv_flow_imp.g_varchar2_table(897) := '20202020202020207D3B0A20202020627265616B3B0A202020206361736520435F415045585F54454D504C4154455F4C4142454C5F464C4F4154494E473A200A2020202064656661756C743A200A2020202020206C5F726574203D207B0A202020202020';
wwv_flow_imp.g_varchar2_table(898) := '20202020202020202020636F6E7461696E65723A2027742D466F726D2D6669656C64436F6E7461696E65722D2D666C6F6174696E674C6162656C272C0A202020202020202020202020202020206C6162656C3A2027272C0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(899) := '20202020696E7075743A2027272C0A2020202020202020202020202020202068696464656E3A2027270A20202020202020202020202020207D3B3B0A20202020627265616B3B0A202020207D0A0A20202020617065782E64656275672E74726163652822';
wwv_flow_imp.g_varchar2_table(900) := '3C3C6A736F6E526567696F6E2E67656E54656D706C617465222C206C5F726574293B200A2020202072657475726E206C5F7265743B0A20207D0A0A20202F2A0A2020202A2067656E657261746520554920666F7220616E206F626A65637420736368656D';
wwv_flow_imp.g_varchar2_table(901) := '612C20666F6C6C6F77206E657374656420736368656D6173200A2020202A2072657475726E73207B6974656D733A302C2077726170706572747970653A2022787878222C2068746D6C3A2022787878227D0A20202A2F0A202066756E6374696F6E206765';
wwv_flow_imp.g_varchar2_table(902) := '6E6572617465466F724F626A65637428736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C20696E41727261792C2068617344656C6574652C206E65774974656D297B0A20202020736368656D612E6170657820';
wwv_flow_imp.g_varchar2_table(903) := '3D20736368656D612E61706578207C7C7B7D3B0A202020206C6574206C5F67656E657261746564203D207B6974656D733A20302C2077726170706572747970653A206E756C6C2C2068746D6C3A2027277D3B0A0A20202020617065782E64656275672E74';
wwv_flow_imp.g_varchar2_table(904) := '7261636528223E3E6A736F6E526567696F6E2E67656E6572617465466F724F626A656374222C20736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C20696E41727261792C2068617344656C6574652C206E6577';
wwv_flow_imp.g_varchar2_table(905) := '4974656D293B0A0A202020206966282827272B6E616D65292E7374617274735769746828275F2729297B2020202F2F2069676E6F72652070726F7065727469657320686176696E67206E616D6573207374617274696E67207769746820225F220A202020';
wwv_flow_imp.g_varchar2_table(906) := '2020202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E67656E6572617465466F724F626A656374222C206C5F67656E657261746564293B0A202020202020202072657475726E206C5F67656E6572617465643B0A2020';
wwv_flow_imp.g_varchar2_table(907) := '20207D0A0A2020202073776974636828736368656D612E74797065297B0A20202020202020206361736520226172726179223A0A202020202020202020206C5F67656E657261746564203D2067656E6572617465466F72417272617928736368656D612C';
wwv_flow_imp.g_varchar2_table(908) := '20646174612C20287072656669783F7072656669782B435F44454C494D495445523A2727292B6E616D652C206E616D652C207374617274656E642C20747275652C20736368656D612E617065782E68617344656C6574652C206E65774974656D293B0A20';
wwv_flow_imp.g_varchar2_table(909) := '20202020202020627265616B3B0A20202020202020206361736520226F626A656374223A202F2F20616E206F626A6563742C20736F2067656E657261746520616C6C206F66206974732070726F706572746965730A202020202020202020206461746120';
wwv_flow_imp.g_varchar2_table(910) := '3D2064617461207C7C277B7D273B0A20202020202020202020696628704F7074696F6E732E68656164657273297B0A2020202020202020202020206C5F67656E6572617465642E68746D6C203D2067656E6572617465536570617261746F722873636865';
wwv_flow_imp.g_varchar2_table(911) := '6D612C2067656E65726174654C6162656C286E616D652C20736368656D61292C2067656E4974656D6E616D65287072656669782C206E616D65292C20696E41727261792C206E756C6C293B0A202020202020202020207D0A20202020202020202020666F';
wwv_flow_imp.g_varchar2_table(912) := '72286C6574205B6C5F6E616D652C206C5F736368656D615D206F66204F626A6563742E656E747269657328736368656D612E70726F706572746965737C7C7B7D29297B0A2020202020202020202020207374617274656E64203D20303B202F2F6C5F726F';
wwv_flow_imp.g_varchar2_table(913) := '773D3D313F2D313A286C5F726F773E3D4F626A6563742E6B65797328736368656D612E70726F70657274696573292E6C656E6774683F313A30293B0A2020202020202020202020206C6574206C5F67656E203D2067656E6572617465466F724F626A6563';
wwv_flow_imp.g_varchar2_table(914) := '74286C5F736368656D612C20646174615B6C5F6E616D655D2C20287072656669783F7072656669782B435F44454C494D495445523A2727292B6E616D652C206C5F6E616D652C207374617274656E642C2066616C73652C2066616C73652C206E65774974';
wwv_flow_imp.g_varchar2_table(915) := '656D293B0A2020202020202020202020206C5F67656E6572617465642E68746D6C202B3D206C5F67656E2E68746D6C3B0A2020202020202020202020206C5F67656E6572617465642E6974656D73202B3D206C5F67656E2E6974656D733B0A2020202020';
wwv_flow_imp.g_varchar2_table(916) := '20202020207D0A0A202020202020202020207B0A2020202020202020202020206C6574206C5F67656E203D2067656E6572617465466F72436F6E646974696F6E616C28736368656D612C20646174612C207072656669782C206E616D652C207374617274';
wwv_flow_imp.g_varchar2_table(917) := '656E642C20696E41727261792C206E65774974656D293B0A2020202020202020202020206C5F67656E6572617465642E68746D6C202B3D206C5F67656E2E68746D6C3B0A2020202020202020202020206C5F67656E6572617465642E6974656D73202B3D';
wwv_flow_imp.g_varchar2_table(918) := '206C5F67656E2E6974656D733B0A202020202020202020207D0A0A20202020202020202020696628696E41727261792026262068617344656C657465297B0A2020202020202020202020206C5F67656E6572617465642E68746D6C202B3D2067656E6572';
wwv_flow_imp.g_varchar2_table(919) := '617465417272617944656C657465427574746F6E2867656E4974656D6E616D65287072656669782C206E616D6529293B0A202020202020202020207D0A2020202020202020627265616B3B0A20202020202020206361736520435F4A534F4E5F53545249';
wwv_flow_imp.g_varchar2_table(920) := '4E473A0A202020202020202020206C5F67656E657261746564203D2067656E6572617465466F72537472696E6728736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C206E65774974656D293B0A202020202020';
wwv_flow_imp.g_varchar2_table(921) := '2020627265616B3B0A0A20202020202020206361736520435F4A534F4E5F494E54454745523A0A20202020202020206361736520435F4A534F4E5F4E554D4245523A0A202020202020202020206C5F67656E657261746564203D2067656E657261746546';
wwv_flow_imp.g_varchar2_table(922) := '6F724E756D6572696328736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C206E65774974656D293B0A2020202020202020627265616B3B0A20202020202020206361736520435F4A534F4E5F424F4F4C45414E';
wwv_flow_imp.g_varchar2_table(923) := '3A0A202020202020202020206C5F67656E657261746564203D2067656E6572617465466F72426F6F6C65616E28736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C206E65774974656D293B0A20202020202020';
wwv_flow_imp.g_varchar2_table(924) := '20627265616B3B0A20202020202020206361736520756E646566696E65643A20202F2F206E6F20747970652C20736F20646F206E6F7468696E670A2020202020202020202069662821435F4A534F4E5F434F4E535420696E20736368656D61297B202F2F';
wwv_flow_imp.g_varchar2_table(925) := '206120636F6E737420646F65736E2774206E656564206120747970650A2020202020202020202020206C6F67536368656D614572726F72282722747970652220697320756E646566696E656427293B0A202020202020202020207D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(926) := '627265616B0A20202020202020206361736520276E756C6C273A0A2020202020202020627265616B3B202020200A202020202020202064656661756C743A0A202020202020202020206C6F67536368656D614572726F7228272274797065223A206E6F74';
wwv_flow_imp.g_varchar2_table(927) := '20696D706C656D656E746564272C20736368656D612E74797065293B0A2020202020202020627265616B3B0A2020202020207D0A0A2020202020206966286C5F67656E6572617465642E7772617070657274797065297B202F2F20696E70757420697465';
wwv_flow_imp.g_varchar2_table(928) := '6D732069732067656E6572617465640A20202020202020206C6574206C6162656C203D2067656E65726174654C6162656C286E616D652C20736368656D61293B0A20202020202020206C6574206C5F6572726F72203D2027273B0A202020202020202069';
wwv_flow_imp.g_varchar2_table(929) := '6628704F7074696F6E732E617065785F76657273696F6E3E3D435F415045585F56455253494F4E5F3232303129207B200A202020202020202020206C5F6572726F72203D20600A3C64697620636C6173733D22742D466F726D2D6974656D417373697374';
wwv_flow_imp.g_varchar2_table(930) := '616E6365223E0A20203C7370616E2069643D22234944235F6572726F725F706C616365686F6C6465722220636C6173733D22612D466F726D2D6572726F7220752D76697369626C652220646174612D74656D706C6174652D69643D22234441544154454D';
wwv_flow_imp.g_varchar2_table(931) := '504C41544523223E3C2F7370616E3E0A20203C64697620636C6173733D22742D466F726D2D6974656D52657175697265642220617269612D68696464656E3D2274727565223E52657175697265643C2F6469763E0A3C2F6469763E0A60200A2020202020';
wwv_flow_imp.g_varchar2_table(932) := '2020207D20656C7365207B0A202020202020202020206C5F6572726F72203D20600A3C7370616E2069643D22234944235F6572726F725F706C616365686F6C6465722220636C6173733D22612D466F726D2D6572726F7220752D76697369626C65222064';
wwv_flow_imp.g_varchar2_table(933) := '6174612D74656D706C6174652D69643D22234441544154454D504C41544523223E3C2F7370616E3E0A603B0A20202020202020207D0A0A2020202020202020636F6E7374206C5F74656D706C617465203D2067656E54656D706C61746528704F7074696F';
wwv_flow_imp.g_varchar2_table(934) := '6E732E74656D706C6174652C20704F7074696F6E732E636F6C77696474682C20736368656D61293B0A20202020202020202F2F20636F6E736F6C652E6C6F6728646174612C20736368656D61290A20202020202020206C5F67656E657261746564203D20';
wwv_flow_imp.g_varchar2_table(935) := '7B0A202020202020202020206974656D733A202020202020206C5F67656E6572617465642E6974656D732C0A2020202020202020202077726170706572747970653A206C5F67656E6572617465642E77726170706572747970652C0A2020202020202020';
wwv_flow_imp.g_varchar2_table(936) := '202068746D6C3A2020202020202020617065782E7574696C2E6170706C7954656D706C617465280A600A20203C64697620636C6173733D22636F6C20636F6C2D23434F4C57494454482320617065782D636F6C2D6175746F2023434F4C5354415254454E';
wwv_flow_imp.g_varchar2_table(937) := '4423223E0A202020203C646976202069643D22234944235F434F4E5441494E45522220636C6173733D22742D466F726D2D6669656C64436F6E7461696E657220234649454C4454454D504C41544523202349535245515549524544232023435353232069';
wwv_flow_imp.g_varchar2_table(938) := '5F3131323931383130395F3020617065782D6974656D2D77726170706572202357524150504552545950452322203E0A2020202020203C64697620636C6173733D22742D466F726D2D6C6162656C436F6E7461696E657220234C4142454C54454D504C41';
wwv_flow_imp.g_varchar2_table(939) := '544523223E0A20202020202020203C6C6162656C20666F723D2223494423222069643D22234944235F4C4142454C2220636C6173733D22742D466F726D2D6C6162656C20234C4142454C48494444454E23223E23544F504C4142454C233C2F6C6162656C';
wwv_flow_imp.g_varchar2_table(940) := '3E0A2020202020203C2F6469763E0A2020202020203C64697620636C6173733D22742D466F726D2D696E707574436F6E7461696E65722023494E50555454454D504C41544523223E0A20202020202020203C64697620636C6173733D22742D466F726D2D';
wwv_flow_imp.g_varchar2_table(941) := '6974656D52657175697265642D6D61726B65722220617269612D68696464656E3D2274727565223E3C2F6469763E0A20202020202020203C64697620636C6173733D22742D466F726D2D6974656D57726170706572223E0A60202B206C5F67656E657261';
wwv_flow_imp.g_varchar2_table(942) := '7465642E68746D6C202B200A60200A20202020202020203C2F6469763E0A60202B206C5F6572726F7220202B20600A2020202020203C2F6469763E0A202020203C2F6469763E0A20203C2F6469763E0A602C0A2020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(943) := '202020202020202020202020202020202020207B20706C616365686F6C646572733A207B225752415050455254595045223A20206C5F67656E6572617465642E77726170706572747970652C0A2020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(944) := '20202020202020202020202020202020202020202020202020202020202022434F4C5749445448223A202020202028736368656D612E617065782E636F6C5370616E3F736368656D612E617065782E636F6C5370616E3A704F7074696F6E732E636F6C77';
wwv_flow_imp.g_varchar2_table(945) := '69647468292C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022524F5753223A20202020202020202028736368656D612E617065782E6C696E65733F736368656D';
wwv_flow_imp.g_varchar2_table(946) := '612E617065782E6C696E65733A35292C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022434F4C5354415254454E44223A20207374617274656E643C303F27636F';
wwv_flow_imp.g_varchar2_table(947) := '6C2D7374617274273A287374617274656E643E303F27636F6C2D656E64273A2727292C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020224944223A202020202020';
wwv_flow_imp.g_varchar2_table(948) := '202020202067656E4974656D6E616D65287072656669782C206E616D65292C200A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020224E414D45223A20202020202020';
wwv_flow_imp.g_varchar2_table(949) := '202067656E4974656D6E616D65287072656669782C206E616D65292C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020224C4142454C223A20202020202020206C61';
wwv_flow_imp.g_varchar2_table(950) := '62656C2C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020225445585443415345223A202020202020736368656D612E617065782E74657874636173653F27646174';
wwv_flow_imp.g_varchar2_table(951) := '612D746578742D636173653D2227202B202827272B20736368656D612E617065782E7465787463617365292E746F5570706572436173652829202B2722273A27272C0A202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(952) := '2020202020202020202020202020202020202020224649454C4454454D504C415445223A206C5F74656D706C6174652E636F6E7461696E65722C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(953) := '202020202020202020202020224C4142454C54454D504C415445223A206C5F74656D706C6174652E6C6162656C2C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(954) := '224C4142454C48494444454E223A2020206C5F74656D706C6174652E68696464656E2C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022494E50555454454D504C';
wwv_flow_imp.g_varchar2_table(955) := '415445223A206C5F74656D706C6174652E696E7075742C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022435353223A2020202020202020202020736368656D61';
wwv_flow_imp.g_varchar2_table(956) := '2E617065782E6373737C7C27272C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022414C49474E223A202020202020202063416C69676E5B736368656D612E6170';
wwv_flow_imp.g_varchar2_table(957) := '65782E616C69676E5D7C7C27272C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022524541444F4E4C59223A2020202020736368656D612E726561644F6E6C793F';
wwv_flow_imp.g_varchar2_table(958) := '2274727565223A2266616C7365222C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020225452494D535041434553223A20202027424F5448272C0A20202020202020';
wwv_flow_imp.g_varchar2_table(959) := '2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022414A41584944454E544946494552223A2070416A61784964656E7469666965722C0A20202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(960) := '20202020202020202020202020202020202020202020202020202020202020202020224441544154454D504C415445223A20704F7074696F6E732E6461746174656D706C61746545542C0A20202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(961) := '2020202020202020202020202020202020202020202020202020202022504C414345484F4C444552223A2020736368656D612E617065782E706C616365686F6C6465723F27706C616365686F6C6465723D22272B736368656D612E617065782E706C6163';
wwv_flow_imp.g_varchar2_table(962) := '65686F6C6465722B2722273A27272C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022464F524D4154223A20202020202020736368656D612E617065782E666F72';
wwv_flow_imp.g_varchar2_table(963) := '6D61747C7C27272C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020224558414D504C45223A202020202020285B435F4A534F4E5F464F524D41545F444154452C20';
wwv_flow_imp.g_varchar2_table(964) := '435F4A534F4E5F464F524D41545F4441544554494D452C20435F4A534F4E5F464F524D41545F54494D455D2E696E636C7564657328736368656D612E666F726D6174293F6A736F6E56616C7565324974656D28736368656D612C206E6577204461746528';
wwv_flow_imp.g_varchar2_table(965) := '292E746F49534F537472696E6728292C206E65774974656D293A2727292C200A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020224D494E4C454E475448223A202020';
wwv_flow_imp.g_varchar2_table(966) := '20736368656D612E6D696E4C656E6774683F276D696E6C656E6774683D27202B20736368656D612E6D696E4C656E6774683A27272C0A20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(967) := '20202020202020224D41584C454E475448223A20202020736368656D612E6D61784C656E6774683F276D61786C656E6774683D27202B20736368656D612E6D61784C656E6774683A27272C0A202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(968) := '202020202020202020202020202020202020202020202020202020202022544F504C4142454C223A202020202028736368656D612E747970653D3D20435F4A534F4E5F424F4F4C45414E2026262021285B435F415045585F53454C4543542C20435F4150';
wwv_flow_imp.g_varchar2_table(969) := '45585F524144494F2C20435F415045585F5357495443485D2E696E636C7564657328736368656D612E617065782E6974656D747970652929293F22223A6C6162656C2C0A2020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(970) := '20202020202020202020202020202020202020202022434845434B4544223A202020202020736368656D612E747970653D3D20435F4A534F4E5F424F4F4C45414E20262620646174613F22636865636B6564223A22222C0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(971) := '2020202020202020202020202020202020202020202020202020202020202020202020202020202020225041545445524E223A202020202020736368656D612E7061747465726E3F277061747465726E3D22272B736368656D612E7061747465726E2B27';
wwv_flow_imp.g_varchar2_table(972) := '22273A22222C20200A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020225245515549524544223A2020202020736368656D612E697352657175697265643F27726571';
wwv_flow_imp.g_varchar2_table(973) := '75697265643D2222273A22222C0A20202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202249535245515549524544223A202020736368656D612E69735265717569726564';
wwv_flow_imp.g_varchar2_table(974) := '3F2769732D7265717569726564273A22222C0A2020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020224D494E223A2020202020202020202028226D696E696D756D222069';
wwv_flow_imp.g_varchar2_table(975) := '6E20736368656D61293F285B435F4A534F4E5F464F524D41545F444154452C20435F4A534F4E5F464F524D41545F4441544554494D452C20435F4A534F4E5F464F524D41545F54494D455D2E696E636C7564657328736368656D612E666F726D6174293F';
wwv_flow_imp.g_varchar2_table(976) := '276D696E273A27646174612D6D696E27292B273D22272B736368656D612E6D696E696D756D2B2722273A22222C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022';
wwv_flow_imp.g_varchar2_table(977) := '4D4158223A2020202020202020202028226D6178696D756D2220696E20736368656D61293F285B435F4A534F4E5F464F524D41545F444154452C20435F4A534F4E5F464F524D41545F4441544554494D452C20435F4A534F4E5F464F524D41545F54494D';
wwv_flow_imp.g_varchar2_table(978) := '455D2E696E636C7564657328736368656D612E666F726D6174293F276D6178273A27646174612D6D617827292B20273D22272B736368656D612E6D6178696D756D2B2722273A22222C0A2020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(979) := '2020202020202020202020202020202020202020202020202020202256414C5545223A20202020202020206A736F6E56616C7565324974656D28736368656D612C20646174612C206E65774974656D297C7C27272C0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(980) := '2020202020202020202020202020202020202020202020202020202020202020202020202020202251554F544556414C5545223A20202028736368656D612E747970653D3D20435F4A534F4E5F535452494E472026262064617461293F617065782E7574';
wwv_flow_imp.g_varchar2_table(981) := '696C2E65736361706548544D4C2827272B64617461293A28646174613F646174613A2727292C0A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202022494D414745223A';
wwv_flow_imp.g_varchar2_table(982) := '2020202020202020736368656D612E617065782E696D6167657C7C22220A202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(983) := '20202020202020202020202020202020202020207D290A20202020202020207D3B0A202020207D0A0A2020202069662828736368656D612E617065782E746578744265666F7265207C7C20736368656D612E617065782E6E6577526F772929207B202F2F';
wwv_flow_imp.g_varchar2_table(984) := '2063757272656E74206669656C642073686F756C642073746172742061742061206E657720726F770A2020202020206C5F67656E6572617465642E68746D6C203D2067656E6572617465536570617261746F7228736368656D612C20736368656D612E61';
wwv_flow_imp.g_varchar2_table(985) := '7065782E746578744265666F72652C20707265666978202B20275F4F424A272C20696E41727261792C206E756C6C29202B206C5F67656E6572617465642E68746D6C3B0A202020207D0A0A20202020696628696E4172726179202626206C5F67656E6572';
wwv_flow_imp.g_varchar2_table(986) := '617465642E6974656D733D3D31297B202F2F2074686973206F626A6563742069732067656E65726174656420696E7369646520616E2061727261792C20736F20616464206F626A6563742072656C617465642068746D6C206172726F756E647D0A202020';
wwv_flow_imp.g_varchar2_table(987) := '202020696628704F7074696F6E732E68656164657273297B0A20202020202020206C5F67656E6572617465642E68746D6C203D2067656E6572617465536570617261746F7228736368656D612C2067656E65726174654C6162656C286E616D652C207363';
wwv_flow_imp.g_varchar2_table(988) := '68656D61292C2067656E4974656D6E616D65287072656669782C206E616D65292C20696E41727261792C206E756C6C29202B206C5F67656E6572617465642E68746D6C3B0A2020202020207D0A20202020202069662868617344656C657465297B0A2020';
wwv_flow_imp.g_varchar2_table(989) := '2020202020206C5F67656E6572617465642E68746D6C202B3D2067656E6572617465417272617944656C657465427574746F6E2867656E4974656D6E616D65287072656669782C206E616D6529293B0A2020202020207D0A202020207D0A202020206170';
wwv_flow_imp.g_varchar2_table(990) := '65782E64656275672E747261636528223C3C6A736F6E526567696F6E2E67656E6572617465466F724F626A656374222C206C5F67656E657261746564293B0A2020202072657475726E286C5F67656E657261746564293B0A20207D0A0A20202F2A0A2020';
wwv_flow_imp.g_varchar2_table(991) := '202A0A20202A2F0A202066756E6374696F6E2067656E6572617465526567696F6E28736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C20696E41727261792C206E65774974656D297B0A20202020617065782E';
wwv_flow_imp.g_varchar2_table(992) := '64656275672E747261636528223E3E6A736F6E526567696F6E2E67656E6572617465526567696F6E222C20736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C20696E41727261792C206E65774974656D293B0A';
wwv_flow_imp.g_varchar2_table(993) := '202020206C6574206C5F67656E657261746564203D2067656E6572617465466F724F626A65637428736368656D612C20646174612C207072656669782C206E616D652C207374617274656E642C20696E41727261792C2066616C73652C206E6577497465';
wwv_flow_imp.g_varchar2_table(994) := '6D293B0A202020206C5F67656E6572617465642E68746D6C203D20600A3C64697620636C6173733D22726F77206A736F6E726567696F6E223E0A60202B206C5F67656E6572617465642E68746D6C202B20600A3C2F6469763E603B0A2020202061706578';
wwv_flow_imp.g_varchar2_table(995) := '2E64656275672E747261636528223C3C6A736F6E526567696F6E2E67656E6572617465526567696F6E222C206C5F67656E657261746564293B0A2020202072657475726E286C5F67656E657261746564293B0A20207D0A20202F2A0A2020202A20676574';
wwv_flow_imp.g_varchar2_table(996) := '20612066696C65207769746820616E20414A41582D726571756573742072657475726E20612070726F6D6973650A20202A2F0A202066756E6374696F6E2067657446696C6528747970652C2073726329207B0A2020202072657475726E206E6577205072';
wwv_flow_imp.g_varchar2_table(997) := '6F6D6973652866756E6374696F6E287265736F6C76652C2072656A65637429207B0A202020202020617065782E64656275672E747261636528276C6F61642066696C6520282573293A2022257322272C20747970652C20737263293B0A20202020202063';
wwv_flow_imp.g_varchar2_table(998) := '6F6E73742073203D20646F63756D656E742E637265617465456C656D656E7428634D6170547970655B747970655D2E746167293B0A2020202020206C65742072203D2066616C73653B0A202020202020732E74797065203D20634D6170547970655B7479';
wwv_flow_imp.g_varchar2_table(999) := '70655D2E747970653B0A202020202020735B634D6170547970655B747970655D2E617474725D203D207372633B0A202020202020732E72656C203D20634D6170547970655B747970655D2E72656C3B0A202020202020732E6173796E63203D2066616C73';
wwv_flow_imp.g_varchar2_table(1000) := '653B0A202020202020732E6F6E6572726F72203D2066756E6374696F6E2865727229207B0A202020202020202072656A656374286572722C2073293B0A2020202020207D3B0A0A202020202020732E6F6E6C6F6164203D20732E6F6E7265616479737461';
wwv_flow_imp.g_varchar2_table(1001) := '74656368616E6765203D2066756E6374696F6E2829207B0A2020202020202020696620282172202626202821746869732E72656164795374617465207C7C20746869732E72656164795374617465203D3D2027636F6D706C657465272929207B0A202020';
wwv_flow_imp.g_varchar2_table(1002) := '2020202020202072203D20747275653B0A202020202020202020207265736F6C766528293B0A20202020202020207D20656C7365207B0A2020202020202020202072656A656374286E756C6C2C2073293B0A20202020202020207D0A2020202020207D3B';
wwv_flow_imp.g_varchar2_table(1003) := '0A2020202020202F2F20617070656E64207363726970742074616720746F20626F64792C20736F2066696C652077696C6C206265206C6F6164656420696E206261636B67726F756E640A202020202020646F63756D656E742E626F64792E617070656E64';
wwv_flow_imp.g_varchar2_table(1004) := '4368696C642873293B0A202020207D293B0A20207D0A0A0A20202F2A0A2020202A206C6F616420616C6C2066696C65732066726F6D206C6973742066696C656E616D65732072656C617469766520746F2062617365506174680A20202A2F0A202066756E';
wwv_flow_imp.g_varchar2_table(1005) := '6374696F6E2067657446696C6573202866696C656E616D65732C20626173655061746829207B0A20202020766172206C5F617272203D20242E6D61702866696C656E616D65732C2066756E6374696F6E2866696C6529207B0A2020202020202020726574';
wwv_flow_imp.g_varchar2_table(1006) := '75726E2067657446696C6528202866696C652E656E64735769746828222E6A7322293F27736372697074273A2763737327292C202862617365506174687C7C222229202B2066696C6520293B0A202020207D293B0A20202020202020200A202020206C5F';
wwv_flow_imp.g_varchar2_table(1007) := '6172722E7075736828242E44656665727265642866756E6374696F6E2820646566657272656420297B0A202020202020202024282064656665727265642E7265736F6C766520293B0A202020207D29293B0A20202020202020200A202020207265747572';
wwv_flow_imp.g_varchar2_table(1008) := '6E20242E7768656E2E6170706C7928242C206C5F617272293B0A20207D0A0A20202F2F206C6F616420746865206F7261636C656A657420666F7220646174652D7069636B657220666F722041504558203C3D32322E310A202066756E6374696F6E206C6F';
wwv_flow_imp.g_varchar2_table(1009) := '6164526571756972656446696C6573323231286974656D7479706573297B0A202020206C6574206C5F68746D6C203D27273B0A20202020617065782E64656275672E747261636528273E3E6A736F6E526567696F6E2E6C6F616452657175697265644669';
wwv_flow_imp.g_varchar2_table(1010) := '6C6573323231272C206974656D7479706573293B0A202020206966286974656D74797065732E666F726D61742E64617465207C7C206974656D74797065732E666F726D61745B22646174652D74696D65225D297B20202F2F4841434B20666F7220415045';
wwv_flow_imp.g_varchar2_table(1011) := '58203C32322E322C206865726520616E206F6C6420646174657069636B657220697320757365640A2020202020206C5F68746D6C202B3D20273C736372697074207372633D2227202B20704F7074696F6E732E617065785F66696C6573202B20276C6962';
wwv_flow_imp.g_varchar2_table(1012) := '7261726965732F617065782F6D696E69666965642F6A6574436F6D6D6F6E42756E646C652E6D696E2E6A73223E3C2F7363726970743E273B0A202020202020696628704F7074696F6E732E617065785F76657273696F6E3E3D435F415045585F56455253';
wwv_flow_imp.g_varchar2_table(1013) := '494F4E5F32323031297B202F2F2061706578203C32322E3120686173206576656E206F6C64657220646174657069636B65720A20202020202020206C5F68746D6C202B3D20273C736372697074207372633D2227202B20704F7074696F6E732E61706578';
wwv_flow_imp.g_varchar2_table(1014) := '5F66696C6573202B20276C69627261726965732F617065782F6D696E69666965642F6A6574446174655069636B657242756E646C652E6D696E2E6A73223E3C2F7363726970743E273B0A2020202020207D0A202020207D0A20202020617065782E646562';
wwv_flow_imp.g_varchar2_table(1015) := '75672E747261636528273C3C6A736F6E526567696F6E2E6C6F6164526571756972656446696C6573323231272C206C5F68746D6C293B0A2020202072657475726E206C5F68746D6C3B0A20207D0A0A20202F2A0A2020202A206275696C642061206C6973';
wwv_flow_imp.g_varchar2_table(1016) := '74206F6620616C6C206D697373696E672066696C65732072657175697265642062792075736564207769676574732F6974656D73206C696B6520726963687478742D656469746F722C202E2E2E200A2020202A204C6F64207468652066696C6573207669';
wwv_flow_imp.g_varchar2_table(1017) := '6120616A61780A20202A2F0A20206173796E632066756E6374696F6E206C6F6164526571756972656446696C6573286974656D747970657329207B0A2020202020202F2F206765742075736564206974656D74797065730A20202020617065782E646562';
wwv_flow_imp.g_varchar2_table(1018) := '75672E747261636528223E3E6A736F6E526567696F6E2E6C6F6164526571756972656446696C6573222C206974656D7479706573293B0A202020206C6574206C5F73637269707473203D205B5D3B0A0A20202020696628704F7074696F6E732E61706578';
wwv_flow_imp.g_varchar2_table(1019) := '5F76657273696F6E203E3D435F415045585F56455253494F4E5F32333032297B20202F2F206E6577204665617475727320666F722032332E320A20202020202069662821637573746F6D456C656D656E74732E6765742827612D636F6D626F626F782729';
wwv_flow_imp.g_varchar2_table(1020) := '20202626206974656D74797065732E6974656D747970652E636F6D626F626F78297B202F2F20636F6D626F626F7820697320757365642C20736F206C6F61642066696C657320666F72206E657720636F6D626F626F780A20202020202020206C5F736372';
wwv_flow_imp.g_varchar2_table(1021) := '697074732E7075736828276C69627261726965732F617065782F6D696E69666965642F6974656D2E436F6D626F626F782E6D696E2E6A7327293B0A2020202020207D0A20202020202069662821637573746F6D456C656D656E74732E6765742827612D71';
wwv_flow_imp.g_varchar2_table(1022) := '72636F6465272920202626206974656D74797065732E6974656D747970652E7172636F6465297B202F2F20636F6D626F626F7820697320757365642C20736F206C6F61642066696C657320666F72206E657720636F6D626F626F780A2020202020202020';
wwv_flow_imp.g_varchar2_table(1023) := '6C5F736372697074732E7075736828276C69627261726965732F617065782F6D696E69666965642F6974656D2E5152636F64652E6D696E2E6A7327293B0A2020202020207D0A0A2020202020206966286974656D74797065732E6974656D747970652E72';
wwv_flow_imp.g_varchar2_table(1024) := '69636874657874297B20202F2F20726963687465787420697320757365642C20736F206C6F61642066696C657320666F7220726963682D746578742D656469746F720A202020202020202069662821637573746F6D456C656D656E74732E676574282761';
wwv_flow_imp.g_varchar2_table(1025) := '2D726963682D746578742D656469746F722729297B20202F2F20437573746F6D20456C656D656E74206973206E6F7420696E207573652C206C6F61642069740A202020202020202020206C5F736372697074732E7075736828276C69627261726965732F';
wwv_flow_imp.g_varchar2_table(1026) := '74696E796D63652F27202B20617065782E6C696256657273696F6E732E74696E796D6365202B20272F736B696E732F75692F6F786964652F736B696E2E63737327293B0A202020202020202020206C5F736372697074732E7075736828276C6962726172';
wwv_flow_imp.g_varchar2_table(1027) := '6965732F74696E796D63652F27202B20617065782E6C696256657273696F6E732E74696E796D6365202B20272F74696E796D63652E6D696E2E6A7327293B0A202020202020202020206C5F736372697074732E7075736828276C69627261726965732F70';
wwv_flow_imp.g_varchar2_table(1028) := '75726966792F2720202B20617065782E6C696256657273696F6E732E646F6D507572696679202B20272F7075726966792E6D696E2E6A7327293B0A202020202020202020206C5F736372697074732E7075736828276C69627261726965732F707269736D';
wwv_flow_imp.g_varchar2_table(1029) := '6A732F27202B20617065782E6C696256657273696F6E732E707269736D4A73202B20272F707269736D2E6A7327293B0A202020202020202020206C5F736372697074732E7075736828276C69627261726965732F6D61726B65646A732F27202B20617065';
wwv_flow_imp.g_varchar2_table(1030) := '782E6C696256657273696F6E732E6D61726B65644A73202B20272F6D61726B65642E6D696E2E6A7327293B0A202020202020202020206C5F736372697074732E7075736828276C69627261726965732F7475726E646F776E2F27202B20617065782E6C69';
wwv_flow_imp.g_varchar2_table(1031) := '6256657273696F6E732E7475726E646F776E202B20272F7475726E646F776E2E6A7327293B0A202020202020202020206C5F736372697074732E7075736828276C69627261726965732F617065782F6D696E69666965642F6974656D2E52696368546578';
wwv_flow_imp.g_varchar2_table(1032) := '74456469746F722E6D696E2E6A7327293B0A20202020202020207D0A2020202020207D0A202020207D0A0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E6C6F6164526571756972656446696C657322293B0A20';
wwv_flow_imp.g_varchar2_table(1033) := '20202072657475726E2067657446696C657328206C5F736372697074732C20704F7074696F6E732E617065785F66696C6573293B0A20207D0A0A20202F2A0A2020202A2073686F7720616C6C20696E2D2F6F75747075742D6974656D7320666F72207468';
wwv_flow_imp.g_varchar2_table(1034) := '65204A534F4E2D726567696F6E0A20202A2F0A202066756E6374696F6E2073686F774669656C6473286974656D7479706573297B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E73686F774669656C64732229';
wwv_flow_imp.g_varchar2_table(1035) := '3B0A202020206C6574206C5F67656E657261746564203D2067656E6572617465526567696F6E28704F7074696F6E732E736368656D612C2067446174612C206E756C6C2C20704F7074696F6E732E646174616974656D2C20302C2066616C73652C207472';
wwv_flow_imp.g_varchar2_table(1036) := '7565293B0A202020206C6574206C5F68746D6C203D206C5F67656E6572617465642E68746D6C3B0A20202020696628704F7074696F6E732E617065785F76657273696F6E203C435F415045585F56455253494F4E5F32323032297B0A2020202020206C5F';
wwv_flow_imp.g_varchar2_table(1037) := '68746D6C202B3D206C6F6164526571756972656446696C6573323231286974656D7479706573293B0A202020207D0A20202020202020202F2F206174746163682048544D4C20746F20726567696F6E0A2020202024282223222B70526567696F6E496429';
wwv_flow_imp.g_varchar2_table(1038) := '2E68746D6C286C5F68746D6C293B0A20202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E73686F774669656C647322293B0A20207D0A0A0A20202F2A0A2020202A207265667265736820746865204A534F4E2D726567';
wwv_flow_imp.g_varchar2_table(1039) := '696F6E0A20202A2F0A20206173796E632066756E6374696F6E2072656672657368286E65774974656D29207B0A20202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E7265667265736822293B0A20202020617065782E';
wwv_flow_imp.g_varchar2_table(1040) := '64656275672E747261636528276A736F6E526567696F6E2E72656672657368272C202764617461272C206E65774974656D2C206744617461293B0A0A2020202061776169742072696368746578744861636B28293B0A2F2F20202020202020202F2F2061';
wwv_flow_imp.g_varchar2_table(1041) := '747461636820746865206669656C647320746F207468652067656E6572617465642055490A202020206174746163684F626A65637428704F7074696F6E732E646174616974656D2C2027272C20704F7074696F6E732E736368656D612C20704F7074696F';
wwv_flow_imp.g_varchar2_table(1042) := '6E732E726561646F6E6C792C2067446174612C206E65774974656D293B0A20202020616464417272617944656C6574654576656E7428293B0A20202020617065784861636B7328293B0A20202020617065782E64656275672E747261636528223C3C6A73';
wwv_flow_imp.g_varchar2_table(1043) := '6F6E526567696F6E2E7265667265736822293B0A20207D0A0A20202F2A0A2020202A2052656D6F766520616C6C2070726F7065727469657320776974682076616C7565204E554C4C20746F20636F6D70616374207468652067656E657261746564204A53';
wwv_flow_imp.g_varchar2_table(1044) := '4F4E0A20202A2F0A202066756E6374696F6E2072656D6F76654E756C6C7328646174612C20736561726368297B0A202020206966286461746129207B0A20202020202069662841727261792E69734172726179286461746129297B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(1045) := '646174612E666F72456163682866756E6374696F6E2876616C75652C20696478297B0A2020202020202020202072656D6F76654E756C6C7328646174615B6964785D2C20736561726368293B202F2F206B65657020617272617920656C656D656E74732C';
wwv_flow_imp.g_varchar2_table(1046) := '206265636175736520706F736974696F6E20636F756C64206265206D65616E696E6766756C6C0A20202020202020207D293B0A202020207D202020656C736520696628747970656F662864617461293D3D435F4A534F4E5F4F424A454354297B0A202020';
wwv_flow_imp.g_varchar2_table(1047) := '20202020204F626A6563742E6B6579732864617461292E666F72456163682866756E6374696F6E2876616C75652C20696478297B0A2020202020202020202069662872656D6F76654E756C6C7328646174615B76616C75655D2C20736561726368293D3D';
wwv_flow_imp.g_varchar2_table(1048) := '3D6E756C6C297B20202F2F2076616C7565206973206E756C6C2C20736F2072656D6F7665207468652077686F6C65206B65790A20202020202020202020202064656C65746528646174615B76616C75655D293B0A202020202020202020207D0A20202020';
wwv_flow_imp.g_varchar2_table(1049) := '202020207D293B0A2020202020202020696628214F626A6563742E6B6579732864617461292E6C656E677468297B202020202F2F204F626A65637420697320656D707479206E6F772C2072656D6F7665206974206C617465720A20202020202020202020';
wwv_flow_imp.g_varchar2_table(1050) := '646174613D6E756C6C3B0A20202020202020207D0A2020202020207D0A202020207D0A2020202072657475726E2864617461293B0A20207D0A0A20202F2A0A2020202A20636F6E7665727420646966666572656E74206461746120666F726D6174732069';
wwv_flow_imp.g_varchar2_table(1051) := '6E20746865204A534F4E2D6461746120696E746F2073696E676C6520666F726D6174730A20202A2F0A202066756E6374696F6E207265666F726D617456616C75657328736368656D612C20646174612C2072656164297B0A20202020617065782E646562';
wwv_flow_imp.g_varchar2_table(1052) := '75672E747261636528223E3E7265666F726D617456616C756573222C20736368656D61293B200A20202020696628736368656D612026262064617461297B0A20202020202073776974636828736368656D612E74797065297B0A20202020202063617365';
wwv_flow_imp.g_varchar2_table(1053) := '20226F626A656374223A0A20202020202020206966286461746120696E7374616E63656F66204F626A65637429207B0A20202020202020202020666F7228636F6E7374206C5F6B657920696E20736368656D612E70726F70657274696573297B0A202020';
wwv_flow_imp.g_varchar2_table(1054) := '20202020202020202020646174615B6C5F6B65795D203D207265666F726D617456616C75657328736368656D612E70726F706572746965735B6C5F6B65795D2C20646174615B6C5F6B65795D2C2072656164293B0A202020202020202020207D0A202020';
wwv_flow_imp.g_varchar2_table(1055) := '20202020207D20656C7365207B0A20202020202020202020617065782E64656275672E6572726F72282763616E206E6F7420646973706C617920646174613A272C20646174612C20276D75737420626520616E206F626A65637427293B0A202020202020';
wwv_flow_imp.g_varchar2_table(1056) := '20207D0A202020202020627265616B3B0A2020202020206361736520226172726179223A0A202020202020202069662841727261792E69734172726179286461746129297B0A20202020202020202020666F72287661722069203D20303B2069203C2073';
wwv_flow_imp.g_varchar2_table(1057) := '6368656D612E6974656D732E6C656E6774683B20692B2B297B0A20202020202020202020202020646174615B695D203D207265666F726D617456616C75657328736368656D612E6974656D735B695D2C20646174615B695D2C2072656164293B0A202020';
wwv_flow_imp.g_varchar2_table(1058) := '202020202020207D0A20202020202020207D20656C7365207B0A20202020202020202020617065782E64656275672E6572726F72282763616E206E6F7420646973706C617920646174613A272C20646174612C20276D75737420626520616E2061727261';
wwv_flow_imp.g_varchar2_table(1059) := '7927293B0A20202020202020207D20202020200A202020202020627265616B3B0A20202020202064656661756C743A0A202020202020627265616B3B0A2020202020207D200A0A202020202020696628736368656D612E6966297B20202F2F20636F6E64';
wwv_flow_imp.g_varchar2_table(1060) := '6974696F6E616C20736368656D612C20616464206576656E74206F6E206974656D730A2020202020202020696628736368656D612E7468656E297B200A20202020202020202020666F7228636F6E7374205B6C5F6E616D652C206C5F6974656D5D206F66';
wwv_flow_imp.g_varchar2_table(1061) := '204F626A6563742E656E747269657328736368656D612E7468656E2E70726F7065727469657329297B0A2020202020202020202020207265666F726D617456616C756573286C5F6974656D2C20646174615B6C5F6E616D655D2C2072656164293B0A2020';
wwv_flow_imp.g_varchar2_table(1062) := '20202020202020207D0A20202020202020207D0A0A2020202020202020696628736368656D612E656C7365297B200A20202020202020202020666F7228636F6E7374205B6C5F6E616D652C206C5F6974656D5D206F66204F626A6563742E656E74726965';
wwv_flow_imp.g_varchar2_table(1063) := '7328736368656D612E656C73652E70726F7065727469657329297B0A2020202020202020202020207265666F726D617456616C756573286C5F6974656D2C20646174615B6C5F6E616D655D2C2072656164293B0A202020202020202020207D0A20202020';
wwv_flow_imp.g_varchar2_table(1064) := '202020207D0A2020202020207D2020202020200A202020207D200A20202020617065782E64656275672E747261636528223C3C7265666F726D617456616C756573222C2064617461293B2020200A2020202072657475726E2864617461293B0A20207D0A';
wwv_flow_imp.g_varchar2_table(1065) := '0A20202F2A0A2020202A2061646A7573742074686520736368656D610A20202A2F0A202066756E6374696F6E2061646A7573744F7074696F6E73286F7074696F6E73297B0A202020206F7074696F6E732E736368656D61203D2020202020202020202020';
wwv_flow_imp.g_varchar2_table(1066) := '206F7074696F6E732E736368656D61207C7C207B7D3B0A202020206F7074696F6E732E736368656D612E70726F70657274696573203D206F7074696F6E732E736368656D612E70726F70657274696573207C7C207B7D3B0A202020206F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(1067) := '736368656D612E61706578203D202020202020206F7074696F6E732E736368656D612E61706578207C7C207B7D3B0A202020206F7074696F6E732E736368656D612E617065782E6C6162656C203D206F7074696F6E732E736368656D612E617065782E6C';
wwv_flow_imp.g_varchar2_table(1068) := '6162656C207C7C206E756C6C3B0A2020202072657475726E206F7074696F6E733B0A20207D0A20202F2A202D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D2D';
wwv_flow_imp.g_varchar2_table(1069) := '2D2D2D2D2D2D2D2D0A2020202A2068657265207468652066756E6374696F6E20636F6465207374617274730A20202A2F0A2020617065782E64656275672E747261636528223E3E696E69744A736F6E526567696F6E222C2070526567696F6E49642C2070';
wwv_flow_imp.g_varchar2_table(1070) := '4E616D652C2070416A61784964656E7469666965722C20704F7074696F6E73293B200A0A2020696628704F7074696F6E732E6869646529207B202F2F2068696465207468652072656C61746564204A534F4E2D6974656D0A20202020617065782E697465';
wwv_flow_imp.g_varchar2_table(1071) := '6D28704F7074696F6E732E646174616974656D292E6869646528293B0A20207D0A0A20207472797B0A20202020704F7074696F6E732E736368656D61203D204A534F4E2E706172736528704F7074696F6E732E736368656D61293B0A20207D2063617463';
wwv_flow_imp.g_varchar2_table(1072) := '68286529207B0A20202020617065782E64656275672E6572726F7228276A736F6E2D726567696F6E3A20736368656D61272C20652C20704F7074696F6E732E736368656D61293B0A20202020704F7074696F6E732E736368656D61203D207B7D3B0A2020';
wwv_flow_imp.g_varchar2_table(1073) := '7D0A0A202020202F2F2067656E657261746520746865204A534F4E2066726F6D20646174616974656D2D6669656C640A2020747279207B0A202020206744617461203D204A534F4E2E706172736528617065782E6974656D28704F7074696F6E732E6461';
wwv_flow_imp.g_varchar2_table(1074) := '74616974656D292E67657456616C756528297C7C277B7D27293B0A20207D206361746368286529207B0A20202020617065782E64656275672E6572726F7228276A736F6E2D726567696F6E3A20646174616974656D272C20704F7074696F6E732E646174';
wwv_flow_imp.g_varchar2_table(1075) := '616974656D2C20652C20704F7074696F6E732E736368656D61293B0A202020206744617461203D207B7D3B0A20207D0A0A2020617065782E64656275672E74726163652827696E69744A736F6E526567696F6E3A2064617461272C206744617461293B0A';
wwv_flow_imp.g_varchar2_table(1076) := '20206C6574206E65774974656D203D2021286744617461202626204F626A6563742E6B657973286744617461292E6C656E677468293B0A0A2020696628704F7074696F6E732E67656E6572617465536368656D61297B20202F2F2067656E657261746520';
wwv_flow_imp.g_varchar2_table(1077) := '4A534F4E2D736368656D61206261736564206F6E204A534F4E2D646174610A202020206C6574206C5F736368656D61203D7B7D3B0A202020206C5F736368656D61203D2067656E6572617465536368656D61286C5F736368656D612C2067446174617C7C';
wwv_flow_imp.g_varchar2_table(1078) := '7B7D293B0A20202020636F6E736F6C652E696E666F28272B2B2B4A534F4E2D736368656D612B2B2B272C204A534F4E2E737472696E67696679286C5F736368656D6129293B0A20202020704F7074696F6E732E736368656D61203D206C5F736368656D61';
wwv_flow_imp.g_varchar2_table(1079) := '3B0A20207D0A0A2020704F7074696F6E73203D2061646A7573744F7074696F6E7328704F7074696F6E73293B0A0A202020202F2F207265736F6C766520616C6C2024726566730A2020704F7074696F6E732E736368656D61203D2070726F706167617465';
wwv_flow_imp.g_varchar2_table(1080) := '5265667328704F7074696F6E732E736368656D61293B0A202070726F70616761746550726F7065727469657328704F7074696F6E732E736368656D612C20302C20704F7074696F6E732E726561646F6E6C792C2066616C73652C20704F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(1081) := '6B656570417474726962757465732C2066616C7365293B0A0A202020202F2F2061646A75737420646966666572656E63657320696E200A20206744617461203D207265666F726D617456616C75657328704F7074696F6E732E736368656D612C20674461';
wwv_flow_imp.g_varchar2_table(1082) := '74612C2074727565293B0A0A202020202F2F2073686F77207468652055492D6669656C64730A0A20206C6574206C5F6974656D7479706573203D206E756C6C3B0A20206C5F6974656D7479706573203D206765744974656D747970657328704F7074696F';
wwv_flow_imp.g_varchar2_table(1083) := '6E732E736368656D612C206C5F6974656D7479706573293B0A0A202073686F774669656C6473286C5F6974656D7479706573293B200A20200A202020202F2F207374617274206865726520616C6C207374756666207769686963682072756E7320617379';
wwv_flow_imp.g_varchar2_table(1084) := '6E630A2020286173796E632066756E6374696F6E28297B0A20202F2A0A2020202A206372656174652074686520726567696F6E20616E64206174746163682064656661756C742068616E646C6572730A20202A2F0A2020202066756E6374696F6E206372';
wwv_flow_imp.g_varchar2_table(1085) := '65617465526567696F6E28297B0A202020202020617065782E64656275672E747261636528223E3E637265617465526567696F6E22293B0A2020202020202F2F2069662072656167696F6E20616C7265616479206578697374732064657374726F792069';
wwv_flow_imp.g_varchar2_table(1086) := '742066697273740A202020202020696628617065782E726567696F6E2E6973526567696F6E2870526567696F6E49642929207B0A2020202020202020617065782E64656275672E7472616365282744455354524F5920524547494F4E272C207052656769';
wwv_flow_imp.g_varchar2_table(1087) := '6F6E4964293B0A2020202020202020617065782E726567696F6E2E64657374726F792870526567696F6E4964293B0A2020202020207D0A202020202020617065782E726567696F6E2E637265617465282070526567696F6E49642C2063616C6C6261636B';
wwv_flow_imp.g_varchar2_table(1088) := '73293B0A202020202020617065782E6974656D2E617474616368282428272327202B2070526567696F6E496429293B0A202020202020617065782E64656275672E747261636528223C3C637265617465526567696F6E22293B2020200A202020207D0A0A';
wwv_flow_imp.g_varchar2_table(1089) := '20202020617065782E64656275672E7472616365282772657175697265642066696C6573206C6F6164696E672E2E2E27293B0A202020206177616974206C6F6164526571756972656446696C6573286C5F6974656D7479706573293B0A20202020617065';
wwv_flow_imp.g_varchar2_table(1090) := '782E64656275672E7472616365282772657175697265642066696C6573206C6F6164656427293B0A2020202061776169742072656672657368286E65774974656D293B0A0A20202020636F6E73742063616C6C6261636B73203D207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(1091) := '202F2F2043616C6C6261636B20666F722072656672657368696E67206F6620746865204A534F4E2D726567696F6E2C2069732063616C6C656420627920415045582D726566726573680A202020202020726566726573683A2066756E6374696F6E282920';
wwv_flow_imp.g_varchar2_table(1092) := '7B0A2020202020202020617065782E64656275672E747261636528273E3E63616C6C6261636B2E726566726573683A20272C2070526567696F6E49642C2070416A61784964656E7469666965722C20704F7074696F6E732C206744617461293B0A202020';
wwv_flow_imp.g_varchar2_table(1093) := '2020202020696628704F7074696F6E732E697344796E616D6963297B0A2020202020202020202020617065782E7365727665722E706C7567696E2028200A20202020202020202020202070416A61784964656E7469666965722C200A2020202020202020';
wwv_flow_imp.g_varchar2_table(1094) := '202020207B20706167654974656D733A20704F7074696F6E732E71756572796974656D737D2C200A2020202020202020202020207B20737563636573733A206173796E632066756E6374696F6E2820646174612029207B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(1095) := '202020202F2F20666F7220736F6D6520726561736F6E207468652024646566732070726F70657274792069732072657475726E656420617320222464656673220A202020202020202020202020202020206C6574206C5F6E65776974656D203D21286744';
wwv_flow_imp.g_varchar2_table(1096) := '61746120262620284F626A6563742E6B657973286744617461292E6C656E6774683E3029293B0A20202020202020202020202020202020646174615B222464656673225D3D646174615B2722246465667322275D3B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(1097) := '2020617065782E64656275672E74726163652827574F524152524F554E4420246465667327293B0A20202020202020202020202020202020704F7074696F6E732E736368656D61203D20646174613B0A20202020202020202020202020202020704F7074';
wwv_flow_imp.g_varchar2_table(1098) := '696F6E73203D2061646A7573744F7074696F6E7328704F7074696F6E73293B0A20202020202020202020202020202020704F7074696F6E732E736368656D61203D2070726F7061676174655265667328704F7074696F6E732E736368656D61293B0A2020';
wwv_flow_imp.g_varchar2_table(1099) := '202020202020202020202020202070726F70616761746550726F7065727469657328704F7074696F6E732E736368656D612C20302C20704F7074696F6E732E726561646F6E6C792C2066616C73652C20704F7074696F6E732E6B65657041747472696275';
wwv_flow_imp.g_varchar2_table(1100) := '7465732C2066616C7365293B0A202020202020202020202020202020206C6574206C5F6974656D7479706573203D206E756C6C3B0A202020202020202020202020202020206C5F6974656D7479706573203D206765744974656D747970657328704F7074';
wwv_flow_imp.g_varchar2_table(1101) := '696F6E732E736368656D612C206C5F6974656D7479706573293B0A20202020202020202020202020202020617065782E64656275672E74726163652827704F7074696F6E733A272C20704F7074696F6E73293B0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(1102) := '73686F774669656C6473286C5F6974656D7479706573293B0A202020202020202020202020202020206177616974206C6F6164526571756972656446696C6573286C5F6974656D7479706573293B0A202020202020202020202020202020206177616974';
wwv_flow_imp.g_varchar2_table(1103) := '2072696368746578744861636B28293B0A202020202020202020202020202020206174746163684F626A65637428704F7074696F6E732E646174616974656D2C2027272C20704F7074696F6E732E736368656D612C20704F7074696F6E732E726561646F';
wwv_flow_imp.g_varchar2_table(1104) := '6E6C792C2067446174612C206C5F6E65776974656D293B0A20202020202020202020202020202020616464417272617944656C6574654576656E7428293B0A20202020202020202020202020202020617065784861636B7328293B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(1105) := '20202020202020207365744F626A65637456616C75657328704F7074696F6E732E646174616974656D2C2027272C20704F7074696F6E732E736368656D612C20704F7074696F6E732E726561646F6E6C792C206744617461290A20202020202020202020';
wwv_flow_imp.g_varchar2_table(1106) := '202020202020637265617465526567696F6E28293B0A20202020202020202020202020207D0A2020202020202020202020207D20200A20202020202020202020293B0A20202020202020207D0A2020202020202020617065782E64656275672E74726163';
wwv_flow_imp.g_varchar2_table(1107) := '6528273C3C63616C6C6261636B2E7265667265736827290A2020202020207D2C0A0A20202020202020202F2F2043616C6C6261636B2063616C6C6564206279206576656E742022617065786265666F7265706167657375626D6974220A20202020202062';
wwv_flow_imp.g_varchar2_table(1108) := '65666F72655375626D69743A2066756E6374696F6E2028297B0A2020202020202020617065782E64656275672E747261636528223E3E6A736F6E526567696F6E2E6265666F72655375626D6974222C2070526567696F6E49642C20704F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(1109) := '646174616974656D2C20704F7074696F6E732E736368656D61293B0A202020202020202069662821704F7074696F6E732E726561646F6E6C79297B20202F2F20646F206E6F7468696E6720666F7220726561646F6E6C79206A736F6E2D726567696F6E0A';
wwv_flow_imp.g_varchar2_table(1110) := '20202020202020202020617065782E64656275672E747261636528276A736F6E526567696F6E272C20704F7074696F6E73293B0A202020202020202020206C6574206C5F6A736F6E3D6765744F626A65637456616C75657328704F7074696F6E732E6461';
wwv_flow_imp.g_varchar2_table(1111) := '74616974656D2C2027272C20704F7074696F6E732E736368656D612C206744617461293B0A20202020202020202020696628704F7074696F6E732E72656D6F76654E756C6C73297B0A2020202020202020202020206C5F6A736F6E203D2072656D6F7665';
wwv_flow_imp.g_varchar2_table(1112) := '4E756C6C73286C5F6A736F6E293B0A202020202020202020202020617065782E64656275672E7472616365282772656D6F766564204E554C4C73272C206C5F6A736F6E293B0A202020202020202020207D0A20202020202020202020617065782E646562';
wwv_flow_imp.g_varchar2_table(1113) := '75672E7472616365282767656E657261746564204A534F4E272C206C5F6A736F6E293B0A20202020202020202020617065782E6974656D28704F7074696F6E732E646174616974656D292E73657456616C7565284A534F4E2E737472696E67696679286C';
wwv_flow_imp.g_varchar2_table(1114) := '5F6A736F6E29293B0A20202020202020207D0A2020202020202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E6265666F72655375626D697422293B0A2020202020207D2C0A0A20202020202020202F2F2043616C6C62';
wwv_flow_imp.g_varchar2_table(1115) := '61636B2063616C6C6564206279206576656E74202261706578706167657375626D6974220A2020202020207375626D69743A2066756E6374696F6E28297B0A2020202020202020617065782E64656275672E747261636528223E3E6A736F6E526567696F';
wwv_flow_imp.g_varchar2_table(1116) := '6E2E7375626D697422293B0A202020202020202020202F2F204861636B20746F2072656D6F7665207468652064796E616D6963616C6C792067656E657261746564206974656D2066726F6D20636C69656E742D726573706F6E73650A2020202020202020';
wwv_flow_imp.g_varchar2_table(1117) := '2428272327202B2070526567696F6E4964202B2027205B6E616D655D27292E72656D6F76654174747228276E616D6527293B0A2020202020202020617065782E64656275672E747261636528223C3C6A736F6E526567696F6E2E7375626D697422293B0A';
wwv_flow_imp.g_varchar2_table(1118) := '2020202020207D0A202020207D3B0A0A20202020617065782E6A517565727928617065782E6750616765436F6E7465787424292E62696E64282022617065786265666F7265706167657375626D6974222C2066756E6374696F6E2829207B0A2020202020';
wwv_flow_imp.g_varchar2_table(1119) := '2063616C6C6261636B732E6265666F72655375626D697428293B0A202020207D293B0A20202020617065782E6A51756572792820617065782E6750616765436F6E746578742420292E6F6E28202261706578706167657375626D6974222C2066756E6374';
wwv_flow_imp.g_varchar2_table(1120) := '696F6E2829207B0A20202020202063616C6C6261636B732E7375626D697428293B0A202020207D293B0A20202020617065782E6A5175657279282077696E646F7720292E6F6E282022617065786265666F726572656672657368222C2066756E6374696F';
wwv_flow_imp.g_varchar2_table(1121) := '6E2829207B0A202020202020617065782E64656275672E747261636528274556454E543A272C2027617065786265666F72657265667265736827293B0A202020207D293B0A20202020617065782E6A5175657279282077696E646F7720292E6F6E282022';
wwv_flow_imp.g_varchar2_table(1122) := '61706578616674657272656672657368222C2066756E6374696F6E2829207B0A202020202020617065782E64656275672E747261636528274556454E543A272C20276170657861667465727265667265736827293B0A202020207D293B0A0A2020202061';
wwv_flow_imp.g_varchar2_table(1123) := '7065782E6A5175657279282077696E646F7720292E6F6E282022617065787265616479656E64222C2066756E6374696F6E2820652029207B0A202020202020617065782E64656275672E747261636528274556454E543A272C2027617065787265616479';
wwv_flow_imp.g_varchar2_table(1124) := '656E6427293B0A202020207D293B0A0A20202020617065782E6A5175657279282077696E646F7720292E6F6E2820226170657877696E646F77726573697A6564222C2066756E6374696F6E28206576656E742029207B0A202020202020617065782E6465';
wwv_flow_imp.g_varchar2_table(1125) := '6275672E747261636528274556454E543A272C20276170657877696E646F77726573697A656427293B0A202020207D293B0A0A202020202428272327202B2070526567696F6E4964292E72656164792866756E6374696F6E2829207B0A20202020202061';
wwv_flow_imp.g_varchar2_table(1126) := '7065782E64656275672E747261636528274556454E543A272C20274A517565727920726561647927293B0A2020202020207365744F626A65637456616C75657328704F7074696F6E732E646174616974656D2C2027272C20704F7074696F6E732E736368';
wwv_flow_imp.g_varchar2_table(1127) := '656D612C20704F7074696F6E732E726561646F6E6C792C206744617461293B0A202020207D293B0A20202020637265617465526567696F6E28293B0A20207D2928293B0A0A2020617065782E64656275672E747261636528223C3C696E69744A736F6E52';
wwv_flow_imp.g_varchar2_table(1128) := '6567696F6E22293B20200A7D0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(20612806025798261)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_file_name=>'json-region.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E6A736F6E726567696F6E207B0A20206D617267696E2D6C6566743A202D302E3572656D3B0A20206D617267696E2D72696768743A202D302E3572656D3B0A7D0A0A2E6A736F6E726567696F6E202E742D526567696F6E2D686561646572207B0A202062';
wwv_flow_imp.g_varchar2_table(2) := '6F726465722D626C6F636B2D656E642D7374796C653A206E6F6E653B0A7D0A0A2E6A736F6E726567696F6E202E742D466F726D2D6974656D5772617070657220696D67207B0A20206D61782D6865696768743A20313030253B0A20206D61782D77696474';
wwv_flow_imp.g_varchar2_table(3) := '683A20313030253B0A7D0A0A2E6A736F6E726567696F6E202E742D466F726D2D6974656D5772617070657220737667207B0A20206865696768743A20313030253B0A7D0A0A2E6A736F6E726567696F6E202E742D526567696F6E2D686561646572207B0A';
wwv_flow_imp.g_varchar2_table(4) := '20206D617267696E2D746F703A203870783B0A20206D617267696E2D626F74746F6D3A203470783B0A7D0A0A2E6A736F6E726567696F6E202E742D466F726D2D6974656D5772617070657220696E7075745B747970653D74696D655D3A3A2D7765626B69';
wwv_flow_imp.g_varchar2_table(5) := '742D63616C656E6461722D7069636B65722D696E64696361746F722C0A2E6A736F6E726567696F6E202E742D466F726D2D6974656D5772617070657220696E7075745B747970653D646174655D3A3A2D7765626B69742D63616C656E6461722D7069636B';
wwv_flow_imp.g_varchar2_table(6) := '65722D696E64696361746F722C0A2E6A736F6E726567696F6E202E742D466F726D2D6974656D5772617070657220696E7075745B747970653D6461746574696D652D6C6F63616C5D3A3A2D7765626B69742D63616C656E6461722D7069636B65722D696E';
wwv_flow_imp.g_varchar2_table(7) := '64696361746F720A207B0A2020706F736974696F6E3A2072656C61746976653B0A2020746F703A202D313070783B0A7D0A0A2E6A736F6E726567696F6E202E742D466F726D2D6974656D5772617070657220696E7075745B747970653D74696D655D2C0A';
wwv_flow_imp.g_varchar2_table(8) := '2E6A736F6E726567696F6E202E742D466F726D2D6974656D5772617070657220696E7075745B747970653D646174655D2C0A2E6A736F6E726567696F6E202E742D466F726D2D6974656D5772617070657220696E7075745B747970653D6461746574696D';
wwv_flow_imp.g_varchar2_table(9) := '652D6C6F63616C5D7B0A20206865696768743A203372656D3B0A7D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(26825092254025390)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_file_name=>'json-region.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2A0A202A206D61726B6564207631322E302E31202D2061206D61726B646F776E207061727365720A202A20436F707972696768742028632920323031312D323032342C204368726973746F70686572204A6566667265792E20284D4954204C696365';
wwv_flow_imp.g_varchar2_table(2) := '6E736564290A202A2068747470733A2F2F6769746875622E636F6D2F6D61726B65646A732F6D61726B65640A202A2F0A0A2F2A2A0A202A20444F204E4F54204544495420544849532046494C450A202A2054686520636F646520696E2074686973206669';
wwv_flow_imp.g_varchar2_table(3) := '6C652069732067656E6572617465642066726F6D2066696C657320696E202E2F7372632F0A202A2F0A0A2F2A2A0A202A204765747320746865206F726967696E616C206D61726B65642064656661756C74206F7074696F6E732E0A202A2F0A66756E6374';
wwv_flow_imp.g_varchar2_table(4) := '696F6E205F67657444656661756C74732829207B0A2020202072657475726E207B0A20202020202020206173796E633A2066616C73652C0A2020202020202020627265616B733A2066616C73652C0A2020202020202020657874656E73696F6E733A206E';
wwv_flow_imp.g_varchar2_table(5) := '756C6C2C0A202020202020202067666D3A20747275652C0A2020202020202020686F6F6B733A206E756C6C2C0A2020202020202020706564616E7469633A2066616C73652C0A202020202020202072656E64657265723A206E756C6C2C0A202020202020';
wwv_flow_imp.g_varchar2_table(6) := '202073696C656E743A2066616C73652C0A2020202020202020746F6B656E697A65723A206E756C6C2C0A202020202020202077616C6B546F6B656E733A206E756C6C0A202020207D3B0A7D0A6C6574205F64656661756C7473203D205F67657444656661';
wwv_flow_imp.g_varchar2_table(7) := '756C747328293B0A66756E6374696F6E206368616E676544656661756C7473286E657744656661756C747329207B0A202020205F64656661756C7473203D206E657744656661756C74733B0A7D0A0A2F2A2A0A202A2048656C706572730A202A2F0A636F';
wwv_flow_imp.g_varchar2_table(8) := '6E73742065736361706554657374203D202F5B263C3E22275D2F3B0A636F6E7374206573636170655265706C616365203D206E65772052656745787028657363617065546573742E736F757263652C20276727293B0A636F6E7374206573636170655465';
wwv_flow_imp.g_varchar2_table(9) := '73744E6F456E636F6465203D202F5B3C3E22275D7C26283F2128235C647B312C377D7C235B58785D5B612D66412D46302D395D7B312C367D7C5C772B293B292F3B0A636F6E7374206573636170655265706C6163654E6F456E636F6465203D206E657720';
wwv_flow_imp.g_varchar2_table(10) := '52656745787028657363617065546573744E6F456E636F64652E736F757263652C20276727293B0A636F6E7374206573636170655265706C6163656D656E7473203D207B0A202020202726273A202726616D703B272C0A20202020273C273A2027266C74';
wwv_flow_imp.g_varchar2_table(11) := '3B272C0A20202020273E273A20272667743B272C0A202020202722273A20272671756F743B272C0A202020202227223A2027262333393B270A7D3B0A636F6E7374206765744573636170655265706C6163656D656E74203D2028636829203D3E20657363';
wwv_flow_imp.g_varchar2_table(12) := '6170655265706C6163656D656E74735B63685D3B0A66756E6374696F6E2065736361706524312868746D6C2C20656E636F646529207B0A2020202069662028656E636F646529207B0A202020202020202069662028657363617065546573742E74657374';
wwv_flow_imp.g_varchar2_table(13) := '2868746D6C2929207B0A20202020202020202020202072657475726E2068746D6C2E7265706C616365286573636170655265706C6163652C206765744573636170655265706C6163656D656E74293B0A20202020202020207D0A202020207D0A20202020';
wwv_flow_imp.g_varchar2_table(14) := '656C7365207B0A202020202020202069662028657363617065546573744E6F456E636F64652E746573742868746D6C2929207B0A20202020202020202020202072657475726E2068746D6C2E7265706C616365286573636170655265706C6163654E6F45';
wwv_flow_imp.g_varchar2_table(15) := '6E636F64652C206765744573636170655265706C6163656D656E74293B0A20202020202020207D0A202020207D0A2020202072657475726E2068746D6C3B0A7D0A636F6E737420756E65736361706554657374203D202F262823283F3A5C642B297C283F';
wwv_flow_imp.g_varchar2_table(16) := '3A23785B302D39412D46612D665D2B297C283F3A5C772B29293B3F2F69673B0A66756E6374696F6E20756E6573636170652868746D6C29207B0A202020202F2F206578706C696369746C79206D6174636820646563696D616C2C206865782C20616E6420';
wwv_flow_imp.g_varchar2_table(17) := '6E616D65642048544D4C20656E7469746965730A2020202072657475726E2068746D6C2E7265706C61636528756E657363617065546573742C20285F2C206E29203D3E207B0A20202020202020206E203D206E2E746F4C6F7765724361736528293B0A20';
wwv_flow_imp.g_varchar2_table(18) := '20202020202020696620286E203D3D3D2027636F6C6F6E27290A20202020202020202020202072657475726E20273A273B0A2020202020202020696620286E2E636861724174283029203D3D3D2027232729207B0A202020202020202020202020726574';
wwv_flow_imp.g_varchar2_table(19) := '75726E206E2E636861724174283129203D3D3D202778270A202020202020202020202020202020203F20537472696E672E66726F6D43686172436F6465287061727365496E74286E2E737562737472696E672832292C20313629290A2020202020202020';
wwv_flow_imp.g_varchar2_table(20) := '20202020202020203A20537472696E672E66726F6D43686172436F6465282B6E2E737562737472696E67283129293B0A20202020202020207D0A202020202020202072657475726E2027273B0A202020207D293B0A7D0A636F6E7374206361726574203D';
wwv_flow_imp.g_varchar2_table(21) := '202F285E7C5B5E5C5B5D295C5E2F673B0A66756E6374696F6E20656469742872656765782C206F707429207B0A202020206C657420736F75726365203D20747970656F66207265676578203D3D3D2027737472696E6727203F207265676578203A207265';
wwv_flow_imp.g_varchar2_table(22) := '6765782E736F757263653B0A202020206F7074203D206F7074207C7C2027273B0A20202020636F6E7374206F626A203D207B0A20202020202020207265706C6163653A20286E616D652C2076616C29203D3E207B0A2020202020202020202020206C6574';
wwv_flow_imp.g_varchar2_table(23) := '2076616C536F75726365203D20747970656F662076616C203D3D3D2027737472696E6727203F2076616C203A2076616C2E736F757263653B0A20202020202020202020202076616C536F75726365203D2076616C536F757263652E7265706C6163652863';
wwv_flow_imp.g_varchar2_table(24) := '617265742C2027243127293B0A202020202020202020202020736F75726365203D20736F757263652E7265706C616365286E616D652C2076616C536F75726365293B0A20202020202020202020202072657475726E206F626A3B0A20202020202020207D';
wwv_flow_imp.g_varchar2_table(25) := '2C0A202020202020202067657452656765783A202829203D3E207B0A20202020202020202020202072657475726E206E65772052656745787028736F757263652C206F7074293B0A20202020202020207D0A202020207D3B0A2020202072657475726E20';
wwv_flow_imp.g_varchar2_table(26) := '6F626A3B0A7D0A66756E6374696F6E20636C65616E55726C286872656629207B0A20202020747279207B0A202020202020202068726566203D20656E636F64655552492868726566292E7265706C616365282F2532352F672C20272527293B0A20202020';
wwv_flow_imp.g_varchar2_table(27) := '7D0A20202020636174636820286529207B0A202020202020202072657475726E206E756C6C3B0A202020207D0A2020202072657475726E20687265663B0A7D0A636F6E7374206E6F6F7054657374203D207B20657865633A202829203D3E206E756C6C20';
wwv_flow_imp.g_varchar2_table(28) := '7D3B0A66756E6374696F6E2073706C697443656C6C73287461626C65526F772C20636F756E7429207B0A202020202F2F20656E7375726520746861742065766572792063656C6C2D64656C696D6974696E6720706970652068617320612073706163650A';
wwv_flow_imp.g_varchar2_table(29) := '202020202F2F206265666F726520697420746F2064697374696E67756973682069742066726F6D20616E206573636170656420706970650A20202020636F6E737420726F77203D207461626C65526F772E7265706C616365282F5C7C2F672C20286D6174';
wwv_flow_imp.g_varchar2_table(30) := '63682C206F66667365742C2073747229203D3E207B0A20202020202020206C65742065736361706564203D2066616C73653B0A20202020202020206C65742063757272203D206F66667365743B0A20202020202020207768696C6520282D2D6375727220';
wwv_flow_imp.g_varchar2_table(31) := '3E3D2030202626207374725B637572725D203D3D3D20275C5C27290A20202020202020202020202065736361706564203D2021657363617065643B0A2020202020202020696620286573636170656429207B0A2020202020202020202020202F2F206F64';
wwv_flow_imp.g_varchar2_table(32) := '64206E756D626572206F6620736C6173686573206D65616E73207C20697320657363617065640A2020202020202020202020202F2F20736F207765206C6561766520697420616C6F6E650A20202020202020202020202072657475726E20277C273B0A20';
wwv_flow_imp.g_varchar2_table(33) := '202020202020207D0A2020202020202020656C7365207B0A2020202020202020202020202F2F20616464207370616365206265666F726520756E65736361706564207C0A20202020202020202020202072657475726E2027207C273B0A20202020202020';
wwv_flow_imp.g_varchar2_table(34) := '207D0A202020207D292C2063656C6C73203D20726F772E73706C6974282F205C7C2F293B0A202020206C65742069203D20303B0A202020202F2F2046697273742F6C6173742063656C6C20696E206120726F772063616E6E6F7420626520656D70747920';
wwv_flow_imp.g_varchar2_table(35) := '696620697420686173206E6F206C656164696E672F747261696C696E6720706970650A20202020696620282163656C6C735B305D2E7472696D282929207B0A202020202020202063656C6C732E736869667428293B0A202020207D0A2020202069662028';
wwv_flow_imp.g_varchar2_table(36) := '63656C6C732E6C656E677468203E2030202626202163656C6C735B63656C6C732E6C656E677468202D20315D2E7472696D282929207B0A202020202020202063656C6C732E706F7028293B0A202020207D0A2020202069662028636F756E7429207B0A20';
wwv_flow_imp.g_varchar2_table(37) := '202020202020206966202863656C6C732E6C656E677468203E20636F756E7429207B0A20202020202020202020202063656C6C732E73706C69636528636F756E74293B0A20202020202020207D0A2020202020202020656C7365207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(38) := '20202020207768696C65202863656C6C732E6C656E677468203C20636F756E74290A2020202020202020202020202020202063656C6C732E70757368282727293B0A20202020202020207D0A202020207D0A20202020666F7220283B2069203C2063656C';
wwv_flow_imp.g_varchar2_table(39) := '6C732E6C656E6774683B20692B2B29207B0A20202020202020202F2F206C656164696E67206F7220747261696C696E6720776869746573706163652069732069676E6F72656420706572207468652067666D20737065630A202020202020202063656C6C';
wwv_flow_imp.g_varchar2_table(40) := '735B695D203D2063656C6C735B695D2E7472696D28292E7265706C616365282F5C5C5C7C2F672C20277C27293B0A202020207D0A2020202072657475726E2063656C6C733B0A7D0A2F2A2A0A202A2052656D6F766520747261696C696E6720276327732E';
wwv_flow_imp.g_varchar2_table(41) := '204571756976616C656E7420746F207374722E7265706C616365282F632A242F2C202727292E0A202A202F632A242F2069732076756C6E657261626C6520746F205245444F532E0A202A0A202A2040706172616D207374720A202A2040706172616D2063';
wwv_flow_imp.g_varchar2_table(42) := '0A202A2040706172616D20696E766572742052656D6F766520737566666978206F66206E6F6E2D6320636861727320696E73746561642E2044656661756C742066616C7365792E0A202A2F0A66756E6374696F6E20727472696D287374722C20632C2069';
wwv_flow_imp.g_varchar2_table(43) := '6E7665727429207B0A20202020636F6E7374206C203D207374722E6C656E6774683B0A20202020696620286C203D3D3D203029207B0A202020202020202072657475726E2027273B0A202020207D0A202020202F2F204C656E677468206F662073756666';
wwv_flow_imp.g_varchar2_table(44) := '6978206D61746368696E672074686520696E7665727420636F6E646974696F6E2E0A202020206C657420737566664C656E203D20303B0A202020202F2F2053746570206C65667420756E74696C207765206661696C20746F206D61746368207468652069';
wwv_flow_imp.g_varchar2_table(45) := '6E7665727420636F6E646974696F6E2E0A202020207768696C652028737566664C656E203C206C29207B0A2020202020202020636F6E7374206375727243686172203D207374722E636861724174286C202D20737566664C656E202D2031293B0A202020';
wwv_flow_imp.g_varchar2_table(46) := '2020202020696620286375727243686172203D3D3D20632026262021696E7665727429207B0A202020202020202020202020737566664C656E2B2B3B0A20202020202020207D0A2020202020202020656C73652069662028637572724368617220213D3D';
wwv_flow_imp.g_varchar2_table(47) := '206320262620696E7665727429207B0A202020202020202020202020737566664C656E2B2B3B0A20202020202020207D0A2020202020202020656C7365207B0A202020202020202020202020627265616B3B0A20202020202020207D0A202020207D0A20';
wwv_flow_imp.g_varchar2_table(48) := '20202072657475726E207374722E736C69636528302C206C202D20737566664C656E293B0A7D0A66756E6374696F6E2066696E64436C6F73696E67427261636B6574287374722C206229207B0A20202020696620287374722E696E6465784F6628625B31';
wwv_flow_imp.g_varchar2_table(49) := '5D29203D3D3D202D3129207B0A202020202020202072657475726E202D313B0A202020207D0A202020206C6574206C6576656C203D20303B0A20202020666F7220286C65742069203D20303B2069203C207374722E6C656E6774683B20692B2B29207B0A';
wwv_flow_imp.g_varchar2_table(50) := '2020202020202020696620287374725B695D203D3D3D20275C5C2729207B0A202020202020202020202020692B2B3B0A20202020202020207D0A2020202020202020656C736520696620287374725B695D203D3D3D20625B305D29207B0A202020202020';
wwv_flow_imp.g_varchar2_table(51) := '2020202020206C6576656C2B2B3B0A20202020202020207D0A2020202020202020656C736520696620287374725B695D203D3D3D20625B315D29207B0A2020202020202020202020206C6576656C2D2D3B0A202020202020202020202020696620286C65';
wwv_flow_imp.g_varchar2_table(52) := '76656C203C203029207B0A2020202020202020202020202020202072657475726E20693B0A2020202020202020202020207D0A20202020202020207D0A202020207D0A2020202072657475726E202D313B0A7D0A0A66756E6374696F6E206F7574707574';
wwv_flow_imp.g_varchar2_table(53) := '4C696E6B286361702C206C696E6B2C207261772C206C6578657229207B0A20202020636F6E73742068726566203D206C696E6B2E687265663B0A20202020636F6E7374207469746C65203D206C696E6B2E7469746C65203F206573636170652431286C69';
wwv_flow_imp.g_varchar2_table(54) := '6E6B2E7469746C6529203A206E756C6C3B0A20202020636F6E73742074657874203D206361705B315D2E7265706C616365282F5C5C285B5C5B5C5D5D292F672C2027243127293B0A20202020696620286361705B305D2E63686172417428302920213D3D';
wwv_flow_imp.g_varchar2_table(55) := '2027212729207B0A20202020202020206C657865722E73746174652E696E4C696E6B203D20747275653B0A2020202020202020636F6E737420746F6B656E203D207B0A202020202020202020202020747970653A20276C696E6B272C0A20202020202020';
wwv_flow_imp.g_varchar2_table(56) := '20202020207261772C0A202020202020202020202020687265662C0A2020202020202020202020207469746C652C0A202020202020202020202020746578742C0A202020202020202020202020746F6B656E733A206C657865722E696E6C696E65546F6B';
wwv_flow_imp.g_varchar2_table(57) := '656E732874657874290A20202020202020207D3B0A20202020202020206C657865722E73746174652E696E4C696E6B203D2066616C73653B0A202020202020202072657475726E20746F6B656E3B0A202020207D0A2020202072657475726E207B0A2020';
wwv_flow_imp.g_varchar2_table(58) := '202020202020747970653A2027696D616765272C0A20202020202020207261772C0A2020202020202020687265662C0A20202020202020207469746C652C0A2020202020202020746578743A2065736361706524312874657874290A202020207D3B0A7D';
wwv_flow_imp.g_varchar2_table(59) := '0A66756E6374696F6E20696E64656E74436F6465436F6D70656E736174696F6E287261772C207465787429207B0A20202020636F6E7374206D61746368496E64656E74546F436F6465203D207261772E6D61746368282F5E285C732B29283F3A60606029';
wwv_flow_imp.g_varchar2_table(60) := '2F293B0A20202020696620286D61746368496E64656E74546F436F6465203D3D3D206E756C6C29207B0A202020202020202072657475726E20746578743B0A202020207D0A20202020636F6E737420696E64656E74546F436F6465203D206D6174636849';
wwv_flow_imp.g_varchar2_table(61) := '6E64656E74546F436F64655B315D3B0A2020202072657475726E20746578740A20202020202020202E73706C697428275C6E27290A20202020202020202E6D6170286E6F6465203D3E207B0A2020202020202020636F6E7374206D61746368496E64656E';
wwv_flow_imp.g_varchar2_table(62) := '74496E4E6F6465203D206E6F64652E6D61746368282F5E5C732B2F293B0A2020202020202020696620286D61746368496E64656E74496E4E6F6465203D3D3D206E756C6C29207B0A20202020202020202020202072657475726E206E6F64653B0A202020';
wwv_flow_imp.g_varchar2_table(63) := '20202020207D0A2020202020202020636F6E7374205B696E64656E74496E4E6F64655D203D206D61746368496E64656E74496E4E6F64653B0A202020202020202069662028696E64656E74496E4E6F64652E6C656E677468203E3D20696E64656E74546F';
wwv_flow_imp.g_varchar2_table(64) := '436F64652E6C656E67746829207B0A20202020202020202020202072657475726E206E6F64652E736C69636528696E64656E74546F436F64652E6C656E677468293B0A20202020202020207D0A202020202020202072657475726E206E6F64653B0A2020';
wwv_flow_imp.g_varchar2_table(65) := '20207D290A20202020202020202E6A6F696E28275C6E27293B0A7D0A2F2A2A0A202A20546F6B656E697A65720A202A2F0A636C617373205F546F6B656E697A6572207B0A202020206F7074696F6E733B0A2020202072756C65733B202F2F207365742062';
wwv_flow_imp.g_varchar2_table(66) := '7920746865206C657865720A202020206C657865723B202F2F2073657420627920746865206C657865720A20202020636F6E7374727563746F72286F7074696F6E7329207B0A2020202020202020746869732E6F7074696F6E73203D206F7074696F6E73';
wwv_flow_imp.g_varchar2_table(67) := '207C7C205F64656661756C74733B0A202020207D0A2020202073706163652873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E626C6F636B2E6E65776C696E652E6578656328737263293B0A202020202020';
wwv_flow_imp.g_varchar2_table(68) := '202069662028636170202626206361705B305D2E6C656E677468203E203029207B0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A20277370616365272C0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(69) := '20207261773A206361705B305D0A2020202020202020202020207D3B0A20202020202020207D0A202020207D0A20202020636F64652873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E626C6F636B2E636F';
wwv_flow_imp.g_varchar2_table(70) := '64652E6578656328737263293B0A20202020202020206966202863617029207B0A202020202020202020202020636F6E73742074657874203D206361705B305D2E7265706C616365282F5E207B312C347D2F676D2C202727293B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(71) := '20202072657475726E207B0A20202020202020202020202020202020747970653A2027636F6465272C0A202020202020202020202020202020207261773A206361705B305D2C0A20202020202020202020202020202020636F6465426C6F636B5374796C';
wwv_flow_imp.g_varchar2_table(72) := '653A2027696E64656E746564272C0A20202020202020202020202020202020746578743A2021746869732E6F7074696F6E732E706564616E7469630A20202020202020202020202020202020202020203F20727472696D28746578742C20275C6E27290A';
wwv_flow_imp.g_varchar2_table(73) := '20202020202020202020202020202020202020203A20746578740A2020202020202020202020207D3B0A20202020202020207D0A202020207D0A2020202066656E6365732873726329207B0A2020202020202020636F6E737420636170203D2074686973';
wwv_flow_imp.g_varchar2_table(74) := '2E72756C65732E626C6F636B2E66656E6365732E6578656328737263293B0A20202020202020206966202863617029207B0A202020202020202020202020636F6E737420726177203D206361705B305D3B0A202020202020202020202020636F6E737420';
wwv_flow_imp.g_varchar2_table(75) := '74657874203D20696E64656E74436F6465436F6D70656E736174696F6E287261772C206361705B335D207C7C202727293B0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A2027636F6465272C';
wwv_flow_imp.g_varchar2_table(76) := '0A202020202020202020202020202020207261772C0A202020202020202020202020202020206C616E673A206361705B325D203F206361705B325D2E7472696D28292E7265706C61636528746869732E72756C65732E696E6C696E652E616E7950756E63';
wwv_flow_imp.g_varchar2_table(77) := '74756174696F6E2C202724312729203A206361705B325D2C0A20202020202020202020202020202020746578740A2020202020202020202020207D3B0A20202020202020207D0A202020207D0A2020202068656164696E672873726329207B0A20202020';
wwv_flow_imp.g_varchar2_table(78) := '20202020636F6E737420636170203D20746869732E72756C65732E626C6F636B2E68656164696E672E6578656328737263293B0A20202020202020206966202863617029207B0A2020202020202020202020206C65742074657874203D206361705B325D';
wwv_flow_imp.g_varchar2_table(79) := '2E7472696D28293B0A2020202020202020202020202F2F2072656D6F766520747261696C696E672023730A202020202020202020202020696620282F23242F2E7465737428746578742929207B0A20202020202020202020202020202020636F6E737420';
wwv_flow_imp.g_varchar2_table(80) := '7472696D6D6564203D20727472696D28746578742C20272327293B0A2020202020202020202020202020202069662028746869732E6F7074696F6E732E706564616E74696329207B0A202020202020202020202020202020202020202074657874203D20';
wwv_flow_imp.g_varchar2_table(81) := '7472696D6D65642E7472696D28293B0A202020202020202020202020202020207D0A20202020202020202020202020202020656C73652069662028217472696D6D6564207C7C202F20242F2E74657374287472696D6D65642929207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(82) := '202020202020202020202020202F2F20436F6D6D6F6E4D61726B207265717569726573207370616365206265666F726520747261696C696E672023730A202020202020202020202020202020202020202074657874203D207472696D6D65642E7472696D';
wwv_flow_imp.g_varchar2_table(83) := '28293B0A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A202768656164696E67272C0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(84) := '2020202020207261773A206361705B305D2C0A2020202020202020202020202020202064657074683A206361705B315D2E6C656E6774682C0A20202020202020202020202020202020746578742C0A20202020202020202020202020202020746F6B656E';
wwv_flow_imp.g_varchar2_table(85) := '733A20746869732E6C657865722E696E6C696E652874657874290A2020202020202020202020207D3B0A20202020202020207D0A202020207D0A2020202068722873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C';
wwv_flow_imp.g_varchar2_table(86) := '65732E626C6F636B2E68722E6578656328737263293B0A20202020202020206966202863617029207B0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A20276872272C0A202020202020202020';
wwv_flow_imp.g_varchar2_table(87) := '202020202020207261773A206361705B305D0A2020202020202020202020207D3B0A20202020202020207D0A202020207D0A20202020626C6F636B71756F74652873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C';
wwv_flow_imp.g_varchar2_table(88) := '65732E626C6F636B2E626C6F636B71756F74652E6578656328737263293B0A20202020202020206966202863617029207B0A202020202020202020202020636F6E73742074657874203D20727472696D286361705B305D2E7265706C616365282F5E202A';
wwv_flow_imp.g_varchar2_table(89) := '3E5B205C745D3F2F676D2C202727292C20275C6E27293B0A202020202020202020202020636F6E737420746F70203D20746869732E6C657865722E73746174652E746F703B0A202020202020202020202020746869732E6C657865722E73746174652E74';
wwv_flow_imp.g_varchar2_table(90) := '6F70203D20747275653B0A202020202020202020202020636F6E737420746F6B656E73203D20746869732E6C657865722E626C6F636B546F6B656E732874657874293B0A202020202020202020202020746869732E6C657865722E73746174652E746F70';
wwv_flow_imp.g_varchar2_table(91) := '203D20746F703B0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A2027626C6F636B71756F7465272C0A202020202020202020202020202020207261773A206361705B305D2C0A202020202020';
wwv_flow_imp.g_varchar2_table(92) := '20202020202020202020746F6B656E732C0A20202020202020202020202020202020746578740A2020202020202020202020207D3B0A20202020202020207D0A202020207D0A202020206C6973742873726329207B0A20202020202020206C6574206361';
wwv_flow_imp.g_varchar2_table(93) := '70203D20746869732E72756C65732E626C6F636B2E6C6973742E6578656328737263293B0A20202020202020206966202863617029207B0A2020202020202020202020206C65742062756C6C203D206361705B315D2E7472696D28293B0A202020202020';
wwv_flow_imp.g_varchar2_table(94) := '202020202020636F6E73742069736F726465726564203D2062756C6C2E6C656E677468203E20313B0A202020202020202020202020636F6E7374206C697374203D207B0A20202020202020202020202020202020747970653A20276C697374272C0A2020';
wwv_flow_imp.g_varchar2_table(95) := '20202020202020202020202020207261773A2027272C0A202020202020202020202020202020206F7264657265643A2069736F7264657265642C0A2020202020202020202020202020202073746172743A2069736F726465726564203F202B62756C6C2E';
wwv_flow_imp.g_varchar2_table(96) := '736C69636528302C202D3129203A2027272C0A202020202020202020202020202020206C6F6F73653A2066616C73652C0A202020202020202020202020202020206974656D733A205B5D0A2020202020202020202020207D3B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(97) := '202062756C6C203D2069736F726465726564203F20605C5C647B312C397D5C5C247B62756C6C2E736C696365282D31297D60203A20605C5C247B62756C6C7D603B0A20202020202020202020202069662028746869732E6F7074696F6E732E706564616E';
wwv_flow_imp.g_varchar2_table(98) := '74696329207B0A2020202020202020202020202020202062756C6C203D2069736F726465726564203F2062756C6C203A20275B2A2B2D5D273B0A2020202020202020202020207D0A2020202020202020202020202F2F20476574206E657874206C697374';
wwv_flow_imp.g_varchar2_table(99) := '206974656D0A202020202020202020202020636F6E7374206974656D5265676578203D206E65772052656745787028605E28207B302C337D247B62756C6C7D2928283F3A5B5C74205D5B5E5C5C6E5D2A293F283F3A5C5C6E7C24292960293B0A20202020';
wwv_flow_imp.g_varchar2_table(100) := '20202020202020206C657420726177203D2027273B0A2020202020202020202020206C6574206974656D436F6E74656E7473203D2027273B0A2020202020202020202020206C657420656E647357697468426C616E6B4C696E65203D2066616C73653B0A';
wwv_flow_imp.g_varchar2_table(101) := '2020202020202020202020202F2F20436865636B2069662063757272656E742062756C6C657420706F696E742063616E2073746172742061206E6577204C697374204974656D0A2020202020202020202020207768696C65202873726329207B0A202020';
wwv_flow_imp.g_varchar2_table(102) := '202020202020202020202020206C657420656E644561726C79203D2066616C73653B0A20202020202020202020202020202020696620282128636170203D206974656D52656765782E6578656328737263292929207B0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(103) := '20202020202020627265616B3B0A202020202020202020202020202020207D0A2020202020202020202020202020202069662028746869732E72756C65732E626C6F636B2E68722E74657374287372632929207B202F2F20456E64206C69737420696620';
wwv_flow_imp.g_varchar2_table(104) := '62756C6C6574207761732061637475616C6C792048522028706F737369626C79206D6F766520696E746F206974656D52656765783F290A2020202020202020202020202020202020202020627265616B3B0A202020202020202020202020202020207D0A';
wwv_flow_imp.g_varchar2_table(105) := '20202020202020202020202020202020726177203D206361705B305D3B0A20202020202020202020202020202020737263203D207372632E737562737472696E67287261772E6C656E677468293B0A202020202020202020202020202020206C6574206C';
wwv_flow_imp.g_varchar2_table(106) := '696E65203D206361705B325D2E73706C697428275C6E272C2031295B305D2E7265706C616365282F5E5C742B2F2C20287429203D3E202720272E7265706561742833202A20742E6C656E67746829293B0A202020202020202020202020202020206C6574';
wwv_flow_imp.g_varchar2_table(107) := '206E6578744C696E65203D207372632E73706C697428275C6E272C2031295B305D3B0A202020202020202020202020202020206C657420696E64656E74203D20303B0A2020202020202020202020202020202069662028746869732E6F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(108) := '706564616E74696329207B0A2020202020202020202020202020202020202020696E64656E74203D20323B0A20202020202020202020202020202020202020206974656D436F6E74656E7473203D206C696E652E7472696D537461727428293B0A202020';
wwv_flow_imp.g_varchar2_table(109) := '202020202020202020202020207D0A20202020202020202020202020202020656C7365207B0A2020202020202020202020202020202020202020696E64656E74203D206361705B325D2E736561726368282F5B5E205D2F293B202F2F2046696E64206669';
wwv_flow_imp.g_varchar2_table(110) := '727374206E6F6E2D737061636520636861720A2020202020202020202020202020202020202020696E64656E74203D20696E64656E74203E2034203F2031203A20696E64656E743B202F2F20547265617420696E64656E74656420636F646520626C6F63';
wwv_flow_imp.g_varchar2_table(111) := '6B7320283E2034207370616365732920617320686176696E67206F6E6C79203120696E64656E740A20202020202020202020202020202020202020206974656D436F6E74656E7473203D206C696E652E736C69636528696E64656E74293B0A2020202020';
wwv_flow_imp.g_varchar2_table(112) := '202020202020202020202020202020696E64656E74202B3D206361705B315D2E6C656E6774683B0A202020202020202020202020202020207D0A202020202020202020202020202020206C657420626C616E6B4C696E65203D2066616C73653B0A202020';
wwv_flow_imp.g_varchar2_table(113) := '2020202020202020202020202069662028216C696E65202626202F5E202A242F2E74657374286E6578744C696E652929207B202F2F204974656D7320626567696E2077697468206174206D6F7374206F6E6520626C616E6B206C696E650A202020202020';
wwv_flow_imp.g_varchar2_table(114) := '2020202020202020202020202020726177202B3D206E6578744C696E65202B20275C6E273B0A2020202020202020202020202020202020202020737263203D207372632E737562737472696E67286E6578744C696E652E6C656E677468202B2031293B0A';
wwv_flow_imp.g_varchar2_table(115) := '2020202020202020202020202020202020202020656E644561726C79203D20747275653B0A202020202020202020202020202020207D0A202020202020202020202020202020206966202821656E644561726C7929207B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(116) := '2020202020202020636F6E7374206E65787442756C6C65745265676578203D206E65772052656745787028605E207B302C247B4D6174682E6D696E28332C20696E64656E74202D2031297D7D283F3A5B2A2B2D5D7C5C5C647B312C397D5B2E295D292828';
wwv_flow_imp.g_varchar2_table(117) := '3F3A5B205C745D5B5E5C5C6E5D2A293F283F3A5C5C6E7C24292960293B0A2020202020202020202020202020202020202020636F6E73742068725265676578203D206E65772052656745787028605E207B302C247B4D6174682E6D696E28332C20696E64';
wwv_flow_imp.g_varchar2_table(118) := '656E74202D2031297D7D28283F3A2D202A297B332C7D7C283F3A5F202A297B332C7D7C283F3A5C5C2A202A297B332C7D29283F3A5C5C6E2B7C242960293B0A2020202020202020202020202020202020202020636F6E73742066656E636573426567696E';
wwv_flow_imp.g_varchar2_table(119) := '5265676578203D206E65772052656745787028605E207B302C247B4D6174682E6D696E28332C20696E64656E74202D2031297D7D283F3A5C605C605C607C7E7E7E2960293B0A2020202020202020202020202020202020202020636F6E73742068656164';
wwv_flow_imp.g_varchar2_table(120) := '696E67426567696E5265676578203D206E65772052656745787028605E207B302C247B4D6174682E6D696E28332C20696E64656E74202D2031297D7D2360293B0A20202020202020202020202020202020202020202F2F20436865636B20696620666F6C';
wwv_flow_imp.g_varchar2_table(121) := '6C6F77696E67206C696E65732073686F756C6420626520696E636C7564656420696E204C697374204974656D0A20202020202020202020202020202020202020207768696C65202873726329207B0A202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(122) := '202020636F6E7374207261774C696E65203D207372632E73706C697428275C6E272C2031295B305D3B0A2020202020202020202020202020202020202020202020206E6578744C696E65203D207261774C696E653B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(123) := '202020202020202020202F2F2052652D616C69676E20746F20666F6C6C6F7720636F6D6D6F6E6D61726B206E657374696E672072756C65730A20202020202020202020202020202020202020202020202069662028746869732E6F7074696F6E732E7065';
wwv_flow_imp.g_varchar2_table(124) := '64616E74696329207B0A202020202020202020202020202020202020202020202020202020206E6578744C696E65203D206E6578744C696E652E7265706C616365282F5E207B312C347D283F3D28207B347D292A5B5E205D292F672C2027202027293B0A';
wwv_flow_imp.g_varchar2_table(125) := '2020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020202F2F20456E64206C697374206974656D20696620666F756E6420636F64652066656E6365730A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(126) := '2020202020202020202020206966202866656E636573426567696E52656765782E74657374286E6578744C696E652929207B0A20202020202020202020202020202020202020202020202020202020627265616B3B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(127) := '202020202020202020207D0A2020202020202020202020202020202020202020202020202F2F20456E64206C697374206974656D20696620666F756E64207374617274206F66206E65772068656164696E670A2020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(128) := '202020202020206966202868656164696E67426567696E52656765782E74657374286E6578744C696E652929207B0A20202020202020202020202020202020202020202020202020202020627265616B3B0A202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(129) := '2020202020207D0A2020202020202020202020202020202020202020202020202F2F20456E64206C697374206974656D20696620666F756E64207374617274206F66206E65772062756C6C65740A20202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(130) := '2020696620286E65787442756C6C657452656765782E74657374286E6578744C696E652929207B0A20202020202020202020202020202020202020202020202020202020627265616B3B0A2020202020202020202020202020202020202020202020207D';
wwv_flow_imp.g_varchar2_table(131) := '0A2020202020202020202020202020202020202020202020202F2F20486F72697A6F6E74616C2072756C6520666F756E640A20202020202020202020202020202020202020202020202069662028687252656765782E74657374287372632929207B0A20';
wwv_flow_imp.g_varchar2_table(132) := '202020202020202020202020202020202020202020202020202020627265616B3B0A2020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020696620286E6578744C696E652E736561';
wwv_flow_imp.g_varchar2_table(133) := '726368282F5B5E205D2F29203E3D20696E64656E74207C7C20216E6578744C696E652E7472696D282929207B202F2F20446564656E7420696620706F737369626C650A202020202020202020202020202020202020202020202020202020206974656D43';
wwv_flow_imp.g_varchar2_table(134) := '6F6E74656E7473202B3D20275C6E27202B206E6578744C696E652E736C69636528696E64656E74293B0A2020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020656C7365207B0A20';
wwv_flow_imp.g_varchar2_table(135) := '2020202020202020202020202020202020202020202020202020202F2F206E6F7420656E6F75676820696E64656E746174696F6E0A2020202020202020202020202020202020202020202020202020202069662028626C616E6B4C696E6529207B0A2020';
wwv_flow_imp.g_varchar2_table(136) := '202020202020202020202020202020202020202020202020202020202020627265616B3B0A202020202020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020202020202F2F207061';
wwv_flow_imp.g_varchar2_table(137) := '7261677261706820636F6E74696E756174696F6E20756E6C657373206C617374206C696E6520776173206120646966666572656E7420626C6F636B206C6576656C20656C656D656E740A2020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(138) := '2020696620286C696E652E736561726368282F5B5E205D2F29203E3D203429207B202F2F20696E64656E74656420636F646520626C6F636B0A2020202020202020202020202020202020202020202020202020202020202020627265616B3B0A20202020';
wwv_flow_imp.g_varchar2_table(139) := '2020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020202020206966202866656E636573426567696E52656765782E74657374286C696E652929207B0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(140) := '202020202020202020202020202020202020202020627265616B3B0A202020202020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020202020206966202868656164696E67426567';
wwv_flow_imp.g_varchar2_table(141) := '696E52656765782E74657374286C696E652929207B0A2020202020202020202020202020202020202020202020202020202020202020627265616B3B0A202020202020202020202020202020202020202020202020202020207D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(142) := '2020202020202020202020202020202020202069662028687252656765782E74657374286C696E652929207B0A2020202020202020202020202020202020202020202020202020202020202020627265616B3B0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(143) := '2020202020202020202020207D0A202020202020202020202020202020202020202020202020202020206974656D436F6E74656E7473202B3D20275C6E27202B206E6578744C696E653B0A2020202020202020202020202020202020202020202020207D';
wwv_flow_imp.g_varchar2_table(144) := '0A2020202020202020202020202020202020202020202020206966202821626C616E6B4C696E6520262620216E6578744C696E652E7472696D282929207B202F2F20436865636B2069662063757272656E74206C696E6520697320626C616E6B0A202020';
wwv_flow_imp.g_varchar2_table(145) := '20202020202020202020202020202020202020202020202020626C616E6B4C696E65203D20747275653B0A2020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020726177202B3D20';
wwv_flow_imp.g_varchar2_table(146) := '7261774C696E65202B20275C6E273B0A202020202020202020202020202020202020202020202020737263203D207372632E737562737472696E67287261774C696E652E6C656E677468202B2031293B0A20202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(147) := '20202020206C696E65203D206E6578744C696E652E736C69636528696E64656E74293B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D0A2020202020202020202020202020202069662028216C6973';
wwv_flow_imp.g_varchar2_table(148) := '742E6C6F6F736529207B0A20202020202020202020202020202020202020202F2F204966207468652070726576696F7573206974656D20656E6465642077697468206120626C616E6B206C696E652C20746865206C697374206973206C6F6F73650A2020';
wwv_flow_imp.g_varchar2_table(149) := '20202020202020202020202020202020202069662028656E647357697468426C616E6B4C696E6529207B0A2020202020202020202020202020202020202020202020206C6973742E6C6F6F7365203D20747275653B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(150) := '2020202020207D0A2020202020202020202020202020202020202020656C736520696620282F5C6E202A5C6E202A242F2E74657374287261772929207B0A202020202020202020202020202020202020202020202020656E647357697468426C616E6B4C';
wwv_flow_imp.g_varchar2_table(151) := '696E65203D20747275653B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D0A202020202020202020202020202020206C65742069737461736B203D206E756C6C3B0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(152) := '2020206C6574206973636865636B65643B0A202020202020202020202020202020202F2F20436865636B20666F72207461736B206C697374206974656D730A2020202020202020202020202020202069662028746869732E6F7074696F6E732E67666D29';
wwv_flow_imp.g_varchar2_table(153) := '207B0A202020202020202020202020202020202020202069737461736B203D202F5E5C5B5B2078585D5C5D202F2E65786563286974656D436F6E74656E7473293B0A20202020202020202020202020202020202020206966202869737461736B29207B0A';
wwv_flow_imp.g_varchar2_table(154) := '2020202020202020202020202020202020202020202020206973636865636B6564203D2069737461736B5B305D20213D3D20275B205D20273B0A2020202020202020202020202020202020202020202020206974656D436F6E74656E7473203D20697465';
wwv_flow_imp.g_varchar2_table(155) := '6D436F6E74656E74732E7265706C616365282F5E5C5B5B2078585D5C5D202B2F2C202727293B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D0A202020202020202020202020202020206C6973742E';
wwv_flow_imp.g_varchar2_table(156) := '6974656D732E70757368287B0A2020202020202020202020202020202020202020747970653A20276C6973745F6974656D272C0A20202020202020202020202020202020202020207261772C0A2020202020202020202020202020202020202020746173';
wwv_flow_imp.g_varchar2_table(157) := '6B3A20212169737461736B2C0A2020202020202020202020202020202020202020636865636B65643A206973636865636B65642C0A20202020202020202020202020202020202020206C6F6F73653A2066616C73652C0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(158) := '20202020202020746578743A206974656D436F6E74656E74732C0A2020202020202020202020202020202020202020746F6B656E733A205B5D0A202020202020202020202020202020207D293B0A202020202020202020202020202020206C6973742E72';
wwv_flow_imp.g_varchar2_table(159) := '6177202B3D207261773B0A2020202020202020202020207D0A2020202020202020202020202F2F20446F206E6F7420636F6E73756D65206E65776C696E657320617420656E64206F662066696E616C206974656D2E20416C7465726E61746976656C792C';
wwv_flow_imp.g_varchar2_table(160) := '206D616B65206974656D5265676578202A73746172742A207769746820616E79206E65776C696E657320746F2073696D706C6966792F737065656420757020656E647357697468426C616E6B4C696E65206C6F6769630A2020202020202020202020206C';
wwv_flow_imp.g_varchar2_table(161) := '6973742E6974656D735B6C6973742E6974656D732E6C656E677468202D20315D2E726177203D207261772E7472696D456E6428293B0A202020202020202020202020286C6973742E6974656D735B6C6973742E6974656D732E6C656E677468202D20315D';
wwv_flow_imp.g_varchar2_table(162) := '292E74657874203D206974656D436F6E74656E74732E7472696D456E6428293B0A2020202020202020202020206C6973742E726177203D206C6973742E7261772E7472696D456E6428293B0A2020202020202020202020202F2F204974656D206368696C';
wwv_flow_imp.g_varchar2_table(163) := '6420746F6B656E732068616E646C6564206865726520617420656E642062656361757365207765206E656564656420746F2068617665207468652066696E616C206974656D20746F207472696D2069742066697273740A20202020202020202020202066';
wwv_flow_imp.g_varchar2_table(164) := '6F7220286C65742069203D20303B2069203C206C6973742E6974656D732E6C656E6774683B20692B2B29207B0A20202020202020202020202020202020746869732E6C657865722E73746174652E746F70203D2066616C73653B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(165) := '202020202020206C6973742E6974656D735B695D2E746F6B656E73203D20746869732E6C657865722E626C6F636B546F6B656E73286C6973742E6974656D735B695D2E746578742C205B5D293B0A2020202020202020202020202020202069662028216C';
wwv_flow_imp.g_varchar2_table(166) := '6973742E6C6F6F736529207B0A20202020202020202020202020202020202020202F2F20436865636B206966206C6973742073686F756C64206265206C6F6F73650A2020202020202020202020202020202020202020636F6E7374207370616365727320';
wwv_flow_imp.g_varchar2_table(167) := '3D206C6973742E6974656D735B695D2E746F6B656E732E66696C7465722874203D3E20742E74797065203D3D3D2027737061636527293B0A2020202020202020202020202020202020202020636F6E7374206861734D756C7469706C654C696E65427265';
wwv_flow_imp.g_varchar2_table(168) := '616B73203D20737061636572732E6C656E677468203E203020262620737061636572732E736F6D652874203D3E202F5C6E2E2A5C6E2F2E7465737428742E72617729293B0A20202020202020202020202020202020202020206C6973742E6C6F6F736520';
wwv_flow_imp.g_varchar2_table(169) := '3D206861734D756C7469706C654C696E65427265616B733B0A202020202020202020202020202020207D0A2020202020202020202020207D0A2020202020202020202020202F2F2053657420616C6C206974656D7320746F206C6F6F7365206966206C69';
wwv_flow_imp.g_varchar2_table(170) := '7374206973206C6F6F73650A202020202020202020202020696620286C6973742E6C6F6F736529207B0A20202020202020202020202020202020666F7220286C65742069203D20303B2069203C206C6973742E6974656D732E6C656E6774683B20692B2B';
wwv_flow_imp.g_varchar2_table(171) := '29207B0A20202020202020202020202020202020202020206C6973742E6974656D735B695D2E6C6F6F7365203D20747275653B0A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020202020202072657475';
wwv_flow_imp.g_varchar2_table(172) := '726E206C6973743B0A20202020202020207D0A202020207D0A2020202068746D6C2873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E626C6F636B2E68746D6C2E6578656328737263293B0A202020202020';
wwv_flow_imp.g_varchar2_table(173) := '20206966202863617029207B0A202020202020202020202020636F6E737420746F6B656E203D207B0A20202020202020202020202020202020747970653A202768746D6C272C0A20202020202020202020202020202020626C6F636B3A20747275652C0A';
wwv_flow_imp.g_varchar2_table(174) := '202020202020202020202020202020207261773A206361705B305D2C0A202020202020202020202020202020207072653A206361705B315D203D3D3D202770726527207C7C206361705B315D203D3D3D202773637269707427207C7C206361705B315D20';
wwv_flow_imp.g_varchar2_table(175) := '3D3D3D20277374796C65272C0A20202020202020202020202020202020746578743A206361705B305D0A2020202020202020202020207D3B0A20202020202020202020202072657475726E20746F6B656E3B0A20202020202020207D0A202020207D0A20';
wwv_flow_imp.g_varchar2_table(176) := '2020206465662873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E626C6F636B2E6465662E6578656328737263293B0A20202020202020206966202863617029207B0A202020202020202020202020636F6E';
wwv_flow_imp.g_varchar2_table(177) := '737420746167203D206361705B315D2E746F4C6F7765724361736528292E7265706C616365282F5C732B2F672C20272027293B0A202020202020202020202020636F6E73742068726566203D206361705B325D203F206361705B325D2E7265706C616365';
wwv_flow_imp.g_varchar2_table(178) := '282F5E3C282E2A293E242F2C2027243127292E7265706C61636528746869732E72756C65732E696E6C696E652E616E7950756E6374756174696F6E2C202724312729203A2027273B0A202020202020202020202020636F6E7374207469746C65203D2063';
wwv_flow_imp.g_varchar2_table(179) := '61705B335D203F206361705B335D2E737562737472696E6728312C206361705B335D2E6C656E677468202D2031292E7265706C61636528746869732E72756C65732E696E6C696E652E616E7950756E6374756174696F6E2C202724312729203A20636170';
wwv_flow_imp.g_varchar2_table(180) := '5B335D3B0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A2027646566272C0A202020202020202020202020202020207461672C0A202020202020202020202020202020207261773A20636170';
wwv_flow_imp.g_varchar2_table(181) := '5B305D2C0A20202020202020202020202020202020687265662C0A202020202020202020202020202020207469746C650A2020202020202020202020207D3B0A20202020202020207D0A202020207D0A202020207461626C652873726329207B0A202020';
wwv_flow_imp.g_varchar2_table(182) := '2020202020636F6E737420636170203D20746869732E72756C65732E626C6F636B2E7461626C652E6578656328737263293B0A2020202020202020696620282163617029207B0A20202020202020202020202072657475726E3B0A20202020202020207D';
wwv_flow_imp.g_varchar2_table(183) := '0A202020202020202069662028212F5B3A7C5D2F2E74657374286361705B325D2929207B0A2020202020202020202020202F2F2064656C696D6974657220726F77206D75737420686176652061207069706520287C29206F7220636F6C6F6E20283A2920';
wwv_flow_imp.g_varchar2_table(184) := '6F74686572776973652069742069732061207365746578742068656164696E670A20202020202020202020202072657475726E3B0A20202020202020207D0A2020202020202020636F6E73742068656164657273203D2073706C697443656C6C73286361';
wwv_flow_imp.g_varchar2_table(185) := '705B315D293B0A2020202020202020636F6E737420616C69676E73203D206361705B325D2E7265706C616365282F5E5C7C7C5C7C202A242F672C202727292E73706C697428277C27293B0A2020202020202020636F6E737420726F7773203D206361705B';
wwv_flow_imp.g_varchar2_table(186) := '335D202626206361705B335D2E7472696D2829203F206361705B335D2E7265706C616365282F5C6E5B205C745D2A242F2C202727292E73706C697428275C6E2729203A205B5D3B0A2020202020202020636F6E7374206974656D203D207B0A2020202020';
wwv_flow_imp.g_varchar2_table(187) := '20202020202020747970653A20277461626C65272C0A2020202020202020202020207261773A206361705B305D2C0A2020202020202020202020206865616465723A205B5D2C0A202020202020202020202020616C69676E3A205B5D2C0A202020202020';
wwv_flow_imp.g_varchar2_table(188) := '202020202020726F77733A205B5D0A20202020202020207D3B0A202020202020202069662028686561646572732E6C656E67746820213D3D20616C69676E732E6C656E67746829207B0A2020202020202020202020202F2F2068656164657220616E6420';
wwv_flow_imp.g_varchar2_table(189) := '616C69676E20636F6C756D6E73206D75737420626520657175616C2C20726F77732063616E20626520646966666572656E742E0A20202020202020202020202072657475726E3B0A20202020202020207D0A2020202020202020666F722028636F6E7374';
wwv_flow_imp.g_varchar2_table(190) := '20616C69676E206F6620616C69676E7329207B0A202020202020202020202020696620282F5E202A2D2B3A202A242F2E7465737428616C69676E2929207B0A202020202020202020202020202020206974656D2E616C69676E2E70757368282772696768';
wwv_flow_imp.g_varchar2_table(191) := '7427293B0A2020202020202020202020207D0A202020202020202020202020656C736520696620282F5E202A3A2D2B3A202A242F2E7465737428616C69676E2929207B0A202020202020202020202020202020206974656D2E616C69676E2E7075736828';
wwv_flow_imp.g_varchar2_table(192) := '2763656E74657227293B0A2020202020202020202020207D0A202020202020202020202020656C736520696620282F5E202A3A2D2B202A242F2E7465737428616C69676E2929207B0A202020202020202020202020202020206974656D2E616C69676E2E';
wwv_flow_imp.g_varchar2_table(193) := '7075736828276C65667427293B0A2020202020202020202020207D0A202020202020202020202020656C7365207B0A202020202020202020202020202020206974656D2E616C69676E2E70757368286E756C6C293B0A2020202020202020202020207D0A';
wwv_flow_imp.g_varchar2_table(194) := '20202020202020207D0A2020202020202020666F722028636F6E737420686561646572206F66206865616465727329207B0A2020202020202020202020206974656D2E6865616465722E70757368287B0A20202020202020202020202020202020746578';
wwv_flow_imp.g_varchar2_table(195) := '743A206865616465722C0A20202020202020202020202020202020746F6B656E733A20746869732E6C657865722E696E6C696E6528686561646572290A2020202020202020202020207D293B0A20202020202020207D0A2020202020202020666F722028';
wwv_flow_imp.g_varchar2_table(196) := '636F6E737420726F77206F6620726F777329207B0A2020202020202020202020206974656D2E726F77732E707573682873706C697443656C6C7328726F772C206974656D2E6865616465722E6C656E677468292E6D61702863656C6C203D3E207B0A2020';
wwv_flow_imp.g_varchar2_table(197) := '202020202020202020202020202072657475726E207B0A2020202020202020202020202020202020202020746578743A2063656C6C2C0A2020202020202020202020202020202020202020746F6B656E733A20746869732E6C657865722E696E6C696E65';
wwv_flow_imp.g_varchar2_table(198) := '2863656C6C290A202020202020202020202020202020207D3B0A2020202020202020202020207D29293B0A20202020202020207D0A202020202020202072657475726E206974656D3B0A202020207D0A202020206C68656164696E672873726329207B0A';
wwv_flow_imp.g_varchar2_table(199) := '2020202020202020636F6E737420636170203D20746869732E72756C65732E626C6F636B2E6C68656164696E672E6578656328737263293B0A20202020202020206966202863617029207B0A20202020202020202020202072657475726E207B0A202020';
wwv_flow_imp.g_varchar2_table(200) := '20202020202020202020202020747970653A202768656164696E67272C0A202020202020202020202020202020207261773A206361705B305D2C0A2020202020202020202020202020202064657074683A206361705B325D2E636861724174283029203D';
wwv_flow_imp.g_varchar2_table(201) := '3D3D20273D27203F2031203A20322C0A20202020202020202020202020202020746578743A206361705B315D2C0A20202020202020202020202020202020746F6B656E733A20746869732E6C657865722E696E6C696E65286361705B315D290A20202020';
wwv_flow_imp.g_varchar2_table(202) := '20202020202020207D3B0A20202020202020207D0A202020207D0A202020207061726167726170682873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E626C6F636B2E7061726167726170682E6578656328';
wwv_flow_imp.g_varchar2_table(203) := '737263293B0A20202020202020206966202863617029207B0A202020202020202020202020636F6E73742074657874203D206361705B315D2E636861724174286361705B315D2E6C656E677468202D203129203D3D3D20275C6E270A2020202020202020';
wwv_flow_imp.g_varchar2_table(204) := '20202020202020203F206361705B315D2E736C69636528302C202D31290A202020202020202020202020202020203A206361705B315D3B0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A2027';
wwv_flow_imp.g_varchar2_table(205) := '706172616772617068272C0A202020202020202020202020202020207261773A206361705B305D2C0A20202020202020202020202020202020746578742C0A20202020202020202020202020202020746F6B656E733A20746869732E6C657865722E696E';
wwv_flow_imp.g_varchar2_table(206) := '6C696E652874657874290A2020202020202020202020207D3B0A20202020202020207D0A202020207D0A20202020746578742873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E626C6F636B2E746578742E';
wwv_flow_imp.g_varchar2_table(207) := '6578656328737263293B0A20202020202020206966202863617029207B0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A202774657874272C0A20202020202020202020202020202020726177';
wwv_flow_imp.g_varchar2_table(208) := '3A206361705B305D2C0A20202020202020202020202020202020746578743A206361705B305D2C0A20202020202020202020202020202020746F6B656E733A20746869732E6C657865722E696E6C696E65286361705B305D290A20202020202020202020';
wwv_flow_imp.g_varchar2_table(209) := '20207D3B0A20202020202020207D0A202020207D0A202020206573636170652873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E696E6C696E652E6573636170652E6578656328737263293B0A2020202020';
wwv_flow_imp.g_varchar2_table(210) := '2020206966202863617029207B0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A2027657363617065272C0A202020202020202020202020202020207261773A206361705B305D2C0A20202020';
wwv_flow_imp.g_varchar2_table(211) := '202020202020202020202020746578743A206573636170652431286361705B315D290A2020202020202020202020207D3B0A20202020202020207D0A202020207D0A202020207461672873726329207B0A2020202020202020636F6E737420636170203D';
wwv_flow_imp.g_varchar2_table(212) := '20746869732E72756C65732E696E6C696E652E7461672E6578656328737263293B0A20202020202020206966202863617029207B0A2020202020202020202020206966202821746869732E6C657865722E73746174652E696E4C696E6B202626202F5E3C';
wwv_flow_imp.g_varchar2_table(213) := '61202F692E74657374286361705B305D2929207B0A20202020202020202020202020202020746869732E6C657865722E73746174652E696E4C696E6B203D20747275653B0A2020202020202020202020207D0A202020202020202020202020656C736520';
wwv_flow_imp.g_varchar2_table(214) := '69662028746869732E6C657865722E73746174652E696E4C696E6B202626202F5E3C5C2F613E2F692E74657374286361705B305D2929207B0A20202020202020202020202020202020746869732E6C657865722E73746174652E696E4C696E6B203D2066';
wwv_flow_imp.g_varchar2_table(215) := '616C73653B0A2020202020202020202020207D0A2020202020202020202020206966202821746869732E6C657865722E73746174652E696E526177426C6F636B202626202F5E3C287072657C636F64657C6B62647C73637269707429285C737C3E292F69';
wwv_flow_imp.g_varchar2_table(216) := '2E74657374286361705B305D2929207B0A20202020202020202020202020202020746869732E6C657865722E73746174652E696E526177426C6F636B203D20747275653B0A2020202020202020202020207D0A202020202020202020202020656C736520';
wwv_flow_imp.g_varchar2_table(217) := '69662028746869732E6C657865722E73746174652E696E526177426C6F636B202626202F5E3C5C2F287072657C636F64657C6B62647C73637269707429285C737C3E292F692E74657374286361705B305D2929207B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(218) := '2020746869732E6C657865722E73746174652E696E526177426C6F636B203D2066616C73653B0A2020202020202020202020207D0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A202768746D';
wwv_flow_imp.g_varchar2_table(219) := '6C272C0A202020202020202020202020202020207261773A206361705B305D2C0A20202020202020202020202020202020696E4C696E6B3A20746869732E6C657865722E73746174652E696E4C696E6B2C0A20202020202020202020202020202020696E';
wwv_flow_imp.g_varchar2_table(220) := '526177426C6F636B3A20746869732E6C657865722E73746174652E696E526177426C6F636B2C0A20202020202020202020202020202020626C6F636B3A2066616C73652C0A20202020202020202020202020202020746578743A206361705B305D0A2020';
wwv_flow_imp.g_varchar2_table(221) := '202020202020202020207D3B0A20202020202020207D0A202020207D0A202020206C696E6B2873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E696E6C696E652E6C696E6B2E6578656328737263293B0A20';
wwv_flow_imp.g_varchar2_table(222) := '202020202020206966202863617029207B0A202020202020202020202020636F6E7374207472696D6D656455726C203D206361705B325D2E7472696D28293B0A2020202020202020202020206966202821746869732E6F7074696F6E732E706564616E74';
wwv_flow_imp.g_varchar2_table(223) := '6963202626202F5E3C2F2E74657374287472696D6D656455726C2929207B0A202020202020202020202020202020202F2F20636F6D6D6F6E6D61726B207265717569726573206D61746368696E6720616E676C6520627261636B6574730A202020202020';
wwv_flow_imp.g_varchar2_table(224) := '202020202020202020206966202821282F3E242F2E74657374287472696D6D656455726C292929207B0A202020202020202020202020202020202020202072657475726E3B0A202020202020202020202020202020207D0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(225) := '202020202F2F20656E64696E6720616E676C6520627261636B65742063616E6E6F7420626520657363617065640A20202020202020202020202020202020636F6E737420727472696D536C617368203D20727472696D287472696D6D656455726C2E736C';
wwv_flow_imp.g_varchar2_table(226) := '69636528302C202D31292C20275C5C27293B0A2020202020202020202020202020202069662028287472696D6D656455726C2E6C656E677468202D20727472696D536C6173682E6C656E6774682920252032203D3D3D203029207B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(227) := '20202020202020202020202072657475726E3B0A202020202020202020202020202020207D0A2020202020202020202020207D0A202020202020202020202020656C7365207B0A202020202020202020202020202020202F2F2066696E6420636C6F7369';
wwv_flow_imp.g_varchar2_table(228) := '6E6720706172656E7468657369730A20202020202020202020202020202020636F6E7374206C617374506172656E496E646578203D2066696E64436C6F73696E67427261636B6574286361705B325D2C2027282927293B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(229) := '20202020696620286C617374506172656E496E646578203E202D3129207B0A2020202020202020202020202020202020202020636F6E7374207374617274203D206361705B305D2E696E6465784F662827212729203D3D3D2030203F2035203A20343B0A';
wwv_flow_imp.g_varchar2_table(230) := '2020202020202020202020202020202020202020636F6E7374206C696E6B4C656E203D207374617274202B206361705B315D2E6C656E677468202B206C617374506172656E496E6465783B0A20202020202020202020202020202020202020206361705B';
wwv_flow_imp.g_varchar2_table(231) := '325D203D206361705B325D2E737562737472696E6728302C206C617374506172656E496E646578293B0A20202020202020202020202020202020202020206361705B305D203D206361705B305D2E737562737472696E6728302C206C696E6B4C656E292E';
wwv_flow_imp.g_varchar2_table(232) := '7472696D28293B0A20202020202020202020202020202020202020206361705B335D203D2027273B0A202020202020202020202020202020207D0A2020202020202020202020207D0A2020202020202020202020206C65742068726566203D206361705B';
wwv_flow_imp.g_varchar2_table(233) := '325D3B0A2020202020202020202020206C6574207469746C65203D2027273B0A20202020202020202020202069662028746869732E6F7074696F6E732E706564616E74696329207B0A202020202020202020202020202020202F2F2073706C6974207065';
wwv_flow_imp.g_varchar2_table(234) := '64616E746963206872656620616E64207469746C650A20202020202020202020202020202020636F6E7374206C696E6B203D202F5E285B5E27225D2A5B5E5C735D295C732B285B27225D29282E2A295C322F2E657865632868726566293B0A2020202020';
wwv_flow_imp.g_varchar2_table(235) := '2020202020202020202020696620286C696E6B29207B0A202020202020202020202020202020202020202068726566203D206C696E6B5B315D3B0A20202020202020202020202020202020202020207469746C65203D206C696E6B5B335D3B0A20202020';
wwv_flow_imp.g_varchar2_table(236) := '2020202020202020202020207D0A2020202020202020202020207D0A202020202020202020202020656C7365207B0A202020202020202020202020202020207469746C65203D206361705B335D203F206361705B335D2E736C69636528312C202D312920';
wwv_flow_imp.g_varchar2_table(237) := '3A2027273B0A2020202020202020202020207D0A20202020202020202020202068726566203D20687265662E7472696D28293B0A202020202020202020202020696620282F5E3C2F2E7465737428687265662929207B0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(238) := '20202069662028746869732E6F7074696F6E732E706564616E7469632026262021282F3E242F2E74657374287472696D6D656455726C292929207B0A20202020202020202020202020202020202020202F2F20706564616E74696320616C6C6F77732073';
wwv_flow_imp.g_varchar2_table(239) := '74617274696E6720616E676C6520627261636B657420776974686F757420656E64696E6720616E676C6520627261636B65740A202020202020202020202020202020202020202068726566203D20687265662E736C6963652831293B0A20202020202020';
wwv_flow_imp.g_varchar2_table(240) := '2020202020202020207D0A20202020202020202020202020202020656C7365207B0A202020202020202020202020202020202020202068726566203D20687265662E736C69636528312C202D31293B0A202020202020202020202020202020207D0A2020';
wwv_flow_imp.g_varchar2_table(241) := '202020202020202020207D0A20202020202020202020202072657475726E206F75747075744C696E6B286361702C207B0A20202020202020202020202020202020687265663A2068726566203F20687265662E7265706C61636528746869732E72756C65';
wwv_flow_imp.g_varchar2_table(242) := '732E696E6C696E652E616E7950756E6374756174696F6E2C202724312729203A20687265662C0A202020202020202020202020202020207469746C653A207469746C65203F207469746C652E7265706C61636528746869732E72756C65732E696E6C696E';
wwv_flow_imp.g_varchar2_table(243) := '652E616E7950756E6374756174696F6E2C202724312729203A207469746C650A2020202020202020202020207D2C206361705B305D2C20746869732E6C65786572293B0A20202020202020207D0A202020207D0A202020207265666C696E6B287372632C';
wwv_flow_imp.g_varchar2_table(244) := '206C696E6B7329207B0A20202020202020206C6574206361703B0A20202020202020206966202828636170203D20746869732E72756C65732E696E6C696E652E7265666C696E6B2E657865632873726329290A2020202020202020202020207C7C202863';
wwv_flow_imp.g_varchar2_table(245) := '6170203D20746869732E72756C65732E696E6C696E652E6E6F6C696E6B2E6578656328737263292929207B0A202020202020202020202020636F6E7374206C696E6B537472696E67203D20286361705B325D207C7C206361705B315D292E7265706C6163';
wwv_flow_imp.g_varchar2_table(246) := '65282F5C732B2F672C20272027293B0A202020202020202020202020636F6E7374206C696E6B203D206C696E6B735B6C696E6B537472696E672E746F4C6F7765724361736528295D3B0A20202020202020202020202069662028216C696E6B29207B0A20';
wwv_flow_imp.g_varchar2_table(247) := '202020202020202020202020202020636F6E73742074657874203D206361705B305D2E6368617241742830293B0A2020202020202020202020202020202072657475726E207B0A2020202020202020202020202020202020202020747970653A20277465';
wwv_flow_imp.g_varchar2_table(248) := '7874272C0A20202020202020202020202020202020202020207261773A20746578742C0A2020202020202020202020202020202020202020746578740A202020202020202020202020202020207D3B0A2020202020202020202020207D0A202020202020';
wwv_flow_imp.g_varchar2_table(249) := '20202020202072657475726E206F75747075744C696E6B286361702C206C696E6B2C206361705B305D2C20746869732E6C65786572293B0A20202020202020207D0A202020207D0A20202020656D5374726F6E67287372632C206D61736B65645372632C';
wwv_flow_imp.g_varchar2_table(250) := '207072657643686172203D20272729207B0A20202020202020206C6574206D61746368203D20746869732E72756C65732E696E6C696E652E656D5374726F6E674C44656C696D2E6578656328737263293B0A202020202020202069662028216D61746368';
wwv_flow_imp.g_varchar2_table(251) := '290A20202020202020202020202072657475726E3B0A20202020202020202F2F205F2063616E2774206265206265747765656E2074776F20616C7068616E756D65726963732E205C707B4C7D5C707B4E7D20696E636C75646573206E6F6E2D656E676C69';
wwv_flow_imp.g_varchar2_table(252) := '736820616C7068616265742F6E756D626572732061732077656C6C0A2020202020202020696620286D617463685B335D2026262070726576436861722E6D61746368282F5B5C707B4C7D5C707B4E7D5D2F7529290A202020202020202020202020726574';
wwv_flow_imp.g_varchar2_table(253) := '75726E3B0A2020202020202020636F6E7374206E65787443686172203D206D617463685B315D207C7C206D617463685B325D207C7C2027273B0A202020202020202069662028216E65787443686172207C7C20217072657643686172207C7C2074686973';
wwv_flow_imp.g_varchar2_table(254) := '2E72756C65732E696E6C696E652E70756E6374756174696F6E2E657865632870726576436861722929207B0A2020202020202020202020202F2F20756E69636F646520526567657820636F756E747320656D6F6A69206173203120636861723B20737072';
wwv_flow_imp.g_varchar2_table(255) := '65616420696E746F20617272617920666F722070726F70657220636F756E74202875736564206D756C7469706C652074696D65732062656C6F77290A202020202020202020202020636F6E7374206C4C656E677468203D205B2E2E2E6D617463685B305D';
wwv_flow_imp.g_varchar2_table(256) := '5D2E6C656E677468202D20313B0A2020202020202020202020206C6574207244656C696D2C20724C656E6774682C2064656C696D546F74616C203D206C4C656E6774682C206D696444656C696D546F74616C203D20303B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(257) := '636F6E737420656E64526567203D206D617463685B305D5B305D203D3D3D20272A27203F20746869732E72756C65732E696E6C696E652E656D5374726F6E675244656C696D417374203A20746869732E72756C65732E696E6C696E652E656D5374726F6E';
wwv_flow_imp.g_varchar2_table(258) := '675244656C696D556E643B0A202020202020202020202020656E645265672E6C617374496E646578203D20303B0A2020202020202020202020202F2F20436C6970206D61736B656453726320746F2073616D652073656374696F6E206F6620737472696E';
wwv_flow_imp.g_varchar2_table(259) := '672061732073726320286D6F766520746F206C657865723F290A2020202020202020202020206D61736B6564537263203D206D61736B65645372632E736C696365282D31202A207372632E6C656E677468202B206C4C656E677468293B0A202020202020';
wwv_flow_imp.g_varchar2_table(260) := '2020202020207768696C652028286D61746368203D20656E645265672E65786563286D61736B6564537263292920213D206E756C6C29207B0A202020202020202020202020202020207244656C696D203D206D617463685B315D207C7C206D617463685B';
wwv_flow_imp.g_varchar2_table(261) := '325D207C7C206D617463685B335D207C7C206D617463685B345D207C7C206D617463685B355D207C7C206D617463685B365D3B0A2020202020202020202020202020202069662028217244656C696D290A20202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(262) := '20636F6E74696E75653B202F2F20736B69702073696E676C65202A20696E205F5F6162632A6162635F5F0A20202020202020202020202020202020724C656E677468203D205B2E2E2E7244656C696D5D2E6C656E6774683B0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(263) := '2020202020696620286D617463685B335D207C7C206D617463685B345D29207B202F2F20666F756E6420616E6F74686572204C6566742044656C696D0A202020202020202020202020202020202020202064656C696D546F74616C202B3D20724C656E67';
wwv_flow_imp.g_varchar2_table(264) := '74683B0A2020202020202020202020202020202020202020636F6E74696E75653B0A202020202020202020202020202020207D0A20202020202020202020202020202020656C736520696620286D617463685B355D207C7C206D617463685B365D29207B';
wwv_flow_imp.g_varchar2_table(265) := '202F2F20656974686572204C656674206F722052696768742044656C696D0A2020202020202020202020202020202020202020696620286C4C656E67746820252033202626202128286C4C656E677468202B20724C656E67746829202520332929207B0A';
wwv_flow_imp.g_varchar2_table(266) := '2020202020202020202020202020202020202020202020206D696444656C696D546F74616C202B3D20724C656E6774683B0A202020202020202020202020202020202020202020202020636F6E74696E75653B202F2F20436F6D6D6F6E4D61726B20456D';
wwv_flow_imp.g_varchar2_table(267) := '7068617369732052756C657320392D31300A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D0A2020202020202020202020202020202064656C696D546F74616C202D3D20724C656E6774683B0A202020';
wwv_flow_imp.g_varchar2_table(268) := '202020202020202020202020206966202864656C696D546F74616C203E2030290A2020202020202020202020202020202020202020636F6E74696E75653B202F2F20486176656E277420666F756E6420656E6F75676820636C6F73696E672064656C696D';
wwv_flow_imp.g_varchar2_table(269) := '69746572730A202020202020202020202020202020202F2F2052656D6F766520657874726120636861726163746572732E202A612A2A2A202D3E202A612A0A20202020202020202020202020202020724C656E677468203D204D6174682E6D696E28724C';
wwv_flow_imp.g_varchar2_table(270) := '656E6774682C20724C656E677468202B2064656C696D546F74616C202B206D696444656C696D546F74616C293B0A202020202020202020202020202020202F2F2063686172206C656E6774682063616E206265203E3120666F7220756E69636F64652063';
wwv_flow_imp.g_varchar2_table(271) := '6861726163746572733B0A20202020202020202020202020202020636F6E7374206C617374436861724C656E677468203D205B2E2E2E6D617463685B305D5D5B305D2E6C656E6774683B0A20202020202020202020202020202020636F6E737420726177';
wwv_flow_imp.g_varchar2_table(272) := '203D207372632E736C69636528302C206C4C656E677468202B206D617463682E696E646578202B206C617374436861724C656E677468202B20724C656E677468293B0A202020202020202020202020202020202F2F204372656174652060656D60206966';
wwv_flow_imp.g_varchar2_table(273) := '20736D616C6C6573742064656C696D6974657220686173206F6464206368617220636F756E742E202A612A2A2A0A20202020202020202020202020202020696620284D6174682E6D696E286C4C656E6774682C20724C656E677468292025203229207B0A';
wwv_flow_imp.g_varchar2_table(274) := '2020202020202020202020202020202020202020636F6E73742074657874203D207261772E736C69636528312C202D31293B0A202020202020202020202020202020202020202072657475726E207B0A2020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(275) := '20202020747970653A2027656D272C0A2020202020202020202020202020202020202020202020207261772C0A202020202020202020202020202020202020202020202020746578742C0A20202020202020202020202020202020202020202020202074';
wwv_flow_imp.g_varchar2_table(276) := '6F6B656E733A20746869732E6C657865722E696E6C696E65546F6B656E732874657874290A20202020202020202020202020202020202020207D3B0A202020202020202020202020202020207D0A202020202020202020202020202020202F2F20437265';
wwv_flow_imp.g_varchar2_table(277) := '61746520277374726F6E672720696620736D616C6C6573742064656C696D6974657220686173206576656E206368617220636F756E742E202A2A612A2A2A0A20202020202020202020202020202020636F6E73742074657874203D207261772E736C6963';
wwv_flow_imp.g_varchar2_table(278) := '6528322C202D32293B0A2020202020202020202020202020202072657475726E207B0A2020202020202020202020202020202020202020747970653A20277374726F6E67272C0A20202020202020202020202020202020202020207261772C0A20202020';
wwv_flow_imp.g_varchar2_table(279) := '20202020202020202020202020202020746578742C0A2020202020202020202020202020202020202020746F6B656E733A20746869732E6C657865722E696E6C696E65546F6B656E732874657874290A202020202020202020202020202020207D3B0A20';
wwv_flow_imp.g_varchar2_table(280) := '20202020202020202020207D0A20202020202020207D0A202020207D0A20202020636F64657370616E2873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E696E6C696E652E636F64652E6578656328737263';
wwv_flow_imp.g_varchar2_table(281) := '293B0A20202020202020206966202863617029207B0A2020202020202020202020206C65742074657874203D206361705B325D2E7265706C616365282F5C6E2F672C20272027293B0A202020202020202020202020636F6E7374206861734E6F6E537061';
wwv_flow_imp.g_varchar2_table(282) := '63654368617273203D202F5B5E205D2F2E746573742874657874293B0A202020202020202020202020636F6E737420686173537061636543686172734F6E426F7468456E6473203D202F5E202F2E74657374287465787429202626202F20242F2E746573';
wwv_flow_imp.g_varchar2_table(283) := '742874657874293B0A202020202020202020202020696620286861734E6F6E5370616365436861727320262620686173537061636543686172734F6E426F7468456E647329207B0A2020202020202020202020202020202074657874203D20746578742E';
wwv_flow_imp.g_varchar2_table(284) := '737562737472696E6728312C20746578742E6C656E677468202D2031293B0A2020202020202020202020207D0A20202020202020202020202074657874203D20657363617065243128746578742C2074727565293B0A2020202020202020202020207265';
wwv_flow_imp.g_varchar2_table(285) := '7475726E207B0A20202020202020202020202020202020747970653A2027636F64657370616E272C0A202020202020202020202020202020207261773A206361705B305D2C0A20202020202020202020202020202020746578740A202020202020202020';
wwv_flow_imp.g_varchar2_table(286) := '2020207D3B0A20202020202020207D0A202020207D0A2020202062722873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E696E6C696E652E62722E6578656328737263293B0A202020202020202069662028';
wwv_flow_imp.g_varchar2_table(287) := '63617029207B0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A20276272272C0A202020202020202020202020202020207261773A206361705B305D0A2020202020202020202020207D3B0A20';
wwv_flow_imp.g_varchar2_table(288) := '202020202020207D0A202020207D0A2020202064656C2873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E696E6C696E652E64656C2E6578656328737263293B0A2020202020202020696620286361702920';
wwv_flow_imp.g_varchar2_table(289) := '7B0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A202764656C272C0A202020202020202020202020202020207261773A206361705B305D2C0A20202020202020202020202020202020746578';
wwv_flow_imp.g_varchar2_table(290) := '743A206361705B325D2C0A20202020202020202020202020202020746F6B656E733A20746869732E6C657865722E696E6C696E65546F6B656E73286361705B325D290A2020202020202020202020207D3B0A20202020202020207D0A202020207D0A2020';
wwv_flow_imp.g_varchar2_table(291) := '20206175746F6C696E6B2873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E696E6C696E652E6175746F6C696E6B2E6578656328737263293B0A20202020202020206966202863617029207B0A2020202020';
wwv_flow_imp.g_varchar2_table(292) := '202020202020206C657420746578742C20687265663B0A202020202020202020202020696620286361705B325D203D3D3D2027402729207B0A2020202020202020202020202020202074657874203D206573636170652431286361705B315D293B0A2020';
wwv_flow_imp.g_varchar2_table(293) := '202020202020202020202020202068726566203D20276D61696C746F3A27202B20746578743B0A2020202020202020202020207D0A202020202020202020202020656C7365207B0A2020202020202020202020202020202074657874203D206573636170';
wwv_flow_imp.g_varchar2_table(294) := '652431286361705B315D293B0A2020202020202020202020202020202068726566203D20746578743B0A2020202020202020202020207D0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A2027';
wwv_flow_imp.g_varchar2_table(295) := '6C696E6B272C0A202020202020202020202020202020207261773A206361705B305D2C0A20202020202020202020202020202020746578742C0A20202020202020202020202020202020687265662C0A20202020202020202020202020202020746F6B65';
wwv_flow_imp.g_varchar2_table(296) := '6E733A205B0A20202020202020202020202020202020202020207B0A202020202020202020202020202020202020202020202020747970653A202774657874272C0A2020202020202020202020202020202020202020202020207261773A20746578742C';
wwv_flow_imp.g_varchar2_table(297) := '0A202020202020202020202020202020202020202020202020746578740A20202020202020202020202020202020202020207D0A202020202020202020202020202020205D0A2020202020202020202020207D3B0A20202020202020207D0A202020207D';
wwv_flow_imp.g_varchar2_table(298) := '0A2020202075726C2873726329207B0A20202020202020206C6574206361703B0A202020202020202069662028636170203D20746869732E72756C65732E696E6C696E652E75726C2E65786563287372632929207B0A2020202020202020202020206C65';
wwv_flow_imp.g_varchar2_table(299) := '7420746578742C20687265663B0A202020202020202020202020696620286361705B325D203D3D3D2027402729207B0A2020202020202020202020202020202074657874203D206573636170652431286361705B305D293B0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(300) := '202020202068726566203D20276D61696C746F3A27202B20746578743B0A2020202020202020202020207D0A202020202020202020202020656C7365207B0A202020202020202020202020202020202F2F20646F20657874656E646564206175746F6C69';
wwv_flow_imp.g_varchar2_table(301) := '6E6B20706174682076616C69646174696F6E0A202020202020202020202020202020206C657420707265764361705A65726F3B0A20202020202020202020202020202020646F207B0A202020202020202020202020202020202020202070726576436170';
wwv_flow_imp.g_varchar2_table(302) := '5A65726F203D206361705B305D3B0A20202020202020202020202020202020202020206361705B305D203D20746869732E72756C65732E696E6C696E652E5F6261636B706564616C2E65786563286361705B305D293F2E5B305D203F3F2027273B0A2020';
wwv_flow_imp.g_varchar2_table(303) := '20202020202020202020202020207D207768696C652028707265764361705A65726F20213D3D206361705B305D293B0A2020202020202020202020202020202074657874203D206573636170652431286361705B305D293B0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(304) := '2020202020696620286361705B315D203D3D3D20277777772E2729207B0A202020202020202020202020202020202020202068726566203D2027687474703A2F2F27202B206361705B305D3B0A202020202020202020202020202020207D0A2020202020';
wwv_flow_imp.g_varchar2_table(305) := '2020202020202020202020656C7365207B0A202020202020202020202020202020202020202068726566203D206361705B305D3B0A202020202020202020202020202020207D0A2020202020202020202020207D0A202020202020202020202020726574';
wwv_flow_imp.g_varchar2_table(306) := '75726E207B0A20202020202020202020202020202020747970653A20276C696E6B272C0A202020202020202020202020202020207261773A206361705B305D2C0A20202020202020202020202020202020746578742C0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(307) := '202020687265662C0A20202020202020202020202020202020746F6B656E733A205B0A20202020202020202020202020202020202020207B0A202020202020202020202020202020202020202020202020747970653A202774657874272C0A2020202020';
wwv_flow_imp.g_varchar2_table(308) := '202020202020202020202020202020202020207261773A20746578742C0A202020202020202020202020202020202020202020202020746578740A20202020202020202020202020202020202020207D0A202020202020202020202020202020205D0A20';
wwv_flow_imp.g_varchar2_table(309) := '20202020202020202020207D3B0A20202020202020207D0A202020207D0A20202020696E6C696E65546578742873726329207B0A2020202020202020636F6E737420636170203D20746869732E72756C65732E696E6C696E652E746578742E6578656328';
wwv_flow_imp.g_varchar2_table(310) := '737263293B0A20202020202020206966202863617029207B0A2020202020202020202020206C657420746578743B0A20202020202020202020202069662028746869732E6C657865722E73746174652E696E526177426C6F636B29207B0A202020202020';
wwv_flow_imp.g_varchar2_table(311) := '2020202020202020202074657874203D206361705B305D3B0A2020202020202020202020207D0A202020202020202020202020656C7365207B0A2020202020202020202020202020202074657874203D206573636170652431286361705B305D293B0A20';
wwv_flow_imp.g_varchar2_table(312) := '20202020202020202020207D0A20202020202020202020202072657475726E207B0A20202020202020202020202020202020747970653A202774657874272C0A202020202020202020202020202020207261773A206361705B305D2C0A20202020202020';
wwv_flow_imp.g_varchar2_table(313) := '202020202020202020746578740A2020202020202020202020207D3B0A20202020202020207D0A202020207D0A7D0A0A2F2A2A0A202A20426C6F636B2D4C6576656C204772616D6D61720A202A2F0A636F6E7374206E65776C696E65203D202F5E283F3A';
wwv_flow_imp.g_varchar2_table(314) := '202A283F3A5C6E7C2429292B2F3B0A636F6E737420626C6F636B436F6465203D202F5E28207B347D5B5E5C6E5D2B283F3A5C6E283F3A202A283F3A5C6E7C2429292A293F292B2F3B0A636F6E73742066656E636573203D202F5E207B302C337D28607B33';
wwv_flow_imp.g_varchar2_table(315) := '2C7D283F3D5B5E605C6E5D2A283F3A5C6E7C2429297C7E7B332C7D29285B5E5C6E5D2A29283F3A5C6E7C2429283F3A7C285B5C735C535D2A3F29283F3A5C6E7C242929283F3A207B302C337D5C315B7E605D2A202A283F3D5C6E7C24297C24292F3B0A63';
wwv_flow_imp.g_varchar2_table(316) := '6F6E7374206872203D202F5E207B302C337D28283F3A2D5B5C74205D2A297B332C7D7C283F3A5F5B205C745D2A297B332C7D7C283F3A5C2A5B205C745D2A297B332C7D29283F3A5C6E2B7C24292F3B0A636F6E73742068656164696E67203D202F5E207B';
wwv_flow_imp.g_varchar2_table(317) := '302C337D28237B312C367D29283F3D5C737C2429282E2A29283F3A5C6E2B7C24292F3B0A636F6E73742062756C6C6574203D202F283F3A5B2A2B2D5D7C5C647B312C397D5B2E295D292F3B0A636F6E7374206C68656164696E67203D2065646974282F5E';
wwv_flow_imp.g_varchar2_table(318) := '283F2162756C6C207C626C6F636B436F64657C66656E6365737C626C6F636B71756F74657C68656164696E677C68746D6C2928283F3A2E7C5C6E283F215C732A3F5C6E7C62756C6C207C626C6F636B436F64657C66656E6365737C626C6F636B71756F74';
wwv_flow_imp.g_varchar2_table(319) := '657C68656164696E677C68746D6C29292B3F295C6E207B302C337D283D2B7C2D2B29202A283F3A5C6E2B7C24292F290A202020202E7265706C616365282F62756C6C2F672C2062756C6C657429202F2F206C697374732063616E20696E74657272757074';
wwv_flow_imp.g_varchar2_table(320) := '0A202020202E7265706C616365282F626C6F636B436F64652F672C202F207B347D2F29202F2F20696E64656E74656420636F646520626C6F636B732063616E20696E746572727570740A202020202E7265706C616365282F66656E6365732F672C202F20';
wwv_flow_imp.g_varchar2_table(321) := '7B302C337D283F3A607B332C7D7C7E7B332C7D292F29202F2F2066656E63656420636F646520626C6F636B732063616E20696E746572727570740A202020202E7265706C616365282F626C6F636B71756F74652F672C202F207B302C337D3E2F29202F2F';
wwv_flow_imp.g_varchar2_table(322) := '20626C6F636B71756F74652063616E20696E746572727570740A202020202E7265706C616365282F68656164696E672F672C202F207B302C337D237B312C367D2F29202F2F204154582068656164696E672063616E20696E746572727570740A20202020';
wwv_flow_imp.g_varchar2_table(323) := '2E7265706C616365282F68746D6C2F672C202F207B302C337D3C5B5E5C6E3E5D2B3E5C6E2F29202F2F20626C6F636B2068746D6C2063616E20696E746572727570740A202020202E676574526567657828293B0A636F6E7374205F706172616772617068';
wwv_flow_imp.g_varchar2_table(324) := '203D202F5E285B5E5C6E5D2B283F3A5C6E283F2168727C68656164696E677C6C68656164696E677C626C6F636B71756F74657C66656E6365737C6C6973747C68746D6C7C7461626C657C202B5C6E295B5E5C6E5D2B292A292F3B0A636F6E737420626C6F';
wwv_flow_imp.g_varchar2_table(325) := '636B54657874203D202F5E5B5E5C6E5D2B2F3B0A636F6E7374205F626C6F636B4C6162656C203D202F283F215C732A5C5D29283F3A5C5C2E7C5B5E5C5B5C5D5C5C5D292B2F3B0A636F6E737420646566203D2065646974282F5E207B302C337D5C5B286C';
wwv_flow_imp.g_varchar2_table(326) := '6162656C295C5D3A202A283F3A5C6E202A293F285B5E3C5C735D5B5E5C735D2A7C3C2E2A3F3E29283F3A283F3A202B283F3A5C6E202A293F7C202A5C6E202A29287469746C6529293F202A283F3A5C6E2B7C24292F290A202020202E7265706C61636528';
wwv_flow_imp.g_varchar2_table(327) := '276C6162656C272C205F626C6F636B4C6162656C290A202020202E7265706C61636528277469746C65272C202F283F3A22283F3A5C5C223F7C5B5E225C5C5D292A227C275B5E275C6E5D2A283F3A5C6E5B5E275C6E5D2B292A5C6E3F277C5C285B5E2829';
wwv_flow_imp.g_varchar2_table(328) := '5D2A5C29292F290A202020202E676574526567657828293B0A636F6E7374206C697374203D2065646974282F5E28207B302C337D62756C6C29285B205C745D5B5E5C6E5D2B3F293F283F3A5C6E7C24292F290A202020202E7265706C616365282F62756C';
wwv_flow_imp.g_varchar2_table(329) := '6C2F672C2062756C6C6574290A202020202E676574526567657828293B0A636F6E7374205F746167203D2027616464726573737C61727469636C657C61736964657C626173657C62617365666F6E747C626C6F636B71756F74657C626F64797C63617074';
wwv_flow_imp.g_varchar2_table(330) := '696F6E270A202020202B20277C63656E7465727C636F6C7C636F6C67726F75707C64647C64657461696C737C6469616C6F677C6469727C6469767C646C7C64747C6669656C647365747C66696763617074696F6E270A202020202B20277C666967757265';
wwv_flow_imp.g_varchar2_table(331) := '7C666F6F7465727C666F726D7C6672616D657C6672616D657365747C685B312D365D7C686561647C6865616465727C68727C68746D6C7C696672616D65270A202020202B20277C6C6567656E647C6C697C6C696E6B7C6D61696E7C6D656E757C6D656E75';
wwv_flow_imp.g_varchar2_table(332) := '6974656D7C6D6574617C6E61767C6E6F6672616D65737C6F6C7C6F707467726F75707C6F7074696F6E270A202020202B20277C707C706172616D7C7365617263687C73656374696F6E7C73756D6D6172797C7461626C657C74626F64797C74647C74666F';
wwv_flow_imp.g_varchar2_table(333) := '6F747C74687C74686561647C7469746C65270A202020202B20277C74727C747261636B7C756C273B0A636F6E7374205F636F6D6D656E74203D202F3C212D2D283F3A2D3F3E7C5B5C735C535D2A3F283F3A2D2D3E7C2429292F3B0A636F6E73742068746D';
wwv_flow_imp.g_varchar2_table(334) := '6C203D206564697428275E207B302C337D283F3A27202F2F206F7074696F6E616C20696E64656E746174696F6E0A202020202B20273C287363726970747C7072657C7374796C657C7465787461726561295B5C5C733E5D5B5C5C735C5C535D2A3F283F3A';
wwv_flow_imp.g_varchar2_table(335) := '3C2F5C5C313E5B5E5C5C6E5D2A5C5C6E2B7C242927202F2F202831290A202020202B20277C636F6D6D656E745B5E5C5C6E5D2A285C5C6E2B7C242927202F2F202832290A202020202B20277C3C5C5C3F5B5C5C735C5C535D2A3F283F3A5C5C3F3E5C5C6E';
wwv_flow_imp.g_varchar2_table(336) := '2A7C242927202F2F202833290A202020202B20277C3C215B412D5A5D5B5C5C735C5C535D2A3F283F3A3E5C5C6E2A7C242927202F2F202834290A202020202B20277C3C215C5C5B43444154415C5C5B5B5C5C735C5C535D2A3F283F3A5C5C5D5C5C5D3E5C';
wwv_flow_imp.g_varchar2_table(337) := '5C6E2A7C242927202F2F202835290A202020202B20277C3C2F3F2874616729283F3A202B7C5C5C6E7C2F3F3E295B5C5C735C5C535D2A3F283F3A283F3A5C5C6E202A292B5C5C6E7C242927202F2F202836290A202020202B20277C3C283F217363726970';
wwv_flow_imp.g_varchar2_table(338) := '747C7072657C7374796C657C746578746172656129285B612D7A5D5B5C5C772D5D2A29283F3A617474726962757465292A3F202A2F3F3E283F3D5B205C5C745D2A283F3A5C5C6E7C2429295B5C5C735C5C535D2A3F283F3A283F3A5C5C6E202A292B5C5C';
wwv_flow_imp.g_varchar2_table(339) := '6E7C242927202F2F20283729206F70656E207461670A202020202B20277C3C2F283F217363726970747C7072657C7374796C657C7465787461726561295B612D7A5D5B5C5C772D5D2A5C5C732A3E283F3D5B205C5C745D2A283F3A5C5C6E7C2429295B5C';
wwv_flow_imp.g_varchar2_table(340) := '5C735C5C535D2A3F283F3A283F3A5C5C6E202A292B5C5C6E7C242927202F2F2028372920636C6F73696E67207461670A202020202B202729272C20276927290A202020202E7265706C6163652827636F6D6D656E74272C205F636F6D6D656E74290A2020';
wwv_flow_imp.g_varchar2_table(341) := '20202E7265706C6163652827746167272C205F746167290A202020202E7265706C6163652827617474726962757465272C202F202B5B612D7A412D5A3A5F5D5B5C772E3A2D5D2A283F3A202A3D202A225B5E225C6E5D2A227C202A3D202A275B5E275C6E';
wwv_flow_imp.g_varchar2_table(342) := '5D2A277C202A3D202A5B5E5C7322273D3C3E605D2B293F2F290A202020202E676574526567657828293B0A636F6E737420706172616772617068203D2065646974285F706172616772617068290A202020202E7265706C61636528276872272C20687229';
wwv_flow_imp.g_varchar2_table(343) := '0A202020202E7265706C616365282768656164696E67272C2027207B302C337D237B312C367D283F3A5C5C737C242927290A202020202E7265706C61636528277C6C68656164696E67272C20272729202F2F2073657465782068656164696E677320646F';
wwv_flow_imp.g_varchar2_table(344) := '6E277420696E7465727275707420636F6D6D6F6E6D61726B20706172616772617068730A202020202E7265706C61636528277C7461626C65272C202727290A202020202E7265706C6163652827626C6F636B71756F7465272C2027207B302C337D3E2729';
wwv_flow_imp.g_varchar2_table(345) := '0A202020202E7265706C616365282766656E636573272C2027207B302C337D283F3A607B332C7D283F3D5B5E605C5C6E5D2A5C5C6E297C7E7B332C7D295B5E5C5C6E5D2A5C5C6E27290A202020202E7265706C61636528276C697374272C2027207B302C';
wwv_flow_imp.g_varchar2_table(346) := '337D283F3A5B2A2B2D5D7C315B2E295D29202729202F2F206F6E6C79206C69737473207374617274696E672066726F6D20312063616E20696E746572727570740A202020202E7265706C616365282768746D6C272C20273C2F3F283F3A74616729283F3A';
wwv_flow_imp.g_varchar2_table(347) := '202B7C5C5C6E7C2F3F3E297C3C283F3A7363726970747C7072657C7374796C657C74657874617265617C212D2D2927290A202020202E7265706C6163652827746167272C205F74616729202F2F20706172732063616E20626520696E7465727275707465';
wwv_flow_imp.g_varchar2_table(348) := '642062792074797065202836292068746D6C20626C6F636B730A202020202E676574526567657828293B0A636F6E737420626C6F636B71756F7465203D2065646974282F5E28207B302C337D3E203F287061726167726170687C5B5E5C6E5D2A29283F3A';
wwv_flow_imp.g_varchar2_table(349) := '5C6E7C2429292B2F290A202020202E7265706C6163652827706172616772617068272C20706172616772617068290A202020202E676574526567657828293B0A2F2A2A0A202A204E6F726D616C20426C6F636B204772616D6D61720A202A2F0A636F6E73';
wwv_flow_imp.g_varchar2_table(350) := '7420626C6F636B4E6F726D616C203D207B0A20202020626C6F636B71756F74652C0A20202020636F64653A20626C6F636B436F64652C0A202020206465662C0A2020202066656E6365732C0A2020202068656164696E672C0A2020202068722C0A202020';
wwv_flow_imp.g_varchar2_table(351) := '2068746D6C2C0A202020206C68656164696E672C0A202020206C6973742C0A202020206E65776C696E652C0A202020207061726167726170682C0A202020207461626C653A206E6F6F70546573742C0A20202020746578743A20626C6F636B546578740A';
wwv_flow_imp.g_varchar2_table(352) := '7D3B0A2F2A2A0A202A2047464D20426C6F636B204772616D6D61720A202A2F0A636F6E73742067666D5461626C65203D206564697428275E202A285B5E5C5C6E205D2E2A295C5C6E27202F2F204865616465720A202020202B2027207B302C337D28283F';
wwv_flow_imp.g_varchar2_table(353) := '3A5C5C7C202A293F3A3F2D2B3A3F202A283F3A5C5C7C202A3A3F2D2B3A3F202A292A283F3A5C5C7C202A293F2927202F2F20416C69676E0A202020202B2027283F3A5C5C6E28283F3A283F21202A5C5C6E7C68727C68656164696E677C626C6F636B7175';
wwv_flow_imp.g_varchar2_table(354) := '6F74657C636F64657C66656E6365737C6C6973747C68746D6C292E2A283F3A5C5C6E7C2429292A295C5C6E2A7C24292729202F2F2043656C6C730A202020202E7265706C61636528276872272C206872290A202020202E7265706C616365282768656164';
wwv_flow_imp.g_varchar2_table(355) := '696E67272C2027207B302C337D237B312C367D283F3A5C5C737C242927290A202020202E7265706C6163652827626C6F636B71756F7465272C2027207B302C337D3E27290A202020202E7265706C6163652827636F6465272C2027207B347D5B5E5C5C6E';
wwv_flow_imp.g_varchar2_table(356) := '5D27290A202020202E7265706C616365282766656E636573272C2027207B302C337D283F3A607B332C7D283F3D5B5E605C5C6E5D2A5C5C6E297C7E7B332C7D295B5E5C5C6E5D2A5C5C6E27290A202020202E7265706C61636528276C697374272C202720';
wwv_flow_imp.g_varchar2_table(357) := '7B302C337D283F3A5B2A2B2D5D7C315B2E295D29202729202F2F206F6E6C79206C69737473207374617274696E672066726F6D20312063616E20696E746572727570740A202020202E7265706C616365282768746D6C272C20273C2F3F283F3A74616729';
wwv_flow_imp.g_varchar2_table(358) := '283F3A202B7C5C5C6E7C2F3F3E297C3C283F3A7363726970747C7072657C7374796C657C74657874617265617C212D2D2927290A202020202E7265706C6163652827746167272C205F74616729202F2F207461626C65732063616E20626520696E746572';
wwv_flow_imp.g_varchar2_table(359) := '7275707465642062792074797065202836292068746D6C20626C6F636B730A202020202E676574526567657828293B0A636F6E737420626C6F636B47666D203D207B0A202020202E2E2E626C6F636B4E6F726D616C2C0A202020207461626C653A206766';
wwv_flow_imp.g_varchar2_table(360) := '6D5461626C652C0A202020207061726167726170683A2065646974285F706172616772617068290A20202020202020202E7265706C61636528276872272C206872290A20202020202020202E7265706C616365282768656164696E67272C2027207B302C';
wwv_flow_imp.g_varchar2_table(361) := '337D237B312C367D283F3A5C5C737C242927290A20202020202020202E7265706C61636528277C6C68656164696E67272C20272729202F2F2073657465782068656164696E677320646F6E277420696E7465727275707420636F6D6D6F6E6D61726B2070';
wwv_flow_imp.g_varchar2_table(362) := '6172616772617068730A20202020202020202E7265706C61636528277461626C65272C2067666D5461626C6529202F2F20696E7465727275707420706172616772617068732077697468207461626C650A20202020202020202E7265706C616365282762';
wwv_flow_imp.g_varchar2_table(363) := '6C6F636B71756F7465272C2027207B302C337D3E27290A20202020202020202E7265706C616365282766656E636573272C2027207B302C337D283F3A607B332C7D283F3D5B5E605C5C6E5D2A5C5C6E297C7E7B332C7D295B5E5C5C6E5D2A5C5C6E27290A';
wwv_flow_imp.g_varchar2_table(364) := '20202020202020202E7265706C61636528276C697374272C2027207B302C337D283F3A5B2A2B2D5D7C315B2E295D29202729202F2F206F6E6C79206C69737473207374617274696E672066726F6D20312063616E20696E746572727570740A2020202020';
wwv_flow_imp.g_varchar2_table(365) := '2020202E7265706C616365282768746D6C272C20273C2F3F283F3A74616729283F3A202B7C5C5C6E7C2F3F3E297C3C283F3A7363726970747C7072657C7374796C657C74657874617265617C212D2D2927290A20202020202020202E7265706C61636528';
wwv_flow_imp.g_varchar2_table(366) := '27746167272C205F74616729202F2F20706172732063616E20626520696E7465727275707465642062792074797065202836292068746D6C20626C6F636B730A20202020202020202E676574526567657828290A7D3B0A2F2A2A0A202A20506564616E74';
wwv_flow_imp.g_varchar2_table(367) := '6963206772616D6D617220286F726967696E616C204A6F686E204772756265722773206C6F6F7365206D61726B646F776E2073706563696669636174696F6E290A202A2F0A636F6E737420626C6F636B506564616E746963203D207B0A202020202E2E2E';
wwv_flow_imp.g_varchar2_table(368) := '626C6F636B4E6F726D616C2C0A2020202068746D6C3A206564697428275E202A283F3A636F6D6D656E74202A283F3A5C5C6E7C5C5C732A2429270A20202020202020202B20277C3C28746167295B5C5C735C5C535D2B3F3C2F5C5C313E202A283F3A5C5C';
wwv_flow_imp.g_varchar2_table(369) := '6E7B322C7D7C5C5C732A242927202F2F20636C6F736564207461670A20202020202020202B20277C3C746167283F3A225B5E225D2A227C5C275B5E5C275D2A5C277C5C5C735B5E5C27222F3E5C5C735D2A292A3F2F3F3E202A283F3A5C5C6E7B322C7D7C';
wwv_flow_imp.g_varchar2_table(370) := '5C5C732A24292927290A20202020202020202E7265706C6163652827636F6D6D656E74272C205F636F6D6D656E74290A20202020202020202E7265706C616365282F7461672F672C2027283F21283F3A270A20202020202020202B2027617C656D7C7374';
wwv_flow_imp.g_varchar2_table(371) := '726F6E677C736D616C6C7C737C636974657C717C64666E7C616262727C646174617C74696D657C636F64657C7661727C73616D707C6B62647C737562270A20202020202020202B20277C7375707C697C627C757C6D61726B7C727562797C72747C72707C';
wwv_flow_imp.g_varchar2_table(372) := '6264697C62646F7C7370616E7C62727C7762727C696E737C64656C7C696D6729270A20202020202020202B20275C5C62295C5C772B283F213A7C5B5E5C5C775C5C73405D2A40295C5C6227290A20202020202020202E676574526567657828292C0A2020';
wwv_flow_imp.g_varchar2_table(373) := '20206465663A202F5E202A5C5B285B5E5C5D5D2B295C5D3A202A3C3F285B5E5C733E5D2B293E3F283F3A202B285B22285D5B5E5C6E5D2B5B22295D29293F202A283F3A5C6E2B7C24292F2C0A2020202068656164696E673A202F5E28237B312C367D2928';
wwv_flow_imp.g_varchar2_table(374) := '2E2A29283F3A5C6E2B7C24292F2C0A2020202066656E6365733A206E6F6F70546573742C202F2F2066656E636573206E6F7420737570706F727465640A202020206C68656164696E673A202F5E282E2B3F295C6E207B302C337D283D2B7C2D2B29202A28';
wwv_flow_imp.g_varchar2_table(375) := '3F3A5C6E2B7C24292F2C0A202020207061726167726170683A2065646974285F706172616772617068290A20202020202020202E7265706C61636528276872272C206872290A20202020202020202E7265706C616365282768656164696E67272C202720';
wwv_flow_imp.g_varchar2_table(376) := '2A237B312C367D202A5B5E5C6E5D27290A20202020202020202E7265706C61636528276C68656164696E67272C206C68656164696E67290A20202020202020202E7265706C61636528277C7461626C65272C202727290A20202020202020202E7265706C';
wwv_flow_imp.g_varchar2_table(377) := '6163652827626C6F636B71756F7465272C2027207B302C337D3E27290A20202020202020202E7265706C61636528277C66656E636573272C202727290A20202020202020202E7265706C61636528277C6C697374272C202727290A20202020202020202E';
wwv_flow_imp.g_varchar2_table(378) := '7265706C61636528277C68746D6C272C202727290A20202020202020202E7265706C61636528277C746167272C202727290A20202020202020202E676574526567657828290A7D3B0A2F2A2A0A202A20496E6C696E652D4C6576656C204772616D6D6172';
wwv_flow_imp.g_varchar2_table(379) := '0A202A2F0A636F6E737420657363617065203D202F5E5C5C285B2122232425262728292A2B2C5C2D2E2F3A3B3C3D3E3F405C5B5C5D5C5C5E5F607B7C7D7E5D292F3B0A636F6E737420696E6C696E65436F6465203D202F5E28602B29285B5E605D7C5B5E';
wwv_flow_imp.g_varchar2_table(380) := '605D5B5C735C535D2A3F5B5E605D295C31283F2160292F3B0A636F6E7374206272203D202F5E28207B322C7D7C5C5C295C6E283F215C732A24292F3B0A636F6E737420696E6C696E6554657874203D202F5E28602B7C5B5E605D29283F3A283F3D207B32';
wwv_flow_imp.g_varchar2_table(381) := '2C7D5C6E297C5B5C735C535D2A3F283F3A283F3D5B5C5C3C215C5B602A5F5D7C5C625F7C24297C5B5E205D283F3D207B322C7D5C6E2929292F3B0A2F2F206C697374206F6620756E69636F64652070756E6374756174696F6E206D61726B732C20706C75';
wwv_flow_imp.g_varchar2_table(382) := '7320616E79206D697373696E6720636861726163746572732066726F6D20436F6D6D6F6E4D61726B20737065630A636F6E7374205F70756E6374756174696F6E203D20275C5C707B507D5C5C707B537D273B0A636F6E73742070756E6374756174696F6E';
wwv_flow_imp.g_varchar2_table(383) := '203D2065646974282F5E28283F215B2A5F5D295B5C7370756E6374756174696F6E5D292F2C20277527290A202020202E7265706C616365282F70756E6374756174696F6E2F672C205F70756E6374756174696F6E292E676574526567657828293B0A2F2F';
wwv_flow_imp.g_varchar2_table(384) := '2073657175656E63657320656D2073686F756C6420736B6970206F766572205B7469746C655D286C696E6B292C2060636F6465602C203C68746D6C3E0A636F6E737420626C6F636B536B6970203D202F5C5B5B5E5B5C5D5D2A3F5C5D5C285B5E5C285C29';
wwv_flow_imp.g_varchar2_table(385) := '5D2A3F5C297C605B5E605D2A3F607C3C5B5E3C3E5D2A3F3E2F673B0A636F6E737420656D5374726F6E674C44656C696D203D2065646974282F5E283F3A5C2A2B283F3A28283F215C2A295B70756E63745D297C5B5E5C732A5D29297C5E5F2B283F3A2828';
wwv_flow_imp.g_varchar2_table(386) := '3F215F295B70756E63745D297C285B5E5C735F5D29292F2C20277527290A202020202E7265706C616365282F70756E63742F672C205F70756E6374756174696F6E290A202020202E676574526567657828293B0A636F6E737420656D5374726F6E675244';
wwv_flow_imp.g_varchar2_table(387) := '656C696D417374203D206564697428275E5B5E5F2A5D2A3F5F5F5B5E5F2A5D2A3F5C5C2A5B5E5F2A5D2A3F283F3D5F5F2927202F2F20536B6970206F727068616E20696E73696465207374726F6E670A202020202B20277C5B5E2A5D2B283F3D5B5E2A5D';
wwv_flow_imp.g_varchar2_table(388) := '2927202F2F20436F6E73756D6520746F2064656C696D0A202020202B20277C283F215C5C2A295B70756E63745D285C5C2A2B29283F3D5B5C5C735D7C242927202F2F2028312920232A2A2A2063616E206F6E6C7920626520612052696768742044656C69';
wwv_flow_imp.g_varchar2_table(389) := '6D697465720A202020202B20277C5B5E70756E63745C5C735D285C5C2A2B29283F215C5C2A29283F3D5B70756E63745C5C735D7C242927202F2F2028322920612A2A2A232C20612A2A2A2063616E206F6E6C7920626520612052696768742044656C696D';
wwv_flow_imp.g_varchar2_table(390) := '697465720A202020202B20277C283F215C5C2A295B70756E63745C5C735D285C5C2A2B29283F3D5B5E70756E63745C5C735D2927202F2F2028332920232A2A2A612C202A2A2A612063616E206F6E6C79206265204C6566742044656C696D697465720A20';
wwv_flow_imp.g_varchar2_table(391) := '2020202B20277C5B5C5C735D285C5C2A2B29283F215C5C2A29283F3D5B70756E63745D2927202F2F20283429202A2A2A232063616E206F6E6C79206265204C6566742044656C696D697465720A202020202B20277C283F215C5C2A295B70756E63745D28';
wwv_flow_imp.g_varchar2_table(392) := '5C5C2A2B29283F215C5C2A29283F3D5B70756E63745D2927202F2F2028352920232A2A2A232063616E20626520656974686572204C656674206F722052696768742044656C696D697465720A202020202B20277C5B5E70756E63745C5C735D285C5C2A2B';
wwv_flow_imp.g_varchar2_table(393) := '29283F3D5B5E70756E63745C5C735D29272C202767752729202F2F2028362920612A2A2A612063616E20626520656974686572204C656674206F722052696768742044656C696D697465720A202020202E7265706C616365282F70756E63742F672C205F';
wwv_flow_imp.g_varchar2_table(394) := '70756E6374756174696F6E290A202020202E676574526567657828293B0A2F2F20283629204E6F7420616C6C6F77656420666F72205F0A636F6E737420656D5374726F6E675244656C696D556E64203D206564697428275E5B5E5F2A5D2A3F5C5C2A5C5C';
wwv_flow_imp.g_varchar2_table(395) := '2A5B5E5F2A5D2A3F5F5B5E5F2A5D2A3F283F3D5C5C2A5C5C2A2927202F2F20536B6970206F727068616E20696E73696465207374726F6E670A202020202B20277C5B5E5F5D2B283F3D5B5E5F5D2927202F2F20436F6E73756D6520746F2064656C696D0A';
wwv_flow_imp.g_varchar2_table(396) := '202020202B20277C283F215F295B70756E63745D285F2B29283F3D5B5C5C735D7C242927202F2F2028312920235F5F5F2063616E206F6E6C7920626520612052696768742044656C696D697465720A202020202B20277C5B5E70756E63745C5C735D285F';
wwv_flow_imp.g_varchar2_table(397) := '2B29283F215F29283F3D5B70756E63745C5C735D7C242927202F2F2028322920615F5F5F232C20615F5F5F2063616E206F6E6C7920626520612052696768742044656C696D697465720A202020202B20277C283F215F295B70756E63745C5C735D285F2B';
wwv_flow_imp.g_varchar2_table(398) := '29283F3D5B5E70756E63745C5C735D2927202F2F2028332920235F5F5F612C205F5F5F612063616E206F6E6C79206265204C6566742044656C696D697465720A202020202B20277C5B5C5C735D285F2B29283F215F29283F3D5B70756E63745D2927202F';
wwv_flow_imp.g_varchar2_table(399) := '2F20283429205F5F5F232063616E206F6E6C79206265204C6566742044656C696D697465720A202020202B20277C283F215F295B70756E63745D285F2B29283F215F29283F3D5B70756E63745D29272C202767752729202F2F2028352920235F5F5F2320';
wwv_flow_imp.g_varchar2_table(400) := '63616E20626520656974686572204C656674206F722052696768742044656C696D697465720A202020202E7265706C616365282F70756E63742F672C205F70756E6374756174696F6E290A202020202E676574526567657828293B0A636F6E737420616E';
wwv_flow_imp.g_varchar2_table(401) := '7950756E6374756174696F6E203D2065646974282F5C5C285B70756E63745D292F2C2027677527290A202020202E7265706C616365282F70756E63742F672C205F70756E6374756174696F6E290A202020202E676574526567657828293B0A636F6E7374';
wwv_flow_imp.g_varchar2_table(402) := '206175746F6C696E6B203D2065646974282F5E3C28736368656D653A5B5E5C735C7830302D5C7831663C3E5D2A7C656D61696C293E2F290A202020202E7265706C6163652827736368656D65272C202F5B612D7A412D5A5D5B612D7A412D5A302D392B2E';
wwv_flow_imp.g_varchar2_table(403) := '2D5D7B312C33317D2F290A202020202E7265706C6163652827656D61696C272C202F5B612D7A412D5A302D392E2123242526272A2B2F3D3F5E5F607B7C7D7E2D5D2B2840295B612D7A412D5A302D395D283F3A5B612D7A412D5A302D392D5D7B302C3631';
wwv_flow_imp.g_varchar2_table(404) := '7D5B612D7A412D5A302D395D293F283F3A5C2E5B612D7A412D5A302D395D283F3A5B612D7A412D5A302D392D5D7B302C36317D5B612D7A412D5A302D395D293F292B283F215B2D5F5D292F290A202020202E676574526567657828293B0A636F6E737420';
wwv_flow_imp.g_varchar2_table(405) := '5F696E6C696E65436F6D6D656E74203D2065646974285F636F6D6D656E74292E7265706C6163652827283F3A2D2D3E7C2429272C20272D2D3E27292E676574526567657828293B0A636F6E737420746167203D206564697428275E636F6D6D656E74270A';
wwv_flow_imp.g_varchar2_table(406) := '202020202B20277C5E3C2F5B612D7A412D5A5D5B5C5C773A2D5D2A5C5C732A3E27202F2F2073656C662D636C6F73696E67207461670A202020202B20277C5E3C5B612D7A412D5A5D5B5C5C772D5D2A283F3A617474726962757465292A3F5C5C732A2F3F';
wwv_flow_imp.g_varchar2_table(407) := '3E27202F2F206F70656E207461670A202020202B20277C5E3C5C5C3F5B5C5C735C5C535D2A3F5C5C3F3E27202F2F2070726F63657373696E6720696E737472756374696F6E2C20652E672E203C3F706870203F3E0A202020202B20277C5E3C215B612D7A';
wwv_flow_imp.g_varchar2_table(408) := '412D5A5D2B5C5C735B5C5C735C5C535D2A3F3E27202F2F206465636C61726174696F6E2C20652E672E203C21444F43545950452068746D6C3E0A202020202B20277C5E3C215C5C5B43444154415C5C5B5B5C5C735C5C535D2A3F5C5C5D5C5C5D3E272920';
wwv_flow_imp.g_varchar2_table(409) := '2F2F2043444154412073656374696F6E0A202020202E7265706C6163652827636F6D6D656E74272C205F696E6C696E65436F6D6D656E74290A202020202E7265706C6163652827617474726962757465272C202F5C732B5B612D7A412D5A3A5F5D5B5C77';
wwv_flow_imp.g_varchar2_table(410) := '2E3A2D5D2A283F3A5C732A3D5C732A225B5E225D2A227C5C732A3D5C732A275B5E275D2A277C5C732A3D5C732A5B5E5C7322273D3C3E605D2B293F2F290A202020202E676574526567657828293B0A636F6E7374205F696E6C696E654C6162656C203D20';
wwv_flow_imp.g_varchar2_table(411) := '2F283F3A5C5B283F3A5C5C2E7C5B5E5C5B5C5D5C5C5D292A5C5D7C5C5C2E7C605B5E605D2A607C5B5E5C5B5C5D5C5C605D292A3F2F3B0A636F6E7374206C696E6B203D2065646974282F5E213F5C5B286C6162656C295C5D5C285C732A28687265662928';
wwv_flow_imp.g_varchar2_table(412) := '3F3A5C732B287469746C6529293F5C732A5C292F290A202020202E7265706C61636528276C6162656C272C205F696E6C696E654C6162656C290A202020202E7265706C616365282768726566272C202F3C283F3A5C5C2E7C5B5E5C6E3C3E5C5C5D292B3E';
wwv_flow_imp.g_varchar2_table(413) := '7C5B5E5C735C7830302D5C7831665D2A2F290A202020202E7265706C61636528277469746C65272C202F22283F3A5C5C223F7C5B5E225C5C5D292A227C27283F3A5C5C273F7C5B5E275C5C5D292A277C5C28283F3A5C5C5C293F7C5B5E295C5C5D292A5C';
wwv_flow_imp.g_varchar2_table(414) := '292F290A202020202E676574526567657828293B0A636F6E7374207265666C696E6B203D2065646974282F5E213F5C5B286C6162656C295C5D5C5B28726566295C5D2F290A202020202E7265706C61636528276C6162656C272C205F696E6C696E654C61';
wwv_flow_imp.g_varchar2_table(415) := '62656C290A202020202E7265706C6163652827726566272C205F626C6F636B4C6162656C290A202020202E676574526567657828293B0A636F6E7374206E6F6C696E6B203D2065646974282F5E213F5C5B28726566295C5D283F3A5C5B5C5D293F2F290A';
wwv_flow_imp.g_varchar2_table(416) := '202020202E7265706C6163652827726566272C205F626C6F636B4C6162656C290A202020202E676574526567657828293B0A636F6E7374207265666C696E6B536561726368203D206564697428277265666C696E6B7C6E6F6C696E6B283F215C5C282927';
wwv_flow_imp.g_varchar2_table(417) := '2C20276727290A202020202E7265706C61636528277265666C696E6B272C207265666C696E6B290A202020202E7265706C61636528276E6F6C696E6B272C206E6F6C696E6B290A202020202E676574526567657828293B0A2F2A2A0A202A204E6F726D61';
wwv_flow_imp.g_varchar2_table(418) := '6C20496E6C696E65204772616D6D61720A202A2F0A636F6E737420696E6C696E654E6F726D616C203D207B0A202020205F6261636B706564616C3A206E6F6F70546573742C202F2F206F6E6C79207573656420666F722047464D2075726C0A2020202061';
wwv_flow_imp.g_varchar2_table(419) := '6E7950756E6374756174696F6E2C0A202020206175746F6C696E6B2C0A20202020626C6F636B536B69702C0A2020202062722C0A20202020636F64653A20696E6C696E65436F64652C0A2020202064656C3A206E6F6F70546573742C0A20202020656D53';
wwv_flow_imp.g_varchar2_table(420) := '74726F6E674C44656C696D2C0A20202020656D5374726F6E675244656C696D4173742C0A20202020656D5374726F6E675244656C696D556E642C0A202020206573636170652C0A202020206C696E6B2C0A202020206E6F6C696E6B2C0A2020202070756E';
wwv_flow_imp.g_varchar2_table(421) := '6374756174696F6E2C0A202020207265666C696E6B2C0A202020207265666C696E6B5365617263682C0A202020207461672C0A20202020746578743A20696E6C696E65546578742C0A2020202075726C3A206E6F6F70546573740A7D3B0A2F2A2A0A202A';
wwv_flow_imp.g_varchar2_table(422) := '20506564616E74696320496E6C696E65204772616D6D61720A202A2F0A636F6E737420696E6C696E65506564616E746963203D207B0A202020202E2E2E696E6C696E654E6F726D616C2C0A202020206C696E6B3A2065646974282F5E213F5C5B286C6162';
wwv_flow_imp.g_varchar2_table(423) := '656C295C5D5C28282E2A3F295C292F290A20202020202020202E7265706C61636528276C6162656C272C205F696E6C696E654C6162656C290A20202020202020202E676574526567657828292C0A202020207265666C696E6B3A2065646974282F5E213F';
wwv_flow_imp.g_varchar2_table(424) := '5C5B286C6162656C295C5D5C732A5C5B285B5E5C5D5D2A295C5D2F290A20202020202020202E7265706C61636528276C6162656C272C205F696E6C696E654C6162656C290A20202020202020202E676574526567657828290A7D3B0A2F2A2A0A202A2047';
wwv_flow_imp.g_varchar2_table(425) := '464D20496E6C696E65204772616D6D61720A202A2F0A636F6E737420696E6C696E6547666D203D207B0A202020202E2E2E696E6C696E654E6F726D616C2C0A202020206573636170653A206564697428657363617065292E7265706C61636528275D2927';
wwv_flow_imp.g_varchar2_table(426) := '2C20277E7C5D2927292E676574526567657828292C0A2020202075726C3A2065646974282F5E28283F3A6674707C68747470733F293A5C2F5C2F7C7777775C2E29283F3A5B612D7A412D5A302D395C2D5D2B5C2E3F292B5B5E5C733C5D2A7C5E656D6169';
wwv_flow_imp.g_varchar2_table(427) := '6C2F2C20276927290A20202020202020202E7265706C6163652827656D61696C272C202F5B412D5A612D7A302D392E5F2B2D5D2B2840295B612D7A412D5A302D392D5F5D2B283F3A5C2E5B612D7A412D5A302D392D5F5D2A5B612D7A412D5A302D395D29';
wwv_flow_imp.g_varchar2_table(428) := '2B283F215B2D5F5D292F290A20202020202020202E676574526567657828292C0A202020205F6261636B706564616C3A202F283F3A5B5E3F212E2C3A3B2A5F27227E2829265D2B7C5C285B5E295D2A5C297C26283F215B612D7A412D5A302D395D2B3B24';
wwv_flow_imp.g_varchar2_table(429) := '297C5B3F212E2C3A3B2A5F27227E295D2B283F212429292B2F2C0A2020202064656C3A202F5E287E7E3F29283F3D5B5E5C737E5D29285B5C735C535D2A3F5B5E5C737E5D295C31283F3D5B5E7E5D7C24292F2C0A20202020746578743A202F5E285B607E';
wwv_flow_imp.g_varchar2_table(430) := '5D2B7C5B5E607E5D29283F3A283F3D207B322C7D5C6E297C283F3D5B612D7A412D5A302D392E2123242526272A2B5C2F3D3F5F607B5C7C7D7E2D5D2B40297C5B5C735C535D2A3F283F3A283F3D5B5C5C3C215C5B602A7E5F5D7C5C625F7C68747470733F';
wwv_flow_imp.g_varchar2_table(431) := '3A5C2F5C2F7C6674703A5C2F5C2F7C7777775C2E7C24297C5B5E205D283F3D207B322C7D5C6E297C5B5E612D7A412D5A302D392E2123242526272A2B5C2F3D3F5F607B5C7C7D7E2D5D283F3D5B612D7A412D5A302D392E2123242526272A2B5C2F3D3F5F';
wwv_flow_imp.g_varchar2_table(432) := '607B5C7C7D7E2D5D2B402929292F0A7D3B0A2F2A2A0A202A2047464D202B204C696E6520427265616B7320496E6C696E65204772616D6D61720A202A2F0A636F6E737420696E6C696E65427265616B73203D207B0A202020202E2E2E696E6C696E654766';
wwv_flow_imp.g_varchar2_table(433) := '6D2C0A2020202062723A2065646974286272292E7265706C61636528277B322C7D272C20272A27292E676574526567657828292C0A20202020746578743A206564697428696E6C696E6547666D2E74657874290A20202020202020202E7265706C616365';
wwv_flow_imp.g_varchar2_table(434) := '28275C5C625F272C20275C5C625F7C207B322C7D5C5C6E27290A20202020202020202E7265706C616365282F5C7B322C5C7D2F672C20272A27290A20202020202020202E676574526567657828290A7D3B0A2F2A2A0A202A206578706F7274730A202A2F';
wwv_flow_imp.g_varchar2_table(435) := '0A636F6E737420626C6F636B203D207B0A202020206E6F726D616C3A20626C6F636B4E6F726D616C2C0A2020202067666D3A20626C6F636B47666D2C0A20202020706564616E7469633A20626C6F636B506564616E7469630A7D3B0A636F6E737420696E';
wwv_flow_imp.g_varchar2_table(436) := '6C696E65203D207B0A202020206E6F726D616C3A20696E6C696E654E6F726D616C2C0A2020202067666D3A20696E6C696E6547666D2C0A20202020627265616B733A20696E6C696E65427265616B732C0A20202020706564616E7469633A20696E6C696E';
wwv_flow_imp.g_varchar2_table(437) := '65506564616E7469630A7D3B0A0A2F2A2A0A202A20426C6F636B204C657865720A202A2F0A636C617373205F4C65786572207B0A20202020746F6B656E733B0A202020206F7074696F6E733B0A2020202073746174653B0A20202020746F6B656E697A65';
wwv_flow_imp.g_varchar2_table(438) := '723B0A20202020696E6C696E6551756575653B0A20202020636F6E7374727563746F72286F7074696F6E7329207B0A20202020202020202F2F20546F6B656E4C6973742063616E6E6F74206265206372656174656420696E206F6E6520676F0A20202020';
wwv_flow_imp.g_varchar2_table(439) := '20202020746869732E746F6B656E73203D205B5D3B0A2020202020202020746869732E746F6B656E732E6C696E6B73203D204F626A6563742E637265617465286E756C6C293B0A2020202020202020746869732E6F7074696F6E73203D206F7074696F6E';
wwv_flow_imp.g_varchar2_table(440) := '73207C7C205F64656661756C74733B0A2020202020202020746869732E6F7074696F6E732E746F6B656E697A6572203D20746869732E6F7074696F6E732E746F6B656E697A6572207C7C206E6577205F546F6B656E697A657228293B0A20202020202020';
wwv_flow_imp.g_varchar2_table(441) := '20746869732E746F6B656E697A6572203D20746869732E6F7074696F6E732E746F6B656E697A65723B0A2020202020202020746869732E746F6B656E697A65722E6F7074696F6E73203D20746869732E6F7074696F6E733B0A2020202020202020746869';
wwv_flow_imp.g_varchar2_table(442) := '732E746F6B656E697A65722E6C65786572203D20746869733B0A2020202020202020746869732E696E6C696E655175657565203D205B5D3B0A2020202020202020746869732E7374617465203D207B0A202020202020202020202020696E4C696E6B3A20';
wwv_flow_imp.g_varchar2_table(443) := '66616C73652C0A202020202020202020202020696E526177426C6F636B3A2066616C73652C0A202020202020202020202020746F703A20747275650A20202020202020207D3B0A2020202020202020636F6E73742072756C6573203D207B0A2020202020';
wwv_flow_imp.g_varchar2_table(444) := '20202020202020626C6F636B3A20626C6F636B2E6E6F726D616C2C0A202020202020202020202020696E6C696E653A20696E6C696E652E6E6F726D616C0A20202020202020207D3B0A202020202020202069662028746869732E6F7074696F6E732E7065';
wwv_flow_imp.g_varchar2_table(445) := '64616E74696329207B0A20202020202020202020202072756C65732E626C6F636B203D20626C6F636B2E706564616E7469633B0A20202020202020202020202072756C65732E696E6C696E65203D20696E6C696E652E706564616E7469633B0A20202020';
wwv_flow_imp.g_varchar2_table(446) := '202020207D0A2020202020202020656C73652069662028746869732E6F7074696F6E732E67666D29207B0A20202020202020202020202072756C65732E626C6F636B203D20626C6F636B2E67666D3B0A2020202020202020202020206966202874686973';
wwv_flow_imp.g_varchar2_table(447) := '2E6F7074696F6E732E627265616B7329207B0A2020202020202020202020202020202072756C65732E696E6C696E65203D20696E6C696E652E627265616B733B0A2020202020202020202020207D0A202020202020202020202020656C7365207B0A2020';
wwv_flow_imp.g_varchar2_table(448) := '202020202020202020202020202072756C65732E696E6C696E65203D20696E6C696E652E67666D3B0A2020202020202020202020207D0A20202020202020207D0A2020202020202020746869732E746F6B656E697A65722E72756C6573203D2072756C65';
wwv_flow_imp.g_varchar2_table(449) := '733B0A202020207D0A202020202F2A2A0A20202020202A204578706F73652052756C65730A20202020202A2F0A20202020737461746963206765742072756C65732829207B0A202020202020202072657475726E207B0A20202020202020202020202062';
wwv_flow_imp.g_varchar2_table(450) := '6C6F636B2C0A202020202020202020202020696E6C696E650A20202020202020207D3B0A202020207D0A202020202F2A2A0A20202020202A20537461746963204C6578204D6574686F640A20202020202A2F0A20202020737461746963206C6578287372';
wwv_flow_imp.g_varchar2_table(451) := '632C206F7074696F6E7329207B0A2020202020202020636F6E7374206C65786572203D206E6577205F4C65786572286F7074696F6E73293B0A202020202020202072657475726E206C657865722E6C657828737263293B0A202020207D0A202020202F2A';
wwv_flow_imp.g_varchar2_table(452) := '2A0A20202020202A20537461746963204C657820496E6C696E65204D6574686F640A20202020202A2F0A20202020737461746963206C6578496E6C696E65287372632C206F7074696F6E7329207B0A2020202020202020636F6E7374206C65786572203D';
wwv_flow_imp.g_varchar2_table(453) := '206E6577205F4C65786572286F7074696F6E73293B0A202020202020202072657475726E206C657865722E696E6C696E65546F6B656E7328737263293B0A202020207D0A202020202F2A2A0A20202020202A2050726570726F63657373696E670A202020';
wwv_flow_imp.g_varchar2_table(454) := '20202A2F0A202020206C65782873726329207B0A2020202020202020737263203D207372630A2020202020202020202020202E7265706C616365282F5C725C6E7C5C722F672C20275C6E27293B0A2020202020202020746869732E626C6F636B546F6B65';
wwv_flow_imp.g_varchar2_table(455) := '6E73287372632C20746869732E746F6B656E73293B0A2020202020202020666F7220286C65742069203D20303B2069203C20746869732E696E6C696E6551756575652E6C656E6774683B20692B2B29207B0A202020202020202020202020636F6E737420';
wwv_flow_imp.g_varchar2_table(456) := '6E657874203D20746869732E696E6C696E6551756575655B695D3B0A202020202020202020202020746869732E696E6C696E65546F6B656E73286E6578742E7372632C206E6578742E746F6B656E73293B0A20202020202020207D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(457) := '746869732E696E6C696E655175657565203D205B5D3B0A202020202020202072657475726E20746869732E746F6B656E733B0A202020207D0A20202020626C6F636B546F6B656E73287372632C20746F6B656E73203D205B5D29207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(458) := '2069662028746869732E6F7074696F6E732E706564616E74696329207B0A202020202020202020202020737263203D207372632E7265706C616365282F5C742F672C20272020202027292E7265706C616365282F5E202B242F676D2C202727293B0A2020';
wwv_flow_imp.g_varchar2_table(459) := '2020202020207D0A2020202020202020656C7365207B0A202020202020202020202020737263203D207372632E7265706C616365282F5E28202A29285C742B292F676D2C20285F2C206C656164696E672C207461627329203D3E207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(460) := '20202020202020202072657475726E206C656164696E67202B202720202020272E72657065617428746162732E6C656E677468293B0A2020202020202020202020207D293B0A20202020202020207D0A20202020202020206C657420746F6B656E3B0A20';
wwv_flow_imp.g_varchar2_table(461) := '202020202020206C6574206C617374546F6B656E3B0A20202020202020206C6574206375745372633B0A20202020202020206C6574206C617374506172616772617068436C69707065643B0A20202020202020207768696C65202873726329207B0A2020';
wwv_flow_imp.g_varchar2_table(462) := '2020202020202020202069662028746869732E6F7074696F6E732E657874656E73696F6E730A20202020202020202020202020202020262620746869732E6F7074696F6E732E657874656E73696F6E732E626C6F636B0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(463) := '202020262620746869732E6F7074696F6E732E657874656E73696F6E732E626C6F636B2E736F6D652828657874546F6B656E697A657229203D3E207B0A202020202020202020202020202020202020202069662028746F6B656E203D20657874546F6B65';
wwv_flow_imp.g_varchar2_table(464) := '6E697A65722E63616C6C287B206C657865723A2074686973207D2C207372632C20746F6B656E732929207B0A202020202020202020202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C65';
wwv_flow_imp.g_varchar2_table(465) := '6E677468293B0A202020202020202020202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020202020202020202072657475726E20747275653B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(466) := '20202020202020207D0A202020202020202020202020202020202020202072657475726E2066616C73653B0A202020202020202020202020202020207D2929207B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(467) := '202020207D0A2020202020202020202020202F2F206E65776C696E650A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E7370616365287372632929207B0A202020202020202020202020202020207372';
wwv_flow_imp.g_varchar2_table(468) := '63203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A2020202020202020202020202020202069662028746F6B656E2E7261772E6C656E677468203D3D3D203120262620746F6B656E732E6C656E677468203E2030';
wwv_flow_imp.g_varchar2_table(469) := '29207B0A20202020202020202020202020202020202020202F2F206966207468657265277320612073696E676C65205C6E2061732061207370616365722C2069742773207465726D696E6174696E6720746865206C617374206C696E652C0A2020202020';
wwv_flow_imp.g_varchar2_table(470) := '2020202020202020202020202020202F2F20736F206D6F766520697420746865726520736F207468617420776520646F6E27742067657420756E6E65636573736172792070617261677261706820746167730A2020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(471) := '202020746F6B656E735B746F6B656E732E6C656E677468202D20315D2E726177202B3D20275C6E273B0A202020202020202020202020202020207D0A20202020202020202020202020202020656C7365207B0A2020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(472) := '202020746F6B656E732E7075736828746F6B656E293B0A202020202020202020202020202020207D0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F20636F6465';
wwv_flow_imp.g_varchar2_table(473) := '0A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E636F6465287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C';
wwv_flow_imp.g_varchar2_table(474) := '656E677468293B0A202020202020202020202020202020206C617374546F6B656E203D20746F6B656E735B746F6B656E732E6C656E677468202D20315D3B0A202020202020202020202020202020202F2F20416E20696E64656E74656420636F64652062';
wwv_flow_imp.g_varchar2_table(475) := '6C6F636B2063616E6E6F7420696E746572727570742061207061726167726170682E0A20202020202020202020202020202020696620286C617374546F6B656E20262620286C617374546F6B656E2E74797065203D3D3D20277061726167726170682720';
wwv_flow_imp.g_varchar2_table(476) := '7C7C206C617374546F6B656E2E74797065203D3D3D202774657874272929207B0A20202020202020202020202020202020202020206C617374546F6B656E2E726177202B3D20275C6E27202B20746F6B656E2E7261773B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(477) := '20202020202020206C617374546F6B656E2E74657874202B3D20275C6E27202B20746F6B656E2E746578743B0A2020202020202020202020202020202020202020746869732E696E6C696E6551756575655B746869732E696E6C696E6551756575652E6C';
wwv_flow_imp.g_varchar2_table(478) := '656E677468202D20315D2E737263203D206C617374546F6B656E2E746578743B0A202020202020202020202020202020207D0A20202020202020202020202020202020656C7365207B0A2020202020202020202020202020202020202020746F6B656E73';
wwv_flow_imp.g_varchar2_table(479) := '2E7075736828746F6B656E293B0A202020202020202020202020202020207D0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F2066656E6365730A202020202020';
wwv_flow_imp.g_varchar2_table(480) := '20202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E66656E636573287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468';
wwv_flow_imp.g_varchar2_table(481) := '293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F2068656164696E';
wwv_flow_imp.g_varchar2_table(482) := '670A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E68656164696E67287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E72';
wwv_flow_imp.g_varchar2_table(483) := '61772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(484) := '2F2F2068720A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E6872287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261';
wwv_flow_imp.g_varchar2_table(485) := '772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F';
wwv_flow_imp.g_varchar2_table(486) := '2F20626C6F636B71756F74650A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E626C6F636B71756F7465287372632929207B0A20202020202020202020202020202020737263203D207372632E737562';
wwv_flow_imp.g_varchar2_table(487) := '737472696E6728746F6B656E2E7261772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(488) := '7D0A2020202020202020202020202F2F206C6973740A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E6C697374287372632929207B0A20202020202020202020202020202020737263203D207372632E';
wwv_flow_imp.g_varchar2_table(489) := '737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(490) := '2020207D0A2020202020202020202020202F2F2068746D6C0A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E68746D6C287372632929207B0A20202020202020202020202020202020737263203D2073';
wwv_flow_imp.g_varchar2_table(491) := '72632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A202020202020';
wwv_flow_imp.g_varchar2_table(492) := '2020202020207D0A2020202020202020202020202F2F206465660A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E646566287372632929207B0A20202020202020202020202020202020737263203D20';
wwv_flow_imp.g_varchar2_table(493) := '7372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A202020202020202020202020202020206C617374546F6B656E203D20746F6B656E735B746F6B656E732E6C656E677468202D20315D3B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(494) := '20202020696620286C617374546F6B656E20262620286C617374546F6B656E2E74797065203D3D3D202770617261677261706827207C7C206C617374546F6B656E2E74797065203D3D3D202774657874272929207B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(495) := '2020202020206C617374546F6B656E2E726177202B3D20275C6E27202B20746F6B656E2E7261773B0A20202020202020202020202020202020202020206C617374546F6B656E2E74657874202B3D20275C6E27202B20746F6B656E2E7261773B0A202020';
wwv_flow_imp.g_varchar2_table(496) := '2020202020202020202020202020202020746869732E696E6C696E6551756575655B746869732E696E6C696E6551756575652E6C656E677468202D20315D2E737263203D206C617374546F6B656E2E746578743B0A202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(497) := '207D0A20202020202020202020202020202020656C7365206966202821746869732E746F6B656E732E6C696E6B735B746F6B656E2E7461675D29207B0A2020202020202020202020202020202020202020746869732E746F6B656E732E6C696E6B735B74';
wwv_flow_imp.g_varchar2_table(498) := '6F6B656E2E7461675D203D207B0A202020202020202020202020202020202020202020202020687265663A20746F6B656E2E687265662C0A2020202020202020202020202020202020202020202020207469746C653A20746F6B656E2E7469746C650A20';
wwv_flow_imp.g_varchar2_table(499) := '202020202020202020202020202020202020207D3B0A202020202020202020202020202020207D0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F207461626C65';
wwv_flow_imp.g_varchar2_table(500) := '202867666D290A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E7461626C65287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B65';
wwv_flow_imp.g_varchar2_table(501) := '6E2E7261772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(502) := '2020202F2F206C68656164696E670A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E6C68656164696E67287372632929207B0A20202020202020202020202020202020737263203D207372632E737562';
wwv_flow_imp.g_varchar2_table(503) := '737472696E6728746F6B656E2E7261772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(504) := '7D0A2020202020202020202020202F2F20746F702D6C6576656C207061726167726170680A2020202020202020202020202F2F2070726576656E742070617261677261706820636F6E73756D696E6720657874656E73696F6E7320627920636C69707069';
wwv_flow_imp.g_varchar2_table(505) := '6E6720277372632720746F20657874656E73696F6E2073746172740A202020202020202020202020637574537263203D207372633B0A20202020202020202020202069662028746869732E6F7074696F6E732E657874656E73696F6E7320262620746869';
wwv_flow_imp.g_varchar2_table(506) := '732E6F7074696F6E732E657874656E73696F6E732E7374617274426C6F636B29207B0A202020202020202020202020202020206C6574207374617274496E646578203D20496E66696E6974793B0A20202020202020202020202020202020636F6E737420';
wwv_flow_imp.g_varchar2_table(507) := '74656D70537263203D207372632E736C6963652831293B0A202020202020202020202020202020206C65742074656D7053746172743B0A20202020202020202020202020202020746869732E6F7074696F6E732E657874656E73696F6E732E7374617274';
wwv_flow_imp.g_varchar2_table(508) := '426C6F636B2E666F724561636828286765745374617274496E64657829203D3E207B0A202020202020202020202020202020202020202074656D705374617274203D206765745374617274496E6465782E63616C6C287B206C657865723A207468697320';
wwv_flow_imp.g_varchar2_table(509) := '7D2C2074656D70537263293B0A202020202020202020202020202020202020202069662028747970656F662074656D705374617274203D3D3D20276E756D626572272026262074656D705374617274203E3D203029207B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(510) := '2020202020202020202020207374617274496E646578203D204D6174682E6D696E287374617274496E6465782C2074656D705374617274293B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D293B0A';
wwv_flow_imp.g_varchar2_table(511) := '20202020202020202020202020202020696620287374617274496E646578203C20496E66696E697479202626207374617274496E646578203E3D203029207B0A2020202020202020202020202020202020202020637574537263203D207372632E737562';
wwv_flow_imp.g_varchar2_table(512) := '737472696E6728302C207374617274496E646578202B2031293B0A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020202020202069662028746869732E73746174652E746F702026262028746F6B656E20';
wwv_flow_imp.g_varchar2_table(513) := '3D20746869732E746F6B656E697A65722E70617261677261706828637574537263292929207B0A202020202020202020202020202020206C617374546F6B656E203D20746F6B656E735B746F6B656E732E6C656E677468202D20315D3B0A202020202020';
wwv_flow_imp.g_varchar2_table(514) := '20202020202020202020696620286C617374506172616772617068436C6970706564202626206C617374546F6B656E2E74797065203D3D3D20277061726167726170682729207B0A20202020202020202020202020202020202020206C617374546F6B65';
wwv_flow_imp.g_varchar2_table(515) := '6E2E726177202B3D20275C6E27202B20746F6B656E2E7261773B0A20202020202020202020202020202020202020206C617374546F6B656E2E74657874202B3D20275C6E27202B20746F6B656E2E746578743B0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(516) := '20202020746869732E696E6C696E6551756575652E706F7028293B0A2020202020202020202020202020202020202020746869732E696E6C696E6551756575655B746869732E696E6C696E6551756575652E6C656E677468202D20315D2E737263203D20';
wwv_flow_imp.g_varchar2_table(517) := '6C617374546F6B656E2E746578743B0A202020202020202020202020202020207D0A20202020202020202020202020202020656C7365207B0A2020202020202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A202020';
wwv_flow_imp.g_varchar2_table(518) := '202020202020202020202020207D0A202020202020202020202020202020206C617374506172616772617068436C6970706564203D20286375745372632E6C656E67746820213D3D207372632E6C656E677468293B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(519) := '2020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F2074657874';
wwv_flow_imp.g_varchar2_table(520) := '0A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E74657874287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C';
wwv_flow_imp.g_varchar2_table(521) := '656E677468293B0A202020202020202020202020202020206C617374546F6B656E203D20746F6B656E735B746F6B656E732E6C656E677468202D20315D3B0A20202020202020202020202020202020696620286C617374546F6B656E202626206C617374';
wwv_flow_imp.g_varchar2_table(522) := '546F6B656E2E74797065203D3D3D2027746578742729207B0A20202020202020202020202020202020202020206C617374546F6B656E2E726177202B3D20275C6E27202B20746F6B656E2E7261773B0A2020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(523) := '6C617374546F6B656E2E74657874202B3D20275C6E27202B20746F6B656E2E746578743B0A2020202020202020202020202020202020202020746869732E696E6C696E6551756575652E706F7028293B0A20202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(524) := '20746869732E696E6C696E6551756575655B746869732E696E6C696E6551756575652E6C656E677468202D20315D2E737263203D206C617374546F6B656E2E746578743B0A202020202020202020202020202020207D0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(525) := '202020656C7365207B0A2020202020202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A202020202020202020202020202020207D0A20202020202020202020202020202020636F6E74696E75653B0A202020202020';
wwv_flow_imp.g_varchar2_table(526) := '2020202020207D0A2020202020202020202020206966202873726329207B0A20202020202020202020202020202020636F6E7374206572724D7367203D2027496E66696E697465206C6F6F70206F6E20627974653A2027202B207372632E63686172436F';
wwv_flow_imp.g_varchar2_table(527) := '646541742830293B0A2020202020202020202020202020202069662028746869732E6F7074696F6E732E73696C656E7429207B0A2020202020202020202020202020202020202020636F6E736F6C652E6572726F72286572724D7367293B0A2020202020';
wwv_flow_imp.g_varchar2_table(528) := '202020202020202020202020202020627265616B3B0A202020202020202020202020202020207D0A20202020202020202020202020202020656C7365207B0A20202020202020202020202020202020202020207468726F77206E6577204572726F722865';
wwv_flow_imp.g_varchar2_table(529) := '72724D7367293B0A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020207D0A2020202020202020746869732E73746174652E746F70203D20747275653B0A202020202020202072657475726E20746F6B65';
wwv_flow_imp.g_varchar2_table(530) := '6E733B0A202020207D0A20202020696E6C696E65287372632C20746F6B656E73203D205B5D29207B0A2020202020202020746869732E696E6C696E6551756575652E70757368287B207372632C20746F6B656E73207D293B0A2020202020202020726574';
wwv_flow_imp.g_varchar2_table(531) := '75726E20746F6B656E733B0A202020207D0A202020202F2A2A0A20202020202A204C6578696E672F436F6D70696C696E670A20202020202A2F0A20202020696E6C696E65546F6B656E73287372632C20746F6B656E73203D205B5D29207B0A2020202020';
wwv_flow_imp.g_varchar2_table(532) := '2020206C657420746F6B656E2C206C617374546F6B656E2C206375745372633B0A20202020202020202F2F20537472696E672077697468206C696E6B73206D61736B656420746F2061766F696420696E746572666572656E6365207769746820656D2061';
wwv_flow_imp.g_varchar2_table(533) := '6E64207374726F6E670A20202020202020206C6574206D61736B6564537263203D207372633B0A20202020202020206C6574206D617463683B0A20202020202020206C6574206B65657050726576436861722C2070726576436861723B0A202020202020';
wwv_flow_imp.g_varchar2_table(534) := '20202F2F204D61736B206F7574207265666C696E6B730A202020202020202069662028746869732E746F6B656E732E6C696E6B7329207B0A202020202020202020202020636F6E7374206C696E6B73203D204F626A6563742E6B65797328746869732E74';
wwv_flow_imp.g_varchar2_table(535) := '6F6B656E732E6C696E6B73293B0A202020202020202020202020696620286C696E6B732E6C656E677468203E203029207B0A202020202020202020202020202020207768696C652028286D61746368203D20746869732E746F6B656E697A65722E72756C';
wwv_flow_imp.g_varchar2_table(536) := '65732E696E6C696E652E7265666C696E6B5365617263682E65786563286D61736B6564537263292920213D206E756C6C29207B0A2020202020202020202020202020202020202020696620286C696E6B732E696E636C75646573286D617463685B305D2E';
wwv_flow_imp.g_varchar2_table(537) := '736C696365286D617463685B305D2E6C617374496E6465784F6628275B2729202B20312C202D31292929207B0A2020202020202020202020202020202020202020202020206D61736B6564537263203D206D61736B65645372632E736C69636528302C20';
wwv_flow_imp.g_varchar2_table(538) := '6D617463682E696E64657829202B20275B27202B202761272E726570656174286D617463685B305D2E6C656E677468202D203229202B20275D27202B206D61736B65645372632E736C69636528746869732E746F6B656E697A65722E72756C65732E696E';
wwv_flow_imp.g_varchar2_table(539) := '6C696E652E7265666C696E6B5365617263682E6C617374496E646578293B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020207D0A2020202020';
wwv_flow_imp.g_varchar2_table(540) := '2020202F2F204D61736B206F7574206F7468657220626C6F636B730A20202020202020207768696C652028286D61746368203D20746869732E746F6B656E697A65722E72756C65732E696E6C696E652E626C6F636B536B69702E65786563286D61736B65';
wwv_flow_imp.g_varchar2_table(541) := '64537263292920213D206E756C6C29207B0A2020202020202020202020206D61736B6564537263203D206D61736B65645372632E736C69636528302C206D617463682E696E64657829202B20275B27202B202761272E726570656174286D617463685B30';
wwv_flow_imp.g_varchar2_table(542) := '5D2E6C656E677468202D203229202B20275D27202B206D61736B65645372632E736C69636528746869732E746F6B656E697A65722E72756C65732E696E6C696E652E626C6F636B536B69702E6C617374496E646578293B0A20202020202020207D0A2020';
wwv_flow_imp.g_varchar2_table(543) := '2020202020202F2F204D61736B206F7574206573636170656420636861726163746572730A20202020202020207768696C652028286D61746368203D20746869732E746F6B656E697A65722E72756C65732E696E6C696E652E616E7950756E6374756174';
wwv_flow_imp.g_varchar2_table(544) := '696F6E2E65786563286D61736B6564537263292920213D206E756C6C29207B0A2020202020202020202020206D61736B6564537263203D206D61736B65645372632E736C69636528302C206D617463682E696E64657829202B20272B2B27202B206D6173';
wwv_flow_imp.g_varchar2_table(545) := '6B65645372632E736C69636528746869732E746F6B656E697A65722E72756C65732E696E6C696E652E616E7950756E6374756174696F6E2E6C617374496E646578293B0A20202020202020207D0A20202020202020207768696C65202873726329207B0A';
wwv_flow_imp.g_varchar2_table(546) := '20202020202020202020202069662028216B656570507265764368617229207B0A202020202020202020202020202020207072657643686172203D2027273B0A2020202020202020202020207D0A2020202020202020202020206B656570507265764368';
wwv_flow_imp.g_varchar2_table(547) := '6172203D2066616C73653B0A2020202020202020202020202F2F20657874656E73696F6E730A20202020202020202020202069662028746869732E6F7074696F6E732E657874656E73696F6E730A20202020202020202020202020202020262620746869';
wwv_flow_imp.g_varchar2_table(548) := '732E6F7074696F6E732E657874656E73696F6E732E696E6C696E650A20202020202020202020202020202020262620746869732E6F7074696F6E732E657874656E73696F6E732E696E6C696E652E736F6D652828657874546F6B656E697A657229203D3E';
wwv_flow_imp.g_varchar2_table(549) := '207B0A202020202020202020202020202020202020202069662028746F6B656E203D20657874546F6B656E697A65722E63616C6C287B206C657865723A2074686973207D2C207372632C20746F6B656E732929207B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(550) := '20202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A202020202020202020202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020202020';
wwv_flow_imp.g_varchar2_table(551) := '202020202020202020202020202020202072657475726E20747275653B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020202020202072657475726E2066616C73653B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(552) := '20207D2929207B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F206573636170650A20202020202020202020202069662028746F6B656E203D20746869732E74';
wwv_flow_imp.g_varchar2_table(553) := '6F6B656E697A65722E657363617065287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A20202020202020202020202020202020746F6B656E';
wwv_flow_imp.g_varchar2_table(554) := '732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F207461670A20202020202020202020202069662028746F6B656E203D207468';
wwv_flow_imp.g_varchar2_table(555) := '69732E746F6B656E697A65722E746167287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A202020202020202020202020202020206C617374';
wwv_flow_imp.g_varchar2_table(556) := '546F6B656E203D20746F6B656E735B746F6B656E732E6C656E677468202D20315D3B0A20202020202020202020202020202020696620286C617374546F6B656E20262620746F6B656E2E74797065203D3D3D20277465787427202626206C617374546F6B';
wwv_flow_imp.g_varchar2_table(557) := '656E2E74797065203D3D3D2027746578742729207B0A20202020202020202020202020202020202020206C617374546F6B656E2E726177202B3D20746F6B656E2E7261773B0A20202020202020202020202020202020202020206C617374546F6B656E2E';
wwv_flow_imp.g_varchar2_table(558) := '74657874202B3D20746F6B656E2E746578743B0A202020202020202020202020202020207D0A20202020202020202020202020202020656C7365207B0A2020202020202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B';
wwv_flow_imp.g_varchar2_table(559) := '0A202020202020202020202020202020207D0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F206C696E6B0A20202020202020202020202069662028746F6B656E';
wwv_flow_imp.g_varchar2_table(560) := '203D20746869732E746F6B656E697A65722E6C696E6B287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(561) := '2020746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F207265666C696E6B2C206E6F6C696E6B0A20202020202020';
wwv_flow_imp.g_varchar2_table(562) := '202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E7265666C696E6B287372632C20746869732E746F6B656E732E6C696E6B732929207B0A20202020202020202020202020202020737263203D207372632E73756273747269';
wwv_flow_imp.g_varchar2_table(563) := '6E6728746F6B656E2E7261772E6C656E677468293B0A202020202020202020202020202020206C617374546F6B656E203D20746F6B656E735B746F6B656E732E6C656E677468202D20315D3B0A20202020202020202020202020202020696620286C6173';
wwv_flow_imp.g_varchar2_table(564) := '74546F6B656E20262620746F6B656E2E74797065203D3D3D20277465787427202626206C617374546F6B656E2E74797065203D3D3D2027746578742729207B0A20202020202020202020202020202020202020206C617374546F6B656E2E726177202B3D';
wwv_flow_imp.g_varchar2_table(565) := '20746F6B656E2E7261773B0A20202020202020202020202020202020202020206C617374546F6B656E2E74657874202B3D20746F6B656E2E746578743B0A202020202020202020202020202020207D0A20202020202020202020202020202020656C7365';
wwv_flow_imp.g_varchar2_table(566) := '207B0A2020202020202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A202020202020202020202020202020207D0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D';
wwv_flow_imp.g_varchar2_table(567) := '0A2020202020202020202020202F2F20656D2026207374726F6E670A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E656D5374726F6E67287372632C206D61736B65645372632C207072657643686172';
wwv_flow_imp.g_varchar2_table(568) := '2929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020';
wwv_flow_imp.g_varchar2_table(569) := '202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F20636F64650A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E636F646573';
wwv_flow_imp.g_varchar2_table(570) := '70616E287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E';
wwv_flow_imp.g_varchar2_table(571) := '293B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F2062720A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E';
wwv_flow_imp.g_varchar2_table(572) := '6272287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E29';
wwv_flow_imp.g_varchar2_table(573) := '3B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F2064656C202867666D290A20202020202020202020202069662028746F6B656E203D20746869732E746F6B65';
wwv_flow_imp.g_varchar2_table(574) := '6E697A65722E64656C287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E70757368';
wwv_flow_imp.g_varchar2_table(575) := '28746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F206175746F6C696E6B0A20202020202020202020202069662028746F6B656E203D20746869';
wwv_flow_imp.g_varchar2_table(576) := '732E746F6B656E697A65722E6175746F6C696E6B287372632929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(577) := '746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A2020202020202020202020202F2F2075726C202867666D290A202020202020202020202020696620';
wwv_flow_imp.g_varchar2_table(578) := '2821746869732E73746174652E696E4C696E6B2026262028746F6B656E203D20746869732E746F6B656E697A65722E75726C28737263292929207B0A20202020202020202020202020202020737263203D207372632E737562737472696E6728746F6B65';
wwv_flow_imp.g_varchar2_table(579) := '6E2E7261772E6C656E677468293B0A20202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A20202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(580) := '2020202F2F20746578740A2020202020202020202020202F2F2070726576656E7420696E6C696E655465787420636F6E73756D696E6720657874656E73696F6E7320627920636C697070696E6720277372632720746F20657874656E73696F6E20737461';
wwv_flow_imp.g_varchar2_table(581) := '72740A202020202020202020202020637574537263203D207372633B0A20202020202020202020202069662028746869732E6F7074696F6E732E657874656E73696F6E7320262620746869732E6F7074696F6E732E657874656E73696F6E732E73746172';
wwv_flow_imp.g_varchar2_table(582) := '74496E6C696E6529207B0A202020202020202020202020202020206C6574207374617274496E646578203D20496E66696E6974793B0A20202020202020202020202020202020636F6E73742074656D70537263203D207372632E736C6963652831293B0A';
wwv_flow_imp.g_varchar2_table(583) := '202020202020202020202020202020206C65742074656D7053746172743B0A20202020202020202020202020202020746869732E6F7074696F6E732E657874656E73696F6E732E7374617274496E6C696E652E666F724561636828286765745374617274';
wwv_flow_imp.g_varchar2_table(584) := '496E64657829203D3E207B0A202020202020202020202020202020202020202074656D705374617274203D206765745374617274496E6465782E63616C6C287B206C657865723A2074686973207D2C2074656D70537263293B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(585) := '2020202020202020202069662028747970656F662074656D705374617274203D3D3D20276E756D626572272026262074656D705374617274203E3D203029207B0A2020202020202020202020202020202020202020202020207374617274496E64657820';
wwv_flow_imp.g_varchar2_table(586) := '3D204D6174682E6D696E287374617274496E6465782C2074656D705374617274293B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D293B0A2020202020202020202020202020202069662028737461';
wwv_flow_imp.g_varchar2_table(587) := '7274496E646578203C20496E66696E697479202626207374617274496E646578203E3D203029207B0A2020202020202020202020202020202020202020637574537263203D207372632E737562737472696E6728302C207374617274496E646578202B20';
wwv_flow_imp.g_varchar2_table(588) := '31293B0A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020202020202069662028746F6B656E203D20746869732E746F6B656E697A65722E696E6C696E6554657874286375745372632929207B0A202020';
wwv_flow_imp.g_varchar2_table(589) := '20202020202020202020202020737263203D207372632E737562737472696E6728746F6B656E2E7261772E6C656E677468293B0A2020202020202020202020202020202069662028746F6B656E2E7261772E736C696365282D312920213D3D20275F2729';
wwv_flow_imp.g_varchar2_table(590) := '207B202F2F20547261636B207072657643686172206265666F726520737472696E67206F66205F5F5F5F20737461727465640A20202020202020202020202020202020202020207072657643686172203D20746F6B656E2E7261772E736C696365282D31';
wwv_flow_imp.g_varchar2_table(591) := '293B0A202020202020202020202020202020207D0A202020202020202020202020202020206B6565705072657643686172203D20747275653B0A202020202020202020202020202020206C617374546F6B656E203D20746F6B656E735B746F6B656E732E';
wwv_flow_imp.g_varchar2_table(592) := '6C656E677468202D20315D3B0A20202020202020202020202020202020696620286C617374546F6B656E202626206C617374546F6B656E2E74797065203D3D3D2027746578742729207B0A20202020202020202020202020202020202020206C61737454';
wwv_flow_imp.g_varchar2_table(593) := '6F6B656E2E726177202B3D20746F6B656E2E7261773B0A20202020202020202020202020202020202020206C617374546F6B656E2E74657874202B3D20746F6B656E2E746578743B0A202020202020202020202020202020207D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(594) := '20202020202020656C7365207B0A2020202020202020202020202020202020202020746F6B656E732E7075736828746F6B656E293B0A202020202020202020202020202020207D0A20202020202020202020202020202020636F6E74696E75653B0A2020';
wwv_flow_imp.g_varchar2_table(595) := '202020202020202020207D0A2020202020202020202020206966202873726329207B0A20202020202020202020202020202020636F6E7374206572724D7367203D2027496E66696E697465206C6F6F70206F6E20627974653A2027202B207372632E6368';
wwv_flow_imp.g_varchar2_table(596) := '6172436F646541742830293B0A2020202020202020202020202020202069662028746869732E6F7074696F6E732E73696C656E7429207B0A2020202020202020202020202020202020202020636F6E736F6C652E6572726F72286572724D7367293B0A20';
wwv_flow_imp.g_varchar2_table(597) := '20202020202020202020202020202020202020627265616B3B0A202020202020202020202020202020207D0A20202020202020202020202020202020656C7365207B0A20202020202020202020202020202020202020207468726F77206E657720457272';
wwv_flow_imp.g_varchar2_table(598) := '6F72286572724D7367293B0A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020207D0A202020202020202072657475726E20746F6B656E733B0A202020207D0A7D0A0A2F2A2A0A202A2052656E64657265';
wwv_flow_imp.g_varchar2_table(599) := '720A202A2F0A636C617373205F52656E6465726572207B0A202020206F7074696F6E733B0A20202020636F6E7374727563746F72286F7074696F6E7329207B0A2020202020202020746869732E6F7074696F6E73203D206F7074696F6E73207C7C205F64';
wwv_flow_imp.g_varchar2_table(600) := '656661756C74733B0A202020207D0A20202020636F646528636F64652C20696E666F737472696E672C206573636170656429207B0A2020202020202020636F6E7374206C616E67203D2028696E666F737472696E67207C7C202727292E6D61746368282F';
wwv_flow_imp.g_varchar2_table(601) := '5E5C532A2F293F2E5B305D3B0A2020202020202020636F6465203D20636F64652E7265706C616365282F5C6E242F2C20272729202B20275C6E273B0A202020202020202069662028216C616E6729207B0A20202020202020202020202072657475726E20';
wwv_flow_imp.g_varchar2_table(602) := '273C7072653E3C636F64653E270A202020202020202020202020202020202B202865736361706564203F20636F6465203A20657363617065243128636F64652C207472756529290A202020202020202020202020202020202B20273C2F636F64653E3C2F';
wwv_flow_imp.g_varchar2_table(603) := '7072653E5C6E273B0A20202020202020207D0A202020202020202072657475726E20273C7072653E3C636F646520636C6173733D226C616E67756167652D270A2020202020202020202020202B206573636170652431286C616E67290A20202020202020';
wwv_flow_imp.g_varchar2_table(604) := '20202020202B2027223E270A2020202020202020202020202B202865736361706564203F20636F6465203A20657363617065243128636F64652C207472756529290A2020202020202020202020202B20273C2F636F64653E3C2F7072653E5C6E273B0A20';
wwv_flow_imp.g_varchar2_table(605) := '2020207D0A20202020626C6F636B71756F74652871756F746529207B0A202020202020202072657475726E20603C626C6F636B71756F74653E5C6E247B71756F74657D3C2F626C6F636B71756F74653E5C6E603B0A202020207D0A2020202068746D6C28';
wwv_flow_imp.g_varchar2_table(606) := '68746D6C2C20626C6F636B29207B0A202020202020202072657475726E2068746D6C3B0A202020207D0A2020202068656164696E6728746578742C206C6576656C2C2072617729207B0A20202020202020202F2F2069676E6F7265204944730A20202020';
wwv_flow_imp.g_varchar2_table(607) := '2020202072657475726E20603C68247B6C6576656C7D3E247B746578747D3C2F68247B6C6576656C7D3E5C6E603B0A202020207D0A2020202068722829207B0A202020202020202072657475726E20273C68723E5C6E273B0A202020207D0A202020206C';
wwv_flow_imp.g_varchar2_table(608) := '69737428626F64792C206F7264657265642C20737461727429207B0A2020202020202020636F6E73742074797065203D206F726465726564203F20276F6C27203A2027756C273B0A2020202020202020636F6E7374207374617274617474203D20286F72';
wwv_flow_imp.g_varchar2_table(609) := '646572656420262620737461727420213D3D203129203F2028272073746172743D2227202B207374617274202B2027222729203A2027273B0A202020202020202072657475726E20273C27202B2074797065202B207374617274617474202B20273E5C6E';
wwv_flow_imp.g_varchar2_table(610) := '27202B20626F6479202B20273C2F27202B2074797065202B20273E5C6E273B0A202020207D0A202020206C6973746974656D28746578742C207461736B2C20636865636B656429207B0A202020202020202072657475726E20603C6C693E247B74657874';
wwv_flow_imp.g_varchar2_table(611) := '7D3C2F6C693E5C6E603B0A202020207D0A20202020636865636B626F7828636865636B656429207B0A202020202020202072657475726E20273C696E70757420270A2020202020202020202020202B2028636865636B6564203F2027636865636B65643D';
wwv_flow_imp.g_varchar2_table(612) := '22222027203A202727290A2020202020202020202020202B202764697361626C65643D222220747970653D22636865636B626F78223E273B0A202020207D0A20202020706172616772617068287465787429207B0A202020202020202072657475726E20';
wwv_flow_imp.g_varchar2_table(613) := '603C703E247B746578747D3C2F703E5C6E603B0A202020207D0A202020207461626C65286865616465722C20626F647929207B0A202020202020202069662028626F6479290A202020202020202020202020626F6479203D20603C74626F64793E247B62';
wwv_flow_imp.g_varchar2_table(614) := '6F64797D3C2F74626F64793E603B0A202020202020202072657475726E20273C7461626C653E5C6E270A2020202020202020202020202B20273C74686561643E5C6E270A2020202020202020202020202B206865616465720A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(615) := '202B20273C2F74686561643E5C6E270A2020202020202020202020202B20626F64790A2020202020202020202020202B20273C2F7461626C653E5C6E273B0A202020207D0A202020207461626C65726F7728636F6E74656E7429207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(616) := '2072657475726E20603C74723E5C6E247B636F6E74656E747D3C2F74723E5C6E603B0A202020207D0A202020207461626C6563656C6C28636F6E74656E742C20666C61677329207B0A2020202020202020636F6E73742074797065203D20666C6167732E';
wwv_flow_imp.g_varchar2_table(617) := '686561646572203F2027746827203A20277464273B0A2020202020202020636F6E737420746167203D20666C6167732E616C69676E0A2020202020202020202020203F20603C247B747970657D20616C69676E3D22247B666C6167732E616C69676E7D22';
wwv_flow_imp.g_varchar2_table(618) := '3E600A2020202020202020202020203A20603C247B747970657D3E603B0A202020202020202072657475726E20746167202B20636F6E74656E74202B20603C2F247B747970657D3E5C6E603B0A202020207D0A202020202F2A2A0A20202020202A207370';
wwv_flow_imp.g_varchar2_table(619) := '616E206C6576656C2072656E64657265720A20202020202A2F0A202020207374726F6E67287465787429207B0A202020202020202072657475726E20603C7374726F6E673E247B746578747D3C2F7374726F6E673E603B0A202020207D0A20202020656D';
wwv_flow_imp.g_varchar2_table(620) := '287465787429207B0A202020202020202072657475726E20603C656D3E247B746578747D3C2F656D3E603B0A202020207D0A20202020636F64657370616E287465787429207B0A202020202020202072657475726E20603C636F64653E247B746578747D';
wwv_flow_imp.g_varchar2_table(621) := '3C2F636F64653E603B0A202020207D0A2020202062722829207B0A202020202020202072657475726E20273C62723E273B0A202020207D0A2020202064656C287465787429207B0A202020202020202072657475726E20603C64656C3E247B746578747D';
wwv_flow_imp.g_varchar2_table(622) := '3C2F64656C3E603B0A202020207D0A202020206C696E6B28687265662C207469746C652C207465787429207B0A2020202020202020636F6E737420636C65616E48726566203D20636C65616E55726C2868726566293B0A20202020202020206966202863';
wwv_flow_imp.g_varchar2_table(623) := '6C65616E48726566203D3D3D206E756C6C29207B0A20202020202020202020202072657475726E20746578743B0A20202020202020207D0A202020202020202068726566203D20636C65616E487265663B0A20202020202020206C6574206F7574203D20';
wwv_flow_imp.g_varchar2_table(624) := '273C6120687265663D2227202B2068726566202B202722273B0A2020202020202020696620287469746C6529207B0A2020202020202020202020206F7574202B3D2027207469746C653D2227202B207469746C65202B202722273B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(625) := '7D0A20202020202020206F7574202B3D20273E27202B2074657874202B20273C2F613E273B0A202020202020202072657475726E206F75743B0A202020207D0A20202020696D61676528687265662C207469746C652C207465787429207B0A2020202020';
wwv_flow_imp.g_varchar2_table(626) := '202020636F6E737420636C65616E48726566203D20636C65616E55726C2868726566293B0A202020202020202069662028636C65616E48726566203D3D3D206E756C6C29207B0A20202020202020202020202072657475726E20746578743B0A20202020';
wwv_flow_imp.g_varchar2_table(627) := '202020207D0A202020202020202068726566203D20636C65616E487265663B0A20202020202020206C6574206F7574203D20603C696D67207372633D22247B687265667D2220616C743D22247B746578747D22603B0A2020202020202020696620287469';
wwv_flow_imp.g_varchar2_table(628) := '746C6529207B0A2020202020202020202020206F7574202B3D2060207469746C653D22247B7469746C657D22603B0A20202020202020207D0A20202020202020206F7574202B3D20273E273B0A202020202020202072657475726E206F75743B0A202020';
wwv_flow_imp.g_varchar2_table(629) := '207D0A2020202074657874287465787429207B0A202020202020202072657475726E20746578743B0A202020207D0A7D0A0A2F2A2A0A202A205465787452656E64657265720A202A2072657475726E73206F6E6C7920746865207465787475616C207061';
wwv_flow_imp.g_varchar2_table(630) := '7274206F662074686520746F6B656E0A202A2F0A636C617373205F5465787452656E6465726572207B0A202020202F2F206E6F206E65656420666F7220626C6F636B206C6576656C2072656E6465726572730A202020207374726F6E6728746578742920';
wwv_flow_imp.g_varchar2_table(631) := '7B0A202020202020202072657475726E20746578743B0A202020207D0A20202020656D287465787429207B0A202020202020202072657475726E20746578743B0A202020207D0A20202020636F64657370616E287465787429207B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(632) := '72657475726E20746578743B0A202020207D0A2020202064656C287465787429207B0A202020202020202072657475726E20746578743B0A202020207D0A2020202068746D6C287465787429207B0A202020202020202072657475726E20746578743B0A';
wwv_flow_imp.g_varchar2_table(633) := '202020207D0A2020202074657874287465787429207B0A202020202020202072657475726E20746578743B0A202020207D0A202020206C696E6B28687265662C207469746C652C207465787429207B0A202020202020202072657475726E202727202B20';
wwv_flow_imp.g_varchar2_table(634) := '746578743B0A202020207D0A20202020696D61676528687265662C207469746C652C207465787429207B0A202020202020202072657475726E202727202B20746578743B0A202020207D0A2020202062722829207B0A202020202020202072657475726E';
wwv_flow_imp.g_varchar2_table(635) := '2027273B0A202020207D0A7D0A0A2F2A2A0A202A2050617273696E67202620436F6D70696C696E670A202A2F0A636C617373205F506172736572207B0A202020206F7074696F6E733B0A2020202072656E64657265723B0A202020207465787452656E64';
wwv_flow_imp.g_varchar2_table(636) := '657265723B0A20202020636F6E7374727563746F72286F7074696F6E7329207B0A2020202020202020746869732E6F7074696F6E73203D206F7074696F6E73207C7C205F64656661756C74733B0A2020202020202020746869732E6F7074696F6E732E72';
wwv_flow_imp.g_varchar2_table(637) := '656E6465726572203D20746869732E6F7074696F6E732E72656E6465726572207C7C206E6577205F52656E646572657228293B0A2020202020202020746869732E72656E6465726572203D20746869732E6F7074696F6E732E72656E64657265723B0A20';
wwv_flow_imp.g_varchar2_table(638) := '20202020202020746869732E72656E64657265722E6F7074696F6E73203D20746869732E6F7074696F6E733B0A2020202020202020746869732E7465787452656E6465726572203D206E6577205F5465787452656E646572657228293B0A202020207D0A';
wwv_flow_imp.g_varchar2_table(639) := '202020202F2A2A0A20202020202A20537461746963205061727365204D6574686F640A20202020202A2F0A2020202073746174696320706172736528746F6B656E732C206F7074696F6E7329207B0A2020202020202020636F6E73742070617273657220';
wwv_flow_imp.g_varchar2_table(640) := '3D206E6577205F506172736572286F7074696F6E73293B0A202020202020202072657475726E207061727365722E706172736528746F6B656E73293B0A202020207D0A202020202F2A2A0A20202020202A2053746174696320506172736520496E6C696E';
wwv_flow_imp.g_varchar2_table(641) := '65204D6574686F640A20202020202A2F0A20202020737461746963207061727365496E6C696E6528746F6B656E732C206F7074696F6E7329207B0A2020202020202020636F6E737420706172736572203D206E6577205F506172736572286F7074696F6E';
wwv_flow_imp.g_varchar2_table(642) := '73293B0A202020202020202072657475726E207061727365722E7061727365496E6C696E6528746F6B656E73293B0A202020207D0A202020202F2A2A0A20202020202A205061727365204C6F6F700A20202020202A2F0A20202020706172736528746F6B';
wwv_flow_imp.g_varchar2_table(643) := '656E732C20746F70203D207472756529207B0A20202020202020206C6574206F7574203D2027273B0A2020202020202020666F7220286C65742069203D20303B2069203C20746F6B656E732E6C656E6774683B20692B2B29207B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(644) := '202020636F6E737420746F6B656E203D20746F6B656E735B695D3B0A2020202020202020202020202F2F2052756E20616E792072656E646572657220657874656E73696F6E730A20202020202020202020202069662028746869732E6F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(645) := '657874656E73696F6E7320262620746869732E6F7074696F6E732E657874656E73696F6E732E72656E64657265727320262620746869732E6F7074696F6E732E657874656E73696F6E732E72656E6465726572735B746F6B656E2E747970655D29207B0A';
wwv_flow_imp.g_varchar2_table(646) := '20202020202020202020202020202020636F6E73742067656E65726963546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020636F6E737420726574203D20746869732E6F7074696F6E732E657874656E73696F6E732E72656E64';
wwv_flow_imp.g_varchar2_table(647) := '65726572735B67656E65726963546F6B656E2E747970655D2E63616C6C287B207061727365723A2074686973207D2C2067656E65726963546F6B656E293B0A202020202020202020202020202020206966202872657420213D3D2066616C7365207C7C20';
wwv_flow_imp.g_varchar2_table(648) := '215B277370616365272C20276872272C202768656164696E67272C2027636F6465272C20277461626C65272C2027626C6F636B71756F7465272C20276C697374272C202768746D6C272C2027706172616772617068272C202774657874275D2E696E636C';
wwv_flow_imp.g_varchar2_table(649) := '756465732867656E65726963546F6B656E2E747970652929207B0A20202020202020202020202020202020202020206F7574202B3D20726574207C7C2027273B0A2020202020202020202020202020202020202020636F6E74696E75653B0A2020202020';
wwv_flow_imp.g_varchar2_table(650) := '20202020202020202020207D0A2020202020202020202020207D0A2020202020202020202020207377697463682028746F6B656E2E7479706529207B0A202020202020202020202020202020206361736520277370616365273A207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(651) := '20202020202020202020202020636F6E74696E75653B0A202020202020202020202020202020207D0A202020202020202020202020202020206361736520276872273A207B0A20202020202020202020202020202020202020206F7574202B3D20746869';
wwv_flow_imp.g_varchar2_table(652) := '732E72656E64657265722E687228293B0A2020202020202020202020202020202020202020636F6E74696E75653B0A202020202020202020202020202020207D0A2020202020202020202020202020202063617365202768656164696E67273A207B0A20';
wwv_flow_imp.g_varchar2_table(653) := '20202020202020202020202020202020202020636F6E73742068656164696E67546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020202020206F7574202B3D20746869732E72656E64657265722E68656164696E672874686973';
wwv_flow_imp.g_varchar2_table(654) := '2E7061727365496E6C696E652868656164696E67546F6B656E2E746F6B656E73292C2068656164696E67546F6B656E2E64657074682C20756E65736361706528746869732E7061727365496E6C696E652868656164696E67546F6B656E2E746F6B656E73';
wwv_flow_imp.g_varchar2_table(655) := '2C20746869732E7465787452656E64657265722929293B0A2020202020202020202020202020202020202020636F6E74696E75653B0A202020202020202020202020202020207D0A20202020202020202020202020202020636173652027636F6465273A';
wwv_flow_imp.g_varchar2_table(656) := '207B0A2020202020202020202020202020202020202020636F6E737420636F6465546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020202020206F7574202B3D20746869732E72656E64657265722E636F646528636F6465546F';
wwv_flow_imp.g_varchar2_table(657) := '6B656E2E746578742C20636F6465546F6B656E2E6C616E672C202121636F6465546F6B656E2E65736361706564293B0A2020202020202020202020202020202020202020636F6E74696E75653B0A202020202020202020202020202020207D0A20202020';
wwv_flow_imp.g_varchar2_table(658) := '2020202020202020202020206361736520277461626C65273A207B0A2020202020202020202020202020202020202020636F6E7374207461626C65546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020202020206C6574206865';
wwv_flow_imp.g_varchar2_table(659) := '61646572203D2027273B0A20202020202020202020202020202020202020202F2F206865616465720A20202020202020202020202020202020202020206C65742063656C6C203D2027273B0A2020202020202020202020202020202020202020666F7220';
wwv_flow_imp.g_varchar2_table(660) := '286C6574206A203D20303B206A203C207461626C65546F6B656E2E6865616465722E6C656E6774683B206A2B2B29207B0A20202020202020202020202020202020202020202020202063656C6C202B3D20746869732E72656E64657265722E7461626C65';
wwv_flow_imp.g_varchar2_table(661) := '63656C6C28746869732E7061727365496E6C696E65287461626C65546F6B656E2E6865616465725B6A5D2E746F6B656E73292C207B206865616465723A20747275652C20616C69676E3A207461626C65546F6B656E2E616C69676E5B6A5D207D293B0A20';
wwv_flow_imp.g_varchar2_table(662) := '202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020686561646572202B3D20746869732E72656E64657265722E7461626C65726F772863656C6C293B0A20202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(663) := '206C657420626F6479203D2027273B0A2020202020202020202020202020202020202020666F7220286C6574206A203D20303B206A203C207461626C65546F6B656E2E726F77732E6C656E6774683B206A2B2B29207B0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(664) := '2020202020202020202020636F6E737420726F77203D207461626C65546F6B656E2E726F77735B6A5D3B0A20202020202020202020202020202020202020202020202063656C6C203D2027273B0A20202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(665) := '2020666F7220286C6574206B203D20303B206B203C20726F772E6C656E6774683B206B2B2B29207B0A2020202020202020202020202020202020202020202020202020202063656C6C202B3D20746869732E72656E64657265722E7461626C6563656C6C';
wwv_flow_imp.g_varchar2_table(666) := '28746869732E7061727365496E6C696E6528726F775B6B5D2E746F6B656E73292C207B206865616465723A2066616C73652C20616C69676E3A207461626C65546F6B656E2E616C69676E5B6B5D207D293B0A202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(667) := '2020202020207D0A202020202020202020202020202020202020202020202020626F6479202B3D20746869732E72656E64657265722E7461626C65726F772863656C6C293B0A20202020202020202020202020202020202020207D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(668) := '2020202020202020202020206F7574202B3D20746869732E72656E64657265722E7461626C65286865616465722C20626F6479293B0A2020202020202020202020202020202020202020636F6E74696E75653B0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(669) := '7D0A20202020202020202020202020202020636173652027626C6F636B71756F7465273A207B0A2020202020202020202020202020202020202020636F6E737420626C6F636B71756F7465546F6B656E203D20746F6B656E3B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(670) := '20202020202020202020636F6E737420626F6479203D20746869732E706172736528626C6F636B71756F7465546F6B656E2E746F6B656E73293B0A20202020202020202020202020202020202020206F7574202B3D20746869732E72656E64657265722E';
wwv_flow_imp.g_varchar2_table(671) := '626C6F636B71756F746528626F6479293B0A2020202020202020202020202020202020202020636F6E74696E75653B0A202020202020202020202020202020207D0A202020202020202020202020202020206361736520276C697374273A207B0A202020';
wwv_flow_imp.g_varchar2_table(672) := '2020202020202020202020202020202020636F6E7374206C697374546F6B656E203D20746F6B656E3B0A2020202020202020202020202020202020202020636F6E7374206F726465726564203D206C697374546F6B656E2E6F7264657265643B0A202020';
wwv_flow_imp.g_varchar2_table(673) := '2020202020202020202020202020202020636F6E7374207374617274203D206C697374546F6B656E2E73746172743B0A2020202020202020202020202020202020202020636F6E7374206C6F6F7365203D206C697374546F6B656E2E6C6F6F73653B0A20';
wwv_flow_imp.g_varchar2_table(674) := '202020202020202020202020202020202020206C657420626F6479203D2027273B0A2020202020202020202020202020202020202020666F7220286C6574206A203D20303B206A203C206C697374546F6B656E2E6974656D732E6C656E6774683B206A2B';
wwv_flow_imp.g_varchar2_table(675) := '2B29207B0A202020202020202020202020202020202020202020202020636F6E7374206974656D203D206C697374546F6B656E2E6974656D735B6A5D3B0A202020202020202020202020202020202020202020202020636F6E737420636865636B656420';
wwv_flow_imp.g_varchar2_table(676) := '3D206974656D2E636865636B65643B0A202020202020202020202020202020202020202020202020636F6E7374207461736B203D206974656D2E7461736B3B0A2020202020202020202020202020202020202020202020206C6574206974656D426F6479';
wwv_flow_imp.g_varchar2_table(677) := '203D2027273B0A202020202020202020202020202020202020202020202020696620286974656D2E7461736B29207B0A20202020202020202020202020202020202020202020202020202020636F6E737420636865636B626F78203D20746869732E7265';
wwv_flow_imp.g_varchar2_table(678) := '6E64657265722E636865636B626F78282121636865636B6564293B0A20202020202020202020202020202020202020202020202020202020696620286C6F6F736529207B0A20202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(679) := '20696620286974656D2E746F6B656E732E6C656E677468203E2030202626206974656D2E746F6B656E735B305D2E74797065203D3D3D20277061726167726170682729207B0A202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(680) := '2020202020206974656D2E746F6B656E735B305D2E74657874203D20636865636B626F78202B20272027202B206974656D2E746F6B656E735B305D2E746578743B0A20202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(681) := '2020696620286974656D2E746F6B656E735B305D2E746F6B656E73202626206974656D2E746F6B656E735B305D2E746F6B656E732E6C656E677468203E2030202626206974656D2E746F6B656E735B305D2E746F6B656E735B305D2E74797065203D3D3D';
wwv_flow_imp.g_varchar2_table(682) := '2027746578742729207B0A202020202020202020202020202020202020202020202020202020202020202020202020202020206974656D2E746F6B656E735B305D2E746F6B656E735B305D2E74657874203D20636865636B626F78202B20272027202B20';
wwv_flow_imp.g_varchar2_table(683) := '6974656D2E746F6B656E735B305D2E746F6B656E735B305D2E746578743B0A2020202020202020202020202020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(684) := '207D0A2020202020202020202020202020202020202020202020202020202020202020656C7365207B0A2020202020202020202020202020202020202020202020202020202020202020202020206974656D2E746F6B656E732E756E7368696674287B0A';
wwv_flow_imp.g_varchar2_table(685) := '20202020202020202020202020202020202020202020202020202020202020202020202020202020747970653A202774657874272C0A20202020202020202020202020202020202020202020202020202020202020202020202020202020746578743A20';
wwv_flow_imp.g_varchar2_table(686) := '636865636B626F78202B202720270A2020202020202020202020202020202020202020202020202020202020202020202020207D293B0A20202020202020202020202020202020202020202020202020202020202020207D0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(687) := '20202020202020202020202020202020207D0A20202020202020202020202020202020202020202020202020202020656C7365207B0A20202020202020202020202020202020202020202020202020202020202020206974656D426F6479202B3D206368';
wwv_flow_imp.g_varchar2_table(688) := '65636B626F78202B202720273B0A202020202020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020206974656D426F';
wwv_flow_imp.g_varchar2_table(689) := '6479202B3D20746869732E7061727365286974656D2E746F6B656E732C206C6F6F7365293B0A202020202020202020202020202020202020202020202020626F6479202B3D20746869732E72656E64657265722E6C6973746974656D286974656D426F64';
wwv_flow_imp.g_varchar2_table(690) := '792C207461736B2C202121636865636B6564293B0A20202020202020202020202020202020202020207D0A20202020202020202020202020202020202020206F7574202B3D20746869732E72656E64657265722E6C69737428626F64792C206F72646572';
wwv_flow_imp.g_varchar2_table(691) := '65642C207374617274293B0A2020202020202020202020202020202020202020636F6E74696E75653B0A202020202020202020202020202020207D0A2020202020202020202020202020202063617365202768746D6C273A207B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(692) := '2020202020202020202020636F6E73742068746D6C546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020202020206F7574202B3D20746869732E72656E64657265722E68746D6C2868746D6C546F6B656E2E746578742C206874';
wwv_flow_imp.g_varchar2_table(693) := '6D6C546F6B656E2E626C6F636B293B0A2020202020202020202020202020202020202020636F6E74696E75653B0A202020202020202020202020202020207D0A20202020202020202020202020202020636173652027706172616772617068273A207B0A';
wwv_flow_imp.g_varchar2_table(694) := '2020202020202020202020202020202020202020636F6E737420706172616772617068546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020202020206F7574202B3D20746869732E72656E64657265722E706172616772617068';
wwv_flow_imp.g_varchar2_table(695) := '28746869732E7061727365496E6C696E6528706172616772617068546F6B656E2E746F6B656E7329293B0A2020202020202020202020202020202020202020636F6E74696E75653B0A202020202020202020202020202020207D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(696) := '2020202020202063617365202774657874273A207B0A20202020202020202020202020202020202020206C65742074657874546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020202020206C657420626F6479203D2074657874';
wwv_flow_imp.g_varchar2_table(697) := '546F6B656E2E746F6B656E73203F20746869732E7061727365496E6C696E652874657874546F6B656E2E746F6B656E7329203A2074657874546F6B656E2E746578743B0A20202020202020202020202020202020202020207768696C65202869202B2031';
wwv_flow_imp.g_varchar2_table(698) := '203C20746F6B656E732E6C656E67746820262620746F6B656E735B69202B20315D2E74797065203D3D3D2027746578742729207B0A20202020202020202020202020202020202020202020202074657874546F6B656E203D20746F6B656E735B2B2B695D';
wwv_flow_imp.g_varchar2_table(699) := '3B0A202020202020202020202020202020202020202020202020626F6479202B3D20275C6E27202B202874657874546F6B656E2E746F6B656E73203F20746869732E7061727365496E6C696E652874657874546F6B656E2E746F6B656E7329203A207465';
wwv_flow_imp.g_varchar2_table(700) := '7874546F6B656E2E74657874293B0A20202020202020202020202020202020202020207D0A20202020202020202020202020202020202020206F7574202B3D20746F70203F20746869732E72656E64657265722E70617261677261706828626F64792920';
wwv_flow_imp.g_varchar2_table(701) := '3A20626F64793B0A2020202020202020202020202020202020202020636F6E74696E75653B0A202020202020202020202020202020207D0A2020202020202020202020202020202064656661756C743A207B0A2020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(702) := '202020636F6E7374206572724D7367203D2027546F6B656E2077697468202227202B20746F6B656E2E74797065202B202722207479706520776173206E6F7420666F756E642E273B0A202020202020202020202020202020202020202069662028746869';
wwv_flow_imp.g_varchar2_table(703) := '732E6F7074696F6E732E73696C656E7429207B0A202020202020202020202020202020202020202020202020636F6E736F6C652E6572726F72286572724D7367293B0A20202020202020202020202020202020202020202020202072657475726E202727';
wwv_flow_imp.g_varchar2_table(704) := '3B0A20202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020656C7365207B0A2020202020202020202020202020202020202020202020207468726F77206E6577204572726F72286572724D7367293B0A';
wwv_flow_imp.g_varchar2_table(705) := '20202020202020202020202020202020202020207D0A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020207D0A202020202020202072657475726E206F75743B0A202020207D0A202020202F2A2A0A2020';
wwv_flow_imp.g_varchar2_table(706) := '2020202A20506172736520496E6C696E6520546F6B656E730A20202020202A2F0A202020207061727365496E6C696E6528746F6B656E732C2072656E646572657229207B0A202020202020202072656E6465726572203D2072656E6465726572207C7C20';
wwv_flow_imp.g_varchar2_table(707) := '746869732E72656E64657265723B0A20202020202020206C6574206F7574203D2027273B0A2020202020202020666F7220286C65742069203D20303B2069203C20746F6B656E732E6C656E6774683B20692B2B29207B0A20202020202020202020202063';
wwv_flow_imp.g_varchar2_table(708) := '6F6E737420746F6B656E203D20746F6B656E735B695D3B0A2020202020202020202020202F2F2052756E20616E792072656E646572657220657874656E73696F6E730A20202020202020202020202069662028746869732E6F7074696F6E732E65787465';
wwv_flow_imp.g_varchar2_table(709) := '6E73696F6E7320262620746869732E6F7074696F6E732E657874656E73696F6E732E72656E64657265727320262620746869732E6F7074696F6E732E657874656E73696F6E732E72656E6465726572735B746F6B656E2E747970655D29207B0A20202020';
wwv_flow_imp.g_varchar2_table(710) := '202020202020202020202020636F6E737420726574203D20746869732E6F7074696F6E732E657874656E73696F6E732E72656E6465726572735B746F6B656E2E747970655D2E63616C6C287B207061727365723A2074686973207D2C20746F6B656E293B';
wwv_flow_imp.g_varchar2_table(711) := '0A202020202020202020202020202020206966202872657420213D3D2066616C7365207C7C20215B27657363617065272C202768746D6C272C20276C696E6B272C2027696D616765272C20277374726F6E67272C2027656D272C2027636F64657370616E';
wwv_flow_imp.g_varchar2_table(712) := '272C20276272272C202764656C272C202774657874275D2E696E636C7564657328746F6B656E2E747970652929207B0A20202020202020202020202020202020202020206F7574202B3D20726574207C7C2027273B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(713) := '202020202020636F6E74696E75653B0A202020202020202020202020202020207D0A2020202020202020202020207D0A2020202020202020202020207377697463682028746F6B656E2E7479706529207B0A202020202020202020202020202020206361';
wwv_flow_imp.g_varchar2_table(714) := '73652027657363617065273A207B0A2020202020202020202020202020202020202020636F6E737420657363617065546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020202020206F7574202B3D2072656E64657265722E7465';
wwv_flow_imp.g_varchar2_table(715) := '787428657363617065546F6B656E2E74657874293B0A2020202020202020202020202020202020202020627265616B3B0A202020202020202020202020202020207D0A2020202020202020202020202020202063617365202768746D6C273A207B0A2020';
wwv_flow_imp.g_varchar2_table(716) := '202020202020202020202020202020202020636F6E737420746167546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020202020206F7574202B3D2072656E64657265722E68746D6C28746167546F6B656E2E74657874293B0A20';
wwv_flow_imp.g_varchar2_table(717) := '20202020202020202020202020202020202020627265616B3B0A202020202020202020202020202020207D0A202020202020202020202020202020206361736520276C696E6B273A207B0A2020202020202020202020202020202020202020636F6E7374';
wwv_flow_imp.g_varchar2_table(718) := '206C696E6B546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020202020206F7574202B3D2072656E64657265722E6C696E6B286C696E6B546F6B656E2E687265662C206C696E6B546F6B656E2E7469746C652C20746869732E70';
wwv_flow_imp.g_varchar2_table(719) := '61727365496E6C696E65286C696E6B546F6B656E2E746F6B656E732C2072656E646572657229293B0A2020202020202020202020202020202020202020627265616B3B0A202020202020202020202020202020207D0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(720) := '2020636173652027696D616765273A207B0A2020202020202020202020202020202020202020636F6E737420696D616765546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020202020206F7574202B3D2072656E64657265722E';
wwv_flow_imp.g_varchar2_table(721) := '696D61676528696D616765546F6B656E2E687265662C20696D616765546F6B656E2E7469746C652C20696D616765546F6B656E2E74657874293B0A2020202020202020202020202020202020202020627265616B3B0A2020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(722) := '20207D0A202020202020202020202020202020206361736520277374726F6E67273A207B0A2020202020202020202020202020202020202020636F6E7374207374726F6E67546F6B656E203D20746F6B656E3B0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(723) := '202020206F7574202B3D2072656E64657265722E7374726F6E6728746869732E7061727365496E6C696E65287374726F6E67546F6B656E2E746F6B656E732C2072656E646572657229293B0A202020202020202020202020202020202020202062726561';
wwv_flow_imp.g_varchar2_table(724) := '6B3B0A202020202020202020202020202020207D0A20202020202020202020202020202020636173652027656D273A207B0A2020202020202020202020202020202020202020636F6E737420656D546F6B656E203D20746F6B656E3B0A20202020202020';
wwv_flow_imp.g_varchar2_table(725) := '202020202020202020202020206F7574202B3D2072656E64657265722E656D28746869732E7061727365496E6C696E6528656D546F6B656E2E746F6B656E732C2072656E646572657229293B0A2020202020202020202020202020202020202020627265';
wwv_flow_imp.g_varchar2_table(726) := '616B3B0A202020202020202020202020202020207D0A20202020202020202020202020202020636173652027636F64657370616E273A207B0A2020202020202020202020202020202020202020636F6E737420636F64657370616E546F6B656E203D2074';
wwv_flow_imp.g_varchar2_table(727) := '6F6B656E3B0A20202020202020202020202020202020202020206F7574202B3D2072656E64657265722E636F64657370616E28636F64657370616E546F6B656E2E74657874293B0A2020202020202020202020202020202020202020627265616B3B0A20';
wwv_flow_imp.g_varchar2_table(728) := '2020202020202020202020202020207D0A202020202020202020202020202020206361736520276272273A207B0A20202020202020202020202020202020202020206F7574202B3D2072656E64657265722E627228293B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(729) := '2020202020202020627265616B3B0A202020202020202020202020202020207D0A2020202020202020202020202020202063617365202764656C273A207B0A2020202020202020202020202020202020202020636F6E73742064656C546F6B656E203D20';
wwv_flow_imp.g_varchar2_table(730) := '746F6B656E3B0A20202020202020202020202020202020202020206F7574202B3D2072656E64657265722E64656C28746869732E7061727365496E6C696E652864656C546F6B656E2E746F6B656E732C2072656E646572657229293B0A20202020202020';
wwv_flow_imp.g_varchar2_table(731) := '20202020202020202020202020627265616B3B0A202020202020202020202020202020207D0A2020202020202020202020202020202063617365202774657874273A207B0A2020202020202020202020202020202020202020636F6E7374207465787454';
wwv_flow_imp.g_varchar2_table(732) := '6F6B656E203D20746F6B656E3B0A20202020202020202020202020202020202020206F7574202B3D2072656E64657265722E746578742874657874546F6B656E2E74657874293B0A2020202020202020202020202020202020202020627265616B3B0A20';
wwv_flow_imp.g_varchar2_table(733) := '2020202020202020202020202020207D0A2020202020202020202020202020202064656661756C743A207B0A2020202020202020202020202020202020202020636F6E7374206572724D7367203D2027546F6B656E2077697468202227202B20746F6B65';
wwv_flow_imp.g_varchar2_table(734) := '6E2E74797065202B202722207479706520776173206E6F7420666F756E642E273B0A202020202020202020202020202020202020202069662028746869732E6F7074696F6E732E73696C656E7429207B0A20202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(735) := '2020202020636F6E736F6C652E6572726F72286572724D7367293B0A20202020202020202020202020202020202020202020202072657475726E2027273B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(736) := '2020202020656C7365207B0A2020202020202020202020202020202020202020202020207468726F77206E6577204572726F72286572724D7367293B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020207D';
wwv_flow_imp.g_varchar2_table(737) := '0A2020202020202020202020207D0A20202020202020207D0A202020202020202072657475726E206F75743B0A202020207D0A7D0A0A636C617373205F486F6F6B73207B0A202020206F7074696F6E733B0A20202020636F6E7374727563746F72286F70';
wwv_flow_imp.g_varchar2_table(738) := '74696F6E7329207B0A2020202020202020746869732E6F7074696F6E73203D206F7074696F6E73207C7C205F64656661756C74733B0A202020207D0A2020202073746174696320706173735468726F756768486F6F6B73203D206E657720536574285B0A';
wwv_flow_imp.g_varchar2_table(739) := '20202020202020202770726570726F63657373272C0A202020202020202027706F737470726F63657373272C0A20202020202020202770726F63657373416C6C546F6B656E73270A202020205D293B0A202020202F2A2A0A20202020202A2050726F6365';
wwv_flow_imp.g_varchar2_table(740) := '7373206D61726B646F776E206265666F7265206D61726B65640A20202020202A2F0A2020202070726570726F63657373286D61726B646F776E29207B0A202020202020202072657475726E206D61726B646F776E3B0A202020207D0A202020202F2A2A0A';
wwv_flow_imp.g_varchar2_table(741) := '20202020202A2050726F636573732048544D4C206166746572206D61726B65642069732066696E69736865640A20202020202A2F0A20202020706F737470726F636573732868746D6C29207B0A202020202020202072657475726E2068746D6C3B0A2020';
wwv_flow_imp.g_varchar2_table(742) := '20207D0A202020202F2A2A0A20202020202A2050726F6365737320616C6C20746F6B656E73206265666F72652077616C6B20746F6B656E730A20202020202A2F0A2020202070726F63657373416C6C546F6B656E7328746F6B656E7329207B0A20202020';
wwv_flow_imp.g_varchar2_table(743) := '2020202072657475726E20746F6B656E733B0A202020207D0A7D0A0A636C617373204D61726B6564207B0A2020202064656661756C7473203D205F67657444656661756C747328293B0A202020206F7074696F6E73203D20746869732E7365744F707469';
wwv_flow_imp.g_varchar2_table(744) := '6F6E733B0A202020207061727365203D20746869732E2370617273654D61726B646F776E285F4C657865722E6C65782C205F5061727365722E7061727365293B0A202020207061727365496E6C696E65203D20746869732E2370617273654D61726B646F';
wwv_flow_imp.g_varchar2_table(745) := '776E285F4C657865722E6C6578496E6C696E652C205F5061727365722E7061727365496E6C696E65293B0A20202020506172736572203D205F5061727365723B0A2020202052656E6465726572203D205F52656E64657265723B0A202020205465787452';
wwv_flow_imp.g_varchar2_table(746) := '656E6465726572203D205F5465787452656E64657265723B0A202020204C65786572203D205F4C657865723B0A20202020546F6B656E697A6572203D205F546F6B656E697A65723B0A20202020486F6F6B73203D205F486F6F6B733B0A20202020636F6E';
wwv_flow_imp.g_varchar2_table(747) := '7374727563746F72282E2E2E6172677329207B0A2020202020202020746869732E757365282E2E2E61726773293B0A202020207D0A202020202F2A2A0A20202020202A2052756E2063616C6C6261636B20666F7220657665727920746F6B656E0A202020';
wwv_flow_imp.g_varchar2_table(748) := '20202A2F0A2020202077616C6B546F6B656E7328746F6B656E732C2063616C6C6261636B29207B0A20202020202020206C65742076616C756573203D205B5D3B0A2020202020202020666F722028636F6E737420746F6B656E206F6620746F6B656E7329';
wwv_flow_imp.g_varchar2_table(749) := '207B0A20202020202020202020202076616C756573203D2076616C7565732E636F6E6361742863616C6C6261636B2E63616C6C28746869732C20746F6B656E29293B0A2020202020202020202020207377697463682028746F6B656E2E7479706529207B';
wwv_flow_imp.g_varchar2_table(750) := '0A202020202020202020202020202020206361736520277461626C65273A207B0A2020202020202020202020202020202020202020636F6E7374207461626C65546F6B656E203D20746F6B656E3B0A202020202020202020202020202020202020202066';
wwv_flow_imp.g_varchar2_table(751) := '6F722028636F6E73742063656C6C206F66207461626C65546F6B656E2E68656164657229207B0A20202020202020202020202020202020202020202020202076616C756573203D2076616C7565732E636F6E63617428746869732E77616C6B546F6B656E';
wwv_flow_imp.g_varchar2_table(752) := '732863656C6C2E746F6B656E732C2063616C6C6261636B29293B0A20202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020666F722028636F6E737420726F77206F66207461626C65546F6B656E2E726F';
wwv_flow_imp.g_varchar2_table(753) := '777329207B0A202020202020202020202020202020202020202020202020666F722028636F6E73742063656C6C206F6620726F7729207B0A2020202020202020202020202020202020202020202020202020202076616C756573203D2076616C7565732E';
wwv_flow_imp.g_varchar2_table(754) := '636F6E63617428746869732E77616C6B546F6B656E732863656C6C2E746F6B656E732C2063616C6C6261636B29293B0A2020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020202020207D0A20202020';
wwv_flow_imp.g_varchar2_table(755) := '20202020202020202020202020202020627265616B3B0A202020202020202020202020202020207D0A202020202020202020202020202020206361736520276C697374273A207B0A2020202020202020202020202020202020202020636F6E7374206C69';
wwv_flow_imp.g_varchar2_table(756) := '7374546F6B656E203D20746F6B656E3B0A202020202020202020202020202020202020202076616C756573203D2076616C7565732E636F6E63617428746869732E77616C6B546F6B656E73286C697374546F6B656E2E6974656D732C2063616C6C626163';
wwv_flow_imp.g_varchar2_table(757) := '6B29293B0A2020202020202020202020202020202020202020627265616B3B0A202020202020202020202020202020207D0A2020202020202020202020202020202064656661756C743A207B0A2020202020202020202020202020202020202020636F6E';
wwv_flow_imp.g_varchar2_table(758) := '73742067656E65726963546F6B656E203D20746F6B656E3B0A202020202020202020202020202020202020202069662028746869732E64656661756C74732E657874656E73696F6E733F2E6368696C64546F6B656E733F2E5B67656E65726963546F6B65';
wwv_flow_imp.g_varchar2_table(759) := '6E2E747970655D29207B0A202020202020202020202020202020202020202020202020746869732E64656661756C74732E657874656E73696F6E732E6368696C64546F6B656E735B67656E65726963546F6B656E2E747970655D2E666F72456163682828';
wwv_flow_imp.g_varchar2_table(760) := '6368696C64546F6B656E7329203D3E207B0A20202020202020202020202020202020202020202020202020202020636F6E737420746F6B656E73203D2067656E65726963546F6B656E5B6368696C64546F6B656E735D2E666C617428496E66696E697479';
wwv_flow_imp.g_varchar2_table(761) := '293B0A2020202020202020202020202020202020202020202020202020202076616C756573203D2076616C7565732E636F6E63617428746869732E77616C6B546F6B656E7328746F6B656E732C2063616C6C6261636B29293B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(762) := '20202020202020202020202020207D293B0A20202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020656C7365206966202867656E65726963546F6B656E2E746F6B656E7329207B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(763) := '2020202020202020202020202020202076616C756573203D2076616C7565732E636F6E63617428746869732E77616C6B546F6B656E732867656E65726963546F6B656E2E746F6B656E732C2063616C6C6261636B29293B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(764) := '20202020202020207D0A202020202020202020202020202020207D0A2020202020202020202020207D0A20202020202020207D0A202020202020202072657475726E2076616C7565733B0A202020207D0A20202020757365282E2E2E6172677329207B0A';
wwv_flow_imp.g_varchar2_table(765) := '2020202020202020636F6E737420657874656E73696F6E73203D20746869732E64656661756C74732E657874656E73696F6E73207C7C207B2072656E6465726572733A207B7D2C206368696C64546F6B656E733A207B7D207D3B0A202020202020202061';
wwv_flow_imp.g_varchar2_table(766) := '7267732E666F724561636828287061636B29203D3E207B0A2020202020202020202020202F2F20636F7079206F7074696F6E7320746F206E6577206F626A6563740A202020202020202020202020636F6E7374206F707473203D207B202E2E2E7061636B';
wwv_flow_imp.g_varchar2_table(767) := '207D3B0A2020202020202020202020202F2F20736574206173796E6320746F2074727565206966206974207761732073657420746F2074727565206265666F72650A2020202020202020202020206F7074732E6173796E63203D20746869732E64656661';
wwv_flow_imp.g_varchar2_table(768) := '756C74732E6173796E63207C7C206F7074732E6173796E63207C7C2066616C73653B0A2020202020202020202020202F2F203D3D2D2D20506172736520226164646F6E2220657874656E73696F6E73202D2D3D3D202F2F0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(769) := '696620287061636B2E657874656E73696F6E7329207B0A202020202020202020202020202020207061636B2E657874656E73696F6E732E666F7245616368282865787429203D3E207B0A2020202020202020202020202020202020202020696620282165';
wwv_flow_imp.g_varchar2_table(770) := '78742E6E616D6529207B0A2020202020202020202020202020202020202020202020207468726F77206E6577204572726F722827657874656E73696F6E206E616D6520726571756972656427293B0A20202020202020202020202020202020202020207D';
wwv_flow_imp.g_varchar2_table(771) := '0A2020202020202020202020202020202020202020696620282772656E64657265722720696E2065787429207B202F2F2052656E646572657220657874656E73696F6E730A202020202020202020202020202020202020202020202020636F6E73742070';
wwv_flow_imp.g_varchar2_table(772) := '72657652656E6465726572203D20657874656E73696F6E732E72656E6465726572735B6578742E6E616D655D3B0A202020202020202020202020202020202020202020202020696620287072657652656E646572657229207B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(773) := '2020202020202020202020202020202020202F2F205265706C61636520657874656E73696F6E20776974682066756E6320746F2072756E206E657720657874656E73696F6E206275742066616C6C206261636B2069662066616C73650A20202020202020';
wwv_flow_imp.g_varchar2_table(774) := '202020202020202020202020202020202020202020657874656E73696F6E732E72656E6465726572735B6578742E6E616D655D203D2066756E6374696F6E20282E2E2E6172677329207B0A20202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(775) := '202020202020206C657420726574203D206578742E72656E64657265722E6170706C7928746869732C2061726773293B0A202020202020202020202020202020202020202020202020202020202020202069662028726574203D3D3D2066616C73652920';
wwv_flow_imp.g_varchar2_table(776) := '7B0A202020202020202020202020202020202020202020202020202020202020202020202020726574203D207072657652656E64657265722E6170706C7928746869732C2061726773293B0A202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(777) := '20202020202020207D0A202020202020202020202020202020202020202020202020202020202020202072657475726E207265743B0A202020202020202020202020202020202020202020202020202020207D3B0A202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(778) := '2020202020202020207D0A202020202020202020202020202020202020202020202020656C7365207B0A20202020202020202020202020202020202020202020202020202020657874656E73696F6E732E72656E6465726572735B6578742E6E616D655D';
wwv_flow_imp.g_varchar2_table(779) := '203D206578742E72656E64657265723B0A2020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020202020207D0A20202020202020202020202020202020202020206966202827746F6B656E697A657227';
wwv_flow_imp.g_varchar2_table(780) := '20696E2065787429207B202F2F20546F6B656E697A657220457874656E73696F6E730A20202020202020202020202020202020202020202020202069662028216578742E6C6576656C207C7C20286578742E6C6576656C20213D3D2027626C6F636B2720';
wwv_flow_imp.g_varchar2_table(781) := '2626206578742E6C6576656C20213D3D2027696E6C696E65272929207B0A202020202020202020202020202020202020202020202020202020207468726F77206E6577204572726F722822657874656E73696F6E206C6576656C206D7573742062652027';
wwv_flow_imp.g_varchar2_table(782) := '626C6F636B27206F722027696E6C696E652722293B0A2020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020636F6E7374206578744C6576656C203D20657874656E73696F6E735B';
wwv_flow_imp.g_varchar2_table(783) := '6578742E6C6576656C5D3B0A202020202020202020202020202020202020202020202020696620286578744C6576656C29207B0A202020202020202020202020202020202020202020202020202020206578744C6576656C2E756E736869667428657874';
wwv_flow_imp.g_varchar2_table(784) := '2E746F6B656E697A6572293B0A2020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020656C7365207B0A202020202020202020202020202020202020202020202020202020206578';
wwv_flow_imp.g_varchar2_table(785) := '74656E73696F6E735B6578742E6C6576656C5D203D205B6578742E746F6B656E697A65725D3B0A2020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020696620286578742E737461';
wwv_flow_imp.g_varchar2_table(786) := '727429207B202F2F2046756E6374696F6E20746F20636865636B20666F72207374617274206F6620746F6B656E0A20202020202020202020202020202020202020202020202020202020696620286578742E6C6576656C203D3D3D2027626C6F636B2729';
wwv_flow_imp.g_varchar2_table(787) := '207B0A202020202020202020202020202020202020202020202020202020202020202069662028657874656E73696F6E732E7374617274426C6F636B29207B0A202020202020202020202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(788) := '657874656E73696F6E732E7374617274426C6F636B2E70757368286578742E7374617274293B0A20202020202020202020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(789) := '2020202020656C7365207B0A202020202020202020202020202020202020202020202020202020202020202020202020657874656E73696F6E732E7374617274426C6F636B203D205B6578742E73746172745D3B0A202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(790) := '20202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020202020202020202020202020656C736520696620286578742E6C6576656C203D3D3D20';
wwv_flow_imp.g_varchar2_table(791) := '27696E6C696E652729207B0A202020202020202020202020202020202020202020202020202020202020202069662028657874656E73696F6E732E7374617274496E6C696E6529207B0A2020202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(792) := '20202020202020202020657874656E73696F6E732E7374617274496E6C696E652E70757368286578742E7374617274293B0A20202020202020202020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(793) := '20202020202020202020202020202020656C7365207B0A202020202020202020202020202020202020202020202020202020202020202020202020657874656E73696F6E732E7374617274496E6C696E65203D205B6578742E73746172745D3B0A202020';
wwv_flow_imp.g_varchar2_table(794) := '20202020202020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020202020207D0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(795) := '202020202020207D0A202020202020202020202020202020202020202069662028276368696C64546F6B656E732720696E20657874202626206578742E6368696C64546F6B656E7329207B202F2F204368696C6420746F6B656E7320746F206265207669';
wwv_flow_imp.g_varchar2_table(796) := '73697465642062792077616C6B546F6B656E730A202020202020202020202020202020202020202020202020657874656E73696F6E732E6368696C64546F6B656E735B6578742E6E616D655D203D206578742E6368696C64546F6B656E733B0A20202020';
wwv_flow_imp.g_varchar2_table(797) := '202020202020202020202020202020207D0A202020202020202020202020202020207D293B0A202020202020202020202020202020206F7074732E657874656E73696F6E73203D20657874656E73696F6E733B0A2020202020202020202020207D0A2020';
wwv_flow_imp.g_varchar2_table(798) := '202020202020202020202F2F203D3D2D2D20506172736520226F76657277726974652220657874656E73696F6E73202D2D3D3D202F2F0A202020202020202020202020696620287061636B2E72656E646572657229207B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(799) := '20202020636F6E73742072656E6465726572203D20746869732E64656661756C74732E72656E6465726572207C7C206E6577205F52656E646572657228746869732E64656661756C7473293B0A20202020202020202020202020202020666F722028636F';
wwv_flow_imp.g_varchar2_table(800) := '6E73742070726F7020696E207061636B2E72656E646572657229207B0A202020202020202020202020202020202020202069662028212870726F7020696E2072656E64657265722929207B0A202020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(801) := '7468726F77206E6577204572726F72286072656E64657265722027247B70726F707D2720646F6573206E6F7420657869737460293B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020202020202069662028';
wwv_flow_imp.g_varchar2_table(802) := '70726F70203D3D3D20276F7074696F6E732729207B0A2020202020202020202020202020202020202020202020202F2F2069676E6F7265206F7074696F6E732070726F70657274790A202020202020202020202020202020202020202020202020636F6E';
wwv_flow_imp.g_varchar2_table(803) := '74696E75653B0A20202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020636F6E73742072656E646572657250726F70203D2070726F703B0A2020202020202020202020202020202020202020636F6E73';
wwv_flow_imp.g_varchar2_table(804) := '742072656E646572657246756E63203D207061636B2E72656E64657265725B72656E646572657250726F705D3B0A2020202020202020202020202020202020202020636F6E7374207072657652656E6465726572203D2072656E64657265725B72656E64';
wwv_flow_imp.g_varchar2_table(805) := '6572657250726F705D3B0A20202020202020202020202020202020202020202F2F205265706C6163652072656E646572657220776974682066756E6320746F2072756E20657874656E73696F6E2C206275742066616C6C206261636B2069662066616C73';
wwv_flow_imp.g_varchar2_table(806) := '650A202020202020202020202020202020202020202072656E64657265725B72656E646572657250726F705D203D20282E2E2E6172677329203D3E207B0A2020202020202020202020202020202020202020202020206C657420726574203D2072656E64';
wwv_flow_imp.g_varchar2_table(807) := '6572657246756E632E6170706C792872656E64657265722C2061726773293B0A20202020202020202020202020202020202020202020202069662028726574203D3D3D2066616C736529207B0A2020202020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(808) := '2020202020726574203D207072657652656E64657265722E6170706C792872656E64657265722C2061726773293B0A2020202020202020202020202020202020202020202020207D0A202020202020202020202020202020202020202020202020726574';
wwv_flow_imp.g_varchar2_table(809) := '75726E20726574207C7C2027273B0A20202020202020202020202020202020202020207D3B0A202020202020202020202020202020207D0A202020202020202020202020202020206F7074732E72656E6465726572203D2072656E64657265723B0A2020';
wwv_flow_imp.g_varchar2_table(810) := '202020202020202020207D0A202020202020202020202020696620287061636B2E746F6B656E697A657229207B0A20202020202020202020202020202020636F6E737420746F6B656E697A6572203D20746869732E64656661756C74732E746F6B656E69';
wwv_flow_imp.g_varchar2_table(811) := '7A6572207C7C206E6577205F546F6B656E697A657228746869732E64656661756C7473293B0A20202020202020202020202020202020666F722028636F6E73742070726F7020696E207061636B2E746F6B656E697A657229207B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(812) := '202020202020202020202069662028212870726F7020696E20746F6B656E697A65722929207B0A2020202020202020202020202020202020202020202020207468726F77206E6577204572726F722860746F6B656E697A65722027247B70726F707D2720';
wwv_flow_imp.g_varchar2_table(813) := '646F6573206E6F7420657869737460293B0A20202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020696620285B276F7074696F6E73272C202772756C6573272C20276C65786572275D2E696E636C7564';
wwv_flow_imp.g_varchar2_table(814) := '65732870726F702929207B0A2020202020202020202020202020202020202020202020202F2F2069676E6F7265206F7074696F6E732C2072756C65732C20616E64206C657865722070726F706572746965730A2020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(815) := '20202020202020636F6E74696E75653B0A20202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020636F6E737420746F6B656E697A657250726F70203D2070726F703B0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(816) := '20202020202020636F6E737420746F6B656E697A657246756E63203D207061636B2E746F6B656E697A65725B746F6B656E697A657250726F705D3B0A2020202020202020202020202020202020202020636F6E73742070726576546F6B656E697A657220';
wwv_flow_imp.g_varchar2_table(817) := '3D20746F6B656E697A65725B746F6B656E697A657250726F705D3B0A20202020202020202020202020202020202020202F2F205265706C61636520746F6B656E697A657220776974682066756E6320746F2072756E20657874656E73696F6E2C20627574';
wwv_flow_imp.g_varchar2_table(818) := '2066616C6C206261636B2069662066616C73650A20202020202020202020202020202020202020202F2F204074732D6578706563742D6572726F722063616E6E6F74207479706520746F6B656E697A65722066756E6374696F6E2064796E616D6963616C';
wwv_flow_imp.g_varchar2_table(819) := '6C790A2020202020202020202020202020202020202020746F6B656E697A65725B746F6B656E697A657250726F705D203D20282E2E2E6172677329203D3E207B0A2020202020202020202020202020202020202020202020206C657420726574203D2074';
wwv_flow_imp.g_varchar2_table(820) := '6F6B656E697A657246756E632E6170706C7928746F6B656E697A65722C2061726773293B0A20202020202020202020202020202020202020202020202069662028726574203D3D3D2066616C736529207B0A202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(821) := '20202020202020202020726574203D2070726576546F6B656E697A65722E6170706C7928746F6B656E697A65722C2061726773293B0A2020202020202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(822) := '2020202072657475726E207265743B0A20202020202020202020202020202020202020207D3B0A202020202020202020202020202020207D0A202020202020202020202020202020206F7074732E746F6B656E697A6572203D20746F6B656E697A65723B';
wwv_flow_imp.g_varchar2_table(823) := '0A2020202020202020202020207D0A2020202020202020202020202F2F203D3D2D2D20506172736520486F6F6B7320657874656E73696F6E73202D2D3D3D202F2F0A202020202020202020202020696620287061636B2E686F6F6B7329207B0A20202020';
wwv_flow_imp.g_varchar2_table(824) := '202020202020202020202020636F6E737420686F6F6B73203D20746869732E64656661756C74732E686F6F6B73207C7C206E6577205F486F6F6B7328293B0A20202020202020202020202020202020666F722028636F6E73742070726F7020696E207061';
wwv_flow_imp.g_varchar2_table(825) := '636B2E686F6F6B7329207B0A202020202020202020202020202020202020202069662028212870726F7020696E20686F6F6B732929207B0A2020202020202020202020202020202020202020202020207468726F77206E6577204572726F722860686F6F';
wwv_flow_imp.g_varchar2_table(826) := '6B2027247B70726F707D2720646F6573206E6F7420657869737460293B0A20202020202020202020202020202020202020207D0A20202020202020202020202020202020202020206966202870726F70203D3D3D20276F7074696F6E732729207B0A2020';
wwv_flow_imp.g_varchar2_table(827) := '202020202020202020202020202020202020202020202F2F2069676E6F7265206F7074696F6E732070726F70657274790A202020202020202020202020202020202020202020202020636F6E74696E75653B0A2020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(828) := '2020207D0A2020202020202020202020202020202020202020636F6E737420686F6F6B7350726F70203D2070726F703B0A2020202020202020202020202020202020202020636F6E737420686F6F6B7346756E63203D207061636B2E686F6F6B735B686F';
wwv_flow_imp.g_varchar2_table(829) := '6F6B7350726F705D3B0A2020202020202020202020202020202020202020636F6E73742070726576486F6F6B203D20686F6F6B735B686F6F6B7350726F705D3B0A2020202020202020202020202020202020202020696620285F486F6F6B732E70617373';
wwv_flow_imp.g_varchar2_table(830) := '5468726F756768486F6F6B732E6861732870726F702929207B0A2020202020202020202020202020202020202020202020202F2F204074732D6578706563742D6572726F722063616E6E6F74207479706520686F6F6B2066756E6374696F6E2064796E61';
wwv_flow_imp.g_varchar2_table(831) := '6D6963616C6C790A202020202020202020202020202020202020202020202020686F6F6B735B686F6F6B7350726F705D203D202861726729203D3E207B0A2020202020202020202020202020202020202020202020202020202069662028746869732E64';
wwv_flow_imp.g_varchar2_table(832) := '656661756C74732E6173796E6329207B0A202020202020202020202020202020202020202020202020202020202020202072657475726E2050726F6D6973652E7265736F6C766528686F6F6B7346756E632E63616C6C28686F6F6B732C2061726729292E';
wwv_flow_imp.g_varchar2_table(833) := '7468656E28726574203D3E207B0A20202020202020202020202020202020202020202020202020202020202020202020202072657475726E2070726576486F6F6B2E63616C6C28686F6F6B732C20726574293B0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(834) := '202020202020202020202020202020207D293B0A202020202020202020202020202020202020202020202020202020207D0A20202020202020202020202020202020202020202020202020202020636F6E737420726574203D20686F6F6B7346756E632E';
wwv_flow_imp.g_varchar2_table(835) := '63616C6C28686F6F6B732C20617267293B0A2020202020202020202020202020202020202020202020202020202072657475726E2070726576486F6F6B2E63616C6C28686F6F6B732C20726574293B0A2020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(836) := '202020207D3B0A20202020202020202020202020202020202020207D0A2020202020202020202020202020202020202020656C7365207B0A2020202020202020202020202020202020202020202020202F2F204074732D6578706563742D6572726F7220';
wwv_flow_imp.g_varchar2_table(837) := '63616E6E6F74207479706520686F6F6B2066756E6374696F6E2064796E616D6963616C6C790A202020202020202020202020202020202020202020202020686F6F6B735B686F6F6B7350726F705D203D20282E2E2E6172677329203D3E207B0A20202020';
wwv_flow_imp.g_varchar2_table(838) := '2020202020202020202020202020202020202020202020206C657420726574203D20686F6F6B7346756E632E6170706C7928686F6F6B732C2061726773293B0A202020202020202020202020202020202020202020202020202020206966202872657420';
wwv_flow_imp.g_varchar2_table(839) := '3D3D3D2066616C736529207B0A2020202020202020202020202020202020202020202020202020202020202020726574203D2070726576486F6F6B2E6170706C7928686F6F6B732C2061726773293B0A2020202020202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(840) := '20202020202020207D0A2020202020202020202020202020202020202020202020202020202072657475726E207265743B0A2020202020202020202020202020202020202020202020207D3B0A20202020202020202020202020202020202020207D0A20';
wwv_flow_imp.g_varchar2_table(841) := '2020202020202020202020202020207D0A202020202020202020202020202020206F7074732E686F6F6B73203D20686F6F6B733B0A2020202020202020202020207D0A2020202020202020202020202F2F203D3D2D2D2050617273652057616C6B546F6B';
wwv_flow_imp.g_varchar2_table(842) := '656E7320657874656E73696F6E73202D2D3D3D202F2F0A202020202020202020202020696620287061636B2E77616C6B546F6B656E7329207B0A20202020202020202020202020202020636F6E73742077616C6B546F6B656E73203D20746869732E6465';
wwv_flow_imp.g_varchar2_table(843) := '6661756C74732E77616C6B546F6B656E733B0A20202020202020202020202020202020636F6E7374207061636B57616C6B746F6B656E73203D207061636B2E77616C6B546F6B656E733B0A202020202020202020202020202020206F7074732E77616C6B';
wwv_flow_imp.g_varchar2_table(844) := '546F6B656E73203D2066756E6374696F6E2028746F6B656E29207B0A20202020202020202020202020202020202020206C65742076616C756573203D205B5D3B0A202020202020202020202020202020202020202076616C7565732E7075736828706163';
wwv_flow_imp.g_varchar2_table(845) := '6B57616C6B746F6B656E732E63616C6C28746869732C20746F6B656E29293B0A20202020202020202020202020202020202020206966202877616C6B546F6B656E7329207B0A20202020202020202020202020202020202020202020202076616C756573';
wwv_flow_imp.g_varchar2_table(846) := '203D2076616C7565732E636F6E6361742877616C6B546F6B656E732E63616C6C28746869732C20746F6B656E29293B0A20202020202020202020202020202020202020207D0A202020202020202020202020202020202020202072657475726E2076616C';
wwv_flow_imp.g_varchar2_table(847) := '7565733B0A202020202020202020202020202020207D3B0A2020202020202020202020207D0A202020202020202020202020746869732E64656661756C7473203D207B202E2E2E746869732E64656661756C74732C202E2E2E6F707473207D3B0A202020';
wwv_flow_imp.g_varchar2_table(848) := '20202020207D293B0A202020202020202072657475726E20746869733B0A202020207D0A202020207365744F7074696F6E73286F707429207B0A2020202020202020746869732E64656661756C7473203D207B202E2E2E746869732E64656661756C7473';
wwv_flow_imp.g_varchar2_table(849) := '2C202E2E2E6F7074207D3B0A202020202020202072657475726E20746869733B0A202020207D0A202020206C65786572287372632C206F7074696F6E7329207B0A202020202020202072657475726E205F4C657865722E6C6578287372632C206F707469';
wwv_flow_imp.g_varchar2_table(850) := '6F6E73203F3F20746869732E64656661756C7473293B0A202020207D0A2020202070617273657228746F6B656E732C206F7074696F6E7329207B0A202020202020202072657475726E205F5061727365722E706172736528746F6B656E732C206F707469';
wwv_flow_imp.g_varchar2_table(851) := '6F6E73203F3F20746869732E64656661756C7473293B0A202020207D0A202020202370617273654D61726B646F776E286C657865722C2070617273657229207B0A202020202020202072657475726E20287372632C206F7074696F6E7329203D3E207B0A';
wwv_flow_imp.g_varchar2_table(852) := '202020202020202020202020636F6E7374206F7269674F7074203D207B202E2E2E6F7074696F6E73207D3B0A202020202020202020202020636F6E7374206F7074203D207B202E2E2E746869732E64656661756C74732C202E2E2E6F7269674F7074207D';
wwv_flow_imp.g_varchar2_table(853) := '3B0A2020202020202020202020202F2F2053686F77207761726E696E6720696620616E20657874656E73696F6E20736574206173796E6320746F20747275652062757420746865207061727365207761732063616C6C65642077697468206173796E633A';
wwv_flow_imp.g_varchar2_table(854) := '2066616C73650A20202020202020202020202069662028746869732E64656661756C74732E6173796E63203D3D3D2074727565202626206F7269674F70742E6173796E63203D3D3D2066616C736529207B0A202020202020202020202020202020206966';
wwv_flow_imp.g_varchar2_table(855) := '2028216F70742E73696C656E7429207B0A2020202020202020202020202020202020202020636F6E736F6C652E7761726E28276D61726B656428293A20546865206173796E63206F7074696F6E207761732073657420746F207472756520627920616E20';
wwv_flow_imp.g_varchar2_table(856) := '657874656E73696F6E2E20546865206173796E633A2066616C7365206F7074696F6E2073656E7420746F2070617273652077696C6C2062652069676E6F7265642E27293B0A202020202020202020202020202020207D0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(857) := '2020206F70742E6173796E63203D20747275653B0A2020202020202020202020207D0A202020202020202020202020636F6E7374207468726F774572726F72203D20746869732E236F6E4572726F722821216F70742E73696C656E742C2021216F70742E';
wwv_flow_imp.g_varchar2_table(858) := '6173796E63293B0A2020202020202020202020202F2F207468726F77206572726F7220696E2063617365206F66206E6F6E20737472696E6720696E7075740A20202020202020202020202069662028747970656F6620737263203D3D3D2027756E646566';
wwv_flow_imp.g_varchar2_table(859) := '696E656427207C7C20737263203D3D3D206E756C6C29207B0A2020202020202020202020202020202072657475726E207468726F774572726F72286E6577204572726F7228276D61726B656428293A20696E70757420706172616D657465722069732075';
wwv_flow_imp.g_varchar2_table(860) := '6E646566696E6564206F72206E756C6C2729293B0A2020202020202020202020207D0A20202020202020202020202069662028747970656F662073726320213D3D2027737472696E672729207B0A2020202020202020202020202020202072657475726E';
wwv_flow_imp.g_varchar2_table(861) := '207468726F774572726F72286E6577204572726F7228276D61726B656428293A20696E70757420706172616D65746572206973206F66207479706520270A20202020202020202020202020202020202020202B204F626A6563742E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(862) := '2E746F537472696E672E63616C6C2873726329202B20272C20737472696E672065787065637465642729293B0A2020202020202020202020207D0A202020202020202020202020696620286F70742E686F6F6B7329207B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(863) := '202020206F70742E686F6F6B732E6F7074696F6E73203D206F70743B0A2020202020202020202020207D0A202020202020202020202020696620286F70742E6173796E6329207B0A2020202020202020202020202020202072657475726E2050726F6D69';
wwv_flow_imp.g_varchar2_table(864) := '73652E7265736F6C7665286F70742E686F6F6B73203F206F70742E686F6F6B732E70726570726F636573732873726329203A20737263290A20202020202020202020202020202020202020202E7468656E28737263203D3E206C65786572287372632C20';
wwv_flow_imp.g_varchar2_table(865) := '6F707429290A20202020202020202020202020202020202020202E7468656E28746F6B656E73203D3E206F70742E686F6F6B73203F206F70742E686F6F6B732E70726F63657373416C6C546F6B656E7328746F6B656E7329203A20746F6B656E73290A20';
wwv_flow_imp.g_varchar2_table(866) := '202020202020202020202020202020202020202E7468656E28746F6B656E73203D3E206F70742E77616C6B546F6B656E73203F2050726F6D6973652E616C6C28746869732E77616C6B546F6B656E7328746F6B656E732C206F70742E77616C6B546F6B65';
wwv_flow_imp.g_varchar2_table(867) := '6E7329292E7468656E282829203D3E20746F6B656E7329203A20746F6B656E73290A20202020202020202020202020202020202020202E7468656E28746F6B656E73203D3E2070617273657228746F6B656E732C206F707429290A202020202020202020';
wwv_flow_imp.g_varchar2_table(868) := '20202020202020202020202E7468656E2868746D6C203D3E206F70742E686F6F6B73203F206F70742E686F6F6B732E706F737470726F636573732868746D6C29203A2068746D6C290A20202020202020202020202020202020202020202E636174636828';
wwv_flow_imp.g_varchar2_table(869) := '7468726F774572726F72293B0A2020202020202020202020207D0A202020202020202020202020747279207B0A20202020202020202020202020202020696620286F70742E686F6F6B7329207B0A20202020202020202020202020202020202020207372';
wwv_flow_imp.g_varchar2_table(870) := '63203D206F70742E686F6F6B732E70726570726F6365737328737263293B0A202020202020202020202020202020207D0A202020202020202020202020202020206C657420746F6B656E73203D206C65786572287372632C206F7074293B0A2020202020';
wwv_flow_imp.g_varchar2_table(871) := '2020202020202020202020696620286F70742E686F6F6B7329207B0A2020202020202020202020202020202020202020746F6B656E73203D206F70742E686F6F6B732E70726F63657373416C6C546F6B656E7328746F6B656E73293B0A20202020202020';
wwv_flow_imp.g_varchar2_table(872) := '2020202020202020207D0A20202020202020202020202020202020696620286F70742E77616C6B546F6B656E7329207B0A2020202020202020202020202020202020202020746869732E77616C6B546F6B656E7328746F6B656E732C206F70742E77616C';
wwv_flow_imp.g_varchar2_table(873) := '6B546F6B656E73293B0A202020202020202020202020202020207D0A202020202020202020202020202020206C65742068746D6C203D2070617273657228746F6B656E732C206F7074293B0A20202020202020202020202020202020696620286F70742E';
wwv_flow_imp.g_varchar2_table(874) := '686F6F6B7329207B0A202020202020202020202020202020202020202068746D6C203D206F70742E686F6F6B732E706F737470726F636573732868746D6C293B0A202020202020202020202020202020207D0A2020202020202020202020202020202072';
wwv_flow_imp.g_varchar2_table(875) := '657475726E2068746D6C3B0A2020202020202020202020207D0A202020202020202020202020636174636820286529207B0A2020202020202020202020202020202072657475726E207468726F774572726F722865293B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(876) := '7D0A20202020202020207D3B0A202020207D0A20202020236F6E4572726F722873696C656E742C206173796E6329207B0A202020202020202072657475726E20286529203D3E207B0A202020202020202020202020652E6D657373616765202B3D20275C';
wwv_flow_imp.g_varchar2_table(877) := '6E506C65617365207265706F7274207468697320746F2068747470733A2F2F6769746875622E636F6D2F6D61726B65646A732F6D61726B65642E273B0A2020202020202020202020206966202873696C656E7429207B0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(878) := '202020636F6E7374206D7367203D20273C703E416E206572726F72206F636375727265643A3C2F703E3C7072653E270A20202020202020202020202020202020202020202B20657363617065243128652E6D657373616765202B2027272C207472756529';
wwv_flow_imp.g_varchar2_table(879) := '0A20202020202020202020202020202020202020202B20273C2F7072653E273B0A20202020202020202020202020202020696620286173796E6329207B0A202020202020202020202020202020202020202072657475726E2050726F6D6973652E726573';
wwv_flow_imp.g_varchar2_table(880) := '6F6C7665286D7367293B0A202020202020202020202020202020207D0A2020202020202020202020202020202072657475726E206D73673B0A2020202020202020202020207D0A202020202020202020202020696620286173796E6329207B0A20202020';
wwv_flow_imp.g_varchar2_table(881) := '20202020202020202020202072657475726E2050726F6D6973652E72656A6563742865293B0A2020202020202020202020207D0A2020202020202020202020207468726F7720653B0A20202020202020207D3B0A202020207D0A7D0A0A636F6E7374206D';
wwv_flow_imp.g_varchar2_table(882) := '61726B6564496E7374616E6365203D206E6577204D61726B656428293B0A66756E6374696F6E206D61726B6564287372632C206F707429207B0A2020202072657475726E206D61726B6564496E7374616E63652E7061727365287372632C206F7074293B';
wwv_flow_imp.g_varchar2_table(883) := '0A7D0A2F2A2A0A202A2053657473207468652064656661756C74206F7074696F6E732E0A202A0A202A2040706172616D206F7074696F6E732048617368206F66206F7074696F6E730A202A2F0A6D61726B65642E6F7074696F6E73203D0A202020206D61';
wwv_flow_imp.g_varchar2_table(884) := '726B65642E7365744F7074696F6E73203D2066756E6374696F6E20286F7074696F6E7329207B0A20202020202020206D61726B6564496E7374616E63652E7365744F7074696F6E73286F7074696F6E73293B0A20202020202020206D61726B65642E6465';
wwv_flow_imp.g_varchar2_table(885) := '6661756C7473203D206D61726B6564496E7374616E63652E64656661756C74733B0A20202020202020206368616E676544656661756C7473286D61726B65642E64656661756C7473293B0A202020202020202072657475726E206D61726B65643B0A2020';
wwv_flow_imp.g_varchar2_table(886) := '20207D3B0A2F2A2A0A202A204765747320746865206F726967696E616C206D61726B65642064656661756C74206F7074696F6E732E0A202A2F0A6D61726B65642E67657444656661756C7473203D205F67657444656661756C74733B0A6D61726B65642E';
wwv_flow_imp.g_varchar2_table(887) := '64656661756C7473203D205F64656661756C74733B0A2F2A2A0A202A2055736520457874656E73696F6E0A202A2F0A6D61726B65642E757365203D2066756E6374696F6E20282E2E2E6172677329207B0A202020206D61726B6564496E7374616E63652E';
wwv_flow_imp.g_varchar2_table(888) := '757365282E2E2E61726773293B0A202020206D61726B65642E64656661756C7473203D206D61726B6564496E7374616E63652E64656661756C74733B0A202020206368616E676544656661756C7473286D61726B65642E64656661756C7473293B0A2020';
wwv_flow_imp.g_varchar2_table(889) := '202072657475726E206D61726B65643B0A7D3B0A2F2A2A0A202A2052756E2063616C6C6261636B20666F7220657665727920746F6B656E0A202A2F0A6D61726B65642E77616C6B546F6B656E73203D2066756E6374696F6E2028746F6B656E732C206361';
wwv_flow_imp.g_varchar2_table(890) := '6C6C6261636B29207B0A2020202072657475726E206D61726B6564496E7374616E63652E77616C6B546F6B656E7328746F6B656E732C2063616C6C6261636B293B0A7D3B0A2F2A2A0A202A20436F6D70696C6573206D61726B646F776E20746F2048544D';
wwv_flow_imp.g_varchar2_table(891) := '4C20776974686F757420656E636C6F73696E6720607060207461672E0A202A0A202A2040706172616D2073726320537472696E67206F66206D61726B646F776E20736F7572636520746F20626520636F6D70696C65640A202A2040706172616D206F7074';
wwv_flow_imp.g_varchar2_table(892) := '696F6E732048617368206F66206F7074696F6E730A202A204072657475726E20537472696E67206F6620636F6D70696C65642048544D4C0A202A2F0A6D61726B65642E7061727365496E6C696E65203D206D61726B6564496E7374616E63652E70617273';
wwv_flow_imp.g_varchar2_table(893) := '65496E6C696E653B0A2F2A2A0A202A204578706F73650A202A2F0A6D61726B65642E506172736572203D205F5061727365723B0A6D61726B65642E706172736572203D205F5061727365722E70617273653B0A6D61726B65642E52656E6465726572203D';
wwv_flow_imp.g_varchar2_table(894) := '205F52656E64657265723B0A6D61726B65642E5465787452656E6465726572203D205F5465787452656E64657265723B0A6D61726B65642E4C65786572203D205F4C657865723B0A6D61726B65642E6C65786572203D205F4C657865722E6C65783B0A6D';
wwv_flow_imp.g_varchar2_table(895) := '61726B65642E546F6B656E697A6572203D205F546F6B656E697A65723B0A6D61726B65642E486F6F6B73203D205F486F6F6B733B0A6D61726B65642E7061727365203D206D61726B65643B0A636F6E7374206F7074696F6E73203D206D61726B65642E6F';
wwv_flow_imp.g_varchar2_table(896) := '7074696F6E733B0A636F6E7374207365744F7074696F6E73203D206D61726B65642E7365744F7074696F6E733B0A636F6E737420757365203D206D61726B65642E7573653B0A636F6E73742077616C6B546F6B656E73203D206D61726B65642E77616C6B';
wwv_flow_imp.g_varchar2_table(897) := '546F6B656E733B0A636F6E7374207061727365496E6C696E65203D206D61726B65642E7061727365496E6C696E653B0A636F6E7374207061727365203D206D61726B65643B0A636F6E737420706172736572203D205F5061727365722E70617273653B0A';
wwv_flow_imp.g_varchar2_table(898) := '636F6E7374206C65786572203D205F4C657865722E6C65783B0A0A6578706F7274207B205F486F6F6B7320617320486F6F6B732C205F4C65786572206173204C657865722C204D61726B65642C205F506172736572206173205061727365722C205F5265';
wwv_flow_imp.g_varchar2_table(899) := '6E64657265722061732052656E64657265722C205F5465787452656E6465726572206173205465787452656E64657265722C205F546F6B656E697A657220617320546F6B656E697A65722C205F64656661756C74732061732064656661756C74732C205F';
wwv_flow_imp.g_varchar2_table(900) := '67657444656661756C74732061732067657444656661756C74732C206C657865722C206D61726B65642C206F7074696F6E732C2070617273652C207061727365496E6C696E652C207061727365722C207365744F7074696F6E732C207573652C2077616C';
wwv_flow_imp.g_varchar2_table(901) := '6B546F6B656E73207D3B0A2F2F2320736F757263654D617070696E6755524C3D6D61726B65642E65736D2E6A732E6D61700A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(59398121651468828)
,p_plugin_id=>wwv_flow_imp.id(59392068835395563)
,p_file_name=>'marked.esm.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/shared_components/plugins/process_type/com_flows4apex_manage_instance_process
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(133205785223254214)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'COM.FLOWS4APEX.MANAGE_INSTANCE.PROCESS'
,p_display_name=>'Flows for APEX - Manage Flow Instance'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','COM.FLOWS4APEX.MANAGE_INSTANCE.PROCESS'),'')
,p_api_version=>2
,p_execution_function=>'flow_plugin_manage_instance.execution'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Process used to Creating a <i>Flows for APEX</i> Flow Instance declaratively.'
,p_version_identifier=>'23.1'
,p_about_url=>'https://github.com/flowsforapex/apex-flowsforapex'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133205953479254225)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Global Flow'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>150
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Set Flow using Name only:',
'<pre>Holiday</pre>',
'Set Flow using Name and Version:',
'<pre>Holiday,0</pre>',
'Set Flow using Id:',
'<pre>1</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Depends on the action selected, you can provide:',
'<ul>',
'<li> a Flow Diagram by Name (and optionally Flow Version) or Id.</li>',
'<li> a Flow Instance Id.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133226242255270728)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Action'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'create_and_start'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Use this attribute to define the action you want to process.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133226792524272517)
,p_plugin_attribute_id=>wwv_flow_imp.id(133226242255270728)
,p_display_sequence=>10
,p_display_value=>'Create and Start'
,p_return_value=>'create_and_start'
,p_is_quick_pick=>true
,p_help_text=>'Use this option to create and start a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133227177410274109)
,p_plugin_attribute_id=>wwv_flow_imp.id(133226242255270728)
,p_display_sequence=>20
,p_display_value=>'Create'
,p_return_value=>'create'
,p_is_quick_pick=>true
,p_help_text=>'Use this option to create a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133227563978274640)
,p_plugin_attribute_id=>wwv_flow_imp.id(133226242255270728)
,p_display_sequence=>30
,p_display_value=>'Start'
,p_return_value=>'start'
,p_help_text=>'Use this option to start a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133228099330276081)
,p_plugin_attribute_id=>wwv_flow_imp.id(133226242255270728)
,p_display_sequence=>40
,p_display_value=>'Delete'
,p_return_value=>'delete'
,p_help_text=>'Use this option to delete a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133228530522277122)
,p_plugin_attribute_id=>wwv_flow_imp.id(133226242255270728)
,p_display_sequence=>50
,p_display_value=>'Reset'
,p_return_value=>'reset'
,p_help_text=>'Use this option to reset a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(74488608244952937)
,p_plugin_attribute_id=>wwv_flow_imp.id(133226242255270728)
,p_display_sequence=>60
,p_display_value=>'Terminate'
,p_return_value=>'terminate'
,p_help_text=>'Use this option to terminate a Flow Instance.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133217998472254229)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Flow Instance Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_max_length=>150
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(133226242255270728)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'create,create_and_start'
,p_help_text=>'Define the new Flow Instance name to be created.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133206210679254225)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Select Flow using'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'static'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A <i>Flows for APEX</i> <b>Flow</b> is the business process diagram or business workflow diagram used to control how your business process proceeds. These are created using the Flow Modeller in the <i>Flows for APEX</i> application.  Once you have'
||' created your Flow diagram, you should specify the Flow name (diagram name) you want to use to control the flow instance to be started.</p>',
'',
'<p>Depends on the action selected, this attribute can be use to define how to retrieve the Flow (Diagram) or the Flow Instance.</p>',
'',
'<p> <b>On Versioning.</b> If you are using flow versioning, where you can have multiple versions of a diagram, note that if you specify just the diagram name, the version of the diagram which is currently in <b>released</b> status will be used. If no'
||' <b>released</b> status version exists, a <b>draft</b> status having version = ''0'' will be used. If that doesn''t exist, you will receive an error.  So in a production environment, where you want your app to run with the current <b>released</b> versio'
||'n, just specify the flow / diagram name - and let the system find the current released version for you.  If you want to test a <b>draft</b> diagram for testing, you will need to use a query to specify which flow / model to use.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133206656399254225)
,p_plugin_attribute_id=>wwv_flow_imp.id(133206210679254225)
,p_display_sequence=>10
,p_display_value=>'APEX item'
,p_return_value=>'item'
,p_help_text=>'Use this when the Flow (Diagram or Instance) is contained in APEX Item(s).'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133308792192349625)
,p_plugin_attribute_id=>wwv_flow_imp.id(133206210679254225)
,p_display_sequence=>20
,p_display_value=>'SQL Query'
,p_return_value=>'sql'
,p_help_text=>'Use this when you want to specify the Flow (Diagram or Instance) with a SQL Query.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133207687643254226)
,p_plugin_attribute_id=>wwv_flow_imp.id(133206210679254225)
,p_display_sequence=>30
,p_display_value=>'Static Text'
,p_return_value=>'static'
,p_help_text=>'Use this when you want to specify the Flow (Diagram or Instance) as text.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133208127137254226)
,p_plugin_attribute_id=>wwv_flow_imp.id(133206210679254225)
,p_display_sequence=>40
,p_display_value=>'Component Setting'
,p_return_value=>'component'
,p_help_text=>'Use this when you want to specify the Flow (Diagram or Instance) to be used as a global component setting.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133208660227254226)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'APEX item(s)'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(133206210679254225)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'item'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'APEX Item(s) containing:',
'<ul>',
'<li>the Flow Name (a dgrm_name) and optionally the Flow Version (a dgrm_version)</li> ',
'<li>the Flow Id (a dgrm_id)</li>',
'<li>the Flow Instance Id (a prcs_id)</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133209418585254226)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Static Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_max_length=>150
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(133206210679254225)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'static'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Set Flow DIagram  using Name only:',
'<pre>Holiday</pre>',
'Set Flow DIagram using Name and Version:',
'<pre>Holiday,0</pre>',
'Set Flow Diagram or Instance using Id:',
'<pre>1</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Provide ',
'<ul>',
'<li>a Flow Diagram Name and optionally Flow Diagram Version, using a Comma (,) separator</li>',
'<li>a Flow Diagram Id</li>',
'<li>a Flow Instance Id</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133308061246347662)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(133206210679254225)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'sql'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SQL query to retrieve Flow Diagram by Name:',
'<pre>',
'select dgrm_name',
'from flow_diagrams',
'where dgrm_id = 1',
'</pre>',
'SQL query to retrieve Flow Diagram by Name and Version:',
'<pre>',
'select dgrm_name, dgrm_version',
'from flow_diagrams',
'where dgrm_id = 1',
'</pre>',
'SQL query to retrieve Flow Diagram by ID:',
'<pre>',
'select dgrm_id',
'from flow_diagrams',
'where dgrm_id = 1',
'</pre>',
'SQL query to retrieve Flow Instance by ID:',
'<pre>',
'select prcs_id',
'from flow_processes',
'where prcs_id = 1',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SQL Query returning depends on the Action (and the Flow (Diagram) Selection) choosen:</br>',
'<ul>',
'<li>The flow name to use. Returned value should be a valid Flow name, i.e., should be contained in the table FLOW_DIAGRAMS in column dgrm_name.</li>',
'<li>The flow name and the flow version to use. Returned values should be a valid Flow name and version, i.e., should be contained in the table FLOW_DIAGRAMS in columns dgrm_name and dgrm_version.</li>',
'<li>The flow id to use. Returned values should be a valid Flow ID, i.e., should be contained in the table FLOW_DIAGRAMS in columns dgrm_id</li>',
'<li>The flow instance id to use. Returned values should be a valid Flow ID, i.e., should be contained in the table FLOW_PROCESSES in columns prcs_id</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133212103657254226)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Flow (Diagram) selection based on'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'name'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(133226242255270728)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'create,create_and_start'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>How are you going to specify which Flow Diagram to use to create the Flow Instance?</p>',
'',
'<p>If you are not using Flow versioning, you can specify the Flow (diagram) by its Name, its Name and Version, or by a Flow ID. If you are not using versioning, the Version will probably be "0".  ',
'',
'<p>If you are using Flow versioning, <i>Flows for APEX</i> will  run the current, <i>released</i> version of a Flow if you specify <b>Name</b> - which you would typically use in your production application.  If you want to test a specific version of '
||'the Flow that is not the current <i>released</i> Flow, you can specify the Flow using its <b>Name and Version</b>, or by using its <b>ID</b>. -- but note that the ID will change if the model is exported and imported into another system.</p>',
'',
'<p>Using Flow ID is only recommended during testing. Note that when a Flow (Diagram) is moved from one system to another, it could be allocated a different ID number, and so using the ID might not be the best solution.</p>',
'',
'<p>When a Flow (diagram) is specified by <b>Name</b> only, the rules for Flow selection are as follows:</p><ul>',
'<li>the engine will first look for a Flow with that Name and having Status of <i>released</i></li>',
'<li>if that doesn''t exist, it will look for a Flow with that Name having a Status of <i>draft</i> and a Version of <i>0</i></li>',
'<li>if that doesn''t exist, it will return an error.</li></ul>',
'',
'',
'<p>For more information on the versioning system and its rules, see the <i>Flows for APEX</i> documentation.</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133212540359254226)
,p_plugin_attribute_id=>wwv_flow_imp.id(133212103657254226)
,p_display_sequence=>10
,p_display_value=>'Name'
,p_return_value=>'name'
,p_help_text=>'Use this when you want to specify the Flow (diagram) giving just the Flow Name, letting <i>Flow for APEX</i> select the version. (see explanation for rules on which version will be used).'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133213017995254228)
,p_plugin_attribute_id=>wwv_flow_imp.id(133212103657254226)
,p_display_sequence=>20
,p_display_value=>'Name & Version'
,p_return_value=>'name_and_version'
,p_help_text=>'Use this when you want to specify a Flow (diagram) using the Flow Name and a specific Version of the Flow. (see explanation)'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133213538482254228)
,p_plugin_attribute_id=>wwv_flow_imp.id(133212103657254226)
,p_display_sequence=>30
,p_display_value=>'ID [deprecated]'
,p_return_value=>'id'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This option is deprecated starting from Flows for APEX 22.2 and will probably be removed in a future release.',
'Use this to specify the Flow (Diagram) to be used by giving a Flow (diagram) ID.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133214895242254228)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Set Business Reference'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(133226242255270728)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'create,create_and_start'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Most Flow Instances will need a Process Variable that contains a reference to its related business object.  This enables your Flow to find its associated object.</p>',
'<p>By convention, we suggest that all Flows use a process variable named ''BUSINESS_REF'' to store a reference to the associated business object in the database.  Several database views and application pages assume that this process variable exists and'
||' is set once the process knows which business object it relates to.</p>',
'<ul>',
'<li>If you know the related business object at this point in your flow, you can have the plugin set it from the contents of an APEX item before the Flow Instance is started.</li>',
'<li>If you don''t know the business object reference at this point, you can set it later in your process.  For example, if a later task creates the business object and the database returns its reference, you should then copy this into the BUSINESS_REF'
||' process variable once you do know it.  This can be done by calling flow_process_vars.set_var.</li>',
'</ul>',
'<p>',
'<p>Select an APEX Page Item containing the business reference key that you want used to set the process variable PROCESS_REF.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133215689789254228)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Return Instance ID into'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Select an APEX Page Item to return the Flow Instance ID (process_id).'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133210262225254226)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Set Process Variables?'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'no'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(133226242255270728)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'create,create_and_start,start'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p> The <i>Flows for APEX</i> system provides a <i>Process Variable</i> system to store process state for the duration of the Flow Instance.  A Flow Instance can often run over days or weeks, and might involve different users performing their tasks a'
||'s part of the flow -- and so the life of a Flow Instance can often be longer than the duration of an APEX session.  The <i>Flows for APEX</i> documentation provides more information on the process variable system. Process Variables can be set by the '
||'application, by scriptTasks, and as part of the process definition.</p>',
'<p> Some Page Variables should be set when a new Flow Instance is created, as part of Flow initiation.  These variables, their types, and values can be set up declaratively in the Process Plugin.</p>',
'',
'<p> To set any <i>Flows for APEX</i> process variables as part of the Flow initialization, set this switch to ''Using JSON'' or ''Using SQL Query'', depending upon how you want to specify the process variables and their content. </p>',
'<p> Process Variables set from this process plugin are set after the new Flow has been <b>created</b>, but before it is <b>started</b>. </p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133210606314254226)
,p_plugin_attribute_id=>wwv_flow_imp.id(133210262225254226)
,p_display_sequence=>10
,p_display_value=>'No Process Variables'
,p_return_value=>'no'
,p_help_text=>'Use this option to indicate that no other process variables should to be set.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133211172579254226)
,p_plugin_attribute_id=>wwv_flow_imp.id(133210262225254226)
,p_display_sequence=>20
,p_display_value=>'Using JSON'
,p_return_value=>'json'
,p_help_text=>'Use this option to use a JSON array to specify your Process Variable(s), their types and initial values.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(133211630862254226)
,p_plugin_attribute_id=>wwv_flow_imp.id(133210262225254226)
,p_display_sequence=>30
,p_display_value=>'SQL Query'
,p_return_value=>'sql'
,p_help_text=>'Use this option to specify a SQL statement to return your process variable names, types, and initial values.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133214081038254228)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'JSON'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(133210262225254226)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'json'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'	{',
'		"name": "Example_vc2_var",',
'		"type": "varchar2",',
'		"value": "text"',
'	},',
'	{',
'		"name": "Example_num_var",',
'		"type": "number",',
'		"value": 200',
'	},',
'	{',
'		"name": "Example_date_var",',
'		"type": "date",',
'		"value": "2021-04-07T22:07:29.961Z"',
'	},',
'	{',
'		"name": "Example_clob_var",',
'		"type": "clob",',
'		"value": "long text"',
'	}',
']',
'</pre>'))
,p_help_text=>'Enter a JSON array that contains one or more process variables, their types, and values.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(133214488780254228)
,p_plugin_id=>wwv_flow_imp.id(133205785223254214)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'SQL Query'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(133210262225254226)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'sql'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select json_array(',
'    json_object(',
'          key ''name'' value ''example_vc2_var''',
'        , key ''type'' value ''varchar2''',
'        , key ''value'' value ''test_vc2''',
'        ),',
'    json_object(',
'          key ''name'' value ''example_num_var''',
'        , key ''type'' value ''number''',
'        , key ''value'' value 200',
'        ),',
'    json_object(',
'          key ''name'' value ''example_date_var''',
'        , key ''type'' value ''date''',
'        , key ''value'' value ''2021-04-07T22:07:29.961Z''',
'        ),',
'    json_object(',
'          key ''name'' value ''examnple_clob_var''',
'        , key ''type'' value ''clob''',
'        , key ''value'' value to_clob(''this is a clob'')',
'        )',
'returning clob)',
'from dual;',
'</pre>'))
,p_help_text=>'SQL query that returns the array containing the instance variables.'
);
end;
/
prompt --application/shared_components/plugins/process_type/com_flows4apex_return_to_flows_process
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(12326872936648292742)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'COM.FLOWS4APEX.RETURN.TO.FLOWS.PROCESS'
,p_display_name=>'Flows for APEX - Return to Flows for APEX'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_TASKDEF_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','COM.FLOWS4APEX.RETURN.TO.FLOWS.PROCESS'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function execution',
'  ( p_process in apex_plugin.t_process',
'  , p_plugin  in apex_plugin.t_plugin ',
'  )',
'return apex_plugin.t_process_exec_result',
'as',
'    l_result     apex_plugin.t_process_exec_result;',
'',
'    --attributes',
'    l_attribute1 p_process.attribute_01%type := p_process.attribute_01;',
'',
'begin',
'',
'    --debug',
'    if apex_application.g_debug ',
'    then',
'        apex_plugin_util.debug_process',
'          ( p_plugin         => p_plugin',
'          , p_process        => p_process',
'          );',
'    end if;',
'',
'    flow_api_pkg.return_approval_result ( p_process_id   => apex_util.get_session_state(l_attribute1),',
'                                          p_apex_task_id => apex_util.get_session_state(''APEX$TASK_ID''),',
'                                          p_result       => apex_util.get_session_state(''APEX$TASK_OUTCOME''));',
'',
'    return l_result;',
'end execution;    '))
,p_api_version=>2
,p_execution_function=>'execution'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
,p_about_url=>'https://github.com/flowsforapex/apex-flowsforapex'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(12326873136039292744)
,p_plugin_id=>wwv_flow_imp.id(12326872936648292742)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Parameter Name containing Process ID'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'PROCESS_ID'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/com_flows4apex_viewer_region
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(52333599725331007516)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.FLOWS4APEX.VIEWER.REGION'
,p_display_name=>'Flows for APEX - Viewer'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.FLOWS4APEX.VIEWER.REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#PLUGIN_FILES#js/flows4apex.apex.viewer.js',
'#PLUGIN_FILES#js/flows4apex.viewer.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#PLUGIN_FILES#css/diagram-js.css',
'#PLUGIN_FILES#css/bpmn-js.css',
'#PLUGIN_FILES#css/bpmn-embedded.css',
'#PLUGIN_FILES#css/flows4apex.viewer.css'))
,p_api_version=>1
,p_render_function=>'flow_viewer.render'
,p_ajax_function=>'flow_viewer.ajax'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ORDER_BY:NO_DATA_FOUND_MESSAGE:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'24.1'
,p_about_url=>'https://github.com/flowsforapex/apex-flowsforapex'
,p_files_version=>923
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49050613765829546004)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Diagram XML'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'CLOB'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column containing the diagram XML.<br />',
'You can choose from any CLOB column of the region source.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49050612585799540186)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Current Nodes'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'ALL_CURRENT'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(48881417529742070863)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column holding ID(s) of the current node(s).<br />',
'For multiple values verify to use colons as delimiters.<br/>',
'Leave empty if you don''t want to highlight current nodes.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48934488602906946239)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>70
,p_prompt=>'Diagram Identifier'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'PRDG_ID'
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_help_text=>'Choose the column containing the diagram identifier of the currently displayed diagram (normally the prdg_id for running instances and the dgrm_id for displaying plain models).'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49056814774776544223)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Completed Nodes'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'ALL_COMPLETED'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(48881417529742070863)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column holding ID(s) of the completed node(s).<br/>',
'For multiple values verify to use colons as delimiters.<br/>',
'Leave empty if you don''t want to highlight completed nodes.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48934490011679947996)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>'Calling Diagram Identifier'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'PRDG_PRDG_ID'
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(113186152547775168)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column containing the diagram identifier of the parent diagram.<br/>',
'In the context of call activities this is the diagram that contains the activity which called the currently displayed diagram (normally the prdg_prdg_id for running instances and the calling_dgrm for displaying plain models).'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49056813515246535255)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Error Nodes'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'ALL_ERRORS'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(48881417529742070863)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column holding ID(s) of the error node(s).<br/>',
'For multiple values verify to use colons as delimiters.<br/>',
'Leave empty if you don''t want to highlight error nodes.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48934491556394949362)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>'Calling Object ID'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'CALLING_OBJT'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(113186152547775168)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column containing the object id of the parent diagram''s call activity.<br/>',
'In the context of call activities this is the call activity which called the current displayed diagram (normally the prdg_prdg_id for running instances or the calling dgrm_id).'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48895315683512067658)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>'Refresh On Load'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Leaving this at "Yes" will make the plugin try to refresh itself on page load.<br />',
'This typically makes sense if your query will immediately return a row.<br />',
'If your query doesn''t return a row on page load you should set this to "No".<br />',
'Then use a dynamic action to listen on your driving page item(s) and trigger a refresh on the plugin region.<br />',
'Remember to add your driving page items to "Page Items to Submit" for this to work properly.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48881417529742070863)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>20
,p_prompt=>'Add Highlighting'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose if you want the plugin to highlight certain nodes based on the current state of process.<br />',
'You can map the region source columns in the other attributes.<br />',
'The highlighting colors will always take precedence over the bpmn colors defined in the diagram.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(48881334760154051560)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>'Show Toolbar'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enable this to show a toolbar in the viewer to control the zoom level and be able to download a svg file from the currently shown model.<br/>',
'Can be further configured by using the JavaScript Initialization Code in the region attributes.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49812961409573762528)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>'Breadcrumb Text'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'BREADCRUMB'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(113186152547775168)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column containing the breadcrumb text when navigating through multiple diagrams using call activities.<br/>',
'You can click on the breadcrumb entries in the viewer to move up to the parent diagrams of the curently displayed diagram.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(49813767998093775054)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>'Allow Drilldown On Diagram Level'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_default_value=>'DRILLDOWN_ALLOWED'
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(113186152547775168)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose if you want to allow users to drill down into the underlying diagram on a specific call activity.<br/>',
'The value can be set separately for each diagram level and thus each call activity.<br/>',
'This option can be used to fulfill security requirements when you want to hide implementation details of single subprocesses.<br/>',
'Allowed column values:<br/>',
'<ul>',
'<li><b>0</b> - Drilldown is prohibited. The call activity will work as a normal task and users can not display the called diagram.</li>',
'<li><b>1</b> - Drilldown is allowed. Users can click the plus icon on the call activity to display the called diagram.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(113186152547775168)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>60
,p_prompt=>'Enable Call Activities'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose if you want the plugin to support call activities.<br/>',
'This option has to be enabled, if you use call cativities in any of your models to ensure displaying the correct diagram.',
'Be sure to setup the other attributes for building up the correct diagram call structure.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(12707352885271121)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Enable Mousewheel Zoom'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enable this to control the zoom level with the mousewheel.<br/>',
'Makes most sense if you''re putting the viewer full screen on a separate page, otherwise this might interfere with normal web page navigation.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(45163159413553070)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>15
,p_prompt=>'Use BPMN Colors'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose if you want the plugin to show the colors defined in the diagram using the bpmn color standard.<br />',
'If you additionally enable the following option <strong>Add Highlighting</strong>, this will take precedence over the bpmn colors.<br />',
'As this can lead to unexpected results, we strongly recommend to only use one option at once.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(45756716662425451)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>55
,p_prompt=>'Iteration Data'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'CLOB'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column holding the data of iterating elements in the diagram.<br/>',
'If existing, according elements will show an option to open the list of instances and select the highlighted instance.<br/>',
'Leave empty if you don''t want to show iteration data in the viewer.<br/>',
'<br/>',
'See view <em>FLOW_INSTANCE_DETAILS_VW</em> on how to build up the JSON structure of the iteration data.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(14515512401786684)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>'User Task URLs'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'CLOB'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the column holding the URLs generated for APEX Page or APEX Simple Form User Tasks.<br/>',
'If existing, users that are eligible to work on a task can directly click on the icon next to the User Tasks to open the referenced page.<br/>',
'Leave empty if you don''t want to link User Tasks directly in the viewer.<br/>',
'<br/>',
'See view <em>FLOW_INSTANCE_DETAILS_VW</em> on how to build up the JSON structure of the URLs.'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(48868159338882654444)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p></p>',
'<pre>',
'function( config ) {',
'    config.currentStyle = {',
'        ''fill'': ''green'',',
'        ''border'': ''black'',',
'        ''label'': ''black''',
'    }',
'    config.completedStyle = {',
'        ''fill'': ''grey'',',
'        ''border'': ''black'',',
'        ''label'': ''black''',
'    }',
'    config.errorStyle = {',
'        ''fill'': ''red'',',
'        ''border'': ''black'',',
'        ''label'': ''white''',
'    };',
'    config.allowDownload = false;',
'    return config;',
'}',
'</pre>',
'<p></p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a JavaScript function that takes a configuration object for the Flow Viewer, modifies the object, and returns it.<br/>',
'This allows advanced customization of the Flow Viewer including:<br/>',
'<ul>',
'<li>Change highlighting options for elements depending on the process status</li>',
'<li>Disable button for downloading model as svg in the viewer toolbar</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(49051114428838469130)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48886408836343029141)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_name=>'mtbv_diagram_loaded'
,p_display_name=>'Diagram Loaded'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48884535414524366769)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_name=>'mtbv_element_click'
,p_display_name=>'Click on Element'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48884535839106366769)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_name=>'mtbv_element_dblclick'
,p_display_name=>'Doubleclick on Element'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48884534676103366754)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_name=>'mtbv_element_hover'
,p_display_name=>'Hover on Element'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48884536250259366770)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_name=>'mtbv_element_mousedown'
,p_display_name=>'Mousedown on Element'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48884536634783366770)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_name=>'mtbv_element_mouseup'
,p_display_name=>'Mouseup on Element'
);
wwv_flow_imp_shared.create_plugin_event(
 p_id=>wwv_flow_imp.id(48884535025328366769)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_name=>'mtbv_element_out'
,p_display_name=>'Leave Element'
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2166756E6374696F6E28652C742C692C73297B652E7769646765742822666C6F777334617065782E766965776572222C7B6F7074696F6E733A7B616A61784964656E7469666965723A6E756C6C2C6974656D73546F5375626D69743A6E756C6C2C6E6F44';
wwv_flow_imp.g_varchar2_table(2) := '617461466F756E644D6573736167653A22436F756C64206E6F74206C6F6164204469616772616D222C726566726573684F6E4C6F61643A21312C73686F77546F6F6C6261723A21312C656E61626C654D6F757365776865656C5A6F6F6D3A21312C616464';
wwv_flow_imp.g_varchar2_table(3) := '486967686C69676874696E673A21312C75736542504D4E636F6C6F72733A21312C656E61626C6543616C6C416374697669746965733A21312C636F6E6669673A7B63757272656E745374796C653A7B66696C6C3A2223366161643432222C626F72646572';
wwv_flow_imp.g_varchar2_table(4) := '3A22626C61636B222C6C6162656C3A22626C61636B227D2C636F6D706C657465645374796C653A7B66696C6C3A2223386339656230222C626F726465723A22626C61636B222C6C6162656C3A22626C61636B227D2C6572726F725374796C653A7B66696C';
wwv_flow_imp.g_varchar2_table(5) := '6C3A2223643234323362222C626F726465723A22626C61636B222C6C6162656C3A227768697465227D2C616C6C6F77446F776E6C6F61643A21307D7D2C5F6372656174653A66756E6374696F6E28297B746869732E5F64656661756C74586D6C3D223C3F';
wwv_flow_imp.g_varchar2_table(6) := '786D6C2076657273696F6E3D27312E302720656E636F64696E673D275554462D38273F3E3C62706D6E3A646566696E6974696F6E7320786D6C6E733A7873693D27687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D612D696E';
wwv_flow_imp.g_varchar2_table(7) := '7374616E63652720786D6C6E733A62706D6E3D27687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F4D4F44454C2720786D6C6E733A62706D6E64693D27687474703A2F2F7777772E6F6D672E6F72672F7370';
wwv_flow_imp.g_varchar2_table(8) := '65632F42504D4E2F32303130303532342F4449272069643D27446566696E6974696F6E735F31777A6234373527207461726765744E616D6573706163653D27687474703A2F2F62706D6E2E696F2F736368656D612F62706D6E27206578706F727465723D';
wwv_flow_imp.g_varchar2_table(9) := '2762706D6E2D6A73202868747470733A2F2F64656D6F2E62706D6E2E696F2927206578706F7274657256657273696F6E3D27372E322E30273E3C62706D6E3A70726F636573732069643D2750726F636573735F30727865726D6827206973457865637574';
wwv_flow_imp.g_varchar2_table(10) := '61626C653D2766616C736527202F3E3C62706D6E64693A42504D4E4469616772616D2069643D2742504D4E4469616772616D5F31273E3C62706D6E64693A42504D4E506C616E652069643D2742504D4E506C616E655F31272062706D6E456C656D656E74';
wwv_flow_imp.g_varchar2_table(11) := '3D2750726F636573735F30727865726D6827202F3E3C2F62706D6E64693A42504D4E4469616772616D3E3C2F62706D6E3A646566696E6974696F6E733E222C746869732E726567696F6E49643D746869732E656C656D656E745B305D2E69642C74686973';
wwv_flow_imp.g_varchar2_table(12) := '2E766965776572577261703D746869732E726567696F6E49642B225F766965776572222C746869732E63616E76617349643D746869732E726567696F6E49642B225F63616E766173222C746869732E656E61626C65644D6F64756C65733D5B62706D6E56';
wwv_flow_imp.g_varchar2_table(13) := '69657765722E637573746F6D4D6F64756C65732E6472696C6C646F776E43656E746572696E672C62706D6E5669657765722E637573746F6D4D6F64756C65732E6D756C7469496E7374616E63654D6F64756C652C62706D6E5669657765722E637573746F';
wwv_flow_imp.g_varchar2_table(14) := '6D4D6F64756C65732E757365725461736B4D6F64756C655D2C28746869732E6F7074696F6E732E616464486967686C69676874696E677C7C746869732E6F7074696F6E732E75736542504D4E636F6C6F7273292626746869732E656E61626C65644D6F64';
wwv_flow_imp.g_varchar2_table(15) := '756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E7374796C654D6F64756C65292C746869732E6F7074696F6E732E656E61626C6543616C6C416374697669746965732626746869732E656E61626C65644D6F64756C';
wwv_flow_imp.g_varchar2_table(16) := '65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E63616C6C41637469766974794D6F64756C65292C746869732E62706D6E52656E64657265723D7B64656661756C7446696C6C436F6C6F723A22766172282D2D64656661';
wwv_flow_imp.g_varchar2_table(17) := '756C742D66696C6C2D636F6C6F7229222C64656661756C745374726F6B65436F6C6F723A22766172282D2D64656661756C742D7374726F6B652D636F6C6F7229222C64656661756C744C6162656C436F6C6F723A22766172282D2D64656661756C742D73';
wwv_flow_imp.g_varchar2_table(18) := '74726F6B652D636F6C6F7229227D2C746869732E6F7074696F6E732E73686F77546F6F6C6261722626746869732E656E61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E637573746F6D50616C';
wwv_flow_imp.g_varchar2_table(19) := '6574746550726F76696465724D6F64756C65292C746869732E6F7074696F6E732E656E61626C654D6F757365776865656C5A6F6F6D2626746869732E656E61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64';
wwv_flow_imp.g_varchar2_table(20) := '756C65732E5A6F6F6D5363726F6C6C4D6F64756C65292C28746869732E6F7074696F6E732E73686F77546F6F6C6261727C7C746869732E6F7074696F6E732E656E61626C654D6F757365776865656C5A6F6F6D292626746869732E656E61626C65644D6F';
wwv_flow_imp.g_varchar2_table(21) := '64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E4D6F766543616E7661734D6F64756C65292C746869732E62706D6E566965776572243D6E65772062706D6E5669657765722E566965776572287B636F6E746169';
wwv_flow_imp.g_varchar2_table(22) := '6E65723A2223222B746869732E63616E76617349642C6164646974696F6E616C4D6F64756C65733A746869732E656E61626C65644D6F64756C65732C62706D6E52656E64657265723A746869732E62706D6E52656E64657265722C636F6E6669673A7468';
wwv_flow_imp.g_varchar2_table(23) := '69732E6F7074696F6E732E636F6E6669677D292C6528646F63756D656E74292E6F6E2822617065786265666F7265706167657375626D6974222C2828652C74293D3E7B747C7C28617065782E6576656E742E6743616E63656C466C61673D2130297D2929';
wwv_flow_imp.g_varchar2_table(24) := '2C746869732E6F7074696F6E732E726566726573684F6E4C6F61642626746869732E7265667265736828292C746869732E5F72656769737465724576656E747328292C742E63726561746528746869732E726567696F6E49642C7B7769646765743A2829';
wwv_flow_imp.g_varchar2_table(25) := '3D3E746869732E656C656D656E742C726566726573683A28293D3E7B746869732E7265667265736828297D2C72657365743A28293D3E7B746869732E726573657428297D2C6C6F61644469616772616D3A28293D3E7B746869732E6C6F61644469616772';
wwv_flow_imp.g_varchar2_table(26) := '616D28297D2C6765745356473A28293D3E746869732E67657453564728292C676574566965776572496E7374616E63653A28293D3E746869732E62706D6E566965776572242C6765744576656E744275733A28293D3E746869732E62706D6E5669657765';
wwv_flow_imp.g_varchar2_table(27) := '72242E67657428226576656E7442757322292C7769646765744E616D653A2262706D6E766965776572222C747970653A22666C6F777334617065782E766965776572227D297D2C6C6F61644469616772616D3A6173796E632066756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(28) := '65282223222B746869732E63616E7661734964292E73686F7728292C65282223222B746869732E726567696F6E49642B22207370616E2E6E6F64617461666F756E6422292E6869646528293B636F6E737420743D746869732E62706D6E56696577657224';
wwv_flow_imp.g_varchar2_table(29) := '3B7472797B636F6E737420653D617761697420742E696D706F7274584D4C28746869732E6469616772616D7C7C746869732E5F64656661756C74586D6C292C7B7761726E696E67733A737D3D653B732E6C656E6774683E302626617065782E6465627567';
wwv_flow_imp.g_varchar2_table(30) := '2E7761726E28225761726E696E677320647572696E6720584D4C20496D706F7274222C73292C746869732E7A6F6F6D28226669742D76696577706F727422293B636F6E737420613D742E67657428226576656E7442757322292C6F3D742E67657428226D';
wwv_flow_imp.g_varchar2_table(31) := '756C7469496E7374616E63654D6F64756C6522293B746869732E757064617465436F6C6F727328746869732E63757272656E742C746869732E636F6D706C657465642C746869732E6572726F72292C612E6F6E2822726F6F742E736574222C28653D3E7B';
wwv_flow_imp.g_varchar2_table(32) := '636F6E73747B656C656D656E743A747D3D653B6F2E69734D756C7469496E7374616E636553756250726F636573732874297C7C746869732E757064617465436F6C6F727328746869732E63757272656E742C746869732E636F6D706C657465642C746869';
wwv_flow_imp.g_varchar2_table(33) := '732E6572726F72297D29292C746869732E697465726174696F6E446174612626746869732E62706D6E566965776572242E67657428226D756C7469496E7374616E63654D6F64756C6522292E6164644F7665726C61797328292C746869732E7573657254';
wwv_flow_imp.g_varchar2_table(34) := '61736B446174612626746869732E62706D6E566965776572242E6765742822757365725461736B4D6F64756C6522292E6164644F7665726C61797328292C692E74726967676572282223222B746869732E726567696F6E49642C226D7462765F64696167';
wwv_flow_imp.g_varchar2_table(35) := '72616D5F6C6F61646564222C7B6469616772616D4964656E7469666965723A746869732E6469616772616D4964656E7469666965722C63616C6C696E674469616772616D4964656E7469666965723A746869732E63616C6C696E674469616772616D4964';
wwv_flow_imp.g_varchar2_table(36) := '656E7469666965722C63616C6C696E674F626A65637449643A746869732E63616C6C696E674F626A65637449647D297D63617463682865297B617065782E64656275672E6572726F7228224C6F6164696E67204469616772616D206661696C65642E222C';
wwv_flow_imp.g_varchar2_table(37) := '652C746869732E6469616772616D297D7D2C757064617465436F6C6F72733A66756E6374696F6E28652C742C69297B696628746869732E6F7074696F6E732E616464486967686C69676874696E677C7C746869732E6F7074696F6E732E75736542504D4E';
wwv_flow_imp.g_varchar2_table(38) := '636F6C6F7273297B636F6E737420733D746869732E62706D6E566965776572242E67657428227374796C654D6F64756C6522293B746869732E7265736574436F6C6F727328292C746869732E6F7074696F6E732E616464486967686C69676874696E6726';
wwv_flow_imp.g_varchar2_table(39) := '26732E686967686C69676874456C656D656E747328652C742C69297D7D2C7265736574436F6C6F72733A66756E6374696F6E28297B696628746869732E6F7074696F6E732E616464486967686C69676874696E677C7C746869732E6F7074696F6E732E75';
wwv_flow_imp.g_varchar2_table(40) := '736542504D4E636F6C6F7273297B636F6E737420653D746869732E62706D6E566965776572242E67657428227374796C654D6F64756C6522293B746869732E6F7074696F6E732E75736542504D4E636F6C6F72737C7C652E726573657442504D4E636F6C';
wwv_flow_imp.g_varchar2_table(41) := '6F727328292C652E7265736574486967686C69676874696E6728297D7D2C7A6F6F6D3A66756E6374696F6E2865297B746869732E62706D6E566965776572242E676574282263616E76617322292E7A6F6F6D28652C226175746F22297D2C676574535647';
wwv_flow_imp.g_varchar2_table(42) := '3A6173796E632066756E6374696F6E28297B7472797B636F6E737420653D617761697420746869732E62706D6E566965776572242E73617665535647287B666F726D61743A21307D292C7B7376673A747D3D653B72657475726E20746869732E6F707469';
wwv_flow_imp.g_varchar2_table(43) := '6F6E732E616464486967686C69676874696E673F746869732E62706D6E566965776572242E67657428227374796C654D6F64756C6522292E6164645374796C65546F5356472874293A747D63617463682865297B7468726F7720617065782E6465627567';
wwv_flow_imp.g_varchar2_table(44) := '2E6572726F72282247657420535647206661696C65642E222C65292C657D7D2C726566726573683A66756E6374696F6E28297B617065782E64656275672E696E666F2822456E7465722052656672657368222C746869732E6F7074696F6E73292C617065';
wwv_flow_imp.g_varchar2_table(45) := '782E7365727665722E706C7567696E28746869732E6F7074696F6E732E616A61784964656E7469666965722C7B706167654974656D733A6528746869732E6F7074696F6E732E6974656D73546F5375626D69742C617065782E6750616765436F6E746578';
wwv_flow_imp.g_varchar2_table(46) := '7424297D2C7B726566726573684F626A6563743A2223222B746869732E63616E76617349642C6C6F6164696E67496E64696361746F723A2223222B746869732E63616E76617349647D292E7468656E2828743D3E7B696628742E666F756E64297B766172';
wwv_flow_imp.g_varchar2_table(47) := '20692C613D21303B746869732E62706D6E566965776572242E67657428226D756C7469496E7374616E63654D6F64756C6522292E7365745769646765742874686973292C746869732E62706D6E566965776572242E6765742822757365725461736B4D6F';
wwv_flow_imp.g_varchar2_table(48) := '64756C6522292E7365745769646765742874686973292C746869732E6F7074696F6E732E656E61626C6543616C6C416374697669746965733F28746869732E62706D6E566965776572242E676574282263616C6C41637469766974794D6F64756C652229';
wwv_flow_imp.g_varchar2_table(49) := '2E7365745769646765742874686973292C28693D742E646174612E66696E642828653D3E652E6469616772616D4964656E7469666965723D3D3D746869732E6469616772616D4964656E7469666965722929297C7C28613D21312C693D742E646174612E';
wwv_flow_imp.g_varchar2_table(50) := '66696E642828653D3E766F696420303D3D3D652E63616C6C696E674469616772616D4964656E7469666965722929292C746869732E646174613D742E646174612C746869732E6469616772616D4964656E7469666965723D692E6469616772616D496465';
wwv_flow_imp.g_varchar2_table(51) := '6E7469666965722C746869732E63616C6C696E674469616772616D4964656E7469666965723D692E63616C6C696E674469616772616D4964656E7469666965722C746869732E63616C6C696E674F626A65637449643D692E63616C6C696E674F626A6563';
wwv_flow_imp.g_varchar2_table(52) := '7449642C617C7C28746869732E62706D6E566965776572242E676574282263616C6C41637469766974794D6F64756C6522292E726573657442726561646372756D6228292C746869732E62706D6E566965776572242E676574282263616C6C4163746976';
wwv_flow_imp.g_varchar2_table(53) := '6974794D6F64756C6522292E75706461746542726561646372756D62282929293A28693D742E646174615B305D2C746869732E6469616772616D4964656E7469666965723D692E6469616772616D4964656E746966696572292C746869732E6F7074696F';
wwv_flow_imp.g_varchar2_table(54) := '6E732E616464486967686C69676874696E67262628746869732E63757272656E743D692E63757272656E742C746869732E636F6D706C657465643D692E636F6D706C657465642C746869732E6572726F723D692E6572726F72292C746869732E64696167';
wwv_flow_imp.g_varchar2_table(55) := '72616D3D692E6469616772616D3B7472797B746869732E697465726174696F6E446174613D4A534F4E2E706172736528692E697465726174696F6E44617461297D63617463682865297B746869732E697465726174696F6E446174613D6E756C6C7D7472';
wwv_flow_imp.g_varchar2_table(56) := '797B746869732E757365725461736B446174613D4A534F4E2E706172736528692E757365725461736B44617461297D63617463682865297B746869732E757365725461736B446174613D6E756C6C7D746869732E6C6F61644469616772616D28297D656C';
wwv_flow_imp.g_varchar2_table(57) := '73652065282223222B746869732E63616E7661734964292E6869646528292C742E6D6573736167653F28617065782E6D6573736167652E636C6561724572726F727328292C732E73686F774572726F7273285B7B747970653A226572726F72222C6C6F63';
wwv_flow_imp.g_varchar2_table(58) := '6174696F6E3A5B2270616765225D2C6D6573736167653A742E6D6573736167652C756E736166653A21317D5D29293A65282223222B746869732E726567696F6E49642B22207370616E2E6E6F64617461666F756E6422292E73686F7728297D29297D2C5F';
wwv_flow_imp.g_varchar2_table(59) := '72656769737465724576656E74733A66756E6374696F6E28297B6C657420653D746869732E62706D6E566965776572242E67657428226576656E7442757322293B5B22656C656D656E742E686F766572222C22656C656D656E742E6F7574222C22656C65';
wwv_flow_imp.g_varchar2_table(60) := '6D656E742E636C69636B222C22656C656D656E742E64626C636C69636B222C22656C656D656E742E6D6F757365646F776E222C22656C656D656E742E6D6F7573657570225D2E666F72456163682828743D3E7B652E6F6E28742C28653D3E7B692E747269';
wwv_flow_imp.g_varchar2_table(61) := '67676572282223222B746869732E726567696F6E49642C226D7462765F222B742E7265706C61636528222E222C225F22292C65297D29297D29297D7D297D28617065782E6A51756572792C617065782E726567696F6E2C617065782E6576656E742C6170';
wwv_flow_imp.g_varchar2_table(62) := '65782E6D657373616765293B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(9283823718249998)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_file_name=>'js/flows4apex.apex.viewer.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A20676C6F62616C20617065782C2042706D6E4A53202A2F0D0A0D0A2866756E6374696F6E2820242C20726567696F6E2C206576656E742C206D65737361676520297B0D0A0D0A2020242E776964676574282022666C6F777334617065782E76696577';
wwv_flow_imp.g_varchar2_table(2) := '6572222C207B0D0A202020206F7074696F6E733A207B0D0A202020202020616A61784964656E7469666965723A206E756C6C2C0D0A2020202020206974656D73546F5375626D69743A206E756C6C2C0D0A2020202020206E6F44617461466F756E644D65';
wwv_flow_imp.g_varchar2_table(3) := '73736167653A2022436F756C64206E6F74206C6F6164204469616772616D222C0D0A202020202020726566726573684F6E4C6F61643A2066616C73652C0D0A20202020202073686F77546F6F6C6261723A2066616C73652C0D0A202020202020656E6162';
wwv_flow_imp.g_varchar2_table(4) := '6C654D6F757365776865656C5A6F6F6D3A2066616C73652C0D0A202020202020616464486967686C69676874696E673A2066616C73652C0D0A20202020202075736542504D4E636F6C6F72733A2066616C73652C0D0A202020202020656E61626C654361';
wwv_flow_imp.g_varchar2_table(5) := '6C6C416374697669746965733A2066616C73652C0D0A202020202020636F6E6669673A207B0D0A202020202020202063757272656E745374796C653A207B0D0A202020202020202020202266696C6C223A202223366161643432222C0D0A202020202020';
wwv_flow_imp.g_varchar2_table(6) := '2020202022626F72646572223A2022626C61636B222C0D0A20202020202020202020226C6162656C223A2022626C61636B220D0A20202020202020207D2C0D0A2020202020202020636F6D706C657465645374796C653A207B0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(7) := '202266696C6C223A202223386339656230222C0D0A2020202020202020202022626F72646572223A2022626C61636B222C0D0A20202020202020202020226C6162656C223A2022626C61636B220D0A20202020202020207D2C0D0A202020202020202065';
wwv_flow_imp.g_varchar2_table(8) := '72726F725374796C653A207B0D0A202020202020202020202266696C6C223A202223643234323362222C0D0A2020202020202020202022626F72646572223A2022626C61636B222C0D0A20202020202020202020226C6162656C223A2022776869746522';
wwv_flow_imp.g_varchar2_table(9) := '0D0A20202020202020207D2C0D0A2020202020202020616C6C6F77446F776E6C6F61643A20747275652C0D0A2020202020207D0D0A202020207D2C0D0A0D0A202020205F6372656174653A2066756E6374696F6E2829207B0D0A0D0A2020202020207468';
wwv_flow_imp.g_varchar2_table(10) := '69732E5F64656661756C74586D6C203D0D0A2020202020202020223C3F786D6C2076657273696F6E3D27312E302720656E636F64696E673D275554462D38273F3E22202B0D0A2020202020202020223C62706D6E3A646566696E6974696F6E7320786D6C';
wwv_flow_imp.g_varchar2_table(11) := '6E733A7873693D27687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D612D696E7374616E63652720786D6C6E733A62706D6E3D27687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F3230313030353234';
wwv_flow_imp.g_varchar2_table(12) := '2F4D4F44454C2720786D6C6E733A62706D6E64693D27687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F4449272069643D27446566696E6974696F6E735F31777A6234373527207461726765744E616D6573';
wwv_flow_imp.g_varchar2_table(13) := '706163653D27687474703A2F2F62706D6E2E696F2F736368656D612F62706D6E27206578706F727465723D2762706D6E2D6A73202868747470733A2F2F64656D6F2E62706D6E2E696F2927206578706F7274657256657273696F6E3D27372E322E30273E';
wwv_flow_imp.g_varchar2_table(14) := '22202B0D0A2020202020202020223C62706D6E3A70726F636573732069643D2750726F636573735F30727865726D682720697345786563757461626C653D2766616C736527202F3E22202B0D0A2020202020202020223C62706D6E64693A42504D4E4469';
wwv_flow_imp.g_varchar2_table(15) := '616772616D2069643D2742504D4E4469616772616D5F31273E22202B0D0A2020202020202020223C62706D6E64693A42504D4E506C616E652069643D2742504D4E506C616E655F31272062706D6E456C656D656E743D2750726F636573735F3072786572';
wwv_flow_imp.g_varchar2_table(16) := '6D6827202F3E22202B0D0A2020202020202020223C2F62706D6E64693A42504D4E4469616772616D3E22202B0D0A2020202020202020223C2F62706D6E3A646566696E6974696F6E733E223B0D0A202020202020746869732E726567696F6E4964202020';
wwv_flow_imp.g_varchar2_table(17) := '203D20746869732E656C656D656E745B305D2E69643B0D0A202020202020746869732E7669657765725772617020203D20746869732E726567696F6E4964202B20225F766965776572223B0D0A202020202020746869732E63616E766173496420202020';
wwv_flow_imp.g_varchar2_table(18) := '3D20746869732E726567696F6E4964202B20225F63616E766173223B0D0A202020202020746869732E656E61626C65644D6F64756C6573203D205B0D0A202020202020202062706D6E5669657765722E637573746F6D4D6F64756C65732E6472696C6C64';
wwv_flow_imp.g_varchar2_table(19) := '6F776E43656E746572696E672C0D0A202020202020202062706D6E5669657765722E637573746F6D4D6F64756C65732E6D756C7469496E7374616E63654D6F64756C652C0D0A202020202020202062706D6E5669657765722E637573746F6D4D6F64756C';
wwv_flow_imp.g_varchar2_table(20) := '65732E757365725461736B4D6F64756C650D0A2020202020205D3B0D0A0D0A2020202020202F2F20616464207374796C65206D6F64756C6520696620616464486967686C69676874696E67206F722062706D6E436F6C6F7273206F7074696F6E73206973';
wwv_flow_imp.g_varchar2_table(21) := '20656E61626C65640D0A2020202020206966202820746869732E6F7074696F6E732E616464486967686C69676874696E67207C7C20746869732E6F7074696F6E732E75736542504D4E636F6C6F72732029207B0D0A2020202020202020746869732E656E';
wwv_flow_imp.g_varchar2_table(22) := '61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E7374796C654D6F64756C65293B0D0A2020202020207D0D0A0D0A2020202020202F2F206164642063616C6C41637469766974794D6F64756C65';
wwv_flow_imp.g_varchar2_table(23) := '2069662063616C6C2061637469766974696573206F7074696F6E20697320656E61626C65640D0A2020202020206966202820746869732E6F7074696F6E732E656E61626C6543616C6C416374697669746965732029207B0D0A2020202020202020746869';
wwv_flow_imp.g_varchar2_table(24) := '732E656E61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E63616C6C41637469766974794D6F64756C65293B0D0A2020202020207D0D0A0D0A2020202020202F2F207365742064656661756C74';
wwv_flow_imp.g_varchar2_table(25) := '20636F6C6F72730D0A202020202020746869732E62706D6E52656E6465726572203D207B0D0A202020202020202064656661756C7446696C6C436F6C6F723A2022766172282D2D64656661756C742D66696C6C2D636F6C6F7229222C0D0A202020202020';
wwv_flow_imp.g_varchar2_table(26) := '202064656661756C745374726F6B65436F6C6F723A2022766172282D2D64656661756C742D7374726F6B652D636F6C6F7229222C0D0A202020202020202064656661756C744C6162656C436F6C6F723A2022766172282D2D64656661756C742D7374726F';
wwv_flow_imp.g_varchar2_table(27) := '6B652D636F6C6F7229222C0D0A2020202020207D0D0A0D0A2020202020202F2F2061646420637573746F6D2070616C657474652069662073686F77546F6F6C626172206F7074696F6E20697320656E61626C65640D0A2020202020206966202820746869';
wwv_flow_imp.g_varchar2_table(28) := '732E6F7074696F6E732E73686F77546F6F6C6261722029207B0D0A2020202020202020746869732E656E61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E637573746F6D50616C657474655072';
wwv_flow_imp.g_varchar2_table(29) := '6F76696465724D6F64756C65293B0D0A2020202020207D0D0A2020202020202F2F20616464207A6F6F6D5363726F6C6C206D6F64756C65206966206D6F75736520776865656C207A6F6F6D206F7074696F6E20697320656E61626C65640D0A2020202020';
wwv_flow_imp.g_varchar2_table(30) := '206966202820746869732E6F7074696F6E732E656E61626C654D6F757365776865656C5A6F6F6D2029207B0D0A2020202020202020746869732E656E61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C';
wwv_flow_imp.g_varchar2_table(31) := '65732E5A6F6F6D5363726F6C6C4D6F64756C65293B0D0A2020202020207D0D0A2020202020202F2F20616464206D6F76652063616E766173206D6F64756C652069662073686F77546F6F6C626172206F7074696F6E206F72206D6F75736520776865656C';
wwv_flow_imp.g_varchar2_table(32) := '207A6F6F6D206F7074696F6E20697320656E61626C65640D0A2020202020206966202820746869732E6F7074696F6E732E73686F77546F6F6C626172207C7C20746869732E6F7074696F6E732E656E61626C654D6F757365776865656C5A6F6F6D29207B';
wwv_flow_imp.g_varchar2_table(33) := '0D0A2020202020202020746869732E656E61626C65644D6F64756C65732E707573682862706D6E5669657765722E637573746F6D4D6F64756C65732E4D6F766543616E7661734D6F64756C65293B0D0A2020202020207D0D0A0D0A202020202020746869';
wwv_flow_imp.g_varchar2_table(34) := '732E62706D6E56696577657224203D206E65772062706D6E5669657765722E566965776572287B0D0A20202020202020202020636F6E7461696E65723A20222322202B20746869732E63616E76617349642C0D0A20202020202020202020616464697469';
wwv_flow_imp.g_varchar2_table(35) := '6F6E616C4D6F64756C65733A20746869732E656E61626C65644D6F64756C65732C0D0A2020202020202020202062706D6E52656E64657265723A20746869732E62706D6E52656E64657265722C0D0A20202020202020202020636F6E6669673A20746869';
wwv_flow_imp.g_varchar2_table(36) := '732E6F7074696F6E732E636F6E6669670D0A2020202020207D293B0D0A0D0A2020202020202F2F2070726576656E742070616765207375626D6974202B2072656C6F616420616674657220627574746F6E20636C69636B0D0A202020202020242820646F';
wwv_flow_imp.g_varchar2_table(37) := '63756D656E7420292E6F6E282022617065786265666F7265706167657375626D6974222C2028205F2C20726571756573742029203D3E207B0D0A20202020202020206966202821726571756573742920617065782E6576656E742E6743616E63656C466C';
wwv_flow_imp.g_varchar2_table(38) := '6167203D20747275653B0D0A2020202020207D20293B0D0A0D0A2020202020206966202820746869732E6F7074696F6E732E726566726573684F6E4C6F61642029207B0D0A2020202020202020746869732E7265667265736828293B0D0A202020202020';
wwv_flow_imp.g_varchar2_table(39) := '7D0D0A0D0A202020202020746869732E5F72656769737465724576656E747328293B0D0A2020202020200D0A202020202020726567696F6E2E63726561746528746869732E726567696F6E49642C207B0D0A20202020202020207769646765743A202829';
wwv_flow_imp.g_varchar2_table(40) := '203D3E207B2072657475726E20746869732E656C656D656E743B207D2C0D0A2020202020202020726566726573683A202829203D3E207B20746869732E7265667265736828293B207D2C0D0A202020202020202072657365743A202829203D3E207B2074';
wwv_flow_imp.g_varchar2_table(41) := '6869732E726573657428293B207D2C0D0A20202020202020206C6F61644469616772616D3A202829203D3E207B20746869732E6C6F61644469616772616D28293B207D2C0D0A20202020202020206765745356473A202829203D3E20746869732E676574';
wwv_flow_imp.g_varchar2_table(42) := '53564728292C0D0A2020202020202020676574566965776572496E7374616E63653A202829203D3E207B2072657475726E20746869732E62706D6E566965776572243B207D2C0D0A20202020202020206765744576656E744275733A202829203D3E207B';
wwv_flow_imp.g_varchar2_table(43) := '2072657475726E20746869732E62706D6E566965776572242E6765742820226576656E744275732220293B207D2C0D0A20202020202020207769646765744E616D653A202262706D6E766965776572222C0D0A2020202020202020747970653A2022666C';
wwv_flow_imp.g_varchar2_table(44) := '6F777334617065782E766965776572220D0A2020202020207D293B0D0A202020207D2C0D0A0D0A202020206C6F61644469616772616D3A206173796E632066756E6374696F6E2829207B0D0A2020202020200D0A202020202020242820222322202B2074';
wwv_flow_imp.g_varchar2_table(45) := '6869732E63616E766173496420292E73686F7728293B0D0A202020202020242820222322202B20746869732E726567696F6E4964202B2022207370616E2E6E6F64617461666F756E642220292E6869646528293B0D0A2020202020200D0A202020202020';
wwv_flow_imp.g_varchar2_table(46) := '636F6E73742062706D6E56696577657224203D20746869732E62706D6E566965776572243B0D0A2020202020200D0A202020202020747279207B0D0A2020202020202020636F6E737420726573756C74203D2061776169742062706D6E56696577657224';
wwv_flow_imp.g_varchar2_table(47) := '2E696D706F7274584D4C2820746869732E6469616772616D207C7C20746869732E5F64656661756C74586D6C20293B0D0A2020202020202020636F6E7374207B207761726E696E6773207D203D20726573756C743B0D0A20202020202020200D0A202020';
wwv_flow_imp.g_varchar2_table(48) := '202020202069662028207761726E696E67732E6C656E677468203E20302029207B0D0A20202020202020202020617065782E64656275672E7761726E2820225761726E696E677320647572696E6720584D4C20496D706F7274222C207761726E696E6773';
wwv_flow_imp.g_varchar2_table(49) := '20293B0D0A20202020202020207D0D0A20202020202020200D0A2020202020202020746869732E7A6F6F6D2820226669742D76696577706F72742220293B0D0A20202020202020200D0A20202020202020200D0A20202020202020202F2F206765742076';
wwv_flow_imp.g_varchar2_table(50) := '6965776572206D6F64756C65730D0A2020202020202020636F6E7374206576656E74427573203D2062706D6E566965776572242E67657428276576656E7442757327293B0D0A2020202020202020636F6E7374206D756C7469496E7374616E63654D6F64';
wwv_flow_imp.g_varchar2_table(51) := '756C65203D2062706D6E566965776572242E67657428276D756C7469496E7374616E63654D6F64756C6527293B0D0A0D0A20202020202020202F2F2075706461746520636F6C6F72732077697468207468652063757272656E7420686967686C69676874';
wwv_flow_imp.g_varchar2_table(52) := '696E6720696E666F0D0A2020202020202020746869732E757064617465436F6C6F727328746869732E63757272656E742C20746869732E636F6D706C657465642C20746869732E6572726F72293B0D0A202020202020202020200D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(53) := '2F2F20726F6F742E736574202D3E206472696C6C656420646F776E20696E746F206F72206D6F766564206F75742066726F6D207375622070726F636573730D0A20202020202020206576656E744275732E6F6E2827726F6F742E736574272C2028657665';
wwv_flow_imp.g_varchar2_table(54) := '6E7429203D3E207B0D0A20202020202020202020636F6E7374207B656C656D656E747D203D206576656E743B0D0A202020202020202020202F2F2069662063757272656E7420656C656D656E74206973206E6F7420697465726174696E67202D3E206974';
wwv_flow_imp.g_varchar2_table(55) := '65726174696E6720656C656D656E7473206172652068616E646C656420696E73696465206D6F64756C650D0A2020202020202020202069662028216D756C7469496E7374616E63654D6F64756C652E69734D756C7469496E7374616E636553756250726F';
wwv_flow_imp.g_varchar2_table(56) := '6365737328656C656D656E742929207B0D0A2020202020202020202020202F2F2075706461746520636F6C6F72730D0A202020202020202020202020746869732E757064617465436F6C6F727328746869732E63757272656E742C20746869732E636F6D';
wwv_flow_imp.g_varchar2_table(57) := '706C657465642C20746869732E6572726F72293B0D0A202020202020202020207D0D0A20202020202020207D293B0D0A0D0A20202020202020202F2F20616464206F7665726C61797320696620697465726174696F6E4461746120697320657869737469';
wwv_flow_imp.g_varchar2_table(58) := '6E670D0A202020202020202069662028746869732E697465726174696F6E4461746129207B0D0A20202020202020202020746869732E62706D6E566965776572242E67657428276D756C7469496E7374616E63654D6F64756C6527292E6164644F766572';
wwv_flow_imp.g_varchar2_table(59) := '6C61797328293B0D0A20202020202020207D0D0A0D0A20202020202020202F2F20616464206F7665726C61797320696620757365725461736B44617461206973206578697374696E670D0A202020202020202069662028746869732E757365725461736B';
wwv_flow_imp.g_varchar2_table(60) := '4461746129207B0D0A20202020202020202020746869732E62706D6E566965776572242E6765742827757365725461736B4D6F64756C6527292E6164644F7665726C61797328293B0D0A20202020202020207D0D0A0D0A20202020202020202F2F207472';
wwv_flow_imp.g_varchar2_table(61) := '6967676572206C6F6164206576656E740D0A20202020202020206576656E742E747269676765722820222322202B20746869732E726567696F6E49642C20226D7462765F6469616772616D5F6C6F61646564222C200D0A202020202020202020207B200D';
wwv_flow_imp.g_varchar2_table(62) := '0A2020202020202020202020206469616772616D4964656E7469666965723A20746869732E6469616772616D4964656E7469666965722C200D0A20202020202020202020202063616C6C696E674469616772616D4964656E7469666965723A2074686973';
wwv_flow_imp.g_varchar2_table(63) := '2E63616C6C696E674469616772616D4964656E7469666965722C200D0A20202020202020202020202063616C6C696E674F626A65637449643A20746869732E63616C6C696E674F626A65637449640D0A202020202020202020207D200D0A202020202020';
wwv_flow_imp.g_varchar2_table(64) := '2020293B0D0A0D0A2020202020207D206361746368202865727229207B0D0A2020202020202020617065782E64656275672E6572726F722820224C6F6164696E67204469616772616D206661696C65642E222C206572722C20746869732E646961677261';
wwv_flow_imp.g_varchar2_table(65) := '6D20293B0D0A2020202020207D0D0A202020207D2C0D0A0D0A20202020757064617465436F6C6F72733A2066756E6374696F6E2863757272656E742C20636F6D706C657465642C206572726F7229207B0D0A2020202020202F2F20696620616E7920636F';
wwv_flow_imp.g_varchar2_table(66) := '6C6F72206F7074696F6E20697320656E61626C65640D0A2020202020206966202820746869732E6F7074696F6E732E616464486967686C69676874696E67207C7C20746869732E6F7074696F6E732E75736542504D4E636F6C6F72732029207B0D0A2020';
wwv_flow_imp.g_varchar2_table(67) := '2020202020202F2F2067657420766965776572206D6F64756C650D0A2020202020202020636F6E7374207374796C654D6F64756C65203D20746869732E62706D6E566965776572242E67657428277374796C654D6F64756C6527293B0D0A202020202020';
wwv_flow_imp.g_varchar2_table(68) := '20202F2F2072657365742063757272656E7420636F6C6F72730D0A2020202020202020746869732E7265736574436F6C6F727328293B0D0A20202020202020202F2F2061646420686967686C69676874696E67206966206F7074696F6E20697320656E61';
wwv_flow_imp.g_varchar2_table(69) := '626C65640D0A20202020202020206966202820746869732E6F7074696F6E732E616464486967686C69676874696E672029207B0D0A202020202020202020207374796C654D6F64756C652E686967686C69676874456C656D656E74732863757272656E74';
wwv_flow_imp.g_varchar2_table(70) := '2C20636F6D706C657465642C206572726F72293B0D0A20202020202020207D0D0A2020202020207D0D0A202020207D2C0D0A0D0A202020207265736574436F6C6F72733A2066756E6374696F6E2829207B0D0A2020202020202F2F20696620616E792063';
wwv_flow_imp.g_varchar2_table(71) := '6F6C6F72206F7074696F6E20697320656E61626C65640D0A2020202020206966202820746869732E6F7074696F6E732E616464486967686C69676874696E67207C7C20746869732E6F7074696F6E732E75736542504D4E636F6C6F72732029207B0D0A20';
wwv_flow_imp.g_varchar2_table(72) := '202020202020202F2F2067657420766965776572206D6F64756C650D0A2020202020202020636F6E7374207374796C654D6F64756C65203D20746869732E62706D6E566965776572242E67657428277374796C654D6F64756C6527293B0D0A2020202020';
wwv_flow_imp.g_varchar2_table(73) := '2020202F2F2072657365742062706D6E20636F6C6F7273206966206F7074696F6E206973206E6F7420656E61626C65640D0A2020202020202020696620282021746869732E6F7074696F6E732E75736542504D4E636F6C6F72732029207B0D0A20202020';
wwv_flow_imp.g_varchar2_table(74) := '2020202020207374796C654D6F64756C652E726573657442504D4E636F6C6F727328293B0D0A20202020202020207D0D0A20202020202020202F2F20726573657420686967686C69676874696E670D0A20202020202020207374796C654D6F64756C652E';
wwv_flow_imp.g_varchar2_table(75) := '7265736574486967686C69676874696E6728293B0D0A2020202020207D0D0A202020207D2C0D0A0D0A202020207A6F6F6D3A2066756E6374696F6E28207A6F6F6D4F7074696F6E2029207B0D0A202020202020746869732E62706D6E566965776572242E';
wwv_flow_imp.g_varchar2_table(76) := '67657428202263616E7661732220292E7A6F6F6D28207A6F6F6D4F7074696F6E2C20276175746F2720293B0D0A202020207D2C0D0A0D0A202020206765745356473A206173796E632066756E6374696F6E2829207B0D0A0D0A202020202020747279207B';
wwv_flow_imp.g_varchar2_table(77) := '0D0A2020202020202020636F6E737420726573756C74203D20617761697420746869732E62706D6E566965776572242E73617665535647287B20666F726D61743A2074727565207D293B0D0A2020202020202020636F6E7374207B20737667207D203D20';
wwv_flow_imp.g_varchar2_table(78) := '726573756C743B0D0A20202020202020200D0A20202020202020202F2F2061646420686967686C69676874696E6720636F6C6F727320746F20696D616765206966206F7074696F6E20697320656E61626C65640D0A202020202020202069662028207468';
wwv_flow_imp.g_varchar2_table(79) := '69732E6F7074696F6E732E616464486967686C69676874696E672029207B0D0A2020202020202020202072657475726E20746869732E62706D6E566965776572242E67657428277374796C654D6F64756C6527292E6164645374796C65546F5356472873';
wwv_flow_imp.g_varchar2_table(80) := '7667293B0D0A20202020202020207D0D0A0D0A202020202020202072657475726E207376673B0D0A2020202020200D0A2020202020207D206361746368202865727229207B0D0A2020202020202020617065782E64656275672E6572726F722820224765';
wwv_flow_imp.g_varchar2_table(81) := '7420535647206661696C65642E222C2065727220293B0D0A20202020202020207468726F77206572723B0D0A2020202020207D0D0A202020207D2C0D0A0D0A20202020726566726573683A2066756E6374696F6E2829207B0D0A0D0A2020202020206170';
wwv_flow_imp.g_varchar2_table(82) := '65782E64656275672E696E666F282022456E7465722052656672657368222C20746869732E6F7074696F6E7320293B0D0A2020202020200D0A202020202020617065782E7365727665722E706C7567696E2820746869732E6F7074696F6E732E616A6178';
wwv_flow_imp.g_varchar2_table(83) := '4964656E7469666965722C207B0D0A2020202020202020706167654974656D733A20242820746869732E6F7074696F6E732E6974656D73546F5375626D69742C20617065782E6750616765436F6E746578742420290D0A2020202020207D2C207B0D0A20';
wwv_flow_imp.g_varchar2_table(84) := '20202020202020726566726573684F626A6563743A20222322202B20746869732E63616E76617349642C0D0A20202020202020206C6F6164696E67496E64696361746F723A20222322202B20746869732E63616E76617349640D0A2020202020207D290D';
wwv_flow_imp.g_varchar2_table(85) := '0A2020202020202E7468656E28207044617461203D3E207B0D0A2020202020202020696620282070446174612E666F756E642029207B0D0A0D0A20202020202020202020766172206469616772616D3B0D0A20202020202020202020766172206F6C644C';
wwv_flow_imp.g_varchar2_table(86) := '6F61646564203D20747275653B0D0A0D0A202020202020202020202F2F2073657420776964676574207265666572656E63650D0A20202020202020202020746869732E62706D6E566965776572242E67657428276D756C7469496E7374616E63654D6F64';
wwv_flow_imp.g_varchar2_table(87) := '756C6527292E7365745769646765742874686973293B0D0A20202020202020202020746869732E62706D6E566965776572242E6765742827757365725461736B4D6F64756C6527292E7365745769646765742874686973293B0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(88) := '200D0A202020202020202020202F2F2069662063616C6C2061637469766974696573206F7074696F6E20656E61626C65640D0A2020202020202020202069662028746869732E6F7074696F6E732E656E61626C6543616C6C416374697669746965732920';
wwv_flow_imp.g_varchar2_table(89) := '7B0D0A2020202020202020202020202F2F2073657420776964676574207265666572656E63650D0A202020202020202020202020746869732E62706D6E566965776572242E676574282763616C6C41637469766974794D6F64756C6527292E7365745769';
wwv_flow_imp.g_varchar2_table(90) := '646765742874686973293B0D0A2020202020202020202020202F2F206C6F6164206F6C64206469616772616D2028696620706F737369626C65290D0A2020202020202020202020206469616772616D203D2070446174612E646174612E66696E64286420';
wwv_flow_imp.g_varchar2_table(91) := '3D3E20642E6469616772616D4964656E746966696572203D3D3D20746869732E6469616772616D4964656E746966696572293B0D0A2020202020202020202020202F2F206F74686572776973653A2067657420726F6F7420656E7472790D0A2020202020';
wwv_flow_imp.g_varchar2_table(92) := '2020202020202069662028216469616772616D29207B0D0A20202020202020202020202020206F6C644C6F61646564203D2066616C73653B0D0A20202020202020202020202020206469616772616D203D2070446174612E646174612E66696E64286420';
wwv_flow_imp.g_varchar2_table(93) := '3D3E20747970656F6628642E63616C6C696E674469616772616D4964656E74696669657229203D3D3D2027756E646566696E656427293B0D0A2020202020202020202020207D200D0A2020202020202020202020202F2F20736574207265666572656E63';
wwv_flow_imp.g_varchar2_table(94) := '657320746F20686965726172636879202B2063757272656E74206469616772616D0D0A202020202020202020202020746869732E64617461203D2070446174612E646174613B0D0A202020202020202020202020746869732E6469616772616D4964656E';
wwv_flow_imp.g_varchar2_table(95) := '746966696572203D206469616772616D2E6469616772616D4964656E7469666965723B0D0A202020202020202020202020746869732E63616C6C696E674469616772616D4964656E746966696572203D206469616772616D2E63616C6C696E6744696167';
wwv_flow_imp.g_varchar2_table(96) := '72616D4964656E7469666965723B0D0A202020202020202020202020746869732E63616C6C696E674F626A6563744964203D206469616772616D2E63616C6C696E674F626A65637449643B0D0A0D0A2020202020202020202020202F2F20726573657420';
wwv_flow_imp.g_varchar2_table(97) := '26207570646174652062726561646372756D620D0A20202020202020202020202069662028216F6C644C6F6164656429207B0D0A20202020202020202020202020202020746869732E62706D6E566965776572242E676574282763616C6C416374697669';
wwv_flow_imp.g_varchar2_table(98) := '74794D6F64756C6527292E726573657442726561646372756D6228293B0D0A20202020202020202020202020202020746869732E62706D6E566965776572242E676574282763616C6C41637469766974794D6F64756C6527292E75706461746542726561';
wwv_flow_imp.g_varchar2_table(99) := '646372756D6228293B0D0A2020202020202020202020207D0D0A202020202020202020207D0D0A202020202020202020202F2F2063616C6C2061637469766974696573206E6F74206163746976617465640D0A20202020202020202020656C7365207B0D';
wwv_flow_imp.g_varchar2_table(100) := '0A2020202020202020202020202F2F2067657420666972737420286F6E6C792920656E7472790D0A2020202020202020202020206469616772616D203D2070446174612E646174615B305D3B0D0A202020202020202020202020746869732E6469616772';
wwv_flow_imp.g_varchar2_table(101) := '616D4964656E746966696572203D206469616772616D2E6469616772616D4964656E7469666965723B0D0A202020202020202020207D0D0A0D0A202020202020202020202F2F2061646420686967686C69676874696E67206966206F7074696F6E206973';
wwv_flow_imp.g_varchar2_table(102) := '20656E61626C65640D0A2020202020202020202069662028746869732E6F7074696F6E732E616464486967686C69676874696E6729207B0D0A202020202020202020202020746869732E63757272656E742020203D206469616772616D2E63757272656E';
wwv_flow_imp.g_varchar2_table(103) := '743B0D0A202020202020202020202020746869732E636F6D706C65746564203D206469616772616D2E636F6D706C657465643B0D0A202020202020202020202020746869732E6572726F7220202020203D206469616772616D2E6572726F723B0D0A2020';
wwv_flow_imp.g_varchar2_table(104) := '20202020202020207D0D0A0D0A202020202020202020202F2F20736574206469616772616D20636F6E74656E740D0A20202020202020202020746869732E6469616772616D203D206469616772616D2E6469616772616D3B0D0A0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(105) := '20202F2F20706172736520697465726174696F6E4461746120616E642061747461636820746F20696E7374616E63650D0A20202020202020202020747279207B0D0A202020202020202020202020746869732E697465726174696F6E44617461203D204A';
wwv_flow_imp.g_varchar2_table(106) := '534F4E2E7061727365286469616772616D2E697465726174696F6E44617461293B0D0A202020202020202020207D0D0A202020202020202020206361746368286529207B0D0A202020202020202020202020746869732E697465726174696F6E44617461';
wwv_flow_imp.g_varchar2_table(107) := '203D206E756C6C3B0D0A202020202020202020207D0D0A202020202020202020200D0A202020202020202020202F2F20706172736520757365725461736B4461746120616E642061747461636820746F20696E7374616E63650D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(108) := '20747279207B0D0A202020202020202020202020746869732E757365725461736B44617461203D204A534F4E2E7061727365286469616772616D2E757365725461736B44617461293B0D0A202020202020202020207D0D0A202020202020202020206361';
wwv_flow_imp.g_varchar2_table(109) := '746368286529207B0D0A202020202020202020202020746869732E757365725461736B44617461203D206E756C6C3B0D0A202020202020202020207D0D0A0D0A202020202020202020202F2F206C6F6164206469616772616D0D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(110) := '20746869732E6C6F61644469616772616D28293B0D0A20202020202020207D20656C7365207B0D0A0D0A20202020202020202020242820222322202B20746869732E63616E766173496420292E6869646528293B0D0A202020202020202020200D0A2020';
wwv_flow_imp.g_varchar2_table(111) := '20202020202020206966202870446174612E6D65737361676529207B0D0A202020202020202020202020617065782E6D6573736167652E636C6561724572726F727328293B0D0A2020202020202020202020206D6573736167652E73686F774572726F72';
wwv_flow_imp.g_varchar2_table(112) := '7328205B0D0A20202020202020202020202020207B0D0A20202020202020202020202020202020747970653A20226572726F72222C0D0A202020202020202020202020202020206C6F636174696F6E3A205B2270616765225D2C0D0A2020202020202020';
wwv_flow_imp.g_varchar2_table(113) := '20202020202020206D6573736167653A2070446174612E6D6573736167652C0D0A20202020202020202020202020202020756E736166653A2066616C73652C0D0A20202020202020202020202020207D2C0D0A2020202020202020202020205D20293B0D';
wwv_flow_imp.g_varchar2_table(114) := '0A202020202020202020207D0D0A20202020202020202020656C7365207B0D0A202020202020202020202020242820222322202B20746869732E726567696F6E4964202B2022207370616E2E6E6F64617461666F756E642220292E73686F7728293B0D0A';
wwv_flow_imp.g_varchar2_table(115) := '202020202020202020207D0D0A20202020202020207D0D0A2020202020207D293B0D0A202020207D2C0D0A0D0A202020205F72656769737465724576656E74733A2066756E6374696F6E2829207B0D0A202020202020636F6E7374206361707475726564';
wwv_flow_imp.g_varchar2_table(116) := '4576656E7473203D205B0D0A202020202020202022656C656D656E742E686F766572222C0D0A202020202020202022656C656D656E742E6F7574222C0D0A202020202020202022656C656D656E742E636C69636B222C0D0A202020202020202022656C65';
wwv_flow_imp.g_varchar2_table(117) := '6D656E742E64626C636C69636B222C0D0A202020202020202022656C656D656E742E6D6F757365646F776E222C0D0A202020202020202022656C656D656E742E6D6F7573657570220D0A2020202020205D3B0D0A0D0A2020202020206C6574206576656E';
wwv_flow_imp.g_varchar2_table(118) := '74427573203D20746869732E62706D6E566965776572242E6765742820226576656E744275732220293B0D0A20202020202063617074757265644576656E74732E666F7245616368282063757272656E744576656E74203D3E207B0D0A20202020202020';
wwv_flow_imp.g_varchar2_table(119) := '206576656E744275732E6F6E282063757272656E744576656E742C206576656E7444617461203D3E207B0D0A202020202020202020206576656E742E747269676765722820222322202B20746869732E726567696F6E49642C20226D7462765F22202B20';
wwv_flow_imp.g_varchar2_table(120) := '63757272656E744576656E742E7265706C61636528222E222C20225F22292C206576656E744461746120293B0D0A20202020202020207D293B0D0A2020202020207D293B0D0A202020207D0D0A20207D290D0A0D0A7D292820617065782E6A5175657279';
wwv_flow_imp.g_varchar2_table(121) := '2C20617065782E726567696F6E2C20617065782E6576656E742C20617065782E6D65737361676520293B0D0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(14511778254670608)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_file_name=>'js/flows4apex.apex.viewer.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7661722062706D6E5669657765723B2828293D3E7B2275736520737472696374223B76617220653D7B643A28742C6E293D3E7B666F7228766172206920696E206E29652E6F286E2C6929262621652E6F28742C692926264F626A6563742E646566696E65';
wwv_flow_imp.g_varchar2_table(2) := '50726F706572747928742C692C7B656E756D657261626C653A21302C6765743A6E5B695D7D297D2C6F3A28652C74293D3E4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28652C74297D2C743D7B7D3B282829';
wwv_flow_imp.g_varchar2_table(3) := '3D3E7B66756E6374696F6E206E28652C74297B74262628652E73757065725F3D742C652E70726F746F747970653D4F626A6563742E63726561746528742E70726F746F747970652C7B636F6E7374727563746F723A7B76616C75653A652C656E756D6572';
wwv_flow_imp.g_varchar2_table(4) := '61626C653A21312C7772697461626C653A21302C636F6E666967757261626C653A21307D7D29297D652E6428742C7B64656661756C743A28293D3E426F7D293B636F6E737420693D4F626A6563742E70726F746F747970652E746F537472696E672C723D';
wwv_flow_imp.g_varchar2_table(5) := '4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B66756E6374696F6E206F2865297B72657475726E20766F696420303D3D3D657D66756E6374696F6E20612865297B72657475726E20766F69642030213D3D657D66756E63';
wwv_flow_imp.g_varchar2_table(6) := '74696F6E20732865297B72657475726E225B6F626A6563742041727261795D223D3D3D692E63616C6C2865297D66756E6374696F6E206C2865297B72657475726E225B6F626A656374204F626A6563745D223D3D3D692E63616C6C2865297D66756E6374';
wwv_flow_imp.g_varchar2_table(7) := '696F6E20632865297B72657475726E225B6F626A656374204E756D6265725D223D3D3D692E63616C6C2865297D66756E6374696F6E20702865297B636F6E737420743D692E63616C6C2865293B72657475726E225B6F626A6563742046756E6374696F6E';
wwv_flow_imp.g_varchar2_table(8) := '5D223D3D3D747C7C225B6F626A656374204173796E6346756E6374696F6E5D223D3D3D747C7C225B6F626A6563742047656E657261746F7246756E6374696F6E5D223D3D3D747C7C225B6F626A656374204173796E6347656E657261746F7246756E6374';
wwv_flow_imp.g_varchar2_table(9) := '696F6E5D223D3D3D747C7C225B6F626A6563742050726F78795D223D3D3D747D66756E6374696F6E20752865297B72657475726E225B6F626A65637420537472696E675D223D3D3D692E63616C6C2865297D66756E6374696F6E206828652C74297B7265';
wwv_flow_imp.g_varchar2_table(10) := '7475726E20722E63616C6C28652C74297D66756E6374696F6E206428652C74297B636F6E7374206E3D782874293B6C657420693B72657475726E206628652C2866756E6374696F6E28652C74297B6966286E28652C74292972657475726E20693D652C21';
wwv_flow_imp.g_varchar2_table(11) := '317D29292C697D66756E6374696F6E206D28652C74297B636F6E7374206E3D782874293B6C657420693D5B5D3B72657475726E206628652C2866756E6374696F6E28652C74297B6E28652C74292626692E707573682865297D29292C697D66756E637469';
wwv_flow_imp.g_varchar2_table(12) := '6F6E206628652C74297B6C6574206E2C693B6966286F2865292972657475726E3B636F6E737420723D732865293F5F3A773B666F72286C6574206F20696E2065296966286828652C6F292626286E3D655B6F5D2C693D74286E2C72286F29292C21313D3D';
wwv_flow_imp.g_varchar2_table(13) := '3D69292972657475726E206E7D66756E6374696F6E207928652C742C6E297B72657475726E206628652C2866756E6374696F6E28652C69297B6E3D74286E2C652C69297D29292C6E7D66756E6374696F6E206728652C74297B72657475726E2121792865';
wwv_flow_imp.g_varchar2_table(14) := '2C2866756E6374696F6E28652C6E2C69297B72657475726E2065262674286E2C69297D292C2130297D66756E6374696F6E207628652C74297B72657475726E21216428652C74297D66756E6374696F6E20622865297B72657475726E2066756E6374696F';
wwv_flow_imp.g_varchar2_table(15) := '6E2874297B72657475726E206728652C2866756E6374696F6E28652C6E297B72657475726E20745B6E5D3D3D3D657D29297D7D66756E6374696F6E20782865297B72657475726E20702865293F653A743D3E743D3D3D657D66756E6374696F6E20772865';
wwv_flow_imp.g_varchar2_table(16) := '297B72657475726E20657D66756E6374696F6E205F2865297B72657475726E204E756D6265722865297D66756E6374696F6E204528652C74297B72657475726E20652E62696E642874297D66756E6374696F6E205328652C2E2E2E74297B72657475726E';
wwv_flow_imp.g_varchar2_table(17) := '204F626A6563742E61737369676E28652C2E2E2E74297D76617220413D3165333B66756E6374696F6E204328652C74297B766172206E3D746869733B743D747C7C412C652E6F6E285B2272656E6465722E7368617065222C2272656E6465722E636F6E6E';
wwv_flow_imp.g_varchar2_table(18) := '656374696F6E225D2C742C2866756E6374696F6E28652C74297B76617220693D652E747970652C723D742E656C656D656E742C6F3D742E6766782C613D742E61747472733B6966286E2E63616E52656E6465722872292972657475726E2272656E646572';
wwv_flow_imp.g_varchar2_table(19) := '2E7368617065223D3D3D693F6E2E647261775368617065286F2C722C61293A6E2E64726177436F6E6E656374696F6E286F2C722C61297D29292C652E6F6E285B2272656E6465722E676574536861706550617468222C2272656E6465722E676574436F6E';
wwv_flow_imp.g_varchar2_table(20) := '6E656374696F6E50617468225D2C742C2866756E6374696F6E28652C74297B6966286E2E63616E52656E6465722874292972657475726E2272656E6465722E676574536861706550617468223D3D3D652E747970653F6E2E676574536861706550617468';
wwv_flow_imp.g_varchar2_table(21) := '2874293A6E2E676574436F6E6E656374696F6E506174682874297D29297D66756E6374696F6E206B28652C74297B766172206E3D4D2865293B72657475726E206E26262266756E6374696F6E223D3D747970656F66206E2E24696E7374616E63654F6626';
wwv_flow_imp.g_varchar2_table(22) := '266E2E24696E7374616E63654F662874297D66756E6374696F6E205228652C74297B72657475726E207628742C2866756E6374696F6E2874297B72657475726E206B28652C74297D29297D66756E6374696F6E204D2865297B72657475726E2065262665';
wwv_flow_imp.g_varchar2_table(23) := '2E627573696E6573734F626A6563747C7C657D66756E6374696F6E20502865297B72657475726E20652626652E64697D66756E6374696F6E204428652C74297B72657475726E216B28652C2262706D6E3A43616C6C416374697669747922292626286B28';
wwv_flow_imp.g_varchar2_table(24) := '652C2262706D6E3A53756250726F6365737322293F21282128743D747C7C50286529297C7C216B28742C2262706D6E64693A42504D4E506C616E652229297C7C7426262121742E6973457870616E6465643A216B28652C2262706D6E3A50617274696369';
wwv_flow_imp.g_varchar2_table(25) := '70616E7422297C7C21214D2865292E70726F63657373526566297D66756E6374696F6E20422865297B6966286B28652C2262706D6E3A5061727469636970616E7422297C7C6B28652C2262706D6E3A4C616E652229297B76617220743D502865292E6973';
wwv_flow_imp.g_varchar2_table(26) := '486F72697A6F6E74616C3B72657475726E20766F696420303D3D3D747C7C747D7D432E70726F746F747970652E63616E52656E6465723D66756E6374696F6E2865297B7D2C432E70726F746F747970652E6472617753686170653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(27) := '652C74297B7D2C432E70726F746F747970652E64726177436F6E6E656374696F6E3D66756E6374696F6E28652C74297B7D2C432E70726F746F747970652E6765745368617065506174683D66756E6374696F6E2865297B7D2C432E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(28) := '2E676574436F6E6E656374696F6E506174683D66756E6374696F6E2865297B7D3B766172204F3D7B77696474683A39302C6865696768743A32307D2C543D31353B66756E6374696F6E204E28652C74297B766172206E2C692C722C6F3D652E6C6162656C';
wwv_flow_imp.g_varchar2_table(29) := '3B72657475726E206F26266F2E626F756E64733F28723D6F2E626F756E64732C693D7B77696474683A4D6174682E6D6178284F2E77696474682C722E7769647468292C6865696768743A722E6865696768747D2C6E3D7B783A722E782B722E7769647468';
wwv_flow_imp.g_varchar2_table(30) := '2F322C793A722E792B722E6865696768742F327D293A286E3D66756E6374696F6E2865297B72657475726E20652E776179706F696E74733F66756E6374696F6E2865297B76617220743D652E6C656E6774682F322D312C6E3D655B4D6174682E666C6F6F';
wwv_flow_imp.g_varchar2_table(31) := '722874295D2C693D655B4D6174682E6365696C28742B2E3031295D2C723D66756E6374696F6E2865297B76617220743D652E6C656E6774682F322D312C6E3D655B4D6174682E666C6F6F722874295D2C693D655B4D6174682E6365696C28742B2E303129';
wwv_flow_imp.g_varchar2_table(32) := '5D3B72657475726E7B783A6E2E782B28692E782D6E2E78292F322C793A6E2E792B28692E792D6E2E79292F327D7D2865292C6F3D4D6174682E6174616E2828692E792D6E2E79292F28692E782D6E2E7829292C613D722E782C733D722E793B7265747572';
wwv_flow_imp.g_varchar2_table(33) := '6E204D6174682E616273286F293C4D6174682E50492F323F732D3D543A612B3D542C7B783A612C793A737D7D28652E776179706F696E7473293A6B28652C2262706D6E3A47726F757022293F7B783A652E782B652E77696474682F322C793A652E792B4F';
wwv_flow_imp.g_varchar2_table(34) := '2E6865696768742F327D3A7B783A652E782B652E77696474682F322C793A652E792B652E6865696768742B4F2E6865696768742F327D7D2874292C693D4F292C53287B783A6E2E782D692E77696474682F322C793A6E2E792D692E6865696768742F327D';
wwv_flow_imp.g_varchar2_table(35) := '2C69297D66756E6374696F6E20492865297B76617220743D652E627573696E6573734F626A6563742C6E3D66756E6374696F6E2865297B72657475726E206B28652C2262706D6E3A466C6F77456C656D656E7422297C7C6B28652C2262706D6E3A506172';
wwv_flow_imp.g_varchar2_table(36) := '7469636970616E7422297C7C6B28652C2262706D6E3A4C616E6522297C7C6B28652C2262706D6E3A53657175656E6365466C6F7722297C7C6B28652C2262706D6E3A4D657373616765466C6F7722297C7C6B28652C2262706D6E3A44617461496E707574';
wwv_flow_imp.g_varchar2_table(37) := '22297C7C6B28652C2262706D6E3A446174614F757470757422293F226E616D65223A6B28652C2262706D6E3A54657874416E6E6F746174696F6E22293F2274657874223A6B28652C2262706D6E3A47726F757022293F2263617465676F727956616C7565';
wwv_flow_imp.g_varchar2_table(38) := '526566223A766F696420307D2874293B6966286E2972657475726E2263617465676F727956616C7565526566223D3D3D6E3F66756E6374696F6E2865297B76617220743D652E63617465676F727956616C75655265663B72657475726E20742626742E76';
wwv_flow_imp.g_varchar2_table(39) := '616C75657C7C22227D2874293A745B6E5D7C7C22227D66756E6374696F6E204C28652C74297B72657475726E20742E617070656E644368696C642866756E6374696F6E28652C74297B696628652E6F776E6572446F63756D656E74213D3D742E6F776E65';
wwv_flow_imp.g_varchar2_table(40) := '72446F63756D656E74297472797B72657475726E20742E6F776E6572446F63756D656E742E696D706F72744E6F646528652C2130297D63617463682865297B7D72657475726E20657D28652C7429297D66756E6374696F6E206A28652C74297B72657475';
wwv_flow_imp.g_varchar2_table(41) := '726E204C28742C65292C657D76617220463D322C563D7B22616C69676E6D656E742D626173656C696E65223A312C22626173656C696E652D7368696674223A312C636C69703A312C22636C69702D70617468223A312C22636C69702D72756C65223A312C';
wwv_flow_imp.g_varchar2_table(42) := '636F6C6F723A312C22636F6C6F722D696E746572706F6C6174696F6E223A312C22636F6C6F722D696E746572706F6C6174696F6E2D66696C74657273223A312C22636F6C6F722D70726F66696C65223A312C22636F6C6F722D72656E646572696E67223A';
wwv_flow_imp.g_varchar2_table(43) := '312C637572736F723A312C646972656374696F6E3A312C646973706C61793A312C22646F6D696E616E742D626173656C696E65223A312C22656E61626C652D6261636B67726F756E64223A312C66696C6C3A312C2266696C6C2D6F706163697479223A31';
wwv_flow_imp.g_varchar2_table(44) := '2C2266696C6C2D72756C65223A312C66696C7465723A312C22666C6F6F642D636F6C6F72223A312C22666C6F6F642D6F706163697479223A312C666F6E743A312C22666F6E742D66616D696C79223A312C22666F6E742D73697A65223A462C22666F6E74';
wwv_flow_imp.g_varchar2_table(45) := '2D73697A652D61646A757374223A312C22666F6E742D73747265746368223A312C22666F6E742D7374796C65223A312C22666F6E742D76617269616E74223A312C22666F6E742D776569676874223A312C22676C7970682D6F7269656E746174696F6E2D';
wwv_flow_imp.g_varchar2_table(46) := '686F72697A6F6E74616C223A312C22676C7970682D6F7269656E746174696F6E2D766572746963616C223A312C22696D6167652D72656E646572696E67223A312C6B65726E696E673A312C226C65747465722D73706163696E67223A312C226C69676874';
wwv_flow_imp.g_varchar2_table(47) := '696E672D636F6C6F72223A312C6D61726B65723A312C226D61726B65722D656E64223A312C226D61726B65722D6D6964223A312C226D61726B65722D7374617274223A312C6D61736B3A312C6F7061636974793A312C6F766572666C6F773A312C22706F';
wwv_flow_imp.g_varchar2_table(48) := '696E7465722D6576656E7473223A312C2273686170652D72656E646572696E67223A312C2273746F702D636F6C6F72223A312C2273746F702D6F706163697479223A312C7374726F6B653A312C227374726F6B652D646173686172726179223A312C2273';
wwv_flow_imp.g_varchar2_table(49) := '74726F6B652D646173686F6666736574223A312C227374726F6B652D6C696E65636170223A312C227374726F6B652D6C696E656A6F696E223A312C227374726F6B652D6D697465726C696D6974223A312C227374726F6B652D6F706163697479223A312C';
wwv_flow_imp.g_varchar2_table(50) := '227374726F6B652D7769647468223A462C22746578742D616E63686F72223A312C22746578742D6465636F726174696F6E223A312C22746578742D72656E646572696E67223A312C22756E69636F64652D62696469223A312C7669736962696C6974793A';
wwv_flow_imp.g_varchar2_table(51) := '312C22776F72642D73706163696E67223A312C2277726974696E672D6D6F6465223A317D3B66756E6374696F6E202428652C742C6E297B76617220693D742E7265706C616365282F285B612D7A5D29285B412D5A5D292F672C2224312D243222292E746F';
wwv_flow_imp.g_varchar2_table(52) := '4C6F7765724361736528292C723D565B695D3B723F28723D3D3D462626226E756D626572223D3D747970656F66206E2626286E3D537472696E67286E292B22707822292C652E7374796C655B695D3D6E293A652E7365744174747269627574654E53286E';
wwv_flow_imp.g_varchar2_table(53) := '756C6C2C742C6E297D66756E6374696F6E207A28652C742C6E297B69662822737472696E67223D3D747970656F662074297B696628766F696420303D3D3D6E2972657475726E2066756E6374696F6E28652C74297B72657475726E20565B745D3F652E73';
wwv_flow_imp.g_varchar2_table(54) := '74796C655B745D3A652E6765744174747269627574654E53286E756C6C2C74297D28652C74293B2428652C742C6E297D656C73652166756E6374696F6E28652C74297B766172206E2C692C723D4F626A6563742E6B6579732874293B666F72286E3D303B';
wwv_flow_imp.g_varchar2_table(55) := '693D725B6E5D3B6E2B2B292428652C692C745B695D297D28652C74293B72657475726E20657D636F6E737420573D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E20472865297B72657475726E206E657720482865';
wwv_flow_imp.g_varchar2_table(56) := '297D66756E6374696F6E20482865297B69662821657C7C21652E6E6F646554797065297468726F77206E6577204572726F7228224120444F4D20656C656D656E74207265666572656E636520697320726571756972656422293B746869732E656C3D652C';
wwv_flow_imp.g_varchar2_table(57) := '746869732E6C6973743D652E636C6173734C6973747D66756E6374696F6E204B2865297B666F722876617220743B743D652E66697273744368696C643B29652E72656D6F76654368696C642874293B72657475726E20657D482E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(58) := '6164643D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C482E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B72657475726E225B6F626A656374205265674578705D22';
wwv_flow_imp.g_varchar2_table(59) := '3D3D572E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C6973742E72656D6F76652865292C74686973297D2C482E70726F746F747970652E72656D6F76654D61746368696E673D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(60) := '297B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29652E7465737428745B6E5D292626746869732E72656D6F766528745B6E5D293B72657475726E20746869737D2C482E70726F';
wwv_flow_imp.g_varchar2_table(61) := '746F747970652E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D3D743F74213D3D746869732E6C6973742E746F67676C6528652C74292626746869732E6C6973742E746F67676C652865293A746869732E6C69';
wwv_flow_imp.g_varchar2_table(62) := '73742E746F67676C652865292C746869737D2C482E70726F746F747970652E61727261793D66756E6374696F6E28297B72657475726E2041727261792E66726F6D28746869732E6C697374297D2C482E70726F746F747970652E6861733D482E70726F74';
wwv_flow_imp.g_varchar2_table(63) := '6F747970652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E636F6E7461696E732865297D3B76617220553D7B7376673A22687474703A2F2F7777772E77332E6F72672F323030302F737667227D2C713D';
wwv_flow_imp.g_varchar2_table(64) := '273C73766720786D6C6E733D22272B552E7376672B2722273B66756E6374696F6E20592865297B76617220743D21313B223C737667223D3D3D652E737562737472696E6728302C34293F2D313D3D3D652E696E6465784F6628552E73766729262628653D';
wwv_flow_imp.g_varchar2_table(65) := '712B652E737562737472696E67283429293A28653D712B223E222B652B223C2F7376673E222C743D2130293B766172206E3D66756E6374696F6E2865297B76617220743B72657475726E28743D6E657720444F4D506172736572292E6173796E633D2131';
wwv_flow_imp.g_varchar2_table(66) := '2C742E706172736546726F6D537472696E6728652C22746578742F786D6C22297D2865293B69662821742972657475726E206E3B666F722876617220693D646F63756D656E742E637265617465446F63756D656E74467261676D656E7428292C723D6E2E';
wwv_flow_imp.g_varchar2_table(67) := '66697273744368696C643B722E66697273744368696C643B29692E617070656E644368696C6428722E66697273744368696C64293B72657475726E20697D66756E6374696F6E205828652C74297B766172206E3B72657475726E223C223D3D3D28653D65';
wwv_flow_imp.g_varchar2_table(68) := '2E7472696D2829292E6368617241742830293F286E3D592865292E66697273744368696C642C6E3D646F63756D656E742E696D706F72744E6F6465286E2C213029293A6E3D646F63756D656E742E637265617465456C656D656E744E5328552E7376672C';
wwv_flow_imp.g_varchar2_table(69) := '65292C7426267A286E2C74292C6E7D766172205A3D6E756C6C3B66756E6374696F6E204A28297B72657475726E206E756C6C3D3D3D5A2626285A3D5828227376672229292C5A7D66756E6374696F6E205128652C74297B766172206E2C692C723D4F626A';
wwv_flow_imp.g_varchar2_table(70) := '6563742E6B6579732874293B666F72286E3D303B693D725B6E5D3B6E2B2B29655B695D3D745B695D3B72657475726E20657D66756E6374696F6E2065652865297B72657475726E20653F4A28292E6372656174655356475472616E73666F726D46726F6D';
wwv_flow_imp.g_varchar2_table(71) := '4D61747269782865293A4A28292E6372656174655356475472616E73666F726D28297D7661722074653D2F285B263C3E5D7B317D292F672C6E653D2F285B5C6E5C72225D7B317D292F672C69653D7B2226223A2226616D703B222C223C223A22266C743B';
wwv_flow_imp.g_varchar2_table(72) := '222C223E223A222667743B222C2722273A2227227D3B66756E6374696F6E20726528652C74297B72657475726E20652E7265706C61636528742C2866756E6374696F6E28652C74297B72657475726E2069655B745D7C7C747D29297D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(73) := '206F6528652C74297B766172206E2C692C722C6F2C613B73776974636828652E6E6F646554797065297B6361736520333A742E7075736828726528652E74657874436F6E74656E742C746529293B627265616B3B6361736520313A696628742E70757368';
wwv_flow_imp.g_varchar2_table(74) := '28223C222C652E7461674E616D65292C652E68617341747472696275746573282929666F72286E3D302C693D28723D652E61747472696275746573292E6C656E6774683B6E3C693B2B2B6E296F3D722E6974656D286E292C742E70757368282220222C6F';
wwv_flow_imp.g_varchar2_table(75) := '2E6E616D652C273D22272C7265286F2E76616C75652C6E65292C272227293B696628652E6861734368696C644E6F6465732829297B666F7228742E7075736828223E22292C6E3D302C693D28613D652E6368696C644E6F646573292E6C656E6774683B6E';
wwv_flow_imp.g_varchar2_table(76) := '3C693B2B2B6E296F6528612E6974656D286E292C74293B742E7075736828223C2F222C652E7461674E616D652C223E22297D656C736520742E7075736828222F3E22293B627265616B3B6361736520383A742E7075736828225C783363212D2D222C7265';
wwv_flow_imp.g_varchar2_table(77) := '28652E6E6F646556616C75652C7465292C222D2D5C78336522293B627265616B3B6361736520343A742E7075736828223C215B43444154415B222C652E6E6F646556616C75652C225D5D3E22293B627265616B3B64656661756C743A7468726F77206E65';
wwv_flow_imp.g_varchar2_table(78) := '77204572726F722822756E61626C6520746F2068616E646C65206E6F646520222B652E6E6F646554797065297D72657475726E20747D66756E6374696F6E20616528652C74297B696628766F69642030213D3D74297B7472797B2166756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(79) := '652C74297B766172206E3D592874293B6966284B2865292C74297B2866756E6374696F6E2865297B72657475726E2223646F63756D656E742D667261676D656E74223D3D3D652E6E6F64654E616D657D29286E297C7C286E3D6E2E646F63756D656E7445';
wwv_flow_imp.g_varchar2_table(80) := '6C656D656E74293B666F722876617220692C723D28693D6E2E6368696C644E6F6465732C41727261792E70726F746F747970652E736C6963652E63616C6C286929292C6F3D303B6F3C722E6C656E6774683B6F2B2B294C28725B6F5D2C65297D7D28652C';
wwv_flow_imp.g_varchar2_table(81) := '74297D63617463682865297B7468726F77206E6577204572726F7228226572726F722070617273696E67205356473A20222B652E6D657373616765297D72657475726E20657D72657475726E2066756E6374696F6E2865297B666F722876617220743D65';
wwv_flow_imp.g_varchar2_table(82) := '2E66697273744368696C642C6E3D5B5D3B743B296F6528742C6E292C743D742E6E6578745369626C696E673B72657475726E206E2E6A6F696E282222297D2865297D66756E6374696F6E2073652865297B76617220743D652E706172656E744E6F64653B';
wwv_flow_imp.g_varchar2_table(83) := '72657475726E20742626742E72656D6F76654368696C642865292C657D66756E6374696F6E206C6528652C74297B72657475726E207420696E7374616E63656F66205356474D61747269783F652E6372656174655356475472616E73666F726D46726F6D';
wwv_flow_imp.g_varchar2_table(84) := '4D61747269782874293A747D66756E6374696F6E20636528652C74297B766172206E3D652E7472616E73666F726D2E6261736556616C3B72657475726E207426262841727261792E697341727261792874297C7C28743D5B745D292C66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(85) := '28652C74297B766172206E2C693B666F7228652E636C65617228292C6E3D303B693D745B6E5D3B6E2B2B29652E617070656E644974656D286C6528652C6929297D286E2C7429292C6E2E636F6E736F6C696461746528297D66756E6374696F6E20706528';
wwv_flow_imp.g_varchar2_table(86) := '65297B72657475726E20652E666C617428292E6A6F696E28222C22292E7265706C616365282F2C3F285B412D7A5D292C3F2F672C22243122297D66756E6374696F6E2075652865297B72657475726E5B224C222C652E782C652E795D7D66756E6374696F';
wwv_flow_imp.g_varchar2_table(87) := '6E20686528652C74297B636F6E7374206E3D652E6C656E6774682C693D5B28723D655B305D2C5B224D222C722E782C722E795D295D3B76617220722C6F2C612C733B666F72286C657420723D313B723C6E3B722B2B297B636F6E7374206E3D655B722D31';
wwv_flow_imp.g_varchar2_table(88) := '5D2C6C3D655B725D2C633D655B722B315D3B69662821637C7C2174297B692E70757368287565286C29293B636F6E74696E75657D636F6E737420703D4D6174682E6D696E28742C6D65286C2E782D6E2E782C6C2E792D6E2E79292C6D6528632E782D6C2E';
wwv_flow_imp.g_varchar2_table(89) := '782C632E792D6C2E7929293B6966282170297B692E70757368287565286C29293B636F6E74696E75657D636F6E737420753D6465286C2C6E2C70292C683D6465286C2C6E2C2E352A70292C643D6465286C2C632C70292C6D3D6465286C2C632C2E352A70';
wwv_flow_imp.g_varchar2_table(90) := '293B692E70757368287565287529292C692E707573682828613D6D2C733D642C5B2243222C286F3D68292E782C6F2E792C612E782C612E792C732E782C732E795D29297D72657475726E20697D66756E6374696F6E20646528652C742C6E297B636F6E73';
wwv_flow_imp.g_varchar2_table(91) := '7420693D742E782D652E782C723D742E792D652E792C6F3D6E2F6D6528692C72293B72657475726E7B783A652E782B692A6F2C793A652E792B722A6F7D7D66756E6374696F6E206D6528652C74297B72657475726E204D6174682E73717274284D617468';
wwv_flow_imp.g_varchar2_table(92) := '2E706F7728652C32292B4D6174682E706F7728742C3229297D66756E6374696F6E20666528652C742C6E297B632874292626286E3D742C743D6E756C6C292C747C7C28743D7B7D293B636F6E737420693D58282270617468222C74293B72657475726E20';
wwv_flow_imp.g_varchar2_table(93) := '63286E29262628692E646174617365742E636F726E65725261646975733D537472696E67286E29292C796528692C65297D66756E6374696F6E20796528652C74297B72657475726E207A28652C7B643A706528686528742C7061727365496E7428652E64';
wwv_flow_imp.g_varchar2_table(94) := '6174617365742E636F726E65725261646975732C3130297C7C3029297D292C657D7661722067653D2268736C283232352C203130252C2031352529222C76653D227768697465223B66756E6374696F6E20626528652C74297B72657475726E207628652E';
wwv_flow_imp.g_varchar2_table(95) := '6576656E74446566696E6974696F6E732C2866756E6374696F6E2865297B72657475726E20652E24747970653D3D3D747D29297D66756E6374696F6E20786528652C742C6E297B76617220693D502865293B72657475726E206E7C7C692E676574282263';
wwv_flow_imp.g_varchar2_table(96) := '6F6C6F723A6261636B67726F756E642D636F6C6F7222297C7C692E676574282262696F633A66696C6C22297C7C747C7C76657D66756E6374696F6E20776528652C742C6E297B76617220693D502865293B72657475726E206E7C7C692E6765742822636F';
wwv_flow_imp.g_varchar2_table(97) := '6C6F723A626F726465722D636F6C6F7222297C7C692E676574282262696F633A7374726F6B6522297C7C747C7C67657D66756E6374696F6E205F6528652C742C6E2C69297B76617220723D502865292E67657428226C6162656C22293B72657475726E20';
wwv_flow_imp.g_varchar2_table(98) := '697C7C722626722E6765742822636F6C6F723A636F6C6F7222297C7C747C7C776528652C6E297D66756E6374696F6E20456528652C743D7B7D297B72657475726E7B77696474683A536528652C74292C6865696768743A416528652C74297D7D66756E63';
wwv_flow_imp.g_varchar2_table(99) := '74696F6E20536528652C743D7B7D297B72657475726E206828742C22776964746822293F742E77696474683A652E77696474687D66756E6374696F6E20416528652C743D7B7D297B72657475726E206828742C2268656967687422293F742E6865696768';
wwv_flow_imp.g_varchar2_table(100) := '743A652E6865696768747D66756E6374696F6E20436528652C74297B72657475726E20742E666F7245616368282866756E6374696F6E2874297B74262622737472696E6722213D747970656F66207426262141727261792E697341727261792874292626';
wwv_flow_imp.g_varchar2_table(101) := '4F626A6563742E6B6579732874292E666F7245616368282866756E6374696F6E286E297B6966282264656661756C7422213D3D6E262621286E20696E206529297B76617220693D4F626A6563742E6765744F776E50726F70657274794465736372697074';
wwv_flow_imp.g_varchar2_table(102) := '6F7228742C6E293B4F626A6563742E646566696E6550726F706572747928652C6E2C692E6765743F693A7B656E756D657261626C653A21302C6765743A66756E6374696F6E28297B72657475726E20745B6E5D7D7D297D7D29297D29292C4F626A656374';
wwv_flow_imp.g_varchar2_table(103) := '2E667265657A652865297D636F6E7374206B653D4F626A6563742E70726F746F747970652E746F537472696E672C52653D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B66756E6374696F6E204D6528652C74297B7265';
wwv_flow_imp.g_varchar2_table(104) := '7475726E2052652E63616C6C28652C74297D66756E6374696F6E20506528652C74297B6C6574206E2C693B696628766F696420303D3D3D652972657475726E3B636F6E737420723D286F3D652C225B6F626A6563742041727261795D223D3D3D6B652E63';
wwv_flow_imp.g_varchar2_table(105) := '616C6C286F293F42653A4465293B766172206F3B666F72286C6574206F20696E2065296966284D6528652C6F292626286E3D655B6F5D2C693D74286E2C72286F29292C21313D3D3D69292972657475726E206E7D66756E6374696F6E2044652865297B72';
wwv_flow_imp.g_varchar2_table(106) := '657475726E20657D66756E6374696F6E2042652865297B72657475726E204E756D6265722865297D66756E6374696F6E204F6528652C2E2E2E74297B636F6E7374206E3D652E7374796C653B72657475726E20506528742C2866756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(107) := '7B652626506528652C2866756E6374696F6E28652C74297B6E5B745D3D657D29297D29292C657D66756E6374696F6E20546528652C742C6E297B72657475726E20323D3D617267756D656E74732E6C656E6774683F652E67657441747472696275746528';
wwv_flow_imp.g_varchar2_table(108) := '74293A6E756C6C3D3D3D6E3F652E72656D6F76654174747269627574652874293A28652E73657441747472696275746528742C6E292C65297D636F6E7374204E653D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(109) := '2049652865297B72657475726E206E6577204C652865297D66756E6374696F6E204C652865297B69662821657C7C21652E6E6F646554797065297468726F77206E6577204572726F7228224120444F4D20656C656D656E74207265666572656E63652069';
wwv_flow_imp.g_varchar2_table(110) := '7320726571756972656422293B746869732E656C3D652C746869732E6C6973743D652E636C6173734C6973747D66756E6374696F6E206A652865297B666F722876617220743B743D652E66697273744368696C643B29652E72656D6F76654368696C6428';
wwv_flow_imp.g_varchar2_table(111) := '74293B72657475726E20657D66756E6374696F6E20466528652C742C6E297B76617220693D6E3F653A652E706172656E744E6F64653B72657475726E206926262266756E6374696F6E223D3D747970656F6620692E636C6F736573742626692E636C6F73';
wwv_flow_imp.g_varchar2_table(112) := '6573742874297C7C6E756C6C7D4C652E70726F746F747970652E6164643D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E6164642865292C746869737D2C4C652E70726F746F747970652E72656D6F76653D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(113) := '2865297B72657475726E225B6F626A656374205265674578705D223D3D4E652E63616C6C2865293F746869732E72656D6F76654D61746368696E672865293A28746869732E6C6973742E72656D6F76652865292C74686973297D2C4C652E70726F746F74';
wwv_flow_imp.g_varchar2_table(114) := '7970652E72656D6F76654D61746368696E673D66756E6374696F6E2865297B636F6E737420743D746869732E617272617928293B666F72286C6574206E3D303B6E3C742E6C656E6774683B6E2B2B29652E7465737428745B6E5D292626746869732E7265';
wwv_flow_imp.g_varchar2_table(115) := '6D6F766528745B6E5D293B72657475726E20746869737D2C4C652E70726F746F747970652E746F67676C653D66756E6374696F6E28652C74297B72657475726E20766F69642030213D3D743F74213D3D746869732E6C6973742E746F67676C6528652C74';
wwv_flow_imp.g_varchar2_table(116) := '292626746869732E6C6973742E746F67676C652865293A746869732E6C6973742E746F67676C652865292C746869737D2C4C652E70726F746F747970652E61727261793D66756E6374696F6E28297B72657475726E2041727261792E66726F6D28746869';
wwv_flow_imp.g_varchar2_table(117) := '732E6C697374297D2C4C652E70726F746F747970652E6861733D4C652E70726F746F747970652E636F6E7461696E733D66756E6374696F6E2865297B72657475726E20746869732E6C6973742E636F6E7461696E732865297D3B7661722056652C24652C';
wwv_flow_imp.g_varchar2_table(118) := '7A652C57653D7B7D3B66756E6374696F6E20476528297B56653D77696E646F772E6164644576656E744C697374656E65723F226164644576656E744C697374656E6572223A226174746163684576656E74222C24653D77696E646F772E72656D6F766545';
wwv_flow_imp.g_varchar2_table(119) := '76656E744C697374656E65723F2272656D6F76654576656E744C697374656E6572223A226465746163684576656E74222C7A653D226164644576656E744C697374656E657222213D3D56653F226F6E223A22227D7661722048652C4B653D57652E62696E';
wwv_flow_imp.g_varchar2_table(120) := '643D66756E6374696F6E28652C742C6E2C69297B72657475726E2056657C7C476528292C655B56655D287A652B742C6E2C697C7C2131292C6E7D2C55653D57652E756E62696E643D66756E6374696F6E28652C742C6E2C69297B72657475726E2024657C';
wwv_flow_imp.g_varchar2_table(121) := '7C476528292C655B24655D287A652B742C6E2C697C7C2131292C6E7D2C71653D4365287B5F5F70726F746F5F5F3A6E756C6C2C62696E643A4B652C756E62696E643A55652C64656661756C743A57657D2C5B57655D292C59653D5B22666F637573222C22';
wwv_flow_imp.g_varchar2_table(122) := '626C7572225D2C58653D7B62696E643A66756E6374696F6E28652C742C6E2C692C72297B72657475726E2D31213D3D59652E696E6465784F66286E29262628723D2130292C71652E62696E6428652C6E2C2866756E6374696F6E286E297B76617220723D';
wwv_flow_imp.g_varchar2_table(123) := '6E2E7461726765747C7C6E2E737263456C656D656E743B6E2E64656C65676174655461726765743D466528722C742C2130292C6E2E64656C65676174655461726765742626692E63616C6C28652C6E297D292C72297D2C756E62696E643A66756E637469';
wwv_flow_imp.g_varchar2_table(124) := '6F6E28652C742C6E2C69297B72657475726E2D31213D3D59652E696E6465784F66287429262628693D2130292C71652E756E62696E6428652C742C6E2C69297D7D2C5A653D21313B22756E646566696E656422213D747970656F6620646F63756D656E74';
wwv_flow_imp.g_varchar2_table(125) := '2626282848653D646F63756D656E742E637265617465456C656D656E7428226469762229292E696E6E657248544D4C3D2720203C6C696E6B2F3E3C7461626C653E3C2F7461626C653E3C6120687265663D222F61223E613C2F613E3C696E707574207479';
wwv_flow_imp.g_varchar2_table(126) := '70653D22636865636B626F78222F3E272C5A653D2148652E676574456C656D656E747342795461674E616D6528226C696E6B22292E6C656E6774682C48653D766F69642030293B766172204A653D7B6C6567656E643A5B312C223C6669656C647365743E';
wwv_flow_imp.g_varchar2_table(127) := '222C223C2F6669656C647365743E225D2C74723A5B322C223C7461626C653E3C74626F64793E222C223C2F74626F64793E3C2F7461626C653E225D2C636F6C3A5B322C223C7461626C653E3C74626F64793E3C2F74626F64793E3C636F6C67726F75703E';
wwv_flow_imp.g_varchar2_table(128) := '222C223C2F636F6C67726F75703E3C2F7461626C653E225D2C5F64656661756C743A5A653F5B312C22583C6469763E222C223C2F6469763E225D3A5B302C22222C22225D7D3B4A652E74643D4A652E74683D5B332C223C7461626C653E3C74626F64793E';
wwv_flow_imp.g_varchar2_table(129) := '3C74723E222C223C2F74723E3C2F74626F64793E3C2F7461626C653E225D2C4A652E6F7074696F6E3D4A652E6F707467726F75703D5B312C273C73656C656374206D756C7469706C653D226D756C7469706C65223E272C223C2F73656C6563743E225D2C';
wwv_flow_imp.g_varchar2_table(130) := '4A652E74686561643D4A652E74626F64793D4A652E636F6C67726F75703D4A652E63617074696F6E3D4A652E74666F6F743D5B312C223C7461626C653E222C223C2F7461626C653E225D2C4A652E706F6C796C696E653D4A652E656C6C697073653D4A65';
wwv_flow_imp.g_varchar2_table(131) := '2E706F6C79676F6E3D4A652E636972636C653D4A652E746578743D4A652E6C696E653D4A652E706174683D4A652E726563743D4A652E673D5B312C273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F7376672220';
wwv_flow_imp.g_varchar2_table(132) := '76657273696F6E3D22312E31223E272C223C2F7376673E225D3B7661722051653D66756E6374696F6E28652C74297B69662822737472696E6722213D747970656F662065297468726F77206E657720547970654572726F722822537472696E6720657870';
wwv_flow_imp.g_varchar2_table(133) := '656374656422293B747C7C28743D646F63756D656E74293B766172206E3D2F3C285B5C773A5D2B292F2E657865632865293B696628216E2972657475726E20742E637265617465546578744E6F64652865293B653D652E7265706C616365282F5E5C732B';
wwv_flow_imp.g_varchar2_table(134) := '7C5C732B242F672C2222293B76617220693D6E5B315D3B69662822626F6479223D3D692972657475726E28723D742E637265617465456C656D656E74282268746D6C2229292E696E6E657248544D4C3D652C722E72656D6F76654368696C6428722E6C61';
wwv_flow_imp.g_varchar2_table(135) := '73744368696C64293B76617220722C6F3D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C284A652C69293F4A655B695D3A4A652E5F64656661756C742C613D6F5B305D2C733D6F5B315D2C6C3D6F5B325D3B66';
wwv_flow_imp.g_varchar2_table(136) := '6F722828723D742E637265617465456C656D656E7428226469762229292E696E6E657248544D4C3D732B652B6C3B612D2D3B29723D722E6C6173744368696C643B696628722E66697273744368696C643D3D722E6C6173744368696C642972657475726E';
wwv_flow_imp.g_varchar2_table(137) := '20722E72656D6F76654368696C6428722E66697273744368696C64293B666F722876617220633D742E637265617465446F63756D656E74467261676D656E7428293B722E66697273744368696C643B29632E617070656E644368696C6428722E72656D6F';
wwv_flow_imp.g_varchar2_table(138) := '76654368696C6428722E66697273744368696C6429293B72657475726E20637D3B66756E6374696F6E20657428652C74297B72657475726E28743D747C7C646F63756D656E74292E717565727953656C6563746F722865297D66756E6374696F6E207474';
wwv_flow_imp.g_varchar2_table(139) := '2865297B652E706172656E744E6F64652626652E706172656E744E6F64652E72656D6F76654368696C642865297D66756E6374696F6E206E7428652C742C6E2C692C72297B766172206F3D656528293B6F2E7365745472616E736C61746528742C6E293B';
wwv_flow_imp.g_varchar2_table(140) := '76617220613D656528293B612E736574526F7461746528697C7C302C302C30293B76617220733D656528293B732E7365745363616C6528727C7C312C727C7C31292C636528652C5B6F2C612C735D297D66756E6374696F6E20697428652C742C6E297B76';
wwv_flow_imp.g_varchar2_table(141) := '617220693D656528293B692E7365745472616E736C61746528742C6E292C636528652C69297D7661722072742C6F742C61743D2872743D66756E6374696F6E2865297B76617220743D652E6578706F7274733D66756E6374696F6E28652C6E297B696628';
wwv_flow_imp.g_varchar2_table(142) := '6E7C7C286E3D3136292C766F696420303D3D3D65262628653D313238292C653C3D302972657475726E2230223B666F722876617220693D4D6174682E6C6F67284D6174682E706F7728322C6529292F4D6174682E6C6F67286E292C723D323B693D3D3D31';
wwv_flow_imp.g_varchar2_table(143) := '2F303B722A3D3229693D4D6174682E6C6F67284D6174682E706F7728322C652F7229292F4D6174682E6C6F67286E292A723B766172206F3D692D4D6174682E666C6F6F722869292C613D22223B666F7228723D303B723C4D6174682E666C6F6F72286929';
wwv_flow_imp.g_varchar2_table(144) := '3B722B2B29613D4D6174682E666C6F6F72284D6174682E72616E646F6D28292A6E292E746F537472696E67286E292B613B6966286F297B76617220733D4D6174682E706F77286E2C6F293B613D4D6174682E666C6F6F72284D6174682E72616E646F6D28';
wwv_flow_imp.g_varchar2_table(145) := '292A73292E746F537472696E67286E292B617D766172206C3D7061727365496E7428612C6E293B72657475726E206C213D3D312F3026266C3E3D4D6174682E706F7728322C65293F7428652C6E293A617D3B742E7261636B3D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(146) := '6E2C69297B76617220723D66756E6374696F6E2872297B76617220613D303B646F7B696628612B2B3E3130297B6966282169297468726F77206E6577204572726F722822746F6F206D616E7920494420636F6C6C6973696F6E732C20757365206D6F7265';
wwv_flow_imp.g_varchar2_table(147) := '206269747322293B652B3D697D76617220733D7428652C6E297D7768696C65284F626A6563742E6861734F776E50726F70657274792E63616C6C286F2C7329293B72657475726E206F5B735D3D722C737D2C6F3D722E686174733D7B7D3B72657475726E';
wwv_flow_imp.g_varchar2_table(148) := '20722E6765743D66756E6374696F6E2865297B72657475726E20722E686174735B655D7D2C722E7365743D66756E6374696F6E28652C74297B72657475726E20722E686174735B655D3D742C727D2C722E626974733D657C7C3132382C722E626173653D';
wwv_flow_imp.g_varchar2_table(149) := '6E7C7C31362C727D7D2C7274286F743D7B6578706F7274733A7B7D7D292C6F742E6578706F727473293B66756E6374696F6E2073742865297B69662821287468697320696E7374616E63656F66207374292972657475726E206E65772073742865293B65';
wwv_flow_imp.g_varchar2_table(150) := '3D657C7C5B3132382C33362C315D2C746869732E5F736565643D652E6C656E6774683F61742E7261636B28655B305D2C655B315D2C655B325D293A657D73742E70726F746F747970652E6E6578743D66756E6374696F6E2865297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(151) := '69732E5F7365656428657C7C2130297D2C73742E70726F746F747970652E6E65787450726566697865643D66756E6374696F6E28652C74297B766172206E3B646F7B6E3D652B746869732E6E657874282130297D7768696C6528746869732E6173736967';
wwv_flow_imp.g_varchar2_table(152) := '6E6564286E29293B72657475726E20746869732E636C61696D286E2C74292C6E7D2C73742E70726F746F747970652E636C61696D3D66756E6374696F6E28652C74297B746869732E5F736565642E73657428652C747C7C2130297D2C73742E70726F746F';
wwv_flow_imp.g_varchar2_table(153) := '747970652E61737369676E65643D66756E6374696F6E2865297B72657475726E20746869732E5F736565642E6765742865297C7C21317D2C73742E70726F746F747970652E756E636C61696D3D66756E6374696F6E2865297B64656C6574652074686973';
wwv_flow_imp.g_varchar2_table(154) := '2E5F736565642E686174735B655D7D2C73742E70726F746F747970652E636C6561723D66756E6374696F6E28297B76617220652C743D746869732E5F736565642E686174733B666F72286520696E207429746869732E756E636C61696D2865297D3B7661';
wwv_flow_imp.g_varchar2_table(155) := '72206C743D6E65772073742C63743D2E39353B66756E6374696F6E20707428652C742C6E2C692C722C6F2C61297B432E63616C6C28746869732C742C61293B76617220733D652626652E64656661756C7446696C6C436F6C6F722C633D652626652E6465';
wwv_flow_imp.g_varchar2_table(156) := '6661756C745374726F6B65436F6C6F722C703D652626652E64656661756C744C6162656C436F6C6F723B66756E6374696F6E20752865297B72657475726E206E2E636F6D707574655374796C6528652C7B7374726F6B654C696E656361703A22726F756E';
wwv_flow_imp.g_varchar2_table(157) := '64222C7374726F6B654C696E656A6F696E3A22726F756E64222C7374726F6B653A67652C7374726F6B6557696474683A322C66696C6C3A227768697465227D297D66756E6374696F6E20682865297B72657475726E206E2E636F6D707574655374796C65';
wwv_flow_imp.g_varchar2_table(158) := '28652C5B226E6F2D66696C6C225D2C7B7374726F6B654C696E656361703A22726F756E64222C7374726F6B654C696E656A6F696E3A22726F756E64222C7374726F6B653A67652C7374726F6B6557696474683A327D297D66756E6374696F6E206428652C';
wwv_flow_imp.g_varchar2_table(159) := '74297B7661727B7265663A6E3D7B783A302C793A307D2C7363616C653A693D312C656C656D656E743A6F2C706172656E744766783A613D722E5F7376677D3D742C733D5828226D61726B6572222C7B69643A652C76696577426F783A2230203020323020';
wwv_flow_imp.g_varchar2_table(160) := '3230222C726566583A6E2E782C726566593A6E2E792C6D61726B657257696474683A32302A692C6D61726B65724865696768743A32302A692C6F7269656E743A226175746F227D293B6A28732C6F293B766172206C3D657428223A73636F7065203E2064';
wwv_flow_imp.g_varchar2_table(161) := '656673222C61293B6C7C7C6A28612C6C3D582822646566732229292C6A286C2C73297D66756E6374696F6E206D28652C742C6E2C69297B76617220723D6C742E6E657874507265666978656428226D61726B65722D22293B72657475726E2066756E6374';
wwv_flow_imp.g_varchar2_table(162) := '696F6E28652C742C6E2C692C72297B2273657175656E6365666C6F772D656E64223D3D3D6E26266428742C7B656C656D656E743A58282270617468222C7B643A224D20312035204C203131203130204C2031203135205A222C2E2E2E75287B66696C6C3A';
wwv_flow_imp.g_varchar2_table(163) := '722C7374726F6B653A722C7374726F6B6557696474683A317D297D292C7265663A7B783A31312C793A31307D2C7363616C653A2E352C706172656E744766783A657D292C226D657373616765666C6F772D7374617274223D3D3D6E26266428742C7B656C';
wwv_flow_imp.g_varchar2_table(164) := '656D656E743A582822636972636C65222C7B63783A362C63793A362C723A332E352C2E2E2E75287B66696C6C3A692C7374726F6B653A722C7374726F6B6557696474683A312C7374726F6B654461736861727261793A5B3165342C315D7D297D292C7265';
wwv_flow_imp.g_varchar2_table(165) := '663A7B783A362C793A367D2C706172656E744766783A657D292C226D657373616765666C6F772D656E64223D3D3D6E26266428742C7B656C656D656E743A58282270617468222C7B643A226D20312035206C2030202D33206C20372033206C202D372033';
wwv_flow_imp.g_varchar2_table(166) := '207A222C2E2E2E75287B66696C6C3A692C7374726F6B653A722C7374726F6B6557696474683A312C7374726F6B654461736861727261793A5B3165342C315D7D297D292C7265663A7B783A382E352C793A357D2C706172656E744766783A657D292C2261';
wwv_flow_imp.g_varchar2_table(167) := '73736F63696174696F6E2D7374617274223D3D3D6E26266428742C7B656C656D656E743A58282270617468222C7B643A224D2031312035204C2031203130204C203131203135222C2E2E2E68287B66696C6C3A226E6F6E65222C7374726F6B653A722C73';
wwv_flow_imp.g_varchar2_table(168) := '74726F6B6557696474683A312E352C7374726F6B654461736861727261793A5B3165342C315D7D297D292C7265663A7B783A312C793A31307D2C7363616C653A2E352C706172656E744766783A657D292C226173736F63696174696F6E2D656E64223D3D';
wwv_flow_imp.g_varchar2_table(169) := '3D6E26266428742C7B656C656D656E743A58282270617468222C7B643A224D20312035204C203131203130204C2031203135222C2E2E2E68287B66696C6C3A226E6F6E65222C7374726F6B653A722C7374726F6B6557696474683A312E352C7374726F6B';
wwv_flow_imp.g_varchar2_table(170) := '654461736861727261793A5B3165342C315D7D297D292C7265663A7B783A31312C793A31307D2C7363616C653A2E352C706172656E744766783A657D292C22636F6E646974696F6E616C2D666C6F772D6D61726B6572223D3D3D6E26266428742C7B656C';
wwv_flow_imp.g_varchar2_table(171) := '656D656E743A58282270617468222C7B643A224D2030203130204C20382036204C203136203130204C2038203134205A222C2E2E2E75287B66696C6C3A692C7374726F6B653A727D297D292C7265663A7B783A2D312C793A31307D2C7363616C653A2E35';
wwv_flow_imp.g_varchar2_table(172) := '2C706172656E744766783A657D292C22636F6E646974696F6E616C2D64656661756C742D666C6F772D6D61726B6572223D3D3D6E26266428742C7B656C656D656E743A58282270617468222C7B643A224D20362034204C203130203136222C2E2E2E7528';
wwv_flow_imp.g_varchar2_table(173) := '7B7374726F6B653A722C66696C6C3A226E6F6E65227D297D292C7265663A7B783A302C793A31307D2C7363616C653A2E352C706172656E744766783A657D297D28652C722C742C6E2C69292C2275726C2823222B722B2229227D66756E6374696F6E2079';
wwv_flow_imp.g_varchar2_table(174) := '28652C742C6E2C692C723D7B7D297B6C286929262628723D692C693D30292C693D697C7C302C723D752872293B766172206F3D582822636972636C65222C7B63783A742F322C63793A6E2F322C723A4D6174682E726F756E642828742B6E292F342D6929';
wwv_flow_imp.g_varchar2_table(175) := '2C2E2E2E727D293B72657475726E206A28652C6F292C6F7D66756E6374696F6E206728652C742C6E2C692C722C6F297B6C2872292626286F3D722C723D30292C723D727C7C302C6F3D75286F293B76617220613D58282272656374222C7B783A722C793A';
wwv_flow_imp.g_varchar2_table(176) := '722C77696474683A742D322A722C6865696768743A6E2D322A722C72783A692C72793A692C2E2E2E6F7D293B72657475726E206A28652C61292C617D66756E6374696F6E207628652C742C6E2C69297B76617220723D666528742C6E3D68286E292C6929';
wwv_flow_imp.g_varchar2_table(177) := '3B72657475726E206A28652C72292C727D66756E6374696F6E206228652C742C6E297B72657475726E207628652C742C6E2C35297D66756E6374696F6E207828652C742C6E297B6E3D68286E293B76617220693D58282270617468222C7B2E2E2E6E2C64';
wwv_flow_imp.g_varchar2_table(178) := '3A747D293B72657475726E206A28652C69292C697D66756E6374696F6E207728652C742C6E2C69297B72657475726E207828742C6E2C53287B22646174612D6D61726B6572223A657D2C6929297D66756E6374696F6E205F2865297B72657475726E205A';
wwv_flow_imp.g_varchar2_table(179) := '5B655D7D66756E6374696F6E20452865297B72657475726E2066756E6374696F6E28742C6E2C69297B72657475726E205F28652928742C6E2C69297D7D66756E6374696F6E204128652C742C6E3D7B7D297B76617220722C6F3D4D2865292C613D226270';
wwv_flow_imp.g_varchar2_table(180) := '6D6E3A496E7465726D6564696174655468726F774576656E74223D3D3D28723D6F292E24747970657C7C2262706D6E3A456E644576656E74223D3D3D722E24747970653B72657475726E206F2E67657428226576656E74446566696E6974696F6E732229';
wwv_flow_imp.g_varchar2_table(181) := '26266F2E67657428226576656E74446566696E6974696F6E7322292E6C656E6774683E313F6F2E6765742822706172616C6C656C4D756C7469706C6522293F66756E6374696F6E28652C742C6E3D7B7D297B72657475726E207828652C692E6765745363';
wwv_flow_imp.g_varchar2_table(182) := '616C65645061746828224556454E545F504152414C4C454C5F4D554C5449504C45222C7B785363616C65466163746F723A312E322C795363616C65466163746F723A312E322C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E';
wwv_flow_imp.g_varchar2_table(183) := '65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3435382C6D793A2E3139347D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B655769';
wwv_flow_imp.g_varchar2_table(184) := '6474683A317D297D28742C652C6E293A66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F4D554C5449504C45222C7B785363616C65466163746F723A312E312C79';
wwv_flow_imp.g_varchar2_table(185) := '5363616C65466163746F723A312E312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3232322C6D793A2E33367D7D292C7B66696C6C3A723F';
wwv_flow_imp.g_varchar2_table(186) := '776528742C632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E3A4D6573736167654576656E74446566696E6974696F6E22293F66756E637469';
wwv_flow_imp.g_varchar2_table(187) := '6F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F4D455353414745222C7B785363616C65466163746F723A2E392C795363616C65466163746F723A2E392C636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(188) := '57696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3233352C6D793A2E3331357D7D292C7B66696C6C3A723F776528742C632C6E2E7374726F6B65293A786528742C732C';
wwv_flow_imp.g_varchar2_table(189) := '6E2E66696C6C292C7374726F6B653A723F786528742C732C6E2E66696C6C293A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E3A54696D65724576656E7444656669';
wwv_flow_imp.g_varchar2_table(190) := '6E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D297B76617220723D7928652C742E77696474682C742E6865696768742C2E322A742E6865696768742C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C';
wwv_flow_imp.g_varchar2_table(191) := '632C6E2E7374726F6B65292C7374726F6B6557696474683A327D293B7828652C692E6765745363616C65645061746828224556454E545F54494D45525F5748222C7B785363616C65466163746F723A2E37352C795363616C65466163746F723A2E37352C';
wwv_flow_imp.g_varchar2_table(192) := '636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E357D7D292C7B7374726F6B653A776528742C632C6E2E7374726F6B65292C7374';
wwv_flow_imp.g_varchar2_table(193) := '726F6B6557696474683A327D293B666F7228766172206F3D303B6F3C31323B6F2B2B297B76617220613D692E6765745363616C65645061746828224556454E545F54494D45525F4C494E45222C7B785363616C65466163746F723A2E37352C795363616C';
wwv_flow_imp.g_varchar2_table(194) := '65466163746F723A2E37352C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E357D7D292C6C3D742E77696474682F322C703D74';
wwv_flow_imp.g_varchar2_table(195) := '2E6865696768742F323B7828652C612C7B7374726F6B6557696474683A312C7374726F6B653A776528742C632C6E2E7374726F6B65292C7472616E73666F726D3A22726F7461746528222B33302A6F2B222C222B702B222C222B6C2B2229227D297D7265';
wwv_flow_imp.g_varchar2_table(196) := '7475726E20727D28742C652C6E293A6265286F2C2262706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D297B72657475726E207828652C692E6765745363616C656450617468';
wwv_flow_imp.g_varchar2_table(197) := '28224556454E545F434F4E444954494F4E414C222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C';
wwv_flow_imp.g_varchar2_table(198) := '706F736974696F6E3A7B6D783A2E352C6D793A2E3232327D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E293A6265286F';
wwv_flow_imp.g_varchar2_table(199) := '2C2262706D6E3A5369676E616C4576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F5349474E414C222C7B785363616C';
wwv_flow_imp.g_varchar2_table(200) := '65466163746F723A2E392C795363616C65466163746F723A2E392C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E327D7D292C';
wwv_flow_imp.g_varchar2_table(201) := '7B7374726F6B6557696474683A312C66696C6C3A723F776528742C632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D28742C652C6E2C61293A6265286F2C2262706D6E';
wwv_flow_imp.g_varchar2_table(202) := '3A457363616C6174696F6E4576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F455343414C4154494F4E222C7B785363';
wwv_flow_imp.g_varchar2_table(203) := '616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E352C6D793A2E327D7D292C';
wwv_flow_imp.g_varchar2_table(204) := '7B66696C6C3A723F776528742C632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E';
wwv_flow_imp.g_varchar2_table(205) := '3A4C696E6B4576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F4C494E4B222C7B785363616C65466163746F723A312C';
wwv_flow_imp.g_varchar2_table(206) := '795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E35372C6D793A2E3236337D7D292C7B66696C6C3A723F77';
wwv_flow_imp.g_varchar2_table(207) := '6528742C632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E3A4572726F72457665';
wwv_flow_imp.g_varchar2_table(208) := '6E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C65645061746828224556454E545F4552524F52222C7B785363616C65466163746F723A312E312C795363616C';
wwv_flow_imp.g_varchar2_table(209) := '65466163746F723A312E312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E322C6D793A2E3732327D7D292C7B66696C6C3A723F776528742C';
wwv_flow_imp.g_varchar2_table(210) := '632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E3A43616E63656C4576656E7444';
wwv_flow_imp.g_varchar2_table(211) := '6566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B766172206F2C612C733D7828652C692E6765745363616C65645061746828224556454E545F43414E43454C5F3435222C7B785363616C65466163746F723A312C795363';
wwv_flow_imp.g_varchar2_table(212) := '616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3633382C6D793A2D2E3035357D7D292C7B66696C6C3A723F7765';
wwv_flow_imp.g_varchar2_table(213) := '28742C632C6E2E7374726F6B65293A226E6F6E65222C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D293B72657475726E206F3D732C28613D65652829292E736574526F746174652834352C302C30292C';
wwv_flow_imp.g_varchar2_table(214) := '6365286F2C61292C737D28742C652C6E2C61293A6265286F2C2262706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D2C72297B72657475726E207828652C692E6765745363616C';
wwv_flow_imp.g_varchar2_table(215) := '65645061746828224556454E545F434F4D50454E534154494F4E222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E';
wwv_flow_imp.g_varchar2_table(216) := '6865696768742C706F736974696F6E3A7B6D783A2E32322C6D793A2E357D7D292C7B66696C6C3A723F776528742C632C6E2E7374726F6B65293A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C737472';
wwv_flow_imp.g_varchar2_table(217) := '6F6B6557696474683A317D297D28742C652C6E2C61293A6265286F2C2262706D6E3A5465726D696E6174654576656E74446566696E6974696F6E22293F66756E6374696F6E28652C742C6E3D7B7D297B72657475726E207928652C742E77696474682C74';
wwv_flow_imp.g_varchar2_table(218) := '2E6865696768742C382C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A347D297D28742C652C6E293A6E756C6C7D76617220523D7B50617274696369';
wwv_flow_imp.g_varchar2_table(219) := '70616E744D756C7469706C69636974794D61726B65723A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D536528742C6E292C6F3D416528742C6E293B7728227061727469636970616E742D6D756C7469706C6963697479222C652C692E67';
wwv_flow_imp.g_varchar2_table(220) := '65745363616C65645061746828224D41524B45525F504152414C4C454C222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A722C636F6E7461696E65724865696768743A6F2C706F73';
wwv_flow_imp.g_varchar2_table(221) := '6974696F6E3A7B6D783A28722F322D36292F722C6D793A286F2D3135292F6F7D7D292C7B7374726F6B6557696474683A322C66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D2C537562';
wwv_flow_imp.g_varchar2_table(222) := '50726F636573734D61726B65723A66756E6374696F6E28652C742C6E3D7B7D297B6974286728652C31342C31342C302C7B7374726F6B6557696474683A312C66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E73';
wwv_flow_imp.g_varchar2_table(223) := '74726F6B65297D292C742E77696474682F322D372E352C742E6865696768742D3230292C7728227375622D70726F63657373222C652C692E6765745363616C65645061746828224D41524B45525F5355425F50524F43455353222C7B785363616C654661';
wwv_flow_imp.g_varchar2_table(224) := '63746F723A312E352C795363616C65466163746F723A312E352C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A28742E77696474682F322D372E';
wwv_flow_imp.g_varchar2_table(225) := '35292F742E77696474682C6D793A28742E6865696768742D3230292F742E6865696768747D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D2C506172616C6C656C4D61726B';
wwv_flow_imp.g_varchar2_table(226) := '65723A66756E6374696F6E28652C742C6E297B76617220723D536528742C6E292C6F3D416528742C6E293B772822706172616C6C656C222C652C692E6765745363616C65645061746828224D41524B45525F504152414C4C454C222C7B785363616C6546';
wwv_flow_imp.g_varchar2_table(227) := '6163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A722C636F6E7461696E65724865696768743A6F2C706F736974696F6E3A7B6D783A28722F322B6E2E706172616C6C656C292F722C6D793A286F2D3230292F';
wwv_flow_imp.g_varchar2_table(228) := '6F7D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D2C53657175656E7469616C4D61726B65723A66756E6374696F6E28652C742C6E297B77282273657175656E7469616C22';
wwv_flow_imp.g_varchar2_table(229) := '2C652C692E6765745363616C65645061746828224D41524B45525F53455155454E5449414C222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E';
wwv_flow_imp.g_varchar2_table(230) := '65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A28742E77696474682F322B6E2E736571292F742E77696474682C6D793A28742E6865696768742D3139292F742E6865696768747D7D292C7B66696C6C3A786528742C732C6E';
wwv_flow_imp.g_varchar2_table(231) := '2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D2C436F6D70656E736174696F6E4D61726B65723A66756E6374696F6E28652C742C6E297B772822636F6D70656E736174696F6E222C652C692E6765745363616C656450';
wwv_flow_imp.g_varchar2_table(232) := '61746828224D41524B45525F434F4D50454E534154494F4E222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865';
wwv_flow_imp.g_varchar2_table(233) := '696768742C706F736974696F6E3A7B6D783A28742E77696474682F322B6E2E636F6D70656E736174696F6E292F742E77696474682C6D793A28742E6865696768742D3133292F742E6865696768747D7D292C7B7374726F6B6557696474683A312C66696C';
wwv_flow_imp.g_varchar2_table(234) := '6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D2C4C6F6F704D61726B65723A66756E6374696F6E28652C742C6E297B76617220723D536528742C6E292C6F3D416528742C6E293B7728226C6F';
wwv_flow_imp.g_varchar2_table(235) := '6F70222C652C692E6765745363616C65645061746828224D41524B45525F4C4F4F50222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A722C636F6E7461696E65724865696768743A';
wwv_flow_imp.g_varchar2_table(236) := '6F2C706F736974696F6E3A7B6D783A28722F322B6E2E6C6F6F70292F722C6D793A286F2D37292F6F7D7D292C7B7374726F6B6557696474683A312E352C66696C6C3A226E6F6E65222C7374726F6B653A776528742C632C6E2E7374726F6B65292C737472';
wwv_flow_imp.g_varchar2_table(237) := '6F6B654D697465726C696D69743A2E357D297D2C4164686F634D61726B65723A66756E6374696F6E28652C742C6E297B76617220723D536528742C6E292C6F3D416528742C6E293B7728226164686F63222C652C692E6765745363616C65645061746828';
wwv_flow_imp.g_varchar2_table(238) := '224D41524B45525F4144484F43222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A722C636F6E7461696E65724865696768743A6F2C706F736974696F6E3A7B6D783A28722F322B6E';
wwv_flow_imp.g_varchar2_table(239) := '2E6164686F63292F722C6D793A286F2D3135292F6F7D7D292C7B7374726F6B6557696474683A312C66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D7D3B66756E6374696F6E204F';
wwv_flow_imp.g_varchar2_table(240) := '28652C742C6E2C69297B525B655D28742C6E2C69297D66756E6374696F6E205428652C742C6E2C693D7B7D297B693D7B66696C6C3A692E66696C6C2C7374726F6B653A692E7374726F6B652C77696474683A536528742C69292C6865696768743A416528';
wwv_flow_imp.g_varchar2_table(241) := '742C69297D3B76617220723D4D2874292C6F3D6E26266E2E696E636C75646573282253756250726F636573734D61726B657222293B693D6F3F7B2E2E2E692C7365713A2D32312C706172616C6C656C3A2D32322C636F6D70656E736174696F6E3A2D3432';
wwv_flow_imp.g_varchar2_table(242) := '2C6C6F6F703A2D31382C6164686F633A31307D3A7B2E2E2E692C7365713A2D352C706172616C6C656C3A2D362C636F6D70656E736174696F6E3A2D32372C6C6F6F703A302C6164686F633A31307D2C66286E2C2866756E6374696F6E286E297B4F286E2C';
wwv_flow_imp.g_varchar2_table(243) := '652C742C69297D29292C722E67657428226973466F72436F6D70656E736174696F6E222926264F2822436F6D70656E736174696F6E4D61726B6572222C652C742C69292C6B28722C2262706D6E3A4164486F6353756250726F63657373222926264F2822';
wwv_flow_imp.g_varchar2_table(244) := '4164686F634D61726B6572222C652C742C69293B76617220613D722E67657428226C6F6F7043686172616374657269737469637322292C733D612626612E6765742822697353657175656E7469616C22293B61262628766F696420303D3D3D7326264F28';
wwv_flow_imp.g_varchar2_table(245) := '224C6F6F704D61726B6572222C652C742C69292C21313D3D3D7326264F2822506172616C6C656C4D61726B6572222C652C742C69292C21303D3D3D7326264F282253657175656E7469616C4D61726B6572222C652C742C6929297D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(246) := '4E28652C742C6E3D7B7D297B6E3D53287B73697A653A7B77696474683A3130307D7D2C6E293B76617220693D6F2E6372656174655465787428747C7C22222C6E293B72657475726E20472869292E6164642822646A732D6C6162656C22292C6A28652C69';
wwv_flow_imp.g_varchar2_table(247) := '292C697D66756E6374696F6E204C28652C742C6E2C693D7B7D297B76617220723D4D2874292C6F3D4565287B783A742E782C793A742E792C77696474683A742E77696474682C6865696768743A742E6865696768747D2C69293B72657475726E204E2865';
wwv_flow_imp.g_varchar2_table(248) := '2C722E6E616D652C7B616C69676E3A6E2C626F783A6F2C70616464696E673A372C7374796C653A7B66696C6C3A5F6528742C702C632C692E7374726F6B65297D7D297D66756E6374696F6E204628652C742C6E2C693D7B7D297B76617220723D42286E29';
wwv_flow_imp.g_varchar2_table(249) := '2C6F3D4E28652C742C7B626F783A7B6865696768743A33302C77696474683A723F4165286E2C69293A5365286E2C69297D2C616C69676E3A2263656E7465722D6D6964646C65222C7374796C653A7B66696C6C3A5F65286E2C702C632C692E7374726F6B';
wwv_flow_imp.g_varchar2_table(250) := '65297D7D293B7226266E74286F2C302C312A4165286E2C69292C323730297D66756E6374696F6E205628652C742C6E3D7B7D297B7661727B77696474683A692C6865696768743A727D3D456528742C6E293B72657475726E206728652C692C722C31302C';
wwv_flow_imp.g_varchar2_table(251) := '7B2E2E2E6E2C66696C6C3A786528742C732C6E2E66696C6C292C66696C6C4F7061636974793A63742C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D66756E6374696F6E202428652C742C6E3D7B7D297B76617220693D4D2874292C72';
wwv_flow_imp.g_varchar2_table(252) := '3D786528742C732C6E2E66696C6C292C6F3D776528742C632C6E2E7374726F6B65293B72657475726E224F6E6522213D3D692E67657428226173736F63696174696F6E446972656374696F6E2229262622426F746822213D3D692E67657428226173736F';
wwv_flow_imp.g_varchar2_table(253) := '63696174696F6E446972656374696F6E22297C7C286E2E6D61726B6572456E643D6D28652C226173736F63696174696F6E2D656E64222C722C6F29292C22426F7468223D3D3D692E67657428226173736F63696174696F6E446972656374696F6E222926';
wwv_flow_imp.g_varchar2_table(254) := '26286E2E6D61726B657253746172743D6D28652C226173736F63696174696F6E2D7374617274222C722C6F29292C6E3D7574286E2C5B226D61726B65725374617274222C226D61726B6572456E64225D292C6228652C742E776179706F696E74732C7B2E';
wwv_flow_imp.g_varchar2_table(255) := '2E2E6E2C7374726F6B653A6F2C7374726F6B654461736861727261793A22302C2035227D297D66756E6374696F6E205728652C742C6E3D7B7D297B76617220723D786528742C732C6E2E66696C6C292C6F3D776528742C632C6E2E7374726F6B65292C61';
wwv_flow_imp.g_varchar2_table(256) := '3D7828652C692E6765745363616C6564506174682822444154415F4F424A4543545F50415448222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E746169';
wwv_flow_imp.g_varchar2_table(257) := '6E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3437342C6D793A2E3239367D7D292C7B66696C6C3A722C66696C6C4F7061636974793A63742C7374726F6B653A6F7D293B72657475726E2066756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(258) := '7B76617220743D652E646174614F626A6563745265663B72657475726E20652E6973436F6C6C656374696F6E7C7C742626742E6973436F6C6C656374696F6E7D284D2874292926267828652C692E6765745363616C6564506174682822444154415F4F42';
wwv_flow_imp.g_varchar2_table(259) := '4A4543545F434F4C4C454354494F4E5F50415448222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E686569676874';
wwv_flow_imp.g_varchar2_table(260) := '2C706F736974696F6E3A7B6D783A2E33332C6D793A28742E6865696768742D3138292F742E6865696768747D7D292C7B7374726F6B6557696474683A322C66696C6C3A722C7374726F6B653A6F7D292C617D66756E6374696F6E204828652C742C6E3D7B';
wwv_flow_imp.g_varchar2_table(261) := '7D297B72657475726E207928652C742E77696474682C742E6865696768742C7B66696C6C4F7061636974793A63742C2E2E2E6E2C66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D6675';
wwv_flow_imp.g_varchar2_table(262) := '6E6374696F6E204B28652C742C6E3D7B7D297B72657475726E2066756E6374696F6E28652C742C6E2C69297B76617220723D742F322C6F3D6E2F322C613D5B7B783A722C793A307D2C7B783A742C793A6F7D2C7B783A722C793A6E7D2C7B783A302C793A';
wwv_flow_imp.g_varchar2_table(263) := '6F7D5D2E6D6170282866756E6374696F6E2865297B72657475726E20652E782B222C222B652E797D29292E6A6F696E28222022293B693D752869293B76617220733D582822706F6C79676F6E222C7B2E2E2E692C706F696E74733A617D293B7265747572';
wwv_flow_imp.g_varchar2_table(264) := '6E206A28652C73292C737D28652C742E77696474682C742E6865696768742C7B66696C6C3A786528742C732C6E2E66696C6C292C66696C6C4F7061636974793A63742C7374726F6B653A776528742C632C6E2E7374726F6B65297D297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(265) := '6E205528652C742C6E3D7B7D297B76617220693D6728652C536528742C6E292C416528742C6E292C302C7B66696C6C3A786528742C732C6E2E66696C6C292C66696C6C4F7061636974793A6E2E66696C6C4F7061636974797C7C63742C7374726F6B653A';
wwv_flow_imp.g_varchar2_table(266) := '776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A312E357D292C723D4D2874293B72657475726E206B28722C2262706D6E3A4C616E65222926264628652C722E67657428226E616D6522292C742C6E292C697D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(267) := '207128652C742C6E3D7B7D297B76617220693D5628652C742C6E293B2866756E6374696F6E2865297B72657475726E2065262621214D2865292E74726967676572656442794576656E747D2928742926267A28692C7B7374726F6B654461736861727261';
wwv_flow_imp.g_varchar2_table(268) := '793A22302C20352E35222C7374726F6B6557696474683A322E357D293B76617220723D442874293B72657475726E204C28652C742C723F2263656E7465722D746F70223A2263656E7465722D6D6964646C65222C6E292C5428652C742C723F766F696420';
wwv_flow_imp.g_varchar2_table(269) := '303A5B2253756250726F636573734D61726B6572225D2C6E292C697D66756E6374696F6E205928652C742C6E3D7B7D297B76617220693D5628652C742C6E293B72657475726E204C28652C742C2263656E7465722D6D6964646C65222C6E292C5428652C';
wwv_flow_imp.g_varchar2_table(270) := '742C766F696420302C6E292C697D766172205A3D746869732E68616E646C6572733D7B2262706D6E3A4164486F6353756250726F63657373223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E207128652C742C6E3D442874293F757428';
wwv_flow_imp.g_varchar2_table(271) := '6E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D293A7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A4173736F63696174696F6E223A66756E6374696F6E28652C742C6E3D7B7D';
wwv_flow_imp.g_varchar2_table(272) := '297B72657475726E202428652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A426F756E646172794576656E74223A66756E6374696F6E28652C742C6E3D7B7D297B7661727B72656E64657249636F6E3A693D';
wwv_flow_imp.g_varchar2_table(273) := '21307D3D6E3B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220723D4D2874292E676574282263616E63656C416374697669747922293B6E3D7B7374726F6B6557696474683A312E352C66696C6C3A786528742C732C6E2E6669';
wwv_flow_imp.g_varchar2_table(274) := '6C6C292C66696C6C4F7061636974793A312C7374726F6B653A776528742C632C6E2E7374726F6B65297D2C727C7C286E2E7374726F6B654461736861727261793D223622293B766172206F3D4828652C742C6E293B72657475726E207928652C742E7769';
wwv_flow_imp.g_varchar2_table(275) := '6474682C742E6865696768742C332C7B2E2E2E6E2C66696C6C3A226E6F6E65227D292C6926264128742C652C6E292C6F7D2C2262706D6E3A427573696E65737352756C655461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D59';
wwv_flow_imp.g_varchar2_table(276) := '28652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207A287828652C692E6765745363616C65645061746828225441534B5F545950455F425553494E4553535F52554C455F4D41494E222C7B616273706F733A';
wwv_flow_imp.g_varchar2_table(277) := '7B783A382C793A387D7D29292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C7A287828652C692E6765745363616C6564506174682822544153';
wwv_flow_imp.g_varchar2_table(278) := '4B5F545950455F425553494E4553535F52554C455F484541444552222C7B616273706F733A7B783A382C793A387D7D29292C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C737472';
wwv_flow_imp.g_varchar2_table(279) := '6F6B6557696474683A317D292C727D2C2262706D6E3A43616C6C4163746976697479223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65225D292C7128652C742C7B7374726F6B';
wwv_flow_imp.g_varchar2_table(280) := '6557696474683A352C2E2E2E6E7D297D2C2262706D6E3A436F6D706C657847617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D4B28652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B726574';
wwv_flow_imp.g_varchar2_table(281) := '75726E207828652C692E6765745363616C6564506174682822474154455741595F434F4D504C4558222C7B785363616C65466163746F723A2E352C795363616C65466163746F723A2E352C636F6E7461696E657257696474683A742E77696474682C636F';
wwv_flow_imp.g_varchar2_table(282) := '6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E34362C6D793A2E32367D7D292C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C737472';
wwv_flow_imp.g_varchar2_table(283) := '6F6B6557696474683A317D292C727D2C2262706D6E3A44617461496E707574223A66756E6374696F6E28652C742C6E3D7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220723D692E6765745261775061746828224441';
wwv_flow_imp.g_varchar2_table(284) := '54415F4152524F5722292C6F3D5728652C742C6E293B72657475726E207828652C722C7B66696C6C3A226E6F6E65222C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C6F7D2C2262706D6E3A446174';
wwv_flow_imp.g_varchar2_table(285) := '61496E7075744173736F63696174696F6E223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65225D292C2428652C742C7B2E2E2E6E2C6D61726B6572456E643A6D28652C226173';
wwv_flow_imp.g_varchar2_table(286) := '736F63696174696F6E2D656E64222C786528742C732C6E2E66696C6C292C776528742C632C6E2E7374726F6B6529297D297D2C2262706D6E3A446174614F626A656374223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E205728652C74';
wwv_flow_imp.g_varchar2_table(287) := '2C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A446174614F626A6563745265666572656E6365223A45282262706D6E3A446174614F626A65637422292C2262706D6E3A446174614F7574707574223A66756E6374';
wwv_flow_imp.g_varchar2_table(288) := '696F6E28652C742C6E3D7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220723D692E676574526177506174682822444154415F4152524F5722292C6F3D5728652C742C6E293B72657475726E207828652C722C7B7374';
wwv_flow_imp.g_varchar2_table(289) := '726F6B6557696474683A312C66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65297D292C6F7D2C2262706D6E3A446174614F75747075744173736F63696174696F6E223A66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(290) := '2C742C6E3D7B7D297B72657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65225D292C2428652C742C7B2E2E2E6E2C6D61726B6572456E643A6D28652C226173736F63696174696F6E2D656E64222C786528742C732C6E2E66696C6C29';
wwv_flow_imp.g_varchar2_table(291) := '2C776528742C632C6E2E7374726F6B6529297D297D2C2262706D6E3A4461746153746F72655265666572656E6365223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65225D292C';
wwv_flow_imp.g_varchar2_table(292) := '7828652C692E6765745363616C6564506174682822444154415F53544F5245222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E657248656967';
wwv_flow_imp.g_varchar2_table(293) := '68743A742E6865696768742C706F736974696F6E3A7B6D783A302C6D793A2E3133337D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C66696C6C4F7061636974793A63742C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374';
wwv_flow_imp.g_varchar2_table(294) := '726F6B6557696474683A327D297D2C2262706D6E3A456E644576656E74223A66756E6374696F6E28652C742C6E3D7B7D297B7661727B72656E64657249636F6E3A693D21307D3D6E3B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76';
wwv_flow_imp.g_varchar2_table(295) := '617220723D4828652C742C7B2E2E2E6E2C7374726F6B6557696474683A347D293B72657475726E206926264128742C652C6E292C727D2C2262706D6E3A4576656E74426173656447617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B6E';
wwv_flow_imp.g_varchar2_table(296) := '3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220723D4D2874292C6F3D4B28652C742C6E293B7928652C742E77696474682C742E6865696768742C2E322A742E6865696768742C7B66696C6C3A786528742C226E6F6E65222C6E2E';
wwv_flow_imp.g_varchar2_table(297) := '66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D293B76617220613D722E67657428226576656E74476174657761795479706522292C733D2121722E6765742822696E7374616E7469617465';
wwv_flow_imp.g_varchar2_table(298) := '22293B69662822506172616C6C656C223D3D3D61297B766172206C3D692E6765745363616C6564506174682822474154455741595F504152414C4C454C222C7B785363616C65466163746F723A2E342C795363616C65466163746F723A2E342C636F6E74';
wwv_flow_imp.g_varchar2_table(299) := '61696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E3437342C6D793A2E3239367D7D293B7828652C6C2C7B66696C6C3A226E6F6E65222C7374726F6B653A77';
wwv_flow_imp.g_varchar2_table(300) := '6528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D297D656C7365224578636C7573697665223D3D3D61262628737C7C7928652C742E77696474682C742E6865696768742C2E32362A742E6865696768742C7B66696C6C3A226E6F';
wwv_flow_imp.g_varchar2_table(301) := '6E65222C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C66756E6374696F6E28297B76617220723D692E6765745363616C6564506174682822474154455741595F4556454E545F4241534544222C7B';
wwv_flow_imp.g_varchar2_table(302) := '785363616C65466163746F723A2E31382C795363616C65466163746F723A2E31382C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E33362C6D';
wwv_flow_imp.g_varchar2_table(303) := '793A2E34347D7D293B7828652C722C7B66696C6C3A226E6F6E65222C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A327D297D2829293B72657475726E206F7D2C2262706D6E3A4578636C7573697665476174';
wwv_flow_imp.g_varchar2_table(304) := '65776179223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D4B28652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29292C6F3D692E6765745363616C6564506174682822474154455741595F4558434C5553495645';
wwv_flow_imp.g_varchar2_table(305) := '222C7B785363616C65466163746F723A2E342C795363616C65466163746F723A2E342C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E33322C';
wwv_flow_imp.g_varchar2_table(306) := '6D793A2E337D7D293B72657475726E20502874292E676574282269734D61726B657256697369626C65222926267828652C6F2C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374';
wwv_flow_imp.g_varchar2_table(307) := '726F6B6557696474683A317D292C727D2C2262706D6E3A47617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E204B28652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A4772';
wwv_flow_imp.g_varchar2_table(308) := '6F7570223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D292C6728652C742E77696474682C742E6865696768742C31302C7B73';
wwv_flow_imp.g_varchar2_table(309) := '74726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A312E352C7374726F6B654461736861727261793A2231302C20362C20302C2036222C66696C6C3A226E6F6E65222C706F696E7465724576656E74733A226E6F6E65';
wwv_flow_imp.g_varchar2_table(310) := '222C77696474683A536528742C6E292C6865696768743A416528742C6E297D297D2C2262706D6E3A496E636C757369766547617465776179223A66756E6374696F6E28652C742C6E3D7B7D297B76617220693D4B28652C742C6E3D7574286E2C5B226669';
wwv_flow_imp.g_varchar2_table(311) := '6C6C222C227374726F6B65225D29293B72657475726E207928652C742E77696474682C742E6865696768742C2E32342A742E6865696768742C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65';
wwv_flow_imp.g_varchar2_table(312) := '292C7374726F6B6557696474683A322E357D292C697D2C2262706D6E3A496E7465726D6564696174654576656E74223A66756E6374696F6E28652C742C6E3D7B7D297B7661727B72656E64657249636F6E3A693D21307D3D6E3B6E3D7574286E2C5B2266';
wwv_flow_imp.g_varchar2_table(313) := '696C6C222C227374726F6B65225D293B76617220723D4828652C742C7B2E2E2E6E2C7374726F6B6557696474683A312E357D293B72657475726E207928652C742E77696474682C742E6865696768742C332C7B66696C6C3A226E6F6E65222C7374726F6B';
wwv_flow_imp.g_varchar2_table(314) := '653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A312E357D292C6926264128742C652C6E292C727D2C2262706D6E3A496E7465726D65646961746543617463684576656E74223A45282262706D6E3A496E7465726D65646961';
wwv_flow_imp.g_varchar2_table(315) := '74654576656E7422292C2262706D6E3A496E7465726D6564696174655468726F774576656E74223A45282262706D6E3A496E7465726D6564696174654576656E7422292C2262706D6E3A4C616E65223A66756E6374696F6E28652C742C6E3D7B7D297B72';
wwv_flow_imp.g_varchar2_table(316) := '657475726E206E3D7574286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D292C5528652C742C7B2E2E2E6E2C66696C6C4F7061636974793A2E32357D297D2C2262706D6E3A4D616E75616C5461736B223A6675';
wwv_flow_imp.g_varchar2_table(317) := '6E6374696F6E28652C742C6E3D7B7D297B76617220723D5928652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207828652C692E6765745363616C65645061746828225441534B5F545950455F4D414E55414C';
wwv_flow_imp.g_varchar2_table(318) := '222C7B616273706F733A7B783A31372C793A31357D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A2E357D292C727D2C2262706D6E3A4D65737361';
wwv_flow_imp.g_varchar2_table(319) := '6765466C6F77223A66756E6374696F6E28652C742C6E3D7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220723D4D2874292C6F3D502874292C613D786528742C732C6E2E66696C6C292C6C3D776528742C632C6E2E73';
wwv_flow_imp.g_varchar2_table(320) := '74726F6B65292C703D6228652C742E776179706F696E74732C7B6D61726B6572456E643A6D28652C226D657373616765666C6F772D656E64222C612C6C292C6D61726B657253746172743A6D28652C226D657373616765666C6F772D7374617274222C61';
wwv_flow_imp.g_varchar2_table(321) := '2C6C292C7374726F6B653A6C2C7374726F6B654461736861727261793A2231302C203131222C7374726F6B6557696474683A312E357D293B696628722E67657428226D6573736167655265662229297B76617220753D702E676574506F696E7441744C65';
wwv_flow_imp.g_varchar2_table(322) := '6E67746828702E676574546F74616C4C656E67746828292F32292C683D692E6765745363616C65645061746828224D4553534147455F464C4F575F4D41524B4552222C7B616273706F733A7B783A752E782C793A752E797D7D292C643D7B7374726F6B65';
wwv_flow_imp.g_varchar2_table(323) := '57696474683A317D3B22696E6974696174696E67223D3D3D6F2E67657428226D65737361676556697369626C654B696E6422293F28642E66696C6C3D612C642E7374726F6B653D6C293A28642E66696C6C3D6C2C642E7374726F6B653D61293B76617220';
wwv_flow_imp.g_varchar2_table(324) := '663D7828652C682C64292C793D4E28652C722E67657428226D65737361676552656622292E67657428226E616D6522292C7B616C69676E3A2263656E7465722D746F70222C666974426F783A21302C7374796C653A7B66696C6C3A6C7D7D292C673D662E';
wwv_flow_imp.g_varchar2_table(325) := '67657442426F7828292C763D792E67657442426F7828293B6E7428792C752E782D762E77696474682F322C752E792B672E6865696768742F322B31302C30297D72657475726E20707D2C2262706D6E3A506172616C6C656C47617465776179223A66756E';
wwv_flow_imp.g_varchar2_table(326) := '6374696F6E28652C742C6E3D7B7D297B76617220723D4B28652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207828652C692E6765745363616C6564506174682822474154455741595F504152414C4C454C22';
wwv_flow_imp.g_varchar2_table(327) := '2C7B785363616C65466163746F723A2E362C795363616C65466163746F723A2E362C636F6E7461696E657257696474683A742E77696474682C636F6E7461696E65724865696768743A742E6865696768742C706F736974696F6E3A7B6D783A2E34362C6D';
wwv_flow_imp.g_varchar2_table(328) := '793A2E327D7D292C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C727D2C2262706D6E3A5061727469636970616E74223A66756E6374696F';
wwv_flow_imp.g_varchar2_table(329) := '6E28652C742C6E3D7B7D297B76617220693D5528652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D29292C723D442874292C6F3D422874292C613D4D2874292C733D612E67657428226E61';
wwv_flow_imp.g_varchar2_table(330) := '6D6522293B69662872297628652C6F3F5B7B783A33302C793A307D2C7B783A33302C793A416528742C6E297D5D3A5B7B783A302C793A33307D2C7B783A536528742C6E292C793A33307D5D2C7B7374726F6B653A776528742C632C6E2E7374726F6B6529';
wwv_flow_imp.g_varchar2_table(331) := '2C7374726F6B6557696474683A312E357D292C4628652C732C742C6E293B656C73657B766172206C3D456528742C6E293B6F7C7C286C2E6865696768743D536528742C6E292C6C2E77696474683D416528742C6E29293B76617220753D4E28652C732C7B';
wwv_flow_imp.g_varchar2_table(332) := '626F783A6C2C616C69676E3A2263656E7465722D6D6964646C65222C7374796C653A7B66696C6C3A5F6528742C702C632C6E2E7374726F6B65297D7D293B6F7C7C6E7428752C302C312A416528742C6E292C323730297D72657475726E20612E67657428';
wwv_flow_imp.g_varchar2_table(333) := '227061727469636970616E744D756C7469706C6963697479222926264F28225061727469636970616E744D756C7469706C69636974794D61726B6572222C652C742C6E292C697D2C2262706D6E3A526563656976655461736B223A66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(334) := '652C742C6E3D7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220722C6F3D4D2874292C613D5928652C742C6E293B72657475726E206F2E6765742822696E7374616E746961746522293F287928652C32382C32382C34';
wwv_flow_imp.g_varchar2_table(335) := '2E342C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C723D692E6765745363616C65645061746828225441534B5F545950455F494E5354414E54';
wwv_flow_imp.g_varchar2_table(336) := '494154494E475F53454E44222C7B616273706F733A7B783A372E37372C793A392E35327D7D29293A723D692E6765745363616C65645061746828225441534B5F545950455F53454E44222C7B785363616C65466163746F723A2E392C795363616C654661';
wwv_flow_imp.g_varchar2_table(337) := '63746F723A2E392C636F6E7461696E657257696474683A32312C636F6E7461696E65724865696768743A31342C706F736974696F6E3A7B6D783A2E332C6D793A2E347D7D292C7828652C722C7B66696C6C3A786528742C732C6E2E66696C6C292C737472';
wwv_flow_imp.g_varchar2_table(338) := '6F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C617D2C2262706D6E3A5363726970745461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D5928652C742C6E3D7574286E2C5B226669';
wwv_flow_imp.g_varchar2_table(339) := '6C6C222C227374726F6B65225D29293B72657475726E207828652C692E6765745363616C65645061746828225441534B5F545950455F534352495054222C7B616273706F733A7B783A31352C793A32307D7D292C7B66696C6C3A786528742C732C6E2E66';
wwv_flow_imp.g_varchar2_table(340) := '696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C727D2C2262706D6E3A53656E645461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D5928652C742C6E3D757428';
wwv_flow_imp.g_varchar2_table(341) := '6E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207828652C692E6765745363616C65645061746828225441534B5F545950455F53454E44222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E';
wwv_flow_imp.g_varchar2_table(342) := '7461696E657257696474683A32312C636F6E7461696E65724865696768743A31342C706F736974696F6E3A7B6D783A2E3238352C6D793A2E3335377D7D292C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A786528742C732C';
wwv_flow_imp.g_varchar2_table(343) := '6E2E66696C6C292C7374726F6B6557696474683A317D292C727D2C2262706D6E3A53657175656E6365466C6F77223A66756E6374696F6E28652C742C6E3D7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D293B76617220693D7865';
wwv_flow_imp.g_varchar2_table(344) := '28742C732C6E2E66696C6C292C723D776528742C632C6E2E7374726F6B65292C6F3D6228652C742E776179706F696E74732C7B6D61726B6572456E643A6D28652C2273657175656E6365666C6F772D656E64222C692C72292C7374726F6B653A727D292C';
wwv_flow_imp.g_varchar2_table(345) := '613D4D2874292C7B736F757263653A6C7D3D743B6966286C297B76617220703D4D286C293B612E6765742822636F6E646974696F6E45787072657373696F6E222926266B28702C2262706D6E3A4163746976697479222926267A286F2C7B6D61726B6572';
wwv_flow_imp.g_varchar2_table(346) := '53746172743A6D28652C22636F6E646974696F6E616C2D666C6F772D6D61726B6572222C692C72297D292C702E676574282264656661756C7422292626286B28702C2262706D6E3A4761746577617922297C7C6B28702C2262706D6E3A41637469766974';
wwv_flow_imp.g_varchar2_table(347) := '792229292626702E676574282264656661756C7422293D3D3D6126267A286F2C7B6D61726B657253746172743A6D28652C22636F6E646974696F6E616C2D64656661756C742D666C6F772D6D61726B6572222C692C72297D297D72657475726E206F7D2C';
wwv_flow_imp.g_varchar2_table(348) := '2262706D6E3A536572766963655461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D5928652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207928652C31302C31302C7B66696C6C3A';
wwv_flow_imp.g_varchar2_table(349) := '786528742C732C6E2E66696C6C292C7374726F6B653A226E6F6E65222C7472616E73666F726D3A227472616E736C61746528362C203629227D292C7828652C692E6765745363616C65645061746828225441534B5F545950455F53455256494345222C7B';
wwv_flow_imp.g_varchar2_table(350) := '616273706F733A7B783A31322C793A31387D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C7928652C31302C31302C7B66696C6C3A7865';
wwv_flow_imp.g_varchar2_table(351) := '28742C732C6E2E66696C6C292C7374726F6B653A226E6F6E65222C7472616E73666F726D3A227472616E736C6174652831312C20313029227D292C7828652C692E6765745363616C65645061746828225441534B5F545950455F53455256494345222C7B';
wwv_flow_imp.g_varchar2_table(352) := '616273706F733A7B783A31372C793A32327D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A317D292C727D2C2262706D6E3A53746172744576656E';
wwv_flow_imp.g_varchar2_table(353) := '74223A66756E6374696F6E28652C742C6E3D7B7D297B7661727B72656E64657249636F6E3A693D21307D3D6E3B6E3D7574286E2C5B2266696C6C222C227374726F6B65225D292C4D2874292E67657428226973496E74657272757074696E6722297C7C28';
wwv_flow_imp.g_varchar2_table(354) := '6E3D7B2E2E2E6E2C7374726F6B654461736861727261793A2236227D293B76617220723D4828652C742C6E293B72657475726E206926264128742C652C6E292C727D2C2262706D6E3A53756250726F63657373223A66756E6374696F6E28652C742C6E3D';
wwv_flow_imp.g_varchar2_table(355) := '7B7D297B72657475726E207128652C742C6E3D442874293F7574286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D293A7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A546173';
wwv_flow_imp.g_varchar2_table(356) := '6B223A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E205928652C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29297D2C2262706D6E3A54657874416E6E6F746174696F6E223A66756E6374696F6E28652C742C6E3D';
wwv_flow_imp.g_varchar2_table(357) := '7B7D297B6E3D7574286E2C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D293B7661727B77696474683A722C6865696768743A6F7D3D456528742C6E292C613D6728652C722C6F2C302C302C7B66696C6C3A226E6F';
wwv_flow_imp.g_varchar2_table(358) := '6E65222C7374726F6B653A226E6F6E65227D293B72657475726E207828652C692E6765745363616C6564506174682822544558545F414E4E4F544154494F4E222C7B785363616C65466163746F723A312C795363616C65466163746F723A312C636F6E74';
wwv_flow_imp.g_varchar2_table(359) := '61696E657257696474683A722C636F6E7461696E65724865696768743A6F2C706F736974696F6E3A7B6D783A302C6D793A307D7D292C7B7374726F6B653A776528742C632C6E2E7374726F6B65297D292C4E28652C4D2874292E67657428227465787422';
wwv_flow_imp.g_varchar2_table(360) := '297C7C22222C7B616C69676E3A226C6566742D746F70222C626F783A456528742C6E292C70616464696E673A372C7374796C653A7B66696C6C3A5F6528742C702C632C6E2E7374726F6B65297D7D292C617D2C2262706D6E3A5472616E73616374696F6E';
wwv_flow_imp.g_varchar2_table(361) := '223A66756E6374696F6E28652C742C693D7B7D297B693D442874293F757428692C5B2266696C6C222C227374726F6B65222C227769647468222C22686569676874225D293A757428692C5B2266696C6C222C227374726F6B65225D293B76617220723D71';
wwv_flow_imp.g_varchar2_table(362) := '28652C742C7B7374726F6B6557696474683A312E352C2E2E2E697D292C6F3D6E2E7374796C65285B226E6F2D66696C6C222C226E6F2D6576656E7473225D2C7B7374726F6B653A776528742C632C692E7374726F6B65292C7374726F6B6557696474683A';
wwv_flow_imp.g_varchar2_table(363) := '312E357D293B72657475726E20442874297C7C28693D7B7D292C6728652C536528742C69292C416528742C69292C372C332C6F292C727D2C2262706D6E3A557365725461736B223A66756E6374696F6E28652C742C6E3D7B7D297B76617220723D592865';
wwv_flow_imp.g_varchar2_table(364) := '2C742C6E3D7574286E2C5B2266696C6C222C227374726F6B65225D29293B72657475726E207828652C692E6765745363616C65645061746828225441534B5F545950455F555345525F31222C7B616273706F733A7B783A31352C793A31327D7D292C7B66';
wwv_flow_imp.g_varchar2_table(365) := '696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A2E357D292C7828652C692E6765745363616C65645061746828225441534B5F545950455F555345525F32222C7B';
wwv_flow_imp.g_varchar2_table(366) := '616273706F733A7B783A31352C793A31327D7D292C7B66696C6C3A786528742C732C6E2E66696C6C292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B6557696474683A2E357D292C7828652C692E6765745363616C65645061';
wwv_flow_imp.g_varchar2_table(367) := '746828225441534B5F545950455F555345525F33222C7B616273706F733A7B783A31352C793A31327D7D292C7B66696C6C3A776528742C632C6E2E7374726F6B65292C7374726F6B653A776528742C632C6E2E7374726F6B65292C7374726F6B65576964';
wwv_flow_imp.g_varchar2_table(368) := '74683A2E357D292C727D2C6C6162656C3A66756E6374696F6E28652C742C6E3D7B7D297B72657475726E2066756E6374696F6E28652C742C6E3D7B7D297B76617220693D7B77696474683A39302C6865696768743A33302C783A742E77696474682F322B';
wwv_flow_imp.g_varchar2_table(369) := '742E782C793A742E6865696768742F322B742E797D3B72657475726E204E28652C492874292C7B626F783A692C666974426F783A21302C7374796C653A53287B7D2C6F2E67657445787465726E616C5374796C6528292C7B66696C6C3A5F6528742C702C';
wwv_flow_imp.g_varchar2_table(370) := '632C6E2E7374726F6B65297D297D297D28652C742C6E297D7D3B746869732E5F64726177506174683D782C746869732E5F72656E64657265723D5F7D66756E6374696F6E20757428652C743D5B5D297B72657475726E20742E726564756365282828742C';
wwv_flow_imp.g_varchar2_table(371) := '6E293D3E28655B6E5D262628745B6E5D3D655B6E5D292C7429292C7B7D297D6E2870742C43292C70742E24696E6A6563743D5B22636F6E6669672E62706D6E52656E6465726572222C226576656E74427573222C227374796C6573222C22706174684D61';
wwv_flow_imp.g_varchar2_table(372) := '70222C2263616E766173222C227465787452656E6465726572225D2C70742E70726F746F747970652E63616E52656E6465723D66756E6374696F6E2865297B72657475726E206B28652C2262706D6E3A42617365456C656D656E7422297D2C70742E7072';
wwv_flow_imp.g_varchar2_table(373) := '6F746F747970652E6472617753686170653D66756E6374696F6E28652C742C6E3D7B7D297B7661727B747970653A697D3D743B72657475726E20746869732E5F72656E646572657228692928652C742C6E297D2C70742E70726F746F747970652E647261';
wwv_flow_imp.g_varchar2_table(374) := '77436F6E6E656374696F6E3D66756E6374696F6E28652C742C6E3D7B7D297B7661727B747970653A697D3D743B72657475726E20746869732E5F72656E646572657228692928652C742C6E297D2C70742E70726F746F747970652E676574536861706550';
wwv_flow_imp.g_varchar2_table(375) := '6174683D66756E6374696F6E2865297B72657475726E206B28652C2262706D6E3A4576656E7422293F7065285B5B224D222C28743D65292E782B742E77696474682F322C742E792B742E6865696768742F325D2C5B226D222C302C2D286E3D742E776964';
wwv_flow_imp.g_varchar2_table(376) := '74682F32295D2C5B2261222C6E2C6E2C302C312C312C302C322A6E5D2C5B2261222C6E2C6E2C302C312C312C302C2D322A6E5D2C5B227A225D5D293A6B28652C2262706D6E3A416374697669747922293F66756E6374696F6E28652C74297B766172206E';
wwv_flow_imp.g_varchar2_table(377) := '3D652E782C693D652E792C723D652E77696474682C6F3D652E6865696768743B72657475726E207065285B5B224D222C6E2B742C695D2C5B226C222C722D32302C305D2C5B2261222C742C742C302C302C312C742C745D2C5B226C222C302C6F2D32305D';
wwv_flow_imp.g_varchar2_table(378) := '2C5B2261222C742C742C302C302C312C2D31302C745D2C5B226C222C32302D722C305D2C5B2261222C742C742C302C302C312C2D31302C2D31305D2C5B226C222C302C32302D6F5D2C5B2261222C742C742C302C302C312C742C2D31305D2C5B227A225D';
wwv_flow_imp.g_varchar2_table(379) := '5D297D28652C3130293A6B28652C2262706D6E3A4761746577617922293F66756E6374696F6E2865297B76617220743D652E77696474682F322C6E3D652E6865696768742F323B72657475726E207065285B5B224D222C652E782B742C652E795D2C5B22';
wwv_flow_imp.g_varchar2_table(380) := '6C222C742C6E5D2C5B226C222C2D742C6E5D2C5B226C222C2D742C2D6E5D2C5B227A225D5D297D2865293A66756E6374696F6E2865297B76617220743D652E782C6E3D652E792C693D652E77696474683B72657475726E207065285B5B224D222C742C6E';
wwv_flow_imp.g_varchar2_table(381) := '5D2C5B226C222C692C305D2C5B226C222C302C652E6865696768745D2C5B226C222C2D692C305D2C5B227A225D5D297D2865293B76617220742C6E7D3B7661722068743D302C64743D7B77696474683A3135302C6865696768743A35307D3B66756E6374';
wwv_flow_imp.g_varchar2_table(382) := '696F6E206D7428652C74297B766172206E3B742E74657874436F6E74656E743D653B7472797B76617220692C723D22223D3D3D653B72657475726E20742E74657874436F6E74656E743D723F2264756D6D79223A652C693D7B77696474683A286E3D742E';
wwv_flow_imp.g_varchar2_table(383) := '67657442426F782829292E77696474682B322A6E2E782C6865696768743A6E2E6865696768747D2C72262628692E77696474683D30292C697D63617463682865297B72657475726E7B77696474683A302C6865696768743A307D7D7D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(384) := '20667428652C742C6E297B666F722876617220692C723D652E736869667428292C6F3D723B3B297B69662828693D6D74286F2C6E29292E77696474683D6F3F692E77696474683A302C2220223D3D3D6F7C7C22223D3D3D6F7C7C692E77696474683C4D61';
wwv_flow_imp.g_varchar2_table(385) := '74682E726F756E642874297C7C6F2E6C656E6774683C322972657475726E20797428652C6F2C722C69293B6F3D7674286F2C692E77696474682C74297D7D66756E6374696F6E20797428652C742C6E2C69297B696628742E6C656E6774683C6E2E6C656E';
wwv_flow_imp.g_varchar2_table(386) := '677468297B76617220723D6E2E736C69636528742E6C656E677468292E7472696D28293B652E756E73686966742872297D72657475726E7B77696474683A692E77696474682C6865696768743A692E6865696768742C746578743A747D7D766172206774';
wwv_flow_imp.g_varchar2_table(387) := '3D22C2AD223B66756E6374696F6E20767428652C742C6E297B76617220693D4D6174682E6D617828652E6C656E6774682A286E2F74292C31292C723D66756E6374696F6E28652C74297B766172206E2C693D652E73706C6974282F285C737C2D7C5C7530';
wwv_flow_imp.g_varchar2_table(388) := '304144292F67292C723D5B5D2C6F3D303B696628692E6C656E6774683E3129666F72283B6E3D692E736869667428293B297B69662821286E2E6C656E6774682B6F3C7429297B222D22213D3D6E26266E213D3D67747C7C722E706F7028293B627265616B';
wwv_flow_imp.g_varchar2_table(389) := '7D722E70757368286E292C6F2B3D6E2E6C656E6774687D76617220613D725B722E6C656E6774682D315D3B72657475726E20612626613D3D3D6774262628725B722E6C656E6774682D315D3D222D22292C722E6A6F696E282222297D28652C69293B7265';
wwv_flow_imp.g_varchar2_table(390) := '7475726E20727C7C28723D652E736C69636528302C4D6174682E6D6178284D6174682E726F756E6428692D31292C312929292C727D66756E6374696F6E2062742865297B746869732E5F636F6E6669673D53287B7D2C7B73697A653A64742C7061646469';
wwv_flow_imp.g_varchar2_table(391) := '6E673A68742C7374796C653A7B7D2C616C69676E3A2263656E7465722D746F70227D2C657C7C7B7D297D66756E6374696F6E2078742865297B76617220743D53287B666F6E7446616D696C793A22417269616C2C2073616E732D7365726966222C666F6E';
wwv_flow_imp.g_varchar2_table(392) := '7453697A653A31322C666F6E745765696768743A226E6F726D616C222C6C696E654865696768743A312E327D2C652626652E64656661756C745374796C657C7C7B7D292C6E3D7061727365496E7428742E666F6E7453697A652C3130292D312C693D5328';
wwv_flow_imp.g_varchar2_table(393) := '7B7D2C742C7B666F6E7453697A653A6E7D2C652626652E65787465726E616C5374796C657C7C7B7D292C723D6E6577206274287B7374796C653A747D293B746869732E67657445787465726E616C4C6162656C426F756E64733D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(394) := '2C74297B766172206E3D722E67657444696D656E73696F6E7328742C7B626F783A7B77696474683A39302C6865696768743A33307D2C7374796C653A697D293B72657475726E7B783A4D6174682E726F756E6428652E782B652E77696474682F322D6E2E';
wwv_flow_imp.g_varchar2_table(395) := '77696474682F32292C793A4D6174682E726F756E6428652E79292C77696474683A4D6174682E6365696C286E2E7769647468292C6865696768743A4D6174682E6365696C286E2E686569676874297D7D2C746869732E67657454657874416E6E6F746174';
wwv_flow_imp.g_varchar2_table(396) := '696F6E426F756E64733D66756E6374696F6E28652C6E297B76617220693D722E67657444696D656E73696F6E73286E2C7B626F783A652C7374796C653A742C616C69676E3A226C6566742D746F70222C70616464696E673A357D293B72657475726E7B78';
wwv_flow_imp.g_varchar2_table(397) := '3A652E782C793A652E792C77696474683A652E77696474682C6865696768743A4D6174682E6D61782833302C4D6174682E726F756E6428692E68656967687429297D7D2C746869732E637265617465546578743D66756E6374696F6E28652C74297B7265';
wwv_flow_imp.g_varchar2_table(398) := '7475726E20722E6372656174655465787428652C747C7C7B7D297D2C746869732E67657444656661756C745374796C653D66756E6374696F6E28297B72657475726E20747D2C746869732E67657445787465726E616C5374796C653D66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(399) := '28297B72657475726E20697D7D62742E70726F746F747970652E637265617465546578743D66756E6374696F6E28652C74297B72657475726E20746869732E6C61796F75745465787428652C74292E656C656D656E747D2C62742E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(400) := '2E67657444696D656E73696F6E733D66756E6374696F6E28652C74297B72657475726E20746869732E6C61796F75745465787428652C74292E64696D656E73696F6E737D2C62742E70726F746F747970652E6C61796F7574546578743D66756E6374696F';
wwv_flow_imp.g_varchar2_table(401) := '6E28652C74297B766172206E2C693D53287B7D2C746869732E5F636F6E6669672E73697A652C742E626F78292C723D53287B7D2C746869732E5F636F6E6669672E7374796C652C742E7374796C65292C6F3D66756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(402) := '652E73706C697428222D22293B72657475726E7B686F72697A6F6E74616C3A745B305D7C7C2263656E746572222C766572746963616C3A745B315D7C7C22746F70227D7D28742E616C69676E7C7C746869732E5F636F6E6669672E616C69676E292C613D';
wwv_flow_imp.g_varchar2_table(403) := '66756E6374696F6E2865297B72657475726E206C2865293F53287B746F703A302C6C6566743A302C72696768743A302C626F74746F6D3A307D2C65293A7B746F703A652C6C6566743A652C72696768743A652C626F74746F6D3A657D7D28766F69642030';
wwv_flow_imp.g_varchar2_table(404) := '213D3D742E70616464696E673F742E70616464696E673A746869732E5F636F6E6669672E70616464696E67292C733D742E666974426F787C7C21312C633D66756E6374696F6E2865297B69662822666F6E7453697A6522696E20652626226C696E654865';
wwv_flow_imp.g_varchar2_table(405) := '6967687422696E20652972657475726E20652E6C696E654865696768742A7061727365496E7428652E666F6E7453697A652C3130297D2872292C703D652E73706C6974282F5C75303041443F5C723F5C6E2F292C753D5B5D2C683D692E77696474682D61';
wwv_flow_imp.g_varchar2_table(406) := '2E6C6566742D612E72696768742C643D5828227465787422293B666F72287A28642C7B783A302C793A307D292C7A28642C72292C6A28286E3D766F696420302C286E3D646F63756D656E742E676574456C656D656E7442794964282268656C7065722D73';
wwv_flow_imp.g_varchar2_table(407) := '76672229297C7C287A286E3D58282273766722292C7B69643A2268656C7065722D737667227D292C4F65286E2C7B7669736962696C6974793A2268696464656E222C706F736974696F6E3A226669786564222C77696474683A302C6865696768743A307D';
wwv_flow_imp.g_varchar2_table(408) := '292C646F63756D656E742E626F64792E617070656E644368696C64286E29292C6E292C64293B702E6C656E6774683B29752E7075736828667428702C682C6429293B226D6964646C65223D3D3D6F2E766572746963616C262628612E746F703D612E626F';
wwv_flow_imp.g_varchar2_table(409) := '74746F6D3D30293B766172206D3D7928752C2866756E6374696F6E28652C742C6E297B72657475726E20652B28637C7C742E686569676874297D292C30292B612E746F702B612E626F74746F6D2C673D7928752C2866756E6374696F6E28652C742C6E29';
wwv_flow_imp.g_varchar2_table(410) := '7B72657475726E20742E77696474683E653F742E77696474683A657D292C30292C763D612E746F703B226D6964646C65223D3D3D6F2E766572746963616C262628762B3D28692E6865696768742D6D292F32292C762D3D28637C7C755B305D2E68656967';
wwv_flow_imp.g_varchar2_table(411) := '6874292F343B76617220623D5828227465787422293B72657475726E207A28622C72292C6628752C2866756E6374696F6E2865297B76617220743B73776974636828762B3D637C7C652E6865696768742C6F2E686F72697A6F6E74616C297B6361736522';
wwv_flow_imp.g_varchar2_table(412) := '6C656674223A743D612E6C6566743B627265616B3B63617365227269676874223A743D28733F673A68292D612E72696768742D652E77696474683B627265616B3B64656661756C743A743D4D6174682E6D6178282828733F673A68292D652E7769647468';
wwv_flow_imp.g_varchar2_table(413) := '292F322B612E6C6566742C30297D766172206E3D582822747370616E22293B7A286E2C7B783A742C793A767D292C6E2E74657874436F6E74656E743D652E746578742C6A28622C6E297D29292C73652864292C7B64696D656E73696F6E733A7B77696474';
wwv_flow_imp.g_varchar2_table(414) := '683A672C6865696768743A6D7D2C656C656D656E743A627D7D2C78742E24696E6A6563743D5B22636F6E6669672E7465787452656E6465726572225D3B7661722077743D2F5C7B285B5E7B7D5D2B295C7D2F672C5F743D2F283F3A283F3A5E7C5C2E2928';
wwv_flow_imp.g_varchar2_table(415) := '2E2B3F29283F3D5C5B7C5C2E7C247C5C28297C5C5B28277C2229282E2B3F295C325C5D29285C285C29293F2F673B636F6E73742045743D7B5F5F696E69745F5F3A5B2262706D6E52656E6465726572225D2C62706D6E52656E64657265723A5B22747970';
wwv_flow_imp.g_varchar2_table(416) := '65222C70745D2C7465787452656E64657265723A5B2274797065222C78745D2C706174684D61703A5B2274797065222C66756E6374696F6E28297B746869732E706174684D61703D7B4556454E545F4D4553534147453A7B643A226D207B6D787D2C7B6D';
wwv_flow_imp.g_varchar2_table(417) := '797D206C20302C7B652E79317D206C207B652E78317D2C30206C20302C2D7B652E79317D207A206C207B652E78307D2C7B652E79307D206C207B652E78307D2C2D7B652E79307D222C6865696768743A33362C77696474683A33362C686569676874456C';
wwv_flow_imp.g_varchar2_table(418) := '656D656E74733A5B362C31345D2C7769647468456C656D656E74733A5B31302E352C32315D7D2C4556454E545F5349474E414C3A7B643A224D207B6D787D2C7B6D797D206C207B652E78307D2C7B652E79307D206C202D7B652E78317D2C30205A222C68';
wwv_flow_imp.g_varchar2_table(419) := '65696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B31385D2C7769647468456C656D656E74733A5B31302C32305D7D2C4556454E545F455343414C4154494F4E3A7B643A224D207B6D787D2C7B6D797D206C207B652E78';
wwv_flow_imp.g_varchar2_table(420) := '307D2C7B652E79307D206C202D7B652E78307D2C2D7B652E79317D206C202D7B652E78307D2C7B652E79317D205A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B32302C375D2C7769647468456C656D656E';
wwv_flow_imp.g_varchar2_table(421) := '74733A5B385D7D2C4556454E545F434F4E444954494F4E414C3A7B643A224D207B652E78307D2C7B652E79307D206C207B652E78317D2C30206C20302C7B652E79327D206C202D7B652E78317D2C30205A204D207B652E78327D2C7B652E79337D206C20';
wwv_flow_imp.g_varchar2_table(422) := '7B652E78307D2C30204D207B652E78327D2C7B652E79347D206C207B652E78307D2C30204D207B652E78327D2C7B652E79357D206C207B652E78307D2C30204D207B652E78327D2C7B652E79367D206C207B652E78307D2C30204D207B652E78327D2C7B';
wwv_flow_imp.g_varchar2_table(423) := '652E79377D206C207B652E78307D2C30204D207B652E78327D2C7B652E79387D206C207B652E78307D2C3020222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B382E352C31342E352C31382C31312E352C3134';
wwv_flow_imp.g_varchar2_table(424) := '2E352C31372E352C32302E352C32332E352C32362E355D2C7769647468456C656D656E74733A5B31302E352C31342E352C31322E355D7D2C4556454E545F4C494E4B3A7B643A226D207B6D787D2C7B6D797D20302C7B652E79307D202D7B652E78317D2C';
wwv_flow_imp.g_varchar2_table(425) := '3020302C7B652E79317D207B652E78317D2C3020302C7B652E79307D207B652E78307D2C2D7B652E79327D202D7B652E78307D2C2D7B652E79327D207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B342E';
wwv_flow_imp.g_varchar2_table(426) := '343337352C362E37352C372E383132355D2C7769647468456C656D656E74733A5B392E38343337352C31332E355D7D2C4556454E545F4552524F523A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C2D7B652E79307D207B652E78317D2C2D7B';
wwv_flow_imp.g_varchar2_table(427) := '652E79317D207B652E78327D2C7B652E79327D207B652E78337D2C2D7B652E79337D202D7B652E78347D2C7B652E79347D202D7B652E78357D2C2D7B652E79357D207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E';
wwv_flow_imp.g_varchar2_table(428) := '74733A5B2E3032332C382E3733372C382E3135312C31362E3536342C31302E3539312C382E3731345D2C7769647468456C656D656E74733A5B2E3038352C362E3637322C362E39372C342E3237332C352E3333372C362E3633365D7D2C4556454E545F43';
wwv_flow_imp.g_varchar2_table(429) := '414E43454C5F34353A7B643A226D207B6D787D2C7B6D797D202D7B652E78317D2C3020302C7B652E78307D207B652E78317D2C3020302C7B652E79317D207B652E78307D2C3020302C2D7B652E79317D207B652E78317D2C3020302C2D7B652E79307D20';
wwv_flow_imp.g_varchar2_table(430) := '2D7B652E78317D2C3020302C2D7B652E79317D202D7B652E78307D2C30207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B342E37352C382E355D2C7769647468456C656D656E74733A5B342E37352C382E';
wwv_flow_imp.g_varchar2_table(431) := '355D7D2C4556454E545F434F4D50454E534154494F4E3A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C2D7B652E79307D20302C7B652E79317D207A206D207B652E78317D2C2D7B652E79327D207B652E78327D2C2D7B652E79337D20302C7B';
wwv_flow_imp.g_varchar2_table(432) := '652E79317D202D7B652E78327D2C2D7B652E79337D207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B362E352C31332C2E342C362E315D2C7769647468456C656D656E74733A5B392C392E332C382E375D';
wwv_flow_imp.g_varchar2_table(433) := '7D2C4556454E545F54494D45525F57483A7B643A224D207B6D787D2C7B6D797D206C207B652E78307D2C2D7B652E79307D206D202D7B652E78307D2C7B652E79307D206C207B652E78317D2C7B652E79317D20222C6865696768743A33362C7769647468';
wwv_flow_imp.g_varchar2_table(434) := '3A33362C686569676874456C656D656E74733A5B31302C325D2C7769647468456C656D656E74733A5B332C375D7D2C4556454E545F54494D45525F4C494E453A7B643A224D207B6D787D2C7B6D797D206D207B652E78307D2C7B652E79307D206C202D7B';
wwv_flow_imp.g_varchar2_table(435) := '652E78317D2C7B652E79317D20222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B31302C335D2C7769647468456C656D656E74733A5B302C305D7D2C4556454E545F4D554C5449504C453A7B643A226D207B6D';
wwv_flow_imp.g_varchar2_table(436) := '787D2C7B6D797D207B652E78317D2C2D7B652E79307D207B652E78317D2C7B652E79307D202D7B652E78307D2C7B652E79317D202D7B652E78327D2C30207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B';
wwv_flow_imp.g_varchar2_table(437) := '362E32383039392C31322E35363139395D2C7769647468456C656D656E74733A5B332E313430352C392E34323134392C31322E35363139385D7D2C4556454E545F504152414C4C454C5F4D554C5449504C453A7B643A226D207B6D787D2C7B6D797D207B';
wwv_flow_imp.g_varchar2_table(438) := '652E78307D2C3020302C7B652E79317D207B652E78317D2C3020302C7B652E79307D202D7B652E78317D2C3020302C7B652E79317D202D7B652E78307D2C3020302C2D7B652E79317D202D7B652E78317D2C3020302C2D7B652E79307D207B652E78317D';
wwv_flow_imp.g_varchar2_table(439) := '2C30207A222C6865696768743A33362C77696474683A33362C686569676874456C656D656E74733A5B322E35363232382C372E36383638335D2C7769647468456C656D656E74733A5B322E35363232382C372E36383638335D7D2C474154455741595F45';
wwv_flow_imp.g_varchar2_table(440) := '58434C55534956453A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C7B652E79307D207B652E78317D2C7B652E79307D207B652E78327D2C30207B652E78347D2C7B652E79327D207B652E78347D2C7B652E79317D207B652E78327D2C30207B';
wwv_flow_imp.g_varchar2_table(441) := '652E78317D2C7B652E79337D207B652E78307D2C7B652E79337D207B652E78337D2C30207B652E78357D2C7B652E79317D207B652E78357D2C7B652E79327D207B652E78337D2C30207A222C6865696768743A31372E352C77696474683A31372E352C68';
wwv_flow_imp.g_varchar2_table(442) := '6569676874456C656D656E74733A5B382E352C362E353331322C2D362E353331322C2D382E355D2C7769647468456C656D656E74733A5B362E352C2D362E352C332C2D332C352C2D355D7D2C474154455741595F504152414C4C454C3A7B643A226D207B';
wwv_flow_imp.g_varchar2_table(443) := '6D787D2C7B6D797D20302C7B652E79317D202D7B652E78317D2C3020302C7B652E79307D207B652E78317D2C3020302C7B652E79317D207B652E78307D2C3020302C2D7B652E79317D207B652E78317D2C3020302C2D7B652E79307D202D7B652E78317D';
wwv_flow_imp.g_varchar2_table(444) := '2C3020302C2D7B652E79317D202D7B652E78307D2C30207A222C6865696768743A33302C77696474683A33302C686569676874456C656D656E74733A5B352C31322E355D2C7769647468456C656D656E74733A5B352C31322E355D7D2C47415445574159';
wwv_flow_imp.g_varchar2_table(445) := '5F4556454E545F42415345443A7B643A226D207B6D787D2C7B6D797D207B652E78307D2C7B652E79307D207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79327D207B652E78327D2C30207A222C6865696768743A31312C77696474683A31';
wwv_flow_imp.g_varchar2_table(446) := '312C686569676874456C656D656E74733A5B2D362C362C31322C2D31325D2C7769647468456C656D656E74733A5B392C2D332C2D31325D7D2C474154455741595F434F4D504C45583A7B643A226D207B6D787D2C7B6D797D20302C7B652E79307D202D7B';
wwv_flow_imp.g_varchar2_table(447) := '652E78307D2C2D7B652E79317D202D7B652E78317D2C7B652E79327D207B652E78307D2C7B652E79317D202D7B652E78327D2C3020302C7B652E79337D207B652E78327D2C3020202D7B652E78307D2C7B652E79317D206C207B652E78317D2C7B652E79';
wwv_flow_imp.g_varchar2_table(448) := '327D207B652E78307D2C2D7B652E79317D20302C7B652E79307D207B652E78337D2C3020302C2D7B652E79307D207B652E78307D2C7B652E79317D207B652E78317D2C2D7B652E79327D202D7B652E78307D2C2D7B652E79317D207B652E78327D2C3020';
wwv_flow_imp.g_varchar2_table(449) := '302C2D7B652E79337D202D7B652E78327D2C30207B652E78307D2C2D7B652E79317D202D7B652E78317D2C2D7B652E79327D202D7B652E78307D2C7B652E79317D20302C2D7B652E79307D202D7B652E78337D2C30207A222C6865696768743A31372E31';
wwv_flow_imp.g_varchar2_table(450) := '32352C77696474683A31372E3132352C686569676874456C656D656E74733A5B342E3837352C332E343337352C322E3132352C335D2C7769647468456C656D656E74733A5B332E343337352C322E3132352C342E3837352C335D7D2C444154415F4F424A';
wwv_flow_imp.g_varchar2_table(451) := '4543545F504154483A7B643A226D20302C30207B652E78317D2C30207B652E78307D2C7B652E79307D20302C7B652E79317D202D7B652E78327D2C3020302C2D7B652E79327D207B652E78317D2C3020302C7B652E79307D207B652E78307D2C30222C68';
wwv_flow_imp.g_varchar2_table(452) := '65696768743A36312C77696474683A35312C686569676874456C656D656E74733A5B31302C35302C36305D2C7769647468456C656D656E74733A5B31302C34302C35302C36305D7D2C444154415F4F424A4543545F434F4C4C454354494F4E5F50415448';
wwv_flow_imp.g_varchar2_table(453) := '3A7B643A226D7B6D787D2C7B6D797D206D20332C32206C20302C3130206D20332C2D3130206C20302C3130206D20332C2D3130206C20302C3130222C6865696768743A31302C77696474683A31302C686569676874456C656D656E74733A5B5D2C776964';
wwv_flow_imp.g_varchar2_table(454) := '7468456C656D656E74733A5B5D7D2C444154415F4152524F573A7B643A226D20352C3920392C3020302C2D3320352C35202D352C3520302C2D33202D392C30207A222C6865696768743A36312C77696474683A35312C686569676874456C656D656E7473';
wwv_flow_imp.g_varchar2_table(455) := '3A5B5D2C7769647468456C656D656E74733A5B5D7D2C444154415F53544F52453A7B643A226D20207B6D787D2C7B6D797D206C2020302C7B652E79327D206320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D20207B652E78327D';
wwv_flow_imp.g_varchar2_table(456) := '2C30206C2020302C2D7B652E79327D2063202D7B652E78307D2C2D7B652E79317D202D7B652E78317D2C2D7B652E79317D202D7B652E78327D2C306320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D20207B652E78327D2C3020';
wwv_flow_imp.g_varchar2_table(457) := '6D20202D7B652E78327D2C7B652E79307D6320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D207B652E78327D2C306D20202D7B652E78327D2C7B652E79307D6320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E';
wwv_flow_imp.g_varchar2_table(458) := '79317D20207B652E78327D2C30222C6865696768743A36312C77696474683A36312C686569676874456C656D656E74733A5B372C31302C34355D2C7769647468456C656D656E74733A5B322C35382C36305D7D2C544558545F414E4E4F544154494F4E3A';
wwv_flow_imp.g_varchar2_table(459) := '7B643A226D207B6D787D2C207B6D797D206D2031302C30206C202D31302C30206C20302C7B652E79307D206C2031302C30222C6865696768743A33302C77696474683A31302C686569676874456C656D656E74733A5B33305D2C7769647468456C656D65';
wwv_flow_imp.g_varchar2_table(460) := '6E74733A5B31305D7D2C4D41524B45525F5355425F50524F434553533A7B643A226D7B6D787D2C7B6D797D206D20372C32206C20302C3130206D202D352C2D35206C2031302C30222C6865696768743A31302C77696474683A31302C686569676874456C';
wwv_flow_imp.g_varchar2_table(461) := '656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F504152414C4C454C3A7B643A226D7B6D787D2C7B6D797D206D20332C32206C20302C3130206D20332C2D3130206C20302C3130206D20332C2D3130206C20302C31';
wwv_flow_imp.g_varchar2_table(462) := '30222C6865696768743A31302C77696474683A31302C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F53455155454E5449414C3A7B643A226D7B6D787D2C7B6D797D206D20302C33206C2031';
wwv_flow_imp.g_varchar2_table(463) := '302C30206D202D31302C33206C2031302C30206D202D31302C33206C2031302C30222C6865696768743A31302C77696474683A31302C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F434F4D';
wwv_flow_imp.g_varchar2_table(464) := '50454E534154494F4E3A7B643A226D207B6D787D2C7B6D797D20372C2D3520302C3130207A206D20372E312C2D302E3320362E392C2D342E3720302C3130202D362E392C2D342E37207A222C6865696768743A31302C77696474683A32312C6865696768';
wwv_flow_imp.g_varchar2_table(465) := '74456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F4C4F4F503A7B643A226D207B6D787D2C7B6D797D206320332E3532363937392C3020362E3338363136312C2D322E38323938353820362E3338363136312C';
wwv_flow_imp.g_varchar2_table(466) := '2D362E33323036363120302C2D332E343930383036202D322E3835393138322C2D362E333230363631202D362E3338363136312C2D362E333230363631202D332E3532363937382C30202D362E33383631362C322E383239383535202D362E3338363136';
wwv_flow_imp.g_varchar2_table(467) := '2C362E33323036363120302C312E37343534303220302E3731343739372C332E33323535363720312E3837303436332C342E34363933383120302E3537373833342C302E35373139303820312E3236353838352C312E30333437323820322E3032393931';
wwv_flow_imp.g_varchar2_table(468) := '362C312E3335343537206C202D302E3731383136332C2D332E393039373933206D20302E3731383136332C332E393039373933202D332E3838353231312C302E383032393032222C6865696768743A31332E392C77696474683A31332E372C6865696768';
wwv_flow_imp.g_varchar2_table(469) := '74456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C4D41524B45525F4144484F433A7B643A226D207B6D787D2C7B6D797D206D20302E38343436312C322E3634343131206320312E30353533332C2D312E323337383039393620';
wwv_flow_imp.g_varchar2_table(470) := '322E36343333372C2D322E303738383220342E32393635332C2D312E393739393739393620322E30353136332C302E3038303520332E38353537392C312E313538303320352E37363038322C312E373931303720312E30363338352C302E333431333939';
wwv_flow_imp.g_varchar2_table(471) := '393620322E32343435342C302E3134333820332E31383735392C2D302E343337363720302E36313734332C2D302E333336343220312E323737352C2D302E363430373820312E373534322C2D312E313735313120302C302E353630323320302C312E3132';
wwv_flow_imp.g_varchar2_table(472) := '30343620302C312E36383037202D302E39383730362C302E3936323337393936202D322E32393739322C312E3632333933393936202D332E363931382C312E3636313831393936202D312E32343435392C302E30393237202D322E34363637312C2D302E';
wwv_flow_imp.g_varchar2_table(473) := '32343931202D332E35393530352C2D302E3734383132202D312E33353738392C2D302E3535393635202D322E37353133332C2D312E3333343336393936202D342E32373032372C2D312E3138313231393936202D312E33373734312C302E313436303120';
wwv_flow_imp.g_varchar2_table(474) := '2D322E34313834322C312E3133363835393936202D332E34343238382C312E3936373832393936207A222C6865696768743A342C77696474683A31352C686569676874456C656D656E74733A5B5D2C7769647468456C656D656E74733A5B5D7D2C544153';
wwv_flow_imp.g_varchar2_table(475) := '4B5F545950455F53454E443A7B643A226D207B6D787D2C7B6D797D206C20302C7B652E79317D206C207B652E78317D2C30206C20302C2D7B652E79317D207A206C207B652E78307D2C7B652E79307D206C207B652E78307D2C2D7B652E79307D222C6865';
wwv_flow_imp.g_varchar2_table(476) := '696768743A31342C77696474683A32312C686569676874456C656D656E74733A5B362C31345D2C7769647468456C656D656E74733A5B31302E352C32315D7D2C5441534B5F545950455F5343524950543A7B643A226D207B6D787D2C7B6D797D20632039';
wwv_flow_imp.g_varchar2_table(477) := '2E3936363535332C2D362E3237323736202D382E3030303932362C2D372E393139333220322E3936383936382C2D31342E393338206C202D382E3830323732382C302063202D31302E3936393839342C372E303138363820362E3939373538352C382E36';
wwv_flow_imp.g_varchar2_table(478) := '36353234202D322E3936383936372C31342E393338207A206D202D372C2D3132206C20352C30206D202D342E352C33206C20342E352C30206D202D332C33206C20352C306D202D342C33206C20352C30222C6865696768743A31352C77696474683A3132';
wwv_flow_imp.g_varchar2_table(479) := '2E362C686569676874456C656D656E74733A5B362C31345D2C7769647468456C656D656E74733A5B31302E352C32315D7D2C5441534B5F545950455F555345525F313A7B643A226D207B6D787D2C7B6D797D206320302E3930392C2D302E38343520312E';
wwv_flow_imp.g_varchar2_table(480) := '3539342C2D322E30343920312E3539342C2D332E33383520302C2D322E353534202D312E3830352C2D342E3632313939393939202D342E3335372C2D342E3632313939393939202D322E35353139393939382C30202D342E32383739393939382C322E30';
wwv_flow_imp.g_varchar2_table(481) := '36373939393939202D342E32383739393939382C342E363231393939393920302C312E33343820302E3937342C322E35363220312E38393539393939382C332E343035202D302E35323839393939382C302E313837202D352E3636392C322E303937202D';
wwv_flow_imp.g_varchar2_table(482) := '352E3739342C342E37353630303035207620362E37313820682031372076202D362E373138206320302C2D322E32393830303035202D352E353237393939362C2D342E35393530303035202D362E303530393939362C2D342E37373630303035207A6D20';
wwv_flow_imp.g_varchar2_table(483) := '2D382C36206C20302C352E35206D2031312C30206C20302C2D35227D2C5441534B5F545950455F555345525F323A7B643A226D207B6D787D2C7B6D797D206D20322E3136322C312E303039206320302C322E34343730303035202D322E3135382C342E34';
wwv_flow_imp.g_varchar2_table(484) := '333130303035202D342E3832312C342E34333130303035202D322E36363439393939382C30202D342E3832322C2D312E393831202D342E3832322C2D342E3433313030303520227D2C5441534B5F545950455F555345525F333A7B643A226D207B6D787D';
wwv_flow_imp.g_varchar2_table(485) := '2C7B6D797D206D202D362E392C2D332E3830206320302C3020322E32353039393939382C2D322E33353820342E32373339393939382C2D312E31373720322E3032342C312E31383120342E3232312C312E35333720342E3132342C302E393635202D302E';
wwv_flow_imp.g_varchar2_table(486) := '3039382C2D302E3537202D302E3131372C2D332E3739303939393939202D342E3139312C2D342E3133353939393939202D332E35373439393939382C302E303031202D342E32303739393939382C332E3336363939393939202D342E3230363939393938';
wwv_flow_imp.g_varchar2_table(487) := '2C342E3334373939393939207A227D2C5441534B5F545950455F4D414E55414C3A7B643A226D207B6D787D2C7B6D797D206320302E3233342C2D302E303120352E3630342C302E30303820382E3032392C302E30303420302E3830382C3020312E323731';
wwv_flow_imp.g_varchar2_table(488) := '2C2D302E31373220312E3431372C2D302E37353220302E3232372C2D302E383938202D302E3333342C2D312E333134202D312E3333382C2D312E333136202D322E3436372C2D302E3031202D372E3838362C2D302E303034202D382E3130382C2D302E30';
wwv_flow_imp.g_varchar2_table(489) := '3034202D302E3031342C2D302E30373920302E3031362C2D302E35333320302C2D302E363120302E3139352C2D302E30343220382E3530372C302E30303620392E3631362C302E30303220302E3837372C2D302E30303720312E33352C2D302E34333820';
wwv_flow_imp.g_varchar2_table(490) := '312E3335332C2D312E32303820302E3030332C2D302E373638202D302E3437392C2D312E3039202D312E33352C2D312E303931202D322E3936382C2D302E303032202D392E3631392C2D302E303133202D392E3631392C2D302E3031332076202D302E35';
wwv_flow_imp.g_varchar2_table(491) := '3931206320302C3020352E3035322C2D302E30313620372E3232352C2D302E30313620302E3838382C2D302E30303220312E3335342C2D302E34313620312E3335312C2D312E313933202D302E3030362C2D302E373631202D302E3439322C2D312E3139';
wwv_flow_imp.g_varchar2_table(492) := '36202D312E3336312C2D312E313936202D332E3437332C2D302E303035202D31302E38362C2D302E303033202D31312E303832393939352C2D302E303033202D302E3032322C2D302E303437202D302E3034352C2D302E303934202D302E3036392C2D30';
wwv_flow_imp.g_varchar2_table(493) := '2E31333920302E333933393939352C2D302E33313920322E303430393939352C2D312E36323620322E343134393939352C2D322E30313720302E3436392C2D302E3438373030303520302E3531392C2D312E3136353030303520302E3136322C2D312E36';
wwv_flow_imp.g_varchar2_table(494) := '303430303035202D302E3431342C2D302E353131202D302E3937332C2D302E35202D312E34382C2D302E323336202D312E343630393939352C302E373634202D362E353939393939352C332E36343330303035202D372E373332393939352C342E323731';
wwv_flow_imp.g_varchar2_table(495) := '30303035202D302E392C302E343939202D312E3531362C312E323533202D312E3838322C322E3139202D302E33373030303030322C302E3935202D302E31372C322E3031202D302E3136362C322E39373920302E3030342C302E373138202D302E323733';
wwv_flow_imp.g_varchar2_table(496) := '30303030322C312E333435202D302E3035352C322E30363320302E3632392C322E30383720322E3432352C332E33313220342E3835392C332E33313820342E363137393939352C302E30313420392E323337393939352C2D302E3133392031332E383536';
wwv_flow_imp.g_varchar2_table(497) := '393939352C2D302E31353820302E3735352C2D302E30303420312E3137312C2D302E33303120312E3138322C2D312E30333320302E3031322C2D302E373534202D302E3432332C2D302E393639202D312E3138332C2D302E393733202D312E3737382C2D';
wwv_flow_imp.g_varchar2_table(498) := '302E3031202D352E3832342C2D302E303034202D362E30342C2D302E303034203130652D342C2D302E30383420302E3030332C2D302E353836203130652D342C2D302E3637207A227D2C5441534B5F545950455F494E5354414E54494154494E475F5345';
wwv_flow_imp.g_varchar2_table(499) := '4E443A7B643A226D207B6D787D2C7B6D797D206C20302C382E34206C2031322E362C30206C20302C2D382E34207A206C20362E332C332E36206C20362E332C2D332E36227D2C5441534B5F545950455F534552564943453A7B643A226D207B6D787D2C7B';
wwv_flow_imp.g_varchar2_table(500) := '6D797D2076202D312E3731333335206320302E3335323332362C2D302E3037303520302E3730333933322C2D302E313738333820312E3034373632382C2D302E333231333320302E3334343431362C2D302E313434363520302E3636353832322C2D302E';
wwv_flow_imp.g_varchar2_table(501) := '333231333320302E3936363337372C2D302E3532313435206C20312E31393433312C312E313830303520312E3536373438372C2D312E3537363838202D312E3139353032382C2D312E3138303134206320302E3430333337362C2D302E36313339342030';
wwv_flow_imp.g_varchar2_table(502) := '2E3638333037392C2D312E323939303820302E3832353434372C2D322E3031383234206C20312E3632323133332C2D302E30312076202D322E32313936206C202D312E3633363531342C302E30312063202D302E30373333332C2D302E3335313533202D';
wwv_flow_imp.g_varchar2_table(503) := '302E3137383331392C2D302E3730303234202D302E3332333536342C2D312E3034333732202D302E3134353234342C2D302E3334343036202D302E3332313430372C2D302E36363434202D302E3532323733352C2D302E3936323137206C20312E313331';
wwv_flow_imp.g_varchar2_table(504) := '3033352C2D312E3133363331202D312E3538333330352C2D312E3536323933202D312E3132393539382C312E31333538392063202D302E3631343035322C2D302E3430313038202D312E3330323838332C2D302E3638303933202D322E3032323633332C';
wwv_flow_imp.g_varchar2_table(505) := '2D302E3832323437206C20302E303039332C2D312E36313835322068202D322E323431313733206C20302E303034322C312E36333132342063202D302E3335333736332C302E30373336202D302E3730353336392C302E3137393737202D312E30343937';
wwv_flow_imp.g_varchar2_table(506) := '38352C302E3332333731202D302E3334343431352C302E3134343337202D302E3636353130322C302E3332303932202D302E393633353030362C302E3532303436206C202D312E313639383632382C2D312E3135383233202D312E353636373639312C31';
wwv_flow_imp.g_varchar2_table(507) := '2E3537393220312E313638343236352C312E31353636392063202D302E343032363537332C302E3631323833202D302E36383330382C312E3239373937202D302E383234373238372C322E3031373133206C202D312E363538383034312C302E30303320';
wwv_flow_imp.g_varchar2_table(508) := '7620322E3232313734206C20312E363732343634382C2D302E303036206320302E3037333332372C302E333530373720302E313739373539382C302E373032343320302E333234323835312C312E303434373220302E313435323432382C302E33343434';
wwv_flow_imp.g_varchar2_table(509) := '3820302E333231343036342C302E3636343420302E353232373333392C302E3936303636206C202D312E313939333433312C312E313937323320312E353834303235362C312E353630313120312E313936343636382C2D312E3139333438206320302E36';
wwv_flow_imp.g_varchar2_table(510) := '3134303531372C302E343033343620312E333032383832372C302E363832333220322E303233333531372C302E3832333331206C20372E3139652D342C312E3639383932206820322E323236383438207A206D20302E3232313436322C2D332E39393537';
wwv_flow_imp.g_varchar2_table(511) := '2063202D312E3738383934382C302E37353032202D332E383537362C2D302E30393238202D342E363039373035352C2D312E3837343338202D302E373532313036352C2D312E373833323120302E3039303539382C2D332E383436323720312E38383032';
wwv_flow_imp.g_varchar2_table(512) := '3634352C2D342E353936303420312E37383832332C2D302E373439333620332E3835363838312C302E3039323920342E3630383938372C312E383734333720302E3735323130362C312E3738313635202D302E303930362C332E3834363132202D312E38';
wwv_flow_imp.g_varchar2_table(513) := '37393534362C342E3539363035207A227D2C5441534B5F545950455F534552564943455F46494C4C3A7B643A226D207B6D787D2C7B6D797D2063202D312E3738383934382C302E37353032202D332E383537362C2D302E30393238202D342E3630393730';
wwv_flow_imp.g_varchar2_table(514) := '35352C2D312E3837343338202D302E373532313036352C2D312E373833323120302E3039303539382C2D332E383436323720312E383830323634352C2D342E353936303420312E37383832332C2D302E373439333620332E3835363838312C302E303932';
wwv_flow_imp.g_varchar2_table(515) := '3920342E3630383938372C312E383734333720302E3735323130362C312E3738313635202D302E303930362C332E3834363132202D312E3837393534362C342E3539363035207A227D2C5441534B5F545950455F425553494E4553535F52554C455F4845';
wwv_flow_imp.g_varchar2_table(516) := '414445523A7B643A226D207B6D787D2C7B6D797D20302C342032302C3020302C2D34207A227D2C5441534B5F545950455F425553494E4553535F52554C455F4D41494E3A7B643A226D207B6D787D2C7B6D797D20302C31322032302C3020302C2D313220';
wwv_flow_imp.g_varchar2_table(517) := '7A6D20302C38206C2032302C30206D202D31332C2D34206C20302C38227D2C4D4553534147455F464C4F575F4D41524B45523A7B643A226D207B6D787D2C7B6D797D206D202D31302E35202C2D37206C20302C3134206C2032312C30206C20302C2D3134';
wwv_flow_imp.g_varchar2_table(518) := '207A206C2031302E352C36206C2031302E352C2D36227D7D2C746869732E676574526177506174683D66756E6374696F6E2865297B72657475726E20746869732E706174684D61705B655D2E647D2C746869732E6765745363616C6564506174683D6675';
wwv_flow_imp.g_varchar2_table(519) := '6E6374696F6E28652C74297B766172206E2C692C723D746869732E706174684D61705B655D3B742E616273706F733F286E3D742E616273706F732E782C693D742E616273706F732E79293A286E3D742E636F6E7461696E657257696474682A742E706F73';
wwv_flow_imp.g_varchar2_table(520) := '6974696F6E2E6D782C693D742E636F6E7461696E65724865696768742A742E706F736974696F6E2E6D79293B766172206F2C612C733D7B7D3B696628742E706F736974696F6E297B666F7228766172206C3D742E636F6E7461696E65724865696768742F';
wwv_flow_imp.g_varchar2_table(521) := '722E6865696768742A742E795363616C65466163746F722C633D742E636F6E7461696E657257696474682F722E77696474682A742E785363616C65466163746F722C703D303B703C722E686569676874456C656D656E74732E6C656E6774683B702B2B29';
wwv_flow_imp.g_varchar2_table(522) := '735B2279222B705D3D722E686569676874456C656D656E74735B705D2A6C3B666F722876617220753D303B753C722E7769647468456C656D656E74732E6C656E6774683B752B2B29735B2278222B755D3D722E7769647468456C656D656E74735B755D2A';
wwv_flow_imp.g_varchar2_table(523) := '637D72657475726E206F3D722E642C613D7B6D783A6E2C6D793A692C653A737D2C537472696E67286F292E7265706C6163652877742C2866756E6374696F6E28652C74297B72657475726E2066756E6374696F6E28652C742C6E297B76617220693D6E3B';
wwv_flow_imp.g_varchar2_table(524) := '72657475726E20742E7265706C616365285F742C2866756E6374696F6E28652C742C6E2C722C6F297B743D747C7C722C692626287420696E2069262628693D695B745D292C2266756E6374696F6E223D3D747970656F66206926266F262628693D692829';
wwv_flow_imp.g_varchar2_table(525) := '29297D29292C693D286E756C6C3D3D697C7C693D3D6E3F653A69292B22227D28652C742C61297D29297D7D5D7D2C53743D7B7472616E736C6174653A5B2276616C7565222C66756E6374696F6E28652C74297B72657475726E20743D747C7C7B7D2C652E';
wwv_flow_imp.g_varchar2_table(526) := '7265706C616365282F7B285B5E7D5D2B297D2F672C2866756E6374696F6E28652C6E297B72657475726E20745B6E5D7C7C227B222B6E2B227D227D29297D5D7D3B7661722041743D4D6174683B66756E6374696F6E2043742865297B72657475726E206C';
wwv_flow_imp.g_varchar2_table(527) := '28652926266828652C226C6162656C54617267657422297D66756E6374696F6E206B742865297B72657475726E7B746F703A652E792C72696768743A652E782B28652E77696474687C7C30292C626F74746F6D3A652E792B28652E6865696768747C7C30';
wwv_flow_imp.g_varchar2_table(528) := '292C6C6566743A652E787D7D66756E6374696F6E2052742865297B72657475726E206C286E3D6529262668286E2C22776179706F696E747322293F66756E6374696F6E2865297B666F722876617220743D652E776179706F696E74732C6E3D742E726564';
wwv_flow_imp.g_varchar2_table(529) := '756365282866756E6374696F6E28652C6E2C69297B76617220722C6F2C613D745B692D315D3B69662861297B76617220733D655B652E6C656E6774682D315D2C6C3D732626732E656E644C656E6774687C7C302C633D28723D612C6F3D6E2C4D6174682E';
wwv_flow_imp.g_varchar2_table(530) := '73717274284D6174682E706F7728722E782D6F2E782C32292B4D6174682E706F7728722E792D6F2E792C322929293B652E70757368287B73746172743A612C656E643A6E2C73746172744C656E6774683A6C2C656E644C656E6774683A6C2B632C6C656E';
wwv_flow_imp.g_varchar2_table(531) := '6774683A637D297D72657475726E20657D292C5B5D292C693D6E2E726564756365282866756E6374696F6E28652C74297B72657475726E20652B742E6C656E6774687D292C30292F322C723D302C6F3D6E5B725D3B6F2E656E644C656E6774683C693B29';
wwv_flow_imp.g_varchar2_table(532) := '6F3D6E5B2B2B725D3B76617220613D28692D6F2E73746172744C656E677468292F6F2E6C656E6774683B72657475726E7B783A6F2E73746172742E782B286F2E656E642E782D6F2E73746172742E78292A612C793A6F2E73746172742E792B286F2E656E';
wwv_flow_imp.g_varchar2_table(533) := '642E792D6F2E73746172742E79292A617D7D2865293A28743D7B783A28693D65292E782B28692E77696474687C7C30292F322C793A692E792B28692E6865696768747C7C30292F327D2C7B783A4D6174682E726F756E6428742E78292C793A4D6174682E';
wwv_flow_imp.g_varchar2_table(534) := '726F756E6428742E79297D293B76617220742C6E2C697D66756E6374696F6E204D742865297B72657475726E20653F223C222B652E24747970652B28652E69643F272069643D22272B652E69643A2222292B2722202F3E273A223C6E756C6C3E227D6675';
wwv_flow_imp.g_varchar2_table(535) := '6E6374696F6E20507428652C742C6E297B72657475726E2053287B69643A652E69642C747970653A652E24747970652C627573696E6573734F626A6563743A652C64693A747D2C6E297D66756E6374696F6E20447428652C742C6E297B76617220693D65';
wwv_flow_imp.g_varchar2_table(536) := '2E776179706F696E743B72657475726E21697C7C692E6C656E6774683C323F5B52742874292C5274286E295D3A692E6D6170282866756E6374696F6E2865297B72657475726E7B783A652E782C793A652E797D7D29297D66756E6374696F6E2042742865';
wwv_flow_imp.g_varchar2_table(537) := '2C742C6E297B72657475726E206E6577204572726F722860656C656D656E7420247B4D742874297D207265666572656E63656420627920247B4D742865297D23247B6E7D206E6F742079657420647261776E60297D66756E6374696F6E204F7428652C74';
wwv_flow_imp.g_varchar2_table(538) := '2C6E2C692C72297B746869732E5F6576656E744275733D652C746869732E5F63616E7661733D742C746869732E5F656C656D656E74466163746F72793D6E2C746869732E5F656C656D656E7452656769737472793D692C746869732E5F7465787452656E';
wwv_flow_imp.g_varchar2_table(539) := '64657265723D727D41742E50492C41742E6D696E2C41742E6D61782C41742E706F772C41742E6162732C41727261792E697341727261792C4F742E24696E6A6563743D5B226576656E74427573222C2263616E766173222C22656C656D656E7446616374';
wwv_flow_imp.g_varchar2_table(540) := '6F7279222C22656C656D656E745265676973747279222C227465787452656E6465726572225D2C4F742E70726F746F747970652E6164643D66756E6374696F6E28652C742C6E297B76617220692C722C6F2C612C732C6C2C633B6966286B28742C226270';
wwv_flow_imp.g_varchar2_table(541) := '6D6E64693A42504D4E506C616E652229297B76617220703D6B28652C2262706D6E3A53756250726F6365737322293F7B69643A652E69642B225F706C616E65227D3A7B7D3B693D746869732E5F656C656D656E74466163746F72792E637265617465526F';
wwv_flow_imp.g_varchar2_table(542) := '6F7428507428652C742C7029292C746869732E5F63616E7661732E616464526F6F74456C656D656E742869297D656C7365206966286B28742C2262706D6E64693A42504D4E53686170652229297B76617220753D214428652C74292C683D66756E637469';
wwv_flow_imp.g_varchar2_table(543) := '6F6E2865297B72657475726E206B28652C2262706D6E3A47726F757022297D2865293B723D6E2626286E2E68696464656E7C7C6E2E636F6C6C6170736564293B76617220643D742E626F756E64733B693D746869732E5F656C656D656E74466163746F72';
wwv_flow_imp.g_varchar2_table(544) := '792E637265617465536861706528507428652C742C7B636F6C6C61707365643A752C68696464656E3A722C783A4D6174682E726F756E6428642E78292C793A4D6174682E726F756E6428642E79292C77696474683A4D6174682E726F756E6428642E7769';
wwv_flow_imp.g_varchar2_table(545) := '647468292C6865696768743A4D6174682E726F756E6428642E686569676874292C69734672616D653A687D29292C6B28652C2262706D6E3A426F756E646172794576656E7422292626746869732E5F617474616368426F756E6461727928652C69292C6B';
wwv_flow_imp.g_varchar2_table(546) := '28652C2262706D6E3A4C616E6522292626286F3D30292C6B28652C2262706D6E3A4461746153746F72655265666572656E63652229262628613D6E2C6C3D28733D5274286429292E782C633D732E792C6C3E3D612E7826266C3C3D612E782B612E776964';
wwv_flow_imp.g_varchar2_table(547) := '74682626633E3D612E792626633C3D612E792B612E6865696768747C7C286E3D746869732E5F63616E7661732E66696E64526F6F74286E2929292C746869732E5F63616E7661732E616464536861706528692C6E2C6F297D656C73657B696628216B2874';
wwv_flow_imp.g_varchar2_table(548) := '2C2262706D6E64693A42504D4E456467652229297468726F77206E6577204572726F722860756E6B6E6F776E20646920247B4D742874297D20666F7220656C656D656E7420247B4D742865297D60293B766172206D3D746869732E5F676574536F757263';
wwv_flow_imp.g_varchar2_table(549) := '652865292C663D746869732E5F6765745461726765742865293B723D6E2626286E2E68696464656E7C7C6E2E636F6C6C6170736564292C693D746869732E5F656C656D656E74466163746F72792E637265617465436F6E6E656374696F6E28507428652C';
wwv_flow_imp.g_varchar2_table(550) := '742C7B68696464656E3A722C736F757263653A6D2C7461726765743A662C776179706F696E74733A447428742C6D2C66297D29292C6B28652C2262706D6E3A446174614173736F63696174696F6E22292626286E3D746869732E5F63616E7661732E6669';
wwv_flow_imp.g_varchar2_table(551) := '6E64526F6F74286E29292C746869732E5F63616E7661732E616464436F6E6E656374696F6E28692C6E2C6F297D72657475726E2066756E6374696F6E2865297B72657475726E206B28652C2262706D6E3A4576656E7422297C7C6B28652C2262706D6E3A';
wwv_flow_imp.g_varchar2_table(552) := '4761746577617922297C7C6B28652C2262706D6E3A4461746153746F72655265666572656E636522297C7C6B28652C2262706D6E3A446174614F626A6563745265666572656E636522297C7C6B28652C2262706D6E3A44617461496E70757422297C7C6B';
wwv_flow_imp.g_varchar2_table(553) := '28652C2262706D6E3A446174614F757470757422297C7C6B28652C2262706D6E3A53657175656E6365466C6F7722297C7C6B28652C2262706D6E3A4D657373616765466C6F7722297C7C6B28652C2262706D6E3A47726F757022297D2865292626492869';
wwv_flow_imp.g_varchar2_table(554) := '292626746869732E6164644C6162656C28652C742C69292C746869732E5F6576656E744275732E66697265282262706D6E456C656D656E742E6164646564222C7B656C656D656E743A697D292C697D2C4F742E70726F746F747970652E5F617474616368';
wwv_flow_imp.g_varchar2_table(555) := '426F756E646172793D66756E6374696F6E28652C74297B766172206E3D652E6174746163686564546F5265663B696628216E297468726F77206E6577204572726F7228606D697373696E6720247B4D742865297D236174746163686564546F5265666029';
wwv_flow_imp.g_varchar2_table(556) := '3B76617220693D746869732E5F656C656D656E7452656769737472792E676574286E2E6964292C723D692626692E6174746163686572733B6966282169297468726F7720427428652C6E2C226174746163686564546F52656622293B742E686F73743D69';
wwv_flow_imp.g_varchar2_table(557) := '2C727C7C28692E6174746163686572733D723D5B5D292C2D313D3D3D722E696E6465784F662874292626722E707573682874297D2C4F742E70726F746F747970652E6164644C6162656C3D66756E6374696F6E28652C742C6E297B76617220692C722C6F';
wwv_flow_imp.g_varchar2_table(558) := '3B72657475726E20693D4E28742C6E292C28723D49286E2929262628693D746869732E5F7465787452656E64657265722E67657445787465726E616C4C6162656C426F756E647328692C7229292C6F3D746869732E5F656C656D656E74466163746F7279';
wwv_flow_imp.g_varchar2_table(559) := '2E6372656174654C6162656C28507428652C742C7B69643A652E69642B225F6C6162656C222C6C6162656C5461726765743A6E2C747970653A226C6162656C222C68696464656E3A6E2E68696464656E7C7C2149286E292C783A4D6174682E726F756E64';
wwv_flow_imp.g_varchar2_table(560) := '28692E78292C793A4D6174682E726F756E6428692E79292C77696474683A4D6174682E726F756E6428692E7769647468292C6865696768743A4D6174682E726F756E6428692E686569676874297D29292C746869732E5F63616E7661732E616464536861';
wwv_flow_imp.g_varchar2_table(561) := '7065286F2C6E2E706172656E74297D2C4F742E70726F746F747970652E5F676574436F6E6E6563746564456C656D656E743D66756E6374696F6E28652C74297B766172206E2C692C723D652E24747970653B696628693D655B742B22526566225D2C2273';
wwv_flow_imp.g_varchar2_table(562) := '6F75726365223D3D3D7426262262706D6E3A44617461496E7075744173736F63696174696F6E223D3D3D72262628693D692626695B305D292C2822736F75726365223D3D3D7426262262706D6E3A446174614F75747075744173736F63696174696F6E22';
wwv_flow_imp.g_varchar2_table(563) := '3D3D3D727C7C22746172676574223D3D3D7426262262706D6E3A44617461496E7075744173736F63696174696F6E223D3D3D7229262628693D652E24706172656E74292C6E3D692626746869732E5F676574456C656D656E742869292972657475726E20';
wwv_flow_imp.g_varchar2_table(564) := '6E3B7468726F7720693F427428652C692C742B2252656622293A6E6577204572726F722860247B4D742865297D23247B747D20526566206E6F742073706563696669656460297D2C4F742E70726F746F747970652E5F676574536F757263653D66756E63';
wwv_flow_imp.g_varchar2_table(565) := '74696F6E2865297B72657475726E20746869732E5F676574436F6E6E6563746564456C656D656E7428652C22736F7572636522297D2C4F742E70726F746F747970652E5F6765745461726765743D66756E6374696F6E2865297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(566) := '732E5F676574436F6E6E6563746564456C656D656E7428652C2274617267657422297D2C4F742E70726F746F747970652E5F676574456C656D656E743D66756E6374696F6E2865297B72657475726E20746869732E5F656C656D656E7452656769737472';
wwv_flow_imp.g_varchar2_table(567) := '792E67657428652E6964297D3B636F6E73742054743D7B5F5F646570656E64735F5F3A5B45742C7B5F5F646570656E64735F5F3A5B53745D2C62706D6E496D706F727465723A5B2274797065222C4F745D7D5D7D3B66756E6374696F6E204E7428652C74';
wwv_flow_imp.g_varchar2_table(568) := '297B766172206E2C692C722C6F3B72657475726E20743D2121742C732865297C7C28653D5B655D292C6628652C2866756E6374696F6E2865297B76617220613D653B652E776179706F696E747326262174262628613D4E7428652E776179706F696E7473';
wwv_flow_imp.g_varchar2_table(569) := '2C213029293B76617220733D612E782C6C3D612E792C633D612E6865696768747C7C302C703D612E77696474687C7C303B28733C6E7C7C766F696420303D3D3D6E292626286E3D73292C286C3C697C7C766F696420303D3D3D6929262628693D6C292C28';
wwv_flow_imp.g_varchar2_table(570) := '732B703E727C7C766F696420303D3D3D7229262628723D732B70292C286C2B633E6F7C7C766F696420303D3D3D6F292626286F3D6C2B63297D29292C7B783A6E2C793A692C6865696768743A6F2D692C77696474683A722D6E7D7D66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(571) := '49742865297B72657475726E22776179706F696E747322696E20653F22636F6E6E656374696F6E223A227822696E20653F227368617065223A22726F6F74227D66756E6374696F6E204C742865297B72657475726E212821657C7C21652E69734672616D';
wwv_flow_imp.g_varchar2_table(572) := '65297D66756E6374696F6E206A742865297B746869732E5F636F756E7465723D302C746869732E5F7072656669783D28653F652B222D223A2222292B4D6174682E666C6F6F72283165392A4D6174682E72616E646F6D2829292B222D227D6A742E70726F';
wwv_flow_imp.g_varchar2_table(573) := '746F747970652E6E6578743D66756E6374696F6E28297B72657475726E20746869732E5F7072656669782B202B2B746869732E5F636F756E7465727D3B7661722046743D6E6577206A7428226F7622293B66756E6374696F6E20567428652C742C6E2C69';
wwv_flow_imp.g_varchar2_table(574) := '297B76617220722C6F3B746869732E5F6576656E744275733D742C746869732E5F63616E7661733D6E2C746869732E5F656C656D656E7452656769737472793D692C746869732E5F6964733D46742C746869732E5F6F7665726C617944656661756C7473';
wwv_flow_imp.g_varchar2_table(575) := '3D53287B73686F773A6E756C6C2C7363616C653A21307D2C652626652E64656661756C7473292C746869732E5F6F7665726C6179733D7B7D2C746869732E5F6F7665726C6179436F6E7461696E6572733D5B5D2C746869732E5F6F7665726C6179526F6F';
wwv_flow_imp.g_varchar2_table(576) := '743D28723D6E2E676574436F6E7461696E657228292C4F65286F3D516528273C64697620636C6173733D22646A732D6F7665726C61792D636F6E7461696E657222202F3E27292C7B706F736974696F6E3A226162736F6C757465222C77696474683A302C';
wwv_flow_imp.g_varchar2_table(577) := '6865696768743A307D292C722E696E736572744265666F7265286F2C722E66697273744368696C64292C6F292C746869732E5F696E697428297D66756E6374696F6E20247428652C742C6E297B4F6528652C7B6C6566743A742B227078222C746F703A6E';
wwv_flow_imp.g_varchar2_table(578) := '2B227078227D297D66756E6374696F6E207A7428652C74297B652E7374796C652E646973706C61793D21313D3D3D743F226E6F6E65223A22227D66756E6374696F6E20577428652C74297B652E7374796C655B227472616E73666F726D2D6F726967696E';
wwv_flow_imp.g_varchar2_table(579) := '225D3D22746F70206C656674222C5B22222C222D6D732D222C222D7765626B69742D225D2E666F7245616368282866756E6374696F6E286E297B652E7374796C655B6E2B227472616E73666F726D225D3D747D29297D56742E24696E6A6563743D5B2263';
wwv_flow_imp.g_varchar2_table(580) := '6F6E6669672E6F7665726C617973222C226576656E74427573222C2263616E766173222C22656C656D656E745265676973747279225D2C56742E70726F746F747970652E6765743D66756E6374696F6E2865297B69662875286529262628653D7B69643A';
wwv_flow_imp.g_varchar2_table(581) := '657D292C7528652E656C656D656E7429262628652E656C656D656E743D746869732E5F656C656D656E7452656769737472792E67657428652E656C656D656E7429292C652E656C656D656E74297B76617220743D746869732E5F6765744F7665726C6179';
wwv_flow_imp.g_varchar2_table(582) := '436F6E7461696E657228652E656C656D656E742C2130293B72657475726E20743F652E747970653F6D28742E6F7665726C6179732C62287B747970653A652E747970657D29293A742E6F7665726C6179732E736C69636528293A5B5D7D72657475726E20';
wwv_flow_imp.g_varchar2_table(583) := '652E747970653F6D28746869732E5F6F7665726C6179732C62287B747970653A652E747970657D29293A652E69643F746869732E5F6F7665726C6179735B652E69645D3A6E756C6C7D2C56742E70726F746F747970652E6164643D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(584) := '652C742C6E297B6966286C2874292626286E3D742C743D6E756C6C292C652E69647C7C28653D746869732E5F656C656D656E7452656769737472792E676574286529292C216E2E706F736974696F6E297468726F77206E6577204572726F7228226D7573';
wwv_flow_imp.g_varchar2_table(585) := '74207370656369666979206F7665726C617920706F736974696F6E22293B696628216E2E68746D6C297468726F77206E6577204572726F7228226D757374207370656369666979206F7665726C61792068746D6C22293B6966282165297468726F77206E';
wwv_flow_imp.g_varchar2_table(586) := '6577204572726F722822696E76616C696420656C656D656E742073706563696669656422293B76617220693D746869732E5F6964732E6E65787428293B72657475726E206E3D53287B7D2C746869732E5F6F7665726C617944656661756C74732C6E2C7B';
wwv_flow_imp.g_varchar2_table(587) := '69643A692C747970653A742C656C656D656E743A652C68746D6C3A6E2E68746D6C7D292C746869732E5F6164644F7665726C6179286E292C697D2C56742E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B76617220743D746869';
wwv_flow_imp.g_varchar2_table(588) := '732E6765742865297C7C5B5D3B732874297C7C28743D5B745D293B766172206E3D746869733B6628742C2866756E6374696F6E2865297B76617220743D6E2E5F6765744F7665726C6179436F6E7461696E657228652E656C656D656E742C2130293B6966';
wwv_flow_imp.g_varchar2_table(589) := '2865262628747428652E68746D6C292C747428652E68746D6C436F6E7461696E6572292C64656C65746520652E68746D6C436F6E7461696E65722C64656C65746520652E656C656D656E742C64656C657465206E2E5F6F7665726C6179735B652E69645D';
wwv_flow_imp.g_varchar2_table(590) := '292C74297B76617220693D742E6F7665726C6179732E696E6465784F662865293B2D31213D3D692626742E6F7665726C6179732E73706C69636528692C31297D7D29297D2C56742E70726F746F747970652E697353686F776E3D66756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(591) := '7B72657475726E226E6F6E6522213D3D746869732E5F6F7665726C6179526F6F742E7374796C652E646973706C61797D2C56742E70726F746F747970652E73686F773D66756E6374696F6E28297B7A7428746869732E5F6F7665726C6179526F6F74297D';
wwv_flow_imp.g_varchar2_table(592) := '2C56742E70726F746F747970652E686964653D66756E6374696F6E28297B7A7428746869732E5F6F7665726C6179526F6F742C2131297D2C56742E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E5F6F7665726C617973';
wwv_flow_imp.g_varchar2_table(593) := '3D7B7D2C746869732E5F6F7665726C6179436F6E7461696E6572733D5B5D2C6A6528746869732E5F6F7665726C6179526F6F74297D2C56742E70726F746F747970652E5F7570646174654F7665726C6179436F6E7461696E65723D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(594) := '65297B76617220743D652E656C656D656E742C6E3D652E68746D6C2C693D742E782C723D742E793B696628742E776179706F696E7473297B766172206F3D4E742874293B693D6F2E782C723D6F2E797D2474286E2C692C72292C546528652E68746D6C2C';
wwv_flow_imp.g_varchar2_table(595) := '22646174612D636F6E7461696E65722D6964222C742E6964297D2C56742E70726F746F747970652E5F7570646174654F7665726C61793D66756E6374696F6E2865297B76617220742C6E2C693D652E706F736974696F6E2C723D652E68746D6C436F6E74';
wwv_flow_imp.g_varchar2_table(596) := '61696E65722C6F3D652E656C656D656E742C613D692E6C6566742C733D692E746F703B766F69642030213D3D692E7269676874262628743D6F2E776179706F696E74733F4E74286F292E77696474683A6F2E77696474682C613D2D312A692E7269676874';
wwv_flow_imp.g_varchar2_table(597) := '2B74292C766F69642030213D3D692E626F74746F6D2626286E3D6F2E776179706F696E74733F4E74286F292E6865696768743A6F2E6865696768742C733D2D312A692E626F74746F6D2B6E292C247428722C617C7C302C737C7C30292C746869732E5F75';
wwv_flow_imp.g_varchar2_table(598) := '70646174654F7665726C61795669736962696C747928652C746869732E5F63616E7661732E76696577626F782829297D2C56742E70726F746F747970652E5F6372656174654F7665726C6179436F6E7461696E65723D66756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(599) := '7220743D516528273C64697620636C6173733D22646A732D6F7665726C61797322202F3E27293B4F6528742C7B706F736974696F6E3A226162736F6C757465227D292C746869732E5F6F7665726C6179526F6F742E617070656E644368696C642874293B';
wwv_flow_imp.g_varchar2_table(600) := '766172206E3D7B68746D6C3A742C656C656D656E743A652C6F7665726C6179733A5B5D7D3B72657475726E20746869732E5F7570646174654F7665726C6179436F6E7461696E6572286E292C746869732E5F6F7665726C6179436F6E7461696E6572732E';
wwv_flow_imp.g_varchar2_table(601) := '70757368286E292C6E7D2C56742E70726F746F747970652E5F757064617465526F6F743D66756E6374696F6E2865297B76617220743D652E7363616C657C7C312C6E3D226D617472697828222B5B742C302C302C742C2D312A652E782A742C2D312A652E';
wwv_flow_imp.g_varchar2_table(602) := '792A745D2E6A6F696E28222C22292B2229223B577428746869732E5F6F7665726C6179526F6F742C6E297D2C56742E70726F746F747970652E5F6765744F7665726C6179436F6E7461696E65723D66756E6374696F6E28652C74297B766172206E3D6428';
wwv_flow_imp.g_varchar2_table(603) := '746869732E5F6F7665726C6179436F6E7461696E6572732C2866756E6374696F6E2874297B72657475726E20742E656C656D656E743D3D3D657D29293B72657475726E206E7C7C743F6E3A746869732E5F6372656174654F7665726C6179436F6E746169';
wwv_flow_imp.g_varchar2_table(604) := '6E65722865297D2C56742E70726F746F747970652E5F6164644F7665726C61793D66756E6374696F6E2865297B76617220742C6E2C693D652E69642C723D652E656C656D656E742C6F3D652E68746D6C3B6F2E67657426266F2E636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(605) := '722E70726F746F747970652E6A71756572792626286F3D6F2E676574283029292C75286F292626286F3D5165286F29292C6E3D746869732E5F6765744F7665726C6179436F6E7461696E65722872292C4F6528743D516528273C64697620636C6173733D';
wwv_flow_imp.g_varchar2_table(606) := '22646A732D6F7665726C61792220646174612D6F7665726C61792D69643D22272B692B27223E27292C7B706F736974696F6E3A226162736F6C757465227D292C742E617070656E644368696C64286F292C652E74797065262649652874292E6164642822';
wwv_flow_imp.g_varchar2_table(607) := '646A732D6F7665726C61792D222B652E74797065292C7A7428742C746869732E5F63616E7661732E66696E64526F6F742872293D3D3D746869732E5F63616E7661732E676574526F6F74456C656D656E742829292C652E68746D6C436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(608) := '3D742C6E2E6F7665726C6179732E707573682865292C6E2E68746D6C2E617070656E644368696C642874292C746869732E5F6F7665726C6179735B695D3D652C746869732E5F7570646174654F7665726C61792865292C746869732E5F7570646174654F';
wwv_flow_imp.g_varchar2_table(609) := '7665726C61795669736962696C747928652C746869732E5F63616E7661732E76696577626F782829297D2C56742E70726F746F747970652E5F7570646174654F7665726C61795669736962696C74793D66756E6374696F6E28652C74297B766172206E3D';
wwv_flow_imp.g_varchar2_table(610) := '652E73686F772C693D746869732E5F63616E7661732E66696E64526F6F7428652E656C656D656E74292C723D6E26266E2E6D696E5A6F6F6D2C6F3D6E26266E2E6D61785A6F6F6D2C733D652E68746D6C436F6E7461696E65722C6C3D21303B2869213D3D';
wwv_flow_imp.g_varchar2_table(611) := '746869732E5F63616E7661732E676574526F6F74456C656D656E7428297C7C6E262628612872292626723E742E7363616C657C7C61286F2926266F3C742E7363616C6529292626286C3D2131292C7A7428732C6C292C746869732E5F7570646174654F76';
wwv_flow_imp.g_varchar2_table(612) := '65726C61795363616C6528652C74297D2C56742E70726F746F747970652E5F7570646174654F7665726C61795363616C653D66756E6374696F6E28652C74297B766172206E2C692C722C6F3D652E7363616C652C733D652E68746D6C436F6E7461696E65';
wwv_flow_imp.g_varchar2_table(613) := '722C6C3D22223B2130213D3D6F26262821313D3D3D6F3F286E3D312C693D31293A286E3D6F2E6D696E2C693D6F2E6D6178292C61286E292626742E7363616C653C6E262628723D28312F742E7363616C657C7C31292A6E292C612869292626742E736361';
wwv_flow_imp.g_varchar2_table(614) := '6C653E69262628723D28312F742E7363616C657C7C31292A6929292C612872292626286C3D227363616C6528222B722B222C222B722B222922292C577428732C6C297D2C56742E70726F746F747970652E5F7570646174654F7665726C61797356697369';
wwv_flow_imp.g_varchar2_table(615) := '62696C74793D66756E6374696F6E2865297B76617220743D746869733B6628746869732E5F6F7665726C6179732C2866756E6374696F6E286E297B742E5F7570646174654F7665726C61795669736962696C7479286E2C65297D29297D2C56742E70726F';
wwv_flow_imp.g_varchar2_table(616) := '746F747970652E5F696E69743D66756E6374696F6E28297B76617220653D746869732E5F6576656E744275732C743D746869733B652E6F6E282263616E7661732E76696577626F782E6368616E67696E67222C2866756E6374696F6E2865297B742E6869';
wwv_flow_imp.g_varchar2_table(617) := '646528297D29292C652E6F6E282263616E7661732E76696577626F782E6368616E676564222C2866756E6374696F6E2865297B766172206E3B6E3D652E76696577626F782C742E5F757064617465526F6F74286E292C742E5F7570646174654F7665726C';
wwv_flow_imp.g_varchar2_table(618) := '6179735669736962696C7479286E292C742E73686F7728297D29292C652E6F6E285B2273686170652E72656D6F7665222C22636F6E6E656374696F6E2E72656D6F7665225D2C2866756E6374696F6E2865297B766172206E3D652E656C656D656E743B66';
wwv_flow_imp.g_varchar2_table(619) := '28742E676574287B656C656D656E743A6E7D292C2866756E6374696F6E2865297B742E72656D6F766528652E6964297D29293B76617220693D742E5F6765744F7665726C6179436F6E7461696E6572286E293B69662869297B747428692E68746D6C293B';
wwv_flow_imp.g_varchar2_table(620) := '76617220723D742E5F6F7665726C6179436F6E7461696E6572732E696E6465784F662869293B2D31213D3D722626742E5F6F7665726C6179436F6E7461696E6572732E73706C69636528722C31297D7D29292C652E6F6E2822656C656D656E742E636861';
wwv_flow_imp.g_varchar2_table(621) := '6E676564222C3530302C2866756E6374696F6E2865297B766172206E3D652E656C656D656E742C693D742E5F6765744F7665726C6179436F6E7461696E6572286E2C2130293B692626286628692E6F7665726C6179732C2866756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(622) := '742E5F7570646174654F7665726C61792865297D29292C742E5F7570646174654F7665726C6179436F6E7461696E6572286929297D29292C652E6F6E2822656C656D656E742E6D61726B65722E757064617465222C2866756E6374696F6E2865297B7661';
wwv_flow_imp.g_varchar2_table(623) := '72206E3D742E5F6765744F7665726C6179436F6E7461696E657228652E656C656D656E742C2130293B6E26264965286E2E68746D6C295B652E6164643F22616464223A2272656D6F7665225D28652E6D61726B6572297D29292C652E6F6E2822726F6F74';
wwv_flow_imp.g_varchar2_table(624) := '2E736574222C2866756E6374696F6E28297B742E5F7570646174654F7665726C6179735669736962696C747928742E5F63616E7661732E76696577626F782829297D29292C652E6F6E28226469616772616D2E636C656172222C746869732E636C656172';
wwv_flow_imp.g_varchar2_table(625) := '2C74686973297D3B636F6E73742047743D7B5F5F696E69745F5F3A5B226F7665726C617973225D2C6F7665726C6179733A5B2274797065222C56745D7D3B66756E6374696F6E20487428652C742C6E2C69297B652E6F6E2822656C656D656E742E636861';
wwv_flow_imp.g_varchar2_table(626) := '6E676564222C2866756E6374696F6E2869297B76617220723D692E656C656D656E743B28722E706172656E747C7C723D3D3D742E676574526F6F74456C656D656E74282929262628692E6766783D6E2E6765744772617068696373287229292C692E6766';
wwv_flow_imp.g_varchar2_table(627) := '782626652E666972652849742872292B222E6368616E676564222C69297D29292C652E6F6E2822656C656D656E74732E6368616E676564222C2866756E6374696F6E2874297B766172206E3D742E656C656D656E74733B6E2E666F724561636828286675';
wwv_flow_imp.g_varchar2_table(628) := '6E6374696F6E2874297B652E666972652822656C656D656E742E6368616E676564222C7B656C656D656E743A747D297D29292C692E757064617465436F6E7461696E6D656E7473286E297D29292C652E6F6E282273686170652E6368616E676564222C28';
wwv_flow_imp.g_varchar2_table(629) := '66756E6374696F6E2865297B692E75706461746528227368617065222C652E656C656D656E742C652E676678297D29292C652E6F6E2822636F6E6E656374696F6E2E6368616E676564222C2866756E6374696F6E2865297B692E7570646174652822636F';
wwv_flow_imp.g_varchar2_table(630) := '6E6E656374696F6E222C652E656C656D656E742C652E676678297D29297D48742E24696E6A6563743D5B226576656E74427573222C2263616E766173222C22656C656D656E745265676973747279222C226772617068696373466163746F7279225D3B63';
wwv_flow_imp.g_varchar2_table(631) := '6F6E7374204B743D7B5F5F696E69745F5F3A5B226368616E6765537570706F7274225D2C6368616E6765537570706F72743A5B2274797065222C48745D7D3B66756E6374696F6E2055742865297B746869732E5F6576656E744275733D657D66756E6374';
wwv_flow_imp.g_varchar2_table(632) := '696F6E2071742865297B72657475726E2066756E6374696F6E28742C6E2C692C722C6F297B28702874297C7C63287429292626286F3D722C723D692C693D6E2C6E3D742C743D6E756C6C292C746869732E6F6E28742C652C6E2C692C722C6F297D7D6675';
wwv_flow_imp.g_varchar2_table(633) := '6E6374696F6E20597428652C74297B742E696E766F6B652855742C74686973292C746869732E6578656375746564282866756E6374696F6E2874297B766172206E3D742E636F6E746578743B6E2E726F6F74456C656D656E743F652E736574526F6F7445';
wwv_flow_imp.g_varchar2_table(634) := '6C656D656E74286E2E726F6F74456C656D656E74293A6E2E726F6F74456C656D656E743D652E676574526F6F74456C656D656E7428297D29292C746869732E726576657274282866756E6374696F6E2874297B766172206E3D742E636F6E746578743B6E';
wwv_flow_imp.g_varchar2_table(635) := '2E726F6F74456C656D656E742626652E736574526F6F74456C656D656E74286E2E726F6F74456C656D656E74297D29297D55742E24696E6A6563743D5B226576656E74427573225D2C55742E70726F746F747970652E6F6E3D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(636) := '742C6E2C692C722C6F297B69662828702874297C7C63287429292626286F3D722C723D692C693D6E2C6E3D742C743D6E756C6C292C70286E292626286F3D722C723D692C693D6E2C6E3D316533292C6C2872292626286F3D722C723D2131292C21702869';
wwv_flow_imp.g_varchar2_table(637) := '29297468726F77206E6577204572726F72282268616E646C6572466E206D75737420626520612066756E6374696F6E22293B732865297C7C28653D5B655D293B76617220613D746869732E5F6576656E744275733B6628652C2866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(638) := '297B76617220733D5B22636F6D6D616E64537461636B222C652C745D2E66696C746572282866756E6374696F6E2865297B72657475726E20657D29292E6A6F696E28222E22293B612E6F6E28732C6E2C723F66756E6374696F6E28652C74297B72657475';
wwv_flow_imp.g_varchar2_table(639) := '726E2066756E6374696F6E286E297B72657475726E20652E63616C6C28747C7C6E756C6C2C6E2E636F6E746578742C6E2E636F6D6D616E642C6E297D7D28692C6F293A692C6F297D29297D2C55742E70726F746F747970652E63616E457865637574653D';
wwv_flow_imp.g_varchar2_table(640) := '7174282263616E4578656375746522292C55742E70726F746F747970652E707265457865637574653D717428227072654578656375746522292C55742E70726F746F747970652E70726545786563757465643D7174282270726545786563757465642229';
wwv_flow_imp.g_varchar2_table(641) := '2C55742E70726F746F747970652E657865637574653D717428226578656375746522292C55742E70726F746F747970652E65786563757465643D71742822657865637574656422292C55742E70726F746F747970652E706F7374457865637574653D7174';
wwv_flow_imp.g_varchar2_table(642) := '2822706F73744578656375746522292C55742E70726F746F747970652E706F737445786563757465643D71742822706F7374457865637574656422292C55742E70726F746F747970652E7265766572743D7174282272657665727422292C55742E70726F';
wwv_flow_imp.g_varchar2_table(643) := '746F747970652E72657665727465643D71742822726576657274656422292C6E2859742C5574292C59742E24696E6A6563743D5B2263616E766173222C22696E6A6563746F72225D3B636F6E73742058743D7B5F5F696E69745F5F3A5B22726F6F74456C';
wwv_flow_imp.g_varchar2_table(644) := '656D656E74734265686176696F72225D2C726F6F74456C656D656E74734265686176696F723A5B2274797065222C59745D7D3B766172205A743D7B2226223A2226616D703B222C223C223A22266C743B222C223E223A222667743B222C2722273A222671';
wwv_flow_imp.g_varchar2_table(645) := '756F743B222C2227223A22262333393B227D2C4A743D225F706C616E65223B66756E6374696F6E2051742865297B76617220743D652E69643B72657475726E206B28652C2262706D6E3A53756250726F6365737322293F66756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(646) := '657475726E20652B4A747D2874293A747D66756E6374696F6E20656E28652C742C6E297B76617220693D516528273C756C20636C6173733D22626A732D62726561646372756D6273223E3C2F756C3E27292C723D6E2E676574436F6E7461696E65722829';
wwv_flow_imp.g_varchar2_table(647) := '2C6F3D49652872293B722E617070656E644368696C642869293B76617220613D5B5D3B66756E6374696F6E20732865297B65262628613D66756E6374696F6E2865297B666F722876617220743D5B5D2C6E3D4D2865293B6E3B6E3D6E2E24706172656E74';
wwv_flow_imp.g_varchar2_table(648) := '29286B286E2C2262706D6E3A53756250726F6365737322297C7C6B286E2C2262706D6E3A50726F636573732229292626742E70757368286E293B72657475726E20742E7265766572736528297D286529293B76617220723D612E666C61744D6170282866';
wwv_flow_imp.g_varchar2_table(649) := '756E6374696F6E2865297B76617220693D6E2E66696E64526F6F74285174286529297C7C6E2E66696E64526F6F7428652E6964293B696628216926266B28652C2262706D6E3A50726F636573732229297B76617220723D742E66696E64282866756E6374';
wwv_flow_imp.g_varchar2_table(650) := '696F6E2874297B766172206E3D4D2874293B72657475726E206E26266E2E676574282270726F6365737352656622293D3D3D657D29293B693D7226266E2E66696E64526F6F7428722E6964297D69662821692972657475726E5B5D3B766172206F2C613D';
wwv_flow_imp.g_varchar2_table(651) := '286F3D22222B286F3D652E6E616D657C7C652E6964292926266F2E7265706C616365282F5B263C3E22275D2F672C2866756E6374696F6E2865297B72657475726E205A745B655D7D29292C733D516528273C6C693E3C7370616E20636C6173733D22626A';
wwv_flow_imp.g_varchar2_table(652) := '732D6372756D62223E3C61207469746C653D22272B612B27223E272B612B223C2F613E3C2F7370616E3E3C2F6C693E22293B72657475726E20732E6164644576656E744C697374656E65722822636C69636B222C2866756E6374696F6E28297B6E2E7365';
wwv_flow_imp.g_varchar2_table(653) := '74526F6F74456C656D656E742869297D29292C737D29293B692E696E6E657248544D4C3D22223B76617220733D722E6C656E6774683E313B6F2E746F67676C652822626A732D62726561646372756D62732D73686F776E222C73292C722E666F72456163';
wwv_flow_imp.g_varchar2_table(654) := '68282866756E6374696F6E2865297B692E617070656E644368696C642865297D29297D652E6F6E2822656C656D656E742E6368616E676564222C2866756E6374696F6E2865297B76617220743D4D28652E656C656D656E74293B6428612C2866756E6374';
wwv_flow_imp.g_varchar2_table(655) := '696F6E2865297B72657475726E20653D3D3D747D292926267328297D29292C652E6F6E2822726F6F742E736574222C2866756E6374696F6E2865297B7328652E656C656D656E74297D29297D66756E6374696F6E20746E28652C74297B766172206E3D6E';
wwv_flow_imp.g_varchar2_table(656) := '756C6C2C693D6E6577206E6E3B652E6F6E2822726F6F742E736574222C2866756E6374696F6E2865297B76617220723D652E656C656D656E742C6F3D742E76696577626F7828292C613D692E6765742872293B696628692E736574286E2C7B783A6F2E78';
wwv_flow_imp.g_varchar2_table(657) := '2C793A6F2E792C7A6F6F6D3A6F2E7363616C657D292C6E3D722C6B28722C2262706D6E3A53756250726F6365737322297C7C61297B613D617C7C7B783A302C793A302C7A6F6F6D3A317D3B76617220733D286F2E782D612E78292A6F2E7363616C652C6C';
wwv_flow_imp.g_varchar2_table(658) := '3D286F2E792D612E79292A6F2E7363616C653B303D3D3D732626303D3D3D6C7C7C742E7363726F6C6C287B64783A732C64793A6C7D292C612E7A6F6F6D213D3D6F2E7363616C652626742E7A6F6F6D28612E7A6F6F6D2C7B783A302C793A307D297D7D29';
wwv_flow_imp.g_varchar2_table(659) := '292C652E6F6E28226469616772616D2E636C656172222C2866756E6374696F6E28297B692E636C65617228292C6E3D6E756C6C7D29297D66756E6374696F6E206E6E28297B746869732E5F656E74726965733D5B5D2C746869732E7365743D66756E6374';
wwv_flow_imp.g_varchar2_table(660) := '696F6E28652C74297B766172206E3D21313B666F7228766172206920696E20746869732E5F656E747269657329696628746869732E5F656E74726965735B695D5B305D3D3D3D65297B746869732E5F656E74726965735B695D5B315D3D742C6E3D21303B';
wwv_flow_imp.g_varchar2_table(661) := '627265616B7D6E7C7C746869732E5F656E74726965732E70757368285B652C745D297D2C746869732E6765743D66756E6374696F6E2865297B666F7228766172207420696E20746869732E5F656E747269657329696628746869732E5F656E7472696573';
wwv_flow_imp.g_varchar2_table(662) := '5B745D5B305D3D3D3D652972657475726E20746869732E5F656E74726965735B745D5B315D3B72657475726E206E756C6C7D2C746869732E636C6561723D66756E6374696F6E28297B746869732E5F656E74726965732E6C656E6774683D307D2C746869';
wwv_flow_imp.g_varchar2_table(663) := '732E72656D6F76653D66756E6374696F6E2865297B76617220743D2D313B666F7228766172206E20696E20746869732E5F656E747269657329696628746869732E5F656E74726965735B6E5D5B305D3D3D3D65297B743D6E3B627265616B7D2D31213D3D';
wwv_flow_imp.g_varchar2_table(664) := '742626746869732E5F656E74726965732E73706C69636528742C31297D7D656E2E24696E6A6563743D5B226576656E74427573222C22656C656D656E745265676973747279222C2263616E766173225D2C746E2E24696E6A6563743D5B226576656E7442';
wwv_flow_imp.g_varchar2_table(665) := '7573222C2263616E766173225D3B66756E6374696F6E20726E28652C74297B746869732E5F6576656E744275733D652C746869732E5F6D6F64646C653D743B766172206E3D746869733B652E6F6E2822696D706F72742E72656E6465722E737461727422';
wwv_flow_imp.g_varchar2_table(666) := '2C313530302C2866756E6374696F6E28652C74297B6E2E5F68616E646C65496D706F727428742E646566696E6974696F6E73297D29297D66756E6374696F6E206F6E2865297B72657475726E206B28652C2262706D6E64693A42504D4E4469616772616D';
wwv_flow_imp.g_varchar2_table(667) := '22293F653A6F6E28652E24706172656E74297D726E2E70726F746F747970652E5F68616E646C65496D706F72743D66756E6374696F6E2865297B696628652E6469616772616D73297B76617220743D746869733B746869732E5F646566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(668) := '733D652C746869732E5F70726F63657373546F4469616772616D4D61703D7B7D2C652E6469616772616D732E666F7245616368282866756E6374696F6E2865297B652E706C616E652626652E706C616E652E62706D6E456C656D656E74262628742E5F70';
wwv_flow_imp.g_varchar2_table(669) := '726F63657373546F4469616772616D4D61705B652E706C616E652E62706D6E456C656D656E742E69645D3D65297D29292C652E6469616772616D732E66696C7465722828653D3E652E706C616E6529292E666C61744D61702828653D3E742E5F63726561';
wwv_flow_imp.g_varchar2_table(670) := '74654E65774469616772616D7328652E706C616E652929292E666F7245616368282866756E6374696F6E2865297B742E5F6D6F7665506C616E65456C656D656E7473546F4F726967696E28652E706C616E65297D29297D7D2C726E2E70726F746F747970';
wwv_flow_imp.g_varchar2_table(671) := '652E5F6372656174654E65774469616772616D733D66756E6374696F6E2865297B76617220743D746869732C6E3D5B5D2C693D5B5D3B652E6765742822706C616E65456C656D656E7422292E666F7245616368282866756E6374696F6E2874297B766172';
wwv_flow_imp.g_varchar2_table(672) := '20723D742E62706D6E456C656D656E743B69662872297B766172206F3D722E24706172656E743B6B28722C2262706D6E3A53756250726F636573732229262621742E6973457870616E64656426266E2E707573682872292C66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(673) := '297B766172206E3D652E24706172656E743B72657475726E2128216B286E2C2262706D6E3A53756250726F6365737322297C7C6E3D3D3D742E62706D6E456C656D656E74292626215228652C5B2262706D6E3A44617461496E7075744173736F63696174';
wwv_flow_imp.g_varchar2_table(674) := '696F6E222C2262706D6E3A446174614F75747075744173736F63696174696F6E225D297D28722C65292626692E70757368287B6469456C656D656E743A742C706172656E743A6F7D297D7D29293B76617220723D5B5D3B72657475726E206E2E666F7245';
wwv_flow_imp.g_varchar2_table(675) := '616368282866756E6374696F6E2865297B69662821742E5F70726F63657373546F4469616772616D4D61705B652E69645D297B766172206E3D742E5F6372656174654469616772616D2865293B742E5F70726F63657373546F4469616772616D4D61705B';
wwv_flow_imp.g_varchar2_table(676) := '652E69645D3D6E2C722E70757368286E297D7D29292C692E666F7245616368282866756E6374696F6E2865297B666F722876617220693D652E6469456C656D656E742C723D652E706172656E743B7226262D313D3D3D6E2E696E6465784F662872293B29';
wwv_flow_imp.g_varchar2_table(677) := '723D722E24706172656E743B69662872297B766172206F3D742E5F70726F63657373546F4469616772616D4D61705B722E69645D3B742E5F6D6F7665546F4469506C616E6528692C6F2E706C616E65297D7D29292C727D2C726E2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(678) := '2E5F6D6F7665506C616E65456C656D656E7473546F4F726967696E3D66756E6374696F6E2865297B76617220743D652E6765742822706C616E65456C656D656E7422292C6E3D66756E6374696F6E2865297B76617220742C6E3D7B746F703A312F302C72';
wwv_flow_imp.g_varchar2_table(679) := '696768743A2D312F302C626F74746F6D3A2D312F302C6C6566743A312F307D3B72657475726E20652E706C616E65456C656D656E742E666F7245616368282866756E6374696F6E2865297B696628652E626F756E6473297B76617220743D6B7428652E62';
wwv_flow_imp.g_varchar2_table(680) := '6F756E6473293B6E2E746F703D4D6174682E6D696E28742E746F702C6E2E746F70292C6E2E6C6566743D4D6174682E6D696E28742E6C6566742C6E2E6C656674297D7D29292C7B783A28743D6E292E6C6566742C793A742E746F702C77696474683A742E';
wwv_flow_imp.g_varchar2_table(681) := '72696768742D742E6C6566742C6865696768743A742E626F74746F6D2D742E746F707D7D2865292C693D6E2E782D3138302C723D6E2E792D3136303B742E666F7245616368282866756E6374696F6E2865297B652E776179706F696E743F652E77617970';
wwv_flow_imp.g_varchar2_table(682) := '6F696E742E666F7245616368282866756E6374696F6E2865297B652E783D652E782D692C652E793D652E792D727D29293A652E626F756E6473262628652E626F756E64732E783D652E626F756E64732E782D692C652E626F756E64732E793D652E626F75';
wwv_flow_imp.g_varchar2_table(683) := '6E64732E792D72297D29297D2C726E2E70726F746F747970652E5F6D6F7665546F4469506C616E653D66756E6374696F6E28652C74297B766172206E3D6F6E2865292E706C616E652E6765742822706C616E65456C656D656E7422293B6E2E73706C6963';
wwv_flow_imp.g_varchar2_table(684) := '65286E2E696E6465784F662865292C31292C742E6765742822706C616E65456C656D656E7422292E707573682865297D2C726E2E70726F746F747970652E5F6372656174654469616772616D3D66756E6374696F6E2865297B76617220743D746869732E';
wwv_flow_imp.g_varchar2_table(685) := '5F6D6F64646C652E637265617465282262706D6E64693A42504D4E506C616E65222C7B62706D6E456C656D656E743A657D292C6E3D746869732E5F6D6F64646C652E637265617465282262706D6E64693A42504D4E4469616772616D222C7B706C616E65';
wwv_flow_imp.g_varchar2_table(686) := '3A747D293B72657475726E20742E24706172656E743D6E2C742E62706D6E456C656D656E743D652C6E2E24706172656E743D746869732E5F646566696E6974696F6E732C746869732E5F646566696E6974696F6E732E6469616772616D732E7075736828';
wwv_flow_imp.g_varchar2_table(687) := '6E292C6E7D2C726E2E24696E6A6563743D5B226576656E74427573222C226D6F64646C65225D3B76617220616E3D3235303B66756E6374696F6E20736E28652C742C6E2C692C72297B55742E63616C6C28746869732C74292C746869732E5F63616E7661';
wwv_flow_imp.g_varchar2_table(688) := '733D652C746869732E5F6576656E744275733D742C746869732E5F656C656D656E7452656769737472793D6E2C746869732E5F6F7665726C6179733D692C746869732E5F7472616E736C6174653D723B766172206F3D746869733B746869732E65786563';
wwv_flow_imp.g_varchar2_table(689) := '75746564282273686170652E746F67676C65436F6C6C61707365222C616E2C2866756E6374696F6E2865297B76617220743D652E73686170653B6F2E5F63616E4472696C6C446F776E2874293F6F2E5F6164644F7665726C61792874293A6F2E5F72656D';
wwv_flow_imp.g_varchar2_table(690) := '6F76654F7665726C61792874297D292C2130292C746869732E7265766572746564282273686170652E746F67676C65436F6C6C61707365222C616E2C2866756E6374696F6E2865297B76617220743D652E73686170653B6F2E5F63616E4472696C6C446F';
wwv_flow_imp.g_varchar2_table(691) := '776E2874293F6F2E5F6164644F7665726C61792874293A6F2E5F72656D6F76654F7665726C61792874297D292C2130292C746869732E6578656375746564285B2273686170652E637265617465222C2273686170652E6D6F7665222C2273686170652E64';
wwv_flow_imp.g_varchar2_table(692) := '656C657465225D2C616E2C2866756E6374696F6E2865297B76617220743D652E6F6C64506172656E742C6E3D652E6E6577506172656E747C7C652E706172656E742C693D652E73686170653B6F2E5F63616E4472696C6C446F776E28692926266F2E5F61';
wwv_flow_imp.g_varchar2_table(693) := '64644F7665726C61792869292C6F2E5F7570646174654472696C6C646F776E4F7665726C61792874292C6F2E5F7570646174654472696C6C646F776E4F7665726C6179286E292C6F2E5F7570646174654472696C6C646F776E4F7665726C61792869297D';
wwv_flow_imp.g_varchar2_table(694) := '292C2130292C746869732E7265766572746564285B2273686170652E637265617465222C2273686170652E6D6F7665222C2273686170652E64656C657465225D2C616E2C2866756E6374696F6E2865297B76617220743D652E6F6C64506172656E742C6E';
wwv_flow_imp.g_varchar2_table(695) := '3D652E6E6577506172656E747C7C652E706172656E742C693D652E73686170653B6F2E5F63616E4472696C6C446F776E28692926266F2E5F6164644F7665726C61792869292C6F2E5F7570646174654472696C6C646F776E4F7665726C61792874292C6F';
wwv_flow_imp.g_varchar2_table(696) := '2E5F7570646174654472696C6C646F776E4F7665726C6179286E292C6F2E5F7570646174654472696C6C646F776E4F7665726C61792869297D292C2130292C742E6F6E2822696D706F72742E72656E6465722E636F6D706C657465222C2866756E637469';
wwv_flow_imp.g_varchar2_table(697) := '6F6E28297B6E2E66696C746572282866756E6374696F6E2865297B72657475726E206F2E5F63616E4472696C6C446F776E2865297D29292E6D6170282866756E6374696F6E2865297B6F2E5F6164644F7665726C61792865297D29297D29297D6E28736E';
wwv_flow_imp.g_varchar2_table(698) := '2C5574292C736E2E70726F746F747970652E5F7570646174654472696C6C646F776E4F7665726C61793D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661733B69662865297B766172206E3D742E66696E64526F6F742865293B6E';
wwv_flow_imp.g_varchar2_table(699) := '2626746869732E5F7570646174654F7665726C61795669736962696C697479286E297D7D2C736E2E70726F746F747970652E5F63616E4472696C6C446F776E3D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661733B7265747572';
wwv_flow_imp.g_varchar2_table(700) := '6E206B28652C2262706D6E3A53756250726F6365737322292626742E66696E64526F6F74285174286529297D2C736E2E70726F746F747970652E5F7570646174654F7665726C61795669736962696C6974793D66756E6374696F6E2865297B7661722074';
wwv_flow_imp.g_varchar2_table(701) := '3D746869732E5F6F7665726C6179732C6E3D4D2865292C693D742E676574287B656C656D656E743A6E2E69642C747970653A226472696C6C646F776E227D295B305D3B69662869297B76617220723D6E26266E2E6765742822666C6F77456C656D656E74';
wwv_flow_imp.g_varchar2_table(702) := '73222926266E2E6765742822666C6F77456C656D656E747322292E6C656E6774683B496528692E68746D6C292E746F67676C652822626A732D6472696C6C646F776E2D656D707479222C2172297D7D2C736E2E70726F746F747970652E5F6164644F7665';
wwv_flow_imp.g_varchar2_table(703) := '726C61793D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661732C6E3D746869732E5F6F7665726C6179732C693D4D2865293B6E2E676574287B656C656D656E743A652C747970653A226472696C6C646F776E227D292E6C656E67';
wwv_flow_imp.g_varchar2_table(704) := '74682626746869732E5F72656D6F76654F7665726C61792865293B76617220723D516528273C627574746F6E20747970653D22627574746F6E2220636C6173733D22626A732D6472696C6C646F776E223E3C73766720786D6C6E733D22687474703A2F2F';
wwv_flow_imp.g_varchar2_table(705) := '7777772E77332E6F72672F323030302F737667222077696474683D22323022206865696768743D223230222076696577426F783D22302030203136203136223E3C706174682066696C6C2D72756C653D226576656E6F64642220643D224D342E38313830';
wwv_flow_imp.g_varchar2_table(706) := '313934382C332E3530373335393331204C31302E343939363839342C392E31383936383934204C31302E352C34204C31322C34204C31322C3132204C342C3132204C342C31302E35204C392E363839363839342C31302E34393936383934204C332E3735';
wwv_flow_imp.g_varchar2_table(707) := '3733353933312C342E35363830313934382043332E34363434363630392C342E323735313236323720332E34363434363630392C332E383030323532353320332E37353733353933312C332E35303733353933312043342E30353032353235332C332E32';
wwv_flow_imp.g_varchar2_table(708) := '3134343636303920342E35323531323632372C332E323134343636303920342E38313830313934382C332E3530373335393331205A222F3E3C2F7376673E3C2F627574746F6E3E27292C6F3D692E67657428226E616D6522297C7C692E67657428226964';
wwv_flow_imp.g_varchar2_table(709) := '22292C613D746869732E5F7472616E736C61746528224F70656E207B656C656D656E747D222C7B656C656D656E743A6F7D293B722E73657441747472696275746528227469746C65222C61292C722E6164644576656E744C697374656E65722822636C69';
wwv_flow_imp.g_varchar2_table(710) := '636B222C2866756E6374696F6E28297B742E736574526F6F74456C656D656E7428742E66696E64526F6F7428517428652929297D29292C6E2E61646428652C226472696C6C646F776E222C7B706F736974696F6E3A7B626F74746F6D3A2D372C72696768';
wwv_flow_imp.g_varchar2_table(711) := '743A2D387D2C68746D6C3A727D292C746869732E5F7570646174654F7665726C61795669736962696C6974792865297D2C736E2E70726F746F747970652E5F72656D6F76654F7665726C61793D66756E6374696F6E2865297B746869732E5F6F7665726C';
wwv_flow_imp.g_varchar2_table(712) := '6179732E72656D6F7665287B656C656D656E743A652C747970653A226472696C6C646F776E227D297D2C736E2E24696E6A6563743D5B2263616E766173222C226576656E74427573222C22656C656D656E745265676973747279222C226F7665726C6179';
wwv_flow_imp.g_varchar2_table(713) := '73222C227472616E736C617465225D3B636F6E7374206C6E3D7B5F5F646570656E64735F5F3A5B47742C4B742C58745D2C5F5F696E69745F5F3A5B226472696C6C646F776E42726561646372756D6273222C226472696C6C646F776E4F7665726C617942';
wwv_flow_imp.g_varchar2_table(714) := '65686176696F72222C226472696C6C646F776E43656E746572696E67222C2273756270726F63657373436F6D7061746962696C697479225D2C6472696C6C646F776E42726561646372756D62733A5B2274797065222C656E5D2C6472696C6C646F776E43';
wwv_flow_imp.g_varchar2_table(715) := '656E746572696E673A5B2274797065222C746E5D2C6472696C6C646F776E4F7665726C61794265686176696F723A5B2274797065222C736E5D2C73756270726F63657373436F6D7061746962696C6974793A5B2274797065222C726E5D7D3B66756E6374';
wwv_flow_imp.g_varchar2_table(716) := '696F6E20636E28652C74297B746869732E5F6576656E744275733D652C746869732E6F66667365743D353B766172206E3D742E636C732822646A732D6F75746C696E65222C5B226E6F2D66696C6C225D292C693D746869733B66756E6374696F6E207228';
wwv_flow_imp.g_varchar2_table(717) := '65297B76617220743D5828227265637422293B72657475726E207A28742C53287B783A302C793A302C72783A342C77696474683A3130302C6865696768743A3130307D2C6E29292C747D652E6F6E285B2273686170652E6164646564222C227368617065';
wwv_flow_imp.g_varchar2_table(718) := '2E6368616E676564225D2C3530302C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E6766782C6F3D657428222E646A732D6F75746C696E65222C6E293B6F7C7C6A286E2C6F3D692E6765744F75746C696E652874297C';
wwv_flow_imp.g_varchar2_table(719) := '7C722829292C692E75706461746553686170654F75746C696E65286F2C74297D29292C652E6F6E285B22636F6E6E656374696F6E2E6164646564222C22636F6E6E656374696F6E2E6368616E676564225D2C2866756E6374696F6E2865297B7661722074';
wwv_flow_imp.g_varchar2_table(720) := '3D652E656C656D656E742C6E3D652E6766782C6F3D657428222E646A732D6F75746C696E65222C6E293B6F7C7C6A286E2C6F3D722829292C692E757064617465436F6E6E656374696F6E4F75746C696E65286F2C74297D29297D636E2E70726F746F7479';
wwv_flow_imp.g_varchar2_table(721) := '70652E75706461746553686170654F75746C696E653D66756E6374696F6E28652C74297B766172206E3D21312C693D746869732E5F67657450726F76696465727328293B692E6C656E67746826266628692C2866756E6374696F6E2869297B6E3D6E7C7C';
wwv_flow_imp.g_varchar2_table(722) := '692E7570646174654F75746C696E6528742C65297D29292C6E7C7C7A28652C7B783A2D746869732E6F66667365742C793A2D746869732E6F66667365742C77696474683A742E77696474682B322A746869732E6F66667365742C6865696768743A742E68';
wwv_flow_imp.g_varchar2_table(723) := '65696768742B322A746869732E6F66667365747D297D2C636E2E70726F746F747970652E757064617465436F6E6E656374696F6E4F75746C696E653D66756E6374696F6E28652C74297B766172206E3D4E742874293B7A28652C7B783A6E2E782D746869';
wwv_flow_imp.g_varchar2_table(724) := '732E6F66667365742C793A6E2E792D746869732E6F66667365742C77696474683A6E2E77696474682B322A746869732E6F66667365742C6865696768743A6E2E6865696768742B322A746869732E6F66667365747D297D2C636E2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(725) := '2E726567697374657250726F76696465723D66756E6374696F6E28652C74297B747C7C28743D652C653D316533292C746869732E5F6576656E744275732E6F6E28226F75746C696E652E67657450726F766964657273222C652C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(726) := '65297B652E70726F7669646572732E707573682874297D29297D2C636E2E70726F746F747970652E5F67657450726F7669646572733D66756E6374696F6E28297B76617220653D746869732E5F6576656E744275732E6372656174654576656E74287B74';
wwv_flow_imp.g_varchar2_table(727) := '7970653A226F75746C696E652E67657450726F766964657273222C70726F7669646572733A5B5D7D293B72657475726E20746869732E5F6576656E744275732E666972652865292C652E70726F7669646572737D2C636E2E70726F746F747970652E6765';
wwv_flow_imp.g_varchar2_table(728) := '744F75746C696E653D66756E6374696F6E2865297B76617220743B72657475726E206628746869732E5F67657450726F76696465727328292C2866756E6374696F6E286E297B70286E2E6765744F75746C696E6529262628743D747C7C6E2E6765744F75';
wwv_flow_imp.g_varchar2_table(729) := '746C696E65286529297D29292C747D2C636E2E24696E6A6563743D5B226576656E74427573222C227374796C6573222C22656C656D656E745265676973747279225D3B636F6E737420706E3D7B5F5F696E69745F5F3A5B226F75746C696E65225D2C6F75';
wwv_flow_imp.g_varchar2_table(730) := '746C696E653A5B2274797065222C636E5D7D2C756E3D7B77696474683A33362C6865696768743A35307D2C686E3D7B77696474683A35302C6865696768743A35307D3B66756E6374696F6E20646E28652C742C6E297B72657475726E2058282270617468';
wwv_flow_imp.g_varchar2_table(731) := '222C7B643A652C7374726F6B6557696474683A322C7472616E73666F726D3A607472616E736C61746528247B742E787D2C20247B742E797D29602C2E2E2E6E7D297D66756E6374696F6E206D6E28652C74297B746869732E5F7374796C65733D742C652E';
wwv_flow_imp.g_varchar2_table(732) := '726567697374657250726F76696465722874686973297D66756E6374696F6E20666E28652C74297B766172206E3B72657475726E2262706D6E3A446174614F626A6563745265666572656E6365223D3D3D743F6E3D756E3A2262706D6E3A446174615374';
wwv_flow_imp.g_varchar2_table(733) := '6F72655265666572656E6365223D3D3D742626286E3D686E292C652E77696474683D3D3D6E2E77696474682626652E6865696768743D3D3D6E2E6865696768747D6D6E2E24696E6A6563743D5B226F75746C696E65222C227374796C6573225D2C6D6E2E';
wwv_flow_imp.g_varchar2_table(734) := '70726F746F747970652E6765744F75746C696E653D66756E6374696F6E2865297B636F6E737420743D746869732E5F7374796C65732E636C732822646A732D6F75746C696E65222C5B226E6F2D66696C6C225D293B766172206E3B696628214374286529';
wwv_flow_imp.g_varchar2_table(735) := '2972657475726E206B28652C2262706D6E3A4761746577617922293F285328286E3D582822726563742229292E7374796C652C7B227472616E73666F726D2D626F78223A2266696C6C2D626F78222C7472616E73666F726D3A22726F7461746528343564';
wwv_flow_imp.g_varchar2_table(736) := '656729222C227472616E73666F726D2D6F726967696E223A2263656E746572227D292C7A286E2C53287B783A322C793A322C72783A342C77696474683A652E77696474682D342C6865696768743A652E6865696768742D347D2C742929293A5228652C5B';
wwv_flow_imp.g_varchar2_table(737) := '2262706D6E3A5461736B222C2262706D6E3A53756250726F63657373222C2262706D6E3A47726F7570222C2262706D6E3A43616C6C4163746976697479225D293F7A286E3D5828227265637422292C53287B783A2D352C793A2D352C72783A31342C7769';
wwv_flow_imp.g_varchar2_table(738) := '6474683A652E77696474682B31302C6865696768743A652E6865696768742B31307D2C7429293A6B28652C2262706D6E3A456E644576656E7422293F7A286E3D582822636972636C6522292C53287B63783A652E77696474682F322C63793A652E686569';
wwv_flow_imp.g_varchar2_table(739) := '6768742F322C723A652E77696474682F322B352B317D2C7429293A6B28652C2262706D6E3A4576656E7422293F7A286E3D582822636972636C6522292C53287B63783A652E77696474682F322C63793A652E6865696768742F322C723A652E7769647468';
wwv_flow_imp.g_varchar2_table(740) := '2F322B357D2C7429293A6B28652C2262706D6E3A446174614F626A6563745265666572656E636522292626666E28652C2262706D6E3A446174614F626A6563745265666572656E636522293F6E3D646E28224D34342E373634382031312E333236334C33';
wwv_flow_imp.g_varchar2_table(741) := '362E3938393220322E36343037344333362E3034353120312E35383632382033342E3536353120302E3938383730382033332E3139303420302E39383837303848352E393836363743332E323236383820302E39383837303820302E3938393632342033';
wwv_flow_imp.g_varchar2_table(742) := '2E333438393220302E39383936323420362E32363033395635352E3032333543302E3938393632342035372E3933343920332E32323638382036302E3239353220352E39383636372036302E323935324834302E3936364334332E373235372036302E32';
wwv_flow_imp.g_varchar2_table(743) := '3935322034352E3936332035372E393334392034352E3936332035352E303233355631342E393435394334352E3936332031332E353939382034352E363430372031322E333034382034342E373634382031312E333236335A222C7B783A2D362C793A2D';
wwv_flow_imp.g_varchar2_table(744) := '367D2C74293A6B28652C2262706D6E3A4461746153746F72655265666572656E636522292626666E28652C2262706D6E3A4461746153746F72655265666572656E636522292626286E3D646E28224D312E30333834352034382E3133343743312E303338';
wwv_flow_imp.g_varchar2_table(745) := '34352034392E3335313120312E30373239352035302E37353820312E33383334322035322E30363443312E36393934392035332E3339333820322E33323432382035342E3731353420332E35363338332035352E3634323843362E30323533332035372E';
wwv_flow_imp.g_varchar2_table(746) := '343834312031302E313136312035382E373638352031342E383231322035392E363036374331392E353737322036302E343533382032352E313338382036302E383733382033302E363833312036302E383733384333362E323237362036302E38373338';
wwv_flow_imp.g_varchar2_table(747) := '2034312E373839312036302E343533382034362E3534352035392E363036374335312E323530342035382E373638372035352E333431322035372E343834322035372E383032382035352E363432394335392E303432342035342E373135362035392E36';
wwv_flow_imp.g_varchar2_table(748) := '3637332035332E333933382035392E393833342035322E3036344336302E323933382035302E373537392036302E333238352034392E3335312036302E333238352034382E313334345631332E383431354336302E333238352031322E36323439203630';
wwv_flow_imp.g_varchar2_table(749) := '2E323933382031312E3231382035392E3938333420392E39313137314335392E3636373320382E35383139342035392E3034323320372E323630322035372E3830323720362E33333239344335352E33343120342E34393136382035312E323530332033';
wwv_flow_imp.g_varchar2_table(750) := '2E32303732332034362E35343520322E33363931344334312E3738393120312E3532322033362E3232373620312E31303230342033302E3638333120312E31303230354332352E3133383820312E31303230362031392E3537373220312E353232303620';
wwv_flow_imp.g_varchar2_table(751) := '31342E3832313320322E33363932334331302E3131363220332E323037333420362E303235343320342E343931383320332E3536333920362E333333313443322E333234333320372E323630333820312E363939353120382E353832303620312E333833';
wwv_flow_imp.g_varchar2_table(752) := '343320392E393131383143312E30373239352031312E3231373920312E30333834352031322E3632343720312E30333834352031332E383431315634382E313334375A222C7B783A2D362C793A2D367D2C7429292C6E7D2C6D6E2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(753) := '2E7570646174654F75746C696E653D66756E6374696F6E28652C74297B6966282143742865292972657475726E205228652C5B2262706D6E3A53756250726F63657373222C2262706D6E3A47726F7570225D293F287A28742C7B77696474683A652E7769';
wwv_flow_imp.g_varchar2_table(754) := '6474682B31302C6865696768743A652E6865696768742B31307D292C2130293A21215228652C5B2262706D6E3A4576656E74222C2262706D6E3A47617465776179222C2262706D6E3A4461746153746F72655265666572656E6365222C2262706D6E3A44';
wwv_flow_imp.g_varchar2_table(755) := '6174614F626A6563745265666572656E6365225D297D3B636F6E737420796E3D7B5F5F646570656E64735F5F3A5B706E5D2C5F5F696E69745F5F3A5B226F75746C696E6550726F7669646572225D2C6F75746C696E6550726F76696465723A5B22747970';
wwv_flow_imp.g_varchar2_table(756) := '65222C6D6E5D7D3B66756E6374696F6E20676E2865297B72657475726E20652E6F726967696E616C4576656E747C7C652E7372634576656E747D66756E6374696F6E20766E2865297B72657475726E20652E706F696E746572732626652E706F696E7465';
wwv_flow_imp.g_varchar2_table(757) := '72732E6C656E677468262628653D652E706F696E746572735B305D292C652E746F75636865732626652E746F75636865732E6C656E677468262628653D652E746F75636865735B305D292C653F7B783A652E636C69656E74582C793A652E636C69656E74';
wwv_flow_imp.g_varchar2_table(758) := '597D3A6E756C6C7D66756E6374696F6E20626E28652C74297B72657475726E28676E2865297C7C65292E627574746F6E3D3D3D747D66756E6374696F6E20786E2865297B72657475726E20626E28652C30297D66756E6374696F6E20776E2865297B7265';
wwv_flow_imp.g_varchar2_table(759) := '7475726E21307D66756E6374696F6E205F6E2865297B72657475726E20786E2865297C7C66756E6374696F6E2865297B72657475726E20626E28652C31297D2865297D66756E6374696F6E20456E28652C742C6E297B76617220693D746869733B66756E';
wwv_flow_imp.g_varchar2_table(760) := '6374696F6E2072286E2C692C72297B766172206F2C613B2866756E6374696F6E28652C74297B72657475726E21286C5B655D7C7C786E292874297D29286E2C69297C7C28723F613D742E67657447726170686963732872293A286F3D692E64656C656761';
wwv_flow_imp.g_varchar2_table(761) := '74655461726765747C7C692E74617267657429262628613D6F2C723D742E676574286129292C61262672262621313D3D3D652E66697265286E2C7B656C656D656E743A722C6766783A612C6F726967696E616C4576656E743A697D29262628692E73746F';
wwv_flow_imp.g_varchar2_table(762) := '7050726F7061676174696F6E28292C692E70726576656E7444656661756C74282929297D766172206F3D7B7D3B66756E6374696F6E20612865297B72657475726E206F5B655D7D76617220733D7B636C69636B3A22656C656D656E742E636C69636B222C';
wwv_flow_imp.g_varchar2_table(763) := '636F6E746578746D656E753A22656C656D656E742E636F6E746578746D656E75222C64626C636C69636B3A22656C656D656E742E64626C636C69636B222C6D6F757365646F776E3A22656C656D656E742E6D6F757365646F776E222C6D6F7573656D6F76';
wwv_flow_imp.g_varchar2_table(764) := '653A22656C656D656E742E6D6F7573656D6F7665222C6D6F7573656F7665723A22656C656D656E742E686F766572222C6D6F7573656F75743A22656C656D656E742E6F7574222C6D6F75736575703A22656C656D656E742E6D6F7573657570227D2C6C3D';
wwv_flow_imp.g_varchar2_table(765) := '7B22656C656D656E742E636F6E746578746D656E75223A776E2C22656C656D656E742E6D6F757365646F776E223A5F6E2C22656C656D656E742E6D6F7573657570223A5F6E2C22656C656D656E742E636C69636B223A5F6E2C22656C656D656E742E6462';
wwv_flow_imp.g_varchar2_table(766) := '6C636C69636B223A5F6E7D3B66756E6374696F6E206328652C742C6E2C69297B76617220613D6F5B6E5D3D66756E6374696F6E2865297B72286E2C65297D3B692626286C5B6E5D3D69292C612E2464656C65676174653D58652E62696E6428652C227376';
wwv_flow_imp.g_varchar2_table(767) := '672C202E646A732D656C656D656E74222C742C61297D66756E6374696F6E207028652C742C6E297B76617220693D61286E293B69262658652E756E62696E6428652C742C692E2464656C6567617465297D652E6F6E282263616E7661732E64657374726F';
wwv_flow_imp.g_varchar2_table(768) := '79222C2866756E6374696F6E2865297B76617220743B743D652E7376672C6628732C2866756E6374696F6E28652C6E297B7028742C6E2C65297D29297D29292C652E6F6E282263616E7661732E696E6974222C2866756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(769) := '743B743D652E7376672C6628732C2866756E6374696F6E28652C6E297B6328742C6E2C65297D29297D29292C652E6F6E285B2273686170652E6164646564222C22636F6E6E656374696F6E2E6164646564225D2C2866756E6374696F6E2874297B766172';
wwv_flow_imp.g_varchar2_table(770) := '206E3D742E656C656D656E742C693D742E6766783B652E666972652822696E746572616374696F6E4576656E74732E637265617465486974222C7B656C656D656E743A6E2C6766783A697D297D29292C652E6F6E285B2273686170652E6368616E676564';
wwv_flow_imp.g_varchar2_table(771) := '222C22636F6E6E656374696F6E2E6368616E676564225D2C3530302C2866756E6374696F6E2874297B766172206E3D742E656C656D656E742C693D742E6766783B652E666972652822696E746572616374696F6E4576656E74732E757064617465486974';
wwv_flow_imp.g_varchar2_table(772) := '222C7B656C656D656E743A6E2C6766783A697D297D29292C652E6F6E2822696E746572616374696F6E4576656E74732E637265617465486974222C3530302C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E6766783B';
wwv_flow_imp.g_varchar2_table(773) := '692E63726561746544656661756C7448697428742C6E297D29292C652E6F6E2822696E746572616374696F6E4576656E74732E757064617465486974222C2866756E6374696F6E2865297B76617220743D652E656C656D656E742C6E3D652E6766783B69';
wwv_flow_imp.g_varchar2_table(774) := '2E75706461746544656661756C7448697428742C6E297D29293B76617220753D6D2822646A732D68697420646A732D6869742D7374726F6B6522292C683D6D2822646A732D68697420646A732D6869742D636C69636B2D7374726F6B6522292C643D7B61';
wwv_flow_imp.g_varchar2_table(775) := '6C6C3A6D2822646A732D68697420646A732D6869742D616C6C22292C22636C69636B2D7374726F6B65223A682C7374726F6B653A752C226E6F2D6D6F7665223A6D2822646A732D68697420646A732D6869742D6E6F2D6D6F766522297D3B66756E637469';
wwv_flow_imp.g_varchar2_table(776) := '6F6E206D28652C74297B72657475726E20743D53287B7374726F6B653A227768697465222C7374726F6B6557696474683A31357D2C747C7C7B7D292C6E2E636C7328652C5B226E6F2D66696C6C222C226E6F2D626F72646572225D2C74297D66756E6374';
wwv_flow_imp.g_varchar2_table(777) := '696F6E207928652C74297B766172206E3D645B745D3B696628216E297468726F77206E6577204572726F722822696E76616C6964206869742074797065203C222B742B223E22293B72657475726E207A28652C6E292C657D66756E6374696F6E20672865';
wwv_flow_imp.g_varchar2_table(778) := '2C74297B6A28652C74297D746869732E72656D6F7665486974733D66756E6374696F6E2865297B662828657C7C646F63756D656E74292E717565727953656C6563746F72416C6C28222E646A732D68697422292C7365297D2C746869732E637265617465';
wwv_flow_imp.g_varchar2_table(779) := '44656661756C744869743D66756E6374696F6E28652C74297B766172206E2C693D652E776179706F696E74732C723D652E69734672616D653B72657475726E20693F746869732E637265617465576179706F696E747348697428742C69293A286E3D723F';
wwv_flow_imp.g_varchar2_table(780) := '227374726F6B65223A22616C6C222C746869732E637265617465426F7848697428742C6E2C7B77696474683A652E77696474682C6865696768743A652E6865696768747D29297D2C746869732E637265617465576179706F696E74734869743D66756E63';
wwv_flow_imp.g_varchar2_table(781) := '74696F6E28652C74297B766172206E3D66652874293B72657475726E2079286E2C227374726F6B6522292C6728652C6E292C6E7D2C746869732E637265617465426F784869743D66756E6374696F6E28652C742C6E297B6E3D53287B783A302C793A307D';
wwv_flow_imp.g_varchar2_table(782) := '2C6E293B76617220693D5828227265637422293B72657475726E207928692C74292C7A28692C6E292C6728652C69292C697D2C746869732E75706461746544656661756C744869743D66756E6374696F6E28652C74297B766172206E3D657428222E646A';
wwv_flow_imp.g_varchar2_table(783) := '732D686974222C74293B6966286E2972657475726E20652E776179706F696E74733F7965286E2C652E776179706F696E7473293A7A286E2C7B77696474683A652E77696474682C6865696768743A652E6865696768747D292C6E7D2C746869732E666972';
wwv_flow_imp.g_varchar2_table(784) := '653D722C746869732E747269676765724D6F7573654576656E743D66756E6374696F6E28652C742C6E297B76617220693D735B655D3B6966282169297468726F77206E6577204572726F722822756E6D617070656420444F4D206576656E74206E616D65';
wwv_flow_imp.g_varchar2_table(785) := '203C222B652B223E22293B72657475726E207228692C742C6E297D2C746869732E6D6F75736548616E646C65723D612C746869732E72656769737465724576656E743D632C746869732E756E72656769737465724576656E743D707D456E2E24696E6A65';
wwv_flow_imp.g_varchar2_table(786) := '63743D5B226576656E74427573222C22656C656D656E745265676973747279222C227374796C6573225D3B636F6E737420536E3D7B5F5F696E69745F5F3A5B22696E746572616374696F6E4576656E7473225D2C696E746572616374696F6E4576656E74';
wwv_flow_imp.g_varchar2_table(787) := '733A5B2274797065222C456E5D7D3B66756E6374696F6E20416E28652C74297B746869732E5F6576656E744275733D652C746869732E5F63616E7661733D742C746869732E5F73656C6563746564456C656D656E74733D5B5D3B766172206E3D74686973';
wwv_flow_imp.g_varchar2_table(788) := '3B652E6F6E285B2273686170652E72656D6F7665222C22636F6E6E656374696F6E2E72656D6F7665225D2C2866756E6374696F6E2865297B76617220743D652E656C656D656E743B6E2E646573656C6563742874297D29292C652E6F6E285B2264696167';
wwv_flow_imp.g_varchar2_table(789) := '72616D2E636C656172222C22726F6F742E736574225D2C2866756E6374696F6E2865297B6E2E73656C656374286E756C6C297D29297D416E2E24696E6A6563743D5B226576656E74427573222C2263616E766173225D2C416E2E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(790) := '646573656C6563743D66756E6374696F6E2865297B76617220743D746869732E5F73656C6563746564456C656D656E74732C6E3D742E696E6465784F662865293B6966282D31213D3D6E297B76617220693D742E736C69636528293B742E73706C696365';
wwv_flow_imp.g_varchar2_table(791) := '286E2C31292C746869732E5F6576656E744275732E66697265282273656C656374696F6E2E6368616E676564222C7B6F6C6453656C656374696F6E3A692C6E657753656C656374696F6E3A747D297D7D2C416E2E70726F746F747970652E6765743D6675';
wwv_flow_imp.g_varchar2_table(792) := '6E6374696F6E28297B72657475726E20746869732E5F73656C6563746564456C656D656E74737D2C416E2E70726F746F747970652E697353656C65637465643D66756E6374696F6E2865297B72657475726E2D31213D3D746869732E5F73656C65637465';
wwv_flow_imp.g_varchar2_table(793) := '64456C656D656E74732E696E6465784F662865297D2C416E2E70726F746F747970652E73656C6563743D66756E6374696F6E28652C74297B766172206E3D746869732E5F73656C6563746564456C656D656E74732C693D6E2E736C69636528293B732865';
wwv_flow_imp.g_varchar2_table(794) := '297C7C28653D653F5B655D3A5B5D293B76617220723D746869732E5F63616E7661732C6F3D722E676574526F6F74456C656D656E7428293B653D652E66696C746572282866756E6374696F6E2865297B76617220743D722E66696E64526F6F742865293B';
wwv_flow_imp.g_varchar2_table(795) := '72657475726E206F3D3D3D747D29292C743F6628652C2866756E6374696F6E2865297B2D313D3D3D6E2E696E6465784F6628652926266E2E707573682865297D29293A746869732E5F73656C6563746564456C656D656E74733D6E3D652E736C69636528';
wwv_flow_imp.g_varchar2_table(796) := '292C746869732E5F6576656E744275732E66697265282273656C656374696F6E2E6368616E676564222C7B6F6C6453656C656374696F6E3A692C6E657753656C656374696F6E3A6E7D297D3B76617220436E3D22686F766572222C6B6E3D2273656C6563';
wwv_flow_imp.g_varchar2_table(797) := '746564223B66756E6374696F6E20526E28652C742C6E297B746869732E5F63616E7661733D653B76617220693D746869733B66756E6374696F6E207228742C6E297B652E6164644D61726B657228742C6E297D66756E6374696F6E206F28742C6E297B65';
wwv_flow_imp.g_varchar2_table(798) := '2E72656D6F76654D61726B657228742C6E297D746869732E5F6D756C746953656C656374696F6E426F783D6E756C6C2C742E6F6E2822656C656D656E742E686F766572222C2866756E6374696F6E2865297B7228652E656C656D656E742C436E297D2929';
wwv_flow_imp.g_varchar2_table(799) := '2C742E6F6E2822656C656D656E742E6F7574222C2866756E6374696F6E2865297B6F28652E656C656D656E742C436E297D29292C742E6F6E282273656C656374696F6E2E6368616E676564222C2866756E6374696F6E2865297B76617220743D652E6F6C';
wwv_flow_imp.g_varchar2_table(800) := '6453656C656374696F6E2C6E3D652E6E657753656C656374696F6E3B6628742C2866756E6374696F6E2865297B2D313D3D3D6E2E696E6465784F6628652926266F28652C6B6E297D29292C66286E2C2866756E6374696F6E2865297B2D313D3D3D742E69';
wwv_flow_imp.g_varchar2_table(801) := '6E6465784F6628652926267228652C6B6E297D29292C692E5F75706461746553656C656374696F6E4F75746C696E65286E297D29292C742E6F6E2822656C656D656E742E6368616E676564222C2866756E6374696F6E2865297B6E2E697353656C656374';
wwv_flow_imp.g_varchar2_table(802) := '656428652E656C656D656E74292626692E5F75706461746553656C656374696F6E4F75746C696E65286E2E6765742829297D29297D66756E6374696F6E204D6E28652C742C6E2C69297B652E6F6E28226372656174652E656E64222C3530302C2866756E';
wwv_flow_imp.g_varchar2_table(803) := '6374696F6E2865297B766172206E3D652E636F6E746578742C693D6E2E63616E457865637574652C723D6E2E656C656D656E74732C6F3D286E2E68696E74737C7C7B7D292E6175746F53656C6563743B69662869297B69662821313D3D3D6F2972657475';
wwv_flow_imp.g_varchar2_table(804) := '726E3B73286F293F742E73656C656374286F293A742E73656C65637428722E66696C74657228506E29297D7D29292C652E6F6E2822636F6E6E6563742E656E64222C3530302C2866756E6374696F6E2865297B766172206E3D652E636F6E746578742E63';
wwv_flow_imp.g_varchar2_table(805) := '6F6E6E656374696F6E3B6E2626742E73656C656374286E297D29292C652E6F6E282273686170652E6D6F76652E656E64222C3530302C2866756E6374696F6E2865297B766172206E3D652E70726576696F757353656C656374696F6E7C7C5B5D2C723D69';
wwv_flow_imp.g_varchar2_table(806) := '2E67657428652E636F6E746578742E73686170652E6964293B64286E2C2866756E6374696F6E2865297B72657475726E20722E69643D3D3D652E69647D29297C7C742E73656C6563742872297D29292C652E6F6E2822656C656D656E742E636C69636B22';
wwv_flow_imp.g_varchar2_table(807) := '2C2866756E6374696F6E2865297B696628786E286529297B76617220693D652E656C656D656E743B693D3D3D6E2E676574526F6F74456C656D656E742829262628693D6E756C6C293B76617220723D742E697353656C65637465642869292C6F3D742E67';
wwv_flow_imp.g_varchar2_table(808) := '657428292E6C656E6774683E312C613D66756E6374696F6E2865297B76617220743D676E2865297C7C653B72657475726E20786E2865292626742E73686966744B65797D2865293B6966287226266F2972657475726E20613F742E646573656C65637428';
wwv_flow_imp.g_varchar2_table(809) := '69293A742E73656C6563742869293B723F742E646573656C6563742869293A742E73656C65637428692C61297D7D29297D66756E6374696F6E20506E2865297B72657475726E21652E68696464656E7D526E2E24696E6A6563743D5B2263616E76617322';
wwv_flow_imp.g_varchar2_table(810) := '2C226576656E74427573222C2273656C656374696F6E225D2C526E2E70726F746F747970652E5F75706461746553656C656374696F6E4F75746C696E653D66756E6374696F6E2865297B76617220743D746869732E5F63616E7661732E6765744C617965';
wwv_flow_imp.g_varchar2_table(811) := '72282273656C656374696F6E4F75746C696E6522293B4B2874293B766172206E3D652E6C656E6774683E313B6966284728746869732E5F63616E7661732E676574436F6E7461696E65722829295B6E3F22616464223A2272656D6F7665225D2822646A73';
wwv_flow_imp.g_varchar2_table(812) := '2D6D756C74692D73656C65637422292C6E297B76617220693D66756E6374696F6E2865297B72657475726E7B783A652E782D362C793A652E792D362C77696474683A652E77696474682B31322C6865696768743A652E6865696768742B31327D7D284E74';
wwv_flow_imp.g_varchar2_table(813) := '286529292C723D5828227265637422293B7A28722C53287B72783A337D2C6929292C472872292E6164642822646A732D73656C656374696F6E2D6F75746C696E6522292C6A28742C72297D7D2C4D6E2E24696E6A6563743D5B226576656E74427573222C';
wwv_flow_imp.g_varchar2_table(814) := '2273656C656374696F6E222C2263616E766173222C22656C656D656E745265676973747279225D3B636F6E737420446E3D7B5F5F696E69745F5F3A5B2273656C656374696F6E56697375616C73222C2273656C656374696F6E4265686176696F72225D2C';
wwv_flow_imp.g_varchar2_table(815) := '5F5F646570656E64735F5F3A5B536E2C706E5D2C73656C656374696F6E3A5B2274797065222C416E5D2C73656C656374696F6E56697375616C733A5B2274797065222C526E5D2C73656C656374696F6E4265686176696F723A5B2274797065222C4D6E5D';
wwv_flow_imp.g_varchar2_table(816) := '7D2C426E3D2F5E636C6173735B207B5D2F3B66756E6374696F6E204F6E2865297B72657475726E2041727261792E697341727261792865297D66756E6374696F6E20546E28652C74297B72657475726E204F626A6563742E70726F746F747970652E6861';
wwv_flow_imp.g_varchar2_table(817) := '734F776E50726F70657274792E63616C6C28652C74297D66756E6374696F6E204E6E282E2E2E65297B313D3D3D652E6C656E67746826264F6E28655B305D29262628653D655B305D293B636F6E737420743D28653D5B2E2E2E655D292E706F7028293B72';
wwv_flow_imp.g_varchar2_table(818) := '657475726E20742E24696E6A6563743D652C747D636F6E737420496E3D2F636F6E7374727563746F725C732A5B5E285D2A5C285C732A285B5E295D2A295C292F6D2C4C6E3D2F5E283F3A6173796E635C732B293F283F3A66756E6374696F6E5C732A5B5E';
wwv_flow_imp.g_varchar2_table(819) := '285D2A293F283F3A5C285C732A285B5E295D2A295C297C285C772B29292F6D2C6A6E3D2F5C2F5C2A285B5E2A5D2A295C2A5C2F2F6D3B66756E6374696F6E20466E2865297B6966282266756E6374696F6E22213D747970656F662065297468726F77206E';
wwv_flow_imp.g_varchar2_table(820) := '6577204572726F72286043616E6E6F7420616E6E6F746174652022247B657D222E20457870656374656420612066756E6374696F6E2160293B636F6E737420743D652E746F537472696E6728292E6D617463682866756E6374696F6E2865297B72657475';
wwv_flow_imp.g_varchar2_table(821) := '726E20426E2E7465737428652E746F537472696E672829297D2865293F496E3A4C6E293B69662821742972657475726E5B5D3B636F6E7374206E3D745B315D7C7C745B325D3B72657475726E206E26266E2E73706C697428222C22292E6D61702828653D';
wwv_flow_imp.g_varchar2_table(822) := '3E7B636F6E737420743D652E6D61746368286A6E293B72657475726E28742626745B315D7C7C65292E7472696D28297D29297C7C5B5D7D66756E6374696F6E20566E28652C74297B636F6E7374206E3D747C7C7B6765743A66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(823) := '297B696628692E707573682865292C21313D3D3D742972657475726E206E756C6C3B7468726F77207328604E6F2070726F766964657220666F722022247B657D222160297D7D2C693D5B5D2C723D746869732E5F70726F7669646572733D4F626A656374';
wwv_flow_imp.g_varchar2_table(824) := '2E637265617465286E2E5F70726F7669646572737C7C6E756C6C292C6F3D746869732E5F696E7374616E6365733D4F626A6563742E637265617465286E756C6C292C613D6F2E696E6A6563746F723D746869732C733D66756E6374696F6E2865297B636F';
wwv_flow_imp.g_varchar2_table(825) := '6E737420743D692E6A6F696E2822202D3E2022293B72657475726E20692E6C656E6774683D302C6E6577204572726F7228743F60247B657D20285265736F6C76696E673A20247B747D29603A65297D3B66756E6374696F6E206C28652C74297B69662821';
wwv_flow_imp.g_varchar2_table(826) := '725B655D2626652E696E636C7564657328222E2229297B636F6E737420743D652E73706C697428222E22293B6C6574206E3D6C28742E73686966742829293B666F72283B742E6C656E6774683B296E3D6E5B742E736869667428295D3B72657475726E20';
wwv_flow_imp.g_varchar2_table(827) := '6E7D696628546E286F2C65292972657475726E206F5B655D3B696628546E28722C6529297B6966282D31213D3D692E696E6465784F66286529297468726F7720692E707573682865292C73282243616E6E6F74207265736F6C76652063697263756C6172';
wwv_flow_imp.g_varchar2_table(828) := '20646570656E64656E63792122293B72657475726E20692E707573682865292C6F5B655D3D725B655D5B305D28725B655D5B315D292C692E706F7028292C6F5B655D7D72657475726E206E2E67657428652C74297D66756E6374696F6E206328652C7429';
wwv_flow_imp.g_varchar2_table(829) := '7B696628766F696420303D3D3D74262628743D7B7D292C2266756E6374696F6E22213D747970656F662065297B696628214F6E286529297468726F772073286043616E6E6F7420696E766F6B652022247B657D222E20457870656374656420612066756E';
wwv_flow_imp.g_varchar2_table(830) := '6374696F6E2160293B653D4E6E28652E736C6963652829297D72657475726E7B666E3A652C646570656E64656E636965733A28652E24696E6A6563747C7C466E286529292E6D61702828653D3E546E28742C65293F745B655D3A6C28652929297D7D6675';
wwv_flow_imp.g_varchar2_table(831) := '6E6374696F6E20702865297B636F6E73747B666E3A742C646570656E64656E636965733A6E7D3D632865293B72657475726E206E65772846756E6374696F6E2E70726F746F747970652E62696E642E63616C6C28742C6E756C6C2C2E2E2E6E29297D6675';
wwv_flow_imp.g_varchar2_table(832) := '6E6374696F6E207528652C742C6E297B636F6E73747B666E3A692C646570656E64656E636965733A727D3D6328652C6E293B72657475726E20692E6170706C7928742C72297D66756E6374696F6E20682865297B72657475726E204E6E2828743D3E652E';
wwv_flow_imp.g_varchar2_table(833) := '67657428742929297D66756E6374696F6E206428652C74297B696628742626742E6C656E677468297B636F6E7374206E3D4F626A6563742E637265617465286E756C6C292C693D4F626A6563742E637265617465286E756C6C292C6F3D5B5D2C613D5B5D';
wwv_flow_imp.g_varchar2_table(834) := '2C733D5B5D3B6C6574206C2C632C702C753B666F72286C6574206520696E2072296C3D725B655D2C2D31213D3D742E696E6465784F662865292626282270726976617465223D3D3D6C5B325D3F28633D6F2E696E6465784F66286C5B335D292C2D313D3D';
wwv_flow_imp.g_varchar2_table(835) := '3D633F28703D6C5B335D2E6372656174654368696C64285B5D2C74292C753D682870292C6F2E70757368286C5B335D292C612E707573682870292C732E707573682875292C6E5B655D3D5B752C652C2270726976617465222C705D293A6E5B655D3D5B73';
wwv_flow_imp.g_varchar2_table(836) := '5B635D2C652C2270726976617465222C615B635D5D293A6E5B655D3D5B6C5B325D2C6C5B315D5D2C695B655D3D2130292C22666163746F727922213D3D6C5B325D2626227479706522213D3D6C5B325D7C7C216C5B315D2E2473636F70657C7C742E666F';
wwv_flow_imp.g_varchar2_table(837) := '72456163682828743D3E7B2D31213D3D6C5B315D2E2473636F70652E696E6465784F662874292626286E5B655D3D5B6C5B325D2C6C5B315D5D2C695B745D3D2130297D29293B742E666F72456163682828653D3E7B69662821695B655D297468726F7720';
wwv_flow_imp.g_varchar2_table(838) := '6E6577204572726F7228274E6F2070726F766964657220666F722022272B652B27222E2043616E6E6F74207573652070726F76696465722066726F6D2074686520706172656E742127297D29292C652E756E7368696674286E297D72657475726E206E65';
wwv_flow_imp.g_varchar2_table(839) := '7720566E28652C61297D636F6E7374206D3D7B666163746F72793A752C747970653A702C76616C75653A66756E6374696F6E2865297B72657475726E20657D7D3B66756E6374696F6E206628652C74297B636F6E7374206E3D652E5F5F696E69745F5F7C';
wwv_flow_imp.g_varchar2_table(840) := '7C5B5D3B72657475726E2066756E6374696F6E28297B6E2E666F72456163682828653D3E7B22737472696E67223D3D747970656F6620653F742E6765742865293A742E696E766F6B652865297D29297D7D66756E6374696F6E20792865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(841) := '20743D652E5F5F6578706F7274735F5F3B69662874297B636F6E7374206E3D652E5F5F6D6F64756C65735F5F2C693D4F626A6563742E6B6579732865292E726564756365282828742C6E293D3E28225F5F6578706F7274735F5F22213D3D6E2626225F5F';
wwv_flow_imp.g_varchar2_table(842) := '6D6F64756C65735F5F22213D3D6E2626225F5F696E69745F5F22213D3D6E2626225F5F646570656E64735F5F22213D3D6E262628745B6E5D3D655B6E5D292C7429292C4F626A6563742E637265617465286E756C6C29292C6F3D6428286E7C7C5B5D292E';
wwv_flow_imp.g_varchar2_table(843) := '636F6E636174286929292C613D4E6E282866756E6374696F6E2865297B72657475726E206F2E6765742865297D29293B742E666F7245616368282866756E6374696F6E2865297B725B655D3D5B612C652C2270726976617465222C6F5D7D29293B636F6E';
wwv_flow_imp.g_varchar2_table(844) := '737420733D28652E5F5F696E69745F5F7C7C5B5D292E736C69636528293B72657475726E20732E756E7368696674282866756E6374696F6E28297B6F2E696E697428297D29292C6628653D4F626A6563742E61737369676E287B7D2C652C7B5F5F696E69';
wwv_flow_imp.g_varchar2_table(845) := '745F5F3A737D292C6F297D72657475726E204F626A6563742E6B6579732865292E666F7245616368282866756E6374696F6E2874297B696628225F5F696E69745F5F223D3D3D747C7C225F5F646570656E64735F5F223D3D3D742972657475726E3B636F';
wwv_flow_imp.g_varchar2_table(846) := '6E7374206E3D655B745D3B6966282270726976617465223D3D3D6E5B325D2972657475726E20766F696428725B745D3D6E293B636F6E737420693D6E5B305D2C6F3D6E5B315D3B725B745D3D5B6D5B695D2C246E28692C6F292C695D7D29292C6628652C';
wwv_flow_imp.g_varchar2_table(847) := '61297D66756E6374696F6E206728652C74297B72657475726E2D31213D3D652E696E6465784F662874297C7C2D31213D3D28653D28742E5F5F646570656E64735F5F7C7C5B5D292E72656475636528672C6529292E696E6465784F662874293F653A652E';
wwv_flow_imp.g_varchar2_table(848) := '636F6E6361742874297D746869732E6765743D6C2C746869732E696E766F6B653D752C746869732E696E7374616E74696174653D702C746869732E6372656174654368696C643D642C746869732E696E69743D66756E6374696F6E2865297B636F6E7374';
wwv_flow_imp.g_varchar2_table(849) := '20743D652E72656475636528672C5B5D292E6D61702879293B6C6574206E3D21313B72657475726E2066756E6374696F6E28297B6E7C7C286E3D21302C742E666F72456163682828653D3E6528292929297D7D2865297D66756E6374696F6E20246E2865';
wwv_flow_imp.g_varchar2_table(850) := '2C74297B72657475726E2276616C756522213D3D6526264F6E287429262628743D4E6E28742E736C696365282929292C747D66756E6374696F6E207A6E28652C74297B432E63616C6C28746869732C652C31292C746869732E434F4E4E454354494F4E5F';
wwv_flow_imp.g_varchar2_table(851) := '5354594C453D742E7374796C65285B226E6F2D66696C6C225D2C7B7374726F6B6557696474683A352C7374726F6B653A2266756368736961227D292C746869732E53484150455F5354594C453D742E7374796C65287B66696C6C3A227768697465222C73';
wwv_flow_imp.g_varchar2_table(852) := '74726F6B653A2266756368736961222C7374726F6B6557696474683A327D292C746869732E4652414D455F5354594C453D742E7374796C65285B226E6F2D66696C6C225D2C7B7374726F6B653A2266756368736961222C7374726F6B6544617368617272';
wwv_flow_imp.g_varchar2_table(853) := '61793A342C7374726F6B6557696474683A327D297D6E287A6E2C43292C7A6E2E70726F746F747970652E63616E52656E6465723D66756E6374696F6E28297B72657475726E21307D2C7A6E2E70726F746F747970652E6472617753686170653D66756E63';
wwv_flow_imp.g_varchar2_table(854) := '74696F6E28652C742C6E297B76617220693D5828227265637422293B72657475726E207A28692C7B783A302C793A302C77696474683A742E77696474687C7C302C6865696768743A742E6865696768747C7C307D292C4C742874293F7A28692C53287B7D';
wwv_flow_imp.g_varchar2_table(855) := '2C746869732E4652414D455F5354594C452C6E7C7C7B7D29293A7A28692C53287B7D2C746869732E53484150455F5354594C452C6E7C7C7B7D29292C6A28652C69292C697D2C7A6E2E70726F746F747970652E64726177436F6E6E656374696F6E3D6675';
wwv_flow_imp.g_varchar2_table(856) := '6E6374696F6E28652C742C6E297B76617220693D666528742E776179706F696E74732C53287B7D2C746869732E434F4E4E454354494F4E5F5354594C452C6E7C7C7B7D29293B72657475726E206A28652C69292C697D2C7A6E2E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(857) := '6765745368617065506174683D66756E6374696F6E2865297B76617220743D652E782C6E3D652E792C693D652E77696474683B72657475726E207065285B5B224D222C742C6E5D2C5B226C222C692C305D2C5B226C222C302C652E6865696768745D2C5B';
wwv_flow_imp.g_varchar2_table(858) := '226C222C2D692C305D2C5B227A225D5D297D2C7A6E2E70726F746F747970652E676574436F6E6E656374696F6E506174683D66756E6374696F6E2865297B76617220742C6E2C693D652E776179706F696E74732C723D5B5D3B666F7228743D303B6E3D69';
wwv_flow_imp.g_varchar2_table(859) := '5B745D3B742B2B296E3D6E2E6F726967696E616C7C7C6E2C722E70757368285B303D3D3D743F224D223A224C222C6E2E782C6E2E795D293B72657475726E2070652872297D2C7A6E2E24696E6A6563743D5B226576656E74427573222C227374796C6573';
wwv_flow_imp.g_varchar2_table(860) := '225D3B636F6E737420576E3D7B5F5F696E69745F5F3A5B2264656661756C7452656E6465726572225D2C64656661756C7452656E64657265723A5B2274797065222C7A6E5D2C7374796C65733A5B2274797065222C66756E6374696F6E28297B76617220';
wwv_flow_imp.g_varchar2_table(861) := '653D7B226E6F2D66696C6C223A7B66696C6C3A226E6F6E65227D2C226E6F2D626F72646572223A7B7374726F6B654F7061636974793A307D2C226E6F2D6576656E7473223A7B706F696E7465724576656E74733A226E6F6E65227D7D2C743D746869733B';
wwv_flow_imp.g_varchar2_table(862) := '746869732E636C733D66756E6374696F6E28652C742C6E297B72657475726E205328746869732E7374796C6528742C6E292C7B636C6173733A657D297D2C746869732E7374796C653D66756E6374696F6E28742C6E297B732874297C7C6E7C7C286E3D74';
wwv_flow_imp.g_varchar2_table(863) := '2C743D5B5D293B76617220693D7928742C2866756E6374696F6E28742C6E297B72657475726E205328742C655B6E5D7C7C7B7D297D292C7B7D293B72657475726E206E3F5328692C6E293A697D2C746869732E636F6D707574655374796C653D66756E63';
wwv_flow_imp.g_varchar2_table(864) := '74696F6E28652C6E2C69297B72657475726E2073286E297C7C28693D6E2C6E3D5B5D292C742E7374796C65286E7C7C5B5D2C53287B7D2C692C657C7C7B7D29297D7D5D7D3B66756E6374696F6E20476E28652C74297B72657475726E204D6174682E726F';
wwv_flow_imp.g_varchar2_table(865) := '756E6428652A74292F747D66756E6374696F6E20486E2865297B72657475726E20632865293F652B227078223A657D66756E6374696F6E204B6E28652C742C6E297B636F6E737420693D5828226722293B472869292E6164642874293B636F6E73742072';
wwv_flow_imp.g_varchar2_table(866) := '3D766F69642030213D3D6E3F6E3A652E6368696C644E6F6465732E6C656E6774682D313B72657475726E20652E696E736572744265666F726528692C652E6368696C644E6F6465735B725D7C7C6E756C6C292C697D636F6E737420556E3D7B7368617065';
wwv_flow_imp.g_varchar2_table(867) := '3A5B2278222C2279222C227769647468222C22686569676874225D2C636F6E6E656374696F6E3A5B22776179706F696E7473225D7D3B66756E6374696F6E20716E28652C742C6E2C69297B746869732E5F6576656E744275733D742C746869732E5F656C';
wwv_flow_imp.g_varchar2_table(868) := '656D656E7452656769737472793D692C746869732E5F6772617068696373466163746F72793D6E2C746869732E5F726F6F74734964783D302C746869732E5F6C61796572733D7B7D2C746869732E5F706C616E65733D5B5D2C746869732E5F726F6F7445';
wwv_flow_imp.g_varchar2_table(869) := '6C656D656E743D6E756C6C2C746869732E5F696E697428657C7C7B7D297D66756E6374696F6E20596E28652C74297B636F6E7374206E3D226D617472697828222B742E612B222C222B742E622B222C222B742E632B222C222B742E642B222C222B742E65';
wwv_flow_imp.g_varchar2_table(870) := '2B222C222B742E662B2229223B652E73657441747472696275746528227472616E73666F726D222C6E297D716E2E24696E6A6563743D5B22636F6E6669672E63616E766173222C226576656E74427573222C226772617068696373466163746F7279222C';
wwv_flow_imp.g_varchar2_table(871) := '22656C656D656E745265676973747279225D2C716E2E70726F746F747970652E5F696E69743D66756E6374696F6E2865297B636F6E737420743D746869732E5F6576656E744275732C6E3D746869732E5F636F6E7461696E65723D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(872) := '65297B636F6E737420743D28653D53287B7D2C7B77696474683A2231303025222C6865696768743A2231303025227D2C6529292E636F6E7461696E65727C7C646F63756D656E742E626F64792C6E3D646F63756D656E742E637265617465456C656D656E';
wwv_flow_imp.g_varchar2_table(873) := '74282264697622293B72657475726E206E2E7365744174747269627574652822636C617373222C22646A732D636F6E7461696E657220646A732D706172656E7422292C4F65286E2C7B706F736974696F6E3A2272656C6174697665222C6F766572666C6F';
wwv_flow_imp.g_varchar2_table(874) := '773A2268696464656E222C77696474683A486E28652E7769647468292C6865696768743A486E28652E686569676874297D292C742E617070656E644368696C64286E292C6E7D2865292C693D746869732E5F7376673D58282273766722293B7A28692C7B';
wwv_flow_imp.g_varchar2_table(875) := '77696474683A2231303025222C6865696768743A2231303025227D292C6A286E2C69293B636F6E737420723D746869732E5F76696577706F72743D4B6E28692C2276696577706F727422293B652E6465666572557064617465262628746869732E5F7669';
wwv_flow_imp.g_varchar2_table(876) := '6577626F784368616E6765643D66756E6374696F6E28652C74297B6C6574206E2C692C722C6F3B66756E6374696F6E2061286E297B6C657420613D446174652E6E6F7728292C633D6E3F303A6F2B742D613B696628633E302972657475726E2073286329';
wwv_flow_imp.g_varchar2_table(877) := '3B652E6170706C7928722C69292C6C28297D66756E6374696F6E20732865297B6E3D73657454696D656F757428612C65297D66756E6374696F6E206C28297B6E2626636C65617254696D656F7574286E292C6E3D6F3D693D723D766F696420307D66756E';
wwv_flow_imp.g_varchar2_table(878) := '6374696F6E2063282E2E2E65297B6F3D446174652E6E6F7728292C693D652C723D746869732C6E7C7C732874297D72657475726E20632E666C7573683D66756E6374696F6E28297B6E262661282130292C6C28297D2C632E63616E63656C3D6C2C637D28';
wwv_flow_imp.g_varchar2_table(879) := '4528746869732E5F76696577626F784368616E6765642C74686973292C33303029292C742E6F6E28226469616772616D2E696E6974222C2828293D3E7B742E66697265282263616E7661732E696E6974222C7B7376673A692C76696577706F72743A727D';
wwv_flow_imp.g_varchar2_table(880) := '297D29292C742E6F6E285B2273686170652E6164646564222C22636F6E6E656374696F6E2E6164646564222C2273686170652E72656D6F766564222C22636F6E6E656374696F6E2E72656D6F766564222C22656C656D656E74732E6368616E676564222C';
wwv_flow_imp.g_varchar2_table(881) := '22726F6F742E736574225D2C2828293D3E7B64656C65746520746869732E5F63616368656456696577626F787D29292C742E6F6E28226469616772616D2E64657374726F79222C3530302C746869732E5F64657374726F792C74686973292C742E6F6E28';
wwv_flow_imp.g_varchar2_table(882) := '226469616772616D2E636C656172222C3530302C746869732E5F636C6561722C74686973297D2C716E2E70726F746F747970652E5F64657374726F793D66756E6374696F6E28297B746869732E5F6576656E744275732E66697265282263616E7661732E';
wwv_flow_imp.g_varchar2_table(883) := '64657374726F79222C7B7376673A746869732E5F7376672C76696577706F72743A746869732E5F76696577706F72747D293B636F6E737420653D746869732E5F636F6E7461696E65722E706172656E744E6F64653B652626652E72656D6F76654368696C';
wwv_flow_imp.g_varchar2_table(884) := '6428746869732E5F636F6E7461696E6572292C64656C65746520746869732E5F7376672C64656C65746520746869732E5F636F6E7461696E65722C64656C65746520746869732E5F6C61796572732C64656C65746520746869732E5F706C616E65732C64';
wwv_flow_imp.g_varchar2_table(885) := '656C65746520746869732E5F726F6F74456C656D656E742C64656C65746520746869732E5F76696577706F72747D2C716E2E70726F746F747970652E5F636C6561723D66756E6374696F6E28297B746869732E5F656C656D656E7452656769737472792E';
wwv_flow_imp.g_varchar2_table(886) := '676574416C6C28292E666F72456163682828653D3E7B636F6E737420743D49742865293B22726F6F74223D3D3D743F746869732E72656D6F7665526F6F74456C656D656E742865293A746869732E5F72656D6F7665456C656D656E7428652C74297D2929';
wwv_flow_imp.g_varchar2_table(887) := '2C746869732E5F706C616E65733D5B5D2C746869732E5F726F6F74456C656D656E743D6E756C6C2C64656C65746520746869732E5F63616368656456696577626F787D2C716E2E70726F746F747970652E67657444656661756C744C617965723D66756E';
wwv_flow_imp.g_varchar2_table(888) := '6374696F6E28297B72657475726E20746869732E6765744C61796572282262617365222C30297D2C716E2E70726F746F747970652E6765744C617965723D66756E6374696F6E28652C74297B6966282165297468726F77206E6577204572726F7228226D';
wwv_flow_imp.g_varchar2_table(889) := '75737420737065636966792061206E616D6522293B6C6574206E3D746869732E5F6C61796572735B655D3B6966286E7C7C286E3D746869732E5F6C61796572735B655D3D746869732E5F6372656174654C6179657228652C7429292C766F69642030213D';
wwv_flow_imp.g_varchar2_table(890) := '3D7426266E2E696E646578213D3D74297468726F77206E6577204572726F7228226C61796572203C222B652B223E20616C7265616479206372656174656420617420696E646578203C222B742B223E22293B72657475726E206E2E67726F75707D2C716E';
wwv_flow_imp.g_varchar2_table(891) := '2E70726F746F747970652E5F6765744368696C64496E6465783D66756E6374696F6E2865297B72657475726E207928746869732E5F6C61796572732C2866756E6374696F6E28742C6E297B72657475726E206E2E76697369626C652626653E3D6E2E696E';
wwv_flow_imp.g_varchar2_table(892) := '6465782626742B2B2C747D292C30297D2C716E2E70726F746F747970652E5F6372656174654C617965723D66756E6374696F6E28652C74297B766F696420303D3D3D74262628743D31293B636F6E7374206E3D746869732E5F6765744368696C64496E64';
wwv_flow_imp.g_varchar2_table(893) := '65782874293B72657475726E7B67726F75703A4B6E28746869732E5F76696577706F72742C226C617965722D222B652C6E292C696E6465783A742C76697369626C653A21307D7D2C716E2E70726F746F747970652E73686F774C617965723D66756E6374';
wwv_flow_imp.g_varchar2_table(894) := '696F6E2865297B6966282165297468726F77206E6577204572726F7228226D75737420737065636966792061206E616D6522293B636F6E737420743D746869732E5F6C61796572735B655D3B6966282174297468726F77206E6577204572726F7228226C';
wwv_flow_imp.g_varchar2_table(895) := '61796572203C222B652B223E20646F6573206E6F7420657869737422293B636F6E7374206E3D746869732E5F76696577706F72742C693D742E67726F75702C723D742E696E6465783B696628742E76697369626C652972657475726E20693B636F6E7374';
wwv_flow_imp.g_varchar2_table(896) := '206F3D746869732E5F6765744368696C64496E6465782872293B72657475726E206E2E696E736572744265666F726528692C6E2E6368696C644E6F6465735B6F5D7C7C6E756C6C292C742E76697369626C653D21302C697D2C716E2E70726F746F747970';
wwv_flow_imp.g_varchar2_table(897) := '652E686964654C617965723D66756E6374696F6E2865297B6966282165297468726F77206E6577204572726F7228226D75737420737065636966792061206E616D6522293B636F6E737420743D746869732E5F6C61796572735B655D3B69662821742974';
wwv_flow_imp.g_varchar2_table(898) := '68726F77206E6577204572726F7228226C61796572203C222B652B223E20646F6573206E6F7420657869737422293B636F6E7374206E3D742E67726F75703B72657475726E20742E76697369626C653F287365286E292C742E76697369626C653D21312C';
wwv_flow_imp.g_varchar2_table(899) := '6E293A6E7D2C716E2E70726F746F747970652E5F72656D6F76654C617965723D66756E6374696F6E2865297B636F6E737420743D746869732E5F6C61796572735B655D3B7426262864656C65746520746869732E5F6C61796572735B655D2C736528742E';
wwv_flow_imp.g_varchar2_table(900) := '67726F757029297D2C716E2E70726F746F747970652E6765744163746976654C617965723D66756E6374696F6E28297B636F6E737420653D746869732E5F66696E64506C616E65466F72526F6F7428746869732E676574526F6F74456C656D656E742829';
wwv_flow_imp.g_varchar2_table(901) := '293B72657475726E20653F652E6C617965723A6E756C6C7D2C716E2E70726F746F747970652E66696E64526F6F743D66756E6374696F6E2865297B69662822737472696E67223D3D747970656F662065262628653D746869732E5F656C656D656E745265';
wwv_flow_imp.g_varchar2_table(902) := '6769737472792E676574286529292C21652972657475726E3B636F6E737420743D746869732E5F66696E64506C616E65466F72526F6F742866756E6374696F6E2865297B666F72283B652E706172656E743B29653D652E706172656E743B72657475726E';
wwv_flow_imp.g_varchar2_table(903) := '20657D286529297C7C7B7D3B72657475726E20742E726F6F74456C656D656E747D2C716E2E70726F746F747970652E676574526F6F74456C656D656E74733D66756E6374696F6E28297B72657475726E20746869732E5F706C616E65732E6D6170282866';
wwv_flow_imp.g_varchar2_table(904) := '756E6374696F6E2865297B72657475726E20652E726F6F74456C656D656E747D29297D2C716E2E70726F746F747970652E5F66696E64506C616E65466F72526F6F743D66756E6374696F6E2865297B72657475726E206428746869732E5F706C616E6573';
wwv_flow_imp.g_varchar2_table(905) := '2C2866756E6374696F6E2874297B72657475726E20742E726F6F74456C656D656E743D3D3D657D29297D2C716E2E70726F746F747970652E676574436F6E7461696E65723D66756E6374696F6E28297B72657475726E20746869732E5F636F6E7461696E';
wwv_flow_imp.g_varchar2_table(906) := '65727D2C716E2E70726F746F747970652E5F7570646174654D61726B65723D66756E6374696F6E28652C742C6E297B6C657420693B652E69647C7C28653D746869732E5F656C656D656E7452656769737472792E676574286529292C652E6D61726B6572';
wwv_flow_imp.g_varchar2_table(907) := '733D652E6D61726B6572737C7C6E6577205365742C693D746869732E5F656C656D656E7452656769737472792E5F656C656D656E74735B652E69645D2C6926262866285B692E6766782C692E7365636F6E646172794766785D2C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(908) := '69297B692626286E3F28652E6D61726B6572732E6164642874292C472869292E616464287429293A28652E6D61726B6572732E64656C6574652874292C472869292E72656D6F766528742929297D29292C746869732E5F6576656E744275732E66697265';
wwv_flow_imp.g_varchar2_table(909) := '2822656C656D656E742E6D61726B65722E757064617465222C7B656C656D656E743A652C6766783A692E6766782C6D61726B65723A742C6164643A21216E7D29297D2C716E2E70726F746F747970652E6164644D61726B65723D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(910) := '2C74297B746869732E5F7570646174654D61726B657228652C742C2130297D2C716E2E70726F746F747970652E72656D6F76654D61726B65723D66756E6374696F6E28652C74297B746869732E5F7570646174654D61726B657228652C742C2131297D2C';
wwv_flow_imp.g_varchar2_table(911) := '716E2E70726F746F747970652E6861734D61726B65723D66756E6374696F6E28652C74297B72657475726E20652E69647C7C28653D746869732E5F656C656D656E7452656769737472792E676574286529292C2121652E6D61726B6572732626652E6D61';
wwv_flow_imp.g_varchar2_table(912) := '726B6572732E6861732874297D2C716E2E70726F746F747970652E746F67676C654D61726B65723D66756E6374696F6E28652C74297B746869732E6861734D61726B657228652C74293F746869732E72656D6F76654D61726B657228652C74293A746869';
wwv_flow_imp.g_varchar2_table(913) := '732E6164644D61726B657228652C74297D2C716E2E70726F746F747970652E676574526F6F74456C656D656E743D66756E6374696F6E28297B636F6E737420653D746869732E5F726F6F74456C656D656E743B72657475726E20657C7C746869732E5F70';
wwv_flow_imp.g_varchar2_table(914) := '6C616E65732E6C656E6774683F653A746869732E736574526F6F74456C656D656E7428746869732E616464526F6F74456C656D656E74286E756C6C29297D2C716E2E70726F746F747970652E616464526F6F74456C656D656E743D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(915) := '65297B636F6E737420743D746869732E5F726F6F74734964782B2B3B657C7C28653D7B69643A225F5F696D706C69636974726F6F745F222B742C6368696C6472656E3A5B5D2C6973496D706C696369743A21307D293B636F6E7374206E3D652E6C617965';
wwv_flow_imp.g_varchar2_table(916) := '723D22726F6F742D222B743B746869732E5F656E7375726556616C69642822726F6F74222C65293B636F6E737420693D746869732E6765744C61796572286E2C30293B72657475726E20746869732E686964654C61796572286E292C746869732E5F6164';
wwv_flow_imp.g_varchar2_table(917) := '64526F6F7428652C69292C746869732E5F706C616E65732E70757368287B726F6F74456C656D656E743A652C6C617965723A697D292C657D2C716E2E70726F746F747970652E72656D6F7665526F6F74456C656D656E743D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(918) := '69662822737472696E67223D3D747970656F662065262628653D746869732E5F656C656D656E7452656769737472792E676574286529292C746869732E5F66696E64506C616E65466F72526F6F742865292972657475726E20746869732E5F72656D6F76';
wwv_flow_imp.g_varchar2_table(919) := '65526F6F742865292C746869732E5F72656D6F76654C6179657228652E6C61796572292C746869732E5F706C616E65733D746869732E5F706C616E65732E66696C746572282866756E6374696F6E2874297B72657475726E20742E726F6F74456C656D65';
wwv_flow_imp.g_varchar2_table(920) := '6E74213D3D657D29292C746869732E5F726F6F74456C656D656E743D3D3D65262628746869732E5F726F6F74456C656D656E743D6E756C6C292C657D2C716E2E70726F746F747970652E736574526F6F74456C656D656E743D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(921) := '7B696628653D3D3D746869732E5F726F6F74456C656D656E742972657475726E20653B6C657420743B6966282165297468726F77206E6577204572726F722822726F6F74456C656D656E7420726571756972656422293B72657475726E20743D74686973';
wwv_flow_imp.g_varchar2_table(922) := '2E5F66696E64506C616E65466F72526F6F742865292C747C7C28653D746869732E616464526F6F74456C656D656E74286529292C746869732E5F736574526F6F742865292C657D2C716E2E70726F746F747970652E5F72656D6F7665526F6F743D66756E';
wwv_flow_imp.g_varchar2_table(923) := '6374696F6E2865297B636F6E737420743D746869732E5F656C656D656E7452656769737472792C6E3D746869732E5F6576656E744275733B6E2E666972652822726F6F742E72656D6F7665222C7B656C656D656E743A657D292C6E2E666972652822726F';
wwv_flow_imp.g_varchar2_table(924) := '6F742E72656D6F766564222C7B656C656D656E743A657D292C742E72656D6F76652865297D2C716E2E70726F746F747970652E5F616464526F6F743D66756E6374696F6E28652C74297B636F6E7374206E3D746869732E5F656C656D656E745265676973';
wwv_flow_imp.g_varchar2_table(925) := '7472792C693D746869732E5F6576656E744275733B692E666972652822726F6F742E616464222C7B656C656D656E743A657D292C6E2E61646428652C74292C692E666972652822726F6F742E6164646564222C7B656C656D656E743A652C6766783A747D';
wwv_flow_imp.g_varchar2_table(926) := '297D2C716E2E70726F746F747970652E5F736574526F6F743D66756E6374696F6E28652C74297B636F6E7374206E3D746869732E5F726F6F74456C656D656E743B6E262628746869732E5F656C656D656E7452656769737472792E757064617465477261';
wwv_flow_imp.g_varchar2_table(927) := '7068696373286E2C6E756C6C2C2130292C746869732E686964654C61796572286E2E6C6179657229292C65262628747C7C28743D746869732E5F66696E64506C616E65466F72526F6F742865292E6C61796572292C746869732E5F656C656D656E745265';
wwv_flow_imp.g_varchar2_table(928) := '6769737472792E757064617465477261706869637328652C746869732E5F7376672C2130292C746869732E73686F774C6179657228652E6C6179657229292C746869732E5F726F6F74456C656D656E743D652C746869732E5F6576656E744275732E6669';
wwv_flow_imp.g_varchar2_table(929) := '72652822726F6F742E736574222C7B656C656D656E743A657D297D2C716E2E70726F746F747970652E5F656E7375726556616C69643D66756E6374696F6E28652C74297B69662821742E6964297468726F77206E6577204572726F722822656C656D656E';
wwv_flow_imp.g_varchar2_table(930) := '74206D757374206861766520616E20696422293B696628746869732E5F656C656D656E7452656769737472792E67657428742E696429297468726F77206E6577204572726F722822656C656D656E74203C222B742E69642B223E20616C72656164792065';
wwv_flow_imp.g_varchar2_table(931) := '786973747322293B636F6E7374206E3D556E5B655D2C693D67286E2C2866756E6374696F6E2865297B72657475726E20766F69642030213D3D745B655D7D29293B6966282169297468726F77206E6577204572726F7228226D75737420737570706C7920';
wwv_flow_imp.g_varchar2_table(932) := '7B20222B6E2E6A6F696E28222C2022292B22207D207769746820222B65297D2C716E2E70726F746F747970652E5F736574506172656E743D66756E6374696F6E28652C742C6E297B2166756E6374696F6E28652C742C6E297B69662865262674297B226E';
wwv_flow_imp.g_varchar2_table(933) := '756D62657222213D747970656F66206E2626286E3D2D31293B76617220693D652E696E6465784F662874293B6966282D31213D3D69297B696628693D3D3D6E2972657475726E3B6966282D313D3D3D6E2972657475726E3B652E73706C69636528692C31';
wwv_flow_imp.g_varchar2_table(934) := '297D2D31213D3D6E3F652E73706C696365286E2C302C74293A652E707573682874297D7D28742E6368696C6472656E2C652C6E292C652E706172656E743D747D2C716E2E70726F746F747970652E5F616464456C656D656E743D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(935) := '2C742C6E2C69297B6E3D6E7C7C746869732E676574526F6F74456C656D656E7428293B636F6E737420723D746869732E5F6576656E744275732C6F3D746869732E5F6772617068696373466163746F72793B746869732E5F656E7375726556616C696428';
wwv_flow_imp.g_varchar2_table(936) := '652C74292C722E6669726528652B222E616464222C7B656C656D656E743A742C706172656E743A6E7D292C746869732E5F736574506172656E7428742C6E2C69293B636F6E737420613D6F2E63726561746528652C742C69293B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(937) := '732E5F656C656D656E7452656769737472792E61646428742C61292C6F2E75706461746528652C742C61292C722E6669726528652B222E6164646564222C7B656C656D656E743A742C6766783A617D292C747D2C716E2E70726F746F747970652E616464';
wwv_flow_imp.g_varchar2_table(938) := '53686170653D66756E6374696F6E28652C742C6E297B72657475726E20746869732E5F616464456C656D656E7428227368617065222C652C742C6E297D2C716E2E70726F746F747970652E616464436F6E6E656374696F6E3D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(939) := '742C6E297B72657475726E20746869732E5F616464456C656D656E742822636F6E6E656374696F6E222C652C742C6E297D2C716E2E70726F746F747970652E5F72656D6F7665456C656D656E743D66756E6374696F6E28652C74297B636F6E7374206E3D';
wwv_flow_imp.g_varchar2_table(940) := '746869732E5F656C656D656E7452656769737472792C693D746869732E5F6772617068696373466163746F72792C723D746869732E5F6576656E744275733B696628653D6E2E67657428652E69647C7C65292972657475726E20722E6669726528742B22';
wwv_flow_imp.g_varchar2_table(941) := '2E72656D6F7665222C7B656C656D656E743A657D292C692E72656D6F76652865292C66756E6374696F6E28652C74297B69662821657C7C21742972657475726E2D313B766172206E3D652E696E6465784F662874293B2D31213D3D6E2626652E73706C69';
wwv_flow_imp.g_varchar2_table(942) := '6365286E2C31297D28652E706172656E742626652E706172656E742E6368696C6472656E2C65292C652E706172656E743D6E756C6C2C722E6669726528742B222E72656D6F766564222C7B656C656D656E743A657D292C6E2E72656D6F76652865292C65';
wwv_flow_imp.g_varchar2_table(943) := '7D2C716E2E70726F746F747970652E72656D6F766553686170653D66756E6374696F6E2865297B72657475726E20746869732E5F72656D6F7665456C656D656E7428652C22736861706522297D2C716E2E70726F746F747970652E72656D6F7665436F6E';
wwv_flow_imp.g_varchar2_table(944) := '6E656374696F6E3D66756E6374696F6E2865297B72657475726E20746869732E5F72656D6F7665456C656D656E7428652C22636F6E6E656374696F6E22297D2C716E2E70726F746F747970652E67657447726170686963733D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(945) := '74297B72657475726E20746869732E5F656C656D656E7452656769737472792E676574477261706869637328652C74297D2C716E2E70726F746F747970652E5F6368616E676556696577626F783D66756E6374696F6E2865297B746869732E5F6576656E';
wwv_flow_imp.g_varchar2_table(946) := '744275732E66697265282263616E7661732E76696577626F782E6368616E67696E6722292C652E6170706C792874686973292C746869732E5F63616368656456696577626F783D6E756C6C2C746869732E5F76696577626F784368616E67656428297D2C';
wwv_flow_imp.g_varchar2_table(947) := '716E2E70726F746F747970652E5F76696577626F784368616E6765643D66756E6374696F6E28297B746869732E5F6576656E744275732E66697265282263616E7661732E76696577626F782E6368616E676564222C7B76696577626F783A746869732E76';
wwv_flow_imp.g_varchar2_table(948) := '696577626F7828297D297D2C716E2E70726F746F747970652E76696577626F783D66756E6374696F6E2865297B696628766F696420303D3D3D652626746869732E5F63616368656456696577626F782972657475726E20746869732E5F63616368656456';
wwv_flow_imp.g_varchar2_table(949) := '696577626F783B636F6E737420743D746869732E5F76696577706F72742C6E3D746869732E67657453697A6528293B6C657420692C722C6F2C612C732C6C2C633B72657475726E20653F28746869732E5F6368616E676556696577626F78282866756E63';
wwv_flow_imp.g_varchar2_table(950) := '74696F6E28297B733D4D6174682E6D696E286E2E77696474682F652E77696474682C6E2E6865696768742F652E686569676874293B636F6E737420693D746869732E5F7376672E6372656174655356474D617472697828292E7363616C652873292E7472';
wwv_flow_imp.g_varchar2_table(951) := '616E736C617465282D652E782C2D652E79293B636528742C69297D29292C65293A286F3D746869732E5F726F6F74456C656D656E743F746869732E6765744163746976654C6179657228293A6E756C6C2C693D6F26266F2E67657442426F7828297C7C7B';
wwv_flow_imp.g_varchar2_table(952) := '7D2C613D63652874292C723D613F612E6D61747269783A66756E6374696F6E28652C742C6E2C692C722C6F297B76617220613D4A28292E6372656174655356474D617472697828293B73776974636828617267756D656E74732E6C656E677468297B6361';
wwv_flow_imp.g_varchar2_table(953) := '736520303A72657475726E20613B6361736520313A72657475726E205128612C65293B6361736520363A72657475726E205128612C7B613A652C623A742C633A6E2C643A692C653A722C663A6F7D297D7D28292C733D476E28722E612C316533292C6C3D';
wwv_flow_imp.g_varchar2_table(954) := '476E282D722E657C7C302C316533292C633D476E282D722E667C7C302C316533292C653D746869732E5F63616368656456696577626F783D7B783A6C3F6C2F733A302C793A633F632F733A302C77696474683A6E2E77696474682F732C6865696768743A';
wwv_flow_imp.g_varchar2_table(955) := '6E2E6865696768742F732C7363616C653A732C696E6E65723A7B77696474683A692E77696474687C7C302C6865696768743A692E6865696768747C7C302C783A692E787C7C302C793A692E797C7C307D2C6F757465723A6E7D297D2C716E2E70726F746F';
wwv_flow_imp.g_varchar2_table(956) := '747970652E7363726F6C6C3D66756E6374696F6E2865297B636F6E737420743D746869732E5F76696577706F72743B6C6574206E3D742E67657443544D28293B72657475726E20652626746869732E5F6368616E676556696577626F78282866756E6374';
wwv_flow_imp.g_varchar2_table(957) := '696F6E28297B653D53287B64783A302C64793A307D2C657C7C7B7D292C6E3D746869732E5F7376672E6372656174655356474D617472697828292E7472616E736C61746528652E64782C652E6479292E6D756C7469706C79286E292C596E28742C6E297D';
wwv_flow_imp.g_varchar2_table(958) := '29292C7B783A6E2E652C793A6E2E667D7D2C716E2E70726F746F747970652E7363726F6C6C546F456C656D656E743D66756E6374696F6E28652C74297B6C6574206E3D3130303B22737472696E67223D3D747970656F662065262628653D746869732E5F';
wwv_flow_imp.g_varchar2_table(959) := '656C656D656E7452656769737472792E676574286529293B636F6E737420693D746869732E66696E64526F6F742865293B69662869213D3D746869732E676574526F6F74456C656D656E7428292626746869732E736574526F6F74456C656D656E742869';
wwv_flow_imp.g_varchar2_table(960) := '292C693D3D3D652972657475726E3B747C7C28743D7B7D292C226E756D626572223D3D747970656F6620742626286E3D74292C743D7B746F703A742E746F707C7C6E2C72696768743A742E72696768747C7C6E2C626F74746F6D3A742E626F74746F6D7C';
wwv_flow_imp.g_varchar2_table(961) := '7C6E2C6C6566743A742E6C6566747C7C6E7D3B636F6E737420723D4E742865292C6F3D6B742872292C613D746869732E76696577626F7828292C733D746869732E7A6F6F6D28293B6C6574206C2C633B612E792B3D742E746F702F732C612E782B3D742E';
wwv_flow_imp.g_varchar2_table(962) := '6C6566742F732C612E77696474682D3D28742E72696768742B742E6C656674292F732C612E6865696768742D3D28742E626F74746F6D2B742E746F70292F733B636F6E737420703D6B742861293B696628722E77696474683C612E77696474682626722E';
wwv_flow_imp.g_varchar2_table(963) := '6865696768743C612E686569676874297B636F6E737420653D4D6174682E6D617828302C6F2E72696768742D702E7269676874292C743D4D6174682E6D696E28302C6F2E6C6566742D702E6C656674292C6E3D4D6174682E6D617828302C6F2E626F7474';
wwv_flow_imp.g_varchar2_table(964) := '6F6D2D702E626F74746F6D292C693D4D6174682E6D696E28302C6F2E746F702D702E746F70293B6C3D657C7C742C633D6E7C7C697D656C7365206C3D722E782D612E782C633D722E792D612E793B746869732E7363726F6C6C287B64783A2D6C2A732C64';
wwv_flow_imp.g_varchar2_table(965) := '793A2D632A737D297D2C716E2E70726F746F747970652E7A6F6F6D3D66756E6374696F6E28652C74297B69662821652972657475726E20746869732E76696577626F782865292E7363616C653B696628226669742D76696577706F7274223D3D3D652972';
wwv_flow_imp.g_varchar2_table(966) := '657475726E20746869732E5F66697456696577706F72742874293B6C6574206E2C693B72657475726E20746869732E5F6368616E676556696577626F78282866756E6374696F6E28297B226F626A65637422213D747970656F6620742626286E3D746869';
wwv_flow_imp.g_varchar2_table(967) := '732E76696577626F7828292E6F757465722C743D7B783A6E2E77696474682F322C793A6E2E6865696768742F327D292C693D746869732E5F7365745A6F6F6D28652C74297D29292C476E28692E612C316533297D2C716E2E70726F746F747970652E5F66';
wwv_flow_imp.g_varchar2_table(968) := '697456696577706F72743D66756E6374696F6E2865297B636F6E737420743D746869732E76696577626F7828292C6E3D742E6F757465722C693D742E696E6E65723B6C657420722C6F3B72657475726E20692E783E3D302626692E793E3D302626692E78';
wwv_flow_imp.g_varchar2_table(969) := '2B692E77696474683C3D6E2E77696474682626692E792B692E6865696768743C3D6E2E686569676874262621653F6F3D7B783A302C793A302C77696474683A4D6174682E6D617828692E77696474682B692E782C6E2E7769647468292C6865696768743A';
wwv_flow_imp.g_varchar2_table(970) := '4D6174682E6D617828692E6865696768742B692E792C6E2E686569676874297D3A28723D4D6174682E6D696E28312C6E2E77696474682F692E77696474682C6E2E6865696768742F692E686569676874292C6F3D7B783A692E782B28653F692E77696474';
wwv_flow_imp.g_varchar2_table(971) := '682F322D6E2E77696474682F722F323A30292C793A692E792B28653F692E6865696768742F322D6E2E6865696768742F722F323A30292C77696474683A6E2E77696474682F722C6865696768743A6E2E6865696768742F727D292C746869732E76696577';
wwv_flow_imp.g_varchar2_table(972) := '626F78286F292C746869732E76696577626F78282131292E7363616C657D2C716E2E70726F746F747970652E5F7365745A6F6F6D3D66756E6374696F6E28652C74297B636F6E7374206E3D746869732E5F7376672C693D746869732E5F76696577706F72';
wwv_flow_imp.g_varchar2_table(973) := '742C723D6E2E6372656174655356474D617472697828292C6F3D6E2E637265617465535647506F696E7428293B6C657420612C732C6C2C632C703B6C3D692E67657443544D28293B636F6E737420753D6C2E613B72657475726E20743F28613D53286F2C';
wwv_flow_imp.g_varchar2_table(974) := '74292C733D612E6D61747269785472616E73666F726D286C2E696E76657273652829292C633D722E7472616E736C61746528732E782C732E79292E7363616C6528312F752A65292E7472616E736C617465282D732E782C2D732E79292C703D6C2E6D756C';
wwv_flow_imp.g_varchar2_table(975) := '7469706C79286329293A703D722E7363616C652865292C596E28746869732E5F76696577706F72742C70292C707D2C716E2E70726F746F747970652E67657453697A653D66756E6374696F6E28297B72657475726E7B77696474683A746869732E5F636F';
wwv_flow_imp.g_varchar2_table(976) := '6E7461696E65722E636C69656E7457696474682C6865696768743A746869732E5F636F6E7461696E65722E636C69656E744865696768747D7D2C716E2E70726F746F747970652E6765744162736F6C75746542426F783D66756E6374696F6E2865297B63';
wwv_flow_imp.g_varchar2_table(977) := '6F6E737420743D746869732E76696577626F7828293B6C6574206E3B72657475726E206E3D652E776179706F696E74733F746869732E67657447726170686963732865292E67657442426F7828293A652C7B783A6E2E782A742E7363616C652D742E782A';
wwv_flow_imp.g_varchar2_table(978) := '742E7363616C652C793A6E2E792A742E7363616C652D742E792A742E7363616C652C77696474683A6E2E77696474682A742E7363616C652C6865696768743A6E2E6865696768742A742E7363616C657D7D2C716E2E70726F746F747970652E726573697A';
wwv_flow_imp.g_varchar2_table(979) := '65643D66756E6374696F6E28297B64656C65746520746869732E5F63616368656456696577626F782C746869732E5F6576656E744275732E66697265282263616E7661732E726573697A656422297D3B76617220586E3D22646174612D656C656D656E74';
wwv_flow_imp.g_varchar2_table(980) := '2D6964223B66756E6374696F6E205A6E2865297B746869732E5F656C656D656E74733D7B7D2C746869732E5F6576656E744275733D657D66756E6374696F6E204A6E28652C742C6E297B76617220693D66756E6374696F6E28652C742C6E2C69297B7661';
wwv_flow_imp.g_varchar2_table(981) := '7220723D6E2E696E76657273653B72657475726E204F626A6563742E646566696E6550726F706572747928652C2272656D6F7665222C7B76616C75653A66756E6374696F6E2865297B766172206E3D746869732E696E6465784F662865293B7265747572';
wwv_flow_imp.g_varchar2_table(982) := '6E2D31213D3D6E262628746869732E73706C696365286E2C31292C742E756E73657428652C722C6929292C657D7D292C4F626A6563742E646566696E6550726F706572747928652C22636F6E7461696E73222C7B76616C75653A66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(983) := '297B72657475726E2D31213D3D746869732E696E6465784F662865297D7D292C4F626A6563742E646566696E6550726F706572747928652C22616464222C7B76616C75653A66756E6374696F6E28652C6E297B766172206F3D746869732E696E6465784F';
wwv_flow_imp.g_varchar2_table(984) := '662865293B696628766F696420303D3D3D6E297B6966282D31213D3D6F2972657475726E3B6E3D746869732E6C656E6774687D2D31213D3D6F2626746869732E73706C696365286F2C31292C746869732E73706C696365286E2C302C65292C2D313D3D3D';
wwv_flow_imp.g_varchar2_table(985) := '6F2626742E73657428652C722C69297D7D292C4F626A6563742E646566696E6550726F706572747928652C225F5F726566735F636F6C6C656374696F6E222C7B76616C75653A21307D292C657D286E5B742E6E616D655D7C7C5B5D2C652C742C6E293B4F';
wwv_flow_imp.g_varchar2_table(986) := '626A6563742E646566696E6550726F7065727479286E2C742E6E616D652C7B656E756D657261626C653A742E656E756D657261626C652C76616C75653A697D292C692E6C656E6774682626692E666F7245616368282866756E6374696F6E2869297B652E';
wwv_flow_imp.g_varchar2_table(987) := '73657428692C742E696E76657273652C6E297D29297D66756E6374696F6E20516E28652C74297B69662821287468697320696E7374616E63656F6620516E292972657475726E206E657720516E28652C74293B652E696E76657273653D742C742E696E76';
wwv_flow_imp.g_varchar2_table(988) := '657273653D652C746869732E70726F70733D7B7D2C746869732E70726F70735B652E6E616D655D3D652C746869732E70726F70735B742E6E616D655D3D747D5A6E2E24696E6A6563743D5B226576656E74427573225D2C5A6E2E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(989) := '6164643D66756E6374696F6E28652C742C6E297B76617220693D652E69643B746869732E5F76616C696461746549642869292C7A28742C586E2C69292C6E26267A286E2C586E2C69292C746869732E5F656C656D656E74735B695D3D7B656C656D656E74';
wwv_flow_imp.g_varchar2_table(990) := '3A652C6766783A742C7365636F6E646172794766783A6E7D7D2C5A6E2E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B76617220743D746869732E5F656C656D656E74732C6E3D652E69647C7C652C693D6E2626745B6E5D3B69';
wwv_flow_imp.g_varchar2_table(991) := '2626287A28692E6766782C586E2C2222292C692E7365636F6E6461727947667826267A28692E7365636F6E646172794766782C586E2C2222292C64656C65746520745B6E5D297D2C5A6E2E70726F746F747970652E75706461746549643D66756E637469';
wwv_flow_imp.g_varchar2_table(992) := '6F6E28652C74297B746869732E5F76616C696461746549642874292C22737472696E67223D3D747970656F662065262628653D746869732E676574286529292C746869732E5F6576656E744275732E666972652822656C656D656E742E75706461746549';
wwv_flow_imp.g_varchar2_table(993) := '64222C7B656C656D656E743A652C6E657749643A747D293B766172206E3D746869732E67657447726170686963732865292C693D746869732E676574477261706869637328652C2130293B746869732E72656D6F76652865292C652E69643D742C746869';
wwv_flow_imp.g_varchar2_table(994) := '732E61646428652C6E2C69297D2C5A6E2E70726F746F747970652E75706461746547726170686963733D66756E6374696F6E28652C742C6E297B76617220693D652E69647C7C652C723D746869732E5F656C656D656E74735B695D3B72657475726E206E';
wwv_flow_imp.g_varchar2_table(995) := '3F722E7365636F6E646172794766783D743A722E6766783D742C7426267A28742C586E2C69292C747D2C5A6E2E70726F746F747970652E6765743D66756E6374696F6E2865297B76617220743B743D22737472696E67223D3D747970656F6620653F653A';
wwv_flow_imp.g_varchar2_table(996) := '6526267A28652C586E293B766172206E3D746869732E5F656C656D656E74735B745D3B72657475726E206E26266E2E656C656D656E747D2C5A6E2E70726F746F747970652E66696C7465723D66756E6374696F6E2865297B76617220743D5B5D3B726574';
wwv_flow_imp.g_varchar2_table(997) := '75726E20746869732E666F7245616368282866756E6374696F6E286E2C69297B65286E2C69292626742E70757368286E297D29292C747D2C5A6E2E70726F746F747970652E66696E643D66756E6374696F6E2865297B666F722876617220743D74686973';
wwv_flow_imp.g_varchar2_table(998) := '2E5F656C656D656E74732C6E3D4F626A6563742E6B6579732874292C693D303B693C6E2E6C656E6774683B692B2B297B76617220723D745B6E5B695D5D2C6F3D722E656C656D656E743B69662865286F2C722E676678292972657475726E206F7D7D2C5A';
wwv_flow_imp.g_varchar2_table(999) := '6E2E70726F746F747970652E676574416C6C3D66756E6374696F6E28297B72657475726E20746869732E66696C746572282866756E6374696F6E2865297B72657475726E20657D29297D2C5A6E2E70726F746F747970652E666F72456163683D66756E63';
wwv_flow_imp.g_varchar2_table(1000) := '74696F6E2865297B76617220743D746869732E5F656C656D656E74733B4F626A6563742E6B6579732874292E666F7245616368282866756E6374696F6E286E297B76617220693D745B6E5D2C723D692E656C656D656E742C6F3D692E6766783B72657475';
wwv_flow_imp.g_varchar2_table(1001) := '726E206528722C6F297D29297D2C5A6E2E70726F746F747970652E67657447726170686963733D66756E6374696F6E28652C74297B766172206E3D652E69647C7C652C693D746869732E5F656C656D656E74735B6E5D3B72657475726E2069262628743F';
wwv_flow_imp.g_varchar2_table(1002) := '692E7365636F6E646172794766783A692E676678297D2C5A6E2E70726F746F747970652E5F76616C696461746549643D66756E6374696F6E2865297B6966282165297468726F77206E6577204572726F722822656C656D656E74206D7573742068617665';
wwv_flow_imp.g_varchar2_table(1003) := '20616E20696422293B696628746869732E5F656C656D656E74735B655D297468726F77206E6577204572726F722822656C656D656E74207769746820696420222B652B2220616C726561647920616464656422297D2C516E2E70726F746F747970652E62';
wwv_flow_imp.g_varchar2_table(1004) := '696E643D66756E6374696F6E28652C74297B69662822737472696E67223D3D747970656F662074297B69662821746869732E70726F70735B745D297468726F77206E6577204572726F7228226E6F2070726F7065727479203C222B742B223E20696E2072';
wwv_flow_imp.g_varchar2_table(1005) := '656622293B743D746869732E70726F70735B745D7D742E636F6C6C656374696F6E3F4A6E28746869732C742C65293A66756E6374696F6E28652C742C6E297B76617220693D742E696E76657273652C723D6E5B742E6E616D655D3B4F626A6563742E6465';
wwv_flow_imp.g_varchar2_table(1006) := '66696E6550726F7065727479286E2C742E6E616D652C7B636F6E666967757261626C653A742E636F6E666967757261626C652C656E756D657261626C653A742E656E756D657261626C652C6765743A66756E6374696F6E28297B72657475726E20727D2C';
wwv_flow_imp.g_varchar2_table(1007) := '7365743A66756E6374696F6E2874297B69662874213D3D72297B766172206F3D723B723D6E756C6C2C6F2626652E756E736574286F2C692C6E292C723D742C652E73657428722C692C6E297D7D7D297D28746869732C742C65297D2C516E2E70726F746F';
wwv_flow_imp.g_varchar2_table(1008) := '747970652E656E7375726552656673436F6C6C656374696F6E3D66756E6374696F6E28652C74297B766172206E3D655B742E6E616D655D3B72657475726E2066756E6374696F6E2865297B72657475726E21303D3D3D652E5F5F726566735F636F6C6C65';
wwv_flow_imp.g_varchar2_table(1009) := '6374696F6E7D286E297C7C4A6E28746869732C742C65292C6E7D2C516E2E70726F746F747970652E656E73757265426F756E643D66756E6374696F6E28652C74297B2866756E6374696F6E28652C74297B72657475726E204F626A6563742E70726F746F';
wwv_flow_imp.g_varchar2_table(1010) := '747970652E6861734F776E50726F70657274792E63616C6C28652C742E6E616D657C7C74297D2928652C74297C7C746869732E62696E6428652C74297D2C516E2E70726F746F747970652E756E7365743D66756E6374696F6E28652C742C6E297B652626';
wwv_flow_imp.g_varchar2_table(1011) := '28746869732E656E73757265426F756E6428652C74292C742E636F6C6C656374696F6E3F746869732E656E7375726552656673436F6C6C656374696F6E28652C74292E72656D6F7665286E293A655B742E6E616D655D3D766F69642030297D2C516E2E70';
wwv_flow_imp.g_varchar2_table(1012) := '726F746F747970652E7365743D66756E6374696F6E28652C742C6E297B65262628746869732E656E73757265426F756E6428652C74292C742E636F6C6C656374696F6E3F746869732E656E7375726552656673436F6C6C656374696F6E28652C74292E61';
wwv_flow_imp.g_varchar2_table(1013) := '6464286E293A655B742E6E616D655D3D6E297D3B7661722065693D6E657720516E287B6E616D653A226368696C6472656E222C656E756D657261626C653A21302C636F6C6C656374696F6E3A21307D2C7B6E616D653A22706172656E74227D292C74693D';
wwv_flow_imp.g_varchar2_table(1014) := '6E657720516E287B6E616D653A226C6162656C73222C656E756D657261626C653A21302C636F6C6C656374696F6E3A21307D2C7B6E616D653A226C6162656C546172676574227D292C6E693D6E657720516E287B6E616D653A2261747461636865727322';
wwv_flow_imp.g_varchar2_table(1015) := '2C636F6C6C656374696F6E3A21307D2C7B6E616D653A22686F7374227D292C69693D6E657720516E287B6E616D653A226F7574676F696E67222C636F6C6C656374696F6E3A21307D2C7B6E616D653A22736F75726365227D292C72693D6E657720516E28';
wwv_flow_imp.g_varchar2_table(1016) := '7B6E616D653A22696E636F6D696E67222C636F6C6C656374696F6E3A21307D2C7B6E616D653A22746172676574227D293B66756E6374696F6E206F6928297B4F626A6563742E646566696E6550726F706572747928746869732C22627573696E6573734F';
wwv_flow_imp.g_varchar2_table(1017) := '626A656374222C7B7772697461626C653A21307D292C4F626A6563742E646566696E6550726F706572747928746869732C226C6162656C222C7B6765743A66756E6374696F6E28297B72657475726E20746869732E6C6162656C735B305D7D2C7365743A';
wwv_flow_imp.g_varchar2_table(1018) := '66756E6374696F6E2865297B76617220743D746869732E6C6162656C2C6E3D746869732E6C6162656C733B21652626743F6E2E72656D6F76652874293A6E2E61646428652C30297D7D292C65692E62696E6428746869732C22706172656E7422292C7469';
wwv_flow_imp.g_varchar2_table(1019) := '2E62696E6428746869732C226C6162656C7322292C69692E62696E6428746869732C226F7574676F696E6722292C72692E62696E6428746869732C22696E636F6D696E6722297D66756E6374696F6E20616928297B6F692E63616C6C2874686973292C65';
wwv_flow_imp.g_varchar2_table(1020) := '692E62696E6428746869732C226368696C6472656E22292C6E692E62696E6428746869732C22686F737422292C6E692E62696E6428746869732C2261747461636865727322297D66756E6374696F6E20736928297B6F692E63616C6C2874686973292C65';
wwv_flow_imp.g_varchar2_table(1021) := '692E62696E6428746869732C226368696C6472656E22297D66756E6374696F6E206C6928297B61692E63616C6C2874686973292C74692E62696E6428746869732C226C6162656C54617267657422297D66756E6374696F6E20636928297B6F692E63616C';
wwv_flow_imp.g_varchar2_table(1022) := '6C2874686973292C69692E62696E6428746869732C22736F7572636522292C72692E62696E6428746869732C2274617267657422297D6E2861692C6F69292C6E2873692C6169292C6E286C692C6169292C6E2863692C6F69293B7661722070693D7B636F';
wwv_flow_imp.g_varchar2_table(1023) := '6E6E656374696F6E3A63692C73686170653A61692C6C6162656C3A6C692C726F6F743A73697D3B66756E6374696F6E20756928297B746869732E5F7569643D31327D75692E70726F746F747970652E637265617465526F6F743D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(1024) := '297B72657475726E20746869732E6372656174652822726F6F74222C65297D2C75692E70726F746F747970652E6372656174654C6162656C3D66756E6374696F6E2865297B72657475726E20746869732E63726561746528226C6162656C222C65297D2C';
wwv_flow_imp.g_varchar2_table(1025) := '75692E70726F746F747970652E63726561746553686170653D66756E6374696F6E2865297B72657475726E20746869732E63726561746528227368617065222C65297D2C75692E70726F746F747970652E637265617465436F6E6E656374696F6E3D6675';
wwv_flow_imp.g_varchar2_table(1026) := '6E6374696F6E2865297B72657475726E20746869732E6372656174652822636F6E6E656374696F6E222C65297D2C75692E70726F746F747970652E6372656174653D66756E6374696F6E28652C74297B72657475726E28743D53287B7D2C747C7C7B7D29';
wwv_flow_imp.g_varchar2_table(1027) := '292E69647C7C28742E69643D652B225F222B746869732E5F7569642B2B292C66756E6374696F6E28652C74297B766172206E3D70695B655D3B696628216E297468726F77206E6577204572726F722822756E6B6E6F776E20747970653A203C222B652B22';
wwv_flow_imp.g_varchar2_table(1028) := '3E22293B72657475726E2053286E6577206E2C74297D28652C74297D3B7661722068693D225F5F666E222C64693D41727261792E70726F746F747970652E736C6963653B66756E6374696F6E206D6928297B746869732E5F6C697374656E6572733D7B7D';
wwv_flow_imp.g_varchar2_table(1029) := '2C746869732E6F6E28226469616772616D2E64657374726F79222C312C746869732E5F64657374726F792C74686973297D66756E6374696F6E20666928297B7D66756E6374696F6E20796928652C74297B746869732E5F6576656E744275733D652C7468';
wwv_flow_imp.g_varchar2_table(1030) := '69732E5F656C656D656E7452656769737472793D747D66756E6374696F6E20676928652C742C6E297B76617220693D6E7C7C742E66697273744368696C643B65213D3D692626742E696E736572744265666F726528652C69297D6D692E70726F746F7479';
wwv_flow_imp.g_varchar2_table(1031) := '70652E6F6E3D66756E6374696F6E28652C742C6E2C69297B696628653D732865293F653A5B655D2C70287429262628693D6E2C6E3D742C743D316533292C2163287429297468726F77206E6577204572726F7228227072696F72697479206D7573742062';
wwv_flow_imp.g_varchar2_table(1032) := '652061206E756D62657222293B76617220723D6E3B6926262828723D45286E2C6929295B68695D3D6E5B68695D7C7C6E293B766172206F3D746869733B652E666F7245616368282866756E6374696F6E2865297B6F2E5F6164644C697374656E65722865';
wwv_flow_imp.g_varchar2_table(1033) := '2C7B7072696F726974793A742C63616C6C6261636B3A722C6E6578743A6E756C6C7D297D29297D2C6D692E70726F746F747970652E6F6E63653D66756E6374696F6E28652C742C6E2C69297B76617220723D746869733B69662870287429262628693D6E';
wwv_flow_imp.g_varchar2_table(1034) := '2C6E3D742C743D316533292C2163287429297468726F77206E6577204572726F7228227072696F72697479206D7573742062652061206E756D62657222293B66756E6374696F6E206F28297B6F2E5F5F6973546F6D623D21303B76617220743D6E2E6170';
wwv_flow_imp.g_varchar2_table(1035) := '706C7928692C617267756D656E7473293B72657475726E20722E6F666628652C6F292C747D6F5B68695D3D6E2C746869732E6F6E28652C742C6F297D2C6D692E70726F746F747970652E6F66663D66756E6374696F6E28652C74297B653D732865293F65';
wwv_flow_imp.g_varchar2_table(1036) := '3A5B655D3B766172206E3D746869733B652E666F7245616368282866756E6374696F6E2865297B6E2E5F72656D6F76654C697374656E657228652C74297D29297D2C6D692E70726F746F747970652E6372656174654576656E743D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1037) := '65297B76617220743D6E65772066693B72657475726E20742E696E69742865292C747D2C6D692E70726F746F747970652E666972653D66756E6374696F6E28652C74297B766172206E2C692C722C6F3B6966286F3D64692E63616C6C28617267756D656E';
wwv_flow_imp.g_varchar2_table(1038) := '7473292C226F626A656374223D3D747970656F662065262628653D28743D65292E74797065292C2165297468726F77206E6577204572726F7228226E6F206576656E7420747970652073706563696669656422293B696628693D746869732E5F6C697374';
wwv_flow_imp.g_varchar2_table(1039) := '656E6572735B655D297B6E3D7420696E7374616E63656F662066693F743A746869732E6372656174654576656E742874292C6F5B305D3D6E3B76617220613D6E2E747970653B65213D3D612626286E2E747970653D65293B7472797B723D746869732E5F';
wwv_flow_imp.g_varchar2_table(1040) := '696E766F6B654C697374656E657273286E2C6F2C69297D66696E616C6C797B65213D3D612626286E2E747970653D61297D72657475726E20766F696420303D3D3D7226266E2E64656661756C7450726576656E746564262628723D2131292C727D7D2C6D';
wwv_flow_imp.g_varchar2_table(1041) := '692E70726F746F747970652E68616E646C654572726F723D66756E6374696F6E2865297B72657475726E21313D3D3D746869732E6669726528226572726F72222C7B6572726F723A657D297D2C6D692E70726F746F747970652E5F64657374726F793D66';
wwv_flow_imp.g_varchar2_table(1042) := '756E6374696F6E28297B746869732E5F6C697374656E6572733D7B7D7D2C6D692E70726F746F747970652E5F696E766F6B654C697374656E6572733D66756E6374696F6E28652C742C6E297B666F722876617220693B6E262621652E63616E63656C4275';
wwv_flow_imp.g_varchar2_table(1043) := '62626C653B29693D746869732E5F696E766F6B654C697374656E657228652C742C6E292C6E3D6E2E6E6578743B72657475726E20697D2C6D692E70726F746F747970652E5F696E766F6B654C697374656E65723D66756E6374696F6E28652C742C6E297B';
wwv_flow_imp.g_varchar2_table(1044) := '76617220693B6966286E2E63616C6C6261636B2E5F5F6973546F6D622972657475726E20693B7472797B693D66756E6374696F6E28652C74297B72657475726E20652E6170706C79286E756C6C2C74297D286E2E63616C6C6261636B2C74292C766F6964';
wwv_flow_imp.g_varchar2_table(1045) := '2030213D3D69262628652E72657475726E56616C75653D692C652E73746F7050726F7061676174696F6E2829292C21313D3D3D692626652E70726576656E7444656661756C7428297D63617463682865297B69662821746869732E68616E646C65457272';
wwv_flow_imp.g_varchar2_table(1046) := '6F72286529297468726F7720636F6E736F6C652E6572726F722822756E68616E646C6564206572726F7220696E206576656E74206C697374656E6572222C65292C657D72657475726E20697D2C6D692E70726F746F747970652E5F6164644C697374656E';
wwv_flow_imp.g_varchar2_table(1047) := '65723D66756E6374696F6E28652C74297B766172206E2C693D746869732E5F6765744C697374656E6572732865293B69662869297B666F72283B693B297B696628692E7072696F726974793C742E7072696F726974792972657475726E20742E6E657874';
wwv_flow_imp.g_varchar2_table(1048) := '3D692C766F6964286E3F6E2E6E6578743D743A746869732E5F7365744C697374656E65727328652C7429293B6E3D692C693D692E6E6578747D6E2E6E6578743D747D656C736520746869732E5F7365744C697374656E65727328652C74297D2C6D692E70';
wwv_flow_imp.g_varchar2_table(1049) := '726F746F747970652E5F6765744C697374656E6572733D66756E6374696F6E2865297B72657475726E20746869732E5F6C697374656E6572735B655D7D2C6D692E70726F746F747970652E5F7365744C697374656E6572733D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(1050) := '74297B746869732E5F6C697374656E6572735B655D3D747D2C6D692E70726F746F747970652E5F72656D6F76654C697374656E65723D66756E6374696F6E28652C74297B766172206E2C692C722C6F3D746869732E5F6765744C697374656E6572732865';
wwv_flow_imp.g_varchar2_table(1051) := '293B6966287429666F72283B6F3B296E3D6F2E6E6578742C28723D6F2E63616C6C6261636B29213D3D742626725B68695D213D3D747C7C28693F692E6E6578743D6E3A746869732E5F7365744C697374656E65727328652C6E29292C693D6F2C6F3D6E3B';
wwv_flow_imp.g_varchar2_table(1052) := '656C736520746869732E5F7365744C697374656E65727328652C6E756C6C297D2C66692E70726F746F747970652E73746F7050726F7061676174696F6E3D66756E6374696F6E28297B746869732E63616E63656C427562626C653D21307D2C66692E7072';
wwv_flow_imp.g_varchar2_table(1053) := '6F746F747970652E70726576656E7444656661756C743D66756E6374696F6E28297B746869732E64656661756C7450726576656E7465643D21307D2C66692E70726F746F747970652E696E69743D66756E6374696F6E2865297B5328746869732C657C7C';
wwv_flow_imp.g_varchar2_table(1054) := '7B7D297D2C79692E24696E6A6563743D5B226576656E74427573222C22656C656D656E745265676973747279225D2C79692E70726F746F747970652E5F6765744368696C6472656E436F6E7461696E65723D66756E6374696F6E2865297B76617220742C';
wwv_flow_imp.g_varchar2_table(1055) := '6E3D746869732E5F656C656D656E7452656769737472792E67657447726170686963732865293B72657475726E20652E706172656E743F28743D66756E6374696F6E2865297B72657475726E20652E706172656E744E6F64652E6368696C644E6F646573';
wwv_flow_imp.g_varchar2_table(1056) := '5B315D7D286E292C747C7C284728743D582822672229292E6164642822646A732D6368696C6472656E22292C6A286E2E706172656E744E6F64652C742929293A743D6E2C747D2C79692E70726F746F747970652E5F636C6561723D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1057) := '65297B76617220743D66756E6374696F6E2865297B72657475726E20652E6368696C644E6F6465735B305D7D2865293B72657475726E206A652874292C747D2C79692E70726F746F747970652E5F637265617465436F6E7461696E65723D66756E637469';
wwv_flow_imp.g_varchar2_table(1058) := '6F6E28652C742C6E2C69297B76617220723D5828226722293B472872292E6164642822646A732D67726F757022292C766F69642030213D3D6E3F676928722C742C742E6368696C644E6F6465735B6E5D293A6A28742C72293B766172206F3D5828226722';
wwv_flow_imp.g_varchar2_table(1059) := '293B47286F292E6164642822646A732D656C656D656E7422292C47286F292E6164642822646A732D222B65292C69262647286F292E6164642822646A732D6672616D6522292C6A28722C6F293B76617220613D5828226722293B72657475726E20472861';
wwv_flow_imp.g_varchar2_table(1060) := '292E6164642822646A732D76697375616C22292C6A286F2C61292C6F7D2C79692E70726F746F747970652E6372656174653D66756E6374696F6E28652C742C6E297B76617220693D746869732E5F6765744368696C6472656E436F6E7461696E65722874';
wwv_flow_imp.g_varchar2_table(1061) := '2E706172656E74293B72657475726E20746869732E5F637265617465436F6E7461696E657228652C692C6E2C4C74287429297D2C79692E70726F746F747970652E757064617465436F6E7461696E6D656E74733D66756E6374696F6E2865297B76617220';
wwv_flow_imp.g_varchar2_table(1062) := '742C6E3D746869732C693D746869732E5F656C656D656E7452656769737472793B743D7928652C2866756E6374696F6E28652C74297B72657475726E20742E706172656E74262628655B742E706172656E742E69645D3D742E706172656E74292C657D29';
wwv_flow_imp.g_varchar2_table(1063) := '2C7B7D292C6628742C2866756E6374696F6E2865297B76617220743D652E6368696C6472656E3B69662874297B76617220723D6E2E5F6765744368696C6472656E436F6E7461696E65722865293B6628742E736C69636528292E7265766572736528292C';
wwv_flow_imp.g_varchar2_table(1064) := '2866756E6374696F6E2865297B676928692E67657447726170686963732865292E706172656E744E6F64652C72297D29297D7D29297D2C79692E70726F746F747970652E6472617753686170653D66756E6374696F6E28652C742C6E3D7B7D297B726574';
wwv_flow_imp.g_varchar2_table(1065) := '75726E20746869732E5F6576656E744275732E66697265282272656E6465722E7368617065222C7B6766783A652C656C656D656E743A742C61747472733A6E7D297D2C79692E70726F746F747970652E6765745368617065506174683D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1066) := '6E2865297B72657475726E20746869732E5F6576656E744275732E66697265282272656E6465722E676574536861706550617468222C65297D2C79692E70726F746F747970652E64726177436F6E6E656374696F6E3D66756E6374696F6E28652C742C6E';
wwv_flow_imp.g_varchar2_table(1067) := '3D7B7D297B72657475726E20746869732E5F6576656E744275732E66697265282272656E6465722E636F6E6E656374696F6E222C7B6766783A652C656C656D656E743A742C61747472733A6E7D297D2C79692E70726F746F747970652E676574436F6E6E';
wwv_flow_imp.g_varchar2_table(1068) := '656374696F6E506174683D66756E6374696F6E2865297B72657475726E20746869732E5F6576656E744275732E66697265282272656E6465722E676574436F6E6E656374696F6E50617468222C65297D2C79692E70726F746F747970652E757064617465';
wwv_flow_imp.g_varchar2_table(1069) := '3D66756E6374696F6E28652C742C6E297B696628742E706172656E74297B76617220693D746869732E5F636C656172286E293B696628227368617065223D3D3D6529746869732E64726177536861706528692C74292C6974286E2C742E782C742E79293B';
wwv_flow_imp.g_varchar2_table(1070) := '656C73657B69662822636F6E6E656374696F6E22213D3D65297468726F77206E6577204572726F722822756E6B6E6F776E20747970653A20222B65293B746869732E64726177436F6E6E656374696F6E28692C74297D742E68696464656E3F7A286E2C22';
wwv_flow_imp.g_varchar2_table(1071) := '646973706C6179222C226E6F6E6522293A7A286E2C22646973706C6179222C22626C6F636B22297D7D2C79692E70726F746F747970652E72656D6F76653D66756E6374696F6E2865297B736528746869732E5F656C656D656E7452656769737472792E67';
wwv_flow_imp.g_varchar2_table(1072) := '657447726170686963732865292E706172656E744E6F6465297D3B636F6E73742076693D7B5F5F646570656E64735F5F3A5B576E5D2C5F5F696E69745F5F3A5B2263616E766173225D2C63616E7661733A5B2274797065222C716E5D2C656C656D656E74';
wwv_flow_imp.g_varchar2_table(1073) := '52656769737472793A5B2274797065222C5A6E5D2C656C656D656E74466163746F72793A5B2274797065222C75695D2C6576656E744275733A5B2274797065222C6D695D2C6772617068696373466163746F72793A5B2274797065222C79695D7D3B6675';
wwv_flow_imp.g_varchar2_table(1074) := '6E6374696F6E20626928652C74297B746869732E5F696E6A6563746F723D747C7C66756E6374696F6E2865297B72657475726E20743D5B7B636F6E6669673A5B2276616C7565222C653D657C7C7B7D5D7D2C76695D2E636F6E63617428652E6D6F64756C';
wwv_flow_imp.g_varchar2_table(1075) := '65737C7C5B5D292C286E3D6E657720566E287429292E696E697428292C6E3B76617220742C6E7D2865292C746869732E67657428226576656E7442757322292E6669726528226469616772616D2E696E697422297D66756E6374696F6E20786928297B7D';
wwv_flow_imp.g_varchar2_table(1076) := '66756E6374696F6E20776928652C74297B746869732E6D6F64656C3D652C746869732E70726F706572746965733D747D62692E70726F746F747970652E6765743D66756E6374696F6E28652C74297B72657475726E20746869732E5F696E6A6563746F72';
wwv_flow_imp.g_varchar2_table(1077) := '2E67657428652C74297D2C62692E70726F746F747970652E696E766F6B653D66756E6374696F6E28652C742C6E297B72657475726E20746869732E5F696E6A6563746F722E696E766F6B6528652C742C6E297D2C62692E70726F746F747970652E646573';
wwv_flow_imp.g_varchar2_table(1078) := '74726F793D66756E6374696F6E28297B746869732E67657428226576656E7442757322292E6669726528226469616772616D2E64657374726F7922297D2C62692E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E676574';
wwv_flow_imp.g_varchar2_table(1079) := '28226576656E7442757322292E6669726528226469616772616D2E636C65617222297D2C78692E70726F746F747970652E6765743D66756E6374696F6E2865297B72657475726E20746869732E246D6F64656C2E70726F706572746965732E6765742874';
wwv_flow_imp.g_varchar2_table(1080) := '6869732C65297D2C78692E70726F746F747970652E7365743D66756E6374696F6E28652C74297B746869732E246D6F64656C2E70726F706572746965732E73657428746869732C652C74297D2C77692E70726F746F747970652E63726561746554797065';
wwv_flow_imp.g_varchar2_table(1081) := '3D66756E6374696F6E2865297B76617220743D746869732E6D6F64656C2C6E3D746869732E70726F706572746965732C693D4F626A6563742E6372656174652878692E70726F746F74797065293B6628652E70726F706572746965732C2866756E637469';
wwv_flow_imp.g_varchar2_table(1082) := '6F6E2865297B652E69734D616E797C7C766F696420303D3D3D652E64656661756C747C7C28695B652E6E616D655D3D652E64656661756C74297D29292C6E2E646566696E654D6F64656C28692C74292C6E2E646566696E6544657363726970746F722869';
wwv_flow_imp.g_varchar2_table(1083) := '2C65293B76617220723D652E6E732E6E616D653B66756E6374696F6E206F2865297B6E2E646566696E6528746869732C222474797065222C7B76616C75653A722C656E756D657261626C653A21307D292C6E2E646566696E6528746869732C2224617474';
wwv_flow_imp.g_varchar2_table(1084) := '7273222C7B76616C75653A7B7D7D292C6E2E646566696E6528746869732C2224706172656E74222C7B7772697461626C653A21307D292C6628652C45282866756E6374696F6E28652C74297B746869732E73657428742C65297D292C7468697329297D72';
wwv_flow_imp.g_varchar2_table(1085) := '657475726E206F2E70726F746F747970653D692C6F2E686173547970653D692E24696E7374616E63654F663D746869732E6D6F64656C2E686173547970652C6E2E646566696E654D6F64656C286F2C74292C6E2E646566696E6544657363726970746F72';
wwv_flow_imp.g_varchar2_table(1086) := '286F2C65292C6F7D3B766172205F693D7B537472696E673A21302C426F6F6C65616E3A21302C496E74656765723A21302C5265616C3A21302C456C656D656E743A21307D2C45693D7B537472696E673A66756E6374696F6E2865297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(1087) := '7D2C426F6F6C65616E3A66756E6374696F6E2865297B72657475726E2274727565223D3D3D657D2C496E74656765723A66756E6374696F6E2865297B72657475726E207061727365496E7428652C3130297D2C5265616C3A66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(1088) := '72657475726E207061727365466C6F61742865297D7D3B66756E6374696F6E20536928652C74297B766172206E3D45695B655D3B72657475726E206E3F6E2874293A747D66756E6374696F6E2041692865297B72657475726E21215F695B655D7D66756E';
wwv_flow_imp.g_varchar2_table(1089) := '6374696F6E2043692865297B72657475726E212145695B655D7D66756E6374696F6E206B6928652C74297B766172206E2C692C723D652E73706C6974282F3A2F293B696628313D3D3D722E6C656E677468296E3D652C693D743B656C73657B6966283221';
wwv_flow_imp.g_varchar2_table(1090) := '3D3D722E6C656E677468297468726F77206E6577204572726F7228226578706563746564203C7072656669783A6C6F63616C4E616D653E206F72203C6C6F63616C4E616D653E2C20676F7420222B65293B6E3D725B315D2C693D725B305D7D7265747572';
wwv_flow_imp.g_varchar2_table(1091) := '6E7B6E616D653A653D28693F692B223A223A2222292B6E2C7072656669783A692C6C6F63616C4E616D653A6E7D7D66756E6374696F6E2052692865297B746869732E6E733D652C746869732E6E616D653D652E6E616D652C746869732E616C6C54797065';
wwv_flow_imp.g_varchar2_table(1092) := '733D5B5D2C746869732E616C6C547970657342794E616D653D7B7D2C746869732E70726F706572746965733D5B5D2C746869732E70726F7065727469657342794E616D653D7B7D7D66756E6374696F6E204D6928652C74297B746869732E7061636B6167';
wwv_flow_imp.g_varchar2_table(1093) := '654D61703D7B7D2C746869732E747970654D61703D7B7D2C746869732E7061636B616765733D5B5D2C746869732E70726F706572746965733D742C6628652C4528746869732E72656769737465725061636B6167652C7468697329297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1094) := '6E20506928652C742C6E297B76617220693D745B6E5D3B6966286920696E2065297468726F77206E6577204572726F7228227061636B616765207769746820222B6E2B22203C222B692B223E20616C726561647920646566696E656422297D66756E6374';
wwv_flow_imp.g_varchar2_table(1095) := '696F6E2044692865297B746869732E6D6F64656C3D657D66756E6374696F6E20426928652C742C6E297B4F626A6563742E646566696E6550726F706572747928652C742E6E616D652C7B656E756D657261626C653A21742E69735265666572656E63652C';
wwv_flow_imp.g_varchar2_table(1096) := '7772697461626C653A21302C76616C75653A6E2C636F6E666967757261626C653A21307D297D66756E6374696F6E204F692865297B72657475726E20652E7265706C616365282F5E3A2F2C2222297D66756E6374696F6E20546928652C743D7B7D297B74';
wwv_flow_imp.g_varchar2_table(1097) := '6869732E70726F706572746965733D6E65772044692874686973292C746869732E666163746F72793D6E657720776928746869732C746869732E70726F70657274696573292C746869732E72656769737472793D6E6577204D6928652C746869732E7072';
wwv_flow_imp.g_varchar2_table(1098) := '6F70657274696573292C746869732E7479706543616368653D7B7D2C746869732E636F6E6669673D747D52692E70726F746F747970652E6275696C643D66756E6374696F6E28297B72657475726E2066756E6374696F6E2865297B6C657420743D7B7D2C';
wwv_flow_imp.g_varchar2_table(1099) := '6E3D4F626A6563742865293B72657475726E2066285B226E73222C226E616D65222C22616C6C5479706573222C22616C6C547970657342794E616D65222C2270726F70657274696573222C2270726F7065727469657342794E616D65222C22626F647950';
wwv_flow_imp.g_varchar2_table(1100) := '726F7065727479222C22696450726F7065727479225D2C2866756E6374696F6E2869297B6920696E206E262628745B695D3D655B695D297D29292C747D2874686973297D2C52692E70726F746F747970652E61646450726F70657274793D66756E637469';
wwv_flow_imp.g_varchar2_table(1101) := '6F6E28652C742C6E297B22626F6F6C65616E223D3D747970656F6620742626286E3D742C743D766F69642030292C746869732E6164644E616D656450726F706572747928652C2131213D3D6E293B76617220693D746869732E70726F706572746965733B';
wwv_flow_imp.g_varchar2_table(1102) := '766F69642030213D3D743F692E73706C69636528742C302C65293A692E707573682865297D2C52692E70726F746F747970652E7265706C61636550726F70657274793D66756E6374696F6E28652C742C6E297B76617220693D652E6E732C723D74686973';
wwv_flow_imp.g_varchar2_table(1103) := '2E70726F706572746965732C6F3D746869732E70726F7065727469657342794E616D652C613D652E6E616D65213D3D742E6E616D653B696628652E69734964297B69662821742E69734964297468726F77206E6577204572726F72282270726F70657274';
wwv_flow_imp.g_varchar2_table(1104) := '79203C222B742E6E732E6E616D652B223E206D7573742062652069642070726F706572747920746F20726566696E65203C222B652E6E732E6E616D652B223E22293B746869732E736574496450726F706572747928742C2131297D696628652E6973426F';
wwv_flow_imp.g_varchar2_table(1105) := '6479297B69662821742E6973426F6479297468726F77206E6577204572726F72282270726F7065727479203C222B742E6E732E6E616D652B223E206D75737420626520626F64792070726F706572747920746F20726566696E65203C222B652E6E732E6E';
wwv_flow_imp.g_varchar2_table(1106) := '616D652B223E22293B746869732E736574426F647950726F706572747928742C2131297D76617220733D722E696E6465784F662865293B6966282D313D3D3D73297468726F77206E6577204572726F72282270726F7065727479203C222B692E6E616D65';
wwv_flow_imp.g_varchar2_table(1107) := '2B223E206E6F7420666F756E6420696E2070726F7065727479206C69737422293B722E73706C69636528732C31292C746869732E61646450726F706572747928742C6E3F766F696420303A732C61292C6F5B692E6E616D655D3D6F5B692E6C6F63616C4E';
wwv_flow_imp.g_varchar2_table(1108) := '616D655D3D747D2C52692E70726F746F747970652E7265646566696E6550726F70657274793D66756E6374696F6E28652C742C6E297B76617220693D652E6E732E7072656669782C723D742E73706C697428222322292C6F3D6B6928725B305D2C69292C';
wwv_flow_imp.g_varchar2_table(1109) := '613D6B6928725B315D2C6F2E707265666978292E6E616D652C733D746869732E70726F7065727469657342794E616D655B615D3B6966282173297468726F77206E6577204572726F722822726566696E65642070726F7065727479203C222B612B223E20';
wwv_flow_imp.g_varchar2_table(1110) := '6E6F7420666F756E6422293B746869732E7265706C61636550726F706572747928732C652C6E292C64656C65746520652E7265646566696E65737D2C52692E70726F746F747970652E6164644E616D656450726F70657274793D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(1111) := '2C74297B766172206E3D652E6E732C693D746869732E70726F7065727469657342794E616D653B74262628746869732E6173736572744E6F74446566696E656428652C6E2E6E616D65292C746869732E6173736572744E6F74446566696E656428652C6E';
wwv_flow_imp.g_varchar2_table(1112) := '2E6C6F63616C4E616D6529292C695B6E2E6E616D655D3D695B6E2E6C6F63616C4E616D655D3D657D2C52692E70726F746F747970652E72656D6F76654E616D656450726F70657274793D66756E6374696F6E2865297B76617220743D652E6E732C6E3D74';
wwv_flow_imp.g_varchar2_table(1113) := '6869732E70726F7065727469657342794E616D653B64656C657465206E5B742E6E616D655D2C64656C657465206E5B742E6C6F63616C4E616D655D7D2C52692E70726F746F747970652E736574426F647950726F70657274793D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(1114) := '2C74297B696628742626746869732E626F647950726F7065727479297468726F77206E6577204572726F722822626F64792070726F706572747920646566696E6564206D756C7469706C652074696D657320283C222B746869732E626F647950726F7065';
wwv_flow_imp.g_varchar2_table(1115) := '7274792E6E732E6E616D652B223E2C203C222B652E6E732E6E616D652B223E2922293B746869732E626F647950726F70657274793D657D2C52692E70726F746F747970652E736574496450726F70657274793D66756E6374696F6E28652C74297B696628';
wwv_flow_imp.g_varchar2_table(1116) := '742626746869732E696450726F7065727479297468726F77206E6577204572726F72282269642070726F706572747920646566696E6564206D756C7469706C652074696D657320283C222B746869732E696450726F70657274792E6E732E6E616D652B22';
wwv_flow_imp.g_varchar2_table(1117) := '3E2C203C222B652E6E732E6E616D652B223E2922293B746869732E696450726F70657274793D657D2C52692E70726F746F747970652E6173736572744E6F7454726169743D66756E6374696F6E2865297B69662828652E657874656E64737C7C5B5D292E';
wwv_flow_imp.g_varchar2_table(1118) := '6C656E677468297468726F77206E6577204572726F72286063616E6E6F7420637265617465203C247B652E6E616D657D3E20657874656E64696E67203C247B652E657874656E64737D3E60297D2C52692E70726F746F747970652E6173736572744E6F74';
wwv_flow_imp.g_varchar2_table(1119) := '446566696E65643D66756E6374696F6E28652C74297B766172206E3D652E6E616D652C693D746869732E70726F7065727469657342794E616D655B6E5D3B69662869297468726F77206E6577204572726F72282270726F7065727479203C222B6E2B223E';
wwv_flow_imp.g_varchar2_table(1120) := '20616C726561647920646566696E65643B206F76657272696465206F66203C222B692E646566696E656442792E6E732E6E616D652B2223222B692E6E732E6E616D652B223E206279203C222B652E646566696E656442792E6E732E6E616D652B2223222B';
wwv_flow_imp.g_varchar2_table(1121) := '652E6E732E6E616D652B223E206E6F7420616C6C6F77656420776974686F7574207265646566696E657322297D2C52692E70726F746F747970652E68617350726F70657274793D66756E6374696F6E2865297B72657475726E20746869732E70726F7065';
wwv_flow_imp.g_varchar2_table(1122) := '727469657342794E616D655B655D7D2C52692E70726F746F747970652E61646454726169743D66756E6374696F6E28652C74297B742626746869732E6173736572744E6F7454726169742865293B766172206E3D746869732E616C6C547970657342794E';
wwv_flow_imp.g_varchar2_table(1123) := '616D652C693D746869732E616C6C54797065732C723D652E6E616D653B7220696E206E7C7C286628652E70726F706572746965732C45282866756E6374696F6E286E297B6E3D53287B7D2C6E2C7B6E616D653A6E2E6E732E6C6F63616C4E616D652C696E';
wwv_flow_imp.g_varchar2_table(1124) := '686572697465643A747D292C4F626A6563742E646566696E6550726F7065727479286E2C22646566696E65644279222C7B76616C75653A657D293B76617220693D6E2E7265706C616365732C723D6E2E7265646566696E65733B697C7C723F746869732E';
wwv_flow_imp.g_varchar2_table(1125) := '7265646566696E6550726F7065727479286E2C697C7C722C69293A286E2E6973426F64792626746869732E736574426F647950726F7065727479286E292C6E2E697349642626746869732E736574496450726F7065727479286E292C746869732E616464';
wwv_flow_imp.g_varchar2_table(1126) := '50726F7065727479286E29297D292C7468697329292C692E707573682865292C6E5B725D3D65297D2C4D692E70726F746F747970652E6765745061636B6167653D66756E6374696F6E2865297B72657475726E20746869732E7061636B6167654D61705B';
wwv_flow_imp.g_varchar2_table(1127) := '655D7D2C4D692E70726F746F747970652E6765745061636B616765733D66756E6374696F6E28297B72657475726E20746869732E7061636B616765737D2C4D692E70726F746F747970652E72656769737465725061636B6167653D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1128) := '65297B653D53287B7D2C65293B76617220743D746869732E7061636B6167654D61703B506928742C652C2270726566697822292C506928742C652C2275726922292C6628652E74797065732C45282866756E6374696F6E2874297B746869732E72656769';
wwv_flow_imp.g_varchar2_table(1129) := '737465725479706528742C65297D292C7468697329292C745B652E7572695D3D745B652E7072656669785D3D652C746869732E7061636B616765732E707573682865297D2C4D692E70726F746F747970652E7265676973746572547970653D66756E6374';
wwv_flow_imp.g_varchar2_table(1130) := '696F6E28652C74297B766172206E3D6B692828653D53287B7D2C652C7B7375706572436C6173733A28652E7375706572436C6173737C7C5B5D292E736C69636528292C657874656E64733A28652E657874656E64737C7C5B5D292E736C69636528292C70';
wwv_flow_imp.g_varchar2_table(1131) := '726F706572746965733A28652E70726F706572746965737C7C5B5D292E736C69636528292C6D6574613A5328652E6D6574617C7C7B7D297D29292E6E616D652C742E707265666978292C693D6E2E6E616D652C723D7B7D3B6628652E70726F7065727469';
wwv_flow_imp.g_varchar2_table(1132) := '65732C45282866756E6374696F6E2865297B76617220743D6B6928652E6E616D652C6E2E707265666978292C693D742E6E616D653B416928652E74797065297C7C28652E747970653D6B6928652E747970652C742E707265666978292E6E616D65292C53';
wwv_flow_imp.g_varchar2_table(1133) := '28652C7B6E733A742C6E616D653A697D292C725B695D3D657D292C7468697329292C5328652C7B6E733A6E2C6E616D653A692C70726F7065727469657342794E616D653A727D292C6628652E657874656E64732C45282866756E6374696F6E2865297B76';
wwv_flow_imp.g_varchar2_table(1134) := '617220743D6B6928652C6E2E707265666978292C723D746869732E747970654D61705B742E6E616D655D3B722E7472616974733D722E7472616974737C7C5B5D2C722E7472616974732E707573682869297D292C7468697329292C746869732E64656669';
wwv_flow_imp.g_varchar2_table(1135) := '6E655061636B61676528652C74292C746869732E747970654D61705B695D3D657D2C4D692E70726F746F747970652E6D617054797065733D66756E6374696F6E28652C742C6E297B76617220693D416928652E6E616D65293F7B6E616D653A652E6E616D';
wwv_flow_imp.g_varchar2_table(1136) := '657D3A746869732E747970654D61705B652E6E616D655D2C723D746869733B66756E6374696F6E206F286E2C69297B766172206F3D6B69286E2C4169286E293F22223A652E707265666978293B722E6D61705479706573286F2C742C69297D66756E6374';
wwv_flow_imp.g_varchar2_table(1137) := '696F6E20612865297B72657475726E206F28652C2130297D6966282169297468726F77206E6577204572726F722822756E6B6E6F776E2074797065203C222B652E6E616D652B223E22293B6628692E7375706572436C6173732C6E3F613A66756E637469';
wwv_flow_imp.g_varchar2_table(1138) := '6F6E2865297B72657475726E206F28652C2131297D292C7428692C216E292C6628692E7472616974732C61297D2C4D692E70726F746F747970652E67657445666665637469766544657363726970746F723D66756E6374696F6E2865297B76617220743D';
wwv_flow_imp.g_varchar2_table(1139) := '6B692865292C6E3D6E65772052692874293B746869732E6D6170547970657328742C2866756E6374696F6E28652C74297B6E2E616464547261697428652C74297D29293B76617220693D6E2E6275696C6428293B72657475726E20746869732E64656669';
wwv_flow_imp.g_varchar2_table(1140) := '6E655061636B61676528692C692E616C6C54797065735B692E616C6C54797065732E6C656E6774682D315D2E24706B67292C697D2C4D692E70726F746F747970652E646566696E655061636B6167653D66756E6374696F6E28652C74297B746869732E70';
wwv_flow_imp.g_varchar2_table(1141) := '726F706572746965732E646566696E6528652C2224706B67222C7B76616C75653A747D297D2C44692E70726F746F747970652E7365743D66756E6374696F6E28652C742C6E297B69662821752874297C7C21742E6C656E677468297468726F77206E6577';
wwv_flow_imp.g_varchar2_table(1142) := '20547970654572726F72282270726F7065727479206E616D65206D7573742062652061206E6F6E2D656D70747920737472696E6722293B76617220693D746869732E67657450726F706572747928652C74292C723D692626692E6E616D653B766F696420';
wwv_flow_imp.g_varchar2_table(1143) := '303D3D3D6E3F693F64656C65746520655B725D3A64656C65746520652E2461747472735B4F692874295D3A693F7220696E20653F655B725D3D6E3A426928652C692C6E293A652E2461747472735B4F692874295D3D6E7D2C44692E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(1144) := '2E6765743D66756E6374696F6E28652C74297B766172206E3D746869732E67657450726F706572747928652C74293B696628216E2972657475726E20652E2461747472735B4F692874295D3B76617220693D6E2E6E616D653B72657475726E21655B695D';
wwv_flow_imp.g_varchar2_table(1145) := '26266E2E69734D616E792626426928652C6E2C5B5D292C655B695D7D2C44692E70726F746F747970652E646566696E653D66756E6374696F6E28652C742C6E297B696628216E2E7772697461626C65297B76617220693D6E2E76616C75653B64656C6574';
wwv_flow_imp.g_varchar2_table(1146) := '65286E3D53287B7D2C6E2C7B6765743A66756E6374696F6E28297B72657475726E20697D7D29292E76616C75657D4F626A6563742E646566696E6550726F706572747928652C742C6E297D2C44692E70726F746F747970652E646566696E654465736372';
wwv_flow_imp.g_varchar2_table(1147) := '6970746F723D66756E6374696F6E28652C74297B746869732E646566696E6528652C222464657363726970746F72222C7B76616C75653A747D297D2C44692E70726F746F747970652E646566696E654D6F64656C3D66756E6374696F6E28652C74297B74';
wwv_flow_imp.g_varchar2_table(1148) := '6869732E646566696E6528652C22246D6F64656C222C7B76616C75653A747D297D2C44692E70726F746F747970652E67657450726F70657274793D66756E6374696F6E28652C74297B766172206E3D746869732E6D6F64656C2C693D6E2E67657450726F';
wwv_flow_imp.g_varchar2_table(1149) := '706572747944657363726970746F7228652C74293B696628692972657475726E20693B696628742E696E636C7564657328223A22292972657475726E206E756C6C3B636F6E737420723D6E2E636F6E6669672E7374726963743B696628766F6964203021';
wwv_flow_imp.g_varchar2_table(1150) := '3D3D72297B636F6E7374206E3D6E657720547970654572726F722860756E6B6E6F776E2070726F7065727479203C247B747D3E206F6E203C247B652E24747970657D3E60293B69662872297468726F77206E3B22756E646566696E656422213D74797065';
wwv_flow_imp.g_varchar2_table(1151) := '6F6620636F6E736F6C652626636F6E736F6C652E7761726E286E297D72657475726E206E756C6C7D2C54692E70726F746F747970652E6372656174653D66756E6374696F6E28652C74297B766172206E3D746869732E676574547970652865293B696628';
wwv_flow_imp.g_varchar2_table(1152) := '216E297468726F77206E6577204572726F722822756E6B6E6F776E2074797065203C222B652B223E22293B72657475726E206E6577206E2874297D2C54692E70726F746F747970652E676574547970653D66756E6374696F6E2865297B76617220743D74';
wwv_flow_imp.g_varchar2_table(1153) := '6869732E7479706543616368652C6E3D752865293F653A652E6E732E6E616D652C693D745B6E5D3B72657475726E20697C7C28653D746869732E72656769737472792E67657445666665637469766544657363726970746F72286E292C693D745B6E5D3D';
wwv_flow_imp.g_varchar2_table(1154) := '746869732E666163746F72792E63726561746554797065286529292C697D2C54692E70726F746F747970652E637265617465416E793D66756E6374696F6E28652C742C6E297B76617220693D6B692865292C723D7B24747970653A652C24696E7374616E';
wwv_flow_imp.g_varchar2_table(1155) := '63654F663A66756E6374696F6E2865297B72657475726E20653D3D3D746869732E24747970657D2C6765743A66756E6374696F6E2865297B72657475726E20746869735B655D7D2C7365743A66756E6374696F6E28652C74297B2166756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1156) := '652C742C6E297B6C657420693D653B6628742C2866756E6374696F6E28652C72297B696628226E756D62657222213D747970656F662065262622737472696E6722213D747970656F662065297468726F77206E6577204572726F722822696C6C6567616C';
wwv_flow_imp.g_varchar2_table(1157) := '206B657920747970653A20222B747970656F6620652B222E204B65792073686F756C64206265206F662074797065206E756D626572206F7220737472696E672E22293B69662822636F6E7374727563746F72223D3D3D65297468726F77206E6577204572';
wwv_flow_imp.g_varchar2_table(1158) := '726F722822696C6C6567616C206B65793A20636F6E7374727563746F7222293B696628225F5F70726F746F5F5F223D3D3D65297468726F77206E6577204572726F722822696C6C6567616C206B65793A205F5F70726F746F5F5F22293B6C657420733D74';
wwv_flow_imp.g_varchar2_table(1159) := '5B722B315D2C6C3D695B655D3B6128732926266E756C6C3D3D6C2626286C3D695B655D3D69734E614E282B73293F7B7D3A5B5D292C6F2873293F6F286E293F64656C65746520695B655D3A695B655D3D6E3A693D6C7D29297D28746869732C5B655D2C74';
wwv_flow_imp.g_varchar2_table(1160) := '297D7D2C733D7B6E616D653A652C697347656E657269633A21302C6E733A7B7072656669783A692E7072656669782C6C6F63616C4E616D653A692E6C6F63616C4E616D652C7572693A747D7D3B72657475726E20746869732E70726F706572746965732E';
wwv_flow_imp.g_varchar2_table(1161) := '646566696E6544657363726970746F7228722C73292C746869732E70726F706572746965732E646566696E654D6F64656C28722C74686973292C746869732E70726F706572746965732E646566696E6528722C22676574222C7B656E756D657261626C65';
wwv_flow_imp.g_varchar2_table(1162) := '3A21312C7772697461626C653A21307D292C746869732E70726F706572746965732E646566696E6528722C22736574222C7B656E756D657261626C653A21312C7772697461626C653A21307D292C746869732E70726F706572746965732E646566696E65';
wwv_flow_imp.g_varchar2_table(1163) := '28722C2224706172656E74222C7B656E756D657261626C653A21312C7772697461626C653A21307D292C746869732E70726F706572746965732E646566696E6528722C2224696E7374616E63654F66222C7B656E756D657261626C653A21312C77726974';
wwv_flow_imp.g_varchar2_table(1164) := '61626C653A21307D292C66286E2C2866756E6374696F6E28652C74297B6C2865292626766F69642030213D3D652E76616C75653F725B652E6E616D655D3D652E76616C75653A725B745D3D657D29292C727D2C54692E70726F746F747970652E67657450';
wwv_flow_imp.g_varchar2_table(1165) := '61636B6167653D66756E6374696F6E2865297B72657475726E20746869732E72656769737472792E6765745061636B6167652865297D2C54692E70726F746F747970652E6765745061636B616765733D66756E6374696F6E28297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(1166) := '69732E72656769737472792E6765745061636B6167657328297D2C54692E70726F746F747970652E676574456C656D656E7444657363726970746F723D66756E6374696F6E2865297B72657475726E20652E2464657363726970746F727D2C54692E7072';
wwv_flow_imp.g_varchar2_table(1167) := '6F746F747970652E686173547970653D66756E6374696F6E28652C74297B72657475726E20766F696420303D3D3D74262628743D652C653D74686973292C7420696E20652E246D6F64656C2E676574456C656D656E7444657363726970746F722865292E';
wwv_flow_imp.g_varchar2_table(1168) := '616C6C547970657342794E616D657D2C54692E70726F746F747970652E67657450726F706572747944657363726970746F723D66756E6374696F6E28652C74297B72657475726E20746869732E676574456C656D656E7444657363726970746F72286529';
wwv_flow_imp.g_varchar2_table(1169) := '2E70726F7065727469657342794E616D655B745D7D2C54692E70726F746F747970652E6765745479706544657363726970746F723D66756E6374696F6E2865297B72657475726E20746869732E72656769737472792E747970654D61705B655D7D3B7661';
wwv_flow_imp.g_varchar2_table(1170) := '72204E693D537472696E672E66726F6D43686172436F64652C49693D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792C4C693D2F2623285C642B293B7C262378285B302D39612D665D2B293B7C26285C772B293B2F67692C';
wwv_flow_imp.g_varchar2_table(1171) := '6A693D7B616D703A2226222C61706F733A2227222C67743A223E222C6C743A223C222C71756F743A2722277D3B66756E6374696F6E20466928652C742C6E2C69297B72657475726E20693F49692E63616C6C286A692C69293F6A695B695D3A2226222B69';
wwv_flow_imp.g_varchar2_table(1172) := '2B223B223A4E6928747C7C7061727365496E74286E2C313629297D66756E6374696F6E2056692865297B72657475726E20652E6C656E6774683E3326262D31213D3D652E696E6465784F6628222622293F652E7265706C616365284C692C4669293A657D';
wwv_flow_imp.g_varchar2_table(1173) := '4F626A6563742E6B657973286A69292E666F7245616368282866756E6374696F6E2865297B6A695B652E746F55707065724361736528295D3D6A695B655D7D29293B7661722024693D227873693A74797065222C7A693D226E6F6E2D7768697465737061';
wwv_flow_imp.g_varchar2_table(1174) := '6365206F757473696465206F6620726F6F74206E6F6465223B66756E6374696F6E2057692865297B72657475726E206E6577204572726F722865297D66756E6374696F6E2047692865297B72657475726E226D697373696E67206E616D65737061636520';
wwv_flow_imp.g_varchar2_table(1175) := '666F7220707265666978203C222B652B223E227D66756E6374696F6E2048692865297B72657475726E7B6765743A652C656E756D657261626C653A21307D7D66756E6374696F6E204B692865297B76617220742C6E3D7B7D3B666F72287420696E206529';
wwv_flow_imp.g_varchar2_table(1176) := '6E5B745D3D655B745D3B72657475726E206E7D66756E6374696F6E2055692865297B72657475726E20652B2224757269227D66756E6374696F6E20716928297B72657475726E7B6C696E653A302C636F6C756D6E3A307D7D66756E6374696F6E20596928';
wwv_flow_imp.g_varchar2_table(1177) := '65297B7468726F7720657D66756E6374696F6E2058692865297B69662821746869732972657475726E206E65772058692865293B76617220742C6E2C692C722C6F2C612C732C6C2C632C703D652626652E70726F78792C753D59692C683D71692C643D21';
wwv_flow_imp.g_varchar2_table(1178) := '312C6D3D21312C663D6E756C6C2C793D21313B66756E6374696F6E20672865297B6520696E7374616E63656F66204572726F727C7C28653D5769286529292C663D652C7528652C68297D66756E6374696F6E20762865297B6F2626286520696E7374616E';
wwv_flow_imp.g_varchar2_table(1179) := '63656F66204572726F727C7C28653D5769286529292C6F28652C6829297D746869732E6F6E3D66756E6374696F6E28652C63297B6966282266756E6374696F6E22213D747970656F662063297468726F7720576928227265717569726564206172677320';
wwv_flow_imp.g_varchar2_table(1180) := '3C6E616D652C2063623E22293B7377697463682865297B63617365226F70656E546167223A6E3D633B627265616B3B636173652274657874223A743D633B627265616B3B6361736522636C6F7365546167223A693D633B627265616B3B63617365226572';
wwv_flow_imp.g_varchar2_table(1181) := '726F72223A753D633B627265616B3B63617365227761726E223A6F3D633B627265616B3B63617365226364617461223A723D633B627265616B3B6361736522617474656E74696F6E223A6C3D633B627265616B3B63617365227175657374696F6E223A73';
wwv_flow_imp.g_varchar2_table(1182) := '3D633B627265616B3B6361736522636F6D6D656E74223A613D633B627265616B3B64656661756C743A7468726F772057692822756E737570706F72746564206576656E743A20222B65297D72657475726E20746869737D2C746869732E6E733D66756E63';
wwv_flow_imp.g_varchar2_table(1183) := '74696F6E2865297B696628766F696420303D3D3D65262628653D7B7D292C226F626A65637422213D747970656F662065297468726F77205769282272657175697265642061726773203C6E734D61703D7B7D3E22293B76617220742C6E3D7B7D3B666F72';
wwv_flow_imp.g_varchar2_table(1184) := '287420696E2065296E5B745D3D655B745D3B72657475726E206E5B22687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D612D696E7374616E6365225D3D22787369222C6D3D21302C633D6E2C746869737D2C746869732E7061';
wwv_flow_imp.g_varchar2_table(1185) := '7273653D66756E6374696F6E2865297B69662822737472696E6722213D747970656F662065297468726F77205769282272657175697265642061726773203C786D6C3D737472696E673E22293B72657475726E20663D6E756C6C2C66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1186) := '65297B766172206F2C752C662C622C782C772C5F2C452C532C412C432C6B3D6D3F5B5D3A6E756C6C2C523D6D3F66756E6374696F6E2865297B76617220742C6E2C693D7B7D3B666F72287420696E206529695B6E3D655B745D5D3D6E2C695B5569286E29';
wwv_flow_imp.g_varchar2_table(1187) := '5D3D743B72657475726E20697D2863293A6E756C6C2C4D3D5B5D2C503D302C443D21312C423D21312C4F3D302C543D302C4E3D22222C493D303B66756E6374696F6E204C28297B6966286E756C6C213D3D432972657475726E20433B76617220652C742C';
wwv_flow_imp.g_varchar2_table(1188) := '6E2C692C722C6F2C612C732C6C2C702C752C683D6D2626522E786D6C6E732C663D6D2626643F5B5D3A6E756C6C2C793D492C673D4E2C623D672E6C656E6774682C783D7B7D2C773D7B7D3B653A666F72283B793C623B792B2B296966286C3D21312C2128';
wwv_flow_imp.g_varchar2_table(1189) := '33323D3D3D28703D672E63686172436F64654174287929297C7C703C31342626703E3829297B666F722828703C36357C7C703E3132327C7C703E39302626703C39372926263935213D3D7026263538213D3D70262628762822696C6C6567616C20666972';
wwv_flow_imp.g_varchar2_table(1190) := '7374206368617220617474726962757465206E616D6522292C6C3D2130292C753D792B313B753C623B752B2B29696628212828703D672E63686172436F64654174287529293E39362626703C3132337C7C703E36342626703C39317C7C703E3437262670';
wwv_flow_imp.g_varchar2_table(1191) := '3C35397C7C34363D3D3D707C7C34353D3D3D707C7C39353D3D3D7029297B69662833323D3D3D707C7C703C31342626703E38297B7628226D697373696E67206174747269627574652076616C756522292C793D753B636F6E74696E756520657D69662836';
wwv_flow_imp.g_varchar2_table(1192) := '313D3D3D7029627265616B3B762822696C6C6567616C20617474726962757465206E616D65206368617222292C6C3D21307D69662822786D6C6E733A786D6C6E73223D3D3D28733D672E737562737472696E6728792C752929262628762822696C6C6567';
wwv_flow_imp.g_varchar2_table(1193) := '616C206465636C61726174696F6E206F6620786D6C6E7322292C6C3D2130292C33343D3D3D28703D672E63686172436F6465417428752B312929292D313D3D3D28753D672E696E6465784F66282722272C793D752B32292926262D31213D3D28753D672E';
wwv_flow_imp.g_varchar2_table(1194) := '696E6465784F66282227222C7929292626287628226174747269627574652076616C75652071756F7465206D6973736D6174636822292C6C3D2130293B656C73652069662833393D3D3D70292D313D3D3D28753D672E696E6465784F66282227222C793D';
wwv_flow_imp.g_varchar2_table(1195) := '752B32292926262D31213D3D28753D672E696E6465784F66282722272C7929292626287628226174747269627574652076616C75652071756F7465206D6973736D6174636822292C6C3D2130293B656C736520666F72287628226D697373696E67206174';
wwv_flow_imp.g_varchar2_table(1196) := '747269627574652076616C75652071756F74657322292C6C3D21302C752B3D313B753C622626212833323D3D3D28703D672E63686172436F6465417428752B3129297C7C703C31342626703E38293B752B2B293B666F72282D313D3D3D75262628762822';
wwv_flow_imp.g_varchar2_table(1197) := '6D697373696E6720636C6F73696E672071756F74657322292C753D622C6C3D2130292C6C7C7C286F3D672E737562737472696E6728792C7529292C793D753B752B313C622626212833323D3D3D28703D672E63686172436F6465417428752B3129297C7C';
wwv_flow_imp.g_varchar2_table(1198) := '703C31342626703E38293B752B2B29793D3D3D75262628762822696C6C6567616C206368617261637465722061667465722061747472696275746520656E6422292C6C3D2130293B696628793D752B312C216C296966287320696E207729762822617474';
wwv_flow_imp.g_varchar2_table(1199) := '726962757465203C222B732B223E20616C726561647920646566696E656422293B656C736520696628775B735D3D21302C6D2969662864297B6966286E756C6C213D3D28723D22786D6C6E73223D3D3D733F22786D6C6E73223A3132303D3D3D732E6368';
wwv_flow_imp.g_varchar2_table(1200) := '6172436F64654174283029262622786D6C6E733A223D3D3D732E73756273747228302C36293F732E7375627374722836293A6E756C6C29297B696628653D5669286F292C743D55692872292C2128613D635B655D29297B69662822786D6C6E73223D3D3D';
wwv_flow_imp.g_varchar2_table(1201) := '727C7C7420696E20522626525B745D213D3D6529646F7B613D226E73222B502B2B7D7768696C6528766F69642030213D3D525B615D293B656C736520613D723B635B655D3D617D525B725D213D3D61262628697C7C28523D4B692852292C693D2130292C';
wwv_flow_imp.g_varchar2_table(1202) := '525B725D3D612C22786D6C6E73223D3D3D72262628525B55692861295D3D652C683D61292C525B745D3D65292C785B735D3D6F3B636F6E74696E75657D662E7075736828732C6F297D656C73652D31213D3D28703D732E696E6465784F6628223A222929';
wwv_flow_imp.g_varchar2_table(1203) := '3F286E3D525B732E737562737472696E6728302C70295D293F2828733D683D3D3D6E3F732E73756273747228702B31293A6E2B732E737562737472287029293D3D3D24692626282D31213D3D28703D6F2E696E6465784F6628223A2229293F286E3D6F2E';
wwv_flow_imp.g_varchar2_table(1204) := '737562737472696E6728302C70292C6F3D286E3D525B6E5D7C7C6E292B6F2E737562737472696E67287029293A6F3D682B223A222B6F292C785B735D3D6F293A7628476928732E737562737472696E6728302C702929293A785B735D3D6F3B656C736520';
wwv_flow_imp.g_varchar2_table(1205) := '785B735D3D6F7D6966286429666F7228793D302C623D662E6C656E6774683B793C623B792B2B297B696628733D665B792B2B5D2C6F3D665B795D2C2D31213D3D28703D732E696E6465784F6628223A222929297B69662821286E3D525B732E7375627374';
wwv_flow_imp.g_varchar2_table(1206) := '72696E6728302C70295D29297B7628476928732E737562737472696E6728302C702929293B636F6E74696E75657D28733D683D3D3D6E3F732E73756273747228702B31293A6E2B732E737562737472287029293D3D3D24692626282D31213D3D28703D6F';
wwv_flow_imp.g_varchar2_table(1207) := '2E696E6465784F6628223A2229293F286E3D6F2E737562737472696E6728302C70292C6F3D286E3D525B6E5D7C7C6E292B6F2E737562737472696E67287029293A6F3D682B223A222B6F297D785B735D3D6F7D72657475726E20433D787D666F7228683D';
wwv_flow_imp.g_varchar2_table(1208) := '66756E6374696F6E28297B666F722876617220742C6E2C693D2F285C725C6E7C5C727C5C6E292F672C723D302C6F3D302C613D302C733D543B4F3E3D61262628743D692E65786563286529292626212828733D745B305D2E6C656E6774682B742E696E64';
wwv_flow_imp.g_varchar2_table(1209) := '6578293E4F293B29722B3D312C613D733B72657475726E2D313D3D4F3F286F3D732C6E3D652E737562737472696E67285429293A303D3D3D543F6E3D652E737562737472696E6728542C4F293A286F3D4F2D612C6E3D2D313D3D543F652E737562737472';
wwv_flow_imp.g_varchar2_table(1210) := '696E67284F293A652E737562737472696E67284F2C542B3129292C7B646174613A6E2C6C696E653A722C636F6C756D6E3A6F7D7D2C70262628413D4F626A6563742E637265617465287B7D2C7B6E616D653A4869282866756E6374696F6E28297B726574';
wwv_flow_imp.g_varchar2_table(1211) := '75726E20457D29292C6F726967696E616C4E616D653A4869282866756E6374696F6E28297B72657475726E20537D29292C61747472733A4869284C292C6E733A4869282866756E6374696F6E28297B72657475726E20527D29297D29293B2D31213D3D54';
wwv_flow_imp.g_varchar2_table(1212) := '3B297B6966282D313D3D3D284F3D36303D3D3D652E63686172436F646541742854293F543A652E696E6465784F6628223C222C5429292972657475726E204D2E6C656E6774683F672822756E657870656374656420656E64206F662066696C6522293A30';
wwv_flow_imp.g_varchar2_table(1213) := '3D3D3D543F6728226D697373696E672073746172742074616722293A766F696428543C652E6C656E6774682626652E737562737472696E672854292E7472696D2829262676287A6929293B69662854213D3D4F296966284D2E6C656E677468297B696628';
wwv_flow_imp.g_varchar2_table(1214) := '742626287428652E737562737472696E6728542C4F292C56692C68292C79292972657475726E7D656C736520696628652E737562737472696E6728542C4F292E7472696D282926262876287A69292C79292972657475726E3B69662833333D3D3D28783D';
wwv_flow_imp.g_varchar2_table(1215) := '652E63686172436F64654174284F2B312929297B69662839313D3D3D28623D652E63686172436F64654174284F2B32292926262243444154415B223D3D3D652E737562737472284F2B332C3629297B6966282D313D3D3D28543D652E696E6465784F6628';
wwv_flow_imp.g_varchar2_table(1216) := '225D5D3E222C4F29292972657475726E20672822756E636C6F73656420636461746122293B696628722626287228652E737562737472696E67284F2B392C54292C68292C79292972657475726E3B542B3D333B636F6E74696E75657D69662834353D3D3D';
wwv_flow_imp.g_varchar2_table(1217) := '62262634353D3D3D652E63686172436F64654174284F2B3329297B6966282D313D3D3D28543D652E696E6465784F6628222D2D5C783365222C4F29292972657475726E20672822756E636C6F73656420636F6D6D656E7422293B69662861262628612865';
wwv_flow_imp.g_varchar2_table(1218) := '2E737562737472696E67284F2B342C54292C56692C68292C79292972657475726E3B542B3D333B636F6E74696E75657D7D6966283633213D3D78297B666F7228753D4F2B313B3B752B2B297B696628773D652E63686172436F646541742875292C69734E';
wwv_flow_imp.g_varchar2_table(1219) := '614E2877292972657475726E20543D2D312C672822756E636C6F7365642074616722293B69662833343D3D3D7729753D2D31213D3D28623D652E696E6465784F66282722272C752B3129293F623A753B656C73652069662833393D3D3D7729753D2D3121';
wwv_flow_imp.g_varchar2_table(1220) := '3D3D28623D652E696E6465784F66282227222C752B3129293F623A753B656C73652069662836323D3D3D77297B543D753B627265616B7D7D6966283333213D3D78297B696628433D7B7D2C34373D3D3D78297B696628443D21312C423D21302C214D2E6C';
wwv_flow_imp.g_varchar2_table(1221) := '656E6774682972657475726E206728226D697373696E67206F70656E2074616722293B696628753D453D4D2E706F7028292C623D4F2B322B752E6C656E6774682C652E737562737472696E67284F2B322C6229213D3D752972657475726E20672822636C';
wwv_flow_imp.g_varchar2_table(1222) := '6F73696E6720746167206D69736D6174636822293B666F72283B623C543B622B2B29696628212833323D3D3D28783D652E63686172436F64654174286229297C7C783E382626783C3134292972657475726E20672822636C6F73652074616722297D656C';
wwv_flow_imp.g_varchar2_table(1223) := '73657B69662834373D3D3D652E63686172436F6465417428542D31293F28753D453D652E737562737472696E67284F2B312C542D31292C443D21302C423D2130293A28753D453D652E737562737472696E67284F2B312C54292C443D21302C423D213129';
wwv_flow_imp.g_varchar2_table(1224) := '2C2128783E39362626783C3132337C7C783E36342626783C39317C7C39353D3D3D787C7C35383D3D3D78292972657475726E20672822696C6C6567616C2066697273742063686172206E6F64654E616D6522293B666F7228623D312C663D752E6C656E67';
wwv_flow_imp.g_varchar2_table(1225) := '74683B623C663B622B2B29696628212828783D752E63686172436F64654174286229293E39362626783C3132337C7C783E36342626783C39317C7C783E34372626783C35397C7C34353D3D3D787C7C39353D3D3D787C7C34363D3D7829297B6966283332';
wwv_flow_imp.g_varchar2_table(1226) := '3D3D3D787C7C783C31342626783E38297B453D752E737562737472696E6728302C62292C433D6E756C6C3B627265616B7D72657475726E20672822696E76616C6964206E6F64654E616D6522297D427C7C4D2E707573682845297D6966286D297B696628';
wwv_flow_imp.g_varchar2_table(1227) := '6F3D522C44262628427C7C6B2E70757368286F292C6E756C6C3D3D3D43262628643D2D31213D3D752E696E6465784F662822786D6C6E73222C622929262628493D622C4E3D752C4C28292C643D213129292C533D452C2D31213D3D28783D452E696E6465';
wwv_flow_imp.g_varchar2_table(1228) := '784F6628223A222929297B69662821285F3D525B452E737562737472696E6728302C78295D292972657475726E206728226D697373696E67206E616D657370616365206F6E203C222B532B223E22293B453D452E73756273747228782B31297D656C7365';
wwv_flow_imp.g_varchar2_table(1229) := '205F3D522E786D6C6E733B5F262628453D5F2B223A222B45297D69662844262628493D622C4E3D752C6E262628703F6E28412C56692C422C68293A6E28452C4C2C56692C422C68292C7929292972657475726E3B69662842297B69662869262628692870';
wwv_flow_imp.g_varchar2_table(1230) := '3F413A452C56692C442C68292C79292972657475726E3B6D262628523D443F6F3A6B2E706F702829297D542B3D317D656C73657B6966286C2626286C28652E737562737472696E67284F2C542B31292C56692C68292C79292972657475726E3B542B3D31';
wwv_flow_imp.g_varchar2_table(1231) := '7D7D656C73657B6966282D313D3D3D28543D652E696E6465784F6628223F3E222C4F29292972657475726E20672822756E636C6F736564207175657374696F6E22293B696628732626287328652E737562737472696E67284F2C542B32292C68292C7929';
wwv_flow_imp.g_varchar2_table(1232) := '2972657475726E3B542B3D327D7D7D2865292C683D71692C793D21312C667D2C746869732E73746F703D66756E6374696F6E28297B793D21307D7D66756E6374696F6E205A692865297B72657475726E20652E786D6C2626226C6F77657243617365223D';
wwv_flow_imp.g_varchar2_table(1233) := '3D3D652E786D6C2E746167416C6961737D766172204A693D7B7873693A22687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D612D696E7374616E6365222C786D6C3A22687474703A2F2F7777772E77332E6F72672F584D4C2F';
wwv_flow_imp.g_varchar2_table(1234) := '313939382F6E616D657370616365227D2C51693D227873693A74797065223B66756E6374696F6E2065722865297B72657475726E20652E786D6C2626652E786D6C2E73657269616C697A657D66756E6374696F6E2074722865297B72657475726E206572';
wwv_flow_imp.g_varchar2_table(1235) := '2865293D3D3D51697D66756E6374696F6E206E7228652C74297B72657475726E205A692874293F652E7072656669782B223A222B28286E3D652E6C6F63616C4E616D65292E6368617241742830292E746F55707065724361736528292B6E2E736C696365';
wwv_flow_imp.g_varchar2_table(1236) := '283129293A652E6E616D653B766172206E7D66756E6374696F6E2069722865297B72657475726E206E6577204572726F722865297D66756E6374696F6E2072722865297B72657475726E20652E2464657363726970746F727D66756E6374696F6E206F72';
wwv_flow_imp.g_varchar2_table(1237) := '2865297B5328746869732C65292C746869732E656C656D656E7473427949643D7B7D2C746869732E7265666572656E6365733D5B5D2C746869732E7761726E696E67733D5B5D2C746869732E6164645265666572656E63653D66756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(1238) := '7B746869732E7265666572656E6365732E707573682865297D2C746869732E616464456C656D656E743D66756E6374696F6E2865297B6966282165297468726F772069722822657870656374656420656C656D656E7422293B76617220742C6E3D746869';
wwv_flow_imp.g_varchar2_table(1239) := '732E656C656D656E7473427949642C693D72722865292E696450726F70657274793B69662869262628743D652E67657428692E6E616D652929297B696628212F5E285B612D7A5D5B5C772D2E5D2A3A293F5B612D7A5F5D5B5C772D2E5D2A242F692E7465';
wwv_flow_imp.g_varchar2_table(1240) := '7374287429297468726F77206E6577204572726F722822696C6C6567616C204944203C222B742B223E22293B6966286E5B745D297468726F7720697228226475706C6963617465204944203C222B742B223E22293B6E5B745D3D657D7D2C746869732E61';
wwv_flow_imp.g_varchar2_table(1241) := '64645761726E696E673D66756E6374696F6E2865297B746869732E7761726E696E67732E707573682865297D7D66756E6374696F6E20617228297B7D66756E6374696F6E20737228297B7D66756E6374696F6E206C7228297B7D66756E6374696F6E2063';
wwv_flow_imp.g_varchar2_table(1242) := '7228652C74297B746869732E70726F70657274793D652C746869732E636F6E746578743D747D66756E6374696F6E20707228652C74297B746869732E656C656D656E743D742C746869732E70726F7065727479446573633D657D66756E6374696F6E2075';
wwv_flow_imp.g_varchar2_table(1243) := '7228297B7D66756E6374696F6E20687228652C742C6E297B746869732E6D6F64656C3D652C746869732E747970653D652E676574547970652874292C746869732E636F6E746578743D6E7D66756E6374696F6E20647228652C742C6E297B68722E63616C';
wwv_flow_imp.g_varchar2_table(1244) := '6C28746869732C652C742C6E297D66756E6374696F6E206D7228652C742C6E297B746869732E6D6F64656C3D652C746869732E636F6E746578743D6E7D66756E6374696F6E2066722865297B6520696E7374616E63656F66205469262628653D7B6D6F64';
wwv_flow_imp.g_varchar2_table(1245) := '656C3A657D292C5328746869732C7B6C61783A21317D2C65297D61722E70726F746F747970652E68616E646C65456E643D66756E6374696F6E28297B7D2C61722E70726F746F747970652E68616E646C65546578743D66756E6374696F6E28297B7D2C61';
wwv_flow_imp.g_varchar2_table(1246) := '722E70726F746F747970652E68616E646C654E6F64653D66756E6374696F6E28297B7D2C73722E70726F746F747970653D4F626A6563742E6372656174652861722E70726F746F74797065292C73722E70726F746F747970652E68616E646C654E6F6465';
wwv_flow_imp.g_varchar2_table(1247) := '3D66756E6374696F6E28297B72657475726E20746869737D2C6C722E70726F746F747970653D4F626A6563742E6372656174652861722E70726F746F74797065292C6C722E70726F746F747970652E68616E646C65546578743D66756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(1248) := '297B746869732E626F64793D28746869732E626F64797C7C2222292B657D2C63722E70726F746F747970653D4F626A6563742E637265617465286C722E70726F746F74797065292C63722E70726F746F747970652E68616E646C654E6F64653D66756E63';
wwv_flow_imp.g_varchar2_table(1249) := '74696F6E2865297B696628746869732E656C656D656E74297468726F7720697228226578706563746564206E6F20737562206E6F64657322293B72657475726E20746869732E656C656D656E743D746869732E6372656174655265666572656E63652865';
wwv_flow_imp.g_varchar2_table(1250) := '292C746869737D2C63722E70726F746F747970652E68616E646C65456E643D66756E6374696F6E28297B746869732E656C656D656E742E69643D746869732E626F64797D2C63722E70726F746F747970652E6372656174655265666572656E63653D6675';
wwv_flow_imp.g_varchar2_table(1251) := '6E6374696F6E2865297B72657475726E7B70726F70657274793A746869732E70726F70657274792E6E732E6E616D652C69643A22227D7D2C70722E70726F746F747970653D4F626A6563742E637265617465286C722E70726F746F74797065292C70722E';
wwv_flow_imp.g_varchar2_table(1252) := '70726F746F747970652E68616E646C65456E643D66756E6374696F6E28297B76617220653D746869732E626F64797C7C22222C743D746869732E656C656D656E742C6E3D746869732E70726F7065727479446573633B653D5369286E2E747970652C6529';
wwv_flow_imp.g_varchar2_table(1253) := '2C6E2E69734D616E793F742E676574286E2E6E616D65292E707573682865293A742E736574286E2E6E616D652C65297D2C75722E70726F746F747970653D4F626A6563742E637265617465286C722E70726F746F74797065292C75722E70726F746F7479';
wwv_flow_imp.g_varchar2_table(1254) := '70652E68616E646C654E6F64653D66756E6374696F6E2865297B76617220743D746869732C6E3D746869732E656C656D656E743B72657475726E206E3F743D746869732E68616E646C654368696C642865293A286E3D746869732E656C656D656E743D74';
wwv_flow_imp.g_varchar2_table(1255) := '6869732E637265617465456C656D656E742865292C746869732E636F6E746578742E616464456C656D656E74286E29292C747D2C68722E70726F746F747970653D4F626A6563742E6372656174652875722E70726F746F74797065292C68722E70726F74';
wwv_flow_imp.g_varchar2_table(1256) := '6F747970652E6164645265666572656E63653D66756E6374696F6E2865297B746869732E636F6E746578742E6164645265666572656E63652865297D2C68722E70726F746F747970652E68616E646C65546578743D66756E6374696F6E2865297B696628';
wwv_flow_imp.g_varchar2_table(1257) := '21727228746869732E656C656D656E74292E626F647950726F7065727479297468726F772069722822756E657870656374656420626F64792074657874203C222B652B223E22293B6C722E70726F746F747970652E68616E646C65546578742E63616C6C';
wwv_flow_imp.g_varchar2_table(1258) := '28746869732C65297D2C68722E70726F746F747970652E68616E646C65456E643D66756E6374696F6E28297B76617220653D746869732E626F64792C743D746869732E656C656D656E742C6E3D72722874292E626F647950726F70657274793B6E262676';
wwv_flow_imp.g_varchar2_table(1259) := '6F69642030213D3D65262628653D5369286E2E747970652C65292C742E736574286E2E6E616D652C6529297D2C68722E70726F746F747970652E637265617465456C656D656E743D66756E6374696F6E2865297B76617220742C6E3D652E617474726962';
wwv_flow_imp.g_varchar2_table(1260) := '757465732C693D746869732E747970652C723D72722869292C6F3D746869732E636F6E746578742C613D6E65772069287B7D292C733D746869732E6D6F64656C3B72657475726E2066286E2C2866756E6374696F6E28652C6E297B76617220693D722E70';
wwv_flow_imp.g_varchar2_table(1261) := '726F7065727469657342794E616D655B6E5D3B692626692E69735265666572656E63653F692E69734D616E793F6628652E73706C697428222022292C2866756E6374696F6E2865297B6F2E6164645265666572656E6365287B656C656D656E743A612C70';
wwv_flow_imp.g_varchar2_table(1262) := '726F70657274793A692E6E732E6E616D652C69643A657D297D29293A6F2E6164645265666572656E6365287B656C656D656E743A612C70726F70657274793A692E6E732E6E616D652C69643A657D293A28693F653D536928692E747970652C65293A2278';
wwv_flow_imp.g_varchar2_table(1263) := '6D6C6E7322213D3D6E262628743D6B69286E2C722E6E732E707265666978292C732E6765745061636B61676528742E7072656669782926266F2E6164645761726E696E67287B6D6573736167653A22756E6B6E6F776E20617474726962757465203C222B';
wwv_flow_imp.g_varchar2_table(1264) := '6E2B223E222C656C656D656E743A612C70726F70657274793A6E2C76616C75653A657D29292C612E736574286E2C6529297D29292C617D2C68722E70726F746F747970652E67657450726F7065727479466F724E6F64653D66756E6374696F6E2865297B';
wwv_flow_imp.g_varchar2_table(1265) := '76617220742C6E2C693D6B6928652E6E616D65292C723D746869732E747970652C6F3D746869732E6D6F64656C2C613D72722872292C733D692E6E616D652C6C3D612E70726F7065727469657342794E616D655B735D3B6966286C2626216C2E69734174';
wwv_flow_imp.g_varchar2_table(1266) := '74722972657475726E207472286C29262628743D652E617474726962757465735B51695D293F28743D66756E6374696F6E28652C74297B766172206E3D6B692865293B72657475726E2066756E6374696F6E28652C74297B766172206E3D652E6E616D65';
wwv_flow_imp.g_varchar2_table(1267) := '2C693D652E6C6F63616C4E616D652C723D742E786D6C2626742E786D6C2E747970655072656669783B72657475726E20722626303D3D3D692E696E6465784F662872293F652E7072656669782B223A222B692E736C69636528722E6C656E677468293A6E';
wwv_flow_imp.g_varchar2_table(1268) := '7D286E2C742E6765745061636B616765286E2E70726566697829297D28742C6F292C53287B7D2C6C2C7B656666656374697665547970653A7272286E3D6F2E67657454797065287429292E6E616D657D29293A6C3B76617220633D6F2E6765745061636B';
wwv_flow_imp.g_varchar2_table(1269) := '61676528692E707265666978293B69662863297B696628743D6E7228692C63292C6E3D6F2E676574547970652874292C6C3D6428612E70726F706572746965732C2866756E6374696F6E2865297B72657475726E21652E69735669727475616C26262165';
wwv_flow_imp.g_varchar2_table(1270) := '2E69735265666572656E6365262621652E697341747472696275746526266E2E6861735479706528652E74797065297D29292972657475726E2053287B7D2C6C2C7B656666656374697665547970653A7272286E292E6E616D657D297D656C7365206966';
wwv_flow_imp.g_varchar2_table(1271) := '286C3D6428612E70726F706572746965732C2866756E6374696F6E2865297B72657475726E21652E69735265666572656E6365262621652E6973417474726962757465262622456C656D656E74223D3D3D652E747970657D29292972657475726E206C3B';
wwv_flow_imp.g_varchar2_table(1272) := '7468726F772069722822756E7265636F676E697A656420656C656D656E74203C222B692E6E616D652B223E22297D2C68722E70726F746F747970652E746F537472696E673D66756E6374696F6E28297B72657475726E22456C656D656E74446573637269';
wwv_flow_imp.g_varchar2_table(1273) := '70746F725B222B727228746869732E74797065292E6E616D652B225D227D2C68722E70726F746F747970652E76616C756548616E646C65723D66756E6374696F6E28652C74297B72657475726E206E657720707228652C74297D2C68722E70726F746F74';
wwv_flow_imp.g_varchar2_table(1274) := '7970652E7265666572656E636548616E646C65723D66756E6374696F6E2865297B72657475726E206E657720637228652C746869732E636F6E74657874297D2C68722E70726F746F747970652E68616E646C65723D66756E6374696F6E2865297B726574';
wwv_flow_imp.g_varchar2_table(1275) := '75726E22456C656D656E74223D3D3D653F6E6577206D7228746869732E6D6F64656C2C652C746869732E636F6E74657874293A6E657720687228746869732E6D6F64656C2C652C746869732E636F6E74657874297D2C68722E70726F746F747970652E68';
wwv_flow_imp.g_varchar2_table(1276) := '616E646C654368696C643D66756E6374696F6E2865297B76617220742C6E2C692C723B696628743D746869732E67657450726F7065727479466F724E6F64652865292C693D746869732E656C656D656E742C4369286E3D742E6566666563746976655479';
wwv_flow_imp.g_varchar2_table(1277) := '70657C7C742E74797065292972657475726E20746869732E76616C756548616E646C657228742C69293B766172206F3D28723D742E69735265666572656E63653F746869732E7265666572656E636548616E646C65722874292E68616E646C654E6F6465';
wwv_flow_imp.g_varchar2_table(1278) := '2865293A746869732E68616E646C6572286E292E68616E646C654E6F6465286529292E656C656D656E743B72657475726E20766F69642030213D3D6F262628742E69734D616E793F692E67657428742E6E616D65292E70757368286F293A692E73657428';
wwv_flow_imp.g_varchar2_table(1279) := '742E6E616D652C6F292C742E69735265666572656E63653F2853286F2C7B656C656D656E743A697D292C746869732E636F6E746578742E6164645265666572656E6365286F29293A6F2E24706172656E743D69292C727D2C64722E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(1280) := '3D4F626A6563742E6372656174652868722E70726F746F74797065292C64722E70726F746F747970652E637265617465456C656D656E743D66756E6374696F6E2865297B76617220743D652E6E616D652C6E3D6B692874292C693D746869732E6D6F6465';
wwv_flow_imp.g_varchar2_table(1281) := '6C2C723D746869732E747970652C6F3D692E6765745061636B616765286E2E707265666978292C613D6F26266E72286E2C6F297C7C743B69662821722E68617354797065286129297468726F772069722822756E657870656374656420656C656D656E74';
wwv_flow_imp.g_varchar2_table(1282) := '203C222B652E6F726967696E616C4E616D652B223E22293B72657475726E2068722E70726F746F747970652E637265617465456C656D656E742E63616C6C28746869732C65297D2C6D722E70726F746F747970653D4F626A6563742E6372656174652875';
wwv_flow_imp.g_varchar2_table(1283) := '722E70726F746F74797065292C6D722E70726F746F747970652E637265617465456C656D656E743D66756E6374696F6E2865297B76617220743D652E6E616D652C6E3D6B692874292E7072656669782C693D652E6E735B6E2B2224757269225D2C723D65';
wwv_flow_imp.g_varchar2_table(1284) := '2E617474726962757465733B72657475726E20746869732E6D6F64656C2E637265617465416E7928742C692C72297D2C6D722E70726F746F747970652E68616E646C654368696C643D66756E6374696F6E2865297B76617220743D6E6577206D72287468';
wwv_flow_imp.g_varchar2_table(1285) := '69732E6D6F64656C2C22456C656D656E74222C746869732E636F6E74657874292E68616E646C654E6F64652865292C6E3D746869732E656C656D656E742C693D742E656C656D656E743B72657475726E20766F69642030213D3D69262628286E2E246368';
wwv_flow_imp.g_varchar2_table(1286) := '696C6472656E3D6E2E246368696C6472656E7C7C5B5D292E707573682869292C692E24706172656E743D6E292C747D2C6D722E70726F746F747970652E68616E646C65456E643D66756E6374696F6E28297B746869732E626F6479262628746869732E65';
wwv_flow_imp.g_varchar2_table(1287) := '6C656D656E742E24626F64793D746869732E626F6479297D2C66722E70726F746F747970652E66726F6D584D4C3D66756E6374696F6E28652C742C6E297B76617220693D742E726F6F7448616E646C65723B7420696E7374616E63656F662068723F2869';
wwv_flow_imp.g_varchar2_table(1288) := '3D742C743D7B7D293A22737472696E67223D3D747970656F6620743F28693D746869732E68616E646C65722874292C743D7B7D293A22737472696E67223D3D747970656F662069262628693D746869732E68616E646C6572286929293B76617220723D74';
wwv_flow_imp.g_varchar2_table(1289) := '6869732E6D6F64656C2C6F3D746869732E6C61782C613D6E6577206F722853287B7D2C742C7B726F6F7448616E646C65723A697D29292C733D6E6577205869287B70726F78793A21307D292C6C3D66756E6374696F6E28297B76617220653D5B5D3B7265';
wwv_flow_imp.g_varchar2_table(1290) := '7475726E204F626A6563742E646566696E6550726F706572747928652C227065656B222C7B76616C75653A66756E6374696F6E28297B72657475726E20746869735B746869732E6C656E6774682D315D7D7D292C657D28293B66756E6374696F6E206328';
wwv_flow_imp.g_varchar2_table(1291) := '652C742C6E297B76617220693D7428292C723D692E6C696E652C6F3D692E636F6C756D6E2C733D692E646174613B223C223D3D3D732E63686172417428302926262D31213D3D732E696E6465784F662822202229262628733D732E736C69636528302C73';
wwv_flow_imp.g_varchar2_table(1292) := '2E696E6465784F662822202229292B223E22293B766172206C3D22756E7061727361626C6520636F6E74656E7420222B28733F732B2220223A2222292B2264657465637465645C6E5C746C696E653A20222B722B225C6E5C74636F6C756D6E3A20222B6F';
wwv_flow_imp.g_varchar2_table(1293) := '2B225C6E5C746E6573746564206572726F723A20222B652E6D6573736167653B6966286E2972657475726E20612E6164645761726E696E67287B6D6573736167653A6C2C6572726F723A657D292C21303B7468726F77206972286C297D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1294) := '6E207028652C74297B72657475726E206328652C742C2130297D692E636F6E746578743D612C6C2E707573682869293B76617220753D2F5E3C5C3F786D6C202F692C683D2F20656E636F64696E673D22285B5E225D2B29222F692C643D2F5E7574662D38';
wwv_flow_imp.g_varchar2_table(1295) := '242F693B66756E6374696F6E206D28652C74297B7472797B6C2E7065656B28292E68616E646C65546578742865297D63617463682865297B7028652C74297D7D76617220663D722E6765745061636B6167657328292E726564756365282866756E637469';
wwv_flow_imp.g_varchar2_table(1296) := '6F6E28652C74297B72657475726E20655B742E7572695D3D742E7072656669782C657D292C7B22687474703A2F2F7777772E77332E6F72672F584D4C2F313939382F6E616D657370616365223A22786D6C227D293B72657475726E20732E6E732866292E';
wwv_flow_imp.g_varchar2_table(1297) := '6F6E28226F70656E546167222C2866756E6374696F6E28652C742C6E2C69297B76617220723D652E61747472737C7C7B7D2C613D4F626A6563742E6B6579732872292E726564756365282866756E6374696F6E28652C6E297B76617220693D7428725B6E';
wwv_flow_imp.g_varchar2_table(1298) := '5D293B72657475726E20655B6E5D3D692C657D292C7B7D293B2166756E6374696F6E28652C74297B766172206E3D6C2E7065656B28293B7472797B6C2E70757368286E2E68616E646C654E6F6465286529297D63617463682865297B6328652C742C6F29';
wwv_flow_imp.g_varchar2_table(1299) := '26266C2E70757368286E6577207372297D7D287B6E616D653A652E6E616D652C6F726967696E616C4E616D653A652E6F726967696E616C4E616D652C617474726962757465733A612C6E733A652E6E737D2C69297D29292E6F6E28227175657374696F6E';
wwv_flow_imp.g_varchar2_table(1300) := '222C2866756E6374696F6E2865297B696628752E74657374286529297B76617220743D682E657865632865292C6E3D742626745B315D3B6E262621642E74657374286E292626612E6164645761726E696E67287B6D6573736167653A22756E737570706F';
wwv_flow_imp.g_varchar2_table(1301) := '7274656420646F63756D656E7420656E636F64696E67203C222B6E2B223E2C2066616C6C696E67206261636B20746F205554462D38227D297D7D29292E6F6E2822636C6F7365546167222C2866756E6374696F6E28297B6C2E706F7028292E68616E646C';
wwv_flow_imp.g_varchar2_table(1302) := '65456E6428297D29292E6F6E28226364617461222C6D292E6F6E282274657874222C2866756E6374696F6E28652C742C6E297B2166756E6374696F6E28652C74297B652E7472696D282926266D28652C74297D28742865292C6E297D29292E6F6E282265';
wwv_flow_imp.g_varchar2_table(1303) := '72726F72222C63292E6F6E28227761726E222C70292C6E65772050726F6D697365282866756E6374696F6E28742C6E297B76617220723B7472797B732E70617273652865292C66756E6374696F6E28297B76617220652C742C6E3D612E656C656D656E74';
wwv_flow_imp.g_varchar2_table(1304) := '73427949642C693D612E7265666572656E6365733B666F7228653D303B743D695B655D3B652B2B297B76617220723D742E656C656D656E742C6F3D6E5B742E69645D2C733D72722872292E70726F7065727469657342794E616D655B742E70726F706572';
wwv_flow_imp.g_varchar2_table(1305) := '74795D3B6966286F7C7C612E6164645761726E696E67287B6D6573736167653A22756E7265736F6C766564207265666572656E6365203C222B742E69642B223E222C656C656D656E743A742E656C656D656E742C70726F70657274793A742E70726F7065';
wwv_flow_imp.g_varchar2_table(1306) := '7274792C76616C75653A742E69647D292C732E69734D616E79297B766172206C3D722E67657428732E6E616D65292C633D6C2E696E6465784F662874293B2D313D3D3D63262628633D6C2E6C656E677468292C6F3F6C5B635D3D6F3A6C2E73706C696365';
wwv_flow_imp.g_varchar2_table(1307) := '28632C31297D656C736520722E73657428732E6E616D652C6F297D7D28297D63617463682865297B723D657D766172206F3D692E656C656D656E743B727C7C6F7C7C28723D697228226661696C656420746F20706172736520646F63756D656E74206173';
wwv_flow_imp.g_varchar2_table(1308) := '203C222B692E747970652E2464657363726970746F722E6E616D652B223E2229293B766172206C3D612E7761726E696E67732C633D612E7265666572656E6365732C703D612E656C656D656E7473427949643B72657475726E20723F28722E7761726E69';
wwv_flow_imp.g_varchar2_table(1309) := '6E67733D6C2C6E287229293A74287B726F6F74456C656D656E743A6F2C656C656D656E7473427949643A702C7265666572656E6365733A632C7761726E696E67733A6C7D297D29297D2C66722E70726F746F747970652E68616E646C65723D66756E6374';
wwv_flow_imp.g_varchar2_table(1310) := '696F6E2865297B72657475726E206E657720647228746869732E6D6F64656C2C65297D3B7661722079723D2F3C7C3E7C277C227C267C5C6E5C727C5C6E2F672C67723D2F3C7C3E7C262F673B66756E6374696F6E2076722865297B76617220743D7B7D2C';
wwv_flow_imp.g_varchar2_table(1311) := '6E3D7B7D2C693D7B7D2C723D5B5D2C6F3D5B5D3B746869732E62795572693D66756E6374696F6E2874297B72657475726E206E5B745D7C7C652626652E62795572692874297D2C746869732E6164643D66756E6374696F6E28652C74297B6E5B652E7572';
wwv_flow_imp.g_varchar2_table(1312) := '695D3D652C743F722E707573682865293A6F2E707573682865292C746869732E6D617050726566697828652E7072656669782C652E757269297D2C746869732E75726942795072656669783D66756E6374696F6E2865297B72657475726E20745B657C7C';
wwv_flow_imp.g_varchar2_table(1313) := '22786D6C6E73225D7D2C746869732E6D61705072656669783D66756E6374696F6E28652C6E297B745B657C7C22786D6C6E73225D3D6E7D2C746869732E6765744E534B65793D66756E6374696F6E2865297B72657475726E20766F69642030213D3D652E';
wwv_flow_imp.g_varchar2_table(1314) := '7072656669783F652E7572692B227C222B652E7072656669783A652E7572697D2C746869732E6C6F67557365643D66756E6374696F6E2874297B766172206E3D742E7572692C723D746869732E6765744E534B65792874293B695B725D3D746869732E62';
wwv_flow_imp.g_varchar2_table(1315) := '79557269286E292C652626652E6C6F67557365642874297D2C746869732E676574557365643D66756E6374696F6E2865297B76617220743D746869733B72657475726E5B5D2E636F6E63617428722C6F292E66696C746572282866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(1316) := '297B766172206E3D742E6765744E534B65792865293B72657475726E20695B6E5D7D29297D7D66756E6374696F6E20627228652C74297B652E73757065725F3D742C652E70726F746F747970653D4F626A6563742E63726561746528742E70726F746F74';
wwv_flow_imp.g_varchar2_table(1317) := '7970652C7B636F6E7374727563746F723A7B76616C75653A652C656E756D657261626C653A21312C7772697461626C653A21302C636F6E666967757261626C653A21307D7D297D66756E6374696F6E2078722865297B72657475726E20752865293F653A';
wwv_flow_imp.g_varchar2_table(1318) := '28652E7072656669783F652E7072656669782B223A223A2222292B652E6C6F63616C4E616D657D7661722077723D7B225C6E223A22233130222C225C6E5C72223A22233130222C2722273A22233334222C2227223A22233339222C223C223A2223363022';
wwv_flow_imp.g_varchar2_table(1319) := '2C223E223A22233632222C2226223A22233338227D2C5F723D7B223C223A226C74222C223E223A226774222C2226223A22616D70227D3B66756E6374696F6E20457228652C742C6E297B72657475726E28653D752865293F653A22222B65292E7265706C';
wwv_flow_imp.g_varchar2_table(1320) := '61636528742C2866756E6374696F6E2865297B72657475726E2226222B6E5B655D2B223B227D29297D66756E6374696F6E2053722865297B746869732E7461674E616D653D657D66756E6374696F6E20417228297B7D66756E6374696F6E204372286529';
wwv_flow_imp.g_varchar2_table(1321) := '7B746869732E7461674E616D653D657D66756E6374696F6E206B7228652C74297B746869732E626F64793D5B5D2C746869732E61747472733D5B5D2C746869732E706172656E743D652C746869732E70726F706572747944657363726970746F723D747D';
wwv_flow_imp.g_varchar2_table(1322) := '66756E6374696F6E20527228652C74297B6B722E63616C6C28746869732C652C74297D66756E6374696F6E204D7228297B746869732E76616C75653D22222C746869732E77726974653D66756E6374696F6E2865297B746869732E76616C75652B3D657D';
wwv_flow_imp.g_varchar2_table(1323) := '7D66756E6374696F6E20507228652C74297B766172206E3D5B22225D3B746869732E617070656E643D66756E6374696F6E2874297B72657475726E20652E77726974652874292C746869737D2C746869732E617070656E644E65774C696E653D66756E63';
wwv_flow_imp.g_varchar2_table(1324) := '74696F6E28297B72657475726E20742626652E777269746528225C6E22292C746869737D2C746869732E617070656E64496E64656E743D66756E6374696F6E28297B72657475726E20742626652E7772697465286E2E6A6F696E282220202229292C7468';
wwv_flow_imp.g_varchar2_table(1325) := '69737D2C746869732E696E64656E743D66756E6374696F6E28297B72657475726E206E2E70757368282222292C746869737D2C746869732E756E696E64656E743D66756E6374696F6E28297B72657475726E206E2E706F7028292C746869737D7D66756E';
wwv_flow_imp.g_varchar2_table(1326) := '6374696F6E2044722865297B72657475726E20653D53287B666F726D61743A21312C707265616D626C653A21307D2C657C7C7B7D292C7B746F584D4C3A66756E6374696F6E28742C6E297B76617220693D6E7C7C6E6577204D722C723D6E657720507228';
wwv_flow_imp.g_varchar2_table(1327) := '692C652E666F726D6174293B696628652E707265616D626C652626722E617070656E6428273C3F786D6C2076657273696F6E3D22312E302220656E636F64696E673D225554462D38223F3E5C6E27292C286E6577206B72292E6275696C642874292E7365';
wwv_flow_imp.g_varchar2_table(1328) := '7269616C697A65546F2872292C216E2972657475726E20692E76616C75657D7D7D66756E6374696F6E20427228652C74297B54692E63616C6C28746869732C652C74297D53722E70726F746F747970652E6275696C643D66756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(1329) := '657475726E20746869732E656C656D656E743D652C746869737D2C53722E70726F746F747970652E73657269616C697A65546F3D66756E6374696F6E2865297B652E617070656E64496E64656E7428292E617070656E6428223C222B746869732E746167';
wwv_flow_imp.g_varchar2_table(1330) := '4E616D652B223E222B746869732E656C656D656E742E69642B223C2F222B746869732E7461674E616D652B223E22292E617070656E644E65774C696E6528297D2C41722E70726F746F747970652E73657269616C697A6556616C75653D41722E70726F74';
wwv_flow_imp.g_varchar2_table(1331) := '6F747970652E73657269616C697A65546F3D66756E6374696F6E2865297B652E617070656E6428746869732E6573636170653F457228746869732E76616C75652C67722C5F72293A746869732E76616C7565297D2C41722E70726F746F747970652E6275';
wwv_flow_imp.g_varchar2_table(1332) := '696C643D66756E6374696F6E28652C74297B72657475726E20746869732E76616C75653D742C22537472696E67223D3D3D652E7479706526262D31213D3D742E73656172636828677229262628746869732E6573636170653D2130292C746869737D2C62';
wwv_flow_imp.g_varchar2_table(1333) := '722843722C4172292C43722E70726F746F747970652E73657269616C697A65546F3D66756E6374696F6E2865297B652E617070656E64496E64656E7428292E617070656E6428223C222B746869732E7461674E616D652B223E22292C746869732E736572';
wwv_flow_imp.g_varchar2_table(1334) := '69616C697A6556616C75652865292C652E617070656E6428223C2F222B746869732E7461674E616D652B223E22292E617070656E644E65774C696E6528297D2C6B722E70726F746F747970652E6275696C643D66756E6374696F6E2865297B746869732E';
wwv_flow_imp.g_varchar2_table(1335) := '656C656D656E743D653B76617220742C6E2C693D652E2464657363726970746F722C723D746869732E70726F706572747944657363726970746F722C6F3D692E697347656E657269633B72657475726E20743D6F3F746869732E706172736547656E6572';
wwv_flow_imp.g_varchar2_table(1336) := '69632865293A746869732E70617273654E73417474726962757465732865292C746869732E6E733D723F746869732E6E7350726F70657274795461674E616D652872293A746869732E6E735461674E616D652869292C746869732E7461674E616D653D74';
wwv_flow_imp.g_varchar2_table(1337) := '6869732E6164645461674E616D6528746869732E6E73292C6F7C7C286E3D66756E6374696F6E2865297B72657475726E206D28652E2464657363726970746F722E70726F706572746965732C2866756E6374696F6E2874297B766172206E3D742E6E616D';
wwv_flow_imp.g_varchar2_table(1338) := '653B696628742E69735669727475616C2972657475726E21313B696628216828652C6E292972657475726E21313B76617220693D655B6E5D3B72657475726E2069213D3D742E64656661756C7426266E756C6C213D3D6926262821742E69734D616E797C';
wwv_flow_imp.g_varchar2_table(1339) := '7C692E6C656E677468297D29297D2865292C746869732E706172736541747472696275746573286D286E2C2866756E6374696F6E2865297B72657475726E20652E6973417474727D2929292C746869732E7061727365436F6E7461696E6D656E7473286D';
wwv_flow_imp.g_varchar2_table(1340) := '286E2C2866756E6374696F6E2865297B72657475726E21652E6973417474727D292929292C746869732E706172736547656E657269634174747269627574657328652C74292C746869737D2C6B722E70726F746F747970652E6E735461674E616D653D66';
wwv_flow_imp.g_varchar2_table(1341) := '756E6374696F6E2865297B72657475726E2066756E6374696F6E28652C74297B72657475726E20742E697347656E657269633F53287B6C6F63616C4E616D653A742E6E732E6C6F63616C4E616D657D2C65293A53287B6C6F63616C4E616D653A286E3D74';
wwv_flow_imp.g_varchar2_table(1342) := '2E6E732E6C6F63616C4E616D652C693D742E24706B672C5A692869293F28723D6E292E6368617241742830292E746F4C6F7765724361736528292B722E736C6963652831293A6E297D2C65293B766172206E2C692C727D28746869732E6C6F674E616D65';
wwv_flow_imp.g_varchar2_table(1343) := '73706163655573656428652E6E73292C65297D2C6B722E70726F746F747970652E6E7350726F70657274795461674E616D653D66756E6374696F6E2865297B72657475726E2066756E6374696F6E28652C74297B72657475726E2053287B6C6F63616C4E';
wwv_flow_imp.g_varchar2_table(1344) := '616D653A742E6E732E6C6F63616C4E616D657D2C65297D28746869732E6C6F674E616D6573706163655573656428652E6E73292C65297D2C6B722E70726F746F747970652E69734C6F63616C4E733D66756E6374696F6E2865297B72657475726E20652E';
wwv_flow_imp.g_varchar2_table(1345) := '7572693D3D3D746869732E6E732E7572697D2C6B722E70726F746F747970652E6E734174747269627574654E616D653D66756E6374696F6E2865297B76617220743B696628743D752865293F6B692865293A652E6E732C652E696E686572697465642972';
wwv_flow_imp.g_varchar2_table(1346) := '657475726E7B6C6F63616C4E616D653A742E6C6F63616C4E616D657D3B766172206E3D746869732E6C6F674E616D657370616365557365642874293B72657475726E20746869732E6765744E616D6573706163657328292E6C6F6755736564286E292C74';
wwv_flow_imp.g_varchar2_table(1347) := '6869732E69734C6F63616C4E73286E293F7B6C6F63616C4E616D653A742E6C6F63616C4E616D657D3A53287B6C6F63616C4E616D653A742E6C6F63616C4E616D657D2C6E297D2C6B722E70726F746F747970652E706172736547656E657269633D66756E';
wwv_flow_imp.g_varchar2_table(1348) := '6374696F6E2865297B76617220743D746869732C6E3D746869732E626F64792C693D5B5D3B72657475726E206628652C2866756E6374696F6E28722C6F297B2224626F6479223D3D3D6F3F6E2E7075736828286E6577204172292E6275696C64287B7479';
wwv_flow_imp.g_varchar2_table(1349) := '70653A22537472696E67227D2C7229293A22246368696C6472656E223D3D3D6F3F6628722C2866756E6374696F6E2865297B6E2E70757368286E6577206B722874292E6275696C64286529297D29293A30213D3D6F2E696E6465784F6628222422292626';
wwv_flow_imp.g_varchar2_table(1350) := '742E70617273654E7341747472696275746528652C6F2C72292626692E70757368287B6E616D653A6F2C76616C75653A727D297D29292C697D2C6B722E70726F746F747970652E70617273654E734174747269627574653D66756E6374696F6E28652C74';
wwv_flow_imp.g_varchar2_table(1351) := '2C6E297B76617220692C723D652E246D6F64656C2C6F3D6B692874293B69662822786D6C6E73223D3D3D6F2E707265666978262628693D7B7072656669783A6F2E6C6F63616C4E616D652C7572693A6E7D292C6F2E7072656669787C7C22786D6C6E7322';
wwv_flow_imp.g_varchar2_table(1352) := '213D3D6F2E6C6F63616C4E616D657C7C28693D7B7572693A6E7D292C21692972657475726E7B6E616D653A742C76616C75653A6E7D3B696628722626722E6765745061636B616765286E2929746869732E6C6F674E616D65737061636528692C21302C21';
wwv_flow_imp.g_varchar2_table(1353) := '30293B656C73657B76617220613D746869732E6C6F674E616D6573706163655573656428692C2130293B746869732E6765744E616D6573706163657328292E6C6F67557365642861297D7D2C6B722E70726F746F747970652E70617273654E7341747472';
wwv_flow_imp.g_varchar2_table(1354) := '6962757465733D66756E6374696F6E28652C74297B766172206E3D746869732C693D652E2461747472732C723D5B5D3B72657475726E206628692C2866756E6374696F6E28742C69297B766172206F3D6E2E70617273654E734174747269627574652865';
wwv_flow_imp.g_varchar2_table(1355) := '2C692C74293B6F2626722E70757368286F297D29292C727D2C6B722E70726F746F747970652E706172736547656E65726963417474726962757465733D66756E6374696F6E28652C74297B766172206E3D746869733B6628742C2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1356) := '74297B696628742E6E616D65213D3D5169297472797B6E2E616464417474726962757465286E2E6E734174747269627574654E616D6528742E6E616D65292C742E76616C7565297D6361746368286E297B636F6E736F6C652E7761726E28226D69737369';
wwv_flow_imp.g_varchar2_table(1357) := '6E67206E616D65737061636520696E666F726D6174696F6E20666F7220222C742E6E616D652C223D222C742E76616C75652C226F6E222C652C6E297D7D29297D2C6B722E70726F746F747970652E7061727365436F6E7461696E6D656E74733D66756E63';
wwv_flow_imp.g_varchar2_table(1358) := '74696F6E2865297B76617220743D746869732C6E3D746869732E626F64792C693D746869732E656C656D656E743B6628652C2866756E6374696F6E2865297B76617220723D692E67657428652E6E616D65292C6F3D652E69735265666572656E63653B69';
wwv_flow_imp.g_varchar2_table(1359) := '6628652E69734D616E797C7C28723D5B725D292C652E6973426F6479296E2E7075736828286E6577204172292E6275696C6428652C725B305D29293B656C736520696628436928652E7479706529296628722C2866756E6374696F6E2869297B6E2E7075';
wwv_flow_imp.g_varchar2_table(1360) := '7368286E657720437228742E6164645461674E616D6528742E6E7350726F70657274795461674E616D6528652929292E6275696C6428652C6929297D29293B656C7365206966286F296628722C2866756E6374696F6E2869297B6E2E70757368286E6577';
wwv_flow_imp.g_varchar2_table(1361) := '20537228742E6164645461674E616D6528742E6E7350726F70657274795461674E616D6528652929292E6275696C64286929297D29293B656C73657B76617220613D74722865292C733D66756E6374696F6E2865297B72657475726E2270726F70657274';
wwv_flow_imp.g_varchar2_table(1362) := '79223D3D3D65722865297D2865293B6628722C2866756E6374696F6E2869297B76617220723B723D613F6E657720527228742C65293A733F6E6577206B7228742C65293A6E6577206B722874292C6E2E7075736828722E6275696C64286929297D29297D';
wwv_flow_imp.g_varchar2_table(1363) := '7D29297D2C6B722E70726F746F747970652E6765744E616D657370616365733D66756E6374696F6E2865297B76617220742C6E3D746869732E6E616D657370616365732C693D746869732E706172656E743B72657475726E206E7C7C28743D692626692E';
wwv_flow_imp.g_varchar2_table(1364) := '6765744E616D6573706163657328292C657C7C21743F746869732E6E616D657370616365733D6E3D6E65772076722874293A6E3D74292C6E7D2C6B722E70726F746F747970652E6C6F674E616D6573706163653D66756E6374696F6E28652C742C6E297B';
wwv_flow_imp.g_varchar2_table(1365) := '76617220693D746869732E6765744E616D65737061636573286E292C723D652E7572692C6F3D652E7072656669783B72657475726E20692E62795572692872292626216E7C7C692E61646428652C74292C692E6D6170507265666978286F2C72292C657D';
wwv_flow_imp.g_varchar2_table(1366) := '2C6B722E70726F746F747970652E6C6F674E616D657370616365557365643D66756E6374696F6E28652C74297B766172206E2C692C722C6F3D746869732E656C656D656E742E246D6F64656C2C613D746869732E6765744E616D65737061636573287429';
wwv_flow_imp.g_varchar2_table(1367) := '2C733D652E7072656669782C6C3D652E7572693B69662821732626216C2972657475726E7B6C6F63616C4E616D653A652E6C6F63616C4E616D657D3B696628723D4A695B735D7C7C6F2626286F2E6765745061636B6167652873297C7C7B7D292E757269';
wwv_flow_imp.g_varchar2_table(1368) := '2C21286C3D6C7C7C727C7C612E757269427950726566697828732929297468726F77206E6577204572726F7228226E6F206E616D6573706163652075726920676976656E20666F7220707265666978203C222B732B223E22293B6966282128653D612E62';
wwv_flow_imp.g_varchar2_table(1369) := '79557269286C2929297B666F72286E3D732C693D313B612E7572694279507265666978286E293B296E3D732B225F222B692B2B3B653D746869732E6C6F674E616D657370616365287B7072656669783A6E2C7572693A6C7D2C723D3D3D6C297D72657475';
wwv_flow_imp.g_varchar2_table(1370) := '726E20732626612E6D617050726566697828732C6C292C657D2C6B722E70726F746F747970652E7061727365417474726962757465733D66756E6374696F6E2865297B76617220743D746869732C6E3D746869732E656C656D656E743B6628652C286675';
wwv_flow_imp.g_varchar2_table(1371) := '6E6374696F6E2865297B76617220693D6E2E67657428652E6E616D65293B696628652E69735265666572656E636529696628652E69734D616E79297B76617220723D5B5D3B6628692C2866756E6374696F6E2865297B722E7075736828652E6964297D29';
wwv_flow_imp.g_varchar2_table(1372) := '292C693D722E6A6F696E28222022297D656C736520693D692E69643B742E61646441747472696275746528742E6E734174747269627574654E616D652865292C69297D29297D2C6B722E70726F746F747970652E6164645461674E616D653D66756E6374';
wwv_flow_imp.g_varchar2_table(1373) := '696F6E2865297B76617220743D746869732E6C6F674E616D657370616365557365642865293B72657475726E20746869732E6765744E616D6573706163657328292E6C6F67557365642874292C78722865297D2C6B722E70726F746F747970652E616464';
wwv_flow_imp.g_varchar2_table(1374) := '4174747269627574653D66756E6374696F6E28652C74297B766172206E3D746869732E61747472733B75287429262628743D457228742C79722C777229293B76617220693D66756E6374696F6E2874297B636F6E7374206E3D78282866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1375) := '2874297B72657475726E20742E6E616D652E6C6F63616C4E616D653D3D3D652E6C6F63616C4E616D652626742E6E616D652E7572693D3D3D652E7572692626742E6E616D652E7072656669783D3D3D652E7072656669787D29293B6C657420693D732874';
wwv_flow_imp.g_varchar2_table(1376) := '293F2D313A766F696420303B72657475726E206628742C2866756E6374696F6E28652C74297B6966286E28652C74292972657475726E20693D742C21317D29292C697D286E292C723D7B6E616D653A652C76616C75653A747D3B2D31213D3D693F6E2E73';
wwv_flow_imp.g_varchar2_table(1377) := '706C69636528692C312C72293A6E2E707573682872297D2C6B722E70726F746F747970652E73657269616C697A65417474726962757465733D66756E6374696F6E2865297B76617220743D746869732E61747472732C6E3D746869732E6E616D65737061';
wwv_flow_imp.g_varchar2_table(1378) := '6365733B6E262628743D66756E6374696F6E2865297B72657475726E20652E6765745573656428292E66696C746572282866756E6374696F6E2865297B72657475726E22786D6C22213D3D652E7072656669787D29292E6D6170282866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1379) := '2865297B72657475726E7B6E616D653A22786D6C6E73222B28652E7072656669783F223A222B652E7072656669783A2222292C76616C75653A652E7572697D7D29297D286E292E636F6E636174287429292C6628742C2866756E6374696F6E2874297B65';
wwv_flow_imp.g_varchar2_table(1380) := '2E617070656E6428222022292E617070656E6428787228742E6E616D6529292E617070656E6428273D2227292E617070656E6428742E76616C7565292E617070656E6428272227297D29297D2C6B722E70726F746F747970652E73657269616C697A6554';
wwv_flow_imp.g_varchar2_table(1381) := '6F3D66756E6374696F6E2865297B76617220743D746869732E626F64795B305D2C6E3D742626742E636F6E7374727563746F72213D3D41723B652E617070656E64496E64656E7428292E617070656E6428223C222B746869732E7461674E616D65292C74';
wwv_flow_imp.g_varchar2_table(1382) := '6869732E73657269616C697A65417474726962757465732865292C652E617070656E6428743F223E223A22202F3E22292C742626286E2626652E617070656E644E65774C696E6528292E696E64656E7428292C6628746869732E626F64792C2866756E63';
wwv_flow_imp.g_varchar2_table(1383) := '74696F6E2874297B742E73657269616C697A65546F2865297D29292C6E2626652E756E696E64656E7428292E617070656E64496E64656E7428292C652E617070656E6428223C2F222B746869732E7461674E616D652B223E2229292C652E617070656E64';
wwv_flow_imp.g_varchar2_table(1384) := '4E65774C696E6528297D2C62722852722C6B72292C52722E70726F746F747970652E70617273654E73417474726962757465733D66756E6374696F6E2865297B76617220743D6B722E70726F746F747970652E70617273654E7341747472696275746573';
wwv_flow_imp.g_varchar2_table(1385) := '2E63616C6C28746869732C65292C6E3D652E2464657363726970746F723B6966286E2E6E616D653D3D3D746869732E70726F706572747944657363726970746F722E747970652972657475726E20743B76617220693D746869732E747970654E733D7468';
wwv_flow_imp.g_varchar2_table(1386) := '69732E6E735461674E616D65286E293B746869732E6765744E616D6573706163657328292E6C6F675573656428746869732E747970654E73293B76617220723D652E246D6F64656C2E6765745061636B61676528692E757269292C6F3D722E786D6C2626';
wwv_flow_imp.g_varchar2_table(1387) := '722E786D6C2E747970655072656669787C7C22223B72657475726E20746869732E61646441747472696275746528746869732E6E734174747269627574654E616D65285169292C28692E7072656669783F692E7072656669782B223A223A2222292B6F2B';
wwv_flow_imp.g_varchar2_table(1388) := '6E2E6E732E6C6F63616C4E616D65292C747D2C52722E70726F746F747970652E69734C6F63616C4E733D66756E6374696F6E2865297B72657475726E20652E7572693D3D3D28746869732E747970654E737C7C746869732E6E73292E7572697D2C42722E';
wwv_flow_imp.g_varchar2_table(1389) := '70726F746F747970653D4F626A6563742E6372656174652854692E70726F746F74797065292C42722E70726F746F747970652E66726F6D584D4C3D66756E6374696F6E28652C742C6E297B752874297C7C286E3D742C743D2262706D6E3A446566696E69';
wwv_flow_imp.g_varchar2_table(1390) := '74696F6E7322293B76617220693D6E65772066722853287B6D6F64656C3A746869732C6C61783A21307D2C6E29292C723D692E68616E646C65722874293B72657475726E20692E66726F6D584D4C28652C72297D2C42722E70726F746F747970652E746F';
wwv_flow_imp.g_varchar2_table(1391) := '584D4C3D66756E6374696F6E28652C74297B766172206E3D6E65772044722874293B72657475726E206E65772050726F6D697365282866756E6374696F6E28742C69297B7472797B72657475726E2074287B786D6C3A6E2E746F584D4C2865297D297D63';
wwv_flow_imp.g_varchar2_table(1392) := '617463682865297B72657475726E20692865297D7D29297D3B766172204F723D7B62706D6E3A7B6E616D653A2242504D4E3230222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F4D4F4445';
wwv_flow_imp.g_varchar2_table(1393) := '4C222C7072656669783A2262706D6E222C6173736F63696174696F6E733A5B5D2C74797065733A5B7B6E616D653A22496E74657266616365222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(1394) := '6D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226F7065726174696F6E73222C747970653A224F7065726174696F6E222C69734D616E793A21307D2C7B6E616D653A22696D706C656D656E746174';
wwv_flow_imp.g_varchar2_table(1395) := '696F6E526566222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224F7065726174696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E';
wwv_flow_imp.g_varchar2_table(1396) := '616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696E4D657373616765526566222C747970653A224D657373616765222C69735265666572656E63653A21307D2C7B6E616D653A226F75744D65737361676552';
wwv_flow_imp.g_varchar2_table(1397) := '6566222C747970653A224D657373616765222C69735265666572656E63653A21307D2C7B6E616D653A226572726F72526566222C747970653A224572726F72222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22696D';
wwv_flow_imp.g_varchar2_table(1398) := '706C656D656E746174696F6E526566222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22456E64506F696E74222C7375706572436C6173733A5B22526F6F74456C656D656E74225D7D2C7B6E616D653A2241756469';
wwv_flow_imp.g_varchar2_table(1399) := '74696E67222C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A22476C6F62616C5461736B222C7375706572436C6173733A5B2243616C6C61626C65456C656D656E74225D2C70726F706572746965733A5B7B6E616D';
wwv_flow_imp.g_varchar2_table(1400) := '653A227265736F7572636573222C747970653A225265736F75726365526F6C65222C69734D616E793A21307D5D7D2C7B6E616D653A224D6F6E69746F72696E67222C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1401) := '22506572666F726D6572222C7375706572436C6173733A5B225265736F75726365526F6C65225D7D2C7B6E616D653A2250726F63657373222C7375706572436C6173733A5B22466C6F77456C656D656E7473436F6E7461696E6572222C2243616C6C6162';
wwv_flow_imp.g_varchar2_table(1402) := '6C65456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2270726F6365737354797065222C747970653A2250726F6365737354797065222C6973417474723A21307D2C7B6E616D653A226973436C6F736564222C6973417474723A2130';
wwv_flow_imp.g_varchar2_table(1403) := '2C747970653A22426F6F6C65616E227D2C7B6E616D653A226175646974696E67222C747970653A224175646974696E67227D2C7B6E616D653A226D6F6E69746F72696E67222C747970653A224D6F6E69746F72696E67227D2C7B6E616D653A2270726F70';
wwv_flow_imp.g_varchar2_table(1404) := '657274696573222C747970653A2250726F7065727479222C69734D616E793A21307D2C7B6E616D653A226C616E6553657473222C69734D616E793A21302C7265706C616365733A22466C6F77456C656D656E7473436F6E7461696E6572236C616E655365';
wwv_flow_imp.g_varchar2_table(1405) := '7473222C747970653A224C616E65536574227D2C7B6E616D653A22666C6F77456C656D656E7473222C69734D616E793A21302C7265706C616365733A22466C6F77456C656D656E7473436F6E7461696E657223666C6F77456C656D656E7473222C747970';
wwv_flow_imp.g_varchar2_table(1406) := '653A22466C6F77456C656D656E74227D2C7B6E616D653A22617274696661637473222C747970653A224172746966616374222C69734D616E793A21307D2C7B6E616D653A227265736F7572636573222C747970653A225265736F75726365526F6C65222C';
wwv_flow_imp.g_varchar2_table(1407) := '69734D616E793A21307D2C7B6E616D653A22636F7272656C6174696F6E537562736372697074696F6E73222C747970653A22436F7272656C6174696F6E537562736372697074696F6E222C69734D616E793A21307D2C7B6E616D653A22737570706F7274';
wwv_flow_imp.g_varchar2_table(1408) := '73222C747970653A2250726F63657373222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22646566696E6974696F6E616C436F6C6C61626F726174696F6E526566222C747970653A22436F6C6C61626F726174696F6E';
wwv_flow_imp.g_varchar2_table(1409) := '222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22697345786563757461626C65222C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A224C616E65536574222C7375706572436C';
wwv_flow_imp.g_varchar2_table(1410) := '6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226C616E6573222C747970653A224C616E65222C69734D616E793A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A225374';
wwv_flow_imp.g_varchar2_table(1411) := '72696E67227D5D7D2C7B6E616D653A224C616E65222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B';
wwv_flow_imp.g_varchar2_table(1412) := '6E616D653A22706172746974696F6E456C656D656E74526566222C747970653A2242617365456C656D656E74222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22706172746974696F6E456C656D656E74222C747970';
wwv_flow_imp.g_varchar2_table(1413) := '653A2242617365456C656D656E74227D2C7B6E616D653A22666C6F774E6F6465526566222C747970653A22466C6F774E6F6465222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226368696C644C616E65536574222C';
wwv_flow_imp.g_varchar2_table(1414) := '747970653A224C616E65536574222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A22476C6F62616C4D616E75616C5461736B222C7375706572436C6173733A5B22476C6F62616C5461736B225D7D2C7B6E61';
wwv_flow_imp.g_varchar2_table(1415) := '6D653A224D616E75616C5461736B222C7375706572436C6173733A5B225461736B225D7D2C7B6E616D653A22557365725461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A2272656E64657269';
wwv_flow_imp.g_varchar2_table(1416) := '6E6773222C747970653A2252656E646572696E67222C69734D616E793A21307D2C7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2252656E646572696E6722';
wwv_flow_imp.g_varchar2_table(1417) := '2C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A2248756D616E506572666F726D6572222C7375706572436C6173733A5B22506572666F726D6572225D7D2C7B6E616D653A22506F74656E7469616C4F776E657222';
wwv_flow_imp.g_varchar2_table(1418) := '2C7375706572436C6173733A5B2248756D616E506572666F726D6572225D7D2C7B6E616D653A22476C6F62616C557365725461736B222C7375706572436C6173733A5B22476C6F62616C5461736B225D2C70726F706572746965733A5B7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1419) := '696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2272656E646572696E6773222C747970653A2252656E646572696E67222C69734D616E793A21307D5D7D2C7B6E616D653A22476174';
wwv_flow_imp.g_varchar2_table(1420) := '65776179222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F774E6F6465225D2C70726F706572746965733A5B7B6E616D653A2267617465776179446972656374696F6E222C747970653A2247617465776179446972656374';
wwv_flow_imp.g_varchar2_table(1421) := '696F6E222C64656661756C743A22556E737065636966696564222C6973417474723A21307D5D7D2C7B6E616D653A224576656E74426173656447617465776179222C7375706572436C6173733A5B2247617465776179225D2C70726F706572746965733A';
wwv_flow_imp.g_varchar2_table(1422) := '5B7B6E616D653A22696E7374616E7469617465222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226576656E744761746577617954797065222C747970653A224576656E74426173656447';
wwv_flow_imp.g_varchar2_table(1423) := '61746577617954797065222C6973417474723A21302C64656661756C743A224578636C7573697665227D5D7D2C7B6E616D653A22436F6D706C657847617465776179222C7375706572436C6173733A5B2247617465776179225D2C70726F706572746965';
wwv_flow_imp.g_varchar2_table(1424) := '733A5B7B6E616D653A2261637469766174696F6E436F6E646974696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A2264656661756C74222C747970653A2253';
wwv_flow_imp.g_varchar2_table(1425) := '657175656E6365466C6F77222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224578636C757369766547617465776179222C7375706572436C6173733A5B2247617465776179225D2C70726F706572746965733A';
wwv_flow_imp.g_varchar2_table(1426) := '5B7B6E616D653A2264656661756C74222C747970653A2253657175656E6365466C6F77222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22496E636C757369766547617465776179222C7375706572436C617373';
wwv_flow_imp.g_varchar2_table(1427) := '3A5B2247617465776179225D2C70726F706572746965733A5B7B6E616D653A2264656661756C74222C747970653A2253657175656E6365466C6F77222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2250617261';
wwv_flow_imp.g_varchar2_table(1428) := '6C6C656C47617465776179222C7375706572436C6173733A5B2247617465776179225D7D2C7B6E616D653A22526F6F74456C656D656E74222C697341627374726163743A21302C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B';
wwv_flow_imp.g_varchar2_table(1429) := '6E616D653A2252656C6174696F6E73686970222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2274797065222C6973417474723A21302C747970653A22537472696E67227D2C7B6E61';
wwv_flow_imp.g_varchar2_table(1430) := '6D653A22646972656374696F6E222C747970653A2252656C6174696F6E73686970446972656374696F6E222C6973417474723A21307D2C7B6E616D653A22736F75726365222C69734D616E793A21302C69735265666572656E63653A21302C747970653A';
wwv_flow_imp.g_varchar2_table(1431) := '22456C656D656E74227D2C7B6E616D653A22746172676574222C69734D616E793A21302C69735265666572656E63653A21302C747970653A22456C656D656E74227D5D7D2C7B6E616D653A2242617365456C656D656E74222C697341627374726163743A';
wwv_flow_imp.g_varchar2_table(1432) := '21302C70726F706572746965733A5B7B6E616D653A226964222C6973417474723A21302C747970653A22537472696E67222C697349643A21307D2C7B6E616D653A22646F63756D656E746174696F6E222C747970653A22446F63756D656E746174696F6E';
wwv_flow_imp.g_varchar2_table(1433) := '222C69734D616E793A21307D2C7B6E616D653A22657874656E73696F6E446566696E6974696F6E73222C747970653A22457874656E73696F6E446566696E6974696F6E222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(1434) := '3A22657874656E73696F6E456C656D656E7473222C747970653A22457874656E73696F6E456C656D656E7473227D5D7D2C7B6E616D653A22457874656E73696F6E222C70726F706572746965733A5B7B6E616D653A226D757374556E6465727374616E64';
wwv_flow_imp.g_varchar2_table(1435) := '222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22646566696E6974696F6E222C747970653A22457874656E73696F6E446566696E6974696F6E222C6973417474723A21302C6973526566';
wwv_flow_imp.g_varchar2_table(1436) := '6572656E63653A21307D5D7D2C7B6E616D653A22457874656E73696F6E446566696E6974696F6E222C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226578';
wwv_flow_imp.g_varchar2_table(1437) := '74656E73696F6E417474726962757465446566696E6974696F6E73222C747970653A22457874656E73696F6E417474726962757465446566696E6974696F6E222C69734D616E793A21307D5D7D2C7B6E616D653A22457874656E73696F6E417474726962';
wwv_flow_imp.g_varchar2_table(1438) := '757465446566696E6974696F6E222C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2274797065222C6973417474723A21302C747970653A22537472696E67';
wwv_flow_imp.g_varchar2_table(1439) := '227D2C7B6E616D653A2269735265666572656E6365222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22657874656E73696F6E446566696E6974696F6E222C747970653A22457874656E73';
wwv_flow_imp.g_varchar2_table(1440) := '696F6E446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22457874656E73696F6E456C656D656E7473222C70726F706572746965733A5B7B6E616D653A2276616C7565526566222C6973';
wwv_flow_imp.g_varchar2_table(1441) := '417474723A21302C69735265666572656E63653A21302C747970653A22456C656D656E74227D2C7B6E616D653A2276616C756573222C747970653A22456C656D656E74222C69734D616E793A21307D2C7B6E616D653A22657874656E73696F6E41747472';
wwv_flow_imp.g_varchar2_table(1442) := '6962757465446566696E6974696F6E222C747970653A22457874656E73696F6E417474726962757465446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22446F63756D656E746174696F';
wwv_flow_imp.g_varchar2_table(1443) := '6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2274657874222C747970653A22537472696E67222C6973426F64793A21307D2C7B6E616D653A2274657874466F726D6174222C64';
wwv_flow_imp.g_varchar2_table(1444) := '656661756C743A22746578742F706C61696E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224576656E74222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F774E6F6465222C2249';
wwv_flow_imp.g_varchar2_table(1445) := '6E746572616374696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A2270726F70657274696573222C747970653A2250726F7065727479222C69734D616E793A21307D5D7D2C7B6E616D653A22496E7465726D65646961746543617463';
wwv_flow_imp.g_varchar2_table(1446) := '684576656E74222C7375706572436C6173733A5B2243617463684576656E74225D7D2C7B6E616D653A22496E7465726D6564696174655468726F774576656E74222C7375706572436C6173733A5B225468726F774576656E74225D7D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1447) := '456E644576656E74222C7375706572436C6173733A5B225468726F774576656E74225D7D2C7B6E616D653A2253746172744576656E74222C7375706572436C6173733A5B2243617463684576656E74225D2C70726F706572746965733A5B7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1448) := '226973496E74657272757074696E67222C64656661756C743A21302C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A225468726F774576656E74222C697341627374726163743A21302C7375706572436C6173733A';
wwv_flow_imp.g_varchar2_table(1449) := '5B224576656E74225D2C70726F706572746965733A5B7B6E616D653A2264617461496E70757473222C747970653A2244617461496E707574222C69734D616E793A21307D2C7B6E616D653A2264617461496E7075744173736F63696174696F6E73222C74';
wwv_flow_imp.g_varchar2_table(1450) := '7970653A2244617461496E7075744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A22696E707574536574222C747970653A22496E707574536574227D2C7B6E616D653A226576656E74446566696E6974696F6E73222C747970';
wwv_flow_imp.g_varchar2_table(1451) := '653A224576656E74446566696E6974696F6E222C69734D616E793A21307D2C7B6E616D653A226576656E74446566696E6974696F6E526566222C747970653A224576656E74446566696E6974696F6E222C69734D616E793A21302C69735265666572656E';
wwv_flow_imp.g_varchar2_table(1452) := '63653A21307D5D7D2C7B6E616D653A2243617463684576656E74222C697341627374726163743A21302C7375706572436C6173733A5B224576656E74225D2C70726F706572746965733A5B7B6E616D653A22706172616C6C656C4D756C7469706C65222C';
wwv_flow_imp.g_varchar2_table(1453) := '6973417474723A21302C747970653A22426F6F6C65616E222C64656661756C743A21317D2C7B6E616D653A22646174614F757470757473222C747970653A22446174614F7574707574222C69734D616E793A21307D2C7B6E616D653A22646174614F7574';
wwv_flow_imp.g_varchar2_table(1454) := '7075744173736F63696174696F6E73222C747970653A22446174614F75747075744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A226F7574707574536574222C747970653A224F7574707574536574227D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1455) := '6576656E74446566696E6974696F6E73222C747970653A224576656E74446566696E6974696F6E222C69734D616E793A21307D2C7B6E616D653A226576656E74446566696E6974696F6E526566222C747970653A224576656E74446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(1456) := '222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22426F756E646172794576656E74222C7375706572436C6173733A5B2243617463684576656E74225D2C70726F706572746965733A5B7B6E616D653A2263616E';
wwv_flow_imp.g_varchar2_table(1457) := '63656C4163746976697479222C64656661756C743A21302C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226174746163686564546F526566222C747970653A224163746976697479222C6973417474723A21302C6973';
wwv_flow_imp.g_varchar2_table(1458) := '5265666572656E63653A21307D5D7D2C7B6E616D653A224576656E74446566696E6974696F6E222C697341627374726163743A21302C7375706572436C6173733A5B22526F6F74456C656D656E74225D7D2C7B6E616D653A2243616E63656C4576656E74';
wwv_flow_imp.g_varchar2_table(1459) := '446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D7D2C7B6E616D653A224572726F724576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(1460) := '6E225D2C70726F706572746965733A5B7B6E616D653A226572726F72526566222C747970653A224572726F72222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225465726D696E6174654576656E74446566696E';
wwv_flow_imp.g_varchar2_table(1461) := '6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D7D2C7B6E616D653A22457363616C6174696F6E4576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(1462) := '6E225D2C70726F706572746965733A5B7B6E616D653A22657363616C6174696F6E526566222C747970653A22457363616C6174696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22457363616C6174696F';
wwv_flow_imp.g_varchar2_table(1463) := '6E222C70726F706572746965733A5B7B6E616D653A22737472756374757265526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226E616D65222C697341';
wwv_flow_imp.g_varchar2_table(1464) := '7474723A21302C747970653A22537472696E67227D2C7B6E616D653A22657363616C6174696F6E436F6465222C6973417474723A21302C747970653A22537472696E67227D5D2C7375706572436C6173733A5B22526F6F74456C656D656E74225D7D2C7B';
wwv_flow_imp.g_varchar2_table(1465) := '6E616D653A22436F6D70656E736174654576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A2277616974466F72436F6D706C6574696F6E';
wwv_flow_imp.g_varchar2_table(1466) := '222C6973417474723A21302C747970653A22426F6F6C65616E222C64656661756C743A21307D2C7B6E616D653A226163746976697479526566222C747970653A224163746976697479222C6973417474723A21302C69735265666572656E63653A21307D';
wwv_flow_imp.g_varchar2_table(1467) := '5D7D2C7B6E616D653A2254696D65724576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A2274696D6544617465222C747970653A224578';
wwv_flow_imp.g_varchar2_table(1468) := '7072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A2274696D654379636C65222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D';
wwv_flow_imp.g_varchar2_table(1469) := '7D2C7B6E616D653A2274696D654475726174696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A224C696E6B4576656E74446566696E6974696F6E222C73';
wwv_flow_imp.g_varchar2_table(1470) := '75706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22746172676574222C747970653A';
wwv_flow_imp.g_varchar2_table(1471) := '224C696E6B4576656E74446566696E6974696F6E222C69735265666572656E63653A21307D2C7B6E616D653A22736F75726365222C747970653A224C696E6B4576656E74446566696E6974696F6E222C69734D616E793A21302C69735265666572656E63';
wwv_flow_imp.g_varchar2_table(1472) := '653A21307D5D7D2C7B6E616D653A224D6573736167654576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A226D65737361676552656622';
wwv_flow_imp.g_varchar2_table(1473) := '2C747970653A224D657373616765222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63';
wwv_flow_imp.g_varchar2_table(1474) := '653A21307D5D7D2C7B6E616D653A22436F6E646974696F6E616C4576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A22636F6E64697469';
wwv_flow_imp.g_varchar2_table(1475) := '6F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A225369676E616C4576656E74446566696E6974696F6E222C7375706572436C6173733A5B224576656E74';
wwv_flow_imp.g_varchar2_table(1476) := '446566696E6974696F6E225D2C70726F706572746965733A5B7B6E616D653A227369676E616C526566222C747970653A225369676E616C222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225369676E616C222C';
wwv_flow_imp.g_varchar2_table(1477) := '7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22737472756374757265526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C6973526566657265';
wwv_flow_imp.g_varchar2_table(1478) := '6E63653A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22496D706C696369745468726F774576656E74222C7375706572436C6173733A5B225468726F774576656E74225D';
wwv_flow_imp.g_varchar2_table(1479) := '7D2C7B6E616D653A22446174615374617465222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B';
wwv_flow_imp.g_varchar2_table(1480) := '6E616D653A224974656D4177617265456C656D656E74222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226974656D5375626A656374526566222C747970653A224974656D44656669';
wwv_flow_imp.g_varchar2_table(1481) := '6E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22646174615374617465222C747970653A22446174615374617465227D5D7D2C7B6E616D653A22446174614173736F63696174696F6E222C73757065';
wwv_flow_imp.g_varchar2_table(1482) := '72436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22736F75726365526566222C747970653A224974656D4177617265456C656D656E74222C69734D616E793A21302C69735265666572656E63653A21';
wwv_flow_imp.g_varchar2_table(1483) := '307D2C7B6E616D653A22746172676574526566222C747970653A224974656D4177617265456C656D656E74222C69735265666572656E63653A21307D2C7B6E616D653A227472616E73666F726D6174696F6E222C747970653A22466F726D616C45787072';
wwv_flow_imp.g_varchar2_table(1484) := '657373696F6E222C786D6C3A7B73657269616C697A653A2270726F7065727479227D7D2C7B6E616D653A2261737369676E6D656E74222C747970653A2241737369676E6D656E74222C69734D616E793A21307D5D7D2C7B6E616D653A2244617461496E70';
wwv_flow_imp.g_varchar2_table(1485) := '7574222C7375706572436C6173733A5B224974656D4177617265456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226973436F6C6C65';
wwv_flow_imp.g_varchar2_table(1486) := '6374696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22696E707574536574526566222C747970653A22496E707574536574222C69734D616E793A21302C69735669727475616C3A';
wwv_flow_imp.g_varchar2_table(1487) := '21302C69735265666572656E63653A21307D2C7B6E616D653A22696E707574536574576974684F7074696F6E616C222C747970653A22496E707574536574222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21';
wwv_flow_imp.g_varchar2_table(1488) := '307D2C7B6E616D653A22696E707574536574576974685768696C65457865637574696E67222C747970653A22496E707574536574222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D5D7D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(1489) := '3A22446174614F7574707574222C7375706572436C6173733A5B224974656D4177617265456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(1490) := '653A226973436F6C6C656374696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226F7574707574536574526566222C747970653A224F7574707574536574222C69734D616E793A21';
wwv_flow_imp.g_varchar2_table(1491) := '302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7574707574536574576974684F7074696F6E616C222C747970653A224F7574707574536574222C69734D616E793A21302C69735669727475616C3A2130';
wwv_flow_imp.g_varchar2_table(1492) := '2C69735265666572656E63653A21307D2C7B6E616D653A226F7574707574536574576974685768696C65457865637574696E67222C747970653A224F7574707574536574222C69734D616E793A21302C69735669727475616C3A21302C69735265666572';
wwv_flow_imp.g_varchar2_table(1493) := '656E63653A21307D5D7D2C7B6E616D653A22496E707574536574222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A2253747269';
wwv_flow_imp.g_varchar2_table(1494) := '6E67227D2C7B6E616D653A2264617461496E70757452656673222C747970653A2244617461496E707574222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7074696F6E616C496E70757452656673222C74797065';
wwv_flow_imp.g_varchar2_table(1495) := '3A2244617461496E707574222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A227768696C65457865637574696E67496E70757452656673222C747970653A2244617461496E707574222C69734D616E793A21302C6973';
wwv_flow_imp.g_varchar2_table(1496) := '5265666572656E63653A21307D2C7B6E616D653A226F757470757453657452656673222C747970653A224F7574707574536574222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224F7574707574536574222C73';
wwv_flow_imp.g_varchar2_table(1497) := '75706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22646174614F757470757452656673222C747970653A22446174614F7574707574222C69734D616E793A21302C69735265666572656E6365';
wwv_flow_imp.g_varchar2_table(1498) := '3A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696E70757453657452656673222C747970653A22496E707574536574222C69734D616E793A21302C69735265666572656E63';
wwv_flow_imp.g_varchar2_table(1499) := '653A21307D2C7B6E616D653A226F7074696F6E616C4F757470757452656673222C747970653A22446174614F7574707574222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A227768696C65457865637574696E674F75';
wwv_flow_imp.g_varchar2_table(1500) := '7470757452656673222C747970653A22446174614F7574707574222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2250726F7065727479222C7375706572436C6173733A5B224974656D4177617265456C656D65';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(1501) := '6E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2244617461496E7075744173736F63696174696F6E222C7375706572436C6173733A5B2244';
wwv_flow_imp.g_varchar2_table(1502) := '6174614173736F63696174696F6E225D7D2C7B6E616D653A22446174614F75747075744173736F63696174696F6E222C7375706572436C6173733A5B22446174614173736F63696174696F6E225D7D2C7B6E616D653A22496E7075744F75747075745370';
wwv_flow_imp.g_varchar2_table(1503) := '6563696669636174696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2264617461496E70757473222C747970653A2244617461496E707574222C69734D616E793A21307D2C7B';
wwv_flow_imp.g_varchar2_table(1504) := '6E616D653A22646174614F757470757473222C747970653A22446174614F7574707574222C69734D616E793A21307D2C7B6E616D653A22696E70757453657473222C747970653A22496E707574536574222C69734D616E793A21307D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1505) := '6F757470757453657473222C747970653A224F7574707574536574222C69734D616E793A21307D5D7D2C7B6E616D653A22446174614F626A656374222C7375706572436C6173733A5B22466C6F77456C656D656E74222C224974656D4177617265456C65';
wwv_flow_imp.g_varchar2_table(1506) := '6D656E74225D2C70726F706572746965733A5B7B6E616D653A226973436F6C6C656374696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A22496E7075744F757470757442696E';
wwv_flow_imp.g_varchar2_table(1507) := '64696E67222C70726F706572746965733A5B7B6E616D653A22696E70757444617461526566222C747970653A22496E707574536574222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7574707574446174615265';
wwv_flow_imp.g_varchar2_table(1508) := '66222C747970653A224F7574707574536574222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C697352656665';
wwv_flow_imp.g_varchar2_table(1509) := '72656E63653A21307D5D7D2C7B6E616D653A2241737369676E6D656E74222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2266726F6D222C747970653A2245787072657373696F6E22';
wwv_flow_imp.g_varchar2_table(1510) := '2C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A22746F222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D7D2C7B6E616D653A224461746153';
wwv_flow_imp.g_varchar2_table(1511) := '746F7265222C7375706572436C6173733A5B22526F6F74456C656D656E74222C224974656D4177617265456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E6722';
wwv_flow_imp.g_varchar2_table(1512) := '7D2C7B6E616D653A226361706163697479222C6973417474723A21302C747970653A22496E7465676572227D2C7B6E616D653A226973556E6C696D69746564222C64656661756C743A21302C6973417474723A21302C747970653A22426F6F6C65616E22';
wwv_flow_imp.g_varchar2_table(1513) := '7D5D7D2C7B6E616D653A224461746153746F72655265666572656E6365222C7375706572436C6173733A5B224974656D4177617265456C656D656E74222C22466C6F77456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2264617461';
wwv_flow_imp.g_varchar2_table(1514) := '53746F7265526566222C747970653A224461746153746F7265222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22446174614F626A6563745265666572656E6365222C7375706572436C6173733A5B224974656D';
wwv_flow_imp.g_varchar2_table(1515) := '4177617265456C656D656E74222C22466C6F77456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22646174614F626A656374526566222C747970653A22446174614F626A656374222C6973417474723A21302C69735265666572656E';
wwv_flow_imp.g_varchar2_table(1516) := '63653A21307D5D7D2C7B6E616D653A22436F6E766572736174696F6E4C696E6B222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22736F75726365526566222C747970653A22496E74';
wwv_flow_imp.g_varchar2_table(1517) := '6572616374696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22746172676574526566222C747970653A22496E746572616374696F6E4E6F6465222C6973417474723A21302C69735265666572656E';
wwv_flow_imp.g_varchar2_table(1518) := '63653A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6E766572736174696F6E4173736F63696174696F6E222C7375706572436C6173733A5B2242617365456C656D';
wwv_flow_imp.g_varchar2_table(1519) := '656E74225D2C70726F706572746965733A5B7B6E616D653A22696E6E6572436F6E766572736174696F6E4E6F6465526566222C747970653A22436F6E766572736174696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D';
wwv_flow_imp.g_varchar2_table(1520) := '2C7B6E616D653A226F75746572436F6E766572736174696F6E4E6F6465526566222C747970653A22436F6E766572736174696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2243616C6C436F6E';
wwv_flow_imp.g_varchar2_table(1521) := '766572736174696F6E222C7375706572436C6173733A5B22436F6E766572736174696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A2263616C6C6564436F6C6C61626F726174696F6E526566222C747970653A22436F6C6C61626F72';
wwv_flow_imp.g_varchar2_table(1522) := '6174696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A227061727469636970616E744173736F63696174696F6E73222C747970653A225061727469636970616E744173736F63696174696F6E222C69734D616E';
wwv_flow_imp.g_varchar2_table(1523) := '793A21307D5D7D2C7B6E616D653A22436F6E766572736174696F6E222C7375706572436C6173733A5B22436F6E766572736174696F6E4E6F6465225D7D2C7B6E616D653A22537562436F6E766572736174696F6E222C7375706572436C6173733A5B2243';
wwv_flow_imp.g_varchar2_table(1524) := '6F6E766572736174696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A22636F6E766572736174696F6E4E6F646573222C747970653A22436F6E766572736174696F6E4E6F6465222C69734D616E793A21307D5D7D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1525) := '436F6E766572736174696F6E4E6F6465222C697341627374726163743A21302C7375706572436C6173733A5B22496E746572616374696F6E4E6F6465222C2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65';
wwv_flow_imp.g_varchar2_table(1526) := '222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227061727469636970616E74526566222C747970653A225061727469636970616E74222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D65';
wwv_flow_imp.g_varchar2_table(1527) := '3A226D657373616765466C6F7752656673222C747970653A224D657373616765466C6F77222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F7272656C6174696F6E4B657973222C747970653A22436F7272656C';
wwv_flow_imp.g_varchar2_table(1528) := '6174696F6E4B6579222C69734D616E793A21307D5D7D2C7B6E616D653A22476C6F62616C436F6E766572736174696F6E222C7375706572436C6173733A5B22436F6C6C61626F726174696F6E225D7D2C7B6E616D653A22506172746E6572456E74697479';
wwv_flow_imp.g_varchar2_table(1529) := '222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227061727469636970616E74526566';
wwv_flow_imp.g_varchar2_table(1530) := '222C747970653A225061727469636970616E74222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22506172746E6572526F6C65222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F70';
wwv_flow_imp.g_varchar2_table(1531) := '6572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227061727469636970616E74526566222C747970653A225061727469636970616E74222C69734D616E793A21302C6973';
wwv_flow_imp.g_varchar2_table(1532) := '5265666572656E63653A21307D5D7D2C7B6E616D653A22436F7272656C6174696F6E50726F7065727479222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22636F7272656C6174696F';
wwv_flow_imp.g_varchar2_table(1533) := '6E50726F706572747952657472696576616C45787072657373696F6E222C747970653A22436F7272656C6174696F6E50726F706572747952657472696576616C45787072657373696F6E222C69734D616E793A21307D2C7B6E616D653A226E616D65222C';
wwv_flow_imp.g_varchar2_table(1534) := '6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2274797065222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224572726F72';
wwv_flow_imp.g_varchar2_table(1535) := '222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22737472756374757265526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C697352656665';
wwv_flow_imp.g_varchar2_table(1536) := '72656E63653A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226572726F72436F6465222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1537) := '436F7272656C6174696F6E4B6579222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22636F7272656C6174696F6E50726F7065727479526566222C747970653A22436F7272656C6174';
wwv_flow_imp.g_varchar2_table(1538) := '696F6E50726F7065727479222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2245787072657373696F6E222C7375';
wwv_flow_imp.g_varchar2_table(1539) := '706572436C6173733A5B2242617365456C656D656E74225D2C697341627374726163743A21312C70726F706572746965733A5B7B6E616D653A22626F6479222C6973426F64793A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22466F';
wwv_flow_imp.g_varchar2_table(1540) := '726D616C45787072657373696F6E222C7375706572436C6173733A5B2245787072657373696F6E225D2C70726F706572746965733A5B7B6E616D653A226C616E6775616765222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(1541) := '653A226576616C7561746573546F54797065526566222C747970653A224974656D446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224D657373616765222C7375706572436C6173733A';
wwv_flow_imp.g_varchar2_table(1542) := '5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226974656D526566222C747970653A224974656D446566696E697469';
wwv_flow_imp.g_varchar2_table(1543) := '6F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224974656D446566696E6974696F6E222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1544) := '226974656D4B696E64222C747970653A224974656D4B696E64222C6973417474723A21307D2C7B6E616D653A22737472756374757265526566222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226973436F6C6C656374';
wwv_flow_imp.g_varchar2_table(1545) := '696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22696D706F7274222C747970653A22496D706F7274222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B';
wwv_flow_imp.g_varchar2_table(1546) := '6E616D653A22466C6F77456C656D656E74222C697341627374726163743A21302C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A';
wwv_flow_imp.g_varchar2_table(1547) := '22537472696E67227D2C7B6E616D653A226175646974696E67222C747970653A224175646974696E67227D2C7B6E616D653A226D6F6E69746F72696E67222C747970653A224D6F6E69746F72696E67227D2C7B6E616D653A2263617465676F727956616C';
wwv_flow_imp.g_varchar2_table(1548) := '7565526566222C747970653A2243617465676F727956616C7565222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2253657175656E6365466C6F77222C7375706572436C6173733A5B22466C6F77456C656D656E';
wwv_flow_imp.g_varchar2_table(1549) := '74225D2C70726F706572746965733A5B7B6E616D653A226973496D6D656469617465222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22636F6E646974696F6E45787072657373696F6E222C747970653A2245787072';
wwv_flow_imp.g_varchar2_table(1550) := '657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A22736F75726365526566222C747970653A22466C6F774E6F6465222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(1551) := '653A22746172676574526566222C747970653A22466C6F774E6F6465222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22466C6F77456C656D656E7473436F6E7461696E6572222C697341627374726163743A21';
wwv_flow_imp.g_varchar2_table(1552) := '302C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226C616E6553657473222C747970653A224C616E65536574222C69734D616E793A21307D2C7B6E616D653A22666C6F77456C656D65';
wwv_flow_imp.g_varchar2_table(1553) := '6E7473222C747970653A22466C6F77456C656D656E74222C69734D616E793A21307D5D7D2C7B6E616D653A2243616C6C61626C65456C656D656E74222C697341627374726163743A21302C7375706572436C6173733A5B22526F6F74456C656D656E7422';
wwv_flow_imp.g_varchar2_table(1554) := '5D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696F53706563696669636174696F6E222C747970653A22496E7075744F757470757453706563696669';
wwv_flow_imp.g_varchar2_table(1555) := '636174696F6E222C786D6C3A7B73657269616C697A653A2270726F7065727479227D7D2C7B6E616D653A22737570706F72746564496E74657266616365526566222C747970653A22496E74657266616365222C69734D616E793A21302C69735265666572';
wwv_flow_imp.g_varchar2_table(1556) := '656E63653A21307D2C7B6E616D653A22696F42696E64696E67222C747970653A22496E7075744F757470757442696E64696E67222C69734D616E793A21302C786D6C3A7B73657269616C697A653A2270726F7065727479227D7D5D7D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1557) := '466C6F774E6F6465222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F77456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22696E636F6D696E67222C747970653A2253657175656E6365466C6F77222C';
wwv_flow_imp.g_varchar2_table(1558) := '69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226F7574676F696E67222C747970653A2253657175656E6365466C6F77222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A226C616E65';
wwv_flow_imp.g_varchar2_table(1559) := '73222C747970653A224C616E65222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22436F7272656C6174696F6E50726F706572747952657472696576616C45787072657373696F';
wwv_flow_imp.g_varchar2_table(1560) := '6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226D65737361676550617468222C747970653A22466F726D616C45787072657373696F6E227D2C7B6E616D653A226D6573736167';
wwv_flow_imp.g_varchar2_table(1561) := '65526566222C747970653A224D657373616765222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22436F7272656C6174696F6E50726F706572747942696E64696E67222C7375706572436C6173733A5B22426173';
wwv_flow_imp.g_varchar2_table(1562) := '65456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226461746150617468222C747970653A22466F726D616C45787072657373696F6E227D2C7B6E616D653A22636F7272656C6174696F6E50726F7065727479526566222C74797065';
wwv_flow_imp.g_varchar2_table(1563) := '3A22436F7272656C6174696F6E50726F7065727479222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225265736F75726365222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F7065';
wwv_flow_imp.g_varchar2_table(1564) := '72746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227265736F75726365506172616D6574657273222C747970653A225265736F75726365506172616D65746572222C69734D';
wwv_flow_imp.g_varchar2_table(1565) := '616E793A21307D5D7D2C7B6E616D653A225265736F75726365506172616D65746572222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C7479';
wwv_flow_imp.g_varchar2_table(1566) := '70653A22537472696E67227D2C7B6E616D653A2269735265717569726564222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A2274797065222C747970653A224974656D446566696E6974696F6E222C6973417474723A';
wwv_flow_imp.g_varchar2_table(1567) := '21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22436F7272656C6174696F6E537562736372697074696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2263';
wwv_flow_imp.g_varchar2_table(1568) := '6F7272656C6174696F6E4B6579526566222C747970653A22436F7272656C6174696F6E4B6579222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F7272656C6174696F6E50726F706572747942696E64696E6722';
wwv_flow_imp.g_varchar2_table(1569) := '2C747970653A22436F7272656C6174696F6E50726F706572747942696E64696E67222C69734D616E793A21307D5D7D2C7B6E616D653A224D657373616765466C6F77222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F7065';
wwv_flow_imp.g_varchar2_table(1570) := '72746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22736F75726365526566222C747970653A22496E746572616374696F6E4E6F6465222C6973417474723A21302C69735265';
wwv_flow_imp.g_varchar2_table(1571) := '666572656E63653A21307D2C7B6E616D653A22746172676574526566222C747970653A22496E746572616374696F6E4E6F6465222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226D657373616765526566222C7479';
wwv_flow_imp.g_varchar2_table(1572) := '70653A224D657373616765222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224D657373616765466C6F774173736F63696174696F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70';
wwv_flow_imp.g_varchar2_table(1573) := '726F706572746965733A5B7B6E616D653A22696E6E65724D657373616765466C6F77526566222C747970653A224D657373616765466C6F77222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226F757465724D657373';
wwv_flow_imp.g_varchar2_table(1574) := '616765466C6F77526566222C747970653A224D657373616765466C6F77222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22496E746572616374696F6E4E6F6465222C697341627374726163743A21302C70726F';
wwv_flow_imp.g_varchar2_table(1575) := '706572746965733A5B7B6E616D653A22696E636F6D696E67436F6E766572736174696F6E4C696E6B73222C747970653A22436F6E766572736174696F6E4C696E6B222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63';
wwv_flow_imp.g_varchar2_table(1576) := '653A21307D2C7B6E616D653A226F7574676F696E67436F6E766572736174696F6E4C696E6B73222C747970653A22436F6E766572736174696F6E4C696E6B222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21';
wwv_flow_imp.g_varchar2_table(1577) := '307D5D7D2C7B6E616D653A225061727469636970616E74222C7375706572436C6173733A5B22496E746572616374696F6E4E6F6465222C2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474';
wwv_flow_imp.g_varchar2_table(1578) := '723A21302C747970653A22537472696E67227D2C7B6E616D653A22696E74657266616365526566222C747970653A22496E74657266616365222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22706172746963697061';
wwv_flow_imp.g_varchar2_table(1579) := '6E744D756C7469706C6963697479222C747970653A225061727469636970616E744D756C7469706C6963697479227D2C7B6E616D653A22656E64506F696E7452656673222C747970653A22456E64506F696E74222C69734D616E793A21302C6973526566';
wwv_flow_imp.g_varchar2_table(1580) := '6572656E63653A21307D2C7B6E616D653A2270726F63657373526566222C747970653A2250726F63657373222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225061727469636970616E744173736F6369617469';
wwv_flow_imp.g_varchar2_table(1581) := '6F6E222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22696E6E65725061727469636970616E74526566222C747970653A225061727469636970616E74222C6973417474723A21302C';
wwv_flow_imp.g_varchar2_table(1582) := '69735265666572656E63653A21307D2C7B6E616D653A226F757465725061727469636970616E74526566222C747970653A225061727469636970616E74222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225061';
wwv_flow_imp.g_varchar2_table(1583) := '727469636970616E744D756C7469706C6963697479222C70726F706572746965733A5B7B6E616D653A226D696E696D756D222C64656661756C743A302C6973417474723A21302C747970653A22496E7465676572227D2C7B6E616D653A226D6178696D75';
wwv_flow_imp.g_varchar2_table(1584) := '6D222C64656661756C743A312C6973417474723A21302C747970653A22496E7465676572227D5D2C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A22436F6C6C61626F726174696F6E222C7375706572436C617373';
wwv_flow_imp.g_varchar2_table(1585) := '3A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226973436C6F736564222C6973417474723A21302C747970653A22';
wwv_flow_imp.g_varchar2_table(1586) := '426F6F6C65616E227D2C7B6E616D653A227061727469636970616E7473222C747970653A225061727469636970616E74222C69734D616E793A21307D2C7B6E616D653A226D657373616765466C6F7773222C747970653A224D657373616765466C6F7722';
wwv_flow_imp.g_varchar2_table(1587) := '2C69734D616E793A21307D2C7B6E616D653A22617274696661637473222C747970653A224172746966616374222C69734D616E793A21307D2C7B6E616D653A22636F6E766572736174696F6E73222C747970653A22436F6E766572736174696F6E4E6F64';
wwv_flow_imp.g_varchar2_table(1588) := '65222C69734D616E793A21307D2C7B6E616D653A22636F6E766572736174696F6E4173736F63696174696F6E73222C747970653A22436F6E766572736174696F6E4173736F63696174696F6E227D2C7B6E616D653A227061727469636970616E74417373';
wwv_flow_imp.g_varchar2_table(1589) := '6F63696174696F6E73222C747970653A225061727469636970616E744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A226D657373616765466C6F774173736F63696174696F6E73222C747970653A224D657373616765466C6F';
wwv_flow_imp.g_varchar2_table(1590) := '774173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A22636F7272656C6174696F6E4B657973222C747970653A22436F7272656C6174696F6E4B6579222C69734D616E793A21307D2C7B6E616D653A2263686F72656F6772617068';
wwv_flow_imp.g_varchar2_table(1591) := '79526566222C747970653A2243686F72656F677261706879222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F6E766572736174696F6E4C696E6B73222C747970653A22436F6E766572736174696F6E4C696E6B';
wwv_flow_imp.g_varchar2_table(1592) := '222C69734D616E793A21307D5D7D2C7B6E616D653A2243686F72656F6772617068794163746976697479222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F774E6F6465225D2C70726F706572746965733A5B7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1593) := '227061727469636970616E74526566222C747970653A225061727469636970616E74222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A22696E6974696174696E675061727469636970616E74526566222C747970653A';
wwv_flow_imp.g_varchar2_table(1594) := '225061727469636970616E74222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22636F7272656C6174696F6E4B657973222C747970653A22436F7272656C6174696F6E4B6579222C69734D616E793A21307D2C7B6E61';
wwv_flow_imp.g_varchar2_table(1595) := '6D653A226C6F6F7054797065222C747970653A2243686F72656F6772617068794C6F6F7054797065222C64656661756C743A224E6F6E65222C6973417474723A21307D5D7D2C7B6E616D653A2243616C6C43686F72656F677261706879222C7375706572';
wwv_flow_imp.g_varchar2_table(1596) := '436C6173733A5B2243686F72656F6772617068794163746976697479225D2C70726F706572746965733A5B7B6E616D653A2263616C6C656443686F72656F677261706879526566222C747970653A2243686F72656F677261706879222C6973417474723A';
wwv_flow_imp.g_varchar2_table(1597) := '21302C69735265666572656E63653A21307D2C7B6E616D653A227061727469636970616E744173736F63696174696F6E73222C747970653A225061727469636970616E744173736F63696174696F6E222C69734D616E793A21307D5D7D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1598) := '2253756243686F72656F677261706879222C7375706572436C6173733A5B2243686F72656F6772617068794163746976697479222C22466C6F77456C656D656E7473436F6E7461696E6572225D2C70726F706572746965733A5B7B6E616D653A22617274';
wwv_flow_imp.g_varchar2_table(1599) := '696661637473222C747970653A224172746966616374222C69734D616E793A21307D5D7D2C7B6E616D653A2243686F72656F6772617068795461736B222C7375706572436C6173733A5B2243686F72656F6772617068794163746976697479225D2C7072';
wwv_flow_imp.g_varchar2_table(1600) := '6F706572746965733A5B7B6E616D653A226D657373616765466C6F77526566222C747970653A224D657373616765466C6F77222C69734D616E793A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2243686F72656F67726170687922';
wwv_flow_imp.g_varchar2_table(1601) := '2C7375706572436C6173733A5B22436F6C6C61626F726174696F6E222C22466C6F77456C656D656E7473436F6E7461696E6572225D7D2C7B6E616D653A22476C6F62616C43686F72656F6772617068795461736B222C7375706572436C6173733A5B2243';
wwv_flow_imp.g_varchar2_table(1602) := '686F72656F677261706879225D2C70726F706572746965733A5B7B6E616D653A22696E6974696174696E675061727469636970616E74526566222C747970653A225061727469636970616E74222C6973417474723A21302C69735265666572656E63653A';
wwv_flow_imp.g_varchar2_table(1603) := '21307D5D7D2C7B6E616D653A2254657874416E6E6F746174696F6E222C7375706572436C6173733A5B224172746966616374225D2C70726F706572746965733A5B7B6E616D653A2274657874222C747970653A22537472696E67227D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1604) := '74657874466F726D6174222C64656661756C743A22746578742F706C61696E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2247726F7570222C7375706572436C6173733A5B224172746966616374225D2C7072';
wwv_flow_imp.g_varchar2_table(1605) := '6F706572746965733A5B7B6E616D653A2263617465676F727956616C7565526566222C747970653A2243617465676F727956616C7565222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A224173736F6369617469';
wwv_flow_imp.g_varchar2_table(1606) := '6F6E222C7375706572436C6173733A5B224172746966616374225D2C70726F706572746965733A5B7B6E616D653A226173736F63696174696F6E446972656374696F6E222C747970653A224173736F63696174696F6E446972656374696F6E222C697341';
wwv_flow_imp.g_varchar2_table(1607) := '7474723A21307D2C7B6E616D653A22736F75726365526566222C747970653A2242617365456C656D656E74222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22746172676574526566222C747970653A224261736545';
wwv_flow_imp.g_varchar2_table(1608) := '6C656D656E74222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2243617465676F7279222C7375706572436C6173733A5B22526F6F74456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A2263';
wwv_flow_imp.g_varchar2_table(1609) := '617465676F727956616C7565222C747970653A2243617465676F727956616C7565222C69734D616E793A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A2241727469666163';
wwv_flow_imp.g_varchar2_table(1610) := '74222C697341627374726163743A21302C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A2243617465676F727956616C7565222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572';
wwv_flow_imp.g_varchar2_table(1611) := '746965733A5B7B6E616D653A2263617465676F72697A6564466C6F77456C656D656E7473222C747970653A22466C6F77456C656D656E74222C69734D616E793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(1612) := '653A2276616C7565222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224163746976697479222C697341627374726163743A21302C7375706572436C6173733A5B22466C6F774E6F6465225D2C70726F7065727469';
wwv_flow_imp.g_varchar2_table(1613) := '65733A5B7B6E616D653A226973466F72436F6D70656E736174696F6E222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A2264656661756C74222C747970653A2253657175656E6365466C6F';
wwv_flow_imp.g_varchar2_table(1614) := '77222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A22696F53706563696669636174696F6E222C747970653A22496E7075744F757470757453706563696669636174696F6E222C786D6C3A7B73657269616C697A653A';
wwv_flow_imp.g_varchar2_table(1615) := '2270726F7065727479227D7D2C7B6E616D653A22626F756E646172794576656E7452656673222C747970653A22426F756E646172794576656E74222C69734D616E793A21302C69735265666572656E63653A21307D2C7B6E616D653A2270726F70657274';
wwv_flow_imp.g_varchar2_table(1616) := '696573222C747970653A2250726F7065727479222C69734D616E793A21307D2C7B6E616D653A2264617461496E7075744173736F63696174696F6E73222C747970653A2244617461496E7075744173736F63696174696F6E222C69734D616E793A21307D';
wwv_flow_imp.g_varchar2_table(1617) := '2C7B6E616D653A22646174614F75747075744173736F63696174696F6E73222C747970653A22446174614F75747075744173736F63696174696F6E222C69734D616E793A21307D2C7B6E616D653A2273746172745175616E74697479222C64656661756C';
wwv_flow_imp.g_varchar2_table(1618) := '743A312C6973417474723A21302C747970653A22496E7465676572227D2C7B6E616D653A227265736F7572636573222C747970653A225265736F75726365526F6C65222C69734D616E793A21307D2C7B6E616D653A22636F6D706C6574696F6E5175616E';
wwv_flow_imp.g_varchar2_table(1619) := '74697479222C64656661756C743A312C6973417474723A21302C747970653A22496E7465676572227D2C7B6E616D653A226C6F6F70436861726163746572697374696373222C747970653A224C6F6F70436861726163746572697374696373227D5D7D2C';
wwv_flow_imp.g_varchar2_table(1620) := '7B6E616D653A22536572766963655461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C';
wwv_flow_imp.g_varchar2_table(1621) := '7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A2253756250726F63657373222C7375706572436C6173733A5B224163';
wwv_flow_imp.g_varchar2_table(1622) := '746976697479222C22466C6F77456C656D656E7473436F6E7461696E6572222C22496E746572616374696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A2274726967676572656442794576656E74222C64656661756C743A21312C69';
wwv_flow_imp.g_varchar2_table(1623) := '73417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A22617274696661637473222C747970653A224172746966616374222C69734D616E793A21307D5D7D2C7B6E616D653A224C6F6F70436861726163746572697374696373222C';
wwv_flow_imp.g_varchar2_table(1624) := '697341627374726163743A21302C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A224D756C7469496E7374616E63654C6F6F70436861726163746572697374696373222C7375706572436C6173733A5B224C6F6F70';
wwv_flow_imp.g_varchar2_table(1625) := '436861726163746572697374696373225D2C70726F706572746965733A5B7B6E616D653A22697353657175656E7469616C222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226265686176';
wwv_flow_imp.g_varchar2_table(1626) := '696F72222C747970653A224D756C7469496E7374616E63654265686176696F72222C64656661756C743A22416C6C222C6973417474723A21307D2C7B6E616D653A226C6F6F7043617264696E616C697479222C747970653A2245787072657373696F6E22';
wwv_flow_imp.g_varchar2_table(1627) := '2C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A226C6F6F7044617461496E707574526566222C747970653A224974656D4177617265456C656D656E74222C69735265666572656E63653A21307D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1628) := '226C6F6F70446174614F7574707574526566222C747970653A224974656D4177617265456C656D656E74222C69735265666572656E63653A21307D2C7B6E616D653A22696E707574446174614974656D222C747970653A2244617461496E707574222C78';
wwv_flow_imp.g_varchar2_table(1629) := '6D6C3A7B73657269616C697A653A2270726F7065727479227D7D2C7B6E616D653A226F7574707574446174614974656D222C747970653A22446174614F7574707574222C786D6C3A7B73657269616C697A653A2270726F7065727479227D7D2C7B6E616D';
wwv_flow_imp.g_varchar2_table(1630) := '653A22636F6D706C65784265686176696F72446566696E6974696F6E222C747970653A22436F6D706C65784265686176696F72446566696E6974696F6E222C69734D616E793A21307D2C7B6E616D653A22636F6D706C6574696F6E436F6E646974696F6E';
wwv_flow_imp.g_varchar2_table(1631) := '222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A226F6E654265686176696F724576656E74526566222C747970653A224576656E74446566696E6974696F6E222C69';
wwv_flow_imp.g_varchar2_table(1632) := '73417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226E6F6E654265686176696F724576656E74526566222C747970653A224576656E74446566696E6974696F6E222C6973417474723A21302C69735265666572656E63653A21';
wwv_flow_imp.g_varchar2_table(1633) := '307D5D7D2C7B6E616D653A225374616E646172644C6F6F70436861726163746572697374696373222C7375706572436C6173733A5B224C6F6F70436861726163746572697374696373225D2C70726F706572746965733A5B7B6E616D653A227465737442';
wwv_flow_imp.g_varchar2_table(1634) := '65666F7265222C64656661756C743A21312C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226C6F6F70436F6E646974696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B73657269616C697A653A22';
wwv_flow_imp.g_varchar2_table(1635) := '7873693A74797065227D7D2C7B6E616D653A226C6F6F704D6178696D756D222C747970653A22496E7465676572222C6973417474723A21307D5D7D2C7B6E616D653A2243616C6C4163746976697479222C7375706572436C6173733A5B22416374697669';
wwv_flow_imp.g_varchar2_table(1636) := '7479222C22496E746572616374696F6E4E6F6465225D2C70726F706572746965733A5B7B6E616D653A2263616C6C6564456C656D656E74222C747970653A22537472696E67222C6973417474723A21307D5D7D2C7B6E616D653A225461736B222C737570';
wwv_flow_imp.g_varchar2_table(1637) := '6572436C6173733A5B224163746976697479222C22496E746572616374696F6E4E6F6465225D7D2C7B6E616D653A2253656E645461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A22696D706C';
wwv_flow_imp.g_varchar2_table(1638) := '656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63653A21307D';
wwv_flow_imp.g_varchar2_table(1639) := '2C7B6E616D653A226D657373616765526566222C747970653A224D657373616765222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A22526563656976655461736B222C7375706572436C6173733A5B225461736B';
wwv_flow_imp.g_varchar2_table(1640) := '225D2C70726F706572746965733A5B7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696E7374616E7469617465222C64656661756C743A21312C697341747472';
wwv_flow_imp.g_varchar2_table(1641) := '3A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226F7065726174696F6E526566222C747970653A224F7065726174696F6E222C6973417474723A21302C69735265666572656E63653A21307D2C7B6E616D653A226D6573736167655265';
wwv_flow_imp.g_varchar2_table(1642) := '66222C747970653A224D657373616765222C6973417474723A21302C69735265666572656E63653A21307D5D7D2C7B6E616D653A225363726970745461736B222C7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(1643) := '6D653A22736372697074466F726D6174222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22736372697074222C747970653A22537472696E67227D5D7D2C7B6E616D653A22427573696E65737352756C655461736B222C';
wwv_flow_imp.g_varchar2_table(1644) := '7375706572436C6173733A5B225461736B225D2C70726F706572746965733A5B7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A224164486F6353756250726F';
wwv_flow_imp.g_varchar2_table(1645) := '63657373222C7375706572436C6173733A5B2253756250726F63657373225D2C70726F706572746965733A5B7B6E616D653A22636F6D706C6574696F6E436F6E646974696F6E222C747970653A2245787072657373696F6E222C786D6C3A7B7365726961';
wwv_flow_imp.g_varchar2_table(1646) := '6C697A653A227873693A74797065227D7D2C7B6E616D653A226F72646572696E67222C747970653A224164486F634F72646572696E67222C6973417474723A21307D2C7B6E616D653A2263616E63656C52656D61696E696E67496E7374616E636573222C';
wwv_flow_imp.g_varchar2_table(1647) := '64656661756C743A21302C6973417474723A21302C747970653A22426F6F6C65616E227D5D7D2C7B6E616D653A225472616E73616374696F6E222C7375706572436C6173733A5B2253756250726F63657373225D2C70726F706572746965733A5B7B6E61';
wwv_flow_imp.g_varchar2_table(1648) := '6D653A2270726F746F636F6C222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226D6574686F64222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22476C6F62616C536372697074';
wwv_flow_imp.g_varchar2_table(1649) := '5461736B222C7375706572436C6173733A5B22476C6F62616C5461736B225D2C70726F706572746965733A5B7B6E616D653A227363726970744C616E6775616765222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2273';
wwv_flow_imp.g_varchar2_table(1650) := '6372697074222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22476C6F62616C427573696E65737352756C655461736B222C7375706572436C6173733A5B22476C6F62616C5461736B225D2C70726F706572746965';
wwv_flow_imp.g_varchar2_table(1651) := '733A5B7B6E616D653A22696D706C656D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6D706C65784265686176696F72446566696E6974696F6E222C7375706572436C6173733A5B22';
wwv_flow_imp.g_varchar2_table(1652) := '42617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22636F6E646974696F6E222C747970653A22466F726D616C45787072657373696F6E227D2C7B6E616D653A226576656E74222C747970653A22496D706C69636974546872';
wwv_flow_imp.g_varchar2_table(1653) := '6F774576656E74227D5D7D2C7B6E616D653A225265736F75726365526F6C65222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A227265736F75726365526566222C747970653A225265';
wwv_flow_imp.g_varchar2_table(1654) := '736F75726365222C69735265666572656E63653A21307D2C7B6E616D653A227265736F75726365506172616D6574657242696E64696E6773222C747970653A225265736F75726365506172616D6574657242696E64696E67222C69734D616E793A21307D';
wwv_flow_imp.g_varchar2_table(1655) := '2C7B6E616D653A227265736F7572636541737369676E6D656E7445787072657373696F6E222C747970653A225265736F7572636541737369676E6D656E7445787072657373696F6E227D2C7B6E616D653A226E616D65222C6973417474723A21302C7479';
wwv_flow_imp.g_varchar2_table(1656) := '70653A22537472696E67227D5D7D2C7B6E616D653A225265736F75726365506172616D6574657242696E64696E67222C70726F706572746965733A5B7B6E616D653A2265787072657373696F6E222C747970653A2245787072657373696F6E222C786D6C';
wwv_flow_imp.g_varchar2_table(1657) := '3A7B73657269616C697A653A227873693A74797065227D7D2C7B6E616D653A22706172616D65746572526566222C747970653A225265736F75726365506172616D65746572222C6973417474723A21302C69735265666572656E63653A21307D5D2C7375';
wwv_flow_imp.g_varchar2_table(1658) := '706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A225265736F7572636541737369676E6D656E7445787072657373696F6E222C70726F706572746965733A5B7B6E616D653A2265787072657373696F6E222C747970653A22';
wwv_flow_imp.g_varchar2_table(1659) := '45787072657373696F6E222C786D6C3A7B73657269616C697A653A227873693A74797065227D7D5D2C7375706572436C6173733A5B2242617365456C656D656E74225D7D2C7B6E616D653A22496D706F7274222C70726F706572746965733A5B7B6E616D';
wwv_flow_imp.g_varchar2_table(1660) := '653A22696D706F727454797065222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226C6F636174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A226E616D657370616365222C';
wwv_flow_imp.g_varchar2_table(1661) := '6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22446566696E6974696F6E73222C7375706572436C6173733A5B2242617365456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A226E616D65222C69';
wwv_flow_imp.g_varchar2_table(1662) := '73417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227461726765744E616D657370616365222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2265787072657373696F6E4C616E6775616765222C';
wwv_flow_imp.g_varchar2_table(1663) := '64656661756C743A22687474703A2F2F7777772E77332E6F72672F313939392F5850617468222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22747970654C616E6775616765222C64656661756C743A22687474703A2F';
wwv_flow_imp.g_varchar2_table(1664) := '2F7777772E77332E6F72672F323030312F584D4C536368656D61222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22696D706F727473222C747970653A22496D706F7274222C69734D616E793A21307D2C7B6E616D653A';
wwv_flow_imp.g_varchar2_table(1665) := '22657874656E73696F6E73222C747970653A22457874656E73696F6E222C69734D616E793A21307D2C7B6E616D653A22726F6F74456C656D656E7473222C747970653A22526F6F74456C656D656E74222C69734D616E793A21307D2C7B6E616D653A2264';
wwv_flow_imp.g_varchar2_table(1666) := '69616772616D73222C69734D616E793A21302C747970653A2262706D6E64693A42504D4E4469616772616D227D2C7B6E616D653A226578706F72746572222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2272656C6174';
wwv_flow_imp.g_varchar2_table(1667) := '696F6E7368697073222C747970653A2252656C6174696F6E73686970222C69734D616E793A21307D2C7B6E616D653A226578706F7274657256657273696F6E222C6973417474723A21302C747970653A22537472696E67227D5D7D5D2C656E756D657261';
wwv_flow_imp.g_varchar2_table(1668) := '74696F6E733A5B7B6E616D653A2250726F6365737354797065222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A225075626C6963227D2C7B6E616D653A2250726976617465227D5D7D2C7B6E616D653A224761';
wwv_flow_imp.g_varchar2_table(1669) := '7465776179446972656374696F6E222C6C69746572616C56616C7565733A5B7B6E616D653A22556E737065636966696564227D2C7B6E616D653A22436F6E76657267696E67227D2C7B6E616D653A22446976657267696E67227D2C7B6E616D653A224D69';
wwv_flow_imp.g_varchar2_table(1670) := '786564227D5D7D2C7B6E616D653A224576656E7442617365644761746577617954797065222C6C69746572616C56616C7565733A5B7B6E616D653A22506172616C6C656C227D2C7B6E616D653A224578636C7573697665227D5D7D2C7B6E616D653A2252';
wwv_flow_imp.g_varchar2_table(1671) := '656C6174696F6E73686970446972656374696F6E222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A22466F7277617264227D2C7B6E616D653A224261636B77617264227D2C7B6E616D653A22426F7468227D5D';
wwv_flow_imp.g_varchar2_table(1672) := '7D2C7B6E616D653A224974656D4B696E64222C6C69746572616C56616C7565733A5B7B6E616D653A22506879736963616C227D2C7B6E616D653A22496E666F726D6174696F6E227D5D7D2C7B6E616D653A2243686F72656F6772617068794C6F6F705479';
wwv_flow_imp.g_varchar2_table(1673) := '7065222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A225374616E64617264227D2C7B6E616D653A224D756C7469496E7374616E636553657175656E7469616C227D2C7B6E616D653A224D756C7469496E7374';
wwv_flow_imp.g_varchar2_table(1674) := '616E6365506172616C6C656C227D5D7D2C7B6E616D653A224173736F63696174696F6E446972656374696F6E222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A224F6E65227D2C7B6E616D653A22426F746822';
wwv_flow_imp.g_varchar2_table(1675) := '7D5D7D2C7B6E616D653A224D756C7469496E7374616E63654265686176696F72222C6C69746572616C56616C7565733A5B7B6E616D653A224E6F6E65227D2C7B6E616D653A224F6E65227D2C7B6E616D653A22416C6C227D2C7B6E616D653A22436F6D70';
wwv_flow_imp.g_varchar2_table(1676) := '6C6578227D5D7D2C7B6E616D653A224164486F634F72646572696E67222C6C69746572616C56616C7565733A5B7B6E616D653A22506172616C6C656C227D2C7B6E616D653A2253657175656E7469616C227D5D7D5D2C786D6C3A7B746167416C6961733A';
wwv_flow_imp.g_varchar2_table(1677) := '226C6F77657243617365222C747970655072656669783A2274227D7D2C62706D6E64693A7B6E616D653A2242504D4E4449222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F4449222C7072';
wwv_flow_imp.g_varchar2_table(1678) := '656669783A2262706D6E6469222C74797065733A5B7B6E616D653A2242504D4E4469616772616D222C70726F706572746965733A5B7B6E616D653A22706C616E65222C747970653A2242504D4E506C616E65222C7265646566696E65733A2264693A4469';
wwv_flow_imp.g_varchar2_table(1679) := '616772616D23726F6F74456C656D656E74227D2C7B6E616D653A226C6162656C5374796C65222C747970653A2242504D4E4C6162656C5374796C65222C69734D616E793A21307D5D2C7375706572436C6173733A5B2264693A4469616772616D225D7D2C';
wwv_flow_imp.g_varchar2_table(1680) := '7B6E616D653A2242504D4E506C616E65222C70726F706572746965733A5B7B6E616D653A2262706D6E456C656D656E74222C6973417474723A21302C69735265666572656E63653A21302C747970653A2262706D6E3A42617365456C656D656E74222C72';
wwv_flow_imp.g_varchar2_table(1681) := '65646566696E65733A2264693A4469616772616D456C656D656E74236D6F64656C456C656D656E74227D5D2C7375706572436C6173733A5B2264693A506C616E65225D7D2C7B6E616D653A2242504D4E5368617065222C70726F706572746965733A5B7B';
wwv_flow_imp.g_varchar2_table(1682) := '6E616D653A2262706D6E456C656D656E74222C6973417474723A21302C69735265666572656E63653A21302C747970653A2262706D6E3A42617365456C656D656E74222C7265646566696E65733A2264693A4469616772616D456C656D656E74236D6F64';
wwv_flow_imp.g_varchar2_table(1683) := '656C456C656D656E74227D2C7B6E616D653A226973486F72697A6F6E74616C222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226973457870616E646564222C6973417474723A21302C747970653A22426F6F6C6561';
wwv_flow_imp.g_varchar2_table(1684) := '6E227D2C7B6E616D653A2269734D61726B657256697369626C65222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A226C6162656C222C747970653A2242504D4E4C6162656C227D2C7B6E616D653A2269734D65737361';
wwv_flow_imp.g_varchar2_table(1685) := '676556697369626C65222C6973417474723A21302C747970653A22426F6F6C65616E227D2C7B6E616D653A227061727469636970616E7442616E644B696E64222C747970653A225061727469636970616E7442616E644B696E64222C6973417474723A21';
wwv_flow_imp.g_varchar2_table(1686) := '307D2C7B6E616D653A2263686F72656F67726170687941637469766974795368617065222C747970653A2242504D4E5368617065222C6973417474723A21302C69735265666572656E63653A21307D5D2C7375706572436C6173733A5B2264693A4C6162';
wwv_flow_imp.g_varchar2_table(1687) := '656C65645368617065225D7D2C7B6E616D653A2242504D4E45646765222C70726F706572746965733A5B7B6E616D653A226C6162656C222C747970653A2242504D4E4C6162656C227D2C7B6E616D653A2262706D6E456C656D656E74222C697341747472';
wwv_flow_imp.g_varchar2_table(1688) := '3A21302C69735265666572656E63653A21302C747970653A2262706D6E3A42617365456C656D656E74222C7265646566696E65733A2264693A4469616772616D456C656D656E74236D6F64656C456C656D656E74227D2C7B6E616D653A22736F75726365';
wwv_flow_imp.g_varchar2_table(1689) := '456C656D656E74222C6973417474723A21302C69735265666572656E63653A21302C747970653A2264693A4469616772616D456C656D656E74222C7265646566696E65733A2264693A4564676523736F75726365227D2C7B6E616D653A22746172676574';
wwv_flow_imp.g_varchar2_table(1690) := '456C656D656E74222C6973417474723A21302C69735265666572656E63653A21302C747970653A2264693A4469616772616D456C656D656E74222C7265646566696E65733A2264693A4564676523746172676574227D2C7B6E616D653A226D6573736167';
wwv_flow_imp.g_varchar2_table(1691) := '6556697369626C654B696E64222C747970653A224D65737361676556697369626C654B696E64222C6973417474723A21302C64656661756C743A22696E6974696174696E67227D5D2C7375706572436C6173733A5B2264693A4C6162656C656445646765';
wwv_flow_imp.g_varchar2_table(1692) := '225D7D2C7B6E616D653A2242504D4E4C6162656C222C70726F706572746965733A5B7B6E616D653A226C6162656C5374796C65222C747970653A2242504D4E4C6162656C5374796C65222C6973417474723A21302C69735265666572656E63653A21302C';
wwv_flow_imp.g_varchar2_table(1693) := '7265646566696E65733A2264693A4469616772616D456C656D656E74237374796C65227D5D2C7375706572436C6173733A5B2264693A4C6162656C225D7D2C7B6E616D653A2242504D4E4C6162656C5374796C65222C70726F706572746965733A5B7B6E';
wwv_flow_imp.g_varchar2_table(1694) := '616D653A22666F6E74222C747970653A2264633A466F6E74227D5D2C7375706572436C6173733A5B2264693A5374796C65225D7D5D2C656E756D65726174696F6E733A5B7B6E616D653A225061727469636970616E7442616E644B696E64222C6C697465';
wwv_flow_imp.g_varchar2_table(1695) := '72616C56616C7565733A5B7B6E616D653A22746F705F696E6974696174696E67227D2C7B6E616D653A226D6964646C655F696E6974696174696E67227D2C7B6E616D653A22626F74746F6D5F696E6974696174696E67227D2C7B6E616D653A22746F705F';
wwv_flow_imp.g_varchar2_table(1696) := '6E6F6E5F696E6974696174696E67227D2C7B6E616D653A226D6964646C655F6E6F6E5F696E6974696174696E67227D2C7B6E616D653A22626F74746F6D5F6E6F6E5F696E6974696174696E67227D5D7D2C7B6E616D653A224D6573736167655669736962';
wwv_flow_imp.g_varchar2_table(1697) := '6C654B696E64222C6C69746572616C56616C7565733A5B7B6E616D653A22696E6974696174696E67227D2C7B6E616D653A226E6F6E5F696E6974696174696E67227D5D7D5D2C6173736F63696174696F6E733A5B5D7D2C64633A7B6E616D653A22444322';
wwv_flow_imp.g_varchar2_table(1698) := '2C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F44442F32303130303532342F4443222C7072656669783A226463222C74797065733A5B7B6E616D653A22426F6F6C65616E227D2C7B6E616D653A22496E7465676572227D2C7B';
wwv_flow_imp.g_varchar2_table(1699) := '6E616D653A225265616C227D2C7B6E616D653A22537472696E67227D2C7B6E616D653A22466F6E74222C70726F706572746965733A5B7B6E616D653A226E616D65222C747970653A22537472696E67222C6973417474723A21307D2C7B6E616D653A2273';
wwv_flow_imp.g_varchar2_table(1700) := '697A65222C747970653A225265616C222C6973417474723A21307D2C7B6E616D653A226973426F6C64222C747970653A22426F6F6C65616E222C6973417474723A21307D2C7B6E616D653A2269734974616C6963222C747970653A22426F6F6C65616E22';
wwv_flow_imp.g_varchar2_table(1701) := '2C6973417474723A21307D2C7B6E616D653A226973556E6465726C696E65222C747970653A22426F6F6C65616E222C6973417474723A21307D2C7B6E616D653A226973537472696B655468726F756768222C747970653A22426F6F6C65616E222C697341';
wwv_flow_imp.g_varchar2_table(1702) := '7474723A21307D5D7D2C7B6E616D653A22506F696E74222C70726F706572746965733A5B7B6E616D653A2278222C747970653A225265616C222C64656661756C743A2230222C6973417474723A21307D2C7B6E616D653A2279222C747970653A22526561';
wwv_flow_imp.g_varchar2_table(1703) := '6C222C64656661756C743A2230222C6973417474723A21307D5D7D2C7B6E616D653A22426F756E6473222C70726F706572746965733A5B7B6E616D653A2278222C747970653A225265616C222C64656661756C743A2230222C6973417474723A21307D2C';
wwv_flow_imp.g_varchar2_table(1704) := '7B6E616D653A2279222C747970653A225265616C222C64656661756C743A2230222C6973417474723A21307D2C7B6E616D653A227769647468222C747970653A225265616C222C6973417474723A21307D2C7B6E616D653A22686569676874222C747970';
wwv_flow_imp.g_varchar2_table(1705) := '653A225265616C222C6973417474723A21307D5D7D5D2C6173736F63696174696F6E733A5B5D7D2C64693A7B6E616D653A224449222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F44442F32303130303532342F4449222C70';
wwv_flow_imp.g_varchar2_table(1706) := '72656669783A226469222C74797065733A5B7B6E616D653A224469616772616D456C656D656E74222C697341627374726163743A21302C70726F706572746965733A5B7B6E616D653A226964222C6973417474723A21302C697349643A21302C74797065';
wwv_flow_imp.g_varchar2_table(1707) := '3A22537472696E67227D2C7B6E616D653A22657874656E73696F6E222C747970653A22457874656E73696F6E227D2C7B6E616D653A226F776E696E674469616772616D222C747970653A224469616772616D222C6973526561644F6E6C793A21302C6973';
wwv_flow_imp.g_varchar2_table(1708) := '5669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A226F776E696E67456C656D656E74222C747970653A224469616772616D456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A21302C6973';
wwv_flow_imp.g_varchar2_table(1709) := '5265666572656E63653A21307D2C7B6E616D653A226D6F64656C456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A21302C69735265666572656E63653A21302C747970653A22456C656D656E74227D2C7B6E616D653A22';
wwv_flow_imp.g_varchar2_table(1710) := '7374796C65222C747970653A225374796C65222C6973526561644F6E6C793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A226F776E6564456C656D656E74222C747970653A224469616772616D456C65';
wwv_flow_imp.g_varchar2_table(1711) := '6D656E74222C6973526561644F6E6C793A21302C69734D616E793A21302C69735669727475616C3A21307D5D7D2C7B6E616D653A224E6F6465222C697341627374726163743A21302C7375706572436C6173733A5B224469616772616D456C656D656E74';
wwv_flow_imp.g_varchar2_table(1712) := '225D7D2C7B6E616D653A2245646765222C697341627374726163743A21302C7375706572436C6173733A5B224469616772616D456C656D656E74225D2C70726F706572746965733A5B7B6E616D653A22736F75726365222C747970653A22446961677261';
wwv_flow_imp.g_varchar2_table(1713) := '6D456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A22746172676574222C747970653A224469616772616D456C656D656E74222C6973526561644F6E6C79';
wwv_flow_imp.g_varchar2_table(1714) := '3A21302C69735669727475616C3A21302C69735265666572656E63653A21307D2C7B6E616D653A22776179706F696E74222C6973556E697175653A21312C69734D616E793A21302C747970653A2264633A506F696E74222C786D6C3A7B73657269616C69';
wwv_flow_imp.g_varchar2_table(1715) := '7A653A227873693A74797065227D7D5D7D2C7B6E616D653A224469616772616D222C697341627374726163743A21302C70726F706572746965733A5B7B6E616D653A226964222C6973417474723A21302C697349643A21302C747970653A22537472696E';
wwv_flow_imp.g_varchar2_table(1716) := '67227D2C7B6E616D653A22726F6F74456C656D656E74222C747970653A224469616772616D456C656D656E74222C6973526561644F6E6C793A21302C69735669727475616C3A21307D2C7B6E616D653A226E616D65222C6973417474723A21302C747970';
wwv_flow_imp.g_varchar2_table(1717) := '653A22537472696E67227D2C7B6E616D653A22646F63756D656E746174696F6E222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A227265736F6C7574696F6E222C6973417474723A21302C747970653A225265616C227D';
wwv_flow_imp.g_varchar2_table(1718) := '2C7B6E616D653A226F776E65645374796C65222C747970653A225374796C65222C6973526561644F6E6C793A21302C69734D616E793A21302C69735669727475616C3A21307D5D7D2C7B6E616D653A225368617065222C697341627374726163743A2130';
wwv_flow_imp.g_varchar2_table(1719) := '2C7375706572436C6173733A5B224E6F6465225D2C70726F706572746965733A5B7B6E616D653A22626F756E6473222C747970653A2264633A426F756E6473227D5D7D2C7B6E616D653A22506C616E65222C697341627374726163743A21302C73757065';
wwv_flow_imp.g_varchar2_table(1720) := '72436C6173733A5B224E6F6465225D2C70726F706572746965733A5B7B6E616D653A22706C616E65456C656D656E74222C747970653A224469616772616D456C656D656E74222C73756273657474656450726F70657274793A224469616772616D456C65';
wwv_flow_imp.g_varchar2_table(1721) := '6D656E742D6F776E6564456C656D656E74222C69734D616E793A21307D5D7D2C7B6E616D653A224C6162656C656445646765222C697341627374726163743A21302C7375706572436C6173733A5B2245646765225D2C70726F706572746965733A5B7B6E';
wwv_flow_imp.g_varchar2_table(1722) := '616D653A226F776E65644C6162656C222C747970653A224C6162656C222C6973526561644F6E6C793A21302C73756273657474656450726F70657274793A224469616772616D456C656D656E742D6F776E6564456C656D656E74222C69734D616E793A21';
wwv_flow_imp.g_varchar2_table(1723) := '302C69735669727475616C3A21307D5D7D2C7B6E616D653A224C6162656C65645368617065222C697341627374726163743A21302C7375706572436C6173733A5B225368617065225D2C70726F706572746965733A5B7B6E616D653A226F776E65644C61';
wwv_flow_imp.g_varchar2_table(1724) := '62656C222C747970653A224C6162656C222C6973526561644F6E6C793A21302C73756273657474656450726F70657274793A224469616772616D456C656D656E742D6F776E6564456C656D656E74222C69734D616E793A21302C69735669727475616C3A';
wwv_flow_imp.g_varchar2_table(1725) := '21307D5D7D2C7B6E616D653A224C6162656C222C697341627374726163743A21302C7375706572436C6173733A5B224E6F6465225D2C70726F706572746965733A5B7B6E616D653A22626F756E6473222C747970653A2264633A426F756E6473227D5D7D';
wwv_flow_imp.g_varchar2_table(1726) := '2C7B6E616D653A225374796C65222C697341627374726163743A21302C70726F706572746965733A5B7B6E616D653A226964222C6973417474723A21302C697349643A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22457874656E73';
wwv_flow_imp.g_varchar2_table(1727) := '696F6E222C70726F706572746965733A5B7B6E616D653A2276616C756573222C69734D616E793A21302C747970653A22456C656D656E74227D5D7D5D2C6173736F63696174696F6E733A5B5D2C786D6C3A7B746167416C6961733A226C6F776572436173';
wwv_flow_imp.g_varchar2_table(1728) := '65227D7D2C62696F633A7B6E616D653A2262706D6E2E696F20636F6C6F727320666F722042504D4E222C7572693A22687474703A2F2F62706D6E2E696F2F736368656D612F62706D6E2F62696F636F6C6F722F312E30222C7072656669783A2262696F63';
wwv_flow_imp.g_varchar2_table(1729) := '222C74797065733A5B7B6E616D653A22436F6C6F7265645368617065222C657874656E64733A5B2262706D6E64693A42504D4E5368617065225D2C70726F706572746965733A5B7B6E616D653A227374726F6B65222C6973417474723A21302C74797065';
wwv_flow_imp.g_varchar2_table(1730) := '3A22537472696E67227D2C7B6E616D653A2266696C6C222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6C6F72656445646765222C657874656E64733A5B2262706D6E64693A42504D4E45646765225D2C70';
wwv_flow_imp.g_varchar2_table(1731) := '726F706572746965733A5B7B6E616D653A227374726F6B65222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A2266696C6C222C6973417474723A21302C747970653A22537472696E67227D5D7D5D2C656E756D65726174';
wwv_flow_imp.g_varchar2_table(1732) := '696F6E733A5B5D2C6173736F63696174696F6E733A5B5D7D2C636F6C6F723A7B6E616D653A2242504D4E20696E20436F6C6F72222C7572693A22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F6E6F6E2D6E6F726D6174697665';
wwv_flow_imp.g_varchar2_table(1733) := '2F636F6C6F722F312E30222C7072656669783A22636F6C6F72222C74797065733A5B7B6E616D653A22436F6C6F7265644C6162656C222C657874656E64733A5B2262706D6E64693A42504D4E4C6162656C225D2C70726F706572746965733A5B7B6E616D';
wwv_flow_imp.g_varchar2_table(1734) := '653A22636F6C6F72222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E616D653A22436F6C6F7265645368617065222C657874656E64733A5B2262706D6E64693A42504D4E5368617065225D2C70726F706572746965733A5B7B';
wwv_flow_imp.g_varchar2_table(1735) := '6E616D653A226261636B67726F756E642D636F6C6F72222C6973417474723A21302C747970653A22537472696E67227D2C7B6E616D653A22626F726465722D636F6C6F72222C6973417474723A21302C747970653A22537472696E67227D5D7D2C7B6E61';
wwv_flow_imp.g_varchar2_table(1736) := '6D653A22436F6C6F72656445646765222C657874656E64733A5B2262706D6E64693A42504D4E45646765225D2C70726F706572746965733A5B7B6E616D653A22626F726465722D636F6C6F72222C6973417474723A21302C747970653A22537472696E67';
wwv_flow_imp.g_varchar2_table(1737) := '227D5D7D5D2C656E756D65726174696F6E733A5B5D2C6173736F63696174696F6E733A5B5D7D7D3B66756E6374696F6E20547228652C74297B72657475726E206E65772042722853287B7D2C4F722C65292C74297D766172204E723D2254726965642074';
wwv_flow_imp.g_varchar2_table(1738) := '6F206163636573732064692066726F6D2074686520627573696E6573734F626A6563742E2054686520646920697320617661696C61626C65207468726F75676820746865206469616772616D20656C656D656E74206F6E6C792E20466F72206D6F726520';
wwv_flow_imp.g_varchar2_table(1739) := '696E666F726D6174696F6E2C207365652068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F62706D6E2D6A732F6973737565732F31343732223B66756E6374696F6E20497228652C74297B72657475726E20652E24696E7374616E6365';
wwv_flow_imp.g_varchar2_table(1740) := '4F662874297D66756E6374696F6E204C722865297B76617220743D7B7D2C6E3D5B5D2C693D7B7D3B66756E6374696F6E207228652C74297B72657475726E2066756E6374696F6E286E297B65286E2C74297D7D66756E6374696F6E206F2865297B745B65';
wwv_flow_imp.g_varchar2_table(1741) := '2E69645D3D657D66756E6374696F6E206128742C6E297B7472797B76617220723D695B742E69645D262666756E6374696F6E28742C6E297B696628742E676678297468726F77206E6577204572726F722860616C72656164792072656E64657265642024';
wwv_flow_imp.g_varchar2_table(1742) := '7B4D742874297D60293B72657475726E20652E656C656D656E7428742C695B742E69645D2C6E297D28742C6E293B72657475726E206F2874292C727D63617463682865297B7328652E6D6573736167652C7B656C656D656E743A742C6572726F723A657D';
wwv_flow_imp.g_varchar2_table(1743) := '292C636F6E736F6C652E6572726F7228606661696C656420746F20696D706F727420247B4D742874297D602C65297D7D66756E6374696F6E207328742C6E297B652E6572726F7228742C6E297D766172206C3D746869732E726567697374657244693D66';
wwv_flow_imp.g_varchar2_table(1744) := '756E6374696F6E2865297B76617220742C6E3D652E62706D6E456C656D656E743B6E3F695B6E2E69645D3F7328606D756C7469706C6520444920656C656D656E747320646566696E656420666F7220247B4D74286E297D602C7B656C656D656E743A6E7D';
wwv_flow_imp.g_varchar2_table(1745) := '293A28695B6E2E69645D3D652C6828743D6E2C22646922297C7C4F626A6563742E646566696E6550726F706572747928742C226469222C7B656E756D657261626C653A21312C6765743A66756E6374696F6E28297B7468726F77206E6577204572726F72';
wwv_flow_imp.g_varchar2_table(1746) := '284E72297D7D29293A7328606E6F2062706D6E456C656D656E74207265666572656E63656420696E20247B4D742865297D602C7B656C656D656E743A657D297D3B66756E6374696F6E20632865297B6C2865297D746869732E68616E646C65446566696E';
wwv_flow_imp.g_varchar2_table(1747) := '6974696F6E733D66756E6374696F6E286F2C61297B76617220683D6F2E6469616772616D733B6966286126262D313D3D3D682E696E6465784F66286129297468726F77206E6577204572726F7228226469616772616D206E6F742070617274206F66203C';
wwv_flow_imp.g_varchar2_table(1748) := '62706D6E3A446566696E6974696F6E73202F3E22293B69662821612626682626682E6C656E677468262628613D685B305D292C2161297468726F77206E6577204572726F7228226E6F206469616772616D20746F20646973706C617922293B693D7B7D2C';
wwv_flow_imp.g_varchar2_table(1749) := '66756E6374696F6E2865297B76617220743B743D652E706C616E652C6C2874292C6628742E706C616E65456C656D656E742C63297D2861293B76617220673D612E706C616E653B6966282167297468726F77206E6577204572726F7228606E6F20706C61';
wwv_flow_imp.g_varchar2_table(1750) := '6E6520666F7220247B4D742861297D60293B76617220763D672E62706D6E456C656D656E743B6966282176297B696628763D66756E6374696F6E2865297B72657475726E206428652E726F6F74456C656D656E74732C2866756E6374696F6E2865297B72';
wwv_flow_imp.g_varchar2_table(1751) := '657475726E20497228652C2262706D6E3A50726F6365737322297C7C497228652C2262706D6E3A436F6C6C61626F726174696F6E22297D29297D286F292C2176297468726F77206E6577204572726F7228226E6F2070726F63657373206F7220636F6C6C';
wwv_flow_imp.g_varchar2_table(1752) := '61626F726174696F6E20746F20646973706C617922293B732860636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E20247B4D742867297D20746F20247B4D742876297D60292C672E62706D6E456C656D656E743D762C6C';
wwv_flow_imp.g_varchar2_table(1753) := '2867297D76617220622C782C5F3D66756E6374696F6E28742C6E297B72657475726E20652E726F6F7428742C695B742E69645D2C6E297D28762C67293B696628497228762C2262706D6E3A50726F6365737322297C7C497228762C2262706D6E3A537562';
wwv_flow_imp.g_varchar2_table(1754) := '50726F636573732229297528762C5F293B656C73657B69662821497228762C2262706D6E3A436F6C6C61626F726174696F6E2229297468726F77206E6577204572726F722860756E737570706F727465642062706D6E456C656D656E7420666F7220247B';
wwv_flow_imp.g_varchar2_table(1755) := '4D742867297D3A20247B4D742876297D60293B783D5F2C662828623D76292E7061727469636970616E74732C7228522C7829292C7728622E6172746966616374732C78292C6E2E70757368282866756E6374696F6E28297B2166756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(1756) := '74297B6628652C7228792C7429297D28622E6D657373616765466C6F77732C78297D29292C66756E6374696F6E28652C6E297B76617220693D6D28652C2866756E6374696F6E2865297B72657475726E21745B652E69645D2626497228652C2262706D6E';
wwv_flow_imp.g_varchar2_table(1757) := '3A50726F6365737322292626652E6C616E65536574737D29293B692E666F7245616368287228752C6E29297D286F2E726F6F74456C656D656E74732C5F297D70286E297D3B76617220703D746869732E68616E646C6544656665727265643D66756E6374';
wwv_flow_imp.g_varchar2_table(1758) := '696F6E28297B666F72283B6E2E6C656E6774683B296E2E7368696674282928297D3B66756E6374696F6E207528652C74297B6B28652C74292C5F28652E696F53706563696669636174696F6E2C74292C7728652E6172746966616374732C74292C6F2865';
wwv_flow_imp.g_varchar2_table(1759) := '297D66756E6374696F6E207928652C74297B6128652C74297D66756E6374696F6E206728652C74297B6128652C74297D66756E6374696F6E207628652C74297B6128652C74297D66756E6374696F6E206228652C74297B6128652C74297D66756E637469';
wwv_flow_imp.g_varchar2_table(1760) := '6F6E207828652C74297B6128652C74297D66756E6374696F6E207728652C74297B6628652C2866756E6374696F6E2865297B497228652C2262706D6E3A4173736F63696174696F6E22293F6E2E70757368282866756E6374696F6E28297B7828652C7429';
wwv_flow_imp.g_varchar2_table(1761) := '7D29293A7828652C74297D29297D66756E6374696F6E205F28652C74297B652626286628652E64617461496E707574732C7228762C7429292C6628652E646174614F7574707574732C7228622C742929297D76617220453D746869732E68616E646C6553';
wwv_flow_imp.g_varchar2_table(1762) := '756250726F636573733D66756E6374696F6E28652C74297B6B28652C74292C7728652E6172746966616374732C74297D3B66756E6374696F6E205328652C74297B76617220693D6128652C74293B497228652C2262706D6E3A53756250726F6365737322';
wwv_flow_imp.g_varchar2_table(1763) := '2926264528652C697C7C74292C497228652C2262706D6E3A4163746976697479222926265F28652E696F53706563696669636174696F6E2C74292C6E2E70757368282866756E6374696F6E28297B6628652E64617461496E7075744173736F6369617469';
wwv_flow_imp.g_varchar2_table(1764) := '6F6E732C7228672C7429292C6628652E646174614F75747075744173736F63696174696F6E732C7228672C7429297D29297D66756E6374696F6E204128652C74297B6E2E70757368282866756E6374696F6E28297B766172206E3D6128652C74293B652E';
wwv_flow_imp.g_varchar2_table(1765) := '6368696C644C616E6553657426264328652E6368696C644C616E655365742C6E7C7C74292C66756E6374696F6E2865297B6628652E666C6F774E6F64655265662C2866756E6374696F6E2874297B766172206E3D742E67657428226C616E657322293B6E';
wwv_flow_imp.g_varchar2_table(1766) := '26266E2E707573682865297D29297D2865297D29297D66756E6374696F6E204328652C74297B6628652E6C616E65732C7228412C7429297D66756E6374696F6E206B28652C74297B2166756E6374696F6E28652C74297B6628652C2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1767) := '2865297B497228652C2262706D6E3A53657175656E6365466C6F7722293F6E2E70757368282866756E6374696F6E28297B2166756E6374696F6E28652C74297B6128652C74297D28652C74297D29293A497228652C2262706D6E3A426F756E6461727945';
wwv_flow_imp.g_varchar2_table(1768) := '76656E7422293F6E2E756E7368696674282866756E6374696F6E28297B5328652C74297D29293A497228652C2262706D6E3A466C6F774E6F646522293F5328652C74293A497228652C2262706D6E3A446174614F626A65637422297C7C28497228652C22';
wwv_flow_imp.g_varchar2_table(1769) := '62706D6E3A4461746153746F72655265666572656E636522297C7C497228652C2262706D6E3A446174614F626A6563745265666572656E636522293F66756E6374696F6E28652C74297B6128652C74297D28652C74293A732860756E7265636F676E697A';
wwv_flow_imp.g_varchar2_table(1770) := '656420666C6F77456C656D656E7420247B4D742865297D20696E20636F6E7465787420247B4D7428742626742E627573696E6573734F626A656374297D602C7B656C656D656E743A652C636F6E746578743A747D29297D29297D28652E666C6F77456C65';
wwv_flow_imp.g_varchar2_table(1771) := '6D656E74732C74292C652E6C616E6553657473262666756E6374696F6E28652C74297B6628652C7228432C7429297D28652E6C616E65536574732C74297D66756E6374696F6E205228652C74297B766172206E3D6128652C74292C693D652E70726F6365';
wwv_flow_imp.g_varchar2_table(1772) := '73735265663B6926267528692C6E7C7C74297D7D66756E6374696F6E206A7228652C742C6E297B76617220692C722C6F2C613D5B5D3B66756E6374696F6E207328652C74297B766172206E3D6E6577204C72287B726F6F743A66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(1773) := '74297B72657475726E20692E61646428652C74297D2C656C656D656E743A66756E6374696F6E28652C742C6E297B72657475726E20692E61646428652C742C6E297D2C6572726F723A66756E6374696F6E28652C74297B612E70757368287B6D65737361';
wwv_flow_imp.g_varchar2_table(1774) := '67653A652C636F6E746578743A747D297D7D293B743D747C7C652E6469616772616D732626652E6469616772616D735B305D3B76617220723D66756E6374696F6E28652C74297B696628742626742E706C616E65297B766172206E2C693D742E706C616E';
wwv_flow_imp.g_varchar2_table(1775) := '652E62706D6E456C656D656E742C723D693B6B28692C2262706D6E3A50726F6365737322297C7C6B28692C2262706D6E3A436F6C6C61626F726174696F6E22297C7C28723D66756E6374696F6E2865297B666F722876617220743D653B743B297B696628';
wwv_flow_imp.g_varchar2_table(1776) := '6B28742C2262706D6E3A50726F6365737322292972657475726E20743B743D742E24706172656E747D7D286929292C6E3D6B28722C2262706D6E3A436F6C6C61626F726174696F6E22293F723A6428652E726F6F74456C656D656E74732C2866756E6374';
wwv_flow_imp.g_varchar2_table(1777) := '696F6E2865297B6966286B28652C2262706D6E3A436F6C6C61626F726174696F6E22292972657475726E206428652E7061727469636970616E74732C2866756E6374696F6E2865297B72657475726E20652E70726F636573735265663D3D3D727D29297D';
wwv_flow_imp.g_varchar2_table(1778) := '29293B766172206F3D5B725D3B6E2626286F3D66756E6374696F6E28652C74297B6C6574206E3D5B5D3B72657475726E206628652C2866756E6374696F6E28652C69297B6E2E70757368287428652C6929297D29292C6E7D286E2E706172746963697061';
wwv_flow_imp.g_varchar2_table(1779) := '6E74732C2866756E6374696F6E2865297B72657475726E20652E70726F636573735265667D2929292E70757368286E293B76617220613D4672286F292C733D5B745D2C6C3D5B695D3B72657475726E206628652E6469616772616D732C2866756E637469';
wwv_flow_imp.g_varchar2_table(1780) := '6F6E2865297B696628652E706C616E65297B76617220743D652E706C616E652E62706D6E456C656D656E743B2D31213D3D612E696E6465784F6628742926262D313D3D3D6C2E696E6465784F66287429262628732E707573682865292C6C2E7075736828';
wwv_flow_imp.g_varchar2_table(1781) := '7429297D7D29292C737D7D28652C74293B6966282172297468726F77206E6577204572726F7228226E6F206469616772616D20746F20646973706C617922293B6628722C2866756E6374696F6E2874297B6E2E68616E646C65446566696E6974696F6E73';
wwv_flow_imp.g_varchar2_table(1782) := '28652C74297D29293B76617220733D742E706C616E652E62706D6E456C656D656E742E69643B6F2E736574526F6F74456C656D656E74286F2E66696E64526F6F7428732B225F706C616E6522297C7C6F2E66696E64526F6F74287329297D72657475726E';
wwv_flow_imp.g_varchar2_table(1783) := '206E65772050726F6D697365282866756E6374696F6E286C2C63297B7472797B72657475726E20693D652E676574282262706D6E496D706F7274657222292C723D652E67657428226576656E7442757322292C6F3D652E676574282263616E7661732229';
wwv_flow_imp.g_varchar2_table(1784) := '2C722E666972652822696D706F72742E72656E6465722E7374617274222C7B646566696E6974696F6E733A747D292C7328742C6E292C722E666972652822696D706F72742E72656E6465722E636F6D706C657465222C7B6572726F723A766F696420302C';
wwv_flow_imp.g_varchar2_table(1785) := '7761726E696E67733A617D292C6C287B7761726E696E67733A617D297D63617463682865297B72657475726E20652E7761726E696E67733D612C632865297D7D29297D66756E6374696F6E2046722865297B76617220743D5B5D3B72657475726E206628';
wwv_flow_imp.g_varchar2_table(1786) := '652C2866756E6374696F6E2865297B65262628742E707573682865292C743D742E636F6E63617428467228652E666C6F77456C656D656E74732929297D29292C747D7661722056722C24723D273C73766720786D6C6E733D22687474703A2F2F7777772E';
wwv_flow_imp.g_varchar2_table(1787) := '77332E6F72672F323030302F737667222076696577426F783D223020302031342E303220352E3537222077696474683D22353322206865696768743D223231223E3C706174682066696C6C3D2263757272656E74436F6C6F722220643D224D312E38382E';
wwv_flow_imp.g_varchar2_table(1788) := '3932762E31346330202E34312D2E31332E36382D2E342E382E33332E31342E34362E34342E34362E3836762E33336330202E36312D2E33332E39352D2E39352E393548305630682E3935632E36352030202E39332E332E39332E39327A4D2E36332E3537';
wwv_flow_imp.g_varchar2_table(1789) := '76312E3036682E3234632E32342030202E33382D2E312E33382D2E3433562E393863302D2E32382D2E312D2E342D2E33322D2E347A6D3020312E363376312E3232682E3336632E322030202E33322D2E312E33322D2E3339762D2E333563302D2E33372D';
wwv_flow_imp.g_varchar2_table(1790) := '2E31322D2E34382D2E342D2E3438482E36337A4D342E31382E3939762E35326330202E36342D2E33312E39382D2E39342E3938682D2E335634682D2E36325630682E3932632E36332030202E39342E33352E39342E39397A4D322E39342E353776312E33';
wwv_flow_imp.g_varchar2_table(1791) := '35682E33632E322030202E332D2E30392E332D2E3337762D2E3663302D2E32392D2E312D2E33382D2E332D2E3338682D2E337A6D322E383920322E32374C362E32352030682E38387634682D2E3656312E31324C362E3120332E3939682D2E366C2D2E34';
wwv_flow_imp.g_varchar2_table(1792) := '362D322E383276322E3832682D2E35355630682E38377A4D382E313420312E315634682D2E35365630682E37394C3920322E345630682E35367634682D2E36347A6D322E343920322E3239762E36682D2E36762D2E367A4D31322E3132203163302D2E36';
wwv_flow_imp.g_varchar2_table(1793) := '332E33332D31202E39352D31202E36312030202E39352E33372E3935203176322E30346330202E36342D2E333420312D2E393520312D2E363220302D2E39352D2E33372D2E39352D317A6D2E363220322E30386330202E32382E31332E33392E33332E33';
wwv_flow_imp.g_varchar2_table(1794) := '39732E33322D2E312E33322D2E34562E393863302D2E32392D2E31322D2E342D2E33322D2E34732D2E33332E31312D2E33332E347A222F3E3C706174682066696C6C3D2263757272656E74436F6C6F722220643D224D3020342E35336831342E30327631';
wwv_flow_imp.g_varchar2_table(1795) := '2E303448307A4D31312E30382030682E3633762E3632682D2E36337A6D2E363320345631682D2E363376322E39387A222F3E3C2F7376673E272C7A723D7B766572746963616C416C69676E3A226D6964646C65227D2C57723D7B636F6C6F723A22233430';
wwv_flow_imp.g_varchar2_table(1796) := '34303430227D2C47723D7B7A496E6465783A2231303031222C706F736974696F6E3A226669786564222C746F703A2230222C6C6566743A2230222C72696768743A2230222C626F74746F6D3A2230227D2C48723D7B77696474683A2231303025222C6865';
wwv_flow_imp.g_varchar2_table(1797) := '696768743A2231303025222C6261636B67726F756E643A22726762612834302C34302C34302C302E3229227D2C4B723D7B706F736974696F6E3A226162736F6C757465222C6C6566743A22353025222C746F703A22343025222C7472616E73666F726D3A';
wwv_flow_imp.g_varchar2_table(1798) := '227472616E736C617465282D35302529222C77696474683A223236307078222C70616464696E673A2231307078222C6261636B67726F756E643A227768697465222C626F78536861646F773A22302031707820347078207267626128302C302C302C302E';
wwv_flow_imp.g_varchar2_table(1799) := '3329222C666F6E7446616D696C793A2248656C7665746963612C20417269616C2C2073616E732D7365726966222C666F6E7453697A653A2231347078222C646973706C61793A22666C6578222C6C696E654865696768743A22312E33227D2C55723D273C';
wwv_flow_imp.g_varchar2_table(1800) := '64697620636C6173733D22626A732D706F77657265642D62792D6C69676874626F78223E3C64697620636C6173733D226261636B64726F70223E3C2F6469763E3C64697620636C6173733D226E6F74696365223E3C6120687265663D2268747470733A2F';
wwv_flow_imp.g_varchar2_table(1801) := '2F62706D6E2E696F22207461726765743D225F626C616E6B222072656C3D226E6F6F70656E65722220636C6173733D226C696E6B223E272B24722B273C2F613E3C7370616E3E5765622D626173656420746F6F6C696E6720666F722042504D4E2C20444D';
wwv_flow_imp.g_varchar2_table(1802) := '4E20616E6420666F726D7320706F7765726564206279203C6120687265663D2268747470733A2F2F62706D6E2E696F22207461726765743D225F626C616E6B222072656C3D226E6F6F70656E6572223E62706D6E2E696F3C2F613E2E3C2F7370616E3E3C';
wwv_flow_imp.g_varchar2_table(1803) := '2F6469763E3C2F6469763E273B66756E6374696F6E2071722865297B653D53287B7D2C58722C65292C746869732E5F6D6F64646C653D746869732E5F6372656174654D6F64646C652865292C746869732E5F636F6E7461696E65723D746869732E5F6372';
wwv_flow_imp.g_varchar2_table(1804) := '65617465436F6E7461696E65722865292C66756E6374696F6E2865297B636F6E737420743D516528273C6120687265663D22687474703A2F2F62706D6E2E696F22207461726765743D225F626C616E6B2220636C6173733D22626A732D706F7765726564';
wwv_flow_imp.g_varchar2_table(1805) := '2D627922207469746C653D22506F77657265642062792062706D6E2E696F22203E272B24722B223C2F613E22293B4F652865742822737667222C74292C7A72292C4F6528742C57722C7B706F736974696F6E3A226162736F6C757465222C626F74746F6D';
wwv_flow_imp.g_varchar2_table(1806) := '3A2231357078222C72696768743A2231357078222C7A496E6465783A22313030227D292C652E617070656E644368696C642874292C71652E62696E6428742C22636C69636B222C2866756E6374696F6E2865297B56727C7C284F652856723D5165285572';
wwv_flow_imp.g_varchar2_table(1807) := '292C4772292C4F652865742822737667222C5672292C7A72292C4F6528657428222E6261636B64726F70222C5672292C4872292C4F6528657428222E6E6F74696365222C5672292C4B72292C4F6528657428222E6C696E6B222C5672292C57722C7B6D61';
wwv_flow_imp.g_varchar2_table(1808) := '7267696E3A2231357078203230707820313570782031307078222C616C69676E53656C663A2263656E746572227D292C58652E62696E642856722C222E6261636B64726F70222C22636C69636B222C2866756E6374696F6E2865297B646F63756D656E74';
wwv_flow_imp.g_varchar2_table(1809) := '2E626F64792E72656D6F76654368696C64285672297D2929292C646F63756D656E742E626F64792E617070656E644368696C64285672292C652E70726576656E7444656661756C7428297D29297D28746869732E5F636F6E7461696E6572292C74686973';
wwv_flow_imp.g_varchar2_table(1810) := '2E5F696E697428746869732E5F636F6E7461696E65722C746869732E5F6D6F64646C652C65297D66756E6374696F6E20597228652C74297B72657475726E20652E7761726E696E67733D742C657D6E2871722C6269292C71722E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(1811) := '696D706F7274584D4C3D6173796E632066756E6374696F6E28652C74297B636F6E7374206E3D746869733B6C657420693D5B5D3B7472797B6C6574206F3B653D746869732E5F656D69742822696D706F72742E70617273652E7374617274222C7B786D6C';
wwv_flow_imp.g_varchar2_table(1812) := '3A657D297C7C653B7472797B6F3D617761697420746869732E5F6D6F64646C652E66726F6D584D4C28652C2262706D6E3A446566696E6974696F6E7322297D63617463682865297B7468726F7720746869732E5F656D69742822696D706F72742E706172';
wwv_flow_imp.g_varchar2_table(1813) := '73652E636F6D706C657465222C7B6572726F723A657D292C657D6C657420613D6F2E726F6F74456C656D656E743B636F6E737420733D6F2E7265666572656E6365732C6C3D6F2E7761726E696E67732C633D6F2E656C656D656E7473427949643B693D69';
wwv_flow_imp.g_varchar2_table(1814) := '2E636F6E636174286C292C613D746869732E5F656D69742822696D706F72742E70617273652E636F6D706C657465222C28723D7B6572726F723A6E756C6C2C646566696E6974696F6E733A612C656C656D656E7473427949643A632C7265666572656E63';
wwv_flow_imp.g_varchar2_table(1815) := '65733A732C7761726E696E67733A697D2C6E2E67657428226576656E7442757322292E6372656174654576656E7428722929297C7C613B636F6E737420703D617761697420746869732E696D706F7274446566696E6974696F6E7328612C74293B726574';
wwv_flow_imp.g_varchar2_table(1816) := '75726E20693D692E636F6E63617428702E7761726E696E6773292C746869732E5F656D69742822696D706F72742E646F6E65222C7B6572726F723A6E756C6C2C7761726E696E67733A697D292C7B7761726E696E67733A697D7D63617463682865297B6C';
wwv_flow_imp.g_varchar2_table(1817) := '657420743D653B7468726F7720693D692E636F6E63617428742E7761726E696E67737C7C5B5D292C597228742C69292C743D66756E6374696F6E2865297B636F6E737420743D2F756E7061727361626C6520636F6E74656E74203C285B5E3E5D2B293E20';
wwv_flow_imp.g_varchar2_table(1818) := '6465746563746564285B5C735C535D2A29242F2E6578656328652E6D657373616765293B72657475726E2074262628652E6D6573736167653D22756E7061727361626C6520636F6E74656E74203C222B745B315D2B223E2064657465637465643B207468';
wwv_flow_imp.g_varchar2_table(1819) := '6973206D617920696E64696361746520616E20696E76616C69642042504D4E20322E30206469616772616D2066696C65222B745B325D292C657D2874292C746869732E5F656D69742822696D706F72742E646F6E65222C7B6572726F723A742C7761726E';
wwv_flow_imp.g_varchar2_table(1820) := '696E67733A742E7761726E696E67737D292C747D76617220727D2C71722E70726F746F747970652E696D706F7274446566696E6974696F6E733D6173796E632066756E6374696F6E28652C74297B72657475726E20746869732E5F736574446566696E69';
wwv_flow_imp.g_varchar2_table(1821) := '74696F6E732865292C7B7761726E696E67733A28617761697420746869732E6F70656E287429292E7761726E696E67737D7D2C71722E70726F746F747970652E6F70656E3D6173796E632066756E6374696F6E2865297B636F6E737420743D746869732E';
wwv_flow_imp.g_varchar2_table(1822) := '5F646566696E6974696F6E733B6C6574206E3D653B6966282174297B636F6E737420653D6E6577204572726F7228226E6F20584D4C20696D706F7274656422293B7468726F7720597228652C5B5D292C657D69662822737472696E67223D3D747970656F';
wwv_flow_imp.g_varchar2_table(1823) := '6620652626286E3D66756E6374696F6E28652C74297B72657475726E207426266428652E6469616772616D732C2866756E6374696F6E2865297B72657475726E20652E69643D3D3D747D29297C7C6E756C6C7D28742C65292C216E29297B636F6E737420';
wwv_flow_imp.g_varchar2_table(1824) := '743D6E6577204572726F72282242504D4E4469616772616D203C222B652B223E206E6F7420666F756E6422293B7468726F7720597228742C5B5D292C747D7472797B746869732E636C65617228297D63617463682865297B7468726F7720597228652C5B';
wwv_flow_imp.g_varchar2_table(1825) := '5D292C657D636F6E73747B7761726E696E67733A697D3D6177616974206A7228746869732C742C6E293B72657475726E7B7761726E696E67733A697D7D2C71722E70726F746F747970652E73617665584D4C3D6173796E632066756E6374696F6E286529';
wwv_flow_imp.g_varchar2_table(1826) := '7B653D657C7C7B7D3B6C657420742C6E2C693D746869732E5F646566696E6974696F6E733B7472797B6966282169297468726F77206E6577204572726F7228226E6F20646566696E6974696F6E73206C6F6164656422293B693D746869732E5F656D6974';
wwv_flow_imp.g_varchar2_table(1827) := '282273617665584D4C2E7374617274222C7B646566696E6974696F6E733A697D297C7C692C6E3D28617761697420746869732E5F6D6F64646C652E746F584D4C28692C6529292E786D6C2C6E3D746869732E5F656D6974282273617665584D4C2E736572';
wwv_flow_imp.g_varchar2_table(1828) := '69616C697A6564222C7B786D6C3A6E7D297C7C6E7D63617463682865297B743D657D636F6E737420723D743F7B6572726F723A747D3A7B786D6C3A6E7D3B696628746869732E5F656D6974282273617665584D4C2E646F6E65222C72292C74297468726F';
wwv_flow_imp.g_varchar2_table(1829) := '7720743B72657475726E20727D2C71722E70726F746F747970652E736176655356473D6173796E632066756E6374696F6E28297B6C657420652C743B746869732E5F656D69742822736176655356472E737461727422293B7472797B636F6E737420743D';
wwv_flow_imp.g_varchar2_table(1830) := '746869732E676574282263616E76617322292C6E3D742E6765744163746976654C6179657228292C693D657428223A73636F7065203E2064656673222C742E5F737667292C723D6165286E292C6F3D693F223C646566733E222B61652869292B223C2F64';
wwv_flow_imp.g_varchar2_table(1831) := '6566733E223A22222C613D6E2E67657442426F7828293B653D273C3F786D6C2076657273696F6E3D22312E302220656E636F64696E673D227574662D38223F3E5C6E5C783363212D2D206372656174656420776974682062706D6E2D6A73202F20687474';
wwv_flow_imp.g_varchar2_table(1832) := '703A2F2F62706D6E2E696F202D2D5C7833655C6E3C21444F435459504520737667205055424C494320222D2F2F5733432F2F4454442053564720312E312F2F454E222022687474703A2F2F7777772E77332E6F72672F47726170686963732F5356472F31';
wwv_flow_imp.g_varchar2_table(1833) := '2E312F4454442F73766731312E647464223E5C6E3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F7376672220786D6C6E733A786C696E6B3D22687474703A2F2F7777772E77332E6F72672F313939392F786C696E';
wwv_flow_imp.g_varchar2_table(1834) := '6B222077696474683D22272B612E77696474682B2722206865696768743D22272B612E6865696768742B27222076696577426F783D22272B612E782B2220222B612E792B2220222B612E77696474682B2220222B612E6865696768742B27222076657273';
wwv_flow_imp.g_varchar2_table(1835) := '696F6E3D22312E31223E272B6F2B722B223C2F7376673E227D63617463682865297B743D657D696628746869732E5F656D69742822736176655356472E646F6E65222C7B6572726F723A742C7376673A657D292C74297468726F7720743B72657475726E';
wwv_flow_imp.g_varchar2_table(1836) := '7B7376673A657D7D2C71722E70726F746F747970652E5F736574446566696E6974696F6E733D66756E6374696F6E2865297B746869732E5F646566696E6974696F6E733D657D2C71722E70726F746F747970652E6765744D6F64756C65733D66756E6374';
wwv_flow_imp.g_varchar2_table(1837) := '696F6E28297B72657475726E20746869732E5F6D6F64756C65737D2C71722E70726F746F747970652E636C6561723D66756E6374696F6E28297B746869732E676574446566696E6974696F6E732829262662692E70726F746F747970652E636C6561722E';
wwv_flow_imp.g_varchar2_table(1838) := '63616C6C2874686973297D2C71722E70726F746F747970652E64657374726F793D66756E6374696F6E28297B62692E70726F746F747970652E64657374726F792E63616C6C2874686973292C747428746869732E5F636F6E7461696E6572297D2C71722E';
wwv_flow_imp.g_varchar2_table(1839) := '70726F746F747970652E6F6E3D66756E6374696F6E28652C742C6E2C69297B72657475726E20746869732E67657428226576656E7442757322292E6F6E28652C742C6E2C69297D2C71722E70726F746F747970652E6F66663D66756E6374696F6E28652C';
wwv_flow_imp.g_varchar2_table(1840) := '74297B746869732E67657428226576656E7442757322292E6F666628652C74297D2C71722E70726F746F747970652E617474616368546F3D66756E6374696F6E2865297B6966282165297468726F77206E6577204572726F722822706172656E744E6F64';
wwv_flow_imp.g_varchar2_table(1841) := '6520726571756972656422293B746869732E64657461636828292C652E6765742626652E636F6E7374727563746F722E70726F746F747970652E6A7175657279262628653D652E676574283029292C22737472696E67223D3D747970656F662065262628';
wwv_flow_imp.g_varchar2_table(1842) := '653D6574286529292C652E617070656E644368696C6428746869732E5F636F6E7461696E6572292C746869732E5F656D69742822617474616368222C7B7D292C746869732E676574282263616E76617322292E726573697A656428297D2C71722E70726F';
wwv_flow_imp.g_varchar2_table(1843) := '746F747970652E676574446566696E6974696F6E733D66756E6374696F6E28297B72657475726E20746869732E5F646566696E6974696F6E737D2C71722E70726F746F747970652E6465746163683D66756E6374696F6E28297B636F6E737420653D7468';
wwv_flow_imp.g_varchar2_table(1844) := '69732E5F636F6E7461696E65722C743D652E706172656E744E6F64653B74262628746869732E5F656D69742822646574616368222C7B7D292C742E72656D6F76654368696C64286529297D2C71722E70726F746F747970652E5F696E69743D66756E6374';
wwv_flow_imp.g_varchar2_table(1845) := '696F6E28652C742C6E297B636F6E737420693D6E2E6D6F64756C65737C7C746869732E6765744D6F64756C6573286E292C723D6E2E6164646974696F6E616C4D6F64756C65737C7C5B5D2C6F3D5B5D2E636F6E636174285B7B62706D6E6A733A5B227661';
wwv_flow_imp.g_varchar2_table(1846) := '6C7565222C746869735D2C6D6F64646C653A5B2276616C7565222C745D7D5D2C692C72292C613D532866756E6374696F6E28652C74297B6C6574206E3D7B7D3B72657475726E2066284F626A6563742865292C2866756E6374696F6E28652C69297B2D31';
wwv_flow_imp.g_varchar2_table(1847) := '3D3D3D742E696E6465784F662869292626286E5B695D3D65297D29292C6E7D286E2C5B226164646974696F6E616C4D6F64756C6573225D292C7B63616E7661733A53287B7D2C6E2E63616E7661732C7B636F6E7461696E65723A657D292C6D6F64756C65';
wwv_flow_imp.g_varchar2_table(1848) := '733A6F7D293B62692E63616C6C28746869732C61292C6E26266E2E636F6E7461696E65722626746869732E617474616368546F286E2E636F6E7461696E6572297D2C71722E70726F746F747970652E5F656D69743D66756E6374696F6E28652C74297B72';
wwv_flow_imp.g_varchar2_table(1849) := '657475726E20746869732E67657428226576656E7442757322292E6669726528652C74297D2C71722E70726F746F747970652E5F637265617465436F6E7461696E65723D66756E6374696F6E2865297B636F6E737420743D516528273C64697620636C61';
wwv_flow_imp.g_varchar2_table(1850) := '73733D22626A732D636F6E7461696E6572223E3C2F6469763E27293B72657475726E204F6528742C7B77696474683A5A7228652E7769647468292C6865696768743A5A7228652E686569676874292C706F736974696F6E3A652E706F736974696F6E7D29';
wwv_flow_imp.g_varchar2_table(1851) := '2C747D2C71722E70726F746F747970652E5F6372656174654D6F64646C653D66756E6374696F6E2865297B72657475726E206E65772054722853287B7D2C746869732E5F6D6F64646C65457874656E73696F6E732C652E6D6F64646C65457874656E7369';
wwv_flow_imp.g_varchar2_table(1852) := '6F6E7329297D2C71722E70726F746F747970652E5F6D6F64756C65733D5B5D3B636F6E73742058723D7B77696474683A2231303025222C6865696768743A2231303025222C706F736974696F6E3A2272656C6174697665227D3B66756E6374696F6E205A';
wwv_flow_imp.g_varchar2_table(1853) := '722865297B72657475726E20652B28632865293F227078223A2222297D66756E6374696F6E204A722865297B71722E63616C6C28746869732C65297D6E284A722C7172292C4A722E70726F746F747970652E5F6D6F64756C65733D5B54742C6C6E2C796E';
wwv_flow_imp.g_varchar2_table(1854) := '2C47742C446E2C53745D2C4A722E70726F746F747970652E5F6D6F64646C65457874656E73696F6E733D7B7D3B7661722051723D2F5E646A732D637572736F722D2E2A242F3B66756E6374696F6E20656F2865297B76617220743D496528646F63756D65';
wwv_flow_imp.g_varchar2_table(1855) := '6E742E626F6479293B742E72656D6F76654D61746368696E67285172292C652626742E6164642822646A732D637572736F722D222B65297D66756E6374696F6E20746F28652C74297B72657475726E7B783A652E782D742E782C793A652E792D742E797D';
wwv_flow_imp.g_varchar2_table(1856) := '7D66756E6374696F6E206E6F28652C74297B766172206E3B66756E6374696F6E20692869297B76617220722C6F3D6E2E73746172742C613D6E2E627574746F6E2C733D766E2869292C6C3D746F28732C6F293B216E2E6472616767696E67262628723D6C';
wwv_flow_imp.g_varchar2_table(1857) := '2C4D6174682E73717274284D6174682E706F7728722E782C32292B4D6174682E706F7728722E792C3229293E3135292626286E2E6472616767696E673D21302C303D3D3D61262666756E6374696F6E28652C74297B743D747C7C22656C656D656E742E63';
wwv_flow_imp.g_varchar2_table(1858) := '6C69636B222C652E6F6E636528742C3565332C2866756E6374696F6E28297B72657475726E21317D29297D2865292C656F2822677261622229292C6E2E6472616767696E672626286C3D746F28732C6E2E6C6173747C7C6E2E7374617274292C742E7363';
wwv_flow_imp.g_varchar2_table(1859) := '726F6C6C287B64783A6C2E782C64793A6C2E797D292C6E2E6C6173743D73292C692E70726576656E7444656661756C7428297D66756E6374696F6E20722865297B71652E756E62696E6428646F63756D656E742C226D6F7573656D6F7665222C69292C71';
wwv_flow_imp.g_varchar2_table(1860) := '652E756E62696E6428646F63756D656E742C226D6F7573657570222C72292C6E3D6E756C6C2C656F286E756C6C297D652E6F6E2822656C656D656E742E6D6F757365646F776E222C3530302C2866756E6374696F6E2865297B72657475726E2066756E63';
wwv_flow_imp.g_varchar2_table(1861) := '74696F6E2865297B69662821466528652E7461726765742C222E646A732D647261676761626C652229297B76617220743D652E627574746F6E3B6966282128743E3D327C7C652E6374726C4B65797C7C652E73686966744B65797C7C652E616C744B6579';
wwv_flow_imp.g_varchar2_table(1862) := '292972657475726E206E3D7B627574746F6E3A742C73746172743A766E2865297D2C71652E62696E6428646F63756D656E742C226D6F7573656D6F7665222C69292C71652E62696E6428646F63756D656E742C226D6F7573657570222C72292C21307D7D';
wwv_flow_imp.g_varchar2_table(1863) := '28652E6F726967696E616C4576656E74297D29292C746869732E69734163746976653D66756E6374696F6E28297B72657475726E21216E7D7D6E6F2E24696E6A6563743D5B226576656E74427573222C2263616E766173225D3B636F6E737420696F3D7B';
wwv_flow_imp.g_varchar2_table(1864) := '5F5F696E69745F5F3A5B226D6F766543616E766173225D2C6D6F766543616E7661733A5B2274797065222C6E6F5D7D3B66756E6374696F6E20726F2865297B72657475726E204D6174682E6C6F672865292F4D6174682E6C6F67283130297D66756E6374';
wwv_flow_imp.g_varchar2_table(1865) := '696F6E206F6F28652C74297B766172206E3D726F28652E6D696E292C693D726F28652E6D6178293B72657475726E284D6174682E616273286E292B4D6174682E616273286929292F747D76617220616F3D4D6174682E7369676E7C7C66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1866) := '2865297B72657475726E20653E3D303F313A2D317D2C736F3D7B6D696E3A2E322C6D61783A347D2C6C6F3D2E37353B66756E6374696F6E20636F28652C742C6E297B653D657C7C7B7D2C746869732E5F656E61626C65643D21312C746869732E5F63616E';
wwv_flow_imp.g_varchar2_table(1867) := '7661733D6E2C746869732E5F636F6E7461696E65723D6E2E5F636F6E7461696E65722C746869732E5F68616E646C65576865656C3D4528746869732E5F68616E646C65576865656C2C74686973292C746869732E5F746F74616C44656C74613D302C7468';
wwv_flow_imp.g_varchar2_table(1868) := '69732E5F7363616C653D652E7363616C657C7C6C6F3B76617220693D746869733B742E6F6E282263616E7661732E696E6974222C2866756E6374696F6E2874297B692E5F696E6974282131213D3D652E656E61626C6564297D29297D636F2E24696E6A65';
wwv_flow_imp.g_varchar2_table(1869) := '63743D5B22636F6E6669672E7A6F6F6D5363726F6C6C222C226576656E74427573222C2263616E766173225D2C636F2E70726F746F747970652E7363726F6C6C3D66756E6374696F6E2865297B746869732E5F63616E7661732E7363726F6C6C2865297D';
wwv_flow_imp.g_varchar2_table(1870) := '2C636F2E70726F746F747970652E72657365743D66756E6374696F6E28297B746869732E5F63616E7661732E7A6F6F6D28226669742D76696577706F727422297D2C636F2E70726F746F747970652E7A6F6F6D3D66756E6374696F6E28652C74297B7661';
wwv_flow_imp.g_varchar2_table(1871) := '72206E3D6F6F28736F2C3230293B746869732E5F746F74616C44656C74612B3D652C4D6174682E61627328746869732E5F746F74616C44656C7461293E2E31262628746869732E5F7A6F6F6D28652C742C6E292C746869732E5F746F74616C44656C7461';
wwv_flow_imp.g_varchar2_table(1872) := '3D30297D2C636F2E70726F746F747970652E5F68616E646C65576865656C3D66756E6374696F6E2865297B69662821466528652E7461726765742C222E646A732D7363726F6C6C61626C65222C213029297B76617220743D746869732E5F636F6E746169';
wwv_flow_imp.g_varchar2_table(1873) := '6E65723B652E70726576656E7444656661756C7428293B766172206E2C693D652E6374726C4B65797C7C2F6D61632F692E74657374286E6176696761746F722E706C6174666F726D292626652E6D6574614B65792C723D652E73686966744B65792C6F3D';
wwv_flow_imp.g_varchar2_table(1874) := '2D312A746869732E5F7363616C653B6966286F2A3D693F303D3D3D652E64656C74614D6F64653F2E30323A2E33323A303D3D3D652E64656C74614D6F64653F313A31362C69297B76617220613D742E676574426F756E64696E67436C69656E7452656374';
wwv_flow_imp.g_varchar2_table(1875) := '28292C733D7B783A652E636C69656E74582D612E6C6566742C793A652E636C69656E74592D612E746F707D3B6E3D4D6174682E73717274284D6174682E706F7728652E64656C7461592C32292B4D6174682E706F7728652E64656C7461582C3229292A61';
wwv_flow_imp.g_varchar2_table(1876) := '6F28652E64656C746159292A6F2C746869732E7A6F6F6D286E2C73297D656C7365206E3D723F7B64783A6F2A652E64656C7461592C64793A307D3A7B64783A6F2A652E64656C7461582C64793A6F2A652E64656C7461597D2C746869732E7363726F6C6C';
wwv_flow_imp.g_varchar2_table(1877) := '286E297D7D2C636F2E70726F746F747970652E737465705A6F6F6D3D66756E6374696F6E28652C74297B766172206E3D6F6F28736F2C3130293B746869732E5F7A6F6F6D28652C742C6E297D2C636F2E70726F746F747970652E5F7A6F6F6D3D66756E63';
wwv_flow_imp.g_varchar2_table(1878) := '74696F6E28652C742C6E297B76617220693D746869732E5F63616E7661732C723D653E303F313A2D312C6F3D726F28692E7A6F6F6D2829292C613D4D6174682E726F756E64286F2F6E292A6E3B612B3D6E2A723B76617220732C6C2C633D4D6174682E70';
wwv_flow_imp.g_varchar2_table(1879) := '6F772831302C61293B692E7A6F6F6D2828733D736F2C6C3D632C4D6174682E6D617828732E6D696E2C4D6174682E6D696E28732E6D61782C6C2929292C74297D2C636F2E70726F746F747970652E746F67676C653D66756E6374696F6E2865297B766172';
wwv_flow_imp.g_varchar2_table(1880) := '20743D746869732E5F636F6E7461696E65722C6E3D746869732E5F68616E646C65576865656C2C693D746869732E5F656E61626C65643B72657475726E20766F696420303D3D3D65262628653D2169292C69213D3D65262671655B653F2262696E64223A';
wwv_flow_imp.g_varchar2_table(1881) := '22756E62696E64225D28742C22776865656C222C6E2C2131292C746869732E5F656E61626C65643D652C657D2C636F2E70726F746F747970652E5F696E69743D66756E6374696F6E2865297B746869732E746F67676C652865297D3B636F6E737420706F';
wwv_flow_imp.g_varchar2_table(1882) := '3D7B5F5F696E69745F5F3A5B227A6F6F6D5363726F6C6C225D2C7A6F6F6D5363726F6C6C3A5B2274797065222C636F5D7D3B76617220756F3D222E646A732D70616C657474652D746F67676C65222C686F3D222E656E747279222C6D6F3D756F2B222C20';
wwv_flow_imp.g_varchar2_table(1883) := '222B686F2C666F3D22646A732D70616C657474652D222C796F3D226F70656E222C676F3D2274776F2D636F6C756D6E223B66756E6374696F6E20766F28652C74297B746869732E5F6576656E744275733D652C746869732E5F63616E7661733D743B7661';
wwv_flow_imp.g_varchar2_table(1884) := '72206E3D746869733B652E6F6E2822746F6F6C2D6D616E616765722E757064617465222C2866756E6374696F6E2865297B76617220743D652E746F6F6C3B6E2E757064617465546F6F6C486967686C696768742874297D29292C652E6F6E28226931386E';
wwv_flow_imp.g_varchar2_table(1885) := '2E6368616E676564222C2866756E6374696F6E28297B6E2E5F75706461746528297D29292C652E6F6E28226469616772616D2E696E6974222C2866756E6374696F6E28297B6E2E5F6469616772616D496E697469616C697A65643D21302C6E2E5F726562';
wwv_flow_imp.g_varchar2_table(1886) := '75696C6428297D29297D66756E6374696F6E20626F28652C74297B766172206E3D742E67657450616C65747465456E747269657328293B72657475726E2070286E293F6E2865293A2866286E2C2866756E6374696F6E28742C6E297B655B6E5D3D747D29';
wwv_flow_imp.g_varchar2_table(1887) := '292C65297D766F2E24696E6A6563743D5B226576656E74427573222C2263616E766173225D2C766F2E70726F746F747970652E726567697374657250726F76696465723D66756E6374696F6E28652C74297B747C7C28743D652C653D316533292C746869';
wwv_flow_imp.g_varchar2_table(1888) := '732E5F6576656E744275732E6F6E282270616C657474652E67657450726F766964657273222C652C2866756E6374696F6E2865297B652E70726F7669646572732E707573682874297D29292C746869732E5F72656275696C6428297D2C766F2E70726F74';
wwv_flow_imp.g_varchar2_table(1889) := '6F747970652E676574456E74726965733D66756E6374696F6E28297B72657475726E20746869732E5F67657450726F76696465727328292E72656475636528626F2C7B7D297D2C766F2E70726F746F747970652E5F72656275696C643D66756E6374696F';
wwv_flow_imp.g_varchar2_table(1890) := '6E28297B746869732E5F6469616772616D496E697469616C697A65642626746869732E5F67657450726F76696465727328292E6C656E677468262628746869732E5F636F6E7461696E65727C7C746869732E5F696E697428292C746869732E5F75706461';
wwv_flow_imp.g_varchar2_table(1891) := '74652829297D2C766F2E70726F746F747970652E5F696E69743D66756E6374696F6E28297B76617220653D746869732C743D746869732E5F6576656E744275732C6E3D746869732E5F676574506172656E74436F6E7461696E657228292C693D74686973';
wwv_flow_imp.g_varchar2_table(1892) := '2E5F636F6E7461696E65723D516528766F2E48544D4C5F4D41524B5550293B6E2E617070656E644368696C642869292C4965286E292E61646428666F2B2273686F776E22292C58652E62696E6428692C6D6F2C22636C69636B222C2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1893) := '2874297B766172206E2C692C723D742E64656C65676174655461726765743B696628693D756F2C286E3D722926262266756E6374696F6E223D3D747970656F66206E2E6D61746368657326266E2E6D6174636865732869292972657475726E20652E746F';
wwv_flow_imp.g_varchar2_table(1894) := '67676C6528293B652E747269676765722822636C69636B222C74297D29292C71652E62696E6428692C226D6F757365646F776E222C2866756E6374696F6E2865297B652E73746F7050726F7061676174696F6E28297D29292C58652E62696E6428692C68';
wwv_flow_imp.g_varchar2_table(1895) := '6F2C22647261677374617274222C2866756E6374696F6E2874297B652E747269676765722822647261677374617274222C74297D29292C742E6F6E282263616E7661732E726573697A6564222C746869732E5F6C61796F75744368616E6765642C746869';
wwv_flow_imp.g_varchar2_table(1896) := '73292C742E66697265282270616C657474652E637265617465222C7B636F6E7461696E65723A697D297D2C766F2E70726F746F747970652E5F67657450726F7669646572733D66756E6374696F6E2865297B76617220743D746869732E5F6576656E7442';
wwv_flow_imp.g_varchar2_table(1897) := '75732E6372656174654576656E74287B747970653A2270616C657474652E67657450726F766964657273222C70726F7669646572733A5B5D7D293B72657475726E20746869732E5F6576656E744275732E666972652874292C742E70726F766964657273';
wwv_flow_imp.g_varchar2_table(1898) := '7D2C766F2E70726F746F747970652E5F746F67676C6553746174653D66756E6374696F6E2865297B653D657C7C7B7D3B76617220742C6E3D746869732E5F676574506172656E74436F6E7461696E657228292C693D746869732E5F636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(1899) := '2C723D746869732E5F6576656E744275732C6F3D49652869292C613D4965286E293B743D2274776F436F6C756D6E22696E20653F652E74776F436F6C756D6E3A746869732E5F6E65656473436F6C6C61707365286E2E636C69656E744865696768742C74';
wwv_flow_imp.g_varchar2_table(1900) := '6869732E5F656E74726965737C7C7B7D292C6F2E746F67676C6528676F2C74292C612E746F67676C6528666F2B676F2C74292C226F70656E22696E20652626286F2E746F67676C6528796F2C652E6F70656E292C612E746F67676C6528666F2B796F2C65';
wwv_flow_imp.g_varchar2_table(1901) := '2E6F70656E29292C722E66697265282270616C657474652E6368616E676564222C7B74776F436F6C756D6E3A742C6F70656E3A746869732E69734F70656E28297D297D2C766F2E70726F746F747970652E5F7570646174653D66756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(1902) := '76617220653D657428222E646A732D70616C657474652D656E7472696573222C746869732E5F636F6E7461696E6572292C743D746869732E5F656E74726965733D746869732E676574456E747269657328293B6A652865292C6628742C2866756E637469';
wwv_flow_imp.g_varchar2_table(1903) := '6F6E28742C6E297B76617220692C723D742E67726F75707C7C2264656661756C74222C6F3D657428225B646174612D67726F75703D222B28693D722C4353532E6573636170652869292B225D22292C65293B6F7C7C285465286F3D516528273C64697620';
wwv_flow_imp.g_varchar2_table(1904) := '636C6173733D2267726F7570223E3C2F6469763E27292C22646174612D67726F7570222C72292C652E617070656E644368696C64286F29293B76617220613D742E68746D6C7C7C28742E736570617261746F723F273C687220636C6173733D2273657061';
wwv_flow_imp.g_varchar2_table(1905) := '7261746F7222202F3E273A273C64697620636C6173733D22656E7472792220647261676761626C653D2274727565223E3C2F6469763E27292C6C3D51652861293B6966286F2E617070656E644368696C64286C292C21742E736570617261746F72262628';
wwv_flow_imp.g_varchar2_table(1906) := '5465286C2C22646174612D616374696F6E222C6E292C742E7469746C6526265465286C2C227469746C65222C742E7469746C65292C742E636C6173734E616D65262666756E6374696F6E28652C74297B766172206E3D49652865293B28732874293F743A';
wwv_flow_imp.g_varchar2_table(1907) := '742E73706C6974282F5C732B2F6729292E666F7245616368282866756E6374696F6E2865297B6E2E6164642865297D29297D286C2C742E636C6173734E616D65292C742E696D61676555726C29297B76617220633D516528223C696D673E22293B546528';
wwv_flow_imp.g_varchar2_table(1908) := '632C22737263222C742E696D61676555726C292C6C2E617070656E644368696C642863297D7D29292C746869732E6F70656E28297D2C766F2E70726F746F747970652E747269676765723D66756E6374696F6E28652C742C6E297B76617220692C722C6F';
wwv_flow_imp.g_varchar2_table(1909) := '3D742E64656C65676174655461726765747C7C742E7461726765743B72657475726E206F3F28693D5465286F2C22646174612D616374696F6E22292C723D742E6F726967696E616C4576656E747C7C742C746869732E74726967676572456E7472792869';
wwv_flow_imp.g_varchar2_table(1910) := '2C652C722C6E29293A742E70726576656E7444656661756C7428297D2C766F2E70726F746F747970652E74726967676572456E7472793D66756E6374696F6E28652C742C6E2C69297B76617220722C6F3B69662828723D746869732E5F656E7472696573';
wwv_flow_imp.g_varchar2_table(1911) := '5B655D292626286F3D722E616374696F6E2C2131213D3D746869732E5F6576656E744275732E66697265282270616C657474652E74726967676572222C7B656E7472793A722C6576656E743A6E7D2929297B69662870286F29297B69662822636C69636B';
wwv_flow_imp.g_varchar2_table(1912) := '223D3D3D742972657475726E206F286E2C69297D656C7365206966286F5B745D2972657475726E206F5B745D286E2C69293B6E2E70726576656E7444656661756C7428297D7D2C766F2E70726F746F747970652E5F6C61796F75744368616E6765643D66';
wwv_flow_imp.g_varchar2_table(1913) := '756E6374696F6E28297B746869732E5F746F67676C655374617465287B7D297D2C766F2E70726F746F747970652E5F6E65656473436F6C6C617073653D66756E6374696F6E28652C74297B72657475726E20653C34362A4F626A6563742E6B6579732874';
wwv_flow_imp.g_varchar2_table(1914) := '292E6C656E6774682B35307D2C766F2E70726F746F747970652E636C6F73653D66756E6374696F6E28297B746869732E5F746F67676C655374617465287B6F70656E3A21312C74776F436F6C756D6E3A21317D297D2C766F2E70726F746F747970652E6F';
wwv_flow_imp.g_varchar2_table(1915) := '70656E3D66756E6374696F6E28297B746869732E5F746F67676C655374617465287B6F70656E3A21307D297D2C766F2E70726F746F747970652E746F67676C653D66756E6374696F6E28297B746869732E69734F70656E28293F746869732E636C6F7365';
wwv_flow_imp.g_varchar2_table(1916) := '28293A746869732E6F70656E28297D2C766F2E70726F746F747970652E6973416374697665546F6F6C3D66756E6374696F6E2865297B72657475726E20652626746869732E5F616374697665546F6F6C3D3D3D657D2C766F2E70726F746F747970652E75';
wwv_flow_imp.g_varchar2_table(1917) := '7064617465546F6F6C486967686C696768743D66756E6374696F6E2865297B76617220743B746869732E5F746F6F6C73436F6E7461696E65727C7C28743D657428222E646A732D70616C657474652D656E7472696573222C746869732E5F636F6E746169';
wwv_flow_imp.g_varchar2_table(1918) := '6E6572292C746869732E5F746F6F6C73436F6E7461696E65723D657428225B646174612D67726F75703D746F6F6C735D222C7429292C6628746869732E5F746F6F6C73436F6E7461696E65722E6368696C6472656E2C2866756E6374696F6E2874297B76';
wwv_flow_imp.g_varchar2_table(1919) := '6172206E3D742E6765744174747269627574652822646174612D616374696F6E22293B6966286E297B76617220693D49652874293B6E3D6E2E7265706C61636528222D746F6F6C222C2222292C692E636F6E7461696E732822656E747279222926266E3D';
wwv_flow_imp.g_varchar2_table(1920) := '3D3D653F692E6164642822686967686C6967687465642D656E74727922293A692E72656D6F76652822686967686C6967687465642D656E74727922297D7D29297D2C766F2E70726F746F747970652E69734F70656E3D66756E6374696F6E28297B726574';
wwv_flow_imp.g_varchar2_table(1921) := '75726E20496528746869732E5F636F6E7461696E6572292E68617328796F297D2C766F2E70726F746F747970652E5F676574506172656E74436F6E7461696E65723D66756E6374696F6E28297B72657475726E20746869732E5F63616E7661732E676574';
wwv_flow_imp.g_varchar2_table(1922) := '436F6E7461696E657228297D2C766F2E48544D4C5F4D41524B55503D273C64697620636C6173733D22646A732D70616C65747465223E3C64697620636C6173733D22646A732D70616C657474652D656E7472696573223E3C2F6469763E3C64697620636C';
wwv_flow_imp.g_varchar2_table(1923) := '6173733D22646A732D70616C657474652D746F67676C65223E3C2F6469763E3C2F6469763E273B636F6E737420786F3D7B5F5F696E69745F5F3A5B2270616C65747465225D2C70616C657474653A5B2274797065222C766F5D7D3B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(1924) := '776F28652C742C6E2C692C72297B652E5F6E65656473436F6C6C617073653D66756E6374696F6E28652C74297B72657475726E21317D2C746869732E67657450616C65747465456E74726965733D66756E6374696F6E2865297B766172206F3D7B7D2C61';
wwv_flow_imp.g_varchar2_table(1925) := '3D6E657720636F287B7D2C6E2C69293B72657475726E2053286F2C7B227A6F6F6D2D696E223A7B67726F75703A22636F6E74726F6C73222C636C6173734E616D653A2266612066612D7365617263682D706C7573222C7469746C653A7428225A6F6F6D20';
wwv_flow_imp.g_varchar2_table(1926) := '496E22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B612E7A6F6F6D28312C30297D7D7D2C227A6F6F6D2D6F7574223A7B67726F75703A22636F6E74726F6C73222C636C6173734E616D653A2266612066612D7365617263682D6D';
wwv_flow_imp.g_varchar2_table(1927) := '696E7573222C7469746C653A7428225A6F6F6D204F757422292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B612E7A6F6F6D282D312C30297D7D7D2C227A6F6F6D2D7265736574223A7B67726F75703A22636F6E74726F6C73222C63';
wwv_flow_imp.g_varchar2_table(1928) := '6C6173734E616D653A2266612066612D6669742D746F2D73697A65222C7469746C653A7428225265736574205A6F6F6D22292C616374696F6E3A7B636C69636B3A66756E6374696F6E2865297B612E726573657428297D7D7D2C2E2E2E722E616C6C6F77';
wwv_flow_imp.g_varchar2_table(1929) := '446F776E6C6F616426267B22646F776E6C6F61642D737667223A7B67726F75703A22636F6E74726F6C73222C636C6173734E616D653A2266612066612D696D616765222C7469746C653A742822446F776E6C6F61642053564722292C616374696F6E3A7B';
wwv_flow_imp.g_varchar2_table(1930) := '636C69636B3A66756E6374696F6E2865297B646F776E6C6F616441735356472865297D7D7D7D7D292C6F7D2C652E726567697374657250726F76696465722874686973297D776F2E24696E6A6563743D5B2270616C65747465222C227472616E736C6174';
wwv_flow_imp.g_varchar2_table(1931) := '65222C226576656E74427573222C2263616E766173222C22636F6E6669672E636F6E666967225D3B636F6E7374205F6F3D7B5F5F646570656E64735F5F3A5B786F2C53745D2C5F5F696E69745F5F3A5B2270616C6574746550726F7669646572225D2C70';
wwv_flow_imp.g_varchar2_table(1932) := '616C6574746550726F76696465723A5B2274797065222C776F5D7D3B66756E6374696F6E20456F28652C742C6E2C692C72297B746869732E5F63616E7661733D652C746869732E5F6576656E744275733D742C746869732E5F656C656D656E7452656769';
wwv_flow_imp.g_varchar2_table(1933) := '737472793D6E2C746869732E5F6F7665726C6179733D692C746869732E5F6D6F64646C653D723B766172206F3D746869733B746869732E5F62726561646372756D623D516528273C756C20636C6173733D22626A732D62726561646372756D6273222069';
wwv_flow_imp.g_varchar2_table(1934) := '643D2263616C6C416374697669747942726561646372756D62223E3C2F756C3E27292C652E676574436F6E7461696E657228292E617070656E644368696C6428746869732E5F62726561646372756D62292C742E6F6E2822696D706F72742E72656E6465';
wwv_flow_imp.g_varchar2_table(1935) := '722E636F6D706C657465222C2866756E6374696F6E28297B6E2E66696C746572282866756E6374696F6E2865297B72657475726E206F2E63616E4472696C6C446F776E2865297D29292E666F7245616368282866756E6374696F6E2865297B6F2E616464';
wwv_flow_imp.g_varchar2_table(1936) := '4F7665726C61792865297D29297D29297D456F2E70726F746F747970652E63616E4472696C6C446F776E3D66756E6374696F6E2865297B72657475726E206B28652C2262706D6E3A43616C6C416374697669747922297D2C456F2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(1937) := '2E6164644F7665726C61793D66756E6374696F6E2865297B76617220743D746869732E5F6F7665726C6179732C6E3D746869732C693D516528273C627574746F6E20636C6173733D22626A732D6472696C6C646F776E223E3C73766720786D6C6E733D22';
wwv_flow_imp.g_varchar2_table(1938) := '687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22323022206865696768743D223230222076696577426F783D22302030203136203136223E3C706174682066696C6C2D72756C653D226576656E6F64642220643D22';
wwv_flow_imp.g_varchar2_table(1939) := '4D342E38313830313934382C332E3530373335393331204C31302E343939363839342C392E31383936383934204C31302E352C34204C31322C34204C31322C3132204C342C3132204C342C31302E35204C392E363839363839342C31302E343939363839';
wwv_flow_imp.g_varchar2_table(1940) := '34204C332E37353733353933312C342E35363830313934382043332E34363434363630392C342E323735313236323720332E34363434363630392C332E383030323532353320332E37353733353933312C332E35303733353933312043342E3035303235';
wwv_flow_imp.g_varchar2_table(1941) := '3235332C332E323134343636303920342E35323531323632372C332E323134343636303920342E38313830313934382C332E3530373335393331205A222F3E3C2F7376673E3C2F627574746F6E3E27293B742E676574287B656C656D656E743A652C7479';
wwv_flow_imp.g_varchar2_table(1942) := '70653A226472696C6C646F776E227D292E6C656E6774682626746869732E72656D6F76654F7665726C61792865292C692E6164644576656E744C697374656E65722822636C69636B222C2866756E6374696F6E2874297B76617220693D652E69642C7B64';
wwv_flow_imp.g_varchar2_table(1943) := '6174613A722C6469616772616D4964656E7469666965723A6F7D3D6E2E5F7769646765742C613D722E66696E642828653D3E652E63616C6C696E674469616772616D4964656E7469666965723D3D3D6F2626652E63616C6C696E674F626A65637449643D';
wwv_flow_imp.g_varchar2_table(1944) := '3D3D6929293B612626313D3D3D612E696E73696768742626286E2E5F7769646765742E6469616772616D4964656E7469666965723D612E6469616772616D4964656E7469666965722C6E2E5F7769646765742E63616C6C696E674469616772616D496465';
wwv_flow_imp.g_varchar2_table(1945) := '6E7469666965723D612E63616C6C696E674469616772616D4964656E7469666965722C6E2E5F7769646765742E63616C6C696E674F626A65637449643D612E63616C6C696E674F626A65637449642C6E2E5F7769646765742E6469616772616D3D612E64';
wwv_flow_imp.g_varchar2_table(1946) := '69616772616D2C6E2E5F7769646765742E63757272656E743D612E63757272656E742C6E2E5F7769646765742E636F6D706C657465643D612E636F6D706C657465642C6E2E5F7769646765742E6572726F723D612E6572726F722C6E2E75706461746542';
wwv_flow_imp.g_varchar2_table(1947) := '726561646372756D6228292C646F63756D656E742E717565727953656C6563746F7228222E626A732D62726561646372756D62733A6E6F74282363616C6C416374697669747942726561646372756D622922292E7374796C652E746F703D223630707822';
wwv_flow_imp.g_varchar2_table(1948) := '2C6E2E5F7769646765742E6C6F61644469616772616D2829297D29292C742E61646428652C226472696C6C646F776E222C7B706F736974696F6E3A7B626F74746F6D3A2D372C72696768743A2D387D2C68746D6C3A697D297D2C456F2E70726F746F7479';
wwv_flow_imp.g_varchar2_table(1949) := '70652E72656D6F76654F7665726C61793D66756E6374696F6E2865297B746869732E5F6F7665726C6179732E72656D6F7665287B656C656D656E743A652C747970653A226472696C6C646F776E227D297D2C456F2E70726F746F747970652E7365745769';
wwv_flow_imp.g_varchar2_table(1950) := '646765743D66756E6374696F6E2865297B746869732E5F7769646765743D657D2C456F2E70726F746F747970652E75706461746542726561646372756D623D66756E6374696F6E28297B76617220653D746869733B636F6E73747B646174613A742C6469';
wwv_flow_imp.g_varchar2_table(1951) := '616772616D4964656E7469666965723A6E2C63616C6C696E674469616772616D4964656E7469666965723A692C63616C6C696E674F626A65637449643A727D3D746869732E5F7769646765743B7661727B62726561646372756D623A6F7D3D742E66696E';
wwv_flow_imp.g_varchar2_table(1952) := '642828653D3E652E6469616772616D4964656E7469666965723D3D3D6E2626652E63616C6C696E674469616772616D4964656E7469666965723D3D3D692626652E63616C6C696E674F626A65637449643D3D3D7229292C613D516528603C6C6920646174';
wwv_flow_imp.g_varchar2_table(1953) := '612D696E6465783D22247B746869732E5F62726561646372756D622E6368696C644E6F6465732E6C656E6774687D225C6E20202020247B6E3F6020646174612D6469616772616D4964656E7469666965723D22247B6E7D22603A22227D5C6E2020202024';
wwv_flow_imp.g_varchar2_table(1954) := '7B693F6020646174612D63616C6C696E674469616772616D4964656E7469666965723D22247B697D22603A22227D5C6E20202020247B723F6020646174612D63616C6C696E674F626A65637449643D2224247B727D22603A22227D3E3C7370616E20636C';
wwv_flow_imp.g_varchar2_table(1955) := '6173733D22626A732D6372756D62223E3C615C6E20202020247B723F60207469746C653D2263616C6C656420627920247B727D22603A22227D3E247B6F7D3C2F613E3C2F7370616E3E3C2F6C693E60293B612E6164644576656E744C697374656E657228';
wwv_flow_imp.g_varchar2_table(1956) := '22636C69636B222C2866756E6374696F6E28297B7661727B696E6465783A742C6469616772616D6964656E7469666965723A6E7D3D612E646174617365743B636F6E73747B646174613A697D3D652E5F7769646765743B76617220723D692E66696E6428';
wwv_flow_imp.g_varchar2_table(1957) := '28653D3E652E6469616772616D4964656E7469666965723D3D6E29293B743C652E5F62726561646372756D622E6368696C644E6F6465732E6C656E6774682D31262628652E7472696D42726561646372756D62546F2874292C652E5F7769646765742E64';
wwv_flow_imp.g_varchar2_table(1958) := '69616772616D4964656E7469666965723D722E6469616772616D4964656E7469666965722C652E5F7769646765742E63616C6C696E674469616772616D4964656E7469666965723D722E63616C6C696E674469616772616D4964656E7469666965722C65';
wwv_flow_imp.g_varchar2_table(1959) := '2E5F7769646765742E63616C6C696E674F626A65637449643D722E63616C6C696E674F626A65637449642C652E5F7769646765742E6469616772616D3D722E6469616772616D2C652E5F7769646765742E63757272656E743D722E63757272656E742C65';
wwv_flow_imp.g_varchar2_table(1960) := '2E5F7769646765742E636F6D706C657465643D722E636F6D706C657465642C652E5F7769646765742E6572726F723D722E6572726F722C652E5F7769646765742E6C6F61644469616772616D2829297D29292C746869732E5F62726561646372756D622E';
wwv_flow_imp.g_varchar2_table(1961) := '617070656E644368696C642861292C746869732E746F67676C6542726561646372756D625669736962696C69747928297D2C456F2E70726F746F747970652E726573657442726561646372756D623D66756E6374696F6E28297B666F72283B746869732E';
wwv_flow_imp.g_varchar2_table(1962) := '5F62726561646372756D622E66697273744368696C643B29746869732E5F62726561646372756D622E72656D6F76654368696C6428746869732E5F62726561646372756D622E66697273744368696C64293B746869732E746F67676C6542726561646372';
wwv_flow_imp.g_varchar2_table(1963) := '756D625669736962696C69747928297D2C456F2E70726F746F747970652E7472696D42726561646372756D62546F3D66756E6374696F6E2865297B76617220743D21312C6E3D5B5D3B666F72286C657420693D303B693C746869732E5F62726561646372';
wwv_flow_imp.g_varchar2_table(1964) := '756D622E6368696C644E6F6465732E6C656E6774683B692B2B29743F6E2E7075736828746869732E5F62726561646372756D622E6368696C644E6F6465735B695D293A746869732E5F62726561646372756D622E6368696C644E6F6465735B695D2E6461';
wwv_flow_imp.g_varchar2_table(1965) := '74617365742E696E6465783D3D3D65262628743D2130293B6E2E666F72456163682828653D3E746869732E5F62726561646372756D622E72656D6F76654368696C6428652929292C746869732E746F67676C6542726561646372756D625669736962696C';
wwv_flow_imp.g_varchar2_table(1966) := '69747928297D2C456F2E70726F746F747970652E746F67676C6542726561646372756D625669736962696C6974793D66756E6374696F6E28297B696628746869732E5F62726561646372756D622E6368696C644E6F6465732E6C656E6774683E31297B63';
wwv_flow_imp.g_varchar2_table(1967) := '6F6E737420653D746869732E5F62726561646372756D622E6F66667365744865696768743B746869732E5F62726561646372756D622E7374796C652E646973706C61793D22666C6578222C746869732E5F63616E7661732E7363726F6C6C287B64783A30';
wwv_flow_imp.g_varchar2_table(1968) := '2C64793A33302B652B33307D297D656C73657B636F6E737420653D646F63756D656E742E717565727953656C6563746F7228222E626A732D62726561646372756D62733A6E6F74282363616C6C416374697669747942726561646372756D622922293B74';
wwv_flow_imp.g_varchar2_table(1969) := '6869732E5F62726561646372756D622E7374796C652E646973706C61793D226E6F6E65222C652E7374796C652E746F703D2233307078227D7D2C456F2E70726F746F747970652E736574506F736974696F6E696E673D66756E6374696F6E28297B7D2C45';
wwv_flow_imp.g_varchar2_table(1970) := '6F2E24696E6A6563743D5B2263616E766173222C226576656E74427573222C22656C656D656E745265676973747279222C226F7665726C617973222C226D6F64646C65225D3B636F6E737420536F3D7B5F5F696E69745F5F3A5B2263616C6C4163746976';
wwv_flow_imp.g_varchar2_table(1971) := '6974794D6F64756C65225D2C63616C6C41637469766974794D6F64756C653A5B2274797065222C456F5D7D3B66756E6374696F6E20416F28652C74297B652E6F6E2822726F6F742E736574222C2866756E6374696F6E28297B742E7A6F6F6D2822666974';
wwv_flow_imp.g_varchar2_table(1972) := '2D76696577706F7274222C226175746F22297D29297D416F2E24696E6A6563743D5B226576656E74427573222C2263616E766173225D3B636F6E737420436F3D7B5F5F696E69745F5F3A5B226472696C6C646F776E43656E746572696E67225D2C647269';
wwv_flow_imp.g_varchar2_table(1973) := '6C6C646F776E43656E746572696E673A5B2274797065222C416F5D7D3B66756E6374696F6E206B6F28652C742C6E297B636F6E737420693D646F63756D656E742E717565727953656C6563746F7228222E63616E76617322293B692E7374796C652E7365';
wwv_flow_imp.g_varchar2_table(1974) := '7450726F706572747928222D2D686967686C696768742D63757272656E742D66696C6C222C652E63757272656E745374796C652E66696C6C292C692E7374796C652E73657450726F706572747928222D2D686967686C696768742D63757272656E742D62';
wwv_flow_imp.g_varchar2_table(1975) := '6F72646572222C652E63757272656E745374796C652E626F72646572292C692E7374796C652E73657450726F706572747928222D2D686967686C696768742D63757272656E742D6C6162656C222C652E63757272656E745374796C652E6C6162656C292C';
wwv_flow_imp.g_varchar2_table(1976) := '692E7374796C652E73657450726F706572747928222D2D686967686C696768742D636F6D706C657465642D66696C6C222C652E636F6D706C657465645374796C652E66696C6C292C692E7374796C652E73657450726F706572747928222D2D686967686C';
wwv_flow_imp.g_varchar2_table(1977) := '696768742D636F6D706C657465642D626F72646572222C652E636F6D706C657465645374796C652E626F72646572292C692E7374796C652E73657450726F706572747928222D2D686967686C696768742D636F6D706C657465642D6C6162656C222C652E';
wwv_flow_imp.g_varchar2_table(1978) := '636F6D706C657465645374796C652E6C6162656C292C692E7374796C652E73657450726F706572747928222D2D686967686C696768742D6572726F722D66696C6C222C652E6572726F725374796C652E66696C6C292C692E7374796C652E73657450726F';
wwv_flow_imp.g_varchar2_table(1979) := '706572747928222D2D686967686C696768742D6572726F722D626F72646572222C652E6572726F725374796C652E626F72646572292C692E7374796C652E73657450726F706572747928222D2D686967686C696768742D6572726F722D6C6162656C222C';
wwv_flow_imp.g_varchar2_table(1980) := '652E6572726F725374796C652E6C6162656C292C746869732E6164645374796C65546F456C656D656E74733D66756E6374696F6E28652C74297B6C6574206E3B666F7228636F6E73742069206F662065296E3D646F63756D656E742E717565727953656C';
wwv_flow_imp.g_varchar2_table(1981) := '6563746F722860675B646174612D656C656D656E742D69643D22247B697D225D3A6E6F74282E646A732D636F6E6E656374696F6E29202E646A732D76697375616C60292C6E26266E2E636C6173734C6973742E6164642874297D2C746869732E68696768';
wwv_flow_imp.g_varchar2_table(1982) := '6C69676874456C656D656E74733D66756E6374696F6E28652C742C6E297B652626652E6C656E6774683E302626746869732E6164645374796C65546F456C656D656E747328652C22686967686C696768742D63757272656E7422292C742626742E6C656E';
wwv_flow_imp.g_varchar2_table(1983) := '6774683E302626746869732E6164645374796C65546F456C656D656E747328742C22686967686C696768742D636F6D706C6574656422292C6E26266E2E6C656E6774683E302626746869732E6164645374796C65546F456C656D656E7473286E2C226869';
wwv_flow_imp.g_varchar2_table(1984) := '67686C696768742D6572726F7222297D2C746869732E7265736574486967686C69676874696E673D66756E6374696F6E28297B636F6E737420653D4F626A6563742E6B657973286E2E5F656C656D656E7473293B6C657420743B666F7228636F6E737420';
wwv_flow_imp.g_varchar2_table(1985) := '6E206F66206529743D646F63756D656E742E717565727953656C6563746F722860675B646174612D656C656D656E742D69643D22247B6E7D225D3A6E6F74282E646A732D636F6E6E656374696F6E29202E646A732D76697375616C60292C74262628742E';
wwv_flow_imp.g_varchar2_table(1986) := '636C6173734C6973742E72656D6F76652822686967686C696768742D63757272656E7422292C742E636C6173734C6973742E72656D6F76652822686967686C696768742D636F6D706C6574656422292C742E636C6173734C6973742E72656D6F76652822';
wwv_flow_imp.g_varchar2_table(1987) := '686967686C696768742D6572726F722229297D2C746869732E726573657442504D4E636F6C6F72733D66756E6374696F6E28297B636F6E737420653D4F626A6563742E6B657973286E2E5F656C656D656E7473293B6C657420743B666F7228636F6E7374';
wwv_flow_imp.g_varchar2_table(1988) := '206E206F66206529743D646F63756D656E742E717565727953656C6563746F722860675B646174612D656C656D656E742D69643D22247B6E7D225D3A6E6F74282E646A732D636F6E6E656374696F6E29202E646A732D76697375616C60292C742626742E';
wwv_flow_imp.g_varchar2_table(1989) := '636C6173734C6973742E616464282272657365742D62706D6E2D636F6C6F727322297D2C746869732E6164645374796C65546F5356473D66756E6374696F6E2865297B636F6E737420743D286E657720444F4D506172736572292E706172736546726F6D';
wwv_flow_imp.g_varchar2_table(1990) := '537472696E6728652C22746578742F786D6C22292C5B6E5D3D742E676574456C656D656E747342795461674E616D6528226465667322292C693D646F63756D656E742E637265617465456C656D656E7428227374796C6522293B692E7365744174747269';
wwv_flow_imp.g_varchar2_table(1991) := '62757465282274797065222C22746578742F63737322293B636F6E737420723D646F63756D656E742E637265617465546578744E6F646528222E646A732D67726F7570207B202D2D64656661756C742D66696C6C2D636F6C6F723A2077686974653B202D';
wwv_flow_imp.g_varchar2_table(1992) := '2D64656661756C742D7374726F6B652D636F6C6F723A20626C61636B3B207D22293B72657475726E20692E617070656E644368696C642872292C6E2E617070656E644368696C642869292C286E657720584D4C53657269616C697A6572292E7365726961';
wwv_flow_imp.g_varchar2_table(1993) := '6C697A65546F537472696E672874297D7D6B6F2E24696E6A6563743D5B22636F6E6669672E636F6E666967222C22636F6E6669672E62706D6E52656E6465726572222C22656C656D656E745265676973747279225D3B636F6E737420526F3D7B5F5F696E';
wwv_flow_imp.g_varchar2_table(1994) := '69745F5F3A5B227374796C654D6F64756C65225D2C7374796C654D6F64756C653A5B2274797065222C6B6F5D7D3B636C617373204D6F7B636F6E7374727563746F7228652C742C6E2C692C72297B746869732E5F63616E7661733D652C746869732E5F65';
wwv_flow_imp.g_varchar2_table(1995) := '76656E744275733D742C746869732E5F656C656D656E7452656769737472793D6E2C746869732E5F7472616E736C6174653D692C746869732E5F6F7665726C6179733D722C746869732E62726561646372756D62497465726174696F6E3D5B5D2C746869';
wwv_flow_imp.g_varchar2_table(1996) := '732E62726561646372756D6253656C656374696F6E3D5B5D3B636F6E7374206F3D516528275C6E2020202020203C6469762069643D226D6F64616C223E5C6E20202020202020203C646976206964203D226D6F64616C2D636F6E74656E74223E5C6E2020';
wwv_flow_imp.g_varchar2_table(1997) := '20202020202020203C6469762069643D22697465726174696F6E2D7469746C65223E5C6E2020202020202020202020203C7370616E3E3C2F7370616E3E5C6E2020202020202020202020203C627574746F6E20636C6173733D2266612066612D74696D65';
wwv_flow_imp.g_varchar2_table(1998) := '73223E3C2F627574746F6E3E5C6E202020202020202020203C2F6469763E5C6E202020202020202020203C6469762069643D22697465726174696F6E2D736561726368223E5C6E2020202020202020202020203C696E70757420747970653D2274657874';
wwv_flow_imp.g_varchar2_table(1999) := '2220706C616365686F6C6465723D225365617263682E2E222F3E5C6E202020202020202020203C2F6469763E5C6E202020202020202020203C6469762069643D22697465726174696F6E2D6C697374223E5C6E20202020202020202020202020203C7461';
wwv_flow_imp.g_varchar2_table(2000) := '626C653E5C6E202020202020202020202020202020203C74686561643E5C6E2020202020202020202020202020202020203C74723E5C6E20202020202020202020202020202020202020203C74683E4C6F6F7020436F756E7465723C2F74683E5C6E2020';
wwv_flow_imp.g_varchar2_table(2001) := '2020202020202020202020202020202020203C74683E4465736372697074696F6E3C2F74683E5C6E20202020202020202020202020202020202020203C74683E5374617475733C2F74683E5C6E2020202020202020202020202020202020203C2F74723E';
wwv_flow_imp.g_varchar2_table(2002) := '5C6E202020202020202020202020202020203C2F74686561643E5C6E202020202020202020202020202020203C74626F64793E3C2F74626F64793E5C6E2020202020202020202020203C2F7461626C653E5C6E202020202020202020203C2F6469763E5C';
wwv_flow_imp.g_varchar2_table(2003) := '6E20202020202020203C2F6469763E5C6E2020202020203C2F6469763E5C6E2020202027293B652E676574436F6E7461696E657228292E617070656E644368696C64286F292C742E6F6E2822696D706F72742E72656E6465722E636F6D706C657465222C';
wwv_flow_imp.g_varchar2_table(2004) := '2828293D3E7B6574282223697465726174696F6E2D73656172636820696E70757422292E6164644576656E744C697374656E657228226B65797570222C28653D3E7B746869732E66696C746572497465726174696F6E732865297D29292C657428222369';
wwv_flow_imp.g_varchar2_table(2005) := '7465726174696F6E2D7469746C6520627574746F6E2E66612D74696D657322292E6164644576656E744C697374656E65722822636C69636B222C28653D3E7B746869732E636C6F7365497465726174696F6E7328297D29297D29292C742E6F6E2822726F';
wwv_flow_imp.g_varchar2_table(2006) := '6F742E736574222C28653D3E7B636F6E73747B656C656D656E743A747D3D653B746869732E726573657442726561646372756D624461746128292C6B28742C2262706D6E3A53756250726F636573732229262628746869732E686173497465726174696F';
wwv_flow_imp.g_varchar2_table(2007) := '6E44617461287429262628746869732E62726561646372756D62497465726174696F6E5B746869732E6765744C61737442726561646372756D62496E64657828295D3D21302C746869732E617070656E6442726561646372756D62427574746F6E287429';
wwv_flow_imp.g_varchar2_table(2008) := '292C746869732E75706461746542726561646372756D622829292C746869732E757064617465486967686C69676874696E6728297D29297D7365745769646765742865297B746869732E5F7769646765743D657D676574497465726174696F6E44617461';
wwv_flow_imp.g_varchar2_table(2009) := '2865297B636F6E73747B69643A747D3D4D2865292C6E3D746869732E62726561646372756D6253656C656374696F6E5B746869732E6765744C61737442726561646372756D62496E64657828292D315D3B72657475726E20746869732E5F776964676574';
wwv_flow_imp.g_varchar2_table(2010) := '2E697465726174696F6E446174612626746869732E5F7769646765742E697465726174696F6E446174615B745D2626746869732E5F7769646765742E697465726174696F6E446174615B745D2E66696C7465722828653D3E216E262621652E706172656E';
wwv_flow_imp.g_varchar2_table(2011) := '74537465704B65797C7C6E2626652E706172656E74537465704B65793D3D6E2E737465704B657929297C7C5B5D7D6164644F7665726C61797328297B746869732E5F656C656D656E7452656769737472792E66696C7465722828653D3E216B28652C2262';
wwv_flow_imp.g_varchar2_table(2012) := '706D6E3A53756250726F6365737322292626746869732E686173497465726174696F6E4461746128652929292E666F72456163682828653D3E7B746869732E6164644F7665726C61792865297D29297D6164644F7665726C61792865297B636F6E737420';
wwv_flow_imp.g_varchar2_table(2013) := '743D516528273C627574746F6E20636C6173733D22626A732D6472696C6C646F776E2066612066612D6C697374223E3C2F627574746F6E3E27293B742E6164644576656E744C697374656E65722822636C69636B222C28743D3E7B746869732E6F70656E';
wwv_flow_imp.g_varchar2_table(2014) := '497465726174696F6E732865297D29292C746869732E5F6F7665726C6179732E61646428652C22697465726174696F6E73222C7B706F736974696F6E3A7B626F74746F6D3A2D372C72696768743A2D387D2C68746D6C3A747D297D69734D756C7469496E';
wwv_flow_imp.g_varchar2_table(2015) := '7374616E636553756250726F636573732865297B636F6E737420743D4D2865293B72657475726E206B28652C2262706D6E3A53756250726F6365737322292626742E6C6F6F704368617261637465726973746963737D686173497465726174696F6E4461';
wwv_flow_imp.g_varchar2_table(2016) := '74612865297B72657475726E20746869732E676574497465726174696F6E446174612865292E6C656E6774683E307D67657442726561646372756D62456C656D656E747328297B72657475726E5B2E2E2E657428222E626A732D62726561646372756D62';
wwv_flow_imp.g_varchar2_table(2017) := '7322292E6368696C6472656E5D7D6765744C61737442726561646372756D62496E64657828297B72657475726E20746869732E67657442726561646372756D62456C656D656E747328292E6C656E6774682D317D726573657442726561646372756D6244';
wwv_flow_imp.g_varchar2_table(2018) := '61746128297B636F6E737420653D746869732E6765744C61737442726561646372756D62496E64657828293B746869732E62726561646372756D62497465726174696F6E2E73706C69636528652B31292C746869732E62726561646372756D6253656C65';
wwv_flow_imp.g_varchar2_table(2019) := '6374696F6E2E73706C69636528652B31297D617070656E6442726561646372756D62427574746F6E2865297B636F6E737420743D746869732E67657442726561646372756D62456C656D656E747328292E706F7028293B69662874297B636F6E7374206E';
wwv_flow_imp.g_varchar2_table(2020) := '3D516528273C627574746F6E20636C6173733D22626A732D6472696C6C646F776E2066612066612D6C697374223E3C2F627574746F6E3E27293B6E2E6164644576656E744C697374656E65722822636C69636B222C28743D3E7B746869732E6F70656E49';
wwv_flow_imp.g_varchar2_table(2021) := '7465726174696F6E732865297D29292C742E617070656E64286E297D7D75706461746542726561646372756D6228297B636F6E737420653D746869732E67657442726561646372756D62456C656D656E747328293B666F72286C657420743D303B743C65';
wwv_flow_imp.g_varchar2_table(2022) := '2E6C656E6774683B742B2B297B696628746869732E62726561646372756D62497465726174696F6E5B745D2626743C652E6C656E6774682D31297B636F6E7374206E3D657428227370616E2E697465726174696F6E2D627574746F6E222C655B745D292C';
wwv_flow_imp.g_varchar2_table(2023) := '693D516528273C7370616E20636C6173733D22626A732D6372756D6220697465726174696F6E2D627574746F6E2066612066612D6C697374223E3C2F7370616E3E27293B6E3F6E2E7265706C616365576974682869293A655B745D2E617070656E642869';
wwv_flow_imp.g_varchar2_table(2024) := '297D636F6E7374206E3D746869732E62726561646372756D6253656C656374696F6E5B745D3B6966286E297B636F6E737420693D657428227370616E2E697465726174696F6E2D64657363222C655B745D292C723D516528603C7370616E20636C617373';
wwv_flow_imp.g_varchar2_table(2025) := '3D22626A732D6372756D6220697465726174696F6E2D64657363223E247B6E2E6465736372697074696F6E7D3C2F7370616E3E60293B693F692E7265706C616365576974682872293A655B745D2E617070656E642872297D7D7D6F70656E4469616C6F67';
wwv_flow_imp.g_varchar2_table(2026) := '28297B636F6E737420653D6574282223697465726174696F6E2D73656172636820696E70757422292C743D65742822236D6F64616C22293B652E76616C75653D22222C742E7374796C652E646973706C61793D22666C6578227D6C6F61645461626C6528';
wwv_flow_imp.g_varchar2_table(2027) := '65297B6574282223697465726174696F6E2D6C6973742074626F647922292E7265706C6163654368696C6472656E282E2E2E28657C7C746869732E6469616C6F6744617461292E6D61702828653D3E7B636F6E737420743D516528605C6E202020202020';
wwv_flow_imp.g_varchar2_table(2028) := '20203C747220247B746869732E6469616C6F67436C69636B61626C653F27636C6173733D22636C69636B61626C6522273A22227D3E5C6E202020202020202020203C74643E247B652E6C6F6F70436F756E7465727D3C2F74643E5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(2029) := '20203C74643E247B652E6465736372697074696F6E7D3C2F74643E5C6E202020202020202020203C74643E247B652E7374617475737D3C2F74643E5C6E20202020202020203C2F74723E5C6E20202020202060293B72657475726E20746869732E646961';
wwv_flow_imp.g_varchar2_table(2030) := '6C6F67436C69636B61626C652626742E6164644576656E744C697374656E65722822636C69636B222C28743D3E7B746869732E6C6F6164497465726174696F6E28652E6C6F6F70436F756E746572292C746869732E636C6F7365497465726174696F6E73';
wwv_flow_imp.g_varchar2_table(2031) := '28297D29292C747D2929297D6F70656E497465726174696F6E732865297B746869732E6469616C6F67446174613D746869732E676574497465726174696F6E446174612865292C746869732E6469616C6F67436C69636B61626C653D6B28652C2262706D';
wwv_flow_imp.g_varchar2_table(2032) := '6E3A53756250726F6365737322292C746869732E6469616C6F6744617461262628746869732E6C6F61645461626C6528292C6574282223697465726174696F6E2D7469746C65207370616E22292E74657874436F6E74656E743D4D2865292E6E616D652C';
wwv_flow_imp.g_varchar2_table(2033) := '746869732E6F70656E4469616C6F672829297D636C6F7365497465726174696F6E7328297B65742822236D6F64616C22292E7374796C652E646973706C61793D226E6F6E65227D6C6F6164497465726174696F6E2865297B636F6E737420743D74686973';
wwv_flow_imp.g_varchar2_table(2034) := '2E6469616C6F67446174612E66696E642828743D3E742E6C6F6F70436F756E7465723D3D6529293B746869732E62726561646372756D6253656C656374696F6E5B746869732E6765744C61737442726561646372756D62496E64657828295D3D742C7468';
wwv_flow_imp.g_varchar2_table(2035) := '69732E75706461746542726561646372756D6228292C746869732E757064617465486967686C69676874696E6728297D66696C746572497465726174696F6E732865297B636F6E73747B76616C75653A747D3D652E7461726765742C6E3D746869732E64';
wwv_flow_imp.g_varchar2_table(2036) := '69616C6F67446174612E66696C7465722828653D3E652E6465736372697074696F6E2E696E636C756465732874297C7C652E7374617475732E696E636C7564657328742929293B746869732E6C6F61645461626C65286E297D757064617465486967686C';
wwv_flow_imp.g_varchar2_table(2037) := '69676874696E6728297B696628746869732E5F776964676574297B636F6E737420653D746869732E62726561646372756D6253656C656374696F6E5B746869732E6765744C61737442726561646372756D62496E64657828295D3B69662865297B636F6E';
wwv_flow_imp.g_varchar2_table(2038) := '73747B63757272656E743A742C636F6D706C657465643A6E2C6572726F723A697D3D652E686967686C69676874696E673B746869732E5F7769646765742E757064617465436F6C6F727328742C6E2C69297D656C736520746869732E5F7769646765742E';
wwv_flow_imp.g_varchar2_table(2039) := '7265736574436F6C6F727328297D7D7D4D6F2E24696E6A6563743D5B2263616E766173222C226576656E74427573222C22656C656D656E745265676973747279222C227472616E736C617465222C226F7665726C617973225D3B636F6E737420506F3D7B';
wwv_flow_imp.g_varchar2_table(2040) := '5F5F696E69745F5F3A5B226D756C7469496E7374616E63654D6F64756C65225D2C6D756C7469496E7374616E63654D6F64756C653A5B2274797065222C4D6F5D7D3B636C61737320446F7B636F6E7374727563746F7228652C742C6E2C692C72297B7468';
wwv_flow_imp.g_varchar2_table(2041) := '69732E5F63616E7661733D652C746869732E5F6576656E744275733D742C746869732E5F656C656D656E7452656769737472793D6E2C746869732E5F7472616E736C6174653D692C746869732E5F6F7665726C6179733D727D6164644F7665726C617973';
wwv_flow_imp.g_varchar2_table(2042) := '28297B636F6E73747B757365725461736B446174613A657D3D746869732E5F7769646765743B746869732E5F656C656D656E7452656769737472792E66696C7465722828743D3E7B636F6E7374206E3D4D2874293B72657475726E206B28742C2262706D';
wwv_flow_imp.g_varchar2_table(2043) := '6E3A557365725461736B22292626652626655B742E69645D2626216E2E6C6F6F704368617261637465726973746963732626216E2E24706172656E742E6C6F6F704368617261637465726973746963737D29292E666F72456163682828743D3E7B746869';
wwv_flow_imp.g_varchar2_table(2044) := '732E6164644F7665726C617928742C655B742E69645D297D29297D6164644F7665726C617928652C74297B636F6E7374206E3D516528273C627574746F6E20636C6173733D22626A732D6472696C6C646F776E2066612066612D65787465726E616C2D6C';
wwv_flow_imp.g_varchar2_table(2045) := '696E6B223E3C2F627574746F6E3E27293B6E2E6164644576656E744C697374656E65722822636C69636B222C2866756E6374696F6E28297B77696E646F772E6F70656E28742C225F73656C6622297D29292C746869732E5F6F7665726C6179732E616464';
wwv_flow_imp.g_varchar2_table(2046) := '28652C22697465726174696F6E73222C7B706F736974696F6E3A7B626F74746F6D3A2D372C72696768743A2D387D2C68746D6C3A6E7D297D7365745769646765742865297B746869732E5F7769646765743D657D7D446F2E24696E6A6563743D5B226361';
wwv_flow_imp.g_varchar2_table(2047) := '6E766173222C226576656E74427573222C22656C656D656E745265676973747279222C227472616E736C617465222C226F7665726C617973225D3B636F6E737420426F3D7B5669657765723A4A722C637573746F6D4D6F64756C65733A7B4D6F76654361';
wwv_flow_imp.g_varchar2_table(2048) := '6E7661734D6F64756C653A696F2C5A6F6F6D5363726F6C6C4D6F64756C653A706F2C6472696C6C646F776E43656E746572696E673A436F2C63616C6C41637469766974794D6F64756C653A536F2C6D756C7469496E7374616E63654D6F64756C653A506F';
wwv_flow_imp.g_varchar2_table(2049) := '2C7374796C654D6F64756C653A526F2C637573746F6D50616C6574746550726F76696465724D6F64756C653A5F6F2C757365725461736B4D6F64756C653A7B5F5F696E69745F5F3A5B22757365725461736B4D6F64756C65225D2C757365725461736B4D';
wwv_flow_imp.g_varchar2_table(2050) := '6F64756C653A5B2274797065222C446F5D7D7D7D7D2928292C62706D6E5669657765723D742E64656661756C747D2928293B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(14512053781670608)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_file_name=>'js/flows4apex.viewer.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '40666F6E742D66616365207B0A2020666F6E742D66616D696C793A202762706D6E273B0A20207372633A2075726C28272E2E2F666F6E742F62706D6E2E656F743F313634303632383927293B0A20207372633A2075726C28272E2E2F666F6E742F62706D';
wwv_flow_imp.g_varchar2_table(2) := '6E2E656F743F3136343036323839236965666978272920666F726D61742827656D6265646465642D6F70656E7479706527292C0A2020202020202075726C28272E2E2F666F6E742F62706D6E2E7376673F31363430363238392362706D6E272920666F72';
wwv_flow_imp.g_varchar2_table(3) := '6D6174282773766727293B0A2020666F6E742D7765696768743A206E6F726D616C3B0A2020666F6E742D7374796C653A206E6F726D616C3B0A7D0A40666F6E742D66616365207B0A2020666F6E742D66616D696C793A202762706D6E273B0A2020737263';
wwv_flow_imp.g_varchar2_table(4) := '3A2075726C2827646174613A6170706C69636174696F6E2F6F637465742D73747265616D3B6261736536342C643039475267414241414141414436454141734141414141756B414141514141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(5) := '4141424855315643414141424341414141447341414142554949736C656B39544C7A49414141464541414141524141414147412B4A45733059323168634141414159674141414A794141414864464E316C2F686E62486C6D414141442F4141414E446341';
wwv_flow_imp.g_varchar2_table(6) := '414B4873755444364647686C5957514141446730414141414D4141414144596A42794A766147686C595141414F47514141414162414141414A4163384137396F625852344141413467414141414245414141477770654141414778765932454141446955';
wwv_flow_imp.g_varchar2_table(7) := '4141414132674141414E72765539455362574634634141414F58414141414166414141414941475742485A755957316C414141356B4141414156494141414939656A68316C584276633351414144726B414141446E674141436967512B4E7937654A786A';
wwv_flow_imp.g_varchar2_table(8) := '59475267594F42694D4743775932427963664D4A5965444C53537A4A5935426959474741414A41384D7073784A7A4D396B5945447867504B735942704469426D673467434143593742556741654A786A5947462B77546942675A574267616D4B61513844';
wwv_flow_imp.g_varchar2_table(9) := '41304D5068475A3877474449794151555A57426C5A73414B41744A635578674F76474238385A4135364838575178547A476F5A70514746474645564D414C586344645A346E4F585652314A555551434634622B6851614A497A6B6D554A45457941674A4B';
wwv_flow_imp.g_varchar2_table(10) := '52736C5273704C746262494579776B4D59485A336F6666306361524C454F716A344E337A4E393346413441734944507169704B5163555969666B62694946354E704B396E6B70652B6E6B7A30784B394C654247765A4952454B4171393454616B776C3134';
wwv_flow_imp.g_varchar2_table(11) := '43452B2F666B47386C677A466F533939375434383674706662346E596C39444F42542F53377A2F54317A4C694979626A4D386E6D47546E6B78752B5854774746504B636F66726669574A5253526A6B5656464A464E545855556B63394454545352444D76';
wwv_flow_imp.g_varchar2_table(12) := '6165455672326D6C4C5435324235323869632B376D783536655573662F517777794244446A44444B4F3859595A344C3354444C464E422F347941797A7A444850416F73737363776E507250434B6D75737338456D5732797A7779353737504F4641773435';
wwv_flow_imp.g_varchar2_table(13) := '34706754546A6E6A4B3938346A362F6F6B69757575654757373654697938722B3539582F663238462B704256397565726C4F3452303730566B685A2F2F6F517330373059736B33335933686D756B39446A71487A5845506E6559624F3877326446356A75';
wwv_flow_imp.g_varchar2_table(14) := '3331426F3650793536646D46496B506E7859624F537779646C31713846776C6C6872626C687259566872615668725A5668726256687259316872613168725A31687262316872594E6872614E68725A4E6872624E6872597644573162444731664764712B';
wwv_flow_imp.g_varchar2_table(15) := '4E7252744E6252744D3752744E3754744D4C54744E4C523959326A625A576A6262576A6259326A62612F7162452F6F4D6266734E6251634D625163742F693454686778317734613645555064714B48756E6146757A464133627169624D4E53394E39524E';
wwv_flow_imp.g_varchar2_table(16) := '4775716D4448585468726F506872715068726F5A513932736F57374F5544647671467377314330613670594D64637547756B2B4775732B477568564433617168627331517432366F327A445562527271746778313234613648555064727146757A314333';
wwv_flow_imp.g_varchar2_table(17) := '62366A37597167374D4E51644775714F4448584868726F54513932706F65374D555066565550664E55486475714C7377314630613671344D6464654775687444336132684C6D576F757A505533527671486778316A78622F487843656A4E5276524D4A44';
wwv_flow_imp.g_varchar2_table(18) := '4C414141654A7A7466516D63484D56316431645633393354505664337A387A75334C737A732B66634D337449753674377462707672533751775357774D4C633568496D4E7751675A38414632754D5268726868384148456334786748766A695959447432';
wwv_flow_imp.g_varchar2_table(19) := '59755059354C4E6A7833627746544279386E3138327546373154327A75354A5731344C457A34366D70362F7136757171563639652F642B723139554D787A427666593330343138795455776E6B3265476D43554D672F69456F4B4577676F315A6A426371';
wwv_flow_imp.g_varchar2_table(20) := '715377716C314C7056444B52546E494A33764A46454132752B6971705A4A78725179547553795131524D4D48554A70306F3959454C78412B6775776F36416D6C6C5A6546783256426B5046374A5547514875556B3376437143326F2F6C5856555143345A';
wwv_flow_imp.g_varchar2_table(21) := '66554E323453476B4B625766317359515161532F746D30527771714F4F374858644D48576854545A6A5742766565424D783739456D426842715166724C70654F71334C49547A4236535666477669653556426D334B2B35385455436652313631396A5646';
wwv_flow_imp.g_varchar2_table(22) := '7733344644636F306A6472664B6E36734B57684939544945796E346E2B524A4A4D4737477A38794363696345785073745A42617171464A4B6F35516734646145546F776B72464653704F73674B644D3153354B776F763236557473717932696645715562';
wwv_flow_imp.g_varchar2_table(23) := '4F46463064455074717470563647714D57594B6559324744434D732B527A636D65316751536441556F67636C4D32416E634D505078794D5A33464753596E676F782B336B71365146366A44504C47544F5A4B356B396B427055674A5046394D7972516971';
wwv_flow_imp.g_varchar2_table(24) := '447542714A64324E30716C304D6956554C427071386C444471585133584B6B4F494B736533376B4549526A6964694D6E726D44613134414A30716B4B524B2F416D63554C706C57314B6C5549684B42556D74635273416F4E457977687A5174702B784A36';
wwv_flow_imp.g_varchar2_table(25) := '34344B7A7473366172616A5647544E584C667572746575765838627A6B6559726C69316652777A333973326A66544E4561656241304D4E504C316D2B49325A59765430506E4C46787A597043476245744C62506D726C7879372B43736557776B4E694E33';
wwv_flow_imp.g_varchar2_table(26) := '7A657A6C497773364F6845614868686174474276736549332F4F6E307A4A476D634E3937657972746E627375366F756B43734857664B43394D35687244525A537654323753686465564C366F5A6151303067715853414A58796873325837447069777448';
wwv_flow_imp.g_varchar2_table(27) := '4D686D6C4F587A4670306333726C70315136614E77336D537A3631617533333934304E7A2B7430646E62632B74575A303974796C4853535858625A793436726C53797339626E6472727244336759574C43783235484F35736E7A2B79664E484E6E566C42';
wwv_flow_imp.g_varchar2_table(28) := '7968664C38326266316A387A30584668704F2B69536B396E2B363733396F5670566E4C427A765A4148724A43656E6F764C4F3243724C5243566C726745734E346F4E346574506D50514230717A464C6D59655941476B5366514B2F6A476668612F427A68';
wwv_flow_imp.g_varchar2_table(29) := '7943627947506B444F77693136596C37754B4A514E654A6C79354E5043724159734F71434557574C31664846476C384775584B57533661545A566A54566C4C6E6F7346426C764A747567784C4D6F7667442F743075583445782F5355486B4F494534564C';
wwv_flow_imp.g_varchar2_table(30) := '3674694168794344376D48525566334550714448546867326F6C78784D466A4F73764638306D6B753743483569664A326C6E41794B394563305A78427974684F673659467964756C6767524A30724366417345303254413075437A686F41516D54525A4B';
wwv_flow_imp.g_varchar2_table(31) := '415A6B5736595A4E316774417977515A48793853686F4A43356A6B6A615765626269326A434374646F684A4E412B4B6B783566712B4A4A6C4F5A703977624A76744D73733275326568347544416D794B647279303877525354784E5370592B49596B6449';
wwv_flow_imp.g_varchar2_table(32) := '51504C4B654F4A326B68784E5351637944654C7949436F44626371447544676F6C3674774759714761534B55544C67595266576330694D496F2B6B69534A716D546B6E59444D6D4A5357463830566C4B2F51594844437030672B79486C476C4761504930';
wwv_flow_imp.g_varchar2_table(33) := '4171526850774353676D51704A6363727859776E645169424535486D3355366F624B6468463456466158526E37572F2F2F654B3761792F637266414B703349636E2B4A6C6B6355676B544450536D77484A3348776B376B49725053414455676774466757';
wwv_flow_imp.g_varchar2_table(34) := '4964674B4B59376E34455A2B503864794549697869465642464F41534C43424B64437868346F455453514B52786F4A777838377152524C4C67377944506B476B47316845466C4A6C5263544B5936397A724D6A424363757173496F4532656D7845744C70';
wwv_flow_imp.g_varchar2_table(35) := '37595444384842436A3052573467534F632F4F59787A6F387A346B6E51464943784D53454A756431795A7A4177346B6F73764351464B5148695171774378465245416955783834625A4267526573784375564D7344655A63543741694438475142514E79';
wwv_flow_imp.g_varchar2_table(36) := '515A43455643524A78433447504231426B6530446A7055674576514D754C34516537562F50456C696D7A68514B6E5139422B574668486779486C5577455351454964437A5145593479636B5070497A7342665949696244436459534642676C3541766B67';
wwv_flow_imp.g_varchar2_table(37) := '374E6A7A6B43776B5271506150347845656B526F4B53457451705069795068466D6E454A2F7735753470307771444D375A5A4E5771517033384644424D68616452777432484D6950654F41524469684937774669772B4D677831694778416E6679444A47';
wwv_flow_imp.g_varchar2_table(38) := '336B614F42547474794379485877506930497351426D6555423153344454736378456F694A78436F5670366A4A6551623930744F375930422F59476D5144706535594830554D4F3046714457594B566341356474486D4670446F4176674765495156685A';
wwv_flow_imp.g_varchar2_table(39) := '434549523676514853746D45467448646B424D6B794D324B344755565941484B42617A6266674B79536139794C7367744A3349704F3047624932337542433645454779546E655671637945576A78316D6843677543626B5179394644326C61435142732F';
wwv_flow_imp.g_varchar2_table(40) := '443631466B5357757A7666416C54364F526F462F617752794C616E45686232303353412F4A59505A61562B4574596E6C57627561614C45494E44414935663349626F47555556697532555733704D486962395A655144333544514E662F764A753948744B';
wwv_flow_imp.g_varchar2_table(41) := '64344669464A736F484A52646174513968385A356C524337596C66526D68636B53556253704E596A2B466B587938596F55396E634C5545726E2F526B3057365A496E49493437524F784D4E39454F77306158567969366172793349536B4B414D4B6C756E';
wwv_flow_imp.g_varchar2_table(42) := '4353656F455570562F79534A4153746E5636626441446A4B6A715442703842416D4743483669496E6956514F4E4E6946526B6E582B55756E684A46554356486D702B78434641436E556B4E717159546C7831736E6E6D69474C444670575355675137394E';
wwv_flow_imp.g_varchar2_table(43) := '6652656E544D53536B30516741717370734B504E44526F595A6B56676954716A63413431454848624D6F306747645566546D6B6A495A7247597A6154306271484B6E4378545A784C6F6D564662494C6C364B564768634C6C5366775A6764552B5A4A3157';
wwv_flow_imp.g_varchar2_table(44) := '316F566F456978626C3867536C7761656B575332414851564B566679346D515735427379327553425A49523177335652346A30514368492F4469736E4138426A555A435445637333436961694E6F64624A53375236414D7344735171377258704C304347';
wwv_flow_imp.g_varchar2_table(45) := '516B52523743727A3638424F496D303444733941307A5341366B68773131756E4C564935454832512F2F756F3849594F51624962744D707A744E79554F55412B32714B4F74515642585659424F396A79445771594A3237436A3163583739534E4D414C78';
wwv_flow_imp.g_varchar2_table(46) := '434B39435137526C6E4A323249784674707045615968545642536C4E485151637A537749624F67427151437A2B7743516B6C4252764E51517347524344447164446451616C6431736E653251472F6F64776B6C45706B6E72634D69722F766F6C454A4738';
wwv_flow_imp.g_varchar2_table(47) := '784E6F3943326B384777517A384E376B487444756268775A7A54414D31646E75494839446B6F774A654C2B504757446D5572537645634435474941386865633230702B412B666153546A6B4C49487366314B514651464A492B3431304B367741302F6576';
wwv_flow_imp.g_varchar2_table(48) := '662F6A5035714B686D663333663337463668765362614441525335667575583874537558392F56626C7458524F58662B6876567231382B5A6B3034526B6F78632F496E427967585A37377A34597542574E4E6F2B4A30455361503631397A2F31384D4467';
wwv_flow_imp.g_varchar2_table(49) := '51696B53766D724671765872317179364D5A584E6F3154726E4C6D726C7A3079504A497475585854374B307358375A7577394B463778313469306B7469582F69316C74523574597A643579313436797A7A6F726B4C456143386A3041754467476D4E6869';
wwv_flow_imp.g_varchar2_table(50) := '566A4C506F4C6E6F6676516675494476685849436D4373615255426867422F68414534423470614C766735555234383232426B6B42774669514478556157507261466A6E6A61674D3449636971716A4C786A67554F476235704130694652736443306B48';
wwv_flow_imp.g_varchar2_table(51) := '596E4955344C49472F4276676C454A563537774F686A454667685131477270735545512B614D5055775254564553464445324479344D564737344F51572B51674E6874334E52446D3543566468334631574F69414F5874783443464C692B427134453134';
wwv_flow_imp.g_varchar2_table(52) := '7075586B6755796F426D566E4264425A4C5A5A74597469346B464130534D6D4137514D4848426272534A53437A324A556F4D3841556C734F474B796A3936796368474E514D64426E642B2F65753376335A56743237345A2F555844784C706551646D6B4F';
wwv_flow_imp.g_varchar2_table(53) := '6F6F415779644A4F32514C4A41723832757547354B48536856415477524159396B58634A72314A5A54796A37557752476B5957494E45416350425855646B73674645345347546F71795A483747494268485563424E6B4563445947756745702F354F4143';
wwv_flow_imp.g_varchar2_table(54) := '676452784A4141516275774E546B4234516F7254434A68324F2F5368647250443948376137476E76596264564B6D7A715851655675786F4647665479424F617955366C4449346944626242446977555369416F616C6863352F4352492F58726E5A497372';
wwv_flow_imp.g_varchar2_table(55) := '754D4C5242733554636345376D4E655770355263474845492B735878364C513745673838624F4E6D4F3434744257576E36485A65614D667345415243424E59425278516C495242642B4174323979367A4F7368346E594945454F55415A5469373633644A';
wwv_flow_imp.g_varchar2_table(56) := '504F2F6E6B4A63584F4F51737A556942486677564B7574746B55737A4D50612F7159697961344A314E65516555554255675542746B494A57494632674B7959754573624578524B5842436A4A5359526941442F32414A4432594A446D30465667414F6F63';
wwv_flow_imp.g_varchar2_table(57) := '747139364B43794C5530626175397343527270324D2F6F3453456445433258336448576F797A71453461437A6849536766437A7441705A4E3446686165734265574E5367642B576465725978412B325076624A494B786C6B7441793455425764506F6546';
wwv_flow_imp.g_varchar2_table(58) := '486F6851315143716866494D5348624B52646752794344765652752F4F7A786956374F64714E4D5A4E58694D696E4B4B2B67696D634D504746725232472B416551643868326E76494B4A5465426C6C3146514475494668746F41744B5057416634454165';
wwv_flow_imp.g_varchar2_table(59) := '55376B504853434C616C2B485239725A4C554C32654678506C3764424F70515541516A6865466D774B6544414D62674B4C51317867703643394B4267684B332F42614B52546742476C46393844745A723467576634504C783048716A7267597630495869';
wwv_flow_imp.g_varchar2_table(60) := '4D6A7335535249684F64367455456A4163316B34686D5974554A577039695256416C6D7142304933523875674970766B456B55536C4776344F72596D4F6D396A48565A514B51536B654E61473752524C7348592F4349436F336834426E584A5550786E76';
wwv_flow_imp.g_varchar2_table(61) := '6C3546542F784B79436339436A32385841514563704A5367523569695741636D7542434776684C427970416866414E54705059394456463757436F746D42593157416E646946712B614C387061446964346950494B6C517252576F726F78306F39677863';
wwv_flow_imp.g_varchar2_table(62) := '74745A72574A6E4F44656F4479324E366939576373494B4A78446B585A7273475456575A7436336B38694A44457A3071502F50386561495558317961677A3955336A4A6A31743671364F325036666374463969505A69343450395065525A71733165666B';
wwv_flow_imp.g_varchar2_table(63) := '6936747A43506D6249486459476A352F6F502B794D35746261425A705076487638423434457144665933796534766A7935673736773376474873587247797445642F724A7235413433434D79436341434335684E7A45584D39637A743149597278414551';
wwv_flow_imp.g_varchar2_table(64) := '7843732B506B6C37663441424642645946424A554B416F51556C62643147655A46596F4C4F49696D49397341574C564E66494E416E496F545944695778414655486B41414C54676E304C3633584B4B706C627352636D4247676C367A37366678366B2B67';
wwv_flow_imp.g_varchar2_table(65) := '6543535A79694B302F38777A30585666323147736662643472747263356F33496F6C3974396F6961464379474E564F526D774F472B4B7559776B6330726A33684E31697462393759362B456D6435506D556741566856326D573962647269416E346A2F33';
wwv_flow_imp.g_varchar2_table(66) := '55396B422B4447473351476635654F783638436E4C525A456F434B3666416D33434D7A7477702F31745554306B4F56704A6178564C5A6336426577612B35635178356F6533374B35466B746150637437654678342F416D55656E7244427651396B4C2B69';
wwv_flow_imp.g_varchar2_table(67) := '356363494A434C746A554368313153715A79325444566449356249444C6C39474F614E4456734F656C4D3856434F6B2B3374335337444A31315654397465397766695873466C335372426B656A66567068666455424D6E4C426257454A58554655694575';
wwv_flow_imp.g_varchar2_table(68) := '714C66366863475A6F6C4A3753724B386B6F7333584C6F6968774970776163683261743558584B6E704F6971456368546E7069774565704D4647723455755A466C4547586F43396944572F45392B4C2F496F764A4C655366324368374873574151507336';
wwv_flow_imp.g_varchar2_table(69) := '424B513158496D41614F6A47746E4558716C5944526F63713741654951356D2F417832336F55356E6A39744D6C7A78524F35304E51303763544D6478527A57704A552F517068626D706A43706C59396F556B73534232366569416C324F685A597A4A3277';
wwv_flow_imp.g_varchar2_table(70) := '4154614A6A746438435452696A3874386D6651353944694B426448696A6D7041544B4C395178646177634461612F746D726B4473334E364F516D7134364E4D365A69316631424F537A4D4479375A492F4444424770417276364B67337051327932747378';
wwv_flow_imp.g_varchar2_table(71) := '79483042494E6337615A446A305057326B76594F5775536B7362382F63597363697A387966544D5A4E2F5A5A423861394D335979445431304444755A35376A4D5A4F776A67435865686C58355039394A6F374934747638644D79717A2B484D6E6244356C';
wwv_flow_imp.g_varchar2_table(72) := '4165757A30374366737039345230794E4C6878364230794E4C4336685266323931343147444F4D3951774D58685977305373786375486777493452366C71794974335957764D6B4B306A323050515554633858666E7267564478724B4F3254476D324733';
wwv_flow_imp.g_varchar2_table(73) := '755866636A49632F383437593864415662394F51646A2B56644F2B6349593073655875574E50797464382F30444572564F32703772763364327A5379417548666E705556644B2B33623564304C433976317A4A3575422F43653569725472596667755766';
wwv_flow_imp.g_varchar2_table(74) := '62424173544C49496E6E792F6738432B665666743237653174575866766F583333586653665173324C3131367A64313358334E33344A3652652B345A59554250504A5465357748464C7A6E70464A2F43646E7A53535433764546507A535362316731505A';
wwv_flow_imp.g_varchar2_table(75) := '70512F3246356F39746239514E61477A5557684B55585951522F45676D3857444F4D7671474A443055627946396F4F4D30366C337A3030333061304F62597139365362612B7159495059724C30425048756E63693144615032475736677A774C5A577069';
wwv_flow_imp.g_varchar2_table(76) := '4373776975307954656164694B354D4F397877386E6B413570474A6650354972554272392B6F4C745A77344F795572767A494856533539657457356F7A6E4A524344646475574C56714574664E6B77726D677A317A68696566317531742B424F5A596153';
wwv_flow_imp.g_varchar2_table(77) := '4B786363795A65484A4B71566A5A7650332F5258433062534B616A792F743737313239637465626D746E595733594C624D764D574C46743455336465316470792B52732F4F544172615A69376A75534D777A41796C50746A3547394A6B6D6C6D7173774B';
wwv_flow_imp.g_varchar2_table(78) := '5A69647A496253634B3569726D66637A4836525553453546687A6F5A4373564A684E425166565446626B6B483357633639484561553646596D455339626D70476361686E324A34396E715150684A677761555676494C783979386168326159523663344F';
wwv_flow_imp.g_varchar2_table(79) := '447A3835756D6E52794C6D473262526C654F48616E6E364F3237523264572B66376D34766C5563575037317154662F4D634C4D6B6435652F7449766A566939625643684A5371576E622F48775066506D642B556966714E537647555A4959766D7A656E6F';
wwv_flow_imp.g_varchar2_table(80) := '354D567175576665334673766A7956774E4E3658326234446464642B56617546586E522B4A4E486474585435317256504C566C614C4C6472657137376F327658505846587065725838716972592F47536A5373666E54732F33533748346B4F4436316150';
wwv_flow_imp.g_varchar2_table(81) := '6268785A64313548522F76777774584C37756D663064546B616B304E446A32346247562F333578634F6A5530613947436D77736C723739707A6344514862506E645551545636713132394131676472544B42304D6A67514361774B424A594541384B4E37';
wwv_flow_imp.g_varchar2_table(82) := '334E3542783334324D452B432B725149335966473844446567373946504F52633870665153793836796B6A5161652B6F303935527039513736714142734F787042366E54446C4B6E4861542B4742326B44686C2F765032306939527046366E544C6C4A2F';
wwv_flow_imp.g_varchar2_table(83) := '6A4335536A446975712F6D5A4E715962644A754B37536B31753648682B436B554C31423974755267656E727570316353394C786B762B4E775247692B2F3671645A383859474A6878397337396A594F72646D335A574B355779787533764E493461447355';
wwv_flow_imp.g_varchar2_table(84) := '5652393067333251502B67472B2B423752384C47387268666C444D576541487A50625146505150305749792F64494B6A662B5330753953373553353177694E682F616464716B36375645335870656F457832485138476D6E71394E4F56322F5036637232';
wwv_flow_imp.g_varchar2_table(85) := '5A534978764837636C386D496C376E362B734B4543784E6576325048432F626638576E2B4A2F4C502B46576D6D566E4C584D3773596169766234495865684874715733584A4C6A624E7256567972326F524B3177744D754F306D36746D43384D49744F67';
wwv_flow_imp.g_varchar2_table(86) := '3354634E4D2B4351646E694A5642616C7971567169666F79706273524842617178597151792F4F3256613967323750547562787055644E526661333445686F79504837374A64634256506155756C4753697863694E464244795869696D77594F49445463';
wwv_flow_imp.g_varchar2_table(87) := '576B41794C7957736949375159715248724C69565830684E7553414441414C7873696F44322F46657A4D75556C6C4B6B4A534A5269736F41726D554E6B4332574570522F31565237537157635850446D2F486362575A395748693344482F65564E35524B';
wwv_flow_imp.g_varchar2_table(88) := '4738706A5838643972514D744C514F7459312B333933683750756B314E5558562F63333451782F437A583564746471542B61796A3239714B717171624C6C337867727745486F48366C4F46487663376F4F6649544D61463533496838514F564256344D66';
wwv_flow_imp.g_varchar2_table(89) := '4277646D37494C46384C736767526156527375315865585245757A527832412F6F32566D6132315836387757324B4F50776436754D366A6E572F4848362F57734D7A3771743059686B354773786F3234554E2B506B737142332B376239787A7548767675';
wwv_flow_imp.g_varchar2_table(90) := '632F55392F766A594A2F463533336E6969536553447A3330554A316E56754B764D4378674E7A2F6C475A705133424F66624F61374133396C374C313478396A64694C7672726731333359572F45687A626A4C2F534351467630764D4E6439466B324C702F';
wwv_flow_imp.g_varchar2_table(91) := '66494B786D43497A36466931442F654F54317154446249487563646277684673692B693164512B3966796F6E6558484E3871573966655A5558764C4C356B3832443548452F4E31544F636D6E5537506E72707A6B4931396555666552522F383457536D64';
wwv_flow_imp.g_varchar2_table(92) := '584437482F372F2F784C332F4B52784D4534686F4552716A4B71534661586A2F482F416B697464646167306E6237684A304F596B4975467243744E34426543666B76504F65376A324635474E3358654376754264307A376E306F38755961595953397A42';
wwv_flow_imp.g_varchar2_table(93) := '6E4866795237627150704D6E667A78727A59516635456B667A4E70653932326B76484D34585863796C353173756E4B48387873766E4877614933775968327042356153542B2F49704F4E7073385230363174592F726247323863485836597974425A3142';
wwv_flow_imp.g_varchar2_table(94) := '31476D4D70443077506835616C7A2B766B632F676C304465647A425A5A675A4936364E326D5233303566566B6F3976306756437668744745675031422B344A322B4F50653967567462517661782F34653934627A7A633335384B57317A3135694833304F';
wwv_flow_imp.g_varchar2_table(95) := '2B57752F7557544A6B75346C532F424C454B5732336F6D4B486F5639446D4C57316B4D38564B7139424D666F555469752F586E744E372B314B743330486D614B5042656E6B5766493773764F63334666506176514C34396E39644A7772726B3539336D61';
wwv_flow_imp.g_varchar2_table(96) := '31645A2F4F5035732F767152624A5A68384B543870592B5674776B49637354386A4833647A73315273744849777146384F575061664F6B3038656B7735766648472B6F3065504F79696659326C5877376E376E7935506362574B414846703339496F7253';
wwv_flow_imp.g_varchar2_table(97) := '396D5636345254304934456C6C7457653975384F3567757143517063304D764C535047624A332B6D69396D314E325A5A7551376A78715833726D685A754774454350734668592F5057557A626D3344592B5072567A46344830352B796B585572635A4242';
wwv_flow_imp.g_varchar2_table(98) := '44504465684555736967347A695A334B38666273344155483234445931766D46795561677A757168567143545069612F64655267513046797876416B4F77484B4832776F4F4179487A6D42475468794848716E646E4467615858626B686E44436D50536C';
wwv_flow_imp.g_varchar2_table(99) := '49375032775755754D33306E58755947787078474753654478684D75316463614D4641593137567058394D4266574556304D6A67386663366C71326167547165744E556B5738636A635072794D625257684E36734E6146763178347A74323362396A3630';
wwv_flow_imp.g_varchar2_table(100) := '72766259356569622B4E566A71707244746576524E5238383935787A6A4C5050506873747665414375372B456A6D7333364A346A7A464E326A39574C2B50475644794F2F5264563673326857653048504C356653525772737A3166534136674556645342';
wwv_flow_imp.g_varchar2_table(101) := '624373436653324A63393530736C397379714B386B437359426173586D585A535645675966697366515A625A6A3878717365414D45335167493034506A627966543861645934685071575459635978653541634A6C7554547659694F4B4A52544D354539';
wwv_flow_imp.g_varchar2_table(102) := '7141423567482B78564551767562777A763554316952694A3771374D7246642B4641707A3770446D346E6D3171556B54413572423637437450632F78724F626A646462466532554F4957726C4538537761736F5963774C42367149374C754A4656685259';
wwv_flow_imp.g_varchar2_table(103) := '2F66646F4149344557613839683352426F6D4D33696C4A372F5A736354336765382F7950667451626962734568486C50792F4E356755583434334C6D75746867494F5A726365555473794968684A4C4E756B64544168474C78507639736B767A6848324B';
wwv_flow_imp.g_varchar2_table(104) := '697542426D69483475723279696C455369554A496B734F7134594B454F643432716E4A71564F4B544C43643766577153353132474B69554A4B3370304F6A61452F47594A5254726C466D2F594B415A766A4C476F5953666167336657357A397962416478';
wwv_flow_imp.g_varchar2_table(105) := '72705672396354504942316A475878393761753157394446364A4B784A72787A374656734A662F357866333761373032586D727763504B496E47744347465250496755686C562F3262753246507734352B3746663446424858312F483243396769312F74';
wwv_flow_imp.g_varchar2_table(106) := '4F614F33747166336A4237596F387468763675337262616E726265334456336531757659707962476B2F715952637A6D45786C4A4F74477536506A476C335A4F70786335726A476F767A6E52767544674F516B717A42417A2F30516C6F2B41336F506F4C';
wwv_flow_imp.g_varchar2_table(107) := '5265644B7175716E5531314E51307065532B63717576686950525A77476536686E3956657548736177764C2F3348303336736C4C7A61616B34784B3365664F58647A76394863575753634357525A41375734385456396178346A67716F51464741385930';
wwv_flow_imp.g_varchar2_table(108) := '6B4B584E4E594C2F4547534A58727467783962427777446B5A5575587253564E3350614E3633763665484857304F7A564B37367765476D754744504E7672354841416B737A78667734746E7A5669362B6132426F4C68754E7A5368635631367863454662';
wwv_flow_imp.g_varchar2_table(109) := '4F316B346332696B6752387A4D3563416153684D505039676D4C675359434B5038366859574C31752B2F7250444D31716176613164793559384E546130646E7A6C335958637374586256783156376D7136656C63336F614A6E646C385638667779497152';
wwv_flow_imp.g_varchar2_table(110) := '477A7537786C4869514C7872617076447563784670386776764A6F4759434763476E667747332F3630346475416B336D37422F2F2B4B536A3730734C68612F75655034716632626D6C5A5550486562484F334F614F6C77446A6B334C63376474416F464E';
wwv_flow_imp.g_varchar2_table(111) := '7831643345756171593875642B414779456B726D5A79496763356C57364761527031696F5145634B76546A6470704943644C625132554E2F4C46417477446E454439512B6A546256507633354E5774584A474F707A4F7265336D676F6C73687835566133';
wwv_flow_imp.g_varchar2_table(112) := '747A6B38702B315A3868396A6C6455722B36354F654F64586D35646E326E65305A464A74795631656632346746572F5943795A3876616C33384E537A512B5A31596D517864666D757A784870654837585A347030484D434C67356836646A702B3448416B';
wwv_flow_imp.g_varchar2_table(113) := '35487052376D6854522B356D575979323035456146335863324C375848737645684E32376E653564644E78774F384973367A3038496E57714F4354617A55647847502F3663535A373650505A6252417864506A54633466524C7352456A30413748566E78';
wwv_flow_imp.g_varchar2_table(114) := '61746F536B6B667A6A45633343502B3445736B725833356D2B42664452796E49543768506A6F3164652B4D72727A69326C44767237307A5445596D44487077514A4E4A2F304A4E6F657039414E3944486F6663646B726853572B426B3433436569445064';
wwv_flow_imp.g_varchar2_table(115) := '52356F7856454F41524143486C4B68636A7944417A6F4363365944523059725A7537576E5A2B7646644E4E625846736F72443262626F3553344F2F5759385047717365477A65452B2F5350546B77557067633656304C6868584E6D656C6D436F464C4B7A';
wwv_flow_imp.g_varchar2_table(116) := '4A6357725A5672504B2F6430646F654372476C3252685A4E51307173774B4867614B6D6E574D713074764A434C467A495870677278514B68513870636D616238452B4C544B68395679365A526D4732505032487A716D4D6E435548664F4A35725544634F';
wwv_flow_imp.g_varchar2_table(117) := '793352686370383444696651617A7532624A7731322F44487A6C7934344850724E7977634F632B304E4E65326B63576A7066544933466B643042336E69715562627073786B45674A674154617A79614A624E667946647657506E56586F5A6A5239477A58';
wwv_flow_imp.g_varchar2_table(118) := '5239657358377668336B715056376D6C7451564130767962692B554F43672B473770773333426D4C483852544953624C39423656766F6630336D6A69726145346146717043524C5047466939374741534E7A636F334E642F437957776E73344D44613974';
wwv_flow_imp.g_varchar2_table(119) := '5758414269414372773732414A486F7147375941576E476F334E7A664E30376C6A7A53496E4D32464B493376474A7956374667624B6930646D2F766866476C69334B7A424939567039704C3231434563786172547373466675335A4E7A38573144364537';
wwv_flow_imp.g_varchar2_table(120) := '767A454E6A726C7A33727A7554624739653548337763506165642F30654C344F6B365A546C49324164365A5269457473364D4A4D39663761576444506E765452714B6E316A4A4F4F44743833685670796B6B4869585963724D6477553777796571766346';
wwv_flow_imp.g_varchar2_table(121) := '54396C62677166773963437078754E6E543263383370474E615A50436F576E5A426965453547335844414A5747707947317674305131794F624F6836355A55755233634451544D503377344966426D7A696C6E486247544F67504C5A4577554A31505352';
wwv_flow_imp.g_varchar2_table(122) := '6278524B522F46713059594A314F306D545231766F456863334E5A3278795061685939546D6A5469556663633631414832327459764C6F74685A76636D526133525A436B4E6732506F4263357447516578317036307056772B384D745378625735714A51';
wwv_flow_imp.g_varchar2_table(123) := '326B696A526A79416F734635745A394833556D4F44656774616B493355484E636675586E50392F3972312F394F6234646F304B75757A755443625331476848444658516E4F7A704931377175654D4C666F69577353444163622B2F75364136484A6B5653';
wwv_flow_imp.g_varchar2_table(124) := '4E5433655A706D646E596D457631564E6D6A52534F6D45596C356A6D7066613277514D544E74587A6D52644F774A71616341794E3436624C504C5664776D3254544A6556617334325856597270645345366249444E59435A6B4D7450746C6E79514F776F';
wwv_flow_imp.g_varchar2_table(125) := '54594471524836425479625368676D616B70476E4E736B4F52453255747257534875594C6A724553716956504F62495870637235556E30434B5067586A3258572F51745A744D344C686C33554E4B6D55326D363679654D6873747644456B4855574E486E';
wwv_flow_imp.g_varchar2_table(126) := '307A695A645974666C2F79636841575A2B6D30547A47496A434671466748462B7831774A637877527A79374F2B5A4241587933675876694D6F4E4433556A377A415A34366D64562B6C2F435A4176574B5538785A777A7031587A32327A546A4436384D65';
wwv_flow_imp.g_varchar2_table(127) := '493633375655746F446E5330593279365A636D6A412B6B6C586D3174566C5776776775536E316644696F5A4D6A744E355967523577583658672B4D736A6B636D63696D4B53496A7031675442464653424F7065366654456A4646543957737A64575A4152';
wwv_flow_imp.g_varchar2_table(128) := '6E562F4D73555866674D2B45492B6A54664677725277325A32394648305563502F4A676B617276776D542F3732657261455072615478696D3454665669613967557378533567626D56755A54304B4C3842692B6B3659753030422B62566C6B6F46323276';
wwv_flow_imp.g_varchar2_table(129) := '74617046642B5769556152314134316A504659565A495546473267756F4C4E5830355671735A784D7061747041545A435561432B6358516D66736F4A686B375A77714B4F467A6F796B6D586139415349536E63485063684B3848367A554B487564616166';
wwv_flow_imp.g_varchar2_table(130) := '5436524B4658535061575A474D6972663079503638336E43653852454D4B4747596C724C46743730614879544A7A4F5356766A65586B484A4C47727A4263384C2B74704732757A34536E7052326A54526768616B5235715652444175656E6E69704E4553';
wwv_flow_imp.g_varchar2_table(131) := '5371704E55533270523575556C6C414C7656416F3041764A5946494E4A4452764C4A7364796D5A6A766D43774E525443567A5133383270364A4F4D4C374178474E7149574C5270536B38474536425A4A4C696449496C733971797243387A4E2B61796379';
wwv_flow_imp.g_varchar2_table(132) := '4C447644765832384369476D655637516D78354A713377316D57746B76796D694A5A476469505073496A7A624B375945375578423870466D4E65456B767A773771377437566A595A617155357164666651654D6E336366324A70686F37594A7434786253';
wwv_flow_imp.g_varchar2_table(133) := '56745554502B5A3443645A7147665441643135373766566139446834666C58744962545275756D44393935622B3566476E484C45672B396859737836356D6F624830496D6A2B685232644178624A644B4B322B50696A684F6C5646734776793452325736';
wwv_flow_imp.g_varchar2_table(134) := '4E456853647064574C6B4563495766556B5544426D54634F5A487535376C455A647A7771305773644C596D30573348335A386F686A47666A59436E546C306B6E57733656754A42626C5669526C393142446153434C4B6B5274706C366A434E3374612F71';
wwv_flow_imp.g_varchar2_table(135) := '746B63576D7168627135743336627861496867725A694932484575593941552B7771364E72557257586B75756975473744642F63564B4931355047486B6E6E326C37396B63386D517632306B4E64646E724B497671746A4F7867694A47434E2F4B473032';
wwv_flow_imp.g_varchar2_table(136) := '65574F535839525A46727539586A646D5756333053776B5763355972476F6F474D6664765350583646564E56464E586B4A5635326556437139356E723466644D4C2B4F302B306C2B68696673597A677458384C6A64523863373949524D77586D4F2F2F55';
wwv_flow_imp.g_varchar2_table(137) := '6555536367726B68316B7732504A35437234636A2B644F64664E763259586A78354E4E34436E68356B6B6D39376C41775375634775493838412B314E5A674C516435615A425344587A6D4F75594B356E507337637A337942655A62354C764E767A482F52';
wwv_flow_imp.g_varchar2_table(138) := '32532B5034466E676F325133675954326E4A645779686D477363642B30796D75336B71683367724F424A62466845426C4A6C576D345935533271346D472F73365A7246536971736E556241424C5163526F4D497231476D4658714A346C39612F50576C6D';
wwv_flow_imp.g_varchar2_table(139) := '6971382F4B31576C5A77314C44355558634A366F6A776A5A31637852343576676A41765336774D6F5A55656777394431474F4E3546657078494C746F2F354738494E5352724970383670617A5659315438792B714F6C455764776C426E51307337476248';
wwv_flow_imp.g_varchar2_table(140) := '2F71444976434A79732B4B734A794330726543523679315739676F7553664A4C53786341557072394B35636D7565575A51633454354E7557697870367636706875525155676D34324E4A6364657A37494B55313877497444627154685633555851546E57';
wwv_flow_imp.g_varchar2_table(141) := '4852444354537A57446E786131776A4F772B4F344C4559752F427364304A7972774F74424D5A794368343039717168594846797465704379724D716A665771483467767145592F4B36577032593170457274704D7855586B6A75306C6D76386479336763';
wwv_flow_imp.g_varchar2_table(142) := '6B43524F317352494B74717559492B72636C616267463034645554504458517064764E42447873306B532F49717175514C384431624A53424A6F58314D53776A67564E45646D41356C48587A454A324B45374F47527952386C49554352394E5935465168';
wwv_flow_imp.g_varchar2_table(143) := '6C314E3953426E71466E7836502F4A6166486D31346C4D337A794B503459363153785469555A65766C725575464E4C4F32714A366B567935636B4355335842362F67595A2B39534E5A34744B44334C4A6E7345357170386F715856646B6E6166782B5158';
wwv_flow_imp.g_varchar2_table(144) := '686F6B337745646D383075495151516247776638434155446771476E66536158794D72494832434E325951676A6B674B386575717A416539524D6B6E4961504D56504C3933464D31756E5A714274564F305767616C6565753858637336587349716D3370';
wwv_flow_imp.g_varchar2_table(145) := '443444652B785530447A32415873564676492F4F50484B4539304A50763158357272315675666E67643232336E6E356E387651376B394E395A374A35796A65776364667056794E50767872354E75656A70324D323379564A2F43766F74565536757A644B';
wwv_flow_imp.g_varchar2_table(146) := '4A4B457A5366754E49753154414B736D3863586666786C762B666D58786736674B343332676433345677662B41322B376166506D73515034713672524D6173787638474544574970637A467A4F584D566379337A67524F774F77704A4455315963423044';
wwv_flow_imp.g_varchar2_table(147) := '376D54447247504146656841696546766D41576F41546435614B78447A6266484D6D793848394268707935616867525563666C61323443733357342F775337524C2F70453165334A7476336665303346306951542B2B3149577670656E2B444457424D4E';
wwv_flow_imp.g_varchar2_table(148) := '33696370626A3937395858587A62396D353358485952665A684A737257644D564D4253507175756D4563544E5A6A446739536D47364663394C72665043416443486930554E4532586853454959766B737432794666424248384C6C6F484D7576716B4F71';
wwv_flow_imp.g_varchar2_table(149) := '4F73762B48324C76625765794A324142737172555069676369306A636D322F5758476A2F2F7A754F417037786B592B556171386961322F64746A694D483675502F572B7A5A2B424D4F4D7145783637416D47326A385A516353305239574A6B663931644D';
wwv_flow_imp.g_varchar2_table(150) := '4F344E6B42627536433551446A456B586A614F487877344E522F743362386C46715A644553797937446F6E727372476B674952454E4C646C3939576A485345507A3375436E5A74653239515A704965686A744576516F4E734B6D31356330757053574439';
wwv_flow_imp.g_varchar2_table(151) := '3957742B396969684E4E6C36384A72614768714D482F4D72626B2B49726257472F42374A373563387669623049344A434872666954774A4453624973615A4C5042787334636B6E2B3834477A564C396631646732525861754B484C753649467654415461';
wwv_flow_imp.g_varchar2_table(152) := '33324C59522F3447634B4F6A6D3161597863776D5A69647A445850624357756A6A6F376F71486A4F4F41746666392B424B707949717048386C47706C6576776A445056303757387732496F6C3145367855476D30325350726965376C5751563531613362';
wwv_flow_imp.g_varchar2_table(153) := '585271766476796471724E4B613677704A415663664D387164757731576545564A647347516930595A467537574A4D565866674A55506449494D6A7151534561457568584745446634374A55766579692B74356E4A576F39457974725655683631787237';
wwv_flow_imp.g_varchar2_table(154) := '437778556E5A747A4A753856645A644832396F502B494D2F6D765A324D645A423536476145656843796A4B7176595861347A6D5A4D35547A2B346D4352465A52756866706975375239626C5A7A734F4A50713332416D7253437A7536514775544B377348';
wwv_flow_imp.g_varchar2_table(155) := '424D6D4C517671356D366A4F742F45632B674547364A636C6D5732785147386C7757477139586B74726A65457557414142664A30427151703744746E6E587A723257515867354F75594B3263354A42777373656A44334A666D4754504552696443544F64';
wwv_flow_imp.g_varchar2_table(156) := '7A41437A4443693869376D6132634E38696E6D552B534C7A446559487A47387076644F43466139556F656B6B5155435A35452F616A49502F596346744C3976574E6A57512B3858773444585858504D2F776E794448696964652F66593341396E526A3732';
wwv_flow_imp.g_varchar2_table(157) := '5374654744576A546E367A4A5A684C7630322F336D457772553257476D56486D484F5A53356F504D52356E376D6338787A7A486659583578304A64382F70535A66764B6E675862386A3244336959384F7666776E792B6A7669722B525548633050506D6A';
wwv_flow_imp.g_varchar2_table(158) := '497263744748644D504E6D6A49656557476F364D386A6A575A426D4E38544D4A515072447A48726D624F5A397A4637626B2B42772F375A3344576D6D44334E375939394669496E65504D776C447233324C6B484C2B726670566D4566395354334F627872';
wwv_flow_imp.g_varchar2_table(159) := '4E7062363539657178755278342B35786F743852616B70324A627053715543544F39596644376645413062555A536E4E6F5A614F5645636D3256794965384F5647555A54554739796932686B49463171386774385144653070704C686B61576D514D4962';
wwv_flow_imp.g_varchar2_table(160) := '435439555458543533614951394856487455435434412B30574E334E476E50494F364A4C6D4D75594A77434E50587343316F56442F466D53682F6D7A51497566374D3553504E53644257494A645863574F6766504A486557717045556A75544F6B6A7947';
wwv_flow_imp.g_varchar2_table(161) := '4F387578744F36464C6933594852424A736F566F3053676D436D666F707167626F7458506867525730774C5A6F456861576A67686C4132702B6D795848737947524461524A474967473543396E61594542445863427165774F424C42524F557374796D36';
wwv_flow_imp.g_varchar2_table(162) := '2F5A49702B54796936625A346D634F514D69647A707473555044354A38596644626547776F6272646C747439484F702B77654E6C78574132344A566E75387865552F4A363459456D7033416F476D45566E42784B304D74426C7A5A625679463341746653';
wwv_flow_imp.g_varchar2_table(163) := '536D6941356B4B7A6B65774E644164344C6D464545577358546F4338495174794C55422B49466334466F4E637379624E74552B714638666B5649494C3455776B6B676D624E4A75572B3642334D45396B7A6F706A7A573131624149306646753234475567';
wwv_flow_imp.g_varchar2_table(164) := '2F564B674F56435570446C656961624655526C56646B53567035524B434E774D4B72384535337356715851462F5A6345314F666D373533764167597179356147502F6770326453774C794457666F4F774E2F317A334C6E7A36717678556E756D314F7957';
wwv_flow_imp.g_varchar2_table(165) := '724A77557673337A666D586668683130687835516466484C34597561465733646E665A7634596F56545032626A493573646E53614C6D594F7334725A796C7A433348693857737A4A4638714836786676657A646C3869476F66384F374A59385078796F37';
wwv_flow_imp.g_varchar2_table(166) := '5473574D5536646F73716C544D6330555132647571332B2F59664C343655626D4B5353687865682B564D4D4C386333343238524C7A694E665A4447372B47696A7161632F354844365177366E39454D4F687777696E3358365577366E502B56772B6C4D4F';
wwv_flow_imp.g_varchar2_table(167) := '66355366636A6A434748373239446364546E2F54346651334866346F762B6E673648782F6A57385A6E3165614471505461526F425047624A6E767A597472316274754262786D3746462B5847666F324E7356387A4D63436A76794F503432384448705559';
wwv_flow_imp.g_varchar2_table(168) := '4454545641424D4872617A437A474B574D6D75594463775A397379797530424465782B7A6D2F6B776377767A53655A2B356D486D4D387A6E6D62396B76737738792F77763568764D7477436E466F726C70445831706D4A565578306F6E684373436A576D';
wwv_flow_imp.g_varchar2_table(169) := '56386F706A6F376830532F6863665454654B62396154784F513641746D4956696F567143634B4F59717159356D734C786243596C59317231644B4D497A756B706652446F4845664A59546B706C4D70786A363951394D53726676714B4861672B2B573277';
wwv_flow_imp.g_varchar2_table(170) := '6271337637574E574345426A4D50786A7633577045744634323556716D3966467952374F48786772426E7963346862636D697A6A31785737716D57585635415050436A6B4564394E797044476765646851325965396169666B336A46492B7163327A7A77';
wwv_flow_imp.g_varchar2_table(171) := '4C4F2F4A4B43782B78514F6148476D79496D4F3570694448595A3962304C5A507A6C34676B4E73432B374E674C64632B4739327A7835356E383537382B412F68484359353276774E56706770756145374553775830553071546279433237735779516F6F';
wwv_flow_imp.g_varchar2_table(172) := '6C79675345674E686E3648666E692F6E62386C585943336E623456313149534771704267452B46637A63456D72322B5779716C425366436C3237324331792F78716D5330545477766E336A384D37584855452F7431343959675378444F664B746277462F';
wwv_flow_imp.g_varchar2_table(173) := '2F68343053596C784D52374759494A4D6C456E6162776C42424975617665696B70314F74734732464E55373331434D49317536384F3738317638315A63363738676376797043312F34484A67395150664C34786D4A6D556C6E786E6473776C2B4E324E39';
wwv_flow_imp.g_varchar2_table(174) := '375055636571713278486B6E3857377950496E5A3755574433444449553751584A46683036745657514F76556933645836766C5562666D6E503731354D3136315A6375444A486267476E49395857762F397543444635363336774B303838494871623379';
wwv_flow_imp.g_varchar2_table(175) := '72562B515430457A7443416C3648366A7942515144397371716B54704842692B536F72635874754F305A6B5931396F7737674B4A2F7A4A4C526B483250774A742F4B3048344F414D516D6F5A516A704138482B666B4133415837636A58482B4837712F78';
wwv_flow_imp.g_varchar2_table(176) := '32585A65375A5A4E4A324346566E336749644B4F7A7835374462747259616463314D627943486D53524F70796F45486E566A704C44414A61636E5761576A6131756670717A2B6C74487958706C544C4B6E6C4F372F3466332F2B67445632664764702B44';
wwv_flow_imp.g_varchar2_table(177) := '396D6379562B7762753366664654395A5353492F2F4F462F6E514F2F534F61796538373934512F334C566E793155737A64364E374D7064646C736B6375353539396671636371336E4955373364666C31314872477678397479303336745933655A466330';
wwv_flow_imp.g_varchar2_table(178) := '705569757467513942566F32383961626B4A2F6E6F4D5944544450497642596D773351794F6162453944417A6D4B48783264536436666F4D6D38756F526261636E4371543342526839597051345866672B7837347A64375779504C59367646442F4E7750';
wwv_flow_imp.g_varchar2_table(179) := '616D37385175666A2B532F6D4833734D4E684F2F583034634E7559486265545A735245342B575A38515754502B35363048654B4F6B4D5078334E43387A4A37302B4E7254746576682B62576635476F2F512B464A564775387439667776564F67505A684D';
wwv_flow_imp.g_varchar2_table(180) := '654E7A2F7A6E472F73354A705A324A694F69304E4A64426B58377A6475332B32632B6448727479306165664F756B76656C32325076442B37494442762B616272313635644F7A746A74376E4A7A7A414F66344C6A4F583934796F636B75686E53644E3478';
wwv_flow_imp.g_varchar2_table(181) := '2B7A36354750386E6379487A37383458455741423554615652666E4732325455696C34334F4558726336594B3970764145384D4A5565726235377A504F2F35794775384D30355A4C355970746F334C53316E473250722B495542514B6554715A59515246';
wwv_flow_imp.g_varchar2_table(182) := '71642F534948624D6B50326F34446744436B595531642F3473336F524864386448324C5755547956486C3847734A4F48367354376236686163624A4733315347584D46446E666C4D66713846514159542B6D467342414A635554772B4B787745634D6D35';
wwv_flow_imp.g_varchar2_table(183) := '56553530385336336C473478665A59377A4F476731744A6C4E66656D335278614441714F366D395341724A626B486B32344E47615A612F4F5339526A562B534E6F436D34614F596B6E6E434351507346696E6B417755457752587A784548556446514451';
wwv_flow_imp.g_varchar2_table(184) := '5558396352505559464A4F39626C467A79616F6B416F7A6C58614C6646776743734B37395749763352515064536455484D54326D486B303068363277793633784C6833414D3468476C36457171716A4C666B2B73726C344B6742312F70366E2B65504E67';
wwv_flow_imp.g_varchar2_table(185) := '5A6F374C496C5A4D443771446B7149674A654A4C6D766D5572366C67716271593041425361553252514D7A543274306358393976434B71727537706C51584E2F633165304D365262644570485431494F75426435576974577771506F697552704D764D74';
wwv_flow_imp.g_varchar2_table(186) := '32574A7364695470566A55555A336D316430477770366354335A374D2B79304A5641473472546B346C4C35504D4C4C74336F684C426A5649386955444B624E596E4C484C5372643653364F74346535575061434A71687478726F6756613949726777577A';
wwv_flow_imp.g_varchar2_table(187) := '72637362306B4737354945634557386D6C4F7667432F33746B666E4E515930662F3962576A38683738452F7364747875663231724D624F564F617642723336546D764E6F705676304657574F4970494B5A5A39697156784B64324E673179536947496575';
wwv_flow_imp.g_varchar2_table(188) := '2F767277463431527246544C6953525035377168562B68306D6833494B42524E616F594676725876514C686A524B45366541477175684C377763674F4A47657A4E2F633352316B4961656D4E536A3570374F6C4341582B3155426962335A58304E376E6A';
wwv_flow_imp.g_varchar2_table(189) := '515A565641483969643754614645306A7547616D7A4F5343704C39743573784B41704B71336448646A582F63322B4731744B6F32503763386B2B6A436556544935396C775A4F68545454304C57324F394C5643317451583552666C2F54692F77794C6A68';
wwv_flow_imp.g_varchar2_table(190) := '4B6738614342484B3858576A566E735479694F757454656D6851336C6D2F6D4744487155334572386B36796A44414B5A56303643734B4F2B6F5471615750464F31507172583955756D7A6B773830755456754B766A6452475A7544394D326F7644387763';
wwv_flow_imp.g_varchar2_table(191) := '47476973384A2B59362F78782F453137584B624B4C44695275516834434445685667584F5534664E6F666E6474726D5A7A4E77325043387A4C77502F735766777647677043762B785A364C6C614C51384931577470724353716C525359332F4153694352';
wwv_flow_imp.g_varchar2_table(192) := '43497A39495A6849344A666772747053357937304A4B53536750693170665A4E5566516B62504B56564F304439455A3062616F433939552B514F3947317759536A5864746E795533342F2B474D6A554478545153496451594C3651485554634374535343';
wwv_flow_imp.g_varchar2_table(193) := '716E4341482B686333682F6D4D334E57642B5857394376336671447634635436326E2F5737694C527649553252375034445A4B5A743362446976347749646B6C7565716976583278574F32653273664E664A53674864347159342F4C76765654386D4838';
wwv_flow_imp.g_varchar2_table(194) := '4F7030397A4235526F584D494F6E4237454145454A78396573667A706A66353034746D2F5743316F797569545436375062384376743255326448687034426F493350446B552B7650644F5A332B6C6579423739686F3454783148513853434168704B4D71';
wwv_flow_imp.g_varchar2_table(195) := '32554D544D7A756158767832357239783742755156433354644638497630485438336332765A543437347A2B647939436172574C37772F64373944697035446D36777850665145515A794659364D6431794A3761696F3231655448306C6447786C39424F';
wwv_flow_imp.g_varchar2_table(196) := '2F5072334E39526D7864445852752F743647442B5078705244614D41654A786A594752675941446939324C6D4A7648384E6C385A754A6C66414555593776392F6E3436672F3263787632414F416E4935474A68416F67426F6867306A654A786A59475267';
wwv_flow_imp.g_varchar2_table(197) := '594137366E77556B587A417767456C47426C535141774264594151444148696359333742774D4138696F634D426741525A474D6C41414141414141414141422B414F49427667626142306F4B634172454374344C3042456D456434536C684D4145337755';
wwv_flow_imp.g_varchar2_table(198) := '53426C73476459644B683145486834655242357148746F6654422F34494C5968476946304963516941694A6F4979776B486953594A506F6C5843592B4A6C776D6C43636B4A35596F4D696A6B4B5577706A436F714B6D6F716C6972714B32517277437755';
wwv_flow_imp.g_varchar2_table(199) := '4C4859733369302B4C6667756F6938514C3651776F6A43364D5A6F78376A4B654D76497A6F4452574E65493269446D344F6477366E44726F4F3651386B44302B507278414D4544615162354344454D6551317844714553475253684B566B707753365A4C';
wwv_flow_imp.g_varchar2_table(200) := '376B77575445524D576B7961544F4A4E504531325461684E3045386954376850366C4255554970517346446155505941414869635932426B5947444959636C69554741414153596735674A43426F622F594434444143465141684541654A78646A37314F';
wwv_flow_imp.g_varchar2_table(201) := '777A415568552F61744541724D59424159764F41454149702F574641394147617A7133555054394F326971786F385374314B646835416B5947586B4B4A425A65684A505564434357342B392B3931784841584342627A67345046666342336267736A7077';
wwv_flow_imp.g_varchar2_table(202) := '437965347364796D46355A64726C764C4866527862376C4C2F32533568306338572B376A45694676634E777A56672F59576E5A77696C664C4C5A7A6A7A584B622F743279532F3677334D45315069313336623873393744456A2B552B377079584B4D6933';
wwv_flow_imp.g_varchar2_table(203) := '4B6737455170613764535172346566684C4378794E5A66704E67764B477575396C475731316B714D764746642B6C4C4A4D6A417946754665564C7430624577696B6C4C6E597171566B566D6D525648716A59794D747A4B6D6D4177476966566570484E45';
wwv_flow_imp.g_varchar2_table(204) := '434A447A357852696B73414345695632574C4D6A55644834374965596352636B68546C39796F6D4D2B664A6F2F38356C4D31397858724D53474D4844384E6A313256564E496F446847544D525973393378572B6D474E4D614A4B77545A6A526E424B624E';
wwv_flow_imp.g_varchar2_table(205) := '54585536343949305264506230455430486C624E5649454A426C7A4A76377A4846472F3642576239596E3441414869636C56623565397047454F576C506D72414159506A4A473264773436544E71317939307A6239456A762B3736505252724478737575';
wwv_flow_imp.g_varchar2_table(206) := '7572734335372F765369755143496A503451632B4E4C4D7A3839366232524731557A582F716463576677524F34526D7359425672574D657A324541644454537869644E6F6F593074644E44464E7335674232647844756678484A374843396A4642567A45';
wwv_flow_imp.g_varchar2_table(207) := '4A567A4748765A7842516534696D743445532F684F6C37474B776877417A6478433764784233647844362F694E62794F4E2F416D33734A397649313338433465344432386A772F77495237694933794D542F41705073506E2B414A66346974386A572F77';
wwv_flow_imp.g_varchar2_table(208) := '4C623744392F6742502B496E2F4978663843742B772B2F3441332F694C2F794E662F417647486F494559467769443447344869454977674D613674574D7A4E6F39356D6C4D5873637845777A49556863354E4B53486C4C456E534F6745556B62684D7947';
wwv_flow_imp.g_varchar2_table(209) := '412F637451784B334B2F31537953427A366953325850614449526E442B6E544F574B6274354B67617869514E73317A4A47325848585051455544424D684F57786F495A514B67364754422B52376852656E7076326C32597A76432B5A75486C79384A5950';
wwv_flow_imp.g_varchar2_table(210) := '53562B7650442B483771426174784C6C786B5475593658624A4B507077565461765355705A4D54542B50736E4A7A4348384D7873482F4B4D6530746C793154594E765266347479636C65546553417A7077444A7A744E6C4C444A65753134464F4248564D';
wwv_flow_imp.g_varchar2_table(211) := '3067746972634C5534492F756C6B764D77646F716531316C70617448304866785171552F4339387036567153667473426D2B414B6C5241734E685231533059366A706D4D4B46704A5362574B4A466E532F6571614A6D51697131434E4B354E785A34626F';
wwv_flow_imp.g_varchar2_table(212) := '4E4B70544E6E75436E526C464D354858686B776D544B7872436F6D50614E4E46693443466C6F2B346654776A595661725737626B392F4473416E6975346252624356747765625264456D4B4B656230584439326B714E5A6B6E464F68425231334A73395A';
wwv_flow_imp.g_varchar2_table(213) := '51493835685A735455317171506E6C51756C766B5461747A3654796C472B47464F4630593076424F385469646E704C4A30797A467050677656624C4C7A792B36754861673166694A36536B4C6D6864664D36486D73573334336D5239576A47752F4C7137';
wwv_flow_imp.g_varchar2_table(214) := '47694D65556A50766C76656B463662397847326A5258506C717864715836366D6B414F35642F4B31554B5264314864664F74587436744B394D4630666A59685A46716A654977707477387552736431496463682B31624D547869704E3135626D4C4A4174';
wwv_flow_imp.g_varchar2_table(215) := '36706C486C7666737A6C4F3868484B4A62703038784D2F654974567A45486E4B4B307670354641335752514D564A6976776D592B4756366A39437562676D353531504B6A4238757A357867573755715030724F3465334C6152552F646A72593835473464';
wwv_flow_imp.g_varchar2_table(216) := '32765035645A78666B3175435358495A48434D623945696F636433454C4B576D6C4769375A4E4B4E5245596E686271536E71344C5A6F7A4B44737845733534616B626445627146466C46496761733159787370504570647859764F7853367A3776544667';
wwv_flow_imp.g_varchar2_table(217) := '36616935704B7439725A4B345A656E59355A525357662F4F645839306E4C515A6D4B596255526F4859303079484E514C6B4F307065586550447832585A6B53487A414850486D71312F774776784A30534141413D272920666F726D61742827776F666627';
wwv_flow_imp.g_varchar2_table(218) := '292C0A2020202020202075726C2827646174613A6170706C69636174696F6E2F6F637465742D73747265616D3B6261736536342C414145414141414C414941414177417752314E565169434C4A586F414141453441414141564539544C7A492B4A457330';
wwv_flow_imp.g_varchar2_table(219) := '414141426A4141414147426A62574677553357582B41414141357741414164305A3278355A726B772B68514141417673414143683747686C5957516A42794A76414141413441414141445A6F61475668427A774476774141414C77414141416B61473130';
wwv_flow_imp.g_varchar2_table(220) := '654B58674141414141414873414141427347787659324876553945534141414C45414141414E707459586877415A5945646741414152674141414167626D46745A586F34645A5541414B33594141414350584276633351512B4E79374141437747414141';
wwv_flow_imp.g_varchar2_table(221) := '436967414151414141314C2F61674141412B674141414141412B67414151414141414141414141414141414141414141414777414151414141414541414F38574E7A5266447A7A314141734436414141414144662F2B396E41414141414E2F2F37326341';
wwv_flow_imp.g_varchar2_table(222) := '41503971412B6744556741414141674141674141414141414141414241414141624152714143414141414141414149414141414B41416F414141442F4141414141414141414145414141414B414441415067414352455A4D5641414F6247463062674161';
wwv_flow_imp.g_varchar2_table(223) := '414151414141414141414141415141414141514141414141414141414151414141414673615764684141674141414142414141414151414541415141414141424141674141514147414141414151414141415144364147514141554141414A3641727741';
wwv_flow_imp.g_varchar2_table(224) := '4141434D416E6F4376414141416541414D5145434141414341415544414141414141414141414141414141414141414141414141414141414146426D52575141774F6742364F45445576397141466F447241435741414141415141414141414141414141';
wwv_flow_imp.g_varchar2_table(225) := '4141414141414143412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F41414144';
wwv_flow_imp.g_varchar2_table(226) := '36414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141';
wwv_flow_imp.g_varchar2_table(227) := '412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B6741';
wwv_flow_imp.g_varchar2_table(228) := '4141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F';
wwv_flow_imp.g_varchar2_table(229) := '4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F41414144';
wwv_flow_imp.g_varchar2_table(230) := '36414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141412B67414141506F4141414436414141414141414251414141414D4141414173';
wwv_flow_imp.g_varchar2_table(231) := '4141414142414141416D4141415141414141414257674144414145414141417341414D4143674141416D414142414575414141414567415141414D414175674236412F6F4C2B68703647766F784F6A63364F482F2F7741413641486F424F67523644486F';
wwv_flow_imp.g_varchar2_table(232) := '612B6A45364E766F34502F2F414141414141414141414141414141414141414141414142414249414567416F4147514131414455414E51413167414141414541416741444141514142514147414163414341414A41416F414377414D4141304144674150';
wwv_flow_imp.g_varchar2_table(233) := '414241414551415341424D4146414156414259414677415941426B414767416241427741485141654142384149414168414349414977416B414355414A67416E414367414B514171414373414C414174414334414C774177414445414D67417A41445141';
wwv_flow_imp.g_varchar2_table(234) := '4E514132414463414F41413541446F414F774138414430415067412F414541415151424341454D4152414246414559415277424941456B415367424C414577415451424F4145384155414252414649415577425541465541566742584146674157514261';
wwv_flow_imp.g_varchar2_table(235) := '41467341584142644146344158774267414745415967426A414751415A51426D414763416141427041476F416177414141515941414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(236) := '41414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(237) := '41414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(238) := '41414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414141414144414141';
wwv_flow_imp.g_varchar2_table(239) := '414141464641414141414141414142724141446F4151414136414541414141424141446F4241414136415141414141434141446F4251414136415541414141444141446F4267414136415941414141454141446F4277414136416341414141464141446F';
wwv_flow_imp.g_varchar2_table(240) := '4341414136416741414141474141446F4351414136416B41414141484141446F4367414136416F41414141494141446F43774141364173414141414A4141446F44414141364177414141414B4141446F44514141364130414141414C4141446F44674141';
wwv_flow_imp.g_varchar2_table(241) := '364134414141414D4141446F44774141364138414141414E4141446F45514141364245414141414F4141446F4567414136424941414141504141446F4577414136424D41414141514141446F4641414136425141414141524141446F4651414136425541';
wwv_flow_imp.g_varchar2_table(242) := '414141534141446F4667414136425941414141544141446F4677414136426341414141554141446F4741414136426741414141564141446F4751414136426B41414141574141446F4767414136426F41414141584141446F477741413642734141414159';
wwv_flow_imp.g_varchar2_table(243) := '4141446F48414141364277414141415A4141446F4851414136423041414141614141446F4867414136423441414141624141446F4877414136423841414141634141446F4941414136434141414141644141446F4951414136434541414141654141446F';
wwv_flow_imp.g_varchar2_table(244) := '4967414136434941414141664141446F4977414136434D41414141674141446F4A41414136435141414141684141446F4A51414136435541414141694141446F4A674141364359414141416A4141446F4A774141364363414141416B4141446F4B414141';
wwv_flow_imp.g_varchar2_table(245) := '364367414141416C4141446F4B51414136436B414141416D4141446F4B67414136436F414141416E4141446F4B774141364373414141416F4141446F4C41414136437741414141704141446F4C51414136433041414141714141446F4C67414136433441';
wwv_flow_imp.g_varchar2_table(246) := '414141724141446F4C77414136433841414141734141446F4D51414136444541414141744141446F4D67414136444941414141754141446F4D77414136444D41414141764141446F4E41414136445141414141774141446F4E5141413644554141414178';
wwv_flow_imp.g_varchar2_table(247) := '4141446F4E67414136445941414141794141446F4E774141364463414141417A4141446F4F41414136446741414141304141446F4F51414136446B41414141314141446F4F67414136446F41414141324141446F4F77414136447341414141334141446F';
wwv_flow_imp.g_varchar2_table(248) := '5041414136447741414141344141446F5051414136443041414141354141446F5067414136443441414141364141446F5077414136443841414141374141446F5141414136454141414141384141446F5151414136454541414141394141446F51674141';
wwv_flow_imp.g_varchar2_table(249) := '364549414141412B4141446F5177414136454D414141412F4141446F5241414136455141414142414141446F5251414136455541414142424141446F5267414136455941414142434141446F5277414136456341414142444141446F5341414136456741';
wwv_flow_imp.g_varchar2_table(250) := '414142454141446F5351414136456B41414142464141446F5367414136456F41414142474141446F5377414136457341414142484141446F5441414136457741414142494141446F54514141364530414141424A4141446F54674141364534414141424B';
wwv_flow_imp.g_varchar2_table(251) := '4141446F54774141364538414141424C4141446F55414141364641414141424D4141446F55514141364645414141424E4141446F55674141364649414141424F4141446F5577414136464D41414142504141446F5641414136465141414142514141446F';
wwv_flow_imp.g_varchar2_table(252) := '5651414136465541414142524141446F5667414136465941414142534141446F5677414136466341414142544141446F5741414136466741414142554141446F5751414136466B41414142564141446F5767414136466F41414142574141446F57774141';
wwv_flow_imp.g_varchar2_table(253) := '36467341414142584141446F5841414136467741414142594141446F58514141364630414141425A4141446F5867414136463441414142614141446F5877414136463841414142624141446F5941414136474141414142634141446F5951414136474541';
wwv_flow_imp.g_varchar2_table(254) := '414142644141446F5967414136474941414142654141446F5977414136474D41414142664141446F5A41414136475141414142674141446F5A51414136475541414142684141446F5A67414136475941414142694141446F5A774141364763414141426A';
wwv_flow_imp.g_varchar2_table(255) := '4141446F61414141364767414141426B4141446F6151414136476B414141426C4141446F61774141364773414141426D4141446F78414141364D51414141426E4141446F32774141364E73414141426F4141446F33414141364E7741414142704141446F';
wwv_flow_imp.g_varchar2_table(256) := '34414141364F4141414142714141446F34514141364F454141414272414141414141422B414F49427667626142306F4B634172454374344C3042456D456434536C684D414533775553426C73476459644B683145486834655242357148746F6654422F34';
wwv_flow_imp.g_varchar2_table(257) := '494C5968476946304963516941694A6F4979776B486953594A506F6C5843592B4A6C776D6C43636B4A35596F4D696A6B4B5577706A436F714B6D6F716C6972714B325172774377554C4859733369302B4C6667756F6938514C3651776F6A43364D5A6F78';
wwv_flow_imp.g_varchar2_table(258) := '376A4B654D76497A6F4452574E65493269446D344F6477366E44726F4F3651386B44302B507278414D4544615162354344454D6551317844714553475253684B566B707753365A4C376B77575445524D576B7961544F4A4E504531325461684E30453869';
wwv_flow_imp.g_varchar2_table(259) := '54376850366C4255554970517346446155505941414141464141442F77414D374175634147774173414445415141424E4141414242694948446745644151634F4152597A495449324A6938424E54516D4A79596A4969636A4253494746784D6541544D68';
wwv_flow_imp.g_varchar2_table(260) := '4D6A5933457A596D497945464B51454449524D694977344246784D65415434424A774D754153556942676344426834424E6A63544E6959427251736C42676F4872416F4842776F4363416B4842776D6F42516B474652494D522F3769436738424D67454E';
wwv_flow_imp.g_varchar2_table(261) := '4367484A436730435141454F432F37692F763042417745444F2F356953774543444138434C414953466730434C41494E4151344B45414573416730584551497341673843357745434178555A435467434477304E4477493343686F55417749427A41384C';
wwv_flow_imp.g_varchar2_table(262) := '2F64554A4451774B41696F4C4544482B427747774152494D2F73414C446749554377452F436730424467722B775173554167344C4155414D456741444141442F6D674F34417949414541415541454541414145694277454746426342466A493341545930';
wwv_flow_imp.g_varchar2_table(263) := '4A77456D42776B434A5349504178556A44774D5648774D7A465238444D7A38444E544D2F417A557641794D314C774D423941384C2F6D454B436747664378384B415A384C432F356843773842687635362F6E6F426577494342414D427767514541774542';
wwv_flow_imp.g_varchar2_table(264) := '417751457767454442415157424151444163494542414D4241514D45424D4942417751454179494C2F6D454B4877762B59516F4B415A384C48776F426E77732B2F6E722B65674747355145444241544341514D454242554642414D427767514541774542';
wwv_flow_imp.g_varchar2_table(265) := '417751457767454442415157424151444163494542414D424141594141502B56413734444A414162414445415351426741486B41696741414153594842676347427759574678595848674533506749334E6963754153636D4A794D6D427A595846686357';
wwv_flow_imp.g_varchar2_table(266) := '46785947427734424A696375416A63324E7A344246795948426763474277595846686357467859324E7A34434A79596E4C6745484E6863574678594846675948426763474A69636D4A7959324E7A59334E67634742786347427859584E7863324E79636D';
wwv_flow_imp.g_varchar2_table(267) := '4A7A63324E79596E426738424A693842466863334677635842796347427963324E79636D4A77487A624756685155494C4444633850564E5074315A5968453847426834636430395156774D5645474E6457546F3843416B39506B436D744531515A434156';
wwv_flow_imp.g_varchar2_table(268) := '467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B47783036634467324B69787563546F654A6A495A4A5445594B69775A4D43555A';
wwv_flow_imp.g_varchar2_table(269) := '4D6959354F473430623345316353524B4E456F6C4A6A495A417949434E6A566158577863746B6C4B4B43674C4842313370466C6255314F474B436B46416A45444D544254566D4E59724542444F7841724C492B7A56566C4352453472417A417654314A62';
wwv_flow_imp.g_varchar2_table(270) := '5531424F4E6A6751454355774D6F7969535577794B7A417741697771526B7051533473734C77634A4D544D3152554B514F7A30694B3238654F6E45324F437771626E41364853597947535577475377714744456C475449444F446C764E4735784E58456C';
wwv_flow_imp.g_varchar2_table(271) := '536A524B4A43597947514141455141412F364D4475414D6941414D414267414C4145344170674438415438426C414878416A774366674C434177554458414F70412F554550774141415245684551557A427A6356495455584554456A42794D484978556A';
wwv_flow_imp.g_varchar2_table(272) := '42794D504278556642444D334D7A637A4E7A4D334D7A637A467A4D584D78637A467A4D584D7A38464E5338464979636A4E534D6E497963584977384648786B2F4244557641794D6E4E5363314A794D7641534D764154556E497963314C77456A4C774531';
wwv_flow_imp.g_varchar2_table(273) := '4A7A556E497A556E4979636A4C7745314C77456A4A7A556E4979384242534D50416855484977384246513843465163564278555041534D50415255504168555041534D5041534D50415255484651384249773843465238464D7A385A4E5338454954456A';
wwv_flow_imp.g_varchar2_table(274) := '46534D504178556642444D334D7A637A467A4D584D78637A467A4D584D7838474D7A38464E5338434979384A4979636A4A794D6E497A554849773843497738424651636A4477456A427855484977636A42794D4846513844497855504152555041694D50';
wwv_flow_imp.g_varchar2_table(275) := '415238464D7A38644D7A38444C774D46447755664668556642444D2F4244556E4E5338494E5363314C77516A4A794D6E4E533842497963314A7A55764154556A4C7745314A794D6E4E5338434E53384442534D504252556A465163564278556A46516356';
wwv_flow_imp.g_varchar2_table(276) := '4678557A46526356467855584652384A4D7A38454E5338434E5363314A7A556E4E5363314A7A55334E5463314E7A55334E5463314C77514649773844465163584651635642785548465163564477675648774D7A507759314E7A552F427A55334E544D31';
wwv_flow_imp.g_varchar2_table(277) := '4E7A55334E5363314C774D46497738444652635646785558465263564877635646785566416A4D5648774D7A507751314C7773314A7A556E4E5363314A7A55764241556A447755564278555044785566425438434E5438424E54637A4E7A552F416A4D2F';
wwv_flow_imp.g_varchar2_table(278) := '436A55334C77514644775566416855584652637A467A4D66416A4D6641544D56467855584652637A4877457A467A4D584652635648774556487749564877497A507755314C787746497738494977636A42794D484977636A42794D504242556642544D33';
wwv_flow_imp.g_varchar2_table(279) := '4D7A637A4E7A4D334D7A384C4D7A637A50774531507745314E7A552F42445576424155504252556642544D66415255584D78637A487745564877457A4678556642444D584D7838474D7A38464E53385749534D5046785566426A4D2F43444D2F42445533';
wwv_flow_imp.g_varchar2_table(280) := '4D7A637A4E7A552F4154552F41544D2F424455764241456E415A722B776552796E5037496E4173474377554D425155474A67594B4341514341774542416759454351517242516B46425155464367556542516F4642515546436751594351554541775145';
wwv_flow_imp.g_varchar2_table(281) := '41514545417751484A675547425173474377623042515146417751454167494941677748434163454177514442414D484267635041676B43417845454177514A435151454177514241674D4341514944416745434567454A424159424177514441514D49';
wwv_flow_imp.g_varchar2_table(282) := '42414D42417745444151674542415142424167424241723938515545434155454151514542417745424151494177454442414D454177514A415138434151494441775543415151444177454341774D4942416B4642775546454159434267495042775948';
wwv_flow_imp.g_varchar2_table(283) := '4177514442414D45427767454241634341514943417751494151515344516F464277594341674D49434151424341516D42416744424151454277514941786F444341634841776B46424151454177514242414D4841514D46424151454241514A42435945';
wwv_flow_imp.g_varchar2_table(284) := '435155454241554E7251514942676342417767444152554441514D4441516B424441454A43514D444167454341774D49424145454167494341774D494241554543514D49417749454177494441674D434177494441774D4341774D4441774D4441774D47';
wwv_flow_imp.g_varchar2_table(285) := '41794D434177514541674946424167426841554942414D444177454741774D434177494441674D4341776357415151424241454741774943424151444241554A424151454177514241674943415149424167454341674942415145494151454241674945';
wwv_flow_imp.g_varchar2_table(286) := '415149484177494241674D434151494741776B4441774D452F634D464241674441774943415149424151454241514543415167434151454241774D45424151464351514441775142416755444167454241514542415149424151494441776B4337675545';
wwv_flow_imp.g_varchar2_table(287) := '434159434151454241514543434149424167494541525942415151444441554A4241594642414D4B4167674241674543416749484151454241514545417751492F4B634643416745416745424151494741674943415151424267494B4177514241775945';
wwv_flow_imp.g_varchar2_table(288) := '42516B45424151444241494245674543415149424167494342774942415145424167634442514C774241554542414D454167494841674D464167514241674D4D43674D4541675142415151444241514A4341554841773843415159464341454241515942';
wwv_flow_imp.g_varchar2_table(289) := '416745434151494341676B424167494442416A397251514942414D434167494642677747415177424267634441514D4441516348417745484277454441514D4543415145444151454241514A4241514542514942415151454178554442416F4847514D4B';
wwv_flow_imp.g_varchar2_table(290) := '41674D4441774D4441774D4342674D4341774944416767426E415545424145484368774C42784945437751484241514842416745454167454177494341515145417751464441554E42415545425167464A67514A42415145424151454151514441514D42';
wwv_flow_imp.g_varchar2_table(291) := '417751454341514A4241494341514947417751462F6B5145425151474167494241674D44425151424241304A4151304242415546424145454251554B42526B4242414555426755464251734B4351554542414D4541514944417751484577554542515545';
wwv_flow_imp.g_varchar2_table(292) := '425155454A5234494241514A44414D4E41684946424155444152514542416B494669774642515146425155454252734542675142415149444177514542416B444267554C42515546426851424867554B4251554541515142424155634451514242415544';
wwv_flow_imp.g_varchar2_table(293) := '4167454341674D45434148362F7367424F4446615072713666514879415145424151634341675144424151454351514642674D434351494241514542415145434251454341774D494241554543514D444177634241514542557745434167514843516B4B';
wwv_flow_imp.g_varchar2_table(294) := '41516B484267634442414D454177514843416355424130454243414441774943416749444177674A4251594642515142424145454252774E42414549424145454241514941514D42417745444241674441514D4541774547424163494151514541514D45';
wwv_flow_imp.g_varchar2_table(295) := '4177454444414D42417745444151674542415142424151454151514E467755464241454541516B464367554D4241554542414D4541514946427777654341514A42425148434163454177514442414D48426751444277554542416B4542414D4541514943';
wwv_flow_imp.g_varchar2_table(296) := '425177464351514442674942415145424151494342774943417749434167454341774D4942516B494177554341514942416745434167494A4167454241536343417755434241454344774D434151494A44416B4243515144417745444177454443776348';
wwv_flow_imp.g_varchar2_table(297) := '43516B45417751454151454541777744424159444177494441774D4441774D4341774D434177494441674D434177514446674D4443416B4A42774D454F77454341774D454451554C41674D4441774D444177494441776F6A417763444277514F43774D48';
wwv_flow_imp.g_varchar2_table(298) := '417767444177494241514D434241674A42414945435151454241514542514D4241774544424145444541514441514D494177454B41514D4441514D4441514D44415159454351454441674D447151454542414D454341514543515545435130454777554E';
wwv_flow_imp.g_varchar2_table(299) := '4351514543515142424349454251454542414D444167454341674D4543416B464242494543775148424151484241674548675149424163454241634542416B45424151444243304242416745424151454867554B4251554642516B464A77554542516B4B';
wwv_flow_imp.g_varchar2_table(300) := '424449454251514942415943416759494367555A41515142464159464251554C426959464267554C426773474667594A43414D4442424143426767494351595242515946426773464951594C4251554B426738424241455A42516F424241594341514544';
wwv_flow_imp.g_varchar2_table(301) := '41675149435167424B5151464251514642516B464967554A4251554642516F4646775545427749434F51454341774D494277514842426F44437773484267514442785150417763424341554542516744417749434167494841514D5641514D4C41516351';
wwv_flow_imp.g_varchar2_table(302) := '4241514D42415145424151454351516D4251554942415144424B414242414D4442416B4A43515942444145474441594641774D43415151424241454342515143416745424151514241514547415145424167454241674D48425151464241674441776B43';
wwv_flow_imp.g_varchar2_table(303) := '4151594445414D474177494441674D43417749444267494441774D444177644B415149424177594D41774D46417749424151454541774D454351554543414D44416745424151454343514943416745434151494241514543416749424151454541514542';
wwv_flow_imp.g_varchar2_table(304) := '4251514442515146434167444167456E415145444267514A42515145424149464177514A4151594A4177494241674D434151494442414D4B416767424167454341674D4241674D44434155454351514441774D4541674543415149424167455145415943';
wwv_flow_imp.g_varchar2_table(305) := '4177554A41776F4241674943447749444251594D46414543415149424167454342674947435151464241514541774D434151454241674943415149424341774442414D4341514944416745434567454A42414D464241514542516B4541774D4541414141';
wwv_flow_imp.g_varchar2_table(306) := '425141412F35594476514D6A414259414D51413641443441524141414153594F4178595848674933506745334E6A63324A7934424A7959484E6863574678595846675948426763474277596E4A69636D4A79596E4A6A632B41684D47447745584E526352';
wwv_flow_imp.g_varchar2_table(307) := '427963554653636C4642556E4A6963423946696D67555142514430376F6242525649596E4B514D4748683532546C3572566C4A514F6A7358467863724C455247576C685757454E444A79594441794D656370512F4E6D77763063724B4749384257537044';
wwv_flow_imp.g_varchar2_table(308) := '49674D6941555A2B6F624F6D506A394A43523464656C4654574664565534636D4C7A45424A695644524652507030684B4C7A5151447859574F545A5154316461546B6C77507638414A6B30686C492B50415369505947526C5A47566C5A5234774677414A';
wwv_flow_imp.g_varchar2_table(309) := '4141442F6F674F3441794141437741584146494175774645416145423641497941703441414145564978557A46544D314D7A556A4E51637A46544D564978556A4E534D314D784D724151636A42794D4846513846465238464D7A38444D7A637A4E7A4D33';
wwv_flow_imp.g_varchar2_table(310) := '4D78637A467A4D584D7838424D7A38444E533845497A556A4A794D6E467738474652384B4D783847465238434D78384E4D7A38454E5338424E53636A4C77596A4C7745314979384C4979384249793848497A556E4E5338454977555041534D5042425550';
wwv_flow_imp.g_varchar2_table(311) := '424255484977635644774D6A4651635642794D564477515642794D50415255504168555041694D5041785550417855484651384B465163564877512F42444D2F4244552F4A6A557641774550425255584651635642785548465163564278554846516356';
wwv_flow_imp.g_varchar2_table(312) := '42785548465163564278555042785566424438464D7A38424D7A38424E5438424D7A637A4E7A55334E544D314E7A55334E5463314E7A55334E5463314E7A55334E5363314C77514644775556467855584652637A4877557A487745564678555846526356';
wwv_flow_imp.g_varchar2_table(313) := '4D78635646785566424438454E53384E4E5363314A7A556E4E533844415138584877512F42444D2F417A4D334D7A637A4E7A4D334D7A63314E7A4D334E54637A5077497A4E7A4D3150774D314C7751464477555648774D564877457A4877497A48774956';
wwv_flow_imp.g_varchar2_table(314) := '4877457A487745564877457A467A4D584D78637A4877497A467A4D5846544D66427A4D584652637A46544D584D7A38454E5338454979636A4A794D6E4979384B4979384549793846497747756658324D66583131586E3139586E31394D77634E4267304E';
wwv_flow_imp.g_varchar2_table(315) := '4279634E446751444177514241674D4443515146426777474677594C4267594742696B4742675947426755664241554D41774D4341675944436963474277594E422B6B464241514441774543416749474167494442675545417767424467494941675943';
wwv_flow_imp.g_varchar2_table(316) := '4241454341674543417749444251514442414D4B425159444351514A4241514442414945426745454177494441674D434151494941515544424149454167494641676343416745434351454341674D4841774944416745434177494741676F462F664D46';
wwv_flow_imp.g_varchar2_table(317) := '427745434177494441674D43417749444241454341674D4342414545424145434167494341674942416749434241494342414542415149444167494B41514943416745454151494241674543415149434151514541773445434151444151454341774543';
wwv_flow_imp.g_varchar2_table(318) := '41674942416745434151494241674944416745434341494241674943415151434241454741676F4342674D4B4177594442514D434151514743415543736751464177594341514542415145424151454341514D464177554442414D4342674D4241674D47';
wwv_flow_imp.g_varchar2_table(319) := '42416B4A42415144416745424177494241674D44416745464151774441514942415145424151454241515144424151492F4B594542514D454241454241774942417749424241454B4151514441674D43415149444151494542776B4A4241514442414945';
wwv_flow_imp.g_varchar2_table(320) := '41674D43427751424267454341514949415145424151554943414B784241514A4241554B42413846425173504267554C425345474378414942415543416751444241304A4267595542514553426763464151554242514546415277424377554242515542';
wwv_flow_imp.g_varchar2_table(321) := '425173504151514241774D4341515144424151492F643445424151444167494241674D454451494241674D4341514944417773434151674441775542416745434151494241674D44415149424167454342414D4741773044485149444451514444516B46';
wwv_flow_imp.g_varchar2_table(322) := '434155434151514442415144424167444641495241776B464551494742514D464251554341513843425149434151514442424545424155434958324D6658324D66526439586E312B58514754415149474151494541674D4543416B464241514442414543';
wwv_flow_imp.g_varchar2_table(323) := '4167494541674542415145424251454742414D4A4251674941675147415145425477454241774D4542415146435151474151494242674D454167674F4177674442674D45415149434177514442414D4842774D494178494B43414945416749444177674B';
wwv_flow_imp.g_varchar2_table(324) := '4277634244416745424151454241514543774548417759434267494442514D484177494443514D43416763434167494341514542416749454167554D41515143416749434167454341674943416745454167454341674D45415151424241454341774944';
wwv_flow_imp.g_varchar2_table(325) := '4167454341774942416759434151494741774D434251494241673844416745434151494442674D4441774D4441774D444151514A4251674441774D4242414D4442415946417749464151494441674D43417749444177494641674D434441494441674D43';
wwv_flow_imp.g_varchar2_table(326) := '4177514442414D4741776F444267494B415159434251514542416B4A426751422F735942416749494241514542444D4443514D474167594441774D4441774D4741674D444351494F417767424451554C4251594B42775146435151474167494341674D44';
wwv_flow_imp.g_varchar2_table(327) := '41774D4742675946415155484479594443674D4442774D4442414D4442414D4442414D48417734444C41554A43415143417749544151494441776745477759484577634E4577594844515966445155424251454641515542425145464151454542415143';
wwv_flow_imp.g_varchar2_table(328) := '4167494441776B4A434159474251595143775952425159474253384742515947444159484251634741763679415149474241514742416B454177554A41674D454177774242414D454177634A4351674441774D43416745474167594441674D4341774D50';
wwv_flow_imp.g_varchar2_table(329) := '42674544417745444241634D424145444241514543516745417749434167454441675145435151464241514441516F434167494341674942415163434251454241514D434167454341514942415145424151494341675143435145424241454541515148';
wwv_flow_imp.g_varchar2_table(330) := '4251514A4341514341774544427759444177594341674D424177494441676B4341774942424145454451454341414141415141414141414451414B4741444D414141456944674548426859584A696348466863324E79596E427934424E6A632B41525958';
wwv_flow_imp.g_varchar2_table(331) := '486749484467496E4A675965415263794E7A597A506749334E6934424A79594345543531566849564679677357677969554341504A4263634968635A49694A6E627938745078594D433056694E4130534152554F4342454D426A31725251674A49557730';
wwv_flow_imp.g_varchar2_table(332) := '51774B464E563438515977334342493749412B67554163456B536873617967714C514D624631526E4D544E554D4145424642734E4151494343556872506A74315942776B41414141417741414141414337674B4B41414D414277414C4141415445544D52';
wwv_flow_imp.g_varchar2_table(333) := '4D78457A45544D524D7848365A47526B5A4751436976326F416C6A3971414A592F6167435741414141416B4141502B69413777444951414441416741496741784145634158414278414951416C5141414151594849514D57467945324577596A42676347';
wwv_flow_imp.g_varchar2_table(334) := '42785958466A63324E7A59584E686357467A596E4A69636D427959584268635746785958466863574E69596E4A696346426763474477454742775958466A63324E7A59334E6A38424E6A633241515948426863574651594842676347466A34424E543442';
wwv_flow_imp.g_varchar2_table(335) := '4A793442425159484268635746525958466863574E54516E4A69636D4E533442415159484267634742794947427759584E6A63324E7A5975415155474678595846686357467A596E4C67456A4A69384241665267594147417747517A2F74497A61417763';
wwv_flow_imp.g_varchar2_table(336) := '4B52496543676755444277524341344A47544D644468594C4368775946516A7149417347486734464B6949554651514F4F6B5839385230624542734F4451734D41775164445259514367385144526B4643414B5A46415543416745424177736741684159';
wwv_flow_imp.g_varchar2_table(337) := '457863544267494E2F4B5158424149484241734944524D69454167434577454E417134544A423450476863524A514D45467A63314E4377484167333932526F464242595245303945467751444A5246514F4159434D71797441536130576C6F4231514942';
wwv_flow_imp.g_varchar2_table(338) := '4251675846414942427755424167494342674D424651344D426751424155384B4651306144415576506730544B4174664B776F4D4852456D45773059476738544268416B48413057447777574442542B30515555437830514341304A5154775244675154';
wwv_flow_imp.g_varchar2_table(339) := '446A4A744E67634A4567555A44694958435330594A686F464751386C4641632F5051674C2F724D4A4678494A445159564451384C43686F594A6763544467454B4567345344516F7343517350444255594D514D41414141524141442F6F774F3441794941';
wwv_flow_imp.g_varchar2_table(340) := '44774166414445416441444B41536742637747324167344357774B654176594454414F4F41394D4548775270414141424A675948426834434E7A34424E7A596D4A7959484E68344344674D75416A59335067455842673842446745574678592B41547342';
wwv_flow_imp.g_varchar2_table(341) := '4E534D324E79596E4B77455649773844465238454D7A637A4E7A4D584D78637A467A4D584D78637A4877597A507755314C77496A4C776B6A4A794D6E4979636A4E513845497738424651636A4477456A427855484977636A42794D484651384449785550';
wwv_flow_imp.g_varchar2_table(342) := '4152555041694D50415238464D7A38644D7A38444C774D6A42513846487859564877517A507751314A7A55764344556E4E5338454979636A4A7A557641534D6E4E5363314C774531497938424E53636A4A7A5576416A5576424155504252556A46516356';
wwv_flow_imp.g_varchar2_table(343) := '4278556A465163564678557A46526356467855584652384A4D7A38454E5338434E5363314A7A556E4E5363314A7A55334E5463314E7A55334E5463314C775546447755564278555044785566425438434E5438424E54637A4E7A552F416A4D2F436A5533';
wwv_flow_imp.g_varchar2_table(344) := '4C77516A4251384648774956467855584D78637A4877497A4877457A46526356467855584D7838424D78637A467855584652384246523843465238434D7A38464E533864425138494977636A42794D484977636A42794D504242556642544D314D7A637A';
wwv_flow_imp.g_varchar2_table(345) := '4E7A4D334D7A384C4D7A637A50774531507745314E7A552F4244557642434D444B7745484977636A46534D4849773848465238454D7A637A4E7A4D334D7A637A4E7A4D584D78637A467A4D584D78637A507755314C77556A4A794D314979636A4A786350';
wwv_flow_imp.g_varchar2_table(346) := '4252385A507751314C774D6A4A7A556E4E53636A4C77456A4C7745314A794D6E4E533842497938424E5363314A794D314A794D6E497938424E533842497963314A794D7641675550416855484977384246513843465163564278555041534D5041525550';
wwv_flow_imp.g_varchar2_table(347) := '4168555041534D5041534D50415255484651384249773843465238464D7A385A4E533845497745504178554846785548465163564278554846513849465238444D7A38474E546331507763314E7A557A4E5463314E7A556E4E5338444977555042425558';
wwv_flow_imp.g_varchar2_table(348) := '465263564678555846523848465263564877497A465238444D7A38454E53384C4E5363314A7A556E4E5363314C77516A45773845465238464D7838424652637A467A4D664152556641544D58465238454D78637A4877597A507755314C78634644786356';
wwv_flow_imp.g_varchar2_table(349) := '4877597A5077677A507751314E7A4D334D7A6331507745315077457A507751314C77516A416652416278635A47465A2B4F6A3152415152454F5373794A6B677A457734725156424C4F426F4A4668685159776B5548516B4A424167454351304557566B53';
wwv_flow_imp.g_varchar2_table(350) := '4A67342F4241344E436755484267494341776749424145494243594543414D45424151484241674447674D494277634443515545424151444241454541776342417755454241514542416B454A67514A425151454251327842514D474277454443414D42';
wwv_flow_imp.g_varchar2_table(351) := '46514D4241774D424351454D41516B4A41774D4341514944417767454151514341674944417767454251514A417767444167514441674D434177494441674D444177494441774D4441774D44417759444977494442415143416755454341554268415145';
wwv_flow_imp.g_varchar2_table(352) := '42414D444177454741774D434177494441674D4341776357415151424241454741774943424151444241554A424151454177514241674943415149424167454341674942415145494151454241674945415149484177494241674D434151494741776B44';
wwv_flow_imp.g_varchar2_table(353) := '41774D45436633484241674441774943415149424151454241514543415167434151454241774D45424151464351514441775142416755444167454241514542415149424151494441776B45416F30464241514442414943427749444251494541514944';
wwv_flow_imp.g_varchar2_table(354) := '44416F444241494541514545417751454351674642774D5041674547425167424151454741514942416745434167494A415149434177514942663275424151454177494341675547444159424441454742774D4241774D42427763444151634841514D42';
wwv_flow_imp.g_varchar2_table(355) := '417751494241514D4241514542416B4542415146416745424241514446514D454367635A41776F4341774D4441774D44417749474177494441674D4343413442705151454151634B484173484567514C4241634542416345434151514341514441674942';
wwv_flow_imp.g_varchar2_table(356) := '42415144424155524451514642415549425359454351514542415145424145454177454441514D4542416745435151434167454342674D454251536E425159474377554D425155474A67594B4341514341774542416759454351517242516B4642515546';
wwv_flow_imp.g_varchar2_table(357) := '4367556542516F464251554643675159435155454177514541514545417751484A6755474251734743776276424155444241514341676743444163494277514442414D454177634742773843435149444551514442416B4A424151444241454341774942';
wwv_flow_imp.g_varchar2_table(358) := '41674D434151495341516B454267454442414D42417767454177454441514D4243415145424145454341454543676A39394151494251514242415145444151454241674441514D454177514442416B424477494241674D444251494242414D4441514944';
wwv_flow_imp.g_varchar2_table(359) := '41776745435155484251555142674947416738484267634442414D45417751484341514542774942416749444241674541713845434159434151454241514543434149424167494541525942415151444441554A4241594642414D4B4167674241674543';
wwv_flow_imp.g_varchar2_table(360) := '416749484151454241514545417751494250796D42415149424149424151454342674943416745454151594343674D4541514D474241554A4241514541775143415249424167454341514943416763434151454241514948417755456C41554542674943';
wwv_flow_imp.g_varchar2_table(361) := '41514944417755454151514E4351454E4151514642515142424155464367555A41515142464159464251554C43676B46424151444241454341774D4542784D4642415546424155464243556543415145435177444451304347675146417745554241514A';
wwv_flow_imp.g_varchar2_table(362) := '43425973425155454251554642415562424159454151454341774D454241514A417759464377554642515955415234464367554642414545415151464841304541515146417749424167494442416745416A5142537A733567466B654652567451443578';
wwv_flow_imp.g_varchar2_table(363) := '4768556E415349395355772F4B4163614F453152495355734D68496A4E67455045514D444151595A496B5149375145434167554D42516B454177594341514542415145434167634341674D434167494241674D444341554A43414D464167454341514942';
wwv_flow_imp.g_varchar2_table(364) := '41674943435149424151456E4151454442514945415149504177494241676B4D4351454A42414D4441514D4441514D4C4277634A43515144424151424151514444414D4542674D4441674D4441774D44417749444177494441674D434177494442414D57';
wwv_flow_imp.g_varchar2_table(365) := '41774D4943516B4841775138415145444177514E4251734341774D4441774D4441674D4443694D4442774D484241344C4177634443414D44416745424177494543416B454167514A42415145424151464177454441514D4541514D5142414D4241776744';
wwv_flow_imp.g_varchar2_table(366) := '41516F4241774D4241774D4241774D424267514A41514D4341774D437177454542414D454341514543515545435130454777554E4351514543515142424349454251454542414D444167454341674D4543416B4642424945437751484241514842416745';
wwv_flow_imp.g_varchar2_table(367) := '48675149424163454241634542416B45424151444241463341514944417767484241634547674D4C4377634742414D4846413844427745494251514643414D44416749434167634241785542417773424278414542417745424151454241514A42435946';
wwv_flow_imp.g_varchar2_table(368) := '4251674542414D456F51494341774D4543516B4A4267454D4151594D42675544417749424241454541514946424149434151454242414542415159424151454341514543417763464241554543414D444351494242674D514177594441674D4341774944';
wwv_flow_imp.g_varchar2_table(369) := '41674D4741674D4441774D4442774E4E415149424177594D41774D46417749424151454541774D454351554543414D4441674542415145434351494341674543415149424151454341674942415145454151454242515144425151464341674441674543';
wwv_flow_imp.g_varchar2_table(370) := '7A67454241514548416749454177514542416B454251594441676B4341514542415145424167554241674D444341514642416B4441774D484151454241564D424167494542776B4A4367454A427759484177514442414D45427767484641514E42415167';
wwv_flow_imp.g_varchar2_table(371) := '41774D434167494341774D49435155474251554541515142424155634451514243415142424151454341454441514D42417751494177454442414D424267514841676F42424151424177514441514D4D4177454441514D42434151454241454542415142';
wwv_flow_imp.g_varchar2_table(372) := '4241305842515545415151424351554B425177454251514541775142416755484442344942416B45464163494277514442414D454177634742414D4842515145435151454177542B78514545434151454241516542516F46425155464351556E42515146';
wwv_flow_imp.g_varchar2_table(373) := '43516F454D67514642416745426749434267674B42526B424241455542675546425173474A675547425173474377595742676B4941774D4545414542426767494351595242515946426773464951594C4251554B426738424241455A42516F4242415943';
wwv_flow_imp.g_varchar2_table(374) := '4151454441675149435167424B5151464251514642516B464967554A4251554642516F4646775545427749432F72494241775945435155454241514342514D454351454743514D4341514944416745434177514443674949415149424167494441514944';
wwv_flow_imp.g_varchar2_table(375) := '4177674642416B4541774D444241494241674543415149424542414741674D4643514D4B41774D4241674943447749444251594D46414543415149424167454342674947435151464241514541774D434151454241674943415149424341774442414D43';
wwv_flow_imp.g_varchar2_table(376) := '41514944416745434567454A42414D464241514542516B4541774D454141594141502B56413734444A414162414445415351426741473041656741414153594842676347427759574678595848674533506749334E6963754153636D4A794D6D427A5958';
wwv_flow_imp.g_varchar2_table(377) := '4668635746785947427734424A696375416A63324E7A344246795948426763474277595846686357467859324E7A34434A79596E4C6745484E6863574678594846675948426763474A69636D4A7959324E7A59334E68635546534D564D78557A4E544D31';
wwv_flow_imp.g_varchar2_table(378) := '497A55484D6A4D564D78556A46534D31497A557A41664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B';
wwv_flow_imp.g_varchar2_table(379) := '4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E50556F596E3539366E3539684A5353666E306D676F414D69416A5931576C3173584C5A4A5369676F437877646436525A57314E54';
wwv_flow_imp.g_varchar2_table(380) := '6869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B44733949697464';
wwv_flow_imp.g_varchar2_table(381) := '546B35386E4A78386E4269645370326453674141427741412F35554476674D6B414273414D51424A414741416151427441484D414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A6763324678595846686357';
wwv_flow_imp.g_varchar2_table(382) := '4267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A595842673842467A55584551636E4642556E4A525156';
wwv_flow_imp.g_varchar2_table(383) := '4A79596E41664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B32655030464642423467';
wwv_flow_imp.g_varchar2_table(384) := '50444238516C424B5279737341514649506B424C5234777A4E6851564643636E505570464E6D77763063724B474938425753704449674D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A';
wwv_flow_imp.g_varchar2_table(385) := '574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B4473394969756A4A6B30686C492B50415369505947526C';
wwv_flow_imp.g_varchar2_table(386) := '5A47566C5A523477467741444141442F6D674F34417949414541415541454941414145694277454746426342466A4933415459304A77456D42776B434E7949504242384344774966424438434877492F4243384350774976424138434A7A556E41665150';
wwv_flow_imp.g_varchar2_table(387) := '432F356843676F426E777366436747664377762B595173504159622B6576353639414943424138444151454469596B4441514544447751454251534A69515146424151504177454241346D4A41774542417738454241554569596B454179494C2F6D454B';
wwv_flow_imp.g_varchar2_table(388) := '4877762B59516F4B415A384C48776F426E77732B2F6E722B6567474772514544447751454251534A69515146424151504177454241346D4A41774542417738454241554569596B454251514544774D4241514F4A695145434141414141414D4141502B57';
wwv_flow_imp.g_varchar2_table(389) := '4137384449674162414449415377414141534948426763474277595746785958486745334E6A632B415463324A7934424A79596E4A6763324678595846686357426763474277596D4A7934424E6A63324E7A3442427759484677594846686333467A5933';
wwv_flow_imp.g_varchar2_table(390) := '4A79596E4E7A59334A6963474477456D4A77487262474E675030414B437A6B39506C524F74464E5851454E514341636447336C5255316B4E443039495279737341514E414F547849527041334F5449514A69684149314A48485470774F4459714C473578';
wwv_flow_imp.g_varchar2_table(391) := '4F68346D4D686B6C4D5267714C426B774A526B79417949334E6C74646131793352306F6E4A677363485473356F5668625531574C4B536F45415934434B5368465230394A69533478444134704D4447486C7A35424978555762683436635459344C437075';
wwv_flow_imp.g_varchar2_table(392) := '63446F644A6A495A4A54415A4C436F594D53555A4D674141436741412F35494477514D6A414277414E77425241476F416277427A414863416577422F41494D414141456949794948426763474277595746785958486745334E6A632B415463324C67456E';
wwv_flow_imp.g_varchar2_table(393) := '4A69636D427A497A4E68635746785958466759484267634F4153636D4A79596E4A6A63324E7A34424679496A496763474277594842685958466863574E6A63324E7A34424A79596E4C6745484D6A4D794678595846686357426763474277597541536375';
wwv_flow_imp.g_varchar2_table(394) := '415463324E7A344242785552495245464D78456A4578557A4E5163564D7A554846544D314278557A4E51487A41514A6A586C74415168595648693476534569795756784C536D67564668746553456C574F4473464256785756446B36447841714E44564B';
wwv_flow_imp.g_varchar2_table(395) := '544C5254565473394852774A436934317547344642565250537A4930435173324F44704D534A314652693077486851564E6A4F4F54774D44533056444B797747434463314F4556456A3359674967496649546F6F593251424C7637712F7634617973724B';
wwv_flow_imp.g_varchar2_table(396) := '7973724B79674D694C69314F554746577330314F4D7A5571446738774C704657563632624E6A6355446A45424C53744D54567453714552474A796F4B49434641503164555756744B56326B724B797049535652506E5473384778734E4A53592F514B4E50';
wwv_flow_imp.g_varchar2_table(397) := '556A7336517A416E4A6B42425330654C4D6A515346427456506B4357516B557248794A3544503651415877592F7251424A786B5A53686759565267595452675941414141454141412F364D4475414D694141734146774261414C49424341464C41614142';
wwv_flow_imp.g_varchar2_table(398) := '2F514A49416F6F437A674D52413267447451514242457341414145564978557A46544D314D7A556A4E51637A46544D564978556A4E534D314D784D784977636A42794D564977636A447763564877517A4E7A4D334D7A637A4E7A4D334D78637A467A4D58';
wwv_flow_imp.g_varchar2_table(399) := '4D78637A467A4D2F4254557642534D6E497A556A4A794D6E46794D504252385A507751314C774D6A4A7A556E4E53636A4C77456A4C7745314A794D6E4E533842497938424E5363314A794D314A794D6E497938424E533842497963314A794D764151556A';
wwv_flow_imp.g_varchar2_table(400) := '4477495642794D504152555041685548465163564477456A44774556447749564477456A4477456A447745564278555041534D504168556642544D2F47545576424345784978556A44774D564877517A4E7A4D334D78637A467A4D584D78637A467A4D66';
wwv_flow_imp.g_varchar2_table(401) := '426A4D2F4254557641694D7643534D6E4979636A4A794D3142794D5041694D5041525548497738424977635642794D484977636A4278555041794D56447745564477496A4477456642544D2F48544D2F4179384442513846487859564877517A50775131';
wwv_flow_imp.g_varchar2_table(402) := '4A7A55764344556E4E5338454979636A4A7A557641534D6E4E5363314C774531497938424E53636A4A7A5576416A55764177556A44775556497855484651635649785548465263564D785558465263564678556643544D2F42445576416A556E4E536331';
wwv_flow_imp.g_varchar2_table(403) := '4A7A556E4E5363314E7A55334E5463314E7A55334E53384542534D504178554846785548465163564278554846513849465238444D7A38474E546331507763314E7A557A4E5463314E7A556E4E53384442534D5041785558465263564678555846523848';
wwv_flow_imp.g_varchar2_table(404) := '465263564877497A465238444D7A38454E53384C4E5363314A7A556E4E5363314C7751464977384646516356447738564877552F416A552F415455334D7A63315077497A50776F314E7938454251384648774956467855584D78637A4877497A4877457A';
wwv_flow_imp.g_varchar2_table(405) := '46526356467855584D7838424D78637A467855584652384246523843465238434D7A38464E53386342534D5043434D484977636A42794D484977636A447751564877557A4E7A4D334D7A637A4E7A4D2F437A4D334D7A38424E5438424E54633150775131';
wwv_flow_imp.g_varchar2_table(406) := '4C775146447755564877557A48774556467A4D584D783842465238424D7863564877517A467A4D66426A4D2F425455764669456A447863564877597A5077677A507751314E7A4D334D7A6331507745315077457A507751314C775142726E31396A483139';
wwv_flow_imp.g_varchar2_table(407) := '64563539665635396653384C4267734644415546426959474367674541674D424151494742416B454B77554A4251554642516F464867554B4251554642516F4547416B4642414D454241454242414D45427959464267554C426773473941554542514D45';
wwv_flow_imp.g_varchar2_table(408) := '424149434341494D4277674842414D4541775144427759484477494A41674D5242414D4543516B4542414D45415149444167454341774942416849424351514741514D45417745444341514441514D424177454942415145415151494151514B2F664546';
wwv_flow_imp.g_varchar2_table(409) := '42416746424145454241514D4241514543414D424177514442414D45435145504167454341774D464167454541774D4241674D444341514A4251634642524147416759434477634742774D454177514442416349424151484167454341674D4543414545';
wwv_flow_imp.g_varchar2_table(410) := '4567304B425163474167494443416745415167454A675149417751454241634543414D614177674842774D4A4251514542414D45415151444277454442515145424151454351516D42416B4642415146446130454341594841514D494177455641774544';
wwv_flow_imp.g_varchar2_table(411) := '4177454A4151774243516B444177494241674D44434151424241494341674D444341514642416B4443414D4342414D434177494441674D4341774D4441674D4441774D4441774D4442674D6A41674D454241494342515149415951464341514441774D42';
wwv_flow_imp.g_varchar2_table(412) := '42674D4441674D434177494441674D48466745454151514242674D4341675145417751464351514542414D45415149434167454341514942416749434151454243414542415149434241454342774D43415149444167454342674D4A41774D4442503344';
wwv_flow_imp.g_varchar2_table(413) := '4251514941774D43416745434151454241514542416745494167454241514D444241514542516B4541774D45415149464177494241514542415145434151454341774D4A4175344642416747416745424151454241676743415149434241455741514545';
wwv_flow_imp.g_varchar2_table(414) := '417777464351514742515144436749494151494241674943427745424151454242414D454350796E42516749424149424151454342674943416745454151594343674D4541514D474241554A424151454177514341524942416745434151494341676343';
wwv_flow_imp.g_varchar2_table(415) := '41514542415149484177554338415146424151444241494342774944425149454151494444416F444241494541514545417751454351674642774D5041674547425167424151454741514942416745434167494A41514943417751492F61304543415144';
wwv_flow_imp.g_varchar2_table(416) := '416749434251594D4267454D41515948417745444177454842774D42427763424177454442416745424177454241514543515145424155434151454542414D564177514B42786B444367494441774D4441774D444167594441674D4341774949415A7746';
wwv_flow_imp.g_varchar2_table(417) := '4241514242776F63437763534241734542775145427751494242414942414D434167454542414D45425177464451514642415549425359454351514542415145424145454177454441514D4542416745435151434167454342674D454266354542415545';
wwv_flow_imp.g_varchar2_table(418) := '4267494341514944417755454151514E4351454E4151514642515142424155464367555A41515142464159464251554C43676B46424151444241454341774D4542784D464241554642415546424355654341514543517744445149534251514641774555';
wwv_flow_imp.g_varchar2_table(419) := '4241514A43425973425155454251554642415562424159454151454341774D454241514A4177594643775546425159554152344643675546424145454151514648413045415151464177494241674944424167434958324D6658324D66526439586E312B';
wwv_flow_imp.g_varchar2_table(420) := '58514756415145424151634341675144424151454351514642674D434351494241514542415145434251454341774D494241554543514D444177634241514542557745434167514843516B4B41516B484267634442414D45417751484341635542413045';
wwv_flow_imp.g_varchar2_table(421) := '4243414441774943416749444177674A4251594642515142424145454252774E42414549424145454241514941514D42417745444241674441514D4541774547424163494151514541514D454177454444414D4241774544415167454241514242415145';
wwv_flow_imp.g_varchar2_table(422) := '4151514E467755464241454541516B464367554D4241554542414D4541514946427777654341514A42425148434163454177514442414D48426751444277554542416B4542414D4541514943425177464351514442674942415145424151494342774943';
wwv_flow_imp.g_varchar2_table(423) := '417749434167454341774D4942516B494177554341514942416745434167494A4167454241536343417755434241454344774D434151494A44416B424351514441774544417745444377634843516B454177514541514545417777444241594441774944';
wwv_flow_imp.g_varchar2_table(424) := '41774D4441774D4341774D434177494441674D434177514446674D4443416B4A42774D454F77454341774D454451554C41674D4441774D444177494441776F6A417763444277514F43774D48417767444177494241514D434241674A4241494543515145';
wwv_flow_imp.g_varchar2_table(425) := '4241514542514D4241774544424145444541514441514D494177454B41514D4441514D4441514D44415159454351454441674D447151454542414D454341514543515545435130454777554E4351514543515142424349454251454542414D4441674543';
wwv_flow_imp.g_varchar2_table(426) := '41674D4543416B464242494543775148424151484241674548675149424163454241634542416B45424151444243304242416745424151454867554B4251554642516B464A77554542516B4B424449454251514942415943416759494367555A41515142';
wwv_flow_imp.g_varchar2_table(427) := '464159464251554C426959464267554C426773474667594A43414D4442424143426767494351595242515946426773464951594C4251554B426738424241455A42516F42424159434151454441675149435167424B5151464251514642516B464967554A';
wwv_flow_imp.g_varchar2_table(428) := '4251554642516F4646775545427749434F51454341774D494277514842426F44437773484267514442785150417763424341554542516744417749434167494841514D5641514D4C415163514241514D42415145424151454351516D4251554942415144';
wwv_flow_imp.g_varchar2_table(429) := '424B414242414D4442416B4A43515942444145474441594641774D43415151424241454342515143416745424151514241514547415145424167454241674D48425151464241674441776B434151594445414D474177494441674D434177494442674944';
wwv_flow_imp.g_varchar2_table(430) := '41774D444177644B415149424177594D41774D46417749424151454541774D454351554543414D444167454241514543435149434167454341514942415145434167494241514545415145424251514442515146434167444167456E415145444267514A';
wwv_flow_imp.g_varchar2_table(431) := '42515145424149464177514A4151594A4177494241674D434151494442414D4B416767424167454341674D4241674D44434155454351514441774D45416745434151494241674551454159434177554A41776F4241674943447749444251594D46414543';
wwv_flow_imp.g_varchar2_table(432) := '415149424167454342674947435151464241514541774D434151454241674943415149424341774442414D4341514944416745434567454A42414D464241514542516B4541774D45414141414141674141502B61413767444967415541436B414C674179';
wwv_flow_imp.g_varchar2_table(433) := '414459414F67412B41454941414145694277594842685158466863574D6A63324E7A59304A79596E4A6763794678595846685148426763474969636D4A7959304E7A59334E6763564553455242544D5249784D564D7A554846544D314278557A4E516356';
wwv_flow_imp.g_varchar2_table(434) := '4D7A5542394870715A6A772B506A786D617652715A6A772B506A786D616E7075586C73314E7A633157313763586C73314E7A6331573134704153372B3676372B4773724B7973724B79736F44496A34385A6D7230616D5938506A34385A6D7230616D5938';
wwv_flow_imp.g_varchar2_table(435) := '506A45334E567465334635624E5463334E567465334635624E54665644503651415877592F7251424A786B5A53686759565267595452675941414141436741412F36494475414D67414138414877417841477741315146654162734341674A4D41726741';
wwv_flow_imp.g_varchar2_table(436) := '4141456D4267634748674933506745334E69596E4A6763324867494F417934434E6A632B415263474477454F41525958466A34424F774531497A59334A674D724151636A42794D4846513846465238464D7A38444D7A637A4E7A4D334D78637A467A4D58';
wwv_flow_imp.g_varchar2_table(437) := '4D7838424D7A38444E533845497A556A4A794D6E467738474652384B4D783847465238434D78384E4D7A38454E5338424E53636A4C77596A4C7745314979384C4979384249793848497A556E4E5338454977555041534D50424255504242554849776356';
wwv_flow_imp.g_varchar2_table(438) := '44774D6A4651635642794D564477515642794D50415255504168555041694D5041785550417855484651384B465163564877512F42444D2F4244552F4A6A5576417745504252555846516356427855484651635642785548465163564278554846516356';
wwv_flow_imp.g_varchar2_table(439) := '4278555042785566424438464D7A38424D7A38424E5438424D7A637A4E7A55334E544D314E7A55334E5463314E7A55334E5463314E7A55334E5363314C77514644775556467855584652637A4877557A4877455646785558465263564D78635646785566';
wwv_flow_imp.g_varchar2_table(440) := '424438454E53384E4E5363314A7A556E4E533844415138584877512F42444D2F417A4D334D7A637A4E7A4D334D7A63314E7A4D334E54637A5077497A4E7A4D3150774D314C7751464477555648774D564877457A4877497A487749564877457A48774556';
wwv_flow_imp.g_varchar2_table(441) := '4877457A467A4D584D78637A4877497A467A4D5846544D66427A4D584652637A46544D584D7A38454E5338454979636A4A794D6E4979384B4979384549793846497748305147385847526857666A6F395551454552446B724D695A494D784D4F4B304651';
wwv_flow_imp.g_varchar2_table(442) := '537A67614352595955474D4A4642304A4351514942416B4E42466C5A4569594F4F77634E4267304E4279634E446751444177514241674D4443515146426777474677594C4267594742696B4742675947426755664241554D41774D434167594443696347';
wwv_flow_imp.g_varchar2_table(443) := '4277594E422B6B4642415144417745434167494741674944426755454177674244674949416759434241454341674543417749444251514442414D4B425159444351514A4241514442414945426745454177494441674D43415149494151554442414945';
wwv_flow_imp.g_varchar2_table(444) := '4167494641676343416745434351454341674D4841774944416745434177494741676F462F664D46427745434177494441674D43417749444241454341674D4342414545424145434167494341674942416749434241494342414542415149444167494B';
wwv_flow_imp.g_varchar2_table(445) := '4151494341674545415149424167454341514943415151454177344543415144415145434177454341674942416745434151494241674944416745434341494241674943415151434241454741676F4342674D4B4177594442514D434151514743415543';
wwv_flow_imp.g_varchar2_table(446) := '736751464177594341514542415145424151454341514D464177554442414D4342674D4241674D4742416B4A42415144416745424177494241674D44416745464151774441514942415145424151454241515144424151492F4B594542514D4542414542';
wwv_flow_imp.g_varchar2_table(447) := '41774942417749424241454B4151514441674D43415149444151494542776B4A424151444241494541674D43427751424267454341514949415145424151554943414B784241514A4241554B42413846425173504267554C425345474378414942415543';
wwv_flow_imp.g_varchar2_table(448) := '416751444241304A4267595542514553426763464151554242514546415277424377554242515542425173504151514241774D4341515144424151492F643445424151444167494241674D454451494241674D4341514944417773434151674441775542';
wwv_flow_imp.g_varchar2_table(449) := '416745434151494241674D44415149424167454342414D4741773044485149444451514444516B46434155434151514442415144424167444641495241776B464551494742514D464251554341513843425149434151514442424545424155434E41464C';
wwv_flow_imp.g_varchar2_table(450) := '4F7A6D415752345646573141506E456146536342496A314A5444386F42786F34545645684A53777945694D324151385241774D4242686B69524167425341454342674543424149444241674A425151454177514241674943424149424151454241515542';
wwv_flow_imp.g_varchar2_table(451) := '426751444351554943414945426745424155384241514D444241514542516B4542674543415159444241494944674D49417759444241454341674D45417751444277634443414D53436767434241494341774D4943676348415177494241514542415145';
wwv_flow_imp.g_varchar2_table(452) := '4241734242774D47416759434177554442774D4341776B44416749484167494341674542415149434241494644414545416749434167494241674943416749424241494241674944424145454151514241674D434177494241674D434151494741674543';
wwv_flow_imp.g_varchar2_table(453) := '42674D44416755434151495041774942416745434177594441774D4441774D44417745454351554941774D44415151444177514742514D43425145434177494441674D4341774D4342514944416777434177494441674D454177514442674D4B41775943';
wwv_flow_imp.g_varchar2_table(454) := '43674547416755454241514A435159454166374741514943434151454241517A41776B444267494741774D4441774D444267494441776B4344674D4941513046437755474367634542516B45426749434167494441774D4442675947425145464277386D';
wwv_flow_imp.g_varchar2_table(455) := '41776F444177634441775144417751444177514442774D4F417977464351674541674D434577454341774D494242734742784D4844524D47427730474877304641515542425145464151554242514542424151454167494341774D4A4351674742675547';
wwv_flow_imp.g_varchar2_table(456) := '45417347455155474267557642675547426777474277554842674C2B73674543426751454267514A42414D464351494442414D4D4151514442414D4843516B4941774D4441674942426749474177494441674D444477594241774D424177514844415142';
wwv_flow_imp.g_varchar2_table(457) := '4177514542416B4942414D43416749424177494542416B45425151454177454B4167494341674943415145484167554241514544416749424167454341514542415145434167494541676B424151514242414545427755454351674541674D4241776347';
wwv_flow_imp.g_varchar2_table(458) := '41774D474167494441514D434177494A41674D43415151424241304241674141417741414141414449414A5941414D414277414C4141415446534531425255684E51555649545849416C6A3971414A592F61674357414A595A4754495A4754495A475141';
wwv_flow_imp.g_varchar2_table(459) := '4141554141502F544139514336514163414659416467434B414A34414141456942676335415251584668634742775950415255684E53636D4A79596E4E6A55354154516D427A497A4678595846683842466863574D7A4579507745574652514842676358';
wwv_flow_imp.g_varchar2_table(460) := '466863574652595646413842446745694A6938424A6A55304E7A51334E6A38424A7934424E5451334D6A637A4E6763774D51595846686365415449324E7A59334E6963774D52595846534D314978556A4E534D56497A55324579494F4152555246423442';
wwv_flow_imp.g_varchar2_table(461) := '4D794579506745314554517541534D46495449654152555246413442497945694C6745314554512B415146494A5449424367594A49686365447745425441455048686368467A464A4167494544776B47426749464177594B44416F454267554745674947';
wwv_flow_imp.g_varchar2_table(462) := '436749424151454A48695165435145424151494B4251494543673449417745434353494341514947444359714A677747416745434D684977464A77564C784D4F4E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C';
wwv_flow_imp.g_varchar2_table(463) := '5069516B50674A6A4D534D534667344C4441385548414B46685149634641384D46796F6A4D5338424151494342414545415149464177775046673050437849424241594742416B434167454B43676F4B41514943435151474267514246414D4949673452';
wwv_flow_imp.g_varchar2_table(464) := '45414544676777474441554E4451304E42517747444259676245784D544578734967464C4E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A5147534A54306B414141464141414141414F5041704D4141774148';
wwv_flow_imp.g_varchar2_table(465) := '4141734144774154414141544553455242544D56497A6368465345484D78556A4E79455649566B444E767A746E352F434169373930734B666E3849434C763353417050396C774A703061327472534F6C70615541417741414141414455674B3841415141';
wwv_flow_imp.g_varchar2_table(466) := '434141554141415446524568455155684553454246534D564D78557A4E544D31497A575741727A3963414A6B2F5A7742425A7562577075624172775A2F56304376437A396E4148366D3171626D317162414141414141514141502B574137304449674158';
wwv_flow_imp.g_varchar2_table(467) := '41444D415077424C414141424967344446686365416A632B415463324E7A596E4C67456E4A694D584D6863574678595846675948426763474277596E4A69636D4A79596E4A6A632B4168634846534D564D78557A4E544D31497A55484D78557A46534D56';
wwv_flow_imp.g_varchar2_table(468) := '497A556A4E544D423846656C66305142514430376F6242525649596E4B514D4748683532546C357243465651546A6B36466863584B797845526C7059566C68445179636D41774D6A486E4B5554305A3966597839665856656658316566583044496B5A39';
wwv_flow_imp.g_varchar2_table(469) := '6F624F6D506A394A43523464656C4654574664565534636D4C7A456E4A6B4A45556B2B6E53456F764E424150466859354E5646505631704F5358412B416442396A4831396A48305866563539666C304141414141424141412F35594476514D6A41425941';
wwv_flow_imp.g_varchar2_table(470) := '4D514137414551414141456D44674D57467834434E7A34424E7A59334E6963754153636D427A5958466863574678594742775948426763474A79596E4A69636D4A79593350674958426738424A774D334E6A635841785958466863334279634841665259';
wwv_flow_imp.g_varchar2_table(471) := '706F4645415541394F364777555653474A796B4442683465646B356561315A5355446F37467863584B797845526C7059566C68445179636D41774D6A486E4B552F4245694D3442304630676A686F6B48446B4D69486831384D674D6941555A2B6F624F6D';
wwv_flow_imp.g_varchar2_table(472) := '506A394A43523464656C4654574664565534636D4C7A45424A695644524652507030684B4C7A5151447859574F545A5154316461546B6C7750744D6A52576D6D2F716F65577936614151594A456C55715133535254514141426741412F35554476674D6B';
wwv_flow_imp.g_varchar2_table(473) := '414273414D51424A414741415A414270414141424A6763474277594842685958466863654154632B416A63324A7934424A79596E497959484E68635746785958466759484467456D4A7934434E7A5933506745584A676347427759484268635746785958';
wwv_flow_imp.g_varchar2_table(474) := '466A59335067496E4A696375415163324678595846676357426763474277596D4A79596E4A6A59334E6A63324677594849514D574679453241664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A';
wwv_flow_imp.g_varchar2_table(475) := '4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E5055705659474142674D426B4D2F3753';
wwv_flow_imp.g_varchar2_table(476) := '4D774D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D697377';
wwv_flow_imp.g_varchar2_table(477) := '4D4149734B6B5A4B5545754C4C4338484354457A4E5556436B4473394969746A724B30424A72526157674141414141474141442F6C514F2B417951414777417841456B4159414271414855414141456D427759484267634746686357467834424E7A3443';
wwv_flow_imp.g_varchar2_table(478) := '4E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A6332';
wwv_flow_imp.g_varchar2_table(479) := '4E7A5946426738424A774D334E6A6358417859584668633342796348426763423832786C59554643437777335044315454376457574952504267596548486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66';
wwv_flow_imp.g_varchar2_table(480) := '573156524D6A55424243516B51555253545A342F51555545486941384D487843554570484B7977424155672B514574486A444D32464255554A796339536745434553497A6748515853434F476951634F517949654858774F47517344496749324E567064';
wwv_flow_imp.g_varchar2_table(481) := '6246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D4441434C437047536C424C';
wwv_flow_imp.g_varchar2_table(482) := '6979777642776B784D7A5646517041375053497264694E466161622B716835624C706F4242676B5356537044644A45574A424D4141414D4141502B574137384449674162414449414F77414141534948426763474277595746785958486745334E6A632B';
wwv_flow_imp.g_varchar2_table(483) := '415463324A7934424A79596E4A6763324678595846686357426763474277596D4A7934424E6A63324E7A3442467759504152633146784548416574735932412F51416F4C4F54302B56453630553164415131414942783062655646545751305054306848';
wwv_flow_imp.g_varchar2_table(484) := '4B79774241304135504568476B4463354D68416D4B45416A55686B3262432F5279736F44496A633257313172584C64485369636D437877644F7A6D6857467454565973704B6751426A6749704B45564854306D4A4C6A454D44696B774D596558506B456A';
wwv_flow_imp.g_varchar2_table(485) := '465261694A6B30686C492B504153695041414141424141412F2F414471774C4D41424D414B7741764144774141424D69446745564552516541544D684D6A34424E5245304C67456A42534579486745564552514F41537342455345524979497541545552';
wwv_flow_imp.g_varchar2_table(486) := '4E443442457945524954636441534D564D78557A4E544D31497A58594B6B63714B6B6371416A6B7152796B7052797239787749354854456348444564645036756378307848427778727745552F75787A54553075545530437A436C484B7635594B6B6370';
wwv_flow_imp.g_varchar2_table(487) := '4B5563714161677152796B77484445642F6C67644D5277424E50374D48444564416167644D527A2B6D663773375263324C6B314E4C6B304141414141424141412F2F414471774C4D41424D414B77417641444D4141424D69446745564552516541544D68';
wwv_flow_imp.g_varchar2_table(488) := '4D6A34424E5245304C67456A42534579486745564552514F415373424553455249794975415455524E44344245794552495463564D7A58584B6B63704B556371416A6F7152796B7052797239786749364854456348444564645036756442307748427777';
wwv_flow_imp.g_varchar2_table(489) := '734145552F75776C79774C4D4B5563712F6C677152796B7052796F42714370484B5441634D52332B57423078484145302F7377634D523042714230784850365A2F75756E4C7938414141494141502F77413673437A4141544143634141424D6944674556';
wwv_flow_imp.g_varchar2_table(490) := '4552516541544D684D6A34424E5245304C67456A42534579486745564552514F41534D68496934424E524530506748584B6B63704B556371416A6F7152796B70527972397867493648544563484445642F6359644D4277634D414C4D4B5563712F6C6771';
wwv_flow_imp.g_varchar2_table(491) := '52796B7052796F42714370484B5441634D52332B57423078484277784851476F48544563414141444141442F6C674F2F41794941477741794144774141414569427759484267634746686357467834424E7A5933506745334E6963754153636D4A795948';
wwv_flow_imp.g_varchar2_table(492) := '4E6863574678595846675948426763474A696375415459334E6A632B415263474477456E417A63324E7863423632786A5944394143677335505435555472525456304244554167484852743555564E5A44513950534563724C41454451446B3853456151';
wwv_flow_imp.g_varchar2_table(493) := '4E7A6B794543596F51434E53316845694D3442304630676A68674D694E7A5A62585774637430644B4A79594C484230374F61465957314E5669796B714241474F41696B6F5255645053596B754D51774F4B5441786835632B51534D56466E556A52576D6D';
wwv_flow_imp.g_varchar2_table(494) := '2F716F6557793661414141474141442F6C514F2B417951414777417841456B415941427241486B414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C674933';
wwv_flow_imp.g_varchar2_table(495) := '4E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A5958426749484E6A63324E78636D4C7745574877456E42676347427759334E6A6332';
wwv_flow_imp.g_varchar2_table(496) := '41664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238';
wwv_flow_imp.g_varchar2_table(497) := '516C424B5279737341514649506B424C5234777A4E6851564643636E505570564745305846796F6E4648305A4D54494D46694A4543426B5342676F4243785157417949434E6A566158577863746B6C4B4B43674C4842313370466C6255314F474B436B46';
wwv_flow_imp.g_varchar2_table(498) := '416A45444D544254566D4E59724542444F7841724C492B7A56566C4352453472417A417654314A625531424F4E6A6751454355774D6F7969535577794B7A417741697771526B7051533473734C77634A4D544D3152554B514F7A30694B3239432F764E42';
wwv_flow_imp.g_varchar2_table(499) := '467A41724659644F6E6C456B5357354B427830554277734749554E4D414141414141634141502B5341384544497741634144634155514271414873416A4143654141414249694D69427759484267634746686357467834424E7A5933506745334E693442';
wwv_flow_imp.g_varchar2_table(500) := '4A79596E4A6763794D7A59584668635746785947427759484467456E4A69636D4A7959334E6A632B4152636949794948426763474277595746785958466A59334E6A632B4153636D4A793442427A497A4D6863574678595846675948426763474C67456E';
wwv_flow_imp.g_varchar2_table(501) := '4C6745334E6A632B415263694267634748674933506745334E69596E4A694D584D68344344674D75416A593350674566415159504151344246686357506745374154556A4E6A636D41664D42416D4E6557304243466855654C693949534C4A5A5845744B';
wwv_flow_imp.g_varchar2_table(502) := '6142555747313549535659344F77554658465A554F546F5045436F304E55704D74464E564F7A306448416B4B4C6A5734626755465645394C4D6A514A437A59344F6B78496E5556474C544165464255324D34355041774E4C52554D724C4159494E7A5534';
wwv_flow_imp.g_varchar2_table(503) := '5255535064694169416838684F69686A4C7A397346786B59566E343650564542424551354B7A49454A555979457734725156424C4F426F4A466868514C44634A4642304A4351514942416B4E42466C5A4569594F417949754C5535515956617A5455347A';
wwv_flow_imp.g_varchar2_table(504) := '4E536F4F447A41756B565A58725A73324E78514F4D5145744B30784E57314B6F5245596E4B676F674955412F5631525A57307058615373724B6B684A56452B644F7A77624777306C4A6A39416F3039534F7A70444D43636D5145464C523473794E424955';
wwv_flow_imp.g_varchar2_table(505) := '4731552B514A5A4352537366496D464B4F7A6D415752345646573141506E45614653636A5045684D50796748476A684E5553456C4C41457845694D324151385241774D4242686B6952416741414141454141442F6C674F3941794D414667417841447741';
wwv_flow_imp.g_varchar2_table(506) := '536741414153594F4178595848674933506745334E6A63324A7934424A7959484E6863574678595846675948426763474277596E4A69636D4A79596E4A6A632B41686347416763324E7A593346795976415259664153634742775948426A63324E7A5942';
wwv_flow_imp.g_varchar2_table(507) := '3946696D67555142514430376F6242525649596E4B514D4748683532546C3572566C4A514F6A7358467863724C455247576C685757454E444A79594441794D65637052504745305846796F6E4648305A4D54494D46694A4543426B5342676F4243785157';
wwv_flow_imp.g_varchar2_table(508) := '41794942526E36687336592B50306B4A4868313655564E5956315654687959764D51456D4A554E4556452B6E53456F764E424150466859354E6C42505631704F5358412B7A454C2B383045584D437356683036655553524A626B6F484852514843775968';
wwv_flow_imp.g_varchar2_table(509) := '51307741424141412F35594476514D6A414259414D51413141446F414141456D44674D57467834434E7A34424E7A59334E6963754153636D427A5958466863574678594742775948426763474A79596E4A69636D4A795933506749584267636841785958';
wwv_flow_imp.g_varchar2_table(510) := '495459423946696D67555142514430376F6242525649596E4B514D4748683532546C3572566C4A514F6A7358467863724C455247576C685757454E444A79594441794D656370525059474142674D426B4D2F37534D774D6941555A2B6F624F6D506A394A';
wwv_flow_imp.g_varchar2_table(511) := '43523464656C4654574664565534636D4C7A45424A695644524652507030684B4C7A5151447859574F545A5154316461546B6C77507343737251456D744670614141634141502F544139514336514154414363414B77417A414463414F77412F41414154';
wwv_flow_imp.g_varchar2_table(512) := '49673442465245554867457A4954492B415455524E433442497755684D683442465245554467456A49534975415455524E4434424678456845515568465345314978556A46544D56497A63684653454446534531317A565A4E54565A4E5149364E566F30';
wwv_flow_imp.g_varchar2_table(513) := '4E466F312F6359434F69552B4A43512B4A6633474A54346B4A4434424166722B477748502F716B57596D4A69654146582F716C32416330433654525A4E6635754E566B304E466B31415A4931575451384A44306C2F6D346C5053516B505355426B695539';
wwv_flow_imp.g_varchar2_table(514) := '4A456A2B684146386732686E5A78566D5A6D5942546D7873414141434141414141414E3941704D415367437A4141414249676335415159484F514547427A6B424267634748514555467A4178466863574D7859334F5145794E6A55304A7A4D794E7A5933';
wwv_flow_imp.g_varchar2_table(515) := '4D54596E506745304A7934424B7745324E546B424E43637541534D464E7A592F415459335067456E4C674576415445484D4449564D68633541525947427A6B4242673842446745564642637848674558466A7342466A637A4D6859584668514842697342';
wwv_flow_imp.g_varchar2_table(516) := '46534579466863574654455542694D684653457946686357427A6B424467456A4952557A4D68595846685535415251484467456A426963354153496E4A6963314A6A30424E4463324E7A59334D5459334D54597A4E444D427A4130535062677645776743';
wwv_flow_imp.g_varchar2_table(517) := '415167514C536842334E7361485155514767344E4267594D4778734F4342674F465159504342674F2F734D464267514F457759504241304745676F464151454642515543427767644442594B4167494642774D4344457557635159494241674842412F79';
wwv_flow_imp.g_varchar2_table(518) := '415434474341514843672F2B7767455042776B4543414D444377762B3863304642674D4742674947427476624F52346844516342416759524A4D4D784277514241704D4B4B494167507867674579514E4D534A4248686F4241534D634478454F43786765';
wwv_flow_imp.g_varchar2_table(519) := '46774D684F78514B4451345248524D4C4441454642774D4F465163544C68494B444149424977454942786F4A4368304D46513047417759464267454241514545425177664351596A4241554B45684D4D497759474452554D43534D444241675244776744';
wwv_flow_imp.g_varchar2_table(520) := '416745424642593041523473436951534852557A475963674241454141414D414141414141346F436167414441415941437741414578456845515568425355464A52456858774D722F5367436850362B2F6F34426367467A2F527343617633704168636A';
wwv_flow_imp.g_varchar2_table(521) := '314D7230395034354141494141502F54413951433651415441434D4141424D69446745564552516541544D684D6A34424E5245304C67456A42534579466855524641596A4953496D4E5245304E75633559546B3559546B43476A6C684F546C684F66336D';
wwv_flow_imp.g_varchar2_table(522) := '41686F724F6A6F722F6559724F6A6F43365468664F66364B4F5638344F46383541585935587A68754F536E2B69696B354F536B4264696B35414141464141442F6D674F34417949414641417041446F415377426441414142496763474277595546785958';
wwv_flow_imp.g_varchar2_table(523) := '466A49334E6A63324E43636D4A7959484D68635746785955427759484269496E4A69636D4E4463324E7A595849675948426834434E7A34424E7A596D4A79596A467A4965416734444C6749324E7A3442487745474477454F41525958466A34424F774531';
wwv_flow_imp.g_varchar2_table(524) := '497A59334A674830656D706D5044342B50475A713947706D5044342B50475A71656D3565577A55334E7A566258747865577A55334E7A5662586D6F2F6242635A47465A2B4F6A3152415152454F537379424356474D684D4F4B304651537A676143525959';
wwv_flow_imp.g_varchar2_table(525) := '554377334352516443516B454341514A4451525A5752496D44674D69506A786D617652715A6A772B506A786D617652715A6A772B4D54633157313763586C73314E7A633157313763586C73314E37314B4F7A6D415752345646573141506E45614653636A';
wwv_flow_imp.g_varchar2_table(526) := '5045684D50796748476A684E5553456C4C41457845694D324151385241774D4242686B6952416741414141464141442F6C674F3941794D41466741784144594151414247414141424A67344446686365416A632B415463324E7A596E4C67456E4A676332';
wwv_flow_imp.g_varchar2_table(527) := '467859584668635742676347427759484269636D4A79596E4A69636D4E7A344342785156495245464D6A4D47427759484267636D4E7851564954555841665259706F4645415541394F364777555653474A796B4442683465646B356561315A5355446F37';
wwv_flow_imp.g_varchar2_table(528) := '467863584B797845526C7059566C68445179636D41774D6A486E4B55666747612F73467963673867474130564545446A2F73696341794942526E36687336592B50306B4A4868313655564E5956315654687959764D51456D4A554E4556452B6E53456F76';
wwv_flow_imp.g_varchar2_table(529) := '4E424150466859354E6C42505631704F5358412B2B4A79634154677843527757435138434E41566458627039414141454141442F6C514F2B41794D414777417A41456F41595141414153594842676347427759574678595848674533506749334E696375';
wwv_flow_imp.g_varchar2_table(530) := '4153636D4A794D6D427A59584668635746785947427759484269596E4A696375415463324E7A344246794948426763474651595746785958466A59335067496E4A696375415163794678595846676355426763474277596D4A79596E4A6A59334E6A6332';
wwv_flow_imp.g_varchar2_table(531) := '416642735A47452F5167734D4E7A773955302B33566C69455477594748687831546B395741787346593174594F446F4743454641516C52527355784F4D444D67466859364F71644E57314A514D54494354454A46556B7962506B42454242386750444B41';
wwv_flow_imp.g_varchar2_table(532) := '4E56464A52796B7141306B39514570486A444D32464255554A79673954514D6941545931576C3172584C5A4A5369676F437877646436525A57314E53686967704267497841544D795646646A574B74415152736345796F735230657A566C6C43526B3475';
wwv_flow_imp.g_varchar2_table(533) := '4D6A4251553174546D7A55334467386E4D44474D6F6B6C4D4D6977764D53307253457052536F63734C51634A4D544D3152554B514F7A34684C514141414141474141442F6C514F2B417951414777417841456B415941426F414845414141456D42775948';
wwv_flow_imp.g_varchar2_table(534) := '4267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947';
wwv_flow_imp.g_varchar2_table(535) := '427759484269596E4A69636D4E6A63324E7A59584642556A46544D564E796357487745484E534D314D77487A624756685155494C4444633850564E5074315A5968453847426834636430395156774D5645474E6457546F3843416B39506B436D74453151';
wwv_flow_imp.g_varchar2_table(536) := '5A434156467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B682B4C6970596B52496A4E6D33393844496749324E56706462467932';
wwv_flow_imp.g_varchar2_table(537) := '53556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D4441434C437047536C424C69797776';
wwv_flow_imp.g_varchar2_table(538) := '42776B784D7A5646517041375053497264444979766D54446568516F50586B326851414141414D4141502B574137384449674162414449415051414141534948426763474277595746785958486745334E6A632B415463324A7934424A79596E4A676332';
wwv_flow_imp.g_varchar2_table(539) := '4678595846686357426763474277596D4A7934424E6A63324E7A344246775943427A59334E6A63584A6963423632786A5944394143677335505435555472525456304244554167484852743555564E5A44513950534563724C41454451446B3853456151';
wwv_flow_imp.g_varchar2_table(540) := '4E7A6B794543596F51434E534B52684E467863714A78523947544544496A633257313172584C64485369636D437877644F7A6D6857467454565973704B6751426A6749704B45564854306D4A4C6A454D44696B774D596558506B456A46525A755176377A';
wwv_flow_imp.g_varchar2_table(541) := '515263774B78574854703441414141454141442F61674B694131494141774155414234414B5141414A534556495145524D7A4932505145304A7A3442505145304A79596A427A4D7946683042464159724151637A4D686357485145554269734241714C2B';
wwv_flow_imp.g_varchar2_table(542) := '704146632F71537756565A524979416D4B4651354F523861494349774254556C4542496348554D707677506F2F545A55556A703749684A474E7878514B43706B4A43676D4B534E754568517750695968414141414141514141502B614137674449674151';
wwv_flow_imp.g_varchar2_table(543) := '4142514161674276414141424967634242685158415259794E7745324E4363424A67634A4169557844774D564C7749504242384349773844465238444D7738434877512F41685566417A4D2F417A5566416A38454C77497A507749314C77496A50774976';
wwv_flow_imp.g_varchar2_table(544) := '424138434E533843427A4135415441423941384C2F6D454B436747664378384B415A384C432F356843773842687635362F6E6F42665151454167466A4177514542413043415145435934774541774942415149444249786A416745424167304542415144';
wwv_flow_imp.g_varchar2_table(545) := '59774543424151534241514341574D44424151454451494241514A6A6A41514441774D444249786A41674542416730454241514459774543424973444967762B59516F66432F356843676F426E77736643674766437A372B657635364159624741514944';
wwv_flow_imp.g_varchar2_table(546) := '4249786A41674542416730454241514459774543424151534241514341574D44424151454451494241514A6A6A4151444167454241674D456A474D43415145434451514542415269415149454767514341574D44424151454451494241514A6A6A415144';
wwv_flow_imp.g_varchar2_table(547) := '417A4141414141454141442F6D674F34417949414541415541426F41487741414153494841515955467745574D6A63424E6A516E415359484351496C447745584954636E4677636A4A7748304477762B59516F4B415A384C48776F426E77734C2F6D454C';
wwv_flow_imp.g_varchar2_table(548) := '447747472F6E722B65674747423942534151705331377449356B67444967762B59516F66432F356843676F426E77736643674766437A372B6576353641596267425A66392F583648334E77414141494141502B61413767444967415041424D4141424D47';
wwv_flow_imp.g_varchar2_table(549) := '46426342466A4933415459304A77456D4967634A417A734B436747664378384B415A384C432F35684368384C2F705142686747472F6E6F4265416F66432F356843676F426E777366436747664377762B527747472F6E722B65674141414141454141442F';
wwv_flow_imp.g_varchar2_table(550) := '6D674F344179494145414155414345414C6741414153494841515955467745574D6A63424E6A516E415359484351496C49673442464234424D6A34424E433442427A49654152514F415349754154512B415148304477762B59516F4B415A384C48776F42';
wwv_flow_imp.g_varchar2_table(551) := '6E77734C2F6D454C447747472F6E722B656747474F5745344F4746795954673459546B7A566A4979566D5A574D6A4A574179494C2F6D454B4877762B59516F4B415A384C48776F426E77732B2F6E722B65674747306A6868636D45344F47467959546758';
wwv_flow_imp.g_varchar2_table(552) := '4D6C5A6D566A4979566D5A574D674141414141444141442F6C674F2F417949414777417941456F4141414569427759484267634746686357467834424E7A5933506745334E6963754153636D4A7959484E6863574678595846675948426763474A696375';
wwv_flow_imp.g_varchar2_table(553) := '415459334E6A632B4152636D427734424277595846686365415463324E7A59335067456E4A6963754151487262474E675030414B437A6B39506C524F74464E5851454E514341636447336C5255316B4E443039495279737341514E414F54784952704133';
wwv_flow_imp.g_varchar2_table(554) := '4F5449514A696841493149704E6A497651676B4C4567346F4A576B314F43777547686B4546685973486B7344496A633257313172584C64485369636D437877644F7A6D6857467454565973704B6751426A6749704B45564854306D4A4C6A454D44696B77';
wwv_flow_imp.g_varchar2_table(555) := '4D596558506B456A46525A5241686F5A575451344D7A516F4A535547427941644D6939764D44516747426F41417741412F35594476774D69414273414D6741324141414249676347427759484268595846686365415463324E7A34424E7A596E4C67456E';
wwv_flow_imp.g_varchar2_table(556) := '4A69636D427A59584668635746785947427759484269596E4C6745324E7A59335067455842676368416574735932412F51416F4C4F54302B564536305531644151314149427830626556465457513050543068484B79774241304135504568476B446335';
wwv_flow_imp.g_varchar2_table(557) := '4D68416D4B45416A55696C6759414741417949334E6C74646131793352306F6E4A677363485473356F5668625531574C4B536F45415934434B5368465230394A69533478444134704D4447486C7A354249785557597179744141494141502B5341384544';
wwv_flow_imp.g_varchar2_table(558) := '497741614144454141414569427759484267634748674558486745334E6A632B415463324A7934424A79596E4A67637946785958466863574267634F4153596E4A696375415463324E7A34424166426B586C7442516855554947424A52363959576B6C4B';
wwv_flow_imp.g_varchar2_table(559) := '6152595844673169536B785A4E43644B524545724C51634A4D444D30687041385069496D427838675043706D417949764C564252596C617A6D7A497A4B4134504C79325256566857577034324F42494C6A69556B506A394A526F737A4E5373554A796739';
wwv_flow_imp.g_varchar2_table(560) := '514A7046534377674951414141414D4141502B574137384449674161414338414F51414141534948426763474277595746785958486745334E6A632B415463324A7934424A79596E427A59584668635746785947427734424A696375415459334E6A6332';
wwv_flow_imp.g_varchar2_table(561) := '46775950415263684E6A38424A67487262474E675030414B437A6B38506C525074464E5851454E514341636447336C5255316B63543068484B797742413041364F3436514E7A6B794479636F514568574A4564735567454B4679735152774D694F445A61';
wwv_flow_imp.g_varchar2_table(562) := '586D7463746B644B4A79594C484277374F71465957314E5669796B71424930434B5368465230394A6953387747696B774D5965575030456A4B3159614E453739524967784E414141414141454141442F6C674F2F41794941477741794144634150514141';
wwv_flow_imp.g_varchar2_table(563) := '41534948426763474277595746785958486745334E6A632B415463324A7934424A79596E4A6763324678595846686357426763474277596D4A7934424E6A63324E7A3442427859584E6A634646425568455163423632786A594439414367733550543555';
wwv_flow_imp.g_varchar2_table(564) := '5472525456304244554167484852743555564E5A44513950534563724C41454451446B38534561514E7A6B794543596F51434E53666C5A564F484C2B6851476179514D694E7A5A62585774637430644B4A79594C484230374F61465957314E5669796B71';
wwv_flow_imp.g_varchar2_table(565) := '4241474F41696B6F5255645053596B754D51774F4B5441786835632B51534D5646707046525335634949794D41524B6A41414141417741412F35594476774D69414273414D6741364141414249676347427759484268595846686365415463324E7A3442';
wwv_flow_imp.g_varchar2_table(566) := '4E7A596E4C67456E4A69636D427A59584668635746785947427759484269596E4C6745324E7A5933506745584642556A46544D564E77487262474E675030414B437A6B39506C524F74464E5851454E514341636447336C5255316B4E4430394952797373';
wwv_flow_imp.g_varchar2_table(567) := '41514E414F547849527041334F5449514A69684149314A6234754B6C417949334E6C74646131793352306F6E4A677363485473356F5668625531574C4B536F45415934434B5368465230394A69533478444134704D4447486C7A354249785557637A4979';
wwv_flow_imp.g_varchar2_table(568) := '766D544441414141427741412F35554476674D6B414273414D51424A414741415A514276414855414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C674933';
wwv_flow_imp.g_varchar2_table(569) := '4E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A594846425568455155794D7759484267634742795933464255684E5263423832786C';
wwv_flow_imp.g_varchar2_table(570) := '59554643437777335044315454376457574952504267596548486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66573156524D6A55424243516B51555253545A342F51555545486941384D48784355457048';
wwv_flow_imp.g_varchar2_table(571) := '4B7977424155672B514574486A444D32464255554A796339536E67426D763742636E49504942674E46524241342F37496E414D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841';
wwv_flow_imp.g_varchar2_table(572) := '517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B447339496975626E4A77424F44454A4842594A4477493042563164';
wwv_flow_imp.g_varchar2_table(573) := '756E3041425141412F35554476674D6B414273414D51424A41474141615141414153594842676347427759574678595848674533506749334E6963754153636D4A794D6D427A59584668635746785947427734424A696375416A63324E7A344246795948';
wwv_flow_imp.g_varchar2_table(574) := '426763474277595846686357467859324E7A34434A79596E4C6745484E6863574678594846675948426763474A69636D4A7959324E7A59334E686347447745584E5263524277487A624756685155494C4444633850564E5074315A596845384742683463';
wwv_flow_imp.g_varchar2_table(575) := '6430395156774D5645474E6457546F3843416B39506B436D744531515A434156467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B';
wwv_flow_imp.g_varchar2_table(576) := '52545A734C39484B79674D69416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D';
wwv_flow_imp.g_varchar2_table(577) := '6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A4E5556436B4473394969756A4A6B30686C492B5041536950414141414141514141502B574137304449774157414445414F774243414141424A67344446686365416A632B41546332';
wwv_flow_imp.g_varchar2_table(578) := '4E7A596E4C67456E4A676332467859584668635742676347427759484269636D4A79596E4A69636D4E7A344346775950415263684E6A38424A6963574677636A4A7A59423946696D67555142514430376F6242525649596E4B514D4748683532546C3572';
wwv_flow_imp.g_varchar2_table(579) := '566C4A514F6A7358467863724C455247576C685757454E444A79594441794D65637052504A4564735567454B467973515235423850306A6D53443844496746476671477A706A342F53516B65485870525531685856564F484A6938784153596C51305255';
wwv_flow_imp.g_varchar2_table(580) := '543664495369383045413857466A6B3255453958576B354A63443630476A524F2F5553494D54524B5769336333433041414141474141414141414E46417055414B51425041464D415677426241463841414145504151594842676355467859584D525958';
wwv_flow_imp.g_varchar2_table(581) := '4668635742676347447745684E7A4D2B4153636D4A7959764153596E4A6A55304E7A592F41515568426763474651595846686378466863574678594842676347427945324E7A596E4A69636D4C77456D4A7959334E4463324678557A4E5163564D7A5548';
wwv_flow_imp.g_varchar2_table(582) := '46544D314278557A4E51463842414A554B5359434778416F4A4241584177454A444274495367484B4251464E525155454677386A445349514642306B54556E2B524145614A78556E415273514B43515146774D424241514E4755582B3552385149775545';
wwv_flow_imp.g_varchar2_table(583) := '4741386B444349504651456349517263356556393362376C41705543415449774C69346F4B4267704A5255654651305A45434D724B774D74567930684968516B4469495848686B6449536F754B793464476934754B4367594B5355564868554E44413450';
wwv_flow_imp.g_varchar2_table(584) := '49536B5846697773496949554A51776A4668345A4853456E49685556637859576442555663785957414141414141514141502F54413951433651415441436341617744494141415449673442465245554867457A4954492B415455524E43344249775568';
wwv_flow_imp.g_varchar2_table(585) := '4D683442465245554467456A49534975415455524E443442467949484F51454744774547427A6B424267634748514578464263774D5234424D7859334F5145794E6A55304A7A4D794E6A63774D54596E506745334E6A516D4B7745324E546B424E436375';
wwv_flow_imp.g_varchar2_table(586) := '415373424E7A59335067456E4A6963484D444579467A6B42466759484F51454744774547467A45574877457A466A637A4D686357464163474979496E4652597A4D6859564D525148446745724152557A4D6859484F51454F4153734246544D784D685956';
wwv_flow_imp.g_varchar2_table(587) := '4F514555427759484954456D4A79596E4F51456D4E5445304E7A59334E6A38424E6A38424E6A50584E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C5069516B50716F4B434264704752304E4251454242517330';
wwv_flow_imp.g_varchar2_table(588) := '4B596D4A455245444368415242414D484341344543424D544467554B4242414978676B5542516B4342776F4D41775144417749454168555A42414D43427749434D5752454351494642514D495A6A4E446851634A42414D45426369724277734441516348';
wwv_flow_imp.g_varchar2_table(589) := '7134494742674D444276377549684D57427755424151514C466B46494477494541514C704E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A5147534A54306B4B415950534245564A7738554442634848426772';
wwv_flow_imp.g_varchar2_table(590) := '4B6749434668414B43524550464134424351594D4A52774D4442494C4267634A4641594D4851734F41525946425138474178555A42676348415145424151554646775547415259424451734C43414D444668414F427763574277774842674D4241684154';
wwv_flow_imp.g_varchar2_table(591) := '4942556147517755446941514C44494B41514541414141434141414141414F47416D41414167414841414154425355464553455242574D426B5147522F4E384449763575416D446A3431542B5141484134414141414141464141414141414D73416E6341';
wwv_flow_imp.g_varchar2_table(592) := '4A67424F414959416A774359414141424642554742796348467759484978557A46686331427A557A4E7A592F41536333467A6332507745314D78557A4A69636D4A7A5548465159484A7763584267636A46546357467763584E78595846544D314E6A6358';
wwv_flow_imp.g_varchar2_table(593) := '4E7963324E7A4D314979596E4E7963484A696333427A4D484678596641546358427863574877457A46513842426738424677636E427759504152556A4E53636D4C7745484A7A636E4A693842427A557A4E7A592F41536333467A63325077455849675955';
wwv_flow_imp.g_varchar2_table(594) := '466A49324E4359484D6859554269496D4E4459426E5259574B456F6F444159344F4167554D5445444268454949686B6944426F674469526542685952446759624553684B4A7773474F546B484379684C4B524D5A61526B544B556F70444159344F41674C';
wwv_flow_imp.g_varchar2_table(595) := '4A30736E4668594252795142447834634379495A4951675342674D784D514D474551676B47694D4D4778384F497738664777736B47695149456759444D6A49444268454949786B6A44426769446849674C7939414C79386745786B5A4A526F61416E6363';
wwv_flow_imp.g_varchar2_table(596) := '4841594D4A306F6F45786871475235624153514F48786F4D49786B6943424149417A417742776B494244646C4E77674C4B45736F46426471415255584B456F6F444159354F67594D4B45736F46685A704752496E5369634D426A636A4D414D4745516769';
wwv_flow_imp.g_varchar2_table(597) := '4753494D4778344F4977454F48786F4D49786F6B43424947417A4D79417759534343515A49777762487734424A413465484177694753494945416744554339424C6935424C794D614A526B5A4A526F4141414141425141412F394D4431414C7041424D41';
wwv_flow_imp.g_varchar2_table(598) := '4A774172414334414D7741414579494F41525552464234424D794579506745314554517541534D46495449654152555246413442497945694C6745314554512B41516352495245464951636E467A63524964633157545531575455434F6A56614E445261';
wwv_flow_imp.g_varchar2_table(599) := '4E663347416A6F6C5069516B506958397869552B4A43512B4151494F2F6967426F7448773850482B48774C704E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A5147534A54306B552F366C4156735869594F65';
wwv_flow_imp.g_varchar2_table(600) := '6E76375A41414141417741414141414445514B644143414157414237414141424967634F41525535415251584668634742775950415255684E53636D4A79596E4E6A55354154516D4A7959484D6863574678596641525958466863784E6A38424E6A6357';
wwv_flow_imp.g_varchar2_table(601) := '46525148426763664168595642673842446745694A6938424A69633050774D6D4A7934424A7959314E4438424E6763774651595846686357467859794E7A59334E6A63324E7A596E4E52595846534D31497855684E534D56497A5532416641724A43496E';
wwv_flow_imp.g_varchar2_table(602) := '454173514F796731476749435167495A4E4367364B4363694A47674A42526F5144416B454341594B45426B4F4167514343676B4D4867516342414542415145514E7A6F33454145424151454547774D454177635142673050426777304177494343785969';
wwv_flow_imp.g_varchar2_table(603) := '4945676749685948417749424177525749464D6A2F76416A557941436E425554524359694A526F5246426F6A4D51546E3577517749786F554B556F6D52424D565577454242515147416759434177454243414943415251614A7859624569414A46416750';
wwv_flow_imp.g_varchar2_table(604) := '4241514345424953454149454241384946416B6942414946467730664768385A4167586841517753464173574441734C444259474351594B445245424A6A6D3768495345684C7335414141414141494141502B57413730444967415841444D4141414569';
wwv_flow_imp.g_varchar2_table(605) := '44674D57467834434E7A34424E7A59334E6963754153636D49786379467859584668635742676347427759484269636D4A79596E4A69636D4E7A3443467748775636562F5241464150547568734646556869637041775965486E5A4F586D73495656424F';
wwv_flow_imp.g_varchar2_table(606) := '4F546F57467863724C455247576C685757454E444A79594441794D656370525041794A476661477A706A342F53516B65485870525531685856564F484A6938784A795A4352464A507030684B4C7A5151447859574F545A5154316461546B6C7750674541';
wwv_flow_imp.g_varchar2_table(607) := '4141554141502B56413734444A4141624144454153514267414773414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D42775948';
wwv_flow_imp.g_varchar2_table(608) := '4267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A5958426749484E6A63324E78636D4A77487A624756685155494C4444633850564E5074315A596845384742683463';
wwv_flow_imp.g_varchar2_table(609) := '6430395156774D5645474E6457546F3843416B39506B436D744531515A434156467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B';
wwv_flow_imp.g_varchar2_table(610) := '5652684E467863714A78523947544544496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F424151';
wwv_flow_imp.g_varchar2_table(611) := '4A5441796A4B4A4A544449724D4441434C437047536C424C6979777642776B784D7A5646517041375053497262304C2B383045584D43735668303665414141414141594141502B56413734444A414162414445415351426741476F416351414141535948';
wwv_flow_imp.g_varchar2_table(612) := '42676347427759574678595848674533506749334E6963754153636D4A794D6D427A59584668635746785947427734424A696375416A63324E7A344246795948426763474277595846686357467859324E7A34434A79596E4C6745484E68635746785948';
wwv_flow_imp.g_varchar2_table(613) := '46675948426763474A69636D4A7959324E7A59334E686347447745584954592F4153596E466863484979633241664E735A5746425167734D4E7A773955302B33566C6945547759474868783354314258417855515931315A4F6A77494354302B514B6130';
wwv_flow_imp.g_varchar2_table(614) := '5456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E505570564A4564735567454B467973515235423850306A6D53443844';
wwv_flow_imp.g_varchar2_table(615) := '496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D444143';
wwv_flow_imp.g_varchar2_table(616) := '4C437047536C424C6979777642776B784D7A5646517041375053497256786F305476314569444530536C6F74334E7774414141514141442F6F414F374179494143674159414359414E5142484146674161514233414951416B774368414C454176774453';
wwv_flow_imp.g_varchar2_table(617) := '414F45413967414141515943427A59334E6A63584A693842466838424A775948426763474E7A59334E684D4742773442466A6332467859324A69636D46795947466863574678592B415363754153636D425159484267634742775948426859794E7A5933';
wwv_flow_imp.g_varchar2_table(618) := '4E6934424D7949484967634F415234424E7A5958466A59304A795948426763474477454742775965415463324E7A59304A67556D42685958466863574D6A596E4A69636D42535948426863654154596E4A6A63324A67556D42686357427759654154632B';
wwv_flow_imp.g_varchar2_table(619) := '415363754151556D426863574678592B4153636D4E7934424253594842676347427759654154632B415463754151556942685958466863574E69596E4A69636D425134424277594842673842446745574E7A34424E7A34424A6755694268595848674558';
wwv_flow_imp.g_varchar2_table(620) := '466A596D4A79596E4A675547427759484267634742775948446745574E7A34424E7A5975415148304745305846796F6E4648305A4D54494D46694A4543426B5342676F424378515744456F76444145544446356D444134464444484B4441384443307774';
wwv_flow_imp.g_varchar2_table(621) := '42786B504242684A4C6754393951734B42677349425545684242455942796C524267454E2F77514B4567634E43516B55435535484442494C51756F4E44676B51436A305A4252455A42696C51434134426677774F41676F304751635A4541516152415439';
wwv_flow_imp.g_varchar2_table(622) := '77786B4643787347474249434768414244674C7044773044415441454542674848527345416737387041384F4177497842786B504253384341513043374138484251454E4D675950475167644A6759424466326F43777743434439554442454243303833';
wwv_flow_imp.g_varchar2_table(623) := '426747664443734C45786B504868454D4251384D4C31736E4341454E2F6A304C44514D4B4B324D3044413446444752504267495943516B4643673449486959664B677343455130325A536B48416730434A6B4C2B383045584D437356683036655553524A';
wwv_flow_imp.g_varchar2_table(624) := '626B6F484852514843775968513077426441495142686B5242426B5741524D5A4241785441524D59425468624367455444444A594941494B4151634643776745506C414D4567746451416354446745434242555243414D4748775152475159664A774949';
wwv_flow_imp.g_varchar2_table(625) := '425177484D44414D4577454C514334484577383741524958426A565543784D4D5855454471514972566B304C4178454D5546514B446930424767356C5867775341516F3265543449436841424767357257676F43457778625A67674C4F41454E4368452F';
wwv_flow_imp.g_varchar2_table(626) := '517777554177736D5679304A4471415246675A4A48514D534741596551675A4E4178554442775144417749454742514241526B59427855504A784D5742534976436745554741515651674D4441515544435173444641384D4367595A45674D4C4D534D48';
wwv_flow_imp.g_varchar2_table(627) := '45773441414141464141442F6C514F2B417951414777417841456B415941426F414141424A6763474277594842685958466863654154632B416A63324A7934424A79596E497959484E68635746785958466759484467456D4A7934434E7A593350674558';
wwv_flow_imp.g_varchar2_table(628) := '4A676347427759484268635746785958466A59335067496E4A696375415163324678595846676357426763474277596D4A79596E4A6A59334E6A6332467851564978557A465463423832786C595546434377773350443154543764575749525042675965';
wwv_flow_imp.g_varchar2_table(629) := '48486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66573156524D6A55424243516B51555253545A342F51555545486941384D487843554570484B7977424155672B514574486A444D32464255554A796339';
wwv_flow_imp.g_varchar2_table(630) := '536F666934715544496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E575931697351454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A';
wwv_flow_imp.g_varchar2_table(631) := '544449724D4441434C437047536C424C6979777642776B784D7A5646517041375053497264444979766D5444414141414141304141502B69413767444941414541416741444141514142514147414254414C77425251476941656B434D774B6641414142';
wwv_flow_imp.g_varchar2_table(632) := '465245684551557A45534D5446544D314278557A4E5163564D7A554846544D314179734242794D4849776356447755564877557A50774D7A4E7A4D334D7A637A467A4D584D78637A4877457A50774D314C77516A4E534D6E497963584477595648776F7A';
wwv_flow_imp.g_varchar2_table(633) := '487759564877497A4877307A507751314C7745314A794D7642694D764154556A4C77736A4C77456A4C77636A4E5363314C77516A4251384249773845465138454651636A4278555041794D56427855484978555042425548497738424651384346513843';
wwv_flow_imp.g_varchar2_table(634) := '49773844465138444651635644776F5642785566424438454D7A38454E54386D4E53384441513846465263564278554846516356427855484651635642785548465163564278554846513848465238455077557A5077457A507745315077457A4E7A4D33';
wwv_flow_imp.g_varchar2_table(635) := '4E5463314D7A55334E5463314E7A55334E5463314E7A55334E5463314A7A5576424155504252555846526356467A4D6642544D6641525558465263564678557A4678555846523845507751314C7730314A7A556E4E5363314C774D424478636642443845';
wwv_flow_imp.g_varchar2_table(636) := '4D7A38444D7A637A4E7A4D334D7A637A4E7A55334D7A63314E7A4D2F416A4D334D7A552F417A557642415550425255664178556641544D66416A4D664168556641544D664152556641544D584D78637A467A4D66416A4D584D7863564D7838484D786356';
wwv_flow_imp.g_varchar2_table(637) := '467A4D564D78637A507751314C77516A4A794D6E4979636A4C776F6A4C77516A4C77556A415630424C7637712F7634617973724B7973724B796D45484451594E4451636E4451344541774D454151494441776B454251594D426863474377594742675970';
wwv_flow_imp.g_varchar2_table(638) := '42675947426759464877514644414D444167494741776F6E42676347445166704251514541774D4241674943426749434177594642414D494151344343414947416751424167494241674D4341775545417751444367554741776B454351514541775143';
wwv_flow_imp.g_varchar2_table(639) := '4241594242414D434177494441674543434145464177514342414943425149484167494241676B424167494442774D434177494241674D434267494B4266337A4251634241674D434177494441674D434177514241674944416751424241514241674943';
wwv_flow_imp.g_varchar2_table(640) := '41674943415149434167514341675142415145434177494343674543416749424241454341514942416745434167454542414D4F424167454177454241674D42416749434151494241674543415149434177494241676743415149434167454541675142';
wwv_flow_imp.g_varchar2_table(641) := '4267494B4167594443674D474177554441674545426767464172494542514D474167454241514542415145424167454442514D464177514441675944415149444267514A435151454177494241514D4341514944417749424251454D4177454341514542';
wwv_flow_imp.g_varchar2_table(642) := '4151454241514545417751454350796D424155444241514241514D4341514D4341515142436745454177494441674543417745434241634A4351514541775143424149444167634541515942416745434341454241514546434167437351514543515146';
wwv_flow_imp.g_varchar2_table(643) := '436751504251554C44775946437755684267735143415146416749454177514E43515947464155424567594842514546415155424251456341517346415155464151554C4477454541514D44416745454177514543503365424151454177494341514944';
wwv_flow_imp.g_varchar2_table(644) := '42413043415149444167454341774D4C4167454941774D4641514942416745434151494441774543415149424167514442674D4E41783043417730454177304A425167464167454541775145417751494178514345514D4A425245434267554442515546';
wwv_flow_imp.g_varchar2_table(645) := '41674550416755434167454541775152424151464168774D2F70414266426A2B7441456E47526C4B474268564742684E474267434C51454342674543424149444241674A4251514541775142416749434241494241514542415155424267514443515549';
wwv_flow_imp.g_varchar2_table(646) := '43414945426745424155384241514D444241514542516B4542674543415159444241494944674D49417759444241454341674D45417751444277634443414D53436767434241494341774D49436763484151774942415145424151454241734242774D47';
wwv_flow_imp.g_varchar2_table(647) := '416759434177554442774D4341776B44416749484167494341674542415149434241494644414545416749434167494241674943416749424241494241674944424145454151514241674D434177494241674D43415149474167454342674D4441675543';
wwv_flow_imp.g_varchar2_table(648) := '4151495041774942416745434177594441774D4441774D44417745454351554941774D44415151444177514742514D43425145434177494441674D4341774D4342514944416777434177494441674D454177514442674D4B417759434367454741675545';
wwv_flow_imp.g_varchar2_table(649) := '4241514A435159454166374741514943434151454241517A41776B444267494741774D4441774D444267494441776B4344674D4941513046437755474367634542516B45426749434167494441774D4442675947425145464277386D41776F4441776344';
wwv_flow_imp.g_varchar2_table(650) := '41775144417751444177514442774D4F417977464351674541674D434577454341774D494242734742784D4844524D47427730474877304641515542425145464151554242514542424151454167494341774D4A43516747426755474541734745515547';
wwv_flow_imp.g_varchar2_table(651) := '4267557642675547426777474277554842674C2B73674543426751454267514A42414D464351494442414D4D4151514442414D4843516B4941774D4441674942426749474177494441674D444477594241774D4241775148444151424177514542416B49';
wwv_flow_imp.g_varchar2_table(652) := '42414D43416749424177494542416B45425151454177454B4167494341674943415145484167554241514544416749424167454341514542415145434167494541676B424151514242414545427755454351674541674D424177634741774D4741674944';
wwv_flow_imp.g_varchar2_table(653) := '41514D434177494A41674D4341515142424130424167414141414D4141502F5341794D433667414641417741455141414153496A455345524A7851564D784568455155574877456A416E4C5731774A6535626A392F41463546536F2B66514C712F4F6743';
wwv_flow_imp.g_varchar2_table(654) := '596F6C64586633384172344D46537442414141414141674141502F5441395143365141544143634154674279414859416567422B4149494141424D69446745564552516541544D684D6A34424E5245304C67456A42534579486745564552514F41534D68';
wwv_flow_imp.g_varchar2_table(655) := '496934424E5245305067455842794D4F4152515846686378466863574678594842673842495463324E7A596E4A69636D4C77456D4A7959314E446332507745484D7759484268555546785966415259584668635742775948497A59334E69636D4A795976';
wwv_flow_imp.g_varchar2_table(656) := '4153596E4A6A55304E7A595846544D314278557A4E5163564D7A554846544D31317A565A4E54565A4E5149364E566F304E466F312F6359434F69552B4A43512B4A6633474A54346B4A44352F417745774C4138494678554A4451454344524D6C4B514542';
wwv_flow_imp.g_varchar2_table(657) := '4179345146414D434451675543424D49444241524C796E356E68594C4677344A46674955435130424167304F4A35345442784D4341673449465159544351735146415237674942476647714141756B305754582B626A565A4E44525A4E5147534E566B30';
wwv_flow_imp.g_varchar2_table(658) := '504351394A6635754A54306B4A44306C415A496C50535263416877324C78594E4742554C45517750447859564751496346686B5945684D4C465167554442454E45424D564852676145513461475259574452634346417752444138504578635143686361';
wwv_flow_imp.g_varchar2_table(659) := '45784D4C465163544452454E45424D584641774D5141774D5151774D5151774D4141514141502F544139514336514154414363414B6741764141415449673442465245554867457A4954492B415455524E433442497755684D683442465245554467456A';
wwv_flow_imp.g_varchar2_table(660) := '49534975415455524E4434424278633342524568455166584E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C5069516B506758362B76344E4166543741756B305754582B626A565A4E44525A4E5147534E566B30';
wwv_flow_imp.g_varchar2_table(661) := '504351394A6635754A54306B4A44306C415A496C505352666A5930302F756B4246347741425141414141414453414B70414273414D67424B414749416567414141534948426763474477455246686357467859674E7A59334E6A63524E43636D4A79596E';
wwv_flow_imp.g_varchar2_table(662) := '4A6763794678595846686347427759484269496E4A69636D4A7A59334E6A6332427A496641525958466A49334E6A384246515948426763474969636D4A79596E4654496641525958466A49334E6A384246515948426763474969636D4A79596E46544966';
wwv_flow_imp.g_varchar2_table(663) := '41525958466941334E6A384246515948426763474969636D4A79596E41665239586A416649676342426951674C3163424346637649434D4841516369487A42656658745A4B786F5242675952475378633846777347524547426845614B316D3241514D44';
wwv_flow_imp.g_varchar2_table(664) := '477A52652B6C34304777634546426B73585042634C426B554241454441787330587670654E4273484242515A4C467A775843775A4641514241774D624E466342434663304777634546426B73566635564C426B5542414B704641735145526F452F695561';
wwv_flow_imp.g_varchar2_table(665) := '4642454A4642514A45524D624164734441526F52454173554978514A44516B4B43676B4F43524D544351344A43676F4A44516B5561774943446777554641774F42436B4C4367344A45784D4A4467734B4D414943446777554641774F42436B4C4367344A';
wwv_flow_imp.g_varchar2_table(666) := '45784D4A4467734B4D414943446777554641774F42504D4C4367344A45784D4A4467734B41416B4141502B66413730444941414B414267414A6741324145774158414271414877416B41414141515943427A59334E6A63584A693842466838424A775948';
wwv_flow_imp.g_varchar2_table(667) := '426763474E7A59334E684D4742773442466A6332467859324A69636D467959474668635746785958466A34424A79596E4A675547427759504151594842676347466A59334E6A632B415463324E4359424A67595846675948426834424E7A34424A793442';
wwv_flow_imp.g_varchar2_table(668) := '4253594746785958466A34424A79596E4C67454242676347427759484267634F415259334E6A63324C67454649675957467859664152597A4D6A596D4A7959764153596E4A6748304745305846796F6E4648305A4D54494D46694A4543426B5342676F42';
wwv_flow_imp.g_varchar2_table(669) := '4378515745464176437745534447466A4451344744437646444138454379556747786F4A474130474F464D452F66414B4377594C437938704351494447526B454A5330454667514944514B74447730444178675A4241385A427838614277494E2F4B5150';
wwv_flow_imp.g_varchar2_table(670) := '44674D464C77635A447751744167454E4171344A4351594B445167325667774245677875565163434466335A43773044436B4E674268494944773052446D4537417759454267496D5176377A515263774B785748547035524A456C75536763644641634C';
wwv_flow_imp.g_varchar2_table(671) := '426946445441467941673847475249454742514246426745433038424578674647696F684D416F46465174724F774D4C41516745437773755377384C44784550443051764252454643424D4F2F736742477738795A43304D4577454B4E6E302B42776B53';
wwv_flow_imp.g_varchar2_table(672) := '41526F506146774B41524D4D57326349432F367A4151594443516F454A426347474249444755674845773442456863464F526F4342526B594152677841775543424141474141442F6C514F2B417951414777417841456B415941426C414773414141456D';
wwv_flow_imp.g_varchar2_table(673) := '427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A595846686357';
wwv_flow_imp.g_varchar2_table(674) := '42785947427759484269596E4A69636D4E6A63324E7A5948466863324E775555465345524277487A624756685155494C4444633850564E5074315A5968453847426834636430395156774D5645474E6457546F3843416B39506B436D744531515A434156';
wwv_flow_imp.g_varchar2_table(675) := '467A6B346F6C3962565645794E5145454A43524252464A4E6E6A3942525151654944777766454A51536B63724C414542534435415330654D4D7A59554652516E4A7A314B556C5A564F484C2B6851476179514D69416A5931576C3173584C5A4A5369676F';
wwv_flow_imp.g_varchar2_table(676) := '437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D4149734B6B5A4B5545754C4C4338484354457A';
wwv_flow_imp.g_varchar2_table(677) := '4E5556436B44733949697562525555755843434D6A4145536F774141414141514141442F6F414F374179494142774150414230414C41412B41453841594142754148734169674359414B67417467444A414E6741375141414153596E427863684E6A636E';
wwv_flow_imp.g_varchar2_table(678) := '4267636A4A7A593346674D4742773442466A6332467859324A69636D46795947466863574678592B415363754153636D425159484267634742775948426859794E7A59334E6934424D7949484967634F415234424E7A5958466A59304A79594842676347';
wwv_flow_imp.g_varchar2_table(679) := '4477454742775965415463324E7A59304A67556D42685958466863574D6A596E4A69636D42535948426863654154596E4A6A63324A67556D42686357427759654154632B415363754151556D426863574678592B4153636D4E7934424253594842676347';
wwv_flow_imp.g_varchar2_table(680) := '427759654154632B415463754151556942685958466863574E69596E4A69636D425134424277594842673842446745574E7A34424E7A34424A6755694268595848674558466A596D4A79596E4A675547427759484267634742775948446745574E7A3442';
wwv_flow_imp.g_varchar2_table(681) := '4E7A597541514C4C523544585567454B4679734D4744446D534439386648784B4C777742457778655A67774F42517778796777504177744D4C51635A44775159535334452F66554C4367594C434156424951515247416370555159424466384543684948';
wwv_flow_imp.g_varchar2_table(682) := '44516B4A46416C4F5277775343304C714451344A45416F3947515552475159705541674F4158384D4467494B4E426B4847524145476B51452F634D5A425173624268675341686F51415134433651384E4177457742424159427830624241494F2F4B5150';
wwv_flow_imp.g_varchar2_table(683) := '44674D434D51635A447755764167454E41757750427755424454494744786B4948535947415133397141734D4167672F56417752415174504E7759426E77777243784D5A4478345244415550444339624A77674244663439437730444369746A4E41774F';
wwv_flow_imp.g_varchar2_table(684) := '4251786B5477594347416B4A42516F4F4342346D48796F4C4168454E4E6D55704277494E41614930614A7A395249676F53704C634C567061415677434541595A4551515A466745544751514D557745544741553457776F42457777795743414343674548';
wwv_flow_imp.g_varchar2_table(685) := '42517349424435514442494C585541484577344241675156455167444268384545526B47487963434341554D427A417744424D424330417542784D504F77455346775931564173544446314241366B434B315A4E43774D52444642554367347441526F4F';
wwv_flow_imp.g_varchar2_table(686) := '5A56344D4567454B4E6E6B2B43416F5141526F4F61316F4B41684D4D57325949437A674244516F5250304D4D46414D4C4A6C637443513667455259475352304445686747486B494754514D564177634541774D43424267554151455A4741635644796354';
wwv_flow_imp.g_varchar2_table(687) := '466755694C776F4246426745465549444177454641776B4C4178515044416F4747524944437A456A42784D4F414141414142414141502B674137734449674144414167414667416C414463415341425A4147634164414344414A45416F514376414D4941';
wwv_flow_imp.g_varchar2_table(688) := '3051446D414141424267636841785958495459544267634F415259334E6863574E69596E4A68636D42685958466863575067456E4C67456E4A6755474277594842676347427759574D6A63324E7A597541544D6942794948446745654154633246785932';
wwv_flow_imp.g_varchar2_table(689) := '4E43636D427759484267384242676347486745334E6A63324E4359464A67595746785958466A49324A79596E4A67556D42775958486745324A7959334E6959464A67595846676347486745335067456E4C6745464A675958466863575067456E4A6A6375';
wwv_flow_imp.g_varchar2_table(690) := '4151556D427759484267634748674533506745334C6745464967595746785958466A596D4A79596E4A67554F415163474277595041513442466A632B4154632B415359464967595746783442467859324A69636D4A795946426763474277594842676347';
wwv_flow_imp.g_varchar2_table(691) := '42773442466A632B415463324C67454239474267415944415A44502B306A4E6B5369384D41524D4D586D594D4467554D4D636F4D44774D4C544330484751384547456B754250333143776F474377674651534545455267484B5645474151332F42416F53';
wwv_flow_imp.g_varchar2_table(692) := '4277304A4352514A546B634D456774433667304F4352414B50526B4645526B474B5641494467462F44413443436A515A42786B5142427045425033444751554C47775959456749614541454F41756B5044514D424D41515147416364477751434476796B';
wwv_flow_imp.g_varchar2_table(693) := '44773444416A4548475138464C77494244514C7344776346415130794267385A4342306D4267454E2F61674C444149495031514D4551454C547A6347415A384D4B777354475138654551774644777776577963494151332B5051734E41776F72597A514D';
wwv_flow_imp.g_varchar2_table(694) := '4467554D5A4538474168674A4351554B446767654A6838714377495244545A6C4B51634344514979724B30424A7252615767485841684147475245454752594245786B4544464D42457867464F46734B41524D4D4D6C676741676F424277554C4341512B';
wwv_flow_imp.g_varchar2_table(695) := '554177534331314142784D4F4151494546524549417759664242455A4268386E41676746444163774D417754415174414C676354447A7342456863474E56514C4577786451514F7041697457545173444551785156416F4F4C514561446D566544424942';
wwv_flow_imp.g_varchar2_table(696) := '436A5A355067674B45414561446D7461436749544446746D434173344151304B455439444442514443795A584C516B4F6F424557426B6B644178495942683543426B304446514D4842414D444167515946414542475267484651386E457859464969384B';
wwv_flow_imp.g_varchar2_table(697) := '415251594242564341774D4242514D4A43774D554477774B42686B534177737849776354446741414141554141502B56413734444A414162414445415351426741476B414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E';
wwv_flow_imp.g_varchar2_table(698) := '4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D427759484267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A595842676358';
wwv_flow_imp.g_varchar2_table(699) := '4954592F415359423832786C59554643437777335044315454376457574952504267596548486450554663444652426A58566B365041674A505435417072524E55475167465263354F4B4A66573156524D6A55424243516B51555253545A342F51555545';
wwv_flow_imp.g_varchar2_table(700) := '486941384D487843554570484B7977424155672B514574486A444D32464255554A796339536C5751523149424368637245456344496749324E5670646246793253556F6F4B4173634858656B575674545534596F4B5155434D514D784D464E5759316973';
wwv_flow_imp.g_varchar2_table(701) := '51454D37454373736A374E5657554A45546973444D433950556C7454554534324F4241514A5441796A4B4A4A544449724D4441434C437047536C424C6979777642776B784D7A56465170413750534972563267302F5553494D5451414141414B4141442F';
wwv_flow_imp.g_varchar2_table(702) := '6E774F39417941414241414F4142514149674179414567415741426D414867416A41414141525156495245464D6A4D47427759484267636D4E7851564954555845775948446745574E7A5958466A596D4A7959584A67595746785958466863575067456E';
wwv_flow_imp.g_varchar2_table(703) := '4A69636D425159484267384242676347427759574E6A63324E7A34424E7A59304A67456D4268635742676347486745335067456E4C6745464A675958466863575067456E4A69637541514547427759484267634742773442466A63324E7A597541515569';
wwv_flow_imp.g_varchar2_table(704) := '4268595846683842466A4D794E69596E4A6938424A69636D415363426D763742636E49504942674E46524241342F37496E4152514C777342456778685977304F42677772785177504241736C494273614352674E426A6854425033774367734743777376';
wwv_flow_imp.g_varchar2_table(705) := '4B516B4341786B5A4243557442425945434130437251384E41774D594751515047516366476763434466796B4477344442533848475138454C51494244514B7543516B47436730494E6C594D4152494D626C5548416733393251734E4177704459415953';
wwv_flow_imp.g_varchar2_table(706) := '4341384E455135684F774D47424159422B7079634154677843527757435138434E41566458627039416641434477595A45675159464145554741514C54774554474155614B6945774367555643327337417773424341514C4379354C4477735045513850';
wwv_flow_imp.g_varchar2_table(707) := '52433846455155494577372B79414562447A4A6B4C51775441516F3266543448435249424767396F58416F42457778625A77674C2F724D4242674D4A4367516B4677595945674D5A53416354446745534677553547674946475267424744454442514945';
wwv_flow_imp.g_varchar2_table(708) := '414141424141414141414E5441684D414C674141457A59334E6A6332467859584668635746785958466A6332507745324E7A593346515948426763474A79596E4A69636D4A7934424267634742775948426765574768736A4C5349744A69595947784167';
wwv_flow_imp.g_varchar2_table(709) := '4F7945644A4345594652384E46777363476951724A69736F49787779495249644E6A775647786B504778414941556F2B4A7A51624641634747413856446873304652454B435273594968496548615533496930554541674847524D754877345947776355';
wwv_flow_imp.g_varchar2_table(710) := '474351584C68774F414141484141442F3077505541756B414577416E4145304164514374414C5941767741414579494F41525552464234424D794579506745314554517541534D46495449654152555246413442497945694C6745314554512B41526355';
wwv_flow_imp.g_varchar2_table(711) := '465159484A7763584267636A46544D57467A556A4E544D334E6A38424A7A63584E7A592F4154557A46544D75415363314278554742796348467759484978557A46686348467A63574678557A4E545933467A636E4E6A38424E51636D4A7A636E4279596E';
wwv_flow_imp.g_varchar2_table(712) := '4E51637A465263574877453346776358466838424E78556A42775950415263484A77634744774556497A556E4A693842427963334A79597641534D314D7A63325077456E4E7863334E6A384246794947464259794E6A516D427A4957464159694A6A5132';
wwv_flow_imp.g_varchar2_table(713) := '317A565A4E54565A4E5149364E566F304E466F312F6359434F69552B4A43512B4A6633474A54346B4A44354A4451345A4C68674941794D6B4177346648774944437755564478594944785549467A734547676345446734594C786B494179516B42516361';
wwv_flow_imp.g_varchar2_table(714) := '4C786F4D4430494E44786B764767674549694D444342677647416F534C42594A4642414946524156425173454168346541674D4D425263514667675146416B5743524D52434259514677594B4251496648774946436755574542594845524D4A43785164';
wwv_flow_imp.g_varchar2_table(715) := '48536B644852554D45424158454241433654525A4E6635754E566B304E466B31415A4931575451384A44306C2F6D346C5053516B505355426B6955394A4449524567514947533859456770434452593546676B5345676756454259464377554248783445';
wwv_flow_imp.g_varchar2_table(716) := '4377496A5143494543426B764751304F5167384D475338614277556B4A514D494753385A446730425167454B4568677547415946496855664151514C425255504667635146416B4246776B55454163574542594643675543494341434177774546684157';
wwv_flow_imp.g_varchar2_table(717) := '434241544352594A464241494652415742517744416A49644B4234654B42305745426351454263514141494141502F5441395143365141544143634141424D69446745564552516541544D684D6A34424E5245304C67456A42534579486745564552514F';
wwv_flow_imp.g_varchar2_table(718) := '41534D68496934424E524530506748584E566B314E566B31416A6F31576A5130576A5839786749364A54346B4A44346C2F63596C5069516B50674C704E466B312F6D343157545130575455426B6A565A4E44776B5053582B626955394A4351394A514753';
wwv_flow_imp.g_varchar2_table(719) := '4A54306B414141444141414141414E65416B38414967416D4143774141414547427734424477454742775957467755575067456E4E525958466A34424A7845304A694948425477424A793442427851564A7955554653596E4E67483243516F4646675647';
wwv_flow_imp.g_varchar2_table(720) := '6A45594E426738424E516F5844674B446D416F574467495447416A2B374145434569666C416978716533734354674547417841444C31347643694D487A77594746417566576D51474268514C4161494D4477693648584563437735586D7071616D707161';
wwv_flow_imp.g_varchar2_table(721) := '535646524141414141416B4141502B664137304449414148414138414851417441454D415577426841484D41687741414153596E427863684E6A636E4267636A4A7A593346674D4742773442466A6332467859324A69636D467959474668635746785958';
wwv_flow_imp.g_varchar2_table(722) := '466A34424A79596E4A675547427759504151594842676347466A59334E6A632B415463324E4359424A67595846675948426834424E7A34424A7934424253594746785958466A34424A79596E4C67454242676347427759484267634F415259334E6A6332';
wwv_flow_imp.g_varchar2_table(723) := '4C67454649675957467859664152597A4D6A596D4A7959764153596E4A674C4C523544585567454B4679734D4744446D53443938664868514C777342456778685977304F42677772785177504241736C494273614352674E426A68544250337743677347';
wwv_flow_imp.g_varchar2_table(724) := '437773764B516B4341786B5A4243557442425945434130437251384E41774D594751515047516366476763434466796B4477344442533848475138454C51494244514B7543516B47436730494E6C594D4152494D626C5548416733393251734E41777044';
wwv_flow_imp.g_varchar2_table(725) := '594159534341384E455135684F774D47424159426F6A526F6E5031456943684B6B747774576C6F425767495042686B5342426755415251594241745041524D5942526F714954414B4252554C617A7344437745494241734C4C6B73504377385244773945';
wwv_flow_imp.g_varchar2_table(726) := '4C7755524251675444763749415273504D6D517444424D42436A5A395067634A4567456144326863436745544446746E4341762B7377454741776B4B424351584268675341786C4942784D4F4152495842546B614167555A474145594D514D4641675141';
wwv_flow_imp.g_varchar2_table(727) := '4141554141502B56413734444A4141624144454153514267414751414141456D427759484267634746686357467834424E7A34434E7A596E4C67456E4A69636A4A67633246785958466863574267634F4153596E4C6749334E6A632B4152636D42775948';
wwv_flow_imp.g_varchar2_table(728) := '4267634746785958466863574E6A632B4169636D4A793442427A59584668635742785947427759484269596E4A69636D4E6A63324E7A59584267636841664E735A5746425167734D4E7A773955302B33566C694554775947486878335431425841785551';
wwv_flow_imp.g_varchar2_table(729) := '5931315A4F6A77494354302B514B61305456426B494255584F54696958317456555449314151516B4A454645556B3265503046464242346750444238516C424B5279737341514649506B424C5234777A4E6851564643636E505570565947414267414D69';
wwv_flow_imp.g_varchar2_table(730) := '416A5931576C3173584C5A4A5369676F437877646436525A57314E546869677042514978417A457755315A6A574B7841517A73514B7979507331565A516B524F4B774D774C30395357314E51546A59344542416C4D444B4D6F6B6C4D4D6973774D414973';
wwv_flow_imp.g_varchar2_table(731) := '4B6B5A4B5545754C4C4338484354457A4E5556436B4473394969746A724B30414142514141502B6A413767444967414541416741444141514142514147414262414C4D424351464D416145422F674A4A416F73437A774D5341326B447467514342457741';
wwv_flow_imp.g_varchar2_table(732) := '414145564553455242544D5249784D564D7A554846544D314278557A4E5163564D7A55444D534D484977636A46534D4849773848465238454D7A637A4E7A4D334D7A637A4E7A4D584D78637A467A4D584D78637A507755314C77556A4A794D314979636A';
wwv_flow_imp.g_varchar2_table(733) := '4A78636A44775566475438454E533844497963314A7A556E49793842497938424E53636A4A7A557641534D764154556E4E53636A4E53636A4A794D764154557641534D6E4E53636A4C774546497738434651636A44774556447749564278554846513842';
wwv_flow_imp.g_varchar2_table(734) := '4977384246513843465138424977384249773842465163564477456A447749564877557A50786B314C7751684D534D5649773844465238454D7A637A4E7A4D584D78637A467A4D584D78637A4877597A507755314C77496A4C776B6A4A794D6E4979636A';
wwv_flow_imp.g_varchar2_table(735) := '4E51636A4477496A4477455642794D5041534D484651636A42794D484977635644774D6A4651384246513843497738424877557A5078307A50774D764177555042523857465238454D7A38454E5363314C7767314A7A557642434D6E497963314C77456A';
wwv_flow_imp.g_varchar2_table(736) := '4A7A556E4E5338424E534D764154556E497963314C7749314C774D464977384646534D564278554846534D564278555846544D56467855584652635648776B7A507751314C7749314A7A556E4E5363314A7A556E4E5463314E7A55334E5463314E7A5576';
wwv_flow_imp.g_varchar2_table(737) := '4241556A44774D564278635642785548465163564278555043425566417A4D2F426A55334E5438484E5463314D7A55334E5463314A7A55764177556A44774D5646785558465263564678556642785558465238434D785566417A4D2F42445576437A556E';
wwv_flow_imp.g_varchar2_table(738) := '4E5363314A7A556E4E53384542534D5042525548465138504652384650774931507745314E7A4D334E5438434D7A384B4E546376424155504252384346526356467A4D584D7838434D7838424D78555846526356467A4D6641544D584D78635646785566';
wwv_flow_imp.g_varchar2_table(739) := '4152556641685566416A4D2F425455764841556A4477676A42794D484977636A42794D4849773845465238464D7A637A4E7A4D334D7A637A5077737A4E7A4D2F4154552F415455334E5438454E53384542513846465238464D7838424652637A467A4D66';
wwv_flow_imp.g_varchar2_table(740) := '4152556641544D58465238454D78637A4877597A507755314C78596849773858465238474D7A38494D7A38454E54637A4E7A4D334E5438424E5438424D7A38454E533845415630424C7637712F7634617973724B7973724B796D554C4267734644415546';
wwv_flow_imp.g_varchar2_table(741) := '426959474367674541674D424151494742416B454B77554A4251554642516F464867554B4251554642516F4547416B4642414D454241454242414D45427959464267554C426773473941554542514D45424149434341494D4277674842414D4541775144';
wwv_flow_imp.g_varchar2_table(742) := '427759484477494A41674D5242414D4543516B4542414D45415149444167454341774942416849424351514741514D45417745444341514441514D424177454942415145415151494151514B2F66454642416746424145454241514D4241514543414D42';
wwv_flow_imp.g_varchar2_table(743) := '4177514442414D45435145504167454341774D464167454541774D4241674D444341514A4251634642524147416759434477634742774D454177514442416349424151484167454341674D45434145454567304B42516347416749444341674541516745';
wwv_flow_imp.g_varchar2_table(744) := '4A675149417751454241634543414D614177674842774D4A4251514542414D45415151444277454442515145424151454351516D42416B4642415146446130454341594841514D4941774556417745444177454A4151774243516B444177494241674D44';
wwv_flow_imp.g_varchar2_table(745) := '434151424241494341674D444341514642416B4443414D4342414D434177494441674D4341774D4441674D4441774D4441774D4442674D6A41674D454241494342515149415951464341514441774D4242674D4441674D434177494441674D4846674545';
wwv_flow_imp.g_varchar2_table(746) := '4151514242674D4341675145417751464351514542414D45415149434167454341514942416749434151454243414542415149434241454342774D43415149444167454342674D4A41774D44425033444251514941774D43416745434151454241514542';
wwv_flow_imp.g_varchar2_table(747) := '416745494167454241514D444241514542516B4541774D45415149464177494241514542415145434151454341774D4A41753446424167474167454241514542416767434151494342414557415145454177774643515147425151444367494941514942';
wwv_flow_imp.g_varchar2_table(748) := '41674943427745424151454242414D454350796E42516749424149424151454342674943416745454151594343674D4541514D474241554A4241514541775143415249424167454341514943416763434151454241514948417755433841514642415144';
wwv_flow_imp.g_varchar2_table(749) := '4241494342774944425149454151494444416F444241494541514545417751454351674642774D5041674547425167424151454741514942416745434167494A41514943417751492F61304543415144416749434251594D4267454D4151594841774544';
wwv_flow_imp.g_varchar2_table(750) := '4177454842774D42427763424177454442416745424177454241514543515145424155434151454542414D564177514B42786B444367494441774D4441774D444167594441674D4341774949415A77464241514242776F63437763534241734542775145';
wwv_flow_imp.g_varchar2_table(751) := '427751494242414942414D434167454542414D45425177464451514642415549425359454351514542415145424145454177454441514D4542416745435151434167454342674D4542663545424155454267494341514944417755454151514E4351454E';
wwv_flow_imp.g_varchar2_table(752) := '4151514642515142424155464367555A41515142464159464251554C43676B46424151444241454341774D4542784D4642415546424155464243556543415145435177444451495342515146417745554241514A43425973425155454251554642415562';
wwv_flow_imp.g_varchar2_table(753) := '424159454151454341774D454241514A41775946437755464251595541523446436755464241454541515146484130454151514641774942416749444241674348417A2B6B414638475036304153635A47556F5947465559474530594741497641514542';
wwv_flow_imp.g_varchar2_table(754) := '4151634341675144424151454351514642674D434351494241514542415145434251454341774D494241554543514D444177634241514542557745434167514843516B4B41516B484267634442414D454177514843416355424130454243414441774943';
wwv_flow_imp.g_varchar2_table(755) := '416749444177674A4251594642515142424145454252774E42414549424145454241514941514D42417745444241674441514D4541774547424163494151514541514D454177454444414D42417745444151674542415142424151454151514E46775546';
wwv_flow_imp.g_varchar2_table(756) := '4241454541516B464367554D4241554542414D4541514946427777654341514A42425148434163454177514442414D48426751444277554542416B4542414D45415149434251774643515144426749424151454241514943427749434177494341674543';
wwv_flow_imp.g_varchar2_table(757) := '41774D4942516B494177554341514942416745434167494A4167454241536343417755434241454344774D434151494A44416B424351514441774544417745444377634843516B45417751454151454541777744424159444177494441774D4441774D43';
wwv_flow_imp.g_varchar2_table(758) := '41774D434177494441674D434177514446674D4443416B4A42774D454F77454341774D454451554C41674D4441774D444177494441776F6A417763444277514F43774D48417767444177494241514D434241674A42414945435151454241514542514D42';
wwv_flow_imp.g_varchar2_table(759) := '41774544424145444541514441514D494177454B41514D4441514D4441514D44415159454351454441674D447151454542414D454341514543515545435130454777554E4351514543515142424349454251454542414D444167454341674D4543416B46';
wwv_flow_imp.g_varchar2_table(760) := '4242494543775148424151484241674548675149424163454241634542416B45424151444243304242416745424151454867554B4251554642516B464A77554542516B4B424449454251514942415943416759494367555A41515142464159464251554C';
wwv_flow_imp.g_varchar2_table(761) := '426959464267554C426773474667594A43414D4442424143426767494351595242515946426773464951594C4251554B426738424241455A42516F42424159434151454441675149435167424B5151464251514642516B464967554A4251554642516F46';
wwv_flow_imp.g_varchar2_table(762) := '46775545427749434F51454341774D494277514842426F44437773484267514442785150417763424341554542516744417749434167494841514D5641514D4C415163514241514D42415145424151454351516D4251554942415144424B414242414D44';
wwv_flow_imp.g_varchar2_table(763) := '42416B4A43515942444145474441594641774D43415151424241454342515143416745424151514241514547415145424167454241674D48425151464241674441776B434151594445414D474177494441674D43417749444267494441774D444177644B';
wwv_flow_imp.g_varchar2_table(764) := '415149424177594D41774D46417749424151454541774D454351554543414D444167454241514543435149434167454341514942415145434167494241514545415145424251514442515146434167444167456E415145444267514A4251514542414946';
wwv_flow_imp.g_varchar2_table(765) := '4177514A4151594A4177494241674D434151494442414D4B416767424167454341674D4241674D44434155454351514441774D45416745434151494241674551454159434177554A41776F4241674943447749444251594D464145434151494241674543';
wwv_flow_imp.g_varchar2_table(766) := '42674947435151464241514541774D434151454241674943415149424341774442414D4341514944416745434567454A42414D464241514542516B4541774D454141414141414D414141414141376B436A67414441416341437741414578456845516352';
wwv_flow_imp.g_varchar2_table(767) := '4952456A4D78456A4C774F4B4D6631696A463565416F37396A774A784D50337241685839367741674141442F37674F73417338414241414A4141344145774159414345414C514132414545415467425641466F415877426B41476B416267427A41486741';
wwv_flow_imp.g_varchar2_table(768) := '66514349414934416C774368414B594171774377414C55417567432F414D51417951444F414141424D6A4D31497863794D7A556A467A497A4E534D584D6A4D31497863794D7A556A467A497A4E6863334A69734249534948467A59794E69636D4E6A556D';
wwv_flow_imp.g_varchar2_table(769) := '425259584E6A63324E79596E4251594846686357467A59334A79594644674558466759574D6A4D794E7A516E425159564D7959334A7755794D7A556A4254497A4E534D464D6A4D31497755794D7A556A4254497A4E534D464D6A4D31497755794D7A556A';
wwv_flow_imp.g_varchar2_table(770) := '4254497A4E534D4642676357467859584E6A636E4A675557467A636D4A77554742785966415459334A775557467A63324E79596E427759584D6A4D31497863794D7A556A467A497A4E534D584D6A4D31497863794D7A556A467A497A4E534D484E445568';
wwv_flow_imp.g_varchar2_table(771) := '45524D794D7845684E7851564D7A554242526B594D57495A474446684752677859686B594D57495A47444668424163594377594C465254393751304D43514D4F42674D42416745435968494E42516F52425251592F544D594577554C4541635144676F4B';
wwv_flow_imp.g_varchar2_table(772) := '4176454C417751434151494B445249484376796A427A4542426934444E526B594D667A4447526778417A305A4744483877786B594D514D39475267782F4D4D5A4744454450526B594D667A4447526778417A73464351594C45516750425241572F4C3847';
wwv_flow_imp.g_varchar2_table(773) := '4553674C42414C634552454643414D62467837394D42735A4251554345784148446D4D5A474446684752677859686B594D57495947444265475267785A526B594D54582B72682B4B697637734A6373436E5445784D5445784D5445784D544542416A4143';
wwv_flow_imp.g_varchar2_table(774) := '417A4142424167454651514850516B5142416B4D4278634E4177385742416B4E4242494845424A5741516F4C416738474152346143426764457855506C5445314D5934784E6A474F4D5455786A7A45314D566B5744774D4843774D5A47774D464452775A';
wwv_flow_imp.g_varchar2_table(775) := '477849545151774644426B4A42784D6E4B6849484568514A4267774A46536B784D5445784D5445784D5445784D534B73712F367041546A2B36366358474338414141734141502F4F41376B433867414641416B4144514152414255414751416641434D41';
wwv_flow_imp.g_varchar2_table(776) := '4A77417241433841414263314D78557A46544D314D78557A4E544D564D7A557A46544D314D78557A4E544D564D7A557A4E544D564A54557A465345314D78556C455345524A78456845533478454446684D574978595446694D5745774454483864544544';
wwv_flow_imp.g_varchar2_table(777) := '4B54483864674F4B4D667A574D6C6B6F4D5445784D5445784D5445784D5445784B466D4B5846786358497343442F33784D41477A2F6B30414141514141502B6341384D444941414441416341446741564141414245544D524D78457A45514548467A557A';
wwv_flow_imp.g_varchar2_table(778) := '4E534D6C465163564D7855334157346D7779622B554B536B58563043553135656F774D672F487744685078384134542B34614F6A62326C756241467162364D41415141412F2B59446D414D41414263414141454642685166415259484151596641525933';
wwv_flow_imp.g_varchar2_table(779) := '41545966415259794E784D324A674F562F6D4D434157414341763470416749744177514231775144575145444161634241674C2F6F67454441563844412F346F41774D7241774D4231674D4457674543415A5542416741434141414141414F35416D5941';
wwv_flow_imp.g_varchar2_table(780) := '41774148414141544553455241524568455338446976796C41796F435A7633774168442B4851477A2F6B304141416B4141502B6E413749444867414441416341437741524142554147514166414355414B5141414152557A4E5155564D7A557A46544D31';
wwv_flow_imp.g_varchar2_table(781) := '4678557A46544D314252557A4E5155564D7A554846534D564D7A554646544D31497A555846544D314153396E2F7148616F64754365796A39665763423943676F64352F396E7039333446494448747261396D646E5A3263654B485764614E72616E30314E';
wwv_flow_imp.g_varchar2_table(782) := '766E516F6E4147644B4856314B436741437741412F38344475514C79414155414351414E414245414651415A414238414977416E414373414C7741414578557A4E544D314D78557A4E544D564D7A557A46544D314D78557A4E544D564D7A557A46544D56';
wwv_flow_imp.g_varchar2_table(783) := '4D7A554646544D314952557A4E51555249524548455345524C6A45514D574578596A46684D5749785954414E4D6678314D514D704D66783241346F782F4E5943386C6B704D4441774D4441774D4441774D4441774B566D4A584678635849763938414951';
wwv_flow_imp.g_varchar2_table(784) := '4D50354E41624D41444141412F2F6F4475514C434141514147414163414341414A41416F414377414D414130414467415041424141414154465245684551556846534D564D78556A46544D564954557A4E534D314D7A556A4D78557A4E544D564D7A557A';
wwv_flow_imp.g_varchar2_table(785) := '46544D314D78557A4E544D564D7A554646544D314D78557A4E544D564D7A557A46544D314D78557A4E5338446976796C41796F4D4441774D2F4E595245524552516D4978595446694D57457859763155596A46684D5749785954466941734C592F684143';
wwv_flow_imp.g_varchar2_table(786) := '794379734D62597871616B78746A45784D5445784D5445784D544578357A45784D5445784D5445784D54454141414141427741412F2F6F4475514C43414151414541415541426741484141674143514141424D5A41534552425345524978557A45534552';
wwv_flow_imp.g_varchar2_table(787) := '4D7A556A4D78557A4E544D564D7A557A46544D314D78557A4E544D564D7A55764134723870514D7144417A3831684552516D4978595446694D57457859674C432F72542B68414C494C5037674D50376A415230774D4441774D4441774D4441774D414141';
wwv_flow_imp.g_varchar2_table(788) := '414141464141442F30674D6A41756F414251414C41413441466741644141414249694D524952456E46544D524952454646794D6E4851456A46544D564E796358427A556A4E544D4363746258416C376C7550333841586C3966654E71616F313558467871';
wwv_flow_imp.g_varchar2_table(789) := '61674C712F4F6743596F6D362F667743766779426242684655467945566C5A5751696741424141412F39494449774C71414155414377414F414255414141456949784568455363564D78456845515558497963564978557A4654634363746258416C376C';
wwv_flow_imp.g_varchar2_table(790) := '7550333841586C3966654E71616F304336767A6F416D4B4A757633384172344D6757786455467945414141434141442F31674E79417538416277446B414141424967594842676347487745564A6938424D53636D4A79596E4A69636D4278554742775958';
wwv_flow_imp.g_varchar2_table(791) := '46686357467859664153636D4A79596E4A676347427A6B4242686357467859584668635746785966415345334E6A38424E6A38424E6A63324E7A596E4C67456E4A67594842676347447745314E4455324A79596E4C674569426763474277595041693842';
wwv_flow_imp.g_varchar2_table(792) := '4A69636D4A793442427A4D484D6A457A4D6859584867456641525966415438434E6A63324E7A34424F774579466838424668635742785566415459334E6A63324E7A59584F51456541526357427759484267384242676347447745684A69636D4A79596E';
wwv_flow_imp.g_varchar2_table(793) := '4A69636D4A79592B41686357467859664154636E4A69636D4A79596E4A6A632B4154633246686357467859584D525966415438424E6938424A6A63324E7A34424166494F4741634C41774D424151594941516B4D4277734C45524D5848526B4841776346';
wwv_flow_imp.g_varchar2_table(794) := '45417746434130474452414A4A79515745786351485155434751346B4C5263634F5363514251464D4177514B444251624378674B4541634B42675159455134634368495042676B47415149454341595647525948445163474277594A42674D464277634D';
wwv_flow_imp.g_varchar2_table(795) := '4278634E41514942415155464241634E42774947434167684767594842516348424155464167514341674547416749424153414B456841494467304B44416B494167514A4267304946424D594751554A4350376644694536487867754977775441674547';
wwv_flow_imp.g_varchar2_table(796) := '4552595048794963485263644452414F4267305042415944415155474452554D4377774944776F55455341424167454241674D44427751474175344F444251684844386F517730584178636744786B5147516B4C4377454C48684D6A466A456D45787379';
wwv_flow_imp.g_varchar2_table(797) := '467777504343494F4341454344687365474341524A533463495667374651634D44533433586B63634F78777448797761447863444177734C45534D4B4742424C45535532467949524377384C43524562466A456B4C7A4D675168346A4541774F41534545';
wwv_flow_imp.g_varchar2_table(798) := '4267773552786B344F4377426C534D784642634A4251494241774D4C48426C414A364148465338714568344E4367454242776B544978676D466A4D7A504734584A7955534E466B6C4853346C4478674F434177514151554E4868636747773832507A4957';
wwv_flow_imp.g_varchar2_table(799) := '4B5330534767384842774D47436849514868496F476A4172426A49374B68354748426B4F4267514141414141434141412F39734462514C674142514147414171414334414D67424D414745415A51414141534947427759484642594846544D314A6A632B';
wwv_flow_imp.g_varchar2_table(800) := '4152637A4E534D6D42544D31497863324678594846544D304E54516E4C67496E4A67636A41544D314977557A4E534D4646425958466863574E7A59584E6863574D7A59334E53496A4269637541546331497755554467456A426973424654497A466A3443';
wwv_flow_imp.g_varchar2_table(801) := '4E7A59314E44556A42544D31497745434B306F4C424149424154494241675132494E684B5A41454B4C792B4C4F787766424449424169513548776B54436632304D6A4943766A49792F554974497851624543455A4441514C43515146416841664E787366';
wwv_flow_imp.g_varchar2_table(802) := '4A774579417234574A68596A52794D554B5430394E69494241544C2B6C693475417438354B784958446A634F526A42514B434974416A45424D6A457842423065514A67624F456B6C49446B6B415149422F6B6378537A48554A3063524367494341514542';
wwv_flow_imp.g_varchar2_table(803) := '415145424151517441514D484E53465857526371477745784151556C4F53414F4852554C7A54454141414141425141412F3667446A774D554141674144414151414251414741414141526B424954556A45544D31415163584E773842467A635041526333';
wwv_flow_imp.g_varchar2_table(804) := '447745584E774A714153587136763531505434397544302B50626739506A3234505434394178542B5376354B50414C3050503758506A302B506A3439506A342B5054342B5054342B414141414141514141502F77413677437A514154414363414E774248';
wwv_flow_imp.g_varchar2_table(805) := '4141415449673442465245554867457A4954492B415455524E433442497755684D683442465245554467456A49534975415455524E4434424679494746524555466A4D684D6A59314554516D497755684D68595645525147497945694A6A55524E446253';
wwv_flow_imp.g_varchar2_table(806) := '4B55516F4B455170416B556F5253676F52536A3975774A46487A5166487A51662F6273664E5238664E54776D4E7A636D4167736D4E6A596D2F6655434378676949686A3939526B6949674C4D4B4551702F6B346F5253676F5253674273696C454B434966';
wwv_flow_imp.g_varchar2_table(807) := '4E522F2B546838314878383148774779487A55664D54596D2F6F496D4E6A596D4158346D4E69496947503643474349694741462B4743494141414141416741412F37384469774C3341424D41484141414151344448674D33506749334279632F41533442';
wwv_flow_imp.g_varchar2_table(808) := '435145474867453341533442417149735544736442696844564330775654734C6E6F493670694A592F752F2B6D774D664D5263425852387641764D444B455657576C453748514D444C3030774E30754D4F6941672F70332B6B78597848774D425A424933';
wwv_flow_imp.g_varchar2_table(809) := '41414141415141412F2B494469414C7841424D4141414547427759484668384242775948466838424E6A3842467A593341346852554C526246436369763670554277344C57624B7957444661417645704B466F7245696369763670564277344C57724B7A';
wwv_flow_imp.g_varchar2_table(810) := '574743744141494141502F6441346F4338774152414255414141454742775948466838424477492F417863324E77455041546344696C4651744673574B78764B7A796A334169444A574446612F6967626F426F4338796B6F576973554C42764D4976636F';
wwv_flow_imp.g_varchar2_table(811) := '4438584B574743742F6E4B68477145414141494141502F6941346F433851414741416F41414145464677455841526346465345314134722B5556762B5253414276466E397A414671417648575776354249414841575A34724B77414141414153414E3441';
wwv_flow_imp.g_varchar2_table(812) := '415141414141414141414156414141414151414141414141415141454142554141514141414141414167414841426B41415141414141414141774145414341414151414141414141424141454143514141514141414141414251414C4143674141514141';
wwv_flow_imp.g_varchar2_table(813) := '414141414267414541444D4141514141414141414367417241446341415141414141414143774154414749414177414242416B4141414171414855414177414242416B4141514149414A38414177414242416B414167414F414B63414177414242416B41';
wwv_flow_imp.g_varchar2_table(814) := '41774149414C55414177414242416B4142414149414C30414177414242416B4142514157414D55414177414242416B4142674149414E73414177414242416B4143674257414F4D414177414242416B414377416D41546C6A59573131626D526849464E6C';
wwv_flow_imp.g_varchar2_table(815) := '636E5A705932567A49456474596B686963473175556D566E64577868636D4A776257356963473175566D567963326C76626941784C6A426963473175523256755A584A686447566B49474A3549484E325A7A4A30644759675A6E4A766253424762323530';
wwv_flow_imp.g_varchar2_table(816) := '5A57787362794277636D39715A574E304C6D6830644841364C79396D623235305A5778736279356A62323041597742684147304164514275414751415951416741464D415A514279414859416151426A4147554163774167414563416251426941456741';
wwv_flow_imp.g_varchar2_table(817) := '596742774147304162674253414755415A7742314147774159514279414749416341427441473441596742774147304162674257414755416367427A41476B4162774275414341414D51417541444141596742774147304162674248414755416267426C';
wwv_flow_imp.g_varchar2_table(818) := '4148494159514230414755415A414167414749416551416741484D416467426E4144494164414230414759414941426D41484941627742744143414152674276414734416441426C41477741624142764143414163414279414738416167426C41474D41';
wwv_flow_imp.g_varchar2_table(819) := '644141754147674164414230414841414F674176414338415A674276414734416441426C41477741624142764143344159774276414730414141414141674141414141414141414B41414141414141414141414141414141414141414141414141414141';
wwv_flow_imp.g_varchar2_table(820) := '4141427341514942417745454151554242674548415167424351454B415173424441454E415134424477455141524542456745544152514246514557415263424741455A41526F42477745634152304248674566415341424951456941534D424A41456C';
wwv_flow_imp.g_varchar2_table(821) := '415359424A77456F41536B424B674572415377424C514575415338424D414578415449424D774530415455424E674533415467424F5145364154734250414539415434425077464141554542516746444155514252514647415563425341464A41556F42';
wwv_flow_imp.g_varchar2_table(822) := '5377464D4155304254674650415641425551465341564D4256414656415659425677465941566B425767466241567742585146654156384259414668415749425977466B415755425A67466E4157674261514671415773426241467441415630636D467A';
wwv_flow_imp.g_varchar2_table(823) := '6142426E5958526C643246354C584268636D46736247567348326C75644756796257566B615746305A53316C646D56756443316A5958526A6143316A5957356A5A577778615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F';
wwv_flow_imp.g_varchar2_table(824) := '4C57357662693170626E526C636E4A3163485270626D63746257567A6332466E5A52687A644746796443316C646D56756443316A623231775A57357A595852706232347563335268636E51745A585A6C626E5174626D39754C576C7564475679636E5677';
wwv_flow_imp.g_varchar2_table(825) := '64476C755A79317759584A686247786C6243317464577830615842735A517473623239774C573168636D746C63684A7759584A686247786C624331746153317459584A725A58496A63335268636E51745A585A6C626E5174626D39754C576C7564475679';
wwv_flow_imp.g_varchar2_table(826) := '636E567764476C755A79317A6157647559577776615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F4C57357662693170626E526C636E4A3163485270626D637464476C745A584971615735305A584A745A5752705958526C';
wwv_flow_imp.g_varchar2_table(827) := '4C5756325A5735304C574E6864474E6F4C584268636D4673624756734C573131624852706347786C4A576C75644756796257566B615746305A53316C646D56756443316A5958526A6143316A623231775A57357A595852706232344C5A3246305A586468';
wwv_flow_imp.g_varchar2_table(828) := '65533134623349515A57356B4C5756325A5735304C574E68626D4E6C62434A70626E526C636D316C5A476C68644755745A585A6C626E51745932463059326774593239755A476C30615739754F326C75644756796257566B615746305A53316C646D5675';
wwv_flow_imp.g_varchar2_table(829) := '6443316A5958526A6143317562323474615735305A584A79645842306157356E4C584268636D4673624756734C573131624852706347786C46584E3059584A304C5756325A5735304C574E76626D527064476C7662694A7A644746796443316C646D5675';
wwv_flow_imp.g_varchar2_table(830) := '6443317562323474615735305A584A79645842306157356E4C5852706257567946484E6C6358566C626E52705957777462576B7462574679613256794358567A5A5849746447467A6177316964584E70626D567A637931796457786C456E4E3159693177';
wwv_flow_imp.g_varchar2_table(831) := '636D396A5A584E7A4C573168636D746C6368317A644746796443316C646D56756443317759584A686247786C6243317464577830615842735A52467A644746796443316C646D56756443316C636E4A7663683970626E526C636D316C5A476C6864475574';
wwv_flow_imp.g_varchar2_table(832) := '5A585A6C626E5174593246305932677463326C6E626D4673486D6C75644756796257566B615746305A53316C646D56756443316A5958526A6143316C636E4A7663685A6C626D51745A585A6C626E51745932397463475675633246306157397546484E31';
wwv_flow_imp.g_varchar2_table(833) := '596E427962324E6C63334D7459323973624746776332566B45334E31596E427962324E6C63334D745A5868775957356B5A5751456447467A6177396C626D51745A585A6C626E51745A584A796233496A615735305A584A745A5752705958526C4C575632';
wwv_flow_imp.g_varchar2_table(834) := '5A5735304C574E6864474E6F4C57567A593246735958527062323465615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F4C58527062575679466E4E3059584A304C5756325A5735304C57567A593246735958527062323453';
wwv_flow_imp.g_varchar2_table(835) := '63335268636E51745A585A6C626E517463326C6E626D4673456D4A3163326C755A584E7A4C584A31624755746447467A61775A745957353159577748636D566A5A576C325A51316A595778734C57466A64476C326158523545584E3059584A304C575632';
wwv_flow_imp.g_varchar2_table(836) := '5A5735304C5852706257567945334E3059584A304C5756325A5735304C57316C63334E685A325558615735305A584A745A5752705958526C4C5756325A5735304C573576626D5564615735305A584A745A5752705958526C4C5756325A5735304C574E68';
wwv_flow_imp.g_varchar2_table(837) := '64474E6F4C577870626D73555A57356B4C5756325A5735304C57567A593246735958527062323448596E4274626931706277396E5958526C643246354C574E76625842735A5867535A3246305A5864686553316C646D567564474A686332566B44476468';
wwv_flow_imp.g_varchar2_table(838) := '6447563359586B74626D39755A51706E5958526C643246354C573979453256755A43316C646D5675644331305A584A7461573568644755515A57356B4C5756325A5735304C584E705A3235686241356C626D51745A585A6C626E5174626D39755A524A6C';
wwv_flow_imp.g_varchar2_table(839) := '626D51745A585A6C626E51746258567364476C77624755525A57356B4C5756325A5735304C57316C63334E685A32554F5A57356B4C5756325A5735304C577870626D7367615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F';
wwv_flow_imp.g_varchar2_table(840) := '4C57316C63334E685A32556C615735305A584A745A5752705958526C4C5756325A5735304C58526F636D39334C574E766258426C626E4E6864476C766268527A644746796443316C646D56756443317464577830615842735A515A7A59334A706348514C';
wwv_flow_imp.g_varchar2_table(841) := '62574675645746734C58526863327345633256755A41647A5A584A3261574E6C44484A6C59325670646D55746447467A617752316332567945484E3059584A304C5756325A5735304C573576626D556A615735305A584A745A5752705958526C4C575632';
wwv_flow_imp.g_varchar2_table(842) := '5A5735304C58526F636D39334C57567A593246735958527062323468615735305A584A745A5752705958526C4C5756325A5735304C574E6864474E6F4C573131624852706347786C4E476C75644756796257566B615746305A53316C646D56756443316A';
wwv_flow_imp.g_varchar2_table(843) := '5958526A6143317562323474615735305A584A79645842306157356E4C57567A593246735958527062323464615735305A584A745A5752705958526C4C5756325A5735304C58526F636D39334C577870626D736D63335268636E51745A585A6C626E5174';
wwv_flow_imp.g_varchar2_table(844) := '626D39754C576C7564475679636E567764476C755A79316A6232356B615852706232344C5A47463059533176596D706C5933514C63324E79615842304C5852686332734A633256755A43313059584E72436D52686447457463335276636D556E63335268';
wwv_flow_imp.g_varchar2_table(845) := '636E51745A585A6C626E5174626D39754C576C7564475679636E567764476C755A79316C63324E68624746306157397549476C75644756796257566B615746305A53316C646D56756443313061484A76647931745A584E7A5957646C4D6D6C7564475679';
wwv_flow_imp.g_varchar2_table(846) := '6257566B615746305A53316C646D56756443316A5958526A6143317562323474615735305A584A79645842306157356E4C573131624852706347786C4D476C75644756796257566B615746305A53316C646D56756443316A5958526A6143317562323474';
wwv_flow_imp.g_varchar2_table(847) := '615735305A584A79645842306157356E4C584E705A32356862434670626E526C636D316C5A476C68644755745A585A6C626E517464476879623363746258567364476C776247556B63335268636E51745A585A6C626E5174626D39754C576C7564475679';
wwv_flow_imp.g_varchar2_table(848) := '636E567764476C755A7931745A584E7A5957646C4457466B4C5768765979317459584A725A58494D63325679646D6C6A5A53313059584E724358526863327374626D39755A524E6A623231775A57357A595852706232347462574679613256794A584E30';
wwv_flow_imp.g_varchar2_table(849) := '59584A304C5756325A5735304C57357662693170626E526C636E4A3163485270626D63746258567364476C7762475566615735305A584A745A5752705958526C4C5756325A5735304C58526F636D39334C584E705A32356862444E70626E526C636D316C';
wwv_flow_imp.g_varchar2_table(850) := '5A476C68644755745A585A6C626E51745932463059326774626D39754C576C7564475679636E567764476C755A79316A6232356B615852706232344C6347467964476C6A61584268626E515A5A585A6C626E51746333566963484A765932567A6379316C';
wwv_flow_imp.g_varchar2_table(851) := '65484268626D526C5A4246735957356C4C576C7563325679644331695A5778766477707A6347466A5A5331306232397345474E76626D356C59335270623234746258567364476B45624746755A51707359584E7A627931306232397345577868626D5574';
wwv_flow_imp.g_varchar2_table(852) := '6157357A5A584A304C57466962335A6C45577868626D55745A476C326157526C4C58526F636D566C44327868626D55745A476C326157526C4C5852336277706B595852684C576C75634856304332526864474574623356306348563043576868626D5174';
wwv_flow_imp.g_varchar2_table(853) := '644739766241566E636D3931634139305A5868304C574675626D3930595852706232344C64484A68626E4E68593352706232344D63324E795A58637464334A6C626D4E6F436D4E76626D356C5933527062323451593239755A476C306157397559577774';
wwv_flow_imp.g_varchar2_table(854) := '5A6D78766477786B5A575A68645778304C575A736233634141413D3D272920666F726D61742827747275657479706527293B0A7D0A2F2A204368726F6D65206861636B3A205356472069732072656E6465726564206D6F726520736D6F6F746820696E20';
wwv_flow_imp.g_varchar2_table(855) := '57696E646F7A7A652E2031303025206D616769632C20756E636F6D6D656E7420696620796F75206E6565642069742E202A2F0A2F2A204E6F74652C20746861742077696C6C20627265616B2068696E74696E672120496E206F74686572204F532D657320';
wwv_flow_imp.g_varchar2_table(856) := '666F6E742077696C6C206265206E6F7420617320736861727020617320697420636F756C64206265202A2F0A2F2A0A406D656469612073637265656E20616E6420282D7765626B69742D6D696E2D6465766963652D706978656C2D726174696F3A302920';
wwv_flow_imp.g_varchar2_table(857) := '7B0A202040666F6E742D66616365207B0A20202020666F6E742D66616D696C793A202762706D6E273B0A202020207372633A2075726C28272E2E2F666F6E742F62706D6E2E7376673F31363430363238392362706D6E272920666F726D61742827737667';
wwv_flow_imp.g_varchar2_table(858) := '27293B0A20207D0A7D0A2A2F0A0A5B636C6173735E3D2262706D6E2D69636F6E2D225D3A6265666F72652C205B636C6173732A3D222062706D6E2D69636F6E2D225D3A6265666F7265207B0A2020666F6E742D66616D696C793A202262706D6E223B0A20';
wwv_flow_imp.g_varchar2_table(859) := '20666F6E742D7374796C653A206E6F726D616C3B0A2020666F6E742D7765696768743A206E6F726D616C3B0A2020737065616B3A206E657665723B0A0A2020646973706C61793A20696E6C696E652D626C6F636B3B0A2020746578742D6465636F726174';
wwv_flow_imp.g_varchar2_table(860) := '696F6E3A20696E68657269743B0A202077696474683A2031656D3B0A20202F2A206D617267696E2D72696768743A202E32656D3B202A2F0A2020746578742D616C69676E3A2063656E7465723B0A20202F2A206F7061636974793A202E383B202A2F0A0A';
wwv_flow_imp.g_varchar2_table(861) := '20202F2A20466F7220736166657479202D20726573657420706172656E74207374796C65732C20746861742063616E20627265616B20676C79706820636F6465732A2F0A2020666F6E742D76617269616E743A206E6F726D616C3B0A2020746578742D74';
wwv_flow_imp.g_varchar2_table(862) := '72616E73666F726D3A206E6F6E653B0A0A20202F2A2066697820627574746F6E73206865696768742C20666F72207477697474657220626F6F747374726170202A2F0A20206C696E652D6865696768743A2031656D3B0A0A20202F2A20416E696D617469';
wwv_flow_imp.g_varchar2_table(863) := '6F6E2063656E74657220636F6D70656E736174696F6E202D206D617267696E732073686F756C642062652073796D6D6574726963202A2F0A20202F2A2072656D6F7665206966206E6F74206E6565646564202A2F0A20202F2A206D617267696E2D6C6566';
wwv_flow_imp.g_varchar2_table(864) := '743A202E32656D3B202A2F0A0A20202F2A20796F752063616E206265206D6F726520636F6D666F727461626C65207769746820696E637265617365642069636F6E732073697A65202A2F0A20202F2A20666F6E742D73697A653A20313230253B202A2F0A';
wwv_flow_imp.g_varchar2_table(865) := '20200A20202F2A20466F6E7420736D6F6F7468696E672E2054686174207761732074616B656E2066726F6D2054574253202A2F0A20202D7765626B69742D666F6E742D736D6F6F7468696E673A20616E7469616C69617365643B0A20202D6D6F7A2D6F73';
wwv_flow_imp.g_varchar2_table(866) := '782D666F6E742D736D6F6F7468696E673A20677261797363616C653B0A0A20202F2A20556E636F6D6D656E7420666F7220334420656666656374202A2F0A20202F2A20746578742D736861646F773A203170782031707820317078207267626128313237';
wwv_flow_imp.g_varchar2_table(867) := '2C203132372C203132372C20302E33293B202A2F0A7D0A0A2E62706D6E2D69636F6E2D74726173683A6265666F7265207B20636F6E74656E743A20275C65383031273B207D202F2A2027EEA08127202A2F0A2E62706D6E2D69636F6E2D67617465776179';
wwv_flow_imp.g_varchar2_table(868) := '2D706172616C6C656C3A6265666F7265207B20636F6E74656E743A20275C65383034273B207D202F2A2027EEA08427202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D63616E63656C3A6265666F7265';
wwv_flow_imp.g_varchar2_table(869) := '207B20636F6E74656E743A20275C65383035273B207D202F2A2027EEA08527202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D6D6573736167653A6265666F';
wwv_flow_imp.g_varchar2_table(870) := '7265207B20636F6E74656E743A20275C65383036273B207D202F2A2027EEA08627202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383037273B20';
wwv_flow_imp.g_varchar2_table(871) := '7D202F2A2027EEA08727202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D706172616C6C656C2D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383038273B207D';
wwv_flow_imp.g_varchar2_table(872) := '202F2A2027EEA08827202A2F0A2E62706D6E2D69636F6E2D6C6F6F702D6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383039273B207D202F2A2027EEA08927202A2F0A2E62706D6E2D69636F6E2D706172616C6C656C2D6D692D';
wwv_flow_imp.g_varchar2_table(873) := '6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383061273B207D202F2A2027EEA08A27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D7369676E616C3A6265666F72';
wwv_flow_imp.g_varchar2_table(874) := '65207B20636F6E74656E743A20275C65383062273B207D202F2A2027EEA08B27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D74696D65723A6265666F72';
wwv_flow_imp.g_varchar2_table(875) := '65207B20636F6E74656E743A20275C65383063273B207D202F2A2027EEA08C27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D706172616C6C656C2D6D756C7469706C653A6265666F7265207B2063';
wwv_flow_imp.g_varchar2_table(876) := '6F6E74656E743A20275C65383064273B207D202F2A2027EEA08D27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C';
wwv_flow_imp.g_varchar2_table(877) := '65383065273B207D202F2A2027EEA08E27202A2F0A2E62706D6E2D69636F6E2D676174657761792D786F723A6265666F7265207B20636F6E74656E743A20275C65383066273B207D202F2A2027EEA08F27202A2F0A2E62706D6E2D69636F6E2D656E642D';
wwv_flow_imp.g_varchar2_table(878) := '6576656E742D63616E63656C3A6265666F7265207B20636F6E74656E743A20275C65383131273B207D202F2A2027EEA09127202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D636F6E646974696F6E3A';
wwv_flow_imp.g_varchar2_table(879) := '6265666F7265207B20636F6E74656E743A20275C65383132273B207D202F2A2027EEA09227202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D706172616C6C';
wwv_flow_imp.g_varchar2_table(880) := '656C2D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383133273B207D202F2A2027EEA09327202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D636F6E646974696F6E3A6265666F7265207B20636F6E7465';
wwv_flow_imp.g_varchar2_table(881) := '6E743A20275C65383134273B207D202F2A2027EEA09427202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D74696D65723A6265666F7265207B20636F6E74656E743A20275C65383135273B20';
wwv_flow_imp.g_varchar2_table(882) := '7D202F2A2027EEA09527202A2F0A2E62706D6E2D69636F6E2D73657175656E7469616C2D6D692D6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383136273B207D202F2A2027EEA09627202A2F0A2E62706D6E2D69636F6E2D7573';
wwv_flow_imp.g_varchar2_table(883) := '65722D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383137273B207D202F2A2027EEA09727202A2F0A2E62706D6E2D69636F6E2D627573696E6573732D72756C653A6265666F7265207B20636F6E74656E743A20275C65383138273B';
wwv_flow_imp.g_varchar2_table(884) := '207D202F2A2027EEA09827202A2F0A2E62706D6E2D69636F6E2D7375622D70726F636573732D6D61726B65723A6265666F7265207B20636F6E74656E743A20275C65383139273B207D202F2A2027EEA09927202A2F0A2E62706D6E2D69636F6E2D737461';
wwv_flow_imp.g_varchar2_table(885) := '72742D6576656E742D706172616C6C656C2D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383161273B207D202F2A2027EEA09A27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6572726F723A626566';
wwv_flow_imp.g_varchar2_table(886) := '6F7265207B20636F6E74656E743A20275C65383162273B207D202F2A2027EEA09B27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D7369676E616C3A6265666F7265207B20636F6E74656E743A2027';
wwv_flow_imp.g_varchar2_table(887) := '5C65383163273B207D202F2A2027EEA09C27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6572726F723A6265666F7265207B20636F6E74656E743A20275C65383164273B207D202F2A2027EEA09D';
wwv_flow_imp.g_varchar2_table(888) := '27202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383165273B207D202F2A2027EEA09E27202A2F0A2E62706D6E2D69636F6E2D73756270726F636573';
wwv_flow_imp.g_varchar2_table(889) := '732D636F6C6C61707365643A6265666F7265207B20636F6E74656E743A20275C65383166273B207D202F2A2027EEA09F27202A2F0A2E62706D6E2D69636F6E2D73756270726F636573732D657870616E6465643A6265666F7265207B20636F6E74656E74';
wwv_flow_imp.g_varchar2_table(890) := '3A20275C65383230273B207D202F2A2027EEA0A027202A2F0A2E62706D6E2D69636F6E2D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383231273B207D202F2A2027EEA0A127202A2F0A2E62706D6E2D69636F6E2D656E642D657665';
wwv_flow_imp.g_varchar2_table(891) := '6E742D6572726F723A6265666F7265207B20636F6E74656E743A20275C65383232273B207D202F2A2027EEA0A227202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D657363616C6174696F6E3A626566';
wwv_flow_imp.g_varchar2_table(892) := '6F7265207B20636F6E74656E743A20275C65383233273B207D202F2A2027EEA0A327202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D74696D65723A6265666F7265207B20636F6E74656E743A20275C';
wwv_flow_imp.g_varchar2_table(893) := '65383234273B207D202F2A2027EEA0A427202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383235273B207D202F2A2027EEA0A527202A2F0A2E62706D';
wwv_flow_imp.g_varchar2_table(894) := '6E2D69636F6E2D73746172742D6576656E742D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C65383236273B207D202F2A2027EEA0A627202A2F0A2E62706D6E2D69636F6E2D627573696E6573732D72756C652D7461736B3A626566';
wwv_flow_imp.g_varchar2_table(895) := '6F7265207B20636F6E74656E743A20275C65383237273B207D202F2A2027EEA0A727202A2F0A2E62706D6E2D69636F6E2D6D616E75616C3A6265666F7265207B20636F6E74656E743A20275C65383238273B207D202F2A2027EEA0A827202A2F0A2E6270';
wwv_flow_imp.g_varchar2_table(896) := '6D6E2D69636F6E2D726563656976653A6265666F7265207B20636F6E74656E743A20275C65383239273B207D202F2A2027EEA0A927202A2F0A2E62706D6E2D69636F6E2D63616C6C2D61637469766974793A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(897) := '275C65383261273B207D202F2A2027EEA0AA27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D74696D65723A6265666F7265207B20636F6E74656E743A20275C65383262273B207D202F2A2027EEA0AB27202A2F0A2E62706D6E2D69';
wwv_flow_imp.g_varchar2_table(898) := '636F6E2D73746172742D6576656E742D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383263273B207D202F2A2027EEA0AC27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D6E6F6E653A';
wwv_flow_imp.g_varchar2_table(899) := '6265666F7265207B20636F6E74656E743A20275C65383264273B207D202F2A2027EEA0AD27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6C696E6B3A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(900) := '275C65383265273B207D202F2A2027EEA0AE27202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383266273B207D202F2A2027EEA0AF27202A2F0A2E62706D';
wwv_flow_imp.g_varchar2_table(901) := '6E2D69636F6E2D62706D6E2D696F3A6265666F7265207B20636F6E74656E743A20275C65383331273B207D202F2A2027EEA0B127202A2F0A2E62706D6E2D69636F6E2D676174657761792D636F6D706C65783A6265666F7265207B20636F6E74656E743A';
wwv_flow_imp.g_varchar2_table(902) := '20275C65383332273B207D202F2A2027EEA0B227202A2F0A2E62706D6E2D69636F6E2D676174657761792D6576656E7462617365643A6265666F7265207B20636F6E74656E743A20275C65383333273B207D202F2A2027EEA0B327202A2F0A2E62706D6E';
wwv_flow_imp.g_varchar2_table(903) := '2D69636F6E2D676174657761792D6E6F6E653A6265666F7265207B20636F6E74656E743A20275C65383334273B207D202F2A2027EEA0B427202A2F0A2E62706D6E2D69636F6E2D676174657761792D6F723A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(904) := '275C65383335273B207D202F2A2027EEA0B527202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D7465726D696E6174653A6265666F7265207B20636F6E74656E743A20275C65383336273B207D202F2A2027EEA0B627202A2F0A2E62706D6E';
wwv_flow_imp.g_varchar2_table(905) := '2D69636F6E2D656E642D6576656E742D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C65383337273B207D202F2A2027EEA0B727202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6E6F6E653A6265666F7265207B2063';
wwv_flow_imp.g_varchar2_table(906) := '6F6E74656E743A20275C65383338273B207D202F2A2027EEA0B827202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383339273B207D202F2A2027EEA0B927202A';
wwv_flow_imp.g_varchar2_table(907) := '2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383361273B207D202F2A2027EEA0BA27202A2F0A2E62706D6E2D69636F6E2D656E642D6576656E742D6C696E6B3A6265';
wwv_flow_imp.g_varchar2_table(908) := '666F7265207B20636F6E74656E743A20275C65383362273B207D202F2A2027EEA0BB27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6D6573736167653A6265666F7265207B20636F6E74656E743A';
wwv_flow_imp.g_varchar2_table(909) := '20275C65383363273B207D202F2A2027EEA0BC27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D636F6D70656E736174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383364273B20';
wwv_flow_imp.g_varchar2_table(910) := '7D202F2A2027EEA0BD27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383365273B207D202F2A2027EEA0BE27202A2F0A2E62706D6E2D69636F6E2D7363';
wwv_flow_imp.g_varchar2_table(911) := '726970743A6265666F7265207B20636F6E74656E743A20275C65383366273B207D202F2A2027EEA0BF27202A2F0A2E62706D6E2D69636F6E2D6D616E75616C2D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383430273B207D202F2A';
wwv_flow_imp.g_varchar2_table(912) := '2027EEA18027202A2F0A2E62706D6E2D69636F6E2D73656E643A6265666F7265207B20636F6E74656E743A20275C65383431273B207D202F2A2027EEA18127202A2F0A2E62706D6E2D69636F6E2D736572766963653A6265666F7265207B20636F6E7465';
wwv_flow_imp.g_varchar2_table(913) := '6E743A20275C65383432273B207D202F2A2027EEA18227202A2F0A2E62706D6E2D69636F6E2D726563656976652D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383433273B207D202F2A2027EEA18327202A2F0A2E62706D6E2D6963';
wwv_flow_imp.g_varchar2_table(914) := '6F6E2D757365723A6265666F7265207B20636F6E74656E743A20275C65383434273B207D202F2A2027EEA18427202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E653A6265666F7265207B20636F6E74656E743A20275C653834';
wwv_flow_imp.g_varchar2_table(915) := '35273B207D202F2A2027EEA18527202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383436273B207D202F2A2027EEA1';
wwv_flow_imp.g_varchar2_table(916) := '8627202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383437273B207D202F2A2027EEA18727202A2F0A2E62706D6E2D6963';
wwv_flow_imp.g_varchar2_table(917) := '6F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383438273B207D202F2A2027EEA18827202A2F0A2E6270';
wwv_flow_imp.g_varchar2_table(918) := '6D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D6C696E6B3A6265666F7265207B20636F6E74656E743A20275C65383439273B207D202F2A2027EEA18927202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E';
wwv_flow_imp.g_varchar2_table(919) := '742D6E6F6E2D696E74657272757074696E672D636F6E646974696F6E3A6265666F7265207B20636F6E74656E743A20275C65383461273B207D202F2A2027EEA18A27202A2F0A2E62706D6E2D69636F6E2D646174612D6F626A6563743A6265666F726520';
wwv_flow_imp.g_varchar2_table(920) := '7B20636F6E74656E743A20275C65383462273B207D202F2A2027EEA18B27202A2F0A2E62706D6E2D69636F6E2D7363726970742D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383463273B207D202F2A2027EEA18C27202A2F0A2E62';
wwv_flow_imp.g_varchar2_table(921) := '706D6E2D69636F6E2D73656E642D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383464273B207D202F2A2027EEA18D27202A2F0A2E62706D6E2D69636F6E2D646174612D73746F72653A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(922) := '275C65383465273B207D202F2A2027EEA18E27202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D657363616C6174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383466273B';
wwv_flow_imp.g_varchar2_table(923) := '207D202F2A2027EEA18F27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383530273B207D202F2A2027EEA19027202A2F0A';
wwv_flow_imp.g_varchar2_table(924) := '2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383531273B207D202F2A2027EEA1912720';
wwv_flow_imp.g_varchar2_table(925) := '2A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C65383532273B207D202F2A2027EEA19227';
wwv_flow_imp.g_varchar2_table(926) := '202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D6D756C7469706C653A6265666F7265207B20636F6E74656E743A20275C65383533273B207D202F2A2027EEA19327202A2F0A2E62706D6E2D69636F6E';
wwv_flow_imp.g_varchar2_table(927) := '2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D6D6573736167653A6265666F7265207B20636F6E74656E743A20275C65383534273B207D202F2A2027EEA19427202A2F0A2E62706D6E2D69636F6E2D61642D686F632D6D6172';
wwv_flow_imp.g_varchar2_table(928) := '6B65723A6265666F7265207B20636F6E74656E743A20275C65383535273B207D202F2A2027EEA19527202A2F0A2E62706D6E2D69636F6E2D736572766963652D7461736B3A6265666F7265207B20636F6E74656E743A20275C65383536273B207D202F2A';
wwv_flow_imp.g_varchar2_table(929) := '2027EEA19627202A2F0A2E62706D6E2D69636F6E2D7461736B2D6E6F6E653A6265666F7265207B20636F6E74656E743A20275C65383537273B207D202F2A2027EEA19727202A2F0A2E62706D6E2D69636F6E2D636F6D70656E736174696F6E2D6D61726B';
wwv_flow_imp.g_varchar2_table(930) := '65723A6265666F7265207B20636F6E74656E743A20275C65383538273B207D202F2A2027EEA19827202A2F0A2E62706D6E2D69636F6E2D73746172742D6576656E742D6E6F6E2D696E74657272757074696E672D6D756C7469706C653A6265666F726520';
wwv_flow_imp.g_varchar2_table(931) := '7B20636F6E74656E743A20275C65383539273B207D202F2A2027EEA19927202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D7468726F772D7369676E616C3A6265666F7265207B20636F6E74656E743A20275C653835';
wwv_flow_imp.g_varchar2_table(932) := '61273B207D202F2A2027EEA19A27202A2F0A2E62706D6E2D69636F6E2D696E7465726D6564696174652D6576656E742D63617463682D6E6F6E2D696E74657272757074696E672D636F6E646974696F6E3A6265666F7265207B20636F6E74656E743A2027';
wwv_flow_imp.g_varchar2_table(933) := '5C65383562273B207D202F2A2027EEA19B27202A2F0A2E62706D6E2D69636F6E2D7061727469636970616E743A6265666F7265207B20636F6E74656E743A20275C65383563273B207D202F2A2027EEA19C27202A2F0A2E62706D6E2D69636F6E2D657665';
wwv_flow_imp.g_varchar2_table(934) := '6E742D73756270726F636573732D657870616E6465643A6265666F7265207B20636F6E74656E743A20275C65383564273B207D202F2A2027EEA19D27202A2F0A2E62706D6E2D69636F6E2D6C616E652D696E736572742D62656C6F773A6265666F726520';
wwv_flow_imp.g_varchar2_table(935) := '7B20636F6E74656E743A20275C65383565273B207D202F2A2027EEA19E27202A2F0A2E62706D6E2D69636F6E2D73706163652D746F6F6C3A6265666F7265207B20636F6E74656E743A20275C65383566273B207D202F2A2027EEA19F27202A2F0A2E6270';
wwv_flow_imp.g_varchar2_table(936) := '6D6E2D69636F6E2D636F6E6E656374696F6E2D6D756C74693A6265666F7265207B20636F6E74656E743A20275C65383630273B207D202F2A2027EEA1A027202A2F0A2E62706D6E2D69636F6E2D6C616E653A6265666F7265207B20636F6E74656E743A20';
wwv_flow_imp.g_varchar2_table(937) := '275C65383631273B207D202F2A2027EEA1A127202A2F0A2E62706D6E2D69636F6E2D6C6173736F2D746F6F6C3A6265666F7265207B20636F6E74656E743A20275C65383632273B207D202F2A2027EEA1A227202A2F0A2E62706D6E2D69636F6E2D6C616E';
wwv_flow_imp.g_varchar2_table(938) := '652D696E736572742D61626F76653A6265666F7265207B20636F6E74656E743A20275C65383633273B207D202F2A2027EEA1A327202A2F0A2E62706D6E2D69636F6E2D6C616E652D6469766964652D74687265653A6265666F7265207B20636F6E74656E';
wwv_flow_imp.g_varchar2_table(939) := '743A20275C65383634273B207D202F2A2027EEA1A427202A2F0A2E62706D6E2D69636F6E2D6C616E652D6469766964652D74776F3A6265666F7265207B20636F6E74656E743A20275C65383635273B207D202F2A2027EEA1A527202A2F0A2E62706D6E2D';
wwv_flow_imp.g_varchar2_table(940) := '69636F6E2D646174612D696E7075743A6265666F7265207B20636F6E74656E743A20275C65383636273B207D202F2A2027EEA1A627202A2F0A2E62706D6E2D69636F6E2D646174612D6F75747075743A6265666F7265207B20636F6E74656E743A20275C';
wwv_flow_imp.g_varchar2_table(941) := '65383637273B207D202F2A2027EEA1A727202A2F0A2E62706D6E2D69636F6E2D68616E642D746F6F6C3A6265666F7265207B20636F6E74656E743A20275C65383638273B207D202F2A2027EEA1A827202A2F0A2E62706D6E2D69636F6E2D67726F75703A';
wwv_flow_imp.g_varchar2_table(942) := '6265666F7265207B20636F6E74656E743A20275C65383639273B207D202F2A2027EEA1A927202A2F0A2E62706D6E2D69636F6E2D746578742D616E6E6F746174696F6E3A6265666F7265207B20636F6E74656E743A20275C65383662273B207D202F2A20';
wwv_flow_imp.g_varchar2_table(943) := '27EEA1AB27202A2F0A2E62706D6E2D69636F6E2D7472616E73616374696F6E3A6265666F7265207B20636F6E74656E743A20275C65386334273B207D202F2A2027EEA38427202A2F0A2E62706D6E2D69636F6E2D73637265772D7772656E63683A626566';
wwv_flow_imp.g_varchar2_table(944) := '6F7265207B20636F6E74656E743A20275C65386462273B207D202F2A2027EEA39B27202A2F0A2E62706D6E2D69636F6E2D636F6E6E656374696F6E3A6265666F7265207B20636F6E74656E743A20275C65386463273B207D202F2A2027EEA39C27202A2F';
wwv_flow_imp.g_varchar2_table(945) := '0A2E62706D6E2D69636F6E2D636F6E646974696F6E616C2D666C6F773A6265666F7265207B20636F6E74656E743A20275C65386530273B207D202F2A2027EEA3A027202A2F0A2E62706D6E2D69636F6E2D64656661756C742D666C6F773A6265666F7265';
wwv_flow_imp.g_varchar2_table(946) := '207B20636F6E74656E743A20275C65386531273B207D202F2A2027EEA3A127202A2F0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(14512843102671178)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_file_name=>'css/bpmn-embedded.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E626A732D636F6E7461696E6572207B0D0A20202D2D626A732D666F6E742D66616D696C793A20417269616C2C2073616E732D73657269663B0D0A0D0A20202D2D636F6C6F722D677265792D3232352D31302D31353A2068736C283232352C203130252C';
wwv_flow_imp.g_varchar2_table(2) := '20313525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D33353A2068736C283232352C203130252C20333525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D35353A2068736C283232352C203130252C20353525293B';
wwv_flow_imp.g_varchar2_table(3) := '0D0A20202D2D636F6C6F722D677265792D3232352D31302D37353A2068736C283232352C203130252C20373525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D38303A2068736C283232352C203130252C20383025293B0D0A20202D2D';
wwv_flow_imp.g_varchar2_table(4) := '636F6C6F722D677265792D3232352D31302D38353A2068736C283232352C203130252C20383525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39303A2068736C283232352C203130252C20393025293B0D0A20202D2D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(5) := '677265792D3232352D31302D39353A2068736C283232352C203130252C20393525293B0D0A20202D2D636F6C6F722D677265792D3232352D31302D39373A2068736C283232352C203130252C20393725293B0D0A0D0A20202D2D636F6C6F722D626C7565';
wwv_flow_imp.g_varchar2_table(6) := '2D3230352D3130302D34353A2068736C283230352C20313030252C20343525293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D33303A2068736C61283230352C20313030252C203435252C20333025293B0D';
wwv_flow_imp.g_varchar2_table(7) := '0A20202D2D636F6C6F722D626C75652D3230352D3130302D35303A2068736C283230352C20313030252C20353025293B0D0A20202D2D636F6C6F722D626C75652D3230352D3130302D39353A2068736C283230352C20313030252C20393525293B0D0A0D';
wwv_flow_imp.g_varchar2_table(8) := '0A20202D2D636F6C6F722D677265656E2D3135302D38362D34343A2068736C283135302C203836252C20343425293B0D0A0D0A20202D2D636F6C6F722D7265642D3336302D3130302D34303A2068736C283336302C20313030252C20343025293B0D0A20';
wwv_flow_imp.g_varchar2_table(9) := '202D2D636F6C6F722D7265642D3336302D3130302D34353A2068736C283336302C20313030252C20343525293B0D0A20202D2D636F6C6F722D7265642D3336302D3130302D39323A2068736C283336302C20313030252C20393225293B0D0A20202D2D63';
wwv_flow_imp.g_varchar2_table(10) := '6F6C6F722D7265642D3336302D3130302D39373A2068736C283336302C20313030252C20393725293B0D0A0D0A20202D2D636F6C6F722D77686974653A2068736C28302C2030252C2031303025293B0D0A20202D2D636F6C6F722D626C61636B3A206873';
wwv_flow_imp.g_varchar2_table(11) := '6C28302C2030252C203025293B0D0A20202D2D636F6C6F722D626C61636B2D6F7061636974792D30353A2068736C6128302C2030252C2030252C203525293B0D0A20202D2D636F6C6F722D626C61636B2D6F7061636974792D31303A2068736C6128302C';
wwv_flow_imp.g_varchar2_table(12) := '2030252C2030252C20313025293B0D0A0D0A20202D2D62726561646372756D62732D666F6E742D66616D696C793A20766172282D2D626A732D666F6E742D66616D696C79293B0D0A20202D2D62726561646372756D62732D6974656D2D636F6C6F723A20';
wwv_flow_imp.g_varchar2_table(13) := '766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A20202D2D62726561646372756D62732D6172726F772D636F6C6F723A20766172282D2D636F6C6F722D626C61636B293B0D0A20202D2D6472696C6C646F776E2D66696C6C2D';
wwv_flow_imp.g_varchar2_table(14) := '636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0D0A20202D2D6472696C6C646F776E2D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0D0A7D0D0A0D0A2E626A73';
wwv_flow_imp.g_varchar2_table(15) := '2D62726561646372756D6273207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A2020646973706C61793A206E6F6E653B0D0A2020666C65782D777261703A20777261703B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D';
wwv_flow_imp.g_varchar2_table(16) := '0A2020746F703A20333070783B0D0A20206C6566743A20333070783B0D0A202070616464696E673A203070783B0D0A20206D617267696E3A203070783B0D0A2020666F6E742D66616D696C793A20766172282D2D62726561646372756D62732D666F6E74';
wwv_flow_imp.g_varchar2_table(17) := '2D66616D696C79293B0D0A2020666F6E742D73697A653A20313670783B0D0A20206C696E652D6865696768743A206E6F726D616C3B0D0A7D0D0A0D0A2E626A732D62726561646372756D62732D73686F776E202E626A732D62726561646372756D627320';
wwv_flow_imp.g_varchar2_table(18) := '7B0D0A2020646973706C61793A20666C65783B0D0A7D0D0A0D0A2E646A732D70616C657474652D73686F776E202E626A732D62726561646372756D6273207B0D0A20206C6566743A20393070783B0D0A7D0D0A0D0A2E646A732D70616C657474652D7368';
wwv_flow_imp.g_varchar2_table(19) := '6F776E2E646A732D70616C657474652D74776F2D636F6C756D6E202E626A732D62726561646372756D6273207B0D0A20206C6566743A2031343070783B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C69207B0D0A2020646973706C6179';
wwv_flow_imp.g_varchar2_table(20) := '3A20696E6C696E652D666C65783B0D0A202070616464696E672D626F74746F6D3A203570783B0D0A2020616C69676E2D6974656D733A2063656E7465723B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C692061207B0D0A202063757273';
wwv_flow_imp.g_varchar2_table(21) := '6F723A20706F696E7465723B0D0A2020636F6C6F723A20766172282D2D62726561646372756D62732D6974656D2D636F6C6F72293B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C693A6C6173742D6F662D747970652061207B0D0A2020';
wwv_flow_imp.g_varchar2_table(22) := '636F6C6F723A20696E68657269743B0D0A2020637572736F723A2064656661756C743B0D0A7D0D0A0D0A2E626A732D62726561646372756D6273206C693A6E6F74283A66697273742D6368696C64293A3A6265666F7265207B0D0A2020636F6E74656E74';
wwv_flow_imp.g_varchar2_table(23) := '3A2075726C2827646174613A696D6167652F7376672B786D6C3B757466382C3C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22313722206865696768743D223137222076696577426F';
wwv_flow_imp.g_varchar2_table(24) := '783D22302030203234203234223E3C7061746820643D224D313020364C382E353920372E34312031332E31372031326C2D342E353820342E35394C31302031386C362D367A22202F3E3C7061746820643D224D30203068323476323448307A222066696C';
wwv_flow_imp.g_varchar2_table(25) := '6C3D226E6F6E6522202F3E3C2F7376673E27293B0D0A202070616464696E673A2030203870783B0D0A2020636F6C6F723A20766172282D2D62726561646372756D62732D6172726F772D636F6C6F72293B0D0A20206865696768743A2031656D3B0D0A7D';
wwv_flow_imp.g_varchar2_table(26) := '0D0A0D0A2E626A732D62726561646372756D6273202E626A732D6372756D62207B0D0A2020646973706C61793A20696E6C696E652D626C6F636B3B0D0A20206D61782D77696474683A2032303070783B0D0A20206F766572666C6F773A2068696464656E';
wwv_flow_imp.g_varchar2_table(27) := '3B0D0A2020746578742D6F766572666C6F773A20656C6C69707369733B0D0A202077686974652D73706163653A206E6F777261703B0D0A7D0D0A0D0A2E626A732D6472696C6C646F776E207B0D0A202077696474683A20323070783B0D0A202068656967';
wwv_flow_imp.g_varchar2_table(28) := '68743A20323070783B0D0A0D0A202070616464696E673A203070783B0D0A20206D617267696E2D6C6566743A202D323070783B0D0A0D0A2020637572736F723A20706F696E7465723B0D0A2020626F726465723A206E6F6E653B0D0A2020626F72646572';
wwv_flow_imp.g_varchar2_table(29) := '2D7261646975733A203270783B0D0A20206F75746C696E653A206E6F6E653B0D0A0D0A202066696C6C3A20766172282D2D6472696C6C646F776E2D66696C6C2D636F6C6F72293B0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D64';
wwv_flow_imp.g_varchar2_table(30) := '72696C6C646F776E2D6261636B67726F756E642D636F6C6F72293B0D0A7D0D0A0D0A2E626A732D6472696C6C646F776E2D656D707479207B0D0A2020646973706C61793A206E6F6E653B0D0A7D0D0A0D0A2E73656C6563746564202E626A732D6472696C';
wwv_flow_imp.g_varchar2_table(31) := '6C646F776E2D656D707479207B0D0A2020646973706C61793A20696E68657269743B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D726573756C7473207B0D0A2020646973706C';
wwv_flow_imp.g_varchar2_table(32) := '61793A20666C65783B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D626F6479205B646174612D67726F75705D202B205B646174612D67726F75705D207B0D0A2020626F726465';
wwv_flow_imp.g_varchar2_table(33) := '722D6C6566743A2031707820736F6C696420766172282D2D706F7075702D626F726465722D636F6C6F72293B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D205B646174612D67726F75703D22616C69676E22';
wwv_flow_imp.g_varchar2_table(34) := '5D207B0D0A2020646973706C61793A20677269643B0D0A2020677269642D74656D706C6174652D636F6C756D6E733A2072657065617428332C20316672293B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D20';
wwv_flow_imp.g_varchar2_table(35) := '2E646A732D706F7075702D626F6479202E656E747279207B0D0A202070616464696E673A20367078203870783B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D626F6479202E65';
wwv_flow_imp.g_varchar2_table(36) := '6E7472793A6E6F74283A66697273742D6368696C6429207B0D0A20206D617267696E2D746F703A20303B0D0A7D0D0A0D0A5B646174612D706F7075703D22616C69676E2D656C656D656E7473225D202E646A732D706F7075702D656E7472792D69636F6E';
wwv_flow_imp.g_varchar2_table(37) := '207B0D0A2020646973706C61793A20626C6F636B3B0D0A20206D617267696E3A20303B0D0A20206865696768743A20323070783B0D0A202077696474683A20323070783B0D0A7D0D0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(14513144205671179)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_file_name=>'css/bpmn-js.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A2A0A202A20636F6C6F7220646566696E6974696F6E730A202A2F0A2E646A732D706172656E74207B0A20202D2D636F6C6F722D677265792D3232352D31302D31353A2068736C283232352C203130252C20313525293B0A20202D2D636F6C6F722D67';
wwv_flow_imp.g_varchar2_table(2) := '7265792D3232352D31302D33353A2068736C283232352C203130252C20333525293B0A20202D2D636F6C6F722D677265792D3232352D31302D35353A2068736C283232352C203130252C20353525293B0A20202D2D636F6C6F722D677265792D3232352D';
wwv_flow_imp.g_varchar2_table(3) := '31302D37353A2068736C283232352C203130252C20373525293B0A20202D2D636F6C6F722D677265792D3232352D31302D38303A2068736C283232352C203130252C20383025293B0A20202D2D636F6C6F722D677265792D3232352D31302D38353A2068';
wwv_flow_imp.g_varchar2_table(4) := '736C283232352C203130252C20383525293B0A20202D2D636F6C6F722D677265792D3232352D31302D39303A2068736C283232352C203130252C20393025293B0A20202D2D636F6C6F722D677265792D3232352D31302D39353A2068736C283232352C20';
wwv_flow_imp.g_varchar2_table(5) := '3130252C20393525293B0A20202D2D636F6C6F722D677265792D3232352D31302D39373A2068736C283232352C203130252C20393725293B0A0A20202D2D636F6C6F722D626C75652D3230352D3130302D34353A2068736C283230352C20313030252C20';
wwv_flow_imp.g_varchar2_table(6) := '343525293B0A20202D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D33303A2068736C61283230352C20313030252C203435252C20333025293B0A20202D2D636F6C6F722D626C75652D3230352D3130302D35303A206873';
wwv_flow_imp.g_varchar2_table(7) := '6C283230352C20313030252C20353025293B0A20202D2D636F6C6F722D626C75652D3230352D3130302D35302D6F7061636974792D31353A2068736C61283230352C20313030252C203530252C20313525293B0A20202D2D636F6C6F722D626C75652D32';
wwv_flow_imp.g_varchar2_table(8) := '30352D3130302D37303A2068736C283230352C20313030252C20373525293B0A20202D2D636F6C6F722D626C75652D3230352D3130302D39353A2068736C283230352C20313030252C20393525293B0A0A20202D2D636F6C6F722D677265656E2D313530';
wwv_flow_imp.g_varchar2_table(9) := '2D38362D34343A2068736C283135302C203836252C20343425293B0A0A20202D2D636F6C6F722D7265642D3336302D3130302D34303A2068736C283336302C20313030252C20343025293B0A20202D2D636F6C6F722D7265642D3336302D3130302D3435';
wwv_flow_imp.g_varchar2_table(10) := '3A2068736C283336302C20313030252C20343525293B0A20202D2D636F6C6F722D7265642D3336302D3130302D39323A2068736C283336302C20313030252C20393225293B0A20202D2D636F6C6F722D7265642D3336302D3130302D39373A2068736C28';
wwv_flow_imp.g_varchar2_table(11) := '3336302C20313030252C20393725293B0A0A20202D2D636F6C6F722D77686974653A2068736C28302C2030252C2031303025293B0A20202D2D636F6C6F722D626C61636B3A2068736C28302C2030252C203025293B0A20202D2D636F6C6F722D626C6163';
wwv_flow_imp.g_varchar2_table(12) := '6B2D6F7061636974792D31303A2068736C6128302C2030252C2030252C20313025293B0A20202D2D636F6C6F722D626C61636B2D6F7061636974792D33303A2068736C6128302C2030252C2030252C20333025293B0A0A20202D2D63616E7661732D6669';
wwv_flow_imp.g_varchar2_table(13) := '6C6C2D636F6C6F723A20766172282D2D636F6C6F722D7768697465293B0A0A20202D2D62656E64706F696E742D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3435293B0A20202D2D62656E64706F696E74';
wwv_flow_imp.g_varchar2_table(14) := '2D7374726F6B652D636F6C6F723A20766172282D2D63616E7661732D66696C6C2D636F6C6F72293B0A0A20202D2D636F6E746578742D7061642D656E7472792D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D776869746529';
wwv_flow_imp.g_varchar2_table(15) := '3B0A20202D2D636F6E746578742D7061642D656E7472792D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3935293B0A0A20202D2D656C656D656E742D647261676765722D636F';
wwv_flow_imp.g_varchar2_table(16) := '6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0A20202D2D656C656D656E742D686F7665722D6F75746C696E652D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3435';
wwv_flow_imp.g_varchar2_table(17) := '293B0A20202D2D656C656D656E742D73656C65637465642D6F75746C696E652D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0A20202D2D656C656D656E742D73656C65637465642D6F7574';
wwv_flow_imp.g_varchar2_table(18) := '6C696E652D7365636F6E646172792D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3730293B0A0A20202D2D6C6173736F2D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D626C75652D32';
wwv_flow_imp.g_varchar2_table(19) := '30352D3130302D35302D6F7061636974792D3135293B0A20202D2D6C6173736F2D7374726F6B652D636F6C6F723A20766172282D2D656C656D656E742D73656C65637465642D6F75746C696E652D7374726F6B652D636F6C6F72293B0A0A20202D2D7061';
wwv_flow_imp.g_varchar2_table(20) := '6C657474652D656E7472792D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3135293B0A20202D2D70616C657474652D656E7472792D686F7665722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D';
wwv_flow_imp.g_varchar2_table(21) := '3130302D3435293B0A20202D2D70616C657474652D656E7472792D73656C65637465642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0A20202D2D70616C657474652D736570617261746F722D636F6C6F72';
wwv_flow_imp.g_varchar2_table(22) := '3A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0A20202D2D70616C657474652D746F67676C652D686F7665722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535';
wwv_flow_imp.g_varchar2_table(23) := '293B0A20202D2D70616C657474652D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3937293B0A20202D2D70616C657474652D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(24) := '677265792D3232352D31302D3735293B0A0A20202D2D706F7075702D666F6E742D66616D696C793A202249424D20506C65782053616E73222C2073616E732D73657269663B0A20202D2D706F7075702D666F6E742D73697A653A20313470783B0A20202D';
wwv_flow_imp.g_varchar2_table(25) := '2D706F7075702D6865616465722D656E7472792D73656C65637465642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0A20202D2D706F7075702D6865616465722D666F6E742D7765696768743A20626F6C64';
wwv_flow_imp.g_varchar2_table(26) := '65723B0A20202D2D706F7075702D6865616465722D67726F75702D646976696465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0A20202D2D706F7075702D6261636B67726F756E642D636F6C6F723A2076';
wwv_flow_imp.g_varchar2_table(27) := '6172282D2D636F6C6F722D7768697465293B0A20202D2D706F7075702D626F726465722D636F6C6F723A207472616E73706172656E743B0A20202D2D706F7075702D736861646F772D636F6C6F723A20766172282D2D636F6C6F722D626C61636B2D6F70';
wwv_flow_imp.g_varchar2_table(28) := '61636974792D3330293B0A20202D2D706F7075702D6465736372697074696F6E2D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0A20202D2D706F7075702D6E6F2D726573756C74732D636F6C6F723A20766172';
wwv_flow_imp.g_varchar2_table(29) := '282D2D636F6C6F722D677265792D3232352D31302D3535293B0A20202D2D706F7075702D656E7472792D7469746C652D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3535293B0A20202D2D706F7075702D656E7472792D';
wwv_flow_imp.g_varchar2_table(30) := '686F7665722D636F6C6F723A2020766172282D2D636F6C6F722D677265792D3232352D31302D3935293B0A20202D2D706F7075702D7365617263682D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735';
wwv_flow_imp.g_varchar2_table(31) := '293B0A20202D2D706F7075702D7365617263682D666F6375732D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0A20202D2D706F7075702D7365617263682D666F6375732D6261636B67726F';
wwv_flow_imp.g_varchar2_table(32) := '756E642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3935293B0A0A20202D2D726573697A65722D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3435293B0A20202D2D';
wwv_flow_imp.g_varchar2_table(33) := '726573697A65722D7374726F6B652D636F6C6F723A20766172282D2D63616E7661732D66696C6C2D636F6C6F72293B0A0A20202D2D7365617263682D636F6E7461696E65722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(34) := '677265792D3232352D31302D3937293B0A20202D2D7365617263682D636F6E7461696E65722D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0A20202D2D7365617263682D636F6E7461696E';
wwv_flow_imp.g_varchar2_table(35) := '65722D626F782D736861646F772D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3935293B0A20202D2D7365617263682D636F6E7461696E65722D626F782D736861646F772D696E7365742D636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(36) := '2D2D636F6C6F722D677265792D3232352D31302D3830293B0A20202D2D7365617263682D696E7075742D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0A20202D2D7365617263682D72657375';
wwv_flow_imp.g_varchar2_table(37) := '6C742D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3735293B0A20202D2D7365617263682D726573756C742D686967686C696768742D636F6C6F723A20766172282D2D636F6C6F722D626C61636B293B';
wwv_flow_imp.g_varchar2_table(38) := '0A20202D2D7365617263682D726573756C742D73656C65637465642D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D3330293B0A0A20202D2D73686170652D6174746163682D616C6C6F7765';
wwv_flow_imp.g_varchar2_table(39) := '642D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D3530293B0A20202D2D73686170652D636F6E6E6563742D616C6C6F7765642D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D67726579';
wwv_flow_imp.g_varchar2_table(40) := '2D3232352D31302D3937293B0A20202D2D73686170652D64726F702D616C6C6F7765642D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D677265792D3232352D31302D3937293B0A20202D2D73686170652D64726F702D6E6F742D616C6C6F';
wwv_flow_imp.g_varchar2_table(41) := '7765642D66696C6C2D636F6C6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3937293B0A20202D2D73686170652D726573697A652D707265766965772D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C7565';
wwv_flow_imp.g_varchar2_table(42) := '2D3230352D3130302D3530293B0A0A20202D2D736E61702D6C696E652D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C75652D3230352D3130302D34352D6F7061636974792D3330293B0A0A20202D2D73706163652D746F6F6C2D';
wwv_flow_imp.g_varchar2_table(43) := '63726F7373686169722D7374726F6B652D636F6C6F723A20766172282D2D636F6C6F722D626C61636B293B0A0A20202D2D746F6F6C7469702D6572726F722D6261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D7265642D333630';
wwv_flow_imp.g_varchar2_table(44) := '2D3130302D3937293B0A20202D2D746F6F6C7469702D6572726F722D626F726465722D636F6C6F723A20766172282D2D636F6C6F722D7265642D3336302D3130302D3435293B0A20202D2D746F6F6C7469702D6572726F722D636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(45) := '2D2D636F6C6F722D7265642D3336302D3130302D3435293B0A7D0A0A2F2A2A0A202A206F75746C696E65207374796C65730A202A2F0A0A2E646A732D6F75746C696E652C0A2E646A732D73656C656374696F6E2D6F75746C696E65207B0A202066696C6C';
wwv_flow_imp.g_varchar2_table(46) := '3A206E6F6E653B0A202073686170652D72656E646572696E673A2067656F6D6574726963507265636973696F6E3B0A20207374726F6B652D77696474683A203270783B0A7D0A0A2E646A732D6F75746C696E65207B0A20207669736962696C6974793A20';
wwv_flow_imp.g_varchar2_table(47) := '68696464656E3B0A7D0A0A2E646A732D73656C656374696F6E2D6F75746C696E65207B0A20207374726F6B653A20766172282D2D656C656D656E742D73656C65637465642D6F75746C696E652D7374726F6B652D636F6C6F72293B0A7D0A0A2E646A732D';
wwv_flow_imp.g_varchar2_table(48) := '656C656D656E742E73656C6563746564202E646A732D6F75746C696E65207B0A20207669736962696C6974793A2076697369626C653B0A0A20207374726F6B653A20766172282D2D656C656D656E742D73656C65637465642D6F75746C696E652D737472';
wwv_flow_imp.g_varchar2_table(49) := '6F6B652D636F6C6F72293B0A7D0A0A2E646A732D636F6E6E656374696F6E2E73656C6563746564202E646A732D6F75746C696E65207B0A2020646973706C61793A206E6F6E653B0A7D0A0A2E646A732D6D756C74692D73656C656374202E646A732D656C';
wwv_flow_imp.g_varchar2_table(50) := '656D656E742E73656C6563746564202E646A732D6F75746C696E65207B0A20207374726F6B653A20766172282D2D656C656D656E742D73656C65637465642D6F75746C696E652D7365636F6E646172792D7374726F6B652D636F6C6F72293B0A20206469';
wwv_flow_imp.g_varchar2_table(51) := '73706C61793A20626C6F636B3B0A7D0A0A2E646A732D73686170652E636F6E6E6563742D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0A202066696C6C3A20766172282D2D73686170652D636F6E6E6563742D616C6C';
wwv_flow_imp.g_varchar2_table(52) := '6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0A7D0A0A2E646A732D73686170652E636F6E6E6563742D6E6F742D6F6B202E646A732D76697375616C203E203A6E74682D6368696C642831292C0A2E646A732D73686170652E6472';
wwv_flow_imp.g_varchar2_table(53) := '6F702D6E6F742D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0A202066696C6C3A20766172282D2D73686170652D64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(54) := '0A7D0A0A2E646A732D73686170652E6E65772D706172656E74202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0A202066696C6C3A20766172282D2D73686170652D64726F702D616C6C6F7765642D66696C6C2D636F6C6F7229';
wwv_flow_imp.g_varchar2_table(55) := '2021696D706F7274616E743B0A7D0A0A7376672E64726F702D6E6F742D6F6B207B0A20206261636B67726F756E643A20766172282D2D73686170652D64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(56) := '0A7D0A0A7376672E6E65772D706172656E74207B0A20206261636B67726F756E643A20766172282D2D73686170652D64726F702D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0A7D0A0A0A2F2A204F7665727269646520';
wwv_flow_imp.g_varchar2_table(57) := '6D6F766520637572736F7220647572696E672064726F7020616E6420636F6E6E656374202A2F0A2E64726F702D6E6F742D6F6B2C0A2E636F6E6E6563742D6E6F742D6F6B2C0A2E64726F702D6E6F742D6F6B202A2C0A2E636F6E6E6563742D6E6F742D6F';
wwv_flow_imp.g_varchar2_table(58) := '6B202A207B0A2020637572736F723A206E6F742D616C6C6F7765642021696D706F7274616E743B0A7D0A0A2E64726F702D6F6B2C0A2E636F6E6E6563742D6F6B2C0A2E64726F702D6F6B202A2C0A2E636F6E6E6563742D6F6B202A207B0A202063757273';
wwv_flow_imp.g_varchar2_table(59) := '6F723A2064656661756C742021696D706F7274616E743B0A7D0A0A2E646A732D656C656D656E742E6174746163682D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0A20207374726F6B652D77696474683A2035707820';
wwv_flow_imp.g_varchar2_table(60) := '21696D706F7274616E743B0A20207374726F6B653A20766172282D2D73686170652D6174746163682D616C6C6F7765642D7374726F6B652D636F6C6F72292021696D706F7274616E743B0A7D0A0A2E646A732D6672616D652E636F6E6E6563742D6E6F74';
wwv_flow_imp.g_varchar2_table(61) := '2D6F6B202E646A732D76697375616C203E203A6E74682D6368696C642831292C0A2E646A732D6672616D652E64726F702D6E6F742D6F6B202E646A732D76697375616C203E203A6E74682D6368696C64283129207B0A20207374726F6B652D7769647468';
wwv_flow_imp.g_varchar2_table(62) := '3A203370782021696D706F7274616E743B0A20207374726F6B653A20766172282D2D73686170652D64726F702D6E6F742D616C6C6F7765642D66696C6C2D636F6C6F72292021696D706F7274616E743B0A202066696C6C3A206E6F6E652021696D706F72';
wwv_flow_imp.g_varchar2_table(63) := '74616E743B0A7D0A0A2F2A2A0A2A2053656C656374696F6E20626F78207374796C650A2A0A2A2F0A2E646A732D6C6173736F2D6F7665726C6179207B0A202066696C6C3A20766172282D2D6C6173736F2D66696C6C2D636F6C6F72293B0A20207374726F';
wwv_flow_imp.g_varchar2_table(64) := '6B653A20766172282D2D6C6173736F2D7374726F6B652D636F6C6F72293B0A20207374726F6B652D77696474683A203270783B0A202073686170652D72656E646572696E673A2067656F6D6574726963507265636973696F6E3B0A2020706F696E746572';
wwv_flow_imp.g_varchar2_table(65) := '2D6576656E74733A206E6F6E653B0A7D0A0A2F2A2A0A202A20526573697A65207374796C65730A202A2F0A2E646A732D726573697A652D6F7665726C6179207B0A202066696C6C3A206E6F6E653B0A0A20207374726F6B652D6461736861727261793A20';
wwv_flow_imp.g_varchar2_table(66) := '352031203320313B0A20207374726F6B653A20766172282D2D73686170652D726573697A652D707265766965772D7374726F6B652D636F6C6F72293B0A0A2020706F696E7465722D6576656E74733A206E6F6E653B0A7D0A0A2E646A732D726573697A65';
wwv_flow_imp.g_varchar2_table(67) := '722D686974207B0A202066696C6C3A206E6F6E653B0A2020706F696E7465722D6576656E74733A20616C6C3B0A7D0A0A2E646A732D726573697A65722D76697375616C207B0A202066696C6C3A20766172282D2D726573697A65722D66696C6C2D636F6C';
wwv_flow_imp.g_varchar2_table(68) := '6F72293B0A20207374726F6B652D77696474683A203170783B0A20207374726F6B653A20766172282D2D726573697A65722D7374726F6B652D636F6C6F72293B0A202073686170652D72656E646572696E673A2067656F6D657472696350726563697369';
wwv_flow_imp.g_varchar2_table(69) := '6F6E3B0A7D0A0A2E646A732D726573697A65723A686F766572202E646A732D726573697A65722D76697375616C207B0A20207374726F6B653A20766172282D2D726573697A65722D7374726F6B652D636F6C6F72293B0A20207374726F6B652D6F706163';
wwv_flow_imp.g_varchar2_table(70) := '6974793A20313B0A7D0A0A2E646A732D637572736F722D726573697A652D6E732C0A2E646A732D726573697A65722D6E2C0A2E646A732D726573697A65722D73207B0A2020637572736F723A206E732D726573697A653B0A7D0A0A2E646A732D63757273';
wwv_flow_imp.g_varchar2_table(71) := '6F722D726573697A652D65772C0A2E646A732D726573697A65722D652C0A2E646A732D726573697A65722D77207B0A2020637572736F723A2065772D726573697A653B0A7D0A0A2E646A732D637572736F722D726573697A652D6E7773652C0A2E646A73';
wwv_flow_imp.g_varchar2_table(72) := '2D726573697A65722D6E772C0A2E646A732D726573697A65722D7365207B0A2020637572736F723A206E7773652D726573697A653B0A7D0A0A2E646A732D637572736F722D726573697A652D6E6573772C0A2E646A732D726573697A65722D6E652C0A2E';
wwv_flow_imp.g_varchar2_table(73) := '646A732D726573697A65722D7377207B0A2020637572736F723A206E6573772D726573697A653B0A7D0A0A2E646A732D73686170652E646A732D726573697A696E67203E202E646A732D6F75746C696E65207B0A20207669736962696C6974793A206869';
wwv_flow_imp.g_varchar2_table(74) := '6464656E2021696D706F7274616E743B0A7D0A0A2E646A732D73686170652E646A732D726573697A696E67203E202E646A732D726573697A6572207B0A20207669736962696C6974793A2068696464656E3B0A7D0A0A2E646A732D64726167676572203E';
wwv_flow_imp.g_varchar2_table(75) := '202E646A732D726573697A6572207B0A20207669736962696C6974793A2068696464656E3B0A7D0A0A2F2A2A0A202A2064726167207374796C65730A202A2F0A2E646A732D64726167676572202A207B0A202066696C6C3A206E6F6E652021696D706F72';
wwv_flow_imp.g_varchar2_table(76) := '74616E743B0A20207374726F6B653A20766172282D2D656C656D656E742D647261676765722D636F6C6F72292021696D706F7274616E743B0A7D0A0A2E646A732D6472616767657220747370616E2C0A2E646A732D647261676765722074657874207B0A';
wwv_flow_imp.g_varchar2_table(77) := '202066696C6C3A20766172282D2D656C656D656E742D647261676765722D636F6C6F72292021696D706F7274616E743B0A20207374726F6B653A206E6F6E652021696D706F7274616E743B0A7D0A0A2E646A732D64726167676572206D61726B65722063';
wwv_flow_imp.g_varchar2_table(78) := '6972636C652C0A2E646A732D64726167676572206D61726B657220706174682C0A2E646A732D64726167676572206D61726B657220706F6C79676F6E2C0A2E646A732D64726167676572206D61726B657220706F6C796C696E652C0A2E646A732D647261';
wwv_flow_imp.g_varchar2_table(79) := '67676572206D61726B65722072656374207B0A202066696C6C3A20766172282D2D656C656D656E742D647261676765722D636F6C6F72292021696D706F7274616E743B0A20207374726F6B653A206E6F6E652021696D706F7274616E743B0A7D0A0A2E64';
wwv_flow_imp.g_varchar2_table(80) := '6A732D64726167676572206D61726B657220746578742C0A2E646A732D64726167676572206D61726B657220747370616E207B0A202066696C6C3A206E6F6E652021696D706F7274616E743B0A20207374726F6B653A20766172282D2D656C656D656E74';
wwv_flow_imp.g_varchar2_table(81) := '2D647261676765722D636F6C6F72292021696D706F7274616E743B0A7D0A0A2E646A732D6472616767696E672C0A2E646A732D6472616767696E67203E202A207B0A20206F7061636974793A20302E332021696D706F7274616E743B0A2020706F696E74';
wwv_flow_imp.g_varchar2_table(82) := '65722D6576656E74733A206E6F6E652021696D706F7274616E743B0A7D0A0A2F2A2A0A202A206E6F20706F696E746572206576656E747320666F722076697375616C0A202A2F0A2E646A732D76697375616C2C0A2E646A732D6F75746C696E65207B0A20';
wwv_flow_imp.g_varchar2_table(83) := '20706F696E7465722D6576656E74733A206E6F6E653B0A7D0A0A2E646A732D656C656D656E742E6174746163682D6F6B202E646A732D686974207B0A20207374726F6B652D77696474683A20363070782021696D706F7274616E743B0A7D0A0A2F2A2A0A';
wwv_flow_imp.g_varchar2_table(84) := '202A20616C6C20706F696E746572206576656E747320666F72206869742073686170650A202A2F0A2E646A732D656C656D656E74203E202E646A732D6869742D616C6C2C0A2E646A732D656C656D656E74203E202E646A732D6869742D6E6F2D6D6F7665';
wwv_flow_imp.g_varchar2_table(85) := '207B0A2020706F696E7465722D6576656E74733A20616C6C3B0A7D0A0A2E646A732D656C656D656E74203E202E646A732D6869742D7374726F6B652C0A2E646A732D656C656D656E74203E202E646A732D6869742D636C69636B2D7374726F6B65207B0A';
wwv_flow_imp.g_varchar2_table(86) := '2020706F696E7465722D6576656E74733A207374726F6B653B0A7D0A0A2F2A2A0A202A207368617065202F20636F6E6E656374696F6E206261736963207374796C65730A202A2F0A2E646A732D636F6E6E656374696F6E202E646A732D76697375616C20';
wwv_flow_imp.g_varchar2_table(87) := '7B0A20207374726F6B652D77696474683A203270783B0A202066696C6C3A206E6F6E653B0A7D0A0A2E646A732D637572736F722D67726162207B0A2020637572736F723A202D7765626B69742D677261623B0A2020637572736F723A202D6D6F7A2D6772';
wwv_flow_imp.g_varchar2_table(88) := '61623B0A2020637572736F723A20677261623B0A7D0A0A2E646A732D637572736F722D6772616262696E67207B0A2020637572736F723A202D7765626B69742D6772616262696E673B0A2020637572736F723A202D6D6F7A2D6772616262696E673B0A20';
wwv_flow_imp.g_varchar2_table(89) := '20637572736F723A206772616262696E673B0A7D0A0A2E646A732D637572736F722D63726F737368616972207B0A2020637572736F723A2063726F7373686169723B0A7D0A0A2E646A732D637572736F722D6D6F7665207B0A2020637572736F723A206D';
wwv_flow_imp.g_varchar2_table(90) := '6F76653B0A7D0A0A2E646A732D637572736F722D726573697A652D6E73207B0A2020637572736F723A206E732D726573697A653B0A7D0A0A2E646A732D637572736F722D726573697A652D6577207B0A2020637572736F723A2065772D726573697A653B';
wwv_flow_imp.g_varchar2_table(91) := '0A7D0A0A0A2F2A2A0A202A20736E617070696E670A202A2F0A2E646A732D736E61702D6C696E65207B0A20207374726F6B653A20766172282D2D736E61702D6C696E652D7374726F6B652D636F6C6F72293B0A20207374726F6B652D6C696E656361703A';
wwv_flow_imp.g_varchar2_table(92) := '20726F756E643B0A20207374726F6B652D77696474683A203270783B0A2020706F696E7465722D6576656E74733A206E6F6E653B0A7D0A0A2F2A2A0A202A20736E617070696E670A202A2F0A2E646A732D63726F737368616972207B0A20207374726F6B';
wwv_flow_imp.g_varchar2_table(93) := '653A20766172282D2D73706163652D746F6F6C2D63726F7373686169722D7374726F6B652D636F6C6F72293B0A20207374726F6B652D6C696E656361703A20726F756E643B0A20207374726F6B652D77696474683A203170783B0A2020706F696E746572';
wwv_flow_imp.g_varchar2_table(94) := '2D6576656E74733A206E6F6E653B0A202073686170652D72656E646572696E673A2067656F6D6574726963507265636973696F6E3B0A20207374726F6B652D6461736861727261793A20352C20353B0A7D0A0A2F2A2A0A202A2070616C657474650A202A';
wwv_flow_imp.g_varchar2_table(95) := '2F0A0A2E646A732D70616C65747465207B0A2020706F736974696F6E3A206162736F6C7574653B0A20206C6566743A20323070783B0A2020746F703A20323070783B0A0A2020626F782D73697A696E673A20626F726465722D626F783B0A202077696474';
wwv_flow_imp.g_varchar2_table(96) := '683A20343870783B0A7D0A0A2E646A732D70616C65747465202E736570617261746F72207B0A20206D617267696E3A203570783B0A202070616464696E672D746F703A203570783B0A0A2020626F726465723A206E6F6E653B0A2020626F726465722D62';
wwv_flow_imp.g_varchar2_table(97) := '6F74746F6D3A20736F6C69642031707820766172282D2D70616C657474652D736570617261746F722D636F6C6F72293B0A0A2020636C6561723A20626F74683B0A7D0A0A2E646A732D70616C65747465202E656E7472793A6265666F7265207B0A202076';
wwv_flow_imp.g_varchar2_table(98) := '6572746963616C2D616C69676E3A20696E697469616C3B0A7D0A0A2E646A732D70616C65747465202E646A732D70616C657474652D746F67676C65207B0A2020637572736F723A20706F696E7465723B0A7D0A0A2E646A732D70616C65747465202E656E';
wwv_flow_imp.g_varchar2_table(99) := '7472792C0A2E646A732D70616C65747465202E646A732D70616C657474652D746F67676C65207B0A2020636F6C6F723A20766172282D2D70616C657474652D656E7472792D636F6C6F72293B0A2020666F6E742D73697A653A20333070783B0A0A202074';
wwv_flow_imp.g_varchar2_table(100) := '6578742D616C69676E3A2063656E7465723B0A7D0A0A2E646A732D70616C65747465202E656E747279207B0A2020666C6F61743A206C6566743B0A7D0A0A2E646A732D70616C65747465202E656E74727920696D67207B0A20206D61782D77696474683A';
wwv_flow_imp.g_varchar2_table(101) := '20313030253B0A7D0A0A2E646A732D70616C65747465202E646A732D70616C657474652D656E74726965733A6166746572207B0A2020636F6E74656E743A2027273B0A2020646973706C61793A207461626C653B0A2020636C6561723A20626F74683B0A';
wwv_flow_imp.g_varchar2_table(102) := '7D0A0A2E646A732D70616C65747465202E646A732D70616C657474652D746F67676C653A686F766572207B0A20206261636B67726F756E643A20766172282D2D70616C657474652D746F67676C652D686F7665722D6261636B67726F756E642D636F6C6F';
wwv_flow_imp.g_varchar2_table(103) := '72293B0A7D0A0A2E646A732D70616C65747465202E656E7472793A686F766572207B0A2020636F6C6F723A20766172282D2D70616C657474652D656E7472792D686F7665722D636F6C6F72293B0A7D0A0A2E646A732D70616C65747465202E686967686C';
wwv_flow_imp.g_varchar2_table(104) := '6967687465642D656E747279207B0A2020636F6C6F723A20766172282D2D70616C657474652D656E7472792D73656C65637465642D636F6C6F72292021696D706F7274616E743B0A7D0A0A2E646A732D70616C65747465202E656E7472792C0A2E646A73';
wwv_flow_imp.g_varchar2_table(105) := '2D70616C65747465202E646A732D70616C657474652D746F67676C65207B0A202077696474683A20343670783B0A20206865696768743A20343670783B0A20206C696E652D6865696768743A20343670783B0A2020637572736F723A2064656661756C74';
wwv_flow_imp.g_varchar2_table(106) := '3B0A7D0A0A2F2A2A0A202A2050616C65747465206F70656E202F2074776F2D636F6C756D6E206C61796F757420697320636F6E74726F6C6C6564207669610A202A20636C6173736573206F6E207468652070616C657474652E204576656E747320746F20';
wwv_flow_imp.g_varchar2_table(107) := '686F6F6B20696E746F2070616C657474650A202A206368616E676564206C6966652D6379636C652061726520617661696C61626C6520696E206164646974696F6E2E0A202A2F0A2E646A732D70616C657474652E74776F2D636F6C756D6E2E6F70656E20';
wwv_flow_imp.g_varchar2_table(108) := '7B0A202077696474683A20393470783B0A7D0A0A2E646A732D70616C657474653A6E6F74282E6F70656E29202E646A732D70616C657474652D656E7472696573207B0A2020646973706C61793A206E6F6E653B0A7D0A0A2E646A732D70616C657474653A';
wwv_flow_imp.g_varchar2_table(109) := '6E6F74282E6F70656E29207B0A20206F766572666C6F773A2068696464656E3B0A7D0A0A2E646A732D70616C657474652E6F70656E202E646A732D70616C657474652D746F67676C65207B0A2020646973706C61793A206E6F6E653B0A7D0A0A2F2A2A0A';
wwv_flow_imp.g_varchar2_table(110) := '202A20636F6E746578742D7061640A202A2F0A2E646A732D636F6E746578742D706164207B0A2020706F736974696F6E3A206162736F6C7574653B0A2020646973706C61793A206E6F6E653B0A2020706F696E7465722D6576656E74733A206E6F6E653B';
wwv_flow_imp.g_varchar2_table(111) := '0A20206C696E652D6865696768743A20313B0A202077696474683A20373270783B0A20207A2D696E6465783A203130303B0A7D0A0A2E646A732D636F6E746578742D706164202E656E747279207B0A202077696474683A20323270783B0A202068656967';
wwv_flow_imp.g_varchar2_table(112) := '68743A20323270783B0A2020746578742D616C69676E3A2063656E7465723B0A2020646973706C61793A20696E6C696E652D626C6F636B3B0A2020666F6E742D73697A653A20323270783B0A20206D617267696E3A2030203270782032707820303B0A0A';
wwv_flow_imp.g_varchar2_table(113) := '2020626F726465722D7261646975733A203370783B0A0A2020637572736F723A2064656661756C743B0A0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6E746578742D7061642D656E7472792D6261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(114) := '6C6F72293B0A2020626F782D736861646F773A20302030203270782031707820766172282D2D636F6E746578742D7061642D656E7472792D6261636B67726F756E642D636F6C6F72293B0A2020706F696E7465722D6576656E74733A20616C6C3B0A2020';
wwv_flow_imp.g_varchar2_table(115) := '766572746963616C2D616C69676E3A206D6964646C653B0A7D0A0A2E646A732D636F6E746578742D706164202E656E7472793A686F766572207B0A20206261636B67726F756E643A20766172282D2D636F6E746578742D7061642D656E7472792D686F76';
wwv_flow_imp.g_varchar2_table(116) := '65722D6261636B67726F756E642D636F6C6F72293B0A7D0A0A2E646A732D636F6E746578742D7061642E6F70656E207B0A2020646973706C61793A20626C6F636B3B0A7D0A0A2F2A2A0A202A20706F707570207374796C65730A202A2F0A2E646A732D70';
wwv_flow_imp.g_varchar2_table(117) := '6F707570207B0A20206C696E652D6865696768743A20313B0A2020626F782D73697A696E673A20626F726465722D626F783B0A202077696474683A206D696E2D636F6E74656E743B0A20206261636B67726F756E643A20766172282D2D706F7075702D62';
wwv_flow_imp.g_varchar2_table(118) := '61636B67726F756E642D636F6C6F72293B0A20206F766572666C6F773A2068696464656E3B0A2020706F736974696F6E3A2066697865643B0A20207A2D696E6465783A203230303B0A2020626F782D736861646F773A2030707820327078203670782076';
wwv_flow_imp.g_varchar2_table(119) := '6172282D2D706F7075702D736861646F772D636F6C6F72293B0A2020626F726465723A20736F6C69642031707820766172282D2D706F7075702D626F726465722D636F6C6F72293B0A20206D696E2D77696474683A2031323070783B0A20206F75746C69';
wwv_flow_imp.g_varchar2_table(120) := '6E653A206E6F6E653B0A2020666F6E742D73697A653A20766172282D2D706F7075702D666F6E742D73697A65293B0A2020666F6E742D66616D696C793A20766172282D2D706F7075702D666F6E742D66616D696C79293B0A7D0A0A2E646A732D706F7075';
wwv_flow_imp.g_varchar2_table(121) := '702D73656172636820696E707574207B0A202077696474683A20313030253B0A2020626F782D73697A696E673A20626F726465722D626F783B0A2020666F6E742D73697A653A20766172282D2D706F7075702D666F6E742D73697A65293B0A2020706164';
wwv_flow_imp.g_varchar2_table(122) := '64696E673A20337078203670783B0A2020626F726465722D7261646975733A203270783B0A2020626F726465723A20736F6C69642031707820766172282D2D706F7075702D7365617263682D626F726465722D636F6C6F72293B0A20206C696E652D6865';
wwv_flow_imp.g_varchar2_table(123) := '696768743A20323170783B0A7D0A0A2E646A732D706F7075702D73656172636820696E7075743A666F637573207B0A20206261636B67726F756E642D636F6C6F723A20766172282D2D706F7075702D7365617263682D666F6375732D6261636B67726F75';
wwv_flow_imp.g_varchar2_table(124) := '6E642D636F6C6F72293B0A2020626F726465723A20736F6C69642031707820766172282D2D706F7075702D7365617263682D666F6375732D626F726465722D636F6C6F72293B0A20206F75746C696E653A206E6F6E653B0A7D0A0A2E646A732D706F7075';
wwv_flow_imp.g_varchar2_table(125) := '702D686561646572207B0A2020646973706C61793A20666C65783B0A2020616C69676E2D6974656D733A20737472657463683B0A20206C696E652D6865696768743A20323070783B0A20206D617267696E3A203130707820313270782031307078203132';
wwv_flow_imp.g_varchar2_table(126) := '70783B0A7D0A0A2E646A732D706F7075702D686561646572202E656E747279207B0A2020626F726465722D7261646975733A203270783B0A7D0A0A2E646A732D706F70757020627574746F6E2E656E747279207B0A202070616464696E673A20303B0A20';
wwv_flow_imp.g_varchar2_table(127) := '206261636B67726F756E643A207472616E73706172656E743B0A2020626F726465723A20303B0A7D0A0A2E646A732D706F7075702D686561646572202E656E7472792E616374697665207B0A2020636F6C6F723A20766172282D2D706F7075702D686561';
wwv_flow_imp.g_varchar2_table(128) := '6465722D656E7472792D73656C65637465642D636F6C6F72293B0A7D0A0A2E646A732D706F7075702D686561646572202E656E7472792E64697361626C6564207B0A2020636F6C6F723A20696E68657269743B0A7D0A0A2E646A732D706F7075702D6865';
wwv_flow_imp.g_varchar2_table(129) := '616465722D67726F7570207B0A2020646973706C61793A20666C65783B0A2020666C65782D646972656374696F6E3A20726F773B0A2020616C69676E2D6974656D733A2063656E7465723B0A20206C6973742D7374796C653A206E6F6E653B0A20206D61';
wwv_flow_imp.g_varchar2_table(130) := '7267696E3A20303B0A202070616464696E673A20303B0A7D0A0A2E646A732D706F7075702D6865616465722D67726F7570202E656E747279207B0A2020646973706C61793A20666C65783B0A2020666C65782D646972656374696F6E3A20726F773B0A20';
wwv_flow_imp.g_varchar2_table(131) := '20616C69676E2D6974656D733A2063656E7465723B0A7D0A0A2E646A732D706F7075702D6865616465722D67726F7570202B202E646A732D706F7075702D6865616465722D67726F75703A6265666F7265207B0A2020636F6E74656E743A2027273B0A20';
wwv_flow_imp.g_varchar2_table(132) := '2077696474683A203170783B0A20206865696768743A20323070783B0A20206261636B67726F756E643A20766172282D2D706F7075702D6865616465722D67726F75702D646976696465722D636F6C6F72293B0A20206D617267696E3A2030203570783B';
wwv_flow_imp.g_varchar2_table(133) := '0A7D0A0A2E646A732D706F7075702D736561726368207B0A20206D617267696E3A203130707820313270783B0A7D0A0A2E646A732D706F7075702D7469746C65207B0A2020666F6E742D73697A653A20766172282D2D706F7075702D666F6E742D73697A';
wwv_flow_imp.g_varchar2_table(134) := '65293B0A2020666F6E742D7765696768743A20766172282D2D706F7075702D6865616465722D666F6E742D776569676874293B0A2020666C65783A20313B0A20206D617267696E3A20303B0A7D0A0A2E646A732D706F7075702D736561726368207B0A20';
wwv_flow_imp.g_varchar2_table(135) := '20706F736974696F6E3A2072656C61746976653B0A202077696474683A206175746F3B0A7D0A0A2E646A732D706F7075702D7365617263682D69636F6E207B0A2020706F736974696F6E3A206162736F6C7574653B0A20206C6566743A203870783B0A20';
wwv_flow_imp.g_varchar2_table(136) := '20746F703A203770783B0A7D0A0A2E646A732D706F7075702D73656172636820696E707574207B0A202070616464696E672D6C6566743A20323570783B0A7D0A0A2E646A732D706F7075702D726573756C7473207B0A20206D617267696E3A2037707820';
wwv_flow_imp.g_varchar2_table(137) := '3370782037707820313270783B0A20206C6973742D7374796C653A206E6F6E653B0A20206D61782D6865696768743A2032383070783B0A20206F766572666C6F773A206175746F3B0A202070616464696E672D72696768743A203970783B0A7D0A0A2E64';
wwv_flow_imp.g_varchar2_table(138) := '6A732D706F7075702D67726F7570207B0A20206D617267696E3A20303B0A202070616464696E673A20303B0A202077696474683A20313030253B0A7D0A0A2E646A732D706F7075702D626F6479202E656E7472792C0A2E646A732D706F7075702D626F64';
wwv_flow_imp.g_varchar2_table(139) := '79202E656E7472792D686561646572207B0A202070616464696E673A20357078203770783B0A2020637572736F723A2064656661756C743B0A2020626F726465722D7261646975733A203470783B0A7D0A0A2E646A732D706F7075702D626F6479202E65';
wwv_flow_imp.g_varchar2_table(140) := '6E7472792D686561646572207B0A2020666F6E742D7765696768743A20766172282D2D706F7075702D6865616465722D666F6E742D776569676874293B0A2020636F6C6F723A20766172282D2D706F7075702D656E7472792D7469746C652D636F6C6F72';
wwv_flow_imp.g_varchar2_table(141) := '293B0A202070616464696E672D6C6566743A20303B0A7D0A0A2E646A732D706F707570205B636C6173732A3D2269636F6E225D202E646A732D706F7075702D6C6162656C2C0A2E646A732D706F7075702D6C6162656C3A6E6F74283A66697273742D6368';
wwv_flow_imp.g_varchar2_table(142) := '696C6429207B0A20206D617267696E2D6C6566743A202E35656D3B0A7D0A0A2E646A732D706F707570205B636C6173732A3D2269636F6E225D3A6265666F72652C0A2E646A732D706F7075702D656E7472792D69636F6E207B0A202077696474683A2031';
wwv_flow_imp.g_varchar2_table(143) := '656D3B0A20206865696768743A2031656D3B0A2020646973706C61793A20696E6C696E652D626C6F636B3B0A2020666F6E742D73697A653A20312E34656D3B0A2020766572746963616C2D616C69676E3A206D6964646C653B0A7D0A0A2E646A732D706F';
wwv_flow_imp.g_varchar2_table(144) := '7075702D626F6479202E656E7472792D6865616465723A6E6F74283A66697273742D6368696C6429207B0A20206D617267696E2D746F703A203870783B0A20206D617267696E2D626F74746F6D3A203270783B0A7D0A0A2E646A732D706F7075702D626F';
wwv_flow_imp.g_varchar2_table(145) := '6479202E656E747279207B0A2020646973706C61793A20666C65783B0A2020666C65782D646972656374696F6E3A20726F773B0A2020616C69676E2D6974656D733A20737472657463683B0A20206865696768743A206D696E2D636F6E74656E743B0A7D';
wwv_flow_imp.g_varchar2_table(146) := '0A0A2E646A732D706F707570202E656E7472792E73656C6563746564207B0A20206261636B67726F756E642D636F6C6F723A20766172282D2D706F7075702D656E7472792D686F7665722D636F6C6F72293B0A7D0A0A2E646A732D706F7075702D626F64';
wwv_flow_imp.g_varchar2_table(147) := '79202E656E7472793A6E6F74283A66697273742D6368696C6429207B0A20206D617267696E2D746F703A203270783B0A7D0A0A2E646A732D706F7075702D656E7472792D636F6E74656E74207B0A2020646973706C61793A20666C65783B0A2020666C65';
wwv_flow_imp.g_varchar2_table(148) := '782D646972656374696F6E3A20636F6C756D6E3B0A2020666C65783A20313B0A20206F766572666C6F773A2068696464656E3B0A7D0A0A2E646A732D706F7075702D656E7472792D6465736372697074696F6E207B0A2020636F6C6F723A20766172282D';
wwv_flow_imp.g_varchar2_table(149) := '2D706F7075702D6465736372697074696F6E2D636F6C6F72293B0A7D0A0A2E646A732D706F7075702D6C6162656C2C0A2E646A732D706F7075702D656E7472792D6465736372697074696F6E207B0A20206C696E652D6865696768743A20312E34656D3B';
wwv_flow_imp.g_varchar2_table(150) := '0A7D0A0A2E646A732D706F707570202E656E7472792C0A2E646A732D706F707570202E656E7472792D686561646572207B0A20206D617267696E3A203170783B0A7D0A0A2E646A732D706F7075702D7469746C652C0A2E646A732D706F7075702D6C6162';
wwv_flow_imp.g_varchar2_table(151) := '656C2C0A2E646A732D706F7075702D656E7472792D6465736372697074696F6E2C0A2E646A732D706F707570202E656E7472792D686561646572207B0A20206F766572666C6F773A2068696464656E3B0A2020746578742D6F766572666C6F773A20656C';
wwv_flow_imp.g_varchar2_table(152) := '6C69707369733B0A202077686974652D73706163653A206E6F777261703B0A7D0A0A2E646A732D706F7075702D656E7472792D6E616D65207B0A2020646973706C61793A20666C65783B0A7D0A0A2E646A732D706F7075702D626F6479207B0A2020666C';
wwv_flow_imp.g_varchar2_table(153) := '65782D646972656374696F6E3A20636F6C756D6E3B0A202077696474683A206175746F3B0A7D0A0A2E646A732D706F707570202A3A3A2D7765626B69742D7363726F6C6C626172207B0A202077696474683A203670783B0A7D0A0A2E646A732D706F7075';
wwv_flow_imp.g_varchar2_table(154) := '70202A3A3A2D7765626B69742D7363726F6C6C6261722D7468756D62207B0A2020626F726465722D7261646975733A203370783B0A20206261636B67726F756E642D636F6C6F723A207267626128302C20302C20302C20302E32293B0A7D0A0A2E646A73';
wwv_flow_imp.g_varchar2_table(155) := '2D706F707570202A3A3A2D7765626B69742D7363726F6C6C6261722D747261636B207B0A2020626F782D736861646F773A206E6F6E653B0A20206261636B67726F756E643A207472616E73706172656E743B0A20206D617267696E3A20303B0A20207061';
wwv_flow_imp.g_varchar2_table(156) := '6464696E673A203570783B0A7D0A0A2E646A732D706F7075702D6E6F2D726573756C7473207B0A202070616464696E673A20302031327078203132707820313270783B0A2020636F6C6F723A20766172282D2D706F7075702D6E6F2D726573756C74732D';
wwv_flow_imp.g_varchar2_table(157) := '636F6C6F72293B0A7D0A0A2E646A732D706F7075702D656E7472792D646F6373207B0A2020666C65783A20303B0A2020666C65782D646972656374696F6E3A20726F773B0A2020616C69676E2D6974656D733A2063656E7465723B0A202070616464696E';
wwv_flow_imp.g_varchar2_table(158) := '672D6C6566743A203570783B0A2020646973706C61793A206E6F6E653B0A7D0A0A2E646A732D706F7075702D626F6479202E656E7472793A686F766572202E646A732D706F7075702D656E7472792D646F6373207B0A2020646973706C61793A20666C65';
wwv_flow_imp.g_varchar2_table(159) := '783B0A7D0A0A2E646A732D706F7075702D656E7472792D646F637320737667207B0A2020766572746963616C2D616C69676E3A206D6964646C653B0A20206D617267696E3A206175746F20327078206175746F203570783B0A7D0A0A2F2A2A0A202A2020';
wwv_flow_imp.g_varchar2_table(160) := '70616C65747465207374796C65730A202A2F0A2E646A732D70616C65747465207B0A20206261636B67726F756E643A20766172282D2D70616C657474652D6261636B67726F756E642D636F6C6F72293B0A2020626F726465723A20736F6C696420317078';
wwv_flow_imp.g_varchar2_table(161) := '20766172282D2D70616C657474652D626F726465722D636F6C6F72293B0A2020626F726465722D7261646975733A203270783B0A7D0A0A2F2A2A0A202A2062656E64706F696E74730A202A2F0A2E646A732D7365676D656E742D647261676765722C0A2E';
wwv_flow_imp.g_varchar2_table(162) := '646A732D62656E64706F696E74207B0A2020646973706C61793A206E6F6E653B0A7D0A0A2E646A732D7365676D656E742D64726167676572202E646A732D76697375616C207B0A2020646973706C61793A206E6F6E653B0A0A202066696C6C3A20766172';
wwv_flow_imp.g_varchar2_table(163) := '282D2D62656E64706F696E742D66696C6C2D636F6C6F72293B0A20207374726F6B653A20766172282D2D62656E64706F696E742D7374726F6B652D636F6C6F72293B0A20207374726F6B652D77696474683A203170783B0A20207374726F6B652D6F7061';
wwv_flow_imp.g_varchar2_table(164) := '636974793A20313B0A7D0A0A2E646A732D7365676D656E742D647261676765723A686F766572202E646A732D76697375616C207B0A2020646973706C61793A20626C6F636B3B0A7D0A0A2E646A732D62656E64706F696E74202E646A732D76697375616C';
wwv_flow_imp.g_varchar2_table(165) := '207B0A202066696C6C3A20766172282D2D62656E64706F696E742D66696C6C2D636F6C6F72293B0A20207374726F6B653A20766172282D2D62656E64706F696E742D7374726F6B652D636F6C6F72293B0A20207374726F6B652D77696474683A20317078';
wwv_flow_imp.g_varchar2_table(166) := '3B0A7D0A0A2E646A732D7365676D656E742D647261676765723A686F7665722C0A2E646A732D62656E64706F696E74732E686F766572202E646A732D7365676D656E742D647261676765722C0A2E646A732D62656E64706F696E74732E73656C65637465';
wwv_flow_imp.g_varchar2_table(167) := '64202E646A732D7365676D656E742D647261676765722C0A2E646A732D62656E64706F696E743A686F7665722C0A2E646A732D62656E64706F696E74732E686F766572202E646A732D62656E64706F696E742C0A2E646A732D62656E64706F696E74732E';
wwv_flow_imp.g_varchar2_table(168) := '73656C6563746564202E646A732D62656E64706F696E74207B0A2020646973706C61793A20626C6F636B3B0A7D0A0A2E646A732D647261672D616374697665202E646A732D62656E64706F696E7473202A207B0A2020646973706C61793A206E6F6E653B';
wwv_flow_imp.g_varchar2_table(169) := '0A7D0A0A2E646A732D62656E64706F696E74733A6E6F74282E686F76657229202E666C6F6174696E67207B0A2020646973706C61793A206E6F6E653B0A7D0A0A2E646A732D7365676D656E742D647261676765723A686F766572202E646A732D76697375';
wwv_flow_imp.g_varchar2_table(170) := '616C2C0A2E646A732D7365676D656E742D647261676765722E646A732D6472616767696E67202E646A732D76697375616C2C0A2E646A732D62656E64706F696E743A686F766572202E646A732D76697375616C2C0A2E646A732D62656E64706F696E742E';
wwv_flow_imp.g_varchar2_table(171) := '666C6F6174696E67202E646A732D76697375616C207B0A202066696C6C3A20766172282D2D62656E64706F696E742D66696C6C2D636F6C6F72293B0A20207374726F6B653A20766172282D2D62656E64706F696E742D7374726F6B652D636F6C6F72293B';
wwv_flow_imp.g_varchar2_table(172) := '0A20207374726F6B652D6F7061636974793A20313B0A7D0A0A2E646A732D62656E64706F696E742E666C6F6174696E67202E646A732D686974207B0A2020706F696E7465722D6576656E74733A206E6F6E653B0A7D0A0A2E646A732D7365676D656E742D';
wwv_flow_imp.g_varchar2_table(173) := '64726167676572202E646A732D6869742C0A2E646A732D62656E64706F696E74202E646A732D686974207B0A202066696C6C3A206E6F6E653B0A2020706F696E7465722D6576656E74733A20616C6C3B0A7D0A0A2E646A732D7365676D656E742D647261';
wwv_flow_imp.g_varchar2_table(174) := '676765722E686F72697A6F6E74616C202E646A732D686974207B0A2020637572736F723A206E732D726573697A653B0A7D0A0A2E646A732D7365676D656E742D647261676765722E766572746963616C202E646A732D686974207B0A2020637572736F72';
wwv_flow_imp.g_varchar2_table(175) := '3A2065772D726573697A653B0A7D0A0A2E646A732D7365676D656E742D647261676765722E646A732D6472616767696E67202E646A732D686974207B0A2020706F696E7465722D6576656E74733A206E6F6E653B0A7D0A0A2E646A732D7570646174696E';
wwv_flow_imp.g_varchar2_table(176) := '672C0A2E646A732D7570646174696E67203E202A207B0A2020706F696E7465722D6576656E74733A206E6F6E652021696D706F7274616E743B0A7D0A0A2E646A732D7570646174696E67202E646A732D636F6E746578742D7061642C0A2E646A732D7570';
wwv_flow_imp.g_varchar2_table(177) := '646174696E67202E646A732D6F75746C696E652C0A2E646A732D7570646174696E67202E646A732D62656E64706F696E742C0A2E646A732D6D756C74692D73656C656374202E646A732D62656E64706F696E742C0A2E646A732D6D756C74692D73656C65';
wwv_flow_imp.g_varchar2_table(178) := '6374202E646A732D7365676D656E742D647261676765722C0A2E636F6E6E6563742D6F6B202E646A732D62656E64706F696E742C0A2E636F6E6E6563742D6E6F742D6F6B202E646A732D62656E64706F696E742C0A2E64726F702D6F6B202E646A732D62';
wwv_flow_imp.g_varchar2_table(179) := '656E64706F696E742C0A2E64726F702D6E6F742D6F6B202E646A732D62656E64706F696E74207B0A2020646973706C61793A206E6F6E652021696D706F7274616E743B0A7D0A0A2E646A732D7365676D656E742D647261676765722E646A732D64726167';
wwv_flow_imp.g_varchar2_table(180) := '67696E672C0A2E646A732D62656E64706F696E742E646A732D6472616767696E67207B0A2020646973706C61793A20626C6F636B3B0A20206F7061636974793A20312E303B0A7D0A0A0A2F2A2A0A202A20746F6F6C746970730A202A2F0A2E646A732D74';
wwv_flow_imp.g_varchar2_table(181) := '6F6F6C7469702D6572726F72207B0A202077696474683A2031363070783B0A202070616464696E673A203670783B0A0A20206261636B67726F756E643A20766172282D2D746F6F6C7469702D6572726F722D6261636B67726F756E642D636F6C6F72293B';
wwv_flow_imp.g_varchar2_table(182) := '0A2020626F726465723A20736F6C69642031707820766172282D2D746F6F6C7469702D6572726F722D626F726465722D636F6C6F72293B0A2020626F726465722D7261646975733A203270783B0A2020636F6C6F723A20766172282D2D746F6F6C746970';
wwv_flow_imp.g_varchar2_table(183) := '2D6572726F722D636F6C6F72293B0A2020666F6E742D73697A653A20313270783B0A20206C696E652D6865696768743A20313670783B0A0A20206F7061636974793A20302E37353B0A7D0A0A2E646A732D746F6F6C7469702D6572726F723A686F766572';
wwv_flow_imp.g_varchar2_table(184) := '207B0A20206F7061636974793A20313B0A7D0A0A0A2F2A2A0A202A20736561726368207061640A202A2F0A2E646A732D7365617263682D636F6E7461696E6572207B0A2020706F736974696F6E3A206162736F6C7574653B0A2020746F703A2032307078';
wwv_flow_imp.g_varchar2_table(185) := '3B0A20206C6566743A20303B0A202072696768743A20303B0A20206D617267696E2D6C6566743A206175746F3B0A20206D617267696E2D72696768743A206175746F3B0A0A202077696474683A203235253B0A20206D696E2D77696474683A2033303070';
wwv_flow_imp.g_varchar2_table(186) := '783B0A20206D61782D77696474683A2034303070783B0A20207A2D696E6465783A2031303B0A0A2020666F6E742D73697A653A20312E3035656D3B0A20206F7061636974793A20302E393B0A20206261636B67726F756E643A20766172282D2D73656172';
wwv_flow_imp.g_varchar2_table(187) := '63682D636F6E7461696E65722D6261636B67726F756E642D636F6C6F72293B0A2020626F726465723A20736F6C69642031707820766172282D2D7365617263682D636F6E7461696E65722D626F726465722D636F6C6F72293B0A2020626F726465722D72';
wwv_flow_imp.g_varchar2_table(188) := '61646975733A203270783B0A2020626F782D736861646F773A2030203020302032707820766172282D2D7365617263682D636F6E7461696E65722D626F782D736861646F772D636F6C6F72292C2030203020302031707820766172282D2D736561726368';
wwv_flow_imp.g_varchar2_table(189) := '2D636F6E7461696E65722D626F782D736861646F772D696E7365742D636F6C6F722920696E7365743B0A7D0A0A2E646A732D7365617263682D636F6E7461696E65723A6E6F74282E6F70656E29207B0A2020646973706C61793A206E6F6E653B0A7D0A0A';
wwv_flow_imp.g_varchar2_table(190) := '2E646A732D7365617263682D696E70757420696E707574207B0A2020666F6E742D73697A653A20312E3035656D3B0A202077696474683A20313030253B0A202070616464696E673A2036707820313070783B0A2020626F726465723A2031707820736F6C';
wwv_flow_imp.g_varchar2_table(191) := '696420766172282D2D7365617263682D696E7075742D626F726465722D636F6C6F72293B0A2020626F782D73697A696E673A20626F726465722D626F783B0A7D0A0A2E646A732D7365617263682D696E70757420696E7075743A666F637573207B0A2020';
wwv_flow_imp.g_varchar2_table(192) := '6F75746C696E653A206E6F6E653B0A2020626F726465722D636F6C6F723A20766172282D2D7365617263682D696E7075742D626F726465722D636F6C6F72293B0A7D0A0A2E646A732D7365617263682D726573756C7473207B0A2020706F736974696F6E';
wwv_flow_imp.g_varchar2_table(193) := '3A2072656C61746976653B0A20206F766572666C6F772D793A206175746F3B0A20206D61782D6865696768743A2032303070783B0A7D0A0A2E646A732D7365617263682D726573756C74733A686F766572207B0A2020637572736F723A20706F696E7465';
wwv_flow_imp.g_varchar2_table(194) := '723B0A7D0A0A2E646A732D7365617263682D726573756C74207B0A202077696474683A20313030253B0A202070616464696E673A2036707820313070783B0A20206261636B67726F756E643A2077686974653B0A2020626F726465722D626F74746F6D3A';
wwv_flow_imp.g_varchar2_table(195) := '20736F6C69642031707820766172282D2D7365617263682D726573756C742D626F726465722D636F6C6F72293B0A2020626F726465722D7261646975733A203170783B0A7D0A0A2E646A732D7365617263682D686967686C69676874207B0A2020636F6C';
wwv_flow_imp.g_varchar2_table(196) := '6F723A20766172282D2D7365617263682D726573756C742D686967686C696768742D636F6C6F72293B0A7D0A0A2E646A732D7365617263682D726573756C742D7072696D617279207B0A20206D617267696E3A2030203020313070783B0A7D0A0A2E646A';
wwv_flow_imp.g_varchar2_table(197) := '732D7365617263682D726573756C742D7365636F6E64617279207B0A2020666F6E742D66616D696C793A206D6F6E6F73706163653B0A20206D617267696E3A20303B0A7D0A0A2E646A732D7365617263682D726573756C743A686F766572207B0A202062';
wwv_flow_imp.g_varchar2_table(198) := '61636B67726F756E643A20766172282D2D7365617263682D726573756C742D73656C65637465642D636F6C6F72293B0A7D0A0A2E646A732D7365617263682D726573756C742D73656C6563746564207B0A20206261636B67726F756E643A20766172282D';
wwv_flow_imp.g_varchar2_table(199) := '2D7365617263682D726573756C742D73656C65637465642D636F6C6F72293B0A7D0A0A2E646A732D7365617263682D726573756C742D73656C65637465643A686F766572207B0A20206261636B67726F756E643A20766172282D2D7365617263682D7265';
wwv_flow_imp.g_varchar2_table(200) := '73756C742D73656C65637465642D636F6C6F72293B0A7D0A0A2E646A732D7365617263682D6F7665726C6179207B0A20206261636B67726F756E643A20766172282D2D7365617263682D726573756C742D73656C65637465642D636F6C6F72293B0A7D0A';
wwv_flow_imp.g_varchar2_table(201) := '0A2F2A2A0A202A2068696464656E207374796C65730A202A2F0A2E646A732D656C656D656E742D68696464656E2C0A2E646A732D656C656D656E742D68696464656E202E646A732D6869742C0A2E646A732D656C656D656E742D68696464656E202E646A';
wwv_flow_imp.g_varchar2_table(202) := '732D6F75746C696E652C0A2E646A732D6C6162656C2D68696464656E202E646A732D6C6162656C207B0A2020646973706C61793A206E6F6E652021696D706F7274616E743B0A7D0A0A2E646A732D656C656D656E74202E646A732D6869742D7374726F6B';
wwv_flow_imp.g_varchar2_table(203) := '652C0A2E646A732D656C656D656E74202E646A732D6869742D636C69636B2D7374726F6B652C0A2E646A732D656C656D656E74202E646A732D6869742D616C6C207B0A2020637572736F723A206D6F76653B0A7D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(14513555153671179)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_file_name=>'css/diagram-js.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2E666C6F777334617065782D766965776572207B0D0A20202D2D636F6C6F722D666C6F77732D627574746F6E2D677265656E3A20233532423431353B0D0A0D0A20202F2A20636F706965642066726F6D206D6F64656C6572202A2F0D0A20202D2D636F6C';
wwv_flow_imp.g_varchar2_table(2) := '6F722D666C6F77732D6469616C6F672D6261636B67726F756E643A2077686974653B0D0A20202D2D636F6C6F722D666C6F77732D6469616C6F672D627574746F6E3A20236638663866383B0D0A20202D2D636F6C6F722D666C6F77732D6469616C6F672D';
wwv_flow_imp.g_varchar2_table(3) := '696E7075743A2068736C283232352C203130252C20393725293B0D0A7D0D0A2F2A2A0D0A202A2067656E6572616C0D0A202A2F0D0A2E63616E766173207B0D0A20206865696768743A20383076683B0D0A20206261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(4) := '20236630663066303B0D0A7D0D0A2E626A732D636F6E7461696E6572207B0D0A20202D2D64656661756C742D66696C6C2D636F6C6F723A2077686974653B0D0A20202D2D64656661756C742D7374726F6B652D636F6C6F723A20626C61636B3B0D0A7D0D';
wwv_flow_imp.g_varchar2_table(5) := '0A2F2A2A0D0A202A206461726B206D6F64650D0A202A2F0D0A2E464C4F57532D4441524B207B0D0A20202D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E643A20233262333033353B0D0A20202D2D636F6C6F722D666C6F77732D6C';
wwv_flow_imp.g_varchar2_table(6) := '6967687465722D6461726B2D6261636B67726F756E643A20233332333833643B0D0A0D0A20202F2A20636F706965642066726F6D206D6F64656C6572202A2F0D0A20202D2D636F6C6F722D666C6F77732D6469616C6F672D6261636B67726F756E643A20';
wwv_flow_imp.g_varchar2_table(7) := '766172282D2D636F6C6F722D666C6F77732D6C6967687465722D6461726B2D6261636B67726F756E64293B0D0A20202D2D636F6C6F722D666C6F77732D6469616C6F672D627574746F6E3A20233238326333303B0D0A20202D2D636F6C6F722D666C6F77';
wwv_flow_imp.g_varchar2_table(8) := '732D6469616C6F672D696E7075743A20233238326333303B0D0A7D0D0A2F2A2A0D0A202A20637573746F6D20636F6C6F72730D0A202A2F20200D0A2E464C4F57532D4441524B202E63616E766173207B0D0A20206261636B67726F756E642D636F6C6F72';
wwv_flow_imp.g_varchar2_table(9) := '3A20766172282D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E64293B0D0A7D0D0A2E464C4F57532D4441524B202E626A732D636F6E7461696E6572207B0D0A20202D2D64656661756C742D66696C6C2D636F6C6F723A2076617228';
wwv_flow_imp.g_varchar2_table(10) := '2D2D636F6C6F722D666C6F77732D6461726B2D6261636B67726F756E64293B0D0A20202D2D64656661756C742D7374726F6B652D636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441524B202E626A732D62726561646372756D6273206C';
wwv_flow_imp.g_varchar2_table(11) := '693A6C6173742D6F662D74797065207370616E207B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A2E464C4F57532D4441524B202E626A732D706F77657265642D6279207B0D0A2020636F6C6F723A2077686974652021696D706F7274616E743B';
wwv_flow_imp.g_varchar2_table(12) := '0D0A7D0D0A2E464C4F57532D4441524B202E646A732D70616C65747465207B0D0A20202D2D70616C657474652D6261636B67726F756E642D636F6C6F723A20233262333033353B0D0A20202D2D70616C657474652D656E7472792D636F6C6F723A207768';
wwv_flow_imp.g_varchar2_table(13) := '6974653B0D0A7D0D0A2F2A204F7665727772697465207465787420636F6C6F72207768656E207573696E672062706D6E20657874656E73696F6E202A2F0D0A2E646A732D76697375616C3A6E6F74282E72657365742D62706D6E2D636F6C6F727329203E';
wwv_flow_imp.g_varchar2_table(14) := '202A3A6E6F74285B7374796C652A3D227374726F6B653A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B225D29202B2074657874207B0D0A20202D2D64656661756C742D7374726F6B652D636F6C6F723A20626C61636B3B0D0A';
wwv_flow_imp.g_varchar2_table(15) := '7D0D0A2F2A2052657365742042504D4E20436F6C6F7273202A2F0D0A2E646A732D76697375616C2E72657365742D62706D6E2D636F6C6F727320726563742C0D0A2E646A732D76697375616C2E72657365742D62706D6E2D636F6C6F727320636972636C';
wwv_flow_imp.g_varchar2_table(16) := '652C0D0A2E646A732D76697375616C2E72657365742D62706D6E2D636F6C6F727320706F6C79676F6E2C0D0A2E646A732D76697375616C2E72657365742D62706D6E2D636F6C6F72732070617468207B0D0A202066696C6C3A20766172282D2D64656661';
wwv_flow_imp.g_varchar2_table(17) := '756C742D66696C6C2D636F6C6F72292021696D706F7274616E743B0D0A20207374726F6B653A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E7265736574';
wwv_flow_imp.g_varchar2_table(18) := '2D62706D6E2D636F6C6F72732074657874207B0D0A202066696C6C3A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72292021696D706F7274616E743B0D0A7D0D0A2F2A2A0D0A202A20486967686C69676874696E673A20436F6D706C';
wwv_flow_imp.g_varchar2_table(19) := '657465640D0A202A2F0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C6574656420726563742C0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C6574656420636972636C652C0D0A2E646A732D76697375';
wwv_flow_imp.g_varchar2_table(20) := '616C2E686967686C696768742D636F6D706C6574656420706F6C79676F6E2C0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C657465642070617468207B0D0A202066696C6C3A20766172282D2D686967686C696768742D636F6D';
wwv_flow_imp.g_varchar2_table(21) := '706C657465642D66696C6C292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C6574656420726563742C0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C6574656420';
wwv_flow_imp.g_varchar2_table(22) := '636972636C652C0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C6574656420706F6C79676F6E207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D636F6D706C657465642D626F72646572292021696D70';
wwv_flow_imp.g_varchar2_table(23) := '6F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C657465642074657874207B0D0A202066696C6C3A20766172282D2D686967686C696768742D636F6D706C657465642D6C6162656C292021696D706F7274';
wwv_flow_imp.g_varchar2_table(24) := '616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D636F6D706C657465642070617468207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D636F6D706C657465642D6C6162656C292021696D706F727461';
wwv_flow_imp.g_varchar2_table(25) := '6E743B0D0A7D0D0A2F2A2A0D0A202A20486967686C69676874696E673A2043757272656E740D0A202A2F0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E7420726563742C0D0A2E646A732D76697375616C2E686967686C6967';
wwv_flow_imp.g_varchar2_table(26) := '68742D63757272656E7420636972636C652C0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E7420706F6C79676F6E2C0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E742070617468207B0D0A2020';
wwv_flow_imp.g_varchar2_table(27) := '66696C6C3A20766172282D2D686967686C696768742D63757272656E742D66696C6C292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E7420726563742C0D0A2E646A732D76697375616C';
wwv_flow_imp.g_varchar2_table(28) := '2E686967686C696768742D63757272656E7420636972636C652C0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E7420706F6C79676F6E207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D6375727265';
wwv_flow_imp.g_varchar2_table(29) := '6E742D626F72646572292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E742074657874207B0D0A202066696C6C3A20766172282D2D686967686C696768742D63757272656E742D6C6162';
wwv_flow_imp.g_varchar2_table(30) := '656C292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D63757272656E742070617468207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D63757272656E742D6C6162656C292021';
wwv_flow_imp.g_varchar2_table(31) := '696D706F7274616E743B0D0A7D0D0A2F2A2A0D0A202A20486967686C69676874696E673A204572726F720D0A202A2F0D0A2E646A732D76697375616C2E686967686C696768742D6572726F7220726563742C0D0A2E646A732D76697375616C2E68696768';
wwv_flow_imp.g_varchar2_table(32) := '6C696768742D6572726F7220636972636C652C0D0A2E646A732D76697375616C2E686967686C696768742D6572726F7220706F6C79676F6E2C0D0A2E646A732D76697375616C2E686967686C696768742D6572726F722070617468207B0D0A202066696C';
wwv_flow_imp.g_varchar2_table(33) := '6C3A20766172282D2D686967686C696768742D6572726F722D66696C6C292021696D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D6572726F7220726563742C0D0A2E646A732D76697375616C2E686967686C69';
wwv_flow_imp.g_varchar2_table(34) := '6768742D6572726F7220636972636C652C0D0A2E646A732D76697375616C2E686967686C696768742D6572726F7220706F6C79676F6E207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D6572726F722D626F7264657229202169';
wwv_flow_imp.g_varchar2_table(35) := '6D706F7274616E743B0D0A7D0D0A2E646A732D76697375616C2E686967686C696768742D6572726F722074657874207B0D0A202066696C6C3A20766172282D2D686967686C696768742D6572726F722D6C6162656C292021696D706F7274616E743B0D0A';
wwv_flow_imp.g_varchar2_table(36) := '7D0D0A2E646A732D76697375616C2E686967686C696768742D6572726F722070617468207B0D0A20207374726F6B653A20766172282D2D686967686C696768742D6572726F722D6C6162656C292021696D706F7274616E743B0D0A7D0D0A2F2A20436F6E';
wwv_flow_imp.g_varchar2_table(37) := '74657874206D656E75202A2F0D0A23636F6E746578742D6D656E75207B0D0A2020706F736974696F6E3A206162736F6C7574653B0D0A20200D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6469616C';
wwv_flow_imp.g_varchar2_table(38) := '6F672D6261636B67726F756E64293B0D0A2020636F6C6F723A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B0D0A0D0A2020626F726465723A2031707820736F6C696420233838383B0D0A7D0D0A0D0A23636F6E746578742D6D';
wwv_flow_imp.g_varchar2_table(39) := '656E75202E6D656E752D6F7074696F6E73207B0D0A20206C6973742D7374796C653A206E6F6E653B0D0A202070616464696E672D6C6566743A20303B0D0A20206D617267696E3A20313070783B0D0A0D0A2020666F6E742D66616D696C793A2073616E73';
wwv_flow_imp.g_varchar2_table(40) := '2D73657269663B0D0A2020666F6E742D73697A653A20313270783B0D0A2020666F6E742D7765696768743A206E6F726D616C3B0D0A7D0D0A0D0A23636F6E746578742D6D656E75202E6D656E752D6F7074696F6E207B0D0A2020637572736F723A20706F';
wwv_flow_imp.g_varchar2_table(41) := '696E7465723B0D0A7D0D0A0D0A23636F6E746578742D6D656E75202E6D656E752D6F7074696F6E2061207B0D0A2020636F6C6F723A20696E68657269743B0D0A2020746578742D6465636F726174696F6E3A206E6F6E653B0D0A7D0D0A2F2A2044697361';
wwv_flow_imp.g_varchar2_table(42) := '626C652063726F73736861697220637572736F72207768656E20686F766572696E67206F76657220656C656D656E7473202A2F0D0A2E646A732D6869742C202E646A732D6869742D616C6C207B0D0A2020637572736F723A2064656661756C742021696D';
wwv_flow_imp.g_varchar2_table(43) := '706F7274616E743B0D0A7D0D0A2F2A20497465726174696F6E206469616C6F67202A2F0D0A236D6F64616C207B0D0A2020646973706C61793A206E6F6E653B0D0A2020706F736974696F6E3A2066697865643B0D0A20207A2D696E6465783A203939393B';
wwv_flow_imp.g_varchar2_table(44) := '0D0A20206C6566743A20303B0D0A2020746F703A20303B0D0A202077696474683A20313030253B0D0A20206865696768743A20313030253B0D0A20206F766572666C6F773A206175746F3B0D0A20206261636B67726F756E642D636F6C6F723A20726762';
wwv_flow_imp.g_varchar2_table(45) := '6128302C302C302C302E34293B0D0A0D0A2020666F6E742D66616D696C793A2073616E732D73657269663B0D0A7D0D0A236D6F64616C2D636F6E74656E74207B0D0A202077696474683A2037353070783B0D0A20206865696768743A2035303070783B0D';
wwv_flow_imp.g_varchar2_table(46) := '0A0D0A20206D617267696E3A206175746F3B0D0A0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C6F77732D6469616C6F672D6261636B67726F756E64293B0D0A2020626F726465723A2031707820736F6C6964';
wwv_flow_imp.g_varchar2_table(47) := '20233838383B0D0A7D0D0A23697465726174696F6E2D7469746C65207B0D0A2020646973706C61793A20666C65783B0D0A20206A7573746966792D636F6E74656E743A2073706163652D6265747765656E3B0D0A20200D0A20206D617267696E3A203130';
wwv_flow_imp.g_varchar2_table(48) := '70783B0D0A7D0D0A23697465726174696F6E2D7469746C65207370616E207B0D0A2020666F6E742D73697A653A20323470783B0D0A2020636F6C6F723A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B0D0A7D0D0A2369746572';
wwv_flow_imp.g_varchar2_table(49) := '6174696F6E2D7469746C6520627574746F6E2E66612D74696D6573207B0D0A20206865696768743A20333070783B0D0A202077696474683A20333070783B0D0A0D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F722D666C';
wwv_flow_imp.g_varchar2_table(50) := '6F77732D6469616C6F672D627574746F6E293B0D0A2020636F6C6F723A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B0D0A0D0A2020626F726465723A2031707820736F6C696420236363633B0D0A2020626F726465722D7261';
wwv_flow_imp.g_varchar2_table(51) := '646975733A203270783B0D0A0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A23697465726174696F6E2D7469746C6520627574746F6E2E66612D74696D65733A686F766572207B0D0A2020636F6C6F723A20766172282D2D636F6C6F722D';
wwv_flow_imp.g_varchar2_table(52) := '666C6F77732D627574746F6E2D677265656E293B0D0A7D0D0A23697465726174696F6E2D736561726368207B0D0A20206D617267696E3A20313070783B0D0A7D0D0A23697465726174696F6E2D73656172636820696E707574207B0D0A20207769647468';
wwv_flow_imp.g_varchar2_table(53) := '3A202D7765626B69742D66696C6C2D617661696C61626C653B0D0A20206D696E2D6865696768743A20323070783B0D0A202070616464696E673A20313070783B0D0A20200D0A20206261636B67726F756E642D636F6C6F723A20766172282D2D636F6C6F';
wwv_flow_imp.g_varchar2_table(54) := '722D666C6F77732D6469616C6F672D696E707574293B0D0A2020636F6C6F723A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B0D0A0D0A2020626F726465723A2031707820736F6C696420233838383B0D0A7D0D0A2369746572';
wwv_flow_imp.g_varchar2_table(55) := '6174696F6E2D6C697374207B0D0A20206865696768743A2034303070783B0D0A20206F766572666C6F772D793A206175746F3B0D0A7D0D0A23697465726174696F6E2D6C697374207461626C65207B0D0A202077696474683A20313030253B0D0A20200D';
wwv_flow_imp.g_varchar2_table(56) := '0A2020636F6C6F723A20766172282D2D64656661756C742D7374726F6B652D636F6C6F72293B0D0A0D0A2020626F726465722D73706163696E673A20313070783B0D0A7D0D0A23697465726174696F6E2D6C697374207468207B0D0A2020746578742D61';
wwv_flow_imp.g_varchar2_table(57) := '6C69676E3A206C6566743B0D0A7D0D0A23697465726174696F6E2D6C6973742074722E636C69636B61626C65207B0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A2F2A2042726561646372756D62202A2F0D0A2F2A204F76657277726974';
wwv_flow_imp.g_varchar2_table(58) := '652064656661756C742073657474696E67206F66206C696E6520627265616B202A2F0D0A2E626A732D62726561646372756D6273202E626A732D6372756D62207B0D0A20206D61782D77696474683A2034303070782021696D706F7274616E743B0D0A7D';
wwv_flow_imp.g_varchar2_table(59) := '0D0A2F2A20576869746520636F6C6F7220666F722069636F6E7320696E73696465206472696C6C646F776E20627574746F6E73202A2F0D0A2E626A732D6472696C6C646F776E2E66612D6C6973742C202E626A732D6472696C6C646F776E2E66612D6578';
wwv_flow_imp.g_varchar2_table(60) := '7465726E616C2D6C696E6B207B0D0A2020636F6C6F723A2077686974653B0D0A7D0D0A2F2A204C656674206D617267696E20666F72206472696C6C646F776E20627574746F6E7320616E6420697465726174696F6E206465736372697074696F6E20696E';
wwv_flow_imp.g_varchar2_table(61) := '2062726561646372756D62202A2F0D0A2E626A732D6372756D62202B202E626A732D6472696C6C646F776E2C0D0A2E626A732D6372756D622E697465726174696F6E2D646573632C0D0A2E626A732D6372756D622E697465726174696F6E2D627574746F';
wwv_flow_imp.g_varchar2_table(62) := '6E207B0D0A20206D617267696E2D6C6566743A203870783B0D0A7D0D0A2E626A732D62726561646372756D6273206C693A6E6F74283A6C6173742D6368696C6429202E626A732D6372756D622E697465726174696F6E2D646573632C0D0A2E626A732D62';
wwv_flow_imp.g_varchar2_table(63) := '726561646372756D6273206C693A6E6F74283A6C6173742D6368696C6429202E626A732D6372756D622E697465726174696F6E2D627574746F6E207B0D0A2020636F6C6F723A20766172282D2D62726561646372756D62732D6974656D2D636F6C6F7229';
wwv_flow_imp.g_varchar2_table(64) := '3B0D0A2020637572736F723A20706F696E7465723B0D0A7D0D0A2E626A732D6372756D622E697465726174696F6E2D627574746F6E207B0D0A2020626F726465723A2031707820736F6C696420766172282D2D62726561646372756D62732D6974656D2D';
wwv_flow_imp.g_varchar2_table(65) := '636F6C6F72293B0D0A2020626F726465722D7261646975733A203270783B0D0A202070616464696E673A203170783B0D0A7D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(14513972935671180)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_file_name=>'css/flows4apex.viewer.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7661722062706D6E5669657765723B0A2F2A2A2A2A2A2A2F20282829203D3E207B202F2F207765627061636B426F6F7473747261700A2F2A2A2A2A2A2A2F20092275736520737472696374223B0A2F2A2A2A2A2A2A2F2009766172205F5F776562706163';
wwv_flow_imp.g_varchar2_table(2) := '6B5F6D6F64756C65735F5F203D20287B0A0A2F2A2A2A2F20222E2F6C69622F76696577657250616C657474652F50616C6574746550726F76696465722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6C69622F76696577657250616C657474652F50616C6574746550726F76696465722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B';
wwv_flow_imp.g_varchar2_table(5) := '0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F65';
wwv_flow_imp.g_varchar2_table(6) := '78706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F2050616C6574746550726F7669646572290A2F2A206861726D6F6E79206578706F72';
wwv_flow_imp.g_varchar2_table(7) := '74202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F6E617669676174696F6E5F7A6F6F6D7363726F6C6C5F5A6F6F6D5363726F6C6C5F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(8) := '4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F5A6F6F6D5363726F6C6C202A2F20222E2F6E6F64655F6D6F6475';
wwv_flow_imp.g_varchar2_table(9) := '6C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F5A6F6F6D5363726F6C6C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B';
wwv_flow_imp.g_varchar2_table(10) := '5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A';
wwv_flow_imp.g_varchar2_table(11) := '7322293B0A0D0A0D0A0D0A2F2A2A0D0A202A20412070616C657474652070726F766964657220666F722042504D4E20322E3020656C656D656E74732E0D0A202A2F0D0A66756E6374696F6E2050616C6574746550726F7669646572280D0A202070616C65';
wwv_flow_imp.g_varchar2_table(12) := '7474652C0D0A20207472616E736C6174652C0D0A20206576656E744275732C0D0A202063616E7661732C0D0A2020636F6E6669670D0A29207B0D0A0D0A202070616C657474652E5F6E65656473436F6C6C61707365203D2066756E6374696F6E20286176';
wwv_flow_imp.g_varchar2_table(13) := '61696C61626C654865696768742C20656E747269657329207B0D0A2020202072657475726E2066616C73653B0D0A20207D3B0D0A0D0A2020746869732E67657450616C65747465456E7472696573203D2066756E6374696F6E2028656C656D656E742920';
wwv_flow_imp.g_varchar2_table(14) := '7B0D0A2020202076617220616374696F6E73203D207B7D3B0D0A20202020766172207A6F6F6D5363726F6C6C203D206E6577206469616772616D5F6A735F6C69625F6E617669676174696F6E5F7A6F6F6D7363726F6C6C5F5A6F6F6D5363726F6C6C5F5F';
wwv_flow_imp.g_varchar2_table(15) := '5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D287B7D2C206576656E744275732C2063616E766173293B0D0A20200D0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(16) := '5F4D4F44554C455F315F5F2E61737369676E2928616374696F6E732C207B0D0A202020202020277A6F6F6D2D696E273A207B0D0A202020202020202067726F75703A2027636F6E74726F6C73272C0D0A2020202020202020636C6173734E616D653A2027';
wwv_flow_imp.g_varchar2_table(17) := '66612066612D7365617263682D706C7573272C0D0A20202020202020207469746C653A207472616E736C61746528275A6F6F6D20496E27292C0D0A2020202020202020616374696F6E3A207B0D0A20202020202020202020636C69636B3A2066756E6374';
wwv_flow_imp.g_varchar2_table(18) := '696F6E20286576656E7429207B0D0A2020202020202020202020207A6F6F6D5363726F6C6C2E7A6F6F6D28312C2030293B0D0A202020202020202020207D2C0D0A20202020202020207D2C0D0A2020202020207D2C0D0A202020202020277A6F6F6D2D6F';
wwv_flow_imp.g_varchar2_table(19) := '7574273A207B0D0A202020202020202067726F75703A2027636F6E74726F6C73272C0D0A2020202020202020636C6173734E616D653A202766612066612D7365617263682D6D696E7573272C0D0A20202020202020207469746C653A207472616E736C61';
wwv_flow_imp.g_varchar2_table(20) := '746528275A6F6F6D204F757427292C0D0A2020202020202020616374696F6E3A207B0D0A20202020202020202020636C69636B3A2066756E6374696F6E20286576656E7429207B0D0A2020202020202020202020207A6F6F6D5363726F6C6C2E7A6F6F6D';
wwv_flow_imp.g_varchar2_table(21) := '282D312C2030293B0D0A202020202020202020207D2C0D0A20202020202020207D2C0D0A2020202020207D2C0D0A202020202020277A6F6F6D2D7265736574273A207B0D0A202020202020202067726F75703A2027636F6E74726F6C73272C0D0A202020';
wwv_flow_imp.g_varchar2_table(22) := '2020202020636C6173734E616D653A202766612066612D6669742D746F2D73697A65272C0D0A20202020202020207469746C653A207472616E736C61746528275265736574205A6F6F6D27292C0D0A2020202020202020616374696F6E3A207B0D0A2020';
wwv_flow_imp.g_varchar2_table(23) := '2020202020202020636C69636B3A2066756E6374696F6E20286576656E7429207B0D0A2020202020202020202020207A6F6F6D5363726F6C6C2E726573657428293B0D0A202020202020202020207D2C0D0A20202020202020207D2C0D0A202020202020';
wwv_flow_imp.g_varchar2_table(24) := '7D2C0D0A2020202020202E2E2E28636F6E6669672E616C6C6F77446F776E6C6F6164202626207B0D0A202020202020202027646F776E6C6F61642D737667273A207B0D0A2020202020202020202067726F75703A2027636F6E74726F6C73272C0D0A2020';
wwv_flow_imp.g_varchar2_table(25) := '2020202020202020636C6173734E616D653A202766612066612D696D616765272C0D0A202020202020202020207469746C653A207472616E736C6174652827446F776E6C6F61642053564727292C0D0A20202020202020202020616374696F6E3A207B0D';
wwv_flow_imp.g_varchar2_table(26) := '0A202020202020202020202020636C69636B3A2066756E6374696F6E20286576656E7429207B0D0A2020202020202020202020202020646F776E6C6F61644173535647286576656E74293B0D0A2020202020202020202020207D2C0D0A20202020202020';
wwv_flow_imp.g_varchar2_table(27) := '2020207D2C0D0A20202020202020207D0D0A2020202020207D290D0A202020207D293B0D0A20200D0A2020202072657475726E20616374696F6E733B0D0A20207D3B0D0A0D0A202070616C657474652E726567697374657250726F766964657228746869';
wwv_flow_imp.g_varchar2_table(28) := '73293B0D0A7D0D0A0D0A50616C6574746550726F76696465722E24696E6A656374203D205B0D0A20202770616C65747465272C0D0A2020277472616E736C617465272C0D0A2020276576656E74427573272C0D0A20202763616E766173272C0D0A20202F';
wwv_flow_imp.g_varchar2_table(29) := '2F20637573746F6D207669657765722070726F70657274696573206E657374656420696E7369646520706172656E7420636F6E666967206F626A6563740D0A202027636F6E6669672E636F6E666967270D0A5D3B0D0A0A0A2F2A2A2A2F207D292C0A0A2F';
wwv_flow_imp.g_varchar2_table(30) := '2A2A2A2F20222E2F6C69622F76696577657250616C657474652F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6C69622F76696577657250';
wwv_flow_imp.g_varchar2_table(31) := '616C657474652F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F776562';
wwv_flow_imp.g_varchar2_table(32) := '7061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578';
wwv_flow_imp.g_varchar2_table(33) := '706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F57454250';
wwv_flow_imp.g_varchar2_table(34) := '41434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F66656174757265735F70616C65';
wwv_flow_imp.g_varchar2_table(35) := '7474655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F66656174757265732F70616C65747465202A2F20222E2F6E6F64';
wwv_flow_imp.g_varchar2_table(36) := '655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F70616C657474652F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F6931386E5F74';
wwv_flow_imp.g_varchar2_table(37) := '72616E736C6174655F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F6931386E2F7472616E736C617465202A2F20222E2F';
wwv_flow_imp.g_varchar2_table(38) := '6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6931386E2F7472616E736C6174652F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F50616C6574746550726F76696465725F6A735F';
wwv_flow_imp.g_varchar2_table(39) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F50616C6574746550726F76696465722E6A73202A2F20222E2F6C69622F76696577657250616C657474652F';
wwv_flow_imp.g_varchar2_table(40) := '50616C6574746550726F76696465722E6A7322293B0A0D0A0D0A0D0A0D0A0D0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0D0A';
wwv_flow_imp.g_varchar2_table(41) := '20205F5F646570656E64735F5F3A205B6469616772616D5F6A735F6C69625F66656174757265735F70616C657474655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D2C206469616772616D5F6A735F';
wwv_flow_imp.g_varchar2_table(42) := '6C69625F6931386E5F7472616E736C6174655F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F5B2264656661756C74225D5D2C0D0A20205F5F696E69745F5F3A205B2770616C6574746550726F7669646572275D2C0D0A20207061';
wwv_flow_imp.g_varchar2_table(43) := '6C6574746550726F76696465723A205B2774797065272C205F50616C6574746550726F76696465725F6A735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D5D2C0D0A7D293B0D0A0A0A2F2A2A2A2F20';
wwv_flow_imp.g_varchar2_table(44) := '7D292C0A0A2F2A2A2A2F20222E2F6D6F64756C65732F63616C6C41637469766974794D6F64756C652F43616C6C41637469766974794D6F64756C652E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(45) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6D6F64756C65732F63616C6C41637469766974794D6F64756C652F43616C6C41637469766974794D6F64756C652E6A73202A2A2A210A20205C2A2A2A2A';
wwv_flow_imp.g_varchar2_table(46) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F65';
wwv_flow_imp.g_varchar2_table(47) := '78706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A';
wwv_flow_imp.g_varchar2_table(48) := '2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A';
wwv_flow_imp.g_varchar2_table(49) := '2F20437573746F6D4472696C6C646F776E290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722062706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F574542';
wwv_flow_imp.g_varchar2_table(50) := '5041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212062706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D';
wwv_flow_imp.g_varchar2_table(51) := '6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F77656270';
wwv_flow_imp.g_varchar2_table(52) := '61636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A0D0A0D0A0D0A0D0A766172204152524F575F444F574E5F535647';
wwv_flow_imp.g_varchar2_table(53) := '203D20273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22323022206865696768743D223230222076696577426F783D22302030203136203136223E3C706174682066696C6C2D7275';
wwv_flow_imp.g_varchar2_table(54) := '6C653D226576656E6F64642220643D224D342E38313830313934382C332E3530373335393331204C31302E343939363839342C392E31383936383934204C31302E352C34204C31322C34204C31322C3132204C342C3132204C342C31302E35204C392E36';
wwv_flow_imp.g_varchar2_table(55) := '3839363839342C31302E34393936383934204C332E37353733353933312C342E35363830313934382043332E34363434363630392C342E323735313236323720332E34363434363630392C332E383030323532353320332E37353733353933312C332E35';
wwv_flow_imp.g_varchar2_table(56) := '303733353933312043342E30353032353235332C332E323134343636303920342E35323531323632372C332E323134343636303920342E38313830313934382C332E3530373335393331205A222F3E3C2F7376673E273B0D0A66756E6374696F6E204375';
wwv_flow_imp.g_varchar2_table(57) := '73746F6D4472696C6C646F776E280D0A2020202063616E7661732C206576656E744275732C20656C656D656E7452656769737472792C206F7665726C6179732C206D6F64646C650D0A29207B0D0A2020746869732E5F63616E766173203D2063616E7661';
wwv_flow_imp.g_varchar2_table(58) := '733B0D0A2020746869732E5F6576656E74427573203D206576656E744275733B0D0A2020746869732E5F656C656D656E745265676973747279203D20656C656D656E7452656769737472793B0D0A2020746869732E5F6F7665726C617973203D206F7665';
wwv_flow_imp.g_varchar2_table(59) := '726C6179733B0D0A2020746869732E5F6D6F64646C65203D206D6F64646C653B0D0A0D0A2020766172205F73656C66203D20746869733B0D0A0D0A20202F2F2063726561746520616E6420617070656E642062726561646372756D620D0A202074686973';
wwv_flow_imp.g_varchar2_table(60) := '2E5F62726561646372756D62203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D6966792928273C756C20636C6173733D22626A732D62726561646372756D6273222069643D2263616C6C';
wwv_flow_imp.g_varchar2_table(61) := '416374697669747942726561646372756D62223E3C2F756C3E27293B0D0A202076617220636F6E7461696E6572203D2063616E7661732E676574436F6E7461696E657228293B0D0A2020636F6E7461696E65722E617070656E644368696C642874686973';
wwv_flow_imp.g_varchar2_table(62) := '2E5F62726561646372756D62293B0D0A0D0A20202F2F20616464206F7665726C617920666F72206472696C6C646F776E2D61626C6520656C656D656E74730D0A20206576656E744275732E6F6E2827696D706F72742E72656E6465722E636F6D706C6574';
wwv_flow_imp.g_varchar2_table(63) := '65272C2066756E6374696F6E202829207B0D0A20202020656C656D656E7452656769737472792E66696C7465722866756E6374696F6E20286529207B0D0A20202020202072657475726E205F73656C662E63616E4472696C6C446F776E2865293B0D0A20';
wwv_flow_imp.g_varchar2_table(64) := '2020207D292E666F72456163682866756E6374696F6E2028656C29207B0D0A2020202020205F73656C662E6164644F7665726C617928656C293B0D0A202020207D293B0D0A20207D293B0D0A7D0D0A0D0A437573746F6D4472696C6C646F776E2E70726F';
wwv_flow_imp.g_varchar2_table(65) := '746F747970652E63616E4472696C6C446F776E203D2066756E6374696F6E2028656C656D656E7429207B0D0A202072657475726E202828302C62706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(66) := '445F4D4F44554C455F315F5F2E69732928656C656D656E742C202762706D6E3A43616C6C41637469766974792729293B0D0A7D3B0D0A0D0A437573746F6D4472696C6C646F776E2E70726F746F747970652E6164644F7665726C6179203D2066756E6374';
wwv_flow_imp.g_varchar2_table(67) := '696F6E2028656C656D656E7429207B0D0A2020766172206F7665726C617973203D20746869732E5F6F7665726C6179733B0D0A0D0A2020766172205F73656C66203D20746869733B0D0A0D0A202076617220627574746F6E203D2028302C6D696E5F646F';
wwv_flow_imp.g_varchar2_table(68) := '6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D6966792928603C627574746F6E20636C6173733D22626A732D6472696C6C646F776E223E247B4152524F575F444F574E5F5356477D3C2F627574746F6E3E60293B0D';
wwv_flow_imp.g_varchar2_table(69) := '0A0D0A20202F2F2072656D6F76652028706F737369626C6529206578697374696E67206F7665726C61790D0A2020696620286F7665726C6179732E676574287B20656C656D656E743A20656C656D656E742C20747970653A20276472696C6C646F776E27';
wwv_flow_imp.g_varchar2_table(70) := '207D292E6C656E67746829207B0D0A20202020746869732E72656D6F76654F7665726C617928656C656D656E74293B0D0A20207D0D0A0D0A20202F2F20616464206576656E74206C697374656E65720D0A2020627574746F6E2E6164644576656E744C69';
wwv_flow_imp.g_varchar2_table(71) := '7374656E65722827636C69636B272C2066756E6374696F6E20286576656E7429207B0D0A0D0A202020202F2F20636C69636B6564206F626A6563740D0A20202020766172206F626A6563744964203D20656C656D656E742E69643B0D0A0D0A202020202F';
wwv_flow_imp.g_varchar2_table(72) := '2F207265747269657665206869657261637279202B2063757272656E74206469616772616D0D0A20202020766172207B20646174612C206469616772616D4964656E746966696572207D203D205F73656C662E5F7769646765743B0D0A0D0A202020202F';
wwv_flow_imp.g_varchar2_table(73) := '2F20676574206E6577206469616772616D2066726F6D206869657261726368790D0A20202020766172206E65774469616772616D203D20646174612E66696E64280D0A20202020202064203D3E0D0A2020202020202020642E63616C6C696E6744696167';
wwv_flow_imp.g_varchar2_table(74) := '72616D4964656E746966696572203D3D3D206469616772616D4964656E7469666965722026260D0A2020202020202020642E63616C6C696E674F626A6563744964203D3D3D206F626A65637449640D0A20202020293B0D0A0D0A202020202F2F20696620';
wwv_flow_imp.g_varchar2_table(75) := '696E736967687420616C6C6F7765640D0A20202020696620286E65774469616772616D202626206E65774469616772616D2E696E7369676874203D3D3D203129207B0D0A2020202020200D0A2020202020202F2F20736574206E6577206469616772616D';
wwv_flow_imp.g_varchar2_table(76) := '2070726F706572746965730D0A2020202020205F73656C662E5F7769646765742E6469616772616D4964656E746966696572203D206E65774469616772616D2E6469616772616D4964656E7469666965723B0D0A2020202020205F73656C662E5F776964';
wwv_flow_imp.g_varchar2_table(77) := '6765742E63616C6C696E674469616772616D4964656E746966696572203D206E65774469616772616D2E63616C6C696E674469616772616D4964656E7469666965723B0D0A2020202020205F73656C662E5F7769646765742E63616C6C696E674F626A65';
wwv_flow_imp.g_varchar2_table(78) := '63744964203D206E65774469616772616D2E63616C6C696E674F626A65637449643B0D0A2020202020205F73656C662E5F7769646765742E6469616772616D203D206E65774469616772616D2E6469616772616D3B0D0A2020202020205F73656C662E5F';
wwv_flow_imp.g_varchar2_table(79) := '7769646765742E63757272656E74203D206E65774469616772616D2E63757272656E743B0D0A2020202020205F73656C662E5F7769646765742E636F6D706C65746564203D206E65774469616772616D2E636F6D706C657465643B0D0A2020202020205F';
wwv_flow_imp.g_varchar2_table(80) := '73656C662E5F7769646765742E6572726F72203D206E65774469616772616D2E6572726F723B0D0A0D0A2020202020202F2F207570646174652062726561646372756D620D0A2020202020205F73656C662E75706461746542726561646372756D622829';
wwv_flow_imp.g_varchar2_table(81) := '3B0D0A0D0A2020202020202F2F206D6F766520646F776E207375622070726F636573732062726561646372756D620D0A202020202020636F6E73742073756250726F6365737342726561646372756D62203D20646F63756D656E742E717565727953656C';
wwv_flow_imp.g_varchar2_table(82) := '6563746F7228272E626A732D62726561646372756D62733A6E6F74282363616C6C416374697669747942726561646372756D622927293B0D0A20202020202073756250726F6365737342726561646372756D622E7374796C652E746F70203D2027363070';
wwv_flow_imp.g_varchar2_table(83) := '78273B0D0A0D0A2020202020202F2F20696E766F6B65206C6F61644469616772616D206F66207769646765740D0A2020202020205F73656C662E5F7769646765742E6C6F61644469616772616D28293B0D0A202020207D0D0A20207D293B0D0A0D0A2020';
wwv_flow_imp.g_varchar2_table(84) := '2F2F20616464206F7665726C61790D0A20206F7665726C6179732E61646428656C656D656E742C20276472696C6C646F776E272C207B0D0A20202020706F736974696F6E3A207B0D0A202020202020626F74746F6D3A202D372C0D0A2020202020207269';
wwv_flow_imp.g_varchar2_table(85) := '6768743A202D380D0A202020207D2C0D0A2020202068746D6C3A20627574746F6E0D0A20207D293B0D0A7D3B0D0A0D0A437573746F6D4472696C6C646F776E2E70726F746F747970652E72656D6F76654F7665726C6179203D2066756E6374696F6E2028';
wwv_flow_imp.g_varchar2_table(86) := '656C656D656E7429207B0D0A2020766172206F7665726C617973203D20746869732E5F6F7665726C6179733B0D0A0D0A20202F2F2072656D6F7665206F7665726C61790D0A20206F7665726C6179732E72656D6F7665287B0D0A20202020656C656D656E';
wwv_flow_imp.g_varchar2_table(87) := '743A20656C656D656E742C0D0A20202020747970653A20276472696C6C646F776E270D0A20207D293B0D0A7D3B0D0A0D0A437573746F6D4472696C6C646F776E2E70726F746F747970652E736574576964676574203D2066756E6374696F6E2028776964';
wwv_flow_imp.g_varchar2_table(88) := '67657429207B0D0A2020746869732E5F776964676574203D207769646765743B0D0A7D3B0D0A0D0A437573746F6D4472696C6C646F776E2E70726F746F747970652E75706461746542726561646372756D62203D2066756E6374696F6E202829207B0D0A';
wwv_flow_imp.g_varchar2_table(89) := '0D0A2020766172205F73656C66203D20746869733B0D0A0D0A20202F2F207265747269657665206869657261726368790D0A2020636F6E7374207B20646174612C206469616772616D4964656E7469666965722C2063616C6C696E674469616772616D49';
wwv_flow_imp.g_varchar2_table(90) := '64656E7469666965722C2063616C6C696E674F626A6563744964207D203D20746869732E5F7769646765743B0D0A0D0A20202F2F2072657472696576652070726F70657274696573206F662063757272656E74206469616772616D0D0A2020766172207B';
wwv_flow_imp.g_varchar2_table(91) := '2062726561646372756D62207D203D20646174612E66696E64280D0A2020202064203D3E0D0A202020202020642E6469616772616D4964656E746966696572203D3D3D206469616772616D4964656E7469666965722026260D0A202020202020642E6361';
wwv_flow_imp.g_varchar2_table(92) := '6C6C696E674469616772616D4964656E746966696572203D3D3D2063616C6C696E674469616772616D4964656E7469666965722026260D0A202020202020642E63616C6C696E674F626A6563744964203D3D3D2063616C6C696E674F626A65637449640D';
wwv_flow_imp.g_varchar2_table(93) := '0A2020293B0D0A0D0A20202F2F2062726561646372756D62206C69737420656E7472790D0A2020766172206C696E6B203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D69667929280D0A';
wwv_flow_imp.g_varchar2_table(94) := '20202020603C6C6920646174612D696E6465783D22247B746869732E5F62726561646372756D622E6368696C644E6F6465732E6C656E6774687D220D0A20202020247B6469616772616D4964656E746966696572203F206020646174612D646961677261';
wwv_flow_imp.g_varchar2_table(95) := '6D4964656E7469666965723D22247B6469616772616D4964656E7469666965727D2260203A2027277D0D0A20202020247B63616C6C696E674469616772616D4964656E746966696572203F206020646174612D63616C6C696E674469616772616D496465';
wwv_flow_imp.g_varchar2_table(96) := '6E7469666965723D22247B63616C6C696E674469616772616D4964656E7469666965727D2260203A2027277D0D0A20202020247B63616C6C696E674F626A6563744964203F206020646174612D63616C6C696E674F626A65637449643D2224247B63616C';
wwv_flow_imp.g_varchar2_table(97) := '6C696E674F626A65637449647D2260203A2027277D3E60202B0D0A20202020603C7370616E20636C6173733D22626A732D6372756D62223E3C610D0A20202020247B63616C6C696E674F626A6563744964203F2060207469746C653D2263616C6C656420';
wwv_flow_imp.g_varchar2_table(98) := '627920247B63616C6C696E674F626A65637449647D2260203A2027277D3E60202B0D0A2020202060247B62726561646372756D627D3C2F613E3C2F7370616E3E3C2F6C693E60293B0D0A0D0A20202F2F20616464206576656E74206C697374656E65720D';
wwv_flow_imp.g_varchar2_table(99) := '0A20206C696E6B2E6164644576656E744C697374656E65722827636C69636B272C2066756E6374696F6E202829207B0D0A0D0A202020202F2F20636C69636B6564206F626A6563740D0A20202020766172207B20696E6465782C206469616772616D6964';
wwv_flow_imp.g_varchar2_table(100) := '656E746966696572207D203D206C696E6B2E646174617365743B0D0A0D0A202020202F2F2072657472696576652063757272656E74282129206869657261726368790D0A20202020636F6E7374207B2064617461207D203D205F73656C662E5F77696467';
wwv_flow_imp.g_varchar2_table(101) := '65743B0D0A0D0A202020202F2F20676574206E6577206469616772616D2066726F6D206869657261726368790D0A20202020766172206E65774469616772616D203D20646174612E66696E64280D0A20202020202064203D3E20642E6469616772616D49';
wwv_flow_imp.g_varchar2_table(102) := '64656E746966696572203D3D206469616772616D6964656E7469666965720D0A20202020293B0D0A0D0A202020202F2F20616C6C20627574206C61737420656E7472792061726520636C69636B61626C650D0A2020202069662028696E646578203C205F';
wwv_flow_imp.g_varchar2_table(103) := '73656C662E5F62726561646372756D622E6368696C644E6F6465732E6C656E677468202D203129207B0D0A0D0A2020202020202F2F207472696D2062726561646372756D6220746F20636C69636B656420656E7472790D0A2020202020205F73656C662E';
wwv_flow_imp.g_varchar2_table(104) := '7472696D42726561646372756D62546F28696E646578293B0D0A0D0A2020202020202F2F20736574206E6577206469616772616D2070726F706572746965730D0A2020202020205F73656C662E5F7769646765742E6469616772616D4964656E74696669';
wwv_flow_imp.g_varchar2_table(105) := '6572203D206E65774469616772616D2E6469616772616D4964656E7469666965723B0D0A2020202020205F73656C662E5F7769646765742E63616C6C696E674469616772616D4964656E746966696572203D206E65774469616772616D2E63616C6C696E';
wwv_flow_imp.g_varchar2_table(106) := '674469616772616D4964656E7469666965723B0D0A2020202020205F73656C662E5F7769646765742E63616C6C696E674F626A6563744964203D206E65774469616772616D2E63616C6C696E674F626A65637449643B0D0A2020202020205F73656C662E';
wwv_flow_imp.g_varchar2_table(107) := '5F7769646765742E6469616772616D203D206E65774469616772616D2E6469616772616D3B0D0A2020202020205F73656C662E5F7769646765742E63757272656E74203D206E65774469616772616D2E63757272656E743B0D0A2020202020205F73656C';
wwv_flow_imp.g_varchar2_table(108) := '662E5F7769646765742E636F6D706C65746564203D206E65774469616772616D2E636F6D706C657465643B0D0A2020202020205F73656C662E5F7769646765742E6572726F72203D206E65774469616772616D2E6572726F723B0D0A0D0A202020202020';
wwv_flow_imp.g_varchar2_table(109) := '2F2F20696E766F6B65206C6F61644469616772616D206F66207769646765740D0A2020202020205F73656C662E5F7769646765742E6C6F61644469616772616D28293B0D0A202020207D0D0A20207D293B0D0A0D0A20202F2F20617070656E6420656E74';
wwv_flow_imp.g_varchar2_table(110) := '72790D0A2020746869732E5F62726561646372756D622E617070656E644368696C64286C696E6B293B0D0A0D0A20202F2F20746F67676C65207669736962696C6974790D0A2020746869732E746F67676C6542726561646372756D625669736962696C69';
wwv_flow_imp.g_varchar2_table(111) := '747928293B0D0A7D3B0D0A0D0A437573746F6D4472696C6C646F776E2E70726F746F747970652E726573657442726561646372756D62203D2066756E6374696F6E202829207B0D0A20202F2F2072656D6F766520616C6C20656E74726965730D0A202077';
wwv_flow_imp.g_varchar2_table(112) := '68696C652028746869732E5F62726561646372756D622E66697273744368696C6429207B0D0A20202020746869732E5F62726561646372756D622E72656D6F76654368696C6428746869732E5F62726561646372756D622E66697273744368696C64293B';
wwv_flow_imp.g_varchar2_table(113) := '0D0A20207D0D0A0D0A20202F2F20746F67676C65207669736962696C6974790D0A2020746869732E746F67676C6542726561646372756D625669736962696C69747928293B0D0A7D3B0D0A0D0A437573746F6D4472696C6C646F776E2E70726F746F7479';
wwv_flow_imp.g_varchar2_table(114) := '70652E7472696D42726561646372756D62546F203D2066756E6374696F6E2028696E64657829207B0D0A202076617220666C6167203D2066616C73653B0D0A20207661722072656D6F76654E6F646573203D205B5D3B0D0A0D0A2020666F7220286C6574';
wwv_flow_imp.g_varchar2_table(115) := '2069203D20303B2069203C20746869732E5F62726561646372756D622E6368696C644E6F6465732E6C656E6774683B20692B2B29207B0D0A2020202069662028666C616729207B0D0A2020202020202F2F2061646420656E74727920746F2072656D6F76';
wwv_flow_imp.g_varchar2_table(116) := '61626C65206E6F6465730D0A20202020202072656D6F76654E6F6465732E7075736828746869732E5F62726561646372756D622E6368696C644E6F6465735B695D293B0D0A202020207D20656C73652069662028746869732E5F62726561646372756D62';
wwv_flow_imp.g_varchar2_table(117) := '2E6368696C644E6F6465735B695D2E646174617365742E696E646578203D3D3D20696E64657829207B0D0A2020202020202F2F206D61726B206173206C617374206E6F64650D0A202020202020666C6167203D20747275653B0D0A202020207D0D0A2020';
wwv_flow_imp.g_varchar2_table(118) := '7D0D0A0D0A20202F2F2072656D6F76652073756273657175656E74206E6F6465730D0A202072656D6F76654E6F6465732E666F7245616368286E203D3E20746869732E5F62726561646372756D622E72656D6F76654368696C64286E29293B0D0A0D0A20';
wwv_flow_imp.g_varchar2_table(119) := '202F2F20746F67676C65207669736962696C6974790D0A2020746869732E746F67676C6542726561646372756D625669736962696C69747928293B0D0A7D3B0D0A0D0A437573746F6D4472696C6C646F776E2E70726F746F747970652E746F67676C6542';
wwv_flow_imp.g_varchar2_table(120) := '726561646372756D625669736962696C697479203D2066756E6374696F6E202829207B0D0A20202F2F2073686F772F686964652062726561646372756D622028646570656E64696E67206F6E206E756D626572206F6620656E7472696573290D0A202069';
wwv_flow_imp.g_varchar2_table(121) := '662028746869732E5F62726561646372756D622E6368696C644E6F6465732E6C656E677468203E203129207B0D0A202020200D0A20202020636F6E73742062726561646372756D62486569676874203D20746869732E5F62726561646372756D622E6F66';
wwv_flow_imp.g_varchar2_table(122) := '667365744865696768743B0D0A202020200D0A202020202F2F2073686F7720656C656D656E740D0A20202020746869732E5F62726561646372756D622E7374796C652E646973706C6179203D2027666C6578273B0D0A202020200D0A202020202F2F2073';
wwv_flow_imp.g_varchar2_table(123) := '63726F6C6C2063616E76617320646F776E0D0A20202020746869732E5F63616E7661732E7363726F6C6C287B2064783A20302C2064793A203330202B2062726561646372756D62486569676874202B203330207D293B0D0A0D0A20207D20656C7365207B';
wwv_flow_imp.g_varchar2_table(124) := '0D0A0D0A20202020636F6E73742073756250726F6365737342726561646372756D62203D20646F63756D656E742E717565727953656C6563746F7228272E626A732D62726561646372756D62733A6E6F74282363616C6C41637469766974794272656164';
wwv_flow_imp.g_varchar2_table(125) := '6372756D622927293B0D0A0D0A202020202F2F206869646520656C656D656E740D0A20202020746869732E5F62726561646372756D622E7374796C652E646973706C6179203D20276E6F6E65273B0D0A202020200D0A202020202F2F206D6F7665207570';
wwv_flow_imp.g_varchar2_table(126) := '207375622070726F636573732062726561646372756D620D0A2020202073756250726F6365737342726561646372756D622E7374796C652E746F70203D202733307078273B0D0A20207D0D0A7D3B0D0A0D0A437573746F6D4472696C6C646F776E2E7072';
wwv_flow_imp.g_varchar2_table(127) := '6F746F747970652E736574506F736974696F6E696E67203D2066756E6374696F6E202829207B0D0A20200D0A7D3B0D0A0D0A437573746F6D4472696C6C646F776E2E24696E6A656374203D205B0D0A20202763616E766173272C0D0A2020276576656E74';
wwv_flow_imp.g_varchar2_table(128) := '427573272C0D0A202027656C656D656E745265676973747279272C0D0A2020276F7665726C617973272C0D0A2020276D6F64646C65270D0A5D3B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6D6F64756C65732F63616C6C4163746976697479';
wwv_flow_imp.g_varchar2_table(129) := '4D6F64756C652F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6D6F64756C65732F63616C6C41637469766974794D';
wwv_flow_imp.g_varchar2_table(130) := '6F64756C652F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C';
wwv_flow_imp.g_varchar2_table(131) := '652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861';
wwv_flow_imp.g_varchar2_table(132) := '726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E';
wwv_flow_imp.g_varchar2_table(133) := '20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F43616C6C41637469766974794D6F64756C655F';
wwv_flow_imp.g_varchar2_table(134) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F43616C6C41637469766974794D6F64756C65202A2F20222E2F6D6F64756C65732F63616C6C416374697669';
wwv_flow_imp.g_varchar2_table(135) := '74794D6F64756C652F43616C6C41637469766974794D6F64756C652E6A7322293B0A0D0A0D0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F20';
wwv_flow_imp.g_varchar2_table(136) := '3D20287B0D0A20205F5F696E69745F5F3A205B2763616C6C41637469766974794D6F64756C65275D2C0D0A202063616C6C41637469766974794D6F64756C653A205B2774797065272C205F43616C6C41637469766974794D6F64756C655F5F5745425041';
wwv_flow_imp.g_varchar2_table(137) := '434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D5D2C0D0A7D293B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6D6F64756C65732F6472696C6C646F776E43656E746572696E672F4472696C6C646F776E4365';
wwv_flow_imp.g_varchar2_table(138) := '6E746572696E672E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6D6F64756C65732F6472696C6C';
wwv_flow_imp.g_varchar2_table(139) := '646F776E43656E746572696E672F4472696C6C646F776E43656E746572696E672E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(140) := '2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F7265717569';
wwv_flow_imp.g_varchar2_table(141) := '72655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861';
wwv_flow_imp.g_varchar2_table(142) := '726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F204472696C6C646F776E43656E746572696E67290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2A0D0A';
wwv_flow_imp.g_varchar2_table(143) := '202A204D6F766520636F6C6C61707365642073756270726F63657373657320696E746F2076696577207768656E206472696C6C696E6720646F776E2E0D0A202A0D0A202A204F76657277726974652064656661756C74206265686176696F757220776865';
wwv_flow_imp.g_varchar2_table(144) := '7265207A6F6F6D20616E64207363726F6C6C2061726520736176656420696E20612073657373696F6E2E0D0A202A205A6F6F6D20616C7761797320726573657420746F206669742D76696577706F727420262063656E7465726564207768656E20647269';
wwv_flow_imp.g_varchar2_table(145) := '6C6C696E6720646F776E202F206D6F76696E672075700D0A202A0D0A202A2040706172616D207B6576656E744275737D206576656E744275730D0A202A2040706172616D207B63616E7661737D2063616E7661730D0A202A2F0D0A66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(146) := '4472696C6C646F776E43656E746572696E67286576656E744275732C2063616E76617329207B0D0A0D0A20206576656E744275732E6F6E2827726F6F742E736574272C2066756E6374696F6E202829207B0D0A0D0A2020202063616E7661732E7A6F6F6D';
wwv_flow_imp.g_varchar2_table(147) := '28276669742D76696577706F7274272C20276175746F27293B0D0A0D0A20207D293B0D0A7D0D0A0D0A4472696C6C646F776E43656E746572696E672E24696E6A656374203D205B276576656E74427573272C202763616E766173275D3B0A0A2F2A2A2A2F';
wwv_flow_imp.g_varchar2_table(148) := '207D292C0A0A2F2A2A2A2F20222E2F6D6F64756C65732F6472696C6C646F776E43656E746572696E672F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(149) := '2A212A5C0A2020212A2A2A202E2F6D6F64756C65732F6472696C6C646F776E43656E746572696E672F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(150) := '2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F72657175';
wwv_flow_imp.g_varchar2_table(151) := '6972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A2068';
wwv_flow_imp.g_varchar2_table(152) := '61726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E79';
wwv_flow_imp.g_varchar2_table(153) := '20696D706F7274202A2F20766172205F4472696C6C646F776E43656E746572696E675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4472696C6C646F77';
wwv_flow_imp.g_varchar2_table(154) := '6E43656E746572696E67202A2F20222E2F6D6F64756C65732F6472696C6C646F776E43656E746572696E672F4472696C6C646F776E43656E746572696E672E6A7322293B0A0D0A0D0A2F2A206861726D6F6E792064656661756C74206578706F7274202A';
wwv_flow_imp.g_varchar2_table(155) := '2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0D0A20205F5F696E69745F5F3A205B276472696C6C646F776E43656E746572696E67275D2C0D0A20206472696C6C646F776E43656E746572696E673A20';
wwv_flow_imp.g_varchar2_table(156) := '5B2774797065272C205F4472696C6C646F776E43656E746572696E675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D5D2C0D0A7D293B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6D6F64';
wwv_flow_imp.g_varchar2_table(157) := '756C65732F6D756C7469496E7374616E63654D6F64756C652F4D756C7469496E7374616E63654D6F64756C652E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(158) := '2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6D6F64756C65732F6D756C7469496E7374616E63654D6F64756C652F4D756C7469496E7374616E63654D6F64756C652E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(159) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C';
wwv_flow_imp.g_varchar2_table(160) := '205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061';
wwv_flow_imp.g_varchar2_table(161) := '636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020204D756C7469496E7374616E63654D6F64756C653A202829203D3E20282F2A2062696E64696E6720';
wwv_flow_imp.g_varchar2_table(162) := '2A2F204D756C7469496E7374616E63654D6F64756C65290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722062706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C';
wwv_flow_imp.g_varchar2_table(163) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212062706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65';
wwv_flow_imp.g_varchar2_table(164) := '732F62706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F';
wwv_flow_imp.g_varchar2_table(165) := '5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A0D0A0D0A0D0A0D0A0D0A636C617373204D756C7469';
wwv_flow_imp.g_varchar2_table(166) := '496E7374616E63654D6F64756C65207B0D0A20200D0A2020636F6E7374727563746F722863616E7661732C206576656E744275732C20656C656D656E7452656769737472792C207472616E736C6174652C206F7665726C61797329207B0D0A2020202074';
wwv_flow_imp.g_varchar2_table(167) := '6869732E5F63616E766173203D2063616E7661733B0D0A20202020746869732E5F6576656E74427573203D206576656E744275733B0D0A20202020746869732E5F656C656D656E745265676973747279203D20656C656D656E7452656769737472793B0D';
wwv_flow_imp.g_varchar2_table(168) := '0A20202020746869732E5F7472616E736C617465203D207472616E736C6174653B0D0A20202020746869732E5F6F7665726C617973203D206F7665726C6179733B0D0A0D0A20202020746869732E62726561646372756D62497465726174696F6E203D20';
wwv_flow_imp.g_varchar2_table(169) := '5B5D3B0D0A20202020746869732E62726561646372756D6253656C656374696F6E203D205B5D3B0D0A0D0A20202020636F6E7374206D6F64616C203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F';
wwv_flow_imp.g_varchar2_table(170) := '2E646F6D6966792928600D0A2020202020203C6469762069643D226D6F64616C223E0D0A20202020202020203C646976206964203D226D6F64616C2D636F6E74656E74223E0D0A202020202020202020203C6469762069643D22697465726174696F6E2D';
wwv_flow_imp.g_varchar2_table(171) := '7469746C65223E0D0A2020202020202020202020203C7370616E3E3C2F7370616E3E0D0A2020202020202020202020203C627574746F6E20636C6173733D2266612066612D74696D6573223E3C2F627574746F6E3E0D0A202020202020202020203C2F64';
wwv_flow_imp.g_varchar2_table(172) := '69763E0D0A202020202020202020203C6469762069643D22697465726174696F6E2D736561726368223E0D0A2020202020202020202020203C696E70757420747970653D22746578742220706C616365686F6C6465723D225365617263682E2E222F3E0D';
wwv_flow_imp.g_varchar2_table(173) := '0A202020202020202020203C2F6469763E0D0A202020202020202020203C6469762069643D22697465726174696F6E2D6C697374223E0D0A20202020202020202020202020203C7461626C653E0D0A202020202020202020202020202020203C74686561';
wwv_flow_imp.g_varchar2_table(174) := '643E0D0A2020202020202020202020202020202020203C74723E0D0A20202020202020202020202020202020202020203C74683E4C6F6F7020436F756E7465723C2F74683E0D0A20202020202020202020202020202020202020203C74683E4465736372';
wwv_flow_imp.g_varchar2_table(175) := '697074696F6E3C2F74683E0D0A20202020202020202020202020202020202020203C74683E5374617475733C2F74683E0D0A2020202020202020202020202020202020203C2F74723E0D0A202020202020202020202020202020203C2F74686561643E0D';
wwv_flow_imp.g_varchar2_table(176) := '0A202020202020202020202020202020203C74626F64793E3C2F74626F64793E0D0A2020202020202020202020203C2F7461626C653E0D0A202020202020202020203C2F6469763E0D0A20202020202020203C2F6469763E0D0A2020202020203C2F6469';
wwv_flow_imp.g_varchar2_table(177) := '763E0D0A2020202060293B0D0A0D0A202020202F2F20617070656E6420636F6E74656E740D0A2020202063616E7661732E676574436F6E7461696E657228292E617070656E644368696C64286D6F64616C293B0D0A0D0A202020206576656E744275732E';
wwv_flow_imp.g_varchar2_table(178) := '6F6E2827696D706F72742E72656E6465722E636F6D706C657465272C202829203D3E207B0D0A2020202020202F2F2061646420736561726368206C697374656E657220666F722066696C746572696E670D0A202020202020636F6E737420736561726368';
wwv_flow_imp.g_varchar2_table(179) := '626172203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E717565727929282723697465726174696F6E2D73656172636820696E70757427293B0D0A2020202020207365617263686261722E6164';
wwv_flow_imp.g_varchar2_table(180) := '644576656E744C697374656E657228276B65797570272C20286576656E7429203D3E207B0D0A2020202020202020746869732E66696C746572497465726174696F6E73286576656E74293B0D0A2020202020207D293B0D0A2020202020202F2F20616464';
wwv_flow_imp.g_varchar2_table(181) := '20636C6F7365206C697374656E65720D0A202020202020636F6E737420636C6F7365427574746F6E203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E717565727929282723697465726174696F';
wwv_flow_imp.g_varchar2_table(182) := '6E2D7469746C6520627574746F6E2E66612D74696D657327293B0D0A202020202020636C6F7365427574746F6E2E6164644576656E744C697374656E65722827636C69636B272C20286576656E7429203D3E207B0D0A2020202020202020746869732E63';
wwv_flow_imp.g_varchar2_table(183) := '6C6F7365497465726174696F6E7328293B0D0A2020202020207D293B0D0A202020207D293B0D0A0D0A202020202F2F207768656E206469616772616D20726F6F74206368616E6765730D0A202020206576656E744275732E6F6E2827726F6F742E736574';
wwv_flow_imp.g_varchar2_table(184) := '272C20286576656E7429203D3E207B0D0A202020202020636F6E7374207B20656C656D656E74207D203D206576656E743B0D0A0D0A2020202020202F2F2072657365742062726561646372756D62206461746120286E756C6C20616C6C20656E74726965';
wwv_flow_imp.g_varchar2_table(185) := '732061626F7665207468652063757272656E74290D0A202020202020746869732E726573657442726561646372756D624461746128293B0D0A0D0A2020202020202F2F206966206472696C6C656420646F776E20696E746F2073756270726F636573730D';
wwv_flow_imp.g_varchar2_table(186) := '0A2020202020206966202828302C62706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69732928656C656D656E742C202762706D6E3A53756250726F6365737327';
wwv_flow_imp.g_varchar2_table(187) := '2929207B0D0A202020202020202069662028746869732E686173497465726174696F6E4461746128656C656D656E742929207B0D0A202020202020202020202F2F207570646174652062726561646372756D6220646174613A206D61726B206375727265';
wwv_flow_imp.g_varchar2_table(188) := '6E7420656E74727920617320697465726174696E670D0A20202020202020202020746869732E62726561646372756D62497465726174696F6E5B746869732E6765744C61737442726561646372756D62496E64657828295D203D20747275653B0D0A2020';
wwv_flow_imp.g_varchar2_table(189) := '20202020202020202F2F207570646174652062726561646372756D623A2061646420627574746F6E20286966206C61737420656C656D656E74290D0A20202020202020202020746869732E617070656E6442726561646372756D62427574746F6E28656C';
wwv_flow_imp.g_varchar2_table(190) := '656D656E74293B0D0A20202020202020207D0D0A2020202020202020746869732E75706461746542726561646372756D6228293B0D0A2020202020207D0D0A0D0A2020202020202F2F2075706461746520686967686C69676874696E67202866726F6D20';
wwv_flow_imp.g_varchar2_table(191) := '63757272656E7420697465726174696F6E290D0A202020202020746869732E757064617465486967686C69676874696E6728293B0D0A202020207D293B0D0A20207D0D0A0D0A20202F2A20496E697469616C69736174696F6E202A2F0D0A0D0A20207365';
wwv_flow_imp.g_varchar2_table(192) := '745769646765742877696467657429207B0D0A20202020746869732E5F776964676574203D207769646765743B0D0A20207D0D0A0D0A20202F2A2048656C706572202A2F0D0A0D0A2020676574497465726174696F6E4461746128656C656D656E742920';
wwv_flow_imp.g_varchar2_table(193) := '7B0D0A0D0A20202020636F6E7374207B206964207D203D2028302C62706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E676574427573696E6573734F626A656374';
wwv_flow_imp.g_varchar2_table(194) := '2928656C656D656E74293B0D0A0D0A202020202F2F2067657420706172656E7420697465726174696F6E2066726F6D2062726561646372756D620D0A20202020636F6E737420706172656E74497465726174696F6E203D20746869732E62726561646372';
wwv_flow_imp.g_varchar2_table(195) := '756D6253656C656374696F6E5B746869732E6765744C61737442726561646372756D62496E6465782829202D20315D3B0D0A0D0A202020202F2F20726574726965766520646174612066726F6D20776964676574206279207573696E6720696420616E64';
wwv_flow_imp.g_varchar2_table(196) := '20737465704B65790D0A2020202072657475726E2028746869732E5F7769646765742E697465726174696F6E446174612026260D0A202020202020746869732E5F7769646765742E697465726174696F6E446174615B69645D2026260D0A202020202020';
wwv_flow_imp.g_varchar2_table(197) := '746869732E5F7769646765742E697465726174696F6E446174615B69645D2E66696C746572280D0A202020202020202069203D3E20282821706172656E74497465726174696F6E2026262021692E706172656E74537465704B657929207C7C2028706172';
wwv_flow_imp.g_varchar2_table(198) := '656E74497465726174696F6E20262620692E706172656E74537465704B6579203D3D20706172656E74497465726174696F6E2E737465704B657929290D0A2020202020202929207C7C205B5D3B0D0A20207D0D0A0D0A20202F2A204F7665726C61797320';
wwv_flow_imp.g_varchar2_table(199) := '2A2F0D0A0D0A20206164644F7665726C6179732829207B0D0A20202020746869732E5F656C656D656E7452656769737472790D0A2020202020202F2F20696420656C656D656E74206973206E6F2073756270726F6365737320616E642068617320697465';
wwv_flow_imp.g_varchar2_table(200) := '726174696F6E20646174610D0A2020202020202E66696C74657228656C656D656E74203D3E20212828302C62706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69';
wwv_flow_imp.g_varchar2_table(201) := '732928656C656D656E742C202762706D6E3A53756250726F6365737327292920262620746869732E686173497465726174696F6E4461746128656C656D656E7429290D0A2020202020202E666F72456163682828656C656D656E7429203D3E207B0D0A20';
wwv_flow_imp.g_varchar2_table(202) := '20202020202020746869732E6164644F7665726C617928656C656D656E74293B0D0A2020202020207D293B0D0A20207D0D0A0D0A20206164644F7665726C617928656C656D656E7429207B0D0A0D0A20202020636F6E737420627574746F6E203D202830';
wwv_flow_imp.g_varchar2_table(203) := '2C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D6966792928273C627574746F6E20636C6173733D22626A732D6472696C6C646F776E2066612066612D6C697374223E3C2F627574746F6E3E27293B';
wwv_flow_imp.g_varchar2_table(204) := '0D0A0D0A202020202F2F20616464206F6E636C69636B206C697374656E65720D0A20202020627574746F6E2E6164644576656E744C697374656E65722827636C69636B272C20285F29203D3E207B0D0A202020202020746869732E6F70656E4974657261';
wwv_flow_imp.g_varchar2_table(205) := '74696F6E7328656C656D656E74293B0D0A202020207D293B0D0A0D0A202020202F2F20616464206F7665726C61790D0A20202020746869732E5F6F7665726C6179732E61646428656C656D656E742C2027697465726174696F6E73272C207B0D0A202020';
wwv_flow_imp.g_varchar2_table(206) := '202020706F736974696F6E3A207B0D0A2020202020202020626F74746F6D3A202D372C0D0A202020202020202072696768743A202D380D0A2020202020207D2C0D0A20202020202068746D6C3A20627574746F6E0D0A202020207D293B0D0A20207D0D0A';
wwv_flow_imp.g_varchar2_table(207) := '0D0A20202F2A20426F6F6C65616E2066756E6374696F6E73202A2F0D0A0D0A202069734D756C7469496E7374616E636553756250726F6365737328656C656D656E7429207B0D0A20202020636F6E737420627573696E6573734F626A656374203D202830';
wwv_flow_imp.g_varchar2_table(208) := '2C62706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E676574427573696E6573734F626A6563742928656C656D656E74293B0D0A2020202072657475726E202830';
wwv_flow_imp.g_varchar2_table(209) := '2C62706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69732928656C656D656E742C202762706D6E3A53756250726F63657373272920262620627573696E657373';
wwv_flow_imp.g_varchar2_table(210) := '4F626A6563742E6C6F6F704368617261637465726973746963733B0D0A20207D0D0A0D0A2020686173497465726174696F6E4461746128656C656D656E7429207B0D0A2020202072657475726E20746869732E676574497465726174696F6E4461746128';
wwv_flow_imp.g_varchar2_table(211) := '656C656D656E74292E6C656E677468203E20303B0D0A20207D0D0A0D0A20202F2A2042726561646372756D62202A2F0D0A0D0A202067657442726561646372756D62456C656D656E74732829207B0D0A20202020636F6E73742062726561646372756D62';
wwv_flow_imp.g_varchar2_table(212) := '203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E71756572792928272E626A732D62726561646372756D627327293B202F2F20544F444F206669782073656C6563746F7220666F72206578636C';
wwv_flow_imp.g_varchar2_table(213) := '7564696E672063616C6C2061637469766974792062726561646372756D620D0A2020202072657475726E205B2E2E2E62726561646372756D622E6368696C6472656E5D3B0D0A20207D0D0A0D0A20206765744C61737442726561646372756D62496E6465';
wwv_flow_imp.g_varchar2_table(214) := '782829207B0D0A20202020636F6E737420656C656D656E7473203D20746869732E67657442726561646372756D62456C656D656E747328293B0D0A2020202072657475726E20656C656D656E74732E6C656E677468202D20313B0D0A20207D0D0A0D0A20';
wwv_flow_imp.g_varchar2_table(215) := '20726573657442726561646372756D62446174612829207B0D0A20202020636F6E7374206C617374496E646578203D20746869732E6765744C61737442726561646372756D62496E64657828293B0D0A0D0A20202020746869732E62726561646372756D';
wwv_flow_imp.g_varchar2_table(216) := '62497465726174696F6E2E73706C696365286C617374496E646578202B2031293B0D0A20202020746869732E62726561646372756D6253656C656374696F6E2E73706C696365286C617374496E646578202B2031293B0D0A20207D0D0A0D0A2020617070';
wwv_flow_imp.g_varchar2_table(217) := '656E6442726561646372756D62427574746F6E28656C656D656E7429207B0D0A0D0A20202020636F6E7374206C617374456C656D656E74203D20746869732E67657442726561646372756D62456C656D656E747328292E706F7028293B0D0A0D0A202020';
wwv_flow_imp.g_varchar2_table(218) := '202F2F20696620656C656D656E74206578697374696E6720286D69676874206265206E756C6C206F6E206469616772616D206C6F6164290D0A20202020696620286C617374456C656D656E7429207B0D0A2020202020202F2F2063726561746520627574';
wwv_flow_imp.g_varchar2_table(219) := '746F6E0D0A202020202020636F6E737420627574746F6E203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D6966792928273C627574746F6E20636C6173733D22626A732D6472696C6C64';
wwv_flow_imp.g_varchar2_table(220) := '6F776E2066612066612D6C697374223E3C2F627574746F6E3E27293B0D0A2020202020202F2F20616464206576656E74206C697374656E65720D0A202020202020627574746F6E2E6164644576656E744C697374656E65722827636C69636B272C20285F';
wwv_flow_imp.g_varchar2_table(221) := '29203D3E207B0D0A20202020202020202F2F206F70656E20697465726174696F6E7320666F72207468697320656C656D656E740D0A2020202020202020746869732E6F70656E497465726174696F6E7328656C656D656E74293B0D0A2020202020207D29';
wwv_flow_imp.g_varchar2_table(222) := '3B0D0A0D0A2020202020206C617374456C656D656E742E617070656E6428627574746F6E293B0D0A202020207D0D0A20207D0D0A0D0A202075706461746542726561646372756D622829207B0D0A0D0A20202020636F6E737420656C656D656E7473203D';
wwv_flow_imp.g_varchar2_table(223) := '20746869732E67657442726561646372756D62456C656D656E747328293B0D0A0D0A20202020666F7220286C65742069203D20303B2069203C20656C656D656E74732E6C656E6774683B20692B2B29207B0D0A0D0A202020202020636F6E737420646174';
wwv_flow_imp.g_varchar2_table(224) := '61203D20746869732E62726561646372756D62497465726174696F6E5B695D3B0D0A0D0A2020202020202F2F2069662063757272656E742062726561646372756D6220656E7472792068617320697465726174696F6E20646174612026206973206E6F74';
wwv_flow_imp.g_varchar2_table(225) := '206C61737420656C656D656E740D0A20202020202069662028646174612026262069203C20656C656D656E74732E6C656E677468202D203129207B0D0A0D0A2020202020202020636F6E7374206578697374696E67203D2028302C6D696E5F646F6D5F5F';
wwv_flow_imp.g_varchar2_table(226) := '5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E71756572792928277370616E2E697465726174696F6E2D627574746F6E272C20656C656D656E74735B695D293B0D0A0D0A2020202020202020636F6E7374207370616E203D202830';
wwv_flow_imp.g_varchar2_table(227) := '2C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D6966792928273C7370616E20636C6173733D22626A732D6372756D6220697465726174696F6E2D627574746F6E2066612066612D6C697374223E3C';
wwv_flow_imp.g_varchar2_table(228) := '2F7370616E3E27293B0D0A20202020202020200D0A20202020202020202F2F20617070656E64207370616E206F72207265706C6163652074657874206966206578697374696E670D0A202020202020202069662028216578697374696E672920656C656D';
wwv_flow_imp.g_varchar2_table(229) := '656E74735B695D2E617070656E64287370616E293B0D0A2020202020202020656C7365206578697374696E672E7265706C61636557697468287370616E293B0D0A2020202020207D0D0A0D0A202020202020636F6E73742073656C6563746564203D2074';
wwv_flow_imp.g_varchar2_table(230) := '6869732E62726561646372756D6253656C656374696F6E5B695D3B0D0A0D0A2020202020202F2F2069662063757272656E742062726561646372756D6220656E747279206861732073656C656374656420697465726174696F6E0D0A2020202020206966';
wwv_flow_imp.g_varchar2_table(231) := '202873656C656374656429207B0D0A0D0A2020202020202020636F6E7374206578697374696E67203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E71756572792928277370616E2E6974657261';
wwv_flow_imp.g_varchar2_table(232) := '74696F6E2D64657363272C20656C656D656E74735B695D293B0D0A0D0A2020202020202020636F6E7374207370616E203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D6966792928603C';
wwv_flow_imp.g_varchar2_table(233) := '7370616E20636C6173733D22626A732D6372756D6220697465726174696F6E2D64657363223E247B73656C65637465642E6465736372697074696F6E7D3C2F7370616E3E60293B0D0A0D0A20202020202020202F2F20617070656E64207370616E206F72';
wwv_flow_imp.g_varchar2_table(234) := '207265706C6163652074657874206966206578697374696E670D0A202020202020202069662028216578697374696E672920656C656D656E74735B695D2E617070656E64287370616E293B0D0A2020202020202020656C7365206578697374696E672E72';
wwv_flow_imp.g_varchar2_table(235) := '65706C61636557697468287370616E293B0D0A2020202020207D0D0A202020207D0D0A20207D0D0A0D0A20202F2A206469616C6F67202A2F0D0A0D0A20206F70656E4469616C6F672829207B0D0A0D0A20202020636F6E73742073656172636862617220';
wwv_flow_imp.g_varchar2_table(236) := '3D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E717565727929282723697465726174696F6E2D73656172636820696E70757427293B0D0A20202020636F6E7374206D6F64616C203D2028302C6D';
wwv_flow_imp.g_varchar2_table(237) := '696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E7175657279292827236D6F64616C27293B0D0A0D0A202020202F2F20636C656172207365617263686261720D0A202020207365617263686261722E76616C7565';
wwv_flow_imp.g_varchar2_table(238) := '203D2027273B0D0A202020202F2F2073686F77206D6F64616C0D0A202020206D6F64616C2E7374796C652E646973706C6179203D2027666C6578273B0D0A20207D0D0A0D0A20206C6F61645461626C65286461746129207B0D0A0D0A20202020636F6E73';
wwv_flow_imp.g_varchar2_table(239) := '742074626F6479203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E717565727929282723697465726174696F6E2D6C6973742074626F647927293B0D0A0D0A202020202F2F206275696C642074';
wwv_flow_imp.g_varchar2_table(240) := '61626C6520626F64790D0A2020202074626F64792E7265706C6163654368696C6472656E280D0A2020202020202E2E2E2864617461207C7C20746869732E6469616C6F6744617461292E6D617028286429203D3E207B0D0A2020202020202020636F6E73';
wwv_flow_imp.g_varchar2_table(241) := '7420726F77203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D6966792928600D0A20202020202020203C747220247B746869732E6469616C6F67436C69636B61626C65203F2027636C61';
wwv_flow_imp.g_varchar2_table(242) := '73733D22636C69636B61626C652227203A2027277D3E0D0A202020202020202020203C74643E247B642E6C6F6F70436F756E7465727D3C2F74643E0D0A202020202020202020203C74643E247B642E6465736372697074696F6E7D3C2F74643E0D0A2020';
wwv_flow_imp.g_varchar2_table(243) := '20202020202020203C74643E247B642E7374617475737D3C2F74643E0D0A20202020202020203C2F74723E0D0A20202020202060293B0D0A0D0A20202020202020202F2F20616464206F6E636C69636B206C697374656E657220696620726F7773206172';
wwv_flow_imp.g_varchar2_table(244) := '6520636C69636B61626C6520287375622070726F636573736573290D0A202020202020202069662028746869732E6469616C6F67436C69636B61626C6529207B0D0A20202020202020202020726F772E6164644576656E744C697374656E65722827636C';
wwv_flow_imp.g_varchar2_table(245) := '69636B272C20285F29203D3E207B0D0A202020202020202020202020746869732E6C6F6164497465726174696F6E28642E6C6F6F70436F756E746572293B0D0A202020202020202020202020746869732E636C6F7365497465726174696F6E7328293B0D';
wwv_flow_imp.g_varchar2_table(246) := '0A202020202020202020207D293B0D0A20202020202020207D0D0A0D0A202020202020202072657475726E20726F773B0D0A2020202020207D29293B0D0A20207D0D0A0D0A20206F70656E497465726174696F6E7328656C656D656E7429207B0D0A0D0A';
wwv_flow_imp.g_varchar2_table(247) := '202020202F2F2073746F7265206461746120616E6420636C69636B61626C6520696E666F20666F72206C617465720D0A20202020746869732E6469616C6F6744617461203D20746869732E676574497465726174696F6E4461746128656C656D656E7429';
wwv_flow_imp.g_varchar2_table(248) := '3B0D0A20202020746869732E6469616C6F67436C69636B61626C65203D2028302C62706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69732928656C656D656E74';
wwv_flow_imp.g_varchar2_table(249) := '2C202762706D6E3A53756250726F6365737327293B0D0A0D0A2020202069662028746869732E6469616C6F674461746129207B0D0A0D0A202020202020746869732E6C6F61645461626C6528293B0D0A0D0A2020202020202F2F20736574207469746C65';
wwv_flow_imp.g_varchar2_table(250) := '0D0A202020202020636F6E7374207469746C65203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E717565727929282723697465726174696F6E2D7469746C65207370616E27293B0D0A20202020';
wwv_flow_imp.g_varchar2_table(251) := '20207469746C652E74657874436F6E74656E74203D2028302C62706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E676574427573696E6573734F626A6563742928';
wwv_flow_imp.g_varchar2_table(252) := '656C656D656E74292E6E616D653B0D0A0D0A202020202020746869732E6F70656E4469616C6F6728293B0D0A202020207D0D0A20207D0D0A0D0A2020636C6F7365497465726174696F6E732829207B0D0A0D0A20202020636F6E7374206D6F64616C203D';
wwv_flow_imp.g_varchar2_table(253) := '2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E7175657279292827236D6F64616C27293B0D0A0D0A202020206D6F64616C2E7374796C652E646973706C6179203D20276E6F6E65273B0D0A20207D';
wwv_flow_imp.g_varchar2_table(254) := '0D0A0D0A20206C6F6164497465726174696F6E286C6F6F70436F756E74657229207B0D0A0D0A20202020636F6E73742073656C6563746564497465726174696F6E203D20746869732E6469616C6F67446174612E66696E642876203D3E20762E6C6F6F70';
wwv_flow_imp.g_varchar2_table(255) := '436F756E746572203D3D206C6F6F70436F756E746572293B0D0A0D0A20202020746869732E62726561646372756D6253656C656374696F6E5B746869732E6765744C61737442726561646372756D62496E64657828295D203D2073656C65637465644974';
wwv_flow_imp.g_varchar2_table(256) := '65726174696F6E3B0D0A0D0A20202020746869732E75706461746542726561646372756D6228293B0D0A20202020746869732E757064617465486967686C69676874696E6728293B0D0A20207D0D0A0D0A202066696C746572497465726174696F6E7328';
wwv_flow_imp.g_varchar2_table(257) := '6576656E7429207B0D0A0D0A20202020636F6E7374207B2076616C7565207D203D206576656E742E7461726765743B0D0A0D0A20202020636F6E73742066696C7465726564203D20746869732E6469616C6F67446174612E66696C746572280D0A202020';
wwv_flow_imp.g_varchar2_table(258) := '20202064203D3E20642E6465736372697074696F6E2E696E636C756465732876616C756529207C7C20642E7374617475732E696E636C756465732876616C7565290D0A20202020293B0D0A0D0A20202020746869732E6C6F61645461626C652866696C74';
wwv_flow_imp.g_varchar2_table(259) := '65726564293B0D0A20207D0D0A0D0A20202F2A205574696C202A2F0D0A20200D0A2020757064617465486967686C69676874696E672829207B0D0A0D0A2020202069662028746869732E5F77696467657429207B0D0A0D0A202020202020636F6E737420';
wwv_flow_imp.g_varchar2_table(260) := '63757272656E74497465726174696F6E203D20746869732E62726561646372756D6253656C656374696F6E5B746869732E6765744C61737442726561646372756D62496E64657828295D3B0D0A0D0A2020202020206966202863757272656E7449746572';
wwv_flow_imp.g_varchar2_table(261) := '6174696F6E29207B0D0A2020202020202020636F6E7374207B2063757272656E742C20636F6D706C657465642C206572726F72207D203D2063757272656E74497465726174696F6E2E686967686C69676874696E673B0D0A202020202020202074686973';
wwv_flow_imp.g_varchar2_table(262) := '2E5F7769646765742E757064617465436F6C6F72732863757272656E742C20636F6D706C657465642C206572726F72293B0D0A2020202020207D20656C7365207B0D0A2020202020202020746869732E5F7769646765742E7265736574436F6C6F727328';
wwv_flow_imp.g_varchar2_table(263) := '293B0D0A2020202020207D0D0A202020207D0D0A20207D0D0A7D0D0A0D0A4D756C7469496E7374616E63654D6F64756C652E24696E6A656374203D205B2763616E766173272C20276576656E74427573272C2027656C656D656E74526567697374727927';
wwv_flow_imp.g_varchar2_table(264) := '2C20277472616E736C617465272C20276F7665726C617973275D3B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6D6F64756C65732F6D756C7469496E7374616E63654D6F64756C652F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(265) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6D6F64756C65732F6D756C7469496E7374616E63654D6F64756C652F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(266) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F77';
wwv_flow_imp.g_varchar2_table(267) := '65627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F72';
wwv_flow_imp.g_varchar2_table(268) := '6571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F';
wwv_flow_imp.g_varchar2_table(269) := '5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F4D756C7469496E7374616E63654D6F64756C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F30';
wwv_flow_imp.g_varchar2_table(270) := '5F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4D756C7469496E7374616E63654D6F64756C65202A2F20222E2F6D6F64756C65732F6D756C7469496E7374616E63654D6F64756C652F4D756C7469496E7374616E63654D6F';
wwv_flow_imp.g_varchar2_table(271) := '64756C652E6A7322293B0A0D0A0D0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0D0A20205F5F696E69745F5F3A205B276D756C';
wwv_flow_imp.g_varchar2_table(272) := '7469496E7374616E63654D6F64756C65275D2C0D0A20206D756C7469496E7374616E63654D6F64756C653A205B2774797065272C205F4D756C7469496E7374616E63654D6F64756C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F30';
wwv_flow_imp.g_varchar2_table(273) := '5F5F2E4D756C7469496E7374616E63654D6F64756C655D2C0D0A7D293B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6D6F64756C65732F7374796C654D6F64756C652F5374796C654D6F64756C652E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(274) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6D6F64756C65732F7374796C654D6F64756C652F5374796C654D6F64756C652E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(275) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(276) := '5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F72657175697265';
wwv_flow_imp.g_varchar2_table(277) := '5F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F205374796C654D6F64756C65290A2F2A2068';
wwv_flow_imp.g_varchar2_table(278) := '61726D6F6E79206578706F7274202A2F207D293B0A66756E6374696F6E205374796C654D6F64756C6528636F6E6669672C2062706D6E52656E64657265722C20656C656D656E74526567697374727929207B0D0A0D0A20202F2F2073657420676C6F6261';
wwv_flow_imp.g_varchar2_table(279) := '6C20637373207661726961626C65730D0A2020636F6E73742063616E766173203D20646F63756D656E742E717565727953656C6563746F7228272E63616E76617327293B0D0A0D0A202063616E7661732E7374796C652E73657450726F70657274792827';
wwv_flow_imp.g_varchar2_table(280) := '2D2D686967686C696768742D63757272656E742D66696C6C272C20636F6E6669672E63757272656E745374796C652E66696C6C293B0D0A202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D6375727265';
wwv_flow_imp.g_varchar2_table(281) := '6E742D626F72646572272C20636F6E6669672E63757272656E745374796C652E626F72646572293B0D0A202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D63757272656E742D6C6162656C272C20636F';
wwv_flow_imp.g_varchar2_table(282) := '6E6669672E63757272656E745374796C652E6C6162656C293B0D0A202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D636F6D706C657465642D66696C6C272C20636F6E6669672E636F6D706C65746564';
wwv_flow_imp.g_varchar2_table(283) := '5374796C652E66696C6C293B0D0A202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D636F6D706C657465642D626F72646572272C20636F6E6669672E636F6D706C657465645374796C652E626F726465';
wwv_flow_imp.g_varchar2_table(284) := '72293B0D0A202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D636F6D706C657465642D6C6162656C272C20636F6E6669672E636F6D706C657465645374796C652E6C6162656C293B0D0A202063616E76';
wwv_flow_imp.g_varchar2_table(285) := '61732E7374796C652E73657450726F706572747928272D2D686967686C696768742D6572726F722D66696C6C272C20636F6E6669672E6572726F725374796C652E66696C6C293B0D0A202063616E7661732E7374796C652E73657450726F706572747928';
wwv_flow_imp.g_varchar2_table(286) := '272D2D686967686C696768742D6572726F722D626F72646572272C20636F6E6669672E6572726F725374796C652E626F72646572293B0D0A202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D6572726F';
wwv_flow_imp.g_varchar2_table(287) := '722D6C6162656C272C20636F6E6669672E6572726F725374796C652E6C6162656C293B0D0A0D0A2020746869732E6164645374796C65546F456C656D656E7473203D2066756E6374696F6E2028656C656D656E74732C20636C6173734E616D6529207B0D';
wwv_flow_imp.g_varchar2_table(288) := '0A0D0A202020206C657420656C656D656E743B0D0A0D0A20202020666F722028636F6E73742065206F6620656C656D656E747329207B0D0A0D0A202020202020656C656D656E74203D20646F63756D656E742E717565727953656C6563746F722860675B';
wwv_flow_imp.g_varchar2_table(289) := '646174612D656C656D656E742D69643D22247B657D225D3A6E6F74282E646A732D636F6E6E656374696F6E29202E646A732D76697375616C60293B0D0A0D0A20202020202069662028656C656D656E7429207B0D0A2020202020202020656C656D656E74';
wwv_flow_imp.g_varchar2_table(290) := '2E636C6173734C6973742E61646428636C6173734E616D65293B0D0A2020202020207D0D0A202020207D0D0A20207D3B0D0A20200D0A2020746869732E686967686C69676874456C656D656E7473203D2066756E6374696F6E202863757272656E742C20';
wwv_flow_imp.g_varchar2_table(291) := '636F6D706C657465642C206572726F7229207B0D0A202020206966202863757272656E742026262063757272656E742E6C656E677468203E20302920746869732E6164645374796C65546F456C656D656E74732863757272656E742C2027686967686C69';
wwv_flow_imp.g_varchar2_table(292) := '6768742D63757272656E7427293B0D0A2020202069662028636F6D706C6574656420262620636F6D706C657465642E6C656E677468203E20302920746869732E6164645374796C65546F456C656D656E747328636F6D706C657465642C2027686967686C';
wwv_flow_imp.g_varchar2_table(293) := '696768742D636F6D706C6574656427293B0D0A20202020696620286572726F72202626206572726F722E6C656E677468203E20302920746869732E6164645374796C65546F456C656D656E7473286572726F722C2027686967686C696768742D6572726F';
wwv_flow_imp.g_varchar2_table(294) := '7227293B0D0A20207D3B0D0A0D0A2020746869732E7265736574486967686C69676874696E67203D2066756E6374696F6E202829207B0D0A0D0A20202020636F6E737420656C656D656E7473203D204F626A6563742E6B65797328656C656D656E745265';
wwv_flow_imp.g_varchar2_table(295) := '6769737472792E5F656C656D656E7473293B0D0A202020206C657420656C656D656E743B0D0A0D0A20202020666F722028636F6E73742065206F6620656C656D656E747329207B0D0A0D0A202020202020656C656D656E74203D20646F63756D656E742E';
wwv_flow_imp.g_varchar2_table(296) := '717565727953656C6563746F722860675B646174612D656C656D656E742D69643D22247B657D225D3A6E6F74282E646A732D636F6E6E656374696F6E29202E646A732D76697375616C60293B0D0A0D0A20202020202069662028656C656D656E7429207B';
wwv_flow_imp.g_varchar2_table(297) := '0D0A2020202020202020656C656D656E742E636C6173734C6973742E72656D6F76652827686967686C696768742D63757272656E7427293B0D0A2020202020202020656C656D656E742E636C6173734C6973742E72656D6F76652827686967686C696768';
wwv_flow_imp.g_varchar2_table(298) := '742D636F6D706C6574656427293B0D0A2020202020202020656C656D656E742E636C6173734C6973742E72656D6F76652827686967686C696768742D6572726F7227293B0D0A2020202020207D0D0A202020207D0D0A20207D3B0D0A0D0A202074686973';
wwv_flow_imp.g_varchar2_table(299) := '2E726573657442504D4E636F6C6F7273203D2066756E6374696F6E202829207B0D0A0D0A20202020636F6E737420656C656D656E7473203D204F626A6563742E6B65797328656C656D656E7452656769737472792E5F656C656D656E7473293B0D0A2020';
wwv_flow_imp.g_varchar2_table(300) := '20206C657420656C656D656E743B0D0A0D0A20202020666F722028636F6E73742065206F6620656C656D656E747329207B0D0A0D0A202020202020656C656D656E74203D20646F63756D656E742E717565727953656C6563746F722860675B646174612D';
wwv_flow_imp.g_varchar2_table(301) := '656C656D656E742D69643D22247B657D225D3A6E6F74282E646A732D636F6E6E656374696F6E29202E646A732D76697375616C60293B0D0A0D0A20202020202069662028656C656D656E7429207B0D0A0D0A2020202020202020656C656D656E742E636C';
wwv_flow_imp.g_varchar2_table(302) := '6173734C6973742E616464282772657365742D62706D6E2D636F6C6F727327293B0D0A2020202020207D0D0A202020207D0D0A20207D3B0D0A0D0A2020746869732E6164645374796C65546F535647203D2066756E6374696F6E202873766729207B0D0A';
wwv_flow_imp.g_varchar2_table(303) := '20202020636F6E737420706172736572203D206E657720444F4D50617273657228293B0D0A20202020636F6E737420786D6C446F63203D207061727365722E706172736546726F6D537472696E67287376672C2027746578742F786D6C27293B0D0A2020';
wwv_flow_imp.g_varchar2_table(304) := '0D0A20202020636F6E7374205B646566735D203D20786D6C446F632E676574456C656D656E747342795461674E616D6528276465667327293B0D0A20200D0A20202020636F6E7374207374796C654E6F6465203D20646F63756D656E742E637265617465';
wwv_flow_imp.g_varchar2_table(305) := '456C656D656E7428277374796C6527293B0D0A202020207374796C654E6F64652E736574417474726962757465282774797065272C2027746578742F63737327293B0D0A0D0A20202020636F6E737420636F6E74656E74203D20646F63756D656E742E63';
wwv_flow_imp.g_varchar2_table(306) := '7265617465546578744E6F646528272E646A732D67726F7570207B202D2D64656661756C742D66696C6C2D636F6C6F723A2077686974653B202D2D64656661756C742D7374726F6B652D636F6C6F723A20626C61636B3B207D27293B0D0A202020207374';
wwv_flow_imp.g_varchar2_table(307) := '796C654E6F64652E617070656E644368696C6428636F6E74656E74293B0D0A202020200D0A20202020646566732E617070656E644368696C64287374796C654E6F6465293B0D0A20200D0A20202020636F6E737420786D6C54657874203D206E65772058';
wwv_flow_imp.g_varchar2_table(308) := '4D4C53657269616C697A657228292E73657269616C697A65546F537472696E6728786D6C446F63293B0D0A20200D0A2020202072657475726E20786D6C546578743B0D0A20207D3B0D0A7D0D0A0D0A5374796C654D6F64756C652E24696E6A656374203D';
wwv_flow_imp.g_varchar2_table(309) := '205B0D0A20202F2F20637573746F6D207669657765722070726F70657274696573206E657374656420696E7369646520706172656E7420636F6E666967206F626A6563740D0A202027636F6E6669672E636F6E666967272C0D0A202027636F6E6669672E';
wwv_flow_imp.g_varchar2_table(310) := '62706D6E52656E6465726572272C0D0A202027656C656D656E745265676973747279270D0A5D3B0D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6D6F64756C65732F7374796C654D6F64756C652F696E6465782E6A73223A0A2F2A212A2A2A';
wwv_flow_imp.g_varchar2_table(311) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6D6F64756C65732F7374796C654D6F64756C652F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(312) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F2920';
wwv_flow_imp.g_varchar2_table(313) := '3D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061';
wwv_flow_imp.g_varchar2_table(314) := '636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F';
wwv_flow_imp.g_varchar2_table(315) := '7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F5374796C654D6F64756C655F6A735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F';
wwv_flow_imp.g_varchar2_table(316) := '5F282F2A21202E2F5374796C654D6F64756C652E6A73202A2F20222E2F6D6F64756C65732F7374796C654D6F64756C652F5374796C654D6F64756C652E6A7322293B0A0D0A0D0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20';
wwv_flow_imp.g_varchar2_table(317) := '636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0D0A20205F5F696E69745F5F3A205B277374796C654D6F64756C65275D2C0D0A20207374796C654D6F64756C653A205B2774797065272C205F5374796C654D';
wwv_flow_imp.g_varchar2_table(318) := '6F64756C655F6A735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D5D0D0A7D293B0D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6D6F64756C65732F757365725461736B4D6F64756C65';
wwv_flow_imp.g_varchar2_table(319) := '2F557365725461736B4D6F64756C652E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6D6F64756C65732F7573657254';
wwv_flow_imp.g_varchar2_table(320) := '61736B4D6F64756C652F557365725461736B4D6F64756C652E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E';
wwv_flow_imp.g_varchar2_table(321) := '757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(322) := '5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F20';
wwv_flow_imp.g_varchar2_table(323) := '2020557365725461736B4D6F64756C653A202829203D3E20282F2A2062696E64696E67202A2F20557365725461736B4D6F64756C65290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F';
wwv_flow_imp.g_varchar2_table(324) := '207661722062706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212062706D6E2D6A732F6C69622F75';
wwv_flow_imp.g_varchar2_table(325) := '74696C2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F';
wwv_flow_imp.g_varchar2_table(326) := '5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E';
wwv_flow_imp.g_varchar2_table(327) := '65736D2E6A7322293B0A0D0A0D0A0D0A0D0A636C61737320557365725461736B4D6F64756C65207B0D0A0D0A2020636F6E7374727563746F722863616E7661732C206576656E744275732C20656C656D656E7452656769737472792C207472616E736C61';
wwv_flow_imp.g_varchar2_table(328) := '74652C206F7665726C61797329207B0D0A20202020746869732E5F63616E766173203D2063616E7661733B0D0A20202020746869732E5F6576656E74427573203D206576656E744275733B0D0A20202020746869732E5F656C656D656E74526567697374';
wwv_flow_imp.g_varchar2_table(329) := '7279203D20656C656D656E7452656769737472793B0D0A20202020746869732E5F7472616E736C617465203D207472616E736C6174653B0D0A20202020746869732E5F6F7665726C617973203D206F7665726C6179733B0D0A20207D0D0A0D0A20206164';
wwv_flow_imp.g_varchar2_table(330) := '644F7665726C6179732829207B0D0A0D0A20202020636F6E7374207B20757365725461736B44617461207D203D20746869732E5F7769646765743B0D0A0D0A20202020746869732E5F656C656D656E7452656769737472792E66696C7465722828656C65';
wwv_flow_imp.g_varchar2_table(331) := '6D656E7429203D3E207B0D0A202020202020636F6E737420626F203D2028302C62706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E676574427573696E6573734F';
wwv_flow_imp.g_varchar2_table(332) := '626A6563742928656C656D656E74293B0D0A2020202020202F2A206F6E6C792073686F77206C696E6B20627574746F6E2069660D0A202020202020202A202D20656C656D656E7420697320757365725461736B0D0A202020202020202A202D206C696E6B';
wwv_flow_imp.g_varchar2_table(333) := '206973206578697374696E670D0A202020202020202A202D20656C656D656E74206973206E6F7420697465726174696E670D0A202020202020202A202D20706172656E74206973206E6F7420697465726174696E670D0A202020202020202A2F0D0A2020';
wwv_flow_imp.g_varchar2_table(334) := '2020202072657475726E2028302C62706D6E5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69732928656C656D656E742C202762706D6E3A557365725461736B272920';
wwv_flow_imp.g_varchar2_table(335) := '26262028757365725461736B4461746120262620757365725461736B446174615B656C656D656E742E69645D292026262021626F2E6C6F6F704368617261637465726973746963732026262021626F2E24706172656E742E6C6F6F704368617261637465';
wwv_flow_imp.g_varchar2_table(336) := '726973746963733B0D0A202020207D292E666F72456163682828656C656D656E7429203D3E207B0D0A202020202020746869732E6164644F7665726C617928656C656D656E742C20757365725461736B446174615B656C656D656E742E69645D293B0D0A';
wwv_flow_imp.g_varchar2_table(337) := '202020207D293B0D0A20207D0D0A0D0A20206164644F7665726C617928656C656D656E742C2075726C29207B0D0A0D0A20202020636F6E737420627574746F6E203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(338) := '4C455F315F5F2E646F6D6966792928273C627574746F6E20636C6173733D22626A732D6472696C6C646F776E2066612066612D65787465726E616C2D6C696E6B223E3C2F627574746F6E3E27293B0D0A0D0A20202020627574746F6E2E6164644576656E';
wwv_flow_imp.g_varchar2_table(339) := '744C697374656E65722827636C69636B272C2066756E6374696F6E202829207B0D0A20202020202077696E646F772E6F70656E2875726C2C20275F73656C6627293B0D0A202020207D293B0D0A0D0A202020202F2F20616464206F7665726C61790D0A20';
wwv_flow_imp.g_varchar2_table(340) := '202020746869732E5F6F7665726C6179732E61646428656C656D656E742C2027697465726174696F6E73272C207B0D0A202020202020706F736974696F6E3A207B0D0A2020202020202020626F74746F6D3A202D372C0D0A202020202020202072696768';
wwv_flow_imp.g_varchar2_table(341) := '743A202D380D0A2020202020207D2C0D0A20202020202068746D6C3A20627574746F6E0D0A202020207D293B0D0A20207D0D0A0D0A20207365745769646765742877696467657429207B0D0A20202020746869732E5F776964676574203D207769646765';
wwv_flow_imp.g_varchar2_table(342) := '743B0D0A20207D0D0A7D0D0A0D0A557365725461736B4D6F64756C652E24696E6A656374203D205B2763616E766173272C20276576656E74427573272C2027656C656D656E745265676973747279272C20277472616E736C617465272C20276F7665726C';
wwv_flow_imp.g_varchar2_table(343) := '617973275D3B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6D6F64756C65732F757365725461736B4D6F64756C652F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(344) := '2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6D6F64756C65732F757365725461736B4D6F64756C652F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(345) := '2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F72657175697265';
wwv_flow_imp.g_varchar2_table(346) := '5F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D';
wwv_flow_imp.g_varchar2_table(347) := '6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D';
wwv_flow_imp.g_varchar2_table(348) := '706F7274202A2F20766172205F557365725461736B4D6F64756C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F557365725461736B4D6F64756C6520';
wwv_flow_imp.g_varchar2_table(349) := '2A2F20222E2F6D6F64756C65732F757365725461736B4D6F64756C652F557365725461736B4D6F64756C652E6A7322293B0A0D0A0D0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44';
wwv_flow_imp.g_varchar2_table(350) := '454641554C545F4558504F52545F5F203D20287B0D0A20205F5F696E69745F5F3A205B27757365725461736B4D6F64756C65275D2C0D0A2020757365725461736B4D6F64756C653A205B2774797065272C205F557365725461736B4D6F64756C655F5F57';
wwv_flow_imp.g_varchar2_table(351) := '45425041434B5F494D504F525445445F4D4F44554C455F305F5F2E557365725461736B4D6F64756C655D2C0D0A7D293B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F4261736556';
wwv_flow_imp.g_varchar2_table(352) := '69657765722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F';
wwv_flow_imp.g_varchar2_table(353) := '426173655669657765722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64';
wwv_flow_imp.g_varchar2_table(354) := '756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A20';
wwv_flow_imp.g_varchar2_table(355) := '6861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A20282920';
wwv_flow_imp.g_varchar2_table(356) := '3D3E20282F2A2062696E64696E67202A2F2042617365566965776572290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D';
wwv_flow_imp.g_varchar2_table(357) := '504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A732229';
wwv_flow_imp.g_varchar2_table(358) := '3B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F';
wwv_flow_imp.g_varchar2_table(359) := '20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722074696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(360) := '44554C455F355F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D7376672F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D';
wwv_flow_imp.g_varchar2_table(361) := '6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A73202A2F20222E';
wwv_flow_imp.g_varchar2_table(362) := '2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F4469616772616D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722062706D6E5F6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(363) := '44554C455F365F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212062706D6E2D6D6F64646C65202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6D6F64646C652F646973742F696E6465782E65736D2E6A7322293B0A2F';
wwv_flow_imp.g_varchar2_table(364) := '2A206861726D6F6E7920696D706F7274202A2F2076617220696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A2120696E6865';
wwv_flow_imp.g_varchar2_table(365) := '726974732D62726F77736572202A2F20222E2F6E6F64655F6D6F64756C65732F696E6865726974732D62726F777365722F646973742F696E6465782E65732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F696D706F72';
wwv_flow_imp.g_varchar2_table(366) := '745F496D706F727465725F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F696D706F72742F496D706F72746572202A2F20222E2F6E6F64655F6D6F64756C';
wwv_flow_imp.g_varchar2_table(367) := '65732F62706D6E2D6A732F6C69622F696D706F72742F496D706F727465722E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F506F776572656442795574696C5F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(368) := '4D4F44554C455F375F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F7574696C2F506F776572656442795574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F506F77657265';
wwv_flow_imp.g_varchar2_table(369) := '6442795574696C2E6A7322293B0A2F2A2A0A202A2054686520636F646520696E20746865203C70726F6A6563742D6C6F676F3E3C2F70726F6A6563742D6C6F676F3E20617265610A202A206D757374206E6F74206265206368616E6765642E0A202A0A20';
wwv_flow_imp.g_varchar2_table(370) := '2A204073656520687474703A2F2F62706D6E2E696F2F6C6963656E736520666F72206D6F726520696E666F726D6174696F6E2E0A202A2F0A0A0A0A0A0A0A0A0A0A0A0A0A0A2F2A2A0A202A204074656D706C61746520540A202A0A202A20407479706564';
wwv_flow_imp.g_varchar2_table(371) := '6566207B20696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C743C543E207D204576656E744275730A202A2F0A0A2F2A2A0A202A204074656D706C61746520540A202A0A202A2040747970';
wwv_flow_imp.g_varchar2_table(372) := '65646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E4576656E744275734576656E7443616C6C6261636B3C543E7D204576656E744275734576656E7443616C6C6261636B0A202A2F0A0A2F2A';
wwv_flow_imp.g_varchar2_table(373) := '2A0A202A204074797065646566207B696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E7D204D6F64756C654465636C61726174696F6E0A202A0A202A204074797065646566207B696D706F727428272E2F6D6F64656C2F54';
wwv_flow_imp.g_varchar2_table(374) := '7970657327292E4D6F64646C657D204D6F64646C650A202A204074797065646566207B696D706F727428272E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E740A202A20407479706564656620';
wwv_flow_imp.g_varchar2_table(375) := '7B696D706F727428272E2F6D6F64656C2F547970657327292E4D6F64646C65457874656E73696F6E7D204D6F64646C65457874656E73696F6E0A202A0A202A204074797065646566207B207B0A202A20202077696474683F3A206E756D6265727C737472';
wwv_flow_imp.g_varchar2_table(376) := '696E673B0A202A2020206865696768743F3A206E756D6265727C737472696E673B0A202A202020706F736974696F6E3F3A20737472696E673B0A202A202020636F6E7461696E65723F3A20737472696E677C48544D4C456C656D656E743B0A202A202020';
wwv_flow_imp.g_varchar2_table(377) := '6D6F64646C65457874656E73696F6E733F3A204D6F64646C65457874656E73696F6E733B0A202A2020206164646974696F6E616C4D6F64756C65733F3A204D6F64756C654465636C61726174696F6E5B5D3B0A202A207D2026205265636F72643C737472';
wwv_flow_imp.g_varchar2_table(378) := '696E672C20616E793E207D20426173655669657765724F7074696F6E730A202A0A202A204074797065646566207B5265636F72643C737472696E672C204D6F64646C65456C656D656E743E7D204D6F64646C65456C656D656E7473427949640A202A0A20';
wwv_flow_imp.g_varchar2_table(379) := '2A204074797065646566207B207B0A202A2020205B6B65793A20737472696E675D3A204D6F64646C65457874656E73696F6E3B0A202A207D207D204D6F64646C65457874656E73696F6E730A202A0A202A204074797065646566207B207B0A202A202020';
wwv_flow_imp.g_varchar2_table(380) := '7761726E696E67733A20737472696E675B5D3B0A202A207D207D20496D706F7274584D4C526573756C740A202A0A202A204074797065646566207B496D706F7274584D4C526573756C742026204572726F727D20496D706F7274584D4C4572726F720A20';
wwv_flow_imp.g_varchar2_table(381) := '2A0A202A204074797065646566207B496D706F7274584D4C526573756C747D20496D706F7274446566696E6974696F6E73526573756C740A202A0A202A204074797065646566207B496D706F7274584D4C4572726F727D20496D706F7274446566696E69';
wwv_flow_imp.g_varchar2_table(382) := '74696F6E734572726F720A202A0A202A204074797065646566207B496D706F7274584D4C526573756C747D204F70656E526573756C740A202A0A202A204074797065646566207B496D706F7274584D4C4572726F727D204F70656E4572726F720A202A0A';
wwv_flow_imp.g_varchar2_table(383) := '202A204074797065646566207B207B0A202A202020666F726D61743F3A20626F6F6C65616E3B0A202A202020707265616D626C653F3A20626F6F6C65616E3B0A202A207D207D2053617665584D4C4F7074696F6E730A202A0A202A204074797065646566';
wwv_flow_imp.g_varchar2_table(384) := '207B207B0A202A202020786D6C3F3A20737472696E673B0A202A2020206572726F723F3A204572726F723B0A202A207D207D2053617665584D4C526573756C740A202A0A202A204074797065646566207B207B0A202A2020207376673A20737472696E67';
wwv_flow_imp.g_varchar2_table(385) := '3B0A202A207D207D2053617665535647526573756C740A202A0A202A204074797065646566207B207B0A202A202020786D6C3A20737472696E673B0A202A207D207D20496D706F7274506172736553746172744576656E740A202A0A202A204074797065';
wwv_flow_imp.g_varchar2_table(386) := '646566207B207B0A202A2020206572726F723F3A20496D706F7274584D4C4572726F723B0A202A202020646566696E6974696F6E733F3A204D6F64646C65456C656D656E743B0A202A202020656C656D656E7473427949643F3A204D6F64646C65456C65';
wwv_flow_imp.g_varchar2_table(387) := '6D656E7473427949643B0A202A2020207265666572656E6365733F3A204D6F64646C65456C656D656E745B5D3B0A202A2020207761726E696E67733A20737472696E675B5D3B0A202A207D207D20496D706F72745061727365436F6D706C657465457665';
wwv_flow_imp.g_varchar2_table(388) := '6E740A202A0A202A204074797065646566207B207B0A202A2020206572726F723F3A20496D706F7274584D4C4572726F723B0A202A2020207761726E696E67733A20737472696E675B5D3B0A202A207D207D20496D706F7274446F6E654576656E740A20';
wwv_flow_imp.g_varchar2_table(389) := '2A0A202A204074797065646566207B207B0A202A202020646566696E6974696F6E733A204D6F64646C65456C656D656E743B0A202A207D207D2053617665584D4C53746172744576656E740A202A0A202A204074797065646566207B53617665584D4C52';
wwv_flow_imp.g_varchar2_table(390) := '6573756C747D2053617665584D4C446F6E654576656E740A202A0A202A204074797065646566207B207B0A202A2020206572726F723F3A204572726F723B0A202A2020207376673A20737472696E673B0A202A207D207D2053617665535647446F6E6545';
wwv_flow_imp.g_varchar2_table(391) := '76656E740A202A2F0A0A2F2A2A0A202A204074656D706C61746520547970650A202A0A202A204074797065646566207B205479706520657874656E6473207B206576656E744275733A204576656E744275733C696E66657220583E207D203F2058203A20';
wwv_flow_imp.g_varchar2_table(392) := '6E65766572207D204576656E744D61700A202A2F0A0A2F2A2A0A202A204120626173652076696577657220666F722042504D4E20322E30206469616772616D732E0A202A0A202A20486176652061206C6F6F6B206174207B406C696E6B2062706D6E2D6A';
wwv_flow_imp.g_varchar2_table(393) := '732F6C69622F5669657765727D2C207B406C696E6B2062706D6E2D6A732F6C69622F4E61766967617465645669657765727D206F72207B406C696E6B2062706D6E2D6A732F6C69622F4D6F64656C65727D20666F720A202A2062756E646C657320746861';
wwv_flow_imp.g_varchar2_table(394) := '7420696E636C7564652061637475616C2066656174757265732E0A202A0A202A204074656D706C617465205B536572766963654D61703D6E756C6C5D0A202A0A202A2040657874656E6473204469616772616D3C536572766963654D61703E0A202A0A20';
wwv_flow_imp.g_varchar2_table(395) := '2A2040706172616D207B426173655669657765724F7074696F6E737D205B6F7074696F6E735D20546865206F7074696F6E7320746F20636F6E66696775726520746865207669657765722E0A202A2F0A66756E6374696F6E204261736556696577657228';
wwv_flow_imp.g_varchar2_table(396) := '6F7074696F6E7329207B0A0A20202F2A2A0A2020202A204074797065207B426173655669657765724F7074696F6E737D0A2020202A2F0A20206F7074696F6E73203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44';
wwv_flow_imp.g_varchar2_table(397) := '554C455F305F5F2E61737369676E29287B7D2C2044454641554C545F4F5054494F4E532C206F7074696F6E73293B0A0A20202F2A2A0A2020202A204074797065207B4D6F64646C657D0A2020202A2F0A2020746869732E5F6D6F64646C65203D20746869';
wwv_flow_imp.g_varchar2_table(398) := '732E5F6372656174654D6F64646C65286F7074696F6E73293B0A0A20202F2A2A0A2020202A204074797065207B48544D4C456C656D656E747D0A2020202A2F0A2020746869732E5F636F6E7461696E6572203D20746869732E5F637265617465436F6E74';
wwv_flow_imp.g_varchar2_table(399) := '61696E6572286F7074696F6E73293B0A0A20202F2A203C70726F6A6563742D6C6F676F3E202A2F0A0A202061646450726F6A6563744C6F676F28746869732E5F636F6E7461696E6572293B0A0A20202F2A203C2F70726F6A6563742D6C6F676F3E202A2F';
wwv_flow_imp.g_varchar2_table(400) := '0A0A2020746869732E5F696E697428746869732E5F636F6E7461696E65722C20746869732E5F6D6F64646C652C206F7074696F6E73293B0A7D0A0A28302C696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44';
wwv_flow_imp.g_varchar2_table(401) := '554C455F315F5F5B2264656661756C74225D2928426173655669657765722C206469616772616D5F6A735F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F5B2264656661756C74225D293B0A0A2F2A2A0A202A2050617273652061';
wwv_flow_imp.g_varchar2_table(402) := '6E642072656E64657220612042504D4E20322E30206469616772616D2E0A202A0A202A204F6E63652066696E69736865642074686520766965776572207265706F727473206261636B2074686520726573756C7420746F207468650A202A2070726F7669';
wwv_flow_imp.g_varchar2_table(403) := '6465642063616C6C6261636B2066756E6374696F6E207769746820286572722C207761726E696E6773292E0A202A0A202A202323204C6966652D4379636C65204576656E74730A202A0A202A20447572696E6720696D706F727420746865207669657765';
wwv_flow_imp.g_varchar2_table(404) := '722077696C6C2066697265206C6966652D6379636C65206576656E74733A0A202A0A202A2020202A20696D706F72742E70617273652E7374617274202861626F757420746F2072656164206D6F64656C2066726F6D20584D4C290A202A2020202A20696D';
wwv_flow_imp.g_varchar2_table(405) := '706F72742E70617273652E636F6D706C65746520286D6F64656C20726561643B206D6179206861766520776F726B6564206F72206E6F74290A202A2020202A20696D706F72742E72656E6465722E7374617274202867726170686963616C20696D706F72';
wwv_flow_imp.g_varchar2_table(406) := '74207374617274290A202A2020202A20696D706F72742E72656E6465722E636F6D706C657465202867726170686963616C20696D706F72742066696E6973686564290A202A2020202A20696D706F72742E646F6E65202865766572797468696E6720646F';
wwv_flow_imp.g_varchar2_table(407) := '6E65290A202A0A202A20596F752063616E20757365207468657365206576656E747320746F20686F6F6B20696E746F20746865206C6966652D6379636C652E0A202A0A202A20407468726F7773207B496D706F7274584D4C4572726F727D20416E206572';
wwv_flow_imp.g_varchar2_table(408) := '726F72207468726F776E20647572696E672074686520696D706F7274206F662074686520584D4C2E0A202A0A202A20406669726573204261736556696577657223496D706F7274506172736553746172744576656E740A202A2040666972657320426173';
wwv_flow_imp.g_varchar2_table(409) := '6556696577657223496D706F72745061727365436F6D706C6574654576656E740A202A2040666972657320496D706F7274657223496D706F727452656E64657253746172744576656E740A202A2040666972657320496D706F7274657223496D706F7274';
wwv_flow_imp.g_varchar2_table(410) := '52656E646572436F6D706C6574654576656E740A202A20406669726573204261736556696577657223496D706F7274446F6E654576656E740A202A0A202A2040706172616D207B737472696E677D20786D6C205468652042504D4E20322E3020584D4C20';
wwv_flow_imp.g_varchar2_table(411) := '746F20626520696D706F727465642E0A202A2040706172616D207B4D6F64646C65456C656D656E747C737472696E677D205B62706D6E4469616772616D5D20546865206F7074696F6E616C206469616772616D206F72204964206F66207468652042504D';
wwv_flow_imp.g_varchar2_table(412) := '4E206469616772616D20746F206F70656E2E0A202A0A202A204072657475726E207B50726F6D6973653C496D706F7274584D4C526573756C743E7D20412070726F6D697365207265736F6C76696E672077697468207761726E696E677320746861742077';
wwv_flow_imp.g_varchar2_table(413) := '6572652070726F647563656420647572696E672074686520696D706F72742E0A202A2F0A426173655669657765722E70726F746F747970652E696D706F7274584D4C203D206173796E632066756E6374696F6E20696D706F7274584D4C28786D6C2C2062';
wwv_flow_imp.g_varchar2_table(414) := '706D6E4469616772616D29207B0A0A2020636F6E73742073656C66203D20746869733B0A0A202066756E6374696F6E205061727365436F6D706C6574654576656E74286461746129207B0A2020202072657475726E2073656C662E67657428276576656E';
wwv_flow_imp.g_varchar2_table(415) := '7442757327292E6372656174654576656E742864617461293B0A20207D0A0A20206C657420616767726567617465645761726E696E6773203D205B5D3B0A2020747279207B0A0A202020202F2F20686F6F6B20696E207072652D7061727365206C697374';
wwv_flow_imp.g_varchar2_table(416) := '656E657273202B0A202020202F2F20616C6C6F7720786D6C206D616E6970756C6174696F6E0A0A202020202F2A2A0A20202020202A20412060696D706F72742E70617273652E737461727460206576656E742E0A20202020202A0A20202020202A204065';
wwv_flow_imp.g_varchar2_table(417) := '76656E74204261736556696577657223496D706F7274506172736553746172744576656E740A20202020202A204074797065207B496D706F7274506172736553746172744576656E747D0A20202020202A2F0A20202020786D6C203D20746869732E5F65';
wwv_flow_imp.g_varchar2_table(418) := '6D69742827696D706F72742E70617273652E7374617274272C207B20786D6C3A20786D6C207D29207C7C20786D6C3B0A0A202020206C6574207061727365526573756C743B0A20202020747279207B0A2020202020207061727365526573756C74203D20';
wwv_flow_imp.g_varchar2_table(419) := '617761697420746869732E5F6D6F64646C652E66726F6D584D4C28786D6C2C202762706D6E3A446566696E6974696F6E7327293B0A202020207D20636174636820286572726F7229207B0A202020202020746869732E5F656D69742827696D706F72742E';
wwv_flow_imp.g_varchar2_table(420) := '70617273652E636F6D706C657465272C207B0A20202020202020206572726F720A2020202020207D293B0A0A2020202020207468726F77206572726F723B0A202020207D0A0A202020206C657420646566696E6974696F6E73203D207061727365526573';
wwv_flow_imp.g_varchar2_table(421) := '756C742E726F6F74456C656D656E743B0A20202020636F6E7374207265666572656E636573203D207061727365526573756C742E7265666572656E6365733B0A20202020636F6E73742070617273655761726E696E6773203D207061727365526573756C';
wwv_flow_imp.g_varchar2_table(422) := '742E7761726E696E67733B0A20202020636F6E737420656C656D656E747342794964203D207061727365526573756C742E656C656D656E7473427949643B0A0A20202020616767726567617465645761726E696E6773203D206167677265676174656457';
wwv_flow_imp.g_varchar2_table(423) := '61726E696E67732E636F6E6361742870617273655761726E696E6773293B0A0A202020202F2F20686F6F6B20696E20706F7374207061727365206C697374656E657273202B0A202020202F2F20616C6C6F7720646566696E6974696F6E73206D616E6970';
wwv_flow_imp.g_varchar2_table(424) := '756C6174696F6E0A0A202020202F2A2A0A20202020202A20412060696D706F72742E70617273652E636F6D706C65746560206576656E742E0A20202020202A0A20202020202A20406576656E74204261736556696577657223496D706F72745061727365';
wwv_flow_imp.g_varchar2_table(425) := '436F6D706C6574654576656E740A20202020202A204074797065207B496D706F72745061727365436F6D706C6574654576656E747D0A20202020202A2F0A20202020646566696E6974696F6E73203D20746869732E5F656D69742827696D706F72742E70';
wwv_flow_imp.g_varchar2_table(426) := '617273652E636F6D706C657465272C205061727365436F6D706C6574654576656E74287B0A2020202020206572726F723A206E756C6C2C0A202020202020646566696E6974696F6E733A20646566696E6974696F6E732C0A202020202020656C656D656E';
wwv_flow_imp.g_varchar2_table(427) := '7473427949643A20656C656D656E7473427949642C0A2020202020207265666572656E6365733A207265666572656E6365732C0A2020202020207761726E696E67733A20616767726567617465645761726E696E67730A202020207D2929207C7C206465';
wwv_flow_imp.g_varchar2_table(428) := '66696E6974696F6E733B0A0A20202020636F6E737420696D706F7274526573756C74203D20617761697420746869732E696D706F7274446566696E6974696F6E7328646566696E6974696F6E732C2062706D6E4469616772616D293B0A0A202020206167';
wwv_flow_imp.g_varchar2_table(429) := '67726567617465645761726E696E6773203D20616767726567617465645761726E696E67732E636F6E63617428696D706F7274526573756C742E7761726E696E6773293B0A0A202020202F2A2A0A20202020202A20412060696D706F72742E7061727365';
wwv_flow_imp.g_varchar2_table(430) := '2E636F6D706C65746560206576656E742E0A20202020202A0A20202020202A20406576656E74204261736556696577657223496D706F7274446F6E654576656E740A20202020202A204074797065207B496D706F7274446F6E654576656E747D0A202020';
wwv_flow_imp.g_varchar2_table(431) := '20202A2F0A20202020746869732E5F656D69742827696D706F72742E646F6E65272C207B206572726F723A206E756C6C2C207761726E696E67733A20616767726567617465645761726E696E6773207D293B0A0A2020202072657475726E207B20776172';
wwv_flow_imp.g_varchar2_table(432) := '6E696E67733A20616767726567617465645761726E696E6773207D3B0A20207D206361746368202865727229207B0A202020206C6574206572726F72203D206572723B0A20202020616767726567617465645761726E696E6773203D2061676772656761';
wwv_flow_imp.g_varchar2_table(433) := '7465645761726E696E67732E636F6E636174286572726F722E7761726E696E6773207C7C205B5D293B0A202020206164645761726E696E6773546F4572726F72286572726F722C20616767726567617465645761726E696E6773293B0A0A202020206572';
wwv_flow_imp.g_varchar2_table(434) := '726F72203D20636865636B56616C69646174696F6E4572726F72286572726F72293B0A0A20202020746869732E5F656D69742827696D706F72742E646F6E65272C207B206572726F722C207761726E696E67733A206572726F722E7761726E696E677320';
wwv_flow_imp.g_varchar2_table(435) := '7D293B0A0A202020207468726F77206572726F723B0A20207D0A7D3B0A0A0A2F2A2A0A202A20496D706F72742070617273656420646566696E6974696F6E7320616E642072656E64657220612042504D4E20322E30206469616772616D2E0A202A0A202A';
wwv_flow_imp.g_varchar2_table(436) := '204F6E63652066696E69736865642074686520766965776572207265706F727473206261636B2074686520726573756C7420746F207468650A202A2070726F76696465642063616C6C6261636B2066756E6374696F6E207769746820286572722C207761';
wwv_flow_imp.g_varchar2_table(437) := '726E696E6773292E0A202A0A202A202323204C6966652D4379636C65204576656E74730A202A0A202A20447572696E6720696D706F727420746865207669657765722077696C6C2066697265206C6966652D6379636C65206576656E74733A0A202A0A20';
wwv_flow_imp.g_varchar2_table(438) := '2A2020202A20696D706F72742E72656E6465722E7374617274202867726170686963616C20696D706F7274207374617274290A202A2020202A20696D706F72742E72656E6465722E636F6D706C657465202867726170686963616C20696D706F72742066';
wwv_flow_imp.g_varchar2_table(439) := '696E6973686564290A202A0A202A20596F752063616E20757365207468657365206576656E747320746F20686F6F6B20696E746F20746865206C6966652D6379636C652E0A202A0A202A20407468726F7773207B496D706F7274446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(440) := '734572726F727D20416E206572726F72207468726F776E20647572696E672074686520696D706F7274206F662074686520646566696E6974696F6E732E0A202A0A202A2040706172616D207B4D6F64646C65456C656D656E747D20646566696E6974696F';
wwv_flow_imp.g_varchar2_table(441) := '6E732054686520646566696E6974696F6E732E0A202A2040706172616D207B4D6F64646C65456C656D656E747C737472696E677D205B62706D6E4469616772616D5D20546865206F7074696F6E616C206469616772616D206F72204944206F6620746865';
wwv_flow_imp.g_varchar2_table(442) := '2042504D4E206469616772616D20746F206F70656E2E0A202A0A202A204072657475726E207B50726F6D6973653C496D706F7274446566696E6974696F6E73526573756C743E7D20412070726F6D697365207265736F6C76696E67207769746820776172';
wwv_flow_imp.g_varchar2_table(443) := '6E696E6773207468617420776572652070726F647563656420647572696E672074686520696D706F72742E0A202A2F0A426173655669657765722E70726F746F747970652E696D706F7274446566696E6974696F6E73203D206173796E632066756E6374';
wwv_flow_imp.g_varchar2_table(444) := '696F6E20696D706F7274446566696E6974696F6E7328646566696E6974696F6E732C2062706D6E4469616772616D29207B0A2020746869732E5F736574446566696E6974696F6E7328646566696E6974696F6E73293B0A2020636F6E737420726573756C';
wwv_flow_imp.g_varchar2_table(445) := '74203D20617761697420746869732E6F70656E2862706D6E4469616772616D293B0A0A202072657475726E207B207761726E696E67733A20726573756C742E7761726E696E6773207D3B0A7D3B0A0A0A2F2A2A0A202A204F70656E206469616772616D20';
wwv_flow_imp.g_varchar2_table(446) := '6F662070726576696F75736C7920696D706F7274656420584D4C2E0A202A0A202A204F6E63652066696E69736865642074686520766965776572207265706F727473206261636B2074686520726573756C7420746F207468650A202A2070726F76696465';
wwv_flow_imp.g_varchar2_table(447) := '642063616C6C6261636B2066756E6374696F6E207769746820286572722C207761726E696E6773292E0A202A0A202A202323204C6966652D4379636C65204576656E74730A202A0A202A20447572696E6720737769746368207468652076696577657220';
wwv_flow_imp.g_varchar2_table(448) := '77696C6C2066697265206C6966652D6379636C65206576656E74733A0A202A0A202A2020202A20696D706F72742E72656E6465722E7374617274202867726170686963616C20696D706F7274207374617274290A202A2020202A20696D706F72742E7265';
wwv_flow_imp.g_varchar2_table(449) := '6E6465722E636F6D706C657465202867726170686963616C20696D706F72742066696E6973686564290A202A0A202A20596F752063616E20757365207468657365206576656E747320746F20686F6F6B20696E746F20746865206C6966652D6379636C65';
wwv_flow_imp.g_varchar2_table(450) := '2E0A202A0A202A20407468726F7773207B4F70656E4572726F727D20416E206572726F72207468726F776E20647572696E67206F70656E696E672E0A202A0A202A2040706172616D207B4D6F64646C65456C656D656E747C737472696E677D2062706D6E';
wwv_flow_imp.g_varchar2_table(451) := '4469616772616D4F72496420546865206469616772616D206F72204964206F66207468652042504D4E206469616772616D20746F206F70656E2E0A202A0A202A204072657475726E207B50726F6D6973653C4F70656E526573756C743E7D20412070726F';
wwv_flow_imp.g_varchar2_table(452) := '6D697365207265736F6C76696E672077697468207761726E696E6773207468617420776572652070726F647563656420647572696E67206F70656E696E672E0A202A2F0A426173655669657765722E70726F746F747970652E6F70656E203D206173796E';
wwv_flow_imp.g_varchar2_table(453) := '632066756E6374696F6E206F70656E2862706D6E4469616772616D4F72496429207B0A0A2020636F6E737420646566696E6974696F6E73203D20746869732E5F646566696E6974696F6E733B0A20206C65742062706D6E4469616772616D203D2062706D';
wwv_flow_imp.g_varchar2_table(454) := '6E4469616772616D4F7249643B0A0A20206966202821646566696E6974696F6E7329207B0A20202020636F6E7374206572726F72203D206E6577204572726F7228276E6F20584D4C20696D706F7274656427293B0A202020206164645761726E696E6773';
wwv_flow_imp.g_varchar2_table(455) := '546F4572726F72286572726F722C205B5D293B0A0A202020207468726F77206572726F723B0A20207D0A0A202069662028747970656F662062706D6E4469616772616D4F724964203D3D3D2027737472696E672729207B0A2020202062706D6E44696167';
wwv_flow_imp.g_varchar2_table(456) := '72616D203D2066696E6442504D4E4469616772616D28646566696E6974696F6E732C2062706D6E4469616772616D4F724964293B0A0A20202020696620282162706D6E4469616772616D29207B0A202020202020636F6E7374206572726F72203D206E65';
wwv_flow_imp.g_varchar2_table(457) := '77204572726F72282742504D4E4469616772616D203C27202B2062706D6E4469616772616D4F724964202B20273E206E6F7420666F756E6427293B0A2020202020206164645761726E696E6773546F4572726F72286572726F722C205B5D293B0A0A2020';
wwv_flow_imp.g_varchar2_table(458) := '202020207468726F77206572726F723B0A202020207D0A20207D0A0A20202F2F20636C656172206578697374696E672072656E6465726564206469616772616D0A20202F2F2063617463682073796E6368726F6E6F757320657863657074696F6E732064';
wwv_flow_imp.g_varchar2_table(459) := '7572696E672023636C65617228290A2020747279207B0A20202020746869732E636C65617228293B0A20207D20636174636820286572726F7229207B0A202020206164645761726E696E6773546F4572726F72286572726F722C205B5D293B0A0A202020';
wwv_flow_imp.g_varchar2_table(460) := '207468726F77206572726F723B0A20207D0A0A20202F2F20706572666F726D2067726170686963616C20696D706F72740A2020636F6E7374207B207761726E696E6773207D203D2061776169742028302C5F696D706F72745F496D706F727465725F5F57';
wwv_flow_imp.g_varchar2_table(461) := '45425041434B5F494D504F525445445F4D4F44554C455F335F5F2E696D706F727442706D6E4469616772616D2928746869732C20646566696E6974696F6E732C2062706D6E4469616772616D293B0A0A202072657475726E207B207761726E696E677320';
wwv_flow_imp.g_varchar2_table(462) := '7D3B0A7D3B0A0A2F2A2A0A202A204578706F7274207468652063757272656E746C7920646973706C617965642042504D4E20322E30206469616772616D2061730A202A20612042504D4E20322E3020584D4C20646F63756D656E742E0A202A0A202A2023';
wwv_flow_imp.g_varchar2_table(463) := '23204C6966652D4379636C65204576656E74730A202A0A202A20447572696E6720584D4C20736176696E6720746865207669657765722077696C6C2066697265206C6966652D6379636C65206576656E74733A0A202A0A202A2020202A2073617665584D';
wwv_flow_imp.g_varchar2_table(464) := '4C2E737461727420286265666F72652073657269616C697A6174696F6E290A202A2020202A2073617665584D4C2E73657269616C697A65642028616674657220786D6C2067656E65726174696F6E290A202A2020202A2073617665584D4C2E646F6E6520';
wwv_flow_imp.g_varchar2_table(465) := '2865766572797468696E6720646F6E65290A202A0A202A20596F752063616E20757365207468657365206576656E747320746F20686F6F6B20696E746F20746865206C6966652D6379636C652E0A202A0A202A20407468726F7773207B4572726F727D20';
wwv_flow_imp.g_varchar2_table(466) := '416E206572726F72207468726F776E20647572696E67206578706F72742E0A202A0A202A2040666972657320426173655669657765722353617665584D4C53746172740A202A2040666972657320426173655669657765722353617665584D4C446F6E65';
wwv_flow_imp.g_varchar2_table(467) := '0A202A0A202A2040706172616D207B53617665584D4C4F7074696F6E737D205B6F7074696F6E735D20546865206F7074696F6E732E0A202A0A202A204072657475726E207B50726F6D6973653C53617665584D4C526573756C743E7D20412070726F6D69';
wwv_flow_imp.g_varchar2_table(468) := '7365207265736F6C76696E6720776974682074686520584D4C2E0A202A2F0A426173655669657765722E70726F746F747970652E73617665584D4C203D206173796E632066756E6374696F6E2073617665584D4C286F7074696F6E7329207B0A0A20206F';
wwv_flow_imp.g_varchar2_table(469) := '7074696F6E73203D206F7074696F6E73207C7C207B7D3B0A0A20206C657420646566696E6974696F6E73203D20746869732E5F646566696E6974696F6E732C0A2020202020206572726F722C20786D6C3B0A0A2020747279207B0A202020206966202821';
wwv_flow_imp.g_varchar2_table(470) := '646566696E6974696F6E7329207B0A2020202020207468726F77206E6577204572726F7228276E6F20646566696E6974696F6E73206C6F6164656427293B0A202020207D0A0A202020202F2F20616C6C6F7720746F20666964646C652061726F756E6420';
wwv_flow_imp.g_varchar2_table(471) := '7769746820646566696E6974696F6E730A0A202020202F2A2A0A20202020202A2041206073617665584D4C2E737461727460206576656E742E0A20202020202A0A20202020202A20406576656E7420426173655669657765722353617665584D4C537461';
wwv_flow_imp.g_varchar2_table(472) := '72744576656E740A20202020202A204074797065207B53617665584D4C53746172744576656E747D0A20202020202A2F0A20202020646566696E6974696F6E73203D20746869732E5F656D6974282773617665584D4C2E7374617274272C207B0A202020';
wwv_flow_imp.g_varchar2_table(473) := '202020646566696E6974696F6E730A202020207D29207C7C20646566696E6974696F6E733B0A0A20202020636F6E737420726573756C74203D20617761697420746869732E5F6D6F64646C652E746F584D4C28646566696E6974696F6E732C206F707469';
wwv_flow_imp.g_varchar2_table(474) := '6F6E73293B0A20202020786D6C203D20726573756C742E786D6C3B0A0A20202020786D6C203D20746869732E5F656D6974282773617665584D4C2E73657269616C697A6564272C207B0A202020202020786D6C0A202020207D29207C7C20786D6C3B0A20';
wwv_flow_imp.g_varchar2_table(475) := '207D206361746368202865727229207B0A202020206572726F72203D206572723B0A20207D0A0A2020636F6E737420726573756C74203D206572726F72203F207B206572726F72207D203A207B20786D6C207D3B0A0A20202F2A2A0A2020202A20412060';
wwv_flow_imp.g_varchar2_table(476) := '73617665584D4C2E646F6E6560206576656E742E0A2020202A0A2020202A20406576656E7420426173655669657765722353617665584D4C446F6E654576656E740A2020202A204074797065207B53617665584D4C446F6E654576656E747D0A2020202A';
wwv_flow_imp.g_varchar2_table(477) := '2F0A2020746869732E5F656D6974282773617665584D4C2E646F6E65272C20726573756C74293B0A0A2020696620286572726F7229207B0A202020207468726F77206572726F723B0A20207D0A0A202072657475726E20726573756C743B0A7D3B0A0A0A';
wwv_flow_imp.g_varchar2_table(478) := '2F2A2A0A202A204578706F7274207468652063757272656E746C7920646973706C617965642042504D4E20322E30206469616772616D2061730A202A20616E2053564720696D6167652E0A202A0A202A202323204C6966652D4379636C65204576656E74';
wwv_flow_imp.g_varchar2_table(479) := '730A202A0A202A20447572696E672053564720736176696E6720746865207669657765722077696C6C2066697265206C6966652D6379636C65206576656E74733A0A202A0A202A2020202A20736176655356472E737461727420286265666F7265207365';
wwv_flow_imp.g_varchar2_table(480) := '7269616C697A6174696F6E290A202A2020202A20736176655356472E646F6E65202865766572797468696E6720646F6E65290A202A0A202A20596F752063616E20757365207468657365206576656E747320746F20686F6F6B20696E746F20746865206C';
wwv_flow_imp.g_varchar2_table(481) := '6966652D6379636C652E0A202A0A202A20407468726F7773207B4572726F727D20416E206572726F72207468726F776E20647572696E67206578706F72742E0A202A0A202A2040666972657320426173655669657765722353617665535647446F6E650A';
wwv_flow_imp.g_varchar2_table(482) := '202A0A202A204072657475726E207B50726F6D6973653C53617665535647526573756C743E7D20412070726F6D697365207265736F6C76696E67207769746820746865205356472E0A202A2F0A426173655669657765722E70726F746F747970652E7361';
wwv_flow_imp.g_varchar2_table(483) := '7665535647203D206173796E632066756E6374696F6E20736176655356472829207B0A2020746869732E5F656D69742827736176655356472E737461727427293B0A0A20206C6574207376672C206572723B0A0A2020747279207B0A20202020636F6E73';
wwv_flow_imp.g_varchar2_table(484) := '742063616E766173203D20746869732E676574282763616E76617327293B0A0A20202020636F6E737420636F6E74656E744E6F6465203D2063616E7661732E6765744163746976654C6179657228292C0A20202020202020202020646566734E6F646520';
wwv_flow_imp.g_varchar2_table(485) := '3D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E71756572792928273A73636F7065203E2064656673272C2063616E7661732E5F737667293B0A0A20202020636F6E737420636F6E74656E747320';
wwv_flow_imp.g_varchar2_table(486) := '3D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E696E6E65725356472928636F6E74656E744E6F6465292C0A2020202020202020202064656673203D20646566734E6F6465203F20273C646566';
wwv_flow_imp.g_varchar2_table(487) := '733E27202B2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E696E6E65725356472928646566734E6F646529202B20273C2F646566733E27203A2027273B0A0A20202020636F6E73742062626F78';
wwv_flow_imp.g_varchar2_table(488) := '203D20636F6E74656E744E6F64652E67657442426F7828293B0A0A20202020737667203D0A202020202020273C3F786D6C2076657273696F6E3D22312E302220656E636F64696E673D227574662D38223F3E5C6E27202B0A202020202020273C212D2D20';
wwv_flow_imp.g_varchar2_table(489) := '6372656174656420776974682062706D6E2D6A73202F20687474703A2F2F62706D6E2E696F202D2D3E5C6E27202B0A202020202020273C21444F435459504520737667205055424C494320222D2F2F5733432F2F4454442053564720312E312F2F454E22';
wwv_flow_imp.g_varchar2_table(490) := '2022687474703A2F2F7777772E77332E6F72672F47726170686963732F5356472F312E312F4454442F73766731312E647464223E5C6E27202B0A202020202020273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F';
wwv_flow_imp.g_varchar2_table(491) := '7376672220786D6C6E733A786C696E6B3D22687474703A2F2F7777772E77332E6F72672F313939392F786C696E6B222027202B0A2020202020202777696474683D2227202B2062626F782E7769647468202B202722206865696768743D2227202B206262';
wwv_flow_imp.g_varchar2_table(492) := '6F782E686569676874202B2027222027202B0A2020202020202776696577426F783D2227202B2062626F782E78202B20272027202B2062626F782E79202B20272027202B2062626F782E7769647468202B20272027202B2062626F782E68656967687420';
wwv_flow_imp.g_varchar2_table(493) := '2B2027222076657273696F6E3D22312E31223E27202B0A20202020202064656673202B20636F6E74656E7473202B0A202020202020273C2F7376673E273B0A20207D20636174636820286529207B0A20202020657272203D20653B0A20207D0A0A20202F';
wwv_flow_imp.g_varchar2_table(494) := '2A2A0A2020202A20412060736176655356472E646F6E6560206576656E742E0A2020202A0A2020202A20406576656E7420426173655669657765722353617665535647446F6E654576656E740A2020202A204074797065207B53617665535647446F6E65';
wwv_flow_imp.g_varchar2_table(495) := '4576656E747D0A2020202A2F0A2020746869732E5F656D69742827736176655356472E646F6E65272C207B0A202020206572726F723A206572722C0A202020207376673A207376670A20207D293B0A0A20206966202865727229207B0A20202020746872';
wwv_flow_imp.g_varchar2_table(496) := '6F77206572723B0A20207D0A0A202072657475726E207B20737667207D3B0A7D3B0A0A426173655669657765722E70726F746F747970652E5F736574446566696E6974696F6E73203D2066756E6374696F6E28646566696E6974696F6E7329207B0A2020';
wwv_flow_imp.g_varchar2_table(497) := '746869732E5F646566696E6974696F6E73203D20646566696E6974696F6E733B0A7D3B0A0A2F2A2A0A202A2052657475726E206D6F64756C657320746F20696E7374616E746961746520776974682E0A202A0A202A204072657475726E207B4D6F64756C';
wwv_flow_imp.g_varchar2_table(498) := '654465636C61726174696F6E5B5D7D20546865206D6F64756C65732E0A202A2F0A426173655669657765722E70726F746F747970652E6765744D6F64756C6573203D2066756E6374696F6E2829207B0A202072657475726E20746869732E5F6D6F64756C';
wwv_flow_imp.g_varchar2_table(499) := '65733B0A7D3B0A0A2F2A2A0A202A2052656D6F766520616C6C20647261776E20656C656D656E74732066726F6D20746865207669657765722E0A202A0A202A2041667465722063616C6C696E672074686973206D6574686F642074686520766965776572';
wwv_flow_imp.g_varchar2_table(500) := '2063616E207374696C6C2062652072657573656420666F72206F70656E696E6720616E6F746865720A202A206469616772616D2E0A202A2F0A426173655669657765722E70726F746F747970652E636C656172203D2066756E6374696F6E2829207B0A20';
wwv_flow_imp.g_varchar2_table(501) := '206966202821746869732E676574446566696E6974696F6E73282929207B0A0A202020202F2F206E6F206469616772616D20746F20636C6561720A2020202072657475726E3B0A20207D0A0A20202F2F2072656D6F766520647261776E20656C656D656E';
wwv_flow_imp.g_varchar2_table(502) := '74730A20206469616772616D5F6A735F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F5B2264656661756C74225D2E70726F746F747970652E636C6561722E63616C6C2874686973293B0A7D3B0A0A2F2A2A0A202A204465737472';
wwv_flow_imp.g_varchar2_table(503) := '6F79207468652076696577657220696E7374616E636520616E642072656D6F766520616C6C206974732072656D61696E646572732066726F6D2074686520646F63756D656E740A202A20747265652E0A202A2F0A426173655669657765722E70726F746F';
wwv_flow_imp.g_varchar2_table(504) := '747970652E64657374726F79203D2066756E6374696F6E2829207B0A0A20202F2F206469616772616D2064657374726F790A20206469616772616D5F6A735F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F5B2264656661756C74';
wwv_flow_imp.g_varchar2_table(505) := '225D2E70726F746F747970652E64657374726F792E63616C6C2874686973293B0A0A20202F2F20646F6D206465746163680A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E72656D6F76652928';
wwv_flow_imp.g_varchar2_table(506) := '746869732E5F636F6E7461696E6572293B0A7D3B0A0A2F2A2A0A202A20406F7665726C6F72640A202A0A202A20526567697374657220616E206576656E74206C697374656E657220666F72206576656E747320776974682074686520676976656E206E61';
wwv_flow_imp.g_varchar2_table(507) := '6D652E0A202A0A202A205468652063616C6C6261636B2077696C6C20626520696E766F6B6564207769746820606576656E742C202E2E2E6164646974696F6E616C417267756D656E7473600A202A20746861742068617665206265656E20706173736564';
wwv_flow_imp.g_varchar2_table(508) := '20746F207B406C696E6B204576656E7442757323666972657D2E0A202A0A202A2052657475726E696E672066616C73652066726F6D2061206C697374656E65722077696C6C2070726576656E7420746865206576656E74732064656661756C7420616374';
wwv_flow_imp.g_varchar2_table(509) := '696F6E0A202A2028696620616E7920697320737065636966696564292E20546F2073746F7020616E206576656E742066726F6D206265696E672070726F636573736564206675727468657220696E0A202A206F74686572206C697374656E657273206578';
wwv_flow_imp.g_varchar2_table(510) := '6563757465207B406C696E6B204576656E742373746F7050726F7061676174696F6E7D2E0A202A0A202A2052657475726E696E6720616E797468696E67206275742060756E646566696E6564602066726F6D2061206C697374656E65722077696C6C2073';
wwv_flow_imp.g_varchar2_table(511) := '746F7020746865206C697374656E65722070726F7061676174696F6E2E0A202A0A202A204074656D706C61746520540A202A0A202A2040706172616D207B737472696E677C737472696E675B5D7D206576656E747320546865206576656E742873292074';
wwv_flow_imp.g_varchar2_table(512) := '6F206C697374656E20746F2E0A202A2040706172616D207B6E756D6265727D205B7072696F726974795D20546865207072696F72697479207769746820776869636820746F206C697374656E2E0A202A2040706172616D207B4576656E74427573457665';
wwv_flow_imp.g_varchar2_table(513) := '6E7443616C6C6261636B3C543E7D2063616C6C6261636B205468652063616C6C6261636B2E0A202A2040706172616D207B616E797D205B746861745D2056616C7565206F6620607468697360207468652063616C6C6261636B2077696C6C206265206361';
wwv_flow_imp.g_varchar2_table(514) := '6C6C656420776974682E0A202A2F0A2F2A2A0A202A20526567697374657220616E206576656E74206C697374656E657220666F72206576656E747320776974682074686520676976656E206E616D652E0A202A0A202A205468652063616C6C6261636B20';
wwv_flow_imp.g_varchar2_table(515) := '77696C6C20626520696E766F6B6564207769746820606576656E742C202E2E2E6164646974696F6E616C417267756D656E7473600A202A20746861742068617665206265656E2070617373656420746F207B406C696E6B204576656E7442757323666972';
wwv_flow_imp.g_varchar2_table(516) := '657D2E0A202A0A202A2052657475726E696E672066616C73652066726F6D2061206C697374656E65722077696C6C2070726576656E7420746865206576656E74732064656661756C7420616374696F6E0A202A2028696620616E79206973207370656369';
wwv_flow_imp.g_varchar2_table(517) := '66696564292E20546F2073746F7020616E206576656E742066726F6D206265696E672070726F636573736564206675727468657220696E0A202A206F74686572206C697374656E6572732065786563757465207B406C696E6B204576656E742373746F70';
wwv_flow_imp.g_varchar2_table(518) := '50726F7061676174696F6E7D2E0A202A0A202A2052657475726E696E6720616E797468696E67206275742060756E646566696E6564602066726F6D2061206C697374656E65722077696C6C2073746F7020746865206C697374656E65722070726F706167';
wwv_flow_imp.g_varchar2_table(519) := '6174696F6E2E0A202A0A202A204074656D706C617465207B6B65796F66204576656E744D61703C536572766963654D61703E7D204576656E744E616D650A202A0A202A2040706172616D207B4576656E744E616D657D206576656E747320746F20737562';
wwv_flow_imp.g_varchar2_table(520) := '73637269626520746F0A202A2040706172616D207B6E756D6265727D205B7072696F726974793D313030305D206C697374656E207072696F726974790A202A2040706172616D207B4576656E744275734576656E7443616C6C6261636B3C284576656E74';
wwv_flow_imp.g_varchar2_table(521) := '4D61703C536572766963654D61703E295B4576656E744E616D655D3E7D2063616C6C6261636B0A202A2040706172616D207B616E797D205B746861745D2063616C6C6261636B20636F6E746578740A202A2F0A426173655669657765722E70726F746F74';
wwv_flow_imp.g_varchar2_table(522) := '7970652E6F6E203D2066756E6374696F6E286576656E74732C207072696F726974792C2063616C6C6261636B2C207468617429207B0A202072657475726E20746869732E67657428276576656E7442757327292E6F6E286576656E74732C207072696F72';
wwv_flow_imp.g_varchar2_table(523) := '6974792C2063616C6C6261636B2C2074686174293B0A7D3B0A0A2F2A2A0A202A2052656D6F766520616E206576656E74206C697374656E65722E0A202A0A202A2040706172616D207B737472696E677C737472696E675B5D7D206576656E747320546865';
wwv_flow_imp.g_varchar2_table(524) := '206576656E742873292E0A202A2040706172616D207B46756E6374696F6E7D205B63616C6C6261636B5D205468652063616C6C6261636B2E0A202A2F0A426173655669657765722E70726F746F747970652E6F6666203D2066756E6374696F6E28657665';
wwv_flow_imp.g_varchar2_table(525) := '6E74732C2063616C6C6261636B29207B0A2020746869732E67657428276576656E7442757327292E6F6666286576656E74732C2063616C6C6261636B293B0A7D3B0A0A2F2A2A0A202A20417474616368207468652076696577657220746F20616E204854';
wwv_flow_imp.g_varchar2_table(526) := '4D4C20656C656D656E742E0A202A0A202A2040706172616D207B48544D4C456C656D656E747D20706172656E744E6F64652054686520706172656E74206E6F646520746F2061747461636820746F2E0A202A2F0A426173655669657765722E70726F746F';
wwv_flow_imp.g_varchar2_table(527) := '747970652E617474616368546F203D2066756E6374696F6E28706172656E744E6F646529207B0A0A20206966202821706172656E744E6F646529207B0A202020207468726F77206E6577204572726F722827706172656E744E6F64652072657175697265';
wwv_flow_imp.g_varchar2_table(528) := '6427293B0A20207D0A0A20202F2F20656E73757265207765206465746163682066726F6D207468650A20202F2F2070726576696F75732C206F6C6420706172656E740A2020746869732E64657461636828293B0A0A20202F2F20756E77726170206A5175';
wwv_flow_imp.g_varchar2_table(529) := '6572792069662070726F76696465640A202069662028706172656E744E6F64652E67657420262620706172656E744E6F64652E636F6E7374727563746F722E70726F746F747970652E6A717565727929207B0A20202020706172656E744E6F6465203D20';
wwv_flow_imp.g_varchar2_table(530) := '706172656E744E6F64652E6765742830293B0A20207D0A0A202069662028747970656F6620706172656E744E6F6465203D3D3D2027737472696E672729207B0A20202020706172656E744E6F6465203D2028302C6D696E5F646F6D5F5F5745425041434B';
wwv_flow_imp.g_varchar2_table(531) := '5F494D504F525445445F4D4F44554C455F345F5F2E71756572792928706172656E744E6F6465293B0A20207D0A0A2020706172656E744E6F64652E617070656E644368696C6428746869732E5F636F6E7461696E6572293B0A0A2020746869732E5F656D';
wwv_flow_imp.g_varchar2_table(532) := '69742827617474616368272C207B7D293B0A0A2020746869732E676574282763616E76617327292E726573697A656428293B0A7D3B0A0A2F2A2A0A202A204765742074686520646566696E6974696F6E73206D6F64656C20656C656D656E742E0A202A0A';
wwv_flow_imp.g_varchar2_table(533) := '202A204072657475726E207B4D6F64646C65456C656D656E747D2054686520646566696E6974696F6E73206D6F64656C20656C656D656E742E0A202A2F0A426173655669657765722E70726F746F747970652E676574446566696E6974696F6E73203D20';
wwv_flow_imp.g_varchar2_table(534) := '66756E6374696F6E2829207B0A202072657475726E20746869732E5F646566696E6974696F6E733B0A7D3B0A0A2F2A2A0A202A2044657461636820746865207669657765722E0A202A0A202A204066697265732042617365566965776572234465746163';
wwv_flow_imp.g_varchar2_table(535) := '684576656E740A202A2F0A426173655669657765722E70726F746F747970652E646574616368203D2066756E6374696F6E2829207B0A0A2020636F6E737420636F6E7461696E6572203D20746869732E5F636F6E7461696E65722C0A2020202020202020';
wwv_flow_imp.g_varchar2_table(536) := '706172656E744E6F6465203D20636F6E7461696E65722E706172656E744E6F64653B0A0A20206966202821706172656E744E6F646529207B0A2020202072657475726E3B0A20207D0A0A20202F2A2A0A2020202A2041206064657461636860206576656E';
wwv_flow_imp.g_varchar2_table(537) := '742E0A2020202A0A2020202A20406576656E742042617365566965776572234465746163684576656E740A2020202A204074797065207B4F626A6563747D0A2020202A2F0A2020746869732E5F656D69742827646574616368272C207B7D293B0A0A2020';
wwv_flow_imp.g_varchar2_table(538) := '706172656E744E6F64652E72656D6F76654368696C6428636F6E7461696E6572293B0A7D3B0A0A426173655669657765722E70726F746F747970652E5F696E6974203D2066756E6374696F6E28636F6E7461696E65722C206D6F64646C652C206F707469';
wwv_flow_imp.g_varchar2_table(539) := '6F6E7329207B0A0A2020636F6E737420626173654D6F64756C6573203D206F7074696F6E732E6D6F64756C6573207C7C20746869732E6765744D6F64756C6573286F7074696F6E73292C0A20202020202020206164646974696F6E616C4D6F64756C6573';
wwv_flow_imp.g_varchar2_table(540) := '203D206F7074696F6E732E6164646974696F6E616C4D6F64756C6573207C7C205B5D2C0A20202020202020207374617469634D6F64756C6573203D205B0A202020202020202020207B0A20202020202020202020202062706D6E6A733A205B202776616C';
wwv_flow_imp.g_varchar2_table(541) := '7565272C2074686973205D2C0A2020202020202020202020206D6F64646C653A205B202776616C7565272C206D6F64646C65205D0A202020202020202020207D0A20202020202020205D3B0A0A2020636F6E7374206469616772616D4D6F64756C657320';
wwv_flow_imp.g_varchar2_table(542) := '3D205B5D2E636F6E636174287374617469634D6F64756C65732C20626173654D6F64756C65732C206164646974696F6E616C4D6F64756C6573293B0A0A2020636F6E7374206469616772616D4F7074696F6E73203D2028302C6D696E5F646173685F5F57';
wwv_flow_imp.g_varchar2_table(543) := '45425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E292828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6F6D697429286F7074696F6E732C205B2027616464697469';
wwv_flow_imp.g_varchar2_table(544) := '6F6E616C4D6F64756C657327205D292C207B0A2020202063616E7661733A2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E29287B7D2C206F7074696F6E732E63616E7661732C20';
wwv_flow_imp.g_varchar2_table(545) := '7B20636F6E7461696E65723A20636F6E7461696E6572207D292C0A202020206D6F64756C65733A206469616772616D4D6F64756C65730A20207D293B0A0A20202F2F20696E766F6B65206469616772616D20636F6E7374727563746F720A202064696167';
wwv_flow_imp.g_varchar2_table(546) := '72616D5F6A735F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F5B2264656661756C74225D2E63616C6C28746869732C206469616772616D4F7074696F6E73293B0A0A2020696620286F7074696F6E73202626206F7074696F6E73';
wwv_flow_imp.g_varchar2_table(547) := '2E636F6E7461696E657229207B0A20202020746869732E617474616368546F286F7074696F6E732E636F6E7461696E6572293B0A20207D0A7D3B0A0A2F2A2A0A202A20456D697420616E206576656E74206F6E2074686520756E6465726C79696E67207B';
wwv_flow_imp.g_varchar2_table(548) := '406C696E6B204576656E744275737D0A202A0A202A2040706172616D20207B737472696E677D20747970650A202A2040706172616D20207B4F626A6563747D206576656E740A202A0A202A204072657475726E207B4F626A6563747D2054686520726574';
wwv_flow_imp.g_varchar2_table(549) := '75726E2076616C75652061667465722063616C6C696E6720616C6C206576656E74206C697374656E6572732E0A202A2F0A426173655669657765722E70726F746F747970652E5F656D6974203D2066756E6374696F6E28747970652C206576656E742920';
wwv_flow_imp.g_varchar2_table(550) := '7B0A202072657475726E20746869732E67657428276576656E7442757327292E6669726528747970652C206576656E74293B0A7D3B0A0A2F2A2A0A202A2040706172616D207B426173655669657765724F7074696F6E737D206F7074696F6E730A202A0A';
wwv_flow_imp.g_varchar2_table(551) := '202A204072657475726E207B48544D4C456C656D656E747D0A202A2F0A426173655669657765722E70726F746F747970652E5F637265617465436F6E7461696E6572203D2066756E6374696F6E286F7074696F6E7329207B0A0A2020636F6E737420636F';
wwv_flow_imp.g_varchar2_table(552) := '6E7461696E6572203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E646F6D6966792928273C64697620636C6173733D22626A732D636F6E7461696E6572223E3C2F6469763E27293B0A0A202028';
wwv_flow_imp.g_varchar2_table(553) := '302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E61737369676E5374796C652928636F6E7461696E65722C207B0A2020202077696474683A20656E73757265556E6974286F7074696F6E732E7769647468';
wwv_flow_imp.g_varchar2_table(554) := '292C0A202020206865696768743A20656E73757265556E6974286F7074696F6E732E686569676874292C0A20202020706F736974696F6E3A206F7074696F6E732E706F736974696F6E0A20207D293B0A0A202072657475726E20636F6E7461696E65723B';
wwv_flow_imp.g_varchar2_table(555) := '0A7D3B0A0A2F2A2A0A202A2040706172616D207B426173655669657765724F7074696F6E737D206F7074696F6E730A202A0A202A204072657475726E207B4D6F64646C657D0A202A2F0A426173655669657765722E70726F746F747970652E5F63726561';
wwv_flow_imp.g_varchar2_table(556) := '74654D6F64646C65203D2066756E6374696F6E286F7074696F6E7329207B0A2020636F6E7374206D6F64646C654F7074696F6E73203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369';
wwv_flow_imp.g_varchar2_table(557) := '676E29287B7D2C20746869732E5F6D6F64646C65457874656E73696F6E732C206F7074696F6E732E6D6F64646C65457874656E73696F6E73293B0A0A202072657475726E206E65772062706D6E5F6D6F64646C655F5F5745425041434B5F494D504F5254';
wwv_flow_imp.g_varchar2_table(558) := '45445F4D4F44554C455F365F5F5B2264656661756C74225D286D6F64646C654F7074696F6E73293B0A7D3B0A0A426173655669657765722E70726F746F747970652E5F6D6F64756C6573203D205B5D3B0A0A2F2F2068656C70657273202F2F2F2F2F2F2F';
wwv_flow_imp.g_varchar2_table(559) := '2F2F2F2F2F2F2F2F0A0A66756E6374696F6E206164645761726E696E6773546F4572726F72286572722C207761726E696E677341727929207B0A20206572722E7761726E696E6773203D207761726E696E67734172793B0A202072657475726E20657272';
wwv_flow_imp.g_varchar2_table(560) := '3B0A7D0A0A66756E6374696F6E20636865636B56616C69646174696F6E4572726F722865727229207B0A0A20202F2F20636865636B2069662077652063616E2068656C7020746865207573657220627920696E6469636174696E672077726F6E67204250';
wwv_flow_imp.g_varchar2_table(561) := '4D4E20322E3020786D6C0A20202F2F2028696E2063617365206865206F7220746865206578706F7274696E6720746F6F6C20646964206E6F74206765742074686174207269676874290A0A2020636F6E7374207061747465726E203D202F756E70617273';
wwv_flow_imp.g_varchar2_table(562) := '61626C6520636F6E74656E74203C285B5E3E5D2B293E206465746563746564285B5C735C535D2A29242F3B0A2020636F6E7374206D61746368203D207061747465726E2E65786563286572722E6D657373616765293B0A0A2020696620286D6174636829';
wwv_flow_imp.g_varchar2_table(563) := '207B0A202020206572722E6D657373616765203D0A20202020202027756E7061727361626C6520636F6E74656E74203C27202B206D617463685B315D202B20273E2064657465637465643B2027202B0A2020202020202774686973206D617920696E6469';
wwv_flow_imp.g_varchar2_table(564) := '6361746520616E20696E76616C69642042504D4E20322E30206469616772616D2066696C6527202B206D617463685B325D3B0A20207D0A0A202072657475726E206572723B0A7D0A0A636F6E73742044454641554C545F4F5054494F4E53203D207B0A20';
wwv_flow_imp.g_varchar2_table(565) := '2077696474683A202731303025272C0A20206865696768743A202731303025272C0A2020706F736974696F6E3A202772656C6174697665270A7D3B0A0A0A2F2A2A0A202A20456E73757265207468652070617373656420617267756D656E742069732061';
wwv_flow_imp.g_varchar2_table(566) := '2070726F70657220756E6974202864656661756C74696E6720746F207078290A202A2F0A66756E6374696F6E20656E73757265556E69742876616C29207B0A202072657475726E2076616C202B202828302C6D696E5F646173685F5F5745425041434B5F';
wwv_flow_imp.g_varchar2_table(567) := '494D504F525445445F4D4F44554C455F305F5F2E69734E756D626572292876616C29203F2027707827203A202727293B0A7D0A0A0A2F2A2A0A202A2046696E642042504D4E4469616772616D20696E20646566696E6974696F6E732062792049440A202A';
wwv_flow_imp.g_varchar2_table(568) := '0A202A2040706172616D207B4D6F64646C65456C656D656E743C446566696E6974696F6E733E7D20646566696E6974696F6E730A202A2040706172616D207B737472696E677D206469616772616D49640A202A0A202A204072657475726E207B4D6F6464';
wwv_flow_imp.g_varchar2_table(569) := '6C65456C656D656E743C42504D4E4469616772616D3E7C6E756C6C7D0A202A2F0A66756E6374696F6E2066696E6442504D4E4469616772616D28646566696E6974696F6E732C206469616772616D496429207B0A202069662028216469616772616D4964';
wwv_flow_imp.g_varchar2_table(570) := '29207B0A2020202072657475726E206E756C6C3B0A20207D0A0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E66696E642928646566696E6974696F6E732E646961677261';
wwv_flow_imp.g_varchar2_table(571) := '6D732C2066756E6374696F6E28656C656D656E7429207B0A2020202072657475726E20656C656D656E742E6964203D3D3D206469616772616D49643B0A20207D29207C7C206E756C6C3B0A7D0A0A0A2F2A203C70726F6A6563742D6C6F676F3E202A2F0A';
wwv_flow_imp.g_varchar2_table(572) := '0A0A0A0A0A2F2A2A0A202A2041646473207468652070726F6A656374206C6F676F20746F20746865206469616772616D20636F6E7461696E65722061730A202A207265717569726564206279207468652062706D6E2E696F206C6963656E73652E0A202A';
wwv_flow_imp.g_varchar2_table(573) := '0A202A204073656520687474703A2F2F62706D6E2E696F2F6C6963656E73650A202A0A202A2040706172616D207B456C656D656E747D20636F6E7461696E65720A202A2F0A66756E6374696F6E2061646450726F6A6563744C6F676F28636F6E7461696E';
wwv_flow_imp.g_varchar2_table(574) := '657229207B0A2020636F6E737420696D67203D205F7574696C5F506F776572656442795574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F375F5F2E42504D4E494F5F494D473B0A0A2020636F6E7374206C696E6B4D61726B7570';
wwv_flow_imp.g_varchar2_table(575) := '203D0A20202020273C6120687265663D22687474703A2F2F62706D6E2E696F222027202B0A20202020277461726765743D225F626C616E6B222027202B0A2020202027636C6173733D22626A732D706F77657265642D6279222027202B0A202020202774';
wwv_flow_imp.g_varchar2_table(576) := '69746C653D22506F77657265642062792062706D6E2E696F222027202B0A20202020273E27202B0A20202020696D67202B0A20202020273C2F613E273B0A0A2020636F6E7374206C696E6B456C656D656E74203D2028302C6D696E5F646F6D5F5F574542';
wwv_flow_imp.g_varchar2_table(577) := '5041434B5F494D504F525445445F4D4F44554C455F345F5F2E646F6D69667929286C696E6B4D61726B7570293B0A0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E61737369676E5374796C65';
wwv_flow_imp.g_varchar2_table(578) := '292828302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E7175657279292827737667272C206C696E6B456C656D656E74292C205F7574696C5F506F776572656442795574696C5F5F5745425041434B5F49';
wwv_flow_imp.g_varchar2_table(579) := '4D504F525445445F4D4F44554C455F375F5F2E4C4F474F5F5354594C4553293B0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E61737369676E5374796C6529286C696E6B456C656D656E742C';
wwv_flow_imp.g_varchar2_table(580) := '205F7574696C5F506F776572656442795574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F375F5F2E4C494E4B5F5354594C45532C207B0A20202020706F736974696F6E3A20276162736F6C757465272C0A20202020626F74746F';
wwv_flow_imp.g_varchar2_table(581) := '6D3A202731357078272C0A2020202072696768743A202731357078272C0A202020207A496E6465783A2027313030270A20207D293B0A0A2020636F6E7461696E65722E617070656E644368696C64286C696E6B456C656D656E74293B0A0A20206D696E5F';
wwv_flow_imp.g_varchar2_table(582) := '646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E6576656E742E62696E64286C696E6B456C656D656E742C2027636C69636B272C2066756E6374696F6E286576656E7429207B0A2020202028302C5F7574696C5F506F77';
wwv_flow_imp.g_varchar2_table(583) := '6572656442795574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F375F5F2E6F70656E2928293B0A0A202020206576656E742E70726576656E7444656661756C7428293B0A20207D293B0A7D0A0A2F2A203C2F70726F6A6563742D';
wwv_flow_imp.g_varchar2_table(584) := '6C6F676F3E202A2F0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F5669657765722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(585) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F5669657765722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(586) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F';
wwv_flow_imp.g_varchar2_table(587) := '7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F72';
wwv_flow_imp.g_varchar2_table(588) := '74735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F20566965776572290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2068';
wwv_flow_imp.g_varchar2_table(589) := '61726D6F6E7920696D706F7274202A2F2076617220696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A2120696E6865726974';
wwv_flow_imp.g_varchar2_table(590) := '732D62726F77736572202A2F20222E2F6E6F64655F6D6F64756C65732F696E6865726974732D62726F777365722F646973742F696E6465782E65732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F636F72655F5F5745';
wwv_flow_imp.g_varchar2_table(591) := '425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F636F7265202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F636F72652F696E646578';
wwv_flow_imp.g_varchar2_table(592) := '2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F66656174757265735F6472696C6C646F776E5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F72657175697265';
wwv_flow_imp.g_varchar2_table(593) := '5F5F282F2A21202E2F66656174757265732F6472696C6C646F776E202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F696E6465782E6A7322293B0A2F2A206861726D6F6E79';
wwv_flow_imp.g_varchar2_table(594) := '20696D706F7274202A2F20766172205F66656174757265735F6F75746C696E655F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F66656174757265732F6F';
wwv_flow_imp.g_varchar2_table(595) := '75746C696E65202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6F75746C696E652F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F';
wwv_flow_imp.g_varchar2_table(596) := '6A735F6C69625F66656174757265735F6F7665726C6179735F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F6665617475';
wwv_flow_imp.g_varchar2_table(597) := '7265732F6F7665726C617973202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F7665726C6179732F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661';
wwv_flow_imp.g_varchar2_table(598) := '72206469616772616D5F6A735F6C69625F66656174757265735F73656C656374696F6E5F5F5745425041434B5F494D504F525445445F4D4F44554C455F365F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A';
wwv_flow_imp.g_varchar2_table(599) := '732F6C69622F66656174757265732F73656C656374696F6E202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E2F696E6465782E6A7322293B0A2F2A206861726D6F6E79';
wwv_flow_imp.g_varchar2_table(600) := '20696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F6931386E5F7472616E736C6174655F5F5745425041434B5F494D504F525445445F4D4F44554C455F375F5F203D205F5F7765627061636B5F726571756972655F5F282F2A2120';
wwv_flow_imp.g_varchar2_table(601) := '6469616772616D2D6A732F6C69622F6931386E2F7472616E736C617465202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6931386E2F7472616E736C6174652F696E6465782E6A7322293B0A2F2A206861726D6F6E';
wwv_flow_imp.g_varchar2_table(602) := '7920696D706F7274202A2F20766172205F426173655669657765725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F42617365566965776572202A2F2022';
wwv_flow_imp.g_varchar2_table(603) := '2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F426173655669657765722E6A7322293B0A0A0A0A0A0A0A0A0A0A0A0A0A2F2A2A0A202A204074797065646566207B20696D706F727428272E2F4261736556696577657227292E426173';
wwv_flow_imp.g_varchar2_table(604) := '655669657765724F7074696F6E73207D20426173655669657765724F7074696F6E730A202A2F0A0A2F2A2A0A202A20412076696577657220666F722042504D4E20322E30206469616772616D732E0A202A0A202A20486176652061206C6F6F6B20617420';
wwv_flow_imp.g_varchar2_table(605) := '7B406C696E6B2062706D6E2D6A732F6C69622F4E61766967617465645669657765727D206F72207B406C696E6B2062706D6E2D6A732F6C69622F4D6F64656C65727D20666F722062756E646C6573207468617420696E636C7564650A202A206164646974';
wwv_flow_imp.g_varchar2_table(606) := '696F6E616C2066656174757265732E0A202A0A202A0A202A20232320457874656E64696E6720746865205669657765720A202A0A202A20496E206F7264657220746F20657874656E642074686520766965776572207061737320657874656E73696F6E20';
wwv_flow_imp.g_varchar2_table(607) := '6D6F64756C657320746F20626F6F74737472617020766961207468650A202A20606164646974696F6E616C4D6F64756C657360206F7074696F6E2E20416E20657874656E73696F6E206D6F64756C6520697320616E206F626A6563742074686174206578';
wwv_flow_imp.g_varchar2_table(608) := '706F7365730A202A206E616D65642073657276696365732E0A202A0A202A2054686520666F6C6C6F77696E67206578616D706C6520646570696374732074686520696E746567726174696F6E206F6620612073696D706C650A202A206C6F6767696E6720';
wwv_flow_imp.g_varchar2_table(609) := '636F6D706F6E656E74207468617420696E7465677261746573207769746820696E746572616374696F6E206576656E74733A0A202A0A202A0A202A206060606A6176617363726970740A202A0A202A202F2F206C6F6767696E6720636F6D706F6E656E74';
wwv_flow_imp.g_varchar2_table(610) := '0A202A2066756E6374696F6E20496E746572616374696F6E4C6F67676572286576656E7442757329207B0A202A2020206576656E744275732E6F6E2827656C656D656E742E686F766572272C2066756E6374696F6E286576656E7429207B0A202A202020';
wwv_flow_imp.g_varchar2_table(611) := '2020636F6E736F6C652E6C6F6728290A202A2020207D290A202A207D0A202A0A202A20496E746572616374696F6E4C6F676765722E24696E6A656374203D205B20276576656E7442757327205D3B202F2F206D696E696669636174696F6E20736176650A';
wwv_flow_imp.g_varchar2_table(612) := '202A0A202A202F2F20657874656E73696F6E206D6F64756C650A202A2076617220657874656E73696F6E4D6F64756C65203D207B0A202A2020205F5F696E69745F5F3A205B2027696E746572616374696F6E4C6F6767657227205D2C0A202A202020696E';
wwv_flow_imp.g_varchar2_table(613) := '746572616374696F6E4C6F676765723A205B202774797065272C20496E746572616374696F6E4C6F67676572205D0A202A207D3B0A202A0A202A202F2F20657874656E6420746865207669657765720A202A207661722062706D6E566965776572203D20';
wwv_flow_imp.g_varchar2_table(614) := '6E657720566965776572287B206164646974696F6E616C4D6F64756C65733A205B20657874656E73696F6E4D6F64756C65205D207D293B0A202A2062706D6E5669657765722E696D706F7274584D4C282E2E2E293B0A202A206060600A202A0A202A2040';
wwv_flow_imp.g_varchar2_table(615) := '74656D706C617465205B536572766963654D61703D6E756C6C5D0A202A0A202A2040657874656E647320426173655669657765723C536572766963654D61703E0A202A0A202A2040706172616D207B426173655669657765724F7074696F6E737D205B6F';
wwv_flow_imp.g_varchar2_table(616) := '7074696F6E735D20546865206F7074696F6E7320746F20636F6E66696775726520746865207669657765722E0A202A2F0A66756E6374696F6E20566965776572286F7074696F6E7329207B0A20205F426173655669657765725F5F5745425041434B5F49';
wwv_flow_imp.g_varchar2_table(617) := '4D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D2E63616C6C28746869732C206F7074696F6E73293B0A7D0A0A28302C696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F31';
wwv_flow_imp.g_varchar2_table(618) := '5F5F5B2264656661756C74225D29285669657765722C205F426173655669657765725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D293B0A0A2F2F206D6F64756C6573207468652076696577657220';
wwv_flow_imp.g_varchar2_table(619) := '697320636F6D706F736564206F660A5669657765722E70726F746F747970652E5F6D6F64756C6573203D205B0A20205F636F72655F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F5B2264656661756C74225D2C0A20205F666561';
wwv_flow_imp.g_varchar2_table(620) := '74757265735F6472696C6C646F776E5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F5B2264656661756C74225D2C0A20205F66656174757265735F6F75746C696E655F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(621) := '455F345F5F5B2264656661756C74225D2C0A20206469616772616D5F6A735F6C69625F66656174757265735F6F7665726C6179735F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F5B2264656661756C74225D2C0A202064696167';
wwv_flow_imp.g_varchar2_table(622) := '72616D5F6A735F6C69625F66656174757265735F73656C656374696F6E5F5F5745425041434B5F494D504F525445445F4D4F44554C455F365F5F5B2264656661756C74225D2C0A20206469616772616D5F6A735F6C69625F6931386E5F7472616E736C61';
wwv_flow_imp.g_varchar2_table(623) := '74655F5F5745425041434B5F494D504F525445445F4D4F44554C455F375F5F5B2264656661756C74225D0A5D3B0A0A2F2F2064656661756C74206D6F64646C6520657874656E73696F6E73207468652076696577657220697320636F6D706F736564206F';
wwv_flow_imp.g_varchar2_table(624) := '660A5669657765722E70726F746F747970652E5F6D6F64646C65457874656E73696F6E73203D207B7D3B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F636F72652F696E6465782E';
wwv_flow_imp.g_varchar2_table(625) := '6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F636F72652F69';
wwv_flow_imp.g_varchar2_table(626) := '6E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F';
wwv_flow_imp.g_varchar2_table(627) := '5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E';
wwv_flow_imp.g_varchar2_table(628) := '79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F';
wwv_flow_imp.g_varchar2_table(629) := '5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F647261775F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(630) := '4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F64726177202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F696E6465782E6A7322293B0A2F2A206861726D';
wwv_flow_imp.g_varchar2_table(631) := '6F6E7920696D706F7274202A2F20766172205F696D706F72745F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F696D706F7274202A2F20222E2F6E6F64';
wwv_flow_imp.g_varchar2_table(632) := '655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F696E6465782E6A7322293B0A0A0A0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F455850';
wwv_flow_imp.g_varchar2_table(633) := '4F52545F5F203D20287B0A20205F5F646570656E64735F5F3A205B0A202020205F647261775F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D2C0A202020205F696D706F72745F5F5745425041434B5F';
wwv_flow_imp.g_varchar2_table(634) := '494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D0A20205D0A7D293B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F42706D6E52656E646572';
wwv_flow_imp.g_varchar2_table(635) := '5574696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E';
wwv_flow_imp.g_varchar2_table(636) := '2D6A732F6C69622F647261772F42706D6E52656E6465725574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A';
wwv_flow_imp.g_varchar2_table(637) := '2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72';
wwv_flow_imp.g_varchar2_table(638) := '285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E7920';
wwv_flow_imp.g_varchar2_table(639) := '6578706F7274202A2F202020626C61636B3A202829203D3E20282F2A2062696E64696E67202A2F20626C61636B292C0A2F2A206861726D6F6E79206578706F7274202A2F202020676574426F756E64733A202829203D3E20282F2A2062696E64696E6720';
wwv_flow_imp.g_varchar2_table(640) := '2A2F20676574426F756E6473292C0A2F2A206861726D6F6E79206578706F7274202A2F202020676574436972636C65506174683A202829203D3E20282F2A2062696E64696E67202A2F20676574436972636C6550617468292C0A2F2A206861726D6F6E79';
wwv_flow_imp.g_varchar2_table(641) := '206578706F7274202A2F20202067657444693A202829203D3E20282F2A2072656578706F72742073616665202A2F205F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6765744469292C0A';
wwv_flow_imp.g_varchar2_table(642) := '2F2A206861726D6F6E79206578706F7274202A2F2020206765744469616D6F6E64506174683A202829203D3E20282F2A2062696E64696E67202A2F206765744469616D6F6E6450617468292C0A2F2A206861726D6F6E79206578706F7274202A2F202020';
wwv_flow_imp.g_varchar2_table(643) := '67657446696C6C436F6C6F723A202829203D3E20282F2A2062696E64696E67202A2F2067657446696C6C436F6C6F72292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206765744865696768743A202829203D3E20282F2A2062696E64696E';
wwv_flow_imp.g_varchar2_table(644) := '67202A2F20676574486569676874292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206765744C6162656C436F6C6F723A202829203D3E20282F2A2062696E64696E67202A2F206765744C6162656C436F6C6F72292C0A2F2A206861726D6F';
wwv_flow_imp.g_varchar2_table(645) := '6E79206578706F7274202A2F20202067657452656374506174683A202829203D3E20282F2A2062696E64696E67202A2F206765745265637450617468292C0A2F2A206861726D6F6E79206578706F7274202A2F202020676574526F756E64526563745061';
wwv_flow_imp.g_varchar2_table(646) := '74683A202829203D3E20282F2A2062696E64696E67202A2F20676574526F756E645265637450617468292C0A2F2A206861726D6F6E79206578706F7274202A2F20202067657453656D616E7469633A202829203D3E20282F2A2072656578706F72742073';
wwv_flow_imp.g_varchar2_table(647) := '616665202A2F205F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E676574427573696E6573734F626A656374292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206765745374';
wwv_flow_imp.g_varchar2_table(648) := '726F6B65436F6C6F723A202829203D3E20282F2A2062696E64696E67202A2F206765745374726F6B65436F6C6F72292C0A2F2A206861726D6F6E79206578706F7274202A2F20202067657457696474683A202829203D3E20282F2A2062696E64696E6720';
wwv_flow_imp.g_varchar2_table(649) := '2A2F206765745769647468292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206973436F6C6C656374696F6E3A202829203D3E20282F2A2062696E64696E67202A2F206973436F6C6C656374696F6E292C0A2F2A206861726D6F6E79206578';
wwv_flow_imp.g_varchar2_table(650) := '706F7274202A2F20202069735468726F774576656E743A202829203D3E20282F2A2062696E64696E67202A2F2069735468726F774576656E74292C0A2F2A206861726D6F6E79206578706F7274202A2F202020697354797065644576656E743A20282920';
wwv_flow_imp.g_varchar2_table(651) := '3D3E20282F2A2062696E64696E67202A2F20697354797065644576656E74292C0A2F2A206861726D6F6E79206578706F7274202A2F20202077686974653A202829203D3E20282F2A2062696E64696E67202A2F207768697465290A2F2A206861726D6F6E';
wwv_flow_imp.g_varchar2_table(652) := '79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F';
wwv_flow_imp.g_varchar2_table(653) := '282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6F64656C55';
wwv_flow_imp.g_varchar2_table(654) := '74696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E';
wwv_flow_imp.g_varchar2_table(655) := '2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F7574696C5F52656E6465725574696C5F5F5745425041434B5F494D504F5254';
wwv_flow_imp.g_varchar2_table(656) := '45445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F7574696C2F52656E6465725574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A73';
wwv_flow_imp.g_varchar2_table(657) := '2F6C69622F7574696C2F52656E6465725574696C2E6A7322293B0A0A0A0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C27292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E740A20';
wwv_flow_imp.g_varchar2_table(658) := '2A204074797065646566207B696D706F727428272E2E2F6D6F64656C27292E456C656D656E747D20456C656D656E740A202A0A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C27292E53686170654C696B657D2053686170654C';
wwv_flow_imp.g_varchar2_table(659) := '696B650A202A0A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F7574696C2F547970657327292E44696D656E73696F6E737D2044696D656E73696F6E730A202A204074797065646566207B696D706F72742827';
wwv_flow_imp.g_varchar2_table(660) := '6469616772616D2D6A732F6C69622F7574696C2F547970657327292E526563747D20526563740A202A2F0A0A2F2F2072652D6578706F727420666F7220636F6D7061746962696C6974790A0A0A0A76617220626C61636B203D202768736C283232352C20';
wwv_flow_imp.g_varchar2_table(661) := '3130252C2031352529273B0A766172207768697465203D20277768697465273B0A0A2F2F20656C656D656E74207574696C73202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A2F2A2A0A202A20436865636B73206966206576656E74446566';
wwv_flow_imp.g_varchar2_table(662) := '696E6974696F6E206F662074686520676976656E20656C656D656E74206D61746368657320776974682073656D616E74696320747970652E0A202A0A202A2040706172616D207B4D6F64646C65456C656D656E747D206576656E740A202A204070617261';
wwv_flow_imp.g_varchar2_table(663) := '6D207B737472696E677D206576656E74446566696E6974696F6E547970650A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E20697354797065644576656E74286576656E742C206576656E74446566696E6974';
wwv_flow_imp.g_varchar2_table(664) := '696F6E5479706529207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E736F6D6529286576656E742E6576656E74446566696E6974696F6E732C2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(665) := '646566696E6974696F6E29207B0A2020202072657475726E20646566696E6974696F6E2E2474797065203D3D3D206576656E74446566696E6974696F6E547970653B0A20207D293B0A7D0A0A2F2A2A0A202A20436865636B20696620656C656D656E7420';
wwv_flow_imp.g_varchar2_table(666) := '69732061207468726F77206576656E742E0A202A0A202A2040706172616D207B4D6F64646C65456C656D656E747D206576656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E2069735468726F77457665';
wwv_flow_imp.g_varchar2_table(667) := '6E74286576656E7429207B0A202072657475726E20286576656E742E2474797065203D3D3D202762706D6E3A496E7465726D6564696174655468726F774576656E742729207C7C20286576656E742E2474797065203D3D3D202762706D6E3A456E644576';
wwv_flow_imp.g_varchar2_table(668) := '656E7427293B0A7D0A0A2F2A2A0A202A20436865636B20696620656C656D656E742069732061207468726F77206576656E742E0A202A0A202A2040706172616D207B4D6F64646C65456C656D656E747D20656C656D656E740A202A0A202A204072657475';
wwv_flow_imp.g_varchar2_table(669) := '726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206973436F6C6C656374696F6E28656C656D656E7429207B0A202076617220646174614F626A656374203D20656C656D656E742E646174614F626A6563745265663B0A0A20207265747572';
wwv_flow_imp.g_varchar2_table(670) := '6E20656C656D656E742E6973436F6C6C656374696F6E207C7C2028646174614F626A65637420262620646174614F626A6563742E6973436F6C6C656374696F6E293B0A7D0A0A0A2F2F20636F6C6F7220616363657373202F2F2F2F2F2F2F2F2F2F2F2F2F';
wwv_flow_imp.g_varchar2_table(671) := '2F2F2F2F2F2F2F2F2F0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A2040706172616D207B737472696E677D205B64656661756C74436F6C6F725D0A202A2040706172616D207B737472696E677D205B6F7665';
wwv_flow_imp.g_varchar2_table(672) := '7272696465436F6C6F725D0A202A0A202A204072657475726E207B737472696E677D0A202A2F0A66756E6374696F6E2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C74436F6C6F722C206F76657272696465436F6C6F7229207B';
wwv_flow_imp.g_varchar2_table(673) := '0A2020766172206469203D2028302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E67657444692928656C656D656E74293B0A0A202072657475726E206F76657272696465436F6C6F72';
wwv_flow_imp.g_varchar2_table(674) := '207C7C2064692E6765742827636F6C6F723A6261636B67726F756E642D636F6C6F722729207C7C2064692E676574282762696F633A66696C6C2729207C7C2064656661756C74436F6C6F72207C7C2077686974653B0A7D0A0A2F2A2A0A202A2040706172';
wwv_flow_imp.g_varchar2_table(675) := '616D207B456C656D656E747D20656C656D656E740A202A2040706172616D207B737472696E677D205B64656661756C74436F6C6F725D0A202A2040706172616D207B737472696E677D205B6F76657272696465436F6C6F725D0A202A0A202A2040726574';
wwv_flow_imp.g_varchar2_table(676) := '75726E207B737472696E677D0A202A2F0A66756E6374696F6E206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C74436F6C6F722C206F76657272696465436F6C6F7229207B0A2020766172206469203D2028302C5F7574696C';
wwv_flow_imp.g_varchar2_table(677) := '5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E67657444692928656C656D656E74293B0A0A202072657475726E206F76657272696465436F6C6F72207C7C2064692E6765742827636F6C6F723A626F';
wwv_flow_imp.g_varchar2_table(678) := '726465722D636F6C6F722729207C7C2064692E676574282762696F633A7374726F6B652729207C7C2064656661756C74436F6C6F72207C7C20626C61636B3B0A7D0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A20';
wwv_flow_imp.g_varchar2_table(679) := '2A2040706172616D207B737472696E677D205B64656661756C74436F6C6F725D0A202A2040706172616D207B737472696E677D205B64656661756C745374726F6B65436F6C6F725D0A202A2040706172616D207B737472696E677D205B6F766572726964';
wwv_flow_imp.g_varchar2_table(680) := '65436F6C6F725D0A202A0A202A204072657475726E207B737472696E677D0A202A2F0A66756E6374696F6E206765744C6162656C436F6C6F7228656C656D656E742C2064656661756C74436F6C6F722C2064656661756C745374726F6B65436F6C6F722C';
wwv_flow_imp.g_varchar2_table(681) := '206F76657272696465436F6C6F7229207B0A2020766172206469203D2028302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E67657444692928656C656D656E74292C0A202020202020';
wwv_flow_imp.g_varchar2_table(682) := '6C6162656C203D2064692E67657428276C6162656C27293B0A0A202072657475726E206F76657272696465436F6C6F72207C7C20286C6162656C202626206C6162656C2E6765742827636F6C6F723A636F6C6F72272929207C7C2064656661756C74436F';
wwv_flow_imp.g_varchar2_table(683) := '6C6F72207C7C0A202020206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F72293B0A7D0A0A2F2F2063726F7070696E67207061746820637573746F6D697A6174696F6E73202F2F2F2F2F2F2F2F2F';
wwv_flow_imp.g_varchar2_table(684) := '2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A2F2A2A0A202A2040706172616D207B53686170654C696B657D2073686170650A202A0A202A204072657475726E207B737472696E677D20706174680A202A2F0A66756E6374696F6E20676574436972636C65506174';
wwv_flow_imp.g_varchar2_table(685) := '6828736861706529207B0A0A2020766172206378203D2073686170652E78202B2073686170652E7769647468202F20322C0A2020202020206379203D2073686170652E79202B2073686170652E686569676874202F20322C0A2020202020207261646975';
wwv_flow_imp.g_varchar2_table(686) := '73203D2073686170652E7769647468202F20323B0A0A202076617220636972636C6550617468203D205B0A202020205B20274D272C2063782C206379205D2C0A202020205B20276D272C20302C202D726164697573205D2C0A202020205B202761272C20';
wwv_flow_imp.g_varchar2_table(687) := '7261646975732C207261646975732C20302C20312C20312C20302C2032202A20726164697573205D2C0A202020205B202761272C207261646975732C207261646975732C20302C20312C20312C20302C202D32202A20726164697573205D2C0A20202020';
wwv_flow_imp.g_varchar2_table(688) := '5B20277A27205D0A20205D3B0A0A202072657475726E2028302C6469616772616D5F6A735F6C69625F7574696C5F52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E636F6D706F6E656E7473546F5061';
wwv_flow_imp.g_varchar2_table(689) := '74682928636972636C6550617468293B0A7D0A0A2F2A2A0A202A2040706172616D207B53686170654C696B657D2073686170650A202A2040706172616D207B6E756D6265727D205B626F726465725261646975735D0A202A0A202A204072657475726E20';
wwv_flow_imp.g_varchar2_table(690) := '7B737472696E677D20706174680A202A2F0A66756E6374696F6E20676574526F756E6452656374506174682873686170652C20626F7264657252616469757329207B0A0A20207661722078203D2073686170652E782C0A20202020202079203D20736861';
wwv_flow_imp.g_varchar2_table(691) := '70652E792C0A2020202020207769647468203D2073686170652E77696474682C0A202020202020686569676874203D2073686170652E6865696768743B0A0A202076617220726F756E645265637450617468203D205B0A202020205B20274D272C207820';
wwv_flow_imp.g_varchar2_table(692) := '2B20626F726465725261646975732C2079205D2C0A202020205B20276C272C207769647468202D20626F72646572526164697573202A20322C2030205D2C0A202020205B202761272C20626F726465725261646975732C20626F72646572526164697573';
wwv_flow_imp.g_varchar2_table(693) := '2C20302C20302C20312C20626F726465725261646975732C20626F72646572526164697573205D2C0A202020205B20276C272C20302C20686569676874202D20626F72646572526164697573202A2032205D2C0A202020205B202761272C20626F726465';
wwv_flow_imp.g_varchar2_table(694) := '725261646975732C20626F726465725261646975732C20302C20302C20312C202D626F726465725261646975732C20626F72646572526164697573205D2C0A202020205B20276C272C20626F72646572526164697573202A2032202D2077696474682C20';
wwv_flow_imp.g_varchar2_table(695) := '30205D2C0A202020205B202761272C20626F726465725261646975732C20626F726465725261646975732C20302C20302C20312C202D626F726465725261646975732C202D626F72646572526164697573205D2C0A202020205B20276C272C20302C2062';
wwv_flow_imp.g_varchar2_table(696) := '6F72646572526164697573202A2032202D20686569676874205D2C0A202020205B202761272C20626F726465725261646975732C20626F726465725261646975732C20302C20302C20312C20626F726465725261646975732C202D626F72646572526164';
wwv_flow_imp.g_varchar2_table(697) := '697573205D2C0A202020205B20277A27205D0A20205D3B0A0A202072657475726E2028302C6469616772616D5F6A735F6C69625F7574696C5F52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E636F6D';
wwv_flow_imp.g_varchar2_table(698) := '706F6E656E7473546F506174682928726F756E645265637450617468293B0A7D0A0A2F2A2A0A202A2040706172616D207B53686170654C696B657D2073686170650A202A0A202A204072657475726E207B737472696E677D20706174680A202A2F0A6675';
wwv_flow_imp.g_varchar2_table(699) := '6E6374696F6E206765744469616D6F6E645061746828736861706529207B0A0A2020766172207769647468203D2073686170652E77696474682C0A202020202020686569676874203D2073686170652E6865696768742C0A20202020202078203D207368';
wwv_flow_imp.g_varchar2_table(700) := '6170652E782C0A20202020202079203D2073686170652E792C0A20202020202068616C665769647468203D207769647468202F20322C0A20202020202068616C66486569676874203D20686569676874202F20323B0A0A2020766172206469616D6F6E64';
wwv_flow_imp.g_varchar2_table(701) := '50617468203D205B0A202020205B20274D272C2078202B2068616C6657696474682C2079205D2C0A202020205B20276C272C2068616C6657696474682C2068616C66486569676874205D2C0A202020205B20276C272C202D68616C6657696474682C2068';
wwv_flow_imp.g_varchar2_table(702) := '616C66486569676874205D2C0A202020205B20276C272C202D68616C6657696474682C202D68616C66486569676874205D2C0A202020205B20277A27205D0A20205D3B0A0A202072657475726E2028302C6469616772616D5F6A735F6C69625F7574696C';
wwv_flow_imp.g_varchar2_table(703) := '5F52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E636F6D706F6E656E7473546F5061746829286469616D6F6E6450617468293B0A7D0A0A2F2A2A0A202A2040706172616D207B53686170654C696B65';
wwv_flow_imp.g_varchar2_table(704) := '7D2073686170650A202A0A202A204072657475726E207B737472696E677D20706174680A202A2F0A66756E6374696F6E20676574526563745061746828736861706529207B0A20207661722078203D2073686170652E782C0A20202020202079203D2073';
wwv_flow_imp.g_varchar2_table(705) := '686170652E792C0A2020202020207769647468203D2073686170652E77696474682C0A202020202020686569676874203D2073686170652E6865696768743B0A0A2020766172207265637450617468203D205B0A202020205B20274D272C20782C207920';
wwv_flow_imp.g_varchar2_table(706) := '5D2C0A202020205B20276C272C2077696474682C2030205D2C0A202020205B20276C272C20302C20686569676874205D2C0A202020205B20276C272C202D77696474682C2030205D2C0A202020205B20277A27205D0A20205D3B0A0A202072657475726E';
wwv_flow_imp.g_varchar2_table(707) := '2028302C6469616772616D5F6A735F6C69625F7574696C5F52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E636F6D706F6E656E7473546F5061746829287265637450617468293B0A7D0A0A2F2A2A0A';
wwv_flow_imp.g_varchar2_table(708) := '202A2047657420776964746820616E64206865696768742066726F6D20656C656D656E74206F72206F76657272696465732E0A202A0A202A2040706172616D207B44696D656E73696F6E737C526563747C53686170654C696B657D20626F756E64730A20';
wwv_flow_imp.g_varchar2_table(709) := '2A2040706172616D207B4F626A6563747D206F76657272696465730A202A0A202A204072657475726E73207B44696D656E73696F6E737D0A202A2F0A66756E6374696F6E20676574426F756E647328626F756E64732C206F7665727269646573203D207B';
wwv_flow_imp.g_varchar2_table(710) := '7D29207B0A202072657475726E207B0A2020202077696474683A20676574576964746828626F756E64732C206F7665727269646573292C0A202020206865696768743A2067657448656967687428626F756E64732C206F7665727269646573290A20207D';
wwv_flow_imp.g_varchar2_table(711) := '3B0A7D0A0A2F2A2A0A202A204765742077696474682066726F6D20656C656D656E74206F72206F76657272696465732E0A202A0A202A2040706172616D207B44696D656E73696F6E737C526563747C53686170654C696B657D20626F756E64730A202A20';
wwv_flow_imp.g_varchar2_table(712) := '40706172616D207B4F626A6563747D206F76657272696465730A202A0A202A204072657475726E73207B6E756D6265727D0A202A2F0A66756E6374696F6E20676574576964746828626F756E64732C206F7665727269646573203D207B7D29207B0A2020';
wwv_flow_imp.g_varchar2_table(713) := '72657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E68617329286F76657272696465732C202777696474682729203F206F76657272696465732E7769647468203A20626F756E64732E';
wwv_flow_imp.g_varchar2_table(714) := '77696474683B0A7D0A0A2F2A2A0A202A20476574206865696768742066726F6D20656C656D656E74206F72206F76657272696465732E0A202A0A202A2040706172616D207B44696D656E73696F6E737C526563747C53686170654C696B657D20626F756E';
wwv_flow_imp.g_varchar2_table(715) := '64730A202A2040706172616D207B4F626A6563747D206F76657272696465730A202A0A202A204072657475726E73207B6E756D6265727D0A202A2F0A66756E6374696F6E2067657448656967687428626F756E64732C206F7665727269646573203D207B';
wwv_flow_imp.g_varchar2_table(716) := '7D29207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E68617329286F76657272696465732C20276865696768742729203F206F76657272696465732E68656967687420';
wwv_flow_imp.g_varchar2_table(717) := '3A20626F756E64732E6865696768743B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F42706D6E52656E64657265722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(718) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F42706D6E52656E64657265';
wwv_flow_imp.g_varchar2_table(719) := '722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C';
wwv_flow_imp.g_varchar2_table(720) := '652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861';
wwv_flow_imp.g_varchar2_table(721) := '726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E';
wwv_flow_imp.g_varchar2_table(722) := '20282F2A2062696E64696E67202A2F2042706D6E52656E6465726572290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076617220696E6865726974735F62726F777365725F5F5745';
wwv_flow_imp.g_varchar2_table(723) := '425041434B5F494D504F525445445F4D4F44554C455F31315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A2120696E6865726974732D62726F77736572202A2F20222E2F6E6F64655F6D6F64756C65732F696E6865726974732D6272';
wwv_flow_imp.g_varchar2_table(724) := '6F777365722F646973742F696E6465782E65732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F203D205F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(725) := '5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469';
wwv_flow_imp.g_varchar2_table(726) := '616772616D5F6A735F6C69625F647261775F4261736552656E64657265725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C6962';
wwv_flow_imp.g_varchar2_table(727) := '2F647261772F4261736552656E6465726572202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F4261736552656E64657265722E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661';
wwv_flow_imp.g_varchar2_table(728) := '72205F7574696C5F44695574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F31305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F44695574696C202A2F20222E2F6E6F64655F6D6F64';
wwv_flow_imp.g_varchar2_table(729) := '756C65732F62706D6E2D6A732F6C69622F7574696C2F44695574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4C6162656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C45';
wwv_flow_imp.g_varchar2_table(730) := '5F395F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F4C6162656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4C6162656C5574696C2E6A7322293B';
wwv_flow_imp.g_varchar2_table(731) := '0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F42';
wwv_flow_imp.g_varchar2_table(732) := '706D6E52656E6465725574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A';
wwv_flow_imp.g_varchar2_table(733) := '735F6C69625F7574696C5F52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F365F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F7574696C2F52656E';
wwv_flow_imp.g_varchar2_table(734) := '6465725574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F52656E6465725574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F42706D6E52656E646572';
wwv_flow_imp.g_varchar2_table(735) := '5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F42706D6E52656E6465725574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E';
wwv_flow_imp.g_varchar2_table(736) := '2D6A732F6C69622F647261772F42706D6E52656E6465725574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F';
wwv_flow_imp.g_varchar2_table(737) := '7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076';
wwv_flow_imp.g_varchar2_table(738) := '61722074696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D';
wwv_flow_imp.g_varchar2_table(739) := '7376672F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F7574696C5F5376675472616E73666F726D5574696C5F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(740) := '525445445F4D4F44554C455F375F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F7574696C2F5376675472616E73666F726D5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469';
wwv_flow_imp.g_varchar2_table(741) := '616772616D2D6A732F6C69622F7574696C2F5376675472616E73666F726D5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206964735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D';
wwv_flow_imp.g_varchar2_table(742) := '205F5F7765627061636B5F726571756972655F5F282F2A2120696473202A2F20222E2F6E6F64655F6D6F64756C65732F6964732F646973742F696E6465782E65736D2E6A7322293B0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A76';
wwv_flow_imp.g_varchar2_table(743) := '6172206D61726B6572496473203D206E6577206964735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D28293B0A0A76617220454C454D454E545F4C4142454C5F44495354414E4345203D2031302C0A';
wwv_flow_imp.g_varchar2_table(744) := '20202020494E4E45525F4F555445525F44495354203D20332C0A202020205041525449434950414E545F5354524F4B455F5749445448203D20312E352C0A202020205441534B5F424F524445525F524144495553203D2031303B0A0A7661722044454641';
wwv_flow_imp.g_varchar2_table(745) := '554C545F4F504143495459203D20302E39352C0A2020202046554C4C5F4F504143495459203D20312C0A202020204C4F575F4F504143495459203D20302E32353B0A0A2F2A2A0A202A204074797065646566207B205061727469616C3C7B0A202A202020';
wwv_flow_imp.g_varchar2_table(746) := '64656661756C7446696C6C436F6C6F723A20737472696E672C0A202A20202064656661756C745374726F6B65436F6C6F723A20737472696E672C0A202A20202064656661756C744C6162656C436F6C6F723A20737472696E670A202A207D3E207D204270';
wwv_flow_imp.g_varchar2_table(747) := '6D6E52656E6465726572436F6E6669670A202A0A202A204074797065646566207B205061727469616C3C7B0A202A20202066696C6C3A20737472696E672C0A202A2020207374726F6B653A20737472696E672C0A202A20202077696474683A2073747269';
wwv_flow_imp.g_varchar2_table(748) := '6E672C0A202A2020206865696768743A20737472696E670A202A207D3E207D2041747472730A202A2F0A0A2F2A2A0A202A204074797065646566207B20696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E74207D20456C656D';
wwv_flow_imp.g_varchar2_table(749) := '656E740A202A2F0A0A2F2A2A0A202A20412072656E646572657220666F722042504D4E20656C656D656E74730A202A0A202A2040706172616D207B42706D6E52656E6465726572436F6E6669677D20636F6E6669670A202A2040706172616D207B696D70';
wwv_flow_imp.g_varchar2_table(750) := '6F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C747D206576656E744275730A202A2040706172616D207B696D706F727428276469616772616D2D6A732F6C69622F647261772F5374796C657327';
wwv_flow_imp.g_varchar2_table(751) := '292E64656661756C747D207374796C65730A202A2040706172616D207B696D706F727428272E2F506174684D617027292E64656661756C747D20706174684D61700A202A2040706172616D207B696D706F727428276469616772616D2D6A732F6C69622F';
wwv_flow_imp.g_varchar2_table(752) := '636F72652F43616E76617327292E64656661756C747D2063616E7661730A202A2040706172616D207B696D706F727428272E2F5465787452656E646572657227292E64656661756C747D207465787452656E64657265720A202A2040706172616D207B6E';
wwv_flow_imp.g_varchar2_table(753) := '756D6265727D205B7072696F726974795D0A202A2F0A66756E6374696F6E2042706D6E52656E6465726572280A20202020636F6E6669672C206576656E744275732C207374796C65732C20706174684D61702C0A2020202063616E7661732C2074657874';
wwv_flow_imp.g_varchar2_table(754) := '52656E64657265722C207072696F7269747929207B0A0A20206469616772616D5F6A735F6C69625F647261775F4261736552656E64657265725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D2E6361';
wwv_flow_imp.g_varchar2_table(755) := '6C6C28746869732C206576656E744275732C207072696F72697479293B0A0A20207661722064656661756C7446696C6C436F6C6F72203D20636F6E66696720262620636F6E6669672E64656661756C7446696C6C436F6C6F722C0A202020202020646566';
wwv_flow_imp.g_varchar2_table(756) := '61756C745374726F6B65436F6C6F72203D20636F6E66696720262620636F6E6669672E64656661756C745374726F6B65436F6C6F722C0A20202020202064656661756C744C6162656C436F6C6F72203D20636F6E66696720262620636F6E6669672E6465';
wwv_flow_imp.g_varchar2_table(757) := '6661756C744C6162656C436F6C6F723B0A0A202066756E6374696F6E2073686170655374796C6528617474727329207B0A2020202072657475726E207374796C65732E636F6D707574655374796C652861747472732C207B0A2020202020207374726F6B';
wwv_flow_imp.g_varchar2_table(758) := '654C696E656361703A2027726F756E64272C0A2020202020207374726F6B654C696E656A6F696E3A2027726F756E64272C0A2020202020207374726F6B653A205F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(759) := '44554C455F325F5F2E626C61636B2C0A2020202020207374726F6B6557696474683A20322C0A20202020202066696C6C3A20277768697465270A202020207D293B0A20207D0A0A202066756E6374696F6E206C696E655374796C6528617474727329207B';
wwv_flow_imp.g_varchar2_table(760) := '0A2020202072657475726E207374796C65732E636F6D707574655374796C652861747472732C205B20276E6F2D66696C6C27205D2C207B0A2020202020207374726F6B654C696E656361703A2027726F756E64272C0A2020202020207374726F6B654C69';
wwv_flow_imp.g_varchar2_table(761) := '6E656A6F696E3A2027726F756E64272C0A2020202020207374726F6B653A205F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E626C61636B2C0A2020202020207374726F6B655769647468';
wwv_flow_imp.g_varchar2_table(762) := '3A20320A202020207D293B0A20207D0A0A202066756E6374696F6E206164644D61726B65722869642C206F7074696F6E7329207B0A20202020766172207B0A202020202020726566203D207B20783A20302C20793A2030207D2C0A202020202020736361';
wwv_flow_imp.g_varchar2_table(763) := '6C65203D20312C0A202020202020656C656D656E742C0A202020202020706172656E74476678203D2063616E7661732E5F7376670A202020207D203D206F7074696F6E733B0A0A20202020766172206D61726B6572203D2028302C74696E795F7376675F';
wwv_flow_imp.g_varchar2_table(764) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6372656174652928276D61726B6572272C207B0A20202020202069643A2069642C0A20202020202076696577426F783A2027302030203230203230272C0A202020202020726566';
wwv_flow_imp.g_varchar2_table(765) := '583A207265662E782C0A202020202020726566593A207265662E792C0A2020202020206D61726B657257696474683A203230202A207363616C652C0A2020202020206D61726B65724865696768743A203230202A207363616C652C0A2020202020206F72';
wwv_flow_imp.g_varchar2_table(766) := '69656E743A20276175746F270A202020207D293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E617070656E6429286D61726B65722C20656C656D656E74293B0A0A202020207661';
wwv_flow_imp.g_varchar2_table(767) := '722064656673203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E71756572792928273A73636F7065203E2064656673272C20706172656E74476678293B0A0A2020202069662028216465667329';
wwv_flow_imp.g_varchar2_table(768) := '207B0A20202020202064656673203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6372656174652928276465667327293B0A0A20202020202028302C74696E795F7376675F5F574542504143';
wwv_flow_imp.g_varchar2_table(769) := '4B5F494D504F525445445F4D4F44554C455F335F5F2E617070656E642928706172656E744766782C2064656673293B0A202020207D0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E';
wwv_flow_imp.g_varchar2_table(770) := '617070656E642928646566732C206D61726B6572293B0A20207D0A0A202066756E6374696F6E206D61726B657228706172656E744766782C20747970652C2066696C6C2C207374726F6B6529207B0A0A0A20202020766172206964203D206D61726B6572';
wwv_flow_imp.g_varchar2_table(771) := '4964732E6E657874507265666978656428276D61726B65722D27293B0A0A202020206372656174654D61726B657228706172656E744766782C2069642C20747970652C2066696C6C2C207374726F6B65293B0A0A2020202072657475726E202775726C28';
wwv_flow_imp.g_varchar2_table(772) := '2327202B206964202B202729273B0A20207D0A0A202066756E6374696F6E206372656174654D61726B657228706172656E744766782C2069642C20747970652C2066696C6C2C207374726F6B6529207B0A0A202020206966202874797065203D3D3D2027';
wwv_flow_imp.g_varchar2_table(773) := '73657175656E6365666C6F772D656E642729207B0A2020202020207661722073657175656E6365666C6F77456E64203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E63726561746529282770';
wwv_flow_imp.g_varchar2_table(774) := '617468272C207B0A2020202020202020643A20274D20312035204C203131203130204C2031203135205A272C0A20202020202020202E2E2E73686170655374796C65287B0A2020202020202020202066696C6C3A207374726F6B652C0A20202020202020';
wwv_flow_imp.g_varchar2_table(775) := '2020207374726F6B653A207374726F6B652C0A202020202020202020207374726F6B6557696474683A20310A20202020202020207D290A2020202020207D293B0A0A2020202020206164644D61726B65722869642C207B0A2020202020202020656C656D';
wwv_flow_imp.g_varchar2_table(776) := '656E743A2073657175656E6365666C6F77456E642C0A20202020202020207265663A207B20783A2031312C20793A203130207D2C0A20202020202020207363616C653A20302E352C0A2020202020202020706172656E744766780A2020202020207D293B';
wwv_flow_imp.g_varchar2_table(777) := '0A202020207D0A0A202020206966202874797065203D3D3D20276D657373616765666C6F772D73746172742729207B0A202020202020766172206D657373616765666C6F775374617274203D2028302C74696E795F7376675F5F5745425041434B5F494D';
wwv_flow_imp.g_varchar2_table(778) := '504F525445445F4D4F44554C455F335F5F2E637265617465292827636972636C65272C207B0A202020202020202063783A20362C0A202020202020202063793A20362C0A2020202020202020723A20332E352C0A20202020202020202E2E2E7368617065';
wwv_flow_imp.g_varchar2_table(779) := '5374796C65287B0A2020202020202020202066696C6C2C0A202020202020202020207374726F6B653A207374726F6B652C0A202020202020202020207374726F6B6557696474683A20312C0A0A202020202020202020202F2F2066697820666F72207361';
wwv_flow_imp.g_varchar2_table(780) := '66617269202F206368726F6D65202F2066697265666F7820627567206E6F7420636F72726563746C790A202020202020202020202F2F20726573657474696E67207374726F6B6520646173682061727261790A202020202020202020207374726F6B6544';
wwv_flow_imp.g_varchar2_table(781) := '61736861727261793A205B2031303030302C2031205D0A20202020202020207D290A2020202020207D293B0A0A2020202020206164644D61726B65722869642C207B0A2020202020202020656C656D656E743A206D657373616765666C6F775374617274';
wwv_flow_imp.g_varchar2_table(782) := '2C0A20202020202020207265663A207B20783A20362C20793A2036207D2C0A2020202020202020706172656E744766780A2020202020207D293B0A202020207D0A0A202020206966202874797065203D3D3D20276D657373616765666C6F772D656E6427';
wwv_flow_imp.g_varchar2_table(783) := '29207B0A202020202020766172206D657373616765666C6F77456E64203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E63726561746529282770617468272C207B0A2020202020202020643A';
wwv_flow_imp.g_varchar2_table(784) := '20276D20312035206C2030202D33206C20372033206C202D372033207A272C0A20202020202020202E2E2E73686170655374796C65287B0A2020202020202020202066696C6C2C0A202020202020202020207374726F6B653A207374726F6B652C0A2020';
wwv_flow_imp.g_varchar2_table(785) := '20202020202020207374726F6B6557696474683A20312C0A0A202020202020202020202F2F2066697820666F7220736166617269202F206368726F6D65202F2066697265666F7820627567206E6F7420636F72726563746C790A20202020202020202020';
wwv_flow_imp.g_varchar2_table(786) := '2F2F20726573657474696E67207374726F6B6520646173682061727261790A202020202020202020207374726F6B654461736861727261793A205B2031303030302C2031205D0A20202020202020207D290A2020202020207D293B0A0A20202020202061';
wwv_flow_imp.g_varchar2_table(787) := '64644D61726B65722869642C207B0A2020202020202020656C656D656E743A206D657373616765666C6F77456E642C0A20202020202020207265663A207B20783A20382E352C20793A2035207D2C0A2020202020202020706172656E744766780A202020';
wwv_flow_imp.g_varchar2_table(788) := '2020207D293B0A202020207D0A0A202020206966202874797065203D3D3D20276173736F63696174696F6E2D73746172742729207B0A202020202020766172206173736F63696174696F6E5374617274203D2028302C74696E795F7376675F5F57454250';
wwv_flow_imp.g_varchar2_table(789) := '41434B5F494D504F525445445F4D4F44554C455F335F5F2E63726561746529282770617468272C207B0A2020202020202020643A20274D2031312035204C2031203130204C203131203135272C0A20202020202020202E2E2E6C696E655374796C65287B';
wwv_flow_imp.g_varchar2_table(790) := '0A2020202020202020202066696C6C3A20276E6F6E65272C0A202020202020202020207374726F6B652C0A202020202020202020207374726F6B6557696474683A20312E352C0A0A202020202020202020202F2F2066697820666F722073616661726920';
wwv_flow_imp.g_varchar2_table(791) := '2F206368726F6D65202F2066697265666F7820627567206E6F7420636F72726563746C790A202020202020202020202F2F20726573657474696E67207374726F6B6520646173682061727261790A202020202020202020207374726F6B65446173686172';
wwv_flow_imp.g_varchar2_table(792) := '7261793A205B2031303030302C2031205D0A20202020202020207D290A2020202020207D293B0A0A2020202020206164644D61726B65722869642C207B0A2020202020202020656C656D656E743A206173736F63696174696F6E53746172742C0A202020';
wwv_flow_imp.g_varchar2_table(793) := '20202020207265663A207B20783A20312C20793A203130207D2C0A20202020202020207363616C653A20302E352C0A2020202020202020706172656E744766780A2020202020207D293B0A202020207D0A0A202020206966202874797065203D3D3D2027';
wwv_flow_imp.g_varchar2_table(794) := '6173736F63696174696F6E2D656E642729207B0A202020202020766172206173736F63696174696F6E456E64203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E637265617465292827706174';
wwv_flow_imp.g_varchar2_table(795) := '68272C207B0A2020202020202020643A20274D20312035204C203131203130204C2031203135272C0A20202020202020202E2E2E6C696E655374796C65287B0A2020202020202020202066696C6C3A20276E6F6E65272C0A202020202020202020207374';
wwv_flow_imp.g_varchar2_table(796) := '726F6B652C0A202020202020202020207374726F6B6557696474683A20312E352C0A0A202020202020202020202F2F2066697820666F7220736166617269202F206368726F6D65202F2066697265666F7820627567206E6F7420636F72726563746C790A';
wwv_flow_imp.g_varchar2_table(797) := '202020202020202020202F2F20726573657474696E67207374726F6B6520646173682061727261790A202020202020202020207374726F6B654461736861727261793A205B2031303030302C2031205D0A20202020202020207D290A2020202020207D29';
wwv_flow_imp.g_varchar2_table(798) := '3B0A0A2020202020206164644D61726B65722869642C207B0A2020202020202020656C656D656E743A206173736F63696174696F6E456E642C0A20202020202020207265663A207B20783A2031312C20793A203130207D2C0A2020202020202020736361';
wwv_flow_imp.g_varchar2_table(799) := '6C653A20302E352C0A2020202020202020706172656E744766780A2020202020207D293B0A202020207D0A0A202020206966202874797065203D3D3D2027636F6E646974696F6E616C2D666C6F772D6D61726B65722729207B0A20202020202076617220';
wwv_flow_imp.g_varchar2_table(800) := '636F6E646974696F6E616C466C6F774D61726B6572203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E63726561746529282770617468272C207B0A2020202020202020643A20274D20302031';
wwv_flow_imp.g_varchar2_table(801) := '30204C20382036204C203136203130204C2038203134205A272C0A20202020202020202E2E2E73686170655374796C65287B0A2020202020202020202066696C6C2C0A202020202020202020207374726F6B653A207374726F6B650A2020202020202020';
wwv_flow_imp.g_varchar2_table(802) := '7D290A2020202020207D293B0A0A2020202020206164644D61726B65722869642C207B0A2020202020202020656C656D656E743A20636F6E646974696F6E616C466C6F774D61726B65722C0A20202020202020207265663A207B20783A202D312C20793A';
wwv_flow_imp.g_varchar2_table(803) := '203130207D2C0A20202020202020207363616C653A20302E352C0A2020202020202020706172656E744766780A2020202020207D293B0A202020207D0A0A202020206966202874797065203D3D3D2027636F6E646974696F6E616C2D64656661756C742D';
wwv_flow_imp.g_varchar2_table(804) := '666C6F772D6D61726B65722729207B0A2020202020207661722064656661756C74466C6F774D61726B6572203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E63726561746529282770617468';
wwv_flow_imp.g_varchar2_table(805) := '272C207B0A2020202020202020643A20274D20362034204C203130203136272C0A20202020202020202E2E2E73686170655374796C65287B0A202020202020202020207374726F6B653A207374726F6B652C0A2020202020202020202066696C6C3A2027';
wwv_flow_imp.g_varchar2_table(806) := '6E6F6E65270A20202020202020207D290A2020202020207D293B0A0A2020202020206164644D61726B65722869642C207B0A2020202020202020656C656D656E743A2064656661756C74466C6F774D61726B65722C0A20202020202020207265663A207B';
wwv_flow_imp.g_varchar2_table(807) := '20783A20302C20793A203130207D2C0A20202020202020207363616C653A20302E352C0A2020202020202020706172656E744766780A2020202020207D293B0A202020207D0A20207D0A0A202066756E6374696F6E2064726177436972636C6528706172';
wwv_flow_imp.g_varchar2_table(808) := '656E744766782C2077696474682C206865696768742C206F66667365742C206174747273203D207B7D29207B0A0A202020206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E69734F626A';
wwv_flow_imp.g_varchar2_table(809) := '65637429286F66667365742929207B0A2020202020206174747273203D206F66667365743B0A2020202020206F6666736574203D20303B0A202020207D0A0A202020206F6666736574203D206F6666736574207C7C20303B0A0A20202020617474727320';
wwv_flow_imp.g_varchar2_table(810) := '3D2073686170655374796C65286174747273293B0A0A20202020766172206378203D207769647468202F20322C0A20202020202020206379203D20686569676874202F20323B0A0A2020202076617220636972636C65203D2028302C74696E795F737667';
wwv_flow_imp.g_varchar2_table(811) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E637265617465292827636972636C65272C207B0A20202020202063783A2063782C0A20202020202063793A2063792C0A202020202020723A204D6174682E726F756E64282877';
wwv_flow_imp.g_varchar2_table(812) := '69647468202B2068656967687429202F2034202D206F6666736574292C0A2020202020202E2E2E61747472730A202020207D293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E61';
wwv_flow_imp.g_varchar2_table(813) := '7070656E642928706172656E744766782C20636972636C65293B0A0A2020202072657475726E20636972636C653B0A20207D0A0A202066756E6374696F6E20647261775265637428706172656E744766782C2077696474682C206865696768742C20722C';
wwv_flow_imp.g_varchar2_table(814) := '206F66667365742C20617474727329207B0A0A202020206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E69734F626A65637429286F66667365742929207B0A2020202020206174747273';
wwv_flow_imp.g_varchar2_table(815) := '203D206F66667365743B0A2020202020206F6666736574203D20303B0A202020207D0A0A202020206F6666736574203D206F6666736574207C7C20303B0A0A202020206174747273203D2073686170655374796C65286174747273293B0A0A2020202076';
wwv_flow_imp.g_varchar2_table(816) := '61722072656374203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E63726561746529282772656374272C207B0A202020202020783A206F66667365742C0A202020202020793A206F66667365';
wwv_flow_imp.g_varchar2_table(817) := '742C0A20202020202077696474683A207769647468202D206F6666736574202A20322C0A2020202020206865696768743A20686569676874202D206F6666736574202A20322C0A20202020202072783A20722C0A20202020202072793A20722C0A202020';
wwv_flow_imp.g_varchar2_table(818) := '2020202E2E2E61747472730A202020207D293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E617070656E642928706172656E744766782C2072656374293B0A0A20202020726574';
wwv_flow_imp.g_varchar2_table(819) := '75726E20726563743B0A20207D0A0A202066756E6374696F6E20647261774469616D6F6E6428706172656E744766782C2077696474682C206865696768742C20617474727329207B0A0A2020202076617220785F32203D207769647468202F20323B0A20';
wwv_flow_imp.g_varchar2_table(820) := '20202076617220795F32203D20686569676874202F20323B0A0A2020202076617220706F696E7473203D205B0A2020202020207B20783A20785F322C20793A2030207D2C0A2020202020207B20783A2077696474682C20793A20795F32207D2C0A202020';
wwv_flow_imp.g_varchar2_table(821) := '2020207B20783A20785F322C20793A20686569676874207D2C0A2020202020207B20783A20302C20793A20795F32207D0A202020205D3B0A0A2020202076617220706F696E7473537472696E67203D20706F696E74732E6D61702866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(822) := '706F696E7429207B0A20202020202072657475726E20706F696E742E78202B20272C27202B20706F696E742E793B0A202020207D292E6A6F696E28272027293B0A0A202020206174747273203D2073686170655374796C65286174747273293B0A0A2020';
wwv_flow_imp.g_varchar2_table(823) := '202076617220706F6C79676F6E203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E637265617465292827706F6C79676F6E272C207B0A2020202020202E2E2E61747472732C0A202020202020';
wwv_flow_imp.g_varchar2_table(824) := '706F696E74733A20706F696E7473537472696E670A202020207D293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E617070656E642928706172656E744766782C20706F6C79676F';
wwv_flow_imp.g_varchar2_table(825) := '6E293B0A0A2020202072657475726E20706F6C79676F6E3B0A20207D0A0A20202F2A2A0A2020202A2040706172616D207B535647456C656D656E747D20706172656E744766780A2020202A2040706172616D207B506F696E745B5D7D20776179706F696E';
wwv_flow_imp.g_varchar2_table(826) := '74730A2020202A2040706172616D207B616E797D2061747472730A2020202A2040706172616D207B6E756D6265727D205B7261646975735D0A2020202A0A2020202A204072657475726E207B535647456C656D656E747D0A2020202A2F0A202066756E63';
wwv_flow_imp.g_varchar2_table(827) := '74696F6E20647261774C696E6528706172656E744766782C20776179706F696E74732C2061747472732C2072616469757329207B0A202020206174747273203D206C696E655374796C65286174747273293B0A0A20202020766172206C696E65203D2028';
wwv_flow_imp.g_varchar2_table(828) := '302C6469616772616D5F6A735F6C69625F7574696C5F52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F365F5F2E6372656174654C696E652928776179706F696E74732C2061747472732C20726164697573293B';
wwv_flow_imp.g_varchar2_table(829) := '0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E617070656E642928706172656E744766782C206C696E65293B0A0A2020202072657475726E206C696E653B0A20207D0A0A20202F2A';
wwv_flow_imp.g_varchar2_table(830) := '2A0A2020202A2040706172616D207B535647456C656D656E747D20706172656E744766780A2020202A2040706172616D207B506F696E745B5D7D20776179706F696E74730A2020202A2040706172616D207B616E797D2061747472730A2020202A0A2020';
wwv_flow_imp.g_varchar2_table(831) := '202A204072657475726E207B535647456C656D656E747D0A2020202A2F0A202066756E6374696F6E2064726177436F6E6E656374696F6E5365676D656E747328706172656E744766782C20776179706F696E74732C20617474727329207B0A2020202072';
wwv_flow_imp.g_varchar2_table(832) := '657475726E20647261774C696E6528706172656E744766782C20776179706F696E74732C2061747472732C2035293B0A20207D0A0A202066756E6374696F6E20647261775061746828706172656E744766782C20642C20617474727329207B0A20202020';
wwv_flow_imp.g_varchar2_table(833) := '6174747273203D206C696E655374796C65286174747273293B0A0A202020207661722070617468203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E63726561746529282770617468272C207B';
wwv_flow_imp.g_varchar2_table(834) := '0A2020202020202E2E2E61747472732C0A202020202020640A202020207D293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E617070656E642928706172656E744766782C207061';
wwv_flow_imp.g_varchar2_table(835) := '7468293B0A0A2020202072657475726E20706174683B0A20207D0A0A202066756E6374696F6E20647261774D61726B657228747970652C20706172656E744766782C20706174682C20617474727329207B0A2020202072657475726E2064726177506174';
wwv_flow_imp.g_varchar2_table(836) := '6828706172656E744766782C20706174682C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E61737369676E29287B2027646174612D6D61726B6572273A2074797065207D2C2061747472732929';
wwv_flow_imp.g_varchar2_table(837) := '3B0A20207D0A0A202066756E6374696F6E2072656E6465726572287479706529207B0A2020202072657475726E2068616E646C6572735B747970655D3B0A20207D0A0A202066756E6374696F6E206173287479706529207B0A2020202072657475726E20';
wwv_flow_imp.g_varchar2_table(838) := '66756E6374696F6E28706172656E744766782C20656C656D656E742C20617474727329207B0A20202020202072657475726E2072656E646572657228747970652928706172656E744766782C20656C656D656E742C206174747273293B0A202020207D3B';
wwv_flow_imp.g_varchar2_table(839) := '0A20207D0A0A2020766172206576656E7449636F6E52656E646572657273203D207B0A202020202762706D6E3A4D6573736167654576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C2061';
wwv_flow_imp.g_varchar2_table(840) := '74747273203D207B7D2C2069735468726F77696E6729207B0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F4D455353414745272C207B0A2020202020202020785363616C';
wwv_flow_imp.g_varchar2_table(841) := '65466163746F723A20302E392C0A2020202020202020795363616C65466163746F723A20302E392C0A2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C0A2020202020202020636F6E7461696E6572486569';
wwv_flow_imp.g_varchar2_table(842) := '6768743A20656C656D656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E3233352C0A202020202020202020206D793A20302E3331350A20202020202020207D0A2020202020207D29';
wwv_flow_imp.g_varchar2_table(843) := '3B0A0A2020202020207661722066696C6C203D2069735468726F77696E670A20202020202020203F2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F';
wwv_flow_imp.g_varchar2_table(844) := '6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A20202020202020203A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(845) := '455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B0A0A202020202020766172207374726F6B65203D2069735468726F77696E670A20202020202020203F';
wwv_flow_imp.g_varchar2_table(846) := '2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C';
wwv_flow_imp.g_varchar2_table(847) := '290A20202020202020203A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F';
wwv_flow_imp.g_varchar2_table(848) := '6C6F722C2061747472732E7374726F6B65293B0A0A202020202020766172206D65737361676550617468203D20647261775061746828706172656E744766782C2070617468446174612C207B0A202020202020202066696C6C2C0A202020202020202073';
wwv_flow_imp.g_varchar2_table(849) := '74726F6B652C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A0A20202020202072657475726E206D657373616765506174683B0A202020207D2C0A202020202762706D6E3A54696D65724576656E74446566696E69';
wwv_flow_imp.g_varchar2_table(850) := '74696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A20202020202076617220636972636C65203D2064726177436972636C6528706172656E744766782C20656C656D656E742E77';
wwv_flow_imp.g_varchar2_table(851) := '696474682C20656C656D656E742E6865696768742C20302E32202A20656C656D656E742E6865696768742C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44';
wwv_flow_imp.g_varchar2_table(852) := '554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745';
wwv_flow_imp.g_varchar2_table(853) := '425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B65';
wwv_flow_imp.g_varchar2_table(854) := '57696474683A20320A2020202020207D293B0A0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F54494D45525F5748272C207B0A2020202020202020785363616C65466163';
wwv_flow_imp.g_varchar2_table(855) := '746F723A20302E37352C0A2020202020202020795363616C65466163746F723A20302E37352C0A2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C0A2020202020202020636F6E7461696E65724865696768';
wwv_flow_imp.g_varchar2_table(856) := '743A20656C656D656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E352C0A202020202020202020206D793A20302E350A20202020202020207D0A2020202020207D293B0A0A202020';
wwv_flow_imp.g_varchar2_table(857) := '202020647261775061746828706172656E744766782C2070617468446174612C207B0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67';
wwv_flow_imp.g_varchar2_table(858) := '65745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20320A2020202020207D293B0A0A20202020202066';
wwv_flow_imp.g_varchar2_table(859) := '6F7220287661722069203D20303B2069203C2031323B20692B2B29207B0A2020202020202020766172206C696E655061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F54494D45525F4C494E45272C207B';
wwv_flow_imp.g_varchar2_table(860) := '0A20202020202020202020785363616C65466163746F723A20302E37352C0A20202020202020202020795363616C65466163746F723A20302E37352C0A20202020202020202020636F6E7461696E657257696474683A20656C656D656E742E7769647468';
wwv_flow_imp.g_varchar2_table(861) := '2C0A20202020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C0A20202020202020202020706F736974696F6E3A207B0A2020202020202020202020206D783A20302E352C0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(862) := '6D793A20302E350A202020202020202020207D0A20202020202020207D293B0A0A2020202020202020766172207769647468203D20656C656D656E742E7769647468202F20322C0A202020202020202020202020686569676874203D20656C656D656E74';
wwv_flow_imp.g_varchar2_table(863) := '2E686569676874202F20323B0A0A2020202020202020647261775061746828706172656E744766782C206C696E6550617468446174612C207B0A202020202020202020207374726F6B6557696474683A20312C0A202020202020202020207374726F6B65';
wwv_flow_imp.g_varchar2_table(864) := '3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C206174747273';
wwv_flow_imp.g_varchar2_table(865) := '2E7374726F6B65292C0A202020202020202020207472616E73666F726D3A2027726F746174652827202B202869202A20333029202B20272C27202B20686569676874202B20272C27202B207769647468202B202729270A20202020202020207D293B0A20';
wwv_flow_imp.g_varchar2_table(866) := '20202020207D0A0A20202020202072657475726E20636972636C653B0A202020207D2C0A202020202762706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C';
wwv_flow_imp.g_varchar2_table(867) := '206174747273203D207B7D2C2069735468726F77696E6729207B0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F455343414C4154494F4E272C207B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(868) := '785363616C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C0A2020202020202020636F6E7461696E657248656967';
wwv_flow_imp.g_varchar2_table(869) := '68743A206576656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E352C0A202020202020202020206D793A20302E320A20202020202020207D0A2020202020207D293B0A0A20202020';
wwv_flow_imp.g_varchar2_table(870) := '20207661722066696C6C203D2069735468726F77696E670A20202020202020203F2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F7229286576';
wwv_flow_imp.g_varchar2_table(871) := '656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A20202020202020203A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574';
wwv_flow_imp.g_varchar2_table(872) := '46696C6C436F6C6F7229286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B0A0A20202020202072657475726E20647261775061746828706172656E744766782C2070617468446174612C207B0A2020202020';
wwv_flow_imp.g_varchar2_table(873) := '20202066696C6C2C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F7229286576656E742C2064656661';
wwv_flow_imp.g_varchar2_table(874) := '756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A202020207D2C0A202020202762706D6E3A436F6E646974696F6E616C4576656E74446566';
wwv_flow_imp.g_varchar2_table(875) := '696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D207B7D29207B0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E54';
wwv_flow_imp.g_varchar2_table(876) := '5F434F4E444954494F4E414C272C207B0A2020202020202020785363616C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A206576656E742E776964';
wwv_flow_imp.g_varchar2_table(877) := '74682C0A2020202020202020636F6E7461696E65724865696768743A206576656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E352C0A202020202020202020206D793A20302E3232';
wwv_flow_imp.g_varchar2_table(878) := '320A20202020202020207D0A2020202020207D293B0A0A20202020202072657475726E20647261775061746828706172656E744766782C2070617468446174612C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C';
wwv_flow_imp.g_varchar2_table(879) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F7229286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A202830';
wwv_flow_imp.g_varchar2_table(880) := '2C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F7229286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B';
wwv_flow_imp.g_varchar2_table(881) := '65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A202020207D2C0A202020202762706D6E3A4C696E6B4576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E';
wwv_flow_imp.g_varchar2_table(882) := '742C206174747273203D207B7D2C2069735468726F77696E6729207B0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F4C494E4B272C207B0A202020202020202078536361';
wwv_flow_imp.g_varchar2_table(883) := '6C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C0A2020202020202020636F6E7461696E65724865696768743A20';
wwv_flow_imp.g_varchar2_table(884) := '6576656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E35372C0A202020202020202020206D793A20302E3236330A20202020202020207D0A2020202020207D293B0A0A2020202020';
wwv_flow_imp.g_varchar2_table(885) := '207661722066696C6C203D2069735468726F77696E670A20202020202020203F2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928657665';
wwv_flow_imp.g_varchar2_table(886) := '6E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A20202020202020203A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446';
wwv_flow_imp.g_varchar2_table(887) := '696C6C436F6C6F7229286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B0A0A20202020202072657475726E20647261775061746828706172656E744766782C2070617468446174612C207B0A202020202020';
wwv_flow_imp.g_varchar2_table(888) := '202066696C6C2C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F7229286576656E742C206465666175';
wwv_flow_imp.g_varchar2_table(889) := '6C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A202020207D2C0A202020202762706D6E3A4572726F724576656E74446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(890) := '273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D207B7D2C2069735468726F77696E6729207B0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C6564506174682827';
wwv_flow_imp.g_varchar2_table(891) := '4556454E545F4552524F52272C207B0A2020202020202020785363616C65466163746F723A20312E312C0A2020202020202020795363616C65466163746F723A20312E312C0A2020202020202020636F6E7461696E657257696474683A206576656E742E';
wwv_flow_imp.g_varchar2_table(892) := '77696474682C0A2020202020202020636F6E7461696E65724865696768743A206576656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E322C0A202020202020202020206D793A2030';
wwv_flow_imp.g_varchar2_table(893) := '2E3732320A20202020202020207D0A2020202020207D293B0A0A2020202020207661722066696C6C203D2069735468726F77696E670A20202020202020203F2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(894) := '5F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F7229286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A20202020202020203A2028302C5F42706D6E52656E6465725574696C5F5F57';
wwv_flow_imp.g_varchar2_table(895) := '45425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F7229286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B0A0A20202020202072657475726E2064726177506174';
wwv_flow_imp.g_varchar2_table(896) := '6828706172656E744766782C2070617468446174612C207B0A202020202020202066696C6C2C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F32';
wwv_flow_imp.g_varchar2_table(897) := '5F5F2E6765745374726F6B65436F6C6F7229286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A202020207D2C';
wwv_flow_imp.g_varchar2_table(898) := '0A202020202762706D6E3A43616E63656C4576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D207B7D2C2069735468726F77696E6729207B0A202020202020766172207061';
wwv_flow_imp.g_varchar2_table(899) := '746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F43414E43454C5F3435272C207B0A2020202020202020785363616C65466163746F723A20312E302C0A2020202020202020795363616C65466163746F723A';
wwv_flow_imp.g_varchar2_table(900) := '20312E302C0A2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C0A2020202020202020636F6E7461696E65724865696768743A206576656E742E6865696768742C0A2020202020202020706F736974696F6E3A20';
wwv_flow_imp.g_varchar2_table(901) := '7B0A202020202020202020206D783A20302E3633382C0A202020202020202020206D793A202D302E3035350A20202020202020207D0A2020202020207D293B0A0A2020202020207661722066696C6C203D2069735468726F77696E67203F2028302C5F42';
wwv_flow_imp.g_varchar2_table(902) := '706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F7229286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B652920';
wwv_flow_imp.g_varchar2_table(903) := '3A20276E6F6E65273B0A0A2020202020207661722070617468203D20647261775061746828706172656E744766782C2070617468446174612C207B0A202020202020202066696C6C2C0A20202020202020207374726F6B653A2028302C5F42706D6E5265';
wwv_flow_imp.g_varchar2_table(904) := '6E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F7229286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020';
wwv_flow_imp.g_varchar2_table(905) := '202020207374726F6B6557696474683A20310A2020202020207D293B0A0A20202020202028302C6469616772616D5F6A735F6C69625F7574696C5F5376675472616E73666F726D5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C45';
wwv_flow_imp.g_varchar2_table(906) := '5F375F5F2E726F746174652928706174682C203435293B0A0A20202020202072657475726E20706174683B0A202020207D2C0A202020202762706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E273A2066756E6374696F6E287061';
wwv_flow_imp.g_varchar2_table(907) := '72656E744766782C206576656E742C206174747273203D207B7D2C2069735468726F77696E6729207B0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F434F4D50454E5341';
wwv_flow_imp.g_varchar2_table(908) := '54494F4E272C207B0A2020202020202020785363616C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C0A20202020';
wwv_flow_imp.g_varchar2_table(909) := '20202020636F6E7461696E65724865696768743A206576656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E32322C0A202020202020202020206D793A20302E350A20202020202020';
wwv_flow_imp.g_varchar2_table(910) := '207D0A2020202020207D293B0A0A2020202020207661722066696C6C203D2069735468726F77696E670A20202020202020203F2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E';
wwv_flow_imp.g_varchar2_table(911) := '6765745374726F6B65436F6C6F7229286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A20202020202020203A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F52';
wwv_flow_imp.g_varchar2_table(912) := '5445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F7229286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B0A0A20202020202072657475726E20647261775061746828706172656E744766782C';
wwv_flow_imp.g_varchar2_table(913) := '2070617468446174612C207B0A202020202020202066696C6C2C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65';
wwv_flow_imp.g_varchar2_table(914) := '436F6C6F7229286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A202020207D2C0A202020202762706D6E3A53';
wwv_flow_imp.g_varchar2_table(915) := '69676E616C4576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D207B7D2C2069735468726F77696E6729207B0A202020202020766172207061746844617461203D20706174';
wwv_flow_imp.g_varchar2_table(916) := '684D61702E6765745363616C65645061746828274556454E545F5349474E414C272C207B0A2020202020202020785363616C65466163746F723A20302E392C0A2020202020202020795363616C65466163746F723A20302E392C0A202020202020202063';
wwv_flow_imp.g_varchar2_table(917) := '6F6E7461696E657257696474683A206576656E742E77696474682C0A2020202020202020636F6E7461696E65724865696768743A206576656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A';
wwv_flow_imp.g_varchar2_table(918) := '20302E352C0A202020202020202020206D793A20302E320A20202020202020207D0A2020202020207D293B0A0A2020202020207661722066696C6C203D2069735468726F77696E670A20202020202020203F2028302C5F42706D6E52656E646572557469';
wwv_flow_imp.g_varchar2_table(919) := '6C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F7229286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A20202020202020203A202830';
wwv_flow_imp.g_varchar2_table(920) := '2C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F7229286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B0A0A20';
wwv_flow_imp.g_varchar2_table(921) := '202020202072657475726E20647261775061746828706172656E744766782C2070617468446174612C207B0A20202020202020207374726F6B6557696474683A20312C0A202020202020202066696C6C2C0A20202020202020207374726F6B653A202830';
wwv_flow_imp.g_varchar2_table(922) := '2C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F7229286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B';
wwv_flow_imp.g_varchar2_table(923) := '65290A2020202020207D293B0A202020207D2C0A202020202762706D6E3A4D756C7469706C654576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D207B7D2C206973546872';
wwv_flow_imp.g_varchar2_table(924) := '6F77696E6729207B0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F4D554C5449504C45272C207B0A2020202020202020785363616C65466163746F723A20312E312C0A20';
wwv_flow_imp.g_varchar2_table(925) := '20202020202020795363616C65466163746F723A20312E312C0A2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C0A2020202020202020636F6E7461696E65724865696768743A206576656E742E686569676874';
wwv_flow_imp.g_varchar2_table(926) := '2C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E3232322C0A202020202020202020206D793A20302E33360A20202020202020207D0A2020202020207D293B0A0A2020202020207661722066696C6C203D20';
wwv_flow_imp.g_varchar2_table(927) := '69735468726F77696E670A20202020202020203F2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F7229286576656E742C2064656661756C7453';
wwv_flow_imp.g_varchar2_table(928) := '74726F6B65436F6C6F722C2061747472732E7374726F6B65290A20202020202020203A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F7229286576';
wwv_flow_imp.g_varchar2_table(929) := '656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B0A0A20202020202072657475726E20647261775061746828706172656E744766782C2070617468446174612C207B0A202020202020202066696C6C2C0A20202020';
wwv_flow_imp.g_varchar2_table(930) := '202020207374726F6B6557696474683A20310A2020202020207D293B0A202020207D2C0A202020202762706D6E3A506172616C6C656C4D756C7469706C654576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C20';
wwv_flow_imp.g_varchar2_table(931) := '6576656E742C206174747273203D207B7D29207B0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F504152414C4C454C5F4D554C5449504C45272C207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(932) := '20785363616C65466163746F723A20312E322C0A2020202020202020795363616C65466163746F723A20312E322C0A2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C0A2020202020202020636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(933) := '724865696768743A206576656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E3435382C0A202020202020202020206D793A20302E3139340A20202020202020207D0A202020202020';
wwv_flow_imp.g_varchar2_table(934) := '7D293B0A0A20202020202072657475726E20647261775061746828706172656E744766782C2070617468446174612C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(935) := '5F4D4F44554C455F325F5F2E67657446696C6C436F6C6F7229286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F';
wwv_flow_imp.g_varchar2_table(936) := '5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F7229286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B65';
wwv_flow_imp.g_varchar2_table(937) := '57696474683A20310A2020202020207D293B0A202020207D2C0A202020202762706D6E3A5465726D696E6174654576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D20';
wwv_flow_imp.g_varchar2_table(938) := '7B7D29207B0A20202020202076617220636972636C65203D2064726177436972636C6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20382C207B0A202020202020202066696C6C3A2028302C';
wwv_flow_imp.g_varchar2_table(939) := '5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F';
wwv_flow_imp.g_varchar2_table(940) := '6B65292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C';
wwv_flow_imp.g_varchar2_table(941) := '745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20340A2020202020207D293B0A0A20202020202072657475726E20636972636C653B0A202020207D0A20207D3B0A0A20206675';
wwv_flow_imp.g_varchar2_table(942) := '6E6374696F6E2072656E6465724576656E7449636F6E28656C656D656E742C20706172656E744766782C206174747273203D207B7D29207B0A202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F57454250';
wwv_flow_imp.g_varchar2_table(943) := '41434B5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928656C656D656E74292C0A202020202020202069735468726F77696E67203D2028302C5F42706D6E52656E6465725574696C5F5F574542504143';
wwv_flow_imp.g_varchar2_table(944) := '4B5F494D504F525445445F4D4F44554C455F325F5F2E69735468726F774576656E74292873656D616E746963293B0A0A202020206966202873656D616E7469632E67657428276576656E74446566696E6974696F6E7327292026262073656D616E746963';
wwv_flow_imp.g_varchar2_table(945) := '2E67657428276576656E74446566696E6974696F6E7327292E6C656E677468203E203129207B0A2020202020206966202873656D616E7469632E6765742827706172616C6C656C4D756C7469706C65272929207B0A202020202020202072657475726E20';
wwv_flow_imp.g_varchar2_table(946) := '6576656E7449636F6E52656E6465726572735B202762706D6E3A506172616C6C656C4D756C7469706C654576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B';
wwv_flow_imp.g_varchar2_table(947) := '0A2020202020207D0A202020202020656C7365207B0A202020202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A4D756C7469706C654576656E74446566696E6974696F6E27205D28706172656E744766782C';
wwv_flow_imp.g_varchar2_table(948) := '20656C656D656E742C2061747472732C2069735468726F77696E67293B0A2020202020207D0A202020207D0A0A202020206966202828302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F';
wwv_flow_imp.g_varchar2_table(949) := '2E697354797065644576656E74292873656D616E7469632C202762706D6E3A4D6573736167654576656E74446566696E6974696F6E272929207B0A20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A4D65';
wwv_flow_imp.g_varchar2_table(950) := '73736167654576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B0A202020207D0A0A202020206966202828302C5F42706D6E52656E6465725574696C5F5F57';
wwv_flow_imp.g_varchar2_table(951) := '45425041434B5F494D504F525445445F4D4F44554C455F325F5F2E697354797065644576656E74292873656D616E7469632C202762706D6E3A54696D65724576656E74446566696E6974696F6E272929207B0A20202020202072657475726E206576656E';
wwv_flow_imp.g_varchar2_table(952) := '7449636F6E52656E6465726572735B202762706D6E3A54696D65724576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B0A202020207D0A0A20202020696620';
wwv_flow_imp.g_varchar2_table(953) := '2828302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E697354797065644576656E74292873656D616E7469632C202762706D6E3A436F6E646974696F6E616C4576656E74446566696E';
wwv_flow_imp.g_varchar2_table(954) := '6974696F6E272929207B0A20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C20';
wwv_flow_imp.g_varchar2_table(955) := '61747472732C2069735468726F77696E67293B0A202020207D0A0A202020206966202828302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E697354797065644576656E74292873656D';
wwv_flow_imp.g_varchar2_table(956) := '616E7469632C202762706D6E3A5369676E616C4576656E74446566696E6974696F6E272929207B0A20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A5369676E616C4576656E74446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(957) := '27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B0A202020207D0A0A202020206966202828302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(958) := '4C455F325F5F2E697354797065644576656E74292873656D616E7469632C202762706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E272929207B0A20202020202072657475726E206576656E7449636F6E52656E6465726572735B';
wwv_flow_imp.g_varchar2_table(959) := '202762706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B0A202020207D0A0A202020206966202828302C5F42706D6E52';
wwv_flow_imp.g_varchar2_table(960) := '656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E697354797065644576656E74292873656D616E7469632C202762706D6E3A4C696E6B4576656E74446566696E6974696F6E272929207B0A202020202020';
wwv_flow_imp.g_varchar2_table(961) := '72657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A4C696E6B4576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B0A20202020';
wwv_flow_imp.g_varchar2_table(962) := '7D0A0A202020206966202828302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E697354797065644576656E74292873656D616E7469632C202762706D6E3A4572726F724576656E7444';
wwv_flow_imp.g_varchar2_table(963) := '6566696E6974696F6E272929207B0A20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A4572726F724576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C206174';
wwv_flow_imp.g_varchar2_table(964) := '7472732C2069735468726F77696E67293B0A202020207D0A0A202020206966202828302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E697354797065644576656E74292873656D616E';
wwv_flow_imp.g_varchar2_table(965) := '7469632C202762706D6E3A43616E63656C4576656E74446566696E6974696F6E272929207B0A20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A43616E63656C4576656E74446566696E6974696F6E2720';
wwv_flow_imp.g_varchar2_table(966) := '5D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B0A202020207D0A0A202020206966202828302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C45';
wwv_flow_imp.g_varchar2_table(967) := '5F325F5F2E697354797065644576656E74292873656D616E7469632C202762706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E272929207B0A20202020202072657475726E206576656E7449636F6E52656E6465726572735B2027';
wwv_flow_imp.g_varchar2_table(968) := '62706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B0A202020207D0A0A202020206966202828302C5F42706D6E52656E';
wwv_flow_imp.g_varchar2_table(969) := '6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E697354797065644576656E74292873656D616E7469632C202762706D6E3A5465726D696E6174654576656E74446566696E6974696F6E272929207B0A202020';
wwv_flow_imp.g_varchar2_table(970) := '20202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A5465726D696E6174654576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E';
wwv_flow_imp.g_varchar2_table(971) := '67293B0A202020207D0A0A2020202072657475726E206E756C6C3B0A20207D0A0A2020766172207461736B4D61726B657252656E646572657273203D207B0A20202020275061727469636970616E744D756C7469706C69636974794D61726B6572273A20';
wwv_flow_imp.g_varchar2_table(972) := '66756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A202020202020766172207769647468203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(973) := '44554C455F325F5F2E67657457696474682928656C656D656E742C206174747273292C0A20202020202020202020686569676874203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F32';
wwv_flow_imp.g_varchar2_table(974) := '5F5F2E6765744865696768742928656C656D656E742C206174747273293B0A0A202020202020766172206D61726B657250617468203D20706174684D61702E6765745363616C65645061746828274D41524B45525F504152414C4C454C272C207B0A2020';
wwv_flow_imp.g_varchar2_table(975) := '202020202020785363616C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A2077696474682C0A2020202020202020636F6E7461696E657248656967';
wwv_flow_imp.g_varchar2_table(976) := '68743A206865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A2028287769647468202F2032202D203629202F207769647468292C0A202020202020202020206D793A2028686569676874202D20313529';
wwv_flow_imp.g_varchar2_table(977) := '202F206865696768740A20202020202020207D0A2020202020207D293B0A0A202020202020647261774D61726B657228277061727469636970616E742D6D756C7469706C6963697479272C20706172656E744766782C206D61726B6572506174682C207B';
wwv_flow_imp.g_varchar2_table(978) := '0A20202020202020207374726F6B6557696474683A20322C0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F7229';
wwv_flow_imp.g_varchar2_table(979) := '28656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C45';
wwv_flow_imp.g_varchar2_table(980) := '5F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D293B0A202020207D2C0A202020202753756250726F636573734D61726B';
wwv_flow_imp.g_varchar2_table(981) := '6572273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A202020202020766172206D61726B657252656374203D20647261775265637428706172656E744766782C2031342C2031342C2030';
wwv_flow_imp.g_varchar2_table(982) := '2C207B0A20202020202020207374726F6B6557696474683A20312C0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C';
wwv_flow_imp.g_varchar2_table(983) := '6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44';
wwv_flow_imp.g_varchar2_table(984) := '554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D293B0A0A20202020202028302C6469616772616D5F6A735F6C69';
wwv_flow_imp.g_varchar2_table(985) := '625F7574696C5F5376675472616E73666F726D5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F375F5F2E7472616E736C61746529286D61726B6572526563742C20656C656D656E742E7769647468202F2032202D20372E352C';
wwv_flow_imp.g_varchar2_table(986) := '20656C656D656E742E686569676874202D203230293B0A0A202020202020766172206D61726B657250617468203D20706174684D61702E6765745363616C65645061746828274D41524B45525F5355425F50524F43455353272C207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(987) := '20785363616C65466163746F723A20312E352C0A2020202020202020795363616C65466163746F723A20312E352C0A2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C0A2020202020202020636F6E746169';
wwv_flow_imp.g_varchar2_table(988) := '6E65724865696768743A20656C656D656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A2028656C656D656E742E7769647468202F2032202D20372E3529202F20656C656D656E742E776964';
wwv_flow_imp.g_varchar2_table(989) := '74682C0A202020202020202020206D793A2028656C656D656E742E686569676874202D20323029202F20656C656D656E742E6865696768740A20202020202020207D0A2020202020207D293B0A0A202020202020647261774D61726B657228277375622D';
wwv_flow_imp.g_varchar2_table(990) := '70726F63657373272C20706172656E744766782C206D61726B6572506174682C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574';
wwv_flow_imp.g_varchar2_table(991) := '46696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F52';
wwv_flow_imp.g_varchar2_table(992) := '5445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D293B0A202020207D2C0A202020202750617261';
wwv_flow_imp.g_varchar2_table(993) := '6C6C656C4D61726B6572273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C20617474727329207B0A202020202020766172207769647468203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D50';
wwv_flow_imp.g_varchar2_table(994) := '4F525445445F4D4F44554C455F325F5F2E67657457696474682928656C656D656E742C206174747273292C0A20202020202020202020686569676874203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(995) := '4D4F44554C455F325F5F2E6765744865696768742928656C656D656E742C206174747273293B0A0A202020202020766172206D61726B657250617468203D20706174684D61702E6765745363616C65645061746828274D41524B45525F504152414C4C45';
wwv_flow_imp.g_varchar2_table(996) := '4C272C207B0A2020202020202020785363616C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A2077696474682C0A2020202020202020636F6E7461';
wwv_flow_imp.g_varchar2_table(997) := '696E65724865696768743A206865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A2028287769647468202F2032202B2061747472732E706172616C6C656C29202F207769647468292C0A202020202020';
wwv_flow_imp.g_varchar2_table(998) := '202020206D793A2028686569676874202D20323029202F206865696768740A20202020202020207D0A2020202020207D293B0A0A202020202020647261774D61726B65722827706172616C6C656C272C20706172656E744766782C206D61726B65725061';
wwv_flow_imp.g_varchar2_table(999) := '74682C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C744669';
wwv_flow_imp.g_varchar2_table(1000) := '6C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F72';
wwv_flow_imp.g_varchar2_table(1001) := '2928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D293B0A202020207D2C0A202020202753657175656E7469616C4D61726B6572273A2066756E6374696F6E28706172656E';
wwv_flow_imp.g_varchar2_table(1002) := '744766782C20656C656D656E742C20617474727329207B0A202020202020766172206D61726B657250617468203D20706174684D61702E6765745363616C65645061746828274D41524B45525F53455155454E5449414C272C207B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(1003) := '785363616C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C0A2020202020202020636F6E7461696E65724865';
wwv_flow_imp.g_varchar2_table(1004) := '696768743A20656C656D656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A202828656C656D656E742E7769647468202F2032202B2061747472732E73657129202F20656C656D656E742E77';
wwv_flow_imp.g_varchar2_table(1005) := '69647468292C0A202020202020202020206D793A2028656C656D656E742E686569676874202D20313929202F20656C656D656E742E6865696768740A20202020202020207D0A2020202020207D293B0A0A202020202020647261774D61726B6572282773';
wwv_flow_imp.g_varchar2_table(1006) := '657175656E7469616C272C20706172656E744766782C206D61726B6572506174682C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67';
wwv_flow_imp.g_varchar2_table(1007) := '657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D50';
wwv_flow_imp.g_varchar2_table(1008) := '4F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D293B0A202020207D2C0A2020202027436F';
wwv_flow_imp.g_varchar2_table(1009) := '6D70656E736174696F6E4D61726B6572273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C20617474727329207B0A202020202020766172206D61726B65724D617468203D20706174684D61702E6765745363616C6564506174';
wwv_flow_imp.g_varchar2_table(1010) := '6828274D41524B45525F434F4D50454E534154494F4E272C207B0A2020202020202020785363616C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A';
wwv_flow_imp.g_varchar2_table(1011) := '20656C656D656E742E77696474682C0A2020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A202828656C656D656E74';
wwv_flow_imp.g_varchar2_table(1012) := '2E7769647468202F2032202B2061747472732E636F6D70656E736174696F6E29202F20656C656D656E742E7769647468292C0A202020202020202020206D793A2028656C656D656E742E686569676874202D20313329202F20656C656D656E742E686569';
wwv_flow_imp.g_varchar2_table(1013) := '6768740A20202020202020207D0A2020202020207D293B0A0A202020202020647261774D61726B65722827636F6D70656E736174696F6E272C20706172656E744766782C206D61726B65724D6174682C207B0A20202020202020207374726F6B65576964';
wwv_flow_imp.g_varchar2_table(1014) := '74683A20312C0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446';
wwv_flow_imp.g_varchar2_table(1015) := '696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F';
wwv_flow_imp.g_varchar2_table(1016) := '722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D293B0A202020207D2C0A20202020274C6F6F704D61726B6572273A2066756E6374696F6E28706172656E744766782C';
wwv_flow_imp.g_varchar2_table(1017) := '20656C656D656E742C20617474727329207B0A202020202020766172207769647468203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657457696474682928656C656D65';
wwv_flow_imp.g_varchar2_table(1018) := '6E742C206174747273292C0A20202020202020202020686569676874203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744865696768742928656C656D656E742C2061';
wwv_flow_imp.g_varchar2_table(1019) := '74747273293B0A0A202020202020766172206D61726B657250617468203D20706174684D61702E6765745363616C65645061746828274D41524B45525F4C4F4F50272C207B0A2020202020202020785363616C65466163746F723A20312C0A2020202020';
wwv_flow_imp.g_varchar2_table(1020) := '202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A2077696474682C0A2020202020202020636F6E7461696E65724865696768743A206865696768742C0A2020202020202020706F736974696F6E';
wwv_flow_imp.g_varchar2_table(1021) := '3A207B0A202020202020202020206D783A2028287769647468202F2032202B2061747472732E6C6F6F7029202F207769647468292C0A202020202020202020206D793A2028686569676874202D203729202F206865696768740A20202020202020207D0A';
wwv_flow_imp.g_varchar2_table(1022) := '2020202020207D293B0A0A202020202020647261774D61726B657228276C6F6F70272C20706172656E744766782C206D61726B6572506174682C207B0A20202020202020207374726F6B6557696474683A20312E352C0A202020202020202066696C6C3A';
wwv_flow_imp.g_varchar2_table(1023) := '20276E6F6E65272C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C206465';
wwv_flow_imp.g_varchar2_table(1024) := '6661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B654D697465726C696D69743A20302E350A2020202020207D293B0A202020207D2C0A20202020274164686F634D61726B6572273A2066';
wwv_flow_imp.g_varchar2_table(1025) := '756E6374696F6E28706172656E744766782C20656C656D656E742C20617474727329207B0A202020202020766172207769647468203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F32';
wwv_flow_imp.g_varchar2_table(1026) := '5F5F2E67657457696474682928656C656D656E742C206174747273292C0A20202020202020202020686569676874203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574';
wwv_flow_imp.g_varchar2_table(1027) := '4865696768742928656C656D656E742C206174747273293B0A0A202020202020766172206D61726B657250617468203D20706174684D61702E6765745363616C65645061746828274D41524B45525F4144484F43272C207B0A2020202020202020785363';
wwv_flow_imp.g_varchar2_table(1028) := '616C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A2077696474682C0A2020202020202020636F6E7461696E65724865696768743A206865696768';
wwv_flow_imp.g_varchar2_table(1029) := '742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A2028287769647468202F2032202B2061747472732E6164686F6329202F207769647468292C0A202020202020202020206D793A2028686569676874202D203135';
wwv_flow_imp.g_varchar2_table(1030) := '29202F206865696768740A20202020202020207D0A2020202020207D293B0A0A202020202020647261774D61726B657228276164686F63272C20706172656E744766782C206D61726B6572506174682C207B0A20202020202020207374726F6B65576964';
wwv_flow_imp.g_varchar2_table(1031) := '74683A20312C0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C';
wwv_flow_imp.g_varchar2_table(1032) := '745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F';
wwv_flow_imp.g_varchar2_table(1033) := '6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D293B0A202020207D0A20207D3B0A0A202066756E6374696F6E2072656E6465725461736B4D61726B65';
wwv_flow_imp.g_varchar2_table(1034) := '7228747970652C20706172656E744766782C20656C656D656E742C20617474727329207B0A202020207461736B4D61726B657252656E6465726572735B2074797065205D28706172656E744766782C20656C656D656E742C206174747273293B0A20207D';
wwv_flow_imp.g_varchar2_table(1035) := '0A0A202066756E6374696F6E2072656E6465725461736B4D61726B65727328706172656E744766782C20656C656D656E742C207461736B4D61726B6572732C206174747273203D207B7D29207B0A202020206174747273203D207B0A2020202020206669';
wwv_flow_imp.g_varchar2_table(1036) := '6C6C3A2061747472732E66696C6C2C0A2020202020207374726F6B653A2061747472732E7374726F6B652C0A20202020202077696474683A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C45';
wwv_flow_imp.g_varchar2_table(1037) := '5F325F5F2E67657457696474682928656C656D656E742C206174747273292C0A2020202020206865696768743A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574486569';
wwv_flow_imp.g_varchar2_table(1038) := '6768742928656C656D656E742C206174747273290A202020207D3B0A0A202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E67657442';
wwv_flow_imp.g_varchar2_table(1039) := '7573696E6573734F626A6563742928656C656D656E74293B0A0A202020207661722073756270726F63657373203D207461736B4D61726B657273202626207461736B4D61726B6572732E696E636C75646573282753756250726F636573734D61726B6572';
wwv_flow_imp.g_varchar2_table(1040) := '27293B0A0A202020206966202873756270726F6365737329207B0A2020202020206174747273203D207B0A20202020202020202E2E2E61747472732C0A20202020202020207365713A202D32312C0A2020202020202020706172616C6C656C3A202D3232';
wwv_flow_imp.g_varchar2_table(1041) := '2C0A2020202020202020636F6D70656E736174696F6E3A202D34322C0A20202020202020206C6F6F703A202D31382C0A20202020202020206164686F633A2031300A2020202020207D3B0A202020207D20656C7365207B0A202020202020617474727320';
wwv_flow_imp.g_varchar2_table(1042) := '3D207B0A20202020202020202E2E2E61747472732C0A20202020202020207365713A202D352C0A2020202020202020706172616C6C656C3A202D362C0A2020202020202020636F6D70656E736174696F6E3A202D32372C0A20202020202020206C6F6F70';
wwv_flow_imp.g_varchar2_table(1043) := '3A20302C0A20202020202020206164686F633A2031300A2020202020207D3B0A202020207D0A0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E666F724561636829287461736B4D6172';
wwv_flow_imp.g_varchar2_table(1044) := '6B6572732C2066756E6374696F6E286D61726B657229207B0A20202020202072656E6465725461736B4D61726B6572286D61726B65722C20706172656E744766782C20656C656D656E742C206174747273293B0A202020207D293B0A0A20202020696620';
wwv_flow_imp.g_varchar2_table(1045) := '2873656D616E7469632E67657428276973466F72436F6D70656E736174696F6E272929207B0A20202020202072656E6465725461736B4D61726B65722827436F6D70656E736174696F6E4D61726B6572272C20706172656E744766782C20656C656D656E';
wwv_flow_imp.g_varchar2_table(1046) := '742C206174747273293B0A202020207D0A0A202020206966202828302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E6973292873656D616E7469632C202762706D6E3A4164486F6353';
wwv_flow_imp.g_varchar2_table(1047) := '756250726F63657373272929207B0A20202020202072656E6465725461736B4D61726B657228274164686F634D61726B6572272C20706172656E744766782C20656C656D656E742C206174747273293B0A202020207D0A0A20202020766172206C6F6F70';
wwv_flow_imp.g_varchar2_table(1048) := '436861726163746572697374696373203D2073656D616E7469632E67657428276C6F6F7043686172616374657269737469637327292C0A2020202020202020697353657175656E7469616C203D206C6F6F70436861726163746572697374696373202626';
wwv_flow_imp.g_varchar2_table(1049) := '206C6F6F704368617261637465726973746963732E6765742827697353657175656E7469616C27293B0A0A20202020696620286C6F6F7043686172616374657269737469637329207B0A0A20202020202069662028697353657175656E7469616C203D3D';
wwv_flow_imp.g_varchar2_table(1050) := '3D20756E646566696E656429207B0A202020202020202072656E6465725461736B4D61726B657228274C6F6F704D61726B6572272C20706172656E744766782C20656C656D656E742C206174747273293B0A2020202020207D0A0A202020202020696620';
wwv_flow_imp.g_varchar2_table(1051) := '28697353657175656E7469616C203D3D3D2066616C736529207B0A202020202020202072656E6465725461736B4D61726B65722827506172616C6C656C4D61726B6572272C20706172656E744766782C20656C656D656E742C206174747273293B0A2020';
wwv_flow_imp.g_varchar2_table(1052) := '202020207D0A0A20202020202069662028697353657175656E7469616C203D3D3D207472756529207B0A202020202020202072656E6465725461736B4D61726B6572282753657175656E7469616C4D61726B6572272C20706172656E744766782C20656C';
wwv_flow_imp.g_varchar2_table(1053) := '656D656E742C206174747273293B0A2020202020207D0A202020207D0A20207D0A0A202066756E6374696F6E2072656E6465724C6162656C28706172656E744766782C206C6162656C2C206174747273203D207B7D29207B0A202020206174747273203D';
wwv_flow_imp.g_varchar2_table(1054) := '2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E61737369676E29287B0A20202020202073697A653A207B0A202020202020202077696474683A203130300A2020202020207D0A202020207D2C20';
wwv_flow_imp.g_varchar2_table(1055) := '6174747273293B0A0A202020207661722074657874203D207465787452656E64657265722E63726561746554657874286C6162656C207C7C2027272C206174747273293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F52';
wwv_flow_imp.g_varchar2_table(1056) := '5445445F4D4F44554C455F335F5F2E636C6173736573292874657874292E6164642827646A732D6C6162656C27293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E617070656E64';
wwv_flow_imp.g_varchar2_table(1057) := '2928706172656E744766782C2074657874293B0A0A2020202072657475726E20746578743B0A20207D0A0A202066756E6374696F6E2072656E646572456D6265646465644C6162656C28706172656E744766782C20656C656D656E742C20616C69676E2C';
wwv_flow_imp.g_varchar2_table(1058) := '206174747273203D207B7D29207B0A202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A65637429';
wwv_flow_imp.g_varchar2_table(1059) := '28656C656D656E74293B0A0A2020202076617220626F78203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574426F756E647329287B0A202020202020783A20656C656D';
wwv_flow_imp.g_varchar2_table(1060) := '656E742E782C0A202020202020793A20656C656D656E742E792C0A20202020202077696474683A20656C656D656E742E77696474682C0A2020202020206865696768743A20656C656D656E742E6865696768740A202020207D2C206174747273293B0A0A';
wwv_flow_imp.g_varchar2_table(1061) := '2020202072657475726E2072656E6465724C6162656C28706172656E744766782C2073656D616E7469632E6E616D652C207B0A202020202020616C69676E2C0A202020202020626F782C0A20202020202070616464696E673A20372C0A20202020202073';
wwv_flow_imp.g_varchar2_table(1062) := '74796C653A207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744C6162656C436F6C6F722928656C656D656E742C2064656661756C';
wwv_flow_imp.g_varchar2_table(1063) := '744C6162656C436F6C6F722C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D0A202020207D293B0A20207D0A0A202066756E6374696F6E2072656E64657245787465726E616C4C6162656C2870';
wwv_flow_imp.g_varchar2_table(1064) := '6172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202076617220626F78203D207B0A20202020202077696474683A2039302C0A2020202020206865696768743A2033302C0A202020202020783A20656C656D656E74';
wwv_flow_imp.g_varchar2_table(1065) := '2E7769647468202F2032202B20656C656D656E742E782C0A202020202020793A20656C656D656E742E686569676874202F2032202B20656C656D656E742E790A202020207D3B0A0A2020202072657475726E2072656E6465724C6162656C28706172656E';
wwv_flow_imp.g_varchar2_table(1066) := '744766782C2028302C5F7574696C5F4C6162656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F395F5F2E6765744C6162656C2928656C656D656E74292C207B0A202020202020626F783A20626F782C0A2020202020206669';
wwv_flow_imp.g_varchar2_table(1067) := '74426F783A20747275652C0A2020202020207374796C653A2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E61737369676E29280A20202020202020207B7D2C0A20202020202020207465787452';
wwv_flow_imp.g_varchar2_table(1068) := '656E64657265722E67657445787465726E616C5374796C6528292C0A20202020202020207B0A2020202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F';
wwv_flow_imp.g_varchar2_table(1069) := '5F2E6765744C6162656C436F6C6F722928656C656D656E742C2064656661756C744C6162656C436F6C6F722C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A20202020202020207D0A202020202020290A202020';
wwv_flow_imp.g_varchar2_table(1070) := '207D293B0A20207D0A0A202066756E6374696F6E2072656E6465724C616E654C6162656C28706172656E744766782C20746578742C20656C656D656E742C206174747273203D207B7D29207B0A20202020766172206973486F72697A6F6E74616C4C616E';
wwv_flow_imp.g_varchar2_table(1071) := '65203D2028302C5F7574696C5F44695574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F31305F5F2E6973486F72697A6F6E74616C2928656C656D656E74293B0A0A202020207661722074657874426F78203D2072656E6465724C';
wwv_flow_imp.g_varchar2_table(1072) := '6162656C28706172656E744766782C20746578742C207B0A202020202020626F783A207B0A20202020202020206865696768743A2033302C0A202020202020202077696474683A206973486F72697A6F6E74616C4C616E65203F2028302C5F42706D6E52';
wwv_flow_imp.g_varchar2_table(1073) := '656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744865696768742928656C656D656E742C20617474727329203A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(1074) := '525445445F4D4F44554C455F325F5F2E67657457696474682928656C656D656E742C206174747273292C0A2020202020207D2C0A202020202020616C69676E3A202763656E7465722D6D6964646C65272C0A2020202020207374796C653A207B0A202020';
wwv_flow_imp.g_varchar2_table(1075) := '202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744C6162656C436F6C6F722928656C656D656E742C2064656661756C744C6162656C436F6C6F72';
wwv_flow_imp.g_varchar2_table(1076) := '2C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D0A202020207D293B0A0A20202020696620286973486F72697A6F6E74616C4C616E6529207B0A20202020202076617220746F70203D202D3120';
wwv_flow_imp.g_varchar2_table(1077) := '2A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744865696768742928656C656D656E742C206174747273293B0A20202020202028302C6469616772616D5F6A735F6C69';
wwv_flow_imp.g_varchar2_table(1078) := '625F7574696C5F5376675472616E73666F726D5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F375F5F2E7472616E73666F726D292874657874426F782C20302C202D746F702C20323730293B0A202020207D0A20207D0A0A20';
wwv_flow_imp.g_varchar2_table(1079) := '2066756E6374696F6E2072656E646572416374697669747928706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A20202020766172207B0A20202020202077696474682C0A2020202020206865696768740A202020207D';
wwv_flow_imp.g_varchar2_table(1080) := '203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574426F756E64732928656C656D656E742C206174747273293B0A0A2020202072657475726E20647261775265637428';
wwv_flow_imp.g_varchar2_table(1081) := '706172656E744766782C2077696474682C206865696768742C205441534B5F424F524445525F5241444955532C207B0A2020202020202E2E2E61747472732C0A20202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F57454250';
wwv_flow_imp.g_varchar2_table(1082) := '41434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202066696C6C4F7061636974793A20444546';
wwv_flow_imp.g_varchar2_table(1083) := '41554C545F4F5041434954592C0A2020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C';
wwv_flow_imp.g_varchar2_table(1084) := '2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A202020207D293B0A20207D0A0A202066756E6374696F6E2072656E6465724173736F63696174696F6E28706172656E744766782C20656C656D656E742C20617474';
wwv_flow_imp.g_varchar2_table(1085) := '7273203D207B7D29207B0A202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928656C65';
wwv_flow_imp.g_varchar2_table(1086) := '6D656E74293B0A0A202020207661722066696C6C203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C';
wwv_flow_imp.g_varchar2_table(1087) := '7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B65203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B6543';
wwv_flow_imp.g_varchar2_table(1088) := '6F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65293B0A0A202020206966202873656D616E7469632E67657428276173736F63696174696F6E446972656374696F6E2729203D3D3D20';
wwv_flow_imp.g_varchar2_table(1089) := '274F6E6527207C7C0A202020202020202073656D616E7469632E67657428276173736F63696174696F6E446972656374696F6E2729203D3D3D2027426F74682729207B0A20202020202061747472732E6D61726B6572456E64203D206D61726B65722870';
wwv_flow_imp.g_varchar2_table(1090) := '6172656E744766782C20276173736F63696174696F6E2D656E64272C2066696C6C2C207374726F6B65293B0A202020207D0A0A202020206966202873656D616E7469632E67657428276173736F63696174696F6E446972656374696F6E2729203D3D3D20';
wwv_flow_imp.g_varchar2_table(1091) := '27426F74682729207B0A20202020202061747472732E6D61726B65725374617274203D206D61726B657228706172656E744766782C20276173736F63696174696F6E2D7374617274272C2066696C6C2C207374726F6B65293B0A202020207D0A0A202020';
wwv_flow_imp.g_varchar2_table(1092) := '206174747273203D207069636B41747472732861747472732C205B0A202020202020276D61726B65725374617274272C0A202020202020276D61726B6572456E64270A202020205D293B0A0A2020202072657475726E2064726177436F6E6E656374696F';
wwv_flow_imp.g_varchar2_table(1093) := '6E5365676D656E747328706172656E744766782C20656C656D656E742E776179706F696E74732C207B0A2020202020202E2E2E61747472732C0A2020202020207374726F6B652C0A2020202020207374726F6B654461736861727261793A2027302C2035';
wwv_flow_imp.g_varchar2_table(1094) := '270A202020207D293B0A20207D0A0A202066756E6374696F6E2072656E646572446174614F626A65637428706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A202020207661722066696C6C203D2028302C5F42706D6E';
wwv_flow_imp.g_varchar2_table(1095) := '52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A202020202020';
wwv_flow_imp.g_varchar2_table(1096) := '20207374726F6B65203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C';
wwv_flow_imp.g_varchar2_table(1097) := '6F722C2061747472732E7374726F6B65293B0A0A20202020766172207061746844617461203D20706174684D61702E6765745363616C6564506174682827444154415F4F424A4543545F50415448272C207B0A202020202020785363616C65466163746F';
wwv_flow_imp.g_varchar2_table(1098) := '723A20312C0A202020202020795363616C65466163746F723A20312C0A202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C0A202020202020636F6E7461696E65724865696768743A20656C656D656E742E686569';
wwv_flow_imp.g_varchar2_table(1099) := '6768742C0A202020202020706F736974696F6E3A207B0A20202020202020206D783A20302E3437342C0A20202020202020206D793A20302E3239360A2020202020207D0A202020207D293B0A0A2020202076617220646174614F626A656374203D206472';
wwv_flow_imp.g_varchar2_table(1100) := '61775061746828706172656E744766782C2070617468446174612C207B0A20202020202066696C6C2C0A20202020202066696C6C4F7061636974793A2044454641554C545F4F5041434954592C0A2020202020207374726F6B650A202020207D293B0A0A';
wwv_flow_imp.g_varchar2_table(1101) := '202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928656C656D656E74293B0A0A202020';
wwv_flow_imp.g_varchar2_table(1102) := '206966202828302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6973436F6C6C656374696F6E292873656D616E7469632929207B0A20202020202076617220636F6C6C656374696F6E';
wwv_flow_imp.g_varchar2_table(1103) := '5061746844617461203D20706174684D61702E6765745363616C6564506174682827444154415F4F424A4543545F434F4C4C454354494F4E5F50415448272C207B0A2020202020202020785363616C65466163746F723A20312C0A202020202020202079';
wwv_flow_imp.g_varchar2_table(1104) := '5363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C0A2020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C0A20202020';
wwv_flow_imp.g_varchar2_table(1105) := '20202020706F736974696F6E3A207B0A202020202020202020206D783A20302E33332C0A202020202020202020206D793A2028656C656D656E742E686569676874202D20313829202F20656C656D656E742E6865696768740A20202020202020207D0A20';
wwv_flow_imp.g_varchar2_table(1106) := '20202020207D293B0A0A202020202020647261775061746828706172656E744766782C20636F6C6C656374696F6E50617468446174612C207B0A20202020202020207374726F6B6557696474683A20322C0A202020202020202066696C6C2C0A20202020';
wwv_flow_imp.g_varchar2_table(1107) := '202020207374726F6B650A2020202020207D293B0A202020207D0A0A2020202072657475726E20646174614F626A6563743B0A20207D0A0A202066756E6374696F6E2072656E6465724576656E7428706172656E744766782C20656C656D656E742C2061';
wwv_flow_imp.g_varchar2_table(1108) := '74747273203D207B7D29207B0A2020202072657475726E2064726177436972636C6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C207B0A20202020202066696C6C4F7061636974793A204445';
wwv_flow_imp.g_varchar2_table(1109) := '4641554C545F4F5041434954592C0A2020202020202E2E2E61747472732C0A20202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F';
wwv_flow_imp.g_varchar2_table(1110) := '6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A2020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(1111) := '4C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A202020207D293B0A20207D0A0A202066756E6374696F6E2072656E64657247617465';
wwv_flow_imp.g_varchar2_table(1112) := '77617928706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202072657475726E20647261774469616D6F6E6428706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768';
wwv_flow_imp.g_varchar2_table(1113) := '742C207B0A20202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C43';
wwv_flow_imp.g_varchar2_table(1114) := '6F6C6F722C2061747472732E66696C6C292C0A20202020202066696C6C4F7061636974793A2044454641554C545F4F5041434954592C0A2020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D50';
wwv_flow_imp.g_varchar2_table(1115) := '4F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A202020207D293B0A20207D0A0A202066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(1116) := '72656E6465724C616E6528706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A20202020766172206C616E65203D20647261775265637428706172656E744766782C2028302C5F42706D6E52656E6465725574696C5F5F';
wwv_flow_imp.g_varchar2_table(1117) := '5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657457696474682928656C656D656E742C206174747273292C2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F32';
wwv_flow_imp.g_varchar2_table(1118) := '5F5F2E6765744865696768742928656C656D656E742C206174747273292C20302C207B0A20202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446';
wwv_flow_imp.g_varchar2_table(1119) := '696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202066696C6C4F7061636974793A2061747472732E66696C6C4F706163697479207C7C2044454641554C545F4F50';
wwv_flow_imp.g_varchar2_table(1120) := '41434954592C0A2020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C';
wwv_flow_imp.g_varchar2_table(1121) := '745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A2020202020207374726F6B6557696474683A20312E350A202020207D293B0A0A202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F';
wwv_flow_imp.g_varchar2_table(1122) := '5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928656C656D656E74293B0A0A202020206966202828302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F5254';
wwv_flow_imp.g_varchar2_table(1123) := '45445F4D4F44554C455F385F5F2E6973292873656D616E7469632C202762706D6E3A4C616E65272929207B0A2020202020207661722074657874203D2073656D616E7469632E67657428276E616D6527293B0A0A20202020202072656E6465724C616E65';
wwv_flow_imp.g_varchar2_table(1124) := '4C6162656C28706172656E744766782C20746578742C20656C656D656E742C206174747273293B0A202020207D0A0A2020202072657475726E206C616E653B0A20207D0A0A202066756E6374696F6E2072656E64657253756250726F6365737328706172';
wwv_flow_imp.g_varchar2_table(1125) := '656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A20202020766172206163746976697479203D2072656E646572416374697669747928706172656E744766782C20656C656D656E742C206174747273293B0A0A202020206966';
wwv_flow_imp.g_varchar2_table(1126) := '202828302C5F7574696C5F44695574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F31305F5F2E69734576656E7453756250726F636573732928656C656D656E742929207B0A20202020202028302C74696E795F7376675F5F5745';
wwv_flow_imp.g_varchar2_table(1127) := '425041434B5F494D504F525445445F4D4F44554C455F335F5F2E61747472292861637469766974792C207B0A20202020202020207374726F6B654461736861727261793A2027302C20352E35272C0A20202020202020207374726F6B6557696474683A20';
wwv_flow_imp.g_varchar2_table(1128) := '322E350A2020202020207D293B0A202020207D0A0A2020202076617220657870616E646564203D2028302C5F7574696C5F44695574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F31305F5F2E6973457870616E6465642928656C';
wwv_flow_imp.g_varchar2_table(1129) := '656D656E74293B0A0A2020202072656E646572456D6265646465644C6162656C28706172656E744766782C20656C656D656E742C20657870616E646564203F202763656E7465722D746F7027203A202763656E7465722D6D6964646C65272C2061747472';
wwv_flow_imp.g_varchar2_table(1130) := '73293B0A0A2020202069662028657870616E64656429207B0A20202020202072656E6465725461736B4D61726B65727328706172656E744766782C20656C656D656E742C20756E646566696E65642C206174747273293B0A202020207D20656C7365207B';
wwv_flow_imp.g_varchar2_table(1131) := '0A20202020202072656E6465725461736B4D61726B65727328706172656E744766782C20656C656D656E742C205B202753756250726F636573734D61726B657227205D2C206174747273293B0A202020207D0A0A2020202072657475726E206163746976';
wwv_flow_imp.g_varchar2_table(1132) := '6974793B0A20207D0A0A202066756E6374696F6E2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A20202020766172206163746976697479203D2072656E646572416374697669747928';
wwv_flow_imp.g_varchar2_table(1133) := '706172656E744766782C20656C656D656E742C206174747273293B0A0A2020202072656E646572456D6265646465644C6162656C28706172656E744766782C20656C656D656E742C202763656E7465722D6D6964646C65272C206174747273293B0A0A20';
wwv_flow_imp.g_varchar2_table(1134) := '20202072656E6465725461736B4D61726B65727328706172656E744766782C20656C656D656E742C20756E646566696E65642C206174747273293B0A0A2020202072657475726E2061637469766974793B0A20207D0A0A20207661722068616E646C6572';
wwv_flow_imp.g_varchar2_table(1135) := '73203D20746869732E68616E646C657273203D207B0A202020202762706D6E3A4164486F6353756250726F63657373273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A20202020202069';
wwv_flow_imp.g_varchar2_table(1136) := '66202828302C5F7574696C5F44695574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F31305F5F2E6973457870616E6465642928656C656D656E742929207B0A20202020202020206174747273203D207069636B41747472732861';
wwv_flow_imp.g_varchar2_table(1137) := '747472732C205B0A202020202020202020202766696C6C272C0A20202020202020202020277374726F6B65272C0A20202020202020202020277769647468272C0A2020202020202020202027686569676874270A20202020202020205D293B0A20202020';
wwv_flow_imp.g_varchar2_table(1138) := '20207D20656C7365207B0A20202020202020206174747273203D207069636B41747472732861747472732C205B0A202020202020202020202766696C6C272C0A20202020202020202020277374726F6B65270A20202020202020205D293B0A2020202020';
wwv_flow_imp.g_varchar2_table(1139) := '207D0A0A20202020202072657475726E2072656E64657253756250726F6365737328706172656E744766782C20656C656D656E742C206174747273293B0A202020207D2C0A202020202762706D6E3A4173736F63696174696F6E273A2066756E6374696F';
wwv_flow_imp.g_varchar2_table(1140) := '6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65';
wwv_flow_imp.g_varchar2_table(1141) := '270A2020202020205D293B0A0A20202020202072657475726E2072656E6465724173736F63696174696F6E28706172656E744766782C20656C656D656E742C206174747273293B0A202020207D2C0A202020202762706D6E3A426F756E64617279457665';
wwv_flow_imp.g_varchar2_table(1142) := '6E74273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A202020202020766172207B2072656E64657249636F6E203D2074727565207D203D2061747472733B0A0A20202020202061747472';
wwv_flow_imp.g_varchar2_table(1143) := '73203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A2020202020207661722073656D616E746963203D2028302C5F42706D6E52656E64';
wwv_flow_imp.g_varchar2_table(1144) := '65725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928656C656D656E74292C0A2020202020202020202063616E63656C4163746976697479203D2073656D616E746963';
wwv_flow_imp.g_varchar2_table(1145) := '2E676574282763616E63656C416374697669747927293B0A0A2020202020206174747273203D207B0A20202020202020207374726F6B6557696474683A20312E352C0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F';
wwv_flow_imp.g_varchar2_table(1146) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A202020202020202066696C6C4F70616369';
wwv_flow_imp.g_varchar2_table(1147) := '74793A2046554C4C5F4F5041434954592C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C';
wwv_flow_imp.g_varchar2_table(1148) := '656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D3B0A0A202020202020696620282163616E63656C416374697669747929207B0A202020202020202061747472732E7374726F6B65';
wwv_flow_imp.g_varchar2_table(1149) := '446173686172726179203D202736273B0A2020202020207D0A0A202020202020766172206576656E74203D2072656E6465724576656E7428706172656E744766782C20656C656D656E742C206174747273293B0A0A20202020202064726177436972636C';
wwv_flow_imp.g_varchar2_table(1150) := '6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20494E4E45525F4F555445525F444953542C207B0A20202020202020202E2E2E61747472732C0A202020202020202066696C6C3A20276E6F6E';
wwv_flow_imp.g_varchar2_table(1151) := '65270A2020202020207D293B0A0A2020202020206966202872656E64657249636F6E29207B0A202020202020202072656E6465724576656E7449636F6E28656C656D656E742C20706172656E744766782C206174747273293B0A2020202020207D0A0A20';
wwv_flow_imp.g_varchar2_table(1152) := '202020202072657475726E206576656E743B0A202020207D2C0A202020202762706D6E3A427573696E65737352756C655461736B273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020';
wwv_flow_imp.g_varchar2_table(1153) := '202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A202020202020766172207461736B203D2072656E6465725461';
wwv_flow_imp.g_varchar2_table(1154) := '736B28706172656E744766782C20656C656D656E742C206174747273293B0A0A2020202020207661722068656164657244617461203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F425553494E4553535F52554C';
wwv_flow_imp.g_varchar2_table(1155) := '455F4D41494E272C207B0A2020202020202020616273706F733A207B0A20202020202020202020783A20382C0A20202020202020202020793A20380A20202020202020207D0A2020202020207D293B0A0A20202020202076617220627573696E65737350';
wwv_flow_imp.g_varchar2_table(1156) := '617468203D20647261775061746828706172656E744766782C2068656164657244617461293B0A0A20202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E617474722928627573696E6573';
wwv_flow_imp.g_varchar2_table(1157) := '73506174682C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C';
wwv_flow_imp.g_varchar2_table(1158) := '7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F';
wwv_flow_imp.g_varchar2_table(1159) := '6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A0A2020202020207661722068656164657250';
wwv_flow_imp.g_varchar2_table(1160) := '61746844617461203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F425553494E4553535F52554C455F484541444552272C207B0A2020202020202020616273706F733A207B0A20202020202020202020783A2038';
wwv_flow_imp.g_varchar2_table(1161) := '2C0A20202020202020202020793A20380A20202020202020207D0A2020202020207D293B0A0A20202020202076617220627573696E65737348656164657250617468203D20647261775061746828706172656E744766782C206865616465725061746844';
wwv_flow_imp.g_varchar2_table(1162) := '617461293B0A0A20202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E617474722928627573696E657373486561646572506174682C207B0A202020202020202066696C6C3A2028302C5F';
wwv_flow_imp.g_varchar2_table(1163) := '42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B';
wwv_flow_imp.g_varchar2_table(1164) := '65292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C74';
wwv_flow_imp.g_varchar2_table(1165) := '5374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A0A20202020202072657475726E207461736B3B0A202020207D2C0A202020202762706D6E3A4361';
wwv_flow_imp.g_varchar2_table(1166) := '6C6C4163746976697479273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A2020202020202020276669';
wwv_flow_imp.g_varchar2_table(1167) := '6C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A20202020202072657475726E2072656E64657253756250726F6365737328706172656E744766782C20656C656D656E742C207B0A20202020202020207374726F6B6557';
wwv_flow_imp.g_varchar2_table(1168) := '696474683A20352C0A20202020202020202E2E2E61747472730A2020202020207D293B0A202020207D2C0A202020202762706D6E3A436F6D706C657847617465776179273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C2061';
wwv_flow_imp.g_varchar2_table(1169) := '74747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A20202020202076617220';
wwv_flow_imp.g_varchar2_table(1170) := '67617465776179203D2072656E6465724761746577617928706172656E744766782C20656C656D656E742C206174747273293B0A0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C6564506174682827474154';
wwv_flow_imp.g_varchar2_table(1171) := '455741595F434F4D504C4558272C207B0A2020202020202020785363616C65466163746F723A20302E352C0A2020202020202020795363616C65466163746F723A302E352C0A2020202020202020636F6E7461696E657257696474683A20656C656D656E';
wwv_flow_imp.g_varchar2_table(1172) := '742E77696474682C0A2020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E34362C0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(1173) := '6D793A20302E32360A20202020202020207D0A2020202020207D293B0A0A202020202020647261775061746828706172656E744766782C2070617468446174612C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C';
wwv_flow_imp.g_varchar2_table(1174) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374';
wwv_flow_imp.g_varchar2_table(1175) := '726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061';
wwv_flow_imp.g_varchar2_table(1176) := '747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A0A20202020202072657475726E20676174657761793B0A202020207D2C0A202020202762706D6E3A44617461496E707574273A2066';
wwv_flow_imp.g_varchar2_table(1177) := '756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A202020202020202027';
wwv_flow_imp.g_varchar2_table(1178) := '7374726F6B65270A2020202020205D293B0A0A202020202020766172206172726F775061746844617461203D20706174684D61702E676574526177506174682827444154415F4152524F5727293B0A0A20202020202076617220646174614F626A656374';
wwv_flow_imp.g_varchar2_table(1179) := '203D2072656E646572446174614F626A65637428706172656E744766782C20656C656D656E742C206174747273293B0A0A202020202020647261775061746828706172656E744766782C206172726F7750617468446174612C207B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(1180) := '66696C6C3A20276E6F6E65272C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E';
wwv_flow_imp.g_varchar2_table(1181) := '742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A0A20202020202072657475726E20646174614F626A6563743B0A202020';
wwv_flow_imp.g_varchar2_table(1182) := '207D2C0A202020202762706D6E3A44617461496E7075744173736F63696174696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B4174';
wwv_flow_imp.g_varchar2_table(1183) := '7472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A20202020202072657475726E2072656E6465724173736F63696174696F6E28706172656E744766782C2065';
wwv_flow_imp.g_varchar2_table(1184) := '6C656D656E742C207B0A20202020202020202E2E2E61747472732C0A20202020202020206D61726B6572456E643A206D61726B657228706172656E744766782C20276173736F63696174696F6E2D656E64272C2028302C5F42706D6E52656E6465725574';
wwv_flow_imp.g_varchar2_table(1185) := '696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C2028302C5F42706D6E52656E646572';
wwv_flow_imp.g_varchar2_table(1186) := '5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B6529290A202020202020';
wwv_flow_imp.g_varchar2_table(1187) := '7D293B0A202020207D2C0A202020202762706D6E3A446174614F626A656374273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B4174747273';
wwv_flow_imp.g_varchar2_table(1188) := '2861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A20202020202072657475726E2072656E646572446174614F626A65637428706172656E744766782C20656C656D65';
wwv_flow_imp.g_varchar2_table(1189) := '6E742C206174747273293B0A202020207D2C0A202020202762706D6E3A446174614F626A6563745265666572656E6365273A206173282762706D6E3A446174614F626A65637427292C0A202020202762706D6E3A446174614F7574707574273A2066756E';
wwv_flow_imp.g_varchar2_table(1190) := '6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374';
wwv_flow_imp.g_varchar2_table(1191) := '726F6B65270A2020202020205D293B0A0A202020202020766172206172726F775061746844617461203D20706174684D61702E676574526177506174682827444154415F4152524F5727293B0A0A20202020202076617220646174614F626A656374203D';
wwv_flow_imp.g_varchar2_table(1192) := '2072656E646572446174614F626A65637428706172656E744766782C20656C656D656E742C206174747273293B0A0A202020202020647261775061746828706172656E744766782C206172726F7750617468446174612C207B0A20202020202020207374';
wwv_flow_imp.g_varchar2_table(1193) := '726F6B6557696474683A20312C0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064';
wwv_flow_imp.g_varchar2_table(1194) := '656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574537472';
wwv_flow_imp.g_varchar2_table(1195) := '6F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D293B0A0A20202020202072657475726E20646174614F626A6563743B0A202020207D2C0A20202020';
wwv_flow_imp.g_varchar2_table(1196) := '2762706D6E3A446174614F75747075744173736F63696174696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B417474727328617474';
wwv_flow_imp.g_varchar2_table(1197) := '72732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A20202020202072657475726E2072656E6465724173736F63696174696F6E28706172656E744766782C20656C656D656E742C';
wwv_flow_imp.g_varchar2_table(1198) := '207B0A20202020202020202E2E2E61747472732C0A20202020202020206D61726B6572456E643A206D61726B657228706172656E744766782C20276173736F63696174696F6E2D656E64272C2028302C5F42706D6E52656E6465725574696C5F5F574542';
wwv_flow_imp.g_varchar2_table(1199) := '5041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C2028302C5F42706D6E52656E6465725574696C5F5F57';
wwv_flow_imp.g_varchar2_table(1200) := '45425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B6529290A2020202020207D293B0A202020';
wwv_flow_imp.g_varchar2_table(1201) := '207D2C0A202020202762706D6E3A4461746153746F72655265666572656E6365273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472';
wwv_flow_imp.g_varchar2_table(1202) := '732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A202020202020766172206461746153746F726550617468203D20706174684D61702E6765745363616C65645061';
wwv_flow_imp.g_varchar2_table(1203) := '74682827444154415F53544F5245272C207B0A2020202020202020785363616C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A20656C656D656E74';
wwv_flow_imp.g_varchar2_table(1204) := '2E77696474682C0A2020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302C0A202020202020202020206D793A20';
wwv_flow_imp.g_varchar2_table(1205) := '302E3133330A20202020202020207D0A2020202020207D293B0A0A20202020202072657475726E20647261775061746828706172656E744766782C206461746153746F7265506174682C207B0A202020202020202066696C6C3A2028302C5F42706D6E52';
wwv_flow_imp.g_varchar2_table(1206) := '656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020';
wwv_flow_imp.g_varchar2_table(1207) := '2066696C6C4F7061636974793A2044454641554C545F4F5041434954592C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374';
wwv_flow_imp.g_varchar2_table(1208) := '726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20320A2020202020207D293B0A202020207D2C0A2020202027';
wwv_flow_imp.g_varchar2_table(1209) := '62706D6E3A456E644576656E74273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A202020202020766172207B2072656E64657249636F6E203D2074727565207D203D2061747472733B0A';
wwv_flow_imp.g_varchar2_table(1210) := '0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A202020202020766172206576656E74203D2072656E64';
wwv_flow_imp.g_varchar2_table(1211) := '65724576656E7428706172656E744766782C20656C656D656E742C207B0A20202020202020202E2E2E61747472732C0A20202020202020207374726F6B6557696474683A20340A2020202020207D293B0A0A2020202020206966202872656E6465724963';
wwv_flow_imp.g_varchar2_table(1212) := '6F6E29207B0A202020202020202072656E6465724576656E7449636F6E28656C656D656E742C20706172656E744766782C206174747273293B0A2020202020207D0A0A20202020202072657475726E206576656E743B0A202020207D2C0A202020202762';
wwv_flow_imp.g_varchar2_table(1213) := '706D6E3A4576656E74426173656447617465776179273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A';
wwv_flow_imp.g_varchar2_table(1214) := '20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A2020202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(1215) := '445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928656C656D656E74293B0A0A202020202020766172206469616D6F6E64203D2072656E6465724761746577617928706172656E744766782C20656C656D656E742C20617474';
wwv_flow_imp.g_varchar2_table(1216) := '7273293B0A0A20202020202064726177436972636C6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20656C656D656E742E686569676874202A20302E32302C207B0A20202020202020206669';
wwv_flow_imp.g_varchar2_table(1217) := '6C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C20276E6F6E65272C2061747472732E66696C6C292C0A20202020';
wwv_flow_imp.g_varchar2_table(1218) := '202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F';
wwv_flow_imp.g_varchar2_table(1219) := '6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A0A2020202020207661722074797065203D2073656D616E7469632E67657428276576656E7447617465776179547970';
wwv_flow_imp.g_varchar2_table(1220) := '6527292C0A20202020202020202020696E7374616E7469617465203D20212173656D616E7469632E6765742827696E7374616E746961746527293B0A0A20202020202066756E6374696F6E20647261774576656E742829207B0A0A202020202020202076';
wwv_flow_imp.g_varchar2_table(1221) := '6172207061746844617461203D20706174684D61702E6765745363616C6564506174682827474154455741595F4556454E545F4241534544272C207B0A20202020202020202020785363616C65466163746F723A20302E31382C0A202020202020202020';
wwv_flow_imp.g_varchar2_table(1222) := '20795363616C65466163746F723A20302E31382C0A20202020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C0A20202020202020202020636F6E7461696E65724865696768743A20656C656D656E742E686569';
wwv_flow_imp.g_varchar2_table(1223) := '6768742C0A20202020202020202020706F736974696F6E3A207B0A2020202020202020202020206D783A20302E33362C0A2020202020202020202020206D793A20302E34340A202020202020202020207D0A20202020202020207D293B0A0A2020202020';
wwv_flow_imp.g_varchar2_table(1224) := '202020647261775061746828706172656E744766782C2070617468446174612C207B0A2020202020202020202066696C6C3A20276E6F6E65272C0A202020202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F574542';
wwv_flow_imp.g_varchar2_table(1225) := '5041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A202020202020202020207374726F6B';
wwv_flow_imp.g_varchar2_table(1226) := '6557696474683A20320A20202020202020207D293B0A2020202020207D0A0A2020202020206966202874797065203D3D3D2027506172616C6C656C2729207B0A2020202020202020766172207061746844617461203D20706174684D61702E6765745363';
wwv_flow_imp.g_varchar2_table(1227) := '616C6564506174682827474154455741595F504152414C4C454C272C207B0A20202020202020202020785363616C65466163746F723A20302E342C0A20202020202020202020795363616C65466163746F723A20302E342C0A2020202020202020202063';
wwv_flow_imp.g_varchar2_table(1228) := '6F6E7461696E657257696474683A20656C656D656E742E77696474682C0A20202020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C0A20202020202020202020706F736974696F6E3A207B0A2020202020';
wwv_flow_imp.g_varchar2_table(1229) := '202020202020206D783A20302E3437342C0A2020202020202020202020206D793A20302E3239360A202020202020202020207D0A20202020202020207D293B0A0A2020202020202020647261775061746828706172656E744766782C2070617468446174';
wwv_flow_imp.g_varchar2_table(1230) := '612C207B0A2020202020202020202066696C6C3A20276E6F6E65272C0A202020202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374';
wwv_flow_imp.g_varchar2_table(1231) := '726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A202020202020202020207374726F6B6557696474683A20310A20202020202020207D293B0A2020202020207D20';
wwv_flow_imp.g_varchar2_table(1232) := '656C7365206966202874797065203D3D3D20274578636C75736976652729207B0A20202020202020206966202821696E7374616E746961746529207B0A2020202020202020202064726177436972636C6528706172656E744766782C20656C656D656E74';
wwv_flow_imp.g_varchar2_table(1233) := '2E77696474682C20656C656D656E742E6865696768742C20656C656D656E742E686569676874202A20302E32362C207B0A20202020202020202020202066696C6C3A20276E6F6E65272C0A2020202020202020202020207374726F6B653A2028302C5F42';
wwv_flow_imp.g_varchar2_table(1234) := '706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65';
wwv_flow_imp.g_varchar2_table(1235) := '292C0A2020202020202020202020207374726F6B6557696474683A20310A202020202020202020207D293B0A20202020202020207D0A0A2020202020202020647261774576656E7428293B0A2020202020207D0A0A0A20202020202072657475726E2064';
wwv_flow_imp.g_varchar2_table(1236) := '69616D6F6E643B0A202020207D2C0A202020202762706D6E3A4578636C757369766547617465776179273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D';
wwv_flow_imp.g_varchar2_table(1237) := '207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A2020202020207661722067617465776179203D2072656E64657247617465776179287061';
wwv_flow_imp.g_varchar2_table(1238) := '72656E744766782C20656C656D656E742C206174747273293B0A0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C6564506174682827474154455741595F4558434C5553495645272C207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(1239) := '20785363616C65466163746F723A20302E342C0A2020202020202020795363616C65466163746F723A20302E342C0A2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C0A2020202020202020636F6E746169';
wwv_flow_imp.g_varchar2_table(1240) := '6E65724865696768743A20656C656D656E742E6865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E33322C0A202020202020202020206D793A20302E330A20202020202020207D0A2020202020';
wwv_flow_imp.g_varchar2_table(1241) := '207D293B0A0A202020202020766172206469203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E67657444692928656C656D656E74293B0A0A2020202020206966202864692E';
wwv_flow_imp.g_varchar2_table(1242) := '676574282769734D61726B657256697369626C65272929207B0A2020202020202020647261775061746828706172656E744766782C2070617468446174612C207B0A2020202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C';
wwv_flow_imp.g_varchar2_table(1243) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(1244) := '7374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C';
wwv_flow_imp.g_varchar2_table(1245) := '2061747472732E7374726F6B65292C0A202020202020202020207374726F6B6557696474683A20310A20202020202020207D293B0A2020202020207D0A0A20202020202072657475726E20676174657761793B0A202020207D2C0A202020202762706D6E';
wwv_flow_imp.g_varchar2_table(1246) := '3A47617465776179273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C';
wwv_flow_imp.g_varchar2_table(1247) := '272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A20202020202072657475726E2072656E6465724761746577617928706172656E744766782C20656C656D656E742C206174747273293B0A202020207D2C0A20202020276270';
wwv_flow_imp.g_varchar2_table(1248) := '6D6E3A47726F7570273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C';
wwv_flow_imp.g_varchar2_table(1249) := '272C0A2020202020202020277374726F6B65272C0A2020202020202020277769647468272C0A202020202020202027686569676874270A2020202020205D293B0A0A20202020202072657475726E20647261775265637428706172656E744766782C2065';
wwv_flow_imp.g_varchar2_table(1250) := '6C656D656E742E77696474682C20656C656D656E742E6865696768742C205441534B5F424F524445525F5241444955532C207B0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(1251) := '525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20312E35';
wwv_flow_imp.g_varchar2_table(1252) := '2C0A20202020202020207374726F6B654461736861727261793A202731302C20362C20302C2036272C0A202020202020202066696C6C3A20276E6F6E65272C0A2020202020202020706F696E7465724576656E74733A20276E6F6E65272C0A2020202020';
wwv_flow_imp.g_varchar2_table(1253) := '20202077696474683A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657457696474682928656C656D656E742C206174747273292C0A20202020202020206865696768743A';
wwv_flow_imp.g_varchar2_table(1254) := '2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744865696768742928656C656D656E742C206174747273290A2020202020207D293B0A202020207D2C0A20202020276270';
wwv_flow_imp.g_varchar2_table(1255) := '6D6E3A496E636C757369766547617465776179273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A2020';
wwv_flow_imp.g_varchar2_table(1256) := '2020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A2020202020207661722067617465776179203D2072656E6465724761746577617928706172656E744766782C20656C656D656E742C2061747472';
wwv_flow_imp.g_varchar2_table(1257) := '73293B0A0A20202020202064726177436972636C6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20656C656D656E742E686569676874202A20302E32342C207B0A202020202020202066696C';
wwv_flow_imp.g_varchar2_table(1258) := '6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E6669';
wwv_flow_imp.g_varchar2_table(1259) := '6C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C';
wwv_flow_imp.g_varchar2_table(1260) := '745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20322E350A2020202020207D293B0A0A20202020202072657475726E20676174657761793B0A202020207D2C0A202020202762';
wwv_flow_imp.g_varchar2_table(1261) := '706D6E3A496E7465726D6564696174654576656E74273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A202020202020766172207B2072656E64657249636F6E203D2074727565207D203D';
wwv_flow_imp.g_varchar2_table(1262) := '2061747472733B0A0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A202020202020766172206F757465';
wwv_flow_imp.g_varchar2_table(1263) := '72203D2072656E6465724576656E7428706172656E744766782C20656C656D656E742C207B0A20202020202020202E2E2E61747472732C0A20202020202020207374726F6B6557696474683A20312E350A2020202020207D293B0A0A2020202020206472';
wwv_flow_imp.g_varchar2_table(1264) := '6177436972636C6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20494E4E45525F4F555445525F444953542C207B0A202020202020202066696C6C3A20276E6F6E65272C0A20202020202020';
wwv_flow_imp.g_varchar2_table(1265) := '207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F72';
wwv_flow_imp.g_varchar2_table(1266) := '2C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20312E350A2020202020207D293B0A0A2020202020206966202872656E64657249636F6E29207B0A202020202020202072656E6465724576656E7449636F6E';
wwv_flow_imp.g_varchar2_table(1267) := '28656C656D656E742C20706172656E744766782C206174747273293B0A2020202020207D0A0A20202020202072657475726E206F757465723B0A202020207D2C0A202020202762706D6E3A496E7465726D65646961746543617463684576656E74273A20';
wwv_flow_imp.g_varchar2_table(1268) := '6173282762706D6E3A496E7465726D6564696174654576656E7427292C0A202020202762706D6E3A496E7465726D6564696174655468726F774576656E74273A206173282762706D6E3A496E7465726D6564696174654576656E7427292C0A2020202027';
wwv_flow_imp.g_varchar2_table(1269) := '62706D6E3A4C616E65273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C';
wwv_flow_imp.g_varchar2_table(1270) := '6C272C0A2020202020202020277374726F6B65272C0A2020202020202020277769647468272C0A202020202020202027686569676874270A2020202020205D293B0A0A20202020202072657475726E2072656E6465724C616E6528706172656E74476678';
wwv_flow_imp.g_varchar2_table(1271) := '2C20656C656D656E742C207B0A20202020202020202E2E2E61747472732C0A202020202020202066696C6C4F7061636974793A204C4F575F4F5041434954590A2020202020207D293B0A202020207D2C0A202020202762706D6E3A4D616E75616C546173';
wwv_flow_imp.g_varchar2_table(1272) := '6B273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A20202020';
wwv_flow_imp.g_varchar2_table(1273) := '20202020277374726F6B65270A2020202020205D293B0A0A202020202020766172207461736B203D2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B0A0A20202020202076617220706174684461746120';
wwv_flow_imp.g_varchar2_table(1274) := '3D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F4D414E55414C272C207B0A2020202020202020616273706F733A207B0A20202020202020202020783A2031372C0A20202020202020202020793A2031350A202020';
wwv_flow_imp.g_varchar2_table(1275) := '20202020207D0A2020202020207D293B0A0A202020202020647261775061746828706172656E744766782C2070617468446174612C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D';
wwv_flow_imp.g_varchar2_table(1276) := '504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E64';
wwv_flow_imp.g_varchar2_table(1277) := '65725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020';
wwv_flow_imp.g_varchar2_table(1278) := '202020207374726F6B6557696474683A20302E350A2020202020207D293B0A0A20202020202072657475726E207461736B3B0A202020207D2C0A202020202762706D6E3A4D657373616765466C6F77273A2066756E6374696F6E28706172656E74476678';
wwv_flow_imp.g_varchar2_table(1279) := '2C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B';
wwv_flow_imp.g_varchar2_table(1280) := '0A0A2020202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928656C656D656E74292C0A';
wwv_flow_imp.g_varchar2_table(1281) := '202020202020202020206469203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E67657444692928656C656D656E74293B0A0A2020202020207661722066696C6C203D202830';
wwv_flow_imp.g_varchar2_table(1282) := '2C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A';
wwv_flow_imp.g_varchar2_table(1283) := '202020202020202020207374726F6B65203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C7453';
wwv_flow_imp.g_varchar2_table(1284) := '74726F6B65436F6C6F722C2061747472732E7374726F6B65293B0A0A2020202020207661722070617468203D2064726177436F6E6E656374696F6E5365676D656E747328706172656E744766782C20656C656D656E742E776179706F696E74732C207B0A';
wwv_flow_imp.g_varchar2_table(1285) := '20202020202020206D61726B6572456E643A206D61726B657228706172656E744766782C20276D657373616765666C6F772D656E64272C2066696C6C2C207374726F6B65292C0A20202020202020206D61726B657253746172743A206D61726B65722870';
wwv_flow_imp.g_varchar2_table(1286) := '6172656E744766782C20276D657373616765666C6F772D7374617274272C2066696C6C2C207374726F6B65292C0A20202020202020207374726F6B652C0A20202020202020207374726F6B654461736861727261793A202731302C203131272C0A202020';
wwv_flow_imp.g_varchar2_table(1287) := '20202020207374726F6B6557696474683A20312E350A2020202020207D293B0A0A2020202020206966202873656D616E7469632E67657428276D657373616765526566272929207B0A2020202020202020766172206D6964506F696E74203D2070617468';
wwv_flow_imp.g_varchar2_table(1288) := '2E676574506F696E7441744C656E67746828706174682E676574546F74616C4C656E6774682829202F2032293B0A0A2020202020202020766172206D61726B65725061746844617461203D20706174684D61702E6765745363616C65645061746828274D';
wwv_flow_imp.g_varchar2_table(1289) := '4553534147455F464C4F575F4D41524B4552272C207B0A20202020202020202020616273706F733A207B0A202020202020202020202020783A206D6964506F696E742E782C0A202020202020202020202020793A206D6964506F696E742E790A20202020';
wwv_flow_imp.g_varchar2_table(1290) := '2020202020207D0A20202020202020207D293B0A0A2020202020202020766172206D6573736167654174747273203D207B0A202020202020202020207374726F6B6557696474683A20310A20202020202020207D3B0A0A20202020202020206966202864';
wwv_flow_imp.g_varchar2_table(1291) := '692E67657428276D65737361676556697369626C654B696E642729203D3D3D2027696E6974696174696E672729207B0A202020202020202020206D65737361676541747472732E66696C6C203D2066696C6C3B0A202020202020202020206D6573736167';
wwv_flow_imp.g_varchar2_table(1292) := '6541747472732E7374726F6B65203D207374726F6B653B0A20202020202020207D20656C7365207B0A202020202020202020206D65737361676541747472732E66696C6C203D207374726F6B653B0A202020202020202020206D65737361676541747472';
wwv_flow_imp.g_varchar2_table(1293) := '732E7374726F6B65203D2066696C6C3B0A20202020202020207D0A0A2020202020202020766172206D657373616765203D20647261775061746828706172656E744766782C206D61726B657250617468446174612C206D6573736167654174747273293B';
wwv_flow_imp.g_varchar2_table(1294) := '0A0A2020202020202020766172206D657373616765526566203D2073656D616E7469632E67657428276D65737361676552656627292C0A2020202020202020202020206E616D65203D206D6573736167655265662E67657428276E616D6527293B0A0A20';
wwv_flow_imp.g_varchar2_table(1295) := '20202020202020766172206C6162656C203D2072656E6465724C6162656C28706172656E744766782C206E616D652C207B0A20202020202020202020616C69676E3A202763656E7465722D746F70272C0A20202020202020202020666974426F783A2074';
wwv_flow_imp.g_varchar2_table(1296) := '7275652C0A202020202020202020207374796C653A207B0A20202020202020202020202066696C6C3A207374726F6B650A202020202020202020207D0A20202020202020207D293B0A0A2020202020202020766172206D657373616765426F756E647320';
wwv_flow_imp.g_varchar2_table(1297) := '3D206D6573736167652E67657442426F7828292C0A2020202020202020202020206C6162656C426F756E6473203D206C6162656C2E67657442426F7828293B0A0A2020202020202020766172207472616E736C61746558203D206D6964506F696E742E78';
wwv_flow_imp.g_varchar2_table(1298) := '202D206C6162656C426F756E64732E7769647468202F20322C0A2020202020202020202020207472616E736C61746559203D206D6964506F696E742E79202B206D657373616765426F756E64732E686569676874202F2032202B20454C454D454E545F4C';
wwv_flow_imp.g_varchar2_table(1299) := '4142454C5F44495354414E43453B0A0A202020202020202028302C6469616772616D5F6A735F6C69625F7574696C5F5376675472616E73666F726D5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F375F5F2E7472616E73666F';
wwv_flow_imp.g_varchar2_table(1300) := '726D29286C6162656C2C207472616E736C617465582C207472616E736C617465592C2030293B0A2020202020207D0A0A20202020202072657475726E20706174683B0A202020207D2C0A202020202762706D6E3A506172616C6C656C4761746577617927';
wwv_flow_imp.g_varchar2_table(1301) := '3A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A202020202020';
wwv_flow_imp.g_varchar2_table(1302) := '2020277374726F6B65270A2020202020205D293B0A0A202020202020766172206469616D6F6E64203D2072656E6465724761746577617928706172656E744766782C20656C656D656E742C206174747273293B0A0A202020202020766172207061746844';
wwv_flow_imp.g_varchar2_table(1303) := '617461203D20706174684D61702E6765745363616C6564506174682827474154455741595F504152414C4C454C272C207B0A2020202020202020785363616C65466163746F723A20302E362C0A2020202020202020795363616C65466163746F723A2030';
wwv_flow_imp.g_varchar2_table(1304) := '2E362C0A2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C0A2020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C0A2020202020202020706F736974696F6E';
wwv_flow_imp.g_varchar2_table(1305) := '3A207B0A202020202020202020206D783A20302E34362C0A202020202020202020206D793A20302E320A20202020202020207D0A2020202020207D293B0A0A202020202020647261775061746828706172656E744766782C2070617468446174612C207B';
wwv_flow_imp.g_varchar2_table(1306) := '0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B';
wwv_flow_imp.g_varchar2_table(1307) := '65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F';
wwv_flow_imp.g_varchar2_table(1308) := '722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A0A20202020202072657475726E206469616D6F6E';
wwv_flow_imp.g_varchar2_table(1309) := '643B0A202020207D2C0A202020202762706D6E3A5061727469636970616E74273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B4174747273';
wwv_flow_imp.g_varchar2_table(1310) := '2861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65272C0A2020202020202020277769647468272C0A202020202020202027686569676874270A2020202020205D293B0A0A2020202020207661722070';
wwv_flow_imp.g_varchar2_table(1311) := '61727469636970616E74203D2072656E6465724C616E6528706172656E744766782C20656C656D656E742C206174747273293B0A0A20202020202076617220657870616E6465645061727469636970616E74203D2028302C5F7574696C5F44695574696C';
wwv_flow_imp.g_varchar2_table(1312) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F31305F5F2E6973457870616E6465642928656C656D656E74293B0A20202020202076617220686F72697A6F6E74616C5061727469636970616E74203D2028302C5F7574696C5F44695574';
wwv_flow_imp.g_varchar2_table(1313) := '696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F31305F5F2E6973486F72697A6F6E74616C2928656C656D656E74293B0A0A2020202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F57';
wwv_flow_imp.g_varchar2_table(1314) := '45425041434B5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928656C656D656E74292C0A202020202020202020206E616D65203D2073656D616E7469632E67657428276E616D6527293B0A0A20202020';
wwv_flow_imp.g_varchar2_table(1315) := '202069662028657870616E6465645061727469636970616E7429207B0A202020202020202076617220776179706F696E7473203D20686F72697A6F6E74616C5061727469636970616E74203F205B0A202020202020202020207B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(1316) := '202020783A2033302C0A202020202020202020202020793A20300A202020202020202020207D2C0A202020202020202020207B0A202020202020202020202020783A2033302C0A202020202020202020202020793A2028302C5F42706D6E52656E646572';
wwv_flow_imp.g_varchar2_table(1317) := '5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744865696768742928656C656D656E742C206174747273290A202020202020202020207D0A20202020202020205D203A205B0A202020202020202020207B0A20';
wwv_flow_imp.g_varchar2_table(1318) := '2020202020202020202020783A20302C0A202020202020202020202020793A2033300A202020202020202020207D2C0A202020202020202020207B0A202020202020202020202020783A2028302C5F42706D6E52656E6465725574696C5F5F5745425041';
wwv_flow_imp.g_varchar2_table(1319) := '434B5F494D504F525445445F4D4F44554C455F325F5F2E67657457696474682928656C656D656E742C206174747273292C0A202020202020202020202020793A2033300A202020202020202020207D0A20202020202020205D3B0A0A2020202020202020';
wwv_flow_imp.g_varchar2_table(1320) := '647261774C696E6528706172656E744766782C20776179706F696E74732C207B0A202020202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67';
wwv_flow_imp.g_varchar2_table(1321) := '65745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A202020202020202020207374726F6B6557696474683A205041525449434950414E545F5354524F4B45';
wwv_flow_imp.g_varchar2_table(1322) := '5F57494454480A20202020202020207D293B0A0A202020202020202072656E6465724C616E654C6162656C28706172656E744766782C206E616D652C20656C656D656E742C206174747273293B0A2020202020207D20656C7365207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(1323) := '2076617220626F756E6473203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574426F756E64732928656C656D656E742C206174747273293B0A0A202020202020202069';
wwv_flow_imp.g_varchar2_table(1324) := '66202821686F72697A6F6E74616C5061727469636970616E7429207B0A20202020202020202020626F756E64732E686569676874203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F32';
wwv_flow_imp.g_varchar2_table(1325) := '5F5F2E67657457696474682928656C656D656E742C206174747273293B0A20202020202020202020626F756E64732E7769647468203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F32';
wwv_flow_imp.g_varchar2_table(1326) := '5F5F2E6765744865696768742928656C656D656E742C206174747273293B0A20202020202020207D0A0A20202020202020207661722074657874426F78203D2072656E6465724C6162656C28706172656E744766782C206E616D652C207B0A2020202020';
wwv_flow_imp.g_varchar2_table(1327) := '2020202020626F783A20626F756E64732C0A20202020202020202020616C69676E3A202763656E7465722D6D6964646C65272C0A202020202020202020207374796C653A207B0A20202020202020202020202066696C6C3A2028302C5F42706D6E52656E';
wwv_flow_imp.g_varchar2_table(1328) := '6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744C6162656C436F6C6F722928656C656D656E742C2064656661756C744C6162656C436F6C6F722C2064656661756C745374726F6B65436F6C6F722C20';
wwv_flow_imp.g_varchar2_table(1329) := '61747472732E7374726F6B65290A202020202020202020207D0A20202020202020207D293B0A0A20202020202020206966202821686F72697A6F6E74616C5061727469636970616E7429207B0A2020202020202020202076617220746F70203D202D3120';
wwv_flow_imp.g_varchar2_table(1330) := '2A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744865696768742928656C656D656E742C206174747273293B0A2020202020202020202028302C6469616772616D5F6A';
wwv_flow_imp.g_varchar2_table(1331) := '735F6C69625F7574696C5F5376675472616E73666F726D5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F375F5F2E7472616E73666F726D292874657874426F782C20302C202D746F702C20323730293B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(1332) := '7D0A2020202020207D0A0A2020202020206966202873656D616E7469632E67657428277061727469636970616E744D756C7469706C6963697479272929207B0A202020202020202072656E6465725461736B4D61726B657228275061727469636970616E';
wwv_flow_imp.g_varchar2_table(1333) := '744D756C7469706C69636974794D61726B6572272C20706172656E744766782C20656C656D656E742C206174747273293B0A2020202020207D0A0A20202020202072657475726E207061727469636970616E743B0A202020207D2C0A202020202762706D';
wwv_flow_imp.g_varchar2_table(1334) := '6E3A526563656976655461736B27203A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020';
wwv_flow_imp.g_varchar2_table(1335) := '202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A2020202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(1336) := '455F385F5F2E676574427573696E6573734F626A6563742928656C656D656E74293B0A0A202020202020766172207461736B203D2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B0A0A20202020202076';
wwv_flow_imp.g_varchar2_table(1337) := '61722070617468446174613B0A0A2020202020206966202873656D616E7469632E6765742827696E7374616E7469617465272929207B0A202020202020202064726177436972636C6528706172656E744766782C2032382C2032382C203230202A20302E';
wwv_flow_imp.g_varchar2_table(1338) := '32322C207B0A2020202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C74';
wwv_flow_imp.g_varchar2_table(1339) := '46696C6C436F6C6F722C2061747472732E66696C6C292C0A202020202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B6543';
wwv_flow_imp.g_varchar2_table(1340) := '6F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A202020202020202020207374726F6B6557696474683A20310A20202020202020207D293B0A0A202020202020202070617468';
wwv_flow_imp.g_varchar2_table(1341) := '44617461203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F494E5354414E54494154494E475F53454E44272C207B0A20202020202020202020616273706F733A207B0A202020202020202020202020783A20372E';
wwv_flow_imp.g_varchar2_table(1342) := '37372C0A202020202020202020202020793A20392E35320A202020202020202020207D0A20202020202020207D293B0A2020202020207D20656C7365207B0A20202020202020207061746844617461203D20706174684D61702E6765745363616C656450';
wwv_flow_imp.g_varchar2_table(1343) := '61746828275441534B5F545950455F53454E44272C207B0A20202020202020202020785363616C65466163746F723A20302E392C0A20202020202020202020795363616C65466163746F723A20302E392C0A20202020202020202020636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(1344) := '7257696474683A2032312C0A20202020202020202020636F6E7461696E65724865696768743A2031342C0A20202020202020202020706F736974696F6E3A207B0A2020202020202020202020206D783A20302E332C0A2020202020202020202020206D79';
wwv_flow_imp.g_varchar2_table(1345) := '3A20302E340A202020202020202020207D0A20202020202020207D293B0A2020202020207D0A0A202020202020647261775061746828706172656E744766782C2070617468446174612C207B0A202020202020202066696C6C3A2028302C5F42706D6E52';
wwv_flow_imp.g_varchar2_table(1346) := '656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020';
wwv_flow_imp.g_varchar2_table(1347) := '207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F72';
wwv_flow_imp.g_varchar2_table(1348) := '2C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A0A20202020202072657475726E207461736B3B0A202020207D2C0A202020202762706D6E3A5363726970745461736B273A20';
wwv_flow_imp.g_varchar2_table(1349) := '66756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020';
wwv_flow_imp.g_varchar2_table(1350) := '277374726F6B65270A2020202020205D293B0A0A202020202020766172207461736B203D2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B0A0A202020202020766172207061746844617461203D207061';
wwv_flow_imp.g_varchar2_table(1351) := '74684D61702E6765745363616C65645061746828275441534B5F545950455F534352495054272C207B0A2020202020202020616273706F733A207B0A20202020202020202020783A2031352C0A20202020202020202020793A2032300A20202020202020';
wwv_flow_imp.g_varchar2_table(1352) := '207D0A2020202020207D293B0A0A202020202020647261775061746828706172656E744766782C2070617468446174612C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F5254';
wwv_flow_imp.g_varchar2_table(1353) := '45445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574';
wwv_flow_imp.g_varchar2_table(1354) := '696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A2020202020202020';
wwv_flow_imp.g_varchar2_table(1355) := '7374726F6B6557696474683A20310A2020202020207D293B0A0A20202020202072657475726E207461736B3B0A202020207D2C0A202020202762706D6E3A53656E645461736B273A2066756E6374696F6E28706172656E744766782C20656C656D656E74';
wwv_flow_imp.g_varchar2_table(1356) := '2C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A20202020202076';
wwv_flow_imp.g_varchar2_table(1357) := '6172207461736B203D2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B0A0A202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828275441534B5F54';
wwv_flow_imp.g_varchar2_table(1358) := '5950455F53454E44272C207B0A2020202020202020785363616C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A2032312C0A202020202020202063';
wwv_flow_imp.g_varchar2_table(1359) := '6F6E7461696E65724865696768743A2031342C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E3238352C0A202020202020202020206D793A20302E3335370A20202020202020207D0A2020202020207D293B';
wwv_flow_imp.g_varchar2_table(1360) := '0A0A202020202020647261775061746828706172656E744766782C2070617468446174612C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F';
wwv_flow_imp.g_varchar2_table(1361) := '5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745';
wwv_flow_imp.g_varchar2_table(1362) := '425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B6557696474683A';
wwv_flow_imp.g_varchar2_table(1363) := '20310A2020202020207D293B0A0A20202020202072657475726E207461736B3B0A202020207D2C0A202020202762706D6E3A53657175656E6365466C6F77273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C20617474727320';
wwv_flow_imp.g_varchar2_table(1364) := '3D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A2020202020207661722066696C6C20';
wwv_flow_imp.g_varchar2_table(1365) := '3D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C';
wwv_flow_imp.g_varchar2_table(1366) := '6C292C0A202020202020202020207374726F6B65203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661';
wwv_flow_imp.g_varchar2_table(1367) := '756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65293B0A0A20202020202076617220636F6E6E656374696F6E203D2064726177436F6E6E656374696F6E5365676D656E747328706172656E744766782C20656C656D656E742E776179';
wwv_flow_imp.g_varchar2_table(1368) := '706F696E74732C207B0A20202020202020206D61726B6572456E643A206D61726B657228706172656E744766782C202773657175656E6365666C6F772D656E64272C2066696C6C2C207374726F6B65292C0A20202020202020207374726F6B650A202020';
wwv_flow_imp.g_varchar2_table(1369) := '2020207D293B0A0A2020202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928656C656D';
wwv_flow_imp.g_varchar2_table(1370) := '656E74293B0A0A202020202020766172207B20736F75726365207D203D20656C656D656E743B0A0A20202020202069662028736F7572636529207B0A202020202020202076617220736F7572636553656D616E746963203D2028302C5F42706D6E52656E';
wwv_flow_imp.g_varchar2_table(1371) := '6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928736F75726365293B0A0A20202020202020202F2F20636F6E646974696F6E616C20666C6F77206D61726B6572';
wwv_flow_imp.g_varchar2_table(1372) := '0A20202020202020206966202873656D616E7469632E6765742827636F6E646974696F6E45787072657373696F6E27292026262028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E';
wwv_flow_imp.g_varchar2_table(1373) := '69732928736F7572636553656D616E7469632C202762706D6E3A4163746976697479272929207B0A2020202020202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E617474722928636F6E';
wwv_flow_imp.g_varchar2_table(1374) := '6E656374696F6E2C207B0A2020202020202020202020206D61726B657253746172743A206D61726B657228706172656E744766782C2027636F6E646974696F6E616C2D666C6F772D6D61726B6572272C2066696C6C2C207374726F6B65290A2020202020';
wwv_flow_imp.g_varchar2_table(1375) := '20202020207D293B0A20202020202020207D0A0A20202020202020202F2F2064656661756C74206D61726B65720A202020202020202069662028736F7572636553656D616E7469632E676574282764656661756C742729202626202828302C5F42706D6E';
wwv_flow_imp.g_varchar2_table(1376) := '52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E69732928736F7572636553656D616E7469632C202762706D6E3A476174657761792729207C7C2028302C5F42706D6E52656E6465725574696C5F5F57';
wwv_flow_imp.g_varchar2_table(1377) := '45425041434B5F494D504F525445445F4D4F44554C455F385F5F2E69732928736F7572636553656D616E7469632C202762706D6E3A41637469766974792729292026260A202020202020202020202020736F7572636553656D616E7469632E6765742827';
wwv_flow_imp.g_varchar2_table(1378) := '64656661756C742729203D3D3D2073656D616E74696329207B0A2020202020202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E617474722928636F6E6E656374696F6E2C207B0A202020';
wwv_flow_imp.g_varchar2_table(1379) := '2020202020202020206D61726B657253746172743A206D61726B657228706172656E744766782C2027636F6E646974696F6E616C2D64656661756C742D666C6F772D6D61726B6572272C2066696C6C2C207374726F6B65290A202020202020202020207D';
wwv_flow_imp.g_varchar2_table(1380) := '293B0A20202020202020207D0A2020202020207D0A0A20202020202072657475726E20636F6E6E656374696F6E3B0A202020207D2C0A202020202762706D6E3A536572766963655461736B273A2066756E6374696F6E28706172656E744766782C20656C';
wwv_flow_imp.g_varchar2_table(1381) := '656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A2020';
wwv_flow_imp.g_varchar2_table(1382) := '20202020766172207461736B203D2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B0A0A20202020202064726177436972636C6528706172656E744766782C2031302C2031302C207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(1383) := '2066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472';
wwv_flow_imp.g_varchar2_table(1384) := '732E66696C6C292C0A20202020202020207374726F6B653A20276E6F6E65272C0A20202020202020207472616E73666F726D3A20277472616E736C61746528362C203629270A2020202020207D293B0A0A20202020202076617220706174684461746153';
wwv_flow_imp.g_varchar2_table(1385) := '65727669636531203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F53455256494345272C207B0A2020202020202020616273706F733A207B0A20202020202020202020783A2031322C0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(1386) := '793A2031380A20202020202020207D0A2020202020207D293B0A0A202020202020647261775061746828706172656E744766782C20706174684461746153657276696365312C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465';
wwv_flow_imp.g_varchar2_table(1387) := '725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A2020202020202020737472';
wwv_flow_imp.g_varchar2_table(1388) := '6F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C206174';
wwv_flow_imp.g_varchar2_table(1389) := '7472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A0A20202020202064726177436972636C6528706172656E744766782C2031302C2031302C207B0A202020202020202066696C6C3A2028';
wwv_flow_imp.g_varchar2_table(1390) := '302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C';
wwv_flow_imp.g_varchar2_table(1391) := '0A20202020202020207374726F6B653A20276E6F6E65272C0A20202020202020207472616E73666F726D3A20277472616E736C6174652831312C20313029270A2020202020207D293B0A0A20202020202076617220706174684461746153657276696365';
wwv_flow_imp.g_varchar2_table(1392) := '32203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F53455256494345272C207B0A2020202020202020616273706F733A207B0A20202020202020202020783A2031372C0A20202020202020202020793A2032320A';
wwv_flow_imp.g_varchar2_table(1393) := '20202020202020207D0A2020202020207D293B0A0A202020202020647261775061746828706172656E744766782C20706174684461746153657276696365322C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F';
wwv_flow_imp.g_varchar2_table(1394) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028';
wwv_flow_imp.g_varchar2_table(1395) := '302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374';
wwv_flow_imp.g_varchar2_table(1396) := '726F6B65292C0A20202020202020207374726F6B6557696474683A20310A2020202020207D293B0A0A20202020202072657475726E207461736B3B0A202020207D2C0A202020202762706D6E3A53746172744576656E74273A2066756E6374696F6E2870';
wwv_flow_imp.g_varchar2_table(1397) := '6172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A202020202020766172207B2072656E64657249636F6E203D2074727565207D203D2061747472733B0A0A2020202020206174747273203D207069636B41747472732861';
wwv_flow_imp.g_varchar2_table(1398) := '747472732C205B0A20202020202020202766696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A2020202020207661722073656D616E746963203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B';
wwv_flow_imp.g_varchar2_table(1399) := '5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928656C656D656E74293B0A0A202020202020696620282173656D616E7469632E67657428276973496E74657272757074696E67272929207B0A20202020';
wwv_flow_imp.g_varchar2_table(1400) := '202020206174747273203D207B0A202020202020202020202E2E2E61747472732C0A202020202020202020207374726F6B654461736861727261793A202736270A20202020202020207D3B0A2020202020207D0A0A202020202020766172206576656E74';
wwv_flow_imp.g_varchar2_table(1401) := '203D2072656E6465724576656E7428706172656E744766782C20656C656D656E742C206174747273293B0A0A2020202020206966202872656E64657249636F6E29207B0A202020202020202072656E6465724576656E7449636F6E28656C656D656E742C';
wwv_flow_imp.g_varchar2_table(1402) := '20706172656E744766782C206174747273293B0A2020202020207D0A0A20202020202072657475726E206576656E743B0A202020207D2C0A202020202762706D6E3A53756250726F63657373273A2066756E6374696F6E28706172656E744766782C2065';
wwv_flow_imp.g_varchar2_table(1403) := '6C656D656E742C206174747273203D207B7D29207B0A2020202020206966202828302C5F7574696C5F44695574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F31305F5F2E6973457870616E6465642928656C656D656E74292920';
wwv_flow_imp.g_varchar2_table(1404) := '7B0A20202020202020206174747273203D207069636B41747472732861747472732C205B0A202020202020202020202766696C6C272C0A20202020202020202020277374726F6B65272C0A20202020202020202020277769647468272C0A202020202020';
wwv_flow_imp.g_varchar2_table(1405) := '2020202027686569676874270A20202020202020205D293B0A2020202020207D20656C7365207B0A20202020202020206174747273203D207069636B41747472732861747472732C205B0A202020202020202020202766696C6C272C0A20202020202020';
wwv_flow_imp.g_varchar2_table(1406) := '202020277374726F6B65270A20202020202020205D293B0A2020202020207D0A0A20202020202072657475726E2072656E64657253756250726F6365737328706172656E744766782C20656C656D656E742C206174747273293B0A202020207D2C0A2020';
wwv_flow_imp.g_varchar2_table(1407) := '20202762706D6E3A5461736B273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A202020202020202027';
wwv_flow_imp.g_varchar2_table(1408) := '66696C6C272C0A2020202020202020277374726F6B65270A2020202020205D293B0A0A20202020202072657475726E2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B0A202020207D2C0A202020202762';
wwv_flow_imp.g_varchar2_table(1409) := '706D6E3A54657874416E6E6F746174696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A202020';
wwv_flow_imp.g_varchar2_table(1410) := '20202020202766696C6C272C0A2020202020202020277374726F6B65272C0A2020202020202020277769647468272C0A202020202020202027686569676874270A2020202020205D293B0A0A202020202020766172207B0A202020202020202077696474';
wwv_flow_imp.g_varchar2_table(1411) := '682C0A20202020202020206865696768740A2020202020207D203D2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574426F756E64732928656C656D656E742C2061747472';
wwv_flow_imp.g_varchar2_table(1412) := '73293B0A0A2020202020207661722074657874456C656D656E74203D20647261775265637428706172656E744766782C2077696474682C206865696768742C20302C20302C207B0A202020202020202066696C6C3A20276E6F6E65272C0A202020202020';
wwv_flow_imp.g_varchar2_table(1413) := '20207374726F6B653A20276E6F6E65270A2020202020207D293B0A0A20202020202076617220746578745061746844617461203D20706174684D61702E6765745363616C6564506174682827544558545F414E4E4F544154494F4E272C207B0A20202020';
wwv_flow_imp.g_varchar2_table(1414) := '20202020785363616C65466163746F723A20312C0A2020202020202020795363616C65466163746F723A20312C0A2020202020202020636F6E7461696E657257696474683A2077696474682C0A2020202020202020636F6E7461696E6572486569676874';
wwv_flow_imp.g_varchar2_table(1415) := '3A206865696768742C0A2020202020202020706F736974696F6E3A207B0A202020202020202020206D783A20302E302C0A202020202020202020206D793A20302E300A20202020202020207D0A2020202020207D293B0A0A202020202020647261775061';
wwv_flow_imp.g_varchar2_table(1416) := '746828706172656E744766782C207465787450617468446174612C207B0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574537472';
wwv_flow_imp.g_varchar2_table(1417) := '6F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A2020202020207D293B0A0A2020202020207661722073656D616E746963203D2028302C5F42706D6E52656E64657255';
wwv_flow_imp.g_varchar2_table(1418) := '74696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E676574427573696E6573734F626A6563742928656C656D656E74292C0A2020202020202020202074657874203D2073656D616E7469632E676574282774657874272920';
wwv_flow_imp.g_varchar2_table(1419) := '7C7C2027273B0A0A20202020202072656E6465724C6162656C28706172656E744766782C20746578742C207B0A2020202020202020616C69676E3A20276C6566742D746F70272C0A2020202020202020626F783A2028302C5F42706D6E52656E64657255';
wwv_flow_imp.g_varchar2_table(1420) := '74696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574426F756E64732928656C656D656E742C206174747273292C0A202020202020202070616464696E673A20372C0A20202020202020207374796C653A207B0A2020';
wwv_flow_imp.g_varchar2_table(1421) := '202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744C6162656C436F6C6F722928656C656D656E742C2064656661756C744C6162656C436F';
wwv_flow_imp.g_varchar2_table(1422) := '6C6F722C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65290A20202020202020207D0A2020202020207D293B0A0A20202020202072657475726E2074657874456C656D656E743B0A202020207D2C0A20202020276270';
wwv_flow_imp.g_varchar2_table(1423) := '6D6E3A5472616E73616374696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206966202828302C5F7574696C5F44695574696C5F5F5745425041434B5F494D504F52';
wwv_flow_imp.g_varchar2_table(1424) := '5445445F4D4F44554C455F31305F5F2E6973457870616E6465642928656C656D656E742929207B0A20202020202020206174747273203D207069636B41747472732861747472732C205B0A202020202020202020202766696C6C272C0A20202020202020';
wwv_flow_imp.g_varchar2_table(1425) := '202020277374726F6B65272C0A20202020202020202020277769647468272C0A2020202020202020202027686569676874270A20202020202020205D293B0A2020202020207D20656C7365207B0A20202020202020206174747273203D207069636B4174';
wwv_flow_imp.g_varchar2_table(1426) := '7472732861747472732C205B0A202020202020202020202766696C6C272C0A20202020202020202020277374726F6B65270A20202020202020205D293B0A2020202020207D0A0A202020202020766172206F75746572203D2072656E6465725375625072';
wwv_flow_imp.g_varchar2_table(1427) := '6F6365737328706172656E744766782C20656C656D656E742C207B0A20202020202020207374726F6B6557696474683A20312E352C0A20202020202020202E2E2E61747472730A2020202020207D293B0A0A20202020202076617220696E6E6572417474';
wwv_flow_imp.g_varchar2_table(1428) := '7273203D207374796C65732E7374796C65285B20276E6F2D66696C6C272C20276E6F2D6576656E747327205D2C207B0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(1429) := '5F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20312E350A202020';
wwv_flow_imp.g_varchar2_table(1430) := '2020207D293B0A0A20202020202076617220657870616E646564203D2028302C5F7574696C5F44695574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F31305F5F2E6973457870616E6465642928656C656D656E74293B0A0A2020';
wwv_flow_imp.g_varchar2_table(1431) := '202020206966202821657870616E64656429207B0A20202020202020206174747273203D207B7D3B0A2020202020207D0A0A2020202020206472617752656374280A2020202020202020706172656E744766782C0A202020202020202028302C5F42706D';
wwv_flow_imp.g_varchar2_table(1432) := '6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657457696474682928656C656D656E742C206174747273292C0A202020202020202028302C5F42706D6E52656E6465725574696C5F5F57454250';
wwv_flow_imp.g_varchar2_table(1433) := '41434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744865696768742928656C656D656E742C206174747273292C0A20202020202020205441534B5F424F524445525F524144495553202D20494E4E45525F4F555445525F444953542C0A20';
wwv_flow_imp.g_varchar2_table(1434) := '20202020202020494E4E45525F4F555445525F444953542C0A2020202020202020696E6E657241747472730A202020202020293B0A0A20202020202072657475726E206F757465723B0A202020207D2C0A202020202762706D6E3A557365725461736B27';
wwv_flow_imp.g_varchar2_table(1435) := '3A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020202020206174747273203D207069636B41747472732861747472732C205B0A20202020202020202766696C6C272C0A202020202020';
wwv_flow_imp.g_varchar2_table(1436) := '2020277374726F6B65270A2020202020205D293B0A0A202020202020766172207461736B203D2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B0A0A2020202020207661722078203D2031353B0A202020';
wwv_flow_imp.g_varchar2_table(1437) := '2020207661722079203D2031323B0A0A2020202020207661722070617468446174615573657231203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F555345525F31272C207B0A2020202020202020616273706F73';
wwv_flow_imp.g_varchar2_table(1438) := '3A207B0A20202020202020202020783A20782C0A20202020202020202020793A20790A20202020202020207D0A2020202020207D293B0A0A202020202020647261775061746828706172656E744766782C20706174684461746155736572312C207B0A20';
wwv_flow_imp.g_varchar2_table(1439) := '2020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F72';
wwv_flow_imp.g_varchar2_table(1440) := '2C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D65';
wwv_flow_imp.g_varchar2_table(1441) := '6E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20302E350A2020202020207D293B0A0A2020202020207661722070617468446174615573657232203D';
wwv_flow_imp.g_varchar2_table(1442) := '20706174684D61702E6765745363616C65645061746828275441534B5F545950455F555345525F32272C207B0A2020202020202020616273706F733A207B0A20202020202020202020783A20782C0A20202020202020202020793A20790A202020202020';
wwv_flow_imp.g_varchar2_table(1443) := '20207D0A2020202020207D293B0A0A202020202020647261775061746828706172656E744766782C20706174684461746155736572322C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F';
wwv_flow_imp.g_varchar2_table(1444) := '494D504F525445445F4D4F44554C455F325F5F2E67657446696C6C436F6C6F722928656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C0A20202020202020207374726F6B653A2028302C5F42706D6E5265';
wwv_flow_imp.g_varchar2_table(1445) := '6E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A2020';
wwv_flow_imp.g_varchar2_table(1446) := '2020202020207374726F6B6557696474683A20302E350A2020202020207D293B0A0A2020202020207661722070617468446174615573657233203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F555345525F3327';
wwv_flow_imp.g_varchar2_table(1447) := '2C207B0A2020202020202020616273706F733A207B0A20202020202020202020783A20782C0A20202020202020202020793A20790A20202020202020207D0A2020202020207D293B0A0A202020202020647261775061746828706172656E744766782C20';
wwv_flow_imp.g_varchar2_table(1448) := '706174684461746155736572332C207B0A202020202020202066696C6C3A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765745374726F6B65436F6C6F722928656C656D65';
wwv_flow_imp.g_varchar2_table(1449) := '6E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B653A2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F32';
wwv_flow_imp.g_varchar2_table(1450) := '5F5F2E6765745374726F6B65436F6C6F722928656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C0A20202020202020207374726F6B6557696474683A20302E350A2020202020207D293B0A0A20';
wwv_flow_imp.g_varchar2_table(1451) := '202020202072657475726E207461736B3B0A202020207D2C0A20202020276C6162656C273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A20202020202072657475726E2072656E646572';
wwv_flow_imp.g_varchar2_table(1452) := '45787465726E616C4C6162656C28706172656E744766782C20656C656D656E742C206174747273293B0A202020207D0A20207D3B0A0A20202F2F20657874656E73696F6E204150492C2075736520617420796F7572206F776E207269736B0A2020746869';
wwv_flow_imp.g_varchar2_table(1453) := '732E5F6472617750617468203D2064726177506174683B0A0A2020746869732E5F72656E6465726572203D2072656E64657265723B0A7D0A0A0A28302C696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(1454) := '4C455F31315F5F5B2264656661756C74225D292842706D6E52656E64657265722C206469616772616D5F6A735F6C69625F647261775F4261736552656E64657265725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B22646566';
wwv_flow_imp.g_varchar2_table(1455) := '61756C74225D293B0A0A42706D6E52656E64657265722E24696E6A656374203D205B0A202027636F6E6669672E62706D6E52656E6465726572272C0A2020276576656E74427573272C0A2020277374796C6573272C0A202027706174684D6170272C0A20';
wwv_flow_imp.g_varchar2_table(1456) := '202763616E766173272C0A2020277465787452656E6465726572270A5D3B0A0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A42706D6E52656E';
wwv_flow_imp.g_varchar2_table(1457) := '64657265722E70726F746F747970652E63616E52656E646572203D2066756E6374696F6E28656C656D656E7429207B0A202072657475726E2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C45';
wwv_flow_imp.g_varchar2_table(1458) := '5F385F5F2E69732928656C656D656E742C202762706D6E3A42617365456C656D656E7427293B0A7D3B0A0A2F2A2A0A202A204472617720736861706520696E746F20706172656E744766782E0A202A0A202A2040706172616D207B535647456C656D656E';
wwv_flow_imp.g_varchar2_table(1459) := '747D20706172656E744766780A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A2040706172616D207B41747472737D205B61747472735D0A202A0A202A204072657475726E207B535647456C656D656E747D206D61696E4766';
wwv_flow_imp.g_varchar2_table(1460) := '780A202A2F0A42706D6E52656E64657265722E70726F746F747970652E647261775368617065203D2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020766172207B2074797065207D203D';
wwv_flow_imp.g_varchar2_table(1461) := '20656C656D656E743B0A0A20207661722068616E646C6572203D20746869732E5F72656E64657265722874797065293B0A0A202072657475726E2068616E646C657228706172656E744766782C20656C656D656E742C206174747273293B0A7D3B0A0A2F';
wwv_flow_imp.g_varchar2_table(1462) := '2A2A0A202A204472617720636F6E6E656374696F6E20696E746F20706172656E744766782E0A202A0A202A2040706172616D207B535647456C656D656E747D20706172656E744766780A202A2040706172616D207B456C656D656E747D20656C656D656E';
wwv_flow_imp.g_varchar2_table(1463) := '740A202A2040706172616D207B41747472737D205B61747472735D0A202A0A202A204072657475726E207B535647456C656D656E747D206D61696E4766780A202A2F0A42706D6E52656E64657265722E70726F746F747970652E64726177436F6E6E6563';
wwv_flow_imp.g_varchar2_table(1464) := '74696F6E203D2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B0A2020766172207B2074797065207D203D20656C656D656E743B0A0A20207661722068616E646C6572203D20746869732E5F72';
wwv_flow_imp.g_varchar2_table(1465) := '656E64657265722874797065293B0A0A202072657475726E2068616E646C657228706172656E744766782C20656C656D656E742C206174747273293B0A7D3B0A0A2F2A2A0A202A2047657420736861706520706174682E0A202A0A202A2040706172616D';
wwv_flow_imp.g_varchar2_table(1466) := '207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B737472696E677D20706174680A202A2F0A42706D6E52656E64657265722E70726F746F747970652E676574536861706550617468203D2066756E6374696F6E28656C';
wwv_flow_imp.g_varchar2_table(1467) := '656D656E7429207B0A20206966202828302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E69732928656C656D656E742C202762706D6E3A4576656E74272929207B0A20202020726574';
wwv_flow_imp.g_varchar2_table(1468) := '75726E2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574436972636C65506174682928656C656D656E74293B0A20207D0A0A20206966202828302C5F42706D6E52656E64';
wwv_flow_imp.g_varchar2_table(1469) := '65725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E69732928656C656D656E742C202762706D6E3A4163746976697479272929207B0A2020202072657475726E2028302C5F42706D6E52656E6465725574696C5F5F';
wwv_flow_imp.g_varchar2_table(1470) := '5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574526F756E6452656374506174682928656C656D656E742C205441534B5F424F524445525F524144495553293B0A20207D0A0A20206966202828302C5F42706D6E52656E6465';
wwv_flow_imp.g_varchar2_table(1471) := '725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F2E69732928656C656D656E742C202762706D6E3A47617465776179272929207B0A2020202072657475726E2028302C5F42706D6E52656E6465725574696C5F5F5745';
wwv_flow_imp.g_varchar2_table(1472) := '425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6765744469616D6F6E64506174682928656C656D656E74293B0A20207D0A0A202072657475726E2028302C5F42706D6E52656E6465725574696C5F5F5745425041434B5F494D504F5254';
wwv_flow_imp.g_varchar2_table(1473) := '45445F4D4F44554C455F325F5F2E67657452656374506174682928656C656D656E74293B0A7D3B0A0A2F2A2A0A202A205069636B206174747269627574657320696620746865792065786973742E0A202A0A202A2040706172616D207B4F626A6563747D';
wwv_flow_imp.g_varchar2_table(1474) := '2061747472730A202A2040706172616D207B737472696E675B5D7D206B6579730A202A0A202A204072657475726E73207B4F626A6563747D0A202A2F0A66756E6374696F6E207069636B41747472732861747472732C206B657973203D205B5D29207B0A';
wwv_flow_imp.g_varchar2_table(1475) := '202072657475726E206B6579732E72656475636528287069636B656441747472732C206B657929203D3E207B0A202020206966202861747472735B206B6579205D29207B0A2020202020207069636B656441747472735B206B6579205D203D2061747472';
wwv_flow_imp.g_varchar2_table(1476) := '735B206B6579205D3B0A202020207D0A0A2020202072657475726E207069636B656441747472733B0A20207D2C207B7D293B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F64';
wwv_flow_imp.g_varchar2_table(1477) := '7261772F506174684D61702E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E';
wwv_flow_imp.g_varchar2_table(1478) := '2D6A732F6C69622F647261772F506174684D61702E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E75736564';
wwv_flow_imp.g_varchar2_table(1479) := '5F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F657870';
wwv_flow_imp.g_varchar2_table(1480) := '6F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264';
wwv_flow_imp.g_varchar2_table(1481) := '656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F20506174684D6170290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2A0A202A204D617020636F6E7461696E696E6720535647207061746873206E656564';
wwv_flow_imp.g_varchar2_table(1482) := '65642062792042706D6E52656E64657265720A202A2F0A66756E6374696F6E20506174684D61702829207B0A0A20202F2A2A0A2020202A20436F6E7461696E732061206D6170206F66207061746820656C656D656E74730A2020202A0A2020202A203C68';
wwv_flow_imp.g_varchar2_table(1483) := '313E5061746820646566696E6974696F6E3C2F68313E0A2020202A204120706172616D65746572697A6564207061746820697320646566696E6564206C696B6520746869733A0A2020202A203C7072653E0A2020202A2027474154455741595F50415241';
wwv_flow_imp.g_varchar2_table(1484) := '4C4C454C273A207B0A2020202A202020643A20276D207B6D787D2C7B6D797D207B652E78307D2C3020302C7B652E78317D207B652E78317D2C3020302C7B652E79307D202D7B652E78317D2C3020302C7B652E79317D2027202B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(1485) := '20272D7B652E78307D2C3020302C2D7B652E79317D202D7B652E78317D2C3020302C2D7B652E79307D207B652E78317D2C30207A272C0A2020202A2020206865696768743A2031372E352C0A2020202A20202077696474683A202031372E352C0A202020';
wwv_flow_imp.g_varchar2_table(1486) := '2A202020686569676874456C656D656E74733A205B322E352C20372E355D2C0A2020202A2020207769647468456C656D656E74733A205B322E352C20372E355D0A2020202A207D0A2020202A203C2F7072653E0A2020202A203C703E4974277320696D70';
wwv_flow_imp.g_varchar2_table(1487) := '6F7274616E7420746F2073706563696679206120636F7272656374203C623E68656967687420616E642077696474683C2F623E20666F7220746865207061746820617320746865207363616C696E670A2020202A206973206261736564206F6E20746865';
wwv_flow_imp.g_varchar2_table(1488) := '20726174696F206265747765656E20746865207370656369666965642068656967687420616E6420776964746820696E2074686973206F626A65637420616E64207468650A2020202A2068656967687420616E6420776964746820746861742069732073';
wwv_flow_imp.g_varchar2_table(1489) := '6574206173207363616C652074617267657420284E6F746520782C7920636F6F7264696E617465732077696C6C206265207363616C656420776974680A2020202A20696E646976696475616C20726174696F73292E3C2F703E0A2020202A203C703E5468';
wwv_flow_imp.g_varchar2_table(1490) := '6520273C623E686569676874456C656D656E74733C2F623E2720616E6420273C623E7769647468456C656D656E74733C2F623E27206172726179206D75737420636F6E7461696E207468652076616C75657320746861742077696C6C206265207363616C';
wwv_flow_imp.g_varchar2_table(1491) := '65642E0A2020202A20546865207363616C696E67206973206261736564206F6E2074686520636F6D707574656420726174696F732E0A2020202A20436F6F7264696E61746573206F6E20746865207920617869732073686F756C6420626520696E207468';
wwv_flow_imp.g_varchar2_table(1492) := '65203C623E686569676874456C656D656E743C2F623E27732061727261792C20746865792077696C6C206265207363616C6564207573696E670A2020202A2074686520636F6D707574656420726174696F20636F656666696369656E742E0A2020202A20';
wwv_flow_imp.g_varchar2_table(1493) := '496E2074686520706172616D65746572697A6564207061746820746865207363616C65642076616C7565732063616E206265206163636573736564207468726F7567682074686520276527206F626A65637420696E207B7D20627261636B6574732E0A20';
wwv_flow_imp.g_varchar2_table(1494) := '20202A2020203C756C3E0A2020202A202020203C6C693E5468652076616C75657320666F7220746865207920617869732063616E20626520616363657373656420696E20746865207061746820737472696E67207573696E67207B652E79307D2C207B65';
wwv_flow_imp.g_varchar2_table(1495) := '2E79317D2C202E2E2E2E3C2F6C693E0A2020202A202020203C6C693E5468652076616C75657320666F7220746865207820617869732063616E20626520616363657373656420696E20746865207061746820737472696E67207573696E67207B652E7830';
wwv_flow_imp.g_varchar2_table(1496) := '7D2C207B652E78317D2C202E2E2E2E3C2F6C693E0A2020202A2020203C2F756C3E0A2020202A202020546865206E756D626572732078302C20783120726573706563746976656C792079302C2079312C202E2E2E206D617020746F2074686520636F7272';
wwv_flow_imp.g_varchar2_table(1497) := '6573706F6E64696E6720617272617920696E6465782E0A2020202A203C2F703E0A2020202A2F0A2020746869732E706174684D6170203D207B0A20202020274556454E545F4D455353414745273A207B0A202020202020643A20276D207B6D787D2C7B6D';
wwv_flow_imp.g_varchar2_table(1498) := '797D206C20302C7B652E79317D206C207B652E78317D2C30206C20302C2D7B652E79317D207A206C207B652E78307D2C7B652E79307D206C207B652E78307D2C2D7B652E79307D272C0A2020202020206865696768743A2033362C0A2020202020207769';
wwv_flow_imp.g_varchar2_table(1499) := '6474683A202033362C0A202020202020686569676874456C656D656E74733A205B20362C203134205D2C0A2020202020207769647468456C656D656E74733A205B2031302E352C203231205D0A202020207D2C0A20202020274556454E545F5349474E41';
wwv_flow_imp.g_varchar2_table(1500) := '4C273A207B0A202020202020643A20274D207B6D787D2C7B6D797D206C207B652E78307D2C7B652E79307D206C202D7B652E78317D2C30205A272C0A2020202020206865696768743A2033362C0A20202020202077696474683A2033362C0A2020202020';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(1501) := '20686569676874456C656D656E74733A205B203138205D2C0A2020202020207769647468456C656D656E74733A205B2031302C203230205D0A202020207D2C0A20202020274556454E545F455343414C4154494F4E273A207B0A202020202020643A2027';
wwv_flow_imp.g_varchar2_table(1502) := '4D207B6D787D2C7B6D797D206C207B652E78307D2C7B652E79307D206C202D7B652E78307D2C2D7B652E79317D206C202D7B652E78307D2C7B652E79317D205A272C0A2020202020206865696768743A2033362C0A20202020202077696474683A203336';
wwv_flow_imp.g_varchar2_table(1503) := '2C0A202020202020686569676874456C656D656E74733A205B2032302C2037205D2C0A2020202020207769647468456C656D656E74733A205B2038205D0A202020207D2C0A20202020274556454E545F434F4E444954494F4E414C273A207B0A20202020';
wwv_flow_imp.g_varchar2_table(1504) := '2020643A20274D207B652E78307D2C7B652E79307D206C207B652E78317D2C30206C20302C7B652E79327D206C202D7B652E78317D2C30205A2027202B0A202020202020202020274D207B652E78327D2C7B652E79337D206C207B652E78307D2C302027';
wwv_flow_imp.g_varchar2_table(1505) := '202B0A202020202020202020274D207B652E78327D2C7B652E79347D206C207B652E78307D2C302027202B0A202020202020202020274D207B652E78327D2C7B652E79357D206C207B652E78307D2C302027202B0A202020202020202020274D207B652E';
wwv_flow_imp.g_varchar2_table(1506) := '78327D2C7B652E79367D206C207B652E78307D2C302027202B0A202020202020202020274D207B652E78327D2C7B652E79377D206C207B652E78307D2C302027202B0A202020202020202020274D207B652E78327D2C7B652E79387D206C207B652E7830';
wwv_flow_imp.g_varchar2_table(1507) := '7D2C3020272C0A2020202020206865696768743A2033362C0A20202020202077696474683A202033362C0A202020202020686569676874456C656D656E74733A205B20382E352C2031342E352C2031382C2031312E352C2031342E352C2031372E352C20';
wwv_flow_imp.g_varchar2_table(1508) := '32302E352C2032332E352C2032362E35205D2C0A2020202020207769647468456C656D656E74733A20205B2031302E352C2031342E352C2031322E35205D0A202020207D2C0A20202020274556454E545F4C494E4B273A207B0A202020202020643A2027';
wwv_flow_imp.g_varchar2_table(1509) := '6D207B6D787D2C7B6D797D20302C7B652E79307D202D7B652E78317D2C3020302C7B652E79317D207B652E78317D2C3020302C7B652E79307D207B652E78307D2C2D7B652E79327D202D7B652E78307D2C2D7B652E79327D207A272C0A20202020202068';
wwv_flow_imp.g_varchar2_table(1510) := '65696768743A2033362C0A20202020202077696474683A2033362C0A202020202020686569676874456C656D656E74733A205B20342E343337352C20362E37352C20372E38313235205D2C0A2020202020207769647468456C656D656E74733A205B2039';
wwv_flow_imp.g_varchar2_table(1511) := '2E38343337352C2031332E35205D0A202020207D2C0A20202020274556454E545F4552524F52273A207B0A202020202020643A20276D207B6D787D2C7B6D797D207B652E78307D2C2D7B652E79307D207B652E78317D2C2D7B652E79317D207B652E7832';
wwv_flow_imp.g_varchar2_table(1512) := '7D2C7B652E79327D207B652E78337D2C2D7B652E79337D202D7B652E78347D2C7B652E79347D202D7B652E78357D2C2D7B652E79357D207A272C0A2020202020206865696768743A2033362C0A20202020202077696474683A2033362C0A202020202020';
wwv_flow_imp.g_varchar2_table(1513) := '686569676874456C656D656E74733A205B20302E3032332C20382E3733372C20382E3135312C2031362E3536342C2031302E3539312C20382E373134205D2C0A2020202020207769647468456C656D656E74733A205B20302E3038352C20362E3637322C';
wwv_flow_imp.g_varchar2_table(1514) := '20362E39372C20342E3237332C20352E3333372C20362E363336205D0A202020207D2C0A20202020274556454E545F43414E43454C5F3435273A207B0A202020202020643A20276D207B6D787D2C7B6D797D202D7B652E78317D2C3020302C7B652E7830';
wwv_flow_imp.g_varchar2_table(1515) := '7D207B652E78317D2C3020302C7B652E79317D207B652E78307D2C302027202B0A202020202020202027302C2D7B652E79317D207B652E78317D2C3020302C2D7B652E79307D202D7B652E78317D2C3020302C2D7B652E79317D202D7B652E78307D2C30';
wwv_flow_imp.g_varchar2_table(1516) := '207A272C0A2020202020206865696768743A2033362C0A20202020202077696474683A2033362C0A202020202020686569676874456C656D656E74733A205B20342E37352C20382E35205D2C0A2020202020207769647468456C656D656E74733A205B20';
wwv_flow_imp.g_varchar2_table(1517) := '342E37352C20382E35205D0A202020207D2C0A20202020274556454E545F434F4D50454E534154494F4E273A207B0A202020202020643A20276D207B6D787D2C7B6D797D207B652E78307D2C2D7B652E79307D20302C7B652E79317D207A206D207B652E';
wwv_flow_imp.g_varchar2_table(1518) := '78317D2C2D7B652E79327D207B652E78327D2C2D7B652E79337D20302C7B652E79317D202D7B652E78327D2C2D7B652E79337D207A272C0A2020202020206865696768743A2033362C0A20202020202077696474683A2033362C0A202020202020686569';
wwv_flow_imp.g_varchar2_table(1519) := '676874456C656D656E74733A205B20362E352C2031332C20302E342C20362E31205D2C0A2020202020207769647468456C656D656E74733A205B20392C20392E332C20382E37205D0A202020207D2C0A20202020274556454E545F54494D45525F574827';
wwv_flow_imp.g_varchar2_table(1520) := '3A207B0A202020202020643A20274D207B6D787D2C7B6D797D206C207B652E78307D2C2D7B652E79307D206D202D7B652E78307D2C7B652E79307D206C207B652E78317D2C7B652E79317D20272C0A2020202020206865696768743A2033362C0A202020';
wwv_flow_imp.g_varchar2_table(1521) := '20202077696474683A202033362C0A202020202020686569676874456C656D656E74733A205B2031302C2032205D2C0A2020202020207769647468456C656D656E74733A205B20332C2037205D0A202020207D2C0A20202020274556454E545F54494D45';
wwv_flow_imp.g_varchar2_table(1522) := '525F4C494E45273A207B0A202020202020643A2020274D207B6D787D2C7B6D797D2027202B0A20202020202020202020276D207B652E78307D2C7B652E79307D206C202D7B652E78317D2C7B652E79317D20272C0A2020202020206865696768743A2033';
wwv_flow_imp.g_varchar2_table(1523) := '362C0A20202020202077696474683A202033362C0A202020202020686569676874456C656D656E74733A205B2031302C2033205D2C0A2020202020207769647468456C656D656E74733A205B20302C2030205D0A202020207D2C0A20202020274556454E';
wwv_flow_imp.g_varchar2_table(1524) := '545F4D554C5449504C45273A207B0A202020202020643A276D207B6D787D2C7B6D797D207B652E78317D2C2D7B652E79307D207B652E78317D2C7B652E79307D202D7B652E78307D2C7B652E79317D202D7B652E78327D2C30207A272C0A202020202020';
wwv_flow_imp.g_varchar2_table(1525) := '6865696768743A2033362C0A20202020202077696474683A202033362C0A202020202020686569676874456C656D656E74733A205B20362E32383039392C2031322E3536313939205D2C0A2020202020207769647468456C656D656E74733A205B20332E';
wwv_flow_imp.g_varchar2_table(1526) := '313430352C20392E34323134392C2031322E3536313938205D0A202020207D2C0A20202020274556454E545F504152414C4C454C5F4D554C5449504C45273A207B0A202020202020643A276D207B6D787D2C7B6D797D207B652E78307D2C3020302C7B65';
wwv_flow_imp.g_varchar2_table(1527) := '2E79317D207B652E78317D2C3020302C7B652E79307D202D7B652E78317D2C3020302C7B652E79317D2027202B0A2020202020202020272D7B652E78307D2C3020302C2D7B652E79317D202D7B652E78317D2C3020302C2D7B652E79307D207B652E7831';
wwv_flow_imp.g_varchar2_table(1528) := '7D2C30207A272C0A2020202020206865696768743A2033362C0A20202020202077696474683A202033362C0A202020202020686569676874456C656D656E74733A205B20322E35363232382C20372E3638363833205D2C0A202020202020776964746845';
wwv_flow_imp.g_varchar2_table(1529) := '6C656D656E74733A205B20322E35363232382C20372E3638363833205D0A202020207D2C0A2020202027474154455741595F4558434C5553495645273A207B0A202020202020643A276D207B6D787D2C7B6D797D207B652E78307D2C7B652E79307D207B';
wwv_flow_imp.g_varchar2_table(1530) := '652E78317D2C7B652E79307D207B652E78327D2C30207B652E78347D2C7B652E79327D2027202B0A2020202020202020202020202020202020202020277B652E78347D2C7B652E79317D207B652E78327D2C30207B652E78317D2C7B652E79337D207B65';
wwv_flow_imp.g_varchar2_table(1531) := '2E78307D2C7B652E79337D2027202B0A2020202020202020202020202020202020202020277B652E78337D2C30207B652E78357D2C7B652E79317D207B652E78357D2C7B652E79327D207B652E78337D2C30207A272C0A2020202020206865696768743A';
wwv_flow_imp.g_varchar2_table(1532) := '2031372E352C0A20202020202077696474683A202031372E352C0A202020202020686569676874456C656D656E74733A205B20382E352C20362E353331322C202D362E353331322C202D382E35205D2C0A2020202020207769647468456C656D656E7473';
wwv_flow_imp.g_varchar2_table(1533) := '3A20205B20362E352C202D362E352C20332C202D332C20352C202D35205D0A202020207D2C0A2020202027474154455741595F504152414C4C454C273A207B0A202020202020643A276D207B6D787D2C7B6D797D20302C7B652E79317D202D7B652E7831';
wwv_flow_imp.g_varchar2_table(1534) := '7D2C3020302C7B652E79307D207B652E78317D2C3020302C7B652E79317D207B652E78307D2C302027202B0A202020202020202027302C2D7B652E79317D207B652E78317D2C3020302C2D7B652E79307D202D7B652E78317D2C3020302C2D7B652E7931';
wwv_flow_imp.g_varchar2_table(1535) := '7D202D7B652E78307D2C30207A272C0A2020202020206865696768743A2033302C0A20202020202077696474683A202033302C0A202020202020686569676874456C656D656E74733A205B20352C2031322E35205D2C0A2020202020207769647468456C';
wwv_flow_imp.g_varchar2_table(1536) := '656D656E74733A205B20352C2031322E35205D0A202020207D2C0A2020202027474154455741595F4556454E545F4241534544273A207B0A202020202020643A276D207B6D787D2C7B6D797D207B652E78307D2C7B652E79307D207B652E78307D2C7B65';
wwv_flow_imp.g_varchar2_table(1537) := '2E79317D207B652E78317D2C7B652E79327D207B652E78327D2C30207A272C0A2020202020206865696768743A2031312C0A20202020202077696474683A202031312C0A202020202020686569676874456C656D656E74733A205B202D362C20362C2031';
wwv_flow_imp.g_varchar2_table(1538) := '322C202D3132205D2C0A2020202020207769647468456C656D656E74733A205B20392C202D332C202D3132205D0A202020207D2C0A2020202027474154455741595F434F4D504C4558273A207B0A202020202020643A276D207B6D787D2C7B6D797D2030';
wwv_flow_imp.g_varchar2_table(1539) := '2C7B652E79307D202D7B652E78307D2C2D7B652E79317D202D7B652E78317D2C7B652E79327D207B652E78307D2C7B652E79317D202D7B652E78327D2C3020302C7B652E79337D2027202B0A2020202020202020277B652E78327D2C3020202D7B652E78';
wwv_flow_imp.g_varchar2_table(1540) := '307D2C7B652E79317D206C207B652E78317D2C7B652E79327D207B652E78307D2C2D7B652E79317D20302C7B652E79307D207B652E78337D2C3020302C2D7B652E79307D207B652E78307D2C7B652E79317D2027202B0A2020202020202020277B652E78';
wwv_flow_imp.g_varchar2_table(1541) := '317D2C2D7B652E79327D202D7B652E78307D2C2D7B652E79317D207B652E78327D2C3020302C2D7B652E79337D202D7B652E78327D2C30207B652E78307D2C2D7B652E79317D202D7B652E78317D2C2D7B652E79327D2027202B0A202020202020202027';
wwv_flow_imp.g_varchar2_table(1542) := '2D7B652E78307D2C7B652E79317D20302C2D7B652E79307D202D7B652E78337D2C30207A272C0A2020202020206865696768743A2031372E3132352C0A20202020202077696474683A202031372E3132352C0A202020202020686569676874456C656D65';
wwv_flow_imp.g_varchar2_table(1543) := '6E74733A205B20342E3837352C20332E343337352C20322E3132352C2033205D2C0A2020202020207769647468456C656D656E74733A205B20332E343337352C20322E3132352C20342E3837352C2033205D0A202020207D2C0A2020202027444154415F';
wwv_flow_imp.g_varchar2_table(1544) := '4F424A4543545F50415448273A207B0A202020202020643A276D20302C30207B652E78317D2C30207B652E78307D2C7B652E79307D20302C7B652E79317D202D7B652E78327D2C3020302C2D7B652E79327D207B652E78317D2C3020302C7B652E79307D';
wwv_flow_imp.g_varchar2_table(1545) := '207B652E78307D2C30272C0A2020202020206865696768743A2036312C0A20202020202077696474683A202035312C0A202020202020686569676874456C656D656E74733A205B2031302C2035302C203630205D2C0A2020202020207769647468456C65';
wwv_flow_imp.g_varchar2_table(1546) := '6D656E74733A205B2031302C2034302C2035302C203630205D0A202020207D2C0A2020202027444154415F4F424A4543545F434F4C4C454354494F4E5F50415448273A207B0A202020202020643A20276D7B6D787D2C7B6D797D206D20332C32206C2030';
wwv_flow_imp.g_varchar2_table(1547) := '2C3130206D20332C2D3130206C20302C3130206D20332C2D3130206C20302C3130272C0A2020202020206865696768743A2031302C0A20202020202077696474683A2031302C0A202020202020686569676874456C656D656E74733A205B5D2C0A202020';
wwv_flow_imp.g_varchar2_table(1548) := '2020207769647468456C656D656E74733A205B5D0A202020207D2C0A2020202027444154415F4152524F57273A207B0A202020202020643A276D20352C3920392C3020302C2D3320352C35202D352C3520302C2D33202D392C30207A272C0A2020202020';
wwv_flow_imp.g_varchar2_table(1549) := '206865696768743A2036312C0A20202020202077696474683A202035312C0A202020202020686569676874456C656D656E74733A205B5D2C0A2020202020207769647468456C656D656E74733A205B5D0A202020207D2C0A2020202027444154415F5354';
wwv_flow_imp.g_varchar2_table(1550) := '4F5245273A207B0A202020202020643A276D20207B6D787D2C7B6D797D2027202B0A2020202020202020276C2020302C7B652E79327D2027202B0A2020202020202020276320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D2020';
wwv_flow_imp.g_varchar2_table(1551) := '7B652E78327D2C302027202B0A2020202020202020276C2020302C2D7B652E79327D2027202B0A20202020202020202763202D7B652E78307D2C2D7B652E79317D202D7B652E78317D2C2D7B652E79317D202D7B652E78327D2C3027202B0A2020202020';
wwv_flow_imp.g_varchar2_table(1552) := '202020276320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D20207B652E78327D2C302027202B0A2020202020202020276D20202D7B652E78327D2C7B652E79307D27202B0A2020202020202020276320207B652E78307D2C7B65';
wwv_flow_imp.g_varchar2_table(1553) := '2E79317D207B652E78317D2C7B652E79317D207B652E78327D2C3027202B0A2020202020202020276D20202D7B652E78327D2C7B652E79307D27202B0A2020202020202020276320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D';
wwv_flow_imp.g_varchar2_table(1554) := '20207B652E78327D2C30272C0A2020202020206865696768743A2036312C0A20202020202077696474683A202036312C0A202020202020686569676874456C656D656E74733A205B20372C2031302C203435205D2C0A2020202020207769647468456C65';
wwv_flow_imp.g_varchar2_table(1555) := '6D656E74733A20205B20322C2035382C203630205D0A202020207D2C0A2020202027544558545F414E4E4F544154494F4E273A207B0A202020202020643A20276D207B6D787D2C207B6D797D206D2031302C30206C202D31302C30206C20302C7B652E79';
wwv_flow_imp.g_varchar2_table(1556) := '307D206C2031302C30272C0A2020202020206865696768743A2033302C0A20202020202077696474683A2031302C0A202020202020686569676874456C656D656E74733A205B203330205D2C0A2020202020207769647468456C656D656E74733A205B20';
wwv_flow_imp.g_varchar2_table(1557) := '3130205D0A202020207D2C0A20202020274D41524B45525F5355425F50524F43455353273A207B0A202020202020643A20276D7B6D787D2C7B6D797D206D20372C32206C20302C3130206D202D352C2D35206C2031302C30272C0A202020202020686569';
wwv_flow_imp.g_varchar2_table(1558) := '6768743A2031302C0A20202020202077696474683A2031302C0A202020202020686569676874456C656D656E74733A205B5D2C0A2020202020207769647468456C656D656E74733A205B5D0A202020207D2C0A20202020274D41524B45525F504152414C';
wwv_flow_imp.g_varchar2_table(1559) := '4C454C273A207B0A202020202020643A20276D7B6D787D2C7B6D797D206D20332C32206C20302C3130206D20332C2D3130206C20302C3130206D20332C2D3130206C20302C3130272C0A2020202020206865696768743A2031302C0A2020202020207769';
wwv_flow_imp.g_varchar2_table(1560) := '6474683A2031302C0A202020202020686569676874456C656D656E74733A205B5D2C0A2020202020207769647468456C656D656E74733A205B5D0A202020207D2C0A20202020274D41524B45525F53455155454E5449414C273A207B0A20202020202064';
wwv_flow_imp.g_varchar2_table(1561) := '3A20276D7B6D787D2C7B6D797D206D20302C33206C2031302C30206D202D31302C33206C2031302C30206D202D31302C33206C2031302C30272C0A2020202020206865696768743A2031302C0A20202020202077696474683A2031302C0A202020202020';
wwv_flow_imp.g_varchar2_table(1562) := '686569676874456C656D656E74733A205B5D2C0A2020202020207769647468456C656D656E74733A205B5D0A202020207D2C0A20202020274D41524B45525F434F4D50454E534154494F4E273A207B0A202020202020643A20276D207B6D787D2C7B6D79';
wwv_flow_imp.g_varchar2_table(1563) := '7D20372C2D3520302C3130207A206D20372E312C2D302E3320362E392C2D342E3720302C3130202D362E392C2D342E37207A272C0A2020202020206865696768743A2031302C0A20202020202077696474683A2032312C0A202020202020686569676874';
wwv_flow_imp.g_varchar2_table(1564) := '456C656D656E74733A205B5D2C0A2020202020207769647468456C656D656E74733A205B5D0A202020207D2C0A20202020274D41524B45525F4C4F4F50273A207B0A202020202020643A20276D207B6D787D2C7B6D797D206320332E3532363937392C30';
wwv_flow_imp.g_varchar2_table(1565) := '20362E3338363136312C2D322E38323938353820362E3338363136312C2D362E33323036363120302C2D332E343930383036202D322E3835393138322C2D362E3332303636312027202B0A2020202020202020272D362E3338363136312C2D362E333230';
wwv_flow_imp.g_varchar2_table(1566) := '363631202D332E3532363937382C30202D362E33383631362C322E383239383535202D362E33383631362C362E33323036363120302C312E3734353430322027202B0A202020202020202027302E3731343739372C332E33323535363720312E38373034';
wwv_flow_imp.g_varchar2_table(1567) := '36332C342E34363933383120302E3537373833342C302E35373139303820312E3236353838352C312E30333437323820322E3032393931362C312E33353435372027202B0A2020202020202020276C202D302E3731383136332C2D332E39303937393320';
wwv_flow_imp.g_varchar2_table(1568) := '6D20302E3731383136332C332E393039373933202D332E3838353231312C302E383032393032272C0A2020202020206865696768743A2031332E392C0A20202020202077696474683A2031332E372C0A202020202020686569676874456C656D656E7473';
wwv_flow_imp.g_varchar2_table(1569) := '3A205B5D2C0A2020202020207769647468456C656D656E74733A205B5D0A202020207D2C0A20202020274D41524B45525F4144484F43273A207B0A202020202020643A20276D207B6D787D2C7B6D797D206D20302E38343436312C322E36343431312063';
wwv_flow_imp.g_varchar2_table(1570) := '20312E30353533332C2D312E323337383039393620322E36343333372C2D322E303738383220342E32393635332C2D312E393739393739393620322E30353136332C302E303830352027202B0A202020202020202027332E38353537392C312E31353830';
wwv_flow_imp.g_varchar2_table(1571) := '3320352E37363038322C312E373931303720312E30363338352C302E333431333939393620322E32343435342C302E3134333820332E31383735392C2D302E343337363720302E36313734332C2D302E33333634322027202B0A20202020202020202731';
wwv_flow_imp.g_varchar2_table(1572) := '2E323737352C2D302E363430373820312E373534322C2D312E313735313120302C302E353630323320302C312E313230343620302C312E36383037202D302E39383730362C302E3936323337393936202D322E32393739322C312E363233393339393620';
wwv_flow_imp.g_varchar2_table(1573) := '27202B0A2020202020202020272D332E363931382C312E3636313831393936202D312E32343435392C302E30393237202D322E34363637312C2D302E32343931202D332E35393530352C2D302E3734383132202D312E33353738392C2D302E3535393635';
wwv_flow_imp.g_varchar2_table(1574) := '2027202B0A2020202020202020272D322E37353133332C2D312E3333343336393936202D342E32373032372C2D312E3138313231393936202D312E33373734312C302E3134363031202D322E34313834322C312E3133363835393936202D332E34343238';
wwv_flow_imp.g_varchar2_table(1575) := '382C312E3936373832393936207A272C0A2020202020206865696768743A20342C0A20202020202077696474683A2031352C0A202020202020686569676874456C656D656E74733A205B5D2C0A2020202020207769647468456C656D656E74733A205B5D';
wwv_flow_imp.g_varchar2_table(1576) := '0A202020207D2C0A20202020275441534B5F545950455F53454E44273A207B0A202020202020643A20276D207B6D787D2C7B6D797D206C20302C7B652E79317D206C207B652E78317D2C30206C20302C2D7B652E79317D207A206C207B652E78307D2C7B';
wwv_flow_imp.g_varchar2_table(1577) := '652E79307D206C207B652E78307D2C2D7B652E79307D272C0A2020202020206865696768743A2031342C0A20202020202077696474683A202032312C0A202020202020686569676874456C656D656E74733A205B20362C203134205D2C0A202020202020';
wwv_flow_imp.g_varchar2_table(1578) := '7769647468456C656D656E74733A205B2031302E352C203231205D0A202020207D2C0A20202020275441534B5F545950455F534352495054273A207B0A202020202020643A20276D207B6D787D2C7B6D797D206320392E3936363535332C2D362E323732';
wwv_flow_imp.g_varchar2_table(1579) := '3736202D382E3030303932362C2D372E393139333220322E3936383936382C2D31342E393338206C202D382E3830323732382C302027202B0A20202020202020202763202D31302E3936393839342C372E303138363820362E3939373538352C382E3636';
wwv_flow_imp.g_varchar2_table(1580) := '353234202D322E3936383936372C31342E393338207A2027202B0A2020202020202020276D202D372C2D3132206C20352C302027202B0A2020202020202020276D202D342E352C33206C20342E352C302027202B0A2020202020202020276D202D332C33';
wwv_flow_imp.g_varchar2_table(1581) := '206C20352C3027202B0A2020202020202020276D202D342C33206C20352C30272C0A2020202020206865696768743A2031352C0A20202020202077696474683A202031322E362C0A202020202020686569676874456C656D656E74733A205B20362C2031';
wwv_flow_imp.g_varchar2_table(1582) := '34205D2C0A2020202020207769647468456C656D656E74733A205B2031302E352C203231205D0A202020207D2C0A20202020275441534B5F545950455F555345525F31273A207B0A202020202020643A20276D207B6D787D2C7B6D797D206320302E3930';
wwv_flow_imp.g_varchar2_table(1583) := '392C2D302E38343520312E3539342C2D322E30343920312E3539342C2D332E33383520302C2D322E353534202D312E3830352C2D342E36323139393939392027202B0A2020202020202020272D342E3335372C2D342E3632313939393939202D322E3535';
wwv_flow_imp.g_varchar2_table(1584) := '3139393939382C30202D342E32383739393939382C322E3036373939393939202D342E32383739393939382C342E363231393939393920302C312E3334382027202B0A202020202020202027302E3937342C322E35363220312E38393539393939382C33';
wwv_flow_imp.g_varchar2_table(1585) := '2E343035202D302E35323839393939382C302E313837202D352E3636392C322E303937202D352E3739342C342E37353630303035207620362E3731382027202B0A202020202020202027682031372076202D362E373138206320302C2D322E3239383030';
wwv_flow_imp.g_varchar2_table(1586) := '3035202D352E353237393939362C2D342E35393530303035202D362E303530393939362C2D342E37373630303035207A27202B0A2020202020202020276D202D382C36206C20302C352E35206D2031312C30206C20302C2D35270A202020207D2C0A2020';
wwv_flow_imp.g_varchar2_table(1587) := '2020275441534B5F545950455F555345525F32273A207B0A202020202020643A20276D207B6D787D2C7B6D797D206D20322E3136322C312E303039206320302C322E34343730303035202D322E3135382C342E34333130303035202D342E3832312C342E';
wwv_flow_imp.g_varchar2_table(1588) := '343331303030352027202B0A2020202020202020272D322E36363439393939382C30202D342E3832322C2D312E393831202D342E3832322C2D342E3433313030303520270A202020207D2C0A20202020275441534B5F545950455F555345525F33273A20';
wwv_flow_imp.g_varchar2_table(1589) := '7B0A202020202020643A20276D207B6D787D2C7B6D797D206D202D362E392C2D332E3830206320302C3020322E32353039393939382C2D322E33353820342E32373339393939382C2D312E31373720322E3032342C312E31383120342E3232312C312E35';
wwv_flow_imp.g_varchar2_table(1590) := '33372027202B0A202020202020202027342E3132342C302E393635202D302E3039382C2D302E3537202D302E3131372C2D332E3739303939393939202D342E3139312C2D342E3133353939393939202D332E35373439393939382C302E3030312027202B';
wwv_flow_imp.g_varchar2_table(1591) := '0A2020202020202020272D342E32303739393939382C332E3336363939393939202D342E32303639393939382C342E3334373939393939207A270A202020207D2C0A20202020275441534B5F545950455F4D414E55414C273A207B0A202020202020643A';
wwv_flow_imp.g_varchar2_table(1592) := '20276D207B6D787D2C7B6D797D206320302E3233342C2D302E303120352E3630342C302E30303820382E3032392C302E30303420302E3830382C3020312E3237312C2D302E31373220312E3431372C2D302E37353220302E3232372C2D302E3839382027';
wwv_flow_imp.g_varchar2_table(1593) := '202B0A2020202020202020272D302E3333342C2D312E333134202D312E3333382C2D312E333136202D322E3436372C2D302E3031202D372E3838362C2D302E303034202D382E3130382C2D302E303034202D302E3031342C2D302E30373920302E303136';
wwv_flow_imp.g_varchar2_table(1594) := '2C2D302E35333320302C2D302E36312027202B0A202020202020202027302E3139352C2D302E30343220382E3530372C302E30303620392E3631362C302E30303220302E3837372C2D302E30303720312E33352C2D302E34333820312E3335332C2D312E';
wwv_flow_imp.g_varchar2_table(1595) := '32303820302E3030332C2D302E373638202D302E3437392C2D312E30392027202B0A2020202020202020272D312E33352C2D312E303931202D322E3936382C2D302E303032202D392E3631392C2D302E303133202D392E3631392C2D302E303133207620';
wwv_flow_imp.g_varchar2_table(1596) := '2D302E353931206320302C3020352E3035322C2D302E30313620372E3232352C2D302E3031362027202B0A202020202020202027302E3838382C2D302E30303220312E3335342C2D302E34313620312E3335312C2D312E313933202D302E3030362C2D30';
wwv_flow_imp.g_varchar2_table(1597) := '2E373631202D302E3439322C2D312E313936202D312E3336312C2D312E313936202D332E3437332C2D302E3030352027202B0A2020202020202020272D31302E38362C2D302E303033202D31312E303832393939352C2D302E303033202D302E3032322C';
wwv_flow_imp.g_varchar2_table(1598) := '2D302E303437202D302E3034352C2D302E303934202D302E3036392C2D302E31333920302E333933393939352C2D302E3331392027202B0A202020202020202027322E303430393939352C2D312E36323620322E343134393939352C2D322E3031372030';
wwv_flow_imp.g_varchar2_table(1599) := '2E3436392C2D302E3438373030303520302E3531392C2D312E3136353030303520302E3136322C2D312E36303430303035202D302E3431342C2D302E3531312027202B0A2020202020202020272D302E3937332C2D302E35202D312E34382C2D302E3233';
wwv_flow_imp.g_varchar2_table(1600) := '36202D312E343630393939352C302E373634202D362E353939393939352C332E36343330303035202D372E373332393939352C342E32373130303035202D302E392C302E3439392027202B0A2020202020202020272D312E3531362C312E323533202D31';
wwv_flow_imp.g_varchar2_table(1601) := '2E3838322C322E3139202D302E33373030303030322C302E3935202D302E31372C322E3031202D302E3136362C322E39373920302E3030342C302E373138202D302E32373330303030322C312E3334352027202B0A2020202020202020272D302E303535';
wwv_flow_imp.g_varchar2_table(1602) := '2C322E30363320302E3632392C322E30383720322E3432352C332E33313220342E3835392C332E33313820342E363137393939352C302E30313420392E323337393939352C2D302E3133392031332E383536393939352C2D302E3135382027202B0A2020';
wwv_flow_imp.g_varchar2_table(1603) := '20202020202027302E3735352C2D302E30303420312E3137312C2D302E33303120312E3138322C2D312E30333320302E3031322C2D302E373534202D302E3432332C2D302E393639202D312E3138332C2D302E393733202D312E3737382C2D302E303120';
wwv_flow_imp.g_varchar2_table(1604) := '27202B0A2020202020202020272D352E3832342C2D302E303034202D362E30342C2D302E303034203130652D342C2D302E30383420302E3030332C2D302E353836203130652D342C2D302E3637207A270A202020207D2C0A20202020275441534B5F5459';
wwv_flow_imp.g_varchar2_table(1605) := '50455F494E5354414E54494154494E475F53454E44273A207B0A202020202020643A20276D207B6D787D2C7B6D797D206C20302C382E34206C2031322E362C30206C20302C2D382E34207A206C20362E332C332E36206C20362E332C2D332E36270A2020';
wwv_flow_imp.g_varchar2_table(1606) := '20207D2C0A20202020275441534B5F545950455F53455256494345273A207B0A202020202020643A20276D207B6D787D2C7B6D797D2076202D312E3731333335206320302E3335323332362C2D302E3037303520302E3730333933322C2D302E31373833';
wwv_flow_imp.g_varchar2_table(1607) := '3820312E3034373632382C2D302E33323133332027202B0A202020202020202027302E3334343431362C2D302E313434363520302E3636353832322C2D302E333231333320302E3936363337372C2D302E3532313435206C20312E31393433312C312E31';
wwv_flow_imp.g_varchar2_table(1608) := '3830303520312E3536373438372C2D312E35373638382027202B0A2020202020202020272D312E3139353032382C2D312E3138303134206320302E3430333337362C2D302E363133393420302E3638333037392C2D312E323939303820302E3832353434';
wwv_flow_imp.g_varchar2_table(1609) := '372C2D322E3031383234206C20312E3632323133332C2D302E30312027202B0A20202020202020202776202D322E32313936206C202D312E3633363531342C302E30312063202D302E30373333332C2D302E3335313533202D302E3137383331392C2D30';
wwv_flow_imp.g_varchar2_table(1610) := '2E3730303234202D302E3332333536342C2D312E30343337322027202B0A2020202020202020272D302E3134353234342C2D302E3334343036202D302E3332313430372C2D302E36363434202D302E3532323733352C2D302E3936323137206C20312E31';
wwv_flow_imp.g_varchar2_table(1611) := '33313033352C2D312E3133363331202D312E3538333330352C2D312E35363239332027202B0A2020202020202020272D312E3132393539382C312E31333538392063202D302E3631343035322C2D302E3430313038202D312E3330323838332C2D302E36';
wwv_flow_imp.g_varchar2_table(1612) := '38303933202D322E3032323633332C2D302E3832323437206C20302E303039332C2D312E36313835322027202B0A20202020202020202768202D322E323431313733206C20302E303034322C312E36333132342063202D302E3335333736332C302E3037';
wwv_flow_imp.g_varchar2_table(1613) := '3336202D302E3730353336392C302E3137393737202D312E3034393738352C302E3332333731202D302E3334343431352C302E31343433372027202B0A2020202020202020272D302E3636353130322C302E3332303932202D302E393633353030362C30';
wwv_flow_imp.g_varchar2_table(1614) := '2E3532303436206C202D312E313639383632382C2D312E3135383233202D312E353636373639312C312E3537393220312E313638343236352C312E31353636392027202B0A20202020202020202763202D302E343032363537332C302E3631323833202D';
wwv_flow_imp.g_varchar2_table(1615) := '302E36383330382C312E3239373937202D302E383234373238372C322E3031373133206C202D312E363538383034312C302E303033207620322E32323137342027202B0A2020202020202020276C20312E363732343634382C2D302E303036206320302E';
wwv_flow_imp.g_varchar2_table(1616) := '3037333332372C302E333530373720302E313739373539382C302E373032343320302E333234323835312C312E303434373220302E313435323432382C302E33343434382027202B0A202020202020202027302E333231343036342C302E363634342030';
wwv_flow_imp.g_varchar2_table(1617) := '2E353232373333392C302E3936303636206C202D312E313939333433312C312E313937323320312E353834303235362C312E353630313120312E313936343636382C2D312E31393334382027202B0A2020202020202020276320302E363134303531372C';
wwv_flow_imp.g_varchar2_table(1618) := '302E343033343620312E333032383832372C302E363832333220322E303233333531372C302E3832333331206C20372E3139652D342C312E3639383932206820322E323236383438207A2027202B0A2020202020202020276D20302E3232313436322C2D';
wwv_flow_imp.g_varchar2_table(1619) := '332E393935372063202D312E3738383934382C302E37353032202D332E383537362C2D302E30393238202D342E363039373035352C2D312E3837343338202D302E373532313036352C2D312E37383332312027202B0A202020202020202027302E303930';
wwv_flow_imp.g_varchar2_table(1620) := '3539382C2D332E383436323720312E383830323634352C2D342E353936303420312E37383832332C2D302E373439333620332E3835363838312C302E3039323920342E3630383938372C312E38373433372027202B0A202020202020202027302E373532';
wwv_flow_imp.g_varchar2_table(1621) := '3130362C312E3738313635202D302E303930362C332E3834363132202D312E3837393534362C342E3539363035207A270A202020207D2C0A20202020275441534B5F545950455F534552564943455F46494C4C273A207B0A202020202020643A20276D20';
wwv_flow_imp.g_varchar2_table(1622) := '7B6D787D2C7B6D797D2063202D312E3738383934382C302E37353032202D332E383537362C2D302E30393238202D342E363039373035352C2D312E3837343338202D302E373532313036352C2D312E37383332312027202B0A202020202020202027302E';
wwv_flow_imp.g_varchar2_table(1623) := '3039303539382C2D332E383436323720312E383830323634352C2D342E353936303420312E37383832332C2D302E373439333620332E3835363838312C302E3039323920342E3630383938372C312E38373433372027202B0A202020202020202027302E';
wwv_flow_imp.g_varchar2_table(1624) := '3735323130362C312E3738313635202D302E303930362C332E3834363132202D312E3837393534362C342E3539363035207A270A202020207D2C0A20202020275441534B5F545950455F425553494E4553535F52554C455F484541444552273A207B0A20';
wwv_flow_imp.g_varchar2_table(1625) := '2020202020643A20276D207B6D787D2C7B6D797D20302C342032302C3020302C2D34207A270A202020207D2C0A20202020275441534B5F545950455F425553494E4553535F52554C455F4D41494E273A207B0A202020202020643A20276D207B6D787D2C';
wwv_flow_imp.g_varchar2_table(1626) := '7B6D797D20302C31322032302C3020302C2D3132207A27202B0A2020202020202020276D20302C38206C2032302C302027202B0A2020202020202020276D202D31332C2D34206C20302C38270A202020207D2C0A20202020274D4553534147455F464C4F';
wwv_flow_imp.g_varchar2_table(1627) := '575F4D41524B4552273A207B0A202020202020643A20276D207B6D787D2C7B6D797D206D202D31302E35202C2D37206C20302C3134206C2032312C30206C20302C2D3134207A206C2031302E352C36206C2031302E352C2D36270A202020207D0A20207D';
wwv_flow_imp.g_varchar2_table(1628) := '3B0A0A20202F2A2A0A2020202A2052657475726E20726177207061746820666F722074686520676976656E2049442E0A2020202A0A2020202A2040706172616D207B737472696E677D207061746849640A2020202A0A2020202A204072657475726E207B';
wwv_flow_imp.g_varchar2_table(1629) := '737472696E677D2072617720706174680A2020202A2F0A2020746869732E67657452617750617468203D2066756E6374696F6E20676574526177506174682870617468496429207B0A2020202072657475726E20746869732E706174684D61705B706174';
wwv_flow_imp.g_varchar2_table(1630) := '6849645D2E643B0A20207D3B0A0A20202F2A2A0A2020202A205363616C657320746865207061746820746F2074686520676976656E2068656967687420616E642077696474682E0A2020202A203C68313E55736520636173653C2F68313E0A2020202A20';
wwv_flow_imp.g_varchar2_table(1631) := '3C703E557365206361736520697320746F207363616C652074686520636F6E74656E74206F6620656C656D656E747320286576656E742C206761746577617973292062617365640A2020202A206F6E2074686520656C656D656E7420626F756E64696E67';
wwv_flow_imp.g_varchar2_table(1632) := '20626F7827732073697A652E0A2020202A203C2F703E0A2020202A203C68313E576879206E6F74207472616E73666F726D3C2F68313E0A2020202A203C703E5363616C696E67206120706174682077697468207472616E73666F726D28292077696C6C20';
wwv_flow_imp.g_varchar2_table(1633) := '616C736F207363616C6520746865207374726F6B6520616E6420494520646F6573206E6F7420737570706F72740A2020202A20746865206F7074696F6E20276E6F6E2D7363616C696E672D7374726F6B652720746F2070726576656E7420746869732E0A';
wwv_flow_imp.g_varchar2_table(1634) := '2020202A20416C736F2074686572652061726520757365206361736573207768657265206F6E6C7920736F6D65207061727473206F66206120706174682073686F756C642062650A2020202A207363616C65642E3C2F703E0A2020202A0A2020202A2040';
wwv_flow_imp.g_varchar2_table(1635) := '706172616D207B737472696E677D2070617468496420546865204944206F662074686520706174682E0A2020202A2040706172616D207B4F626A6563747D20706172616D203C703E0A2020202A2020204578616D706C6520706172616D206F626A656374';
wwv_flow_imp.g_varchar2_table(1636) := '207363616C657320746865207061746820746F203630252073697A65206F662074686520636F6E7461696E65722028646174612E77696474682C20646174612E686569676874292E0A2020202A2020203C7072653E0A2020202A2020207B0A2020202A20';
wwv_flow_imp.g_varchar2_table(1637) := '20202020785363616C65466163746F723A20302E362C0A2020202A2020202020795363616C65466163746F723A302E362C0A2020202A2020202020636F6E7461696E657257696474683A20646174612E77696474682C0A2020202A2020202020636F6E74';
wwv_flow_imp.g_varchar2_table(1638) := '61696E65724865696768743A20646174612E6865696768742C0A2020202A2020202020706F736974696F6E3A207B0A2020202A202020202020206D783A20302E34362C0A2020202A202020202020206D793A20302E322C0A2020202A20202020207D0A20';
wwv_flow_imp.g_varchar2_table(1639) := '20202A2020207D0A2020202A2020203C2F7072653E0A2020202A2020203C756C3E0A2020202A202020203C6C693E746172676574706174687769647468203D20785363616C65466163746F72202A20636F6E7461696E657257696474683C2F6C693E0A20';
wwv_flow_imp.g_varchar2_table(1640) := '20202A202020203C6C693E74617267657470617468686569676874203D20795363616C65466163746F72202A20636F6E7461696E65724865696768743C2F6C693E0A2020202A202020203C6C693E506F736974696F6E206973207573656420746F207365';
wwv_flow_imp.g_varchar2_table(1641) := '7420746865207374617274696E6720636F6F7264696E617465206F662074686520706174682E204D20697320636F6D70757465643A0A202020202A202020203C756C3E0A202020202A2020202020203C6C693E706F736974696F6E2E78202A20636F6E74';
wwv_flow_imp.g_varchar2_table(1642) := '61696E657257696474683C2F6C693E0A202020202A2020202020203C6C693E706F736974696F6E2E79202A20636F6E7461696E65724865696768743C2F6C693E0A202020202A202020203C2F756C3E0A202020202A2020202043656E746572206F662074';
wwv_flow_imp.g_varchar2_table(1643) := '686520636F6E7461696E6572203C7072653E20706F736974696F6E3A207B0A2020202A202020202020206D783A20302E352C0A2020202A202020202020206D793A20302E352C0A2020202A20202020207D3C2F7072653E0A2020202A2020202020557070';
wwv_flow_imp.g_varchar2_table(1644) := '6572206C65667420636F726E6572206F662074686520636F6E7461696E65720A2020202A20202020203C7072653E20706F736974696F6E3A207B0A2020202A202020202020206D783A20302E302C0A2020202A202020202020206D793A20302E302C0A20';
wwv_flow_imp.g_varchar2_table(1645) := '20202A20202020207D3C2F7072653E0A2020202A202020203C2F6C693E0A2020202A2020203C2F756C3E0A2020202A203C2F703E0A2020202A0A2020202A204072657475726E207B737472696E677D207363616C656420706174680A2020202A2F0A2020';
wwv_flow_imp.g_varchar2_table(1646) := '746869732E6765745363616C656450617468203D2066756E6374696F6E206765745363616C656450617468287061746849642C20706172616D29207B0A202020207661722072617750617468203D20746869732E706174684D61705B7061746849645D3B';
wwv_flow_imp.g_varchar2_table(1647) := '0A0A202020202F2F20706F736974696F6E696E670A202020202F2F20636F6D707574652074686520737461727420706F696E74206F662074686520706174680A20202020766172206D782C206D793B0A0A2020202069662028706172616D2E616273706F';
wwv_flow_imp.g_varchar2_table(1648) := '7329207B0A2020202020206D78203D20706172616D2E616273706F732E783B0A2020202020206D79203D20706172616D2E616273706F732E793B0A202020207D20656C7365207B0A2020202020206D78203D20706172616D2E636F6E7461696E65725769';
wwv_flow_imp.g_varchar2_table(1649) := '647468202A20706172616D2E706F736974696F6E2E6D783B0A2020202020206D79203D20706172616D2E636F6E7461696E6572486569676874202A20706172616D2E706F736974696F6E2E6D793B0A202020207D0A0A2020202076617220636F6F726469';
wwv_flow_imp.g_varchar2_table(1650) := '6E61746573203D207B7D3B202F2F206D617020666F7220746865207363616C656420636F6F7264696E617465730A2020202069662028706172616D2E706F736974696F6E29207B0A0A2020202020202F2F20706174680A20202020202076617220686569';
wwv_flow_imp.g_varchar2_table(1651) := '676874526174696F203D2028706172616D2E636F6E7461696E6572486569676874202F20726177506174682E68656967687429202A20706172616D2E795363616C65466163746F723B0A202020202020766172207769647468526174696F203D20287061';
wwv_flow_imp.g_varchar2_table(1652) := '72616D2E636F6E7461696E65725769647468202F20726177506174682E776964746829202A20706172616D2E785363616C65466163746F723B0A0A0A2020202020202F2F204170706C792068656967687420726174696F0A202020202020666F72202876';
wwv_flow_imp.g_varchar2_table(1653) := '617220686569676874496E646578203D20303B20686569676874496E646578203C20726177506174682E686569676874456C656D656E74732E6C656E6774683B20686569676874496E6465782B2B29207B0A2020202020202020636F6F7264696E617465';
wwv_flow_imp.g_varchar2_table(1654) := '735B277927202B20686569676874496E6465785D203D20726177506174682E686569676874456C656D656E74735B686569676874496E6465785D202A20686569676874526174696F3B0A2020202020207D0A0A2020202020202F2F204170706C79207769';
wwv_flow_imp.g_varchar2_table(1655) := '64746820726174696F0A202020202020666F722028766172207769647468496E646578203D20303B207769647468496E646578203C20726177506174682E7769647468456C656D656E74732E6C656E6774683B207769647468496E6465782B2B29207B0A';
wwv_flow_imp.g_varchar2_table(1656) := '2020202020202020636F6F7264696E617465735B277827202B207769647468496E6465785D203D20726177506174682E7769647468456C656D656E74735B7769647468496E6465785D202A207769647468526174696F3B0A2020202020207D0A20202020';
wwv_flow_imp.g_varchar2_table(1657) := '7D0A0A202020202F2F204170706C792076616C756520746F2072617720706174680A202020207661722070617468203D20666F726D6174280A202020202020726177506174682E642C207B0A20202020202020206D783A206D782C0A2020202020202020';
wwv_flow_imp.g_varchar2_table(1658) := '6D793A206D792C0A2020202020202020653A20636F6F7264696E617465730A2020202020207D0A20202020293B0A2020202072657475726E20706174683B0A20207D3B0A7D0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F';
wwv_flow_imp.g_varchar2_table(1659) := '2F2F2F2F0A0A2F2F20636F7069656420616E642061646A75737465642066726F6D2068747470733A2F2F6769746875622E636F6D2F61646F62652D776562706C6174666F726D2F536E61702E7376672F626C6F622F6D61737465722F7372632F7376672E';
wwv_flow_imp.g_varchar2_table(1660) := '6A730A76617220746F6B656E5265676578203D202F5C7B285B5E7B7D5D2B295C7D2F672C0A202020206F626A4E6F746174696F6E5265676578203D202F283F3A283F3A5E7C5C2E29282E2B3F29283F3D5C5B7C5C2E7C247C5C28297C5C5B28277C222928';
wwv_flow_imp.g_varchar2_table(1661) := '2E2B3F295C325C5D29285C285C29293F2F673B202F2F206D617463686573202E7878787878206F72205B227878787878225D20746F2072756E206F766572206F626A6563742070726F706572746965730A0A66756E6374696F6E207265706C6163657228';
wwv_flow_imp.g_varchar2_table(1662) := '616C6C2C206B65792C206F626A29207B0A202076617220726573203D206F626A3B0A20206B65792E7265706C616365286F626A4E6F746174696F6E52656765782C2066756E6374696F6E28616C6C2C206E616D652C2071756F74652C2071756F7465644E';
wwv_flow_imp.g_varchar2_table(1663) := '616D652C20697346756E6329207B0A202020206E616D65203D206E616D65207C7C2071756F7465644E616D653B0A202020206966202872657329207B0A202020202020696620286E616D6520696E2072657329207B0A2020202020202020726573203D20';
wwv_flow_imp.g_varchar2_table(1664) := '7265735B6E616D655D3B0A2020202020207D0A202020202020747970656F6620726573203D3D202766756E6374696F6E2720262620697346756E632026262028726573203D207265732829293B0A202020207D0A20207D293B0A2020726573203D202872';
wwv_flow_imp.g_varchar2_table(1665) := '6573203D3D206E756C6C207C7C20726573203D3D206F626A203F20616C6C203A2072657329202B2027273B0A0A202072657475726E207265733B0A7D0A0A66756E6374696F6E20666F726D6174287374722C206F626A29207B0A202072657475726E2053';
wwv_flow_imp.g_varchar2_table(1666) := '7472696E6728737472292E7265706C61636528746F6B656E52656765782C2066756E6374696F6E28616C6C2C206B657929207B0A2020202072657475726E207265706C6163657228616C6C2C206B65792C206F626A293B0A20207D293B0A7D0A0A0A2F2A';
wwv_flow_imp.g_varchar2_table(1667) := '2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F5465787452656E64657265722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(1668) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F5465787452656E64657265722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(1669) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F';
wwv_flow_imp.g_varchar2_table(1670) := '2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F77656270';
wwv_flow_imp.g_varchar2_table(1671) := '61636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F20546578745265';
wwv_flow_imp.g_varchar2_table(1672) := '6E6465726572290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F';
wwv_flow_imp.g_varchar2_table(1673) := '7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F';
wwv_flow_imp.g_varchar2_table(1674) := '20766172206469616772616D5F6A735F6C69625F7574696C5F546578745F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F';
wwv_flow_imp.g_varchar2_table(1675) := '7574696C2F54657874202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F546578742E6A7322293B0A0A0A0A0A7661722044454641554C545F464F4E545F53495A45203D2031323B0A766172204C494E45';
wwv_flow_imp.g_varchar2_table(1676) := '5F4845494748545F524154494F203D20312E323B0A0A766172204D494E5F544558545F414E4E4F544154494F4E5F484549474854203D2033303B0A0A2F2A2A0A202A204074797065646566207B207B0A202A202020666F6E7446616D696C793A20737472';
wwv_flow_imp.g_varchar2_table(1677) := '696E673B0A202A202020666F6E7453697A653A206E756D6265723B0A202A202020666F6E745765696768743A20737472696E673B0A202A2020206C696E654865696768743A206E756D6265723B0A202A207D207D205465787452656E6465726572537479';
wwv_flow_imp.g_varchar2_table(1678) := '6C650A202A0A202A204074797065646566207B207B0A202A20202064656661756C745374796C653F3A205061727469616C3C5465787452656E64657265725374796C653E3B0A202A20202065787465726E616C5374796C653F3A205061727469616C3C54';
wwv_flow_imp.g_varchar2_table(1679) := '65787452656E64657265725374796C653E3B0A202A207D207D205465787452656E6465726572436F6E6669670A202A0A202A204074797065646566207B20696D706F727428276469616772616D2D6A732F6C69622F7574696C2F5465787427292E546578';
wwv_flow_imp.g_varchar2_table(1680) := '744C61796F7574436F6E666967207D20546578744C61796F7574436F6E6669670A202A0A202A204074797065646566207B20696D706F727428276469616772616D2D6A732F6C69622F7574696C2F547970657327292E52656374207D20526563740A202A';
wwv_flow_imp.g_varchar2_table(1681) := '2F0A0A0A2F2A2A0A202A2052656E64657273207465787420616E6420636F6D7075746573207465787420626F756E64696E6720626F7865732E0A202A0A202A2040706172616D207B5465787452656E6465726572436F6E6669677D205B636F6E6669675D';
wwv_flow_imp.g_varchar2_table(1682) := '0A202A2F0A66756E6374696F6E205465787452656E646572657228636F6E66696729207B0A0A20207661722064656661756C745374796C65203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E';
wwv_flow_imp.g_varchar2_table(1683) := '61737369676E29287B0A20202020666F6E7446616D696C793A2027417269616C2C2073616E732D7365726966272C0A20202020666F6E7453697A653A2044454641554C545F464F4E545F53495A452C0A20202020666F6E745765696768743A20276E6F72';
wwv_flow_imp.g_varchar2_table(1684) := '6D616C272C0A202020206C696E654865696768743A204C494E455F4845494748545F524154494F0A20207D2C20636F6E66696720262620636F6E6669672E64656661756C745374796C65207C7C207B7D293B0A0A202076617220666F6E7453697A65203D';
wwv_flow_imp.g_varchar2_table(1685) := '207061727365496E742864656661756C745374796C652E666F6E7453697A652C20313029202D20313B0A0A20207661722065787465726E616C5374796C65203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(1686) := '455F305F5F2E61737369676E29287B7D2C2064656661756C745374796C652C207B0A20202020666F6E7453697A653A20666F6E7453697A650A20207D2C20636F6E66696720262620636F6E6669672E65787465726E616C5374796C65207C7C207B7D293B';
wwv_flow_imp.g_varchar2_table(1687) := '0A0A202076617220746578745574696C203D206E6577206469616772616D5F6A735F6C69625F7574696C5F546578745F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D287B0A202020207374796C653A';
wwv_flow_imp.g_varchar2_table(1688) := '2064656661756C745374796C650A20207D293B0A0A20202F2A2A0A2020202A2047657420746865206E657720626F756E6473206F6620616E2065787465726E616C6C792072656E64657265642C0A2020202A206C61796F75746564206C6162656C2E0A20';
wwv_flow_imp.g_varchar2_table(1689) := '20202A0A2020202A2040706172616D207B526563747D20626F756E64730A2020202A2040706172616D207B737472696E677D20746578740A2020202A0A2020202A204072657475726E207B526563747D0A2020202A2F0A2020746869732E676574457874';
wwv_flow_imp.g_varchar2_table(1690) := '65726E616C4C6162656C426F756E6473203D2066756E6374696F6E28626F756E64732C207465787429207B0A0A20202020766172206C61796F7574656444696D656E73696F6E73203D20746578745574696C2E67657444696D656E73696F6E7328746578';
wwv_flow_imp.g_varchar2_table(1691) := '742C207B0A202020202020626F783A207B0A202020202020202077696474683A2039302C0A20202020202020206865696768743A2033300A2020202020207D2C0A2020202020207374796C653A2065787465726E616C5374796C650A202020207D293B0A';
wwv_flow_imp.g_varchar2_table(1692) := '0A202020202F2F20726573697A65206C6162656C20736861706520746F20666974206C6162656C20746578740A2020202072657475726E207B0A202020202020783A204D6174682E726F756E6428626F756E64732E78202B20626F756E64732E77696474';
wwv_flow_imp.g_varchar2_table(1693) := '68202F2032202D206C61796F7574656444696D656E73696F6E732E7769647468202F2032292C0A202020202020793A204D6174682E726F756E6428626F756E64732E79292C0A20202020202077696474683A204D6174682E6365696C286C61796F757465';
wwv_flow_imp.g_varchar2_table(1694) := '6444696D656E73696F6E732E7769647468292C0A2020202020206865696768743A204D6174682E6365696C286C61796F7574656444696D656E73696F6E732E686569676874290A202020207D3B0A0A20207D3B0A0A20202F2A2A0A2020202A2047657420';
wwv_flow_imp.g_varchar2_table(1695) := '746865206E657720626F756E6473206F66207465787420616E6E6F746174696F6E2E0A2020202A0A2020202A2040706172616D207B526563747D20626F756E64730A2020202A2040706172616D207B737472696E677D20746578740A2020202A0A202020';
wwv_flow_imp.g_varchar2_table(1696) := '2A204072657475726E207B526563747D0A2020202A2F0A2020746869732E67657454657874416E6E6F746174696F6E426F756E6473203D2066756E6374696F6E28626F756E64732C207465787429207B0A0A20202020766172206C61796F757465644469';
wwv_flow_imp.g_varchar2_table(1697) := '6D656E73696F6E73203D20746578745574696C2E67657444696D656E73696F6E7328746578742C207B0A202020202020626F783A20626F756E64732C0A2020202020207374796C653A2064656661756C745374796C652C0A202020202020616C69676E3A';
wwv_flow_imp.g_varchar2_table(1698) := '20276C6566742D746F70272C0A20202020202070616464696E673A20350A202020207D293B0A0A2020202072657475726E207B0A202020202020783A20626F756E64732E782C0A202020202020793A20626F756E64732E792C0A20202020202077696474';
wwv_flow_imp.g_varchar2_table(1699) := '683A20626F756E64732E77696474682C0A2020202020206865696768743A204D6174682E6D6178284D494E5F544558545F414E4E4F544154494F4E5F4845494748542C204D6174682E726F756E64286C61796F7574656444696D656E73696F6E732E6865';
wwv_flow_imp.g_varchar2_table(1700) := '6967687429290A202020207D3B0A20207D3B0A0A20202F2A2A0A2020202A204372656174652061206C61796F75746564207465787420656C656D656E742E0A2020202A0A2020202A2040706172616D207B737472696E677D20746578740A2020202A2040';
wwv_flow_imp.g_varchar2_table(1701) := '706172616D207B546578744C61796F7574436F6E6669677D205B6F7074696F6E735D0A2020202A0A2020202A204072657475726E207B535647456C656D656E747D2072656E646572656420746578740A2020202A2F0A2020746869732E63726561746554';
wwv_flow_imp.g_varchar2_table(1702) := '657874203D2066756E6374696F6E28746578742C206F7074696F6E7329207B0A2020202072657475726E20746578745574696C2E6372656174655465787428746578742C206F7074696F6E73207C7C207B7D293B0A20207D3B0A0A20202F2A2A0A202020';
wwv_flow_imp.g_varchar2_table(1703) := '2A204765742064656661756C742074657874207374796C652E0A2020202A2F0A2020746869732E67657444656661756C745374796C65203D2066756E6374696F6E2829207B0A2020202072657475726E2064656661756C745374796C653B0A20207D3B0A';
wwv_flow_imp.g_varchar2_table(1704) := '0A20202F2A2A0A2020202A20476574207468652065787465726E616C2074657874207374796C652E0A2020202A2F0A2020746869732E67657445787465726E616C5374796C65203D2066756E6374696F6E2829207B0A2020202072657475726E20657874';
wwv_flow_imp.g_varchar2_table(1705) := '65726E616C5374796C653B0A20207D3B0A0A7D0A0A5465787452656E64657265722E24696E6A656374203D205B0A202027636F6E6669672E7465787452656E6465726572270A5D3B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D';
wwv_flow_imp.g_varchar2_table(1706) := '6F64756C65732F62706D6E2D6A732F6C69622F647261772F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E';
wwv_flow_imp.g_varchar2_table(1707) := '6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A';
wwv_flow_imp.g_varchar2_table(1708) := '2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F';
wwv_flow_imp.g_varchar2_table(1709) := '5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578';
wwv_flow_imp.g_varchar2_table(1710) := '706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A';
wwv_flow_imp.g_varchar2_table(1711) := '2F20766172205F42706D6E52656E64657265725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F42706D6E52656E6465726572202A2F20222E2F6E6F6465';
wwv_flow_imp.g_varchar2_table(1712) := '5F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F42706D6E52656E64657265722E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F5465787452656E64657265725F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(1713) := '445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F5465787452656E6465726572202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F5465787452656E646572';
wwv_flow_imp.g_varchar2_table(1714) := '65722E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F506174684D61705F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F';
wwv_flow_imp.g_varchar2_table(1715) := '506174684D6170202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F506174684D61702E6A7322293B0A0A0A0A0A0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F';
wwv_flow_imp.g_varchar2_table(1716) := '5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F696E69745F5F3A205B202762706D6E52656E646572657227205D2C0A202062706D6E52656E64657265723A205B202774797065272C205F42706D6E52656E64657265';
wwv_flow_imp.g_varchar2_table(1717) := '725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D205D2C0A20207465787452656E64657265723A205B202774797065272C205F5465787452656E64657265725F5F5745425041434B5F494D504F5254';
wwv_flow_imp.g_varchar2_table(1718) := '45445F4D4F44554C455F315F5F5B2264656661756C74225D205D2C0A2020706174684D61703A205B202774797065272C205F506174684D61705F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F5B2264656661756C74225D205D0A';
wwv_flow_imp.g_varchar2_table(1719) := '7D293B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F4472696C6C646F776E42726561646372756D62732E6A73223A0A2F2A212A';
wwv_flow_imp.g_varchar2_table(1720) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65';
wwv_flow_imp.g_varchar2_table(1721) := '732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F4472696C6C646F776E42726561646372756D62732E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(1722) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F';
wwv_flow_imp.g_varchar2_table(1723) := '7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F';
wwv_flow_imp.g_varchar2_table(1724) := '726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F204472696C6C646F776E42';
wwv_flow_imp.g_varchar2_table(1725) := '726561646372756D6273290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D';
wwv_flow_imp.g_varchar2_table(1726) := '205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A';
wwv_flow_imp.g_varchar2_table(1727) := '2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D69';
wwv_flow_imp.g_varchar2_table(1728) := '6E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F7574696C5F4573636170655574696C5F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(1729) := '445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F7574696C2F4573636170655574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F';
wwv_flow_imp.g_varchar2_table(1730) := '6C69622F7574696C2F4573636170655574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F';
wwv_flow_imp.g_varchar2_table(1731) := '7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A2F2A206861';
wwv_flow_imp.g_varchar2_table(1732) := '726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4472696C6C646F776E5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E';
wwv_flow_imp.g_varchar2_table(1733) := '2F7574696C2F4472696C6C646F776E5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4472696C6C646F776E5574696C2E6A7322293B0A0A0A0A0A0A0A0A2F2A2A0A202A204074797065646566207B';
wwv_flow_imp.g_varchar2_table(1734) := '696D706F727428276469616772616D2D6A732F6C69622F636F72652F43616E76617327292E64656661756C747D2043616E7661730A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F456C656D656E';
wwv_flow_imp.g_varchar2_table(1735) := '74526567697374727927292E64656661756C747D20456C656D656E7452656769737472790A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C747D204576';
wwv_flow_imp.g_varchar2_table(1736) := '656E744275730A202A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E740A202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C';
wwv_flow_imp.g_varchar2_table(1737) := '2F547970657327292E53686170657D2053686170650A202A2F0A0A766172204F50454E5F434C415353203D2027626A732D62726561646372756D62732D73686F776E273B0A0A0A2F2A2A0A202A2041646473206F7665726C617973207468617420616C6C';
wwv_flow_imp.g_varchar2_table(1738) := '6F7720737769746368696E6720706C616E6573206F6E20636F6C6C61707365642073756270726F6365737365732E0A202A0A202A2040706172616D207B4576656E744275737D206576656E744275730A202A2040706172616D207B456C656D656E745265';
wwv_flow_imp.g_varchar2_table(1739) := '6769737472797D20656C656D656E7452656769737472790A202A2040706172616D207B43616E7661737D2063616E7661730A202A2F0A66756E6374696F6E204472696C6C646F776E42726561646372756D6273286576656E744275732C20656C656D656E';
wwv_flow_imp.g_varchar2_table(1740) := '7452656769737472792C2063616E76617329207B0A20207661722062726561646372756D6273203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D6966792928273C756C20636C6173733D';
wwv_flow_imp.g_varchar2_table(1741) := '22626A732D62726561646372756D6273223E3C2F756C3E27293B0A202076617220636F6E7461696E6572203D2063616E7661732E676574436F6E7461696E657228293B0A202076617220636F6E7461696E6572436C6173736573203D2028302C6D696E5F';
wwv_flow_imp.g_varchar2_table(1742) := '646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E636C61737365732928636F6E7461696E6572293B0A2020636F6E7461696E65722E617070656E644368696C642862726561646372756D6273293B0A0A20207661722062';
wwv_flow_imp.g_varchar2_table(1743) := '7573696E6573734F626A656374506172656E7473203D205B5D3B0A0A20202F2F207570646174652062726561646372756D6273206966206E616D65206F72204944206F6620746865207072696D617279207368617065206368616E6765730A2020657665';
wwv_flow_imp.g_varchar2_table(1744) := '6E744275732E6F6E2827656C656D656E742E6368616E676564272C2066756E6374696F6E286576656E7429207B0A20202020766172207368617065203D206576656E742E656C656D656E742C0A2020202020202020627573696E6573734F626A65637420';
wwv_flow_imp.g_varchar2_table(1745) := '3D2028302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E676574427573696E6573734F626A65637429287368617065293B0A0A2020202076617220697350726573656E74203D202830';
wwv_flow_imp.g_varchar2_table(1746) := '2C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E66696E642928627573696E6573734F626A656374506172656E74732C2066756E6374696F6E28656C656D656E7429207B0A20202020202072657475726E';
wwv_flow_imp.g_varchar2_table(1747) := '20656C656D656E74203D3D3D20627573696E6573734F626A6563743B0A202020207D293B0A0A202020206966202821697350726573656E7429207B0A20202020202072657475726E3B0A202020207D0A0A2020202075706461746542726561646372756D';
wwv_flow_imp.g_varchar2_table(1748) := '627328293B0A20207D293B0A0A20202F2A2A0A2020202A20557064617465732074686520646973706C617965642062726561646372756D62732E204966206E6F20656C656D656E742069732070726F76696465642C206F6E6C79207468650A2020202A20';
wwv_flow_imp.g_varchar2_table(1749) := '6C6162656C732061726520757064617465642E0A2020202A0A2020202A2040706172616D207B456C656D656E747D205B656C656D656E745D0A2020202A2F0A202066756E6374696F6E2075706461746542726561646372756D627328656C656D656E7429';
wwv_flow_imp.g_varchar2_table(1750) := '207B0A2020202069662028656C656D656E7429207B0A202020202020627573696E6573734F626A656374506172656E7473203D20676574427573696E6573734F626A656374506172656E74436861696E28656C656D656E74293B0A202020207D0A0A2020';
wwv_flow_imp.g_varchar2_table(1751) := '20207661722070617468203D20627573696E6573734F626A656374506172656E74732E666C61744D61702866756E6374696F6E28706172656E7429207B0A20202020202076617220706172656E74506C616E65203D0A202020202020202063616E766173';
wwv_flow_imp.g_varchar2_table(1752) := '2E66696E64526F6F742828302C5F7574696C5F4472696C6C646F776E5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E676574506C616E65496446726F6D53686170652928706172656E742929207C7C0A2020202020';
wwv_flow_imp.g_varchar2_table(1753) := '20202063616E7661732E66696E64526F6F7428706172656E742E6964293B0A0A2020202020202F2F207768656E2074686520726F6F74206973206120636F6C6C61626F726174696F6E2C207468652070726F6365737320646F6573206E6F742068617665';
wwv_flow_imp.g_varchar2_table(1754) := '20610A2020202020202F2F20636F72726573706F6E64696E6720656C656D656E7420696E2074686520656C656D656E74526567697374792E20496E73746561642C207765207365617263680A2020202020202F2F20666F722074686520636F7272657370';
wwv_flow_imp.g_varchar2_table(1755) := '6F6E64696E67207061727469636970616E740A2020202020206966202821706172656E74506C616E652026262028302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69732928706172';
wwv_flow_imp.g_varchar2_table(1756) := '656E742C202762706D6E3A50726F63657373272929207B0A2020202020202020766172207061727469636970616E74203D20656C656D656E7452656769737472792E66696E642866756E6374696F6E28656C656D656E7429207B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(1757) := '2076617220627573696E6573734F626A656374203D2028302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E676574427573696E6573734F626A6563742928656C656D656E74293B0A0A';
wwv_flow_imp.g_varchar2_table(1758) := '2020202020202020202072657475726E20627573696E6573734F626A65637420262620627573696E6573734F626A6563742E676574282770726F636573735265662729203D3D3D20706172656E743B0A20202020202020207D293B0A0A20202020202020';
wwv_flow_imp.g_varchar2_table(1759) := '20706172656E74506C616E65203D207061727469636970616E742026262063616E7661732E66696E64526F6F74287061727469636970616E742E6964293B0A2020202020207D0A0A2020202020206966202821706172656E74506C616E6529207B0A2020';
wwv_flow_imp.g_varchar2_table(1760) := '20202020202072657475726E205B5D3B0A2020202020207D0A0A202020202020766172207469746C65203D2028302C6469616772616D5F6A735F6C69625F7574696C5F4573636170655574696C5F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(1761) := '4C455F345F5F2E65736361706548544D4C2928706172656E742E6E616D65207C7C20706172656E742E6964293B0A202020202020766172206C696E6B203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F30';
wwv_flow_imp.g_varchar2_table(1762) := '5F5F2E646F6D6966792928273C6C693E3C7370616E20636C6173733D22626A732D6372756D62223E3C61207469746C653D2227202B207469746C65202B2027223E27202B207469746C65202B20273C2F613E3C2F7370616E3E3C2F6C693E27293B0A0A20';
wwv_flow_imp.g_varchar2_table(1763) := '20202020206C696E6B2E6164644576656E744C697374656E65722827636C69636B272C2066756E6374696F6E2829207B0A202020202020202063616E7661732E736574526F6F74456C656D656E7428706172656E74506C616E65293B0A2020202020207D';
wwv_flow_imp.g_varchar2_table(1764) := '293B0A0A20202020202072657475726E206C696E6B3B0A202020207D293B0A0A2020202062726561646372756D62732E696E6E657248544D4C203D2027273B0A0A202020202F2F2073686F772062726561646372756D627320616E64206578706F736520';
wwv_flow_imp.g_varchar2_table(1765) := '737461746520746F202E646A732D636F6E7461696E65720A202020207661722076697369626C65203D20706174682E6C656E677468203E20313B0A0A20202020636F6E7461696E6572436C61737365732E746F67676C65284F50454E5F434C4153532C20';
wwv_flow_imp.g_varchar2_table(1766) := '76697369626C65293B0A0A20202020706174682E666F72456163682866756E6374696F6E28656C656D656E7429207B0A20202020202062726561646372756D62732E617070656E644368696C6428656C656D656E74293B0A202020207D293B0A20207D0A';
wwv_flow_imp.g_varchar2_table(1767) := '0A20206576656E744275732E6F6E2827726F6F742E736574272C2066756E6374696F6E286576656E7429207B0A2020202075706461746542726561646372756D6273286576656E742E656C656D656E74293B0A20207D293B0A0A7D0A0A4472696C6C646F';
wwv_flow_imp.g_varchar2_table(1768) := '776E42726561646372756D62732E24696E6A656374203D205B20276576656E74427573272C2027656C656D656E745265676973747279272C202763616E76617327205D3B0A0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F0A0A2F2A2A0A202A';
wwv_flow_imp.g_varchar2_table(1769) := '2052657475726E732074686520706172656E747320666F722074686520656C656D656E74207573696E672074686520627573696E657373206F626A65637420636861696E2C0A202A207374617274696E6720776974682074686520726F6F7420656C656D';
wwv_flow_imp.g_varchar2_table(1770) := '656E742E0A202A0A202A2040706172616D207B53686170657D206368696C640A202A0A202A204072657475726E207B53686170657D0A202A2F0A66756E6374696F6E20676574427573696E6573734F626A656374506172656E74436861696E286368696C';
wwv_flow_imp.g_varchar2_table(1771) := '6429207B0A202076617220627573696E6573734F626A656374203D2028302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E676574427573696E6573734F626A65637429286368696C64';
wwv_flow_imp.g_varchar2_table(1772) := '293B0A0A202076617220706172656E7473203D205B5D3B0A0A2020666F72202876617220656C656D656E74203D20627573696E6573734F626A6563743B20656C656D656E743B20656C656D656E74203D20656C656D656E742E24706172656E7429207B0A';
wwv_flow_imp.g_varchar2_table(1773) := '202020206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69732928656C656D656E742C202762706D6E3A53756250726F636573732729207C7C2028302C5F7574696C5F';
wwv_flow_imp.g_varchar2_table(1774) := '4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69732928656C656D656E742C202762706D6E3A50726F63657373272929207B0A202020202020706172656E74732E7075736828656C656D656E74293B0A';
wwv_flow_imp.g_varchar2_table(1775) := '202020207D0A20207D0A0A202072657475726E20706172656E74732E7265766572736528293B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C';
wwv_flow_imp.g_varchar2_table(1776) := '6C646F776E2F4472696C6C646F776E43656E746572696E672E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(1777) := '2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F4472696C6C646F776E43656E746572696E672E6A73202A2A2A210A20205C2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(1778) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64';
wwv_flow_imp.g_varchar2_table(1779) := '756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A20';
wwv_flow_imp.g_varchar2_table(1780) := '6861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A20282920';
wwv_flow_imp.g_varchar2_table(1781) := '3D3E20282F2A2062696E64696E67202A2F204472696C6C646F776E43656E746572696E67290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6F64656C55';
wwv_flow_imp.g_varchar2_table(1782) := '74696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62';
wwv_flow_imp.g_varchar2_table(1783) := '706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F43616E76617327292E64656661756C747D2043616E';
wwv_flow_imp.g_varchar2_table(1784) := '7661730A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A2F0A0A2F2A2A0A202A204D6F766520636F6C6C6170736564';
wwv_flow_imp.g_varchar2_table(1785) := '2073756270726F63657373657320696E746F2076696577207768656E206472696C6C696E6720646F776E2E0A202A0A202A205A6F6F6D20616E64207363726F6C6C2061726520736176656420696E20612073657373696F6E2E0A202A0A202A2040706172';
wwv_flow_imp.g_varchar2_table(1786) := '616D207B4576656E744275737D206576656E744275730A202A2040706172616D207B43616E7661737D2063616E7661730A202A2F0A66756E6374696F6E204472696C6C646F776E43656E746572696E67286576656E744275732C2063616E76617329207B';
wwv_flow_imp.g_varchar2_table(1787) := '0A0A20207661722063757272656E74526F6F74203D206E756C6C3B0A202076617220706F736974696F6E4D6170203D206E6577204D617028293B0A0A20206576656E744275732E6F6E2827726F6F742E736574272C2066756E6374696F6E286576656E74';
wwv_flow_imp.g_varchar2_table(1788) := '29207B0A20202020766172206E6577526F6F74203D206576656E742E656C656D656E743B0A202020207661722063757272656E7456696577626F78203D2063616E7661732E76696577626F7828293B0A202020207661722073746F72656456696577626F';
wwv_flow_imp.g_varchar2_table(1789) := '78203D20706F736974696F6E4D61702E676574286E6577526F6F74293B0A0A20202020706F736974696F6E4D61702E7365742863757272656E74526F6F742C207B0A202020202020783A2063757272656E7456696577626F782E782C0A20202020202079';
wwv_flow_imp.g_varchar2_table(1790) := '3A2063757272656E7456696577626F782E792C0A2020202020207A6F6F6D3A2063757272656E7456696577626F782E7363616C650A202020207D293B0A0A2020202063757272656E74526F6F74203D206E6577526F6F743B0A0A202020202F2F204B6565';
wwv_flow_imp.g_varchar2_table(1791) := '702076696577626F78207768656E207265706C6163696E6720726F6F7420656C656D656E74730A20202020696620282128302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69732928';
wwv_flow_imp.g_varchar2_table(1792) := '6E6577526F6F742C202762706D6E3A53756250726F636573732729202626202173746F72656456696577626F7829207B0A20202020202072657475726E3B0A202020207D0A0A2020202073746F72656456696577626F78203D2073746F72656456696577';
wwv_flow_imp.g_varchar2_table(1793) := '626F78207C7C207B20783A20302C20793A20302C207A6F6F6D3A2031207D3B0A0A20202020766172206478203D202863757272656E7456696577626F782E78202D2073746F72656456696577626F782E7829202A2063757272656E7456696577626F782E';
wwv_flow_imp.g_varchar2_table(1794) := '7363616C652C0A20202020202020206479203D202863757272656E7456696577626F782E79202D2073746F72656456696577626F782E7929202A2063757272656E7456696577626F782E7363616C653B0A0A2020202069662028647820213D3D2030207C';
wwv_flow_imp.g_varchar2_table(1795) := '7C20647920213D3D203029207B0A20202020202063616E7661732E7363726F6C6C287B0A202020202020202064783A2064782C0A202020202020202064793A2064790A2020202020207D293B0A202020207D0A0A202020206966202873746F7265645669';
wwv_flow_imp.g_varchar2_table(1796) := '6577626F782E7A6F6F6D20213D3D2063757272656E7456696577626F782E7363616C6529207B0A20202020202063616E7661732E7A6F6F6D2873746F72656456696577626F782E7A6F6F6D2C207B20783A20302C20793A2030207D293B0A202020207D0A';
wwv_flow_imp.g_varchar2_table(1797) := '20207D293B0A0A20206576656E744275732E6F6E28276469616772616D2E636C656172272C2066756E6374696F6E2829207B0A20202020706F736974696F6E4D61702E636C65617228293B0A2020202063757272656E74526F6F74203D206E756C6C3B0A';
wwv_flow_imp.g_varchar2_table(1798) := '20207D293B0A0A7D0A0A4472696C6C646F776E43656E746572696E672E24696E6A656374203D205B20276576656E74427573272C202763616E76617327205D3B0A0A0A2F2A2A0A202A20455335204D617020696D706C656D656E746174696F6E2E20576F';
wwv_flow_imp.g_varchar2_table(1799) := '726B732E0A202A2F0A66756E6374696F6E204D61702829207B0A0A2020746869732E5F656E7472696573203D205B5D3B0A0A2020746869732E736574203D2066756E6374696F6E286B65792C2076616C756529207B0A0A2020202076617220666F756E64';
wwv_flow_imp.g_varchar2_table(1800) := '203D2066616C73653B0A0A20202020666F722028766172206B20696E20746869732E5F656E747269657329207B0A20202020202069662028746869732E5F656E74726965735B6B5D5B305D203D3D3D206B657929207B0A2020202020202020746869732E';
wwv_flow_imp.g_varchar2_table(1801) := '5F656E74726965735B6B5D5B315D203D2076616C75653B0A0A2020202020202020666F756E64203D20747275653B0A0A2020202020202020627265616B3B0A2020202020207D0A202020207D0A0A202020206966202821666F756E6429207B0A20202020';
wwv_flow_imp.g_varchar2_table(1802) := '2020746869732E5F656E74726965732E70757368285B206B65792C2076616C7565205D293B0A202020207D0A20207D3B0A0A2020746869732E676574203D2066756E6374696F6E286B657929207B0A0A20202020666F722028766172206B20696E207468';
wwv_flow_imp.g_varchar2_table(1803) := '69732E5F656E747269657329207B0A20202020202069662028746869732E5F656E74726965735B6B5D5B305D203D3D3D206B657929207B0A202020202020202072657475726E20746869732E5F656E74726965735B6B5D5B315D3B0A2020202020207D0A';
wwv_flow_imp.g_varchar2_table(1804) := '202020207D0A0A2020202072657475726E206E756C6C3B0A20207D3B0A0A2020746869732E636C656172203D2066756E6374696F6E2829207B0A20202020746869732E5F656E74726965732E6C656E677468203D20303B0A20207D3B0A0A202074686973';
wwv_flow_imp.g_varchar2_table(1805) := '2E72656D6F7665203D2066756E6374696F6E286B657929207B0A0A2020202076617220696478203D202D313B0A0A20202020666F722028766172206B20696E20746869732E5F656E747269657329207B0A20202020202069662028746869732E5F656E74';
wwv_flow_imp.g_varchar2_table(1806) := '726965735B6B5D5B305D203D3D3D206B657929207B0A2020202020202020696478203D206B3B0A0A2020202020202020627265616B3B0A2020202020207D0A202020207D0A0A202020206966202869647820213D3D202D3129207B0A2020202020207468';
wwv_flow_imp.g_varchar2_table(1807) := '69732E5F656E74726965732E73706C696365286964782C2031293B0A202020207D0A20207D3B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C';
wwv_flow_imp.g_varchar2_table(1808) := '6C646F776E2F4472696C6C646F776E4F7665726C61794265686176696F722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(1809) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F4472696C6C646F776E4F7665726C61794265686176696F';
wwv_flow_imp.g_varchar2_table(1810) := '722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A';
wwv_flow_imp.g_varchar2_table(1811) := '2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F';
wwv_flow_imp.g_varchar2_table(1812) := '5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578';
wwv_flow_imp.g_varchar2_table(1813) := '706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F204472696C6C646F776E4F7665726C61794265686176696F72290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D';
wwv_flow_imp.g_varchar2_table(1814) := '6F6E7920696D706F7274202A2F2076617220696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A2120696E6865726974732D62';
wwv_flow_imp.g_varchar2_table(1815) := '726F77736572202A2F20222E2F6E6F64655F6D6F64756C65732F696E6865726974732D62726F777365722F646973742F696E6465782E65732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C';
wwv_flow_imp.g_varchar2_table(1816) := '69625F636F6D6D616E645F436F6D6D616E64496E746572636570746F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F';
wwv_flow_imp.g_varchar2_table(1817) := '636F6D6D616E642F436F6D6D616E64496E746572636570746F72202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F6D6D616E642F436F6D6D616E64496E746572636570746F722E6A7322293B0A2F2A20686172';
wwv_flow_imp.g_varchar2_table(1818) := '6D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C';
wwv_flow_imp.g_varchar2_table(1819) := '2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F574542';
wwv_flow_imp.g_varchar2_table(1820) := '5041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D';
wwv_flow_imp.g_varchar2_table(1821) := '2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4472696C6C646F776E5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F72657175697265';
wwv_flow_imp.g_varchar2_table(1822) := '5F5F282F2A21202E2E2F2E2E2F7574696C2F4472696C6C646F776E5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4472696C6C646F776E5574696C2E6A7322293B0A0A0A0A0A0A0A0A2F2A2A0A20';
wwv_flow_imp.g_varchar2_table(1823) := '2A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F43616E76617327292E64656661756C747D2043616E7661730A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C6962';
wwv_flow_imp.g_varchar2_table(1824) := '2F636F72652F456C656D656E74526567697374727927292E64656661756C747D20456C656D656E7452656769737472790A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E744275732729';
wwv_flow_imp.g_varchar2_table(1825) := '2E64656661756C747D204576656E744275730A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F66656174757265732F6F7665726C6179732F4F7665726C61797327292E64656661756C747D204F7665726C6179';
wwv_flow_imp.g_varchar2_table(1826) := '730A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F6931386E2F7472616E736C6174652F7472616E736C61746527292E64656661756C747D205472616E736C6174650A202A0A202A204074797065646566207B';
wwv_flow_imp.g_varchar2_table(1827) := '696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E740A202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E506172656E747D20506172656E74';
wwv_flow_imp.g_varchar2_table(1828) := '0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E53686170657D2053686170650A202A2F0A0A766172204C4F575F5052494F52495459203D203235303B0A766172204152524F575F444F574E5F53';
wwv_flow_imp.g_varchar2_table(1829) := '5647203D20273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222077696474683D22323022206865696768743D223230222076696577426F783D22302030203136203136223E3C706174682066696C6C2D';
wwv_flow_imp.g_varchar2_table(1830) := '72756C653D226576656E6F64642220643D224D342E38313830313934382C332E3530373335393331204C31302E343939363839342C392E31383936383934204C31302E352C34204C31322C34204C31322C3132204C342C3132204C342C31302E35204C39';
wwv_flow_imp.g_varchar2_table(1831) := '2E363839363839342C31302E34393936383934204C332E37353733353933312C342E35363830313934382043332E34363434363630392C342E323735313236323720332E34363434363630392C332E383030323532353320332E37353733353933312C33';
wwv_flow_imp.g_varchar2_table(1832) := '2E35303733353933312043342E30353032353235332C332E323134343636303920342E35323531323632372C332E323134343636303920342E38313830313934382C332E3530373335393331205A222F3E3C2F7376673E273B0A0A76617220454D505459';
wwv_flow_imp.g_varchar2_table(1833) := '5F4D41524B4552203D2027626A732D6472696C6C646F776E2D656D707479273B0A0A2F2A2A0A202A2040706172616D207B43616E7661737D2063616E7661730A202A2040706172616D207B4576656E744275737D206576656E744275730A202A20407061';
wwv_flow_imp.g_varchar2_table(1834) := '72616D207B456C656D656E7452656769737472797D20656C656D656E7452656769737472790A202A2040706172616D207B4F7665726C6179737D206F7665726C6179730A202A2040706172616D207B5472616E736C6174657D207472616E736C6174650A';
wwv_flow_imp.g_varchar2_table(1835) := '202A2F0A66756E6374696F6E204472696C6C646F776E4F7665726C61794265686176696F72280A2020202063616E7661732C206576656E744275732C20656C656D656E7452656769737472792C206F7665726C6179732C207472616E736C6174650A2920';
wwv_flow_imp.g_varchar2_table(1836) := '7B0A20206469616772616D5F6A735F6C69625F636F6D6D616E645F436F6D6D616E64496E746572636570746F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D2E63616C6C28746869732C20657665';
wwv_flow_imp.g_varchar2_table(1837) := '6E74427573293B0A0A2020746869732E5F63616E766173203D2063616E7661733B0A2020746869732E5F6576656E74427573203D206576656E744275733B0A2020746869732E5F656C656D656E745265676973747279203D20656C656D656E7452656769';
wwv_flow_imp.g_varchar2_table(1838) := '737472793B0A2020746869732E5F6F7665726C617973203D206F7665726C6179733B0A2020746869732E5F7472616E736C617465203D207472616E736C6174653B0A0A20207661722073656C66203D20746869733B0A0A2020746869732E657865637574';
wwv_flow_imp.g_varchar2_table(1839) := '6564282773686170652E746F67676C65436F6C6C61707365272C204C4F575F5052494F524954592C2066756E6374696F6E28636F6E7465787429207B0A20202020766172207368617065203D20636F6E746578742E73686170653B0A0A202020202F2F20';
wwv_flow_imp.g_varchar2_table(1840) := '416464206F7665726C617920746F2074686520636F6C6C61707365642073686170650A202020206966202873656C662E5F63616E4472696C6C446F776E2873686170652929207B0A20202020202073656C662E5F6164644F7665726C6179287368617065';
wwv_flow_imp.g_varchar2_table(1841) := '293B0A202020207D20656C7365207B0A20202020202073656C662E5F72656D6F76654F7665726C6179287368617065293B0A202020207D0A20207D2C2074727565293B0A0A0A2020746869732E7265766572746564282773686170652E746F67676C6543';
wwv_flow_imp.g_varchar2_table(1842) := '6F6C6C61707365272C204C4F575F5052494F524954592C2066756E6374696F6E28636F6E7465787429207B0A20202020766172207368617065203D20636F6E746578742E73686170653B0A0A202020202F2F20416464206F7665726C617920746F207468';
wwv_flow_imp.g_varchar2_table(1843) := '6520636F6C6C61707365642073686170650A202020206966202873656C662E5F63616E4472696C6C446F776E2873686170652929207B0A20202020202073656C662E5F6164644F7665726C6179287368617065293B0A202020207D20656C7365207B0A20';
wwv_flow_imp.g_varchar2_table(1844) := '202020202073656C662E5F72656D6F76654F7665726C6179287368617065293B0A202020207D0A20207D2C2074727565293B0A0A0A2020746869732E6578656375746564285B202773686170652E637265617465272C202773686170652E6D6F7665272C';
wwv_flow_imp.g_varchar2_table(1845) := '202773686170652E64656C65746527205D2C204C4F575F5052494F524954592C0A2020202066756E6374696F6E28636F6E7465787429207B0A202020202020766172206F6C64506172656E74203D20636F6E746578742E6F6C64506172656E742C0A2020';
wwv_flow_imp.g_varchar2_table(1846) := '20202020202020206E6577506172656E74203D20636F6E746578742E6E6577506172656E74207C7C20636F6E746578742E706172656E742C0A202020202020202020207368617065203D20636F6E746578742E73686170653B0A0A2020202020202F2F20';
wwv_flow_imp.g_varchar2_table(1847) := '416464206F7665726C617920746F2074686520636F6C6C61707365642073686170650A2020202020206966202873656C662E5F63616E4472696C6C446F776E2873686170652929207B0A202020202020202073656C662E5F6164644F7665726C61792873';
wwv_flow_imp.g_varchar2_table(1848) := '68617065293B0A2020202020207D0A0A20202020202073656C662E5F7570646174654472696C6C646F776E4F7665726C6179286F6C64506172656E74293B0A20202020202073656C662E5F7570646174654472696C6C646F776E4F7665726C6179286E65';
wwv_flow_imp.g_varchar2_table(1849) := '77506172656E74293B0A20202020202073656C662E5F7570646174654472696C6C646F776E4F7665726C6179287368617065293B0A202020207D2C2074727565293B0A0A0A2020746869732E7265766572746564285B202773686170652E637265617465';
wwv_flow_imp.g_varchar2_table(1850) := '272C202773686170652E6D6F7665272C202773686170652E64656C65746527205D2C204C4F575F5052494F524954592C0A2020202066756E6374696F6E28636F6E7465787429207B0A202020202020766172206F6C64506172656E74203D20636F6E7465';
wwv_flow_imp.g_varchar2_table(1851) := '78742E6F6C64506172656E742C0A202020202020202020206E6577506172656E74203D20636F6E746578742E6E6577506172656E74207C7C20636F6E746578742E706172656E742C0A202020202020202020207368617065203D20636F6E746578742E73';
wwv_flow_imp.g_varchar2_table(1852) := '686170653B0A0A2020202020202F2F20416464206F7665726C617920746F2074686520636F6C6C61707365642073686170650A2020202020206966202873656C662E5F63616E4472696C6C446F776E2873686170652929207B0A20202020202020207365';
wwv_flow_imp.g_varchar2_table(1853) := '6C662E5F6164644F7665726C6179287368617065293B0A2020202020207D0A0A20202020202073656C662E5F7570646174654472696C6C646F776E4F7665726C6179286F6C64506172656E74293B0A20202020202073656C662E5F757064617465447269';
wwv_flow_imp.g_varchar2_table(1854) := '6C6C646F776E4F7665726C6179286E6577506172656E74293B0A20202020202073656C662E5F7570646174654472696C6C646F776E4F7665726C6179287368617065293B0A202020207D2C2074727565293B0A0A0A20206576656E744275732E6F6E2827';
wwv_flow_imp.g_varchar2_table(1855) := '696D706F72742E72656E6465722E636F6D706C657465272C2066756E6374696F6E2829207B0A20202020656C656D656E7452656769737472792E66696C7465722866756E6374696F6E286529207B0A20202020202072657475726E2073656C662E5F6361';
wwv_flow_imp.g_varchar2_table(1856) := '6E4472696C6C446F776E2865293B0A202020207D292E6D61702866756E6374696F6E28656C29207B0A20202020202073656C662E5F6164644F7665726C617928656C293B0A202020207D293B0A20207D293B0A0A7D0A0A28302C696E6865726974735F62';
wwv_flow_imp.g_varchar2_table(1857) := '726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D29284472696C6C646F776E4F7665726C61794265686176696F722C206469616772616D5F6A735F6C69625F636F6D6D616E645F436F6D';
wwv_flow_imp.g_varchar2_table(1858) := '6D616E64496E746572636570746F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D293B0A0A2F2A2A0A202A2040706172616D207B53686170657D2073686170650A202A2F0A4472696C6C646F776E';
wwv_flow_imp.g_varchar2_table(1859) := '4F7665726C61794265686176696F722E70726F746F747970652E5F7570646174654472696C6C646F776E4F7665726C6179203D2066756E6374696F6E28736861706529207B0A20207661722063616E766173203D20746869732E5F63616E7661733B0A0A';
wwv_flow_imp.g_varchar2_table(1860) := '20206966202821736861706529207B0A2020202072657475726E3B0A20207D0A0A202076617220726F6F74203D2063616E7661732E66696E64526F6F74287368617065293B0A0A202069662028726F6F7429207B0A20202020746869732E5F7570646174';
wwv_flow_imp.g_varchar2_table(1861) := '654F7665726C61795669736962696C69747928726F6F74293B0A20207D0A7D3B0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A4472696C6C64';
wwv_flow_imp.g_varchar2_table(1862) := '6F776E4F7665726C61794265686176696F722E70726F746F747970652E5F63616E4472696C6C446F776E203D2066756E6374696F6E28656C656D656E7429207B0A20207661722063616E766173203D20746869732E5F63616E7661733B0A0A2020726574';
wwv_flow_imp.g_varchar2_table(1863) := '75726E2028302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E69732928656C656D656E742C202762706D6E3A53756250726F6365737327292026262063616E7661732E66696E64526F';
wwv_flow_imp.g_varchar2_table(1864) := '6F742828302C5F7574696C5F4472696C6C646F776E5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E676574506C616E65496446726F6D53686170652928656C656D656E7429293B0A7D3B0A0A2F2A2A0A202A205570';
wwv_flow_imp.g_varchar2_table(1865) := '6461746520746865207669736962696C697479206F6620746865206472696C6C646F776E206F7665726C61792E2049662074686520706C616E6520686173206E6F20656C656D656E74732C0A202A20746865206472696C6C646F776E2077696C6C206F6E';
wwv_flow_imp.g_varchar2_table(1866) := '6C792062652073686F776E207768656E2074686520656C656D656E742069732073656C65637465642E0A202A0A202A2040706172616D207B506172656E747D20656C656D656E742054686520636F6C6C617073656420726F6F74206F722073686170652E';
wwv_flow_imp.g_varchar2_table(1867) := '0A202A2F0A4472696C6C646F776E4F7665726C61794265686176696F722E70726F746F747970652E5F7570646174654F7665726C61795669736962696C697479203D2066756E6374696F6E28656C656D656E7429207B0A2020766172206F7665726C6179';
wwv_flow_imp.g_varchar2_table(1868) := '73203D20746869732E5F6F7665726C6179733B0A0A202076617220627573696E6573734F626A656374203D2028302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574427573696E';
wwv_flow_imp.g_varchar2_table(1869) := '6573734F626A6563742928656C656D656E74293B0A0A2020766172206F7665726C6179203D206F7665726C6179732E676574287B20656C656D656E743A20627573696E6573734F626A6563742E69642C20747970653A20276472696C6C646F776E27207D';
wwv_flow_imp.g_varchar2_table(1870) := '295B305D3B0A0A202069662028216F7665726C617929207B0A2020202072657475726E3B0A20207D0A0A202076617220686173466C6F77456C656D656E7473203D20627573696E6573734F626A6563740A20202020262620627573696E6573734F626A65';
wwv_flow_imp.g_varchar2_table(1871) := '63742E6765742827666C6F77456C656D656E747327290A20202020262620627573696E6573734F626A6563742E6765742827666C6F77456C656D656E747327292E6C656E6774683B0A0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(1872) := '525445445F4D4F44554C455F345F5F2E636C617373657329286F7665726C61792E68746D6C292E746F67676C6528454D5054595F4D41524B45522C2021686173466C6F77456C656D656E7473293B0A7D3B0A0A2F2A2A0A202A204164642061206472696C';
wwv_flow_imp.g_varchar2_table(1873) := '6C646F776E20627574746F6E20746F2074686520676976656E20656C656D656E7420617373756D696E672074686520706C616E6520686173207468652073616D650A202A2049442061732074686520656C656D656E742E0A202A0A202A2040706172616D';
wwv_flow_imp.g_varchar2_table(1874) := '207B53686170657D20656C656D656E742054686520636F6C6C61707365642073686170652E0A202A2F0A4472696C6C646F776E4F7665726C61794265686176696F722E70726F746F747970652E5F6164644F7665726C6179203D2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(1875) := '656C656D656E7429207B0A20207661722063616E766173203D20746869732E5F63616E7661732C0A2020202020206F7665726C617973203D20746869732E5F6F7665726C6179732C0A202020202020626F203D2028302C5F7574696C5F4D6F64656C5574';
wwv_flow_imp.g_varchar2_table(1876) := '696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E676574427573696E6573734F626A6563742928656C656D656E74293B0A0A2020766172206578697374696E674F7665726C617973203D206F7665726C6179732E67657428';
wwv_flow_imp.g_varchar2_table(1877) := '7B20656C656D656E743A20656C656D656E742C20747970653A20276472696C6C646F776E27207D293B0A0A2020696620286578697374696E674F7665726C6179732E6C656E67746829207B0A20202020746869732E5F72656D6F76654F7665726C617928';
wwv_flow_imp.g_varchar2_table(1878) := '656C656D656E74293B0A20207D0A0A202076617220627574746F6E203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E646F6D6966792928273C627574746F6E20747970653D22627574746F6E22';
wwv_flow_imp.g_varchar2_table(1879) := '20636C6173733D22626A732D6472696C6C646F776E223E27202B204152524F575F444F574E5F535647202B20273C2F627574746F6E3E27292C0A202020202020656C656D656E744E616D65203D20626F2E67657428276E616D652729207C7C20626F2E67';
wwv_flow_imp.g_varchar2_table(1880) := '65742827696427292C0A2020202020207469746C65203D20746869732E5F7472616E736C61746528274F70656E207B656C656D656E747D272C207B20656C656D656E743A20656C656D656E744E616D65207D293B0A2020627574746F6E2E736574417474';
wwv_flow_imp.g_varchar2_table(1881) := '72696275746528277469746C65272C207469746C65293B0A0A2020627574746F6E2E6164644576656E744C697374656E65722827636C69636B272C2066756E6374696F6E2829207B0A2020202063616E7661732E736574526F6F74456C656D656E742863';
wwv_flow_imp.g_varchar2_table(1882) := '616E7661732E66696E64526F6F742828302C5F7574696C5F4472696C6C646F776E5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E676574506C616E65496446726F6D53686170652928656C656D656E742929293B0A';
wwv_flow_imp.g_varchar2_table(1883) := '20207D293B0A0A20206F7665726C6179732E61646428656C656D656E742C20276472696C6C646F776E272C207B0A20202020706F736974696F6E3A207B0A202020202020626F74746F6D3A202D372C0A20202020202072696768743A202D380A20202020';
wwv_flow_imp.g_varchar2_table(1884) := '7D2C0A2020202068746D6C3A20627574746F6E0A20207D293B0A0A2020746869732E5F7570646174654F7665726C61795669736962696C69747928656C656D656E74293B0A7D3B0A0A4472696C6C646F776E4F7665726C61794265686176696F722E7072';
wwv_flow_imp.g_varchar2_table(1885) := '6F746F747970652E5F72656D6F76654F7665726C6179203D2066756E6374696F6E28656C656D656E7429207B0A2020766172206F7665726C617973203D20746869732E5F6F7665726C6179733B0A0A20206F7665726C6179732E72656D6F7665287B0A20';
wwv_flow_imp.g_varchar2_table(1886) := '202020656C656D656E743A20656C656D656E742C0A20202020747970653A20276472696C6C646F776E270A20207D293B0A7D3B0A0A4472696C6C646F776E4F7665726C61794265686176696F722E24696E6A656374203D205B0A20202763616E76617327';
wwv_flow_imp.g_varchar2_table(1887) := '2C0A2020276576656E74427573272C0A202027656C656D656E745265676973747279272C0A2020276F7665726C617973272C0A2020277472616E736C617465270A5D3B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65';
wwv_flow_imp.g_varchar2_table(1888) := '732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F53756270726F63657373436F6D7061746962696C6974792E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(1889) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F77';
wwv_flow_imp.g_varchar2_table(1890) := '6E2F53756270726F63657373436F6D7061746962696C6974792E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(1891) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A';
wwv_flow_imp.g_varchar2_table(1892) := '5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F657870';
wwv_flow_imp.g_varchar2_table(1893) := '6F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F2053756270726F63657373436F6D7061746962696C697479290A2F2A206861726D6F6E79';
wwv_flow_imp.g_varchar2_table(1894) := '206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F6C61796F75745F4C61796F75745574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F';
wwv_flow_imp.g_varchar2_table(1895) := '5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F6C61796F75742F4C61796F75745574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6C61796F75';
wwv_flow_imp.g_varchar2_table(1896) := '742F4C61796F75745574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(1897) := '5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A0A0A0A0A2F2A2A0A202A2040';
wwv_flow_imp.g_varchar2_table(1898) := '74797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F54';
wwv_flow_imp.g_varchar2_table(1899) := '7970657327292E4D6F64646C657D204D6F64646C650A202A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E740A202A204074797065646566207B696D706F';
wwv_flow_imp.g_varchar2_table(1900) := '727428272E2E2F2E2E2F6D6F64656C2F547970657327292E53686170657D2053686170650A202A0A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F43616E76617327292E43616E766173506C616E';
wwv_flow_imp.g_varchar2_table(1901) := '657D2043616E766173506C616E650A202A0A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F7574696C2F547970657327292E526563747D20526563740A202A2F0A0A7661722044454641554C545F504F534954';
wwv_flow_imp.g_varchar2_table(1902) := '494F4E203D207B0A2020783A203138302C0A2020793A203136300A7D3B0A0A2F2A2A0A202A20486F6F6B20696E746F2060696D706F72742E72656E6465722E73746172746020616E6420637265617465206E657720706C616E657320666F722064696167';
wwv_flow_imp.g_varchar2_table(1903) := '72616D7320776974680A202A20636F6C6C61707365642073756270726F63657373657320616E6420616C6C20444920656C656D656E7473206F6E207468652073616D6520706C616E652E0A202A0A202A2040706172616D207B4576656E744275737D2065';
wwv_flow_imp.g_varchar2_table(1904) := '76656E744275730A202A2040706172616D207B4D6F64646C657D206D6F64646C650A202A2F0A66756E6374696F6E2053756270726F63657373436F6D7061746962696C697479286576656E744275732C206D6F64646C6529207B0A2020746869732E5F65';
wwv_flow_imp.g_varchar2_table(1905) := '76656E74427573203D206576656E744275733B0A2020746869732E5F6D6F64646C65203D206D6F64646C653B0A0A20207661722073656C66203D20746869733B0A0A20206576656E744275732E6F6E2827696D706F72742E72656E6465722E7374617274';
wwv_flow_imp.g_varchar2_table(1906) := '272C20313530302C2066756E6374696F6E28652C20636F6E7465787429207B0A2020202073656C662E5F68616E646C65496D706F727428636F6E746578742E646566696E6974696F6E73293B0A20207D293B0A7D0A0A2F2A2A0A202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(1907) := '7B4D6F64646C65456C656D656E747D20646566696E6974696F6E730A202A2F0A53756270726F63657373436F6D7061746962696C6974792E70726F746F747970652E5F68616E646C65496D706F7274203D2066756E6374696F6E28646566696E6974696F';
wwv_flow_imp.g_varchar2_table(1908) := '6E7329207B0A20206966202821646566696E6974696F6E732E6469616772616D7329207B0A2020202072657475726E3B0A20207D0A0A20207661722073656C66203D20746869733B0A2020746869732E5F646566696E6974696F6E73203D20646566696E';
wwv_flow_imp.g_varchar2_table(1909) := '6974696F6E733B0A2020746869732E5F70726F63657373546F4469616772616D4D6170203D207B7D3B0A0A2020646566696E6974696F6E732E6469616772616D732E666F72456163682866756E6374696F6E286469616772616D29207B0A202020206966';
wwv_flow_imp.g_varchar2_table(1910) := '2028216469616772616D2E706C616E65207C7C20216469616772616D2E706C616E652E62706D6E456C656D656E7429207B0A20202020202072657475726E3B0A202020207D0A0A2020202073656C662E5F70726F63657373546F4469616772616D4D6170';
wwv_flow_imp.g_varchar2_table(1911) := '5B6469616772616D2E706C616E652E62706D6E456C656D656E742E69645D203D206469616772616D3B0A20207D293B0A0A2020766172206E65774469616772616D73203D20646566696E6974696F6E732E6469616772616D730A202020202E66696C7465';
wwv_flow_imp.g_varchar2_table(1912) := '72286469616772616D203D3E206469616772616D2E706C616E65290A202020202E666C61744D6170286469616772616D203D3E2073656C662E5F6372656174654E65774469616772616D73286469616772616D2E706C616E6529293B0A0A20206E657744';
wwv_flow_imp.g_varchar2_table(1913) := '69616772616D732E666F72456163682866756E6374696F6E286469616772616D29207B0A2020202073656C662E5F6D6F7665506C616E65456C656D656E7473546F4F726967696E286469616772616D2E706C616E65293B0A20207D293B0A7D3B0A0A0A2F';
wwv_flow_imp.g_varchar2_table(1914) := '2A2A0A202A204D6F76657320616C6C20444920656C656D656E74732066726F6D20636F6C6C61707365642073756270726F63657373657320746F2061206E657720706C616E652E0A202A0A202A2040706172616D207B43616E766173506C616E657D2070';
wwv_flow_imp.g_varchar2_table(1915) := '6C616E650A202A0A202A204072657475726E207B4D6F64646C65456C656D656E745B5D7D206E6577206469616772616D73206372656174656420666F722074686520636F6C6C61707365642073756270726F6365737365730A202A2F0A53756270726F63';
wwv_flow_imp.g_varchar2_table(1916) := '657373436F6D7061746962696C6974792E70726F746F747970652E5F6372656174654E65774469616772616D73203D2066756E6374696F6E28706C616E6529207B0A20207661722073656C66203D20746869733B0A0A202076617220636F6C6C61707365';
wwv_flow_imp.g_varchar2_table(1917) := '64456C656D656E7473203D205B5D3B0A202076617220656C656D656E7473546F4D6F7665203D205B5D3B0A0A2020706C616E652E6765742827706C616E65456C656D656E7427292E666F72456163682866756E6374696F6E286469456C656D656E742920';
wwv_flow_imp.g_varchar2_table(1918) := '7B0A2020202076617220627573696E6573734F626A656374203D206469456C656D656E742E62706D6E456C656D656E743B0A0A202020206966202821627573696E6573734F626A65637429207B0A20202020202072657475726E3B0A202020207D0A0A20';
wwv_flow_imp.g_varchar2_table(1919) := '20202076617220706172656E74203D20627573696E6573734F626A6563742E24706172656E743B0A0A202020206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E697329';
wwv_flow_imp.g_varchar2_table(1920) := '28627573696E6573734F626A6563742C202762706D6E3A53756250726F63657373272920262620216469456C656D656E742E6973457870616E64656429207B0A202020202020636F6C6C6170736564456C656D656E74732E7075736828627573696E6573';
wwv_flow_imp.g_varchar2_table(1921) := '734F626A656374293B0A202020207D0A0A202020206966202873686F756C644D6F7665546F506C616E6528627573696E6573734F626A6563742C20706C616E652929207B0A0A2020202020202F2F20646F6E2774206368616E6765207468652061727261';
wwv_flow_imp.g_varchar2_table(1922) := '79207768696C652077652069746572617465206F7665722069740A202020202020656C656D656E7473546F4D6F76652E70757368287B206469456C656D656E743A206469456C656D656E742C20706172656E743A20706172656E74207D293B0A20202020';
wwv_flow_imp.g_varchar2_table(1923) := '7D0A20207D293B0A0A2020766172206E65774469616772616D73203D205B5D3B0A0A20202F2F20637265617465206E657720706C616E657320666F7220616C6C20636F6C6C61707365642073756270726F6365737365732C206576656E207768656E2074';
wwv_flow_imp.g_varchar2_table(1924) := '6865792061726520656D7074790A2020636F6C6C6170736564456C656D656E74732E666F72456163682866756E6374696F6E28656C656D656E7429207B0A20202020696620282173656C662E5F70726F63657373546F4469616772616D4D61705B20656C';
wwv_flow_imp.g_varchar2_table(1925) := '656D656E742E6964205D29207B0A202020202020766172206469616772616D203D2073656C662E5F6372656174654469616772616D28656C656D656E74293B0A0A20202020202073656C662E5F70726F63657373546F4469616772616D4D61705B656C65';
wwv_flow_imp.g_varchar2_table(1926) := '6D656E742E69645D203D206469616772616D3B0A0A2020202020206E65774469616772616D732E70757368286469616772616D293B0A202020207D0A20207D293B0A0A2020656C656D656E7473546F4D6F76652E666F72456163682866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1927) := '28656C656D656E7429207B0A20202020766172206469456C656D656E74203D20656C656D656E742E6469456C656D656E743B0A2020202076617220706172656E74203D20656C656D656E742E706172656E743B0A0A202020202F2F20706172656E742069';
wwv_flow_imp.g_varchar2_table(1928) := '7320657870616E6465642C20676574206E65617265737420636F6C6C617073656420706172656E740A202020207768696C652028706172656E7420262620636F6C6C6170736564456C656D656E74732E696E6465784F6628706172656E7429203D3D3D20';
wwv_flow_imp.g_varchar2_table(1929) := '2D3129207B0A202020202020706172656E74203D20706172656E742E24706172656E743B0A202020207D0A0A202020202F2F2066616C736520706F7369746976652C20616C6C20706172656E74732061726520657870616E6465640A2020202069662028';
wwv_flow_imp.g_varchar2_table(1930) := '21706172656E7429207B0A20202020202072657475726E3B0A202020207D0A0A20202020766172206469616772616D203D2073656C662E5F70726F63657373546F4469616772616D4D61705B20706172656E742E6964205D3B0A0A2020202073656C662E';
wwv_flow_imp.g_varchar2_table(1931) := '5F6D6F7665546F4469506C616E65286469456C656D656E742C206469616772616D2E706C616E65293B0A20207D293B0A0A202072657475726E206E65774469616772616D733B0A7D3B0A0A2F2A2A0A202A2040706172616D207B43616E766173506C616E';
wwv_flow_imp.g_varchar2_table(1932) := '657D20706C616E650A202A2F0A53756270726F63657373436F6D7061746962696C6974792E70726F746F747970652E5F6D6F7665506C616E65456C656D656E7473546F4F726967696E203D2066756E6374696F6E28706C616E6529207B0A202076617220';
wwv_flow_imp.g_varchar2_table(1933) := '656C656D656E7473203D20706C616E652E6765742827706C616E65456C656D656E7427293B0A0A20202F2F2067657420626F756E64696E6720626F78206F6620616C6C20656C656D656E74730A202076617220706C616E65426F756E6473203D20676574';
wwv_flow_imp.g_varchar2_table(1934) := '506C616E65426F756E647328706C616E65293B0A0A2020766172206F6666736574203D207B0A20202020783A20706C616E65426F756E64732E78202D2044454641554C545F504F534954494F4E2E782C0A20202020793A20706C616E65426F756E64732E';
wwv_flow_imp.g_varchar2_table(1935) := '79202D2044454641554C545F504F534954494F4E2E790A20207D3B0A0A2020656C656D656E74732E666F72456163682866756E6374696F6E286469456C656D656E7429207B0A20202020696620286469456C656D656E742E776179706F696E7429207B0A';
wwv_flow_imp.g_varchar2_table(1936) := '2020202020206469456C656D656E742E776179706F696E742E666F72456163682866756E6374696F6E28776179706F696E7429207B0A2020202020202020776179706F696E742E78203D20776179706F696E742E78202D206F66667365742E783B0A2020';
wwv_flow_imp.g_varchar2_table(1937) := '202020202020776179706F696E742E79203D20776179706F696E742E79202D206F66667365742E793B0A2020202020207D293B0A202020207D20656C736520696620286469456C656D656E742E626F756E647329207B0A2020202020206469456C656D65';
wwv_flow_imp.g_varchar2_table(1938) := '6E742E626F756E64732E78203D206469456C656D656E742E626F756E64732E78202D206F66667365742E783B0A2020202020206469456C656D656E742E626F756E64732E79203D206469456C656D656E742E626F756E64732E79202D206F66667365742E';
wwv_flow_imp.g_varchar2_table(1939) := '793B0A202020207D0A20207D293B0A7D3B0A0A2F2A2A0A202A2040706172616D207B4D6F64646C65456C656D656E747D206469456C656D656E740A202A2040706172616D207B43616E766173506C616E657D206E6577506C616E650A202A2F0A53756270';
wwv_flow_imp.g_varchar2_table(1940) := '726F63657373436F6D7061746962696C6974792E70726F746F747970652E5F6D6F7665546F4469506C616E65203D2066756E6374696F6E286469456C656D656E742C206E6577506C616E6529207B0A202076617220636F6E7461696E696E674469616772';
wwv_flow_imp.g_varchar2_table(1941) := '616D203D2066696E64526F6F744469616772616D286469456C656D656E74293B0A0A20202F2F2072656D6F76652044492066726F6D206F6C6420506C616E6520616E642061646420697420746F20746865206E6577206F6E650A20207661722070617265';
wwv_flow_imp.g_varchar2_table(1942) := '6E74506C616E65456C656D656E74203D20636F6E7461696E696E674469616772616D2E706C616E652E6765742827706C616E65456C656D656E7427293B0A0A2020706172656E74506C616E65456C656D656E742E73706C69636528706172656E74506C61';
wwv_flow_imp.g_varchar2_table(1943) := '6E65456C656D656E742E696E6465784F66286469456C656D656E74292C2031293B0A0A20206E6577506C616E652E6765742827706C616E65456C656D656E7427292E70757368286469456C656D656E74293B0A7D3B0A0A2F2A2A0A202A2040706172616D';
wwv_flow_imp.g_varchar2_table(1944) := '207B4D6F64646C65456C656D656E747D20627573696E6573734F626A6563740A202A0A202A204072657475726E207B4D6F64646C65456C656D656E747D0A202A2F0A53756270726F63657373436F6D7061746962696C6974792E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(1945) := '5F6372656174654469616772616D203D2066756E6374696F6E28627573696E6573734F626A65637429207B0A202076617220706C616E65203D20746869732E5F6D6F64646C652E637265617465282762706D6E64693A42504D4E506C616E65272C207B0A';
wwv_flow_imp.g_varchar2_table(1946) := '2020202062706D6E456C656D656E743A20627573696E6573734F626A6563740A20207D293B0A0A2020766172206469616772616D203D20746869732E5F6D6F64646C652E637265617465282762706D6E64693A42504D4E4469616772616D272C207B0A20';
wwv_flow_imp.g_varchar2_table(1947) := '202020706C616E653A20706C616E650A20207D293B0A0A2020706C616E652E24706172656E74203D206469616772616D3B0A0A2020706C616E652E62706D6E456C656D656E74203D20627573696E6573734F626A6563743B0A0A20206469616772616D2E';
wwv_flow_imp.g_varchar2_table(1948) := '24706172656E74203D20746869732E5F646566696E6974696F6E733B0A0A2020746869732E5F646566696E6974696F6E732E6469616772616D732E70757368286469616772616D293B0A0A202072657475726E206469616772616D3B0A7D3B0A0A537562';
wwv_flow_imp.g_varchar2_table(1949) := '70726F63657373436F6D7061746962696C6974792E24696E6A656374203D205B20276576656E74427573272C20276D6F64646C6527205D3B0A0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F0A0A66756E6374696F6E2066696E64526F6F7444';
wwv_flow_imp.g_varchar2_table(1950) := '69616772616D28656C656D656E7429207B0A20206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69732928656C656D656E742C202762706D6E64693A42504D4E446961';
wwv_flow_imp.g_varchar2_table(1951) := '6772616D272929207B0A2020202072657475726E20656C656D656E743B0A20207D20656C7365207B0A2020202072657475726E2066696E64526F6F744469616772616D28656C656D656E742E24706172656E74293B0A20207D0A7D0A0A2F2A2A0A202A20';
wwv_flow_imp.g_varchar2_table(1952) := '40706172616D207B43616E766173506C616E657D20706C616E650A202A0A202A204072657475726E207B526563747D0A202A2F0A66756E6374696F6E20676574506C616E65426F756E647328706C616E6529207B0A202076617220706C616E655472626C';
wwv_flow_imp.g_varchar2_table(1953) := '203D207B0A20202020746F703A20496E66696E6974792C0A2020202072696768743A202D496E66696E6974792C0A20202020626F74746F6D3A202D496E66696E6974792C0A202020206C6566743A20496E66696E6974790A20207D3B0A0A2020706C616E';
wwv_flow_imp.g_varchar2_table(1954) := '652E706C616E65456C656D656E742E666F72456163682866756E6374696F6E28656C656D656E7429207B0A202020206966202821656C656D656E742E626F756E647329207B0A20202020202072657475726E3B0A202020207D0A0A202020207661722074';
wwv_flow_imp.g_varchar2_table(1955) := '72626C203D2028302C6469616772616D5F6A735F6C69625F6C61796F75745F4C61796F75745574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E61735452424C2928656C656D656E742E626F756E6473293B0A0A202020';
wwv_flow_imp.g_varchar2_table(1956) := '20706C616E655472626C2E746F70203D204D6174682E6D696E287472626C2E746F702C20706C616E655472626C2E746F70293B0A20202020706C616E655472626C2E6C656674203D204D6174682E6D696E287472626C2E6C6566742C20706C616E655472';
wwv_flow_imp.g_varchar2_table(1957) := '626C2E6C656674293B0A20207D293B0A0A202072657475726E2028302C6469616772616D5F6A735F6C69625F6C61796F75745F4C61796F75745574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6173426F756E647329';
wwv_flow_imp.g_varchar2_table(1958) := '28706C616E655472626C293B0A7D0A0A2F2A2A0A202A2040706172616D207B4D6F64646C65456C656D656E747D20627573696E6573734F626A6563740A202A2040706172616D207B43616E766173506C616E657D20706C616E650A202A0A202A20407265';
wwv_flow_imp.g_varchar2_table(1959) := '7475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E2073686F756C644D6F7665546F506C616E6528627573696E6573734F626A6563742C20706C616E6529207B0A202076617220706172656E74203D20627573696E6573734F626A656374';
wwv_flow_imp.g_varchar2_table(1960) := '2E24706172656E743B0A0A20202F2F20646F6E2774206D6F766520656C656D656E747320746861742061726520616C7265616479206F6E2074686520706C616E650A2020696620282128302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B';
wwv_flow_imp.g_varchar2_table(1961) := '5F494D504F525445445F4D4F44554C455F305F5F2E69732928706172656E742C202762706D6E3A53756250726F636573732729207C7C20706172656E74203D3D3D20706C616E652E62706D6E456C656D656E7429207B0A2020202072657475726E206661';
wwv_flow_imp.g_varchar2_table(1962) := '6C73653B0A20207D0A0A20202F2F20646174614173736F63696174696F6E7320617265206368696C6472656E206F66207468652073756270726F63657373206275742072656E6465726564206F6E2070726F63657373206C6576656C0A20202F2F206366';
wwv_flow_imp.g_varchar2_table(1963) := '2E2068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F62706D6E2D6A732F6973737565732F313631390A20206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F30';
wwv_flow_imp.g_varchar2_table(1964) := '5F5F2E6973416E792928627573696E6573734F626A6563742C205B202762706D6E3A44617461496E7075744173736F63696174696F6E272C202762706D6E3A446174614F75747075744173736F63696174696F6E27205D2929207B0A2020202072657475';
wwv_flow_imp.g_varchar2_table(1965) := '726E2066616C73653B0A20207D0A0A202072657475726E20747275653B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F696E';
wwv_flow_imp.g_varchar2_table(1966) := '6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F';
wwv_flow_imp.g_varchar2_table(1967) := '62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(1968) := '2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061';
wwv_flow_imp.g_varchar2_table(1969) := '636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C';
wwv_flow_imp.g_varchar2_table(1970) := '207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A20';
wwv_flow_imp.g_varchar2_table(1971) := '6861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F66656174757265735F6F7665726C6179735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F72657175';
wwv_flow_imp.g_varchar2_table(1972) := '6972655F5F282F2A21206469616772616D2D6A732F6C69622F66656174757265732F6F7665726C617973202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F7665726C6179732F696E646578';
wwv_flow_imp.g_varchar2_table(1973) := '2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F66656174757265735F6368616E67655F737570706F72745F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F20';
wwv_flow_imp.g_varchar2_table(1974) := '3D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F66656174757265732F6368616E67652D737570706F7274202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66';
wwv_flow_imp.g_varchar2_table(1975) := '656174757265732F6368616E67652D737570706F72742F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F66656174757265735F726F6F745F656C656D656E74735F5F57';
wwv_flow_imp.g_varchar2_table(1976) := '45425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F66656174757265732F726F6F742D656C656D656E7473202A2F20222E2F6E6F64';
wwv_flow_imp.g_varchar2_table(1977) := '655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F726F6F742D656C656D656E74732F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F4472696C6C646F776E4272656164';
wwv_flow_imp.g_varchar2_table(1978) := '6372756D62735F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4472696C6C646F776E42726561646372756D6273202A2F20222E2F6E6F64655F6D6F6475';
wwv_flow_imp.g_varchar2_table(1979) := '6C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F4472696C6C646F776E42726561646372756D62732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F4472696C6C646F776E43656E';
wwv_flow_imp.g_varchar2_table(1980) := '746572696E675F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4472696C6C646F776E43656E746572696E67202A2F20222E2F6E6F64655F6D6F64756C65';
wwv_flow_imp.g_varchar2_table(1981) := '732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F4472696C6C646F776E43656E746572696E672E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F53756270726F63657373436F6D706174';
wwv_flow_imp.g_varchar2_table(1982) := '6962696C6974795F5F5745425041434B5F494D504F525445445F4D4F44554C455F365F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F53756270726F63657373436F6D7061746962696C697479202A2F20222E2F6E6F64655F';
wwv_flow_imp.g_varchar2_table(1983) := '6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F53756270726F63657373436F6D7061746962696C6974792E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F4472696C6C';
wwv_flow_imp.g_varchar2_table(1984) := '646F776E4F7665726C61794265686176696F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4472696C6C646F776E4F7665726C61794265686176696F';
wwv_flow_imp.g_varchar2_table(1985) := '72202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F4472696C6C646F776E4F7665726C61794265686176696F722E6A7322293B0A0A0A0A0A0A0A0A0A0A2F2A206861726D6F';
wwv_flow_imp.g_varchar2_table(1986) := '6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F646570656E64735F5F3A205B206469616772616D5F6A735F6C69625F66656174757265735F';
wwv_flow_imp.g_varchar2_table(1987) := '6F7665726C6179735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D2C206469616772616D5F6A735F6C69625F66656174757265735F6368616E67655F737570706F72745F5F5745425041434B5F494D';
wwv_flow_imp.g_varchar2_table(1988) := '504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D2C206469616772616D5F6A735F6C69625F66656174757265735F726F6F745F656C656D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F5B226465';
wwv_flow_imp.g_varchar2_table(1989) := '6661756C74225D205D2C0A20205F5F696E69745F5F3A205B20276472696C6C646F776E42726561646372756D6273272C20276472696C6C646F776E4F7665726C61794265686176696F72272C20276472696C6C646F776E43656E746572696E67272C2027';
wwv_flow_imp.g_varchar2_table(1990) := '73756270726F63657373436F6D7061746962696C69747927205D2C0A20206472696C6C646F776E42726561646372756D62733A205B202774797065272C205F4472696C6C646F776E42726561646372756D62735F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(1991) := '445F4D4F44554C455F335F5F5B2264656661756C74225D205D2C0A20206472696C6C646F776E43656E746572696E673A205B202774797065272C205F4472696C6C646F776E43656E746572696E675F5F5745425041434B5F494D504F525445445F4D4F44';
wwv_flow_imp.g_varchar2_table(1992) := '554C455F345F5F5B2264656661756C74225D205D2C0A20206472696C6C646F776E4F7665726C61794265686176696F723A205B202774797065272C205F4472696C6C646F776E4F7665726C61794265686176696F725F5F5745425041434B5F494D504F52';
wwv_flow_imp.g_varchar2_table(1993) := '5445445F4D4F44554C455F355F5F5B2264656661756C74225D205D2C0A202073756270726F63657373436F6D7061746962696C6974793A205B202774797065272C205F53756270726F63657373436F6D7061746962696C6974795F5F5745425041434B5F';
wwv_flow_imp.g_varchar2_table(1994) := '494D504F525445445F4D4F44554C455F365F5F5B2264656661756C74225D205D0A7D293B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6F75746C696E652F';
wwv_flow_imp.g_varchar2_table(1995) := '4F75746C696E6550726F76696465722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020';
wwv_flow_imp.g_varchar2_table(1996) := '212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6F75746C696E652F4F75746C696E6550726F76696465722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(1997) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F';
wwv_flow_imp.g_varchar2_table(1998) := '2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F77656270';
wwv_flow_imp.g_varchar2_table(1999) := '61636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F204F75746C696E';
wwv_flow_imp.g_varchar2_table(2000) := '6550726F7669646572290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D';
wwv_flow_imp.g_varchar2_table(2001) := '205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274';
wwv_flow_imp.g_varchar2_table(2002) := '202A2F207661722074696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F';
wwv_flow_imp.g_varchar2_table(2003) := '74696E792D7376672F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F20';
wwv_flow_imp.g_varchar2_table(2004) := '3D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A2F';
wwv_flow_imp.g_varchar2_table(2005) := '2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4C6162656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E';
wwv_flow_imp.g_varchar2_table(2006) := '2F7574696C2F4C6162656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F4F7574';
wwv_flow_imp.g_varchar2_table(2007) := '6C696E655574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4F75746C696E655574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D';
wwv_flow_imp.g_varchar2_table(2008) := '6E2D6A732F6C69622F66656174757265732F6F75746C696E652F4F75746C696E655574696C2E6A7322293B0A0A0A0A0A0A0A0A0A0A0A636F6E73742044454641554C545F4F4646534554203D20353B0A0A2F2A2A0A202A2042504D4E2D73706563696669';
wwv_flow_imp.g_varchar2_table(2009) := '63206F75746C696E652070726F76696465722E0A202A0A202A2040696D706C656D656E7473207B426173654F75746C696E6550726F76696465727D0A202A0A202A2040706172616D207B4F75746C696E657D206F75746C696E650A202A2040706172616D';
wwv_flow_imp.g_varchar2_table(2010) := '207B5374796C65737D207374796C65730A202A2F0A66756E6374696F6E204F75746C696E6550726F7669646572286F75746C696E652C207374796C657329207B0A0A2020746869732E5F7374796C6573203D207374796C65733B0A20206F75746C696E65';
wwv_flow_imp.g_varchar2_table(2011) := '2E726567697374657250726F76696465722874686973293B0A7D0A0A4F75746C696E6550726F76696465722E24696E6A656374203D205B0A2020276F75746C696E65272C0A2020277374796C6573270A5D3B0A0A2F2A2A0A202A2052657475726E73206F';
wwv_flow_imp.g_varchar2_table(2012) := '75746C696E6520666F72206120676976656E20656C656D656E742E0A202A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B4F75746C696E657D0A202A2F0A4F75746C696E6550726F766964';
wwv_flow_imp.g_varchar2_table(2013) := '65722E70726F746F747970652E6765744F75746C696E65203D2066756E6374696F6E28656C656D656E7429207B0A0A2020636F6E7374204F55544C494E455F5354594C45203D20746869732E5F7374796C65732E636C732827646A732D6F75746C696E65';
wwv_flow_imp.g_varchar2_table(2014) := '272C205B20276E6F2D66696C6C27205D293B0A0A2020766172206F75746C696E653B0A0A20206966202828302C5F7574696C5F4C6162656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734C6162656C292865';
wwv_flow_imp.g_varchar2_table(2015) := '6C656D656E742929207B0A2020202072657475726E3B0A20207D0A0A20206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69732928656C656D656E742C202762706D6E';
wwv_flow_imp.g_varchar2_table(2016) := '3A47617465776179272929207B0A202020206F75746C696E65203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6372656174652928277265637427293B0A0A2020202028302C6D696E5F6461';
wwv_flow_imp.g_varchar2_table(2017) := '73685F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E61737369676E29286F75746C696E652E7374796C652C207B0A202020202020277472616E73666F726D2D626F78273A202766696C6C2D626F78272C0A2020202020202774';
wwv_flow_imp.g_varchar2_table(2018) := '72616E73666F726D273A2027726F7461746528343564656729272C0A202020202020277472616E73666F726D2D6F726967696E273A202763656E746572270A202020207D293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D50';
wwv_flow_imp.g_varchar2_table(2019) := '4F525445445F4D4F44554C455F325F5F2E6174747229286F75746C696E652C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E61737369676E29287B0A202020202020783A20322C0A2020202020';
wwv_flow_imp.g_varchar2_table(2020) := '20793A20322C0A20202020202072783A20342C0A20202020202077696474683A20656C656D656E742E7769647468202D20342C0A2020202020206865696768743A20656C656D656E742E686569676874202D20342C0A202020207D2C204F55544C494E45';
wwv_flow_imp.g_varchar2_table(2021) := '5F5354594C4529293B0A0A20207D20656C7365206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973416E792928656C656D656E742C205B202762706D6E3A5461736B';
wwv_flow_imp.g_varchar2_table(2022) := '272C202762706D6E3A53756250726F63657373272C202762706D6E3A47726F7570272C202762706D6E3A43616C6C416374697669747927205D2929207B0A202020206F75746C696E65203D2028302C74696E795F7376675F5F5745425041434B5F494D50';
wwv_flow_imp.g_varchar2_table(2023) := '4F525445445F4D4F44554C455F325F5F2E6372656174652928277265637427293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6174747229286F75746C696E652C2028302C6D69';
wwv_flow_imp.g_varchar2_table(2024) := '6E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E61737369676E29287B0A202020202020783A202D44454641554C545F4F46465345542C0A202020202020793A202D44454641554C545F4F46465345542C0A2020';
wwv_flow_imp.g_varchar2_table(2025) := '2020202072783A2031342C0A20202020202077696474683A20656C656D656E742E7769647468202B2044454641554C545F4F4646534554202A20322C0A2020202020206865696768743A20656C656D656E742E686569676874202B2044454641554C545F';
wwv_flow_imp.g_varchar2_table(2026) := '4F4646534554202A20320A202020207D2C204F55544C494E455F5354594C4529293B0A0A20207D20656C7365206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E697329';
wwv_flow_imp.g_varchar2_table(2027) := '28656C656D656E742C202762706D6E3A456E644576656E74272929207B0A0A202020206F75746C696E65203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E637265617465292827636972636C';
wwv_flow_imp.g_varchar2_table(2028) := '6527293B0A0A202020202F2F20457874726120317078206F6666736574206E65656465642064756520746F20696E63726561736564207374726F6B652D7769647468206F6620656E64206576656E740A202020202F2F207768696368206D616B65732069';
wwv_flow_imp.g_varchar2_table(2029) := '7420626967676572207468616E206F74686572206576656E74732E0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6174747229286F75746C696E652C2028302C6D696E5F64617368';
wwv_flow_imp.g_varchar2_table(2030) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E61737369676E29287B0A20202020202063783A20656C656D656E742E7769647468202F20322C0A20202020202063793A20656C656D656E742E686569676874202F20322C0A20';
wwv_flow_imp.g_varchar2_table(2031) := '2020202020723A20656C656D656E742E7769647468202F2032202B2044454641554C545F4F4646534554202B20310A202020207D2C204F55544C494E455F5354594C4529293B0A0A20207D20656C7365206966202828302C5F7574696C5F4D6F64656C55';
wwv_flow_imp.g_varchar2_table(2032) := '74696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69732928656C656D656E742C202762706D6E3A4576656E74272929207B0A202020206F75746C696E65203D2028302C74696E795F7376675F5F5745425041434B5F494D';
wwv_flow_imp.g_varchar2_table(2033) := '504F525445445F4D4F44554C455F325F5F2E637265617465292827636972636C6527293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6174747229286F75746C696E652C202830';
wwv_flow_imp.g_varchar2_table(2034) := '2C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E61737369676E29287B0A20202020202063783A20656C656D656E742E7769647468202F20322C0A20202020202063793A20656C656D656E742E68656967';
wwv_flow_imp.g_varchar2_table(2035) := '6874202F20322C0A202020202020723A20656C656D656E742E7769647468202F2032202B2044454641554C545F4F46465345540A202020207D2C204F55544C494E455F5354594C4529293B0A0A20207D20656C7365206966202828302C5F7574696C5F4D';
wwv_flow_imp.g_varchar2_table(2036) := '6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69732928656C656D656E742C202762706D6E3A446174614F626A6563745265666572656E636527292026262069735374616E6461726453697A6528656C65';
wwv_flow_imp.g_varchar2_table(2037) := '6D656E742C202762706D6E3A446174614F626A6563745265666572656E6365272929207B0A0A202020206F75746C696E65203D2028302C5F4F75746C696E655574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E637265';
wwv_flow_imp.g_varchar2_table(2038) := '6174655061746829280A2020202020205F4F75746C696E655574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E444154415F4F424A4543545F5245464552454E43455F4F55544C494E455F504154482C0A202020202020';
wwv_flow_imp.g_varchar2_table(2039) := '7B20783A202D362C20793A202D36207D2C0A2020202020204F55544C494E455F5354594C450A20202020293B0A0A20207D20656C7365206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(2040) := '4C455F315F5F2E69732928656C656D656E742C202762706D6E3A4461746153746F72655265666572656E636527292026262069735374616E6461726453697A6528656C656D656E742C202762706D6E3A4461746153746F72655265666572656E63652729';
wwv_flow_imp.g_varchar2_table(2041) := '29207B0A0A202020206F75746C696E65203D2028302C5F4F75746C696E655574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E6372656174655061746829280A2020202020205F4F75746C696E655574696C5F5F574542';
wwv_flow_imp.g_varchar2_table(2042) := '5041434B5F494D504F525445445F4D4F44554C455F345F5F2E444154415F53544F52455F5245464552454E43455F4F55544C494E455F504154482C0A2020202020207B20783A202D362C20793A202D36207D2C0A2020202020204F55544C494E455F5354';
wwv_flow_imp.g_varchar2_table(2043) := '594C450A20202020293B0A20207D0A0A202072657475726E206F75746C696E653B0A7D3B0A0A2F2A2A0A202A205570646174657320746865206F75746C696E6520666F72206120676976656E20656C656D656E742E0A202A2052657475726E7320747275';
wwv_flow_imp.g_varchar2_table(2044) := '65206966207468652075706461746520666F722074686520676976656E20656C656D656E74207761732068616E646C656420627920746869732070726F76696465722E0A202A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A20';
wwv_flow_imp.g_varchar2_table(2045) := '2A2040706172616D207B4F75746C696E657D206F75746C696E650A202A204072657475726E73207B626F6F6C65616E7D0A202A2F0A4F75746C696E6550726F76696465722E70726F746F747970652E7570646174654F75746C696E65203D2066756E6374';
wwv_flow_imp.g_varchar2_table(2046) := '696F6E28656C656D656E742C206F75746C696E6529207B0A0A20206966202828302C5F7574696C5F4C6162656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734C6162656C2928656C656D656E742929207B0A';
wwv_flow_imp.g_varchar2_table(2047) := '2020202072657475726E3B0A20207D0A0A20206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973416E792928656C656D656E742C205B202762706D6E3A5375625072';
wwv_flow_imp.g_varchar2_table(2048) := '6F63657373272C202762706D6E3A47726F757027205D2929207B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6174747229286F75746C696E652C207B0A20202020202077696474';
wwv_flow_imp.g_varchar2_table(2049) := '683A20656C656D656E742E7769647468202B2044454641554C545F4F4646534554202A20322C0A2020202020206865696768743A20656C656D656E742E686569676874202B2044454641554C545F4F4646534554202A20320A202020207D293B0A0A2020';
wwv_flow_imp.g_varchar2_table(2050) := '202072657475726E20747275653B0A0A20207D20656C7365206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973416E792928656C656D656E742C205B0A2020202027';
wwv_flow_imp.g_varchar2_table(2051) := '62706D6E3A4576656E74272C0A202020202762706D6E3A47617465776179272C0A202020202762706D6E3A4461746153746F72655265666572656E6365272C0A202020202762706D6E3A446174614F626A6563745265666572656E6365270A20205D2929';
wwv_flow_imp.g_varchar2_table(2052) := '207B0A2020202072657475726E20747275653B0A20207D0A0A202072657475726E2066616C73653B0A7D3B0A0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F0A0A66756E6374696F6E2069735374616E6461726453697A6528656C656D656E74';
wwv_flow_imp.g_varchar2_table(2053) := '2C207479706529207B0A2020766172207374616E6461726453697A653B0A0A20206966202874797065203D3D3D202762706D6E3A446174614F626A6563745265666572656E63652729207B0A202020207374616E6461726453697A65203D205F4F75746C';
wwv_flow_imp.g_varchar2_table(2054) := '696E655574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E444154415F4F424A4543545F5245464552454E43455F5354414E444152445F53495A453B0A20207D20656C7365206966202874797065203D3D3D202762706D';
wwv_flow_imp.g_varchar2_table(2055) := '6E3A4461746153746F72655265666572656E63652729207B0A202020207374616E6461726453697A65203D205F4F75746C696E655574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E444154415F53544F52455F524546';
wwv_flow_imp.g_varchar2_table(2056) := '4552454E43455F5354414E444152445F53495A453B0A20207D0A0A202072657475726E20656C656D656E742E7769647468203D3D3D207374616E6461726453697A652E77696474680A20202020202020202020262620656C656D656E742E686569676874';
wwv_flow_imp.g_varchar2_table(2057) := '203D3D3D207374616E6461726453697A652E6865696768743B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6F75746C696E652F4F75746C696E655574';
wwv_flow_imp.g_varchar2_table(2058) := '696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C';
wwv_flow_imp.g_varchar2_table(2059) := '65732F62706D6E2D6A732F6C69622F66656174757265732F6F75746C696E652F4F75746C696E655574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(2060) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E';
wwv_flow_imp.g_varchar2_table(2061) := '207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(2062) := '5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020444154415F4F424A4543545F5245464552454E43455F4F55544C494E455F504154483A202829203D3E20282F2A2062696E64696E67202A2F20444154415F4F';
wwv_flow_imp.g_varchar2_table(2063) := '424A4543545F5245464552454E43455F4F55544C494E455F50415448292C0A2F2A206861726D6F6E79206578706F7274202A2F202020444154415F4F424A4543545F5245464552454E43455F5354414E444152445F53495A453A202829203D3E20282F2A';
wwv_flow_imp.g_varchar2_table(2064) := '2062696E64696E67202A2F20444154415F4F424A4543545F5245464552454E43455F5354414E444152445F53495A45292C0A2F2A206861726D6F6E79206578706F7274202A2F202020444154415F53544F52455F5245464552454E43455F4F55544C494E';
wwv_flow_imp.g_varchar2_table(2065) := '455F504154483A202829203D3E20282F2A2062696E64696E67202A2F20444154415F53544F52455F5245464552454E43455F4F55544C494E455F50415448292C0A2F2A206861726D6F6E79206578706F7274202A2F202020444154415F53544F52455F52';
wwv_flow_imp.g_varchar2_table(2066) := '45464552454E43455F5354414E444152445F53495A453A202829203D3E20282F2A2062696E64696E67202A2F20444154415F53544F52455F5245464552454E43455F5354414E444152445F53495A45292C0A2F2A206861726D6F6E79206578706F727420';
wwv_flow_imp.g_varchar2_table(2067) := '2A2F202020637265617465506174683A202829203D3E20282F2A2062696E64696E67202A2F2063726561746550617468290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076617220';
wwv_flow_imp.g_varchar2_table(2068) := '74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D737667';
wwv_flow_imp.g_varchar2_table(2069) := '2F646973742F696E6465782E65736D2E6A7322293B0A0A0A636F6E737420444154415F4F424A4543545F5245464552454E43455F4F55544C494E455F50415448203D20274D34342E373634382031312E333236334C33362E3938393220322E3634303734';
wwv_flow_imp.g_varchar2_table(2070) := '4333362E3034353120312E35383632382033342E3536353120302E3938383730382033332E3139303420302E39383837303848352E393836363743332E323236383820302E39383837303820302E39383936323420332E333438393220302E3938393632';
wwv_flow_imp.g_varchar2_table(2071) := '3420362E32363033395635352E3032333543302E3938393632342035372E3933343920332E32323638382036302E3239353220352E39383636372036302E323935324834302E3936364334332E373235372036302E323935322034352E3936332035372E';
wwv_flow_imp.g_varchar2_table(2072) := '393334392034352E3936332035352E303233355631342E393435394334352E3936332031332E353939382034352E363430372031322E333034382034342E373634382031312E333236335A273B0A636F6E737420444154415F53544F52455F5245464552';
wwv_flow_imp.g_varchar2_table(2073) := '454E43455F4F55544C494E455F50415448203D20274D312E30333834352034382E3133343743312E30333834352034392E3335313120312E30373239352035302E37353820312E33383334322035322E30363443312E36393934392035332E3339333820';
wwv_flow_imp.g_varchar2_table(2074) := '322E33323432382035342E3731353420332E35363338332035352E3634323843362E30323533332035372E343834312031302E313136312035382E373638352031342E383231322035392E363036374331392E353737322036302E343533382032352E31';
wwv_flow_imp.g_varchar2_table(2075) := '3338382036302E383733382033302E363833312036302E383733384333362E323237362036302E383733382034312E373839312036302E343533382034362E3534352035392E363036374335312E323530342035382E373638372035352E333431322035';
wwv_flow_imp.g_varchar2_table(2076) := '372E343834322035372E383032382035352E363432394335392E303432342035342E373135362035392E363637332035332E333933382035392E393833342035322E3036344336302E323933382035302E373537392036302E333238352034392E333531';
wwv_flow_imp.g_varchar2_table(2077) := '2036302E333238352034382E313334345631332E383431354336302E333238352031322E363234392036302E323933382031312E3231382035392E3938333420392E39313137314335392E3636373320382E35383139342035392E3034323320372E3236';
wwv_flow_imp.g_varchar2_table(2078) := '30322035372E3830323720362E33333239344335352E33343120342E34393136382035312E3235303320332E32303732332034362E35343520322E33363931344334312E3738393120312E3532322033362E3232373620312E31303230342033302E3638';
wwv_flow_imp.g_varchar2_table(2079) := '333120312E31303230354332352E3133383820312E31303230362031392E3537373220312E35323230362031342E3832313320322E33363932334331302E3131363220332E323037333420362E303235343320342E343931383320332E3536333920362E';
wwv_flow_imp.g_varchar2_table(2080) := '333333313443322E333234333320372E323630333820312E363939353120382E353832303620312E333833343320392E393131383143312E30373239352031312E3231373920312E30333834352031322E3632343720312E30333834352031332E383431';
wwv_flow_imp.g_varchar2_table(2081) := '315634382E313334375A273B0A0A2F2A2A0A202A204074797065207B44696D656E73696F6E737D0A202A2F0A636F6E737420444154415F4F424A4543545F5245464552454E43455F5354414E444152445F53495A45203D207B2077696474683A2033362C';
wwv_flow_imp.g_varchar2_table(2082) := '206865696768743A203530207D3B0A0A2F2A2A0A202A204074797065207B44696D656E73696F6E737D0A202A2F0A636F6E737420444154415F53544F52455F5245464552454E43455F5354414E444152445F53495A45203D207B2077696474683A203530';
wwv_flow_imp.g_varchar2_table(2083) := '2C206865696768743A203530207D3B0A0A2F2A2A0A202A204372656174652061207061746820656C656D656E74207769746820676976656E20617474726962757465732E0A202A2040706172616D207B737472696E677D20706174680A202A2040706172';
wwv_flow_imp.g_varchar2_table(2084) := '616D207B4F626A6563747D2061747472730A202A2040706172616D207B4F626A6563747D204F55544C494E455F5354594C450A202A204072657475726E207B535647456C656D656E747D0A202A2F0A66756E6374696F6E20637265617465506174682870';
wwv_flow_imp.g_varchar2_table(2085) := '6174682C2061747472732C204F55544C494E455F5354594C4529207B0A202072657475726E2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E63726561746529282770617468272C207B0A202020';
wwv_flow_imp.g_varchar2_table(2086) := '20643A20706174682C0A202020207374726F6B6557696474683A20322C0A202020207472616E73666F726D3A20607472616E736C61746528247B61747472732E787D2C20247B61747472732E797D29602C0A202020202E2E2E4F55544C494E455F535459';
wwv_flow_imp.g_varchar2_table(2087) := '4C450A20207D293B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6F75746C696E652F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(2088) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6F75746C69';
wwv_flow_imp.g_varchar2_table(2089) := '6E652F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F77';
wwv_flow_imp.g_varchar2_table(2090) := '65627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F72';
wwv_flow_imp.g_varchar2_table(2091) := '74735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F20202022646566';
wwv_flow_imp.g_varchar2_table(2092) := '61756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F';
wwv_flow_imp.g_varchar2_table(2093) := '6A735F6C69625F66656174757265735F6F75746C696E655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F666561747572';
wwv_flow_imp.g_varchar2_table(2094) := '65732F6F75746C696E65202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F75746C696E652F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F';
wwv_flow_imp.g_varchar2_table(2095) := '4F75746C696E6550726F76696465725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4F75746C696E6550726F7669646572202A2F20222E2F6E6F64655F';
wwv_flow_imp.g_varchar2_table(2096) := '6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6F75746C696E652F4F75746C696E6550726F76696465722E6A7322293B0A0A0A0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F57';
wwv_flow_imp.g_varchar2_table(2097) := '45425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F646570656E64735F5F3A205B0A202020206469616772616D5F6A735F6C69625F66656174757265735F6F75746C696E655F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(2098) := '4D4F44554C455F305F5F5B2264656661756C74225D0A20205D2C0A20205F5F696E69745F5F3A205B20276F75746C696E6550726F766964657227205D2C0A20206F75746C696E6550726F76696465723A205B202774797065272C205F4F75746C696E6550';
wwv_flow_imp.g_varchar2_table(2099) := '726F76696465725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D205D0A7D293B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C6962';
wwv_flow_imp.g_varchar2_table(2100) := '2F696D706F72742F42706D6E496D706F727465722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E';
wwv_flow_imp.g_varchar2_table(2101) := '6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F42706D6E496D706F727465722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(2102) := '2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F776562';
wwv_flow_imp.g_varchar2_table(2103) := '7061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F';
wwv_flow_imp.g_varchar2_table(2104) := '5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F2042706D6E496D706F72746572290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F';
wwv_flow_imp.g_varchar2_table(2105) := '2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20';
wwv_flow_imp.g_varchar2_table(2106) := '222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(2107) := '525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4D6F6465';
wwv_flow_imp.g_varchar2_table(2108) := '6C5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4C6162656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F203D205F5F7765627061636B5F726571756972';
wwv_flow_imp.g_varchar2_table(2109) := '655F5F282F2A21202E2E2F7574696C2F4C6162656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4C6162656C5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076';
wwv_flow_imp.g_varchar2_table(2110) := '6172206469616772616D5F6A735F6C69625F6C61796F75745F4C61796F75745574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A';
wwv_flow_imp.g_varchar2_table(2111) := '732F6C69622F6C61796F75742F4C61796F75745574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6C61796F75742F4C61796F75745574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F727420';
wwv_flow_imp.g_varchar2_table(2112) := '2A2F20766172205F7574696C5F44695574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F44695574696C202A2F20222E2F6E6F6465';
wwv_flow_imp.g_varchar2_table(2113) := '5F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F44695574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D';
wwv_flow_imp.g_varchar2_table(2114) := '205F5F7765627061636B5F726571756972655F5F282F2A21202E2F5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F5574696C2E6A7322293B0A0A0A0A0A0A0A0A0A0A0A0A0A2F2A2A0A202A20';
wwv_flow_imp.g_varchar2_table(2115) := '4074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F43616E76617327292E64656661756C747D2043616E7661730A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F63';
wwv_flow_imp.g_varchar2_table(2116) := '6F72652F456C656D656E74526567697374727927292E64656661756C747D20456C656D656E7452656769737472790A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64';
wwv_flow_imp.g_varchar2_table(2117) := '656661756C747D204576656E744275730A202A0A202A204074797065646566207B696D706F727428272E2E2F66656174757265732F6D6F64656C696E672F456C656D656E74466163746F727927292E64656661756C747D20456C656D656E74466163746F';
wwv_flow_imp.g_varchar2_table(2118) := '72790A202A204074797065646566207B696D706F727428272E2E2F647261772F5465787452656E646572657227292E64656661756C747D205465787452656E64657265720A202A0A202A204074797065646566207B696D706F727428272E2E2F6D6F6465';
wwv_flow_imp.g_varchar2_table(2119) := '6C2F547970657327292E456C656D656E747D20456C656D656E740A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4C6162656C7D204C6162656C0A202A204074797065646566207B696D706F727428272E';
wwv_flow_imp.g_varchar2_table(2120) := '2E2F6D6F64656C2F547970657327292E53686170657D2053686170650A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E436F6E6E656374696F6E7D20436F6E6E656374696F6E0A202A2040747970656465';
wwv_flow_imp.g_varchar2_table(2121) := '66207B696D706F727428272E2E2F6D6F64656C2F547970657327292E526F6F747D20526F6F740A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C';
wwv_flow_imp.g_varchar2_table(2122) := '656D656E740A202A2F0A0A2F2A2A0A202A2040706172616D207B4D6F64646C65456C656D656E747D2073656D616E7469630A202A2040706172616D207B4D6F64646C65456C656D656E747D2064690A202A2040706172616D207B4F626A6563747D205B61';
wwv_flow_imp.g_varchar2_table(2123) := '747472733D6E756C6C5D0A202A0A202A204072657475726E207B4F626A6563747D0A202A2F0A66756E6374696F6E20656C656D656E74446174612873656D616E7469632C2064692C20617474727329207B0A202072657475726E2028302C6D696E5F6461';
wwv_flow_imp.g_varchar2_table(2124) := '73685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E29287B0A2020202069643A2073656D616E7469632E69642C0A20202020747970653A2073656D616E7469632E24747970652C0A20202020627573696E6573';
wwv_flow_imp.g_varchar2_table(2125) := '734F626A6563743A2073656D616E7469632C0A2020202064693A2064690A20207D2C206174747273293B0A7D0A0A66756E6374696F6E20676574576179706F696E74732864692C20736F757263652C2074617267657429207B0A0A202076617220776179';
wwv_flow_imp.g_varchar2_table(2126) := '706F696E7473203D2064692E776179706F696E743B0A0A20206966202821776179706F696E7473207C7C20776179706F696E74732E6C656E677468203C203229207B0A2020202072657475726E205B2028302C6469616772616D5F6A735F6C69625F6C61';
wwv_flow_imp.g_varchar2_table(2127) := '796F75745F4C61796F75745574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6765744D69642928736F75726365292C2028302C6469616772616D5F6A735F6C69625F6C61796F75745F4C61796F75745574696C5F5F57';
wwv_flow_imp.g_varchar2_table(2128) := '45425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6765744D6964292874617267657429205D3B0A20207D0A0A202072657475726E20776179706F696E74732E6D61702866756E6374696F6E287029207B0A2020202072657475726E207B';
wwv_flow_imp.g_varchar2_table(2129) := '20783A20702E782C20793A20702E79207D3B0A20207D293B0A7D0A0A66756E6374696F6E206E6F74596574447261776E2873656D616E7469632C2072656653656D616E7469632C2070726F706572747929207B0A202072657475726E206E657720457272';
wwv_flow_imp.g_varchar2_table(2130) := '6F72280A2020202060656C656D656E7420247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E656C656D656E74546F537472696E67292872656653656D616E74696329207D207265666572656E636564';
wwv_flow_imp.g_varchar2_table(2131) := '20627920247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E656C656D656E74546F537472696E67292873656D616E74696329207D23247B2070726F7065727479207D206E6F74207965742064726177';
wwv_flow_imp.g_varchar2_table(2132) := '6E600A2020293B0A7D0A0A0A2F2A2A0A202A20416E20696D706F72746572207468617420616464732062706D6E20656C656D656E747320746F207468652063616E7661730A202A0A202A2040706172616D207B4576656E744275737D206576656E744275';
wwv_flow_imp.g_varchar2_table(2133) := '730A202A2040706172616D207B43616E7661737D2063616E7661730A202A2040706172616D207B456C656D656E74466163746F72797D20656C656D656E74466163746F72790A202A2040706172616D207B456C656D656E7452656769737472797D20656C';
wwv_flow_imp.g_varchar2_table(2134) := '656D656E7452656769737472790A202A2040706172616D207B5465787452656E64657265727D207465787452656E64657265720A202A2F0A66756E6374696F6E2042706D6E496D706F72746572280A202020206576656E744275732C2063616E7661732C';
wwv_flow_imp.g_varchar2_table(2135) := '20656C656D656E74466163746F72792C0A20202020656C656D656E7452656769737472792C207465787452656E646572657229207B0A0A2020746869732E5F6576656E74427573203D206576656E744275733B0A2020746869732E5F63616E766173203D';
wwv_flow_imp.g_varchar2_table(2136) := '2063616E7661733B0A2020746869732E5F656C656D656E74466163746F7279203D20656C656D656E74466163746F72793B0A2020746869732E5F656C656D656E745265676973747279203D20656C656D656E7452656769737472793B0A2020746869732E';
wwv_flow_imp.g_varchar2_table(2137) := '5F7465787452656E6465726572203D207465787452656E64657265723B0A7D0A0A42706D6E496D706F727465722E24696E6A656374203D205B0A2020276576656E74427573272C0A20202763616E766173272C0A202027656C656D656E74466163746F72';
wwv_flow_imp.g_varchar2_table(2138) := '79272C0A202027656C656D656E745265676973747279272C0A2020277465787452656E6465726572270A5D3B0A0A0A2F2A2A0A202A2041646420612042504D4E20656C656D656E74202873656D616E7469632920746F207468652063616E766173206D61';
wwv_flow_imp.g_varchar2_table(2139) := '6B696E672069742061206368696C64206F66207468650A202A20676976656E20706172656E742E0A202A0A202A2040706172616D207B4D6F64646C65456C656D656E747D2073656D616E7469630A202A2040706172616D207B4D6F64646C65456C656D65';
wwv_flow_imp.g_varchar2_table(2140) := '6E747D2064690A202A2040706172616D207B53686170657D20706172656E74456C656D656E740A202A0A202A204072657475726E207B5368617065207C20526F6F74207C20436F6E6E656374696F6E7D0A202A2F0A42706D6E496D706F727465722E7072';
wwv_flow_imp.g_varchar2_table(2141) := '6F746F747970652E616464203D2066756E6374696F6E2873656D616E7469632C2064692C20706172656E74456C656D656E7429207B0A202076617220656C656D656E742C0A20202020202068696464656E3B0A0A202076617220706172656E74496E6465';
wwv_flow_imp.g_varchar2_table(2142) := '783B0A0A20202F2F20524F4F5420454C454D454E540A20202F2F2068616E646C6520746865207370656369616C20636173652074686174207765206465616C207769746820610A20202F2F20696E76697369626C6520726F6F7420656C656D656E742028';
wwv_flow_imp.g_varchar2_table(2143) := '70726F636573732C2073756270726F63657373206F7220636F6C6C61626F726174696F6E290A20206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6973292864692C20';
wwv_flow_imp.g_varchar2_table(2144) := '2762706D6E64693A42504D4E506C616E65272929207B0A0A20202020766172206174747273203D2028302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6973292873656D616E746963';
wwv_flow_imp.g_varchar2_table(2145) := '2C202762706D6E3A53756250726F6365737327290A2020202020203F207B2069643A2073656D616E7469632E6964202B20275F706C616E6527207D0A2020202020203A207B7D3B0A0A202020202F2F206164642061207669727475616C20656C656D656E';
wwv_flow_imp.g_varchar2_table(2146) := '7420286E6F74206265696E6720647261776E290A20202020656C656D656E74203D20746869732E5F656C656D656E74466163746F72792E637265617465526F6F7428656C656D656E74446174612873656D616E7469632C2064692C20617474727329293B';
wwv_flow_imp.g_varchar2_table(2147) := '0A0A20202020746869732E5F63616E7661732E616464526F6F74456C656D656E7428656C656D656E74293B0A20207D0A0A20202F2F2053484150450A2020656C7365206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F49';
wwv_flow_imp.g_varchar2_table(2148) := '4D504F525445445F4D4F44554C455F335F5F2E6973292864692C202762706D6E64693A42504D4E5368617065272929207B0A0A2020202076617220636F6C6C6170736564203D202128302C5F7574696C5F44695574696C5F5F5745425041434B5F494D50';
wwv_flow_imp.g_varchar2_table(2149) := '4F525445445F4D4F44554C455F345F5F2E6973457870616E646564292873656D616E7469632C206469292C0A202020202020202069734672616D65203D2069734672616D65456C656D656E742873656D616E746963293B0A0A2020202068696464656E20';
wwv_flow_imp.g_varchar2_table(2150) := '3D20706172656E74456C656D656E742026262028706172656E74456C656D656E742E68696464656E207C7C20706172656E74456C656D656E742E636F6C6C6170736564293B0A0A2020202076617220626F756E6473203D2064692E626F756E64733B0A0A';
wwv_flow_imp.g_varchar2_table(2151) := '20202020656C656D656E74203D20746869732E5F656C656D656E74466163746F72792E637265617465536861706528656C656D656E74446174612873656D616E7469632C2064692C207B0A202020202020636F6C6C61707365643A20636F6C6C61707365';
wwv_flow_imp.g_varchar2_table(2152) := '642C0A20202020202068696464656E3A2068696464656E2C0A202020202020783A204D6174682E726F756E6428626F756E64732E78292C0A202020202020793A204D6174682E726F756E6428626F756E64732E79292C0A20202020202077696474683A20';
wwv_flow_imp.g_varchar2_table(2153) := '4D6174682E726F756E6428626F756E64732E7769647468292C0A2020202020206865696768743A204D6174682E726F756E6428626F756E64732E686569676874292C0A20202020202069734672616D653A2069734672616D650A202020207D29293B0A0A';
wwv_flow_imp.g_varchar2_table(2154) := '202020206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6973292873656D616E7469632C202762706D6E3A426F756E646172794576656E74272929207B0A2020202020';
wwv_flow_imp.g_varchar2_table(2155) := '20746869732E5F617474616368426F756E646172792873656D616E7469632C20656C656D656E74293B0A202020207D0A0A202020202F2F20696E73657274206C616E657320626568696E64206F7468657220666C6F77206E6F646573202863662E202337';
wwv_flow_imp.g_varchar2_table(2156) := '3237290A202020206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6973292873656D616E7469632C202762706D6E3A4C616E65272929207B0A20202020202070617265';
wwv_flow_imp.g_varchar2_table(2157) := '6E74496E646578203D20303B0A202020207D0A0A202020206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6973292873656D616E7469632C202762706D6E3A44617461';
wwv_flow_imp.g_varchar2_table(2158) := '53746F72655265666572656E6365272929207B0A0A2020202020202F2F20636865636B207768657468657220646174612073746F726520697320696E73696465206F7572206F757473696465206F66206974732073656D616E74696320706172656E740A';
wwv_flow_imp.g_varchar2_table(2159) := '20202020202069662028216973506F696E74496E7369646542426F7828706172656E74456C656D656E742C2028302C6469616772616D5F6A735F6C69625F6C61796F75745F4C61796F75745574696C5F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(2160) := '44554C455F315F5F2E6765744D69642928626F756E6473292929207B0A2020202020202020706172656E74456C656D656E74203D20746869732E5F63616E7661732E66696E64526F6F7428706172656E74456C656D656E74293B0A2020202020207D0A20';
wwv_flow_imp.g_varchar2_table(2161) := '2020207D0A0A20202020746869732E5F63616E7661732E616464536861706528656C656D656E742C20706172656E74456C656D656E742C20706172656E74496E646578293B0A20207D0A0A20202F2F20434F4E4E454354494F4E0A2020656C7365206966';
wwv_flow_imp.g_varchar2_table(2162) := '202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6973292864692C202762706D6E64693A42504D4E45646765272929207B0A0A2020202076617220736F75726365203D207468';
wwv_flow_imp.g_varchar2_table(2163) := '69732E5F676574536F757263652873656D616E746963292C0A2020202020202020746172676574203D20746869732E5F6765745461726765742873656D616E746963293B0A0A2020202068696464656E203D20706172656E74456C656D656E7420262620';
wwv_flow_imp.g_varchar2_table(2164) := '28706172656E74456C656D656E742E68696464656E207C7C20706172656E74456C656D656E742E636F6C6C6170736564293B0A0A20202020656C656D656E74203D20746869732E5F656C656D656E74466163746F72792E637265617465436F6E6E656374';
wwv_flow_imp.g_varchar2_table(2165) := '696F6E28656C656D656E74446174612873656D616E7469632C2064692C207B0A20202020202068696464656E3A2068696464656E2C0A202020202020736F757263653A20736F757263652C0A2020202020207461726765743A207461726765742C0A2020';
wwv_flow_imp.g_varchar2_table(2166) := '20202020776179706F696E74733A20676574576179706F696E74732864692C20736F757263652C20746172676574290A202020207D29293B0A0A202020206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F5254';
wwv_flow_imp.g_varchar2_table(2167) := '45445F4D4F44554C455F335F5F2E6973292873656D616E7469632C202762706D6E3A446174614173736F63696174696F6E272929207B0A0A2020202020202F2F2072656E64657220616C77617973206F6E20746F703B207468697320656E737572657320';
wwv_flow_imp.g_varchar2_table(2168) := '446174614173736F63696174696F6E730A2020202020202F2F206172652072656E646572656420636F72726563746C79206163726F737320646966666572656E7420226861636B73222070656F706C650A2020202020202F2F206C6F766520746F206D6F';
wwv_flow_imp.g_varchar2_table(2169) := '64656C20737563682061732063726F7373207061727469636970616E74202F207375622070726F636573730A2020202020202F2F206173736F63696174696F6E730A202020202020706172656E74456C656D656E74203D20746869732E5F63616E766173';
wwv_flow_imp.g_varchar2_table(2170) := '2E66696E64526F6F7428706172656E74456C656D656E74293B0A202020207D0A0A20202020746869732E5F63616E7661732E616464436F6E6E656374696F6E28656C656D656E742C20706172656E74456C656D656E742C20706172656E74496E64657829';
wwv_flow_imp.g_varchar2_table(2171) := '3B0A20207D20656C7365207B0A202020207468726F77206E6577204572726F72280A20202020202060756E6B6E6F776E20646920247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E656C656D656E74';
wwv_flow_imp.g_varchar2_table(2172) := '546F537472696E672928646929207D20666F7220656C656D656E7420247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E656C656D656E74546F537472696E67292873656D616E74696329207D600A20';
wwv_flow_imp.g_varchar2_table(2173) := '202020293B0A20207D0A0A20202F2F20286F7074696F6E616C29204C4142454C0A20206966202828302C5F7574696C5F4C6162656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E69734C6162656C45787465726E';
wwv_flow_imp.g_varchar2_table(2174) := '616C292873656D616E746963292026262028302C5F7574696C5F4C6162656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E6765744C6162656C2928656C656D656E742929207B0A20202020746869732E6164644C';
wwv_flow_imp.g_varchar2_table(2175) := '6162656C2873656D616E7469632C2064692C20656C656D656E74293B0A20207D0A0A2020746869732E5F6576656E744275732E66697265282762706D6E456C656D656E742E6164646564272C207B20656C656D656E743A20656C656D656E74207D293B0A';
wwv_flow_imp.g_varchar2_table(2176) := '0A202072657475726E20656C656D656E743B0A7D3B0A0A0A2F2A2A0A202A20417474616368206120626F756E6461727920656C656D656E7420746F2074686520676976656E20686F73742E0A202A0A202A2040706172616D207B4D6F64646C65456C656D';
wwv_flow_imp.g_varchar2_table(2177) := '656E747D20626F756E6461727953656D616E7469630A202A2040706172616D207B53686170657D20626F756E64617279456C656D656E740A202A2F0A42706D6E496D706F727465722E70726F746F747970652E5F617474616368426F756E64617279203D';
wwv_flow_imp.g_varchar2_table(2178) := '2066756E6374696F6E28626F756E6461727953656D616E7469632C20626F756E64617279456C656D656E7429207B0A202076617220686F737453656D616E746963203D20626F756E6461727953656D616E7469632E6174746163686564546F5265663B0A';
wwv_flow_imp.g_varchar2_table(2179) := '0A20206966202821686F737453656D616E74696329207B0A202020207468726F77206E6577204572726F72280A202020202020606D697373696E6720247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F';
wwv_flow_imp.g_varchar2_table(2180) := '2E656C656D656E74546F537472696E672928626F756E6461727953656D616E74696329207D236174746163686564546F526566600A20202020293B0A20207D0A0A202076617220686F7374203D20746869732E5F656C656D656E7452656769737472792E';
wwv_flow_imp.g_varchar2_table(2181) := '67657428686F737453656D616E7469632E6964292C0A202020202020617474616368657273203D20686F737420262620686F73742E6174746163686572733B0A0A20206966202821686F737429207B0A202020207468726F77206E6F7459657444726177';
wwv_flow_imp.g_varchar2_table(2182) := '6E28626F756E6461727953656D616E7469632C20686F737453656D616E7469632C20276174746163686564546F52656627293B0A20207D0A0A20202F2F207769726520656C656D656E742E686F7374203C3E20686F73742E6174746163686572730A2020';
wwv_flow_imp.g_varchar2_table(2183) := '626F756E64617279456C656D656E742E686F7374203D20686F73743B0A0A2020696620282161747461636865727329207B0A20202020686F73742E617474616368657273203D20617474616368657273203D205B5D3B0A20207D0A0A2020696620286174';
wwv_flow_imp.g_varchar2_table(2184) := '746163686572732E696E6465784F6628626F756E64617279456C656D656E7429203D3D3D202D3129207B0A202020206174746163686572732E7075736828626F756E64617279456C656D656E74293B0A20207D0A7D3B0A0A0A2F2A2A0A202A2041646420';
wwv_flow_imp.g_varchar2_table(2185) := '61206C6162656C20746F206120676976656E20656C656D656E742E0A202A0A202A2040706172616D207B4D6F64646C65456C656D656E747D2073656D616E7469630A202A2040706172616D207B4D6F64646C65456C656D656E747D2064690A202A204070';
wwv_flow_imp.g_varchar2_table(2186) := '6172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B4C6162656C7D0A202A2F0A42706D6E496D706F727465722E70726F746F747970652E6164644C6162656C203D2066756E6374696F6E2873656D616E746963';
wwv_flow_imp.g_varchar2_table(2187) := '2C2064692C20656C656D656E7429207B0A202076617220626F756E64732C0A202020202020746578742C0A2020202020206C6162656C3B0A0A2020626F756E6473203D2028302C5F7574696C5F4C6162656C5574696C5F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(2188) := '525445445F4D4F44554C455F355F5F2E67657445787465726E616C4C6162656C426F756E6473292864692C20656C656D656E74293B0A0A202074657874203D2028302C5F7574696C5F4C6162656C5574696C5F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(2189) := '5F4D4F44554C455F355F5F2E6765744C6162656C2928656C656D656E74293B0A0A2020696620287465787429207B0A0A202020202F2F2067657420636F7272656374656420626F756E64732066726F6D2061637475616C206C61796F7574656420746578';
wwv_flow_imp.g_varchar2_table(2190) := '740A20202020626F756E6473203D20746869732E5F7465787452656E64657265722E67657445787465726E616C4C6162656C426F756E647328626F756E64732C2074657874293B0A20207D0A0A20206C6162656C203D20746869732E5F656C656D656E74';
wwv_flow_imp.g_varchar2_table(2191) := '466163746F72792E6372656174654C6162656C28656C656D656E74446174612873656D616E7469632C2064692C207B0A2020202069643A2073656D616E7469632E6964202B20275F6C6162656C272C0A202020206C6162656C5461726765743A20656C65';
wwv_flow_imp.g_varchar2_table(2192) := '6D656E742C0A20202020747970653A20276C6162656C272C0A2020202068696464656E3A20656C656D656E742E68696464656E207C7C202128302C5F7574696C5F4C6162656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F';
wwv_flow_imp.g_varchar2_table(2193) := '355F5F2E6765744C6162656C2928656C656D656E74292C0A20202020783A204D6174682E726F756E6428626F756E64732E78292C0A20202020793A204D6174682E726F756E6428626F756E64732E79292C0A2020202077696474683A204D6174682E726F';
wwv_flow_imp.g_varchar2_table(2194) := '756E6428626F756E64732E7769647468292C0A202020206865696768743A204D6174682E726F756E6428626F756E64732E686569676874290A20207D29293B0A0A202072657475726E20746869732E5F63616E7661732E6164645368617065286C616265';
wwv_flow_imp.g_varchar2_table(2195) := '6C2C20656C656D656E742E706172656E74293B0A7D3B0A0A2F2A2A0A202A204765742074686520736F75726365206F7220746172676574206F662074686520676976656E20636F6E6E656374696F6E2E0A202A0A202A2040706172616D207B4D6F64646C';
wwv_flow_imp.g_varchar2_table(2196) := '65456C656D656E747D2073656D616E7469630A202A2040706172616D207B27736F7572636527207C2027746172676574277D20736964650A202A0A202A204072657475726E207B456C656D656E747D0A202A2F0A42706D6E496D706F727465722E70726F';
wwv_flow_imp.g_varchar2_table(2197) := '746F747970652E5F676574436F6E6E6563746564456C656D656E74203D2066756E6374696F6E2873656D616E7469632C207369646529207B0A0A202076617220656C656D656E742C0A20202020202072656653656D616E7469632C0A2020202020207479';
wwv_flow_imp.g_varchar2_table(2198) := '7065203D2073656D616E7469632E24747970653B0A0A202072656653656D616E746963203D2073656D616E7469635B73696465202B2027526566275D3B0A0A20202F2F2068616E646C65206D7973746572696F75732069734D616E792044617461417373';
wwv_flow_imp.g_varchar2_table(2199) := '6F63696174696F6E23736F757263655265660A20206966202873696465203D3D3D2027736F75726365272026262074797065203D3D3D202762706D6E3A44617461496E7075744173736F63696174696F6E2729207B0A2020202072656653656D616E7469';
wwv_flow_imp.g_varchar2_table(2200) := '63203D2072656653656D616E7469632026262072656653656D616E7469635B305D3B0A20207D0A0A20202F2F2066697820736F75726365202F2074617267657420666F722044617461496E7075744173736F63696174696F6E202F20446174614F757470';
wwv_flow_imp.g_varchar2_table(2201) := '75744173736F63696174696F6E0A20206966202873696465203D3D3D2027736F75726365272026262074797065203D3D3D202762706D6E3A446174614F75747075744173736F63696174696F6E27207C7C0A20202020202073696465203D3D3D20277461';
wwv_flow_imp.g_varchar2_table(2202) := '72676574272026262074797065203D3D3D202762706D6E3A44617461496E7075744173736F63696174696F6E2729207B0A0A2020202072656653656D616E746963203D2073656D616E7469632E24706172656E743B0A20207D0A0A2020656C656D656E74';
wwv_flow_imp.g_varchar2_table(2203) := '203D2072656653656D616E74696320262620746869732E5F676574456C656D656E742872656653656D616E746963293B0A0A202069662028656C656D656E7429207B0A2020202072657475726E20656C656D656E743B0A20207D0A0A2020696620287265';
wwv_flow_imp.g_varchar2_table(2204) := '6653656D616E74696329207B0A202020207468726F77206E6F74596574447261776E2873656D616E7469632C2072656653656D616E7469632C2073696465202B202752656627293B0A20207D20656C7365207B0A202020207468726F77206E6577204572';
wwv_flow_imp.g_varchar2_table(2205) := '726F72280A20202020202060247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E656C656D656E74546F537472696E67292873656D616E74696329207D23247B2073696465207D20526566206E6F7420';
wwv_flow_imp.g_varchar2_table(2206) := '737065636966696564600A20202020293B0A20207D0A7D3B0A0A42706D6E496D706F727465722E70726F746F747970652E5F676574536F75726365203D2066756E6374696F6E2873656D616E74696329207B0A202072657475726E20746869732E5F6765';
wwv_flow_imp.g_varchar2_table(2207) := '74436F6E6E6563746564456C656D656E742873656D616E7469632C2027736F7572636527293B0A7D3B0A0A42706D6E496D706F727465722E70726F746F747970652E5F676574546172676574203D2066756E6374696F6E2873656D616E74696329207B0A';
wwv_flow_imp.g_varchar2_table(2208) := '202072657475726E20746869732E5F676574436F6E6E6563746564456C656D656E742873656D616E7469632C202774617267657427293B0A7D3B0A0A0A42706D6E496D706F727465722E70726F746F747970652E5F676574456C656D656E74203D206675';
wwv_flow_imp.g_varchar2_table(2209) := '6E6374696F6E2873656D616E74696329207B0A202072657475726E20746869732E5F656C656D656E7452656769737472792E6765742873656D616E7469632E6964293B0A7D3B0A0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F';
wwv_flow_imp.g_varchar2_table(2210) := '2F2F2F2F0A0A66756E6374696F6E206973506F696E74496E7369646542426F782862626F782C20706F696E7429207B0A20207661722078203D20706F696E742E782C0A20202020202079203D20706F696E742E793B0A0A202072657475726E2078203E3D';
wwv_flow_imp.g_varchar2_table(2211) := '2062626F782E782026260A2020202078203C3D2062626F782E78202B2062626F782E77696474682026260A2020202079203E3D2062626F782E792026260A2020202079203C3D2062626F782E79202B2062626F782E6865696768743B0A7D0A0A66756E63';
wwv_flow_imp.g_varchar2_table(2212) := '74696F6E2069734672616D65456C656D656E742873656D616E74696329207B0A202072657475726E2028302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6973292873656D616E7469';
wwv_flow_imp.g_varchar2_table(2213) := '632C202762706D6E3A47726F757027293B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F42706D6E5472656557616C6B65722E6A73223A0A2F2A212A2A2A';
wwv_flow_imp.g_varchar2_table(2214) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F7274';
wwv_flow_imp.g_varchar2_table(2215) := '2F42706D6E5472656557616C6B65722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E';
wwv_flow_imp.g_varchar2_table(2216) := '757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(2217) := '5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F20';
wwv_flow_imp.g_varchar2_table(2218) := '20202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F2042706D6E5472656557616C6B6572290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076617220';
wwv_flow_imp.g_varchar2_table(2219) := '6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D64617368';
wwv_flow_imp.g_varchar2_table(2220) := '2F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972';
wwv_flow_imp.g_varchar2_table(2221) := '655F5F282F2A21202E2F5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F436F6D7061';
wwv_flow_imp.g_varchar2_table(2222) := '746962696C6974795574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F436F6D7061746962696C6974795574696C202A2F20222E2F';
wwv_flow_imp.g_varchar2_table(2223) := '6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F436F6D7061746962696C6974795574696C2E6A7322293B0A0A0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327';
wwv_flow_imp.g_varchar2_table(2224) := '292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E740A202A2F0A0A2F2A2A0A202A2052657475726E73207472756520696620616E20656C656D656E74206973206F662074686520676976656E206D6574612D6D6F64656C20747970';
wwv_flow_imp.g_varchar2_table(2225) := '652E0A202A0A202A2040706172616D207B4D6F64646C65456C656D656E747D20656C656D656E740A202A2040706172616D207B737472696E677D20747970650A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(2226) := '20697328656C656D656E742C207479706529207B0A202072657475726E20656C656D656E742E24696E7374616E63654F662874797065293B0A7D0A0A0A2F2A2A0A202A2046696E642061207375697461626C6520646973706C61792063616E6469646174';
wwv_flow_imp.g_varchar2_table(2227) := '6520666F7220646566696E6974696F6E732077686572652074686520444920646F6573206E6F740A202A20636F72726563746C792073706563696679206F6E652E0A202A0A202A2040706172616D207B4D6F64646C65456C656D656E747D20646566696E';
wwv_flow_imp.g_varchar2_table(2228) := '6974696F6E730A202A0A202A204072657475726E207B4D6F64646C65456C656D656E747D0A202A2F0A66756E6374696F6E2066696E64446973706C617943616E64696461746528646566696E6974696F6E7329207B0A202072657475726E2028302C6D69';
wwv_flow_imp.g_varchar2_table(2229) := '6E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E66696E642928646566696E6974696F6E732E726F6F74456C656D656E74732C2066756E6374696F6E286529207B0A2020202072657475726E20697328652C2027';
wwv_flow_imp.g_varchar2_table(2230) := '62706D6E3A50726F636573732729207C7C20697328652C202762706D6E3A436F6C6C61626F726174696F6E27293B0A20207D293B0A7D0A0A2F2A2A0A202A2040706172616D207B5265636F72643C27656C656D656E7427207C2027726F6F7427207C2027';
wwv_flow_imp.g_varchar2_table(2231) := '6572726F72272C2046756E6374696F6E3E7D2068616E646C65720A202A2F0A66756E6374696F6E2042706D6E5472656557616C6B65722868616E646C657229207B0A0A20202F2F206C697374206F6620636F6E7461696E65727320616C72656164792077';
wwv_flow_imp.g_varchar2_table(2232) := '616C6B65640A20207661722068616E646C6564456C656D656E7473203D207B7D3B0A0A20202F2F206C697374206F6620656C656D656E747320746F2068616E646C6520646566657272656420746F20656E737572650A20202F2F20707265726571756973';
wwv_flow_imp.g_varchar2_table(2233) := '697465732061726520647261776E0A2020766172206465666572726564203D205B5D3B0A0A20207661722064694D6170203D207B7D3B0A0A20202F2F2048656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A202066756E6374';
wwv_flow_imp.g_varchar2_table(2234) := '696F6E20636F6E7465787475616C28666E2C2063747829207B0A2020202072657475726E2066756E6374696F6E286529207B0A202020202020666E28652C20637478293B0A202020207D3B0A20207D0A0A202066756E6374696F6E2068616E646C656428';
wwv_flow_imp.g_varchar2_table(2235) := '656C656D656E7429207B0A2020202068616E646C6564456C656D656E74735B656C656D656E742E69645D203D20656C656D656E743B0A20207D0A0A202066756E6374696F6E20697348616E646C656428656C656D656E7429207B0A202020207265747572';
wwv_flow_imp.g_varchar2_table(2236) := '6E2068616E646C6564456C656D656E74735B656C656D656E742E69645D3B0A20207D0A0A202066756E6374696F6E20766973697428656C656D656E742C2063747829207B0A0A2020202076617220676678203D20656C656D656E742E6766783B0A0A2020';
wwv_flow_imp.g_varchar2_table(2237) := '20202F2F2061766F6964206D756C7469706C652072656E646572696E67206F6620656C656D656E74730A202020206966202867667829207B0A2020202020207468726F77206E6577204572726F72280A202020202020202060616C72656164792072656E';
wwv_flow_imp.g_varchar2_table(2238) := '646572656420247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E656C656D656E74546F537472696E672928656C656D656E7429207D600A202020202020293B0A202020207D0A0A202020202F2F2063';
wwv_flow_imp.g_varchar2_table(2239) := '616C6C2068616E646C65720A2020202072657475726E2068616E646C65722E656C656D656E7428656C656D656E742C2064694D61705B656C656D656E742E69645D2C20637478293B0A20207D0A0A202066756E6374696F6E207669736974526F6F742865';
wwv_flow_imp.g_varchar2_table(2240) := '6C656D656E742C206469616772616D29207B0A2020202072657475726E2068616E646C65722E726F6F7428656C656D656E742C2064694D61705B656C656D656E742E69645D2C206469616772616D293B0A20207D0A0A202066756E6374696F6E20766973';
wwv_flow_imp.g_varchar2_table(2241) := '69744966446928656C656D656E742C2063747829207B0A0A20202020747279207B0A20202020202076617220676678203D2064694D61705B656C656D656E742E69645D20262620766973697428656C656D656E742C20637478293B0A0A20202020202068';
wwv_flow_imp.g_varchar2_table(2242) := '616E646C656428656C656D656E74293B0A0A20202020202072657475726E206766783B0A202020207D20636174636820286572726F7229207B0A2020202020206C6F674572726F72286572726F722E6D6573736167652C207B20656C656D656E742C2065';
wwv_flow_imp.g_varchar2_table(2243) := '72726F72207D293B0A0A202020202020636F6E736F6C652E6572726F7228606661696C656420746F20696D706F727420247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E656C656D656E74546F5374';
wwv_flow_imp.g_varchar2_table(2244) := '72696E672928656C656D656E7429207D602C206572726F72293B0A202020207D0A20207D0A0A202066756E6374696F6E206C6F674572726F72286D6573736167652C20636F6E7465787429207B0A2020202068616E646C65722E6572726F72286D657373';
wwv_flow_imp.g_varchar2_table(2245) := '6167652C20636F6E74657874293B0A20207D0A0A20202F2F2044492068616E646C696E67202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A20207661722072656769737465724469203D20746869732E72656769737465724469203D206675';
wwv_flow_imp.g_varchar2_table(2246) := '6E6374696F6E207265676973746572446928646929207B0A202020207661722062706D6E456C656D656E74203D2064692E62706D6E456C656D656E743B0A0A202020206966202862706D6E456C656D656E7429207B0A2020202020206966202864694D61';
wwv_flow_imp.g_varchar2_table(2247) := '705B62706D6E456C656D656E742E69645D29207B0A20202020202020206C6F674572726F72280A20202020202020202020606D756C7469706C6520444920656C656D656E747320646566696E656420666F7220247B2028302C5F5574696C5F5F57454250';
wwv_flow_imp.g_varchar2_table(2248) := '41434B5F494D504F525445445F4D4F44554C455F315F5F2E656C656D656E74546F537472696E67292862706D6E456C656D656E7429207D602C0A202020202020202020207B20656C656D656E743A2062706D6E456C656D656E74207D0A20202020202020';
wwv_flow_imp.g_varchar2_table(2249) := '20293B0A2020202020207D20656C7365207B0A202020202020202064694D61705B62706D6E456C656D656E742E69645D203D2064693B0A0A202020202020202028302C5F7574696C5F436F6D7061746962696C6974795574696C5F5F5745425041434B5F';
wwv_flow_imp.g_varchar2_table(2250) := '494D504F525445445F4D4F44554C455F325F5F2E656E73757265436F6D7061744469526566292862706D6E456C656D656E74293B0A2020202020207D0A202020207D20656C7365207B0A2020202020206C6F674572726F72280A2020202020202020606E';
wwv_flow_imp.g_varchar2_table(2251) := '6F2062706D6E456C656D656E74207265666572656E63656420696E20247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E656C656D656E74546F537472696E672928646929207D602C0A202020202020';
wwv_flow_imp.g_varchar2_table(2252) := '20207B20656C656D656E743A206469207D0A202020202020293B0A202020207D0A20207D3B0A0A202066756E6374696F6E2068616E646C654469616772616D286469616772616D29207B0A2020202068616E646C65506C616E65286469616772616D2E70';
wwv_flow_imp.g_varchar2_table(2253) := '6C616E65293B0A20207D0A0A202066756E6374696F6E2068616E646C65506C616E6528706C616E6529207B0A202020207265676973746572446928706C616E65293B0A0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(2254) := '445F4D4F44554C455F305F5F2E666F72456163682928706C616E652E706C616E65456C656D656E742C2068616E646C65506C616E65456C656D656E74293B0A20207D0A0A202066756E6374696F6E2068616E646C65506C616E65456C656D656E7428706C';
wwv_flow_imp.g_varchar2_table(2255) := '616E65456C656D656E7429207B0A202020207265676973746572446928706C616E65456C656D656E74293B0A20207D0A0A0A20202F2F2053656D616E7469632068616E646C696E67202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A20202F';
wwv_flow_imp.g_varchar2_table(2256) := '2A2A0A2020202A2048616E646C6520646566696E6974696F6E7320616E642072657475726E207468652072656E6465726564206469616772616D2028696620616E79292E0A2020202A0A2020202A2040706172616D207B4D6F64646C65456C656D656E74';
wwv_flow_imp.g_varchar2_table(2257) := '7D20646566696E6974696F6E7320746F2077616C6B20616E6420696D706F72740A2020202A2040706172616D207B4D6F64646C65456C656D656E747D205B6469616772616D5D207370656369666963206469616772616D20746F20696D706F727420616E';
wwv_flow_imp.g_varchar2_table(2258) := '6420646973706C61790A2020202A0A2020202A20407468726F7773207B4572726F727D206966206E6F206469616772616D20746F20646973706C617920636F756C6420626520666F756E640A2020202A2F0A2020746869732E68616E646C65446566696E';
wwv_flow_imp.g_varchar2_table(2259) := '6974696F6E73203D2066756E6374696F6E2068616E646C65446566696E6974696F6E7328646566696E6974696F6E732C206469616772616D29207B0A0A202020202F2F206D616B6520737572652077652077616C6B2074686520636F7272656374206270';
wwv_flow_imp.g_varchar2_table(2260) := '6D6E456C656D656E740A0A20202020766172206469616772616D73203D20646566696E6974696F6E732E6469616772616D733B0A0A20202020696620286469616772616D202626206469616772616D732E696E6465784F66286469616772616D29203D3D';
wwv_flow_imp.g_varchar2_table(2261) := '3D202D3129207B0A2020202020207468726F77206E6577204572726F7228276469616772616D206E6F742070617274206F66203C62706D6E3A446566696E6974696F6E73202F3E27293B0A202020207D0A0A2020202069662028216469616772616D2026';
wwv_flow_imp.g_varchar2_table(2262) := '26206469616772616D73202626206469616772616D732E6C656E67746829207B0A2020202020206469616772616D203D206469616772616D735B305D3B0A202020207D0A0A202020202F2F206E6F206469616772616D202D3E206E6F7468696E6720746F';
wwv_flow_imp.g_varchar2_table(2263) := '20696D706F72740A2020202069662028216469616772616D29207B0A2020202020207468726F77206E6577204572726F7228276E6F206469616772616D20746F20646973706C617927293B0A202020207D0A0A202020202F2F206C6F6164204449206672';
wwv_flow_imp.g_varchar2_table(2264) := '6F6D2073656C6563746564206469616772616D206F6E6C790A2020202064694D6170203D207B7D3B0A2020202068616E646C654469616772616D286469616772616D293B0A0A0A2020202076617220706C616E65203D206469616772616D2E706C616E65';
wwv_flow_imp.g_varchar2_table(2265) := '3B0A0A202020206966202821706C616E6529207B0A2020202020207468726F77206E6577204572726F72280A2020202020202020606E6F20706C616E6520666F7220247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(2266) := '4C455F315F5F2E656C656D656E74546F537472696E6729286469616772616D29207D600A202020202020293B0A202020207D0A0A2020202076617220726F6F74456C656D656E74203D20706C616E652E62706D6E456C656D656E743B0A0A202020202F2F';
wwv_flow_imp.g_varchar2_table(2267) := '20656E737572652077652064656661756C7420746F2061207375697461626C6520646973706C61792063616E646964617465202870726F63657373206F7220636F6C6C61626F726174696F6E292C0A202020202F2F206576656E206966206E6F6E206973';
wwv_flow_imp.g_varchar2_table(2268) := '2073706563696669656420696E2044490A202020206966202821726F6F74456C656D656E7429207B0A202020202020726F6F74456C656D656E74203D2066696E64446973706C617943616E64696461746528646566696E6974696F6E73293B0A0A202020';
wwv_flow_imp.g_varchar2_table(2269) := '2020206966202821726F6F74456C656D656E7429207B0A20202020202020207468726F77206E6577204572726F7228276E6F2070726F63657373206F7220636F6C6C61626F726174696F6E20746F20646973706C617927293B0A2020202020207D20656C';
wwv_flow_imp.g_varchar2_table(2270) := '7365207B0A0A20202020202020206C6F674572726F72280A2020202020202020202060636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E20247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D';
wwv_flow_imp.g_varchar2_table(2271) := '4F44554C455F315F5F2E656C656D656E74546F537472696E672928706C616E6529207D20746F20247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E656C656D656E74546F537472696E672928726F6F';
wwv_flow_imp.g_varchar2_table(2272) := '74456C656D656E7429207D600A2020202020202020293B0A0A20202020202020202F2F20636F7272656374204449206F6E2074686520666C790A2020202020202020706C616E652E62706D6E456C656D656E74203D20726F6F74456C656D656E743B0A20';
wwv_flow_imp.g_varchar2_table(2273) := '202020202020207265676973746572446928706C616E65293B0A2020202020207D0A202020207D0A0A0A2020202076617220637478203D207669736974526F6F7428726F6F74456C656D656E742C20706C616E65293B0A0A202020206966202869732872';
wwv_flow_imp.g_varchar2_table(2274) := '6F6F74456C656D656E742C202762706D6E3A50726F636573732729207C7C20697328726F6F74456C656D656E742C202762706D6E3A53756250726F63657373272929207B0A20202020202068616E646C6550726F6365737328726F6F74456C656D656E74';
wwv_flow_imp.g_varchar2_table(2275) := '2C20637478293B0A202020207D20656C73652069662028697328726F6F74456C656D656E742C202762706D6E3A436F6C6C61626F726174696F6E272929207B0A20202020202068616E646C65436F6C6C61626F726174696F6E28726F6F74456C656D656E';
wwv_flow_imp.g_varchar2_table(2276) := '742C20637478293B0A0A2020202020202F2F20666F7263652064726177696E67206F662065766572797468696E67206E6F742079657420647261776E20746861742069732070617274206F6620746865207461726765742044490A20202020202068616E';
wwv_flow_imp.g_varchar2_table(2277) := '646C65556E68616E646C656450726F63657373657328646566696E6974696F6E732E726F6F74456C656D656E74732C20637478293B0A202020207D20656C7365207B0A2020202020207468726F77206E6577204572726F72280A20202020202020206075';
wwv_flow_imp.g_varchar2_table(2278) := '6E737570706F727465642062706D6E456C656D656E7420666F7220247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E656C656D656E74546F537472696E672928706C616E6529207D3A20247B202830';
wwv_flow_imp.g_varchar2_table(2279) := '2C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E656C656D656E74546F537472696E672928726F6F74456C656D656E7429207D600A202020202020293B0A202020207D0A0A202020202F2F2068616E646C652061';
wwv_flow_imp.g_varchar2_table(2280) := '6C6C20646566657272656420656C656D656E74730A2020202068616E646C654465666572726564286465666572726564293B0A20207D3B0A0A20207661722068616E646C654465666572726564203D20746869732E68616E646C65446566657272656420';
wwv_flow_imp.g_varchar2_table(2281) := '3D2066756E6374696F6E2068616E646C6544656665727265642829207B0A0A2020202076617220666E3B0A0A202020202F2F20647261696E20646566657272656420756E74696C20656D7074790A202020207768696C65202864656665727265642E6C65';
wwv_flow_imp.g_varchar2_table(2282) := '6E67746829207B0A202020202020666E203D2064656665727265642E736869667428293B0A0A202020202020666E28293B0A202020207D0A20207D3B0A0A202066756E6374696F6E2068616E646C6550726F636573732870726F636573732C20636F6E74';
wwv_flow_imp.g_varchar2_table(2283) := '65787429207B0A2020202068616E646C65466C6F77456C656D656E7473436F6E7461696E65722870726F636573732C20636F6E74657874293B0A2020202068616E646C65496F53706563696669636174696F6E2870726F636573732E696F537065636966';
wwv_flow_imp.g_varchar2_table(2284) := '69636174696F6E2C20636F6E74657874293B0A0A2020202068616E646C654172746966616374732870726F636573732E6172746966616374732C20636F6E74657874293B0A0A202020202F2F206C6F672070726F636573732068616E646C65640A202020';
wwv_flow_imp.g_varchar2_table(2285) := '2068616E646C65642870726F63657373293B0A20207D0A0A202066756E6374696F6E2068616E646C65556E68616E646C656450726F63657373657328726F6F74456C656D656E74732C2063747829207B0A0A202020202F2F2077616C6B207468726F7567';
wwv_flow_imp.g_varchar2_table(2286) := '6820616C6C2070726F63657373657320746861742068617665206E6F7420796574206265656E20647261776E20616E642064726177207468656D0A202020202F2F206966207468657920636F6E7461696E206C616E6573207769746820444920696E666F';
wwv_flow_imp.g_varchar2_table(2287) := '726D6174696F6E2E0A202020202F2F20776520646F207468697320746F20706173732074686520667265652D666C6F6174696E67206C616E65207465737420636173657320696E20746865204D49574720746573742073756974650A2020202076617220';
wwv_flow_imp.g_varchar2_table(2288) := '70726F636573736573203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E66696C7465722928726F6F74456C656D656E74732C2066756E6374696F6E286529207B0A2020202020207265747572';
wwv_flow_imp.g_varchar2_table(2289) := '6E2021697348616E646C656428652920262620697328652C202762706D6E3A50726F63657373272920262620652E6C616E65536574733B0A202020207D293B0A0A2020202070726F6365737365732E666F724561636828636F6E7465787475616C286861';
wwv_flow_imp.g_varchar2_table(2290) := '6E646C6550726F636573732C2063747829293B0A20207D0A0A202066756E6374696F6E2068616E646C654D657373616765466C6F77286D657373616765466C6F772C20636F6E7465787429207B0A20202020766973697449664469286D65737361676546';
wwv_flow_imp.g_varchar2_table(2291) := '6C6F772C20636F6E74657874293B0A20207D0A0A202066756E6374696F6E2068616E646C654D657373616765466C6F7773286D657373616765466C6F77732C20636F6E7465787429207B0A2020202028302C6D696E5F646173685F5F5745425041434B5F';
wwv_flow_imp.g_varchar2_table(2292) := '494D504F525445445F4D4F44554C455F305F5F2E666F724561636829286D657373616765466C6F77732C20636F6E7465787475616C2868616E646C654D657373616765466C6F772C20636F6E7465787429293B0A20207D0A0A202066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(2293) := '68616E646C65446174614173736F63696174696F6E286173736F63696174696F6E2C20636F6E7465787429207B0A20202020766973697449664469286173736F63696174696F6E2C20636F6E74657874293B0A20207D0A0A202066756E6374696F6E2068';
wwv_flow_imp.g_varchar2_table(2294) := '616E646C6544617461496E7075742864617461496E7075742C20636F6E7465787429207B0A202020207669736974496644692864617461496E7075742C20636F6E74657874293B0A20207D0A0A202066756E6374696F6E2068616E646C65446174614F75';
wwv_flow_imp.g_varchar2_table(2295) := '7470757428646174614F75747075742C20636F6E7465787429207B0A2020202076697369744966446928646174614F75747075742C20636F6E74657874293B0A20207D0A0A202066756E6374696F6E2068616E646C654172746966616374286172746966';
wwv_flow_imp.g_varchar2_table(2296) := '6163742C20636F6E7465787429207B0A0A202020202F2F2062706D6E3A54657874416E6E6F746174696F6E0A202020202F2F2062706D6E3A47726F75700A202020202F2F2062706D6E3A4173736F63696174696F6E0A0A20202020766973697449664469';
wwv_flow_imp.g_varchar2_table(2297) := '2861727469666163742C20636F6E74657874293B0A20207D0A0A202066756E6374696F6E2068616E646C65417274696661637473286172746966616374732C20636F6E7465787429207B0A0A2020202028302C6D696E5F646173685F5F5745425041434B';
wwv_flow_imp.g_varchar2_table(2298) := '5F494D504F525445445F4D4F44554C455F305F5F2E666F724561636829286172746966616374732C2066756E6374696F6E286529207B0A20202020202069662028697328652C202762706D6E3A4173736F63696174696F6E272929207B0A202020202020';
wwv_flow_imp.g_varchar2_table(2299) := '202064656665727265642E707573682866756E6374696F6E2829207B0A2020202020202020202068616E646C65417274696661637428652C20636F6E74657874293B0A20202020202020207D293B0A2020202020207D20656C7365207B0A202020202020';
wwv_flow_imp.g_varchar2_table(2300) := '202068616E646C65417274696661637428652C20636F6E74657874293B0A2020202020207D0A202020207D293B0A20207D0A0A202066756E6374696F6E2068616E646C65496F53706563696669636174696F6E28696F53706563696669636174696F6E2C';
wwv_flow_imp.g_varchar2_table(2301) := '20636F6E7465787429207B0A0A202020206966202821696F53706563696669636174696F6E29207B0A20202020202072657475726E3B0A202020207D0A0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(2302) := '4C455F305F5F2E666F72456163682928696F53706563696669636174696F6E2E64617461496E707574732C20636F6E7465787475616C2868616E646C6544617461496E7075742C20636F6E7465787429293B0A2020202028302C6D696E5F646173685F5F';
wwv_flow_imp.g_varchar2_table(2303) := '5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F72456163682928696F53706563696669636174696F6E2E646174614F7574707574732C20636F6E7465787475616C2868616E646C65446174614F75747075742C20636F6E7465';
wwv_flow_imp.g_varchar2_table(2304) := '787429293B0A20207D0A0A20207661722068616E646C6553756250726F63657373203D20746869732E68616E646C6553756250726F63657373203D2066756E6374696F6E2068616E646C6553756250726F636573732873756250726F636573732C20636F';
wwv_flow_imp.g_varchar2_table(2305) := '6E7465787429207B0A2020202068616E646C65466C6F77456C656D656E7473436F6E7461696E65722873756250726F636573732C20636F6E74657874293B0A2020202068616E646C654172746966616374732873756250726F636573732E617274696661';
wwv_flow_imp.g_varchar2_table(2306) := '6374732C20636F6E74657874293B0A20207D3B0A0A202066756E6374696F6E2068616E646C65466C6F774E6F646528666C6F774E6F64652C20636F6E7465787429207B0A20202020766172206368696C64437478203D2076697369744966446928666C6F';
wwv_flow_imp.g_varchar2_table(2307) := '774E6F64652C20636F6E74657874293B0A0A2020202069662028697328666C6F774E6F64652C202762706D6E3A53756250726F63657373272929207B0A20202020202068616E646C6553756250726F6365737328666C6F774E6F64652C206368696C6443';
wwv_flow_imp.g_varchar2_table(2308) := '7478207C7C20636F6E74657874293B0A202020207D0A0A2020202069662028697328666C6F774E6F64652C202762706D6E3A4163746976697479272929207B0A20202020202068616E646C65496F53706563696669636174696F6E28666C6F774E6F6465';
wwv_flow_imp.g_varchar2_table(2309) := '2E696F53706563696669636174696F6E2C20636F6E74657874293B0A202020207D0A0A202020202F2F2064656665722068616E646C696E67206F66206173736F63696174696F6E730A202020202F2F2061666665637465642074797065733A0A20202020';
wwv_flow_imp.g_varchar2_table(2310) := '2F2F0A202020202F2F2020202A2062706D6E3A41637469766974790A202020202F2F2020202A2062706D6E3A5468726F774576656E740A202020202F2F2020202A2062706D6E3A43617463684576656E740A202020202F2F0A2020202064656665727265';
wwv_flow_imp.g_varchar2_table(2311) := '642E707573682866756E6374696F6E2829207B0A20202020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F72456163682928666C6F774E6F64652E64617461496E7075744173736F6369';
wwv_flow_imp.g_varchar2_table(2312) := '6174696F6E732C20636F6E7465787475616C2868616E646C65446174614173736F63696174696F6E2C20636F6E7465787429293B0A20202020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E';
wwv_flow_imp.g_varchar2_table(2313) := '666F72456163682928666C6F774E6F64652E646174614F75747075744173736F63696174696F6E732C20636F6E7465787475616C2868616E646C65446174614173736F63696174696F6E2C20636F6E7465787429293B0A202020207D293B0A20207D0A0A';
wwv_flow_imp.g_varchar2_table(2314) := '202066756E6374696F6E2068616E646C6553657175656E6365466C6F772873657175656E6365466C6F772C20636F6E7465787429207B0A202020207669736974496644692873657175656E6365466C6F772C20636F6E74657874293B0A20207D0A0A2020';
wwv_flow_imp.g_varchar2_table(2315) := '66756E6374696F6E2068616E646C6544617461456C656D656E7428646174614F626A6563742C20636F6E7465787429207B0A2020202076697369744966446928646174614F626A6563742C20636F6E74657874293B0A20207D0A0A202066756E6374696F';
wwv_flow_imp.g_varchar2_table(2316) := '6E2068616E646C654C616E65286C616E652C20636F6E7465787429207B0A0A2020202064656665727265642E707573682866756E6374696F6E2829207B0A0A202020202020766172206E6577436F6E74657874203D20766973697449664469286C616E65';
wwv_flow_imp.g_varchar2_table(2317) := '2C20636F6E74657874293B0A0A202020202020696620286C616E652E6368696C644C616E6553657429207B0A202020202020202068616E646C654C616E65536574286C616E652E6368696C644C616E655365742C206E6577436F6E74657874207C7C2063';
wwv_flow_imp.g_varchar2_table(2318) := '6F6E74657874293B0A2020202020207D0A0A20202020202077697265466C6F774E6F646552656673286C616E65293B0A202020207D293B0A20207D0A0A202066756E6374696F6E2068616E646C654C616E65536574286C616E655365742C20636F6E7465';
wwv_flow_imp.g_varchar2_table(2319) := '787429207B0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F724561636829286C616E655365742E6C616E65732C20636F6E7465787475616C2868616E646C654C616E652C20636F';
wwv_flow_imp.g_varchar2_table(2320) := '6E7465787429293B0A20207D0A0A202066756E6374696F6E2068616E646C654C616E6553657473286C616E65536574732C20636F6E7465787429207B0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(2321) := '455F305F5F2E666F724561636829286C616E65536574732C20636F6E7465787475616C2868616E646C654C616E655365742C20636F6E7465787429293B0A20207D0A0A202066756E6374696F6E2068616E646C65466C6F77456C656D656E7473436F6E74';
wwv_flow_imp.g_varchar2_table(2322) := '61696E657228636F6E7461696E65722C20636F6E7465787429207B0A2020202068616E646C65466C6F77456C656D656E747328636F6E7461696E65722E666C6F77456C656D656E74732C20636F6E74657874293B0A0A2020202069662028636F6E746169';
wwv_flow_imp.g_varchar2_table(2323) := '6E65722E6C616E655365747329207B0A20202020202068616E646C654C616E655365747328636F6E7461696E65722E6C616E65536574732C20636F6E74657874293B0A202020207D0A20207D0A0A202066756E6374696F6E2068616E646C65466C6F7745';
wwv_flow_imp.g_varchar2_table(2324) := '6C656D656E747328666C6F77456C656D656E74732C20636F6E7465787429207B0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F72456163682928666C6F77456C656D656E74732C';
wwv_flow_imp.g_varchar2_table(2325) := '2066756E6374696F6E28666C6F77456C656D656E7429207B0A20202020202069662028697328666C6F77456C656D656E742C202762706D6E3A53657175656E6365466C6F77272929207B0A202020202020202064656665727265642E707573682866756E';
wwv_flow_imp.g_varchar2_table(2326) := '6374696F6E2829207B0A2020202020202020202068616E646C6553657175656E6365466C6F7728666C6F77456C656D656E742C20636F6E74657874293B0A20202020202020207D293B0A2020202020207D20656C73652069662028697328666C6F77456C';
wwv_flow_imp.g_varchar2_table(2327) := '656D656E742C202762706D6E3A426F756E646172794576656E74272929207B0A202020202020202064656665727265642E756E73686966742866756E6374696F6E2829207B0A2020202020202020202068616E646C65466C6F774E6F646528666C6F7745';
wwv_flow_imp.g_varchar2_table(2328) := '6C656D656E742C20636F6E74657874293B0A20202020202020207D293B0A2020202020207D20656C73652069662028697328666C6F77456C656D656E742C202762706D6E3A466C6F774E6F6465272929207B0A202020202020202068616E646C65466C6F';
wwv_flow_imp.g_varchar2_table(2329) := '774E6F646528666C6F77456C656D656E742C20636F6E74657874293B0A2020202020207D20656C73652069662028697328666C6F77456C656D656E742C202762706D6E3A446174614F626A656374272929207B0A0A20202020202020202F2F20534B4950';
wwv_flow_imp.g_varchar2_table(2330) := '2028617373756D6520636F7272656374207265666572656E63696E672076696120446174614F626A6563745265666572656E6365290A2020202020207D20656C73652069662028697328666C6F77456C656D656E742C202762706D6E3A4461746153746F';
wwv_flow_imp.g_varchar2_table(2331) := '72655265666572656E6365272929207B0A202020202020202068616E646C6544617461456C656D656E7428666C6F77456C656D656E742C20636F6E74657874293B0A2020202020207D20656C73652069662028697328666C6F77456C656D656E742C2027';
wwv_flow_imp.g_varchar2_table(2332) := '62706D6E3A446174614F626A6563745265666572656E6365272929207B0A202020202020202068616E646C6544617461456C656D656E7428666C6F77456C656D656E742C20636F6E74657874293B0A2020202020207D20656C7365207B0A202020202020';
wwv_flow_imp.g_varchar2_table(2333) := '20206C6F674572726F72280A2020202020202020202060756E7265636F676E697A656420666C6F77456C656D656E7420247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E656C656D656E74546F5374';
wwv_flow_imp.g_varchar2_table(2334) := '72696E672928666C6F77456C656D656E7429207D20696E20636F6E7465787420247B2028302C5F5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E656C656D656E74546F537472696E672928636F6E74657874202626';
wwv_flow_imp.g_varchar2_table(2335) := '20636F6E746578742E627573696E6573734F626A65637429207D602C0A202020202020202020207B0A202020202020202020202020656C656D656E743A20666C6F77456C656D656E742C0A202020202020202020202020636F6E746578740A2020202020';
wwv_flow_imp.g_varchar2_table(2336) := '20202020207D0A2020202020202020293B0A2020202020207D0A202020207D293B0A20207D0A0A202066756E6374696F6E2068616E646C655061727469636970616E74287061727469636970616E742C20636F6E7465787429207B0A2020202076617220';
wwv_flow_imp.g_varchar2_table(2337) := '6E6577437478203D20766973697449664469287061727469636970616E742C20636F6E74657874293B0A0A202020207661722070726F63657373203D207061727469636970616E742E70726F636573735265663B0A202020206966202870726F63657373';
wwv_flow_imp.g_varchar2_table(2338) := '29207B0A20202020202068616E646C6550726F636573732870726F636573732C206E6577437478207C7C20636F6E74657874293B0A202020207D0A20207D0A0A202066756E6374696F6E2068616E646C65436F6C6C61626F726174696F6E28636F6C6C61';
wwv_flow_imp.g_varchar2_table(2339) := '626F726174696F6E2C20636F6E7465787429207B0A0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F72456163682928636F6C6C61626F726174696F6E2E7061727469636970616E';
wwv_flow_imp.g_varchar2_table(2340) := '74732C20636F6E7465787475616C2868616E646C655061727469636970616E742C20636F6E7465787429293B0A0A2020202068616E646C6541727469666163747328636F6C6C61626F726174696F6E2E6172746966616374732C20636F6E74657874293B';
wwv_flow_imp.g_varchar2_table(2341) := '0A0A202020202F2F2068616E646C65206D65737361676520666C6F7773206C617465737420696E207468652070726F636573730A2020202064656665727265642E707573682866756E6374696F6E2829207B0A20202020202068616E646C654D65737361';
wwv_flow_imp.g_varchar2_table(2342) := '6765466C6F777328636F6C6C61626F726174696F6E2E6D657373616765466C6F77732C20636F6E74657874293B0A202020207D293B0A20207D0A0A0A202066756E6374696F6E2077697265466C6F774E6F646552656673286C616E6529207B0A0A202020';
wwv_flow_imp.g_varchar2_table(2343) := '202F2F207769726520746865207669727475616C20666C6F774E6F646552656673203C2D3E2072656C6174696F6E736869700A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F7245';
wwv_flow_imp.g_varchar2_table(2344) := '61636829286C616E652E666C6F774E6F64655265662C2066756E6374696F6E28666C6F774E6F646529207B0A202020202020766172206C616E6573203D20666C6F774E6F64652E67657428276C616E657327293B0A0A202020202020696620286C616E65';
wwv_flow_imp.g_varchar2_table(2345) := '7329207B0A20202020202020206C616E65732E70757368286C616E65293B0A2020202020207D0A202020207D293B0A20207D0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F';
wwv_flow_imp.g_varchar2_table(2346) := '696D706F72742F496D706F727465722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C';
wwv_flow_imp.g_varchar2_table(2347) := '65732F62706D6E2D6A732F6C69622F696D706F72742F496D706F727465722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A';
wwv_flow_imp.g_varchar2_table(2348) := '2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E7228';
wwv_flow_imp.g_varchar2_table(2349) := '5F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E792065';
wwv_flow_imp.g_varchar2_table(2350) := '78706F7274202A2F202020696D706F727442706D6E4469616772616D3A202829203D3E20282F2A2062696E64696E67202A2F20696D706F727442706D6E4469616772616D290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861';
wwv_flow_imp.g_varchar2_table(2351) := '726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E';
wwv_flow_imp.g_varchar2_table(2352) := '6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F42706D6E5472656557616C6B65725F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(2353) := '5F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F42706D6E5472656557616C6B6572202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F42706D6E547265';
wwv_flow_imp.g_varchar2_table(2354) := '6557616C6B65722E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F72657175';
wwv_flow_imp.g_varchar2_table(2355) := '6972655F5F282F2A21202E2E2F7574696C2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A0A0A0A0A0A0A0A2F2A2A0A202A20407479706564';
wwv_flow_imp.g_varchar2_table(2356) := '6566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E740A202A0A202A204074797065646566207B207B0A202A2020207761726E696E67733A20737472696E675B5D';
wwv_flow_imp.g_varchar2_table(2357) := '3B0A202A207D207D20496D706F727442504D4E4469616772616D526573756C740A202A0A202A204074797065646566207B496D706F727442504D4E4469616772616D526573756C742026204572726F727D20496D706F727442504D4E4469616772616D45';
wwv_flow_imp.g_varchar2_table(2358) := '72726F720A202A2F0A0A2F2A2A0A202A20496D706F72742074686520646566696E6974696F6E7320696E746F2061206469616772616D2E0A202A0A202A204572726F727320616E64207761726E696E677320617265207265706F72746564207468726F75';
wwv_flow_imp.g_varchar2_table(2359) := '676820746865207370656369666965642063616C6C6261636B2E0A202A0A202A2040706172616D207B4D6F64646C65456C656D656E747D206469616772616D0A202A2040706172616D207B4D6F64646C65456C656D656E747D20646566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(2360) := '730A202A2040706172616D207B4D6F64646C65456C656D656E747D205B62706D6E4469616772616D5D20546865206469616772616D20746F2062652072656E646572656420286966206E6F740A202A2070726F76696465642C2074686520666972737420';
wwv_flow_imp.g_varchar2_table(2361) := '6F6E652077696C6C2062652072656E6465726564292E0A202A0A202A204072657475726E207B50726F6D6973653C496D706F727442504D4E4469616772616D526573756C743E7D0A202A2F0A66756E6374696F6E20696D706F727442706D6E4469616772';
wwv_flow_imp.g_varchar2_table(2362) := '616D286469616772616D2C20646566696E6974696F6E732C2062706D6E4469616772616D29207B0A0A202076617220696D706F727465722C0A2020202020206576656E744275732C0A20202020202063616E7661733B0A0A2020766172206572726F722C';
wwv_flow_imp.g_varchar2_table(2363) := '0A2020202020207761726E696E6773203D205B5D3B0A0A20202F2A2A0A2020202A2057616C6B20746865206469616772616D2073656D616E746963616C6C792C20696D706F7274696E6720283D64726177696E67290A2020202A20616C6C20656C656D65';
wwv_flow_imp.g_varchar2_table(2364) := '6E747320796F7520656E636F756E7465722E0A2020202A0A2020202A2040706172616D207B4D6F64646C65456C656D656E747D20646566696E6974696F6E730A2020202A2040706172616D207B4D6F64646C65456C656D656E747D2062706D6E44696167';
wwv_flow_imp.g_varchar2_table(2365) := '72616D0A2020202A2F0A202066756E6374696F6E2072656E64657228646566696E6974696F6E732C2062706D6E4469616772616D29207B0A0A202020207661722076697369746F72203D207B0A0A202020202020726F6F743A2066756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(2366) := '6C656D656E742C20646929207B0A202020202020202072657475726E20696D706F727465722E61646428656C656D656E742C206469293B0A2020202020207D2C0A0A202020202020656C656D656E743A2066756E6374696F6E28656C656D656E742C2064';
wwv_flow_imp.g_varchar2_table(2367) := '692C20706172656E74536861706529207B0A202020202020202072657475726E20696D706F727465722E61646428656C656D656E742C2064692C20706172656E745368617065293B0A2020202020207D2C0A0A2020202020206572726F723A2066756E63';
wwv_flow_imp.g_varchar2_table(2368) := '74696F6E286D6573736167652C20636F6E7465787429207B0A20202020202020207761726E696E67732E70757368287B206D6573736167653A206D6573736167652C20636F6E746578743A20636F6E74657874207D293B0A2020202020207D0A20202020';
wwv_flow_imp.g_varchar2_table(2369) := '7D3B0A0A202020207661722077616C6B6572203D206E6577205F42706D6E5472656557616C6B65725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D2876697369746F72293B0A0A0A2020202062706D';
wwv_flow_imp.g_varchar2_table(2370) := '6E4469616772616D203D2062706D6E4469616772616D207C7C2028646566696E6974696F6E732E6469616772616D7320262620646566696E6974696F6E732E6469616772616D735B305D293B0A0A20202020766172206469616772616D73546F496D706F';
wwv_flow_imp.g_varchar2_table(2371) := '7274203D206765744469616772616D73546F496D706F727428646566696E6974696F6E732C2062706D6E4469616772616D293B0A0A2020202069662028216469616772616D73546F496D706F727429207B0A2020202020207468726F77206E6577204572';
wwv_flow_imp.g_varchar2_table(2372) := '726F7228276E6F206469616772616D20746F20646973706C617927293B0A202020207D0A0A202020202F2F2074726176657273652042504D4E20322E3020646F63756D656E74206D6F64656C2C0A202020202F2F207374617274696E6720617420646566';
wwv_flow_imp.g_varchar2_table(2373) := '696E6974696F6E730A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F724561636829286469616772616D73546F496D706F72742C2066756E6374696F6E286469616772616D29207B';
wwv_flow_imp.g_varchar2_table(2374) := '0A20202020202077616C6B65722E68616E646C65446566696E6974696F6E7328646566696E6974696F6E732C206469616772616D293B0A202020207D293B0A0A2020202076617220726F6F744964203D2062706D6E4469616772616D2E706C616E652E62';
wwv_flow_imp.g_varchar2_table(2375) := '706D6E456C656D656E742E69643B0A0A202020202F2F20776520646F206E65656420746F206163636F756E7420666F7220646966666572656E7420776179732077652063726561746520726F6F7420656C656D656E74730A202020202F2F206561636820';
wwv_flow_imp.g_varchar2_table(2376) := '6E657374656420696D706F72746564203C726F6F743E20646F20686176652074686520605F706C616E6560207375666669782C207768696C650A202020202F2F2074686520726F6F74203C726F6F743E20697320666F756E6420756E6465722074686520';
wwv_flow_imp.g_varchar2_table(2377) := '627573696E657373206F626A6563742049440A2020202063616E7661732E736574526F6F74456C656D656E74280A20202020202063616E7661732E66696E64526F6F7428726F6F744964202B20275F706C616E652729207C7C2063616E7661732E66696E';
wwv_flow_imp.g_varchar2_table(2378) := '64526F6F7428726F6F744964290A20202020293B0A20207D0A0A202072657475726E206E65772050726F6D6973652866756E6374696F6E287265736F6C76652C2072656A65637429207B0A20202020747279207B0A202020202020696D706F7274657220';
wwv_flow_imp.g_varchar2_table(2379) := '3D206469616772616D2E676574282762706D6E496D706F7274657227293B0A2020202020206576656E74427573203D206469616772616D2E67657428276576656E7442757327293B0A20202020202063616E766173203D206469616772616D2E67657428';
wwv_flow_imp.g_varchar2_table(2380) := '2763616E76617327293B0A0A2020202020206576656E744275732E666972652827696D706F72742E72656E6465722E7374617274272C207B20646566696E6974696F6E733A20646566696E6974696F6E73207D293B0A0A20202020202072656E64657228';
wwv_flow_imp.g_varchar2_table(2381) := '646566696E6974696F6E732C2062706D6E4469616772616D293B0A0A2020202020206576656E744275732E666972652827696D706F72742E72656E6465722E636F6D706C657465272C207B0A20202020202020206572726F723A206572726F722C0A2020';
wwv_flow_imp.g_varchar2_table(2382) := '2020202020207761726E696E67733A207761726E696E67730A2020202020207D293B0A0A20202020202072657475726E207265736F6C7665287B207761726E696E67733A207761726E696E6773207D293B0A202020207D20636174636820286529207B0A';
wwv_flow_imp.g_varchar2_table(2383) := '0A202020202020652E7761726E696E6773203D207761726E696E67733B0A20202020202072657475726E2072656A6563742865293B0A202020207D0A20207D293B0A7D0A0A2F2A2A0A202A2052657475726E7320616C6C206469616772616D7320696E20';
wwv_flow_imp.g_varchar2_table(2384) := '7468652073616D65206869657261726368792061732074686520726571756573746564206469616772616D2E0A202A20496E636C7564657320616C6C20706172656E7420616E64207375622070726F63657373206469616772616D732E0A202A0A202A20';
wwv_flow_imp.g_varchar2_table(2385) := '40706172616D207B4D6F64646C65456C656D656E747D20646566696E6974696F6E730A202A2040706172616D207B4D6F64646C65456C656D656E747D2062706D6E4469616772616D0A202A0A202A204072657475726E207B4D6F64646C65456C656D656E';
wwv_flow_imp.g_varchar2_table(2386) := '745B5D7D0A202A2F0A66756E6374696F6E206765744469616772616D73546F496D706F727428646566696E6974696F6E732C2062706D6E4469616772616D29207B0A2020696620282162706D6E4469616772616D207C7C202162706D6E4469616772616D';
wwv_flow_imp.g_varchar2_table(2387) := '2E706C616E6529207B0A2020202072657475726E3B0A20207D0A0A20207661722062706D6E456C656D656E74203D2062706D6E4469616772616D2E706C616E652E62706D6E456C656D656E742C0A202020202020726F6F74456C656D656E74203D206270';
wwv_flow_imp.g_varchar2_table(2388) := '6D6E456C656D656E743B0A0A2020696620282128302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6973292862706D6E456C656D656E742C202762706D6E3A50726F63657373272920';
wwv_flow_imp.g_varchar2_table(2389) := '2626202128302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6973292862706D6E456C656D656E742C202762706D6E3A436F6C6C61626F726174696F6E272929207B0A20202020726F';
wwv_flow_imp.g_varchar2_table(2390) := '6F74456C656D656E74203D2066696E64526F6F7450726F636573732862706D6E456C656D656E74293B0A20207D0A0A20202F2F20696E2063617365207468652070726F636573732069732070617274206F66206120636F6C6C61626F726174696F6E2C20';
wwv_flow_imp.g_varchar2_table(2391) := '74686520706C616E65207265666572656E636573207468650A20202F2F20636F6C6C61626F726174696F6E2C206E6F74207468652070726F636573730A202076617220636F6C6C61626F726174696F6E3B0A0A20206966202828302C5F7574696C5F4D6F';
wwv_flow_imp.g_varchar2_table(2392) := '64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E69732928726F6F74456C656D656E742C202762706D6E3A436F6C6C61626F726174696F6E272929207B0A20202020636F6C6C61626F726174696F6E203D2072';
wwv_flow_imp.g_varchar2_table(2393) := '6F6F74456C656D656E743B0A20207D20656C7365207B0A20202020636F6C6C61626F726174696F6E203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E66696E642928646566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(2394) := '732E726F6F74456C656D656E74732C2066756E6374696F6E28656C656D656E7429207B0A202020202020696620282128302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6973292865';
wwv_flow_imp.g_varchar2_table(2395) := '6C656D656E742C202762706D6E3A436F6C6C61626F726174696F6E272929207B0A202020202020202072657475726E3B0A2020202020207D0A0A20202020202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(2396) := '5F4D4F44554C455F315F5F2E66696E642928656C656D656E742E7061727469636970616E74732C2066756E6374696F6E287061727469636970616E7429207B0A202020202020202072657475726E207061727469636970616E742E70726F636573735265';
wwv_flow_imp.g_varchar2_table(2397) := '66203D3D3D20726F6F74456C656D656E743B0A2020202020207D293B0A202020207D293B0A20207D0A0A202076617220726F6F74456C656D656E7473203D205B20726F6F74456C656D656E74205D3B0A0A20202F2F20616C6C20636F6C6C61626F726174';
wwv_flow_imp.g_varchar2_table(2398) := '696F6E2070726F6365737365732063616E20636F6E7461696E207375622D6469616772616D730A202069662028636F6C6C61626F726174696F6E29207B0A20202020726F6F74456C656D656E7473203D2028302C6D696E5F646173685F5F574542504143';
wwv_flow_imp.g_varchar2_table(2399) := '4B5F494D504F525445445F4D4F44554C455F315F5F2E6D61702928636F6C6C61626F726174696F6E2E7061727469636970616E74732C2066756E6374696F6E287061727469636970616E7429207B0A20202020202072657475726E207061727469636970';
wwv_flow_imp.g_varchar2_table(2400) := '616E742E70726F636573735265663B0A202020207D293B0A0A20202020726F6F74456C656D656E74732E7075736828636F6C6C61626F726174696F6E293B0A20207D0A0A202076617220616C6C4368696C6472656E203D2073656C66416E64416C6C466C';
wwv_flow_imp.g_varchar2_table(2401) := '6F77456C656D656E747328726F6F74456C656D656E7473293B0A0A20202F2F2069662077652068617665206D756C7469706C65206469616772616D73207265666572656E63696E67207468652073616D6520656C656D656E742C2077650A20202F2F2075';
wwv_flow_imp.g_varchar2_table(2402) := '73652074686520666972737420696E207468652066696C650A2020766172206469616772616D73546F496D706F7274203D205B2062706D6E4469616772616D205D3B0A20207661722068616E646C6564456C656D656E7473203D205B2062706D6E456C65';
wwv_flow_imp.g_varchar2_table(2403) := '6D656E74205D3B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F72456163682928646566696E6974696F6E732E6469616772616D732C2066756E6374696F6E286469616772616D29';
wwv_flow_imp.g_varchar2_table(2404) := '207B0A0A2020202069662028216469616772616D2E706C616E6529207B0A20202020202072657475726E3B0A202020207D0A0A2020202076617220627573696E6573734F626A656374203D206469616772616D2E706C616E652E62706D6E456C656D656E';
wwv_flow_imp.g_varchar2_table(2405) := '743B0A0A20202020696620280A202020202020616C6C4368696C6472656E2E696E6465784F6628627573696E6573734F626A6563742920213D3D202D312026260A20202020202068616E646C6564456C656D656E74732E696E6465784F6628627573696E';
wwv_flow_imp.g_varchar2_table(2406) := '6573734F626A65637429203D3D3D202D310A2020202029207B0A2020202020206469616772616D73546F496D706F72742E70757368286469616772616D293B0A20202020202068616E646C6564456C656D656E74732E7075736828627573696E6573734F';
wwv_flow_imp.g_varchar2_table(2407) := '626A656374293B0A202020207D0A20207D293B0A0A0A202072657475726E206469616772616D73546F496D706F72743B0A7D0A0A66756E6374696F6E2073656C66416E64416C6C466C6F77456C656D656E747328656C656D656E747329207B0A20207661';
wwv_flow_imp.g_varchar2_table(2408) := '7220726573756C74203D205B5D3B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F72456163682928656C656D656E74732C2066756E6374696F6E28656C656D656E7429207B0A2020';
wwv_flow_imp.g_varchar2_table(2409) := '20206966202821656C656D656E7429207B0A20202020202072657475726E3B0A202020207D0A0A20202020726573756C742E7075736828656C656D656E74293B0A0A20202020726573756C74203D20726573756C742E636F6E6361742873656C66416E64';
wwv_flow_imp.g_varchar2_table(2410) := '416C6C466C6F77456C656D656E747328656C656D656E742E666C6F77456C656D656E747329293B0A20207D293B0A0A202072657475726E20726573756C743B0A7D0A0A66756E6374696F6E2066696E64526F6F7450726F6365737328656C656D656E7429';
wwv_flow_imp.g_varchar2_table(2411) := '207B0A202076617220706172656E74203D20656C656D656E743B0A0A20207768696C652028706172656E7429207B0A202020206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F32';
wwv_flow_imp.g_varchar2_table(2412) := '5F5F2E69732928706172656E742C202762706D6E3A50726F63657373272929207B0A20202020202072657475726E20706172656E743B0A202020207D0A0A20202020706172656E74203D20706172656E742E24706172656E743B0A20207D0A7D0A0A0A2F';
wwv_flow_imp.g_varchar2_table(2413) := '2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F5574696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(2414) := '2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F5574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(2415) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F2920';
wwv_flow_imp.g_varchar2_table(2416) := '3D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061';
wwv_flow_imp.g_varchar2_table(2417) := '636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020656C656D656E74546F537472696E673A202829203D3E20282F2A2062696E64696E67202A2F20656C656D656E74546F537472696E67290A2F2A20686172';
wwv_flow_imp.g_varchar2_table(2418) := '6D6F6E79206578706F7274202A2F207D293B0A66756E6374696F6E20656C656D656E74546F537472696E67286529207B0A202069662028216529207B0A2020202072657475726E20273C6E756C6C3E273B0A20207D0A0A202072657475726E20273C2720';
wwv_flow_imp.g_varchar2_table(2419) := '2B20652E2474797065202B2028652E6964203F20272069643D2227202B20652E6964203A20272729202B202722202F3E273B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F69';
wwv_flow_imp.g_varchar2_table(2420) := '6D706F72742F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E';
wwv_flow_imp.g_varchar2_table(2421) := '2D6A732F6C69622F696D706F72742F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E75736564';
wwv_flow_imp.g_varchar2_table(2422) := '5F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F657870';
wwv_flow_imp.g_varchar2_table(2423) := '6F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264';
wwv_flow_imp.g_varchar2_table(2424) := '656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076617220646961677261';
wwv_flow_imp.g_varchar2_table(2425) := '6D5F6A735F6C69625F6931386E5F7472616E736C6174655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F6931386E2F74';
wwv_flow_imp.g_varchar2_table(2426) := '72616E736C617465202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6931386E2F7472616E736C6174652F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F42706D6E';
wwv_flow_imp.g_varchar2_table(2427) := '496D706F727465725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F42706D6E496D706F72746572202A2F20222E2F6E6F64655F6D6F64756C65732F6270';
wwv_flow_imp.g_varchar2_table(2428) := '6D6E2D6A732F6C69622F696D706F72742F42706D6E496D706F727465722E6A7322293B0A0A0A0A0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F';
wwv_flow_imp.g_varchar2_table(2429) := '5F203D20287B0A20205F5F646570656E64735F5F3A205B0A202020206469616772616D5F6A735F6C69625F6931386E5F7472616E736C6174655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D0A2020';
wwv_flow_imp.g_varchar2_table(2430) := '5D2C0A202062706D6E496D706F727465723A205B202774797065272C205F42706D6E496D706F727465725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D205D0A7D293B0A0A2F2A2A2A2F207D292C0A';
wwv_flow_imp.g_varchar2_table(2431) := '0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F436F6D7061746962696C6974795574696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(2432) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F436F6D7061746962696C6974795574696C2E6A73202A2A2A210A20205C2A2A';
wwv_flow_imp.g_varchar2_table(2433) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061';
wwv_flow_imp.g_varchar2_table(2434) := '636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F';
wwv_flow_imp.g_varchar2_table(2435) := '7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020656E73757265436F6D70617444695265663A202829203D3E2028';
wwv_flow_imp.g_varchar2_table(2436) := '2F2A2062696E64696E67202A2F20656E73757265436F6D7061744469526566290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B';
wwv_flow_imp.g_varchar2_table(2437) := '5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A';
wwv_flow_imp.g_varchar2_table(2438) := '7322293B0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E740A202A2F0A0A0A2F2F20544F444F286E696B6B75293A20';
wwv_flow_imp.g_varchar2_table(2439) := '72656D6F76652077697468206675747572652062706D6E2D6A732076657273696F6E0A0A7661722044495F4552524F525F4D455353414745203D2027547269656420746F206163636573732064692066726F6D2074686520627573696E6573734F626A65';
wwv_flow_imp.g_varchar2_table(2440) := '63742E2054686520646920697320617661696C61626C65207468726F75676820746865206469616772616D20656C656D656E74206F6E6C792E20466F72206D6F726520696E666F726D6174696F6E2C207365652068747470733A2F2F6769746875622E63';
wwv_flow_imp.g_varchar2_table(2441) := '6F6D2F62706D6E2D696F2F62706D6E2D6A732F6973737565732F31343732273B0A0A2F2A2A0A202A2040707269766174650A202A0A202A2040706172616D207B4D6F64646C65456C656D656E747D20627573696E6573734F626A6563740A202A2F0A6675';
wwv_flow_imp.g_varchar2_table(2442) := '6E6374696F6E20656E73757265436F6D706174446952656628627573696E6573734F626A65637429207B0A0A20202F2F2062706D6E456C656D656E742063616E2068617665206D756C7469706C6520696E646570656E64656E74204449730A2020696620';
wwv_flow_imp.g_varchar2_table(2443) := '282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6861732928627573696E6573734F626A6563742C20276469272929207B0A202020204F626A6563742E646566696E6550726F70657274792862';
wwv_flow_imp.g_varchar2_table(2444) := '7573696E6573734F626A6563742C20276469272C207B0A202020202020656E756D657261626C653A2066616C73652C0A2020202020206765743A2066756E6374696F6E2829207B0A20202020202020207468726F77206E6577204572726F722844495F45';
wwv_flow_imp.g_varchar2_table(2445) := '52524F525F4D455353414745293B0A2020202020207D0A202020207D293B0A20207D0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F44695574696C2E6A73223A0A';
wwv_flow_imp.g_varchar2_table(2446) := '2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4469557469';
wwv_flow_imp.g_varchar2_table(2447) := '6C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F77';
wwv_flow_imp.g_varchar2_table(2448) := '65627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E7920';
wwv_flow_imp.g_varchar2_table(2449) := '6578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020686173436F6D70656E736174654576656E7444656669';
wwv_flow_imp.g_varchar2_table(2450) := '6E6974696F6E3A202829203D3E20282F2A2062696E64696E67202A2F20686173436F6D70656E736174654576656E74446566696E6974696F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206861734572726F724576656E7444656669';
wwv_flow_imp.g_varchar2_table(2451) := '6E6974696F6E3A202829203D3E20282F2A2062696E64696E67202A2F206861734572726F724576656E74446566696E6974696F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F202020686173457363616C6174696F6E4576656E7444656669';
wwv_flow_imp.g_varchar2_table(2452) := '6E6974696F6E3A202829203D3E20282F2A2062696E64696E67202A2F20686173457363616C6174696F6E4576656E74446566696E6974696F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206861734576656E74446566696E6974696F';
wwv_flow_imp.g_varchar2_table(2453) := '6E3A202829203D3E20282F2A2062696E64696E67202A2F206861734576656E74446566696E6974696F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F20202069734576656E7453756250726F636573733A202829203D3E20282F2A2062696E';
wwv_flow_imp.g_varchar2_table(2454) := '64696E67202A2F2069734576656E7453756250726F63657373292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206973457870616E6465643A202829203D3E20282F2A2062696E64696E67202A2F206973457870616E646564292C0A2F2A20';
wwv_flow_imp.g_varchar2_table(2455) := '6861726D6F6E79206578706F7274202A2F2020206973486F72697A6F6E74616C3A202829203D3E20282F2A2062696E64696E67202A2F206973486F72697A6F6E74616C292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206973496E746572';
wwv_flow_imp.g_varchar2_table(2456) := '72757074696E673A202829203D3E20282F2A2062696E64696E67202A2F206973496E74657272757074696E67290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F4D6F64';
wwv_flow_imp.g_varchar2_table(2457) := '656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A73';
wwv_flow_imp.g_varchar2_table(2458) := '2F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(2459) := '5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F7274';
wwv_flow_imp.g_varchar2_table(2460) := '28272E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E740A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D65';
wwv_flow_imp.g_varchar2_table(2461) := '6E740A202A2F0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A2040706172616D207B4D6F64646C65456C656D656E747D205B64695D0A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66';
wwv_flow_imp.g_varchar2_table(2462) := '756E6374696F6E206973457870616E64656428656C656D656E742C20646929207B0A0A20206966202828302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69732928656C656D656E742C20276270';
wwv_flow_imp.g_varchar2_table(2463) := '6D6E3A43616C6C4163746976697479272929207B0A2020202072657475726E2066616C73653B0A20207D0A0A20206966202828302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69732928656C65';
wwv_flow_imp.g_varchar2_table(2464) := '6D656E742C202762706D6E3A53756250726F63657373272929207B0A202020206469203D206469207C7C2028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E67657444692928656C656D656E74';
wwv_flow_imp.g_varchar2_table(2465) := '293B0A0A202020206966202864692026262028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6973292864692C202762706D6E64693A42504D4E506C616E65272929207B0A2020202020207265';
wwv_flow_imp.g_varchar2_table(2466) := '7475726E20747275653B0A202020207D0A0A2020202072657475726E20646920262620212164692E6973457870616E6465643B0A20207D0A0A20206966202828302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(2467) := '455F305F5F2E69732928656C656D656E742C202762706D6E3A5061727469636970616E74272929207B0A2020202072657475726E20212128302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6765';
wwv_flow_imp.g_varchar2_table(2468) := '74427573696E6573734F626A6563742928656C656D656E74292E70726F636573735265663B0A20207D0A0A202072657475726E20747275653B0A7D0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A2040';
wwv_flow_imp.g_varchar2_table(2469) := '72657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206973486F72697A6F6E74616C28656C656D656E7429207B0A0A2020696620282128302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C45';
wwv_flow_imp.g_varchar2_table(2470) := '5F305F5F2E69732928656C656D656E742C202762706D6E3A5061727469636970616E742729202626202128302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69732928656C656D656E742C202762';
wwv_flow_imp.g_varchar2_table(2471) := '706D6E3A4C616E65272929207B0A2020202072657475726E20756E646566696E65643B0A20207D0A0A2020766172206973486F72697A6F6E74616C203D2028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C45';
wwv_flow_imp.g_varchar2_table(2472) := '5F305F5F2E67657444692928656C656D656E74292E6973486F72697A6F6E74616C3B0A0A2020696620286973486F72697A6F6E74616C203D3D3D20756E646566696E656429207B0A2020202072657475726E20747275653B0A20207D0A0A202072657475';
wwv_flow_imp.g_varchar2_table(2473) := '726E206973486F72697A6F6E74616C3B0A7D0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206973496E74657272757074';
wwv_flow_imp.g_varchar2_table(2474) := '696E6728656C656D656E7429207B0A202072657475726E20656C656D656E742026262028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E676574427573696E6573734F626A6563742928656C65';
wwv_flow_imp.g_varchar2_table(2475) := '6D656E74292E6973496E74657272757074696E6720213D3D2066616C73653B0A7D0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374';
wwv_flow_imp.g_varchar2_table(2476) := '696F6E2069734576656E7453756250726F6365737328656C656D656E7429207B0A202072657475726E20656C656D656E7420262620212128302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6765';
wwv_flow_imp.g_varchar2_table(2477) := '74427573696E6573734F626A6563742928656C656D656E74292E74726967676572656442794576656E743B0A7D0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A2040706172616D207B737472696E677D206576';
wwv_flow_imp.g_varchar2_table(2478) := '656E74547970650A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206861734576656E74446566696E6974696F6E28656C656D656E742C206576656E745479706529207B0A2020766172206576656E74446566';
wwv_flow_imp.g_varchar2_table(2479) := '696E6974696F6E73203D2028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E676574427573696E6573734F626A6563742928656C656D656E74292E6576656E74446566696E6974696F6E733B0A';
wwv_flow_imp.g_varchar2_table(2480) := '0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E736F6D6529286576656E74446566696E6974696F6E732C2066756E6374696F6E286576656E7429207B0A20202020726574';
wwv_flow_imp.g_varchar2_table(2481) := '75726E2028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E697329286576656E742C206576656E7454797065293B0A20207D293B0A7D0A0A2F2A2A0A202A2040706172616D207B456C656D656E';
wwv_flow_imp.g_varchar2_table(2482) := '747D20656C656D656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206861734572726F724576656E74446566696E6974696F6E28656C656D656E7429207B0A202072657475726E206861734576656E74';
wwv_flow_imp.g_varchar2_table(2483) := '446566696E6974696F6E28656C656D656E742C202762706D6E3A4572726F724576656E74446566696E6974696F6E27293B0A7D0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B';
wwv_flow_imp.g_varchar2_table(2484) := '626F6F6C65616E7D0A202A2F0A66756E6374696F6E20686173457363616C6174696F6E4576656E74446566696E6974696F6E28656C656D656E7429207B0A202072657475726E206861734576656E74446566696E6974696F6E28656C656D656E742C2027';
wwv_flow_imp.g_varchar2_table(2485) := '62706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E27293B0A7D0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E';
wwv_flow_imp.g_varchar2_table(2486) := '6374696F6E20686173436F6D70656E736174654576656E74446566696E6974696F6E28656C656D656E7429207B0A202072657475726E206861734576656E74446566696E6974696F6E28656C656D656E742C202762706D6E3A436F6D70656E7361746545';
wwv_flow_imp.g_varchar2_table(2487) := '76656E74446566696E6974696F6E27293B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4472696C6C646F776E5574696C2E6A73223A0A2F2A212A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(2488) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4472696C6C646F';
wwv_flow_imp.g_varchar2_table(2489) := '776E5574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B';
wwv_flow_imp.g_varchar2_table(2490) := '5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B';
wwv_flow_imp.g_varchar2_table(2491) := '0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020676574506C616E654964';
wwv_flow_imp.g_varchar2_table(2492) := '46726F6D53686170653A202829203D3E20282F2A2062696E64696E67202A2F20676574506C616E65496446726F6D5368617065292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206765745368617065496446726F6D506C616E653A202829';
wwv_flow_imp.g_varchar2_table(2493) := '203D3E20282F2A2062696E64696E67202A2F206765745368617065496446726F6D506C616E65292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206973506C616E653A202829203D3E20282F2A2062696E64696E67202A2F206973506C616E';
wwv_flow_imp.g_varchar2_table(2494) := '65292C0A2F2A206861726D6F6E79206578706F7274202A2F202020706C616E655375666669783A202829203D3E20282F2A2062696E64696E67202A2F20706C616E65537566666978292C0A2F2A206861726D6F6E79206578706F7274202A2F202020746F';
wwv_flow_imp.g_varchar2_table(2495) := '506C616E6549643A202829203D3E20282F2A2062696E64696E67202A2F20746F506C616E654964290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F4D6F64656C557469';
wwv_flow_imp.g_varchar2_table(2496) := '6C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F';
wwv_flow_imp.g_varchar2_table(2497) := '7574696C2F4D6F64656C5574696C2E6A7322293B0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E740A202A204074797065646566207B696D706F72';
wwv_flow_imp.g_varchar2_table(2498) := '7428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E740A202A2F0A0A76617220706C616E65537566666978203D20275F706C616E65273B0A0A2F2A2A0A202A20476574207072696D6172';
wwv_flow_imp.g_varchar2_table(2499) := '7920736861706520494420666F72206120706C616E652E0A202A0A202A2040706172616D20207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B737472696E677D0A202A2F0A66756E';
wwv_flow_imp.g_varchar2_table(2500) := '6374696F6E206765745368617065496446726F6D506C616E6528656C656D656E7429207B0A2020766172206964203D20656C656D656E742E69643B0A0A202072657475726E2072656D6F7665506C616E65537566666978286964293B0A7D0A0A2F2A2A0A';
wwv_flow_imp.g_varchar2_table(2501) := '202A2047657420706C616E6520494420666F722061207072696D6172792073686170652E0A202A0A202A2040706172616D20207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B7374';
wwv_flow_imp.g_varchar2_table(2502) := '72696E677D0A202A2F0A66756E6374696F6E20676574506C616E65496446726F6D536861706528656C656D656E7429207B0A2020766172206964203D20656C656D656E742E69643B0A0A20206966202828302C5F4D6F64656C5574696C5F5F5745425041';
wwv_flow_imp.g_varchar2_table(2503) := '434B5F494D504F525445445F4D4F44554C455F305F5F2E69732928656C656D656E742C202762706D6E3A53756250726F63657373272929207B0A2020202072657475726E20616464506C616E65537566666978286964293B0A20207D0A0A202072657475';
wwv_flow_imp.g_varchar2_table(2504) := '726E2069643B0A7D0A0A2F2A2A0A202A2047657420706C616E6520494420666F72207072696D6172792073686170652049442E0A202A0A202A2040706172616D207B737472696E677D2069640A202A0A202A204072657475726E207B737472696E677D0A';
wwv_flow_imp.g_varchar2_table(2505) := '202A2F0A66756E6374696F6E20746F506C616E65496428696429207B0A202072657475726E20616464506C616E65537566666978286964293B0A7D0A0A2F2A2A0A202A20436865636B2077657468657220656C656D656E7420697320706C616E652E0A20';
wwv_flow_imp.g_varchar2_table(2506) := '2A0A202A2040706172616D20207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206973506C616E6528656C656D656E7429207B';
wwv_flow_imp.g_varchar2_table(2507) := '0A2020766172206469203D2028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E67657444692928656C656D656E74293B0A0A202072657475726E2028302C5F4D6F64656C5574696C5F5F574542';
wwv_flow_imp.g_varchar2_table(2508) := '5041434B5F494D504F525445445F4D4F44554C455F305F5F2E6973292864692C202762706D6E64693A42504D4E506C616E6527293B0A7D0A0A66756E6374696F6E20616464506C616E6553756666697828696429207B0A202072657475726E206964202B';
wwv_flow_imp.g_varchar2_table(2509) := '20706C616E655375666669783B0A7D0A0A66756E6374696F6E2072656D6F7665506C616E6553756666697828696429207B0A202072657475726E2069642E7265706C616365286E65772052656745787028706C616E65537566666978202B20272427292C';
wwv_flow_imp.g_varchar2_table(2510) := '202727293B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4C6162656C5574696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(2511) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4C6162656C5574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(2512) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C';
wwv_flow_imp.g_varchar2_table(2513) := '205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061';
wwv_flow_imp.g_varchar2_table(2514) := '636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F20202044454641554C545F4C4142454C5F53495A453A202829203D3E20282F2A2062696E64696E67202A';
wwv_flow_imp.g_varchar2_table(2515) := '2F2044454641554C545F4C4142454C5F53495A45292C0A2F2A206861726D6F6E79206578706F7274202A2F202020464C4F575F4C4142454C5F494E44454E543A202829203D3E20282F2A2062696E64696E67202A2F20464C4F575F4C4142454C5F494E44';
wwv_flow_imp.g_varchar2_table(2516) := '454E54292C0A2F2A206861726D6F6E79206578706F7274202A2F20202067657445787465726E616C4C6162656C426F756E64733A202829203D3E20282F2A2062696E64696E67202A2F2067657445787465726E616C4C6162656C426F756E6473292C0A2F';
wwv_flow_imp.g_varchar2_table(2517) := '2A206861726D6F6E79206578706F7274202A2F20202067657445787465726E616C4C6162656C4D69643A202829203D3E20282F2A2062696E64696E67202A2F2067657445787465726E616C4C6162656C4D6964292C0A2F2A206861726D6F6E7920657870';
wwv_flow_imp.g_varchar2_table(2518) := '6F7274202A2F202020676574466C6F774C6162656C506F736974696F6E3A202829203D3E20282F2A2062696E64696E67202A2F20676574466C6F774C6162656C506F736974696F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206765';
wwv_flow_imp.g_varchar2_table(2519) := '744C6162656C3A202829203D3E20282F2A2062696E64696E67202A2F206765744C6162656C292C0A2F2A206861726D6F6E79206578706F7274202A2F202020676574576179706F696E74734D69643A202829203D3E20282F2A2062696E64696E67202A2F';
wwv_flow_imp.g_varchar2_table(2520) := '20676574576179706F696E74734D6964292C0A2F2A206861726D6F6E79206578706F7274202A2F20202068617345787465726E616C4C6162656C3A202829203D3E20282F2A2062696E64696E67202A2F2068617345787465726E616C4C6162656C292C0A';
wwv_flow_imp.g_varchar2_table(2521) := '2F2A206861726D6F6E79206578706F7274202A2F20202069734C6162656C3A202829203D3E20282F2A2072656578706F72742073616665202A2F206469616772616D5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D';
wwv_flow_imp.g_varchar2_table(2522) := '504F525445445F4D4F44554C455F305F5F2E69734C6162656C292C0A2F2A206861726D6F6E79206578706F7274202A2F20202069734C6162656C45787465726E616C3A202829203D3E20282F2A2062696E64696E67202A2F2069734C6162656C45787465';
wwv_flow_imp.g_varchar2_table(2523) := '726E616C292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207365744C6162656C3A202829203D3E20282F2A2062696E64696E67202A2F207365744C6162656C290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2068';
wwv_flow_imp.g_varchar2_table(2524) := '61726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F';
wwv_flow_imp.g_varchar2_table(2525) := '6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44';
wwv_flow_imp.g_varchar2_table(2526) := '554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A2F2A';
wwv_flow_imp.g_varchar2_table(2527) := '206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972';
wwv_flow_imp.g_varchar2_table(2528) := '655F5F282F2A21206469616772616D2D6A732F6C69622F7574696C2F4D6F64656C5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A0A0A0A0A0A0A0A';
wwv_flow_imp.g_varchar2_table(2529) := '0A2F2A2A0A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F7574696C2F547970657327292E506F696E747D20506F696E740A202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C';
wwv_flow_imp.g_varchar2_table(2530) := '69622F7574696C2F547970657327292E526563747D20526563740A202A0A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E740A202A204074797065646566207B696D';
wwv_flow_imp.g_varchar2_table(2531) := '706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E740A202A2F0A0A7661722044454641554C545F4C4142454C5F53495A45203D207B0A202077696474683A2039302C0A202068';
wwv_flow_imp.g_varchar2_table(2532) := '65696768743A2032300A7D3B0A0A76617220464C4F575F4C4142454C5F494E44454E54203D2031353B0A0A0A2F2A2A0A202A2052657475726E20747275652069662074686520676976656E2073656D616E7469632068617320616E2065787465726E616C';
wwv_flow_imp.g_varchar2_table(2533) := '206C6162656C2E0A202A0A202A2040706172616D207B456C656D656E747D2073656D616E7469630A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E2069734C6162656C45787465726E616C2873656D616E7469';
wwv_flow_imp.g_varchar2_table(2534) := '6329207B0A202072657475726E2028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A4576656E742729207C7C0A20202020202020202028302C';
wwv_flow_imp.g_varchar2_table(2535) := '5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A476174657761792729207C7C0A20202020202020202028302C5F4D6F64656C5574696C5F5F574542';
wwv_flow_imp.g_varchar2_table(2536) := '5041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A4461746153746F72655265666572656E63652729207C7C0A20202020202020202028302C5F4D6F64656C5574696C5F5F5745425041434B';
wwv_flow_imp.g_varchar2_table(2537) := '5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A446174614F626A6563745265666572656E63652729207C7C0A20202020202020202028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D';
wwv_flow_imp.g_varchar2_table(2538) := '504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A44617461496E7075742729207C7C0A20202020202020202028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C45';
wwv_flow_imp.g_varchar2_table(2539) := '5F315F5F2E6973292873656D616E7469632C202762706D6E3A446174614F75747075742729207C7C0A20202020202020202028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D';
wwv_flow_imp.g_varchar2_table(2540) := '616E7469632C202762706D6E3A53657175656E6365466C6F772729207C7C0A20202020202020202028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C20276270';
wwv_flow_imp.g_varchar2_table(2541) := '6D6E3A4D657373616765466C6F772729207C7C0A20202020202020202028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A47726F757027293B';
wwv_flow_imp.g_varchar2_table(2542) := '0A7D0A0A2F2A2A0A202A2052657475726E20747275652069662074686520676976656E20656C656D656E742068617320616E2065787465726E616C206C6162656C2E0A202A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A';
wwv_flow_imp.g_varchar2_table(2543) := '0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E2068617345787465726E616C4C6162656C28656C656D656E7429207B0A202072657475726E2028302C6469616772616D5F6A735F6C69625F7574696C5F4D6F64656C';
wwv_flow_imp.g_varchar2_table(2544) := '5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734C6162656C2928656C656D656E742E6C6162656C293B0A7D0A0A2F2A2A0A202A204765742074686520706F736974696F6E206F6620612073657175656E636520';
wwv_flow_imp.g_varchar2_table(2545) := '666C6F77206C6162656C2E0A202A0A202A2040706172616D20207B506F696E745B5D7D20776179706F696E74730A202A0A202A204072657475726E207B506F696E747D0A202A2F0A66756E6374696F6E20676574466C6F774C6162656C506F736974696F';
wwv_flow_imp.g_varchar2_table(2546) := '6E28776179706F696E747329207B0A0A20202F2F206765742074686520776179706F696E7473206D69640A2020766172206D6964203D20776179706F696E74732E6C656E677468202F2032202D20313B0A0A2020766172206669727374203D2077617970';
wwv_flow_imp.g_varchar2_table(2547) := '6F696E74735B4D6174682E666C6F6F72286D6964295D3B0A2020766172207365636F6E64203D20776179706F696E74735B4D6174682E6365696C286D6964202B20302E3031295D3B0A0A20202F2F2067657420706F736974696F6E0A202076617220706F';
wwv_flow_imp.g_varchar2_table(2548) := '736974696F6E203D20676574576179706F696E74734D696428776179706F696E7473293B0A0A20202F2F2063616C63756C61746520616E676C650A202076617220616E676C65203D204D6174682E6174616E28287365636F6E642E79202D206669727374';
wwv_flow_imp.g_varchar2_table(2549) := '2E7929202F20287365636F6E642E78202D2066697273742E7829293B0A0A20207661722078203D20706F736974696F6E2E782C0A20202020202079203D20706F736974696F6E2E793B0A0A2020696620284D6174682E61627328616E676C6529203C204D';
wwv_flow_imp.g_varchar2_table(2550) := '6174682E5049202F203229207B0A2020202079202D3D20464C4F575F4C4142454C5F494E44454E543B0A20207D20656C7365207B0A2020202078202B3D20464C4F575F4C4142454C5F494E44454E543B0A20207D0A0A202072657475726E207B20783A20';
wwv_flow_imp.g_varchar2_table(2551) := '782C20793A2079207D3B0A7D0A0A0A2F2A2A0A202A2047657420746865206D6964646C65206F662061206E756D626572206F6620776179706F696E74732E0A202A0A202A2040706172616D20207B506F696E745B5D7D20776179706F696E74730A202A0A';
wwv_flow_imp.g_varchar2_table(2552) := '202A204072657475726E207B506F696E747D0A202A2F0A66756E6374696F6E20676574576179706F696E74734D696428776179706F696E747329207B0A0A2020766172206D6964203D20776179706F696E74732E6C656E677468202F2032202D20313B0A';
wwv_flow_imp.g_varchar2_table(2553) := '0A2020766172206669727374203D20776179706F696E74735B4D6174682E666C6F6F72286D6964295D3B0A2020766172207365636F6E64203D20776179706F696E74735B4D6174682E6365696C286D6964202B20302E3031295D3B0A0A20207265747572';
wwv_flow_imp.g_varchar2_table(2554) := '6E207B0A20202020783A2066697273742E78202B20287365636F6E642E78202D2066697273742E7829202F20322C0A20202020793A2066697273742E79202B20287365636F6E642E79202D2066697273742E7929202F20320A20207D3B0A7D0A0A2F2A2A';
wwv_flow_imp.g_varchar2_table(2555) := '0A202A2047657420746865206D6964646C65206F66207468652065787465726E616C206C6162656C206F6620616E20656C656D656E742E0A202A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E';
wwv_flow_imp.g_varchar2_table(2556) := '207B506F696E747D0A202A2F0A66756E6374696F6E2067657445787465726E616C4C6162656C4D696428656C656D656E7429207B0A0A202069662028656C656D656E742E776179706F696E747329207B0A2020202072657475726E20676574466C6F774C';
wwv_flow_imp.g_varchar2_table(2557) := '6162656C506F736974696F6E28656C656D656E742E776179706F696E7473293B0A20207D20656C7365206966202828302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69732928656C656D656E74';
wwv_flow_imp.g_varchar2_table(2558) := '2C202762706D6E3A47726F7570272929207B0A2020202072657475726E207B0A202020202020783A20656C656D656E742E78202B20656C656D656E742E7769647468202F20322C0A202020202020793A20656C656D656E742E79202B2044454641554C54';
wwv_flow_imp.g_varchar2_table(2559) := '5F4C4142454C5F53495A452E686569676874202F20320A202020207D3B0A20207D20656C7365207B0A2020202072657475726E207B0A202020202020783A20656C656D656E742E78202B20656C656D656E742E7769647468202F20322C0A202020202020';
wwv_flow_imp.g_varchar2_table(2560) := '793A20656C656D656E742E79202B20656C656D656E742E686569676874202B2044454641554C545F4C4142454C5F53495A452E686569676874202F20320A202020207D3B0A20207D0A7D0A0A0A2F2A2A0A202A2052657475726E2074686520626F756E64';
wwv_flow_imp.g_varchar2_table(2561) := '73206F6620616E20656C656D656E7473206C6162656C2C207061727365642066726F6D2074686520656C656D656E7473204449206F720A202A2067656E6572617465642066726F6D2069747320626F756E64732E0A202A0A202A2040706172616D207B4D';
wwv_flow_imp.g_varchar2_table(2562) := '6F64646C65456C656D656E747D2064690A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B526563747D0A202A2F0A66756E6374696F6E2067657445787465726E616C4C6162656C426F756E64';
wwv_flow_imp.g_varchar2_table(2563) := '732864692C20656C656D656E7429207B0A0A2020766172206D69642C0A20202020202073697A652C0A202020202020626F756E64732C0A2020202020206C6162656C203D2064692E6C6162656C3B0A0A2020696620286C6162656C202626206C6162656C';
wwv_flow_imp.g_varchar2_table(2564) := '2E626F756E647329207B0A20202020626F756E6473203D206C6162656C2E626F756E64733B0A0A2020202073697A65203D207B0A20202020202077696474683A204D6174682E6D61782844454641554C545F4C4142454C5F53495A452E77696474682C20';
wwv_flow_imp.g_varchar2_table(2565) := '626F756E64732E7769647468292C0A2020202020206865696768743A20626F756E64732E6865696768740A202020207D3B0A0A202020206D6964203D207B0A202020202020783A20626F756E64732E78202B20626F756E64732E7769647468202F20322C';
wwv_flow_imp.g_varchar2_table(2566) := '0A202020202020793A20626F756E64732E79202B20626F756E64732E686569676874202F20320A202020207D3B0A20207D20656C7365207B0A0A202020206D6964203D2067657445787465726E616C4C6162656C4D696428656C656D656E74293B0A0A20';
wwv_flow_imp.g_varchar2_table(2567) := '20202073697A65203D2044454641554C545F4C4142454C5F53495A453B0A20207D0A0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E29287B0A2020202078';
wwv_flow_imp.g_varchar2_table(2568) := '3A206D69642E78202D2073697A652E7769647468202F20322C0A20202020793A206D69642E79202D2073697A652E686569676874202F20320A20207D2C2073697A65293B0A7D0A0A2F2A2A0A202A2040706172616D207B4D6F64646C65456C656D656E74';
wwv_flow_imp.g_varchar2_table(2569) := '7D2073656D616E7469630A202A0A202A204072657475726E73207B737472696E677D0A202A2F0A66756E6374696F6E206765744C6162656C417474722873656D616E74696329207B0A2020696620280A2020202028302C5F4D6F64656C5574696C5F5F57';
wwv_flow_imp.g_varchar2_table(2570) := '45425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A466C6F77456C656D656E742729207C7C0A2020202028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(2571) := '4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A5061727469636970616E742729207C7C0A2020202028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873';
wwv_flow_imp.g_varchar2_table(2572) := '656D616E7469632C202762706D6E3A4C616E652729207C7C0A2020202028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A53657175656E6365';
wwv_flow_imp.g_varchar2_table(2573) := '466C6F772729207C7C0A2020202028302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A4D657373616765466C6F772729207C7C0A202020202830';
wwv_flow_imp.g_varchar2_table(2574) := '2C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A44617461496E7075742729207C7C0A2020202028302C5F4D6F64656C5574696C5F5F5745425041';
wwv_flow_imp.g_varchar2_table(2575) := '434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A446174614F757470757427290A202029207B0A2020202072657475726E20276E616D65273B0A20207D0A0A20206966202828302C5F4D6F6465';
wwv_flow_imp.g_varchar2_table(2576) := '6C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A54657874416E6E6F746174696F6E272929207B0A2020202072657475726E202774657874273B0A20207D0A0A20';
wwv_flow_imp.g_varchar2_table(2577) := '206966202828302C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973292873656D616E7469632C202762706D6E3A47726F7570272929207B0A2020202072657475726E202763617465676F727956';
wwv_flow_imp.g_varchar2_table(2578) := '616C7565526566273B0A20207D0A7D0A0A2F2A2A0A202A2040706172616D207B4D6F64646C65456C656D656E747D2073656D616E7469630A202A0A202A204072657475726E73207B737472696E677D0A202A2F0A66756E6374696F6E2067657443617465';
wwv_flow_imp.g_varchar2_table(2579) := '676F727956616C75652873656D616E74696329207B0A20207661722063617465676F727956616C7565526566203D2073656D616E7469635B2763617465676F727956616C7565526566275D3B0A0A2020696620282163617465676F727956616C75655265';
wwv_flow_imp.g_varchar2_table(2580) := '6629207B0A2020202072657475726E2027273B0A20207D0A0A0A202072657475726E2063617465676F727956616C75655265662E76616C7565207C7C2027273B0A7D0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A';
wwv_flow_imp.g_varchar2_table(2581) := '202A0A202A204072657475726E207B737472696E677D0A202A2F0A66756E6374696F6E206765744C6162656C28656C656D656E7429207B0A20207661722073656D616E746963203D20656C656D656E742E627573696E6573734F626A6563742C0A202020';
wwv_flow_imp.g_varchar2_table(2582) := '20202061747472203D206765744C6162656C417474722873656D616E746963293B0A0A2020696620286174747229207B0A0A202020206966202861747472203D3D3D202763617465676F727956616C75655265662729207B0A0A20202020202072657475';
wwv_flow_imp.g_varchar2_table(2583) := '726E2067657443617465676F727956616C75652873656D616E746963293B0A202020207D0A0A2020202072657475726E2073656D616E7469635B617474725D207C7C2027273B0A20207D0A7D0A0A0A2F2A2A0A202A2040706172616D207B456C656D656E';
wwv_flow_imp.g_varchar2_table(2584) := '747D20656C656D656E740A202A2040706172616D207B737472696E677D20746578740A202A0A202A204072657475726E207B456C656D656E747D0A202A2F0A66756E6374696F6E207365744C6162656C28656C656D656E742C207465787429207B0A2020';
wwv_flow_imp.g_varchar2_table(2585) := '7661722073656D616E746963203D20656C656D656E742E627573696E6573734F626A6563742C0A20202020202061747472203D206765744C6162656C417474722873656D616E746963293B0A0A2020696620286174747229207B0A0A2020202069662028';
wwv_flow_imp.g_varchar2_table(2586) := '61747472203D3D3D202763617465676F727956616C75655265662729207B0A20202020202073656D616E7469635B2763617465676F727956616C7565526566275D2E76616C7565203D20746578743B0A202020207D20656C7365207B0A20202020202073';
wwv_flow_imp.g_varchar2_table(2587) := '656D616E7469635B617474725D203D20746578743B0A202020207D0A0A20207D0A0A202072657475726E20656C656D656E743B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C6962';
wwv_flow_imp.g_varchar2_table(2588) := '2F7574696C2F4D6F64656C5574696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65';
wwv_flow_imp.g_varchar2_table(2589) := '732F62706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F20';
wwv_flow_imp.g_varchar2_table(2590) := '28285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F77';
wwv_flow_imp.g_varchar2_table(2591) := '65627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F';
wwv_flow_imp.g_varchar2_table(2592) := '7274202A2F202020676574427573696E6573734F626A6563743A202829203D3E20282F2A2062696E64696E67202A2F20676574427573696E6573734F626A656374292C0A2F2A206861726D6F6E79206578706F7274202A2F20202067657444693A202829';
wwv_flow_imp.g_varchar2_table(2593) := '203D3E20282F2A2062696E64696E67202A2F206765744469292C0A2F2A206861726D6F6E79206578706F7274202A2F20202069733A202829203D3E20282F2A2062696E64696E67202A2F206973292C0A2F2A206861726D6F6E79206578706F7274202A2F';
wwv_flow_imp.g_varchar2_table(2594) := '2020206973416E793A202829203D3E20282F2A2062696E64696E67202A2F206973416E79290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745';
wwv_flow_imp.g_varchar2_table(2595) := '425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E';
wwv_flow_imp.g_varchar2_table(2596) := '65736D2E6A7322293B0A0A0A2F2A2A0A202A204074797065646566207B20696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E74207D20456C656D656E740A202A204074797065646566207B20696D706F727428272E2E2F6D6F';
wwv_flow_imp.g_varchar2_table(2597) := '64656C2F547970657327292E4D6F64646C65456C656D656E74207D204D6F64646C65456C656D656E740A202A2F0A0A2F2A2A0A202A20497320616E20656C656D656E74206F662074686520676976656E2042504D4E20747970653F0A202A0A202A204070';
wwv_flow_imp.g_varchar2_table(2598) := '6172616D20207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E740A202A2040706172616D20207B737472696E677D20747970650A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(2599) := '697328656C656D656E742C207479706529207B0A202076617220626F203D20676574427573696E6573734F626A65637428656C656D656E74293B0A0A202072657475726E20626F2026262028747970656F6620626F2E24696E7374616E63654F66203D3D';
wwv_flow_imp.g_varchar2_table(2600) := '3D202766756E6374696F6E272920262620626F2E24696E7374616E63654F662874797065293B0A7D0A0A0A2F2A2A0A202A2052657475726E207472756520696620656C656D656E742068617320616E79206F662074686520676976656E2074797065732E';
wwv_flow_imp.g_varchar2_table(2601) := '0A202A0A202A2040706172616D207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E740A202A2040706172616D207B737472696E675B5D7D2074797065730A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F';
wwv_flow_imp.g_varchar2_table(2602) := '0A66756E6374696F6E206973416E7928656C656D656E742C20747970657329207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E736F6D65292874797065732C2066756E';
wwv_flow_imp.g_varchar2_table(2603) := '6374696F6E287429207B0A2020202072657475726E20697328656C656D656E742C2074293B0A20207D293B0A7D0A0A2F2A2A0A202A2052657475726E2074686520627573696E657373206F626A65637420666F72206120676976656E20656C656D656E74';
wwv_flow_imp.g_varchar2_table(2604) := '2E0A202A0A202A2040706172616D207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B4D6F64646C65456C656D656E747D0A202A2F0A66756E6374696F6E20676574427573696E6573';
wwv_flow_imp.g_varchar2_table(2605) := '734F626A65637428656C656D656E7429207B0A202072657475726E2028656C656D656E7420262620656C656D656E742E627573696E6573734F626A65637429207C7C20656C656D656E743B0A7D0A0A2F2A2A0A202A2052657475726E2074686520646920';
wwv_flow_imp.g_varchar2_table(2606) := '6F626A65637420666F72206120676976656E20656C656D656E742E0A202A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B4D6F64646C65456C656D656E747D0A202A2F0A66756E6374696F';
wwv_flow_imp.g_varchar2_table(2607) := '6E20676574446928656C656D656E7429207B0A202072657475726E20656C656D656E7420262620656C656D656E742E64693B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F75';
wwv_flow_imp.g_varchar2_table(2608) := '74696C2F506F776572656442795574696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F';
wwv_flow_imp.g_varchar2_table(2609) := '6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F506F776572656442795574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(2610) := '2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F72';
wwv_flow_imp.g_varchar2_table(2611) := '6571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F';
wwv_flow_imp.g_varchar2_table(2612) := '2A206861726D6F6E79206578706F7274202A2F20202042504D4E494F5F494D473A202829203D3E20282F2A2062696E64696E67202A2F2042504D4E494F5F494D47292C0A2F2A206861726D6F6E79206578706F7274202A2F2020204C494E4B5F5354594C';
wwv_flow_imp.g_varchar2_table(2613) := '45533A202829203D3E20282F2A2062696E64696E67202A2F204C494E4B5F5354594C4553292C0A2F2A206861726D6F6E79206578706F7274202A2F2020204C4F474F5F5354594C45533A202829203D3E20282F2A2062696E64696E67202A2F204C4F474F';
wwv_flow_imp.g_varchar2_table(2614) := '5F5354594C4553292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206F70656E3A202829203D3E20282F2A2062696E64696E67202A2F206F70656E290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E';
wwv_flow_imp.g_varchar2_table(2615) := '7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F';
wwv_flow_imp.g_varchar2_table(2616) := '64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A2F2A2A0A202A20546869732066696C65206D757374206E6F74206265206368616E676564206F722065786368616E6765642E0A202A0A202A204073656520687474';
wwv_flow_imp.g_varchar2_table(2617) := '703A2F2F62706D6E2E696F2F6C6963656E736520666F72206D6F726520696E666F726D6174696F6E2E0A202A2F0A0A0A0A0A2F2F20696E6C696E6564202E2E2F2E2E2F7265736F75726365732F6C6F676F2E7376670A7661722042504D4E494F5F4C4F47';
wwv_flow_imp.g_varchar2_table(2618) := '4F5F535647203D20273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F323030302F737667222076696577426F783D223020302031342E303220352E3537222077696474683D22353322206865696768743D223231223E3C7061';
wwv_flow_imp.g_varchar2_table(2619) := '74682066696C6C3D2263757272656E74436F6C6F722220643D224D312E38382E3932762E31346330202E34312D2E31332E36382D2E342E382E33332E31342E34362E34342E34362E3836762E33336330202E36312D2E33332E39352D2E39352E39354830';
wwv_flow_imp.g_varchar2_table(2620) := '5630682E3935632E36352030202E39332E332E39332E39327A4D2E36332E353776312E3036682E3234632E32342030202E33382D2E312E33382D2E3433562E393863302D2E32382D2E312D2E342D2E33322D2E347A6D3020312E363376312E3232682E33';
wwv_flow_imp.g_varchar2_table(2621) := '36632E322030202E33322D2E312E33322D2E3339762D2E333563302D2E33372D2E31322D2E34382D2E342D2E3438482E36337A4D342E31382E3939762E35326330202E36342D2E33312E39382D2E39342E3938682D2E335634682D2E36325630682E3932';
wwv_flow_imp.g_varchar2_table(2622) := '632E36332030202E39342E33352E39342E39397A4D322E39342E353776312E3335682E33632E322030202E332D2E30392E332D2E3337762D2E3663302D2E32392D2E312D2E33382D2E332D2E3338682D2E337A6D322E383920322E32374C362E32352030';
wwv_flow_imp.g_varchar2_table(2623) := '682E38387634682D2E3656312E31324C362E3120332E3939682D2E366C2D2E34362D322E383276322E3832682D2E35355630682E38377A4D382E313420312E315634682D2E35365630682E37394C3920322E345630682E35367634682D2E36347A6D322E';
wwv_flow_imp.g_varchar2_table(2624) := '343920322E3239762E36682D2E36762D2E367A4D31322E3132203163302D2E36332E33332D31202E39352D31202E36312030202E39352E33372E3935203176322E30346330202E36342D2E333420312D2E393520312D2E363220302D2E39352D2E33372D';
wwv_flow_imp.g_varchar2_table(2625) := '2E39352D317A6D2E363220322E30386330202E32382E31332E33392E33332E3339732E33322D2E312E33322D2E34562E393863302D2E32392D2E31322D2E342D2E33322D2E34732D2E33332E31312D2E33332E347A222F3E3C706174682066696C6C3D22';
wwv_flow_imp.g_varchar2_table(2626) := '63757272656E74436F6C6F722220643D224D3020342E35336831342E303276312E303448307A4D31312E30382030682E3633762E3632682D2E36337A6D2E363320345631682D2E363376322E39387A222F3E3C2F7376673E273B0A0A7661722042504D4E';
wwv_flow_imp.g_varchar2_table(2627) := '494F5F494D47203D2042504D4E494F5F4C4F474F5F5356473B0A0A766172204C4F474F5F5354594C4553203D207B0A2020766572746963616C416C69676E3A20276D6964646C65270A7D3B0A0A766172204C494E4B5F5354594C4553203D207B0A202027';
wwv_flow_imp.g_varchar2_table(2628) := '636F6C6F72273A202723343034303430270A7D3B0A0A766172204C49474854424F585F5354594C4553203D207B0A2020277A496E646578273A202731303031272C0A202027706F736974696F6E273A20276669786564272C0A202027746F70273A202730';
wwv_flow_imp.g_varchar2_table(2629) := '272C0A2020276C656674273A202730272C0A2020277269676874273A202730272C0A202027626F74746F6D273A202730270A7D3B0A0A766172204241434B44524F505F5354594C4553203D207B0A2020277769647468273A202731303025272C0A202027';
wwv_flow_imp.g_varchar2_table(2630) := '686569676874273A202731303025272C0A2020276261636B67726F756E64273A2027726762612834302C34302C34302C302E3229270A7D3B0A0A766172204E4F544943455F5354594C4553203D207B0A202027706F736974696F6E273A20276162736F6C';
wwv_flow_imp.g_varchar2_table(2631) := '757465272C0A2020276C656674273A2027353025272C0A202027746F70273A2027343025272C0A2020277472616E73666F726D273A20277472616E736C617465282D35302529272C0A2020277769647468273A20273236307078272C0A20202770616464';
wwv_flow_imp.g_varchar2_table(2632) := '696E67273A202731307078272C0A2020276261636B67726F756E64273A20277768697465272C0A202027626F78536861646F77273A2027302031707820347078207267626128302C302C302C302E3329272C0A202027666F6E7446616D696C79273A2027';
wwv_flow_imp.g_varchar2_table(2633) := '48656C7665746963612C20417269616C2C2073616E732D7365726966272C0A202027666F6E7453697A65273A202731347078272C0A202027646973706C6179273A2027666C6578272C0A2020276C696E65486569676874273A2027312E33270A7D3B0A0A';
wwv_flow_imp.g_varchar2_table(2634) := '766172204C49474854424F585F4D41524B5550203D0A2020273C64697620636C6173733D22626A732D706F77657265642D62792D6C69676874626F78223E27202B0A20202020273C64697620636C6173733D226261636B64726F70223E3C2F6469763E27';
wwv_flow_imp.g_varchar2_table(2635) := '202B0A20202020273C64697620636C6173733D226E6F74696365223E27202B0A202020202020273C6120687265663D2268747470733A2F2F62706D6E2E696F22207461726765743D225F626C616E6B222072656C3D226E6F6F70656E65722220636C6173';
wwv_flow_imp.g_varchar2_table(2636) := '733D226C696E6B223E27202B0A202020202020202042504D4E494F5F494D47202B0A202020202020273C2F613E27202B0A202020202020273C7370616E3E27202B0A2020202020202020275765622D626173656420746F6F6C696E6720666F722042504D';
wwv_flow_imp.g_varchar2_table(2637) := '4E2C20444D4E20616E6420666F726D732027202B0A202020202020202027706F7765726564206279203C6120687265663D2268747470733A2F2F62706D6E2E696F22207461726765743D225F626C616E6B222072656C3D226E6F6F70656E6572223E6270';
wwv_flow_imp.g_varchar2_table(2638) := '6D6E2E696F3C2F613E2E27202B0A202020202020273C2F7370616E3E27202B0A20202020273C2F6469763E27202B0A2020273C2F6469763E273B0A0A0A766172206C69676874626F783B0A0A66756E6374696F6E206372656174654C69676874626F7828';
wwv_flow_imp.g_varchar2_table(2639) := '29207B0A20206C69676874626F78203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D69667929284C49474854424F585F4D41524B5550293B0A0A202028302C6D696E5F646F6D5F5F5745';
wwv_flow_imp.g_varchar2_table(2640) := '425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E5374796C6529286C69676874626F782C204C49474854424F585F5354594C4553293B0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(2641) := '44554C455F305F5F2E61737369676E5374796C65292828302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E7175657279292827737667272C206C69676874626F78292C204C4F474F5F5354594C4553293B';
wwv_flow_imp.g_varchar2_table(2642) := '0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E5374796C65292828302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E71756572';
wwv_flow_imp.g_varchar2_table(2643) := '792928272E6261636B64726F70272C206C69676874626F78292C204241434B44524F505F5354594C4553293B0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E5374796C652928';
wwv_flow_imp.g_varchar2_table(2644) := '28302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E71756572792928272E6E6F74696365272C206C69676874626F78292C204E4F544943455F5354594C4553293B0A202028302C6D696E5F646F6D5F5F57';
wwv_flow_imp.g_varchar2_table(2645) := '45425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E5374796C65292828302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E71756572792928272E6C696E6B272C206C696768';
wwv_flow_imp.g_varchar2_table(2646) := '74626F78292C204C494E4B5F5354594C45532C207B0A20202020276D617267696E273A202731357078203230707820313570782031307078272C0A2020202027616C69676E53656C66273A202763656E746572270A20207D293B0A7D0A0A66756E637469';
wwv_flow_imp.g_varchar2_table(2647) := '6F6E206F70656E2829207B0A0A202069662028216C69676874626F7829207B0A202020206372656174654C69676874626F7828293B0A0A202020206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E64656C65';
wwv_flow_imp.g_varchar2_table(2648) := '676174652E62696E64286C69676874626F782C20272E6261636B64726F70272C2027636C69636B272C2066756E6374696F6E286576656E7429207B0A202020202020646F63756D656E742E626F64792E72656D6F76654368696C64286C69676874626F78';
wwv_flow_imp.g_varchar2_table(2649) := '293B0A202020207D293B0A20207D0A0A2020646F63756D656E742E626F64792E617070656E644368696C64286C69676874626F78293B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D';
wwv_flow_imp.g_varchar2_table(2650) := '6A732F6C69622F4469616772616D2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F646961';
wwv_flow_imp.g_varchar2_table(2651) := '6772616D2D6A732F6C69622F4469616772616D2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765';
wwv_flow_imp.g_varchar2_table(2652) := '627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274';
wwv_flow_imp.g_varchar2_table(2653) := '735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661';
wwv_flow_imp.g_varchar2_table(2654) := '756C74223A202829203D3E20282F2A2062696E64696E67202A2F204469616772616D290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076617220646964695F5F5745425041434B5F';
wwv_flow_imp.g_varchar2_table(2655) := '494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212064696469202A2F20222E2F6E6F64655F6D6F64756C65732F646964692F646973742F696E6465782E6A7322293B0A2F2A206861726D6F';
wwv_flow_imp.g_varchar2_table(2656) := '6E7920696D706F7274202A2F20766172205F636F72655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F636F7265202A2F20222E2F6E6F64655F6D6F6475';
wwv_flow_imp.g_varchar2_table(2657) := '6C65732F6469616772616D2D6A732F6C69622F636F72652F696E6465782E6A7322293B0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428276469646927292E496E6A656374696F6E436F6E746578747D20496E6A656374696F6E43';
wwv_flow_imp.g_varchar2_table(2658) := '6F6E746578740A202A204074797065646566207B696D706F727428276469646927292E4C6F63616C734D61707D204C6F63616C734D61700A202A204074797065646566207B696D706F727428276469646927292E4D6F64756C654465636C61726174696F';
wwv_flow_imp.g_varchar2_table(2659) := '6E7D204D6F64756C654465636C61726174696F6E0A202A0A202A204074797065646566207B207B0A202A2020206D6F64756C65733F3A204D6F64756C654465636C61726174696F6E5B5D3B0A202A207D2026205265636F72643C737472696E672C20616E';
wwv_flow_imp.g_varchar2_table(2660) := '793E207D204469616772616D4F7074696F6E730A202A2F0A0A2F2A2A0A202A204074656D706C61746520540A202A204074797065646566207B696D706F727428276469646927292E466163746F727946756E6374696F6E3C543E7D20466163746F727946';
wwv_flow_imp.g_varchar2_table(2661) := '756E6374696F6E0A202A2F0A0A2F2A2A0A202A204074656D706C61746520540A202A204074797065646566207B696D706F727428276469646927292E417272617946756E633C543E7D20417272617946756E630A202A2F0A0A2F2A2A0A202A20426F6F74';
wwv_flow_imp.g_varchar2_table(2662) := '737472617020616E20696E6A6563746F722066726F6D2061206C697374206F66206D6F64756C65732C20696E7374616E74696174696E672061206E756D626572206F662064656661756C7420636F6D706F6E656E74730A202A0A202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(2663) := '7B4D6F64756C654465636C61726174696F6E5B5D7D206D6F64756C65730A202A0A202A204072657475726E207B496E6A6563746F727D206120696E6A6563746F7220746F2075736520746F206163636573732074686520636F6D706F6E656E74730A202A';
wwv_flow_imp.g_varchar2_table(2664) := '2F0A66756E6374696F6E20626F6F747374726170286D6F64756C657329207B0A202076617220696E6A6563746F72203D206E657720646964695F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E496E6A6563746F72286D6F6475';
wwv_flow_imp.g_varchar2_table(2665) := '6C6573293B0A0A2020696E6A6563746F722E696E697428293B0A0A202072657475726E20696E6A6563746F723B0A7D0A0A2F2A2A0A202A204372656174657320616E20696E6A6563746F722066726F6D20706173736564206F7074696F6E732E0A202A0A';
wwv_flow_imp.g_varchar2_table(2666) := '202A204074656D706C61746520536572766963654D61700A202A2040706172616D207B4469616772616D4F7074696F6E737D205B6F7074696F6E735D0A202A0A202A204072657475726E207B496E6A6563746F723C536572766963654D61703E7D0A202A';
wwv_flow_imp.g_varchar2_table(2667) := '2F0A66756E6374696F6E20637265617465496E6A6563746F72286F7074696F6E7329207B0A0A20206F7074696F6E73203D206F7074696F6E73207C7C207B7D3B0A0A20202F2A2A0A2020202A204074797065207B204D6F64756C654465636C6172617469';
wwv_flow_imp.g_varchar2_table(2668) := '6F6E207D0A2020202A2F0A202076617220636F6E6669674D6F64756C65203D207B0A2020202027636F6E666967273A205B202776616C7565272C206F7074696F6E73205D0A20207D3B0A0A2020766172206D6F64756C6573203D205B20636F6E6669674D';
wwv_flow_imp.g_varchar2_table(2669) := '6F64756C652C205F636F72655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D205D2E636F6E636174286F7074696F6E732E6D6F64756C6573207C7C205B5D293B0A0A202072657475726E20626F6F74';
wwv_flow_imp.g_varchar2_table(2670) := '7374726170286D6F64756C6573293B0A7D0A0A0A2F2A2A0A202A20546865206D61696E206469616772616D2D6A7320656E74727920706F696E74207468617420626F6F7473747261707320746865206469616772616D2077697468207468652067697665';
wwv_flow_imp.g_varchar2_table(2671) := '6E0A202A20636F6E66696775726174696F6E2E0A202A0A202A20546F20726567697374657220657874656E73696F6E73207769746820746865206469616772616D2C2070617373207468656D2061732041727261793C4D6F64756C653E20746F20746865';
wwv_flow_imp.g_varchar2_table(2672) := '20636F6E7374727563746F722E0A202A0A202A2040636C6173730A202A2040636F6E7374727563746F720A202A204074656D706C617465205B536572766963654D61703D6E756C6C5D0A202A0A202A20406578616D706C65204372656174696E67206120';
wwv_flow_imp.g_varchar2_table(2673) := '706C75672D696E2074686174206C6F6773207768656E65766572206120736861706520697320616464656420746F207468652063616E7661732E0A202A0A202A206060606A6176617363726970740A202A202F2F20706C75672D696E20696D706C656D65';
wwv_flow_imp.g_varchar2_table(2674) := '6E746174696F6E0A202A2066756E6374696F6E204D794C6F6767696E67506C7567696E286576656E7442757329207B0A202A2020206576656E744275732E6F6E282773686170652E6164646564272C2066756E6374696F6E286576656E7429207B0A202A';
wwv_flow_imp.g_varchar2_table(2675) := '2020202020636F6E736F6C652E6C6F672827736861706520272C206576656E742E73686170652C20272077617320616464656420746F20746865206469616772616D27293B0A202A2020207D293B0A202A207D0A202A0A202A202F2F206578706F727420';
wwv_flow_imp.g_varchar2_table(2676) := '6173206D6F64756C650A202A206578706F72742064656661756C74207B0A202A2020205F5F696E69745F5F3A205B20276D794C6F6767696E67506C7567696E27205D2C0A202A20202020206D794C6F6767696E67506C7567696E3A205B20277479706527';
wwv_flow_imp.g_varchar2_table(2677) := '2C204D794C6F6767696E67506C7567696E205D0A202A207D3B0A202A206060600A202A0A202A205573652074686520706C75672D696E20696E2061204469616772616D20696E7374616E63653A0A202A0A202A206060606A6176617363726970740A202A';
wwv_flow_imp.g_varchar2_table(2678) := '20696D706F7274204D794C6F6767696E674D6F64756C652066726F6D2027706174682D746F2D6D792D6C6F6767696E672D706C7567696E273B0A202A0A202A20766172206469616772616D203D206E6577204469616772616D287B0A202A2020206D6F64';
wwv_flow_imp.g_varchar2_table(2679) := '756C65733A205B0A202A20202020204D794C6F6767696E674D6F64756C650A202A2020205D0A202A207D293B0A202A0A202A206469616772616D2E696E766F6B65285B202763616E766173272C2066756E6374696F6E2863616E76617329207B0A202A20';
wwv_flow_imp.g_varchar2_table(2680) := '20202F2F2061646420736861706520746F2064726177696E672063616E7661730A202A20202063616E7661732E6164645368617065287B20783A2031302C20793A203130207D293B0A202A207D293B0A202A0A202A202F2F20277368617065202E2E2E20';
wwv_flow_imp.g_varchar2_table(2681) := '77617320616464656420746F20746865206469616772616D27206C6F6767656420746F20636F6E736F6C650A202A206060600A202A0A202A2040706172616D207B4469616772616D4F7074696F6E737D205B6F7074696F6E735D0A202A2040706172616D';
wwv_flow_imp.g_varchar2_table(2682) := '207B496E6A6563746F723C536572766963654D61703E7D205B696E6A6563746F725D20416E20286F7074696F6E616C2920696E6A6563746F7220746F20626F6F74737472617020746865206469616772616D20776974682E0A202A2F0A66756E6374696F';
wwv_flow_imp.g_varchar2_table(2683) := '6E204469616772616D286F7074696F6E732C20696E6A6563746F7229207B0A0A20202F2A2A0A2020202A204074797065207B496E6A6563746F723C536572766963654D61703E7D0A2020202A2F0A2020746869732E5F696E6A6563746F72203D20696E6A';
wwv_flow_imp.g_varchar2_table(2684) := '6563746F72207C7C20637265617465496E6A6563746F72286F7074696F6E73293B0A0A20202F2F20696E69740A0A20202F2A2A0A2020202A20416E206576656E7420696E6469636174696E67207468617420616C6C20706C75672D696E7320617265206C';
wwv_flow_imp.g_varchar2_table(2685) := '6F616465642E0A2020202A0A2020202A205573652074686973206576656E7420746F2066697265206F74686572206576656E747320746F20696E746572657374656420706C75672D696E730A2020202A0A2020202A20406D656D6265724F662044696167';
wwv_flow_imp.g_varchar2_table(2686) := '72616D0A2020202A0A2020202A20406576656E74206469616772616D2E696E69740A2020202A0A2020202A20406578616D706C650A2020202A0A2020202A206060606A6176617363726970740A2020202A206576656E744275732E6F6E28276469616772';
wwv_flow_imp.g_varchar2_table(2687) := '616D2E696E6974272C2066756E6374696F6E2829207B0A2020202A2020206576656E744275732E6669726528276D792D637573746F6D2D6576656E74272C207B20666F6F3A202742415227207D293B0A2020202A207D293B0A2020202A206060600A2020';
wwv_flow_imp.g_varchar2_table(2688) := '202A0A2020202A204074797065207B4F626A6563747D0A2020202A2F0A2020746869732E67657428276576656E7442757327292E6669726528276469616772616D2E696E697427293B0A7D0A0A2F2A2A0A202A20406F7665726C6F72640A202A0A202A20';
wwv_flow_imp.g_varchar2_table(2689) := '5265736F6C7665732061206469616772616D20736572766963652E0A202A0A202A204074656D706C61746520540A202A0A202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865207365727669636520746F20';
wwv_flow_imp.g_varchar2_table(2690) := '6765742E0A202A0A202A204072657475726E207B547D0A202A2F0A2F2A2A0A202A20406F7665726C6F72640A202A0A202A205265736F6C7665732061206469616772616D20736572766963652E0A202A0A202A204074656D706C61746520540A202A0A20';
wwv_flow_imp.g_varchar2_table(2691) := '2A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865207365727669636520746F206765742E0A202A2040706172616D207B747275657D207374726963742049662066616C73652C207265736F6C7665206D6973';
wwv_flow_imp.g_varchar2_table(2692) := '73696E6720736572766963657320746F206E756C6C2E0A202A0A202A204072657475726E207B547D0A202A2F0A2F2A2A0A202A20406F7665726C6F72640A202A0A202A205265736F6C7665732061206469616772616D20736572766963652E0A202A0A20';
wwv_flow_imp.g_varchar2_table(2693) := '2A204074656D706C61746520540A202A0A202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865207365727669636520746F206765742E0A202A2040706172616D207B626F6F6C65616E7D2073747269637420';
wwv_flow_imp.g_varchar2_table(2694) := '49662066616C73652C207265736F6C7665206D697373696E6720736572766963657320746F206E756C6C2E0A202A0A202A204072657475726E207B547C6E756C6C7D0A202A2F0A2F2A2A0A202A205265736F6C7665732061206469616772616D20736572';
wwv_flow_imp.g_varchar2_table(2695) := '766963652E0A202A0A202A204074656D706C617465207B6B65796F6620536572766963654D61707D204E616D650A202A0A202A2040706172616D207B4E616D657D206E616D6520546865206E616D65206F6620746865207365727669636520746F206765';
wwv_flow_imp.g_varchar2_table(2696) := '742E0A202A0A202A204072657475726E207B536572766963654D61705B4E616D655D7D0A202A2F0A4469616772616D2E70726F746F747970652E676574203D2066756E6374696F6E286E616D652C2073747269637429207B0A202072657475726E207468';
wwv_flow_imp.g_varchar2_table(2697) := '69732E5F696E6A6563746F722E676574286E616D652C20737472696374293B0A7D3B0A0A2F2A2A0A202A20406F7665726C6F72640A202A0A202A20496E766F6B652074686520676976656E2066756E6374696F6E2C20696E6A656374696E672064657065';
wwv_flow_imp.g_varchar2_table(2698) := '6E64656E636965732E2052657475726E2074686520726573756C742E0A202A0A202A204074656D706C61746520540A202A0A202A2040706172616D207B466163746F727946756E6374696F6E3C543E7D2066756E630A202A2040706172616D207B496E6A';
wwv_flow_imp.g_varchar2_table(2699) := '656374696F6E436F6E746578747D205B636F6E746578745D0A202A2040706172616D207B4C6F63616C734D61707D205B6C6F63616C735D0A202A0A202A204072657475726E207B547D0A202A2F0A2F2A2A0A202A20496E766F6B65207468652067697665';
wwv_flow_imp.g_varchar2_table(2700) := '6E2066756E6374696F6E2C20696E6A656374696E6720646570656E64656E636965732070726F766964656420696E0A202A206172726179206E6F746174696F6E2E2052657475726E2074686520726573756C742E0A202A0A202A204074656D706C617465';
wwv_flow_imp.g_varchar2_table(2701) := '20540A202A0A202A2040706172616D207B417272617946756E633C543E7D2066756E632066756E6374696F6E20746F20626520696E766F6B65640A202A2040706172616D207B496E6A656374696F6E436F6E746578747D205B636F6E746578745D20636F';
wwv_flow_imp.g_varchar2_table(2702) := '6E74657874206F662074686520696E766F636174696F6E0A202A2040706172616D207B4C6F63616C734D61707D205B6C6F63616C735D206C6F63616C732070726F76696465640A202A0A202A204072657475726E207B547D0A202A2F0A4469616772616D';
wwv_flow_imp.g_varchar2_table(2703) := '2E70726F746F747970652E696E766F6B65203D2066756E6374696F6E2866756E632C20636F6E746578742C206C6F63616C7329207B0A202072657475726E20746869732E5F696E6A6563746F722E696E766F6B652866756E632C20636F6E746578742C20';
wwv_flow_imp.g_varchar2_table(2704) := '6C6F63616C73293B0A7D3B0A0A2F2A2A0A202A2044657374726F797320746865206469616772616D0A202A2F0A4469616772616D2E70726F746F747970652E64657374726F79203D2066756E6374696F6E2829207B0A2020746869732E67657428276576';
wwv_flow_imp.g_varchar2_table(2705) := '656E7442757327292E6669726528276469616772616D2E64657374726F7927293B0A7D3B0A0A2F2A2A0A202A20436C65617220746865206469616772616D2C2072656D6F76696E6720616C6C20636F6E74656E74732E0A202A2F0A4469616772616D2E70';
wwv_flow_imp.g_varchar2_table(2706) := '726F746F747970652E636C656172203D2066756E6374696F6E2829207B0A2020746869732E67657428276576656E7442757327292E6669726528276469616772616D2E636C65617227293B0A7D3B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E';
wwv_flow_imp.g_varchar2_table(2707) := '2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F6D6D616E642F436F6D6D616E64496E746572636570746F722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(2708) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F6D6D616E642F436F6D6D616E64496E746572636570746F722E6A';
wwv_flow_imp.g_varchar2_table(2709) := '73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F77656270';
wwv_flow_imp.g_varchar2_table(2710) := '61636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F';
wwv_flow_imp.g_varchar2_table(2711) := '5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C';
wwv_flow_imp.g_varchar2_table(2712) := '74223A202829203D3E20282F2A2062696E64696E67202A2F20436F6D6D616E64496E746572636570746F72290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F64';
wwv_flow_imp.g_varchar2_table(2713) := '6173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F64697374';
wwv_flow_imp.g_varchar2_table(2714) := '2F696E6465782E65736D2E6A7322293B0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F636F72652F547970657327292E456C656D656E744C696B657D20456C656D656E744C696B650A202A204074797065646566207B696D';
wwv_flow_imp.g_varchar2_table(2715) := '706F727428272E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A204074797065646566207B696D706F727428272E2F436F6D6D616E64537461636B27292E436F6D6D616E64436F6E746578747D20436F6D';
wwv_flow_imp.g_varchar2_table(2716) := '6D616E64436F6E746578740A202A0A202A204074797065646566207B737472696E677C737472696E675B5D7D204576656E74730A202A204074797065646566207B2028636F6E746578743A20436F6D6D616E64436F6E7465787429203D3E20456C656D65';
wwv_flow_imp.g_varchar2_table(2717) := '6E744C696B655B5D207C20766F6964207D2048616E646C657246756E6374696F6E0A202A204074797065646566207B2028636F6E746578743A20436F6D6D616E64436F6E7465787429203D3E20766F6964207D20436F6D706F736548616E646C65724675';
wwv_flow_imp.g_varchar2_table(2718) := '6E6374696F6E0A202A2F0A0A7661722044454641554C545F5052494F52495459203D20313030303B0A0A2F2A2A0A202A2041207574696C69747920746861742063616E206265207573656420746F20706C756720696E746F2074686520636F6D6D616E64';
wwv_flow_imp.g_varchar2_table(2719) := '20657865637574696F6E20666F720A202A20657874656E73696F6E20616E642F6F722076616C69646174696F6E2E0A202A0A202A2040636C6173730A202A2040636F6E7374727563746F720A202A0A202A20406578616D706C650A202A0A202A20606060';
wwv_flow_imp.g_varchar2_table(2720) := '6A6176617363726970740A202A20696D706F727420436F6D6D616E64496E746572636570746F722066726F6D20276469616772616D2D6A732F6C69622F636F6D6D616E642F436F6D6D616E64496E746572636570746F72273B0A202A0A202A20636C6173';
wwv_flow_imp.g_varchar2_table(2721) := '7320436F6D6D616E644C6F6767657220657874656E647320436F6D6D616E64496E746572636570746F72207B0A202A202020636F6E7374727563746F72286576656E7442757329207B0A202A20202020207375706572286576656E74427573293B0A202A';
wwv_flow_imp.g_varchar2_table(2722) := '0A202A202020746869732E70726545786563757465282773686170652E637265617465272C20286576656E7429203D3E207B0A202A2020202020636F6E736F6C652E6C6F672827636F6D6D616E64537461636B2E73686170652D6372656174652E707265';
wwv_flow_imp.g_varchar2_table(2723) := '45786563757465272C206576656E74293B0A202A2020207D293B0A202A207D0A202A206060600A202A0A202A2040706172616D207B4576656E744275737D206576656E744275730A202A2F0A66756E6374696F6E20436F6D6D616E64496E746572636570';
wwv_flow_imp.g_varchar2_table(2724) := '746F72286576656E7442757329207B0A0A20202F2A2A0A2020202A204074797065207B4576656E744275737D0A2020202A2F0A2020746869732E5F6576656E74427573203D206576656E744275733B0A7D0A0A436F6D6D616E64496E746572636570746F';
wwv_flow_imp.g_varchar2_table(2725) := '722E24696E6A656374203D205B20276576656E7442757327205D3B0A0A66756E6374696F6E20756E777261704576656E7428666E2C207468617429207B0A202072657475726E2066756E6374696F6E286576656E7429207B0A2020202072657475726E20';
wwv_flow_imp.g_varchar2_table(2726) := '666E2E63616C6C2874686174207C7C206E756C6C2C206576656E742E636F6E746578742C206576656E742E636F6D6D616E642C206576656E74293B0A20207D3B0A7D0A0A0A2F2A2A0A202A20496E74657263657074206120636F6D6D616E642064757269';
wwv_flow_imp.g_varchar2_table(2727) := '6E67206F6E65206F6620746865207068617365732E0A202A0A202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570740A202A2040706172616D207B737472696E677D205B686F6F';
wwv_flow_imp.g_varchar2_table(2728) := '6B5D20706861736520746F20696E746572636570740A202A2040706172616D207B6E756D6265727D205B7072696F726974795D0A202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F';
wwv_flow_imp.g_varchar2_table(2729) := '6E7D2068616E646C6572466E0A202A2040706172616D207B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065640A202A2040706172616D207B616E797D205B746861';
wwv_flow_imp.g_varchar2_table(2730) := '745D0A202A2F0A436F6D6D616E64496E746572636570746F722E70726F746F747970652E6F6E203D2066756E6374696F6E286576656E74732C20686F6F6B2C207072696F726974792C2068616E646C6572466E2C20756E777261702C207468617429207B';
wwv_flow_imp.g_varchar2_table(2731) := '0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E697346756E6374696F6E2928686F6F6B29207C7C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(2732) := '4D4F44554C455F305F5F2E69734E756D6265722928686F6F6B2929207B0A2020202074686174203D20756E777261703B0A20202020756E77726170203D2068616E646C6572466E3B0A2020202068616E646C6572466E203D207072696F726974793B0A20';
wwv_flow_imp.g_varchar2_table(2733) := '2020207072696F72697479203D20686F6F6B3B0A20202020686F6F6B203D206E756C6C3B0A20207D0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E697346756E6374696F6E29';
wwv_flow_imp.g_varchar2_table(2734) := '287072696F726974792929207B0A2020202074686174203D20756E777261703B0A20202020756E77726170203D2068616E646C6572466E3B0A2020202068616E646C6572466E203D207072696F726974793B0A202020207072696F72697479203D204445';
wwv_flow_imp.g_varchar2_table(2735) := '4641554C545F5052494F524954593B0A20207D0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734F626A6563742928756E777261702929207B0A2020202074686174203D20';
wwv_flow_imp.g_varchar2_table(2736) := '756E777261703B0A20202020756E77726170203D2066616C73653B0A20207D0A0A2020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E697346756E6374696F6E292868616E646C6572';
wwv_flow_imp.g_varchar2_table(2737) := '466E2929207B0A202020207468726F77206E6577204572726F72282768616E646C6572466E206D75737420626520612066756E6374696F6E27293B0A20207D0A0A2020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(2738) := '445F4D4F44554C455F305F5F2E6973417272617929286576656E74732929207B0A202020206576656E7473203D205B206576656E7473205D3B0A20207D0A0A2020766172206576656E74427573203D20746869732E5F6576656E744275733B0A0A202028';
wwv_flow_imp.g_varchar2_table(2739) := '302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F724561636829286576656E74732C2066756E6374696F6E286576656E7429207B0A0A202020202F2F20636F6E63617420636F6D6D616E64537461';
wwv_flow_imp.g_varchar2_table(2740) := '636B282E6576656E74293F282E686F6F6B293F0A202020207661722066756C6C4576656E74203D205B2027636F6D6D616E64537461636B272C206576656E742C20686F6F6B205D2E66696C7465722866756E6374696F6E286529207B2072657475726E20';
wwv_flow_imp.g_varchar2_table(2741) := '653B207D292E6A6F696E28272E27293B0A0A202020206576656E744275732E6F6E2866756C6C4576656E742C207072696F726974792C20756E77726170203F20756E777261704576656E742868616E646C6572466E2C207468617429203A2068616E646C';
wwv_flow_imp.g_varchar2_table(2742) := '6572466E2C2074686174293B0A20207D293B0A7D3B0A0A2F2A2A0A202A204164642061203C63616E457865637574653E207068617365206F6620636F6D6D616E6420696E746572636570746F722E0A202A0A202A2040706172616D207B4576656E74737D';
wwv_flow_imp.g_varchar2_table(2743) := '205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570740A202A2040706172616D207B6E756D6265727D205B7072696F726974795D0A202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C4861';
wwv_flow_imp.g_varchar2_table(2744) := '6E646C657246756E6374696F6E7D2068616E646C6572466E0A202A2040706172616D207B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065640A202A204070617261';
wwv_flow_imp.g_varchar2_table(2745) := '6D207B616E797D205B746861745D0A202A2F0A436F6D6D616E64496E746572636570746F722E70726F746F747970652E63616E45786563757465203D20637265617465486F6F6B282763616E4578656375746527293B0A0A2F2A2A0A202A204164642061';
wwv_flow_imp.g_varchar2_table(2746) := '203C707265457865637574653E207068617365206F6620636F6D6D616E6420696E746572636570746F722E0A202A0A202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570740A20';
wwv_flow_imp.g_varchar2_table(2747) := '2A2040706172616D207B6E756D6265727D205B7072696F726974795D0A202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E0A202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(2748) := '7B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065640A202A2040706172616D207B616E797D205B746861745D0A202A2F0A436F6D6D616E64496E74657263657074';
wwv_flow_imp.g_varchar2_table(2749) := '6F722E70726F746F747970652E70726545786563757465203D20637265617465486F6F6B28277072654578656375746527293B0A0A2F2A2A0A202A204164642061203C70726545786563757465643E207068617365206F6620636F6D6D616E6420696E74';
wwv_flow_imp.g_varchar2_table(2750) := '6572636570746F722E0A202A0A202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570740A202A2040706172616D207B6E756D6265727D205B7072696F726974795D0A202A204070';
wwv_flow_imp.g_varchar2_table(2751) := '6172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E0A202A2040706172616D207B626F6F6C65616E7D205B756E777261705D20776865746865722074686520657665';
wwv_flow_imp.g_varchar2_table(2752) := '6E742073686F756C6420626520756E777261707065640A202A2040706172616D207B616E797D205B746861745D0A202A2F0A436F6D6D616E64496E746572636570746F722E70726F746F747970652E7072654578656375746564203D2063726561746548';
wwv_flow_imp.g_varchar2_table(2753) := '6F6F6B2827707265457865637574656427293B0A0A2F2A2A0A202A204164642061203C657865637574653E207068617365206F6620636F6D6D616E6420696E746572636570746F722E0A202A0A202A2040706172616D207B4576656E74737D205B657665';
wwv_flow_imp.g_varchar2_table(2754) := '6E74735D20636F6D6D616E6428732920746F20696E746572636570740A202A2040706172616D207B6E756D6265727D205B7072696F726974795D0A202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C6572';
wwv_flow_imp.g_varchar2_table(2755) := '46756E6374696F6E7D2068616E646C6572466E0A202A2040706172616D207B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065640A202A2040706172616D207B616E';
wwv_flow_imp.g_varchar2_table(2756) := '797D205B746861745D0A202A2F0A436F6D6D616E64496E746572636570746F722E70726F746F747970652E65786563757465203D20637265617465486F6F6B28276578656375746527293B0A0A2F2A2A0A202A204164642061203C65786563757465643E';
wwv_flow_imp.g_varchar2_table(2757) := '207068617365206F6620636F6D6D616E6420696E746572636570746F722E0A202A0A202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570740A202A2040706172616D207B6E756D';
wwv_flow_imp.g_varchar2_table(2758) := '6265727D205B7072696F726974795D0A202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E0A202A2040706172616D207B626F6F6C65616E7D205B756E';
wwv_flow_imp.g_varchar2_table(2759) := '777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065640A202A2040706172616D207B616E797D205B746861745D0A202A2F0A436F6D6D616E64496E746572636570746F722E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(2760) := '6578656375746564203D20637265617465486F6F6B2827657865637574656427293B0A0A2F2A2A0A202A204164642061203C706F7374457865637574653E207068617365206F6620636F6D6D616E6420696E746572636570746F722E0A202A0A202A2040';
wwv_flow_imp.g_varchar2_table(2761) := '706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570740A202A2040706172616D207B6E756D6265727D205B7072696F726974795D0A202A2040706172616D207B436F6D706F736548616E64';
wwv_flow_imp.g_varchar2_table(2762) := '6C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E0A202A2040706172616D207B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E7772';
wwv_flow_imp.g_varchar2_table(2763) := '61707065640A202A2040706172616D207B616E797D205B746861745D0A202A2F0A436F6D6D616E64496E746572636570746F722E70726F746F747970652E706F737445786563757465203D20637265617465486F6F6B2827706F73744578656375746527';
wwv_flow_imp.g_varchar2_table(2764) := '293B0A0A2F2A2A0A202A204164642061203C706F737445786563757465643E207068617365206F6620636F6D6D616E6420696E746572636570746F722E0A202A0A202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E64';
wwv_flow_imp.g_varchar2_table(2765) := '28732920746F20696E746572636570740A202A2040706172616D207B6E756D6265727D205B7072696F726974795D0A202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D206861';
wwv_flow_imp.g_varchar2_table(2766) := '6E646C6572466E0A202A2040706172616D207B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065640A202A2040706172616D207B616E797D205B746861745D0A202A';
wwv_flow_imp.g_varchar2_table(2767) := '2F0A436F6D6D616E64496E746572636570746F722E70726F746F747970652E706F73744578656375746564203D20637265617465486F6F6B2827706F7374457865637574656427293B0A0A2F2A2A0A202A204164642061203C7265766572743E20706861';
wwv_flow_imp.g_varchar2_table(2768) := '7365206F6620636F6D6D616E6420696E746572636570746F722E0A202A0A202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570740A202A2040706172616D207B6E756D6265727D';
wwv_flow_imp.g_varchar2_table(2769) := '205B7072696F726974795D0A202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E0A202A2040706172616D207B626F6F6C65616E7D205B756E77726170';
wwv_flow_imp.g_varchar2_table(2770) := '5D207768657468657220746865206576656E742073686F756C6420626520756E777261707065640A202A2040706172616D207B616E797D205B746861745D0A202A2F0A436F6D6D616E64496E746572636570746F722E70726F746F747970652E72657665';
wwv_flow_imp.g_varchar2_table(2771) := '7274203D20637265617465486F6F6B282772657665727427293B0A0A2F2A2A0A202A204164642061203C72657665727465643E207068617365206F6620636F6D6D616E6420696E746572636570746F722E0A202A0A202A2040706172616D207B4576656E';
wwv_flow_imp.g_varchar2_table(2772) := '74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570740A202A2040706172616D207B6E756D6265727D205B7072696F726974795D0A202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E';
wwv_flow_imp.g_varchar2_table(2773) := '7C48616E646C657246756E6374696F6E7D2068616E646C6572466E0A202A2040706172616D207B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065640A202A204070';
wwv_flow_imp.g_varchar2_table(2774) := '6172616D207B616E797D205B746861745D0A202A2F0A436F6D6D616E64496E746572636570746F722E70726F746F747970652E7265766572746564203D20637265617465486F6F6B2827726576657274656427293B0A0A2F2A0A202A204164642070726F';
wwv_flow_imp.g_varchar2_table(2775) := '746F74797065206D6574686F647320666F722065616368207068617365206F6620636F6D6D616E6420657865637574696F6E2028652E672E20657865637574652C0A202A20726576657274292E0A202A0A202A2040706172616D207B737472696E677D20';
wwv_flow_imp.g_varchar2_table(2776) := '686F6F6B0A202A0A202A204072657475726E207B20280A202A2020206576656E74733F3A204576656E74732C0A202A2020207072696F726974793F3A206E756D6265722C0A202A20202068616E646C6572466E3A20436F6D706F736548616E646C657246';
wwv_flow_imp.g_varchar2_table(2777) := '756E6374696F6E7C48616E646C657246756E6374696F6E2C0A202A202020756E777261703F3A20626F6F6C65616E0A202A2029203D3E20616E79207D0A202A2F0A66756E6374696F6E20637265617465486F6F6B28686F6F6B29207B0A0A20202F2A2A0A';
wwv_flow_imp.g_varchar2_table(2778) := '2020202A204074686973207B436F6D6D616E64496E746572636570746F727D0A2020202A0A2020202A2040706172616D207B4576656E74737D205B6576656E74735D0A2020202A2040706172616D207B6E756D6265727D205B7072696F726974795D0A20';
wwv_flow_imp.g_varchar2_table(2779) := '20202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E0A2020202A2040706172616D207B626F6F6C65616E7D205B756E777261705D0A2020202A204070';
wwv_flow_imp.g_varchar2_table(2780) := '6172616D207B616E797D205B746861745D0A2020202A2F0A2020636F6E737420686F6F6B466E203D2066756E6374696F6E286576656E74732C207072696F726974792C2068616E646C6572466E2C20756E777261702C207468617429207B0A0A20202020';
wwv_flow_imp.g_varchar2_table(2781) := '6966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E697346756E6374696F6E29286576656E747329207C7C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(2782) := '44554C455F305F5F2E69734E756D62657229286576656E74732929207B0A20202020202074686174203D20756E777261703B0A202020202020756E77726170203D2068616E646C6572466E3B0A20202020202068616E646C6572466E203D207072696F72';
wwv_flow_imp.g_varchar2_table(2783) := '6974793B0A2020202020207072696F72697479203D206576656E74733B0A2020202020206576656E7473203D206E756C6C3B0A202020207D0A0A20202020746869732E6F6E286576656E74732C20686F6F6B2C207072696F726974792C2068616E646C65';
wwv_flow_imp.g_varchar2_table(2784) := '72466E2C20756E777261702C2074686174293B0A20207D3B0A0A202072657475726E20686F6F6B466E3B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F';
wwv_flow_imp.g_varchar2_table(2785) := '43616E7661732E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D';
wwv_flow_imp.g_varchar2_table(2786) := '2D6A732F6C69622F636F72652F43616E7661732E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365';
wwv_flow_imp.g_varchar2_table(2787) := '645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578';
wwv_flow_imp.g_varchar2_table(2788) := '706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F20202022';
wwv_flow_imp.g_varchar2_table(2789) := '64656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F2043616E766173290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F57';
wwv_flow_imp.g_varchar2_table(2790) := '45425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E646578';
wwv_flow_imp.g_varchar2_table(2791) := '2E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D';
wwv_flow_imp.g_varchar2_table(2792) := '696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F436F6C6C656374696F6E735F5F57';
wwv_flow_imp.g_varchar2_table(2793) := '45425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F436F6C6C656374696F6E73202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D';
wwv_flow_imp.g_varchar2_table(2794) := '6A732F6C69622F7574696C2F436F6C6C656374696F6E732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F456C656D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D';
wwv_flow_imp.g_varchar2_table(2795) := '205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F456C656D656E7473202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F456C656D656E74732E6A7322293B0A2F2A2068';
wwv_flow_imp.g_varchar2_table(2796) := '61726D6F6E7920696D706F7274202A2F20766172205F6C61796F75745F4C61796F75745574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F6C61';
wwv_flow_imp.g_varchar2_table(2797) := '796F75742F4C61796F75745574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6C61796F75742F4C61796F75745574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722074';
wwv_flow_imp.g_varchar2_table(2798) := '696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D7376672F';
wwv_flow_imp.g_varchar2_table(2799) := '646973742F696E6465782E65736D2E6A7322293B0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2F547970657327292E436F6E6E656374696F6E4C696B657D20436F6E6E656374696F6E4C696B';
wwv_flow_imp.g_varchar2_table(2800) := '650A202A204074797065646566207B696D706F727428272E2F547970657327292E526F6F744C696B657D20526F6F744C696B650A202A204074797065646566207B696D706F727428272E2F547970657327292E506172656E744C696B65207D2050617265';
wwv_flow_imp.g_varchar2_table(2801) := '6E744C696B650A202A204074797065646566207B696D706F727428272E2F547970657327292E53686170654C696B657D2053686170654C696B650A202A0A202A204074797065646566207B207B0A202A202020636F6E7461696E65723F3A2048544D4C45';
wwv_flow_imp.g_varchar2_table(2802) := '6C656D656E743B0A202A20202064656665725570646174653F3A20626F6F6C65616E3B0A202A20202077696474683F3A206E756D6265723B0A202A2020206865696768743F3A206E756D6265723B0A202A207D207D2043616E766173436F6E6669670A20';
wwv_flow_imp.g_varchar2_table(2803) := '2A204074797065646566207B207B0A202A20202067726F75703A20535647456C656D656E743B0A202A202020696E6465783A206E756D6265723B0A202A20202076697369626C653A20626F6F6C65616E3B0A202A207D207D2043616E7661734C61796572';
wwv_flow_imp.g_varchar2_table(2804) := '0A202A204074797065646566207B207B0A202A2020205B6B65793A20737472696E675D3A2043616E7661734C617965723B0A202A207D207D2043616E7661734C61796572730A202A204074797065646566207B207B0A202A202020726F6F74456C656D65';
wwv_flow_imp.g_varchar2_table(2805) := '6E743A2053686170654C696B653B0A202A2020206C617965723A2043616E7661734C617965723B0A202A207D207D2043616E766173506C616E650A202A204074797065646566207B207B0A202A2020207363616C653A206E756D6265723B0A202A202020';
wwv_flow_imp.g_varchar2_table(2806) := '696E6E65723A20526563743B0A202A2020206F757465723A2044696D656E73696F6E733B0A202A207D20262052656374207D2043616E76617356696577626F780A202A0A202A204074797065646566207B696D706F727428272E2F456C656D656E745265';
wwv_flow_imp.g_varchar2_table(2807) := '67697374727927292E64656661756C747D20456C656D656E7452656769737472790A202A204074797065646566207B696D706F727428272E2F4576656E7442757327292E64656661756C747D204576656E744275730A202A204074797065646566207B69';
wwv_flow_imp.g_varchar2_table(2808) := '6D706F727428272E2F4772617068696373466163746F727927292E64656661756C747D204772617068696373466163746F72790A202A0A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E44696D656E73696F';
wwv_flow_imp.g_varchar2_table(2809) := '6E737D2044696D656E73696F6E730A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F696E740A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327';
wwv_flow_imp.g_varchar2_table(2810) := '292E526563747D20526563740A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E526563745452424C7D20526563745452424C0A202A204074797065646566207B696D706F727428272E2E2F7574696C2F5479';
wwv_flow_imp.g_varchar2_table(2811) := '70657327292E5363726F6C6C44656C74617D205363726F6C6C44656C74610A202A2F0A0A66756E6374696F6E20726F756E64286E756D6265722C207265736F6C7574696F6E29207B0A202072657475726E204D6174682E726F756E64286E756D62657220';
wwv_flow_imp.g_varchar2_table(2812) := '2A207265736F6C7574696F6E29202F207265736F6C7574696F6E3B0A7D0A0A66756E6374696F6E20656E737572655078286E756D62657229207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(2813) := '44554C455F305F5F2E69734E756D62657229286E756D62657229203F206E756D626572202B2027707827203A206E756D6265723B0A7D0A0A66756E6374696F6E2066696E64526F6F7428656C656D656E7429207B0A20207768696C652028656C656D656E';
wwv_flow_imp.g_varchar2_table(2814) := '742E706172656E7429207B0A20202020656C656D656E74203D20656C656D656E742E706172656E743B0A20207D0A0A202072657475726E20656C656D656E743B0A7D0A0A2F2A2A0A202A204372656174657320612048544D4C20636F6E7461696E657220';
wwv_flow_imp.g_varchar2_table(2815) := '656C656D656E7420666F7220612053564720656C656D656E7420776974680A202A2074686520676976656E20636F6E66696775726174696F6E0A202A0A202A2040706172616D207B43616E766173436F6E6669677D206F7074696F6E730A202A0A202A20';
wwv_flow_imp.g_varchar2_table(2816) := '4072657475726E207B48544D4C456C656D656E747D2074686520636F6E7461696E657220656C656D656E740A202A2F0A66756E6374696F6E20637265617465436F6E7461696E6572286F7074696F6E7329207B0A0A20206F7074696F6E73203D2028302C';
wwv_flow_imp.g_varchar2_table(2817) := '6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E29287B7D2C207B2077696474683A202731303025272C206865696768743A20273130302527207D2C206F7074696F6E73293B0A0A2020636F';
wwv_flow_imp.g_varchar2_table(2818) := '6E737420636F6E7461696E6572203D206F7074696F6E732E636F6E7461696E6572207C7C20646F63756D656E742E626F64793B0A0A20202F2F206372656174652061203C6469763E2061726F756E64207468652073766720656C656D656E742077697468';
wwv_flow_imp.g_varchar2_table(2819) := '2074686520726573706563746976652073697A650A20202F2F2074686973207761792077652063616E20616C77617973206765742074686520636F727265637420636F6E7461696E65722073697A650A20202F2F20287468697320697320696D706F7373';
wwv_flow_imp.g_varchar2_table(2820) := '69626C6520666F72203C7376673E20656C656D656E747320617420746865206D6F6D656E74290A2020636F6E737420706172656E74203D20646F63756D656E742E637265617465456C656D656E74282764697627293B0A2020706172656E742E73657441';
wwv_flow_imp.g_varchar2_table(2821) := '74747269627574652827636C617373272C2027646A732D636F6E7461696E657220646A732D706172656E7427293B0A0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E61737369676E5374796C';
wwv_flow_imp.g_varchar2_table(2822) := '652928706172656E742C207B0A20202020706F736974696F6E3A202772656C6174697665272C0A202020206F766572666C6F773A202768696464656E272C0A2020202077696474683A20656E737572655078286F7074696F6E732E7769647468292C0A20';
wwv_flow_imp.g_varchar2_table(2823) := '2020206865696768743A20656E737572655078286F7074696F6E732E686569676874290A20207D293B0A0A2020636F6E7461696E65722E617070656E644368696C6428706172656E74293B0A0A202072657475726E20706172656E743B0A7D0A0A66756E';
wwv_flow_imp.g_varchar2_table(2824) := '6374696F6E2063726561746547726F757028706172656E742C20636C732C206368696C64496E64657829207B0A2020636F6E73742067726F7570203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F';
wwv_flow_imp.g_varchar2_table(2825) := '5F2E6372656174652928276727293B0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E636C6173736573292867726F7570292E61646428636C73293B0A0A2020636F6E737420696E64657820';
wwv_flow_imp.g_varchar2_table(2826) := '3D206368696C64496E64657820213D3D20756E646566696E6564203F206368696C64496E646578203A20706172656E742E6368696C644E6F6465732E6C656E677468202D20313B0A0A20202F2F206D75737420656E73757265207365636F6E6420617267';
wwv_flow_imp.g_varchar2_table(2827) := '756D656E74206973206E6F6465206F72205F6E756C6C5F0A20202F2F2063662E2068747470733A2F2F646576656C6F7065722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F4E6F64652F696E736572744265666F72650A';
wwv_flow_imp.g_varchar2_table(2828) := '2020706172656E742E696E736572744265666F72652867726F75702C20706172656E742E6368696C644E6F6465735B696E6465785D207C7C206E756C6C293B0A0A202072657475726E2067726F75703B0A7D0A0A636F6E737420424153455F4C41594552';
wwv_flow_imp.g_varchar2_table(2829) := '203D202762617365273B0A0A2F2F2072656E64657220706C616E6520636F6E74656E747320626568696E64207574696C697479206C61796572730A636F6E737420504C414E455F4C415945525F494E444558203D20303B0A636F6E7374205554494C4954';
wwv_flow_imp.g_varchar2_table(2830) := '595F4C415945525F494E444558203D20313B0A0A0A636F6E73742052455155495245445F4D4F44454C5F4154545253203D207B0A202073686170653A205B202778272C202779272C20277769647468272C202768656967687427205D2C0A2020636F6E6E';
wwv_flow_imp.g_varchar2_table(2831) := '656374696F6E3A205B2027776179706F696E747327205D0A7D3B0A0A2F2A2A0A202A20546865206D61696E2064726177696E672063616E7661732E0A202A0A202A2040636C6173730A202A2040636F6E7374727563746F720A202A0A202A2040656D6974';
wwv_flow_imp.g_varchar2_table(2832) := '732043616E7661732363616E7661732E696E69740A202A0A202A2040706172616D207B43616E766173436F6E6669677C6E756C6C7D20636F6E6669670A202A2040706172616D207B4576656E744275737D206576656E744275730A202A2040706172616D';
wwv_flow_imp.g_varchar2_table(2833) := '207B4772617068696373466163746F72797D206772617068696373466163746F72790A202A2040706172616D207B456C656D656E7452656769737472797D20656C656D656E7452656769737472790A202A2F0A66756E6374696F6E2043616E7661732863';
wwv_flow_imp.g_varchar2_table(2834) := '6F6E6669672C206576656E744275732C206772617068696373466163746F72792C20656C656D656E74526567697374727929207B0A2020746869732E5F6576656E74427573203D206576656E744275733B0A2020746869732E5F656C656D656E74526567';
wwv_flow_imp.g_varchar2_table(2835) := '6973747279203D20656C656D656E7452656769737472793B0A2020746869732E5F6772617068696373466163746F7279203D206772617068696373466163746F72793B0A0A20202F2A2A0A2020202A204074797065207B6E756D6265727D0A2020202A2F';
wwv_flow_imp.g_varchar2_table(2836) := '0A2020746869732E5F726F6F7473496478203D20303B0A0A20202F2A2A0A2020202A204074797065207B43616E7661734C61796572737D0A2020202A2F0A2020746869732E5F6C6179657273203D207B7D3B0A0A20202F2A2A0A2020202A204074797065';
wwv_flow_imp.g_varchar2_table(2837) := '207B43616E766173506C616E655B5D7D0A2020202A2F0A2020746869732E5F706C616E6573203D205B5D3B0A0A20202F2A2A0A2020202A204074797065207B526F6F744C696B657C6E756C6C7D0A2020202A2F0A2020746869732E5F726F6F74456C656D';
wwv_flow_imp.g_varchar2_table(2838) := '656E74203D206E756C6C3B0A0A2020746869732E5F696E697428636F6E666967207C7C207B7D293B0A7D0A0A43616E7661732E24696E6A656374203D205B0A202027636F6E6669672E63616E766173272C0A2020276576656E74427573272C0A20202767';
wwv_flow_imp.g_varchar2_table(2839) := '72617068696373466163746F7279272C0A202027656C656D656E745265676973747279270A5D3B0A0A2F2A2A0A202A20437265617465732061203C7376673E20656C656D656E742074686174206973207772617070656420696E746F2061203C6469763E';
wwv_flow_imp.g_varchar2_table(2840) := '2E0A202A2054686973207761792077652061726520616C776179732061626C6520746F20636F72726563746C7920666967757265206F7574207468652073697A65206F66207468652073766720656C656D656E740A202A206279207175657279696E6720';
wwv_flow_imp.g_varchar2_table(2841) := '74686520706172656E74206E6F64652E0A0A202A20284974206973206E6F7420706F737369626C6520746F20676574207468652073697A65206F6620612073766720656C656D656E742063726F73732062726F77736572204020323031342D30342D3031';
wwv_flow_imp.g_varchar2_table(2842) := '290A0A202A203C64697620636C6173733D22646A732D636F6E7461696E657222207374796C653D2277696474683A207B646573697265642D77696474687D2C206865696768743A207B646573697265642D6865696768747D223E0A202A2020203C737667';
wwv_flow_imp.g_varchar2_table(2843) := '2077696474683D223130302522206865696768743D2231303025223E0A202A202020202E2E2E0A202A2020203C2F7376673E0A202A203C2F6469763E0A202A0A202A2040706172616D207B43616E766173436F6E6669677D20636F6E6669670A202A2F0A';
wwv_flow_imp.g_varchar2_table(2844) := '43616E7661732E70726F746F747970652E5F696E6974203D2066756E6374696F6E28636F6E66696729207B0A0A2020636F6E7374206576656E74427573203D20746869732E5F6576656E744275733B0A0A20202F2F2068746D6C20636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(2845) := '0A2020636F6E737420636F6E7461696E6572203D20746869732E5F636F6E7461696E6572203D20637265617465436F6E7461696E657228636F6E666967293B0A0A2020636F6E737420737667203D20746869732E5F737667203D2028302C74696E795F73';
wwv_flow_imp.g_varchar2_table(2846) := '76675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E63726561746529282773766727293B0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E617474722928737667';
wwv_flow_imp.g_varchar2_table(2847) := '2C207B2077696474683A202731303025272C206865696768743A20273130302527207D293B0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E617070656E642928636F6E7461696E65722C';
wwv_flow_imp.g_varchar2_table(2848) := '20737667293B0A0A2020636F6E73742076696577706F7274203D20746869732E5F76696577706F7274203D2063726561746547726F7570287376672C202776696577706F727427293B0A0A20202F2F206465626F756E63652063616E7661732E76696577';
wwv_flow_imp.g_varchar2_table(2849) := '626F782E6368616E676564206576656E7473207768656E206465666572557064617465206973207365740A20202F2F20746F2068656C70207769746820706F74656E7469616C20706572666F726D616E6365206973737565730A202069662028636F6E66';
wwv_flow_imp.g_varchar2_table(2850) := '69672E646566657255706461746529207B0A20202020746869732E5F76696577626F784368616E676564203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6465626F756E6365292828302C6D';
wwv_flow_imp.g_varchar2_table(2851) := '696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E62696E642928746869732E5F76696577626F784368616E6765642C2074686973292C20333030293B0A20207D0A0A20206576656E744275732E6F6E28276469';
wwv_flow_imp.g_varchar2_table(2852) := '616772616D2E696E6974272C202829203D3E207B0A0A202020202F2A2A0A20202020202A20416E206576656E7420696E6469636174696E672074686174207468652063616E76617320697320726561647920746F20626520647261776E206F6E2E0A2020';
wwv_flow_imp.g_varchar2_table(2853) := '2020202A0A20202020202A20406D656D6265724F662043616E7661730A20202020202A0A20202020202A20406576656E742063616E7661732E696E69740A20202020202A0A20202020202A204074797065207B4F626A6563747D0A20202020202A204070';
wwv_flow_imp.g_varchar2_table(2854) := '726F7065727479207B535647456C656D656E747D207376672074686520637265617465642073766720656C656D656E740A20202020202A204070726F7065727479207B535647456C656D656E747D2076696577706F727420746865206469726563742070';
wwv_flow_imp.g_varchar2_table(2855) := '6172656E74206F66206469616772616D20656C656D656E747320616E64207368617065730A20202020202A2F0A202020206576656E744275732E66697265282763616E7661732E696E6974272C207B0A2020202020207376673A207376672C0A20202020';
wwv_flow_imp.g_varchar2_table(2856) := '202076696577706F72743A2076696577706F72740A202020207D293B0A0A20207D293B0A0A20202F2F2072657365742076696577626F78206F6E207368617065206368616E67657320746F0A20202F2F207265636F6D7075746520746865207669657762';
wwv_flow_imp.g_varchar2_table(2857) := '6F780A20206576656E744275732E6F6E285B0A202020202773686170652E6164646564272C0A2020202027636F6E6E656374696F6E2E6164646564272C0A202020202773686170652E72656D6F766564272C0A2020202027636F6E6E656374696F6E2E72';
wwv_flow_imp.g_varchar2_table(2858) := '656D6F766564272C0A2020202027656C656D656E74732E6368616E676564272C0A2020202027726F6F742E736574270A20205D2C202829203D3E207B0A2020202064656C65746520746869732E5F63616368656456696577626F783B0A20207D293B0A0A';
wwv_flow_imp.g_varchar2_table(2859) := '20206576656E744275732E6F6E28276469616772616D2E64657374726F79272C203530302C20746869732E5F64657374726F792C2074686973293B0A20206576656E744275732E6F6E28276469616772616D2E636C656172272C203530302C2074686973';
wwv_flow_imp.g_varchar2_table(2860) := '2E5F636C6561722C2074686973293B0A7D3B0A0A43616E7661732E70726F746F747970652E5F64657374726F79203D2066756E6374696F6E2829207B0A2020746869732E5F6576656E744275732E66697265282763616E7661732E64657374726F79272C';
wwv_flow_imp.g_varchar2_table(2861) := '207B0A202020207376673A20746869732E5F7376672C0A2020202076696577706F72743A20746869732E5F76696577706F72740A20207D293B0A0A2020636F6E737420706172656E74203D20746869732E5F636F6E7461696E65722E706172656E744E6F';
wwv_flow_imp.g_varchar2_table(2862) := '64653B0A0A202069662028706172656E7429207B0A20202020706172656E742E72656D6F76654368696C6428746869732E5F636F6E7461696E6572293B0A20207D0A0A202064656C65746520746869732E5F7376673B0A202064656C6574652074686973';
wwv_flow_imp.g_varchar2_table(2863) := '2E5F636F6E7461696E65723B0A202064656C65746520746869732E5F6C61796572733B0A202064656C65746520746869732E5F706C616E65733B0A202064656C65746520746869732E5F726F6F74456C656D656E743B0A202064656C6574652074686973';
wwv_flow_imp.g_varchar2_table(2864) := '2E5F76696577706F72743B0A7D3B0A0A43616E7661732E70726F746F747970652E5F636C656172203D2066756E6374696F6E2829207B0A0A2020636F6E737420616C6C456C656D656E7473203D20746869732E5F656C656D656E7452656769737472792E';
wwv_flow_imp.g_varchar2_table(2865) := '676574416C6C28293B0A0A20202F2F2072656D6F766520616C6C20656C656D656E74730A2020616C6C456C656D656E74732E666F724561636828656C656D656E74203D3E207B0A20202020636F6E73742074797065203D2028302C5F7574696C5F456C65';
wwv_flow_imp.g_varchar2_table(2866) := '6D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E676574547970652928656C656D656E74293B0A0A202020206966202874797065203D3D3D2027726F6F742729207B0A202020202020746869732E72656D6F766552';
wwv_flow_imp.g_varchar2_table(2867) := '6F6F74456C656D656E7428656C656D656E74293B0A202020207D20656C7365207B0A202020202020746869732E5F72656D6F7665456C656D656E7428656C656D656E742C2074797065293B0A202020207D0A20207D293B0A0A20202F2F2072656D6F7665';
wwv_flow_imp.g_varchar2_table(2868) := '20616C6C20706C616E65730A2020746869732E5F706C616E6573203D205B5D3B0A2020746869732E5F726F6F74456C656D656E74203D206E756C6C3B0A0A20202F2F20666F726365207265636F6D7075746174696F6E206F66207669657720626F780A20';
wwv_flow_imp.g_varchar2_table(2869) := '2064656C65746520746869732E5F63616368656456696577626F783B0A7D3B0A0A2F2A2A0A202A2052657475726E73207468652064656661756C74206C61796572206F6E2077686963680A202A20616C6C20656C656D656E74732061726520647261776E';
wwv_flow_imp.g_varchar2_table(2870) := '2E0A202A0A202A204072657475726E207B535647456C656D656E747D20205468652053564720656C656D656E74206F6620746865206C617965722E0A202A2F0A43616E7661732E70726F746F747970652E67657444656661756C744C61796572203D2066';
wwv_flow_imp.g_varchar2_table(2871) := '756E6374696F6E2829207B0A202072657475726E20746869732E6765744C6179657228424153455F4C415945522C20504C414E455F4C415945525F494E444558293B0A7D3B0A0A2F2A2A0A202A2052657475726E732061206C6179657220746861742069';
wwv_flow_imp.g_varchar2_table(2872) := '73207573656420746F206472617720656C656D656E74730A202A206F7220616E6E6F746174696F6E73206F6E2069742E0A202A0A202A204E6F6E2D6578697374696E67206C617965727320726574726965766564207468726F7567682074686973206D65';
wwv_flow_imp.g_varchar2_table(2873) := '74686F640A202A2077696C6C20626520637265617465642E20447572696E67206372656174696F6E2C20746865206F7074696F6E616C20696E6465780A202A206D6179206265207573656420746F20637265617465206C61796572732062656C6F77206F';
wwv_flow_imp.g_varchar2_table(2874) := '722061626F7665206578697374696E67206C61796572732E0A202A2041206C6179657220776974682061206365727461696E20696E64657820697320616C7761797320637265617465642061626F766520616C6C0A202A206578697374696E67206C6179';
wwv_flow_imp.g_varchar2_table(2875) := '6572732077697468207468652073616D6520696E6465782E0A202A0A202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865206C617965722E0A202A2040706172616D207B6E756D6265727D205B696E646578';
wwv_flow_imp.g_varchar2_table(2876) := '5D2054686520696E646578206F6620746865206C617965722E0A202A0A202A204072657475726E207B535647456C656D656E747D205468652053564720656C656D656E74206F6620746865206C617965722E0A202A2F0A43616E7661732E70726F746F74';
wwv_flow_imp.g_varchar2_table(2877) := '7970652E6765744C61796572203D2066756E6374696F6E286E616D652C20696E64657829207B0A0A202069662028216E616D6529207B0A202020207468726F77206E6577204572726F7228276D75737420737065636966792061206E616D6527293B0A20';
wwv_flow_imp.g_varchar2_table(2878) := '207D0A0A20206C6574206C61796572203D20746869732E5F6C61796572735B6E616D655D3B0A0A202069662028216C6179657229207B0A202020206C61796572203D20746869732E5F6C61796572735B6E616D655D203D20746869732E5F637265617465';
wwv_flow_imp.g_varchar2_table(2879) := '4C61796572286E616D652C20696E646578293B0A20207D0A0A20202F2F207468726F7720616E206572726F72206966206C61796572206372656174696F6E202F20726574726976616C2069730A20202F2F20726571756573746564206F6E206469666665';
wwv_flow_imp.g_varchar2_table(2880) := '72656E7420696E6465780A202069662028747970656F6620696E64657820213D3D2027756E646566696E656427202626206C617965722E696E64657820213D3D20696E64657829207B0A202020207468726F77206E6577204572726F7228276C61796572';
wwv_flow_imp.g_varchar2_table(2881) := '203C27202B206E616D65202B20273E20616C7265616479206372656174656420617420696E646578203C27202B20696E646578202B20273E27293B0A20207D0A0A202072657475726E206C617965722E67726F75703B0A7D3B0A0A2F2A2A0A202A20466F';
wwv_flow_imp.g_varchar2_table(2882) := '72206120676976656E20696E6465782C2072657475726E20746865206E756D626572206F66206C61796572732074686174206861766520612068696768657220696E64657820616E640A202A206172652076697369626C652E0A202A0A202A2054686973';
wwv_flow_imp.g_varchar2_table(2883) := '206973207573656420746F2064657465726D696E6520746865206E6F64652061206C617965722073686F756C6420626520696E7365727465642061742E0A202A0A202A2040706172616D207B6E756D6265727D20696E6465780A202A0A202A2040726574';
wwv_flow_imp.g_varchar2_table(2884) := '75726E207B6E756D6265727D0A202A2F0A43616E7661732E70726F746F747970652E5F6765744368696C64496E646578203D2066756E6374696F6E28696E64657829207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F49';
wwv_flow_imp.g_varchar2_table(2885) := '4D504F525445445F4D4F44554C455F305F5F2E7265647563652928746869732E5F6C61796572732C2066756E6374696F6E286368696C64496E6465782C206C6179657229207B0A20202020696620286C617965722E76697369626C6520262620696E6465';
wwv_flow_imp.g_varchar2_table(2886) := '78203E3D206C617965722E696E64657829207B0A2020202020206368696C64496E6465782B2B3B0A202020207D0A0A2020202072657475726E206368696C64496E6465783B0A20207D2C2030293B0A7D3B0A0A2F2A2A0A202A2043726561746573206120';
wwv_flow_imp.g_varchar2_table(2887) := '676976656E206C6179657220616E642072657475726E732069742E0A202A0A202A2040706172616D207B737472696E677D206E616D650A202A2040706172616D207B6E756D6265727D205B696E6465783D305D0A202A0A202A204072657475726E207B43';
wwv_flow_imp.g_varchar2_table(2888) := '616E7661734C617965727D0A202A2F0A43616E7661732E70726F746F747970652E5F6372656174654C61796572203D2066756E6374696F6E286E616D652C20696E64657829207B0A0A202069662028747970656F6620696E646578203D3D3D2027756E64';
wwv_flow_imp.g_varchar2_table(2889) := '6566696E65642729207B0A20202020696E646578203D205554494C4954595F4C415945525F494E4445583B0A20207D0A0A2020636F6E7374206368696C64496E646578203D20746869732E5F6765744368696C64496E64657828696E646578293B0A0A20';
wwv_flow_imp.g_varchar2_table(2890) := '2072657475726E207B0A2020202067726F75703A2063726561746547726F757028746869732E5F76696577706F72742C20276C617965722D27202B206E616D652C206368696C64496E646578292C0A20202020696E6465783A20696E6465782C0A202020';
wwv_flow_imp.g_varchar2_table(2891) := '2076697369626C653A20747275650A20207D3B0A7D3B0A0A0A2F2A2A0A202A2053686F7773206120676976656E206C617965722E0A202A0A202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865206C617965';
wwv_flow_imp.g_varchar2_table(2892) := '722E0A202A0A202A204072657475726E207B535647456C656D656E747D205468652053564720656C656D656E74206F6620746865206C617965722E0A202A2F0A43616E7661732E70726F746F747970652E73686F774C61796572203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(2893) := '6E286E616D6529207B0A0A202069662028216E616D6529207B0A202020207468726F77206E6577204572726F7228276D75737420737065636966792061206E616D6527293B0A20207D0A0A2020636F6E7374206C61796572203D20746869732E5F6C6179';
wwv_flow_imp.g_varchar2_table(2894) := '6572735B6E616D655D3B0A0A202069662028216C6179657229207B0A202020207468726F77206E6577204572726F7228276C61796572203C27202B206E616D65202B20273E20646F6573206E6F7420657869737427293B0A20207D0A0A2020636F6E7374';
wwv_flow_imp.g_varchar2_table(2895) := '2076696577706F7274203D20746869732E5F76696577706F72743B0A2020636F6E73742067726F7570203D206C617965722E67726F75703B0A2020636F6E737420696E646578203D206C617965722E696E6465783B0A0A2020696620286C617965722E76';
wwv_flow_imp.g_varchar2_table(2896) := '697369626C6529207B0A2020202072657475726E2067726F75703B0A20207D0A0A2020636F6E7374206368696C64496E646578203D20746869732E5F6765744368696C64496E64657828696E646578293B0A0A202076696577706F72742E696E73657274';
wwv_flow_imp.g_varchar2_table(2897) := '4265666F72652867726F75702C2076696577706F72742E6368696C644E6F6465735B6368696C64496E6465785D207C7C206E756C6C293B0A0A20206C617965722E76697369626C65203D20747275653B0A0A202072657475726E2067726F75703B0A7D3B';
wwv_flow_imp.g_varchar2_table(2898) := '0A0A2F2A2A0A202A204869646573206120676976656E206C617965722E0A202A0A202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865206C617965722E0A202A0A202A204072657475726E207B535647456C';
wwv_flow_imp.g_varchar2_table(2899) := '656D656E747D205468652053564720656C656D656E74206F6620746865206C617965722E0A202A2F0A43616E7661732E70726F746F747970652E686964654C61796572203D2066756E6374696F6E286E616D6529207B0A0A202069662028216E616D6529';
wwv_flow_imp.g_varchar2_table(2900) := '207B0A202020207468726F77206E6577204572726F7228276D75737420737065636966792061206E616D6527293B0A20207D0A0A2020636F6E7374206C61796572203D20746869732E5F6C61796572735B6E616D655D3B0A0A202069662028216C617965';
wwv_flow_imp.g_varchar2_table(2901) := '7229207B0A202020207468726F77206E6577204572726F7228276C61796572203C27202B206E616D65202B20273E20646F6573206E6F7420657869737427293B0A20207D0A0A2020636F6E73742067726F7570203D206C617965722E67726F75703B0A0A';
wwv_flow_imp.g_varchar2_table(2902) := '202069662028216C617965722E76697369626C6529207B0A2020202072657475726E2067726F75703B0A20207D0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E72656D6F766529286772';
wwv_flow_imp.g_varchar2_table(2903) := '6F7570293B0A0A20206C617965722E76697369626C65203D2066616C73653B0A0A202072657475726E2067726F75703B0A7D3B0A0A0A43616E7661732E70726F746F747970652E5F72656D6F76654C61796572203D2066756E6374696F6E286E616D6529';
wwv_flow_imp.g_varchar2_table(2904) := '207B0A0A2020636F6E7374206C61796572203D20746869732E5F6C61796572735B6E616D655D3B0A0A2020696620286C6179657229207B0A2020202064656C65746520746869732E5F6C61796572735B6E616D655D3B0A0A2020202028302C74696E795F';
wwv_flow_imp.g_varchar2_table(2905) := '7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E72656D6F766529286C617965722E67726F7570293B0A20207D0A7D3B0A0A2F2A2A0A202A2052657475726E73207468652063757272656E746C7920616374697665206C';
wwv_flow_imp.g_varchar2_table(2906) := '617965722E2043616E206265206E756C6C2E0A202A0A202A204072657475726E207B43616E7661734C617965727C6E756C6C7D2054686520616374697665206C61796572206F6620606E756C6C602E0A202A2F0A43616E7661732E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(2907) := '2E6765744163746976654C61796572203D2066756E6374696F6E2829207B0A2020636F6E737420706C616E65203D20746869732E5F66696E64506C616E65466F72526F6F7428746869732E676574526F6F74456C656D656E742829293B0A0A2020696620';
wwv_flow_imp.g_varchar2_table(2908) := '2821706C616E6529207B0A2020202072657475726E206E756C6C3B0A20207D0A0A202072657475726E20706C616E652E6C617965723B0A7D3B0A0A0A2F2A2A0A202A2052657475726E732074686520706C616E6520776869636820636F6E7461696E7320';
wwv_flow_imp.g_varchar2_table(2909) := '74686520676976656E20656C656D656E742E0A202A0A202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E677D20656C656D656E742054686520656C656D656E74206F72206974732049442E0A202A0A';
wwv_flow_imp.g_varchar2_table(2910) := '202A204072657475726E207B526F6F744C696B657C756E646566696E65647D2054686520726F6F74206F662074686520656C656D656E742E0A202A2F0A43616E7661732E70726F746F747970652E66696E64526F6F74203D2066756E6374696F6E28656C';
wwv_flow_imp.g_varchar2_table(2911) := '656D656E7429207B0A202069662028747970656F6620656C656D656E74203D3D3D2027737472696E672729207B0A20202020656C656D656E74203D20746869732E5F656C656D656E7452656769737472792E67657428656C656D656E74293B0A20207D0A';
wwv_flow_imp.g_varchar2_table(2912) := '0A20206966202821656C656D656E7429207B0A2020202072657475726E3B0A20207D0A0A2020636F6E737420706C616E65203D20746869732E5F66696E64506C616E65466F72526F6F74280A2020202066696E64526F6F7428656C656D656E74290A2020';
wwv_flow_imp.g_varchar2_table(2913) := '29207C7C207B7D3B0A0A202072657475726E20706C616E652E726F6F74456C656D656E743B0A7D3B0A0A2F2A2A0A202A2052657475726E2061206C697374206F6620616C6C20726F6F7420656C656D656E7473206F6E20746865206469616772616D2E0A';
wwv_flow_imp.g_varchar2_table(2914) := '202A0A202A204072657475726E207B28526F6F744C696B65295B5D7D20546865206C697374206F6620726F6F7420656C656D656E74732E0A202A2F0A43616E7661732E70726F746F747970652E676574526F6F74456C656D656E7473203D2066756E6374';
wwv_flow_imp.g_varchar2_table(2915) := '696F6E2829207B0A202072657475726E20746869732E5F706C616E65732E6D61702866756E6374696F6E28706C616E6529207B0A2020202072657475726E20706C616E652E726F6F74456C656D656E743B0A20207D293B0A7D3B0A0A43616E7661732E70';
wwv_flow_imp.g_varchar2_table(2916) := '726F746F747970652E5F66696E64506C616E65466F72526F6F74203D2066756E6374696F6E28726F6F74456C656D656E7429207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F30';
wwv_flow_imp.g_varchar2_table(2917) := '5F5F2E66696E642928746869732E5F706C616E65732C2066756E6374696F6E28706C616E6529207B0A2020202072657475726E20706C616E652E726F6F74456C656D656E74203D3D3D20726F6F74456C656D656E743B0A20207D293B0A7D3B0A0A0A2F2A';
wwv_flow_imp.g_varchar2_table(2918) := '2A0A202A2052657475726E73207468652068746D6C20656C656D656E74207468617420656E636C6F736573207468650A202A2064726177696E672063616E7661732E0A202A0A202A204072657475726E207B48544D4C456C656D656E747D205468652048';
wwv_flow_imp.g_varchar2_table(2919) := '544D4C20656C656D656E74206F662074686520636F6E7461696E65722E0A202A2F0A43616E7661732E70726F746F747970652E676574436F6E7461696E6572203D2066756E6374696F6E2829207B0A202072657475726E20746869732E5F636F6E746169';
wwv_flow_imp.g_varchar2_table(2920) := '6E65723B0A7D3B0A0A0A2F2F206D61726B657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A43616E7661732E70726F746F747970652E5F7570646174654D61726B6572203D2066756E6374696F6E28656C656D656E742C206D61726B';
wwv_flow_imp.g_varchar2_table(2921) := '65722C2061646429207B0A20206C657420636F6E7461696E65723B0A0A20206966202821656C656D656E742E696429207B0A20202020656C656D656E74203D20746869732E5F656C656D656E7452656769737472792E67657428656C656D656E74293B0A';
wwv_flow_imp.g_varchar2_table(2922) := '20207D0A0A2020656C656D656E742E6D61726B657273203D20656C656D656E742E6D61726B657273207C7C206E65772053657428293B0A0A20202F2F207765206E65656420746F2061636365737320616C6C0A2020636F6E7461696E6572203D20746869';
wwv_flow_imp.g_varchar2_table(2923) := '732E5F656C656D656E7452656769737472792E5F656C656D656E74735B656C656D656E742E69645D3B0A0A20206966202821636F6E7461696E657229207B0A2020202072657475726E3B0A20207D0A0A202028302C6D696E5F646173685F5F5745425041';
wwv_flow_imp.g_varchar2_table(2924) := '434B5F494D504F525445445F4D4F44554C455F305F5F2E666F724561636829285B20636F6E7461696E65722E6766782C20636F6E7461696E65722E7365636F6E64617279476678205D2C2066756E6374696F6E2867667829207B0A202020206966202867';
wwv_flow_imp.g_varchar2_table(2925) := '667829207B0A0A2020202020202F2F20696E766F6B652065697468657220616464436C617373206F722072656D6F7665436C617373206261736564206F6E206D6F64650A2020202020206966202861646429207B0A2020202020202020656C656D656E74';
wwv_flow_imp.g_varchar2_table(2926) := '2E6D61726B6572732E616464286D61726B6572293B0A202020202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E636C61737365732928676678292E616464286D61726B6572293B0A2020';
wwv_flow_imp.g_varchar2_table(2927) := '202020207D20656C7365207B0A2020202020202020656C656D656E742E6D61726B6572732E64656C657465286D61726B6572293B0A202020202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F';
wwv_flow_imp.g_varchar2_table(2928) := '5F2E636C61737365732928676678292E72656D6F7665286D61726B6572293B0A2020202020207D0A202020207D0A20207D293B0A0A20202F2A2A0A2020202A20416E206576656E7420696E6469636174696E6720746861742061206D61726B6572206861';
wwv_flow_imp.g_varchar2_table(2929) := '73206265656E207570646174656420666F7220616E20656C656D656E740A2020202A0A2020202A20406576656E7420656C656D656E742E6D61726B65722E7570646174650A2020202A204074797065207B4F626A6563747D0A2020202A204070726F7065';
wwv_flow_imp.g_varchar2_table(2930) := '727479207B456C656D656E747D20656C656D656E74207468652073686170650A2020202A204070726F7065727479207B535647456C656D656E747D20676678207468652067726170686963616C20726570726573656E746174696F6E206F662074686520';
wwv_flow_imp.g_varchar2_table(2931) := '73686170650A2020202A204070726F7065727479207B737472696E677D206D61726B65720A2020202A204070726F7065727479207B626F6F6C65616E7D20616464207472756520696620746865206D61726B6572207761732061646465642C2066616C73';
wwv_flow_imp.g_varchar2_table(2932) := '6520696620697420676F742072656D6F7665640A2020202A2F0A2020746869732E5F6576656E744275732E666972652827656C656D656E742E6D61726B65722E757064617465272C207B20656C656D656E743A20656C656D656E742C206766783A20636F';
wwv_flow_imp.g_varchar2_table(2933) := '6E7461696E65722E6766782C206D61726B65723A206D61726B65722C206164643A202121616464207D293B0A7D3B0A0A0A2F2A2A0A202A20416464732061206D61726B657220746F20616E20656C656D656E7420286261736963616C6C79206120637373';
wwv_flow_imp.g_varchar2_table(2934) := '20636C617373292E0A202A0A202A2046697265732074686520656C656D656E742E6D61726B65722E757064617465206576656E742C206D616B696E6720697420706F737369626C6520746F0A202A20696E7465677261746520657874656E73696F6E2069';
wwv_flow_imp.g_varchar2_table(2935) := '6E746F20746865206D61726B6572206C6966652D6379636C652C20746F6F2E0A202A0A202A20406578616D706C650A202A0A202A206060606A6176617363726970740A202A2063616E7661732E6164644D61726B65722827666F6F272C2027736F6D652D';
wwv_flow_imp.g_varchar2_table(2936) := '6D61726B657227293B0A202A0A202A20636F6E737420666F6F476678203D2063616E7661732E67657447726170686963732827666F6F27293B0A202A0A202A20666F6F4766783B202F2F203C6720636C6173733D222E2E2E20736F6D652D6D61726B6572';
wwv_flow_imp.g_varchar2_table(2937) := '223E202E2E2E203C2F673E0A202A206060600A202A0A202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E677D20656C656D656E742054686520656C656D656E74206F72206974732049442E0A202A20';
wwv_flow_imp.g_varchar2_table(2938) := '40706172616D207B737472696E677D206D61726B657220546865206D61726B65722E0A202A2F0A43616E7661732E70726F746F747970652E6164644D61726B6572203D2066756E6374696F6E28656C656D656E742C206D61726B657229207B0A20207468';
wwv_flow_imp.g_varchar2_table(2939) := '69732E5F7570646174654D61726B657228656C656D656E742C206D61726B65722C2074727565293B0A7D3B0A0A0A2F2A2A0A202A2052656D6F76652061206D61726B65722066726F6D20616E20656C656D656E742E0A202A0A202A204669726573207468';
wwv_flow_imp.g_varchar2_table(2940) := '6520656C656D656E742E6D61726B65722E757064617465206576656E742C206D616B696E6720697420706F737369626C6520746F0A202A20696E7465677261746520657874656E73696F6E20696E746F20746865206D61726B6572206C6966652D637963';
wwv_flow_imp.g_varchar2_table(2941) := '6C652C20746F6F2E0A202A0A202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E677D20656C656D656E742054686520656C656D656E74206F72206974732049442E0A202A2040706172616D207B7374';
wwv_flow_imp.g_varchar2_table(2942) := '72696E677D206D61726B657220546865206D61726B65722E0A202A2F0A43616E7661732E70726F746F747970652E72656D6F76654D61726B6572203D2066756E6374696F6E28656C656D656E742C206D61726B657229207B0A2020746869732E5F757064';
wwv_flow_imp.g_varchar2_table(2943) := '6174654D61726B657228656C656D656E742C206D61726B65722C2066616C7365293B0A7D3B0A0A2F2A2A0A202A20436865636B207768657468657220616E20656C656D656E7420686173206120676976656E206D61726B65722E0A202A0A202A20407061';
wwv_flow_imp.g_varchar2_table(2944) := '72616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E677D20656C656D656E742054686520656C656D656E74206F72206974732049442E0A202A2040706172616D207B737472696E677D206D61726B657220546865206D';
wwv_flow_imp.g_varchar2_table(2945) := '61726B65722E0A202A2F0A43616E7661732E70726F746F747970652E6861734D61726B6572203D2066756E6374696F6E28656C656D656E742C206D61726B657229207B0A20206966202821656C656D656E742E696429207B0A20202020656C656D656E74';
wwv_flow_imp.g_varchar2_table(2946) := '203D20746869732E5F656C656D656E7452656769737472792E67657428656C656D656E74293B0A20207D0A0A20206966202821656C656D656E742E6D61726B65727329207B0A2020202072657475726E2066616C73653B0A20207D0A0A20207265747572';
wwv_flow_imp.g_varchar2_table(2947) := '6E20656C656D656E742E6D61726B6572732E686173286D61726B6572293B0A7D3B0A0A2F2A2A0A202A20546F67676C65732061206D61726B6572206F6E20616E20656C656D656E742E0A202A0A202A2046697265732074686520656C656D656E742E6D61';
wwv_flow_imp.g_varchar2_table(2948) := '726B65722E757064617465206576656E742C206D616B696E6720697420706F737369626C6520746F0A202A20696E7465677261746520657874656E73696F6E20696E746F20746865206D61726B6572206C6966652D6379636C652C20746F6F2E0A202A0A';
wwv_flow_imp.g_varchar2_table(2949) := '202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E677D20656C656D656E742054686520656C656D656E74206F72206974732049442E0A202A2040706172616D207B737472696E677D206D61726B6572';
wwv_flow_imp.g_varchar2_table(2950) := '20546865206D61726B65722E0A202A2F0A43616E7661732E70726F746F747970652E746F67676C654D61726B6572203D2066756E6374696F6E28656C656D656E742C206D61726B657229207B0A202069662028746869732E6861734D61726B657228656C';
wwv_flow_imp.g_varchar2_table(2951) := '656D656E742C206D61726B65722929207B0A20202020746869732E72656D6F76654D61726B657228656C656D656E742C206D61726B6572293B0A20207D20656C7365207B0A20202020746869732E6164644D61726B657228656C656D656E742C206D6172';
wwv_flow_imp.g_varchar2_table(2952) := '6B6572293B0A20207D0A7D3B0A0A2F2A2A0A202A2052657475726E73207468652063757272656E7420726F6F7420656C656D656E742E0A202A0A202A20537570706F7274732074776F20646966666572656E74206D6F64657320666F722068616E646C69';
wwv_flow_imp.g_varchar2_table(2953) := '6E6720726F6F7420656C656D656E74733A0A202A0A202A20312E206966206E6F20726F6F7420656C656D656E7420686173206265656E206164646564206265666F72652C20616E20696D706C6963697420726F6F742077696C6C2062652061646465640A';
wwv_flow_imp.g_varchar2_table(2954) := '202A20616E642072657475726E65642E2054686973206973207573656420696E206170706C69636174696F6E73207468617420646F6E27742072657175697265206578706C696369740A202A20726F6F7420656C656D656E74732E0A202A0A202A20322E';
wwv_flow_imp.g_varchar2_table(2955) := '207768656E20726F6F7420656C656D656E74732068617665206265656E206164646564206265666F72652063616C6C696E672060676574526F6F74456C656D656E74602C0A202A20726F6F7420656C656D656E74732063616E206265206E756C6C2E2054';
wwv_flow_imp.g_varchar2_table(2956) := '686973206973207573656420666F72206170706C69636174696F6E7320746861742077616E7420746F206D616E6167650A202A20726F6F7420656C656D656E7473207468656D73656C7665732E0A202A0A202A204072657475726E207B526F6F744C696B';
wwv_flow_imp.g_varchar2_table(2957) := '657D205468652063757272656E7420726F6F7420656C656D656E742E0A202A2F0A43616E7661732E70726F746F747970652E676574526F6F74456C656D656E74203D2066756E6374696F6E2829207B0A2020636F6E737420726F6F74456C656D656E7420';
wwv_flow_imp.g_varchar2_table(2958) := '3D20746869732E5F726F6F74456C656D656E743B0A0A20202F2F2063616E2072657475726E206E756C6C20696620726F6F7420656C656D656E7473206172652070726573656E7420627574206E6F6E652077617320736574207965740A20206966202872';
wwv_flow_imp.g_varchar2_table(2959) := '6F6F74456C656D656E74207C7C20746869732E5F706C616E65732E6C656E67746829207B0A2020202072657475726E20726F6F74456C656D656E743B0A20207D0A0A202072657475726E20746869732E736574526F6F74456C656D656E7428746869732E';
wwv_flow_imp.g_varchar2_table(2960) := '616464526F6F74456C656D656E74286E756C6C29293B0A7D3B0A0A2F2A2A0A202A2041646473206120676976656E20726F6F7420656C656D656E7420616E642072657475726E732069742E0A202A0A202A2040706172616D207B526F6F744C696B657D20';
wwv_flow_imp.g_varchar2_table(2961) := '5B726F6F74456C656D656E745D2054686520726F6F7420656C656D656E7420746F2062652061646465642E0A202A0A202A204072657475726E207B526F6F744C696B657D2054686520616464656420726F6F7420656C656D656E74206F7220616E20696D';
wwv_flow_imp.g_varchar2_table(2962) := '706C6963697420726F6F7420656C656D656E742E0A202A2F0A43616E7661732E70726F746F747970652E616464526F6F74456C656D656E74203D2066756E6374696F6E28726F6F74456C656D656E7429207B0A2020636F6E737420696478203D20746869';
wwv_flow_imp.g_varchar2_table(2963) := '732E5F726F6F74734964782B2B3B0A0A20206966202821726F6F74456C656D656E7429207B0A20202020726F6F74456C656D656E74203D207B0A20202020202069643A20275F5F696D706C69636974726F6F745F27202B206964782C0A20202020202063';
wwv_flow_imp.g_varchar2_table(2964) := '68696C6472656E3A205B5D2C0A2020202020206973496D706C696369743A20747275650A202020207D3B0A20207D0A0A2020636F6E7374206C617965724E616D65203D20726F6F74456C656D656E742E6C61796572203D2027726F6F742D27202B206964';
wwv_flow_imp.g_varchar2_table(2965) := '783B0A0A2020746869732E5F656E7375726556616C69642827726F6F74272C20726F6F74456C656D656E74293B0A0A2020636F6E7374206C61796572203D20746869732E6765744C61796572286C617965724E616D652C20504C414E455F4C415945525F';
wwv_flow_imp.g_varchar2_table(2966) := '494E444558293B0A0A2020746869732E686964654C61796572286C617965724E616D65293B0A0A2020746869732E5F616464526F6F7428726F6F74456C656D656E742C206C61796572293B0A0A2020746869732E5F706C616E65732E70757368287B0A20';
wwv_flow_imp.g_varchar2_table(2967) := '202020726F6F74456C656D656E743A20726F6F74456C656D656E742C0A202020206C617965723A206C617965720A20207D293B0A0A202072657475726E20726F6F74456C656D656E743B0A7D3B0A0A2F2A2A0A202A2052656D6F76657320612067697665';
wwv_flow_imp.g_varchar2_table(2968) := '6E20726F6F7420656C656D656E7420616E642072657475726E732069742E0A202A0A202A2040706172616D207B526F6F744C696B657C737472696E677D20726F6F74456C656D656E7420656C656D656E74206F7220656C656D656E742049440A202A0A20';
wwv_flow_imp.g_varchar2_table(2969) := '2A204072657475726E207B526F6F744C696B657C756E646566696E65647D2072656D6F76656420656C656D656E740A202A2F0A43616E7661732E70726F746F747970652E72656D6F7665526F6F74456C656D656E74203D2066756E6374696F6E28726F6F';
wwv_flow_imp.g_varchar2_table(2970) := '74456C656D656E7429207B0A0A202069662028747970656F6620726F6F74456C656D656E74203D3D3D2027737472696E672729207B0A20202020726F6F74456C656D656E74203D20746869732E5F656C656D656E7452656769737472792E67657428726F';
wwv_flow_imp.g_varchar2_table(2971) := '6F74456C656D656E74293B0A20207D0A0A2020636F6E737420706C616E65203D20746869732E5F66696E64506C616E65466F72526F6F7428726F6F74456C656D656E74293B0A0A20206966202821706C616E6529207B0A2020202072657475726E3B0A20';
wwv_flow_imp.g_varchar2_table(2972) := '207D0A0A20202F2F20686F6F6B207570206C6966652D6379636C65206576656E74730A2020746869732E5F72656D6F7665526F6F7428726F6F74456C656D656E74293B0A0A20202F2F20636C65616E207570206C617965720A2020746869732E5F72656D';
wwv_flow_imp.g_varchar2_table(2973) := '6F76654C6179657228726F6F74456C656D656E742E6C61796572293B0A0A20202F2F20636C65616E20757020706C616E650A2020746869732E5F706C616E6573203D20746869732E5F706C616E65732E66696C7465722866756E6374696F6E28706C616E';
wwv_flow_imp.g_varchar2_table(2974) := '6529207B0A2020202072657475726E20706C616E652E726F6F74456C656D656E7420213D3D20726F6F74456C656D656E743B0A20207D293B0A0A20202F2F20636C65616E2075702061637469766520726F6F740A202069662028746869732E5F726F6F74';
wwv_flow_imp.g_varchar2_table(2975) := '456C656D656E74203D3D3D20726F6F74456C656D656E7429207B0A20202020746869732E5F726F6F74456C656D656E74203D206E756C6C3B0A20207D0A0A202072657475726E20726F6F74456C656D656E743B0A7D3B0A0A0A2F2A2A0A202A2053657473';
wwv_flow_imp.g_varchar2_table(2976) := '206120676976656E20656C656D656E7420617320746865206E657720726F6F7420656C656D656E7420666F72207468652063616E7661730A202A20616E642072657475726E7320746865206E657720726F6F7420656C656D656E742E0A202A0A202A2040';
wwv_flow_imp.g_varchar2_table(2977) := '706172616D207B526F6F744C696B657D20726F6F74456C656D656E742054686520726F6F7420656C656D656E7420746F206265207365742E0A202A0A202A204072657475726E207B526F6F744C696B657D205468652073657420726F6F7420656C656D65';
wwv_flow_imp.g_varchar2_table(2978) := '6E742E0A202A2F0A43616E7661732E70726F746F747970652E736574526F6F74456C656D656E74203D2066756E6374696F6E28726F6F74456C656D656E7429207B0A0A202069662028726F6F74456C656D656E74203D3D3D20746869732E5F726F6F7445';
wwv_flow_imp.g_varchar2_table(2979) := '6C656D656E7429207B0A2020202072657475726E20726F6F74456C656D656E743B0A20207D0A0A20206C657420706C616E653B0A0A20206966202821726F6F74456C656D656E7429207B0A202020207468726F77206E6577204572726F722827726F6F74';
wwv_flow_imp.g_varchar2_table(2980) := '456C656D656E7420726571756972656427293B0A20207D0A0A2020706C616E65203D20746869732E5F66696E64506C616E65466F72526F6F7428726F6F74456C656D656E74293B0A0A20202F2F206769766520736574206164642073656D616E74696373';
wwv_flow_imp.g_varchar2_table(2981) := '20666F72206261636B776172647320636F6D7061746962696C6974790A20206966202821706C616E6529207B0A20202020726F6F74456C656D656E74203D20746869732E616464526F6F74456C656D656E7428726F6F74456C656D656E74293B0A20207D';
wwv_flow_imp.g_varchar2_table(2982) := '0A0A2020746869732E5F736574526F6F7428726F6F74456C656D656E74293B0A0A202072657475726E20726F6F74456C656D656E743B0A7D3B0A0A0A43616E7661732E70726F746F747970652E5F72656D6F7665526F6F74203D2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(2983) := '656C656D656E7429207B0A2020636F6E737420656C656D656E745265676973747279203D20746869732E5F656C656D656E7452656769737472792C0A20202020202020206576656E74427573203D20746869732E5F6576656E744275733B0A0A20202F2F';
wwv_flow_imp.g_varchar2_table(2984) := '2073696D756C61746520656C656D656E742072656D6F7665206576656E742073657175656E63650A20206576656E744275732E666972652827726F6F742E72656D6F7665272C207B20656C656D656E743A20656C656D656E74207D293B0A20206576656E';
wwv_flow_imp.g_varchar2_table(2985) := '744275732E666972652827726F6F742E72656D6F766564272C207B20656C656D656E743A20656C656D656E74207D293B0A0A2020656C656D656E7452656769737472792E72656D6F766528656C656D656E74293B0A7D3B0A0A0A43616E7661732E70726F';
wwv_flow_imp.g_varchar2_table(2986) := '746F747970652E5F616464526F6F74203D2066756E6374696F6E28656C656D656E742C2067667829207B0A2020636F6E737420656C656D656E745265676973747279203D20746869732E5F656C656D656E7452656769737472792C0A2020202020202020';
wwv_flow_imp.g_varchar2_table(2987) := '6576656E74427573203D20746869732E5F6576656E744275733B0A0A20202F2F20726573656D626C6520656C656D656E7420616464206576656E742073657175656E63650A20206576656E744275732E666972652827726F6F742E616464272C207B2065';
wwv_flow_imp.g_varchar2_table(2988) := '6C656D656E743A20656C656D656E74207D293B0A0A2020656C656D656E7452656769737472792E61646428656C656D656E742C20676678293B0A0A20206576656E744275732E666972652827726F6F742E6164646564272C207B20656C656D656E743A20';
wwv_flow_imp.g_varchar2_table(2989) := '656C656D656E742C206766783A20676678207D293B0A7D3B0A0A0A43616E7661732E70726F746F747970652E5F736574526F6F74203D2066756E6374696F6E28726F6F74456C656D656E742C206C6179657229207B0A0A2020636F6E7374206375727265';
wwv_flow_imp.g_varchar2_table(2990) := '6E74526F6F74203D20746869732E5F726F6F74456C656D656E743B0A0A20206966202863757272656E74526F6F7429207B0A0A202020202F2F20756E2D6173736F63696174652070726576696F757320726F6F7420656C656D656E74203C7376673E0A20';
wwv_flow_imp.g_varchar2_table(2991) := '202020746869732E5F656C656D656E7452656769737472792E75706461746547726170686963732863757272656E74526F6F742C206E756C6C2C2074727565293B0A0A202020202F2F20686964652070726576696F7573206C617965720A202020207468';
wwv_flow_imp.g_varchar2_table(2992) := '69732E686964654C617965722863757272656E74526F6F742E6C61796572293B0A20207D0A0A202069662028726F6F74456C656D656E7429207B0A0A2020202069662028216C6179657229207B0A2020202020206C61796572203D20746869732E5F6669';
wwv_flow_imp.g_varchar2_table(2993) := '6E64506C616E65466F72526F6F7428726F6F74456C656D656E74292E6C617965723B0A202020207D0A0A202020202F2F206173736F636961746520656C656D656E742077697468203C7376673E0A20202020746869732E5F656C656D656E745265676973';
wwv_flow_imp.g_varchar2_table(2994) := '7472792E757064617465477261706869637328726F6F74456C656D656E742C20746869732E5F7376672C2074727565293B0A0A202020202F2F2073686F7720726F6F74206C617965720A20202020746869732E73686F774C6179657228726F6F74456C65';
wwv_flow_imp.g_varchar2_table(2995) := '6D656E742E6C61796572293B0A20207D0A0A2020746869732E5F726F6F74456C656D656E74203D20726F6F74456C656D656E743B0A0A2020746869732E5F6576656E744275732E666972652827726F6F742E736574272C207B20656C656D656E743A2072';
wwv_flow_imp.g_varchar2_table(2996) := '6F6F74456C656D656E74207D293B0A7D3B0A0A43616E7661732E70726F746F747970652E5F656E7375726556616C6964203D2066756E6374696F6E28747970652C20656C656D656E7429207B0A20206966202821656C656D656E742E696429207B0A2020';
wwv_flow_imp.g_varchar2_table(2997) := '20207468726F77206E6577204572726F722827656C656D656E74206D757374206861766520616E20696427293B0A20207D0A0A202069662028746869732E5F656C656D656E7452656769737472792E67657428656C656D656E742E69642929207B0A2020';
wwv_flow_imp.g_varchar2_table(2998) := '20207468726F77206E6577204572726F722827656C656D656E74203C27202B20656C656D656E742E6964202B20273E20616C72656164792065786973747327293B0A20207D0A0A2020636F6E73742072657175697265644174747273203D205245515549';
wwv_flow_imp.g_varchar2_table(2999) := '5245445F4D4F44454C5F41545452535B747970655D3B0A0A2020636F6E73742076616C6964203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E65766572792928726571756972656441747472';
wwv_flow_imp.g_varchar2_table(3000) := '732C2066756E6374696F6E286174747229207B0A2020202072657475726E20747970656F6620656C656D656E745B617474725D20213D3D2027756E646566696E6564273B0A20207D293B0A0A2020696620282176616C696429207B0A202020207468726F';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(3001) := '77206E6577204572726F72280A202020202020276D75737420737570706C79207B2027202B20726571756972656441747472732E6A6F696E28272C202729202B2027207D20776974682027202B2074797065293B0A20207D0A7D3B0A0A43616E7661732E';
wwv_flow_imp.g_varchar2_table(3002) := '70726F746F747970652E5F736574506172656E74203D2066756E6374696F6E28656C656D656E742C20706172656E742C20706172656E74496E64657829207B0A202028302C5F7574696C5F436F6C6C656374696F6E735F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(3003) := '525445445F4D4F44554C455F345F5F2E6164642928706172656E742E6368696C6472656E2C20656C656D656E742C20706172656E74496E646578293B0A2020656C656D656E742E706172656E74203D20706172656E743B0A7D3B0A0A2F2A2A0A202A2041';
wwv_flow_imp.g_varchar2_table(3004) := '64647320616E20656C656D656E7420746F207468652063616E7661732E0A202A0A202A20546869732077697265732074686520706172656E74203C2D3E206368696C642072656C6174696F6E73686970206265747765656E2074686520656C656D656E74';
wwv_flow_imp.g_varchar2_table(3005) := '20616E640A202A2061206578706C696369746C792073706563696669656420706172656E74206F7220616E20696D706C6963697420726F6F7420656C656D656E742E0A202A0A202A20447572696E672061646420697420656D6974732074686520657665';
wwv_flow_imp.g_varchar2_table(3006) := '6E74730A202A0A202A20202A203C7B747970657D2E6164643E2028656C656D656E742C20706172656E74290A202A20202A203C7B747970657D2E61646465643E2028656C656D656E742C20676678290A202A0A202A20457874656E73696F6E73206D6179';
wwv_flow_imp.g_varchar2_table(3007) := '20686F6F6B20696E746F207468657365206576656E747320746F20706572666F726D207468656972206D616769632E0A202A0A202A2040706172616D207B737472696E677D20747970650A202A2040706172616D207B436F6E6E656374696F6E4C696B65';
wwv_flow_imp.g_varchar2_table(3008) := '7C53686170654C696B657D20656C656D656E740A202A2040706172616D207B53686170654C696B657D205B706172656E745D0A202A2040706172616D207B6E756D6265727D205B706172656E74496E6465785D0A202A0A202A204072657475726E207B43';
wwv_flow_imp.g_varchar2_table(3009) := '6F6E6E656374696F6E4C696B657C53686170654C696B657D2054686520616464656420656C656D656E742E0A202A2F0A43616E7661732E70726F746F747970652E5F616464456C656D656E74203D2066756E6374696F6E28747970652C20656C656D656E';
wwv_flow_imp.g_varchar2_table(3010) := '742C20706172656E742C20706172656E74496E64657829207B0A0A2020706172656E74203D20706172656E74207C7C20746869732E676574526F6F74456C656D656E7428293B0A0A2020636F6E7374206576656E74427573203D20746869732E5F657665';
wwv_flow_imp.g_varchar2_table(3011) := '6E744275732C0A20202020202020206772617068696373466163746F7279203D20746869732E5F6772617068696373466163746F72793B0A0A2020746869732E5F656E7375726556616C696428747970652C20656C656D656E74293B0A0A20206576656E';
wwv_flow_imp.g_varchar2_table(3012) := '744275732E666972652874797065202B20272E616464272C207B20656C656D656E743A20656C656D656E742C20706172656E743A20706172656E74207D293B0A0A2020746869732E5F736574506172656E7428656C656D656E742C20706172656E742C20';
wwv_flow_imp.g_varchar2_table(3013) := '706172656E74496E646578293B0A0A20202F2F206372656174652067726170686963730A2020636F6E737420676678203D206772617068696373466163746F72792E63726561746528747970652C20656C656D656E742C20706172656E74496E64657829';
wwv_flow_imp.g_varchar2_table(3014) := '3B0A0A2020746869732E5F656C656D656E7452656769737472792E61646428656C656D656E742C20676678293B0A0A20202F2F20757064617465206974732076697375616C0A20206772617068696373466163746F72792E75706461746528747970652C';
wwv_flow_imp.g_varchar2_table(3015) := '20656C656D656E742C20676678293B0A0A20206576656E744275732E666972652874797065202B20272E6164646564272C207B20656C656D656E743A20656C656D656E742C206766783A20676678207D293B0A0A202072657475726E20656C656D656E74';
wwv_flow_imp.g_varchar2_table(3016) := '3B0A7D3B0A0A2F2A2A0A202A2041646473206120736861706520746F207468652063616E7661732E0A202A0A202A2040706172616D207B53686170654C696B657D2073686170652054686520736861706520746F2062652061646465640A202A20407061';
wwv_flow_imp.g_varchar2_table(3017) := '72616D207B506172656E744C696B657D205B706172656E745D20546865207368617065277320706172656E742E0A202A2040706172616D207B6E756D6265727D205B706172656E74496E6465785D2054686520696E64657820617420776869636820746F';
wwv_flow_imp.g_varchar2_table(3018) := '206164642074686520736861706520746F2074686520706172656E742773206368696C6472656E2E0A202A0A202A204072657475726E207B53686170654C696B657D205468652061646465642073686170652E0A202A2F0A43616E7661732E70726F746F';
wwv_flow_imp.g_varchar2_table(3019) := '747970652E6164645368617065203D2066756E6374696F6E2873686170652C20706172656E742C20706172656E74496E64657829207B0A202072657475726E20746869732E5F616464456C656D656E7428277368617065272C2073686170652C20706172';
wwv_flow_imp.g_varchar2_table(3020) := '656E742C20706172656E74496E646578293B0A7D3B0A0A2F2A2A0A202A2041646473206120636F6E6E656374696F6E20746F207468652063616E7661732E0A202A0A202A2040706172616D207B436F6E6E656374696F6E4C696B657D20636F6E6E656374';
wwv_flow_imp.g_varchar2_table(3021) := '696F6E2054686520636F6E6E656374696F6E20746F2062652061646465642E0A202A2040706172616D207B506172656E744C696B657D205B706172656E745D2054686520636F6E6E656374696F6E277320706172656E742E0A202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(3022) := '6E756D6265727D205B706172656E74496E6465785D2054686520696E64657820617420776869636820746F206164642074686520636F6E6E656374696F6E20746F2074686520706172656E742773206368696C6472656E2E0A202A0A202A204072657475';
wwv_flow_imp.g_varchar2_table(3023) := '726E207B436F6E6E656374696F6E4C696B657D2054686520616464656420636F6E6E656374696F6E2E0A202A2F0A43616E7661732E70726F746F747970652E616464436F6E6E656374696F6E203D2066756E6374696F6E28636F6E6E656374696F6E2C20';
wwv_flow_imp.g_varchar2_table(3024) := '706172656E742C20706172656E74496E64657829207B0A202072657475726E20746869732E5F616464456C656D656E742827636F6E6E656374696F6E272C20636F6E6E656374696F6E2C20706172656E742C20706172656E74496E646578293B0A7D3B0A';
wwv_flow_imp.g_varchar2_table(3025) := '0A0A2F2A2A0A202A20496E7465726E616C2072656D6F766520656C656D656E740A202A2F0A43616E7661732E70726F746F747970652E5F72656D6F7665456C656D656E74203D2066756E6374696F6E28656C656D656E742C207479706529207B0A0A2020';
wwv_flow_imp.g_varchar2_table(3026) := '636F6E737420656C656D656E745265676973747279203D20746869732E5F656C656D656E7452656769737472792C0A20202020202020206772617068696373466163746F7279203D20746869732E5F6772617068696373466163746F72792C0A20202020';
wwv_flow_imp.g_varchar2_table(3027) := '202020206576656E74427573203D20746869732E5F6576656E744275733B0A0A2020656C656D656E74203D20656C656D656E7452656769737472792E67657428656C656D656E742E6964207C7C20656C656D656E74293B0A0A20206966202821656C656D';
wwv_flow_imp.g_varchar2_table(3028) := '656E7429207B0A0A202020202F2F20656C656D656E74207761732072656D6F76656420616C72656164790A2020202072657475726E3B0A20207D0A0A20206576656E744275732E666972652874797065202B20272E72656D6F7665272C207B20656C656D';
wwv_flow_imp.g_varchar2_table(3029) := '656E743A20656C656D656E74207D293B0A0A20206772617068696373466163746F72792E72656D6F766528656C656D656E74293B0A0A20202F2F20756E73657420706172656E74203C2D3E206368696C642072656C6174696F6E736869700A202028302C';
wwv_flow_imp.g_varchar2_table(3030) := '5F7574696C5F436F6C6C656374696F6E735F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E72656D6F76652928656C656D656E742E706172656E7420262620656C656D656E742E706172656E742E6368696C6472656E2C20656C';
wwv_flow_imp.g_varchar2_table(3031) := '656D656E74293B0A2020656C656D656E742E706172656E74203D206E756C6C3B0A0A20206576656E744275732E666972652874797065202B20272E72656D6F766564272C207B20656C656D656E743A20656C656D656E74207D293B0A0A2020656C656D65';
wwv_flow_imp.g_varchar2_table(3032) := '6E7452656769737472792E72656D6F766528656C656D656E74293B0A0A202072657475726E20656C656D656E743B0A7D3B0A0A0A2F2A2A0A202A2052656D6F76657320612073686170652066726F6D207468652063616E7661732E0A202A0A202A204066';
wwv_flow_imp.g_varchar2_table(3033) := '6972657320536861706552656D6F76654576656E740A202A2040666972657320536861706552656D6F7665644576656E740A202A0A202A2040706172616D207B53686170654C696B657C737472696E677D20736861706520546865207368617065206F72';
wwv_flow_imp.g_varchar2_table(3034) := '206974732049442E0A202A0A202A204072657475726E207B53686170654C696B657D205468652072656D6F7665642073686170652E0A202A2F0A43616E7661732E70726F746F747970652E72656D6F76655368617065203D2066756E6374696F6E287368';
wwv_flow_imp.g_varchar2_table(3035) := '61706529207B0A0A20202F2A2A0A2020202A20416E206576656E7420696E6469636174696E67207468617420612073686170652069732061626F757420746F2062652072656D6F7665642066726F6D207468652063616E7661732E0A2020202A0A202020';
wwv_flow_imp.g_varchar2_table(3036) := '2A20406D656D6265724F662043616E7661730A2020202A0A2020202A20406576656E7420536861706552656D6F76654576656E740A2020202A204074797065207B4F626A6563747D0A2020202A204070726F7065727479207B53686170654C696B657D20';
wwv_flow_imp.g_varchar2_table(3037) := '656C656D656E74205468652073686170652E0A2020202A204070726F7065727479207B535647456C656D656E747D20676678205468652067726170686963616C20656C656D656E742E0A2020202A2F0A0A20202F2A2A0A2020202A20416E206576656E74';
wwv_flow_imp.g_varchar2_table(3038) := '20696E6469636174696E672074686174206120736861706520686173206265656E2072656D6F7665642066726F6D207468652063616E7661732E0A2020202A0A2020202A20406D656D6265724F662043616E7661730A2020202A0A2020202A2040657665';
wwv_flow_imp.g_varchar2_table(3039) := '6E7420536861706552656D6F7665644576656E740A2020202A204074797065207B4F626A6563747D0A2020202A204070726F7065727479207B53686170654C696B657D20656C656D656E74205468652073686170652E0A2020202A204070726F70657274';
wwv_flow_imp.g_varchar2_table(3040) := '79207B535647456C656D656E747D20676678205468652067726170686963616C20656C656D656E742E0A2020202A2F0A202072657475726E20746869732E5F72656D6F7665456C656D656E742873686170652C2027736861706527293B0A7D3B0A0A0A2F';
wwv_flow_imp.g_varchar2_table(3041) := '2A2A0A202A2052656D6F766573206120636F6E6E656374696F6E2066726F6D207468652063616E7661732E0A202A0A202A2040666972657320436F6E6E656374696F6E52656D6F76654576656E740A202A2040666972657320436F6E6E656374696F6E52';
wwv_flow_imp.g_varchar2_table(3042) := '656D6F7665644576656E740A202A0A202A2040706172616D207B436F6E6E656374696F6E4C696B657C737472696E677D20636F6E6E656374696F6E2054686520636F6E6E656374696F6E206F72206974732049442E0A202A0A202A204072657475726E20';
wwv_flow_imp.g_varchar2_table(3043) := '7B436F6E6E656374696F6E4C696B657D205468652072656D6F76656420636F6E6E656374696F6E2E0A202A2F0A43616E7661732E70726F746F747970652E72656D6F7665436F6E6E656374696F6E203D2066756E6374696F6E28636F6E6E656374696F6E';
wwv_flow_imp.g_varchar2_table(3044) := '29207B0A0A20202F2A2A0A2020202A20416E206576656E7420696E6469636174696E672074686174206120636F6E6E656374696F6E2069732061626F757420746F2062652072656D6F7665642066726F6D207468652063616E7661732E0A2020202A0A20';
wwv_flow_imp.g_varchar2_table(3045) := '20202A20406D656D6265724F662043616E7661730A2020202A0A2020202A20406576656E7420436F6E6E656374696F6E52656D6F76654576656E740A2020202A204074797065207B4F626A6563747D0A2020202A204070726F7065727479207B436F6E6E';
wwv_flow_imp.g_varchar2_table(3046) := '656374696F6E4C696B657D20656C656D656E742054686520636F6E6E656374696F6E2E0A2020202A204070726F7065727479207B535647456C656D656E747D20676678205468652067726170686963616C20656C656D656E742E0A2020202A2F0A0A2020';
wwv_flow_imp.g_varchar2_table(3047) := '2F2A2A0A2020202A20416E206576656E7420696E6469636174696E672074686174206120636F6E6E656374696F6E20686173206265656E2072656D6F7665642066726F6D207468652063616E7661732E0A2020202A0A2020202A20406D656D6265724F66';
wwv_flow_imp.g_varchar2_table(3048) := '2043616E7661730A2020202A0A2020202A20406576656E7420436F6E6E656374696F6E52656D6F7665644576656E740A2020202A204074797065207B4F626A6563747D0A2020202A204070726F7065727479207B436F6E6E656374696F6E4C696B657D20';
wwv_flow_imp.g_varchar2_table(3049) := '656C656D656E742054686520636F6E6E656374696F6E2E0A2020202A204070726F7065727479207B535647456C656D656E747D20676678205468652067726170686963616C20656C656D656E742E0A2020202A2F0A202072657475726E20746869732E5F';
wwv_flow_imp.g_varchar2_table(3050) := '72656D6F7665456C656D656E7428636F6E6E656374696F6E2C2027636F6E6E656374696F6E27293B0A7D3B0A0A0A2F2A2A0A202A2052657475726E73207468652067726170686963616C20656C656D656E74206F6620616E20656C656D656E742E0A202A';
wwv_flow_imp.g_varchar2_table(3051) := '0A202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E677D20656C656D656E742054686520656C656D656E74206F72206974732049442E0A202A2040706172616D207B626F6F6C65616E7D205B736563';
wwv_flow_imp.g_varchar2_table(3052) := '6F6E646172793D66616C73655D205768657468657220746F2072657475726E20746865207365636F6E646172792067726170686963616C20656C656D656E742E0A202A0A202A204072657475726E207B535647456C656D656E747D205468652067726170';
wwv_flow_imp.g_varchar2_table(3053) := '686963616C20656C656D656E742E0A202A2F0A43616E7661732E70726F746F747970652E6765744772617068696373203D2066756E6374696F6E28656C656D656E742C207365636F6E6461727929207B0A202072657475726E20746869732E5F656C656D';
wwv_flow_imp.g_varchar2_table(3054) := '656E7452656769737472792E676574477261706869637328656C656D656E742C207365636F6E64617279293B0A7D3B0A0A0A2F2A2A0A202A20506572666F726D20612076696577626F782075706461746520766961206120676976656E206368616E6765';
wwv_flow_imp.g_varchar2_table(3055) := '2066756E6374696F6E2E0A202A0A202A2040706172616D207B46756E6374696F6E7D206368616E6765466E0A202A2F0A43616E7661732E70726F746F747970652E5F6368616E676556696577626F78203D2066756E6374696F6E286368616E6765466E29';
wwv_flow_imp.g_varchar2_table(3056) := '207B0A0A20202F2F206E6F74696679206F7468657273206F6620746865207570636F6D696E672076696577626F78206368616E67650A2020746869732E5F6576656E744275732E66697265282763616E7661732E76696577626F782E6368616E67696E67';
wwv_flow_imp.g_varchar2_table(3057) := '27293B0A0A20202F2F20706572666F726D2061637475616C206368616E67650A20206368616E6765466E2E6170706C792874686973293B0A0A20202F2F20726573657420746865206361636865642076696577626F7820736F20746861740A20202F2F20';
wwv_flow_imp.g_varchar2_table(3058) := '61206E657720676574206F7065726174696F6E206F6E2076696577626F78206F72207A6F6F6D0A20202F2F20747269676765727320612076696577626F782072652D636F6D7075746174696F6E0A2020746869732E5F63616368656456696577626F7820';
wwv_flow_imp.g_varchar2_table(3059) := '3D206E756C6C3B0A0A20202F2F206E6F74696679206F7468657273206F6620746865206368616E67653B207468697320737465700A20202F2F206D6179206F72206D6179206E6F74206265206465626F756E6365640A2020746869732E5F76696577626F';
wwv_flow_imp.g_varchar2_table(3060) := '784368616E67656428293B0A7D3B0A0A43616E7661732E70726F746F747970652E5F76696577626F784368616E676564203D2066756E6374696F6E2829207B0A2020746869732E5F6576656E744275732E66697265282763616E7661732E76696577626F';
wwv_flow_imp.g_varchar2_table(3061) := '782E6368616E676564272C207B2076696577626F783A20746869732E76696577626F782829207D293B0A7D3B0A0A0A2F2A2A0A202A2047657473206F72207365747320746865207669657720626F78206F66207468652063616E7661732C20692E652E20';
wwv_flow_imp.g_varchar2_table(3062) := '7468650A202A206172656120746861742069732063757272656E746C7920646973706C617965642E0A202A0A202A2054686520676574746572206D61792072657475726E2061206361636865642076696577626F78202869662069742069732063757272';
wwv_flow_imp.g_varchar2_table(3063) := '656E746C790A202A206368616E67696E67292E20546F20666F7263652061207265636F6D7075746174696F6E2C2070617373206066616C7365602061732074686520666972737420617267756D656E742E0A202A0A202A20406578616D706C650A202A0A';
wwv_flow_imp.g_varchar2_table(3064) := '202A206060606A6176617363726970740A202A2063616E7661732E76696577626F78287B20783A203130302C20793A203130302C2077696474683A203530302C206865696768743A20353030207D290A202A0A202A202F2F207365747320746865207669';
wwv_flow_imp.g_varchar2_table(3065) := '7369626C652061726561206F6620746865206469616772616D20746F20283130307C31303029202D3E20283630307C313030290A202A202F2F20616E6420616E64207363616C6573206974206163636F7264696E6720746F20746865206469616772616D';
wwv_flow_imp.g_varchar2_table(3066) := '2077696474680A202A0A202A20636F6E73742076696577626F78203D2063616E7661732E76696577626F7828293B202F2F2070617373206066616C73656020746F20666F726365207265636F6D707574696E672074686520626F782E0A202A0A202A2063';
wwv_flow_imp.g_varchar2_table(3067) := '6F6E736F6C652E6C6F672876696577626F78293B0A202A202F2F207B0A202A202F2F202020696E6E65723A2044696D656E73696F6E732C0A202A202F2F2020206F757465723A2044696D656E73696F6E732C0A202A202F2F2020207363616C652C0A202A';
wwv_flow_imp.g_varchar2_table(3068) := '202F2F202020782C20792C0A202A202F2F20202077696474682C206865696768740A202A202F2F207D0A202A0A202A202F2F206966207468652063757272656E74206469616772616D206973207A6F6F6D656420616E64207363726F6C6C65642C20796F';
wwv_flow_imp.g_varchar2_table(3069) := '75206D617920726573657420697420746F207468650A202A202F2F2064656661756C74207A6F6F6D207669612074686973206D6574686F642C20746F6F3A0A202A0A202A20636F6E7374207A6F6F6D6564416E645363726F6C6C656456696577626F7820';
wwv_flow_imp.g_varchar2_table(3070) := '3D2063616E7661732E76696577626F7828293B0A202A0A202A2063616E7661732E76696577626F78287B0A202A202020783A20302C0A202A202020793A20302C0A202A20202077696474683A207A6F6F6D6564416E645363726F6C6C656456696577626F';
wwv_flow_imp.g_varchar2_table(3071) := '782E6F757465722E77696474682C0A202A2020206865696768743A207A6F6F6D6564416E645363726F6C6C656456696577626F782E6F757465722E6865696768740A202A207D293B0A202A206060600A202A0A202A2040706172616D207B526563747D20';
wwv_flow_imp.g_varchar2_table(3072) := '5B626F785D205468652076696577626F7820746F206265207365742E0A202A0A202A204072657475726E207B43616E76617356696577626F787D20546865207365742076696577626F782E0A202A2F0A43616E7661732E70726F746F747970652E766965';
wwv_flow_imp.g_varchar2_table(3073) := '77626F78203D2066756E6374696F6E28626F7829207B0A0A202069662028626F78203D3D3D20756E646566696E656420262620746869732E5F63616368656456696577626F7829207B0A2020202072657475726E20746869732E5F636163686564566965';
wwv_flow_imp.g_varchar2_table(3074) := '77626F783B0A20207D0A0A2020636F6E73742076696577706F7274203D20746869732E5F76696577706F72742C0A20202020202020206F75746572426F78203D20746869732E67657453697A6528293B0A20206C657420696E6E6572426F782C0A202020';
wwv_flow_imp.g_varchar2_table(3075) := '2020206D61747269782C0A2020202020206163746976654C617965722C0A2020202020207472616E73666F726D2C0A2020202020207363616C652C0A202020202020782C20793B0A0A20206966202821626F7829207B0A0A202020202F2F20636F6D7075';
wwv_flow_imp.g_varchar2_table(3076) := '74652074686520696E6E657220626F78206261736564206F6E207468650A202020202F2F206469616772616D7320616374697665206C617965722E205468697320616C6C6F777320757320746F206578636C7564650A202020202F2F2065787465726E61';
wwv_flow_imp.g_varchar2_table(3077) := '6C20636F6D706F6E656E74732C2073756368206173206F7665726C6179730A0A202020206163746976654C61796572203D20746869732E5F726F6F74456C656D656E74203F20746869732E6765744163746976654C617965722829203A206E756C6C3B0A';
wwv_flow_imp.g_varchar2_table(3078) := '20202020696E6E6572426F78203D206163746976654C61796572202626206163746976654C617965722E67657442426F782829207C7C207B7D3B0A0A202020207472616E73666F726D203D2028302C74696E795F7376675F5F5745425041434B5F494D50';
wwv_flow_imp.g_varchar2_table(3079) := '4F525445445F4D4F44554C455F325F5F2E7472616E73666F726D292876696577706F7274293B0A202020206D6174726978203D207472616E73666F726D203F207472616E73666F726D2E6D6174726978203A2028302C74696E795F7376675F5F57454250';
wwv_flow_imp.g_varchar2_table(3080) := '41434B5F494D504F525445445F4D4F44554C455F325F5F2E6372656174654D61747269782928293B0A202020207363616C65203D20726F756E64286D61747269782E612C2031303030293B0A0A2020202078203D20726F756E64282D6D61747269782E65';
wwv_flow_imp.g_varchar2_table(3081) := '207C7C20302C2031303030293B0A2020202079203D20726F756E64282D6D61747269782E66207C7C20302C2031303030293B0A0A20202020626F78203D20746869732E5F63616368656456696577626F78203D207B0A202020202020783A2078203F2078';
wwv_flow_imp.g_varchar2_table(3082) := '202F207363616C65203A20302C0A202020202020793A2079203F2079202F207363616C65203A20302C0A20202020202077696474683A206F75746572426F782E7769647468202F207363616C652C0A2020202020206865696768743A206F75746572426F';
wwv_flow_imp.g_varchar2_table(3083) := '782E686569676874202F207363616C652C0A2020202020207363616C653A207363616C652C0A202020202020696E6E65723A207B0A202020202020202077696474683A20696E6E6572426F782E7769647468207C7C20302C0A2020202020202020686569';
wwv_flow_imp.g_varchar2_table(3084) := '6768743A20696E6E6572426F782E686569676874207C7C20302C0A2020202020202020783A20696E6E6572426F782E78207C7C20302C0A2020202020202020793A20696E6E6572426F782E79207C7C20300A2020202020207D2C0A2020202020206F7574';
wwv_flow_imp.g_varchar2_table(3085) := '65723A206F75746572426F780A202020207D3B0A0A2020202072657475726E20626F783B0A20207D20656C7365207B0A0A20202020746869732E5F6368616E676556696577626F782866756E6374696F6E2829207B0A2020202020207363616C65203D20';
wwv_flow_imp.g_varchar2_table(3086) := '4D6174682E6D696E286F75746572426F782E7769647468202F20626F782E77696474682C206F75746572426F782E686569676874202F20626F782E686569676874293B0A0A202020202020636F6E7374206D6174726978203D20746869732E5F7376672E';
wwv_flow_imp.g_varchar2_table(3087) := '6372656174655356474D617472697828290A20202020202020202E7363616C65287363616C65290A20202020202020202E7472616E736C617465282D626F782E782C202D626F782E79293B0A0A20202020202028302C74696E795F7376675F5F57454250';
wwv_flow_imp.g_varchar2_table(3088) := '41434B5F494D504F525445445F4D4F44554C455F325F5F2E7472616E73666F726D292876696577706F72742C206D6174726978293B0A202020207D293B0A20207D0A0A202072657475726E20626F783B0A7D3B0A0A0A2F2A2A0A202A2047657473206F72';
wwv_flow_imp.g_varchar2_table(3089) := '207365747320746865207363726F6C6C206F66207468652063616E7661732E0A202A0A202A2040706172616D207B5363726F6C6C44656C74617D205B64656C74615D20546865207363726F6C6C20746F206265207365742E0A202A0A202A204072657475';
wwv_flow_imp.g_varchar2_table(3090) := '726E207B506F696E747D0A202A2F0A43616E7661732E70726F746F747970652E7363726F6C6C203D2066756E6374696F6E2864656C746129207B0A0A2020636F6E7374206E6F6465203D20746869732E5F76696577706F72743B0A20206C6574206D6174';
wwv_flow_imp.g_varchar2_table(3091) := '726978203D206E6F64652E67657443544D28293B0A0A20206966202864656C746129207B0A20202020746869732E5F6368616E676556696577626F782866756E6374696F6E2829207B0A20202020202064656C7461203D2028302C6D696E5F646173685F';
wwv_flow_imp.g_varchar2_table(3092) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E29287B2064783A20302C2064793A2030207D2C2064656C7461207C7C207B7D293B0A0A2020202020206D6174726978203D20746869732E5F7376672E6372656174';
wwv_flow_imp.g_varchar2_table(3093) := '655356474D617472697828292E7472616E736C6174652864656C74612E64782C2064656C74612E6479292E6D756C7469706C79286D6174726978293B0A0A20202020202073657443544D286E6F64652C206D6174726978293B0A202020207D293B0A2020';
wwv_flow_imp.g_varchar2_table(3094) := '7D0A0A202072657475726E207B20783A206D61747269782E652C20793A206D61747269782E66207D3B0A7D3B0A0A2F2A2A0A202A205363726F6C6C73207468652076696577626F7820746F20636F6E7461696E2074686520676976656E20656C656D656E';
wwv_flow_imp.g_varchar2_table(3095) := '742E0A202A204F7074696F6E616C6C79207370656369667920612070616464696E6720746F206265206170706C69656420746F207468652065646765732E0A202A0A202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B';
wwv_flow_imp.g_varchar2_table(3096) := '657C737472696E677D20656C656D656E742054686520656C656D656E7420746F207363726F6C6C20746F206F72206974732049442E0A202A2040706172616D207B526563745452424C7C6E756D6265727D205B70616464696E673D3130305D2054686520';
wwv_flow_imp.g_varchar2_table(3097) := '70616464696E6720746F206265206170706C6965642E2043616E20616C736F207370656369667920746F702C20626F74746F6D2C206C65667420616E642072696768742E0A202A2F0A43616E7661732E70726F746F747970652E7363726F6C6C546F456C';
wwv_flow_imp.g_varchar2_table(3098) := '656D656E74203D2066756E6374696F6E28656C656D656E742C2070616464696E6729207B0A20206C65742064656661756C7450616464696E67203D203130303B0A0A202069662028747970656F6620656C656D656E74203D3D3D2027737472696E672729';
wwv_flow_imp.g_varchar2_table(3099) := '207B0A20202020656C656D656E74203D20746869732E5F656C656D656E7452656769737472792E67657428656C656D656E74293B0A20207D0A0A20202F2F2073657420746F20636F727265637420726F6F74456C656D656E740A2020636F6E737420726F';
wwv_flow_imp.g_varchar2_table(3100) := '6F74456C656D656E74203D20746869732E66696E64526F6F7428656C656D656E74293B0A0A202069662028726F6F74456C656D656E7420213D3D20746869732E676574526F6F74456C656D656E74282929207B0A20202020746869732E736574526F6F74';
wwv_flow_imp.g_varchar2_table(3101) := '456C656D656E7428726F6F74456C656D656E74293B0A20207D0A0A20202F2F20656C656D656E7420697320726F6F74456C656D656E742C20646F206E6F74206368616E67652076696577706F72740A202069662028726F6F74456C656D656E74203D3D3D';
wwv_flow_imp.g_varchar2_table(3102) := '20656C656D656E7429207B0A2020202072657475726E3B0A20207D0A0A2020696620282170616464696E6729207B0A2020202070616464696E67203D207B7D3B0A20207D0A202069662028747970656F662070616464696E67203D3D3D20276E756D6265';
wwv_flow_imp.g_varchar2_table(3103) := '722729207B0A2020202064656661756C7450616464696E67203D2070616464696E673B0A20207D0A0A202070616464696E67203D207B0A20202020746F703A2070616464696E672E746F70207C7C2064656661756C7450616464696E672C0A2020202072';
wwv_flow_imp.g_varchar2_table(3104) := '696768743A2070616464696E672E7269676874207C7C2064656661756C7450616464696E672C0A20202020626F74746F6D3A2070616464696E672E626F74746F6D207C7C2064656661756C7450616464696E672C0A202020206C6566743A207061646469';
wwv_flow_imp.g_varchar2_table(3105) := '6E672E6C656674207C7C2064656661756C7450616464696E670A20207D3B0A0A2020636F6E737420656C656D656E74426F756E6473203D2028302C5F7574696C5F456C656D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F33';
wwv_flow_imp.g_varchar2_table(3106) := '5F5F2E67657442426F782928656C656D656E74292C0A2020202020202020656C656D656E745472626C203D2028302C5F6C61796F75745F4C61796F75745574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E6173545242';
wwv_flow_imp.g_varchar2_table(3107) := '4C2928656C656D656E74426F756E6473292C0A202020202020202076696577626F78426F756E6473203D20746869732E76696577626F7828292C0A20202020202020207A6F6F6D203D20746869732E7A6F6F6D28293B0A20206C65742064782C2064793B';
wwv_flow_imp.g_varchar2_table(3108) := '0A0A20202F2F20736872696E6B2076696577626F78426F756E647320776974682070616464696E670A202076696577626F78426F756E64732E79202B3D2070616464696E672E746F70202F207A6F6F6D3B0A202076696577626F78426F756E64732E7820';
wwv_flow_imp.g_varchar2_table(3109) := '2B3D2070616464696E672E6C656674202F207A6F6F6D3B0A202076696577626F78426F756E64732E7769647468202D3D202870616464696E672E7269676874202B2070616464696E672E6C65667429202F207A6F6F6D3B0A202076696577626F78426F75';
wwv_flow_imp.g_varchar2_table(3110) := '6E64732E686569676874202D3D202870616464696E672E626F74746F6D202B2070616464696E672E746F7029202F207A6F6F6D3B0A0A2020636F6E73742076696577626F785472626C203D2028302C5F6C61796F75745F4C61796F75745574696C5F5F57';
wwv_flow_imp.g_varchar2_table(3111) := '45425041434B5F494D504F525445445F4D4F44554C455F355F5F2E61735452424C292876696577626F78426F756E6473293B0A0A2020636F6E73742063616E466974203D20656C656D656E74426F756E64732E7769647468203C2076696577626F78426F';
wwv_flow_imp.g_varchar2_table(3112) := '756E64732E776964746820262620656C656D656E74426F756E64732E686569676874203C2076696577626F78426F756E64732E6865696768743B0A0A2020696620282163616E46697429207B0A0A202020202F2F20746F702D6C656674207768656E2065';
wwv_flow_imp.g_varchar2_table(3113) := '6C656D656E742063616E2774206669740A202020206478203D20656C656D656E74426F756E64732E78202D2076696577626F78426F756E64732E783B0A202020206479203D20656C656D656E74426F756E64732E79202D2076696577626F78426F756E64';
wwv_flow_imp.g_varchar2_table(3114) := '732E793B0A0A20207D20656C7365207B0A0A20202020636F6E737420645269676874203D204D6174682E6D617828302C20656C656D656E745472626C2E7269676874202D2076696577626F785472626C2E7269676874292C0A2020202020202020202064';
wwv_flow_imp.g_varchar2_table(3115) := '4C656674203D204D6174682E6D696E28302C20656C656D656E745472626C2E6C656674202D2076696577626F785472626C2E6C656674292C0A2020202020202020202064426F74746F6D203D204D6174682E6D617828302C20656C656D656E745472626C';
wwv_flow_imp.g_varchar2_table(3116) := '2E626F74746F6D202D2076696577626F785472626C2E626F74746F6D292C0A2020202020202020202064546F70203D204D6174682E6D696E28302C20656C656D656E745472626C2E746F70202D2076696577626F785472626C2E746F70293B0A0A202020';
wwv_flow_imp.g_varchar2_table(3117) := '206478203D20645269676874207C7C20644C6566743B0A202020206479203D2064426F74746F6D207C7C2064546F703B0A0A20207D0A0A2020746869732E7363726F6C6C287B2064783A202D6478202A207A6F6F6D2C2064793A202D6479202A207A6F6F';
wwv_flow_imp.g_varchar2_table(3118) := '6D207D293B0A7D3B0A0A2F2A2A0A202A2047657473206F722073657473207468652063757272656E74207A6F6F6D206F66207468652063616E7661732C206F7074696F6E616C6C79207A6F6F6D696E6720746F207468650A202A20737065636966696564';
wwv_flow_imp.g_varchar2_table(3119) := '20706F736974696F6E2E0A202A0A202A2054686520676574746572206D61792072657475726E206120636163686564207A6F6F6D206C6576656C2E2043616C6C2069742077697468206066616C736560206173207468652066697273740A202A20617267';
wwv_flow_imp.g_varchar2_table(3120) := '756D656E7420746F20666F726365207265636F6D7075746174696F6E206F66207468652063757272656E74206C6576656C2E0A202A0A202A2040706172616D207B6E756D6265727C276669742D76696577706F7274277D205B6E65775363616C655D2054';
wwv_flow_imp.g_varchar2_table(3121) := '6865206E6577207A6F6F6D206C6576656C2C206569746865722061206E756D6265722C0A202A20692E652E20302E392C206F7220606669742D76696577706F72746020746F2061646A757374207468652073697A6520746F206669742074686520637572';
wwv_flow_imp.g_varchar2_table(3122) := '72656E742076696577706F72742E0A202A2040706172616D207B506F696E747D205B63656E7465725D20546865207265666572656E636520706F696E74207B20783A202E2E2E2C20793A202E2E2E7D20746F207A6F6F6D20746F2E0A202A0A202A204072';
wwv_flow_imp.g_varchar2_table(3123) := '657475726E207B6E756D6265727D2054686520736574207A6F6F6D206C6576656C2E0A202A2F0A43616E7661732E70726F746F747970652E7A6F6F6D203D2066756E6374696F6E286E65775363616C652C2063656E74657229207B0A0A20206966202821';
wwv_flow_imp.g_varchar2_table(3124) := '6E65775363616C6529207B0A2020202072657475726E20746869732E76696577626F78286E65775363616C65292E7363616C653B0A20207D0A0A2020696620286E65775363616C65203D3D3D20276669742D76696577706F72742729207B0A2020202072';
wwv_flow_imp.g_varchar2_table(3125) := '657475726E20746869732E5F66697456696577706F72742863656E746572293B0A20207D0A0A20206C6574206F757465722C0A2020202020206D61747269783B0A0A2020746869732E5F6368616E676556696577626F782866756E6374696F6E2829207B';
wwv_flow_imp.g_varchar2_table(3126) := '0A0A2020202069662028747970656F662063656E74657220213D3D20276F626A6563742729207B0A2020202020206F75746572203D20746869732E76696577626F7828292E6F757465723B0A0A20202020202063656E746572203D207B0A202020202020';
wwv_flow_imp.g_varchar2_table(3127) := '2020783A206F757465722E7769647468202F20322C0A2020202020202020793A206F757465722E686569676874202F20320A2020202020207D3B0A202020207D0A0A202020206D6174726978203D20746869732E5F7365745A6F6F6D286E65775363616C';
wwv_flow_imp.g_varchar2_table(3128) := '652C2063656E746572293B0A20207D293B0A0A202072657475726E20726F756E64286D61747269782E612C2031303030293B0A7D3B0A0A66756E6374696F6E2073657443544D286E6F64652C206D29207B0A2020636F6E7374206D737472203D20276D61';
wwv_flow_imp.g_varchar2_table(3129) := '747269782827202B206D2E61202B20272C27202B206D2E62202B20272C27202B206D2E63202B20272C27202B206D2E64202B20272C27202B206D2E65202B20272C27202B206D2E66202B202729273B0A20206E6F64652E73657441747472696275746528';
wwv_flow_imp.g_varchar2_table(3130) := '277472616E73666F726D272C206D737472293B0A7D0A0A43616E7661732E70726F746F747970652E5F66697456696577706F7274203D2066756E6374696F6E2863656E74657229207B0A0A2020636F6E73742076626F78203D20746869732E7669657762';
wwv_flow_imp.g_varchar2_table(3131) := '6F7828292C0A20202020202020206F75746572203D2076626F782E6F757465722C0A2020202020202020696E6E6572203D2076626F782E696E6E65723B0A20206C6574206E65775363616C652C0A2020202020206E657756696577626F783B0A0A20202F';
wwv_flow_imp.g_varchar2_table(3132) := '2F20646973706C61792074686520636F6D706C657465206469616772616D20776974686F7574207A6F6F6D696E6720696E2E0A20202F2F20696E7374656164206F662072656C79696E67206F6E20696E7465726E616C207A6F6F6D2C2077652070657266';
wwv_flow_imp.g_varchar2_table(3133) := '6F726D20610A20202F2F2068617264207265736574206F6E207468652063616E7661732076696577626F7820746F207265616C697A6520746869730A20202F2F0A20202F2F206966206469616772616D20646F6573206E6F74206E65656420746F206265';
wwv_flow_imp.g_varchar2_table(3134) := '207A6F6F6D656420696E2C20776520666F6375732069742061726F756E640A20202F2F20746865206469616772616D206F726967696E20696E73746561640A0A202069662028696E6E65722E78203E3D20302026260A202020202020696E6E65722E7920';
wwv_flow_imp.g_varchar2_table(3135) := '3E3D20302026260A202020202020696E6E65722E78202B20696E6E65722E7769647468203C3D206F757465722E77696474682026260A202020202020696E6E65722E79202B20696E6E65722E686569676874203C3D206F757465722E6865696768742026';
wwv_flow_imp.g_varchar2_table(3136) := '260A2020202020202163656E74657229207B0A0A202020206E657756696577626F78203D207B0A202020202020783A20302C0A202020202020793A20302C0A20202020202077696474683A204D6174682E6D617828696E6E65722E7769647468202B2069';
wwv_flow_imp.g_varchar2_table(3137) := '6E6E65722E782C206F757465722E7769647468292C0A2020202020206865696768743A204D6174682E6D617828696E6E65722E686569676874202B20696E6E65722E792C206F757465722E686569676874290A202020207D3B0A20207D20656C7365207B';
wwv_flow_imp.g_varchar2_table(3138) := '0A0A202020206E65775363616C65203D204D6174682E6D696E28312C206F757465722E7769647468202F20696E6E65722E77696474682C206F757465722E686569676874202F20696E6E65722E686569676874293B0A202020206E657756696577626F78';
wwv_flow_imp.g_varchar2_table(3139) := '203D207B0A202020202020783A20696E6E65722E78202B202863656E746572203F20696E6E65722E7769647468202F2032202D206F757465722E7769647468202F206E65775363616C65202F2032203A2030292C0A202020202020793A20696E6E65722E';
wwv_flow_imp.g_varchar2_table(3140) := '79202B202863656E746572203F20696E6E65722E686569676874202F2032202D206F757465722E686569676874202F206E65775363616C65202F2032203A2030292C0A20202020202077696474683A206F757465722E7769647468202F206E6577536361';
wwv_flow_imp.g_varchar2_table(3141) := '6C652C0A2020202020206865696768743A206F757465722E686569676874202F206E65775363616C650A202020207D3B0A20207D0A0A2020746869732E76696577626F78286E657756696577626F78293B0A0A202072657475726E20746869732E766965';
wwv_flow_imp.g_varchar2_table(3142) := '77626F782866616C7365292E7363616C653B0A7D3B0A0A0A43616E7661732E70726F746F747970652E5F7365745A6F6F6D203D2066756E6374696F6E287363616C652C2063656E74657229207B0A0A2020636F6E737420737667203D20746869732E5F73';
wwv_flow_imp.g_varchar2_table(3143) := '76672C0A202020202020202076696577706F7274203D20746869732E5F76696577706F72743B0A0A2020636F6E7374206D6174726978203D207376672E6372656174655356474D617472697828293B0A2020636F6E737420706F696E74203D207376672E';
wwv_flow_imp.g_varchar2_table(3144) := '637265617465535647506F696E7428293B0A0A20206C65742063656E746572506F696E742C0A2020202020206F726967696E616C506F696E742C0A20202020202063757272656E744D61747269782C0A2020202020207363616C654D61747269782C0A20';
wwv_flow_imp.g_varchar2_table(3145) := '20202020206E65774D61747269783B0A0A202063757272656E744D6174726978203D2076696577706F72742E67657443544D28293B0A0A2020636F6E73742063757272656E745363616C65203D2063757272656E744D61747269782E613B0A0A20206966';
wwv_flow_imp.g_varchar2_table(3146) := '202863656E74657229207B0A2020202063656E746572506F696E74203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E2928706F696E742C2063656E746572293B0A0A20202020';
wwv_flow_imp.g_varchar2_table(3147) := '2F2F20726576657274206170706C6965642076696577706F7274207472616E73666F726D6174696F6E730A202020206F726967696E616C506F696E74203D2063656E746572506F696E742E6D61747269785472616E73666F726D2863757272656E744D61';
wwv_flow_imp.g_varchar2_table(3148) := '747269782E696E76657273652829293B0A0A202020202F2F20637265617465207363616C65206D61747269780A202020207363616C654D6174726978203D206D61747269780A2020202020202E7472616E736C617465286F726967696E616C506F696E74';
wwv_flow_imp.g_varchar2_table(3149) := '2E782C206F726967696E616C506F696E742E79290A2020202020202E7363616C652831202F2063757272656E745363616C65202A207363616C65290A2020202020202E7472616E736C617465282D6F726967696E616C506F696E742E782C202D6F726967';
wwv_flow_imp.g_varchar2_table(3150) := '696E616C506F696E742E79293B0A0A202020206E65774D6174726978203D2063757272656E744D61747269782E6D756C7469706C79287363616C654D6174726978293B0A20207D20656C7365207B0A202020206E65774D6174726978203D206D61747269';
wwv_flow_imp.g_varchar2_table(3151) := '782E7363616C65287363616C65293B0A20207D0A0A202073657443544D28746869732E5F76696577706F72742C206E65774D6174726978293B0A0A202072657475726E206E65774D61747269783B0A7D3B0A0A0A2F2A2A0A202A2052657475726E732074';
wwv_flow_imp.g_varchar2_table(3152) := '68652073697A65206F66207468652063616E7661732E0A202A0A202A204072657475726E207B44696D656E73696F6E737D205468652073697A65206F66207468652063616E7661732E0A202A2F0A43616E7661732E70726F746F747970652E6765745369';
wwv_flow_imp.g_varchar2_table(3153) := '7A65203D2066756E6374696F6E2829207B0A202072657475726E207B0A2020202077696474683A20746869732E5F636F6E7461696E65722E636C69656E7457696474682C0A202020206865696768743A20746869732E5F636F6E7461696E65722E636C69';
wwv_flow_imp.g_varchar2_table(3154) := '656E744865696768740A20207D3B0A7D3B0A0A0A2F2A2A0A202A2052657475726E7320746865206162736F6C75746520626F756E64696E6720626F78206F6620616E20656C656D656E742E0A202A0A202A20546865206162736F6C75746520626F756E64';
wwv_flow_imp.g_varchar2_table(3155) := '696E6720626F78206D6179206265207573656420746F20646973706C6179206F7665726C61797320696E207468652063616C6C6572730A202A202862726F777365722920636F6F7264696E6174652073797374656D20726174686572207468616E207468';
wwv_flow_imp.g_varchar2_table(3156) := '65207A6F6F6D656420696E2F6F75742063616E76617320636F6F7264696E617465732E0A202A0A202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657D20656C656D656E742054686520656C656D656E742E0A202A0A';
wwv_flow_imp.g_varchar2_table(3157) := '202A204072657475726E207B526563747D2054686520656C656D656E742773206162736F6C75746520626F756E64696E6720626F782E0A202A2F0A43616E7661732E70726F746F747970652E6765744162736F6C75746542426F78203D2066756E637469';
wwv_flow_imp.g_varchar2_table(3158) := '6F6E28656C656D656E7429207B0A2020636F6E73742076626F78203D20746869732E76696577626F7828293B0A20206C65742062626F783B0A0A20202F2F20636F6E6E656374696F6E0A20202F2F20757365207376672062626F780A202069662028656C';
wwv_flow_imp.g_varchar2_table(3159) := '656D656E742E776179706F696E747329207B0A20202020636F6E737420676678203D20746869732E676574477261706869637328656C656D656E74293B0A0A2020202062626F78203D206766782E67657442426F7828293B0A20207D0A0A20202F2F2073';
wwv_flow_imp.g_varchar2_table(3160) := '68617065730A20202F2F2075736520646174610A2020656C7365207B0A2020202062626F78203D20656C656D656E743B0A20207D0A0A2020636F6E73742078203D2062626F782E78202A2076626F782E7363616C65202D2076626F782E78202A2076626F';
wwv_flow_imp.g_varchar2_table(3161) := '782E7363616C653B0A2020636F6E73742079203D2062626F782E79202A2076626F782E7363616C65202D2076626F782E79202A2076626F782E7363616C653B0A0A2020636F6E7374207769647468203D2062626F782E7769647468202A2076626F782E73';
wwv_flow_imp.g_varchar2_table(3162) := '63616C653B0A2020636F6E737420686569676874203D2062626F782E686569676874202A2076626F782E7363616C653B0A0A202072657475726E207B0A20202020783A20782C0A20202020793A20792C0A2020202077696474683A2077696474682C0A20';
wwv_flow_imp.g_varchar2_table(3163) := '2020206865696768743A206865696768740A20207D3B0A7D3B0A0A2F2A2A0A202A20466972657320616E206576656E7420736F206F74686572206D6F64756C65732063616E20726561637420746F207468652063616E76617320726573697A696E672E0A';
wwv_flow_imp.g_varchar2_table(3164) := '202A2F0A43616E7661732E70726F746F747970652E726573697A6564203D2066756E6374696F6E2829207B0A0A20202F2F20666F726365207265636F6D7075746174696F6E206F66207669657720626F780A202064656C65746520746869732E5F636163';
wwv_flow_imp.g_varchar2_table(3165) := '68656456696577626F783B0A0A2020746869732E5F6576656E744275732E66697265282763616E7661732E726573697A656427293B0A7D3B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D';
wwv_flow_imp.g_varchar2_table(3166) := '6A732F6C69622F636F72652F456C656D656E74466163746F72792E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A20';
wwv_flow_imp.g_varchar2_table(3167) := '20212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F456C656D656E74466163746F72792E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3168) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F72657175697265';
wwv_flow_imp.g_varchar2_table(3169) := '5F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F77';
wwv_flow_imp.g_varchar2_table(3170) := '65627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F20456C656D656E74466163746F7279290A2F2A206861726D6F6E';
wwv_flow_imp.g_varchar2_table(3171) := '79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F6D6F64656C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F';
wwv_flow_imp.g_varchar2_table(3172) := '2A21202E2E2F6D6F64656C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6D6F64656C2F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F57';
wwv_flow_imp.g_varchar2_table(3173) := '45425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E646578';
wwv_flow_imp.g_varchar2_table(3174) := '2E65736D2E6A7322293B0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E740A202A204074797065646566207B696D706F727428272E2E2F6D6F';
wwv_flow_imp.g_varchar2_table(3175) := '64656C2F547970657327292E436F6E6E656374696F6E7D20436F6E6E656374696F6E0A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4C6162656C7D204C6162656C0A202A204074797065646566207B69';
wwv_flow_imp.g_varchar2_table(3176) := '6D706F727428272E2E2F6D6F64656C2F547970657327292E526F6F747D20526F6F740A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E53686170657D2053686170650A202A2F0A0A2F2A2A0A202A204120';
wwv_flow_imp.g_varchar2_table(3177) := '666163746F727920666F72206D6F64656C20656C656D656E74732E0A202A0A202A204074656D706C617465207B436F6E6E656374696F6E7D205B543D436F6E6E656374696F6E5D0A202A204074656D706C617465207B4C6162656C7D205B553D4C616265';
wwv_flow_imp.g_varchar2_table(3178) := '6C5D0A202A204074656D706C617465207B526F6F747D205B563D526F6F745D0A202A204074656D706C617465207B53686170657D205B573D53686170655D0A202A2F0A66756E6374696F6E20456C656D656E74466163746F72792829207B0A2020746869';
wwv_flow_imp.g_varchar2_table(3179) := '732E5F756964203D2031323B0A7D0A0A2F2A2A0A202A20437265617465206120726F6F7420656C656D656E742E0A202A0A202A2040706172616D207B5061727469616C3C526F6F743E7D205B61747472735D0A202A0A202A204072657475726E207B567D';
wwv_flow_imp.g_varchar2_table(3180) := '20546865206372656174656420726F6F7420656C656D656E742E0A202A2F0A456C656D656E74466163746F72792E70726F746F747970652E637265617465526F6F74203D2066756E6374696F6E28617474727329207B0A202072657475726E2074686973';
wwv_flow_imp.g_varchar2_table(3181) := '2E6372656174652827726F6F74272C206174747273293B0A7D3B0A0A2F2A2A0A202A204372656174652061206C6162656C2E0A202A0A202A2040706172616D207B5061727469616C3C4C6162656C3E7D205B61747472735D0A202A0A202A204072657475';
wwv_flow_imp.g_varchar2_table(3182) := '726E207B557D205468652063726561746564206C6162656C2E0A202A2F0A456C656D656E74466163746F72792E70726F746F747970652E6372656174654C6162656C203D2066756E6374696F6E28617474727329207B0A202072657475726E2074686973';
wwv_flow_imp.g_varchar2_table(3183) := '2E63726561746528276C6162656C272C206174747273293B0A7D3B0A0A2F2A2A0A202A2043726561746520612073686170652E0A202A0A202A2040706172616D207B5061727469616C3C53686170653E7D205B61747472735D0A202A0A202A2040726574';
wwv_flow_imp.g_varchar2_table(3184) := '75726E207B577D2054686520637265617465642073686170652E0A202A2F0A456C656D656E74466163746F72792E70726F746F747970652E6372656174655368617065203D2066756E6374696F6E28617474727329207B0A202072657475726E20746869';
wwv_flow_imp.g_varchar2_table(3185) := '732E63726561746528277368617065272C206174747273293B0A7D3B0A0A2F2A2A0A202A20437265617465206120636F6E6E656374696F6E2E0A202A0A202A2040706172616D207B5061727469616C3C436F6E6E656374696F6E3E7D205B61747472735D';
wwv_flow_imp.g_varchar2_table(3186) := '0A202A0A202A204072657475726E207B547D20546865206372656174656420636F6E6E656374696F6E2E0A202A2F0A456C656D656E74466163746F72792E70726F746F747970652E637265617465436F6E6E656374696F6E203D2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(3187) := '617474727329207B0A202072657475726E20746869732E6372656174652827636F6E6E656374696F6E272C206174747273293B0A7D3B0A0A2F2A2A0A202A20437265617465206120726F6F7420656C656D656E742E0A202A0A202A20406F7665726C6F72';
wwv_flow_imp.g_varchar2_table(3188) := '640A202A2040706172616D207B27726F6F74277D20747970650A202A2040706172616D207B5061727469616C3C526F6F743E7D205B61747472735D0A202A204072657475726E207B567D0A202A2F0A2F2A2A0A202A204372656174652061207368617065';
wwv_flow_imp.g_varchar2_table(3189) := '2E0A202A0A202A20406F7665726C6F72640A202A2040706172616D207B277368617065277D20747970650A202A2040706172616D207B5061727469616C3C53686170653E7D205B61747472735D0A202A204072657475726E207B577D0A202A2F0A2F2A2A';
wwv_flow_imp.g_varchar2_table(3190) := '0A202A20437265617465206120636F6E6E656374696F6E2E0A202A0A202A20406F7665726C6F72640A202A2040706172616D207B27636F6E6E656374696F6E277D20747970650A202A2040706172616D207B5061727469616C3C436F6E6E656374696F6E';
wwv_flow_imp.g_varchar2_table(3191) := '3E7D205B61747472735D0A202A204072657475726E207B547D0A202A2F0A2F2A2A0A202A204372656174652061206C6162656C2E0A202A0A202A2040706172616D207B276C6162656C277D20747970650A202A2040706172616D207B5061727469616C3C';
wwv_flow_imp.g_varchar2_table(3192) := '4C6162656C3E7D205B61747472735D0A202A204072657475726E207B557D0A202A2F0A456C656D656E74466163746F72792E70726F746F747970652E637265617465203D2066756E6374696F6E28747970652C20617474727329207B0A0A202061747472';
wwv_flow_imp.g_varchar2_table(3193) := '73203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E29287B7D2C206174747273207C7C207B7D293B0A0A2020696620282161747472732E696429207B0A202020206174747273';
wwv_flow_imp.g_varchar2_table(3194) := '2E6964203D2074797065202B20275F27202B2028746869732E5F7569642B2B293B0A20207D0A0A202072657475726E2028302C5F6D6F64656C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6372656174652928747970652C';
wwv_flow_imp.g_varchar2_table(3195) := '206174747273293B0A7D3B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F456C656D656E7452656769737472792E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3196) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F456C65';
wwv_flow_imp.g_varchar2_table(3197) := '6D656E7452656769737472792E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E75';
wwv_flow_imp.g_varchar2_table(3198) := '7365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F';
wwv_flow_imp.g_varchar2_table(3199) := '6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020';
wwv_flow_imp.g_varchar2_table(3200) := '202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F20456C656D656E745265676973747279290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076617220';
wwv_flow_imp.g_varchar2_table(3201) := '74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D737667';
wwv_flow_imp.g_varchar2_table(3202) := '2F646973742F696E6465782E65736D2E6A7322293B0A76617220454C454D454E545F4944203D2027646174612D656C656D656E742D6964273B0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2F547970657327292E456C656D';
wwv_flow_imp.g_varchar2_table(3203) := '656E744C696B657D20456C656D656E744C696B650A202A0A202A204074797065646566207B696D706F727428272E2F4576656E7442757327292E64656661756C747D204576656E744275730A202A0A202A204074797065646566207B2028656C656D656E';
wwv_flow_imp.g_varchar2_table(3204) := '743A20456C656D656E744C696B652C206766783A20535647456C656D656E7429203D3E20626F6F6C65616E7C616E79207D20456C656D656E74526567697374727946696C74657243616C6C6261636B0A202A204074797065646566207B2028656C656D65';
wwv_flow_imp.g_varchar2_table(3205) := '6E743A20456C656D656E744C696B652C206766783A20535647456C656D656E7429203D3E20616E79207D20456C656D656E745265676973747279466F724561636843616C6C6261636B0A202A2F0A0A2F2A2A0A202A204120726567697374727920746861';
wwv_flow_imp.g_varchar2_table(3206) := '74206B6565707320747261636B206F6620616C6C2073686170657320696E20746865206469616772616D2E0A202A0A202A2040636C6173730A202A2040636F6E7374727563746F720A202A0A202A2040706172616D207B4576656E744275737D20657665';
wwv_flow_imp.g_varchar2_table(3207) := '6E744275730A202A2F0A66756E6374696F6E20456C656D656E745265676973747279286576656E7442757329207B0A0A20202F2A2A0A2020202A204074797065207B207B0A2020202A2020205B69643A20737472696E675D3A207B0A2020202A20202020';
wwv_flow_imp.g_varchar2_table(3208) := '20656C656D656E743A20456C656D656E744C696B653B0A2020202A20202020206766783F3A20535647456C656D656E743B0A2020202A20202020207365636F6E646172794766783F3A20535647456C656D656E743B0A2020202A2020207D0A2020202A20';
wwv_flow_imp.g_varchar2_table(3209) := '7D207D0A2020202A2F0A2020746869732E5F656C656D656E7473203D207B7D3B0A0A2020746869732E5F6576656E74427573203D206576656E744275733B0A7D0A0A456C656D656E7452656769737472792E24696E6A656374203D205B20276576656E74';
wwv_flow_imp.g_varchar2_table(3210) := '42757327205D3B0A0A2F2A2A0A202A2041646420616E20656C656D656E7420616E64206974732067726170686963616C20726570726573656E746174696F6E28732920746F207468652072656769737472792E0A202A0A202A2040706172616D207B456C';
wwv_flow_imp.g_varchar2_table(3211) := '656D656E744C696B657D20656C656D656E742054686520656C656D656E7420746F2062652061646465642E0A202A2040706172616D207B535647456C656D656E747D2067667820546865207072696D6172792067726170686963616C2072657072657365';
wwv_flow_imp.g_varchar2_table(3212) := '6E746174696F6E2E0A202A2040706172616D207B535647456C656D656E747D205B7365636F6E646172794766785D20546865207365636F6E646172792067726170686963616C20726570726573656E746174696F6E2E0A202A2F0A456C656D656E745265';
wwv_flow_imp.g_varchar2_table(3213) := '6769737472792E70726F746F747970652E616464203D2066756E6374696F6E28656C656D656E742C206766782C207365636F6E6461727947667829207B0A0A2020766172206964203D20656C656D656E742E69643B0A0A2020746869732E5F76616C6964';
wwv_flow_imp.g_varchar2_table(3214) := '6174654964286964293B0A0A20202F2F206173736F636961746520646F6D206E6F6465207769746820656C656D656E740A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6174747229286766';
wwv_flow_imp.g_varchar2_table(3215) := '782C20454C454D454E545F49442C206964293B0A0A2020696620287365636F6E6461727947667829207B0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6174747229287365636F6E64';
wwv_flow_imp.g_varchar2_table(3216) := '6172794766782C20454C454D454E545F49442C206964293B0A20207D0A0A2020746869732E5F656C656D656E74735B69645D203D207B20656C656D656E743A20656C656D656E742C206766783A206766782C207365636F6E646172794766783A20736563';
wwv_flow_imp.g_varchar2_table(3217) := '6F6E64617279476678207D3B0A7D3B0A0A2F2A2A0A202A2052656D6F766520616E20656C656D656E742066726F6D207468652072656769737472792E0A202A0A202A2040706172616D207B456C656D656E744C696B657C737472696E677D20656C656D65';
wwv_flow_imp.g_varchar2_table(3218) := '6E740A202A2F0A456C656D656E7452656769737472792E70726F746F747970652E72656D6F7665203D2066756E6374696F6E28656C656D656E7429207B0A202076617220656C656D656E7473203D20746869732E5F656C656D656E74732C0A2020202020';
wwv_flow_imp.g_varchar2_table(3219) := '206964203D20656C656D656E742E6964207C7C20656C656D656E742C0A202020202020636F6E7461696E6572203D20696420262620656C656D656E74735B69645D3B0A0A202069662028636F6E7461696E657229207B0A0A202020202F2F20756E736574';
wwv_flow_imp.g_varchar2_table(3220) := '20656C656D656E74206964206F6E206766780A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E617474722928636F6E7461696E65722E6766782C20454C454D454E545F49442C20272729';
wwv_flow_imp.g_varchar2_table(3221) := '3B0A0A2020202069662028636F6E7461696E65722E7365636F6E6461727947667829207B0A20202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E617474722928636F6E7461696E65722E';
wwv_flow_imp.g_varchar2_table(3222) := '7365636F6E646172794766782C20454C454D454E545F49442C202727293B0A202020207D0A0A2020202064656C65746520656C656D656E74735B69645D3B0A20207D0A7D3B0A0A2F2A2A0A202A2055706461746520616E20656C656D656E74732049442E';
wwv_flow_imp.g_varchar2_table(3223) := '0A202A0A202A2040706172616D207B456C656D656E744C696B657C737472696E677D20656C656D656E742054686520656C656D656E74206F72206974732049442E0A202A2040706172616D207B737472696E677D206E6577496420546865206E65772049';
wwv_flow_imp.g_varchar2_table(3224) := '442E0A202A2F0A456C656D656E7452656769737472792E70726F746F747970652E7570646174654964203D2066756E6374696F6E28656C656D656E742C206E6577496429207B0A0A2020746869732E5F76616C69646174654964286E65774964293B0A0A';
wwv_flow_imp.g_varchar2_table(3225) := '202069662028747970656F6620656C656D656E74203D3D3D2027737472696E672729207B0A20202020656C656D656E74203D20746869732E67657428656C656D656E74293B0A20207D0A0A2020746869732E5F6576656E744275732E666972652827656C';
wwv_flow_imp.g_varchar2_table(3226) := '656D656E742E7570646174654964272C207B0A20202020656C656D656E743A20656C656D656E742C0A202020206E657749643A206E657749640A20207D293B0A0A202076617220676678203D20746869732E676574477261706869637328656C656D656E';
wwv_flow_imp.g_varchar2_table(3227) := '74292C0A2020202020207365636F6E64617279476678203D20746869732E676574477261706869637328656C656D656E742C2074727565293B0A0A2020746869732E72656D6F766528656C656D656E74293B0A0A2020656C656D656E742E6964203D206E';
wwv_flow_imp.g_varchar2_table(3228) := '657749643B0A0A2020746869732E61646428656C656D656E742C206766782C207365636F6E64617279476678293B0A7D3B0A0A2F2A2A0A202A20557064617465207468652067726170686963616C20726570726573656E746174696F6E206F6620616E20';
wwv_flow_imp.g_varchar2_table(3229) := '656C656D656E742E0A202A0A202A2040706172616D207B456C656D656E744C696B657C737472696E677D2066696C7465722054686520656C656D656E74206F72206974732049442E0A202A2040706172616D207B535647456C656D656E747D2067667820';
wwv_flow_imp.g_varchar2_table(3230) := '546865206E65772067726170686963616C20726570726573656E746174696F6E2E0A202A2040706172616D207B626F6F6C65616E7D205B7365636F6E646172793D66616C73655D205768657468657220746F2075706461746520746865207365636F6E64';
wwv_flow_imp.g_varchar2_table(3231) := '6172792067726170686963616C20726570726573656E746174696F6E2E0A202A2F0A456C656D656E7452656769737472792E70726F746F747970652E7570646174654772617068696373203D2066756E6374696F6E2866696C7465722C206766782C2073';
wwv_flow_imp.g_varchar2_table(3232) := '65636F6E6461727929207B0A2020766172206964203D2066696C7465722E6964207C7C2066696C7465723B0A0A202076617220636F6E7461696E6572203D20746869732E5F656C656D656E74735B69645D3B0A0A2020696620287365636F6E6461727929';
wwv_flow_imp.g_varchar2_table(3233) := '207B0A20202020636F6E7461696E65722E7365636F6E64617279476678203D206766783B0A20207D20656C7365207B0A20202020636F6E7461696E65722E676678203D206766783B0A20207D0A0A20206966202867667829207B0A2020202028302C7469';
wwv_flow_imp.g_varchar2_table(3234) := '6E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6174747229286766782C20454C454D454E545F49442C206964293B0A20207D0A0A202072657475726E206766783B0A7D3B0A0A2F2A2A0A202A20476574207468';
wwv_flow_imp.g_varchar2_table(3235) := '6520656C656D656E7420776974682074686520676976656E204944206F722067726170686963616C20726570726573656E746174696F6E2E0A202A0A202A20406578616D706C650A202A0A202A206060606A6176617363726970740A202A20656C656D65';
wwv_flow_imp.g_varchar2_table(3236) := '6E7452656769737472792E6765742827536F6D65456C656D656E7449645F3127293B0A202A0A202A20656C656D656E7452656769737472792E67657428676678293B0A202A206060600A202A0A202A2040706172616D207B737472696E677C535647456C';
wwv_flow_imp.g_varchar2_table(3237) := '656D656E747D2066696C7465722054686520656C656D656E7473204944206F722067726170686963616C20726570726573656E746174696F6E2E0A202A0A202A204072657475726E207B456C656D656E744C696B657C756E646566696E65647D20546865';
wwv_flow_imp.g_varchar2_table(3238) := '20656C656D656E742E0A202A2F0A456C656D656E7452656769737472792E70726F746F747970652E676574203D2066756E6374696F6E2866696C74657229207B0A20207661722069643B0A0A202069662028747970656F662066696C746572203D3D3D20';
wwv_flow_imp.g_varchar2_table(3239) := '27737472696E672729207B0A202020206964203D2066696C7465723B0A20207D20656C7365207B0A202020206964203D2066696C7465722026262028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E';
wwv_flow_imp.g_varchar2_table(3240) := '61747472292866696C7465722C20454C454D454E545F4944293B0A20207D0A0A202076617220636F6E7461696E6572203D20746869732E5F656C656D656E74735B69645D3B0A202072657475726E20636F6E7461696E657220262620636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(3241) := '722E656C656D656E743B0A7D3B0A0A2F2A2A0A202A2052657475726E20616C6C20656C656D656E74732074686174206D61746368206120676976656E2066696C7465722066756E6374696F6E2E0A202A0A202A2040706172616D207B456C656D656E7452';
wwv_flow_imp.g_varchar2_table(3242) := '6567697374727946696C74657243616C6C6261636B7D20666E205468652066696C7465722066756E6374696F6E2E0A202A0A202A204072657475726E207B456C656D656E744C696B655B5D7D20546865206D61746368696E6720656C656D656E74732E0A';
wwv_flow_imp.g_varchar2_table(3243) := '202A2F0A456C656D656E7452656769737472792E70726F746F747970652E66696C746572203D2066756E6374696F6E28666E29207B0A0A20207661722066696C7465726564203D205B5D3B0A0A2020746869732E666F72456163682866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3244) := '28656C656D656E742C2067667829207B0A2020202069662028666E28656C656D656E742C206766782929207B0A20202020202066696C74657265642E7075736828656C656D656E74293B0A202020207D0A20207D293B0A0A202072657475726E2066696C';
wwv_flow_imp.g_varchar2_table(3245) := '74657265643B0A7D3B0A0A2F2A2A0A202A2052657475726E2074686520666972737420656C656D656E742074686174206D6174636865732074686520676976656E2066696C7465722066756E6374696F6E2E0A202A0A202A2040706172616D207B456C65';
wwv_flow_imp.g_varchar2_table(3246) := '6D656E74526567697374727946696C74657243616C6C6261636B7D20666E205468652066696C7465722066756E6374696F6E2E0A202A0A202A204072657475726E207B456C656D656E744C696B657C756E646566696E65647D20546865206D6174636869';
wwv_flow_imp.g_varchar2_table(3247) := '6E6720656C656D656E742E0A202A2F0A456C656D656E7452656769737472792E70726F746F747970652E66696E64203D2066756E6374696F6E28666E29207B0A2020766172206D6170203D20746869732E5F656C656D656E74732C0A2020202020206B65';
wwv_flow_imp.g_varchar2_table(3248) := '7973203D204F626A6563742E6B657973286D6170293B0A0A2020666F7220287661722069203D20303B2069203C206B6579732E6C656E6774683B20692B2B29207B0A20202020766172206964203D206B6579735B695D2C0A2020202020202020636F6E74';
wwv_flow_imp.g_varchar2_table(3249) := '61696E6572203D206D61705B69645D2C0A2020202020202020656C656D656E74203D20636F6E7461696E65722E656C656D656E742C0A2020202020202020676678203D20636F6E7461696E65722E6766783B0A0A2020202069662028666E28656C656D65';
wwv_flow_imp.g_varchar2_table(3250) := '6E742C206766782929207B0A20202020202072657475726E20656C656D656E743B0A202020207D0A20207D0A7D3B0A0A2F2A2A0A202A2047657420616C6C20656C656D656E74732E0A202A0A202A204072657475726E207B456C656D656E744C696B655B';
wwv_flow_imp.g_varchar2_table(3251) := '5D7D20416C6C20656C656D656E74732E0A202A2F0A456C656D656E7452656769737472792E70726F746F747970652E676574416C6C203D2066756E6374696F6E2829207B0A202072657475726E20746869732E66696C7465722866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(3252) := '29207B2072657475726E20653B207D293B0A7D3B0A0A2F2A2A0A202A2045786563757465206120676976656E2066756E6374696F6E20666F72206561636820656C656D656E742E0A202A0A202A2040706172616D207B456C656D656E7452656769737472';
wwv_flow_imp.g_varchar2_table(3253) := '79466F724561636843616C6C6261636B7D20666E205468652066756E6374696F6E20746F20657865637574652E0A202A2F0A456C656D656E7452656769737472792E70726F746F747970652E666F7245616368203D2066756E6374696F6E28666E29207B';
wwv_flow_imp.g_varchar2_table(3254) := '0A0A2020766172206D6170203D20746869732E5F656C656D656E74733B0A0A20204F626A6563742E6B657973286D6170292E666F72456163682866756E6374696F6E28696429207B0A2020202076617220636F6E7461696E6572203D206D61705B69645D';
wwv_flow_imp.g_varchar2_table(3255) := '2C0A2020202020202020656C656D656E74203D20636F6E7461696E65722E656C656D656E742C0A2020202020202020676678203D20636F6E7461696E65722E6766783B0A0A2020202072657475726E20666E28656C656D656E742C20676678293B0A2020';
wwv_flow_imp.g_varchar2_table(3256) := '7D293B0A7D3B0A0A2F2A2A0A202A2052657475726E207468652067726170686963616C20726570726573656E746174696F6E206F6620616E20656C656D656E742E0A202A0A202A20406578616D706C650A202A0A202A206060606A617661736372697074';
wwv_flow_imp.g_varchar2_table(3257) := '0A202A20656C656D656E7452656769737472792E67657447726170686963732827536F6D65456C656D656E7449645F3127293B0A202A0A202A20656C656D656E7452656769737472792E676574477261706869637328726F6F74456C656D656E74293B20';
wwv_flow_imp.g_varchar2_table(3258) := '2F2F203C67202E2E2E3E0A202A0A202A20656C656D656E7452656769737472792E676574477261706869637328726F6F74456C656D656E742C2074727565293B202F2F203C737667202E2E2E3E0A202A206060600A202A0A202A2040706172616D207B45';
wwv_flow_imp.g_varchar2_table(3259) := '6C656D656E744C696B657C737472696E677D2066696C7465722054686520656C656D656E74206F72206974732049442E0A202A2040706172616D207B626F6F6C65616E7D205B7365636F6E646172793D66616C73655D205768657468657220746F207265';
wwv_flow_imp.g_varchar2_table(3260) := '7475726E20746865207365636F6E646172792067726170686963616C20726570726573656E746174696F6E2E0A202A0A202A204072657475726E207B535647456C656D656E747D205468652067726170686963616C20726570726573656E746174696F6E';
wwv_flow_imp.g_varchar2_table(3261) := '2E0A202A2F0A456C656D656E7452656769737472792E70726F746F747970652E6765744772617068696373203D2066756E6374696F6E2866696C7465722C207365636F6E6461727929207B0A2020766172206964203D2066696C7465722E6964207C7C20';
wwv_flow_imp.g_varchar2_table(3262) := '66696C7465723B0A0A202076617220636F6E7461696E6572203D20746869732E5F656C656D656E74735B69645D3B0A202072657475726E20636F6E7461696E657220262620287365636F6E64617279203F20636F6E7461696E65722E7365636F6E646172';
wwv_flow_imp.g_varchar2_table(3263) := '79476678203A20636F6E7461696E65722E676678293B0A7D3B0A0A2F2A2A0A202A2056616C696461746520616E20494420616E64207468726F7720616E206572726F7220696620696E76616C69642E0A202A0A202A2040706172616D207B737472696E67';
wwv_flow_imp.g_varchar2_table(3264) := '7D2069640A202A0A202A20407468726F7773207B4572726F727D204572726F7220696E6469636174696E6720746861742074686520494420697320696E76616C6964206F7220616C72656164792061737369676E65642E0A202A2F0A456C656D656E7452';
wwv_flow_imp.g_varchar2_table(3265) := '656769737472792E70726F746F747970652E5F76616C69646174654964203D2066756E6374696F6E28696429207B0A20206966202821696429207B0A202020207468726F77206E6577204572726F722827656C656D656E74206D75737420686176652061';
wwv_flow_imp.g_varchar2_table(3266) := '6E20696427293B0A20207D0A0A202069662028746869732E5F656C656D656E74735B69645D29207B0A202020207468726F77206E6577204572726F722827656C656D656E7420776974682069642027202B206964202B202720616C726561647920616464';
wwv_flow_imp.g_varchar2_table(3267) := '656427293B0A20207D0A7D3B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F4576656E744275732E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3268) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F4576656E744275732E6A73202A2A2A';
wwv_flow_imp.g_varchar2_table(3269) := '210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F77656270';
wwv_flow_imp.g_varchar2_table(3270) := '61636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E7920657870';
wwv_flow_imp.g_varchar2_table(3271) := '6F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64';
wwv_flow_imp.g_varchar2_table(3272) := '696E67202A2F204576656E74427573290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C45';
wwv_flow_imp.g_varchar2_table(3273) := '5F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A0A0A76617220464E5F5245';
wwv_flow_imp.g_varchar2_table(3274) := '46203D20275F5F666E273B0A0A7661722044454641554C545F5052494F52495459203D20313030303B0A0A76617220736C696365203D2041727261792E70726F746F747970652E736C6963653B0A0A2F2A2A0A202A204074797065646566207B207B0A20';
wwv_flow_imp.g_varchar2_table(3275) := '2A20202073746F7050726F7061676174696F6E28293A20766F69643B0A202A20202070726576656E7444656661756C7428293A20766F69643B0A202A20202063616E63656C427562626C653A20626F6F6C65616E3B0A202A20202064656661756C745072';
wwv_flow_imp.g_varchar2_table(3276) := '6576656E7465643A20626F6F6C65616E3B0A202A20202072657475726E56616C75653A20616E793B0A202A207D207D204576656E740A202A2F0A0A2F2A2A0A202A204074656D706C61746520450A202A0A202A204074797065646566207B20286576656E';
wwv_flow_imp.g_varchar2_table(3277) := '743A20452026204576656E742C202E2E2E616E7929203D3E20616E79207D204576656E744275734576656E7443616C6C6261636B0A202A2F0A0A2F2A2A0A202A204074797065646566207B207B0A202A20207072696F726974793A206E756D6265723B0A';
wwv_flow_imp.g_varchar2_table(3278) := '202A20206E6578743A204576656E744275734C697374656E6572207C206E756C6C3B0A202A202063616C6C6261636B3A204576656E744275734576656E7443616C6C6261636B3C616E793E3B0A202A207D207D204576656E744275734C697374656E6572';
wwv_flow_imp.g_varchar2_table(3279) := '0A202A2F0A0A2F2A2A0A202A20412067656E6572616C20707572706F7365206576656E74206275732E0A202A0A202A205468697320636F6D706F6E656E74206973207573656420746F20636F6D6D756E6963617465206163726F73732061206469616772';
wwv_flow_imp.g_varchar2_table(3280) := '616D20696E7374616E63652E0A202A204F74686572207061727473206F662061206469616772616D2063616E2075736520697420746F206C697374656E20746F20616E642062726F616463617374206576656E74732E0A202A0A202A0A202A2023232052';
wwv_flow_imp.g_varchar2_table(3281) := '65676973746572696E6720666F72204576656E74730A202A0A202A20546865206576656E74206275732070726F766964657320746865207B406C696E6B204576656E74427573236F6E7D20616E64207B406C696E6B204576656E74427573236F6E63657D';
wwv_flow_imp.g_varchar2_table(3282) := '0A202A206D6574686F647320746F20726567697374657220666F72206576656E74732E207B406C696E6B204576656E74427573236F66667D2063616E206265207573656420746F0A202A2072656D6F7665206576656E7420726567697374726174696F6E';
wwv_flow_imp.g_varchar2_table(3283) := '732E204C697374656E657273207265636569766520616E20696E7374616E6365206F66207B406C696E6B204576656E747D0A202A2061732074686520666972737420617267756D656E742E20497420616C6C6F7773207468656D20746F20686F6F6B2069';
wwv_flow_imp.g_varchar2_table(3284) := '6E746F20746865206576656E7420657865637574696F6E2E0A202A0A202A206060606A6176617363726970740A202A0A202A202F2F206C697374656E20666F72206576656E740A202A206576656E744275732E6F6E2827666F6F272C2066756E6374696F';
wwv_flow_imp.g_varchar2_table(3285) := '6E286576656E7429207B0A202A0A202A2020202F2F20616363657373206576656E7420747970650A202A2020206576656E742E747970653B202F2F2027666F6F270A202A0A202A2020202F2F2073746F702070726F7061676174696F6E20746F206F7468';
wwv_flow_imp.g_varchar2_table(3286) := '6572206C697374656E6572730A202A2020206576656E742E73746F7050726F7061676174696F6E28293B0A202A0A202A2020202F2F2070726576656E74206576656E742064656661756C740A202A2020206576656E742E70726576656E7444656661756C';
wwv_flow_imp.g_varchar2_table(3287) := '7428293B0A202A207D293B0A202A0A202A202F2F206C697374656E20666F72206576656E74207769746820637573746F6D207061796C6F61640A202A206576656E744275732E6F6E2827626172272C2066756E6374696F6E286576656E742C207061796C';
wwv_flow_imp.g_varchar2_table(3288) := '6F616429207B0A202A202020636F6E736F6C652E6C6F67287061796C6F6164293B0A202A207D293B0A202A0A202A202F2F206C697374656E20666F72206576656E742072657475726E696E672076616C75650A202A206576656E744275732E6F6E282766';
wwv_flow_imp.g_varchar2_table(3289) := '6F6F626172272C2066756E6374696F6E286576656E7429207B0A202A0A202A2020202F2F2073746F70206576656E742070726F7061676174696F6E202B2070726576656E742064656661756C740A202A20202072657475726E2066616C73653B0A202A0A';
wwv_flow_imp.g_varchar2_table(3290) := '202A2020202F2F2073746F70206576656E742070726F7061676174696F6E202B2072657475726E20637573746F6D20726573756C740A202A20202072657475726E207B0A202A2020202020636F6D706C65783A20276C697374656E696E6720726573756C';
wwv_flow_imp.g_varchar2_table(3291) := '74270A202A2020207D3B0A202A207D293B0A202A0A202A0A202A202F2F206C697374656E207769746820637573746F6D207072696F72697479202864656661756C743D313030302C2068696768657220697320626574746572290A202A206576656E7442';
wwv_flow_imp.g_varchar2_table(3292) := '75732E6F6E28277072696F72697479666F6F272C20313530302C2066756E6374696F6E286576656E7429207B0A202A202020636F6E736F6C652E6C6F672827696E766F6B65642066697273742127293B0A202A207D293B0A202A0A202A0A202A202F2F20';
wwv_flow_imp.g_varchar2_table(3293) := '6C697374656E20666F72206576656E7420616E6420706173732074686520636F6E746578742028607468697360290A202A206576656E744275732E6F6E2827666F6F626172272C2066756E6374696F6E286576656E7429207B0A202A202020746869732E';
wwv_flow_imp.g_varchar2_table(3294) := '666F6F28293B0A202A207D2C2074686973293B0A202A206060600A202A0A202A0A202A20232320456D697474696E67204576656E74730A202A0A202A204576656E74732063616E20626520656D69747465642076696120746865206576656E7420627573';
wwv_flow_imp.g_varchar2_table(3295) := '207573696E67207B406C696E6B204576656E7442757323666972657D2E0A202A0A202A206060606A6176617363726970740A202A0A202A202F2F2066616C736520696E646963617465732074686174207468652064656661756C7420616374696F6E0A20';
wwv_flow_imp.g_varchar2_table(3296) := '2A202F2F207761732070726576656E746564206279206C697374656E6572730A202A20696620286576656E744275732E666972652827666F6F2729203D3D3D2066616C736529207B0A202A202020636F6E736F6C652E6C6F67282764656661756C742068';
wwv_flow_imp.g_varchar2_table(3297) := '6173206265656E2070726576656E7465642127293B0A202A207D3B0A202A0A202A0A202A202F2F20637573746F6D2061726773202B2072657475726E2076616C7565206C697374656E65720A202A206576656E744275732E6F6E282773756D272C206675';
wwv_flow_imp.g_varchar2_table(3298) := '6E6374696F6E286576656E742C20612C206229207B0A202A20202072657475726E2061202B20623B0A202A207D293B0A202A0A202A202F2F20796F752063616E207061737320637573746F6D20617267756D656E7473202B207265747269657665207265';
wwv_flow_imp.g_varchar2_table(3299) := '73756C742076616C7565732E0A202A207661722073756D203D206576656E744275732E66697265282773756D272C20312C2032293B0A202A20636F6E736F6C652E6C6F672873756D293B202F2F20330A202A206060600A202A0A202A204074656D706C61';
wwv_flow_imp.g_varchar2_table(3300) := '7465205B4576656E744D61703D6E756C6C5D0A202A2F0A66756E6374696F6E204576656E744275732829207B0A0A20202F2A2A0A2020202A204074797065207B205265636F72643C737472696E672C204576656E744275734C697374656E65723E207D0A';
wwv_flow_imp.g_varchar2_table(3301) := '2020202A2F0A2020746869732E5F6C697374656E657273203D207B7D3B0A0A20202F2F20636C65616E7570206F6E2064657374726F79206F6E206C6F77657374207072696F7269747920746F20616C6C6F770A20202F2F206D6573736167652070617373';
wwv_flow_imp.g_varchar2_table(3302) := '696E6720756E74696C207468652062697474657220656E640A2020746869732E6F6E28276469616772616D2E64657374726F79272C20312C20746869732E5F64657374726F792C2074686973293B0A7D0A0A2F2A2A0A202A20406F7665726C6F72640A20';
wwv_flow_imp.g_varchar2_table(3303) := '2A0A202A20526567697374657220616E206576656E74206C697374656E657220666F72206576656E747320776974682074686520676976656E206E616D652E0A202A0A202A205468652063616C6C6261636B2077696C6C20626520696E766F6B65642077';
wwv_flow_imp.g_varchar2_table(3304) := '69746820606576656E742C202E2E2E6164646974696F6E616C417267756D656E7473600A202A20746861742068617665206265656E2070617373656420746F207B406C696E6B204576656E7442757323666972657D2E0A202A0A202A2052657475726E69';
wwv_flow_imp.g_varchar2_table(3305) := '6E672066616C73652066726F6D2061206C697374656E65722077696C6C2070726576656E7420746865206576656E74732064656661756C7420616374696F6E0A202A2028696620616E7920697320737065636966696564292E20546F2073746F7020616E';
wwv_flow_imp.g_varchar2_table(3306) := '206576656E742066726F6D206265696E672070726F636573736564206675727468657220696E0A202A206F74686572206C697374656E6572732065786563757465207B406C696E6B204576656E742373746F7050726F7061676174696F6E7D2E0A202A0A';
wwv_flow_imp.g_varchar2_table(3307) := '202A2052657475726E696E6720616E797468696E67206275742060756E646566696E6564602066726F6D2061206C697374656E65722077696C6C2073746F7020746865206C697374656E65722070726F7061676174696F6E2E0A202A0A202A204074656D';
wwv_flow_imp.g_varchar2_table(3308) := '706C61746520540A202A0A202A2040706172616D207B737472696E677C737472696E675B5D7D206576656E747320746F2073756273637269626520746F0A202A2040706172616D207B6E756D6265727D205B7072696F726974793D313030305D206C6973';
wwv_flow_imp.g_varchar2_table(3309) := '74656E207072696F726974790A202A2040706172616D207B4576656E744275734576656E7443616C6C6261636B3C543E7D2063616C6C6261636B0A202A2040706172616D207B616E797D205B746861745D2063616C6C6261636B20636F6E746578740A20';
wwv_flow_imp.g_varchar2_table(3310) := '2A2F0A2F2A2A0A202A20526567697374657220616E206576656E74206C697374656E657220666F72206576656E747320776974682074686520676976656E206E616D652E0A202A0A202A205468652063616C6C6261636B2077696C6C20626520696E766F';
wwv_flow_imp.g_varchar2_table(3311) := '6B6564207769746820606576656E742C202E2E2E6164646974696F6E616C417267756D656E7473600A202A20746861742068617665206265656E2070617373656420746F207B406C696E6B204576656E7442757323666972657D2E0A202A0A202A205265';
wwv_flow_imp.g_varchar2_table(3312) := '7475726E696E672066616C73652066726F6D2061206C697374656E65722077696C6C2070726576656E7420746865206576656E74732064656661756C7420616374696F6E0A202A2028696620616E7920697320737065636966696564292E20546F207374';
wwv_flow_imp.g_varchar2_table(3313) := '6F7020616E206576656E742066726F6D206265696E672070726F636573736564206675727468657220696E0A202A206F74686572206C697374656E6572732065786563757465207B406C696E6B204576656E742373746F7050726F7061676174696F6E7D';
wwv_flow_imp.g_varchar2_table(3314) := '2E0A202A0A202A2052657475726E696E6720616E797468696E67206275742060756E646566696E6564602066726F6D2061206C697374656E65722077696C6C2073746F7020746865206C697374656E65722070726F7061676174696F6E2E0A202A0A202A';
wwv_flow_imp.g_varchar2_table(3315) := '204074656D706C617465207B6B65796F66204576656E744D61707D204576656E744E616D650A202A0A202A2040706172616D207B4576656E744E616D657D206576656E747320746F2073756273637269626520746F0A202A2040706172616D207B6E756D';
wwv_flow_imp.g_varchar2_table(3316) := '6265727D205B7072696F726974793D313030305D206C697374656E207072696F726974790A202A2040706172616D207B4576656E744275734576656E7443616C6C6261636B3C4576656E744D61705B4576656E744E616D655D3E7D2063616C6C6261636B';
wwv_flow_imp.g_varchar2_table(3317) := '0A202A2040706172616D207B616E797D205B746861745D2063616C6C6261636B20636F6E746578740A202A2F0A4576656E744275732E70726F746F747970652E6F6E203D2066756E6374696F6E286576656E74732C207072696F726974792C2063616C6C';
wwv_flow_imp.g_varchar2_table(3318) := '6261636B2C207468617429207B0A0A20206576656E7473203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6973417272617929286576656E747329203F206576656E7473203A205B20657665';
wwv_flow_imp.g_varchar2_table(3319) := '6E7473205D3B0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E697346756E6374696F6E29287072696F726974792929207B0A2020202074686174203D2063616C6C6261636B3B';
wwv_flow_imp.g_varchar2_table(3320) := '0A2020202063616C6C6261636B203D207072696F726974793B0A202020207072696F72697479203D2044454641554C545F5052494F524954593B0A20207D0A0A2020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(3321) := '5F4D4F44554C455F305F5F2E69734E756D62657229287072696F726974792929207B0A202020207468726F77206E6577204572726F7228277072696F72697479206D7573742062652061206E756D62657227293B0A20207D0A0A20207661722061637475';
wwv_flow_imp.g_varchar2_table(3322) := '616C43616C6C6261636B203D2063616C6C6261636B3B0A0A2020696620287468617429207B0A2020202061637475616C43616C6C6261636B203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E';
wwv_flow_imp.g_varchar2_table(3323) := '62696E64292863616C6C6261636B2C2074686174293B0A0A202020202F2F206D616B6520737572652077652072656D656D62657220616E64206172652061626C6520746F2072656D6F76650A202020202F2F20626F756E642063616C6C6261636B732076';
wwv_flow_imp.g_varchar2_table(3324) := '6961207B406C696E6B20236F66667D207573696E6720746865206F726967696E616C0A202020202F2F2063616C6C6261636B0A2020202061637475616C43616C6C6261636B5B464E5F5245465D203D2063616C6C6261636B5B464E5F5245465D207C7C20';
wwv_flow_imp.g_varchar2_table(3325) := '63616C6C6261636B3B0A20207D0A0A20207661722073656C66203D20746869733B0A0A20206576656E74732E666F72456163682866756E6374696F6E286529207B0A2020202073656C662E5F6164644C697374656E657228652C207B0A20202020202070';
wwv_flow_imp.g_varchar2_table(3326) := '72696F726974793A207072696F726974792C0A20202020202063616C6C6261636B3A2061637475616C43616C6C6261636B2C0A2020202020206E6578743A206E756C6C0A202020207D293B0A20207D293B0A7D3B0A0A2F2A2A0A202A20406F7665726C6F';
wwv_flow_imp.g_varchar2_table(3327) := '72640A202A0A202A20526567697374657220616E206576656E74206C697374656E657220746861742069732063616C6C6564206F6E6C79206F6E63652E0A202A0A202A204074656D706C61746520540A202A0A202A2040706172616D207B737472696E67';
wwv_flow_imp.g_varchar2_table(3328) := '7C737472696E675B5D7D206576656E747320746F2073756273637269626520746F0A202A2040706172616D207B6E756D6265727D205B7072696F726974793D313030305D20746865206C697374656E207072696F726974790A202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(3329) := '4576656E744275734576656E7443616C6C6261636B3C543E7D2063616C6C6261636B0A202A2040706172616D207B616E797D205B746861745D2063616C6C6261636B20636F6E746578740A202A2F0A2F2A2A0A202A20526567697374657220616E206576';
wwv_flow_imp.g_varchar2_table(3330) := '656E74206C697374656E657220746861742069732063616C6C6564206F6E6C79206F6E63652E0A202A0A202A204074656D706C617465207B6B65796F66204576656E744D61707D204576656E744E616D650A202A0A202A2040706172616D207B4576656E';
wwv_flow_imp.g_varchar2_table(3331) := '744E616D657D206576656E747320746F2073756273637269626520746F0A202A2040706172616D207B6E756D6265727D205B7072696F726974793D313030305D206C697374656E207072696F726974790A202A2040706172616D207B4576656E74427573';
wwv_flow_imp.g_varchar2_table(3332) := '4576656E7443616C6C6261636B3C4576656E744D61705B4576656E744E616D655D3E7D2063616C6C6261636B0A202A2040706172616D207B616E797D205B746861745D2063616C6C6261636B20636F6E746578740A202A2F0A4576656E744275732E7072';
wwv_flow_imp.g_varchar2_table(3333) := '6F746F747970652E6F6E6365203D2066756E6374696F6E286576656E74732C207072696F726974792C2063616C6C6261636B2C207468617429207B0A20207661722073656C66203D20746869733B0A0A20206966202828302C6D696E5F646173685F5F57';
wwv_flow_imp.g_varchar2_table(3334) := '45425041434B5F494D504F525445445F4D4F44554C455F305F5F2E697346756E6374696F6E29287072696F726974792929207B0A2020202074686174203D2063616C6C6261636B3B0A2020202063616C6C6261636B203D207072696F726974793B0A2020';
wwv_flow_imp.g_varchar2_table(3335) := '20207072696F72697479203D2044454641554C545F5052494F524954593B0A20207D0A0A2020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734E756D62657229287072696F7269';
wwv_flow_imp.g_varchar2_table(3336) := '74792929207B0A202020207468726F77206E6577204572726F7228277072696F72697479206D7573742062652061206E756D62657227293B0A20207D0A0A202066756E6374696F6E207772617070656443616C6C6261636B2829207B0A20202020777261';
wwv_flow_imp.g_varchar2_table(3337) := '7070656443616C6C6261636B2E5F5F6973546F6D62203D20747275653B0A0A2020202076617220726573756C74203D2063616C6C6261636B2E6170706C7928746861742C20617267756D656E7473293B0A0A2020202073656C662E6F6666286576656E74';
wwv_flow_imp.g_varchar2_table(3338) := '732C207772617070656443616C6C6261636B293B0A0A2020202072657475726E20726573756C743B0A20207D0A0A20202F2F206D616B6520737572652077652072656D656D62657220616E64206172652061626C6520746F2072656D6F76650A20202F2F';
wwv_flow_imp.g_varchar2_table(3339) := '20626F756E642063616C6C6261636B7320766961207B406C696E6B20236F66667D207573696E6720746865206F726967696E616C0A20202F2F2063616C6C6261636B0A20207772617070656443616C6C6261636B5B464E5F5245465D203D2063616C6C62';
wwv_flow_imp.g_varchar2_table(3340) := '61636B3B0A0A2020746869732E6F6E286576656E74732C207072696F726974792C207772617070656443616C6C6261636B293B0A7D3B0A0A0A2F2A2A0A202A2052656D6F766573206576656E74206C697374656E657273206279206576656E7420616E64';
wwv_flow_imp.g_varchar2_table(3341) := '2063616C6C6261636B2E0A202A0A202A204966206E6F2063616C6C6261636B20697320676976656E2C20616C6C206C697374656E65727320666F72206120676976656E206576656E74206E616D6520617265206265696E672072656D6F7665642E0A202A';
wwv_flow_imp.g_varchar2_table(3342) := '0A202A2040706172616D207B737472696E677C737472696E675B5D7D206576656E74730A202A2040706172616D207B4576656E744275734576656E7443616C6C6261636B7D205B63616C6C6261636B5D0A202A2F0A4576656E744275732E70726F746F74';
wwv_flow_imp.g_varchar2_table(3343) := '7970652E6F6666203D2066756E6374696F6E286576656E74732C2063616C6C6261636B29207B0A0A20206576656E7473203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6973417272617929';
wwv_flow_imp.g_varchar2_table(3344) := '286576656E747329203F206576656E7473203A205B206576656E7473205D3B0A0A20207661722073656C66203D20746869733B0A0A20206576656E74732E666F72456163682866756E6374696F6E286576656E7429207B0A2020202073656C662E5F7265';
wwv_flow_imp.g_varchar2_table(3345) := '6D6F76654C697374656E6572286576656E742C2063616C6C6261636B293B0A20207D293B0A0A7D3B0A0A0A2F2A2A0A202A2043726561746520616E206576656E74207265636F676E697A656420626520746865206576656E74206275732E0A202A0A202A';
wwv_flow_imp.g_varchar2_table(3346) := '2040706172616D207B4F626A6563747D2064617461204576656E7420646174612E0A202A0A202A204072657475726E207B4576656E747D20416E206576656E7420746861742077696C6C206265207265636F676E697A656420627920746865206576656E';
wwv_flow_imp.g_varchar2_table(3347) := '74206275732E0A202A2F0A4576656E744275732E70726F746F747970652E6372656174654576656E74203D2066756E6374696F6E286461746129207B0A2020766172206576656E74203D206E657720496E7465726E616C4576656E7428293B0A0A202065';
wwv_flow_imp.g_varchar2_table(3348) := '76656E742E696E69742864617461293B0A0A202072657475726E206576656E743B0A7D3B0A0A0A2F2A2A0A202A20466972657320616E206576656E742E0A202A0A202A20406578616D706C650A202A0A202A206060606A6176617363726970740A202A20';
wwv_flow_imp.g_varchar2_table(3349) := '2F2F2066697265206576656E74206279206E616D650A202A206576656E74732E666972652827666F6F27293B0A202A0A202A202F2F2066697265206576656E74206F626A6563742077697468206E657374656420747970650A202A20766172206576656E';
wwv_flow_imp.g_varchar2_table(3350) := '74203D207B20747970653A2027666F6F27207D3B0A202A206576656E74732E66697265286576656E74293B0A202A0A202A202F2F2066697265206576656E742077697468206578706C6963697420747970650A202A20766172206576656E74203D207B20';
wwv_flow_imp.g_varchar2_table(3351) := '783A2031302C20793A203230207D3B0A202A206576656E74732E666972652827656C656D656E742E6D6F766564272C206576656E74293B0A202A0A202A202F2F2070617373206164646974696F6E616C20617267756D656E747320746F20746865206576';
wwv_flow_imp.g_varchar2_table(3352) := '656E740A202A206576656E74732E6F6E2827666F6F272C2066756E6374696F6E286576656E742C2062617229207B0A202A202020616C65727428626172293B0A202A207D293B0A202A0A202A206576656E74732E66697265287B20747970653A2027666F';
wwv_flow_imp.g_varchar2_table(3353) := '6F27207D2C20274920616D206261722127293B0A202A206060600A202A0A202A2040706172616D207B737472696E677D205B747970655D206576656E7420747970650A202A2040706172616D207B4F626A6563747D205B646174615D206576656E74206F';
wwv_flow_imp.g_varchar2_table(3354) := '72206576656E7420646174610A202A2040706172616D207B2E2E2E616E797D205B617267735D206164646974696F6E616C20617267756D656E7473207468652063616C6C6261636B2077696C6C2062652063616C6C656420776974682E0A202A0A202A20';
wwv_flow_imp.g_varchar2_table(3355) := '4072657475726E207B616E797D205468652072657475726E2076616C75652E2057696C6C2062652073657420746F206066616C736560206966207468652064656661756C74207761732070726576656E7465642E0A202A2F0A4576656E744275732E7072';
wwv_flow_imp.g_varchar2_table(3356) := '6F746F747970652E66697265203D2066756E6374696F6E28747970652C206461746129207B0A2020766172206576656E742C0A20202020202066697273744C697374656E65722C0A20202020202072657475726E56616C75652C0A202020202020617267';
wwv_flow_imp.g_varchar2_table(3357) := '733B0A0A202061726773203D20736C6963652E63616C6C28617267756D656E7473293B0A0A202069662028747970656F662074797065203D3D3D20276F626A6563742729207B0A2020202064617461203D20747970653B0A2020202074797065203D2064';
wwv_flow_imp.g_varchar2_table(3358) := '6174612E747970653B0A20207D0A0A202069662028217479706529207B0A202020207468726F77206E6577204572726F7228276E6F206576656E7420747970652073706563696669656427293B0A20207D0A0A202066697273744C697374656E6572203D';
wwv_flow_imp.g_varchar2_table(3359) := '20746869732E5F6C697374656E6572735B747970655D3B0A0A2020696620282166697273744C697374656E657229207B0A2020202072657475726E3B0A20207D0A0A20202F2F207765206D616B652073757265207765206669726520696E7374616E6365';
wwv_flow_imp.g_varchar2_table(3360) := '73206F66206F757220686F6D65206D6164650A20202F2F206576656E747320686572652E2057652077726170207468656D206F6E6C79206F6E63652C2074686F7567680A2020696620286461746120696E7374616E63656F6620496E7465726E616C4576';
wwv_flow_imp.g_varchar2_table(3361) := '656E7429207B0A0A202020202F2F207765206172652066696E652C20776520616C72656164206861766520616E206576656E740A202020206576656E74203D20646174613B0A20207D20656C7365207B0A202020206576656E74203D20746869732E6372';
wwv_flow_imp.g_varchar2_table(3362) := '656174654576656E742864617461293B0A20207D0A0A20202F2F20656E73757265207765207061737320746865206576656E742061732074686520666972737420706172616D657465720A2020617267735B305D203D206576656E743B0A0A20202F2F20';
wwv_flow_imp.g_varchar2_table(3363) := '6F726967696E616C206576656E7420747970652028696E20636173652077652064656C6567617465290A2020766172206F726967696E616C54797065203D206576656E742E747970653B0A0A20202F2F20757064617465206576656E7420747970652062';
wwv_flow_imp.g_varchar2_table(3364) := '65666F72652064656C65676174696F6E0A2020696620287479706520213D3D206F726967696E616C5479706529207B0A202020206576656E742E74797065203D20747970653B0A20207D0A0A2020747279207B0A2020202072657475726E56616C756520';
wwv_flow_imp.g_varchar2_table(3365) := '3D20746869732E5F696E766F6B654C697374656E657273286576656E742C20617267732C2066697273744C697374656E6572293B0A20207D2066696E616C6C79207B0A0A202020202F2F207265736574206576656E742074797065206166746572206465';
wwv_flow_imp.g_varchar2_table(3366) := '6C65676174696F6E0A20202020696620287479706520213D3D206F726967696E616C5479706529207B0A2020202020206576656E742E74797065203D206F726967696E616C547970653B0A202020207D0A20207D0A0A20202F2F20736574207468652072';
wwv_flow_imp.g_varchar2_table(3367) := '657475726E2076616C756520746F2066616C736520696620746865206576656E742064656661756C740A20202F2F20676F742070726576656E74656420616E64206E6F206F746865722072657475726E2076616C7565206578697374730A202069662028';
wwv_flow_imp.g_varchar2_table(3368) := '72657475726E56616C7565203D3D3D20756E646566696E6564202626206576656E742E64656661756C7450726576656E74656429207B0A2020202072657475726E56616C7565203D2066616C73653B0A20207D0A0A202072657475726E2072657475726E';
wwv_flow_imp.g_varchar2_table(3369) := '56616C75653B0A7D3B0A0A2F2A2A0A202A2048616E646C6520616E206572726F7220627920666972696E6720616E206576656E742E0A202A0A202A2040706172616D207B4572726F727D206572726F7220546865206572726F7220746F2062652068616E';
wwv_flow_imp.g_varchar2_table(3370) := '646C65642E0A202A0A202A204072657475726E207B626F6F6C65616E7D205768657468657220746865206572726F72207761732068616E646C65642E0A202A2F0A4576656E744275732E70726F746F747970652E68616E646C654572726F72203D206675';
wwv_flow_imp.g_varchar2_table(3371) := '6E6374696F6E286572726F7229207B0A202072657475726E20746869732E6669726528276572726F72272C207B206572726F723A206572726F72207D29203D3D3D2066616C73653B0A7D3B0A0A0A4576656E744275732E70726F746F747970652E5F6465';
wwv_flow_imp.g_varchar2_table(3372) := '7374726F79203D2066756E6374696F6E2829207B0A2020746869732E5F6C697374656E657273203D207B7D3B0A7D3B0A0A2F2A2A0A202A2040706172616D207B4576656E747D206576656E740A202A2040706172616D207B616E795B5D7D20617267730A';
wwv_flow_imp.g_varchar2_table(3373) := '202A2040706172616D207B4576656E744275734C697374656E65727D206C697374656E65720A202A0A202A204072657475726E207B616E797D0A202A2F0A4576656E744275732E70726F746F747970652E5F696E766F6B654C697374656E657273203D20';
wwv_flow_imp.g_varchar2_table(3374) := '66756E6374696F6E286576656E742C20617267732C206C697374656E657229207B0A0A20207661722072657475726E56616C75653B0A0A20207768696C6520286C697374656E657229207B0A0A202020202F2F2068616E646C652073746F707065642070';
wwv_flow_imp.g_varchar2_table(3375) := '726F7061676174696F6E0A20202020696620286576656E742E63616E63656C427562626C6529207B0A202020202020627265616B3B0A202020207D0A0A2020202072657475726E56616C7565203D20746869732E5F696E766F6B654C697374656E657228';
wwv_flow_imp.g_varchar2_table(3376) := '6576656E742C20617267732C206C697374656E6572293B0A0A202020206C697374656E6572203D206C697374656E65722E6E6578743B0A20207D0A0A202072657475726E2072657475726E56616C75653B0A7D3B0A0A2F2A2A0A202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(3377) := '7B4576656E747D206576656E740A202A2040706172616D207B616E795B5D7D20617267730A202A2040706172616D207B4576656E744275734C697374656E65727D206C697374656E65720A202A0A202A204072657475726E207B616E797D0A202A2F0A45';
wwv_flow_imp.g_varchar2_table(3378) := '76656E744275732E70726F746F747970652E5F696E766F6B654C697374656E6572203D2066756E6374696F6E286576656E742C20617267732C206C697374656E657229207B0A0A20207661722072657475726E56616C75653B0A0A2020696620286C6973';
wwv_flow_imp.g_varchar2_table(3379) := '74656E65722E63616C6C6261636B2E5F5F6973546F6D6229207B0A2020202072657475726E2072657475726E56616C75653B0A20207D0A0A2020747279207B0A0A202020202F2F2072657475726E696E672066616C73652070726576656E747320746865';
wwv_flow_imp.g_varchar2_table(3380) := '2064656661756C7420616374696F6E0A2020202072657475726E56616C7565203D20696E766F6B6546756E6374696F6E286C697374656E65722E63616C6C6261636B2C2061726773293B0A0A202020202F2F2073746F702070726F7061676174696F6E20';
wwv_flow_imp.g_varchar2_table(3381) := '6F6E2072657475726E2076616C75650A202020206966202872657475726E56616C756520213D3D20756E646566696E656429207B0A2020202020206576656E742E72657475726E56616C7565203D2072657475726E56616C75653B0A2020202020206576';
wwv_flow_imp.g_varchar2_table(3382) := '656E742E73746F7050726F7061676174696F6E28293B0A202020207D0A0A202020202F2F2070726576656E742064656661756C74206F6E2072657475726E2066616C73650A202020206966202872657475726E56616C7565203D3D3D2066616C73652920';
wwv_flow_imp.g_varchar2_table(3383) := '7B0A2020202020206576656E742E70726576656E7444656661756C7428293B0A202020207D0A20207D20636174636820286572726F7229207B0A202020206966202821746869732E68616E646C654572726F72286572726F722929207B0A202020202020';
wwv_flow_imp.g_varchar2_table(3384) := '636F6E736F6C652E6572726F722827756E68616E646C6564206572726F7220696E206576656E74206C697374656E6572272C206572726F72293B0A0A2020202020207468726F77206572726F723B0A202020207D0A20207D0A0A202072657475726E2072';
wwv_flow_imp.g_varchar2_table(3385) := '657475726E56616C75653B0A7D3B0A0A2F2A2A0A202A20416464206E6577206C697374656E657220776974682061206365727461696E207072696F7269747920746F20746865206C6973740A202A206F66206C697374656E6572732028666F7220746865';
wwv_flow_imp.g_varchar2_table(3386) := '20676976656E206576656E74292E0A202A0A202A205468652073656D616E74696373206F66206C697374656E657220726567697374726174696F6E202F206C697374656E657220657865637574696F6E206172650A202A20666972737420726567697374';
wwv_flow_imp.g_varchar2_table(3387) := '65722C2066697273742073657276653A204E6577206C697374656E6572732077696C6C20616C7761797320626520696E7365727465640A202A206166746572206578697374696E67206C697374656E6572732077697468207468652073616D6520707269';
wwv_flow_imp.g_varchar2_table(3388) := '6F726974792E0A202A0A202A204578616D706C653A20496E73657274696E672074776F206C697374656E6572732077697468207072696F72697479203130303020616E6420313330300A202A0A202A202020202A206265666F72653A205B20313530302C';
wwv_flow_imp.g_varchar2_table(3389) := '20313530302C20313030302C2031303030205D0A202A202020202A2061667465723A205B20313530302C20313530302C20286E65773D31333030292C20313030302C20313030302C20286E65773D3130303029205D0A202A0A202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(3390) := '737472696E677D206576656E740A202A2040706172616D207B4576656E744275734C697374656E65727D206E65774C697374656E65720A202A2F0A4576656E744275732E70726F746F747970652E5F6164644C697374656E6572203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(3391) := '6E286576656E742C206E65774C697374656E657229207B0A0A2020766172206C697374656E6572203D20746869732E5F6765744C697374656E657273286576656E74292C0A20202020202070726576696F75734C697374656E65723B0A0A20202F2F206E';
wwv_flow_imp.g_varchar2_table(3392) := '6F207072696F72206C697374656E6572730A202069662028216C697374656E657229207B0A20202020746869732E5F7365744C697374656E657273286576656E742C206E65774C697374656E6572293B0A0A2020202072657475726E3B0A20207D0A0A20';
wwv_flow_imp.g_varchar2_table(3393) := '202F2F20656E73757265207765206F72646572206C697374656E657273206279207072696F726974792066726F6D0A20202F2F20302028686967682920746F206E203E203020286C6F77290A20207768696C6520286C697374656E657229207B0A0A2020';
wwv_flow_imp.g_varchar2_table(3394) := '2020696620286C697374656E65722E7072696F72697479203C206E65774C697374656E65722E7072696F7269747929207B0A0A2020202020206E65774C697374656E65722E6E657874203D206C697374656E65723B0A0A20202020202069662028707265';
wwv_flow_imp.g_varchar2_table(3395) := '76696F75734C697374656E657229207B0A202020202020202070726576696F75734C697374656E65722E6E657874203D206E65774C697374656E65723B0A2020202020207D20656C7365207B0A2020202020202020746869732E5F7365744C697374656E';
wwv_flow_imp.g_varchar2_table(3396) := '657273286576656E742C206E65774C697374656E6572293B0A2020202020207D0A0A20202020202072657475726E3B0A202020207D0A0A2020202070726576696F75734C697374656E6572203D206C697374656E65723B0A202020206C697374656E6572';
wwv_flow_imp.g_varchar2_table(3397) := '203D206C697374656E65722E6E6578743B0A20207D0A0A20202F2F20616464206E6577206C697374656E657220746F206261636B0A202070726576696F75734C697374656E65722E6E657874203D206E65774C697374656E65723B0A7D3B0A0A0A2F2A2A';
wwv_flow_imp.g_varchar2_table(3398) := '0A202A2040706172616D207B737472696E677D206E616D650A202A0A202A204072657475726E207B4576656E744275734C697374656E65727D0A202A2F0A4576656E744275732E70726F746F747970652E5F6765744C697374656E657273203D2066756E';
wwv_flow_imp.g_varchar2_table(3399) := '6374696F6E286E616D6529207B0A202072657475726E20746869732E5F6C697374656E6572735B6E616D655D3B0A7D3B0A0A2F2A2A0A202A2040706172616D207B737472696E677D206E616D650A202A2040706172616D207B4576656E744275734C6973';
wwv_flow_imp.g_varchar2_table(3400) := '74656E65727D206C697374656E65720A202A2F0A4576656E744275732E70726F746F747970652E5F7365744C697374656E657273203D2066756E6374696F6E286E616D652C206C697374656E657229207B0A2020746869732E5F6C697374656E6572735B';
wwv_flow_imp.g_varchar2_table(3401) := '6E616D655D203D206C697374656E65723B0A7D3B0A0A4576656E744275732E70726F746F747970652E5F72656D6F76654C697374656E6572203D2066756E6374696F6E286576656E742C2063616C6C6261636B29207B0A0A2020766172206C697374656E';
wwv_flow_imp.g_varchar2_table(3402) := '6572203D20746869732E5F6765744C697374656E657273286576656E74292C0A2020202020206E6578744C697374656E65722C0A20202020202070726576696F75734C697374656E65722C0A2020202020206C697374656E657243616C6C6261636B3B0A';
wwv_flow_imp.g_varchar2_table(3403) := '0A2020696620282163616C6C6261636B29207B0A0A202020202F2F20636C656172206C697374656E6572730A20202020746869732E5F7365744C697374656E657273286576656E742C206E756C6C293B0A0A2020202072657475726E3B0A20207D0A0A20';
wwv_flow_imp.g_varchar2_table(3404) := '207768696C6520286C697374656E657229207B0A0A202020206E6578744C697374656E6572203D206C697374656E65722E6E6578743B0A0A202020206C697374656E657243616C6C6261636B203D206C697374656E65722E63616C6C6261636B3B0A0A20';
wwv_flow_imp.g_varchar2_table(3405) := '202020696620286C697374656E657243616C6C6261636B203D3D3D2063616C6C6261636B207C7C206C697374656E657243616C6C6261636B5B464E5F5245465D203D3D3D2063616C6C6261636B29207B0A2020202020206966202870726576696F75734C';
wwv_flow_imp.g_varchar2_table(3406) := '697374656E657229207B0A202020202020202070726576696F75734C697374656E65722E6E657874203D206E6578744C697374656E65723B0A2020202020207D20656C7365207B0A0A20202020202020202F2F206E6577206669727374206C697374656E';
wwv_flow_imp.g_varchar2_table(3407) := '65720A2020202020202020746869732E5F7365744C697374656E657273286576656E742C206E6578744C697374656E6572293B0A2020202020207D0A202020207D0A0A2020202070726576696F75734C697374656E6572203D206C697374656E65723B0A';
wwv_flow_imp.g_varchar2_table(3408) := '202020206C697374656E6572203D206E6578744C697374656E65723B0A20207D0A7D3B0A0A2F2A2A0A202A2041206576656E74207468617420697320656D69747465642076696120746865206576656E74206275732E0A202A2F0A66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(3409) := '496E7465726E616C4576656E742829207B207D0A0A496E7465726E616C4576656E742E70726F746F747970652E73746F7050726F7061676174696F6E203D2066756E6374696F6E2829207B0A2020746869732E63616E63656C427562626C65203D207472';
wwv_flow_imp.g_varchar2_table(3410) := '75653B0A7D3B0A0A496E7465726E616C4576656E742E70726F746F747970652E70726576656E7444656661756C74203D2066756E6374696F6E2829207B0A2020746869732E64656661756C7450726576656E746564203D20747275653B0A7D3B0A0A496E';
wwv_flow_imp.g_varchar2_table(3411) := '7465726E616C4576656E742E70726F746F747970652E696E6974203D2066756E6374696F6E286461746129207B0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E2928746869';
wwv_flow_imp.g_varchar2_table(3412) := '732C2064617461207C7C207B7D293B0A7D3B0A0A0A2F2A2A0A202A20496E766F6B652066756E6374696F6E2E20426520666173742E2E2E0A202A0A202A2040706172616D207B46756E6374696F6E7D20666E0A202A2040706172616D207B616E795B5D7D';
wwv_flow_imp.g_varchar2_table(3413) := '20617267730A202A0A202A204072657475726E207B616E797D0A202A2F0A66756E6374696F6E20696E766F6B6546756E6374696F6E28666E2C206172677329207B0A202072657475726E20666E2E6170706C79286E756C6C2C2061726773293B0A7D0A0A';
wwv_flow_imp.g_varchar2_table(3414) := '0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F4772617068696373466163746F72792E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3415) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F4772617068696373466163746F7279';
wwv_flow_imp.g_varchar2_table(3416) := '2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F';
wwv_flow_imp.g_varchar2_table(3417) := '6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A';
wwv_flow_imp.g_varchar2_table(3418) := '2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A20';
wwv_flow_imp.g_varchar2_table(3419) := '2829203D3E20282F2A2062696E64696E67202A2F204772617068696373466163746F7279290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745';
wwv_flow_imp.g_varchar2_table(3420) := '425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E';
wwv_flow_imp.g_varchar2_table(3421) := '65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F47726170686963735574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F7265717569';
wwv_flow_imp.g_varchar2_table(3422) := '72655F5F282F2A21202E2E2F7574696C2F47726170686963735574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F47726170686963735574696C2E6A7322293B0A2F2A206861726D6F6E792069';
wwv_flow_imp.g_varchar2_table(3423) := '6D706F7274202A2F20766172205F7574696C5F5376675472616E73666F726D5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F53';
wwv_flow_imp.g_varchar2_table(3424) := '76675472616E73666F726D5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F5376675472616E73666F726D5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076';
wwv_flow_imp.g_varchar2_table(3425) := '6172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D';
wwv_flow_imp.g_varchar2_table(3426) := '2F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722074696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571';
wwv_flow_imp.g_varchar2_table(3427) := '756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D7376672F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F';
wwv_flow_imp.g_varchar2_table(3428) := '456C656D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F456C656D656E7473202A2F20222E2F6E6F64655F6D6F64756C65732F';
wwv_flow_imp.g_varchar2_table(3429) := '6469616772616D2D6A732F6C69622F7574696C2F456C656D656E74732E6A7322293B0A0A0A0A0A0A0A0A0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2F547970657327292E436F6E6E656374696F6E4C696B657D20436F';
wwv_flow_imp.g_varchar2_table(3430) := '6E6E656374696F6E4C696B650A202A204074797065646566207B696D706F727428272E2F547970657327292E456C656D656E744C696B657D20456C656D656E744C696B650A202A204074797065646566207B696D706F727428272E2F547970657327292E';
wwv_flow_imp.g_varchar2_table(3431) := '53686170654C696B657D2053686170654C696B650A202A0A202A204074797065646566207B696D706F727428272E2F456C656D656E74526567697374727927292E64656661756C747D20456C656D656E7452656769737472790A202A2040747970656465';
wwv_flow_imp.g_varchar2_table(3432) := '66207B696D706F727428272E2F4576656E7442757327292E64656661756C747D204576656E744275730A202A2F0A0A2F2A2A0A202A204120666163746F7279207468617420637265617465732067726170686963616C20656C656D656E74732E0A202A0A';
wwv_flow_imp.g_varchar2_table(3433) := '202A2040706172616D207B4576656E744275737D206576656E744275730A202A2040706172616D207B456C656D656E7452656769737472797D20656C656D656E7452656769737472790A202A2F0A66756E6374696F6E204772617068696373466163746F';
wwv_flow_imp.g_varchar2_table(3434) := '7279286576656E744275732C20656C656D656E74526567697374727929207B0A2020746869732E5F6576656E74427573203D206576656E744275733B0A2020746869732E5F656C656D656E745265676973747279203D20656C656D656E74526567697374';
wwv_flow_imp.g_varchar2_table(3435) := '72793B0A7D0A0A4772617068696373466163746F72792E24696E6A656374203D205B20276576656E7442757327202C2027656C656D656E74526567697374727927205D3B0A0A2F2A2A0A202A2040706172616D207B207B20706172656E743F3A20616E79';
wwv_flow_imp.g_varchar2_table(3436) := '207D207D20656C656D656E740A202A204072657475726E207B535647456C656D656E747D0A202A2F0A4772617068696373466163746F72792E70726F746F747970652E5F6765744368696C6472656E436F6E7461696E6572203D2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(3437) := '656C656D656E7429207B0A0A202076617220676678203D20746869732E5F656C656D656E7452656769737472792E676574477261706869637328656C656D656E74293B0A0A2020766172206368696C6472656E4766783B0A0A20202F2F20726F6F742065';
wwv_flow_imp.g_varchar2_table(3438) := '6C656D656E740A20206966202821656C656D656E742E706172656E7429207B0A202020206368696C6472656E476678203D206766783B0A20207D20656C7365207B0A202020206368696C6472656E476678203D2028302C5F7574696C5F47726170686963';
wwv_flow_imp.g_varchar2_table(3439) := '735574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6765744368696C6472656E2928676678293B0A2020202069662028216368696C6472656E47667829207B0A2020202020206368696C6472656E476678203D202830';
wwv_flow_imp.g_varchar2_table(3440) := '2C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6372656174652928276727293B0A20202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E';
wwv_flow_imp.g_varchar2_table(3441) := '636C617373657329286368696C6472656E476678292E6164642827646A732D6368696C6472656E27293B0A0A20202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E617070656E64292867';
wwv_flow_imp.g_varchar2_table(3442) := '66782E706172656E744E6F64652C206368696C6472656E476678293B0A202020207D0A20207D0A0A202072657475726E206368696C6472656E4766783B0A7D3B0A0A2F2A2A0A202A20436C65617273207468652067726170686963616C20726570726573';
wwv_flow_imp.g_varchar2_table(3443) := '656E746174696F6E206F662074686520656C656D656E7420616E642072657475726E73207468650A202A20636C65617265642076697375616C2028746865203C6720636C6173733D22646A732D76697375616C22202F3E20656C656D656E74292E0A202A';
wwv_flow_imp.g_varchar2_table(3444) := '2F0A4772617068696373466163746F72792E70726F746F747970652E5F636C656172203D2066756E6374696F6E2867667829207B0A20207661722076697375616C203D2028302C5F7574696C5F47726170686963735574696C5F5F5745425041434B5F49';
wwv_flow_imp.g_varchar2_table(3445) := '4D504F525445445F4D4F44554C455F305F5F2E67657456697375616C2928676678293B0A0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E636C656172292876697375616C293B0A0A20207265';
wwv_flow_imp.g_varchar2_table(3446) := '7475726E2076697375616C3B0A7D3B0A0A2F2A2A0A202A204372656174657320612067667820636F6E7461696E657220666F722073686170657320616E6420636F6E6E656374696F6E730A202A0A202A20546865206C61796F757420697320617320666F';
wwv_flow_imp.g_varchar2_table(3447) := '6C6C6F77733A0A202A0A202A203C6720636C6173733D22646A732D67726F7570223E0A202A0A202A2020203C212D2D2074686520676678202D2D3E0A202A2020203C6720636C6173733D22646A732D656C656D656E7420646A732D2873686170657C636F';
wwv_flow_imp.g_varchar2_table(3448) := '6E6E656374696F6E7C6672616D6529223E0A202A20202020203C6720636C6173733D22646A732D76697375616C223E0A202A202020202020203C212D2D207468652072656E646572657220647261777320696E2068657265202D2D3E0A202A2020202020';
wwv_flow_imp.g_varchar2_table(3449) := '3C2F673E0A202A0A202A20202020203C212D2D20657874656E73696F6E7320286F7665726C6179732C20636C69636B20626F782C202E2E2E2920676F657320686572650A202A2020203C2F673E0A202A0A202A2020203C212D2D20746865206766782063';
wwv_flow_imp.g_varchar2_table(3450) := '68696C64206E6F646573202D2D3E0A202A2020203C6720636C6173733D22646A732D6368696C6472656E223E3C2F673E0A202A203C2F673E0A202A0A202A2040706172616D207B737472696E677D2074797065207468652074797065206F662074686520';
wwv_flow_imp.g_varchar2_table(3451) := '656C656D656E742C20692E652E207368617065207C20636F6E6E656374696F6E0A202A2040706172616D207B535647456C656D656E747D206368696C6472656E4766780A202A2040706172616D207B6E756D6265727D205B706172656E74496E6465785D';
wwv_flow_imp.g_varchar2_table(3452) := '20706F736974696F6E20746F2063726561746520636F6E7461696E657220696E20706172656E740A202A2040706172616D207B626F6F6C65616E7D205B69734672616D655D206973206672616D6520656C656D656E740A202A0A202A204072657475726E';
wwv_flow_imp.g_varchar2_table(3453) := '207B535647456C656D656E747D0A202A2F0A4772617068696373466163746F72792E70726F746F747970652E5F637265617465436F6E7461696E6572203D2066756E6374696F6E280A20202020747970652C206368696C6472656E4766782C2070617265';
wwv_flow_imp.g_varchar2_table(3454) := '6E74496E6465782C2069734672616D650A29207B0A2020766172206F75746572476678203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6372656174652928276727293B0A202028302C7469';
wwv_flow_imp.g_varchar2_table(3455) := '6E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E636C617373657329286F75746572476678292E6164642827646A732D67726F757027293B0A0A20202F2F20696E73657274206E6F646520617420706F73697469';
wwv_flow_imp.g_varchar2_table(3456) := '6F6E0A202069662028747970656F6620706172656E74496E64657820213D3D2027756E646566696E65642729207B0A2020202070726570656E64546F286F757465724766782C206368696C6472656E4766782C206368696C6472656E4766782E6368696C';
wwv_flow_imp.g_varchar2_table(3457) := '644E6F6465735B706172656E74496E6465785D293B0A20207D20656C7365207B0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E617070656E6429286368696C6472656E4766782C206F';
wwv_flow_imp.g_varchar2_table(3458) := '75746572476678293B0A20207D0A0A202076617220676678203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6372656174652928276727293B0A202028302C74696E795F7376675F5F574542';
wwv_flow_imp.g_varchar2_table(3459) := '5041434B5F494D504F525445445F4D4F44554C455F315F5F2E636C61737365732928676678292E6164642827646A732D656C656D656E7427293B0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F';
wwv_flow_imp.g_varchar2_table(3460) := '5F2E636C61737365732928676678292E6164642827646A732D27202B2074797065293B0A0A20206966202869734672616D6529207B0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E63';
wwv_flow_imp.g_varchar2_table(3461) := '6C61737365732928676678292E6164642827646A732D6672616D6527293B0A20207D0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E617070656E6429286F757465724766782C20676678';
wwv_flow_imp.g_varchar2_table(3462) := '293B0A0A20202F2F206372656174652076697375616C0A20207661722076697375616C203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6372656174652928276727293B0A202028302C7469';
wwv_flow_imp.g_varchar2_table(3463) := '6E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E636C6173736573292876697375616C292E6164642827646A732D76697375616C27293B0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(3464) := '525445445F4D4F44554C455F315F5F2E617070656E6429286766782C2076697375616C293B0A0A202072657475726E206766783B0A7D3B0A0A2F2A2A0A202A2043726561746520612067726170686963616C20656C656D656E742E0A202A0A202A204070';
wwv_flow_imp.g_varchar2_table(3465) := '6172616D207B2027736861706527207C2027636F6E6E656374696F6E27207C20276C6162656C27207C2027726F6F7427207D2074797065205468652074797065206F662074686520656C656D656E742E0A202A2040706172616D207B456C656D656E744C';
wwv_flow_imp.g_varchar2_table(3466) := '696B657D20656C656D656E742054686520656C656D656E742E0A202A2040706172616D207B6E756D6265727D205B706172656E74496E6465785D2054686520696E64657820617420776869636820746F20616464207468652067726170686963616C2065';
wwv_flow_imp.g_varchar2_table(3467) := '6C656D656E7420746F2069747320706172656E742773206368696C6472656E2E0A202A0A202A204072657475726E207B535647456C656D656E747D205468652067726170686963616C20656C656D656E742E0A202A2F0A4772617068696373466163746F';
wwv_flow_imp.g_varchar2_table(3468) := '72792E70726F746F747970652E637265617465203D2066756E6374696F6E28747970652C20656C656D656E742C20706172656E74496E64657829207B0A2020766172206368696C6472656E476678203D20746869732E5F6765744368696C6472656E436F';
wwv_flow_imp.g_varchar2_table(3469) := '6E7461696E657228656C656D656E742E706172656E74293B0A202072657475726E20746869732E5F637265617465436F6E7461696E657228747970652C206368696C6472656E4766782C20706172656E74496E6465782C2028302C5F7574696C5F456C65';
wwv_flow_imp.g_varchar2_table(3470) := '6D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E69734672616D65456C656D656E742928656C656D656E7429293B0A7D3B0A0A2F2A2A0A202A205570646174652074686520636F6E7461696E6D656E7473206F6620';
wwv_flow_imp.g_varchar2_table(3471) := '74686520676976656E20656C656D656E74732E0A202A0A202A2040706172616D207B456C656D656E744C696B655B5D7D20656C656D656E74732054686520656C656D656E74732E0A202A2F0A4772617068696373466163746F72792E70726F746F747970';
wwv_flow_imp.g_varchar2_table(3472) := '652E757064617465436F6E7461696E6D656E7473203D2066756E6374696F6E28656C656D656E747329207B0A0A20207661722073656C66203D20746869732C0A202020202020656C656D656E745265676973747279203D20746869732E5F656C656D656E';
wwv_flow_imp.g_varchar2_table(3473) := '7452656769737472792C0A202020202020706172656E74733B0A0A2020706172656E7473203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E7265647563652928656C656D656E74732C206675';
wwv_flow_imp.g_varchar2_table(3474) := '6E6374696F6E286D61702C206529207B0A0A2020202069662028652E706172656E7429207B0A2020202020206D61705B652E706172656E742E69645D203D20652E706172656E743B0A202020207D0A0A2020202072657475726E206D61703B0A20207D2C';
wwv_flow_imp.g_varchar2_table(3475) := '207B7D293B0A0A20202F2F2075706461746520616C6C20706172656E7473206F66206368616E67656420616E642072656F7267616E697A6564207468656972206368696C6472656E0A20202F2F20696E2074686520636F7272656374206F726465722028';
wwv_flow_imp.g_varchar2_table(3476) := '617320696E6469636174656420696E206F7572206D6F64656C290A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E666F72456163682928706172656E74732C2066756E6374696F6E28706172';
wwv_flow_imp.g_varchar2_table(3477) := '656E7429207B0A0A20202020766172206368696C6472656E203D20706172656E742E6368696C6472656E3B0A0A2020202069662028216368696C6472656E29207B0A20202020202072657475726E3B0A202020207D0A0A20202020766172206368696C64';
wwv_flow_imp.g_varchar2_table(3478) := '72656E476678203D2073656C662E5F6765744368696C6472656E436F6E7461696E657228706172656E74293B0A0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E666F72456163682928';
wwv_flow_imp.g_varchar2_table(3479) := '6368696C6472656E2E736C69636528292E7265766572736528292C2066756E6374696F6E286368696C6429207B0A202020202020766172206368696C64476678203D20656C656D656E7452656769737472792E6765744772617068696373286368696C64';
wwv_flow_imp.g_varchar2_table(3480) := '293B0A0A20202020202070726570656E64546F286368696C644766782E706172656E744E6F64652C206368696C6472656E476678293B0A202020207D293B0A20207D293B0A7D3B0A0A2F2A2A0A202A204472617720612073686170652E0A202A0A202A20';
wwv_flow_imp.g_varchar2_table(3481) := '40706172616D207B535647456C656D656E747D2076697375616C205468652067726170686963616C20656C656D656E742E0A202A2040706172616D207B53686170654C696B657D20656C656D656E74205468652073686170652E0A202A2040706172616D';
wwv_flow_imp.g_varchar2_table(3482) := '207B4F626A6563747D206174747273204F7074696F6E616C20617474726962757465732E0A202A0A202A204072657475726E207B535647456C656D656E747D0A202A2F0A4772617068696373466163746F72792E70726F746F747970652E647261775368';
wwv_flow_imp.g_varchar2_table(3483) := '617065203D2066756E6374696F6E2876697375616C2C20656C656D656E742C206174747273203D207B7D29207B0A2020766172206576656E74427573203D20746869732E5F6576656E744275733B0A0A202072657475726E206576656E744275732E6669';
wwv_flow_imp.g_varchar2_table(3484) := '7265282772656E6465722E7368617065272C207B206766783A2076697375616C2C20656C656D656E742C206174747273207D293B0A7D3B0A0A2F2A2A0A202A20476574207468652070617468206F6620612073686170652E0A202A0A202A204070617261';
wwv_flow_imp.g_varchar2_table(3485) := '6D207B53686170654C696B657D20656C656D656E74205468652073686170652E0A202A0A202A204072657475726E207B737472696E677D205468652070617468206F66207468652073686170652E0A202A2F0A4772617068696373466163746F72792E70';
wwv_flow_imp.g_varchar2_table(3486) := '726F746F747970652E676574536861706550617468203D2066756E6374696F6E28656C656D656E7429207B0A2020766172206576656E74427573203D20746869732E5F6576656E744275733B0A0A202072657475726E206576656E744275732E66697265';
wwv_flow_imp.g_varchar2_table(3487) := '282772656E6465722E676574536861706550617468272C20656C656D656E74293B0A7D3B0A0A2F2A2A0A202A2044726177206120636F6E6E656374696F6E2E0A202A0A202A2040706172616D207B535647456C656D656E747D2076697375616C20546865';
wwv_flow_imp.g_varchar2_table(3488) := '2067726170686963616C20656C656D656E742E0A202A2040706172616D207B436F6E6E656374696F6E4C696B657D20656C656D656E742054686520636F6E6E656374696F6E2E0A202A2040706172616D207B4F626A6563747D206174747273204F707469';
wwv_flow_imp.g_varchar2_table(3489) := '6F6E616C20617474726962757465732E0A202A0A202A204072657475726E207B535647456C656D656E747D0A202A2F0A4772617068696373466163746F72792E70726F746F747970652E64726177436F6E6E656374696F6E203D2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(3490) := '76697375616C2C20656C656D656E742C206174747273203D207B7D29207B0A2020766172206576656E74427573203D20746869732E5F6576656E744275733B0A0A202072657475726E206576656E744275732E66697265282772656E6465722E636F6E6E';
wwv_flow_imp.g_varchar2_table(3491) := '656374696F6E272C207B206766783A2076697375616C2C20656C656D656E742C206174747273207D293B0A7D3B0A0A2F2A2A0A202A20476574207468652070617468206F66206120636F6E6E656374696F6E2E0A202A0A202A2040706172616D207B436F';
wwv_flow_imp.g_varchar2_table(3492) := '6E6E656374696F6E4C696B657D20636F6E6E656374696F6E2054686520636F6E6E656374696F6E2E0A202A0A202A204072657475726E207B737472696E677D205468652070617468206F662074686520636F6E6E656374696F6E2E0A202A2F0A47726170';
wwv_flow_imp.g_varchar2_table(3493) := '68696373466163746F72792E70726F746F747970652E676574436F6E6E656374696F6E50617468203D2066756E6374696F6E28636F6E6E656374696F6E29207B0A2020766172206576656E74427573203D20746869732E5F6576656E744275733B0A0A20';
wwv_flow_imp.g_varchar2_table(3494) := '2072657475726E206576656E744275732E66697265282772656E6465722E676574436F6E6E656374696F6E50617468272C20636F6E6E656374696F6E293B0A7D3B0A0A2F2A2A0A202A2055706461746520616E20656C656D656E74732067726170686963';
wwv_flow_imp.g_varchar2_table(3495) := '616C20726570726573656E746174696F6E2E0A202A0A202A2040706172616D207B277368617065277C27636F6E6E656374696F6E277D20747970650A202A2040706172616D207B456C656D656E744C696B657D20656C656D656E740A202A204070617261';
wwv_flow_imp.g_varchar2_table(3496) := '6D207B535647456C656D656E747D206766780A202A2F0A4772617068696373466163746F72792E70726F746F747970652E757064617465203D2066756E6374696F6E28747970652C20656C656D656E742C2067667829207B0A0A20202F2F20646F204E4F';
wwv_flow_imp.g_varchar2_table(3497) := '542075706461746520726F6F7420656C656D656E740A20206966202821656C656D656E742E706172656E7429207B0A2020202072657475726E3B0A20207D0A0A20207661722076697375616C203D20746869732E5F636C65617228676678293B0A0A2020';
wwv_flow_imp.g_varchar2_table(3498) := '2F2F207265647261770A20206966202874797065203D3D3D202773686170652729207B0A20202020746869732E6472617753686170652876697375616C2C20656C656D656E74293B0A0A202020202F2F2075706461746520706F736974696F6E696E670A';
wwv_flow_imp.g_varchar2_table(3499) := '2020202028302C5F7574696C5F5376675472616E73666F726D5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E7472616E736C61746529286766782C20656C656D656E742E782C20656C656D656E742E79293B0A2020';
wwv_flow_imp.g_varchar2_table(3500) := '7D20656C7365206966202874797065203D3D3D2027636F6E6E656374696F6E2729207B0A20202020746869732E64726177436F6E6E656374696F6E2876697375616C2C20656C656D656E74293B0A20207D20656C7365207B0A202020207468726F77206E';
wwv_flow_imp.g_varchar2_table(3501) := '6577204572726F722827756E6B6E6F776E20747970653A2027202B2074797065293B0A20207D0A0A202069662028656C656D656E742E68696464656E29207B0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(3502) := '44554C455F315F5F2E6174747229286766782C2027646973706C6179272C20276E6F6E6527293B0A20207D20656C7365207B0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E61747472';
wwv_flow_imp.g_varchar2_table(3503) := '29286766782C2027646973706C6179272C2027626C6F636B27293B0A20207D0A7D3B0A0A2F2A2A0A202A2052656D6F766520612067726170686963616C20656C656D656E742E0A202A0A202A2040706172616D207B456C656D656E744C696B657D20656C';
wwv_flow_imp.g_varchar2_table(3504) := '656D656E742054686520656C656D656E742E0A202A2F0A4772617068696373466163746F72792E70726F746F747970652E72656D6F7665203D2066756E6374696F6E28656C656D656E7429207B0A202076617220676678203D20746869732E5F656C656D';
wwv_flow_imp.g_varchar2_table(3505) := '656E7452656769737472792E676574477261706869637328656C656D656E74293B0A0A20202F2F2072656D6F76650A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E72656D6F766529286766';
wwv_flow_imp.g_varchar2_table(3506) := '782E706172656E744E6F6465293B0A7D3B0A0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F0A0A66756E6374696F6E2070726570656E64546F286E65774E6F64652C20706172656E744E6F64652C207369626C696E674E6F646529207B0A2020';
wwv_flow_imp.g_varchar2_table(3507) := '766172206E6F6465203D207369626C696E674E6F6465207C7C20706172656E744E6F64652E66697273744368696C643B0A0A20202F2F20646F206E6F742070726570656E64206E6F646520746F20697473656C6620746F2070726576656E742049452066';
wwv_flow_imp.g_varchar2_table(3508) := '726F6D206372617368696E670A20202F2F2068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F62706D6E2D6A732F6973737565732F3734360A2020696620286E65774E6F6465203D3D3D206E6F646529207B0A2020202072657475726E';
wwv_flow_imp.g_varchar2_table(3509) := '3B0A20207D0A0A2020706172656E744E6F64652E696E736572744265666F7265286E65774E6F64652C206E6F6465293B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C6962';
wwv_flow_imp.g_varchar2_table(3510) := '2F636F72652F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F646961';
wwv_flow_imp.g_varchar2_table(3511) := '6772616D2D6A732F6C69622F636F72652F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E75';
wwv_flow_imp.g_varchar2_table(3512) := '7365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F';
wwv_flow_imp.g_varchar2_table(3513) := '6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020';
wwv_flow_imp.g_varchar2_table(3514) := '202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F6472';
wwv_flow_imp.g_varchar2_table(3515) := '61775F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F64726177202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F';
wwv_flow_imp.g_varchar2_table(3516) := '647261772F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F43616E7661735F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F';
wwv_flow_imp.g_varchar2_table(3517) := '282F2A21202E2F43616E766173202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F43616E7661732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F456C656D656E7452';
wwv_flow_imp.g_varchar2_table(3518) := '656769737472795F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F456C656D656E745265676973747279202A2F20222E2F6E6F64655F6D6F64756C65732F';
wwv_flow_imp.g_varchar2_table(3519) := '6469616772616D2D6A732F6C69622F636F72652F456C656D656E7452656769737472792E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F456C656D656E74466163746F72795F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(3520) := '5F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F456C656D656E74466163746F7279202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F456C656D656E';
wwv_flow_imp.g_varchar2_table(3521) := '74466163746F72792E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F4576656E744275735F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F';
wwv_flow_imp.g_varchar2_table(3522) := '282F2A21202E2F4576656E74427573202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F4576656E744275732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F47726170';
wwv_flow_imp.g_varchar2_table(3523) := '68696373466163746F72795F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4772617068696373466163746F7279202A2F20222E2F6E6F64655F6D6F6475';
wwv_flow_imp.g_varchar2_table(3524) := '6C65732F6469616772616D2D6A732F6C69622F636F72652F4772617068696373466163746F72792E6A7322293B0A0A0A0A0A0A0A0A0A2F2A2A0A202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F';
wwv_flow_imp.g_varchar2_table(3525) := '6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F646570656E64735F5F3A205B205F647261775F5F57';
wwv_flow_imp.g_varchar2_table(3526) := '45425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D205D2C0A20205F5F696E69745F5F3A205B202763616E76617327205D2C0A202063616E7661733A205B202774797065272C205F43616E7661735F5F57454250';
wwv_flow_imp.g_varchar2_table(3527) := '41434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D205D2C0A2020656C656D656E7452656769737472793A205B202774797065272C205F456C656D656E7452656769737472795F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(3528) := '445F4D4F44554C455F325F5F5B2264656661756C74225D205D2C0A2020656C656D656E74466163746F72793A205B202774797065272C205F456C656D656E74466163746F72795F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F5B';
wwv_flow_imp.g_varchar2_table(3529) := '2264656661756C74225D205D2C0A20206576656E744275733A205B202774797065272C205F4576656E744275735F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F5B2264656661756C74225D205D2C0A2020677261706869637346';
wwv_flow_imp.g_varchar2_table(3530) := '6163746F72793A205B202774797065272C205F4772617068696373466163746F72795F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F5B2264656661756C74225D205D0A7D293B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F2022';
wwv_flow_imp.g_varchar2_table(3531) := '2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F4261736552656E64657265722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3532) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F4261736552656E64657265722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3533) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F';
wwv_flow_imp.g_varchar2_table(3534) := '7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F';
wwv_flow_imp.g_varchar2_table(3535) := '726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F204261736552656E646572';
wwv_flow_imp.g_varchar2_table(3536) := '6572290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A7661722044454641554C545F52454E4445525F5052494F52495459203D20313030303B0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F636F72652F54';
wwv_flow_imp.g_varchar2_table(3537) := '7970657327292E456C656D656E744C696B657D20456C656D656E740A202A204074797065646566207B696D706F727428272E2E2F636F72652F547970657327292E436F6E6E656374696F6E4C696B657D20436F6E6E656374696F6E0A202A204074797065';
wwv_flow_imp.g_varchar2_table(3538) := '646566207B696D706F727428272E2E2F636F72652F547970657327292E53686170654C696B657D2053686170650A202A0A202A204074797065646566207B696D706F727428272E2E2F636F72652F4576656E7442757327292E64656661756C747D204576';
wwv_flow_imp.g_varchar2_table(3539) := '656E744275730A202A2F0A0A2F2A2A0A202A20546865206261736520696D706C656D656E746174696F6E206F6620736861706520616E6420636F6E6E656374696F6E2072656E6465726572732E0A202A0A202A2040706172616D207B4576656E74427573';
wwv_flow_imp.g_varchar2_table(3540) := '7D206576656E744275730A202A2040706172616D207B6E756D6265727D205B72656E6465725072696F726974793D313030305D0A202A2F0A66756E6374696F6E204261736552656E6465726572286576656E744275732C2072656E6465725072696F7269';
wwv_flow_imp.g_varchar2_table(3541) := '747929207B0A20207661722073656C66203D20746869733B0A0A202072656E6465725072696F72697479203D2072656E6465725072696F72697479207C7C2044454641554C545F52454E4445525F5052494F524954593B0A0A20206576656E744275732E';
wwv_flow_imp.g_varchar2_table(3542) := '6F6E285B202772656E6465722E7368617065272C202772656E6465722E636F6E6E656374696F6E27205D2C2072656E6465725072696F726974792C2066756E6374696F6E286576742C20636F6E7465787429207B0A202020207661722074797065203D20';
wwv_flow_imp.g_varchar2_table(3543) := '6576742E747970652C0A2020202020202020656C656D656E74203D20636F6E746578742E656C656D656E742C0A202020202020202076697375616C73203D20636F6E746578742E6766782C0A20202020202020206174747273203D20636F6E746578742E';
wwv_flow_imp.g_varchar2_table(3544) := '61747472733B0A0A202020206966202873656C662E63616E52656E64657228656C656D656E742929207B0A2020202020206966202874797065203D3D3D202772656E6465722E73686170652729207B0A202020202020202072657475726E2073656C662E';
wwv_flow_imp.g_varchar2_table(3545) := '6472617753686170652876697375616C732C20656C656D656E742C206174747273293B0A2020202020207D20656C7365207B0A202020202020202072657475726E2073656C662E64726177436F6E6E656374696F6E2876697375616C732C20656C656D65';
wwv_flow_imp.g_varchar2_table(3546) := '6E742C206174747273293B0A2020202020207D0A202020207D0A20207D293B0A0A20206576656E744275732E6F6E285B202772656E6465722E676574536861706550617468272C202772656E6465722E676574436F6E6E656374696F6E5061746827205D';
wwv_flow_imp.g_varchar2_table(3547) := '2C2072656E6465725072696F726974792C2066756E6374696F6E286576742C20656C656D656E7429207B0A202020206966202873656C662E63616E52656E64657228656C656D656E742929207B0A202020202020696620286576742E74797065203D3D3D';
wwv_flow_imp.g_varchar2_table(3548) := '202772656E6465722E6765745368617065506174682729207B0A202020202020202072657475726E2073656C662E67657453686170655061746828656C656D656E74293B0A2020202020207D20656C7365207B0A202020202020202072657475726E2073';
wwv_flow_imp.g_varchar2_table(3549) := '656C662E676574436F6E6E656374696F6E5061746828656C656D656E74293B0A2020202020207D0A202020207D0A20207D293B0A7D0A0A2F2A2A0A202A20436865636B73207768657468657220616E20656C656D656E742063616E2062652072656E6465';
wwv_flow_imp.g_varchar2_table(3550) := '7265642E0A202A0A202A2040706172616D207B456C656D656E747D20656C656D656E742054686520656C656D656E7420746F2062652072656E64657265642E0A202A0A202A204072657475726E207B626F6F6C65616E7D20576865746865722074686520';
wwv_flow_imp.g_varchar2_table(3551) := '656C656D656E742063616E2062652072656E64657265642E0A202A2F0A4261736552656E64657265722E70726F746F747970652E63616E52656E646572203D2066756E6374696F6E28656C656D656E7429207B7D3B0A0A2F2A2A0A202A20447261777320';
wwv_flow_imp.g_varchar2_table(3552) := '612073686170652E0A202A0A202A2040706172616D207B535647456C656D656E747D2076697375616C73205468652053564720656C656D656E7420746F20647261772074686520736861706520696E746F2E0A202A2040706172616D207B53686170657D';
wwv_flow_imp.g_varchar2_table(3553) := '2073686170652054686520736861706520746F20626520647261776E2E0A202A0A202A204072657475726E207B535647456C656D656E747D205468652053564720656C656D656E74206F662074686520736861706520647261776E2E0A202A2F0A426173';
wwv_flow_imp.g_varchar2_table(3554) := '6552656E64657265722E70726F746F747970652E647261775368617065203D2066756E6374696F6E2876697375616C732C20736861706529207B7D3B0A0A2F2A2A0A202A204472617773206120636F6E6E656374696F6E2E0A202A0A202A204070617261';
wwv_flow_imp.g_varchar2_table(3555) := '6D207B535647456C656D656E747D2076697375616C73205468652053564720656C656D656E7420746F20647261772074686520636F6E6E656374696F6E20696E746F2E0A202A2040706172616D207B436F6E6E656374696F6E7D20636F6E6E656374696F';
wwv_flow_imp.g_varchar2_table(3556) := '6E2054686520636F6E6E656374696F6E20746F20626520647261776E2E0A202A0A202A204072657475726E207B535647456C656D656E747D205468652053564720656C656D656E74206F662074686520636F6E6E656374696F6E20647261776E2E0A202A';
wwv_flow_imp.g_varchar2_table(3557) := '2F0A4261736552656E64657265722E70726F746F747970652E64726177436F6E6E656374696F6E203D2066756E6374696F6E2876697375616C732C20636F6E6E656374696F6E29207B7D3B0A0A2F2A2A0A202A2047657473207468652053564720706174';
wwv_flow_imp.g_varchar2_table(3558) := '68206F66207468652067726170686963616C20726570726573656E746174696F6E206F6620612073686170652E0A202A0A202A2040706172616D207B53686170657D207368617065205468652073686170652E0A202A0A202A204072657475726E207B73';
wwv_flow_imp.g_varchar2_table(3559) := '7472696E677D20546865205356472070617468206F66207468652073686170652E0A202A2F0A4261736552656E64657265722E70726F746F747970652E676574536861706550617468203D2066756E6374696F6E28736861706529207B7D3B0A0A2F2A2A';
wwv_flow_imp.g_varchar2_table(3560) := '0A202A204765747320746865205356472070617468206F66207468652067726170686963616C20726570726573656E746174696F6E206F66206120636F6E6E656374696F6E2E0A202A0A202A2040706172616D207B436F6E6E656374696F6E7D20636F6E';
wwv_flow_imp.g_varchar2_table(3561) := '6E656374696F6E2054686520636F6E6E656374696F6E2E0A202A0A202A204072657475726E207B737472696E677D20546865205356472070617468206F662074686520636F6E6E656374696F6E2E0A202A2F0A4261736552656E64657265722E70726F74';
wwv_flow_imp.g_varchar2_table(3562) := '6F747970652E676574436F6E6E656374696F6E50617468203D2066756E6374696F6E28636F6E6E656374696F6E29207B7D3B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C6962';
wwv_flow_imp.g_varchar2_table(3563) := '2F647261772F44656661756C7452656E64657265722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A';
wwv_flow_imp.g_varchar2_table(3564) := '2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F44656661756C7452656E64657265722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3565) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F';
wwv_flow_imp.g_varchar2_table(3566) := '29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F776562';
wwv_flow_imp.g_varchar2_table(3567) := '7061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F2044656661756C7452656E6465726572290A2F2A206861726D6F6E79';
wwv_flow_imp.g_varchar2_table(3568) := '206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076617220696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F7265';
wwv_flow_imp.g_varchar2_table(3569) := '71756972655F5F282F2A2120696E6865726974732D62726F77736572202A2F20222E2F6E6F64655F6D6F64756C65732F696E6865726974732D62726F777365722F646973742F696E6465782E65732E6A7322293B0A2F2A206861726D6F6E7920696D706F';
wwv_flow_imp.g_varchar2_table(3570) := '7274202A2F20766172205F4261736552656E64657265725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4261736552656E6465726572202A2F20222E2F';
wwv_flow_imp.g_varchar2_table(3571) := '6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F4261736552656E64657265722E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F52656E6465725574696C5F5F5745425041';
wwv_flow_imp.g_varchar2_table(3572) := '434B5F494D504F525445445F4D4F44554C455F355F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F52656E6465725574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69';
wwv_flow_imp.g_varchar2_table(3573) := '622F7574696C2F52656E6465725574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722074696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F72';
wwv_flow_imp.g_varchar2_table(3574) := '6571756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D7376672F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F';
wwv_flow_imp.g_varchar2_table(3575) := '646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973';
wwv_flow_imp.g_varchar2_table(3576) := '742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F456C656D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F72';
wwv_flow_imp.g_varchar2_table(3577) := '6571756972655F5F282F2A21202E2E2F7574696C2F456C656D656E7473202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F456C656D656E74732E6A7322293B0A0A0A0A0A0A0A0A0A0A0A0A0A2F2A2A0A';
wwv_flow_imp.g_varchar2_table(3578) := '202A204074797065646566207B696D706F727428272E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A204074797065646566207B696D706F727428272E2F5374796C657327292E64656661756C747D2053';
wwv_flow_imp.g_varchar2_table(3579) := '74796C65730A202A2F0A0A2F2F206170706C792064656661756C742072656E64657265722077697468206C6F7765737420706F737369626C65207072696F726974790A2F2F20736F2074686174206974206F6E6C79206B69636B7320696E206966206E6F';
wwv_flow_imp.g_varchar2_table(3580) := '6F6E6520656C736520636F756C642072656E6465720A7661722044454641554C545F52454E4445525F5052494F52495459203D20313B0A0A2F2A2A0A202A205468652064656661756C742072656E6465726572207573656420666F722073686170657320';
wwv_flow_imp.g_varchar2_table(3581) := '616E6420636F6E6E656374696F6E732E0A202A0A202A2040706172616D207B4576656E744275737D206576656E744275730A202A2040706172616D207B5374796C65737D207374796C65730A202A2F0A66756E6374696F6E2044656661756C7452656E64';
wwv_flow_imp.g_varchar2_table(3582) := '65726572286576656E744275732C207374796C657329207B0A0A20205F4261736552656E64657265725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D2E63616C6C28746869732C206576656E744275';
wwv_flow_imp.g_varchar2_table(3583) := '732C2044454641554C545F52454E4445525F5052494F52495459293B0A0A2020746869732E434F4E4E454354494F4E5F5354594C45203D207374796C65732E7374796C65285B20276E6F2D66696C6C27205D2C207B207374726F6B6557696474683A2035';
wwv_flow_imp.g_varchar2_table(3584) := '2C207374726F6B653A20276675636873696127207D293B0A2020746869732E53484150455F5354594C45203D207374796C65732E7374796C65287B2066696C6C3A20277768697465272C207374726F6B653A202766756368736961272C207374726F6B65';
wwv_flow_imp.g_varchar2_table(3585) := '57696474683A2032207D293B0A2020746869732E4652414D455F5354594C45203D207374796C65732E7374796C65285B20276E6F2D66696C6C27205D2C207B207374726F6B653A202766756368736961272C207374726F6B654461736861727261793A20';
wwv_flow_imp.g_varchar2_table(3586) := '342C207374726F6B6557696474683A2032207D293B0A7D0A0A28302C696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D292844656661756C7452656E64657265';
wwv_flow_imp.g_varchar2_table(3587) := '722C205F4261736552656E64657265725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D293B0A0A0A2F2A2A0A202A2040707269766174650A202A2F0A44656661756C7452656E64657265722E70726F';
wwv_flow_imp.g_varchar2_table(3588) := '746F747970652E63616E52656E646572203D2066756E6374696F6E2829207B0A202072657475726E20747275653B0A7D3B0A0A2F2A2A0A202A2040707269766174650A202A2F0A44656661756C7452656E64657265722E70726F746F747970652E647261';
wwv_flow_imp.g_varchar2_table(3589) := '775368617065203D2066756E6374696F6E206472617753686170652876697375616C732C20656C656D656E742C20617474727329207B0A20207661722072656374203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(3590) := '44554C455F325F5F2E6372656174652928277265637427293B0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E617474722928726563742C207B0A20202020783A20302C0A20202020793A';
wwv_flow_imp.g_varchar2_table(3591) := '20302C0A2020202077696474683A20656C656D656E742E7769647468207C7C20302C0A202020206865696768743A20656C656D656E742E686569676874207C7C20300A20207D293B0A0A20206966202828302C5F7574696C5F456C656D656E74735F5F57';
wwv_flow_imp.g_varchar2_table(3592) := '45425041434B5F494D504F525445445F4D4F44554C455F335F5F2E69734672616D65456C656D656E742928656C656D656E742929207B0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E';
wwv_flow_imp.g_varchar2_table(3593) := '617474722928726563742C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E61737369676E29287B7D2C20746869732E4652414D455F5354594C452C206174747273207C7C207B7D29293B0A2020';
wwv_flow_imp.g_varchar2_table(3594) := '7D20656C7365207B0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E617474722928726563742C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(3595) := '4C455F345F5F2E61737369676E29287B7D2C20746869732E53484150455F5354594C452C206174747273207C7C207B7D29293B0A20207D0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E';
wwv_flow_imp.g_varchar2_table(3596) := '617070656E64292876697375616C732C2072656374293B0A0A202072657475726E20726563743B0A7D3B0A0A2F2A2A0A202A2040707269766174650A202A2F0A44656661756C7452656E64657265722E70726F746F747970652E64726177436F6E6E6563';
wwv_flow_imp.g_varchar2_table(3597) := '74696F6E203D2066756E6374696F6E2064726177436F6E6E656374696F6E2876697375616C732C20636F6E6E656374696F6E2C20617474727329207B0A0A2020766172206C696E65203D2028302C5F7574696C5F52656E6465725574696C5F5F57454250';
wwv_flow_imp.g_varchar2_table(3598) := '41434B5F494D504F525445445F4D4F44554C455F355F5F2E6372656174654C696E652928636F6E6E656374696F6E2E776179706F696E74732C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E61';
wwv_flow_imp.g_varchar2_table(3599) := '737369676E29287B7D2C20746869732E434F4E4E454354494F4E5F5354594C452C206174747273207C7C207B7D29293B0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E617070656E642928';
wwv_flow_imp.g_varchar2_table(3600) := '76697375616C732C206C696E65293B0A0A202072657475726E206C696E653B0A7D3B0A0A2F2A2A0A202A2040707269766174650A202A2F0A44656661756C7452656E64657265722E70726F746F747970652E676574536861706550617468203D2066756E';
wwv_flow_imp.g_varchar2_table(3601) := '6374696F6E2067657453686170655061746828736861706529207B0A0A20207661722078203D2073686170652E782C0A20202020202079203D2073686170652E792C0A2020202020207769647468203D2073686170652E77696474682C0A202020202020';
wwv_flow_imp.g_varchar2_table(3602) := '686569676874203D2073686170652E6865696768743B0A0A202076617220736861706550617468203D205B0A202020205B20274D272C20782C2079205D2C0A202020205B20276C272C2077696474682C2030205D2C0A202020205B20276C272C20302C20';
wwv_flow_imp.g_varchar2_table(3603) := '686569676874205D2C0A202020205B20276C272C202D77696474682C2030205D2C0A202020205B20277A27205D0A20205D3B0A0A202072657475726E2028302C5F7574696C5F52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D';
wwv_flow_imp.g_varchar2_table(3604) := '4F44554C455F355F5F2E636F6D706F6E656E7473546F506174682928736861706550617468293B0A7D3B0A0A2F2A2A0A202A2040707269766174650A202A2F0A44656661756C7452656E64657265722E70726F746F747970652E676574436F6E6E656374';
wwv_flow_imp.g_varchar2_table(3605) := '696F6E50617468203D2066756E6374696F6E20676574436F6E6E656374696F6E5061746828636F6E6E656374696F6E29207B0A202076617220776179706F696E7473203D20636F6E6E656374696F6E2E776179706F696E74733B0A0A2020766172206964';
wwv_flow_imp.g_varchar2_table(3606) := '782C20706F696E742C20636F6E6E656374696F6E50617468203D205B5D3B0A0A2020666F722028696478203D20303B2028706F696E74203D20776179706F696E74735B6964785D293B206964782B2B29207B0A0A202020202F2F2074616B6520696E7669';
wwv_flow_imp.g_varchar2_table(3607) := '7369626C6520646F636B696E6720696E746F206163636F756E740A202020202F2F207768656E206372656174696E672074686520706174680A20202020706F696E74203D20706F696E742E6F726967696E616C207C7C20706F696E743B0A0A2020202063';
wwv_flow_imp.g_varchar2_table(3608) := '6F6E6E656374696F6E506174682E70757368285B20696478203D3D3D2030203F20274D27203A20274C272C20706F696E742E782C20706F696E742E79205D293B0A20207D0A0A202072657475726E2028302C5F7574696C5F52656E6465725574696C5F5F';
wwv_flow_imp.g_varchar2_table(3609) := '5745425041434B5F494D504F525445445F4D4F44554C455F355F5F2E636F6D706F6E656E7473546F506174682928636F6E6E656374696F6E50617468293B0A7D3B0A0A44656661756C7452656E64657265722E24696E6A656374203D205B20276576656E';
wwv_flow_imp.g_varchar2_table(3610) := '74427573272C20277374796C657327205D3B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F5374796C65732E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3611) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F5374796C65732E6A73202A2A2A';
wwv_flow_imp.g_varchar2_table(3612) := '210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F776562706163';
wwv_flow_imp.g_varchar2_table(3613) := '6B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F72';
wwv_flow_imp.g_varchar2_table(3614) := '74202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E';
wwv_flow_imp.g_varchar2_table(3615) := '67202A2F205374796C6573290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F';
wwv_flow_imp.g_varchar2_table(3616) := '203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A0A0A0A2F2A2A0A202A204120636F6D';
wwv_flow_imp.g_varchar2_table(3617) := '706F6E656E742074686174206D616E61676573207368617065207374796C65730A202A2F0A66756E6374696F6E205374796C65732829207B0A0A20207661722064656661756C74547261697473203D207B0A0A20202020276E6F2D66696C6C273A207B0A';
wwv_flow_imp.g_varchar2_table(3618) := '20202020202066696C6C3A20276E6F6E65270A202020207D2C0A20202020276E6F2D626F72646572273A207B0A2020202020207374726F6B654F7061636974793A20302E300A202020207D2C0A20202020276E6F2D6576656E7473273A207B0A20202020';
wwv_flow_imp.g_varchar2_table(3619) := '2020706F696E7465724576656E74733A20276E6F6E65270A202020207D0A20207D3B0A0A20207661722073656C66203D20746869733B0A0A20202F2A2A0A2020202A204275696C64732061207374796C6520646566696E6974696F6E2066726F6D206120';
wwv_flow_imp.g_varchar2_table(3620) := '636C6173734E616D652C2061206C697374206F662074726169747320616E6420616E206F626A6563740A2020202A206F66206164646974696F6E616C20617474726962757465732E0A2020202A0A2020202A2040706172616D207B737472696E677D2063';
wwv_flow_imp.g_varchar2_table(3621) := '6C6173734E616D650A2020202A2040706172616D207B737472696E675B5D7D205B7472616974735D0A2020202A2040706172616D207B4F626A6563747D205B6164646974696F6E616C41747472735D0A2020202A0A2020202A204072657475726E207B4F';
wwv_flow_imp.g_varchar2_table(3622) := '626A6563747D20746865207374796C6520646566696E6974696F6E0A2020202A2F0A2020746869732E636C73203D2066756E6374696F6E28636C6173734E616D652C207472616974732C206164646974696F6E616C417474727329207B0A202020207661';
wwv_flow_imp.g_varchar2_table(3623) := '72206174747273203D20746869732E7374796C65287472616974732C206164646974696F6E616C4174747273293B0A0A2020202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E';
wwv_flow_imp.g_varchar2_table(3624) := '61737369676E292861747472732C207B2027636C617373273A20636C6173734E616D65207D293B0A20207D3B0A0A20202F2A2A0A2020202A204275696C64732061207374796C6520646566696E6974696F6E2066726F6D2061206C697374206F66207472';
wwv_flow_imp.g_varchar2_table(3625) := '6169747320616E6420616E206F626A656374206F66206164646974696F6E616C0A2020202A20617474726962757465732E0A2020202A0A2020202A2040706172616D207B737472696E675B5D7D205B7472616974735D0A2020202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(3626) := '4F626A6563747D206164646974696F6E616C41747472730A2020202A0A2020202A204072657475726E207B4F626A6563747D20746865207374796C6520646566696E6974696F6E0A2020202A2F0A2020746869732E7374796C65203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(3627) := '6E287472616974732C206164646974696F6E616C417474727329207B0A0A20202020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6973417272617929287472616974732920262620';
wwv_flow_imp.g_varchar2_table(3628) := '216164646974696F6E616C417474727329207B0A2020202020206164646974696F6E616C4174747273203D207472616974733B0A202020202020747261697473203D205B5D3B0A202020207D0A0A20202020766172206174747273203D2028302C6D696E';
wwv_flow_imp.g_varchar2_table(3629) := '5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E72656475636529287472616974732C2066756E6374696F6E2861747472732C207429207B0A20202020202072657475726E2028302C6D696E5F646173685F5F5745';
wwv_flow_imp.g_varchar2_table(3630) := '425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E292861747472732C2064656661756C745472616974735B745D207C7C207B7D293B0A202020207D2C207B7D293B0A0A2020202072657475726E206164646974696F6E616C';
wwv_flow_imp.g_varchar2_table(3631) := '4174747273203F2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E292861747472732C206164646974696F6E616C417474727329203A2061747472733B0A20207D3B0A0A0A20202F';
wwv_flow_imp.g_varchar2_table(3632) := '2A2A0A2020202A20436F6D70757465732061207374796C6520646566696E6974696F6E2066726F6D2061206C697374206F662074726169747320616E6420616E206F626A656374206F660A2020202A206164646974696F6E616C20617474726962757465';
wwv_flow_imp.g_varchar2_table(3633) := '732C207769746820637573746F6D207374796C6520646566696E6974696F6E206F626A6563742E0A2020202A0A2020202A2040706172616D207B4F626A6563747D20637573746F6D0A2020202A2040706172616D207B737472696E675B5D7D205B747261';
wwv_flow_imp.g_varchar2_table(3634) := '6974735D0A2020202A2040706172616D207B4F626A6563747D2064656661756C745374796C65730A2020202A0A2020202A204072657475726E207B4F626A6563747D20746865207374796C6520646566696E6974696F6E0A2020202A2F0A202074686973';
wwv_flow_imp.g_varchar2_table(3635) := '2E636F6D707574655374796C65203D2066756E6374696F6E28637573746F6D2C207472616974732C2064656661756C745374796C657329207B0A20202020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44';
wwv_flow_imp.g_varchar2_table(3636) := '554C455F305F5F2E6973417272617929287472616974732929207B0A20202020202064656661756C745374796C6573203D207472616974733B0A202020202020747261697473203D205B5D3B0A202020207D0A0A2020202072657475726E2073656C662E';
wwv_flow_imp.g_varchar2_table(3637) := '7374796C6528747261697473207C7C205B5D2C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E29287B7D2C2064656661756C745374796C65732C20637573746F6D207C7C207B7D';
wwv_flow_imp.g_varchar2_table(3638) := '29293B0A20207D3B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3639) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3640) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C';
wwv_flow_imp.g_varchar2_table(3641) := '205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061';
wwv_flow_imp.g_varchar2_table(3642) := '636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F455850';
wwv_flow_imp.g_varchar2_table(3643) := '4F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F44656661756C7452656E64657265725F5F5745425041434B5F494D504F525445445F4D4F44554C455F30';
wwv_flow_imp.g_varchar2_table(3644) := '5F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F44656661756C7452656E6465726572202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F44656661756C7452656E64657265';
wwv_flow_imp.g_varchar2_table(3645) := '722E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F5374796C65735F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F5374';
wwv_flow_imp.g_varchar2_table(3646) := '796C6573202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F5374796C65732E6A7322293B0A0A0A0A2F2A2A0A202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C';
wwv_flow_imp.g_varchar2_table(3647) := '61726174696F6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F696E69745F5F3A205B202764656661';
wwv_flow_imp.g_varchar2_table(3648) := '756C7452656E646572657227205D2C0A202064656661756C7452656E64657265723A205B202774797065272C205F44656661756C7452656E64657265725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C7422';
wwv_flow_imp.g_varchar2_table(3649) := '5D205D2C0A20207374796C65733A205B202774797065272C205F5374796C65735F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D205D0A7D293B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E';
wwv_flow_imp.g_varchar2_table(3650) := '2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6368616E67652D737570706F72742F4368616E6765537570706F72742E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3651) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F666561747572';
wwv_flow_imp.g_varchar2_table(3652) := '65732F6368616E67652D737570706F72742F4368616E6765537570706F72742E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3653) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E';
wwv_flow_imp.g_varchar2_table(3654) := '207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(3655) := '5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F204368616E6765537570706F7274290A2F2A206861726D6F6E79206578706F72';
wwv_flow_imp.g_varchar2_table(3656) := '74202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F456C656D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F28';
wwv_flow_imp.g_varchar2_table(3657) := '2F2A21202E2E2F2E2E2F7574696C2F456C656D656E7473202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F456C656D656E74732E6A7322293B0A0A0A2F2A2A0A202A204074797065646566207B696D70';
wwv_flow_imp.g_varchar2_table(3658) := '6F727428272E2E2F2E2E2F636F72652F43616E76617327292E64656661756C747D2043616E7661730A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F456C656D656E74526567697374727927292E64656661756C747D20';
wwv_flow_imp.g_varchar2_table(3659) := '456C656D656E7452656769737472790A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A204074797065646566207B696D706F727428272E2E';
wwv_flow_imp.g_varchar2_table(3660) := '2F2E2E2F636F72652F4772617068696373466163746F727927292E64656661756C747D204772617068696373466163746F72790A202A2F0A0A2F2A2A0A202A2041646473206368616E676520737570706F727420746F20746865206469616772616D2C20';
wwv_flow_imp.g_varchar2_table(3661) := '696E636C7564696E670A202A0A202A203C756C3E0A202A2020203C6C693E726564726177696E672073686170657320616E6420636F6E6E656374696F6E73206F6E206368616E67653C2F6C693E0A202A203C2F756C3E0A202A0A202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(3662) := '7B4576656E744275737D206576656E744275730A202A2040706172616D207B43616E7661737D2063616E7661730A202A2040706172616D207B456C656D656E7452656769737472797D20656C656D656E7452656769737472790A202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(3663) := '7B4772617068696373466163746F72797D206772617068696373466163746F72790A202A2F0A66756E6374696F6E204368616E6765537570706F7274280A202020206576656E744275732C2063616E7661732C20656C656D656E7452656769737472792C';
wwv_flow_imp.g_varchar2_table(3664) := '0A202020206772617068696373466163746F727929207B0A0A0A20202F2F2072656472617720736861706573202F20636F6E6E656374696F6E73206F6E206368616E67650A0A20206576656E744275732E6F6E2827656C656D656E742E6368616E676564';
wwv_flow_imp.g_varchar2_table(3665) := '272C2066756E6374696F6E286576656E7429207B0A0A2020202076617220656C656D656E74203D206576656E742E656C656D656E743B0A0A202020202F2F20656C656D656E74206D696768742068617665206265656E2064656C6574656420616E642072';
wwv_flow_imp.g_varchar2_table(3666) := '65706C61636564206279206E657720656C656D656E7420776974682073616D652049440A202020202F2F207468757320636865636B20666F7220706172656E74206F6620656C656D656E742065786365707420666F7220726F6F7420656C656D656E740A';
wwv_flow_imp.g_varchar2_table(3667) := '2020202069662028656C656D656E742E706172656E74207C7C20656C656D656E74203D3D3D2063616E7661732E676574526F6F74456C656D656E74282929207B0A2020202020206576656E742E676678203D20656C656D656E7452656769737472792E67';
wwv_flow_imp.g_varchar2_table(3668) := '6574477261706869637328656C656D656E74293B0A202020207D0A0A202020202F2F207368617065202B20676678206D61792068617665206265656E2064656C657465640A2020202069662028216576656E742E67667829207B0A202020202020726574';
wwv_flow_imp.g_varchar2_table(3669) := '75726E3B0A202020207D0A0A202020206576656E744275732E666972652828302C5F7574696C5F456C656D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E676574547970652928656C656D656E7429202B20272E63';
wwv_flow_imp.g_varchar2_table(3670) := '68616E676564272C206576656E74293B0A20207D293B0A0A20206576656E744275732E6F6E2827656C656D656E74732E6368616E676564272C2066756E6374696F6E286576656E7429207B0A0A2020202076617220656C656D656E7473203D206576656E';
wwv_flow_imp.g_varchar2_table(3671) := '742E656C656D656E74733B0A0A20202020656C656D656E74732E666F72456163682866756E6374696F6E286529207B0A2020202020206576656E744275732E666972652827656C656D656E742E6368616E676564272C207B20656C656D656E743A206520';
wwv_flow_imp.g_varchar2_table(3672) := '7D293B0A202020207D293B0A0A202020206772617068696373466163746F72792E757064617465436F6E7461696E6D656E747328656C656D656E7473293B0A20207D293B0A0A20206576656E744275732E6F6E282773686170652E6368616E676564272C';
wwv_flow_imp.g_varchar2_table(3673) := '2066756E6374696F6E286576656E7429207B0A202020206772617068696373466163746F72792E75706461746528277368617065272C206576656E742E656C656D656E742C206576656E742E676678293B0A20207D293B0A0A20206576656E744275732E';
wwv_flow_imp.g_varchar2_table(3674) := '6F6E2827636F6E6E656374696F6E2E6368616E676564272C2066756E6374696F6E286576656E7429207B0A202020206772617068696373466163746F72792E7570646174652827636F6E6E656374696F6E272C206576656E742E656C656D656E742C2065';
wwv_flow_imp.g_varchar2_table(3675) := '76656E742E676678293B0A20207D293B0A7D0A0A4368616E6765537570706F72742E24696E6A656374203D205B0A2020276576656E74427573272C0A20202763616E766173272C0A202027656C656D656E745265676973747279272C0A20202767726170';
wwv_flow_imp.g_varchar2_table(3676) := '68696373466163746F7279270A5D3B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6368616E67652D737570706F72742F696E6465782E6A73223A0A';
wwv_flow_imp.g_varchar2_table(3677) := '2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F64';
wwv_flow_imp.g_varchar2_table(3678) := '69616772616D2D6A732F6C69622F66656174757265732F6368616E67652D737570706F72742F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3679) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F';
wwv_flow_imp.g_varchar2_table(3680) := '29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F776562';
wwv_flow_imp.g_varchar2_table(3681) := '7061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578';
wwv_flow_imp.g_varchar2_table(3682) := '706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F4368616E6765537570706F72745F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F72657175697265';
wwv_flow_imp.g_varchar2_table(3683) := '5F5F282F2A21202E2F4368616E6765537570706F7274202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6368616E67652D737570706F72742F4368616E6765537570706F72742E6A7322293B';
wwv_flow_imp.g_varchar2_table(3684) := '0A0A0A0A2F2A2A0A202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041';
wwv_flow_imp.g_varchar2_table(3685) := '434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F696E69745F5F3A205B20276368616E6765537570706F727427205D2C0A20206368616E6765537570706F72743A205B202774797065272C205F4368616E6765537570706F72745F';
wwv_flow_imp.g_varchar2_table(3686) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D205D0A7D293B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6665617475';
wwv_flow_imp.g_varchar2_table(3687) := '7265732F696E746572616374696F6E2D6576656E74732F496E746572616374696F6E4576656E74732E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3688) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F696E746572616374696F6E2D657665';
wwv_flow_imp.g_varchar2_table(3689) := '6E74732F496E746572616374696F6E4576656E74732E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3690) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B';
wwv_flow_imp.g_varchar2_table(3691) := '0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F65';
wwv_flow_imp.g_varchar2_table(3692) := '78706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F20496E746572616374696F6E4576656E7473290A2F2A206861726D6F6E7920657870';
wwv_flow_imp.g_varchar2_table(3693) := '6F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A2120';
wwv_flow_imp.g_varchar2_table(3694) := '6D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F';
wwv_flow_imp.g_varchar2_table(3695) := '494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A732229';
wwv_flow_imp.g_varchar2_table(3696) := '3B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6F7573655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F';
wwv_flow_imp.g_varchar2_table(3697) := '7574696C2F4D6F757365202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6F7573652E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722074696E795F7376675F5F574542';
wwv_flow_imp.g_varchar2_table(3698) := '5041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D7376672F646973742F696E6465782E65';
wwv_flow_imp.g_varchar2_table(3699) := '736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F';
wwv_flow_imp.g_varchar2_table(3700) := '5F282F2A21202E2E2F2E2E2F7574696C2F52656E6465725574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F52656E6465725574696C2E6A7322293B0A0A0A0A0A0A0A0A0A0A0A2F2A2A0A202A';
wwv_flow_imp.g_varchar2_table(3701) := '204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E740A202A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F456C656D656E745265';
wwv_flow_imp.g_varchar2_table(3702) := '67697374727927292E64656661756C747D20456C656D656E7452656769737472790A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A204074';
wwv_flow_imp.g_varchar2_table(3703) := '797065646566207B696D706F727428272E2E2F2E2E2F647261772F5374796C657327292E64656661756C747D205374796C65730A202A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F7574696C2F547970657327292E506F696E74';
wwv_flow_imp.g_varchar2_table(3704) := '7D20506F696E740A202A2F0A0A66756E6374696F6E20616C6C6F77416C6C286576656E7429207B2072657475726E20747275653B207D0A0A66756E6374696F6E20616C6C6F775072696D617279416E64417578696C69617279286576656E7429207B0A20';
wwv_flow_imp.g_varchar2_table(3705) := '2072657475726E2028302C5F7574696C5F4D6F7573655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69735072696D617279427574746F6E29286576656E7429207C7C2028302C5F7574696C5F4D6F7573655F5F5745425041';
wwv_flow_imp.g_varchar2_table(3706) := '434B5F494D504F525445445F4D4F44554C455F305F5F2E6973417578696C69617279427574746F6E29286576656E74293B0A7D0A0A766172204C4F575F5052494F52495459203D203530303B0A0A0A2F2A2A0A202A204120706C7567696E207468617420';
wwv_flow_imp.g_varchar2_table(3707) := '70726F766964657320696E746572616374696F6E206576656E747320666F72206469616772616D20656C656D656E74732E0A202A0A202A20497420656D6974732074686520666F6C6C6F77696E67206576656E74733A0A202A0A202A2020202A20656C65';
wwv_flow_imp.g_varchar2_table(3708) := '6D656E742E636C69636B0A202A2020202A20656C656D656E742E636F6E746578746D656E750A202A2020202A20656C656D656E742E64626C636C69636B0A202A2020202A20656C656D656E742E686F7665720A202A2020202A20656C656D656E742E6D6F';
wwv_flow_imp.g_varchar2_table(3709) := '757365646F776E0A202A2020202A20656C656D656E742E6D6F7573656D6F76650A202A2020202A20656C656D656E742E6D6F75736575700A202A2020202A20656C656D656E742E6F75740A202A0A202A2045616368206576656E74206973206120747570';
wwv_flow_imp.g_varchar2_table(3710) := '6C65207B20656C656D656E742C206766782C206F726967696E616C4576656E74207D2E0A202A0A202A2043616E63656C696E6720746865206576656E7420766961204576656E742370726576656E7444656661756C7428290A202A2070726576656E7473';
wwv_flow_imp.g_varchar2_table(3711) := '20746865206F726967696E616C20444F4D206F7065726174696F6E2E0A202A0A202A2040706172616D207B4576656E744275737D206576656E744275730A202A2040706172616D207B456C656D656E7452656769737472797D20656C656D656E74526567';
wwv_flow_imp.g_varchar2_table(3712) := '69737472790A202A2040706172616D207B5374796C65737D207374796C65730A202A2F0A66756E6374696F6E20496E746572616374696F6E4576656E7473286576656E744275732C20656C656D656E7452656769737472792C207374796C657329207B0A';
wwv_flow_imp.g_varchar2_table(3713) := '0A20207661722073656C66203D20746869733B0A0A20202F2A2A0A2020202A204669726520616E20696E746572616374696F6E206576656E742E0A2020202A0A2020202A2040706172616D207B737472696E677D2074797065206C6F63616C206576656E';
wwv_flow_imp.g_varchar2_table(3714) := '74206E616D652C20652E672E20656C656D656E742E636C69636B2E0A2020202A2040706172616D207B4D6F7573654576656E747C546F7563684576656E747D206576656E74206E6174697665206576656E740A2020202A2040706172616D207B456C656D';
wwv_flow_imp.g_varchar2_table(3715) := '656E747D205B656C656D656E745D20746865206469616772616D20656C656D656E7420746F20656D697420746865206576656E74206F6E3B0A2020202A202020202020202020202020202020202020202020202020202020202020202020202064656661';
wwv_flow_imp.g_varchar2_table(3716) := '756C747320746F20746865206576656E74207461726765740A2020202A2F0A202066756E6374696F6E206669726528747970652C206576656E742C20656C656D656E7429207B0A0A2020202069662028697349676E6F72656428747970652C206576656E';
wwv_flow_imp.g_varchar2_table(3717) := '742929207B0A20202020202072657475726E3B0A202020207D0A0A20202020766172207461726765742C206766782C2072657475726E56616C75653B0A0A202020206966202821656C656D656E7429207B0A202020202020746172676574203D20657665';
wwv_flow_imp.g_varchar2_table(3718) := '6E742E64656C6567617465546172676574207C7C206576656E742E7461726765743B0A0A2020202020206966202874617267657429207B0A2020202020202020676678203D207461726765743B0A2020202020202020656C656D656E74203D20656C656D';
wwv_flow_imp.g_varchar2_table(3719) := '656E7452656769737472792E67657428676678293B0A2020202020207D0A202020207D20656C7365207B0A202020202020676678203D20656C656D656E7452656769737472792E676574477261706869637328656C656D656E74293B0A202020207D0A0A';
wwv_flow_imp.g_varchar2_table(3720) := '202020206966202821676678207C7C2021656C656D656E7429207B0A20202020202072657475726E3B0A202020207D0A0A2020202072657475726E56616C7565203D206576656E744275732E6669726528747970652C207B0A202020202020656C656D65';
wwv_flow_imp.g_varchar2_table(3721) := '6E743A20656C656D656E742C0A2020202020206766783A206766782C0A2020202020206F726967696E616C4576656E743A206576656E740A202020207D293B0A0A202020206966202872657475726E56616C7565203D3D3D2066616C736529207B0A2020';
wwv_flow_imp.g_varchar2_table(3722) := '202020206576656E742E73746F7050726F7061676174696F6E28293B0A2020202020206576656E742E70726576656E7444656661756C7428293B0A202020207D0A20207D0A0A20202F2F20544F444F286E696B6B75293A20646F63756D656E7420746869';
wwv_flow_imp.g_varchar2_table(3723) := '730A20207661722068616E646C657273203D207B7D3B0A0A202066756E6374696F6E206D6F75736548616E646C6572286C6F63616C4576656E744E616D6529207B0A2020202072657475726E2068616E646C6572735B6C6F63616C4576656E744E616D65';
wwv_flow_imp.g_varchar2_table(3724) := '5D3B0A20207D0A0A202066756E6374696F6E20697349676E6F726564286C6F63616C4576656E744E616D652C206576656E7429207B0A0A202020207661722066696C746572203D2069676E6F72656446696C746572735B6C6F63616C4576656E744E616D';
wwv_flow_imp.g_varchar2_table(3725) := '655D207C7C205F7574696C5F4D6F7573655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69735072696D617279427574746F6E3B0A0A202020202F2F206F6E6C79207265616374206F6E206C656674206D6F75736520627574';
wwv_flow_imp.g_varchar2_table(3726) := '746F6E20696E746572616374696F6E730A202020202F2F2065786365707420666F7220696E746572616374696F6E206576656E747320746861742061726520656E61626C65640A202020202F2F20666F7220736563756E64617279206D6F757365206275';
wwv_flow_imp.g_varchar2_table(3727) := '74746F6E0A2020202072657475726E202166696C746572286576656E74293B0A20207D0A0A20207661722062696E64696E6773203D207B0A20202020636C69636B3A2027656C656D656E742E636C69636B272C0A20202020636F6E746578746D656E753A';
wwv_flow_imp.g_varchar2_table(3728) := '2027656C656D656E742E636F6E746578746D656E75272C0A2020202064626C636C69636B3A2027656C656D656E742E64626C636C69636B272C0A202020206D6F757365646F776E3A2027656C656D656E742E6D6F757365646F776E272C0A202020206D6F';
wwv_flow_imp.g_varchar2_table(3729) := '7573656D6F76653A2027656C656D656E742E6D6F7573656D6F7665272C0A202020206D6F7573656F7665723A2027656C656D656E742E686F766572272C0A202020206D6F7573656F75743A2027656C656D656E742E6F7574272C0A202020206D6F757365';
wwv_flow_imp.g_varchar2_table(3730) := '75703A2027656C656D656E742E6D6F7573657570272C0A20207D3B0A0A20207661722069676E6F72656446696C74657273203D207B0A2020202027656C656D656E742E636F6E746578746D656E75273A20616C6C6F77416C6C2C0A2020202027656C656D';
wwv_flow_imp.g_varchar2_table(3731) := '656E742E6D6F757365646F776E273A20616C6C6F775072696D617279416E64417578696C696172792C0A2020202027656C656D656E742E6D6F7573657570273A20616C6C6F775072696D617279416E64417578696C696172792C0A2020202027656C656D';
wwv_flow_imp.g_varchar2_table(3732) := '656E742E636C69636B273A20616C6C6F775072696D617279416E64417578696C696172792C0A2020202027656C656D656E742E64626C636C69636B273A20616C6C6F775072696D617279416E64417578696C696172790A20207D3B0A0A0A20202F2F206D';
wwv_flow_imp.g_varchar2_table(3733) := '616E75616C206576656E742074726967676572202F2F2F2F2F2F2F2F2F2F0A0A20202F2A2A0A2020202A205472696767657220616E20696E746572616374696F6E206576656E7420286261736564206F6E2061206E617469766520646F6D206576656E74';
wwv_flow_imp.g_varchar2_table(3734) := '290A2020202A206F6E2074686520746172676574207368617065206F7220636F6E6E656374696F6E2E0A2020202A0A2020202A2040706172616D207B737472696E677D206576656E744E616D6520746865206E616D65206F662074686520747269676765';
wwv_flow_imp.g_varchar2_table(3735) := '72656420444F4D206576656E740A2020202A2040706172616D207B4D6F7573654576656E747C546F7563684576656E747D206576656E740A2020202A2040706172616D207B456C656D656E747D20746172676574456C656D656E740A2020202A2F0A2020';
wwv_flow_imp.g_varchar2_table(3736) := '66756E6374696F6E20747269676765724D6F7573654576656E74286576656E744E616D652C206576656E742C20746172676574456C656D656E7429207B0A0A202020202F2F20692E652E20656C656D656E742E6D6F757365646F776E2E2E2E0A20202020';
wwv_flow_imp.g_varchar2_table(3737) := '766172206C6F63616C4576656E744E616D65203D2062696E64696E67735B6576656E744E616D655D3B0A0A2020202069662028216C6F63616C4576656E744E616D6529207B0A2020202020207468726F77206E6577204572726F722827756E6D61707065';
wwv_flow_imp.g_varchar2_table(3738) := '6420444F4D206576656E74206E616D65203C27202B206576656E744E616D65202B20273E27293B0A202020207D0A0A2020202072657475726E2066697265286C6F63616C4576656E744E616D652C206576656E742C20746172676574456C656D656E7429';
wwv_flow_imp.g_varchar2_table(3739) := '3B0A20207D0A0A0A202076617220454C454D454E545F53454C4543544F52203D20277376672C202E646A732D656C656D656E74273B0A0A20202F2F206576656E742068616E646C696E67202F2F2F2F2F2F2F0A0A202066756E6374696F6E207265676973';
wwv_flow_imp.g_varchar2_table(3740) := '7465724576656E74286E6F64652C206576656E742C206C6F63616C4576656E742C2069676E6F72656446696C74657229207B0A0A202020207661722068616E646C6572203D2068616E646C6572735B6C6F63616C4576656E745D203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(3741) := '6E286576656E7429207B0A20202020202066697265286C6F63616C4576656E742C206576656E74293B0A202020207D3B0A0A202020206966202869676E6F72656446696C74657229207B0A20202020202069676E6F72656446696C746572735B6C6F6361';
wwv_flow_imp.g_varchar2_table(3742) := '6C4576656E745D203D2069676E6F72656446696C7465723B0A202020207D0A0A2020202068616E646C65722E2464656C6567617465203D206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E64656C65676174';
wwv_flow_imp.g_varchar2_table(3743) := '652E62696E64286E6F64652C20454C454D454E545F53454C4543544F522C206576656E742C2068616E646C6572293B0A20207D0A0A202066756E6374696F6E20756E72656769737465724576656E74286E6F64652C206576656E742C206C6F63616C4576';
wwv_flow_imp.g_varchar2_table(3744) := '656E7429207B0A0A202020207661722068616E646C6572203D206D6F75736548616E646C6572286C6F63616C4576656E74293B0A0A20202020696620282168616E646C657229207B0A20202020202072657475726E3B0A202020207D0A0A202020206D69';
wwv_flow_imp.g_varchar2_table(3745) := '6E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E64656C65676174652E756E62696E64286E6F64652C206576656E742C2068616E646C65722E2464656C6567617465293B0A20207D0A0A202066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(3746) := '72656769737465724576656E74732873766729207B0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E666F7245616368292862696E64696E67732C2066756E6374696F6E2876616C2C20';
wwv_flow_imp.g_varchar2_table(3747) := '6B657929207B0A20202020202072656769737465724576656E74287376672C206B65792C2076616C293B0A202020207D293B0A20207D0A0A202066756E6374696F6E20756E72656769737465724576656E74732873766729207B0A2020202028302C6D69';
wwv_flow_imp.g_varchar2_table(3748) := '6E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E666F7245616368292862696E64696E67732C2066756E6374696F6E2876616C2C206B657929207B0A202020202020756E72656769737465724576656E74287376';
wwv_flow_imp.g_varchar2_table(3749) := '672C206B65792C2076616C293B0A202020207D293B0A20207D0A0A20206576656E744275732E6F6E282763616E7661732E64657374726F79272C2066756E6374696F6E286576656E7429207B0A20202020756E72656769737465724576656E7473286576';
wwv_flow_imp.g_varchar2_table(3750) := '656E742E737667293B0A20207D293B0A0A20206576656E744275732E6F6E282763616E7661732E696E6974272C2066756E6374696F6E286576656E7429207B0A2020202072656769737465724576656E7473286576656E742E737667293B0A20207D293B';
wwv_flow_imp.g_varchar2_table(3751) := '0A0A0A20202F2F2068697420626F78207570646174696E67202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A20206576656E744275732E6F6E285B202773686170652E6164646564272C2027636F6E6E656374696F6E2E616464656427205D2C2066756E63';
wwv_flow_imp.g_varchar2_table(3752) := '74696F6E286576656E7429207B0A2020202076617220656C656D656E74203D206576656E742E656C656D656E742C0A2020202020202020676678203D206576656E742E6766783B0A0A202020206576656E744275732E666972652827696E746572616374';
wwv_flow_imp.g_varchar2_table(3753) := '696F6E4576656E74732E637265617465486974272C207B20656C656D656E743A20656C656D656E742C206766783A20676678207D293B0A20207D293B0A0A20202F2F2055706461746520646A732D686974206F6E206368616E67652E0A20202F2F204120';
wwv_flow_imp.g_varchar2_table(3754) := '6C6F77207072696F7274697479206973206E65636573736172792C206265636175736520646A732D686974206F66206C6162656C732068617320746F20626520757064617465640A20202F2F20616674657220746865206C6162656C20626F756E647320';
wwv_flow_imp.g_varchar2_table(3755) := '68617665206265656E207570646174656420696E207468652072656E64657265722E0A20206576656E744275732E6F6E285B0A202020202773686170652E6368616E676564272C0A2020202027636F6E6E656374696F6E2E6368616E676564270A20205D';
wwv_flow_imp.g_varchar2_table(3756) := '2C204C4F575F5052494F524954592C2066756E6374696F6E286576656E7429207B0A0A2020202076617220656C656D656E74203D206576656E742E656C656D656E742C0A2020202020202020676678203D206576656E742E6766783B0A0A202020206576';
wwv_flow_imp.g_varchar2_table(3757) := '656E744275732E666972652827696E746572616374696F6E4576656E74732E757064617465486974272C207B20656C656D656E743A20656C656D656E742C206766783A20676678207D293B0A20207D293B0A0A20206576656E744275732E6F6E2827696E';
wwv_flow_imp.g_varchar2_table(3758) := '746572616374696F6E4576656E74732E637265617465486974272C204C4F575F5052494F524954592C2066756E6374696F6E286576656E7429207B0A2020202076617220656C656D656E74203D206576656E742E656C656D656E742C0A20202020202020';
wwv_flow_imp.g_varchar2_table(3759) := '20676678203D206576656E742E6766783B0A0A2020202073656C662E63726561746544656661756C7448697428656C656D656E742C20676678293B0A20207D293B0A0A20206576656E744275732E6F6E2827696E746572616374696F6E4576656E74732E';
wwv_flow_imp.g_varchar2_table(3760) := '757064617465486974272C2066756E6374696F6E286576656E7429207B0A2020202076617220656C656D656E74203D206576656E742E656C656D656E742C0A2020202020202020676678203D206576656E742E6766783B0A0A2020202073656C662E7570';
wwv_flow_imp.g_varchar2_table(3761) := '6461746544656661756C7448697428656C656D656E742C20676678293B0A20207D293B0A0A0A20202F2F20686974207374796C6573202F2F2F2F2F2F2F2F2F2F2F2F0A0A2020766172205354524F4B455F4849545F5354594C45203D2063726561746548';
wwv_flow_imp.g_varchar2_table(3762) := '69745374796C652827646A732D68697420646A732D6869742D7374726F6B6527293B0A0A202076617220434C49434B5F5354524F4B455F4849545F5354594C45203D206372656174654869745374796C652827646A732D68697420646A732D6869742D63';
wwv_flow_imp.g_varchar2_table(3763) := '6C69636B2D7374726F6B6527293B0A0A202076617220414C4C5F4849545F5354594C45203D206372656174654869745374796C652827646A732D68697420646A732D6869742D616C6C27293B0A0A2020766172204E4F5F4D4F56455F4849545F5354594C';
wwv_flow_imp.g_varchar2_table(3764) := '45203D206372656174654869745374796C652827646A732D68697420646A732D6869742D6E6F2D6D6F766527293B0A0A2020766172204849545F5459504553203D207B0A2020202027616C6C273A20414C4C5F4849545F5354594C452C0A202020202763';
wwv_flow_imp.g_varchar2_table(3765) := '6C69636B2D7374726F6B65273A20434C49434B5F5354524F4B455F4849545F5354594C452C0A20202020277374726F6B65273A205354524F4B455F4849545F5354594C452C0A20202020276E6F2D6D6F7665273A204E4F5F4D4F56455F4849545F535459';
wwv_flow_imp.g_varchar2_table(3766) := '4C450A20207D3B0A0A202066756E6374696F6E206372656174654869745374796C6528636C6173734E616D65732C20617474727329207B0A0A202020206174747273203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D';
wwv_flow_imp.g_varchar2_table(3767) := '4F44554C455F325F5F2E61737369676E29287B0A2020202020207374726F6B653A20277768697465272C0A2020202020207374726F6B6557696474683A2031350A202020207D2C206174747273207C7C207B7D293B0A0A2020202072657475726E207374';
wwv_flow_imp.g_varchar2_table(3768) := '796C65732E636C7328636C6173734E616D65732C205B20276E6F2D66696C6C272C20276E6F2D626F7264657227205D2C206174747273293B0A20207D0A0A0A20202F2F207374796C652068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A20';
wwv_flow_imp.g_varchar2_table(3769) := '2066756E6374696F6E206170706C795374796C65286869742C207479706529207B0A0A20202020766172206174747273203D204849545F54595045535B747970655D3B0A0A202020206966202821617474727329207B0A2020202020207468726F77206E';
wwv_flow_imp.g_varchar2_table(3770) := '6577204572726F722827696E76616C6964206869742074797065203C27202B2074797065202B20273E27293B0A202020207D0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E617474';
wwv_flow_imp.g_varchar2_table(3771) := '7229286869742C206174747273293B0A0A2020202072657475726E206869743B0A20207D0A0A202066756E6374696F6E20617070656E64486974286766782C2068697429207B0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(3772) := '525445445F4D4F44554C455F335F5F2E617070656E6429286766782C20686974293B0A20207D0A0A0A20202F2F204150490A0A20202F2A2A0A2020202A2052656D6F76652068696E7473206F6E2074686520676976656E2067726170686963732E0A2020';
wwv_flow_imp.g_varchar2_table(3773) := '202A0A2020202A2040706172616D207B535647456C656D656E747D206766780A2020202A2F0A2020746869732E72656D6F766548697473203D2066756E6374696F6E2867667829207B0A202020207661722068697473203D2028302C6D696E5F646F6D5F';
wwv_flow_imp.g_varchar2_table(3774) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E7175657279416C6C2928272E646A732D686974272C20676678293B0A0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F32';
wwv_flow_imp.g_varchar2_table(3775) := '5F5F2E666F72456163682928686974732C2074696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E72656D6F7665293B0A20207D3B0A0A20202F2A2A0A2020202A204372656174652064656661756C7420686974';
wwv_flow_imp.g_varchar2_table(3776) := '20666F722074686520676976656E20656C656D656E742E0A2020202A0A2020202A2040706172616D207B456C656D656E747D20656C656D656E740A2020202A2040706172616D207B535647456C656D656E747D206766780A2020202A0A2020202A204072';
wwv_flow_imp.g_varchar2_table(3777) := '657475726E207B535647456C656D656E747D2063726561746564206869740A2020202A2F0A2020746869732E63726561746544656661756C74486974203D2066756E6374696F6E28656C656D656E742C2067667829207B0A202020207661722077617970';
wwv_flow_imp.g_varchar2_table(3778) := '6F696E7473203D20656C656D656E742E776179706F696E74732C0A202020202020202069734672616D65203D20656C656D656E742E69734672616D652C0A2020202020202020626F78547970653B0A0A2020202069662028776179706F696E747329207B';
wwv_flow_imp.g_varchar2_table(3779) := '0A20202020202072657475726E20746869732E637265617465576179706F696E7473486974286766782C20776179706F696E7473293B0A202020207D20656C7365207B0A0A202020202020626F7854797065203D2069734672616D65203F20277374726F';
wwv_flow_imp.g_varchar2_table(3780) := '6B6527203A2027616C6C273B0A0A20202020202072657475726E20746869732E637265617465426F78486974286766782C20626F78547970652C207B0A202020202020202077696474683A20656C656D656E742E77696474682C0A202020202020202068';
wwv_flow_imp.g_varchar2_table(3781) := '65696768743A20656C656D656E742E6865696768740A2020202020207D293B0A202020207D0A20207D3B0A0A20202F2A2A0A2020202A20437265617465206869747320666F722074686520676976656E20776179706F696E74732E0A2020202A0A202020';
wwv_flow_imp.g_varchar2_table(3782) := '2A2040706172616D207B535647456C656D656E747D206766780A2020202A2040706172616D207B506F696E745B5D7D20776179706F696E74730A2020202A0A2020202A204072657475726E207B535647456C656D656E747D0A2020202A2F0A2020746869';
wwv_flow_imp.g_varchar2_table(3783) := '732E637265617465576179706F696E7473486974203D2066756E6374696F6E286766782C20776179706F696E747329207B0A0A2020202076617220686974203D2028302C5F7574696C5F52656E6465725574696C5F5F5745425041434B5F494D504F5254';
wwv_flow_imp.g_varchar2_table(3784) := '45445F4D4F44554C455F345F5F2E6372656174654C696E652928776179706F696E7473293B0A0A202020206170706C795374796C65286869742C20277374726F6B6527293B0A0A20202020617070656E64486974286766782C20686974293B0A0A202020';
wwv_flow_imp.g_varchar2_table(3785) := '2072657475726E206869743B0A20207D3B0A0A20202F2A2A0A2020202A20437265617465206869747320666F72206120626F782E0A2020202A0A2020202A2040706172616D207B535647456C656D656E747D206766780A2020202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(3786) := '737472696E677D20747970650A2020202A2040706172616D207B4F626A6563747D2061747472730A2020202A0A2020202A204072657475726E207B535647456C656D656E747D0A2020202A2F0A2020746869732E637265617465426F78486974203D2066';
wwv_flow_imp.g_varchar2_table(3787) := '756E6374696F6E286766782C20747970652C20617474727329207B0A0A202020206174747273203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E29287B0A202020202020783A';
wwv_flow_imp.g_varchar2_table(3788) := '20302C0A202020202020793A20300A202020207D2C206174747273293B0A0A2020202076617220686974203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6372656174652928277265637427';
wwv_flow_imp.g_varchar2_table(3789) := '293B0A0A202020206170706C795374796C65286869742C2074797065293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6174747229286869742C206174747273293B0A0A202020';
wwv_flow_imp.g_varchar2_table(3790) := '20617070656E64486974286766782C20686974293B0A0A2020202072657475726E206869743B0A20207D3B0A0A20202F2A2A0A2020202A205570646174652064656661756C7420686974206F662074686520656C656D656E742E0A2020202A0A2020202A';
wwv_flow_imp.g_varchar2_table(3791) := '2040706172616D207B456C656D656E747D20656C656D656E740A2020202A2040706172616D207B535647456C656D656E747D206766780A2020202A0A2020202A204072657475726E207B535647456C656D656E747D2075706461746564206869740A2020';
wwv_flow_imp.g_varchar2_table(3792) := '202A2F0A2020746869732E75706461746544656661756C74486974203D2066756E6374696F6E28656C656D656E742C2067667829207B0A0A2020202076617220686974203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D';
wwv_flow_imp.g_varchar2_table(3793) := '4F44554C455F315F5F2E71756572792928272E646A732D686974272C20676678293B0A0A20202020696620282168697429207B0A20202020202072657475726E3B0A202020207D0A0A2020202069662028656C656D656E742E776179706F696E74732920';
wwv_flow_imp.g_varchar2_table(3794) := '7B0A20202020202028302C5F7574696C5F52656E6465725574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E7570646174654C696E6529286869742C20656C656D656E742E776179706F696E7473293B0A202020207D20';
wwv_flow_imp.g_varchar2_table(3795) := '656C7365207B0A20202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E6174747229286869742C207B0A202020202020202077696474683A20656C656D656E742E77696474682C0A202020';
wwv_flow_imp.g_varchar2_table(3796) := '20202020206865696768743A20656C656D656E742E6865696768740A2020202020207D293B0A202020207D0A0A2020202072657475726E206869743B0A20207D3B0A0A2020746869732E66697265203D20666972653B0A0A2020746869732E7472696767';
wwv_flow_imp.g_varchar2_table(3797) := '65724D6F7573654576656E74203D20747269676765724D6F7573654576656E743B0A0A2020746869732E6D6F75736548616E646C6572203D206D6F75736548616E646C65723B0A0A2020746869732E72656769737465724576656E74203D207265676973';
wwv_flow_imp.g_varchar2_table(3798) := '7465724576656E743B0A2020746869732E756E72656769737465724576656E74203D20756E72656769737465724576656E743B0A7D0A0A0A496E746572616374696F6E4576656E74732E24696E6A656374203D205B0A2020276576656E74427573272C0A';
wwv_flow_imp.g_varchar2_table(3799) := '202027656C656D656E745265676973747279272C0A2020277374796C6573270A5D3B0A0A0A2F2A2A0A202A20416E206576656E7420696E6469636174696E67207468617420746865206D6F75736520686F7665726564206F76657220616E20656C656D65';
wwv_flow_imp.g_varchar2_table(3800) := '6E740A202A0A202A20406576656E7420656C656D656E742E686F7665720A202A0A202A204074797065207B4F626A6563747D0A202A204070726F7065727479207B456C656D656E747D20656C656D656E740A202A204070726F7065727479207B53564745';
wwv_flow_imp.g_varchar2_table(3801) := '6C656D656E747D206766780A202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E740A202A2F0A0A2F2A2A0A202A20416E206576656E7420696E6469636174696E67207468617420746865206D6F75736520686173206C65';
wwv_flow_imp.g_varchar2_table(3802) := '667420616E20656C656D656E740A202A0A202A20406576656E7420656C656D656E742E6F75740A202A0A202A204074797065207B4F626A6563747D0A202A204070726F7065727479207B456C656D656E747D20656C656D656E740A202A204070726F7065';
wwv_flow_imp.g_varchar2_table(3803) := '727479207B535647456C656D656E747D206766780A202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E740A202A2F0A0A2F2A2A0A202A20416E206576656E7420696E6469636174696E67207468617420746865206D6F75';
wwv_flow_imp.g_varchar2_table(3804) := '73652068617320636C69636B656420616E20656C656D656E740A202A0A202A20406576656E7420656C656D656E742E636C69636B0A202A0A202A204074797065207B4F626A6563747D0A202A204070726F7065727479207B456C656D656E747D20656C65';
wwv_flow_imp.g_varchar2_table(3805) := '6D656E740A202A204070726F7065727479207B535647456C656D656E747D206766780A202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E740A202A2F0A0A2F2A2A0A202A20416E206576656E7420696E6469636174696E';
wwv_flow_imp.g_varchar2_table(3806) := '67207468617420746865206D6F7573652068617320646F75626C6520636C69636B656420616E20656C656D656E740A202A0A202A20406576656E7420656C656D656E742E64626C636C69636B0A202A0A202A204074797065207B4F626A6563747D0A202A';
wwv_flow_imp.g_varchar2_table(3807) := '204070726F7065727479207B456C656D656E747D20656C656D656E740A202A204070726F7065727479207B535647456C656D656E747D206766780A202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E740A202A2F0A0A2F';
wwv_flow_imp.g_varchar2_table(3808) := '2A2A0A202A20416E206576656E7420696E6469636174696E67207468617420746865206D6F7573652068617320676F6E6520646F776E206F6E20616E20656C656D656E742E0A202A0A202A20406576656E7420656C656D656E742E6D6F757365646F776E';
wwv_flow_imp.g_varchar2_table(3809) := '0A202A0A202A204074797065207B4F626A6563747D0A202A204070726F7065727479207B456C656D656E747D20656C656D656E740A202A204070726F7065727479207B535647456C656D656E747D206766780A202A204070726F7065727479207B457665';
wwv_flow_imp.g_varchar2_table(3810) := '6E747D206F726967696E616C4576656E740A202A2F0A0A2F2A2A0A202A20416E206576656E7420696E6469636174696E67207468617420746865206D6F7573652068617320676F6E65207570206F6E20616E20656C656D656E742E0A202A0A202A204065';
wwv_flow_imp.g_varchar2_table(3811) := '76656E7420656C656D656E742E6D6F75736575700A202A0A202A204074797065207B4F626A6563747D0A202A204070726F7065727479207B456C656D656E747D20656C656D656E740A202A204070726F7065727479207B535647456C656D656E747D2067';
wwv_flow_imp.g_varchar2_table(3812) := '66780A202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E740A202A2F0A0A2F2A2A0A202A20416E206576656E7420696E6469636174696E6720746861742074686520636F6E74657874206D656E7520616374696F6E2069';
wwv_flow_imp.g_varchar2_table(3813) := '73207472696767657265640A202A20766961206D6F757365206F7220746F75636820636F6E74726F6C732E0A202A0A202A20406576656E7420656C656D656E742E636F6E746578746D656E750A202A0A202A204074797065207B4F626A6563747D0A202A';
wwv_flow_imp.g_varchar2_table(3814) := '204070726F7065727479207B456C656D656E747D20656C656D656E740A202A204070726F7065727479207B535647456C656D656E747D206766780A202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E740A202A2F0A0A2F';
wwv_flow_imp.g_varchar2_table(3815) := '2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F696E746572616374696F6E2D6576656E74732F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3816) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F';
wwv_flow_imp.g_varchar2_table(3817) := '6C69622F66656174757265732F696E746572616374696F6E2D6576656E74732F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3818) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F2920';
wwv_flow_imp.g_varchar2_table(3819) := '3D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061';
wwv_flow_imp.g_varchar2_table(3820) := '636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F';
wwv_flow_imp.g_varchar2_table(3821) := '7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F496E746572616374696F6E4576656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F7265717569';
wwv_flow_imp.g_varchar2_table(3822) := '72655F5F282F2A21202E2F496E746572616374696F6E4576656E7473202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F696E746572616374696F6E2D6576656E74732F496E74657261637469';
wwv_flow_imp.g_varchar2_table(3823) := '6F6E4576656E74732E6A7322293B0A0A0A0A2F2A2A0A202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F';
wwv_flow_imp.g_varchar2_table(3824) := '20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F696E69745F5F3A205B2027696E746572616374696F6E4576656E747327205D2C0A2020696E746572616374696F6E4576656E74733A205B2027';
wwv_flow_imp.g_varchar2_table(3825) := '74797065272C205F496E746572616374696F6E4576656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D205D0A7D293B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F';
wwv_flow_imp.g_varchar2_table(3826) := '64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F75746C696E652F4F75746C696E652E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3827) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F75746C696E652F4F75746C696E652E6A73202A2A2A210A20205C2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3828) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765';
wwv_flow_imp.g_varchar2_table(3829) := '627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E792065';
wwv_flow_imp.g_varchar2_table(3830) := '78706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A206269';
wwv_flow_imp.g_varchar2_table(3831) := '6E64696E67202A2F204F75746C696E65290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F456C656D656E74735F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(3832) := '5F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F456C656D656E7473202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F456C65';
wwv_flow_imp.g_varchar2_table(3833) := '6D656E74732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722074696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21';
wwv_flow_imp.g_varchar2_table(3834) := '2074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D7376672F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B';
wwv_flow_imp.g_varchar2_table(3835) := '5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322';
wwv_flow_imp.g_varchar2_table(3836) := '293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368';
wwv_flow_imp.g_varchar2_table(3837) := '202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A0A0A766172204C4F575F5052494F52495459203D203530303B0A0A0A0A0A0A0A0A7661722044454641554C545F5052494F52';
wwv_flow_imp.g_varchar2_table(3838) := '495459203D20313030303B0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E740A202A0A202A204074797065646566207B696D706F727428272E';
wwv_flow_imp.g_varchar2_table(3839) := '2F4F75746C696E6550726F766964657227292E64656661756C747D204F75746C696E6550726F76696465720A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E';
wwv_flow_imp.g_varchar2_table(3840) := '744275730A202A204074797065646566207B696D706F727428272E2E2F2E2E2F647261772F5374796C657327292E64656661756C747D205374796C65730A202A2F0A0A2F2A2A0A202A2040636C6173730A202A0A202A204120706C7567696E2074686174';
wwv_flow_imp.g_varchar2_table(3841) := '206164647320616E206F75746C696E6520746F2073686170657320616E6420636F6E6E656374696F6E732074686174206D61792062652061637469766174656420616E64207374796C65640A202A207669612043535320636C61737365732E0A202A0A20';
wwv_flow_imp.g_varchar2_table(3842) := '2A2040706172616D207B4576656E744275737D206576656E744275730A202A2040706172616D207B5374796C65737D207374796C65730A202A2F0A66756E6374696F6E204F75746C696E65286576656E744275732C207374796C657329207B0A0A202074';
wwv_flow_imp.g_varchar2_table(3843) := '6869732E5F6576656E74427573203D206576656E744275733B0A0A2020746869732E6F6666736574203D20353B0A0A2020766172204F55544C494E455F5354594C45203D207374796C65732E636C732827646A732D6F75746C696E65272C205B20276E6F';
wwv_flow_imp.g_varchar2_table(3844) := '2D66696C6C27205D293B0A0A20207661722073656C66203D20746869733B0A0A20202F2A2A0A2020202A2040706172616D207B535647456C656D656E747D206766780A2020202A0A2020202A204072657475726E207B535647456C656D656E747D206F75';
wwv_flow_imp.g_varchar2_table(3845) := '746C696E650A2020202A2F0A202066756E6374696F6E206372656174654F75746C696E652867667829207B0A20202020766172206F75746C696E65203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F30';
wwv_flow_imp.g_varchar2_table(3846) := '5F5F2E6372656174652928277265637427293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6174747229286F75746C696E652C2028302C6D696E5F646173685F5F574542504143';
wwv_flow_imp.g_varchar2_table(3847) := '4B5F494D504F525445445F4D4F44554C455F315F5F2E61737369676E29287B0A202020202020783A20302C0A202020202020793A20302C0A20202020202072783A20342C0A20202020202077696474683A203130302C0A2020202020206865696768743A';
wwv_flow_imp.g_varchar2_table(3848) := '203130300A202020207D2C204F55544C494E455F5354594C4529293B0A0A2020202072657475726E206F75746C696E653B0A20207D0A0A20202F2F2041206C6F77207072696F7274697479206973206E65636573736172792C2062656361757365206F75';
wwv_flow_imp.g_varchar2_table(3849) := '746C696E6573206F66206C6162656C73206861766520746F20626520757064617465640A20202F2F20616674657220746865206C6162656C20626F756E64732068617665206265656E207570646174656420696E207468652072656E64657265722E0A20';
wwv_flow_imp.g_varchar2_table(3850) := '206576656E744275732E6F6E285B202773686170652E6164646564272C202773686170652E6368616E67656427205D2C204C4F575F5052494F524954592C2066756E6374696F6E286576656E7429207B0A2020202076617220656C656D656E74203D2065';
wwv_flow_imp.g_varchar2_table(3851) := '76656E742E656C656D656E742C0A2020202020202020676678203D206576656E742E6766783B0A0A20202020766172206F75746C696E65203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E7175';
wwv_flow_imp.g_varchar2_table(3852) := '6572792928272E646A732D6F75746C696E65272C20676678293B0A0A2020202069662028216F75746C696E6529207B0A2020202020206F75746C696E65203D2073656C662E6765744F75746C696E6528656C656D656E7429207C7C206372656174654F75';
wwv_flow_imp.g_varchar2_table(3853) := '746C696E6528676678293B0A20202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E617070656E6429286766782C206F75746C696E65293B0A202020207D0A0A2020202073656C662E7570';
wwv_flow_imp.g_varchar2_table(3854) := '6461746553686170654F75746C696E65286F75746C696E652C20656C656D656E74293B0A20207D293B0A0A20206576656E744275732E6F6E285B2027636F6E6E656374696F6E2E6164646564272C2027636F6E6E656374696F6E2E6368616E6765642720';
wwv_flow_imp.g_varchar2_table(3855) := '5D2C2066756E6374696F6E286576656E7429207B0A2020202076617220656C656D656E74203D206576656E742E656C656D656E742C0A2020202020202020676678203D206576656E742E6766783B0A0A20202020766172206F75746C696E65203D202830';
wwv_flow_imp.g_varchar2_table(3856) := '2C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E71756572792928272E646A732D6F75746C696E65272C20676678293B0A0A2020202069662028216F75746C696E6529207B0A2020202020206F75746C696E';
wwv_flow_imp.g_varchar2_table(3857) := '65203D206372656174654F75746C696E6528676678293B0A20202020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E617070656E6429286766782C206F75746C696E65293B0A202020207D0A';
wwv_flow_imp.g_varchar2_table(3858) := '0A2020202073656C662E757064617465436F6E6E656374696F6E4F75746C696E65286F75746C696E652C20656C656D656E74293B0A20207D293B0A7D0A0A0A2F2A2A0A202A205570646174657320746865206F75746C696E65206F662061207368617065';
wwv_flow_imp.g_varchar2_table(3859) := '2072657370656374696E67207468652064696D656E73696F6E206F66207468650A202A20656C656D656E7420616E6420616E206F75746C696E65206F66667365742E0A202A0A202A2040706172616D207B535647456C656D656E747D206F75746C696E65';
wwv_flow_imp.g_varchar2_table(3860) := '0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A2F0A4F75746C696E652E70726F746F747970652E75706461746553686170654F75746C696E65203D2066756E6374696F6E286F75746C696E652C20656C656D656E7429207B';
wwv_flow_imp.g_varchar2_table(3861) := '0A0A20207661722075706461746564203D2066616C73653B0A20207661722070726F766964657273203D20746869732E5F67657450726F76696465727328293B0A0A20206966202870726F7669646572732E6C656E67746829207B0A2020202028302C6D';
wwv_flow_imp.g_varchar2_table(3862) := '696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F7245616368292870726F7669646572732C2066756E6374696F6E2870726F766964657229207B0A20202020202075706461746564203D20757064617465';
wwv_flow_imp.g_varchar2_table(3863) := '64207C7C2070726F76696465722E7570646174654F75746C696E6528656C656D656E742C206F75746C696E65293B0A202020207D293B0A20207D0A0A202069662028217570646174656429207B0A2020202028302C74696E795F7376675F5F5745425041';
wwv_flow_imp.g_varchar2_table(3864) := '434B5F494D504F525445445F4D4F44554C455F305F5F2E6174747229286F75746C696E652C207B0A202020202020783A202D746869732E6F66667365742C0A202020202020793A202D746869732E6F66667365742C0A20202020202077696474683A2065';
wwv_flow_imp.g_varchar2_table(3865) := '6C656D656E742E7769647468202B20746869732E6F6666736574202A20322C0A2020202020206865696768743A20656C656D656E742E686569676874202B20746869732E6F6666736574202A20320A202020207D293B0A20207D0A7D3B0A0A2F2A2A0A20';
wwv_flow_imp.g_varchar2_table(3866) := '2A205570646174657320746865206F75746C696E65206F66206120636F6E6E656374696F6E2072657370656374696E672074686520626F756E64696E6720626F78206F660A202A2074686520636F6E6E656374696F6E20616E6420616E206F75746C696E';
wwv_flow_imp.g_varchar2_table(3867) := '65206F66667365742E0A202A20526567697374657220616E206F75746C696E652070726F766964657220776974682074686520676976656E207072696F726974792E0A202A0A202A2040706172616D207B535647456C656D656E747D206F75746C696E65';
wwv_flow_imp.g_varchar2_table(3868) := '0A202A2040706172616D207B456C656D656E747D20636F6E6E656374696F6E0A202A2F0A4F75746C696E652E70726F746F747970652E757064617465436F6E6E656374696F6E4F75746C696E65203D2066756E6374696F6E286F75746C696E652C20636F';
wwv_flow_imp.g_varchar2_table(3869) := '6E6E656374696F6E29207B0A20207661722062626F78203D2028302C5F7574696C5F456C656D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E67657442426F782928636F6E6E656374696F6E293B0A0A202028302C';
wwv_flow_imp.g_varchar2_table(3870) := '74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6174747229286F75746C696E652C207B0A20202020783A2062626F782E78202D20746869732E6F66667365742C0A20202020793A2062626F782E79202D20';
wwv_flow_imp.g_varchar2_table(3871) := '746869732E6F66667365742C0A2020202077696474683A2062626F782E7769647468202B20746869732E6F6666736574202A20322C0A202020206865696768743A2062626F782E686569676874202B20746869732E6F6666736574202A20320A20207D29';
wwv_flow_imp.g_varchar2_table(3872) := '3B0A7D3B0A0A2F2A2A0A202A20526567697374657220616E206F75746C696E652070726F766964657220776974682074686520676976656E207072696F726974792E0A202A0A202A2040706172616D207B6E756D6265727D207072696F726974790A202A';
wwv_flow_imp.g_varchar2_table(3873) := '2040706172616D207B4F75746C696E6550726F76696465727D2070726F76696465720A202A2F0A4F75746C696E652E70726F746F747970652E726567697374657250726F7669646572203D2066756E6374696F6E287072696F726974792C2070726F7669';
wwv_flow_imp.g_varchar2_table(3874) := '64657229207B0A2020696620282170726F766964657229207B0A2020202070726F7669646572203D207072696F726974793B0A202020207072696F72697479203D2044454641554C545F5052494F524954593B0A20207D0A0A2020746869732E5F657665';
wwv_flow_imp.g_varchar2_table(3875) := '6E744275732E6F6E28276F75746C696E652E67657450726F766964657273272C207072696F726974792C2066756E6374696F6E286576656E7429207B0A202020206576656E742E70726F7669646572732E707573682870726F7669646572293B0A20207D';
wwv_flow_imp.g_varchar2_table(3876) := '293B0A7D3B0A0A2F2A2A0A202A2052657475726E73207468652072656769737465726564206F75746C696E652070726F7669646572732E0A202A0A202A204072657475726E73207B4F75746C696E6550726F76696465725B5D7D0A202A2F0A4F75746C69';
wwv_flow_imp.g_varchar2_table(3877) := '6E652E70726F746F747970652E5F67657450726F766964657273203D2066756E6374696F6E2829207B0A2020766172206576656E74203D20746869732E5F6576656E744275732E6372656174654576656E74287B0A20202020747970653A20276F75746C';
wwv_flow_imp.g_varchar2_table(3878) := '696E652E67657450726F766964657273272C0A2020202070726F7669646572733A205B5D0A20207D293B0A0A2020746869732E5F6576656E744275732E66697265286576656E74293B0A0A202072657475726E206576656E742E70726F7669646572733B';
wwv_flow_imp.g_varchar2_table(3879) := '0A7D3B0A0A2F2A2A0A202A2052657475726E7320746865206F75746C696E6520666F7220616E20656C656D656E742E0A202A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A2F0A4F75746C696E652E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(3880) := '2E6765744F75746C696E65203D2066756E6374696F6E28656C656D656E7429207B0A2020766172206F75746C696E653B0A20207661722070726F766964657273203D20746869732E5F67657450726F76696465727328293B0A0A202028302C6D696E5F64';
wwv_flow_imp.g_varchar2_table(3881) := '6173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F7245616368292870726F7669646572732C2066756E6374696F6E2870726F766964657229207B0A0A20202020696620282128302C6D696E5F646173685F5F574542';
wwv_flow_imp.g_varchar2_table(3882) := '5041434B5F494D504F525445445F4D4F44554C455F315F5F2E697346756E6374696F6E292870726F76696465722E6765744F75746C696E652929207B0A20202020202072657475726E3B0A202020207D0A0A202020206F75746C696E65203D206F75746C';
wwv_flow_imp.g_varchar2_table(3883) := '696E65207C7C2070726F76696465722E6765744F75746C696E6528656C656D656E74293B0A20207D293B0A0A202072657475726E206F75746C696E653B0A7D3B0A0A4F75746C696E652E24696E6A656374203D205B20276576656E74427573272C202773';
wwv_flow_imp.g_varchar2_table(3884) := '74796C6573272C2027656C656D656E74526567697374727927205D3B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F75746C696E652F696E646578';
wwv_flow_imp.g_varchar2_table(3885) := '2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469';
wwv_flow_imp.g_varchar2_table(3886) := '616772616D2D6A732F6C69622F66656174757265732F6F75746C696E652F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3887) := '2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061';
wwv_flow_imp.g_varchar2_table(3888) := '636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C';
wwv_flow_imp.g_varchar2_table(3889) := '207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A20';
wwv_flow_imp.g_varchar2_table(3890) := '6861726D6F6E7920696D706F7274202A2F20766172205F4F75746C696E655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4F75746C696E65202A2F2022';
wwv_flow_imp.g_varchar2_table(3891) := '2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F75746C696E652F4F75746C696E652E6A7322293B0A0A0A0A2F2A2A0A202A204074797065207B20696D706F727428276469646927292E4D6F64756C65';
wwv_flow_imp.g_varchar2_table(3892) := '4465636C61726174696F6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F696E69745F5F3A205B2027';
wwv_flow_imp.g_varchar2_table(3893) := '6F75746C696E6527205D2C0A20206F75746C696E653A205B202774797065272C205F4F75746C696E655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D205D0A7D293B0A0A2F2A2A2A2F207D292C0A0A';
wwv_flow_imp.g_varchar2_table(3894) := '2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F7665726C6179732F4F7665726C6179732E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(3895) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F7665726C6179732F4F76';
wwv_flow_imp.g_varchar2_table(3896) := '65726C6179732E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E75';
wwv_flow_imp.g_varchar2_table(3897) := '7365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F';
wwv_flow_imp.g_varchar2_table(3898) := '6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020';
wwv_flow_imp.g_varchar2_table(3899) := '202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F204F7665726C617973290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173';
wwv_flow_imp.g_varchar2_table(3900) := '685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F69';
wwv_flow_imp.g_varchar2_table(3901) := '6E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F';
wwv_flow_imp.g_varchar2_table(3902) := '2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F456C656D656E74735F5F';
wwv_flow_imp.g_varchar2_table(3903) := '5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F456C656D656E7473202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D';
wwv_flow_imp.g_varchar2_table(3904) := '2D6A732F6C69622F7574696C2F456C656D656E74732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F496447656E657261746F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F20';
wwv_flow_imp.g_varchar2_table(3905) := '3D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F496447656E657261746F72202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F496447656E657261746F722E';
wwv_flow_imp.g_varchar2_table(3906) := '6A7322293B0A0A0A0A0A0A0A0A0A2F2F20646F63756D656E74207769646520756E69717565206F7665726C6179206964730A76617220696473203D206E6577205F7574696C5F496447656E657261746F725F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(3907) := '4D4F44554C455F305F5F5B2264656661756C74225D28276F7627293B0A0A766172204C4F575F5052494F52495459203D203530303B0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E';
wwv_flow_imp.g_varchar2_table(3908) := '64656661756C747D2043616E7661730A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F456C656D656E74526567697374727927292E64656661756C747D20456C656D656E7452656769737472790A202A20407479706564';
wwv_flow_imp.g_varchar2_table(3909) := '6566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D';
wwv_flow_imp.g_varchar2_table(3910) := '656E747D20456C656D656E740A202A0A202A204074797065646566207B207B0A202A2020206D696E5A6F6F6D3F3A206E756D6265722C0A202A2020206D61785A6F6F6D3F3A206E756D6265720A202A207D207D204F7665726C617973436F6E6669675368';
wwv_flow_imp.g_varchar2_table(3911) := '6F770A202A0A202A204074797065646566207B207B0A202A2020206D696E3F3A206E756D6265722C0A202A2020206D61783F3A206E756D6265720A202A207D207D204F7665726C617973436F6E6669675363616C650A202A0A202A204074797065646566';
wwv_flow_imp.g_varchar2_table(3912) := '207B207B0A2A20202069643A20737472696E672C0A2A202020747970653A20737472696E67207C206E756C6C2C0A2A202020656C656D656E743A20456C656D656E74207C20737472696E670A2A207D2026204F7665726C61794174747273207D204F7665';
wwv_flow_imp.g_varchar2_table(3913) := '726C61790A2A0A202A204074797065646566207B207B0A202A20202068746D6C3A2048544D4C456C656D656E74207C20737472696E672C0A202A202020706F736974696F6E3A207B0A202A2020202020746F703F3A206E756D6265722C0A202A20202020';
wwv_flow_imp.g_varchar2_table(3914) := '2072696768743F3A206E756D6265722C0A202A2020202020626F74746F6D3F3A206E756D6265722C0A202A20202020206C6566743F3A206E756D6265720A202A2020207D0A202A207D2026204F7665726C617973436F6E66696744656661756C74207D20';
wwv_flow_imp.g_varchar2_table(3915) := '4F7665726C617941747472730A202A0A202A204074797065646566207B207B0A202A20202068746D6C3A2048544D4C456C656D656E742C0A202A202020656C656D656E743A20456C656D656E742C0A202A2020206F7665726C6179733A204F7665726C61';
wwv_flow_imp.g_varchar2_table(3916) := '795B5D0A202A207D207D204F7665726C6179436F6E7461696E65720A202A0A202A204074797065646566207B7B0A202A20202064656661756C74733F3A204F7665726C617973436F6E66696744656661756C740A202A207D7D204F7665726C617973436F';
wwv_flow_imp.g_varchar2_table(3917) := '6E6669670A202A0A202A204074797065646566207B207B0A202A202073686F773F3A204F7665726C617973436F6E66696753686F772C0A202A20207363616C653F3A204F7665726C617973436F6E6669675363616C65207C20626F6F6C65616E0A202A20';
wwv_flow_imp.g_varchar2_table(3918) := '7D207D204F7665726C617973436F6E66696744656661756C740A202A0A202A204074797065646566207B207B0A202A20202069643F3A20737472696E673B0A202A202020656C656D656E743F3A20456C656D656E74207C20737472696E673B0A202A2020';
wwv_flow_imp.g_varchar2_table(3919) := '20747970653F3A20737472696E673B0A202A207D207C20737472696E67207D204F7665726C61797346696C7465720A202A2F0A0A2F2A2A0A202A20412073657276696365207468617420616C6C6F777320757365727320746F20617474616368206F7665';
wwv_flow_imp.g_varchar2_table(3920) := '726C61797320746F206469616772616D20656C656D656E74732E0A202A0A202A20546865206F7665726C617920736572766963652077696C6C2074616B652063617265206F66206F7665726C617920706F736974696F6E696E6720647572696E67207570';
wwv_flow_imp.g_varchar2_table(3921) := '64617465732E0A202A0A202A20406578616D706C650A202A0A202A206060606A6176617363726970740A202A202F2F2061646420612070696E6B206261646765206F6E2074686520746F70206C656674206F66207468652073686170650A202A0A202A20';
wwv_flow_imp.g_varchar2_table(3922) := '6F7665726C6179732E61646428736F6D6553686170652C207B0A202A202020706F736974696F6E3A207B0A202A2020202020746F703A202D352C0A202A20202020206C6566743A202D350A202A2020207D2C0A202A20202068746D6C3A20273C64697620';
wwv_flow_imp.g_varchar2_table(3923) := '7374796C653D2277696474683A20313070783B206261636B67726F756E643A20667563687369613B20636F6C6F723A2077686974653B223E303C2F6469763E270A202A207D293B0A202A0A202A202F2F206F722061646420766961207368617065206964';
wwv_flow_imp.g_varchar2_table(3924) := '0A202A0A202A206F7665726C6179732E6164642827736F6D652D656C656D656E742D6964272C207B0A202A202020706F736974696F6E3A207B0A202A2020202020746F703A202D352C0A202A20202020206C6566743A202D350A202A2020207D0A202A20';
wwv_flow_imp.g_varchar2_table(3925) := '202068746D6C3A20273C646976207374796C653D2277696474683A20313070783B206261636B67726F756E643A20667563687369613B20636F6C6F723A2077686974653B223E303C2F6469763E270A202A207D293B0A202A0A202A202F2F206F72206164';
wwv_flow_imp.g_varchar2_table(3926) := '642077697468206F7074696F6E616C20747970650A202A0A202A206F7665726C6179732E61646428736F6D6553686170652C20276261646765272C207B0A202A202020706F736974696F6E3A207B0A202A2020202020746F703A202D352C0A202A202020';
wwv_flow_imp.g_varchar2_table(3927) := '20206C6566743A202D350A202A2020207D0A202A20202068746D6C3A20273C646976207374796C653D2277696474683A20313070783B206261636B67726F756E643A20667563687369613B20636F6C6F723A2077686974653B223E303C2F6469763E270A';
wwv_flow_imp.g_varchar2_table(3928) := '202A207D293B0A202A206060600A202A0A202A206060606A6176617363726970740A202A202F2F2072656D6F766520616E206F7665726C61790A202A0A202A20766172206964203D206F7665726C6179732E616464282E2E2E293B0A202A206F7665726C';
wwv_flow_imp.g_varchar2_table(3929) := '6179732E72656D6F7665286964293B0A202A0A202A0A202A20596F75206D617920636F6E666967757265206F7665726C61792064656661756C747320647572696E6720746F6F6C2062792070726F766964696E6720612060636F6E66696760206D6F6475';
wwv_flow_imp.g_varchar2_table(3930) := '6C650A202A207769746820606F7665726C6179732E64656661756C74736020617320616E20656E7472793A0A202A0A202A207B0A202A2020206F7665726C6179733A207B0A202A202020202064656661756C74733A207B0A202A2020202020202073686F';
wwv_flow_imp.g_varchar2_table(3931) := '773A207B0A202A2020202020202020206D696E5A6F6F6D3A20302E372C0A202A2020202020202020206D61785A6F6F6D3A20352E300A202A202020202020207D2C0A202A202020202020207363616C653A207B0A202A2020202020202020206D696E3A20';
wwv_flow_imp.g_varchar2_table(3932) := '310A202A202020202020207D0A202A20202020207D0A202A207D0A202A206060600A202A0A202A2040706172616D207B4F7665726C617973436F6E6669677D20636F6E6669670A202A2040706172616D207B4576656E744275737D206576656E74427573';
wwv_flow_imp.g_varchar2_table(3933) := '0A202A2040706172616D207B43616E7661737D2063616E7661730A202A2040706172616D207B456C656D656E7452656769737472797D20656C656D656E7452656769737472790A202A2F0A66756E6374696F6E204F7665726C61797328636F6E6669672C';
wwv_flow_imp.g_varchar2_table(3934) := '206576656E744275732C2063616E7661732C20656C656D656E74526567697374727929207B0A2020746869732E5F6576656E74427573203D206576656E744275733B0A2020746869732E5F63616E766173203D2063616E7661733B0A2020746869732E5F';
wwv_flow_imp.g_varchar2_table(3935) := '656C656D656E745265676973747279203D20656C656D656E7452656769737472793B0A0A2020746869732E5F696473203D206964733B0A0A20202F2A2A0A2020202A204074797065207B4F7665726C617973436F6E66696744656661756C747D0A202020';
wwv_flow_imp.g_varchar2_table(3936) := '2A2F0A2020746869732E5F6F7665726C617944656661756C7473203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E61737369676E29287B0A0A202020202F2F206E6F2073686F7720636F6E73';
wwv_flow_imp.g_varchar2_table(3937) := '747261696E74730A2020202073686F773A206E756C6C2C0A0A202020202F2F20616C77617973207363616C650A202020207363616C653A20747275650A20207D2C20636F6E66696720262620636F6E6669672E64656661756C7473293B0A0A20202F2A2A';
wwv_flow_imp.g_varchar2_table(3938) := '0A2020202A204074797065207B5265636F72643C737472696E672C204F7665726C61793E7D0A2020202A2F0A2020746869732E5F6F7665726C617973203D207B7D3B0A0A20202F2A2A0A2020202A204074797065207B4F7665726C6179436F6E7461696E';
wwv_flow_imp.g_varchar2_table(3939) := '65725B5D7D0A2020202A2F0A2020746869732E5F6F7665726C6179436F6E7461696E657273203D205B5D3B0A0A20202F2A2A0A2020202A204074797065207B48544D4C456C656D656E747D0A2020202A2F0A2020746869732E5F6F7665726C6179526F6F';
wwv_flow_imp.g_varchar2_table(3940) := '74203D20637265617465526F6F742863616E7661732E676574436F6E7461696E65722829293B0A0A2020746869732E5F696E697428293B0A7D0A0A0A4F7665726C6179732E24696E6A656374203D205B0A202027636F6E6669672E6F7665726C61797327';
wwv_flow_imp.g_varchar2_table(3941) := '2C0A2020276576656E74427573272C0A20202763616E766173272C0A202027656C656D656E745265676973747279270A5D3B0A0A0A2F2A2A0A202A2052657475726E7320746865206F7665726C6179207769746820746865207370656369666965642049';
wwv_flow_imp.g_varchar2_table(3942) := '44206F722061206C697374206F66206F7665726C6179730A202A20666F7220616E20656C656D656E742077697468206120676976656E20747970652E0A202A0A202A20406578616D706C650A202A0A202A206060606A6176617363726970740A202A202F';
wwv_flow_imp.g_varchar2_table(3943) := '2F2072657475726E207468652073696E676C65206F7665726C617920776974682074686520676976656E2049440A202A206F7665726C6179732E6765742827736F6D652D696427293B0A202A0A202A202F2F2072657475726E20616C6C206F7665726C61';
wwv_flow_imp.g_varchar2_table(3944) := '797320666F72207468652073686170650A202A206F7665726C6179732E676574287B20656C656D656E743A20736F6D655368617065207D293B0A202A0A202A202F2F2072657475726E20616C6C206F7665726C617973206F6E2073686170652077697468';
wwv_flow_imp.g_varchar2_table(3945) := '207479706520276261646765270A202A206F7665726C6179732E676574287B20656C656D656E743A20736F6D6553686170652C20747970653A2027626164676527207D293B0A202A0A202A202F2F2073686170652063616E20616C736F20626520737065';
wwv_flow_imp.g_varchar2_table(3946) := '6369666965642061732049440A202A206F7665726C6179732E676574287B20656C656D656E743A2027656C656D656E742D6964272C20747970653A2027626164676527207D293B0A202A206060600A202A0A202A2040706172616D207B4F7665726C6179';
wwv_flow_imp.g_varchar2_table(3947) := '7346696C7465727D20736561726368205468652066696C74657220746F206265207573656420746F2066696E6420746865206F7665726C61792873292E0A202A0A202A204072657475726E207B4F7665726C61797C4F7665726C61795B5D7D2054686520';
wwv_flow_imp.g_varchar2_table(3948) := '6F7665726C61792873292E0A202A2F0A4F7665726C6179732E70726F746F747970652E676574203D2066756E6374696F6E2873656172636829207B0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44';
wwv_flow_imp.g_varchar2_table(3949) := '554C455F315F5F2E6973537472696E6729287365617263682929207B0A20202020736561726368203D207B2069643A20736561726368207D3B0A20207D0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D';
wwv_flow_imp.g_varchar2_table(3950) := '4F44554C455F315F5F2E6973537472696E6729287365617263682E656C656D656E742929207B0A202020207365617263682E656C656D656E74203D20746869732E5F656C656D656E7452656769737472792E676574287365617263682E656C656D656E74';
wwv_flow_imp.g_varchar2_table(3951) := '293B0A20207D0A0A2020696620287365617263682E656C656D656E7429207B0A2020202076617220636F6E7461696E6572203D20746869732E5F6765744F7665726C6179436F6E7461696E6572287365617263682E656C656D656E742C2074727565293B';
wwv_flow_imp.g_varchar2_table(3952) := '0A0A202020202F2F2072657475726E2061206C697374206F66206F7665726C617973207768656E20736561726368696E6720627920656C656D656E7420282B74797065290A2020202069662028636F6E7461696E657229207B0A20202020202072657475';
wwv_flow_imp.g_varchar2_table(3953) := '726E207365617263682E74797065203F2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E66696C7465722928636F6E7461696E65722E6F7665726C6179732C2028302C6D696E5F646173685F5F57';
wwv_flow_imp.g_varchar2_table(3954) := '45425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6D617463685061747465726E29287B20747970653A207365617263682E74797065207D2929203A20636F6E7461696E65722E6F7665726C6179732E736C69636528293B0A202020207D';
wwv_flow_imp.g_varchar2_table(3955) := '20656C7365207B0A20202020202072657475726E205B5D3B0A202020207D0A20207D20656C736520696620287365617263682E7479706529207B0A2020202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(3956) := '4D4F44554C455F315F5F2E66696C7465722928746869732E5F6F7665726C6179732C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6D617463685061747465726E29287B20747970653A207365';
wwv_flow_imp.g_varchar2_table(3957) := '617263682E74797065207D29293B0A20207D20656C7365207B0A0A202020202F2F2072657475726E2073696E676C6520656C656D656E74207768656E20736561726368696E672062792069640A2020202072657475726E207365617263682E6964203F20';
wwv_flow_imp.g_varchar2_table(3958) := '746869732E5F6F7665726C6179735B7365617263682E69645D203A206E756C6C3B0A20207D0A7D3B0A0A2F2A2A0A202A204164647320616E2048544D4C206F7665726C617920746F20616E20656C656D656E742E0A202A0A202A2040706172616D207B45';
wwv_flow_imp.g_varchar2_table(3959) := '6C656D656E747C737472696E677D20656C656D656E742054686520656C656D656E7420746F2061646420746865206F7665726C617920746F2E0A202A2040706172616D207B737472696E677D205B747970655D20416E206F7074696F6E616C2074797065';
wwv_flow_imp.g_varchar2_table(3960) := '20746861742063616E206265207573656420746F2066696C7465722E0A202A2040706172616D207B4F7665726C617941747472737D206F7665726C617920546865206F7665726C61792E0A202A0A202A204072657475726E207B737472696E677D205468';
wwv_flow_imp.g_varchar2_table(3961) := '65206F7665726C6179277320494420746861742063616E206265207573656420746F20676574206F722072656D6F76652069742E0A202A2F0A4F7665726C6179732E70726F746F747970652E616464203D2066756E6374696F6E28656C656D656E742C20';
wwv_flow_imp.g_varchar2_table(3962) := '747970652C206F7665726C617929207B0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69734F626A6563742928747970652929207B0A202020206F7665726C6179203D207479';
wwv_flow_imp.g_varchar2_table(3963) := '70653B0A2020202074797065203D206E756C6C3B0A20207D0A0A20206966202821656C656D656E742E696429207B0A20202020656C656D656E74203D20746869732E5F656C656D656E7452656769737472792E67657428656C656D656E74293B0A20207D';
wwv_flow_imp.g_varchar2_table(3964) := '0A0A202069662028216F7665726C61792E706F736974696F6E29207B0A202020207468726F77206E6577204572726F7228276D757374207370656369666979206F7665726C617920706F736974696F6E27293B0A20207D0A0A202069662028216F766572';
wwv_flow_imp.g_varchar2_table(3965) := '6C61792E68746D6C29207B0A202020207468726F77206E6577204572726F7228276D757374207370656369666979206F7665726C61792068746D6C27293B0A20207D0A0A20206966202821656C656D656E7429207B0A202020207468726F77206E657720';
wwv_flow_imp.g_varchar2_table(3966) := '4572726F722827696E76616C696420656C656D656E742073706563696669656427293B0A20207D0A0A2020766172206964203D20746869732E5F6964732E6E65787428293B0A0A20206F7665726C6179203D2028302C6D696E5F646173685F5F57454250';
wwv_flow_imp.g_varchar2_table(3967) := '41434B5F494D504F525445445F4D4F44554C455F315F5F2E61737369676E29287B7D2C20746869732E5F6F7665726C617944656661756C74732C206F7665726C61792C207B0A2020202069643A2069642C0A20202020747970653A20747970652C0A2020';
wwv_flow_imp.g_varchar2_table(3968) := '2020656C656D656E743A20656C656D656E742C0A2020202068746D6C3A206F7665726C61792E68746D6C0A20207D293B0A0A2020746869732E5F6164644F7665726C6179286F7665726C6179293B0A0A202072657475726E2069643B0A7D3B0A0A0A2F2A';
wwv_flow_imp.g_varchar2_table(3969) := '2A0A202A2052656D6F766520616E206F7665726C617920776974682074686520676976656E204944206F7220616C6C206F7665726C617973206D61746368696E672074686520676976656E2066696C7465722E0A202A0A202A2040736565204F7665726C';
wwv_flow_imp.g_varchar2_table(3970) := '6179732367657420666F722066696C746572206F7074696F6E732E0A202A0A202A2040706172616D207B4F7665726C61797346696C7465727D2066696C746572205468652066696C74657220746F206265207573656420746F2066696E6420746865206F';
wwv_flow_imp.g_varchar2_table(3971) := '7665726C61792E0A202A2F0A4F7665726C6179732E70726F746F747970652E72656D6F7665203D2066756E6374696F6E2866696C74657229207B0A0A2020766172206F7665726C617973203D20746869732E6765742866696C74657229207C7C205B5D3B';
wwv_flow_imp.g_varchar2_table(3972) := '0A0A2020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973417272617929286F7665726C6179732929207B0A202020206F7665726C617973203D205B206F7665726C617973205D3B';
wwv_flow_imp.g_varchar2_table(3973) := '0A20207D0A0A20207661722073656C66203D20746869733B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F724561636829286F7665726C6179732C2066756E6374696F6E286F7665';
wwv_flow_imp.g_varchar2_table(3974) := '726C617929207B0A0A2020202076617220636F6E7461696E6572203D2073656C662E5F6765744F7665726C6179436F6E7461696E6572286F7665726C61792E656C656D656E742C2074727565293B0A0A20202020696620286F7665726C617929207B0A20';
wwv_flow_imp.g_varchar2_table(3975) := '202020202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E72656D6F766529286F7665726C61792E68746D6C293B0A20202020202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F5254';
wwv_flow_imp.g_varchar2_table(3976) := '45445F4D4F44554C455F325F5F2E72656D6F766529286F7665726C61792E68746D6C436F6E7461696E6572293B0A0A20202020202064656C657465206F7665726C61792E68746D6C436F6E7461696E65723B0A20202020202064656C657465206F766572';
wwv_flow_imp.g_varchar2_table(3977) := '6C61792E656C656D656E743B0A0A20202020202064656C6574652073656C662E5F6F7665726C6179735B6F7665726C61792E69645D3B0A202020207D0A0A2020202069662028636F6E7461696E657229207B0A20202020202076617220696478203D2063';
wwv_flow_imp.g_varchar2_table(3978) := '6F6E7461696E65722E6F7665726C6179732E696E6465784F66286F7665726C6179293B0A2020202020206966202869647820213D3D202D3129207B0A2020202020202020636F6E7461696E65722E6F7665726C6179732E73706C696365286964782C2031';
wwv_flow_imp.g_varchar2_table(3979) := '293B0A2020202020207D0A202020207D0A20207D293B0A0A7D3B0A0A2F2A2A0A202A20436865636B732077686574686572206F7665726C617973206172652073686F776E2E0A202A0A202A204072657475726E207B626F6F6C65616E7D20576865746865';
wwv_flow_imp.g_varchar2_table(3980) := '72206F7665726C617973206172652073686F776E2E0A202A2F0A4F7665726C6179732E70726F746F747970652E697353686F776E203D2066756E6374696F6E2829207B0A202072657475726E20746869732E5F6F7665726C6179526F6F742E7374796C65';
wwv_flow_imp.g_varchar2_table(3981) := '2E646973706C617920213D3D20276E6F6E65273B0A7D3B0A0A2F2A2A0A202A2053686F7720616C6C206F7665726C6179732E0A202A2F0A4F7665726C6179732E70726F746F747970652E73686F77203D2066756E6374696F6E2829207B0A202073657456';
wwv_flow_imp.g_varchar2_table(3982) := '697369626C6528746869732E5F6F7665726C6179526F6F74293B0A7D3B0A0A2F2A2A0A202A204869646520616C6C206F7665726C6179732E0A202A2F0A4F7665726C6179732E70726F746F747970652E68696465203D2066756E6374696F6E2829207B0A';
wwv_flow_imp.g_varchar2_table(3983) := '202073657456697369626C6528746869732E5F6F7665726C6179526F6F742C2066616C7365293B0A7D3B0A0A2F2A2A0A202A2052656D6F766520616C6C206F7665726C61797320616E6420746865697220636F6E7461696E65722E0A202A2F0A4F766572';
wwv_flow_imp.g_varchar2_table(3984) := '6C6179732E70726F746F747970652E636C656172203D2066756E6374696F6E2829207B0A2020746869732E5F6F7665726C617973203D207B7D3B0A0A2020746869732E5F6F7665726C6179436F6E7461696E657273203D205B5D3B0A0A202028302C6D69';
wwv_flow_imp.g_varchar2_table(3985) := '6E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E636C6561722928746869732E5F6F7665726C6179526F6F74293B0A7D3B0A0A4F7665726C6179732E70726F746F747970652E5F7570646174654F7665726C617943';
wwv_flow_imp.g_varchar2_table(3986) := '6F6E7461696E6572203D2066756E6374696F6E28636F6E7461696E657229207B0A202076617220656C656D656E74203D20636F6E7461696E65722E656C656D656E742C0A20202020202068746D6C203D20636F6E7461696E65722E68746D6C3B0A0A2020';
wwv_flow_imp.g_varchar2_table(3987) := '2F2F2075706461746520636F6E7461696E6572206C6566742C746F70206163636F7264696E6720746F2074686520656C656D656E747320782C7920636F6F7264696E617465730A20202F2F207468697320656E73757265732077652063616E2061747461';
wwv_flow_imp.g_varchar2_table(3988) := '6368206368696C6420656C656D656E74732072656C617469766520746F207468697320636F6E7461696E65720A0A20207661722078203D20656C656D656E742E782C0A20202020202079203D20656C656D656E742E793B0A0A202069662028656C656D65';
wwv_flow_imp.g_varchar2_table(3989) := '6E742E776179706F696E747329207B0A202020207661722062626F78203D2028302C5F7574696C5F456C656D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E67657442426F782928656C656D656E74293B0A202020';
wwv_flow_imp.g_varchar2_table(3990) := '2078203D2062626F782E783B0A2020202079203D2062626F782E793B0A20207D0A0A2020736574506F736974696F6E2868746D6C2C20782C2079293B0A0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F';
wwv_flow_imp.g_varchar2_table(3991) := '325F5F2E617474722928636F6E7461696E65722E68746D6C2C2027646174612D636F6E7461696E65722D6964272C20656C656D656E742E6964293B0A7D3B0A0A0A4F7665726C6179732E70726F746F747970652E5F7570646174654F7665726C6179203D';
wwv_flow_imp.g_varchar2_table(3992) := '2066756E6374696F6E286F7665726C617929207B0A0A202076617220706F736974696F6E203D206F7665726C61792E706F736974696F6E2C0A20202020202068746D6C436F6E7461696E6572203D206F7665726C61792E68746D6C436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(3993) := '2C0A202020202020656C656D656E74203D206F7665726C61792E656C656D656E743B0A0A20202F2F20757064617465206F7665726C61792068746D6C2072656C617469766520746F20736861706520626563617573650A20202F2F20697420697320616C';
wwv_flow_imp.g_varchar2_table(3994) := '726561647920706F736974696F6E6564206F6E2074686520656C656D656E740A0A20202F2F207570646174652072656C61746976650A2020766172206C656674203D20706F736974696F6E2E6C6566742C0A202020202020746F70203D20706F73697469';
wwv_flow_imp.g_varchar2_table(3995) := '6F6E2E746F703B0A0A202069662028706F736974696F6E2E726967687420213D3D20756E646566696E656429207B0A0A202020207661722077696474683B0A0A2020202069662028656C656D656E742E776179706F696E747329207B0A20202020202077';
wwv_flow_imp.g_varchar2_table(3996) := '69647468203D2028302C5F7574696C5F456C656D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E67657442426F782928656C656D656E74292E77696474683B0A202020207D20656C7365207B0A2020202020207769';
wwv_flow_imp.g_varchar2_table(3997) := '647468203D20656C656D656E742E77696474683B0A202020207D0A0A202020206C656674203D20706F736974696F6E2E7269676874202A202D31202B2077696474683B0A20207D0A0A202069662028706F736974696F6E2E626F74746F6D20213D3D2075';
wwv_flow_imp.g_varchar2_table(3998) := '6E646566696E656429207B0A0A20202020766172206865696768743B0A0A2020202069662028656C656D656E742E776179706F696E747329207B0A202020202020686569676874203D2028302C5F7574696C5F456C656D656E74735F5F5745425041434B';
wwv_flow_imp.g_varchar2_table(3999) := '5F494D504F525445445F4D4F44554C455F335F5F2E67657442426F782928656C656D656E74292E6865696768743B0A202020207D20656C7365207B0A202020202020686569676874203D20656C656D656E742E6865696768743B0A202020207D0A0A2020';
wwv_flow_imp.g_varchar2_table(4000) := '2020746F70203D20706F736974696F6E2E626F74746F6D202A202D31202B206865696768743B0A20207D0A0A2020736574506F736974696F6E2868746D6C436F6E7461696E65722C206C656674207C7C20302C20746F70207C7C2030293B0A2020746869';
wwv_flow_imp.g_varchar2_table(4001) := '732E5F7570646174654F7665726C61795669736962696C7479286F7665726C61792C20746869732E5F63616E7661732E76696577626F782829293B0A7D3B0A0A0A4F7665726C6179732E70726F746F747970652E5F6372656174654F7665726C6179436F';
wwv_flow_imp.g_varchar2_table(4002) := '6E7461696E6572203D2066756E6374696F6E28656C656D656E7429207B0A20207661722068746D6C203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E646F6D6966792928273C64697620636C61';
wwv_flow_imp.g_varchar2_table(4003) := '73733D22646A732D6F7665726C61797322202F3E27293B0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E5374796C65292868746D6C2C207B20706F736974696F6E3A20276162';
wwv_flow_imp.g_varchar2_table(4004) := '736F6C75746527207D293B0A0A2020746869732E5F6F7665726C6179526F6F742E617070656E644368696C642868746D6C293B0A0A202076617220636F6E7461696E6572203D207B0A2020202068746D6C3A2068746D6C2C0A20202020656C656D656E74';
wwv_flow_imp.g_varchar2_table(4005) := '3A20656C656D656E742C0A202020206F7665726C6179733A205B5D0A20207D3B0A0A2020746869732E5F7570646174654F7665726C6179436F6E7461696E657228636F6E7461696E6572293B0A0A2020746869732E5F6F7665726C6179436F6E7461696E';
wwv_flow_imp.g_varchar2_table(4006) := '6572732E7075736828636F6E7461696E6572293B0A0A202072657475726E20636F6E7461696E65723B0A7D3B0A0A0A4F7665726C6179732E70726F746F747970652E5F757064617465526F6F74203D2066756E6374696F6E2876696577626F7829207B0A';
wwv_flow_imp.g_varchar2_table(4007) := '2020766172207363616C65203D2076696577626F782E7363616C65207C7C20313B0A0A2020766172206D6174726978203D20276D61747269782827202B0A20205B0A202020207363616C652C0A20202020302C0A20202020302C0A202020207363616C65';
wwv_flow_imp.g_varchar2_table(4008) := '2C0A202020202D31202A2076696577626F782E78202A207363616C652C0A202020202D31202A2076696577626F782E79202A207363616C650A20205D2E6A6F696E28272C2729202B0A20202729273B0A0A20207365745472616E73666F726D2874686973';
wwv_flow_imp.g_varchar2_table(4009) := '2E5F6F7665726C6179526F6F742C206D6174726978293B0A7D3B0A0A0A4F7665726C6179732E70726F746F747970652E5F6765744F7665726C6179436F6E7461696E6572203D2066756E6374696F6E28656C656D656E742C2072617729207B0A20207661';
wwv_flow_imp.g_varchar2_table(4010) := '7220636F6E7461696E6572203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E66696E642928746869732E5F6F7665726C6179436F6E7461696E6572732C2066756E6374696F6E286329207B0A';
wwv_flow_imp.g_varchar2_table(4011) := '2020202072657475726E20632E656C656D656E74203D3D3D20656C656D656E743B0A20207D293B0A0A0A20206966202821636F6E7461696E6572202626202172617729207B0A2020202072657475726E20746869732E5F6372656174654F7665726C6179';
wwv_flow_imp.g_varchar2_table(4012) := '436F6E7461696E657228656C656D656E74293B0A20207D0A0A202072657475726E20636F6E7461696E65723B0A7D3B0A0A0A4F7665726C6179732E70726F746F747970652E5F6164644F7665726C6179203D2066756E6374696F6E286F7665726C617929';
wwv_flow_imp.g_varchar2_table(4013) := '207B0A0A2020766172206964203D206F7665726C61792E69642C0A202020202020656C656D656E74203D206F7665726C61792E656C656D656E742C0A20202020202068746D6C203D206F7665726C61792E68746D6C2C0A20202020202068746D6C436F6E';
wwv_flow_imp.g_varchar2_table(4014) := '7461696E65722C0A2020202020206F7665726C6179436F6E7461696E65723B0A0A20202F2F20756E77726170206A71756572792028666F722074686F73652077686F206E656564206974290A20206966202868746D6C2E6765742026262068746D6C2E63';
wwv_flow_imp.g_varchar2_table(4015) := '6F6E7374727563746F722E70726F746F747970652E6A717565727929207B0A2020202068746D6C203D2068746D6C2E6765742830293B0A20207D0A0A20202F2F206372656174652070726F7065722068746D6C20656C656D656E74732066726F6D0A2020';
wwv_flow_imp.g_varchar2_table(4016) := '2F2F206F7665726C61792048544D4C20737472696E67730A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973537472696E67292868746D6C2929207B0A2020202068746D6C203D';
wwv_flow_imp.g_varchar2_table(4017) := '2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E646F6D696679292868746D6C293B0A20207D0A0A20206F7665726C6179436F6E7461696E6572203D20746869732E5F6765744F7665726C6179436F';
wwv_flow_imp.g_varchar2_table(4018) := '6E7461696E657228656C656D656E74293B0A0A202068746D6C436F6E7461696E6572203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E646F6D6966792928273C64697620636C6173733D22646A';
wwv_flow_imp.g_varchar2_table(4019) := '732D6F7665726C61792220646174612D6F7665726C61792D69643D2227202B206964202B2027223E27293B0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E5374796C65292868';
wwv_flow_imp.g_varchar2_table(4020) := '746D6C436F6E7461696E65722C207B20706F736974696F6E3A20276162736F6C75746527207D293B0A0A202068746D6C436F6E7461696E65722E617070656E644368696C642868746D6C293B0A0A2020696620286F7665726C61792E7479706529207B0A';
wwv_flow_imp.g_varchar2_table(4021) := '2020202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E636C6173736573292868746D6C436F6E7461696E6572292E6164642827646A732D6F7665726C61792D27202B206F7665726C61792E747970';
wwv_flow_imp.g_varchar2_table(4022) := '65293B0A20207D0A0A202076617220656C656D656E74526F6F74203D20746869732E5F63616E7661732E66696E64526F6F7428656C656D656E74293B0A202076617220616374697665526F6F74203D20746869732E5F63616E7661732E676574526F6F74';
wwv_flow_imp.g_varchar2_table(4023) := '456C656D656E7428293B0A0A202073657456697369626C652868746D6C436F6E7461696E65722C20656C656D656E74526F6F74203D3D3D20616374697665526F6F74293B0A0A20206F7665726C61792E68746D6C436F6E7461696E6572203D2068746D6C';
wwv_flow_imp.g_varchar2_table(4024) := '436F6E7461696E65723B0A0A20206F7665726C6179436F6E7461696E65722E6F7665726C6179732E70757368286F7665726C6179293B0A20206F7665726C6179436F6E7461696E65722E68746D6C2E617070656E644368696C642868746D6C436F6E7461';
wwv_flow_imp.g_varchar2_table(4025) := '696E6572293B0A0A2020746869732E5F6F7665726C6179735B69645D203D206F7665726C61793B0A0A2020746869732E5F7570646174654F7665726C6179286F7665726C6179293B0A2020746869732E5F7570646174654F7665726C6179566973696269';
wwv_flow_imp.g_varchar2_table(4026) := '6C7479286F7665726C61792C20746869732E5F63616E7661732E76696577626F782829293B0A7D3B0A0A0A4F7665726C6179732E70726F746F747970652E5F7570646174654F7665726C61795669736962696C7479203D2066756E6374696F6E286F7665';
wwv_flow_imp.g_varchar2_table(4027) := '726C61792C2076696577626F7829207B0A20207661722073686F77203D206F7665726C61792E73686F772C0A202020202020726F6F74456C656D656E74203D20746869732E5F63616E7661732E66696E64526F6F74286F7665726C61792E656C656D656E';
wwv_flow_imp.g_varchar2_table(4028) := '74292C0A2020202020206D696E5A6F6F6D203D2073686F772026262073686F772E6D696E5A6F6F6D2C0A2020202020206D61785A6F6F6D203D2073686F772026262073686F772E6D61785A6F6F6D2C0A20202020202068746D6C436F6E7461696E657220';
wwv_flow_imp.g_varchar2_table(4029) := '3D206F7665726C61792E68746D6C436F6E7461696E65722C0A202020202020616374697665526F6F74456C656D656E74203D20746869732E5F63616E7661732E676574526F6F74456C656D656E7428292C0A20202020202076697369626C65203D207472';
wwv_flow_imp.g_varchar2_table(4030) := '75653B0A0A202069662028726F6F74456C656D656E7420213D3D20616374697665526F6F74456C656D656E7429207B0A2020202076697369626C65203D2066616C73653B0A20207D20656C7365206966202873686F7729207B0A20202020696620280A20';
wwv_flow_imp.g_varchar2_table(4031) := '20202020202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973446566696E656429286D696E5A6F6F6D29202626206D696E5A6F6F6D203E2076696577626F782E7363616C6529207C7C0A2020';
wwv_flow_imp.g_varchar2_table(4032) := '202020202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973446566696E656429286D61785A6F6F6D29202626206D61785A6F6F6D203C2076696577626F782E7363616C65290A202020202920';
wwv_flow_imp.g_varchar2_table(4033) := '7B0A20202020202076697369626C65203D2066616C73653B0A202020207D0A20207D0A0A202073657456697369626C652868746D6C436F6E7461696E65722C2076697369626C65293B0A0A2020746869732E5F7570646174654F7665726C61795363616C';
wwv_flow_imp.g_varchar2_table(4034) := '65286F7665726C61792C2076696577626F78293B0A7D3B0A0A0A4F7665726C6179732E70726F746F747970652E5F7570646174654F7665726C61795363616C65203D2066756E6374696F6E286F7665726C61792C2076696577626F7829207B0A20207661';
wwv_flow_imp.g_varchar2_table(4035) := '722073686F756C645363616C65203D206F7665726C61792E7363616C652C0A2020202020206D696E5363616C652C0A2020202020206D61785363616C652C0A20202020202068746D6C436F6E7461696E6572203D206F7665726C61792E68746D6C436F6E';
wwv_flow_imp.g_varchar2_table(4036) := '7461696E65723B0A0A2020766172207363616C652C207472616E73666F726D203D2027273B0A0A20206966202873686F756C645363616C6520213D3D207472756529207B0A0A202020206966202873686F756C645363616C65203D3D3D2066616C736529';
wwv_flow_imp.g_varchar2_table(4037) := '207B0A2020202020206D696E5363616C65203D20313B0A2020202020206D61785363616C65203D20313B0A202020207D20656C7365207B0A2020202020206D696E5363616C65203D2073686F756C645363616C652E6D696E3B0A2020202020206D617853';
wwv_flow_imp.g_varchar2_table(4038) := '63616C65203D2073686F756C645363616C652E6D61783B0A202020207D0A0A202020206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973446566696E656429286D696E5363616C6529';
wwv_flow_imp.g_varchar2_table(4039) := '2026262076696577626F782E7363616C65203C206D696E5363616C6529207B0A2020202020207363616C65203D202831202F2076696577626F782E7363616C65207C7C203129202A206D696E5363616C653B0A202020207D0A0A20202020696620282830';
wwv_flow_imp.g_varchar2_table(4040) := '2C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973446566696E656429286D61785363616C65292026262076696577626F782E7363616C65203E206D61785363616C6529207B0A202020202020736361';
wwv_flow_imp.g_varchar2_table(4041) := '6C65203D202831202F2076696577626F782E7363616C65207C7C203129202A206D61785363616C653B0A202020207D0A20207D0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E';
wwv_flow_imp.g_varchar2_table(4042) := '6973446566696E656429287363616C652929207B0A202020207472616E73666F726D203D20277363616C652827202B207363616C65202B20272C27202B207363616C65202B202729273B0A20207D0A0A20207365745472616E73666F726D2868746D6C43';
wwv_flow_imp.g_varchar2_table(4043) := '6F6E7461696E65722C207472616E73666F726D293B0A7D3B0A0A0A4F7665726C6179732E70726F746F747970652E5F7570646174654F7665726C6179735669736962696C7479203D2066756E6374696F6E2876696577626F7829207B0A0A202076617220';
wwv_flow_imp.g_varchar2_table(4044) := '73656C66203D20746869733B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F72456163682928746869732E5F6F7665726C6179732C2066756E6374696F6E286F7665726C61792920';
wwv_flow_imp.g_varchar2_table(4045) := '7B0A2020202073656C662E5F7570646174654F7665726C61795669736962696C7479286F7665726C61792C2076696577626F78293B0A20207D293B0A7D3B0A0A0A4F7665726C6179732E70726F746F747970652E5F696E6974203D2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(4046) := '2829207B0A0A2020766172206576656E74427573203D20746869732E5F6576656E744275733B0A0A20207661722073656C66203D20746869733B0A0A0A20202F2F207363726F6C6C2F7A6F6F6D20696E746567726174696F6E0A0A202066756E6374696F';
wwv_flow_imp.g_varchar2_table(4047) := '6E2075706461746556696577626F782876696577626F7829207B0A2020202073656C662E5F757064617465526F6F742876696577626F78293B0A2020202073656C662E5F7570646174654F7665726C6179735669736962696C74792876696577626F7829';
wwv_flow_imp.g_varchar2_table(4048) := '3B0A0A2020202073656C662E73686F7728293B0A20207D0A0A20206576656E744275732E6F6E282763616E7661732E76696577626F782E6368616E67696E67272C2066756E6374696F6E286576656E7429207B0A2020202073656C662E6869646528293B';
wwv_flow_imp.g_varchar2_table(4049) := '0A20207D293B0A0A20206576656E744275732E6F6E282763616E7661732E76696577626F782E6368616E676564272C2066756E6374696F6E286576656E7429207B0A2020202075706461746556696577626F78286576656E742E76696577626F78293B0A';
wwv_flow_imp.g_varchar2_table(4050) := '20207D293B0A0A0A20202F2F2072656D6F766520696E746567726174696F6E0A0A20206576656E744275732E6F6E285B202773686170652E72656D6F7665272C2027636F6E6E656374696F6E2E72656D6F766527205D2C2066756E6374696F6E28652920';
wwv_flow_imp.g_varchar2_table(4051) := '7B0A2020202076617220656C656D656E74203D20652E656C656D656E743B0A20202020766172206F7665726C617973203D2073656C662E676574287B20656C656D656E743A20656C656D656E74207D293B0A0A2020202028302C6D696E5F646173685F5F';
wwv_flow_imp.g_varchar2_table(4052) := '5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F724561636829286F7665726C6179732C2066756E6374696F6E286F29207B0A20202020202073656C662E72656D6F7665286F2E6964293B0A202020207D293B0A0A2020202076';
wwv_flow_imp.g_varchar2_table(4053) := '617220636F6E7461696E6572203D2073656C662E5F6765744F7665726C6179436F6E7461696E657228656C656D656E74293B0A0A2020202069662028636F6E7461696E657229207B0A20202020202028302C6D696E5F646F6D5F5F5745425041434B5F49';
wwv_flow_imp.g_varchar2_table(4054) := '4D504F525445445F4D4F44554C455F325F5F2E72656D6F76652928636F6E7461696E65722E68746D6C293B0A2020202020207661722069203D2073656C662E5F6F7665726C6179436F6E7461696E6572732E696E6465784F6628636F6E7461696E657229';
wwv_flow_imp.g_varchar2_table(4055) := '3B0A202020202020696620286920213D3D202D3129207B0A202020202020202073656C662E5F6F7665726C6179436F6E7461696E6572732E73706C69636528692C2031293B0A2020202020207D0A202020207D0A20207D293B0A0A0A20202F2F206D6F76';
wwv_flow_imp.g_varchar2_table(4056) := '6520696E746567726174696F6E0A0A20206576656E744275732E6F6E2827656C656D656E742E6368616E676564272C204C4F575F5052494F524954592C2066756E6374696F6E286529207B0A2020202076617220656C656D656E74203D20652E656C656D';
wwv_flow_imp.g_varchar2_table(4057) := '656E743B0A0A2020202076617220636F6E7461696E6572203D2073656C662E5F6765744F7665726C6179436F6E7461696E657228656C656D656E742C2074727565293B0A0A2020202069662028636F6E7461696E657229207B0A20202020202028302C6D';
wwv_flow_imp.g_varchar2_table(4058) := '696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F72456163682928636F6E7461696E65722E6F7665726C6179732C2066756E6374696F6E286F7665726C617929207B0A202020202020202073656C662E5F';
wwv_flow_imp.g_varchar2_table(4059) := '7570646174654F7665726C6179286F7665726C6179293B0A2020202020207D293B0A0A20202020202073656C662E5F7570646174654F7665726C6179436F6E7461696E657228636F6E7461696E6572293B0A202020207D0A20207D293B0A0A0A20202F2F';
wwv_flow_imp.g_varchar2_table(4060) := '206D61726B657220696E746567726174696F6E2C2073696D706C7920616464207468656D206F6E20746865206F7665726C61797320617320636C61737365732C20746F6F2E0A0A20206576656E744275732E6F6E2827656C656D656E742E6D61726B6572';
wwv_flow_imp.g_varchar2_table(4061) := '2E757064617465272C2066756E6374696F6E286529207B0A2020202076617220636F6E7461696E6572203D2073656C662E5F6765744F7665726C6179436F6E7461696E657228652E656C656D656E742C2074727565293B0A2020202069662028636F6E74';
wwv_flow_imp.g_varchar2_table(4062) := '61696E657229207B0A20202020202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E636C61737365732928636F6E7461696E65722E68746D6C295B652E616464203F202761646427203A202772656D';
wwv_flow_imp.g_varchar2_table(4063) := '6F7665275D28652E6D61726B6572293B0A202020207D0A20207D293B0A0A0A20206576656E744275732E6F6E2827726F6F742E736574272C2066756E6374696F6E2829207B0A2020202073656C662E5F7570646174654F7665726C617973566973696269';
wwv_flow_imp.g_varchar2_table(4064) := '6C74792873656C662E5F63616E7661732E76696577626F782829293B0A20207D293B0A0A20202F2F20636C656172206F7665726C6179732077697468206469616772616D0A0A20206576656E744275732E6F6E28276469616772616D2E636C656172272C';
wwv_flow_imp.g_varchar2_table(4065) := '20746869732E636C6561722C2074686973293B0A7D3B0A0A0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A66756E6374696F6E20637265617465526F6F7428706172656E744E6F64652920';
wwv_flow_imp.g_varchar2_table(4066) := '7B0A202076617220726F6F74203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E646F6D69667929280A20202020273C64697620636C6173733D22646A732D6F7665726C61792D636F6E7461696E';
wwv_flow_imp.g_varchar2_table(4067) := '657222202F3E270A2020293B0A0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E5374796C652928726F6F742C207B0A20202020706F736974696F6E3A20276162736F6C757465';
wwv_flow_imp.g_varchar2_table(4068) := '272C0A2020202077696474683A20302C0A202020206865696768743A20300A20207D293B0A0A2020706172656E744E6F64652E696E736572744265666F726528726F6F742C20706172656E744E6F64652E66697273744368696C64293B0A0A2020726574';
wwv_flow_imp.g_varchar2_table(4069) := '75726E20726F6F743B0A7D0A0A66756E6374696F6E20736574506F736974696F6E28656C2C20782C207929207B0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E5374796C6529';
wwv_flow_imp.g_varchar2_table(4070) := '28656C2C207B206C6566743A2078202B20277078272C20746F703A2079202B2027707827207D293B0A7D0A0A2F2A2A0A202A2053657420656C656D656E742076697369626C650A202A0A202A2040706172616D207B444F4D456C656D656E747D20656C0A';
wwv_flow_imp.g_varchar2_table(4071) := '202A2040706172616D207B626F6F6C65616E7D205B76697369626C653D747275655D0A202A2F0A66756E6374696F6E2073657456697369626C6528656C2C2076697369626C6529207B0A2020656C2E7374796C652E646973706C6179203D207669736962';
wwv_flow_imp.g_varchar2_table(4072) := '6C65203D3D3D2066616C7365203F20276E6F6E6527203A2027273B0A7D0A0A66756E6374696F6E207365745472616E73666F726D28656C2C207472616E73666F726D29207B0A0A2020656C2E7374796C655B277472616E73666F726D2D6F726967696E27';
wwv_flow_imp.g_varchar2_table(4073) := '5D203D2027746F70206C656674273B0A0A20205B2027272C20272D6D732D272C20272D7765626B69742D27205D2E666F72456163682866756E6374696F6E2870726566697829207B0A20202020656C2E7374796C655B707265666978202B20277472616E';
wwv_flow_imp.g_varchar2_table(4074) := '73666F726D275D203D207472616E73666F726D3B0A20207D293B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F7665726C6179732F696E6465';
wwv_flow_imp.g_varchar2_table(4075) := '782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F';
wwv_flow_imp.g_varchar2_table(4076) := '6469616772616D2D6A732F6C69622F66656174757265732F6F7665726C6179732F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4077) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F77';
wwv_flow_imp.g_varchar2_table(4078) := '65627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274';
wwv_flow_imp.g_varchar2_table(4079) := '735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B';
wwv_flow_imp.g_varchar2_table(4080) := '0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F4F7665726C6179735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4F7665726C6179';
wwv_flow_imp.g_varchar2_table(4081) := '73202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F7665726C6179732F4F7665726C6179732E6A7322293B0A0A0A0A2F2A2A0A202A204074797065207B20696D706F727428276469646927';
wwv_flow_imp.g_varchar2_table(4082) := '292E4D6F64756C654465636C61726174696F6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F696E69';
wwv_flow_imp.g_varchar2_table(4083) := '745F5F3A205B20276F7665726C61797327205D2C0A20206F7665726C6179733A205B202774797065272C205F4F7665726C6179735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D205D0A7D293B0A0A';
wwv_flow_imp.g_varchar2_table(4084) := '2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F70616C657474652F50616C657474652E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4085) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F70616C65';
wwv_flow_imp.g_varchar2_table(4086) := '7474652F50616C657474652E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F';
wwv_flow_imp.g_varchar2_table(4087) := '756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061';
wwv_flow_imp.g_varchar2_table(4088) := '636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A';
wwv_flow_imp.g_varchar2_table(4089) := '2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F2050616C65747465290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F64';
wwv_flow_imp.g_varchar2_table(4090) := '6173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F64697374';
wwv_flow_imp.g_varchar2_table(4091) := '2F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F';
wwv_flow_imp.g_varchar2_table(4092) := '282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4573636170655574';
wwv_flow_imp.g_varchar2_table(4093) := '696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F4573636170655574696C202A2F20222E2F6E6F64655F6D6F64756C65732F64';
wwv_flow_imp.g_varchar2_table(4094) := '69616772616D2D6A732F6C69622F7574696C2F4573636170655574696C2E6A7322293B0A0A0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E64656661756C747D2043616E76';
wwv_flow_imp.g_varchar2_table(4095) := '61730A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A0A202A204074797065646566207B696D706F727428272E2F50616C6574746550726F';
wwv_flow_imp.g_varchar2_table(4096) := '766964657227292E50616C65747465456E74726965737D2050616C65747465456E74726965730A202A204074797065646566207B696D706F727428272E2F50616C6574746550726F766964657227292E64656661756C747D2050616C6574746550726F76';
wwv_flow_imp.g_varchar2_table(4097) := '696465720A202A2F0A0A76617220544F47474C455F53454C4543544F52203D20272E646A732D70616C657474652D746F67676C65272C0A20202020454E5452595F53454C4543544F52203D20272E656E747279272C0A20202020454C454D454E545F5345';
wwv_flow_imp.g_varchar2_table(4098) := '4C4543544F52203D20544F47474C455F53454C4543544F52202B20272C2027202B20454E5452595F53454C4543544F523B0A0A7661722050414C455454455F505245464958203D2027646A732D70616C657474652D272C0A2020202050414C455454455F';
wwv_flow_imp.g_varchar2_table(4099) := '53484F574E5F434C53203D202773686F776E272C0A2020202050414C455454455F4F50454E5F434C53203D20276F70656E272C0A2020202050414C455454455F54574F5F434F4C554D4E5F434C53203D202774776F2D636F6C756D6E273B0A0A76617220';
wwv_flow_imp.g_varchar2_table(4100) := '44454641554C545F5052494F52495459203D20313030303B0A0A0A2F2A2A0A202A20412070616C6574746520636F6E7461696E696E67206D6F64656C696E6720656C656D656E74732E0A202A0A202A2040706172616D207B4576656E744275737D206576';
wwv_flow_imp.g_varchar2_table(4101) := '656E744275730A202A2040706172616D207B43616E7661737D2063616E7661730A202A2F0A66756E6374696F6E2050616C65747465286576656E744275732C2063616E76617329207B0A0A2020746869732E5F6576656E74427573203D206576656E7442';
wwv_flow_imp.g_varchar2_table(4102) := '75733B0A2020746869732E5F63616E766173203D2063616E7661733B0A0A20207661722073656C66203D20746869733B0A0A20206576656E744275732E6F6E2827746F6F6C2D6D616E616765722E757064617465272C2066756E6374696F6E286576656E';
wwv_flow_imp.g_varchar2_table(4103) := '7429207B0A2020202076617220746F6F6C203D206576656E742E746F6F6C3B0A0A2020202073656C662E757064617465546F6F6C486967686C6967687428746F6F6C293B0A20207D293B0A0A20206576656E744275732E6F6E28276931386E2E6368616E';
wwv_flow_imp.g_varchar2_table(4104) := '676564272C2066756E6374696F6E2829207B0A2020202073656C662E5F75706461746528293B0A20207D293B0A0A20206576656E744275732E6F6E28276469616772616D2E696E6974272C2066756E6374696F6E2829207B0A0A2020202073656C662E5F';
wwv_flow_imp.g_varchar2_table(4105) := '6469616772616D496E697469616C697A6564203D20747275653B0A0A2020202073656C662E5F72656275696C6428293B0A20207D293B0A7D0A0A50616C657474652E24696E6A656374203D205B20276576656E74427573272C202763616E76617327205D';
wwv_flow_imp.g_varchar2_table(4106) := '3B0A0A2F2A2A0A202A20406F7665726C6F72640A202A0A202A20526567697374657220612070616C657474652070726F766964657220776974682064656661756C74207072696F726974792E205365650A202A207B406C696E6B2050616C657474655072';
wwv_flow_imp.g_varchar2_table(4107) := '6F76696465727D20666F72206578616D706C65732E0A202A0A202A2040706172616D207B50616C6574746550726F76696465727D2070726F76696465720A202A2F0A0A2F2A2A0A202A20526567697374657220612070616C657474652070726F76696465';
wwv_flow_imp.g_varchar2_table(4108) := '7220776974682074686520676976656E207072696F726974792E205365650A202A207B406C696E6B2050616C6574746550726F76696465727D20666F72206578616D706C65732E0A202A0A202A2040706172616D207B6E756D6265727D207072696F7269';
wwv_flow_imp.g_varchar2_table(4109) := '74790A202A2040706172616D207B50616C6574746550726F76696465727D2070726F76696465720A202A2F0A50616C657474652E70726F746F747970652E726567697374657250726F7669646572203D2066756E6374696F6E287072696F726974792C20';
wwv_flow_imp.g_varchar2_table(4110) := '70726F766964657229207B0A2020696620282170726F766964657229207B0A2020202070726F7669646572203D207072696F726974793B0A202020207072696F72697479203D2044454641554C545F5052494F524954593B0A20207D0A0A202074686973';
wwv_flow_imp.g_varchar2_table(4111) := '2E5F6576656E744275732E6F6E282770616C657474652E67657450726F766964657273272C207072696F726974792C2066756E6374696F6E286576656E7429207B0A202020206576656E742E70726F7669646572732E707573682870726F766964657229';
wwv_flow_imp.g_varchar2_table(4112) := '3B0A20207D293B0A0A2020746869732E5F72656275696C6428293B0A7D3B0A0A0A2F2A2A0A202A2052657475726E73207468652070616C6574746520656E74726965732E0A202A0A202A204072657475726E207B50616C65747465456E74726965737D0A';
wwv_flow_imp.g_varchar2_table(4113) := '202A2F0A50616C657474652E70726F746F747970652E676574456E7472696573203D2066756E6374696F6E2829207B0A20207661722070726F766964657273203D20746869732E5F67657450726F76696465727328293B0A0A202072657475726E207072';
wwv_flow_imp.g_varchar2_table(4114) := '6F7669646572732E7265647563652861646450616C65747465456E74726965732C207B7D293B0A7D3B0A0A50616C657474652E70726F746F747970652E5F72656275696C64203D2066756E6374696F6E2829207B0A0A20206966202821746869732E5F64';
wwv_flow_imp.g_varchar2_table(4115) := '69616772616D496E697469616C697A656429207B0A2020202072657475726E3B0A20207D0A0A20207661722070726F766964657273203D20746869732E5F67657450726F76696465727328293B0A0A2020696620282170726F7669646572732E6C656E67';
wwv_flow_imp.g_varchar2_table(4116) := '746829207B0A2020202072657475726E3B0A20207D0A0A20206966202821746869732E5F636F6E7461696E657229207B0A20202020746869732E5F696E697428293B0A20207D0A0A2020746869732E5F75706461746528293B0A7D3B0A0A2F2A2A0A202A';
wwv_flow_imp.g_varchar2_table(4117) := '20496E697469616C697A652070616C657474652E0A202A2F0A50616C657474652E70726F746F747970652E5F696E6974203D2066756E6374696F6E2829207B0A0A20207661722073656C66203D20746869733B0A0A2020766172206576656E7442757320';
wwv_flow_imp.g_varchar2_table(4118) := '3D20746869732E5F6576656E744275733B0A0A202076617220706172656E74436F6E7461696E6572203D20746869732E5F676574506172656E74436F6E7461696E657228293B0A0A202076617220636F6E7461696E6572203D20746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(4119) := '61696E6572203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D696679292850616C657474652E48544D4C5F4D41524B5550293B0A0A2020706172656E74436F6E7461696E65722E617070';
wwv_flow_imp.g_varchar2_table(4120) := '656E644368696C6428636F6E7461696E6572293B0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E636C61737365732928706172656E74436F6E7461696E6572292E6164642850414C45545445';
wwv_flow_imp.g_varchar2_table(4121) := '5F505245464958202B2050414C455454455F53484F574E5F434C53293B0A0A20206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E64656C65676174652E62696E6428636F6E7461696E65722C20454C454D45';
wwv_flow_imp.g_varchar2_table(4122) := '4E545F53454C4543544F522C2027636C69636B272C2066756E6374696F6E286576656E7429207B0A0A2020202076617220746172676574203D206576656E742E64656C65676174655461726765743B0A0A202020206966202828302C6D696E5F646F6D5F';
wwv_flow_imp.g_varchar2_table(4123) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6D61746368657329287461726765742C20544F47474C455F53454C4543544F522929207B0A20202020202072657475726E2073656C662E746F67676C6528293B0A202020207D0A';
wwv_flow_imp.g_varchar2_table(4124) := '0A2020202073656C662E747269676765722827636C69636B272C206576656E74293B0A20207D293B0A0A20202F2F2070726576656E7420647261672070726F7061676174696F6E0A20206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(4125) := '4D4F44554C455F305F5F2E6576656E742E62696E6428636F6E7461696E65722C20276D6F757365646F776E272C2066756E6374696F6E286576656E7429207B0A202020206576656E742E73746F7050726F7061676174696F6E28293B0A20207D293B0A0A';
wwv_flow_imp.g_varchar2_table(4126) := '20202F2F2070726576656E7420647261672070726F7061676174696F6E0A20206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E64656C65676174652E62696E6428636F6E7461696E65722C20454E5452595F';
wwv_flow_imp.g_varchar2_table(4127) := '53454C4543544F522C2027647261677374617274272C2066756E6374696F6E286576656E7429207B0A2020202073656C662E747269676765722827647261677374617274272C206576656E74293B0A20207D293B0A0A20206576656E744275732E6F6E28';
wwv_flow_imp.g_varchar2_table(4128) := '2763616E7661732E726573697A6564272C20746869732E5F6C61796F75744368616E6765642C2074686973293B0A0A20206576656E744275732E66697265282770616C657474652E637265617465272C207B0A20202020636F6E7461696E65723A20636F';
wwv_flow_imp.g_varchar2_table(4129) := '6E7461696E65720A20207D293B0A7D3B0A0A50616C657474652E70726F746F747970652E5F67657450726F766964657273203D2066756E6374696F6E28696429207B0A0A2020766172206576656E74203D20746869732E5F6576656E744275732E637265';
wwv_flow_imp.g_varchar2_table(4130) := '6174654576656E74287B0A20202020747970653A202770616C657474652E67657450726F766964657273272C0A2020202070726F7669646572733A205B5D0A20207D293B0A0A2020746869732E5F6576656E744275732E66697265286576656E74293B0A';
wwv_flow_imp.g_varchar2_table(4131) := '0A202072657475726E206576656E742E70726F7669646572733B0A7D3B0A0A2F2A2A0A202A205570646174652070616C657474652073746174652E0A202A0A202A2040706172616D207B207B0A202A2020206F70656E3F3A20626F6F6C65616E3B0A202A';
wwv_flow_imp.g_varchar2_table(4132) := '20202074776F436F6C756D6E3F3A20626F6F6C65616E3B0A202A207D207D205B73746174655D0A202A2F0A50616C657474652E70726F746F747970652E5F746F67676C655374617465203D2066756E6374696F6E28737461746529207B0A0A2020737461';
wwv_flow_imp.g_varchar2_table(4133) := '7465203D207374617465207C7C207B7D3B0A0A202076617220706172656E74203D20746869732E5F676574506172656E74436F6E7461696E657228292C0A202020202020636F6E7461696E6572203D20746869732E5F636F6E7461696E65723B0A0A2020';
wwv_flow_imp.g_varchar2_table(4134) := '766172206576656E74427573203D20746869732E5F6576656E744275733B0A0A20207661722074776F436F6C756D6E3B0A0A202076617220636C73203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F';
wwv_flow_imp.g_varchar2_table(4135) := '5F2E636C61737365732928636F6E7461696E6572292C0A202020202020706172656E74436C73203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E636C61737365732928706172656E74293B0A0A';
wwv_flow_imp.g_varchar2_table(4136) := '2020696620282774776F436F6C756D6E2720696E20737461746529207B0A2020202074776F436F6C756D6E203D2073746174652E74776F436F6C756D6E3B0A20207D20656C7365207B0A2020202074776F436F6C756D6E203D20746869732E5F6E656564';
wwv_flow_imp.g_varchar2_table(4137) := '73436F6C6C6170736528706172656E742E636C69656E744865696768742C20746869732E5F656E7472696573207C7C207B7D293B0A20207D0A0A20202F2F20616C77617973207570646174652074776F20636F6C756D6E0A2020636C732E746F67676C65';
wwv_flow_imp.g_varchar2_table(4138) := '2850414C455454455F54574F5F434F4C554D4E5F434C532C2074776F436F6C756D6E293B0A2020706172656E74436C732E746F67676C652850414C455454455F505245464958202B2050414C455454455F54574F5F434F4C554D4E5F434C532C2074776F';
wwv_flow_imp.g_varchar2_table(4139) := '436F6C756D6E293B0A0A202069662028276F70656E2720696E20737461746529207B0A20202020636C732E746F67676C652850414C455454455F4F50454E5F434C532C2073746174652E6F70656E293B0A20202020706172656E74436C732E746F67676C';
wwv_flow_imp.g_varchar2_table(4140) := '652850414C455454455F505245464958202B2050414C455454455F4F50454E5F434C532C2073746174652E6F70656E293B0A20207D0A0A20206576656E744275732E66697265282770616C657474652E6368616E676564272C207B0A2020202074776F43';
wwv_flow_imp.g_varchar2_table(4141) := '6F6C756D6E3A2074776F436F6C756D6E2C0A202020206F70656E3A20746869732E69734F70656E28290A20207D293B0A7D3B0A0A50616C657474652E70726F746F747970652E5F757064617465203D2066756E6374696F6E2829207B0A0A202076617220';
wwv_flow_imp.g_varchar2_table(4142) := '656E7472696573436F6E7461696E6572203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E71756572792928272E646A732D70616C657474652D656E7472696573272C20746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(4143) := '61696E6572292C0A202020202020656E7472696573203D20746869732E5F656E7472696573203D20746869732E676574456E747269657328293B0A0A202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F';
wwv_flow_imp.g_varchar2_table(4144) := '5F2E636C6561722928656E7472696573436F6E7461696E6572293B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F72456163682928656E74726965732C2066756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(4145) := '6E7472792C20696429207B0A0A202020207661722067726F7570696E67203D20656E7472792E67726F7570207C7C202764656661756C74273B0A0A2020202076617220636F6E7461696E6572203D2028302C6D696E5F646F6D5F5F5745425041434B5F49';
wwv_flow_imp.g_varchar2_table(4146) := '4D504F525445445F4D4F44554C455F305F5F2E71756572792928275B646174612D67726F75703D27202B2028302C5F7574696C5F4573636170655574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6573636170654353';
wwv_flow_imp.g_varchar2_table(4147) := '53292867726F7570696E6729202B20275D272C20656E7472696573436F6E7461696E6572293B0A202020206966202821636F6E7461696E657229207B0A202020202020636F6E7461696E6572203D2028302C6D696E5F646F6D5F5F5745425041434B5F49';
wwv_flow_imp.g_varchar2_table(4148) := '4D504F525445445F4D4F44554C455F305F5F2E646F6D6966792928273C64697620636C6173733D2267726F7570223E3C2F6469763E27293B0A20202020202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F30';
wwv_flow_imp.g_varchar2_table(4149) := '5F5F2E617474722928636F6E7461696E65722C2027646174612D67726F7570272C2067726F7570696E67293B0A0A202020202020656E7472696573436F6E7461696E65722E617070656E644368696C6428636F6E7461696E6572293B0A202020207D0A0A';
wwv_flow_imp.g_varchar2_table(4150) := '202020207661722068746D6C203D20656E7472792E68746D6C207C7C20280A202020202020656E7472792E736570617261746F72203F0A2020202020202020273C687220636C6173733D22736570617261746F7222202F3E27203A0A2020202020202020';
wwv_flow_imp.g_varchar2_table(4151) := '273C64697620636C6173733D22656E7472792220647261676761626C653D2274727565223E3C2F6469763E27293B0A0A0A2020202076617220636F6E74726F6C203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(4152) := '4C455F305F5F2E646F6D696679292868746D6C293B0A20202020636F6E7461696E65722E617070656E644368696C6428636F6E74726F6C293B0A0A202020206966202821656E7472792E736570617261746F7229207B0A20202020202028302C6D696E5F';
wwv_flow_imp.g_varchar2_table(4153) := '646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E617474722928636F6E74726F6C2C2027646174612D616374696F6E272C206964293B0A0A20202020202069662028656E7472792E7469746C6529207B0A202020202020';
wwv_flow_imp.g_varchar2_table(4154) := '202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E617474722928636F6E74726F6C2C20277469746C65272C20656E7472792E7469746C65293B0A2020202020207D0A0A2020202020206966202865';
wwv_flow_imp.g_varchar2_table(4155) := '6E7472792E636C6173734E616D6529207B0A2020202020202020616464436C617373657328636F6E74726F6C2C20656E7472792E636C6173734E616D65293B0A2020202020207D0A0A20202020202069662028656E7472792E696D61676555726C29207B';
wwv_flow_imp.g_varchar2_table(4156) := '0A202020202020202076617220696D616765203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E646F6D6966792928273C696D673E27293B0A202020202020202028302C6D696E5F646F6D5F5F57';
wwv_flow_imp.g_varchar2_table(4157) := '45425041434B5F494D504F525445445F4D4F44554C455F305F5F2E617474722928696D6167652C2027737263272C20656E7472792E696D61676555726C293B0A0A2020202020202020636F6E74726F6C2E617070656E644368696C6428696D616765293B';
wwv_flow_imp.g_varchar2_table(4158) := '0A2020202020207D0A202020207D0A20207D293B0A0A20202F2F206F70656E206166746572207570646174650A2020746869732E6F70656E28293B0A7D3B0A0A0A2F2A2A0A202A205472696767657220616E20616374696F6E20617661696C61626C6520';
wwv_flow_imp.g_varchar2_table(4159) := '6F6E207468652070616C657474650A202A0A202A2040706172616D207B737472696E677D20616374696F6E0A202A2040706172616D207B4576656E747D206576656E740A202A2040706172616D207B626F6F6C65616E7D205B6175746F41637469766174';
wwv_flow_imp.g_varchar2_table(4160) := '653D66616C73655D0A202A2F0A50616C657474652E70726F746F747970652E74726967676572203D2066756E6374696F6E28616374696F6E2C206576656E742C206175746F416374697661746529207B0A202076617220656E7472792C0A202020202020';
wwv_flow_imp.g_varchar2_table(4161) := '6F726967696E616C4576656E742C0A202020202020627574746F6E203D206576656E742E64656C6567617465546172676574207C7C206576656E742E7461726765743B0A0A20206966202821627574746F6E29207B0A2020202072657475726E20657665';
wwv_flow_imp.g_varchar2_table(4162) := '6E742E70726576656E7444656661756C7428293B0A20207D0A0A2020656E747279203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E617474722928627574746F6E2C2027646174612D61637469';
wwv_flow_imp.g_varchar2_table(4163) := '6F6E27293B0A20206F726967696E616C4576656E74203D206576656E742E6F726967696E616C4576656E74207C7C206576656E743B0A0A202072657475726E20746869732E74726967676572456E74727928656E7472792C20616374696F6E2C206F7269';
wwv_flow_imp.g_varchar2_table(4164) := '67696E616C4576656E742C206175746F4163746976617465293B0A7D3B0A0A2F2A2A0A202A2040706172616D207B737472696E677D20656E74727949640A202A2040706172616D207B737472696E677D20616374696F6E0A202A2040706172616D207B45';
wwv_flow_imp.g_varchar2_table(4165) := '76656E747D206576656E740A202A2040706172616D207B626F6F6C65616E7D205B6175746F41637469766174653D66616C73655D0A202A2F0A50616C657474652E70726F746F747970652E74726967676572456E747279203D2066756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(4166) := '6E74727949642C20616374696F6E2C206576656E742C206175746F416374697661746529207B0A202076617220656E7472696573203D20746869732E5F656E74726965732C0A202020202020656E7472792C0A20202020202068616E646C65723B0A0A20';
wwv_flow_imp.g_varchar2_table(4167) := '20656E747279203D20656E74726965735B656E74727949645D3B0A0A20202F2F207768656E207573657220636C69636B73206F6E207468652070616C6574746520616E64206E6F74206F6E20616E20616374696F6E0A20206966202821656E7472792920';
wwv_flow_imp.g_varchar2_table(4168) := '7B0A2020202072657475726E3B0A20207D0A0A202068616E646C6572203D20656E7472792E616374696F6E3B0A0A202069662028746869732E5F6576656E744275732E66697265282770616C657474652E74726967676572272C207B20656E7472792C20';
wwv_flow_imp.g_varchar2_table(4169) := '6576656E74207D29203D3D3D2066616C736529207B0A2020202072657475726E3B0A20207D0A0A20202F2F2073696D706C6520616374696F6E20287669612063616C6C6261636B2066756E6374696F6E290A20206966202828302C6D696E5F646173685F';
wwv_flow_imp.g_varchar2_table(4170) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E697346756E6374696F6E292868616E646C65722929207B0A2020202069662028616374696F6E203D3D3D2027636C69636B2729207B0A20202020202072657475726E2068616E64';
wwv_flow_imp.g_varchar2_table(4171) := '6C6572286576656E742C206175746F4163746976617465293B0A202020207D0A20207D20656C7365207B0A202020206966202868616E646C65725B616374696F6E5D29207B0A20202020202072657475726E2068616E646C65725B616374696F6E5D2865';
wwv_flow_imp.g_varchar2_table(4172) := '76656E742C206175746F4163746976617465293B0A202020207D0A20207D0A0A20202F2F2073696C656E6365206F7468657220616374696F6E730A20206576656E742E70726576656E7444656661756C7428293B0A7D3B0A0A50616C657474652E70726F';
wwv_flow_imp.g_varchar2_table(4173) := '746F747970652E5F6C61796F75744368616E676564203D2066756E6374696F6E2829207B0A2020746869732E5F746F67676C655374617465287B7D293B0A7D3B0A0A2F2A2A0A202A20446F207765206E65656420746F20636F6C6C6170736520746F2074';
wwv_flow_imp.g_varchar2_table(4174) := '776F20636F6C756D6E733F0A202A0A202A2040706172616D207B6E756D6265727D20617661696C61626C654865696768740A202A2040706172616D207B50616C65747465456E74726965737D20656E74726965730A202A0A202A204072657475726E207B';
wwv_flow_imp.g_varchar2_table(4175) := '626F6F6C65616E7D0A202A2F0A50616C657474652E70726F746F747970652E5F6E65656473436F6C6C61707365203D2066756E6374696F6E28617661696C61626C654865696768742C20656E747269657329207B0A0A20202F2F20746F70206D61726769';
wwv_flow_imp.g_varchar2_table(4176) := '6E202B20626F74746F6D20746F67676C65202B20626F74746F6D206D617267696E0A20202F2F20696D706C656D656E746F7273206D757374206F766572726964652074686973206D6574686F6420696620746865790A20202F2F206368616E6765207468';
wwv_flow_imp.g_varchar2_table(4177) := '652070616C65747465207374796C65730A2020766172206D617267696E203D203230202B203130202B2032303B0A0A202076617220656E7472696573486569676874203D204F626A6563742E6B65797328656E7472696573292E6C656E677468202A2034';
wwv_flow_imp.g_varchar2_table(4178) := '363B0A0A202072657475726E20617661696C61626C65486569676874203C20656E7472696573486569676874202B206D617267696E3B0A7D3B0A0A2F2A2A0A202A20436C6F7365207468652070616C657474652E0A202A2F0A50616C657474652E70726F';
wwv_flow_imp.g_varchar2_table(4179) := '746F747970652E636C6F7365203D2066756E6374696F6E2829207B0A2020746869732E5F746F67676C655374617465287B0A202020206F70656E3A2066616C73652C0A2020202074776F436F6C756D6E3A2066616C73650A20207D293B0A7D3B0A0A2F2A';
wwv_flow_imp.g_varchar2_table(4180) := '2A0A202A204F70656E207468652070616C657474652E0A202A2F0A50616C657474652E70726F746F747970652E6F70656E203D2066756E6374696F6E2829207B0A2020746869732E5F746F67676C655374617465287B206F70656E3A2074727565207D29';
wwv_flow_imp.g_varchar2_table(4181) := '3B0A7D3B0A0A2F2A2A0A202A20546F67676C65207468652070616C657474652E0A202A2F0A50616C657474652E70726F746F747970652E746F67676C65203D2066756E6374696F6E2829207B0A202069662028746869732E69734F70656E282929207B0A';
wwv_flow_imp.g_varchar2_table(4182) := '20202020746869732E636C6F736528293B0A20207D20656C7365207B0A20202020746869732E6F70656E28293B0A20207D0A7D3B0A0A2F2A2A0A202A2040706172616D207B737472696E677D20746F6F6C0A202A0A202A204072657475726E207B626F6F';
wwv_flow_imp.g_varchar2_table(4183) := '6C65616E7D0A202A2F0A50616C657474652E70726F746F747970652E6973416374697665546F6F6C203D2066756E6374696F6E28746F6F6C29207B0A202072657475726E20746F6F6C20262620746869732E5F616374697665546F6F6C203D3D3D20746F';
wwv_flow_imp.g_varchar2_table(4184) := '6F6C3B0A7D3B0A0A2F2A2A0A202A2040706172616D207B737472696E677D206E616D650A202A2F0A50616C657474652E70726F746F747970652E757064617465546F6F6C486967686C69676874203D2066756E6374696F6E286E616D6529207B0A202076';
wwv_flow_imp.g_varchar2_table(4185) := '617220656E7472696573436F6E7461696E65722C0A202020202020746F6F6C73436F6E7461696E65723B0A0A20206966202821746869732E5F746F6F6C73436F6E7461696E657229207B0A20202020656E7472696573436F6E7461696E6572203D202830';
wwv_flow_imp.g_varchar2_table(4186) := '2C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E71756572792928272E646A732D70616C657474652D656E7472696573272C20746869732E5F636F6E7461696E6572293B0A0A20202020746869732E5F746F';
wwv_flow_imp.g_varchar2_table(4187) := '6F6C73436F6E7461696E6572203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E71756572792928275B646174612D67726F75703D746F6F6C735D272C20656E7472696573436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(4188) := '293B0A20207D0A0A2020746F6F6C73436F6E7461696E6572203D20746869732E5F746F6F6C73436F6E7461696E65723B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F7245616368';
wwv_flow_imp.g_varchar2_table(4189) := '2928746F6F6C73436F6E7461696E65722E6368696C6472656E2C2066756E6374696F6E28746F6F6C29207B0A2020202076617220616374696F6E4E616D65203D20746F6F6C2E6765744174747269627574652827646174612D616374696F6E27293B0A0A';
wwv_flow_imp.g_varchar2_table(4190) := '202020206966202821616374696F6E4E616D6529207B0A20202020202072657475726E3B0A202020207D0A0A2020202076617220746F6F6C436C6173736573203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(4191) := '455F305F5F2E636C61737365732928746F6F6C293B0A0A20202020616374696F6E4E616D65203D20616374696F6E4E616D652E7265706C61636528272D746F6F6C272C202727293B0A0A2020202069662028746F6F6C436C61737365732E636F6E746169';
wwv_flow_imp.g_varchar2_table(4192) := '6E732827656E747279272920262620616374696F6E4E616D65203D3D3D206E616D6529207B0A202020202020746F6F6C436C61737365732E6164642827686967686C6967687465642D656E74727927293B0A202020207D20656C7365207B0A2020202020';
wwv_flow_imp.g_varchar2_table(4193) := '20746F6F6C436C61737365732E72656D6F76652827686967686C6967687465642D656E74727927293B0A202020207D0A20207D293B0A7D3B0A0A0A2F2A2A0A202A2052657475726E20607472756560206966207468652070616C65747465206973206F70';
wwv_flow_imp.g_varchar2_table(4194) := '656E65642E0A202A0A202A20406578616D706C650A202A0A202A206060606A6176617363726970740A202A2070616C657474652E6F70656E28293B0A202A0A202A206966202870616C657474652E69734F70656E282929207B0A202A2020202F2F207965';
wwv_flow_imp.g_varchar2_table(4195) := '732C20776520617265206F70656E0A202A207D0A202A206060600A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A50616C657474652E70726F746F747970652E69734F70656E203D2066756E6374696F6E2829207B0A2020726574';
wwv_flow_imp.g_varchar2_table(4196) := '75726E2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E636C61737365732928746869732E5F636F6E7461696E6572292E6861732850414C455454455F4F50454E5F434C53293B0A7D3B0A0A2F2A2A';
wwv_flow_imp.g_varchar2_table(4197) := '0A202A2047657420706172656E7420656C656D656E74206F662070616C657474652E0A202A0A202A204072657475726E207B48544D4C456C656D656E747D0A202A2F0A50616C657474652E70726F746F747970652E5F676574506172656E74436F6E7461';
wwv_flow_imp.g_varchar2_table(4198) := '696E6572203D2066756E6374696F6E2829207B0A202072657475726E20746869732E5F63616E7661732E676574436F6E7461696E657228293B0A7D3B0A0A0A2F2A206D61726B757020646566696E6974696F6E202A2F0A0A50616C657474652E48544D4C';
wwv_flow_imp.g_varchar2_table(4199) := '5F4D41524B5550203D0A2020273C64697620636C6173733D22646A732D70616C65747465223E27202B0A20202020273C64697620636C6173733D22646A732D70616C657474652D656E7472696573223E3C2F6469763E27202B0A20202020273C64697620';
wwv_flow_imp.g_varchar2_table(4200) := '636C6173733D22646A732D70616C657474652D746F67676C65223E3C2F6469763E27202B0A2020273C2F6469763E273B0A0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A66756E6374696F6E20616464436C';
wwv_flow_imp.g_varchar2_table(4201) := '617373657328656C656D656E742C20636C6173734E616D657329207B0A0A202076617220636C6173736573203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E636C61737365732928656C656D65';
wwv_flow_imp.g_varchar2_table(4202) := '6E74293B0A0A20207661722061637475616C436C6173734E616D6573203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E697341727261792928636C6173734E616D657329203F20636C617373';
wwv_flow_imp.g_varchar2_table(4203) := '4E616D6573203A20636C6173734E616D65732E73706C6974282F5C732B2F67293B0A202061637475616C436C6173734E616D65732E666F72456163682866756E6374696F6E28636C7329207B0A20202020636C61737365732E61646428636C73293B0A20';
wwv_flow_imp.g_varchar2_table(4204) := '207D293B0A7D0A0A66756E6374696F6E2061646450616C65747465456E747269657328656E74726965732C2070726F766964657229207B0A0A202076617220656E74726965734F7255706461746572203D2070726F76696465722E67657450616C657474';
wwv_flow_imp.g_varchar2_table(4205) := '65456E747269657328293B0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E697346756E6374696F6E2928656E74726965734F72557064617465722929207B0A20202020726574';
wwv_flow_imp.g_varchar2_table(4206) := '75726E20656E74726965734F725570646174657228656E7472696573293B0A20207D0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E666F72456163682928656E74726965734F72557064';
wwv_flow_imp.g_varchar2_table(4207) := '617465722C2066756E6374696F6E28656E7472792C20696429207B0A20202020656E74726965735B69645D203D20656E7472793B0A20207D293B0A0A202072657475726E20656E74726965733B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E';
wwv_flow_imp.g_varchar2_table(4208) := '2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F70616C657474652F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4209) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F70616C657474652F696E6465782E6A73202A2A2A210A20205C2A2A';
wwv_flow_imp.g_varchar2_table(4210) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765';
wwv_flow_imp.g_varchar2_table(4211) := '627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E792065';
wwv_flow_imp.g_varchar2_table(4212) := '78706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F574542';
wwv_flow_imp.g_varchar2_table(4213) := '5041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F50616C657474655F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(4214) := '4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F50616C65747465202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F70616C657474652F5061';
wwv_flow_imp.g_varchar2_table(4215) := '6C657474652E6A7322293B0A0A0A0A2F2A2A0A202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F';
wwv_flow_imp.g_varchar2_table(4216) := '6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F696E69745F5F3A205B202770616C6574746527205D2C0A202070616C657474653A205B202774797065272C205F50616C657474655F5F574542504143';
wwv_flow_imp.g_varchar2_table(4217) := '4B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D205D0A7D293B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F726F';
wwv_flow_imp.g_varchar2_table(4218) := '6F742D656C656D656E74732F526F6F74456C656D656E74734265686176696F722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4219) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F726F6F742D656C656D656E74732F526F6F74456C656D656E74';
wwv_flow_imp.g_varchar2_table(4220) := '734265686176696F722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4221) := '2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F7265';
wwv_flow_imp.g_varchar2_table(4222) := '71756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A';
wwv_flow_imp.g_varchar2_table(4223) := '206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F20526F6F74456C656D656E74734265686176696F72290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A';
wwv_flow_imp.g_varchar2_table(4224) := '2F2A206861726D6F6E7920696D706F7274202A2F2076617220696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A2120696E68';
wwv_flow_imp.g_varchar2_table(4225) := '65726974732D62726F77736572202A2F20222E2F6E6F64655F6D6F64756C65732F696E6865726974732D62726F777365722F646973742F696E6465782E65732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F636F6D6D';
wwv_flow_imp.g_varchar2_table(4226) := '616E645F436F6D6D616E64496E746572636570746F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F636F6D6D616E642F436F6D6D616E6449';
wwv_flow_imp.g_varchar2_table(4227) := '6E746572636570746F72202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F6D6D616E642F436F6D6D616E64496E746572636570746F722E6A7322293B0A0A0A0A0A2F2A2A0A202A204074797065646566207B69';
wwv_flow_imp.g_varchar2_table(4228) := '6D706F727428276469646927292E496E6A6563746F727D20496E6A6563746F720A202A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E64656661756C747D2043616E7661730A202A2F0A0A2F2A';
wwv_flow_imp.g_varchar2_table(4229) := '2A0A202A2041206D6F64656C696E67206265686176696F72207468617420656E7375726573207765207365742074686520636F727265637420726F6F7420656C656D656E740A202A20617320776520756E646F20616E64207265646F20636F6D6D616E64';
wwv_flow_imp.g_varchar2_table(4230) := '732E0A202A0A202A2040706172616D207B43616E7661737D2063616E7661730A202A2040706172616D207B496E6A6563746F727D20696E6A6563746F720A202A2F0A66756E6374696F6E20526F6F74456C656D656E74734265686176696F722863616E76';
wwv_flow_imp.g_varchar2_table(4231) := '61732C20696E6A6563746F7229207B0A0A2020696E6A6563746F722E696E766F6B65285F636F6D6D616E645F436F6D6D616E64496E746572636570746F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74';
wwv_flow_imp.g_varchar2_table(4232) := '225D2C2074686973293B0A0A2020746869732E65786563757465642866756E6374696F6E286576656E7429207B0A2020202076617220636F6E74657874203D206576656E742E636F6E746578743B0A0A2020202069662028636F6E746578742E726F6F74';
wwv_flow_imp.g_varchar2_table(4233) := '456C656D656E7429207B0A20202020202063616E7661732E736574526F6F74456C656D656E7428636F6E746578742E726F6F74456C656D656E74293B0A202020207D20656C7365207B0A202020202020636F6E746578742E726F6F74456C656D656E7420';
wwv_flow_imp.g_varchar2_table(4234) := '3D2063616E7661732E676574526F6F74456C656D656E7428293B0A202020207D0A20207D293B0A0A2020746869732E7265766572742866756E6374696F6E286576656E7429207B0A2020202076617220636F6E74657874203D206576656E742E636F6E74';
wwv_flow_imp.g_varchar2_table(4235) := '6578743B0A0A2020202069662028636F6E746578742E726F6F74456C656D656E7429207B0A20202020202063616E7661732E736574526F6F74456C656D656E7428636F6E746578742E726F6F74456C656D656E74293B0A202020207D0A20207D293B0A7D';
wwv_flow_imp.g_varchar2_table(4236) := '0A0A28302C696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D2928526F6F74456C656D656E74734265686176696F722C205F636F6D6D616E645F436F6D6D616E';
wwv_flow_imp.g_varchar2_table(4237) := '64496E746572636570746F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D293B0A0A526F6F74456C656D656E74734265686176696F722E24696E6A656374203D205B202763616E766173272C2027';
wwv_flow_imp.g_varchar2_table(4238) := '696E6A6563746F7227205D3B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F726F6F742D656C656D656E74732F696E6465782E6A73223A0A2F2A212A';
wwv_flow_imp.g_varchar2_table(4239) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F646961677261';
wwv_flow_imp.g_varchar2_table(4240) := '6D2D6A732F6C69622F66656174757265732F726F6F742D656C656D656E74732F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4241) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A';
wwv_flow_imp.g_varchar2_table(4242) := '0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578';
wwv_flow_imp.g_varchar2_table(4243) := '706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F';
wwv_flow_imp.g_varchar2_table(4244) := '207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F526F6F74456C656D656E74734265686176696F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F72657175697265';
wwv_flow_imp.g_varchar2_table(4245) := '5F5F282F2A21202E2F526F6F74456C656D656E74734265686176696F72202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F726F6F742D656C656D656E74732F526F6F74456C656D656E747342';
wwv_flow_imp.g_varchar2_table(4246) := '65686176696F722E6A7322293B0A0A0A0A2F2A2A0A202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20';
wwv_flow_imp.g_varchar2_table(4247) := '636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F696E69745F5F3A205B2027726F6F74456C656D656E74734265686176696F7227205D2C0A2020726F6F74456C656D656E74734265686176696F72';
wwv_flow_imp.g_varchar2_table(4248) := '3A205B202774797065272C205F526F6F74456C656D656E74734265686176696F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D205D0A7D293B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F2022';
wwv_flow_imp.g_varchar2_table(4249) := '2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E2F53656C656374696F6E2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4250) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E2F53656C65';
wwv_flow_imp.g_varchar2_table(4251) := '6374696F6E2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E';
wwv_flow_imp.g_varchar2_table(4252) := '757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(4253) := '5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F20';
wwv_flow_imp.g_varchar2_table(4254) := '20202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F2053656C656374696F6E290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F64';
wwv_flow_imp.g_varchar2_table(4255) := '6173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F64697374';
wwv_flow_imp.g_varchar2_table(4256) := '2F696E6465782E65736D2E6A7322293B0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E64656661756C747D2043616E7661730A202A204074797065646566207B696D706F727428';
wwv_flow_imp.g_varchar2_table(4257) := '272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A2F0A0A2F2A2A0A202A204120736572766963652074686174206F6666657273207468652063757272656E742073656C656374696F6E20696E20';
wwv_flow_imp.g_varchar2_table(4258) := '61206469616772616D2E0A202A204F6666657273207468652061706920746F20636F6E74726F6C207468652073656C656374696F6E2C20746F6F2E0A202A0A202A2040706172616D207B4576656E744275737D206576656E744275730A202A2040706172';
wwv_flow_imp.g_varchar2_table(4259) := '616D207B43616E7661737D2063616E7661730A202A2F0A66756E6374696F6E2053656C656374696F6E286576656E744275732C2063616E76617329207B0A0A2020746869732E5F6576656E74427573203D206576656E744275733B0A2020746869732E5F';
wwv_flow_imp.g_varchar2_table(4260) := '63616E766173203D2063616E7661733B0A0A20202F2A2A0A2020202A204074797065207B4F626A6563745B5D7D0A2020202A2F0A2020746869732E5F73656C6563746564456C656D656E7473203D205B5D3B0A0A20207661722073656C66203D20746869';
wwv_flow_imp.g_varchar2_table(4261) := '733B0A0A20206576656E744275732E6F6E285B202773686170652E72656D6F7665272C2027636F6E6E656374696F6E2E72656D6F766527205D2C2066756E6374696F6E286529207B0A2020202076617220656C656D656E74203D20652E656C656D656E74';
wwv_flow_imp.g_varchar2_table(4262) := '3B0A2020202073656C662E646573656C65637428656C656D656E74293B0A20207D293B0A0A20206576656E744275732E6F6E285B20276469616772616D2E636C656172272C2027726F6F742E73657427205D2C2066756E6374696F6E286529207B0A2020';
wwv_flow_imp.g_varchar2_table(4263) := '202073656C662E73656C656374286E756C6C293B0A20207D293B0A7D0A0A53656C656374696F6E2E24696E6A656374203D205B20276576656E74427573272C202763616E76617327205D3B0A0A2F2A2A0A202A20446573656C65637420616E20656C656D';
wwv_flow_imp.g_varchar2_table(4264) := '656E742E0A202A0A202A2040706172616D207B4F626A6563747D20656C656D656E742054686520656C656D656E7420746F20646573656C6563742E0A202A2F0A53656C656374696F6E2E70726F746F747970652E646573656C656374203D2066756E6374';
wwv_flow_imp.g_varchar2_table(4265) := '696F6E28656C656D656E7429207B0A20207661722073656C6563746564456C656D656E7473203D20746869732E5F73656C6563746564456C656D656E74733B0A0A202076617220696478203D2073656C6563746564456C656D656E74732E696E6465784F';
wwv_flow_imp.g_varchar2_table(4266) := '6628656C656D656E74293B0A0A20206966202869647820213D3D202D3129207B0A20202020766172206F6C6453656C656374696F6E203D2073656C6563746564456C656D656E74732E736C69636528293B0A0A2020202073656C6563746564456C656D65';
wwv_flow_imp.g_varchar2_table(4267) := '6E74732E73706C696365286964782C2031293B0A0A20202020746869732E5F6576656E744275732E66697265282773656C656374696F6E2E6368616E676564272C207B206F6C6453656C656374696F6E3A206F6C6453656C656374696F6E2C206E657753';
wwv_flow_imp.g_varchar2_table(4268) := '656C656374696F6E3A2073656C6563746564456C656D656E7473207D293B0A20207D0A7D3B0A0A2F2A2A0A202A20476574207468652073656C656374656420656C656D656E74732E0A202A0A202A204072657475726E207B4F626A6563745B5D7D205468';
wwv_flow_imp.g_varchar2_table(4269) := '652073656C656374656420656C656D656E74732E0A202A2F0A53656C656374696F6E2E70726F746F747970652E676574203D2066756E6374696F6E2829207B0A202072657475726E20746869732E5F73656C6563746564456C656D656E74733B0A7D3B0A';
wwv_flow_imp.g_varchar2_table(4270) := '0A2F2A2A0A202A20436865636B207768657468657220616E20656C656D656E742069732073656C65637465642E0A202A0A202A2040706172616D207B4F626A6563747D20656C656D656E742054686520656C656D656E742E0A202A0A202A204072657475';
wwv_flow_imp.g_varchar2_table(4271) := '726E207B626F6F6C65616E7D20576865746865722074686520656C656D656E742069732073656C65637465642E0A202A2F0A53656C656374696F6E2E70726F746F747970652E697353656C6563746564203D2066756E6374696F6E28656C656D656E7429';
wwv_flow_imp.g_varchar2_table(4272) := '207B0A202072657475726E20746869732E5F73656C6563746564456C656D656E74732E696E6465784F6628656C656D656E742920213D3D202D313B0A7D3B0A0A0A2F2A2A0A202A2053656C656374206F6E65206F72206D616E7920656C656D656E74732E';
wwv_flow_imp.g_varchar2_table(4273) := '0A202A0A202A2040706172616D207B4F626A6563747C4F626A6563745B5D7D20656C656D656E74732054686520656C656D656E7428732920746F2073656C6563742E0A202A2040706172616D207B626F6F6C65616E7D205B6164645D2057686574686572';
wwv_flow_imp.g_varchar2_table(4274) := '20746F206164642074686520656C656D656E7428732920746F207468652073656C656374656420656C656D656E74732E0A202A2044656661756C747320746F206066616C7365602E0A202A2F0A53656C656374696F6E2E70726F746F747970652E73656C';
wwv_flow_imp.g_varchar2_table(4275) := '656374203D2066756E6374696F6E28656C656D656E74732C2061646429207B0A20207661722073656C6563746564456C656D656E7473203D20746869732E5F73656C6563746564456C656D656E74732C0A2020202020206F6C6453656C656374696F6E20';
wwv_flow_imp.g_varchar2_table(4276) := '3D2073656C6563746564456C656D656E74732E736C69636528293B0A0A2020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E697341727261792928656C656D656E74732929207B0A20';
wwv_flow_imp.g_varchar2_table(4277) := '202020656C656D656E7473203D20656C656D656E7473203F205B20656C656D656E7473205D203A205B5D3B0A20207D0A0A20207661722063616E766173203D20746869732E5F63616E7661733B0A0A202076617220726F6F74456C656D656E74203D2063';
wwv_flow_imp.g_varchar2_table(4278) := '616E7661732E676574526F6F74456C656D656E7428293B0A0A2020656C656D656E7473203D20656C656D656E74732E66696C7465722866756E6374696F6E28656C656D656E7429207B0A2020202076617220656C656D656E74526F6F74203D2063616E76';
wwv_flow_imp.g_varchar2_table(4279) := '61732E66696E64526F6F7428656C656D656E74293B0A0A2020202072657475726E20726F6F74456C656D656E74203D3D3D20656C656D656E74526F6F743B0A20207D293B0A0A20202F2F2073656C656374696F6E206D617920626520636C656172656420';
wwv_flow_imp.g_varchar2_table(4280) := '62792070617373696E6720616E20656D707479206172726179206F72206E756C6C0A20202F2F20746F20746865206D6574686F640A20206966202861646429207B0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(4281) := '4D4F44554C455F305F5F2E666F72456163682928656C656D656E74732C2066756E6374696F6E28656C656D656E7429207B0A2020202020206966202873656C6563746564456C656D656E74732E696E6465784F6628656C656D656E742920213D3D202D31';
wwv_flow_imp.g_varchar2_table(4282) := '29207B0A0A20202020202020202F2F20616C72656164792073656C65637465640A202020202020202072657475726E3B0A2020202020207D20656C7365207B0A202020202020202073656C6563746564456C656D656E74732E7075736828656C656D656E';
wwv_flow_imp.g_varchar2_table(4283) := '74293B0A2020202020207D0A202020207D293B0A20207D20656C7365207B0A20202020746869732E5F73656C6563746564456C656D656E7473203D2073656C6563746564456C656D656E7473203D20656C656D656E74732E736C69636528293B0A20207D';
wwv_flow_imp.g_varchar2_table(4284) := '0A0A2020746869732E5F6576656E744275732E66697265282773656C656374696F6E2E6368616E676564272C207B206F6C6453656C656374696F6E3A206F6C6453656C656374696F6E2C206E657753656C656374696F6E3A2073656C6563746564456C65';
wwv_flow_imp.g_varchar2_table(4285) := '6D656E7473207D293B0A7D3B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E2F53656C656374696F6E4265686176696F722E';
wwv_flow_imp.g_varchar2_table(4286) := '6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F';
wwv_flow_imp.g_varchar2_table(4287) := '64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E2F53656C656374696F6E4265686176696F722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4288) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F';
wwv_flow_imp.g_varchar2_table(4289) := '7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F';
wwv_flow_imp.g_varchar2_table(4290) := '5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F2053';
wwv_flow_imp.g_varchar2_table(4291) := '656C656374696F6E4265686176696F72290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6F7573655F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(4292) := '44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F4D6F757365202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6F7573652E6A7322';
wwv_flow_imp.g_varchar2_table(4293) := '293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368';
wwv_flow_imp.g_varchar2_table(4294) := '202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E64';
wwv_flow_imp.g_varchar2_table(4295) := '656661756C747D2043616E7661730A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F456C656D656E74526567697374727927292E64656661756C747D20456C656D656E7452656769737472790A202A2040747970656465';
wwv_flow_imp.g_varchar2_table(4296) := '66207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A204074797065646566207B696D706F727428272E2F53656C656374696F6E27292E64656661756C747D2053656C6563';
wwv_flow_imp.g_varchar2_table(4297) := '74696F6E0A202A2F0A0A2F2A2A0A202A2040706172616D207B4576656E744275737D206576656E744275730A202A2040706172616D207B53656C656374696F6E7D2073656C656374696F6E0A202A2040706172616D207B43616E7661737D2063616E7661';
wwv_flow_imp.g_varchar2_table(4298) := '730A202A2040706172616D207B456C656D656E7452656769737472797D20656C656D656E7452656769737472790A202A2F0A66756E6374696F6E2053656C656374696F6E4265686176696F72286576656E744275732C2073656C656374696F6E2C206361';
wwv_flow_imp.g_varchar2_table(4299) := '6E7661732C20656C656D656E74526567697374727929207B0A0A20202F2F2053656C65637420656C656D656E7473206F6E206372656174650A20206576656E744275732E6F6E28276372656174652E656E64272C203530302C2066756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(4300) := '76656E7429207B0A2020202076617220636F6E74657874203D206576656E742E636F6E746578742C0A202020202020202063616E45786563757465203D20636F6E746578742E63616E457865637574652C0A2020202020202020656C656D656E7473203D';
wwv_flow_imp.g_varchar2_table(4301) := '20636F6E746578742E656C656D656E74732C0A202020202020202068696E7473203D20636F6E746578742E68696E7473207C7C207B7D2C0A20202020202020206175746F53656C656374203D2068696E74732E6175746F53656C6563743B0A0A20202020';
wwv_flow_imp.g_varchar2_table(4302) := '6966202863616E4578656375746529207B0A202020202020696620286175746F53656C656374203D3D3D2066616C736529207B0A0A20202020202020202F2F2053656C656374206E6F20656C656D656E74730A202020202020202072657475726E3B0A20';
wwv_flow_imp.g_varchar2_table(4303) := '20202020207D0A0A2020202020206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6973417272617929286175746F53656C6563742929207B0A202020202020202073656C656374696F6E';
wwv_flow_imp.g_varchar2_table(4304) := '2E73656C656374286175746F53656C656374293B0A2020202020207D20656C7365207B0A0A20202020202020202F2F2053656C65637420616C6C20656C656D656E74732062792064656661756C740A202020202020202073656C656374696F6E2E73656C';
wwv_flow_imp.g_varchar2_table(4305) := '65637428656C656D656E74732E66696C74657228697353686F776E29293B0A2020202020207D0A202020207D0A20207D293B0A0A20202F2F2053656C65637420636F6E6E656374696F6E2074617267657473206F6E20636F6E6E6563740A20206576656E';
wwv_flow_imp.g_varchar2_table(4306) := '744275732E6F6E2827636F6E6E6563742E656E64272C203530302C2066756E6374696F6E286576656E7429207B0A2020202076617220636F6E74657874203D206576656E742E636F6E746578742C0A2020202020202020636F6E6E656374696F6E203D20';
wwv_flow_imp.g_varchar2_table(4307) := '636F6E746578742E636F6E6E656374696F6E3B0A0A2020202069662028636F6E6E656374696F6E29207B0A20202020202073656C656374696F6E2E73656C65637428636F6E6E656374696F6E293B0A202020207D0A20207D293B0A0A20202F2F2053656C';
wwv_flow_imp.g_varchar2_table(4308) := '65637420736861706573206F6E206D6F76650A20206576656E744275732E6F6E282773686170652E6D6F76652E656E64272C203530302C2066756E6374696F6E286576656E7429207B0A202020207661722070726576696F757353656C656374696F6E20';
wwv_flow_imp.g_varchar2_table(4309) := '3D206576656E742E70726576696F757353656C656374696F6E207C7C205B5D3B0A0A20202020766172207368617065203D20656C656D656E7452656769737472792E676574286576656E742E636F6E746578742E73686170652E6964293B0A0A20202020';
wwv_flow_imp.g_varchar2_table(4310) := '2F2F20416C776179732073656C656374206D61696E207368617065206F6E206D6F76650A2020202076617220697353656C6563746564203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6669';
wwv_flow_imp.g_varchar2_table(4311) := '6E64292870726576696F757353656C656374696F6E2C2066756E6374696F6E2873656C6563746564536861706529207B0A20202020202072657475726E2073686170652E6964203D3D3D2073656C656374656453686170652E69643B0A202020207D293B';
wwv_flow_imp.g_varchar2_table(4312) := '0A0A202020206966202821697353656C656374656429207B0A20202020202073656C656374696F6E2E73656C656374287368617065293B0A202020207D0A20207D293B0A0A20202F2F2053656C65637420656C656D656E7473206F6E20636C69636B0A20';
wwv_flow_imp.g_varchar2_table(4313) := '206576656E744275732E6F6E2827656C656D656E742E636C69636B272C2066756E6374696F6E286576656E7429207B0A0A20202020696620282128302C5F7574696C5F4D6F7573655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F';
wwv_flow_imp.g_varchar2_table(4314) := '5F2E69735072696D617279427574746F6E29286576656E742929207B0A20202020202072657475726E3B0A202020207D0A0A2020202076617220656C656D656E74203D206576656E742E656C656D656E743B0A0A2020202069662028656C656D656E7420';
wwv_flow_imp.g_varchar2_table(4315) := '3D3D3D2063616E7661732E676574526F6F74456C656D656E74282929207B0A202020202020656C656D656E74203D206E756C6C3B0A202020207D0A0A2020202076617220697353656C6563746564203D2073656C656374696F6E2E697353656C65637465';
wwv_flow_imp.g_varchar2_table(4316) := '6428656C656D656E74292C0A202020202020202069734D756C746953656C656374203D2073656C656374696F6E2E67657428292E6C656E677468203E20313B0A0A202020202F2F2041646420746F2073656C656374696F6E206966205348494654207072';
wwv_flow_imp.g_varchar2_table(4317) := '65737365640A2020202076617220616464203D2028302C5F7574696C5F4D6F7573655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6861735365636F6E646172794D6F64696669657229286576656E74293B0A0A2020202069';
wwv_flow_imp.g_varchar2_table(4318) := '662028697353656C65637465642026262069734D756C746953656C65637429207B0A2020202020206966202861646429207B0A0A20202020202020202F2F20446573656C65637420656C656D656E740A202020202020202072657475726E2073656C6563';
wwv_flow_imp.g_varchar2_table(4319) := '74696F6E2E646573656C65637428656C656D656E74293B0A2020202020207D20656C7365207B0A0A20202020202020202F2F2053656C65637420656C656D656E74206F6E6C790A202020202020202072657475726E2073656C656374696F6E2E73656C65';
wwv_flow_imp.g_varchar2_table(4320) := '637428656C656D656E74293B0A2020202020207D0A202020207D20656C7365206966202821697353656C656374656429207B0A0A2020202020202F2F2053656C65637420656C656D656E740A20202020202073656C656374696F6E2E73656C6563742865';
wwv_flow_imp.g_varchar2_table(4321) := '6C656D656E742C20616464293B0A202020207D20656C7365207B0A0A2020202020202F2F20446573656C65637420656C656D656E740A20202020202073656C656374696F6E2E646573656C65637428656C656D656E74293B0A202020207D0A20207D293B';
wwv_flow_imp.g_varchar2_table(4322) := '0A7D0A0A53656C656374696F6E4265686176696F722E24696E6A656374203D205B0A2020276576656E74427573272C0A20202773656C656374696F6E272C0A20202763616E766173272C0A202027656C656D656E745265676973747279270A5D3B0A0A0A';
wwv_flow_imp.g_varchar2_table(4323) := '66756E6374696F6E20697353686F776E28656C656D656E7429207B0A202072657475726E2021656C656D656E742E68696464656E3B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A';
wwv_flow_imp.g_varchar2_table(4324) := '732F6C69622F66656174757265732F73656C656374696F6E2F53656C656374696F6E56697375616C732E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4325) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E2F53656C656374696F6E5669737561';
wwv_flow_imp.g_varchar2_table(4326) := '6C732E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F202828';
wwv_flow_imp.g_varchar2_table(4327) := '5F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F776562';
wwv_flow_imp.g_varchar2_table(4328) := '7061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274';
wwv_flow_imp.g_varchar2_table(4329) := '202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F2053656C656374696F6E56697375616C73290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A';
wwv_flow_imp.g_varchar2_table(4330) := '2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D69';
wwv_flow_imp.g_varchar2_table(4331) := '6E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722074696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061';
wwv_flow_imp.g_varchar2_table(4332) := '636B5F726571756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D7376672F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076617220';
wwv_flow_imp.g_varchar2_table(4333) := '5F7574696C5F456C656D656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F456C656D656E7473202A2F20222E2F6E6F6465';
wwv_flow_imp.g_varchar2_table(4334) := '5F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F456C656D656E74732E6A7322293B0A0A0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E6465666175';
wwv_flow_imp.g_varchar2_table(4335) := '6C747D2043616E7661730A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A204074797065646566207B696D706F727428272E2F53656C6563';
wwv_flow_imp.g_varchar2_table(4336) := '74696F6E27292E64656661756C747D2053656C656374696F6E0A202A2F0A0A766172204D41524B45525F484F564552203D2027686F766572272C0A202020204D41524B45525F53454C4543544544203D202773656C6563746564273B0A0A766172205345';
wwv_flow_imp.g_varchar2_table(4337) := '4C454354494F4E5F4F55544C494E455F50414444494E47203D20363B0A0A0A2F2A2A0A202A204120706C7567696E2074686174206164647320612076697369626C652073656C656374696F6E20554920746F2073686170657320616E6420636F6E6E6563';
wwv_flow_imp.g_varchar2_table(4338) := '74696F6E730A202A20627920617070656E64696E6720746865203C636F64653E686F7665723C2F636F64653E20616E64203C636F64653E73656C65637465643C2F636F64653E20636C617373657320746F207468656D2E0A202A0A202A2040636C617373';
wwv_flow_imp.g_varchar2_table(4339) := '0A202A0A202A204D616B657320656C656D656E74732073656C65637461626C652C20746F6F2E0A202A0A202A2040706172616D207B43616E7661737D2063616E7661730A202A2040706172616D207B4576656E744275737D206576656E744275730A202A';
wwv_flow_imp.g_varchar2_table(4340) := '2040706172616D207B53656C656374696F6E7D2073656C656374696F6E0A202A2F0A66756E6374696F6E2053656C656374696F6E56697375616C732863616E7661732C206576656E744275732C2073656C656374696F6E29207B0A2020746869732E5F63';
wwv_flow_imp.g_varchar2_table(4341) := '616E766173203D2063616E7661733B0A0A20207661722073656C66203D20746869733B0A0A2020746869732E5F6D756C746953656C656374696F6E426F78203D206E756C6C3B0A0A202066756E6374696F6E206164644D61726B657228652C20636C7329';
wwv_flow_imp.g_varchar2_table(4342) := '207B0A2020202063616E7661732E6164644D61726B657228652C20636C73293B0A20207D0A0A202066756E6374696F6E2072656D6F76654D61726B657228652C20636C7329207B0A2020202063616E7661732E72656D6F76654D61726B657228652C2063';
wwv_flow_imp.g_varchar2_table(4343) := '6C73293B0A20207D0A0A20206576656E744275732E6F6E2827656C656D656E742E686F766572272C2066756E6374696F6E286576656E7429207B0A202020206164644D61726B6572286576656E742E656C656D656E742C204D41524B45525F484F564552';
wwv_flow_imp.g_varchar2_table(4344) := '293B0A20207D293B0A0A20206576656E744275732E6F6E2827656C656D656E742E6F7574272C2066756E6374696F6E286576656E7429207B0A2020202072656D6F76654D61726B6572286576656E742E656C656D656E742C204D41524B45525F484F5645';
wwv_flow_imp.g_varchar2_table(4345) := '52293B0A20207D293B0A0A20206576656E744275732E6F6E282773656C656374696F6E2E6368616E676564272C2066756E6374696F6E286576656E7429207B0A0A2020202066756E6374696F6E20646573656C656374287329207B0A2020202020207265';
wwv_flow_imp.g_varchar2_table(4346) := '6D6F76654D61726B657228732C204D41524B45525F53454C4543544544293B0A202020207D0A0A2020202066756E6374696F6E2073656C656374287329207B0A2020202020206164644D61726B657228732C204D41524B45525F53454C4543544544293B';
wwv_flow_imp.g_varchar2_table(4347) := '0A202020207D0A0A20202020766172206F6C6453656C656374696F6E203D206576656E742E6F6C6453656C656374696F6E2C0A20202020202020206E657753656C656374696F6E203D206576656E742E6E657753656C656374696F6E3B0A0A2020202028';
wwv_flow_imp.g_varchar2_table(4348) := '302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F724561636829286F6C6453656C656374696F6E2C2066756E6374696F6E286529207B0A202020202020696620286E657753656C656374696F6E2E';
wwv_flow_imp.g_varchar2_table(4349) := '696E6465784F66286529203D3D3D202D3129207B0A2020202020202020646573656C6563742865293B0A2020202020207D0A202020207D293B0A0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F';
wwv_flow_imp.g_varchar2_table(4350) := '305F5F2E666F724561636829286E657753656C656374696F6E2C2066756E6374696F6E286529207B0A202020202020696620286F6C6453656C656374696F6E2E696E6465784F66286529203D3D3D202D3129207B0A202020202020202073656C65637428';
wwv_flow_imp.g_varchar2_table(4351) := '65293B0A2020202020207D0A202020207D293B0A0A2020202073656C662E5F75706461746553656C656374696F6E4F75746C696E65286E657753656C656374696F6E293B0A20207D293B0A0A0A20206576656E744275732E6F6E2827656C656D656E742E';
wwv_flow_imp.g_varchar2_table(4352) := '6368616E676564272C2066756E6374696F6E286576656E7429207B0A202020206966202873656C656374696F6E2E697353656C6563746564286576656E742E656C656D656E742929207B0A20202020202073656C662E5F75706461746553656C65637469';
wwv_flow_imp.g_varchar2_table(4353) := '6F6E4F75746C696E652873656C656374696F6E2E6765742829293B0A202020207D0A20207D293B0A7D0A0A53656C656374696F6E56697375616C732E24696E6A656374203D205B0A20202763616E766173272C0A2020276576656E74427573272C0A2020';
wwv_flow_imp.g_varchar2_table(4354) := '2773656C656374696F6E270A5D3B0A0A53656C656374696F6E56697375616C732E70726F746F747970652E5F75706461746553656C656374696F6E4F75746C696E65203D2066756E6374696F6E2873656C656374696F6E29207B0A2020766172206C6179';
wwv_flow_imp.g_varchar2_table(4355) := '6572203D20746869732E5F63616E7661732E6765744C61796572282773656C656374696F6E4F75746C696E6527293B0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E636C65617229286C';
wwv_flow_imp.g_varchar2_table(4356) := '61796572293B0A0A202076617220656E61626C6564203D2073656C656374696F6E2E6C656E677468203E20313B0A0A202076617220636F6E7461696E6572203D20746869732E5F63616E7661732E676574436F6E7461696E657228293B0A0A202028302C';
wwv_flow_imp.g_varchar2_table(4357) := '74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E636C61737365732928636F6E7461696E6572295B656E61626C6564203F202761646427203A202772656D6F7665275D2827646A732D6D756C74692D73656C';
wwv_flow_imp.g_varchar2_table(4358) := '65637427293B0A0A20206966202821656E61626C656429207B0A2020202072657475726E3B0A20207D0A0A20207661722062426F78203D2061646453656C656374696F6E4F75746C696E6550616464696E672828302C5F7574696C5F456C656D656E7473';
wwv_flow_imp.g_varchar2_table(4359) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E67657442426F78292873656C656374696F6E29293B0A0A20207661722072656374203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(4360) := '4C455F315F5F2E6372656174652928277265637427293B0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E617474722928726563742C2028302C6D696E5F646173685F5F5745425041434B';
wwv_flow_imp.g_varchar2_table(4361) := '5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E29287B0A2020202072783A20330A20207D2C2062426F7829293B0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E636C';
wwv_flow_imp.g_varchar2_table(4362) := '6173736573292872656374292E6164642827646A732D73656C656374696F6E2D6F75746C696E6527293B0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E617070656E6429286C61796572';
wwv_flow_imp.g_varchar2_table(4363) := '2C2072656374293B0A7D3B0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F0A0A66756E6374696F6E2061646453656C656374696F6E4F75746C696E6550616464696E672862426F7829207B0A202072657475726E207B0A20202020783A206242';
wwv_flow_imp.g_varchar2_table(4364) := '6F782E78202D2053454C454354494F4E5F4F55544C494E455F50414444494E472C0A20202020793A2062426F782E79202D2053454C454354494F4E5F4F55544C494E455F50414444494E472C0A2020202077696474683A2062426F782E7769647468202B';
wwv_flow_imp.g_varchar2_table(4365) := '2053454C454354494F4E5F4F55544C494E455F50414444494E47202A20322C0A202020206865696768743A2062426F782E686569676874202B2053454C454354494F4E5F4F55544C494E455F50414444494E47202A20320A20207D3B0A7D0A0A2F2A2A2A';
wwv_flow_imp.g_varchar2_table(4366) := '2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E2F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4367) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F';
wwv_flow_imp.g_varchar2_table(4368) := '6E2F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E7573';
wwv_flow_imp.g_varchar2_table(4369) := '65645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F65';
wwv_flow_imp.g_varchar2_table(4370) := '78706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020';
wwv_flow_imp.g_varchar2_table(4371) := '2264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F696E74';
wwv_flow_imp.g_varchar2_table(4372) := '6572616374696F6E5F6576656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F696E746572616374696F6E2D6576656E7473202A2F20222E2F6E';
wwv_flow_imp.g_varchar2_table(4373) := '6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F696E746572616374696F6E2D6576656E74732F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F6F75746C696E65';
wwv_flow_imp.g_varchar2_table(4374) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F6F75746C696E65202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C6962';
wwv_flow_imp.g_varchar2_table(4375) := '2F66656174757265732F6F75746C696E652F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F53656C656374696F6E5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F77';
wwv_flow_imp.g_varchar2_table(4376) := '65627061636B5F726571756972655F5F282F2A21202E2F53656C656374696F6E202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E2F53656C656374696F6E2E6A732229';
wwv_flow_imp.g_varchar2_table(4377) := '3B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F53656C656374696F6E56697375616C735F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A2120';
wwv_flow_imp.g_varchar2_table(4378) := '2E2F53656C656374696F6E56697375616C73202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E2F53656C656374696F6E56697375616C732E6A7322293B0A2F2A206861';
wwv_flow_imp.g_varchar2_table(4379) := '726D6F6E7920696D706F7274202A2F20766172205F53656C656374696F6E4265686176696F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F53656C65';
wwv_flow_imp.g_varchar2_table(4380) := '6374696F6E4265686176696F72202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E2F53656C656374696F6E4265686176696F722E6A7322293B0A0A0A0A0A0A0A0A0A2F';
wwv_flow_imp.g_varchar2_table(4381) := '2A2A0A202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F4445';
wwv_flow_imp.g_varchar2_table(4382) := '4641554C545F4558504F52545F5F203D20287B0A20205F5F696E69745F5F3A205B202773656C656374696F6E56697375616C73272C202773656C656374696F6E4265686176696F7227205D2C0A20205F5F646570656E64735F5F3A205B0A202020205F69';
wwv_flow_imp.g_varchar2_table(4383) := '6E746572616374696F6E5F6576656E74735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D2C0A202020205F6F75746C696E655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F';
wwv_flow_imp.g_varchar2_table(4384) := '5B2264656661756C74225D0A20205D2C0A202073656C656374696F6E3A205B202774797065272C205F53656C656374696F6E5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F5B2264656661756C74225D205D2C0A202073656C65';
wwv_flow_imp.g_varchar2_table(4385) := '6374696F6E56697375616C733A205B202774797065272C205F53656C656374696F6E56697375616C735F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F5B2264656661756C74225D205D2C0A202073656C656374696F6E42656861';
wwv_flow_imp.g_varchar2_table(4386) := '76696F723A205B202774797065272C205F53656C656374696F6E4265686176696F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F5B2264656661756C74225D205D0A7D293B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20';
wwv_flow_imp.g_varchar2_table(4387) := '222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6931386E2F7472616E736C6174652F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4388) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6931386E2F7472616E736C6174652F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4389) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F';
wwv_flow_imp.g_varchar2_table(4390) := '6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F727420';
wwv_flow_imp.g_varchar2_table(4391) := '2A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44';
wwv_flow_imp.g_varchar2_table(4392) := '454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7472616E736C6174655F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(4393) := '4C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F7472616E736C617465202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6931386E2F7472616E736C6174652F7472616E736C';
wwv_flow_imp.g_varchar2_table(4394) := '6174652E6A7322293B0A0A0A0A2F2A2A0A202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E73';
wwv_flow_imp.g_varchar2_table(4395) := '74205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20207472616E736C6174653A205B202776616C7565272C205F7472616E736C6174655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264';
wwv_flow_imp.g_varchar2_table(4396) := '656661756C74225D205D0A7D293B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6931386E2F7472616E736C6174652F7472616E736C6174652E6A73223A0A2F2A212A2A2A';
wwv_flow_imp.g_varchar2_table(4397) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C';
wwv_flow_imp.g_varchar2_table(4398) := '69622F6931386E2F7472616E736C6174652F7472616E736C6174652E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4399) := '2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571';
wwv_flow_imp.g_varchar2_table(4400) := '756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A20';
wwv_flow_imp.g_varchar2_table(4401) := '6861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F207472616E736C617465290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2A0A202A204074797065';
wwv_flow_imp.g_varchar2_table(4402) := '646566207B207B0A202A2020205B6B65793A20737472696E675D3A20737472696E673B0A202A207D207D205472616E736C6174655265706C6163656D656E74730A202A2F0A0A2F2A2A0A202A20412073696D706C65207472616E736C6174696F6E207374';
wwv_flow_imp.g_varchar2_table(4403) := '756220746F206265207573656420666F72206D756C74692D6C616E677561676520737570706F72740A202A20696E206469616772616D732E2043616E20626520656173696C79207265706C6163656420776974682061206D6F726520736F706869737469';
wwv_flow_imp.g_varchar2_table(4404) := '63617465640A202A20736F6C7574696F6E2E0A202A0A202A20406578616D706C650A202A0A202A206060606A6176617363726970740A202A202F2F2075736520697420696E7369646520616E79206469616772616D20636F6D706F6E656E742062792069';
wwv_flow_imp.g_varchar2_table(4405) := '6E6A656374696E6720607472616E736C617465602E0A202A0A202A2066756E6374696F6E204D7953657276696365287472616E736C61746529207B0A202A202020616C657274287472616E736C617465282748454C4C4F207B796F757D272C207B20796F';
wwv_flow_imp.g_varchar2_table(4406) := '753A2027596F752127207D29293B0A202A207D0A202A206060600A202A0A202A2040706172616D207B737472696E677D2074656D706C61746520746F20696E746572706F6C6174650A202A2040706172616D207B5472616E736C6174655265706C616365';
wwv_flow_imp.g_varchar2_table(4407) := '6D656E74737D205B7265706C6163656D656E74735D2061206D617020776974682073756273746974757465730A202A0A202A204072657475726E207B737472696E677D20746865207472616E736C6174656420737472696E670A202A2F0A66756E637469';
wwv_flow_imp.g_varchar2_table(4408) := '6F6E207472616E736C6174652874656D706C6174652C207265706C6163656D656E747329207B0A0A20207265706C6163656D656E7473203D207265706C6163656D656E7473207C7C207B7D3B0A0A202072657475726E2074656D706C6174652E7265706C';
wwv_flow_imp.g_varchar2_table(4409) := '616365282F7B285B5E7D5D2B297D2F672C2066756E6374696F6E285F2C206B657929207B0A2020202072657475726E207265706C6163656D656E74735B6B65795D207C7C20277B27202B206B6579202B20277D273B0A20207D293B0A7D0A0A2F2A2A2A2F';
wwv_flow_imp.g_varchar2_table(4410) := '207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6C61796F75742F4C61796F75745574696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4411) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6C61796F75742F4C61796F75745574696C2E6A73202A2A2A210A20205C2A2A2A';
wwv_flow_imp.g_varchar2_table(4412) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F';
wwv_flow_imp.g_varchar2_table(4413) := '6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F727420';
wwv_flow_imp.g_varchar2_table(4414) := '2A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020206173426F756E64733A202829203D3E20282F2A2062696E64696E67202A';
wwv_flow_imp.g_varchar2_table(4415) := '2F206173426F756E6473292C0A2F2A206861726D6F6E79206578706F7274202A2F20202061735452424C3A202829203D3E20282F2A2062696E64696E67202A2F2061735452424C292C0A2F2A206861726D6F6E79206578706F7274202A2F20202066696C';
wwv_flow_imp.g_varchar2_table(4416) := '746572526564756E64616E74576179706F696E74733A202829203D3E20282F2A2062696E64696E67202A2F2066696C746572526564756E64616E74576179706F696E7473292C0A2F2A206861726D6F6E79206578706F7274202A2F202020676574426F75';
wwv_flow_imp.g_varchar2_table(4417) := '6E64734D69643A202829203D3E20282F2A2062696E64696E67202A2F20676574426F756E64734D6964292C0A2F2A206861726D6F6E79206578706F7274202A2F202020676574436F6E6E656374696F6E4D69643A202829203D3E20282F2A2062696E6469';
wwv_flow_imp.g_varchar2_table(4418) := '6E67202A2F20676574436F6E6E656374696F6E4D6964292C0A2F2A206861726D6F6E79206578706F7274202A2F202020676574456C656D656E744C696E65496E74657273656374696F6E3A202829203D3E20282F2A2062696E64696E67202A2F20676574';
wwv_flow_imp.g_varchar2_table(4419) := '456C656D656E744C696E65496E74657273656374696F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F202020676574496E74657273656374696F6E733A202829203D3E20282F2A2062696E64696E67202A2F20676574496E74657273656374';
wwv_flow_imp.g_varchar2_table(4420) := '696F6E73292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206765744D69643A202829203D3E20282F2A2062696E64696E67202A2F206765744D6964292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206765744F7269656E74';
wwv_flow_imp.g_varchar2_table(4421) := '6174696F6E3A202829203D3E20282F2A2062696E64696E67202A2F206765744F7269656E746174696F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F202020726F756E64426F756E64733A202829203D3E20282F2A2062696E64696E67202A';
wwv_flow_imp.g_varchar2_table(4422) := '2F20726F756E64426F756E6473292C0A2F2A206861726D6F6E79206578706F7274202A2F202020726F756E64506F696E743A202829203D3E20282F2A2062696E64696E67202A2F20726F756E64506F696E74290A2F2A206861726D6F6E79206578706F72';
wwv_flow_imp.g_varchar2_table(4423) := '74202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D69';
wwv_flow_imp.g_varchar2_table(4424) := '6E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F47656F6D657472795F5F574542';
wwv_flow_imp.g_varchar2_table(4425) := '5041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F47656F6D65747279202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69';
wwv_flow_imp.g_varchar2_table(4426) := '622F7574696C2F47656F6D657472792E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076617220706174685F696E74657273656374696F6E5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765';
wwv_flow_imp.g_varchar2_table(4427) := '627061636B5F726571756972655F5F282F2A2120706174682D696E74657273656374696F6E202A2F20222E2F6E6F64655F6D6F64756C65732F706174682D696E74657273656374696F6E2F696E746572736563742E6A7322293B0A2F2A206861726D6F6E';
wwv_flow_imp.g_varchar2_table(4428) := '7920696D706F7274202A2F20766172205F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F7574696C2F4D6F64656C';
wwv_flow_imp.g_varchar2_table(4429) := '5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A7322293B0A0A0A0A0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F636F7265';
wwv_flow_imp.g_varchar2_table(4430) := '2F547970657327292E456C656D656E744C696B657D20456C656D656E740A202A204074797065646566207B696D706F727428272E2E2F636F72652F547970657327292E436F6E6E656374696F6E4C696B657D20436F6E6E656374696F6E0A202A0A202A20';
wwv_flow_imp.g_varchar2_table(4431) := '4074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E446972656374696F6E5452424C7D20446972656374696F6E5452424C0A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E';
wwv_flow_imp.g_varchar2_table(4432) := '496E74657273656374696F6E7D20496E74657273656374696F6E0A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F696E740A202A204074797065646566207B696D706F727428272E2E';
wwv_flow_imp.g_varchar2_table(4433) := '2F7574696C2F547970657327292E526563747D20526563740A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E526563745452424C7D20526563745452424C0A202A2F0A0A2F2A2A0A202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(4434) := '7B526563747D20626F756E64730A202A0A202A204072657475726E73207B526563747D0A202A2F0A66756E6374696F6E20726F756E64426F756E647328626F756E647329207B0A202072657475726E207B0A20202020783A204D6174682E726F756E6428';
wwv_flow_imp.g_varchar2_table(4435) := '626F756E64732E78292C0A20202020793A204D6174682E726F756E6428626F756E64732E79292C0A2020202077696474683A204D6174682E726F756E6428626F756E64732E7769647468292C0A202020206865696768743A204D6174682E726F756E6428';
wwv_flow_imp.g_varchar2_table(4436) := '626F756E64732E686569676874290A20207D3B0A7D0A0A2F2A2A0A202A2040706172616D207B506F696E747D20706F696E740A202A0A202A204072657475726E73207B506F696E747D0A202A2F0A66756E6374696F6E20726F756E64506F696E7428706F';
wwv_flow_imp.g_varchar2_table(4437) := '696E7429207B0A0A202072657475726E207B0A20202020783A204D6174682E726F756E6428706F696E742E78292C0A20202020793A204D6174682E726F756E6428706F696E742E79290A20207D3B0A7D0A0A0A2F2A2A0A202A20436F6E76657274207468';
wwv_flow_imp.g_varchar2_table(4438) := '6520676976656E20626F756E647320746F2061207B20746F702C206C6566742C20626F74746F6D2C207269676874207D2064657363726970746F722E0A202A0A202A2040706172616D207B506F696E747C526563747D20626F756E64730A202A0A202A20';
wwv_flow_imp.g_varchar2_table(4439) := '4072657475726E207B526563745452424C7D0A202A2F0A66756E6374696F6E2061735452424C28626F756E647329207B0A202072657475726E207B0A20202020746F703A20626F756E64732E792C0A2020202072696768743A20626F756E64732E78202B';
wwv_flow_imp.g_varchar2_table(4440) := '2028626F756E64732E7769647468207C7C2030292C0A20202020626F74746F6D3A20626F756E64732E79202B2028626F756E64732E686569676874207C7C2030292C0A202020206C6566743A20626F756E64732E780A20207D3B0A7D0A0A0A2F2A2A0A20';
wwv_flow_imp.g_varchar2_table(4441) := '2A20436F6E766572742061207B20746F702C206C6566742C20626F74746F6D2C207269676874207D20746F20616E206F626A6563747320626F756E64732E0A202A0A202A2040706172616D207B526563745452424C7D207472626C0A202A0A202A204072';
wwv_flow_imp.g_varchar2_table(4442) := '657475726E207B526563747D0A202A2F0A66756E6374696F6E206173426F756E6473287472626C29207B0A202072657475726E207B0A20202020783A207472626C2E6C6566742C0A20202020793A207472626C2E746F702C0A2020202077696474683A20';
wwv_flow_imp.g_varchar2_table(4443) := '7472626C2E7269676874202D207472626C2E6C6566742C0A202020206865696768743A207472626C2E626F74746F6D202D207472626C2E746F700A20207D3B0A7D0A0A0A2F2A2A0A202A2047657420746865206D6964206F662074686520676976656E20';
wwv_flow_imp.g_varchar2_table(4444) := '626F756E6473206F7220706F696E742E0A202A0A202A2040706172616D207B506F696E747C526563747D20626F756E64730A202A0A202A204072657475726E207B506F696E747D0A202A2F0A66756E6374696F6E20676574426F756E64734D696428626F';
wwv_flow_imp.g_varchar2_table(4445) := '756E647329207B0A202072657475726E20726F756E64506F696E74287B0A20202020783A20626F756E64732E78202B2028626F756E64732E7769647468207C7C203029202F20322C0A20202020793A20626F756E64732E79202B2028626F756E64732E68';
wwv_flow_imp.g_varchar2_table(4446) := '6569676874207C7C203029202F20320A20207D293B0A7D0A0A0A2F2A2A0A202A2047657420746865206D6964206F662074686520676976656E20436F6E6E656374696F6E2E0A202A0A202A2040706172616D207B436F6E6E656374696F6E7D20636F6E6E';
wwv_flow_imp.g_varchar2_table(4447) := '656374696F6E0A202A0A202A204072657475726E207B506F696E747D0A202A2F0A66756E6374696F6E20676574436F6E6E656374696F6E4D696428636F6E6E656374696F6E29207B0A202076617220776179706F696E7473203D20636F6E6E656374696F';
wwv_flow_imp.g_varchar2_table(4448) := '6E2E776179706F696E74733B0A0A20202F2F2063616C63756C61746520746F74616C206C656E67746820616E64206C656E677468206F662065616368207365676D656E740A2020766172207061727473203D20776179706F696E74732E72656475636528';
wwv_flow_imp.g_varchar2_table(4449) := '66756E6374696F6E2870617274732C20706F696E742C20696E64657829207B0A0A20202020766172206C617374506F696E74203D20776179706F696E74735B696E646578202D20315D3B0A0A20202020696620286C617374506F696E7429207B0A202020';
wwv_flow_imp.g_varchar2_table(4450) := '202020766172206C61737450617274203D2070617274735B70617274732E6C656E677468202D20315D3B0A0A2020202020207661722073746172744C656E677468203D206C61737450617274202626206C617374506172742E656E644C656E677468207C';
wwv_flow_imp.g_varchar2_table(4451) := '7C20303B0A202020202020766172206C656E677468203D2064697374616E6365286C617374506F696E742C20706F696E74293B0A0A20202020202070617274732E70757368287B0A202020202020202073746172743A206C617374506F696E742C0A2020';
wwv_flow_imp.g_varchar2_table(4452) := '202020202020656E643A20706F696E742C0A202020202020202073746172744C656E6774683A2073746172744C656E6774682C0A2020202020202020656E644C656E6774683A2073746172744C656E677468202B206C656E6774682C0A20202020202020';
wwv_flow_imp.g_varchar2_table(4453) := '206C656E6774683A206C656E6774680A2020202020207D293B0A202020207D0A0A2020202072657475726E2070617274733B0A20207D2C205B5D293B0A0A202076617220746F74616C4C656E677468203D2070617274732E7265647563652866756E6374';
wwv_flow_imp.g_varchar2_table(4454) := '696F6E286C656E6774682C207061727429207B0A2020202072657475726E206C656E677468202B20706172742E6C656E6774683B0A20207D2C2030293B0A0A20202F2F2066696E6420776869636820736567656D656E7420636F6E7461696E73206D6964';
wwv_flow_imp.g_varchar2_table(4455) := '646C6520706F696E740A2020766172206D69644C656E677468203D20746F74616C4C656E677468202F20323B0A0A20207661722069203D20303B0A2020766172206D69645365676D656E74203D2070617274735B695D3B0A0A20207768696C6520286D69';
wwv_flow_imp.g_varchar2_table(4456) := '645365676D656E742E656E644C656E677468203C206D69644C656E67746829207B0A202020206D69645365676D656E74203D2070617274735B2B2B695D3B0A20207D0A0A20202F2F2063616C63756C6174652072656C617469766520706F736974696F6E';
wwv_flow_imp.g_varchar2_table(4457) := '206F6E206D6964207365676D656E740A2020766172207365676D656E7450726F6772657373203D20286D69644C656E677468202D206D69645365676D656E742E73746172744C656E67746829202F206D69645365676D656E742E6C656E6774683B0A0A20';
wwv_flow_imp.g_varchar2_table(4458) := '20766172206D6964506F696E74203D207B0A20202020783A206D69645365676D656E742E73746172742E78202B20286D69645365676D656E742E656E642E78202D206D69645365676D656E742E73746172742E7829202A207365676D656E7450726F6772';
wwv_flow_imp.g_varchar2_table(4459) := '6573732C0A20202020793A206D69645365676D656E742E73746172742E79202B20286D69645365676D656E742E656E642E79202D206D69645365676D656E742E73746172742E7929202A207365676D656E7450726F67726573730A20207D3B0A0A202072';
wwv_flow_imp.g_varchar2_table(4460) := '657475726E206D6964506F696E743B0A7D0A0A0A2F2A2A0A202A2047657420746865206D6964206F662074686520676976656E20456C656D656E742E0A202A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072';
wwv_flow_imp.g_varchar2_table(4461) := '657475726E207B506F696E747D0A202A2F0A66756E6374696F6E206765744D696428656C656D656E7429207B0A20206966202828302C5F7574696C5F4D6F64656C5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E69';
wwv_flow_imp.g_varchar2_table(4462) := '73436F6E6E656374696F6E2928656C656D656E742929207B0A2020202072657475726E20676574436F6E6E656374696F6E4D696428656C656D656E74293B0A20207D0A0A202072657475726E20676574426F756E64734D696428656C656D656E74293B0A';
wwv_flow_imp.g_varchar2_table(4463) := '7D0A0A2F2F206F7269656E746174696F6E207574696C73202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A2F2A2A0A202A20476574206F7269656E746174696F6E206F662074686520676976656E2072656374616E676C6520776974682072';
wwv_flow_imp.g_varchar2_table(4464) := '65737065637420746F0A202A20746865207265666572656E63652072656374616E676C652E0A202A0A202A20412070616464696E672028706F736974697665206F72206E6567617469766529206D61792062652070617373656420746F20696E666C7565';
wwv_flow_imp.g_varchar2_table(4465) := '6E63650A202A20686F72697A6F6E74616C202F20766572746963616C206F7269656E746174696F6E20616E6420696E74657273656374696F6E2E0A202A0A202A2040706172616D207B526563747D20726563740A202A2040706172616D207B526563747D';
wwv_flow_imp.g_varchar2_table(4466) := '207265666572656E63650A202A2040706172616D207B506F696E747C6E756D6265727D2070616464696E670A202A0A202A204072657475726E207B446972656374696F6E5452424C7C496E74657273656374696F6E7D20746865206F7269656E74617469';
wwv_flow_imp.g_varchar2_table(4467) := '6F6E3B206F6E65206F6620746F702C20746F702D6C6566742C206C6566742C202E2E2E2C20626F74746F6D2C207269676874206F7220696E746572736563742E0A202A2F0A66756E6374696F6E206765744F7269656E746174696F6E28726563742C2072';
wwv_flow_imp.g_varchar2_table(4468) := '65666572656E63652C2070616464696E6729207B0A0A202070616464696E67203D2070616464696E67207C7C20303B0A0A20202F2F206D616B6520737572652077652063616E2075736520616E206F626A6563742C20746F6F0A20202F2F20666F722069';
wwv_flow_imp.g_varchar2_table(4469) := '6E646976696475616C207B20782C2079207D2070616464696E670A2020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E69734F626A656374292870616464696E672929207B0A202020';
wwv_flow_imp.g_varchar2_table(4470) := '2070616464696E67203D207B20783A2070616464696E672C20793A2070616464696E67207D3B0A20207D0A0A0A202076617220726563744F7269656E746174696F6E203D2061735452424C2872656374292C0A2020202020207265666572656E63654F72';
wwv_flow_imp.g_varchar2_table(4471) := '69656E746174696F6E203D2061735452424C287265666572656E6365293B0A0A202076617220746F70203D20726563744F7269656E746174696F6E2E626F74746F6D202B2070616464696E672E79203C3D207265666572656E63654F7269656E74617469';
wwv_flow_imp.g_varchar2_table(4472) := '6F6E2E746F702C0A2020202020207269676874203D20726563744F7269656E746174696F6E2E6C656674202D2070616464696E672E78203E3D207265666572656E63654F7269656E746174696F6E2E72696768742C0A202020202020626F74746F6D203D';
wwv_flow_imp.g_varchar2_table(4473) := '20726563744F7269656E746174696F6E2E746F70202D2070616464696E672E79203E3D207265666572656E63654F7269656E746174696F6E2E626F74746F6D2C0A2020202020206C656674203D20726563744F7269656E746174696F6E2E726967687420';
wwv_flow_imp.g_varchar2_table(4474) := '2B2070616464696E672E78203C3D207265666572656E63654F7269656E746174696F6E2E6C6566743B0A0A202076617220766572746963616C203D20746F70203F2027746F7027203A2028626F74746F6D203F2027626F74746F6D27203A206E756C6C29';
wwv_flow_imp.g_varchar2_table(4475) := '2C0A202020202020686F72697A6F6E74616C203D206C656674203F20276C65667427203A20287269676874203F2027726967687427203A206E756C6C293B0A0A202069662028686F72697A6F6E74616C20262620766572746963616C29207B0A20202020';
wwv_flow_imp.g_varchar2_table(4476) := '72657475726E20766572746963616C202B20272D27202B20686F72697A6F6E74616C3B0A20207D20656C7365207B0A2020202072657475726E20686F72697A6F6E74616C207C7C20766572746963616C207C7C2027696E74657273656374273B0A20207D';
wwv_flow_imp.g_varchar2_table(4477) := '0A7D0A0A0A2F2F20696E74657273656374696F6E207574696C73202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A2F2A2A0A202A2047657420696E74657273656374696F6E206265747765656E20616E20656C656D656E7420616E64206120';
wwv_flow_imp.g_varchar2_table(4478) := '6C696E6520706174682E0A202A0A202A2040706172616D207B737472696E677D20656C656D656E74506174680A202A2040706172616D207B737472696E677D206C696E65506174680A202A2040706172616D207B626F6F6C65616E7D2063726F70537461';
wwv_flow_imp.g_varchar2_table(4479) := '7274205768657468657220746F2063726F70207374617274206F7220656E642E0A202A0A202A204072657475726E207B506F696E747D0A202A2F0A66756E6374696F6E20676574456C656D656E744C696E65496E74657273656374696F6E28656C656D65';
wwv_flow_imp.g_varchar2_table(4480) := '6E74506174682C206C696E65506174682C2063726F70537461727429207B0A0A202076617220696E74657273656374696F6E73203D20676574496E74657273656374696F6E7328656C656D656E74506174682C206C696E6550617468293B0A0A20202F2F';
wwv_flow_imp.g_varchar2_table(4481) := '207265636F676E697A6520696E74657273656374696F6E730A20202F2F206F6E6C79206F6E65202D3E2063686F6F73650A20202F2F2074776F20636C6F736520746F676574686572202D3E2063686F6F73652066697273740A20202F2F2074776F206F72';
wwv_flow_imp.g_varchar2_table(4482) := '206D6F72652064697374696E6374202D3E2070756C6C206F757420617070726F707269617465206F6E650A20202F2F206E6F6E65202D3E206F6B202866616C6C6261636B20746F20706F696E7420697473656C66290A202069662028696E746572736563';
wwv_flow_imp.g_varchar2_table(4483) := '74696F6E732E6C656E677468203D3D3D203129207B0A2020202072657475726E20726F756E64506F696E7428696E74657273656374696F6E735B305D293B0A20207D20656C73652069662028696E74657273656374696F6E732E6C656E677468203D3D3D';
wwv_flow_imp.g_varchar2_table(4484) := '20322026262028302C5F7574696C5F47656F6D657472795F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E706F696E7444697374616E63652928696E74657273656374696F6E735B305D2C20696E74657273656374696F6E735B';
wwv_flow_imp.g_varchar2_table(4485) := '315D29203C203129207B0A2020202072657475726E20726F756E64506F696E7428696E74657273656374696F6E735B305D293B0A20207D20656C73652069662028696E74657273656374696F6E732E6C656E677468203E203129207B0A0A202020202F2F';
wwv_flow_imp.g_varchar2_table(4486) := '20736F727420627920696E74657273656374696F6E73206261736564206F6E20636F6E6E656374696F6E207365676D656E74202B0A202020202F2F2064697374616E63652066726F6D2073746172740A20202020696E74657273656374696F6E73203D20';
wwv_flow_imp.g_varchar2_table(4487) := '28302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E736F727442792928696E74657273656374696F6E732C2066756E6374696F6E286929207B0A2020202020207661722064697374616E6365203D204D';
wwv_flow_imp.g_varchar2_table(4488) := '6174682E666C6F6F7228692E7432202A2031303029207C7C20313B0A0A20202020202064697374616E6365203D20313030202D2064697374616E63653B0A0A20202020202064697374616E6365203D202864697374616E6365203C203130203F20273027';
wwv_flow_imp.g_varchar2_table(4489) := '203A20272729202B2064697374616E63653B0A0A2020202020202F2F20637265617465206120736F727420737472696E672074686174206D616B6573207375726520776520736F72740A2020202020202F2F206C696E65207365676D656E742041534320';
wwv_flow_imp.g_varchar2_table(4490) := '2B206C696E65207365676D656E7420706F736974696F6E20444553432028666F722063726F705374617274290A2020202020202F2F206C696E65207365676D656E7420415343202B206C696E65207365676D656E7420706F736974696F6E204153432028';
wwv_flow_imp.g_varchar2_table(4491) := '666F722063726F70456E64290A20202020202072657475726E20692E7365676D656E7432202B20272327202B2064697374616E63653B0A202020207D293B0A0A2020202072657475726E20726F756E64506F696E7428696E74657273656374696F6E735B';
wwv_flow_imp.g_varchar2_table(4492) := '63726F705374617274203F2030203A20696E74657273656374696F6E732E6C656E677468202D20315D293B0A20207D0A0A202072657475726E206E756C6C3B0A7D0A0A0A66756E6374696F6E20676574496E74657273656374696F6E7328612C20622920';
wwv_flow_imp.g_varchar2_table(4493) := '7B0A202072657475726E2028302C706174685F696E74657273656374696F6E5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D2928612C2062293B0A7D0A0A0A66756E6374696F6E2066696C74657252';
wwv_flow_imp.g_varchar2_table(4494) := '6564756E64616E74576179706F696E747328776179706F696E747329207B0A0A20202F2F20616C74657220636F7079206F6620776179706F696E74732C206E6F74206F726967696E616C0A2020776179706F696E7473203D20776179706F696E74732E73';
wwv_flow_imp.g_varchar2_table(4495) := '6C69636528293B0A0A202076617220696478203D20302C0A202020202020706F696E742C0A20202020202070726576696F7573506F696E742C0A2020202020206E657874506F696E743B0A0A20207768696C652028776179706F696E74735B6964785D29';
wwv_flow_imp.g_varchar2_table(4496) := '207B0A20202020706F696E74203D20776179706F696E74735B6964785D3B0A2020202070726576696F7573506F696E74203D20776179706F696E74735B696478202D20315D3B0A202020206E657874506F696E74203D20776179706F696E74735B696478';
wwv_flow_imp.g_varchar2_table(4497) := '202B20315D3B0A0A202020206966202828302C5F7574696C5F47656F6D657472795F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E706F696E7444697374616E63652928706F696E742C206E657874506F696E7429203D3D3D20';
wwv_flow_imp.g_varchar2_table(4498) := '30207C7C0A202020202020202028302C5F7574696C5F47656F6D657472795F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E706F696E74734F6E4C696E65292870726576696F7573506F696E742C206E657874506F696E742C20';
wwv_flow_imp.g_varchar2_table(4499) := '706F696E742929207B0A0A2020202020202F2F2072656D6F766520706F696E742C206966206F7665726C617070696E672077697468207B6E657874506F696E747D0A2020202020202F2F206F72206F6E206C696E652077697468207B70726576696F7573';
wwv_flow_imp.g_varchar2_table(4500) := '506F696E747D202D3E207B706F696E747D202D3E207B6E657874506F696E747D0A202020202020776179706F696E74732E73706C696365286964782C2031293B0A202020207D20656C7365207B0A2020202020206964782B2B3B0A202020207D0A20207D';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(4501) := '0A0A202072657475726E20776179706F696E74733B0A7D0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A66756E6374696F6E2064697374616E636528612C206229207B0A202072657475726E204D6174682E';
wwv_flow_imp.g_varchar2_table(4502) := '73717274284D6174682E706F7728612E78202D20622E782C203229202B204D6174682E706F7728612E79202D20622E792C203229293B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A';
wwv_flow_imp.g_varchar2_table(4503) := '732F6C69622F6D6F64656C2F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F6475';
wwv_flow_imp.g_varchar2_table(4504) := '6C65732F6469616772616D2D6A732F6C69622F6D6F64656C2F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A';
wwv_flow_imp.g_varchar2_table(4505) := '2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F';
wwv_flow_imp.g_varchar2_table(4506) := '5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578';
wwv_flow_imp.g_varchar2_table(4507) := '706F7274202A2F2020206372656174653A202829203D3E20282F2A2062696E64696E67202A2F20637265617465292C0A2F2A206861726D6F6E79206578706F7274202A2F20202069734D6F64656C456C656D656E743A202829203D3E20282F2A2062696E';
wwv_flow_imp.g_varchar2_table(4508) := '64696E67202A2F2069734D6F64656C456C656D656E74290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(4509) := '5F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A2068';
wwv_flow_imp.g_varchar2_table(4510) := '61726D6F6E7920696D706F7274202A2F2076617220696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A2120696E6865726974';
wwv_flow_imp.g_varchar2_table(4511) := '732D62726F77736572202A2F20222E2F6E6F64655F6D6F64756C65732F696E6865726974732D62726F777365722F646973742F696E6465782E65732E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206F626A6563745F7265';
wwv_flow_imp.g_varchar2_table(4512) := '66735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206F626A6563742D72656673202A2F20222E2F6E6F64655F6D6F64756C65732F6F626A6563742D72656673';
wwv_flow_imp.g_varchar2_table(4513) := '2F646973742F696E6465782E6A7322293B0A0A0A0A0A0A76617220706172656E7452656673203D206E6577206F626A6563745F726566735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E52656673287B206E616D653A202763';
wwv_flow_imp.g_varchar2_table(4514) := '68696C6472656E272C20656E756D657261626C653A20747275652C20636F6C6C656374696F6E3A2074727565207D2C207B206E616D653A2027706172656E7427207D292C0A202020206C6162656C52656673203D206E6577206F626A6563745F72656673';
wwv_flow_imp.g_varchar2_table(4515) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E52656673287B206E616D653A20276C6162656C73272C20656E756D657261626C653A20747275652C20636F6C6C656374696F6E3A2074727565207D2C207B206E616D653A2027';
wwv_flow_imp.g_varchar2_table(4516) := '6C6162656C54617267657427207D292C0A20202020617474616368657252656673203D206E6577206F626A6563745F726566735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E52656673287B206E616D653A20276174746163';
wwv_flow_imp.g_varchar2_table(4517) := '68657273272C20636F6C6C656374696F6E3A2074727565207D2C207B206E616D653A2027686F737427207D292C0A202020206F7574676F696E6752656673203D206E6577206F626A6563745F726566735F5F5745425041434B5F494D504F525445445F4D';
wwv_flow_imp.g_varchar2_table(4518) := '4F44554C455F305F5F2E52656673287B206E616D653A20276F7574676F696E67272C20636F6C6C656374696F6E3A2074727565207D2C207B206E616D653A2027736F7572636527207D292C0A20202020696E636F6D696E6752656673203D206E6577206F';
wwv_flow_imp.g_varchar2_table(4519) := '626A6563745F726566735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E52656673287B206E616D653A2027696E636F6D696E67272C20636F6C6C656374696F6E3A2074727565207D2C207B206E616D653A2027746172676574';
wwv_flow_imp.g_varchar2_table(4520) := '27207D293B0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2F547970657327292E456C656D656E747D20456C656D656E740A202A204074797065646566207B696D706F727428272E2F547970657327292E53686170657D20536861';
wwv_flow_imp.g_varchar2_table(4521) := '70650A202A204074797065646566207B696D706F727428272E2F547970657327292E526F6F747D20526F6F740A202A204074797065646566207B696D706F727428272E2F547970657327292E4C6162656C7D204C6162656C0A202A204074797065646566';
wwv_flow_imp.g_varchar2_table(4522) := '207B696D706F727428272E2F547970657327292E436F6E6E656374696F6E7D20436F6E6E656374696F6E0A202A2F0A0A2F2A2A0A202A205468652062617369632067726170686963616C20726570726573656E746174696F6E0A202A0A202A2040636C61';
wwv_flow_imp.g_varchar2_table(4523) := '73730A202A2040636F6E7374727563746F720A202A2F0A66756E6374696F6E20456C656D656E74496D706C2829207B0A0A20202F2A2A0A2020202A20546865206F626A6563742074686174206261636B73207570207468652073686170650A2020202A0A';
wwv_flow_imp.g_varchar2_table(4524) := '2020202A20406E616D6520456C656D656E7423627573696E6573734F626A6563740A2020202A204074797065204F626A6563740A2020202A2F0A20204F626A6563742E646566696E6550726F706572747928746869732C2027627573696E6573734F626A';
wwv_flow_imp.g_varchar2_table(4525) := '656374272C207B0A202020207772697461626C653A20747275650A20207D293B0A0A0A20202F2A2A0A2020202A2053696E676C65206C6162656C20737570706F72742C2077696C6C206D617070656420746F206D756C7469206C6162656C206172726179';
wwv_flow_imp.g_varchar2_table(4526) := '0A2020202A0A2020202A20406E616D6520456C656D656E74236C6162656C0A2020202A204074797065204F626A6563740A2020202A2F0A20204F626A6563742E646566696E6550726F706572747928746869732C20276C6162656C272C207B0A20202020';
wwv_flow_imp.g_varchar2_table(4527) := '6765743A2066756E6374696F6E2829207B0A20202020202072657475726E20746869732E6C6162656C735B305D3B0A202020207D2C0A202020207365743A2066756E6374696F6E286E65774C6162656C29207B0A0A202020202020766172206C6162656C';
wwv_flow_imp.g_varchar2_table(4528) := '203D20746869732E6C6162656C2C0A202020202020202020206C6162656C73203D20746869732E6C6162656C733B0A0A20202020202069662028216E65774C6162656C202626206C6162656C29207B0A20202020202020206C6162656C732E72656D6F76';
wwv_flow_imp.g_varchar2_table(4529) := '65286C6162656C293B0A2020202020207D20656C7365207B0A20202020202020206C6162656C732E616464286E65774C6162656C2C2030293B0A2020202020207D0A202020207D0A20207D293B0A0A20202F2A2A0A2020202A2054686520706172656E74';
wwv_flow_imp.g_varchar2_table(4530) := '2073686170650A2020202A0A2020202A20406E616D6520456C656D656E7423706172656E740A2020202A2040747970652053686170650A2020202A2F0A2020706172656E74526566732E62696E6428746869732C2027706172656E7427293B0A0A20202F';
wwv_flow_imp.g_varchar2_table(4531) := '2A2A0A2020202A20546865206C697374206F66206C6162656C730A2020202A0A2020202A20406E616D6520456C656D656E74236C6162656C730A2020202A204074797065204C6162656C0A2020202A2F0A20206C6162656C526566732E62696E64287468';
wwv_flow_imp.g_varchar2_table(4532) := '69732C20276C6162656C7327293B0A0A20202F2A2A0A2020202A20546865206C697374206F66206F7574676F696E6720636F6E6E656374696F6E730A2020202A0A2020202A20406E616D6520456C656D656E74236F7574676F696E670A2020202A204074';
wwv_flow_imp.g_varchar2_table(4533) := '7970652041727261793C436F6E6E656374696F6E3E0A2020202A2F0A20206F7574676F696E67526566732E62696E6428746869732C20276F7574676F696E6727293B0A0A20202F2A2A0A2020202A20546865206C697374206F6620696E636F6D696E6720';
wwv_flow_imp.g_varchar2_table(4534) := '636F6E6E656374696F6E730A2020202A0A2020202A20406E616D6520456C656D656E7423696E636F6D696E670A2020202A2040747970652041727261793C436F6E6E656374696F6E3E0A2020202A2F0A2020696E636F6D696E67526566732E62696E6428';
wwv_flow_imp.g_varchar2_table(4535) := '746869732C2027696E636F6D696E6727293B0A7D0A0A0A2F2A2A0A202A20412067726170686963616C206F626A6563740A202A0A202A2040636C6173730A202A2040636F6E7374727563746F720A202A0A202A2040657874656E647320456C656D656E74';
wwv_flow_imp.g_varchar2_table(4536) := '496D706C0A202A2F0A66756E6374696F6E205368617065496D706C2829207B0A2020456C656D656E74496D706C2E63616C6C2874686973293B0A0A20202F2A2A0A2020202A20496E64696361746573206672616D65207368617065730A2020202A0A2020';
wwv_flow_imp.g_varchar2_table(4537) := '202A20406E616D65205368617065496D706C2369734672616D650A2020202A20407479706520626F6F6C65616E0A2020202A2F0A0A20202F2A2A0A2020202A20546865206C697374206F66206368696C6472656E0A2020202A0A2020202A20406E616D65';
wwv_flow_imp.g_varchar2_table(4538) := '205368617065496D706C236368696C6472656E0A2020202A20407479706520456C656D656E745B5D0A2020202A2F0A2020706172656E74526566732E62696E6428746869732C20276368696C6472656E27293B0A0A20202F2A2A0A2020202A20406E616D';
wwv_flow_imp.g_varchar2_table(4539) := '65205368617065496D706C23686F73740A2020202A2040747970652053686170650A2020202A2F0A20206174746163686572526566732E62696E6428746869732C2027686F737427293B0A0A20202F2A2A0A2020202A20406E616D65205368617065496D';
wwv_flow_imp.g_varchar2_table(4540) := '706C236174746163686572730A2020202A2040747970652053686170650A2020202A2F0A20206174746163686572526566732E62696E6428746869732C202761747461636865727327293B0A7D0A0A28302C696E6865726974735F62726F777365725F5F';
wwv_flow_imp.g_varchar2_table(4541) := '5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D29285368617065496D706C2C20456C656D656E74496D706C293B0A0A0A2F2A2A0A202A204120726F6F742067726170686963616C206F626A6563740A202A';
wwv_flow_imp.g_varchar2_table(4542) := '0A202A2040636C6173730A202A2040636F6E7374727563746F720A202A0A202A2040657874656E647320456C656D656E74496D706C0A202A2F0A66756E6374696F6E20526F6F74496D706C2829207B0A2020456C656D656E74496D706C2E63616C6C2874';
wwv_flow_imp.g_varchar2_table(4543) := '686973293B0A0A20202F2A2A0A2020202A20546865206C697374206F66206368696C6472656E0A2020202A0A2020202A20406E616D6520526F6F74496D706C236368696C6472656E0A2020202A20407479706520456C656D656E745B5D0A2020202A2F0A';
wwv_flow_imp.g_varchar2_table(4544) := '2020706172656E74526566732E62696E6428746869732C20276368696C6472656E27293B0A7D0A0A28302C696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D29';
wwv_flow_imp.g_varchar2_table(4545) := '28526F6F74496D706C2C205368617065496D706C293B0A0A0A2F2A2A0A202A2041206C6162656C20666F7220616E20656C656D656E740A202A0A202A2040636C6173730A202A2040636F6E7374727563746F720A202A0A202A2040657874656E64732053';
wwv_flow_imp.g_varchar2_table(4546) := '68617065496D706C0A202A2F0A66756E6374696F6E204C6162656C496D706C2829207B0A20205368617065496D706C2E63616C6C2874686973293B0A0A20202F2A2A0A2020202A20546865206C6162656C656420656C656D656E740A2020202A0A202020';
wwv_flow_imp.g_varchar2_table(4547) := '2A20406E616D65204C6162656C496D706C236C6162656C5461726765740A2020202A20407479706520456C656D656E740A2020202A2F0A20206C6162656C526566732E62696E6428746869732C20276C6162656C54617267657427293B0A7D0A0A28302C';
wwv_flow_imp.g_varchar2_table(4548) := '696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B2264656661756C74225D29284C6162656C496D706C2C205368617065496D706C293B0A0A0A2F2A2A0A202A204120636F6E6E65637469';
wwv_flow_imp.g_varchar2_table(4549) := '6F6E206265747765656E2074776F20656C656D656E74730A202A0A202A2040636C6173730A202A2040636F6E7374727563746F720A202A0A202A2040657874656E647320456C656D656E74496D706C0A202A2F0A66756E6374696F6E20436F6E6E656374';
wwv_flow_imp.g_varchar2_table(4550) := '696F6E496D706C2829207B0A2020456C656D656E74496D706C2E63616C6C2874686973293B0A0A20202F2A2A0A2020202A2054686520656C656D656E74207468697320636F6E6E656374696F6E206F726967696E617465732066726F6D0A2020202A0A20';
wwv_flow_imp.g_varchar2_table(4551) := '20202A20406E616D6520436F6E6E656374696F6E496D706C23736F757263650A2020202A20407479706520456C656D656E740A2020202A2F0A20206F7574676F696E67526566732E62696E6428746869732C2027736F7572636527293B0A0A20202F2A2A';
wwv_flow_imp.g_varchar2_table(4552) := '0A2020202A2054686520656C656D656E74207468697320636F6E6E656374696F6E20706F696E747320746F0A2020202A0A2020202A20406E616D6520436F6E6E656374696F6E496D706C237461726765740A2020202A20407479706520456C656D656E74';
wwv_flow_imp.g_varchar2_table(4553) := '0A2020202A2F0A2020696E636F6D696E67526566732E62696E6428746869732C202774617267657427293B0A7D0A0A28302C696E6865726974735F62726F777365725F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F5B22646566';
wwv_flow_imp.g_varchar2_table(4554) := '61756C74225D2928436F6E6E656374696F6E496D706C2C20456C656D656E74496D706C293B0A0A0A766172207479706573203D207B0A2020636F6E6E656374696F6E3A20436F6E6E656374696F6E496D706C2C0A202073686170653A205368617065496D';
wwv_flow_imp.g_varchar2_table(4555) := '706C2C0A20206C6162656C3A204C6162656C496D706C2C0A2020726F6F743A20526F6F74496D706C0A7D3B0A0A2F2A2A0A202A2043726561746573206120726F6F7420656C656D656E742E0A202A0A202A20406F7665726C6F72640A202A0A202A204065';
wwv_flow_imp.g_varchar2_table(4556) := '78616D706C650A202A0A202A206060606A6176617363726970740A202A20696D706F7274202A206173204D6F64656C2066726F6D20276469616772616D2D6A732F6C69622F6D6F64656C273B0A202A0A202A20636F6E737420726F6F74203D204D6F6465';
wwv_flow_imp.g_varchar2_table(4557) := '6C2E6372656174652827726F6F74272C207B0A202A202020783A203130302C0A202A202020793A203130302C0A202A20202077696474683A203130302C0A202A2020206865696768743A203130300A202A207D293B0A202A206060600A202A0A202A2040';
wwv_flow_imp.g_varchar2_table(4558) := '706172616D207B27726F6F74277D20747970650A202A2040706172616D207B616E797D205B61747472735D0A202A0A202A204072657475726E207B526F6F747D0A202A2F0A0A2F2A2A0A202A2043726561746573206120636F6E6E656374696F6E2E0A20';
wwv_flow_imp.g_varchar2_table(4559) := '2A0A202A20406F7665726C6F72640A202A0A202A20406578616D706C650A202A0A202A206060606A6176617363726970740A202A20696D706F7274202A206173204D6F64656C2066726F6D20276469616772616D2D6A732F6C69622F6D6F64656C273B0A';
wwv_flow_imp.g_varchar2_table(4560) := '202A0A202A20636F6E737420636F6E6E656374696F6E203D204D6F64656C2E6372656174652827636F6E6E656374696F6E272C207B0A202A202020776179706F696E74733A205B0A202A20202020207B20783A203130302C20793A20313030207D2C0A20';
wwv_flow_imp.g_varchar2_table(4561) := '2A20202020207B20783A203230302C20793A20313030207D0A202A2020205D0A202A207D293B0A202A206060600A202A0A202A2040706172616D207B27636F6E6E656374696F6E277D20747970650A202A2040706172616D207B616E797D205B61747472';
wwv_flow_imp.g_varchar2_table(4562) := '735D0A202A0A202A204072657475726E207B436F6E6E656374696F6E7D0A202A2F0A0A2F2A2A0A202A204372656174657320612073686170652E0A202A0A202A20406F7665726C6F72640A202A0A202A20406578616D706C650A202A0A202A206060606A';
wwv_flow_imp.g_varchar2_table(4563) := '6176617363726970740A202A20696D706F7274202A206173204D6F64656C2066726F6D20276469616772616D2D6A732F6C69622F6D6F64656C273B0A202A0A202A20636F6E7374207368617065203D204D6F64656C2E6372656174652827736861706527';
wwv_flow_imp.g_varchar2_table(4564) := '2C207B0A202A202020783A203130302C0A202A202020793A203130302C0A202A20202077696474683A203130302C0A202A2020206865696768743A203130300A202A207D293B0A202A206060600A202A0A202A2040706172616D207B277368617065277D';
wwv_flow_imp.g_varchar2_table(4565) := '20747970650A202A2040706172616D207B616E797D205B61747472735D0A202A0A202A204072657475726E207B53686170657D0A202A2F0A0A2F2A2A0A202A20437265617465732061206C6162656C2E0A202A0A202A20406578616D706C650A202A0A20';
wwv_flow_imp.g_varchar2_table(4566) := '2A206060606A6176617363726970740A202A20696D706F7274202A206173204D6F64656C2066726F6D20276469616772616D2D6A732F6C69622F6D6F64656C273B0A202A0A202A20636F6E7374206C6162656C203D204D6F64656C2E6372656174652827';
wwv_flow_imp.g_varchar2_table(4567) := '6C6162656C272C207B0A202A202020783A203130302C0A202A202020793A203130302C0A202A20202077696474683A203130302C0A202A2020206865696768743A203130302C0A202A2020206C6162656C5461726765743A2073686170650A202A207D29';
wwv_flow_imp.g_varchar2_table(4568) := '3B0A202A206060600A202A0A202A2040706172616D207B276C6162656C277D20747970650A202A2040706172616D207B4F626A6563747D205B61747472735D0A202A0A202A204072657475726E207B4C6162656C7D0A202A2F0A66756E6374696F6E2063';
wwv_flow_imp.g_varchar2_table(4569) := '726561746528747970652C20617474727329207B0A20207661722054797065203D2074797065735B747970655D3B0A202069662028215479706529207B0A202020207468726F77206E6577204572726F722827756E6B6E6F776E20747970653A203C2720';
wwv_flow_imp.g_varchar2_table(4570) := '2B2074797065202B20273E27293B0A20207D0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E29286E6577205479706528292C206174747273293B0A7D0A0A';
wwv_flow_imp.g_varchar2_table(4571) := '2F2A2A0A202A20436865636B73207768657468657220616E206F626A6563742069732061206D6F64656C20696E7374616E63652E0A202A0A202A2040706172616D207B616E797D206F626A0A202A0A202A204072657475726E207B626F6F6C65616E7D0A';
wwv_flow_imp.g_varchar2_table(4572) := '202A2F0A66756E6374696F6E2069734D6F64656C456C656D656E74286F626A29207B0A202072657475726E206F626A20696E7374616E63656F6620456C656D656E74496D706C3B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F';
wwv_flow_imp.g_varchar2_table(4573) := '6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F6D6F766563616E7661732F4D6F766543616E7661732E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4574) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F6D6F766563616E7661732F';
wwv_flow_imp.g_varchar2_table(4575) := '4D6F766543616E7661732E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A';
wwv_flow_imp.g_varchar2_table(4576) := '2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E7228';
wwv_flow_imp.g_varchar2_table(4577) := '5F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E792065';
wwv_flow_imp.g_varchar2_table(4578) := '78706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F204D6F766543616E766173290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F';
wwv_flow_imp.g_varchar2_table(4579) := '20766172205F7574696C5F437572736F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F437572736F72202A2F20222E2F6E6F64';
wwv_flow_imp.g_varchar2_table(4580) := '655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F437572736F722E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F436C69636B547261705F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(4581) := '445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F436C69636B54726170202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F43';
wwv_flow_imp.g_varchar2_table(4582) := '6C69636B547261702E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F506F736974696F6E5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F';
wwv_flow_imp.g_varchar2_table(4583) := '726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F506F736974696F6E5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F506F736974696F6E5574696C2E6A7322293B0A2F2A2068';
wwv_flow_imp.g_varchar2_table(4584) := '61726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F';
wwv_flow_imp.g_varchar2_table(4585) := '64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4576656E745F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(4586) := '455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F4576656E74202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4576656E742E6A7322293B0A';
wwv_flow_imp.g_varchar2_table(4587) := '0A0A0A0A0A0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E64656661756C747D2043616E7661730A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F';
wwv_flow_imp.g_varchar2_table(4588) := '72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A2F0A0A766172205448524553484F4C44203D2031353B0A0A0A2F2A2A0A202A204D6F7665207468652063616E76617320766961206D6F7573652E0A202A0A202A2040';
wwv_flow_imp.g_varchar2_table(4589) := '706172616D207B4576656E744275737D206576656E744275730A202A2040706172616D207B43616E7661737D2063616E7661730A202A2F0A66756E6374696F6E204D6F766543616E766173286576656E744275732C2063616E76617329207B0A0A202076';
wwv_flow_imp.g_varchar2_table(4590) := '617220636F6E746578743B0A0A0A20202F2F206C697374656E20666F72206D6F7665206F6E20656C656D656E74206D6F75736520646F776E3B0A20202F2F20616C6C6F77206F746865727320746F20686F6F6B20696E746F20746865206576656E742062';
wwv_flow_imp.g_varchar2_table(4591) := '65666F72652075732074686F7567680A20202F2F20286472616767696E67202F20656C656D656E74206D6F76696E672077696C6C20646F2074686973290A20206576656E744275732E6F6E2827656C656D656E742E6D6F757365646F776E272C20353030';
wwv_flow_imp.g_varchar2_table(4592) := '2C2066756E6374696F6E286529207B0A2020202072657475726E2068616E646C65537461727428652E6F726967696E616C4576656E74293B0A20207D293B0A0A0A202066756E6374696F6E2068616E646C654D6F7665286576656E7429207B0A0A202020';
wwv_flow_imp.g_varchar2_table(4593) := '20766172207374617274203D20636F6E746578742E73746172742C0A2020202020202020627574746F6E203D20636F6E746578742E627574746F6E2C0A2020202020202020706F736974696F6E203D2028302C5F7574696C5F4576656E745F5F57454250';
wwv_flow_imp.g_varchar2_table(4594) := '41434B5F494D504F525445445F4D4F44554C455F305F5F2E746F506F696E7429286576656E74292C0A202020202020202064656C7461203D2028302C5F7574696C5F506F736974696F6E5574696C5F5F5745425041434B5F494D504F525445445F4D4F44';
wwv_flow_imp.g_varchar2_table(4595) := '554C455F315F5F2E64656C74612928706F736974696F6E2C207374617274293B0A0A202020206966202821636F6E746578742E6472616767696E67202626206C656E6774682864656C746129203E205448524553484F4C4429207B0A202020202020636F';
wwv_flow_imp.g_varchar2_table(4596) := '6E746578742E6472616767696E67203D20747275653B0A0A20202020202069662028627574746F6E203D3D3D203029207B0A202020202020202028302C5F7574696C5F436C69636B547261705F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(4597) := '455F325F5F2E696E7374616C6C29286576656E74427573293B0A2020202020207D0A0A20202020202028302C5F7574696C5F437572736F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E7365742928276772616227293B0A';
wwv_flow_imp.g_varchar2_table(4598) := '202020207D0A0A2020202069662028636F6E746578742E6472616767696E6729207B0A0A202020202020766172206C617374506F736974696F6E203D20636F6E746578742E6C617374207C7C20636F6E746578742E73746172743B0A0A20202020202064';
wwv_flow_imp.g_varchar2_table(4599) := '656C7461203D2028302C5F7574696C5F506F736974696F6E5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E64656C74612928706F736974696F6E2C206C617374506F736974696F6E293B0A0A20202020202063616E';
wwv_flow_imp.g_varchar2_table(4600) := '7661732E7363726F6C6C287B0A202020202020202064783A2064656C74612E782C0A202020202020202064793A2064656C74612E790A2020202020207D293B0A0A202020202020636F6E746578742E6C617374203D20706F736974696F6E3B0A20202020';
wwv_flow_imp.g_varchar2_table(4601) := '7D0A0A202020202F2F2070726576656E742073656C6563740A202020206576656E742E70726576656E7444656661756C7428293B0A20207D0A0A0A202066756E6374696F6E2068616E646C65456E64286576656E7429207B0A202020206D696E5F646F6D';
wwv_flow_imp.g_varchar2_table(4602) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E6576656E742E756E62696E6428646F63756D656E742C20276D6F7573656D6F7665272C2068616E646C654D6F7665293B0A202020206D696E5F646F6D5F5F5745425041434B5F';
wwv_flow_imp.g_varchar2_table(4603) := '494D504F525445445F4D4F44554C455F345F5F2E6576656E742E756E62696E6428646F63756D656E742C20276D6F7573657570272C2068616E646C65456E64293B0A0A20202020636F6E74657874203D206E756C6C3B0A0A2020202028302C5F7574696C';
wwv_flow_imp.g_varchar2_table(4604) := '5F437572736F725F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E756E7365742928293B0A20207D0A0A202066756E6374696F6E2068616E646C655374617274286576656E7429207B0A0A202020202F2F206576656E74206973';
wwv_flow_imp.g_varchar2_table(4605) := '20616C72656164792068616E646C656420627920272E646A732D647261676761626C65270A202020206966202828302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E636C6F7365737429286576656E742E';
wwv_flow_imp.g_varchar2_table(4606) := '7461726765742C20272E646A732D647261676761626C65272929207B0A20202020202072657475726E3B0A202020207D0A0A2020202076617220627574746F6E203D206576656E742E627574746F6E3B0A0A202020202F2F2072656A6563742072696768';
wwv_flow_imp.g_varchar2_table(4607) := '74206D6F75736520627574746F6E206F72206D6F646966696572206B65790A2020202069662028627574746F6E203E3D2032207C7C206576656E742E6374726C4B6579207C7C206576656E742E73686966744B6579207C7C206576656E742E616C744B65';
wwv_flow_imp.g_varchar2_table(4608) := '7929207B0A20202020202072657475726E3B0A202020207D0A0A20202020636F6E74657874203D207B0A202020202020627574746F6E3A20627574746F6E2C0A20202020202073746172743A2028302C5F7574696C5F4576656E745F5F5745425041434B';
wwv_flow_imp.g_varchar2_table(4609) := '5F494D504F525445445F4D4F44554C455F305F5F2E746F506F696E7429286576656E74290A202020207D3B0A0A202020206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E6576656E742E62696E6428646F63';
wwv_flow_imp.g_varchar2_table(4610) := '756D656E742C20276D6F7573656D6F7665272C2068616E646C654D6F7665293B0A202020206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E6576656E742E62696E6428646F63756D656E742C20276D6F7573';
wwv_flow_imp.g_varchar2_table(4611) := '657570272C2068616E646C65456E64293B0A0A202020202F2F2077652776652068616E646C656420746865206576656E740A2020202072657475726E20747275653B0A20207D0A0A2020746869732E6973416374697665203D2066756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(4612) := '207B0A2020202072657475726E202121636F6E746578743B0A20207D3B0A0A7D0A0A0A4D6F766543616E7661732E24696E6A656374203D205B0A2020276576656E74427573272C0A20202763616E766173270A5D3B0A0A0A0A2F2F2068656C7065727320';
wwv_flow_imp.g_varchar2_table(4613) := '2F2F2F2F2F2F2F0A0A66756E6374696F6E206C656E67746828706F696E7429207B0A202072657475726E204D6174682E73717274284D6174682E706F7728706F696E742E782C203229202B204D6174682E706F7728706F696E742E792C203229293B0A7D';
wwv_flow_imp.g_varchar2_table(4614) := '0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F6D6F766563616E7661732F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4615) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669';
wwv_flow_imp.g_varchar2_table(4616) := '676174696F6E2F6D6F766563616E7661732F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4617) := '2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F72657175';
wwv_flow_imp.g_varchar2_table(4618) := '6972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A2068';
wwv_flow_imp.g_varchar2_table(4619) := '61726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E79';
wwv_flow_imp.g_varchar2_table(4620) := '20696D706F7274202A2F20766172205F4D6F766543616E7661735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4D6F766543616E766173202A2F20222E';
wwv_flow_imp.g_varchar2_table(4621) := '2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F6D6F766563616E7661732F4D6F766543616E7661732E6A7322293B0A0A0A0A2F2A2A0A202A204074797065207B20696D706F72742827646964692729';
wwv_flow_imp.g_varchar2_table(4622) := '2E4D6F64756C654465636C61726174696F6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F696E6974';
wwv_flow_imp.g_varchar2_table(4623) := '5F5F3A205B20276D6F766543616E76617327205D2C0A20206D6F766543616E7661733A205B202774797065272C205F4D6F766543616E7661735F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D205D0A';
wwv_flow_imp.g_varchar2_table(4624) := '7D293B0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F5A6F6F6D5363726F6C6C2E6A73223A0A2F2A212A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4625) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D';
wwv_flow_imp.g_varchar2_table(4626) := '2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F5A6F6F6D5363726F6C6C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4627) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F';
wwv_flow_imp.g_varchar2_table(4628) := '29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F776562';
wwv_flow_imp.g_varchar2_table(4629) := '7061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F205A6F6F6D5363726F6C6C290A2F2A206861726D6F6E79206578706F';
wwv_flow_imp.g_varchar2_table(4630) := '7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D69';
wwv_flow_imp.g_varchar2_table(4631) := '6E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F5A6F6F6D5574696C5F5F5745425041434B5F494D';
wwv_flow_imp.g_varchar2_table(4632) := '504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F5A6F6F6D5574696C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F';
wwv_flow_imp.g_varchar2_table(4633) := '7A6F6F6D7363726F6C6C2F5A6F6F6D5574696C2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6174685F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061';
wwv_flow_imp.g_varchar2_table(4634) := '636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F4D617468202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6174682E6A7322293B0A2F2A206861726D6F6E7920696D706F7274';
wwv_flow_imp.g_varchar2_table(4635) := '202A2F20766172205F7574696C5F506C6174666F726D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F506C6174666F726D202A2F';
wwv_flow_imp.g_varchar2_table(4636) := '20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F506C6174666F726D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F52';
wwv_flow_imp.g_varchar2_table(4637) := '5445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A0A';
wwv_flow_imp.g_varchar2_table(4638) := '0A0A0A0A0A0A0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E64656661756C747D2043616E7661730A202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72';
wwv_flow_imp.g_varchar2_table(4639) := '652F4576656E7442757327292E64656661756C747D204576656E744275730A202A0A202A204074797065646566207B696D706F727428272E2E2F2E2E2F7574696C2F547970657327292E506F696E747D20506F696E740A202A204074797065646566207B';
wwv_flow_imp.g_varchar2_table(4640) := '696D706F727428272E2E2F2E2E2F7574696C2F547970657327292E5363726F6C6C44656C74617D205363726F6C6C44656C74610A202A2F0A0A766172207369676E203D204D6174682E7369676E207C7C2066756E6374696F6E286E29207B0A2020726574';
wwv_flow_imp.g_varchar2_table(4641) := '75726E206E203E3D2030203F2031203A202D313B0A7D3B0A0A7661722052414E4745203D207B206D696E3A20302E322C206D61783A2034207D2C0A202020204E554D5F5354455053203D2031303B0A0A7661722044454C54415F5448524553484F4C4420';
wwv_flow_imp.g_varchar2_table(4642) := '3D20302E313B0A0A7661722044454641554C545F5343414C45203D20302E37353B0A0A2F2A2A0A202A20416E20696D706C656D656E746174696F6E206F66207A6F6F6D696E6720616E64207363726F6C6C696E672077697468696E207468650A202A207B';
wwv_flow_imp.g_varchar2_table(4643) := '406C696E6B2043616E7661737D2076696120746865206D6F75736520776865656C2E0A202A0A202A204D6F75736520776865656C207A6F6F6D696E67202F207363726F6C6C696E67206D61792062652064697361626C6564207573696E670A202A207468';
wwv_flow_imp.g_varchar2_table(4644) := '65207B406C696E6B20746F67676C6528656E61626C6564297D206D6574686F642E0A202A0A202A2040706172616D207B4F626A6563747D205B636F6E6669675D0A202A2040706172616D207B626F6F6C65616E7D205B636F6E6669672E656E61626C6564';
wwv_flow_imp.g_varchar2_table(4645) := '3D747275655D2064656661756C7420656E61626C65642073746174650A202A2040706172616D207B6E756D6265727D205B636F6E6669672E7363616C653D2E37355D207363726F6C6C2073656E7369766974790A202A2040706172616D207B4576656E74';
wwv_flow_imp.g_varchar2_table(4646) := '4275737D206576656E744275730A202A2040706172616D207B43616E7661737D2063616E7661730A202A2F0A66756E6374696F6E205A6F6F6D5363726F6C6C28636F6E6669672C206576656E744275732C2063616E76617329207B0A0A2020636F6E6669';
wwv_flow_imp.g_varchar2_table(4647) := '67203D20636F6E666967207C7C207B7D3B0A0A2020746869732E5F656E61626C6564203D2066616C73653B0A0A2020746869732E5F63616E766173203D2063616E7661733B0A2020746869732E5F636F6E7461696E6572203D2063616E7661732E5F636F';
wwv_flow_imp.g_varchar2_table(4648) := '6E7461696E65723B0A0A2020746869732E5F68616E646C65576865656C203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E62696E642928746869732E5F68616E646C65576865656C2C207468';
wwv_flow_imp.g_varchar2_table(4649) := '6973293B0A0A2020746869732E5F746F74616C44656C7461203D20303B0A2020746869732E5F7363616C65203D20636F6E6669672E7363616C65207C7C2044454641554C545F5343414C453B0A0A20207661722073656C66203D20746869733B0A0A2020';
wwv_flow_imp.g_varchar2_table(4650) := '6576656E744275732E6F6E282763616E7661732E696E6974272C2066756E6374696F6E286529207B0A2020202073656C662E5F696E697428636F6E6669672E656E61626C656420213D3D2066616C7365293B0A20207D293B0A7D0A0A5A6F6F6D5363726F';
wwv_flow_imp.g_varchar2_table(4651) := '6C6C2E24696E6A656374203D205B0A202027636F6E6669672E7A6F6F6D5363726F6C6C272C0A2020276576656E74427573272C0A20202763616E766173270A5D3B0A0A2F2A2A0A202A2040706172616D207B5363726F6C6C44656C74617D2064656C7461';
wwv_flow_imp.g_varchar2_table(4652) := '0A202A2F0A5A6F6F6D5363726F6C6C2E70726F746F747970652E7363726F6C6C203D2066756E6374696F6E207363726F6C6C2864656C746129207B0A2020746869732E5F63616E7661732E7363726F6C6C2864656C7461293B0A7D3B0A0A0A5A6F6F6D53';
wwv_flow_imp.g_varchar2_table(4653) := '63726F6C6C2E70726F746F747970652E7265736574203D2066756E6374696F6E2072657365742829207B0A2020746869732E5F63616E7661732E7A6F6F6D28276669742D76696577706F727427293B0A7D3B0A0A2F2A2A0A202A205A6F6F6D2064657065';
wwv_flow_imp.g_varchar2_table(4654) := '6E64696E67206F6E2064656C74612E0A202A0A202A2040706172616D207B6E756D6265727D2064656C74610A202A2040706172616D207B506F696E747D20706F736974696F6E0A202A2F0A5A6F6F6D5363726F6C6C2E70726F746F747970652E7A6F6F6D';
wwv_flow_imp.g_varchar2_table(4655) := '203D2066756E6374696F6E207A6F6F6D2864656C74612C20706F736974696F6E29207B0A0A20202F2F207A6F6F6D20776974682068616C662074686520737465702073697A65206F6620737465705A6F6F6D0A2020766172207374657053697A65203D20';
wwv_flow_imp.g_varchar2_table(4656) := '28302C5F5A6F6F6D5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6765745374657053697A65292852414E47452C204E554D5F5354455053202A2032293B0A0A20202F2F2061646420756E74696C20746872657368';
wwv_flow_imp.g_varchar2_table(4657) := '6F6C6420726561636865640A2020746869732E5F746F74616C44656C7461202B3D2064656C74613B0A0A2020696620284D6174682E61627328746869732E5F746F74616C44656C746129203E2044454C54415F5448524553484F4C4429207B0A20202020';
wwv_flow_imp.g_varchar2_table(4658) := '746869732E5F7A6F6F6D2864656C74612C20706F736974696F6E2C207374657053697A65293B0A0A202020202F2F2072657365740A20202020746869732E5F746F74616C44656C7461203D20303B0A20207D0A7D3B0A0A0A5A6F6F6D5363726F6C6C2E70';
wwv_flow_imp.g_varchar2_table(4659) := '726F746F747970652E5F68616E646C65576865656C203D2066756E6374696F6E2068616E646C65576865656C286576656E7429207B0A0A20202F2F206576656E7420697320616C72656164792068616E646C656420627920272E646A732D7363726F6C6C';
wwv_flow_imp.g_varchar2_table(4660) := '61626C65270A20206966202828302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E636C6F7365737429286576656E742E7461726765742C20272E646A732D7363726F6C6C61626C65272C20747275652929';
wwv_flow_imp.g_varchar2_table(4661) := '207B0A2020202072657475726E3B0A20207D0A0A202076617220656C656D656E74203D20746869732E5F636F6E7461696E65723B0A0A20206576656E742E70726576656E7444656661756C7428293B0A0A20202F2F2070696E636820746F207A6F6F6D20';
wwv_flow_imp.g_varchar2_table(4662) := '6973206D617070656420746F20776865656C202B206374726C4B6579203D20747275650A20202F2F20696E206D6F6465726E2062726F7773657273202821290A0A20207661722069735A6F6F6D203D206576656E742E6374726C4B6579207C7C20282830';
wwv_flow_imp.g_varchar2_table(4663) := '2C5F7574696C5F506C6174666F726D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F2E69734D6163292829202626206576656E742E6D6574614B6579293B0A0A2020766172206973486F72697A6F6E74616C5363726F6C6C203D';
wwv_flow_imp.g_varchar2_table(4664) := '206576656E742E73686966744B65793B0A0A202076617220666163746F72203D202D31202A20746869732E5F7363616C652C0A20202020202064656C74613B0A0A20206966202869735A6F6F6D29207B0A20202020666163746F72202A3D206576656E74';
wwv_flow_imp.g_varchar2_table(4665) := '2E64656C74614D6F6465203D3D3D2030203F20302E303230203A20302E33323B0A20207D20656C7365207B0A20202020666163746F72202A3D206576656E742E64656C74614D6F6465203D3D3D2030203F20312E30203A2031362E303B0A20207D0A0A20';
wwv_flow_imp.g_varchar2_table(4666) := '206966202869735A6F6F6D29207B0A2020202076617220656C656D656E7452656374203D20656C656D656E742E676574426F756E64696E67436C69656E745265637428293B0A0A20202020766172206F6666736574203D207B0A202020202020783A2065';
wwv_flow_imp.g_varchar2_table(4667) := '76656E742E636C69656E7458202D20656C656D656E74526563742E6C6566742C0A202020202020793A206576656E742E636C69656E7459202D20656C656D656E74526563742E746F700A202020207D3B0A0A2020202064656C7461203D20280A20202020';
wwv_flow_imp.g_varchar2_table(4668) := '20204D6174682E73717274280A20202020202020204D6174682E706F77286576656E742E64656C7461592C203229202B0A20202020202020204D6174682E706F77286576656E742E64656C7461582C2032290A20202020202029202A207369676E286576';
wwv_flow_imp.g_varchar2_table(4669) := '656E742E64656C74615929202A20666163746F720A20202020293B0A0A202020202F2F207A6F6F6D20696E2072656C617469766520746F206469616772616D207B782C797D20636F6F7264696E617465730A20202020746869732E7A6F6F6D2864656C74';
wwv_flow_imp.g_varchar2_table(4670) := '612C206F6666736574293B0A20207D20656C7365207B0A0A20202020696620286973486F72697A6F6E74616C5363726F6C6C29207B0A20202020202064656C7461203D207B0A202020202020202064783A20666163746F72202A206576656E742E64656C';
wwv_flow_imp.g_varchar2_table(4671) := '7461592C0A202020202020202064793A20300A2020202020207D3B0A202020207D20656C7365207B0A20202020202064656C7461203D207B0A202020202020202064783A20666163746F72202A206576656E742E64656C7461582C0A2020202020202020';
wwv_flow_imp.g_varchar2_table(4672) := '64793A20666163746F72202A206576656E742E64656C7461590A2020202020207D3B0A202020207D0A0A20202020746869732E7363726F6C6C2864656C7461293B0A20207D0A7D3B0A0A2F2A2A0A202A205A6F6F6D207769746820666978656420737465';
wwv_flow_imp.g_varchar2_table(4673) := '702073697A652E0A202A0A202A2040706172616D207B6E756D6265727D2064656C7461205A6F6F6D2064656C746120283120666F72207A6F6F6D696E6720696E2C202D3120666F72207A6F6F6D696E67206F7574292E0A202A2040706172616D207B506F';
wwv_flow_imp.g_varchar2_table(4674) := '696E747D205B706F736974696F6E5D0A202A2F0A5A6F6F6D5363726F6C6C2E70726F746F747970652E737465705A6F6F6D203D2066756E6374696F6E20737465705A6F6F6D2864656C74612C20706F736974696F6E29207B0A0A20207661722073746570';
wwv_flow_imp.g_varchar2_table(4675) := '53697A65203D2028302C5F5A6F6F6D5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6765745374657053697A65292852414E47452C204E554D5F5354455053293B0A0A2020746869732E5F7A6F6F6D2864656C7461';
wwv_flow_imp.g_varchar2_table(4676) := '2C20706F736974696F6E2C207374657053697A65293B0A7D3B0A0A0A2F2A2A0A202A205A6F6F6D20696E2F6F757420676976656E206120737465702073697A652E0A202A0A202A2040706172616D207B6E756D6265727D2064656C74610A202A20407061';
wwv_flow_imp.g_varchar2_table(4677) := '72616D207B506F696E747D205B706F736974696F6E5D0A202A2040706172616D207B6E756D6265727D207374657053697A650A202A2F0A5A6F6F6D5363726F6C6C2E70726F746F747970652E5F7A6F6F6D203D2066756E6374696F6E2864656C74612C20';
wwv_flow_imp.g_varchar2_table(4678) := '706F736974696F6E2C207374657053697A6529207B0A20207661722063616E766173203D20746869732E5F63616E7661733B0A0A202076617220646972656374696F6E203D2064656C7461203E2030203F2031203A202D313B0A0A202076617220637572';
wwv_flow_imp.g_varchar2_table(4679) := '72656E744C696E6561725A6F6F6D4C6576656C203D2028302C5F7574696C5F4D6174685F5F5745425041434B5F494D504F525445445F4D4F44554C455F345F5F2E6C6F673130292863616E7661732E7A6F6F6D2829293B0A0A20202F2F20736E61702074';
wwv_flow_imp.g_varchar2_table(4680) := '6F20612070726F78696D617465207A6F6F6D20737465700A2020766172206E65774C696E6561725A6F6F6D4C6576656C203D204D6174682E726F756E642863757272656E744C696E6561725A6F6F6D4C6576656C202F207374657053697A6529202A2073';
wwv_flow_imp.g_varchar2_table(4681) := '74657053697A653B0A0A20202F2F20696E637265617365206F72206465637265617365206F6E65207A6F6F6D207374657020696E2074686520676976656E20646972656374696F6E0A20206E65774C696E6561725A6F6F6D4C6576656C202B3D20737465';
wwv_flow_imp.g_varchar2_table(4682) := '7053697A65202A20646972656374696F6E3B0A0A20202F2F2063616C63756C61746520746865206162736F6C757465206C6F6761726974686D6963207A6F6F6D206C6576656C206261736564206F6E20746865206C696E656172207A6F6F6D206C657665';
wwv_flow_imp.g_varchar2_table(4683) := '6C0A20202F2F2028652E672E203220666F7220616E206162736F6C757465207832207A6F6F6D290A2020766172206E65774C6F675A6F6F6D4C6576656C203D204D6174682E706F772831302C206E65774C696E6561725A6F6F6D4C6576656C293B0A0A20';
wwv_flow_imp.g_varchar2_table(4684) := '2063616E7661732E7A6F6F6D2828302C5F5A6F6F6D5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E636170292852414E47452C206E65774C6F675A6F6F6D4C6576656C292C20706F736974696F6E293B0A7D3B0A0A';
wwv_flow_imp.g_varchar2_table(4685) := '0A2F2A2A0A202A20546F67676C6520746865207A6F6F6D207363726F6C6C206162696C69747920766961206D6F75736520776865656C2E0A202A0A202A2040706172616D207B626F6F6C65616E7D205B6E6577456E61626C65645D206E657720656E6162';
wwv_flow_imp.g_varchar2_table(4686) := '6C65642073746174650A202A2F0A5A6F6F6D5363726F6C6C2E70726F746F747970652E746F67676C65203D2066756E6374696F6E20746F67676C65286E6577456E61626C656429207B0A0A202076617220656C656D656E74203D20746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(4687) := '7461696E65723B0A20207661722068616E646C65576865656C203D20746869732E5F68616E646C65576865656C3B0A0A2020766172206F6C64456E61626C6564203D20746869732E5F656E61626C65643B0A0A202069662028747970656F66206E657745';
wwv_flow_imp.g_varchar2_table(4688) := '6E61626C6564203D3D3D2027756E646566696E65642729207B0A202020206E6577456E61626C6564203D20216F6C64456E61626C65643B0A20207D0A0A20202F2F206F6E6C79207265616374206F6E2061637475616C206368616E6765730A2020696620';
wwv_flow_imp.g_varchar2_table(4689) := '286F6C64456E61626C656420213D3D206E6577456E61626C656429207B0A0A202020202F2F20616464206F722072656D6F766520776865656C206C697374656E6572206261736564206F6E0A202020202F2F206368616E67656420656E61626C65642073';
wwv_flow_imp.g_varchar2_table(4690) := '746174650A202020206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6576656E745B6E6577456E61626C6564203F202762696E6427203A2027756E62696E64275D28656C656D656E742C2027776865656C27';
wwv_flow_imp.g_varchar2_table(4691) := '2C2068616E646C65576865656C2C2066616C7365293B0A20207D0A0A2020746869732E5F656E61626C6564203D206E6577456E61626C65643B0A0A202072657475726E206E6577456E61626C65643B0A7D3B0A0A0A5A6F6F6D5363726F6C6C2E70726F74';
wwv_flow_imp.g_varchar2_table(4692) := '6F747970652E5F696E6974203D2066756E6374696F6E286E6577456E61626C656429207B0A2020746869732E746F67676C65286E6577456E61626C6564293B0A7D3B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65';
wwv_flow_imp.g_varchar2_table(4693) := '732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F5A6F6F6D5574696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4694) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F5A6F6F6D5574696C2E6A';
wwv_flow_imp.g_varchar2_table(4695) := '73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F';
wwv_flow_imp.g_varchar2_table(4696) := '7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F';
wwv_flow_imp.g_varchar2_table(4697) := '7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020636170';
wwv_flow_imp.g_varchar2_table(4698) := '3A202829203D3E20282F2A2062696E64696E67202A2F20636170292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206765745374657053697A653A202829203D3E20282F2A2062696E64696E67202A2F206765745374657053697A65290A2F';
wwv_flow_imp.g_varchar2_table(4699) := '2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F7574696C5F4D6174685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(4700) := '5F726571756972655F5F282F2A21202E2E2F2E2E2F7574696C2F4D617468202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6174682E6A7322293B0A0A0A2F2A2A0A202A2047657420737465702073';
wwv_flow_imp.g_varchar2_table(4701) := '697A6520666F7220676976656E2072616E676520616E64206E756D626572206F662073746570732E0A202A0A202A2040706172616D207B4F626A6563747D2072616E67650A202A2040706172616D207B6E756D6265727D2072616E67652E6D696E0A202A';
wwv_flow_imp.g_varchar2_table(4702) := '2040706172616D207B6E756D6265727D2072616E67652E6D61780A202A2040706172616D207B6E756D6265727D2073746570730A202A2F0A66756E6374696F6E206765745374657053697A652872616E67652C20737465707329207B0A0A202076617220';
wwv_flow_imp.g_varchar2_table(4703) := '6D696E4C696E65617252616E6765203D2028302C5F7574696C5F4D6174685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6C6F673130292872616E67652E6D696E292C0A2020202020206D61784C696E65617252616E676520';
wwv_flow_imp.g_varchar2_table(4704) := '3D2028302C5F7574696C5F4D6174685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6C6F673130292872616E67652E6D6178293B0A0A2020766172206162736F6C7574654C696E65617252616E6765203D204D6174682E6162';
wwv_flow_imp.g_varchar2_table(4705) := '73286D696E4C696E65617252616E676529202B204D6174682E616273286D61784C696E65617252616E6765293B0A0A202072657475726E206162736F6C7574654C696E65617252616E6765202F2073746570733B0A7D0A0A2F2A2A0A202A204070617261';
wwv_flow_imp.g_varchar2_table(4706) := '6D207B4F626A6563747D2072616E67650A202A2040706172616D207B6E756D6265727D2072616E67652E6D696E0A202A2040706172616D207B6E756D6265727D2072616E67652E6D61780A202A2040706172616D207B6E756D6265727D207363616C650A';
wwv_flow_imp.g_varchar2_table(4707) := '202A2F0A66756E6374696F6E206361702872616E67652C207363616C6529207B0A202072657475726E204D6174682E6D61782872616E67652E6D696E2C204D6174682E6D696E2872616E67652E6D61782C207363616C6529293B0A7D0A0A0A2F2A2A2A2F';
wwv_flow_imp.g_varchar2_table(4708) := '207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4709) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A';
wwv_flow_imp.g_varchar2_table(4710) := '6F6F6D7363726F6C6C2F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A';
wwv_flow_imp.g_varchar2_table(4711) := '2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E7228';
wwv_flow_imp.g_varchar2_table(4712) := '5F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E792065';
wwv_flow_imp.g_varchar2_table(4713) := '78706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F727420';
wwv_flow_imp.g_varchar2_table(4714) := '2A2F20766172205F5A6F6F6D5363726F6C6C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F5A6F6F6D5363726F6C6C202A2F20222E2F6E6F64655F6D6F';
wwv_flow_imp.g_varchar2_table(4715) := '64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F5A6F6F6D5363726F6C6C2E6A7322293B0A0A0A0A2F2A2A0A202A204074797065207B20696D706F727428276469646927292E4D6F64756C6544';
wwv_flow_imp.g_varchar2_table(4716) := '65636C61726174696F6E207D0A202A2F0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D20287B0A20205F5F696E69745F5F3A205B20277A';
wwv_flow_imp.g_varchar2_table(4717) := '6F6F6D5363726F6C6C27205D2C0A20207A6F6F6D5363726F6C6C3A205B202774797065272C205F5A6F6F6D5363726F6C6C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D205D0A7D293B0A0A2F2A2A';
wwv_flow_imp.g_varchar2_table(4718) := '2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F436C69636B547261702E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4719) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F436C69636B547261702E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4720) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C';
wwv_flow_imp.g_varchar2_table(4721) := '205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061';
wwv_flow_imp.g_varchar2_table(4722) := '636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020696E7374616C6C3A202829203D3E20282F2A2062696E64696E67202A2F20696E7374616C6C290A';
wwv_flow_imp.g_varchar2_table(4723) := '2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275730A202A2F0A0A7661722054524150';
wwv_flow_imp.g_varchar2_table(4724) := '5F5052494F52495459203D20353030303B0A0A2F2A2A0A202A20496E7374616C6C73206120636C69636B207472617020746861742070726576656E747320612067686F737420636C69636B20666F6C6C6F77696E672061206472616767696E67206F7065';
wwv_flow_imp.g_varchar2_table(4725) := '726174696F6E2E0A202A0A202A2040706172616D207B4576656E744275737D206576656E744275730A202A2040706172616D207B737472696E677D205B6576656E744E616D653D27656C656D656E742E636C69636B275D0A202A0A202A20407265747572';
wwv_flow_imp.g_varchar2_table(4726) := '6E207B2829203D3E20766F69647D20612066756E6374696F6E20746F20696D6D6564696174656C792072656D6F76652074686520696E7374616C6C656420747261702E0A202A2F0A66756E6374696F6E20696E7374616C6C286576656E744275732C2065';
wwv_flow_imp.g_varchar2_table(4727) := '76656E744E616D6529207B0A0A20206576656E744E616D65203D206576656E744E616D65207C7C2027656C656D656E742E636C69636B273B0A0A202066756E6374696F6E20747261702829207B0A2020202072657475726E2066616C73653B0A20207D0A';
wwv_flow_imp.g_varchar2_table(4728) := '0A20206576656E744275732E6F6E6365286576656E744E616D652C20545241505F5052494F524954592C2074726170293B0A0A202072657475726E2066756E6374696F6E2829207B0A202020206576656E744275732E6F6666286576656E744E616D652C';
wwv_flow_imp.g_varchar2_table(4729) := '2074726170293B0A20207D3B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F436F6C6C656374696F6E732E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4730) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F436F6C6C65637469';
wwv_flow_imp.g_varchar2_table(4731) := '6F6E732E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D';
wwv_flow_imp.g_varchar2_table(4732) := '6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F';
wwv_flow_imp.g_varchar2_table(4733) := '2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020206164643A202829203D3E2028';
wwv_flow_imp.g_varchar2_table(4734) := '2F2A2062696E64696E67202A2F20616464292C0A2F2A206861726D6F6E79206578706F7274202A2F202020696E6465784F663A202829203D3E20282F2A2062696E64696E67202A2F20696E6465784F66292C0A2F2A206861726D6F6E79206578706F7274';
wwv_flow_imp.g_varchar2_table(4735) := '202A2F20202072656D6F76653A202829203D3E20282F2A2062696E64696E67202A2F2072656D6F7665290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2A0A202A204661696C736166652072656D6F766520616E20656C656D656E';
wwv_flow_imp.g_varchar2_table(4736) := '742066726F6D206120636F6C6C656374696F6E0A202A0A202A2040706172616D207B41727261793C4F626A6563743E7D205B636F6C6C656374696F6E5D0A202A2040706172616D207B4F626A6563747D205B656C656D656E745D0A202A0A202A20407265';
wwv_flow_imp.g_varchar2_table(4737) := '7475726E207B6E756D6265727D207468652070726576696F757320696E646578206F662074686520656C656D656E740A202A2F0A66756E6374696F6E2072656D6F766528636F6C6C656374696F6E2C20656C656D656E7429207B0A0A2020696620282163';
wwv_flow_imp.g_varchar2_table(4738) := '6F6C6C656374696F6E207C7C2021656C656D656E7429207B0A2020202072657475726E202D313B0A20207D0A0A202076617220696478203D20636F6C6C656374696F6E2E696E6465784F6628656C656D656E74293B0A0A20206966202869647820213D3D';
wwv_flow_imp.g_varchar2_table(4739) := '202D3129207B0A20202020636F6C6C656374696F6E2E73706C696365286964782C2031293B0A20207D0A0A202072657475726E206964783B0A7D0A0A2F2A2A0A202A204661696C20736176652061646420616E20656C656D656E7420746F207468652067';
wwv_flow_imp.g_varchar2_table(4740) := '6976656E20636F6E6E656374696F6E2C20656E737572696E670A202A20697420646F6573206E6F74207965742065786973742E0A202A0A202A2040706172616D207B41727261793C4F626A6563743E7D20636F6C6C656374696F6E0A202A204070617261';
wwv_flow_imp.g_varchar2_table(4741) := '6D207B4F626A6563747D20656C656D656E740A202A2040706172616D207B6E756D6265727D205B6964785D0A202A2F0A66756E6374696F6E2061646428636F6C6C656374696F6E2C20656C656D656E742C2069647829207B0A0A20206966202821636F6C';
wwv_flow_imp.g_varchar2_table(4742) := '6C656374696F6E207C7C2021656C656D656E7429207B0A2020202072657475726E3B0A20207D0A0A202069662028747970656F662069647820213D3D20276E756D6265722729207B0A20202020696478203D202D313B0A20207D0A0A2020766172206375';
wwv_flow_imp.g_varchar2_table(4743) := '7272656E74496478203D20636F6C6C656374696F6E2E696E6465784F6628656C656D656E74293B0A0A20206966202863757272656E7449647820213D3D202D3129207B0A0A202020206966202863757272656E74496478203D3D3D2069647829207B0A0A';
wwv_flow_imp.g_varchar2_table(4744) := '2020202020202F2F206E6F7468696E6720746F20646F2C20706F736974696F6E20686173206E6F74206368616E6765640A20202020202072657475726E3B0A202020207D20656C7365207B0A0A2020202020206966202869647820213D3D202D3129207B';
wwv_flow_imp.g_varchar2_table(4745) := '0A0A20202020202020202F2F2072656D6F76652066726F6D2063757272656E7420706F736974696F6E0A2020202020202020636F6C6C656374696F6E2E73706C6963652863757272656E744964782C2031293B0A2020202020207D20656C7365207B0A0A';
wwv_flow_imp.g_varchar2_table(4746) := '20202020202020202F2F20616C72656164792065786973747320696E20636F6C6C656374696F6E0A202020202020202072657475726E3B0A2020202020207D0A202020207D0A20207D0A0A20206966202869647820213D3D202D3129207B0A0A20202020';
wwv_flow_imp.g_varchar2_table(4747) := '2F2F20696E736572742061742073706563696669656420706F736974696F6E0A20202020636F6C6C656374696F6E2E73706C696365286964782C20302C20656C656D656E74293B0A20207D20656C7365207B0A0A202020202F2F207075736820746F2065';
wwv_flow_imp.g_varchar2_table(4748) := '6E640A20202020636F6C6C656374696F6E2E7075736828656C656D656E74293B0A20207D0A7D0A0A0A2F2A2A0A202A204661696C2073617665206765742074686520696E646578206F6620616E20656C656D656E7420696E206120636F6C6C656374696F';
wwv_flow_imp.g_varchar2_table(4749) := '6E2E0A202A0A202A2040706172616D207B41727261793C4F626A6563743E7D20636F6C6C656374696F6E0A202A2040706172616D207B4F626A6563747D20656C656D656E740A202A0A202A204072657475726E207B6E756D6265727D2074686520696E64';
wwv_flow_imp.g_varchar2_table(4750) := '6578206F72202D3120696620636F6C6C656374696F6E206F7220656C656D656E7420646F0A202A2020202020202020202020202020202020206E6F74206578697374206F722074686520656C656D656E74206973206E6F7420636F6E7461696E65642E0A';
wwv_flow_imp.g_varchar2_table(4751) := '202A2F0A66756E6374696F6E20696E6465784F6628636F6C6C656374696F6E2C20656C656D656E7429207B0A0A20206966202821636F6C6C656374696F6E207C7C2021656C656D656E7429207B0A2020202072657475726E202D313B0A20207D0A0A2020';
wwv_flow_imp.g_varchar2_table(4752) := '72657475726E20636F6C6C656374696F6E2E696E6465784F6628656C656D656E74293B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F437572736F722E';
wwv_flow_imp.g_varchar2_table(4753) := '6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C6962';
wwv_flow_imp.g_varchar2_table(4754) := '2F7574696C2F437572736F722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061';
wwv_flow_imp.g_varchar2_table(4755) := '636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F';
wwv_flow_imp.g_varchar2_table(4756) := '293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020206861733A20282920';
wwv_flow_imp.g_varchar2_table(4757) := '3D3E20282F2A2062696E64696E67202A2F20686173292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207365743A202829203D3E20282F2A2062696E64696E67202A2F20736574292C0A2F2A206861726D6F6E79206578706F7274202A2F20';
wwv_flow_imp.g_varchar2_table(4758) := '2020756E7365743A202829203D3E20282F2A2062696E64696E67202A2F20756E736574290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F57454250';
wwv_flow_imp.g_varchar2_table(4759) := '41434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E';
wwv_flow_imp.g_varchar2_table(4760) := '6A7322293B0A0A0A76617220435552534F525F434C535F5041545445524E203D202F5E646A732D637572736F722D2E2A242F3B0A0A2F2A2A0A202A2040706172616D207B737472696E677D206D6F64650A202A2F0A66756E6374696F6E20736574286D6F';
wwv_flow_imp.g_varchar2_table(4761) := '646529207B0A202076617220636C6173736573203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E636C61737365732928646F63756D656E742E626F6479293B0A0A2020636C61737365732E7265';
wwv_flow_imp.g_varchar2_table(4762) := '6D6F76654D61746368696E6728435552534F525F434C535F5041545445524E293B0A0A2020696620286D6F646529207B0A20202020636C61737365732E6164642827646A732D637572736F722D27202B206D6F6465293B0A20207D0A7D0A0A66756E6374';
wwv_flow_imp.g_varchar2_table(4763) := '696F6E20756E7365742829207B0A2020736574286E756C6C293B0A7D0A0A2F2A2A0A202A2040706172616D207B737472696E677D206D6F64650A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E20686173286D';
wwv_flow_imp.g_varchar2_table(4764) := '6F646529207B0A202076617220636C6173736573203D2028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E636C61737365732928646F63756D656E742E626F6479293B0A0A202072657475726E20636C';
wwv_flow_imp.g_varchar2_table(4765) := '61737365732E6861732827646A732D637572736F722D27202B206D6F6465293B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F456C656D656E74732E6A';
wwv_flow_imp.g_varchar2_table(4766) := '73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69';
wwv_flow_imp.g_varchar2_table(4767) := '622F7574696C2F456C656D656E74732E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F';
wwv_flow_imp.g_varchar2_table(4768) := '7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F';
wwv_flow_imp.g_varchar2_table(4769) := '7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020616464';
wwv_flow_imp.g_varchar2_table(4770) := '3A202829203D3E20282F2A2062696E64696E67202A2F20616464292C0A2F2A206861726D6F6E79206578706F7274202A2F20202065616368456C656D656E743A202829203D3E20282F2A2062696E64696E67202A2F2065616368456C656D656E74292C0A';
wwv_flow_imp.g_varchar2_table(4771) := '2F2A206861726D6F6E79206578706F7274202A2F20202067657442426F783A202829203D3E20282F2A2062696E64696E67202A2F2067657442426F78292C0A2F2A206861726D6F6E79206578706F7274202A2F202020676574436C6F737572653A202829';
wwv_flow_imp.g_varchar2_table(4772) := '203D3E20282F2A2062696E64696E67202A2F20676574436C6F73757265292C0A2F2A206861726D6F6E79206578706F7274202A2F202020676574456E636C6F736564456C656D656E74733A202829203D3E20282F2A2062696E64696E67202A2F20676574';
wwv_flow_imp.g_varchar2_table(4773) := '456E636C6F736564456C656D656E7473292C0A2F2A206861726D6F6E79206578706F7274202A2F202020676574506172656E74733A202829203D3E20282F2A2062696E64696E67202A2F20676574506172656E7473292C0A2F2A206861726D6F6E792065';
wwv_flow_imp.g_varchar2_table(4774) := '78706F7274202A2F202020676574547970653A202829203D3E20282F2A2062696E64696E67202A2F2067657454797065292C0A2F2A206861726D6F6E79206578706F7274202A2F20202069734672616D65456C656D656E743A202829203D3E20282F2A20';
wwv_flow_imp.g_varchar2_table(4775) := '62696E64696E67202A2F2069734672616D65456C656D656E74292C0A2F2A206861726D6F6E79206578706F7274202A2F20202073656C66416E64416C6C4368696C6472656E3A202829203D3E20282F2A2062696E64696E67202A2F2073656C66416E6441';
wwv_flow_imp.g_varchar2_table(4776) := '6C6C4368696C6472656E292C0A2F2A206861726D6F6E79206578706F7274202A2F20202073656C66416E644368696C6472656E3A202829203D3E20282F2A2062696E64696E67202A2F2073656C66416E644368696C6472656E292C0A2F2A206861726D6F';
wwv_flow_imp.g_varchar2_table(4777) := '6E79206578706F7274202A2F20202073656C66416E644469726563744368696C6472656E3A202829203D3E20282F2A2062696E64696E67202A2F2073656C66416E644469726563744368696C6472656E290A2F2A206861726D6F6E79206578706F727420';
wwv_flow_imp.g_varchar2_table(4778) := '2A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D';
wwv_flow_imp.g_varchar2_table(4779) := '64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E436F';
wwv_flow_imp.g_varchar2_table(4780) := '6E6E656374696F6E7D20436F6E6E656374696F6E0A202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E740A202A204074797065646566207B696D706F727428272E2E2F';
wwv_flow_imp.g_varchar2_table(4781) := '6D6F64656C2F547970657327292E53686170657D2053686170650A202A0A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E526563747D20526563740A202A0A202A204074797065646566207B207B0A202A20';
wwv_flow_imp.g_varchar2_table(4782) := '2020616C6C5368617065733A205265636F72643C737472696E672C2053686170653E2C0A202A202020616C6C436F6E6E656374696F6E733A205265636F72643C737472696E672C20436F6E6E656374696F6E3E2C0A202A202020746F704C6576656C3A20';
wwv_flow_imp.g_varchar2_table(4783) := '5265636F72643C737472696E672C20456C656D656E743E2C0A202A202020656E636C6F736564436F6E6E656374696F6E733A205265636F72643C737472696E672C20436F6E6E656374696F6E3E2C0A202A202020656E636C6F736564456C656D656E7473';
wwv_flow_imp.g_varchar2_table(4784) := '3A205265636F72643C737472696E672C20456C656D656E743E0A202A207D207D20436C6F737572650A202A2F0A0A2F2A2A0A202A2047657420706172656E7420656C656D656E74732E0A202A0A202A2040706172616D207B456C656D656E745B5D7D2065';
wwv_flow_imp.g_varchar2_table(4785) := '6C656D656E74730A202A0A202A204072657475726E207B456C656D656E745B5D7D0A202A2F0A66756E6374696F6E20676574506172656E747328656C656D656E747329207B0A0A20202F2F2066696E6420656C656D656E7473207468617420617265206E';
wwv_flow_imp.g_varchar2_table(4786) := '6F74206368696C6472656E206F6620616E79206F7468657220656C656D656E74730A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E66696C7465722928656C656D656E7473';
wwv_flow_imp.g_varchar2_table(4787) := '2C2066756E6374696F6E28656C656D656E7429207B0A2020202072657475726E202128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E66696E642928656C656D656E74732C2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(4788) := '6529207B0A20202020202072657475726E206520213D3D20656C656D656E7420262620676574506172656E7428656C656D656E742C2065293B0A202020207D293B0A20207D293B0A7D0A0A0A66756E6374696F6E20676574506172656E7428656C656D65';
wwv_flow_imp.g_varchar2_table(4789) := '6E742C20706172656E7429207B0A20206966202821706172656E7429207B0A2020202072657475726E3B0A20207D0A0A202069662028656C656D656E74203D3D3D20706172656E7429207B0A2020202072657475726E20706172656E743B0A20207D0A0A';
wwv_flow_imp.g_varchar2_table(4790) := '20206966202821656C656D656E742E706172656E7429207B0A2020202072657475726E3B0A20207D0A0A202072657475726E20676574506172656E7428656C656D656E742E706172656E742C20706172656E74293B0A7D0A0A0A2F2A2A0A202A20416464';
wwv_flow_imp.g_varchar2_table(4791) := '7320616E20656C656D656E7420746F206120636F6C6C656374696F6E20616E642072657475726E732074727565206966207468650A202A20656C656D656E74207761732061646465642E0A202A0A202A2040706172616D207B4F626A6563745B5D7D2065';
wwv_flow_imp.g_varchar2_table(4792) := '6C656D656E74730A202A2040706172616D207B4F626A6563747D20656C656D656E740A202A2040706172616D207B626F6F6C65616E7D205B756E697175655D0A202A2F0A66756E6374696F6E2061646428656C656D656E74732C20656C656D656E742C20';
wwv_flow_imp.g_varchar2_table(4793) := '756E6971756529207B0A20207661722063616E416464203D2021756E69717565207C7C20656C656D656E74732E696E6465784F6628656C656D656E7429203D3D3D202D313B0A0A20206966202863616E41646429207B0A20202020656C656D656E74732E';
wwv_flow_imp.g_varchar2_table(4794) := '7075736828656C656D656E74293B0A20207D0A0A202072657475726E2063616E4164643B0A7D0A0A0A2F2A2A0A202A2049746572617465206F766572206561636820656C656D656E7420696E206120636F6C6C656374696F6E2C2063616C6C696E672074';
wwv_flow_imp.g_varchar2_table(4795) := '6865206974657261746F722066756E6374696F6E2060666E600A202A20776974682028656C656D656E742C20696E6465782C20726563757273696F6E4465707468292E0A202A0A202A205265637572736520696E746F20616C6C20656C656D656E747320';
wwv_flow_imp.g_varchar2_table(4796) := '74686174206172652072657475726E65642062792060666E602E0A202A0A202A2040706172616D207B456C656D656E747C456C656D656E745B5D7D20656C656D656E74730A202A2040706172616D207B28656C656D656E743A20456C656D656E742C2069';
wwv_flow_imp.g_varchar2_table(4797) := '6E6465783A206E756D6265722C2064657074683A206E756D62657229203D3E20456C656D656E745B5D207C20626F6F6C65616E207C20756E646566696E65647D20666E0A202A2040706172616D207B6E756D6265727D205B64657074685D206D6178696D';
wwv_flow_imp.g_varchar2_table(4798) := '756D20726563757273696F6E2064657074680A202A2F0A66756E6374696F6E2065616368456C656D656E7428656C656D656E74732C20666E2C20646570746829207B0A0A20206465707468203D206465707468207C7C20303B0A0A202069662028212830';
wwv_flow_imp.g_varchar2_table(4799) := '2C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E697341727261792928656C656D656E74732929207B0A20202020656C656D656E7473203D205B20656C656D656E7473205D3B0A20207D0A0A202028302C';
wwv_flow_imp.g_varchar2_table(4800) := '6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F72456163682928656C656D656E74732C2066756E6374696F6E28732C206929207B0A202020207661722066696C746572203D20666E28732C20692C20';
wwv_flow_imp.g_varchar2_table(4801) := '6465707468293B0A0A202020206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734172726179292866696C746572292026262066696C7465722E6C656E67746829207B0A2020202020';
wwv_flow_imp.g_varchar2_table(4802) := '2065616368456C656D656E742866696C7465722C20666E2C206465707468202B2031293B0A202020207D0A20207D293B0A7D0A0A0A2F2A2A0A202A20436F6C6C656374732073656C66202B206368696C6420656C656D656E747320757020746F20612067';
wwv_flow_imp.g_varchar2_table(4803) := '6976656E2064657074682066726F6D2061206C697374206F6620656C656D656E74732E0A202A0A202A2040706172616D207B456C656D656E747C456C656D656E745B5D7D20656C656D656E74732074686520656C656D656E747320746F2073656C656374';
wwv_flow_imp.g_varchar2_table(4804) := '20746865206368696C6472656E2066726F6D0A202A2040706172616D207B626F6F6C65616E7D20756E69717565207768657468657220746F2072657475726E206120756E6971756520726573756C742073657420286E6F206475706C696361746573290A';
wwv_flow_imp.g_varchar2_table(4805) := '202A2040706172616D207B6E756D6265727D206D617844657074682074686520646570746820746F20736561726368207468726F756768206F72202D3120666F7220696E66696E6974650A202A0A202A204072657475726E207B456C656D656E745B5D7D';
wwv_flow_imp.g_varchar2_table(4806) := '20666F756E6420656C656D656E74730A202A2F0A66756E6374696F6E2073656C66416E644368696C6472656E28656C656D656E74732C20756E697175652C206D6178446570746829207B0A202076617220726573756C74203D205B5D2C0A202020202020';
wwv_flow_imp.g_varchar2_table(4807) := '70726F6365737365644368696C6472656E203D205B5D3B0A0A202065616368456C656D656E7428656C656D656E74732C2066756E6374696F6E28656C656D656E742C20692C20646570746829207B0A2020202061646428726573756C742C20656C656D65';
wwv_flow_imp.g_varchar2_table(4808) := '6E742C20756E69717565293B0A0A20202020766172206368696C6472656E203D20656C656D656E742E6368696C6472656E3B0A0A202020202F2F206D61782074726176657273616C206465707468206E6F742072656163686564207965740A2020202069';
wwv_flow_imp.g_varchar2_table(4809) := '6620286D61784465707468203D3D3D202D31207C7C206465707468203C206D6178446570746829207B0A0A2020202020202F2F206368696C6472656E206578697374202626206368696C6472656E206E6F74207965742070726F6365737365640A202020';
wwv_flow_imp.g_varchar2_table(4810) := '202020696620286368696C6472656E202626206164642870726F6365737365644368696C6472656E2C206368696C6472656E2C20756E697175652929207B0A202020202020202072657475726E206368696C6472656E3B0A2020202020207D0A20202020';
wwv_flow_imp.g_varchar2_table(4811) := '7D0A20207D293B0A0A202072657475726E20726573756C743B0A7D0A0A2F2A2A0A202A2052657475726E2073656C66202B20646972656374206368696C6472656E20666F722061206E756D626572206F6620656C656D656E74730A202A0A202A20407061';
wwv_flow_imp.g_varchar2_table(4812) := '72616D207B456C656D656E745B5D7D20656C656D656E747320746F2071756572790A202A2040706172616D207B626F6F6C65616E7D205B616C6C6F774475706C6963617465735D20746F20616C6C6F77206475706C69636174657320696E207468652072';
wwv_flow_imp.g_varchar2_table(4813) := '6573756C74207365740A202A0A202A204072657475726E207B456C656D656E745B5D7D2074686520636F6C6C656374656420656C656D656E74730A202A2F0A66756E6374696F6E2073656C66416E644469726563744368696C6472656E28656C656D656E';
wwv_flow_imp.g_varchar2_table(4814) := '74732C20616C6C6F774475706C69636174657329207B0A202072657475726E2073656C66416E644368696C6472656E28656C656D656E74732C2021616C6C6F774475706C6963617465732C2031293B0A7D0A0A0A2F2A2A0A202A2052657475726E207365';
wwv_flow_imp.g_varchar2_table(4815) := '6C66202B20414C4C206368696C6472656E20666F722061206E756D626572206F6620656C656D656E74730A202A0A202A2040706172616D207B456C656D656E745B5D7D20656C656D656E747320746F2071756572790A202A2040706172616D207B626F6F';
wwv_flow_imp.g_varchar2_table(4816) := '6C65616E7D205B616C6C6F774475706C6963617465735D20746F20616C6C6F77206475706C69636174657320696E2074686520726573756C74207365740A202A0A202A204072657475726E207B456C656D656E745B5D7D2074686520636F6C6C65637465';
wwv_flow_imp.g_varchar2_table(4817) := '6420656C656D656E74730A202A2F0A66756E6374696F6E2073656C66416E64416C6C4368696C6472656E28656C656D656E74732C20616C6C6F774475706C69636174657329207B0A202072657475726E2073656C66416E644368696C6472656E28656C65';
wwv_flow_imp.g_varchar2_table(4818) := '6D656E74732C2021616C6C6F774475706C6963617465732C202D31293B0A7D0A0A0A2F2A2A0A202A2047657473207468652074686520636C6F7375726520666F7220616C6C2073656C656374656420656C656D656E74732C0A202A20746865697220656E';
wwv_flow_imp.g_varchar2_table(4819) := '636C6F736564206368696C6472656E20616E6420636F6E6E656374696F6E732E0A202A0A202A2040706172616D207B456C656D656E745B5D7D20656C656D656E74730A202A2040706172616D207B626F6F6C65616E7D205B6973546F704C6576656C3D74';
wwv_flow_imp.g_varchar2_table(4820) := '7275655D0A202A2040706172616D207B436C6F737572657D205B636C6F737572655D0A202A0A202A204072657475726E207B436C6F737572657D206E6577436C6F737572650A202A2F0A66756E6374696F6E20676574436C6F7375726528656C656D656E';
wwv_flow_imp.g_varchar2_table(4821) := '74732C206973546F704C6576656C2C20636C6F7375726529207B0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6973556E646566696E656429286973546F704C6576656C2929';
wwv_flow_imp.g_varchar2_table(4822) := '207B0A202020206973546F704C6576656C203D20747275653B0A20207D0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734F626A65637429286973546F704C6576656C2929';
wwv_flow_imp.g_varchar2_table(4823) := '207B0A20202020636C6F73757265203D206973546F704C6576656C3B0A202020206973546F704C6576656C203D20747275653B0A20207D0A0A0A2020636C6F73757265203D20636C6F73757265207C7C207B7D3B0A0A202076617220616C6C5368617065';
wwv_flow_imp.g_varchar2_table(4824) := '73203D20636F70794F626A65637428636C6F737572652E616C6C536861706573292C0A202020202020616C6C436F6E6E656374696F6E73203D20636F70794F626A65637428636C6F737572652E616C6C436F6E6E656374696F6E73292C0A202020202020';
wwv_flow_imp.g_varchar2_table(4825) := '656E636C6F736564456C656D656E7473203D20636F70794F626A65637428636C6F737572652E656E636C6F736564456C656D656E7473292C0A202020202020656E636C6F736564436F6E6E656374696F6E73203D20636F70794F626A65637428636C6F73';
wwv_flow_imp.g_varchar2_table(4826) := '7572652E656E636C6F736564436F6E6E656374696F6E73293B0A0A202076617220746F704C6576656C203D20636F70794F626A656374280A20202020636C6F737572652E746F704C6576656C2C0A202020206973546F704C6576656C2026262028302C6D';
wwv_flow_imp.g_varchar2_table(4827) := '696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E67726F757042792928656C656D656E74732C2066756E6374696F6E286529207B2072657475726E20652E69643B207D290A2020293B0A0A0A202066756E6374';
wwv_flow_imp.g_varchar2_table(4828) := '696F6E2068616E646C65436F6E6E656374696F6E286329207B0A2020202069662028746F704C6576656C5B632E736F757263652E69645D20262620746F704C6576656C5B632E7461726765742E69645D29207B0A202020202020746F704C6576656C5B63';
wwv_flow_imp.g_varchar2_table(4829) := '2E69645D203D205B2063205D3B0A202020207D0A0A202020202F2F206E6F7420656E636C6F7365642061732061206368696C642C20627574206D61796265206C6F676963616C6C790A202020202F2F2028636F6E6E656374696E672074776F206D6F7665';
wwv_flow_imp.g_varchar2_table(4830) := '6420656C656D656E74733F290A2020202069662028616C6C5368617065735B632E736F757263652E69645D20262620616C6C5368617065735B632E7461726765742E69645D29207B0A202020202020656E636C6F736564436F6E6E656374696F6E735B63';
wwv_flow_imp.g_varchar2_table(4831) := '2E69645D203D20656E636C6F736564456C656D656E74735B632E69645D203D20633B0A202020207D0A0A20202020616C6C436F6E6E656374696F6E735B632E69645D203D20633B0A20207D0A0A202066756E6374696F6E2068616E646C65456C656D656E';
wwv_flow_imp.g_varchar2_table(4832) := '7428656C656D656E7429207B0A0A20202020656E636C6F736564456C656D656E74735B656C656D656E742E69645D203D20656C656D656E743B0A0A2020202069662028656C656D656E742E776179706F696E747329207B0A0A2020202020202F2F207265';
wwv_flow_imp.g_varchar2_table(4833) := '6D656D62657220636F6E6E656374696F6E0A202020202020656E636C6F736564436F6E6E656374696F6E735B656C656D656E742E69645D203D20616C6C436F6E6E656374696F6E735B656C656D656E742E69645D203D20656C656D656E743B0A20202020';
wwv_flow_imp.g_varchar2_table(4834) := '7D20656C7365207B0A0A2020202020202F2F2072656D656D6265722073686170650A202020202020616C6C5368617065735B656C656D656E742E69645D203D20656C656D656E743B0A0A2020202020202F2F2072656D656D62657220616C6C20636F6E6E';
wwv_flow_imp.g_varchar2_table(4835) := '656374696F6E730A20202020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F72456163682928656C656D656E742E696E636F6D696E672C2068616E646C65436F6E6E656374696F6E293B';
wwv_flow_imp.g_varchar2_table(4836) := '0A0A20202020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F72456163682928656C656D656E742E6F7574676F696E672C2068616E646C65436F6E6E656374696F6E293B0A0A20202020';
wwv_flow_imp.g_varchar2_table(4837) := '20202F2F207265637572736520696E746F206368696C6472656E0A20202020202072657475726E20656C656D656E742E6368696C6472656E3B0A202020207D0A20207D0A0A202065616368456C656D656E7428656C656D656E74732C2068616E646C6545';
wwv_flow_imp.g_varchar2_table(4838) := '6C656D656E74293B0A0A202072657475726E207B0A20202020616C6C5368617065733A20616C6C5368617065732C0A20202020616C6C436F6E6E656374696F6E733A20616C6C436F6E6E656374696F6E732C0A20202020746F704C6576656C3A20746F70';
wwv_flow_imp.g_varchar2_table(4839) := '4C6576656C2C0A20202020656E636C6F736564436F6E6E656374696F6E733A20656E636C6F736564436F6E6E656374696F6E732C0A20202020656E636C6F736564456C656D656E74733A20656E636C6F736564456C656D656E74730A20207D3B0A7D0A0A';
wwv_flow_imp.g_varchar2_table(4840) := '2F2A2A0A202A2052657475726E732074686520737572726F756E64696E672062626F7820666F7220616C6C20656C656D656E747320696E0A202A20746865206172726179206F722074686520656C656D656E74207072696D69746976652E0A202A0A202A';
wwv_flow_imp.g_varchar2_table(4841) := '2040706172616D207B456C656D656E747C456C656D656E745B5D7D20656C656D656E74730A202A2040706172616D207B626F6F6C65616E7D205B73746F70526563757273696F6E3D66616C73655D0A202A0A202A204072657475726E207B526563747D0A';
wwv_flow_imp.g_varchar2_table(4842) := '202A2F0A66756E6374696F6E2067657442426F7828656C656D656E74732C2073746F70526563757273696F6E29207B0A0A202073746F70526563757273696F6E203D20212173746F70526563757273696F6E3B0A2020696620282128302C6D696E5F6461';
wwv_flow_imp.g_varchar2_table(4843) := '73685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E697341727261792928656C656D656E74732929207B0A20202020656C656D656E7473203D205B20656C656D656E7473205D3B0A20207D0A0A2020766172206D696E582C0A';
wwv_flow_imp.g_varchar2_table(4844) := '2020202020206D696E592C0A2020202020206D6178582C0A2020202020206D6178593B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F72456163682928656C656D656E74732C2066';
wwv_flow_imp.g_varchar2_table(4845) := '756E6374696F6E28656C656D656E7429207B0A0A202020202F2F20496620656C656D656E74206973206120636F6E6E656374696F6E207468652062626F78206D75737420626520636F6D70757465642066697273740A202020207661722062626F78203D';
wwv_flow_imp.g_varchar2_table(4846) := '20656C656D656E743B0A2020202069662028656C656D656E742E776179706F696E7473202626202173746F70526563757273696F6E29207B0A20202020202062626F78203D2067657442426F7828656C656D656E742E776179706F696E74732C20747275';
wwv_flow_imp.g_varchar2_table(4847) := '65293B0A202020207D0A0A202020207661722078203D2062626F782E782C0A202020202020202079203D2062626F782E792C0A2020202020202020686569676874203D2062626F782E686569676874207C7C20302C0A2020202020202020776964746820';
wwv_flow_imp.g_varchar2_table(4848) := '3D2062626F782E7769647468207C7C20303B0A0A202020206966202878203C206D696E58207C7C206D696E58203D3D3D20756E646566696E656429207B0A2020202020206D696E58203D20783B0A202020207D0A202020206966202879203C206D696E59';
wwv_flow_imp.g_varchar2_table(4849) := '207C7C206D696E59203D3D3D20756E646566696E656429207B0A2020202020206D696E59203D20793B0A202020207D0A0A20202020696620282878202B20776964746829203E206D617858207C7C206D617858203D3D3D20756E646566696E656429207B';
wwv_flow_imp.g_varchar2_table(4850) := '0A2020202020206D617858203D2078202B2077696474683B0A202020207D0A20202020696620282879202B2068656967687429203E206D617859207C7C206D617859203D3D3D20756E646566696E656429207B0A2020202020206D617859203D2079202B';
wwv_flow_imp.g_varchar2_table(4851) := '206865696768743B0A202020207D0A20207D293B0A0A202072657475726E207B0A20202020783A206D696E582C0A20202020793A206D696E592C0A202020206865696768743A206D617859202D206D696E592C0A2020202077696474683A206D61785820';
wwv_flow_imp.g_varchar2_table(4852) := '2D206D696E580A20207D3B0A7D0A0A0A2F2A2A0A202A2052657475726E7320616C6C20656C656D656E747320746861742061726520656E636C6F7365642066726F6D2074686520626F756E64696E6720626F782E0A202A0A202A2020202A204966206262';
wwv_flow_imp.g_varchar2_table(4853) := '6F782E2877696474687C68656967687429206973206E6F742073706563696669656420746865206D6574686F642072657475726E730A202A2020202020616C6C20656C656D656E7473207769746820656C656D656E742E782F79203E2062626F782E782F';
wwv_flow_imp.g_varchar2_table(4854) := '790A202A2020202A204966206F6E6C792062626F782E78206F722062626F782E79206973207370656369666965642C206D6574686F642072657475726E20616C6C20656C656D656E747320776974680A202A2020202020652E78203E2062626F782E7820';
wwv_flow_imp.g_varchar2_table(4855) := '6F7220652E79203E2062626F782E790A202A0A202A2040706172616D207B456C656D656E745B5D7D20656C656D656E7473204C697374206F6620456C656D656E747320746F20736561726368207468726F7567680A202A2040706172616D207B52656374';
wwv_flow_imp.g_varchar2_table(4856) := '7D2062626F782074686520656E636C6F73696E672062626F782E0A202A0A202A204072657475726E207B456C656D656E745B5D7D20656E636C6F73656420656C656D656E74730A202A2F0A66756E6374696F6E20676574456E636C6F736564456C656D65';
wwv_flow_imp.g_varchar2_table(4857) := '6E747328656C656D656E74732C2062626F7829207B0A0A20207661722066696C7465726564456C656D656E7473203D207B7D3B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F7245';
wwv_flow_imp.g_varchar2_table(4858) := '6163682928656C656D656E74732C2066756E6374696F6E28656C656D656E7429207B0A0A202020207661722065203D20656C656D656E743B0A0A2020202069662028652E776179706F696E747329207B0A20202020202065203D2067657442426F782865';
wwv_flow_imp.g_varchar2_table(4859) := '293B0A202020207D0A0A20202020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734E756D626572292862626F782E79292026262028652E78203E2062626F782E782929207B0A20';
wwv_flow_imp.g_varchar2_table(4860) := '202020202066696C7465726564456C656D656E74735B656C656D656E742E69645D203D20656C656D656E743B0A202020207D0A20202020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F';
wwv_flow_imp.g_varchar2_table(4861) := '2E69734E756D626572292862626F782E78292026262028652E79203E2062626F782E792929207B0A20202020202066696C7465726564456C656D656E74735B656C656D656E742E69645D203D20656C656D656E743B0A202020207D0A2020202069662028';
wwv_flow_imp.g_varchar2_table(4862) := '652E78203E2062626F782E7820262620652E79203E2062626F782E7929207B0A2020202020206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734E756D626572292862626F782E7769';
wwv_flow_imp.g_varchar2_table(4863) := '647468292026262028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734E756D626572292862626F782E686569676874292026260A20202020202020202020652E7769647468202B20652E78203C';
wwv_flow_imp.g_varchar2_table(4864) := '2062626F782E7769647468202B2062626F782E782026260A20202020202020202020652E686569676874202B20652E79203C2062626F782E686569676874202B2062626F782E7929207B0A0A202020202020202066696C7465726564456C656D656E7473';
wwv_flow_imp.g_varchar2_table(4865) := '5B656C656D656E742E69645D203D20656C656D656E743B0A2020202020207D20656C736520696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734E756D626572292862626F782E7769';
wwv_flow_imp.g_varchar2_table(4866) := '64746829207C7C202128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734E756D626572292862626F782E6865696768742929207B0A202020202020202066696C7465726564456C656D656E7473';
wwv_flow_imp.g_varchar2_table(4867) := '5B656C656D656E742E69645D203D20656C656D656E743B0A2020202020207D0A202020207D0A20207D293B0A0A202072657475726E2066696C7465726564456C656D656E74733B0A7D0A0A2F2A2A0A202A204765742074686520656C656D656E74277320';
wwv_flow_imp.g_varchar2_table(4868) := '747970650A202A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B27636F6E6E656374696F6E27207C2027736861706527207C2027726F6F74277D0A202A2F0A66756E6374696F6E20676574';
wwv_flow_imp.g_varchar2_table(4869) := '5479706528656C656D656E7429207B0A0A20206966202827776179706F696E74732720696E20656C656D656E7429207B0A2020202072657475726E2027636F6E6E656374696F6E273B0A20207D0A0A20206966202827782720696E20656C656D656E7429';
wwv_flow_imp.g_varchar2_table(4870) := '207B0A2020202072657475726E20277368617065273B0A20207D0A0A202072657475726E2027726F6F74273B0A7D0A0A2F2A2A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E207B626F6F6C65';
wwv_flow_imp.g_varchar2_table(4871) := '616E7D0A202A2F0A66756E6374696F6E2069734672616D65456C656D656E7428656C656D656E7429207B0A202072657475726E20212128656C656D656E7420262620656C656D656E742E69734672616D65293B0A7D0A0A2F2F2068656C70657273202F2F';
wwv_flow_imp.g_varchar2_table(4872) := '2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A66756E6374696F6E20636F70794F626A65637428737263312C207372633229207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F52';
wwv_flow_imp.g_varchar2_table(4873) := '5445445F4D4F44554C455F305F5F2E61737369676E29287B7D2C2073726331207C7C207B7D2C2073726332207C7C207B7D293B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F';
wwv_flow_imp.g_varchar2_table(4874) := '6C69622F7574696C2F4573636170655574696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64';
wwv_flow_imp.g_varchar2_table(4875) := '655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4573636170655574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4876) := '2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(4877) := '5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B';
wwv_flow_imp.g_varchar2_table(4878) := '0A2F2A206861726D6F6E79206578706F7274202A2F2020206573636170654353533A202829203D3E20282F2A2062696E64696E67202A2F20657363617065435353292C0A2F2A206861726D6F6E79206578706F7274202A2F20202065736361706548544D';
wwv_flow_imp.g_varchar2_table(4879) := '4C3A202829203D3E20282F2A2062696E64696E67202A2F2065736361706548544D4C290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2A0A202A2040706172616D207B737472696E677D207374720A202A0A202A20407265747572';
wwv_flow_imp.g_varchar2_table(4880) := '6E207B737472696E677D0A202A2F0A66756E6374696F6E206573636170654353532873747229207B0A202072657475726E204353532E65736361706528737472293B0A7D0A0A7661722048544D4C5F4553434150455F4D4150203D207B0A20202726273A';
wwv_flow_imp.g_varchar2_table(4881) := '202726616D703B272C0A2020273C273A2027266C743B272C0A2020273E273A20272667743B272C0A20202722273A20272671756F743B272C0A2020275C27273A2027262333393B270A7D3B0A0A2F2A2A0A202A2040706172616D207B737472696E677D20';
wwv_flow_imp.g_varchar2_table(4882) := '7374720A202A0A202A204072657475726E207B737472696E677D0A202A2F0A66756E6374696F6E2065736361706548544D4C2873747229207B0A2020737472203D202727202B207374723B0A0A202072657475726E20737472202626207374722E726570';
wwv_flow_imp.g_varchar2_table(4883) := '6C616365282F5B263C3E22275D2F672C2066756E6374696F6E286D6174636829207B0A2020202072657475726E2048544D4C5F4553434150455F4D41505B6D617463685D3B0A20207D293B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F';
wwv_flow_imp.g_varchar2_table(4884) := '6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4576656E742E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A';
wwv_flow_imp.g_varchar2_table(4885) := '5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4576656E742E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4886) := '2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F776562';
wwv_flow_imp.g_varchar2_table(4887) := '7061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F';
wwv_flow_imp.g_varchar2_table(4888) := '5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020206765744F726967696E616C3A202829203D3E20282F2A2062696E64696E67202A2F206765744F726967696E616C292C0A2F2A206861726D6F6E79206578706F7274202A2F20202073';
wwv_flow_imp.g_varchar2_table(4889) := '746F7050726F7061676174696F6E3A202829203D3E20282F2A2062696E64696E67202A2F2073746F7050726F7061676174696F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F202020746F506F696E743A202829203D3E20282F2A2062696E';
wwv_flow_imp.g_varchar2_table(4890) := '64696E67202A2F20746F506F696E74290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F696E740A202A2F0A';
wwv_flow_imp.g_varchar2_table(4891) := '0A66756E6374696F6E205F5F73746F7050726F7061676174696F6E286576656E7429207B0A202069662028216576656E74207C7C20747970656F66206576656E742E73746F7050726F7061676174696F6E20213D3D202766756E6374696F6E2729207B0A';
wwv_flow_imp.g_varchar2_table(4892) := '2020202072657475726E3B0A20207D0A0A20206576656E742E73746F7050726F7061676174696F6E28293B0A7D0A0A2F2A2A0A202A2040706172616D207B696D706F727428272E2E2F636F72652F4576656E7442757327292E4576656E747D206576656E';
wwv_flow_imp.g_varchar2_table(4893) := '740A202A0A202A204072657475726E207B4576656E747D0A202A2F0A66756E6374696F6E206765744F726967696E616C286576656E7429207B0A202072657475726E206576656E742E6F726967696E616C4576656E74207C7C206576656E742E73726345';
wwv_flow_imp.g_varchar2_table(4894) := '76656E743B0A7D0A0A2F2A2A0A202A2040706172616D207B4576656E747C696D706F727428272E2E2F636F72652F4576656E7442757327292E4576656E747D206576656E740A202A2F0A66756E6374696F6E2073746F7050726F7061676174696F6E2865';
wwv_flow_imp.g_varchar2_table(4895) := '76656E7429207B0A20205F5F73746F7050726F7061676174696F6E286576656E74293B0A20205F5F73746F7050726F7061676174696F6E286765744F726967696E616C286576656E7429293B0A7D0A0A2F2A2A0A202A2040706172616D207B4576656E74';
wwv_flow_imp.g_varchar2_table(4896) := '7D206576656E740A202A0A202A204072657475726E207B506F696E747C6E756C6C7D0A202A2F0A66756E6374696F6E20746F506F696E74286576656E7429207B0A0A2020696620286576656E742E706F696E74657273202626206576656E742E706F696E';
wwv_flow_imp.g_varchar2_table(4897) := '746572732E6C656E67746829207B0A202020206576656E74203D206576656E742E706F696E746572735B305D3B0A20207D0A0A2020696620286576656E742E746F7563686573202626206576656E742E746F75636865732E6C656E67746829207B0A2020';
wwv_flow_imp.g_varchar2_table(4898) := '20206576656E74203D206576656E742E746F75636865735B305D3B0A20207D0A0A202072657475726E206576656E74203F207B0A20202020783A206576656E742E636C69656E74582C0A20202020793A206576656E742E636C69656E74590A20207D203A';
wwv_flow_imp.g_varchar2_table(4899) := '206E756C6C3B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F47656F6D657472792E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4900) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F47656F6D657472792E6A73202A2A2A210A20205C';
wwv_flow_imp.g_varchar2_table(4901) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F65';
wwv_flow_imp.g_varchar2_table(4902) := '78706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A';
wwv_flow_imp.g_varchar2_table(4903) := '2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020206765744D6964506F696E743A202829203D3E20282F2A2062696E64696E67';
wwv_flow_imp.g_varchar2_table(4904) := '202A2F206765744D6964506F696E74292C0A2F2A206861726D6F6E79206578706F7274202A2F202020706F696E7444697374616E63653A202829203D3E20282F2A2062696E64696E67202A2F20706F696E7444697374616E6365292C0A2F2A206861726D';
wwv_flow_imp.g_varchar2_table(4905) := '6F6E79206578706F7274202A2F202020706F696E74496E526563743A202829203D3E20282F2A2062696E64696E67202A2F20706F696E74496E52656374292C0A2F2A206861726D6F6E79206578706F7274202A2F202020706F696E7473416C69676E6564';
wwv_flow_imp.g_varchar2_table(4906) := '3A202829203D3E20282F2A2062696E64696E67202A2F20706F696E7473416C69676E6564292C0A2F2A206861726D6F6E79206578706F7274202A2F202020706F696E7473416C69676E65644F6E417869733A202829203D3E20282F2A2062696E64696E67';
wwv_flow_imp.g_varchar2_table(4907) := '202A2F20706F696E7473416C69676E65644F6E41786973292C0A2F2A206861726D6F6E79206578706F7274202A2F202020706F696E74734F6E4C696E653A202829203D3E20282F2A2062696E64696E67202A2F20706F696E74734F6E4C696E65290A2F2A';
wwv_flow_imp.g_varchar2_table(4908) := '206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F7265';
wwv_flow_imp.g_varchar2_table(4909) := '71756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F';
wwv_flow_imp.g_varchar2_table(4910) := '7574696C2F547970657327292E417869737D20417869730A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F696E740A202A204074797065646566207B696D706F727428272E2E2F7574';
wwv_flow_imp.g_varchar2_table(4911) := '696C2F547970657327292E526563747D20526563740A202A2F0A0A2F2A2A0A202A20436F6D7075746573207468652064697374616E6365206265747765656E2074776F20706F696E74732E0A202A0A202A2040706172616D207B506F696E747D20610A20';
wwv_flow_imp.g_varchar2_table(4912) := '2A2040706172616D207B506F696E747D20620A202A0A202A204072657475726E207B6E756D6265727D205468652064697374616E6365206265747765656E207468652074776F20706F696E74732E0A202A2F0A66756E6374696F6E20706F696E74446973';
wwv_flow_imp.g_varchar2_table(4913) := '74616E636528612C206229207B0A2020696620282161207C7C20216229207B0A2020202072657475726E202D313B0A20207D0A0A202072657475726E204D6174682E73717274280A202020204D6174682E706F7728612E78202D20622E782C203229202B';
wwv_flow_imp.g_varchar2_table(4914) := '0A202020204D6174682E706F7728612E79202D20622E792C2032290A2020293B0A7D0A0A0A2F2A2A0A202A2052657475726E7320747275652069662074686520706F696E742072206973206F6E20746865206C696E65206265747765656E207020616E64';
wwv_flow_imp.g_varchar2_table(4915) := '20712E0A202A0A202A2040706172616D207B506F696E747D20700A202A2040706172616D207B506F696E747D20710A202A2040706172616D207B506F696E747D20720A202A2040706172616D207B6E756D6265727D205B61636375726163793D355D2054';
wwv_flow_imp.g_varchar2_table(4916) := '6865206163637572616379207769746820776869636820746F20636865636B20286C6F77657220697320626574746572292E0A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E20706F696E74734F6E4C696E65';
wwv_flow_imp.g_varchar2_table(4917) := '28702C20712C20722C20616363757261637929207B0A0A202069662028747970656F66206163637572616379203D3D3D2027756E646566696E65642729207B0A202020206163637572616379203D20353B0A20207D0A0A2020696620282170207C7C2021';
wwv_flow_imp.g_varchar2_table(4918) := '71207C7C20217229207B0A2020202072657475726E2066616C73653B0A20207D0A0A20207661722076616C203D2028712E78202D20702E7829202A2028722E79202D20702E7929202D2028712E79202D20702E7929202A2028722E78202D20702E78292C';
wwv_flow_imp.g_varchar2_table(4919) := '0A20202020202064697374203D20706F696E7444697374616E636528702C2071293B0A0A20202F2F204073656520687474703A2F2F737461636B6F766572666C6F772E636F6D2F612F3930373439312F3431323139300A202072657475726E204D617468';
wwv_flow_imp.g_varchar2_table(4920) := '2E6162732876616C202F206469737429203C3D2061636375726163793B0A7D0A0A0A76617220414C49474E45445F5448524553484F4C44203D20323B0A0A2F2A2A0A202A20436865636B20776865746865722074776F20706F696E74732061726520686F';
wwv_flow_imp.g_varchar2_table(4921) := '72697A6F6E74616C6C79206F7220766572746963616C6C7920616C69676E65642E0A202A0A202A2040706172616D207B506F696E745B5D7C506F696E747D20610A202A2040706172616D207B506F696E747D205B625D0A202A0A202A204072657475726E';
wwv_flow_imp.g_varchar2_table(4922) := '207B737472696E677C626F6F6C65616E7D20496620616E6420686F77207468652074776F20706F696E74732061726520616C69676E656420282768272C20277627206F72206066616C736560292E0A202A2F0A66756E6374696F6E20706F696E7473416C';
wwv_flow_imp.g_varchar2_table(4923) := '69676E656428612C206229207B0A202076617220706F696E7473203D2041727261792E66726F6D28617267756D656E7473292E666C617428293B0A0A2020636F6E737420617869734D6170203D207B0A202020202778273A202776272C0A202020202779';
wwv_flow_imp.g_varchar2_table(4924) := '273A202768270A20207D3B0A0A2020666F722028636F6E7374205B20617869732C206F7269656E746174696F6E205D206F66204F626A6563742E656E747269657328617869734D61702929207B0A2020202069662028706F696E7473416C69676E65644F';
wwv_flow_imp.g_varchar2_table(4925) := '6E4178697328617869732C20706F696E74732929207B0A20202020202072657475726E206F7269656E746174696F6E3B0A202020207D0A20207D0A0A202072657475726E2066616C73653B0A7D0A0A2F2A2A0A202A2040706172616D207B417869737D20';
wwv_flow_imp.g_varchar2_table(4926) := '617869730A202A2040706172616D207B506F696E745B5D7D20706F696E74730A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E20706F696E7473416C69676E65644F6E4178697328617869732C20706F696E74';
wwv_flow_imp.g_varchar2_table(4927) := '7329207B0A2020636F6E7374207265666572656E6365506F696E74203D20706F696E74735B305D3B0A0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6576657279292870';
wwv_flow_imp.g_varchar2_table(4928) := '6F696E74732C2066756E6374696F6E28706F696E7429207B0A2020202072657475726E204D6174682E616273287265666572656E6365506F696E745B617869735D202D20706F696E745B617869735D29203C3D20414C49474E45445F5448524553484F4C';
wwv_flow_imp.g_varchar2_table(4929) := '443B0A20207D293B0A7D0A0A2F2A2A0A202A2052657475726E7320747275652069662074686520706F696E74207020697320696E73696465207468652072656374616E676C6520726563740A202A0A202A2040706172616D207B506F696E747D20700A20';
wwv_flow_imp.g_varchar2_table(4930) := '2A2040706172616D207B526563747D20726563740A202A2040706172616D207B6E756D6265727D20746F6C6572616E63650A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E20706F696E74496E526563742870';
wwv_flow_imp.g_varchar2_table(4931) := '2C20726563742C20746F6C6572616E636529207B0A2020746F6C6572616E6365203D20746F6C6572616E6365207C7C20303B0A0A202072657475726E20702E78203E20726563742E78202D20746F6C6572616E63652026260A202020202020202020702E';
wwv_flow_imp.g_varchar2_table(4932) := '79203E20726563742E79202D20746F6C6572616E63652026260A202020202020202020702E78203C20726563742E78202B20726563742E7769647468202B20746F6C6572616E63652026260A202020202020202020702E79203C20726563742E79202B20';
wwv_flow_imp.g_varchar2_table(4933) := '726563742E686569676874202B20746F6C6572616E63653B0A7D0A0A2F2A2A0A202A2052657475726E73206120706F696E7420696E20746865206D6964646C65206F6620706F696E7473207020616E6420710A202A0A202A2040706172616D207B506F69';
wwv_flow_imp.g_varchar2_table(4934) := '6E747D20700A202A2040706172616D207B506F696E747D20710A202A0A202A204072657475726E207B506F696E747D20546865206D696420706F696E74206265747765656E207468652074776F20706F696E74732E0A202A2F0A66756E6374696F6E2067';
wwv_flow_imp.g_varchar2_table(4935) := '65744D6964506F696E7428702C207129207B0A202072657475726E207B0A20202020783A204D6174682E726F756E6428702E78202B202828712E78202D20702E7829202F20322E3029292C0A20202020793A204D6174682E726F756E6428702E79202B20';
wwv_flow_imp.g_varchar2_table(4936) := '2828712E79202D20702E7929202F20322E3029290A20207D3B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F47726170686963735574696C2E6A73223A';
wwv_flow_imp.g_varchar2_table(4937) := '0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C';
wwv_flow_imp.g_varchar2_table(4938) := '69622F7574696C2F47726170686963735574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F202828';
wwv_flow_imp.g_varchar2_table(4939) := '5F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F776562';
wwv_flow_imp.g_varchar2_table(4940) := '7061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274';
wwv_flow_imp.g_varchar2_table(4941) := '202A2F2020206765744368696C6472656E3A202829203D3E20282F2A2062696E64696E67202A2F206765744368696C6472656E292C0A2F2A206861726D6F6E79206578706F7274202A2F20202067657456697375616C3A202829203D3E20282F2A206269';
wwv_flow_imp.g_varchar2_table(4942) := '6E64696E67202A2F2067657456697375616C290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2A0A202A205356477320666F7220656C656D656E7473206172652067656E65726174656420627920746865207B406C696E6B204772';
wwv_flow_imp.g_varchar2_table(4943) := '617068696373466163746F72797D2E0A202A0A202A2054686973207574696C69747920676976657320717569636B2061636365737320746F2074686520696D706F7274616E742073656D616E7469630A202A207061727473206F6620616E20656C656D65';
wwv_flow_imp.g_varchar2_table(4944) := '6E742E0A202A2F0A0A2F2A2A0A202A2052657475726E73207468652076697375616C2070617274206F662061206469616772616D20656C656D656E742E0A202A0A202A2040706172616D207B535647456C656D656E747D206766780A202A0A202A204072';
wwv_flow_imp.g_varchar2_table(4945) := '657475726E207B535647456C656D656E747D0A202A2F0A66756E6374696F6E2067657456697375616C2867667829207B0A202072657475726E206766782E6368696C644E6F6465735B305D3B0A7D0A0A2F2A2A0A202A2052657475726E73207468652063';
wwv_flow_imp.g_varchar2_table(4946) := '68696C6472656E20666F72206120676976656E206469616772616D20656C656D656E742E0A202A0A202A2040706172616D207B535647456C656D656E747D206766780A202A204072657475726E207B535647456C656D656E747D0A202A2F0A66756E6374';
wwv_flow_imp.g_varchar2_table(4947) := '696F6E206765744368696C6472656E2867667829207B0A202072657475726E206766782E706172656E744E6F64652E6368696C644E6F6465735B315D3B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469';
wwv_flow_imp.g_varchar2_table(4948) := '616772616D2D6A732F6C69622F7574696C2F496447656E657261746F722E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A20';
wwv_flow_imp.g_varchar2_table(4949) := '20212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F496447656E657261746F722E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4950) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E';
wwv_flow_imp.g_varchar2_table(4951) := '207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(4952) := '5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F20496447656E657261746F72290A2F2A206861726D6F6E79206578706F727420';
wwv_flow_imp.g_varchar2_table(4953) := '2A2F207D293B0A2F2A2A0A202A205574696C20746861742070726F766964657320756E69717565204944732E0A202A0A202A2040636C6173730A202A2040636F6E7374727563746F720A202A0A202A20546865206964732063616E20626520637573746F';
wwv_flow_imp.g_varchar2_table(4954) := '6D697A656420766961206120676976656E2070726566697820616E6420636F6E7461696E20612072616E646F6D2076616C756520746F2061766F696420636F6C6C6973696F6E732E0A202A0A202A2040706172616D207B737472696E677D205B70726566';
wwv_flow_imp.g_varchar2_table(4955) := '69785D20612070726566697820746F2070726570656E6420746F2067656E657261746564206964732028666F722062657474657220726561646162696C697479290A202A2F0A66756E6374696F6E20496447656E657261746F722870726566697829207B';
wwv_flow_imp.g_varchar2_table(4956) := '0A0A2020746869732E5F636F756E746572203D20303B0A2020746869732E5F707265666978203D2028707265666978203F20707265666978202B20272D27203A20272729202B204D6174682E666C6F6F72284D6174682E72616E646F6D2829202A203130';
wwv_flow_imp.g_varchar2_table(4957) := '303030303030303029202B20272D273B0A7D0A0A2F2A2A0A202A2052657475726E732061206E65787420756E697175652049442E0A202A0A202A204072657475726E207B737472696E677D207468652069640A202A2F0A496447656E657261746F722E70';
wwv_flow_imp.g_varchar2_table(4958) := '726F746F747970652E6E657874203D2066756E6374696F6E2829207B0A202072657475726E20746869732E5F707265666978202B20282B2B746869732E5F636F756E746572293B0A7D3B0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64';
wwv_flow_imp.g_varchar2_table(4959) := '655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6174682E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A202021';
wwv_flow_imp.g_varchar2_table(4960) := '2A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6174682E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4961) := '2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F7265';
wwv_flow_imp.g_varchar2_table(4962) := '71756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A';
wwv_flow_imp.g_varchar2_table(4963) := '206861726D6F6E79206578706F7274202A2F2020206C6F6731303A202829203D3E20282F2A2062696E64696E67202A2F206C6F673130292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207375627374726163743A202829203D3E20282F2A';
wwv_flow_imp.g_varchar2_table(4964) := '2072656578706F72742073616665202A2F205F506F736974696F6E5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E64656C7461290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D';
wwv_flow_imp.g_varchar2_table(4965) := '6F6E7920696D706F7274202A2F20766172205F506F736974696F6E5574696C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F506F736974696F6E557469';
wwv_flow_imp.g_varchar2_table(4966) := '6C202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F506F736974696F6E5574696C2E6A7322293B0A2F2A2A0A202A2047657420746865206C6F6761726974686D206F6620782077697468206261736520';
wwv_flow_imp.g_varchar2_table(4967) := '31302E0A202A0A202A2040706172616D207B6E756D6265727D20780A202A2F0A66756E6374696F6E206C6F673130287829207B0A202072657475726E204D6174682E6C6F67287829202F204D6174682E6C6F67283130293B0A7D0A0A0A0A0A2F2A2A2A2F';
wwv_flow_imp.g_varchar2_table(4968) := '207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4969) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(4970) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F';
wwv_flow_imp.g_varchar2_table(4971) := '5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B';
wwv_flow_imp.g_varchar2_table(4972) := '5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020206973436F6E6E656374696F6E3A202829203D3E20282F2A2062696E64696E67202A2F206973436F6E6E';
wwv_flow_imp.g_varchar2_table(4973) := '656374696F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F20202069734C6162656C3A202829203D3E20282F2A2062696E64696E67202A2F2069734C6162656C292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206973526F6F';
wwv_flow_imp.g_varchar2_table(4974) := '743A202829203D3E20282F2A2062696E64696E67202A2F206973526F6F74290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F';
wwv_flow_imp.g_varchar2_table(4975) := '494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A73';
wwv_flow_imp.g_varchar2_table(4976) := '22293B0A0A0A2F2A2A0A202A20436865636B73207768657468657220612076616C756520697320616E20696E7374616E6365206F6620436F6E6E656374696F6E2E0A202A0A202A2040706172616D207B616E797D2076616C75650A202A0A202A20407265';
wwv_flow_imp.g_varchar2_table(4977) := '7475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206973436F6E6E656374696F6E2876616C756529207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E';
wwv_flow_imp.g_varchar2_table(4978) := '69734F626A656374292876616C7565292026262028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E686173292876616C75652C2027776179706F696E747327293B0A7D0A0A2F2A2A0A202A20436865';
wwv_flow_imp.g_varchar2_table(4979) := '636B73207768657468657220612076616C756520697320616E20696E7374616E6365206F66204C6162656C2E0A202A0A202A2040706172616D207B616E797D2076616C75650A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A6675';
wwv_flow_imp.g_varchar2_table(4980) := '6E6374696F6E2069734C6162656C2876616C756529207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734F626A656374292876616C7565292026262028302C6D696E';
wwv_flow_imp.g_varchar2_table(4981) := '5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E686173292876616C75652C20276C6162656C54617267657427293B0A7D0A0A2F2A2A0A202A20436865636B73207768657468657220612076616C75652069732061';
wwv_flow_imp.g_varchar2_table(4982) := '6E20696E7374616E6365206F6620526F6F742E0A202A0A202A2040706172616D207B616E797D2076616C75650A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206973526F6F742876616C756529207B0A2020';
wwv_flow_imp.g_varchar2_table(4983) := '72657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734F626A656374292876616C7565292026262028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F';
wwv_flow_imp.g_varchar2_table(4984) := '44554C455F305F5F2E69734E696C292876616C75652E706172656E74293B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6F7573652E6A73223A0A2F2A';
wwv_flow_imp.g_varchar2_table(4985) := '212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6F';
wwv_flow_imp.g_varchar2_table(4986) := '7573652E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C';
wwv_flow_imp.g_varchar2_table(4987) := '205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D';
wwv_flow_imp.g_varchar2_table(4988) := '6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020206861735072696D6172794D6F646966696572';
wwv_flow_imp.g_varchar2_table(4989) := '3A202829203D3E20282F2A2062696E64696E67202A2F206861735072696D6172794D6F646966696572292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206861735365636F6E646172794D6F6469666965723A202829203D3E20282F2A2062';
wwv_flow_imp.g_varchar2_table(4990) := '696E64696E67202A2F206861735365636F6E646172794D6F646966696572292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206973417578696C69617279427574746F6E3A202829203D3E20282F2A2062696E64696E67202A2F2069734175';
wwv_flow_imp.g_varchar2_table(4991) := '78696C69617279427574746F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206973427574746F6E3A202829203D3E20282F2A2062696E64696E67202A2F206973427574746F6E292C0A2F2A206861726D6F6E79206578706F7274202A';
wwv_flow_imp.g_varchar2_table(4992) := '2F20202069734D61633A202829203D3E20282F2A2072656578706F72742073616665202A2F205F506C6174666F726D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734D6163292C0A2F2A206861726D6F6E79206578706F';
wwv_flow_imp.g_varchar2_table(4993) := '7274202A2F20202069735072696D617279427574746F6E3A202829203D3E20282F2A2062696E64696E67202A2F2069735072696D617279427574746F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F20202069735365636F6E646172794275';
wwv_flow_imp.g_varchar2_table(4994) := '74746F6E3A202829203D3E20282F2A2062696E64696E67202A2F2069735365636F6E64617279427574746F6E290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F457665';
wwv_flow_imp.g_varchar2_table(4995) := '6E745F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F4576656E74202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F';
wwv_flow_imp.g_varchar2_table(4996) := '7574696C2F4576656E742E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F506C6174666F726D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F72657175697265';
wwv_flow_imp.g_varchar2_table(4997) := '5F5F282F2A21202E2F506C6174666F726D202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F506C6174666F726D2E6A7322293B0A0A0A0A0A0A0A2F2A2A0A202A2040706172616D207B4D6F7573654576';
wwv_flow_imp.g_varchar2_table(4998) := '656E747D206576656E740A202A2040706172616D207B737472696E677D20627574746F6E0A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206973427574746F6E286576656E742C20627574746F6E29207B0A';
wwv_flow_imp.g_varchar2_table(4999) := '202072657475726E202828302C5F4576656E745F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6765744F726967696E616C29286576656E7429207C7C206576656E74292E627574746F6E203D3D3D20627574746F6E3B0A7D0A';
wwv_flow_imp.g_varchar2_table(5000) := '0A2F2A2A0A202A2040706172616D207B4D6F7573654576656E747D206576656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E2069735072696D617279427574746F6E286576656E7429207B0A0A20202F';
wwv_flow_imp.g_varchar2_table(5001) := '2F20627574746F6E203D3D3D2030202D3E206C65667420C3A16B61207072696D617279206D6F75736520627574746F6E0A202072657475726E206973427574746F6E286576656E742C2030293B0A7D0A0A2F2A2A0A202A2040706172616D207B4D6F7573';
wwv_flow_imp.g_varchar2_table(5002) := '654576656E747D206576656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206973417578696C69617279427574746F6E286576656E7429207B0A0A20202F2F20627574746F6E203D3D3D2031202D3E20';
wwv_flow_imp.g_varchar2_table(5003) := '617578696C6961727920C3A16B6120776865656C20627574746F6E0A202072657475726E206973427574746F6E286576656E742C2031293B0A7D0A0A2F2A2A0A202A2040706172616D207B4D6F7573654576656E747D206576656E740A202A0A202A2040';
wwv_flow_imp.g_varchar2_table(5004) := '72657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E2069735365636F6E64617279427574746F6E286576656E7429207B0A0A20202F2F20627574746F6E203D3D3D2032202D3E20726967687420C3A16B61207365636F6E6461727920';
wwv_flow_imp.g_varchar2_table(5005) := '627574746F6E0A202072657475726E206973427574746F6E286576656E742C2032293B0A7D0A0A2F2A2A0A202A2040706172616D207B4D6F7573654576656E747D206576656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A';
wwv_flow_imp.g_varchar2_table(5006) := '66756E6374696F6E206861735072696D6172794D6F646966696572286576656E7429207B0A2020766172206F726967696E616C4576656E74203D2028302C5F4576656E745F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6765';
wwv_flow_imp.g_varchar2_table(5007) := '744F726967696E616C29286576656E7429207C7C206576656E743B0A0A2020696620282169735072696D617279427574746F6E286576656E742929207B0A2020202072657475726E2066616C73653B0A20207D0A0A20202F2F2055736520636D64206173';
wwv_flow_imp.g_varchar2_table(5008) := '207072696D617279206D6F646966696572206B657920666F72206D6163204F530A20206966202828302C5F506C6174666F726D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734D616329282929207B0A20202020726574';
wwv_flow_imp.g_varchar2_table(5009) := '75726E206F726967696E616C4576656E742E6D6574614B65793B0A20207D20656C7365207B0A2020202072657475726E206F726967696E616C4576656E742E6374726C4B65793B0A20207D0A7D0A0A2F2A2A0A202A2040706172616D207B4D6F75736545';
wwv_flow_imp.g_varchar2_table(5010) := '76656E747D206576656E740A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206861735365636F6E646172794D6F646966696572286576656E7429207B0A2020766172206F726967696E616C4576656E74203D';
wwv_flow_imp.g_varchar2_table(5011) := '2028302C5F4576656E745F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6765744F726967696E616C29286576656E7429207C7C206576656E743B0A0A202072657475726E2069735072696D617279427574746F6E286576656E';
wwv_flow_imp.g_varchar2_table(5012) := '7429202626206F726967696E616C4576656E742E73686966744B65793B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F506C6174666F726D2E6A73223A';
wwv_flow_imp.g_varchar2_table(5013) := '0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F75';
wwv_flow_imp.g_varchar2_table(5014) := '74696C2F506C6174666F726D2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F776562';
wwv_flow_imp.g_varchar2_table(5015) := '7061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F727473';
wwv_flow_imp.g_varchar2_table(5016) := '5F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F20202069734D61633A';
wwv_flow_imp.g_varchar2_table(5017) := '202829203D3E20282F2A2062696E64696E67202A2F2069734D6163290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A66756E6374696F6E2069734D61632829207B0A202072657475726E20282F6D61632F69292E74657374286E617669';
wwv_flow_imp.g_varchar2_table(5018) := '6761746F722E706C6174666F726D293B0A7D0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F506F736974696F6E5574696C2E6A73223A0A2F2A212A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(5019) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F506F';
wwv_flow_imp.g_varchar2_table(5020) := '736974696F6E5574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F77';
wwv_flow_imp.g_varchar2_table(5021) := '65627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F72';
wwv_flow_imp.g_varchar2_table(5022) := '74735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F20202063656E74';
wwv_flow_imp.g_varchar2_table(5023) := '65723A202829203D3E20282F2A2062696E64696E67202A2F2063656E746572292C0A2F2A206861726D6F6E79206578706F7274202A2F20202064656C74613A202829203D3E20282F2A2062696E64696E67202A2F2064656C7461290A2F2A206861726D6F';
wwv_flow_imp.g_varchar2_table(5024) := '6E79206578706F7274202A2F207D293B0A2F2A2A0A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F696E740A202A204074797065646566207B696D706F727428272E2E2F7574696C2F';
wwv_flow_imp.g_varchar2_table(5025) := '547970657327292E526563747D20526563740A202A2F0A0A2F2A2A0A202A2040706172616D207B526563747D20626F756E64730A202A204072657475726E207B506F696E747D0A202A2F0A66756E6374696F6E2063656E74657228626F756E647329207B';
wwv_flow_imp.g_varchar2_table(5026) := '0A202072657475726E207B0A20202020783A20626F756E64732E78202B2028626F756E64732E7769647468202F2032292C0A20202020793A20626F756E64732E79202B2028626F756E64732E686569676874202F2032290A20207D3B0A7D0A0A0A2F2A2A';
wwv_flow_imp.g_varchar2_table(5027) := '0A202A2040706172616D207B506F696E747D20610A202A2040706172616D207B506F696E747D20620A202A204072657475726E207B506F696E747D0A202A2F0A66756E6374696F6E2064656C746128612C206229207B0A202072657475726E207B0A2020';
wwv_flow_imp.g_varchar2_table(5028) := '2020783A20612E78202D20622E782C0A20202020793A20612E79202D20622E790A20207D3B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F52656E6465';
wwv_flow_imp.g_varchar2_table(5029) := '725574696C2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F64696167';
wwv_flow_imp.g_varchar2_table(5030) := '72616D2D6A732F6C69622F7574696C2F52656E6465725574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A';
wwv_flow_imp.g_varchar2_table(5031) := '2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F';
wwv_flow_imp.g_varchar2_table(5032) := '5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578';
wwv_flow_imp.g_varchar2_table(5033) := '706F7274202A2F202020636F6D706F6E656E7473546F506174683A202829203D3E20282F2A2062696E64696E67202A2F20636F6D706F6E656E7473546F50617468292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206372656174654C696E';
wwv_flow_imp.g_varchar2_table(5034) := '653A202829203D3E20282F2A2062696E64696E67202A2F206372656174654C696E65292C0A2F2A206861726D6F6E79206578706F7274202A2F202020746F535647506F696E74733A202829203D3E20282F2A2062696E64696E67202A2F20746F53564750';
wwv_flow_imp.g_varchar2_table(5035) := '6F696E7473292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207570646174654C696E653A202829203D3E20282F2A2062696E64696E67202A2F207570646174654C696E65290A2F2A206861726D6F6E79206578706F7274202A2F207D293B';
wwv_flow_imp.g_varchar2_table(5036) := '0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A';
wwv_flow_imp.g_varchar2_table(5037) := '2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722074696E795F7376675F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(5038) := '4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D7376672F646973742F696E6465782E65736D2E6A7322293B0A0A0A0A0A0A';
wwv_flow_imp.g_varchar2_table(5039) := '2F2A2A0A202A204074797065646566207B28737472696E677C6E756D626572295B5D7D20436F6D706F6E656E740A202A0A202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F696E740A20';
wwv_flow_imp.g_varchar2_table(5040) := '2A2F0A0A2F2A2A0A202A2040706172616D207B436F6D706F6E656E745B5D207C20436F6D706F6E656E745B5D5B5D7D20656C656D656E74730A202A0A202A204072657475726E207B737472696E677D0A202A2F0A66756E6374696F6E20636F6D706F6E65';
wwv_flow_imp.g_varchar2_table(5041) := '6E7473546F5061746828656C656D656E747329207B0A202072657475726E20656C656D656E74732E666C617428292E6A6F696E28272C27292E7265706C616365282F2C3F285B412D7A5D292C3F2F672C2027243127293B0A7D0A0A2F2A2A0A202A204070';
wwv_flow_imp.g_varchar2_table(5042) := '6172616D207B506F696E745B5D7D20706F696E74730A202A0A202A204072657475726E207B737472696E677D0A202A2F0A66756E6374696F6E20746F535647506F696E747328706F696E747329207B0A202076617220726573756C74203D2027273B0A0A';
wwv_flow_imp.g_varchar2_table(5043) := '2020666F7220287661722069203D20302C20703B202870203D20706F696E74735B695D293B20692B2B29207B0A20202020726573756C74202B3D20702E78202B20272C27202B20702E79202B202720273B0A20207D0A0A202072657475726E2072657375';
wwv_flow_imp.g_varchar2_table(5044) := '6C743B0A7D0A0A2F2A2A0A202A2040706172616D207B506F696E747D20706F696E740A202A0A202A204072657475726E207B436F6D706F6E656E745B5D7D0A202A2F0A66756E6374696F6E206D6F766528706F696E7429207B0A202072657475726E205B';
wwv_flow_imp.g_varchar2_table(5045) := '20274D272C20706F696E742E782C20706F696E742E79205D3B0A7D0A0A2F2A2A0A202A2040706172616D207B506F696E747D20706F696E740A202A0A202A204072657475726E207B436F6D706F6E656E745B5D7D0A202A2F0A66756E6374696F6E206C69';
wwv_flow_imp.g_varchar2_table(5046) := '6E65546F28706F696E7429207B0A202072657475726E205B20274C272C20706F696E742E782C20706F696E742E79205D3B0A7D0A0A2F2A2A0A202A2040706172616D207B506F696E747D2070310A202A2040706172616D207B506F696E747D2070320A20';
wwv_flow_imp.g_varchar2_table(5047) := '2A2040706172616D207B506F696E747D2070330A202A0A202A204072657475726E207B436F6D706F6E656E745B5D7D0A202A2F0A66756E6374696F6E206375727665546F2870312C2070322C20703329207B0A202072657475726E205B202743272C2070';
wwv_flow_imp.g_varchar2_table(5048) := '312E782C2070312E792C2070322E782C2070322E792C2070332E782C2070332E79205D3B0A7D0A0A2F2A2A0A202A2040706172616D207B506F696E745B5D7D20776179706F696E74730A202A2040706172616D207B6E756D6265727D205B636F726E6572';
wwv_flow_imp.g_varchar2_table(5049) := '5261646975735D0A202A204072657475726E207B436F6D706F6E656E745B5D5B5D7D0A202A2F0A66756E6374696F6E20647261775061746828776179706F696E74732C20636F726E657252616469757329207B0A2020636F6E737420706F696E74436F75';
wwv_flow_imp.g_varchar2_table(5050) := '6E74203D20776179706F696E74732E6C656E6774683B0A0A2020636F6E73742070617468203D205B206D6F766528776179706F696E74735B305D29205D3B0A0A2020666F7220286C65742069203D20313B2069203C20706F696E74436F756E743B20692B';
wwv_flow_imp.g_varchar2_table(5051) := '2B29207B0A0A20202020636F6E737420706F696E744265666F7265203D20776179706F696E74735B69202D20315D3B0A20202020636F6E737420706F696E74203D20776179706F696E74735B695D3B0A20202020636F6E737420706F696E744166746572';
wwv_flow_imp.g_varchar2_table(5052) := '203D20776179706F696E74735B69202B20315D3B0A0A202020206966202821706F696E744166746572207C7C2021636F726E657252616469757329207B0A202020202020706174682E70757368286C696E65546F28706F696E7429293B0A0A2020202020';
wwv_flow_imp.g_varchar2_table(5053) := '20636F6E74696E75653B0A202020207D0A0A20202020636F6E737420656666656374697665526164697573203D204D6174682E6D696E280A202020202020636F726E65725261646975732C0A202020202020766563746F724C656E67746828706F696E74';
wwv_flow_imp.g_varchar2_table(5054) := '2E78202D20706F696E744265666F72652E782C20706F696E742E79202D20706F696E744265666F72652E79292C0A202020202020766563746F724C656E67746828706F696E7441667465722E78202D20706F696E742E782C20706F696E7441667465722E';
wwv_flow_imp.g_varchar2_table(5055) := '79202D20706F696E742E79290A20202020293B0A0A20202020696620282165666665637469766552616469757329207B0A202020202020706174682E70757368286C696E65546F28706F696E7429293B0A0A202020202020636F6E74696E75653B0A2020';
wwv_flow_imp.g_varchar2_table(5056) := '20207D0A0A20202020636F6E7374206265666F7265506F696E74203D20676574506F696E7441744C656E67746828706F696E742C20706F696E744265666F72652C20656666656374697665526164697573293B0A20202020636F6E7374206265666F7265';
wwv_flow_imp.g_varchar2_table(5057) := '506F696E7432203D20676574506F696E7441744C656E67746828706F696E742C20706F696E744265666F72652C20656666656374697665526164697573202A202E35293B0A0A20202020636F6E7374206166746572506F696E74203D20676574506F696E';
wwv_flow_imp.g_varchar2_table(5058) := '7441744C656E67746828706F696E742C20706F696E7441667465722C20656666656374697665526164697573293B0A20202020636F6E7374206166746572506F696E7432203D20676574506F696E7441744C656E67746828706F696E742C20706F696E74';
wwv_flow_imp.g_varchar2_table(5059) := '41667465722C20656666656374697665526164697573202A202E35293B0A0A20202020706174682E70757368286C696E65546F286265666F7265506F696E7429293B0A20202020706174682E70757368286375727665546F286265666F7265506F696E74';
wwv_flow_imp.g_varchar2_table(5060) := '322C206166746572506F696E74322C206166746572506F696E7429293B0A20207D0A0A202072657475726E20706174683B0A7D0A0A66756E6374696F6E20676574506F696E7441744C656E6774682873746172742C20656E642C206C656E67746829207B';
wwv_flow_imp.g_varchar2_table(5061) := '0A0A2020636F6E73742064656C746158203D20656E642E78202D2073746172742E783B0A2020636F6E73742064656C746159203D20656E642E79202D2073746172742E793B0A0A2020636F6E737420746F74616C4C656E677468203D20766563746F724C';
wwv_flow_imp.g_varchar2_table(5062) := '656E6774682864656C7461582C2064656C746159293B0A0A2020636F6E73742070657263656E74203D206C656E677468202F20746F74616C4C656E6774683B0A0A202072657475726E207B0A20202020783A2073746172742E78202B2064656C74615820';
wwv_flow_imp.g_varchar2_table(5063) := '2A2070657263656E742C0A20202020793A2073746172742E79202B2064656C746159202A2070657263656E740A20207D3B0A7D0A0A66756E6374696F6E20766563746F724C656E67746828782C207929207B0A202072657475726E204D6174682E737172';
wwv_flow_imp.g_varchar2_table(5064) := '74284D6174682E706F7728782C203229202B204D6174682E706F7728792C203229293B0A7D0A0A2F2A2A0A202A2040706172616D207B506F696E745B5D7D20706F696E74730A202A2040706172616D207B6E756D6265727C4F626A6563747D205B617474';
wwv_flow_imp.g_varchar2_table(5065) := '72735D0A202A2040706172616D207B6E756D6265727D205B7261646975735D0A202A0A202A204072657475726E207B535647456C656D656E747D0A202A2F0A66756E6374696F6E206372656174654C696E6528706F696E74732C2061747472732C207261';
wwv_flow_imp.g_varchar2_table(5066) := '6469757329207B0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734E756D626572292861747472732929207B0A20202020726164697573203D2061747472733B0A20202020';
wwv_flow_imp.g_varchar2_table(5067) := '6174747273203D206E756C6C3B0A20207D0A0A20206966202821617474727329207B0A202020206174747273203D207B7D3B0A20207D0A0A2020636F6E7374206C696E65203D2028302C74696E795F7376675F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(5068) := '5F4D4F44554C455F315F5F2E63726561746529282770617468272C206174747273293B0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734E756D6265722928726164697573';
wwv_flow_imp.g_varchar2_table(5069) := '2929207B0A202020206C696E652E646174617365742E636F726E6572526164697573203D20537472696E6728726164697573293B0A20207D0A0A202072657475726E207570646174654C696E65286C696E652C20706F696E7473293B0A7D0A0A2F2A2A0A';
wwv_flow_imp.g_varchar2_table(5070) := '202A2040706172616D207B535647456C656D656E747D206766780A202A2040706172616D207B506F696E745B5D7D20706F696E74730A202A0A202A204072657475726E207B535647456C656D656E747D0A202A2F0A66756E6374696F6E20757064617465';
wwv_flow_imp.g_varchar2_table(5071) := '4C696E65286766782C20706F696E747329207B0A0A2020636F6E737420636F726E6572526164697573203D207061727365496E74286766782E646174617365742E636F726E65725261646975732C20313029207C7C20303B0A0A202028302C74696E795F';
wwv_flow_imp.g_varchar2_table(5072) := '7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6174747229286766782C207B0A20202020643A20636F6D706F6E656E7473546F5061746828647261775061746828706F696E74732C20636F726E657252616469757329';
wwv_flow_imp.g_varchar2_table(5073) := '290A20207D293B0A0A202072657475726E206766783B0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F5376675472616E73666F726D5574696C2E6A7322';
wwv_flow_imp.g_varchar2_table(5074) := '3A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D';
wwv_flow_imp.g_varchar2_table(5075) := '2D6A732F6C69622F7574696C2F5376675472616E73666F726D5574696C2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(5076) := '2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F72657175';
wwv_flow_imp.g_varchar2_table(5077) := '6972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A2068';
wwv_flow_imp.g_varchar2_table(5078) := '61726D6F6E79206578706F7274202A2F202020726F746174653A202829203D3E20282F2A2062696E64696E67202A2F20726F74617465292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207363616C653A202829203D3E20282F2A2062696E';
wwv_flow_imp.g_varchar2_table(5079) := '64696E67202A2F207363616C65292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207472616E73666F726D3A202829203D3E20282F2A2062696E64696E67202A2F207472616E73666F726D292C0A2F2A206861726D6F6E79206578706F7274';
wwv_flow_imp.g_varchar2_table(5080) := '202A2F2020207472616E736C6174653A202829203D3E20282F2A2062696E64696E67202A2F207472616E736C617465290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722074';
wwv_flow_imp.g_varchar2_table(5081) := '696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212074696E792D737667202A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D7376672F';
wwv_flow_imp.g_varchar2_table(5082) := '646973742F696E6465782E65736D2E6A7322293B0A0D0A0D0A0D0A2F2A2A0D0A202A2040706172616D207B535647456C656D656E747D206766780D0A202A2040706172616D207B6E756D6265727D20780D0A202A2040706172616D207B6E756D6265727D';
wwv_flow_imp.g_varchar2_table(5083) := '20790D0A202A2040706172616D207B6E756D6265727D205B616E676C655D0D0A202A2040706172616D207B6E756D6265727D205B616D6F756E745D0D0A202A2F0D0A66756E6374696F6E207472616E73666F726D286766782C20782C20792C20616E676C';
wwv_flow_imp.g_varchar2_table(5084) := '652C20616D6F756E7429207B0D0A2020766172207472616E736C617465203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6372656174655472616E73666F726D2928293B0D0A20207472616E';
wwv_flow_imp.g_varchar2_table(5085) := '736C6174652E7365745472616E736C61746528782C2079293B0D0A0D0A202076617220726F74617465203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6372656174655472616E73666F726D';
wwv_flow_imp.g_varchar2_table(5086) := '2928293B0D0A2020726F746174652E736574526F7461746528616E676C65207C7C20302C20302C2030293B0D0A0D0A2020766172207363616C65203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F';
wwv_flow_imp.g_varchar2_table(5087) := '5F2E6372656174655472616E73666F726D2928293B0D0A20207363616C652E7365745363616C6528616D6F756E74207C7C20312C20616D6F756E74207C7C2031293B0D0A0D0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(5088) := '445F4D4F44554C455F305F5F2E7472616E73666F726D29286766782C205B207472616E736C6174652C20726F746174652C207363616C65205D293B0D0A7D0D0A0D0A0D0A2F2A2A0D0A202A2040706172616D207B535647456C656D656E747D206766780D';
wwv_flow_imp.g_varchar2_table(5089) := '0A202A2040706172616D207B6E756D6265727D20780D0A202A2040706172616D207B6E756D6265727D20790D0A202A2F0D0A66756E6374696F6E207472616E736C617465286766782C20782C207929207B0D0A2020766172207472616E736C617465203D';
wwv_flow_imp.g_varchar2_table(5090) := '2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6372656174655472616E73666F726D2928293B0D0A20207472616E736C6174652E7365745472616E736C61746528782C2079293B0D0A0D0A2020';
wwv_flow_imp.g_varchar2_table(5091) := '28302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E7472616E73666F726D29286766782C207472616E736C617465293B0D0A7D0D0A0D0A0D0A2F2A2A0D0A202A2040706172616D207B535647456C656D';
wwv_flow_imp.g_varchar2_table(5092) := '656E747D206766780D0A202A2040706172616D207B6E756D6265727D20616E676C650D0A202A2F0D0A66756E6374696F6E20726F74617465286766782C20616E676C6529207B0D0A202076617220726F74617465203D2028302C74696E795F7376675F5F';
wwv_flow_imp.g_varchar2_table(5093) := '5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6372656174655472616E73666F726D2928293B0D0A2020726F746174652E736574526F7461746528616E676C652C20302C2030293B0D0A0D0A202028302C74696E795F7376675F5F';
wwv_flow_imp.g_varchar2_table(5094) := '5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E7472616E73666F726D29286766782C20726F74617465293B0D0A7D0D0A0D0A0D0A2F2A2A0D0A202A2040706172616D207B535647456C656D656E747D206766780D0A202A20407061';
wwv_flow_imp.g_varchar2_table(5095) := '72616D207B6E756D6265727D20616D6F756E740D0A202A2F0D0A66756E6374696F6E207363616C65286766782C20616D6F756E7429207B0D0A2020766172207363616C65203D2028302C74696E795F7376675F5F5745425041434B5F494D504F52544544';
wwv_flow_imp.g_varchar2_table(5096) := '5F4D4F44554C455F305F5F2E6372656174655472616E73666F726D2928293B0D0A20207363616C652E7365745363616C6528616D6F756E742C20616D6F756E74293B0D0A0D0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(5097) := '445F4D4F44554C455F305F5F2E7472616E73666F726D29286766782C207363616C65293B0D0A7D0D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F54657874';
wwv_flow_imp.g_varchar2_table(5098) := '2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F';
wwv_flow_imp.g_varchar2_table(5099) := '7574696C2F546578742E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F';
wwv_flow_imp.g_varchar2_table(5100) := '64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A';
wwv_flow_imp.g_varchar2_table(5101) := '206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829';
wwv_flow_imp.g_varchar2_table(5102) := '203D3E20282F2A2062696E64696E67202A2F2054657874290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(5103) := '445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A20';
wwv_flow_imp.g_varchar2_table(5104) := '6861726D6F6E7920696D706F7274202A2F207661722074696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212074696E792D737667202A2F20222E';
wwv_flow_imp.g_varchar2_table(5105) := '2F6E6F64655F6D6F64756C65732F74696E792D7376672F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(5106) := '455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D646F6D202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A7322293B0A0A0A0A0A0A0A0A2F2A2A0A20';
wwv_flow_imp.g_varchar2_table(5107) := '2A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E44696D656E73696F6E737D2044696D656E73696F6E730A202A0A202A204074797065646566207B207B0A202A202020746F703A206E756D6265723B0A202A2020';
wwv_flow_imp.g_varchar2_table(5108) := '206C6566743A206E756D6265723B0A202A20202072696768743A206E756D6265723B0A202A202020626F74746F6D3A206E756D6265723B0A202A207D207D2050616464696E670A202A0A202A204074797065646566207B206E756D626572207C20506172';
wwv_flow_imp.g_varchar2_table(5109) := '7469616C3C50616464696E673E207D2050616464696E67436F6E6669670A202A0A202A204074797065646566207B207B0A202A202020686F72697A6F6E74616C3A202763656E74657227207C20276C65667427207C20277269676874273B0A202A202020';
wwv_flow_imp.g_varchar2_table(5110) := '766572746963616C3A2027746F7027207C20276D6964646C65273B0A202A207D207D20416C69676E6D656E740A202A0A202A20204074797065646566207B202763656E7465722D6D6964646C6527207C202763656E7465722D746F7027207D20416C6967';
wwv_flow_imp.g_varchar2_table(5111) := '6E6D656E74436F6E6669670A202A0A202A204074797065646566207B205061727469616C3C7B0A202A202020616C69676E3A20416C69676E6D656E74436F6E6669673B0A202A2020207374796C653A205265636F72643C737472696E672C206E756D6265';
wwv_flow_imp.g_varchar2_table(5112) := '72207C20737472696E673E3B0A202A20202070616464696E673A2050616464696E67436F6E6669673B0A202A207D3E207D204261736554657874436F6E6669670A202A0A202A204074797065646566207B204261736554657874436F6E66696720262050';
wwv_flow_imp.g_varchar2_table(5113) := '61727469616C3C7B0A202A20202073697A653A2044696D656E73696F6E733B0A202A207D3E207D2054657874436F6E6669670A202A0A202A204074797065646566207B204261736554657874436F6E6669672026205061727469616C3C7B0A202A202020';
wwv_flow_imp.g_varchar2_table(5114) := '626F783A2044696D656E73696F6E733B0A202A202020666974426F783A20626F6F6C65616E3B0A202A207D3E207D20546578744C61796F7574436F6E6669670A202A0A202A20204074797065646566207B2044696D656E73696F6E732026207B0A202A20';
wwv_flow_imp.g_varchar2_table(5115) := '20746578743A20737472696E673B0A202A207D207D204C696E6544657363726970746F720A202A2F0A0A7661722044454641554C545F424F585F50414444494E47203D20303B0A0A7661722044454641554C545F4C4142454C5F53495A45203D207B0A20';
wwv_flow_imp.g_varchar2_table(5116) := '2077696474683A203135302C0A20206865696768743A2035300A7D3B0A0A0A2F2A2A0A202A2040706172616D207B416C69676E6D656E74436F6E6669677D20616C69676E0A202A204072657475726E207B416C69676E6D656E747D0A202A2F0A66756E63';
wwv_flow_imp.g_varchar2_table(5117) := '74696F6E207061727365416C69676E28616C69676E29207B0A0A2020766172207061727473203D20616C69676E2E73706C697428272D27293B0A0A202072657475726E207B0A20202020686F72697A6F6E74616C3A2070617274735B305D207C7C202763';
wwv_flow_imp.g_varchar2_table(5118) := '656E746572272C0A20202020766572746963616C3A2070617274735B315D207C7C2027746F70270A20207D3B0A7D0A0A2F2A2A0A202A2040706172616D207B50616464696E67436F6E6669677D2070616464696E670A202A0A202A204072657475726E20';
wwv_flow_imp.g_varchar2_table(5119) := '7B50616464696E677D0A202A2F0A66756E6374696F6E20706172736550616464696E672870616464696E6729207B0A0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734F626A';
wwv_flow_imp.g_varchar2_table(5120) := '656374292870616464696E672929207B0A2020202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E29287B20746F703A20302C206C6566743A20302C2072696768';
wwv_flow_imp.g_varchar2_table(5121) := '743A20302C20626F74746F6D3A2030207D2C2070616464696E67293B0A20207D20656C7365207B0A2020202072657475726E207B0A202020202020746F703A2070616464696E672C0A2020202020206C6566743A2070616464696E672C0A202020202020';
wwv_flow_imp.g_varchar2_table(5122) := '72696768743A2070616464696E672C0A202020202020626F74746F6D3A2070616464696E670A202020207D3B0A20207D0A7D0A0A2F2A2A0A202A2040706172616D207B737472696E677D20746578740A202A2040706172616D207B53564754657874456C';
wwv_flow_imp.g_varchar2_table(5123) := '656D656E747D2066616B65546578740A202A0A202A204072657475726E207B696D706F727428272E2E2F7574696C2F547970657327292E44696D656E73696F6E737D0A202A2F0A66756E6374696F6E206765745465787442426F7828746578742C206661';
wwv_flow_imp.g_varchar2_table(5124) := '6B655465787429207B0A0A202066616B65546578742E74657874436F6E74656E74203D20746578743B0A0A2020766172207465787442426F783B0A0A2020747279207B0A202020207661722062626F782C0A2020202020202020656D7074794C696E6520';
wwv_flow_imp.g_varchar2_table(5125) := '3D2074657874203D3D3D2027273B0A0A202020202F2F206164642064756D6D7920746578742C207768656E206C696E6520697320656D70747920746F0A202020202F2F2064657465726D696E6520636F7272656374206865696768740A2020202066616B';
wwv_flow_imp.g_varchar2_table(5126) := '65546578742E74657874436F6E74656E74203D20656D7074794C696E65203F202764756D6D7927203A20746578743B0A0A202020207465787442426F78203D2066616B65546578742E67657442426F7828293B0A0A202020202F2F2074616B6520746578';
wwv_flow_imp.g_varchar2_table(5127) := '742072656E646572696E672072656C6174656420686F72697A6F6E74616C0A202020202F2F2070616464696E6720696E746F206163636F756E740A2020202062626F78203D207B0A20202020202077696474683A207465787442426F782E776964746820';
wwv_flow_imp.g_varchar2_table(5128) := '2B207465787442426F782E78202A20322C0A2020202020206865696768743A207465787442426F782E6865696768740A202020207D3B0A0A2020202069662028656D7074794C696E6529207B0A0A2020202020202F2F20636F7272656374207769647468';
wwv_flow_imp.g_varchar2_table(5129) := '0A20202020202062626F782E7769647468203D20303B0A202020207D0A0A2020202072657475726E2062626F783B0A20207D20636174636820286529207B0A2020202072657475726E207B2077696474683A20302C206865696768743A2030207D3B0A20';
wwv_flow_imp.g_varchar2_table(5130) := '207D0A7D0A0A0A2F2A2A0A202A204C61796F757420746865206E657874206C696E6520616E642072657475726E20746865206C61796F7574656420656C656D656E742E0A202A0A202A20416C7465727320746865206C696E6573207061737365642E0A20';
wwv_flow_imp.g_varchar2_table(5131) := '2A0A202A2040706172616D207B737472696E675B5D7D206C696E65730A202A2040706172616D207B6E756D6265727D206D617857696474680A202A2040706172616D207B53564754657874456C656D656E747D2066616B65546578740A202A0A202A2040';
wwv_flow_imp.g_varchar2_table(5132) := '72657475726E207B4C696E6544657363726970746F727D20746865206C696E652064657363726970746F720A202A2F0A66756E6374696F6E206C61796F75744E657874286C696E65732C206D617857696474682C2066616B655465787429207B0A0A2020';
wwv_flow_imp.g_varchar2_table(5133) := '766172206F726967696E616C4C696E65203D206C696E65732E736869667428292C0A2020202020206669744C696E65203D206F726967696E616C4C696E653B0A0A2020766172207465787442426F783B0A0A2020666F7220283B3B29207B0A2020202074';
wwv_flow_imp.g_varchar2_table(5134) := '65787442426F78203D206765745465787442426F78286669744C696E652C2066616B6554657874293B0A0A202020207465787442426F782E7769647468203D206669744C696E65203F207465787442426F782E7769647468203A20303B0A0A202020202F';
wwv_flow_imp.g_varchar2_table(5135) := '2F2074727920746F206669740A20202020696620286669744C696E65203D3D3D20272027207C7C206669744C696E65203D3D3D202727207C7C207465787442426F782E7769647468203C204D6174682E726F756E64286D6178576964746829207C7C2066';
wwv_flow_imp.g_varchar2_table(5136) := '69744C696E652E6C656E677468203C203229207B0A20202020202072657475726E20666974286C696E65732C206669744C696E652C206F726967696E616C4C696E652C207465787442426F78293B0A202020207D0A0A202020206669744C696E65203D20';
wwv_flow_imp.g_varchar2_table(5137) := '73686F7274656E4C696E65286669744C696E652C207465787442426F782E77696474682C206D61785769647468293B0A20207D0A7D0A0A2F2A2A0A202A2040706172616D207B737472696E675B5D7D206C696E65730A202A2040706172616D207B737472';
wwv_flow_imp.g_varchar2_table(5138) := '696E677D206669744C696E650A202A2040706172616D207B737472696E677D206F726967696E616C4C696E650A202A2040706172616D207B44696D656E73696F6E737D207465787442426F780A202A0A202A204072657475726E207B4C696E6544657363';
wwv_flow_imp.g_varchar2_table(5139) := '726970746F727D0A202A2F0A66756E6374696F6E20666974286C696E65732C206669744C696E652C206F726967696E616C4C696E652C207465787442426F7829207B0A2020696620286669744C696E652E6C656E677468203C206F726967696E616C4C69';
wwv_flow_imp.g_varchar2_table(5140) := '6E652E6C656E67746829207B0A202020207661722072656D61696E646572203D206F726967696E616C4C696E652E736C696365286669744C696E652E6C656E677468292E7472696D28293B0A0A202020206C696E65732E756E73686966742872656D6169';
wwv_flow_imp.g_varchar2_table(5141) := '6E646572293B0A20207D0A0A202072657475726E207B0A2020202077696474683A207465787442426F782E77696474682C0A202020206865696768743A207465787442426F782E6865696768742C0A20202020746578743A206669744C696E650A20207D';
wwv_flow_imp.g_varchar2_table(5142) := '3B0A7D0A0A76617220534F46545F425245414B203D20275C7530304144273B0A0A0A2F2A2A0A202A2053686F7274656E732061206C696E65206261736564206F6E2073706163696E6720616E642068797068656E732E0A202A2052657475726E73207468';
wwv_flow_imp.g_varchar2_table(5143) := '652073686F7274656E656420726573756C74206F6E20737563636573732E0A202A0A202A2040706172616D207B737472696E677D206C696E650A202A2040706172616D207B6E756D6265727D206D61784C656E67746820746865206D6178696D756D2063';
wwv_flow_imp.g_varchar2_table(5144) := '686172616374657273206F662074686520737472696E670A202A0A202A204072657475726E207B737472696E677D207468652073686F7274656E656420737472696E670A202A2F0A66756E6374696F6E2073656D616E74696353686F7274656E286C696E';
wwv_flow_imp.g_varchar2_table(5145) := '652C206D61784C656E67746829207B0A0A2020766172207061727473203D206C696E652E73706C6974282F285C737C2D7C5C7530304144292F67292C0A202020202020706172742C0A20202020202073686F7274656E65645061727473203D205B5D2C0A';
wwv_flow_imp.g_varchar2_table(5146) := '2020202020206C656E677468203D20303B0A0A20202F2F2074727920746F2073686F7274656E2076696120627265616B2063686172730A20206966202870617274732E6C656E677468203E203129207B0A0A202020207768696C6520282870617274203D';
wwv_flow_imp.g_varchar2_table(5147) := '2070617274732E736869667428292929207B0A20202020202069662028706172742E6C656E677468202B206C656E677468203C206D61784C656E67746829207B0A202020202020202073686F7274656E656450617274732E707573682870617274293B0A';
wwv_flow_imp.g_varchar2_table(5148) := '20202020202020206C656E677468202B3D20706172742E6C656E6774683B0A2020202020207D20656C7365207B0A0A20202020202020202F2F2072656D6F76652070726576696F757320706172742C20746F6F2069662068797068656E20646F6573206E';
wwv_flow_imp.g_varchar2_table(5149) := '6F742066697420616E796D6F72650A20202020202020206966202870617274203D3D3D20272D27207C7C2070617274203D3D3D20534F46545F425245414B29207B0A2020202020202020202073686F7274656E656450617274732E706F7028293B0A2020';
wwv_flow_imp.g_varchar2_table(5150) := '2020202020207D0A0A2020202020202020627265616B3B0A2020202020207D0A202020207D0A20207D0A0A2020766172206C617374203D2073686F7274656E656450617274735B73686F7274656E656450617274732E6C656E677468202D20315D3B0A0A';
wwv_flow_imp.g_varchar2_table(5151) := '20202F2F207472616E736C61746520747261696C696E6720736F667420627265616B20746F2061637475616C2068797068656E0A2020696620286C617374202626206C617374203D3D3D20534F46545F425245414B29207B0A2020202073686F7274656E';
wwv_flow_imp.g_varchar2_table(5152) := '656450617274735B73686F7274656E656450617274732E6C656E677468202D20315D203D20272D273B0A20207D0A0A202072657475726E2073686F7274656E656450617274732E6A6F696E282727293B0A7D0A0A0A2F2A2A0A202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(5153) := '737472696E677D206C696E650A202A2040706172616D207B6E756D6265727D2077696474680A202A2040706172616D207B6E756D6265727D206D617857696474680A202A0A202A204072657475726E207B737472696E677D0A202A2F0A66756E6374696F';
wwv_flow_imp.g_varchar2_table(5154) := '6E2073686F7274656E4C696E65286C696E652C2077696474682C206D6178576964746829207B0A2020766172206C656E677468203D204D6174682E6D6178286C696E652E6C656E677468202A20286D61785769647468202F207769647468292C2031293B';
wwv_flow_imp.g_varchar2_table(5155) := '0A0A20202F2F2074727920746F2073686F7274656E2073656D616E746963616C6C792028692E652E206261736564206F6E2073706163657320616E642068797068656E73290A20207661722073686F7274656E65644C696E65203D2073656D616E746963';
wwv_flow_imp.g_varchar2_table(5156) := '53686F7274656E286C696E652C206C656E677468293B0A0A2020696620282173686F7274656E65644C696E6529207B0A0A202020202F2F20666F7263652073686F7274656E2062792063757474696E6720746865206C6F6E6720776F72640A2020202073';
wwv_flow_imp.g_varchar2_table(5157) := '686F7274656E65644C696E65203D206C696E652E736C69636528302C204D6174682E6D6178284D6174682E726F756E64286C656E677468202D2031292C203129293B0A20207D0A0A202072657475726E2073686F7274656E65644C696E653B0A7D0A0A0A';
wwv_flow_imp.g_varchar2_table(5158) := '2F2A2A0A202A204072657475726E207B535647535647456C656D656E747D0A202A2F0A66756E6374696F6E2067657448656C7065725376672829207B0A20207661722068656C706572537667203D20646F63756D656E742E676574456C656D656E744279';
wwv_flow_imp.g_varchar2_table(5159) := '4964282768656C7065722D73766727293B0A0A2020696620282168656C70657253766729207B0A2020202068656C706572537667203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E63726561';
wwv_flow_imp.g_varchar2_table(5160) := '746529282773766727293B0A0A2020202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E61747472292868656C7065725376672C207B0A20202020202069643A202768656C7065722D737667270A';
wwv_flow_imp.g_varchar2_table(5161) := '202020207D293B0A0A2020202028302C6D696E5F646F6D5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E5374796C65292868656C7065725376672C207B0A2020202020207669736962696C6974793A20276869';
wwv_flow_imp.g_varchar2_table(5162) := '6464656E272C0A202020202020706F736974696F6E3A20276669786564272C0A20202020202077696474683A20302C0A2020202020206865696768743A20300A202020207D293B0A0A20202020646F63756D656E742E626F64792E617070656E64436869';
wwv_flow_imp.g_varchar2_table(5163) := '6C642868656C706572537667293B0A20207D0A0A202072657475726E2068656C7065725376673B0A7D0A0A0A2F2A2A0A202A20437265617465732061206E6577206C6162656C207574696C6974790A202A0A202A2040706172616D207B54657874436F6E';
wwv_flow_imp.g_varchar2_table(5164) := '6669677D205B636F6E6669675D0A202A2F0A66756E6374696F6E205465787428636F6E66696729207B0A0A2020746869732E5F636F6E666967203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F';
wwv_flow_imp.g_varchar2_table(5165) := '2E61737369676E29287B7D2C207B0A2020202073697A653A2044454641554C545F4C4142454C5F53495A452C0A2020202070616464696E673A2044454641554C545F424F585F50414444494E472C0A202020207374796C653A207B7D2C0A20202020616C';
wwv_flow_imp.g_varchar2_table(5166) := '69676E3A202763656E7465722D746F70270A20207D2C20636F6E666967207C7C207B7D293B0A7D0A0A2F2A2A0A202A2052657475726E7320746865206C61796F75746564207465787420617320616E2053564720656C656D656E742E0A202A0A202A2040';
wwv_flow_imp.g_varchar2_table(5167) := '706172616D207B737472696E677D20746578740A202A2040706172616D207B546578744C61796F7574436F6E6669677D206F7074696F6E730A202A0A202A204072657475726E207B535647456C656D656E747D0A202A2F0A546578742E70726F746F7479';
wwv_flow_imp.g_varchar2_table(5168) := '70652E63726561746554657874203D2066756E6374696F6E28746578742C206F7074696F6E7329207B0A202072657475726E20746869732E6C61796F75745465787428746578742C206F7074696F6E73292E656C656D656E743B0A7D3B0A0A2F2A2A0A20';
wwv_flow_imp.g_varchar2_table(5169) := '2A2052657475726E732061206C6162656C73206C61796F757465642064696D656E73696F6E732E0A202A0A202A2040706172616D207B737472696E677D207465787420746F206C61796F75740A202A2040706172616D207B546578744C61796F7574436F';
wwv_flow_imp.g_varchar2_table(5170) := '6E6669677D206F7074696F6E730A202A0A202A204072657475726E207B44696D656E73696F6E737D0A202A2F0A546578742E70726F746F747970652E67657444696D656E73696F6E73203D2066756E6374696F6E28746578742C206F7074696F6E732920';
wwv_flow_imp.g_varchar2_table(5171) := '7B0A202072657475726E20746869732E6C61796F75745465787428746578742C206F7074696F6E73292E64696D656E73696F6E733B0A7D3B0A0A2F2A2A0A202A204372656174657320616E642072657475726E732061206C6162656C20616E6420697473';
wwv_flow_imp.g_varchar2_table(5172) := '20626F756E64696E6720626F782E0A202A0A202A2040706172616D207B737472696E677D207465787420746865207465787420746F2072656E646572206F6E20746865206C6162656C0A202A2040706172616D207B546578744C61796F7574436F6E6669';
wwv_flow_imp.g_varchar2_table(5173) := '677D206F7074696F6E730A202A0A202A204072657475726E207B207B0A202A202020656C656D656E743A20535647456C656D656E742C0A202A20202064696D656E73696F6E733A2044696D656E73696F6E730A202A207D207D0A202A2F0A546578742E70';
wwv_flow_imp.g_varchar2_table(5174) := '726F746F747970652E6C61796F757454657874203D2066756E6374696F6E28746578742C206F7074696F6E7329207B0A202076617220626F78203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F';
wwv_flow_imp.g_varchar2_table(5175) := '2E61737369676E29287B7D2C20746869732E5F636F6E6669672E73697A652C206F7074696F6E732E626F78292C0A2020202020207374796C65203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F';
wwv_flow_imp.g_varchar2_table(5176) := '2E61737369676E29287B7D2C20746869732E5F636F6E6669672E7374796C652C206F7074696F6E732E7374796C65292C0A202020202020616C69676E203D207061727365416C69676E286F7074696F6E732E616C69676E207C7C20746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(5177) := '6669672E616C69676E292C0A20202020202070616464696E67203D20706172736550616464696E67286F7074696F6E732E70616464696E6720213D3D20756E646566696E6564203F206F7074696F6E732E70616464696E67203A20746869732E5F636F6E';
wwv_flow_imp.g_varchar2_table(5178) := '6669672E70616464696E67292C0A202020202020666974426F78203D206F7074696F6E732E666974426F78207C7C2066616C73653B0A0A2020766172206C696E65486569676874203D206765744C696E65486569676874287374796C65293B0A0A20202F';
wwv_flow_imp.g_varchar2_table(5179) := '2F2077652073706C69742074657874206279206C696E657320616E64206E6F726D616C697A650A20202F2F207B736F667420627265616B7D202B207B6C696E6520627265616B7D203D3E207B206C696E6520627265616B207D0A2020766172206C696E65';
wwv_flow_imp.g_varchar2_table(5180) := '73203D20746578742E73706C6974282F5C75303041443F5C723F5C6E2F292C0A2020202020206C61796F75746564203D205B5D3B0A0A2020766172206D61785769647468203D20626F782E7769647468202D2070616464696E672E6C656674202D207061';
wwv_flow_imp.g_varchar2_table(5181) := '6464696E672E72696768743B0A0A20202F2F20656E7375726520636F72726563742072656E646572696E6720627920617474616368696E672068656C7065722074657874206E6F646520746F20696E76697369626C65205356470A20207661722068656C';
wwv_flow_imp.g_varchar2_table(5182) := '70657254657874203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6372656174652928277465787427293B0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(5183) := '4D4F44554C455F315F5F2E61747472292868656C706572546578742C207B20783A20302C20793A2030207D293B0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E61747472292868656C7065';
wwv_flow_imp.g_varchar2_table(5184) := '72546578742C207374796C65293B0A0A20207661722068656C706572537667203D2067657448656C70657253766728293B0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E617070656E64';
wwv_flow_imp.g_varchar2_table(5185) := '292868656C7065725376672C2068656C70657254657874293B0A0A20207768696C6520286C696E65732E6C656E67746829207B0A202020206C61796F757465642E70757368286C61796F75744E657874286C696E65732C206D617857696474682C206865';
wwv_flow_imp.g_varchar2_table(5186) := '6C7065725465787429293B0A20207D0A0A202069662028616C69676E2E766572746963616C203D3D3D20276D6964646C652729207B0A2020202070616464696E672E746F70203D2070616464696E672E626F74746F6D203D20303B0A20207D0A0A202076';
wwv_flow_imp.g_varchar2_table(5187) := '617220746F74616C486569676874203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E72656475636529286C61796F757465642C2066756E6374696F6E2873756D2C206C696E652C2069647829';
wwv_flow_imp.g_varchar2_table(5188) := '207B0A2020202072657475726E2073756D202B20286C696E65486569676874207C7C206C696E652E686569676874293B0A20207D2C203029202B2070616464696E672E746F70202B2070616464696E672E626F74746F6D3B0A0A2020766172206D61784C';
wwv_flow_imp.g_varchar2_table(5189) := '696E655769647468203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E72656475636529286C61796F757465642C2066756E6374696F6E2873756D2C206C696E652C2069647829207B0A202020';
wwv_flow_imp.g_varchar2_table(5190) := '2072657475726E206C696E652E7769647468203E2073756D203F206C696E652E7769647468203A2073756D3B0A20207D2C2030293B0A0A20202F2F20746865207920706F736974696F6E206F6620746865206E657874206C696E650A2020766172207920';
wwv_flow_imp.g_varchar2_table(5191) := '3D2070616464696E672E746F703B0A0A202069662028616C69676E2E766572746963616C203D3D3D20276D6964646C652729207B0A2020202079202B3D2028626F782E686569676874202D20746F74616C48656967687429202F20323B0A20207D0A0A20';
wwv_flow_imp.g_varchar2_table(5192) := '202F2F206D61676963206E756D62657220696E697469616C206F66667365740A202079202D3D20286C696E65486569676874207C7C206C61796F757465645B305D2E68656967687429202F20343B0A0A0A20207661722074657874456C656D656E74203D';
wwv_flow_imp.g_varchar2_table(5193) := '2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6372656174652928277465787427293B0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F31';
wwv_flow_imp.g_varchar2_table(5194) := '5F5F2E61747472292874657874456C656D656E742C207374796C65293B0A0A20202F2F206C61796F75742065616368206C696E652074616B696E6720696E746F206163636F756E74207468617420706172656E740A20202F2F207368617065206D696768';
wwv_flow_imp.g_varchar2_table(5195) := '7420726573697A6520746F2066697420746578742073697A650A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F724561636829286C61796F757465642C2066756E6374696F6E286C696E';
wwv_flow_imp.g_varchar2_table(5196) := '6529207B0A0A2020202076617220783B0A0A2020202079202B3D20286C696E65486569676874207C7C206C696E652E686569676874293B0A0A202020207377697463682028616C69676E2E686F72697A6F6E74616C29207B0A202020206361736520276C';
wwv_flow_imp.g_varchar2_table(5197) := '656674273A0A20202020202078203D2070616464696E672E6C6566743B0A202020202020627265616B3B0A0A202020206361736520277269676874273A0A20202020202078203D202828666974426F78203F206D61784C696E655769647468203A206D61';
wwv_flow_imp.g_varchar2_table(5198) := '785769647468290A20202020202020202D2070616464696E672E7269676874202D206C696E652E7769647468293B0A202020202020627265616B3B0A0A2020202064656661756C743A0A0A2020202020202F2F20616B612063656E7465720A2020202020';
wwv_flow_imp.g_varchar2_table(5199) := '2078203D204D6174682E6D617828282828666974426F78203F206D61784C696E655769647468203A206D61785769647468290A20202020202020202D206C696E652E776964746829202F2032202B2070616464696E672E6C656674292C2030293B0A2020';
wwv_flow_imp.g_varchar2_table(5200) := '20207D0A0A2020202076617220747370616E203D2028302C74696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E637265617465292827747370616E27293B0A2020202028302C74696E795F7376675F5F574542';
wwv_flow_imp.g_varchar2_table(5201) := '5041434B5F494D504F525445445F4D4F44554C455F315F5F2E617474722928747370616E2C207B20783A20782C20793A2079207D293B0A0A20202020747370616E2E74657874436F6E74656E74203D206C696E652E746578743B0A0A2020202028302C74';
wwv_flow_imp.g_varchar2_table(5202) := '696E795F7376675F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E617070656E64292874657874456C656D656E742C20747370616E293B0A20207D293B0A0A202028302C74696E795F7376675F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(5203) := '525445445F4D4F44554C455F315F5F2E72656D6F7665292868656C70657254657874293B0A0A20207661722064696D656E73696F6E73203D207B0A2020202077696474683A206D61784C696E6557696474682C0A202020206865696768743A20746F7461';
wwv_flow_imp.g_varchar2_table(5204) := '6C4865696768740A20207D3B0A0A202072657475726E207B0A2020202064696D656E73696F6E733A2064696D656E73696F6E732C0A20202020656C656D656E743A2074657874456C656D656E740A20207D3B0A7D3B0A0A0A66756E6374696F6E20676574';
wwv_flow_imp.g_varchar2_table(5205) := '4C696E65486569676874287374796C6529207B0A20206966202827666F6E7453697A652720696E207374796C6520262620276C696E654865696768742720696E207374796C6529207B0A2020202072657475726E207374796C652E6C696E654865696768';
wwv_flow_imp.g_varchar2_table(5206) := '74202A207061727365496E74287374796C652E666F6E7453697A652C203130293B0A20207D0A7D0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6964732F646973742F696E6465782E65736D2E6A73223A0A2F';
wwv_flow_imp.g_varchar2_table(5207) := '2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6964732F646973742F696E6465782E65736D2E6A73202A2A2A210A20';
wwv_flow_imp.g_varchar2_table(5208) := '205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F';
wwv_flow_imp.g_varchar2_table(5209) := '2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F77656270';
wwv_flow_imp.g_varchar2_table(5210) := '61636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20285F5F5745425041434B5F44454641554C545F4558';
wwv_flow_imp.g_varchar2_table(5211) := '504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A66756E6374696F6E20637265617465436F6D6D6F6E6A734D6F64756C6528666E2C206D6F64756C6529207B0A0972657475726E206D6F64756C65203D207B206578706F';
wwv_flow_imp.g_varchar2_table(5212) := '7274733A207B7D207D2C20666E286D6F64756C652C206D6F64756C652E6578706F727473292C206D6F64756C652E6578706F7274733B0A7D0A0A766172206861745F31203D20637265617465436F6D6D6F6E6A734D6F64756C652866756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(5213) := '286D6F64756C6529207B0A76617220686174203D206D6F64756C652E6578706F727473203D2066756E6374696F6E2028626974732C206261736529207B0A20202020696620282162617365292062617365203D2031363B0A202020206966202862697473';
wwv_flow_imp.g_varchar2_table(5214) := '203D3D3D20756E646566696E6564292062697473203D203132383B0A202020206966202862697473203C3D2030292072657475726E202730273B0A202020200A2020202076617220646967697473203D204D6174682E6C6F67284D6174682E706F772832';
wwv_flow_imp.g_varchar2_table(5215) := '2C20626974732929202F204D6174682E6C6F672862617365293B0A20202020666F7220287661722069203D20323B20646967697473203D3D3D20496E66696E6974793B2069202A3D203229207B0A2020202020202020646967697473203D204D6174682E';
wwv_flow_imp.g_varchar2_table(5216) := '6C6F67284D6174682E706F7728322C2062697473202F20692929202F204D6174682E6C6F67286261736529202A20693B0A202020207D0A202020200A202020207661722072656D203D20646967697473202D204D6174682E666C6F6F7228646967697473';
wwv_flow_imp.g_varchar2_table(5217) := '293B0A202020200A2020202076617220726573203D2027273B0A202020200A20202020666F7220287661722069203D20303B2069203C204D6174682E666C6F6F7228646967697473293B20692B2B29207B0A20202020202020207661722078203D204D61';
wwv_flow_imp.g_varchar2_table(5218) := '74682E666C6F6F72284D6174682E72616E646F6D2829202A2062617365292E746F537472696E672862617365293B0A2020202020202020726573203D2078202B207265733B0A202020207D0A202020200A202020206966202872656D29207B0A20202020';
wwv_flow_imp.g_varchar2_table(5219) := '202020207661722062203D204D6174682E706F7728626173652C2072656D293B0A20202020202020207661722078203D204D6174682E666C6F6F72284D6174682E72616E646F6D2829202A2062292E746F537472696E672862617365293B0A2020202020';
wwv_flow_imp.g_varchar2_table(5220) := '202020726573203D2078202B207265733B0A202020207D0A202020200A2020202076617220706172736564203D207061727365496E74287265732C2062617365293B0A202020206966202870617273656420213D3D20496E66696E697479202626207061';
wwv_flow_imp.g_varchar2_table(5221) := '72736564203E3D204D6174682E706F7728322C20626974732929207B0A202020202020202072657475726E2068617428626974732C2062617365290A202020207D0A20202020656C73652072657475726E207265733B0A7D3B0A0A6861742E7261636B20';
wwv_flow_imp.g_varchar2_table(5222) := '3D2066756E6374696F6E2028626974732C20626173652C20657870616E64427929207B0A2020202076617220666E203D2066756E6374696F6E20286461746129207B0A2020202020202020766172206974657273203D20303B0A2020202020202020646F';
wwv_flow_imp.g_varchar2_table(5223) := '207B0A202020202020202020202020696620286974657273202B2B203E20313029207B0A2020202020202020202020202020202069662028657870616E644279292062697473202B3D20657870616E6442793B0A20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(5224) := '656C7365207468726F77206E6577204572726F722827746F6F206D616E7920494420636F6C6C6973696F6E732C20757365206D6F7265206269747327290A2020202020202020202020207D0A2020202020202020202020200A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(5225) := '20766172206964203D2068617428626974732C2062617365293B0A20202020202020207D207768696C6520284F626A6563742E6861734F776E50726F70657274792E63616C6C28686174732C20696429293B0A20202020202020200A2020202020202020';
wwv_flow_imp.g_varchar2_table(5226) := '686174735B69645D203D20646174613B0A202020202020202072657475726E2069643B0A202020207D3B0A202020207661722068617473203D20666E2E68617473203D207B7D3B0A202020200A20202020666E2E676574203D2066756E6374696F6E2028';
wwv_flow_imp.g_varchar2_table(5227) := '696429207B0A202020202020202072657475726E20666E2E686174735B69645D3B0A202020207D3B0A202020200A20202020666E2E736574203D2066756E6374696F6E202869642C2076616C756529207B0A2020202020202020666E2E686174735B6964';
wwv_flow_imp.g_varchar2_table(5228) := '5D203D2076616C75653B0A202020202020202072657475726E20666E3B0A202020207D3B0A202020200A20202020666E2E62697473203D2062697473207C7C203132383B0A20202020666E2E62617365203D2062617365207C7C2031363B0A2020202072';
wwv_flow_imp.g_varchar2_table(5229) := '657475726E20666E3B0A7D3B0A7D293B0A0A2F2A2A0A202A204372656174652061206E65772069642067656E657261746F72202F20636163686520696E7374616E63652E0A202A0A202A20596F75206D6179206F7074696F6E616C6C792070726F766964';
wwv_flow_imp.g_varchar2_table(5230) := '65206120736565642074686174206973207573656420696E7465726E616C6C792E0A202A0A202A2040706172616D207B536565647D20736565640A202A2F0A66756E6374696F6E20496473287365656429207B0A20206966202821287468697320696E73';
wwv_flow_imp.g_varchar2_table(5231) := '74616E63656F66204964732929207B0A2020202072657475726E206E6577204964732873656564293B0A20207D0A202073656564203D2073656564207C7C205B3132382C2033362C20315D3B0A2020746869732E5F73656564203D20736565642E6C656E';
wwv_flow_imp.g_varchar2_table(5232) := '677468203F206861745F312E7261636B28736565645B305D2C20736565645B315D2C20736565645B325D29203A20736565643B0A7D0A0A2F2A2A0A202A2047656E65726174652061206E6578742069642E0A202A0A202A2040706172616D207B4F626A65';
wwv_flow_imp.g_varchar2_table(5233) := '63747D205B656C656D656E745D20656C656D656E7420746F2062696E642074686520696420746F0A202A0A202A204072657475726E207B537472696E677D2069640A202A2F0A4964732E70726F746F747970652E6E657874203D2066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(5234) := '28656C656D656E7429207B0A202072657475726E20746869732E5F7365656428656C656D656E74207C7C2074727565293B0A7D3B0A0A2F2A2A0A202A2047656E65726174652061206E6578742069642077697468206120676976656E207072656669782E';
wwv_flow_imp.g_varchar2_table(5235) := '0A202A0A202A2040706172616D207B4F626A6563747D205B656C656D656E745D20656C656D656E7420746F2062696E642074686520696420746F0A202A0A202A204072657475726E207B537472696E677D2069640A202A2F0A4964732E70726F746F7479';
wwv_flow_imp.g_varchar2_table(5236) := '70652E6E6578745072656669786564203D2066756E6374696F6E20287072656669782C20656C656D656E7429207B0A20207661722069643B0A2020646F207B0A202020206964203D20707265666978202B20746869732E6E6578742874727565293B0A20';
wwv_flow_imp.g_varchar2_table(5237) := '207D207768696C652028746869732E61737369676E656428696429293B0A0A20202F2F20636C61696D207B7072656669787D7B72616E646F6D7D0A2020746869732E636C61696D2869642C20656C656D656E74293B0A0A20202F2F2072657475726E0A20';
wwv_flow_imp.g_varchar2_table(5238) := '2072657475726E2069643B0A7D3B0A0A2F2A2A0A202A204D616E75616C6C7920636C61696D20616E206578697374696E672069642E0A202A0A202A2040706172616D207B537472696E677D2069640A202A2040706172616D207B537472696E677D205B65';
wwv_flow_imp.g_varchar2_table(5239) := '6C656D656E745D20656C656D656E742074686520696420697320636C61696D65642062790A202A2F0A4964732E70726F746F747970652E636C61696D203D2066756E6374696F6E202869642C20656C656D656E7429207B0A2020746869732E5F73656564';
wwv_flow_imp.g_varchar2_table(5240) := '2E7365742869642C20656C656D656E74207C7C2074727565293B0A7D3B0A0A2F2A2A0A202A2052657475726E7320747275652069662074686520676976656E2069642068617320616C7265616479206265656E2061737369676E65642E0A202A0A202A20';
wwv_flow_imp.g_varchar2_table(5241) := '40706172616D20207B537472696E677D2069640A202A204072657475726E207B426F6F6C65616E7D0A202A2F0A4964732E70726F746F747970652E61737369676E6564203D2066756E6374696F6E2028696429207B0A202072657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(5242) := '5F736565642E67657428696429207C7C2066616C73653B0A7D3B0A0A2F2A2A0A202A20556E636C61696D20616E2069642E0A202A0A202A2040706172616D20207B537472696E677D2069642074686520696420746F20756E636C61696D0A202A2F0A4964';
wwv_flow_imp.g_varchar2_table(5243) := '732E70726F746F747970652E756E636C61696D203D2066756E6374696F6E2028696429207B0A202064656C65746520746869732E5F736565642E686174735B69645D3B0A7D3B0A0A2F2A2A0A202A20436C65617220616C6C20636C61696D656420696473';
wwv_flow_imp.g_varchar2_table(5244) := '2E0A202A2F0A4964732E70726F746F747970652E636C656172203D2066756E6374696F6E202829207B0A20207661722068617473203D20746869732E5F736565642E686174732C0A2020202069643B0A2020666F722028696420696E206861747329207B';
wwv_flow_imp.g_varchar2_table(5245) := '0A20202020746869732E756E636C61696D286964293B0A20207D0A7D3B0A0A2F2A206861726D6F6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D202849647329';
wwv_flow_imp.g_varchar2_table(5246) := '3B0A2F2F2320736F757263654D617070696E6755524C3D696E6465782E65736D2E6A732E6D61700A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F696E6865726974732D62726F777365722F646973742F696E64';
wwv_flow_imp.g_varchar2_table(5247) := '65782E65732E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F696E6865';
wwv_flow_imp.g_varchar2_table(5248) := '726974732D62726F777365722F646973742F696E6465782E65732E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A';
wwv_flow_imp.g_varchar2_table(5249) := '2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F';
wwv_flow_imp.g_varchar2_table(5250) := '5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578';
wwv_flow_imp.g_varchar2_table(5251) := '706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F2065290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A66756E6374696F6E206528652C74297B74262628652E73757065725F3D74';
wwv_flow_imp.g_varchar2_table(5252) := '2C652E70726F746F747970653D4F626A6563742E63726561746528742E70726F746F747970652C7B636F6E7374727563746F723A7B76616C75653A652C656E756D657261626C653A21312C7772697461626C653A21302C636F6E666967757261626C653A';
wwv_flow_imp.g_varchar2_table(5253) := '21307D7D29297D0A2F2F2320736F757263654D617070696E6755524C3D696E6465782E65732E6A732E6D61700A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65';
wwv_flow_imp.g_varchar2_table(5254) := '736D2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E';
wwv_flow_imp.g_varchar2_table(5255) := '6465782E65736D2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C65';
wwv_flow_imp.g_varchar2_table(5256) := '2C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A20686172';
wwv_flow_imp.g_varchar2_table(5257) := '6D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F20202061737369676E5374796C653A202829203D';
wwv_flow_imp.g_varchar2_table(5258) := '3E20282F2A2062696E64696E67202A2F2061737369676E292C0A2F2A206861726D6F6E79206578706F7274202A2F202020617474723A202829203D3E20282F2A2062696E64696E67202A2F2061747472292C0A2F2A206861726D6F6E79206578706F7274';
wwv_flow_imp.g_varchar2_table(5259) := '202A2F202020636C61737365733A202829203D3E20282F2A2062696E64696E67202A2F20636C6173736573292C0A2F2A206861726D6F6E79206578706F7274202A2F202020636C6561723A202829203D3E20282F2A2062696E64696E67202A2F20636C65';
wwv_flow_imp.g_varchar2_table(5260) := '6172292C0A2F2A206861726D6F6E79206578706F7274202A2F202020636C6F736573743A202829203D3E20282F2A2062696E64696E67202A2F20636C6F73657374292C0A2F2A206861726D6F6E79206578706F7274202A2F20202064656C65676174653A';
wwv_flow_imp.g_varchar2_table(5261) := '202829203D3E20282F2A2062696E64696E67202A2F2064656C6567617465292C0A2F2A206861726D6F6E79206578706F7274202A2F202020646F6D6966793A202829203D3E20282F2A2062696E64696E67202A2F20646F6D6966792431292C0A2F2A2068';
wwv_flow_imp.g_varchar2_table(5262) := '61726D6F6E79206578706F7274202A2F2020206576656E743A202829203D3E20282F2A2062696E64696E67202A2F206576656E74292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206D6174636865733A202829203D3E20282F2A2062696E';
wwv_flow_imp.g_varchar2_table(5263) := '64696E67202A2F206D617463686573292C0A2F2A206861726D6F6E79206578706F7274202A2F20202071756572793A202829203D3E20282F2A2062696E64696E67202A2F207175657279292C0A2F2A206861726D6F6E79206578706F7274202A2F202020';
wwv_flow_imp.g_varchar2_table(5264) := '7175657279416C6C3A202829203D3E20282F2A2062696E64696E67202A2F20616C6C292C0A2F2A206861726D6F6E79206578706F7274202A2F20202072656D6F76653A202829203D3E20282F2A2062696E64696E67202A2F2072656D6F7665290A2F2A20';
wwv_flow_imp.g_varchar2_table(5265) := '6861726D6F6E79206578706F7274202A2F207D293B0A66756E6374696F6E205F6D657267654E616D65737061636573286E2C206D29207B0A20206D2E666F72456163682866756E6374696F6E20286529207B0A202020206520262620747970656F662065';
wwv_flow_imp.g_varchar2_table(5266) := '20213D3D2027737472696E6727202626202141727261792E69734172726179286529202626204F626A6563742E6B6579732865292E666F72456163682866756E6374696F6E20286B29207B0A202020202020696620286B20213D3D202764656661756C74';
wwv_flow_imp.g_varchar2_table(5267) := '272026262021286B20696E206E2929207B0A20202020202020207661722064203D204F626A6563742E6765744F776E50726F706572747944657363726970746F7228652C206B293B0A20202020202020204F626A6563742E646566696E6550726F706572';
wwv_flow_imp.g_varchar2_table(5268) := '7479286E2C206B2C20642E676574203F2064203A207B0A20202020202020202020656E756D657261626C653A20747275652C0A202020202020202020206765743A2066756E6374696F6E202829207B2072657475726E20655B6B5D3B207D0A2020202020';
wwv_flow_imp.g_varchar2_table(5269) := '2020207D293B0A2020202020207D0A202020207D293B0A20207D293B0A202072657475726E204F626A6563742E667265657A65286E293B0A7D0A0A2F2A2A0A202A20466C617474656E2061727261792C206F6E65206C6576656C20646565702E0A202A0A';
wwv_flow_imp.g_varchar2_table(5270) := '202A204074656D706C61746520540A202A0A202A2040706172616D207B545B5D5B5D207C20545B5D207C206E756C6C7D205B6172725D0A202A0A202A204072657475726E207B545B5D7D0A202A2F0A0A636F6E7374206E6174697665546F537472696E67';
wwv_flow_imp.g_varchar2_table(5271) := '203D204F626A6563742E70726F746F747970652E746F537472696E673B0A636F6E7374206E61746976654861734F776E50726F7065727479203D204F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B0A0A66756E6374696F';
wwv_flow_imp.g_varchar2_table(5272) := '6E206973556E646566696E6564286F626A29207B0A202072657475726E206F626A203D3D3D20756E646566696E65643B0A7D0A0A66756E6374696F6E2069734172726179286F626A29207B0A202072657475726E206E6174697665546F537472696E672E';
wwv_flow_imp.g_varchar2_table(5273) := '63616C6C286F626A29203D3D3D20275B6F626A6563742041727261795D273B0A7D0A0A2F2A2A0A202A2052657475726E20747275652C20696620746172676574206F776E7320612070726F706572747920776974682074686520676976656E206B65792E';
wwv_flow_imp.g_varchar2_table(5274) := '0A202A0A202A2040706172616D207B4F626A6563747D207461726765740A202A2040706172616D207B537472696E677D206B65790A202A0A202A204072657475726E207B426F6F6C65616E7D0A202A2F0A66756E6374696F6E2068617328746172676574';
wwv_flow_imp.g_varchar2_table(5275) := '2C206B657929207B0A202072657475726E206E61746976654861734F776E50726F70657274792E63616C6C287461726765742C206B6579293B0A7D0A0A0A2F2A2A0A202A2049746572617465206F76657220636F6C6C656374696F6E3B2072657475726E';
wwv_flow_imp.g_varchar2_table(5276) := '696E6720736F6D657468696E670A202A20286E6F6E2D756E646566696E6564292077696C6C2073746F7020697465726174696F6E2E0A202A0A202A204074656D706C61746520540A202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F';
wwv_flow_imp.g_varchar2_table(5277) := '6C6C656374696F6E0A202A2040706172616D207B2028286974656D3A20542C206964783A206E756D62657229203D3E2028626F6F6C65616E7C766F69642929207C2028286974656D3A20542C206B65793A20737472696E6729203D3E2028626F6F6C6561';
wwv_flow_imp.g_varchar2_table(5278) := '6E7C766F69642929207D206974657261746F720A202A0A202A204072657475726E207B547D2072657475726E20726573756C7420746861742073746F707065642074686520697465726174696F6E0A202A2F0A66756E6374696F6E20666F724561636828';
wwv_flow_imp.g_varchar2_table(5279) := '636F6C6C656374696F6E2C206974657261746F7229207B0A0A20206C65742076616C2C0A202020202020726573756C743B0A0A2020696620286973556E646566696E656428636F6C6C656374696F6E2929207B0A2020202072657475726E3B0A20207D0A';
wwv_flow_imp.g_varchar2_table(5280) := '0A2020636F6E737420636F6E766572744B6579203D206973417272617928636F6C6C656374696F6E29203F20746F4E756D203A206964656E746974793B0A0A2020666F7220286C6574206B657920696E20636F6C6C656374696F6E29207B0A0A20202020';
wwv_flow_imp.g_varchar2_table(5281) := '6966202868617328636F6C6C656374696F6E2C206B65792929207B0A20202020202076616C203D20636F6C6C656374696F6E5B6B65795D3B0A0A202020202020726573756C74203D206974657261746F722876616C2C20636F6E766572744B6579286B65';
wwv_flow_imp.g_varchar2_table(5282) := '7929293B0A0A20202020202069662028726573756C74203D3D3D2066616C736529207B0A202020202020202072657475726E2076616C3B0A2020202020207D0A202020207D0A20207D0A7D0A0A0A66756E6374696F6E206964656E746974792861726729';
wwv_flow_imp.g_varchar2_table(5283) := '207B0A202072657475726E206172673B0A7D0A0A66756E6374696F6E20746F4E756D2861726729207B0A202072657475726E204E756D62657228617267293B0A7D0A0A2F2A2A0A202A2041737369676E73207374796C6520617474726962757465732069';
wwv_flow_imp.g_varchar2_table(5284) := '6E2061207374796C652D73726320636F6D706C69616E74207761792E0A202A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A2040706172616D207B2E2E2E4F626A6563747D207374796C65536F75726365730A202A0A202A';
wwv_flow_imp.g_varchar2_table(5285) := '204072657475726E207B456C656D656E747D2074686520656C656D656E740A202A2F0A66756E6374696F6E2061737369676E28656C656D656E742C202E2E2E7374796C65536F757263657329207B0A2020636F6E737420746172676574203D20656C656D';
wwv_flow_imp.g_varchar2_table(5286) := '656E742E7374796C653B0A0A2020666F7245616368287374796C65536F75726365732C2066756E6374696F6E287374796C6529207B0A2020202069662028217374796C6529207B0A20202020202072657475726E3B0A202020207D0A0A20202020666F72';
wwv_flow_imp.g_varchar2_table(5287) := '45616368287374796C652C2066756E6374696F6E2876616C75652C206B657929207B0A2020202020207461726765745B6B65795D203D2076616C75653B0A202020207D293B0A20207D293B0A0A202072657475726E20656C656D656E743B0A7D0A0A2F2A';
wwv_flow_imp.g_varchar2_table(5288) := '2A0A202A205365742061747472696275746520606E616D656020746F206076616C602C206F7220676574206174747220606E616D65602E0A202A0A202A2040706172616D207B456C656D656E747D20656C0A202A2040706172616D207B537472696E677D';
wwv_flow_imp.g_varchar2_table(5289) := '206E616D650A202A2040706172616D207B537472696E677D205B76616C5D0A202A2040617069207075626C69630A202A2F0A66756E6374696F6E206174747228656C2C206E616D652C2076616C29207B0A0A20202F2F206765740A202069662028617267';
wwv_flow_imp.g_varchar2_table(5290) := '756D656E74732E6C656E677468203D3D203229207B0A2020202072657475726E20656C2E676574417474726962757465286E616D65293B0A20207D0A0A20202F2F2072656D6F76650A20206966202876616C203D3D3D206E756C6C29207B0A2020202072';
wwv_flow_imp.g_varchar2_table(5291) := '657475726E20656C2E72656D6F7665417474726962757465286E616D65293B0A20207D0A0A20202F2F207365740A2020656C2E736574417474726962757465286E616D652C2076616C293B0A0A202072657475726E20656C3B0A7D0A0A2F2A2A0A202A20';
wwv_flow_imp.g_varchar2_table(5292) := '54616B656E2066726F6D2068747470733A2F2F6769746875622E636F6D2F636F6D706F6E656E742F636C61737365730A202A0A202A20576974686F75742074686520636F6D706F6E656E7420626974732E0A202A2F0A0A2F2A2A0A202A20746F53747269';
wwv_flow_imp.g_varchar2_table(5293) := '6E67207265666572656E63652E0A202A2F0A0A636F6E737420746F537472696E67203D204F626A6563742E70726F746F747970652E746F537472696E673B0A0A2F2A2A0A202A20577261702060656C6020696E20612060436C6173734C697374602E0A20';
wwv_flow_imp.g_varchar2_table(5294) := '2A0A202A2040706172616D207B456C656D656E747D20656C0A202A204072657475726E207B436C6173734C6973747D0A202A2040617069207075626C69630A202A2F0A0A66756E6374696F6E20636C617373657328656C29207B0A202072657475726E20';
wwv_flow_imp.g_varchar2_table(5295) := '6E657720436C6173734C69737428656C293B0A7D0A0A2F2A2A0A202A20496E697469616C697A652061206E657720436C6173734C69737420666F722060656C602E0A202A0A202A2040706172616D207B456C656D656E747D20656C0A202A204061706920';
wwv_flow_imp.g_varchar2_table(5296) := '707269766174650A202A2F0A0A66756E6374696F6E20436C6173734C69737428656C29207B0A20206966202821656C207C7C2021656C2E6E6F64655479706529207B0A202020207468726F77206E6577204572726F7228274120444F4D20656C656D656E';
wwv_flow_imp.g_varchar2_table(5297) := '74207265666572656E636520697320726571756972656427293B0A20207D0A2020746869732E656C203D20656C3B0A2020746869732E6C697374203D20656C2E636C6173734C6973743B0A7D0A0A2F2A2A0A202A2041646420636C61737320606E616D65';
wwv_flow_imp.g_varchar2_table(5298) := '60206966206E6F7420616C72656164792070726573656E742E0A202A0A202A2040706172616D207B537472696E677D206E616D650A202A204072657475726E207B436C6173734C6973747D0A202A2040617069207075626C69630A202A2F0A0A436C6173';
wwv_flow_imp.g_varchar2_table(5299) := '734C6973742E70726F746F747970652E616464203D2066756E6374696F6E286E616D6529207B0A2020746869732E6C6973742E616464286E616D65293B0A202072657475726E20746869733B0A7D3B0A0A2F2A2A0A202A2052656D6F766520636C617373';
wwv_flow_imp.g_varchar2_table(5300) := '20606E616D6560207768656E2070726573656E742C206F720A202A2070617373206120726567756C61722065787072657373696F6E20746F2072656D6F76650A202A20616E79207768696368206D617463682E0A202A0A202A2040706172616D207B5374';
wwv_flow_imp.g_varchar2_table(5301) := '72696E677C5265674578707D206E616D650A202A204072657475726E207B436C6173734C6973747D0A202A2040617069207075626C69630A202A2F0A0A436C6173734C6973742E70726F746F747970652E72656D6F7665203D2066756E6374696F6E286E';
wwv_flow_imp.g_varchar2_table(5302) := '616D6529207B0A202069662028275B6F626A656374205265674578705D27203D3D20746F537472696E672E63616C6C286E616D652929207B0A2020202072657475726E20746869732E72656D6F76654D61746368696E67286E616D65293B0A20207D0A0A';
wwv_flow_imp.g_varchar2_table(5303) := '2020746869732E6C6973742E72656D6F7665286E616D65293B0A202072657475726E20746869733B0A7D3B0A0A2F2A2A0A202A2052656D6F766520616C6C20636C6173736573206D61746368696E6720607265602E0A202A0A202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(5304) := '5265674578707D2072650A202A204072657475726E207B436C6173734C6973747D0A202A204061706920707269766174650A202A2F0A0A436C6173734C6973742E70726F746F747970652E72656D6F76654D61746368696E67203D2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(5305) := '28726529207B0A2020636F6E737420617272203D20746869732E617272617928293B0A2020666F7220286C65742069203D20303B2069203C206172722E6C656E6774683B20692B2B29207B0A202020206966202872652E74657374286172725B695D2929';
wwv_flow_imp.g_varchar2_table(5306) := '207B0A202020202020746869732E72656D6F7665286172725B695D293B0A202020207D0A20207D0A202072657475726E20746869733B0A7D3B0A0A2F2A2A0A202A20546F67676C6520636C61737320606E616D65602C2063616E20666F72636520737461';
wwv_flow_imp.g_varchar2_table(5307) := '7465207669612060666F726365602E0A202A0A202A20466F722062726F7773657273207468617420737570706F727420636C6173734C6973742C2062757420646F206E6F7420737570706F72742060666F72636560207965742C0A202A20746865206D69';
wwv_flow_imp.g_varchar2_table(5308) := '7374616B652077696C6C20626520646574656374656420616E6420636F727265637465642E0A202A0A202A2040706172616D207B537472696E677D206E616D650A202A2040706172616D207B426F6F6C65616E7D20666F7263650A202A20407265747572';
wwv_flow_imp.g_varchar2_table(5309) := '6E207B436C6173734C6973747D0A202A2040617069207075626C69630A202A2F0A0A436C6173734C6973742E70726F746F747970652E746F67676C65203D2066756E6374696F6E286E616D652C20666F72636529207B0A20206966202827756E64656669';
wwv_flow_imp.g_varchar2_table(5310) := '6E65642720213D3D20747970656F6620666F72636529207B0A2020202069662028666F72636520213D3D20746869732E6C6973742E746F67676C65286E616D652C20666F7263652929207B0A202020202020746869732E6C6973742E746F67676C65286E';
wwv_flow_imp.g_varchar2_table(5311) := '616D65293B202F2F20746F67676C6520616761696E20746F20636F72726563740A202020207D0A20207D20656C7365207B0A20202020746869732E6C6973742E746F67676C65286E616D65293B0A20207D0A202072657475726E20746869733B0A7D3B0A';
wwv_flow_imp.g_varchar2_table(5312) := '0A2F2A2A0A202A2052657475726E20616E206172726179206F6620636C61737365732E0A202A0A202A204072657475726E207B41727261797D0A202A2040617069207075626C69630A202A2F0A0A436C6173734C6973742E70726F746F747970652E6172';
wwv_flow_imp.g_varchar2_table(5313) := '726179203D2066756E6374696F6E2829207B0A202072657475726E2041727261792E66726F6D28746869732E6C697374293B0A7D3B0A0A2F2A2A0A202A20436865636B20696620636C61737320606E616D65602069732070726573656E742E0A202A0A20';
wwv_flow_imp.g_varchar2_table(5314) := '2A2040706172616D207B537472696E677D206E616D650A202A204072657475726E207B436C6173734C6973747D0A202A2040617069207075626C69630A202A2F0A0A436C6173734C6973742E70726F746F747970652E686173203D0A436C6173734C6973';
wwv_flow_imp.g_varchar2_table(5315) := '742E70726F746F747970652E636F6E7461696E73203D2066756E6374696F6E286E616D6529207B0A202072657475726E20746869732E6C6973742E636F6E7461696E73286E616D65293B0A7D3B0A0A2F2A2A0A202A20436C656172207574696C6974790A';
wwv_flow_imp.g_varchar2_table(5316) := '202A2F0A0A2F2A2A0A202A2052656D6F76657320616C6C206368696C6472656E2066726F6D2074686520676976656E20656C656D656E740A202A0A202A2040706172616D207B456C656D656E747D20656C656D656E740A202A0A202A204072657475726E';
wwv_flow_imp.g_varchar2_table(5317) := '207B456C656D656E747D2074686520656C656D656E742028666F7220636861696E696E67290A202A2F0A66756E6374696F6E20636C65617228656C656D656E7429207B0A2020766172206368696C643B0A0A20207768696C652028286368696C64203D20';
wwv_flow_imp.g_varchar2_table(5318) := '656C656D656E742E66697273744368696C642929207B0A20202020656C656D656E742E72656D6F76654368696C64286368696C64293B0A20207D0A0A202072657475726E20656C656D656E743B0A7D0A0A2F2A2A0A202A20436C6F736573740A202A0A20';
wwv_flow_imp.g_varchar2_table(5319) := '2A2040706172616D207B456C656D656E747D20656C0A202A2040706172616D207B737472696E677D2073656C6563746F720A202A2040706172616D207B626F6F6C65616E7D20636865636B596F757253656C6620286F7074696F6E616C290A202A2F0A66';
wwv_flow_imp.g_varchar2_table(5320) := '756E6374696F6E20636C6F7365737428656C656D656E742C2073656C6563746F722C20636865636B596F757253656C6629207B0A20207661722061637475616C456C656D656E74203D20636865636B596F757253656C66203F20656C656D656E74203A20';
wwv_flow_imp.g_varchar2_table(5321) := '656C656D656E742E706172656E744E6F64653B0A0A202072657475726E2061637475616C456C656D656E7420262620747970656F662061637475616C456C656D656E742E636C6F73657374203D3D3D202766756E6374696F6E272026262061637475616C';
wwv_flow_imp.g_varchar2_table(5322) := '456C656D656E742E636C6F736573742873656C6563746F7229207C7C206E756C6C3B0A7D0A0A76617220636F6D706F6E656E744576656E74203D207B7D3B0A0A7661722062696E6424312C20756E62696E6424312C207072656669783B0A0A66756E6374';
wwv_flow_imp.g_varchar2_table(5323) := '696F6E20646574656374202829207B0A202062696E642431203D2077696E646F772E6164644576656E744C697374656E6572203F20276164644576656E744C697374656E657227203A20276174746163684576656E74273B0A2020756E62696E64243120';
wwv_flow_imp.g_varchar2_table(5324) := '3D2077696E646F772E72656D6F76654576656E744C697374656E6572203F202772656D6F76654576656E744C697374656E657227203A20276465746163684576656E74273B0A2020707265666978203D2062696E64243120213D3D20276164644576656E';
wwv_flow_imp.g_varchar2_table(5325) := '744C697374656E657227203F20276F6E27203A2027273B0A7D0A0A2F2A2A0A202A2042696E642060656C60206576656E742060747970656020746F2060666E602E0A202A0A202A2040706172616D207B456C656D656E747D20656C0A202A204070617261';
wwv_flow_imp.g_varchar2_table(5326) := '6D207B537472696E677D20747970650A202A2040706172616D207B46756E6374696F6E7D20666E0A202A2040706172616D207B426F6F6C65616E7D20636170747572650A202A204072657475726E207B46756E6374696F6E7D0A202A2040617069207075';
wwv_flow_imp.g_varchar2_table(5327) := '626C69630A202A2F0A0A7661722062696E645F31203D20636F6D706F6E656E744576656E742E62696E64203D2066756E6374696F6E28656C2C20747970652C20666E2C2063617074757265297B0A2020696620282162696E642431292064657465637428';
wwv_flow_imp.g_varchar2_table(5328) := '293B0A2020656C5B62696E6424315D28707265666978202B20747970652C20666E2C2063617074757265207C7C2066616C7365293B0A202072657475726E20666E3B0A7D3B0A0A2F2A2A0A202A20556E62696E642060656C60206576656E742060747970';
wwv_flow_imp.g_varchar2_table(5329) := '656027732063616C6C6261636B2060666E602E0A202A0A202A2040706172616D207B456C656D656E747D20656C0A202A2040706172616D207B537472696E677D20747970650A202A2040706172616D207B46756E6374696F6E7D20666E0A202A20407061';
wwv_flow_imp.g_varchar2_table(5330) := '72616D207B426F6F6C65616E7D20636170747572650A202A204072657475726E207B46756E6374696F6E7D0A202A2040617069207075626C69630A202A2F0A0A76617220756E62696E645F31203D20636F6D706F6E656E744576656E742E756E62696E64';
wwv_flow_imp.g_varchar2_table(5331) := '203D2066756E6374696F6E28656C2C20747970652C20666E2C2063617074757265297B0A20206966202821756E62696E642431292064657465637428293B0A2020656C5B756E62696E6424315D28707265666978202B20747970652C20666E2C20636170';
wwv_flow_imp.g_varchar2_table(5332) := '74757265207C7C2066616C7365293B0A202072657475726E20666E3B0A7D3B0A0A766172206576656E74203D202F2A235F5F505552455F5F2A2F5F6D657267654E616D65737061636573287B0A20205F5F70726F746F5F5F3A206E756C6C2C0A20206269';
wwv_flow_imp.g_varchar2_table(5333) := '6E643A2062696E645F312C0A2020756E62696E643A20756E62696E645F312C0A20202764656661756C74273A20636F6D706F6E656E744576656E740A7D2C205B636F6D706F6E656E744576656E745D293B0A0A2F2A2A0A202A204D6F64756C6520646570';
wwv_flow_imp.g_varchar2_table(5334) := '656E64656E636965732E0A202A2F0A0A2F2A2A0A202A2044656C6567617465206576656E742060747970656020746F206073656C6563746F72600A202A20616E6420696E766F6B652060666E286529602E20412063616C6C6261636B2066756E6374696F';
wwv_flow_imp.g_varchar2_table(5335) := '6E0A202A2069732072657475726E6564207768696368206D61792062652070617373656420746F20602E756E62696E642829602E0A202A0A202A2040706172616D207B456C656D656E747D20656C0A202A2040706172616D207B537472696E677D207365';
wwv_flow_imp.g_varchar2_table(5336) := '6C6563746F720A202A2040706172616D207B537472696E677D20747970650A202A2040706172616D207B46756E6374696F6E7D20666E0A202A2040706172616D207B426F6F6C65616E7D20636170747572650A202A204072657475726E207B46756E6374';
wwv_flow_imp.g_varchar2_table(5337) := '696F6E7D0A202A2040617069207075626C69630A202A2F0A0A2F2F20536F6D65206576656E747320646F6E277420627562626C652C20736F2077652077616E7420746F2062696E6420746F20746865206361707475726520706861736520696E73746561';
wwv_flow_imp.g_varchar2_table(5338) := '640A2F2F207768656E2064656C65676174696E672E0A76617220666F726365436170747572654576656E7473203D205B2027666F637573272C2027626C757227205D3B0A0A66756E6374696F6E2062696E6428656C2C2073656C6563746F722C20747970';
wwv_flow_imp.g_varchar2_table(5339) := '652C20666E2C206361707475726529207B0A202069662028666F726365436170747572654576656E74732E696E6465784F6628747970652920213D3D202D3129207B0A2020202063617074757265203D20747275653B0A20207D0A0A202072657475726E';
wwv_flow_imp.g_varchar2_table(5340) := '206576656E742E62696E6428656C2C20747970652C2066756E6374696F6E286529207B0A2020202076617220746172676574203D20652E746172676574207C7C20652E737263456C656D656E743B0A20202020652E64656C656761746554617267657420';
wwv_flow_imp.g_varchar2_table(5341) := '3D20636C6F73657374287461726765742C2073656C6563746F722C2074727565293B0A2020202069662028652E64656C656761746554617267657429207B0A202020202020666E2E63616C6C28656C2C2065293B0A202020207D0A20207D2C2063617074';
wwv_flow_imp.g_varchar2_table(5342) := '757265293B0A7D0A0A2F2A2A0A202A20556E62696E64206576656E742060747970656027732063616C6C6261636B2060666E602E0A202A0A202A2040706172616D207B456C656D656E747D20656C0A202A2040706172616D207B537472696E677D207479';
wwv_flow_imp.g_varchar2_table(5343) := '70650A202A2040706172616D207B46756E6374696F6E7D20666E0A202A2040706172616D207B426F6F6C65616E7D20636170747572650A202A2040617069207075626C69630A202A2F0A66756E6374696F6E20756E62696E6428656C2C20747970652C20';
wwv_flow_imp.g_varchar2_table(5344) := '666E2C206361707475726529207B0A202069662028666F726365436170747572654576656E74732E696E6465784F6628747970652920213D3D202D3129207B0A2020202063617074757265203D20747275653B0A20207D0A0A202072657475726E206576';
wwv_flow_imp.g_varchar2_table(5345) := '656E742E756E62696E6428656C2C20747970652C20666E2C2063617074757265293B0A7D0A0A7661722064656C6567617465203D207B0A202062696E642C0A2020756E62696E640A7D3B0A0A2F2A2A0A202A204578706F736520607061727365602E0A20';
wwv_flow_imp.g_varchar2_table(5346) := '2A2F0A0A76617220646F6D696679203D2070617273653B0A0A2F2A2A0A202A20546573747320666F722062726F7773657220737570706F72742E0A202A2F0A0A76617220696E6E657248544D4C427567203D2066616C73653B0A76617220627567546573';
wwv_flow_imp.g_varchar2_table(5347) := '744469763B0A69662028747970656F6620646F63756D656E7420213D3D2027756E646566696E65642729207B0A202062756754657374446976203D20646F63756D656E742E637265617465456C656D656E74282764697627293B0A20202F2F2053657475';
wwv_flow_imp.g_varchar2_table(5348) := '700A2020627567546573744469762E696E6E657248544D4C203D202720203C6C696E6B2F3E3C7461626C653E3C2F7461626C653E3C6120687265663D222F61223E613C2F613E3C696E70757420747970653D22636865636B626F78222F3E273B0A20202F';
wwv_flow_imp.g_varchar2_table(5349) := '2F204D616B6520737572652074686174206C696E6B20656C656D656E7473206765742073657269616C697A656420636F72726563746C7920627920696E6E657248544D4C0A20202F2F20546869732072657175697265732061207772617070657220656C';
wwv_flow_imp.g_varchar2_table(5350) := '656D656E7420696E2049450A2020696E6E657248544D4C427567203D2021627567546573744469762E676574456C656D656E747342795461674E616D6528276C696E6B27292E6C656E6774683B0A202062756754657374446976203D20756E646566696E';
wwv_flow_imp.g_varchar2_table(5351) := '65643B0A7D0A0A2F2A2A0A202A2057726170206D61702066726F6D206A71756572792E0A202A2F0A0A766172206D6170203D207B0A20206C6567656E643A205B312C20273C6669656C647365743E272C20273C2F6669656C647365743E275D2C0A202074';
wwv_flow_imp.g_varchar2_table(5352) := '723A205B322C20273C7461626C653E3C74626F64793E272C20273C2F74626F64793E3C2F7461626C653E275D2C0A2020636F6C3A205B322C20273C7461626C653E3C74626F64793E3C2F74626F64793E3C636F6C67726F75703E272C20273C2F636F6C67';
wwv_flow_imp.g_varchar2_table(5353) := '726F75703E3C2F7461626C653E275D2C0A20202F2F20666F72207363726970742F6C696E6B2F7374796C65207461677320746F20776F726B20696E204945362D382C20796F75206861766520746F20777261700A20202F2F20696E206120646976207769';
wwv_flow_imp.g_varchar2_table(5354) := '74682061206E6F6E2D776869746573706163652063686172616374657220696E2066726F6E742C206861210A20205F64656661756C743A20696E6E657248544D4C427567203F205B312C2027583C6469763E272C20273C2F6469763E275D203A205B302C';
wwv_flow_imp.g_varchar2_table(5355) := '2027272C2027275D0A7D3B0A0A6D61702E7464203D0A6D61702E7468203D205B332C20273C7461626C653E3C74626F64793E3C74723E272C20273C2F74723E3C2F74626F64793E3C2F7461626C653E275D3B0A0A6D61702E6F7074696F6E203D0A6D6170';
wwv_flow_imp.g_varchar2_table(5356) := '2E6F707467726F7570203D205B312C20273C73656C656374206D756C7469706C653D226D756C7469706C65223E272C20273C2F73656C6563743E275D3B0A0A6D61702E7468656164203D0A6D61702E74626F6479203D0A6D61702E636F6C67726F757020';
wwv_flow_imp.g_varchar2_table(5357) := '3D0A6D61702E63617074696F6E203D0A6D61702E74666F6F74203D205B312C20273C7461626C653E272C20273C2F7461626C653E275D3B0A0A6D61702E706F6C796C696E65203D0A6D61702E656C6C69707365203D0A6D61702E706F6C79676F6E203D0A';
wwv_flow_imp.g_varchar2_table(5358) := '6D61702E636972636C65203D0A6D61702E74657874203D0A6D61702E6C696E65203D0A6D61702E70617468203D0A6D61702E72656374203D0A6D61702E67203D205B312C20273C73766720786D6C6E733D22687474703A2F2F7777772E77332E6F72672F';
wwv_flow_imp.g_varchar2_table(5359) := '323030302F737667222076657273696F6E3D22312E31223E272C273C2F7376673E275D3B0A0A2F2A2A0A202A205061727365206068746D6C6020616E642072657475726E206120444F4D204E6F646520696E7374616E63652C20776869636820636F756C';
wwv_flow_imp.g_varchar2_table(5360) := '64206265206120546578744E6F64652C0A202A2048544D4C20444F4D204E6F6465206F6620736F6D65206B696E6420283C6469763E20666F72206578616D706C65292C206F72206120446F63756D656E74467261676D656E740A202A20696E7374616E63';
wwv_flow_imp.g_varchar2_table(5361) := '652C20646570656E64696E67206F6E2074686520636F6E74656E7473206F6620746865206068746D6C6020737472696E672E0A202A0A202A2040706172616D207B537472696E677D2068746D6C202D2048544D4C20737472696E6720746F2022646F6D69';
wwv_flow_imp.g_varchar2_table(5362) := '6679220A202A2040706172616D207B446F63756D656E747D20646F63202D205468652060646F63756D656E746020696E7374616E636520746F2063726561746520746865204E6F646520666F720A202A204072657475726E207B444F4D4E6F64657D2074';
wwv_flow_imp.g_varchar2_table(5363) := '686520546578744E6F64652C20444F4D204E6F64652C206F7220446F63756D656E74467261676D656E7420696E7374616E63650A202A204061706920707269766174650A202A2F0A0A66756E6374696F6E2070617273652868746D6C2C20646F6329207B';
wwv_flow_imp.g_varchar2_table(5364) := '0A20206966202827737472696E672720213D20747970656F662068746D6C29207468726F77206E657720547970654572726F722827537472696E6720657870656374656427293B0A0A20202F2F2064656661756C7420746F2074686520676C6F62616C20';
wwv_flow_imp.g_varchar2_table(5365) := '60646F63756D656E7460206F626A6563740A20206966202821646F632920646F63203D20646F63756D656E743B0A0A20202F2F20746167206E616D650A2020766172206D203D202F3C285B5C773A5D2B292F2E657865632868746D6C293B0A2020696620';
wwv_flow_imp.g_varchar2_table(5366) := '28216D292072657475726E20646F632E637265617465546578744E6F64652868746D6C293B0A0A202068746D6C203D2068746D6C2E7265706C616365282F5E5C732B7C5C732B242F672C202727293B202F2F2052656D6F7665206C656164696E672F7472';
wwv_flow_imp.g_varchar2_table(5367) := '61696C696E6720776869746573706163650A0A202076617220746167203D206D5B315D3B0A0A20202F2F20626F647920737570706F72740A202069662028746167203D3D2027626F64792729207B0A2020202076617220656C203D20646F632E63726561';
wwv_flow_imp.g_varchar2_table(5368) := '7465456C656D656E74282768746D6C27293B0A20202020656C2E696E6E657248544D4C203D2068746D6C3B0A2020202072657475726E20656C2E72656D6F76654368696C6428656C2E6C6173744368696C64293B0A20207D0A0A20202F2F207772617020';
wwv_flow_imp.g_varchar2_table(5369) := '6D61700A20207661722077726170203D204F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C286D61702C2074616729203F206D61705B7461675D203A206D61702E5F64656661756C743B0A202076617220646570';
wwv_flow_imp.g_varchar2_table(5370) := '7468203D20777261705B305D3B0A202076617220707265666978203D20777261705B315D3B0A202076617220737566666978203D20777261705B325D3B0A202076617220656C203D20646F632E637265617465456C656D656E74282764697627293B0A20';
wwv_flow_imp.g_varchar2_table(5371) := '20656C2E696E6E657248544D4C203D20707265666978202B2068746D6C202B207375666669783B0A20207768696C65202864657074682D2D2920656C203D20656C2E6C6173744368696C643B0A0A20202F2F206F6E6520656C656D656E740A2020696620';
wwv_flow_imp.g_varchar2_table(5372) := '28656C2E66697273744368696C64203D3D20656C2E6C6173744368696C6429207B0A2020202072657475726E20656C2E72656D6F76654368696C6428656C2E66697273744368696C64293B0A20207D0A0A20202F2F207365766572616C20656C656D656E';
wwv_flow_imp.g_varchar2_table(5373) := '74730A202076617220667261676D656E74203D20646F632E637265617465446F63756D656E74467261676D656E7428293B0A20207768696C652028656C2E66697273744368696C6429207B0A20202020667261676D656E742E617070656E644368696C64';
wwv_flow_imp.g_varchar2_table(5374) := '28656C2E72656D6F76654368696C6428656C2E66697273744368696C6429293B0A20207D0A0A202072657475726E20667261676D656E743B0A7D0A0A76617220646F6D6966792431203D20646F6D6966793B0A0A2F2A2A0A202A2040706172616D207B20';
wwv_flow_imp.g_varchar2_table(5375) := '48544D4C456C656D656E74207D20656C656D656E740A202A2040706172616D207B20537472696E67207D2073656C6563746F720A202A0A202A204072657475726E207B20626F6F6C65616E207D0A202A2F0A66756E6374696F6E206D6174636865732865';
wwv_flow_imp.g_varchar2_table(5376) := '6C656D656E742C2073656C6563746F7229207B0A202072657475726E20656C656D656E7420262620747970656F6620656C656D656E742E6D617463686573203D3D3D202766756E6374696F6E2720262620656C656D656E742E6D6174636865732873656C';
wwv_flow_imp.g_varchar2_table(5377) := '6563746F7229207C7C2066616C73653B0A7D0A0A66756E6374696F6E2071756572792873656C6563746F722C20656C29207B0A2020656C203D20656C207C7C20646F63756D656E743B0A0A202072657475726E20656C2E717565727953656C6563746F72';
wwv_flow_imp.g_varchar2_table(5378) := '2873656C6563746F72293B0A7D0A0A66756E6374696F6E20616C6C2873656C6563746F722C20656C29207B0A2020656C203D20656C207C7C20646F63756D656E743B0A0A202072657475726E20656C2E717565727953656C6563746F72416C6C2873656C';
wwv_flow_imp.g_varchar2_table(5379) := '6563746F72293B0A7D0A0A66756E6374696F6E2072656D6F766528656C29207B0A2020656C2E706172656E744E6F646520262620656C2E706172656E744E6F64652E72656D6F76654368696C6428656C293B0A7D0A0A0A2F2F2320736F757263654D6170';
wwv_flow_imp.g_varchar2_table(5380) := '70696E6755524C3D696E6465782E65736D2E6A732E6D61700A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F736178656E2F646973742F696E6465782E65736D2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(5381) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F736178656E2F646973742F696E6465782E65736D2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(5382) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C205F5F7765627061636B5F6578706F7274735F5F2C205F5F776562';
wwv_flow_imp.g_varchar2_table(5383) := '7061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571';
wwv_flow_imp.g_varchar2_table(5384) := '756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020205061727365723A202829203D3E20282F2A2062696E64696E67202A2F20506172736572292C0A2F2A206861726D';
wwv_flow_imp.g_varchar2_table(5385) := '6F6E79206578706F7274202A2F2020206465636F64653A202829203D3E20282F2A2062696E64696E67202A2F206465636F6465456E746974696573290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A7661722066726F6D43686172436F';
wwv_flow_imp.g_varchar2_table(5386) := '6465203D20537472696E672E66726F6D43686172436F64653B0A0A766172206861734F776E50726F7065727479203D204F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B0A0A76617220454E544954595F5041545445524E';
wwv_flow_imp.g_varchar2_table(5387) := '203D202F2623285C642B293B7C262378285B302D39612D665D2B293B7C26285C772B293B2F69673B0A0A76617220454E544954595F4D415050494E47203D207B0A202027616D70273A202726272C0A20202761706F73273A20275C27272C0A2020276774';
wwv_flow_imp.g_varchar2_table(5388) := '273A20273E272C0A2020276C74273A20273C272C0A20202771756F74273A202722270A7D3B0A0A2F2F206D6170205550504552434153452076617269616E7473206F6620737570706F72746564207370656369616C2063686172730A4F626A6563742E6B';
wwv_flow_imp.g_varchar2_table(5389) := '65797328454E544954595F4D415050494E47292E666F72456163682866756E6374696F6E286B29207B0A2020454E544954595F4D415050494E475B6B2E746F55707065724361736528295D203D20454E544954595F4D415050494E475B6B5D3B0A7D293B';
wwv_flow_imp.g_varchar2_table(5390) := '0A0A0A66756E6374696F6E207265706C616365456E746974696573285F2C20642C20782C207A29207B0A0A20202F2F207265736572766564206E616D65732C20692E652E20266E6273703B0A2020696620287A29207B0A20202020696620286861734F77';
wwv_flow_imp.g_varchar2_table(5391) := '6E50726F70657274792E63616C6C28454E544954595F4D415050494E472C207A2929207B0A20202020202072657475726E20454E544954595F4D415050494E475B7A5D3B0A202020207D20656C7365207B0A0A2020202020202F2F2066616C6C20626163';
wwv_flow_imp.g_varchar2_table(5392) := '6B20746F206F726967696E616C2076616C75650A20202020202072657475726E20272627202B207A202B20273B273B0A202020207D0A20207D0A0A20202F2F20646563696D616C20656E636F64656420636861720A2020696620286429207B0A20202020';
wwv_flow_imp.g_varchar2_table(5393) := '72657475726E2066726F6D43686172436F64652864293B0A20207D0A0A20202F2F2068657820656E636F64656420636861720A202072657475726E2066726F6D43686172436F6465287061727365496E7428782C20313629293B0A7D0A0A0A2F2A2A0A20';
wwv_flow_imp.g_varchar2_table(5394) := '2A204120626173696320656E74697479206465636F64657220746861742063616E206465636F64652061206D696E696D616C0A202A207375622D736574206F66207265736572766564206E616D6573202826616D703B292061732077656C6C2061730A20';
wwv_flow_imp.g_varchar2_table(5395) := '2A2068657820282623786161663B2920616E6420646563696D616C20282623313233313B2920656E636F64656420636861726163746572732E0A202A0A202A2040706172616D207B737472696E677D207374720A202A0A202A204072657475726E207B73';
wwv_flow_imp.g_varchar2_table(5396) := '7472696E677D206465636F64656420737472696E670A202A2F0A66756E6374696F6E206465636F6465456E746974696573287329207B0A202069662028732E6C656E677468203E203320262620732E696E6465784F66282726272920213D3D202D312920';
wwv_flow_imp.g_varchar2_table(5397) := '7B0A2020202072657475726E20732E7265706C61636528454E544954595F5041545445524E2C207265706C616365456E746974696573293B0A20207D0A0A202072657475726E20733B0A7D0A0A766172205853495F555249203D2027687474703A2F2F77';
wwv_flow_imp.g_varchar2_table(5398) := '77772E77332E6F72672F323030312F584D4C536368656D612D696E7374616E6365273B0A766172205853495F505245464958203D2027787369273B0A766172205853495F54595045203D20277873693A74797065273B0A0A766172204E4F4E5F57484954';
wwv_flow_imp.g_varchar2_table(5399) := '4553504143455F4F5554534944455F524F4F545F4E4F4445203D20276E6F6E2D77686974657370616365206F757473696465206F6620726F6F74206E6F6465273B0A0A66756E6374696F6E206572726F72286D736729207B0A202072657475726E206E65';
wwv_flow_imp.g_varchar2_table(5400) := '77204572726F72286D7367293B0A7D0A0A66756E6374696F6E206D697373696E674E616D657370616365466F725072656669782870726566697829207B0A202072657475726E20276D697373696E67206E616D65737061636520666F7220707265666978';
wwv_flow_imp.g_varchar2_table(5401) := '203C27202B20707265666978202B20273E273B0A7D0A0A66756E6374696F6E2067657474657228676574466E29207B0A202072657475726E207B0A2020202027676574273A20676574466E2C0A2020202027656E756D657261626C65273A20747275650A';
wwv_flow_imp.g_varchar2_table(5402) := '20207D3B0A7D0A0A66756E6374696F6E20636C6F6E654E734D6174726978286E734D617472697829207B0A202076617220636C6F6E65203D207B7D2C206B65793B0A2020666F7220286B657920696E206E734D617472697829207B0A20202020636C6F6E';
wwv_flow_imp.g_varchar2_table(5403) := '655B6B65795D203D206E734D61747269785B6B65795D3B0A20207D0A202072657475726E20636C6F6E653B0A7D0A0A66756E6374696F6E207572695072656669782870726566697829207B0A202072657475726E20707265666978202B20272475726927';
wwv_flow_imp.g_varchar2_table(5404) := '3B0A7D0A0A66756E6374696F6E206275696C644E734D6174726978286E73557269546F50726566697829207B0A2020766172206E734D6174726978203D207B7D2C0A2020202020207572692C0A2020202020207072656669783B0A0A2020666F72202875';
wwv_flow_imp.g_varchar2_table(5405) := '726920696E206E73557269546F50726566697829207B0A20202020707265666978203D206E73557269546F5072656669785B7572695D3B0A202020206E734D61747269785B7072656669785D203D207072656669783B0A202020206E734D61747269785B';
wwv_flow_imp.g_varchar2_table(5406) := '75726950726566697828707265666978295D203D207572693B0A20207D0A0A202072657475726E206E734D61747269783B0A7D0A0A66756E6374696F6E206E6F6F70476574436F6E746578742829207B0A202072657475726E207B20276C696E65273A20';
wwv_flow_imp.g_varchar2_table(5407) := '302C2027636F6C756D6E273A2030207D3B0A7D0A0A66756E6374696F6E207468726F7746756E632865727229207B0A20207468726F77206572723B0A7D0A0A2F2A2A0A202A20437265617465732061206E65772070617273657220776974682074686520';
wwv_flow_imp.g_varchar2_table(5408) := '676976656E206F7074696F6E732E0A202A0A202A2040636F6E7374727563746F720A202A0A202A2040706172616D20207B214F626A6563743C737472696E672C203F3E3D7D206F7074696F6E730A202A2F0A66756E6374696F6E20506172736572286F70';
wwv_flow_imp.g_varchar2_table(5409) := '74696F6E7329207B0A0A202069662028217468697329207B0A2020202072657475726E206E657720506172736572286F7074696F6E73293B0A20207D0A0A20207661722070726F7879203D206F7074696F6E73202626206F7074696F6E735B2770726F78';
wwv_flow_imp.g_varchar2_table(5410) := '79275D3B0A0A2020766172206F6E546578742C0A2020202020206F6E4F70656E5461672C0A2020202020206F6E436C6F73655461672C0A2020202020206F6E43444154412C0A2020202020206F6E4572726F72203D207468726F7746756E632C0A202020';
wwv_flow_imp.g_varchar2_table(5411) := '2020206F6E5761726E696E672C0A2020202020206F6E436F6D6D656E742C0A2020202020206F6E5175657374696F6E2C0A2020202020206F6E417474656E74696F6E3B0A0A202076617220676574436F6E74657874203D206E6F6F70476574436F6E7465';
wwv_flow_imp.g_varchar2_table(5412) := '78743B0A0A20202F2A2A0A2020202A20446F207765206E65656420746F207061727365207468652063757272656E7420656C656D656E7473206174747269627574657320666F72206E616D657370616365733F0A2020202A0A2020202A20407479706520';
wwv_flow_imp.g_varchar2_table(5413) := '7B626F6F6C65616E7D0A2020202A2F0A2020766172206D617962654E53203D2066616C73653B0A0A20202F2A2A0A2020202A20446F2077652070726F63657373206E616D6573706163657320617420616C6C3F0A2020202A0A2020202A20407479706520';
wwv_flow_imp.g_varchar2_table(5414) := '7B626F6F6C65616E7D0A2020202A2F0A20207661722069734E616D657370616365203D2066616C73653B0A0A20202F2A2A0A2020202A2054686520636175676874206572726F722072657475726E6564206F6E20706172736520656E640A2020202A0A20';
wwv_flow_imp.g_varchar2_table(5415) := '20202A204074797065207B4572726F727D0A2020202A2F0A20207661722072657475726E4572726F72203D206E756C6C3B0A0A20202F2A2A0A2020202A2053686F756C642077652073746F702070617273696E673F0A2020202A0A2020202A2040747970';
wwv_flow_imp.g_varchar2_table(5416) := '65207B626F6F6C65616E7D0A2020202A2F0A202076617220706172736553746F70203D2066616C73653B0A0A20202F2A2A0A2020202A2041206D6170206F66207B207572693A20707265666978207D207573656420627920746865207061727365722E0A';
wwv_flow_imp.g_varchar2_table(5417) := '2020202A0A2020202A2054686973206D61702077696C6C20656E737572652077652063616E206E6F726D616C697A6520707265666978657320647572696E672070726F63657373696E673B0A2020202A20666F722065616368207572692C206F6E6C7920';
wwv_flow_imp.g_varchar2_table(5418) := '6F6E65207072656669782077696C6C206265206578706F73656420746F207468652068616E646C6572732E0A2020202A0A2020202A204074797065207B214F626A6563743C737472696E672C20737472696E673E7D7D0A2020202A2F0A2020766172206E';
wwv_flow_imp.g_varchar2_table(5419) := '73557269546F5072656669783B0A0A20202F2A2A0A2020202A2048616E646C65207061727365206572726F722E0A2020202A0A2020202A2040706172616D20207B737472696E677C4572726F727D206572720A2020202A2F0A202066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(5420) := '68616E646C654572726F722865727229207B0A2020202069662028212865727220696E7374616E63656F66204572726F722929207B0A202020202020657272203D206572726F7228657272293B0A202020207D0A0A2020202072657475726E4572726F72';
wwv_flow_imp.g_varchar2_table(5421) := '203D206572723B0A0A202020206F6E4572726F72286572722C20676574436F6E74657874293B0A20207D0A0A20202F2A2A0A2020202A2048616E646C65207061727365206572726F722E0A2020202A0A2020202A2040706172616D20207B737472696E67';
wwv_flow_imp.g_varchar2_table(5422) := '7C4572726F727D206572720A2020202A2F0A202066756E6374696F6E2068616E646C655761726E696E672865727229207B0A0A2020202069662028216F6E5761726E696E6729207B0A20202020202072657475726E3B0A202020207D0A0A202020206966';
wwv_flow_imp.g_varchar2_table(5423) := '2028212865727220696E7374616E63656F66204572726F722929207B0A202020202020657272203D206572726F7228657272293B0A202020207D0A0A202020206F6E5761726E696E67286572722C20676574436F6E74657874293B0A20207D0A0A20202F';
wwv_flow_imp.g_varchar2_table(5424) := '2A2A0A2020202A205265676973746572207061727365206C697374656E65722E0A2020202A0A2020202A2040706172616D20207B737472696E677D2020206E616D650A2020202A2040706172616D20207B46756E6374696F6E7D2063620A2020202A0A20';
wwv_flow_imp.g_varchar2_table(5425) := '20202A204072657475726E207B5061727365727D0A2020202A2F0A2020746869735B276F6E275D203D2066756E6374696F6E286E616D652C20636229207B0A0A2020202069662028747970656F6620636220213D3D202766756E6374696F6E2729207B0A';
wwv_flow_imp.g_varchar2_table(5426) := '2020202020207468726F77206572726F72282772657175697265642061726773203C6E616D652C2063623E27293B0A202020207D0A0A2020202073776974636820286E616D6529207B0A202020206361736520276F70656E546167273A206F6E4F70656E';
wwv_flow_imp.g_varchar2_table(5427) := '546167203D2063623B20627265616B3B0A2020202063617365202774657874273A206F6E54657874203D2063623B20627265616B3B0A20202020636173652027636C6F7365546167273A206F6E436C6F7365546167203D2063623B20627265616B3B0A20';
wwv_flow_imp.g_varchar2_table(5428) := '2020206361736520276572726F72273A206F6E4572726F72203D2063623B20627265616B3B0A202020206361736520277761726E273A206F6E5761726E696E67203D2063623B20627265616B3B0A202020206361736520276364617461273A206F6E4344';
wwv_flow_imp.g_varchar2_table(5429) := '415441203D2063623B20627265616B3B0A20202020636173652027617474656E74696F6E273A206F6E417474656E74696F6E203D2063623B20627265616B3B202F2F203C215858585858207A7A7A7A3D2265656565223E0A202020206361736520277175';
wwv_flow_imp.g_varchar2_table(5430) := '657374696F6E273A206F6E5175657374696F6E203D2063623B20627265616B3B202F2F203C3F202E2E2E2E20203F3E0A20202020636173652027636F6D6D656E74273A206F6E436F6D6D656E74203D2063623B20627265616B3B0A202020206465666175';
wwv_flow_imp.g_varchar2_table(5431) := '6C743A0A2020202020207468726F77206572726F722827756E737570706F72746564206576656E743A2027202B206E616D65293B0A202020207D0A0A2020202072657475726E20746869733B0A20207D3B0A0A20202F2A2A0A2020202A20536574207468';
wwv_flow_imp.g_varchar2_table(5432) := '65206E616D65737061636520746F20707265666978206D617070696E672E0A2020202A0A2020202A20406578616D706C650A2020202A0A2020202A207061727365722E6E73287B0A2020202A20202027687474703A2F2F666F6F273A2027666F6F272C0A';
wwv_flow_imp.g_varchar2_table(5433) := '2020202A20202027687474703A2F2F626172273A2027626172270A2020202A207D293B0A2020202A0A2020202A2040706172616D20207B214F626A6563743C737472696E672C20737472696E673E7D206E734D61700A2020202A0A2020202A2040726574';
wwv_flow_imp.g_varchar2_table(5434) := '75726E207B5061727365727D0A2020202A2F0A2020746869735B276E73275D203D2066756E6374696F6E286E734D617029207B0A0A2020202069662028747970656F66206E734D6170203D3D3D2027756E646566696E65642729207B0A2020202020206E';
wwv_flow_imp.g_varchar2_table(5435) := '734D6170203D207B7D3B0A202020207D0A0A2020202069662028747970656F66206E734D617020213D3D20276F626A6563742729207B0A2020202020207468726F77206572726F72282772657175697265642061726773203C6E734D61703D7B7D3E2729';
wwv_flow_imp.g_varchar2_table(5436) := '3B0A202020207D0A0A20202020766172205F6E73557269546F507265666978203D207B7D2C206B3B0A0A20202020666F7220286B20696E206E734D617029207B0A2020202020205F6E73557269546F5072656669785B6B5D203D206E734D61705B6B5D3B';
wwv_flow_imp.g_varchar2_table(5437) := '0A202020207D0A0A202020202F2F20464F5243452064656661756C74206D617070696E6720666F7220736368656D6120696E7374616E63650A202020205F6E73557269546F5072656669785B5853495F5552495D203D205853495F5052454649583B0A0A';
wwv_flow_imp.g_varchar2_table(5438) := '2020202069734E616D657370616365203D20747275653B0A202020206E73557269546F507265666978203D205F6E73557269546F5072656669783B0A0A2020202072657475726E20746869733B0A20207D3B0A0A20202F2A2A0A2020202A205061727365';
wwv_flow_imp.g_varchar2_table(5439) := '20786D6C20737472696E672E0A2020202A0A2020202A2040706172616D20207B737472696E677D20786D6C0A2020202A0A2020202A204072657475726E207B4572726F727D2072657475726E4572726F722C206966206E6F74207468726F776E0A202020';
wwv_flow_imp.g_varchar2_table(5440) := '2A2F0A2020746869735B277061727365275D203D2066756E6374696F6E28786D6C29207B0A2020202069662028747970656F6620786D6C20213D3D2027737472696E672729207B0A2020202020207468726F77206572726F722827726571756972656420';
wwv_flow_imp.g_varchar2_table(5441) := '61726773203C786D6C3D737472696E673E27293B0A202020207D0A0A2020202072657475726E4572726F72203D206E756C6C3B0A0A20202020706172736528786D6C293B0A0A20202020676574436F6E74657874203D206E6F6F70476574436F6E746578';
wwv_flow_imp.g_varchar2_table(5442) := '743B0A20202020706172736553746F70203D2066616C73653B0A0A2020202072657475726E2072657475726E4572726F723B0A20207D3B0A0A20202F2A2A0A2020202A2053746F702070617273696E672E0A2020202A2F0A2020746869735B2773746F70';
wwv_flow_imp.g_varchar2_table(5443) := '275D203D2066756E6374696F6E2829207B0A20202020706172736553746F70203D20747275653B0A20207D3B0A0A20202F2A2A0A2020202A20506172736520737472696E672C20696E766F6B696E6720636F6E66696775726564206C697374656E657273';
wwv_flow_imp.g_varchar2_table(5444) := '206F6E20656C656D656E742E0A2020202A0A2020202A2040706172616D20207B737472696E677D20786D6C0A2020202A2F0A202066756E6374696F6E20706172736528786D6C29207B0A20202020766172206E734D6174726978537461636B203D206973';
wwv_flow_imp.g_varchar2_table(5445) := '4E616D657370616365203F205B5D203A206E756C6C2C0A20202020202020206E734D6174726978203D2069734E616D657370616365203F206275696C644E734D6174726978286E73557269546F50726566697829203A206E756C6C2C0A20202020202020';
wwv_flow_imp.g_varchar2_table(5446) := '205F6E734D61747269782C0A20202020202020206E6F6465537461636B203D205B5D2C0A2020202020202020616E6F6E796D6F75734E73436F756E74203D20302C0A20202020202020207461675374617274203D2066616C73652C0A2020202020202020';
wwv_flow_imp.g_varchar2_table(5447) := '746167456E64203D2066616C73652C0A202020202020202069203D20302C206A203D20302C0A2020202020202020782C20792C20712C20772C20762C0A2020202020202020786D6C6E732C0A2020202020202020656C656D656E744E616D652C0A202020';
wwv_flow_imp.g_varchar2_table(5448) := '20202020205F656C656D656E744E616D652C0A2020202020202020656C656D656E7450726F78790A20202020202020203B0A0A20202020766172206174747273537472696E67203D2027272C0A202020202020202061747472735374617274203D20302C';
wwv_flow_imp.g_varchar2_table(5449) := '0A20202020202020206361636865644174747273202F2F2066616C7365203D207061727365642077697468206572726F72732C206E756C6C203D206E656564732070617273696E670A20202020202020203B0A0A202020202F2A2A0A20202020202A2050';
wwv_flow_imp.g_varchar2_table(5450) := '617273652061747472696275746573206F6E2064656D616E6420616E642072657475726E73207468652070617273656420617474726962757465732E0A20202020202A0A20202020202A2052657475726E2073656D616E746963733A2028312920606661';
wwv_flow_imp.g_varchar2_table(5451) := '6C736560206F6E20617474726962757465207061727365206572726F722C0A20202020202A20283229206F626A6563742068617368206F6E206578747261637465642061747472732E0A20202020202A0A20202020202A204072657475726E207B626F6F';
wwv_flow_imp.g_varchar2_table(5452) := '6C65616E7C4F626A6563747D0A20202020202A2F0A2020202066756E6374696F6E2067657441747472732829207B0A20202020202069662028636163686564417474727320213D3D206E756C6C29207B0A202020202020202072657475726E2063616368';
wwv_flow_imp.g_varchar2_table(5453) := '656441747472733B0A2020202020207D0A0A202020202020766172206E735572692C0A202020202020202020206E735572695072656669782C0A202020202020202020206E734E616D652C0A2020202020202020202064656661756C74416C696173203D';
wwv_flow_imp.g_varchar2_table(5454) := '2069734E616D657370616365202626206E734D61747269785B27786D6C6E73275D2C0A20202020202020202020617474724C697374203D2069734E616D657370616365202626206D617962654E53203F205B5D203A206E756C6C2C0A2020202020202020';
wwv_flow_imp.g_varchar2_table(5455) := '202069203D20617474727353746172742C0A2020202020202020202073203D206174747273537472696E672C0A202020202020202020206C203D20732E6C656E6774682C0A202020202020202020206861734E65774D61747269782C0A20202020202020';
wwv_flow_imp.g_varchar2_table(5456) := '2020206E6577616C6961732C0A2020202020202020202076616C75652C0A20202020202020202020616C6961732C0A202020202020202020206E616D652C0A202020202020202020206174747273203D207B7D2C0A202020202020202020207365656E41';
wwv_flow_imp.g_varchar2_table(5457) := '74747273203D207B7D2C0A20202020202020202020736B6970417474722C0A20202020202020202020772C0A202020202020202020206A3B0A0A2020202020207061727365417474723A0A202020202020666F7220283B2069203C206C3B20692B2B2920';
wwv_flow_imp.g_varchar2_table(5458) := '7B0A2020202020202020736B697041747472203D2066616C73653B0A202020202020202077203D20732E63686172436F646541742869293B0A0A20202020202020206966202877203D3D3D203332207C7C202877203C2031342026262077203E20382929';
wwv_flow_imp.g_varchar2_table(5459) := '207B202F2F20574849544553504143453D7B205C665C6E5C725C745C767D0A20202020202020202020636F6E74696E75653B0A20202020202020207D0A0A20202020202020202F2F207761697420666F72206E6F6E207768697465737061636520636861';
wwv_flow_imp.g_varchar2_table(5460) := '7261637465720A20202020202020206966202877203C203635207C7C2077203E20313232207C7C202877203E2039302026262077203C2039372929207B0A20202020202020202020696620287720213D3D203935202626207720213D3D20353829207B20';
wwv_flow_imp.g_varchar2_table(5461) := '2F2F2063686172203935225F22203538223A220A20202020202020202020202068616E646C655761726E696E672827696C6C6567616C206669727374206368617220617474726962757465206E616D6527293B0A202020202020202020202020736B6970';
wwv_flow_imp.g_varchar2_table(5462) := '41747472203D20747275653B0A202020202020202020207D0A20202020202020207D0A0A20202020202020202F2F20706172736520617474726962757465206E616D650A2020202020202020666F7220286A203D2069202B20313B206A203C206C3B206A';
wwv_flow_imp.g_varchar2_table(5463) := '2B2B29207B0A2020202020202020202077203D20732E63686172436F64654174286A293B0A0A20202020202020202020696620280A20202020202020202020202077203E2039362026262077203C20313233207C7C0A2020202020202020202020207720';
wwv_flow_imp.g_varchar2_table(5464) := '3E2036342026262077203C203931207C7C0A20202020202020202020202077203E2034372026262077203C203539207C7C0A20202020202020202020202077203D3D3D203436207C7C202F2F20272E270A20202020202020202020202077203D3D3D2034';
wwv_flow_imp.g_varchar2_table(5465) := '35207C7C202F2F20272D270A20202020202020202020202077203D3D3D203935202F2F20275F270A2020202020202020202029207B0A202020202020202020202020636F6E74696E75653B0A202020202020202020207D0A0A202020202020202020202F';
wwv_flow_imp.g_varchar2_table(5466) := '2F20756E657870656374656420776869746573706163650A202020202020202020206966202877203D3D3D203332207C7C202877203C2031342026262077203E20382929207B202F2F20574849544553504143450A20202020202020202020202068616E';
wwv_flow_imp.g_varchar2_table(5467) := '646C655761726E696E6728276D697373696E67206174747269627574652076616C756527293B0A20202020202020202020202069203D206A3B0A0A202020202020202020202020636F6E74696E7565207061727365417474723B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(5468) := '207D0A0A202020202020202020202F2F20657870656374656420223D220A202020202020202020206966202877203D3D3D20363129207B202F2F20223D22203D3D2036310A202020202020202020202020627265616B3B0A202020202020202020207D0A';
wwv_flow_imp.g_varchar2_table(5469) := '0A2020202020202020202068616E646C655761726E696E672827696C6C6567616C20617474726962757465206E616D65206368617227293B0A20202020202020202020736B697041747472203D20747275653B0A20202020202020207D0A0A2020202020';
wwv_flow_imp.g_varchar2_table(5470) := '2020206E616D65203D20732E737562737472696E6728692C206A293B0A0A2020202020202020696620286E616D65203D3D3D2027786D6C6E733A786D6C6E732729207B0A2020202020202020202068616E646C655761726E696E672827696C6C6567616C';
wwv_flow_imp.g_varchar2_table(5471) := '206465636C61726174696F6E206F6620786D6C6E7327293B0A20202020202020202020736B697041747472203D20747275653B0A20202020202020207D0A0A202020202020202077203D20732E63686172436F64654174286A202B2031293B0A0A202020';
wwv_flow_imp.g_varchar2_table(5472) := '20202020206966202877203D3D3D20333429207B202F2F202722270A202020202020202020206A203D20732E696E6465784F66282722272C2069203D206A202B2032293B0A0A20202020202020202020696620286A203D3D3D202D3129207B0A20202020';
wwv_flow_imp.g_varchar2_table(5473) := '20202020202020206A203D20732E696E6465784F6628275C27272C2069293B0A0A202020202020202020202020696620286A20213D3D202D3129207B0A202020202020202020202020202068616E646C655761726E696E67282761747472696275746520';
wwv_flow_imp.g_varchar2_table(5474) := '76616C75652071756F7465206D6973736D6174636827293B0A2020202020202020202020202020736B697041747472203D20747275653B0A2020202020202020202020207D0A202020202020202020207D0A0A20202020202020207D20656C7365206966';
wwv_flow_imp.g_varchar2_table(5475) := '202877203D3D3D20333929207B202F2F202227220A202020202020202020206A203D20732E696E6465784F6628275C27272C2069203D206A202B2032293B0A0A20202020202020202020696620286A203D3D3D202D3129207B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(5476) := '20206A203D20732E696E6465784F66282722272C2069293B0A0A202020202020202020202020696620286A20213D3D202D3129207B0A202020202020202020202020202068616E646C655761726E696E6728276174747269627574652076616C75652071';
wwv_flow_imp.g_varchar2_table(5477) := '756F7465206D6973736D6174636827293B0A2020202020202020202020202020736B697041747472203D20747275653B0A2020202020202020202020207D0A202020202020202020207D0A0A20202020202020207D20656C7365207B0A20202020202020';
wwv_flow_imp.g_varchar2_table(5478) := '20202068616E646C655761726E696E6728276D697373696E67206174747269627574652076616C75652071756F74657327293B0A20202020202020202020736B697041747472203D20747275653B0A0A202020202020202020202F2F20736B697020746F';
wwv_flow_imp.g_varchar2_table(5479) := '206E6578742073706163650A20202020202020202020666F7220286A203D206A202B20313B206A203C206C3B206A2B2B29207B0A20202020202020202020202077203D20732E63686172436F64654174286A202B2031293B0A0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(5480) := '20206966202877203D3D3D203332207C7C202877203C2031342026262077203E20382929207B202F2F20574849544553504143450A2020202020202020202020202020627265616B3B0A2020202020202020202020207D0A202020202020202020207D0A';
wwv_flow_imp.g_varchar2_table(5481) := '0A20202020202020207D0A0A2020202020202020696620286A203D3D3D202D3129207B0A2020202020202020202068616E646C655761726E696E6728276D697373696E6720636C6F73696E672071756F74657327293B0A0A202020202020202020206A20';
wwv_flow_imp.g_varchar2_table(5482) := '3D206C3B0A20202020202020202020736B697041747472203D20747275653B0A20202020202020207D0A0A20202020202020206966202821736B69704174747229207B0A2020202020202020202076616C7565203D20732E737562737472696E6728692C';
wwv_flow_imp.g_varchar2_table(5483) := '206A293B0A20202020202020207D0A0A202020202020202069203D206A3B0A0A20202020202020202F2F20656E7375726520535041434520666F6C6C6F7773206174747269627574650A20202020202020202F2F20736B697020696C6C6567616C20636F';
wwv_flow_imp.g_varchar2_table(5484) := '6E74656E74206F74686572776973650A20202020202020202F2F206578616D706C6520613D226222630A2020202020202020666F7220283B206A202B2031203C206C3B206A2B2B29207B0A2020202020202020202077203D20732E63686172436F646541';
wwv_flow_imp.g_varchar2_table(5485) := '74286A202B2031293B0A0A202020202020202020206966202877203D3D3D203332207C7C202877203C2031342026262077203E20382929207B202F2F20574849544553504143450A202020202020202020202020627265616B3B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(5486) := '207D0A0A202020202020202020202F2F20464952535420494C4C4547414C20434841520A202020202020202020206966202869203D3D3D206A29207B0A20202020202020202020202068616E646C655761726E696E672827696C6C6567616C2063686172';
wwv_flow_imp.g_varchar2_table(5487) := '61637465722061667465722061747472696275746520656E6427293B0A202020202020202020202020736B697041747472203D20747275653B0A202020202020202020207D0A20202020202020207D0A0A20202020202020202F2F20616476616E636520';
wwv_flow_imp.g_varchar2_table(5488) := '637572736F7220746F206E657874206174747269627574650A202020202020202069203D206A202B20313B0A0A202020202020202069662028736B69704174747229207B0A20202020202020202020636F6E74696E7565207061727365417474723B0A20';
wwv_flow_imp.g_varchar2_table(5489) := '202020202020207D0A0A20202020202020202F2F20636865636B206174747269627574652072652D6465636C61726174696F6E0A2020202020202020696620286E616D6520696E207365656E417474727329207B0A2020202020202020202068616E646C';
wwv_flow_imp.g_varchar2_table(5490) := '655761726E696E672827617474726962757465203C27202B206E616D65202B20273E20616C726561647920646566696E656427293B0A20202020202020202020636F6E74696E75653B0A20202020202020207D0A0A20202020202020207365656E417474';
wwv_flow_imp.g_varchar2_table(5491) := '72735B6E616D655D203D20747275653B0A0A2020202020202020696620282169734E616D65737061636529207B0A2020202020202020202061747472735B6E616D655D203D2076616C75653B0A20202020202020202020636F6E74696E75653B0A202020';
wwv_flow_imp.g_varchar2_table(5492) := '20202020207D0A0A20202020202020202F2F2074727920746F2065787472616374206E616D65737061636520696E666F726D6174696F6E0A2020202020202020696620286D617962654E5329207B0A202020202020202020206E6577616C696173203D20';
wwv_flow_imp.g_varchar2_table(5493) := '280A2020202020202020202020206E616D65203D3D3D2027786D6C6E73270A20202020202020202020202020203F2027786D6C6E73270A20202020202020202020202020203A20286E616D652E63686172436F64654174283029203D3D3D203132302026';
wwv_flow_imp.g_varchar2_table(5494) := '26206E616D652E73756273747228302C203629203D3D3D2027786D6C6E733A27290A202020202020202020202020202020203F206E616D652E7375627374722836290A202020202020202020202020202020203A206E756C6C0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(5495) := '293B0A0A202020202020202020202F2F2068616E646C6520786D6C6E73283A616C696173292061737369676E6D656E740A20202020202020202020696620286E6577616C69617320213D3D206E756C6C29207B0A2020202020202020202020206E735572';
wwv_flow_imp.g_varchar2_table(5496) := '69203D206465636F6465456E7469746965732876616C7565293B0A2020202020202020202020206E73557269507265666978203D20757269507265666978286E6577616C696173293B0A0A202020202020202020202020616C696173203D206E73557269';
wwv_flow_imp.g_varchar2_table(5497) := '546F5072656669785B6E735572695D3B0A0A2020202020202020202020206966202821616C69617329207B0A0A20202020202020202020202020202F2F206E6F2070726566697820646566696E6564206F722070726566697820636F6C6C6973696F6E0A';
wwv_flow_imp.g_varchar2_table(5498) := '2020202020202020202020202020696620280A20202020202020202020202020202020286E6577616C696173203D3D3D2027786D6C6E732729207C7C0A20202020202020202020202020202020286E7355726950726566697820696E206E734D61747269';
wwv_flow_imp.g_varchar2_table(5499) := '78202626206E734D61747269785B6E735572695072656669785D20213D3D206E73557269290A202020202020202020202020202029207B0A0A202020202020202020202020202020202F2F20616C6F636174652066726565206E73207072656669780A20';
wwv_flow_imp.g_varchar2_table(5500) := '202020202020202020202020202020646F207B0A202020202020202020202020202020202020616C696173203D20276E7327202B2028616E6F6E796D6F75734E73436F756E742B2B293B0A202020202020202020202020202020207D207768696C652028';
wwv_flow_imp.g_varchar2_table(5501) := '747970656F66206E734D61747269785B616C6961735D20213D3D2027756E646566696E656427293B0A20202020202020202020202020207D20656C7365207B0A20202020202020202020202020202020616C696173203D206E6577616C6961733B0A2020';
wwv_flow_imp.g_varchar2_table(5502) := '2020202020202020202020207D0A0A20202020202020202020202020206E73557269546F5072656669785B6E735572695D203D20616C6961733B0A2020202020202020202020207D0A0A202020202020202020202020696620286E734D61747269785B6E';
wwv_flow_imp.g_varchar2_table(5503) := '6577616C6961735D20213D3D20616C69617329207B0A202020202020202020202020202069662028216861734E65774D617472697829207B0A202020202020202020202020202020206E734D6174726978203D20636C6F6E654E734D6174726978286E73';
wwv_flow_imp.g_varchar2_table(5504) := '4D6174726978293B0A202020202020202020202020202020206861734E65774D6174726978203D20747275653B0A20202020202020202020202020207D0A0A20202020202020202020202020206E734D61747269785B6E6577616C6961735D203D20616C';
wwv_flow_imp.g_varchar2_table(5505) := '6961733B0A2020202020202020202020202020696620286E6577616C696173203D3D3D2027786D6C6E732729207B0A202020202020202020202020202020206E734D61747269785B75726950726566697828616C696173295D203D206E735572693B0A20';
wwv_flow_imp.g_varchar2_table(5506) := '20202020202020202020202020202064656661756C74416C696173203D20616C6961733B0A20202020202020202020202020207D0A0A20202020202020202020202020206E734D61747269785B6E735572695072656669785D203D206E735572693B0A20';
wwv_flow_imp.g_varchar2_table(5507) := '20202020202020202020207D0A0A2020202020202020202020202F2F206578706F736520786D6C6E73283A617364293D222E2E2E2220696E20617474726962757465730A20202020202020202020202061747472735B6E616D655D203D2076616C75653B';
wwv_flow_imp.g_varchar2_table(5508) := '0A202020202020202020202020636F6E74696E75653B0A202020202020202020207D0A0A202020202020202020202F2F20636F6C6C656374206174747269627574657320756E74696C20616C6C206E616D6573706163650A202020202020202020202F2F';
wwv_flow_imp.g_varchar2_table(5509) := '206465636C61726174696F6E73206172652070726F6365737365640A20202020202020202020617474724C6973742E70757368286E616D652C2076616C7565293B0A20202020202020202020636F6E74696E75653B0A0A20202020202020207D202F2A2A';
wwv_flow_imp.g_varchar2_table(5510) := '20656E6420696620286D617962654E7329202A2F0A0A20202020202020202F2F2068616E646C652061747472696275746573206F6E20656C656D656E7420776974686F75740A20202020202020202F2F206E616D657370616365206465636C6172617469';
wwv_flow_imp.g_varchar2_table(5511) := '6F6E730A202020202020202077203D206E616D652E696E6465784F6628273A27293B0A20202020202020206966202877203D3D3D202D3129207B0A2020202020202020202061747472735B6E616D655D203D2076616C75653B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(5512) := '636F6E74696E75653B0A20202020202020207D0A0A20202020202020202F2F206E6F726D616C697A65206E7320617474726962757465206E616D650A20202020202020206966202821286E734E616D65203D206E734D61747269785B6E616D652E737562';
wwv_flow_imp.g_varchar2_table(5513) := '737472696E6728302C2077295D2929207B0A2020202020202020202068616E646C655761726E696E67286D697373696E674E616D657370616365466F72507265666978286E616D652E737562737472696E6728302C20772929293B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(5514) := '2020636F6E74696E75653B0A20202020202020207D0A0A20202020202020206E616D65203D2064656661756C74416C696173203D3D3D206E734E616D650A202020202020202020203F206E616D652E7375627374722877202B2031290A20202020202020';
wwv_flow_imp.g_varchar2_table(5515) := '2020203A206E734E616D65202B206E616D652E7375627374722877293B0A0A20202020202020202F2F20656E643A206E6F726D616C697A65206E7320617474726962757465206E616D650A0A20202020202020202F2F206E6F726D616C697A6520787369';
wwv_flow_imp.g_varchar2_table(5516) := '3A74797065206E73206174747269627574652076616C75650A2020202020202020696620286E616D65203D3D3D205853495F5459504529207B0A2020202020202020202077203D2076616C75652E696E6465784F6628273A27293B0A0A20202020202020';
wwv_flow_imp.g_varchar2_table(5517) := '202020696620287720213D3D202D3129207B0A2020202020202020202020206E734E616D65203D2076616C75652E737562737472696E6728302C2077293B0A0A2020202020202020202020202F2F2068616E646C652064656661756C7420707265666978';
wwv_flow_imp.g_varchar2_table(5518) := '65732C20692E652E2078733A537472696E6720677261636566756C6C790A2020202020202020202020206E734E616D65203D206E734D61747269785B6E734E616D655D207C7C206E734E616D653B0A20202020202020202020202076616C7565203D206E';
wwv_flow_imp.g_varchar2_table(5519) := '734E616D65202B2076616C75652E737562737472696E672877293B0A202020202020202020207D20656C7365207B0A20202020202020202020202076616C7565203D2064656661756C74416C696173202B20273A27202B2076616C75653B0A2020202020';
wwv_flow_imp.g_varchar2_table(5520) := '20202020207D0A20202020202020207D0A0A20202020202020202F2F20656E643A206E6F726D616C697A65207873693A74797065206E73206174747269627574652076616C75650A0A202020202020202061747472735B6E616D655D203D2076616C7565';
wwv_flow_imp.g_varchar2_table(5521) := '3B0A2020202020207D0A0A0A2020202020202F2F2068616E646C652064656665727265642C20706F737369626C79206E616D6573706163656420617474726962757465730A202020202020696620286D617962654E5329207B0A0A20202020202020202F';
wwv_flow_imp.g_varchar2_table(5522) := '2F206E6F726D616C697A6520636170747572656420617474726962757465730A2020202020202020666F72202869203D20302C206C203D20617474724C6973742E6C656E6774683B2069203C206C3B20692B2B29207B0A0A202020202020202020206E61';
wwv_flow_imp.g_varchar2_table(5523) := '6D65203D20617474724C6973745B692B2B5D3B0A2020202020202020202076616C7565203D20617474724C6973745B695D3B0A0A2020202020202020202077203D206E616D652E696E6465784F6628273A27293B0A0A2020202020202020202069662028';
wwv_flow_imp.g_varchar2_table(5524) := '7720213D3D202D3129207B0A0A2020202020202020202020202F2F206E6F726D616C697A65206E7320617474726962757465206E616D650A2020202020202020202020206966202821286E734E616D65203D206E734D61747269785B6E616D652E737562';
wwv_flow_imp.g_varchar2_table(5525) := '737472696E6728302C2077295D2929207B0A202020202020202020202020202068616E646C655761726E696E67286D697373696E674E616D657370616365466F72507265666978286E616D652E737562737472696E6728302C20772929293B0A20202020';
wwv_flow_imp.g_varchar2_table(5526) := '20202020202020202020636F6E74696E75653B0A2020202020202020202020207D0A0A2020202020202020202020206E616D65203D2064656661756C74416C696173203D3D3D206E734E616D650A20202020202020202020202020203F206E616D652E73';
wwv_flow_imp.g_varchar2_table(5527) := '75627374722877202B2031290A20202020202020202020202020203A206E734E616D65202B206E616D652E7375627374722877293B0A0A2020202020202020202020202F2F20656E643A206E6F726D616C697A65206E7320617474726962757465206E61';
wwv_flow_imp.g_varchar2_table(5528) := '6D650A0A2020202020202020202020202F2F206E6F726D616C697A65207873693A74797065206E73206174747269627574652076616C75650A202020202020202020202020696620286E616D65203D3D3D205853495F5459504529207B0A202020202020';
wwv_flow_imp.g_varchar2_table(5529) := '202020202020202077203D2076616C75652E696E6465784F6628273A27293B0A0A2020202020202020202020202020696620287720213D3D202D3129207B0A202020202020202020202020202020206E734E616D65203D2076616C75652E737562737472';
wwv_flow_imp.g_varchar2_table(5530) := '696E6728302C2077293B0A0A202020202020202020202020202020202F2F2068616E646C652064656661756C742070726566697865732C20692E652E2078733A537472696E6720677261636566756C6C790A202020202020202020202020202020206E73';
wwv_flow_imp.g_varchar2_table(5531) := '4E616D65203D206E734D61747269785B6E734E616D655D207C7C206E734E616D653B0A2020202020202020202020202020202076616C7565203D206E734E616D65202B2076616C75652E737562737472696E672877293B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(5532) := '20207D20656C7365207B0A2020202020202020202020202020202076616C7565203D2064656661756C74416C696173202B20273A27202B2076616C75653B0A20202020202020202020202020207D0A2020202020202020202020207D0A0A202020202020';
wwv_flow_imp.g_varchar2_table(5533) := '2020202020202F2F20656E643A206E6F726D616C697A65207873693A74797065206E73206174747269627574652076616C75650A202020202020202020207D0A0A2020202020202020202061747472735B6E616D655D203D2076616C75653B0A20202020';
wwv_flow_imp.g_varchar2_table(5534) := '202020207D0A0A20202020202020202F2F20656E643A206E6F726D616C697A6520636170747572656420617474726962757465730A2020202020207D0A0A20202020202072657475726E206361636865644174747273203D2061747472733B0A20202020';
wwv_flow_imp.g_varchar2_table(5535) := '7D0A0A202020202F2A2A0A20202020202A20457874726163742074686520706172736520636F6E74657874207B206C696E652C20636F6C756D6E2C2070617274207D0A20202020202A2066726F6D207468652063757272656E742070617273657220706F';
wwv_flow_imp.g_varchar2_table(5536) := '736974696F6E2E0A20202020202A0A20202020202A204072657475726E207B4F626A6563747D20706172736520636F6E746578740A20202020202A2F0A2020202066756E6374696F6E206765745061727365436F6E746578742829207B0A202020202020';
wwv_flow_imp.g_varchar2_table(5537) := '7661722073706C6974735265203D202F285C725C6E7C5C727C5C6E292F673B0A0A202020202020766172206C696E65203D20303B0A20202020202076617220636F6C756D6E203D20303B0A2020202020207661722073746172744F664C696E65203D2030';
wwv_flow_imp.g_varchar2_table(5538) := '3B0A20202020202076617220656E644F664C696E65203D206A3B0A202020202020766172206D617463683B0A20202020202076617220646174613B0A0A2020202020207768696C65202869203E3D2073746172744F664C696E6529207B0A0A2020202020';
wwv_flow_imp.g_varchar2_table(5539) := '2020206D61746368203D2073706C69747352652E6578656328786D6C293B0A0A202020202020202069662028216D6174636829207B0A20202020202020202020627265616B3B0A20202020202020207D0A0A20202020202020202F2F20656E64206F6620';
wwv_flow_imp.g_varchar2_table(5540) := '6C696E65203D2028627265616B20696478202B20627265616B206368617273290A2020202020202020656E644F664C696E65203D206D617463685B305D2E6C656E677468202B206D617463682E696E6465783B0A0A202020202020202069662028656E64';
wwv_flow_imp.g_varchar2_table(5541) := '4F664C696E65203E206929207B0A20202020202020202020627265616B3B0A20202020202020207D0A0A20202020202020202F2F20616476616E636520746F206E657874206C696E650A20202020202020206C696E65202B3D20313B0A0A202020202020';
wwv_flow_imp.g_varchar2_table(5542) := '202073746172744F664C696E65203D20656E644F664C696E653B0A2020202020207D0A0A2020202020202F2F20454F46206572726F72730A2020202020206966202869203D3D202D3129207B0A2020202020202020636F6C756D6E203D20656E644F664C';
wwv_flow_imp.g_varchar2_table(5543) := '696E653B0A202020202020202064617461203D20786D6C2E737562737472696E67286A293B0A2020202020207D20656C73650A0A2020202020202F2F207374617274206572726F72730A202020202020696620286A203D3D3D203029207B0A2020202020';
wwv_flow_imp.g_varchar2_table(5544) := '20202064617461203D20786D6C2E737562737472696E67286A2C2069293B0A2020202020207D0A0A2020202020202F2F206F74686572206572726F72730A202020202020656C7365207B0A2020202020202020636F6C756D6E203D2069202D2073746172';
wwv_flow_imp.g_varchar2_table(5545) := '744F664C696E653B0A202020202020202064617461203D20286A203D3D202D31203F20786D6C2E737562737472696E67286929203A20786D6C2E737562737472696E6728692C206A202B203129293B0A2020202020207D0A0A2020202020207265747572';
wwv_flow_imp.g_varchar2_table(5546) := '6E207B0A20202020202020202764617461273A20646174612C0A2020202020202020276C696E65273A206C696E652C0A202020202020202027636F6C756D6E273A20636F6C756D6E0A2020202020207D3B0A202020207D0A0A20202020676574436F6E74';
wwv_flow_imp.g_varchar2_table(5547) := '657874203D206765745061727365436F6E746578743B0A0A0A202020206966202870726F787929207B0A202020202020656C656D656E7450726F7879203D204F626A6563742E637265617465287B7D2C207B0A2020202020202020276E616D65273A2067';
wwv_flow_imp.g_varchar2_table(5548) := '65747465722866756E6374696F6E2829207B0A2020202020202020202072657475726E20656C656D656E744E616D653B0A20202020202020207D292C0A2020202020202020276F726967696E616C4E616D65273A206765747465722866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(5549) := '2829207B0A2020202020202020202072657475726E205F656C656D656E744E616D653B0A20202020202020207D292C0A2020202020202020276174747273273A20676574746572286765744174747273292C0A2020202020202020276E73273A20676574';
wwv_flow_imp.g_varchar2_table(5550) := '7465722866756E6374696F6E2829207B0A2020202020202020202072657475726E206E734D61747269783B0A20202020202020207D290A2020202020207D293B0A202020207D0A0A202020202F2F2061637475616C207061727365206C6F6769630A2020';
wwv_flow_imp.g_varchar2_table(5551) := '20207768696C6520286A20213D3D202D3129207B0A0A20202020202069662028786D6C2E63686172436F64654174286A29203D3D3D20363029207B202F2F20223C220A202020202020202069203D206A3B0A2020202020207D20656C7365207B0A202020';
wwv_flow_imp.g_varchar2_table(5552) := '202020202069203D20786D6C2E696E6465784F6628273C272C206A293B0A2020202020207D0A0A2020202020202F2F20706172736520656E640A2020202020206966202869203D3D3D202D3129207B0A2020202020202020696620286E6F646553746163';
wwv_flow_imp.g_varchar2_table(5553) := '6B2E6C656E67746829207B0A2020202020202020202072657475726E2068616E646C654572726F722827756E657870656374656420656E64206F662066696C6527293B0A20202020202020207D0A0A2020202020202020696620286A203D3D3D20302920';
wwv_flow_imp.g_varchar2_table(5554) := '7B0A2020202020202020202072657475726E2068616E646C654572726F7228276D697373696E672073746172742074616727293B0A20202020202020207D0A0A2020202020202020696620286A203C20786D6C2E6C656E67746829207B0A202020202020';
wwv_flow_imp.g_varchar2_table(5555) := '2020202069662028786D6C2E737562737472696E67286A292E7472696D282929207B0A20202020202020202020202068616E646C655761726E696E67284E4F4E5F574849544553504143455F4F5554534944455F524F4F545F4E4F4445293B0A20202020';
wwv_flow_imp.g_varchar2_table(5556) := '2020202020207D0A20202020202020207D0A0A202020202020202072657475726E3B0A2020202020207D0A0A2020202020202F2F20706172736520746578740A202020202020696620286A20213D3D206929207B0A0A2020202020202020696620286E6F';
wwv_flow_imp.g_varchar2_table(5557) := '6465537461636B2E6C656E67746829207B0A20202020202020202020696620286F6E5465787429207B0A2020202020202020202020206F6E5465787428786D6C2E737562737472696E67286A2C2069292C206465636F6465456E7469746965732C206765';
wwv_flow_imp.g_varchar2_table(5558) := '74436F6E74657874293B0A0A20202020202020202020202069662028706172736553746F7029207B0A202020202020202020202020202072657475726E3B0A2020202020202020202020207D0A202020202020202020207D0A20202020202020207D2065';
wwv_flow_imp.g_varchar2_table(5559) := '6C7365207B0A2020202020202020202069662028786D6C2E737562737472696E67286A2C2069292E7472696D282929207B0A20202020202020202020202068616E646C655761726E696E67284E4F4E5F574849544553504143455F4F5554534944455F52';
wwv_flow_imp.g_varchar2_table(5560) := '4F4F545F4E4F4445293B0A0A20202020202020202020202069662028706172736553746F7029207B0A202020202020202020202020202072657475726E3B0A2020202020202020202020207D0A202020202020202020207D0A20202020202020207D0A20';
wwv_flow_imp.g_varchar2_table(5561) := '20202020207D0A0A20202020202077203D20786D6C2E63686172436F6465417428692B31293B0A0A2020202020202F2F20706172736520636F6D6D656E7473202B2043444154410A2020202020206966202877203D3D3D20333329207B202F2F20222122';
wwv_flow_imp.g_varchar2_table(5562) := '0A202020202020202071203D20786D6C2E63686172436F6465417428692B32293B0A0A20202020202020202F2F2043444154412073656374696F6E0A20202020202020206966202871203D3D3D20393120262620786D6C2E7375627374722869202B2033';
wwv_flow_imp.g_varchar2_table(5563) := '2C203629203D3D3D202743444154415B2729207B202F2F203931203D3D20225B220A202020202020202020206A203D20786D6C2E696E6465784F6628275D5D3E272C2069293B0A20202020202020202020696620286A203D3D3D202D3129207B0A202020';
wwv_flow_imp.g_varchar2_table(5564) := '20202020202020202072657475726E2068616E646C654572726F722827756E636C6F73656420636461746127293B0A202020202020202020207D0A0A20202020202020202020696620286F6E434441544129207B0A2020202020202020202020206F6E43';
wwv_flow_imp.g_varchar2_table(5565) := '4441544128786D6C2E737562737472696E672869202B20392C206A292C20676574436F6E74657874293B0A20202020202020202020202069662028706172736553746F7029207B0A202020202020202020202020202072657475726E3B0A202020202020';
wwv_flow_imp.g_varchar2_table(5566) := '2020202020207D0A202020202020202020207D0A0A202020202020202020206A202B3D20333B0A20202020202020202020636F6E74696E75653B0A20202020202020207D0A0A20202020202020202F2F20636F6D6D656E740A2020202020202020696620';
wwv_flow_imp.g_varchar2_table(5567) := '2871203D3D3D20343520262620786D6C2E63686172436F646541742869202B203329203D3D3D20343529207B202F2F203435203D3D20222D220A202020202020202020206A203D20786D6C2E696E6465784F6628272D2D3E272C2069293B0A2020202020';
wwv_flow_imp.g_varchar2_table(5568) := '2020202020696620286A203D3D3D202D3129207B0A20202020202020202020202072657475726E2068616E646C654572726F722827756E636C6F73656420636F6D6D656E7427293B0A202020202020202020207D0A0A0A20202020202020202020696620';
wwv_flow_imp.g_varchar2_table(5569) := '286F6E436F6D6D656E7429207B0A2020202020202020202020206F6E436F6D6D656E7428786D6C2E737562737472696E672869202B20342C206A292C206465636F6465456E7469746965732C20676574436F6E74657874293B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(5570) := '202069662028706172736553746F7029207B0A202020202020202020202020202072657475726E3B0A2020202020202020202020207D0A202020202020202020207D0A0A202020202020202020206A202B3D20333B0A20202020202020202020636F6E74';
wwv_flow_imp.g_varchar2_table(5571) := '696E75653B0A20202020202020207D0A2020202020207D0A0A2020202020202F2F207061727365207175657374696F6E203C3F202E2E2E203F3E0A2020202020206966202877203D3D3D20363329207B202F2F20223F220A20202020202020206A203D20';
wwv_flow_imp.g_varchar2_table(5572) := '786D6C2E696E6465784F6628273F3E272C2069293B0A2020202020202020696620286A203D3D3D202D3129207B0A2020202020202020202072657475726E2068616E646C654572726F722827756E636C6F736564207175657374696F6E27293B0A202020';
wwv_flow_imp.g_varchar2_table(5573) := '20202020207D0A0A2020202020202020696620286F6E5175657374696F6E29207B0A202020202020202020206F6E5175657374696F6E28786D6C2E737562737472696E6728692C206A202B2032292C20676574436F6E74657874293B0A20202020202020';
wwv_flow_imp.g_varchar2_table(5574) := '20202069662028706172736553746F7029207B0A20202020202020202020202072657475726E3B0A202020202020202020207D0A20202020202020207D0A0A20202020202020206A202B3D20323B0A2020202020202020636F6E74696E75653B0A202020';
wwv_flow_imp.g_varchar2_table(5575) := '2020207D0A0A2020202020202F2F2066696E64206D61746368696E6720636C6F73696E672074616720666F7220617474656E74696F6E206F72207374616E6461726420746167730A2020202020202F2F20666F722074686174207765206D75737420736B';
wwv_flow_imp.g_varchar2_table(5576) := '6970207468726F756768206174747269627574652076616C7565730A2020202020202F2F2028656E636C6F73656420696E2073696E676C65206F7220646F75626C652071756F746573290A202020202020666F72202878203D2069202B20313B203B2078';
wwv_flow_imp.g_varchar2_table(5577) := '2B2B29207B0A202020202020202076203D20786D6C2E63686172436F646541742878293B0A20202020202020206966202869734E614E28762929207B0A202020202020202020206A203D202D313B0A2020202020202020202072657475726E2068616E64';
wwv_flow_imp.g_varchar2_table(5578) := '6C654572726F722827756E636C6F7365642074616727293B0A20202020202020207D0A0A20202020202020202F2F205B31305D2041747456616C7565203A3A3D2027222720285B5E3C26225D207C205265666572656E6365292A20272227207C20222722';
wwv_flow_imp.g_varchar2_table(5579) := '20285B5E3C26275D207C205265666572656E6365292A202227220A20202020202020202F2F20736B697073207468652071756F74656420737472696E670A20202020202020202F2F2028646F75626C652071756F7465732920646F6573206E6F74206170';
wwv_flow_imp.g_varchar2_table(5580) := '7065617220696E2061206C69746572616C20656E636C6F7365642062792028646F75626C652071756F746573290A20202020202020202F2F202873696E676C652071756F74652920646F6573206E6F742061707065617220696E2061206C69746572616C';
wwv_flow_imp.g_varchar2_table(5581) := '20656E636C6F736564206279202873696E676C652071756F7465290A20202020202020206966202876203D3D3D20333429207B202F2F20202722270A2020202020202020202071203D20786D6C2E696E6465784F66282722272C2078202B2031293B0A20';
wwv_flow_imp.g_varchar2_table(5582) := '20202020202020202078203D207120213D3D202D31203F2071203A20783B0A20202020202020207D20656C7365206966202876203D3D3D20333929207B202F2F202227220A2020202020202020202071203D20786D6C2E696E6465784F66282227222C20';
wwv_flow_imp.g_varchar2_table(5583) := '78202B2031293B0A2020202020202020202078203D207120213D3D202D31203F2071203A20783B0A20202020202020207D20656C7365206966202876203D3D3D20363229207B202F2F20273E270A202020202020202020206A203D20783B0A2020202020';
wwv_flow_imp.g_varchar2_table(5584) := '2020202020627265616B3B0A20202020202020207D0A2020202020207D0A0A0A2020202020202F2F20706172736520617474656E74696F6E203C21202E2E2E3E0A2020202020202F2F2070726576696F75736C7920636F6D6D656E7420616E6420434441';
wwv_flow_imp.g_varchar2_table(5585) := '5441206861766520616C7265616479206265656E207061727365640A2020202020206966202877203D3D3D20333329207B202F2F202221220A0A2020202020202020696620286F6E417474656E74696F6E29207B0A202020202020202020206F6E417474';
wwv_flow_imp.g_varchar2_table(5586) := '656E74696F6E28786D6C2E737562737472696E6728692C206A202B2031292C206465636F6465456E7469746965732C20676574436F6E74657874293B0A2020202020202020202069662028706172736553746F7029207B0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(5587) := '72657475726E3B0A202020202020202020207D0A20202020202020207D0A0A20202020202020206A202B3D20313B0A2020202020202020636F6E74696E75653B0A2020202020207D0A0A2020202020202F2F20646F6E27742070726F6365737320617474';
wwv_flow_imp.g_varchar2_table(5588) := '726962757465733B0A2020202020202F2F20746865726520617265206E6F6E650A2020202020206361636865644174747273203D207B7D3B0A0A2020202020202F2F2069662028786D6C2E63686172436F6465417428692B3129203D3D3D20343729207B';
wwv_flow_imp.g_varchar2_table(5589) := '202F2F203C2F2E2E2E0A2020202020206966202877203D3D3D20343729207B202F2F203C2F2E2E2E0A20202020202020207461675374617274203D2066616C73653B0A2020202020202020746167456E64203D20747275653B0A0A202020202020202069';
wwv_flow_imp.g_varchar2_table(5590) := '662028216E6F6465537461636B2E6C656E67746829207B0A2020202020202020202072657475726E2068616E646C654572726F7228276D697373696E67206F70656E2074616727293B0A20202020202020207D0A0A20202020202020202F2F2076657269';
wwv_flow_imp.g_varchar2_table(5591) := '6679206F70656E203C2D3E20636C6F736520746167206D617463680A202020202020202078203D20656C656D656E744E616D65203D206E6F6465537461636B2E706F7028293B0A202020202020202071203D2069202B2032202B20782E6C656E6774683B';
wwv_flow_imp.g_varchar2_table(5592) := '0A0A202020202020202069662028786D6C2E737562737472696E672869202B20322C20712920213D3D207829207B0A2020202020202020202072657475726E2068616E646C654572726F722827636C6F73696E6720746167206D69736D6174636827293B';
wwv_flow_imp.g_varchar2_table(5593) := '0A20202020202020207D0A0A20202020202020202F2F2076657269667920636861727320696E20636C6F7365207461670A2020202020202020666F7220283B2071203C206A3B20712B2B29207B0A2020202020202020202077203D20786D6C2E63686172';
wwv_flow_imp.g_varchar2_table(5594) := '436F646541742871293B0A0A202020202020202020206966202877203D3D3D203332207C7C202877203E20382026262077203C2031342929207B202F2F205C665C6E5C725C745C762073706163650A202020202020202020202020636F6E74696E75653B';
wwv_flow_imp.g_varchar2_table(5595) := '0A202020202020202020207D0A0A2020202020202020202072657475726E2068616E646C654572726F722827636C6F73652074616727293B0A20202020202020207D0A0A2020202020207D20656C7365207B0A202020202020202069662028786D6C2E63';
wwv_flow_imp.g_varchar2_table(5596) := '686172436F64654174286A202D203129203D3D3D20343729207B202F2F202E2E2E2F3E0A2020202020202020202078203D20656C656D656E744E616D65203D20786D6C2E737562737472696E672869202B20312C206A202D2031293B0A0A202020202020';
wwv_flow_imp.g_varchar2_table(5597) := '202020207461675374617274203D20747275653B0A20202020202020202020746167456E64203D20747275653B0A0A20202020202020207D20656C7365207B0A2020202020202020202078203D20656C656D656E744E616D65203D20786D6C2E73756273';
wwv_flow_imp.g_varchar2_table(5598) := '7472696E672869202B20312C206A293B0A0A202020202020202020207461675374617274203D20747275653B0A20202020202020202020746167456E64203D2066616C73653B0A20202020202020207D0A0A202020202020202069662028212877203E20';
wwv_flow_imp.g_varchar2_table(5599) := '39362026262077203C20313233207C7C2077203E2036342026262077203C203931207C7C2077203D3D3D203935207C7C2077203D3D3D2035382929207B202F2F2063686172203935225F22203538223A220A2020202020202020202072657475726E2068';
wwv_flow_imp.g_varchar2_table(5600) := '616E646C654572726F722827696C6C6567616C2066697273742063686172206E6F64654E616D6527293B0A20202020202020207D0A0A2020202020202020666F72202871203D20312C2079203D20782E6C656E6774683B2071203C20793B20712B2B2920';
wwv_flow_imp.g_varchar2_table(5601) := '7B0A2020202020202020202077203D20782E63686172436F646541742871293B0A0A202020202020202020206966202877203E2039362026262077203C20313233207C7C2077203E2036342026262077203C203931207C7C2077203E2034372026262077';
wwv_flow_imp.g_varchar2_table(5602) := '203C203539207C7C2077203D3D3D203435207C7C2077203D3D3D203935207C7C2077203D3D20343629207B0A202020202020202020202020636F6E74696E75653B0A202020202020202020207D0A0A202020202020202020206966202877203D3D3D2033';
wwv_flow_imp.g_varchar2_table(5603) := '32207C7C202877203C2031342026262077203E20382929207B202F2F205C665C6E5C725C745C762073706163650A202020202020202020202020656C656D656E744E616D65203D20782E737562737472696E6728302C2071293B0A0A2020202020202020';
wwv_flow_imp.g_varchar2_table(5604) := '202020202F2F206D617962652074686572652061726520617474726962757465730A2020202020202020202020206361636865644174747273203D206E756C6C3B0A202020202020202020202020627265616B3B0A202020202020202020207D0A0A2020';
wwv_flow_imp.g_varchar2_table(5605) := '202020202020202072657475726E2068616E646C654572726F722827696E76616C6964206E6F64654E616D6527293B0A20202020202020207D0A0A20202020202020206966202821746167456E6429207B0A202020202020202020206E6F646553746163';
wwv_flow_imp.g_varchar2_table(5606) := '6B2E7075736828656C656D656E744E616D65293B0A20202020202020207D0A2020202020207D0A0A2020202020206966202869734E616D65737061636529207B0A0A20202020202020205F6E734D6174726978203D206E734D61747269783B0A0A202020';
wwv_flow_imp.g_varchar2_table(5607) := '202020202069662028746167537461727429207B0A0A202020202020202020202F2F2072656D656D626572206F6C64206E616D6573706163650A202020202020202020202F2F20756E6C6573732077652772652073656C662D636C6F73696E670A202020';
wwv_flow_imp.g_varchar2_table(5608) := '202020202020206966202821746167456E6429207B0A2020202020202020202020206E734D6174726978537461636B2E70757368285F6E734D6174726978293B0A202020202020202020207D0A0A20202020202020202020696620286361636865644174';
wwv_flow_imp.g_varchar2_table(5609) := '747273203D3D3D206E756C6C29207B0A0A2020202020202020202020202F2F20717569636B20636865636B2C2077686574686572207468657265206D6179206265206E616D6573706163650A2020202020202020202020202F2F206465636C6172617469';
wwv_flow_imp.g_varchar2_table(5610) := '6F6E73206F6E20746865206E6F64653B20696620746861742069732074686520636173650A2020202020202020202020202F2F207765206E65656420746F2065616765726C7920706172736520746865206E6F646520617474726962757465730A202020';
wwv_flow_imp.g_varchar2_table(5611) := '20202020202020202069662028286D617962654E53203D20782E696E6465784F662827786D6C6E73272C20712920213D3D202D312929207B0A202020202020202020202020202061747472735374617274203D20713B0A20202020202020202020202020';
wwv_flow_imp.g_varchar2_table(5612) := '206174747273537472696E67203D20783B0A0A2020202020202020202020202020676574417474727328293B0A0A20202020202020202020202020206D617962654E53203D2066616C73653B0A2020202020202020202020207D0A202020202020202020';
wwv_flow_imp.g_varchar2_table(5613) := '207D0A20202020202020207D0A0A20202020202020205F656C656D656E744E616D65203D20656C656D656E744E616D653B0A0A202020202020202077203D20656C656D656E744E616D652E696E6465784F6628273A27293B0A2020202020202020696620';
wwv_flow_imp.g_varchar2_table(5614) := '287720213D3D202D3129207B0A20202020202020202020786D6C6E73203D206E734D61747269785B656C656D656E744E616D652E737562737472696E6728302C2077295D3B0A0A202020202020202020202F2F2070726566697820676976656E3B206E61';
wwv_flow_imp.g_varchar2_table(5615) := '6D657370616365206D7573742065786973740A202020202020202020206966202821786D6C6E7329207B0A20202020202020202020202072657475726E2068616E646C654572726F7228276D697373696E67206E616D657370616365206F6E203C27202B';
wwv_flow_imp.g_varchar2_table(5616) := '205F656C656D656E744E616D65202B20273E27293B0A202020202020202020207D0A0A20202020202020202020656C656D656E744E616D65203D20656C656D656E744E616D652E7375627374722877202B2031293B0A20202020202020207D20656C7365';
wwv_flow_imp.g_varchar2_table(5617) := '207B0A20202020202020202020786D6C6E73203D206E734D61747269785B27786D6C6E73275D3B0A0A202020202020202020202F2F206966206E6F2064656661756C74206E616D65737061636520697320646566696E65642C0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(5618) := '2F2F207765276C6C20696D706F72742074686520656C656D656E7420617320616E6F6E796D6F75732E0A202020202020202020202F2F0A202020202020202020202F2F20697420697320757020746F20757365727320746F20636F727265637420746861';
wwv_flow_imp.g_varchar2_table(5619) := '7420746F2074686520646F63756D656E7420646566696E65640A202020202020202020202F2F207461726765744E616D6573706163652C206F7220776861746576657220746865697220756E64657273616E64696E67206F66207468650A202020202020';
wwv_flow_imp.g_varchar2_table(5620) := '202020202F2F20584D4C2073706563206D616E64617465732E0A20202020202020207D0A0A20202020202020202F2F2061646A757374206E616D657370616365207072656669787320617320636F6E666967757265640A20202020202020206966202878';
wwv_flow_imp.g_varchar2_table(5621) := '6D6C6E7329207B0A20202020202020202020656C656D656E744E616D65203D20786D6C6E73202B20273A27202B20656C656D656E744E616D653B0A20202020202020207D0A0A2020202020207D0A0A20202020202069662028746167537461727429207B';
wwv_flow_imp.g_varchar2_table(5622) := '0A202020202020202061747472735374617274203D20713B0A20202020202020206174747273537472696E67203D20783B0A0A2020202020202020696620286F6E4F70656E54616729207B0A202020202020202020206966202870726F787929207B0A20';
wwv_flow_imp.g_varchar2_table(5623) := '20202020202020202020206F6E4F70656E54616728656C656D656E7450726F78792C206465636F6465456E7469746965732C20746167456E642C20676574436F6E74657874293B0A202020202020202020207D20656C7365207B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(5624) := '2020206F6E4F70656E54616728656C656D656E744E616D652C2067657441747472732C206465636F6465456E7469746965732C20746167456E642C20676574436F6E74657874293B0A202020202020202020207D0A0A2020202020202020202069662028';
wwv_flow_imp.g_varchar2_table(5625) := '706172736553746F7029207B0A20202020202020202020202072657475726E3B0A202020202020202020207D0A20202020202020207D0A0A2020202020207D0A0A20202020202069662028746167456E6429207B0A0A2020202020202020696620286F6E';
wwv_flow_imp.g_varchar2_table(5626) := '436C6F736554616729207B0A202020202020202020206F6E436C6F73655461672870726F7879203F20656C656D656E7450726F7879203A20656C656D656E744E616D652C206465636F6465456E7469746965732C2074616753746172742C20676574436F';
wwv_flow_imp.g_varchar2_table(5627) := '6E74657874293B0A0A2020202020202020202069662028706172736553746F7029207B0A20202020202020202020202072657475726E3B0A202020202020202020207D0A20202020202020207D0A0A20202020202020202F2F20726573746F7265206F6C';
wwv_flow_imp.g_varchar2_table(5628) := '64206E616D6573706163650A20202020202020206966202869734E616D65737061636529207B0A202020202020202020206966202821746167537461727429207B0A2020202020202020202020206E734D6174726978203D206E734D6174726978537461';
wwv_flow_imp.g_varchar2_table(5629) := '636B2E706F7028293B0A202020202020202020207D20656C7365207B0A2020202020202020202020206E734D6174726978203D205F6E734D61747269783B0A202020202020202020207D0A20202020202020207D0A2020202020207D0A0A202020202020';
wwv_flow_imp.g_varchar2_table(5630) := '6A202B3D20313B0A202020207D0A20207D202F2A2A20656E64207061727365202A2F0A0A7D0A0A0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F74696E792D7376672F646973742F696E6465782E65736D2E6A';
wwv_flow_imp.g_varchar2_table(5631) := '73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F74696E792D7376672F646973742F696E6465';
wwv_flow_imp.g_varchar2_table(5632) := '782E65736D2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F6D6F64756C652C';
wwv_flow_imp.g_varchar2_table(5633) := '205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D';
wwv_flow_imp.g_varchar2_table(5634) := '6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020617070656E643A202829203D3E20282F2A20';
wwv_flow_imp.g_varchar2_table(5635) := '62696E64696E67202A2F20617070656E64292C0A2F2A206861726D6F6E79206578706F7274202A2F202020617070656E64546F3A202829203D3E20282F2A2062696E64696E67202A2F20617070656E64546F292C0A2F2A206861726D6F6E79206578706F';
wwv_flow_imp.g_varchar2_table(5636) := '7274202A2F202020617474723A202829203D3E20282F2A2062696E64696E67202A2F2061747472292C0A2F2A206861726D6F6E79206578706F7274202A2F202020636C61737365733A202829203D3E20282F2A2062696E64696E67202A2F20636C617373';
wwv_flow_imp.g_varchar2_table(5637) := '6573292C0A2F2A206861726D6F6E79206578706F7274202A2F202020636C6561723A202829203D3E20282F2A2062696E64696E67202A2F20636C656172292C0A2F2A206861726D6F6E79206578706F7274202A2F202020636C6F6E653A202829203D3E20';
wwv_flow_imp.g_varchar2_table(5638) := '282F2A2062696E64696E67202A2F20636C6F6E65292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206372656174653A202829203D3E20282F2A2062696E64696E67202A2F20637265617465292C0A2F2A206861726D6F6E79206578706F72';
wwv_flow_imp.g_varchar2_table(5639) := '74202A2F2020206372656174654D61747269783A202829203D3E20282F2A2062696E64696E67202A2F206372656174654D6174726978292C0A2F2A206861726D6F6E79206578706F7274202A2F202020637265617465506F696E743A202829203D3E2028';
wwv_flow_imp.g_varchar2_table(5640) := '2F2A2062696E64696E67202A2F20637265617465506F696E74292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206372656174655472616E73666F726D3A202829203D3E20282F2A2062696E64696E67202A2F206372656174655472616E73';
wwv_flow_imp.g_varchar2_table(5641) := '666F726D292C0A2F2A206861726D6F6E79206578706F7274202A2F202020696E6E65725356473A202829203D3E20282F2A2062696E64696E67202A2F20696E6E6572535647292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206F66663A20';
wwv_flow_imp.g_varchar2_table(5642) := '2829203D3E20282F2A2062696E64696E67202A2F206F6666292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206F6E3A202829203D3E20282F2A2062696E64696E67202A2F206F6E292C0A2F2A206861726D6F6E79206578706F7274202A2F';
wwv_flow_imp.g_varchar2_table(5643) := '20202070726570656E643A202829203D3E20282F2A2062696E64696E67202A2F2070726570656E64292C0A2F2A206861726D6F6E79206578706F7274202A2F20202070726570656E64546F3A202829203D3E20282F2A2062696E64696E67202A2F207072';
wwv_flow_imp.g_varchar2_table(5644) := '6570656E64546F292C0A2F2A206861726D6F6E79206578706F7274202A2F20202072656D6F76653A202829203D3E20282F2A2062696E64696E67202A2F2072656D6F7665292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207265706C6163';
wwv_flow_imp.g_varchar2_table(5645) := '653A202829203D3E20282F2A2062696E64696E67202A2F207265706C616365292C0A2F2A206861726D6F6E79206578706F7274202A2F20202073656C6563743A202829203D3E20282F2A2062696E64696E67202A2F2073656C656374292C0A2F2A206861';
wwv_flow_imp.g_varchar2_table(5646) := '726D6F6E79206578706F7274202A2F20202073656C656374416C6C3A202829203D3E20282F2A2062696E64696E67202A2F2073656C656374416C6C292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207472616E73666F726D3A202829203D';
wwv_flow_imp.g_varchar2_table(5647) := '3E20282F2A2062696E64696E67202A2F207472616E73666F726D290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A66756E6374696F6E20656E73757265496D706F7274656428656C656D656E742C2074617267657429207B0A0A202069';
wwv_flow_imp.g_varchar2_table(5648) := '662028656C656D656E742E6F776E6572446F63756D656E7420213D3D207461726765742E6F776E6572446F63756D656E7429207B0A20202020747279207B0A0A2020202020202F2F206D6179206661696C206F6E207765626B69740A2020202020207265';
wwv_flow_imp.g_varchar2_table(5649) := '7475726E207461726765742E6F776E6572446F63756D656E742E696D706F72744E6F646528656C656D656E742C2074727565293B0A202020207D20636174636820286529207B0A0A2020202020202F2F2069676E6F72650A202020207D0A20207D0A0A20';
wwv_flow_imp.g_varchar2_table(5650) := '2072657475726E20656C656D656E743B0A7D0A0A2F2A2A0A202A20617070656E64546F207574696C6974790A202A2F0A0A0A2F2A2A0A202A20417070656E642061206E6F646520746F20612074617267657420656C656D656E7420616E64207265747572';
wwv_flow_imp.g_varchar2_table(5651) := '6E2074686520617070656E646564206E6F64652E0A202A0A202A2040706172616D20207B535647456C656D656E747D20656C656D656E740A202A2040706172616D20207B535647456C656D656E747D207461726765740A202A0A202A204072657475726E';
wwv_flow_imp.g_varchar2_table(5652) := '207B535647456C656D656E747D2074686520617070656E646564206E6F64650A202A2F0A66756E6374696F6E20617070656E64546F28656C656D656E742C2074617267657429207B0A202072657475726E207461726765742E617070656E644368696C64';
wwv_flow_imp.g_varchar2_table(5653) := '28656E73757265496D706F7274656428656C656D656E742C2074617267657429293B0A7D0A0A2F2A2A0A202A20617070656E64207574696C6974790A202A2F0A0A0A2F2A2A0A202A20417070656E642061206E6F646520746F20616E20656C656D656E74';
wwv_flow_imp.g_varchar2_table(5654) := '0A202A0A202A2040706172616D20207B535647456C656D656E747D20656C656D656E740A202A2040706172616D20207B535647456C656D656E747D206E6F64650A202A0A202A204072657475726E207B535647456C656D656E747D2074686520656C656D';
wwv_flow_imp.g_varchar2_table(5655) := '656E740A202A2F0A66756E6374696F6E20617070656E64287461726765742C206E6F646529207B0A2020617070656E64546F286E6F64652C20746172676574293B0A202072657475726E207461726765743B0A7D0A0A2F2A2A0A202A2061747472696275';
wwv_flow_imp.g_varchar2_table(5656) := '7465206163636573736F72207574696C6974790A202A2F0A0A766172204C454E4754485F41545452203D20323B0A0A766172204353535F50524F50455254494553203D207B0A202027616C69676E6D656E742D626173656C696E65273A20312C0A202027';
wwv_flow_imp.g_varchar2_table(5657) := '626173656C696E652D7368696674273A20312C0A202027636C6970273A20312C0A202027636C69702D70617468273A20312C0A202027636C69702D72756C65273A20312C0A202027636F6C6F72273A20312C0A202027636F6C6F722D696E746572706F6C';
wwv_flow_imp.g_varchar2_table(5658) := '6174696F6E273A20312C0A202027636F6C6F722D696E746572706F6C6174696F6E2D66696C74657273273A20312C0A202027636F6C6F722D70726F66696C65273A20312C0A202027636F6C6F722D72656E646572696E67273A20312C0A20202763757273';
wwv_flow_imp.g_varchar2_table(5659) := '6F72273A20312C0A202027646972656374696F6E273A20312C0A202027646973706C6179273A20312C0A202027646F6D696E616E742D626173656C696E65273A20312C0A202027656E61626C652D6261636B67726F756E64273A20312C0A20202766696C';
wwv_flow_imp.g_varchar2_table(5660) := '6C273A20312C0A20202766696C6C2D6F706163697479273A20312C0A20202766696C6C2D72756C65273A20312C0A20202766696C746572273A20312C0A202027666C6F6F642D636F6C6F72273A20312C0A202027666C6F6F642D6F706163697479273A20';
wwv_flow_imp.g_varchar2_table(5661) := '312C0A202027666F6E74273A20312C0A202027666F6E742D66616D696C79273A20312C0A202027666F6E742D73697A65273A204C454E4754485F415454522C0A202027666F6E742D73697A652D61646A757374273A20312C0A202027666F6E742D737472';
wwv_flow_imp.g_varchar2_table(5662) := '65746368273A20312C0A202027666F6E742D7374796C65273A20312C0A202027666F6E742D76617269616E74273A20312C0A202027666F6E742D776569676874273A20312C0A202027676C7970682D6F7269656E746174696F6E2D686F72697A6F6E7461';
wwv_flow_imp.g_varchar2_table(5663) := '6C273A20312C0A202027676C7970682D6F7269656E746174696F6E2D766572746963616C273A20312C0A202027696D6167652D72656E646572696E67273A20312C0A2020276B65726E696E67273A20312C0A2020276C65747465722D73706163696E6727';
wwv_flow_imp.g_varchar2_table(5664) := '3A20312C0A2020276C69676874696E672D636F6C6F72273A20312C0A2020276D61726B6572273A20312C0A2020276D61726B65722D656E64273A20312C0A2020276D61726B65722D6D6964273A20312C0A2020276D61726B65722D7374617274273A2031';
wwv_flow_imp.g_varchar2_table(5665) := '2C0A2020276D61736B273A20312C0A2020276F706163697479273A20312C0A2020276F766572666C6F77273A20312C0A202027706F696E7465722D6576656E7473273A20312C0A20202773686170652D72656E646572696E67273A20312C0A2020277374';
wwv_flow_imp.g_varchar2_table(5666) := '6F702D636F6C6F72273A20312C0A20202773746F702D6F706163697479273A20312C0A2020277374726F6B65273A20312C0A2020277374726F6B652D646173686172726179273A20312C0A2020277374726F6B652D646173686F6666736574273A20312C';
wwv_flow_imp.g_varchar2_table(5667) := '0A2020277374726F6B652D6C696E65636170273A20312C0A2020277374726F6B652D6C696E656A6F696E273A20312C0A2020277374726F6B652D6D697465726C696D6974273A20312C0A2020277374726F6B652D6F706163697479273A20312C0A202027';
wwv_flow_imp.g_varchar2_table(5668) := '7374726F6B652D7769647468273A204C454E4754485F415454522C0A202027746578742D616E63686F72273A20312C0A202027746578742D6465636F726174696F6E273A20312C0A202027746578742D72656E646572696E67273A20312C0A202027756E';
wwv_flow_imp.g_varchar2_table(5669) := '69636F64652D62696469273A20312C0A2020277669736962696C697479273A20312C0A202027776F72642D73706163696E67273A20312C0A20202777726974696E672D6D6F6465273A20310A7D3B0A0A0A66756E6374696F6E2067657441747472696275';
wwv_flow_imp.g_varchar2_table(5670) := '7465286E6F64652C206E616D6529207B0A2020696620284353535F50524F504552544945535B6E616D655D29207B0A2020202072657475726E206E6F64652E7374796C655B6E616D655D3B0A20207D20656C7365207B0A2020202072657475726E206E6F';
wwv_flow_imp.g_varchar2_table(5671) := '64652E6765744174747269627574654E53286E756C6C2C206E616D65293B0A20207D0A7D0A0A66756E6374696F6E20736574417474726962757465286E6F64652C206E616D652C2076616C756529207B0A20207661722068797068656E61746564203D20';
wwv_flow_imp.g_varchar2_table(5672) := '6E616D652E7265706C616365282F285B612D7A5D29285B412D5A5D292F672C202724312D243227292E746F4C6F7765724361736528293B0A0A20207661722074797065203D204353535F50524F504552544945535B68797068656E617465645D3B0A0A20';
wwv_flow_imp.g_varchar2_table(5673) := '20696620287479706529207B0A0A202020202F2F20617070656E6420706978656C20756E69742C20756E6C6573732070726573656E740A202020206966202874797065203D3D3D204C454E4754485F4154545220262620747970656F662076616C756520';
wwv_flow_imp.g_varchar2_table(5674) := '3D3D3D20276E756D6265722729207B0A20202020202076616C7565203D20537472696E672876616C756529202B20277078273B0A202020207D0A0A202020206E6F64652E7374796C655B68797068656E617465645D203D2076616C75653B0A20207D2065';
wwv_flow_imp.g_varchar2_table(5675) := '6C7365207B0A202020206E6F64652E7365744174747269627574654E53286E756C6C2C206E616D652C2076616C7565293B0A20207D0A7D0A0A66756E6374696F6E2073657441747472696275746573286E6F64652C20617474727329207B0A0A20207661';
wwv_flow_imp.g_varchar2_table(5676) := '72206E616D6573203D204F626A6563742E6B657973286174747273292C20692C206E616D653B0A0A2020666F72202869203D20302C206E616D653B20286E616D65203D206E616D65735B695D293B20692B2B29207B0A2020202073657441747472696275';
wwv_flow_imp.g_varchar2_table(5677) := '7465286E6F64652C206E616D652C2061747472735B6E616D655D293B0A20207D0A7D0A0A2F2A2A0A202A2047657473206F722073657473207261772061747472696275746573206F6E2061206E6F64652E0A202A0A202A2040706172616D20207B535647';
wwv_flow_imp.g_varchar2_table(5678) := '456C656D656E747D206E6F64650A202A2040706172616D20207B4F626A6563747D205B61747472735D0A202A2040706172616D20207B537472696E677D205B6E616D655D0A202A2040706172616D20207B537472696E677D205B76616C75655D0A202A0A';
wwv_flow_imp.g_varchar2_table(5679) := '202A204072657475726E207B537472696E677D0A202A2F0A66756E6374696F6E2061747472286E6F64652C206E616D652C2076616C756529207B0A202069662028747970656F66206E616D65203D3D3D2027737472696E672729207B0A20202020696620';
wwv_flow_imp.g_varchar2_table(5680) := '2876616C756520213D3D20756E646566696E656429207B0A202020202020736574417474726962757465286E6F64652C206E616D652C2076616C7565293B0A202020207D20656C7365207B0A20202020202072657475726E206765744174747269627574';
wwv_flow_imp.g_varchar2_table(5681) := '65286E6F64652C206E616D65293B0A202020207D0A20207D20656C7365207B0A2020202073657441747472696275746573286E6F64652C206E616D65293B0A20207D0A0A202072657475726E206E6F64653B0A7D0A0A2F2A2A0D0A202A2054616B656E20';
wwv_flow_imp.g_varchar2_table(5682) := '66726F6D2068747470733A2F2F6769746875622E636F6D2F636F6D706F6E656E742F636C61737365730D0A202A0D0A202A20576974686F75742074686520636F6D706F6E656E7420626974732E0D0A202A2F0D0A0D0A2F2A2A0D0A202A20746F53747269';
wwv_flow_imp.g_varchar2_table(5683) := '6E67207265666572656E63652E0D0A202A2F0D0A0D0A636F6E737420746F537472696E67203D204F626A6563742E70726F746F747970652E746F537472696E673B0D0A0D0A2F2A2A0D0A20202A20577261702060656C6020696E20612060436C6173734C';
wwv_flow_imp.g_varchar2_table(5684) := '697374602E0D0A20202A0D0A20202A2040706172616D207B456C656D656E747D20656C0D0A20202A204072657475726E207B436C6173734C6973747D0D0A20202A2040617069207075626C69630D0A20202A2F0D0A0D0A66756E6374696F6E20636C6173';
wwv_flow_imp.g_varchar2_table(5685) := '73657328656C29207B0D0A202072657475726E206E657720436C6173734C69737428656C293B0D0A7D0D0A0D0A66756E6374696F6E20436C6173734C69737428656C29207B0D0A20206966202821656C207C7C2021656C2E6E6F64655479706529207B0D';
wwv_flow_imp.g_varchar2_table(5686) := '0A202020207468726F77206E6577204572726F7228274120444F4D20656C656D656E74207265666572656E636520697320726571756972656427293B0D0A20207D0D0A2020746869732E656C203D20656C3B0D0A2020746869732E6C697374203D20656C';
wwv_flow_imp.g_varchar2_table(5687) := '2E636C6173734C6973743B0D0A7D0D0A0D0A2F2A2A0D0A20202A2041646420636C61737320606E616D6560206966206E6F7420616C72656164792070726573656E742E0D0A20202A0D0A20202A2040706172616D207B537472696E677D206E616D650D0A';
wwv_flow_imp.g_varchar2_table(5688) := '20202A204072657475726E207B436C6173734C6973747D0D0A20202A2040617069207075626C69630D0A20202A2F0D0A0D0A436C6173734C6973742E70726F746F747970652E616464203D2066756E6374696F6E286E616D6529207B0D0A202074686973';
wwv_flow_imp.g_varchar2_table(5689) := '2E6C6973742E616464286E616D65293B0D0A202072657475726E20746869733B0D0A7D3B0D0A0D0A2F2A2A0D0A20202A2052656D6F766520636C61737320606E616D6560207768656E2070726573656E742C206F720D0A20202A20706173732061207265';
wwv_flow_imp.g_varchar2_table(5690) := '67756C61722065787072657373696F6E20746F2072656D6F76650D0A20202A20616E79207768696368206D617463682E0D0A20202A0D0A20202A2040706172616D207B537472696E677C5265674578707D206E616D650D0A20202A204072657475726E20';
wwv_flow_imp.g_varchar2_table(5691) := '7B436C6173734C6973747D0D0A20202A2040617069207075626C69630D0A20202A2F0D0A0D0A436C6173734C6973742E70726F746F747970652E72656D6F7665203D2066756E6374696F6E286E616D6529207B0D0A202069662028275B6F626A65637420';
wwv_flow_imp.g_varchar2_table(5692) := '5265674578705D27203D3D20746F537472696E672E63616C6C286E616D652929207B0D0A2020202072657475726E20746869732E72656D6F76654D61746368696E67286E616D65293B0D0A20207D0D0A0D0A2020746869732E6C6973742E72656D6F7665';
wwv_flow_imp.g_varchar2_table(5693) := '286E616D65293B0D0A202072657475726E20746869733B0D0A7D3B0D0A0D0A2F2A2A0D0A20202A2052656D6F766520616C6C20636C6173736573206D61746368696E6720607265602E0D0A20202A0D0A20202A2040706172616D207B5265674578707D20';
wwv_flow_imp.g_varchar2_table(5694) := '72650D0A20202A204072657475726E207B436C6173734C6973747D0D0A20202A204061706920707269766174650D0A20202A2F0D0A0D0A436C6173734C6973742E70726F746F747970652E72656D6F76654D61746368696E67203D2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(5695) := '28726529207B0D0A2020636F6E737420617272203D20746869732E617272617928293B0D0A2020666F7220286C65742069203D20303B2069203C206172722E6C656E6774683B20692B2B29207B0D0A202020206966202872652E74657374286172725B69';
wwv_flow_imp.g_varchar2_table(5696) := '5D2929207B0D0A202020202020746869732E72656D6F7665286172725B695D293B0D0A202020207D0D0A20207D0D0A202072657475726E20746869733B0D0A7D3B0D0A0D0A2F2A2A0D0A20202A20546F67676C6520636C61737320606E616D65602C2063';
wwv_flow_imp.g_varchar2_table(5697) := '616E20666F726365207374617465207669612060666F726365602E0D0A20202A0D0A20202A20466F722062726F7773657273207468617420737570706F727420636C6173734C6973742C2062757420646F206E6F7420737570706F72742060666F726365';
wwv_flow_imp.g_varchar2_table(5698) := '60207965742C0D0A20202A20746865206D697374616B652077696C6C20626520646574656374656420616E6420636F727265637465642E0D0A20202A0D0A20202A2040706172616D207B537472696E677D206E616D650D0A20202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(5699) := '426F6F6C65616E7D20666F7263650D0A20202A204072657475726E207B436C6173734C6973747D0D0A20202A2040617069207075626C69630D0A20202A2F0D0A0D0A436C6173734C6973742E70726F746F747970652E746F67676C65203D2066756E6374';
wwv_flow_imp.g_varchar2_table(5700) := '696F6E286E616D652C20666F72636529207B0D0A20206966202827756E646566696E65642720213D3D20747970656F6620666F72636529207B0D0A2020202069662028666F72636520213D3D20746869732E6C6973742E746F67676C65286E616D652C20';
wwv_flow_imp.g_varchar2_table(5701) := '666F7263652929207B0D0A202020202020746869732E6C6973742E746F67676C65286E616D65293B202F2F20746F67676C6520616761696E20746F20636F72726563740D0A202020207D0D0A20207D20656C7365207B0D0A20202020746869732E6C6973';
wwv_flow_imp.g_varchar2_table(5702) := '742E746F67676C65286E616D65293B0D0A20207D0D0A202072657475726E20746869733B0D0A7D3B0D0A0D0A2F2A2A0D0A20202A2052657475726E20616E206172726179206F6620636C61737365732E0D0A20202A0D0A20202A204072657475726E207B';
wwv_flow_imp.g_varchar2_table(5703) := '41727261797D0D0A20202A2040617069207075626C69630D0A20202A2F0D0A0D0A436C6173734C6973742E70726F746F747970652E6172726179203D2066756E6374696F6E2829207B0D0A202072657475726E2041727261792E66726F6D28746869732E';
wwv_flow_imp.g_varchar2_table(5704) := '6C697374293B0D0A7D3B0D0A0D0A2F2A2A0D0A20202A20436865636B20696620636C61737320606E616D65602069732070726573656E742E0D0A20202A0D0A20202A2040706172616D207B537472696E677D206E616D650D0A20202A204072657475726E';
wwv_flow_imp.g_varchar2_table(5705) := '207B436C6173734C6973747D0D0A20202A2040617069207075626C69630D0A20202A2F0D0A0D0A436C6173734C6973742E70726F746F747970652E686173203D0D0A20436C6173734C6973742E70726F746F747970652E636F6E7461696E73203D206675';
wwv_flow_imp.g_varchar2_table(5706) := '6E6374696F6E286E616D6529207B0D0A20202072657475726E20746869732E6C6973742E636F6E7461696E73286E616D65293B0D0A207D3B0A0A2F2A2A0A202A20436C656172207574696C6974790A202A2F0A0A2F2A2A0A202A2052656D6F7665732061';
wwv_flow_imp.g_varchar2_table(5707) := '6C6C206368696C6472656E2066726F6D2074686520676976656E20656C656D656E740A202A0A202A2040706172616D20207B535647456C656D656E747D20656C656D656E740A202A204072657475726E207B456C656D656E747D2074686520656C656D65';
wwv_flow_imp.g_varchar2_table(5708) := '6E742028666F7220636861696E696E67290A202A2F0A66756E6374696F6E20636C65617228656C656D656E7429207B0A2020766172206368696C643B0A0A20207768696C652028286368696C64203D20656C656D656E742E66697273744368696C642929';
wwv_flow_imp.g_varchar2_table(5709) := '207B0A20202020656C656D656E742E72656D6F76654368696C64286368696C64293B0A20207D0A0A202072657475726E20656C656D656E743B0A7D0A0A66756E6374696F6E20636C6F6E6528656C656D656E7429207B0A202072657475726E20656C656D';
wwv_flow_imp.g_varchar2_table(5710) := '656E742E636C6F6E654E6F64652874727565293B0A7D0A0A766172206E73203D207B0A20207376673A2027687474703A2F2F7777772E77332E6F72672F323030302F737667270A7D3B0A0A2F2A2A0A202A20444F4D2070617273696E67207574696C6974';
wwv_flow_imp.g_varchar2_table(5711) := '790A202A2F0A0A0A766172205356475F5354415254203D20273C73766720786D6C6E733D2227202B206E732E737667202B202722273B0A0A66756E6374696F6E2070617273652873766729207B0A0A202076617220756E77726170203D2066616C73653B';
wwv_flow_imp.g_varchar2_table(5712) := '0A0A20202F2F20656E7375726520776520696D706F727420612076616C69642073766720646F63756D656E740A2020696620287376672E737562737472696E6728302C203429203D3D3D20273C7376672729207B0A20202020696620287376672E696E64';
wwv_flow_imp.g_varchar2_table(5713) := '65784F66286E732E73766729203D3D3D202D3129207B0A202020202020737667203D205356475F5354415254202B207376672E737562737472696E672834293B0A202020207D0A20207D20656C7365207B0A0A202020202F2F206E616D65737061636520';
wwv_flow_imp.g_varchar2_table(5714) := '7376670A20202020737667203D205356475F5354415254202B20273E27202B20737667202B20273C2F7376673E273B0A20202020756E77726170203D20747275653B0A20207D0A0A202076617220706172736564203D207061727365446F63756D656E74';
wwv_flow_imp.g_varchar2_table(5715) := '28737667293B0A0A20206966202821756E7772617029207B0A2020202072657475726E207061727365643B0A20207D0A0A202076617220667261676D656E74203D20646F63756D656E742E637265617465446F63756D656E74467261676D656E7428293B';
wwv_flow_imp.g_varchar2_table(5716) := '0A0A202076617220706172656E74203D207061727365642E66697273744368696C643B0A0A20207768696C652028706172656E742E66697273744368696C6429207B0A20202020667261676D656E742E617070656E644368696C6428706172656E742E66';
wwv_flow_imp.g_varchar2_table(5717) := '697273744368696C64293B0A20207D0A0A202072657475726E20667261676D656E743B0A7D0A0A66756E6374696F6E207061727365446F63756D656E742873766729207B0A0A2020766172207061727365723B0A0A20202F2F2070617273650A20207061';
wwv_flow_imp.g_varchar2_table(5718) := '72736572203D206E657720444F4D50617273657228293B0A20207061727365722E6173796E63203D2066616C73653B0A0A202072657475726E207061727365722E706172736546726F6D537472696E67287376672C2027746578742F786D6C27293B0A7D';
wwv_flow_imp.g_varchar2_table(5719) := '0A0A2F2A2A0A202A20437265617465207574696C69747920666F722053564720656C656D656E74730A202A2F0A0A0A0A2F2A2A0A202A20437265617465206120737065636966696320747970652066726F6D206E616D65206F7220535647206D61726B75';
wwv_flow_imp.g_varchar2_table(5720) := '702E0A202A0A202A2040706172616D207B537472696E677D206E616D6520746865206E616D65206F72206D61726B7570206F662074686520656C656D656E740A202A2040706172616D207B4F626A6563747D205B61747472735D20617474726962757465';
wwv_flow_imp.g_varchar2_table(5721) := '7320746F20736574206F6E2074686520656C656D656E740A202A0A202A204072657475726E73207B535647456C656D656E747D0A202A2F0A66756E6374696F6E20637265617465286E616D652C20617474727329207B0A202076617220656C656D656E74';
wwv_flow_imp.g_varchar2_table(5722) := '3B0A0A20206E616D65203D206E616D652E7472696D28293B0A0A2020696620286E616D652E636861724174283029203D3D3D20273C2729207B0A20202020656C656D656E74203D207061727365286E616D65292E66697273744368696C643B0A20202020';
wwv_flow_imp.g_varchar2_table(5723) := '656C656D656E74203D20646F63756D656E742E696D706F72744E6F646528656C656D656E742C2074727565293B0A20207D20656C7365207B0A20202020656C656D656E74203D20646F63756D656E742E637265617465456C656D656E744E53286E732E73';
wwv_flow_imp.g_varchar2_table(5724) := '76672C206E616D65293B0A20207D0A0A202069662028617474727329207B0A202020206174747228656C656D656E742C206174747273293B0A20207D0A0A202072657475726E20656C656D656E743B0A7D0A0A2F2A2A0A202A204576656E74732068616E';
wwv_flow_imp.g_varchar2_table(5725) := '646C696E67207574696C6974790A202A2F0A0A66756E6374696F6E206F6E286E6F64652C206576656E742C206C697374656E65722C207573654361707475726529207B0A20206E6F64652E6164644576656E744C697374656E6572286576656E742C206C';
wwv_flow_imp.g_varchar2_table(5726) := '697374656E65722C2075736543617074757265293B0A7D0A0A66756E6374696F6E206F6666286E6F64652C206576656E742C206C697374656E65722C207573654361707475726529207B0A20206E6F64652E72656D6F76654576656E744C697374656E65';
wwv_flow_imp.g_varchar2_table(5727) := '72286576656E742C206C697374656E65722C2075736543617074757265293B0A7D0A0A2F2A2A0A202A2047656F6D657472792068656C706572730A202A2F0A0A0A2F2F2066616B65206E6F6465207573656420746F20696E7374616E7469617465207376';
wwv_flow_imp.g_varchar2_table(5728) := '672067656F6D6574727920656C656D656E74730A766172206E6F6465203D206E756C6C3B0A0A66756E6374696F6E206765744E6F64652829207B0A2020696620286E6F6465203D3D3D206E756C6C29207B0A202020206E6F6465203D2063726561746528';
wwv_flow_imp.g_varchar2_table(5729) := '2773766727293B0A20207D0A0A202072657475726E206E6F64653B0A7D0A0A66756E6374696F6E20657874656E64286F626A6563742C2070726F707329207B0A202076617220692C206B2C206B657973203D204F626A6563742E6B6579732870726F7073';
wwv_flow_imp.g_varchar2_table(5730) := '293B0A0A2020666F72202869203D20303B20286B203D206B6579735B695D293B20692B2B29207B0A202020206F626A6563745B6B5D203D2070726F70735B6B5D3B0A20207D0A0A202072657475726E206F626A6563743B0A7D0A0A0A66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(5731) := '20637265617465506F696E7428782C207929207B0A202076617220706F696E74203D206765744E6F646528292E637265617465535647506F696E7428293B0A0A20207377697463682028617267756D656E74732E6C656E67746829207B0A202063617365';
wwv_flow_imp.g_varchar2_table(5732) := '20303A0A2020202072657475726E20706F696E743B0A20206361736520323A0A2020202078203D207B0A202020202020783A20782C0A202020202020793A20790A202020207D3B0A20202020627265616B3B0A20207D0A0A202072657475726E20657874';
wwv_flow_imp.g_varchar2_table(5733) := '656E6428706F696E742C2078293B0A7D0A0A2F2A2A0A202A20437265617465206D61747269782076696120617267732E0A202A0A202A20406578616D706C650A202A0A202A206372656174654D6174726978287B20613A20312C20623A2031207D293B0A';
wwv_flow_imp.g_varchar2_table(5734) := '202A206372656174654D617472697828293B0A202A206372656174654D617472697828312C20322C20302C20302C2033302C203230293B0A202A0A202A204072657475726E207B5356474D61747269787D0A202A2F0A66756E6374696F6E206372656174';
wwv_flow_imp.g_varchar2_table(5735) := '654D617472697828612C20622C20632C20642C20652C206629207B0A2020766172206D6174726978203D206765744E6F646528292E6372656174655356474D617472697828293B0A0A20207377697463682028617267756D656E74732E6C656E67746829';
wwv_flow_imp.g_varchar2_table(5736) := '207B0A20206361736520303A0A2020202072657475726E206D61747269783B0A20206361736520313A0A2020202072657475726E20657874656E64286D61747269782C2061293B0A20206361736520363A0A2020202072657475726E20657874656E6428';
wwv_flow_imp.g_varchar2_table(5737) := '6D61747269782C207B0A202020202020613A20612C0A202020202020623A20622C0A202020202020633A20632C0A202020202020643A20642C0A202020202020653A20652C0A202020202020663A20660A202020207D293B0A20207D0A7D0A0A66756E63';
wwv_flow_imp.g_varchar2_table(5738) := '74696F6E206372656174655472616E73666F726D286D617472697829207B0A2020696620286D617472697829207B0A2020202072657475726E206765744E6F646528292E6372656174655356475472616E73666F726D46726F6D4D6174726978286D6174';
wwv_flow_imp.g_varchar2_table(5739) := '726978293B0A20207D20656C7365207B0A2020202072657475726E206765744E6F646528292E6372656174655356475472616E73666F726D28293B0A20207D0A7D0A0A2F2A2A0A202A2053657269616C697A6174696F6E207574696C0A202A2F0A0A7661';
wwv_flow_imp.g_varchar2_table(5740) := '7220544558545F454E544954494553203D202F285B263C3E5D7B317D292F673B0A76617220415454525F454E544954494553203D202F285B5C6E5C72225D7B317D292F673B0A0A76617220454E544954595F5245504C4143454D454E54203D207B0A2020';
wwv_flow_imp.g_varchar2_table(5741) := '2726273A202726616D703B272C0A2020273C273A2027266C743B272C0A2020273E273A20272667743B272C0A20202722273A20275C27270A7D3B0A0A66756E6374696F6E20657363617065287374722C207061747465726E29207B0A0A202066756E6374';
wwv_flow_imp.g_varchar2_table(5742) := '696F6E207265706C616365466E286D617463682C20656E7469747929207B0A2020202072657475726E20454E544954595F5245504C4143454D454E545B656E746974795D207C7C20656E746974793B0A20207D0A0A202072657475726E207374722E7265';
wwv_flow_imp.g_varchar2_table(5743) := '706C616365287061747465726E2C207265706C616365466E293B0A7D0A0A66756E6374696F6E2073657269616C697A65286E6F64652C206F757470757429207B0A0A202076617220692C206C656E2C20617474724D61702C20617474724E6F64652C2063';
wwv_flow_imp.g_varchar2_table(5744) := '68696C644E6F6465733B0A0A202073776974636820286E6F64652E6E6F64655479706529207B0A0A20202F2F20544558540A20206361736520333A0A0A202020202F2F207265706C616365207370656369616C20584D4C20636861726163746572730A20';
wwv_flow_imp.g_varchar2_table(5745) := '2020206F75747075742E7075736828657363617065286E6F64652E74657874436F6E74656E742C20544558545F454E54495449455329293B0A20202020627265616B3B0A0A20202F2F20454C454D454E540A20206361736520313A0A202020206F757470';
wwv_flow_imp.g_varchar2_table(5746) := '75742E7075736828273C272C206E6F64652E7461674E616D65293B0A0A20202020696620286E6F64652E68617341747472696275746573282929207B0A202020202020617474724D6170203D206E6F64652E617474726962757465733B0A202020202020';
wwv_flow_imp.g_varchar2_table(5747) := '666F72202869203D20302C206C656E203D20617474724D61702E6C656E6774683B2069203C206C656E3B202B2B6929207B0A2020202020202020617474724E6F6465203D20617474724D61702E6974656D2869293B0A20202020202020206F7574707574';
wwv_flow_imp.g_varchar2_table(5748) := '2E70757368282720272C20617474724E6F64652E6E616D652C20273D22272C2065736361706528617474724E6F64652E76616C75652C20415454525F454E544954494553292C20272227293B0A2020202020207D0A202020207D0A0A2020202069662028';
wwv_flow_imp.g_varchar2_table(5749) := '6E6F64652E6861734368696C644E6F646573282929207B0A2020202020206F75747075742E7075736828273E27293B0A2020202020206368696C644E6F646573203D206E6F64652E6368696C644E6F6465733B0A202020202020666F72202869203D2030';
wwv_flow_imp.g_varchar2_table(5750) := '2C206C656E203D206368696C644E6F6465732E6C656E6774683B2069203C206C656E3B202B2B6929207B0A202020202020202073657269616C697A65286368696C644E6F6465732E6974656D2869292C206F7574707574293B0A2020202020207D0A2020';
wwv_flow_imp.g_varchar2_table(5751) := '202020206F75747075742E7075736828273C2F272C206E6F64652E7461674E616D652C20273E27293B0A202020207D20656C7365207B0A2020202020206F75747075742E7075736828272F3E27293B0A202020207D0A20202020627265616B3B0A0A2020';
wwv_flow_imp.g_varchar2_table(5752) := '2F2F20434F4D4D454E540A20206361736520383A0A202020206F75747075742E7075736828273C212D2D272C20657363617065286E6F64652E6E6F646556616C75652C20544558545F454E544954494553292C20272D2D3E27293B0A2020202062726561';
wwv_flow_imp.g_varchar2_table(5753) := '6B3B0A0A20202F2F2043444154410A20206361736520343A0A202020206F75747075742E7075736828273C215B43444154415B272C206E6F64652E6E6F646556616C75652C20275D5D3E27293B0A20202020627265616B3B0A0A202064656661756C743A';
wwv_flow_imp.g_varchar2_table(5754) := '0A202020207468726F77206E6577204572726F722827756E61626C6520746F2068616E646C65206E6F64652027202B206E6F64652E6E6F646554797065293B0A20207D0A0A202072657475726E206F75747075743B0A7D0A0A2F2A2A0A202A20696E6E65';
wwv_flow_imp.g_varchar2_table(5755) := '7248544D4C206C696B652066756E6374696F6E616C69747920666F722053564720656C656D656E74732E0A202A206261736564206F6E20696E6E6572535647202868747470733A2F2F636F64652E676F6F676C652E636F6D2F702F696E6E657273766729';
wwv_flow_imp.g_varchar2_table(5756) := '0A202A2F0A0A0A0A66756E6374696F6E2073657428656C656D656E742C2073766729207B0A0A202076617220706172736564203D20706172736528737667293B0A0A20202F2F20636C65617220656C656D656E7420636F6E74656E74730A2020636C6561';
wwv_flow_imp.g_varchar2_table(5757) := '7228656C656D656E74293B0A0A2020696620282173766729207B0A2020202072657475726E3B0A20207D0A0A202069662028216973467261676D656E74287061727365642929207B0A0A202020202F2F2065787472616374203C7376673E2066726F6D20';
wwv_flow_imp.g_varchar2_table(5758) := '70617273656420646F63756D656E740A20202020706172736564203D207061727365642E646F63756D656E74456C656D656E743B0A20207D0A0A2020766172206E6F646573203D20736C696365287061727365642E6368696C644E6F646573293B0A0A20';
wwv_flow_imp.g_varchar2_table(5759) := '202F2F20696D706F7274202B20617070656E642065616368206E6F64650A2020666F7220287661722069203D20303B2069203C206E6F6465732E6C656E6774683B20692B2B29207B0A20202020617070656E64546F286E6F6465735B695D2C20656C656D';
wwv_flow_imp.g_varchar2_table(5760) := '656E74293B0A20207D0A0A7D0A0A66756E6374696F6E2067657428656C656D656E7429207B0A2020766172206368696C64203D20656C656D656E742E66697273744368696C642C0A2020202020206F7574707574203D205B5D3B0A0A20207768696C6520';
wwv_flow_imp.g_varchar2_table(5761) := '286368696C6429207B0A2020202073657269616C697A65286368696C642C206F7574707574293B0A202020206368696C64203D206368696C642E6E6578745369626C696E673B0A20207D0A0A202072657475726E206F75747075742E6A6F696E28272729';
wwv_flow_imp.g_varchar2_table(5762) := '3B0A7D0A0A66756E6374696F6E206973467261676D656E74286E6F646529207B0A202072657475726E206E6F64652E6E6F64654E616D65203D3D3D202723646F63756D656E742D667261676D656E74273B0A7D0A0A66756E6374696F6E20696E6E657253';
wwv_flow_imp.g_varchar2_table(5763) := '564728656C656D656E742C2073766729207B0A0A20206966202873766720213D3D20756E646566696E656429207B0A0A20202020747279207B0A20202020202073657428656C656D656E742C20737667293B0A202020207D20636174636820286529207B';
wwv_flow_imp.g_varchar2_table(5764) := '0A2020202020207468726F77206E6577204572726F7228276572726F722070617273696E67205356473A2027202B20652E6D657373616765293B0A202020207D0A0A2020202072657475726E20656C656D656E743B0A20207D20656C7365207B0A202020';
wwv_flow_imp.g_varchar2_table(5765) := '2072657475726E2067657428656C656D656E74293B0A20207D0A7D0A0A0A66756E6374696F6E20736C6963652861727229207B0A202072657475726E2041727261792E70726F746F747970652E736C6963652E63616C6C28617272293B0A7D0A0A2F2A2A';
wwv_flow_imp.g_varchar2_table(5766) := '0A202A2053656C656374696F6E207574696C69746965730A202A2F0A0A66756E6374696F6E2073656C656374286E6F64652C2073656C6563746F7229207B0A202072657475726E206E6F64652E717565727953656C6563746F722873656C6563746F7229';
wwv_flow_imp.g_varchar2_table(5767) := '3B0A7D0A0A66756E6374696F6E2073656C656374416C6C286E6F64652C2073656C6563746F7229207B0A2020766172206E6F646573203D206E6F64652E717565727953656C6563746F72416C6C2873656C6563746F72293B0A0A202072657475726E205B';
wwv_flow_imp.g_varchar2_table(5768) := '5D2E6D61702E63616C6C286E6F6465732C2066756E6374696F6E28656C656D656E7429207B0A2020202072657475726E20656C656D656E743B0A20207D293B0A7D0A0A2F2A2A0A202A2070726570656E64546F207574696C6974790A202A2F0A0A0A2F2A';
wwv_flow_imp.g_varchar2_table(5769) := '2A0A202A2050726570656E642061206E6F646520746F20612074617267657420656C656D656E7420616E642072657475726E207468652070726570656E646564206E6F64652E0A202A0A202A2040706172616D20207B535647456C656D656E747D206E6F';
wwv_flow_imp.g_varchar2_table(5770) := '64650A202A2040706172616D20207B535647456C656D656E747D207461726765740A202A0A202A204072657475726E207B535647456C656D656E747D207468652070726570656E646564206E6F64650A202A2F0A66756E6374696F6E2070726570656E64';
wwv_flow_imp.g_varchar2_table(5771) := '546F286E6F64652C2074617267657429207B0A202072657475726E207461726765742E696E736572744265666F726528656E73757265496D706F72746564286E6F64652C20746172676574292C207461726765742E66697273744368696C64207C7C206E';
wwv_flow_imp.g_varchar2_table(5772) := '756C6C293B0A7D0A0A2F2A2A0A202A2070726570656E64207574696C6974790A202A2F0A0A0A2F2A2A0A202A2050726570656E642061206E6F646520746F20612074617267657420656C656D656E740A202A0A202A2040706172616D20207B535647456C';
wwv_flow_imp.g_varchar2_table(5773) := '656D656E747D207461726765740A202A2040706172616D20207B535647456C656D656E747D206E6F64650A202A0A202A204072657475726E207B535647456C656D656E747D207468652074617267657420656C656D656E740A202A2F0A66756E6374696F';
wwv_flow_imp.g_varchar2_table(5774) := '6E2070726570656E64287461726765742C206E6F646529207B0A202070726570656E64546F286E6F64652C20746172676574293B0A202072657475726E207461726765743B0A7D0A0A66756E6374696F6E2072656D6F766528656C656D656E7429207B0A';
wwv_flow_imp.g_varchar2_table(5775) := '202076617220706172656E74203D20656C656D656E742E706172656E744E6F64653B0A0A202069662028706172656E7429207B0A20202020706172656E742E72656D6F76654368696C6428656C656D656E74293B0A20207D0A0A202072657475726E2065';
wwv_flow_imp.g_varchar2_table(5776) := '6C656D656E743B0A7D0A0A2F2A2A0A202A205265706C616365207574696C6974790A202A2F0A0A0A66756E6374696F6E207265706C61636528656C656D656E742C207265706C6163656D656E7429207B0A2020656C656D656E742E706172656E744E6F64';
wwv_flow_imp.g_varchar2_table(5777) := '652E7265706C6163654368696C6428656E73757265496D706F72746564287265706C6163656D656E742C20656C656D656E74292C20656C656D656E74293B0A202072657475726E207265706C6163656D656E743B0A7D0A0A2F2A2A0A202A207472616E73';
wwv_flow_imp.g_varchar2_table(5778) := '666F726D206163636573736F72207574696C6974790A202A2F0A0A66756E6374696F6E20777261704D6174726978287472616E73666F726D4C6973742C207472616E73666F726D29207B0A2020696620287472616E73666F726D20696E7374616E63656F';
wwv_flow_imp.g_varchar2_table(5779) := '66205356474D617472697829207B0A2020202072657475726E207472616E73666F726D4C6973742E6372656174655356475472616E73666F726D46726F6D4D6174726978287472616E73666F726D293B0A20207D0A0A202072657475726E207472616E73';
wwv_flow_imp.g_varchar2_table(5780) := '666F726D3B0A7D0A0A0A66756E6374696F6E207365745472616E73666F726D73287472616E73666F726D4C6973742C207472616E73666F726D7329207B0A202076617220692C20743B0A0A20207472616E73666F726D4C6973742E636C65617228293B0A';
wwv_flow_imp.g_varchar2_table(5781) := '0A2020666F72202869203D20303B202874203D207472616E73666F726D735B695D293B20692B2B29207B0A202020207472616E73666F726D4C6973742E617070656E644974656D28777261704D6174726978287472616E73666F726D4C6973742C207429';
wwv_flow_imp.g_varchar2_table(5782) := '293B0A20207D0A7D0A0A2F2A2A0A202A20476574206F722073657420746865207472616E73666F726D73206F6E2074686520676976656E206E6F64652E0A202A0A202A2040706172616D207B535647456C656D656E747D206E6F64650A202A2040706172';
wwv_flow_imp.g_varchar2_table(5783) := '616D20207B5356475472616E73666F726D7C5356474D61747269787C41727261793C5356475472616E73666F726D7C5356474D61747269783E7D205B7472616E73666F726D735D0A202A0A202A204072657475726E207B5356475472616E73666F726D7D';
wwv_flow_imp.g_varchar2_table(5784) := '2074686520636F6E736F6C696461746564207472616E73666F726D0A202A2F0A66756E6374696F6E207472616E73666F726D286E6F64652C207472616E73666F726D7329207B0A2020766172207472616E73666F726D4C697374203D206E6F64652E7472';
wwv_flow_imp.g_varchar2_table(5785) := '616E73666F726D2E6261736556616C3B0A0A2020696620287472616E73666F726D7329207B0A0A20202020696620282141727261792E69734172726179287472616E73666F726D732929207B0A2020202020207472616E73666F726D73203D205B207472';
wwv_flow_imp.g_varchar2_table(5786) := '616E73666F726D73205D3B0A202020207D0A0A202020207365745472616E73666F726D73287472616E73666F726D4C6973742C207472616E73666F726D73293B0A20207D0A0A202072657475726E207472616E73666F726D4C6973742E636F6E736F6C69';
wwv_flow_imp.g_varchar2_table(5787) := '6461746528293B0A7D0A0A0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D6D6F64646C652F646973742F696E6465782E65736D2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(5788) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F62706D6E2D6D6F64646C652F646973742F696E6465782E65736D2E6A73202A2A2A210A20205C2A2A';
wwv_flow_imp.g_varchar2_table(5789) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F5F5F7765627061636B5F6D6F64756C655F5F2C205F5F77';
wwv_flow_imp.g_varchar2_table(5790) := '65627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E7920';
wwv_flow_imp.g_varchar2_table(5791) := '6578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062';
wwv_flow_imp.g_varchar2_table(5792) := '696E64696E67202A2F2073696D706C65290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(5793) := '455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E79';
wwv_flow_imp.g_varchar2_table(5794) := '20696D706F7274202A2F20766172206D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D6F64646C65202A2F20222E2F6E6F64655F6D6F64756C';
wwv_flow_imp.g_varchar2_table(5795) := '65732F6D6F64646C652F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D6F64646C655F786D6C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F';
wwv_flow_imp.g_varchar2_table(5796) := '7765627061636B5F726571756972655F5F282F2A21206D6F64646C652D786D6C202A2F20222E2F6E6F64655F6D6F64756C65732F6D6F64646C652D786D6C2F646973742F696E6465782E65736D2E6A7322293B0A0A0A0A0A2F2A2A0A202A204120737562';
wwv_flow_imp.g_varchar2_table(5797) := '20636C617373206F66207B406C696E6B204D6F64646C657D207769746820737570706F727420666F7220696D706F727420616E64206578706F7274206F662042504D4E20322E3020786D6C2066696C65732E0A202A0A202A2040636C6173732042706D6E';
wwv_flow_imp.g_varchar2_table(5798) := '4D6F64646C650A202A2040657874656E6473204D6F64646C650A202A0A202A2040706172616D207B4F626A6563747C41727261797D207061636B6167657320746F2075736520666F7220696E7374616E74696174696E6720746865206D6F64656C0A202A';
wwv_flow_imp.g_varchar2_table(5799) := '2040706172616D207B4F626A6563747D205B6F7074696F6E735D206164646974696F6E616C206F7074696F6E7320746F2070617373206F7665720A202A2F0A66756E6374696F6E2042706D6E4D6F64646C65287061636B616765732C206F7074696F6E73';
wwv_flow_imp.g_varchar2_table(5800) := '29207B0A20206D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E4D6F64646C652E63616C6C28746869732C207061636B616765732C206F7074696F6E73293B0A7D0A0A42706D6E4D6F64646C652E70726F746F74';
wwv_flow_imp.g_varchar2_table(5801) := '797065203D204F626A6563742E637265617465286D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E4D6F64646C652E70726F746F74797065293B0A0A2F2A2A0A202A205468652066726F6D584D4C20726573756C';
wwv_flow_imp.g_varchar2_table(5802) := '742E0A202A0A202A204074797065646566207B4F626A6563747D205061727365526573756C740A202A0A202A204070726F7065727479207B4D6F64646C65456C656D656E747D20726F6F74456C656D656E740A202A204070726F7065727479207B417272';
wwv_flow_imp.g_varchar2_table(5803) := '61793C4F626A6563743E7D207265666572656E6365730A202A204070726F7065727479207B41727261793C4572726F723E7D207761726E696E67730A202A204070726F7065727479207B4F626A6563747D20656C656D656E747342794964202D2061206D';
wwv_flow_imp.g_varchar2_table(5804) := '617070696E6720636F6E7461696E696E672065616368204944202D3E204D6F64646C65456C656D656E740A202A2F0A0A2F2A2A0A202A205468652066726F6D584D4C206572726F722E0A202A0A202A204074797065646566207B4572726F727D20506172';
wwv_flow_imp.g_varchar2_table(5805) := '73654572726F720A202A0A202A204070726F7065727479207B41727261793C4572726F723E7D207761726E696E67730A202A2F0A0A2F2A2A0A202A20496E7374616E74696174657320612042504D4E206D6F64656C20747265652066726F6D2061206769';
wwv_flow_imp.g_varchar2_table(5806) := '76656E20786D6C20737472696E672E0A202A0A202A2040706172616D207B537472696E677D202020786D6C5374720A202A2040706172616D207B537472696E677D2020205B747970654E616D653D2762706D6E3A446566696E6974696F6E73275D206E61';
wwv_flow_imp.g_varchar2_table(5807) := '6D65206F662074686520726F6F7420656C656D656E740A202A2040706172616D207B4F626A6563747D2020205B6F7074696F6E735D20206F7074696F6E7320746F207061737320746F2074686520756E6465726C79696E67207265616465720A202A0A20';
wwv_flow_imp.g_varchar2_table(5808) := '2A204072657475726E73207B50726F6D6973653C5061727365526573756C742C2050617273654572726F723E7D0A202A2F0A42706D6E4D6F64646C652E70726F746F747970652E66726F6D584D4C203D2066756E6374696F6E28786D6C5374722C207479';
wwv_flow_imp.g_varchar2_table(5809) := '70654E616D652C206F7074696F6E7329207B0A0A2020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E6973537472696E672928747970654E616D652929207B0A202020206F7074696F';
wwv_flow_imp.g_varchar2_table(5810) := '6E73203D20747970654E616D653B0A20202020747970654E616D65203D202762706D6E3A446566696E6974696F6E73273B0A20207D0A0A202076617220726561646572203D206E6577206D6F64646C655F786D6C5F5F5745425041434B5F494D504F5254';
wwv_flow_imp.g_varchar2_table(5811) := '45445F4D4F44554C455F325F5F2E5265616465722828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E61737369676E29287B206D6F64656C3A20746869732C206C61783A2074727565207D2C206F70';
wwv_flow_imp.g_varchar2_table(5812) := '74696F6E7329293B0A202076617220726F6F7448616E646C6572203D207265616465722E68616E646C657228747970654E616D65293B0A0A202072657475726E207265616465722E66726F6D584D4C28786D6C5374722C20726F6F7448616E646C657229';
wwv_flow_imp.g_varchar2_table(5813) := '3B0A7D3B0A0A0A2F2A2A0A202A2054686520746F584D4C20726573756C742E0A202A0A202A204074797065646566207B4F626A6563747D2053657269616C697A6174696F6E526573756C740A202A0A202A204070726F7065727479207B537472696E677D';
wwv_flow_imp.g_varchar2_table(5814) := '20786D6C0A202A2F0A0A2F2A2A0A202A2053657269616C697A657320612042504D4E20322E30206F626A656374207472656520746F20584D4C2E0A202A0A202A2040706172616D207B537472696E677D202020656C656D656E742020202074686520726F';
wwv_flow_imp.g_varchar2_table(5815) := '6F7420656C656D656E742C207479706963616C6C7920616E20696E7374616E6365206F66206062706D6E3A446566696E6974696F6E73600A202A2040706172616D207B4F626A6563747D2020205B6F7074696F6E735D2020746F207061737320746F2074';
wwv_flow_imp.g_varchar2_table(5816) := '686520756E6465726C79696E67207772697465720A202A0A202A204072657475726E73207B50726F6D6973653C53657269616C697A6174696F6E526573756C742C204572726F723E7D0A202A2F0A42706D6E4D6F64646C652E70726F746F747970652E74';
wwv_flow_imp.g_varchar2_table(5817) := '6F584D4C203D2066756E6374696F6E28656C656D656E742C206F7074696F6E7329207B0A0A202076617220777269746572203D206E6577206D6F64646C655F786D6C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E57726974';
wwv_flow_imp.g_varchar2_table(5818) := '6572286F7074696F6E73293B0A0A202072657475726E206E65772050726F6D6973652866756E6374696F6E287265736F6C76652C2072656A65637429207B0A20202020747279207B0A20202020202076617220726573756C74203D207772697465722E74';
wwv_flow_imp.g_varchar2_table(5819) := '6F584D4C28656C656D656E74293B0A0A20202020202072657475726E207265736F6C7665287B0A2020202020202020786D6C3A20726573756C740A2020202020207D293B0A202020207D206361746368202865727229207B0A2020202020207265747572';
wwv_flow_imp.g_varchar2_table(5820) := '6E2072656A65637428657272293B0A202020207D0A20207D293B0A7D3B0A0A766172206E616D652435203D202242504D4E3230223B0A766172207572692435203D2022687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130';
wwv_flow_imp.g_varchar2_table(5821) := '303532342F4D4F44454C223B0A766172207072656669782435203D202262706D6E223B0A766172206173736F63696174696F6E732435203D205B0A5D3B0A7661722074797065732435203D205B0A097B0A09096E616D653A2022496E7465726661636522';
wwv_flow_imp.g_varchar2_table(5822) := '2C0A09097375706572436C6173733A205B0A09090922526F6F74456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A090909';
wwv_flow_imp.g_varchar2_table(5823) := '09747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20226F7065726174696F6E73222C0A09090909747970653A20224F7065726174696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A090909';
wwv_flow_imp.g_varchar2_table(5824) := '7B0A090909096E616D653A2022696D706C656D656E746174696F6E526566222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224F70657261';
wwv_flow_imp.g_varchar2_table(5825) := '74696F6E222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A2074727565';
wwv_flow_imp.g_varchar2_table(5826) := '2C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022696E4D657373616765526566222C0A09090909747970653A20224D657373616765222C0A0909090969735265666572656E63653A2074727565';
wwv_flow_imp.g_varchar2_table(5827) := '0A0909097D2C0A0909097B0A090909096E616D653A20226F75744D657373616765526566222C0A09090909747970653A20224D657373616765222C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D';
wwv_flow_imp.g_varchar2_table(5828) := '653A20226572726F72526566222C0A09090909747970653A20224572726F72222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022696D706C';
wwv_flow_imp.g_varchar2_table(5829) := '656D656E746174696F6E526566222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022456E64506F696E74222C0A09097375706572436C6173';
wwv_flow_imp.g_varchar2_table(5830) := '733A205B0A09090922526F6F74456C656D656E74220A09095D0A097D2C0A097B0A09096E616D653A20224175646974696E67222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D0A097D2C0A097B0A09096E';
wwv_flow_imp.g_varchar2_table(5831) := '616D653A2022476C6F62616C5461736B222C0A09097375706572436C6173733A205B0A0909092243616C6C61626C65456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20227265736F757263';
wwv_flow_imp.g_varchar2_table(5832) := '6573222C0A09090909747970653A20225265736F75726365526F6C65222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224D6F6E69746F72696E67222C0A09097375706572436C6173733A20';
wwv_flow_imp.g_varchar2_table(5833) := '5B0A0909092242617365456C656D656E74220A09095D0A097D2C0A097B0A09096E616D653A2022506572666F726D6572222C0A09097375706572436C6173733A205B0A090909225265736F75726365526F6C65220A09095D0A097D2C0A097B0A09096E61';
wwv_flow_imp.g_varchar2_table(5834) := '6D653A202250726F63657373222C0A09097375706572436C6173733A205B0A09090922466C6F77456C656D656E7473436F6E7461696E6572222C0A0909092243616C6C61626C65456C656D656E74220A09095D2C0A090970726F706572746965733A205B';
wwv_flow_imp.g_varchar2_table(5835) := '0A0909097B0A090909096E616D653A202270726F6365737354797065222C0A09090909747970653A202250726F6365737354797065222C0A090909096973417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226973436C6F';
wwv_flow_imp.g_varchar2_table(5836) := '736564222C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A20226175646974696E67222C0A09090909747970653A20224175646974696E67220A0909';
wwv_flow_imp.g_varchar2_table(5837) := '097D2C0A0909097B0A090909096E616D653A20226D6F6E69746F72696E67222C0A09090909747970653A20224D6F6E69746F72696E67220A0909097D2C0A0909097B0A090909096E616D653A202270726F70657274696573222C0A09090909747970653A';
wwv_flow_imp.g_varchar2_table(5838) := '202250726F7065727479222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226C616E6553657473222C0A0909090969734D616E793A20747275652C0A090909097265706C616365733A2022466C6F77';
wwv_flow_imp.g_varchar2_table(5839) := '456C656D656E7473436F6E7461696E6572236C616E6553657473222C0A09090909747970653A20224C616E65536574220A0909097D2C0A0909097B0A090909096E616D653A2022666C6F77456C656D656E7473222C0A0909090969734D616E793A207472';
wwv_flow_imp.g_varchar2_table(5840) := '75652C0A090909097265706C616365733A2022466C6F77456C656D656E7473436F6E7461696E657223666C6F77456C656D656E7473222C0A09090909747970653A2022466C6F77456C656D656E74220A0909097D2C0A0909097B0A090909096E616D653A';
wwv_flow_imp.g_varchar2_table(5841) := '2022617274696661637473222C0A09090909747970653A20224172746966616374222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A20227265736F7572636573222C0A09090909747970653A20225265';
wwv_flow_imp.g_varchar2_table(5842) := '736F75726365526F6C65222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022636F7272656C6174696F6E537562736372697074696F6E73222C0A09090909747970653A2022436F7272656C6174696F';
wwv_flow_imp.g_varchar2_table(5843) := '6E537562736372697074696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022737570706F727473222C0A09090909747970653A202250726F63657373222C0A0909090969734D616E793A2074';
wwv_flow_imp.g_varchar2_table(5844) := '7275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022646566696E6974696F6E616C436F6C6C61626F726174696F6E526566222C0A09090909747970653A2022436F6C6C61626F7261';
wwv_flow_imp.g_varchar2_table(5845) := '74696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022697345786563757461626C65222C0A090909096973417474723A2074727565';
wwv_flow_imp.g_varchar2_table(5846) := '2C0A09090909747970653A2022426F6F6C65616E220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224C616E65536574222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F';
wwv_flow_imp.g_varchar2_table(5847) := '706572746965733A205B0A0909097B0A090909096E616D653A20226C616E6573222C0A09090909747970653A20224C616E65222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226E616D65222C0A09';
wwv_flow_imp.g_varchar2_table(5848) := '0909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224C616E65222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E7422';
wwv_flow_imp.g_varchar2_table(5849) := '0A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D';
wwv_flow_imp.g_varchar2_table(5850) := '653A2022706172746974696F6E456C656D656E74526566222C0A09090909747970653A202242617365456C656D656E74222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A090909';
wwv_flow_imp.g_varchar2_table(5851) := '7B0A090909096E616D653A2022706172746974696F6E456C656D656E74222C0A09090909747970653A202242617365456C656D656E74220A0909097D2C0A0909097B0A090909096E616D653A2022666C6F774E6F6465526566222C0A0909090974797065';
wwv_flow_imp.g_varchar2_table(5852) := '3A2022466C6F774E6F6465222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226368696C644C616E65536574222C0A09090909747970653A';
wwv_flow_imp.g_varchar2_table(5853) := '20224C616E65536574222C0A09090909786D6C3A207B0A090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022476C6F62616C4D616E75616C5461736B222C0A';
wwv_flow_imp.g_varchar2_table(5854) := '09097375706572436C6173733A205B0A09090922476C6F62616C5461736B220A09095D0A097D2C0A097B0A09096E616D653A20224D616E75616C5461736B222C0A09097375706572436C6173733A205B0A090909225461736B220A09095D0A097D2C0A09';
wwv_flow_imp.g_varchar2_table(5855) := '7B0A09096E616D653A2022557365725461736B222C0A09097375706572436C6173733A205B0A090909225461736B220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202272656E646572696E6773222C0A0909';
wwv_flow_imp.g_varchar2_table(5856) := '0909747970653A202252656E646572696E67222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022696D706C656D656E746174696F6E222C0A090909096973417474723A20747275652C0A0909090974';
wwv_flow_imp.g_varchar2_table(5857) := '7970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202252656E646572696E67222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D0A097D2C0A097B0A09096E616D';
wwv_flow_imp.g_varchar2_table(5858) := '653A202248756D616E506572666F726D6572222C0A09097375706572436C6173733A205B0A09090922506572666F726D6572220A09095D0A097D2C0A097B0A09096E616D653A2022506F74656E7469616C4F776E6572222C0A09097375706572436C6173';
wwv_flow_imp.g_varchar2_table(5859) := '733A205B0A0909092248756D616E506572666F726D6572220A09095D0A097D2C0A097B0A09096E616D653A2022476C6F62616C557365725461736B222C0A09097375706572436C6173733A205B0A09090922476C6F62616C5461736B220A09095D2C0A09';
wwv_flow_imp.g_varchar2_table(5860) := '0970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696D706C656D656E746174696F6E222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A09090909';
wwv_flow_imp.g_varchar2_table(5861) := '6E616D653A202272656E646572696E6773222C0A09090909747970653A202252656E646572696E67222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202247617465776179222C0A0909697341';
wwv_flow_imp.g_varchar2_table(5862) := '627374726163743A20747275652C0A09097375706572436C6173733A205B0A09090922466C6F774E6F6465220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202267617465776179446972656374696F6E222C';
wwv_flow_imp.g_varchar2_table(5863) := '0A09090909747970653A202247617465776179446972656374696F6E222C0A090909092264656661756C74223A2022556E737065636966696564222C0A090909096973417474723A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D65';
wwv_flow_imp.g_varchar2_table(5864) := '3A20224576656E74426173656447617465776179222C0A09097375706572436C6173733A205B0A0909092247617465776179220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696E7374616E7469617465';
wwv_flow_imp.g_varchar2_table(5865) := '222C0A090909092264656661756C74223A2066616C73652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A20226576656E7447617465776179547970';
wwv_flow_imp.g_varchar2_table(5866) := '65222C0A09090909747970653A20224576656E7442617365644761746577617954797065222C0A090909096973417474723A20747275652C0A090909092264656661756C74223A20224578636C7573697665220A0909097D0A09095D0A097D2C0A097B0A';
wwv_flow_imp.g_varchar2_table(5867) := '09096E616D653A2022436F6D706C657847617465776179222C0A09097375706572436C6173733A205B0A0909092247617465776179220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226163746976617469';
wwv_flow_imp.g_varchar2_table(5868) := '6F6E436F6E646974696F6E222C0A09090909747970653A202245787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909097D2C0A0909097B0A090909096E616D';
wwv_flow_imp.g_varchar2_table(5869) := '653A202264656661756C74222C0A09090909747970653A202253657175656E6365466C6F77222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E61';
wwv_flow_imp.g_varchar2_table(5870) := '6D653A20224578636C757369766547617465776179222C0A09097375706572436C6173733A205B0A0909092247617465776179220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202264656661756C74222C0A';
wwv_flow_imp.g_varchar2_table(5871) := '09090909747970653A202253657175656E6365466C6F77222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022496E636C7573697665';
wwv_flow_imp.g_varchar2_table(5872) := '47617465776179222C0A09097375706572436C6173733A205B0A0909092247617465776179220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202264656661756C74222C0A09090909747970653A2022536571';
wwv_flow_imp.g_varchar2_table(5873) := '75656E6365466C6F77222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022506172616C6C656C47617465776179222C0A0909737570';
wwv_flow_imp.g_varchar2_table(5874) := '6572436C6173733A205B0A0909092247617465776179220A09095D0A097D2C0A097B0A09096E616D653A2022526F6F74456C656D656E74222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A205B0A090909224261';
wwv_flow_imp.g_varchar2_table(5875) := '7365456C656D656E74220A09095D0A097D2C0A097B0A09096E616D653A202252656C6174696F6E73686970222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A';
wwv_flow_imp.g_varchar2_table(5876) := '0909097B0A090909096E616D653A202274797065222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022646972656374696F6E222C0A090909097479';
wwv_flow_imp.g_varchar2_table(5877) := '70653A202252656C6174696F6E73686970446972656374696F6E222C0A090909096973417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022736F75726365222C0A0909090969734D616E793A20747275652C0A0909090969';
wwv_flow_imp.g_varchar2_table(5878) := '735265666572656E63653A20747275652C0A09090909747970653A2022456C656D656E74220A0909097D2C0A0909097B0A090909096E616D653A2022746172676574222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E';
wwv_flow_imp.g_varchar2_table(5879) := '63653A20747275652C0A09090909747970653A2022456C656D656E74220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202242617365456C656D656E74222C0A0909697341627374726163743A20747275652C0A090970726F706572746965';
wwv_flow_imp.g_varchar2_table(5880) := '733A205B0A0909097B0A090909096E616D653A20226964222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67222C0A09090909697349643A20747275650A0909097D2C0A0909097B0A090909096E616D653A20';
wwv_flow_imp.g_varchar2_table(5881) := '22646F63756D656E746174696F6E222C0A09090909747970653A2022446F63756D656E746174696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022657874656E73696F6E446566696E697469';
wwv_flow_imp.g_varchar2_table(5882) := '6F6E73222C0A09090909747970653A2022457874656E73696F6E446566696E6974696F6E222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20';
wwv_flow_imp.g_varchar2_table(5883) := '22657874656E73696F6E456C656D656E7473222C0A09090909747970653A2022457874656E73696F6E456C656D656E7473220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022457874656E73696F6E222C0A090970726F70657274696573';
wwv_flow_imp.g_varchar2_table(5884) := '3A205B0A0909097B0A090909096E616D653A20226D757374556E6465727374616E64222C0A090909092264656661756C74223A2066616C73652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A090909';
wwv_flow_imp.g_varchar2_table(5885) := '7D2C0A0909097B0A090909096E616D653A2022646566696E6974696F6E222C0A09090909747970653A2022457874656E73696F6E446566696E6974696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20';
wwv_flow_imp.g_varchar2_table(5886) := '747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022457874656E73696F6E446566696E6974696F6E222C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474';
wwv_flow_imp.g_varchar2_table(5887) := '723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022657874656E73696F6E417474726962757465446566696E6974696F6E73222C0A09090909747970653A2022457874656E7369';
wwv_flow_imp.g_varchar2_table(5888) := '6F6E417474726962757465446566696E6974696F6E222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022457874656E73696F6E417474726962757465446566696E6974696F6E222C0A090970';
wwv_flow_imp.g_varchar2_table(5889) := '726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20227479706522';
wwv_flow_imp.g_varchar2_table(5890) := '2C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A202269735265666572656E6365222C0A090909092264656661756C74223A2066616C73652C0A090909';
wwv_flow_imp.g_varchar2_table(5891) := '096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A2022657874656E73696F6E446566696E6974696F6E222C0A09090909747970653A2022457874656E73696F6E44';
wwv_flow_imp.g_varchar2_table(5892) := '6566696E6974696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022457874656E73696F6E456C656D656E7473222C0A090970';
wwv_flow_imp.g_varchar2_table(5893) := '726F706572746965733A205B0A0909097B0A090909096E616D653A202276616C7565526566222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275652C0A09090909747970653A2022456C656D656E7422';
wwv_flow_imp.g_varchar2_table(5894) := '0A0909097D2C0A0909097B0A090909096E616D653A202276616C756573222C0A09090909747970653A2022456C656D656E74222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022657874656E73696F';
wwv_flow_imp.g_varchar2_table(5895) := '6E417474726962757465446566696E6974696F6E222C0A09090909747970653A2022457874656E73696F6E417474726962757465446566696E6974696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20';
wwv_flow_imp.g_varchar2_table(5896) := '747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022446F63756D656E746174696F6E222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A';
wwv_flow_imp.g_varchar2_table(5897) := '0909097B0A090909096E616D653A202274657874222C0A09090909747970653A2022537472696E67222C0A090909096973426F64793A20747275650A0909097D2C0A0909097B0A090909096E616D653A202274657874466F726D6174222C0A0909090922';
wwv_flow_imp.g_varchar2_table(5898) := '64656661756C74223A2022746578742F706C61696E222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224576656E74222C0A090969734162';
wwv_flow_imp.g_varchar2_table(5899) := '7374726163743A20747275652C0A09097375706572436C6173733A205B0A09090922466C6F774E6F6465222C0A09090922496E746572616374696F6E4E6F6465220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D65';
wwv_flow_imp.g_varchar2_table(5900) := '3A202270726F70657274696573222C0A09090909747970653A202250726F7065727479222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022496E7465726D6564696174654361746368457665';
wwv_flow_imp.g_varchar2_table(5901) := '6E74222C0A09097375706572436C6173733A205B0A0909092243617463684576656E74220A09095D0A097D2C0A097B0A09096E616D653A2022496E7465726D6564696174655468726F774576656E74222C0A09097375706572436C6173733A205B0A0909';
wwv_flow_imp.g_varchar2_table(5902) := '09225468726F774576656E74220A09095D0A097D2C0A097B0A09096E616D653A2022456E644576656E74222C0A09097375706572436C6173733A205B0A090909225468726F774576656E74220A09095D0A097D2C0A097B0A09096E616D653A2022537461';
wwv_flow_imp.g_varchar2_table(5903) := '72744576656E74222C0A09097375706572436C6173733A205B0A0909092243617463684576656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226973496E74657272757074696E67222C0A09090909';
wwv_flow_imp.g_varchar2_table(5904) := '2264656661756C74223A20747275652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225468726F774576656E74222C0A09096973416273';
wwv_flow_imp.g_varchar2_table(5905) := '74726163743A20747275652C0A09097375706572436C6173733A205B0A090909224576656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202264617461496E70757473222C0A09090909747970653A20';
wwv_flow_imp.g_varchar2_table(5906) := '2244617461496E707574222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A202264617461496E7075744173736F63696174696F6E73222C0A09090909747970653A202244617461496E7075744173736F';
wwv_flow_imp.g_varchar2_table(5907) := '63696174696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022696E707574536574222C0A09090909747970653A2022496E707574536574220A0909097D2C0A0909097B0A090909096E616D65';
wwv_flow_imp.g_varchar2_table(5908) := '3A20226576656E74446566696E6974696F6E73222C0A09090909747970653A20224576656E74446566696E6974696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226576656E74446566696E';
wwv_flow_imp.g_varchar2_table(5909) := '6974696F6E526566222C0A09090909747970653A20224576656E74446566696E6974696F6E222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E61';
wwv_flow_imp.g_varchar2_table(5910) := '6D653A202243617463684576656E74222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A205B0A090909224576656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A';
wwv_flow_imp.g_varchar2_table(5911) := '2022706172616C6C656C4D756C7469706C65222C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E222C0A090909092264656661756C74223A2066616C73650A0909097D2C0A0909097B0A090909096E616D65';
wwv_flow_imp.g_varchar2_table(5912) := '3A2022646174614F757470757473222C0A09090909747970653A2022446174614F7574707574222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022646174614F75747075744173736F63696174696F';
wwv_flow_imp.g_varchar2_table(5913) := '6E73222C0A09090909747970653A2022446174614F75747075744173736F63696174696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F7574707574536574222C0A09090909747970653A';
wwv_flow_imp.g_varchar2_table(5914) := '20224F7574707574536574220A0909097D2C0A0909097B0A090909096E616D653A20226576656E74446566696E6974696F6E73222C0A09090909747970653A20224576656E74446566696E6974696F6E222C0A0909090969734D616E793A20747275650A';
wwv_flow_imp.g_varchar2_table(5915) := '0909097D2C0A0909097B0A090909096E616D653A20226576656E74446566696E6974696F6E526566222C0A09090909747970653A20224576656E74446566696E6974696F6E222C0A0909090969734D616E793A20747275652C0A09090909697352656665';
wwv_flow_imp.g_varchar2_table(5916) := '72656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022426F756E646172794576656E74222C0A09097375706572436C6173733A205B0A0909092243617463684576656E74220A09095D2C0A090970726F7065727469';
wwv_flow_imp.g_varchar2_table(5917) := '65733A205B0A0909097B0A090909096E616D653A202263616E63656C4163746976697479222C0A090909092264656661756C74223A20747275652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909';
wwv_flow_imp.g_varchar2_table(5918) := '097D2C0A0909097B0A090909096E616D653A20226174746163686564546F526566222C0A09090909747970653A20224163746976697479222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909';
wwv_flow_imp.g_varchar2_table(5919) := '097D0A09095D0A097D2C0A097B0A09096E616D653A20224576656E74446566696E6974696F6E222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A205B0A09090922526F6F74456C656D656E74220A09095D0A097D';
wwv_flow_imp.g_varchar2_table(5920) := '2C0A097B0A09096E616D653A202243616E63656C4576656E74446566696E6974696F6E222C0A09097375706572436C6173733A205B0A090909224576656E74446566696E6974696F6E220A09095D0A097D2C0A097B0A09096E616D653A20224572726F72';
wwv_flow_imp.g_varchar2_table(5921) := '4576656E74446566696E6974696F6E222C0A09097375706572436C6173733A205B0A090909224576656E74446566696E6974696F6E220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226572726F72526566';
wwv_flow_imp.g_varchar2_table(5922) := '222C0A09090909747970653A20224572726F72222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225465726D696E6174654576656E';
wwv_flow_imp.g_varchar2_table(5923) := '74446566696E6974696F6E222C0A09097375706572436C6173733A205B0A090909224576656E74446566696E6974696F6E220A09095D0A097D2C0A097B0A09096E616D653A2022457363616C6174696F6E4576656E74446566696E6974696F6E222C0A09';
wwv_flow_imp.g_varchar2_table(5924) := '097375706572436C6173733A205B0A090909224576656E74446566696E6974696F6E220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022657363616C6174696F6E526566222C0A09090909747970653A2022';
wwv_flow_imp.g_varchar2_table(5925) := '457363616C6174696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022457363616C6174696F6E222C0A090970726F70657274';
wwv_flow_imp.g_varchar2_table(5926) := '6965733A205B0A0909097B0A090909096E616D653A2022737472756374757265526566222C0A09090909747970653A20224974656D446566696E6974696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A';
wwv_flow_imp.g_varchar2_table(5927) := '20747275650A0909097D2C0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022657363616C61';
wwv_flow_imp.g_varchar2_table(5928) := '74696F6E436F6465222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D2C0A09097375706572436C6173733A205B0A09090922526F6F74456C656D656E74220A09095D0A097D2C0A09';
wwv_flow_imp.g_varchar2_table(5929) := '7B0A09096E616D653A2022436F6D70656E736174654576656E74446566696E6974696F6E222C0A09097375706572436C6173733A205B0A090909224576656E74446566696E6974696F6E220A09095D2C0A090970726F706572746965733A205B0A090909';
wwv_flow_imp.g_varchar2_table(5930) := '7B0A090909096E616D653A202277616974466F72436F6D706C6574696F6E222C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E222C0A090909092264656661756C74223A20747275650A0909097D2C0A0909';
wwv_flow_imp.g_varchar2_table(5931) := '097B0A090909096E616D653A20226163746976697479526566222C0A09090909747970653A20224163746976697479222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A09';
wwv_flow_imp.g_varchar2_table(5932) := '7D2C0A097B0A09096E616D653A202254696D65724576656E74446566696E6974696F6E222C0A09097375706572436C6173733A205B0A090909224576656E74446566696E6974696F6E220A09095D2C0A090970726F706572746965733A205B0A0909097B';
wwv_flow_imp.g_varchar2_table(5933) := '0A090909096E616D653A202274696D6544617465222C0A09090909747970653A202245787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909097D2C0A090909';
wwv_flow_imp.g_varchar2_table(5934) := '7B0A090909096E616D653A202274696D654379636C65222C0A09090909747970653A202245787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909097D2C0A09';
wwv_flow_imp.g_varchar2_table(5935) := '09097B0A090909096E616D653A202274696D654475726174696F6E222C0A09090909747970653A202245787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909';
wwv_flow_imp.g_varchar2_table(5936) := '097D0A09095D0A097D2C0A097B0A09096E616D653A20224C696E6B4576656E74446566696E6974696F6E222C0A09097375706572436C6173733A205B0A090909224576656E74446566696E6974696F6E220A09095D2C0A090970726F706572746965733A';
wwv_flow_imp.g_varchar2_table(5937) := '205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022746172676574222C0A090909097479';
wwv_flow_imp.g_varchar2_table(5938) := '70653A20224C696E6B4576656E74446566696E6974696F6E222C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022736F75726365222C0A09090909747970653A20224C696E6B4576656E74';
wwv_flow_imp.g_varchar2_table(5939) := '446566696E6974696F6E222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224D6573736167654576656E74446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(5940) := '222C0A09097375706572436C6173733A205B0A090909224576656E74446566696E6974696F6E220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226D657373616765526566222C0A09090909747970653A20';
wwv_flow_imp.g_varchar2_table(5941) := '224D657373616765222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F7065726174696F6E526566222C0A09090909747970653A20224F';
wwv_flow_imp.g_varchar2_table(5942) := '7065726174696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022436F6E646974696F6E616C4576656E74446566696E697469';
wwv_flow_imp.g_varchar2_table(5943) := '6F6E222C0A09097375706572436C6173733A205B0A090909224576656E74446566696E6974696F6E220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022636F6E646974696F6E222C0A09090909747970653A';
wwv_flow_imp.g_varchar2_table(5944) := '202245787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225369676E616C4576656E74446566696E';
wwv_flow_imp.g_varchar2_table(5945) := '6974696F6E222C0A09097375706572436C6173733A205B0A090909224576656E74446566696E6974696F6E220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20227369676E616C526566222C0A090909097479';
wwv_flow_imp.g_varchar2_table(5946) := '70653A20225369676E616C222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225369676E616C222C0A09097375706572436C617373';
wwv_flow_imp.g_varchar2_table(5947) := '3A205B0A09090922526F6F74456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022737472756374757265526566222C0A09090909747970653A20224974656D446566696E6974696F6E222C';
wwv_flow_imp.g_varchar2_table(5948) := '0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A202253';
wwv_flow_imp.g_varchar2_table(5949) := '7472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022496D706C696369745468726F774576656E74222C0A09097375706572436C6173733A205B0A090909225468726F774576656E74220A09095D0A097D2C0A097B0A09096E61';
wwv_flow_imp.g_varchar2_table(5950) := '6D653A2022446174615374617465222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973';
wwv_flow_imp.g_varchar2_table(5951) := '417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224974656D4177617265456C656D656E74222C0A09097375706572436C6173733A205B0A090909224261736545';
wwv_flow_imp.g_varchar2_table(5952) := '6C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226974656D5375626A656374526566222C0A09090909747970653A20224974656D446566696E6974696F6E222C0A09090909697341747472';
wwv_flow_imp.g_varchar2_table(5953) := '3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022646174615374617465222C0A09090909747970653A2022446174615374617465220A0909097D0A09095D0A097D2C0A09';
wwv_flow_imp.g_varchar2_table(5954) := '7B0A09096E616D653A2022446174614173736F63696174696F6E222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202273';
wwv_flow_imp.g_varchar2_table(5955) := '6F75726365526566222C0A09090909747970653A20224974656D4177617265456C656D656E74222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D65';
wwv_flow_imp.g_varchar2_table(5956) := '3A2022746172676574526566222C0A09090909747970653A20224974656D4177617265456C656D656E74222C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20227472616E73666F726D6174';
wwv_flow_imp.g_varchar2_table(5957) := '696F6E222C0A09090909747970653A2022466F726D616C45787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A202270726F7065727479220A090909097D0A0909097D2C0A0909097B0A090909096E616D653A';
wwv_flow_imp.g_varchar2_table(5958) := '202261737369676E6D656E74222C0A09090909747970653A202241737369676E6D656E74222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202244617461496E707574222C0A09097375706572';
wwv_flow_imp.g_varchar2_table(5959) := '436C6173733A205B0A090909224974656D4177617265456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970';
wwv_flow_imp.g_varchar2_table(5960) := '653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20226973436F6C6C656374696F6E222C0A090909092264656661756C74223A2066616C73652C0A090909096973417474723A20747275652C0A09090909747970653A2022';
wwv_flow_imp.g_varchar2_table(5961) := '426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A2022696E707574536574526566222C0A09090909747970653A2022496E707574536574222C0A0909090969734D616E793A20747275652C0A0909090969735669727475616C3A20';
wwv_flow_imp.g_varchar2_table(5962) := '747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022696E707574536574576974684F7074696F6E616C222C0A09090909747970653A2022496E707574536574222C0A0909090969';
wwv_flow_imp.g_varchar2_table(5963) := '734D616E793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022696E707574536574576974685768696C654578656375';
wwv_flow_imp.g_varchar2_table(5964) := '74696E67222C0A09090909747970653A2022496E707574536574222C0A0909090969734D616E793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A09';
wwv_flow_imp.g_varchar2_table(5965) := '7D2C0A097B0A09096E616D653A2022446174614F7574707574222C0A09097375706572436C6173733A205B0A090909224974656D4177617265456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D65';
wwv_flow_imp.g_varchar2_table(5966) := '3A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20226973436F6C6C656374696F6E222C0A090909092264656661756C74223A2066';
wwv_flow_imp.g_varchar2_table(5967) := '616C73652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A20226F7574707574536574526566222C0A09090909747970653A20224F75747075745365';
wwv_flow_imp.g_varchar2_table(5968) := '74222C0A0909090969734D616E793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F757470757453657457697468';
wwv_flow_imp.g_varchar2_table(5969) := '4F7074696F6E616C222C0A09090909747970653A20224F7574707574536574222C0A0909090969734D616E793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C';
wwv_flow_imp.g_varchar2_table(5970) := '0A0909097B0A090909096E616D653A20226F7574707574536574576974685768696C65457865637574696E67222C0A09090909747970653A20224F7574707574536574222C0A0909090969734D616E793A20747275652C0A090909096973566972747561';
wwv_flow_imp.g_varchar2_table(5971) := '6C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022496E707574536574222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A';
wwv_flow_imp.g_varchar2_table(5972) := '09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D65';
wwv_flow_imp.g_varchar2_table(5973) := '3A202264617461496E70757452656673222C0A09090909747970653A202244617461496E707574222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D';
wwv_flow_imp.g_varchar2_table(5974) := '653A20226F7074696F6E616C496E70757452656673222C0A09090909747970653A202244617461496E707574222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A0909';
wwv_flow_imp.g_varchar2_table(5975) := '09096E616D653A20227768696C65457865637574696E67496E70757452656673222C0A09090909747970653A202244617461496E707574222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909';
wwv_flow_imp.g_varchar2_table(5976) := '097D2C0A0909097B0A090909096E616D653A20226F757470757453657452656673222C0A09090909747970653A20224F7574707574536574222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A09';
wwv_flow_imp.g_varchar2_table(5977) := '09097D0A09095D0A097D2C0A097B0A09096E616D653A20224F7574707574536574222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E';
wwv_flow_imp.g_varchar2_table(5978) := '616D653A2022646174614F757470757452656673222C0A09090909747970653A2022446174614F7574707574222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A0909';
wwv_flow_imp.g_varchar2_table(5979) := '09096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022696E70757453657452656673222C0A09090909747970653A20';
wwv_flow_imp.g_varchar2_table(5980) := '22496E707574536574222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F7074696F6E616C4F757470757452656673222C0A0909090974';
wwv_flow_imp.g_varchar2_table(5981) := '7970653A2022446174614F7574707574222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20227768696C65457865637574696E674F75747075';
wwv_flow_imp.g_varchar2_table(5982) := '7452656673222C0A09090909747970653A2022446174614F7574707574222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202250726F';
wwv_flow_imp.g_varchar2_table(5983) := '7065727479222C0A09097375706572436C6173733A205B0A090909224974656D4177617265456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A09090909697341747472';
wwv_flow_imp.g_varchar2_table(5984) := '3A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202244617461496E7075744173736F63696174696F6E222C0A09097375706572436C6173733A205B0A090909224461746141';
wwv_flow_imp.g_varchar2_table(5985) := '73736F63696174696F6E220A09095D0A097D2C0A097B0A09096E616D653A2022446174614F75747075744173736F63696174696F6E222C0A09097375706572436C6173733A205B0A09090922446174614173736F63696174696F6E220A09095D0A097D2C';
wwv_flow_imp.g_varchar2_table(5986) := '0A097B0A09096E616D653A2022496E7075744F757470757453706563696669636174696F6E222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A09';
wwv_flow_imp.g_varchar2_table(5987) := '0909096E616D653A202264617461496E70757473222C0A09090909747970653A202244617461496E707574222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022646174614F757470757473222C0A09';
wwv_flow_imp.g_varchar2_table(5988) := '090909747970653A2022446174614F7574707574222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022696E70757453657473222C0A09090909747970653A2022496E707574536574222C0A09090909';
wwv_flow_imp.g_varchar2_table(5989) := '69734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F757470757453657473222C0A09090909747970653A20224F7574707574536574222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C';
wwv_flow_imp.g_varchar2_table(5990) := '0A097B0A09096E616D653A2022446174614F626A656374222C0A09097375706572436C6173733A205B0A09090922466C6F77456C656D656E74222C0A090909224974656D4177617265456C656D656E74220A09095D2C0A090970726F706572746965733A';
wwv_flow_imp.g_varchar2_table(5991) := '205B0A0909097B0A090909096E616D653A20226973436F6C6C656374696F6E222C0A090909092264656661756C74223A2066616C73652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D0A09';
wwv_flow_imp.g_varchar2_table(5992) := '095D0A097D2C0A097B0A09096E616D653A2022496E7075744F757470757442696E64696E67222C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696E70757444617461526566222C0A09090909747970653A2022496E';
wwv_flow_imp.g_varchar2_table(5993) := '707574536574222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F757470757444617461526566222C0A09090909747970653A20224F75';
wwv_flow_imp.g_varchar2_table(5994) := '74707574536574222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F7065726174696F6E526566222C0A09090909747970653A20224F70';
wwv_flow_imp.g_varchar2_table(5995) := '65726174696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202241737369676E6D656E74222C0A09097375706572436C617373';
wwv_flow_imp.g_varchar2_table(5996) := '3A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202266726F6D222C0A09090909747970653A202245787072657373696F6E222C0A09090909786D6C3A207B0A';
wwv_flow_imp.g_varchar2_table(5997) := '090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909097D2C0A0909097B0A090909096E616D653A2022746F222C0A09090909747970653A202245787072657373696F6E222C0A09090909786D6C3A207B0A0909090909';
wwv_flow_imp.g_varchar2_table(5998) := '73657269616C697A653A20227873693A74797065220A090909097D0A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224461746153746F7265222C0A09097375706572436C6173733A205B0A09090922526F6F74456C656D656E74222C0A09';
wwv_flow_imp.g_varchar2_table(5999) := '0909224974656D4177617265456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67';
wwv_flow_imp.g_varchar2_table(6000) := '220A0909097D2C0A0909097B0A090909096E616D653A20226361706163697479222C0A090909096973417474723A20747275652C0A09090909747970653A2022496E7465676572220A0909097D2C0A0909097B0A090909096E616D653A20226973556E6C';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(6001) := '696D69746564222C0A090909092264656661756C74223A20747275652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224461746153746F';
wwv_flow_imp.g_varchar2_table(6002) := '72655265666572656E6365222C0A09097375706572436C6173733A205B0A090909224974656D4177617265456C656D656E74222C0A09090922466C6F77456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A09090909';
wwv_flow_imp.g_varchar2_table(6003) := '6E616D653A20226461746153746F7265526566222C0A09090909747970653A20224461746153746F7265222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B';
wwv_flow_imp.g_varchar2_table(6004) := '0A09096E616D653A2022446174614F626A6563745265666572656E6365222C0A09097375706572436C6173733A205B0A090909224974656D4177617265456C656D656E74222C0A09090922466C6F77456C656D656E74220A09095D2C0A090970726F7065';
wwv_flow_imp.g_varchar2_table(6005) := '72746965733A205B0A0909097B0A090909096E616D653A2022646174614F626A656374526566222C0A09090909747970653A2022446174614F626A656374222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20';
wwv_flow_imp.g_varchar2_table(6006) := '747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022436F6E766572736174696F6E4C696E6B222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A';
wwv_flow_imp.g_varchar2_table(6007) := '205B0A0909097B0A090909096E616D653A2022736F75726365526566222C0A09090909747970653A2022496E746572616374696F6E4E6F6465222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A';
wwv_flow_imp.g_varchar2_table(6008) := '0909097D2C0A0909097B0A090909096E616D653A2022746172676574526566222C0A09090909747970653A2022496E746572616374696F6E4E6F6465222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A207472';
wwv_flow_imp.g_varchar2_table(6009) := '75650A0909097D2C0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022436F6E766572';
wwv_flow_imp.g_varchar2_table(6010) := '736174696F6E4173736F63696174696F6E222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696E6E6572436F6E7665';
wwv_flow_imp.g_varchar2_table(6011) := '72736174696F6E4E6F6465526566222C0A09090909747970653A2022436F6E766572736174696F6E4E6F6465222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A0909';
wwv_flow_imp.g_varchar2_table(6012) := '09096E616D653A20226F75746572436F6E766572736174696F6E4E6F6465526566222C0A09090909747970653A2022436F6E766572736174696F6E4E6F6465222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A';
wwv_flow_imp.g_varchar2_table(6013) := '20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202243616C6C436F6E766572736174696F6E222C0A09097375706572436C6173733A205B0A09090922436F6E766572736174696F6E4E6F6465220A09095D2C0A090970726F7065';
wwv_flow_imp.g_varchar2_table(6014) := '72746965733A205B0A0909097B0A090909096E616D653A202263616C6C6564436F6C6C61626F726174696F6E526566222C0A09090909747970653A2022436F6C6C61626F726174696F6E222C0A090909096973417474723A20747275652C0A0909090969';
wwv_flow_imp.g_varchar2_table(6015) := '735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20227061727469636970616E744173736F63696174696F6E73222C0A09090909747970653A20225061727469636970616E744173736F63696174696F6E222C';
wwv_flow_imp.g_varchar2_table(6016) := '0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022436F6E766572736174696F6E222C0A09097375706572436C6173733A205B0A09090922436F6E766572736174696F6E4E6F6465220A09095D0A';
wwv_flow_imp.g_varchar2_table(6017) := '097D2C0A097B0A09096E616D653A2022537562436F6E766572736174696F6E222C0A09097375706572436C6173733A205B0A09090922436F6E766572736174696F6E4E6F6465220A09095D2C0A090970726F706572746965733A205B0A0909097B0A0909';
wwv_flow_imp.g_varchar2_table(6018) := '09096E616D653A2022636F6E766572736174696F6E4E6F646573222C0A09090909747970653A2022436F6E766572736174696F6E4E6F6465222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20';
wwv_flow_imp.g_varchar2_table(6019) := '22436F6E766572736174696F6E4E6F6465222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A205B0A09090922496E746572616374696F6E4E6F6465222C0A0909092242617365456C656D656E74220A09095D2C0A';
wwv_flow_imp.g_varchar2_table(6020) := '090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20227061';
wwv_flow_imp.g_varchar2_table(6021) := '727469636970616E74526566222C0A09090909747970653A20225061727469636970616E74222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A';
wwv_flow_imp.g_varchar2_table(6022) := '20226D657373616765466C6F7752656673222C0A09090909747970653A20224D657373616765466C6F77222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A09090909';
wwv_flow_imp.g_varchar2_table(6023) := '6E616D653A2022636F7272656C6174696F6E4B657973222C0A09090909747970653A2022436F7272656C6174696F6E4B6579222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022476C6F6261';
wwv_flow_imp.g_varchar2_table(6024) := '6C436F6E766572736174696F6E222C0A09097375706572436C6173733A205B0A09090922436F6C6C61626F726174696F6E220A09095D0A097D2C0A097B0A09096E616D653A2022506172746E6572456E74697479222C0A09097375706572436C6173733A';
wwv_flow_imp.g_varchar2_table(6025) := '205B0A09090922526F6F74456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E6722';
wwv_flow_imp.g_varchar2_table(6026) := '0A0909097D2C0A0909097B0A090909096E616D653A20227061727469636970616E74526566222C0A09090909747970653A20225061727469636970616E74222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20';
wwv_flow_imp.g_varchar2_table(6027) := '747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022506172746E6572526F6C65222C0A09097375706572436C6173733A205B0A09090922526F6F74456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909';
wwv_flow_imp.g_varchar2_table(6028) := '097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20227061727469636970616E74526566222C0A090909';
wwv_flow_imp.g_varchar2_table(6029) := '09747970653A20225061727469636970616E74222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022436F7272656C6174696F6E5072';
wwv_flow_imp.g_varchar2_table(6030) := '6F7065727479222C0A09097375706572436C6173733A205B0A09090922526F6F74456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022636F7272656C6174696F6E50726F70657274795265';
wwv_flow_imp.g_varchar2_table(6031) := '7472696576616C45787072657373696F6E222C0A09090909747970653A2022436F7272656C6174696F6E50726F706572747952657472696576616C45787072657373696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A';
wwv_flow_imp.g_varchar2_table(6032) := '090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A202274797065222C0A09090909747970653A20224974656D44';
wwv_flow_imp.g_varchar2_table(6033) := '6566696E6974696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224572726F72222C0A09097375706572436C6173733A205B';
wwv_flow_imp.g_varchar2_table(6034) := '0A09090922526F6F74456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022737472756374757265526566222C0A09090909747970653A20224974656D446566696E6974696F6E222C0A0909';
wwv_flow_imp.g_varchar2_table(6035) := '09096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A202253747269';
wwv_flow_imp.g_varchar2_table(6036) := '6E67220A0909097D2C0A0909097B0A090909096E616D653A20226572726F72436F6465222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022';
wwv_flow_imp.g_varchar2_table(6037) := '436F7272656C6174696F6E4B6579222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022636F7272656C6174696F6E5072';
wwv_flow_imp.g_varchar2_table(6038) := '6F7065727479526566222C0A09090909747970653A2022436F7272656C6174696F6E50726F7065727479222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A09090909';
wwv_flow_imp.g_varchar2_table(6039) := '6E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202245787072657373696F6E222C0A09097375706572436C6173';
wwv_flow_imp.g_varchar2_table(6040) := '733A205B0A0909092242617365456C656D656E74220A09095D2C0A0909697341627374726163743A2066616C73652C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022626F6479222C0A090909096973426F64793A2074';
wwv_flow_imp.g_varchar2_table(6041) := '7275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022466F726D616C45787072657373696F6E222C0A09097375706572436C6173733A205B0A0909092245787072657373696F6E220A';
wwv_flow_imp.g_varchar2_table(6042) := '09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226C616E6775616765222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A09090909';
wwv_flow_imp.g_varchar2_table(6043) := '6E616D653A20226576616C7561746573546F54797065526566222C0A09090909747970653A20224974656D446566696E6974696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D';
wwv_flow_imp.g_varchar2_table(6044) := '0A09095D0A097D2C0A097B0A09096E616D653A20224D657373616765222C0A09097375706572436C6173733A205B0A09090922526F6F74456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20';
wwv_flow_imp.g_varchar2_table(6045) := '226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20226974656D526566222C0A09090909747970653A20224974656D446566696E697469';
wwv_flow_imp.g_varchar2_table(6046) := '6F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224974656D446566696E6974696F6E222C0A09097375706572436C6173733A';
wwv_flow_imp.g_varchar2_table(6047) := '205B0A09090922526F6F74456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226974656D4B696E64222C0A09090909747970653A20224974656D4B696E64222C0A09090909697341747472';
wwv_flow_imp.g_varchar2_table(6048) := '3A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022737472756374757265526566222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D65';
wwv_flow_imp.g_varchar2_table(6049) := '3A20226973436F6C6C656374696F6E222C0A090909092264656661756C74223A2066616C73652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A2022';
wwv_flow_imp.g_varchar2_table(6050) := '696D706F7274222C0A09090909747970653A2022496D706F7274222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022466C6F77456C';
wwv_flow_imp.g_varchar2_table(6051) := '656D656E74222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E61';
wwv_flow_imp.g_varchar2_table(6052) := '6D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20226175646974696E67222C0A09090909747970653A20224175646974696E67220A0909097D';
wwv_flow_imp.g_varchar2_table(6053) := '2C0A0909097B0A090909096E616D653A20226D6F6E69746F72696E67222C0A09090909747970653A20224D6F6E69746F72696E67220A0909097D2C0A0909097B0A090909096E616D653A202263617465676F727956616C7565526566222C0A0909090974';
wwv_flow_imp.g_varchar2_table(6054) := '7970653A202243617465676F727956616C7565222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202253657175656E6365466C6F7722';
wwv_flow_imp.g_varchar2_table(6055) := '2C0A09097375706572436C6173733A205B0A09090922466C6F77456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226973496D6D656469617465222C0A090909096973417474723A207472';
wwv_flow_imp.g_varchar2_table(6056) := '75652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A2022636F6E646974696F6E45787072657373696F6E222C0A09090909747970653A202245787072657373696F6E222C0A09090909786D6C3A';
wwv_flow_imp.g_varchar2_table(6057) := '207B0A090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909097D2C0A0909097B0A090909096E616D653A2022736F75726365526566222C0A09090909747970653A2022466C6F774E6F6465222C0A0909090969734174';
wwv_flow_imp.g_varchar2_table(6058) := '74723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022746172676574526566222C0A09090909747970653A2022466C6F774E6F6465222C0A090909096973417474723A20';
wwv_flow_imp.g_varchar2_table(6059) := '747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022466C6F77456C656D656E7473436F6E7461696E6572222C0A0909697341627374726163743A20747275652C0A090973';
wwv_flow_imp.g_varchar2_table(6060) := '75706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226C616E6553657473222C0A09090909747970653A20224C616E65536574222C0A09';
wwv_flow_imp.g_varchar2_table(6061) := '09090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022666C6F77456C656D656E7473222C0A09090909747970653A2022466C6F77456C656D656E74222C0A0909090969734D616E793A20747275650A0909097D0A';
wwv_flow_imp.g_varchar2_table(6062) := '09095D0A097D2C0A097B0A09096E616D653A202243616C6C61626C65456C656D656E74222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A205B0A09090922526F6F74456C656D656E74220A09095D2C0A09097072';
wwv_flow_imp.g_varchar2_table(6063) := '6F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022696F53706563';
wwv_flow_imp.g_varchar2_table(6064) := '696669636174696F6E222C0A09090909747970653A2022496E7075744F757470757453706563696669636174696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A202270726F7065727479220A090909097D0A0909097D2C0A';
wwv_flow_imp.g_varchar2_table(6065) := '0909097B0A090909096E616D653A2022737570706F72746564496E74657266616365526566222C0A09090909747970653A2022496E74657266616365222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A207472';
wwv_flow_imp.g_varchar2_table(6066) := '75650A0909097D2C0A0909097B0A090909096E616D653A2022696F42696E64696E67222C0A09090909747970653A2022496E7075744F757470757442696E64696E67222C0A0909090969734D616E793A20747275652C0A09090909786D6C3A207B0A0909';
wwv_flow_imp.g_varchar2_table(6067) := '09090973657269616C697A653A202270726F7065727479220A090909097D0A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022466C6F774E6F6465222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A';
wwv_flow_imp.g_varchar2_table(6068) := '205B0A09090922466C6F77456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696E636F6D696E67222C0A09090909747970653A202253657175656E6365466C6F77222C0A090909096973';
wwv_flow_imp.g_varchar2_table(6069) := '4D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F7574676F696E67222C0A09090909747970653A202253657175656E6365466C6F77222C0A0909090969734D';
wwv_flow_imp.g_varchar2_table(6070) := '616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226C616E6573222C0A09090909747970653A20224C616E65222C0A0909090969734D616E793A20747275652C0A09';
wwv_flow_imp.g_varchar2_table(6071) := '09090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022436F7272656C6174696F6E50726F706572747952657472696576616C4578707265';
wwv_flow_imp.g_varchar2_table(6072) := '7373696F6E222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226D65737361676550617468222C0A0909090974797065';
wwv_flow_imp.g_varchar2_table(6073) := '3A2022466F726D616C45787072657373696F6E220A0909097D2C0A0909097B0A090909096E616D653A20226D657373616765526566222C0A09090909747970653A20224D657373616765222C0A090909096973417474723A20747275652C0A0909090969';
wwv_flow_imp.g_varchar2_table(6074) := '735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022436F7272656C6174696F6E50726F706572747942696E64696E67222C0A09097375706572436C6173733A205B0A0909092242617365456C656D65';
wwv_flow_imp.g_varchar2_table(6075) := '6E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226461746150617468222C0A09090909747970653A2022466F726D616C45787072657373696F6E220A0909097D2C0A0909097B0A090909096E616D65';
wwv_flow_imp.g_varchar2_table(6076) := '3A2022636F7272656C6174696F6E50726F7065727479526566222C0A09090909747970653A2022436F7272656C6174696F6E50726F7065727479222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A2074727565';
wwv_flow_imp.g_varchar2_table(6077) := '0A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225265736F75726365222C0A09097375706572436C6173733A205B0A09090922526F6F74456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A09090909';
wwv_flow_imp.g_varchar2_table(6078) := '6E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20227265736F75726365506172616D6574657273222C0A090909097479';
wwv_flow_imp.g_varchar2_table(6079) := '70653A20225265736F75726365506172616D65746572222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225265736F75726365506172616D65746572222C0A09097375706572436C6173733A';
wwv_flow_imp.g_varchar2_table(6080) := '205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E6722';
wwv_flow_imp.g_varchar2_table(6081) := '0A0909097D2C0A0909097B0A090909096E616D653A202269735265717569726564222C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A202274797065';
wwv_flow_imp.g_varchar2_table(6082) := '222C0A09090909747970653A20224974656D446566696E6974696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022436F7272';
wwv_flow_imp.g_varchar2_table(6083) := '656C6174696F6E537562736372697074696F6E222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022636F7272656C6174';
wwv_flow_imp.g_varchar2_table(6084) := '696F6E4B6579526566222C0A09090909747970653A2022436F7272656C6174696F6E4B6579222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A';
wwv_flow_imp.g_varchar2_table(6085) := '2022636F7272656C6174696F6E50726F706572747942696E64696E67222C0A09090909747970653A2022436F7272656C6174696F6E50726F706572747942696E64696E67222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C';
wwv_flow_imp.g_varchar2_table(6086) := '0A097B0A09096E616D653A20224D657373616765466C6F77222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D';
wwv_flow_imp.g_varchar2_table(6087) := '65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022736F75726365526566222C0A09090909747970653A2022496E746572616374696F6E4E6F64';
wwv_flow_imp.g_varchar2_table(6088) := '65222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022746172676574526566222C0A09090909747970653A2022496E746572616374696F6E';
wwv_flow_imp.g_varchar2_table(6089) := '4E6F6465222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226D657373616765526566222C0A09090909747970653A20224D657373616765';
wwv_flow_imp.g_varchar2_table(6090) := '222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224D657373616765466C6F774173736F63696174696F6E222C0A09097375706572';
wwv_flow_imp.g_varchar2_table(6091) := '436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696E6E65724D657373616765466C6F77526566222C0A09090909747970653A20224D657373';
wwv_flow_imp.g_varchar2_table(6092) := '616765466C6F77222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F757465724D657373616765466C6F77526566222C0A090909097479';
wwv_flow_imp.g_varchar2_table(6093) := '70653A20224D657373616765466C6F77222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022496E746572616374696F6E4E6F646522';
wwv_flow_imp.g_varchar2_table(6094) := '2C0A0909697341627374726163743A20747275652C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696E636F6D696E67436F6E766572736174696F6E4C696E6B73222C0A09090909747970653A2022436F6E76657273';
wwv_flow_imp.g_varchar2_table(6095) := '6174696F6E4C696E6B222C0A0909090969734D616E793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F7574676F';
wwv_flow_imp.g_varchar2_table(6096) := '696E67436F6E766572736174696F6E4C696E6B73222C0A09090909747970653A2022436F6E766572736174696F6E4C696E6B222C0A0909090969734D616E793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265';
wwv_flow_imp.g_varchar2_table(6097) := '666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225061727469636970616E74222C0A09097375706572436C6173733A205B0A09090922496E746572616374696F6E4E6F6465222C0A090909224261736545';
wwv_flow_imp.g_varchar2_table(6098) := '6C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A';
wwv_flow_imp.g_varchar2_table(6099) := '090909096E616D653A2022696E74657266616365526566222C0A09090909747970653A2022496E74657266616365222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A';
wwv_flow_imp.g_varchar2_table(6100) := '090909096E616D653A20227061727469636970616E744D756C7469706C6963697479222C0A09090909747970653A20225061727469636970616E744D756C7469706C6963697479220A0909097D2C0A0909097B0A090909096E616D653A2022656E64506F';
wwv_flow_imp.g_varchar2_table(6101) := '696E7452656673222C0A09090909747970653A2022456E64506F696E74222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A202270726F636573';
wwv_flow_imp.g_varchar2_table(6102) := '73526566222C0A09090909747970653A202250726F63657373222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202250617274696369';
wwv_flow_imp.g_varchar2_table(6103) := '70616E744173736F63696174696F6E222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696E6E657250617274696369';
wwv_flow_imp.g_varchar2_table(6104) := '70616E74526566222C0A09090909747970653A20225061727469636970616E74222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F7574';
wwv_flow_imp.g_varchar2_table(6105) := '65725061727469636970616E74526566222C0A09090909747970653A20225061727469636970616E74222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A';
wwv_flow_imp.g_varchar2_table(6106) := '09096E616D653A20225061727469636970616E744D756C7469706C6963697479222C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226D696E696D756D222C0A090909092264656661756C74223A20302C0A0909090969';
wwv_flow_imp.g_varchar2_table(6107) := '73417474723A20747275652C0A09090909747970653A2022496E7465676572220A0909097D2C0A0909097B0A090909096E616D653A20226D6178696D756D222C0A090909092264656661756C74223A20312C0A090909096973417474723A20747275652C';
wwv_flow_imp.g_varchar2_table(6108) := '0A09090909747970653A2022496E7465676572220A0909097D0A09095D2C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D0A097D2C0A097B0A09096E616D653A2022436F6C6C61626F726174696F6E222C0A';
wwv_flow_imp.g_varchar2_table(6109) := '09097375706572436C6173733A205B0A09090922526F6F74456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A0909090974';
wwv_flow_imp.g_varchar2_table(6110) := '7970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20226973436C6F736564222C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A09090909';
wwv_flow_imp.g_varchar2_table(6111) := '6E616D653A20227061727469636970616E7473222C0A09090909747970653A20225061727469636970616E74222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226D657373616765466C6F7773222C';
wwv_flow_imp.g_varchar2_table(6112) := '0A09090909747970653A20224D657373616765466C6F77222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022617274696661637473222C0A09090909747970653A20224172746966616374222C0A09';
wwv_flow_imp.g_varchar2_table(6113) := '09090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022636F6E766572736174696F6E73222C0A09090909747970653A2022436F6E766572736174696F6E4E6F6465222C0A0909090969734D616E793A2074727565';
wwv_flow_imp.g_varchar2_table(6114) := '0A0909097D2C0A0909097B0A090909096E616D653A2022636F6E766572736174696F6E4173736F63696174696F6E73222C0A09090909747970653A2022436F6E766572736174696F6E4173736F63696174696F6E220A0909097D2C0A0909097B0A090909';
wwv_flow_imp.g_varchar2_table(6115) := '096E616D653A20227061727469636970616E744173736F63696174696F6E73222C0A09090909747970653A20225061727469636970616E744173736F63696174696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A0909';
wwv_flow_imp.g_varchar2_table(6116) := '09096E616D653A20226D657373616765466C6F774173736F63696174696F6E73222C0A09090909747970653A20224D657373616765466C6F774173736F63696174696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A09';
wwv_flow_imp.g_varchar2_table(6117) := '0909096E616D653A2022636F7272656C6174696F6E4B657973222C0A09090909747970653A2022436F7272656C6174696F6E4B6579222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A202263686F7265';
wwv_flow_imp.g_varchar2_table(6118) := '6F677261706879526566222C0A09090909747970653A202243686F72656F677261706879222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20';
wwv_flow_imp.g_varchar2_table(6119) := '22636F6E766572736174696F6E4C696E6B73222C0A09090909747970653A2022436F6E766572736174696F6E4C696E6B222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202243686F72656F67';
wwv_flow_imp.g_varchar2_table(6120) := '72617068794163746976697479222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A205B0A09090922466C6F774E6F6465220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D65';
wwv_flow_imp.g_varchar2_table(6121) := '3A20227061727469636970616E74526566222C0A09090909747970653A20225061727469636970616E74222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A09090909';
wwv_flow_imp.g_varchar2_table(6122) := '6E616D653A2022696E6974696174696E675061727469636970616E74526566222C0A09090909747970653A20225061727469636970616E74222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A09';
wwv_flow_imp.g_varchar2_table(6123) := '09097D2C0A0909097B0A090909096E616D653A2022636F7272656C6174696F6E4B657973222C0A09090909747970653A2022436F7272656C6174696F6E4B6579222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E';
wwv_flow_imp.g_varchar2_table(6124) := '616D653A20226C6F6F7054797065222C0A09090909747970653A202243686F72656F6772617068794C6F6F7054797065222C0A090909092264656661756C74223A20224E6F6E65222C0A090909096973417474723A20747275650A0909097D0A09095D0A';
wwv_flow_imp.g_varchar2_table(6125) := '097D2C0A097B0A09096E616D653A202243616C6C43686F72656F677261706879222C0A09097375706572436C6173733A205B0A0909092243686F72656F6772617068794163746976697479220A09095D2C0A090970726F706572746965733A205B0A0909';
wwv_flow_imp.g_varchar2_table(6126) := '097B0A090909096E616D653A202263616C6C656443686F72656F677261706879526566222C0A09090909747970653A202243686F72656F677261706879222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A2074';
wwv_flow_imp.g_varchar2_table(6127) := '7275650A0909097D2C0A0909097B0A090909096E616D653A20227061727469636970616E744173736F63696174696F6E73222C0A09090909747970653A20225061727469636970616E744173736F63696174696F6E222C0A0909090969734D616E793A20';
wwv_flow_imp.g_varchar2_table(6128) := '747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202253756243686F72656F677261706879222C0A09097375706572436C6173733A205B0A0909092243686F72656F6772617068794163746976697479222C0A09090922466C6F7745';
wwv_flow_imp.g_varchar2_table(6129) := '6C656D656E7473436F6E7461696E6572220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022617274696661637473222C0A09090909747970653A20224172746966616374222C0A0909090969734D616E793A';
wwv_flow_imp.g_varchar2_table(6130) := '20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202243686F72656F6772617068795461736B222C0A09097375706572436C6173733A205B0A0909092243686F72656F6772617068794163746976697479220A09095D2C0A090970';
wwv_flow_imp.g_varchar2_table(6131) := '726F706572746965733A205B0A0909097B0A090909096E616D653A20226D657373616765466C6F77526566222C0A09090909747970653A20224D657373616765466C6F77222C0A0909090969734D616E793A20747275652C0A0909090969735265666572';
wwv_flow_imp.g_varchar2_table(6132) := '656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202243686F72656F677261706879222C0A09097375706572436C6173733A205B0A09090922436F6C6C61626F726174696F6E222C0A09090922466C6F77456C656D65';
wwv_flow_imp.g_varchar2_table(6133) := '6E7473436F6E7461696E6572220A09095D0A097D2C0A097B0A09096E616D653A2022476C6F62616C43686F72656F6772617068795461736B222C0A09097375706572436C6173733A205B0A0909092243686F72656F677261706879220A09095D2C0A0909';
wwv_flow_imp.g_varchar2_table(6134) := '70726F706572746965733A205B0A0909097B0A090909096E616D653A2022696E6974696174696E675061727469636970616E74526566222C0A09090909747970653A20225061727469636970616E74222C0A090909096973417474723A20747275652C0A';
wwv_flow_imp.g_varchar2_table(6135) := '0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202254657874416E6E6F746174696F6E222C0A09097375706572436C6173733A205B0A090909224172746966616374220A09095D2C0A09';
wwv_flow_imp.g_varchar2_table(6136) := '0970726F706572746965733A205B0A0909097B0A090909096E616D653A202274657874222C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A202274657874466F726D6174222C0A0909090922646566';
wwv_flow_imp.g_varchar2_table(6137) := '61756C74223A2022746578742F706C61696E222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202247726F7570222C0A09097375706572436C';
wwv_flow_imp.g_varchar2_table(6138) := '6173733A205B0A090909224172746966616374220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202263617465676F727956616C7565526566222C0A09090909747970653A202243617465676F727956616C75';
wwv_flow_imp.g_varchar2_table(6139) := '65222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224173736F63696174696F6E222C0A09097375706572436C6173733A205B0A09';
wwv_flow_imp.g_varchar2_table(6140) := '0909224172746966616374220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226173736F63696174696F6E446972656374696F6E222C0A09090909747970653A20224173736F63696174696F6E4469726563';
wwv_flow_imp.g_varchar2_table(6141) := '74696F6E222C0A090909096973417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022736F75726365526566222C0A09090909747970653A202242617365456C656D656E74222C0A090909096973417474723A20747275652C';
wwv_flow_imp.g_varchar2_table(6142) := '0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022746172676574526566222C0A09090909747970653A202242617365456C656D656E74222C0A090909096973417474723A20747275652C0A';
wwv_flow_imp.g_varchar2_table(6143) := '0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202243617465676F7279222C0A09097375706572436C6173733A205B0A09090922526F6F74456C656D656E74220A09095D2C0A09097072';
wwv_flow_imp.g_varchar2_table(6144) := '6F706572746965733A205B0A0909097B0A090909096E616D653A202263617465676F727956616C7565222C0A09090909747970653A202243617465676F727956616C7565222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A09';
wwv_flow_imp.g_varchar2_table(6145) := '0909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224172746966616374222C0A09096973416273747261';
wwv_flow_imp.g_varchar2_table(6146) := '63743A20747275652C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D0A097D2C0A097B0A09096E616D653A202243617465676F727956616C7565222C0A09097375706572436C6173733A205B0A0909092242';
wwv_flow_imp.g_varchar2_table(6147) := '617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202263617465676F72697A6564466C6F77456C656D656E7473222C0A09090909747970653A2022466C6F77456C656D656E74222C0A';
wwv_flow_imp.g_varchar2_table(6148) := '0909090969734D616E793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A202276616C7565222C0A090909096973417474';
wwv_flow_imp.g_varchar2_table(6149) := '723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224163746976697479222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A205B0A';
wwv_flow_imp.g_varchar2_table(6150) := '09090922466C6F774E6F6465220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226973466F72436F6D70656E736174696F6E222C0A090909092264656661756C74223A2066616C73652C0A09090909697341';
wwv_flow_imp.g_varchar2_table(6151) := '7474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A202264656661756C74222C0A09090909747970653A202253657175656E6365466C6F77222C0A090909096973417474723A';
wwv_flow_imp.g_varchar2_table(6152) := '20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022696F53706563696669636174696F6E222C0A09090909747970653A2022496E7075744F7574707574537065636966696361';
wwv_flow_imp.g_varchar2_table(6153) := '74696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A202270726F7065727479220A090909097D0A0909097D2C0A0909097B0A090909096E616D653A2022626F756E646172794576656E7452656673222C0A09090909747970';
wwv_flow_imp.g_varchar2_table(6154) := '653A2022426F756E646172794576656E74222C0A0909090969734D616E793A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A202270726F70657274696573222C0A0909090974';
wwv_flow_imp.g_varchar2_table(6155) := '7970653A202250726F7065727479222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A202264617461496E7075744173736F63696174696F6E73222C0A09090909747970653A202244617461496E707574';
wwv_flow_imp.g_varchar2_table(6156) := '4173736F63696174696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022646174614F75747075744173736F63696174696F6E73222C0A09090909747970653A2022446174614F757470757441';
wwv_flow_imp.g_varchar2_table(6157) := '73736F63696174696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A202273746172745175616E74697479222C0A090909092264656661756C74223A20312C0A090909096973417474723A207472';
wwv_flow_imp.g_varchar2_table(6158) := '75652C0A09090909747970653A2022496E7465676572220A0909097D2C0A0909097B0A090909096E616D653A20227265736F7572636573222C0A09090909747970653A20225265736F75726365526F6C65222C0A0909090969734D616E793A2074727565';
wwv_flow_imp.g_varchar2_table(6159) := '0A0909097D2C0A0909097B0A090909096E616D653A2022636F6D706C6574696F6E5175616E74697479222C0A090909092264656661756C74223A20312C0A090909096973417474723A20747275652C0A09090909747970653A2022496E7465676572220A';
wwv_flow_imp.g_varchar2_table(6160) := '0909097D2C0A0909097B0A090909096E616D653A20226C6F6F70436861726163746572697374696373222C0A09090909747970653A20224C6F6F70436861726163746572697374696373220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20';
wwv_flow_imp.g_varchar2_table(6161) := '22536572766963655461736B222C0A09097375706572436C6173733A205B0A090909225461736B220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696D706C656D656E746174696F6E222C0A0909090969';
wwv_flow_imp.g_varchar2_table(6162) := '73417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20226F7065726174696F6E526566222C0A09090909747970653A20224F7065726174696F6E222C0A0909090969734174';
wwv_flow_imp.g_varchar2_table(6163) := '74723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202253756250726F63657373222C0A09097375706572436C6173733A205B0A090909224163746976697479222C';
wwv_flow_imp.g_varchar2_table(6164) := '0A09090922466C6F77456C656D656E7473436F6E7461696E6572222C0A09090922496E746572616374696F6E4E6F6465220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202274726967676572656442794576';
wwv_flow_imp.g_varchar2_table(6165) := '656E74222C0A090909092264656661756C74223A2066616C73652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A2022617274696661637473222C0A';
wwv_flow_imp.g_varchar2_table(6166) := '09090909747970653A20224172746966616374222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224C6F6F70436861726163746572697374696373222C0A0909697341627374726163743A20';
wwv_flow_imp.g_varchar2_table(6167) := '747275652C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D0A097D2C0A097B0A09096E616D653A20224D756C7469496E7374616E63654C6F6F70436861726163746572697374696373222C0A090973757065';
wwv_flow_imp.g_varchar2_table(6168) := '72436C6173733A205B0A090909224C6F6F70436861726163746572697374696373220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022697353657175656E7469616C222C0A090909092264656661756C7422';
wwv_flow_imp.g_varchar2_table(6169) := '3A2066616C73652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A20226265686176696F72222C0A09090909747970653A20224D756C7469496E7374';
wwv_flow_imp.g_varchar2_table(6170) := '616E63654265686176696F72222C0A090909092264656661756C74223A2022416C6C222C0A090909096973417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226C6F6F7043617264696E616C697479222C0A090909097479';
wwv_flow_imp.g_varchar2_table(6171) := '70653A202245787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909097D2C0A0909097B0A090909096E616D653A20226C6F6F7044617461496E707574526566';
wwv_flow_imp.g_varchar2_table(6172) := '222C0A09090909747970653A20224974656D4177617265456C656D656E74222C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226C6F6F70446174614F7574707574526566222C0A090909';
wwv_flow_imp.g_varchar2_table(6173) := '09747970653A20224974656D4177617265456C656D656E74222C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022696E707574446174614974656D222C0A09090909747970653A20224461';
wwv_flow_imp.g_varchar2_table(6174) := '7461496E707574222C0A09090909786D6C3A207B0A090909090973657269616C697A653A202270726F7065727479220A090909097D0A0909097D2C0A0909097B0A090909096E616D653A20226F7574707574446174614974656D222C0A09090909747970';
wwv_flow_imp.g_varchar2_table(6175) := '653A2022446174614F7574707574222C0A09090909786D6C3A207B0A090909090973657269616C697A653A202270726F7065727479220A090909097D0A0909097D2C0A0909097B0A090909096E616D653A2022636F6D706C65784265686176696F724465';
wwv_flow_imp.g_varchar2_table(6176) := '66696E6974696F6E222C0A09090909747970653A2022436F6D706C65784265686176696F72446566696E6974696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022636F6D706C6574696F6E43';
wwv_flow_imp.g_varchar2_table(6177) := '6F6E646974696F6E222C0A09090909747970653A202245787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909097D2C0A0909097B0A090909096E616D653A20';
wwv_flow_imp.g_varchar2_table(6178) := '226F6E654265686176696F724576656E74526566222C0A09090909747970653A20224576656E74446566696E6974696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909';
wwv_flow_imp.g_varchar2_table(6179) := '097B0A090909096E616D653A20226E6F6E654265686176696F724576656E74526566222C0A09090909747970653A20224576656E74446566696E6974696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A';
wwv_flow_imp.g_varchar2_table(6180) := '20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225374616E646172644C6F6F70436861726163746572697374696373222C0A09097375706572436C6173733A205B0A090909224C6F6F70436861726163746572697374696373';
wwv_flow_imp.g_varchar2_table(6181) := '220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022746573744265666F7265222C0A090909092264656661756C74223A2066616C73652C0A090909096973417474723A20747275652C0A0909090974797065';
wwv_flow_imp.g_varchar2_table(6182) := '3A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A20226C6F6F70436F6E646974696F6E222C0A09090909747970653A202245787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A';
wwv_flow_imp.g_varchar2_table(6183) := '20227873693A74797065220A090909097D0A0909097D2C0A0909097B0A090909096E616D653A20226C6F6F704D6178696D756D222C0A09090909747970653A2022496E7465676572222C0A090909096973417474723A20747275650A0909097D0A09095D';
wwv_flow_imp.g_varchar2_table(6184) := '0A097D2C0A097B0A09096E616D653A202243616C6C4163746976697479222C0A09097375706572436C6173733A205B0A090909224163746976697479222C0A09090922496E746572616374696F6E4E6F6465220A09095D2C0A090970726F706572746965';
wwv_flow_imp.g_varchar2_table(6185) := '733A205B0A0909097B0A090909096E616D653A202263616C6C6564456C656D656E74222C0A09090909747970653A2022537472696E67222C0A090909096973417474723A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202254';
wwv_flow_imp.g_varchar2_table(6186) := '61736B222C0A09097375706572436C6173733A205B0A090909224163746976697479222C0A09090922496E746572616374696F6E4E6F6465220A09095D0A097D2C0A097B0A09096E616D653A202253656E645461736B222C0A09097375706572436C6173';
wwv_flow_imp.g_varchar2_table(6187) := '733A205B0A090909225461736B220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696D706C656D656E746174696F6E222C0A090909096973417474723A20747275652C0A09090909747970653A20225374';
wwv_flow_imp.g_varchar2_table(6188) := '72696E67220A0909097D2C0A0909097B0A090909096E616D653A20226F7065726174696F6E526566222C0A09090909747970653A20224F7065726174696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A';
wwv_flow_imp.g_varchar2_table(6189) := '20747275650A0909097D2C0A0909097B0A090909096E616D653A20226D657373616765526566222C0A09090909747970653A20224D657373616765222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275';
wwv_flow_imp.g_varchar2_table(6190) := '650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022526563656976655461736B222C0A09097375706572436C6173733A205B0A090909225461736B220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D';
wwv_flow_imp.g_varchar2_table(6191) := '653A2022696D706C656D656E746174696F6E222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022696E7374616E7469617465222C0A090909092264';
wwv_flow_imp.g_varchar2_table(6192) := '656661756C74223A2066616C73652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A20226F7065726174696F6E526566222C0A09090909747970653A';
wwv_flow_imp.g_varchar2_table(6193) := '20224F7065726174696F6E222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226D657373616765526566222C0A09090909747970653A2022';
wwv_flow_imp.g_varchar2_table(6194) := '4D657373616765222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225363726970745461736B222C0A09097375706572436C617373';
wwv_flow_imp.g_varchar2_table(6195) := '3A205B0A090909225461736B220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022736372697074466F726D6174222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E';
wwv_flow_imp.g_varchar2_table(6196) := '67220A0909097D2C0A0909097B0A090909096E616D653A2022736372697074222C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022427573696E65737352756C655461736B222C0A090973';
wwv_flow_imp.g_varchar2_table(6197) := '75706572436C6173733A205B0A090909225461736B220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696D706C656D656E746174696F6E222C0A090909096973417474723A20747275652C0A0909090974';
wwv_flow_imp.g_varchar2_table(6198) := '7970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224164486F6353756250726F63657373222C0A09097375706572436C6173733A205B0A0909092253756250726F63657373220A09095D2C0A090970726F70';
wwv_flow_imp.g_varchar2_table(6199) := '6572746965733A205B0A0909097B0A090909096E616D653A2022636F6D706C6574696F6E436F6E646974696F6E222C0A09090909747970653A202245787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A2022';
wwv_flow_imp.g_varchar2_table(6200) := '7873693A74797065220A090909097D0A0909097D2C0A0909097B0A090909096E616D653A20226F72646572696E67222C0A09090909747970653A20224164486F634F72646572696E67222C0A090909096973417474723A20747275650A0909097D2C0A09';
wwv_flow_imp.g_varchar2_table(6201) := '09097B0A090909096E616D653A202263616E63656C52656D61696E696E67496E7374616E636573222C0A090909092264656661756C74223A20747275652C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E22';
wwv_flow_imp.g_varchar2_table(6202) := '0A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225472616E73616374696F6E222C0A09097375706572436C6173733A205B0A0909092253756250726F63657373220A09095D2C0A090970726F706572746965733A205B0A0909097B0A0909';
wwv_flow_imp.g_varchar2_table(6203) := '09096E616D653A202270726F746F636F6C222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20226D6574686F64222C0A090909096973417474723A20';
wwv_flow_imp.g_varchar2_table(6204) := '747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022476C6F62616C5363726970745461736B222C0A09097375706572436C6173733A205B0A09090922476C6F62616C5461736B22';
wwv_flow_imp.g_varchar2_table(6205) := '0A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20227363726970744C616E6775616765222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909';
wwv_flow_imp.g_varchar2_table(6206) := '097B0A090909096E616D653A2022736372697074222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022476C6F62616C427573696E65737352';
wwv_flow_imp.g_varchar2_table(6207) := '756C655461736B222C0A09097375706572436C6173733A205B0A09090922476C6F62616C5461736B220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696D706C656D656E746174696F6E222C0A09090909';
wwv_flow_imp.g_varchar2_table(6208) := '6973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022436F6D706C65784265686176696F72446566696E6974696F6E222C0A09097375706572436C6173733A20';
wwv_flow_imp.g_varchar2_table(6209) := '5B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022636F6E646974696F6E222C0A09090909747970653A2022466F726D616C45787072657373696F6E220A090909';
wwv_flow_imp.g_varchar2_table(6210) := '7D2C0A0909097B0A090909096E616D653A20226576656E74222C0A09090909747970653A2022496D706C696369745468726F774576656E74220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225265736F75726365526F6C65222C0A0909';
wwv_flow_imp.g_varchar2_table(6211) := '7375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20227265736F75726365526566222C0A09090909747970653A20225265736F757263';
wwv_flow_imp.g_varchar2_table(6212) := '65222C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20227265736F75726365506172616D6574657242696E64696E6773222C0A09090909747970653A20225265736F75726365506172616D';
wwv_flow_imp.g_varchar2_table(6213) := '6574657242696E64696E67222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A20227265736F7572636541737369676E6D656E7445787072657373696F6E222C0A09090909747970653A20225265736F75';
wwv_flow_imp.g_varchar2_table(6214) := '72636541737369676E6D656E7445787072657373696F6E220A0909097D2C0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A';
wwv_flow_imp.g_varchar2_table(6215) := '097D2C0A097B0A09096E616D653A20225265736F75726365506172616D6574657242696E64696E67222C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202265787072657373696F6E222C0A09090909747970653A202245';
wwv_flow_imp.g_varchar2_table(6216) := '787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909097D2C0A0909097B0A090909096E616D653A2022706172616D65746572526566222C0A09090909747970';
wwv_flow_imp.g_varchar2_table(6217) := '653A20225265736F75726365506172616D65746572222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D0A09095D2C0A09097375706572436C6173733A205B0A0909092242617365456C';
wwv_flow_imp.g_varchar2_table(6218) := '656D656E74220A09095D0A097D2C0A097B0A09096E616D653A20225265736F7572636541737369676E6D656E7445787072657373696F6E222C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202265787072657373696F6E';
wwv_flow_imp.g_varchar2_table(6219) := '222C0A09090909747970653A202245787072657373696F6E222C0A09090909786D6C3A207B0A090909090973657269616C697A653A20227873693A74797065220A090909097D0A0909097D0A09095D2C0A09097375706572436C6173733A205B0A090909';
wwv_flow_imp.g_varchar2_table(6220) := '2242617365456C656D656E74220A09095D0A097D2C0A097B0A09096E616D653A2022496D706F7274222C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022696D706F727454797065222C0A090909096973417474723A20';
wwv_flow_imp.g_varchar2_table(6221) := '747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20226C6F636174696F6E222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C';
wwv_flow_imp.g_varchar2_table(6222) := '0A0909097B0A090909096E616D653A20226E616D657370616365222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022446566696E6974696F';
wwv_flow_imp.g_varchar2_table(6223) := '6E73222C0A09097375706572436C6173733A205B0A0909092242617365456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A090909096973417474723A20747275652C0A';
wwv_flow_imp.g_varchar2_table(6224) := '09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20227461726765744E616D657370616365222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D';
wwv_flow_imp.g_varchar2_table(6225) := '2C0A0909097B0A090909096E616D653A202265787072657373696F6E4C616E6775616765222C0A090909092264656661756C74223A2022687474703A2F2F7777772E77332E6F72672F313939392F5850617468222C0A090909096973417474723A207472';
wwv_flow_imp.g_varchar2_table(6226) := '75652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022747970654C616E6775616765222C0A090909092264656661756C74223A2022687474703A2F2F7777772E77332E6F72672F323030312F58';
wwv_flow_imp.g_varchar2_table(6227) := '4D4C536368656D61222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022696D706F727473222C0A09090909747970653A2022496D706F7274222C0A';
wwv_flow_imp.g_varchar2_table(6228) := '0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022657874656E73696F6E73222C0A09090909747970653A2022457874656E73696F6E222C0A0909090969734D616E793A20747275650A0909097D2C0A0909';
wwv_flow_imp.g_varchar2_table(6229) := '097B0A090909096E616D653A2022726F6F74456C656D656E7473222C0A09090909747970653A2022526F6F74456C656D656E74222C0A0909090969734D616E793A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226469616772616D';
wwv_flow_imp.g_varchar2_table(6230) := '73222C0A0909090969734D616E793A20747275652C0A09090909747970653A202262706D6E64693A42504D4E4469616772616D220A0909097D2C0A0909097B0A090909096E616D653A20226578706F72746572222C0A090909096973417474723A207472';
wwv_flow_imp.g_varchar2_table(6231) := '75652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A202272656C6174696F6E7368697073222C0A09090909747970653A202252656C6174696F6E73686970222C0A0909090969734D616E793A2074';
wwv_flow_imp.g_varchar2_table(6232) := '7275650A0909097D2C0A0909097B0A090909096E616D653A20226578706F7274657256657273696F6E222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D0A5D3B0A76617220';
wwv_flow_imp.g_varchar2_table(6233) := '656E756D65726174696F6E732433203D205B0A097B0A09096E616D653A202250726F6365737354797065222C0A09096C69746572616C56616C7565733A205B0A0909097B0A090909096E616D653A20224E6F6E65220A0909097D2C0A0909097B0A090909';
wwv_flow_imp.g_varchar2_table(6234) := '096E616D653A20225075626C6963220A0909097D2C0A0909097B0A090909096E616D653A202250726976617465220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202247617465776179446972656374696F6E222C0A09096C69746572616C';
wwv_flow_imp.g_varchar2_table(6235) := '56616C7565733A205B0A0909097B0A090909096E616D653A2022556E737065636966696564220A0909097D2C0A0909097B0A090909096E616D653A2022436F6E76657267696E67220A0909097D2C0A0909097B0A090909096E616D653A20224469766572';
wwv_flow_imp.g_varchar2_table(6236) := '67696E67220A0909097D2C0A0909097B0A090909096E616D653A20224D69786564220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224576656E7442617365644761746577617954797065222C0A09096C69746572616C56616C7565733A';
wwv_flow_imp.g_varchar2_table(6237) := '205B0A0909097B0A090909096E616D653A2022506172616C6C656C220A0909097D2C0A0909097B0A090909096E616D653A20224578636C7573697665220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202252656C6174696F6E7368697044';
wwv_flow_imp.g_varchar2_table(6238) := '6972656374696F6E222C0A09096C69746572616C56616C7565733A205B0A0909097B0A090909096E616D653A20224E6F6E65220A0909097D2C0A0909097B0A090909096E616D653A2022466F7277617264220A0909097D2C0A0909097B0A090909096E61';
wwv_flow_imp.g_varchar2_table(6239) := '6D653A20224261636B77617264220A0909097D2C0A0909097B0A090909096E616D653A2022426F7468220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224974656D4B696E64222C0A09096C69746572616C56616C7565733A205B0A0909';
wwv_flow_imp.g_varchar2_table(6240) := '097B0A090909096E616D653A2022506879736963616C220A0909097D2C0A0909097B0A090909096E616D653A2022496E666F726D6174696F6E220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A202243686F72656F6772617068794C6F6F70';
wwv_flow_imp.g_varchar2_table(6241) := '54797065222C0A09096C69746572616C56616C7565733A205B0A0909097B0A090909096E616D653A20224E6F6E65220A0909097D2C0A0909097B0A090909096E616D653A20225374616E64617264220A0909097D2C0A0909097B0A090909096E616D653A';
wwv_flow_imp.g_varchar2_table(6242) := '20224D756C7469496E7374616E636553657175656E7469616C220A0909097D2C0A0909097B0A090909096E616D653A20224D756C7469496E7374616E6365506172616C6C656C220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022417373';
wwv_flow_imp.g_varchar2_table(6243) := '6F63696174696F6E446972656374696F6E222C0A09096C69746572616C56616C7565733A205B0A0909097B0A090909096E616D653A20224E6F6E65220A0909097D2C0A0909097B0A090909096E616D653A20224F6E65220A0909097D2C0A0909097B0A09';
wwv_flow_imp.g_varchar2_table(6244) := '0909096E616D653A2022426F7468220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224D756C7469496E7374616E63654265686176696F72222C0A09096C69746572616C56616C7565733A205B0A0909097B0A090909096E616D653A2022';
wwv_flow_imp.g_varchar2_table(6245) := '4E6F6E65220A0909097D2C0A0909097B0A090909096E616D653A20224F6E65220A0909097D2C0A0909097B0A090909096E616D653A2022416C6C220A0909097D2C0A0909097B0A090909096E616D653A2022436F6D706C6578220A0909097D0A09095D0A';
wwv_flow_imp.g_varchar2_table(6246) := '097D2C0A097B0A09096E616D653A20224164486F634F72646572696E67222C0A09096C69746572616C56616C7565733A205B0A0909097B0A090909096E616D653A2022506172616C6C656C220A0909097D2C0A0909097B0A090909096E616D653A202253';
wwv_flow_imp.g_varchar2_table(6247) := '657175656E7469616C220A0909097D0A09095D0A097D0A5D3B0A76617220786D6C2431203D207B0A09746167416C6961733A20226C6F77657243617365222C0A09747970655072656669783A202274220A7D3B0A7661722042706D6E5061636B61676520';
wwv_flow_imp.g_varchar2_table(6248) := '3D207B0A096E616D653A206E616D6524352C0A097572693A2075726924352C0A097072656669783A2070726566697824352C0A096173736F63696174696F6E733A206173736F63696174696F6E7324352C0A0974797065733A20747970657324352C0A09';
wwv_flow_imp.g_varchar2_table(6249) := '656E756D65726174696F6E733A20656E756D65726174696F6E7324332C0A09786D6C3A20786D6C24310A7D3B0A0A766172206E616D652434203D202242504D4E4449223B0A766172207572692434203D2022687474703A2F2F7777772E6F6D672E6F7267';
wwv_flow_imp.g_varchar2_table(6250) := '2F737065632F42504D4E2F32303130303532342F4449223B0A766172207072656669782434203D202262706D6E6469223B0A7661722074797065732434203D205B0A097B0A09096E616D653A202242504D4E4469616772616D222C0A090970726F706572';
wwv_flow_imp.g_varchar2_table(6251) := '746965733A205B0A0909097B0A090909096E616D653A2022706C616E65222C0A09090909747970653A202242504D4E506C616E65222C0A090909097265646566696E65733A202264693A4469616772616D23726F6F74456C656D656E74220A0909097D2C';
wwv_flow_imp.g_varchar2_table(6252) := '0A0909097B0A090909096E616D653A20226C6162656C5374796C65222C0A09090909747970653A202242504D4E4C6162656C5374796C65222C0A0909090969734D616E793A20747275650A0909097D0A09095D2C0A09097375706572436C6173733A205B';
wwv_flow_imp.g_varchar2_table(6253) := '0A0909092264693A4469616772616D220A09095D0A097D2C0A097B0A09096E616D653A202242504D4E506C616E65222C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202262706D6E456C656D656E74222C0A0909090969';
wwv_flow_imp.g_varchar2_table(6254) := '73417474723A20747275652C0A0909090969735265666572656E63653A20747275652C0A09090909747970653A202262706D6E3A42617365456C656D656E74222C0A090909097265646566696E65733A202264693A4469616772616D456C656D656E7423';
wwv_flow_imp.g_varchar2_table(6255) := '6D6F64656C456C656D656E74220A0909097D0A09095D2C0A09097375706572436C6173733A205B0A0909092264693A506C616E65220A09095D0A097D2C0A097B0A09096E616D653A202242504D4E5368617065222C0A090970726F706572746965733A20';
wwv_flow_imp.g_varchar2_table(6256) := '5B0A0909097B0A090909096E616D653A202262706D6E456C656D656E74222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275652C0A09090909747970653A202262706D6E3A42617365456C656D656E74';
wwv_flow_imp.g_varchar2_table(6257) := '222C0A090909097265646566696E65733A202264693A4469616772616D456C656D656E74236D6F64656C456C656D656E74220A0909097D2C0A0909097B0A090909096E616D653A20226973486F72697A6F6E74616C222C0A090909096973417474723A20';
wwv_flow_imp.g_varchar2_table(6258) := '747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A20226973457870616E646564222C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A09';
wwv_flow_imp.g_varchar2_table(6259) := '09097D2C0A0909097B0A090909096E616D653A202269734D61726B657256697369626C65222C0A090909096973417474723A20747275652C0A09090909747970653A2022426F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A20226C';
wwv_flow_imp.g_varchar2_table(6260) := '6162656C222C0A09090909747970653A202242504D4E4C6162656C220A0909097D2C0A0909097B0A090909096E616D653A202269734D65737361676556697369626C65222C0A090909096973417474723A20747275652C0A09090909747970653A202242';
wwv_flow_imp.g_varchar2_table(6261) := '6F6F6C65616E220A0909097D2C0A0909097B0A090909096E616D653A20227061727469636970616E7442616E644B696E64222C0A09090909747970653A20225061727469636970616E7442616E644B696E64222C0A090909096973417474723A20747275';
wwv_flow_imp.g_varchar2_table(6262) := '650A0909097D2C0A0909097B0A090909096E616D653A202263686F72656F67726170687941637469766974795368617065222C0A09090909747970653A202242504D4E5368617065222C0A090909096973417474723A20747275652C0A09090909697352';
wwv_flow_imp.g_varchar2_table(6263) := '65666572656E63653A20747275650A0909097D0A09095D2C0A09097375706572436C6173733A205B0A0909092264693A4C6162656C65645368617065220A09095D0A097D2C0A097B0A09096E616D653A202242504D4E45646765222C0A090970726F7065';
wwv_flow_imp.g_varchar2_table(6264) := '72746965733A205B0A0909097B0A090909096E616D653A20226C6162656C222C0A09090909747970653A202242504D4E4C6162656C220A0909097D2C0A0909097B0A090909096E616D653A202262706D6E456C656D656E74222C0A090909096973417474';
wwv_flow_imp.g_varchar2_table(6265) := '723A20747275652C0A0909090969735265666572656E63653A20747275652C0A09090909747970653A202262706D6E3A42617365456C656D656E74222C0A090909097265646566696E65733A202264693A4469616772616D456C656D656E74236D6F6465';
wwv_flow_imp.g_varchar2_table(6266) := '6C456C656D656E74220A0909097D2C0A0909097B0A090909096E616D653A2022736F75726365456C656D656E74222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A20747275652C0A09090909747970653A2022';
wwv_flow_imp.g_varchar2_table(6267) := '64693A4469616772616D456C656D656E74222C0A090909097265646566696E65733A202264693A4564676523736F75726365220A0909097D2C0A0909097B0A090909096E616D653A2022746172676574456C656D656E74222C0A09090909697341747472';
wwv_flow_imp.g_varchar2_table(6268) := '3A20747275652C0A0909090969735265666572656E63653A20747275652C0A09090909747970653A202264693A4469616772616D456C656D656E74222C0A090909097265646566696E65733A202264693A4564676523746172676574220A0909097D2C0A';
wwv_flow_imp.g_varchar2_table(6269) := '0909097B0A090909096E616D653A20226D65737361676556697369626C654B696E64222C0A09090909747970653A20224D65737361676556697369626C654B696E64222C0A090909096973417474723A20747275652C0A090909092264656661756C7422';
wwv_flow_imp.g_varchar2_table(6270) := '3A2022696E6974696174696E67220A0909097D0A09095D2C0A09097375706572436C6173733A205B0A0909092264693A4C6162656C656445646765220A09095D0A097D2C0A097B0A09096E616D653A202242504D4E4C6162656C222C0A090970726F7065';
wwv_flow_imp.g_varchar2_table(6271) := '72746965733A205B0A0909097B0A090909096E616D653A20226C6162656C5374796C65222C0A09090909747970653A202242504D4E4C6162656C5374796C65222C0A090909096973417474723A20747275652C0A0909090969735265666572656E63653A';
wwv_flow_imp.g_varchar2_table(6272) := '20747275652C0A090909097265646566696E65733A202264693A4469616772616D456C656D656E74237374796C65220A0909097D0A09095D2C0A09097375706572436C6173733A205B0A0909092264693A4C6162656C220A09095D0A097D2C0A097B0A09';
wwv_flow_imp.g_varchar2_table(6273) := '096E616D653A202242504D4E4C6162656C5374796C65222C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022666F6E74222C0A09090909747970653A202264633A466F6E74220A0909097D0A09095D2C0A090973757065';
wwv_flow_imp.g_varchar2_table(6274) := '72436C6173733A205B0A0909092264693A5374796C65220A09095D0A097D0A5D3B0A76617220656E756D65726174696F6E732432203D205B0A097B0A09096E616D653A20225061727469636970616E7442616E644B696E64222C0A09096C69746572616C';
wwv_flow_imp.g_varchar2_table(6275) := '56616C7565733A205B0A0909097B0A090909096E616D653A2022746F705F696E6974696174696E67220A0909097D2C0A0909097B0A090909096E616D653A20226D6964646C655F696E6974696174696E67220A0909097D2C0A0909097B0A090909096E61';
wwv_flow_imp.g_varchar2_table(6276) := '6D653A2022626F74746F6D5F696E6974696174696E67220A0909097D2C0A0909097B0A090909096E616D653A2022746F705F6E6F6E5F696E6974696174696E67220A0909097D2C0A0909097B0A090909096E616D653A20226D6964646C655F6E6F6E5F69';
wwv_flow_imp.g_varchar2_table(6277) := '6E6974696174696E67220A0909097D2C0A0909097B0A090909096E616D653A2022626F74746F6D5F6E6F6E5F696E6974696174696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224D65737361676556697369626C654B696E6422';
wwv_flow_imp.g_varchar2_table(6278) := '2C0A09096C69746572616C56616C7565733A205B0A0909097B0A090909096E616D653A2022696E6974696174696E67220A0909097D2C0A0909097B0A090909096E616D653A20226E6F6E5F696E6974696174696E67220A0909097D0A09095D0A097D0A5D';
wwv_flow_imp.g_varchar2_table(6279) := '3B0A766172206173736F63696174696F6E732434203D205B0A5D3B0A7661722042706D6E44695061636B616765203D207B0A096E616D653A206E616D6524342C0A097572693A2075726924342C0A097072656669783A2070726566697824342C0A097479';
wwv_flow_imp.g_varchar2_table(6280) := '7065733A20747970657324342C0A09656E756D65726174696F6E733A20656E756D65726174696F6E7324322C0A096173736F63696174696F6E733A206173736F63696174696F6E7324340A7D3B0A0A766172206E616D652433203D20224443223B0A7661';
wwv_flow_imp.g_varchar2_table(6281) := '72207572692433203D2022687474703A2F2F7777772E6F6D672E6F72672F737065632F44442F32303130303532342F4443223B0A766172207072656669782433203D20226463223B0A7661722074797065732433203D205B0A097B0A09096E616D653A20';
wwv_flow_imp.g_varchar2_table(6282) := '22426F6F6C65616E220A097D2C0A097B0A09096E616D653A2022496E7465676572220A097D2C0A097B0A09096E616D653A20225265616C220A097D2C0A097B0A09096E616D653A2022537472696E67220A097D2C0A097B0A09096E616D653A2022466F6E';
wwv_flow_imp.g_varchar2_table(6283) := '74222C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226E616D65222C0A09090909747970653A2022537472696E67222C0A090909096973417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A';
wwv_flow_imp.g_varchar2_table(6284) := '202273697A65222C0A09090909747970653A20225265616C222C0A090909096973417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226973426F6C64222C0A09090909747970653A2022426F6F6C65616E222C0A09090909';
wwv_flow_imp.g_varchar2_table(6285) := '6973417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A202269734974616C6963222C0A09090909747970653A2022426F6F6C65616E222C0A090909096973417474723A20747275650A0909097D2C0A0909097B0A090909096E';
wwv_flow_imp.g_varchar2_table(6286) := '616D653A20226973556E6465726C696E65222C0A09090909747970653A2022426F6F6C65616E222C0A090909096973417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226973537472696B655468726F756768222C0A0909';
wwv_flow_imp.g_varchar2_table(6287) := '0909747970653A2022426F6F6C65616E222C0A090909096973417474723A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022506F696E74222C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20';
wwv_flow_imp.g_varchar2_table(6288) := '2278222C0A09090909747970653A20225265616C222C0A090909092264656661756C74223A202230222C0A090909096973417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A202279222C0A09090909747970653A2022526561';
wwv_flow_imp.g_varchar2_table(6289) := '6C222C0A090909092264656661756C74223A202230222C0A090909096973417474723A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022426F756E6473222C0A090970726F706572746965733A205B0A0909097B0A09090909';
wwv_flow_imp.g_varchar2_table(6290) := '6E616D653A202278222C0A09090909747970653A20225265616C222C0A090909092264656661756C74223A202230222C0A090909096973417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A202279222C0A0909090974797065';
wwv_flow_imp.g_varchar2_table(6291) := '3A20225265616C222C0A090909092264656661756C74223A202230222C0A090909096973417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A20227769647468222C0A09090909747970653A20225265616C222C0A0909090969';
wwv_flow_imp.g_varchar2_table(6292) := '73417474723A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022686569676874222C0A09090909747970653A20225265616C222C0A090909096973417474723A20747275650A0909097D0A09095D0A097D0A5D3B0A76617220617373';
wwv_flow_imp.g_varchar2_table(6293) := '6F63696174696F6E732433203D205B0A5D3B0A7661722044635061636B616765203D207B0A096E616D653A206E616D6524332C0A097572693A2075726924332C0A097072656669783A2070726566697824332C0A0974797065733A20747970657324332C';
wwv_flow_imp.g_varchar2_table(6294) := '0A096173736F63696174696F6E733A206173736F63696174696F6E7324330A7D3B0A0A766172206E616D652432203D20224449223B0A766172207572692432203D2022687474703A2F2F7777772E6F6D672E6F72672F737065632F44442F323031303035';
wwv_flow_imp.g_varchar2_table(6295) := '32342F4449223B0A766172207072656669782432203D20226469223B0A7661722074797065732432203D205B0A097B0A09096E616D653A20224469616772616D456C656D656E74222C0A0909697341627374726163743A20747275652C0A090970726F70';
wwv_flow_imp.g_varchar2_table(6296) := '6572746965733A205B0A0909097B0A090909096E616D653A20226964222C0A090909096973417474723A20747275652C0A09090909697349643A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E';
wwv_flow_imp.g_varchar2_table(6297) := '616D653A2022657874656E73696F6E222C0A09090909747970653A2022457874656E73696F6E220A0909097D2C0A0909097B0A090909096E616D653A20226F776E696E674469616772616D222C0A09090909747970653A20224469616772616D222C0A09';
wwv_flow_imp.g_varchar2_table(6298) := '0909096973526561644F6E6C793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F776E696E67456C656D656E7422';
wwv_flow_imp.g_varchar2_table(6299) := '2C0A09090909747970653A20224469616772616D456C656D656E74222C0A090909096973526561644F6E6C793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C';
wwv_flow_imp.g_varchar2_table(6300) := '0A0909097B0A090909096E616D653A20226D6F64656C456C656D656E74222C0A090909096973526561644F6E6C793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275652C0A0909';
wwv_flow_imp.g_varchar2_table(6301) := '0909747970653A2022456C656D656E74220A0909097D2C0A0909097B0A090909096E616D653A20227374796C65222C0A09090909747970653A20225374796C65222C0A090909096973526561644F6E6C793A20747275652C0A0909090969735669727475';
wwv_flow_imp.g_varchar2_table(6302) := '616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A20226F776E6564456C656D656E74222C0A09090909747970653A20224469616772616D456C656D656E74222C0A090909';
wwv_flow_imp.g_varchar2_table(6303) := '096973526561644F6E6C793A20747275652C0A0909090969734D616E793A20747275652C0A0909090969735669727475616C3A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224E6F6465222C0A0909697341627374726163';
wwv_flow_imp.g_varchar2_table(6304) := '743A20747275652C0A09097375706572436C6173733A205B0A090909224469616772616D456C656D656E74220A09095D0A097D2C0A097B0A09096E616D653A202245646765222C0A0909697341627374726163743A20747275652C0A0909737570657243';
wwv_flow_imp.g_varchar2_table(6305) := '6C6173733A205B0A090909224469616772616D456C656D656E74220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022736F75726365222C0A09090909747970653A20224469616772616D456C656D656E7422';
wwv_flow_imp.g_varchar2_table(6306) := '2C0A090909096973526561644F6E6C793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A0909097B0A090909096E616D653A2022746172676574222C0A0909';
wwv_flow_imp.g_varchar2_table(6307) := '0909747970653A20224469616772616D456C656D656E74222C0A090909096973526561644F6E6C793A20747275652C0A0909090969735669727475616C3A20747275652C0A0909090969735265666572656E63653A20747275650A0909097D2C0A090909';
wwv_flow_imp.g_varchar2_table(6308) := '7B0A090909096E616D653A2022776179706F696E74222C0A090909096973556E697175653A2066616C73652C0A0909090969734D616E793A20747275652C0A09090909747970653A202264633A506F696E74222C0A09090909786D6C3A207B0A09090909';
wwv_flow_imp.g_varchar2_table(6309) := '0973657269616C697A653A20227873693A74797065220A090909097D0A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224469616772616D222C0A0909697341627374726163743A20747275652C0A090970726F706572746965733A205B0A';
wwv_flow_imp.g_varchar2_table(6310) := '0909097B0A090909096E616D653A20226964222C0A090909096973417474723A20747275652C0A09090909697349643A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022726F6F74';
wwv_flow_imp.g_varchar2_table(6311) := '456C656D656E74222C0A09090909747970653A20224469616772616D456C656D656E74222C0A090909096973526561644F6E6C793A20747275652C0A0909090969735669727475616C3A20747275650A0909097D2C0A0909097B0A090909096E616D653A';
wwv_flow_imp.g_varchar2_table(6312) := '20226E616D65222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022646F63756D656E746174696F6E222C0A090909096973417474723A2074727565';
wwv_flow_imp.g_varchar2_table(6313) := '2C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A20227265736F6C7574696F6E222C0A090909096973417474723A20747275652C0A09090909747970653A20225265616C220A0909097D2C0A090909';
wwv_flow_imp.g_varchar2_table(6314) := '7B0A090909096E616D653A20226F776E65645374796C65222C0A09090909747970653A20225374796C65222C0A090909096973526561644F6E6C793A20747275652C0A0909090969734D616E793A20747275652C0A0909090969735669727475616C3A20';
wwv_flow_imp.g_varchar2_table(6315) := '747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225368617065222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A205B0A090909224E6F6465220A09095D2C0A090970726F706572746965';
wwv_flow_imp.g_varchar2_table(6316) := '733A205B0A0909097B0A090909096E616D653A2022626F756E6473222C0A09090909747970653A202264633A426F756E6473220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022506C616E65222C0A0909697341627374726163743A2074';
wwv_flow_imp.g_varchar2_table(6317) := '7275652C0A09097375706572436C6173733A205B0A090909224E6F6465220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022706C616E65456C656D656E74222C0A09090909747970653A2022446961677261';
wwv_flow_imp.g_varchar2_table(6318) := '6D456C656D656E74222C0A0909090973756273657474656450726F70657274793A20224469616772616D456C656D656E742D6F776E6564456C656D656E74222C0A0909090969734D616E793A20747275650A0909097D0A09095D0A097D2C0A097B0A0909';
wwv_flow_imp.g_varchar2_table(6319) := '6E616D653A20224C6162656C656445646765222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A205B0A0909092245646765220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D';
wwv_flow_imp.g_varchar2_table(6320) := '653A20226F776E65644C6162656C222C0A09090909747970653A20224C6162656C222C0A090909096973526561644F6E6C793A20747275652C0A0909090973756273657474656450726F70657274793A20224469616772616D456C656D656E742D6F776E';
wwv_flow_imp.g_varchar2_table(6321) := '6564456C656D656E74222C0A0909090969734D616E793A20747275652C0A0909090969735669727475616C3A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224C6162656C65645368617065222C0A09096973416273747261';
wwv_flow_imp.g_varchar2_table(6322) := '63743A20747275652C0A09097375706572436C6173733A205B0A090909225368617065220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226F776E65644C6162656C222C0A09090909747970653A20224C61';
wwv_flow_imp.g_varchar2_table(6323) := '62656C222C0A090909096973526561644F6E6C793A20747275652C0A0909090973756273657474656450726F70657274793A20224469616772616D456C656D656E742D6F776E6564456C656D656E74222C0A0909090969734D616E793A20747275652C0A';
wwv_flow_imp.g_varchar2_table(6324) := '0909090969735669727475616C3A20747275650A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20224C6162656C222C0A0909697341627374726163743A20747275652C0A09097375706572436C6173733A205B0A090909224E6F6465220A09';
wwv_flow_imp.g_varchar2_table(6325) := '095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022626F756E6473222C0A09090909747970653A202264633A426F756E6473220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A20225374796C65222C0A';
wwv_flow_imp.g_varchar2_table(6326) := '0909697341627374726163743A20747275652C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20226964222C0A090909096973417474723A20747275652C0A09090909697349643A20747275652C0A09090909747970653A';
wwv_flow_imp.g_varchar2_table(6327) := '2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022457874656E73696F6E222C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A202276616C756573222C0A0909090969734D616E793A20';
wwv_flow_imp.g_varchar2_table(6328) := '747275652C0A09090909747970653A2022456C656D656E74220A0909097D0A09095D0A097D0A5D3B0A766172206173736F63696174696F6E732432203D205B0A5D3B0A76617220786D6C203D207B0A09746167416C6961733A20226C6F77657243617365';
wwv_flow_imp.g_varchar2_table(6329) := '220A7D3B0A7661722044695061636B616765203D207B0A096E616D653A206E616D6524322C0A097572693A2075726924322C0A097072656669783A2070726566697824322C0A0974797065733A20747970657324322C0A096173736F63696174696F6E73';
wwv_flow_imp.g_varchar2_table(6330) := '3A206173736F63696174696F6E7324322C0A09786D6C3A20786D6C0A7D3B0A0A766172206E616D652431203D202262706D6E2E696F20636F6C6F727320666F722042504D4E223B0A766172207572692431203D2022687474703A2F2F62706D6E2E696F2F';
wwv_flow_imp.g_varchar2_table(6331) := '736368656D612F62706D6E2F62696F636F6C6F722F312E30223B0A766172207072656669782431203D202262696F63223B0A7661722074797065732431203D205B0A097B0A09096E616D653A2022436F6C6F7265645368617065222C0A09092265787465';
wwv_flow_imp.g_varchar2_table(6332) := '6E6473223A205B0A0909092262706D6E64693A42504D4E5368617065220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20227374726F6B65222C0A090909096973417474723A20747275652C0A090909097479';
wwv_flow_imp.g_varchar2_table(6333) := '70653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A202266696C6C222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D';
wwv_flow_imp.g_varchar2_table(6334) := '653A2022436F6C6F72656445646765222C0A090922657874656E6473223A205B0A0909092262706D6E64693A42504D4E45646765220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A20227374726F6B65222C0A';
wwv_flow_imp.g_varchar2_table(6335) := '090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A202266696C6C222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E';
wwv_flow_imp.g_varchar2_table(6336) := '67220A0909097D0A09095D0A097D0A5D3B0A76617220656E756D65726174696F6E732431203D205B0A5D3B0A766172206173736F63696174696F6E732431203D205B0A5D3B0A7661722042696F635061636B616765203D207B0A096E616D653A206E616D';
wwv_flow_imp.g_varchar2_table(6337) := '6524312C0A097572693A2075726924312C0A097072656669783A2070726566697824312C0A0974797065733A20747970657324312C0A09656E756D65726174696F6E733A20656E756D65726174696F6E7324312C0A096173736F63696174696F6E733A20';
wwv_flow_imp.g_varchar2_table(6338) := '6173736F63696174696F6E7324310A7D3B0A0A766172206E616D65203D202242504D4E20696E20436F6C6F72223B0A76617220757269203D2022687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F6E6F6E2D6E6F726D6174697665';
wwv_flow_imp.g_varchar2_table(6339) := '2F636F6C6F722F312E30223B0A76617220707265666978203D2022636F6C6F72223B0A766172207479706573203D205B0A097B0A09096E616D653A2022436F6C6F7265644C6162656C222C0A090922657874656E6473223A205B0A0909092262706D6E64';
wwv_flow_imp.g_varchar2_table(6340) := '693A42504D4E4C6162656C220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022636F6C6F72222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A';
wwv_flow_imp.g_varchar2_table(6341) := '09095D0A097D2C0A097B0A09096E616D653A2022436F6C6F7265645368617065222C0A090922657874656E6473223A205B0A0909092262706D6E64693A42504D4E5368617065220A09095D2C0A090970726F706572746965733A205B0A0909097B0A0909';
wwv_flow_imp.g_varchar2_table(6342) := '09096E616D653A20226261636B67726F756E642D636F6C6F72222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D2C0A0909097B0A090909096E616D653A2022626F726465722D636F6C6F7222';
wwv_flow_imp.g_varchar2_table(6343) := '2C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E67220A0909097D0A09095D0A097D2C0A097B0A09096E616D653A2022436F6C6F72656445646765222C0A090922657874656E6473223A205B0A0909092262706D';
wwv_flow_imp.g_varchar2_table(6344) := '6E64693A42504D4E45646765220A09095D2C0A090970726F706572746965733A205B0A0909097B0A090909096E616D653A2022626F726465722D636F6C6F72222C0A090909096973417474723A20747275652C0A09090909747970653A2022537472696E';
wwv_flow_imp.g_varchar2_table(6345) := '67220A0909097D0A09095D0A097D0A5D3B0A76617220656E756D65726174696F6E73203D205B0A5D3B0A766172206173736F63696174696F6E73203D205B0A5D3B0A7661722042706D6E496E436F6C6F725061636B616765203D207B0A096E616D653A20';
wwv_flow_imp.g_varchar2_table(6346) := '6E616D652C0A097572693A207572692C0A097072656669783A207072656669782C0A0974797065733A2074797065732C0A09656E756D65726174696F6E733A20656E756D65726174696F6E732C0A096173736F63696174696F6E733A206173736F636961';
wwv_flow_imp.g_varchar2_table(6347) := '74696F6E730A7D3B0A0A766172207061636B61676573203D207B0A202062706D6E3A2042706D6E5061636B6167652C0A202062706D6E64693A2042706D6E44695061636B6167652C0A202064633A2044635061636B6167652C0A202064693A2044695061';
wwv_flow_imp.g_varchar2_table(6348) := '636B6167652C0A202062696F633A2042696F635061636B6167652C0A2020636F6C6F723A2042706D6E496E436F6C6F725061636B6167650A7D3B0A0A66756E6374696F6E2073696D706C65286164646974696F6E616C5061636B616765732C206F707469';
wwv_flow_imp.g_varchar2_table(6349) := '6F6E7329207B0A202076617220706B73203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E61737369676E29287B7D2C207061636B616765732C206164646974696F6E616C5061636B61676573';
wwv_flow_imp.g_varchar2_table(6350) := '293B0A0A202072657475726E206E65772042706D6E4D6F64646C6528706B732C206F7074696F6E73293B0A7D0A0A0A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F646964692F646973742F696E6465782E6A73';
wwv_flow_imp.g_varchar2_table(6351) := '223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F646964692F646973742F696E6465782E6A73202A2A2A210A20205C';
wwv_flow_imp.g_varchar2_table(6352) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F5F5F7765627061636B5F6D6F64756C655F5F2C205F5F7765627061636B5F6578';
wwv_flow_imp.g_varchar2_table(6353) := '706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F';
wwv_flow_imp.g_varchar2_table(6354) := '205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020496E6A6563746F723A202829203D3E20282F2A2062696E64696E67202A2F20';
wwv_flow_imp.g_varchar2_table(6355) := '496E6A6563746F72292C0A2F2A206861726D6F6E79206578706F7274202A2F202020616E6E6F746174653A202829203D3E20282F2A2062696E64696E67202A2F20616E6E6F74617465292C0A2F2A206861726D6F6E79206578706F7274202A2F20202070';
wwv_flow_imp.g_varchar2_table(6356) := '61727365416E6E6F746174696F6E733A202829203D3E20282F2A2062696E64696E67202A2F207061727365416E6E6F746174696F6E73290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A636F6E737420434C4153535F5041545445524E';
wwv_flow_imp.g_varchar2_table(6357) := '203D202F5E636C6173735B207B5D2F3B0A0A0A2F2A2A0A202A2040706172616D207B66756E6374696F6E7D20666E0A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206973436C61737328666E29207B0A2020';
wwv_flow_imp.g_varchar2_table(6358) := '72657475726E20434C4153535F5041545445524E2E7465737428666E2E746F537472696E672829293B0A7D0A0A2F2A2A0A202A2040706172616D207B616E797D206F626A0A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E';
wwv_flow_imp.g_varchar2_table(6359) := '6374696F6E2069734172726179286F626A29207B0A202072657475726E2041727261792E69734172726179286F626A293B0A7D0A0A2F2A2A0A202A2040706172616D207B616E797D206F626A0A202A2040706172616D207B737472696E677D2070726F70';
wwv_flow_imp.g_varchar2_table(6360) := '0A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206861734F776E50726F70286F626A2C2070726F7029207B0A202072657475726E204F626A6563742E70726F746F747970652E6861734F776E50726F706572';
wwv_flow_imp.g_varchar2_table(6361) := '74792E63616C6C286F626A2C2070726F70293B0A7D0A0A2F2A2A0A202A204074797065646566207B696D706F727428272E2F696E6465782E6A7327292E496E6A656374416E6E6F7461746564207D20496E6A656374416E6E6F74617465640A202A2F0A0A';
wwv_flow_imp.g_varchar2_table(6362) := '2F2A2A0A202A204074656D706C61746520540A202A0A202A2040706172616D73207B5B2E2E2E737472696E675B5D2C20545D207C202E2E2E737472696E675B5D2C20547D20617267730A202A0A202A204072657475726E207B54202620496E6A65637441';
wwv_flow_imp.g_varchar2_table(6363) := '6E6E6F74617465647D0A202A2F0A66756E6374696F6E20616E6E6F74617465282E2E2E6172677329207B0A0A202069662028617267732E6C656E677468203D3D3D2031202626206973417272617928617267735B305D2929207B0A202020206172677320';
wwv_flow_imp.g_varchar2_table(6364) := '3D20617267735B305D3B0A20207D0A0A202061726773203D205B202E2E2E61726773205D3B0A0A2020636F6E737420666E203D20617267732E706F7028293B0A0A2020666E2E24696E6A656374203D20617267733B0A0A202072657475726E20666E3B0A';
wwv_flow_imp.g_varchar2_table(6365) := '7D0A0A0A2F2F2043757272656E74206C696D69746174696F6E733A0A2F2F202D2063616E27742070757420696E746F202266756E6374696F6E206172672220636F6D6D656E74730A2F2F2066756E6374696F6E202F2A20286E6F20706172656E74686573';
wwv_flow_imp.g_varchar2_table(6366) := '6973206C696B65207468697329202A2F2028297B7D0A2F2F2066756E6374696F6E2061626328202F2A20787820286E6F20706172656E746865736973206C696B65207468697329202A2F20612C206229207B7D0A2F2F0A2F2F204A757374207075742074';
wwv_flow_imp.g_varchar2_table(6367) := '686520636F6D6D656E74206265666F72652066756E6374696F6E206F7220696E736964653A0A2F2F202F2A20282828746869732069732066696E65292929202A2F2066756E6374696F6E28612C206229207B7D0A2F2F2066756E6374696F6E2061626328';
wwv_flow_imp.g_varchar2_table(6368) := '6129207B202F2A20282828746869732069732066696E65292929202A2F7D0A2F2F0A2F2F202D2063616E27742072656C6961626C79206175746F2D616E6E6F7461746520636F6E7374727563746F723B207765276C6C206D61746368207468650A2F2F20';
wwv_flow_imp.g_varchar2_table(6369) := '666972737420636F6E7374727563746F72282E2E2E29207061747465726E20666F756E64207768696368206D617920626520746865206F6E650A2F2F206F662061206E657374656420636C6173732C20746F6F2E0A0A636F6E737420434F4E5354525543';
wwv_flow_imp.g_varchar2_table(6370) := '544F525F41524753203D202F636F6E7374727563746F725C732A5B5E285D2A5C285C732A285B5E295D2A295C292F6D3B0A636F6E737420464E5F41524753203D202F5E283F3A6173796E635C732B293F283F3A66756E6374696F6E5C732A5B5E285D2A29';
wwv_flow_imp.g_varchar2_table(6371) := '3F283F3A5C285C732A285B5E295D2A295C297C285C772B29292F6D3B0A636F6E737420464E5F415247203D202F5C2F5C2A285B5E2A5D2A295C2A5C2F2F6D3B0A0A2F2A2A0A202A2040706172616D207B756E6B6E6F776E7D20666E0A202A0A202A204072';
wwv_flow_imp.g_varchar2_table(6372) := '657475726E207B737472696E675B5D7D0A202A2F0A66756E6374696F6E207061727365416E6E6F746174696F6E7328666E29207B0A0A202069662028747970656F6620666E20213D3D202766756E6374696F6E2729207B0A202020207468726F77206E65';
wwv_flow_imp.g_varchar2_table(6373) := '77204572726F72286043616E6E6F7420616E6E6F746174652022247B666E7D222E20457870656374656420612066756E6374696F6E2160293B0A20207D0A0A2020636F6E7374206D61746368203D20666E2E746F537472696E6728292E6D617463682869';
wwv_flow_imp.g_varchar2_table(6374) := '73436C61737328666E29203F20434F4E5354525543544F525F41524753203A20464E5F41524753293B0A0A20202F2F206D617920706172736520636C61737320776974686F757420636F6E7374727563746F720A202069662028216D6174636829207B0A';
wwv_flow_imp.g_varchar2_table(6375) := '2020202072657475726E205B5D3B0A20207D0A0A2020636F6E73742061726773203D206D617463685B315D207C7C206D617463685B325D3B0A0A202072657475726E206172677320262620617267732E73706C697428272C27292E6D617028617267203D';
wwv_flow_imp.g_varchar2_table(6376) := '3E207B0A20202020636F6E7374206172674D61746368203D206172672E6D6174636828464E5F415247293B0A2020202072657475726E20286172674D61746368202626206172674D617463685B315D207C7C20617267292E7472696D28293B0A20207D29';
wwv_flow_imp.g_varchar2_table(6377) := '207C7C205B5D3B0A7D0A0A2F2A2A0A202A204074797065646566207B20696D706F727428272E2F696E6465782E6A7327292E4D6F64756C654465636C61726174696F6E207D204D6F64756C654465636C61726174696F6E0A202A20407479706564656620';
wwv_flow_imp.g_varchar2_table(6378) := '7B20696D706F727428272E2F696E6465782E6A7327292E4D6F64756C65446566696E6974696F6E207D204D6F64756C65446566696E6974696F6E0A202A204074797065646566207B20696D706F727428272E2F696E6465782E6A7327292E496E6A656374';
wwv_flow_imp.g_varchar2_table(6379) := '6F72436F6E74657874207D20496E6A6563746F72436F6E746578740A202A0A202A204074797065646566207B20696D706F727428272E2F696E6465782E6A7327292E54797065644465636C61726174696F6E3C616E792C20616E793E207D205479706564';
wwv_flow_imp.g_varchar2_table(6380) := '4465636C61726174696F6E0A202A2F0A0A2F2A2A0A202A204372656174652061206E657720696E6A6563746F7220776974682074686520676976656E206D6F64756C65732E0A202A0A202A2040706172616D207B4D6F64756C65446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(6381) := '5B5D7D206D6F64756C65730A202A2040706172616D207B496E6A6563746F72436F6E746578747D205B5F706172656E745D0A202A2F0A66756E6374696F6E20496E6A6563746F72286D6F64756C65732C205F706172656E7429207B0A0A2020636F6E7374';
wwv_flow_imp.g_varchar2_table(6382) := '20706172656E74203D205F706172656E74207C7C202F2A2A20407479706520496E6A6563746F72436F6E74657874202A2F20287B0A202020206765743A2066756E6374696F6E286E616D652C2073747269637429207B0A20202020202063757272656E74';
wwv_flow_imp.g_varchar2_table(6383) := '6C795265736F6C76696E672E70757368286E616D65293B0A0A20202020202069662028737472696374203D3D3D2066616C736529207B0A202020202020202072657475726E206E756C6C3B0A2020202020207D20656C7365207B0A202020202020202074';
wwv_flow_imp.g_varchar2_table(6384) := '68726F77206572726F7228604E6F2070726F766964657220666F722022247B206E616D65207D222160293B0A2020202020207D0A202020207D0A20207D293B0A0A2020636F6E73742063757272656E746C795265736F6C76696E67203D205B5D3B0A2020';
wwv_flow_imp.g_varchar2_table(6385) := '636F6E73742070726F766964657273203D20746869732E5F70726F766964657273203D204F626A6563742E63726561746528706172656E742E5F70726F766964657273207C7C206E756C6C293B0A2020636F6E737420696E7374616E636573203D207468';
wwv_flow_imp.g_varchar2_table(6386) := '69732E5F696E7374616E636573203D204F626A6563742E637265617465286E756C6C293B0A0A2020636F6E73742073656C66203D20696E7374616E6365732E696E6A6563746F72203D20746869733B0A0A2020636F6E7374206572726F72203D2066756E';
wwv_flow_imp.g_varchar2_table(6387) := '6374696F6E286D736729207B0A20202020636F6E737420737461636B203D2063757272656E746C795265736F6C76696E672E6A6F696E2827202D3E2027293B0A2020202063757272656E746C795265736F6C76696E672E6C656E677468203D20303B0A20';
wwv_flow_imp.g_varchar2_table(6388) := '20202072657475726E206E6577204572726F7228737461636B203F2060247B206D7367207D20285265736F6C76696E673A20247B20737461636B207D2960203A206D7367293B0A20207D3B0A0A20202F2A2A0A2020202A2052657475726E2061206E616D';
wwv_flow_imp.g_varchar2_table(6389) := '656420736572766963652E0A2020202A0A2020202A2040706172616D207B737472696E677D206E616D650A2020202A2040706172616D207B626F6F6C65616E7D205B7374726963743D747275655D2069662066616C73652C207265736F6C7665206D6973';
wwv_flow_imp.g_varchar2_table(6390) := '73696E6720736572766963657320746F206E756C6C0A2020202A0A2020202A204072657475726E207B616E797D0A2020202A2F0A202066756E6374696F6E20676574286E616D652C2073747269637429207B0A20202020696620282170726F7669646572';
wwv_flow_imp.g_varchar2_table(6391) := '735B6E616D655D202626206E616D652E696E636C7564657328272E272929207B0A0A202020202020636F6E7374207061727473203D206E616D652E73706C697428272E27293B0A2020202020206C6574207069766F74203D20676574282F2A2A20407479';
wwv_flow_imp.g_varchar2_table(6392) := '7065207B20737472696E67207D202A2F202870617274732E7368696674282929293B0A0A2020202020207768696C65202870617274732E6C656E67746829207B0A20202020202020207069766F74203D207069766F745B2F2A2A204074797065207B2073';
wwv_flow_imp.g_varchar2_table(6393) := '7472696E67207D202A2F202870617274732E73686966742829295D3B0A2020202020207D0A0A20202020202072657475726E207069766F743B0A202020207D0A0A20202020696620286861734F776E50726F7028696E7374616E6365732C206E616D6529';
wwv_flow_imp.g_varchar2_table(6394) := '29207B0A20202020202072657475726E20696E7374616E6365735B6E616D655D3B0A202020207D0A0A20202020696620286861734F776E50726F702870726F7669646572732C206E616D652929207B0A2020202020206966202863757272656E746C7952';
wwv_flow_imp.g_varchar2_table(6395) := '65736F6C76696E672E696E6465784F66286E616D652920213D3D202D3129207B0A202020202020202063757272656E746C795265736F6C76696E672E70757368286E616D65293B0A20202020202020207468726F77206572726F72282743616E6E6F7420';
wwv_flow_imp.g_varchar2_table(6396) := '7265736F6C76652063697263756C617220646570656E64656E63792127293B0A2020202020207D0A0A20202020202063757272656E746C795265736F6C76696E672E70757368286E616D65293B0A202020202020696E7374616E6365735B6E616D655D20';
wwv_flow_imp.g_varchar2_table(6397) := '3D2070726F7669646572735B6E616D655D5B305D2870726F7669646572735B6E616D655D5B315D293B0A20202020202063757272656E746C795265736F6C76696E672E706F7028293B0A0A20202020202072657475726E20696E7374616E6365735B6E61';
wwv_flow_imp.g_varchar2_table(6398) := '6D655D3B0A202020207D0A0A2020202072657475726E20706172656E742E676574286E616D652C20737472696374293B0A20207D0A0A202066756E6374696F6E20666E44656628666E2C206C6F63616C7329207B0A0A2020202069662028747970656F66';
wwv_flow_imp.g_varchar2_table(6399) := '206C6F63616C73203D3D3D2027756E646566696E65642729207B0A2020202020206C6F63616C73203D207B7D3B0A202020207D0A0A2020202069662028747970656F6620666E20213D3D202766756E6374696F6E2729207B0A2020202020206966202869';
wwv_flow_imp.g_varchar2_table(6400) := '73417272617928666E2929207B0A2020202020202020666E203D20616E6E6F7461746528666E2E736C6963652829293B0A2020202020207D20656C7365207B0A20202020202020207468726F77206572726F72286043616E6E6F7420696E766F6B652022';
wwv_flow_imp.g_varchar2_table(6401) := '247B20666E207D222E20457870656374656420612066756E6374696F6E2160293B0A2020202020207D0A202020207D0A0A202020202F2A2A0A20202020202A204074797065207B737472696E675B5D7D0A20202020202A2F0A20202020636F6E73742069';
wwv_flow_imp.g_varchar2_table(6402) := '6E6A656374203D20666E2E24696E6A656374207C7C207061727365416E6E6F746174696F6E7328666E293B0A20202020636F6E737420646570656E64656E63696573203D20696E6A6563742E6D617028646570203D3E207B0A2020202020206966202868';
wwv_flow_imp.g_varchar2_table(6403) := '61734F776E50726F70286C6F63616C732C206465702929207B0A202020202020202072657475726E206C6F63616C735B6465705D3B0A2020202020207D20656C7365207B0A202020202020202072657475726E2067657428646570293B0A202020202020';
wwv_flow_imp.g_varchar2_table(6404) := '7D0A202020207D293B0A0A2020202072657475726E207B0A202020202020666E3A20666E2C0A202020202020646570656E64656E636965730A202020207D3B0A20207D0A0A20202F2A2A0A2020202A20496E7374616E7469617465207468652067697665';
wwv_flow_imp.g_varchar2_table(6405) := '6E20747970652C20696E6A656374696E6720646570656E64656E636965732E0A2020202A0A2020202A204074656D706C61746520540A2020202A0A2020202A2040706172616D207B2046756E6374696F6E207C205B2E2E2E737472696E675B5D2C204675';
wwv_flow_imp.g_varchar2_table(6406) := '6E6374696F6E205D7D20747970650A2020202A0A2020202A204072657475726E20540A2020202A2F0A202066756E6374696F6E20696E7374616E7469617465287479706529207B0A20202020636F6E7374207B0A202020202020666E2C0A202020202020';
wwv_flow_imp.g_varchar2_table(6407) := '646570656E64656E636965730A202020207D203D20666E4465662874797065293B0A0A202020202F2F20696E7374616E746961746520766172206172677320636F6E7374727563746F720A20202020636F6E737420436F6E7374727563746F72203D2046';
wwv_flow_imp.g_varchar2_table(6408) := '756E6374696F6E2E70726F746F747970652E62696E642E63616C6C28666E2C206E756C6C2C202E2E2E646570656E64656E63696573293B0A0A2020202072657475726E206E657720436F6E7374727563746F7228293B0A20207D0A0A20202F2A2A0A2020';
wwv_flow_imp.g_varchar2_table(6409) := '202A20496E766F6B652074686520676976656E2066756E6374696F6E2C20696E6A656374696E6720646570656E64656E636965732E2052657475726E2074686520726573756C742E0A2020202A0A2020202A204074656D706C61746520540A2020202A0A';
wwv_flow_imp.g_varchar2_table(6410) := '2020202A2040706172616D207B2046756E6374696F6E207C205B2E2E2E737472696E675B5D2C2046756E6374696F6E205D7D2066756E630A2020202A2040706172616D207B204F626A656374207D205B636F6E746578745D0A2020202A2040706172616D';
wwv_flow_imp.g_varchar2_table(6411) := '207B204F626A656374207D205B6C6F63616C735D0A2020202A0A2020202A204072657475726E207B547D20696E766F636174696F6E20726573756C740A2020202A2F0A202066756E6374696F6E20696E766F6B652866756E632C20636F6E746578742C20';
wwv_flow_imp.g_varchar2_table(6412) := '6C6F63616C7329207B0A20202020636F6E7374207B0A202020202020666E2C0A202020202020646570656E64656E636965730A202020207D203D20666E4465662866756E632C206C6F63616C73293B0A0A2020202072657475726E20666E2E6170706C79';
wwv_flow_imp.g_varchar2_table(6413) := '28636F6E746578742C20646570656E64656E63696573293B0A20207D0A0A20202F2A2A0A2020202A2040706172616D207B496E6A6563746F727D206368696C64496E6A6563746F720A2020202A0A2020202A204072657475726E207B46756E6374696F6E';
wwv_flow_imp.g_varchar2_table(6414) := '7D0A2020202A2F0A202066756E6374696F6E2063726561746550726976617465496E6A6563746F72466163746F7279286368696C64496E6A6563746F7229207B0A2020202072657475726E20616E6E6F74617465286B6579203D3E206368696C64496E6A';
wwv_flow_imp.g_varchar2_table(6415) := '6563746F722E676574286B657929293B0A20207D0A0A20202F2A2A0A2020202A2040706172616D207B4D6F64756C65446566696E6974696F6E5B5D7D206D6F64756C65730A2020202A2040706172616D207B737472696E675B5D7D205B666F7263654E65';
wwv_flow_imp.g_varchar2_table(6416) := '77496E7374616E6365735D0A2020202A0A2020202A204072657475726E207B496E6A6563746F727D0A2020202A2F0A202066756E6374696F6E206372656174654368696C64286D6F64756C65732C20666F7263654E6577496E7374616E63657329207B0A';
wwv_flow_imp.g_varchar2_table(6417) := '2020202069662028666F7263654E6577496E7374616E63657320262620666F7263654E6577496E7374616E6365732E6C656E67746829207B0A202020202020636F6E73742066726F6D506172656E744D6F64756C65203D204F626A6563742E6372656174';
wwv_flow_imp.g_varchar2_table(6418) := '65286E756C6C293B0A202020202020636F6E7374206D61746368656453636F706573203D204F626A6563742E637265617465286E756C6C293B0A0A202020202020636F6E73742070726976617465496E6A6563746F72734361636865203D205B5D3B0A20';
wwv_flow_imp.g_varchar2_table(6419) := '2020202020636F6E737420707269766174654368696C64496E6A6563746F7273203D205B5D3B0A202020202020636F6E737420707269766174654368696C64466163746F72696573203D205B5D3B0A0A2020202020206C65742070726F76696465723B0A';
wwv_flow_imp.g_varchar2_table(6420) := '2020202020206C65742063616368654964783B0A2020202020206C657420707269766174654368696C64496E6A6563746F723B0A2020202020206C657420707269766174654368696C64496E6A6563746F72466163746F72793B0A0A202020202020666F';
wwv_flow_imp.g_varchar2_table(6421) := '7220286C6574206E616D6520696E2070726F76696465727329207B0A202020202020202070726F7669646572203D2070726F7669646572735B6E616D655D3B0A0A202020202020202069662028666F7263654E6577496E7374616E6365732E696E646578';
wwv_flow_imp.g_varchar2_table(6422) := '4F66286E616D652920213D3D202D3129207B0A202020202020202020206966202870726F76696465725B325D203D3D3D2027707269766174652729207B0A2020202020202020202020206361636865496478203D2070726976617465496E6A6563746F72';
wwv_flow_imp.g_varchar2_table(6423) := '7343616368652E696E6465784F662870726F76696465725B335D293B0A202020202020202020202020696620286361636865496478203D3D3D202D3129207B0A2020202020202020202020202020707269766174654368696C64496E6A6563746F72203D';
wwv_flow_imp.g_varchar2_table(6424) := '2070726F76696465725B335D2E6372656174654368696C64285B5D2C20666F7263654E6577496E7374616E636573293B0A2020202020202020202020202020707269766174654368696C64496E6A6563746F72466163746F7279203D2063726561746550';
wwv_flow_imp.g_varchar2_table(6425) := '726976617465496E6A6563746F72466163746F727928707269766174654368696C64496E6A6563746F72293B0A202020202020202020202020202070726976617465496E6A6563746F727343616368652E707573682870726F76696465725B335D293B0A';
wwv_flow_imp.g_varchar2_table(6426) := '2020202020202020202020202020707269766174654368696C64496E6A6563746F72732E7075736828707269766174654368696C64496E6A6563746F72293B0A2020202020202020202020202020707269766174654368696C64466163746F726965732E';
wwv_flow_imp.g_varchar2_table(6427) := '7075736828707269766174654368696C64496E6A6563746F72466163746F7279293B0A202020202020202020202020202066726F6D506172656E744D6F64756C655B6E616D655D203D205B20707269766174654368696C64496E6A6563746F7246616374';
wwv_flow_imp.g_varchar2_table(6428) := '6F72792C206E616D652C202770726976617465272C20707269766174654368696C64496E6A6563746F72205D3B0A2020202020202020202020207D20656C7365207B0A202020202020202020202020202066726F6D506172656E744D6F64756C655B6E61';
wwv_flow_imp.g_varchar2_table(6429) := '6D655D203D205B20707269766174654368696C64466163746F726965735B63616368654964785D2C206E616D652C202770726976617465272C20707269766174654368696C64496E6A6563746F72735B63616368654964785D205D3B0A20202020202020';
wwv_flow_imp.g_varchar2_table(6430) := '20202020207D0A202020202020202020207D20656C7365207B0A20202020202020202020202066726F6D506172656E744D6F64756C655B6E616D655D203D205B2070726F76696465725B325D2C2070726F76696465725B315D205D3B0A20202020202020';
wwv_flow_imp.g_varchar2_table(6431) := '2020207D0A202020202020202020206D61746368656453636F7065735B6E616D655D203D20747275653B0A20202020202020207D0A0A2020202020202020696620282870726F76696465725B325D203D3D3D2027666163746F727927207C7C2070726F76';
wwv_flow_imp.g_varchar2_table(6432) := '696465725B325D203D3D3D20277479706527292026262070726F76696465725B315D2E2473636F706529207B0A202020202020202020202F2A206A7368696E74202D57303833202A2F0A20202020202020202020666F7263654E6577496E7374616E6365';
wwv_flow_imp.g_varchar2_table(6433) := '732E666F72456163682873636F7065203D3E207B0A2020202020202020202020206966202870726F76696465725B315D2E2473636F70652E696E6465784F662873636F70652920213D3D202D3129207B0A202020202020202020202020202066726F6D50';
wwv_flow_imp.g_varchar2_table(6434) := '6172656E744D6F64756C655B6E616D655D203D205B2070726F76696465725B325D2C2070726F76696465725B315D205D3B0A20202020202020202020202020206D61746368656453636F7065735B73636F70655D203D20747275653B0A20202020202020';
wwv_flow_imp.g_varchar2_table(6435) := '20202020207D0A202020202020202020207D293B0A20202020202020207D0A2020202020207D0A0A202020202020666F7263654E6577496E7374616E6365732E666F72456163682873636F7065203D3E207B0A202020202020202069662028216D617463';
wwv_flow_imp.g_varchar2_table(6436) := '68656453636F7065735B73636F70655D29207B0A202020202020202020207468726F77206E6577204572726F7228274E6F2070726F766964657220666F72202227202B2073636F7065202B2027222E2043616E6E6F74207573652070726F766964657220';
wwv_flow_imp.g_varchar2_table(6437) := '66726F6D2074686520706172656E742127293B0A20202020202020207D0A2020202020207D293B0A0A2020202020206D6F64756C65732E756E73686966742866726F6D506172656E744D6F64756C65293B0A202020207D0A0A2020202072657475726E20';
wwv_flow_imp.g_varchar2_table(6438) := '6E657720496E6A6563746F72286D6F64756C65732C2073656C66293B0A20207D0A0A2020636F6E737420666163746F72794D6170203D207B0A20202020666163746F72793A20696E766F6B652C0A20202020747970653A20696E7374616E74696174652C';
wwv_flow_imp.g_varchar2_table(6439) := '0A2020202076616C75653A2066756E6374696F6E2876616C756529207B0A20202020202072657475726E2076616C75653B0A202020207D0A20207D3B0A0A20202F2A2A0A2020202A2040706172616D207B4D6F64756C65446566696E6974696F6E7D206D';
wwv_flow_imp.g_varchar2_table(6440) := '6F64756C65446566696E6974696F6E0A2020202A2040706172616D207B496E6A6563746F727D20696E6A6563746F720A2020202A2F0A202066756E6374696F6E20637265617465496E697469616C697A6572286D6F64756C65446566696E6974696F6E2C';
wwv_flow_imp.g_varchar2_table(6441) := '20696E6A6563746F7229207B0A0A20202020636F6E737420696E697469616C697A657273203D206D6F64756C65446566696E6974696F6E2E5F5F696E69745F5F207C7C205B5D3B0A0A2020202072657475726E2066756E6374696F6E2829207B0A202020';
wwv_flow_imp.g_varchar2_table(6442) := '202020696E697469616C697A6572732E666F724561636828696E697469616C697A6572203D3E207B0A0A20202020202020202F2F2065616765726C79207265736F6C766520636F6D706F6E656E742028666E206F7220737472696E67290A202020202020';
wwv_flow_imp.g_varchar2_table(6443) := '202069662028747970656F6620696E697469616C697A6572203D3D3D2027737472696E672729207B0A20202020202020202020696E6A6563746F722E67657428696E697469616C697A6572293B0A20202020202020207D20656C7365207B0A2020202020';
wwv_flow_imp.g_varchar2_table(6444) := '2020202020696E6A6563746F722E696E766F6B6528696E697469616C697A6572293B0A20202020202020207D0A2020202020207D293B0A202020207D3B0A20207D0A0A20202F2A2A0A2020202A2040706172616D207B4D6F64756C65446566696E697469';
wwv_flow_imp.g_varchar2_table(6445) := '6F6E7D206D6F64756C65446566696E6974696F6E0A2020202A2F0A202066756E6374696F6E206C6F61644D6F64756C65286D6F64756C65446566696E6974696F6E29207B0A0A20202020636F6E7374206D6F64756C654578706F727473203D206D6F6475';
wwv_flow_imp.g_varchar2_table(6446) := '6C65446566696E6974696F6E2E5F5F6578706F7274735F5F3B0A0A202020202F2F2070726976617465206D6F64756C650A20202020696620286D6F64756C654578706F72747329207B0A202020202020636F6E7374206E65737465644D6F64756C657320';
wwv_flow_imp.g_varchar2_table(6447) := '3D206D6F64756C65446566696E6974696F6E2E5F5F6D6F64756C65735F5F3B0A0A202020202020636F6E737420636C6F6E65644D6F64756C65203D204F626A6563742E6B657973286D6F64756C65446566696E6974696F6E292E7265647563652828636C';
wwv_flow_imp.g_varchar2_table(6448) := '6F6E65644D6F64756C652C206B657929203D3E207B0A0A2020202020202020696620286B657920213D3D20275F5F6578706F7274735F5F27202626206B657920213D3D20275F5F6D6F64756C65735F5F27202626206B657920213D3D20275F5F696E6974';
wwv_flow_imp.g_varchar2_table(6449) := '5F5F27202626206B657920213D3D20275F5F646570656E64735F5F2729207B0A20202020202020202020636C6F6E65644D6F64756C655B6B65795D203D206D6F64756C65446566696E6974696F6E5B6B65795D3B0A20202020202020207D0A0A20202020';
wwv_flow_imp.g_varchar2_table(6450) := '2020202072657475726E20636C6F6E65644D6F64756C653B0A2020202020207D2C204F626A6563742E637265617465286E756C6C29293B0A0A202020202020636F6E7374206368696C644D6F64756C6573203D20286E65737465644D6F64756C6573207C';
wwv_flow_imp.g_varchar2_table(6451) := '7C205B5D292E636F6E63617428636C6F6E65644D6F64756C65293B0A0A202020202020636F6E73742070726976617465496E6A6563746F72203D206372656174654368696C64286368696C644D6F64756C6573293B0A202020202020636F6E7374206765';
wwv_flow_imp.g_varchar2_table(6452) := '7446726F6D50726976617465496E6A6563746F72203D20616E6E6F746174652866756E6374696F6E286B657929207B0A202020202020202072657475726E2070726976617465496E6A6563746F722E676574286B6579293B0A2020202020207D293B0A0A';
wwv_flow_imp.g_varchar2_table(6453) := '2020202020206D6F64756C654578706F7274732E666F72456163682866756E6374696F6E286B657929207B0A202020202020202070726F7669646572735B6B65795D203D205B2067657446726F6D50726976617465496E6A6563746F722C206B65792C20';
wwv_flow_imp.g_varchar2_table(6454) := '2770726976617465272C2070726976617465496E6A6563746F72205D3B0A2020202020207D293B0A0A2020202020202F2F20656E73757265206368696C6420696E6A6563746F7220696E697469616C697A65730A202020202020636F6E737420696E6974';
wwv_flow_imp.g_varchar2_table(6455) := '69616C697A657273203D20286D6F64756C65446566696E6974696F6E2E5F5F696E69745F5F207C7C205B5D292E736C69636528293B0A0A202020202020696E697469616C697A6572732E756E73686966742866756E6374696F6E2829207B0A2020202020';
wwv_flow_imp.g_varchar2_table(6456) := '20202070726976617465496E6A6563746F722E696E697428293B0A2020202020207D293B0A0A2020202020206D6F64756C65446566696E6974696F6E203D204F626A6563742E61737369676E287B7D2C206D6F64756C65446566696E6974696F6E2C207B';
wwv_flow_imp.g_varchar2_table(6457) := '0A20202020202020205F5F696E69745F5F3A20696E697469616C697A6572730A2020202020207D293B0A0A20202020202072657475726E20637265617465496E697469616C697A6572286D6F64756C65446566696E6974696F6E2C207072697661746549';
wwv_flow_imp.g_varchar2_table(6458) := '6E6A6563746F72293B0A202020207D0A0A202020202F2F206E6F726D616C206D6F64756C650A202020204F626A6563742E6B657973286D6F64756C65446566696E6974696F6E292E666F72456163682866756E6374696F6E286B657929207B0A0A202020';
wwv_flow_imp.g_varchar2_table(6459) := '202020696620286B6579203D3D3D20275F5F696E69745F5F27207C7C206B6579203D3D3D20275F5F646570656E64735F5F2729207B0A202020202020202072657475726E3B0A2020202020207D0A0A202020202020636F6E737420747970654465636C61';
wwv_flow_imp.g_varchar2_table(6460) := '726174696F6E203D202F2A2A204074797065207B2054797065644465636C61726174696F6E207D202A2F20280A20202020202020206D6F64756C65446566696E6974696F6E5B6B65795D0A202020202020293B0A0A202020202020696620287479706544';
wwv_flow_imp.g_varchar2_table(6461) := '65636C61726174696F6E5B325D203D3D3D2027707269766174652729207B0A202020202020202070726F7669646572735B6B65795D203D20747970654465636C61726174696F6E3B0A202020202020202072657475726E3B0A2020202020207D0A0A2020';
wwv_flow_imp.g_varchar2_table(6462) := '20202020636F6E73742074797065203D20747970654465636C61726174696F6E5B305D3B0A202020202020636F6E73742076616C7565203D20747970654465636C61726174696F6E5B315D3B0A0A20202020202070726F7669646572735B6B65795D203D';
wwv_flow_imp.g_varchar2_table(6463) := '205B20666163746F72794D61705B747970655D2C206172726179556E7772617028747970652C2076616C7565292C2074797065205D3B0A202020207D293B0A0A2020202072657475726E20637265617465496E697469616C697A6572286D6F64756C6544';
wwv_flow_imp.g_varchar2_table(6464) := '6566696E6974696F6E2C2073656C66293B0A20207D0A0A20202F2A2A0A2020202A2040706172616D207B4D6F64756C65446566696E6974696F6E5B5D7D206D6F64756C65446566696E6974696F6E730A2020202A2040706172616D207B4D6F64756C6544';
wwv_flow_imp.g_varchar2_table(6465) := '6566696E6974696F6E7D206D6F64756C65446566696E6974696F6E0A2020202A0A2020202A204072657475726E207B4D6F64756C65446566696E6974696F6E5B5D7D0A2020202A2F0A202066756E6374696F6E207265736F6C7665446570656E64656E63';
wwv_flow_imp.g_varchar2_table(6466) := '696573286D6F64756C65446566696E6974696F6E732C206D6F64756C65446566696E6974696F6E29207B0A0A20202020696620286D6F64756C65446566696E6974696F6E732E696E6465784F66286D6F64756C65446566696E6974696F6E2920213D3D20';
wwv_flow_imp.g_varchar2_table(6467) := '2D3129207B0A20202020202072657475726E206D6F64756C65446566696E6974696F6E733B0A202020207D0A0A202020206D6F64756C65446566696E6974696F6E73203D20286D6F64756C65446566696E6974696F6E2E5F5F646570656E64735F5F207C';
wwv_flow_imp.g_varchar2_table(6468) := '7C205B5D292E726564756365287265736F6C7665446570656E64656E636965732C206D6F64756C65446566696E6974696F6E73293B0A0A20202020696620286D6F64756C65446566696E6974696F6E732E696E6465784F66286D6F64756C65446566696E';
wwv_flow_imp.g_varchar2_table(6469) := '6974696F6E2920213D3D202D3129207B0A20202020202072657475726E206D6F64756C65446566696E6974696F6E733B0A202020207D0A0A2020202072657475726E206D6F64756C65446566696E6974696F6E732E636F6E636174286D6F64756C654465';
wwv_flow_imp.g_varchar2_table(6470) := '66696E6974696F6E293B0A20207D0A0A20202F2A2A0A2020202A2040706172616D207B4D6F64756C65446566696E6974696F6E5B5D7D206D6F64756C65446566696E6974696F6E730A2020202A0A2020202A204072657475726E207B202829203D3E2076';
wwv_flow_imp.g_varchar2_table(6471) := '6F6964207D20696E697469616C697A6572466E0A2020202A2F0A202066756E6374696F6E20626F6F747374726170286D6F64756C65446566696E6974696F6E7329207B0A0A20202020636F6E737420696E697469616C697A657273203D206D6F64756C65';
wwv_flow_imp.g_varchar2_table(6472) := '446566696E6974696F6E730A2020202020202E726564756365287265736F6C7665446570656E64656E636965732C205B5D290A2020202020202E6D6170286C6F61644D6F64756C65293B0A0A202020206C657420696E697469616C697A6564203D206661';
wwv_flow_imp.g_varchar2_table(6473) := '6C73653B0A0A2020202072657475726E2066756E6374696F6E2829207B0A0A20202020202069662028696E697469616C697A656429207B0A202020202020202072657475726E3B0A2020202020207D0A0A202020202020696E697469616C697A6564203D';
wwv_flow_imp.g_varchar2_table(6474) := '20747275653B0A0A202020202020696E697469616C697A6572732E666F724561636828696E697469616C697A6572203D3E20696E697469616C697A65722829293B0A202020207D3B0A20207D0A0A20202F2F207075626C6963204150490A202074686973';
wwv_flow_imp.g_varchar2_table(6475) := '2E676574203D206765743B0A2020746869732E696E766F6B65203D20696E766F6B653B0A2020746869732E696E7374616E7469617465203D20696E7374616E74696174653B0A2020746869732E6372656174654368696C64203D20637265617465436869';
wwv_flow_imp.g_varchar2_table(6476) := '6C643B0A0A20202F2F2073657475700A2020746869732E696E6974203D20626F6F747374726170286D6F64756C6573293B0A7D0A0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A66756E6374696F6E206172726179556E7772';
wwv_flow_imp.g_varchar2_table(6477) := '617028747970652C2076616C756529207B0A2020696620287479706520213D3D202776616C75652720262620697341727261792876616C75652929207B0A2020202076616C7565203D20616E6E6F746174652876616C75652E736C6963652829293B0A20';
wwv_flow_imp.g_varchar2_table(6478) := '207D0A0A202072657475726E2076616C75653B0A7D0A0A0A2F2F2320736F757263654D617070696E6755524C3D696E6465782E6A732E6D61700A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173';
wwv_flow_imp.g_varchar2_table(6479) := '682F646973742F696E6465782E65736D2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F';
wwv_flow_imp.g_varchar2_table(6480) := '6D696E2D646173682F646973742F696E6465782E65736D2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E7573';
wwv_flow_imp.g_varchar2_table(6481) := '65645F7765627061636B5F5F5F7765627061636B5F6D6F64756C655F5F2C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72';
wwv_flow_imp.g_varchar2_table(6482) := '285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E7920';
wwv_flow_imp.g_varchar2_table(6483) := '6578706F7274202A2F20202061737369676E3A202829203D3E20282F2A2062696E64696E67202A2F2061737369676E292C0A2F2A206861726D6F6E79206578706F7274202A2F20202062696E643A202829203D3E20282F2A2062696E64696E67202A2F20';
wwv_flow_imp.g_varchar2_table(6484) := '62696E64292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206465626F756E63653A202829203D3E20282F2A2062696E64696E67202A2F206465626F756E6365292C0A2F2A206861726D6F6E79206578706F7274202A2F202020656E737572';
wwv_flow_imp.g_varchar2_table(6485) := '6541727261793A202829203D3E20282F2A2062696E64696E67202A2F20656E737572654172726179292C0A2F2A206861726D6F6E79206578706F7274202A2F20202065766572793A202829203D3E20282F2A2062696E64696E67202A2F20657665727929';
wwv_flow_imp.g_varchar2_table(6486) := '2C0A2F2A206861726D6F6E79206578706F7274202A2F20202066696C7465723A202829203D3E20282F2A2062696E64696E67202A2F2066696C746572292C0A2F2A206861726D6F6E79206578706F7274202A2F20202066696E643A202829203D3E20282F';
wwv_flow_imp.g_varchar2_table(6487) := '2A2062696E64696E67202A2F2066696E64292C0A2F2A206861726D6F6E79206578706F7274202A2F20202066696E64496E6465783A202829203D3E20282F2A2062696E64696E67202A2F2066696E64496E646578292C0A2F2A206861726D6F6E79206578';
wwv_flow_imp.g_varchar2_table(6488) := '706F7274202A2F202020666C617474656E3A202829203D3E20282F2A2062696E64696E67202A2F20666C617474656E292C0A2F2A206861726D6F6E79206578706F7274202A2F202020666F72456163683A202829203D3E20282F2A2062696E64696E6720';
wwv_flow_imp.g_varchar2_table(6489) := '2A2F20666F7245616368292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206765743A202829203D3E20282F2A2062696E64696E67202A2F20676574292C0A2F2A206861726D6F6E79206578706F7274202A2F20202067726F757042793A20';
wwv_flow_imp.g_varchar2_table(6490) := '2829203D3E20282F2A2062696E64696E67202A2F2067726F75704279292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206861733A202829203D3E20282F2A2062696E64696E67202A2F20686173292C0A2F2A206861726D6F6E7920657870';
wwv_flow_imp.g_varchar2_table(6491) := '6F7274202A2F202020697341727261793A202829203D3E20282F2A2062696E64696E67202A2F2069734172726179292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206973446566696E65643A202829203D3E20282F2A2062696E64696E67';
wwv_flow_imp.g_varchar2_table(6492) := '202A2F206973446566696E6564292C0A2F2A206861726D6F6E79206578706F7274202A2F202020697346756E6374696F6E3A202829203D3E20282F2A2062696E64696E67202A2F20697346756E6374696F6E292C0A2F2A206861726D6F6E79206578706F';
wwv_flow_imp.g_varchar2_table(6493) := '7274202A2F20202069734E696C3A202829203D3E20282F2A2062696E64696E67202A2F2069734E696C292C0A2F2A206861726D6F6E79206578706F7274202A2F20202069734E756D6265723A202829203D3E20282F2A2062696E64696E67202A2F206973';
wwv_flow_imp.g_varchar2_table(6494) := '4E756D626572292C0A2F2A206861726D6F6E79206578706F7274202A2F20202069734F626A6563743A202829203D3E20282F2A2062696E64696E67202A2F2069734F626A656374292C0A2F2A206861726D6F6E79206578706F7274202A2F202020697353';
wwv_flow_imp.g_varchar2_table(6495) := '7472696E673A202829203D3E20282F2A2062696E64696E67202A2F206973537472696E67292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206973556E646566696E65643A202829203D3E20282F2A2062696E64696E67202A2F206973556E';
wwv_flow_imp.g_varchar2_table(6496) := '646566696E6564292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206B6579733A202829203D3E20282F2A2062696E64696E67202A2F206B657973292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206D61703A202829203D3E';
wwv_flow_imp.g_varchar2_table(6497) := '20282F2A2062696E64696E67202A2F206D6170292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206D617463685061747465726E3A202829203D3E20282F2A2062696E64696E67202A2F206D617463685061747465726E292C0A2F2A206861';
wwv_flow_imp.g_varchar2_table(6498) := '726D6F6E79206578706F7274202A2F2020206D657267653A202829203D3E20282F2A2062696E64696E67202A2F206D65726765292C0A2F2A206861726D6F6E79206578706F7274202A2F2020206F6D69743A202829203D3E20282F2A2062696E64696E67';
wwv_flow_imp.g_varchar2_table(6499) := '202A2F206F6D6974292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207069636B3A202829203D3E20282F2A2062696E64696E67202A2F207069636B292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207265647563653A2028';
wwv_flow_imp.g_varchar2_table(6500) := '29203D3E20282F2A2062696E64696E67202A2F20726564756365292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207365743A202829203D3E20282F2A2062696E64696E67202A2F20736574292C0A2F2A206861726D6F6E79206578706F72';
wwv_flow_imp.g_varchar2_table(6501) := '74202A2F20202073697A653A202829203D3E20282F2A2062696E64696E67202A2F2073697A65292C0A2F2A206861726D6F6E79206578706F7274202A2F202020736F6D653A202829203D3E20282F2A2062696E64696E67202A2F20736F6D65292C0A2F2A';
wwv_flow_imp.g_varchar2_table(6502) := '206861726D6F6E79206578706F7274202A2F202020736F727442793A202829203D3E20282F2A2062696E64696E67202A2F20736F72744279292C0A2F2A206861726D6F6E79206578706F7274202A2F2020207468726F74746C653A202829203D3E20282F';
wwv_flow_imp.g_varchar2_table(6503) := '2A2062696E64696E67202A2F207468726F74746C65292C0A2F2A206861726D6F6E79206578706F7274202A2F202020756E696F6E42793A202829203D3E20282F2A2062696E64696E67202A2F20756E696F6E4279292C0A2F2A206861726D6F6E79206578';
wwv_flow_imp.g_varchar2_table(6504) := '706F7274202A2F202020756E6971756542793A202829203D3E20282F2A2062696E64696E67202A2F20756E697175654279292C0A2F2A206861726D6F6E79206578706F7274202A2F20202076616C7565733A202829203D3E20282F2A2062696E64696E67';
wwv_flow_imp.g_varchar2_table(6505) := '202A2F2076616C756573292C0A2F2A206861726D6F6E79206578706F7274202A2F202020776974686F75743A202829203D3E20282F2A2062696E64696E67202A2F20776974686F7574290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A';
wwv_flow_imp.g_varchar2_table(6506) := '2F2A2A0A202A20466C617474656E2061727261792C206F6E65206C6576656C20646565702E0A202A0A202A204074656D706C61746520540A202A0A202A2040706172616D207B545B5D5B5D207C20545B5D207C206E756C6C7D205B6172725D0A202A0A20';
wwv_flow_imp.g_varchar2_table(6507) := '2A204072657475726E207B545B5D7D0A202A2F0A66756E6374696F6E20666C617474656E2861727229207B0A202072657475726E2041727261792E70726F746F747970652E636F6E6361742E6170706C79285B5D2C20617272293B0A7D0A0A636F6E7374';
wwv_flow_imp.g_varchar2_table(6508) := '206E6174697665546F537472696E67203D204F626A6563742E70726F746F747970652E746F537472696E673B0A636F6E7374206E61746976654861734F776E50726F7065727479203D204F626A6563742E70726F746F747970652E6861734F776E50726F';
wwv_flow_imp.g_varchar2_table(6509) := '70657274793B0A0A66756E6374696F6E206973556E646566696E6564286F626A29207B0A202072657475726E206F626A203D3D3D20756E646566696E65643B0A7D0A0A66756E6374696F6E206973446566696E6564286F626A29207B0A20207265747572';
wwv_flow_imp.g_varchar2_table(6510) := '6E206F626A20213D3D20756E646566696E65643B0A7D0A0A66756E6374696F6E2069734E696C286F626A29207B0A202072657475726E206F626A203D3D206E756C6C3B0A7D0A0A66756E6374696F6E2069734172726179286F626A29207B0A2020726574';
wwv_flow_imp.g_varchar2_table(6511) := '75726E206E6174697665546F537472696E672E63616C6C286F626A29203D3D3D20275B6F626A6563742041727261795D273B0A7D0A0A66756E6374696F6E2069734F626A656374286F626A29207B0A202072657475726E206E6174697665546F53747269';
wwv_flow_imp.g_varchar2_table(6512) := '6E672E63616C6C286F626A29203D3D3D20275B6F626A656374204F626A6563745D273B0A7D0A0A66756E6374696F6E2069734E756D626572286F626A29207B0A202072657475726E206E6174697665546F537472696E672E63616C6C286F626A29203D3D';
wwv_flow_imp.g_varchar2_table(6513) := '3D20275B6F626A656374204E756D6265725D273B0A7D0A0A2F2A2A0A202A2040706172616D207B616E797D206F626A0A202A0A202A204072657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E20697346756E6374696F6E286F626A29';
wwv_flow_imp.g_varchar2_table(6514) := '207B0A2020636F6E737420746167203D206E6174697665546F537472696E672E63616C6C286F626A293B0A0A202072657475726E20280A20202020746167203D3D3D20275B6F626A6563742046756E6374696F6E5D27207C7C0A20202020746167203D3D';
wwv_flow_imp.g_varchar2_table(6515) := '3D20275B6F626A656374204173796E6346756E6374696F6E5D27207C7C0A20202020746167203D3D3D20275B6F626A6563742047656E657261746F7246756E6374696F6E5D27207C7C0A20202020746167203D3D3D20275B6F626A656374204173796E63';
wwv_flow_imp.g_varchar2_table(6516) := '47656E657261746F7246756E6374696F6E5D27207C7C0A20202020746167203D3D3D20275B6F626A6563742050726F78795D270A2020293B0A7D0A0A66756E6374696F6E206973537472696E67286F626A29207B0A202072657475726E206E6174697665';
wwv_flow_imp.g_varchar2_table(6517) := '546F537472696E672E63616C6C286F626A29203D3D3D20275B6F626A65637420537472696E675D273B0A7D0A0A0A2F2A2A0A202A20456E7375726520636F6C6C656374696F6E20697320616E2061727261792E0A202A0A202A2040706172616D207B4F62';
wwv_flow_imp.g_varchar2_table(6518) := '6A6563747D206F626A0A202A2F0A66756E6374696F6E20656E737572654172726179286F626A29207B0A0A20206966202869734172726179286F626A2929207B0A2020202072657475726E3B0A20207D0A0A20207468726F77206E6577204572726F7228';
wwv_flow_imp.g_varchar2_table(6519) := '276D75737420737570706C7920617272617927293B0A7D0A0A2F2A2A0A202A2052657475726E20747275652C20696620746172676574206F776E7320612070726F706572747920776974682074686520676976656E206B65792E0A202A0A202A20407061';
wwv_flow_imp.g_varchar2_table(6520) := '72616D207B4F626A6563747D207461726765740A202A2040706172616D207B537472696E677D206B65790A202A0A202A204072657475726E207B426F6F6C65616E7D0A202A2F0A66756E6374696F6E20686173287461726765742C206B657929207B0A20';
wwv_flow_imp.g_varchar2_table(6521) := '2072657475726E206E61746976654861734F776E50726F70657274792E63616C6C287461726765742C206B6579293B0A7D0A0A2F2A2A0A202A204074656D706C61746520540A202A204074797065646566207B20280A202A2020202828653A205429203D';
wwv_flow_imp.g_varchar2_table(6522) := '3E20626F6F6C65616E29207C0A202A2020202828653A20542C206964783A206E756D62657229203D3E20626F6F6C65616E29207C0A202A2020202828653A20542C206B65793A20737472696E6729203D3E20626F6F6C65616E29207C0A202A2020207374';
wwv_flow_imp.g_varchar2_table(6523) := '72696E67207C0A202A2020206E756D6265720A202A2029207D204D6174636865720A202A2F0A0A2F2A2A0A202A204074656D706C61746520540A202A204074656D706C61746520550A202A0A202A204074797065646566207B20280A202A202020282865';
wwv_flow_imp.g_varchar2_table(6524) := '3A205429203D3E205529207C20737472696E67207C206E756D6265720A202A2029207D20457874726163746F720A202A2F0A0A0A2F2A2A0A202A204074656D706C61746520540A202A204074797065646566207B202876616C3A20542C206B65793A2061';
wwv_flow_imp.g_varchar2_table(6525) := '6E7929203D3E20626F6F6C65616E207D204D61746368466E0A202A2F0A0A2F2A2A0A202A204074656D706C61746520540A202A204074797065646566207B20545B5D207D204172726179436F6C6C656374696F6E0A202A2F0A0A2F2A2A0A202A20407465';
wwv_flow_imp.g_varchar2_table(6526) := '6D706C61746520540A202A204074797065646566207B207B205B6B65793A20737472696E675D3A2054207D207D20537472696E674B657956616C7565436F6C6C656374696F6E0A202A2F0A0A2F2A2A0A202A204074656D706C61746520540A202A204074';
wwv_flow_imp.g_varchar2_table(6527) := '797065646566207B207B205B6B65793A206E756D6265725D3A2054207D207D204E756D6265724B657956616C7565436F6C6C656374696F6E0A202A2F0A0A2F2A2A0A202A204074656D706C61746520540A202A204074797065646566207B20537472696E';
wwv_flow_imp.g_varchar2_table(6528) := '674B657956616C7565436F6C6C656374696F6E3C543E207C204E756D6265724B657956616C7565436F6C6C656374696F6E3C543E207D204B657956616C7565436F6C6C656374696F6E0A202A2F0A0A2F2A2A0A202A204074656D706C61746520540A202A';
wwv_flow_imp.g_varchar2_table(6529) := '204074797065646566207B204B657956616C7565436F6C6C656374696F6E3C543E207C204172726179436F6C6C656374696F6E3C543E207D20436F6C6C656374696F6E0A202A2F0A0A2F2A2A0A202A2046696E6420656C656D656E7420696E20636F6C6C';
wwv_flow_imp.g_varchar2_table(6530) := '656374696F6E2E0A202A0A202A204074656D706C61746520540A202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E0A202A2040706172616D207B4D6174636865723C543E7D206D6174636865720A202A0A202A20';
wwv_flow_imp.g_varchar2_table(6531) := '4072657475726E207B4F626A6563747D0A202A2F0A66756E6374696F6E2066696E6428636F6C6C656374696F6E2C206D61746368657229207B0A0A2020636F6E7374206D61746368466E203D20746F4D617463686572286D617463686572293B0A0A2020';
wwv_flow_imp.g_varchar2_table(6532) := '6C6574206D617463683B0A0A2020666F724561636828636F6C6C656374696F6E2C2066756E6374696F6E2876616C2C206B657929207B0A20202020696620286D61746368466E2876616C2C206B65792929207B0A2020202020206D61746368203D207661';
wwv_flow_imp.g_varchar2_table(6533) := '6C3B0A0A20202020202072657475726E2066616C73653B0A202020207D0A20207D293B0A0A202072657475726E206D617463683B0A0A7D0A0A0A2F2A2A0A202A2046696E6420656C656D656E7420696E64657820696E20636F6C6C656374696F6E2E0A20';
wwv_flow_imp.g_varchar2_table(6534) := '2A0A202A204074656D706C61746520540A202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E0A202A2040706172616D207B4D6174636865723C543E7D206D6174636865720A202A0A202A204072657475726E207B';
wwv_flow_imp.g_varchar2_table(6535) := '6E756D6265727D0A202A2F0A66756E6374696F6E2066696E64496E64657828636F6C6C656374696F6E2C206D61746368657229207B0A0A2020636F6E7374206D61746368466E203D20746F4D617463686572286D617463686572293B0A0A20206C657420';
wwv_flow_imp.g_varchar2_table(6536) := '696478203D206973417272617928636F6C6C656374696F6E29203F202D31203A20756E646566696E65643B0A0A2020666F724561636828636F6C6C656374696F6E2C2066756E6374696F6E2876616C2C206B657929207B0A20202020696620286D617463';
wwv_flow_imp.g_varchar2_table(6537) := '68466E2876616C2C206B65792929207B0A202020202020696478203D206B65793B0A0A20202020202072657475726E2066616C73653B0A202020207D0A20207D293B0A0A202072657475726E206964783B0A7D0A0A0A2F2A2A0A202A2046696C74657220';
wwv_flow_imp.g_varchar2_table(6538) := '656C656D656E747320696E20636F6C6C656374696F6E2E0A202A0A202A204074656D706C61746520540A202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E0A202A2040706172616D207B4D6174636865723C543E';
wwv_flow_imp.g_varchar2_table(6539) := '7D206D6174636865720A202A0A202A204072657475726E207B545B5D7D20726573756C740A202A2F0A66756E6374696F6E2066696C74657228636F6C6C656374696F6E2C206D61746368657229207B0A0A2020636F6E7374206D61746368466E203D2074';
wwv_flow_imp.g_varchar2_table(6540) := '6F4D617463686572286D617463686572293B0A0A20206C657420726573756C74203D205B5D3B0A0A2020666F724561636828636F6C6C656374696F6E2C2066756E6374696F6E2876616C2C206B657929207B0A20202020696620286D61746368466E2876';
wwv_flow_imp.g_varchar2_table(6541) := '616C2C206B65792929207B0A202020202020726573756C742E707573682876616C293B0A202020207D0A20207D293B0A0A202072657475726E20726573756C743B0A7D0A0A0A2F2A2A0A202A2049746572617465206F76657220636F6C6C656374696F6E';
wwv_flow_imp.g_varchar2_table(6542) := '3B2072657475726E696E6720736F6D657468696E670A202A20286E6F6E2D756E646566696E6564292077696C6C2073746F7020697465726174696F6E2E0A202A0A202A204074656D706C61746520540A202A2040706172616D207B436F6C6C656374696F';
wwv_flow_imp.g_varchar2_table(6543) := '6E3C543E7D20636F6C6C656374696F6E0A202A2040706172616D207B2028286974656D3A20542C206964783A206E756D62657229203D3E2028626F6F6C65616E7C766F69642929207C2028286974656D3A20542C206B65793A20737472696E6729203D3E';
wwv_flow_imp.g_varchar2_table(6544) := '2028626F6F6C65616E7C766F69642929207D206974657261746F720A202A0A202A204072657475726E207B547D2072657475726E20726573756C7420746861742073746F707065642074686520697465726174696F6E0A202A2F0A66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(6545) := '666F724561636828636F6C6C656374696F6E2C206974657261746F7229207B0A0A20206C65742076616C2C0A202020202020726573756C743B0A0A2020696620286973556E646566696E656428636F6C6C656374696F6E2929207B0A2020202072657475';
wwv_flow_imp.g_varchar2_table(6546) := '726E3B0A20207D0A0A2020636F6E737420636F6E766572744B6579203D206973417272617928636F6C6C656374696F6E29203F20746F4E756D203A206964656E746974793B0A0A2020666F7220286C6574206B657920696E20636F6C6C656374696F6E29';
wwv_flow_imp.g_varchar2_table(6547) := '207B0A0A202020206966202868617328636F6C6C656374696F6E2C206B65792929207B0A20202020202076616C203D20636F6C6C656374696F6E5B6B65795D3B0A0A202020202020726573756C74203D206974657261746F722876616C2C20636F6E7665';
wwv_flow_imp.g_varchar2_table(6548) := '72744B6579286B657929293B0A0A20202020202069662028726573756C74203D3D3D2066616C736529207B0A202020202020202072657475726E2076616C3B0A2020202020207D0A202020207D0A20207D0A7D0A0A2F2A2A0A202A2052657475726E2063';
wwv_flow_imp.g_varchar2_table(6549) := '6F6C6C656374696F6E20776974686F757420656C656D656E742E0A202A0A202A204074656D706C61746520540A202A2040706172616D207B4172726179436F6C6C656374696F6E3C543E7D206172720A202A2040706172616D207B4D6174636865723C54';
wwv_flow_imp.g_varchar2_table(6550) := '3E7D206D6174636865720A202A0A202A204072657475726E207B545B5D7D0A202A2F0A66756E6374696F6E20776974686F7574286172722C206D61746368657229207B0A0A2020696620286973556E646566696E6564286172722929207B0A2020202072';
wwv_flow_imp.g_varchar2_table(6551) := '657475726E205B5D3B0A20207D0A0A2020656E73757265417272617928617272293B0A0A2020636F6E7374206D61746368466E203D20746F4D617463686572286D617463686572293B0A0A202072657475726E206172722E66696C7465722866756E6374';
wwv_flow_imp.g_varchar2_table(6552) := '696F6E28656C2C2069647829207B0A2020202072657475726E20216D61746368466E28656C2C20696478293B0A20207D293B0A0A7D0A0A0A2F2A2A0A202A2052656475636520636F6C6C656374696F6E2C2072657475726E696E6720612073696E676C65';
wwv_flow_imp.g_varchar2_table(6553) := '20726573756C742E0A202A0A202A204074656D706C61746520540A202A204074656D706C61746520560A202A0A202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E0A202A2040706172616D207B28726573756C74';
wwv_flow_imp.g_varchar2_table(6554) := '3A20562C20656E7472793A20542C20696E6465783A20616E7929203D3E20567D206974657261746F720A202A2040706172616D207B567D20726573756C740A202A0A202A204072657475726E207B567D20726573756C742072657475726E65642066726F';
wwv_flow_imp.g_varchar2_table(6555) := '6D206C617374206974657261746F720A202A2F0A66756E6374696F6E2072656475636528636F6C6C656374696F6E2C206974657261746F722C20726573756C7429207B0A0A2020666F724561636828636F6C6C656374696F6E2C2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(6556) := '76616C75652C2069647829207B0A20202020726573756C74203D206974657261746F7228726573756C742C2076616C75652C20696478293B0A20207D293B0A0A202072657475726E20726573756C743B0A7D0A0A0A2F2A2A0A202A2052657475726E2074';
wwv_flow_imp.g_varchar2_table(6557) := '72756520696620657665727920656C656D656E7420696E2074686520636F6C6C656374696F6E0A202A206D617463686573207468652063726974657269612E0A202A0A202A2040706172616D20207B4F626A6563747C41727261797D20636F6C6C656374';
wwv_flow_imp.g_varchar2_table(6558) := '696F6E0A202A2040706172616D20207B46756E6374696F6E7D206D6174636865720A202A0A202A204072657475726E207B426F6F6C65616E7D0A202A2F0A66756E6374696F6E20657665727928636F6C6C656374696F6E2C206D61746368657229207B0A';
wwv_flow_imp.g_varchar2_table(6559) := '0A202072657475726E20212172656475636528636F6C6C656374696F6E2C2066756E6374696F6E286D6174636865732C2076616C2C206B657929207B0A2020202072657475726E206D617463686573202626206D6174636865722876616C2C206B657929';
wwv_flow_imp.g_varchar2_table(6560) := '3B0A20207D2C2074727565293B0A7D0A0A0A2F2A2A0A202A2052657475726E207472756520696620736F6D6520656C656D656E747320696E2074686520636F6C6C656374696F6E0A202A206D61746368207468652063726974657269612E0A202A0A202A';
wwv_flow_imp.g_varchar2_table(6561) := '2040706172616D20207B4F626A6563747C41727261797D20636F6C6C656374696F6E0A202A2040706172616D20207B46756E6374696F6E7D206D6174636865720A202A0A202A204072657475726E207B426F6F6C65616E7D0A202A2F0A66756E6374696F';
wwv_flow_imp.g_varchar2_table(6562) := '6E20736F6D6528636F6C6C656374696F6E2C206D61746368657229207B0A0A202072657475726E20212166696E6428636F6C6C656374696F6E2C206D617463686572293B0A7D0A0A0A2F2A2A0A202A205472616E73666F726D206120636F6C6C65637469';
wwv_flow_imp.g_varchar2_table(6563) := '6F6E20696E746F20616E6F7468657220636F6C6C656374696F6E0A202A20627920706970696E672065616368206D656D626572207468726F7567682074686520676976656E20666E2E0A202A0A202A2040706172616D20207B4F626A6563747C41727261';
wwv_flow_imp.g_varchar2_table(6564) := '797D202020636F6C6C656374696F6E0A202A2040706172616D20207B46756E6374696F6E7D20666E0A202A0A202A204072657475726E207B41727261797D207472616E73666F726D656420636F6C6C656374696F6E0A202A2F0A66756E6374696F6E206D';
wwv_flow_imp.g_varchar2_table(6565) := '617028636F6C6C656374696F6E2C20666E29207B0A0A20206C657420726573756C74203D205B5D3B0A0A2020666F724561636828636F6C6C656374696F6E2C2066756E6374696F6E2876616C2C206B657929207B0A20202020726573756C742E70757368';
wwv_flow_imp.g_varchar2_table(6566) := '28666E2876616C2C206B657929293B0A20207D293B0A0A202072657475726E20726573756C743B0A7D0A0A0A2F2A2A0A202A204765742074686520636F6C6C656374696F6E73206B6579732E0A202A0A202A2040706172616D20207B4F626A6563747C41';
wwv_flow_imp.g_varchar2_table(6567) := '727261797D20636F6C6C656374696F6E0A202A0A202A204072657475726E207B41727261797D0A202A2F0A66756E6374696F6E206B65797328636F6C6C656374696F6E29207B0A202072657475726E20636F6C6C656374696F6E202626204F626A656374';
wwv_flow_imp.g_varchar2_table(6568) := '2E6B65797328636F6C6C656374696F6E29207C7C205B5D3B0A7D0A0A0A2F2A2A0A202A2053686F727468616E6420666F7220606B657973286F292E6C656E677468602E0A202A0A202A2040706172616D20207B4F626A6563747C41727261797D20636F6C';
wwv_flow_imp.g_varchar2_table(6569) := '6C656374696F6E0A202A0A202A204072657475726E207B4E756D6265727D0A202A2F0A66756E6374696F6E2073697A6528636F6C6C656374696F6E29207B0A202072657475726E206B65797328636F6C6C656374696F6E292E6C656E6774683B0A7D0A0A';
wwv_flow_imp.g_varchar2_table(6570) := '0A2F2A2A0A202A20476574207468652076616C75657320696E2074686520636F6C6C656374696F6E2E0A202A0A202A2040706172616D20207B4F626A6563747C41727261797D20636F6C6C656374696F6E0A202A0A202A204072657475726E207B417272';
wwv_flow_imp.g_varchar2_table(6571) := '61797D0A202A2F0A66756E6374696F6E2076616C75657328636F6C6C656374696F6E29207B0A202072657475726E206D617028636F6C6C656374696F6E2C202876616C29203D3E2076616C293B0A7D0A0A0A2F2A2A0A202A2047726F757020636F6C6C65';
wwv_flow_imp.g_varchar2_table(6572) := '6374696F6E206D656D62657273206279206174747269627574652E0A202A0A202A2040706172616D207B4F626A6563747C41727261797D20636F6C6C656374696F6E0A202A2040706172616D207B457874726163746F727D20657874726163746F720A20';
wwv_flow_imp.g_varchar2_table(6573) := '2A0A202A204072657475726E207B4F626A6563747D206D61702077697468207B206174747256616C7565203D3E205B20612C20622C2063205D207D0A202A2F0A66756E6374696F6E2067726F7570427928636F6C6C656374696F6E2C2065787472616374';
wwv_flow_imp.g_varchar2_table(6574) := '6F722C2067726F75706564203D207B7D29207B0A0A2020657874726163746F72203D20746F457874726163746F7228657874726163746F72293B0A0A2020666F724561636828636F6C6C656374696F6E2C2066756E6374696F6E2876616C29207B0A2020';
wwv_flow_imp.g_varchar2_table(6575) := '20206C6574206469736372696D696E61746F72203D20657874726163746F722876616C29207C7C20275F273B0A0A202020206C65742067726F7570203D2067726F757065645B6469736372696D696E61746F725D3B0A0A20202020696620282167726F75';
wwv_flow_imp.g_varchar2_table(6576) := '7029207B0A20202020202067726F7570203D2067726F757065645B6469736372696D696E61746F725D203D205B5D3B0A202020207D0A0A2020202067726F75702E707573682876616C293B0A20207D293B0A0A202072657475726E2067726F757065643B';
wwv_flow_imp.g_varchar2_table(6577) := '0A7D0A0A0A66756E6374696F6E20756E69717565427928657874726163746F722C202E2E2E636F6C6C656374696F6E7329207B0A0A2020657874726163746F72203D20746F457874726163746F7228657874726163746F72293B0A0A20206C6574206772';
wwv_flow_imp.g_varchar2_table(6578) := '6F75706564203D207B7D3B0A0A2020666F724561636828636F6C6C656374696F6E732C20286329203D3E2067726F7570427928632C20657874726163746F722C2067726F7570656429293B0A0A20206C657420726573756C74203D206D61702867726F75';
wwv_flow_imp.g_varchar2_table(6579) := '7065642C2066756E6374696F6E2876616C2C206B657929207B0A2020202072657475726E2076616C5B305D3B0A20207D293B0A0A202072657475726E20726573756C743B0A7D0A0A0A636F6E737420756E696F6E4279203D20756E6971756542793B0A0A';
wwv_flow_imp.g_varchar2_table(6580) := '0A0A2F2A2A0A202A20536F727420636F6C6C656374696F6E2062792063726974657269612E0A202A0A202A204074656D706C61746520540A202A0A202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E0A202A2040';
wwv_flow_imp.g_varchar2_table(6581) := '706172616D207B457874726163746F723C542C206E756D626572207C20737472696E673E7D20657874726163746F720A202A0A202A204072657475726E207B41727261797D0A202A2F0A66756E6374696F6E20736F7274427928636F6C6C656374696F6E';
wwv_flow_imp.g_varchar2_table(6582) := '2C20657874726163746F7229207B0A0A2020657874726163746F72203D20746F457874726163746F7228657874726163746F72293B0A0A20206C657420736F72746564203D205B5D3B0A0A2020666F724561636828636F6C6C656374696F6E2C2066756E';
wwv_flow_imp.g_varchar2_table(6583) := '6374696F6E2876616C75652C206B657929207B0A202020206C65742064697363203D20657874726163746F722876616C75652C206B6579293B0A0A202020206C657420656E747279203D207B0A202020202020643A20646973632C0A202020202020763A';
wwv_flow_imp.g_varchar2_table(6584) := '2076616C75650A202020207D3B0A0A20202020666F72202876617220696478203D20303B20696478203C20736F727465642E6C656E6774683B206964782B2B29207B0A2020202020206C6574207B2064207D203D20736F727465645B6964785D3B0A0A20';
wwv_flow_imp.g_varchar2_table(6585) := '20202020206966202864697363203C206429207B0A2020202020202020736F727465642E73706C696365286964782C20302C20656E747279293B0A202020202020202072657475726E3B0A2020202020207D0A202020207D0A0A202020202F2F206E6F74';
wwv_flow_imp.g_varchar2_table(6586) := '20696E7365727465642C20617070656E64202821290A20202020736F727465642E7075736828656E747279293B0A20207D293B0A0A202072657475726E206D617028736F727465642C20286529203D3E20652E76293B0A7D0A0A0A2F2A2A0A202A204372';
wwv_flow_imp.g_varchar2_table(6587) := '6561746520616E206F626A656374207061747465726E206D6174636865722E0A202A0A202A20406578616D706C650A202A0A202A206060606A6176617363726970740A202A20636F6E7374206D617463686572203D206D617463685061747465726E287B';
wwv_flow_imp.g_varchar2_table(6588) := '2069643A2031207D293B0A202A0A202A206C657420656C656D656E74203D2066696E6428656C656D656E74732C206D617463686572293B0A202A206060600A202A0A202A204074656D706C61746520540A202A0A202A2040706172616D207B547D207061';
wwv_flow_imp.g_varchar2_table(6589) := '747465726E0A202A0A202A204072657475726E207B2028656C3A20616E7929203D3E2020626F6F6C65616E207D206D617463686572466E0A202A2F0A66756E6374696F6E206D617463685061747465726E287061747465726E29207B0A0A202072657475';
wwv_flow_imp.g_varchar2_table(6590) := '726E2066756E6374696F6E28656C29207B0A0A2020202072657475726E206576657279287061747465726E2C2066756E6374696F6E2876616C2C206B657929207B0A20202020202072657475726E20656C5B6B65795D203D3D3D2076616C3B0A20202020';
wwv_flow_imp.g_varchar2_table(6591) := '7D293B0A0A20207D3B0A7D0A0A0A2F2A2A0A202A2040706172616D207B737472696E67207C202828653A20616E7929203D3E20616E7929207D20657874726163746F720A202A0A202A204072657475726E207B2028653A20616E7929203D3E20616E7920';
wwv_flow_imp.g_varchar2_table(6592) := '7D0A202A2F0A66756E6374696F6E20746F457874726163746F7228657874726163746F7229207B0A0A20202F2A2A0A2020202A2040736174697366696573207B2028653A20616E7929203D3E20616E79207D0A2020202A2F0A202072657475726E206973';
wwv_flow_imp.g_varchar2_table(6593) := '46756E6374696F6E28657874726163746F7229203F20657874726163746F72203A20286529203D3E207B0A0A202020202F2F204074732D69676E6F72653A206A75737420776F726B730A2020202072657475726E20655B657874726163746F725D3B0A20';
wwv_flow_imp.g_varchar2_table(6594) := '207D3B0A7D0A0A0A2F2A2A0A202A204074656D706C61746520540A202A2040706172616D207B4D6174636865723C543E7D206D6174636865720A202A0A202A204072657475726E207B4D61746368466E3C543E7D0A202A2F0A66756E6374696F6E20746F';
wwv_flow_imp.g_varchar2_table(6595) := '4D617463686572286D61746368657229207B0A202072657475726E20697346756E6374696F6E286D61746368657229203F206D617463686572203A20286529203D3E207B0A2020202072657475726E2065203D3D3D206D6174636865723B0A20207D3B0A';
wwv_flow_imp.g_varchar2_table(6596) := '7D0A0A0A66756E6374696F6E206964656E746974792861726729207B0A202072657475726E206172673B0A7D0A0A66756E6374696F6E20746F4E756D2861726729207B0A202072657475726E204E756D62657228617267293B0A7D0A0A2F2A20676C6F62';
wwv_flow_imp.g_varchar2_table(6597) := '616C2073657454696D656F757420636C65617254696D656F7574202A2F0A0A2F2A2A0A202A204074797065646566207B207B0A202A202020282E2E2E617267733A20616E795B5D293A20616E793B0A202A202020666C7573683A202829203D3E20766F69';
wwv_flow_imp.g_varchar2_table(6598) := '643B0A202A20202063616E63656C3A202829203D3E20766F69643B0A202A207D207D204465626F756E63656446756E6374696F6E0A202A2F0A0A2F2A2A0A202A204465626F756E636520666E2C2063616C6C696E67206974206F6E6C79206F6E63652069';
wwv_flow_imp.g_varchar2_table(6599) := '662074686520676976656E2074696D650A202A20656C6170736564206265747765656E2063616C6C732E0A202A0A202A204C6F646173682D7374796C65207468652066756E6374696F6E206578706F736573206D6574686F647320746F206023636C6561';
wwv_flow_imp.g_varchar2_table(6600) := '72600A202A20616E64206023666C7573686020746F20636F6E74726F6C20696E7465726E616C206265686176696F722E0A202A0A202A2040706172616D20207B46756E6374696F6E7D20666E0A202A2040706172616D20207B4E756D6265727D2074696D';
wwv_flow_imp.g_varchar2_table(6601) := '656F75740A202A0A202A204072657475726E207B4465626F756E63656446756E6374696F6E7D206465626F756E6365642066756E6374696F6E0A202A2F0A66756E6374696F6E206465626F756E636528666E2C2074696D656F757429207B0A0A20206C65';
wwv_flow_imp.g_varchar2_table(6602) := '742074696D65723B0A0A20206C6574206C617374417267733B0A20206C6574206C617374546869733B0A0A20206C6574206C6173744E6F773B0A0A202066756E6374696F6E206669726528666F72636529207B0A0A202020206C6574206E6F77203D2044';
wwv_flow_imp.g_varchar2_table(6603) := '6174652E6E6F7728293B0A0A202020206C6574207363686564756C656444696666203D20666F726365203F2030203A20286C6173744E6F77202B2074696D656F757429202D206E6F773B0A0A20202020696620287363686564756C656444696666203E20';
wwv_flow_imp.g_varchar2_table(6604) := '3029207B0A20202020202072657475726E207363686564756C65287363686564756C656444696666293B0A202020207D0A0A20202020666E2E6170706C79286C617374546869732C206C61737441726773293B0A0A20202020636C65617228293B0A2020';
wwv_flow_imp.g_varchar2_table(6605) := '7D0A0A202066756E6374696F6E207363686564756C652874696D656F757429207B0A2020202074696D6572203D2073657454696D656F757428666972652C2074696D656F7574293B0A20207D0A0A202066756E6374696F6E20636C6561722829207B0A20';
wwv_flow_imp.g_varchar2_table(6606) := '2020206966202874696D657229207B0A202020202020636C65617254696D656F75742874696D6572293B0A202020207D0A0A2020202074696D6572203D206C6173744E6F77203D206C61737441726773203D206C61737454686973203D20756E64656669';
wwv_flow_imp.g_varchar2_table(6607) := '6E65643B0A20207D0A0A202066756E6374696F6E20666C7573682829207B0A202020206966202874696D657229207B0A202020202020666972652874727565293B0A202020207D0A0A20202020636C65617228293B0A20207D0A0A20202F2A2A0A202020';
wwv_flow_imp.g_varchar2_table(6608) := '2A204074797065207B204465626F756E63656446756E6374696F6E207D0A2020202A2F0A202066756E6374696F6E2063616C6C6261636B282E2E2E6172677329207B0A202020206C6173744E6F77203D20446174652E6E6F7728293B0A0A202020206C61';
wwv_flow_imp.g_varchar2_table(6609) := '737441726773203D20617267733B0A202020206C61737454686973203D20746869733B0A0A202020202F2F20656E7375726520616E20657865637574696F6E206973207363686564756C65640A20202020696620282174696D657229207B0A2020202020';
wwv_flow_imp.g_varchar2_table(6610) := '207363686564756C652874696D656F7574293B0A202020207D0A20207D0A0A202063616C6C6261636B2E666C757368203D20666C7573683B0A202063616C6C6261636B2E63616E63656C203D20636C6561723B0A0A202072657475726E2063616C6C6261';
wwv_flow_imp.g_varchar2_table(6611) := '636B3B0A7D0A0A2F2A2A0A202A205468726F74746C6520666E2C2063616C6C696E67206174206D6F7374206F6E63650A202A20696E2074686520676976656E20696E74657276616C2E0A202A0A202A2040706172616D20207B46756E6374696F6E7D2066';
wwv_flow_imp.g_varchar2_table(6612) := '6E0A202A2040706172616D20207B4E756D6265727D20696E74657276616C0A202A0A202A204072657475726E207B46756E6374696F6E7D207468726F74746C65642066756E6374696F6E0A202A2F0A66756E6374696F6E207468726F74746C6528666E2C';
wwv_flow_imp.g_varchar2_table(6613) := '20696E74657276616C29207B0A20206C6574207468726F74746C696E67203D2066616C73653B0A0A202072657475726E2066756E6374696F6E282E2E2E6172677329207B0A0A20202020696620287468726F74746C696E6729207B0A2020202020207265';
wwv_flow_imp.g_varchar2_table(6614) := '7475726E3B0A202020207D0A0A20202020666E282E2E2E61726773293B0A202020207468726F74746C696E67203D20747275653B0A0A2020202073657454696D656F7574282829203D3E207B0A2020202020207468726F74746C696E67203D2066616C73';
wwv_flow_imp.g_varchar2_table(6615) := '653B0A202020207D2C20696E74657276616C293B0A20207D3B0A7D0A0A2F2A2A0A202A2042696E642066756E6374696F6E20616761696E737420746172676574203C746869733E2E0A202A0A202A2040706172616D20207B46756E6374696F6E7D20666E';
wwv_flow_imp.g_varchar2_table(6616) := '0A202A2040706172616D20207B4F626A6563747D2020207461726765740A202A0A202A204072657475726E207B46756E6374696F6E7D20626F756E642066756E6374696F6E0A202A2F0A66756E6374696F6E2062696E6428666E2C207461726765742920';
wwv_flow_imp.g_varchar2_table(6617) := '7B0A202072657475726E20666E2E62696E6428746172676574293B0A7D0A0A2F2A2A0A202A20436F6E76656E69656E6365207772617070657220666F7220604F626A6563742E61737369676E602E0A202A0A202A2040706172616D207B4F626A6563747D';
wwv_flow_imp.g_varchar2_table(6618) := '207461726765740A202A2040706172616D207B2E2E2E4F626A6563747D206F74686572730A202A0A202A204072657475726E207B4F626A6563747D20746865207461726765740A202A2F0A66756E6374696F6E2061737369676E287461726765742C202E';
wwv_flow_imp.g_varchar2_table(6619) := '2E2E6F746865727329207B0A202072657475726E204F626A6563742E61737369676E287461726765742C202E2E2E6F7468657273293B0A7D0A0A2F2A2A0A202A20536574732061206E65737465642070726F7065727479206F66206120676976656E206F';
wwv_flow_imp.g_varchar2_table(6620) := '626A65637420746F20746865207370656369666965642076616C75652E0A202A0A202A2054686973206D75746174657320746865206F626A65637420616E642072657475726E732069742E0A202A0A202A204074656D706C61746520540A202A0A202A20';
wwv_flow_imp.g_varchar2_table(6621) := '40706172616D207B547D207461726765742054686520746172676574206F662074686520736574206F7065726174696F6E2E0A202A2040706172616D207B28737472696E677C6E756D626572295B5D7D207061746820546865207061746820746F207468';
wwv_flow_imp.g_varchar2_table(6622) := '65206E65737465642076616C75652E0A202A2040706172616D207B616E797D2076616C7565205468652076616C756520746F207365742E0A202A0A202A204072657475726E207B547D0A202A2F0A66756E6374696F6E20736574287461726765742C2070';
wwv_flow_imp.g_varchar2_table(6623) := '6174682C2076616C756529207B0A0A20206C65742063757272656E74546172676574203D207461726765743B0A0A2020666F724561636828706174682C2066756E6374696F6E286B65792C2069647829207B0A0A2020202069662028747970656F66206B';
wwv_flow_imp.g_varchar2_table(6624) := '657920213D3D20276E756D6265722720262620747970656F66206B657920213D3D2027737472696E672729207B0A2020202020207468726F77206E6577204572726F722827696C6C6567616C206B657920747970653A2027202B20747970656F66206B65';
wwv_flow_imp.g_varchar2_table(6625) := '79202B20272E204B65792073686F756C64206265206F662074797065206E756D626572206F7220737472696E672E27293B0A202020207D0A0A20202020696620286B6579203D3D3D2027636F6E7374727563746F722729207B0A2020202020207468726F';
wwv_flow_imp.g_varchar2_table(6626) := '77206E6577204572726F722827696C6C6567616C206B65793A20636F6E7374727563746F7227293B0A202020207D0A0A20202020696620286B6579203D3D3D20275F5F70726F746F5F5F2729207B0A2020202020207468726F77206E6577204572726F72';
wwv_flow_imp.g_varchar2_table(6627) := '2827696C6C6567616C206B65793A205F5F70726F746F5F5F27293B0A202020207D0A0A202020206C6574206E6578744B6579203D20706174685B696478202B20315D3B0A202020206C6574206E657874546172676574203D2063757272656E7454617267';
wwv_flow_imp.g_varchar2_table(6628) := '65745B6B65795D3B0A0A20202020696620286973446566696E6564286E6578744B6579292026262069734E696C286E6578745461726765742929207B0A2020202020206E657874546172676574203D2063757272656E745461726765745B6B65795D203D';
wwv_flow_imp.g_varchar2_table(6629) := '2069734E614E282B6E6578744B657929203F207B7D203A205B5D3B0A202020207D0A0A20202020696620286973556E646566696E6564286E6578744B65792929207B0A202020202020696620286973556E646566696E65642876616C75652929207B0A20';
wwv_flow_imp.g_varchar2_table(6630) := '2020202020202064656C6574652063757272656E745461726765745B6B65795D3B0A2020202020207D20656C7365207B0A202020202020202063757272656E745461726765745B6B65795D203D2076616C75653B0A2020202020207D0A202020207D2065';
wwv_flow_imp.g_varchar2_table(6631) := '6C7365207B0A20202020202063757272656E74546172676574203D206E6578745461726765743B0A202020207D0A20207D293B0A0A202072657475726E207461726765743B0A7D0A0A0A2F2A2A0A202A20476574732061206E65737465642070726F7065';
wwv_flow_imp.g_varchar2_table(6632) := '727479206F66206120676976656E206F626A6563742E0A202A0A202A2040706172616D207B4F626A6563747D207461726765742054686520746172676574206F662074686520676574206F7065726174696F6E2E0A202A2040706172616D207B28737472';
wwv_flow_imp.g_varchar2_table(6633) := '696E677C6E756D626572295B5D7D207061746820546865207061746820746F20746865206E65737465642076616C75652E0A202A2040706172616D207B616E797D205B64656661756C7456616C75655D205468652076616C756520746F2072657475726E';
wwv_flow_imp.g_varchar2_table(6634) := '206966206E6F2076616C7565206578697374732E0A202A0A202A204072657475726E207B616E797D0A202A2F0A66756E6374696F6E20676574287461726765742C20706174682C2064656661756C7456616C756529207B0A0A20206C6574206375727265';
wwv_flow_imp.g_varchar2_table(6635) := '6E74546172676574203D207461726765743B0A0A2020666F724561636828706174682C2066756E6374696F6E286B657929207B0A0A202020202F2F20616363657373696E67206E696C2070726F7065727479207969656C6473203C756E646566696E6564';
wwv_flow_imp.g_varchar2_table(6636) := '3E0A202020206966202869734E696C2863757272656E745461726765742929207B0A20202020202063757272656E74546172676574203D20756E646566696E65643B0A0A20202020202072657475726E2066616C73653B0A202020207D0A0A2020202063';
wwv_flow_imp.g_varchar2_table(6637) := '757272656E74546172676574203D2063757272656E745461726765745B6B65795D3B0A20207D293B0A0A202072657475726E206973556E646566696E65642863757272656E7454617267657429203F2064656661756C7456616C7565203A206375727265';
wwv_flow_imp.g_varchar2_table(6638) := '6E745461726765743B0A7D0A0A2F2A2A0A202A205069636B2070726F706572746965732066726F6D2074686520676976656E207461726765742E0A202A0A202A204074656D706C61746520540A202A204074656D706C617465207B616E795B5D7D20560A';
wwv_flow_imp.g_varchar2_table(6639) := '202A0A202A2040706172616D207B547D207461726765740A202A2040706172616D207B567D2070726F706572746965730A202A0A202A204072657475726E205069636B3C542C20563E0A202A2F0A66756E6374696F6E207069636B287461726765742C20';
wwv_flow_imp.g_varchar2_table(6640) := '70726F7065727469657329207B0A0A20206C657420726573756C74203D207B7D3B0A0A20206C6574206F626A203D204F626A65637428746172676574293B0A0A2020666F72456163682870726F706572746965732C2066756E6374696F6E2870726F7029';
wwv_flow_imp.g_varchar2_table(6641) := '207B0A0A202020206966202870726F7020696E206F626A29207B0A202020202020726573756C745B70726F705D203D207461726765745B70726F705D3B0A202020207D0A20207D293B0A0A202072657475726E20726573756C743B0A7D0A0A2F2A2A0A20';
wwv_flow_imp.g_varchar2_table(6642) := '2A205069636B20616C6C207461726765742070726F706572746965732C206578636C7564696E672074686520676976656E206F6E65732E0A202A0A202A204074656D706C61746520540A202A204074656D706C617465207B616E795B5D7D20560A202A0A';
wwv_flow_imp.g_varchar2_table(6643) := '202A2040706172616D207B547D207461726765740A202A2040706172616D207B567D2070726F706572746965730A202A0A202A204072657475726E207B4F6D69743C542C20563E7D207461726765740A202A2F0A66756E6374696F6E206F6D6974287461';
wwv_flow_imp.g_varchar2_table(6644) := '726765742C2070726F7065727469657329207B0A0A20206C657420726573756C74203D207B7D3B0A0A20206C6574206F626A203D204F626A65637428746172676574293B0A0A2020666F7245616368286F626A2C2066756E6374696F6E2870726F702C20';
wwv_flow_imp.g_varchar2_table(6645) := '6B657929207B0A0A202020206966202870726F706572746965732E696E6465784F66286B657929203D3D3D202D3129207B0A202020202020726573756C745B6B65795D203D2070726F703B0A202020207D0A20207D293B0A0A202072657475726E207265';
wwv_flow_imp.g_varchar2_table(6646) := '73756C743B0A7D0A0A2F2A2A0A202A205265637572736976656C79206D6572676520602E2E2E736F75726365736020696E746F20676976656E207461726765742E0A202A0A202A20446F657320737570706F7274206D657267696E67206F626A65637473';
wwv_flow_imp.g_varchar2_table(6647) := '3B20646F6573206E6F7420737570706F7274206D657267696E67206172726179732E0A202A0A202A2040706172616D207B4F626A6563747D207461726765740A202A2040706172616D207B2E2E2E4F626A6563747D20736F75726365730A202A0A202A20';
wwv_flow_imp.g_varchar2_table(6648) := '4072657475726E207B4F626A6563747D20746865207461726765740A202A2F0A66756E6374696F6E206D65726765287461726765742C202E2E2E736F757263657329207B0A0A20206966202821736F75726365732E6C656E67746829207B0A2020202072';
wwv_flow_imp.g_varchar2_table(6649) := '657475726E207461726765743B0A20207D0A0A2020666F724561636828736F75726365732C2066756E6374696F6E28736F7572636529207B0A0A202020202F2F20736B6970206E6F6E2D6F626A20736F75726365732C20692E652E206E756C6C0A202020';
wwv_flow_imp.g_varchar2_table(6650) := '206966202821736F75726365207C7C202169734F626A65637428736F757263652929207B0A20202020202072657475726E3B0A202020207D0A0A20202020666F724561636828736F757263652C2066756E6374696F6E28736F7572636556616C2C206B65';
wwv_flow_imp.g_varchar2_table(6651) := '7929207B0A0A202020202020696620286B6579203D3D3D20275F5F70726F746F5F5F2729207B0A202020202020202072657475726E3B0A2020202020207D0A0A2020202020206C65742074617267657456616C203D207461726765745B6B65795D3B0A0A';
wwv_flow_imp.g_varchar2_table(6652) := '2020202020206966202869734F626A65637428736F7572636556616C2929207B0A0A2020202020202020696620282169734F626A6563742874617267657456616C2929207B0A0A202020202020202020202F2F206F76657272696465207461726765745B';
wwv_flow_imp.g_varchar2_table(6653) := '6B65795D2077697468206F626A6563740A2020202020202020202074617267657456616C203D207B7D3B0A20202020202020207D0A0A20202020202020207461726765745B6B65795D203D206D657267652874617267657456616C2C20736F7572636556';
wwv_flow_imp.g_varchar2_table(6654) := '616C293B0A2020202020207D20656C7365207B0A20202020202020207461726765745B6B65795D203D20736F7572636556616C3B0A2020202020207D0A0A202020207D293B0A20207D293B0A0A202072657475726E207461726765743B0A7D0A0A0A0A0A';
wwv_flow_imp.g_varchar2_table(6655) := '2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6D6F64646C652D786D6C2F646973742F696E6465782E65736D2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(6656) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6D6F64646C652D786D6C2F646973742F696E6465782E65736D2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(6657) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F5F5F7765627061636B5F6D6F64756C655F5F2C205F5F7765627061636B5F6578706F7274735F5F2C20';
wwv_flow_imp.g_varchar2_table(6658) := '5F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F776562706163';
wwv_flow_imp.g_varchar2_table(6659) := '6B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020205265616465723A202829203D3E20282F2A2062696E64696E67202A2F20526561646572292C0A2F2A';
wwv_flow_imp.g_varchar2_table(6660) := '206861726D6F6E79206578706F7274202A2F2020205772697465723A202829203D3E20282F2A2062696E64696E67202A2F20577269746572290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274';
wwv_flow_imp.g_varchar2_table(6661) := '202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F';
wwv_flow_imp.g_varchar2_table(6662) := '6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F2076617220736178656E5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F776562706163';
wwv_flow_imp.g_varchar2_table(6663) := '6B5F726571756972655F5F282F2A2120736178656E202A2F20222E2F6E6F64655F6D6F64756C65732F736178656E2F646973742F696E6465782E65736D2E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D6F64646C655F';
wwv_flow_imp.g_varchar2_table(6664) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206D6F64646C65202A2F20222E2F6E6F64655F6D6F64756C65732F6D6F64646C652F646973742F696E6465782E65';
wwv_flow_imp.g_varchar2_table(6665) := '736D2E6A7322293B0A0A0A0A0A66756E6374696F6E206861734C6F77657243617365416C69617328706B6729207B0A202072657475726E20706B672E786D6C20262620706B672E786D6C2E746167416C696173203D3D3D20276C6F77657243617365273B';
wwv_flow_imp.g_varchar2_table(6666) := '0A7D0A0A7661722044454641554C545F4E535F4D4150203D207B0A202027787369273A2027687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D612D696E7374616E6365272C0A202027786D6C273A2027687474703A2F2F7777';
wwv_flow_imp.g_varchar2_table(6667) := '772E77332E6F72672F584D4C2F313939382F6E616D657370616365270A7D3B0A0A766172205853495F54595045203D20277873693A74797065273B0A0A66756E6374696F6E2073657269616C697A65466F726D617428656C656D656E7429207B0A202072';
wwv_flow_imp.g_varchar2_table(6668) := '657475726E20656C656D656E742E786D6C20262620656C656D656E742E786D6C2E73657269616C697A653B0A7D0A0A66756E6374696F6E2073657269616C697A6541735479706528656C656D656E7429207B0A202072657475726E2073657269616C697A';
wwv_flow_imp.g_varchar2_table(6669) := '65466F726D617428656C656D656E7429203D3D3D205853495F545950453B0A7D0A0A66756E6374696F6E2073657269616C697A65417350726F706572747928656C656D656E7429207B0A202072657475726E2073657269616C697A65466F726D61742865';
wwv_flow_imp.g_varchar2_table(6670) := '6C656D656E7429203D3D3D202770726F7065727479273B0A7D0A0A66756E6374696F6E206361706974616C697A652873747229207B0A202072657475726E207374722E6368617241742830292E746F5570706572436173652829202B207374722E736C69';
wwv_flow_imp.g_varchar2_table(6671) := '63652831293B0A7D0A0A66756E6374696F6E20616C696173546F4E616D6528616C6961734E732C20706B6729207B0A0A202069662028216861734C6F77657243617365416C69617328706B672929207B0A2020202072657475726E20616C6961734E732E';
wwv_flow_imp.g_varchar2_table(6672) := '6E616D653B0A20207D0A0A202072657475726E20616C6961734E732E707265666978202B20273A27202B206361706974616C697A6528616C6961734E732E6C6F63616C4E616D65293B0A7D0A0A66756E6374696F6E207072656669786564546F4E616D65';
wwv_flow_imp.g_varchar2_table(6673) := '286E616D654E732C20706B6729207B0A0A2020766172206E616D65203D206E616D654E732E6E616D652C0A2020202020206C6F63616C4E616D65203D206E616D654E732E6C6F63616C4E616D653B0A0A20207661722074797065507265666978203D2070';
wwv_flow_imp.g_varchar2_table(6674) := '6B672E786D6C20262620706B672E786D6C2E747970655072656669783B0A0A20206966202874797065507265666978202626206C6F63616C4E616D652E696E6465784F66287479706550726566697829203D3D3D203029207B0A2020202072657475726E';
wwv_flow_imp.g_varchar2_table(6675) := '206E616D654E732E707265666978202B20273A27202B206C6F63616C4E616D652E736C69636528747970655072656669782E6C656E677468293B0A20207D20656C7365207B0A2020202072657475726E206E616D653B0A20207D0A7D0A0A66756E637469';
wwv_flow_imp.g_varchar2_table(6676) := '6F6E206E6F726D616C697A65587369547970654E616D65286E616D652C206D6F64656C29207B0A0A2020766172206E616D654E73203D2028302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E70617273654E';
wwv_flow_imp.g_varchar2_table(6677) := '616D654E5329286E616D65293B0A202076617220706B67203D206D6F64656C2E6765745061636B616765286E616D654E732E707265666978293B0A0A202072657475726E207072656669786564546F4E616D65286E616D654E732C20706B67293B0A7D0A';
wwv_flow_imp.g_varchar2_table(6678) := '0A66756E6374696F6E206572726F72286D65737361676529207B0A202072657475726E206E6577204572726F72286D657373616765293B0A7D0A0A2F2A2A0A202A2047657420746865206D6F64646C652064657363726970746F7220666F722061206769';
wwv_flow_imp.g_varchar2_table(6679) := '76656E20696E7374616E6365206F7220747970652E0A202A0A202A2040706172616D20207B4D6F64646C65456C656D656E747C46756E6374696F6E7D20656C656D656E740A202A0A202A204072657475726E207B4F626A6563747D20746865206D6F6464';
wwv_flow_imp.g_varchar2_table(6680) := '6C652064657363726970746F720A202A2F0A66756E6374696F6E206765744D6F64646C6544657363726970746F7228656C656D656E7429207B0A202072657475726E20656C656D656E742E2464657363726970746F723B0A7D0A0A0A2F2A2A0A202A2041';
wwv_flow_imp.g_varchar2_table(6681) := '20706172736520636F6E746578742E0A202A0A202A2040636C6173730A202A0A202A2040706172616D207B4F626A6563747D206F7074696F6E730A202A2040706172616D207B456C656D656E7448616E646C65727D206F7074696F6E732E726F6F744861';
wwv_flow_imp.g_varchar2_table(6682) := '6E646C65722074686520726F6F742068616E646C657220666F722070617273696E67206120646F63756D656E740A202A2040706172616D207B626F6F6C65616E7D205B6F7074696F6E732E6C61783D66616C73655D2077686574686572206F72206E6F74';
wwv_flow_imp.g_varchar2_table(6683) := '20746F2069676E6F726520696E76616C696420656C656D656E74730A202A2F0A66756E6374696F6E20436F6E74657874286F7074696F6E7329207B0A0A20202F2A2A0A2020202A204070726F7065727479207B456C656D656E7448616E646C65727D2072';
wwv_flow_imp.g_varchar2_table(6684) := '6F6F7448616E646C65720A2020202A2F0A0A20202F2A2A0A2020202A204070726F7065727479207B426F6F6C65616E7D206C61780A2020202A2F0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F32';
wwv_flow_imp.g_varchar2_table(6685) := '5F5F2E61737369676E2928746869732C206F7074696F6E73293B0A0A2020746869732E656C656D656E747342794964203D207B7D3B0A2020746869732E7265666572656E636573203D205B5D3B0A2020746869732E7761726E696E6773203D205B5D3B0A';
wwv_flow_imp.g_varchar2_table(6686) := '0A20202F2A2A0A2020202A2041646420616E20756E7265736F6C766564207265666572656E63652E0A2020202A0A2020202A2040706172616D207B4F626A6563747D207265666572656E63650A2020202A2F0A2020746869732E6164645265666572656E';
wwv_flow_imp.g_varchar2_table(6687) := '6365203D2066756E6374696F6E287265666572656E636529207B0A20202020746869732E7265666572656E6365732E70757368287265666572656E6365293B0A20207D3B0A0A20202F2A2A0A2020202A2041646420612070726F63657373656420656C65';
wwv_flow_imp.g_varchar2_table(6688) := '6D656E742E0A2020202A0A2020202A2040706172616D207B4D6F64646C65456C656D656E747D20656C656D656E740A2020202A2F0A2020746869732E616464456C656D656E74203D2066756E6374696F6E28656C656D656E7429207B0A0A202020206966';
wwv_flow_imp.g_varchar2_table(6689) := '202821656C656D656E7429207B0A2020202020207468726F77206572726F722827657870656374656420656C656D656E7427293B0A202020207D0A0A2020202076617220656C656D656E747342794964203D20746869732E656C656D656E747342794964';
wwv_flow_imp.g_varchar2_table(6690) := '3B0A0A202020207661722064657363726970746F72203D206765744D6F64646C6544657363726970746F7228656C656D656E74293B0A0A2020202076617220696450726F7065727479203D2064657363726970746F722E696450726F70657274792C0A20';
wwv_flow_imp.g_varchar2_table(6691) := '2020202020202069643B0A0A2020202069662028696450726F706572747929207B0A2020202020206964203D20656C656D656E742E67657428696450726F70657274792E6E616D65293B0A0A20202020202069662028696429207B0A0A20202020202020';
wwv_flow_imp.g_varchar2_table(6692) := '202F2F20666F7220514E616D652076616C69646174696F6E2061732070657220687474703A2F2F7777772E77332E6F72672F54522F5245432D786D6C2F234E542D4E616D65436861720A202020202020202069662028212F5E285B612D7A5D5B5C772D2E';
wwv_flow_imp.g_varchar2_table(6693) := '5D2A3A293F5B612D7A5F5D5B5C772D2E5D2A242F692E746573742869642929207B0A202020202020202020207468726F77206E6577204572726F722827696C6C6567616C204944203C27202B206964202B20273E27293B0A20202020202020207D0A0A20';
wwv_flow_imp.g_varchar2_table(6694) := '2020202020202069662028656C656D656E7473427949645B69645D29207B0A202020202020202020207468726F77206572726F7228276475706C6963617465204944203C27202B206964202B20273E27293B0A20202020202020207D0A0A202020202020';
wwv_flow_imp.g_varchar2_table(6695) := '2020656C656D656E7473427949645B69645D203D20656C656D656E743B0A2020202020207D0A202020207D0A20207D3B0A0A20202F2A2A0A2020202A2041646420616E20696D706F7274207761726E696E672E0A2020202A0A2020202A2040706172616D';
wwv_flow_imp.g_varchar2_table(6696) := '207B4F626A6563747D207761726E696E670A2020202A2040706172616D207B537472696E677D207761726E696E672E6D6573736167650A2020202A2040706172616D207B4572726F727D205B7761726E696E672E6572726F725D0A2020202A2F0A202074';
wwv_flow_imp.g_varchar2_table(6697) := '6869732E6164645761726E696E67203D2066756E6374696F6E287761726E696E6729207B0A20202020746869732E7761726E696E67732E70757368287761726E696E67293B0A20207D3B0A7D0A0A66756E6374696F6E204261736548616E646C65722829';
wwv_flow_imp.g_varchar2_table(6698) := '207B7D0A0A4261736548616E646C65722E70726F746F747970652E68616E646C65456E64203D2066756E6374696F6E2829207B7D3B0A4261736548616E646C65722E70726F746F747970652E68616E646C6554657874203D2066756E6374696F6E282920';
wwv_flow_imp.g_varchar2_table(6699) := '7B7D3B0A4261736548616E646C65722E70726F746F747970652E68616E646C654E6F6465203D2066756E6374696F6E2829207B7D3B0A0A0A2F2A2A0A202A20412073696D706C652070617373207468726F7567682068616E646C6572207468617420646F';
wwv_flow_imp.g_varchar2_table(6700) := '6573206E6F7468696E672065786365707420666F720A202A2069676E6F72696E6720616C6C20696E7075742069742072656365697665732E0A202A0A202A2054686973206973207573656420746F2069676E6F726520756E6B6E6F776E20656C656D656E';
wwv_flow_imp.g_varchar2_table(6701) := '747320616E640A202A20617474726962757465732E0A202A2F0A66756E6374696F6E204E6F6F7048616E646C65722829207B207D0A0A4E6F6F7048616E646C65722E70726F746F74797065203D204F626A6563742E637265617465284261736548616E64';
wwv_flow_imp.g_varchar2_table(6702) := '6C65722E70726F746F74797065293B0A0A4E6F6F7048616E646C65722E70726F746F747970652E68616E646C654E6F6465203D2066756E6374696F6E2829207B0A202072657475726E20746869733B0A7D3B0A0A66756E6374696F6E20426F647948616E';
wwv_flow_imp.g_varchar2_table(6703) := '646C65722829207B7D0A0A426F647948616E646C65722E70726F746F74797065203D204F626A6563742E637265617465284261736548616E646C65722E70726F746F74797065293B0A0A426F647948616E646C65722E70726F746F747970652E68616E64';
wwv_flow_imp.g_varchar2_table(6704) := '6C6554657874203D2066756E6374696F6E287465787429207B0A2020746869732E626F6479203D2028746869732E626F6479207C7C20272729202B20746578743B0A7D3B0A0A66756E6374696F6E205265666572656E636548616E646C65722870726F70';
wwv_flow_imp.g_varchar2_table(6705) := '657274792C20636F6E7465787429207B0A2020746869732E70726F7065727479203D2070726F70657274793B0A2020746869732E636F6E74657874203D20636F6E746578743B0A7D0A0A5265666572656E636548616E646C65722E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(6706) := '203D204F626A6563742E63726561746528426F647948616E646C65722E70726F746F74797065293B0A0A5265666572656E636548616E646C65722E70726F746F747970652E68616E646C654E6F6465203D2066756E6374696F6E286E6F646529207B0A0A';
wwv_flow_imp.g_varchar2_table(6707) := '202069662028746869732E656C656D656E7429207B0A202020207468726F77206572726F7228276578706563746564206E6F20737562206E6F64657327293B0A20207D20656C7365207B0A20202020746869732E656C656D656E74203D20746869732E63';
wwv_flow_imp.g_varchar2_table(6708) := '72656174655265666572656E6365286E6F6465293B0A20207D0A0A202072657475726E20746869733B0A7D3B0A0A5265666572656E636548616E646C65722E70726F746F747970652E68616E646C65456E64203D2066756E6374696F6E2829207B0A2020';
wwv_flow_imp.g_varchar2_table(6709) := '746869732E656C656D656E742E6964203D20746869732E626F64793B0A7D3B0A0A5265666572656E636548616E646C65722E70726F746F747970652E6372656174655265666572656E6365203D2066756E6374696F6E286E6F646529207B0A2020726574';
wwv_flow_imp.g_varchar2_table(6710) := '75726E207B0A2020202070726F70657274793A20746869732E70726F70657274792E6E732E6E616D652C0A2020202069643A2027270A20207D3B0A7D3B0A0A66756E6374696F6E2056616C756548616E646C65722870726F7065727479446573632C2065';
wwv_flow_imp.g_varchar2_table(6711) := '6C656D656E7429207B0A2020746869732E656C656D656E74203D20656C656D656E743B0A2020746869732E70726F706572747944657363203D2070726F7065727479446573633B0A7D0A0A56616C756548616E646C65722E70726F746F74797065203D20';
wwv_flow_imp.g_varchar2_table(6712) := '4F626A6563742E63726561746528426F647948616E646C65722E70726F746F74797065293B0A0A56616C756548616E646C65722E70726F746F747970652E68616E646C65456E64203D2066756E6374696F6E2829207B0A0A20207661722076616C756520';
wwv_flow_imp.g_varchar2_table(6713) := '3D20746869732E626F6479207C7C2027272C0A202020202020656C656D656E74203D20746869732E656C656D656E742C0A20202020202070726F706572747944657363203D20746869732E70726F7065727479446573633B0A0A202076616C7565203D20';
wwv_flow_imp.g_varchar2_table(6714) := '28302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E636F6572636554797065292870726F7065727479446573632E747970652C2076616C7565293B0A0A20206966202870726F7065727479446573632E6973';
wwv_flow_imp.g_varchar2_table(6715) := '4D616E7929207B0A20202020656C656D656E742E6765742870726F7065727479446573632E6E616D65292E707573682876616C7565293B0A20207D20656C7365207B0A20202020656C656D656E742E7365742870726F7065727479446573632E6E616D65';
wwv_flow_imp.g_varchar2_table(6716) := '2C2076616C7565293B0A20207D0A7D3B0A0A0A66756E6374696F6E2042617365456C656D656E7448616E646C65722829207B7D0A0A42617365456C656D656E7448616E646C65722E70726F746F74797065203D204F626A6563742E63726561746528426F';
wwv_flow_imp.g_varchar2_table(6717) := '647948616E646C65722E70726F746F74797065293B0A0A42617365456C656D656E7448616E646C65722E70726F746F747970652E68616E646C654E6F6465203D2066756E6374696F6E286E6F646529207B0A202076617220706172736572203D20746869';
wwv_flow_imp.g_varchar2_table(6718) := '732C0A202020202020656C656D656E74203D20746869732E656C656D656E743B0A0A20206966202821656C656D656E7429207B0A20202020656C656D656E74203D20746869732E656C656D656E74203D20746869732E637265617465456C656D656E7428';
wwv_flow_imp.g_varchar2_table(6719) := '6E6F6465293B0A0A20202020746869732E636F6E746578742E616464456C656D656E7428656C656D656E74293B0A20207D20656C7365207B0A20202020706172736572203D20746869732E68616E646C654368696C64286E6F6465293B0A20207D0A0A20';
wwv_flow_imp.g_varchar2_table(6720) := '2072657475726E207061727365723B0A7D3B0A0A2F2A2A0A202A2040636C617373205265616465722E456C656D656E7448616E646C65720A202A0A202A2F0A66756E6374696F6E20456C656D656E7448616E646C6572286D6F64656C2C20747970654E61';
wwv_flow_imp.g_varchar2_table(6721) := '6D652C20636F6E7465787429207B0A2020746869732E6D6F64656C203D206D6F64656C3B0A2020746869732E74797065203D206D6F64656C2E6765745479706528747970654E616D65293B0A2020746869732E636F6E74657874203D20636F6E74657874';
wwv_flow_imp.g_varchar2_table(6722) := '3B0A7D0A0A456C656D656E7448616E646C65722E70726F746F74797065203D204F626A6563742E6372656174652842617365456C656D656E7448616E646C65722E70726F746F74797065293B0A0A456C656D656E7448616E646C65722E70726F746F7479';
wwv_flow_imp.g_varchar2_table(6723) := '70652E6164645265666572656E6365203D2066756E6374696F6E287265666572656E636529207B0A2020746869732E636F6E746578742E6164645265666572656E6365287265666572656E6365293B0A7D3B0A0A456C656D656E7448616E646C65722E70';
wwv_flow_imp.g_varchar2_table(6724) := '726F746F747970652E68616E646C6554657874203D2066756E6374696F6E287465787429207B0A0A202076617220656C656D656E74203D20746869732E656C656D656E742C0A20202020202064657363726970746F72203D206765744D6F64646C654465';
wwv_flow_imp.g_varchar2_table(6725) := '7363726970746F7228656C656D656E74292C0A202020202020626F647950726F7065727479203D2064657363726970746F722E626F647950726F70657274793B0A0A20206966202821626F647950726F706572747929207B0A202020207468726F772065';
wwv_flow_imp.g_varchar2_table(6726) := '72726F722827756E657870656374656420626F64792074657874203C27202B2074657874202B20273E27293B0A20207D0A0A2020426F647948616E646C65722E70726F746F747970652E68616E646C65546578742E63616C6C28746869732C2074657874';
wwv_flow_imp.g_varchar2_table(6727) := '293B0A7D3B0A0A456C656D656E7448616E646C65722E70726F746F747970652E68616E646C65456E64203D2066756E6374696F6E2829207B0A0A20207661722076616C7565203D20746869732E626F64792C0A202020202020656C656D656E74203D2074';
wwv_flow_imp.g_varchar2_table(6728) := '6869732E656C656D656E742C0A20202020202064657363726970746F72203D206765744D6F64646C6544657363726970746F7228656C656D656E74292C0A202020202020626F647950726F7065727479203D2064657363726970746F722E626F64795072';
wwv_flow_imp.g_varchar2_table(6729) := '6F70657274793B0A0A202069662028626F647950726F70657274792026262076616C756520213D3D20756E646566696E656429207B0A2020202076616C7565203D2028302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C45';
wwv_flow_imp.g_varchar2_table(6730) := '5F315F5F2E636F65726365547970652928626F647950726F70657274792E747970652C2076616C7565293B0A20202020656C656D656E742E73657428626F647950726F70657274792E6E616D652C2076616C7565293B0A20207D0A7D3B0A0A2F2A2A0A20';
wwv_flow_imp.g_varchar2_table(6731) := '2A2043726561746520616E20696E7374616E6365206F6620746865206D6F64656C2066726F6D2074686520676976656E206E6F64652E0A202A0A202A2040706172616D20207B456C656D656E747D206E6F64652074686520786D6C206E6F64650A202A2F';
wwv_flow_imp.g_varchar2_table(6732) := '0A456C656D656E7448616E646C65722E70726F746F747970652E637265617465456C656D656E74203D2066756E6374696F6E286E6F646529207B0A20207661722061747472696275746573203D206E6F64652E617474726962757465732C0A2020202020';
wwv_flow_imp.g_varchar2_table(6733) := '2054797065203D20746869732E747970652C0A20202020202064657363726970746F72203D206765744D6F64646C6544657363726970746F722854797065292C0A202020202020636F6E74657874203D20746869732E636F6E746578742C0A2020202020';
wwv_flow_imp.g_varchar2_table(6734) := '20696E7374616E6365203D206E65772054797065287B7D292C0A2020202020206D6F64656C203D20746869732E6D6F64656C2C0A20202020202070726F704E616D654E733B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F5254';
wwv_flow_imp.g_varchar2_table(6735) := '45445F4D4F44554C455F325F5F2E666F72456163682928617474726962757465732C2066756E6374696F6E2876616C75652C206E616D6529207B0A0A202020207661722070726F70203D2064657363726970746F722E70726F7065727469657342794E61';
wwv_flow_imp.g_varchar2_table(6736) := '6D655B6E616D655D2C0A202020202020202076616C7565733B0A0A202020206966202870726F702026262070726F702E69735265666572656E636529207B0A0A202020202020696620282170726F702E69734D616E7929207B0A2020202020202020636F';
wwv_flow_imp.g_varchar2_table(6737) := '6E746578742E6164645265666572656E6365287B0A20202020202020202020656C656D656E743A20696E7374616E63652C0A2020202020202020202070726F70657274793A2070726F702E6E732E6E616D652C0A2020202020202020202069643A207661';
wwv_flow_imp.g_varchar2_table(6738) := '6C75650A20202020202020207D293B0A2020202020207D20656C7365207B0A0A20202020202020202F2F204944524546533A207061727365207265666572656E63657320617320776869746573706163652D736570617261746564206C6973740A202020';
wwv_flow_imp.g_varchar2_table(6739) := '202020202076616C756573203D2076616C75652E73706C697428272027293B0A0A202020202020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E666F7245616368292876616C7565732C2066';
wwv_flow_imp.g_varchar2_table(6740) := '756E6374696F6E287629207B0A20202020202020202020636F6E746578742E6164645265666572656E6365287B0A202020202020202020202020656C656D656E743A20696E7374616E63652C0A20202020202020202020202070726F70657274793A2070';
wwv_flow_imp.g_varchar2_table(6741) := '726F702E6E732E6E616D652C0A20202020202020202020202069643A20760A202020202020202020207D293B0A20202020202020207D293B0A2020202020207D0A0A202020207D20656C7365207B0A2020202020206966202870726F7029207B0A202020';
wwv_flow_imp.g_varchar2_table(6742) := '202020202076616C7565203D2028302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E636F6572636554797065292870726F702E747970652C2076616C7565293B0A2020202020207D20656C73650A20202020';
wwv_flow_imp.g_varchar2_table(6743) := '2020696620286E616D6520213D3D2027786D6C6E732729207B0A202020202020202070726F704E616D654E73203D2028302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E70617273654E616D654E5329286E';
wwv_flow_imp.g_varchar2_table(6744) := '616D652C2064657363726970746F722E6E732E707265666978293B0A0A20202020202020202F2F20636865636B20776865746865722061747472696275746520697320646566696E656420696E20612077656C6C2D6B6E6F776E206E616D657370616365';
wwv_flow_imp.g_varchar2_table(6745) := '0A20202020202020202F2F206966207468617420697320746865206361736520776520656D69742061207761726E696E6720746F20696E64696361746520706F74656E7469616C206D69737573650A2020202020202020696620286D6F64656C2E676574';
wwv_flow_imp.g_varchar2_table(6746) := '5061636B6167652870726F704E616D654E732E7072656669782929207B0A0A20202020202020202020636F6E746578742E6164645761726E696E67287B0A2020202020202020202020206D6573736167653A2027756E6B6E6F776E206174747269627574';
wwv_flow_imp.g_varchar2_table(6747) := '65203C27202B206E616D65202B20273E272C0A202020202020202020202020656C656D656E743A20696E7374616E63652C0A20202020202020202020202070726F70657274793A206E616D652C0A20202020202020202020202076616C75653A2076616C';
wwv_flow_imp.g_varchar2_table(6748) := '75650A202020202020202020207D293B0A20202020202020207D0A2020202020207D0A0A202020202020696E7374616E63652E736574286E616D652C2076616C7565293B0A202020207D0A20207D293B0A0A202072657475726E20696E7374616E63653B';
wwv_flow_imp.g_varchar2_table(6749) := '0A7D3B0A0A456C656D656E7448616E646C65722E70726F746F747970652E67657450726F7065727479466F724E6F6465203D2066756E6374696F6E286E6F646529207B0A0A2020766172206E616D65203D206E6F64652E6E616D653B0A2020766172206E';
wwv_flow_imp.g_varchar2_table(6750) := '616D654E73203D2028302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E70617273654E616D654E5329286E616D65293B0A0A20207661722074797065203D20746869732E747970652C0A2020202020206D6F';
wwv_flow_imp.g_varchar2_table(6751) := '64656C203D20746869732E6D6F64656C2C0A20202020202064657363726970746F72203D206765744D6F64646C6544657363726970746F722874797065293B0A0A20207661722070726F70657274794E616D65203D206E616D654E732E6E616D652C0A20';
wwv_flow_imp.g_varchar2_table(6752) := '202020202070726F7065727479203D2064657363726970746F722E70726F7065727469657342794E616D655B70726F70657274794E616D655D2C0A202020202020656C656D656E74547970654E616D652C0A202020202020656C656D656E74547970653B';
wwv_flow_imp.g_varchar2_table(6753) := '0A0A20202F2F2073656172636820666F722070726F70657274696573206279206E616D652066697273740A0A20206966202870726F7065727479202626202170726F70657274792E69734174747229207B0A0A202020206966202873657269616C697A65';
wwv_flow_imp.g_varchar2_table(6754) := '4173547970652870726F70657274792929207B0A202020202020656C656D656E74547970654E616D65203D206E6F64652E617474726962757465735B5853495F545950455D3B0A0A2020202020202F2F207873692074797065206973206F7074696F6E61';
wwv_flow_imp.g_varchar2_table(6755) := '6C2C20696620697420646F6573206E6F7420657869737473207468650A2020202020202F2F2064656661756C74207479706520697320617373756D65640A20202020202069662028656C656D656E74547970654E616D6529207B0A0A2020202020202020';
wwv_flow_imp.g_varchar2_table(6756) := '2F2F2074616B6520706F737369626C6520747970652070726566697865732066726F6D20584D4C0A20202020202020202F2F20696E746F206163636F756E742C20692E652E3A207873693A747970653D22747B41637475616C547970657D220A20202020';
wwv_flow_imp.g_varchar2_table(6757) := '20202020656C656D656E74547970654E616D65203D206E6F726D616C697A65587369547970654E616D6528656C656D656E74547970654E616D652C206D6F64656C293B0A0A2020202020202020656C656D656E7454797065203D206D6F64656C2E676574';
wwv_flow_imp.g_varchar2_table(6758) := '5479706528656C656D656E74547970654E616D65293B0A0A202020202020202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E29287B7D2C2070726F7065727479';
wwv_flow_imp.g_varchar2_table(6759) := '2C207B0A20202020202020202020656666656374697665547970653A206765744D6F64646C6544657363726970746F7228656C656D656E7454797065292E6E616D650A20202020202020207D293B0A2020202020207D0A202020207D0A0A202020202F2F';
wwv_flow_imp.g_varchar2_table(6760) := '2073656172636820666F722070726F70657274696573206279206E616D652066697273740A2020202072657475726E2070726F70657274793B0A20207D0A0A202076617220706B67203D206D6F64656C2E6765745061636B616765286E616D654E732E70';
wwv_flow_imp.g_varchar2_table(6761) := '7265666978293B0A0A202069662028706B6729207B0A20202020656C656D656E74547970654E616D65203D20616C696173546F4E616D65286E616D654E732C20706B67293B0A20202020656C656D656E7454797065203D206D6F64656C2E676574547970';
wwv_flow_imp.g_varchar2_table(6762) := '6528656C656D656E74547970654E616D65293B0A0A202020202F2F2073656172636820666F7220636F6C6C656374696F6E206D656D62657273206C617465720A2020202070726F7065727479203D2028302C6D696E5F646173685F5F5745425041434B5F';
wwv_flow_imp.g_varchar2_table(6763) := '494D504F525445445F4D4F44554C455F325F5F2E66696E64292864657363726970746F722E70726F706572746965732C2066756E6374696F6E287029207B0A20202020202072657475726E2021702E69735669727475616C2026262021702E6973526566';
wwv_flow_imp.g_varchar2_table(6764) := '6572656E63652026262021702E697341747472696275746520262620656C656D656E74547970652E6861735479706528702E74797065293B0A202020207D293B0A0A202020206966202870726F706572747929207B0A20202020202072657475726E2028';
wwv_flow_imp.g_varchar2_table(6765) := '302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E29287B7D2C2070726F70657274792C207B0A2020202020202020656666656374697665547970653A206765744D6F64646C6544657363';
wwv_flow_imp.g_varchar2_table(6766) := '726970746F7228656C656D656E7454797065292E6E616D650A2020202020207D293B0A202020207D0A20207D20656C7365207B0A0A202020202F2F20706172736520756E6B6E6F776E20656C656D656E7420286D6179626520657874656E73696F6E290A';
wwv_flow_imp.g_varchar2_table(6767) := '2020202070726F7065727479203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E66696E64292864657363726970746F722E70726F706572746965732C2066756E6374696F6E287029207B0A20';
wwv_flow_imp.g_varchar2_table(6768) := '202020202072657475726E2021702E69735265666572656E63652026262021702E697341747472696275746520262620702E74797065203D3D3D2027456C656D656E74273B0A202020207D293B0A0A202020206966202870726F706572747929207B0A20';
wwv_flow_imp.g_varchar2_table(6769) := '202020202072657475726E2070726F70657274793B0A202020207D0A20207D0A0A20207468726F77206572726F722827756E7265636F676E697A656420656C656D656E74203C27202B206E616D654E732E6E616D65202B20273E27293B0A7D3B0A0A456C';
wwv_flow_imp.g_varchar2_table(6770) := '656D656E7448616E646C65722E70726F746F747970652E746F537472696E67203D2066756E6374696F6E2829207B0A202072657475726E2027456C656D656E7444657363726970746F725B27202B206765744D6F64646C6544657363726970746F722874';
wwv_flow_imp.g_varchar2_table(6771) := '6869732E74797065292E6E616D65202B20275D273B0A7D3B0A0A456C656D656E7448616E646C65722E70726F746F747970652E76616C756548616E646C6572203D2066756E6374696F6E2870726F7065727479446573632C20656C656D656E7429207B0A';
wwv_flow_imp.g_varchar2_table(6772) := '202072657475726E206E65772056616C756548616E646C65722870726F7065727479446573632C20656C656D656E74293B0A7D3B0A0A456C656D656E7448616E646C65722E70726F746F747970652E7265666572656E636548616E646C6572203D206675';
wwv_flow_imp.g_varchar2_table(6773) := '6E6374696F6E2870726F70657274794465736329207B0A202072657475726E206E6577205265666572656E636548616E646C65722870726F7065727479446573632C20746869732E636F6E74657874293B0A7D3B0A0A456C656D656E7448616E646C6572';
wwv_flow_imp.g_varchar2_table(6774) := '2E70726F746F747970652E68616E646C6572203D2066756E6374696F6E287479706529207B0A20206966202874797065203D3D3D2027456C656D656E742729207B0A2020202072657475726E206E65772047656E65726963456C656D656E7448616E646C';
wwv_flow_imp.g_varchar2_table(6775) := '657228746869732E6D6F64656C2C20747970652C20746869732E636F6E74657874293B0A20207D20656C7365207B0A2020202072657475726E206E657720456C656D656E7448616E646C657228746869732E6D6F64656C2C20747970652C20746869732E';
wwv_flow_imp.g_varchar2_table(6776) := '636F6E74657874293B0A20207D0A7D3B0A0A2F2A2A0A202A2048616E646C6520746865206368696C6420656C656D656E742070617273696E670A202A0A202A2040706172616D20207B456C656D656E747D206E6F64652074686520786D6C206E6F64650A';
wwv_flow_imp.g_varchar2_table(6777) := '202A2F0A456C656D656E7448616E646C65722E70726F746F747970652E68616E646C654368696C64203D2066756E6374696F6E286E6F646529207B0A20207661722070726F7065727479446573632C20747970652C20656C656D656E742C206368696C64';
wwv_flow_imp.g_varchar2_table(6778) := '48616E646C65723B0A0A202070726F706572747944657363203D20746869732E67657450726F7065727479466F724E6F6465286E6F6465293B0A2020656C656D656E74203D20746869732E656C656D656E743B0A0A202074797065203D2070726F706572';
wwv_flow_imp.g_varchar2_table(6779) := '7479446573632E65666665637469766554797065207C7C2070726F7065727479446573632E747970653B0A0A20206966202828302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E697353696D706C65547970';
wwv_flow_imp.g_varchar2_table(6780) := '652928747970652929207B0A2020202072657475726E20746869732E76616C756548616E646C65722870726F7065727479446573632C20656C656D656E74293B0A20207D0A0A20206966202870726F7065727479446573632E69735265666572656E6365';
wwv_flow_imp.g_varchar2_table(6781) := '29207B0A202020206368696C6448616E646C6572203D20746869732E7265666572656E636548616E646C65722870726F706572747944657363292E68616E646C654E6F6465286E6F6465293B0A20207D20656C7365207B0A202020206368696C6448616E';
wwv_flow_imp.g_varchar2_table(6782) := '646C6572203D20746869732E68616E646C65722874797065292E68616E646C654E6F6465286E6F6465293B0A20207D0A0A2020766172206E6577456C656D656E74203D206368696C6448616E646C65722E656C656D656E743B0A0A20202F2F206368696C';
wwv_flow_imp.g_varchar2_table(6783) := '642068616E646C6573206D61792064656369646520746F20736B697020656C656D656E74730A20202F2F206279206E6F742072657475726E696E6720616E797468696E670A2020696620286E6577456C656D656E7420213D3D20756E646566696E656429';
wwv_flow_imp.g_varchar2_table(6784) := '207B0A0A202020206966202870726F7065727479446573632E69734D616E7929207B0A202020202020656C656D656E742E6765742870726F7065727479446573632E6E616D65292E70757368286E6577456C656D656E74293B0A202020207D20656C7365';
wwv_flow_imp.g_varchar2_table(6785) := '207B0A202020202020656C656D656E742E7365742870726F7065727479446573632E6E616D652C206E6577456C656D656E74293B0A202020207D0A0A202020206966202870726F7065727479446573632E69735265666572656E636529207B0A20202020';
wwv_flow_imp.g_varchar2_table(6786) := '202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E29286E6577456C656D656E742C207B0A2020202020202020656C656D656E743A20656C656D656E740A2020202020207D293B0A';
wwv_flow_imp.g_varchar2_table(6787) := '0A202020202020746869732E636F6E746578742E6164645265666572656E6365286E6577456C656D656E74293B0A202020207D20656C7365207B0A0A2020202020202F2F2065737461626C697368206368696C64202D3E20706172656E742072656C6174';
wwv_flow_imp.g_varchar2_table(6788) := '696F6E736869700A2020202020206E6577456C656D656E742E24706172656E74203D20656C656D656E743B0A202020207D0A20207D0A0A202072657475726E206368696C6448616E646C65723B0A7D3B0A0A2F2A2A0A202A20416E20656C656D656E7420';
wwv_flow_imp.g_varchar2_table(6789) := '68616E646C6572207468617420706572666F726D73207370656369616C2076616C69646174696F6E0A202A20746F20656E7375726520746865206E6F6465206974206765747320696E697469616C697A65642077697468206D6174636865730A202A2074';
wwv_flow_imp.g_varchar2_table(6790) := '68652068616E646C657273207479706520286E616D6573706163652077697365292E0A202A0A202A2040706172616D207B4D6F64646C657D206D6F64656C0A202A2040706172616D207B537472696E677D20747970654E616D650A202A2040706172616D';
wwv_flow_imp.g_varchar2_table(6791) := '207B436F6E746578747D20636F6E746578740A202A2F0A66756E6374696F6E20526F6F74456C656D656E7448616E646C6572286D6F64656C2C20747970654E616D652C20636F6E7465787429207B0A2020456C656D656E7448616E646C65722E63616C6C';
wwv_flow_imp.g_varchar2_table(6792) := '28746869732C206D6F64656C2C20747970654E616D652C20636F6E74657874293B0A7D0A0A526F6F74456C656D656E7448616E646C65722E70726F746F74797065203D204F626A6563742E63726561746528456C656D656E7448616E646C65722E70726F';
wwv_flow_imp.g_varchar2_table(6793) := '746F74797065293B0A0A526F6F74456C656D656E7448616E646C65722E70726F746F747970652E637265617465456C656D656E74203D2066756E6374696F6E286E6F646529207B0A0A2020766172206E616D65203D206E6F64652E6E616D652C0A202020';
wwv_flow_imp.g_varchar2_table(6794) := '2020206E616D654E73203D2028302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E70617273654E616D654E5329286E616D65292C0A2020202020206D6F64656C203D20746869732E6D6F64656C2C0A202020';
wwv_flow_imp.g_varchar2_table(6795) := '20202074797065203D20746869732E747970652C0A202020202020706B67203D206D6F64656C2E6765745061636B616765286E616D654E732E707265666978292C0A202020202020747970654E616D65203D20706B6720262620616C696173546F4E616D';
wwv_flow_imp.g_varchar2_table(6796) := '65286E616D654E732C20706B6729207C7C206E616D653B0A0A20202F2F207665726966792074686520636F7272656374206E616D6573706163652069662077652070617273650A20202F2F2074686520666972737420656C656D656E7420696E20746865';
wwv_flow_imp.g_varchar2_table(6797) := '2068616E646C657220747265650A20202F2F0A20202F2F207468697320656E737572657320776520646F6E2774206D697374616B656E6C7920696D706F72742077726F6E67206E616D65737061636520656C656D656E74730A2020696620282174797065';
wwv_flow_imp.g_varchar2_table(6798) := '2E6861735479706528747970654E616D652929207B0A202020207468726F77206572726F722827756E657870656374656420656C656D656E74203C27202B206E6F64652E6F726967696E616C4E616D65202B20273E27293B0A20207D0A0A202072657475';
wwv_flow_imp.g_varchar2_table(6799) := '726E20456C656D656E7448616E646C65722E70726F746F747970652E637265617465456C656D656E742E63616C6C28746869732C206E6F6465293B0A7D3B0A0A0A66756E6374696F6E2047656E65726963456C656D656E7448616E646C6572286D6F6465';
wwv_flow_imp.g_varchar2_table(6800) := '6C2C20747970654E616D652C20636F6E7465787429207B0A2020746869732E6D6F64656C203D206D6F64656C3B0A2020746869732E636F6E74657874203D20636F6E746578743B0A7D0A0A47656E65726963456C656D656E7448616E646C65722E70726F';
wwv_flow_imp.g_varchar2_table(6801) := '746F74797065203D204F626A6563742E6372656174652842617365456C656D656E7448616E646C65722E70726F746F74797065293B0A0A47656E65726963456C656D656E7448616E646C65722E70726F746F747970652E637265617465456C656D656E74';
wwv_flow_imp.g_varchar2_table(6802) := '203D2066756E6374696F6E286E6F646529207B0A0A2020766172206E616D65203D206E6F64652E6E616D652C0A2020202020206E73203D2028302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E7061727365';
wwv_flow_imp.g_varchar2_table(6803) := '4E616D654E5329286E616D65292C0A202020202020707265666978203D206E732E7072656669782C0A202020202020757269203D206E6F64652E6E735B707265666978202B202724757269275D2C0A20202020202061747472696275746573203D206E6F';
wwv_flow_imp.g_varchar2_table(6804) := '64652E617474726962757465733B0A0A202072657475726E20746869732E6D6F64656C2E637265617465416E79286E616D652C207572692C2061747472696275746573293B0A7D3B0A0A47656E65726963456C656D656E7448616E646C65722E70726F74';
wwv_flow_imp.g_varchar2_table(6805) := '6F747970652E68616E646C654368696C64203D2066756E6374696F6E286E6F646529207B0A0A20207661722068616E646C6572203D206E65772047656E65726963456C656D656E7448616E646C657228746869732E6D6F64656C2C2027456C656D656E74';
wwv_flow_imp.g_varchar2_table(6806) := '272C20746869732E636F6E74657874292E68616E646C654E6F6465286E6F6465292C0A202020202020656C656D656E74203D20746869732E656C656D656E743B0A0A2020766172206E6577456C656D656E74203D2068616E646C65722E656C656D656E74';
wwv_flow_imp.g_varchar2_table(6807) := '2C0A2020202020206368696C6472656E3B0A0A2020696620286E6577456C656D656E7420213D3D20756E646566696E656429207B0A202020206368696C6472656E203D20656C656D656E742E246368696C6472656E203D20656C656D656E742E24636869';
wwv_flow_imp.g_varchar2_table(6808) := '6C6472656E207C7C205B5D3B0A202020206368696C6472656E2E70757368286E6577456C656D656E74293B0A0A202020202F2F2065737461626C697368206368696C64202D3E20706172656E742072656C6174696F6E736869700A202020206E6577456C';
wwv_flow_imp.g_varchar2_table(6809) := '656D656E742E24706172656E74203D20656C656D656E743B0A20207D0A0A202072657475726E2068616E646C65723B0A7D3B0A0A47656E65726963456C656D656E7448616E646C65722E70726F746F747970652E68616E646C65456E64203D2066756E63';
wwv_flow_imp.g_varchar2_table(6810) := '74696F6E2829207B0A202069662028746869732E626F647929207B0A20202020746869732E656C656D656E742E24626F6479203D20746869732E626F64793B0A20207D0A7D3B0A0A2F2A2A0A202A20412072656164657220666F722061206D6574612D6D';
wwv_flow_imp.g_varchar2_table(6811) := '6F64656C0A202A0A202A2040706172616D207B4F626A6563747D206F7074696F6E730A202A2040706172616D207B4D6F64656C7D206F7074696F6E732E6D6F64656C207573656420746F207265616420786D6C2066696C65730A202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(6812) := '7B426F6F6C65616E7D206F7074696F6E732E6C6178207768657468657220746F206D616B65207061727365206572726F7273207761726E696E67730A202A2F0A66756E6374696F6E20526561646572286F7074696F6E7329207B0A0A2020696620286F70';
wwv_flow_imp.g_varchar2_table(6813) := '74696F6E7320696E7374616E63656F66206D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E4D6F64646C6529207B0A202020206F7074696F6E73203D207B0A2020202020206D6F64656C3A206F7074696F6E730A';
wwv_flow_imp.g_varchar2_table(6814) := '202020207D3B0A20207D0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E2928746869732C207B206C61783A2066616C7365207D2C206F7074696F6E73293B0A7D0A0A2F2A';
wwv_flow_imp.g_varchar2_table(6815) := '2A0A202A205468652066726F6D584D4C20726573756C742E0A202A0A202A204074797065646566207B4F626A6563747D205061727365526573756C740A202A0A202A204070726F7065727479207B4D6F64646C65456C656D656E747D20726F6F74456C65';
wwv_flow_imp.g_varchar2_table(6816) := '6D656E740A202A204070726F7065727479207B41727261793C4F626A6563743E7D207265666572656E6365730A202A204070726F7065727479207B41727261793C4572726F723E7D207761726E696E67730A202A204070726F7065727479207B4F626A65';
wwv_flow_imp.g_varchar2_table(6817) := '63747D20656C656D656E747342794964202D2061206D617070696E6720636F6E7461696E696E672065616368204944202D3E204D6F64646C65456C656D656E740A202A2F0A0A2F2A2A0A202A205468652066726F6D584D4C20726573756C742E0A202A0A';
wwv_flow_imp.g_varchar2_table(6818) := '202A204074797065646566207B4572726F727D2050617273654572726F720A202A0A202A204070726F7065727479207B41727261793C4572726F723E7D207761726E696E67730A202A2F0A0A2F2A2A0A202A2050617273652074686520676976656E2058';
wwv_flow_imp.g_varchar2_table(6819) := '4D4C20696E746F2061206D6F64646C6520646F63756D656E7420747265652E0A202A0A202A2040706172616D207B537472696E677D20786D6C0A202A2040706172616D207B456C656D656E7448616E646C65727C4F626A6563747D206F7074696F6E7320';
wwv_flow_imp.g_varchar2_table(6820) := '6F7220726F6F7448616E646C65720A202A0A202A204072657475726E73207B50726F6D6973653C5061727365526573756C742C2050617273654572726F723E7D0A202A2F0A5265616465722E70726F746F747970652E66726F6D584D4C203D2066756E63';
wwv_flow_imp.g_varchar2_table(6821) := '74696F6E28786D6C2C206F7074696F6E732C20646F6E6529207B0A0A202076617220726F6F7448616E646C6572203D206F7074696F6E732E726F6F7448616E646C65723B0A0A2020696620286F7074696F6E7320696E7374616E63656F6620456C656D65';
wwv_flow_imp.g_varchar2_table(6822) := '6E7448616E646C657229207B0A0A202020202F2F20726F6F742068616E646C657220706173736564207669612028786D6C2C207B20726F6F7448616E646C65723A20456C656D656E7448616E646C6572207D2C202E2E2E290A20202020726F6F7448616E';
wwv_flow_imp.g_varchar2_table(6823) := '646C6572203D206F7074696F6E733B0A202020206F7074696F6E73203D207B7D3B0A20207D20656C7365207B0A2020202069662028747970656F66206F7074696F6E73203D3D3D2027737472696E672729207B0A0A2020202020202F2F20726F6F744861';
wwv_flow_imp.g_varchar2_table(6824) := '6E646C657220706173736564207669612028786D6C2C2027736F6D65537472696E67272C202E2E2E290A202020202020726F6F7448616E646C6572203D20746869732E68616E646C6572286F7074696F6E73293B0A2020202020206F7074696F6E73203D';
wwv_flow_imp.g_varchar2_table(6825) := '207B7D3B0A202020207D20656C73652069662028747970656F6620726F6F7448616E646C6572203D3D3D2027737472696E672729207B0A0A2020202020202F2F20726F6F7448616E646C657220706173736564207669612028786D6C2C207B20726F6F74';
wwv_flow_imp.g_varchar2_table(6826) := '48616E646C65723A2027736F6D65537472696E6727207D2C202E2E2E290A202020202020726F6F7448616E646C6572203D20746869732E68616E646C657228726F6F7448616E646C6572293B0A202020207D0A20207D0A0A2020766172206D6F64656C20';
wwv_flow_imp.g_varchar2_table(6827) := '3D20746869732E6D6F64656C2C0A2020202020206C6178203D20746869732E6C61783B0A0A202076617220636F6E74657874203D206E657720436F6E746578742828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(6828) := '455F325F5F2E61737369676E29287B7D2C206F7074696F6E732C207B20726F6F7448616E646C65723A20726F6F7448616E646C6572207D29292C0A202020202020706172736572203D206E657720736178656E5F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(6829) := '445F4D4F44554C455F305F5F2E506172736572287B2070726F78793A2074727565207D292C0A202020202020737461636B203D20637265617465537461636B28293B0A0A2020726F6F7448616E646C65722E636F6E74657874203D20636F6E746578743B';
wwv_flow_imp.g_varchar2_table(6830) := '0A0A20202F2F207075736820726F6F742068616E646C65720A2020737461636B2E7075736828726F6F7448616E646C6572293B0A0A0A20202F2A2A0A2020202A2048616E646C65206572726F722E0A2020202A0A2020202A2040706172616D20207B4572';
wwv_flow_imp.g_varchar2_table(6831) := '726F727D206572720A2020202A2040706172616D20207B46756E6374696F6E7D20676574436F6E746578740A2020202A2040706172616D20207B626F6F6C65616E7D206C61780A2020202A0A2020202A204072657475726E207B626F6F6C65616E7D2074';
wwv_flow_imp.g_varchar2_table(6832) := '7275652069662068616E646C65640A2020202A2F0A202066756E6374696F6E2068616E646C654572726F72286572722C20676574436F6E746578742C206C617829207B0A0A2020202076617220637478203D20676574436F6E7465787428293B0A0A2020';
wwv_flow_imp.g_varchar2_table(6833) := '2020766172206C696E65203D206374782E6C696E652C0A2020202020202020636F6C756D6E203D206374782E636F6C756D6E2C0A202020202020202064617461203D206374782E646174613B0A0A202020202F2F20776520726563656976652074686520';
wwv_flow_imp.g_varchar2_table(6834) := '66756C6C20636F6E74657874206461746120686572652C0A202020202F2F20666F7220656C656D656E7473207472696D20646F776E2074686520696E666F726D6174696F6E0A202020202F2F20746F2074686520746167206E616D652C206F6E6C790A20';
wwv_flow_imp.g_varchar2_table(6835) := '20202069662028646174612E636861724174283029203D3D3D20273C2720262620646174612E696E6465784F66282720272920213D3D202D3129207B0A20202020202064617461203D20646174612E736C69636528302C20646174612E696E6465784F66';
wwv_flow_imp.g_varchar2_table(6836) := '282720272929202B20273E273B0A202020207D0A0A20202020766172206D657373616765203D0A20202020202027756E7061727361626C6520636F6E74656E742027202B202864617461203F2064617461202B20272027203A20272729202B2027646574';
wwv_flow_imp.g_varchar2_table(6837) := '65637465645C6E5C7427202B0A2020202020202020276C696E653A2027202B206C696E65202B20275C6E5C7427202B0A202020202020202027636F6C756D6E3A2027202B20636F6C756D6E202B20275C6E5C7427202B0A2020202020202020276E657374';
wwv_flow_imp.g_varchar2_table(6838) := '6564206572726F723A2027202B206572722E6D6573736167653B0A0A20202020696620286C617829207B0A202020202020636F6E746578742E6164645761726E696E67287B0A20202020202020206D6573736167653A206D6573736167652C0A20202020';
wwv_flow_imp.g_varchar2_table(6839) := '202020206572726F723A206572720A2020202020207D293B0A0A20202020202072657475726E20747275653B0A202020207D20656C7365207B0A2020202020207468726F77206572726F72286D657373616765293B0A202020207D0A20207D0A0A202066';
wwv_flow_imp.g_varchar2_table(6840) := '756E6374696F6E2068616E646C655761726E696E67286572722C20676574436F6E7465787429207B0A0A202020202F2F206A757374206C696B652068616E646C696E67206572726F727320696E203C6C61783D747275653E206D6F64650A202020207265';
wwv_flow_imp.g_varchar2_table(6841) := '7475726E2068616E646C654572726F72286572722C20676574436F6E746578742C2074727565293B0A20207D0A0A20202F2A2A0A2020202A205265736F6C766520636F6C6C6563746564207265666572656E636573206F6E20706172736520656E642E0A';
wwv_flow_imp.g_varchar2_table(6842) := '2020202A2F0A202066756E6374696F6E207265736F6C76655265666572656E6365732829207B0A0A2020202076617220656C656D656E747342794964203D20636F6E746578742E656C656D656E7473427949643B0A20202020766172207265666572656E';
wwv_flow_imp.g_varchar2_table(6843) := '636573203D20636F6E746578742E7265666572656E6365733B0A0A2020202076617220692C20723B0A0A20202020666F72202869203D20303B202872203D207265666572656E6365735B695D293B20692B2B29207B0A20202020202076617220656C656D';
wwv_flow_imp.g_varchar2_table(6844) := '656E74203D20722E656C656D656E743B0A202020202020766172207265666572656E6365203D20656C656D656E7473427949645B722E69645D3B0A2020202020207661722070726F7065727479203D206765744D6F64646C6544657363726970746F7228';
wwv_flow_imp.g_varchar2_table(6845) := '656C656D656E74292E70726F7065727469657342794E616D655B722E70726F70657274795D3B0A0A20202020202069662028217265666572656E636529207B0A2020202020202020636F6E746578742E6164645761726E696E67287B0A20202020202020';
wwv_flow_imp.g_varchar2_table(6846) := '2020206D6573736167653A2027756E7265736F6C766564207265666572656E6365203C27202B20722E6964202B20273E272C0A20202020202020202020656C656D656E743A20722E656C656D656E742C0A2020202020202020202070726F70657274793A';
wwv_flow_imp.g_varchar2_table(6847) := '20722E70726F70657274792C0A2020202020202020202076616C75653A20722E69640A20202020202020207D293B0A2020202020207D0A0A2020202020206966202870726F70657274792E69734D616E7929207B0A202020202020202076617220636F6C';
wwv_flow_imp.g_varchar2_table(6848) := '6C656374696F6E203D20656C656D656E742E6765742870726F70657274792E6E616D65292C0A202020202020202020202020696478203D20636F6C6C656374696F6E2E696E6465784F662872293B0A0A20202020202020202F2F207765207265706C6163';
wwv_flow_imp.g_varchar2_table(6849) := '6520616E206578697374696E6720706C61636520686F6C646572202869647820213D202D3129206F720A20202020202020202F2F20617070656E6420746F2074686520636F6C6C656374696F6E20696E73746561640A2020202020202020696620286964';
wwv_flow_imp.g_varchar2_table(6850) := '78203D3D3D202D3129207B0A20202020202020202020696478203D20636F6C6C656374696F6E2E6C656E6774683B0A20202020202020207D0A0A202020202020202069662028217265666572656E636529207B0A0A202020202020202020202F2F207265';
wwv_flow_imp.g_varchar2_table(6851) := '6D6F766520756E7265736F6C7661626C65207265666572656E63650A20202020202020202020636F6C6C656374696F6E2E73706C696365286964782C2031293B0A20202020202020207D20656C7365207B0A0A202020202020202020202F2F2061646420';
wwv_flow_imp.g_varchar2_table(6852) := '6F7220757064617465207265666572656E636520696E20636F6C6C656374696F6E0A20202020202020202020636F6C6C656374696F6E5B6964785D203D207265666572656E63653B0A20202020202020207D0A2020202020207D20656C7365207B0A2020';
wwv_flow_imp.g_varchar2_table(6853) := '202020202020656C656D656E742E7365742870726F70657274792E6E616D652C207265666572656E6365293B0A2020202020207D0A202020207D0A20207D0A0A202066756E6374696F6E2068616E646C65436C6F73652829207B0A20202020737461636B';
wwv_flow_imp.g_varchar2_table(6854) := '2E706F7028292E68616E646C65456E6428293B0A20207D0A0A202076617220505245414D424C455F53544152545F5041545445524E203D202F5E3C5C3F786D6C202F693B0A0A202076617220454E434F44494E475F5041545445524E203D202F20656E63';
wwv_flow_imp.g_varchar2_table(6855) := '6F64696E673D22285B5E225D2B29222F693B0A0A2020766172205554465F385F5041545445524E203D202F5E7574662D38242F693B0A0A202066756E6374696F6E2068616E646C655175657374696F6E287175657374696F6E29207B0A0A202020206966';
wwv_flow_imp.g_varchar2_table(6856) := '202821505245414D424C455F53544152545F5041545445524E2E74657374287175657374696F6E2929207B0A20202020202072657475726E3B0A202020207D0A0A20202020766172206D61746368203D20454E434F44494E475F5041545445524E2E6578';
wwv_flow_imp.g_varchar2_table(6857) := '6563287175657374696F6E293B0A2020202076617220656E636F64696E67203D206D61746368202626206D617463685B315D3B0A0A202020206966202821656E636F64696E67207C7C205554465F385F5041545445524E2E7465737428656E636F64696E';
wwv_flow_imp.g_varchar2_table(6858) := '672929207B0A20202020202072657475726E3B0A202020207D0A0A20202020636F6E746578742E6164645761726E696E67287B0A2020202020206D6573736167653A0A202020202020202027756E737570706F7274656420646F63756D656E7420656E63';
wwv_flow_imp.g_varchar2_table(6859) := '6F64696E67203C27202B20656E636F64696E67202B20273E2C2027202B0A20202020202020202766616C6C696E67206261636B20746F205554462D38270A202020207D293B0A20207D0A0A202066756E6374696F6E2068616E646C654F70656E286E6F64';
wwv_flow_imp.g_varchar2_table(6860) := '652C20676574436F6E7465787429207B0A202020207661722068616E646C6572203D20737461636B2E7065656B28293B0A0A20202020747279207B0A202020202020737461636B2E707573682868616E646C65722E68616E646C654E6F6465286E6F6465';
wwv_flow_imp.g_varchar2_table(6861) := '29293B0A202020207D206361746368202865727229207B0A0A2020202020206966202868616E646C654572726F72286572722C20676574436F6E746578742C206C61782929207B0A2020202020202020737461636B2E70757368286E6577204E6F6F7048';
wwv_flow_imp.g_varchar2_table(6862) := '616E646C65722829293B0A2020202020207D0A202020207D0A20207D0A0A202066756E6374696F6E2068616E646C65434461746128746578742C20676574436F6E7465787429207B0A0A20202020747279207B0A202020202020737461636B2E7065656B';
wwv_flow_imp.g_varchar2_table(6863) := '28292E68616E646C65546578742874657874293B0A202020207D206361746368202865727229207B0A20202020202068616E646C655761726E696E67286572722C20676574436F6E74657874293B0A202020207D0A20207D0A0A202066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(6864) := '2068616E646C655465787428746578742C20676574436F6E7465787429207B0A0A202020202F2F2073747269702077686974657370616365206F6E6C79206E6F6465732C20692E652E206265666F72650A202020202F2F203C2143444154415B202E2E2E';
wwv_flow_imp.g_varchar2_table(6865) := '205D3E2073656374696F6E7320616E6420696E206265747765656E20746167730A0A202020206966202821746578742E7472696D282929207B0A20202020202072657475726E3B0A202020207D0A0A2020202068616E646C65434461746128746578742C';
wwv_flow_imp.g_varchar2_table(6866) := '20676574436F6E74657874293B0A20207D0A0A2020766172207572694D6170203D206D6F64656C2E6765745061636B6167657328292E7265647563652866756E6374696F6E287572694D61702C207029207B0A202020207572694D61705B702E7572695D';
wwv_flow_imp.g_varchar2_table(6867) := '203D20702E7072656669783B0A0A2020202072657475726E207572694D61703B0A20207D2C207B0A2020202027687474703A2F2F7777772E77332E6F72672F584D4C2F313939382F6E616D657370616365273A2027786D6C27202F2F2061646420646566';
wwv_flow_imp.g_varchar2_table(6868) := '61756C7420786D6C206E730A20207D293B0A20207061727365720A202020202E6E73287572694D6170290A202020202E6F6E28276F70656E546167272C2066756E6374696F6E286F626A2C206465636F64655374722C2073656C66436C6F73696E672C20';
wwv_flow_imp.g_varchar2_table(6869) := '676574436F6E7465787429207B0A0A2020202020202F2F20677261636566756C6C792068616E646C6520756E7061727361626C652061747472696275746573202861747472733D66616C7365290A202020202020766172206174747273203D206F626A2E';
wwv_flow_imp.g_varchar2_table(6870) := '6174747273207C7C207B7D3B0A0A202020202020766172206465636F6465644174747273203D204F626A6563742E6B657973286174747273292E7265647563652866756E6374696F6E28642C206B657929207B0A20202020202020207661722076616C75';
wwv_flow_imp.g_varchar2_table(6871) := '65203D206465636F64655374722861747472735B6B65795D293B0A0A2020202020202020645B6B65795D203D2076616C75653B0A0A202020202020202072657475726E20643B0A2020202020207D2C207B7D293B0A0A202020202020766172206E6F6465';
wwv_flow_imp.g_varchar2_table(6872) := '203D207B0A20202020202020206E616D653A206F626A2E6E616D652C0A20202020202020206F726967696E616C4E616D653A206F626A2E6F726967696E616C4E616D652C0A2020202020202020617474726962757465733A206465636F64656441747472';
wwv_flow_imp.g_varchar2_table(6873) := '732C0A20202020202020206E733A206F626A2E6E730A2020202020207D3B0A0A20202020202068616E646C654F70656E286E6F64652C20676574436F6E74657874293B0A202020207D290A202020202E6F6E28277175657374696F6E272C2068616E646C';
wwv_flow_imp.g_varchar2_table(6874) := '655175657374696F6E290A202020202E6F6E2827636C6F7365546167272C2068616E646C65436C6F7365290A202020202E6F6E28276364617461272C2068616E646C654344617461290A202020202E6F6E282774657874272C2066756E6374696F6E2874';
wwv_flow_imp.g_varchar2_table(6875) := '6578742C206465636F6465456E7469746965732C20676574436F6E7465787429207B0A20202020202068616E646C6554657874286465636F6465456E7469746965732874657874292C20676574436F6E74657874293B0A202020207D290A202020202E6F';
wwv_flow_imp.g_varchar2_table(6876) := '6E28276572726F72272C2068616E646C654572726F72290A202020202E6F6E28277761726E272C2068616E646C655761726E696E67293B0A0A20202F2F206173796E6320584D4C2070617273696E6720746F206D616B6520737572652074686520657865';
wwv_flow_imp.g_varchar2_table(6877) := '637574696F6E20656E7669726F6E6D656E740A20202F2F20286E6F6465206F722062726F77657229206973206B65707420726573706F6E7369766520616E642074686174206365727461696E206F7074696D697A6174696F6E0A20202F2F207374726174';
wwv_flow_imp.g_varchar2_table(6878) := '65676965732063616E206B69636B20696E2E0A202072657475726E206E65772050726F6D6973652866756E6374696F6E287265736F6C76652C2072656A65637429207B0A0A20202020766172206572723B0A0A20202020747279207B0A20202020202070';
wwv_flow_imp.g_varchar2_table(6879) := '61727365722E706172736528786D6C293B0A0A2020202020207265736F6C76655265666572656E63657328293B0A202020207D20636174636820286529207B0A202020202020657272203D20653B0A202020207D0A0A2020202076617220726F6F74456C';
wwv_flow_imp.g_varchar2_table(6880) := '656D656E74203D20726F6F7448616E646C65722E656C656D656E743B0A0A2020202069662028216572722026262021726F6F74456C656D656E7429207B0A202020202020657272203D206572726F7228276661696C656420746F20706172736520646F63';
wwv_flow_imp.g_varchar2_table(6881) := '756D656E74206173203C27202B20726F6F7448616E646C65722E747970652E2464657363726970746F722E6E616D65202B20273E27293B0A202020207D0A0A20202020766172207761726E696E6773203D20636F6E746578742E7761726E696E67733B0A';
wwv_flow_imp.g_varchar2_table(6882) := '20202020766172207265666572656E636573203D20636F6E746578742E7265666572656E6365733B0A2020202076617220656C656D656E747342794964203D20636F6E746578742E656C656D656E7473427949643B0A0A20202020696620286572722920';
wwv_flow_imp.g_varchar2_table(6883) := '7B0A2020202020206572722E7761726E696E6773203D207761726E696E67733B0A0A20202020202072657475726E2072656A65637428657272293B0A202020207D20656C7365207B0A20202020202072657475726E207265736F6C7665287B0A20202020';
wwv_flow_imp.g_varchar2_table(6884) := '20202020726F6F74456C656D656E743A20726F6F74456C656D656E742C0A2020202020202020656C656D656E7473427949643A20656C656D656E7473427949642C0A20202020202020207265666572656E6365733A207265666572656E6365732C0A2020';
wwv_flow_imp.g_varchar2_table(6885) := '2020202020207761726E696E67733A207761726E696E67730A2020202020207D293B0A202020207D0A20207D293B0A7D3B0A0A5265616465722E70726F746F747970652E68616E646C6572203D2066756E6374696F6E286E616D6529207B0A2020726574';
wwv_flow_imp.g_varchar2_table(6886) := '75726E206E657720526F6F74456C656D656E7448616E646C657228746869732E6D6F64656C2C206E616D65293B0A7D3B0A0A0A2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A66756E6374696F6E2063';
wwv_flow_imp.g_varchar2_table(6887) := '7265617465537461636B2829207B0A202076617220737461636B203D205B5D3B0A0A20204F626A6563742E646566696E6550726F706572747928737461636B2C20277065656B272C207B0A2020202076616C75653A2066756E6374696F6E2829207B0A20';
wwv_flow_imp.g_varchar2_table(6888) := '202020202072657475726E20746869735B746869732E6C656E677468202D20315D3B0A202020207D0A20207D293B0A0A202072657475726E20737461636B3B0A7D0A0A76617220584D4C5F505245414D424C45203D20273C3F786D6C2076657273696F6E';
wwv_flow_imp.g_varchar2_table(6889) := '3D22312E302220656E636F64696E673D225554462D38223F3E5C6E273B0A0A766172204553434150455F415454525F4348415253203D202F3C7C3E7C277C227C267C5C6E5C727C5C6E2F673B0A766172204553434150455F4348415253203D202F3C7C3E';
wwv_flow_imp.g_varchar2_table(6890) := '7C262F673B0A0A0A66756E6374696F6E204E616D6573706163657328706172656E7429207B0A0A2020766172207072656669784D6170203D207B7D3B0A2020766172207572694D6170203D207B7D3B0A20207661722075736564203D207B7D3B0A0A2020';
wwv_flow_imp.g_varchar2_table(6891) := '7661722077656C6C6B6E6F776E203D205B5D3B0A202076617220637573746F6D203D205B5D3B0A0A20202F2F204150490A0A2020746869732E6279557269203D2066756E6374696F6E2875726929207B0A2020202072657475726E207572694D61705B75';
wwv_flow_imp.g_varchar2_table(6892) := '72695D207C7C20280A202020202020706172656E7420262620706172656E742E627955726928757269290A20202020293B0A20207D3B0A0A2020746869732E616464203D2066756E6374696F6E286E732C20697357656C6C6B6E6F776E29207B0A0A2020';
wwv_flow_imp.g_varchar2_table(6893) := '20207572694D61705B6E732E7572695D203D206E733B0A0A2020202069662028697357656C6C6B6E6F776E29207B0A20202020202077656C6C6B6E6F776E2E70757368286E73293B0A202020207D20656C7365207B0A202020202020637573746F6D2E70';
wwv_flow_imp.g_varchar2_table(6894) := '757368286E73293B0A202020207D0A0A20202020746869732E6D6170507265666978286E732E7072656669782C206E732E757269293B0A20207D3B0A0A2020746869732E7572694279507265666978203D2066756E6374696F6E2870726566697829207B';
wwv_flow_imp.g_varchar2_table(6895) := '0A2020202072657475726E207072656669784D61705B707265666978207C7C2027786D6C6E73275D3B0A20207D3B0A0A2020746869732E6D6170507265666978203D2066756E6374696F6E287072656669782C2075726929207B0A202020207072656669';
wwv_flow_imp.g_varchar2_table(6896) := '784D61705B707265666978207C7C2027786D6C6E73275D203D207572693B0A20207D3B0A0A2020746869732E6765744E534B6579203D2066756E6374696F6E286E7329207B0A2020202072657475726E20286E732E70726566697820213D3D20756E6465';
wwv_flow_imp.g_varchar2_table(6897) := '66696E656429203F20286E732E757269202B20277C27202B206E732E70726566697829203A206E732E7572693B0A20207D3B0A0A2020746869732E6C6F6755736564203D2066756E6374696F6E286E7329207B0A0A2020202076617220757269203D206E';
wwv_flow_imp.g_varchar2_table(6898) := '732E7572693B0A20202020766172206E734B6579203D20746869732E6765744E534B6579286E73293B0A0A20202020757365645B6E734B65795D203D20746869732E627955726928757269293B0A0A202020202F2F20496E666F726D20706172656E7420';
wwv_flow_imp.g_varchar2_table(6899) := '7265637572736976656C792061626F757420746865207573616765206F662074686973204E530A2020202069662028706172656E7429207B0A202020202020706172656E742E6C6F6755736564286E73293B0A202020207D0A20207D3B0A0A2020746869';
wwv_flow_imp.g_varchar2_table(6900) := '732E67657455736564203D2066756E6374696F6E286E7329207B0A0A2020202066756E6374696F6E20697355736564286E7329207B0A202020202020766172206E734B6579203D2073656C662E6765744E534B6579286E73293B0A0A2020202020207265';
wwv_flow_imp.g_varchar2_table(6901) := '7475726E20757365645B6E734B65795D3B0A202020207D0A0A202020207661722073656C66203D20746869733B0A0A2020202076617220616C6C4E73203D205B5D2E636F6E6361742877656C6C6B6E6F776E2C20637573746F6D293B0A0A202020207265';
wwv_flow_imp.g_varchar2_table(6902) := '7475726E20616C6C4E732E66696C74657228697355736564293B0A20207D3B0A0A7D0A0A66756E6374696F6E206C6F77657228737472696E6729207B0A202072657475726E20737472696E672E6368617241742830292E746F4C6F776572436173652829';
wwv_flow_imp.g_varchar2_table(6903) := '202B20737472696E672E736C6963652831293B0A7D0A0A66756E6374696F6E206E616D65546F416C696173286E616D652C20706B6729207B0A2020696620286861734C6F77657243617365416C69617328706B672929207B0A2020202072657475726E20';
wwv_flow_imp.g_varchar2_table(6904) := '6C6F776572286E616D65293B0A20207D20656C7365207B0A2020202072657475726E206E616D653B0A20207D0A7D0A0A66756E6374696F6E20696E6865726974732863746F722C20737570657243746F7229207B0A202063746F722E73757065725F203D';
wwv_flow_imp.g_varchar2_table(6905) := '20737570657243746F723B0A202063746F722E70726F746F74797065203D204F626A6563742E63726561746528737570657243746F722E70726F746F747970652C207B0A20202020636F6E7374727563746F723A207B0A20202020202076616C75653A20';
wwv_flow_imp.g_varchar2_table(6906) := '63746F722C0A202020202020656E756D657261626C653A2066616C73652C0A2020202020207772697461626C653A20747275652C0A202020202020636F6E666967757261626C653A20747275650A202020207D0A20207D293B0A7D0A0A66756E6374696F';
wwv_flow_imp.g_varchar2_table(6907) := '6E206E734E616D65286E7329207B0A20206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6973537472696E6729286E732929207B0A2020202072657475726E206E733B0A20207D20656C';
wwv_flow_imp.g_varchar2_table(6908) := '7365207B0A2020202072657475726E20286E732E707265666978203F206E732E707265666978202B20273A27203A20272729202B206E732E6C6F63616C4E616D653B0A20207D0A7D0A0A66756E6374696F6E206765744E734174747273286E616D657370';
wwv_flow_imp.g_varchar2_table(6909) := '6163657329207B0A0A202072657475726E206E616D657370616365732E6765745573656428292E66696C7465722866756E6374696F6E286E7329207B0A0A202020202F2F20646F206E6F742073657269616C697A65206275696C7420696E203C786D6C3E';
wwv_flow_imp.g_varchar2_table(6910) := '206E616D6573706163650A2020202072657475726E206E732E70726566697820213D3D2027786D6C273B0A20207D292E6D61702866756E6374696F6E286E7329207B0A20202020766172206E616D65203D2027786D6C6E7327202B20286E732E70726566';
wwv_flow_imp.g_varchar2_table(6911) := '6978203F20273A27202B206E732E707265666978203A202727293B0A2020202072657475726E207B206E616D653A206E616D652C2076616C75653A206E732E757269207D3B0A20207D293B0A0A7D0A0A66756E6374696F6E20676574456C656D656E744E';
wwv_flow_imp.g_varchar2_table(6912) := '73286E732C2064657363726970746F7229207B0A20206966202864657363726970746F722E697347656E6572696329207B0A2020202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F';
wwv_flow_imp.g_varchar2_table(6913) := '5F2E61737369676E29287B206C6F63616C4E616D653A2064657363726970746F722E6E732E6C6F63616C4E616D65207D2C206E73293B0A20207D20656C7365207B0A2020202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D';
wwv_flow_imp.g_varchar2_table(6914) := '504F525445445F4D4F44554C455F325F5F2E61737369676E29287B206C6F63616C4E616D653A206E616D65546F416C6961732864657363726970746F722E6E732E6C6F63616C4E616D652C2064657363726970746F722E24706B6729207D2C206E73293B';
wwv_flow_imp.g_varchar2_table(6915) := '0A20207D0A7D0A0A66756E6374696F6E2067657450726F70657274794E73286E732C2064657363726970746F7229207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61';
wwv_flow_imp.g_varchar2_table(6916) := '737369676E29287B206C6F63616C4E616D653A2064657363726970746F722E6E732E6C6F63616C4E616D65207D2C206E73293B0A7D0A0A66756E6374696F6E2067657453657269616C697A61626C6550726F7065727469657328656C656D656E7429207B';
wwv_flow_imp.g_varchar2_table(6917) := '0A20207661722064657363726970746F72203D20656C656D656E742E2464657363726970746F723B0A0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E66696C7465722928';
wwv_flow_imp.g_varchar2_table(6918) := '64657363726970746F722E70726F706572746965732C2066756E6374696F6E287029207B0A20202020766172206E616D65203D20702E6E616D653B0A0A2020202069662028702E69735669727475616C29207B0A20202020202072657475726E2066616C';
wwv_flow_imp.g_varchar2_table(6919) := '73653B0A202020207D0A0A202020202F2F20646F206E6F742073657269616C697A652064656661756C74730A20202020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E686173292865';
wwv_flow_imp.g_varchar2_table(6920) := '6C656D656E742C206E616D652929207B0A20202020202072657475726E2066616C73653B0A202020207D0A0A202020207661722076616C7565203D20656C656D656E745B6E616D655D3B0A0A202020202F2F20646F206E6F742073657269616C697A6520';
wwv_flow_imp.g_varchar2_table(6921) := '64656661756C7420657175616C730A202020206966202876616C7565203D3D3D20702E64656661756C7429207B0A20202020202072657475726E2066616C73653B0A202020207D0A0A202020202F2F20646F206E6F742073657269616C697A65206E756C';
wwv_flow_imp.g_varchar2_table(6922) := '6C2070726F706572746965730A202020206966202876616C7565203D3D3D206E756C6C29207B0A20202020202072657475726E2066616C73653B0A202020207D0A0A2020202072657475726E20702E69734D616E79203F2076616C75652E6C656E677468';
wwv_flow_imp.g_varchar2_table(6923) := '203A20747275653B0A20207D293B0A7D0A0A766172204553434150455F415454525F4D4150203D207B0A2020275C6E273A2027233130272C0A2020275C6E5C72273A2027233130272C0A20202722273A2027233334272C0A2020275C27273A2027233339';
wwv_flow_imp.g_varchar2_table(6924) := '272C0A2020273C273A2027233630272C0A2020273E273A2027233632272C0A20202726273A2027233338270A7D3B0A0A766172204553434150455F4D4150203D207B0A2020273C273A20276C74272C0A2020273E273A20276774272C0A20202726273A20';
wwv_flow_imp.g_varchar2_table(6925) := '27616D70270A7D3B0A0A66756E6374696F6E20657363617065287374722C20636861725061747465726E2C207265706C6163654D617029207B0A0A20202F2F20656E73757265207765206172652068616E646C696E6720737472696E677320686572650A';
wwv_flow_imp.g_varchar2_table(6926) := '2020737472203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6973537472696E67292873747229203F20737472203A202727202B207374723B0A0A202072657475726E207374722E7265706C';
wwv_flow_imp.g_varchar2_table(6927) := '61636528636861725061747465726E2C2066756E6374696F6E287329207B0A2020202072657475726E20272627202B207265706C6163654D61705B735D202B20273B273B0A20207D293B0A7D0A0A2F2A2A0A202A20457363617065206120737472696E67';
wwv_flow_imp.g_varchar2_table(6928) := '2061747472696275746520746F206E6F7420636F6E7461696E20616E79206261642076616C75657320286C696E6520627265616B732C202722272C202E2E2E290A202A0A202A2040706172616D207B537472696E677D207374722074686520737472696E';
wwv_flow_imp.g_varchar2_table(6929) := '6720746F206573636170650A202A204072657475726E207B537472696E677D20746865206573636170656420737472696E670A202A2F0A66756E6374696F6E20657363617065417474722873747229207B0A202072657475726E20657363617065287374';
wwv_flow_imp.g_varchar2_table(6930) := '722C204553434150455F415454525F43484152532C204553434150455F415454525F4D4150293B0A7D0A0A66756E6374696F6E20657363617065426F64792873747229207B0A202072657475726E20657363617065287374722C204553434150455F4348';
wwv_flow_imp.g_varchar2_table(6931) := '4152532C204553434150455F4D4150293B0A7D0A0A66756E6374696F6E2066696C746572417474726962757465732870726F707329207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(6932) := '455F325F5F2E66696C746572292870726F70732C2066756E6374696F6E287029207B2072657475726E20702E6973417474723B207D293B0A7D0A0A66756E6374696F6E2066696C746572436F6E7461696E65642870726F707329207B0A20207265747572';
wwv_flow_imp.g_varchar2_table(6933) := '6E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E66696C746572292870726F70732C2066756E6374696F6E287029207B2072657475726E2021702E6973417474723B207D293B0A7D0A0A0A6675';
wwv_flow_imp.g_varchar2_table(6934) := '6E6374696F6E205265666572656E636553657269616C697A6572287461674E616D6529207B0A2020746869732E7461674E616D65203D207461674E616D653B0A7D0A0A5265666572656E636553657269616C697A65722E70726F746F747970652E627569';
wwv_flow_imp.g_varchar2_table(6935) := '6C64203D2066756E6374696F6E28656C656D656E7429207B0A2020746869732E656C656D656E74203D20656C656D656E743B0A202072657475726E20746869733B0A7D3B0A0A5265666572656E636553657269616C697A65722E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(6936) := '73657269616C697A65546F203D2066756E6374696F6E2877726974657229207B0A20207772697465720A202020202E617070656E64496E64656E7428290A202020202E617070656E6428273C27202B20746869732E7461674E616D65202B20273E27202B';
wwv_flow_imp.g_varchar2_table(6937) := '20746869732E656C656D656E742E6964202B20273C2F27202B20746869732E7461674E616D65202B20273E27290A202020202E617070656E644E65774C696E6528293B0A7D3B0A0A66756E6374696F6E20426F647953657269616C697A65722829207B7D';
wwv_flow_imp.g_varchar2_table(6938) := '0A0A426F647953657269616C697A65722E70726F746F747970652E73657269616C697A6556616C7565203D0A426F647953657269616C697A65722E70726F746F747970652E73657269616C697A65546F203D2066756E6374696F6E287772697465722920';
wwv_flow_imp.g_varchar2_table(6939) := '7B0A20207772697465722E617070656E64280A20202020746869732E6573636170650A2020202020203F20657363617065426F647928746869732E76616C7565290A2020202020203A20746869732E76616C75650A2020293B0A7D3B0A0A426F64795365';
wwv_flow_imp.g_varchar2_table(6940) := '7269616C697A65722E70726F746F747970652E6275696C64203D2066756E6374696F6E2870726F702C2076616C756529207B0A2020746869732E76616C7565203D2076616C75653B0A0A20206966202870726F702E74797065203D3D3D2027537472696E';
wwv_flow_imp.g_varchar2_table(6941) := '67272026262076616C75652E736561726368284553434150455F43484152532920213D3D202D3129207B0A20202020746869732E657363617065203D20747275653B0A20207D0A0A202072657475726E20746869733B0A7D3B0A0A66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(6942) := '56616C756553657269616C697A6572287461674E616D6529207B0A2020746869732E7461674E616D65203D207461674E616D653B0A7D0A0A696E6865726974732856616C756553657269616C697A65722C20426F647953657269616C697A6572293B0A0A';
wwv_flow_imp.g_varchar2_table(6943) := '56616C756553657269616C697A65722E70726F746F747970652E73657269616C697A65546F203D2066756E6374696F6E2877726974657229207B0A0A20207772697465720A202020202E617070656E64496E64656E7428290A202020202E617070656E64';
wwv_flow_imp.g_varchar2_table(6944) := '28273C27202B20746869732E7461674E616D65202B20273E27293B0A0A2020746869732E73657269616C697A6556616C756528777269746572293B0A0A20207772697465720A202020202E617070656E6428273C2F27202B20746869732E7461674E616D';
wwv_flow_imp.g_varchar2_table(6945) := '65202B20273E27290A202020202E617070656E644E65774C696E6528293B0A7D3B0A0A66756E6374696F6E20456C656D656E7453657269616C697A657228706172656E742C2070726F706572747944657363726970746F7229207B0A2020746869732E62';
wwv_flow_imp.g_varchar2_table(6946) := '6F6479203D205B5D3B0A2020746869732E6174747273203D205B5D3B0A0A2020746869732E706172656E74203D20706172656E743B0A2020746869732E70726F706572747944657363726970746F72203D2070726F706572747944657363726970746F72';
wwv_flow_imp.g_varchar2_table(6947) := '3B0A7D0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E6275696C64203D2066756E6374696F6E28656C656D656E7429207B0A2020746869732E656C656D656E74203D20656C656D656E743B0A0A202076617220656C656D656E';
wwv_flow_imp.g_varchar2_table(6948) := '7444657363726970746F72203D20656C656D656E742E2464657363726970746F722C0A20202020202070726F706572747944657363726970746F72203D20746869732E70726F706572747944657363726970746F723B0A0A2020766172206F7468657241';
wwv_flow_imp.g_varchar2_table(6949) := '747472732C0A20202020202070726F706572746965733B0A0A202076617220697347656E65726963203D20656C656D656E7444657363726970746F722E697347656E657269633B0A0A202069662028697347656E6572696329207B0A202020206F746865';
wwv_flow_imp.g_varchar2_table(6950) := '724174747273203D20746869732E706172736547656E6572696328656C656D656E74293B0A20207D20656C7365207B0A202020206F746865724174747273203D20746869732E70617273654E734174747269627574657328656C656D656E74293B0A2020';
wwv_flow_imp.g_varchar2_table(6951) := '7D0A0A20206966202870726F706572747944657363726970746F7229207B0A20202020746869732E6E73203D20746869732E6E7350726F70657274795461674E616D652870726F706572747944657363726970746F72293B0A20207D20656C7365207B0A';
wwv_flow_imp.g_varchar2_table(6952) := '20202020746869732E6E73203D20746869732E6E735461674E616D6528656C656D656E7444657363726970746F72293B0A20207D0A0A20202F2F20636F6D7075746520746167206E616D650A2020746869732E7461674E616D65203D20746869732E6164';
wwv_flow_imp.g_varchar2_table(6953) := '645461674E616D6528746869732E6E73293B0A0A20206966202821697347656E6572696329207B0A2020202070726F70657274696573203D2067657453657269616C697A61626C6550726F7065727469657328656C656D656E74293B0A0A202020207468';
wwv_flow_imp.g_varchar2_table(6954) := '69732E7061727365417474726962757465732866696C746572417474726962757465732870726F7065727469657329293B0A20202020746869732E7061727365436F6E7461696E6D656E74732866696C746572436F6E7461696E65642870726F70657274';
wwv_flow_imp.g_varchar2_table(6955) := '69657329293B0A20207D0A0A2020746869732E706172736547656E657269634174747269627574657328656C656D656E742C206F746865724174747273293B0A0A202072657475726E20746869733B0A7D3B0A0A456C656D656E7453657269616C697A65';
wwv_flow_imp.g_varchar2_table(6956) := '722E70726F746F747970652E6E735461674E616D65203D2066756E6374696F6E2864657363726970746F7229207B0A2020766172206566666563746976654E73203D20746869732E6C6F674E616D657370616365557365642864657363726970746F722E';
wwv_flow_imp.g_varchar2_table(6957) := '6E73293B0A202072657475726E20676574456C656D656E744E73286566666563746976654E732C2064657363726970746F72293B0A7D3B0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E6E7350726F70657274795461674E61';
wwv_flow_imp.g_varchar2_table(6958) := '6D65203D2066756E6374696F6E2864657363726970746F7229207B0A2020766172206566666563746976654E73203D20746869732E6C6F674E616D657370616365557365642864657363726970746F722E6E73293B0A202072657475726E206765745072';
wwv_flow_imp.g_varchar2_table(6959) := '6F70657274794E73286566666563746976654E732C2064657363726970746F72293B0A7D3B0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E69734C6F63616C4E73203D2066756E6374696F6E286E7329207B0A202072657475';
wwv_flow_imp.g_varchar2_table(6960) := '726E206E732E757269203D3D3D20746869732E6E732E7572693B0A7D3B0A0A2F2A2A0A202A20476574207468652061637475616C206E7320617474726962757465206E616D6520666F722074686520676976656E20656C656D656E742E0A202A0A202A20';
wwv_flow_imp.g_varchar2_table(6961) := '40706172616D207B4F626A6563747D20656C656D656E740A202A2040706172616D207B426F6F6C65616E7D205B656C656D656E742E696E686572697465643D66616C73655D0A202A0A202A204072657475726E207B4F626A6563747D206E734E616D650A';
wwv_flow_imp.g_varchar2_table(6962) := '202A2F0A456C656D656E7453657269616C697A65722E70726F746F747970652E6E734174747269627574654E616D65203D2066756E6374696F6E28656C656D656E7429207B0A0A2020766172206E733B0A0A20206966202828302C6D696E5F646173685F';
wwv_flow_imp.g_varchar2_table(6963) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6973537472696E672928656C656D656E742929207B0A202020206E73203D2028302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E70';
wwv_flow_imp.g_varchar2_table(6964) := '617273654E616D654E532928656C656D656E74293B0A20207D20656C7365207B0A202020206E73203D20656C656D656E742E6E733B0A20207D0A0A20202F2F2072657475726E206A757374206C6F63616C206E616D6520666F7220696E68657269746564';
wwv_flow_imp.g_varchar2_table(6965) := '20617474726962757465730A202069662028656C656D656E742E696E6865726974656429207B0A2020202072657475726E207B206C6F63616C4E616D653A206E732E6C6F63616C4E616D65207D3B0A20207D0A0A20202F2F207061727365202B206C6F67';
wwv_flow_imp.g_varchar2_table(6966) := '20656666656374697665206E730A2020766172206566666563746976654E73203D20746869732E6C6F674E616D65737061636555736564286E73293B0A0A20202F2F204C4F472041435455414C206E616D657370616365207573650A2020746869732E67';
wwv_flow_imp.g_varchar2_table(6967) := '65744E616D6573706163657328292E6C6F6755736564286566666563746976654E73293B0A0A20202F2F207374726970207072656669782069662073616D65206E616D657370616365206C696B6520706172656E740A202069662028746869732E69734C';
wwv_flow_imp.g_varchar2_table(6968) := '6F63616C4E73286566666563746976654E732929207B0A2020202072657475726E207B206C6F63616C4E616D653A206E732E6C6F63616C4E616D65207D3B0A20207D20656C7365207B0A2020202072657475726E2028302C6D696E5F646173685F5F5745';
wwv_flow_imp.g_varchar2_table(6969) := '425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E29287B206C6F63616C4E616D653A206E732E6C6F63616C4E616D65207D2C206566666563746976654E73293B0A20207D0A7D3B0A0A456C656D656E7453657269616C697A';
wwv_flow_imp.g_varchar2_table(6970) := '65722E70726F746F747970652E706172736547656E65726963203D2066756E6374696F6E28656C656D656E7429207B0A0A20207661722073656C66203D20746869732C0A202020202020626F6479203D20746869732E626F64793B0A0A20207661722061';
wwv_flow_imp.g_varchar2_table(6971) := '747472696275746573203D205B5D3B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E666F72456163682928656C656D656E742C2066756E6374696F6E2876616C2C206B657929207B0A0A';
wwv_flow_imp.g_varchar2_table(6972) := '20202020766172206E6F6E4E73417474723B0A0A20202020696620286B6579203D3D3D202724626F64792729207B0A202020202020626F64792E70757368286E657720426F647953657269616C697A657228292E6275696C64287B20747970653A202753';
wwv_flow_imp.g_varchar2_table(6973) := '7472696E6727207D2C2076616C29293B0A202020207D20656C73650A20202020696620286B6579203D3D3D2027246368696C6472656E2729207B0A20202020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(6974) := '455F325F5F2E666F7245616368292876616C2C2066756E6374696F6E286368696C6429207B0A2020202020202020626F64792E70757368286E657720456C656D656E7453657269616C697A65722873656C66292E6275696C64286368696C6429293B0A20';
wwv_flow_imp.g_varchar2_table(6975) := '20202020207D293B0A202020207D20656C73650A20202020696620286B65792E696E6465784F66282724272920213D3D203029207B0A2020202020206E6F6E4E7341747472203D2073656C662E70617273654E7341747472696275746528656C656D656E';
wwv_flow_imp.g_varchar2_table(6976) := '742C206B65792C2076616C293B0A0A202020202020696620286E6F6E4E734174747229207B0A2020202020202020617474726962757465732E70757368287B206E616D653A206B65792C2076616C75653A2076616C207D293B0A2020202020207D0A2020';
wwv_flow_imp.g_varchar2_table(6977) := '20207D0A20207D293B0A0A202072657475726E20617474726962757465733B0A7D3B0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E70617273654E73417474726962757465203D2066756E6374696F6E28656C656D656E742C';
wwv_flow_imp.g_varchar2_table(6978) := '206E616D652C2076616C756529207B0A2020766172206D6F64656C203D20656C656D656E742E246D6F64656C3B0A0A2020766172206E616D654E73203D2028302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F';
wwv_flow_imp.g_varchar2_table(6979) := '2E70617273654E616D654E5329286E616D65293B0A0A2020766172206E733B0A0A20202F2F20706172736520786D6C6E733A666F6F3D22687474703A2F2F666F6F2E626172220A2020696620286E616D654E732E707265666978203D3D3D2027786D6C6E';
wwv_flow_imp.g_varchar2_table(6980) := '732729207B0A202020206E73203D207B207072656669783A206E616D654E732E6C6F63616C4E616D652C207572693A2076616C7565207D3B0A20207D0A0A20202F2F20706172736520786D6C6E733D22687474703A2F2F666F6F2E626172220A20206966';
wwv_flow_imp.g_varchar2_table(6981) := '2028216E616D654E732E707265666978202626206E616D654E732E6C6F63616C4E616D65203D3D3D2027786D6C6E732729207B0A202020206E73203D207B207572693A2076616C7565207D3B0A20207D0A0A202069662028216E7329207B0A2020202072';
wwv_flow_imp.g_varchar2_table(6982) := '657475726E207B0A2020202020206E616D653A206E616D652C0A20202020202076616C75653A2076616C75650A202020207D3B0A20207D0A0A2020696620286D6F64656C202626206D6F64656C2E6765745061636B6167652876616C75652929207B0A0A';
wwv_flow_imp.g_varchar2_table(6983) := '202020202F2F2072656769737465722077656C6C206B6E6F776E206E616D6573706163650A20202020746869732E6C6F674E616D657370616365286E732C20747275652C2074727565293B0A20207D20656C7365207B0A0A202020202F2F206C6F672063';
wwv_flow_imp.g_varchar2_table(6984) := '7573746F6D206E616D657370616365206469726563746C7920617320757365640A202020207661722061637475616C4E73203D20746869732E6C6F674E616D65737061636555736564286E732C2074727565293B0A0A20202020746869732E6765744E61';
wwv_flow_imp.g_varchar2_table(6985) := '6D6573706163657328292E6C6F67557365642861637475616C4E73293B0A20207D0A7D3B0A0A0A2F2A2A0A202A205061727365206E616D6573706163657320616E642072657475726E2061206C697374206F66206C656674206F7665722067656E657269';
wwv_flow_imp.g_varchar2_table(6986) := '6320617474726962757465730A202A0A202A2040706172616D20207B4F626A6563747D20656C656D656E740A202A204072657475726E207B41727261793C4F626A6563743E7D0A202A2F0A456C656D656E7453657269616C697A65722E70726F746F7479';
wwv_flow_imp.g_varchar2_table(6987) := '70652E70617273654E7341747472696275746573203D2066756E6374696F6E28656C656D656E742C20617474727329207B0A20207661722073656C66203D20746869733B0A0A20207661722067656E657269634174747273203D20656C656D656E742E24';
wwv_flow_imp.g_varchar2_table(6988) := '61747472733B0A0A20207661722061747472696275746573203D205B5D3B0A0A20202F2F207061727365206E616D65737061636520617474726962757465732066697273740A20202F2F20616E64206C6F67207468656D2E2070757368206E6F6E206E61';
wwv_flow_imp.g_varchar2_table(6989) := '6D657370616365206174747269627574657320746F2061206C6973740A20202F2F20616E642070726F63657373207468656D206C617465720A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E';
wwv_flow_imp.g_varchar2_table(6990) := '666F7245616368292867656E6572696341747472732C2066756E6374696F6E2876616C75652C206E616D6529207B0A0A20202020766172206E6F6E4E7341747472203D2073656C662E70617273654E7341747472696275746528656C656D656E742C206E';
wwv_flow_imp.g_varchar2_table(6991) := '616D652C2076616C7565293B0A0A20202020696620286E6F6E4E734174747229207B0A202020202020617474726962757465732E70757368286E6F6E4E7341747472293B0A202020207D0A20207D293B0A0A202072657475726E20617474726962757465';
wwv_flow_imp.g_varchar2_table(6992) := '733B0A7D3B0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E706172736547656E6572696341747472696275746573203D2066756E6374696F6E28656C656D656E742C206174747269627574657329207B0A0A20207661722073';
wwv_flow_imp.g_varchar2_table(6993) := '656C66203D20746869733B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E666F72456163682928617474726962757465732C2066756E6374696F6E286174747229207B0A0A202020202F';
wwv_flow_imp.g_varchar2_table(6994) := '2F20646F206E6F742073657269616C697A65207873693A74797065206174747269627574650A202020202F2F20697420697320736574206D616E75616C6C79206261736564206F6E207468652061637475616C20696D706C656D656E746174696F6E2074';
wwv_flow_imp.g_varchar2_table(6995) := '7970650A2020202069662028617474722E6E616D65203D3D3D205853495F5459504529207B0A20202020202072657475726E3B0A202020207D0A0A20202020747279207B0A20202020202073656C662E6164644174747269627574652873656C662E6E73';
wwv_flow_imp.g_varchar2_table(6996) := '4174747269627574654E616D6528617474722E6E616D65292C20617474722E76616C7565293B0A202020207D20636174636820286529207B0A2020202020202F2A20676C6F62616C20636F6E736F6C65202A2F0A0A202020202020636F6E736F6C652E77';
wwv_flow_imp.g_varchar2_table(6997) := '61726E280A2020202020202020276D697373696E67206E616D65737061636520696E666F726D6174696F6E20666F7220272C0A2020202020202020617474722E6E616D652C20273D272C20617474722E76616C75652C20276F6E272C20656C656D656E74';
wwv_flow_imp.g_varchar2_table(6998) := '2C0A202020202020202065293B0A202020207D0A20207D293B0A7D3B0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E7061727365436F6E7461696E6D656E7473203D2066756E6374696F6E2870726F7065727469657329207B';
wwv_flow_imp.g_varchar2_table(6999) := '0A0A20207661722073656C66203D20746869732C0A202020202020626F6479203D20746869732E626F64792C0A202020202020656C656D656E74203D20746869732E656C656D656E743B0A0A202028302C6D696E5F646173685F5F5745425041434B5F49';
wwv_flow_imp.g_varchar2_table(7000) := '4D504F525445445F4D4F44554C455F325F5F2E666F7245616368292870726F706572746965732C2066756E6374696F6E287029207B0A202020207661722076616C7565203D20656C656D656E742E67657428702E6E616D65292C0A202020202020202069';
wwv_flow_imp.g_varchar2_table(7001) := '735265666572656E6365203D20702E69735265666572656E63652C0A202020202020202069734D616E79203D20702E69734D616E793B0A0A20202020696620282169734D616E7929207B0A20202020202076616C7565203D205B2076616C7565205D3B0A';
wwv_flow_imp.g_varchar2_table(7002) := '202020207D0A0A2020202069662028702E6973426F647929207B0A202020202020626F64792E70757368286E657720426F647953657269616C697A657228292E6275696C6428702C2076616C75655B305D29293B0A202020207D20656C73650A20202020';
wwv_flow_imp.g_varchar2_table(7003) := '6966202828302C6D6F64646C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F2E697353696D706C65547970652928702E747970652929207B0A20202020202028302C6D696E5F646173685F5F5745425041434B5F494D504F52';
wwv_flow_imp.g_varchar2_table(7004) := '5445445F4D4F44554C455F325F5F2E666F7245616368292876616C75652C2066756E6374696F6E287629207B0A2020202020202020626F64792E70757368286E65772056616C756553657269616C697A65722873656C662E6164645461674E616D652873';
wwv_flow_imp.g_varchar2_table(7005) := '656C662E6E7350726F70657274795461674E616D6528702929292E6275696C6428702C207629293B0A2020202020207D293B0A202020207D20656C73650A202020206966202869735265666572656E636529207B0A20202020202028302C6D696E5F6461';
wwv_flow_imp.g_varchar2_table(7006) := '73685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E666F7245616368292876616C75652C2066756E6374696F6E287629207B0A2020202020202020626F64792E70757368286E6577205265666572656E636553657269616C69';
wwv_flow_imp.g_varchar2_table(7007) := '7A65722873656C662E6164645461674E616D652873656C662E6E7350726F70657274795461674E616D6528702929292E6275696C64287629293B0A2020202020207D293B0A202020207D20656C7365207B0A0A2020202020202F2F20616C6C6F77207365';
wwv_flow_imp.g_varchar2_table(7008) := '7269616C697A6174696F6E2076696120747970650A2020202020202F2F20726174686572207468616E20656C656D656E74206E616D650A20202020202076617220617354797065203D2073657269616C697A654173547970652870292C0A202020202020';
wwv_flow_imp.g_varchar2_table(7009) := '20202020617350726F7065727479203D2073657269616C697A65417350726F70657274792870293B0A0A20202020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E666F724561636829287661';
wwv_flow_imp.g_varchar2_table(7010) := '6C75652C2066756E6374696F6E287629207B0A20202020202020207661722073657269616C697A65723B0A0A20202020202020206966202861735479706529207B0A2020202020202020202073657269616C697A6572203D206E65772054797065536572';
wwv_flow_imp.g_varchar2_table(7011) := '69616C697A65722873656C662C2070293B0A20202020202020207D20656C73650A202020202020202069662028617350726F706572747929207B0A2020202020202020202073657269616C697A6572203D206E657720456C656D656E7453657269616C69';
wwv_flow_imp.g_varchar2_table(7012) := '7A65722873656C662C2070293B0A20202020202020207D20656C7365207B0A2020202020202020202073657269616C697A6572203D206E657720456C656D656E7453657269616C697A65722873656C66293B0A20202020202020207D0A0A202020202020';
wwv_flow_imp.g_varchar2_table(7013) := '2020626F64792E707573682873657269616C697A65722E6275696C64287629293B0A2020202020207D293B0A202020207D0A20207D293B0A7D3B0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E6765744E616D657370616365';
wwv_flow_imp.g_varchar2_table(7014) := '73203D2066756E6374696F6E286C6F63616C29207B0A0A2020766172206E616D65737061636573203D20746869732E6E616D657370616365732C0A202020202020706172656E74203D20746869732E706172656E742C0A202020202020706172656E744E';
wwv_flow_imp.g_varchar2_table(7015) := '616D657370616365733B0A0A202069662028216E616D6573706163657329207B0A20202020706172656E744E616D65737061636573203D20706172656E7420262620706172656E742E6765744E616D6573706163657328293B0A0A20202020696620286C';
wwv_flow_imp.g_varchar2_table(7016) := '6F63616C207C7C2021706172656E744E616D6573706163657329207B0A202020202020746869732E6E616D65737061636573203D206E616D65737061636573203D206E6577204E616D6573706163657328706172656E744E616D65737061636573293B0A';
wwv_flow_imp.g_varchar2_table(7017) := '202020207D20656C7365207B0A2020202020206E616D65737061636573203D20706172656E744E616D657370616365733B0A202020207D0A20207D0A0A202072657475726E206E616D657370616365733B0A7D3B0A0A456C656D656E7453657269616C69';
wwv_flow_imp.g_varchar2_table(7018) := '7A65722E70726F746F747970652E6C6F674E616D657370616365203D2066756E6374696F6E286E732C2077656C6C6B6E6F776E2C206C6F63616C29207B0A2020766172206E616D65737061636573203D20746869732E6765744E616D6573706163657328';
wwv_flow_imp.g_varchar2_table(7019) := '6C6F63616C293B0A0A2020766172206E73557269203D206E732E7572692C0A2020202020206E73507265666978203D206E732E7072656669783B0A0A2020766172206578697374696E67203D206E616D657370616365732E6279557269286E7355726929';
wwv_flow_imp.g_varchar2_table(7020) := '3B0A0A202069662028216578697374696E67207C7C206C6F63616C29207B0A202020206E616D657370616365732E616464286E732C2077656C6C6B6E6F776E293B0A20207D0A0A20206E616D657370616365732E6D6170507265666978286E7350726566';
wwv_flow_imp.g_varchar2_table(7021) := '69782C206E73557269293B0A0A202072657475726E206E733B0A7D3B0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E6C6F674E616D65737061636555736564203D2066756E6374696F6E286E732C206C6F63616C29207B0A20';
wwv_flow_imp.g_varchar2_table(7022) := '2076617220656C656D656E74203D20746869732E656C656D656E742C0A2020202020206D6F64656C203D20656C656D656E742E246D6F64656C2C0A2020202020206E616D65737061636573203D20746869732E6765744E616D65737061636573286C6F63';
wwv_flow_imp.g_varchar2_table(7023) := '616C293B0A0A20202F2F206E73206D61792062650A20202F2F0A20202F2F2020202A20707265666978206F6E6C790A20202F2F2020202A207072656669783A7572690A20202F2F2020202A206C6F63616C4E616D65206F6E6C790A0A2020766172207072';
wwv_flow_imp.g_varchar2_table(7024) := '65666978203D206E732E7072656669782C0A202020202020757269203D206E732E7572692C0A2020202020206E65775072656669782C206964782C0A20202020202077656C6C6B6E6F776E5572693B0A0A20202F2F2068616E646C6520616E6F6E796D6F';
wwv_flow_imp.g_varchar2_table(7025) := '7573206E616D657370616365732028656C656D656E74466F726D3D756E7175616C6966696564292C2063662E202332330A20206966202821707265666978202626202175726929207B0A2020202072657475726E207B206C6F63616C4E616D653A206E73';
wwv_flow_imp.g_varchar2_table(7026) := '2E6C6F63616C4E616D65207D3B0A20207D0A0A202077656C6C6B6E6F776E557269203D2044454641554C545F4E535F4D41505B7072656669785D207C7C206D6F64656C20262620286D6F64656C2E6765745061636B6167652870726566697829207C7C20';
wwv_flow_imp.g_varchar2_table(7027) := '7B7D292E7572693B0A0A2020757269203D20757269207C7C2077656C6C6B6E6F776E557269207C7C206E616D657370616365732E757269427950726566697828707265666978293B0A0A2020696620282175726929207B0A202020207468726F77206E65';
wwv_flow_imp.g_varchar2_table(7028) := '77204572726F7228276E6F206E616D6573706163652075726920676976656E20666F7220707265666978203C27202B20707265666978202B20273E27293B0A20207D0A0A20206E73203D206E616D657370616365732E627955726928757269293B0A0A20';
wwv_flow_imp.g_varchar2_table(7029) := '2069662028216E7329207B0A202020206E6577507265666978203D207072656669783B0A20202020696478203D20313B0A0A202020202F2F2066696E642061207072656669782074686174206973206E6F74206D6170706564207965740A202020207768';
wwv_flow_imp.g_varchar2_table(7030) := '696C6520286E616D657370616365732E7572694279507265666978286E65775072656669782929207B0A2020202020206E6577507265666978203D20707265666978202B20275F27202B206964782B2B3B0A202020207D0A0A202020206E73203D207468';
wwv_flow_imp.g_varchar2_table(7031) := '69732E6C6F674E616D657370616365287B207072656669783A206E65775072656669782C207572693A20757269207D2C2077656C6C6B6E6F776E557269203D3D3D20757269293B0A20207D0A0A20206966202870726566697829207B0A202020206E616D';
wwv_flow_imp.g_varchar2_table(7032) := '657370616365732E6D6170507265666978287072656669782C20757269293B0A20207D0A0A202072657475726E206E733B0A7D3B0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E706172736541747472696275746573203D20';
wwv_flow_imp.g_varchar2_table(7033) := '66756E6374696F6E2870726F7065727469657329207B0A20207661722073656C66203D20746869732C0A202020202020656C656D656E74203D20746869732E656C656D656E743B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(7034) := '525445445F4D4F44554C455F325F5F2E666F7245616368292870726F706572746965732C2066756E6374696F6E287029207B0A0A202020207661722076616C7565203D20656C656D656E742E67657428702E6E616D65293B0A0A2020202069662028702E';
wwv_flow_imp.g_varchar2_table(7035) := '69735265666572656E636529207B0A0A2020202020206966202821702E69734D616E7929207B0A202020202020202076616C7565203D2076616C75652E69643B0A2020202020207D0A202020202020656C7365207B0A2020202020202020766172207661';
wwv_flow_imp.g_varchar2_table(7036) := '6C756573203D205B5D3B0A202020202020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E666F7245616368292876616C75652C2066756E6374696F6E287629207B0A20202020202020202020';
wwv_flow_imp.g_varchar2_table(7037) := '76616C7565732E7075736828762E6964293B0A20202020202020207D293B0A0A20202020202020202F2F20494452454653206973206120776869746573706163652D736570617261746564206C697374206F66207265666572656E6365732E0A20202020';
wwv_flow_imp.g_varchar2_table(7038) := '2020202076616C7565203D2076616C7565732E6A6F696E28272027293B0A2020202020207D0A0A202020207D0A0A2020202073656C662E6164644174747269627574652873656C662E6E734174747269627574654E616D652870292C2076616C7565293B';
wwv_flow_imp.g_varchar2_table(7039) := '0A20207D293B0A7D3B0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E6164645461674E616D65203D2066756E6374696F6E286E735461674E616D6529207B0A20207661722061637475616C4E73203D20746869732E6C6F674E';
wwv_flow_imp.g_varchar2_table(7040) := '616D65737061636555736564286E735461674E616D65293B0A0A2020746869732E6765744E616D6573706163657328292E6C6F67557365642861637475616C4E73293B0A0A202072657475726E206E734E616D65286E735461674E616D65293B0A7D3B0A';
wwv_flow_imp.g_varchar2_table(7041) := '0A456C656D656E7453657269616C697A65722E70726F746F747970652E616464417474726962757465203D2066756E6374696F6E286E616D652C2076616C756529207B0A2020766172206174747273203D20746869732E61747472733B0A0A2020696620';
wwv_flow_imp.g_varchar2_table(7042) := '2828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E6973537472696E67292876616C75652929207B0A2020202076616C7565203D20657363617065417474722876616C7565293B0A20207D0A0A2020';
wwv_flow_imp.g_varchar2_table(7043) := '2F2F2064652D6475706C696361746520617474726962757465730A20202F2F2068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F6D6F64646C652D786D6C2F6973737565732F36360A202076617220696478203D2028302C6D696E5F64';
wwv_flow_imp.g_varchar2_table(7044) := '6173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E66696E64496E646578292861747472732C2066756E6374696F6E28656C656D656E7429207B0A2020202072657475726E20280A202020202020656C656D656E742E6E61';
wwv_flow_imp.g_varchar2_table(7045) := '6D652E6C6F63616C4E616D65203D3D3D206E616D652E6C6F63616C4E616D652026260A202020202020656C656D656E742E6E616D652E757269203D3D3D206E616D652E7572692026260A202020202020656C656D656E742E6E616D652E70726566697820';
wwv_flow_imp.g_varchar2_table(7046) := '3D3D3D206E616D652E7072656669780A20202020293B0A20207D293B0A0A20207661722061747472203D207B206E616D653A206E616D652C2076616C75653A2076616C7565207D3B0A0A20206966202869647820213D3D202D3129207B0A202020206174';
wwv_flow_imp.g_varchar2_table(7047) := '7472732E73706C696365286964782C20312C2061747472293B0A20207D20656C7365207B0A2020202061747472732E707573682861747472293B0A20207D0A7D3B0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E7365726961';
wwv_flow_imp.g_varchar2_table(7048) := '6C697A6541747472696275746573203D2066756E6374696F6E2877726974657229207B0A2020766172206174747273203D20746869732E61747472732C0A2020202020206E616D65737061636573203D20746869732E6E616D657370616365733B0A0A20';
wwv_flow_imp.g_varchar2_table(7049) := '20696620286E616D6573706163657329207B0A202020206174747273203D206765744E734174747273286E616D65737061636573292E636F6E636174286174747273293B0A20207D0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D50';
wwv_flow_imp.g_varchar2_table(7050) := '4F525445445F4D4F44554C455F325F5F2E666F7245616368292861747472732C2066756E6374696F6E286129207B0A202020207772697465720A2020202020202E617070656E6428272027290A2020202020202E617070656E64286E734E616D6528612E';
wwv_flow_imp.g_varchar2_table(7051) := '6E616D6529292E617070656E6428273D2227292E617070656E6428612E76616C7565292E617070656E6428272227293B0A20207D293B0A7D3B0A0A456C656D656E7453657269616C697A65722E70726F746F747970652E73657269616C697A65546F203D';
wwv_flow_imp.g_varchar2_table(7052) := '2066756E6374696F6E2877726974657229207B0A2020766172206669727374426F6479203D20746869732E626F64795B305D2C0A202020202020696E64656E74203D206669727374426F6479202626206669727374426F64792E636F6E7374727563746F';
wwv_flow_imp.g_varchar2_table(7053) := '7220213D3D20426F647953657269616C697A65723B0A0A20207772697465720A202020202E617070656E64496E64656E7428290A202020202E617070656E6428273C27202B20746869732E7461674E616D65293B0A0A2020746869732E73657269616C69';
wwv_flow_imp.g_varchar2_table(7054) := '7A654174747269627574657328777269746572293B0A0A20207772697465722E617070656E64286669727374426F6479203F20273E27203A2027202F3E27293B0A0A2020696620286669727374426F647929207B0A0A2020202069662028696E64656E74';
wwv_flow_imp.g_varchar2_table(7055) := '29207B0A2020202020207772697465720A20202020202020202E617070656E644E65774C696E6528290A20202020202020202E696E64656E7428293B0A202020207D0A0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(7056) := '445F4D4F44554C455F325F5F2E666F72456163682928746869732E626F64792C2066756E6374696F6E286229207B0A202020202020622E73657269616C697A65546F28777269746572293B0A202020207D293B0A0A2020202069662028696E64656E7429';
wwv_flow_imp.g_varchar2_table(7057) := '207B0A2020202020207772697465720A20202020202020202E756E696E64656E7428290A20202020202020202E617070656E64496E64656E7428293B0A202020207D0A0A202020207772697465722E617070656E6428273C2F27202B20746869732E7461';
wwv_flow_imp.g_varchar2_table(7058) := '674E616D65202B20273E27293B0A20207D0A0A20207772697465722E617070656E644E65774C696E6528293B0A7D3B0A0A2F2A2A0A202A20412073657269616C697A657220666F7220747970657320746861742068616E646C65732073657269616C697A';
wwv_flow_imp.g_varchar2_table(7059) := '6174696F6E206F6620646174612074797065730A202A2F0A66756E6374696F6E205479706553657269616C697A657228706172656E742C2070726F706572747944657363726970746F7229207B0A2020456C656D656E7453657269616C697A65722E6361';
wwv_flow_imp.g_varchar2_table(7060) := '6C6C28746869732C20706172656E742C2070726F706572747944657363726970746F72293B0A7D0A0A696E686572697473285479706553657269616C697A65722C20456C656D656E7453657269616C697A6572293B0A0A5479706553657269616C697A65';
wwv_flow_imp.g_varchar2_table(7061) := '722E70726F746F747970652E70617273654E7341747472696275746573203D2066756E6374696F6E28656C656D656E7429207B0A0A20202F2F2065787472616374656420617474726962757465730A20207661722061747472696275746573203D20456C';
wwv_flow_imp.g_varchar2_table(7062) := '656D656E7453657269616C697A65722E70726F746F747970652E70617273654E73417474726962757465732E63616C6C28746869732C20656C656D656E74293B0A0A20207661722064657363726970746F72203D20656C656D656E742E24646573637269';
wwv_flow_imp.g_varchar2_table(7063) := '70746F723B0A0A20202F2F206F6E6C792073657269616C697A65207873693A74797065206966206E65636573736172790A20206966202864657363726970746F722E6E616D65203D3D3D20746869732E70726F706572747944657363726970746F722E74';
wwv_flow_imp.g_varchar2_table(7064) := '79706529207B0A2020202072657475726E20617474726962757465733B0A20207D0A0A202076617220747970654E73203D20746869732E747970654E73203D20746869732E6E735461674E616D652864657363726970746F72293B0A2020746869732E67';
wwv_flow_imp.g_varchar2_table(7065) := '65744E616D6573706163657328292E6C6F675573656428746869732E747970654E73293B0A0A20202F2F20616464207873693A747970652061747472696275746520746F20726570726573656E742074686520656C656D656E74730A20202F2F20616374';
wwv_flow_imp.g_varchar2_table(7066) := '75616C20747970650A0A202076617220706B67203D20656C656D656E742E246D6F64656C2E6765745061636B61676528747970654E732E757269292C0A20202020202074797065507265666978203D2028706B672E786D6C20262620706B672E786D6C2E';
wwv_flow_imp.g_varchar2_table(7067) := '7479706550726566697829207C7C2027273B0A0A2020746869732E616464417474726962757465280A20202020746869732E6E734174747269627574654E616D65285853495F54595045292C0A2020202028747970654E732E707265666978203F207479';
wwv_flow_imp.g_varchar2_table(7068) := '70654E732E707265666978202B20273A27203A20272729202B2074797065507265666978202B2064657363726970746F722E6E732E6C6F63616C4E616D650A2020293B0A0A202072657475726E20617474726962757465733B0A7D3B0A0A547970655365';
wwv_flow_imp.g_varchar2_table(7069) := '7269616C697A65722E70726F746F747970652E69734C6F63616C4E73203D2066756E6374696F6E286E7329207B0A202072657475726E206E732E757269203D3D3D2028746869732E747970654E73207C7C20746869732E6E73292E7572693B0A7D3B0A0A';
wwv_flow_imp.g_varchar2_table(7070) := '66756E6374696F6E20536176696E675772697465722829207B0A2020746869732E76616C7565203D2027273B0A0A2020746869732E7772697465203D2066756E6374696F6E2873747229207B0A20202020746869732E76616C7565202B3D207374723B0A';
wwv_flow_imp.g_varchar2_table(7071) := '20207D3B0A7D0A0A66756E6374696F6E20466F726D6174696E67577269746572286F75742C20666F726D617429207B0A0A202076617220696E64656E74203D205B202727205D3B0A0A2020746869732E617070656E64203D2066756E6374696F6E287374';
wwv_flow_imp.g_varchar2_table(7072) := '7229207B0A202020206F75742E777269746528737472293B0A0A2020202072657475726E20746869733B0A20207D3B0A0A2020746869732E617070656E644E65774C696E65203D2066756E6374696F6E2829207B0A2020202069662028666F726D617429';
wwv_flow_imp.g_varchar2_table(7073) := '207B0A2020202020206F75742E777269746528275C6E27293B0A202020207D0A0A2020202072657475726E20746869733B0A20207D3B0A0A2020746869732E617070656E64496E64656E74203D2066756E6374696F6E2829207B0A202020206966202866';
wwv_flow_imp.g_varchar2_table(7074) := '6F726D617429207B0A2020202020206F75742E777269746528696E64656E742E6A6F696E282720202729293B0A202020207D0A0A2020202072657475726E20746869733B0A20207D3B0A0A2020746869732E696E64656E74203D2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(7075) := '29207B0A20202020696E64656E742E70757368282727293B0A2020202072657475726E20746869733B0A20207D3B0A0A2020746869732E756E696E64656E74203D2066756E6374696F6E2829207B0A20202020696E64656E742E706F7028293B0A202020';
wwv_flow_imp.g_varchar2_table(7076) := '2072657475726E20746869733B0A20207D3B0A7D0A0A2F2A2A0A202A20412077726974657220666F72206D6574612D6D6F64656C206261636B656420646F63756D656E742074726565730A202A0A202A2040706172616D207B4F626A6563747D206F7074';
wwv_flow_imp.g_varchar2_table(7077) := '696F6E73206F7574707574206F7074696F6E7320746F207061737320696E746F20746865207772697465720A202A2F0A66756E6374696F6E20577269746572286F7074696F6E7329207B0A0A20206F7074696F6E73203D2028302C6D696E5F646173685F';
wwv_flow_imp.g_varchar2_table(7078) := '5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F2E61737369676E29287B20666F726D61743A2066616C73652C20707265616D626C653A2074727565207D2C206F7074696F6E73207C7C207B7D293B0A0A202066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(7079) := '746F584D4C28747265652C2077726974657229207B0A2020202076617220696E7465726E616C577269746572203D20777269746572207C7C206E657720536176696E6757726974657228293B0A2020202076617220666F726D6174696E67577269746572';
wwv_flow_imp.g_varchar2_table(7080) := '203D206E657720466F726D6174696E6757726974657228696E7465726E616C5772697465722C206F7074696F6E732E666F726D6174293B0A0A20202020696620286F7074696F6E732E707265616D626C6529207B0A202020202020666F726D6174696E67';
wwv_flow_imp.g_varchar2_table(7081) := '5772697465722E617070656E6428584D4C5F505245414D424C45293B0A202020207D0A0A202020206E657720456C656D656E7453657269616C697A657228292E6275696C642874726565292E73657269616C697A65546F28666F726D6174696E67577269';
wwv_flow_imp.g_varchar2_table(7082) := '746572293B0A0A20202020696620282177726974657229207B0A20202020202072657475726E20696E7465726E616C5772697465722E76616C75653B0A202020207D0A20207D0A0A202072657475726E207B0A20202020746F584D4C3A20746F584D4C0A';
wwv_flow_imp.g_varchar2_table(7083) := '20207D3B0A7D0A0A0A2F2F2320736F757263654D617070696E6755524C3D696E6465782E65736D2E6A732E6D61700A0A0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6D6F64646C652F646973742F696E6465782E';
wwv_flow_imp.g_varchar2_table(7084) := '65736D2E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6D6F64646C652F646973742F696E64';
wwv_flow_imp.g_varchar2_table(7085) := '65782E65736D2E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F5F5F776562706163';
wwv_flow_imp.g_varchar2_table(7086) := '6B5F6D6F64756C655F5F2C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F';
wwv_flow_imp.g_varchar2_table(7087) := '5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020204D6F64646C653A';
wwv_flow_imp.g_varchar2_table(7088) := '202829203D3E20282F2A2062696E64696E67202A2F204D6F64646C65292C0A2F2A206861726D6F6E79206578706F7274202A2F202020636F65726365547970653A202829203D3E20282F2A2062696E64696E67202A2F20636F6572636554797065292C0A';
wwv_flow_imp.g_varchar2_table(7089) := '2F2A206861726D6F6E79206578706F7274202A2F20202069734275696C74496E547970653A202829203D3E20282F2A2062696E64696E67202A2F2069734275696C74496E292C0A2F2A206861726D6F6E79206578706F7274202A2F202020697353696D70';
wwv_flow_imp.g_varchar2_table(7090) := '6C65547970653A202829203D3E20282F2A2062696E64696E67202A2F20697353696D706C65292C0A2F2A206861726D6F6E79206578706F7274202A2F20202070617273654E616D654E533A202829203D3E20282F2A2062696E64696E67202A2F20706172';
wwv_flow_imp.g_varchar2_table(7091) := '73654E616D65290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F';
wwv_flow_imp.g_varchar2_table(7092) := '7765627061636B5F726571756972655F5F282F2A21206D696E2D64617368202A2F20222E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A7322293B0A0A0A2F2A2A0A202A204D6F64646C652062617365';
wwv_flow_imp.g_varchar2_table(7093) := '20656C656D656E742E0A202A2F0A66756E6374696F6E20426173652829207B207D0A0A426173652E70726F746F747970652E676574203D2066756E6374696F6E286E616D6529207B0A202072657475726E20746869732E246D6F64656C2E70726F706572';
wwv_flow_imp.g_varchar2_table(7094) := '746965732E67657428746869732C206E616D65293B0A7D3B0A0A426173652E70726F746F747970652E736574203D2066756E6374696F6E286E616D652C2076616C756529207B0A2020746869732E246D6F64656C2E70726F706572746965732E73657428';
wwv_flow_imp.g_varchar2_table(7095) := '746869732C206E616D652C2076616C7565293B0A7D3B0A0A2F2A2A0A202A2041206D6F64656C20656C656D656E7420666163746F72792E0A202A0A202A2040706172616D207B4D6F64646C657D206D6F64656C0A202A2040706172616D207B50726F7065';
wwv_flow_imp.g_varchar2_table(7096) := '72746965737D2070726F706572746965730A202A2F0A66756E6374696F6E20466163746F7279286D6F64656C2C2070726F7065727469657329207B0A2020746869732E6D6F64656C203D206D6F64656C3B0A2020746869732E70726F7065727469657320';
wwv_flow_imp.g_varchar2_table(7097) := '3D2070726F706572746965733B0A7D0A0A0A466163746F72792E70726F746F747970652E63726561746554797065203D2066756E6374696F6E2864657363726970746F7229207B0A0A2020766172206D6F64656C203D20746869732E6D6F64656C3B0A0A';
wwv_flow_imp.g_varchar2_table(7098) := '20207661722070726F7073203D20746869732E70726F706572746965732C0A20202020202070726F746F74797065203D204F626A6563742E63726561746528426173652E70726F746F74797065293B0A0A20202F2F20696E697469616C697A6520646566';
wwv_flow_imp.g_varchar2_table(7099) := '61756C742076616C7565730A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F7245616368292864657363726970746F722E70726F706572746965732C2066756E6374696F6E287029207B';
wwv_flow_imp.g_varchar2_table(7100) := '0A202020206966202821702E69734D616E7920262620702E64656661756C7420213D3D20756E646566696E656429207B0A20202020202070726F746F747970655B702E6E616D655D203D20702E64656661756C743B0A202020207D0A20207D293B0A0A20';
wwv_flow_imp.g_varchar2_table(7101) := '2070726F70732E646566696E654D6F64656C2870726F746F747970652C206D6F64656C293B0A202070726F70732E646566696E6544657363726970746F722870726F746F747970652C2064657363726970746F72293B0A0A2020766172206E616D65203D';
wwv_flow_imp.g_varchar2_table(7102) := '2064657363726970746F722E6E732E6E616D653B0A0A20202F2A2A0A2020202A20546865206E6577207479706520636F6E7374727563746F720A2020202A2F0A202066756E6374696F6E204D6F64646C65456C656D656E7428617474727329207B0A2020';
wwv_flow_imp.g_varchar2_table(7103) := '202070726F70732E646566696E6528746869732C20272474797065272C207B2076616C75653A206E616D652C20656E756D657261626C653A2074727565207D293B0A2020202070726F70732E646566696E6528746869732C2027246174747273272C207B';
wwv_flow_imp.g_varchar2_table(7104) := '2076616C75653A207B7D207D293B0A2020202070726F70732E646566696E6528746869732C202724706172656E74272C207B207772697461626C653A2074727565207D293B0A0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(7105) := '525445445F4D4F44554C455F305F5F2E666F7245616368292861747472732C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E62696E64292866756E6374696F6E2876616C2C206B657929207B0A';
wwv_flow_imp.g_varchar2_table(7106) := '202020202020746869732E736574286B65792C2076616C293B0A202020207D2C207468697329293B0A20207D0A0A20204D6F64646C65456C656D656E742E70726F746F74797065203D2070726F746F747970653B0A0A20204D6F64646C65456C656D656E';
wwv_flow_imp.g_varchar2_table(7107) := '742E68617354797065203D2070726F746F747970652E24696E7374616E63654F66203D20746869732E6D6F64656C2E686173547970653B0A0A20202F2F20737461746963206C696E6B730A202070726F70732E646566696E654D6F64656C284D6F64646C';
wwv_flow_imp.g_varchar2_table(7108) := '65456C656D656E742C206D6F64656C293B0A202070726F70732E646566696E6544657363726970746F72284D6F64646C65456C656D656E742C2064657363726970746F72293B0A0A202072657475726E204D6F64646C65456C656D656E743B0A7D3B0A0A';
wwv_flow_imp.g_varchar2_table(7109) := '2F2A2A0A202A204275696C742D696E206D6F64646C652074797065730A202A2F0A766172204255494C54494E53203D207B0A2020537472696E673A20747275652C0A2020426F6F6C65616E3A20747275652C0A2020496E74656765723A20747275652C0A';
wwv_flow_imp.g_varchar2_table(7110) := '20205265616C3A20747275652C0A2020456C656D656E743A20747275650A7D3B0A0A2F2A2A0A202A20436F6E7665727465727320666F72206275696C7420696E2074797065732066726F6D20737472696E6720726570726573656E746174696F6E730A20';
wwv_flow_imp.g_varchar2_table(7111) := '2A2F0A76617220545950455F434F4E56455254455253203D207B0A2020537472696E673A2066756E6374696F6E287329207B2072657475726E20733B207D2C0A2020426F6F6C65616E3A2066756E6374696F6E287329207B2072657475726E2073203D3D';
wwv_flow_imp.g_varchar2_table(7112) := '3D202774727565273B207D2C0A2020496E74656765723A2066756E6374696F6E287329207B2072657475726E207061727365496E7428732C203130293B207D2C0A20205265616C3A2066756E6374696F6E287329207B2072657475726E20706172736546';
wwv_flow_imp.g_varchar2_table(7113) := '6C6F61742873293B207D0A7D3B0A0A2F2A2A0A202A20436F6E766572742061207479706520746F20697473207265616C20726570726573656E746174696F6E0A202A2F0A66756E6374696F6E20636F657263655479706528747970652C2076616C756529';
wwv_flow_imp.g_varchar2_table(7114) := '207B0A0A202076617220636F6E766572746572203D20545950455F434F4E564552544552535B747970655D3B0A0A202069662028636F6E76657274657229207B0A2020202072657475726E20636F6E7665727465722876616C7565293B0A20207D20656C';
wwv_flow_imp.g_varchar2_table(7115) := '7365207B0A2020202072657475726E2076616C75653B0A20207D0A7D0A0A2F2A2A0A202A2052657475726E20776865746865722074686520676976656E2074797065206973206275696C742D696E0A202A2F0A66756E6374696F6E2069734275696C7449';
wwv_flow_imp.g_varchar2_table(7116) := '6E287479706529207B0A202072657475726E2021214255494C54494E535B747970655D3B0A7D0A0A2F2A2A0A202A2052657475726E20776865746865722074686520676976656E20747970652069732073696D706C650A202A2F0A66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(7117) := '697353696D706C65287479706529207B0A202072657475726E202121545950455F434F4E564552544552535B747970655D3B0A7D0A0A2F2A2A0A202A205061727365732061206E616D6573706163656420617474726962757465206E616D65206F662074';
wwv_flow_imp.g_varchar2_table(7118) := '686520666F726D20286E733A296C6F63616C4E616D6520746F20616E206F626A6563742C0A202A20676976656E20612064656661756C742070726566697820746F20617373756D6520696E2063617365206E6F206578706C69636974206E616D65737061';
wwv_flow_imp.g_varchar2_table(7119) := '636520697320676976656E2E0A202A0A202A2040706172616D207B537472696E677D206E616D650A202A2040706172616D207B537472696E677D205B64656661756C745072656669785D207468652064656661756C742070726566697820746F2074616B';
wwv_flow_imp.g_varchar2_table(7120) := '652C206966206E6F6E652069732070726573656E742E0A202A0A202A204072657475726E207B4F626A6563747D2074686520706172736564206E616D650A202A2F0A66756E6374696F6E2070617273654E616D65286E616D652C2064656661756C745072';
wwv_flow_imp.g_varchar2_table(7121) := '6566697829207B0A2020766172207061727473203D206E616D652E73706C6974282F3A2F292C0A2020202020206C6F63616C4E616D652C207072656669783B0A0A20202F2F206E6F207072656669782028692E652E206F6E6C79206C6F63616C206E616D';
wwv_flow_imp.g_varchar2_table(7122) := '65290A20206966202870617274732E6C656E677468203D3D3D203129207B0A202020206C6F63616C4E616D65203D206E616D653B0A20202020707265666978203D2064656661756C745072656669783B0A20207D20656C73650A0A20202F2F2070726566';
wwv_flow_imp.g_varchar2_table(7123) := '6978202B206C6F63616C206E616D650A20206966202870617274732E6C656E677468203D3D3D203229207B0A202020206C6F63616C4E616D65203D2070617274735B315D3B0A20202020707265666978203D2070617274735B305D3B0A20207D20656C73';
wwv_flow_imp.g_varchar2_table(7124) := '65207B0A202020207468726F77206E6577204572726F7228276578706563746564203C7072656669783A6C6F63616C4E616D653E206F72203C6C6F63616C4E616D653E2C20676F742027202B206E616D65293B0A20207D0A0A20206E616D65203D202870';
wwv_flow_imp.g_varchar2_table(7125) := '7265666978203F20707265666978202B20273A27203A20272729202B206C6F63616C4E616D653B0A0A202072657475726E207B0A202020206E616D653A206E616D652C0A202020207072656669783A207072656669782C0A202020206C6F63616C4E616D';
wwv_flow_imp.g_varchar2_table(7126) := '653A206C6F63616C4E616D650A20207D3B0A7D0A0A2F2A2A0A202A2041207574696C69747920746F206275696C6420656C656D656E742064657363726970746F72732E0A202A2F0A66756E6374696F6E2044657363726970746F724275696C646572286E';
wwv_flow_imp.g_varchar2_table(7127) := '616D654E7329207B0A2020746869732E6E73203D206E616D654E733B0A2020746869732E6E616D65203D206E616D654E732E6E616D653B0A2020746869732E616C6C5479706573203D205B5D3B0A2020746869732E616C6C547970657342794E616D6520';
wwv_flow_imp.g_varchar2_table(7128) := '3D207B7D3B0A2020746869732E70726F70657274696573203D205B5D3B0A2020746869732E70726F7065727469657342794E616D65203D207B7D3B0A7D0A0A0A44657363726970746F724275696C6465722E70726F746F747970652E6275696C64203D20';
wwv_flow_imp.g_varchar2_table(7129) := '66756E6374696F6E2829207B0A202072657475726E2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E7069636B2928746869732C205B0A20202020276E73272C0A20202020276E616D65272C0A20';
wwv_flow_imp.g_varchar2_table(7130) := '20202027616C6C5479706573272C0A2020202027616C6C547970657342794E616D65272C0A202020202770726F70657274696573272C0A202020202770726F7065727469657342794E616D65272C0A2020202027626F647950726F7065727479272C0A20';
wwv_flow_imp.g_varchar2_table(7131) := '20202027696450726F7065727479270A20205D293B0A7D3B0A0A2F2A2A0A202A204164642070726F706572747920617420676976656E20696E6465782E0A202A0A202A2040706172616D207B4F626A6563747D20700A202A2040706172616D207B4E756D';
wwv_flow_imp.g_varchar2_table(7132) := '6265727D205B6964785D0A202A2040706172616D207B426F6F6C65616E7D205B76616C69646174653D747275655D0A202A2F0A44657363726970746F724275696C6465722E70726F746F747970652E61646450726F7065727479203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(7133) := '6E28702C206964782C2076616C696461746529207B0A0A202069662028747970656F6620696478203D3D3D2027626F6F6C65616E2729207B0A2020202076616C6964617465203D206964783B0A20202020696478203D20756E646566696E65643B0A2020';
wwv_flow_imp.g_varchar2_table(7134) := '7D0A0A2020746869732E6164644E616D656450726F706572747928702C2076616C696461746520213D3D2066616C7365293B0A0A20207661722070726F70657274696573203D20746869732E70726F706572746965733B0A0A2020696620286964782021';
wwv_flow_imp.g_varchar2_table(7135) := '3D3D20756E646566696E656429207B0A2020202070726F706572746965732E73706C696365286964782C20302C2070293B0A20207D20656C7365207B0A2020202070726F706572746965732E707573682870293B0A20207D0A7D3B0A0A0A446573637269';
wwv_flow_imp.g_varchar2_table(7136) := '70746F724275696C6465722E70726F746F747970652E7265706C61636550726F7065727479203D2066756E6374696F6E286F6C6450726F70657274792C206E657750726F70657274792C207265706C61636529207B0A2020766172206F6C644E616D654E';
wwv_flow_imp.g_varchar2_table(7137) := '73203D206F6C6450726F70657274792E6E733B0A0A20207661722070726F7073203D20746869732E70726F706572746965732C0A20202020202070726F7065727469657342794E616D65203D20746869732E70726F7065727469657342794E616D652C0A';
wwv_flow_imp.g_varchar2_table(7138) := '20202020202072656E616D65203D206F6C6450726F70657274792E6E616D6520213D3D206E657750726F70657274792E6E616D653B0A0A2020696620286F6C6450726F70657274792E6973496429207B0A2020202069662028216E657750726F70657274';
wwv_flow_imp.g_varchar2_table(7139) := '792E6973496429207B0A2020202020207468726F77206E6577204572726F72280A20202020202020202770726F7065727479203C27202B206E657750726F70657274792E6E732E6E616D65202B20273E206D7573742062652069642070726F7065727479';
wwv_flow_imp.g_varchar2_table(7140) := '2027202B0A202020202020202027746F20726566696E65203C27202B206F6C6450726F70657274792E6E732E6E616D65202B20273E27293B0A202020207D0A0A20202020746869732E736574496450726F7065727479286E657750726F70657274792C20';
wwv_flow_imp.g_varchar2_table(7141) := '66616C7365293B0A20207D0A0A2020696620286F6C6450726F70657274792E6973426F647929207B0A0A2020202069662028216E657750726F70657274792E6973426F647929207B0A2020202020207468726F77206E6577204572726F72280A20202020';
wwv_flow_imp.g_varchar2_table(7142) := '202020202770726F7065727479203C27202B206E657750726F70657274792E6E732E6E616D65202B20273E206D75737420626520626F64792070726F70657274792027202B0A202020202020202027746F20726566696E65203C27202B206F6C6450726F';
wwv_flow_imp.g_varchar2_table(7143) := '70657274792E6E732E6E616D65202B20273E27293B0A202020207D0A0A202020202F2F20544F444F3A20436865636B20636F6D7061746962696C6974790A20202020746869732E736574426F647950726F7065727479286E657750726F70657274792C20';
wwv_flow_imp.g_varchar2_table(7144) := '66616C7365293B0A20207D0A0A20202F2F2076616C6964617465206578697374656E636520616E6420676574206C6F636174696F6E206F66206F6C642070726F70657274790A202076617220696478203D2070726F70732E696E6465784F66286F6C6450';
wwv_flow_imp.g_varchar2_table(7145) := '726F7065727479293B0A202069662028696478203D3D3D202D3129207B0A202020207468726F77206E6577204572726F72282770726F7065727479203C27202B206F6C644E616D654E732E6E616D65202B20273E206E6F7420666F756E6420696E207072';
wwv_flow_imp.g_varchar2_table(7146) := '6F7065727479206C69737427293B0A20207D0A0A20202F2F2072656D6F7665206F6C642070726F70657274790A202070726F70732E73706C696365286964782C2031293B0A0A20202F2F207265706C6163696E6720746865206E616D65642070726F7065';
wwv_flow_imp.g_varchar2_table(7147) := '72747920697320696E74656E74696F6E616C0A20202F2F0A20202F2F20202A2076616C6964617465206F6E6C7920696620746869732069732061202272656E616D6522206F7065726174696F6E0A20202F2F20202A206164642061742073706563696669';
wwv_flow_imp.g_varchar2_table(7148) := '6320696E64657820756E6C65737320776520227265706C616365220A20202F2F0A2020746869732E61646450726F7065727479286E657750726F70657274792C207265706C616365203F20756E646566696E6564203A206964782C2072656E616D65293B';
wwv_flow_imp.g_varchar2_table(7149) := '0A0A20202F2F206D616B65206E65772070726F706572747920617661696C61626C6520756E646572206F6C64206E616D650A202070726F7065727469657342794E616D655B6F6C644E616D654E732E6E616D655D203D2070726F7065727469657342794E';
wwv_flow_imp.g_varchar2_table(7150) := '616D655B6F6C644E616D654E732E6C6F63616C4E616D655D203D206E657750726F70657274793B0A7D3B0A0A0A44657363726970746F724275696C6465722E70726F746F747970652E7265646566696E6550726F7065727479203D2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(7151) := '28702C2074617267657450726F70657274794E616D652C207265706C61636529207B0A0A2020766172206E73507265666978203D20702E6E732E7072656669783B0A2020766172207061727473203D2074617267657450726F70657274794E616D652E73';
wwv_flow_imp.g_varchar2_table(7152) := '706C697428272327293B0A0A2020766172206E616D65203D2070617273654E616D652870617274735B305D2C206E73507265666978293B0A202076617220617474724E616D65203D2070617273654E616D652870617274735B315D2C206E616D652E7072';
wwv_flow_imp.g_varchar2_table(7153) := '65666978292E6E616D653B0A0A2020766172207265646566696E656450726F7065727479203D20746869732E70726F7065727469657342794E616D655B617474724E616D655D3B0A202069662028217265646566696E656450726F706572747929207B0A';
wwv_flow_imp.g_varchar2_table(7154) := '202020207468726F77206E6577204572726F722827726566696E65642070726F7065727479203C27202B20617474724E616D65202B20273E206E6F7420666F756E6427293B0A20207D20656C7365207B0A20202020746869732E7265706C61636550726F';
wwv_flow_imp.g_varchar2_table(7155) := '7065727479287265646566696E656450726F70657274792C20702C207265706C616365293B0A20207D0A0A202064656C65746520702E7265646566696E65733B0A7D3B0A0A44657363726970746F724275696C6465722E70726F746F747970652E616464';
wwv_flow_imp.g_varchar2_table(7156) := '4E616D656450726F7065727479203D2066756E6374696F6E28702C2076616C696461746529207B0A2020766172206E73203D20702E6E732C0A20202020202070726F707342794E616D65203D20746869732E70726F7065727469657342794E616D653B0A';
wwv_flow_imp.g_varchar2_table(7157) := '0A20206966202876616C696461746529207B0A20202020746869732E6173736572744E6F74446566696E656428702C206E732E6E616D65293B0A20202020746869732E6173736572744E6F74446566696E656428702C206E732E6C6F63616C4E616D6529';
wwv_flow_imp.g_varchar2_table(7158) := '3B0A20207D0A0A202070726F707342794E616D655B6E732E6E616D655D203D2070726F707342794E616D655B6E732E6C6F63616C4E616D655D203D20703B0A7D3B0A0A44657363726970746F724275696C6465722E70726F746F747970652E72656D6F76';
wwv_flow_imp.g_varchar2_table(7159) := '654E616D656450726F7065727479203D2066756E6374696F6E287029207B0A2020766172206E73203D20702E6E732C0A20202020202070726F707342794E616D65203D20746869732E70726F7065727469657342794E616D653B0A0A202064656C657465';
wwv_flow_imp.g_varchar2_table(7160) := '2070726F707342794E616D655B6E732E6E616D655D3B0A202064656C6574652070726F707342794E616D655B6E732E6C6F63616C4E616D655D3B0A7D3B0A0A44657363726970746F724275696C6465722E70726F746F747970652E736574426F64795072';
wwv_flow_imp.g_varchar2_table(7161) := '6F7065727479203D2066756E6374696F6E28702C2076616C696461746529207B0A0A20206966202876616C696461746520262620746869732E626F647950726F706572747929207B0A202020207468726F77206E6577204572726F72280A202020202020';
wwv_flow_imp.g_varchar2_table(7162) := '27626F64792070726F706572747920646566696E6564206D756C7469706C652074696D65732027202B0A20202020202027283C27202B20746869732E626F647950726F70657274792E6E732E6E616D65202B20273E2C203C27202B20702E6E732E6E616D';
wwv_flow_imp.g_varchar2_table(7163) := '65202B20273E2927293B0A20207D0A0A2020746869732E626F647950726F7065727479203D20703B0A7D3B0A0A44657363726970746F724275696C6465722E70726F746F747970652E736574496450726F7065727479203D2066756E6374696F6E28702C';
wwv_flow_imp.g_varchar2_table(7164) := '2076616C696461746529207B0A0A20206966202876616C696461746520262620746869732E696450726F706572747929207B0A202020207468726F77206E6577204572726F72280A2020202020202769642070726F706572747920646566696E6564206D';
wwv_flow_imp.g_varchar2_table(7165) := '756C7469706C652074696D65732027202B0A20202020202027283C27202B20746869732E696450726F70657274792E6E732E6E616D65202B20273E2C203C27202B20702E6E732E6E616D65202B20273E2927293B0A20207D0A0A2020746869732E696450';
wwv_flow_imp.g_varchar2_table(7166) := '726F7065727479203D20703B0A7D3B0A0A44657363726970746F724275696C6465722E70726F746F747970652E6173736572744E6F745472616974203D2066756E6374696F6E287479706544657363726970746F7229207B0A0A2020636F6E7374205F65';
wwv_flow_imp.g_varchar2_table(7167) := '7874656E6473203D207479706544657363726970746F722E657874656E6473207C7C205B5D3B0A0A2020696620285F657874656E64732E6C656E67746829207B0A202020207468726F77206E6577204572726F72280A2020202020206063616E6E6F7420';
wwv_flow_imp.g_varchar2_table(7168) := '637265617465203C247B207479706544657363726970746F722E6E616D65207D3E20657874656E64696E67203C247B207479706544657363726970746F722E657874656E6473207D3E600A20202020293B0A20207D0A7D3B0A0A44657363726970746F72';
wwv_flow_imp.g_varchar2_table(7169) := '4275696C6465722E70726F746F747970652E6173736572744E6F74446566696E6564203D2066756E6374696F6E28702C206E616D6529207B0A20207661722070726F70657274794E616D65203D20702E6E616D652C0A202020202020646566696E656450';
wwv_flow_imp.g_varchar2_table(7170) := '726F7065727479203D20746869732E70726F7065727469657342794E616D655B70726F70657274794E616D655D3B0A0A202069662028646566696E656450726F706572747929207B0A202020207468726F77206E6577204572726F72280A202020202020';
wwv_flow_imp.g_varchar2_table(7171) := '2770726F7065727479203C27202B2070726F70657274794E616D65202B20273E20616C726561647920646566696E65643B2027202B0A202020202020276F76657272696465206F66203C27202B20646566696E656450726F70657274792E646566696E65';
wwv_flow_imp.g_varchar2_table(7172) := '6442792E6E732E6E616D65202B20272327202B20646566696E656450726F70657274792E6E732E6E616D65202B20273E2062792027202B0A202020202020273C27202B20702E646566696E656442792E6E732E6E616D65202B20272327202B20702E6E73';
wwv_flow_imp.g_varchar2_table(7173) := '2E6E616D65202B20273E206E6F7420616C6C6F77656420776974686F7574207265646566696E657327293B0A20207D0A7D3B0A0A44657363726970746F724275696C6465722E70726F746F747970652E68617350726F7065727479203D2066756E637469';
wwv_flow_imp.g_varchar2_table(7174) := '6F6E286E616D6529207B0A202072657475726E20746869732E70726F7065727469657342794E616D655B6E616D655D3B0A7D3B0A0A44657363726970746F724275696C6465722E70726F746F747970652E6164645472616974203D2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(7175) := '28742C20696E6865726974656429207B0A0A202069662028696E6865726974656429207B0A20202020746869732E6173736572744E6F7454726169742874293B0A20207D0A0A202076617220747970657342794E616D65203D20746869732E616C6C5479';
wwv_flow_imp.g_varchar2_table(7176) := '70657342794E616D652C0A2020202020207479706573203D20746869732E616C6C54797065733B0A0A202076617220747970654E616D65203D20742E6E616D653B0A0A202069662028747970654E616D6520696E20747970657342794E616D6529207B0A';
wwv_flow_imp.g_varchar2_table(7177) := '2020202072657475726E3B0A20207D0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F72456163682928742E70726F706572746965732C2028302C6D696E5F646173685F5F57454250';
wwv_flow_imp.g_varchar2_table(7178) := '41434B5F494D504F525445445F4D4F44554C455F305F5F2E62696E64292866756E6374696F6E287029207B0A0A202020202F2F20636C6F6E652070726F706572747920746F20616C6C6F7720657874656E73696F6E730A2020202070203D2028302C6D69';
wwv_flow_imp.g_varchar2_table(7179) := '6E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E29287B7D2C20702C207B0A2020202020206E616D653A20702E6E732E6C6F63616C4E616D652C0A202020202020696E686572697465643A20696E';
wwv_flow_imp.g_varchar2_table(7180) := '686572697465640A202020207D293B0A0A202020204F626A6563742E646566696E6550726F706572747928702C2027646566696E65644279272C207B0A20202020202076616C75653A20740A202020207D293B0A0A20202020766172207265706C616365';
wwv_flow_imp.g_varchar2_table(7181) := '73203D20702E7265706C616365732C0A20202020202020207265646566696E6573203D20702E7265646566696E65733B0A0A202020202F2F20616464207265706C6163652F7265646566696E6520737570706F72740A20202020696620287265706C6163';
wwv_flow_imp.g_varchar2_table(7182) := '6573207C7C207265646566696E657329207B0A202020202020746869732E7265646566696E6550726F706572747928702C207265706C61636573207C7C207265646566696E65732C207265706C61636573293B0A202020207D20656C7365207B0A202020';
wwv_flow_imp.g_varchar2_table(7183) := '20202069662028702E6973426F647929207B0A2020202020202020746869732E736574426F647950726F70657274792870293B0A2020202020207D0A20202020202069662028702E6973496429207B0A2020202020202020746869732E73657449645072';
wwv_flow_imp.g_varchar2_table(7184) := '6F70657274792870293B0A2020202020207D0A202020202020746869732E61646450726F70657274792870293B0A202020207D0A20207D2C207468697329293B0A0A202074797065732E707573682874293B0A2020747970657342794E616D655B747970';
wwv_flow_imp.g_varchar2_table(7185) := '654E616D655D203D20743B0A7D3B0A0A2F2A2A0A202A2041207265676973747279206F66204D6F64646C65207061636B616765732E0A202A0A202A2040706172616D207B41727261793C5061636B6167653E7D207061636B616765730A202A2040706172';
wwv_flow_imp.g_varchar2_table(7186) := '616D207B50726F706572746965737D2070726F706572746965730A202A2F0A66756E6374696F6E205265676973747279287061636B616765732C2070726F7065727469657329207B0A2020746869732E7061636B6167654D6170203D207B7D3B0A202074';
wwv_flow_imp.g_varchar2_table(7187) := '6869732E747970654D6170203D207B7D3B0A0A2020746869732E7061636B61676573203D205B5D3B0A0A2020746869732E70726F70657274696573203D2070726F706572746965733B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D';
wwv_flow_imp.g_varchar2_table(7188) := '504F525445445F4D4F44554C455F305F5F2E666F724561636829287061636B616765732C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E62696E642928746869732E7265676973746572506163';
wwv_flow_imp.g_varchar2_table(7189) := '6B6167652C207468697329293B0A7D0A0A0A52656769737472792E70726F746F747970652E6765745061636B616765203D2066756E6374696F6E287572694F7250726566697829207B0A202072657475726E20746869732E7061636B6167654D61705B75';
wwv_flow_imp.g_varchar2_table(7190) := '72694F725072656669785D3B0A7D3B0A0A52656769737472792E70726F746F747970652E6765745061636B61676573203D2066756E6374696F6E2829207B0A202072657475726E20746869732E7061636B616765733B0A7D3B0A0A0A5265676973747279';
wwv_flow_imp.g_varchar2_table(7191) := '2E70726F746F747970652E72656769737465725061636B616765203D2066756E6374696F6E28706B6729207B0A0A20202F2F20636F7079207061636B6167650A2020706B67203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445';
wwv_flow_imp.g_varchar2_table(7192) := '445F4D4F44554C455F305F5F2E61737369676E29287B7D2C20706B67293B0A0A202076617220706B674D6170203D20746869732E7061636B6167654D61703B0A0A2020656E73757265417661696C61626C6528706B674D61702C20706B672C2027707265';
wwv_flow_imp.g_varchar2_table(7193) := '66697827293B0A2020656E73757265417661696C61626C6528706B674D61702C20706B672C202775726927293B0A0A20202F2F2072656769737465722074797065730A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D';
wwv_flow_imp.g_varchar2_table(7194) := '4F44554C455F305F5F2E666F72456163682928706B672E74797065732C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E62696E64292866756E6374696F6E2864657363726970746F7229207B0A';
wwv_flow_imp.g_varchar2_table(7195) := '20202020746869732E7265676973746572547970652864657363726970746F722C20706B67293B0A20207D2C207468697329293B0A0A2020706B674D61705B706B672E7572695D203D20706B674D61705B706B672E7072656669785D203D20706B673B0A';
wwv_flow_imp.g_varchar2_table(7196) := '2020746869732E7061636B616765732E7075736828706B67293B0A7D3B0A0A0A2F2A2A0A202A205265676973746572206120747970652066726F6D2061207370656369666963207061636B61676520776974682075730A202A2F0A52656769737472792E';
wwv_flow_imp.g_varchar2_table(7197) := '70726F746F747970652E726567697374657254797065203D2066756E6374696F6E28747970652C20706B6729207B0A0A202074797065203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E6173';
wwv_flow_imp.g_varchar2_table(7198) := '7369676E29287B7D2C20747970652C207B0A202020207375706572436C6173733A2028747970652E7375706572436C617373207C7C205B5D292E736C69636528292C0A20202020657874656E64733A2028747970652E657874656E6473207C7C205B5D29';
wwv_flow_imp.g_varchar2_table(7199) := '2E736C69636528292C0A2020202070726F706572746965733A2028747970652E70726F70657274696573207C7C205B5D292E736C69636528292C0A202020206D6574613A2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D';
wwv_flow_imp.g_varchar2_table(7200) := '4F44554C455F305F5F2E61737369676E292828747970652E6D657461207C7C207B7D29290A20207D293B0A0A2020766172206E73203D2070617273654E616D6528747970652E6E616D652C20706B672E707265666978292C0A2020202020206E616D6520';
wwv_flow_imp.g_varchar2_table(7201) := '3D206E732E6E616D652C0A20202020202070726F7065727469657342794E616D65203D207B7D3B0A0A20202F2F2070617273652070726F706572746965730A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C';
wwv_flow_imp.g_varchar2_table(7202) := '455F305F5F2E666F72456163682928747970652E70726F706572746965732C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E62696E64292866756E6374696F6E287029207B0A0A202020202F2F';
wwv_flow_imp.g_varchar2_table(7203) := '206E616D6573706163652070726F7065727479206E616D65730A202020207661722070726F70657274794E73203D2070617273654E616D6528702E6E616D652C206E732E707265666978292C0A202020202020202070726F70657274794E616D65203D20';
wwv_flow_imp.g_varchar2_table(7204) := '70726F70657274794E732E6E616D653B0A0A202020202F2F206E616D6573706163652070726F70657274792074797065730A20202020696620282169734275696C74496E28702E747970652929207B0A202020202020702E74797065203D207061727365';
wwv_flow_imp.g_varchar2_table(7205) := '4E616D6528702E747970652C2070726F70657274794E732E707265666978292E6E616D653B0A202020207D0A0A2020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E2928702C';
wwv_flow_imp.g_varchar2_table(7206) := '207B0A2020202020206E733A2070726F70657274794E732C0A2020202020206E616D653A2070726F70657274794E616D650A202020207D293B0A0A2020202070726F7065727469657342794E616D655B70726F70657274794E616D655D203D20703B0A20';
wwv_flow_imp.g_varchar2_table(7207) := '207D2C207468697329293B0A0A20202F2F20757064617465206E73202B206E616D650A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E2928747970652C207B0A202020206E73';
wwv_flow_imp.g_varchar2_table(7208) := '3A206E732C0A202020206E616D653A206E616D652C0A2020202070726F7065727469657342794E616D653A2070726F7065727469657342794E616D650A20207D293B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(7209) := '4D4F44554C455F305F5F2E666F72456163682928747970652E657874656E64732C2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E62696E64292866756E6374696F6E28657874656E64734E616D';
wwv_flow_imp.g_varchar2_table(7210) := '6529207B0A2020202076617220657874656E64734E616D654E73203D2070617273654E616D6528657874656E64734E616D652C206E732E707265666978293B0A0A2020202076617220657874656E646564203D20746869732E747970654D61705B657874';
wwv_flow_imp.g_varchar2_table(7211) := '656E64734E616D654E732E6E616D655D3B0A0A20202020657874656E6465642E747261697473203D20657874656E6465642E747261697473207C7C205B5D3B0A20202020657874656E6465642E7472616974732E70757368286E616D65293B0A20207D2C';
wwv_flow_imp.g_varchar2_table(7212) := '207468697329293B0A0A20202F2F206C696E6B20746F207061636B6167650A2020746869732E646566696E655061636B61676528747970652C20706B67293B0A0A20202F2F2072656769737465720A2020746869732E747970654D61705B6E616D655D20';
wwv_flow_imp.g_varchar2_table(7213) := '3D20747970653B0A7D3B0A0A0A2F2A2A0A202A205472617665727365207468652074797065206869657261726368792066726F6D20626F74746F6D20746F20746F702C0A202A2063616C6C696E67206974657261746F7220776974682028747970652C20';
wwv_flow_imp.g_varchar2_table(7214) := '696E686572697465642920666F7220616C6C20656C656D656E747320696E0A202A2074686520696E6865726974616E636520636861696E2E0A202A0A202A2040706172616D207B4F626A6563747D206E734E616D650A202A2040706172616D207B46756E';
wwv_flow_imp.g_varchar2_table(7215) := '6374696F6E7D206974657261746F720A202A2040706172616D207B426F6F6C65616E7D205B74726169743D66616C73655D0A202A2F0A52656769737472792E70726F746F747970652E6D61705479706573203D2066756E6374696F6E286E734E616D652C';
wwv_flow_imp.g_varchar2_table(7216) := '206974657261746F722C20747261697429207B0A0A20207661722074797065203D2069734275696C74496E286E734E616D652E6E616D6529203F207B206E616D653A206E734E616D652E6E616D65207D203A20746869732E747970654D61705B6E734E61';
wwv_flow_imp.g_varchar2_table(7217) := '6D652E6E616D655D3B0A0A20207661722073656C66203D20746869733B0A0A20202F2A2A0A2020202A205472617665727365207468652073656C65637465642073757065722074797065206F722074726169740A2020202A0A2020202A2040706172616D';
wwv_flow_imp.g_varchar2_table(7218) := '207B537472696E677D20636C730A2020202A2040706172616D207B426F6F6C65616E7D205B74726169743D66616C73655D0A2020202A2F0A202066756E6374696F6E20747261766572736528636C732C20747261697429207B0A20202020766172207061';
wwv_flow_imp.g_varchar2_table(7219) := '72656E744E73203D2070617273654E616D6528636C732C2069734275696C74496E28636C7329203F202727203A206E734E616D652E707265666978293B0A2020202073656C662E6D6170547970657328706172656E744E732C206974657261746F722C20';
wwv_flow_imp.g_varchar2_table(7220) := '7472616974293B0A20207D0A0A20202F2A2A0A2020202A205472617665727365207468652073656C65637465642074726169742E0A2020202A0A2020202A2040706172616D207B537472696E677D20636C730A2020202A2F0A202066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(7221) := '7472617665727365547261697428636C7329207B0A2020202072657475726E20747261766572736528636C732C2074727565293B0A20207D0A0A20202F2A2A0A2020202A205472617665727365207468652073656C656374656420737570657220747970';
wwv_flow_imp.g_varchar2_table(7222) := '650A2020202A0A2020202A2040706172616D207B537472696E677D20636C730A2020202A2F0A202066756E6374696F6E207472617665727365537570657228636C7329207B0A2020202072657475726E20747261766572736528636C732C2066616C7365';
wwv_flow_imp.g_varchar2_table(7223) := '293B0A20207D0A0A202069662028217479706529207B0A202020207468726F77206E6577204572726F722827756E6B6E6F776E2074797065203C27202B206E734E616D652E6E616D65202B20273E27293B0A20207D0A0A202028302C6D696E5F64617368';
wwv_flow_imp.g_varchar2_table(7224) := '5F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F72456163682928747970652E7375706572436C6173732C207472616974203F2074726176657273655472616974203A2074726176657273655375706572293B0A0A20202F';
wwv_flow_imp.g_varchar2_table(7225) := '2F2063616C6C206974657261746F7220776974682028747970652C20696E686572697465643D217472616974290A20206974657261746F7228747970652C20217472616974293B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F';
wwv_flow_imp.g_varchar2_table(7226) := '525445445F4D4F44554C455F305F5F2E666F72456163682928747970652E7472616974732C2074726176657273655472616974293B0A7D3B0A0A0A2F2A2A0A202A2052657475726E7320746865206566666563746976652064657363726970746F722066';
wwv_flow_imp.g_varchar2_table(7227) := '6F72206120747970652E0A202A0A202A2040706172616D20207B537472696E677D207479706520746865206E616D65737061636564206E616D6520286E733A6C6F63616C4E616D6529206F662074686520747970650A202A0A202A204072657475726E20';
wwv_flow_imp.g_varchar2_table(7228) := '7B44657363726970746F727D2074686520726573756C74696E67206566666563746976652064657363726970746F720A202A2F0A52656769737472792E70726F746F747970652E67657445666665637469766544657363726970746F72203D2066756E63';
wwv_flow_imp.g_varchar2_table(7229) := '74696F6E286E616D6529207B0A0A2020766172206E734E616D65203D2070617273654E616D65286E616D65293B0A0A2020766172206275696C646572203D206E65772044657363726970746F724275696C646572286E734E616D65293B0A0A2020746869';
wwv_flow_imp.g_varchar2_table(7230) := '732E6D61705479706573286E734E616D652C2066756E6374696F6E28747970652C20696E6865726974656429207B0A202020206275696C6465722E616464547261697428747970652C20696E68657269746564293B0A20207D293B0A0A20207661722064';
wwv_flow_imp.g_varchar2_table(7231) := '657363726970746F72203D206275696C6465722E6275696C6428293B0A0A20202F2F20646566696E65207061636B616765206C696E6B0A2020746869732E646566696E655061636B6167652864657363726970746F722C2064657363726970746F722E61';
wwv_flow_imp.g_varchar2_table(7232) := '6C6C54797065735B64657363726970746F722E616C6C54797065732E6C656E677468202D20315D2E24706B67293B0A0A202072657475726E2064657363726970746F723B0A7D3B0A0A0A52656769737472792E70726F746F747970652E646566696E6550';
wwv_flow_imp.g_varchar2_table(7233) := '61636B616765203D2066756E6374696F6E287461726765742C20706B6729207B0A2020746869732E70726F706572746965732E646566696E65287461726765742C202724706B67272C207B2076616C75653A20706B67207D293B0A7D3B0A0A0A0A2F2F20';
wwv_flow_imp.g_varchar2_table(7234) := '68656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A66756E6374696F6E20656E73757265417661696C61626C65287061636B6167654D61702C20706B672C206964656E7469666965724B657929207B0A0A2020';
wwv_flow_imp.g_varchar2_table(7235) := '7661722076616C7565203D20706B675B6964656E7469666965724B65795D3B0A0A20206966202876616C756520696E207061636B6167654D617029207B0A202020207468726F77206E6577204572726F7228277061636B61676520776974682027202B20';
wwv_flow_imp.g_varchar2_table(7236) := '6964656E7469666965724B6579202B2027203C27202B2076616C7565202B20273E20616C726561647920646566696E656427293B0A20207D0A7D0A0A2F2A2A0A202A2041207574696C6974792074686174206765747320616E6420736574732070726F70';
wwv_flow_imp.g_varchar2_table(7237) := '657274696573206F66206D6F64656C20656C656D656E74732E0A202A0A202A2040706172616D207B4D6F64656C7D206D6F64656C0A202A2F0A66756E6374696F6E2050726F70657274696573286D6F64656C29207B0A2020746869732E6D6F64656C203D';
wwv_flow_imp.g_varchar2_table(7238) := '206D6F64656C3B0A7D0A0A0A2F2A2A0A202A20536574732061206E616D65642070726F7065727479206F6E207468652074617267657420656C656D656E742E0A202A204966207468652076616C756520697320756E646566696E65642C20746865207072';
wwv_flow_imp.g_varchar2_table(7239) := '6F706572747920676574732064656C657465642E0A202A0A202A2040706172616D207B4F626A6563747D207461726765740A202A2040706172616D207B537472696E677D206E616D650A202A2040706172616D207B4F626A6563747D2076616C75650A20';
wwv_flow_imp.g_varchar2_table(7240) := '2A2F0A50726F706572746965732E70726F746F747970652E736574203D2066756E6374696F6E287461726765742C206E616D652C2076616C756529207B0A0A2020696620282128302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(7241) := '4D4F44554C455F305F5F2E6973537472696E6729286E616D6529207C7C20216E616D652E6C656E67746829207B0A202020207468726F77206E657720547970654572726F72282770726F7065727479206E616D65206D7573742062652061206E6F6E2D65';
wwv_flow_imp.g_varchar2_table(7242) := '6D70747920737472696E6727293B0A20207D0A0A20207661722070726F7065727479203D20746869732E67657450726F7065727479287461726765742C206E616D65293B0A0A20207661722070726F70657274794E616D65203D2070726F706572747920';
wwv_flow_imp.g_varchar2_table(7243) := '26262070726F70657274792E6E616D653B0A0A2020696620286973556E646566696E65642876616C75652929207B0A0A202020202F2F20756E736574207468652070726F70657274792C20696620746865207370656369666965642076616C7565206973';
wwv_flow_imp.g_varchar2_table(7244) := '20756E646566696E65643B0A202020202F2F2064656C6574652066726F6D202461747472732028666F7220657874656E73696F6E7329206F72207468652074617267657420697473656C660A202020206966202870726F706572747929207B0A20202020';
wwv_flow_imp.g_varchar2_table(7245) := '202064656C657465207461726765745B70726F70657274794E616D655D3B0A202020207D20656C7365207B0A20202020202064656C657465207461726765742E2461747472735B7374726970476C6F62616C286E616D65295D3B0A202020207D0A20207D';
wwv_flow_imp.g_varchar2_table(7246) := '20656C7365207B0A0A202020202F2F20736574207468652070726F70657274792C20646566696E696E672077656C6C20646566696E65642070726F70657274696573206F6E2074686520666C790A202020202F2F206F722073696D706C79207570646174';
wwv_flow_imp.g_varchar2_table(7247) := '696E67207468656D20696E207461726765742E2461747472732028666F7220657874656E73696F6E73290A202020206966202870726F706572747929207B0A2020202020206966202870726F70657274794E616D6520696E2074617267657429207B0A20';
wwv_flow_imp.g_varchar2_table(7248) := '202020202020207461726765745B70726F70657274794E616D655D203D2076616C75653B0A2020202020207D20656C7365207B0A2020202020202020646566696E6550726F7065727479287461726765742C2070726F70657274792C2076616C7565293B';
wwv_flow_imp.g_varchar2_table(7249) := '0A2020202020207D0A202020207D20656C7365207B0A2020202020207461726765742E2461747472735B7374726970476C6F62616C286E616D65295D203D2076616C75653B0A202020207D0A20207D0A7D3B0A0A2F2A2A0A202A2052657475726E732074';
wwv_flow_imp.g_varchar2_table(7250) := '6865206E616D65642070726F7065727479206F662074686520676976656E20656C656D656E740A202A0A202A2040706172616D20207B4F626A6563747D207461726765740A202A2040706172616D20207B537472696E677D206E616D650A202A0A202A20';
wwv_flow_imp.g_varchar2_table(7251) := '4072657475726E207B4F626A6563747D0A202A2F0A50726F706572746965732E70726F746F747970652E676574203D2066756E6374696F6E287461726765742C206E616D6529207B0A0A20207661722070726F7065727479203D20746869732E67657450';
wwv_flow_imp.g_varchar2_table(7252) := '726F7065727479287461726765742C206E616D65293B0A0A2020696620282170726F706572747929207B0A2020202072657475726E207461726765742E2461747472735B7374726970476C6F62616C286E616D65295D3B0A20207D0A0A20207661722070';
wwv_flow_imp.g_varchar2_table(7253) := '726F70657274794E616D65203D2070726F70657274792E6E616D653B0A0A20202F2F20636865636B2069662061636365737320746F20636F6C6C656374696F6E2070726F706572747920616E64206C617A696C7920696E697469616C697A652069740A20';
wwv_flow_imp.g_varchar2_table(7254) := '2069662028217461726765745B70726F70657274794E616D655D2026262070726F70657274792E69734D616E7929207B0A20202020646566696E6550726F7065727479287461726765742C2070726F70657274792C205B5D293B0A20207D0A0A20207265';
wwv_flow_imp.g_varchar2_table(7255) := '7475726E207461726765745B70726F70657274794E616D655D3B0A7D3B0A0A0A2F2A2A0A202A20446566696E6520612070726F7065727479206F6E207468652074617267657420656C656D656E740A202A0A202A2040706172616D20207B4F626A656374';
wwv_flow_imp.g_varchar2_table(7256) := '7D207461726765740A202A2040706172616D20207B537472696E677D206E616D650A202A2040706172616D20207B4F626A6563747D206F7074696F6E730A202A2F0A50726F706572746965732E70726F746F747970652E646566696E65203D2066756E63';
wwv_flow_imp.g_varchar2_table(7257) := '74696F6E287461726765742C206E616D652C206F7074696F6E7329207B0A0A202069662028216F7074696F6E732E7772697461626C6529207B0A0A202020207661722076616C7565203D206F7074696F6E732E76616C75653B0A0A202020202F2F207573';
wwv_flow_imp.g_varchar2_table(7258) := '65206765747465727320666F7220726561642D6F6E6C79207661726961626C657320746F20737570706F7274204553362070726F786965730A202020202F2F2063662E2068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F696E746572';
wwv_flow_imp.g_varchar2_table(7259) := '6E616C2D646F63732F6973737565732F3338360A202020206F7074696F6E73203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E61737369676E29287B7D2C206F7074696F6E732C207B0A2020';
wwv_flow_imp.g_varchar2_table(7260) := '202020206765743A2066756E6374696F6E2829207B2072657475726E2076616C75653B207D0A202020207D293B0A0A2020202064656C657465206F7074696F6E732E76616C75653B0A20207D0A0A20204F626A6563742E646566696E6550726F70657274';
wwv_flow_imp.g_varchar2_table(7261) := '79287461726765742C206E616D652C206F7074696F6E73293B0A7D3B0A0A0A2F2A2A0A202A20446566696E65207468652064657363726970746F7220666F7220616E20656C656D656E740A202A2F0A50726F706572746965732E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(7262) := '646566696E6544657363726970746F72203D2066756E6374696F6E287461726765742C2064657363726970746F7229207B0A2020746869732E646566696E65287461726765742C20272464657363726970746F72272C207B2076616C75653A2064657363';
wwv_flow_imp.g_varchar2_table(7263) := '726970746F72207D293B0A7D3B0A0A2F2A2A0A202A20446566696E6520746865206D6F64656C20666F7220616E20656C656D656E740A202A2F0A50726F706572746965732E70726F746F747970652E646566696E654D6F64656C203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(7264) := '6E287461726765742C206D6F64656C29207B0A2020746869732E646566696E65287461726765742C2027246D6F64656C272C207B2076616C75653A206D6F64656C207D293B0A7D3B0A0A2F2A2A0A202A2052657475726E2070726F706572747920776974';
wwv_flow_imp.g_varchar2_table(7265) := '682074686520676976656E206E616D65206F6E2074686520656C656D656E742E0A202A0A202A2040706172616D207B616E797D207461726765740A202A2040706172616D207B737472696E677D206E616D650A202A0A202A204072657475726E207B6F62';
wwv_flow_imp.g_varchar2_table(7266) := '6A656374207C206E756C6C7D2070726F70657274790A202A2F0A50726F706572746965732E70726F746F747970652E67657450726F7065727479203D2066756E6374696F6E287461726765742C206E616D6529207B0A0A2020766172206D6F64656C203D';
wwv_flow_imp.g_varchar2_table(7267) := '20746869732E6D6F64656C3B0A0A20207661722070726F7065727479203D206D6F64656C2E67657450726F706572747944657363726970746F72287461726765742C206E616D65293B0A0A20206966202870726F706572747929207B0A20202020726574';
wwv_flow_imp.g_varchar2_table(7268) := '75726E2070726F70657274793B0A20207D0A0A2020696620286E616D652E696E636C7564657328273A272929207B0A2020202072657475726E206E756C6C3B0A20207D0A0A2020636F6E737420737472696374203D206D6F64656C2E636F6E6669672E73';
wwv_flow_imp.g_varchar2_table(7269) := '74726963743B0A0A202069662028747970656F662073747269637420213D3D2027756E646566696E65642729207B0A20202020636F6E7374206572726F72203D206E657720547970654572726F722860756E6B6E6F776E2070726F7065727479203C247B';
wwv_flow_imp.g_varchar2_table(7270) := '206E616D65207D3E206F6E203C247B207461726765742E2474797065207D3E60293B0A0A202020206966202873747269637429207B0A2020202020207468726F77206572726F723B0A202020207D20656C7365207B0A0A2020202020202F2F2065736C69';
wwv_flow_imp.g_varchar2_table(7271) := '6E742D64697361626C652D6E6578742D6C696E65206E6F2D756E6465660A202020202020747970656F6620636F6E736F6C6520213D3D2027756E646566696E65642720262620636F6E736F6C652E7761726E286572726F72293B0A202020207D0A20207D';
wwv_flow_imp.g_varchar2_table(7272) := '0A0A202072657475726E206E756C6C3B0A7D3B0A0A66756E6374696F6E206973556E646566696E65642876616C29207B0A202072657475726E20747970656F662076616C203D3D3D2027756E646566696E6564273B0A7D0A0A66756E6374696F6E206465';
wwv_flow_imp.g_varchar2_table(7273) := '66696E6550726F7065727479287461726765742C2070726F70657274792C2076616C756529207B0A20204F626A6563742E646566696E6550726F7065727479287461726765742C2070726F70657274792E6E616D652C207B0A20202020656E756D657261';
wwv_flow_imp.g_varchar2_table(7274) := '626C653A202170726F70657274792E69735265666572656E63652C0A202020207772697461626C653A20747275652C0A2020202076616C75653A2076616C75652C0A20202020636F6E666967757261626C653A20747275650A20207D293B0A7D0A0A6675';
wwv_flow_imp.g_varchar2_table(7275) := '6E6374696F6E207374726970476C6F62616C286E616D6529207B0A202072657475726E206E616D652E7265706C616365282F5E3A2F2C202727293B0A7D0A0A2F2F204D6F64646C6520696D706C656D656E746174696F6E202F2F2F2F2F2F2F2F2F2F2F2F';
wwv_flow_imp.g_varchar2_table(7276) := '2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F0A0A2F2A2A0A202A2040636C617373204D6F64646C650A202A0A202A2041206D6F64656C20746861742063616E206265207573656420746F20637265617465';
wwv_flow_imp.g_varchar2_table(7277) := '20656C656D656E7473206F66206120737065636966696320747970652E0A202A0A202A20406578616D706C650A202A0A202A20766172204D6F64646C65203D207265717569726528276D6F64646C6527293B0A202A0A202A2076617220706B67203D207B';
wwv_flow_imp.g_varchar2_table(7278) := '0A202A2020206E616D653A20276D797061636B616765272C0A202A2020207072656669783A20276D79272C0A202A20202074797065733A205B0A202A20202020207B206E616D653A2027526F6F7427207D0A202A2020205D0A202A207D3B0A202A0A202A';
wwv_flow_imp.g_varchar2_table(7279) := '20766172206D6F64646C65203D206E6577204D6F64646C65285B706B675D293B0A202A0A202A2040706172616D207B41727261793C5061636B6167653E7D207061636B6167657320746865207061636B6167657320746F20636F6E7461696E0A202A0A20';
wwv_flow_imp.g_varchar2_table(7280) := '2A2040706172616D207B207B207374726963743F3A20626F6F6C65616E207D207D205B636F6E6669675D206D6F64646C6520636F6E66696775726174696F6E0A202A2F0A66756E6374696F6E204D6F64646C65287061636B616765732C20636F6E666967';
wwv_flow_imp.g_varchar2_table(7281) := '203D207B7D29207B0A0A2020746869732E70726F70657274696573203D206E65772050726F706572746965732874686973293B0A0A2020746869732E666163746F7279203D206E657720466163746F727928746869732C20746869732E70726F70657274';
wwv_flow_imp.g_varchar2_table(7282) := '696573293B0A2020746869732E7265676973747279203D206E6577205265676973747279287061636B616765732C20746869732E70726F70657274696573293B0A0A2020746869732E747970654361636865203D207B7D3B0A0A2020746869732E636F6E';
wwv_flow_imp.g_varchar2_table(7283) := '666967203D20636F6E6669673B0A7D0A0A0A2F2A2A0A202A2043726561746520616E20696E7374616E6365206F66207468652073706563696669656420747970652E0A202A0A202A20406D6574686F64204D6F64646C65236372656174650A202A0A202A';
wwv_flow_imp.g_varchar2_table(7284) := '20406578616D706C650A202A0A202A2076617220666F6F203D206D6F64646C652E63726561746528276D793A466F6F27293B0A202A2076617220626172203D206D6F64646C652E63726561746528276D793A426172272C207B2069643A20274241525F31';
wwv_flow_imp.g_varchar2_table(7285) := '27207D293B0A202A0A202A2040706172616D20207B537472696E677C4F626A6563747D2064657363726970746F722074686520747970652064657363726970746F72206F72206E616D65206B6E6F7720746F20746865206D6F64656C0A202A2040706172';
wwv_flow_imp.g_varchar2_table(7286) := '616D20207B4F626A6563747D20617474727320202061206E756D626572206F66206174747269627574657320746F20696E697469616C697A6520746865206D6F64656C20696E7374616E636520776974680A202A204072657475726E207B4F626A656374';
wwv_flow_imp.g_varchar2_table(7287) := '7D2020202020202020206D6F64656C20696E7374616E63650A202A2F0A4D6F64646C652E70726F746F747970652E637265617465203D2066756E6374696F6E2864657363726970746F722C20617474727329207B0A20207661722054797065203D207468';
wwv_flow_imp.g_varchar2_table(7288) := '69732E676574547970652864657363726970746F72293B0A0A202069662028215479706529207B0A202020207468726F77206E6577204572726F722827756E6B6E6F776E2074797065203C27202B2064657363726970746F72202B20273E27293B0A2020';
wwv_flow_imp.g_varchar2_table(7289) := '7D0A0A202072657475726E206E65772054797065286174747273293B0A7D3B0A0A0A2F2A2A0A202A2052657475726E7320746865207479706520726570726573656E74696E67206120676976656E2064657363726970746F720A202A0A202A20406D6574';
wwv_flow_imp.g_varchar2_table(7290) := '686F64204D6F64646C6523676574547970650A202A0A202A20406578616D706C650A202A0A202A2076617220466F6F203D206D6F64646C652E6765745479706528276D793A466F6F27293B0A202A2076617220666F6F203D206E657720466F6F287B2027';
wwv_flow_imp.g_varchar2_table(7291) := '696427203A2027464F4F5F3127207D293B0A202A0A202A2040706172616D20207B537472696E677C4F626A6563747D2064657363726970746F722074686520747970652064657363726970746F72206F72206E616D65206B6E6F7720746F20746865206D';
wwv_flow_imp.g_varchar2_table(7292) := '6F64656C0A202A204072657475726E207B4F626A6563747D202020202020202020746865207479706520726570726573656E74696E67207468652064657363726970746F720A202A2F0A4D6F64646C652E70726F746F747970652E67657454797065203D';
wwv_flow_imp.g_varchar2_table(7293) := '2066756E6374696F6E2864657363726970746F7229207B0A0A2020766172206361636865203D20746869732E7479706543616368653B0A0A2020766172206E616D65203D2028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D';
wwv_flow_imp.g_varchar2_table(7294) := '4F44554C455F305F5F2E6973537472696E67292864657363726970746F7229203F2064657363726970746F72203A2064657363726970746F722E6E732E6E616D653B0A0A20207661722074797065203D2063616368655B6E616D655D3B0A0A2020696620';
wwv_flow_imp.g_varchar2_table(7295) := '28217479706529207B0A2020202064657363726970746F72203D20746869732E72656769737472792E67657445666665637469766544657363726970746F72286E616D65293B0A2020202074797065203D2063616368655B6E616D655D203D2074686973';
wwv_flow_imp.g_varchar2_table(7296) := '2E666163746F72792E637265617465547970652864657363726970746F72293B0A20207D0A0A202072657475726E20747970653B0A7D3B0A0A0A2F2A2A0A202A204372656174657320616E20616E792D656C656D656E74207479706520746F2062652075';
wwv_flow_imp.g_varchar2_table(7297) := '7365642077697468696E206D6F64656C20696E7374616E6365732E0A202A0A202A20546869732063616E206265207573656420746F2063726561746520637573746F6D20656C656D656E74732074686174206C6965206F75747369646520746865206D65';
wwv_flow_imp.g_varchar2_table(7298) := '74612D6D6F64656C2E0A202A20546865206372656174656420656C656D656E7420636F6E7461696E7320616C6C20746865206D6574612D6461746120726571756972656420746F2073657269616C697A652069740A202A2061732070617274206F66206D';
wwv_flow_imp.g_varchar2_table(7299) := '6574612D6D6F64656C20656C656D656E74732E0A202A0A202A20406D6574686F64204D6F64646C6523637265617465416E790A202A0A202A20406578616D706C650A202A0A202A2076617220666F6F203D206D6F64646C652E637265617465416E792827';
wwv_flow_imp.g_varchar2_table(7300) := '76656E646F723A466F6F272C2027687474703A2F2F76656E646F72272C207B0A202A20202076616C75653A2027626172270A202A207D293B0A202A0A202A2076617220636F6E7461696E6572203D206D6F64646C652E63726561746528276D793A436F6E';
wwv_flow_imp.g_varchar2_table(7301) := '7461696E6572272C2027687474703A2F2F6D79272C207B0A202A202020616E793A205B20666F6F205D0A202A207D293B0A202A0A202A202F2F20676F20616865616420616E642073657269616C697A65207468652073747566660A202A0A202A0A202A20';
wwv_flow_imp.g_varchar2_table(7302) := '40706172616D20207B537472696E677D206E616D652020746865206E616D65206F662074686520656C656D656E740A202A2040706172616D20207B537472696E677D206E7355726920746865206E616D65737061636520757269206F662074686520656C';
wwv_flow_imp.g_varchar2_table(7303) := '656D656E740A202A2040706172616D20207B4F626A6563747D205B70726F706572746965735D2061206D6170206F662070726F7065727469657320746F20696E697469616C697A652074686520696E7374616E636520776974680A202A20407265747572';
wwv_flow_imp.g_varchar2_table(7304) := '6E207B4F626A6563747D2074686520616E79207479706520696E7374616E63650A202A2F0A4D6F64646C652E70726F746F747970652E637265617465416E79203D2066756E6374696F6E286E616D652C206E735572692C2070726F706572746965732920';
wwv_flow_imp.g_varchar2_table(7305) := '7B0A0A2020766172206E616D654E73203D2070617273654E616D65286E616D65293B0A0A202076617220656C656D656E74203D207B0A2020202024747970653A206E616D652C0A2020202024696E7374616E63654F663A2066756E6374696F6E28747970';
wwv_flow_imp.g_varchar2_table(7306) := '6529207B0A20202020202072657475726E2074797065203D3D3D20746869732E24747970653B0A202020207D2C0A202020206765743A2066756E6374696F6E286B657929207B0A20202020202072657475726E20746869735B6B65795D3B0A202020207D';
wwv_flow_imp.g_varchar2_table(7307) := '2C0A202020207365743A2066756E6374696F6E286B65792C2076616C756529207B0A20202020202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E7365742928746869732C205B206B6579205D2C';
wwv_flow_imp.g_varchar2_table(7308) := '2076616C7565293B0A202020207D0A20207D3B0A0A20207661722064657363726970746F72203D207B0A202020206E616D653A206E616D652C0A20202020697347656E657269633A20747275652C0A202020206E733A207B0A2020202020207072656669';
wwv_flow_imp.g_varchar2_table(7309) := '783A206E616D654E732E7072656669782C0A2020202020206C6F63616C4E616D653A206E616D654E732E6C6F63616C4E616D652C0A2020202020207572693A206E735572690A202020207D0A20207D3B0A0A2020746869732E70726F706572746965732E';
wwv_flow_imp.g_varchar2_table(7310) := '646566696E6544657363726970746F7228656C656D656E742C2064657363726970746F72293B0A2020746869732E70726F706572746965732E646566696E654D6F64656C28656C656D656E742C2074686973293B0A2020746869732E70726F7065727469';
wwv_flow_imp.g_varchar2_table(7311) := '65732E646566696E6528656C656D656E742C2027676574272C207B20656E756D657261626C653A2066616C73652C207772697461626C653A2074727565207D293B0A2020746869732E70726F706572746965732E646566696E6528656C656D656E742C20';
wwv_flow_imp.g_varchar2_table(7312) := '27736574272C207B20656E756D657261626C653A2066616C73652C207772697461626C653A2074727565207D293B0A2020746869732E70726F706572746965732E646566696E6528656C656D656E742C202724706172656E74272C207B20656E756D6572';
wwv_flow_imp.g_varchar2_table(7313) := '61626C653A2066616C73652C207772697461626C653A2074727565207D293B0A2020746869732E70726F706572746965732E646566696E6528656C656D656E742C202724696E7374616E63654F66272C207B20656E756D657261626C653A2066616C7365';
wwv_flow_imp.g_varchar2_table(7314) := '2C207772697461626C653A2074727565207D293B0A0A202028302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E666F7245616368292870726F706572746965732C2066756E6374696F6E28612C206B65';
wwv_flow_imp.g_varchar2_table(7315) := '7929207B0A202020206966202828302C6D696E5F646173685F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F2E69734F626A6563742928612920262620612E76616C756520213D3D20756E646566696E656429207B0A2020202020';
wwv_flow_imp.g_varchar2_table(7316) := '20656C656D656E745B612E6E616D655D203D20612E76616C75653B0A202020207D20656C7365207B0A202020202020656C656D656E745B6B65795D203D20613B0A202020207D0A20207D293B0A0A202072657475726E20656C656D656E743B0A7D3B0A0A';
wwv_flow_imp.g_varchar2_table(7317) := '2F2A2A0A202A2052657475726E7320612072656769737465726564207061636B61676520627920757269206F72207072656669780A202A0A202A204072657475726E207B4F626A6563747D20746865207061636B6167650A202A2F0A4D6F64646C652E70';
wwv_flow_imp.g_varchar2_table(7318) := '726F746F747970652E6765745061636B616765203D2066756E6374696F6E287572694F7250726566697829207B0A202072657475726E20746869732E72656769737472792E6765745061636B616765287572694F72507265666978293B0A7D3B0A0A2F2A';
wwv_flow_imp.g_varchar2_table(7319) := '2A0A202A2052657475726E73206120736E617073686F74206F6620616C6C206B6E6F776E207061636B616765730A202A0A202A204072657475726E207B4F626A6563747D20746865207061636B6167650A202A2F0A4D6F64646C652E70726F746F747970';
wwv_flow_imp.g_varchar2_table(7320) := '652E6765745061636B61676573203D2066756E6374696F6E2829207B0A202072657475726E20746869732E72656769737472792E6765745061636B6167657328293B0A7D3B0A0A2F2A2A0A202A2052657475726E73207468652064657363726970746F72';
wwv_flow_imp.g_varchar2_table(7321) := '20666F7220616E20656C656D656E740A202A2F0A4D6F64646C652E70726F746F747970652E676574456C656D656E7444657363726970746F72203D2066756E6374696F6E28656C656D656E7429207B0A202072657475726E20656C656D656E742E246465';
wwv_flow_imp.g_varchar2_table(7322) := '7363726970746F723B0A7D3B0A0A2F2A2A0A202A2052657475726E7320747275652069662074686520676976656E2064657363726970746F72206F7220696E7374616E63650A202A20726570726573656E74732074686520676976656E20747970652E0A';
wwv_flow_imp.g_varchar2_table(7323) := '202A0A202A204D6179206265206170706C69656420746F20746869732C20696620656C656D656E74206973206F6D69747465642E0A202A2F0A4D6F64646C652E70726F746F747970652E68617354797065203D2066756E6374696F6E28656C656D656E74';
wwv_flow_imp.g_varchar2_table(7324) := '2C207479706529207B0A20206966202874797065203D3D3D20756E646566696E656429207B0A2020202074797065203D20656C656D656E743B0A20202020656C656D656E74203D20746869733B0A20207D0A0A20207661722064657363726970746F7220';
wwv_flow_imp.g_varchar2_table(7325) := '3D20656C656D656E742E246D6F64656C2E676574456C656D656E7444657363726970746F7228656C656D656E74293B0A0A202072657475726E20287479706520696E2064657363726970746F722E616C6C547970657342794E616D65293B0A7D3B0A0A2F';
wwv_flow_imp.g_varchar2_table(7326) := '2A2A0A202A2052657475726E73207468652064657363726970746F72206F6620616E20656C656D656E7473206E616D65642070726F70657274790A202A2F0A4D6F64646C652E70726F746F747970652E67657450726F706572747944657363726970746F';
wwv_flow_imp.g_varchar2_table(7327) := '72203D2066756E6374696F6E28656C656D656E742C2070726F706572747929207B0A202072657475726E20746869732E676574456C656D656E7444657363726970746F7228656C656D656E74292E70726F7065727469657342794E616D655B70726F7065';
wwv_flow_imp.g_varchar2_table(7328) := '7274795D3B0A7D3B0A0A2F2A2A0A202A2052657475726E732061206D6170706564207479706527732064657363726970746F720A202A2F0A4D6F64646C652E70726F746F747970652E6765745479706544657363726970746F72203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(7329) := '6E287479706529207B0A202072657475726E20746869732E72656769737472792E747970654D61705B747970655D3B0A7D3B0A0A0A2F2F2320736F757263654D617070696E6755524C3D696E6465782E65736D2E6A732E6D61700A0A0A2F2A2A2A2F207D';
wwv_flow_imp.g_varchar2_table(7330) := '292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F6F626A6563742D726566732F646973742F696E6465782E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(7331) := '2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F6F626A6563742D726566732F646973742F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(7332) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F5F5F7765627061636B5F6D6F64756C655F5F2C205F5F7765627061636B5F6578706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F';
wwv_flow_imp.g_varchar2_table(7333) := '29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F776562';
wwv_flow_imp.g_varchar2_table(7334) := '7061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F202020436F6C6C656374696F6E3A202829203D3E20282F2A2062696E64696E67202A2F20636F6C6C656374696F6E292C0A2F2A206861726D6F6E79206578';
wwv_flow_imp.g_varchar2_table(7335) := '706F7274202A2F202020526566733A202829203D3E20282F2A2062696E64696E67202A2F2052656673290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2A0A202A20457874656E6473206120636F6C6C656374696F6E2077697468';
wwv_flow_imp.g_varchar2_table(7336) := '207B406C696E6B20526566737D206177617265206D6574686F64730A202A0A202A2040706172616D207B41727261793C4F626A6563743E7D20636F6C6C656374696F6E0A202A2040706172616D207B526566737D207265667320696E7374616E63650A20';
wwv_flow_imp.g_varchar2_table(7337) := '2A2040706172616D207B4F626A6563747D2070726F706572747920726570726573656E7465642062792074686520636F6C6C656374696F6E0A202A2040706172616D207B4F626A6563747D20746172676574206F626A6563742074686520636F6C6C6563';
wwv_flow_imp.g_varchar2_table(7338) := '74696F6E20697320617474616368656420746F0A202A0A202A204072657475726E207B52656673436F6C6C656374696F6E3C4F626A6563743E7D2074686520657874656E6465642061727261790A202A2F0A66756E6374696F6E20657874656E6428636F';
wwv_flow_imp.g_varchar2_table(7339) := '6C6C656374696F6E2C20726566732C2070726F70657274792C2074617267657429207B0A202076617220696E766572736550726F7065727479203D2070726F70657274792E696E76657273653B0A0A20202F2A2A0A2020202A2052656D6F766573207468';
wwv_flow_imp.g_varchar2_table(7340) := '6520676976656E20656C656D656E742066726F6D2074686520617272617920616E642072657475726E732069742E0A2020202A0A2020202A20406D6574686F642052656673436F6C6C656374696F6E2372656D6F76650A2020202A0A2020202A20407061';
wwv_flow_imp.g_varchar2_table(7341) := '72616D207B4F626A6563747D20656C656D656E742074686520656C656D656E7420746F2072656D6F76650A2020202A2F0A20204F626A6563742E646566696E6550726F706572747928636F6C6C656374696F6E2C202772656D6F7665272C207B0A202020';
wwv_flow_imp.g_varchar2_table(7342) := '2076616C75653A2066756E6374696F6E2028656C656D656E7429207B0A20202020202076617220696478203D20746869732E696E6465784F6628656C656D656E74293B0A2020202020206966202869647820213D3D202D3129207B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(7343) := '746869732E73706C696365286964782C2031293B0A0A20202020202020202F2F20756E73657420696E76657273650A2020202020202020726566732E756E73657428656C656D656E742C20696E766572736550726F70657274792C20746172676574293B';
wwv_flow_imp.g_varchar2_table(7344) := '0A2020202020207D0A20202020202072657475726E20656C656D656E743B0A202020207D0A20207D293B0A0A20202F2A2A0A2020202A2052657475726E7320747275652069662074686520636F6C6C656374696F6E20636F6E7461696E73207468652067';
wwv_flow_imp.g_varchar2_table(7345) := '6976656E20656C656D656E740A2020202A0A2020202A20406D6574686F642052656673436F6C6C656374696F6E23636F6E7461696E730A2020202A0A2020202A2040706172616D207B4F626A6563747D20656C656D656E742074686520656C656D656E74';
wwv_flow_imp.g_varchar2_table(7346) := '20746F20636865636B20666F720A2020202A2F0A20204F626A6563742E646566696E6550726F706572747928636F6C6C656374696F6E2C2027636F6E7461696E73272C207B0A2020202076616C75653A2066756E6374696F6E2028656C656D656E742920';
wwv_flow_imp.g_varchar2_table(7347) := '7B0A20202020202072657475726E20746869732E696E6465784F6628656C656D656E742920213D3D202D313B0A202020207D0A20207D293B0A0A20202F2A2A0A2020202A204164647320616E20656C656D656E7420746F207468652061727261792C2075';
wwv_flow_imp.g_varchar2_table(7348) := '6E6C6573732069742065786973747320616C726561647920287365742073656D616E74696373292E0A2020202A0A2020202A20406D6574686F642052656673436F6C6C656374696F6E236164640A2020202A0A2020202A2040706172616D207B4F626A65';
wwv_flow_imp.g_varchar2_table(7349) := '63747D20656C656D656E742074686520656C656D656E7420746F206164640A2020202A2040706172616D207B4E756D6265727D206F7074696F6E616C20696E64657820746F2061646420656C656D656E7420746F0A2020202A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(7350) := '20202020202028706F737369626C79206D6F76696E67206F7468657220656C656D656E74732061726F756E64290A2020202A2F0A20204F626A6563742E646566696E6550726F706572747928636F6C6C656374696F6E2C2027616464272C207B0A202020';
wwv_flow_imp.g_varchar2_table(7351) := '2076616C75653A2066756E6374696F6E2028656C656D656E742C2069647829207B0A2020202020207661722063757272656E74496478203D20746869732E696E6465784F6628656C656D656E74293B0A20202020202069662028747970656F6620696478';
wwv_flow_imp.g_varchar2_table(7352) := '203D3D3D2027756E646566696E65642729207B0A20202020202020206966202863757272656E7449647820213D3D202D3129207B0A202020202020202020202F2F20656C656D656E7420616C726561647920696E20636F6C6C656374696F6E202821290A';
wwv_flow_imp.g_varchar2_table(7353) := '2020202020202020202072657475726E3B0A20202020202020207D0A0A20202020202020202F2F2061646420746F20656E64206F662061727261792C206173206E6F20696478206973207370656369666965640A2020202020202020696478203D207468';
wwv_flow_imp.g_varchar2_table(7354) := '69732E6C656E6774683B0A2020202020207D0A0A2020202020202F2F2068616E646C6520616C726561647920696E20636F6C6C656374696F6E0A2020202020206966202863757272656E7449647820213D3D202D3129207B0A20202020202020202F2F20';
wwv_flow_imp.g_varchar2_table(7355) := '72656D6F766520656C656D656E742066726F6D2063757272656E744964780A2020202020202020746869732E73706C6963652863757272656E744964782C2031293B0A2020202020207D0A0A2020202020202F2F2061646420656C656D656E7420617420';
wwv_flow_imp.g_varchar2_table(7356) := '6964780A202020202020746869732E73706C696365286964782C20302C20656C656D656E74293B0A2020202020206966202863757272656E74496478203D3D3D202D3129207B0A20202020202020202F2F2073657420696E76657273652C20756E6C6573';
wwv_flow_imp.g_varchar2_table(7357) := '7320656C656D656E74207761730A20202020202020202F2F20696E20636F6C6C656374696F6E20616C72656164790A2020202020202020726566732E73657428656C656D656E742C20696E766572736550726F70657274792C20746172676574293B0A20';
wwv_flow_imp.g_varchar2_table(7358) := '20202020207D0A202020207D0A20207D293B0A0A20202F2F20612073696D706C65206D61726B65722C206964656E74696679696E67207468697320656C656D656E740A20202F2F206173206265696E672061207265667320636F6C6C656374696F6E0A20';
wwv_flow_imp.g_varchar2_table(7359) := '204F626A6563742E646566696E6550726F706572747928636F6C6C656374696F6E2C20275F5F726566735F636F6C6C656374696F6E272C207B0A2020202076616C75653A20747275650A20207D293B0A202072657475726E20636F6C6C656374696F6E3B';
wwv_flow_imp.g_varchar2_table(7360) := '0A7D0A0A2F2A2A0A202A20436865636B73206966206120676976656E20636F6C6C656374696F6E20697320657874656E6465640A202A0A202A2040706172616D207B41727261793C4F626A6563743E7D20636F6C6C656374696F6E0A202A0A202A204072';
wwv_flow_imp.g_varchar2_table(7361) := '657475726E207B626F6F6C65616E7D0A202A2F0A66756E6374696F6E206973457874656E64656428636F6C6C656374696F6E29207B0A202072657475726E20636F6C6C656374696F6E2E5F5F726566735F636F6C6C656374696F6E203D3D3D2074727565';
wwv_flow_imp.g_varchar2_table(7362) := '3B0A7D0A0A76617220636F6C6C656374696F6E203D207B0A20205F5F70726F746F5F5F3A206E756C6C2C0A2020657874656E643A20657874656E642C0A20206973457874656E6465643A206973457874656E6465640A7D3B0A0A66756E6374696F6E2068';
wwv_flow_imp.g_varchar2_table(7363) := '61734F776E50726F706572747928652C2070726F706572747929207B0A202072657475726E204F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28652C2070726F70657274792E6E616D65207C7C2070726F7065';
wwv_flow_imp.g_varchar2_table(7364) := '727479293B0A7D0A66756E6374696F6E20646566696E65436F6C6C656374696F6E50726F7065727479287265662C2070726F70657274792C2074617267657429207B0A202076617220636F6C6C656374696F6E203D20657874656E64287461726765745B';
wwv_flow_imp.g_varchar2_table(7365) := '70726F70657274792E6E616D655D207C7C205B5D2C207265662C2070726F70657274792C20746172676574293B0A20204F626A6563742E646566696E6550726F7065727479287461726765742C2070726F70657274792E6E616D652C207B0A2020202065';
wwv_flow_imp.g_varchar2_table(7366) := '6E756D657261626C653A2070726F70657274792E656E756D657261626C652C0A2020202076616C75653A20636F6C6C656374696F6E0A20207D293B0A202069662028636F6C6C656374696F6E2E6C656E67746829207B0A20202020636F6C6C656374696F';
wwv_flow_imp.g_varchar2_table(7367) := '6E2E666F72456163682866756E6374696F6E20286F29207B0A2020202020207265662E736574286F2C2070726F70657274792E696E76657273652C20746172676574293B0A202020207D293B0A20207D0A7D0A66756E6374696F6E20646566696E655072';
wwv_flow_imp.g_varchar2_table(7368) := '6F7065727479287265662C2070726F70657274792C2074617267657429207B0A202076617220696E766572736550726F7065727479203D2070726F70657274792E696E76657273653B0A2020766172205F76616C7565203D207461726765745B70726F70';
wwv_flow_imp.g_varchar2_table(7369) := '657274792E6E616D655D3B0A20204F626A6563742E646566696E6550726F7065727479287461726765742C2070726F70657274792E6E616D652C207B0A20202020636F6E666967757261626C653A2070726F70657274792E636F6E666967757261626C65';
wwv_flow_imp.g_varchar2_table(7370) := '2C0A20202020656E756D657261626C653A2070726F70657274792E656E756D657261626C652C0A202020206765743A2066756E6374696F6E202829207B0A20202020202072657475726E205F76616C75653B0A202020207D2C0A202020207365743A2066';
wwv_flow_imp.g_varchar2_table(7371) := '756E6374696F6E202876616C756529207B0A2020202020202F2F2072657475726E20696620776520616C726561647920706572666F726D656420616C6C206368616E6765730A2020202020206966202876616C7565203D3D3D205F76616C756529207B0A';
wwv_flow_imp.g_varchar2_table(7372) := '202020202020202072657475726E3B0A2020202020207D0A202020202020766172206F6C64203D205F76616C75653B0A0A2020202020202F2F2074656D706F7261727920736574206E756C6C0A2020202020205F76616C7565203D206E756C6C3B0A2020';
wwv_flow_imp.g_varchar2_table(7373) := '20202020696620286F6C6429207B0A20202020202020207265662E756E736574286F6C642C20696E766572736550726F70657274792C20746172676574293B0A2020202020207D0A0A2020202020202F2F20736574206E65772076616C75650A20202020';
wwv_flow_imp.g_varchar2_table(7374) := '20205F76616C7565203D2076616C75653B0A0A2020202020202F2F2073657420696E76657273652076616C75650A2020202020207265662E736574285F76616C75652C20696E766572736550726F70657274792C20746172676574293B0A202020207D0A';
wwv_flow_imp.g_varchar2_table(7375) := '20207D293B0A7D0A0A2F2A2A0A202A20437265617465732061206E6577207265666572656E636573206F626A65637420646566696E696E672074776F20696E766572736C792072656C617465640A202A206174747269627574652064657363726970746F';
wwv_flow_imp.g_varchar2_table(7376) := '7273206120616E6420622E0A202A0A202A203C703E0A202A2020205768656E20626F756E6420746F20616E206F626A656374207573696E67207B406C696E6B20526566732362696E647D20746865207265666572656E6365730A202A2020206765742061';
wwv_flow_imp.g_varchar2_table(7377) := '637469766174656420616E6420656E7375726520746861742061646420616E642072656D6F7665206F7065726174696F6E7320617265206170706C6965640A202A202020726576657273656C792C20746F6F2E0A202A203C2F703E0A202A0A202A203C70';
wwv_flow_imp.g_varchar2_table(7378) := '3E0A202A202020466F72206174747269627574657320726570726573656E74656420617320636F6C6C656374696F6E73207B406C696E6B20526566737D2070726F7669646573207468650A202A2020207B406C696E6B2052656673436F6C6C656374696F';
wwv_flow_imp.g_varchar2_table(7379) := '6E236164647D2C207B406C696E6B2052656673436F6C6C656374696F6E2372656D6F76657D20616E64207B406C696E6B2052656673436F6C6C656374696F6E23636F6E7461696E737D20657874656E73696F6E730A202A20202074686174206D75737420';
wwv_flow_imp.g_varchar2_table(7380) := '6265207573656420746F2070726F7065726C7920686F6F6B20696E746F2074686520696E7665727365206368616E6765206D656368616E69736D2E0A202A203C2F703E0A202A0A202A2040636C61737320526566730A202A0A202A2040636C6173736465';
wwv_flow_imp.g_varchar2_table(7381) := '736320412062692D646972656374696F6E616C207265666572656E6365206265747765656E2074776F20617474726962757465732E0A202A0A202A2040706172616D207B526566732E41747472696275746544657363726970746F727D20612070726F70';
wwv_flow_imp.g_varchar2_table(7382) := '657274792064657363726970746F720A202A2040706172616D207B526566732E41747472696275746544657363726970746F727D20622070726F70657274792064657363726970746F720A202A0A202A20406578616D706C650A202A0A202A2076617220';
wwv_flow_imp.g_varchar2_table(7383) := '72656673203D2052656673287B206E616D653A2027776865656C73272C20636F6C6C656374696F6E3A20747275652C20656E756D657261626C653A2074727565207D2C207B206E616D653A202763617227207D293B0A202A0A202A207661722063617220';
wwv_flow_imp.g_varchar2_table(7384) := '3D207B206E616D653A2027746F796F746127207D3B0A202A2076617220776865656C73203D205B7B20706F733A202766726F6E742D6C65667427207D2C207B20706F733A202766726F6E742D726967687427207D5D3B0A202A0A202A20726566732E6269';
wwv_flow_imp.g_varchar2_table(7385) := '6E64286361722C2027776865656C7327293B0A202A0A202A206361722E776865656C73202F2F205B5D0A202A206361722E776865656C732E61646428776865656C735B305D293B0A202A206361722E776865656C732E61646428776865656C735B315D29';
wwv_flow_imp.g_varchar2_table(7386) := '3B0A202A0A202A206361722E776865656C73202F2F205B7B20706F733A202766726F6E742D6C65667427207D2C207B20706F733A202766726F6E742D726967687427207D5D0A202A0A202A20776865656C735B305D2E636172202F2F207B206E616D653A';
wwv_flow_imp.g_varchar2_table(7387) := '2027746F796F746127207D3B0A202A206361722E776865656C732E72656D6F766528776865656C735B305D293B0A202A0A202A20776865656C735B305D2E636172202F2F20756E646566696E65640A202A2F0A66756E6374696F6E205265667328612C20';
wwv_flow_imp.g_varchar2_table(7388) := '6229207B0A20206966202821287468697320696E7374616E63656F6620526566732929207B0A2020202072657475726E206E6577205265667328612C2062293B0A20207D0A0A20202F2F206C696E6B0A2020612E696E7665727365203D20623B0A202062';
wwv_flow_imp.g_varchar2_table(7389) := '2E696E7665727365203D20613B0A2020746869732E70726F7073203D207B7D3B0A2020746869732E70726F70735B612E6E616D655D203D20613B0A2020746869732E70726F70735B622E6E616D655D203D20623B0A7D0A0A2F2A2A0A202A2042696E6473';
wwv_flow_imp.g_varchar2_table(7390) := '206F6E652073696465206F6620612062692D646972656374696F6E616C207265666572656E636520746F20610A202A20746172676574206F626A6563742E0A202A0A202A20406D656D6265724F6620526566730A202A0A202A2040706172616D20207B4F';
wwv_flow_imp.g_varchar2_table(7391) := '626A6563747D207461726765740A202A2040706172616D20207B537472696E677D2070726F70657274790A202A2F0A526566732E70726F746F747970652E62696E64203D2066756E6374696F6E20287461726765742C2070726F706572747929207B0A20';
wwv_flow_imp.g_varchar2_table(7392) := '2069662028747970656F662070726F7065727479203D3D3D2027737472696E672729207B0A202020206966202821746869732E70726F70735B70726F70657274795D29207B0A2020202020207468726F77206E6577204572726F7228276E6F2070726F70';
wwv_flow_imp.g_varchar2_table(7393) := '65727479203C27202B2070726F7065727479202B20273E20696E2072656627293B0A202020207D0A2020202070726F7065727479203D20746869732E70726F70735B70726F70657274795D3B0A20207D0A20206966202870726F70657274792E636F6C6C';
wwv_flow_imp.g_varchar2_table(7394) := '656374696F6E29207B0A20202020646566696E65436F6C6C656374696F6E50726F706572747928746869732C2070726F70657274792C20746172676574293B0A20207D20656C7365207B0A20202020646566696E6550726F706572747928746869732C20';
wwv_flow_imp.g_varchar2_table(7395) := '70726F70657274792C20746172676574293B0A20207D0A7D3B0A526566732E70726F746F747970652E656E7375726552656673436F6C6C656374696F6E203D2066756E6374696F6E20287461726765742C2070726F706572747929207B0A202076617220';
wwv_flow_imp.g_varchar2_table(7396) := '636F6C6C656374696F6E203D207461726765745B70726F70657274792E6E616D655D3B0A202069662028216973457874656E64656428636F6C6C656374696F6E2929207B0A20202020646566696E65436F6C6C656374696F6E50726F7065727479287468';
wwv_flow_imp.g_varchar2_table(7397) := '69732C2070726F70657274792C20746172676574293B0A20207D0A202072657475726E20636F6C6C656374696F6E3B0A7D3B0A526566732E70726F746F747970652E656E73757265426F756E64203D2066756E6374696F6E20287461726765742C207072';
wwv_flow_imp.g_varchar2_table(7398) := '6F706572747929207B0A202069662028216861734F776E50726F7065727479287461726765742C2070726F70657274792929207B0A20202020746869732E62696E64287461726765742C2070726F7065727479293B0A20207D0A7D3B0A526566732E7072';
wwv_flow_imp.g_varchar2_table(7399) := '6F746F747970652E756E736574203D2066756E6374696F6E20287461726765742C2070726F70657274792C2076616C756529207B0A20206966202874617267657429207B0A20202020746869732E656E73757265426F756E64287461726765742C207072';
wwv_flow_imp.g_varchar2_table(7400) := '6F7065727479293B0A202020206966202870726F70657274792E636F6C6C656374696F6E29207B0A202020202020746869732E656E7375726552656673436F6C6C656374696F6E287461726765742C2070726F7065727479292E72656D6F76652876616C';
wwv_flow_imp.g_varchar2_table(7401) := '7565293B0A202020207D20656C7365207B0A2020202020207461726765745B70726F70657274792E6E616D655D203D20756E646566696E65643B0A202020207D0A20207D0A7D3B0A526566732E70726F746F747970652E736574203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(7402) := '6E20287461726765742C2070726F70657274792C2076616C756529207B0A20206966202874617267657429207B0A20202020746869732E656E73757265426F756E64287461726765742C2070726F7065727479293B0A202020206966202870726F706572';
wwv_flow_imp.g_varchar2_table(7403) := '74792E636F6C6C656374696F6E29207B0A202020202020746869732E656E7375726552656673436F6C6C656374696F6E287461726765742C2070726F7065727479292E6164642876616C7565293B0A202020207D20656C7365207B0A2020202020207461';
wwv_flow_imp.g_varchar2_table(7404) := '726765745B70726F70657274792E6E616D655D203D2076616C75653B0A202020207D0A20207D0A7D3B0A0A2F2A2A0A202A20416E206174747269627574652064657363726970746F7220746F2062652075736564207370656369667920616E2061747472';
wwv_flow_imp.g_varchar2_table(7405) := '696275746520696E2061207B406C696E6B20526566737D20696E7374616E63650A202A0A202A204074797065646566207B4F626A6563747D20526566732E41747472696275746544657363726970746F720A202A204070726F7065727479207B53747269';
wwv_flow_imp.g_varchar2_table(7406) := '6E677D206E616D650A202A204070726F7065727479207B626F6F6C65616E7D205B636F6C6C656374696F6E3D66616C73655D0A202A204070726F7065727479207B626F6F6C65616E7D205B656E756D657261626C653D66616C73655D0A202A2F0A0A0A0A';
wwv_flow_imp.g_varchar2_table(7407) := '0A2F2A2A2A2F207D292C0A0A2F2A2A2A2F20222E2F6E6F64655F6D6F64756C65732F706174682D696E74657273656374696F6E2F696E746572736563742E6A73223A0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(7408) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A212A5C0A2020212A2A2A202E2F6E6F64655F6D6F64756C65732F706174682D696E74657273656374696F6E2F696E746572736563742E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(7409) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2F2028285F5F756E757365645F7765627061636B5F5F5F7765627061636B5F6D6F64756C655F5F2C205F5F7765627061636B5F6578';
wwv_flow_imp.g_varchar2_table(7410) := '706F7274735F5F2C205F5F7765627061636B5F726571756972655F5F29203D3E207B0A0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A206861726D6F6E79206578706F7274202A2F';
wwv_flow_imp.g_varchar2_table(7411) := '205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829203D3E20282F2A2062696E64696E67202A2F';
wwv_flow_imp.g_varchar2_table(7412) := '2066696E6450617468496E74657273656374696F6E73290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A2A0A202A20546869732066696C6520636F6E7461696E7320736F7572636520636F646520616461707465642066726F6D20';
wwv_flow_imp.g_varchar2_table(7413) := '536E61702E73766720286C6963656E736564204170616368652D322E30292E0A202A0A202A20407365652068747470733A2F2F6769746875622E636F6D2F61646F62652D776562706C6174666F726D2F536E61702E7376672F626C6F622F6D6173746572';
wwv_flow_imp.g_varchar2_table(7414) := '2F7372632F706174682E6A730A202A2F0A0A2F2A2065736C696E74206E6F2D66616C6C7468726F7567683A20226F666622202A2F0A0A76617220703273203D202F2C3F285B612D7A5D292C3F2F67692C0A20202020746F466C6F6174203D207061727365';
wwv_flow_imp.g_varchar2_table(7415) := '466C6F61742C0A202020206D617468203D204D6174682C0A202020205049203D206D6174682E50492C0A202020206D6D696E203D206D6174682E6D696E2C0A202020206D6D6178203D206D6174682E6D61782C0A20202020706F77203D206D6174682E70';
wwv_flow_imp.g_varchar2_table(7416) := '6F772C0A20202020616273203D206D6174682E6162732C0A2020202070617468436F6D6D616E64203D202F285B612D7A5D295B5C732C5D2A28282D3F5C642A5C2E3F5C642A283F3A655B2D2B5D3F5C642B293F5B5C735D2A2C3F5B5C735D2A292B292F69';
wwv_flow_imp.g_varchar2_table(7417) := '672C0A202020207061746856616C756573203D202F282D3F5C642A5C2E3F5C642A283F3A655B2D2B5D3F5C642B293F295B5C735D2A2C3F5B5C735D2A2F69673B0A0A7661722069734172726179203D2041727261792E69734172726179207C7C2066756E';
wwv_flow_imp.g_varchar2_table(7418) := '6374696F6E286F29207B2072657475726E206F20696E7374616E63656F662041727261793B207D3B0A0A66756E6374696F6E2068617350726F7065727479286F626A2C2070726F706572747929207B0A202072657475726E204F626A6563742E70726F74';
wwv_flow_imp.g_varchar2_table(7419) := '6F747970652E6861734F776E50726F70657274792E63616C6C286F626A2C2070726F7065727479293B0A7D0A0A66756E6374696F6E20636C6F6E65286F626A29207B0A0A202069662028747970656F66206F626A203D3D202766756E6374696F6E27207C';
wwv_flow_imp.g_varchar2_table(7420) := '7C204F626A656374286F626A2920213D3D206F626A29207B0A2020202072657475726E206F626A3B0A20207D0A0A202076617220726573203D206E6577206F626A2E636F6E7374727563746F723B0A0A2020666F722028766172206B657920696E206F62';
wwv_flow_imp.g_varchar2_table(7421) := '6A29207B0A202020206966202868617350726F7065727479286F626A2C206B65792929207B0A2020202020207265735B6B65795D203D20636C6F6E65286F626A5B6B65795D293B0A202020207D0A20207D0A0A202072657475726E207265733B0A7D0A0A';
wwv_flow_imp.g_varchar2_table(7422) := '66756E6374696F6E207265707573682861727261792C206974656D29207B0A2020666F7220287661722069203D20302C206969203D2061727261792E6C656E6774683B2069203C2069693B20692B2B29206966202861727261795B695D203D3D3D206974';
wwv_flow_imp.g_varchar2_table(7423) := '656D29207B0A2020202072657475726E2061727261792E707573682861727261792E73706C69636528692C2031295B305D293B0A20207D0A7D0A0A66756E6374696F6E20636163686572286629207B0A0A202066756E6374696F6E206E6577662829207B';
wwv_flow_imp.g_varchar2_table(7424) := '0A0A2020202076617220617267203D2041727261792E70726F746F747970652E736C6963652E63616C6C28617267756D656E74732C2030292C0A202020202020202061726773203D206172672E6A6F696E28275C753234303027292C0A20202020202020';
wwv_flow_imp.g_varchar2_table(7425) := '206361636865203D206E6577662E6361636865203D206E6577662E6361636865207C7C207B7D2C0A2020202020202020636F756E74203D206E6577662E636F756E74203D206E6577662E636F756E74207C7C205B5D3B0A0A202020206966202868617350';
wwv_flow_imp.g_varchar2_table(7426) := '726F70657274792863616368652C20617267732929207B0A20202020202072657075736828636F756E742C2061726773293B0A20202020202072657475726E2063616368655B617267735D3B0A202020207D0A0A20202020636F756E742E6C656E677468';
wwv_flow_imp.g_varchar2_table(7427) := '203E3D203165332026262064656C6574652063616368655B636F756E742E736869667428295D3B0A20202020636F756E742E707573682861726773293B0A2020202063616368655B617267735D203D2066282E2E2E617267756D656E7473293B0A0A2020';
wwv_flow_imp.g_varchar2_table(7428) := '202072657475726E2063616368655B617267735D3B0A20207D0A202072657475726E206E6577663B0A7D0A0A66756E6374696F6E20706172736550617468537472696E672870617468537472696E6729207B0A0A2020696620282170617468537472696E';
wwv_flow_imp.g_varchar2_table(7429) := '6729207B0A2020202072657475726E206E756C6C3B0A20207D0A0A202076617220707468203D2070617468732870617468537472696E67293B0A0A2020696620287074682E61727229207B0A2020202072657475726E20636C6F6E65287074682E617272';
wwv_flow_imp.g_varchar2_table(7430) := '293B0A20207D0A0A202076617220706172616D436F756E7473203D207B20613A20372C20633A20362C20683A20312C206C3A20322C206D3A20322C20713A20342C20733A20342C20743A20322C20763A20312C207A3A2030207D2C0A2020202020206461';
wwv_flow_imp.g_varchar2_table(7431) := '7461203D205B5D3B0A0A202069662028697341727261792870617468537472696E672920262620697341727261792870617468537472696E675B305D2929207B202F2F20726F75676820617373756D7074696F6E0A2020202064617461203D20636C6F6E';
wwv_flow_imp.g_varchar2_table(7432) := '652870617468537472696E67293B0A20207D0A0A20206966202821646174612E6C656E67746829207B0A0A20202020537472696E672870617468537472696E67292E7265706C6163652870617468436F6D6D616E642C2066756E6374696F6E28612C2062';
wwv_flow_imp.g_varchar2_table(7433) := '2C206329207B0A20202020202076617220706172616D73203D205B5D2C0A202020202020202020206E616D65203D20622E746F4C6F7765724361736528293B0A0A202020202020632E7265706C616365287061746856616C7565732C2066756E6374696F';
wwv_flow_imp.g_varchar2_table(7434) := '6E28612C206229207B0A20202020202020206220262620706172616D732E70757368282B62293B0A2020202020207D293B0A0A202020202020696620286E616D65203D3D20276D2720262620706172616D732E6C656E677468203E203229207B0A202020';
wwv_flow_imp.g_varchar2_table(7435) := '2020202020646174612E70757368285B20622C202E2E2E706172616D732E73706C69636528302C203229205D293B0A20202020202020206E616D65203D20276C273B0A202020202020202062203D2062203D3D20276D27203F20276C27203A20274C273B';
wwv_flow_imp.g_varchar2_table(7436) := '0A2020202020207D0A0A2020202020207768696C652028706172616D732E6C656E677468203E3D20706172616D436F756E74735B6E616D655D29207B0A2020202020202020646174612E70757368285B20622C202E2E2E706172616D732E73706C696365';
wwv_flow_imp.g_varchar2_table(7437) := '28302C20706172616D436F756E74735B6E616D655D29205D293B0A20202020202020206966202821706172616D436F756E74735B6E616D655D29207B0A20202020202020202020627265616B3B0A20202020202020207D0A2020202020207D0A20202020';
wwv_flow_imp.g_varchar2_table(7438) := '7D293B0A20207D0A0A2020646174612E746F537472696E67203D2070617468732E746F537472696E673B0A20207074682E617272203D20636C6F6E652864617461293B0A0A202072657475726E20646174613B0A7D0A0A66756E6374696F6E2070617468';
wwv_flow_imp.g_varchar2_table(7439) := '7328707329207B0A20207661722070203D2070617468732E7073203D2070617468732E7073207C7C207B7D3B0A0A202069662028705B70735D29207B0A20202020705B70735D2E736C656570203D203130303B0A20207D20656C7365207B0A2020202070';
wwv_flow_imp.g_varchar2_table(7440) := '5B70735D203D207B0A202020202020736C6565703A203130300A202020207D3B0A20207D0A0A202073657454696D656F75742866756E6374696F6E2829207B0A20202020666F722028766172206B657920696E207029207B0A2020202020206966202868';
wwv_flow_imp.g_varchar2_table(7441) := '617350726F706572747928702C206B657929202626206B657920213D20707329207B0A2020202020202020705B6B65795D2E736C6565702D2D3B0A202020202020202021705B6B65795D2E736C6565702026262064656C65746520705B6B65795D3B0A20';
wwv_flow_imp.g_varchar2_table(7442) := '20202020207D0A202020207D0A20207D293B0A0A202072657475726E20705B70735D3B0A7D0A0A66756E6374696F6E207265637442426F7828782C20792C2077696474682C2068656967687429207B0A0A202069662028617267756D656E74732E6C656E';
wwv_flow_imp.g_varchar2_table(7443) := '677468203D3D3D203129207B0A2020202079203D20782E793B0A202020207769647468203D20782E77696474683B0A20202020686569676874203D20782E6865696768743B0A2020202078203D20782E783B0A20207D0A0A202072657475726E207B0A20';
wwv_flow_imp.g_varchar2_table(7444) := '202020783A20782C0A20202020793A20792C0A2020202077696474683A2077696474682C0A202020206865696768743A206865696768742C0A2020202078323A2078202B2077696474682C0A2020202079323A2079202B206865696768740A20207D3B0A';
wwv_flow_imp.g_varchar2_table(7445) := '7D0A0A66756E6374696F6E2070617468546F537472696E672829207B0A202072657475726E20746869732E6A6F696E28272C27292E7265706C616365287032732C2027243127293B0A7D0A0A66756E6374696F6E2070617468436C6F6E65287061746841';
wwv_flow_imp.g_varchar2_table(7446) := '7272617929207B0A202076617220726573203D20636C6F6E6528706174684172726179293B0A20207265732E746F537472696E67203D2070617468546F537472696E673B0A202072657475726E207265733B0A7D0A0A66756E6374696F6E2066696E6444';
wwv_flow_imp.g_varchar2_table(7447) := '6F747341745365676D656E74287031782C207031792C206331782C206331792C206332782C206332792C207032782C207032792C207429207B0A2020766172207431203D2031202D20742C0A202020202020743133203D20706F772874312C2033292C0A';
wwv_flow_imp.g_varchar2_table(7448) := '202020202020743132203D20706F772874312C2032292C0A2020202020207432203D2074202A20742C0A2020202020207433203D207432202A20742C0A20202020202078203D20743133202A20703178202B20743132202A2033202A2074202A20633178';
wwv_flow_imp.g_varchar2_table(7449) := '202B207431202A2033202A2074202A2074202A20633278202B207433202A207032782C0A20202020202079203D20743133202A20703179202B20743132202A2033202A2074202A20633179202B207431202A2033202A2074202A2074202A20633279202B';
wwv_flow_imp.g_varchar2_table(7450) := '207433202A207032793B0A0A202072657475726E207B0A20202020783A206669784572726F722878292C0A20202020793A206669784572726F722879290A20207D3B0A7D0A0A66756E6374696F6E2062657A69657242426F7828706F696E747329207B0A';
wwv_flow_imp.g_varchar2_table(7451) := '0A20207661722062626F78203D20637572766542426F78282E2E2E706F696E7473293B0A0A202072657475726E207265637442426F78280A2020202062626F782E78302C0A2020202062626F782E79302C0A2020202062626F782E7831202D2062626F78';
wwv_flow_imp.g_varchar2_table(7452) := '2E78302C0A2020202062626F782E7931202D2062626F782E79300A2020293B0A7D0A0A66756E6374696F6E206973506F696E74496E7369646542426F782862626F782C20782C207929207B0A202072657475726E2078203E3D2062626F782E782026260A';
wwv_flow_imp.g_varchar2_table(7453) := '2020202078203C3D2062626F782E78202B2062626F782E77696474682026260A2020202079203E3D2062626F782E792026260A2020202079203C3D2062626F782E79202B2062626F782E6865696768743B0A7D0A0A66756E6374696F6E20697342426F78';
wwv_flow_imp.g_varchar2_table(7454) := '496E746572736563742862626F78312C2062626F783229207B0A202062626F7831203D207265637442426F782862626F7831293B0A202062626F7832203D207265637442426F782862626F7832293B0A202072657475726E206973506F696E74496E7369';
wwv_flow_imp.g_varchar2_table(7455) := '646542426F782862626F78322C2062626F78312E782C2062626F78312E79290A202020207C7C206973506F696E74496E7369646542426F782862626F78322C2062626F78312E78322C2062626F78312E79290A202020207C7C206973506F696E74496E73';
wwv_flow_imp.g_varchar2_table(7456) := '69646542426F782862626F78322C2062626F78312E782C2062626F78312E7932290A202020207C7C206973506F696E74496E7369646542426F782862626F78322C2062626F78312E78322C2062626F78312E7932290A202020207C7C206973506F696E74';
wwv_flow_imp.g_varchar2_table(7457) := '496E7369646542426F782862626F78312C2062626F78322E782C2062626F78322E79290A202020207C7C206973506F696E74496E7369646542426F782862626F78312C2062626F78322E78322C2062626F78322E79290A202020207C7C206973506F696E';
wwv_flow_imp.g_varchar2_table(7458) := '74496E7369646542426F782862626F78312C2062626F78322E782C2062626F78322E7932290A202020207C7C206973506F696E74496E7369646542426F782862626F78312C2062626F78322E78322C2062626F78322E7932290A202020207C7C20286262';
wwv_flow_imp.g_varchar2_table(7459) := '6F78312E78203C2062626F78322E78322026262062626F78312E78203E2062626F78322E780A20202020202020207C7C2062626F78322E78203C2062626F78312E78322026262062626F78322E78203E2062626F78312E78290A20202020262620286262';
wwv_flow_imp.g_varchar2_table(7460) := '6F78312E79203C2062626F78322E79322026262062626F78312E79203E2062626F78322E790A20202020202020207C7C2062626F78322E79203C2062626F78312E79322026262062626F78322E79203E2062626F78312E79293B0A7D0A0A66756E637469';
wwv_flow_imp.g_varchar2_table(7461) := '6F6E20626173653328742C2070312C2070322C2070332C20703429207B0A2020766172207431203D202D33202A207031202B2039202A207032202D2039202A207033202B2033202A2070342C0A2020202020207432203D2074202A207431202B2036202A';
wwv_flow_imp.g_varchar2_table(7462) := '207031202D203132202A207032202B2036202A2070333B0A202072657475726E2074202A207432202D2033202A207031202B2033202A2070323B0A7D0A0A66756E6374696F6E2062657A6C656E2878312C2079312C2078322C2079322C2078332C207933';
wwv_flow_imp.g_varchar2_table(7463) := '2C2078342C2079342C207A29207B0A0A2020696620287A203D3D206E756C6C29207B0A202020207A203D20313B0A20207D0A0A20207A203D207A203E2031203F2031203A207A203C2030203F2030203A207A3B0A0A2020766172207A32203D207A202F20';
wwv_flow_imp.g_varchar2_table(7464) := '322C0A2020202020206E203D2031322C0A2020202020205476616C756573203D205B202D2E313235322C2E313235322C2D2E333637382C2E333637382C2D2E353837332C2E353837332C2D2E373639392C2E373639392C2D2E393034312C2E393034312C';
wwv_flow_imp.g_varchar2_table(7465) := '2D2E393831362C2E39383136205D2C0A2020202020204376616C756573203D205B20302E323439312C302E323439312C302E323333352C302E323333352C302E323033322C302E323033322C302E313630312C302E313630312C302E313036392C302E31';
wwv_flow_imp.g_varchar2_table(7466) := '3036392C302E303437322C302E30343732205D2C0A20202020202073756D203D20303B0A0A2020666F7220287661722069203D20303B2069203C206E3B20692B2B29207B0A20202020766172206374203D207A32202A205476616C7565735B695D202B20';
wwv_flow_imp.g_varchar2_table(7467) := '7A322C0A20202020202020207862617365203D2062617365332863742C2078312C2078322C2078332C207834292C0A20202020202020207962617365203D2062617365332863742C2079312C2079322C2079332C207934292C0A2020202020202020636F';
wwv_flow_imp.g_varchar2_table(7468) := '6D62203D207862617365202A207862617365202B207962617365202A2079626173653B0A0A2020202073756D202B3D204376616C7565735B695D202A206D6174682E7371727428636F6D62293B0A20207D0A0A202072657475726E207A32202A2073756D';
wwv_flow_imp.g_varchar2_table(7469) := '3B0A7D0A0A0A66756E6374696F6E20696E746572736563744C696E65732878312C2079312C2078322C2079322C2078332C2079332C2078342C20793429207B0A0A2020696620280A202020206D6D61782878312C20783229203C206D6D696E2878332C20';
wwv_flow_imp.g_varchar2_table(7470) := '783429207C7C0A2020202020206D6D696E2878312C20783229203E206D6D61782878332C20783429207C7C0A2020202020206D6D61782879312C20793229203C206D6D696E2879332C20793429207C7C0A2020202020206D6D696E2879312C2079322920';
wwv_flow_imp.g_varchar2_table(7471) := '3E206D6D61782879332C207934290A202029207B0A2020202072657475726E3B0A20207D0A0A2020766172206E78203D20287831202A207932202D207931202A20783229202A20287833202D20783429202D20287831202D20783229202A20287833202A';
wwv_flow_imp.g_varchar2_table(7472) := '207934202D207933202A207834292C0A2020202020206E79203D20287831202A207932202D207931202A20783229202A20287933202D20793429202D20287931202D20793229202A20287833202A207934202D207933202A207834292C0A202020202020';
wwv_flow_imp.g_varchar2_table(7473) := '64656E6F6D696E61746F72203D20287831202D20783229202A20287933202D20793429202D20287931202D20793229202A20287833202D207834293B0A0A2020696620282164656E6F6D696E61746F7229207B0A2020202072657475726E3B0A20207D0A';
wwv_flow_imp.g_varchar2_table(7474) := '0A2020766172207078203D206669784572726F72286E78202F2064656E6F6D696E61746F72292C0A2020202020207079203D206669784572726F72286E79202F2064656E6F6D696E61746F72292C0A202020202020707832203D202B70782E746F466978';
wwv_flow_imp.g_varchar2_table(7475) := '65642832292C0A202020202020707932203D202B70792E746F46697865642832293B0A0A2020696620280A20202020707832203C202B6D6D696E2878312C207832292E746F4669786564283229207C7C0A202020202020707832203E202B6D6D61782878';
wwv_flow_imp.g_varchar2_table(7476) := '312C207832292E746F4669786564283229207C7C0A202020202020707832203C202B6D6D696E2878332C207834292E746F4669786564283229207C7C0A202020202020707832203E202B6D6D61782878332C207834292E746F4669786564283229207C7C';
wwv_flow_imp.g_varchar2_table(7477) := '0A202020202020707932203C202B6D6D696E2879312C207932292E746F4669786564283229207C7C0A202020202020707932203E202B6D6D61782879312C207932292E746F4669786564283229207C7C0A202020202020707932203C202B6D6D696E2879';
wwv_flow_imp.g_varchar2_table(7478) := '332C207934292E746F4669786564283229207C7C0A202020202020707932203E202B6D6D61782879332C207934292E746F46697865642832290A202029207B0A2020202072657475726E3B0A20207D0A0A202072657475726E207B20783A2070782C2079';
wwv_flow_imp.g_varchar2_table(7479) := '3A207079207D3B0A7D0A0A66756E6374696F6E206669784572726F72286E756D62657229207B0A202072657475726E204D6174682E726F756E64286E756D626572202A2031303030303030303030303029202F203130303030303030303030303B0A7D0A';
wwv_flow_imp.g_varchar2_table(7480) := '0A66756E6374696F6E2066696E6442657A696572496E74657273656374696F6E732862657A312C2062657A322C206A757374436F756E7429207B0A20207661722062626F7831203D2062657A69657242426F782862657A31292C0A20202020202062626F';
wwv_flow_imp.g_varchar2_table(7481) := '7832203D2062657A69657242426F782862657A32293B0A0A20206966202821697342426F78496E746572736563742862626F78312C2062626F78322929207B0A2020202072657475726E206A757374436F756E74203F2030203A205B5D3B0A20207D0A0A';
wwv_flow_imp.g_varchar2_table(7482) := '20202F2F20417320616E206F7074696D697A6174696F6E2C206C696E65732077696C6C2068617665206F6E6C792031207365676D656E740A0A2020766172206C31203D2062657A6C656E282E2E2E62657A31292C0A2020202020206C32203D2062657A6C';
wwv_flow_imp.g_varchar2_table(7483) := '656E282E2E2E62657A32292C0A2020202020206E31203D2069734C696E652862657A3129203F2031203A207E7E286C31202F203529207C7C20312C0A2020202020206E32203D2069734C696E652862657A3229203F2031203A207E7E286C32202F203529';
wwv_flow_imp.g_varchar2_table(7484) := '207C7C20312C0A202020202020646F747331203D205B5D2C0A202020202020646F747332203D205B5D2C0A2020202020207879203D207B7D2C0A202020202020726573203D206A757374436F756E74203F2030203A205B5D3B0A0A2020666F7220287661';
wwv_flow_imp.g_varchar2_table(7485) := '722069203D20303B2069203C206E31202B20313B20692B2B29207B0A202020207661722070203D2066696E64446F747341745365676D656E74282E2E2E62657A312C2069202F206E31293B0A20202020646F7473312E70757368287B20783A20702E782C';
wwv_flow_imp.g_varchar2_table(7486) := '20793A20702E792C20743A2069202F206E31207D293B0A20207D0A0A2020666F72202869203D20303B2069203C206E32202B20313B20692B2B29207B0A2020202070203D2066696E64446F747341745365676D656E74282E2E2E62657A322C2069202F20';
wwv_flow_imp.g_varchar2_table(7487) := '6E32293B0A20202020646F7473322E70757368287B20783A20702E782C20793A20702E792C20743A2069202F206E32207D293B0A20207D0A0A2020666F72202869203D20303B2069203C206E313B20692B2B29207B0A0A20202020666F72202876617220';
wwv_flow_imp.g_varchar2_table(7488) := '6A203D20303B206A203C206E323B206A2B2B29207B0A202020202020766172206469203D20646F7473315B695D2C0A20202020202020202020646931203D20646F7473315B69202B20315D2C0A20202020202020202020646A203D20646F7473325B6A5D';
wwv_flow_imp.g_varchar2_table(7489) := '2C0A20202020202020202020646A31203D20646F7473325B6A202B20315D2C0A202020202020202020206369203D20616273286469312E78202D2064692E7829203C202E3031203F20277927203A202778272C0A20202020202020202020636A203D2061';
wwv_flow_imp.g_varchar2_table(7490) := '627328646A312E78202D20646A2E7829203C202E3031203F20277927203A202778272C0A202020202020202020206973203D20696E746572736563744C696E65732864692E782C2064692E792C206469312E782C206469312E792C20646A2E782C20646A';
wwv_flow_imp.g_varchar2_table(7491) := '2E792C20646A312E782C20646A312E79292C0A202020202020202020206B65793B0A0A20202020202069662028697329207B0A20202020202020206B6579203D2069732E782E746F4669786564283929202B20272327202B2069732E792E746F46697865';
wwv_flow_imp.g_varchar2_table(7492) := '642839293B0A0A20202020202020206966202878795B6B65795D29207B0A20202020202020202020636F6E74696E75653B0A20202020202020207D0A0A202020202020202078795B6B65795D203D20747275653B0A0A2020202020202020766172207431';
wwv_flow_imp.g_varchar2_table(7493) := '203D2064692E74202B20616273282869735B63695D202D2064695B63695D29202F20286469315B63695D202D2064695B63695D2929202A20286469312E74202D2064692E74292C0A2020202020202020202020207432203D20646A2E74202B2061627328';
wwv_flow_imp.g_varchar2_table(7494) := '2869735B636A5D202D20646A5B636A5D29202F2028646A315B636A5D202D20646A5B636A5D2929202A2028646A312E74202D20646A2E74293B0A0A2020202020202020696620287431203E3D2030202626207431203C3D2031202626207432203E3D2030';
wwv_flow_imp.g_varchar2_table(7495) := '202626207432203C3D203129207B0A0A20202020202020202020696620286A757374436F756E7429207B0A2020202020202020202020207265732B2B3B0A202020202020202020207D20656C7365207B0A2020202020202020202020207265732E707573';
wwv_flow_imp.g_varchar2_table(7496) := '68287B0A2020202020202020202020202020783A2069732E782C0A2020202020202020202020202020793A2069732E792C0A202020202020202020202020202074313A2074312C0A202020202020202020202020202074323A2074320A20202020202020';
wwv_flow_imp.g_varchar2_table(7497) := '20202020207D293B0A202020202020202020207D0A20202020202020207D0A2020202020207D0A202020207D0A20207D0A0A202072657475726E207265733B0A7D0A0A0A2F2A2A0A202A2046696E64206F7220636F756E74732074686520696E74657273';
wwv_flow_imp.g_varchar2_table(7498) := '656374696F6E73206265747765656E2074776F205356472070617468732E0A202A0A202A2052657475726E732061206E756D62657220696E20636F756E74696E67206D6F646520616E642061206C697374206F6620696E74657273656374696F6E73206F';
wwv_flow_imp.g_varchar2_table(7499) := '74686572776973652E0A202A0A202A20412073696E676C6520696E74657273656374696F6E20656E74727920636F6E7461696E732074686520696E74657273656374696F6E20636F6F7264696E617465732028782C2079290A202A2061732077656C6C20';
wwv_flow_imp.g_varchar2_table(7500) := '6173206164646974696F6E616C20696E666F726D6174696F6E20726567617264696E672074686520696E74657273656374696E67207365676D656E74730A202A206F6E2065616368207061746820287365676D656E74312C207365676D656E7432292061';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(7501) := '6E64207468652072656C6174697665206C6F636174696F6E206F66207468650A202A20696E74657273656374696F6E206F6E207468657365207365676D656E7473202874312C207432292E0A202A0A202A205468652070617468206D617920626520616E';
wwv_flow_imp.g_varchar2_table(7502) := '20535647207061746820737472696E67206F722061206C697374206F66207061746820636F6D706F6E656E74730A202A207375636820617320605B205B20274D272C20302C203130205D2C205B20274C272C2032302C2030205D205D602E0A202A0A202A';
wwv_flow_imp.g_varchar2_table(7503) := '20406578616D706C650A202A0A202A2076617220696E74657273656374696F6E73203D2066696E6450617468496E74657273656374696F6E73280A202A202020274D302C304C3130302C313030272C0A202A2020205B205B20274D272C20302C20313030';
wwv_flow_imp.g_varchar2_table(7504) := '205D2C205B20274C272C203130302C2030205D205D0A202A20293B0A202A0A202A202F2F20696E74657273656374696F6E73203D205B0A202A202F2F2020207B20783A2035302C20793A2035302C207365676D656E74313A20312C207365676D656E7432';
wwv_flow_imp.g_varchar2_table(7505) := '3A20312C2074313A20302E352C2074323A20302E35207D0A202A202F2F205D0A202A0A202A2040706172616D207B537472696E677C41727261793C506174684465663E7D2070617468310A202A2040706172616D207B537472696E677C41727261793C50';
wwv_flow_imp.g_varchar2_table(7506) := '6174684465663E7D2070617468320A202A2040706172616D207B426F6F6C65616E7D205B6A757374436F756E743D66616C73655D0A202A0A202A204072657475726E207B41727261793C496E74657273656374696F6E3E7C4E756D6265727D0A202A2F0A';
wwv_flow_imp.g_varchar2_table(7507) := '66756E6374696F6E2066696E6450617468496E74657273656374696F6E732870617468312C2070617468322C206A757374436F756E7429207B0A20207061746831203D2070617468546F4375727665287061746831293B0A20207061746832203D207061';
wwv_flow_imp.g_varchar2_table(7508) := '7468546F4375727665287061746832293B0A0A20207661722078312C2079312C2078322C2079322C2078316D2C2079316D2C2078326D2C2079326D2C2062657A312C2062657A322C0A202020202020726573203D206A757374436F756E74203F2030203A';
wwv_flow_imp.g_varchar2_table(7509) := '205B5D3B0A0A2020666F7220287661722069203D20302C206969203D2070617468312E6C656E6774683B2069203C2069693B20692B2B29207B0A20202020766172207069203D2070617468315B695D3B0A0A202020206966202870695B305D203D3D2027';
wwv_flow_imp.g_varchar2_table(7510) := '4D2729207B0A2020202020207831203D2078316D203D2070695B315D3B0A2020202020207931203D2079316D203D2070695B325D3B0A202020207D20656C7365207B0A0A2020202020206966202870695B305D203D3D2027432729207B0A202020202020';
wwv_flow_imp.g_varchar2_table(7511) := '202062657A31203D205B2078312C2079312C202E2E2E70692E736C696365283129205D3B0A20202020202020207831203D2062657A315B365D3B0A20202020202020207931203D2062657A315B375D3B0A2020202020207D20656C7365207B0A20202020';
wwv_flow_imp.g_varchar2_table(7512) := '2020202062657A31203D205B2078312C2079312C2078312C2079312C2078316D2C2079316D2C2078316D2C2079316D205D3B0A20202020202020207831203D2078316D3B0A20202020202020207931203D2079316D3B0A2020202020207D0A0A20202020';
wwv_flow_imp.g_varchar2_table(7513) := '2020666F722028766172206A203D20302C206A6A203D2070617468322E6C656E6774683B206A203C206A6A3B206A2B2B29207B0A202020202020202076617220706A203D2070617468325B6A5D3B0A0A202020202020202069662028706A5B305D203D3D';
wwv_flow_imp.g_varchar2_table(7514) := '20274D2729207B0A202020202020202020207832203D2078326D203D20706A5B315D3B0A202020202020202020207932203D2079326D203D20706A5B325D3B0A20202020202020207D20656C7365207B0A0A2020202020202020202069662028706A5B30';
wwv_flow_imp.g_varchar2_table(7515) := '5D203D3D2027432729207B0A20202020202020202020202062657A32203D205B2078322C2079322C202E2E2E706A2E736C696365283129205D3B0A2020202020202020202020207832203D2062657A325B365D3B0A202020202020202020202020793220';
wwv_flow_imp.g_varchar2_table(7516) := '3D2062657A325B375D3B0A202020202020202020207D20656C7365207B0A20202020202020202020202062657A32203D205B2078322C2079322C2078322C2079322C2078326D2C2079326D2C2078326D2C2079326D205D3B0A2020202020202020202020';
wwv_flow_imp.g_varchar2_table(7517) := '207832203D2078326D3B0A2020202020202020202020207932203D2079326D3B0A202020202020202020207D0A0A2020202020202020202076617220696E7472203D2066696E6442657A696572496E74657273656374696F6E732862657A312C2062657A';
wwv_flow_imp.g_varchar2_table(7518) := '322C206A757374436F756E74293B0A0A20202020202020202020696620286A757374436F756E7429207B0A202020202020202020202020726573202B3D20696E74723B0A202020202020202020207D20656C7365207B0A0A202020202020202020202020';
wwv_flow_imp.g_varchar2_table(7519) := '666F722028766172206B203D20302C206B6B203D20696E74722E6C656E6774683B206B203C206B6B3B206B2B2B29207B0A2020202020202020202020202020696E74725B6B5D2E7365676D656E7431203D20693B0A202020202020202020202020202069';
wwv_flow_imp.g_varchar2_table(7520) := '6E74725B6B5D2E7365676D656E7432203D206A3B0A2020202020202020202020202020696E74725B6B5D2E62657A31203D2062657A313B0A2020202020202020202020202020696E74725B6B5D2E62657A32203D2062657A323B0A202020202020202020';
wwv_flow_imp.g_varchar2_table(7521) := '2020207D0A0A202020202020202020202020726573203D207265732E636F6E63617428696E7472293B0A202020202020202020207D0A20202020202020207D0A2020202020207D0A202020207D0A20207D0A0A202072657475726E207265733B0A7D0A0A';
wwv_flow_imp.g_varchar2_table(7522) := '0A66756E6374696F6E2070617468546F4162736F6C7574652870617468417272617929207B0A202076617220707468203D20706174687328706174684172726179293B0A0A2020696620287074682E61627329207B0A2020202072657475726E20706174';
wwv_flow_imp.g_varchar2_table(7523) := '68436C6F6E65287074682E616273293B0A20207D0A0A20206966202821697341727261792870617468417272617929207C7C20216973417272617928706174684172726179202626207061746841727261795B305D2929207B202F2F20726F7567682061';
wwv_flow_imp.g_varchar2_table(7524) := '7373756D7074696F6E0A20202020706174684172726179203D20706172736550617468537472696E6728706174684172726179293B0A20207D0A0A20206966202821706174684172726179207C7C20217061746841727261792E6C656E67746829207B0A';
wwv_flow_imp.g_varchar2_table(7525) := '2020202072657475726E205B205B20274D272C20302C2030205D205D3B0A20207D0A0A202076617220726573203D205B5D2C0A20202020202078203D20302C0A20202020202079203D20302C0A2020202020206D78203D20302C0A2020202020206D7920';
wwv_flow_imp.g_varchar2_table(7526) := '3D20302C0A2020202020207374617274203D20302C0A2020202020207061303B0A0A2020696620287061746841727261795B305D5B305D203D3D20274D2729207B0A2020202078203D202B7061746841727261795B305D5B315D3B0A2020202079203D20';
wwv_flow_imp.g_varchar2_table(7527) := '2B7061746841727261795B305D5B325D3B0A202020206D78203D20783B0A202020206D79203D20793B0A2020202073746172742B2B3B0A202020207265735B305D203D205B20274D272C20782C2079205D3B0A20207D0A0A2020666F7220287661722072';
wwv_flow_imp.g_varchar2_table(7528) := '2C2070612C2069203D2073746172742C206969203D207061746841727261792E6C656E6774683B2069203C2069693B20692B2B29207B0A202020207265732E707573682872203D205B5D293B0A202020207061203D207061746841727261795B695D3B0A';
wwv_flow_imp.g_varchar2_table(7529) := '20202020706130203D2070615B305D3B0A0A202020206966202870613020213D207061302E746F557070657243617365282929207B0A202020202020725B305D203D207061302E746F55707065724361736528293B0A0A20202020202073776974636820';
wwv_flow_imp.g_varchar2_table(7530) := '28725B305D29207B0A20202020202063617365202741273A0A2020202020202020725B315D203D2070615B315D3B0A2020202020202020725B325D203D2070615B325D3B0A2020202020202020725B335D203D2070615B335D3B0A202020202020202072';
wwv_flow_imp.g_varchar2_table(7531) := '5B345D203D2070615B345D3B0A2020202020202020725B355D203D2070615B355D3B0A2020202020202020725B365D203D202B70615B365D202B20783B0A2020202020202020725B375D203D202B70615B375D202B20793B0A2020202020202020627265';
wwv_flow_imp.g_varchar2_table(7532) := '616B3B0A20202020202063617365202756273A0A2020202020202020725B315D203D202B70615B315D202B20793B0A2020202020202020627265616B3B0A20202020202063617365202748273A0A2020202020202020725B315D203D202B70615B315D20';
wwv_flow_imp.g_varchar2_table(7533) := '2B20783B0A2020202020202020627265616B3B0A2020202020206361736520274D273A0A20202020202020206D78203D202B70615B315D202B20783B0A20202020202020206D79203D202B70615B325D202B20793B0A20202020202064656661756C743A';
wwv_flow_imp.g_varchar2_table(7534) := '0A2020202020202020666F722028766172206A203D20312C206A6A203D2070612E6C656E6774683B206A203C206A6A3B206A2B2B29207B0A20202020202020202020725B6A5D203D202B70615B6A5D202B2028286A2025203229203F2078203A2079293B';
wwv_flow_imp.g_varchar2_table(7535) := '0A20202020202020207D0A2020202020207D0A202020207D20656C7365207B0A202020202020666F722028766172206B203D20302C206B6B203D2070612E6C656E6774683B206B203C206B6B3B206B2B2B29207B0A2020202020202020725B6B5D203D20';
wwv_flow_imp.g_varchar2_table(7536) := '70615B6B5D3B0A2020202020207D0A202020207D0A20202020706130203D207061302E746F55707065724361736528293B0A0A202020207377697463682028725B305D29207B0A202020206361736520275A273A0A20202020202078203D202B6D783B0A';
wwv_flow_imp.g_varchar2_table(7537) := '20202020202079203D202B6D793B0A202020202020627265616B3B0A2020202063617365202748273A0A20202020202078203D20725B315D3B0A202020202020627265616B3B0A2020202063617365202756273A0A20202020202079203D20725B315D3B';
wwv_flow_imp.g_varchar2_table(7538) := '0A202020202020627265616B3B0A202020206361736520274D273A0A2020202020206D78203D20725B722E6C656E677468202D20325D3B0A2020202020206D79203D20725B722E6C656E677468202D20315D3B0A2020202064656661756C743A0A202020';
wwv_flow_imp.g_varchar2_table(7539) := '20202078203D20725B722E6C656E677468202D20325D3B0A20202020202079203D20725B722E6C656E677468202D20315D3B0A202020207D0A20207D0A0A20207265732E746F537472696E67203D2070617468546F537472696E673B0A20207074682E61';
wwv_flow_imp.g_varchar2_table(7540) := '6273203D2070617468436C6F6E6528726573293B0A0A202072657475726E207265733B0A7D0A0A66756E6374696F6E2069734C696E652862657A29207B0A202072657475726E20280A2020202062657A5B305D203D3D3D2062657A5B325D2026260A2020';
wwv_flow_imp.g_varchar2_table(7541) := '202062657A5B315D203D3D3D2062657A5B335D2026260A2020202062657A5B345D203D3D3D2062657A5B365D2026260A2020202062657A5B355D203D3D3D2062657A5B375D0A2020293B0A7D0A0A66756E6374696F6E206C696E65546F43757276652878';
wwv_flow_imp.g_varchar2_table(7542) := '312C2079312C2078322C20793229207B0A202072657475726E205B0A2020202078312C2079312C2078322C0A2020202079322C2078322C2079320A20205D3B0A7D0A0A66756E6374696F6E207175626963546F43757276652878312C2079312C2061782C';
wwv_flow_imp.g_varchar2_table(7543) := '2061792C2078322C20793229207B0A2020766172205F3133203D2031202F20332C0A2020202020205F3233203D2032202F20333B0A0A202072657475726E205B0A202020205F3133202A207831202B205F3233202A2061782C0A202020205F3133202A20';
wwv_flow_imp.g_varchar2_table(7544) := '7931202B205F3233202A2061792C0A202020205F3133202A207832202B205F3233202A2061782C0A202020205F3133202A207932202B205F3233202A2061792C0A2020202078322C0A2020202079320A20205D3B0A7D0A0A66756E6374696F6E20617263';
wwv_flow_imp.g_varchar2_table(7545) := '546F43757276652878312C2079312C2072782C2072792C20616E676C652C206C617267655F6172635F666C61672C2073776565705F666C61672C2078322C2079322C2072656375727369766529207B0A0A20202F2F20666F72206D6F726520696E666F72';
wwv_flow_imp.g_varchar2_table(7546) := '6D6174696F6E206F662077686572652074686973206D6174682063616D652066726F6D2076697369743A0A20202F2F20687474703A2F2F7777772E77332E6F72672F54522F53564731312F696D706C6E6F74652E68746D6C23417263496D706C656D656E';
wwv_flow_imp.g_varchar2_table(7547) := '746174696F6E4E6F7465730A2020766172205F313230203D205049202A20313230202F203138302C0A202020202020726164203D205049202F20313830202A20282B616E676C65207C7C2030292C0A202020202020726573203D205B5D2C0A2020202020';
wwv_flow_imp.g_varchar2_table(7548) := '2078792C0A202020202020726F74617465203D206361636865722866756E6374696F6E28782C20792C2072616429207B0A20202020202020207661722058203D2078202A206D6174682E636F732872616429202D2079202A206D6174682E73696E287261';
wwv_flow_imp.g_varchar2_table(7549) := '64292C0A20202020202020202020202059203D2078202A206D6174682E73696E2872616429202B2079202A206D6174682E636F7328726164293B0A0A202020202020202072657475726E207B20783A20582C20793A2059207D3B0A2020202020207D293B';
wwv_flow_imp.g_varchar2_table(7550) := '0A0A2020696620282172656375727369766529207B0A202020207879203D20726F746174652878312C2079312C202D726164293B0A202020207831203D2078792E783B0A202020207931203D2078792E793B0A202020207879203D20726F746174652878';
wwv_flow_imp.g_varchar2_table(7551) := '322C2079322C202D726164293B0A202020207832203D2078792E783B0A202020207932203D2078792E793B0A0A202020207661722078203D20287831202D20783229202F20322C0A202020202020202079203D20287931202D20793229202F20323B0A0A';
wwv_flow_imp.g_varchar2_table(7552) := '202020207661722068203D202878202A207829202F20287278202A20727829202B202879202A207929202F20287279202A207279293B0A0A202020206966202868203E203129207B0A20202020202068203D206D6174682E737172742868293B0A202020';
wwv_flow_imp.g_varchar2_table(7553) := '2020207278203D2068202A2072783B0A2020202020207279203D2068202A2072793B0A202020207D0A0A2020202076617220727832203D207278202A2072782C0A2020202020202020727932203D207279202A2072792C0A20202020202020206B203D20';
wwv_flow_imp.g_varchar2_table(7554) := '286C617267655F6172635F666C6167203D3D2073776565705F666C6167203F202D31203A203129202A0A2020202020202020202020206D6174682E73717274286162732828727832202A20727932202D20727832202A2079202A2079202D20727932202A';
wwv_flow_imp.g_varchar2_table(7555) := '2078202A207829202F2028727832202A2079202A2079202B20727932202A2078202A20782929292C0A20202020202020206378203D206B202A207278202A2079202F207279202B20287831202B20783229202F20322C0A20202020202020206379203D20';
wwv_flow_imp.g_varchar2_table(7556) := '6B202A202D7279202A2078202F207278202B20287931202B20793229202F20322C0A20202020202020206631203D206D6174682E6173696E2828287931202D20637929202F207279292E746F4669786564283929292C0A20202020202020206632203D20';
wwv_flow_imp.g_varchar2_table(7557) := '6D6174682E6173696E2828287932202D20637929202F207279292E746F4669786564283929293B0A0A202020206631203D207831203C206378203F205049202D206631203A2066313B0A202020206632203D207832203C206378203F205049202D206632';
wwv_flow_imp.g_varchar2_table(7558) := '203A2066323B0A202020206631203C203020262620286631203D205049202A2032202B206631293B0A202020206632203C203020262620286632203D205049202A2032202B206632293B0A0A202020206966202873776565705F666C6167202626206631';
wwv_flow_imp.g_varchar2_table(7559) := '203E20663229207B0A2020202020206631203D206631202D205049202A20323B0A202020207D0A20202020696620282173776565705F666C6167202626206632203E20663129207B0A2020202020206632203D206632202D205049202A20323B0A202020';
wwv_flow_imp.g_varchar2_table(7560) := '207D0A20207D20656C7365207B0A202020206631203D207265637572736976655B305D3B0A202020206632203D207265637572736976655B315D3B0A202020206378203D207265637572736976655B325D3B0A202020206379203D207265637572736976';
wwv_flow_imp.g_varchar2_table(7561) := '655B335D3B0A20207D0A0A2020766172206466203D206632202D2066313B0A0A20206966202861627328646629203E205F31323029207B0A202020207661722066326F6C64203D2066322C0A202020202020202078326F6C64203D2078322C0A20202020';
wwv_flow_imp.g_varchar2_table(7562) := '2020202079326F6C64203D2079323B0A0A202020206632203D206631202B205F313230202A202873776565705F666C6167202626206632203E206631203F2031203A202D31293B0A202020207832203D206378202B207278202A206D6174682E636F7328';
wwv_flow_imp.g_varchar2_table(7563) := '6632293B0A202020207932203D206379202B207279202A206D6174682E73696E286632293B0A20202020726573203D20617263546F43757276652878322C2079322C2072782C2072792C20616E676C652C20302C2073776565705F666C61672C2078326F';
wwv_flow_imp.g_varchar2_table(7564) := '6C642C2079326F6C642C205B2066322C2066326F6C642C2063782C206379205D293B0A20207D0A0A20206466203D206632202D2066313B0A0A2020766172206331203D206D6174682E636F73286631292C0A2020202020207331203D206D6174682E7369';
wwv_flow_imp.g_varchar2_table(7565) := '6E286631292C0A2020202020206332203D206D6174682E636F73286632292C0A2020202020207332203D206D6174682E73696E286632292C0A20202020202074203D206D6174682E74616E286466202F2034292C0A2020202020206878203D2034202F20';
wwv_flow_imp.g_varchar2_table(7566) := '33202A207278202A20742C0A2020202020206879203D2034202F2033202A207279202A20742C0A2020202020206D31203D205B2078312C207931205D2C0A2020202020206D32203D205B207831202B206878202A2073312C207931202D206879202A2063';
wwv_flow_imp.g_varchar2_table(7567) := '31205D2C0A2020202020206D33203D205B207832202B206878202A2073322C207932202D206879202A206332205D2C0A2020202020206D34203D205B2078322C207932205D3B0A0A20206D325B305D203D2032202A206D315B305D202D206D325B305D3B';
wwv_flow_imp.g_varchar2_table(7568) := '0A20206D325B315D203D2032202A206D315B315D202D206D325B315D3B0A0A20206966202872656375727369766529207B0A2020202072657475726E205B206D322C206D332C206D34205D2E636F6E63617428726573293B0A20207D20656C7365207B0A';
wwv_flow_imp.g_varchar2_table(7569) := '20202020726573203D205B206D322C206D332C206D34205D2E636F6E63617428726573292E6A6F696E28292E73706C697428272C27293B0A20202020766172206E6577726573203D205B5D3B0A0A20202020666F7220287661722069203D20302C206969';
wwv_flow_imp.g_varchar2_table(7570) := '203D207265732E6C656E6774683B2069203C2069693B20692B2B29207B0A2020202020206E65777265735B695D203D206920252032203F20726F74617465287265735B69202D20315D2C207265735B695D2C20726164292E79203A20726F746174652872';
wwv_flow_imp.g_varchar2_table(7571) := '65735B695D2C207265735B69202B20315D2C20726164292E783B0A202020207D0A0A2020202072657475726E206E65777265733B0A20207D0A7D0A0A2F2F2052657475726E7320626F756E64696E6720626F78206F662063756269632062657A69657220';
wwv_flow_imp.g_varchar2_table(7572) := '63757276652E0A2F2F20536F757263653A20687474703A2F2F626C6F672E6861636B6572732D636166652E6E65742F323030392F30362F686F772D746F2D63616C63756C6174652D62657A6965722D6375727665732D626F756E64696E672E68746D6C0A';
wwv_flow_imp.g_varchar2_table(7573) := '2F2F204F726967696E616C2076657273696F6E3A204E495348494F204869726F6B617A750A2F2F204D6F64696669636174696F6E733A2068747470733A2F2F6769746875622E636F6D2F74696D6F32323334350A66756E6374696F6E2063757276654242';
wwv_flow_imp.g_varchar2_table(7574) := '6F782878302C2079302C2078312C2079312C2078322C2079322C2078332C20793329207B0A2020766172207476616C756573203D205B5D2C0A202020202020626F756E6473203D205B205B5D2C205B5D205D2C0A202020202020612C20622C20632C2074';
wwv_flow_imp.g_varchar2_table(7575) := '2C2074312C2074322C20623261632C2073717274623261633B0A0A2020666F7220287661722069203D20303B2069203C20323B202B2B6929207B0A0A202020206966202869203D3D203029207B0A20202020202062203D2036202A207830202D20313220';
wwv_flow_imp.g_varchar2_table(7576) := '2A207831202B2036202A2078323B0A20202020202061203D202D33202A207830202B2039202A207831202D2039202A207832202B2033202A2078333B0A20202020202063203D2033202A207831202D2033202A2078303B0A202020207D20656C7365207B';
wwv_flow_imp.g_varchar2_table(7577) := '0A20202020202062203D2036202A207930202D203132202A207931202B2036202A2079323B0A20202020202061203D202D33202A207930202B2039202A207931202D2039202A207932202B2033202A2079333B0A20202020202063203D2033202A207931';
wwv_flow_imp.g_varchar2_table(7578) := '202D2033202A2079303B0A202020207D0A0A2020202069662028616273286129203C2031652D313229207B0A0A20202020202069662028616273286229203C2031652D313229207B0A2020202020202020636F6E74696E75653B0A2020202020207D0A0A';
wwv_flow_imp.g_varchar2_table(7579) := '20202020202074203D202D63202F20623B0A0A2020202020206966202830203C20742026262074203C203129207B0A20202020202020207476616C7565732E707573682874293B0A2020202020207D0A0A202020202020636F6E74696E75653B0A202020';
wwv_flow_imp.g_varchar2_table(7580) := '207D0A0A2020202062326163203D2062202A2062202D2034202A2063202A20613B0A202020207371727462326163203D206D6174682E737172742862326163293B0A0A202020206966202862326163203C203029207B0A202020202020636F6E74696E75';
wwv_flow_imp.g_varchar2_table(7581) := '653B0A202020207D0A0A202020207431203D20282D62202B20737172746232616329202F202832202A2061293B0A0A202020206966202830203C207431202626207431203C203129207B0A2020202020207476616C7565732E70757368287431293B0A20';
wwv_flow_imp.g_varchar2_table(7582) := '2020207D0A0A202020207432203D20282D62202D20737172746232616329202F202832202A2061293B0A0A202020206966202830203C207432202626207432203C203129207B0A2020202020207476616C7565732E70757368287432293B0A202020207D';
wwv_flow_imp.g_varchar2_table(7583) := '0A20207D0A0A2020766172206A203D207476616C7565732E6C656E6774682C0A2020202020206A6C656E203D206A2C0A2020202020206D743B0A0A20207768696C6520286A2D2D29207B0A2020202074203D207476616C7565735B6A5D3B0A202020206D';
wwv_flow_imp.g_varchar2_table(7584) := '74203D2031202D20743B0A20202020626F756E64735B305D5B6A5D203D20286D74202A206D74202A206D74202A20783029202B202833202A206D74202A206D74202A2074202A20783129202B202833202A206D74202A2074202A2074202A20783229202B';
wwv_flow_imp.g_varchar2_table(7585) := '202874202A2074202A2074202A207833293B0A20202020626F756E64735B315D5B6A5D203D20286D74202A206D74202A206D74202A20793029202B202833202A206D74202A206D74202A2074202A20793129202B202833202A206D74202A2074202A2074';
wwv_flow_imp.g_varchar2_table(7586) := '202A20793229202B202874202A2074202A2074202A207933293B0A20207D0A0A2020626F756E64735B305D5B6A6C656E5D203D2078303B0A2020626F756E64735B315D5B6A6C656E5D203D2079303B0A2020626F756E64735B305D5B6A6C656E202B2031';
wwv_flow_imp.g_varchar2_table(7587) := '5D203D2078333B0A2020626F756E64735B315D5B6A6C656E202B20315D203D2079333B0A2020626F756E64735B305D2E6C656E677468203D20626F756E64735B315D2E6C656E677468203D206A6C656E202B20323B0A0A202072657475726E207B0A2020';
wwv_flow_imp.g_varchar2_table(7588) := '202078303A206D6D696E282E2E2E626F756E64735B305D292C0A2020202079303A206D6D696E282E2E2E626F756E64735B315D292C0A2020202078313A206D6D6178282E2E2E626F756E64735B305D292C0A2020202079313A206D6D6178282E2E2E626F';
wwv_flow_imp.g_varchar2_table(7589) := '756E64735B315D290A20207D3B0A7D0A0A66756E6374696F6E2070617468546F4375727665287061746829207B0A0A202076617220707468203D2070617468732870617468293B0A0A20202F2F2072657475726E206361636865642063757276652C2069';
wwv_flow_imp.g_varchar2_table(7590) := '66206578697374696E670A2020696620287074682E637572766529207B0A2020202072657475726E2070617468436C6F6E65287074682E6375727665293B0A20207D0A0A20207661722063757276656450617468203D2070617468546F4162736F6C7574';
wwv_flow_imp.g_varchar2_table(7591) := '652870617468292C0A2020202020206174747273203D207B20783A20302C20793A20302C2062783A20302C2062793A20302C20583A20302C20593A20302C2071783A206E756C6C2C2071793A206E756C6C207D2C0A20202020202070726F636573735061';
wwv_flow_imp.g_varchar2_table(7592) := '7468203D2066756E6374696F6E28706174682C20642C2070617468436F6D6D616E6429207B0A2020202020202020766172206E782C206E793B0A0A202020202020202069662028217061746829207B0A2020202020202020202072657475726E205B2027';
wwv_flow_imp.g_varchar2_table(7593) := '43272C20642E782C20642E792C20642E782C20642E792C20642E782C20642E79205D3B0A20202020202020207D0A0A20202020202020202128706174685B305D20696E207B20543A20312C20513A2031207D292026262028642E7178203D20642E717920';
wwv_flow_imp.g_varchar2_table(7594) := '3D206E756C6C293B0A0A20202020202020207377697463682028706174685B305D29207B0A20202020202020206361736520274D273A0A20202020202020202020642E58203D20706174685B315D3B0A20202020202020202020642E59203D2070617468';
wwv_flow_imp.g_varchar2_table(7595) := '5B325D3B0A20202020202020202020627265616B3B0A202020202020202063617365202741273A0A2020202020202020202070617468203D205B202743272C202E2E2E617263546F437572766528642E782C20642E792C202E2E2E706174682E736C6963';
wwv_flow_imp.g_varchar2_table(7596) := '6528312929205D3B0A20202020202020202020627265616B3B0A202020202020202063617365202753273A0A202020202020202020206966202870617468436F6D6D616E64203D3D20274327207C7C2070617468436F6D6D616E64203D3D202753272920';
wwv_flow_imp.g_varchar2_table(7597) := '7B0A0A2020202020202020202020202F2F20496E202753272063617365207765206861766520746F2074616B6520696E746F206163636F756E742C206966207468652070726576696F757320636F6D6D616E6420697320432F532E0A2020202020202020';
wwv_flow_imp.g_varchar2_table(7598) := '202020206E78203D20642E78202A2032202D20642E62783B0A0A2020202020202020202020202F2F20416E64207265666C656374207468652070726576696F75730A2020202020202020202020206E79203D20642E79202A2032202D20642E62793B0A0A';
wwv_flow_imp.g_varchar2_table(7599) := '2020202020202020202020202F2F20636F6D6D616E64277320636F6E74726F6C20706F696E742072656C617469766520746F207468652063757272656E7420706F696E742E0A202020202020202020207D0A20202020202020202020656C7365207B0A0A';
wwv_flow_imp.g_varchar2_table(7600) := '2020202020202020202020202F2F206F7220736F6D6520656C7365206F72206E6F7468696E670A2020202020202020202020206E78203D20642E783B0A2020202020202020202020206E79203D20642E793B0A202020202020202020207D0A2020202020';
wwv_flow_imp.g_varchar2_table(7601) := '202020202070617468203D205B202743272C206E782C206E792C202E2E2E706174682E736C696365283129205D3B0A20202020202020202020627265616B3B0A202020202020202063617365202754273A0A202020202020202020206966202870617468';
wwv_flow_imp.g_varchar2_table(7602) := '436F6D6D616E64203D3D20275127207C7C2070617468436F6D6D616E64203D3D2027542729207B0A0A2020202020202020202020202F2F20496E202754272063617365207765206861766520746F2074616B6520696E746F206163636F756E742C206966';
wwv_flow_imp.g_varchar2_table(7603) := '207468652070726576696F757320636F6D6D616E6420697320512F542E0A202020202020202020202020642E7178203D20642E78202A2032202D20642E71783B0A0A2020202020202020202020202F2F20416E64206D616B652061207265666C65637469';
wwv_flow_imp.g_varchar2_table(7604) := '6F6E2073696D696C61720A202020202020202020202020642E7179203D20642E79202A2032202D20642E71793B0A0A2020202020202020202020202F2F20746F2063617365202753272E0A202020202020202020207D0A20202020202020202020656C73';
wwv_flow_imp.g_varchar2_table(7605) := '65207B0A0A2020202020202020202020202F2F206F7220736F6D657468696E6720656C7365206F72206E6F7468696E670A202020202020202020202020642E7178203D20642E783B0A202020202020202020202020642E7179203D20642E793B0A202020';
wwv_flow_imp.g_varchar2_table(7606) := '202020202020207D0A2020202020202020202070617468203D205B202743272C202E2E2E7175626963546F437572766528642E782C20642E792C20642E71782C20642E71792C20706174685B315D2C20706174685B325D29205D3B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(7607) := '2020627265616B3B0A202020202020202063617365202751273A0A20202020202020202020642E7178203D20706174685B315D3B0A20202020202020202020642E7179203D20706174685B325D3B0A2020202020202020202070617468203D205B202743';
wwv_flow_imp.g_varchar2_table(7608) := '272C202E2E2E7175626963546F437572766528642E782C20642E792C20706174685B315D2C20706174685B325D2C20706174685B335D2C20706174685B345D29205D3B0A20202020202020202020627265616B3B0A20202020202020206361736520274C';
wwv_flow_imp.g_varchar2_table(7609) := '273A0A2020202020202020202070617468203D205B202743272C202E2E2E6C696E65546F437572766528642E782C20642E792C20706174685B315D2C20706174685B325D29205D3B0A20202020202020202020627265616B3B0A20202020202020206361';
wwv_flow_imp.g_varchar2_table(7610) := '7365202748273A0A2020202020202020202070617468203D205B202743272C202E2E2E6C696E65546F437572766528642E782C20642E792C20706174685B315D2C20642E7929205D3B0A20202020202020202020627265616B3B0A202020202020202063';
wwv_flow_imp.g_varchar2_table(7611) := '617365202756273A0A2020202020202020202070617468203D205B202743272C202E2E2E6C696E65546F437572766528642E782C20642E792C20642E782C20706174685B315D29205D3B0A20202020202020202020627265616B3B0A2020202020202020';
wwv_flow_imp.g_varchar2_table(7612) := '6361736520275A273A0A2020202020202020202070617468203D205B202743272C202E2E2E6C696E65546F437572766528642E782C20642E792C20642E582C20642E5929205D3B0A20202020202020202020627265616B3B0A20202020202020207D0A0A';
wwv_flow_imp.g_varchar2_table(7613) := '202020202020202072657475726E20706174683B0A2020202020207D2C0A0A202020202020666978417263203D2066756E6374696F6E2870702C206929207B0A0A20202020202020206966202870705B695D2E6C656E677468203E203729207B0A202020';
wwv_flow_imp.g_varchar2_table(7614) := '2020202020202070705B695D2E736869667428293B0A20202020202020202020766172207069203D2070705B695D3B0A0A202020202020202020207768696C65202870692E6C656E67746829207B0A20202020202020202020202070617468436F6D6D61';
wwv_flow_imp.g_varchar2_table(7615) := '6E64735B695D203D202741273B202F2F2069662063726561746564206D756C7469706C6520433A732C207468656972206F726967696E616C207365672069732073617665640A20202020202020202020202070702E73706C69636528692B2B2C20302C20';
wwv_flow_imp.g_varchar2_table(7616) := '5B202743272C202E2E2E70692E73706C69636528302C203629205D293B0A202020202020202020207D0A0A2020202020202020202070702E73706C69636528692C2031293B0A202020202020202020206969203D20637572766564506174682E6C656E67';
wwv_flow_imp.g_varchar2_table(7617) := '74683B0A20202020202020207D0A2020202020207D2C0A0A20202020202070617468436F6D6D616E6473203D205B5D2C202F2F207061746820636F6D6D616E6473206F66206F726967696E616C207061746820700A202020202020706669727374203D20';
wwv_flow_imp.g_varchar2_table(7618) := '27272C202F2F2074656D706F7261727920686F6C64657220666F72206F726967696E616C207061746820636F6D6D616E640A20202020202070617468436F6D6D616E64203D2027273B202F2F20686F6C64657220666F722070726576696F757320706174';
wwv_flow_imp.g_varchar2_table(7619) := '6820636F6D6D616E64206F66206F726967696E616C20706174680A0A2020666F7220287661722069203D20302C206969203D20637572766564506174682E6C656E6774683B2069203C2069693B20692B2B29207B0A20202020637572766564506174685B';
wwv_flow_imp.g_varchar2_table(7620) := '695D2026262028706669727374203D20637572766564506174685B695D5B305D293B202F2F20736176652063757272656E74207061746820636F6D6D616E640A0A202020206966202870666972737420213D2027432729202F2F2043206973206E6F7420';
wwv_flow_imp.g_varchar2_table(7621) := '7361766564207965742C2062656361757365206974206D617920626520726573756C74206F6620636F6E76657273696F6E0A202020207B0A20202020202070617468436F6D6D616E64735B695D203D207066697273743B202F2F20536176652063757272';
wwv_flow_imp.g_varchar2_table(7622) := '656E74207061746820636F6D6D616E640A20202020202069202626202870617468436F6D6D616E64203D2070617468436F6D6D616E64735B69202D20315D293B202F2F204765742070726576696F7573207061746820636F6D6D616E642070617468436F';
wwv_flow_imp.g_varchar2_table(7623) := '6D6D616E640A202020207D0A20202020637572766564506174685B695D203D2070726F636573735061746828637572766564506174685B695D2C2061747472732C2070617468436F6D6D616E64293B202F2F2050726576696F7573207061746820636F6D';
wwv_flow_imp.g_varchar2_table(7624) := '6D616E6420697320696E70757474656420746F2070726F63657373506174680A0A202020206966202870617468436F6D6D616E64735B695D20213D2027412720262620706669727374203D3D20274327292070617468436F6D6D616E64735B695D203D20';
wwv_flow_imp.g_varchar2_table(7625) := '2743273B202F2F204120697320746865206F6E6C7920636F6D6D616E640A202020202F2F207768696368206D61792070726F64756365206D756C7469706C6520433A730A202020202F2F20736F207765206861766520746F206D616B6520737572652074';
wwv_flow_imp.g_varchar2_table(7626) := '686174204320697320616C736F204320696E206F726967696E616C20706174680A0A2020202066697841726328637572766564506174682C2069293B202F2F20666978417263206164647320616C736F2074686520726967687420616D6F756E74206F66';
wwv_flow_imp.g_varchar2_table(7627) := '20413A7320746F2070617468436F6D6D616E64730A0A2020202076617220736567203D20637572766564506174685B695D2C0A20202020202020207365676C656E203D207365672E6C656E6774683B0A0A2020202061747472732E78203D207365675B73';
wwv_flow_imp.g_varchar2_table(7628) := '65676C656E202D20325D3B0A2020202061747472732E79203D207365675B7365676C656E202D20315D3B0A2020202061747472732E6278203D20746F466C6F6174287365675B7365676C656E202D20345D29207C7C2061747472732E783B0A2020202061';
wwv_flow_imp.g_varchar2_table(7629) := '747472732E6279203D20746F466C6F6174287365675B7365676C656E202D20335D29207C7C2061747472732E793B0A20207D0A0A20202F2F2063616368652063757276650A20207074682E6375727665203D2070617468436C6F6E652863757276656450';
wwv_flow_imp.g_varchar2_table(7630) := '617468293B0A0A202072657475726E20637572766564506174683B0A7D0A0A2F2A2A2A2F207D290A0A2F2A2A2A2A2A2A2F20097D293B0A2F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(7631) := '2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2A2A2A2F20092F2F20546865206D6F64756C652063616368650A2F2A2A2A2A2A2A2F2009766172205F5F7765627061636B5F6D6F64756C655F63616368655F5F203D';
wwv_flow_imp.g_varchar2_table(7632) := '207B7D3B0A2F2A2A2A2A2A2A2F20090A2F2A2A2A2A2A2A2F20092F2F2054686520726571756972652066756E6374696F6E0A2F2A2A2A2A2A2A2F200966756E6374696F6E205F5F7765627061636B5F726571756972655F5F286D6F64756C65496429207B';
wwv_flow_imp.g_varchar2_table(7633) := '0A2F2A2A2A2A2A2A2F2009092F2F20436865636B206966206D6F64756C6520697320696E2063616368650A2F2A2A2A2A2A2A2F200909766172206361636865644D6F64756C65203D205F5F7765627061636B5F6D6F64756C655F63616368655F5F5B6D6F';
wwv_flow_imp.g_varchar2_table(7634) := '64756C6549645D3B0A2F2A2A2A2A2A2A2F200909696620286361636865644D6F64756C6520213D3D20756E646566696E656429207B0A2F2A2A2A2A2A2A2F2009090972657475726E206361636865644D6F64756C652E6578706F7274733B0A2F2A2A2A2A';
wwv_flow_imp.g_varchar2_table(7635) := '2A2A2F2009097D0A2F2A2A2A2A2A2A2F2009092F2F204372656174652061206E6577206D6F64756C652028616E642070757420697420696E746F20746865206361636865290A2F2A2A2A2A2A2A2F200909766172206D6F64756C65203D205F5F77656270';
wwv_flow_imp.g_varchar2_table(7636) := '61636B5F6D6F64756C655F63616368655F5F5B6D6F64756C6549645D203D207B0A2F2A2A2A2A2A2A2F200909092F2F206E6F206D6F64756C652E6964206E65656465640A2F2A2A2A2A2A2A2F200909092F2F206E6F206D6F64756C652E6C6F6164656420';
wwv_flow_imp.g_varchar2_table(7637) := '6E65656465640A2F2A2A2A2A2A2A2F200909096578706F7274733A207B7D0A2F2A2A2A2A2A2A2F2009097D3B0A2F2A2A2A2A2A2A2F20090A2F2A2A2A2A2A2A2F2009092F2F204578656375746520746865206D6F64756C652066756E6374696F6E0A2F2A';
wwv_flow_imp.g_varchar2_table(7638) := '2A2A2A2A2A2F2009095F5F7765627061636B5F6D6F64756C65735F5F5B6D6F64756C6549645D286D6F64756C652C206D6F64756C652E6578706F7274732C205F5F7765627061636B5F726571756972655F5F293B0A2F2A2A2A2A2A2A2F20090A2F2A2A2A';
wwv_flow_imp.g_varchar2_table(7639) := '2A2A2A2F2009092F2F2052657475726E20746865206578706F727473206F6620746865206D6F64756C650A2F2A2A2A2A2A2A2F20090972657475726E206D6F64756C652E6578706F7274733B0A2F2A2A2A2A2A2A2F20097D0A2F2A2A2A2A2A2A2F20090A';
wwv_flow_imp.g_varchar2_table(7640) := '2F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A2F2A2A2A2A2A2A2F20092F2A207765627061636B2F72756E74';
wwv_flow_imp.g_varchar2_table(7641) := '696D652F646566696E652070726F70657274792067657474657273202A2F0A2F2A2A2A2A2A2A2F2009282829203D3E207B0A2F2A2A2A2A2A2A2F2009092F2F20646566696E65206765747465722066756E6374696F6E7320666F72206861726D6F6E7920';
wwv_flow_imp.g_varchar2_table(7642) := '6578706F7274730A2F2A2A2A2A2A2A2F2009095F5F7765627061636B5F726571756972655F5F2E64203D20286578706F7274732C20646566696E6974696F6E29203D3E207B0A2F2A2A2A2A2A2A2F20090909666F7228766172206B657920696E20646566';
wwv_flow_imp.g_varchar2_table(7643) := '696E6974696F6E29207B0A2F2A2A2A2A2A2A2F20090909096966285F5F7765627061636B5F726571756972655F5F2E6F28646566696E6974696F6E2C206B65792920262620215F5F7765627061636B5F726571756972655F5F2E6F286578706F7274732C';
wwv_flow_imp.g_varchar2_table(7644) := '206B65792929207B0A2F2A2A2A2A2A2A2F2009090909094F626A6563742E646566696E6550726F7065727479286578706F7274732C206B65792C207B20656E756D657261626C653A20747275652C206765743A20646566696E6974696F6E5B6B65795D20';
wwv_flow_imp.g_varchar2_table(7645) := '7D293B0A2F2A2A2A2A2A2A2F20090909097D0A2F2A2A2A2A2A2A2F200909097D0A2F2A2A2A2A2A2A2F2009097D3B0A2F2A2A2A2A2A2A2F20097D2928293B0A2F2A2A2A2A2A2A2F20090A2F2A2A2A2A2A2A2F20092F2A207765627061636B2F72756E7469';
wwv_flow_imp.g_varchar2_table(7646) := '6D652F6861734F776E50726F70657274792073686F727468616E64202A2F0A2F2A2A2A2A2A2A2F2009282829203D3E207B0A2F2A2A2A2A2A2A2F2009095F5F7765627061636B5F726571756972655F5F2E6F203D20286F626A2C2070726F7029203D3E20';
wwv_flow_imp.g_varchar2_table(7647) := '284F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C286F626A2C2070726F7029290A2F2A2A2A2A2A2A2F20097D2928293B0A2F2A2A2A2A2A2A2F20090A2F2A2A2A2A2A2A2F20092F2A207765627061636B2F7275';
wwv_flow_imp.g_varchar2_table(7648) := '6E74696D652F6D616B65206E616D657370616365206F626A656374202A2F0A2F2A2A2A2A2A2A2F2009282829203D3E207B0A2F2A2A2A2A2A2A2F2009092F2F20646566696E65205F5F65734D6F64756C65206F6E206578706F7274730A2F2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(7649) := '2F2009095F5F7765627061636B5F726571756972655F5F2E72203D20286578706F72747329203D3E207B0A2F2A2A2A2A2A2A2F20090909696628747970656F662053796D626F6C20213D3D2027756E646566696E6564272026262053796D626F6C2E746F';
wwv_flow_imp.g_varchar2_table(7650) := '537472696E6754616729207B0A2F2A2A2A2A2A2A2F20090909094F626A6563742E646566696E6550726F7065727479286578706F7274732C2053796D626F6C2E746F537472696E675461672C207B2076616C75653A20274D6F64756C6527207D293B0A2F';
wwv_flow_imp.g_varchar2_table(7651) := '2A2A2A2A2A2A2F200909097D0A2F2A2A2A2A2A2A2F200909094F626A6563742E646566696E6550726F7065727479286578706F7274732C20275F5F65734D6F64756C65272C207B2076616C75653A2074727565207D293B0A2F2A2A2A2A2A2A2F2009097D';
wwv_flow_imp.g_varchar2_table(7652) := '3B0A2F2A2A2A2A2A2A2F20097D2928293B0A2F2A2A2A2A2A2A2F20090A2F2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(7653) := '2A2A2F0A766172205F5F7765627061636B5F6578706F7274735F5F203D207B7D3B0A2F2F205468697320656E747279206E65656420746F206265207772617070656420696E20616E20494946452062656361757365206974206465636C61726573202762';
wwv_flow_imp.g_varchar2_table(7654) := '706D6E56696577657227206F6E20746F702D6C6576656C2C20776869636820636F6E666C696374732077697468207468652063757272656E74206C696272617279206F75747075742E0A282829203D3E207B0A2F2A212A2A2A2A2A2A2A2A2A2A2A2A2A2A';
wwv_flow_imp.g_varchar2_table(7655) := '2A2A2A2A212A5C0A2020212A2A2A202E2F696E6465782E6A73202A2A2A210A20205C2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2A2F0A5F5F7765627061636B5F726571756972655F5F2E72285F5F7765627061636B5F6578706F7274735F5F293B0A2F2A';
wwv_flow_imp.g_varchar2_table(7656) := '206861726D6F6E79206578706F7274202A2F205F5F7765627061636B5F726571756972655F5F2E64285F5F7765627061636B5F6578706F7274735F5F2C207B0A2F2A206861726D6F6E79206578706F7274202A2F2020202264656661756C74223A202829';
wwv_flow_imp.g_varchar2_table(7657) := '203D3E20285F5F5745425041434B5F44454641554C545F4558504F52545F5F290A2F2A206861726D6F6E79206578706F7274202A2F207D293B0A2F2A206861726D6F6E7920696D706F7274202A2F207661722062706D6E5F6A735F6C69625F5669657765';
wwv_flow_imp.g_varchar2_table(7658) := '725F5F5745425041434B5F494D504F525445445F4D4F44554C455F365F5F203D205F5F7765627061636B5F726571756972655F5F282F2A212062706D6E2D6A732F6C69622F566965776572202A2F20222E2F6E6F64655F6D6F64756C65732F62706D6E2D';
wwv_flow_imp.g_varchar2_table(7659) := '6A732F6C69622F5669657765722E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F6E617669676174696F6E5F6D6F766563616E7661735F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(7660) := '4D4F44554C455F375F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F6E617669676174696F6E2F6D6F766563616E766173202A2F20222E2F6E6F64655F6D6F64756C65732F6469616772616D';
wwv_flow_imp.g_varchar2_table(7661) := '2D6A732F6C69622F6E617669676174696F6E2F6D6F766563616E7661732F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172206469616772616D5F6A735F6C69625F6E617669676174696F6E5F7A6F6F6D736372';
wwv_flow_imp.g_varchar2_table(7662) := '6F6C6C5F5F5745425041434B5F494D504F525445445F4D4F44554C455F385F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21206469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C202A2F2022';
wwv_flow_imp.g_varchar2_table(7663) := '2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F6C69625F766965776572';
wwv_flow_imp.g_varchar2_table(7664) := '50616C657474655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F6C69622F76696577657250616C65747465202A2F20222E2F6C69622F76696577657250';
wwv_flow_imp.g_varchar2_table(7665) := '616C657474652F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F6D6F64756C65735F63616C6C41637469766974794D6F64756C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F315F5F';
wwv_flow_imp.g_varchar2_table(7666) := '203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F6D6F64756C65732F63616C6C41637469766974794D6F64756C65202A2F20222E2F6D6F64756C65732F63616C6C41637469766974794D6F64756C652F696E6465782E6A7322293B';
wwv_flow_imp.g_varchar2_table(7667) := '0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F6D6F64756C65735F6472696C6C646F776E43656E746572696E675F5F5745425041434B5F494D504F525445445F4D4F44554C455F325F5F203D205F5F7765627061636B5F7265717569';
wwv_flow_imp.g_varchar2_table(7668) := '72655F5F282F2A21202E2F6D6F64756C65732F6472696C6C646F776E43656E746572696E67202A2F20222E2F6D6F64756C65732F6472696C6C646F776E43656E746572696E672F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274';
wwv_flow_imp.g_varchar2_table(7669) := '202A2F20766172205F6D6F64756C65735F7374796C654D6F64756C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F6D6F64756C65732F7374796C654D';
wwv_flow_imp.g_varchar2_table(7670) := '6F64756C65202A2F20222E2F6D6F64756C65732F7374796C654D6F64756C652F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F6D6F64756C65735F6D756C7469496E7374616E63654D6F64756C655F5F57';
wwv_flow_imp.g_varchar2_table(7671) := '45425041434B5F494D504F525445445F4D4F44554C455F345F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F6D6F64756C65732F6D756C7469496E7374616E63654D6F64756C65202A2F20222E2F6D6F64756C65732F6D756C';
wwv_flow_imp.g_varchar2_table(7672) := '7469496E7374616E63654D6F64756C652F696E6465782E6A7322293B0A2F2A206861726D6F6E7920696D706F7274202A2F20766172205F6D6F64756C65735F757365725461736B4D6F64756C655F5F5F5745425041434B5F494D504F525445445F4D4F44';
wwv_flow_imp.g_varchar2_table(7673) := '554C455F355F5F203D205F5F7765627061636B5F726571756972655F5F282F2A21202E2F6D6F64756C65732F757365725461736B4D6F64756C652F202A2F20222E2F6D6F64756C65732F757365725461736B4D6F64756C652F696E6465782E6A7322293B';
wwv_flow_imp.g_varchar2_table(7674) := '0A0D0A0D0A0D0A0D0A0D0A0D0A0D0A0D0A0D0A0D0A0D0A7661722062706D6E566965776572203D207B0D0A20205669657765723A2062706D6E5F6A735F6C69625F5669657765725F5F5745425041434B5F494D504F525445445F4D4F44554C455F365F5F';
wwv_flow_imp.g_varchar2_table(7675) := '5B2264656661756C74225D2C0D0A2020637573746F6D4D6F64756C65733A207B0D0A202020204D6F766543616E7661734D6F64756C653A206469616772616D5F6A735F6C69625F6E617669676174696F6E5F6D6F766563616E7661735F5F574542504143';
wwv_flow_imp.g_varchar2_table(7676) := '4B5F494D504F525445445F4D4F44554C455F375F5F5B2264656661756C74225D2C0D0A202020205A6F6F6D5363726F6C6C4D6F64756C653A206469616772616D5F6A735F6C69625F6E617669676174696F6E5F7A6F6F6D7363726F6C6C5F5F5745425041';
wwv_flow_imp.g_varchar2_table(7677) := '434B5F494D504F525445445F4D4F44554C455F385F5F5B2264656661756C74225D2C0D0A202020206472696C6C646F776E43656E746572696E673A205F6D6F64756C65735F6472696C6C646F776E43656E746572696E675F5F5745425041434B5F494D50';
wwv_flow_imp.g_varchar2_table(7678) := '4F525445445F4D4F44554C455F325F5F5B2264656661756C74225D2C0D0A2020202063616C6C41637469766974794D6F64756C653A205F6D6F64756C65735F63616C6C41637469766974794D6F64756C655F5F5745425041434B5F494D504F525445445F';
wwv_flow_imp.g_varchar2_table(7679) := '4D4F44554C455F315F5F5B2264656661756C74225D2C0D0A202020206D756C7469496E7374616E63654D6F64756C653A205F6D6F64756C65735F6D756C7469496E7374616E63654D6F64756C655F5F5745425041434B5F494D504F525445445F4D4F4455';
wwv_flow_imp.g_varchar2_table(7680) := '4C455F345F5F5B2264656661756C74225D2C0D0A202020207374796C654D6F64756C653A205F6D6F64756C65735F7374796C654D6F64756C655F5F5745425041434B5F494D504F525445445F4D4F44554C455F335F5F5B2264656661756C74225D2C0D0A';
wwv_flow_imp.g_varchar2_table(7681) := '20202020637573746F6D50616C6574746550726F76696465724D6F64756C653A205F6C69625F76696577657250616C657474655F5F5745425041434B5F494D504F525445445F4D4F44554C455F305F5F5B2264656661756C74225D2C0D0A202020207573';
wwv_flow_imp.g_varchar2_table(7682) := '65725461736B4D6F64756C653A205F6D6F64756C65735F757365725461736B4D6F64756C655F5F5F5745425041434B5F494D504F525445445F4D4F44554C455F355F5F5B2264656661756C74225D0D0A20207D2C0D0A7D3B0D0A0D0A2F2A206861726D6F';
wwv_flow_imp.g_varchar2_table(7683) := '6E792064656661756C74206578706F7274202A2F20636F6E7374205F5F5745425041434B5F44454641554C545F4558504F52545F5F203D202862706D6E566965776572293B0D0A0A7D2928293B0A0A62706D6E566965776572203D205F5F776562706163';
wwv_flow_imp.g_varchar2_table(7684) := '6B5F6578706F7274735F5F5B2264656661756C74225D3B0A2F2A2A2A2A2A2A2F207D2928290A3B0A2F2F2320736F757263654D617070696E6755524C3D666C6F777334617065782E7669657765722E6A732E6D6170';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(14526836540955688)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_file_name=>'js/flows4apex.viewer.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C2266696C65223A22666C6F777334617065782E7669657765722E6A73222C226D617070696E6773223A223B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41414179453B41414376433B4141436C433B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(2) := '414143413B414143653B414143663B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C7942414179422C75464141552C474141473B4141';
wwv_flow_imp.g_varchar2_table(3) := '4374433B414143412C494141492C674441414D3B414143563B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141573B414143582C534141533B414143542C4F41414F3B414143503B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(4) := '414143413B414143413B414143413B414143413B414143412C574141573B414143582C534141533B414143542C4F41414F3B414143503B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141573B414143582C';
wwv_flow_imp.g_varchar2_table(5) := '534141533B414143542C4F41414F3B414143503B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C614141613B414143622C574141573B414143583B414143412C4F41414F3B414143502C4B41414B3B';
wwv_flow_imp.g_varchar2_table(6) := '4141434C3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143684634443B41';
wwv_flow_imp.g_varchar2_table(7) := '41434E3B41414374443B4141436D443B4141436E443B414143412C69454141653B414143662C6742414167422C75454141612C454141452C71454141533B41414378433B414143412C3442414134422C32444141653B41414333432C434141432C454141';
wwv_flow_imp.g_varchar2_table(8) := '433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414354463B41414367443B414143663B4141436A433B414143413B414143653B414143663B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(9) := '414143413B414143412C7142414171422C2B4341414D3B41414333423B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C4B41414B3B4141434C2C474141473B414143483B41';
wwv_flow_imp.g_varchar2_table(10) := '4143413B414143413B414143412C554141552C38444141453B4141435A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C654141652C2B4341414D2C6B4341416B432C654141653B41414374453B414143413B41';
wwv_flow_imp.g_varchar2_table(11) := '4143412C7142414171422C7143414171433B41414331443B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C554141552C3042414130423B41414370433B414143413B414143';
wwv_flow_imp.g_varchar2_table(12) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(13) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B414143483B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C474141';
wwv_flow_imp.g_varchar2_table(14) := '473B414143483B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B414143483B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(15) := '413B414143413B414143413B414143412C554141552C7145414171453B4141432F453B414143413B414143412C514141512C614141613B41414372423B414143413B414143413B414143413B414143413B414143413B414143413B414143412C61414161';
wwv_flow_imp.g_varchar2_table(16) := '2C2B4341414D3B4141436E422C7542414175422C6D4341416D433B41414331442C4D41414D2C6744414167442C6B4241416B423B41414378452C4D41414D2C3844414138442C7942414179423B41414337462C4D41414D2C3643414136432C6742414167';
wwv_flow_imp.g_varchar2_table(17) := '422C514141513B41414333453B414143412C4D41414D2C7543414175432C6742414167422C514141513B41414372452C4F41414F2C574141573B4141436C423B414143413B414143413B414143413B414143413B414143412C554141552C324241413242';
wwv_flow_imp.g_varchar2_table(18) := '3B41414372433B414143413B414143412C594141592C4F41414F3B4141436E423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(19) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B414143483B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(20) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C6B4241416B422C7743414177433B41414331443B414143413B4141';
wwv_flow_imp.g_varchar2_table(21) := '43413B414143412C4D41414D3B4141434E3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(22) := '43413B414143413B414143413B414143413B414143413B414143412C3042414130422C7543414175433B4141436A453B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(23) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436C5073443B41414374443B414143412C';
wwv_flow_imp.g_varchar2_table(24) := '69454141653B414143663B414143412C2B4241412B422C324441416B423B4141436A442C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B41434C443B414143413B414143413B414143413B414143413B414143413B414143412C574141572C554141553B41';
wwv_flow_imp.g_varchar2_table(25) := '414372422C574141572C514141513B4141436E423B414143653B414143663B414143413B414143413B414143413B414143413B414143412C474141473B414143483B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436C4273443B414143';
wwv_flow_imp.g_varchar2_table(26) := '74443B414143412C69454141653B414143663B414143412C2B4241412B422C324441416B423B4141436A442C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41434C443B4141436D453B414143663B41414370443B414143413B4141434F3B41414350';
wwv_flow_imp.g_varchar2_table(27) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C6B4241416B422C2B4341414D3B41414378423B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(28) := '414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(29) := '414143413B414143413B414143413B414143413B414143412C7742414177422C38434141513B41414368433B414143413B414143412C4F41414F3B414143503B414143412C3042414130422C38434141513B4141436C433B414143413B414143412C4F41';
wwv_flow_imp.g_varchar2_table(30) := '414F3B414143502C4B41414B3B4141434C3B414143413B414143413B414143412C634141632C554141553B41414378423B414143413B414143413B414143413B414143413B414143412C554141552C38444141453B4141435A3B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(31) := '414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(32) := '414143413B414143413B414143412C594141592C4B41414B2C454141452C3645414169423B41414370433B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(33) := '43413B414143413B414143413B414143413B414143413B414143412C3242414132422C38444141453B41414337423B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143413B414143412C6D4241416D422C2B4341414D3B';
wwv_flow_imp.g_varchar2_table(34) := '4141437A423B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143412C4B41414B3B4141434C3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(35) := '3B414143413B414143413B414143412C3242414132422C3645414169423B41414335432C574141572C38444141453B414143623B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C754241';
wwv_flow_imp.g_varchar2_table(36) := '4175422C38434141512C7342414173423B41414372443B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(37) := '43413B414143413B414143413B414143413B414143413B414143413B414143412C7142414171422C2B4341414D3B41414333423B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(38) := '413B414143413B414143413B414143413B414143413B414143412C6F4241416F422C7142414171423B4141437A433B414143413B414143413B414143413B414143413B414143413B414143412C7942414179422C38434141513B4141436A433B41414341';
wwv_flow_imp.g_varchar2_table(39) := '2C7142414171422C2B4341414D3B41414333423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C7942414179422C38434141513B4141436A433B414143412C71';
wwv_flow_imp.g_varchar2_table(40) := '42414171422C2B4341414D2C3243414132432C7142414171423B41414333463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C7342414173422C38';
wwv_flow_imp.g_varchar2_table(41) := '434141513B41414339422C6B4241416B422C38434141513B41414331423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C6B4241416B422C38434141513B41414331423B414143413B41';
wwv_flow_imp.g_varchar2_table(42) := '4143413B414143413B414143412C6F4241416F422C2B4341414D3B41414331422C634141632C6744414167443B41414339442C6742414167422C634141633B41414339422C6742414167422C634141633B41414339422C6742414167422C534141533B41';
wwv_flow_imp.g_varchar2_table(43) := '41437A423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141573B414143583B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(44) := '414143413B414143412C3242414132422C38444141453B41414337423B414143413B414143413B414143413B414143413B414143413B414143412C6F4241416F422C38434141513B41414335422C3042414130422C3645414169423B41414333433B4141';
wwv_flow_imp.g_varchar2_table(45) := '43413B414143413B414143413B414143413B414143413B414143413B414143412C6B4241416B422C38434141513B41414331423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(46) := '413B414143413B414143413B414143413B414143413B414143413B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(47) := '43413B414143413B414143413B414143413B414143413B414143413B414143412C6742414167422C3442414134423B41414335433B414143412C514141513B414143523B414143413B414143413B414143413B414143413B414143413B414143413B3B3B';
wwv_flow_imp.g_varchar2_table(48) := '3B3B3B3B3B3B3B3B3B3B3B3B41436E5534443B41414335443B414143412C69454141653B414143663B414143412C6743414167432C714541416D423B4141436E442C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B41434C633B414143663B414143413B41';
wwv_flow_imp.g_varchar2_table(49) := '4143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C364441413644';
wwv_flow_imp.g_varchar2_table(50) := '2C454141453B4141432F443B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(51) := '413B414143413B414143412C3644414136442C454141453B4141432F443B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(52) := '414143413B414143412C3644414136442C454141453B4141432F443B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(53) := '43413B414143413B414143412C3044414130442C3642414136422C6743414167433B41414376483B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(54) := '414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143374632433B41414333433B414143412C69454141653B414143663B414143412C7742414177422C75444141573B4141436E432C434141432C454141433B3B3B3B3B3B3B3B';
wwv_flow_imp.g_varchar2_table(55) := '3B3B3B3B3B3B3B3B3B41434C463B4141436D453B4141436C433B4141436A433B4141434F3B414143503B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C594141';
wwv_flow_imp.g_varchar2_table(56) := '592C654141653B41414333423B414143413B414143412C6942414169422C3645414169423B4141436C433B414143413B414143413B414143413B414143413B414143413B414143412C614141612C38444141453B414143662C4B41414B3B4141434C3B41';
wwv_flow_imp.g_varchar2_table(57) := '4143412C4B41414B3B4141434C3B414143413B414143413B414143413B414143412C6D4241416D422C2B4341414D3B4141437A423B414143413B414143413B414143412C4B41414B3B4141434C3B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(58) := '43413B414143412C4F41414F3B414143503B414143412C4B41414B3B4141434C3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414376446B443B4141436C443B414143412C';
wwv_flow_imp.g_varchar2_table(59) := '69454141653B414143663B414143412C3242414132422C32444141633B4141437A432C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41434C443B414143413B414143413B414143413B414143413B414143413B41414D6B423B3B4141';
wwv_flow_imp.g_varchar2_table(60) := '4F443B3B414149433B3B414145653B414143493B3B414145473B3B414149623B3B41414533423B414143413B414143413B414143412C634141632C6F4441416F443B4141436C453B3B414145413B414143413B414143413B414143412C614141612C6945';
wwv_flow_imp.g_varchar2_table(61) := '414169453B41414339453B3B414145413B414143412C614141612C6B4341416B433B4141432F433B414143412C614141612C6743414167433B41414337432C614141612C7543414175433B41414370442C614141612C7943414179433B41414374443B41';
wwv_flow_imp.g_varchar2_table(62) := '4143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B2C7742414177423B41414337423B414143412C614141612C2B4241412B423B41414335433B414143413B414143413B414143412C4F41414F3B';
wwv_flow_imp.g_varchar2_table(63) := '414143503B414143413B414143413B414143412C4F41414F3B414143503B414143412C614141612C7942414179423B41414374433B414143412C614141612C6942414169423B41414339423B414143412C614141612C6742414167423B41414337423B41';
wwv_flow_imp.g_varchar2_table(64) := '4143412C614141612C6942414169423B41414339423B414143412C614141612C6742414167423B41414337423B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143413B414143412C4F41414F3B';
wwv_flow_imp.g_varchar2_table(65) := '414143503B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B';
wwv_flow_imp.g_varchar2_table(66) := '414143413B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143412C4F41414F3B414143503B414143412C614141612C654141653B41414335423B414143413B414143413B414143413B414143412C4F41414F';
wwv_flow_imp.g_varchar2_table(67) := '3B414143503B3B414145413B414143413B414143413B414143412C634141632C654141652C3842414138422C634141633B4141437A453B3B414145413B414143413B414143413B414143412C6D4241416D422C7942414179422C474141472C6D4341416D';
wwv_flow_imp.g_varchar2_table(68) := '432C494141492C3242414132423B4141436A483B414143413B414143413B414143413B414143413B414143413B414143412C574141572C6D4241416D423B41414339423B414143653B3B414145663B414143412C594141593B4141435A3B414143412C59';
wwv_flow_imp.g_varchar2_table(69) := '4141592C674441414D2C474141473B3B41414572423B414143412C594141593B4141435A3B414143413B3B414145413B414143412C594141593B4141435A3B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(70) := '45412C34444141512C614141612C6B4441414F3B3B41414535423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C3043414130433B41414331433B414143413B';
wwv_flow_imp.g_varchar2_table(71) := '414143413B414143413B414143413B414143413B414143412C594141592C6742414167423B41414335423B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C73';
wwv_flow_imp.g_varchar2_table(72) := '42414173423B4141436A433B414143412C594141592C3042414130423B41414374433B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(73) := '414143413B414143412C634141633B414143643B414143412C3643414136432C554141553B3B41414576443B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143412C4F41414F3B3B414145503B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(74) := '3B414143413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143412C634141633B414143643B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(75) := '4143412C4B41414B3B3B4141454C3B3B414145413B3B414145413B414143413B414143413B414143413B414143412C634141633B414143643B414143412C6743414167432C3243414132433B3B41414533452C614141613B414143622C494141493B4141';
wwv_flow_imp.g_varchar2_table(76) := '434A3B414143413B414143413B3B414145413B3B414145412C6743414167432C6943414169433B3B4141456A453B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(77) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C594141592C7742414177423B41414370433B414143412C574141572C654141653B41414331422C574141572C7342414173423B4141436A433B414143412C';
wwv_flow_imp.g_varchar2_table(78) := '594141592C6B4341416B433B41414339433B414143413B414143413B414143413B3B414145412C574141573B414143583B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(79) := '3B414143413B414143413B414143413B414143413B414143413B414143412C594141592C574141573B41414376423B414143412C574141572C7342414173423B4141436A433B414143412C594141592C7142414171423B4141436A433B414143413B3B41';
wwv_flow_imp.g_varchar2_table(80) := '4145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(81) := '414143412C494141493B4141434A3B3B414145413B414143413B3B414145413B414143412C554141552C574141572C514141512C6D45414169423B3B41414539432C574141573B414143583B3B414145413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(82) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C594141592C4F41414F3B4141436E423B414143413B414143413B414143413B414143412C574141572C6742414167423B';
wwv_flow_imp.g_varchar2_table(83) := '41414333423B414143412C594141592C7742414177423B41414370433B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(84) := '4143412C634141633B414143643B414143413B414143413B414143412C4B41414B3B3B4141454C3B414143413B3B414145413B414143413B414143412C4B41414B3B4141434C2C494141493B4141434A3B414143413B3B414145412C3242414132422C51';
wwv_flow_imp.g_varchar2_table(85) := '4141512C494141493B3B41414576433B414143413B414143413B414143413B414143412C594141593B4141435A3B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(86) := '414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C594141592C4F41414F3B4141436E423B414143413B414143413B414143412C594141592C7742414177423B41414370433B41';
wwv_flow_imp.g_varchar2_table(87) := '4143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143412C7142414171422C38434141513B3B41414537422C7142414171422C6B444141513B41414337422C7543414175432C6B444141513B3B4141452F433B3B414145';
wwv_flow_imp.g_varchar2_table(88) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B3B414145413B414143413B414143413B414143413B414143412C594141593B4141435A3B4141';
wwv_flow_imp.g_varchar2_table(89) := '43413B414143413B414143413B414143412C474141473B3B414145483B414143413B414143413B3B414145412C574141573B414143583B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C594141592C714241';
wwv_flow_imp.g_varchar2_table(90) := '4171423B4141436A433B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143412C454141452C6B44';
wwv_flow_imp.g_varchar2_table(91) := '41414F3B414143543B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143412C454141452C6B4441414F3B3B414145543B414143412C454141452C2B434141533B414143583B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(92) := '414143413B414143413B414143413B414143412C3642414136422C6F4241416F423B4141436A443B414143413B414143413B414143412C3442414134422C3442414134423B41414378443B414143413B414143413B414143413B414143413B414143412C';
wwv_flow_imp.g_varchar2_table(93) := '574141572C6942414169423B41414335422C574141572C514141513B4141436E422C574141572C3042414130423B41414372432C574141572C4B41414B3B41414368423B414143413B414143413B414143413B414143413B414143412C3642414136422C';
wwv_flow_imp.g_varchar2_table(94) := '6F4241416F423B4141436A443B414143413B414143413B414143412C3442414134422C3442414134423B41414378443B414143413B414143413B414143412C634141632C3442414134423B41414331433B414143412C574141572C574141573B41414374';
wwv_flow_imp.g_varchar2_table(95) := '422C574141572C514141513B4141436E422C574141572C3044414130443B41414372452C574141572C4B41414B3B41414368423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C6942414169423B';
wwv_flow_imp.g_varchar2_table(96) := '41414335422C574141572C554141553B41414372423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C614141613B41414378423B414143413B3B414145413B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(97) := '3B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143412C6942414169422C38434141513B4141437A423B3B414145413B3B414145412C7942414179423B3B4141457A423B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(98) := '4143413B414143413B414143412C594141592C654141653B41414333423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(99) := '43413B3B414145413B414143413B414143413B414143413B414143412C594141593B4141435A3B414143412C7942414179423B3B4141457A423B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(100) := '414143413B414143413B3B414145413B3B414145412C7942414179422C674441414D2C434141432C38434141493B41414370432C594141592C674441414D2C474141472C6F4241416F422C7342414173423B4141432F443B414143412C474141473B3B41';
wwv_flow_imp.g_varchar2_table(101) := '4145483B414143412C454141452C6B4441414F3B3B414145543B414143413B414143413B414143413B3B414145413B414143412C6F4341416F433B41414370433B414143412C594141592C514141513B41414370422C594141592C514141513B41414370';
wwv_flow_imp.g_varchar2_table(102) := '423B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B3B414145413B414143412C574141572C6D4241416D423B41414339423B414143412C594141593B4141435A3B414143413B3B414145412C6F4241416F422C';
wwv_flow_imp.g_varchar2_table(103) := '2B4341414D3B3B41414531422C454141452C6F444141573B414143623B414143413B414143413B414143412C474141473B3B414145483B414143413B3B414145413B414143412C574141572C6D4241416D423B41414339423B414143412C594141593B41';
wwv_flow_imp.g_varchar2_table(104) := '41435A3B414143413B414143412C7742414177422C674441414D2C474141473B3B4141456A432C614141612C6D444141553B41414376423B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B3B41414541';
wwv_flow_imp.g_varchar2_table(105) := '3B414143413B3B414145413B414143413B3B414145413B414143413B414143412C7544414175443B41414376443B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B3B414147413B414143413B';
wwv_flow_imp.g_varchar2_table(106) := '414143413B414143413B414143412C6742414167422C6B444141513B41414378423B3B3B414147413B414143413B414143413B414143412C574141572C3442414134423B41414376432C574141572C514141513B4141436E423B414143412C594141593B';
wwv_flow_imp.g_varchar2_table(107) := '4141435A3B414143413B414143413B414143413B414143413B3B414145412C534141532C38434141493B414143623B414143412C474141473B414143483B3B3B414147413B3B41414F38423B3B414149623B3B4141456A423B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(108) := '4143413B414143413B414143413B414143412C574141572C534141533B41414370423B414143413B414143412C634141632C32444141553B3B41414578423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B41';
wwv_flow_imp.g_varchar2_table(109) := '4145412C7342414173422C2B4341414D3B3B41414535422C454141452C6F444141572C434141432C38434141512C7342414173422C34444141573B41414376442C454141452C6F444141572C634141632C34444141573B41414374433B414143413B4141';
wwv_flow_imp.g_varchar2_table(110) := '43413B414143413B414143412C474141473B3B414145483B3B414145412C454141452C30434141513B414143562C494141492C79444141613B3B4141456A423B414143412C474141473B414143483B3B414145413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B';
wwv_flow_imp.g_varchar2_table(111) := '3B3B3B3B3B3B3B41437A314277433B3B414145523B4141436F423B4141434C3B414143653B414143453B4141434A3B3B41414574423B3B3B41414774433B414143412C634141632C3243414132433B4141437A443B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(112) := '3B414143412C6D4241416D422C6D4341416D432C494141492C3242414132423B41414372463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(113) := '43413B414143413B414143413B414143413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143412C2B4341412B433B4141432F433B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(114) := '3B414143412C6943414169432C7743414177433B4141437A453B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C6D4241416D423B41414339423B414143653B414143662C454141452C6D444141553B';
wwv_flow_imp.g_varchar2_table(115) := '4141435A3B3B414145412C34444141512C534141532C6D444141553B3B41414533423B414143413B414143412C454141452C36434141553B4141435A2C454141452C3244414167423B4141436C422C454141452C79444141613B414143662C454141452C';
wwv_flow_imp.g_varchar2_table(116) := '77454141633B41414368422C454141452C79454141653B4141436A422C454141452C71454141653B4141436A423B3B414145413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143394569433B414143493B3B41414572432C69454141653B414143';
wwv_flow_imp.g_varchar2_table(117) := '663B414143412C494141492C36434141553B414143642C494141492C2B434141593B41414368423B414143412C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41434C69423B3B414149533B3B414149613B';
wwv_flow_imp.g_varchar2_table(118) := '3B3B41414778433B414143412C614141612C6B4341416B433B4141432F432C614141612C3442414134423B4141437A433B414143412C614141612C3842414138423B41414333433B414143412C614141612C6744414167443B41414337442C614141612C';
wwv_flow_imp.g_varchar2_table(119) := '3043414130433B41414376443B3B414145413B41414932423B3B3B41414770423B414143413B3B414145503B3B414145413B414143413B414143413B414143412C574141572C654141653B41414331422C574141572C514141513B4141436E423B414143';
wwv_flow_imp.g_varchar2_table(120) := '412C594141593B4141435A3B4141434F3B414143502C534141532C38434141493B414143623B414143412C474141473B414143483B3B414145413B414143413B414143413B414143412C574141572C654141653B41414331423B414143412C594141593B';
wwv_flow_imp.g_varchar2_table(121) := '4141435A3B4141434F3B414143503B414143413B3B414145413B414143413B414143413B414143412C574141572C654141653B41414331423B414143412C594141593B4141435A3B4141434F3B414143503B3B414145413B414143413B3B3B414147413B';
wwv_flow_imp.g_varchar2_table(122) := '3B414145413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B4141434F3B414143502C574141572C734441414B3B3B41414568';
wwv_flow_imp.g_varchar2_table(123) := '423B414143413B3B414145413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B4141434F3B414143502C574141572C73444141';
wwv_flow_imp.g_varchar2_table(124) := '4B3B3B41414568423B414143413B3B414145413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143412C594141593B41';
wwv_flow_imp.g_varchar2_table(125) := '41435A3B4141434F3B414143502C574141572C734441414B3B41414368423B3B414145413B414143413B414143413B3B414145413B3B414145413B414143412C574141572C574141573B41414374423B414143412C594141592C514141513B4141437042';
wwv_flow_imp.g_varchar2_table(126) := '3B4141434F3B3B414145503B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145412C534141532C6746414167423B4141437A423B3B414145413B414143412C574141572C5741';
wwv_flow_imp.g_varchar2_table(127) := '41573B41414374422C574141572C514141513B4141436E423B414143412C594141592C514141513B41414370423B4141434F3B3B414145503B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(128) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145412C534141532C6746414167423B4141437A423B3B414145413B414143412C574141572C574141573B41414374423B414143412C594141592C514141513B41';
wwv_flow_imp.g_varchar2_table(129) := '414370423B4141434F3B3B414145503B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145412C534141532C6746414167423B4141437A42';
wwv_flow_imp.g_varchar2_table(130) := '3B3B414145413B414143412C574141572C574141573B41414374423B414143412C594141592C514141513B41414370423B4141434F3B414143503B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(131) := '414143413B414143413B3B414145412C534141532C6746414167423B4141437A423B3B414145413B414143413B414143413B414143412C574141572C3242414132423B41414374432C574141572C514141513B4141436E423B414143412C614141613B41';
wwv_flow_imp.g_varchar2_table(132) := '4143623B4141434F2C7943414179433B41414368443B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C3242414132423B41414374432C574141572C514141513B4141436E423B414143';
wwv_flow_imp.g_varchar2_table(133) := '412C614141613B414143623B4141434F2C7743414177433B4141432F432C534141532C36434141473B4141435A3B3B414145413B414143413B414143413B414143412C574141572C3242414132423B41414374432C574141572C514141513B4141436E42';
wwv_flow_imp.g_varchar2_table(134) := '3B414143412C614141613B414143623B4141434F2C7943414179433B41414368442C534141532C36434141473B4141435A3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143685177433B3B41414D74423B3B41414530433B3B41414D';
wwv_flow_imp.g_varchar2_table(135) := '70433B3B414149473B3B414149413B3B414149613B3B41416B42643B3B414149543B3B41414F433B3B41414D34423B3B41414578423B3B4141456D423B3B4141457A432C6F4241416F422C32434141473B3B41414576423B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(136) := '43413B3B414145413B414143413B414143413B3B414145413B414143412C634141633B414143643B414143413B414143413B414143412C494141492C494141493B414143523B414143412C634141633B414143643B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(137) := '414143412C494141492C494141493B414143523B3B414145413B414143412C634141632C6D4341416D433B4141436A443B3B414145413B414143413B414143413B414143412C574141572C6F4241416F423B4141432F422C574141572C6744414167443B';
wwv_flow_imp.g_varchar2_table(138) := '41414333442C574141572C3843414138433B4141437A442C574141572C3642414136423B41414378432C574141572C3843414138433B4141437A442C574141572C6B4341416B433B41414337432C574141572C514141513B4141436E423B414143653B41';
wwv_flow_imp.g_varchar2_table(139) := '4143663B414143413B3B414145412C454141452C77454141593B3B414145643B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C634141632C6B4441414B3B4141436E423B414143413B414143412C4B41414B3B';
wwv_flow_imp.g_varchar2_table(140) := '4141434C3B3B414145413B414143413B414143413B414143413B414143412C634141632C6B4441414B3B4141436E423B414143412C4B41414B3B4141434C3B3B414145413B414143413B414143412C634141632C594141593B41414331423B414143413B';
wwv_flow_imp.g_varchar2_table(141) := '414143413B414143412C4D41414D3B3B4141454E2C6942414169422C67444141533B41414331423B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C2C494141492C67444141533B3B4141';
wwv_flow_imp.g_varchar2_table(142) := '45622C654141652C38434141513B3B41414576423B414143412C614141612C67444141533B3B41414574422C4D41414D2C67444141533B414143663B3B414145412C494141492C67444141533B414143623B3B414145413B3B3B414147413B3B41414541';
wwv_flow_imp.g_varchar2_table(143) := '3B3B414145413B414143413B3B414145413B3B414145413B414143412C3442414134422C67444141533B41414372433B414143413B414143413B414143413B414143413B414143412C534141533B414143542C4F41414F3B3B414145503B414143413B41';
wwv_flow_imp.g_varchar2_table(144) := '4143412C654141652C634141633B41414337423B414143413B414143412C4F41414F3B414143503B3B414145413B414143412C3642414136422C67444141533B41414374433B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(145) := '3B414145413B414143413B414143413B414143412C534141533B414143542C4F41414F3B3B414145503B414143413B414143412C654141652C594141593B41414333423B414143412C4F41414F3B414143503B3B414145413B414143412C324241413242';
wwv_flow_imp.g_varchar2_table(146) := '2C67444141533B41414370433B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C534141533B414143542C4F41414F3B3B414145503B414143413B414143412C654141652C634141633B4141433742';
wwv_flow_imp.g_varchar2_table(147) := '3B414143412C4F41414F3B414143503B3B414145413B414143412C3642414136422C67444141533B41414374433B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C534141533B414143542C4F4141';
wwv_flow_imp.g_varchar2_table(148) := '4F3B3B414145503B414143413B414143412C654141652C614141613B41414335423B414143413B414143412C4F41414F3B414143503B3B414145413B414143412C3242414132422C67444141533B41414370433B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(149) := '4143413B3B414145413B414143413B414143413B414143412C534141533B414143542C4F41414F3B3B414145503B414143413B414143412C654141652C634141633B41414337423B414143413B414143412C4F41414F3B414143503B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(150) := '43412C6B4341416B432C67444141533B41414333433B414143413B414143413B414143413B414143412C534141533B414143542C4F41414F3B3B414145503B414143413B414143412C654141652C634141633B41414337423B414143413B414143412C4F';
wwv_flow_imp.g_varchar2_table(151) := '41414F3B414143503B3B414145413B414143412C3842414138422C67444141533B41414376433B414143413B414143413B414143413B414143412C534141533B414143542C4F41414F3B3B414145503B414143413B414143412C654141652C614141613B';
wwv_flow_imp.g_varchar2_table(152) := '41414335423B414143413B414143412C4F41414F3B414143503B414143413B3B414145412C6B4541416B453B3B4141456C452C514141512C6B444141513B41414368423B414143413B414143413B3B414145413B3B414145413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(153) := '3B3B414145412C6942414169422C67444141533B41414331423B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C2C494141492C67444141533B3B414145623B414143413B3B414145413B3B414145412C514141512C6B444141';
wwv_flow_imp.g_varchar2_table(154) := '513B41414368423B414143413B414143413B3B414145413B3B414145413B3B414145412C654141652C67444141533B41414378423B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C2C49';
wwv_flow_imp.g_varchar2_table(155) := '4141492C67444141533B3B414145623B414143413B3B414145413B3B414145413B414143413B3B414145413B414143412C514141512C634141633B41414374422C514141512C6B4241416B423B41414331422C514141512C6D4241416D423B4141433342';
wwv_flow_imp.g_varchar2_table(156) := '2C514141513B414143523B3B414145413B414143413B414143412C4B41414B3B3B4141454C3B3B414145412C6B4241416B422C67444141533B41414333423B414143413B414143412C4B41414B3B3B4141454C2C494141492C67444141533B3B41414562';
wwv_flow_imp.g_varchar2_table(157) := '3B414143413B3B414145413B414143412C614141612C594141593B4141437A422C614141612C534141533B41414374422C614141612C4B41414B3B4141436C422C614141612C514141513B41414372423B414143412C634141633B414143643B41414341';
wwv_flow_imp.g_varchar2_table(158) := '3B414143413B3B414145412C654141652C30454141553B3B4141457A422C494141492C67444141533B3B414145623B414143413B3B414145413B414143412C614141612C594141593B4141437A422C614141612C534141533B41414374422C614141612C';
wwv_flow_imp.g_varchar2_table(159) := '4B41414B3B4141436C423B414143412C634141633B414143643B414143413B414143413B414143413B3B414145413B414143413B3B414145412C654141652C67444141533B41414378423B414143413B414143412C4B41414B3B3B4141454C2C49414149';
wwv_flow_imp.g_varchar2_table(160) := '2C67444141533B3B414145623B414143413B3B414145413B414143412C7143414171432C674441414D2C474141472C7142414171423B4141436E453B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(161) := '413B3B414145413B414143412C3045414130453B41414331453B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C554141552C2B444141633B4141';
wwv_flow_imp.g_varchar2_table(162) := '4378422C554141552C36444141593B3B41414574423B414143412C554141552C36444141593B41414374422C554141552C2B444141633B3B41414578423B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C4B41';
wwv_flow_imp.g_varchar2_table(163) := '414B3B4141434C2C7745414177453B41414378453B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(164) := '43413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145502C7342414173422C514141513B41414339423B414143413B414143';
wwv_flow_imp.g_varchar2_table(165) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C534141533B3B414145543B414143413B3B414145413B414143413B414143412C6B4241416B422C2B444141633B41414368433B414143412C534141533B4141';
wwv_flow_imp.g_varchar2_table(166) := '43543B3B414145413B414143412C4B41414B3B4141434C2C3245414132453B41414333453B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C5541';
wwv_flow_imp.g_varchar2_table(167) := '41552C2B444141633B41414378422C554141552C36444141593B3B41414574423B414143413B414143412C6742414167422C2B444141633B41414339423B414143412C4F41414F3B414143502C4B41414B3B4141434C2C3445414134453B41414335453B';
wwv_flow_imp.g_varchar2_table(168) := '414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339423B414143';
wwv_flow_imp.g_varchar2_table(169) := '412C4F41414F3B414143502C4B41414B3B4141434C2C7145414171453B41414372453B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C55414155';
wwv_flow_imp.g_varchar2_table(170) := '2C2B444141633B41414378422C554141552C36444141593B3B41414574423B414143413B414143412C6742414167422C2B444141633B41414339423B414143412C4F41414F3B414143502C4B41414B3B4141434C2C7345414173453B41414374453B4141';
wwv_flow_imp.g_varchar2_table(171) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C554141552C2B444141633B41414378422C554141552C36444141593B3B41414574423B414143413B41';
wwv_flow_imp.g_varchar2_table(172) := '4143412C6742414167422C2B444141633B41414339423B414143412C4F41414F3B414143502C4B41414B3B4141434C2C7545414175453B41414376453B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(173) := '3B414143412C4F41414F3B3B414145502C3842414138422C2B444141633B3B41414535433B414143413B414143412C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145502C4D41414D2C344541414D3B3B4141455A3B41';
wwv_flow_imp.g_varchar2_table(174) := '4143412C4B41414B3B4141434C2C3245414132453B41414333453B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C554141552C2B444141633B41';
wwv_flow_imp.g_varchar2_table(175) := '414378422C554141552C36444141593B3B41414574423B414143413B414143412C6742414167422C2B444141633B41414339423B414143412C4F41414F3B414143502C4B41414B3B4141434C2C7545414175453B41414376453B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(176) := '414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C554141552C2B444141633B41414378422C554141552C36444141593B3B41414574423B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(177) := '2C6742414167422C2B444141633B41414339422C4F41414F3B414143502C4B41414B3B4141434C2C7945414179453B4141437A453B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41';
wwv_flow_imp.g_varchar2_table(178) := '414F3B3B414145503B414143412C554141552C2B444141633B41414378422C554141552C36444141593B3B41414574423B414143413B414143413B414143412C4F41414F3B414143502C4B41414B3B4141434C2C6946414169463B4141436A463B414143';
wwv_flow_imp.g_varchar2_table(179) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339423B414143412C4F';
wwv_flow_imp.g_varchar2_table(180) := '41414F3B414143502C4B41414B3B4141434C2C3445414134453B41414335453B414143412C634141632C2B444141633B41414335422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143413B414143413B3B';
wwv_flow_imp.g_varchar2_table(181) := '414145412C7944414179443B4141437A442C6D4241416D422C6B454141573B41414339422C7142414171422C36444141593B3B4141456A433B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145412C5141';
wwv_flow_imp.g_varchar2_table(182) := '41512C36444141593B41414370423B414143413B3B414145412C514141512C36444141593B41414370423B414143413B3B414145412C514141512C36444141593B41414370423B414143413B3B414145412C514141512C36444141593B41414370423B41';
wwv_flow_imp.g_varchar2_table(183) := '4143413B3B414145412C514141512C36444141593B41414370423B414143413B3B414145412C514141512C36444141593B41414370423B414143413B3B414145412C514141512C36444141593B41414370423B414143413B3B414145412C514141512C36';
wwv_flow_imp.g_varchar2_table(184) := '444141593B41414370423B414143413B3B414145412C514141512C36444141593B41414370423B414143413B3B414145412C514141512C36444141593B41414370423B414143413B3B414145413B414143413B3B414145413B414143412C344541413445';
wwv_flow_imp.g_varchar2_table(185) := '3B41414335452C6B4241416B422C79444141513B41414331422C6D4241416D422C30444141533B3B41414535423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145';
wwv_flow_imp.g_varchar2_table(186) := '503B414143413B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339422C4F41414F3B414143502C4B41414B3B4141434C2C2B4441412B443B4141432F443B414143413B414143412C634141632C36444141';
wwv_flow_imp.g_varchar2_table(187) := '593B41414331422C6742414167422C2B444141633B41414339422C4F41414F3B3B414145502C4D41414D2C2B454141533B3B414145663B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C';
wwv_flow_imp.g_varchar2_table(188) := '4F41414F3B3B414145503B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339422C4F41414F3B414143502C4B41414B3B4141434C3B414143412C6B4241416B422C79444141513B41414331422C6D424141';
wwv_flow_imp.g_varchar2_table(189) := '6D422C30444141533B3B41414535423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C634141632C36444141593B41414331422C674241416742';
wwv_flow_imp.g_varchar2_table(190) := '2C2B444141633B41414339422C4F41414F3B414143502C4B41414B3B4141434C3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C63';
wwv_flow_imp.g_varchar2_table(191) := '4141632C36444141593B41414331422C6742414167422C2B444141633B41414339422C4F41414F3B414143502C4B41414B3B4141434C3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(192) := '414143412C4F41414F3B3B414145503B414143413B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339422C4F41414F3B414143502C4B41414B3B4141434C3B414143412C6B4241416B422C79444141513B';
wwv_flow_imp.g_varchar2_table(193) := '41414331422C6D4241416D422C30444141533B3B41414535423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143413B414143413B414143412C674241';
wwv_flow_imp.g_varchar2_table(194) := '4167422C2B444141633B41414339423B414143412C4F41414F3B414143502C4B41414B3B4141434C3B414143412C6B4241416B422C79444141513B41414331422C6D4241416D422C30444141533B3B41414535423B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(195) := '414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143413B414143412C634141632C2B444141633B41414335422C6742414167422C2B444141633B41414339422C4F41414F3B414143503B414143';
wwv_flow_imp.g_varchar2_table(196) := '413B3B414145413B414143413B414143413B3B414145412C7745414177453B41414378453B414143413B414143413B414143412C614141612C79444141513B41414372422C634141632C30444141533B41414376423B3B414145412C6D4241416D422C6B';
wwv_flow_imp.g_varchar2_table(197) := '454141573B3B41414539423B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(198) := '43413B414143413B414143413B3B414145412C494141492C694441414F3B414143583B414143412C4B41414B3B3B4141454C3B414143413B414143413B3B414145412C514141512C6D444141453B414143563B414143413B3B414145413B414143413B3B';
wwv_flow_imp.g_varchar2_table(199) := '414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145412C6D4441416D443B4141436E442C594141592C674441414D3B4141436C423B41';
wwv_flow_imp.g_varchar2_table(200) := '4143413B414143413B414143412C4B41414B3B3B4141454C3B3B414145412C494141492C69444141553B3B414145642C494141492C67444141533B3B414145623B414143413B3B414145412C6F4541416F453B41414370452C6D4241416D422C6B454141';
wwv_flow_imp.g_varchar2_table(201) := '573B3B41414539422C634141632C30444141533B41414376423B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C3B414143413B414143413B414143413B414143413B414143412C634141632C38444141613B41414333423B41';
wwv_flow_imp.g_varchar2_table(202) := '4143412C4B41414B3B4141434C3B3B414145412C3644414136443B41414337443B414143413B414143413B414143413B414143413B414143413B3B414145412C6B4341416B432C79444141513B41414331433B414143413B414143412C614141612C6744';
wwv_flow_imp.g_varchar2_table(203) := '41414D3B4141436E422C554141553B414143563B414143413B414143412C6742414167422C38444141613B41414337423B414143413B414143412C4B41414B3B4141434C3B3B414145412C2B4441412B443B4141432F442C3242414132422C3244414159';
wwv_flow_imp.g_varchar2_table(204) := '3B3B41414576433B414143413B414143413B414143412C6B4341416B432C30444141532C6D4241416D422C79444141513B41414374452C4F41414F3B414143503B414143413B414143412C634141632C38444141613B41414333423B414143412C4B4141';
wwv_flow_imp.g_varchar2_table(205) := '4B3B3B4141454C3B414143412C7142414171422C30444141533B41414339422C4D41414D2C2B454141533B414143663B414143413B3B414145412C7744414177443B41414378443B414143413B414143413B414143412C4D41414D2C454141452C304441';
wwv_flow_imp.g_varchar2_table(206) := '41533B3B4141456A423B414143413B414143412C594141592C36444141593B41414378423B414143412C634141632C2B444141633B41414335422C4B41414B3B4141434C3B3B414145412C3244414132443B41414333442C6D4241416D422C6B45414157';
wwv_flow_imp.g_varchar2_table(207) := '3B3B41414539422C654141652C36444141593B41414333422C6942414169422C2B444141633B3B4141452F423B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(208) := '45413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B3B414145412C3044414130443B41414331442C654141652C36444141593B41414333422C6942414169422C2B444141633B3B4141452F423B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(209) := '4143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C3B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C2C6D4241416D422C6B454141573B3B41414539422C51414151';
wwv_flow_imp.g_varchar2_table(210) := '2C36444141593B41414370423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143413B414143413B414143413B414143412C4F41414F3B414143503B3B';
wwv_flow_imp.g_varchar2_table(211) := '414145413B414143413B3B414145412C7144414171443B41414372443B414143413B414143413B414143412C594141592C36444141593B41414378422C634141632C2B444141633B41414335422C4B41414B3B4141434C3B3B414145412C754441417544';
wwv_flow_imp.g_varchar2_table(212) := '3B41414376443B414143412C594141592C36444141593B41414378423B414143412C634141632C2B444141633B41414335422C4B41414B3B4141434C3B3B414145412C6F4441416F443B41414370442C6D4341416D432C79444141512C6B4241416B422C';
wwv_flow_imp.g_varchar2_table(213) := '30444141533B41414374452C594141592C36444141593B41414378423B414143412C634141632C2B444141633B41414335423B414143412C4B41414B3B3B4141454C2C6D4241416D422C6B454141573B3B41414539422C514141512C6D444141453B4141';
wwv_flow_imp.g_varchar2_table(214) := '43563B3B414145413B414143413B3B414145413B414143413B3B414145412C3044414130443B41414331443B3B414145412C514141512C6745414169423B4141437A422C4D41414D2C384341414F3B414143623B414143413B414143412C4F41414F3B41';
wwv_flow_imp.g_varchar2_table(215) := '4143503B3B414145412C6D4241416D422C79444141553B3B41414537423B3B414145413B414143413B414143412C4D41414D3B4141434E3B414143413B3B414145413B414143413B3B414145412C6F4441416F443B41414370443B3B414145413B3B4141';
wwv_flow_imp.g_varchar2_table(216) := '45413B3B414145413B414143413B3B414145413B414143412C6D4541416D453B4141436E452C554141552C79444141553B41414370423B414143413B414143413B414143413B414143413B414143413B414143412C514141513B414143523B414143413B';
wwv_flow_imp.g_varchar2_table(217) := '414143413B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C2C2B4441412B443B4141432F443B414143413B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C2C6945414169453B4141436A452C5941';
wwv_flow_imp.g_varchar2_table(218) := '41592C6F4241416F423B3B41414568433B414143413B414143413B414143413B3B414145412C7142414171422C6B454141573B41414368433B3B414145413B414143413B414143412C634141632C36444141593B41414331423B414143412C6742414167';
wwv_flow_imp.g_varchar2_table(219) := '422C2B444141633B41414339423B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143412C4F41414F3B3B414145503B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C2C6F';
wwv_flow_imp.g_varchar2_table(220) := '4541416F453B41414370453B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B3B414145412C4D41414D2C384341414F3B414143622C634141';
wwv_flow_imp.g_varchar2_table(221) := '632C36444141593B41414331422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B3B414145412C4D41414D2C38434141';
wwv_flow_imp.g_varchar2_table(222) := '4F3B414143622C634141632C2B444141633B41414335422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143412C4B41414B3B4141434C2C6745414167453B41414368453B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(223) := '413B3B414145413B414143413B414143413B414143412C4F41414F3B414143502C4B41414B3B4141434C2C6B4541416B453B4141436C453B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(224) := '43413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C634141632C2B444141633B41414335422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B41414341';
wwv_flow_imp.g_varchar2_table(225) := '2C4B41414B3B4141434C2C3644414136443B41414337443B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143412C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145';
wwv_flow_imp.g_varchar2_table(226) := '503B414143412C4B41414B3B4141434C2C7745414177453B41414378453B414143413B414143413B414143413B3B414145413B414143413B414143412C7744414177442C36444141592C7943414179432C2B444141633B41414333482C4F41414F3B4141';
wwv_flow_imp.g_varchar2_table(227) := '43502C4B41414B3B4141434C2C3844414138443B41414339443B414143413B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C3B414143412C3844414138443B41414339443B414143413B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(228) := '3B3B414145413B3B414145413B414143413B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339422C4F41414F3B3B414145503B414143412C4B41414B3B4141434C2C7945414179453B4141437A453B4141';
wwv_flow_imp.g_varchar2_table(229) := '43413B414143413B414143413B3B414145413B414143413B414143412C7744414177442C36444141592C7943414179432C2B444141633B41414333482C4F41414F3B414143502C4B41414B3B4141434C2C7345414173453B41414374453B414143413B41';
wwv_flow_imp.g_varchar2_table(230) := '4143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C634141632C36444141593B41414331423B414143412C6742';
wwv_flow_imp.g_varchar2_table(231) := '414167422C2B444141633B41414339423B414143412C4F41414F3B414143502C4B41414B3B4141434C2C3444414134443B41414335442C594141592C6F4241416F423B3B41414568433B414143413B414143413B414143413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(232) := '414143413B414143412C4F41414F3B3B414145503B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C2C7145414171453B41414372453B414143413B414143413B414143413B3B414145412C7142414171422C6B454141573B3B';
wwv_flow_imp.g_varchar2_table(233) := '41414568433B3B414145413B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143413B3B414145413B3B414145413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(234) := '3B414143413B414143413B414143413B414143413B414143413B414143412C534141533B3B414145543B414143413B414143412C6B4241416B422C2B444141633B41414368433B414143412C534141533B414143543B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(235) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C534141533B3B414145543B414143413B414143412C6B4241416B422C2B444141633B41414368433B414143412C534141533B414143542C514141';
wwv_flow_imp.g_varchar2_table(236) := '513B414143523B414143413B414143413B414143412C6F4241416F422C2B444141633B4141436C433B414143412C574141573B414143583B3B414145413B414143413B3B3B414147413B414143412C4B41414B3B4141434C2C6F4541416F453B41414370';
wwv_flow_imp.g_varchar2_table(237) := '453B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145502C654141652C734441414B3B3B414145';
wwv_flow_imp.g_varchar2_table(238) := '70423B414143413B414143412C6742414167422C2B444141633B41414339422C6B4241416B422C2B444141633B41414368433B414143412C534141533B414143543B3B414145413B414143412C4B41414B3B4141434C2C3244414132443B41414333443B';
wwv_flow_imp.g_varchar2_table(239) := '414143413B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C2C7944414179443B4141437A443B414143413B414143413B414143413B414143413B414143413B3B414145413B414143412C6742414167422C2B444141633B4141';
wwv_flow_imp.g_varchar2_table(240) := '4339423B414143413B414143413B414143413B414143412C654141652C79444141513B41414376422C6742414167422C30444141533B4141437A422C4F41414F3B414143502C4B41414B3B4141434C2C6F4541416F453B41414370453B414143413B4141';
wwv_flow_imp.g_varchar2_table(241) := '43413B414143413B3B414145413B3B414145413B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143412C4B41414B3B4141434C2C7145414171453B41';
wwv_flow_imp.g_varchar2_table(242) := '414372452C594141592C6F4241416F423B3B41414568433B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C4F41414F3B3B414145503B414143413B414143412C6742414167422C2B444141633B41414339423B';
wwv_flow_imp.g_varchar2_table(243) := '414143412C4F41414F3B3B414145503B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C3B414143413B414143412C7744414177443B41414378443B414143413B414143413B414143413B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(244) := '3B414143413B414143413B414143412C4F41414F3B414143502C4B41414B3B4141434C2C3844414138443B41414339443B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(245) := '2C4F41414F3B3B414145503B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143412C4B41414B3B4141434C2C2B4441412B443B4141432F443B414143';
wwv_flow_imp.g_varchar2_table(246) := '413B414143413B414143413B3B414145412C7142414171422C6B454141573B41414368432C654141652C734441414B3B3B41414570422C6942414169422C36444141593B41414337422C6D4241416D422C2B444141633B3B4141456A433B414143413B41';
wwv_flow_imp.g_varchar2_table(247) := '4143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C534141533B3B414145543B414143413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(248) := '43413B414143413B414143412C554141553B414143563B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C534141533B3B414145543B414143';
wwv_flow_imp.g_varchar2_table(249) := '413B3B414145413B414143413B3B414145412C514141512C2B454141533B4141436A423B3B414145413B414143412C4B41414B3B4141434C2C6D4541416D453B4141436E453B414143413B414143413B414143413B3B414145413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(250) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C634141632C2B444141633B41414335422C6742414167422C2B444141633B41414339423B414143412C4F';
wwv_flow_imp.g_varchar2_table(251) := '41414F3B3B414145503B414143412C4B41414B3B4141434C2C2B4441412B443B4141432F443B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145412C6743414167432C79444141553B41414331432C6B4341416B43';
wwv_flow_imp.g_varchar2_table(252) := '2C32444141593B3B41414539432C7142414171422C6B454141573B41414368433B3B414145413B414143413B414143413B414143413B414143413B414143412C574141573B414143583B414143413B414143412C654141652C30444141533B4141437842';
wwv_flow_imp.g_varchar2_table(253) := '3B414143413B414143413B414143413B414143413B414143412C574141573B414143583B414143412C654141652C79444141513B41414376423B414143413B414143413B3B414145413B414143412C6B4241416B422C2B444141633B41414368433B4141';
wwv_flow_imp.g_varchar2_table(254) := '43412C534141533B3B414145543B414143412C514141513B414143522C7142414171422C30444141533B3B41414539423B414143412C3042414130422C79444141513B4141436C432C7942414179422C30444141533B4141436C433B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(255) := '43413B414143413B414143413B414143412C6B4241416B422C38444141613B4141432F423B414143412C534141533B3B414145543B414143412C7942414179422C30444141533B4141436C432C554141552C2B454141533B4141436E423B414143413B3B';
wwv_flow_imp.g_varchar2_table(256) := '414145413B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C2C6745414167453B41414368453B414143413B414143413B414143413B3B414145412C7142414171422C6B454141573B3B41414568433B3B414145413B3B414145';
wwv_flow_imp.g_varchar2_table(257) := '413B414143413B414143412C6742414167422C36444141593B41414335422C6B4241416B422C2B444141633B41414368433B414143412C534141533B3B414145543B414143413B414143413B414143413B414143413B414143412C534141533B41414354';
wwv_flow_imp.g_varchar2_table(258) := '2C514141513B414143523B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C534141533B414143543B3B414145413B414143412C634141632C36444141593B41414331422C674241416742';
wwv_flow_imp.g_varchar2_table(259) := '2C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143412C4B41414B3B4141434C2C3844414138443B41414339443B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(260) := '4143413B414143412C4F41414F3B3B414145503B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143412C4B41414B3B4141434C2C3444414134443B41';
wwv_flow_imp.g_varchar2_table(261) := '414335443B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C634141632C2B44';
wwv_flow_imp.g_varchar2_table(262) := '4141633B41414335422C6742414167422C36444141593B41414335423B414143412C4F41414F3B3B414145503B414143412C4B41414B3B4141434C2C6745414167453B41414368453B414143413B414143413B414143413B3B414145412C694241416942';
wwv_flow_imp.g_varchar2_table(263) := '2C36444141593B41414337422C6D4241416D422C2B444141633B3B4141456A433B414143413B414143413B414143412C4F41414F3B3B414145502C7142414171422C6B454141573B3B41414568432C594141592C534141533B3B41414572423B41414341';
wwv_flow_imp.g_varchar2_table(264) := '2C3642414136422C6B454141573B3B41414578433B414143412C6D4441416D442C6D444141453B41414372442C554141552C384341414F3B4141436A423B414143412C574141573B414143583B3B414145413B414143412C3843414138432C6D44414145';
wwv_flow_imp.g_varchar2_table(265) := '2C6F4341416F432C6D444141453B41414374463B414143412C554141552C384341414F3B4141436A423B414143412C574141573B414143583B414143413B3B414145413B414143412C4B41414B3B4141434C2C2B4441412B443B4141432F443B41414341';
wwv_flow_imp.g_varchar2_table(266) := '3B414143413B414143413B3B414145413B3B414145413B414143412C634141632C36444141593B41414331423B414143413B414143412C4F41414F3B3B414145503B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145';
wwv_flow_imp.g_varchar2_table(267) := '503B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143412C634141632C36444141593B41414331423B414143413B414143412C4F41414F3B3B414145';
wwv_flow_imp.g_varchar2_table(268) := '503B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C634141632C36444141593B41414331422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143412C';
wwv_flow_imp.g_varchar2_table(269) := '4B41414B3B4141434C2C3844414138443B41414339442C594141592C6F4241416F423B3B41414568433B414143413B414143413B414143413B3B414145412C7142414171422C6B454141573B3B41414568433B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(270) := '43413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C2C3844414138443B41414339442C554141552C79444141553B41414370423B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(271) := '3B414143413B414143412C514141513B414143523B414143413B414143413B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C2C7744414177443B41414378443B414143413B414143413B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(272) := '2C4B41414B3B4141434C2C6B4541416B453B4141436C453B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C514141512C454141452C30444141533B3B4141456E423B414143413B4141';
wwv_flow_imp.g_varchar2_table(273) := '43413B414143412C4F41414F3B3B414145503B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C6742414167422C2B444141633B41414339422C4F';
wwv_flow_imp.g_varchar2_table(274) := '41414F3B3B414145502C7142414171422C6B454141573B41414368433B3B414145413B414143413B414143412C614141612C30444141533B41414374423B414143413B414143412C6742414167422C38444141613B41414337423B414143412C4F41414F';
wwv_flow_imp.g_varchar2_table(275) := '3B3B414145503B414143412C4B41414B3B4141434C2C2B4441412B443B4141432F442C554141552C79444141553B41414370423B414143413B414143413B414143413B414143413B414143413B414143412C514141513B414143523B414143413B414143';
wwv_flow_imp.g_varchar2_table(276) := '413B414143413B414143413B3B414145413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145502C7142414171422C79444141553B3B4141';
wwv_flow_imp.g_varchar2_table(277) := '452F423B414143413B414143413B3B414145413B414143413B414143412C514141512C79444141513B41414368422C514141512C30444141533B4141436A423B414143413B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C2C';
wwv_flow_imp.g_varchar2_table(278) := '3444414134443B41414335443B414143413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C634141632C364441';
wwv_flow_imp.g_varchar2_table(279) := '41593B41414331422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C634141632C36444141593B41414331';
wwv_flow_imp.g_varchar2_table(280) := '422C6742414167422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C634141632C2B444141633B41414335422C6742414167';
wwv_flow_imp.g_varchar2_table(281) := '422C2B444141633B41414339423B414143412C4F41414F3B3B414145503B414143412C4B41414B3B4141434C2C6F4441416F443B41414370443B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B3B414147412C364441';
wwv_flow_imp.g_varchar2_table(282) := '41512C654141652C77454141593B3B4141456E433B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B3B414147413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B41';
wwv_flow_imp.g_varchar2_table(283) := '4143413B414143412C534141532C6D444141453B414143583B3B414145413B414143413B414143413B414143412C574141572C594141593B41414376422C574141572C534141533B41414370422C574141572C4F41414F3B4141436C423B414143412C59';
wwv_flow_imp.g_varchar2_table(284) := '4141592C594141593B41414378423B414143412C3045414130453B41414331452C514141512C4F41414F3B3B414145663B3B414145413B414143413B3B414145413B414143413B414143413B414143412C574141572C594141593B41414376422C574141';
wwv_flow_imp.g_varchar2_table(285) := '572C534141533B41414370422C574141572C4F41414F3B4141436C423B414143412C594141592C594141593B41414378423B414143412C2B4541412B453B4141432F452C514141512C4F41414F3B3B414145663B3B414145413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(286) := '3B414143413B414143413B414143412C574141572C534141533B41414370423B414143412C594141592C514141513B41414370423B414143413B414143412C4D41414D2C6D444141453B414143522C574141572C38444141613B41414378423B3B414145';
wwv_flow_imp.g_varchar2_table(287) := '412C4D41414D2C6D444141453B414143522C574141572C6945414167423B41414333423B3B414145412C4D41414D2C6D444141453B414143522C574141572C2B444141633B4141437A423B3B414145412C534141532C34444141573B41414370423B3B41';
wwv_flow_imp.g_varchar2_table(288) := '4145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C554141553B41414372423B414143412C614141613B414143623B414143413B414143413B414143413B414143413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(289) := '412C474141472C494141493B414143503B3B3B3B3B3B3B3B3B3B3B3B3B3B41436A7945413B414143413B414143413B414143653B3B414145663B414143413B414143413B414143413B414143413B414143413B414143413B414143412C634141632C4741';
wwv_flow_imp.g_varchar2_table(290) := '41472C454141452C4B41414B2C4B41414B2C4D41414D2C4F41414F2C4B41414B2C4D41414D2C4D41414D2C454141452C4B41414B2C4D41414D2C4D41414D3B41414339452C614141612C4B41414B2C4F41414F2C4D41414D2C454141452C4B41414B2C4F';
wwv_flow_imp.g_varchar2_table(291) := '41414F2C4F41414F2C4B41414B3B4141437A443B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C3846414138463B414143';
wwv_flow_imp.g_varchar2_table(292) := '39463B414143412C6746414167462C4B41414B2C474141472C4B41414B3B41414337462C6746414167462C4B41414B2C474141472C4B41414B3B41414337463B414143413B414143413B414143413B414143413B414143413B414143412C614141612C47';
wwv_flow_imp.g_varchar2_table(293) := '4141472C454141452C494141492C4B41414B2C4D41414D2C474141472C4B41414B2C534141532C4D41414D2C4B41414B2C4B41414B2C454141452C4D41414D2C474141472C4B41414B2C474141472C4B41414B3B41414331463B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(294) := '414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141492C474141472C4B41414B2C454141452C4D41414D2C494141492C4B41414B3B4141432F433B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(295) := '2C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141492C474141472C4B41414B2C454141452C4D41414D2C494141492C4B41414B2C474141472C4D41414D2C494141492C4B41414B2C454141452C4D41414D3B4141437A';
wwv_flow_imp.g_varchar2_table(296) := '453B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C4B41414B2C454141452C4D41414D2C474141472C4B41414B2C514141512C4D41414D2C494141492C4B41414B3B4141437A442C614141612C4B41';
wwv_flow_imp.g_varchar2_table(297) := '414B2C454141452C4D41414D2C474141472C4B41414B3B4141436C432C614141612C4B41414B2C454141452C4D41414D2C474141472C4B41414B3B4141436C432C614141612C4B41414B2C454141452C4D41414D2C474141472C4B41414B3B4141436C43';
wwv_flow_imp.g_varchar2_table(298) := '2C614141612C4B41414B2C454141452C4D41414D2C474141472C4B41414B3B4141436C432C614141612C4B41414B2C454141452C4D41414D2C474141472C4B41414B3B4141436C432C614141612C4B41414B2C454141452C4D41414D2C474141472C4B41';
wwv_flow_imp.g_varchar2_table(299) := '414B3B4141436C433B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141492C474141472C4D41414D2C454141452C4B41414B2C4D41414D2C4F41414F2C4B41414B2C4D';
wwv_flow_imp.g_varchar2_table(300) := '41414D2C4F41414F2C4B41414B2C474141472C4D41414D2C454141452C4B41414B2C474141472C4D41414D3B4141436E473B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C';
wwv_flow_imp.g_varchar2_table(301) := '4B41414B2C4B41414B2C474141472C4F41414F2C4B41414B2C474141472C4F41414F2C4B41414B2C454141452C4F41414F2C4B41414B2C474141472C4D41414D2C454141452C4B41414B2C454141452C4D41414D2C454141452C4B41414B2C474141472C';
wwv_flow_imp.g_varchar2_table(302) := '4D41414D3B41414368483B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141492C454141452C4B41414B2C4D41414D2C4F41414F2C4B41414B2C4D41414D2C4F41414F';
wwv_flow_imp.g_varchar2_table(303) := '2C4B41414B3B4141436A452C614141612C4F41414F2C4B41414B2C4F41414F2C4D41414D2C454141452C4B41414B2C4F41414F2C4D41414D2C454141452C4B41414B3B4141436A453B414143413B414143413B414143413B414143412C4B41414B3B4141';
wwv_flow_imp.g_varchar2_table(304) := '434C3B414143412C614141612C474141472C454141452C4B41414B2C4B41414B2C474141472C4D41414D2C474141472C4D41414D2C4B41414B2C4B41414B2C474141472C4F41414F2C4B41414B2C474141472C4D41414D2C474141472C4D41414D2C4541';
wwv_flow_imp.g_varchar2_table(305) := '41452C4B41414B2C474141472C4D41414D3B4141437A473B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141492C474141472C4B41414B2C474141472C4D41414D2C49';
wwv_flow_imp.g_varchar2_table(306) := '4141492C4B41414B2C454141452C4D41414D2C474141472C4B41414B2C454141452C4D41414D3B41414378453B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C634141632C474141472C454141452C494141493B';
wwv_flow_imp.g_varchar2_table(307) := '41414376422C634141632C4B41414B2C454141452C4D41414D2C494141492C4B41414B2C454141452C4D41414D3B41414335433B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C594141592C474141472C454141';
wwv_flow_imp.g_varchar2_table(308) := '452C4B41414B2C4B41414B2C474141472C4F41414F2C4B41414B2C454141452C4D41414D2C454141452C4B41414B2C454141452C4D41414D2C454141452C4B41414B3B41414378453B414143413B414143413B414143413B414143412C4B41414B3B4141';
wwv_flow_imp.g_varchar2_table(309) := '434C3B414143412C594141592C474141472C454141452C4B41414B2C4B41414B2C4D41414D2C4F41414F2C4B41414B2C4D41414D2C4D41414D2C454141452C4B41414B2C4D41414D2C4D41414D3B41414335452C574141572C4B41414B2C4F41414F2C4D';
wwv_flow_imp.g_varchar2_table(310) := '41414D2C454141452C4B41414B2C4F41414F2C4F41414F2C4B41414B3B41414376443B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C594141592C474141472C454141452C4B41414B2C4B41414B2C454141452C';
wwv_flow_imp.g_varchar2_table(311) := '4F41414F2C4B41414B2C454141452C4F41414F2C4B41414B2C494141492C4B41414B2C454141452C4D41414D3B41414378452C7342414173422C4B41414B2C454141452C4F41414F2C4B41414B2C494141492C4B41414B2C454141452C4F41414F2C4B41';
wwv_flow_imp.g_varchar2_table(312) := '414B2C454141452C4D41414D3B41414378452C7342414173422C4B41414B2C494141492C4B41414B2C454141452C4F41414F2C4B41414B2C454141452C4F41414F2C4B41414B3B41414368453B414143413B414143413B414143413B414143412C4B4141';
wwv_flow_imp.g_varchar2_table(313) := '4B3B4141434C3B414143412C594141592C474141472C454141452C494141492C474141472C4D41414D2C454141452C4B41414B2C4D41414D2C4F41414F2C4B41414B2C4D41414D2C4F41414F2C4B41414B3B4141437A452C614141612C4F41414F2C4B41';
wwv_flow_imp.g_varchar2_table(314) := '414B2C4F41414F2C4D41414D2C454141452C4B41414B2C4F41414F2C4D41414D2C454141452C4B41414B3B4141436A453B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C594141592C474141472C454141452C4B';
wwv_flow_imp.g_varchar2_table(315) := '41414B2C4B41414B2C454141452C4F41414F2C4B41414B2C454141452C4F41414F2C4B41414B2C454141452C4F41414F2C4B41414B3B41414372453B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C594141592C';
wwv_flow_imp.g_varchar2_table(316) := '474141472C454141452C494141492C474141472C4D41414D2C454141452C4B41414B2C474141472C4D41414D2C454141452C4B41414B2C454141452C4F41414F2C4B41414B2C454141452C4D41414D2C454141452C4B41414B2C4D41414D2C4D41414D3B';
wwv_flow_imp.g_varchar2_table(317) := '41414339462C554141552C4B41414B2C4D41414D2C4B41414B2C454141452C4D41414D2C474141472C4B41414B2C454141452C4F41414F2C4B41414B2C474141472C4D41414D2C474141472C4F41414F2C4B41414B2C4F41414F2C4F41414F2C4B41414B';
wwv_flow_imp.g_varchar2_table(318) := '2C454141452C4D41414D3B41414333472C554141552C4B41414B2C474141472C4D41414D2C454141452C4B41414B2C474141472C4F41414F2C4B41414B2C4F41414F2C4D41414D2C454141452C4B41414B2C494141492C4B41414B2C474141472C4D4141';
wwv_flow_imp.g_varchar2_table(319) := '4D2C454141452C4B41414B2C474141472C4D41414D3B41414370472C574141572C4B41414B2C454141452C4D41414D2C494141492C4D41414D2C454141452C4B41414B3B4141437A433B414143413B414143413B414143413B414143412C4B41414B3B41';
wwv_flow_imp.g_varchar2_table(320) := '41434C3B414143412C6742414167422C4B41414B2C494141492C4B41414B2C454141452C4D41414D2C474141472C4D41414D2C454141452C4B41414B2C4F41414F2C4F41414F2C4B41414B2C4D41414D2C4F41414F2C4B41414B3B41414333463B414143';
wwv_flow_imp.g_varchar2_table(321) := '413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C594141592C474141472C454141452C494141493B41414372423B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(322) := '43413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374422C654141652C4D41414D3B41414372422C614141612C4B41414B2C454141452C4F41414F2C4B41414B2C';
wwv_flow_imp.g_varchar2_table(323) := '454141452C514141512C4B41414B3B4141432F432C6742414167422C4D41414D3B41414374422C614141612C4B41414B2C474141472C4D41414D2C454141452C4B41414B2C474141472C4D41414D2C454141452C4B41414B3B4141436C442C614141612C';
wwv_flow_imp.g_varchar2_table(324) := '4B41414B2C454141452C4F41414F2C4B41414B2C454141452C514141512C4B41414B3B4141432F432C634141632C4B41414B2C454141452C4B41414B3B41414331422C614141612C4B41414B2C454141452C4F41414F2C4B41414B2C454141452C4F4141';
wwv_flow_imp.g_varchar2_table(325) := '4F2C4B41414B3B41414339432C634141632C4B41414B2C454141452C4B41414B3B41414331422C614141612C4B41414B2C454141452C4F41414F2C4B41414B2C454141452C514141512C4B41414B3B4141432F433B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(326) := '414143412C4B41414B3B4141434C3B414143412C614141612C474141472C474141472C494141492C6F4241416F422C4D41414D3B4141436A443B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C594141592C4741';
wwv_flow_imp.g_varchar2_table(327) := '41472C454141452C494141493B41414372423B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C594141592C474141472C454141452C494141493B41414372423B414143413B414143413B414143413B414143412C';
wwv_flow_imp.g_varchar2_table(328) := '4B41414B3B4141434C3B414143412C594141592C474141472C454141452C494141493B41414372423B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374';
wwv_flow_imp.g_varchar2_table(329) := '423B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374423B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41';
wwv_flow_imp.g_varchar2_table(330) := '414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C47';
wwv_flow_imp.g_varchar2_table(331) := '4141472C454141452C494141492C4B41414B2C4D41414D2C474141472C4B41414B2C534141532C4D41414D2C4B41414B2C4B41414B2C454141452C4D41414D2C474141472C4B41414B2C474141472C4B41414B3B41414331463B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(332) := '414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B';
wwv_flow_imp.g_varchar2_table(333) := '3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374423B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374423B4141';
wwv_flow_imp.g_varchar2_table(334) := '43412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374423B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374423B414143413B';
wwv_flow_imp.g_varchar2_table(335) := '414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374422C4B41414B3B4141434C';
wwv_flow_imp.g_varchar2_table(336) := '3B414143412C614141612C474141472C454141452C494141493B41414374423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(337) := '412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374423B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374422C4B41414B3B41';
wwv_flow_imp.g_varchar2_table(338) := '41434C3B414143412C614141612C474141472C454141452C494141493B41414374423B414143413B414143412C4B41414B3B4141434C3B414143412C614141612C474141472C454141452C494141493B41414374423B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(339) := '413B414143413B414143412C614141612C514141513B41414372423B414143412C634141632C514141513B41414374423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(340) := '414143413B414143413B414143413B414143413B414143413B414143412C614141612C514141513B41414372422C614141612C514141513B41414372423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(341) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C554141553B414143563B414143413B414143';
wwv_flow_imp.g_varchar2_table(342) := '413B414143413B414143412C554141553B414143563B414143413B414143413B414143413B414143412C634141632C514141513B41414374423B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(343) := '414143412C4D41414D3B4141434E3B414143413B414143413B3B414145412C3042414130423B41414331423B3B414145413B414143413B414143413B3B3B414147413B414143412C6743414167432C3643414136433B41414337453B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(344) := '45413B414143412C2B4241412B422C3243414132433B41414331453B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(345) := '3B414145413B414143412C6F4241416F422C4B41414B2C4B41414B3B41414339422C6D4641416D463B3B4141456E463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4741';
wwv_flow_imp.g_varchar2_table(346) := '41473B414143483B3B414145413B414143413B3B414145413B414143413B414143413B414143412C474141473B414143483B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414337646B433B3B414145633B3B41414568443B414143413B3B414145413B3B4141';
wwv_flow_imp.g_varchar2_table(347) := '45413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143412C634141632C7344414173443B41414370453B41414341';
wwv_flow_imp.g_varchar2_table(348) := '2C634141632C3243414132433B4141437A443B3B3B414147413B414143413B414143413B414143412C574141572C6F4241416F423B4141432F423B414143653B3B414145662C7142414171422C674441414D3B41414333423B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(349) := '4143413B414143412C474141472C7143414171433B3B41414578433B3B414145412C7342414173422C674441414D2C474141473B4141432F423B414143412C474141472C7343414173433B3B4141457A432C7142414171422C67454141513B4141433742';
wwv_flow_imp.g_varchar2_table(350) := '3B414143412C474141473B3B414145483B414143413B414143413B414143413B414143412C614141612C4D41414D3B4141436E422C614141612C514141513B41414372423B414143412C634141633B414143643B414143413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(351) := '414143413B414143413B414143412C4F41414F3B414143503B414143412C4B41414B3B3B4141454C3B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143412C6141';
wwv_flow_imp.g_varchar2_table(352) := '41612C4D41414D3B4141436E422C614141612C514141513B41414372423B414143412C634141633B414143643B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C3B414143413B414143';
wwv_flow_imp.g_varchar2_table(353) := '413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C614141612C514141513B41414372422C614141612C6B4241416B423B4141432F423B414143412C634141632C594141593B41414331423B4141';
wwv_flow_imp.g_varchar2_table(354) := '43413B414143412C6B4441416B443B4141436C443B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(355) := '414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143784930433B414143413B3B414145563B3B41414568432C69454141653B414143663B414143412C3042414130422C71444141593B41414374432C3042414130422C71444141593B41414374432C';
wwv_flow_imp.g_varchar2_table(356) := '7142414171422C674441414F3B41414335422C434141432C454141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41435677433B414143563B3B41414534423B414143433B41414733423B3B4141456C433B414143412C614141612C384341413843';
wwv_flow_imp.g_varchar2_table(357) := '3B41414333442C614141612C7544414175443B41414370452C614141612C6744414167443B41414337443B414143412C614141612C7143414171433B4141436C442C614141612C6D4341416D433B41414368443B3B414145413B3B3B414147413B414143';
wwv_flow_imp.g_varchar2_table(358) := '413B414143413B414143412C574141572C554141553B41414372422C574141572C6942414169423B41414335422C574141572C514141513B4141436E423B414143653B414143662C6F4241416F422C2B4341414D3B41414331423B414143412C79424141';
wwv_flow_imp.g_varchar2_table(359) := '79422C674441414F3B41414368433B3B414145413B3B414145413B414143413B414143413B414143412C7942414179422C6B45414169423B3B41414531432C6F4241416F422C38434141493B41414378423B414143412C4B41414B3B3B4141454C3B4141';
wwv_flow_imp.g_varchar2_table(360) := '43413B414143413B3B414145413B414143412C474141473B3B414145483B414143413B414143413B414143413B414143412C614141612C534141533B41414374423B414143413B414143413B414143413B414143413B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(361) := '412C7742414177422C774541416D423B41414333433B3B414145413B414143413B414143413B414143412C3042414130422C6D444141453B41414335423B414143412C2B4241412B422C6B45414169423B3B41414568443B414143412C534141533B3B41';
wwv_flow_imp.g_varchar2_table(362) := '4145543B414143413B3B414145413B414143413B414143413B3B414145412C6B4241416B422C30454141553B41414335422C6942414169422C2B4341414D3B3B41414576423B414143413B414143412C4F41414F3B3B414145503B414143412C4B41414B';
wwv_flow_imp.g_varchar2_table(363) := '3B3B4141454C3B3B414145413B414143413B3B414145413B3B414145413B414143413B414143412C4B41414B3B4141434C3B3B414145413B414143413B414143412C474141473B3B414145483B3B414145413B3B3B414147413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(364) := '3B414143413B414143413B414143412C574141572C4F41414F3B4141436C423B414143412C594141593B4141435A3B414143413B414143412C7542414175422C6B45414169423B3B41414578433B3B414145412C7143414171432C534141533B41414339';
wwv_flow_imp.g_varchar2_table(365) := '432C514141512C6D444141452C6743414167432C6D444141453B41414335433B414143413B414143413B3B414145413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143314930433B3B41414531433B414143412C614141612C3843414138433B4141';
wwv_flow_imp.g_varchar2_table(366) := '4333442C614141612C6744414167443B41414337443B3B414145413B414143413B414143413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C514141513B4141436E423B414143653B3B414145663B41414341';
wwv_flow_imp.g_varchar2_table(367) := '3B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C3B3B414145413B414143412C534141532C6D444141453B414143583B414143413B3B414145412C754341';
wwv_flow_imp.g_varchar2_table(368) := '4175433B3B41414576433B414143413B3B414145413B414143413B414143413B414143413B414143412C4F41414F3B414143503B3B414145413B414143412C7743414177432C594141593B41414370443B414143412C474141473B3B414145483B414143';
wwv_flow_imp.g_varchar2_table(369) := '413B414143413B414143412C474141473B3B414145483B3B414145413B3B3B414147413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(370) := '413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B';
wwv_flow_imp.g_varchar2_table(371) := '414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143314877433B3B4141456D433B414143643B4141436E423B';
wwv_flow_imp.g_varchar2_table(372) := '41414371423B3B4141452F443B414143412C614141612C3843414138433B41414333442C614141612C7544414175443B41414370452C614141612C6744414167443B41414337442C614141612C3644414136443B41414331452C614141612C3244414132';
wwv_flow_imp.g_varchar2_table(373) := '443B41414378453B414143412C614141612C7143414171433B4141436C442C614141612C6F4341416F433B4141436A442C614141612C6D4341416D433B41414368443B3B414145413B414143413B3B414145413B3B414145413B414143412C574141572C';
wwv_flow_imp.g_varchar2_table(374) := '514141513B4141436E422C574141572C554141553B41414372422C574141572C6942414169423B41414335422C574141572C554141553B41414372422C574141572C574141573B41414374423B414143653B414143663B414143413B414143412C454141';
wwv_flow_imp.g_varchar2_table(375) := '452C694641416B423B3B41414570423B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143412C474141473B3B';
wwv_flow_imp.g_varchar2_table(376) := '3B414147483B414143413B3B414145413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143412C474141473B3B3B414147483B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(377) := '414143413B3B414145413B414143413B414143413B414143412C4B41414B3B3B3B4141474C3B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C';
wwv_flow_imp.g_varchar2_table(378) := '4B41414B3B3B3B4141474C3B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C4B41414B3B4141434C2C474141473B3B414145483B3B414145412C34444141512C3242414132422C694641416B423B3B41414572443B41414341';
wwv_flow_imp.g_varchar2_table(379) := '2C574141572C4F41414F3B4141436C423B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143412C574141572C534141533B41414370423B414143';
wwv_flow_imp.g_varchar2_table(380) := '412C594141593B4141435A3B414143413B414143413B3B414145412C534141532C6D444141452C6744414167442C774541416D423B41414339453B3B414145413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E42';
wwv_flow_imp.g_varchar2_table(381) := '3B414143413B414143413B3B414145412C7542414175422C6B45414169423B3B41414578432C2B4241412B422C2B4341412B433B3B41414539453B414143413B414143413B3B414145413B414143413B414143413B3B414145412C454141452C67444141';
wwv_flow_imp.g_varchar2_table(382) := '4F3B414143543B3B414145413B414143413B414143413B414143413B414143412C574141572C4F41414F3B4141436C423B414143413B414143413B414143413B414143412C574141572C6B45414169423B3B41414535422C7743414177432C7143414171';
wwv_flow_imp.g_varchar2_table(383) := '433B3B41414537453B414143413B414143413B3B414145412C654141652C2B4341414D3B41414372423B414143412C7143414171432C514141512C4B41414B2C7342414173423B41414378453B3B414145413B414143412C3043414130432C774541416D';
wwv_flow_imp.g_varchar2_table(384) := '423B41414337442C474141473B3B414145483B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143412C474141473B3B414145483B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(385) := '412C474141473B414143483B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41437A4E6F453B4141436E423B3B4141456A443B414143412C614141612C674441416744';
wwv_flow_imp.g_varchar2_table(386) := '3B41414337442C614141612C6F4341416F433B4141436A443B414143412C614141612C7143414171433B4141436C442C614141612C6D4341416D433B41414368443B414143412C614141612C6B4441416B443B4141432F443B414143412C614141612C30';
wwv_flow_imp.g_varchar2_table(387) := '43414130433B41414376443B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C514141513B4141436E423B414143653B41414366';
wwv_flow_imp.g_varchar2_table(388) := '3B414143413B3B414145413B3B414145413B414143413B414143412C474141473B414143483B3B414145413B414143412C574141572C654141653B41414331423B414143413B414143413B414143413B414143413B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(389) := '3B3B414145413B414143413B414143413B414143413B3B414145413B414143412C474141473B3B414145483B414143413B414143413B3B414145413B414143413B414143412C474141473B414143483B3B3B414147413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(390) := '412C574141572C614141613B41414378423B414143412C594141592C6942414169423B41414337423B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B41414541';
wwv_flow_imp.g_varchar2_table(391) := '2C514141512C6D444141453B414143563B414143413B3B414145413B3B414145413B414143412C3442414134422C7343414173433B4141436C453B414143412C474141473B3B414145483B3B414145413B414143413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(392) := '413B3B414145413B414143413B414143412C474141473B3B414145483B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B414143412C4741';
wwv_flow_imp.g_varchar2_table(393) := '41473B3B414145483B414143413B3B414145413B414143412C574141572C614141613B41414378423B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(394) := '4143413B414143413B414143412C4F41414F3B414143502C4D41414D3B4141434E3B414143413B414143413B414143412C474141473B414143483B3B414145413B414143412C574141572C654141653B41414331422C574141572C614141613B41414378';
wwv_flow_imp.g_varchar2_table(395) := '423B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143412C574141572C654141653B41414331423B414143412C594141593B4141435A3B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(396) := '412C474141473B3B414145483B414143413B414143412C474141473B3B414145483B3B414145413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B3B3B414147413B3B414145413B414143412C4D41414D2C6D444141453B4141';
wwv_flow_imp.g_varchar2_table(397) := '43523B414143412C494141493B4141434A3B414143413B414143413B3B414145413B414143412C574141572C614141613B41414378423B414143412C594141593B4141435A3B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(398) := '414143413B3B414145413B414143413B414143413B414143413B3B414145412C654141652C774541414D3B3B41414572423B414143413B414143412C474141473B3B414145482C534141532C30454141513B4141436A423B3B414145413B414143412C57';
wwv_flow_imp.g_varchar2_table(399) := '4141572C654141653B41414331422C574141572C614141613B41414378423B414143412C594141593B4141435A3B414143413B414143413B3B414145413B414143412C4F41414F2C6D444141453B414143543B414143413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(400) := '4143412C4D41414D2C734441414B3B414143583B414143413B3B414145413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41437A5138443B414143573B414143463B3B414145623B4141434A3B414143553B414143453B3B4141456C';
wwv_flow_imp.g_varchar2_table(401) := '452C69454141653B414143662C6942414169422C77454141632C454141452C384541416D422C454141452C364541416B423B41414378453B414143412C6B4341416B432C364441416F423B41414374442C6743414167432C324441416B423B4141436C44';
wwv_flow_imp.g_varchar2_table(402) := '2C7343414173432C6945414177423B41414339442C7143414171432C6745414175423B41414335442C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143684269433B3B41414B68423B3B41414B593B3B41414569423B3B41415178423B3B41';
wwv_flow_imp.g_varchar2_table(403) := '414576423B3B414145413B414143413B414143413B414143412C6742414167423B41414368423B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E423B414143653B3B414145663B414143413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(404) := '45413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B414143413B3B414145413B3B414145413B3B414145412C4D41414D2C7744';
wwv_flow_imp.g_varchar2_table(405) := '41414F3B414143623B414143413B3B414145412C4D41414D2C6D444141453B414143522C634141632C67444141533B3B41414576422C494141492C674441414D3B414143563B414143413B414143413B414143412C4B41414B3B3B4141454C2C49414149';
wwv_flow_imp.g_varchar2_table(406) := '2C384341414F2C554141552C674441414D3B41414333423B414143413B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C2C494141492C534141532C734441414B3B4141436C422C634141632C67444141533B3B41414576422C';
wwv_flow_imp.g_varchar2_table(407) := '494141492C384341414F2C554141552C674441414D3B41414333423B414143413B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C2C494141492C534141532C6D444141453B3B414145662C634141632C67444141533B3B4141';
wwv_flow_imp.g_varchar2_table(408) := '4576423B414143413B3B414145412C494141492C384341414F2C554141552C674441414D3B41414333423B414143413B414143413B414143412C4B41414B3B3B4141454C2C494141492C534141532C6D444141453B414143662C634141632C6744414153';
wwv_flow_imp.g_varchar2_table(409) := '3B3B41414576422C494141492C384341414F2C554141552C674441414D3B41414333423B414143413B414143413B414143412C4B41414B3B3B4141454C2C494141492C534141532C6D444141453B3B414145662C634141632C77444141553B4141437842';
wwv_flow_imp.g_varchar2_table(410) := '2C4D41414D2C344541416B433B41414378432C514141512C634141633B41414374423B414143413B3B414145412C494141492C534141532C6D444141453B3B414145662C634141632C77444141553B41414378422C4D41414D2C3245414169433B414143';
wwv_flow_imp.g_varchar2_table(411) := '76432C514141512C634141633B41414374423B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143412C574141572C534141533B41414370422C574141572C534141533B41414370422C6141';
wwv_flow_imp.g_varchar2_table(412) := '41613B414143623B414143413B3B414145412C4D41414D2C774441414F3B414143623B414143413B3B414145412C4D41414D2C734441414B3B3B414145582C494141492C384341414F3B414143583B414143413B414143412C4B41414B3B3B4141454C3B';
wwv_flow_imp.g_varchar2_table(413) := '3B414145412C494141492C534141532C734441414B3B4141436C423B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B3B414147413B3B414145413B414143413B3B414145413B414143412C6D42';
wwv_flow_imp.g_varchar2_table(414) := '41416D422C364541416D433B41414374442C494141493B4141434A2C6D4241416D422C344541416B433B41414372443B3B414145413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436A4C6B423B3B414145583B414143413B';
wwv_flow_imp.g_varchar2_table(415) := '3B414145503B414143412C554141553B414143563B4141434F2C3843414138433B3B41414572443B414143412C554141553B414143563B4141434F2C3643414136433B3B41414570443B414143413B414143412C574141572C514141513B4141436E422C';
wwv_flow_imp.g_varchar2_table(416) := '574141572C514141513B4141436E422C574141572C514141513B4141436E422C594141593B4141435A3B4141434F3B414143502C534141532C67444141533B4141436C423B414143413B414143412C3442414134422C514141512C494141492C51414151';
wwv_flow_imp.g_varchar2_table(417) := '3B41414368443B414143412C474141473B414143483B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41432F4271443B4141434E3B3B4141452F432C69454141653B414143663B414143412C494141492C754541414D3B414143563B414143413B414143412C3642';
wwv_flow_imp.g_varchar2_table(418) := '414136422C77444141633B41414333432C434141432C454141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41435067423B3B41414571423B3B41414D5A3B3B414149653B3B4141496C423B3B414149523B3B41414568423B414143412C614141';
wwv_flow_imp.g_varchar2_table(419) := '612C3843414138433B41414333442C614141612C7544414175443B41414370452C614141612C6744414167443B41414337443B414143412C614141612C7544414175443B41414370452C614141612C7743414177433B41414372443B414143412C614141';
wwv_flow_imp.g_varchar2_table(420) := '612C6B4341416B433B4141432F432C614141612C6743414167433B41414337432C614141612C6743414167433B41414337432C614141612C7143414171433B4141436C442C614141612C2B4241412B423B41414335432C614141612C7743414177433B41';
wwv_flow_imp.g_varchar2_table(421) := '414372443B3B414145413B414143412C574141572C654141653B41414331422C574141572C654141653B41414331422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B414143413B414143412C534141532C674441414D3B';
wwv_flow_imp.g_varchar2_table(422) := '414143663B414143413B414143413B414143413B414143412C474141473B414143483B3B414145413B3B414145413B3B414145413B414143412C614141612C774541414D2C554141552C774541414D3B4141436E433B3B414145413B414143412C614141';
wwv_flow_imp.g_varchar2_table(423) := '613B414143622C474141473B414143483B3B414145413B414143413B414143412C6742414167422C73444141652C6742414167422C6942414169422C73444141652C594141592C494141492C574141573B41414331473B414143413B3B3B414147413B41';
wwv_flow_imp.g_varchar2_table(424) := '4143413B414143413B414143412C574141572C554141553B41414372422C574141572C514141513B4141436E422C574141572C6742414167423B41414333422C574141572C6942414169423B41414335422C574141572C634141633B4141437A423B4141';
wwv_flow_imp.g_varchar2_table(425) := '43653B414143663B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(426) := '413B414143412C574141572C654141653B41414331422C574141572C654141653B41414331422C574141572C4F41414F3B4141436C423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(427) := '413B414143413B414143412C4D41414D2C6D444141453B3B414145522C6742414167422C6D444141453B4141436C422C554141553B414143563B3B414145413B414143413B3B414145413B414143413B3B414145413B414143412C574141572C6D444141';
wwv_flow_imp.g_varchar2_table(428) := '453B3B414145622C7142414171422C77444141553B4141432F423B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C2C51414151';
wwv_flow_imp.g_varchar2_table(429) := '2C6D444141453B414143563B414143413B3B414145413B414143412C514141512C6D444141453B414143563B414143413B3B414145412C514141512C6D444141453B3B414145563B414143412C3443414134432C774541414D3B4141436C443B41414341';
wwv_flow_imp.g_varchar2_table(430) := '3B414143413B3B414145413B414143413B3B414145413B414143412C574141572C6D444141453B3B414145623B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C2C5141';
wwv_flow_imp.g_varchar2_table(431) := '41512C6D444141453B3B414145562C2B4241412B423B4141432F423B414143413B414143413B414143413B414143413B3B414145413B414143412C494141493B4141434A3B414143412C7142414171422C73444141652C4F41414F2C654141652C734441';
wwv_flow_imp.g_varchar2_table(432) := '41652C594141593B41414372463B414143413B3B414145413B414143412C4D41414D2C67454141652C634141632C79444141513B41414333433B414143413B3B414145412C3643414136432C6B4241416B423B3B4141452F443B414143413B3B3B414147';
wwv_flow_imp.g_varchar2_table(433) := '413B414143413B414143413B414143412C574141572C654141653B41414331422C574141572C4F41414F3B4141436C423B414143413B414143413B3B414145413B414143413B414143412C6B4241416B422C73444141652C6F4241416F423B4141437244';
wwv_flow_imp.g_varchar2_table(434) := '3B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B3B414147413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(435) := '43412C574141572C654141653B41414331422C574141572C654141653B41414331422C574141572C534141533B41414370423B414143412C594141593B4141435A3B414143413B414143413B414143413B414143413B3B414145412C574141572C754541';
wwv_flow_imp.g_varchar2_table(436) := '4173423B3B4141456A432C534141532C79444141513B3B4141456A423B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C2B4241412B422C79444141513B41414376433B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(437) := '414143413B414143412C474141473B3B414145483B414143413B3B414145413B414143413B414143413B414143412C574141572C654141653B41414331422C574141572C7142414171423B41414368433B414143412C594141593B4141435A3B41414341';
wwv_flow_imp.g_varchar2_table(438) := '3B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(439) := '4143413B414143412C494141493B4141434A3B414143412C554141552C73444141652C594141592C494141492C4F41414F3B41414368443B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B3B';
wwv_flow_imp.g_varchar2_table(440) := '414147413B414143413B414143413B3B3B414147413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143412C534141532C6D444141453B414143583B3B3B3B3B3B3B3B3B3B';
wwv_flow_imp.g_varchar2_table(441) := '3B3B3B3B3B3B3B3B414374576B423B3B414149463B3B4141496D423B3B4141456E433B414143412C614141612C7743414177433B41414372443B3B414145413B414143413B414143413B414143412C574141572C654141653B41414331422C574141572C';
wwv_flow_imp.g_varchar2_table(442) := '514141513B4141436E423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143412C574141572C654141653B41414331423B414143412C594141593B4141435A3B41';
wwv_flow_imp.g_varchar2_table(443) := '4143413B414143412C534141532C38434141493B414143623B414143412C474141473B414143483B3B414145413B414143412C574141572C6744414167443B41414333443B414143653B3B414145663B414143413B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(444) := '3B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(445) := '4143412C3642414136422C73444141652C574141573B41414376443B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B3B414145413B414143412C4D';
wwv_flow_imp.g_varchar2_table(446) := '41414D3B4141434E2C6743414167432C6742414167423B3B41414568442C7943414179432C73444141652C574141573B4141436E453B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(447) := '43413B414143413B414143412C2B4341412B432C73444141652C654141653B41414337452C594141593B4141435A3B414143412C514141513B414143523B3B414145412C514141512C3045414169423B4141437A423B414143412C4D41414D3B4141434E';
wwv_flow_imp.g_varchar2_table(448) := '3B414143412C7943414179432C73444141652C4D41414D3B41414339442C554141553B414143563B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145412C494141492C694441414F3B414143583B3B';
wwv_flow_imp.g_varchar2_table(449) := '414145413B414143413B414143413B3B3B414147413B3B414145413B414143413B414143413B414143412C614141612C654141653B41414335422C614141612C654141653B41414335423B414143412C634141632C4F41414F3B41414372423B41414341';
wwv_flow_imp.g_varchar2_table(450) := '3B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B3B414147413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(451) := '414143412C7942414179422C73444141652C574141573B4141436E443B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143412C514141513B3B414145523B414143412C6744414167442C';
wwv_flow_imp.g_varchar2_table(452) := '73444141652C554141552C4D41414D2C73444141652C654141653B41414337473B3B414145413B414143413B414143413B414143413B414143413B3B3B414147413B3B414145413B414143413B414143412C4D41414D3B4141434E3B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(453) := '43413B414143412C4D41414D3B4141434E3B414143412C7743414177432C73444141652C534141532C4B41414B2C73444141652C654141653B4141436E473B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145';
wwv_flow_imp.g_varchar2_table(454) := '413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143412C6F4241416F422C';
wwv_flow_imp.g_varchar2_table(455) := '674441414D3B41414331423B414143412C4B41414B3B3B4141454C3B414143413B3B414145413B414143413B414143413B3B414145413B414143412C494141492C694441414F3B414143583B3B414145413B414143413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(456) := '43413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145412C494141492C694441414F3B414143583B414143413B414143413B414143412C';
wwv_flow_imp.g_varchar2_table(457) := '534141533B414143542C514141513B414143523B414143413B414143412C4B41414B3B4141434C3B3B414145413B3B414145413B414143413B414143413B3B414145412C494141492C694441414F3B414143582C494141492C694441414F3B414143583B';
wwv_flow_imp.g_varchar2_table(458) := '3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(459) := '414143413B414143412C4D41414D2C694441414F3B414143622C4D41414D2C694441414F3B414143622C4B41414B3B4141434C3B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145';
wwv_flow_imp.g_varchar2_table(460) := '413B3B414145413B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C3B3B414145413B414143412C494141492C694441414F3B414143583B3B414145413B414143412C494141492C694441414F3B414143583B3B414145413B41';
wwv_flow_imp.g_varchar2_table(461) := '4143413B3B414145413B414143413B414143413B414143413B3B414145413B414143412C494141492C694441414F3B414143583B414143413B414143413B414143412C534141533B414143542C514141513B414143523B414143413B414143412C534141';
wwv_flow_imp.g_varchar2_table(462) := '533B414143542C514141513B414143523B414143412C514141513B3B414145523B414143412C514141513B414143523B414143412C514141513B414143523B414143412C514141513B414143523B414143412C7543414175432C73444141652C67424141';
wwv_flow_imp.g_varchar2_table(463) := '67422C634141632C73444141652C7143414171433B41414378493B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B3B414145413B414143413B3B414145413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(464) := '4143413B3B414145413B3B414145412C494141492C694441414F3B3B414145583B3B414145413B414143413B414143413B414143412C4B41414B3B4141434C3B3B3B414147413B3B414145413B414143412C494141492C694441414F3B414143583B3B41';
wwv_flow_imp.g_varchar2_table(465) := '4145413B414143413B414143413B414143412C4B41414B3B4141434C3B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414368636B423B3B41414534423B3B414145503B3B3B41414776433B414143412C614141612C7743414177433B41414372';
wwv_flow_imp.g_varchar2_table(466) := '443B414143413B414143413B414143412C4F41414F3B414143503B414143412C614141612C6943414169433B41414339433B3B414145413B414143413B414143413B414143413B414143413B414143412C574141572C654141653B41414331422C574141';
wwv_flow_imp.g_varchar2_table(467) := '572C654141653B41414331422C574141572C654141653B41414331423B414143413B414143412C594141593B4141435A3B4141434F3B3B414145503B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(468) := '413B414143412C614141612C654141653B41414335422C614141612C654141653B41414335423B414143413B3B414145413B3B414145413B414143413B414143412C4F41414F3B3B414145503B414143413B414143412C4F41414F3B3B414145503B4141';
wwv_flow_imp.g_varchar2_table(469) := '43412C7742414177422C6F4341416F433B41414335443B414143413B3B414145412C7142414171422C75444141633B3B3B4141476E433B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143412C494141492C6944';
wwv_flow_imp.g_varchar2_table(470) := '41414F3B414143583B414143412C4B41414B3B3B4141454C3B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145412C3643414136432C';
wwv_flow_imp.g_varchar2_table(471) := '3042414130423B3B41414576453B3B414145413B414143413B414143413B414143412C4F41414F3B3B414145502C7542414175422C6F4241416F423B41414333432C4D41414D3B3B4141454E3B414143413B414143413B414143412C474141473B414143';
wwv_flow_imp.g_varchar2_table(472) := '483B3B414145413B414143413B414143413B414143413B414143412C574141572C654141653B41414331422C574141572C654141653B41414331423B414143412C594141593B4141435A3B414143413B414143413B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(473) := '3B414143413B3B414145412C4F41414F2C6D444141452C6B4341416B432C6D444141453B41414337433B414143413B3B414145413B414143413B414143413B3B414145412C4D41414D2C6D444141453B414143523B414143412C494141493B4141434A2C';
wwv_flow_imp.g_varchar2_table(474) := '6F4241416F422C38434141493B41414378422C574141572C6D444141453B414143623B414143413B3B414145412C614141612C38434141493B4141436A423B414143412C4F41414F3B414143502C4B41414B3B4141434C3B3B414145413B3B414145413B';
wwv_flow_imp.g_varchar2_table(475) := '414143413B414143412C6D4241416D422C36434141473B41414374423B414143412C4B41414B3B3B4141454C3B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145412C454141452C694441414F3B3B414145543B';
wwv_flow_imp.g_varchar2_table(476) := '414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B3B3B414147483B414143413B3B414145413B414143413B3B414145412C454141452C69444141';
wwv_flow_imp.g_varchar2_table(477) := '4F3B414143543B414143413B414143413B3B414145413B3B414145413B414143412C474141473B3B414145483B414143413B3B414145413B414143413B3B414145413B414143412C514141512C6D444141453B414143563B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(478) := '4143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143374E4F3B414143503B414143413B414143413B3B414145413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41434E73443B3B4141455A3B3B41414531432C69454141653B414143663B';
wwv_flow_imp.g_varchar2_table(479) := '414143412C494141492C71454141533B414143623B414143412C3042414130422C71444141593B41414374432C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41435069423B3B4141456C423B414143412C614141612C7743414177433B41414372443B';
wwv_flow_imp.g_varchar2_table(480) := '3B3B414147413B3B414145413B3B414145413B414143413B414143413B414143412C574141572C654141653B41414331423B4141434F3B3B414145503B414143412C4F41414F2C36434141473B414143563B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(481) := '413B414143412C4B41414B3B4141434C3B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41437A4271423B3B414149483B3B4141456C423B414143412C614141612C6B4341416B433B4141432F432C614141612C7743414177433B41';
wwv_flow_imp.g_varchar2_table(482) := '414372443B3B414145413B414143412C574141572C534141533B41414370422C574141572C654141653B41414331423B414143412C594141593B4141435A3B4141434F3B3B414145502C4D41414D2C38434141453B414143523B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(483) := '2C4D41414D2C38434141453B414143522C654141652C694441414B3B3B41414570422C634141632C38434141453B41414368423B414143413B3B414145413B414143413B3B414145412C4D41414D2C38434141453B414143522C614141612C3644414169';
wwv_flow_imp.g_varchar2_table(484) := '423B41414339423B3B414145413B414143413B3B414145413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B3B414145502C4F41414F2C38434141452C6B4341416B432C38434141453B41414337';
wwv_flow_imp.g_varchar2_table(485) := '433B414143413B3B414145412C7142414171422C694441414B3B3B41414531423B414143413B414143413B3B414145413B414143413B3B414145413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F';
wwv_flow_imp.g_varchar2_table(486) := '3B414143502C6F4241416F422C3644414169423B41414372433B3B414145413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B414143502C7342414173422C3644414169423B41414376433B3B41';
wwv_flow_imp.g_varchar2_table(487) := '4145413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B4141434F3B414143502C7942414179422C3644414169423B3B41414531432C534141532C38434141493B4141';
wwv_flow_imp.g_varchar2_table(488) := '43622C574141572C38434141453B414143622C474141473B414143483B3B414145413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B414143503B414143413B3B414145413B414143412C574141';
wwv_flow_imp.g_varchar2_table(489) := '572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B414143503B414143413B3B414145413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B414143503B414143413B';
wwv_flow_imp.g_varchar2_table(490) := '3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41437A4877433B3B41414578433B414143412C614141612C6B4341416B433B4141432F432C614141612C7743414177433B41414372443B3B4141454F3B3B414145503B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(491) := '2C594141592C7542414175423B4141436E433B414143412C594141593B4141435A3B4141434F3B414143503B3B414145413B414143413B3B414145413B414143413B414143413B414143412C594141592C7542414175423B4141436E433B414143412C59';
wwv_flow_imp.g_varchar2_table(492) := '4141593B4141435A3B4141434F3B414143503B3B414145412C4D41414D2C38434141453B414143523B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E423B414143412C59';
wwv_flow_imp.g_varchar2_table(493) := '4141593B4141435A3B4141434F3B414143503B414143413B3B414145413B414143413B414143413B414143412C594141592C7542414175423B4141436E433B414143412C594141593B4141435A3B4141434F3B414143502C574141572C694441414B3B3B';
wwv_flow_imp.g_varchar2_table(494) := '41414568422C534141532C38434141453B414143583B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436E456B423B3B414145653B3B41414575423B';
wwv_flow_imp.g_varchar2_table(495) := '3B414145413B3B41414578443B414143412C614141612C3243414132433B41414378442C614141612C3043414130433B41414376443B414143412C614141612C6B4341416B433B4141432F432C614141612C7743414177433B41414372443B3B4141454F';
wwv_flow_imp.g_varchar2_table(496) := '3B414143503B414143413B414143413B3B4141454F3B3B3B414147503B414143413B414143413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B414143502C534141532C38434141453B41414358';
wwv_flow_imp.g_varchar2_table(497) := '2C534141532C38434141453B414143582C534141532C38434141453B414143582C534141532C38434141453B414143582C534141532C38434141453B414143582C534141532C38434141453B414143582C534141532C38434141453B414143582C534141';
wwv_flow_imp.g_varchar2_table(498) := '532C38434141453B414143582C534141532C38434141453B414143583B3B414145413B414143413B414143413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B414143502C534141532C73454141';
wwv_flow_imp.g_varchar2_table(499) := '4F3B41414368423B3B414145413B414143413B414143413B414143412C594141592C534141533B41414372423B414143412C594141593B4141435A3B4141434F3B3B414145503B414143413B3B414145413B414143413B3B414145413B414143413B3B41';
wwv_flow_imp.g_varchar2_table(500) := '4145413B414143413B3B414145413B414143413B3B414145413B414143413B414143412C494141493B4141434A3B414143413B3B414145412C574141573B414143583B3B3B414147413B414143413B414143413B414143412C594141592C534141533B41';
wwv_flow_imp.g_varchar2_table(501) := '414372423B414143412C594141593B4141435A3B4141434F3B3B414145503B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C534141533B41';
wwv_flow_imp.g_varchar2_table(502) := '414370423B414143412C594141593B4141435A3B4141434F3B3B414145503B414143413B414143412C494141492C534141532C38434141453B414143663B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143';
wwv_flow_imp.g_varchar2_table(503) := '413B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143412C574141572C654141653B41414331422C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B3B414145';
wwv_flow_imp.g_varchar2_table(504) := '503B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C494141493B3B4141454A3B3B414145413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(505) := '45412C534141532C674441414D3B414143663B414143413B414143412C474141473B414143483B3B414145413B414143412C574141572C654141653B41414331423B414143412C614141613B414143623B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(506) := '2C38434141453B4141434E2C494141492C38434141453B4141434E2C494141492C38434141453B4141434E2C494141492C38434141453B4141434E2C494141492C38434141453B4141434E2C494141492C38434141453B4141434E2C494141492C384341';
wwv_flow_imp.g_varchar2_table(507) := '41453B4141434E3B414143413B414143413B3B414145412C4D41414D2C38434141453B414143523B414143413B3B414145412C4D41414D2C38434141453B414143523B414143413B414143413B3B414145413B414143412C574141572C654141653B4141';
wwv_flow_imp.g_varchar2_table(508) := '4331423B414143412C614141613B414143623B414143413B414143413B3B414145413B414143413B414143413B3B3B414147413B414143413B3B414145413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B41';
wwv_flow_imp.g_varchar2_table(509) := '41434F3B414143503B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B3B3B414147413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E423B414143';
wwv_flow_imp.g_varchar2_table(510) := '412C594141593B4141435A3B4141434F3B414143503B414143413B3B414145413B3B414145413B414143413B414143412C4D41414D3B4141434E3B414143413B3B414145413B3B414145413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41';
wwv_flow_imp.g_varchar2_table(511) := '436E516B423B3B4141456C423B414143412C634141632C6D4341416D433B4141436A442C634141632C7943414179433B41414376443B3B414145413B414143413B414143413B414143412C594141592C7542414175423B4141436E432C594141592C5141';
wwv_flow_imp.g_varchar2_table(512) := '41513B41414370423B414143412C594141593B4141435A3B4141434F3B414143503B3B414145413B414143413B3B3B414147413B414143413B414143413B414143412C574141572C7542414175423B4141436C432C574141572C554141553B4141437242';
wwv_flow_imp.g_varchar2_table(513) := '3B414143412C594141593B4141435A3B4141434F3B414143502C534141532C38434141493B414143623B414143412C474141473B414143483B3B414145413B414143413B414143413B414143412C574141572C7542414175423B4141436C433B41414341';
wwv_flow_imp.g_varchar2_table(514) := '2C594141593B4141435A3B4141434F3B414143503B414143413B3B414145413B414143413B414143413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B414143503B414143413B3B3B3B3B3B3B3B';
wwv_flow_imp.g_varchar2_table(515) := '3B3B3B3B3B3B3B3B3B3B41433144413B414143413B414143413B414143413B414143413B3B41414F69423B3B3B4141476A423B414143413B3B4141454F3B3B414145413B414143503B414143413B3B4141454F3B414143503B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(516) := '414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(517) := '413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B3B';
wwv_flow_imp.g_varchar2_table(518) := '414147413B3B414145413B414143412C614141612C2B4341414D3B3B4141456E422C454141452C6F444141573B414143622C454141452C6F444141572C434141432C38434141513B41414374422C454141452C6F444141572C434141432C38434141513B';
wwv_flow_imp.g_varchar2_table(519) := '41414374422C454141452C6F444141572C434141432C38434141513B41414374422C454141452C6F444141572C434141432C38434141513B41414374423B414143413B414143412C474141473B414143483B3B4141454F3B3B414145503B414143413B3B';
wwv_flow_imp.g_varchar2_table(520) := '414145412C494141492C36434141573B414143663B414143412C4B41414B3B4141434C3B3B414145413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436C4767433B3B414145413B3B41414568433B414143412C614141612C6943414169433B';
wwv_flow_imp.g_varchar2_table(521) := '41414339432C614141612C3042414130423B41414376432C614141612C6B4341416B433B4141432F433B414143413B414143413B414143412C4B41414B2C7742414177423B41414337423B3B414145413B414143413B414143412C614141612C6D434141';
wwv_flow_imp.g_varchar2_table(522) := '6D433B41414368443B3B414145413B414143413B414143412C614141612C3642414136423B41414331433B3B414145413B414143413B414143413B414143412C574141572C7142414171423B41414368433B414143412C594141592C554141553B414143';
wwv_flow_imp.g_varchar2_table(523) := '74423B414143413B414143412C7142414171422C30434141513B3B41414537423B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143412C574141572C6742414167423B41414333423B414143412C594141593B4141';
wwv_flow_imp.g_varchar2_table(524) := '435A3B414143413B3B414145413B3B414145413B414143412C614141613B414143623B414143413B414143413B414143413B3B414145412C6743414167432C36434141553B3B41414531433B414143413B3B3B414147413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(525) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(526) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143412C7542';
wwv_flow_imp.g_varchar2_table(527) := '414175422C634141633B41414372432C494141493B4141434A3B414143413B414143413B414143413B414143412C574141572C6742414167423B41414333422C574141572C7342414173423B4141436A433B414143653B3B414145663B414143412C5941';
wwv_flow_imp.g_varchar2_table(528) := '41593B4141435A3B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C3043414130432C594141';
wwv_flow_imp.g_varchar2_table(529) := '593B41414374442C4D41414D3B4141434E3B414143413B414143412C594141593B4141435A3B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B41';
wwv_flow_imp.g_varchar2_table(530) := '41436E423B414143412C594141593B4141435A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C4D41414D3B4141436A423B414143412C594141';
wwv_flow_imp.g_varchar2_table(531) := '593B4141435A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C534141533B41414370423B414143412C594141593B4141435A3B414143413B41';
wwv_flow_imp.g_varchar2_table(532) := '4143413B414143413B414143412C634141632C6B4241416B423B41414368433B414143412C574141572C4D41414D3B4141436A423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(533) := '4143413B414143413B414143413B414143413B414143412C574141572C6F4241416F423B4141432F422C574141572C6B4241416B423B41414337422C574141572C574141573B41414374423B414143412C594141593B4141435A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(534) := '3B414143413B414143413B414143413B414143413B414143412C574141572C634141633B4141437A422C574141572C6B4241416B423B41414337422C574141572C574141573B41414374423B414143412C594141593B4141435A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(535) := '3B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436E4F6B423B3B4141456C423B414143';
wwv_flow_imp.g_varchar2_table(536) := '412C614141612C7143414171433B4141436C442C614141612C6F4341416F433B4141436A442C614141612C7943414179433B41414374443B414143412C614141612C6942414169423B41414339422C634141632C6F4441416F443B4141436C452C634141';
wwv_flow_imp.g_varchar2_table(537) := '632C6F4341416F433B4141436C443B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(538) := '413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143413B414143412C574141572C554141553B41414372423B414143653B3B414145663B414143412C594141593B4141435A3B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(539) := '3B414145413B414143413B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C514141513B4141436E422C57414157';
wwv_flow_imp.g_varchar2_table(540) := '2C7743414177433B4141436E442C574141572C534141533B41414370422C574141572C4B41414B3B41414368423B414143413B3B414145412C4D41414D2C6F444141552C554141552C6B444141513B4141436C433B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(541) := '414143413B414143413B3B414145412C4D41414D2C6F444141553B41414368423B414143413B414143413B414143413B414143413B3B414145412C4D41414D2C6B444141513B414143643B414143413B414143413B3B414145412C4F41414F2C6F444141';
wwv_flow_imp.g_varchar2_table(542) := '553B4141436A423B414143413B3B414145412C4F41414F2C694441414F3B414143643B414143413B3B414145413B3B414145412C454141452C694441414F3B3B414145543B414143412C7945414179452C574141573B3B41414570463B414143412C4741';
wwv_flow_imp.g_varchar2_table(543) := '41473B414143483B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C7743414177433B4141436E442C574141572C534141533B41414370422C574141572C';
wwv_flow_imp.g_varchar2_table(544) := '4B41414B3B41414368423B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C7743414177433B4141436E442C574141572C534141533B414143';
wwv_flow_imp.g_varchar2_table(545) := '70422C574141572C4B41414B3B41414368423B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C7743414177433B4141436E442C574141572C';
wwv_flow_imp.g_varchar2_table(546) := '534141533B41414370422C574141572C4B41414B3B41414368423B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C7743414177433B414143';
wwv_flow_imp.g_varchar2_table(547) := '6E442C574141572C534141533B41414370422C574141572C4B41414B3B41414368423B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C7743';
wwv_flow_imp.g_varchar2_table(548) := '414177433B4141436E442C574141572C534141533B41414370422C574141572C4B41414B3B41414368423B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E42';
wwv_flow_imp.g_varchar2_table(549) := '2C574141572C7743414177433B4141436E442C574141572C534141533B41414370422C574141572C4B41414B3B41414368423B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C5141';
wwv_flow_imp.g_varchar2_table(550) := '41513B4141436E422C574141572C7743414177433B4141436E442C574141572C534141533B41414370422C574141572C4B41414B3B41414368423B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E42';
wwv_flow_imp.g_varchar2_table(551) := '2C574141572C514141513B4141436E422C574141572C7743414177433B4141436E442C574141572C534141533B41414370422C574141572C4B41414B3B41414368423B414143413B3B414145413B414143413B414143413B414143412C574141572C5141';
wwv_flow_imp.g_varchar2_table(552) := '41513B4141436E422C574141572C514141513B4141436E422C574141572C7743414177433B4141436E442C574141572C534141533B41414370422C574141572C4B41414B3B41414368423B414143413B3B414145413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(553) := '3B414143412C574141572C514141513B4141436E423B414143412C614141613B414143623B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143412C594141593B4141435A3B414143412C614141612C5141';
wwv_flow_imp.g_varchar2_table(554) := '41513B41414372422C614141612C514141513B41414372422C614141612C7743414177433B41414372442C614141612C534141533B41414374422C614141612C4B41414B3B4141436C423B414143413B3B414145412C514141512C6F444141552C594141';
wwv_flow_imp.g_varchar2_table(555) := '592C6B444141513B41414374433B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414368506B423B3B414149443B3B41414B593B';
wwv_flow_imp.g_varchar2_table(556) := '3B41414B483B3B4141456F423B3B41415335423B3B41414573433B3B3B41414778443B414143412C614141612C6B4341416B433B4141432F432C614141612C3442414134423B4141437A432C614141612C2B4241412B423B41414335432C614141612C36';
wwv_flow_imp.g_varchar2_table(557) := '42414136423B41414331433B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143412C4F41414F3B414143';
wwv_flow_imp.g_varchar2_table(558) := '503B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143413B414143412C4B41414B2C534141533B414143643B414143412C614141612C7143414171433B4141436C442C614141612C3842414138423B414143';
wwv_flow_imp.g_varchar2_table(559) := '33432C614141612C7143414171433B4141436C443B414143412C614141612C6F4341416F433B4141436A442C614141612C2B4241412B423B41414335432C614141612C3842414138423B41414333432C614141612C6B4341416B433B4141432F432C6141';
wwv_flow_imp.g_varchar2_table(560) := '41612C7143414171433B4141436C443B3B414145413B414143413B414143413B3B414145413B414143412C534141532C6B444141513B4141436A423B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(561) := '43413B414143413B414143413B414143412C574141572C634141633B4141437A423B414143412C594141592C614141613B4141437A423B414143413B3B414145412C594141592C674441414D2C474141472C494141492C2B4241412B423B3B4141457844';
wwv_flow_imp.g_varchar2_table(562) := '3B3B414145413B414143413B414143413B414143413B414143413B3B414145412C454141452C6F444141573B414143623B414143413B414143413B414143413B414143412C474141473B3B414145483B3B414145413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(563) := '412C6742414167422C67444141533B4141437A422C454141452C69444141553B3B4141455A3B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B3B3B414147413B414143413B41';
wwv_flow_imp.g_varchar2_table(564) := '4143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C6D4241416D423B41414339422C574141572C554141553B41414372422C574141572C694241416942';
wwv_flow_imp.g_varchar2_table(565) := '3B41414335422C574141572C6942414169423B41414335423B414143653B414143663B414143413B414143413B3B414145413B414143412C594141593B4141435A3B414143413B3B414145413B414143412C594141593B4141435A3B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(566) := '45413B414143412C594141593B4141435A3B414143413B3B414145413B414143412C594141593B4141435A3B414143413B3B414145412C7942414179423B4141437A423B3B414145413B414143413B414143413B414143413B414143413B414143413B3B';
wwv_flow_imp.g_varchar2_table(567) := '414145413B414143413B414143413B414143413B3B414145413B3B414145412C3643414136432C634141632C574141572C654141653B41414372463B414143413B414143413B414143413B414143413B414143412C574141572C634141633B4141437A42';
wwv_flow_imp.g_varchar2_table(568) := '3B414143413B3B414145413B3B414145413B414143413B3B414145412C3042414130422C67444141533B4141436E432C454141452C384341414F2C514141512C2B4241412B423B3B41414568442C454141452C67444141533B3B414145583B3B41414541';
wwv_flow_imp.g_varchar2_table(569) := '3B414143413B414143413B414143412C3242414132422C6B444141512C434141432C38434141493B41414378433B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C634141633B4141';
wwv_flow_imp.g_varchar2_table(570) := '43642C6B4241416B422C594141593B41414339422C6B4241416B422C594141593B41414339423B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C2C474141473B3B414145483B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(571) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B3B414145483B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C474141473B3B414145483B3B414145413B';
wwv_flow_imp.g_varchar2_table(572) := '414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143412C6942414169422C754441414F3B3B41414578423B414143413B41';
wwv_flow_imp.g_varchar2_table(573) := '4143412C4D41414D3B4141434E3B414143413B414143412C474141473B3B414145483B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C594141592C614141613B414143';
wwv_flow_imp.g_varchar2_table(574) := '7A423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B';
wwv_flow_imp.g_varchar2_table(575) := '4141436E423B414143412C594141592C594141593B41414378423B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(576) := '413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E423B414143412C594141593B4141435A3B414143413B414143412C534141532C674441414D3B414143663B';
wwv_flow_imp.g_varchar2_table(577) := '414143413B414143413B3B414145413B414143412C474141473B414143483B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B41';
wwv_flow_imp.g_varchar2_table(578) := '4143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C574141572C514141513B4141436E423B414143412C';
wwv_flow_imp.g_varchar2_table(579) := '594141592C594141593B41414378423B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B4141';
wwv_flow_imp.g_varchar2_table(580) := '45413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E423B414143412C594141592C594141593B41414378423B414143413B3B414145413B414143413B414143413B3B';
wwv_flow_imp.g_varchar2_table(581) := '414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145412C454141452C67444141533B3B414145583B3B414145413B414143413B3B3B414147413B3B414145413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(582) := '3B3B414145412C494141492C67444141533B414143623B414143413B3B414145413B414143413B414143413B414143412C594141592C6B4241416B423B41414339423B414143413B414143413B3B414145413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(583) := '4143413B3B3B414147413B414143413B414143413B414143412C574141572C6943414169433B41414335433B414143412C594141592C6F4241416F423B41414368433B414143413B414143413B414143413B414143413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(584) := '43413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C594141592C634141633B41414331423B414143413B414143413B414143413B414143412C474141473B414143483B3B4141';
wwv_flow_imp.g_varchar2_table(585) := '45413B414143412C534141532C38434141493B414143623B414143412C474141473B414143483B3B3B414147413B414143413B414143413B414143413B414143412C594141592C614141613B4141437A423B414143413B414143413B414143413B3B3B41';
wwv_flow_imp.g_varchar2_table(586) := '4147413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145412C454141452C694441414F3B414143543B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(587) := '413B414143412C514141512C69444141553B4141436C422C514141513B414143523B414143412C514141512C69444141553B4141436C423B414143413B414143412C474141473B3B414145483B414143413B414143413B414143413B414143412C594141';
wwv_flow_imp.g_varchar2_table(588) := '593B4141435A2C6742414167422C534141533B4141437A422C6742414167422C594141593B41414335422C6742414167422C514141513B41414378422C6742414167422C534141533B4141437A423B414143412C6944414169442C6B4541416B453B4141';
wwv_flow_imp.g_varchar2_table(589) := '436E483B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141573B414143583B414143413B414143412C57414157';
wwv_flow_imp.g_varchar2_table(590) := '2C6943414169433B41414335432C574141572C514141513B4141436E423B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C6943414169433B41414335432C';
wwv_flow_imp.g_varchar2_table(591) := '574141572C514141513B4141436E423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C6943414169433B41414335432C574141572C514141513B4141436E423B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(592) := '3B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C6943414169433B41414335432C574141572C514141513B414143';
wwv_flow_imp.g_varchar2_table(593) := '6E423B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(594) := '4143413B414143413B414143412C594141592C554141553B41414374423B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C574141572C5541';
wwv_flow_imp.g_varchar2_table(595) := '41553B41414372423B414143412C594141592C554141553B41414374423B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B3B414145413B';
wwv_flow_imp.g_varchar2_table(596) := '3B414145413B3B414145413B414143413B414143413B414143412C474141473B3B414145483B414143413B3B414145413B414143413B414143413B414143412C574141572C6942414169423B41414335423B414143412C594141592C6F4241416F423B41';
wwv_flow_imp.g_varchar2_table(597) := '414368433B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C474141473B3B414145';
wwv_flow_imp.g_varchar2_table(598) := '483B414143413B414143413B414143413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B414143412C574141572C554141553B41414372423B414143412C594141592C554141553B41414374423B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(599) := '45413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B3B3B414147413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(600) := '413B414143412C6943414169432C6B4241416B423B4141436E442C6B4341416B432C6B4241416B423B3B41414570443B414143413B3B3B414147413B414143413B414143413B3B414145413B414143412C3842414138422C6B4241416B423B3B41414568';
wwv_flow_imp.g_varchar2_table(601) := '443B3B414145412C6743414167432C3442414134423B41414335443B3B3B414147413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(602) := '413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145412C6F4341416F432C7342414173423B41414331443B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B41';
wwv_flow_imp.g_varchar2_table(603) := '4145412C6742414167422C2B4341414B3B41414372423B414143412C474141473B3B414145483B414143413B414143412C7142414171422C6D4341416D433B41414378443B414143413B3B414145413B414143412C454141452C73444141613B41414366';
wwv_flow_imp.g_varchar2_table(604) := '3B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C514141512C4B41414B3B414143622C514141512C4B41414B3B414143623B414143413B414143413B414143412C574141';
wwv_flow_imp.g_varchar2_table(605) := '572C514141513B4141436E422C574141572C3042414130423B41414372432C574141572C574141573B41414374422C574141572C514141513B4141436E423B414143412C594141592C3042414130423B41414374433B414143413B3B414145413B3B4141';
wwv_flow_imp.g_varchar2_table(606) := '45413B414143413B3B414145413B3B414145412C6943414169432C6B4341416B433B3B4141456E453B3B414145413B414143413B3B414145413B3B414145413B414143413B3B414145412C6D4341416D432C3442414134423B3B4141452F443B41414341';
wwv_flow_imp.g_varchar2_table(607) := '3B3B414145413B414143413B414143413B414143412C574141572C574141573B41414374422C574141572C594141593B41414376422C574141572C514141513B4141436E423B414143412C594141592C574141573B41414376423B414143413B41414341';
wwv_flow_imp.g_varchar2_table(608) := '3B414143413B3B414145413B414143413B414143413B414143412C574141572C6742414167423B41414333422C574141572C594141593B41414376422C574141572C514141513B4141436E423B414143412C594141592C6742414167423B41414335423B';
wwv_flow_imp.g_varchar2_table(609) := '414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145412C6F4341416F432C6B4241416B42';
wwv_flow_imp.g_varchar2_table(610) := '3B3B41414574443B3B414145413B414143412C454141452C7944414167423B4141436C423B3B414145412C7143414171432C6B4241416B423B3B41414576443B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(611) := '413B414143413B414143412C574141572C6B4241416B423B41414337423B414143412C594141592C574141573B41414376423B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C594141593B414143';
wwv_flow_imp.g_varchar2_table(612) := '5A2C6742414167422C574141573B41414333422C6742414167422C594141593B41414335423B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C594141593B4141435A2C6742414167422C574141573B41414333';
wwv_flow_imp.g_varchar2_table(613) := '422C6742414167422C594141593B41414335423B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C7542414175423B4141436C433B414143412C594141592C6742414167';
wwv_flow_imp.g_varchar2_table(614) := '423B41414335423B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C594141593B4141435A2C6742414167422C6742414167423B41414368432C6742414167422C594141593B41414335423B3B4141';
wwv_flow_imp.g_varchar2_table(615) := '45413B414143413B414143413B414143413B414143413B414143413B414143412C594141593B4141435A2C6742414167422C6742414167423B41414368432C6742414167422C594141593B41414335423B414143413B414143413B3B3B414147413B4141';
wwv_flow_imp.g_varchar2_table(616) := '43413B414143413B414143412C574141572C6943414169433B41414335432C574141572C534141533B41414370423B414143412C594141592C594141593B41414378423B414143413B414143413B414143413B3B3B414147413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(617) := '414143412C574141572C554141553B41414372423B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145412C6B4341416B433B4141436C433B414143413B414143413B3B41';
wwv_flow_imp.g_varchar2_table(618) := '4145413B414143412C6B4441416B442C7942414179423B41414333453B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C6F4241416F422C7943414179433B';
wwv_flow_imp.g_varchar2_table(619) := '41414337443B414143413B414143413B414143413B414143412C7143414171433B41414372433B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(620) := '4143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143412C574141572C4D41414D3B4141436A423B414143412C594141592C654141653B41414333423B41414341';
wwv_flow_imp.g_varchar2_table(621) := '3B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145412C674241';
wwv_flow_imp.g_varchar2_table(622) := '4167422C6D444141593B41414335422C3443414134432C73444141593B41414378443B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(623) := '413B414143412C4F41414F3B414143503B414143413B3B414145413B414143412C494141493B3B4141454A3B414143413B3B414145413B414143413B414143413B3B414145412C4D41414D2C6D444141593B4141436C422C4B41414B3B4141434C3B3B41';
wwv_flow_imp.g_varchar2_table(624) := '4145413B414143413B3B3B414147413B414143413B414143413B414143412C574141572C614141613B41414378423B414143412C594141593B4141435A3B414143413B3B414145413B414143413B3B414145413B414143413B414143412C634141632C67';
wwv_flow_imp.g_varchar2_table(625) := '4441414D2C474141472C634141632C614141613B3B4141456C443B3B414145413B414143412C4B41414B3B4141434C3B3B414145412C574141573B414143583B3B414145413B414143413B414143413B414143413B414143412C574141572C6943414169';
wwv_flow_imp.g_varchar2_table(626) := '433B41414335432C574141572C6942414169423B41414335423B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(627) := '3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145412C7742414177422C75444141633B41414374432C7342414173422C304441414D3B';
wwv_flow_imp.g_varchar2_table(628) := '41414335423B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145412C7342414173422C304441414D3B3B41414535423B3B414145413B3B414145413B414143413B414143413B3B414145412C49414149';
wwv_flow_imp.g_varchar2_table(629) := '3B3B4141454A3B414143413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145412C6742414167422C6743414167433B41414368443B3B414145413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(630) := '3B414143412C574141572C7542414175423B4141436C433B414143412C574141572C4F41414F2C2B4241412B422C6742414167423B4141436A453B414143412C594141592C514141513B41414370423B414143413B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(631) := '3B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143412C474141473B3B414145483B414143413B3B41';
wwv_flow_imp.g_varchar2_table(632) := '4145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(633) := '43413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B3B4141454A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145';
wwv_flow_imp.g_varchar2_table(634) := '413B414143413B3B3B414147413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143412C6B4241416B422C674441414D3B3B41';
wwv_flow_imp.g_varchar2_table(635) := '414578423B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143412C494141493B4141434A3B414143413B3B414145413B3B414145413B414143413B3B3B414147413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(636) := '2C594141592C594141593B41414378423B414143413B414143413B414143413B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C3042414130423B41414372';
wwv_flow_imp.g_varchar2_table(637) := '433B414143412C594141592C4D41414D3B4141436C423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(638) := '413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B3B3B';
wwv_flow_imp.g_varchar2_table(639) := '3B3B3B3B3B3B3B3B3B3B3B3B3B41437A2B436B423B3B41414567423B3B4141456C433B414143412C614141612C6B4341416B433B4141432F432C614141612C7143414171433B4141436C442C614141612C6743414167433B41414337432C614141612C2B';
wwv_flow_imp.g_varchar2_table(640) := '4241412B423B41414335432C614141612C6743414167433B41414337433B3B414145413B414143413B414143413B414143412C634141632C594141593B41414331422C634141632C4F41414F3B41414372422C634141632C4D41414D3B41414370422C63';
wwv_flow_imp.g_varchar2_table(641) := '4141632C4F41414F3B41414372423B414143653B414143663B414143413B3B414145413B414143413B414143413B414143412C574141572C654141653B41414331423B414143412C594141592C474141473B414143663B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(642) := '413B3B414145413B414143413B414143413B414143412C574141572C6742414167423B41414333423B414143412C594141592C474141473B414143663B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141';
wwv_flow_imp.g_varchar2_table(643) := '572C6742414167423B41414333423B414143412C594141592C474141473B414143663B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C7142414171423B41414368433B414143412C594141592C47';
wwv_flow_imp.g_varchar2_table(644) := '4141473B414143663B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C654141653B41414331422C594141593B4141435A3B414143413B414143';
wwv_flow_imp.g_varchar2_table(645) := '413B414143413B414143413B414143412C574141572C534141533B41414370422C574141572C6742414167423B41414333422C594141593B4141435A3B414143413B414143413B414143413B414143413B414143412C574141572C634141633B4141437A';
wwv_flow_imp.g_varchar2_table(646) := '422C574141572C7142414171423B41414368432C594141593B4141435A3B414143413B414143413B414143413B414143412C574141572C534141533B41414370422C574141572C6742414167423B41414333422C594141593B4141435A3B414143413B3B';
wwv_flow_imp.g_varchar2_table(647) := '414145412C554141552C674441414D2C474141472C614141613B3B41414568433B414143413B414143413B3B414145412C534141532C384341414D3B414143663B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41433947413B3B41414532433B3B41414533433B41';
wwv_flow_imp.g_varchar2_table(648) := '4143412C614141612C2B4241412B423B41414335433B414143412C614141612C3842414138423B41414333433B414143412C634141632C7944414179443B41414376452C634141632C6944414169443B4141432F443B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(649) := '413B414143413B414143413B414143413B414143412C574141572C554141553B41414372423B414143653B3B414145663B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(650) := '414143413B3B414145413B3B414145413B414143413B414143413B414143412C574141572C614141613B41414378422C574141572C594141593B41414376422C574141572C594141593B41414376423B414143413B3B414145413B3B414145413B3B4141';
wwv_flow_imp.g_varchar2_table(651) := '45413B414143412C454141452C384341414F3B3B414145543B414143412C494141492C384341414F3B414143583B3B414145412C7942414179423B4141437A423B3B414145413B414143413B414143413B414143412C574141572C6F4241416F423B4141';
wwv_flow_imp.g_varchar2_table(652) := '432F423B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143412C494141492C384341414F3B3B414145583B414143412C4D41414D2C384341414F3B414143623B3B414145413B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(653) := '3B414143413B414143413B414143412C574141572C6F4241416F423B4141432F422C574141572C514141513B4141436E423B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C4741';
wwv_flow_imp.g_varchar2_table(654) := '41473B3B414145483B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C574141572C6F4241416F423B4141432F422C574141572C594141593B41414376422C574141572C534141';
wwv_flow_imp.g_varchar2_table(655) := '533B41414370423B414143413B414143413B3B414145413B3B414145413B414143413B414143412C494141493B4141434A3B414143413B3B414145413B414143412C494141492C384341414F3B414143583B3B414145413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(656) := '4143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C6D4241416D423B41414339423B414143412C594141592C7542414175423B4141436E433B414143413B';
wwv_flow_imp.g_varchar2_table(657) := '414143413B3B414145413B414143413B414143412C494141493B4141434A2C6D4241416D422C384341414F3B41414331423B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C2B4241412B423B41';
wwv_flow_imp.g_varchar2_table(658) := '414331433B414143412C594141592C654141653B41414333423B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143412C474141473B3B414145483B414143413B3B414145413B414143413B414143413B414143412C';
wwv_flow_imp.g_varchar2_table(659) := '574141572C2B4241412B423B41414331433B414143412C594141592C7542414175423B4141436E433B414143413B414143413B414143413B3B414145412C6B4241416B422C6942414169423B4141436E433B414143413B414143413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(660) := '45413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C594141592C654141653B41414333423B414143413B414143412C6D4341416D432C574141573B41414339433B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(661) := '4143413B414143412C574141572C6743414167433B41414333433B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143412C474141473B414143483B3B414145413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(662) := '3B414143413B414143413B414143413B414143413B414143412C3643414136433B41414337433B414143412C6D4441416D443B4141436E443B414143413B414143412C574141572C6F4241416F423B4141432F422C574141572C534141533B4141437042';
wwv_flow_imp.g_varchar2_table(663) := '3B414143412C594141592C594141593B41414378423B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E423B414143412C594141592C4F41414F3B';
wwv_flow_imp.g_varchar2_table(664) := '4141436E423B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41432F516B423B3B4141456C423B3B414145413B3B414145413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(665) := '4143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B3B414145413B414143413B414143413B414143412C634141632C6F4341416F433B4141436C443B3B414145413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(666) := '4143413B414143412C4F41414F3B414143503B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C2B4241412B422C6D4241416D422C4B41414B3B41414376442C6F4341416F';
wwv_flow_imp.g_varchar2_table(667) := '432C6F4241416F423B41414378442C6945414169453B4141436A453B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C6942414169423B4141436A423B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(668) := '3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(669) := '3B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(670) := '3B414143413B414143412C6B4441416B442C6F4241416F423B41414374453B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(671) := '3B4141434A3B414143413B414143413B414143412C7142414171423B41414372423B414143413B414143413B414143413B414143653B3B414145663B414143412C614141613B414143623B414143413B3B414145413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(672) := '3B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C3642414136422C6F4241416F423B4141436A443B414143413B414143413B414143412C3442414134422C3442414134423B41414378443B414143413B414143';
wwv_flow_imp.g_varchar2_table(673) := '413B414143413B414143413B414143412C574141572C6942414169423B41414335422C574141572C514141513B4141436E422C574141572C3042414130423B41414372432C574141572C4B41414B3B41414368423B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(674) := '414143413B414143412C3642414136422C6F4241416F423B4141436A443B414143413B414143413B414143412C3442414134422C3442414134423B41414378443B414143413B414143413B414143412C634141632C6742414167423B41414339423B4141';
wwv_flow_imp.g_varchar2_table(675) := '43412C574141572C574141573B41414374422C574141572C514141513B4141436E422C574141572C3443414134433B41414376442C574141572C4B41414B3B41414368423B414143413B3B414145412C574141572C694441414F3B3B4141456C422C4D41';
wwv_flow_imp.g_varchar2_table(676) := '414D2C6F444141553B41414368423B414143413B414143413B414143413B3B414145412C4F41414F2C6B444141513B414143663B414143413B3B414145413B3B414145413B414143412C7142414171422C38434141493B3B4141457A423B414143412C34';
wwv_flow_imp.g_varchar2_table(677) := '42414134422C594141593B41414378433B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143412C4B41414B3B4141434C2C474141473B414143483B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(678) := '414143413B414143413B414143413B414143413B414143412C574141572C6942414169423B41414335422C574141572C514141513B4141436E422C574141572C3042414130423B41414372432C574141572C4B41414B3B41414368423B414143413B4141';
wwv_flow_imp.g_varchar2_table(679) := '43413B414143413B414143412C634141632C6742414167423B41414339423B414143412C574141572C574141573B41414374422C574141572C514141513B4141436E422C574141572C3443414134433B41414376442C574141572C4B41414B3B41414368';
wwv_flow_imp.g_varchar2_table(680) := '423B414143413B414143413B3B414145412C4D41414D2C6F444141553B41414368423B414143413B414143413B414143413B3B414145412C4F41414F2C6B444141513B414143663B414143413B3B414145413B414143413B3B414145413B3B414145413B';
wwv_flow_imp.g_varchar2_table(681) := '3B414145413B414143413B3B414145413B414143412C3042414130422C594141593B41414374433B414143413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143412C574141572C6942414169423B';
wwv_flow_imp.g_varchar2_table(682) := '41414335422C574141572C7542414175423B4141436C433B414143413B3B414145412C574141572C694441414F3B3B4141456C423B3B414145413B414143413B414143412C474141473B3B414145483B3B3B414147413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(683) := '412C574141572C514141513B4141436E423B414143412C594141592C4F41414F3B4141436E423B414143413B414143413B3B414145413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(684) := '43413B414143413B414143413B414143413B414143412C6942414169423B4141436A423B414143413B414143413B414143412C6942414169423B4141436A423B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41';
wwv_flow_imp.g_varchar2_table(685) := '4143412C6942414169422C614141613B41414339423B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143412C594141592C4B41414B3B4141436A42';
wwv_flow_imp.g_varchar2_table(686) := '3B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(687) := '413B414143413B3B414145413B414143413B414143412C494141493B4141434A3B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143412C494141';
wwv_flow_imp.g_varchar2_table(688) := '493B3B4141454A3B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C574141572C4F41414F3B4141436C';
wwv_flow_imp.g_varchar2_table(689) := '423B414143412C594141592C534141533B41414372423B414143413B414143412C3842414138422C634141633B41414335433B3B3B414147413B414143413B414143413B3B414145413B414143412C574141572C4F41414F3B4141436C422C574141572C';
wwv_flow_imp.g_varchar2_table(690) := '4F41414F3B4141436C422C574141572C6B4241416B423B41414337423B414143412C594141593B4141435A3B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B3B';
wwv_flow_imp.g_varchar2_table(691) := '414145413B414143413B3B414145413B414143412C574141572C4F41414F3B4141436C422C574141572C4F41414F3B4141436C422C574141572C6B4241416B423B41414337423B414143412C594141593B4141435A3B414143413B3B414145413B3B4141';
wwv_flow_imp.g_varchar2_table(692) := '45413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(693) := '45413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C';
wwv_flow_imp.g_varchar2_table(694) := '514141513B4141436E422C574141572C6B4241416B423B41414337423B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B';
wwv_flow_imp.g_varchar2_table(695) := '3B414145413B414143413B414143412C514141513B414143523B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B3B414147413B414143412C574141572C514141513B4141436E';
wwv_flow_imp.g_varchar2_table(696) := '423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143412C574141572C514141513B4141436E422C574141572C6B4241416B423B41414337423B414143413B414143413B414143413B3B414145413B3B41';
wwv_flow_imp.g_varchar2_table(697) := '4145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143412C514141513B3B414145523B414143';
wwv_flow_imp.g_varchar2_table(698) := '413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143412C454141';
wwv_flow_imp.g_varchar2_table(699) := '452C674441414D2C6942414169423B4141437A423B3B3B414147413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C4F41414F3B4141436C423B414143412C594141593B4141435A3B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(700) := '414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436E6D426B423B3B41414B593B3B41414575423B3B414145543B3B41415131423B3B414149513B3B41414531423B414143412C614141612C6B4341416B433B4141432F432C614141612C';
wwv_flow_imp.g_varchar2_table(701) := '2B4241412B423B41414335432C614141612C3642414136423B41414331433B414143412C614141612C7143414171433B4141436C442C614141612C3842414138423B41414333433B3B414145413B414143413B414143413B414143412C574141572C5541';
wwv_flow_imp.g_varchar2_table(702) := '41553B41414372422C574141572C6942414169423B41414335423B414143653B414143663B414143413B414143413B3B414145413B3B414145413B414143412C634141632C6942414169423B4141432F422C594141593B4141435A3B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(703) := '45413B3B414145413B3B414145413B414143413B414143413B414143412C494141493B4141434A2C6B4241416B422C2B444141573B41414337423B414143412C6F4241416F422C67444141533B41414337422C4D41414D2C69444141553B3B4141456842';
wwv_flow_imp.g_varchar2_table(704) := '2C4D41414D2C67444141533B414143663B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C654141652C36444141533B3B41414578422C454141452C38434141513B3B414145563B41';
wwv_flow_imp.g_varchar2_table(705) := '4143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(706) := '414143413B414143412C574141572C514141513B4141436E422C574141572C594141593B41414376422C574141572C514141513B4141436E422C574141572C534141533B41414370423B414143412C594141593B4141435A3B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(707) := '4143413B414143412C6942414169422C67444141533B41414331422C454141452C69444141553B3B4141455A3B414143413B414143413B414143412C494141493B4141434A2C494141492C67444141533B414143623B3B414145412C594141592C674441';
wwv_flow_imp.g_varchar2_table(708) := '41533B41414372422C454141452C69444141553B4141435A2C454141452C69444141553B3B4141455A3B414143412C494141492C69444141553B414143643B3B414145412C454141452C67444141533B3B414145583B414143412C654141652C67444141';
wwv_flow_imp.g_varchar2_table(709) := '533B41414378422C454141452C69444141553B3B4141455A2C454141452C67444141533B3B414145583B414143413B3B414145413B414143413B414143413B414143412C594141592C3443414134433B41414378442C574141572C614141613B41414378';
wwv_flow_imp.g_varchar2_table(710) := '422C574141572C514141513B4141436E423B414143412C594141592C594141593B41414378423B414143413B414143413B414143412C2B4441412B442C38444141633B41414337453B3B414145413B414143413B414143413B414143412C574141572C65';
wwv_flow_imp.g_varchar2_table(711) := '4141653B41414331423B414143413B3B414145413B414143413B414143413B3B414145412C594141592C674441414D3B3B4141456C423B414143413B414143413B3B414145413B414143412C474141472C494141493B3B414145503B414143413B414143';
wwv_flow_imp.g_varchar2_table(712) := '412C454141452C694441414F3B3B414145543B3B414145413B414143413B414143413B3B414145413B3B414145412C494141492C694441414F3B414143583B3B414145413B414143412C4B41414B3B4141434C2C474141473B414143483B3B414145413B';
wwv_flow_imp.g_varchar2_table(713) := '414143413B414143413B414143412C574141572C594141593B41414376422C574141572C574141573B41414374422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B414143412C3045414130453B41414331453B3B414145';
wwv_flow_imp.g_varchar2_table(714) := '412C7943414179432C3642414136423B41414374453B3B414145413B414143413B414143413B414143412C574141572C574141573B41414374423B414143412C594141592C514141513B41414370423B414143413B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(715) := '3B3B414145413B414143413B414143413B414143412C574141572C594141593B41414376422C574141572C6742414167423B41414333422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B414143412C2B4541412B453B41';
wwv_flow_imp.g_varchar2_table(716) := '41432F453B3B414145412C3843414138432C3642414136423B41414333453B3B414145413B414143413B414143413B414143412C574141572C6742414167423B41414333423B414143412C594141592C514141513B41414370423B414143413B41414341';
wwv_flow_imp.g_varchar2_table(717) := '3B3B414145413B414143413B3B414145413B414143413B414143413B414143412C574141572C7342414173423B4141436A432C574141572C614141613B41414378422C574141572C594141593B41414376423B414143413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(718) := '4143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143412C494141492C69454141533B414143622C494141493B4141434A3B414143412C494141493B4141434A3B414143413B3B414145413B414143412C49';
wwv_flow_imp.g_varchar2_table(719) := '4141492C384341414F3B414143582C494141493B4141434A2C494141492C384341414F3B414143583B414143413B3B414145413B414143413B414143413B414143412C574141572C614141613B41414378423B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(720) := '4143412C454141452C67444141533B414143583B3B3B414147413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143335469';
wwv_flow_imp.g_varchar2_table(721) := '433B3B414145483B4141436B423B414143463B4141435A3B414143633B3B41414568443B414143412C574141573B414143583B414143412C69454141653B414143662C6942414169422C36434141553B41414333423B414143412C6F4241416F422C2B43';
wwv_flow_imp.g_varchar2_table(722) := '41414D3B41414331422C3642414136422C77444141653B41414335432C3442414134422C75444141633B41414331432C7342414173422C69444141513B41414339422C3642414136422C77444141653B41414335432C434141433B3B3B3B3B3B3B3B3B3B';
wwv_flow_imp.g_varchar2_table(723) := '3B3B3B3B41436E42443B3B414145413B414143412C614141612C7143414171433B4141436C442C614141612C7743414177433B41414372442C614141612C6D4341416D433B41414368443B414143412C614141612C6F4341416F433B4141436A443B3B41';
wwv_flow_imp.g_varchar2_table(724) := '4145413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C514141513B4141436E423B414143653B414143663B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(725) := '4143413B414143413B414143412C514141513B414143523B414143413B414143413B414143412C474141473B3B414145483B414143413B414143413B414143413B414143412C514141513B414143523B414143413B414143413B414143412C474141473B';
wwv_flow_imp.g_varchar2_table(726) := '414143483B3B414145413B414143413B414143413B414143412C574141572C534141533B41414370423B414143412C594141592C534141533B41414372423B414143413B3B414145413B414143413B414143413B414143412C574141572C594141593B41';
wwv_flow_imp.g_varchar2_table(727) := '414376422C574141572C4F41414F3B4141436C423B414143412C594141592C594141593B41414378423B414143413B3B414145413B414143413B414143413B414143412C574141572C594141593B41414376422C574141572C594141593B41414376423B';
wwv_flow_imp.g_varchar2_table(728) := '414143412C594141592C594141593B41414378423B414143413B3B414145413B414143413B414143413B414143412C574141572C4F41414F3B4141436C423B414143412C594141592C514141513B41414370423B414143413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(729) := '414143413B414143412C574141572C594141593B41414376423B414143412C594141592C514141513B41414370423B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143354677433B3B414145453B3B41414B643B3B41414D563B3B4141';
wwv_flow_imp.g_varchar2_table(730) := '4567423B3B414149523B3B41414531423B414143412C614141612C6F4341416F433B4141436A442C614141612C3442414134423B4141437A433B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C';
wwv_flow_imp.g_varchar2_table(731) := '554141553B41414372422C574141572C514141513B4141436E423B414143653B3B414145662C454141452C71444141593B3B414145642C7744414177442C6D4341416D433B41414333462C6F4341416F432C6B4441416B443B41414374462C6D4441416D';
wwv_flow_imp.g_varchar2_table(732) := '442C7544414175443B41414331473B3B414145412C34444141512C6B4241416B422C71444141593B3B3B41414774433B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C61';
wwv_flow_imp.g_varchar2_table(733) := '4141612C67444141533B3B41414574422C454141452C384341414F3B414143543B414143413B414143413B414143413B414143412C474141473B3B414145482C4D41414D2C38444141633B41414370422C494141492C384341414F2C4F41414F2C674441';
wwv_flow_imp.g_varchar2_table(734) := '414D2C474141472C2B4241412B423B41414331442C494141493B4141434A2C494141492C384341414F2C4F41414F2C674441414D2C474141472C2B4241412B423B41414331443B3B414145412C454141452C67444141533B3B414145583B414143413B3B';
wwv_flow_imp.g_varchar2_table(735) := '414145413B414143413B414143413B414143413B3B414145412C614141612C34444141552C7542414175422C674441414D2C474141472C6F4341416F433B41414333462C454141452C67444141533B3B414145583B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(736) := '3B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145412C534141532C6B45414167423B4141437A423B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(737) := '43413B414143413B414143413B414143413B3B414145413B3B414145412C6742414167422C3042414130423B3B41414531433B414143413B414143413B3B414145413B414143413B3B414145412C534141532C6B45414167423B4141437A423B3B414145';
wwv_flow_imp.g_varchar2_table(738) := '413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41432F486B423B3B3B4141476C423B414143413B414143413B414143653B3B414145663B3B414145413B414143413B414143412C4B41414B3B4141434C3B414143413B414143412C4B41414B3B4141434C3B41';
wwv_flow_imp.g_varchar2_table(739) := '4143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143412C614141612C514141513B41414372422C614141612C554141553B41414376422C614141612C514141513B41414372423B414143412C63';
wwv_flow_imp.g_varchar2_table(740) := '4141632C514141513B41414374423B414143413B414143413B3B414145412C574141572C674441414D2C554141552C6F4241416F423B4141432F433B3B414145413B414143413B414143413B414143413B414143412C614141612C554141553B41414376';
wwv_flow_imp.g_varchar2_table(741) := '422C614141612C514141513B41414372423B414143412C634141632C514141513B41414374423B414143413B3B414145412C534141532C694441414F3B41414368423B414143413B414143413B3B414145412C6742414167422C674441414D3B41414374';
wwv_flow_imp.g_varchar2_table(742) := '422C614141612C674441414D2C3842414138423B4141436A442C4B41414B2C494141493B3B414145542C3642414136422C674441414D3B4141436E433B3B3B414147413B414143413B414143413B414143413B414143412C614141612C514141513B4141';
wwv_flow_imp.g_varchar2_table(743) := '4372422C614141612C554141553B41414376422C614141612C514141513B41414372423B414143412C634141632C514141513B41414374423B414143413B414143412C534141532C694441414F3B41414368423B414143413B414143413B3B414145412C';
wwv_flow_imp.g_varchar2_table(744) := '6F4341416F432C674441414D2C474141472C3642414136423B41414331453B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143724667443B4141436C423B3B41414539423B414143412C574141573B414143583B414143412C69454141653B4141';
wwv_flow_imp.g_varchar2_table(745) := '43663B414143412C3642414136422C77444141653B41414335432C6F4241416F422C2B4341414D3B41414331422C434141432C454141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41435232423B3B41414537423B414143412C614141612C714341417143';
wwv_flow_imp.g_varchar2_table(746) := '3B4141436C442C614141612C3843414138433B41414333442C614141612C7543414175433B41414370442C614141612C3843414138433B41414333443B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(747) := '412C574141572C554141553B41414372422C574141572C514141513B4141436E422C574141572C6942414169423B41414335422C574141572C6942414169423B41414335423B414143653B414143663B414143413B3B3B414147413B3B414145413B3B41';
wwv_flow_imp.g_varchar2_table(748) := '4145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145412C6B4241416B422C75444141633B41414368432C474141473B3B414145483B3B414145413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(749) := '4143412C7943414179432C594141593B41414372442C4B41414B3B3B4141454C3B414143412C474141473B3B414145483B414143413B414143412C474141473B3B414145483B414143413B414143412C474141473B414143483B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(750) := '3B414143413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41437A4534433B3B3B41414735433B414143412C574141573B414143583B414143412C69454141653B414143663B414143412C3242414132422C73444141613B41';
wwv_flow_imp.g_varchar2_table(751) := '414378432C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41434E69423B3B41414D443B3B41414B533B3B41414F523B3B41414B613B3B4141452F423B414143412C614141612C7143414171433B4141436C443B414143412C614141612C3843';
wwv_flow_imp.g_varchar2_table(752) := '414138433B41414333442C614141612C7543414175433B41414370442C614141612C7143414171433B4141436C443B414143412C614141612C6B4341416B433B4141432F433B3B414145412C3242414132423B3B41414533423B414143412C534141532C';
wwv_flow_imp.g_varchar2_table(753) := '34444141652C574141572C3844414169423B41414370443B3B414145413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(754) := '413B414143412C3242414132422C3642414136423B41414378443B414143413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C6942414169423B41414335422C574141572C514141513B4141436E423B414143';
wwv_flow_imp.g_varchar2_table(755) := '653B3B414145663B3B414145413B414143413B414143413B414143412C614141612C514141513B41414372422C614141612C7542414175423B41414370432C614141612C534141533B41414374423B414143413B414143413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(756) := '414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(757) := '414143412C4B41414B3B3B4141454C3B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145412C6D4441416D442C77444141653B3B4141456C453B414143413B';
wwv_flow_imp.g_varchar2_table(758) := '414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(759) := '413B3B3B414147413B3B414145413B414143413B414143413B414143413B414143412C614141612C514141513B41414372422C614141612C7542414175423B41414370432C614141612C534141533B41414374423B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(760) := '3B3B414145413B414143413B414143413B3B414145413B414143413B3B3B414147413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145412C7742414177422C36434141573B4141';
wwv_flow_imp.g_varchar2_table(761) := '436E433B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145412C494141492C36434141573B414143663B3B414145413B414143412C494141492C694441414F3B414143583B414143412C4B41414B3B4141434C3B3B414145';
wwv_flow_imp.g_varchar2_table(762) := '413B414143412C494141492C694441414F3B414143583B414143412C4B41414B3B4141434C3B3B414145413B414143413B414143412C474141473B3B414145483B414143413B414143412C474141473B3B3B414147483B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(763) := '43413B3B414145412C6D4441416D442C3442414134423B4141432F452C474141473B3B414145483B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145412C6D4441416D442C344241413442';
wwv_flow_imp.g_varchar2_table(764) := '3B4141432F452C474141473B3B414145483B414143413B414143413B3B414145413B414143412C474141473B3B414145483B414143413B414143413B3B414145413B414143412C474141473B3B3B414147483B3B414145413B3B414145413B3B41414541';
wwv_flow_imp.g_varchar2_table(765) := '3B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145412C594141592C674441414D3B4141436C423B414143413B414143412C4B41414B2C614141613B3B4141456C423B414143413B3B';
wwv_flow_imp.g_varchar2_table(766) := '3B414147413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145412C494141492C384341414F3B3B414145583B414143413B3B414145413B414143412C494141492C67444141533B414143623B3B3B414147413B3B414145';
wwv_flow_imp.g_varchar2_table(767) := '413B414143413B414143413B414143412C614141612C594141593B4141437A423B414143413B414143412C654141652C69444141573B3B41414531422C494141492C694441414F2C4F41414F2C34434141533B41414333423B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(768) := '414143413B414143412C614141612C534141533B41414374422C614141612C594141593B4141437A423B414143412C634141632C594141593B41414331423B414143413B414143413B414143413B414143413B3B414145413B414143413B414143412C4D';
wwv_flow_imp.g_varchar2_table(769) := '41414D3B3B4141454E3B3B414145413B414143413B414143413B414143412C4F41414F3B414143503B414143413B3B414145413B414143413B414143413B414143412C614141612C594141593B4141437A422C614141612C534141533B41414374423B41';
wwv_flow_imp.g_varchar2_table(770) := '4143412C634141633B414143643B414143413B3B414145412C634141632C34444141553B3B41414578423B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C614141612C594141593B4141437A422C614141';
wwv_flow_imp.g_varchar2_table(771) := '612C514141513B41414372422C614141612C514141513B41414372423B414143412C634141633B414143643B414143413B3B414145412C594141592C674441414D3B4141436C423B414143413B414143412C4B41414B3B3B4141454C2C634141632C6744';
wwv_flow_imp.g_varchar2_table(772) := '4141533B3B41414576423B3B414145412C494141492C384341414F3B3B414145583B3B414145413B414143413B3B414145413B414143413B414143413B414143412C614141612C534141533B41414374422C614141612C594141593B4141437A423B4141';
wwv_flow_imp.g_varchar2_table(773) := '43412C634141632C594141593B41414331423B414143413B3B414145412C634141632C38434141513B3B41414574423B414143413B414143413B3B414145413B414143412C4D41414D2C34444141553B41414368422C4D41414D3B4141434E2C4D41414D';
wwv_flow_imp.g_varchar2_table(774) := '2C384341414F3B414143623B414143413B414143412C4F41414F3B414143503B3B414145413B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(775) := '4143413B3B3B414147413B414143413B414143413B414143413B414143413B414143412C554141553B414143562C634141632C534141533B41414376422C634141632C594141593B41414331422C634141632C4F41414F3B41414372423B3B414145413B';
wwv_flow_imp.g_varchar2_table(776) := '414143413B414143413B414143413B414143413B414143412C554141553B414143562C634141632C534141533B41414376422C634141632C594141593B41414331422C634141632C4F41414F3B41414372423B3B414145413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(777) := '4143413B414143413B414143412C554141553B414143562C634141632C534141533B41414376422C634141632C594141593B41414331422C634141632C4F41414F3B41414372423B3B414145413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(778) := '43412C554141553B414143562C634141632C534141533B41414376422C634141632C594141593B41414331422C634141632C4F41414F3B41414372423B3B414145413B414143413B414143413B414143413B414143413B414143412C554141553B414143';
wwv_flow_imp.g_varchar2_table(779) := '562C634141632C534141533B41414376422C634141632C594141593B41414331422C634141632C4F41414F3B41414372423B3B414145413B414143413B414143413B414143413B414143413B414143412C554141553B414143562C634141632C53414153';
wwv_flow_imp.g_varchar2_table(780) := '3B41414376422C634141632C594141593B41414331422C634141632C4F41414F3B41414372423B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C554141553B414143562C634141632C534141533B4141437642';
wwv_flow_imp.g_varchar2_table(781) := '2C634141632C594141593B41414331422C634141632C4F41414F3B41414372423B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41437667426F443B3B3B41414770443B414143412C574141573B414143583B414143412C69454141653B414143663B414143412C2B';
wwv_flow_imp.g_varchar2_table(782) := '4241412B422C3044414169423B41414368442C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41435436433B3B41414539433B3B41414D6B423B3B414149443B3B41414D433B3B4141456C423B3B414145413B414143412C614141612C71434141';
wwv_flow_imp.g_varchar2_table(783) := '71433B4141436C443B414143412C614141612C7143414171433B4141436C442C614141612C7543414175433B41414370442C614141612C7143414171433B4141436C443B3B414145413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(784) := '4143412C574141572C554141553B41414372422C574141572C514141513B4141436E423B414143653B3B414145663B3B414145413B3B414145413B3B414145413B3B414145413B414143412C614141612C594141593B4141437A423B414143412C634141';
wwv_flow_imp.g_varchar2_table(785) := '632C594141593B41414331423B414143413B414143412C6B4241416B422C67444141533B3B41414533422C494141492C384341414F2C554141552C674441414D3B41414333423B414143413B414143413B414143413B414143413B414143412C4B41414B';
wwv_flow_imp.g_varchar2_table(786) := '3B3B4141454C3B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145412C6B4241416B422C38434141513B3B41414531423B414143413B414143412C4D41414D2C67444141533B414143663B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(787) := '2C474141473B3B414145483B414143413B414143413B3B414145412C6B4241416B422C38434141513B3B41414531423B414143413B414143412C4D41414D2C67444141533B414143663B3B414145413B414143412C474141473B414143483B3B3B414147';
wwv_flow_imp.g_varchar2_table(788) := '413B414143413B414143413B414143413B414143412C574141572C594141593B41414376422C574141572C534141533B41414370423B414143413B3B414145413B414143413B3B414145413B414143412C494141492C694441414F3B414143583B414143';
wwv_flow_imp.g_varchar2_table(789) := '412C4B41414B3B4141434C3B3B414145413B414143412C494141492C384341414F3B414143583B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143413B3B414145413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(790) := '414143412C574141572C594141593B41414376422C574141572C534141533B41414370423B414143413B414143412C614141612C754441414F3B3B41414570422C454141452C384341414F3B414143543B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(791) := '2C474141473B414143483B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C6942414169423B41414335423B414143413B414143413B414143413B414143413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(792) := '413B414143412C474141473B414143483B3B414145413B414143413B414143413B414143412C614141613B414143623B414143413B414143413B414143413B414143413B414143412C474141473B3B414145483B3B414145413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(793) := '3B414143413B414143413B414143412C574141572C534141533B41414370423B414143413B414143413B414143413B3B414145412C454141452C694441414F3B3B414145542C534141532C6F444141553B4141436E423B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(794) := '43412C474141473B3B414145483B414143413B3B414145413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41437A4D67433B3B3B41414768433B414143412C574141573B414143583B414143412C69454141653B414143663B414143412C7142414171422C674441';
wwv_flow_imp.g_varchar2_table(795) := '414F3B41414335422C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41434369423B3B414153443B3B414149593B3B414145593B3B4141457A433B414143412C634141632C79444141473B3B4141456A423B3B414145413B414143412C61414161';
wwv_flow_imp.g_varchar2_table(796) := '2C7143414171433B4141436C442C614141612C3843414138433B41414333442C614141612C7543414175433B41414370443B414143412C614141612C7143414171433B4141436C443B414143413B414143413B414143413B414143412C4F41414F3B4141';
wwv_flow_imp.g_varchar2_table(797) := '43503B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143413B414143413B414143412C494141492C6942414169423B41414372423B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(798) := '3B414143413B414143413B414143413B414143412C4B41414B2C3042414130423B4141432F423B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143412C4D41414D3B4141434E3B41';
wwv_flow_imp.g_varchar2_table(799) := '4143413B414143413B414143413B414143412C4F41414F3B414143503B414143413B414143413B414143413B414143413B414143412C4B41414B2C574141573B41414368423B3B414145413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(800) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4D41414D3B4141434E2C7143414171432C7142414171422C614141613B41414376452C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(801) := '3B414143413B414143413B414143413B414143413B414143413B414143412C7143414171432C7142414171422C614141613B41414376452C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(802) := '3B414143412C7143414171432C7142414171422C614141613B41414376452C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(803) := '3B414143413B414143413B414143413B414143413B414143413B414143412C554141553B414143563B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C6742414167423B41414333422C574141572C55';
wwv_flow_imp.g_varchar2_table(804) := '4141553B41414372422C574141572C514141513B4141436E422C574141572C6942414169423B41414335423B414143653B414143663B414143413B414143413B3B414145413B3B414145413B414143412C594141593B4141435A3B414143412C30424141';
wwv_flow_imp.g_varchar2_table(805) := '30422C674441414D3B3B41414568433B414143413B3B414145413B414143413B414143412C474141473B3B414145483B414143412C594141593B4141435A3B414143413B3B414145413B414143412C594141593B4141435A3B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(806) := '414143412C594141593B4141435A3B414143413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(807) := '414143413B414143413B414143413B414143413B414143412C6B4241416B422C6F4241416F423B41414374433B414143413B414143412C6B4241416B422C6D4341416D433B41414372443B414143413B414143412C6B4241416B422C7343414173433B41';
wwv_flow_imp.g_varchar2_table(808) := '414378443B414143413B414143412C574141572C6742414167423B41414333423B414143412C594141592C6D4241416D423B4141432F423B414143413B3B414145412C4D41414D2C6B444141513B414143642C654141653B414143663B3B414145412C4D';
wwv_flow_imp.g_varchar2_table(809) := '41414D2C6B444141513B414143643B414143413B3B414145413B414143413B3B414145413B414143413B414143412C3242414132422C674441414D2C7142414171422C73444141592C474141472C6D4241416D423B41414378462C4D41414D3B4141434E';
wwv_flow_imp.g_varchar2_table(810) := '3B414143413B414143412C494141493B4141434A2C574141572C674441414D2C6942414169422C73444141592C474141472C6D4241416D423B41414370452C494141493B3B4141454A3B414143413B414143413B414143413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(811) := '414143413B414143412C574141572C6742414167423B41414333422C574141572C514141513B4141436E422C574141572C634141633B4141437A423B414143412C594141592C514141513B41414370423B414143413B3B414145412C4D41414D2C6B4441';
wwv_flow_imp.g_varchar2_table(812) := '41513B414143643B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145412C594141592C67';
wwv_flow_imp.g_varchar2_table(813) := '4441414D2C474141473B41414372423B414143413B414143413B414143413B414143412C474141473B3B414145483B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143412C574141572C6742414167';
wwv_flow_imp.g_varchar2_table(814) := '423B41414333423B414143413B3B414145413B3B414145412C4F41414F2C694441414F3B414143643B414143413B3B414145413B3B414145412C454141452C694441414F3B3B414145543B3B414145413B414143412C4D41414D2C2B434141533B414143';
wwv_flow_imp.g_varchar2_table(815) := '662C4D41414D2C2B434141533B3B414145663B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B3B414145483B3B414145413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(816) := '43412C594141592C534141533B41414372423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(817) := '413B414143413B414143413B414143413B414143413B3B414145413B3B414145412C454141452C38434141513B414143563B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143412C65';
wwv_flow_imp.g_varchar2_table(818) := '4141652C754441414F3B41414374423B414143413B414143413B3B414145413B3B414145412C454141452C364341414F3B414143543B3B3B414147413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(819) := '4143413B3B414145413B3B414145413B3B414145413B414143412C634141632C754441414F3B41414372422C4D41414D3B4141434E3B414143413B3B414145413B414143413B3B414145413B3B414145413B3B414145413B414143412C654141652C7544';
wwv_flow_imp.g_varchar2_table(820) := '41414F3B41414374422C4D41414D3B4141434E3B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B3B414147413B414143412C614141612C2B4341414D3B4141436E422C454141452C6F444141572C534141532C734241';
wwv_flow_imp.g_varchar2_table(821) := '4173423B3B41414535433B3B414145413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B3B3B414147413B414143413B3B414145413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(822) := '43413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B3B414147413B414143412C6B4241416B422C38434141493B41414374423B414143412C474141473B3B3B414147483B414143413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(823) := '43413B3B3B414147413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143412C4D41414D2C6B444141513B414143642C574141572C2B4341414D3B';
wwv_flow_imp.g_varchar2_table(824) := '4141436A423B3B414145413B3B414145412C6B4241416B422C2B4341414D3B41414378422C454141452C6F444141572C6B4241416B422C7342414173423B3B41414572443B3B414145413B414143412C494141492C67444141553B414143643B3B414145';
wwv_flow_imp.g_varchar2_table(825) := '413B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(826) := '414143413B414143412C494141493B4141434A3B414143412C4F41414F2C6D444141533B41414368422C4F41414F2C6D444141533B41414368423B414143413B414143413B414143413B3B414145413B3B414145413B414143413B3B3B414147413B4141';
wwv_flow_imp.g_varchar2_table(827) := '43413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143413B3B414145412C514141512C6D444141533B4141436A423B414143413B3B';
wwv_flow_imp.g_varchar2_table(828) := '414145412C514141512C6D444141533B4141436A423B414143413B414143413B3B414145412C4D41414D2C6D444141533B414143663B414143413B3B414145413B414143413B3B3B414147413B3B414145413B3B414145412C454141452C694441414F3B';
wwv_flow_imp.g_varchar2_table(829) := '414143543B414143412C474141473B414143483B3B3B414147413B3B414145413B3B414145413B3B3B414147413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143412C474141473B3B414145483B';
wwv_flow_imp.g_varchar2_table(830) := '414143413B414143412C474141473B3B3B414147483B3B414145413B414143413B414143412C3842414138422C6B4241416B423B3B41414568442C494141492C694441414F3B414143583B414143412C4B41414B3B3B4141454C3B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(831) := '412C4D41414D2C2B434141533B414143663B414143413B414143413B414143413B414143413B414143412C474141473B3B3B414147483B3B414145413B414143413B3B414145413B3B414145413B414143412C4D41414D2C694441414F3B414143623B41';
wwv_flow_imp.g_varchar2_table(832) := '4143412C4F41414F3B3B414145503B414143413B414143412C474141473B3B3B414147483B3B414145413B414143413B414143413B414143412C4D41414D2C67444141553B41414368423B414143412C474141473B3B3B414147483B414143413B414143';
wwv_flow_imp.g_varchar2_table(833) := '412C474141473B3B414145483B3B414145413B414143413B3B3B3B414149413B3B414145413B414143412C614141612C2B4341414D3B4141436E423B414143413B3B414145412C454141452C6F444141573B414143623B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(834) := '412C474141473B3B414145483B3B414145413B414143413B3B414145413B414143412C454141452C6F444141572C4F41414F2C2B4241412B423B4141436E443B3B414145413B414143413B414143413B414143412C574141572C594141593B4141437642';
wwv_flow_imp.g_varchar2_table(835) := '2C574141572C534141533B41414370423B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143412C474141473B414143483B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41432F74426B433B3B3B4141476C433B';
wwv_flow_imp.g_varchar2_table(836) := '414143412C574141573B414143583B414143412C69454141653B414143663B414143412C7342414173422C69444141513B41414339422C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41434C69423B3B414157443B3B414149633B3B4141452F42';
wwv_flow_imp.g_varchar2_table(837) := '3B414143412C614141612C7143414171433B4141436C442C614141612C7543414175433B41414370443B414143412C614141612C3443414134433B4141437A442C614141612C7143414171433B4141436C443B3B414145413B414143413B414143413B3B';
wwv_flow_imp.g_varchar2_table(838) := '414145413B414143413B414143413B414143413B3B414145413B3B3B414147413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C514141513B4141436E423B414143653B3B414145663B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(839) := '413B3B414145413B414143413B3B414145413B414143412C474141473B3B414145483B414143413B414143412C474141473B3B414145483B3B414145413B3B414145413B414143412C474141473B414143483B3B414145413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(840) := '414143413B414143413B414143412C494141492C7542414175423B41414333423B414143412C574141572C6942414169423B41414335423B3B414145413B414143413B414143412C494141492C7542414175423B41414333423B414143412C574141572C';
wwv_flow_imp.g_varchar2_table(841) := '514141513B4141436E422C574141572C6942414169423B41414335423B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143412C474141473B3B414145483B414143413B3B3B414147413B414143413B4141';
wwv_flow_imp.g_varchar2_table(842) := '43413B414143412C594141593B4141435A3B414143413B414143413B3B414145412C2B4341412B433B4141432F433B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(843) := '413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B3B414145412C6F4341416F432C2B4341414D3B3B41414531433B414143412C454141452C67444141553B3B';
wwv_flow_imp.g_varchar2_table(844) := '4141455A2C454141452C36434141573B3B414145623B3B414145412C514141512C67444141553B4141436C423B414143413B3B414145413B414143412C474141473B3B414145483B414143412C454141452C30434141513B414143563B414143412C4741';
wwv_flow_imp.g_varchar2_table(845) := '41473B3B414145483B414143412C454141452C36434141573B414143623B414143412C474141473B3B414145483B3B414145413B414143413B414143412C474141473B414143483B3B414145413B3B414145413B414143413B414143413B414143412C47';
wwv_flow_imp.g_varchar2_table(846) := '4141473B3B414145483B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143413B3B414145413B3B414145413B414143413B3B414145413B3B41414541';
wwv_flow_imp.g_varchar2_table(847) := '3B3B414145412C594141592C67444141553B41414374422C6B4241416B422C67444141553B3B41414535423B414143413B414143412C494141493B4141434A2C3445414134453B41414335453B3B414145413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(848) := '4143413B414143413B414143413B3B414145413B414143413B414143413B414143412C474141473B414143483B3B414145413B3B414145412C7942414179422C38434141513B4141436A433B3B414145412C454141452C38434141513B3B414145562C45';
wwv_flow_imp.g_varchar2_table(849) := '4141452C694441414F3B3B414145543B3B414145412C6F4241416F422C38434141512C6B4241416B422C32444141533B41414376443B414143412C6B4241416B422C2B4341414D3B41414378422C4D41414D2C364341414F3B3B414145623B414143413B';
wwv_flow_imp.g_varchar2_table(850) := '3B414145413B414143413B414143413B414143413B3B3B414147412C6B4241416B422C2B4341414D3B41414378423B3B414145413B414143412C4D41414D2C364341414F3B3B414145623B414143412C514141512C364341414F3B414143663B3B414145';
wwv_flow_imp.g_varchar2_table(851) := '413B414143413B414143413B3B414145413B414143412C6F4241416F422C2B4341414D3B41414331422C514141512C364341414F3B3B414145663B414143413B414143413B414143412C474141473B3B414145483B414143413B414143413B3B3B414147';
wwv_flow_imp.g_varchar2_table(852) := '413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C4F41414F3B4141436C422C574141572C534141533B41414370423B414143413B414143413B414143413B414143413B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(853) := '3B3B414145412C554141552C364341414F3B4141436A423B3B414145413B414143413B3B414145413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C4F41414F3B4141436C422C574141572C53';
wwv_flow_imp.g_varchar2_table(854) := '4141533B41414370423B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145412C2B4341412B432C634141633B41414337443B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(855) := '43412C4D41414D2C6F444141553B41414368423B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143412C7342414173423B41414374423B';
wwv_flow_imp.g_varchar2_table(856) := '3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C6742414167423B41414333423B414143412C594141593B4141435A3B414143413B3B414145413B414143413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(857) := '413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B414143483B3B414145413B414143413B414143413B414143413B414143412C7342414173422C594141';
wwv_flow_imp.g_varchar2_table(858) := '593B4141436C433B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B3B414145413B414143412C574141572C514141513B4141436E423B414143412C59414159';
wwv_flow_imp.g_varchar2_table(859) := '3B4141435A3B414143413B414143413B414143413B3B414145413B414143412C574141572C514141513B4141436E423B414143413B414143413B414143413B3B414145413B414143412C7542414175422C38434141513B3B4141452F422C324241413242';
wwv_flow_imp.g_varchar2_table(860) := '2C38434141513B4141436E433B3B414145413B3B414145412C454141452C694441414F3B414143543B3B414145413B414143413B414143413B3B414145412C7342414173422C67444141553B3B41414568433B3B414145413B414143413B414143412C4D';
wwv_flow_imp.g_varchar2_table(861) := '41414D3B4141434E3B414143413B414143412C474141473B414143483B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(862) := '2C594141593B4141435A3B414143413B414143412C534141532C67444141553B4141436E423B3B414145413B414143413B414143413B414143412C594141593B4141435A3B414143413B414143413B414143413B3B3B414147413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(863) := '413B414143413B414143413B414143413B3B3B414147413B3B414145413B3B414145412C6742414167422C67444141553B3B41414531422C7942414179422C694441414F3B41414368433B414143413B414143412C474141473B414143483B3B41414541';
wwv_flow_imp.g_varchar2_table(864) := '3B3B414145413B3B414145412C4D41414D2C6F444141553B41414368423B414143413B3B414145412C454141452C694441414F3B414143543B414143412C474141473B3B414145483B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143316667433B3B';
wwv_flow_imp.g_varchar2_table(865) := '3B41414768433B414143412C574141573B414143583B414143412C69454141653B414143663B414143412C7142414171422C674441414F3B41414335422C434141432C454141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41435473433B3B4141453042';
wwv_flow_imp.g_varchar2_table(866) := '3B3B4141456C453B414143412C614141612C7942414179423B41414374433B414143412C614141612C7143414171433B4141436C443B3B414145413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C57414157';
wwv_flow_imp.g_varchar2_table(867) := '2C554141553B41414372423B414143653B3B414145662C6B4241416B422C6D4541416B423B3B41414570433B414143413B3B414145413B414143413B414143412C4D41414D3B4141434E3B414143413B414143412C474141473B3B414145483B41414341';
wwv_flow_imp.g_varchar2_table(868) := '3B3B414145413B414143413B414143413B414143412C474141473B414143483B3B414145412C34444141512C7542414175422C6D4541416B423B3B4141456A443B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143314330443B3B3B41414731443B414143412C57';
wwv_flow_imp.g_varchar2_table(869) := '4141573B414143583B414143412C69454141653B414143663B414143412C6B4341416B432C364441416F423B41414374442C434141432C454141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41434E67423B3B4141456C423B414143412C614141612C7143';
wwv_flow_imp.g_varchar2_table(870) := '414171433B4141436C442C614141612C7543414175433B41414370443B3B414145413B414143413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C514141513B4141436E423B414143653B3B414145663B4141';
wwv_flow_imp.g_varchar2_table(871) := '43413B3B414145413B414143412C594141593B4141435A3B414143413B3B414145413B3B414145413B414143413B414143413B414143412C474141473B3B414145483B414143413B414143412C474141473B414143483B3B414145413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(872) := '4143413B414143413B414143412C574141572C514141513B4141436E423B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B3B414145412C2B4341412B432C3444414134443B41414333473B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(873) := '414143413B414143413B414143412C594141592C554141553B41414374423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E423B414143412C594141592C534141533B4141';
wwv_flow_imp.g_varchar2_table(874) := '4372423B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C574141572C6942414169423B41414335422C574141572C534141533B41414370423B414143413B414143413B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(875) := '2C4F41414F2C694441414F3B414143643B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B414143412C474141473B3B414145483B414143413B414143413B414143412C494141492C694441414F3B414143583B3B41';
wwv_flow_imp.g_varchar2_table(876) := '4145413B414143413B414143412C514141513B414143523B414143413B414143412C4B41414B3B4141434C2C494141493B4141434A3B414143413B3B414145412C3643414136432C3444414134443B4141437A473B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B';
wwv_flow_imp.g_varchar2_table(877) := '3B4143784830423B3B41414B523B3B4141456C423B414143412C614141612C7143414171433B4141436C442C614141612C3843414138433B41414333442C614141612C7543414175433B41414370442C614141612C2B4241412B423B41414335433B3B41';
wwv_flow_imp.g_varchar2_table(878) := '4145413B414143412C574141572C554141553B41414372422C574141572C574141573B41414374422C574141572C514141513B4141436E422C574141572C6942414169423B41414335423B414143653B3B414145663B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(879) := '3B414143413B414143412C6D4341416D433B4141436E433B3B414145413B414143413B3B414145413B414143413B414143413B3B414145412C554141552C694441414F3B4141436A423B414143412C514141513B3B414145523B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(880) := '414143413B414143412C474141473B3B414145483B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C474141473B3B414145483B414143413B414143413B3B414145413B3B414145413B414143412C7142414171';
wwv_flow_imp.g_varchar2_table(881) := '422C38434141493B4141437A423B414143412C4B41414B3B3B4141454C3B414143413B414143413B414143412C474141473B3B414145483B414143413B3B414145412C534141532C34444141653B41414378423B414143413B3B414145413B3B41414541';
wwv_flow_imp.g_varchar2_table(882) := '3B414143413B414143413B3B414145413B414143413B3B414145413B414143412C634141632C694541416F423B3B4141456C433B414143413B3B414145413B414143413B414143412C514141513B3B414145523B414143413B414143413B414143412C4D';
wwv_flow_imp.g_varchar2_table(883) := '41414D3B3B4141454E3B414143413B414143412C4D41414D3B3B4141454E3B414143413B414143413B414143412C474141473B414143483B3B414145413B414143413B414143413B414143413B414143413B414143413B3B3B414147413B414143413B41';
wwv_flow_imp.g_varchar2_table(884) := '4143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414335486B423B3B414151413B3B41414534423B3B41414539433B414143412C614141612C7143414171433B4141436C442C614141612C7543414175433B41414370442C614141612C2B4241412B42';
wwv_flow_imp.g_varchar2_table(885) := '3B41414335433B3B414145413B414143413B3B414145413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C554141553B414143';
wwv_flow_imp.g_varchar2_table(886) := '72422C574141572C574141573B41414374423B414143653B414143663B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143412C474141473B3B414145483B';
wwv_flow_imp.g_varchar2_table(887) := '414143413B414143412C474141473B3B414145483B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145412C494141492C694441414F3B414143583B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(888) := '2C4B41414B3B3B4141454C2C494141492C694441414F3B414143583B414143413B414143413B414143412C4B41414B3B3B4141454C3B414143412C474141473B3B3B414147483B414143413B414143413B414143413B414143412C474141473B41414348';
wwv_flow_imp.g_varchar2_table(889) := '3B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145412C454141452C2B434141513B3B414145563B3B414145413B3B414145412C454141452C69444141553B3B4141455A3B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(890) := '3B414145412C7743414177432C754441414F3B3B4141452F432C614141612C67444141533B3B41414574422C454141452C384341414F2C4F41414F2C674441414D3B41414374423B414143412C474141473B3B414145482C454141452C69444141553B3B';
wwv_flow_imp.g_varchar2_table(891) := '4141455A2C454141452C67444141533B414143583B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143374934443B41414372423B3B';
wwv_flow_imp.g_varchar2_table(892) := '414145483B414143633B414143453B3B3B41414770443B414143412C574141573B414143583B414143412C69454141653B414143663B414143413B414143412C494141492C3244414175423B41414333422C494141492C67444141613B4141436A423B41';
wwv_flow_imp.g_varchar2_table(893) := '4143412C7542414175422C6B444141533B41414368432C3842414138422C7944414167423B41414339432C2B4241412B422C3044414169423B41414368442C434141432C454141433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414370426B433B3B3B414147';
wwv_flow_imp.g_varchar2_table(894) := '70433B414143412C574141573B414143583B414143412C69454141653B414143662C7742414177422C6B444141533B4141436A432C434141433B3B3B3B3B3B3B3B3B3B3B3B3B3B414352443B414143413B414143413B414143412C4F41414F3B41414350';
wwv_flow_imp.g_varchar2_table(895) := '3B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C3642414136422C494141492C4B41414B2C614141613B4141436E443B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(896) := '414143412C574141572C514141513B4141436E422C574141572C7542414175423B4141436C433B414143412C594141592C514141513B41414370423B414143653B3B414145663B3B414145412C3442414134422C494141492C494141493B41414370432C';
wwv_flow_imp.g_varchar2_table(897) := '6B4341416B432C594141593B41414339432C474141473B414143483B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414339426B423B3B41414B513B3B41414571423B3B414145453B3B4141456A443B414143412C614141612C7143';
wwv_flow_imp.g_varchar2_table(898) := '414171433B4141436C442C614141612C7743414177433B41414372443B414143412C614141612C7543414175433B41414370442C614141612C7343414173433B4141436E442C614141612C2B4241412B423B41414335432C614141612C3842414138423B';
wwv_flow_imp.g_varchar2_table(899) := '41414333432C614141612C6B4341416B433B4141432F433B3B414145413B414143412C574141572C4D41414D3B4141436A423B414143412C614141613B414143623B4141434F3B414143503B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(900) := '3B414143413B3B414145413B414143412C574141572C4F41414F3B4141436C423B414143412C614141613B414143623B4141434F3B3B414145503B414143413B414143413B414143413B414143413B3B3B414147413B414143412C6D4341416D432C3242';
wwv_flow_imp.g_varchar2_table(901) := '414132423B41414339443B414143412C574141572C594141593B41414376423B414143412C594141593B4141435A3B4141434F3B414143503B414143413B414143413B414143413B414143413B414143413B414143413B3B3B414147413B414143412C65';
wwv_flow_imp.g_varchar2_table(902) := '4141652C3242414132423B41414331433B414143412C574141572C554141553B41414372423B414143412C594141593B4141435A3B4141434F3B414143503B414143413B414143413B414143413B414143413B414143413B414143413B3B3B414147413B';
wwv_flow_imp.g_varchar2_table(903) := '414143413B414143413B414143412C574141572C594141593B41414376423B414143412C594141593B4141435A3B4141434F3B414143503B414143413B414143413B414143412C474141473B414143483B3B3B414147413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(904) := '43412C574141572C594141593B41414376423B414143412C594141593B4141435A3B4141434F3B414143503B3B414145413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(905) := '4143413B414143413B414143413B414143412C4F41414F3B414143503B3B414145413B414143412C474141473B3B414145483B414143413B414143412C474141473B3B414145483B414143413B3B414145413B414143413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(906) := '4143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B';
wwv_flow_imp.g_varchar2_table(907) := '4141434F3B414143502C4D41414D2C36444141593B4141436C423B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C4D41414D3B';
wwv_flow_imp.g_varchar2_table(908) := '4141436A422C574141572C4D41414D3B4141436A422C574141572C634141633B4141437A423B414143412C594141592C3442414134422C6942414169423B4141437A443B4141434F3B3B414145503B3B414145413B414143412C7342414173422C4F4141';
wwv_flow_imp.g_varchar2_table(909) := '4F3B41414337422C4F41414F2C6B444141513B414143662C6742414167423B41414368423B3B3B414147413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143412C494141';
wwv_flow_imp.g_varchar2_table(910) := '493B4141434A3B414143413B414143413B3B3B414147413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C534141533B41414370423B414143412C5941';
wwv_flow_imp.g_varchar2_table(911) := '41593B4141435A3B4141434F3B3B414145503B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141492C7543414175432C36444141613B41414378443B414143412C494141493B3B4141454A3B';
wwv_flow_imp.g_varchar2_table(912) := '414143413B414143412C6F4241416F422C674441414D3B41414331423B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C3B414143413B3B414145413B414143413B3B3B4141474F';
wwv_flow_imp.g_varchar2_table(913) := '3B414143502C534141532C36444141633B41414376423B3B3B4141474F3B3B414145503B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145412C514141512C36444141613B';
wwv_flow_imp.g_varchar2_table(914) := '41414372422C514141512C34444141593B3B41414570422C3443414134433B41414335432C3042414130422C654141652C494141492C4F41414F2C494141493B41414378443B414143412C4D41414D3B4141434E3B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(915) := '3B414143413B3B414145413B3B414145413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436E546B433B4141434D3B3B4141454C3B3B4141456E432C7142414171422C36434141492C474141472C7344414173442C494141492C';
wwv_flow_imp.g_varchar2_table(916) := '6742414167423B41414374472C6F4241416F422C36434141492C474141472C6F4441416F442C494141492C7142414171423B41414378472C7542414175422C36434141492C474141472C7143414171432C494141492C634141633B41414372462C754241';
wwv_flow_imp.g_varchar2_table(917) := '4175422C36434141492C474141472C6F4341416F432C494141492C6742414167423B41414374462C7542414175422C36434141492C474141472C6F4341416F432C494141492C6742414167423B3B41414574463B414143412C614141612C324241413242';
wwv_flow_imp.g_varchar2_table(918) := '3B41414378432C614141612C7942414179423B41414374432C614141612C7742414177423B41414372432C614141612C7942414179423B41414374432C614141612C3842414138423B41414333433B3B414145413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(919) := '414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B3B3B414147483B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(920) := '43413B414143413B414143413B414143412C4B41414B3B4141434C3B3B414145413B414143413B3B414145413B414143413B414143412C514141513B414143523B414143413B414143413B414143412C474141473B3B414145483B414143413B41414341';
wwv_flow_imp.g_varchar2_table(921) := '3B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(922) := '4143413B414143413B414143413B414143413B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(923) := '413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(924) := '414143413B414143413B3B414145412C34444141513B3B3B414147523B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(925) := '414143413B414143413B414143413B3B414145412C34444141513B3B3B414147523B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(926) := '414143413B414143413B414143413B414143413B3B414145412C34444141513B3B3B414147523B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(927) := '414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145412C34444141513B3B3B414147523B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(928) := '414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(929) := '3B414143412C574141572C514141513B4141436E422C574141572C4B41414B3B41414368423B414143412C594141593B4141435A3B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(930) := '4143413B414143413B414143413B414143412C534141532C6742414167423B4141437A422C534141533B414143543B414143412C494141493B4141434A3B414143413B414143412C574141572C634141633B4141437A422C574141572C4B41414B3B4141';
wwv_flow_imp.g_varchar2_table(931) := '4368423B414143412C594141593B4141435A3B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C';
wwv_flow_imp.g_varchar2_table(932) := '494141493B4141434A3B414143413B414143412C574141572C534141533B41414370422C574141572C4B41414B3B41414368423B414143412C594141593B4141435A3B3B414145413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(933) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E423B414143412C';
wwv_flow_imp.g_varchar2_table(934) := '594141593B4141435A3B4141434F3B414143503B414143413B414143413B414143413B414143412C534141532C674441414D3B414143663B3B414145413B414143413B414143413B414143412C574141572C4B41414B3B41414368423B414143412C5941';
wwv_flow_imp.g_varchar2_table(935) := '41593B4141435A3B4141434F3B414143503B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41437A5532423B3B414149473B3B414149473B3B41414B68423B3B414149533B3B41414531423B414143412C614141612C7143414171433B414143';
wwv_flow_imp.g_varchar2_table(936) := '6C442C614141612C7543414175433B41414370443B3B414145413B3B3B414147413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C514141513B4141436E423B414143653B3B414145663B3B3B414147413B41';
wwv_flow_imp.g_varchar2_table(937) := '4143413B414143413B414143413B414143413B414143412C474141473B3B3B414147483B3B414145413B414143413B414143412C6D4241416D422C6F4441414F3B41414331422C6742414167422C79444141513B3B41414578423B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(938) := '413B414143412C514141512C7744414167423B41414378423B3B414145412C4D41414D2C69444141533B414143663B3B414145413B3B414145413B3B414145412C634141632C79444141513B3B41414574423B414143413B414143413B414143412C4F41';
wwv_flow_imp.g_varchar2_table(939) := '414F3B3B414145503B414143413B3B414145413B414143413B414143413B3B3B414147413B414143412C494141492C30434141513B4141435A2C494141492C30434141513B3B4141455A3B3B414145412C494141492C6D444141573B414143663B3B4141';
wwv_flow_imp.g_varchar2_table(940) := '45413B3B414145413B414143412C514141512C67444141553B4141436C423B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143412C614141612C6F4441414F3B41414370423B3B414145';
wwv_flow_imp.g_varchar2_table(941) := '412C494141492C30434141513B4141435A2C494141492C30434141513B3B4141455A3B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B3B414147413B414143413B414143413B414143413B3B3B3B414149413B3B4141';
wwv_flow_imp.g_varchar2_table(942) := '45413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143314973433B3B3B41414774433B414143412C574141573B414143583B414143412C69454141653B414143663B414143412C7742414177422C6D444141553B4141436C432C4341';
wwv_flow_imp.g_varchar2_table(943) := '41433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41434E67423B3B41414B473B3B4141494B3B3B414149493B3B414149583B3B4141456C423B414143412C614141612C7143414171433B4141436C442C614141612C7543414175433B41414370443B41';
wwv_flow_imp.g_varchar2_table(944) := '4143412C614141612C6B4341416B433B4141432F432C614141612C7743414177433B41414372443B3B414145413B414143413B414143413B3B414145412C634141632C6B4241416B423B41414368433B3B414145413B3B414145413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(945) := '43413B414143412C494141492C634141633B4141436C423B414143413B414143412C514141512C7542414175423B4141432F423B414143412C574141572C514141513B4141436E422C574141572C534141533B41414370422C574141572C514141513B41';
wwv_flow_imp.g_varchar2_table(946) := '41436E422C574141572C554141553B41414372422C574141572C514141513B4141436E423B414143653B3B414145663B3B414145413B3B414145413B414143413B3B414145412C7342414173422C38434141493B3B41414531423B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(947) := '413B3B414145413B414143413B414143412C474141473B414143483B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143412C574141572C614141613B41414378423B414143413B414143413B414143413B3B3B4141';
wwv_flow_imp.g_varchar2_table(948) := '47413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C4F41414F3B4141436C423B414143413B3B414145413B414143412C6942414169422C73444141573B3B41414535';
wwv_flow_imp.g_varchar2_table(949) := '423B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B3B414147413B3B414145413B414143412C4D41414D2C67444141553B41414368423B414143413B3B414145413B3B414145413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(950) := '413B3B414145412C6943414169432C714441414B3B3B41414574433B3B414145413B414143413B3B414145413B414143413B414143412C494141493B4141434A3B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(951) := '413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145412C6F4341416F432C4B41414B3B4141437A433B414143412C494141493B3B4141454A3B414143413B414143413B414143413B414143413B414143412C4D41';
wwv_flow_imp.g_varchar2_table(952) := '414D3B4141434E3B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C4F41414F3B4141436C423B414143';
wwv_flow_imp.g_varchar2_table(953) := '413B3B414145412C6942414169422C73444141573B3B41414535423B414143413B3B3B414147413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C4F41414F3B4141436C422C574141572C514141513B414143';
wwv_flow_imp.g_varchar2_table(954) := '6E423B414143413B414143413B3B414145413B3B414145412C2B4241412B422C694441414B3B3B41414570433B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145412C634141632C38434141473B4141436A423B';
wwv_flow_imp.g_varchar2_table(955) := '3B3B414147413B414143413B414143413B414143412C574141572C534141533B41414370423B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(956) := '43412C494141492C30434141513B4141435A3B3B414145413B3B414145413B414143413B3B3B414147413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143315079423B3B4141457A423B414143413B414143413B414143412C5741';
wwv_flow_imp.g_varchar2_table(957) := '41572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B4141434F3B3B414145502C7542414175422C694441414B3B41414335422C7542414175422C69';
wwv_flow_imp.g_varchar2_table(958) := '4441414B3B3B41414535423B3B414145413B414143413B3B414145413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B4141';
wwv_flow_imp.g_varchar2_table(959) := '434F3B414143503B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143394273433B3B3B41414774433B414143412C574141573B414143583B414143412C69454141653B414143663B414143412C7742414177422C6D444141553B4141436C432C4341';
wwv_flow_imp.g_varchar2_table(960) := '41433B3B3B3B3B3B3B3B3B3B3B3B3B3B414354443B414143412C614141612C6F4341416F433B4141436A443B3B414145413B3B414145413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C514141513B414143';
wwv_flow_imp.g_varchar2_table(961) := '6E423B414143412C594141592C594141593B41414378423B4141434F3B3B414145503B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41433342413B41';
wwv_flow_imp.g_varchar2_table(962) := '4143413B414143413B414143412C574141572C654141653B41414331422C574141572C514141513B4141436E423B414143412C594141592C514141513B41414370423B4141434F3B3B414145503B414143413B414143413B3B414145413B3B414145413B';
wwv_flow_imp.g_varchar2_table(963) := '414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143412C574141572C654141653B41414331422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B4141434F3B';
wwv_flow_imp.g_varchar2_table(964) := '3B414145503B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B414143412C4D41414D3B3B4141454E3B3B414145413B414143413B414143412C514141513B3B41';
wwv_flow_imp.g_varchar2_table(965) := '4145523B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143412C494141493B3B4141454A3B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C574141572C65';
wwv_flow_imp.g_varchar2_table(966) := '4141653B41414331422C574141572C514141513B4141436E423B414143412C594141592C514141513B41414370423B414143413B4141434F3B3B414145503B414143413B414143413B3B414145413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B';
wwv_flow_imp.g_varchar2_table(967) := '3B41437A4669423B3B4141456A423B3B414145413B414143412C574141572C514141513B4141436E423B4141434F3B414143502C6742414167422C67444141553B3B41414531423B3B414145413B414143413B414143413B414143413B3B4141454F3B41';
wwv_flow_imp.g_varchar2_table(968) := '4143503B414143413B3B414145413B414143412C574141572C514141513B4141436E423B414143412C594141593B4141435A3B4141434F3B414143502C6742414167422C67444141553B3B41414531423B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B';
wwv_flow_imp.g_varchar2_table(969) := '3B3B3B3B3B3B3B3B3B3B3B414374426B423B3B4141456C423B414143412C614141612C7143414171433B4141436C442C614141612C6B4341416B433B4141432F432C614141612C6743414167433B41414337433B414143412C614141612C384241413842';
wwv_flow_imp.g_varchar2_table(970) := '3B41414333433B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B3B414145413B414143413B414143413B414143412C574141572C574141573B41414374423B414143412C594141593B41';
wwv_flow_imp.g_varchar2_table(971) := '41435A3B4141434F3B3B414145503B414143412C534141532C674441414D3B414143662C594141592C38434141493B41414368423B414143412C4B41414B3B4141434C2C474141473B414143483B3B3B414147413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(972) := '3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C514141513B4141436E';
wwv_flow_imp.g_varchar2_table(973) := '422C574141572C534141533B41414370423B4141434F3B414143503B3B414145413B414143413B414143413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C6D4241';
wwv_flow_imp.g_varchar2_table(974) := '416D423B41414339422C574141572C7146414171463B41414368472C574141572C514141513B4141436E423B4141434F3B3B414145503B3B414145412C4F41414F2C694441414F3B414143643B414143413B3B414145412C454141452C694441414F3B41';
wwv_flow_imp.g_varchar2_table(975) := '4143543B3B414145412C514141512C694441414F3B414143663B414143413B414143412C474141473B414143483B3B3B414147413B414143413B414143413B414143412C574141572C6D4241416D423B41414339422C574141572C534141533B41414370';
wwv_flow_imp.g_varchar2_table(976) := '422C574141572C514141513B4141436E423B414143412C594141592C574141573B41414376423B4141434F3B414143503B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(977) := '43413B414143413B414143412C474141473B3B414145483B414143413B3B414145413B414143413B414143413B414143412C574141572C574141573B41414374422C574141572C534141533B41414370423B414143412C594141592C574141573B414143';
wwv_flow_imp.g_varchar2_table(978) := '76423B4141434F3B414143503B414143413B3B3B414147413B414143413B414143413B414143412C574141572C574141573B41414374422C574141572C534141533B41414370423B414143412C594141592C574141573B41414376423B4141434F3B4141';
wwv_flow_imp.g_varchar2_table(979) := '43503B414143413B3B3B414147413B414143413B414143413B414143413B414143412C574141572C574141573B41414374422C574141572C534141533B41414370422C574141572C534141533B41414370423B414143412C594141592C534141533B4141';
wwv_flow_imp.g_varchar2_table(980) := '4372423B4141434F3B3B414145502C4D41414D2C71444141573B4141436A423B414143413B3B414145412C4D41414D2C6B444141513B414143643B414143413B414143413B3B3B414147413B3B414145413B414143413B414143413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(981) := '45413B414143413B414143412C6B4241416B422C694441414F2C7942414179422C634141633B41414368453B3B3B414147413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(982) := '43413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B414143412C4D41414D3B3B4141454E3B414143413B3B414145413B414143412C4D41414D2C694441414F3B3B414145622C4D41414D2C694441414F3B3B414145623B4141';
wwv_flow_imp.g_varchar2_table(983) := '43413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C574141572C6D4241416D423B4141';
wwv_flow_imp.g_varchar2_table(984) := '4339422C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B3B414145503B414143412C4F41414F2C694441414F3B414143643B414143413B3B414145413B414143413B414143413B414143413B3B414145412C45';
wwv_flow_imp.g_varchar2_table(985) := '4141452C694441414F3B3B414145543B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(986) := '4143413B414143413B414143413B414143413B414143412C474141473B3B414145483B414143413B414143413B414143413B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(987) := '413B414143413B414143412C574141572C574141573B41414374422C574141572C4D41414D3B4141436A423B414143412C594141592C574141573B41414376423B4141434F3B3B414145503B3B414145412C454141452C694441414F3B3B414145543B3B';
wwv_flow_imp.g_varchar2_table(988) := '414145413B414143413B414143413B3B414145412C534141532C6B444141513B4141436A423B414143413B414143412C534141532C6B444141513B4141436A423B414143413B414143413B414143412C554141552C6B444141512C6742414167422C6B44';
wwv_flow_imp.g_varchar2_table(989) := '4141513B41414331433B414143413B3B414145413B414143412C514141512C554141552C6B444141512C6942414169422C6B444141513B4141436E443B414143413B414143413B414143412C474141473B3B414145483B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(990) := '43413B414143413B414143412C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B3B414145503B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(991) := '43412C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B414143503B414143413B3B414145413B3B414145413B414143412C534141532C674441414D2C474141472C594141592C594141593B41414331433B3B3B';
wwv_flow_imp.g_varchar2_table(992) := '3B3B3B3B3B3B3B3B3B3B3B3B3B41436E59413B414143412C574141572C514141513B4141436E423B414143412C594141593B4141435A3B4141434F3B414143503B414143413B3B414145413B414143412C614141613B414143622C594141593B4141435A';
wwv_flow_imp.g_varchar2_table(993) := '2C594141593B4141435A2C634141633B414143642C634141633B414143643B3B414145413B414143412C574141572C514141513B4141436E423B414143412C594141593B4141435A3B4141434F3B414143503B3B414145413B414143413B414143412C47';
wwv_flow_imp.g_varchar2_table(994) := '4141473B414143483B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41433542413B414143412C614141612C2B4241412B423B41414335433B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143412C574141';
wwv_flow_imp.g_varchar2_table(995) := '572C6B4341416B433B41414337433B414143412C594141593B4141435A3B4141434F3B414143503B414143413B3B414145413B414143412C574141572C7743414177433B4141436E443B4141434F3B414143503B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(996) := '414143412C574141572C4F41414F3B4141436C423B414143412C594141593B4141435A3B4141434F3B3B414145503B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C494141493B41';
wwv_flow_imp.g_varchar2_table(997) := '41434A3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414339436B423B3B4141456C423B414143412C614141612C3842414138423B41414333432C614141612C2B4241412B423B41414335432C614141612C3842414138423B41414333433B3B414145';
wwv_flow_imp.g_varchar2_table(998) := '413B414143413B414143413B414143412C574141572C4F41414F3B4141436C422C574141572C4F41414F3B4141436C423B414143412C594141592C514141513B41414370423B4141434F3B414143503B414143413B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(999) := '3B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C574141572C4F41414F3B4141436C422C574141572C4F41414F3B4141436C422C574141572C4F41414F3B4141436C422C574141572C514141513B4141436E';
wwv_flow_imp.g_varchar2_table(1000) := '423B414143412C594141593B4141435A3B4141434F3B3B414145503B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B3B414147413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(1001) := '4143413B414143412C574141572C654141653B41414331422C574141572C4F41414F3B4141436C423B414143412C594141592C6742414167423B41414335423B4141434F3B414143503B3B414145413B414143413B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(1002) := '3B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143412C574141572C4D41414D3B4141436A422C574141572C534141533B41414370423B414143412C594141593B4141435A3B4141434F3B414143503B';
wwv_flow_imp.g_varchar2_table(1003) := '3B414145412C534141532C2B4341414B3B414143643B414143412C474141473B414143483B3B414145413B414143413B414143413B414143412C574141572C4F41414F3B4141436C422C574141572C4D41414D3B4141436A422C574141572C514141513B';
wwv_flow_imp.g_varchar2_table(1004) := '4141436E423B414143412C594141593B4141435A3B4141434F3B414143503B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C4F41414F3B4141436C422C574141572C4F';
wwv_flow_imp.g_varchar2_table(1005) := '41414F3B4141436C423B414143412C594141592C4F41414F3B4141436E423B4141434F3B414143503B414143413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436C49413B414143412C3243414132432C734241417342';
wwv_flow_imp.g_varchar2_table(1006) := '3B4141436A453B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C594141593B41414376423B414143412C594141593B4141435A3B4141434F3B414143503B414143413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(1007) := '414143413B414143412C574141572C594141593B41414376422C594141593B4141435A3B4141434F3B414143503B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B41433142413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1008) := '414143413B414143412C574141572C514141513B4141436E423B414143653B3B414145663B414143413B414143413B3B414145413B414143413B414143413B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B3B';
wwv_flow_imp.g_varchar2_table(1009) := '3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41437642413B414143413B414143413B414143412C574141572C514141513B4141436E423B4141434F3B414143503B414143413B3B4141456F443B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41434C6C433B3B4141';
wwv_flow_imp.g_varchar2_table(1010) := '456C423B414143413B414143413B414143412C574141572C4B41414B3B41414368423B414143412C594141593B4141435A3B4141434F3B414143502C534141532C6B444141512C574141572C36434141473B4141432F423B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(1011) := '4143413B414143412C574141572C4B41414B3B41414368423B414143412C594141593B4141435A3B4141434F3B414143502C534141532C6B444141512C574141572C36434141473B4141432F423B3B414145413B414143413B414143413B414143412C57';
wwv_flow_imp.g_varchar2_table(1012) := '4141572C4B41414B3B41414368423B414143412C594141593B4141435A3B4141434F3B414143502C534141532C6B444141512C574141572C2B4341414B3B4141436A433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436E4369423B3B414149';
wwv_flow_imp.g_varchar2_table(1013) := '473B3B414149413B3B41414570423B414143412C574141572C594141593B41414376422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B4141434F3B414143502C554141552C6D44414167423B41414331423B3B41414541';
wwv_flow_imp.g_varchar2_table(1014) := '3B414143412C574141572C594141593B41414376423B414143412C594141593B4141435A3B4141434F3B3B414145503B414143413B414143413B3B414145413B414143412C574141572C594141593B41414376423B414143412C594141593B4141435A3B';
wwv_flow_imp.g_varchar2_table(1015) := '4141434F3B3B414145503B414143413B414143413B3B414145413B414143412C574141572C594141593B41414376423B414143412C594141593B4141435A3B4141434F3B3B414145503B414143413B414143413B3B414145413B414143412C574141572C';
wwv_flow_imp.g_varchar2_table(1016) := '594141593B41414376423B414143412C594141593B4141435A3B4141434F3B414143502C7342414173422C6D44414167423B3B41414574433B414143413B414143413B3B414145413B414143412C4D41414D2C674441414B3B414143583B414143412C49';
wwv_flow_imp.g_varchar2_table(1017) := '4141493B4141434A3B414143413B414143413B3B414145413B414143412C574141572C594141593B41414376423B414143412C594141593B4141435A3B4141434F3B414143502C7342414173422C6D44414167423B3B41414574433B414143413B3B3B3B';
wwv_flow_imp.g_varchar2_table(1018) := '3B3B3B3B3B3B3B3B3B3B3B414370464F3B414143503B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414346413B414143412C614141612C2B4241412B423B41414335432C614141612C3842414138423B41414333433B3B414145413B414143412C5741';
wwv_flow_imp.g_varchar2_table(1019) := '41572C4D41414D3B4141436A422C594141593B4141435A3B4141434F3B414143503B414143413B414143413B414143413B414143413B3B3B414147413B414143412C574141572C4F41414F3B4141436C422C574141572C4F41414F3B4141436C422C5941';
wwv_flow_imp.g_varchar2_table(1020) := '41593B4141435A3B4141434F3B414143503B414143413B414143413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41437A426B423B3B41414B413B3B3B4141476C423B414143412C614141612C6D4241416D423B4141436843';
wwv_flow_imp.g_varchar2_table(1021) := '3B414143412C614141612C2B4241412B423B41414335433B3B414145413B414143412C574141572C3642414136423B41414378433B414143412C594141593B4141435A3B4141434F3B414143503B414143413B3B414145413B414143412C574141572C53';
wwv_flow_imp.g_varchar2_table(1022) := '4141533B41414370423B414143412C594141593B4141435A3B4141434F3B414143503B3B414145412C7142414171422C6942414169423B41414374433B414143413B3B414145413B414143413B3B414145413B414143412C574141572C4F41414F3B4141';
wwv_flow_imp.g_varchar2_table(1023) := '436C423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143412C574141572C4F41414F3B4141436C423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1024) := '412C574141572C4F41414F3B4141436C422C574141572C4F41414F3B4141436C422C574141572C4F41414F3B4141436C423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143412C574141572C53414153';
wwv_flow_imp.g_varchar2_table(1025) := '3B41414370422C574141572C514141513B4141436E422C594141593B4141435A3B414143413B414143413B3B414145413B3B414145412C6B4241416B422C6742414167423B3B4141456C433B414143413B414143413B3B414145413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(1026) := '45413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(1027) := '414143413B3B414145413B3B414145413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143412C574141572C534141533B414143';
wwv_flow_imp.g_varchar2_table(1028) := '70422C574141572C654141653B41414331422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B4141434F3B3B414145502C4D41414D2C6B444141513B414143643B414143413B414143413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1029) := '43413B3B414145412C654141652C67444141533B3B41414578422C4D41414D2C6B444141513B414143643B414143413B3B414145413B414143413B3B414145413B414143412C574141572C594141593B41414376422C574141572C534141533B41414370';
wwv_flow_imp.g_varchar2_table(1030) := '423B414143412C594141593B4141435A3B4141434F3B3B414145503B3B414145412C454141452C384341414F3B414143543B414143412C474141473B3B414145483B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143394B6B423B4141436C';
wwv_flow_imp.g_varchar2_table(1031) := '423B414143413B414143413B414143412C574141572C594141593B41414376422C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143';
wwv_flow_imp.g_varchar2_table(1032) := '4F3B414143502C6B4241416B422C79444141653B4141436A433B414143413B414143412C654141652C79444141653B41414339423B414143413B414143412C634141632C79444141653B41414337423B414143413B414143412C454141452C6D44414159';
wwv_flow_imp.g_varchar2_table(1033) := '3B414143643B414143413B414143413B414143413B414143412C574141572C594141593B41414376422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B4141434F3B414143502C6B4241416B422C79444141653B414143';
wwv_flow_imp.g_varchar2_table(1034) := '6A433B414143413B414143412C454141452C6D444141593B414143643B414143413B414143413B414143413B414143412C574141572C594141593B41414376422C574141572C514141513B4141436E423B4141434F3B414143502C654141652C79444141';
wwv_flow_imp.g_varchar2_table(1035) := '653B41414339423B414143413B414143412C454141452C6D444141593B414143643B414143413B414143413B414143413B414143412C574141572C594141593B41414376422C574141572C514141513B4141436E423B4141434F3B414143502C63414163';
wwv_flow_imp.g_varchar2_table(1036) := '2C79444141653B41414337423B414143413B414143412C454141452C6D444141593B414143643B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414378446B423B3B41414F413B3B414149443B3B3B4141476A423B414143412C614141612C6F4341416F433B';
wwv_flow_imp.g_varchar2_table(1037) := '4141436A443B414143413B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143412C634141632C3442414134423B41414331433B414143413B414143413B414143413B414143412C4F41414F3B414143503B41';
wwv_flow_imp.g_varchar2_table(1038) := '4143412C654141652C6943414169433B41414368443B414143412C634141633B414143643B414143413B414143413B414143412C494141492C494141493B414143523B414143412C634141633B414143643B414143412C494141492C494141493B414143';
wwv_flow_imp.g_varchar2_table(1039) := '523B414143412C634141633B414143643B414143413B414143412C494141492C494141493B414143523B414143412C654141653B414143663B414143412C4F41414F3B414143503B3B414145413B3B414145413B414143413B414143413B414143413B3B';
wwv_flow_imp.g_varchar2_table(1040) := '3B414147413B414143412C574141572C6942414169423B41414335422C594141593B4141435A3B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143412C574141572C654141653B414143';
wwv_flow_imp.g_varchar2_table(1041) := '31423B414143412C594141593B4141435A3B414143413B3B414145412C4D41414D2C6B444141513B414143642C574141572C674441414D2C474141472C7343414173433B41414331442C494141493B4141434A3B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1042) := '4143413B414143413B414143413B414143413B3B414145413B414143412C574141572C514141513B4141436E422C574141572C6742414167423B41414333423B414143412C594141593B4141435A3B414143413B3B414145413B3B414145413B3B414145';
wwv_flow_imp.g_varchar2_table(1043) := '413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143412C4941';
wwv_flow_imp.g_varchar2_table(1044) := '41493B4141434A2C614141613B414143623B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C514141513B4141436E422C574141572C6742414167423B41';
wwv_flow_imp.g_varchar2_table(1045) := '414333423B414143412C594141592C6742414167423B41414335423B414143413B3B414145413B414143413B3B414145413B3B414145412C534141533B414143543B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1046) := '4143413B414143413B3B414145413B414143412C574141572C554141553B41414372422C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C594141593B41414376423B414143412C594141593B4141435A3B41';
wwv_flow_imp.g_varchar2_table(1047) := '4143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B3B414147413B414143413B414143413B414143413B414143412C574141572C514141513B41';
wwv_flow_imp.g_varchar2_table(1048) := '41436E422C574141572C514141513B4141436E423B414143412C594141592C514141513B41414370423B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1049) := '414143412C514141513B3B414145523B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B3B414147413B414143';
wwv_flow_imp.g_varchar2_table(1050) := '412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1051) := '43413B414143413B3B414145413B414143413B3B3B414147413B414143412C594141593B4141435A3B414143413B414143413B3B414145413B414143412C6742414167422C67444141533B3B4141457A422C494141492C384341414F3B414143583B4141';
wwv_flow_imp.g_varchar2_table(1052) := '43412C4B41414B3B3B4141454C2C494141492C6F444141573B414143663B414143413B414143413B414143413B414143412C4B41414B3B3B4141454C3B414143413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143412C57';
wwv_flow_imp.g_varchar2_table(1053) := '4141572C594141593B41414376423B414143653B3B414145662C6942414169422C674441414D2C474141473B41414331423B414143413B414143412C614141613B414143623B414143412C474141472C634141633B4141436A423B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1054) := '413B414143413B414143412C574141572C514141513B4141436E422C574141572C6B4241416B423B41414337423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141';
wwv_flow_imp.g_varchar2_table(1055) := '572C514141513B4141436E422C574141572C6B4241416B423B41414337423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C5741';
wwv_flow_imp.g_varchar2_table(1056) := '41572C6B4241416B423B41414337423B414143413B414143413B414143413B414143413B414143413B414143413B414143412C594141592C674441414D2C474141473B41414372422C634141632C674441414D2C474141473B41414376423B414143413B';
wwv_flow_imp.g_varchar2_table(1057) := '414143413B3B414145413B3B414145413B414143412C4D41414D2C594141592C474141472C594141592C4B41414B3B41414374433B414143413B3B414145413B3B414145413B414143412C6D4241416D422C67444141533B41414335422C454141452C38';
wwv_flow_imp.g_varchar2_table(1058) := '4341414F2C654141652C594141593B41414370432C454141452C384341414F3B3B414145543B3B414145412C454141452C67444141533B3B414145583B414143413B414143413B3B414145413B414143413B414143413B3B414145412C6F4241416F422C';
wwv_flow_imp.g_varchar2_table(1059) := '674441414D3B41414331423B414143412C474141473B3B414145482C7142414171422C674441414D3B41414333423B414143412C474141473B3B414145483B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B3B414147';
wwv_flow_imp.g_varchar2_table(1060) := '412C6F4241416F422C67444141533B3B41414537422C454141452C384341414F3B3B414145543B414143413B414143412C454141452C694441414F3B3B414145543B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1061) := '4143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145412C6742414167422C67444141533B4141437A422C494141492C384341414F2C554141552C594141593B3B4141456A433B3B414145412C';
wwv_flow_imp.g_varchar2_table(1062) := '494141492C67444141533B414143622C474141473B3B414145482C454141452C67444141533B3B414145583B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B3B414147413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1063) := '413B414143413B414143413B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436E63413B414143412C6D4241416D422C614141613B41414368433B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C6F424141';
wwv_flow_imp.g_varchar2_table(1064) := '6F422C7142414171423B4141437A433B414143413B414143413B414143413B414143413B414143413B414143413B414143412C6F4241416F422C7742414177423B41414335433B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1065) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1066) := '412C554141553B414143563B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1067) := '413B414143412C434141433B3B414145443B414143413B414143413B414143413B414143413B414143412C574141572C4D41414D3B4141436A423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(1068) := '414143413B414143413B414143412C574141572C514141513B4141436E423B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141';
wwv_flow_imp.g_varchar2_table(1069) := '436E423B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B414143413B414143412C494141493B3B4141454A2C594141592C514141513B41414370423B3B414145413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1070) := '4143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C594141592C514141513B41414370422C5941';
wwv_flow_imp.g_varchar2_table(1071) := '41593B4141435A3B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1072) := '3B414143413B414143413B414143413B414143413B414143413B3B414145412C69454141652C474141472C454141433B4141436E423B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143354A412C6742414167422C7344414173442C614141612C6D4441416D442C';
wwv_flow_imp.g_varchar2_table(1073) := '47414177423B414143394A3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B414344413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C3642414136423B41414337422C534141533B414143543B';
wwv_flow_imp.g_varchar2_table(1074) := '414143412C4B41414B3B4141434C2C474141473B414143483B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C574141572C6F4241416F423B4141432F423B414143412C594141593B4141435A3B3B414145413B';
wwv_flow_imp.g_varchar2_table(1075) := '414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143412C594141593B';
wwv_flow_imp.g_varchar2_table(1076) := '4141435A3B414143413B414143413B414143413B3B3B414147413B414143412C3442414134423B41414335423B414143413B414143413B414143412C574141572C654141653B41414331422C594141592C3046414130463B41414374473B414143412C59';
wwv_flow_imp.g_varchar2_table(1077) := '4141592C474141473B414143663B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1078) := '3B414143413B3B3B414147413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C534141533B41414370422C574141572C574141573B41414374423B414143412C594141';
wwv_flow_imp.g_varchar2_table(1079) := '592C534141533B41414372423B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143412C4B41414B3B4141434C2C474141473B3B414145483B414143413B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1080) := '413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1081) := '413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143412C5741';
wwv_flow_imp.g_varchar2_table(1082) := '41572C534141533B41414370422C594141593B4141435A3B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C534141533B41414370423B414143413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1083) := '43413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C594141593B4141435A3B414143413B3B414145413B414143413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1084) := '413B414143413B414143413B414143413B414143413B414143412C574141572C654141653B41414331422C594141593B4141435A3B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(1085) := '3B414143413B414143413B414143412C574141572C514141513B4141436E422C594141593B4141435A3B414143413B3B414145413B414143413B414143412C6B4241416B422C6742414167423B4141436C433B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1086) := '43413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C534141533B41414370422C594141593B4141435A3B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1087) := '413B414143413B414143412C3842414138423B41414339423B414143412C494141493B4141434A3B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C594141593B4141435A3B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1088) := '413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C594141593B4141435A3B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1089) := '413B414143413B414143413B414143412C574141572C534141533B41414370423B414143412C594141592C534141533B41414372423B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1090) := '413B414143413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E422C574141572C534141533B41414370423B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1091) := '4143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E422C574141572C554141553B41414372422C574141572C534141533B4141';
wwv_flow_imp.g_varchar2_table(1092) := '4370422C594141593B4141435A3B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E422C5741';
wwv_flow_imp.g_varchar2_table(1093) := '41572C554141553B41414372422C574141572C534141533B41414370422C594141593B4141435A3B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1094) := '412C434141433B3B414145443B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E422C574141572C514141513B4141436E';
wwv_flow_imp.g_varchar2_table(1095) := '422C574141572C554141553B41414372422C574141572C534141533B41414370422C594141593B4141435A3B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1096) := '413B414143413B414143413B414143413B414143412C474141473B414143483B3B414145413B414143413B414143413B414143412C574141572C534141533B41414370422C574141572C514141513B4141436E422C574141572C554141553B4141437242';
wwv_flow_imp.g_varchar2_table(1097) := '2C574141572C534141533B41414370423B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145';
wwv_flow_imp.g_varchar2_table(1098) := '413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1099) := '414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1100) := '4143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C554141553B41414372422C594141592C534141533B41414372423B4141';
wwv_flow_imp.g_varchar2_table(1101) := '43413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145412C7943414179433B3B4141457A433B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1102) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B3B4141';
wwv_flow_imp.g_varchar2_table(1103) := '45413B414143412C594141592C634141633B41414331422C594141592C534141533B41414372423B414143412C614141613B414143623B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1104) := '43413B3B414145413B414143413B3B414145413B414143413B414143413B3B41414538493B41414339493B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436E6A42413B3B414145413B3B414145412C3842414138422C6742414167422C514141513B3B414145';
wwv_flow_imp.g_varchar2_table(1105) := '74443B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C434141433B3B3B414147443B3B414145413B414143413B414143413B414143413B414143412C4D41414D3B3B4141';
wwv_flow_imp.g_varchar2_table(1106) := '454E3B414143412C7942414179423B4141437A423B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B3B414147413B414143413B414143412C6D4341416D433B4141436E432C654141652C7342';
wwv_flow_imp.g_varchar2_table(1107) := '414173423B41414372433B414143412C574141572C514141513B4141436E423B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1108) := '3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143412C6742414167423B41414368423B414143413B4141';
wwv_flow_imp.g_varchar2_table(1109) := '43413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143412C6D4241416D423B4141436E423B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(1110) := '3B414143412C574141573B414143583B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C594141592C7142414171423B4141436A433B414143413B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1111) := '413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143412C594141593B4141435A3B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1112) := '413B414143413B414143413B414143412C594141593B4141435A3B414143413B3B414145413B414143413B414143413B414143412C594141593B4141435A3B414143413B3B414145413B414143413B414143413B414143412C594141593B4141435A3B41';
wwv_flow_imp.g_varchar2_table(1113) := '4143413B3B414145413B414143412C6742414167422C634141633B41414339423B414143413B414143413B414143413B414143412C594141593B4141435A3B414143413B3B414145413B414143413B414143413B414143412C634141632C634141633B41';
wwv_flow_imp.g_varchar2_table(1114) := '414335423B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C634141632C634141633B41414335423B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1115) := '3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C634141632C554141553B41414378422C634141632C554141553B41414378423B414143412C634141633B414143643B414143413B';
wwv_flow_imp.g_varchar2_table(1116) := '3B414145413B414143413B414143413B3B414145413B414143412C6F4341416F433B41414370432C3842414138423B41414339422C7343414173433B41414374432C6743414167433B41414368432C6943414169433B4141436A432C6743414167433B41';
wwv_flow_imp.g_varchar2_table(1117) := '414368432C7743414177432C4F41414F3B4141432F432C7343414173432C4F41414F3B41414337432C6F4341416F433B41414370433B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1118) := '3B414143413B414143413B414143413B414143412C4D41414D3B4141434E3B414143412C634141632C7942414179423B41414376433B414143412C634141633B414143643B414143413B3B414145413B414143413B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(1119) := '2C3043414130433B41414331433B3B414145412C3242414132423B3B41414533423B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C6341';
wwv_flow_imp.g_varchar2_table(1120) := '41632C514141513B41414374423B414143412C634141632C4F41414F3B41414372423B414143413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(1121) := '414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C634141632C514141513B41414374423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1122) := '413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C6742414167423B41414368';
wwv_flow_imp.g_varchar2_table(1123) := '423B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C6F4241416F423B';
wwv_flow_imp.g_varchar2_table(1124) := '41414370422C7742414177423B41414378423B414143413B414143413B3B414145413B414143412C614141612C4F41414F3B41414370423B414143413B3B414145412C3643414136432C6742414167423B41414337443B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1125) := '43413B414143412C7343414173433B41414374433B414143413B414143413B414143413B3B414145413B414143412C7742414177422C4F41414F3B4141432F423B3B414145413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1126) := '3B414143413B414143413B414143413B3B414145413B414143412C2B4341412B433B4141432F433B414143413B3B414145413B414143413B3B414145413B414143412C3042414130423B41414331423B414143413B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1127) := '3B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145412C7742414177423B41414378423B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145412C55414155';
wwv_flow_imp.g_varchar2_table(1128) := '2C7142414171423B4141432F423B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145412C554141553B414143563B414143413B3B414145413B414143412C3042414130422C4F41414F3B4141436A43';
wwv_flow_imp.g_varchar2_table(1129) := '3B3B414145412C6944414169443B4141436A443B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1130) := '3B414143412C654141652C574141573B41414331423B3B414145412C2B4341412B433B4141432F433B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(1131) := '4143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1132) := '43413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C6B4241416B423B4141436C422C67424141';
wwv_flow_imp.g_varchar2_table(1133) := '67423B41414368423B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(1134) := '4143413B414143413B3B414145413B414143413B414143413B414143413B3B414145412C554141553B3B414145563B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1135) := '43413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C594141593B4141435A3B414143413B414143413B3B414145413B3B';
wwv_flow_imp.g_varchar2_table(1136) := '414145413B414143413B3B3B414147413B414143413B3B414145413B414143412C7943414179432C4F41414F3B3B41414568443B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(1137) := '3B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C6742414167423B41414368423B414143413B414143413B3B414145413B414143413B3B';
wwv_flow_imp.g_varchar2_table(1138) := '414145413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143412C6D4341416D433B4141436E433B414143413B414143412C6742414167422C514141513B41414378423B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(1139) := '414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1140) := '413B3B414145413B414143413B414143413B414143413B414143412C514141513B3B414145523B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1141) := '3B414143413B414143413B3B414145413B3B3B414147413B414143412C7143414171433B41414372433B414143413B414143412C534141533B414143543B414143413B414143412C534141533B414143543B414143413B414143413B414143412C534141';
wwv_flow_imp.g_varchar2_table(1142) := '533B414143542C4F41414F3B414143503B3B414145413B414143413B3B414145412C7343414173433B41414374433B414143412C514141513B414143523B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1143) := '4143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C55';
wwv_flow_imp.g_varchar2_table(1144) := '4141553B414143563B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143412C7342414173423B41414374423B3B414145413B414143412C3644414136443B41414337443B41';
wwv_flow_imp.g_varchar2_table(1145) := '4143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143412C7744414177443B41414378443B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1146) := '3B3B414147413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143412C7342414173423B41414374423B414143413B414143413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1147) := '43413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C7742414177423B41414378423B414143413B414143413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1148) := '4143413B414143413B414143413B414143412C7742414177423B41414378423B414143413B414143412C554141552C7142414171423B4141432F423B414143413B414143412C554141552C7142414171423B4141432F423B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1149) := '43413B3B3B414147413B414143413B414143412C7342414173423B3B41414574423B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145412C324341';
wwv_flow_imp.g_varchar2_table(1150) := '4132433B41414333432C7342414173423B41414374423B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143412C654141652C4F41414F3B414143';
wwv_flow_imp.g_varchar2_table(1151) := '74423B3B414145412C2B4341412B433B4141432F433B414143413B3B414145413B414143413B3B414145412C514141513B414143522C3443414134433B41414335433B3B414145413B414143413B3B414145412C554141553B414143563B3B414145413B';
wwv_flow_imp.g_varchar2_table(1152) := '414143413B414143413B3B414145412C6746414167463B41414368463B414143413B3B414145412C6B4341416B432C4F41414F3B4141437A433B3B414145413B414143413B414143413B3B414145412C2B4341412B433B4141432F433B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1153) := '4143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B3B414145';
wwv_flow_imp.g_varchar2_table(1154) := '413B414143412C7943414179433B4141437A433B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145412C3242414132423B414143';
wwv_flow_imp.g_varchar2_table(1155) := '33423B414143413B414143413B3B414145413B414143412C554141553B414143563B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B4141';
wwv_flow_imp.g_varchar2_table(1156) := '45413B414143413B414143413B3B414145413B414143413B414143413B414143412C594141593B4141435A3B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1157) := '4143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143413B414143412C494141493B3B4141454A3B3B41414534433B3B';
wwv_flow_imp.g_varchar2_table(1158) := '3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41437A6A4335433B3B414145413B414143413B3B414145413B414143413B414143412C4D41414D3B3B4141454E3B414143413B414143413B3B414145413B414143413B3B';
wwv_flow_imp.g_varchar2_table(1159) := '414145413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C594141592C594141593B41414378422C594141592C594141593B41414378423B414143412C594141592C594141593B41414378423B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1160) := '414143413B3B414145413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C594141592C594141593B41414378422C594141592C594141593B41414378423B414143412C594141592C594141593B41414378423B41414341';
wwv_flow_imp.g_varchar2_table(1161) := '3B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1162) := '4143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1163) := '4143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1164) := '4143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1165) := '413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143412C494141493B4141434A3B414143413B414143413B3B414145413B3B414145413B3B414145412C6F4241416F422C6D424141';
wwv_flow_imp.g_varchar2_table(1166) := '6D423B41414376433B414143413B414143413B3B414145413B414143413B414143413B414143412C594141592C594141593B41414378422C594141592C514141513B41414370422C594141592C514141513B41414370422C594141592C514141513B4141';
wwv_flow_imp.g_varchar2_table(1167) := '4370423B414143412C594141593B4141435A3B414143413B414143413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143412C494141493B4141434A3B414143413B3B414145413B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(1168) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C594141592C534141533B41414372422C614141613B414143623B414143';
wwv_flow_imp.g_varchar2_table(1169) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C594141592C514141513B414143';
wwv_flow_imp.g_varchar2_table(1170) := '70422C614141613B414143623B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C594141592C654141653B41414333422C614141613B41';
wwv_flow_imp.g_varchar2_table(1171) := '4143623B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C594141592C514141513B41414370422C614141613B';
wwv_flow_imp.g_varchar2_table(1172) := '414143623B414143413B414143413B414143413B414143413B414143412C6B4241416B422C6742414167423B4141436C433B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1173) := '414143413B414143413B414143412C594141592C514141513B41414370422C594141592C534141533B41414372422C614141613B414143623B414143413B414143413B414143413B414143413B414143413B414143412C3842414138423B41414339423B';
wwv_flow_imp.g_varchar2_table(1174) := '414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C614141613B414143623B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1175) := '414143413B414143413B414143412C594141592C514141513B41414370422C614141613B414143623B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1176) := '43413B414143412C594141592C594141593B41414378422C594141592C534141533B41414372423B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1177) := '4143413B414143413B3B414145413B414143413B414143413B3B3B414147413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143412C494141493B3B4141454A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1178) := '3B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(1179) := '3B3B414145413B414143413B414143413B3B3B3B414149413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143412C614141613B414143623B414143413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(1180) := '45413B3B414145413B414143413B414143413B414143412C494141493B4141434A3B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B41';
wwv_flow_imp.g_varchar2_table(1181) := '4145413B414143413B414143413B3B414145413B414143413B414143413B3B3B414147413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145412C634141632C65414165';
wwv_flow_imp.g_varchar2_table(1182) := '3B41414337423B414143413B3B414145413B414143413B3B3B414147413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(1183) := '45413B414143413B414143413B414143413B414143413B414143412C6B4241416B422C594141593B41414339423B414143413B414143413B414143412C594141593B4141435A3B414143413B414143413B3B414145413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1184) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143413B3B414145413B414143413B414143413B414143412C494141493B4141434A3B4141';
wwv_flow_imp.g_varchar2_table(1185) := '43413B414143413B3B414145413B414143413B414143413B3B414145412C3442414134422C454141453B41414339422C3842414138422C454141453B3B41414568433B414143412C614141613B414143622C594141593B4141435A2C594141593B414143';
wwv_flow_imp.g_varchar2_table(1186) := '5A3B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1187) := '3B3B414145413B414143413B414143412C7743414177432C534141533B4141436A443B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C3243414132432C534141533B41414370443B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1188) := '4143412C4D41414D3B4141434E3B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1189) := '4143413B414143413B414143413B3B3B3B414149413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143412C6B4241416B42';
wwv_flow_imp.g_varchar2_table(1190) := '2C6B4241416B423B41414370433B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B41414541';
wwv_flow_imp.g_varchar2_table(1191) := '3B3B414145413B414143413B414143412C4D41414D3B4141434E3B414143413B3B414145413B414143412C494141493B4141434A3B414143413B414143413B3B3B414147413B414143413B414143413B3B414145413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1192) := '413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143412C474141473B414143483B3B414145413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C594141592C594141593B414143';
wwv_flow_imp.g_varchar2_table(1193) := '78422C594141592C594141593B41414378423B414143412C594141592C594141593B41414378423B414143413B414143413B414143413B3B414145413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C594141592C5941';
wwv_flow_imp.g_varchar2_table(1194) := '41593B41414378422C594141592C594141593B41414378423B414143412C594141592C594141593B41414378423B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1195) := '4143413B3B414145413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B3B414147413B414143';
wwv_flow_imp.g_varchar2_table(1196) := '413B3B414145413B3B414145412C634141632C7142414171423B4141436E433B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C594141593B41414376422C594141592C7344414173443B4141436C453B414143';
wwv_flow_imp.g_varchar2_table(1197) := '412C594141592C634141633B41414331423B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B4141456D4D3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41433777';
wwv_flow_imp.g_varchar2_table(1198) := '42764A3B4141435A3B414143593B3B41414535433B414143412C6D4241416D422C634141633B4141436A433B414143413B414143413B414143413B414143412C574141572C634141633B4141437A422C574141572C514141513B4141436E423B41414341';
wwv_flow_imp.g_varchar2_table(1199) := '3B414143412C454141452C304341414D3B414143523B3B414145412C7143414171432C304341414D3B3B41414533433B414143413B414143413B414143412C614141612C514141513B41414372423B414143412C634141632C654141653B41414337422C';
wwv_flow_imp.g_varchar2_table(1200) := '634141632C654141653B41414337422C634141632C634141633B41414335422C634141632C514141513B41414374423B3B414145413B414143413B414143413B414143412C614141612C4F41414F3B41414370423B414143412C634141632C634141633B';
wwv_flow_imp.g_varchar2_table(1201) := '41414335423B3B414145413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C554141553B41414372422C574141572C554141553B41414372423B414143412C614141613B414143623B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(1202) := '2C4F41414F2C6B444141513B414143663B414143413B414143413B3B414145412C6D4241416D422C384341414D2C434141432C674441414D2C474141472C7742414177423B41414333443B3B414145413B414143413B3B3B414147413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1203) := '43413B414143412C614141612C514141513B41414372423B414143412C634141632C514141513B41414374423B3B414145413B414143413B414143413B414143412C574141572C554141553B41414372422C574141572C554141553B41414372423B4141';
wwv_flow_imp.g_varchar2_table(1204) := '43412C614141613B414143623B414143413B3B414145412C6D4241416D422C384341414D3B3B4141457A423B414143413B414143413B3B414145413B414143413B414143412C4F41414F3B414143502C4D41414D3B4141434E3B414143413B414143412C';
wwv_flow_imp.g_varchar2_table(1205) := '474141473B414143483B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1206) := '3B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1207) := '3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1208) := '3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1209) := '3B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1210) := '2C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1211) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1212) := '3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1213) := '3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1214) := '3B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1215) := '3B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1216) := '3B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1217) := '3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1218) := '3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B41414346';
wwv_flow_imp.g_varchar2_table(1219) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B41414346';
wwv_flow_imp.g_varchar2_table(1220) := '3B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1221) := '3B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1222) := '3B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1223) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B41414341';
wwv_flow_imp.g_varchar2_table(1224) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1225) := '2C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1226) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B41414341';
wwv_flow_imp.g_varchar2_table(1227) := '3B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1228) := '3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1229) := '3B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1230) := '3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1231) := '2C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1232) := '3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1233) := '3B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B41414341';
wwv_flow_imp.g_varchar2_table(1234) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1235) := '3B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1236) := '3B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1237) := '3B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1238) := '2C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1239) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1240) := '3B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1241) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1242) := '2C494141493B4141434A3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1243) := '2C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1244) := '3B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B41414341';
wwv_flow_imp.g_varchar2_table(1245) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1246) := '3B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1247) := '3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1248) := '3B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1249) := '3B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1250) := '3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1251) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1252) := '3B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1253) := '3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1254) := '2C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1255) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1256) := '3B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B41414341';
wwv_flow_imp.g_varchar2_table(1257) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C454141453B414143463B41414341';
wwv_flow_imp.g_varchar2_table(1258) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1259) := '3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1260) := '3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1261) := '3B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B41414341';
wwv_flow_imp.g_varchar2_table(1262) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1263) := '3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1264) := '3B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1265) := '3B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1266) := '3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1267) := '3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1268) := '3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1269) := '2C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1270) := '3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1271) := '3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1272) := '3B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1273) := '3B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1274) := '3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1275) := '3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1276) := '2C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1277) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1278) := '3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1279) := '2C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1280) := '3B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1281) := '3B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1282) := '3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1283) := '3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1284) := '2C454141453B414143463B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1285) := '3B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1286) := '2C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1287) := '3B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1288) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1289) := '3B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1290) := '3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1291) := '3B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1292) := '2C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1293) := '3B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1294) := '3B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1295) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1296) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1297) := '3B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1298) := '3B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1299) := '3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1300) := '3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1301) := '3B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1302) := '3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1303) := '3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1304) := '3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1305) := '3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1306) := '3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1307) := '3B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1308) := '3B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1309) := '3B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B41414341';
wwv_flow_imp.g_varchar2_table(1310) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1311) := '3B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1312) := '3B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1313) := '3B414143412C494141493B4141434A3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1314) := '3B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1315) := '3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1316) := '3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1317) := '3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1318) := '3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1319) := '3B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1320) := '3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1321) := '2C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1322) := '3B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1323) := '3B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B41414346';
wwv_flow_imp.g_varchar2_table(1324) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1325) := '3B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1326) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1327) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1328) := '3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1329) := '3B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1330) := '3B414143463B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1331) := '3B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1332) := '3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1333) := '3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1334) := '3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1335) := '3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1336) := '3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1337) := '3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1338) := '3B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1339) := '3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1340) := '3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1341) := '3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1342) := '3B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1343) := '3B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B41414341';
wwv_flow_imp.g_varchar2_table(1344) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1345) := '2C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1346) := '3B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1347) := '2C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1348) := '3B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1349) := '3B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1350) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1351) := '3B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1352) := '3B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1353) := '3B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1354) := '3B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C454141453B414143463B41414341';
wwv_flow_imp.g_varchar2_table(1355) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1356) := '2C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1357) := '3B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1358) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1359) := '3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1360) := '3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1361) := '3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1362) := '2C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1363) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1364) := '3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143412C494141493B4141434A3B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1365) := '3B4141434A3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C454141453B41414346';
wwv_flow_imp.g_varchar2_table(1366) := '3B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143412C494141493B4141434A3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C45414145';
wwv_flow_imp.g_varchar2_table(1367) := '3B414143463B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C49414149';
wwv_flow_imp.g_varchar2_table(1368) := '3B4141434A3B414143413B414143412C494141493B4141434A3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1369) := '2C494141493B4141434A3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1370) := '3B414143412C494141493B4141434A3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143412C494141493B4141434A';
wwv_flow_imp.g_varchar2_table(1371) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1372) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1373) := '413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143';
wwv_flow_imp.g_varchar2_table(1374) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1375) := '412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143';
wwv_flow_imp.g_varchar2_table(1376) := '413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1377) := '413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141';
wwv_flow_imp.g_varchar2_table(1378) := '493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141';
wwv_flow_imp.g_varchar2_table(1379) := '453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1380) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143';
wwv_flow_imp.g_varchar2_table(1381) := '412C494141493B4141434A3B414143413B414143412C494141493B4141434A3B414143413B414143412C494141493B4141434A3B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C454141453B414143';
wwv_flow_imp.g_varchar2_table(1382) := '463B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1383) := '413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143412C454141453B414143463B414143413B414143412C454141453B414143463B4141';
wwv_flow_imp.g_varchar2_table(1384) := '43413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B4141';
wwv_flow_imp.g_varchar2_table(1385) := '43413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1386) := '43413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1387) := '43413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143412C494141493B4141';
wwv_flow_imp.g_varchar2_table(1388) := '434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1389) := '43413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41';
wwv_flow_imp.g_varchar2_table(1390) := '4143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41';
wwv_flow_imp.g_varchar2_table(1391) := '4143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1392) := '4143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1393) := '4143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1394) := '4143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B41';
wwv_flow_imp.g_varchar2_table(1395) := '4143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41';
wwv_flow_imp.g_varchar2_table(1396) := '4143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1397) := '4143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1398) := '4143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1399) := '4143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B41';
wwv_flow_imp.g_varchar2_table(1400) := '4143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1401) := '4143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1402) := '4143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1403) := '414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1404) := '414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1405) := '414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1406) := '3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1407) := '3B414143413B414143413B414143413B414143412C454141453B414143463B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1408) := '3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(1409) := '45413B414143412C594141592C674441414D2C474141473B3B41414572423B414143413B3B41414536423B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436A714837422C6743414167433B3B3B41414768433B414143412C574141572C554141553B414143';
wwv_flow_imp.g_varchar2_table(1410) := '72423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143412C574141572C4B41414B3B41414368423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(1411) := '2C574141572C4B41414B3B41414368422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143412C614141612C7543414175433B41414370443B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1412) := '43413B414143413B414143412C594141592C6D4341416D433B4141432F433B414143412C594141593B4141435A3B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B3B3B4141';
wwv_flow_imp.g_varchar2_table(1413) := '47413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C7142414171423B41414372423B414143412C2B4341412B433B4141432F433B414143413B3B414145413B414143413B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(1414) := '2C574141572C534141533B41414370423B414143412C594141593B4141435A3B414143413B3B414145413B414143412C7743414177432C474141473B41414333433B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B3B';
wwv_flow_imp.g_varchar2_table(1415) := '414145413B414143413B414143413B414143412C474141473B414143483B3B414145413B414143412C634141632C7943414179433B41414376442C634141632C7743414177433B41414374442C634141632C7543414175433B41414372443B414143412C';
wwv_flow_imp.g_varchar2_table(1416) := '634141632C6B4441416B443B41414368453B3B414145413B414143413B414143413B414143412C574141572C6F4241416F423B4141432F422C574141572C6942414169423B41414335423B414143413B3B414145413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1417) := '413B414143413B414143412C514141513B414143522C7943414179432C4D41414D3B4141432F433B414143413B414143412C474141473B3B414145483B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143412C6943';
wwv_flow_imp.g_varchar2_table(1418) := '414169432C4D41414D2C654141652C4F41414F3B41414337443B3B414145413B414143413B414143413B414143412C614141612C514141513B41414372422C614141612C534141533B41414374423B414143412C634141633B414143643B414143413B41';
wwv_flow_imp.g_varchar2_table(1419) := '4143413B3B414145413B414143412C6B4341416B432C534141533B3B41414533433B414143412C6B4341416B432C534141533B41414333433B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1420) := '414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C514141513B41414352';
wwv_flow_imp.g_varchar2_table(1421) := '2C7543414175432C494141493B41414333433B414143413B3B414145413B414143412C634141633B414143643B414143413B414143413B414143413B414143413B414143412C514141513B414143523B414143413B414143412C4B41414B3B3B4141454C';
wwv_flow_imp.g_varchar2_table(1422) := '3B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C634141632C7143414171433B4141436E443B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1423) := '414143412C4D41414D3B3B4141454E3B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C634141632C7143414171433B4141436E442C634141632C534141533B41414376422C634141';
wwv_flow_imp.g_varchar2_table(1424) := '632C534141533B41414376423B414143412C634141632C474141473B4141436A423B414143413B414143413B414143413B414143413B414143412C4D41414D3B3B4141454E3B414143413B3B414145413B414143412C614141612C554141553B41414376';
wwv_flow_imp.g_varchar2_table(1425) := '423B414143412C634141633B414143643B414143413B414143413B414143413B3B414145413B414143412C614141612C6F4241416F423B4141436A432C614141612C554141553B41414376423B414143412C634141633B414143643B414143413B414143';
wwv_flow_imp.g_varchar2_table(1426) := '413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1427) := '3B414143413B414143413B414143412C634141633B414143643B414143413B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1428) := '412C574141573B414143583B414143413B3B414145413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1429) := '3B414143413B3B414145413B414143412C614141612C6B4241416B423B4141432F422C614141612C554141553B41414376423B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C554141553B41';
wwv_flow_imp.g_varchar2_table(1430) := '4143563B414143413B414143412C4F41414F3B414143503B414143413B3B414145413B414143412C614141612C6B4241416B423B4141432F423B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1431) := '413B414143413B3B414145413B414143412C4F41414F3B3B414145503B3B414145413B414143413B414143413B414143412C4F41414F3B3B414145503B414143413B414143412C4F41414F3B3B414145503B414143413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1432) := '43412C4F41414F3B3B414145502C7943414179433B4141437A433B414143412C4F41414F3B3B414145503B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145412C3043414130432C6D4241416D423B4141433744';
wwv_flow_imp.g_varchar2_table(1433) := '3B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143412C4B41414B3B3B4141454C3B414143413B3B414145413B414143412C614141612C6F4241416F423B4141436A432C614141612C6B';
wwv_flow_imp.g_varchar2_table(1434) := '4241416B423B4141432F423B414143412C634141633B414143643B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143412C614141612C6F4241';
wwv_flow_imp.g_varchar2_table(1435) := '416F423B4141436A433B414143412C654141652C614141613B41414335423B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1436) := '413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B3B414147413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B41414567443B41414368443B3B3B3B3B';
wwv_flow_imp.g_varchar2_table(1437) := '3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436866413B414143413B414143413B414143413B414143413B414143412C574141572C6F4241416F423B4141432F423B414143412C';
wwv_flow_imp.g_varchar2_table(1438) := '594141593B4141435A3B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1439) := '3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143412C574141572C4B41414B3B41414368423B414143412C594141593B4141435A3B414143413B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1440) := '414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C574141572C514141513B4141436E423B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1441) := '3B414145413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(1442) := '414143413B414143412C634141633B414143643B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B3B414145413B414143413B414143413B414143413B414143412C634141633B414143643B414143412C4F41414F';
wwv_flow_imp.g_varchar2_table(1443) := '3B414143503B3B3B414147413B414143413B414143412C634141632C6743414167433B41414339433B3B414145413B414143413B414143412C634141632C4D41414D3B41414370423B3B414145413B414143413B414143412C6742414167422C71424141';
wwv_flow_imp.g_varchar2_table(1444) := '71423B41414372433B3B414145413B414143413B414143412C6742414167422C7142414171423B41414372433B3B414145413B414143413B414143412C634141632C3444414134443B41414331453B3B414145413B414143413B414143412C634141632C';
wwv_flow_imp.g_varchar2_table(1445) := '3643414136433B41414333443B3B414145413B414143413B414143413B414143413B414143412C574141572C654141653B41414331422C574141572C594141593B41414376423B414143412C594141593B4141435A3B414143413B3B414145413B3B4141';
wwv_flow_imp.g_varchar2_table(1446) := '45413B3B414145413B414143413B414143413B3B414145413B414143413B414143412C474141473B3B414145483B3B414145413B3B3B414147413B414143413B414143413B414143413B414143412C574141572C654141653B41414331422C574141572C';
wwv_flow_imp.g_varchar2_table(1447) := '594141593B41414376423B414143412C594141593B4141435A3B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143412C474141473B3B414145483B414143413B3B3B414147413B4141';
wwv_flow_imp.g_varchar2_table(1448) := '43413B414143413B414143413B414143412C574141572C654141653B41414331422C574141572C594141593B41414376423B414143412C594141592C4B41414B3B4141436A423B414143413B3B414145413B3B414145413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(1449) := '4143413B414143413B414143412C474141473B3B414145483B414143413B3B3B414147413B414143412C3442414134423B41414335423B414143413B414143413B414143412C574141572C654141653B41414331422C594141592C3046414130463B4141';
wwv_flow_imp.g_varchar2_table(1450) := '4374473B414143412C594141592C474141473B414143663B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1451) := '3B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C574141572C6F4241416F423B4141432F422C574141572C594141593B41414376423B414143412C594141593B4141435A3B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1452) := '413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143412C474141473B3B414145483B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C654141653B4141';
wwv_flow_imp.g_varchar2_table(1453) := '4331422C574141572C7743414177433B4141436E442C574141572C474141473B414143643B414143412C594141592C474141473B414143663B414143413B3B414145413B414143413B414143412C474141473B3B414145483B414143413B3B3B41414741';
wwv_flow_imp.g_varchar2_table(1454) := '3B414143413B414143413B414143413B414143412C594141592C634141633B41414331422C594141592C554141553B41414374423B414143412C594141593B4141435A3B414143413B3B414145413B414143413B414143412C474141473B414143483B3B';
wwv_flow_imp.g_varchar2_table(1455) := '3B414147413B414143413B414143413B414143413B414143412C594141592C634141633B41414331422C594141592C554141553B41414374423B414143412C594141593B4141435A3B414143413B3B414145413B414143413B3B3B414147413B41414341';
wwv_flow_imp.g_varchar2_table(1456) := '3B414143413B414143413B414143412C594141592C6742414167423B41414335422C594141592C554141553B41414374423B414143412C594141592C4F41414F3B4141436E423B414143413B3B414145413B3B414145413B414143413B414143412C4741';
wwv_flow_imp.g_varchar2_table(1457) := '41473B3B414145483B414143413B3B3B414147413B414143413B414143413B414143412C594141592C634141633B41414331423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B3B414147413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1458) := '4143412C594141592C634141633B41414331423B414143412C594141593B4141435A3B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C594141592C634141633B41414331423B414143412C594141593B4141';
wwv_flow_imp.g_varchar2_table(1459) := '435A3B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C574141572C634141633B4141437A422C574141572C574141573B41414374423B414143412C594141592C514141512C574141573B4141432F423B4141';
wwv_flow_imp.g_varchar2_table(1460) := '43412C6F4441416F443B3B41414570443B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143412C474141473B3B414145483B414143413B3B3B414147413B3B414145413B3B414145413B3B414145';
wwv_flow_imp.g_varchar2_table(1461) := '413B3B414145413B414143413B414143412C474141473B3B414145483B414143413B3B3B414147413B3B3B3B414149413B414143413B414143413B414143413B414143413B414143412C574141572C654141653B41414331422C574141572C2B4241412B';
wwv_flow_imp.g_varchar2_table(1462) := '423B41414331433B414143412C594141593B4141435A3B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145412C7342414173422C7142414171423B41414333432C5941';
wwv_flow_imp.g_varchar2_table(1463) := '41592C494141493B3B41414568423B414143413B414143413B414143413B414143413B3B414145413B414143413B414143412C474141473B3B414145483B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1464) := '4143412C6B4341416B432C4F41414F3B4141437A433B414143413B414143413B414143413B414143413B414143413B414143412C574141572C474141473B414143643B414143412C614141612C7742414177423B41414372433B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(1465) := '3B3B414145413B414143413B414143412C4B41414B3B3B4141454C3B414143413B3B3B414147413B414143412C574141572C3642414136423B41414378433B414143412C614141613B414143623B414143413B3B414145413B414143412C6B4241416B42';
wwv_flow_imp.g_varchar2_table(1466) := '3B4141436C423B414143413B3B414145413B414143413B414143413B414143413B3B3B414147413B414143413B414143412C574141572C594141593B41414376423B414143412C594141593B4141435A3B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1467) := '3B414143413B3B3B414147413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1468) := '413B414143413B414143413B414143413B414143413B414143412C594141592C554141553B41414374422C594141592C514141513B41414370423B414143412C594141592C6D4241416D423B4141432F423B414143413B3B414145413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1469) := '4143413B3B414145413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B41';
wwv_flow_imp.g_varchar2_table(1470) := '4145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143412C614141613B414143623B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1471) := '4143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143412C594141592C554141553B41414374422C594141592C514141513B41414370423B414143412C594141592C55';
wwv_flow_imp.g_varchar2_table(1472) := '4141553B41414374423B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143412C4B41414B3B4141434C3B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1473) := '414143412C594141592C554141553B41414374422C594141592C554141553B41414374423B414143412C594141592C554141553B41414374423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C51';
wwv_flow_imp.g_varchar2_table(1474) := '4141513B4141436E422C574141572C574141573B41414374423B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1475) := '43412C574141572C474141473B414143642C574141572C6D4241416D423B41414339422C574141572C4B41414B3B41414368423B414143412C594141593B4141435A3B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1476) := '3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143412C3644414136443B41414337443B3B414145413B414143413B414143413B414143412C514141513B414143523B4141';
wwv_flow_imp.g_varchar2_table(1477) := '43413B414143412C4D41414D3B4141434E3B414143413B414143412C474141473B3B414145483B414143413B3B3B414147413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C6D4241416D423B41414339422C';
wwv_flow_imp.g_varchar2_table(1478) := '574141572C4B41414B3B41414368423B414143412C594141593B4141435A3B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143412C474141473B3B414145483B414143';
wwv_flow_imp.g_varchar2_table(1479) := '413B3B414145413B414143413B414143413B414143413B414143412C634141632C4F41414F3B41414372423B414143412C574141572C474141473B414143642C574141572C474141473B414143643B414143413B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(1480) := '3B414145413B3B414145413B3B414145413B414143413B414143413B414143412C474141473B3B414145483B414143413B3B414145413B414143413B414143413B414143413B414143412C634141632C4F41414F3B41414372423B414143412C57414157';
wwv_flow_imp.g_varchar2_table(1481) := '2C474141473B414143642C574141572C474141473B414143643B414143412C594141592C594141593B41414378423B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143412C474141473B3B414145';
wwv_flow_imp.g_varchar2_table(1482) := '483B414143413B3B414145413B414143413B414143413B414143412C6943414169433B4141436A433B414143412C574141572C514141513B4141436E422C574141572C574141573B41414374423B414143412C594141592C514141513B41414370423B41';
wwv_flow_imp.g_varchar2_table(1483) := '4143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1484) := '43413B3B414145413B414143412C514141513B414143523B414143413B3B414145412C4B41414B3B4141434C2C474141473B3B414145483B414143413B3B41414569553B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143763242394F3B41414370443B';
wwv_flow_imp.g_varchar2_table(1485) := '41414377433B3B41414576453B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B41';
wwv_flow_imp.g_varchar2_table(1486) := '4145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1487) := '3B414143413B3B414145413B3B414145412C654141652C6D444141573B41414331423B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C594141592C7742414177423B4141437043';
wwv_flow_imp.g_varchar2_table(1488) := '3B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C6742414167423B414143';
wwv_flow_imp.g_varchar2_table(1489) := '33422C574141572C534141533B41414370423B414143413B3B414145413B414143412C6742414167422C6742414167423B41414368433B3B414145413B414143412C6742414167422C534141533B4141437A423B3B414145412C454141452C674441414D';
wwv_flow_imp.g_varchar2_table(1490) := '3B3B414145523B414143413B414143413B3B414145413B414143413B414143413B414143412C614141612C514141513B41414372423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C614141612C654141653B';
wwv_flow_imp.g_varchar2_table(1491) := '41414335423B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(1492) := '4143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C614141612C514141513B41414372422C614141612C514141513B41414372422C614141612C4F41414F3B41414370423B414143413B41';
wwv_flow_imp.g_varchar2_table(1493) := '4143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1494) := '3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143412C494141493B4141434A3B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1495) := '43413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B';
wwv_flow_imp.g_varchar2_table(1496) := '414145412C554141552C6B444141553B3B41414570423B414143413B414143412C494141493B4141434A3B414143413B414143413B3B3B414147413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1497) := '4143412C494141493B4141434A3B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B41';
wwv_flow_imp.g_varchar2_table(1498) := '4145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143412C594141592C6B444141553B41414374';
wwv_flow_imp.g_varchar2_table(1499) := '423B414143413B414143413B3B414145413B414143413B414143413B414143412C594141592C534141533B41414372423B414143413B414143413B414143413B414143413B414143413B414143412C3442414134423B41414335423B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(1500) := '45412C454141452C694441414F3B3B414145543B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143412C534141533B414143542C514141513B3B414145523B414143413B3B414145412C514141512C69';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(1501) := '4441414F3B414143663B414143413B414143413B414143413B414143412C574141573B414143582C534141533B414143543B3B414145412C4D41414D3B4141434E3B414143412C6742414167422C6B444141553B41414331422C514141513B414143523B';
wwv_flow_imp.g_varchar2_table(1502) := '414143412C7142414171422C6D444141573B3B41414568433B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C574141573B414143583B414143413B3B414145413B414143413B414143412C474141';
wwv_flow_imp.g_varchar2_table(1503) := '473B3B414145483B414143413B3B414145413B3B414145413B414143412C654141652C6D444141573B3B41414531423B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1504) := '413B3B414145413B414143413B414143413B3B414145413B414143412C3243414132432C574141573B41414374443B3B414145413B3B414145412C654141652C674441414D2C474141473B41414378423B414143412C534141533B414143543B41414341';
wwv_flow_imp.g_varchar2_table(1505) := '3B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143412C654141652C38434141493B4141436E423B414143412C4B41414B3B3B4141454C3B414143412C614141612C674441414D2C47';
wwv_flow_imp.g_varchar2_table(1506) := '4141473B41414374423B414143412C4F41414F3B414143503B414143412C494141493B3B4141454A3B414143412C654141652C38434141493B4141436E423B414143412C4B41414B3B3B4141454C3B414143413B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(1507) := '414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(1508) := '414143413B414143413B414143412C594141592C534141533B41414372423B414143413B414143413B3B414145413B414143413B3B414145413B3B414145412C4D41414D2C6F444141593B4141436C423B414143413B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1509) := '412C494141493B4141434A3B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143412C4D41414D3B4141434E3B414143413B3B414145413B414143412C4D41414D2C674441414D3B4141435A3B414143';
wwv_flow_imp.g_varchar2_table(1510) := '412C4F41414F3B3B414145503B414143412C4D41414D3B3B4141454E3B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E';
wwv_flow_imp.g_varchar2_table(1511) := '422C574141572C514141513B4141436E422C574141572C534141533B41414370423B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143412C654141652C6D444141573B41414331423B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1512) := '4143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143412C57414157';
wwv_flow_imp.g_varchar2_table(1513) := '2C6D444141573B41414374423B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(1514) := '414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C4F41414F3B4141436C422C574141572C534141533B41414370423B';
wwv_flow_imp.g_varchar2_table(1515) := '414143413B3B414145412C7942414179422C304341414D3B4141432F423B414143413B414143413B414143413B3B414145412C454141452C674441414D2C534141532C594141593B41414337423B3B414145413B414143413B414143413B414143412C61';
wwv_flow_imp.g_varchar2_table(1516) := '4141612C514141513B41414372423B414143412C634141632C654141653B41414337422C634141632C654141653B41414337422C634141632C634141633B41414335422C634141632C514141513B41414374423B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1517) := '414143412C614141612C4F41414F3B41414370423B414143412C634141632C634141633B41414335423B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C7542414175423B4141436C433B414143';
wwv_flow_imp.g_varchar2_table(1518) := '412C614141613B414143623B414143413B3B414145413B3B414145413B3B414145412C7543414175432C3642414136423B41414370453B414143413B414143412C494141493B4141434A3B3B414145413B414143413B414143413B414143412C4D41414D';
wwv_flow_imp.g_varchar2_table(1519) := '3B3B4141454E2C7743414177432C3242414132423B4141436E453B414143413B414143413B3B414145413B414143413B3B414145412C3442414134422C674441414D2C474141472C614141612C3042414130423B41414335452C6D4241416D422C794341';
wwv_flow_imp.g_varchar2_table(1520) := '414D2C474141472C614141613B4141437A433B3B414145413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143412C634141632C4F41414F3B41414372422C634141632C554141553B41414378422C634141632C534141533B';
wwv_flow_imp.g_varchar2_table(1521) := '41414376423B414143412C634141632C534141533B41414376423B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1522) := '3B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C4F41414F3B3B414145503B414143412C4D41414D3B4141434E3B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(1523) := '3B414143413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145412C6742414167422C7142414171423B41414372433B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1524) := '414143412C534141533B414143543B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143412C554141553B3B414145563B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1525) := '414143412C514141513B414143523B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(1526) := '45413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B3B414145413B414143413B3B414145413B414143413B414143412C4D41414D3B3B4141454E3B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1527) := '413B414143413B3B414145413B3B414145413B414143413B414143412C4D41414D3B4141434E3B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1528) := '4143413B3B414145413B414143412C474141473B414143483B414143412C474141473B414143483B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143412C4F41414F2C494141493B3B';
wwv_flow_imp.g_varchar2_table(1529) := '414145583B414143413B414143413B414143413B414143413B414143413B3B414145413B414143412C4B41414B3B4141434C3B414143413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1530) := '413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143412C4D41414D3B4141434E3B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1531) := '4143413B3B414145413B414143412C4D41414D3B4141434E3B414143413B414143413B414143413B414143413B414143412C4F41414F3B414143503B414143412C474141473B414143483B3B414145413B414143413B414143413B3B3B414147413B3B41';
wwv_flow_imp.g_varchar2_table(1532) := '4145413B414143413B3B414145413B414143413B414143413B414143413B414143412C474141473B3B414145483B414143413B3B414145413B3B414145413B414143413B3B3B414147413B3B414145413B414143413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1533) := '413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143412C4D41414D3B4141434E3B414143413B3B414145413B414143413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(1534) := '4143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1535) := '413B3B414145413B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B3B';
wwv_flow_imp.g_varchar2_table(1536) := '414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B414143483B3B414145413B414143412C4D41414D2C6B444141513B414143643B414143412C494141493B414143';
wwv_flow_imp.g_varchar2_table(1537) := '4A3B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143412C474141473B414143483B414143412C614141613B414143622C474141473B3B414145483B3B414145413B414143413B414143412C574141572C674441';
wwv_flow_imp.g_varchar2_table(1538) := '414D2C474141472C6F4341416F433B41414378442C494141493B4141434A2C574141572C674441414D2C474141472C6B4541416B453B41414374463B414143413B3B414145413B414143412C534141532C674441414D2C474141472C6F4341416F433B41';
wwv_flow_imp.g_varchar2_table(1539) := '414374443B3B414145413B414143413B3B414145412C534141532C674441414D3B414143663B3B414145413B414143413B414143413B3B414145413B414143412C534141532C36434141473B4141435A3B414143413B3B414145413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1540) := '43413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143412C474141473B414143483B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1541) := '3B3B414145413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143412C514141512C6B444141513B3B41414568423B414143412C6D4341416D433B4141436E432C474141473B414143483B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(1542) := '3B414143413B414143412C574141572C514141513B4141436E422C594141592C514141513B41414370423B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143412C534141532C674441414D2C73424141';
wwv_flow_imp.g_varchar2_table(1543) := '73422C6B4241416B423B41414376443B3B414145413B414143412C534141532C674441414D2C7342414173422C6D4241416D423B41414378443B3B3B414147413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1544) := '413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1545) := '3B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B';
wwv_flow_imp.g_varchar2_table(1546) := '414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143412C494141493B4141434A3B414143413B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1547) := '2C494141493B4141434A3B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1548) := '43413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C534141533B41414370423B414143412C594141592C514141513B414143';
wwv_flow_imp.g_varchar2_table(1549) := '70423B414143413B3B414145413B3B414145412C4D41414D2C6B444141513B414143642C534141532C6D444141573B41414370422C494141493B4141434A3B414143413B3B414145413B414143413B414143412C614141613B414143623B3B414145413B';
wwv_flow_imp.g_varchar2_table(1550) := '414143413B3B414145413B414143413B3B414145413B414143413B414143412C614141613B414143622C494141493B4141434A2C574141572C674441414D2C474141472C7942414179423B41414337433B414143413B3B414145413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1551) := '43413B3B414145413B3B414145412C454141452C694441414F3B3B414145543B3B414145413B414143412C3643414136432C6742414167423B41414337442C4D41414D3B4141434E3B414143412C4D41414D2C694441414F3B414143623B414143412C4F';
wwv_flow_imp.g_varchar2_table(1552) := '41414F3B414143502C4D41414D3B4141434E3B414143413B3B414145413B414143412C3042414130422C7542414175423B4141436A443B414143413B414143412C474141473B3B414145483B414143413B3B414145413B414143413B3B414145412C6541';
wwv_flow_imp.g_varchar2_table(1553) := '41652C6D444141573B3B41414531423B3B414145413B414143413B414143412C574141573B414143583B3B414145413B414143413B414143412C574141573B414143583B3B414145413B414143413B414143413B414143413B414143413B414143413B3B';
wwv_flow_imp.g_varchar2_table(1554) := '414145413B3B414145413B414143413B414143412C494141493B3B4141454A3B414143413B3B414145413B414143413B414143413B3B3B414147413B414143413B414143413B414143412C594141592C514141513B41414370422C594141593B4141435A';
wwv_flow_imp.g_varchar2_table(1555) := '3B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143412C454141452C694441414F3B3B414145543B3B414145413B414143413B414143413B414143412C474141473B3B414145483B414143413B3B41';
wwv_flow_imp.g_varchar2_table(1556) := '4145413B3B414145413B3B414145412C454141452C694441414F3B3B414145543B414143413B414143413B414143413B414143413B3B414145413B414143413B414143412C4D41414D3B4141434E3B3B414145413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1557) := '414143413B414143412C474141473B414143483B3B414145413B3B414145413B414143413B414143413B3B414145412C454141452C694441414F3B414143543B414143413B414143413B3B414145413B414143413B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(1558) := '3B414143412C4D41414D3B4141434E2C514141512C6F444141593B41414370422C4D41414D2C694441414F3B414143623B414143412C4F41414F3B414143502C4D41414D3B4141434E3B414143412C4D41414D2C694441414F3B414143623B414143412C';
wwv_flow_imp.g_varchar2_table(1559) := '4F41414F3B414143502C4D41414D3B3B4141454E3B414143413B414143413B414143413B3B414145412C4D41414D2C694441414F3B414143623B3B414145413B414143413B414143412C554141553B414143563B414143413B414143412C554141553B41';
wwv_flow_imp.g_varchar2_table(1560) := '4143563B414143413B3B414145413B414143412C4F41414F3B414143503B414143412C474141473B414143483B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143412C4D41414D3B41';
wwv_flow_imp.g_varchar2_table(1561) := '41434E3B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1562) := '413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143412C614141613B414143623B3B414145412C6D4641416D463B3B4141456E463B';
wwv_flow_imp.g_varchar2_table(1563) := '3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145412C3642414136422C3642414136423B41414331443B3B414145413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1564) := '3B3B414145413B414143413B3B414145413B414143413B414143413B3B414145412C454141452C694441414F3B3B414145543B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143412C514141512C694441414F3B41';
wwv_flow_imp.g_varchar2_table(1565) := '4143663B414143412C534141533B3B414145543B414143413B414143413B3B414145413B3B414145413B414143412C474141473B414143483B3B414145413B414143413B3B414145413B3B414145413B414143413B3B414145413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1566) := '412C4D41414D2C6B444141513B414143643B414143413B3B414145413B414143413B414143412C594141592C6D444141533B41414372423B414143413B414143413B414143413B414143413B414143412C474141473B3B414145482C654141653B3B4141';
wwv_flow_imp.g_varchar2_table(1567) := '45663B414143413B414143412C494141493B4141434A3B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145412C454141452C694441414F3B414143543B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1568) := '412C474141473B414143483B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145412C494141492C69';
wwv_flow_imp.g_varchar2_table(1569) := '4441414F3B414143583B414143412C4B41414B3B3B4141454C3B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B';
wwv_flow_imp.g_varchar2_table(1570) := '414145413B3B414145413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1571) := '43413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B3B414145413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1572) := '413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1573) := '413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E423B414143413B3B414145412C594141592C674441414D2C474141472C2B4241412B422C654141653B3B4141456E453B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1574) := '3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B41414530423B41414331423B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436A77';
wwv_flow_imp.g_varchar2_table(1575) := '4467463B3B41414568463B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C';
wwv_flow_imp.g_varchar2_table(1576) := '594141593B41414376423B414143413B414143413B414143413B414143413B3B3B414147413B3B414145413B3B414145413B414143413B3B414145413B414143412C454141452C694441414F3B414143543B414143413B414143413B414143412C474141';
wwv_flow_imp.g_varchar2_table(1577) := '473B3B414145483B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143412C6B4341416B432C2B4241412B423B4141436A452C6D4341416D432C574141573B41414339432C6F4341416F432C6742414167423B3B4141';
wwv_flow_imp.g_varchar2_table(1578) := '4570442C494141492C694441414F2C514141512C38434141493B41414376423B414143412C4B41414B3B4141434C3B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1579) := '413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C7742414177422C574141573B4141436E432C7942414179422C7342414173423B4141432F43';
wwv_flow_imp.g_varchar2_table(1580) := '2C7942414179422C7942414179423B4141436C442C7342414173423B41414374423B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143412C494141493B4141434A3B414143413B414143413B3B4141';
wwv_flow_imp.g_varchar2_table(1581) := '45413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E42';
wwv_flow_imp.g_varchar2_table(1582) := '2C574141572C514141513B4141436E423B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143412C494141493B3B4141454A3B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1583) := '414143413B414143412C494141493B4141434A3B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1584) := '43413B414143413B414143413B414143413B3B3B414147413B414143412C534141532C38434141493B414143623B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1585) := '413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C534141533B41414370423B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B3B41';
wwv_flow_imp.g_varchar2_table(1586) := '4145413B414143413B414143412C494141493B4141434A3B414143413B414143413B3B3B414147413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1587) := '4143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(1588) := '414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B3B414147413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C494141493B4141434A3B41414341';
wwv_flow_imp.g_varchar2_table(1589) := '3B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B41';
wwv_flow_imp.g_varchar2_table(1590) := '4145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(1591) := '3B414143412C7942414179422C7142414171422C6742414167422C7742414177423B41414374463B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143412C7744414177443B41414378443B414143413B';
wwv_flow_imp.g_varchar2_table(1592) := '414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145412C454141452C694441414F2C6541';
wwv_flow_imp.g_varchar2_table(1593) := '41652C38434141493B3B41414535423B414143412C514141512C674441414D2C474141473B4141436A423B414143413B414143412C4B41414B3B3B4141454C3B414143413B414143412C4B41414B3B3B4141454C3B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(1594) := '3B414143413B414143412C4D41414D3B4141434E3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B3B414145483B414143413B414143413B3B414145413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1595) := '43412C574141572C6742414167423B41414333422C574141572C594141593B41414376423B414143413B414143413B414143413B3B414145413B3B414145413B3B414145412C454141452C694441414F2C574141572C38434141493B41414378423B3B3B';
wwv_flow_imp.g_varchar2_table(1596) := '414147413B414143413B414143413B3B414145413B414143413B414143413B3B3B414147413B3B414145413B414143412C514141512C674441414D2C474141473B3B4141456A423B3B414145413B414143413B3B414145413B414143412C454141452C69';
wwv_flow_imp.g_varchar2_table(1597) := '4441414F2C594141592C38434141493B4141437A423B414143412C474141473B3B414145483B414143413B414143413B3B3B414147413B414143413B414143413B414143413B3B414145412C534141532C674441414D2C474141473B4141436C423B4141';
wwv_flow_imp.g_varchar2_table(1598) := '43413B414143413B414143412C554141552C674441414D2C6942414169423B4141436A432C474141473B3B414145483B414143413B414143413B3B414145413B414143412C454141452C694441414F2C6B4241416B422C38434141493B3B4141452F423B';
wwv_flow_imp.g_varchar2_table(1599) := '414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145412C494141492C674441414D3B414143563B414143413B414143412C4B41414B3B3B4141454C3B414143412C474141473B3B414145483B414143412C454141452C';
wwv_flow_imp.g_varchar2_table(1600) := '674441414D3B414143523B414143413B414143413B414143412C474141473B3B414145482C454141452C694441414F2C654141652C38434141493B41414335423B3B414145413B3B414145413B414143413B414143412C474141473B3B414145483B4141';
wwv_flow_imp.g_varchar2_table(1601) := '43413B3B414145413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C554141553B41414372422C574141572C534141533B41414370423B41';
wwv_flow_imp.g_varchar2_table(1602) := '4143413B3B414145412C7743414177432C6F4241416F423B3B41414535443B3B414145413B414143413B414143413B414143412C614141612C514141513B41414372422C614141612C534141533B41414374423B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1603) := '4143413B3B414145413B414143413B414143413B414143412C614141612C514141513B41414372423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C614141612C514141513B41414372423B414143413B4141';
wwv_flow_imp.g_varchar2_table(1604) := '43413B414143413B3B414145413B414143413B414143413B3B414145412C454141452C694441414F3B3B414145543B414143413B3B414145412C454141452C694441414F3B414143543B3B3B414147413B414143413B414143413B414143412C59414159';
wwv_flow_imp.g_varchar2_table(1605) := '2C514141513B41414370423B414143412C594141592C594141593B41414378423B414143413B3B414145413B3B414145413B3B414145413B414143413B414143412C474141473B3B414145483B3B414145413B414143413B3B414145413B414143413B3B';
wwv_flow_imp.g_varchar2_table(1606) := '3B414147413B414143412C3243414132432C594141593B41414376443B3B3B3B414149413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C574141572C4F41414F';
wwv_flow_imp.g_varchar2_table(1607) := '3B4141436C423B414143413B414143413B414143413B3B3B414147413B414143413B414143413B414143413B414143412C574141572C514141513B4141436E422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143';
wwv_flow_imp.g_varchar2_table(1608) := '413B3B414145412C4F41414F2C6B444141513B414143663B414143413B3B414145413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143412C494141493B3B41';
wwv_flow_imp.g_varchar2_table(1609) := '41454A3B414143413B414143413B414143413B414143413B414143412C514141513B414143523B414143413B414143412C4D41414D3B4141434E3B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C594141592C';
wwv_flow_imp.g_varchar2_table(1610) := '514141513B41414370422C594141592C514141513B41414370423B414143412C594141593B4141435A3B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1611) := '413B414143413B3B3B414147413B414143413B414143413B414143412C594141592C514141513B41414370422C594141592C514141513B41414370422C594141592C514141513B41414370423B414143413B3B414145413B3B414145413B3B414145413B';
wwv_flow_imp.g_varchar2_table(1612) := '414143413B414143412C634141632C674441414D2C474141473B41414376422C7742414177423B41414378422C4B41414B3B3B4141454C3B414143413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B414143412C75';
wwv_flow_imp.g_varchar2_table(1613) := '43414175432C6D4241416D423B41414331443B3B414145413B414143413B414143413B414143413B414143412C6B4341416B432C634141633B41414368443B3B414145413B414143413B414143413B414143412C574141572C4B41414B3B41414368422C';
wwv_flow_imp.g_varchar2_table(1614) := '574141572C514141513B4141436E423B414143412C594141592C654141653B41414333423B414143413B3B414145413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1615) := '43412C7344414173442C4D41414D2C534141532C634141633B3B4141456E463B414143413B414143412C4D41414D3B3B4141454E3B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B41414541';
wwv_flow_imp.g_varchar2_table(1616) := '3B414143413B414143413B414143413B414143413B414143413B414143412C474141473B414143483B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1617) := '4143413B414143413B414143413B414143413B414143413B414143413B414143412C534141533B414143543B414143413B414143413B414143413B414143413B414143412C574141572C6742414167423B41414333423B414143412C634141632C714241';
wwv_flow_imp.g_varchar2_table(1618) := '4171423B4141436E433B414143412C7143414171433B3B41414572433B3B414145413B414143413B3B414145413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1619) := '4143412C7543414175432C614141613B41414370443B414143412C594141592C654141653B41414333422C594141592C514141513B41414370422C594141592C6742414167423B41414335423B414143413B414143413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1620) := '43413B3B414145413B414143413B3B3B414147413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C7542414175422C6742414167423B41414376433B414143412C594141592C654141653B41414333';
wwv_flow_imp.g_varchar2_table(1621) := '422C594141592C6742414167423B41414335423B414143413B3B414145413B3B414145412C614141612C6B444141513B3B41414572423B3B414145413B414143413B414143413B414143413B3B414145413B414143413B3B3B414147413B414143413B41';
wwv_flow_imp.g_varchar2_table(1622) := '4143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143412C494141493B4141434A3B414143413B41';
wwv_flow_imp.g_varchar2_table(1623) := '4143413B414143413B414143412C594141592C514141513B41414370422C594141592C514141513B41414370422C594141592C514141513B41414370422C594141592C514141513B41414370423B414143413B3B414145413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(1624) := '414143413B414143413B414143412C4B41414B3B4141434C3B414143413B414143412C4B41414B3B4141434C3B414143412C4D41414D2C36434141473B414143543B414143413B3B414145413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1625) := '413B414143413B414143413B414143413B3B414145413B414143413B414143412C3243414132432C6D4341416D433B41414339452C3243414132432C6D4341416D433B41414339452C2B4341412B432C6D4341416D433B4141436C462C6D4441416D442C';
wwv_flow_imp.g_varchar2_table(1626) := '6D4341416D433B3B41414574462C454141452C694441414F3B414143542C514141512C6B444141513B41414368423B414143412C4D41414D3B4141434E3B414143413B414143412C474141473B3B414145483B414143413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(1627) := '4143413B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B3B414145413B414143413B414143413B414143412C594141592C514141513B41414370423B414143413B414143413B414143413B3B414145413B4141';
wwv_flow_imp.g_varchar2_table(1628) := '43413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1629) := '413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B41414538473B41414339473B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B4143722B42413B414143412C3842';
wwv_flow_imp.g_varchar2_table(1630) := '414138422C594141593B41414331433B414143412C574141572C654141653B41414331422C574141572C4D41414D3B4141436A422C574141572C514141513B4141436E422C574141572C514141513B4141436E423B414143412C594141592C7742414177';
wwv_flow_imp.g_varchar2_table(1631) := '423B41414370433B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143412C614141612C514141513B41414372423B414143413B414143413B414143413B414143413B414143413B3B414145413B41414341';
wwv_flow_imp.g_varchar2_table(1632) := '3B414143413B414143413B414143413B414143412C474141473B3B414145483B414143413B414143413B414143413B414143413B414143412C614141612C514141513B41414372423B414143413B414143413B414143413B414143413B414143412C4741';
wwv_flow_imp.g_varchar2_table(1633) := '41473B3B414145483B414143413B414143413B414143413B414143413B414143412C614141612C514141513B41414372422C614141612C514141513B41414372423B414143413B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1634) := '3B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C47';
wwv_flow_imp.g_varchar2_table(1635) := '4141473B3B414145483B414143413B414143413B414143413B414143412C474141473B414143483B414143413B3B414145413B414143413B414143413B414143412C574141572C654141653B41414331423B414143412C594141593B4141435A3B414143';
wwv_flow_imp.g_varchar2_table(1636) := '413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B414143483B414143413B41';
wwv_flow_imp.g_varchar2_table(1637) := '4143413B414143412C4B41414B3B4141434C3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1638) := '4143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143412C474141473B414143483B3B414145413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1639) := '43412C6F4341416F432C6942414169423B41414372443B414143413B414143413B414143413B414143413B414143412C6744414167442C594141593B41414335442C4D41414D2C7942414179422C474141472C3642414136422C4B41414B2C2B4241412B';
wwv_flow_imp.g_varchar2_table(1640) := '423B4141436E473B414143413B414143413B414143413B414143413B414143413B414143413B414143412C574141572C3042414130423B41414372432C574141572C3042414130423B41414372433B414143413B414143413B414143412C714241417142';
wwv_flow_imp.g_varchar2_table(1641) := '2C6F4441416F442C494141492C614141613B41414331463B414143412C654141653B414143662C6D4241416D422C6D4241416D422C494141492C6F4241416F423B41414339443B414143413B414143413B414143413B414143413B414143413B41414341';
wwv_flow_imp.g_varchar2_table(1642) := '3B414143412C6F4241416F422C6D4241416D422C494141492C6F4241416F423B4141432F443B414143412C7342414173423B41414374423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1643) := '413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C594141592C514141513B41414370422C594141592C514141513B41414370423B414143413B';
wwv_flow_imp.g_varchar2_table(1644) := '414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1645) := '414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143413B414143413B414143413B414143413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1646) := '414143413B414143412C4D41414D3B4141434E3B414143413B414143413B414143413B3B414145413B414143412C6945414169452C594141593B41414337453B414143412C614141612C514141513B41414372422C634141632C514141513B4141437442';
wwv_flow_imp.g_varchar2_table(1647) := '2C634141632C534141533B41414376422C634141632C534141533B41414376423B3B41414530433B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41436E5231433B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1648) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145412C3643414136433B3B41414537433B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145';
wwv_flow_imp.g_varchar2_table(1649) := '413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143412C7143414171432C514141513B41414337433B414143413B414143413B3B414145413B3B414145413B3B414145413B414143413B414143412C';
wwv_flow_imp.g_varchar2_table(1650) := '3643414136433B41414337433B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B';
wwv_flow_imp.g_varchar2_table(1651) := '414145413B414143413B414143413B3B414145412C7342414173422C3444414134443B4141436C463B3B414145412C7544414175443B41414376443B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1652) := '43412C4F41414F3B3B414145503B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C4B41414B3B4141434C3B3B414145413B414143413B3B414145413B414143';
wwv_flow_imp.g_varchar2_table(1653) := '413B3B414145413B414143413B3B414145413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143412C474141473B';
wwv_flow_imp.g_varchar2_table(1654) := '3B414145483B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(1655) := '414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1656) := '43413B3B414145413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1657) := '43413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B3B41414541';
wwv_flow_imp.g_varchar2_table(1658) := '3B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B3B414145412C6B4241416B422C4F41414F3B4141437A423B414143413B414143413B414143413B3B414145413B414143413B3B414145413B41';
wwv_flow_imp.g_varchar2_table(1659) := '4143413B3B3B414147413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1660) := '414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145412C574141573B414143583B3B414145413B414143413B414143413B3B41';
wwv_flow_imp.g_varchar2_table(1661) := '4145413B414143413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143412C614141613B414143623B3B414145412C6B4241416B422C594141593B';
wwv_flow_imp.g_varchar2_table(1662) := '41414339423B414143412C6942414169422C3242414132423B41414335433B3B414145412C634141632C594141593B41414331423B414143412C6942414169422C3242414132423B41414335433B3B414145412C634141632C514141513B3B4141457442';
wwv_flow_imp.g_varchar2_table(1663) := '2C6F4241416F422C514141513B41414335423B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B3B41';
wwv_flow_imp.g_varchar2_table(1664) := '4145413B3B414145413B414143413B414143412C594141593B4141435A3B414143413B414143413B414143413B414143413B414143412C614141613B414143623B414143413B414143413B414143413B414143413B3B414145413B414143413B3B3B4141';
wwv_flow_imp.g_varchar2_table(1665) := '47413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1666) := '43413B414143412C554141553B414143563B414143413B414143412C574141572C7542414175423B4141436C432C574141572C7542414175423B4141436C432C574141572C534141533B41414370423B414143412C594141593B4141435A3B414143653B';
wwv_flow_imp.g_varchar2_table(1667) := '414143663B414143413B3B414145413B414143413B3B414145412C7143414171432C514141513B41414337433B3B414145413B414143413B414143413B414143412C4D41414D3B3B4141454E3B414143413B414143413B414143413B414143412C514141';
wwv_flow_imp.g_varchar2_table(1668) := '513B414143523B414143413B414143413B414143413B3B414145412C7943414179432C514141513B4141436A443B3B414145413B414143413B414143413B414143412C554141553B3B414145563B414143413B414143413B414143413B414143412C5941';
wwv_flow_imp.g_varchar2_table(1669) := '41593B4141435A3B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143412C594141593B3B4141455A2C3843414138432C514141513B41414374443B414143413B414143413B414143413B414143413B3B414145413B';
wwv_flow_imp.g_varchar2_table(1670) := '414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B3B414147413B414143413B3B414145413B414143413B414143413B3B414145412C6F4541416F453B41414370453B414143413B3B414145413B414143413B41';
wwv_flow_imp.g_varchar2_table(1671) := '4143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145412C6F4441416F442C514141513B41';
wwv_flow_imp.g_varchar2_table(1672) := '414335443B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1673) := '413B414143413B414143413B414143413B414143413B414143413B414143412C7743414177432C514141513B41414368443B414143413B414143413B414143412C4D41414D3B4141434E2C7343414173432C514141513B41414339433B414143413B4141';
wwv_flow_imp.g_varchar2_table(1674) := '43413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1675) := '4143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B41';
wwv_flow_imp.g_varchar2_table(1676) := '4145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143';
wwv_flow_imp.g_varchar2_table(1677) := '413B414143413B414143413B3B414145412C6942414169423B4141436A422C4F41414F3B3B414145503B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(1678) := '414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1679) := '43413B414143413B414143412C494141493B4141434A3B414143413B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1680) := '413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B414143412C494141493B4141434A3B414143413B';
wwv_flow_imp.g_varchar2_table(1681) := '3B414145412C7143414171432C514141513B41414337433B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145412C6B4241416B422C4F';
wwv_flow_imp.g_varchar2_table(1682) := '41414F3B3B4141457A423B414143413B414143413B414143413B414143412C4D41414D3B4141434E3B414143413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B';
wwv_flow_imp.g_varchar2_table(1683) := '3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143413B4141';
wwv_flow_imp.g_varchar2_table(1684) := '43413B3B414145413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145';
wwv_flow_imp.g_varchar2_table(1685) := '413B3B414145413B3B414145413B414143413B414143413B414143413B3B414145413B414143412C6742414167422C3044414130443B41414331453B414143413B3B414145413B414143413B414143413B3B414145412C7542414175422C594141593B3B';
wwv_flow_imp.g_varchar2_table(1686) := '4141456E433B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B';
wwv_flow_imp.g_varchar2_table(1687) := '414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B414145413B414143413B414143413B3B414145413B414143413B414143413B414143413B414143413B414143413B41';
wwv_flow_imp.g_varchar2_table(1688) := '4143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B414143413B3B414145413B414143412C';
wwv_flow_imp.g_varchar2_table(1689) := '4F41414F3B3B414145503B3B414145413B414143413B414143413B3B414145413B414143412C6D4341416D433B4141436E433B414143413B3B414145413B414143413B414143413B414143412C4F41414F3B3B414145503B414143413B414143412C7742';
wwv_flow_imp.g_varchar2_table(1690) := '414177423B3B41414578422C3043414130432C514141513B4141436C442C6B4441416B443B3B4141456C443B414143413B414143412C6743414167433B41414368432C6744414167443B41414368443B414143412C6F4541416F453B3B41414570452C77';
wwv_flow_imp.g_varchar2_table(1691) := '45414177453B41414378453B414143413B3B414145412C3242414132423B3B41414533423B414143413B3B414145413B414143413B414143413B414143413B414143413B3B414145413B414143413B3B414145413B414143413B3B3B3B3B3B5543313542';
wwv_flow_imp.g_varchar2_table(1692) := '413B554143413B3B554145413B554143413B554143413B554143413B554143413B554143413B554143413B554143413B554143413B554143413B554143413B554143413B554143413B3B554145413B554143413B3B554145413B554143413B554143413B';
wwv_flow_imp.g_varchar2_table(1693) := '3B3B3B3B57437442413B574143413B574143413B574143413B574143412C7943414179432C7743414177433B5741436A463B574143413B574143413B3B3B3B3B574350413B3B3B3B3B574341413B574143413B574143413B574143412C7544414175442C';
wwv_flow_imp.g_varchar2_table(1694) := '6942414169423B57414378453B574143412C6744414167442C614141613B57414337443B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B3B41434E77433B41414378433B4141436F453B414143413B4141434E3B414143413B414143413B41414364';
wwv_flow_imp.g_varchar2_table(1695) := '3B41414367423B414143543B41414376443B414143413B414143412C554141552C304441414D3B41414368423B414143412C6F4241416F423B41414370422C6F4241416F423B41414370422C7342414173423B41414374422C7342414173423B41414374';
wwv_flow_imp.g_varchar2_table(1696) := '422C7542414175423B41414376422C654141653B414143662C2B4241412B423B4141432F422C6B4241416B423B4141436C422C474141473B414143483B414143413B414143412C69454141652C554141552C45414143222C22736F7572636573223A5B22';
wwv_flow_imp.g_varchar2_table(1697) := '7765627061636B3A2F2F62706D6E5669657765722F2E2F6C69622F76696577657250616C657474652F50616C6574746550726F76696465722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6C69622F76696577657250616C6574';
wwv_flow_imp.g_varchar2_table(1698) := '74652F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6D6F64756C65732F63616C6C41637469766974794D6F64756C652F43616C6C41637469766974794D6F64756C652E6A73222C227765627061636B3A2F2F6270';
wwv_flow_imp.g_varchar2_table(1699) := '6D6E5669657765722F2E2F6D6F64756C65732F63616C6C41637469766974794D6F64756C652F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6D6F64756C65732F6472696C6C646F776E43656E746572696E672F44';
wwv_flow_imp.g_varchar2_table(1700) := '72696C6C646F776E43656E746572696E672E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6D6F64756C65732F6472696C6C646F776E43656E746572696E672F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669';
wwv_flow_imp.g_varchar2_table(1701) := '657765722F2E2F6D6F64756C65732F6D756C7469496E7374616E63654D6F64756C652F4D756C7469496E7374616E63654D6F64756C652E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6D6F64756C65732F6D756C7469496E7374';
wwv_flow_imp.g_varchar2_table(1702) := '616E63654D6F64756C652F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6D6F64756C65732F7374796C654D6F64756C652F5374796C654D6F64756C652E6A73222C227765627061636B3A2F2F62706D6E56696577';
wwv_flow_imp.g_varchar2_table(1703) := '65722F2E2F6D6F64756C65732F7374796C654D6F64756C652F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6D6F64756C65732F757365725461736B4D6F64756C652F557365725461736B4D6F64756C652E6A7322';
wwv_flow_imp.g_varchar2_table(1704) := '2C227765627061636B3A2F2F62706D6E5669657765722F2E2F6D6F64756C65732F757365725461736B4D6F64756C652F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D';
wwv_flow_imp.g_varchar2_table(1705) := '6A732F6C69622F426173655669657765722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F5669657765722E6A73222C227765627061636B3A2F2F62706D6E566965';
wwv_flow_imp.g_varchar2_table(1706) := '7765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F636F72652F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F';
wwv_flow_imp.g_varchar2_table(1707) := '42706D6E52656E6465725574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F42706D6E52656E64657265722E6A73222C227765627061636B3A2F';
wwv_flow_imp.g_varchar2_table(1708) := '2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F506174684D61702E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A73';
wwv_flow_imp.g_varchar2_table(1709) := '2F6C69622F647261772F5465787452656E64657265722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F647261772F696E6465782E6A73222C227765627061636B3A';
wwv_flow_imp.g_varchar2_table(1710) := '2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F4472696C6C646F776E42726561646372756D62732E6A73222C227765627061636B3A2F2F62706D6E56';
wwv_flow_imp.g_varchar2_table(1711) := '69657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F4472696C6C646F776E43656E746572696E672E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E';
wwv_flow_imp.g_varchar2_table(1712) := '6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F4472696C6C646F776E4F7665726C61794265686176696F722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F6465';
wwv_flow_imp.g_varchar2_table(1713) := '5F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F53756270726F63657373436F6D7061746962696C6974792E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64';
wwv_flow_imp.g_varchar2_table(1714) := '756C65732F62706D6E2D6A732F6C69622F66656174757265732F6472696C6C646F776E2F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F6665617475';
wwv_flow_imp.g_varchar2_table(1715) := '7265732F6F75746C696E652F4F75746C696E6550726F76696465722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6F75746C696E652F4F75';
wwv_flow_imp.g_varchar2_table(1716) := '746C696E655574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F66656174757265732F6F75746C696E652F696E6465782E6A73222C227765627061636B3A2F';
wwv_flow_imp.g_varchar2_table(1717) := '2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F42706D6E496D706F727465722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F';
wwv_flow_imp.g_varchar2_table(1718) := '62706D6E2D6A732F6C69622F696D706F72742F42706D6E5472656557616C6B65722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F496D706F7274';
wwv_flow_imp.g_varchar2_table(1719) := '65722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F5574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F6465';
wwv_flow_imp.g_varchar2_table(1720) := '5F6D6F64756C65732F62706D6E2D6A732F6C69622F696D706F72742F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F436F6D7061746962';
wwv_flow_imp.g_varchar2_table(1721) := '696C6974795574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F44695574696C2E6A73222C227765627061636B3A2F2F62706D6E566965776572';
wwv_flow_imp.g_varchar2_table(1722) := '2F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4472696C6C646F776E5574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F';
wwv_flow_imp.g_varchar2_table(1723) := '7574696C2F4C6162656C5574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A73222C227765627061636B3A2F2F6270';
wwv_flow_imp.g_varchar2_table(1724) := '6D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F62706D6E2D6A732F6C69622F7574696C2F506F776572656442795574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F64696167';
wwv_flow_imp.g_varchar2_table(1725) := '72616D2D6A732F6C69622F4469616772616D2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F6D6D616E642F436F6D6D616E64496E746572636570746F';
wwv_flow_imp.g_varchar2_table(1726) := '722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F43616E7661732E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F';
wwv_flow_imp.g_varchar2_table(1727) := '64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F456C656D656E74466163746F72792E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69';
wwv_flow_imp.g_varchar2_table(1728) := '622F636F72652F456C656D656E7452656769737472792E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F4576656E744275732E6A73222C227765';
wwv_flow_imp.g_varchar2_table(1729) := '627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F4772617068696373466163746F72792E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F';
wwv_flow_imp.g_varchar2_table(1730) := '64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F636F72652F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F4261';
wwv_flow_imp.g_varchar2_table(1731) := '736552656E64657265722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F44656661756C7452656E64657265722E6A73222C227765627061636B';
wwv_flow_imp.g_varchar2_table(1732) := '3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F647261772F5374796C65732E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F646961';
wwv_flow_imp.g_varchar2_table(1733) := '6772616D2D6A732F6C69622F647261772F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6368616E67652D737570706F';
wwv_flow_imp.g_varchar2_table(1734) := '72742F4368616E6765537570706F72742E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6368616E67652D737570706F72742F696E64';
wwv_flow_imp.g_varchar2_table(1735) := '65782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F696E746572616374696F6E2D6576656E74732F496E746572616374696F6E4576';
wwv_flow_imp.g_varchar2_table(1736) := '656E74732E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F696E746572616374696F6E2D6576656E74732F696E6465782E6A73222C22';
wwv_flow_imp.g_varchar2_table(1737) := '7765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F75746C696E652F4F75746C696E652E6A73222C227765627061636B3A2F2F62706D6E5669657765';
wwv_flow_imp.g_varchar2_table(1738) := '722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F6F75746C696E652F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F64696167';
wwv_flow_imp.g_varchar2_table(1739) := '72616D2D6A732F6C69622F66656174757265732F6F7665726C6179732F4F7665726C6179732E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F666561747572';
wwv_flow_imp.g_varchar2_table(1740) := '65732F6F7665726C6179732F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F70616C657474652F50616C657474652E6A';
wwv_flow_imp.g_varchar2_table(1741) := '73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F70616C657474652F696E6465782E6A73222C227765627061636B3A2F2F62706D6E566965';
wwv_flow_imp.g_varchar2_table(1742) := '7765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F726F6F742D656C656D656E74732F526F6F74456C656D656E74734265686176696F722E6A73222C227765627061636B3A2F2F62706D6E566965';
wwv_flow_imp.g_varchar2_table(1743) := '7765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F726F6F742D656C656D656E74732F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F6475';
wwv_flow_imp.g_varchar2_table(1744) := '6C65732F6469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E2F53656C656374696F6E2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F';
wwv_flow_imp.g_varchar2_table(1745) := '6C69622F66656174757265732F73656C656374696F6E2F53656C656374696F6E4265686176696F722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F666561';
wwv_flow_imp.g_varchar2_table(1746) := '74757265732F73656C656374696F6E2F53656C656374696F6E56697375616C732E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F66656174757265732F7365';
wwv_flow_imp.g_varchar2_table(1747) := '6C656374696F6E2F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6931386E2F7472616E736C6174652F696E6465782E6A73222C2277656270';
wwv_flow_imp.g_varchar2_table(1748) := '61636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6931386E2F7472616E736C6174652F7472616E736C6174652E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F';
wwv_flow_imp.g_varchar2_table(1749) := '6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6C61796F75742F4C61796F75745574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69';
wwv_flow_imp.g_varchar2_table(1750) := '622F6D6F64656C2F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F6D6F766563616E7661732F4D6F766543616E76';
wwv_flow_imp.g_varchar2_table(1751) := '61732E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F6D6F766563616E7661732F696E6465782E6A73222C227765627061636B3A';
wwv_flow_imp.g_varchar2_table(1752) := '2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F5A6F6F6D5363726F6C6C2E6A73222C227765627061636B3A2F2F62706D6E5669657765';
wwv_flow_imp.g_varchar2_table(1753) := '722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F5A6F6F6D5574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F6475';
wwv_flow_imp.g_varchar2_table(1754) := '6C65732F6469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C';
wwv_flow_imp.g_varchar2_table(1755) := '69622F7574696C2F436C69636B547261702E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F436F6C6C656374696F6E732E6A73222C2277656270';
wwv_flow_imp.g_varchar2_table(1756) := '61636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F437572736F722E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F';
wwv_flow_imp.g_varchar2_table(1757) := '6469616772616D2D6A732F6C69622F7574696C2F456C656D656E74732E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4573636170655574696C';
wwv_flow_imp.g_varchar2_table(1758) := '2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4576656E742E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F6465';
wwv_flow_imp.g_varchar2_table(1759) := '5F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F47656F6D657472792E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F47';
wwv_flow_imp.g_varchar2_table(1760) := '726170686963735574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F496447656E657261746F722E6A73222C227765627061636B3A2F2F';
wwv_flow_imp.g_varchar2_table(1761) := '62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6174682E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D';
wwv_flow_imp.g_varchar2_table(1762) := '6A732F6C69622F7574696C2F4D6F64656C5574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F4D6F7573652E6A73222C22776562706163';
wwv_flow_imp.g_varchar2_table(1763) := '6B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F506C6174666F726D2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F';
wwv_flow_imp.g_varchar2_table(1764) := '6469616772616D2D6A732F6C69622F7574696C2F506F736974696F6E5574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F52656E646572';
wwv_flow_imp.g_varchar2_table(1765) := '5574696C2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F5376675472616E73666F726D5574696C2E6A73222C227765627061636B3A2F2F6270';
wwv_flow_imp.g_varchar2_table(1766) := '6D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6469616772616D2D6A732F6C69622F7574696C2F546578742E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6964732F646973742F69';
wwv_flow_imp.g_varchar2_table(1767) := '6E6465782E65736D2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F696E6865726974732D62726F777365722F646973742F696E6465782E65732E6A73222C227765627061636B3A2F2F62706D6E';
wwv_flow_imp.g_varchar2_table(1768) := '5669657765722F2E2F6E6F64655F6D6F64756C65732F6D696E2D646F6D2F646973742F696E6465782E65736D2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F736178656E2F646973742F696E64';
wwv_flow_imp.g_varchar2_table(1769) := '65782E65736D2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F74696E792D7376672F646973742F696E6465782E65736D2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F';
wwv_flow_imp.g_varchar2_table(1770) := '6E6F64655F6D6F64756C65732F62706D6E2D6D6F64646C652F646973742F696E6465782E65736D2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F646964692F646973742F696E6465782E6A7322';
wwv_flow_imp.g_varchar2_table(1771) := '2C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6D696E2D646173682F646973742F696E6465782E65736D2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C';
wwv_flow_imp.g_varchar2_table(1772) := '65732F6D6F64646C652D786D6C2F646973742F696E6465782E65736D2E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6D6F64646C652F646973742F696E6465782E65736D2E6A73222C22776562';
wwv_flow_imp.g_varchar2_table(1773) := '7061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F6F626A6563742D726566732F646973742F696E6465782E6A73222C227765627061636B3A2F2F62706D6E5669657765722F2E2F6E6F64655F6D6F64756C65732F706174';
wwv_flow_imp.g_varchar2_table(1774) := '682D696E74657273656374696F6E2F696E746572736563742E6A73222C227765627061636B3A2F2F62706D6E5669657765722F7765627061636B2F626F6F747374726170222C227765627061636B3A2F2F62706D6E5669657765722F7765627061636B2F';
wwv_flow_imp.g_varchar2_table(1775) := '72756E74696D652F646566696E652070726F70657274792067657474657273222C227765627061636B3A2F2F62706D6E5669657765722F7765627061636B2F72756E74696D652F6861734F776E50726F70657274792073686F727468616E64222C227765';
wwv_flow_imp.g_varchar2_table(1776) := '627061636B3A2F2F62706D6E5669657765722F7765627061636B2F72756E74696D652F6D616B65206E616D657370616365206F626A656374222C227765627061636B3A2F2F62706D6E5669657765722F2E2F696E6465782E6A73225D2C22736F75726365';
wwv_flow_imp.g_varchar2_table(1777) := '73436F6E74656E74223A5B22696D706F7274205A6F6F6D5363726F6C6C2066726F6D20276469616772616D2D6A732F6C69622F6E617669676174696F6E2F7A6F6F6D7363726F6C6C2F5A6F6F6D5363726F6C6C273B5C725C6E696D706F7274207B206173';
wwv_flow_imp.g_varchar2_table(1778) := '7369676E207D2066726F6D20276D696E2D64617368273B5C725C6E5C725C6E2F2A2A5C725C6E202A20412070616C657474652070726F766964657220666F722042504D4E20322E3020656C656D656E74732E5C725C6E202A2F5C725C6E6578706F727420';
wwv_flow_imp.g_varchar2_table(1779) := '64656661756C742066756E6374696F6E2050616C6574746550726F7669646572285C725C6E202070616C657474652C5C725C6E20207472616E736C6174652C5C725C6E20206576656E744275732C5C725C6E202063616E7661732C5C725C6E2020636F6E';
wwv_flow_imp.g_varchar2_table(1780) := '6669675C725C6E29207B5C725C6E5C725C6E202070616C657474652E5F6E65656473436F6C6C61707365203D2066756E6374696F6E2028617661696C61626C654865696768742C20656E747269657329207B5C725C6E2020202072657475726E2066616C';
wwv_flow_imp.g_varchar2_table(1781) := '73653B5C725C6E20207D3B5C725C6E5C725C6E2020746869732E67657450616C65747465456E7472696573203D2066756E6374696F6E2028656C656D656E7429207B5C725C6E2020202076617220616374696F6E73203D207B7D3B5C725C6E2020202076';
wwv_flow_imp.g_varchar2_table(1782) := '6172207A6F6F6D5363726F6C6C203D206E6577205A6F6F6D5363726F6C6C287B7D2C206576656E744275732C2063616E766173293B5C725C6E20205C725C6E2020202061737369676E28616374696F6E732C207B5C725C6E202020202020277A6F6F6D2D';
wwv_flow_imp.g_varchar2_table(1783) := '696E273A207B5C725C6E202020202020202067726F75703A2027636F6E74726F6C73272C5C725C6E2020202020202020636C6173734E616D653A202766612066612D7365617263682D706C7573272C5C725C6E20202020202020207469746C653A207472';
wwv_flow_imp.g_varchar2_table(1784) := '616E736C61746528275A6F6F6D20496E27292C5C725C6E2020202020202020616374696F6E3A207B5C725C6E20202020202020202020636C69636B3A2066756E6374696F6E20286576656E7429207B5C725C6E2020202020202020202020207A6F6F6D53';
wwv_flow_imp.g_varchar2_table(1785) := '63726F6C6C2E7A6F6F6D28312C2030293B5C725C6E202020202020202020207D2C5C725C6E20202020202020207D2C5C725C6E2020202020207D2C5C725C6E202020202020277A6F6F6D2D6F7574273A207B5C725C6E202020202020202067726F75703A';
wwv_flow_imp.g_varchar2_table(1786) := '2027636F6E74726F6C73272C5C725C6E2020202020202020636C6173734E616D653A202766612066612D7365617263682D6D696E7573272C5C725C6E20202020202020207469746C653A207472616E736C61746528275A6F6F6D204F757427292C5C725C';
wwv_flow_imp.g_varchar2_table(1787) := '6E2020202020202020616374696F6E3A207B5C725C6E20202020202020202020636C69636B3A2066756E6374696F6E20286576656E7429207B5C725C6E2020202020202020202020207A6F6F6D5363726F6C6C2E7A6F6F6D282D312C2030293B5C725C6E';
wwv_flow_imp.g_varchar2_table(1788) := '202020202020202020207D2C5C725C6E20202020202020207D2C5C725C6E2020202020207D2C5C725C6E202020202020277A6F6F6D2D7265736574273A207B5C725C6E202020202020202067726F75703A2027636F6E74726F6C73272C5C725C6E202020';
wwv_flow_imp.g_varchar2_table(1789) := '2020202020636C6173734E616D653A202766612066612D6669742D746F2D73697A65272C5C725C6E20202020202020207469746C653A207472616E736C61746528275265736574205A6F6F6D27292C5C725C6E2020202020202020616374696F6E3A207B';
wwv_flow_imp.g_varchar2_table(1790) := '5C725C6E20202020202020202020636C69636B3A2066756E6374696F6E20286576656E7429207B5C725C6E2020202020202020202020207A6F6F6D5363726F6C6C2E726573657428293B5C725C6E202020202020202020207D2C5C725C6E202020202020';
wwv_flow_imp.g_varchar2_table(1791) := '20207D2C5C725C6E2020202020207D2C5C725C6E2020202020202E2E2E28636F6E6669672E616C6C6F77446F776E6C6F6164202626207B5C725C6E202020202020202027646F776E6C6F61642D737667273A207B5C725C6E202020202020202020206772';
wwv_flow_imp.g_varchar2_table(1792) := '6F75703A2027636F6E74726F6C73272C5C725C6E20202020202020202020636C6173734E616D653A202766612066612D696D616765272C5C725C6E202020202020202020207469746C653A207472616E736C6174652827446F776E6C6F61642053564727';
wwv_flow_imp.g_varchar2_table(1793) := '292C5C725C6E20202020202020202020616374696F6E3A207B5C725C6E202020202020202020202020636C69636B3A2066756E6374696F6E20286576656E7429207B5C725C6E2020202020202020202020202020646F776E6C6F61644173535647286576';
wwv_flow_imp.g_varchar2_table(1794) := '656E74293B5C725C6E2020202020202020202020207D2C5C725C6E202020202020202020207D2C5C725C6E20202020202020207D5C725C6E2020202020207D295C725C6E202020207D293B5C725C6E20205C725C6E2020202072657475726E2061637469';
wwv_flow_imp.g_varchar2_table(1795) := '6F6E733B5C725C6E20207D3B5C725C6E5C725C6E202070616C657474652E726567697374657250726F76696465722874686973293B5C725C6E7D5C725C6E5C725C6E50616C6574746550726F76696465722E24696E6A656374203D205B5C725C6E202027';
wwv_flow_imp.g_varchar2_table(1796) := '70616C65747465272C5C725C6E2020277472616E736C617465272C5C725C6E2020276576656E74427573272C5C725C6E20202763616E766173272C5C725C6E20202F2F20637573746F6D207669657765722070726F70657274696573206E657374656420';
wwv_flow_imp.g_varchar2_table(1797) := '696E7369646520706172656E7420636F6E666967206F626A6563745C725C6E202027636F6E6669672E636F6E666967275C725C6E5D3B5C725C6E222C22696D706F72742050616C657474654D6F64756C652066726F6D20276469616772616D2D6A732F6C';
wwv_flow_imp.g_varchar2_table(1798) := '69622F66656174757265732F70616C65747465273B5C725C6E696D706F7274207472616E736C6174652066726F6D20276469616772616D2D6A732F6C69622F6931386E2F7472616E736C617465273B5C725C6E5C725C6E696D706F72742050616C657474';
wwv_flow_imp.g_varchar2_table(1799) := '6550726F76696465722066726F6D20272E2F50616C6574746550726F76696465722E6A73273B5C725C6E5C725C6E6578706F72742064656661756C74207B5C725C6E20205F5F646570656E64735F5F3A205B50616C657474654D6F64756C652C20747261';
wwv_flow_imp.g_varchar2_table(1800) := '6E736C6174655D2C5C725C6E20205F5F696E69745F5F3A205B2770616C6574746550726F7669646572275D2C5C725C6E202070616C6574746550726F76696465723A205B2774797065272C2050616C6574746550726F76696465725D2C5C725C6E7D3B5C';
wwv_flow_imp.g_varchar2_table(1801) := '725C6E222C225C725C6E696D706F7274207B206973207D2066726F6D202762706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C273B5C725C6E696D706F7274207B20646F6D696679207D2066726F6D20276D696E2D646F6D273B5C725C6E5C';
wwv_flow_imp.g_varchar2_table(1802) := '725C6E766172204152524F575F444F574E5F535647203D20273C73766720786D6C6E733D5C22687474703A2F2F7777772E77332E6F72672F323030302F7376675C222077696474683D5C2232305C22206865696768743D5C2232305C222076696577426F';
wwv_flow_imp.g_varchar2_table(1803) := '783D5C223020302031362031365C223E3C706174682066696C6C2D72756C653D5C226576656E6F64645C2220643D5C224D342E38313830313934382C332E3530373335393331204C31302E343939363839342C392E31383936383934204C31302E352C34';
wwv_flow_imp.g_varchar2_table(1804) := '204C31322C34204C31322C3132204C342C3132204C342C31302E35204C392E363839363839342C31302E34393936383934204C332E37353733353933312C342E35363830313934382043332E34363434363630392C342E323735313236323720332E3436';
wwv_flow_imp.g_varchar2_table(1805) := '3434363630392C332E383030323532353320332E37353733353933312C332E35303733353933312043342E30353032353235332C332E323134343636303920342E35323531323632372C332E323134343636303920342E38313830313934382C332E3530';
wwv_flow_imp.g_varchar2_table(1806) := '373335393331205A5C222F3E3C2F7376673E273B5C725C6E6578706F72742064656661756C742066756E6374696F6E20437573746F6D4472696C6C646F776E285C725C6E2020202063616E7661732C206576656E744275732C20656C656D656E74526567';
wwv_flow_imp.g_varchar2_table(1807) := '69737472792C206F7665726C6179732C206D6F64646C655C725C6E29207B5C725C6E2020746869732E5F63616E766173203D2063616E7661733B5C725C6E2020746869732E5F6576656E74427573203D206576656E744275733B5C725C6E202074686973';
wwv_flow_imp.g_varchar2_table(1808) := '2E5F656C656D656E745265676973747279203D20656C656D656E7452656769737472793B5C725C6E2020746869732E5F6F7665726C617973203D206F7665726C6179733B5C725C6E2020746869732E5F6D6F64646C65203D206D6F64646C653B5C725C6E';
wwv_flow_imp.g_varchar2_table(1809) := '5C725C6E2020766172205F73656C66203D20746869733B5C725C6E5C725C6E20202F2F2063726561746520616E6420617070656E642062726561646372756D625C725C6E2020746869732E5F62726561646372756D62203D20646F6D69667928273C756C';
wwv_flow_imp.g_varchar2_table(1810) := '20636C6173733D5C22626A732D62726561646372756D62735C222069643D5C2263616C6C416374697669747942726561646372756D625C223E3C2F756C3E27293B5C725C6E202076617220636F6E7461696E6572203D2063616E7661732E676574436F6E';
wwv_flow_imp.g_varchar2_table(1811) := '7461696E657228293B5C725C6E2020636F6E7461696E65722E617070656E644368696C6428746869732E5F62726561646372756D62293B5C725C6E5C725C6E20202F2F20616464206F7665726C617920666F72206472696C6C646F776E2D61626C652065';
wwv_flow_imp.g_varchar2_table(1812) := '6C656D656E74735C725C6E20206576656E744275732E6F6E2827696D706F72742E72656E6465722E636F6D706C657465272C2066756E6374696F6E202829207B5C725C6E20202020656C656D656E7452656769737472792E66696C7465722866756E6374';
wwv_flow_imp.g_varchar2_table(1813) := '696F6E20286529207B5C725C6E20202020202072657475726E205F73656C662E63616E4472696C6C446F776E2865293B5C725C6E202020207D292E666F72456163682866756E6374696F6E2028656C29207B5C725C6E2020202020205F73656C662E6164';
wwv_flow_imp.g_varchar2_table(1814) := '644F7665726C617928656C293B5C725C6E202020207D293B5C725C6E20207D293B5C725C6E7D5C725C6E5C725C6E437573746F6D4472696C6C646F776E2E70726F746F747970652E63616E4472696C6C446F776E203D2066756E6374696F6E2028656C65';
wwv_flow_imp.g_varchar2_table(1815) := '6D656E7429207B5C725C6E202072657475726E2028697328656C656D656E742C202762706D6E3A43616C6C41637469766974792729293B5C725C6E7D3B5C725C6E5C725C6E437573746F6D4472696C6C646F776E2E70726F746F747970652E6164644F76';
wwv_flow_imp.g_varchar2_table(1816) := '65726C6179203D2066756E6374696F6E2028656C656D656E7429207B5C725C6E2020766172206F7665726C617973203D20746869732E5F6F7665726C6179733B5C725C6E5C725C6E2020766172205F73656C66203D20746869733B5C725C6E5C725C6E20';
wwv_flow_imp.g_varchar2_table(1817) := '2076617220627574746F6E203D20646F6D69667928603C627574746F6E20636C6173733D5C22626A732D6472696C6C646F776E5C223E247B4152524F575F444F574E5F5356477D3C2F627574746F6E3E60293B5C725C6E5C725C6E20202F2F2072656D6F';
wwv_flow_imp.g_varchar2_table(1818) := '76652028706F737369626C6529206578697374696E67206F7665726C61795C725C6E2020696620286F7665726C6179732E676574287B20656C656D656E743A20656C656D656E742C20747970653A20276472696C6C646F776E27207D292E6C656E677468';
wwv_flow_imp.g_varchar2_table(1819) := '29207B5C725C6E20202020746869732E72656D6F76654F7665726C617928656C656D656E74293B5C725C6E20207D5C725C6E5C725C6E20202F2F20616464206576656E74206C697374656E65725C725C6E2020627574746F6E2E6164644576656E744C69';
wwv_flow_imp.g_varchar2_table(1820) := '7374656E65722827636C69636B272C2066756E6374696F6E20286576656E7429207B5C725C6E5C725C6E202020202F2F20636C69636B6564206F626A6563745C725C6E20202020766172206F626A6563744964203D20656C656D656E742E69643B5C725C';
wwv_flow_imp.g_varchar2_table(1821) := '6E5C725C6E202020202F2F207265747269657665206869657261637279202B2063757272656E74206469616772616D5C725C6E20202020766172207B20646174612C206469616772616D4964656E746966696572207D203D205F73656C662E5F77696467';
wwv_flow_imp.g_varchar2_table(1822) := '65743B5C725C6E5C725C6E202020202F2F20676574206E6577206469616772616D2066726F6D206869657261726368795C725C6E20202020766172206E65774469616772616D203D20646174612E66696E64285C725C6E20202020202064203D3E5C725C';
wwv_flow_imp.g_varchar2_table(1823) := '6E2020202020202020642E63616C6C696E674469616772616D4964656E746966696572203D3D3D206469616772616D4964656E7469666965722026265C725C6E2020202020202020642E63616C6C696E674F626A6563744964203D3D3D206F626A656374';
wwv_flow_imp.g_varchar2_table(1824) := '49645C725C6E20202020293B5C725C6E5C725C6E202020202F2F20696620696E736967687420616C6C6F7765645C725C6E20202020696620286E65774469616772616D202626206E65774469616772616D2E696E7369676874203D3D3D203129207B5C72';
wwv_flow_imp.g_varchar2_table(1825) := '5C6E2020202020205C725C6E2020202020202F2F20736574206E6577206469616772616D2070726F706572746965735C725C6E2020202020205F73656C662E5F7769646765742E6469616772616D4964656E746966696572203D206E6577446961677261';
wwv_flow_imp.g_varchar2_table(1826) := '6D2E6469616772616D4964656E7469666965723B5C725C6E2020202020205F73656C662E5F7769646765742E63616C6C696E674469616772616D4964656E746966696572203D206E65774469616772616D2E63616C6C696E674469616772616D4964656E';
wwv_flow_imp.g_varchar2_table(1827) := '7469666965723B5C725C6E2020202020205F73656C662E5F7769646765742E63616C6C696E674F626A6563744964203D206E65774469616772616D2E63616C6C696E674F626A65637449643B5C725C6E2020202020205F73656C662E5F7769646765742E';
wwv_flow_imp.g_varchar2_table(1828) := '6469616772616D203D206E65774469616772616D2E6469616772616D3B5C725C6E2020202020205F73656C662E5F7769646765742E63757272656E74203D206E65774469616772616D2E63757272656E743B5C725C6E2020202020205F73656C662E5F77';
wwv_flow_imp.g_varchar2_table(1829) := '69646765742E636F6D706C65746564203D206E65774469616772616D2E636F6D706C657465643B5C725C6E2020202020205F73656C662E5F7769646765742E6572726F72203D206E65774469616772616D2E6572726F723B5C725C6E5C725C6E20202020';
wwv_flow_imp.g_varchar2_table(1830) := '20202F2F207570646174652062726561646372756D625C725C6E2020202020205F73656C662E75706461746542726561646372756D6228293B5C725C6E5C725C6E2020202020202F2F206D6F766520646F776E207375622070726F636573732062726561';
wwv_flow_imp.g_varchar2_table(1831) := '646372756D625C725C6E202020202020636F6E73742073756250726F6365737342726561646372756D62203D20646F63756D656E742E717565727953656C6563746F7228272E626A732D62726561646372756D62733A6E6F74282363616C6C4163746976';
wwv_flow_imp.g_varchar2_table(1832) := '69747942726561646372756D622927293B5C725C6E20202020202073756250726F6365737342726561646372756D622E7374796C652E746F70203D202736307078273B5C725C6E5C725C6E2020202020202F2F20696E766F6B65206C6F61644469616772';
wwv_flow_imp.g_varchar2_table(1833) := '616D206F66207769646765745C725C6E2020202020205F73656C662E5F7769646765742E6C6F61644469616772616D28293B5C725C6E202020207D5C725C6E20207D293B5C725C6E5C725C6E20202F2F20616464206F7665726C61795C725C6E20206F76';
wwv_flow_imp.g_varchar2_table(1834) := '65726C6179732E61646428656C656D656E742C20276472696C6C646F776E272C207B5C725C6E20202020706F736974696F6E3A207B5C725C6E202020202020626F74746F6D3A202D372C5C725C6E20202020202072696768743A202D385C725C6E202020';
wwv_flow_imp.g_varchar2_table(1835) := '207D2C5C725C6E2020202068746D6C3A20627574746F6E5C725C6E20207D293B5C725C6E7D3B5C725C6E5C725C6E437573746F6D4472696C6C646F776E2E70726F746F747970652E72656D6F76654F7665726C6179203D2066756E6374696F6E2028656C';
wwv_flow_imp.g_varchar2_table(1836) := '656D656E7429207B5C725C6E2020766172206F7665726C617973203D20746869732E5F6F7665726C6179733B5C725C6E5C725C6E20202F2F2072656D6F7665206F7665726C61795C725C6E20206F7665726C6179732E72656D6F7665287B5C725C6E2020';
wwv_flow_imp.g_varchar2_table(1837) := '2020656C656D656E743A20656C656D656E742C5C725C6E20202020747970653A20276472696C6C646F776E275C725C6E20207D293B5C725C6E7D3B5C725C6E5C725C6E437573746F6D4472696C6C646F776E2E70726F746F747970652E73657457696467';
wwv_flow_imp.g_varchar2_table(1838) := '6574203D2066756E6374696F6E202877696467657429207B5C725C6E2020746869732E5F776964676574203D207769646765743B5C725C6E7D3B5C725C6E5C725C6E437573746F6D4472696C6C646F776E2E70726F746F747970652E7570646174654272';
wwv_flow_imp.g_varchar2_table(1839) := '6561646372756D62203D2066756E6374696F6E202829207B5C725C6E5C725C6E2020766172205F73656C66203D20746869733B5C725C6E5C725C6E20202F2F207265747269657665206869657261726368795C725C6E2020636F6E7374207B2064617461';
wwv_flow_imp.g_varchar2_table(1840) := '2C206469616772616D4964656E7469666965722C2063616C6C696E674469616772616D4964656E7469666965722C2063616C6C696E674F626A6563744964207D203D20746869732E5F7769646765743B5C725C6E5C725C6E20202F2F2072657472696576';
wwv_flow_imp.g_varchar2_table(1841) := '652070726F70657274696573206F662063757272656E74206469616772616D5C725C6E2020766172207B2062726561646372756D62207D203D20646174612E66696E64285C725C6E2020202064203D3E5C725C6E202020202020642E6469616772616D49';
wwv_flow_imp.g_varchar2_table(1842) := '64656E746966696572203D3D3D206469616772616D4964656E7469666965722026265C725C6E202020202020642E63616C6C696E674469616772616D4964656E746966696572203D3D3D2063616C6C696E674469616772616D4964656E74696669657220';
wwv_flow_imp.g_varchar2_table(1843) := '26265C725C6E202020202020642E63616C6C696E674F626A6563744964203D3D3D2063616C6C696E674F626A65637449645C725C6E2020293B5C725C6E5C725C6E20202F2F2062726561646372756D62206C69737420656E7472795C725C6E2020766172';
wwv_flow_imp.g_varchar2_table(1844) := '206C696E6B203D20646F6D696679285C725C6E20202020603C6C6920646174612D696E6465783D5C22247B746869732E5F62726561646372756D622E6368696C644E6F6465732E6C656E6774687D5C225C725C6E20202020247B6469616772616D496465';
wwv_flow_imp.g_varchar2_table(1845) := '6E746966696572203F206020646174612D6469616772616D4964656E7469666965723D5C22247B6469616772616D4964656E7469666965727D5C2260203A2027277D5C725C6E20202020247B63616C6C696E674469616772616D4964656E746966696572';
wwv_flow_imp.g_varchar2_table(1846) := '203F206020646174612D63616C6C696E674469616772616D4964656E7469666965723D5C22247B63616C6C696E674469616772616D4964656E7469666965727D5C2260203A2027277D5C725C6E20202020247B63616C6C696E674F626A6563744964203F';
wwv_flow_imp.g_varchar2_table(1847) := '206020646174612D63616C6C696E674F626A65637449643D5C2224247B63616C6C696E674F626A65637449647D5C2260203A2027277D3E60202B5C725C6E20202020603C7370616E20636C6173733D5C22626A732D6372756D625C223E3C615C725C6E20';
wwv_flow_imp.g_varchar2_table(1848) := '202020247B63616C6C696E674F626A6563744964203F2060207469746C653D5C2263616C6C656420627920247B63616C6C696E674F626A65637449647D5C2260203A2027277D3E60202B5C725C6E2020202060247B62726561646372756D627D3C2F613E';
wwv_flow_imp.g_varchar2_table(1849) := '3C2F7370616E3E3C2F6C693E60293B5C725C6E5C725C6E20202F2F20616464206576656E74206C697374656E65725C725C6E20206C696E6B2E6164644576656E744C697374656E65722827636C69636B272C2066756E6374696F6E202829207B5C725C6E';
wwv_flow_imp.g_varchar2_table(1850) := '5C725C6E202020202F2F20636C69636B6564206F626A6563745C725C6E20202020766172207B20696E6465782C206469616772616D6964656E746966696572207D203D206C696E6B2E646174617365743B5C725C6E5C725C6E202020202F2F2072657472';
wwv_flow_imp.g_varchar2_table(1851) := '696576652063757272656E74282129206869657261726368795C725C6E20202020636F6E7374207B2064617461207D203D205F73656C662E5F7769646765743B5C725C6E5C725C6E202020202F2F20676574206E6577206469616772616D2066726F6D20';
wwv_flow_imp.g_varchar2_table(1852) := '6869657261726368795C725C6E20202020766172206E65774469616772616D203D20646174612E66696E64285C725C6E20202020202064203D3E20642E6469616772616D4964656E746966696572203D3D206469616772616D6964656E7469666965725C';
wwv_flow_imp.g_varchar2_table(1853) := '725C6E20202020293B5C725C6E5C725C6E202020202F2F20616C6C20627574206C61737420656E7472792061726520636C69636B61626C655C725C6E2020202069662028696E646578203C205F73656C662E5F62726561646372756D622E6368696C644E';
wwv_flow_imp.g_varchar2_table(1854) := '6F6465732E6C656E677468202D203129207B5C725C6E5C725C6E2020202020202F2F207472696D2062726561646372756D6220746F20636C69636B656420656E7472795C725C6E2020202020205F73656C662E7472696D42726561646372756D62546F28';
wwv_flow_imp.g_varchar2_table(1855) := '696E646578293B5C725C6E5C725C6E2020202020202F2F20736574206E6577206469616772616D2070726F706572746965735C725C6E2020202020205F73656C662E5F7769646765742E6469616772616D4964656E746966696572203D206E6577446961';
wwv_flow_imp.g_varchar2_table(1856) := '6772616D2E6469616772616D4964656E7469666965723B5C725C6E2020202020205F73656C662E5F7769646765742E63616C6C696E674469616772616D4964656E746966696572203D206E65774469616772616D2E63616C6C696E674469616772616D49';
wwv_flow_imp.g_varchar2_table(1857) := '64656E7469666965723B5C725C6E2020202020205F73656C662E5F7769646765742E63616C6C696E674F626A6563744964203D206E65774469616772616D2E63616C6C696E674F626A65637449643B5C725C6E2020202020205F73656C662E5F77696467';
wwv_flow_imp.g_varchar2_table(1858) := '65742E6469616772616D203D206E65774469616772616D2E6469616772616D3B5C725C6E2020202020205F73656C662E5F7769646765742E63757272656E74203D206E65774469616772616D2E63757272656E743B5C725C6E2020202020205F73656C66';
wwv_flow_imp.g_varchar2_table(1859) := '2E5F7769646765742E636F6D706C65746564203D206E65774469616772616D2E636F6D706C657465643B5C725C6E2020202020205F73656C662E5F7769646765742E6572726F72203D206E65774469616772616D2E6572726F723B5C725C6E5C725C6E20';
wwv_flow_imp.g_varchar2_table(1860) := '20202020202F2F20696E766F6B65206C6F61644469616772616D206F66207769646765745C725C6E2020202020205F73656C662E5F7769646765742E6C6F61644469616772616D28293B5C725C6E202020207D5C725C6E20207D293B5C725C6E5C725C6E';
wwv_flow_imp.g_varchar2_table(1861) := '20202F2F20617070656E6420656E7472795C725C6E2020746869732E5F62726561646372756D622E617070656E644368696C64286C696E6B293B5C725C6E5C725C6E20202F2F20746F67676C65207669736962696C6974795C725C6E2020746869732E74';
wwv_flow_imp.g_varchar2_table(1862) := '6F67676C6542726561646372756D625669736962696C69747928293B5C725C6E7D3B5C725C6E5C725C6E437573746F6D4472696C6C646F776E2E70726F746F747970652E726573657442726561646372756D62203D2066756E6374696F6E202829207B5C';
wwv_flow_imp.g_varchar2_table(1863) := '725C6E20202F2F2072656D6F766520616C6C20656E74726965735C725C6E20207768696C652028746869732E5F62726561646372756D622E66697273744368696C6429207B5C725C6E20202020746869732E5F62726561646372756D622E72656D6F7665';
wwv_flow_imp.g_varchar2_table(1864) := '4368696C6428746869732E5F62726561646372756D622E66697273744368696C64293B5C725C6E20207D5C725C6E5C725C6E20202F2F20746F67676C65207669736962696C6974795C725C6E2020746869732E746F67676C6542726561646372756D6256';
wwv_flow_imp.g_varchar2_table(1865) := '69736962696C69747928293B5C725C6E7D3B5C725C6E5C725C6E437573746F6D4472696C6C646F776E2E70726F746F747970652E7472696D42726561646372756D62546F203D2066756E6374696F6E2028696E64657829207B5C725C6E20207661722066';
wwv_flow_imp.g_varchar2_table(1866) := '6C6167203D2066616C73653B5C725C6E20207661722072656D6F76654E6F646573203D205B5D3B5C725C6E5C725C6E2020666F7220286C65742069203D20303B2069203C20746869732E5F62726561646372756D622E6368696C644E6F6465732E6C656E';
wwv_flow_imp.g_varchar2_table(1867) := '6774683B20692B2B29207B5C725C6E2020202069662028666C616729207B5C725C6E2020202020202F2F2061646420656E74727920746F2072656D6F7661626C65206E6F6465735C725C6E20202020202072656D6F76654E6F6465732E70757368287468';
wwv_flow_imp.g_varchar2_table(1868) := '69732E5F62726561646372756D622E6368696C644E6F6465735B695D293B5C725C6E202020207D20656C73652069662028746869732E5F62726561646372756D622E6368696C644E6F6465735B695D2E646174617365742E696E646578203D3D3D20696E';
wwv_flow_imp.g_varchar2_table(1869) := '64657829207B5C725C6E2020202020202F2F206D61726B206173206C617374206E6F64655C725C6E202020202020666C6167203D20747275653B5C725C6E202020207D5C725C6E20207D5C725C6E5C725C6E20202F2F2072656D6F766520737562736571';
wwv_flow_imp.g_varchar2_table(1870) := '75656E74206E6F6465735C725C6E202072656D6F76654E6F6465732E666F7245616368286E203D3E20746869732E5F62726561646372756D622E72656D6F76654368696C64286E29293B5C725C6E5C725C6E20202F2F20746F67676C6520766973696269';
wwv_flow_imp.g_varchar2_table(1871) := '6C6974795C725C6E2020746869732E746F67676C6542726561646372756D625669736962696C69747928293B5C725C6E7D3B5C725C6E5C725C6E437573746F6D4472696C6C646F776E2E70726F746F747970652E746F67676C6542726561646372756D62';
wwv_flow_imp.g_varchar2_table(1872) := '5669736962696C697479203D2066756E6374696F6E202829207B5C725C6E20202F2F2073686F772F686964652062726561646372756D622028646570656E64696E67206F6E206E756D626572206F6620656E7472696573295C725C6E2020696620287468';
wwv_flow_imp.g_varchar2_table(1873) := '69732E5F62726561646372756D622E6368696C644E6F6465732E6C656E677468203E203129207B5C725C6E202020205C725C6E20202020636F6E73742062726561646372756D62486569676874203D20746869732E5F62726561646372756D622E6F6666';
wwv_flow_imp.g_varchar2_table(1874) := '7365744865696768743B5C725C6E202020205C725C6E202020202F2F2073686F7720656C656D656E745C725C6E20202020746869732E5F62726561646372756D622E7374796C652E646973706C6179203D2027666C6578273B5C725C6E202020205C725C';
wwv_flow_imp.g_varchar2_table(1875) := '6E202020202F2F207363726F6C6C2063616E76617320646F776E5C725C6E20202020746869732E5F63616E7661732E7363726F6C6C287B2064783A20302C2064793A203330202B2062726561646372756D62486569676874202B203330207D293B5C725C';
wwv_flow_imp.g_varchar2_table(1876) := '6E5C725C6E20207D20656C7365207B5C725C6E5C725C6E20202020636F6E73742073756250726F6365737342726561646372756D62203D20646F63756D656E742E717565727953656C6563746F7228272E626A732D62726561646372756D62733A6E6F74';
wwv_flow_imp.g_varchar2_table(1877) := '282363616C6C416374697669747942726561646372756D622927293B5C725C6E5C725C6E202020202F2F206869646520656C656D656E745C725C6E20202020746869732E5F62726561646372756D622E7374796C652E646973706C6179203D20276E6F6E';
wwv_flow_imp.g_varchar2_table(1878) := '65273B5C725C6E202020205C725C6E202020202F2F206D6F7665207570207375622070726F636573732062726561646372756D625C725C6E2020202073756250726F6365737342726561646372756D622E7374796C652E746F70203D202733307078273B';
wwv_flow_imp.g_varchar2_table(1879) := '5C725C6E20207D5C725C6E7D3B5C725C6E5C725C6E437573746F6D4472696C6C646F776E2E70726F746F747970652E736574506F736974696F6E696E67203D2066756E6374696F6E202829207B5C725C6E20205C725C6E7D3B5C725C6E5C725C6E437573';
wwv_flow_imp.g_varchar2_table(1880) := '746F6D4472696C6C646F776E2E24696E6A656374203D205B5C725C6E20202763616E766173272C5C725C6E2020276576656E74427573272C5C725C6E202027656C656D656E745265676973747279272C5C725C6E2020276F7665726C617973272C5C725C';
wwv_flow_imp.g_varchar2_table(1881) := '6E2020276D6F64646C65275C725C6E5D3B222C22696D706F72742043616C6C41637469766974794D6F64756C652066726F6D20272E2F43616C6C41637469766974794D6F64756C65273B5C725C6E5C725C6E6578706F72742064656661756C74207B5C72';
wwv_flow_imp.g_varchar2_table(1882) := '5C6E20205F5F696E69745F5F3A205B2763616C6C41637469766974794D6F64756C65275D2C5C725C6E202063616C6C41637469766974794D6F64756C653A205B2774797065272C2043616C6C41637469766974794D6F64756C655D2C5C725C6E7D3B222C';
wwv_flow_imp.g_varchar2_table(1883) := '222F2A2A5C725C6E202A204D6F766520636F6C6C61707365642073756270726F63657373657320696E746F2076696577207768656E206472696C6C696E6720646F776E2E5C725C6E202A5C725C6E202A204F76657277726974652064656661756C742062';
wwv_flow_imp.g_varchar2_table(1884) := '65686176696F7572207768657265207A6F6F6D20616E64207363726F6C6C2061726520736176656420696E20612073657373696F6E2E5C725C6E202A205A6F6F6D20616C7761797320726573657420746F206669742D76696577706F727420262063656E';
wwv_flow_imp.g_varchar2_table(1885) := '7465726564207768656E206472696C6C696E6720646F776E202F206D6F76696E672075705C725C6E202A5C725C6E202A2040706172616D207B6576656E744275737D206576656E744275735C725C6E202A2040706172616D207B63616E7661737D206361';
wwv_flow_imp.g_varchar2_table(1886) := '6E7661735C725C6E202A2F5C725C6E6578706F72742064656661756C742066756E6374696F6E204472696C6C646F776E43656E746572696E67286576656E744275732C2063616E76617329207B5C725C6E5C725C6E20206576656E744275732E6F6E2827';
wwv_flow_imp.g_varchar2_table(1887) := '726F6F742E736574272C2066756E6374696F6E202829207B5C725C6E5C725C6E2020202063616E7661732E7A6F6F6D28276669742D76696577706F7274272C20276175746F27293B5C725C6E5C725C6E20207D293B5C725C6E7D5C725C6E5C725C6E4472';
wwv_flow_imp.g_varchar2_table(1888) := '696C6C646F776E43656E746572696E672E24696E6A656374203D205B276576656E74427573272C202763616E766173275D3B222C22696D706F7274204472696C6C646F776E43656E746572696E672066726F6D20272E2F4472696C6C646F776E43656E74';
wwv_flow_imp.g_varchar2_table(1889) := '6572696E67273B5C725C6E5C725C6E6578706F72742064656661756C74207B5C725C6E20205F5F696E69745F5F3A205B276472696C6C646F776E43656E746572696E67275D2C5C725C6E20206472696C6C646F776E43656E746572696E673A205B277479';
wwv_flow_imp.g_varchar2_table(1890) := '7065272C204472696C6C646F776E43656E746572696E675D2C5C725C6E7D3B222C225C725C6E696D706F7274207B20676574427573696E6573734F626A6563742C206973207D2066726F6D202762706D6E2D6A732F6C69622F7574696C2F4D6F64656C55';
wwv_flow_imp.g_varchar2_table(1891) := '74696C273B5C725C6E696D706F7274207B20646F6D6966792C20717565727920617320646F6D5175657279207D2066726F6D20276D696E2D646F6D273B5C725C6E5C725C6E5C725C6E6578706F727420636C617373204D756C7469496E7374616E63654D';
wwv_flow_imp.g_varchar2_table(1892) := '6F64756C65207B5C725C6E20205C725C6E2020636F6E7374727563746F722863616E7661732C206576656E744275732C20656C656D656E7452656769737472792C207472616E736C6174652C206F7665726C61797329207B5C725C6E2020202074686973';
wwv_flow_imp.g_varchar2_table(1893) := '2E5F63616E766173203D2063616E7661733B5C725C6E20202020746869732E5F6576656E74427573203D206576656E744275733B5C725C6E20202020746869732E5F656C656D656E745265676973747279203D20656C656D656E7452656769737472793B';
wwv_flow_imp.g_varchar2_table(1894) := '5C725C6E20202020746869732E5F7472616E736C617465203D207472616E736C6174653B5C725C6E20202020746869732E5F6F7665726C617973203D206F7665726C6179733B5C725C6E5C725C6E20202020746869732E62726561646372756D62497465';
wwv_flow_imp.g_varchar2_table(1895) := '726174696F6E203D205B5D3B5C725C6E20202020746869732E62726561646372756D6253656C656374696F6E203D205B5D3B5C725C6E5C725C6E20202020636F6E7374206D6F64616C203D20646F6D69667928605C725C6E2020202020203C6469762069';
wwv_flow_imp.g_varchar2_table(1896) := '643D5C226D6F64616C5C223E5C725C6E20202020202020203C646976206964203D5C226D6F64616C2D636F6E74656E745C223E5C725C6E202020202020202020203C6469762069643D5C22697465726174696F6E2D7469746C655C223E5C725C6E202020';
wwv_flow_imp.g_varchar2_table(1897) := '2020202020202020203C7370616E3E3C2F7370616E3E5C725C6E2020202020202020202020203C627574746F6E20636C6173733D5C2266612066612D74696D65735C223E3C2F627574746F6E3E5C725C6E202020202020202020203C2F6469763E5C725C';
wwv_flow_imp.g_varchar2_table(1898) := '6E202020202020202020203C6469762069643D5C22697465726174696F6E2D7365617263685C223E5C725C6E2020202020202020202020203C696E70757420747970653D5C22746578745C2220706C616365686F6C6465723D5C225365617263682E2E5C';
wwv_flow_imp.g_varchar2_table(1899) := '222F3E5C725C6E202020202020202020203C2F6469763E5C725C6E202020202020202020203C6469762069643D5C22697465726174696F6E2D6C6973745C223E5C725C6E20202020202020202020202020203C7461626C653E5C725C6E20202020202020';
wwv_flow_imp.g_varchar2_table(1900) := '2020202020202020203C74686561643E5C725C6E2020202020202020202020202020202020203C74723E5C725C6E20202020202020202020202020202020202020203C74683E4C6F6F7020436F756E7465723C2F74683E5C725C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(1901) := '20202020202020202020203C74683E4465736372697074696F6E3C2F74683E5C725C6E20202020202020202020202020202020202020203C74683E5374617475733C2F74683E5C725C6E2020202020202020202020202020202020203C2F74723E5C725C';
wwv_flow_imp.g_varchar2_table(1902) := '6E202020202020202020202020202020203C2F74686561643E5C725C6E202020202020202020202020202020203C74626F64793E3C2F74626F64793E5C725C6E2020202020202020202020203C2F7461626C653E5C725C6E202020202020202020203C2F';
wwv_flow_imp.g_varchar2_table(1903) := '6469763E5C725C6E20202020202020203C2F6469763E5C725C6E2020202020203C2F6469763E5C725C6E2020202060293B5C725C6E5C725C6E202020202F2F20617070656E6420636F6E74656E745C725C6E2020202063616E7661732E676574436F6E74';
wwv_flow_imp.g_varchar2_table(1904) := '61696E657228292E617070656E644368696C64286D6F64616C293B5C725C6E5C725C6E202020206576656E744275732E6F6E2827696D706F72742E72656E6465722E636F6D706C657465272C202829203D3E207B5C725C6E2020202020202F2F20616464';
wwv_flow_imp.g_varchar2_table(1905) := '20736561726368206C697374656E657220666F722066696C746572696E675C725C6E202020202020636F6E737420736561726368626172203D20646F6D5175657279282723697465726174696F6E2D73656172636820696E70757427293B5C725C6E2020';
wwv_flow_imp.g_varchar2_table(1906) := '202020207365617263686261722E6164644576656E744C697374656E657228276B65797570272C20286576656E7429203D3E207B5C725C6E2020202020202020746869732E66696C746572497465726174696F6E73286576656E74293B5C725C6E202020';
wwv_flow_imp.g_varchar2_table(1907) := '2020207D293B5C725C6E2020202020202F2F2061646420636C6F7365206C697374656E65725C725C6E202020202020636F6E737420636C6F7365427574746F6E203D20646F6D5175657279282723697465726174696F6E2D7469746C6520627574746F6E';
wwv_flow_imp.g_varchar2_table(1908) := '2E66612D74696D657327293B5C725C6E202020202020636C6F7365427574746F6E2E6164644576656E744C697374656E65722827636C69636B272C20286576656E7429203D3E207B5C725C6E2020202020202020746869732E636C6F7365497465726174';
wwv_flow_imp.g_varchar2_table(1909) := '696F6E7328293B5C725C6E2020202020207D293B5C725C6E202020207D293B5C725C6E5C725C6E202020202F2F207768656E206469616772616D20726F6F74206368616E6765735C725C6E202020206576656E744275732E6F6E2827726F6F742E736574';
wwv_flow_imp.g_varchar2_table(1910) := '272C20286576656E7429203D3E207B5C725C6E202020202020636F6E7374207B20656C656D656E74207D203D206576656E743B5C725C6E5C725C6E2020202020202F2F2072657365742062726561646372756D62206461746120286E756C6C20616C6C20';
wwv_flow_imp.g_varchar2_table(1911) := '656E74726965732061626F7665207468652063757272656E74295C725C6E202020202020746869732E726573657442726561646372756D624461746128293B5C725C6E5C725C6E2020202020202F2F206966206472696C6C656420646F776E20696E746F';
wwv_flow_imp.g_varchar2_table(1912) := '2073756270726F636573735C725C6E20202020202069662028697328656C656D656E742C202762706D6E3A53756250726F63657373272929207B5C725C6E202020202020202069662028746869732E686173497465726174696F6E4461746128656C656D';
wwv_flow_imp.g_varchar2_table(1913) := '656E742929207B5C725C6E202020202020202020202F2F207570646174652062726561646372756D6220646174613A206D61726B2063757272656E7420656E74727920617320697465726174696E675C725C6E20202020202020202020746869732E6272';
wwv_flow_imp.g_varchar2_table(1914) := '6561646372756D62497465726174696F6E5B746869732E6765744C61737442726561646372756D62496E64657828295D203D20747275653B5C725C6E202020202020202020202F2F207570646174652062726561646372756D623A206164642062757474';
wwv_flow_imp.g_varchar2_table(1915) := '6F6E20286966206C61737420656C656D656E74295C725C6E20202020202020202020746869732E617070656E6442726561646372756D62427574746F6E28656C656D656E74293B5C725C6E20202020202020207D5C725C6E202020202020202074686973';
wwv_flow_imp.g_varchar2_table(1916) := '2E75706461746542726561646372756D6228293B5C725C6E2020202020207D5C725C6E5C725C6E2020202020202F2F2075706461746520686967686C69676874696E67202866726F6D2063757272656E7420697465726174696F6E295C725C6E20202020';
wwv_flow_imp.g_varchar2_table(1917) := '2020746869732E757064617465486967686C69676874696E6728293B5C725C6E202020207D293B5C725C6E20207D5C725C6E5C725C6E20202F2A20496E697469616C69736174696F6E202A2F5C725C6E5C725C6E20207365745769646765742877696467';
wwv_flow_imp.g_varchar2_table(1918) := '657429207B5C725C6E20202020746869732E5F776964676574203D207769646765743B5C725C6E20207D5C725C6E5C725C6E20202F2A2048656C706572202A2F5C725C6E5C725C6E2020676574497465726174696F6E4461746128656C656D656E742920';
wwv_flow_imp.g_varchar2_table(1919) := '7B5C725C6E5C725C6E20202020636F6E7374207B206964207D203D20676574427573696E6573734F626A65637428656C656D656E74293B5C725C6E5C725C6E202020202F2F2067657420706172656E7420697465726174696F6E2066726F6D2062726561';
wwv_flow_imp.g_varchar2_table(1920) := '646372756D625C725C6E20202020636F6E737420706172656E74497465726174696F6E203D20746869732E62726561646372756D6253656C656374696F6E5B746869732E6765744C61737442726561646372756D62496E6465782829202D20315D3B5C72';
wwv_flow_imp.g_varchar2_table(1921) := '5C6E5C725C6E202020202F2F20726574726965766520646174612066726F6D20776964676574206279207573696E6720696420616E6420737465704B65795C725C6E2020202072657475726E2028746869732E5F7769646765742E697465726174696F6E';
wwv_flow_imp.g_varchar2_table(1922) := '446174612026265C725C6E202020202020746869732E5F7769646765742E697465726174696F6E446174615B69645D2026265C725C6E202020202020746869732E5F7769646765742E697465726174696F6E446174615B69645D2E66696C746572285C72';
wwv_flow_imp.g_varchar2_table(1923) := '5C6E202020202020202069203D3E20282821706172656E74497465726174696F6E2026262021692E706172656E74537465704B657929207C7C2028706172656E74497465726174696F6E20262620692E706172656E74537465704B6579203D3D20706172';
wwv_flow_imp.g_varchar2_table(1924) := '656E74497465726174696F6E2E737465704B657929295C725C6E2020202020202929207C7C205B5D3B5C725C6E20207D5C725C6E5C725C6E20202F2A204F7665726C617973202A2F5C725C6E5C725C6E20206164644F7665726C6179732829207B5C725C';
wwv_flow_imp.g_varchar2_table(1925) := '6E20202020746869732E5F656C656D656E7452656769737472795C725C6E2020202020202F2F20696420656C656D656E74206973206E6F2073756270726F6365737320616E642068617320697465726174696F6E20646174615C725C6E2020202020202E';
wwv_flow_imp.g_varchar2_table(1926) := '66696C74657228656C656D656E74203D3E202128697328656C656D656E742C202762706D6E3A53756250726F6365737327292920262620746869732E686173497465726174696F6E4461746128656C656D656E7429295C725C6E2020202020202E666F72';
wwv_flow_imp.g_varchar2_table(1927) := '456163682828656C656D656E7429203D3E207B5C725C6E2020202020202020746869732E6164644F7665726C617928656C656D656E74293B5C725C6E2020202020207D293B5C725C6E20207D5C725C6E5C725C6E20206164644F7665726C617928656C65';
wwv_flow_imp.g_varchar2_table(1928) := '6D656E7429207B5C725C6E5C725C6E20202020636F6E737420627574746F6E203D20646F6D69667928273C627574746F6E20636C6173733D5C22626A732D6472696C6C646F776E2066612066612D6C6973745C223E3C2F627574746F6E3E27293B5C725C';
wwv_flow_imp.g_varchar2_table(1929) := '6E5C725C6E202020202F2F20616464206F6E636C69636B206C697374656E65725C725C6E20202020627574746F6E2E6164644576656E744C697374656E65722827636C69636B272C20285F29203D3E207B5C725C6E202020202020746869732E6F70656E';
wwv_flow_imp.g_varchar2_table(1930) := '497465726174696F6E7328656C656D656E74293B5C725C6E202020207D293B5C725C6E5C725C6E202020202F2F20616464206F7665726C61795C725C6E20202020746869732E5F6F7665726C6179732E61646428656C656D656E742C2027697465726174';
wwv_flow_imp.g_varchar2_table(1931) := '696F6E73272C207B5C725C6E202020202020706F736974696F6E3A207B5C725C6E2020202020202020626F74746F6D3A202D372C5C725C6E202020202020202072696768743A202D385C725C6E2020202020207D2C5C725C6E20202020202068746D6C3A';
wwv_flow_imp.g_varchar2_table(1932) := '20627574746F6E5C725C6E202020207D293B5C725C6E20207D5C725C6E5C725C6E20202F2A20426F6F6C65616E2066756E6374696F6E73202A2F5C725C6E5C725C6E202069734D756C7469496E7374616E636553756250726F6365737328656C656D656E';
wwv_flow_imp.g_varchar2_table(1933) := '7429207B5C725C6E20202020636F6E737420627573696E6573734F626A656374203D20676574427573696E6573734F626A65637428656C656D656E74293B5C725C6E2020202072657475726E20697328656C656D656E742C202762706D6E3A5375625072';
wwv_flow_imp.g_varchar2_table(1934) := '6F63657373272920262620627573696E6573734F626A6563742E6C6F6F704368617261637465726973746963733B5C725C6E20207D5C725C6E5C725C6E2020686173497465726174696F6E4461746128656C656D656E7429207B5C725C6E202020207265';
wwv_flow_imp.g_varchar2_table(1935) := '7475726E20746869732E676574497465726174696F6E4461746128656C656D656E74292E6C656E677468203E20303B5C725C6E20207D5C725C6E5C725C6E20202F2A2042726561646372756D62202A2F5C725C6E5C725C6E202067657442726561646372';
wwv_flow_imp.g_varchar2_table(1936) := '756D62456C656D656E74732829207B5C725C6E20202020636F6E73742062726561646372756D62203D20646F6D517565727928272E626A732D62726561646372756D627327293B202F2F20544F444F206669782073656C6563746F7220666F7220657863';
wwv_flow_imp.g_varchar2_table(1937) := '6C7564696E672063616C6C2061637469766974792062726561646372756D625C725C6E2020202072657475726E205B2E2E2E62726561646372756D622E6368696C6472656E5D3B5C725C6E20207D5C725C6E5C725C6E20206765744C6173744272656164';
wwv_flow_imp.g_varchar2_table(1938) := '6372756D62496E6465782829207B5C725C6E20202020636F6E737420656C656D656E7473203D20746869732E67657442726561646372756D62456C656D656E747328293B5C725C6E2020202072657475726E20656C656D656E74732E6C656E677468202D';
wwv_flow_imp.g_varchar2_table(1939) := '20313B5C725C6E20207D5C725C6E5C725C6E2020726573657442726561646372756D62446174612829207B5C725C6E20202020636F6E7374206C617374496E646578203D20746869732E6765744C61737442726561646372756D62496E64657828293B5C';
wwv_flow_imp.g_varchar2_table(1940) := '725C6E5C725C6E20202020746869732E62726561646372756D62497465726174696F6E2E73706C696365286C617374496E646578202B2031293B5C725C6E20202020746869732E62726561646372756D6253656C656374696F6E2E73706C696365286C61';
wwv_flow_imp.g_varchar2_table(1941) := '7374496E646578202B2031293B5C725C6E20207D5C725C6E5C725C6E2020617070656E6442726561646372756D62427574746F6E28656C656D656E7429207B5C725C6E5C725C6E20202020636F6E7374206C617374456C656D656E74203D20746869732E';
wwv_flow_imp.g_varchar2_table(1942) := '67657442726561646372756D62456C656D656E747328292E706F7028293B5C725C6E5C725C6E202020202F2F20696620656C656D656E74206578697374696E6720286D69676874206265206E756C6C206F6E206469616772616D206C6F6164295C725C6E';
wwv_flow_imp.g_varchar2_table(1943) := '20202020696620286C617374456C656D656E7429207B5C725C6E2020202020202F2F2063726561746520627574746F6E5C725C6E202020202020636F6E737420627574746F6E203D20646F6D69667928273C627574746F6E20636C6173733D5C22626A73';
wwv_flow_imp.g_varchar2_table(1944) := '2D6472696C6C646F776E2066612066612D6C6973745C223E3C2F627574746F6E3E27293B5C725C6E2020202020202F2F20616464206576656E74206C697374656E65725C725C6E202020202020627574746F6E2E6164644576656E744C697374656E6572';
wwv_flow_imp.g_varchar2_table(1945) := '2827636C69636B272C20285F29203D3E207B5C725C6E20202020202020202F2F206F70656E20697465726174696F6E7320666F72207468697320656C656D656E745C725C6E2020202020202020746869732E6F70656E497465726174696F6E7328656C65';
wwv_flow_imp.g_varchar2_table(1946) := '6D656E74293B5C725C6E2020202020207D293B5C725C6E5C725C6E2020202020206C617374456C656D656E742E617070656E6428627574746F6E293B5C725C6E202020207D5C725C6E20207D5C725C6E5C725C6E20207570646174654272656164637275';
wwv_flow_imp.g_varchar2_table(1947) := '6D622829207B5C725C6E5C725C6E20202020636F6E737420656C656D656E7473203D20746869732E67657442726561646372756D62456C656D656E747328293B5C725C6E5C725C6E20202020666F7220286C65742069203D20303B2069203C20656C656D';
wwv_flow_imp.g_varchar2_table(1948) := '656E74732E6C656E6774683B20692B2B29207B5C725C6E5C725C6E202020202020636F6E73742064617461203D20746869732E62726561646372756D62497465726174696F6E5B695D3B5C725C6E5C725C6E2020202020202F2F2069662063757272656E';
wwv_flow_imp.g_varchar2_table(1949) := '742062726561646372756D6220656E7472792068617320697465726174696F6E20646174612026206973206E6F74206C61737420656C656D656E745C725C6E20202020202069662028646174612026262069203C20656C656D656E74732E6C656E677468';
wwv_flow_imp.g_varchar2_table(1950) := '202D203129207B5C725C6E5C725C6E2020202020202020636F6E7374206578697374696E67203D20646F6D517565727928277370616E2E697465726174696F6E2D627574746F6E272C20656C656D656E74735B695D293B5C725C6E5C725C6E2020202020';
wwv_flow_imp.g_varchar2_table(1951) := '202020636F6E7374207370616E203D20646F6D69667928273C7370616E20636C6173733D5C22626A732D6372756D6220697465726174696F6E2D627574746F6E2066612066612D6C6973745C223E3C2F7370616E3E27293B5C725C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(1952) := '5C725C6E20202020202020202F2F20617070656E64207370616E206F72207265706C6163652074657874206966206578697374696E675C725C6E202020202020202069662028216578697374696E672920656C656D656E74735B695D2E617070656E6428';
wwv_flow_imp.g_varchar2_table(1953) := '7370616E293B5C725C6E2020202020202020656C7365206578697374696E672E7265706C61636557697468287370616E293B5C725C6E2020202020207D5C725C6E5C725C6E202020202020636F6E73742073656C6563746564203D20746869732E627265';
wwv_flow_imp.g_varchar2_table(1954) := '61646372756D6253656C656374696F6E5B695D3B5C725C6E5C725C6E2020202020202F2F2069662063757272656E742062726561646372756D6220656E747279206861732073656C656374656420697465726174696F6E5C725C6E202020202020696620';
wwv_flow_imp.g_varchar2_table(1955) := '2873656C656374656429207B5C725C6E5C725C6E2020202020202020636F6E7374206578697374696E67203D20646F6D517565727928277370616E2E697465726174696F6E2D64657363272C20656C656D656E74735B695D293B5C725C6E5C725C6E2020';
wwv_flow_imp.g_varchar2_table(1956) := '202020202020636F6E7374207370616E203D20646F6D69667928603C7370616E20636C6173733D5C22626A732D6372756D6220697465726174696F6E2D646573635C223E247B73656C65637465642E6465736372697074696F6E7D3C2F7370616E3E6029';
wwv_flow_imp.g_varchar2_table(1957) := '3B5C725C6E5C725C6E20202020202020202F2F20617070656E64207370616E206F72207265706C6163652074657874206966206578697374696E675C725C6E202020202020202069662028216578697374696E672920656C656D656E74735B695D2E6170';
wwv_flow_imp.g_varchar2_table(1958) := '70656E64287370616E293B5C725C6E2020202020202020656C7365206578697374696E672E7265706C61636557697468287370616E293B5C725C6E2020202020207D5C725C6E202020207D5C725C6E20207D5C725C6E5C725C6E20202F2A206469616C6F';
wwv_flow_imp.g_varchar2_table(1959) := '67202A2F5C725C6E5C725C6E20206F70656E4469616C6F672829207B5C725C6E5C725C6E20202020636F6E737420736561726368626172203D20646F6D5175657279282723697465726174696F6E2D73656172636820696E70757427293B5C725C6E2020';
wwv_flow_imp.g_varchar2_table(1960) := '2020636F6E7374206D6F64616C203D20646F6D51756572792827236D6F64616C27293B5C725C6E5C725C6E202020202F2F20636C656172207365617263686261725C725C6E202020207365617263686261722E76616C7565203D2027273B5C725C6E2020';
wwv_flow_imp.g_varchar2_table(1961) := '20202F2F2073686F77206D6F64616C5C725C6E202020206D6F64616C2E7374796C652E646973706C6179203D2027666C6578273B5C725C6E20207D5C725C6E5C725C6E20206C6F61645461626C65286461746129207B5C725C6E5C725C6E20202020636F';
wwv_flow_imp.g_varchar2_table(1962) := '6E73742074626F6479203D20646F6D5175657279282723697465726174696F6E2D6C6973742074626F647927293B5C725C6E5C725C6E202020202F2F206275696C64207461626C6520626F64795C725C6E2020202074626F64792E7265706C6163654368';
wwv_flow_imp.g_varchar2_table(1963) := '696C6472656E285C725C6E2020202020202E2E2E2864617461207C7C20746869732E6469616C6F6744617461292E6D617028286429203D3E207B5C725C6E2020202020202020636F6E737420726F77203D20646F6D69667928605C725C6E202020202020';
wwv_flow_imp.g_varchar2_table(1964) := '20203C747220247B746869732E6469616C6F67436C69636B61626C65203F2027636C6173733D5C22636C69636B61626C655C2227203A2027277D3E5C725C6E202020202020202020203C74643E247B642E6C6F6F70436F756E7465727D3C2F74643E5C72';
wwv_flow_imp.g_varchar2_table(1965) := '5C6E202020202020202020203C74643E247B642E6465736372697074696F6E7D3C2F74643E5C725C6E202020202020202020203C74643E247B642E7374617475737D3C2F74643E5C725C6E20202020202020203C2F74723E5C725C6E2020202020206029';
wwv_flow_imp.g_varchar2_table(1966) := '3B5C725C6E5C725C6E20202020202020202F2F20616464206F6E636C69636B206C697374656E657220696620726F77732061726520636C69636B61626C6520287375622070726F636573736573295C725C6E202020202020202069662028746869732E64';
wwv_flow_imp.g_varchar2_table(1967) := '69616C6F67436C69636B61626C6529207B5C725C6E20202020202020202020726F772E6164644576656E744C697374656E65722827636C69636B272C20285F29203D3E207B5C725C6E202020202020202020202020746869732E6C6F6164497465726174';
wwv_flow_imp.g_varchar2_table(1968) := '696F6E28642E6C6F6F70436F756E746572293B5C725C6E202020202020202020202020746869732E636C6F7365497465726174696F6E7328293B5C725C6E202020202020202020207D293B5C725C6E20202020202020207D5C725C6E5C725C6E20202020';
wwv_flow_imp.g_varchar2_table(1969) := '2020202072657475726E20726F773B5C725C6E2020202020207D29293B5C725C6E20207D5C725C6E5C725C6E20206F70656E497465726174696F6E7328656C656D656E7429207B5C725C6E5C725C6E202020202F2F2073746F7265206461746120616E64';
wwv_flow_imp.g_varchar2_table(1970) := '20636C69636B61626C6520696E666F20666F72206C617465725C725C6E20202020746869732E6469616C6F6744617461203D20746869732E676574497465726174696F6E4461746128656C656D656E74293B5C725C6E20202020746869732E6469616C6F';
wwv_flow_imp.g_varchar2_table(1971) := '67436C69636B61626C65203D20697328656C656D656E742C202762706D6E3A53756250726F6365737327293B5C725C6E5C725C6E2020202069662028746869732E6469616C6F674461746129207B5C725C6E5C725C6E202020202020746869732E6C6F61';
wwv_flow_imp.g_varchar2_table(1972) := '645461626C6528293B5C725C6E5C725C6E2020202020202F2F20736574207469746C655C725C6E202020202020636F6E7374207469746C65203D20646F6D5175657279282723697465726174696F6E2D7469746C65207370616E27293B5C725C6E202020';
wwv_flow_imp.g_varchar2_table(1973) := '2020207469746C652E74657874436F6E74656E74203D20676574427573696E6573734F626A65637428656C656D656E74292E6E616D653B5C725C6E5C725C6E202020202020746869732E6F70656E4469616C6F6728293B5C725C6E202020207D5C725C6E';
wwv_flow_imp.g_varchar2_table(1974) := '20207D5C725C6E5C725C6E2020636C6F7365497465726174696F6E732829207B5C725C6E5C725C6E20202020636F6E7374206D6F64616C203D20646F6D51756572792827236D6F64616C27293B5C725C6E5C725C6E202020206D6F64616C2E7374796C65';
wwv_flow_imp.g_varchar2_table(1975) := '2E646973706C6179203D20276E6F6E65273B5C725C6E20207D5C725C6E5C725C6E20206C6F6164497465726174696F6E286C6F6F70436F756E74657229207B5C725C6E5C725C6E20202020636F6E73742073656C6563746564497465726174696F6E203D';
wwv_flow_imp.g_varchar2_table(1976) := '20746869732E6469616C6F67446174612E66696E642876203D3E20762E6C6F6F70436F756E746572203D3D206C6F6F70436F756E746572293B5C725C6E5C725C6E20202020746869732E62726561646372756D6253656C656374696F6E5B746869732E67';
wwv_flow_imp.g_varchar2_table(1977) := '65744C61737442726561646372756D62496E64657828295D203D2073656C6563746564497465726174696F6E3B5C725C6E5C725C6E20202020746869732E75706461746542726561646372756D6228293B5C725C6E20202020746869732E757064617465';
wwv_flow_imp.g_varchar2_table(1978) := '486967686C69676874696E6728293B5C725C6E20207D5C725C6E5C725C6E202066696C746572497465726174696F6E73286576656E7429207B5C725C6E5C725C6E20202020636F6E7374207B2076616C7565207D203D206576656E742E7461726765743B';
wwv_flow_imp.g_varchar2_table(1979) := '5C725C6E5C725C6E20202020636F6E73742066696C7465726564203D20746869732E6469616C6F67446174612E66696C746572285C725C6E20202020202064203D3E20642E6465736372697074696F6E2E696E636C756465732876616C756529207C7C20';
wwv_flow_imp.g_varchar2_table(1980) := '642E7374617475732E696E636C756465732876616C7565295C725C6E20202020293B5C725C6E5C725C6E20202020746869732E6C6F61645461626C652866696C7465726564293B5C725C6E20207D5C725C6E5C725C6E20202F2A205574696C202A2F5C72';
wwv_flow_imp.g_varchar2_table(1981) := '5C6E20205C725C6E2020757064617465486967686C69676874696E672829207B5C725C6E5C725C6E2020202069662028746869732E5F77696467657429207B5C725C6E5C725C6E202020202020636F6E73742063757272656E74497465726174696F6E20';
wwv_flow_imp.g_varchar2_table(1982) := '3D20746869732E62726561646372756D6253656C656374696F6E5B746869732E6765744C61737442726561646372756D62496E64657828295D3B5C725C6E5C725C6E2020202020206966202863757272656E74497465726174696F6E29207B5C725C6E20';
wwv_flow_imp.g_varchar2_table(1983) := '20202020202020636F6E7374207B2063757272656E742C20636F6D706C657465642C206572726F72207D203D2063757272656E74497465726174696F6E2E686967686C69676874696E673B5C725C6E2020202020202020746869732E5F7769646765742E';
wwv_flow_imp.g_varchar2_table(1984) := '757064617465436F6C6F72732863757272656E742C20636F6D706C657465642C206572726F72293B5C725C6E2020202020207D20656C7365207B5C725C6E2020202020202020746869732E5F7769646765742E7265736574436F6C6F727328293B5C725C';
wwv_flow_imp.g_varchar2_table(1985) := '6E2020202020207D5C725C6E202020207D5C725C6E20207D5C725C6E7D5C725C6E5C725C6E4D756C7469496E7374616E63654D6F64756C652E24696E6A656374203D205B2763616E766173272C20276576656E74427573272C2027656C656D656E745265';
wwv_flow_imp.g_varchar2_table(1986) := '676973747279272C20277472616E736C617465272C20276F7665726C617973275D3B222C22696D706F7274207B204D756C7469496E7374616E63654D6F64756C65207D2066726F6D20272E2F4D756C7469496E7374616E63654D6F64756C65273B5C725C';
wwv_flow_imp.g_varchar2_table(1987) := '6E5C725C6E6578706F72742064656661756C74207B5C725C6E20205F5F696E69745F5F3A205B276D756C7469496E7374616E63654D6F64756C65275D2C5C725C6E20206D756C7469496E7374616E63654D6F64756C653A205B2774797065272C204D756C';
wwv_flow_imp.g_varchar2_table(1988) := '7469496E7374616E63654D6F64756C655D2C5C725C6E7D3B222C226578706F72742064656661756C742066756E6374696F6E205374796C654D6F64756C6528636F6E6669672C2062706D6E52656E64657265722C20656C656D656E745265676973747279';
wwv_flow_imp.g_varchar2_table(1989) := '29207B5C725C6E5C725C6E20202F2F2073657420676C6F62616C20637373207661726961626C65735C725C6E2020636F6E73742063616E766173203D20646F63756D656E742E717565727953656C6563746F7228272E63616E76617327293B5C725C6E5C';
wwv_flow_imp.g_varchar2_table(1990) := '725C6E202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D63757272656E742D66696C6C272C20636F6E6669672E63757272656E745374796C652E66696C6C293B5C725C6E202063616E7661732E737479';
wwv_flow_imp.g_varchar2_table(1991) := '6C652E73657450726F706572747928272D2D686967686C696768742D63757272656E742D626F72646572272C20636F6E6669672E63757272656E745374796C652E626F72646572293B5C725C6E202063616E7661732E7374796C652E73657450726F7065';
wwv_flow_imp.g_varchar2_table(1992) := '72747928272D2D686967686C696768742D63757272656E742D6C6162656C272C20636F6E6669672E63757272656E745374796C652E6C6162656C293B5C725C6E202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C69';
wwv_flow_imp.g_varchar2_table(1993) := '6768742D636F6D706C657465642D66696C6C272C20636F6E6669672E636F6D706C657465645374796C652E66696C6C293B5C725C6E202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D636F6D706C6574';
wwv_flow_imp.g_varchar2_table(1994) := '65642D626F72646572272C20636F6E6669672E636F6D706C657465645374796C652E626F72646572293B5C725C6E202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D636F6D706C657465642D6C616265';
wwv_flow_imp.g_varchar2_table(1995) := '6C272C20636F6E6669672E636F6D706C657465645374796C652E6C6162656C293B5C725C6E202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D6572726F722D66696C6C272C20636F6E6669672E657272';
wwv_flow_imp.g_varchar2_table(1996) := '6F725374796C652E66696C6C293B5C725C6E202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D6572726F722D626F72646572272C20636F6E6669672E6572726F725374796C652E626F72646572293B5C';
wwv_flow_imp.g_varchar2_table(1997) := '725C6E202063616E7661732E7374796C652E73657450726F706572747928272D2D686967686C696768742D6572726F722D6C6162656C272C20636F6E6669672E6572726F725374796C652E6C6162656C293B5C725C6E5C725C6E2020746869732E616464';
wwv_flow_imp.g_varchar2_table(1998) := '5374796C65546F456C656D656E7473203D2066756E6374696F6E2028656C656D656E74732C20636C6173734E616D6529207B5C725C6E5C725C6E202020206C657420656C656D656E743B5C725C6E5C725C6E20202020666F722028636F6E73742065206F';
wwv_flow_imp.g_varchar2_table(1999) := '6620656C656D656E747329207B5C725C6E5C725C6E202020202020656C656D656E74203D20646F63756D656E742E717565727953656C6563746F722860675B646174612D656C656D656E742D69643D5C22247B657D5C225D3A6E6F74282E646A732D636F';
wwv_flow_imp.g_varchar2_table(2000) := '6E6E656374696F6E29202E646A732D76697375616C60293B5C725C6E5C725C6E20202020202069662028656C656D656E7429207B5C725C6E2020202020202020656C656D656E742E636C6173734C6973742E61646428636C6173734E616D65293B5C725C';
wwv_flow_imp.g_varchar2_table(2001) := '6E2020202020207D5C725C6E202020207D5C725C6E20207D3B5C725C6E20205C725C6E2020746869732E686967686C69676874456C656D656E7473203D2066756E6374696F6E202863757272656E742C20636F6D706C657465642C206572726F7229207B';
wwv_flow_imp.g_varchar2_table(2002) := '5C725C6E202020206966202863757272656E742026262063757272656E742E6C656E677468203E20302920746869732E6164645374796C65546F456C656D656E74732863757272656E742C2027686967686C696768742D63757272656E7427293B5C725C';
wwv_flow_imp.g_varchar2_table(2003) := '6E2020202069662028636F6D706C6574656420262620636F6D706C657465642E6C656E677468203E20302920746869732E6164645374796C65546F456C656D656E747328636F6D706C657465642C2027686967686C696768742D636F6D706C6574656427';
wwv_flow_imp.g_varchar2_table(2004) := '293B5C725C6E20202020696620286572726F72202626206572726F722E6C656E677468203E20302920746869732E6164645374796C65546F456C656D656E7473286572726F722C2027686967686C696768742D6572726F7227293B5C725C6E20207D3B5C';
wwv_flow_imp.g_varchar2_table(2005) := '725C6E5C725C6E2020746869732E7265736574486967686C69676874696E67203D2066756E6374696F6E202829207B5C725C6E5C725C6E20202020636F6E737420656C656D656E7473203D204F626A6563742E6B65797328656C656D656E745265676973';
wwv_flow_imp.g_varchar2_table(2006) := '7472792E5F656C656D656E7473293B5C725C6E202020206C657420656C656D656E743B5C725C6E5C725C6E20202020666F722028636F6E73742065206F6620656C656D656E747329207B5C725C6E5C725C6E202020202020656C656D656E74203D20646F';
wwv_flow_imp.g_varchar2_table(2007) := '63756D656E742E717565727953656C6563746F722860675B646174612D656C656D656E742D69643D5C22247B657D5C225D3A6E6F74282E646A732D636F6E6E656374696F6E29202E646A732D76697375616C60293B5C725C6E5C725C6E20202020202069';
wwv_flow_imp.g_varchar2_table(2008) := '662028656C656D656E7429207B5C725C6E2020202020202020656C656D656E742E636C6173734C6973742E72656D6F76652827686967686C696768742D63757272656E7427293B5C725C6E2020202020202020656C656D656E742E636C6173734C697374';
wwv_flow_imp.g_varchar2_table(2009) := '2E72656D6F76652827686967686C696768742D636F6D706C6574656427293B5C725C6E2020202020202020656C656D656E742E636C6173734C6973742E72656D6F76652827686967686C696768742D6572726F7227293B5C725C6E2020202020207D5C72';
wwv_flow_imp.g_varchar2_table(2010) := '5C6E202020207D5C725C6E20207D3B5C725C6E5C725C6E2020746869732E726573657442504D4E636F6C6F7273203D2066756E6374696F6E202829207B5C725C6E5C725C6E20202020636F6E737420656C656D656E7473203D204F626A6563742E6B6579';
wwv_flow_imp.g_varchar2_table(2011) := '7328656C656D656E7452656769737472792E5F656C656D656E7473293B5C725C6E202020206C657420656C656D656E743B5C725C6E5C725C6E20202020666F722028636F6E73742065206F6620656C656D656E747329207B5C725C6E5C725C6E20202020';
wwv_flow_imp.g_varchar2_table(2012) := '2020656C656D656E74203D20646F63756D656E742E717565727953656C6563746F722860675B646174612D656C656D656E742D69643D5C22247B657D5C225D3A6E6F74282E646A732D636F6E6E656374696F6E29202E646A732D76697375616C60293B5C';
wwv_flow_imp.g_varchar2_table(2013) := '725C6E5C725C6E20202020202069662028656C656D656E7429207B5C725C6E5C725C6E2020202020202020656C656D656E742E636C6173734C6973742E616464282772657365742D62706D6E2D636F6C6F727327293B5C725C6E2020202020207D5C725C';
wwv_flow_imp.g_varchar2_table(2014) := '6E202020207D5C725C6E20207D3B5C725C6E5C725C6E2020746869732E6164645374796C65546F535647203D2066756E6374696F6E202873766729207B5C725C6E20202020636F6E737420706172736572203D206E657720444F4D50617273657228293B';
wwv_flow_imp.g_varchar2_table(2015) := '5C725C6E20202020636F6E737420786D6C446F63203D207061727365722E706172736546726F6D537472696E67287376672C2027746578742F786D6C27293B5C725C6E20205C725C6E20202020636F6E7374205B646566735D203D20786D6C446F632E67';
wwv_flow_imp.g_varchar2_table(2016) := '6574456C656D656E747342795461674E616D6528276465667327293B5C725C6E20205C725C6E20202020636F6E7374207374796C654E6F6465203D20646F63756D656E742E637265617465456C656D656E7428277374796C6527293B5C725C6E20202020';
wwv_flow_imp.g_varchar2_table(2017) := '7374796C654E6F64652E736574417474726962757465282774797065272C2027746578742F63737327293B5C725C6E5C725C6E20202020636F6E737420636F6E74656E74203D20646F63756D656E742E637265617465546578744E6F646528272E646A73';
wwv_flow_imp.g_varchar2_table(2018) := '2D67726F7570207B202D2D64656661756C742D66696C6C2D636F6C6F723A2077686974653B202D2D64656661756C742D7374726F6B652D636F6C6F723A20626C61636B3B207D27293B5C725C6E202020207374796C654E6F64652E617070656E64436869';
wwv_flow_imp.g_varchar2_table(2019) := '6C6428636F6E74656E74293B5C725C6E202020205C725C6E20202020646566732E617070656E644368696C64287374796C654E6F6465293B5C725C6E20205C725C6E20202020636F6E737420786D6C54657874203D206E657720584D4C53657269616C69';
wwv_flow_imp.g_varchar2_table(2020) := '7A657228292E73657269616C697A65546F537472696E6728786D6C446F63293B5C725C6E20205C725C6E2020202072657475726E20786D6C546578743B5C725C6E20207D3B5C725C6E7D5C725C6E5C725C6E5374796C654D6F64756C652E24696E6A6563';
wwv_flow_imp.g_varchar2_table(2021) := '74203D205B5C725C6E20202F2F20637573746F6D207669657765722070726F70657274696573206E657374656420696E7369646520706172656E7420636F6E666967206F626A6563745C725C6E202027636F6E6669672E636F6E666967272C5C725C6E20';
wwv_flow_imp.g_varchar2_table(2022) := '2027636F6E6669672E62706D6E52656E6465726572272C5C725C6E202027656C656D656E745265676973747279275C725C6E5D3B5C725C6E222C22696D706F7274205374796C654D6F64756C652066726F6D20272E2F5374796C654D6F64756C652E6A73';
wwv_flow_imp.g_varchar2_table(2023) := '273B5C725C6E5C725C6E6578706F72742064656661756C74207B5C725C6E20205F5F696E69745F5F3A205B277374796C654D6F64756C65275D2C5C725C6E20207374796C654D6F64756C653A205B2774797065272C205374796C654D6F64756C655D5C72';
wwv_flow_imp.g_varchar2_table(2024) := '5C6E7D3B5C725C6E222C225C725C6E696D706F7274207B20676574427573696E6573734F626A6563742C206973207D2066726F6D202762706D6E2D6A732F6C69622F7574696C2F4D6F64656C5574696C273B5C725C6E696D706F7274207B20646F6D6966';
wwv_flow_imp.g_varchar2_table(2025) := '79207D2066726F6D20276D696E2D646F6D273B5C725C6E5C725C6E6578706F727420636C61737320557365725461736B4D6F64756C65207B5C725C6E5C725C6E2020636F6E7374727563746F722863616E7661732C206576656E744275732C20656C656D';
wwv_flow_imp.g_varchar2_table(2026) := '656E7452656769737472792C207472616E736C6174652C206F7665726C61797329207B5C725C6E20202020746869732E5F63616E766173203D2063616E7661733B5C725C6E20202020746869732E5F6576656E74427573203D206576656E744275733B5C';
wwv_flow_imp.g_varchar2_table(2027) := '725C6E20202020746869732E5F656C656D656E745265676973747279203D20656C656D656E7452656769737472793B5C725C6E20202020746869732E5F7472616E736C617465203D207472616E736C6174653B5C725C6E20202020746869732E5F6F7665';
wwv_flow_imp.g_varchar2_table(2028) := '726C617973203D206F7665726C6179733B5C725C6E20207D5C725C6E5C725C6E20206164644F7665726C6179732829207B5C725C6E5C725C6E20202020636F6E7374207B20757365725461736B44617461207D203D20746869732E5F7769646765743B5C';
wwv_flow_imp.g_varchar2_table(2029) := '725C6E5C725C6E20202020746869732E5F656C656D656E7452656769737472792E66696C7465722828656C656D656E7429203D3E207B5C725C6E202020202020636F6E737420626F203D20676574427573696E6573734F626A65637428656C656D656E74';
wwv_flow_imp.g_varchar2_table(2030) := '293B5C725C6E2020202020202F2A206F6E6C792073686F77206C696E6B20627574746F6E2069665C725C6E202020202020202A202D20656C656D656E7420697320757365725461736B5C725C6E202020202020202A202D206C696E6B2069732065786973';
wwv_flow_imp.g_varchar2_table(2031) := '74696E675C725C6E202020202020202A202D20656C656D656E74206973206E6F7420697465726174696E675C725C6E202020202020202A202D20706172656E74206973206E6F7420697465726174696E675C725C6E202020202020202A2F5C725C6E2020';
wwv_flow_imp.g_varchar2_table(2032) := '2020202072657475726E20697328656C656D656E742C202762706D6E3A557365725461736B27292026262028757365725461736B4461746120262620757365725461736B446174615B656C656D656E742E69645D292026262021626F2E6C6F6F70436861';
wwv_flow_imp.g_varchar2_table(2033) := '7261637465726973746963732026262021626F2E24706172656E742E6C6F6F704368617261637465726973746963733B5C725C6E202020207D292E666F72456163682828656C656D656E7429203D3E207B5C725C6E202020202020746869732E6164644F';
wwv_flow_imp.g_varchar2_table(2034) := '7665726C617928656C656D656E742C20757365725461736B446174615B656C656D656E742E69645D293B5C725C6E202020207D293B5C725C6E20207D5C725C6E5C725C6E20206164644F7665726C617928656C656D656E742C2075726C29207B5C725C6E';
wwv_flow_imp.g_varchar2_table(2035) := '5C725C6E20202020636F6E737420627574746F6E203D20646F6D69667928273C627574746F6E20636C6173733D5C22626A732D6472696C6C646F776E2066612066612D65787465726E616C2D6C696E6B5C223E3C2F627574746F6E3E27293B5C725C6E5C';
wwv_flow_imp.g_varchar2_table(2036) := '725C6E20202020627574746F6E2E6164644576656E744C697374656E65722827636C69636B272C2066756E6374696F6E202829207B5C725C6E20202020202077696E646F772E6F70656E2875726C2C20275F73656C6627293B5C725C6E202020207D293B';
wwv_flow_imp.g_varchar2_table(2037) := '5C725C6E5C725C6E202020202F2F20616464206F7665726C61795C725C6E20202020746869732E5F6F7665726C6179732E61646428656C656D656E742C2027697465726174696F6E73272C207B5C725C6E202020202020706F736974696F6E3A207B5C72';
wwv_flow_imp.g_varchar2_table(2038) := '5C6E2020202020202020626F74746F6D3A202D372C5C725C6E202020202020202072696768743A202D385C725C6E2020202020207D2C5C725C6E20202020202068746D6C3A20627574746F6E5C725C6E202020207D293B5C725C6E20207D5C725C6E5C72';
wwv_flow_imp.g_varchar2_table(2039) := '5C6E20207365745769646765742877696467657429207B5C725C6E20202020746869732E5F776964676574203D207769646765743B5C725C6E20207D5C725C6E7D5C725C6E5C725C6E557365725461736B4D6F64756C652E24696E6A656374203D205B27';
wwv_flow_imp.g_varchar2_table(2040) := '63616E766173272C20276576656E74427573272C2027656C656D656E745265676973747279272C20277472616E736C617465272C20276F7665726C617973275D3B222C22696D706F7274207B20557365725461736B4D6F64756C65207D2066726F6D2027';
wwv_flow_imp.g_varchar2_table(2041) := '2E2F557365725461736B4D6F64756C65273B5C725C6E5C725C6E6578706F72742064656661756C74207B5C725C6E20205F5F696E69745F5F3A205B27757365725461736B4D6F64756C65275D2C5C725C6E2020757365725461736B4D6F64756C653A205B';
wwv_flow_imp.g_varchar2_table(2042) := '2774797065272C20557365725461736B4D6F64756C655D2C5C725C6E7D3B222C222F2A2A5C6E202A2054686520636F646520696E20746865203C70726F6A6563742D6C6F676F3E3C2F70726F6A6563742D6C6F676F3E20617265615C6E202A206D757374';
wwv_flow_imp.g_varchar2_table(2043) := '206E6F74206265206368616E6765642E5C6E202A5C6E202A204073656520687474703A2F2F62706D6E2E696F2F6C6963656E736520666F72206D6F726520696E666F726D6174696F6E2E5C6E202A2F5C6E696D706F7274207B5C6E202061737369676E2C';
wwv_flow_imp.g_varchar2_table(2044) := '5C6E202066696E642C5C6E202069734E756D6265722C5C6E20206F6D69745C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E2020646F6D6966792C5C6E202061737369676E5374796C652C5C6E202071756572792061';
wwv_flow_imp.g_varchar2_table(2045) := '7320646F6D51756572792C5C6E202072656D6F766520617320646F6D52656D6F76655C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E696D706F7274207B5C6E2020696E6E65725356475C6E7D2066726F6D202774696E792D737667273B5C6E5C';
wwv_flow_imp.g_varchar2_table(2046) := '6E696D706F7274204469616772616D2066726F6D20276469616772616D2D6A73273B5C6E696D706F72742042706D6E4D6F64646C652066726F6D202762706D6E2D6D6F64646C65273B5C6E5C6E696D706F727420696E6865726974732066726F6D202769';
wwv_flow_imp.g_varchar2_table(2047) := '6E6865726974732D62726F77736572273B5C6E5C6E696D706F7274207B5C6E2020696D706F727442706D6E4469616772616D5C6E7D2066726F6D20272E2F696D706F72742F496D706F72746572273B5C6E5C6E2F2A2A5C6E202A204074656D706C617465';
wwv_flow_imp.g_varchar2_table(2048) := '20545C6E202A5C6E202A204074797065646566207B20696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C743C543E207D204576656E744275735C6E202A2F5C6E5C6E2F2A2A5C6E202A2040';
wwv_flow_imp.g_varchar2_table(2049) := '74656D706C61746520545C6E202A5C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E4576656E744275734576656E7443616C6C6261636B3C543E7D204576656E7442';
wwv_flow_imp.g_varchar2_table(2050) := '75734576656E7443616C6C6261636B5C6E202A2F5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E7D204D6F64756C654465636C61726174696F6E5C6E202A5C6E20';
wwv_flow_imp.g_varchar2_table(2051) := '2A204074797065646566207B696D706F727428272E2F6D6F64656C2F547970657327292E4D6F64646C657D204D6F64646C655C6E202A204074797065646566207B696D706F727428272E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D65';
wwv_flow_imp.g_varchar2_table(2052) := '6E747D204D6F64646C65456C656D656E745C6E202A204074797065646566207B696D706F727428272E2F6D6F64656C2F547970657327292E4D6F64646C65457874656E73696F6E7D204D6F64646C65457874656E73696F6E5C6E202A5C6E202A20407479';
wwv_flow_imp.g_varchar2_table(2053) := '7065646566207B207B5C6E202A20202077696474683F3A206E756D6265727C737472696E673B5C6E202A2020206865696768743F3A206E756D6265727C737472696E673B5C6E202A202020706F736974696F6E3F3A20737472696E673B5C6E202A202020';
wwv_flow_imp.g_varchar2_table(2054) := '636F6E7461696E65723F3A20737472696E677C48544D4C456C656D656E743B5C6E202A2020206D6F64646C65457874656E73696F6E733F3A204D6F64646C65457874656E73696F6E733B5C6E202A2020206164646974696F6E616C4D6F64756C65733F3A';
wwv_flow_imp.g_varchar2_table(2055) := '204D6F64756C654465636C61726174696F6E5B5D3B5C6E202A207D2026205265636F72643C737472696E672C20616E793E207D20426173655669657765724F7074696F6E735C6E202A5C6E202A204074797065646566207B5265636F72643C737472696E';
wwv_flow_imp.g_varchar2_table(2056) := '672C204D6F64646C65456C656D656E743E7D204D6F64646C65456C656D656E7473427949645C6E202A5C6E202A204074797065646566207B207B5C6E202A2020205B6B65793A20737472696E675D3A204D6F64646C65457874656E73696F6E3B5C6E202A';
wwv_flow_imp.g_varchar2_table(2057) := '207D207D204D6F64646C65457874656E73696F6E735C6E202A5C6E202A204074797065646566207B207B5C6E202A2020207761726E696E67733A20737472696E675B5D3B5C6E202A207D207D20496D706F7274584D4C526573756C745C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(2058) := '204074797065646566207B496D706F7274584D4C526573756C742026204572726F727D20496D706F7274584D4C4572726F725C6E202A5C6E202A204074797065646566207B496D706F7274584D4C526573756C747D20496D706F7274446566696E697469';
wwv_flow_imp.g_varchar2_table(2059) := '6F6E73526573756C745C6E202A5C6E202A204074797065646566207B496D706F7274584D4C4572726F727D20496D706F7274446566696E6974696F6E734572726F725C6E202A5C6E202A204074797065646566207B496D706F7274584D4C526573756C74';
wwv_flow_imp.g_varchar2_table(2060) := '7D204F70656E526573756C745C6E202A5C6E202A204074797065646566207B496D706F7274584D4C4572726F727D204F70656E4572726F725C6E202A5C6E202A204074797065646566207B207B5C6E202A202020666F726D61743F3A20626F6F6C65616E';
wwv_flow_imp.g_varchar2_table(2061) := '3B5C6E202A202020707265616D626C653F3A20626F6F6C65616E3B5C6E202A207D207D2053617665584D4C4F7074696F6E735C6E202A5C6E202A204074797065646566207B207B5C6E202A202020786D6C3F3A20737472696E673B5C6E202A2020206572';
wwv_flow_imp.g_varchar2_table(2062) := '726F723F3A204572726F723B5C6E202A207D207D2053617665584D4C526573756C745C6E202A5C6E202A204074797065646566207B207B5C6E202A2020207376673A20737472696E673B5C6E202A207D207D2053617665535647526573756C745C6E202A';
wwv_flow_imp.g_varchar2_table(2063) := '5C6E202A204074797065646566207B207B5C6E202A202020786D6C3A20737472696E673B5C6E202A207D207D20496D706F7274506172736553746172744576656E745C6E202A5C6E202A204074797065646566207B207B5C6E202A2020206572726F723F';
wwv_flow_imp.g_varchar2_table(2064) := '3A20496D706F7274584D4C4572726F723B5C6E202A202020646566696E6974696F6E733F3A204D6F64646C65456C656D656E743B5C6E202A202020656C656D656E7473427949643F3A204D6F64646C65456C656D656E7473427949643B5C6E202A202020';
wwv_flow_imp.g_varchar2_table(2065) := '7265666572656E6365733F3A204D6F64646C65456C656D656E745B5D3B5C6E202A2020207761726E696E67733A20737472696E675B5D3B5C6E202A207D207D20496D706F72745061727365436F6D706C6574654576656E745C6E202A5C6E202A20407479';
wwv_flow_imp.g_varchar2_table(2066) := '7065646566207B207B5C6E202A2020206572726F723F3A20496D706F7274584D4C4572726F723B5C6E202A2020207761726E696E67733A20737472696E675B5D3B5C6E202A207D207D20496D706F7274446F6E654576656E745C6E202A5C6E202A204074';
wwv_flow_imp.g_varchar2_table(2067) := '797065646566207B207B5C6E202A202020646566696E6974696F6E733A204D6F64646C65456C656D656E743B5C6E202A207D207D2053617665584D4C53746172744576656E745C6E202A5C6E202A204074797065646566207B53617665584D4C52657375';
wwv_flow_imp.g_varchar2_table(2068) := '6C747D2053617665584D4C446F6E654576656E745C6E202A5C6E202A204074797065646566207B207B5C6E202A2020206572726F723F3A204572726F723B5C6E202A2020207376673A20737472696E673B5C6E202A207D207D2053617665535647446F6E';
wwv_flow_imp.g_varchar2_table(2069) := '654576656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A204074656D706C61746520547970655C6E202A5C6E202A204074797065646566207B205479706520657874656E6473207B206576656E744275733A204576656E744275733C696E66657220583E20';
wwv_flow_imp.g_varchar2_table(2070) := '7D203F2058203A206E65766572207D204576656E744D61705C6E202A2F5C6E5C6E2F2A2A5C6E202A204120626173652076696577657220666F722042504D4E20322E30206469616772616D732E5C6E202A5C6E202A20486176652061206C6F6F6B206174';
wwv_flow_imp.g_varchar2_table(2071) := '207B406C696E6B2062706D6E2D6A732F6C69622F5669657765727D2C207B406C696E6B2062706D6E2D6A732F6C69622F4E61766967617465645669657765727D206F72207B406C696E6B2062706D6E2D6A732F6C69622F4D6F64656C65727D20666F725C';
wwv_flow_imp.g_varchar2_table(2072) := '6E202A2062756E646C6573207468617420696E636C7564652061637475616C2066656174757265732E5C6E202A5C6E202A204074656D706C617465205B536572766963654D61703D6E756C6C5D5C6E202A5C6E202A2040657874656E6473204469616772';
wwv_flow_imp.g_varchar2_table(2073) := '616D3C536572766963654D61703E5C6E202A5C6E202A2040706172616D207B426173655669657765724F7074696F6E737D205B6F7074696F6E735D20546865206F7074696F6E7320746F20636F6E66696775726520746865207669657765722E5C6E202A';
wwv_flow_imp.g_varchar2_table(2074) := '2F5C6E6578706F72742064656661756C742066756E6374696F6E2042617365566965776572286F7074696F6E7329207B5C6E5C6E20202F2A2A5C6E2020202A204074797065207B426173655669657765724F7074696F6E737D5C6E2020202A2F5C6E2020';
wwv_flow_imp.g_varchar2_table(2075) := '6F7074696F6E73203D2061737369676E287B7D2C2044454641554C545F4F5054494F4E532C206F7074696F6E73293B5C6E5C6E20202F2A2A5C6E2020202A204074797065207B4D6F64646C657D5C6E2020202A2F5C6E2020746869732E5F6D6F64646C65';
wwv_flow_imp.g_varchar2_table(2076) := '203D20746869732E5F6372656174654D6F64646C65286F7074696F6E73293B5C6E5C6E20202F2A2A5C6E2020202A204074797065207B48544D4C456C656D656E747D5C6E2020202A2F5C6E2020746869732E5F636F6E7461696E6572203D20746869732E';
wwv_flow_imp.g_varchar2_table(2077) := '5F637265617465436F6E7461696E6572286F7074696F6E73293B5C6E5C6E20202F2A203C70726F6A6563742D6C6F676F3E202A2F5C6E5C6E202061646450726F6A6563744C6F676F28746869732E5F636F6E7461696E6572293B5C6E5C6E20202F2A203C';
wwv_flow_imp.g_varchar2_table(2078) := '2F70726F6A6563742D6C6F676F3E202A2F5C6E5C6E2020746869732E5F696E697428746869732E5F636F6E7461696E65722C20746869732E5F6D6F64646C652C206F7074696F6E73293B5C6E7D5C6E5C6E696E6865726974732842617365566965776572';
wwv_flow_imp.g_varchar2_table(2079) := '2C204469616772616D293B5C6E5C6E2F2A2A5C6E202A20506172736520616E642072656E64657220612042504D4E20322E30206469616772616D2E5C6E202A5C6E202A204F6E63652066696E69736865642074686520766965776572207265706F727473';
wwv_flow_imp.g_varchar2_table(2080) := '206261636B2074686520726573756C7420746F207468655C6E202A2070726F76696465642063616C6C6261636B2066756E6374696F6E207769746820286572722C207761726E696E6773292E5C6E202A5C6E202A202323204C6966652D4379636C652045';
wwv_flow_imp.g_varchar2_table(2081) := '76656E74735C6E202A5C6E202A20447572696E6720696D706F727420746865207669657765722077696C6C2066697265206C6966652D6379636C65206576656E74733A5C6E202A5C6E202A2020202A20696D706F72742E70617273652E73746172742028';
wwv_flow_imp.g_varchar2_table(2082) := '61626F757420746F2072656164206D6F64656C2066726F6D20584D4C295C6E202A2020202A20696D706F72742E70617273652E636F6D706C65746520286D6F64656C20726561643B206D6179206861766520776F726B6564206F72206E6F74295C6E202A';
wwv_flow_imp.g_varchar2_table(2083) := '2020202A20696D706F72742E72656E6465722E7374617274202867726170686963616C20696D706F7274207374617274295C6E202A2020202A20696D706F72742E72656E6465722E636F6D706C657465202867726170686963616C20696D706F72742066';
wwv_flow_imp.g_varchar2_table(2084) := '696E6973686564295C6E202A2020202A20696D706F72742E646F6E65202865766572797468696E6720646F6E65295C6E202A5C6E202A20596F752063616E20757365207468657365206576656E747320746F20686F6F6B20696E746F20746865206C6966';
wwv_flow_imp.g_varchar2_table(2085) := '652D6379636C652E5C6E202A5C6E202A20407468726F7773207B496D706F7274584D4C4572726F727D20416E206572726F72207468726F776E20647572696E672074686520696D706F7274206F662074686520584D4C2E5C6E202A5C6E202A2040666972';
wwv_flow_imp.g_varchar2_table(2086) := '6573204261736556696577657223496D706F7274506172736553746172744576656E745C6E202A20406669726573204261736556696577657223496D706F72745061727365436F6D706C6574654576656E745C6E202A2040666972657320496D706F7274';
wwv_flow_imp.g_varchar2_table(2087) := '657223496D706F727452656E64657253746172744576656E745C6E202A2040666972657320496D706F7274657223496D706F727452656E646572436F6D706C6574654576656E745C6E202A20406669726573204261736556696577657223496D706F7274';
wwv_flow_imp.g_varchar2_table(2088) := '446F6E654576656E745C6E202A5C6E202A2040706172616D207B737472696E677D20786D6C205468652042504D4E20322E3020584D4C20746F20626520696D706F727465642E5C6E202A2040706172616D207B4D6F64646C65456C656D656E747C737472';
wwv_flow_imp.g_varchar2_table(2089) := '696E677D205B62706D6E4469616772616D5D20546865206F7074696F6E616C206469616772616D206F72204964206F66207468652042504D4E206469616772616D20746F206F70656E2E5C6E202A5C6E202A204072657475726E207B50726F6D6973653C';
wwv_flow_imp.g_varchar2_table(2090) := '496D706F7274584D4C526573756C743E7D20412070726F6D697365207265736F6C76696E672077697468207761726E696E6773207468617420776572652070726F647563656420647572696E672074686520696D706F72742E5C6E202A2F5C6E42617365';
wwv_flow_imp.g_varchar2_table(2091) := '5669657765722E70726F746F747970652E696D706F7274584D4C203D206173796E632066756E6374696F6E20696D706F7274584D4C28786D6C2C2062706D6E4469616772616D29207B5C6E5C6E2020636F6E73742073656C66203D20746869733B5C6E5C';
wwv_flow_imp.g_varchar2_table(2092) := '6E202066756E6374696F6E205061727365436F6D706C6574654576656E74286461746129207B5C6E2020202072657475726E2073656C662E67657428276576656E7442757327292E6372656174654576656E742864617461293B5C6E20207D5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(2093) := '206C657420616767726567617465645761726E696E6773203D205B5D3B5C6E2020747279207B5C6E5C6E202020202F2F20686F6F6B20696E207072652D7061727365206C697374656E657273202B5C6E202020202F2F20616C6C6F7720786D6C206D616E';
wwv_flow_imp.g_varchar2_table(2094) := '6970756C6174696F6E5C6E5C6E202020202F2A2A5C6E20202020202A20412060696D706F72742E70617273652E737461727460206576656E742E5C6E20202020202A5C6E20202020202A20406576656E74204261736556696577657223496D706F727450';
wwv_flow_imp.g_varchar2_table(2095) := '6172736553746172744576656E745C6E20202020202A204074797065207B496D706F7274506172736553746172744576656E747D5C6E20202020202A2F5C6E20202020786D6C203D20746869732E5F656D69742827696D706F72742E70617273652E7374';
wwv_flow_imp.g_varchar2_table(2096) := '617274272C207B20786D6C3A20786D6C207D29207C7C20786D6C3B5C6E5C6E202020206C6574207061727365526573756C743B5C6E20202020747279207B5C6E2020202020207061727365526573756C74203D20617761697420746869732E5F6D6F6464';
wwv_flow_imp.g_varchar2_table(2097) := '6C652E66726F6D584D4C28786D6C2C202762706D6E3A446566696E6974696F6E7327293B5C6E202020207D20636174636820286572726F7229207B5C6E202020202020746869732E5F656D69742827696D706F72742E70617273652E636F6D706C657465';
wwv_flow_imp.g_varchar2_table(2098) := '272C207B5C6E20202020202020206572726F725C6E2020202020207D293B5C6E5C6E2020202020207468726F77206572726F723B5C6E202020207D5C6E5C6E202020206C657420646566696E6974696F6E73203D207061727365526573756C742E726F6F';
wwv_flow_imp.g_varchar2_table(2099) := '74456C656D656E743B5C6E20202020636F6E7374207265666572656E636573203D207061727365526573756C742E7265666572656E6365733B5C6E20202020636F6E73742070617273655761726E696E6773203D207061727365526573756C742E776172';
wwv_flow_imp.g_varchar2_table(2100) := '6E696E67733B5C6E20202020636F6E737420656C656D656E747342794964203D207061727365526573756C742E656C656D656E7473427949643B5C6E5C6E20202020616767726567617465645761726E696E6773203D2061676772656761746564576172';
wwv_flow_imp.g_varchar2_table(2101) := '6E696E67732E636F6E6361742870617273655761726E696E6773293B5C6E5C6E202020202F2F20686F6F6B20696E20706F7374207061727365206C697374656E657273202B5C6E202020202F2F20616C6C6F7720646566696E6974696F6E73206D616E69';
wwv_flow_imp.g_varchar2_table(2102) := '70756C6174696F6E5C6E5C6E202020202F2A2A5C6E20202020202A20412060696D706F72742E70617273652E636F6D706C65746560206576656E742E5C6E20202020202A5C6E20202020202A20406576656E74204261736556696577657223496D706F72';
wwv_flow_imp.g_varchar2_table(2103) := '745061727365436F6D706C6574654576656E745C6E20202020202A204074797065207B496D706F72745061727365436F6D706C6574654576656E747D5C6E20202020202A2F5C6E20202020646566696E6974696F6E73203D20746869732E5F656D697428';
wwv_flow_imp.g_varchar2_table(2104) := '27696D706F72742E70617273652E636F6D706C657465272C205061727365436F6D706C6574654576656E74287B5C6E2020202020206572726F723A206E756C6C2C5C6E202020202020646566696E6974696F6E733A20646566696E6974696F6E732C5C6E';
wwv_flow_imp.g_varchar2_table(2105) := '202020202020656C656D656E7473427949643A20656C656D656E7473427949642C5C6E2020202020207265666572656E6365733A207265666572656E6365732C5C6E2020202020207761726E696E67733A20616767726567617465645761726E696E6773';
wwv_flow_imp.g_varchar2_table(2106) := '5C6E202020207D2929207C7C20646566696E6974696F6E733B5C6E5C6E20202020636F6E737420696D706F7274526573756C74203D20617761697420746869732E696D706F7274446566696E6974696F6E7328646566696E6974696F6E732C2062706D6E';
wwv_flow_imp.g_varchar2_table(2107) := '4469616772616D293B5C6E5C6E20202020616767726567617465645761726E696E6773203D20616767726567617465645761726E696E67732E636F6E63617428696D706F7274526573756C742E7761726E696E6773293B5C6E5C6E202020202F2A2A5C6E';
wwv_flow_imp.g_varchar2_table(2108) := '20202020202A20412060696D706F72742E70617273652E636F6D706C65746560206576656E742E5C6E20202020202A5C6E20202020202A20406576656E74204261736556696577657223496D706F7274446F6E654576656E745C6E20202020202A204074';
wwv_flow_imp.g_varchar2_table(2109) := '797065207B496D706F7274446F6E654576656E747D5C6E20202020202A2F5C6E20202020746869732E5F656D69742827696D706F72742E646F6E65272C207B206572726F723A206E756C6C2C207761726E696E67733A2061676772656761746564576172';
wwv_flow_imp.g_varchar2_table(2110) := '6E696E6773207D293B5C6E5C6E2020202072657475726E207B207761726E696E67733A20616767726567617465645761726E696E6773207D3B5C6E20207D206361746368202865727229207B5C6E202020206C6574206572726F72203D206572723B5C6E';
wwv_flow_imp.g_varchar2_table(2111) := '20202020616767726567617465645761726E696E6773203D20616767726567617465645761726E696E67732E636F6E636174286572726F722E7761726E696E6773207C7C205B5D293B5C6E202020206164645761726E696E6773546F4572726F72286572';
wwv_flow_imp.g_varchar2_table(2112) := '726F722C20616767726567617465645761726E696E6773293B5C6E5C6E202020206572726F72203D20636865636B56616C69646174696F6E4572726F72286572726F72293B5C6E5C6E20202020746869732E5F656D69742827696D706F72742E646F6E65';
wwv_flow_imp.g_varchar2_table(2113) := '272C207B206572726F722C207761726E696E67733A206572726F722E7761726E696E6773207D293B5C6E5C6E202020207468726F77206572726F723B5C6E20207D5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A20496D706F72742070617273656420646566';
wwv_flow_imp.g_varchar2_table(2114) := '696E6974696F6E7320616E642072656E64657220612042504D4E20322E30206469616772616D2E5C6E202A5C6E202A204F6E63652066696E69736865642074686520766965776572207265706F727473206261636B2074686520726573756C7420746F20';
wwv_flow_imp.g_varchar2_table(2115) := '7468655C6E202A2070726F76696465642063616C6C6261636B2066756E6374696F6E207769746820286572722C207761726E696E6773292E5C6E202A5C6E202A202323204C6966652D4379636C65204576656E74735C6E202A5C6E202A20447572696E67';
wwv_flow_imp.g_varchar2_table(2116) := '20696D706F727420746865207669657765722077696C6C2066697265206C6966652D6379636C65206576656E74733A5C6E202A5C6E202A2020202A20696D706F72742E72656E6465722E7374617274202867726170686963616C20696D706F7274207374';
wwv_flow_imp.g_varchar2_table(2117) := '617274295C6E202A2020202A20696D706F72742E72656E6465722E636F6D706C657465202867726170686963616C20696D706F72742066696E6973686564295C6E202A5C6E202A20596F752063616E20757365207468657365206576656E747320746F20';
wwv_flow_imp.g_varchar2_table(2118) := '686F6F6B20696E746F20746865206C6966652D6379636C652E5C6E202A5C6E202A20407468726F7773207B496D706F7274446566696E6974696F6E734572726F727D20416E206572726F72207468726F776E20647572696E672074686520696D706F7274';
wwv_flow_imp.g_varchar2_table(2119) := '206F662074686520646566696E6974696F6E732E5C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D20646566696E6974696F6E732054686520646566696E6974696F6E732E5C6E202A2040706172616D207B4D6F64646C6545';
wwv_flow_imp.g_varchar2_table(2120) := '6C656D656E747C737472696E677D205B62706D6E4469616772616D5D20546865206F7074696F6E616C206469616772616D206F72204944206F66207468652042504D4E206469616772616D20746F206F70656E2E5C6E202A5C6E202A204072657475726E';
wwv_flow_imp.g_varchar2_table(2121) := '207B50726F6D6973653C496D706F7274446566696E6974696F6E73526573756C743E7D20412070726F6D697365207265736F6C76696E672077697468207761726E696E6773207468617420776572652070726F647563656420647572696E672074686520';
wwv_flow_imp.g_varchar2_table(2122) := '696D706F72742E5C6E202A2F5C6E426173655669657765722E70726F746F747970652E696D706F7274446566696E6974696F6E73203D206173796E632066756E6374696F6E20696D706F7274446566696E6974696F6E7328646566696E6974696F6E732C';
wwv_flow_imp.g_varchar2_table(2123) := '2062706D6E4469616772616D29207B5C6E2020746869732E5F736574446566696E6974696F6E7328646566696E6974696F6E73293B5C6E2020636F6E737420726573756C74203D20617761697420746869732E6F70656E2862706D6E4469616772616D29';
wwv_flow_imp.g_varchar2_table(2124) := '3B5C6E5C6E202072657475726E207B207761726E696E67733A20726573756C742E7761726E696E6773207D3B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A204F70656E206469616772616D206F662070726576696F75736C7920696D706F7274656420584D';
wwv_flow_imp.g_varchar2_table(2125) := '4C2E5C6E202A5C6E202A204F6E63652066696E69736865642074686520766965776572207265706F727473206261636B2074686520726573756C7420746F207468655C6E202A2070726F76696465642063616C6C6261636B2066756E6374696F6E207769';
wwv_flow_imp.g_varchar2_table(2126) := '746820286572722C207761726E696E6773292E5C6E202A5C6E202A202323204C6966652D4379636C65204576656E74735C6E202A5C6E202A20447572696E672073776974636820746865207669657765722077696C6C2066697265206C6966652D637963';
wwv_flow_imp.g_varchar2_table(2127) := '6C65206576656E74733A5C6E202A5C6E202A2020202A20696D706F72742E72656E6465722E7374617274202867726170686963616C20696D706F7274207374617274295C6E202A2020202A20696D706F72742E72656E6465722E636F6D706C6574652028';
wwv_flow_imp.g_varchar2_table(2128) := '67726170686963616C20696D706F72742066696E6973686564295C6E202A5C6E202A20596F752063616E20757365207468657365206576656E747320746F20686F6F6B20696E746F20746865206C6966652D6379636C652E5C6E202A5C6E202A20407468';
wwv_flow_imp.g_varchar2_table(2129) := '726F7773207B4F70656E4572726F727D20416E206572726F72207468726F776E20647572696E67206F70656E696E672E5C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747C737472696E677D2062706D6E4469616772616D4F72';
wwv_flow_imp.g_varchar2_table(2130) := '496420546865206469616772616D206F72204964206F66207468652042504D4E206469616772616D20746F206F70656E2E5C6E202A5C6E202A204072657475726E207B50726F6D6973653C4F70656E526573756C743E7D20412070726F6D697365207265';
wwv_flow_imp.g_varchar2_table(2131) := '736F6C76696E672077697468207761726E696E6773207468617420776572652070726F647563656420647572696E67206F70656E696E672E5C6E202A2F5C6E426173655669657765722E70726F746F747970652E6F70656E203D206173796E632066756E';
wwv_flow_imp.g_varchar2_table(2132) := '6374696F6E206F70656E2862706D6E4469616772616D4F72496429207B5C6E5C6E2020636F6E737420646566696E6974696F6E73203D20746869732E5F646566696E6974696F6E733B5C6E20206C65742062706D6E4469616772616D203D2062706D6E44';
wwv_flow_imp.g_varchar2_table(2133) := '69616772616D4F7249643B5C6E5C6E20206966202821646566696E6974696F6E7329207B5C6E20202020636F6E7374206572726F72203D206E6577204572726F7228276E6F20584D4C20696D706F7274656427293B5C6E202020206164645761726E696E';
wwv_flow_imp.g_varchar2_table(2134) := '6773546F4572726F72286572726F722C205B5D293B5C6E5C6E202020207468726F77206572726F723B5C6E20207D5C6E5C6E202069662028747970656F662062706D6E4469616772616D4F724964203D3D3D2027737472696E672729207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(2135) := '62706D6E4469616772616D203D2066696E6442504D4E4469616772616D28646566696E6974696F6E732C2062706D6E4469616772616D4F724964293B5C6E5C6E20202020696620282162706D6E4469616772616D29207B5C6E202020202020636F6E7374';
wwv_flow_imp.g_varchar2_table(2136) := '206572726F72203D206E6577204572726F72282742504D4E4469616772616D203C27202B2062706D6E4469616772616D4F724964202B20273E206E6F7420666F756E6427293B5C6E2020202020206164645761726E696E6773546F4572726F7228657272';
wwv_flow_imp.g_varchar2_table(2137) := '6F722C205B5D293B5C6E5C6E2020202020207468726F77206572726F723B5C6E202020207D5C6E20207D5C6E5C6E20202F2F20636C656172206578697374696E672072656E6465726564206469616772616D5C6E20202F2F2063617463682073796E6368';
wwv_flow_imp.g_varchar2_table(2138) := '726F6E6F757320657863657074696F6E7320647572696E672023636C65617228295C6E2020747279207B5C6E20202020746869732E636C65617228293B5C6E20207D20636174636820286572726F7229207B5C6E202020206164645761726E696E677354';
wwv_flow_imp.g_varchar2_table(2139) := '6F4572726F72286572726F722C205B5D293B5C6E5C6E202020207468726F77206572726F723B5C6E20207D5C6E5C6E20202F2F20706572666F726D2067726170686963616C20696D706F72745C6E2020636F6E7374207B207761726E696E6773207D203D';
wwv_flow_imp.g_varchar2_table(2140) := '20617761697420696D706F727442706D6E4469616772616D28746869732C20646566696E6974696F6E732C2062706D6E4469616772616D293B5C6E5C6E202072657475726E207B207761726E696E6773207D3B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2045';
wwv_flow_imp.g_varchar2_table(2141) := '78706F7274207468652063757272656E746C7920646973706C617965642042504D4E20322E30206469616772616D2061735C6E202A20612042504D4E20322E3020584D4C20646F63756D656E742E5C6E202A5C6E202A202323204C6966652D4379636C65';
wwv_flow_imp.g_varchar2_table(2142) := '204576656E74735C6E202A5C6E202A20447572696E6720584D4C20736176696E6720746865207669657765722077696C6C2066697265206C6966652D6379636C65206576656E74733A5C6E202A5C6E202A2020202A2073617665584D4C2E737461727420';
wwv_flow_imp.g_varchar2_table(2143) := '286265666F72652073657269616C697A6174696F6E295C6E202A2020202A2073617665584D4C2E73657269616C697A65642028616674657220786D6C2067656E65726174696F6E295C6E202A2020202A2073617665584D4C2E646F6E6520286576657279';
wwv_flow_imp.g_varchar2_table(2144) := '7468696E6720646F6E65295C6E202A5C6E202A20596F752063616E20757365207468657365206576656E747320746F20686F6F6B20696E746F20746865206C6966652D6379636C652E5C6E202A5C6E202A20407468726F7773207B4572726F727D20416E';
wwv_flow_imp.g_varchar2_table(2145) := '206572726F72207468726F776E20647572696E67206578706F72742E5C6E202A5C6E202A2040666972657320426173655669657765722353617665584D4C53746172745C6E202A2040666972657320426173655669657765722353617665584D4C446F6E';
wwv_flow_imp.g_varchar2_table(2146) := '655C6E202A5C6E202A2040706172616D207B53617665584D4C4F7074696F6E737D205B6F7074696F6E735D20546865206F7074696F6E732E5C6E202A5C6E202A204072657475726E207B50726F6D6973653C53617665584D4C526573756C743E7D204120';
wwv_flow_imp.g_varchar2_table(2147) := '70726F6D697365207265736F6C76696E6720776974682074686520584D4C2E5C6E202A2F5C6E426173655669657765722E70726F746F747970652E73617665584D4C203D206173796E632066756E6374696F6E2073617665584D4C286F7074696F6E7329';
wwv_flow_imp.g_varchar2_table(2148) := '207B5C6E5C6E20206F7074696F6E73203D206F7074696F6E73207C7C207B7D3B5C6E5C6E20206C657420646566696E6974696F6E73203D20746869732E5F646566696E6974696F6E732C5C6E2020202020206572726F722C20786D6C3B5C6E5C6E202074';
wwv_flow_imp.g_varchar2_table(2149) := '7279207B5C6E202020206966202821646566696E6974696F6E7329207B5C6E2020202020207468726F77206E6577204572726F7228276E6F20646566696E6974696F6E73206C6F6164656427293B5C6E202020207D5C6E5C6E202020202F2F20616C6C6F';
wwv_flow_imp.g_varchar2_table(2150) := '7720746F20666964646C652061726F756E64207769746820646566696E6974696F6E735C6E5C6E202020202F2A2A5C6E20202020202A2041206073617665584D4C2E737461727460206576656E742E5C6E20202020202A5C6E20202020202A2040657665';
wwv_flow_imp.g_varchar2_table(2151) := '6E7420426173655669657765722353617665584D4C53746172744576656E745C6E20202020202A204074797065207B53617665584D4C53746172744576656E747D5C6E20202020202A2F5C6E20202020646566696E6974696F6E73203D20746869732E5F';
wwv_flow_imp.g_varchar2_table(2152) := '656D6974282773617665584D4C2E7374617274272C207B5C6E202020202020646566696E6974696F6E735C6E202020207D29207C7C20646566696E6974696F6E733B5C6E5C6E20202020636F6E737420726573756C74203D20617761697420746869732E';
wwv_flow_imp.g_varchar2_table(2153) := '5F6D6F64646C652E746F584D4C28646566696E6974696F6E732C206F7074696F6E73293B5C6E20202020786D6C203D20726573756C742E786D6C3B5C6E5C6E20202020786D6C203D20746869732E5F656D6974282773617665584D4C2E73657269616C69';
wwv_flow_imp.g_varchar2_table(2154) := '7A6564272C207B5C6E202020202020786D6C5C6E202020207D29207C7C20786D6C3B5C6E20207D206361746368202865727229207B5C6E202020206572726F72203D206572723B5C6E20207D5C6E5C6E2020636F6E737420726573756C74203D20657272';
wwv_flow_imp.g_varchar2_table(2155) := '6F72203F207B206572726F72207D203A207B20786D6C207D3B5C6E5C6E20202F2A2A5C6E2020202A2041206073617665584D4C2E646F6E6560206576656E742E5C6E2020202A5C6E2020202A20406576656E742042617365566965776572235361766558';
wwv_flow_imp.g_varchar2_table(2156) := '4D4C446F6E654576656E745C6E2020202A204074797065207B53617665584D4C446F6E654576656E747D5C6E2020202A2F5C6E2020746869732E5F656D6974282773617665584D4C2E646F6E65272C20726573756C74293B5C6E5C6E2020696620286572';
wwv_flow_imp.g_varchar2_table(2157) := '726F7229207B5C6E202020207468726F77206572726F723B5C6E20207D5C6E5C6E202072657475726E20726573756C743B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A204578706F7274207468652063757272656E746C7920646973706C61796564204250';
wwv_flow_imp.g_varchar2_table(2158) := '4D4E20322E30206469616772616D2061735C6E202A20616E2053564720696D6167652E5C6E202A5C6E202A202323204C6966652D4379636C65204576656E74735C6E202A5C6E202A20447572696E672053564720736176696E6720746865207669657765';
wwv_flow_imp.g_varchar2_table(2159) := '722077696C6C2066697265206C6966652D6379636C65206576656E74733A5C6E202A5C6E202A2020202A20736176655356472E737461727420286265666F72652073657269616C697A6174696F6E295C6E202A2020202A20736176655356472E646F6E65';
wwv_flow_imp.g_varchar2_table(2160) := '202865766572797468696E6720646F6E65295C6E202A5C6E202A20596F752063616E20757365207468657365206576656E747320746F20686F6F6B20696E746F20746865206C6966652D6379636C652E5C6E202A5C6E202A20407468726F7773207B4572';
wwv_flow_imp.g_varchar2_table(2161) := '726F727D20416E206572726F72207468726F776E20647572696E67206578706F72742E5C6E202A5C6E202A2040666972657320426173655669657765722353617665535647446F6E655C6E202A5C6E202A204072657475726E207B50726F6D6973653C53';
wwv_flow_imp.g_varchar2_table(2162) := '617665535647526573756C743E7D20412070726F6D697365207265736F6C76696E67207769746820746865205356472E5C6E202A2F5C6E426173655669657765722E70726F746F747970652E73617665535647203D206173796E632066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(2163) := '20736176655356472829207B5C6E2020746869732E5F656D69742827736176655356472E737461727427293B5C6E5C6E20206C6574207376672C206572723B5C6E5C6E2020747279207B5C6E20202020636F6E73742063616E766173203D20746869732E';
wwv_flow_imp.g_varchar2_table(2164) := '676574282763616E76617327293B5C6E5C6E20202020636F6E737420636F6E74656E744E6F6465203D2063616E7661732E6765744163746976654C6179657228292C5C6E20202020202020202020646566734E6F6465203D20646F6D517565727928273A';
wwv_flow_imp.g_varchar2_table(2165) := '73636F7065203E2064656673272C2063616E7661732E5F737667293B5C6E5C6E20202020636F6E737420636F6E74656E7473203D20696E6E657253564728636F6E74656E744E6F6465292C5C6E2020202020202020202064656673203D20646566734E6F';
wwv_flow_imp.g_varchar2_table(2166) := '6465203F20273C646566733E27202B20696E6E657253564728646566734E6F646529202B20273C2F646566733E27203A2027273B5C6E5C6E20202020636F6E73742062626F78203D20636F6E74656E744E6F64652E67657442426F7828293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(2167) := '202020737667203D5C6E202020202020273C3F786D6C2076657273696F6E3D5C22312E305C2220656E636F64696E673D5C227574662D385C223F3E5C5C6E27202B5C6E202020202020273C212D2D206372656174656420776974682062706D6E2D6A7320';
wwv_flow_imp.g_varchar2_table(2168) := '2F20687474703A2F2F62706D6E2E696F202D2D3E5C5C6E27202B5C6E202020202020273C21444F435459504520737667205055424C4943205C222D2F2F5733432F2F4454442053564720312E312F2F454E5C22205C22687474703A2F2F7777772E77332E';
wwv_flow_imp.g_varchar2_table(2169) := '6F72672F47726170686963732F5356472F312E312F4454442F73766731312E6474645C223E5C5C6E27202B5C6E202020202020273C73766720786D6C6E733D5C22687474703A2F2F7777772E77332E6F72672F323030302F7376675C2220786D6C6E733A';
wwv_flow_imp.g_varchar2_table(2170) := '786C696E6B3D5C22687474703A2F2F7777772E77332E6F72672F313939392F786C696E6B5C222027202B5C6E2020202020202777696474683D5C2227202B2062626F782E7769647468202B20275C22206865696768743D5C2227202B2062626F782E6865';
wwv_flow_imp.g_varchar2_table(2171) := '69676874202B20275C222027202B5C6E2020202020202776696577426F783D5C2227202B2062626F782E78202B20272027202B2062626F782E79202B20272027202B2062626F782E7769647468202B20272027202B2062626F782E686569676874202B20';
wwv_flow_imp.g_varchar2_table(2172) := '275C222076657273696F6E3D5C22312E315C223E27202B5C6E20202020202064656673202B20636F6E74656E7473202B5C6E202020202020273C2F7376673E273B5C6E20207D20636174636820286529207B5C6E20202020657272203D20653B5C6E2020';
wwv_flow_imp.g_varchar2_table(2173) := '7D5C6E5C6E20202F2A2A5C6E2020202A20412060736176655356472E646F6E6560206576656E742E5C6E2020202A5C6E2020202A20406576656E7420426173655669657765722353617665535647446F6E654576656E745C6E2020202A20407479706520';
wwv_flow_imp.g_varchar2_table(2174) := '7B53617665535647446F6E654576656E747D5C6E2020202A2F5C6E2020746869732E5F656D69742827736176655356472E646F6E65272C207B5C6E202020206572726F723A206572722C5C6E202020207376673A207376675C6E20207D293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(2175) := '206966202865727229207B5C6E202020207468726F77206572723B5C6E20207D5C6E5C6E202072657475726E207B20737667207D3B5C6E7D3B5C6E5C6E426173655669657765722E70726F746F747970652E5F736574446566696E6974696F6E73203D20';
wwv_flow_imp.g_varchar2_table(2176) := '66756E6374696F6E28646566696E6974696F6E7329207B5C6E2020746869732E5F646566696E6974696F6E73203D20646566696E6974696F6E733B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E206D6F64756C657320746F20696E7374616E74';
wwv_flow_imp.g_varchar2_table(2177) := '6961746520776974682E5C6E202A5C6E202A204072657475726E207B4D6F64756C654465636C61726174696F6E5B5D7D20546865206D6F64756C65732E5C6E202A2F5C6E426173655669657765722E70726F746F747970652E6765744D6F64756C657320';
wwv_flow_imp.g_varchar2_table(2178) := '3D2066756E6374696F6E2829207B5C6E202072657475726E20746869732E5F6D6F64756C65733B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052656D6F766520616C6C20647261776E20656C656D656E74732066726F6D20746865207669657765722E5C6E20';
wwv_flow_imp.g_varchar2_table(2179) := '2A5C6E202A2041667465722063616C6C696E672074686973206D6574686F6420746865207669657765722063616E207374696C6C2062652072657573656420666F72206F70656E696E6720616E6F746865725C6E202A206469616772616D2E5C6E202A2F';
wwv_flow_imp.g_varchar2_table(2180) := '5C6E426173655669657765722E70726F746F747970652E636C656172203D2066756E6374696F6E2829207B5C6E20206966202821746869732E676574446566696E6974696F6E73282929207B5C6E5C6E202020202F2F206E6F206469616772616D20746F';
wwv_flow_imp.g_varchar2_table(2181) := '20636C6561725C6E2020202072657475726E3B5C6E20207D5C6E5C6E20202F2F2072656D6F766520647261776E20656C656D656E74735C6E20204469616772616D2E70726F746F747970652E636C6561722E63616C6C2874686973293B5C6E7D3B5C6E5C';
wwv_flow_imp.g_varchar2_table(2182) := '6E2F2A2A5C6E202A2044657374726F79207468652076696577657220696E7374616E636520616E642072656D6F766520616C6C206974732072656D61696E646572732066726F6D2074686520646F63756D656E745C6E202A20747265652E5C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(2183) := '6E426173655669657765722E70726F746F747970652E64657374726F79203D2066756E6374696F6E2829207B5C6E5C6E20202F2F206469616772616D2064657374726F795C6E20204469616772616D2E70726F746F747970652E64657374726F792E6361';
wwv_flow_imp.g_varchar2_table(2184) := '6C6C2874686973293B5C6E5C6E20202F2F20646F6D206465746163685C6E2020646F6D52656D6F766528746869732E5F636F6E7461696E6572293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20406F7665726C6F72645C6E202A5C6E202A2052656769737465';
wwv_flow_imp.g_varchar2_table(2185) := '7220616E206576656E74206C697374656E657220666F72206576656E747320776974682074686520676976656E206E616D652E5C6E202A5C6E202A205468652063616C6C6261636B2077696C6C20626520696E766F6B6564207769746820606576656E74';
wwv_flow_imp.g_varchar2_table(2186) := '2C202E2E2E6164646974696F6E616C417267756D656E7473605C6E202A20746861742068617665206265656E2070617373656420746F207B406C696E6B204576656E7442757323666972657D2E5C6E202A5C6E202A2052657475726E696E672066616C73';
wwv_flow_imp.g_varchar2_table(2187) := '652066726F6D2061206C697374656E65722077696C6C2070726576656E7420746865206576656E74732064656661756C7420616374696F6E5C6E202A2028696620616E7920697320737065636966696564292E20546F2073746F7020616E206576656E74';
wwv_flow_imp.g_varchar2_table(2188) := '2066726F6D206265696E672070726F636573736564206675727468657220696E5C6E202A206F74686572206C697374656E6572732065786563757465207B406C696E6B204576656E742373746F7050726F7061676174696F6E7D2E5C6E202A5C6E202A20';
wwv_flow_imp.g_varchar2_table(2189) := '52657475726E696E6720616E797468696E67206275742060756E646566696E6564602066726F6D2061206C697374656E65722077696C6C2073746F7020746865206C697374656E65722070726F7061676174696F6E2E5C6E202A5C6E202A204074656D70';
wwv_flow_imp.g_varchar2_table(2190) := '6C61746520545C6E202A5C6E202A2040706172616D207B737472696E677C737472696E675B5D7D206576656E747320546865206576656E7428732920746F206C697374656E20746F2E5C6E202A2040706172616D207B6E756D6265727D205B7072696F72';
wwv_flow_imp.g_varchar2_table(2191) := '6974795D20546865207072696F72697479207769746820776869636820746F206C697374656E2E5C6E202A2040706172616D207B4576656E744275734576656E7443616C6C6261636B3C543E7D2063616C6C6261636B205468652063616C6C6261636B2E';
wwv_flow_imp.g_varchar2_table(2192) := '5C6E202A2040706172616D207B616E797D205B746861745D2056616C7565206F6620607468697360207468652063616C6C6261636B2077696C6C2062652063616C6C656420776974682E5C6E202A2F5C6E2F2A2A5C6E202A20526567697374657220616E';
wwv_flow_imp.g_varchar2_table(2193) := '206576656E74206C697374656E657220666F72206576656E747320776974682074686520676976656E206E616D652E5C6E202A5C6E202A205468652063616C6C6261636B2077696C6C20626520696E766F6B6564207769746820606576656E742C202E2E';
wwv_flow_imp.g_varchar2_table(2194) := '2E6164646974696F6E616C417267756D656E7473605C6E202A20746861742068617665206265656E2070617373656420746F207B406C696E6B204576656E7442757323666972657D2E5C6E202A5C6E202A2052657475726E696E672066616C7365206672';
wwv_flow_imp.g_varchar2_table(2195) := '6F6D2061206C697374656E65722077696C6C2070726576656E7420746865206576656E74732064656661756C7420616374696F6E5C6E202A2028696620616E7920697320737065636966696564292E20546F2073746F7020616E206576656E742066726F';
wwv_flow_imp.g_varchar2_table(2196) := '6D206265696E672070726F636573736564206675727468657220696E5C6E202A206F74686572206C697374656E6572732065786563757465207B406C696E6B204576656E742373746F7050726F7061676174696F6E7D2E5C6E202A5C6E202A2052657475';
wwv_flow_imp.g_varchar2_table(2197) := '726E696E6720616E797468696E67206275742060756E646566696E6564602066726F6D2061206C697374656E65722077696C6C2073746F7020746865206C697374656E65722070726F7061676174696F6E2E5C6E202A5C6E202A204074656D706C617465';
wwv_flow_imp.g_varchar2_table(2198) := '207B6B65796F66204576656E744D61703C536572766963654D61703E7D204576656E744E616D655C6E202A5C6E202A2040706172616D207B4576656E744E616D657D206576656E747320746F2073756273637269626520746F5C6E202A2040706172616D';
wwv_flow_imp.g_varchar2_table(2199) := '207B6E756D6265727D205B7072696F726974793D313030305D206C697374656E207072696F726974795C6E202A2040706172616D207B4576656E744275734576656E7443616C6C6261636B3C284576656E744D61703C536572766963654D61703E295B45';
wwv_flow_imp.g_varchar2_table(2200) := '76656E744E616D655D3E7D2063616C6C6261636B5C6E202A2040706172616D207B616E797D205B746861745D2063616C6C6261636B20636F6E746578745C6E202A2F5C6E426173655669657765722E70726F746F747970652E6F6E203D2066756E637469';
wwv_flow_imp.g_varchar2_table(2201) := '6F6E286576656E74732C207072696F726974792C2063616C6C6261636B2C207468617429207B5C6E202072657475726E20746869732E67657428276576656E7442757327292E6F6E286576656E74732C207072696F726974792C2063616C6C6261636B2C';
wwv_flow_imp.g_varchar2_table(2202) := '2074686174293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052656D6F766520616E206576656E74206C697374656E65722E5C6E202A5C6E202A2040706172616D207B737472696E677C737472696E675B5D7D206576656E747320546865206576656E742873';
wwv_flow_imp.g_varchar2_table(2203) := '292E5C6E202A2040706172616D207B46756E6374696F6E7D205B63616C6C6261636B5D205468652063616C6C6261636B2E5C6E202A2F5C6E426173655669657765722E70726F746F747970652E6F6666203D2066756E6374696F6E286576656E74732C20';
wwv_flow_imp.g_varchar2_table(2204) := '63616C6C6261636B29207B5C6E2020746869732E67657428276576656E7442757327292E6F6666286576656E74732C2063616C6C6261636B293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20417474616368207468652076696577657220746F20616E204854';
wwv_flow_imp.g_varchar2_table(2205) := '4D4C20656C656D656E742E5C6E202A5C6E202A2040706172616D207B48544D4C456C656D656E747D20706172656E744E6F64652054686520706172656E74206E6F646520746F2061747461636820746F2E5C6E202A2F5C6E426173655669657765722E70';
wwv_flow_imp.g_varchar2_table(2206) := '726F746F747970652E617474616368546F203D2066756E6374696F6E28706172656E744E6F646529207B5C6E5C6E20206966202821706172656E744E6F646529207B5C6E202020207468726F77206E6577204572726F722827706172656E744E6F646520';
wwv_flow_imp.g_varchar2_table(2207) := '726571756972656427293B5C6E20207D5C6E5C6E20202F2F20656E73757265207765206465746163682066726F6D207468655C6E20202F2F2070726576696F75732C206F6C6420706172656E745C6E2020746869732E64657461636828293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(2208) := '202F2F20756E77726170206A51756572792069662070726F76696465645C6E202069662028706172656E744E6F64652E67657420262620706172656E744E6F64652E636F6E7374727563746F722E70726F746F747970652E6A717565727929207B5C6E20';
wwv_flow_imp.g_varchar2_table(2209) := '202020706172656E744E6F6465203D20706172656E744E6F64652E6765742830293B5C6E20207D5C6E5C6E202069662028747970656F6620706172656E744E6F6465203D3D3D2027737472696E672729207B5C6E20202020706172656E744E6F6465203D';
wwv_flow_imp.g_varchar2_table(2210) := '20646F6D517565727928706172656E744E6F6465293B5C6E20207D5C6E5C6E2020706172656E744E6F64652E617070656E644368696C6428746869732E5F636F6E7461696E6572293B5C6E5C6E2020746869732E5F656D69742827617474616368272C20';
wwv_flow_imp.g_varchar2_table(2211) := '7B7D293B5C6E5C6E2020746869732E676574282763616E76617327292E726573697A656428293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204765742074686520646566696E6974696F6E73206D6F64656C20656C656D656E742E5C6E202A5C6E202A204072';
wwv_flow_imp.g_varchar2_table(2212) := '657475726E207B4D6F64646C65456C656D656E747D2054686520646566696E6974696F6E73206D6F64656C20656C656D656E742E5C6E202A2F5C6E426173655669657765722E70726F746F747970652E676574446566696E6974696F6E73203D2066756E';
wwv_flow_imp.g_varchar2_table(2213) := '6374696F6E2829207B5C6E202072657475726E20746869732E5F646566696E6974696F6E733B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2044657461636820746865207669657765722E5C6E202A5C6E202A2040666972657320426173655669657765722344';
wwv_flow_imp.g_varchar2_table(2214) := '65746163684576656E745C6E202A2F5C6E426173655669657765722E70726F746F747970652E646574616368203D2066756E6374696F6E2829207B5C6E5C6E2020636F6E737420636F6E7461696E6572203D20746869732E5F636F6E7461696E65722C5C';
wwv_flow_imp.g_varchar2_table(2215) := '6E2020202020202020706172656E744E6F6465203D20636F6E7461696E65722E706172656E744E6F64653B5C6E5C6E20206966202821706172656E744E6F646529207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A';
wwv_flow_imp.g_varchar2_table(2216) := '2041206064657461636860206576656E742E5C6E2020202A5C6E2020202A20406576656E742042617365566965776572234465746163684576656E745C6E2020202A204074797065207B4F626A6563747D5C6E2020202A2F5C6E2020746869732E5F656D';
wwv_flow_imp.g_varchar2_table(2217) := '69742827646574616368272C207B7D293B5C6E5C6E2020706172656E744E6F64652E72656D6F76654368696C6428636F6E7461696E6572293B5C6E7D3B5C6E5C6E426173655669657765722E70726F746F747970652E5F696E6974203D2066756E637469';
wwv_flow_imp.g_varchar2_table(2218) := '6F6E28636F6E7461696E65722C206D6F64646C652C206F7074696F6E7329207B5C6E5C6E2020636F6E737420626173654D6F64756C6573203D206F7074696F6E732E6D6F64756C6573207C7C20746869732E6765744D6F64756C6573286F7074696F6E73';
wwv_flow_imp.g_varchar2_table(2219) := '292C5C6E20202020202020206164646974696F6E616C4D6F64756C6573203D206F7074696F6E732E6164646974696F6E616C4D6F64756C6573207C7C205B5D2C5C6E20202020202020207374617469634D6F64756C6573203D205B5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(2220) := '2020207B5C6E20202020202020202020202062706D6E6A733A205B202776616C7565272C2074686973205D2C5C6E2020202020202020202020206D6F64646C653A205B202776616C7565272C206D6F64646C65205D5C6E202020202020202020207D5C6E';
wwv_flow_imp.g_varchar2_table(2221) := '20202020202020205D3B5C6E5C6E2020636F6E7374206469616772616D4D6F64756C6573203D205B5D2E636F6E636174287374617469634D6F64756C65732C20626173654D6F64756C65732C206164646974696F6E616C4D6F64756C6573293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(2222) := '2020636F6E7374206469616772616D4F7074696F6E73203D2061737369676E286F6D6974286F7074696F6E732C205B20276164646974696F6E616C4D6F64756C657327205D292C207B5C6E2020202063616E7661733A2061737369676E287B7D2C206F70';
wwv_flow_imp.g_varchar2_table(2223) := '74696F6E732E63616E7661732C207B20636F6E7461696E65723A20636F6E7461696E6572207D292C5C6E202020206D6F64756C65733A206469616772616D4D6F64756C65735C6E20207D293B5C6E5C6E20202F2F20696E766F6B65206469616772616D20';
wwv_flow_imp.g_varchar2_table(2224) := '636F6E7374727563746F725C6E20204469616772616D2E63616C6C28746869732C206469616772616D4F7074696F6E73293B5C6E5C6E2020696620286F7074696F6E73202626206F7074696F6E732E636F6E7461696E657229207B5C6E20202020746869';
wwv_flow_imp.g_varchar2_table(2225) := '732E617474616368546F286F7074696F6E732E636F6E7461696E6572293B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A20456D697420616E206576656E74206F6E2074686520756E6465726C79696E67207B406C696E6B204576656E744275737D5C';
wwv_flow_imp.g_varchar2_table(2226) := '6E202A5C6E202A2040706172616D20207B737472696E677D20747970655C6E202A2040706172616D20207B4F626A6563747D206576656E745C6E202A5C6E202A204072657475726E207B4F626A6563747D205468652072657475726E2076616C75652061';
wwv_flow_imp.g_varchar2_table(2227) := '667465722063616C6C696E6720616C6C206576656E74206C697374656E6572732E5C6E202A2F5C6E426173655669657765722E70726F746F747970652E5F656D6974203D2066756E6374696F6E28747970652C206576656E7429207B5C6E202072657475';
wwv_flow_imp.g_varchar2_table(2228) := '726E20746869732E67657428276576656E7442757327292E6669726528747970652C206576656E74293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B426173655669657765724F7074696F6E737D206F7074696F6E735C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(2229) := '204072657475726E207B48544D4C456C656D656E747D5C6E202A2F5C6E426173655669657765722E70726F746F747970652E5F637265617465436F6E7461696E6572203D2066756E6374696F6E286F7074696F6E7329207B5C6E5C6E2020636F6E737420';
wwv_flow_imp.g_varchar2_table(2230) := '636F6E7461696E6572203D20646F6D69667928273C64697620636C6173733D5C22626A732D636F6E7461696E65725C223E3C2F6469763E27293B5C6E5C6E202061737369676E5374796C6528636F6E7461696E65722C207B5C6E2020202077696474683A';
wwv_flow_imp.g_varchar2_table(2231) := '20656E73757265556E6974286F7074696F6E732E7769647468292C5C6E202020206865696768743A20656E73757265556E6974286F7074696F6E732E686569676874292C5C6E20202020706F736974696F6E3A206F7074696F6E732E706F736974696F6E';
wwv_flow_imp.g_varchar2_table(2232) := '5C6E20207D293B5C6E5C6E202072657475726E20636F6E7461696E65723B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B426173655669657765724F7074696F6E737D206F7074696F6E735C6E202A5C6E202A204072657475726E207B4D6F';
wwv_flow_imp.g_varchar2_table(2233) := '64646C657D5C6E202A2F5C6E426173655669657765722E70726F746F747970652E5F6372656174654D6F64646C65203D2066756E6374696F6E286F7074696F6E7329207B5C6E2020636F6E7374206D6F64646C654F7074696F6E73203D2061737369676E';
wwv_flow_imp.g_varchar2_table(2234) := '287B7D2C20746869732E5F6D6F64646C65457874656E73696F6E732C206F7074696F6E732E6D6F64646C65457874656E73696F6E73293B5C6E5C6E202072657475726E206E65772042706D6E4D6F64646C65286D6F64646C654F7074696F6E73293B5C6E';
wwv_flow_imp.g_varchar2_table(2235) := '7D3B5C6E5C6E426173655669657765722E70726F746F747970652E5F6D6F64756C6573203D205B5D3B5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E206164645761726E696E6773546F457272';
wwv_flow_imp.g_varchar2_table(2236) := '6F72286572722C207761726E696E677341727929207B5C6E20206572722E7761726E696E6773203D207761726E696E67734172793B5C6E202072657475726E206572723B5C6E7D5C6E5C6E66756E6374696F6E20636865636B56616C69646174696F6E45';
wwv_flow_imp.g_varchar2_table(2237) := '72726F722865727229207B5C6E5C6E20202F2F20636865636B2069662077652063616E2068656C7020746865207573657220627920696E6469636174696E672077726F6E672042504D4E20322E3020786D6C5C6E20202F2F2028696E2063617365206865';
wwv_flow_imp.g_varchar2_table(2238) := '206F7220746865206578706F7274696E6720746F6F6C20646964206E6F74206765742074686174207269676874295C6E5C6E2020636F6E7374207061747465726E203D202F756E7061727361626C6520636F6E74656E74203C285B5E3E5D2B293E206465';
wwv_flow_imp.g_varchar2_table(2239) := '746563746564285B5C5C735C5C535D2A29242F3B5C6E2020636F6E7374206D61746368203D207061747465726E2E65786563286572722E6D657373616765293B5C6E5C6E2020696620286D6174636829207B5C6E202020206572722E6D65737361676520';
wwv_flow_imp.g_varchar2_table(2240) := '3D5C6E20202020202027756E7061727361626C6520636F6E74656E74203C27202B206D617463685B315D202B20273E2064657465637465643B2027202B5C6E2020202020202774686973206D617920696E64696361746520616E20696E76616C69642042';
wwv_flow_imp.g_varchar2_table(2241) := '504D4E20322E30206469616772616D2066696C6527202B206D617463685B325D3B5C6E20207D5C6E5C6E202072657475726E206572723B5C6E7D5C6E5C6E636F6E73742044454641554C545F4F5054494F4E53203D207B5C6E202077696474683A202731';
wwv_flow_imp.g_varchar2_table(2242) := '303025272C5C6E20206865696768743A202731303025272C5C6E2020706F736974696F6E3A202772656C6174697665275C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A20456E73757265207468652070617373656420617267756D656E742069732061207072';
wwv_flow_imp.g_varchar2_table(2243) := '6F70657220756E6974202864656661756C74696E6720746F207078295C6E202A2F5C6E66756E6374696F6E20656E73757265556E69742876616C29207B5C6E202072657475726E2076616C202B202869734E756D6265722876616C29203F202770782720';
wwv_flow_imp.g_varchar2_table(2244) := '3A202727293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2046696E642042504D4E4469616772616D20696E20646566696E6974696F6E732062792049445C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E743C446566696E6974696F';
wwv_flow_imp.g_varchar2_table(2245) := '6E733E7D20646566696E6974696F6E735C6E202A2040706172616D207B737472696E677D206469616772616D49645C6E202A5C6E202A204072657475726E207B4D6F64646C65456C656D656E743C42504D4E4469616772616D3E7C6E756C6C7D5C6E202A';
wwv_flow_imp.g_varchar2_table(2246) := '2F5C6E66756E6374696F6E2066696E6442504D4E4469616772616D28646566696E6974696F6E732C206469616772616D496429207B5C6E202069662028216469616772616D496429207B5C6E2020202072657475726E206E756C6C3B5C6E20207D5C6E5C';
wwv_flow_imp.g_varchar2_table(2247) := '6E202072657475726E2066696E6428646566696E6974696F6E732E6469616772616D732C2066756E6374696F6E28656C656D656E7429207B5C6E2020202072657475726E20656C656D656E742E6964203D3D3D206469616772616D49643B5C6E20207D29';
wwv_flow_imp.g_varchar2_table(2248) := '207C7C206E756C6C3B5C6E7D5C6E5C6E5C6E2F2A203C70726F6A6563742D6C6F676F3E202A2F5C6E5C6E696D706F7274207B5C6E20206F70656E206173206F70656E506F776572656442792C5C6E202042504D4E494F5F494D472C5C6E20204C4F474F5F';
wwv_flow_imp.g_varchar2_table(2249) := '5354594C45532C5C6E20204C494E4B5F5354594C45535C6E7D2066726F6D20272E2F7574696C2F506F776572656442795574696C273B5C6E5C6E696D706F7274207B5C6E20206576656E7420617320646F6D4576656E745C6E7D2066726F6D20276D696E';
wwv_flow_imp.g_varchar2_table(2250) := '2D646F6D273B5C6E5C6E2F2A2A5C6E202A2041646473207468652070726F6A656374206C6F676F20746F20746865206469616772616D20636F6E7461696E65722061735C6E202A207265717569726564206279207468652062706D6E2E696F206C696365';
wwv_flow_imp.g_varchar2_table(2251) := '6E73652E5C6E202A5C6E202A204073656520687474703A2F2F62706D6E2E696F2F6C6963656E73655C6E202A5C6E202A2040706172616D207B456C656D656E747D20636F6E7461696E65725C6E202A2F5C6E66756E6374696F6E2061646450726F6A6563';
wwv_flow_imp.g_varchar2_table(2252) := '744C6F676F28636F6E7461696E657229207B5C6E2020636F6E737420696D67203D2042504D4E494F5F494D473B5C6E5C6E2020636F6E7374206C696E6B4D61726B7570203D5C6E20202020273C6120687265663D5C22687474703A2F2F62706D6E2E696F';
wwv_flow_imp.g_varchar2_table(2253) := '5C222027202B5C6E20202020277461726765743D5C225F626C616E6B5C222027202B5C6E2020202027636C6173733D5C22626A732D706F77657265642D62795C222027202B5C6E20202020277469746C653D5C22506F77657265642062792062706D6E2E';
wwv_flow_imp.g_varchar2_table(2254) := '696F5C222027202B5C6E20202020273E27202B5C6E20202020696D67202B5C6E20202020273C2F613E273B5C6E5C6E2020636F6E7374206C696E6B456C656D656E74203D20646F6D696679286C696E6B4D61726B7570293B5C6E5C6E202061737369676E';
wwv_flow_imp.g_varchar2_table(2255) := '5374796C6528646F6D51756572792827737667272C206C696E6B456C656D656E74292C204C4F474F5F5354594C4553293B5C6E202061737369676E5374796C65286C696E6B456C656D656E742C204C494E4B5F5354594C45532C207B5C6E20202020706F';
wwv_flow_imp.g_varchar2_table(2256) := '736974696F6E3A20276162736F6C757465272C5C6E20202020626F74746F6D3A202731357078272C5C6E2020202072696768743A202731357078272C5C6E202020207A496E6465783A2027313030275C6E20207D293B5C6E5C6E2020636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(2257) := '722E617070656E644368696C64286C696E6B456C656D656E74293B5C6E5C6E2020646F6D4576656E742E62696E64286C696E6B456C656D656E742C2027636C69636B272C2066756E6374696F6E286576656E7429207B5C6E202020206F70656E506F7765';
wwv_flow_imp.g_varchar2_table(2258) := '726564427928293B5C6E5C6E202020206576656E742E70726576656E7444656661756C7428293B5C6E20207D293B5C6E7D5C6E5C6E2F2A203C2F70726F6A6563742D6C6F676F3E202A2F5C6E222C22696D706F727420696E6865726974732066726F6D20';
wwv_flow_imp.g_varchar2_table(2259) := '27696E6865726974732D62726F77736572273B5C6E5C6E696D706F727420436F72654D6F64756C652066726F6D20272E2F636F7265273B5C6E696D706F7274204472696C6C646F776E4D6F6464756C652066726F6D20272E2F66656174757265732F6472';
wwv_flow_imp.g_varchar2_table(2260) := '696C6C646F776E273B5C6E696D706F7274204F75746C696E654D6F64756C652066726F6D20272E2F66656174757265732F6F75746C696E65273B5C6E696D706F7274204F7665726C6179734D6F64756C652066726F6D20276469616772616D2D6A732F6C';
wwv_flow_imp.g_varchar2_table(2261) := '69622F66656174757265732F6F7665726C617973273B5C6E696D706F72742053656C656374696F6E4D6F64756C652066726F6D20276469616772616D2D6A732F6C69622F66656174757265732F73656C656374696F6E273B5C6E696D706F727420547261';
wwv_flow_imp.g_varchar2_table(2262) := '6E736C6174654D6F64756C652066726F6D20276469616772616D2D6A732F6C69622F6931386E2F7472616E736C617465273B5C6E5C6E696D706F727420426173655669657765722066726F6D20272E2F42617365566965776572273B5C6E5C6E5C6E2F2A';
wwv_flow_imp.g_varchar2_table(2263) := '2A5C6E202A204074797065646566207B20696D706F727428272E2F4261736556696577657227292E426173655669657765724F7074696F6E73207D20426173655669657765724F7074696F6E735C6E202A2F5C6E5C6E2F2A2A5C6E202A20412076696577';
wwv_flow_imp.g_varchar2_table(2264) := '657220666F722042504D4E20322E30206469616772616D732E5C6E202A5C6E202A20486176652061206C6F6F6B206174207B406C696E6B2062706D6E2D6A732F6C69622F4E61766967617465645669657765727D206F72207B406C696E6B2062706D6E2D';
wwv_flow_imp.g_varchar2_table(2265) := '6A732F6C69622F4D6F64656C65727D20666F722062756E646C6573207468617420696E636C7564655C6E202A206164646974696F6E616C2066656174757265732E5C6E202A5C6E202A5C6E202A20232320457874656E64696E6720746865205669657765';
wwv_flow_imp.g_varchar2_table(2266) := '725C6E202A5C6E202A20496E206F7264657220746F20657874656E642074686520766965776572207061737320657874656E73696F6E206D6F64756C657320746F20626F6F74737472617020766961207468655C6E202A20606164646974696F6E616C4D';
wwv_flow_imp.g_varchar2_table(2267) := '6F64756C657360206F7074696F6E2E20416E20657874656E73696F6E206D6F64756C6520697320616E206F626A6563742074686174206578706F7365735C6E202A206E616D65642073657276696365732E5C6E202A5C6E202A2054686520666F6C6C6F77';
wwv_flow_imp.g_varchar2_table(2268) := '696E67206578616D706C6520646570696374732074686520696E746567726174696F6E206F6620612073696D706C655C6E202A206C6F6767696E6720636F6D706F6E656E74207468617420696E7465677261746573207769746820696E74657261637469';
wwv_flow_imp.g_varchar2_table(2269) := '6F6E206576656E74733A5C6E202A5C6E202A5C6E202A206060606A6176617363726970745C6E202A5C6E202A202F2F206C6F6767696E6720636F6D706F6E656E745C6E202A2066756E6374696F6E20496E746572616374696F6E4C6F6767657228657665';
wwv_flow_imp.g_varchar2_table(2270) := '6E7442757329207B5C6E202A2020206576656E744275732E6F6E2827656C656D656E742E686F766572272C2066756E6374696F6E286576656E7429207B5C6E202A2020202020636F6E736F6C652E6C6F6728295C6E202A2020207D295C6E202A207D5C6E';
wwv_flow_imp.g_varchar2_table(2271) := '202A5C6E202A20496E746572616374696F6E4C6F676765722E24696E6A656374203D205B20276576656E7442757327205D3B202F2F206D696E696669636174696F6E20736176655C6E202A5C6E202A202F2F20657874656E73696F6E206D6F64756C655C';
wwv_flow_imp.g_varchar2_table(2272) := '6E202A2076617220657874656E73696F6E4D6F64756C65203D207B5C6E202A2020205F5F696E69745F5F3A205B2027696E746572616374696F6E4C6F6767657227205D2C5C6E202A202020696E746572616374696F6E4C6F676765723A205B2027747970';
wwv_flow_imp.g_varchar2_table(2273) := '65272C20496E746572616374696F6E4C6F67676572205D5C6E202A207D3B5C6E202A5C6E202A202F2F20657874656E6420746865207669657765725C6E202A207661722062706D6E566965776572203D206E657720566965776572287B20616464697469';
wwv_flow_imp.g_varchar2_table(2274) := '6F6E616C4D6F64756C65733A205B20657874656E73696F6E4D6F64756C65205D207D293B5C6E202A2062706D6E5669657765722E696D706F7274584D4C282E2E2E293B5C6E202A206060605C6E202A5C6E202A204074656D706C617465205B5365727669';
wwv_flow_imp.g_varchar2_table(2275) := '63654D61703D6E756C6C5D5C6E202A5C6E202A2040657874656E647320426173655669657765723C536572766963654D61703E5C6E202A5C6E202A2040706172616D207B426173655669657765724F7074696F6E737D205B6F7074696F6E735D20546865';
wwv_flow_imp.g_varchar2_table(2276) := '206F7074696F6E7320746F20636F6E66696775726520746865207669657765722E5C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E20566965776572286F7074696F6E7329207B5C6E2020426173655669657765722E63616C6C';
wwv_flow_imp.g_varchar2_table(2277) := '28746869732C206F7074696F6E73293B5C6E7D5C6E5C6E696E686572697473285669657765722C2042617365566965776572293B5C6E5C6E2F2F206D6F64756C6573207468652076696577657220697320636F6D706F736564206F665C6E566965776572';
wwv_flow_imp.g_varchar2_table(2278) := '2E70726F746F747970652E5F6D6F64756C6573203D205B5C6E2020436F72654D6F64756C652C5C6E20204472696C6C646F776E4D6F6464756C652C5C6E20204F75746C696E654D6F64756C652C5C6E20204F7665726C6179734D6F64756C652C5C6E2020';
wwv_flow_imp.g_varchar2_table(2279) := '53656C656374696F6E4D6F64756C652C5C6E20205472616E736C6174654D6F64756C655C6E5D3B5C6E5C6E2F2F2064656661756C74206D6F64646C6520657874656E73696F6E73207468652076696577657220697320636F6D706F736564206F665C6E56';
wwv_flow_imp.g_varchar2_table(2280) := '69657765722E70726F746F747970652E5F6D6F64646C65457874656E73696F6E73203D207B7D3B222C22696D706F727420447261774D6F64756C652066726F6D20272E2E2F64726177273B5C6E696D706F727420496D706F72744D6F64756C652066726F';
wwv_flow_imp.g_varchar2_table(2281) := '6D20272E2E2F696D706F7274273B5C6E5C6E6578706F72742064656661756C74207B5C6E20205F5F646570656E64735F5F3A205B5C6E20202020447261774D6F64756C652C5C6E20202020496D706F72744D6F64756C655C6E20205D5C6E7D3B222C2269';
wwv_flow_imp.g_varchar2_table(2282) := '6D706F7274207B5C6E20206861732C5C6E2020736F6D655C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E202067657444695C6E7D2066726F6D20272E2E2F7574696C2F4D6F64656C5574696C273B5C6E5C6E696D70';
wwv_flow_imp.g_varchar2_table(2283) := '6F7274207B5C6E2020636F6D706F6E656E7473546F506174685C6E7D2066726F6D20276469616772616D2D6A732F6C69622F7574696C2F52656E6465725574696C273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E';
wwv_flow_imp.g_varchar2_table(2284) := '2E2F6D6F64656C27292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E745C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C27292E456C656D656E747D20456C656D656E745C6E202A5C6E202A20407479';
wwv_flow_imp.g_varchar2_table(2285) := '7065646566207B696D706F727428272E2E2F6D6F64656C27292E53686170654C696B657D2053686170654C696B655C6E202A5C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F7574696C2F54797065732729';
wwv_flow_imp.g_varchar2_table(2286) := '2E44696D656E73696F6E737D2044696D656E73696F6E735C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F7574696C2F547970657327292E526563747D20526563745C6E202A2F5C6E5C6E2F2F2072652D65';
wwv_flow_imp.g_varchar2_table(2287) := '78706F727420666F7220636F6D7061746962696C6974795C6E6578706F7274207B5C6E202067657444692C5C6E2020676574427573696E6573734F626A6563742061732067657453656D616E7469635C6E7D2066726F6D20272E2E2F7574696C2F4D6F64';
wwv_flow_imp.g_varchar2_table(2288) := '656C5574696C273B5C6E5C6E5C6E6578706F72742076617220626C61636B203D202768736C283232352C203130252C2031352529273B5C6E6578706F727420766172207768697465203D20277768697465273B5C6E5C6E2F2F20656C656D656E74207574';
wwv_flow_imp.g_varchar2_table(2289) := '696C73202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E2F2A2A5C6E202A20436865636B73206966206576656E74446566696E6974696F6E206F662074686520676976656E20656C656D656E74206D6174636865732077697468207365';
wwv_flow_imp.g_varchar2_table(2290) := '6D616E74696320747970652E5C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D206576656E745C6E202A2040706172616D207B737472696E677D206576656E74446566696E6974696F6E547970655C6E202A5C6E202A204072';
wwv_flow_imp.g_varchar2_table(2291) := '657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E20697354797065644576656E74286576656E742C206576656E74446566696E6974696F6E5479706529207B5C6E202072657475726E20736F6D65286576656E';
wwv_flow_imp.g_varchar2_table(2292) := '742E6576656E74446566696E6974696F6E732C2066756E6374696F6E28646566696E6974696F6E29207B5C6E2020202072657475726E20646566696E6974696F6E2E2474797065203D3D3D206576656E74446566696E6974696F6E547970653B5C6E2020';
wwv_flow_imp.g_varchar2_table(2293) := '7D293B5C6E7D5C6E5C6E2F2A2A5C6E202A20436865636B20696620656C656D656E742069732061207468726F77206576656E742E5C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D206576656E745C6E202A5C6E202A204072';
wwv_flow_imp.g_varchar2_table(2294) := '657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E2069735468726F774576656E74286576656E7429207B5C6E202072657475726E20286576656E742E2474797065203D3D3D202762706D6E3A496E7465726D65';
wwv_flow_imp.g_varchar2_table(2295) := '64696174655468726F774576656E742729207C7C20286576656E742E2474797065203D3D3D202762706D6E3A456E644576656E7427293B5C6E7D5C6E5C6E2F2A2A5C6E202A20436865636B20696620656C656D656E742069732061207468726F77206576';
wwv_flow_imp.g_varchar2_table(2296) := '656E742E5C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E206973436F6C6C6563';
wwv_flow_imp.g_varchar2_table(2297) := '74696F6E28656C656D656E7429207B5C6E202076617220646174614F626A656374203D20656C656D656E742E646174614F626A6563745265663B5C6E5C6E202072657475726E20656C656D656E742E6973436F6C6C656374696F6E207C7C202864617461';
wwv_flow_imp.g_varchar2_table(2298) := '4F626A65637420262620646174614F626A6563742E6973436F6C6C656374696F6E293B5C6E7D5C6E5C6E5C6E2F2F20636F6C6F7220616363657373202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E2F2A2A5C6E202A2040706172616D';
wwv_flow_imp.g_varchar2_table(2299) := '207B456C656D656E747D20656C656D656E745C6E202A2040706172616D207B737472696E677D205B64656661756C74436F6C6F725D5C6E202A2040706172616D207B737472696E677D205B6F76657272696465436F6C6F725D5C6E202A5C6E202A204072';
wwv_flow_imp.g_varchar2_table(2300) := '657475726E207B737472696E677D5C6E202A2F5C6E6578706F72742066756E6374696F6E2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C74436F6C6F722C206F76657272696465436F6C6F7229207B5C6E202076617220646920';
wwv_flow_imp.g_varchar2_table(2301) := '3D20676574446928656C656D656E74293B5C6E5C6E202072657475726E206F76657272696465436F6C6F72207C7C2064692E6765742827636F6C6F723A6261636B67726F756E642D636F6C6F722729207C7C2064692E676574282762696F633A66696C6C';
wwv_flow_imp.g_varchar2_table(2302) := '2729207C7C2064656661756C74436F6C6F72207C7C2077686974653B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A2040706172616D207B737472696E677D205B64656661756C74436F6C6F';
wwv_flow_imp.g_varchar2_table(2303) := '725D5C6E202A2040706172616D207B737472696E677D205B6F76657272696465436F6C6F725D5C6E202A5C6E202A204072657475726E207B737472696E677D5C6E202A2F5C6E6578706F72742066756E6374696F6E206765745374726F6B65436F6C6F72';
wwv_flow_imp.g_varchar2_table(2304) := '28656C656D656E742C2064656661756C74436F6C6F722C206F76657272696465436F6C6F7229207B5C6E2020766172206469203D20676574446928656C656D656E74293B5C6E5C6E202072657475726E206F76657272696465436F6C6F72207C7C206469';
wwv_flow_imp.g_varchar2_table(2305) := '2E6765742827636F6C6F723A626F726465722D636F6C6F722729207C7C2064692E676574282762696F633A7374726F6B652729207C7C2064656661756C74436F6C6F72207C7C20626C61636B3B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(2306) := '456C656D656E747D20656C656D656E745C6E202A2040706172616D207B737472696E677D205B64656661756C74436F6C6F725D5C6E202A2040706172616D207B737472696E677D205B64656661756C745374726F6B65436F6C6F725D5C6E202A20407061';
wwv_flow_imp.g_varchar2_table(2307) := '72616D207B737472696E677D205B6F76657272696465436F6C6F725D5C6E202A5C6E202A204072657475726E207B737472696E677D5C6E202A2F5C6E6578706F72742066756E6374696F6E206765744C6162656C436F6C6F7228656C656D656E742C2064';
wwv_flow_imp.g_varchar2_table(2308) := '656661756C74436F6C6F722C2064656661756C745374726F6B65436F6C6F722C206F76657272696465436F6C6F7229207B5C6E2020766172206469203D20676574446928656C656D656E74292C5C6E2020202020206C6162656C203D2064692E67657428';
wwv_flow_imp.g_varchar2_table(2309) := '276C6162656C27293B5C6E5C6E202072657475726E206F76657272696465436F6C6F72207C7C20286C6162656C202626206C6162656C2E6765742827636F6C6F723A636F6C6F72272929207C7C2064656661756C74436F6C6F72207C7C5C6E2020202067';
wwv_flow_imp.g_varchar2_table(2310) := '65745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F72293B5C6E7D5C6E5C6E2F2F2063726F7070696E67207061746820637573746F6D697A6174696F6E73202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F';
wwv_flow_imp.g_varchar2_table(2311) := '2F2F2F2F5C6E5C6E2F2A2A5C6E202A2040706172616D207B53686170654C696B657D2073686170655C6E202A5C6E202A204072657475726E207B737472696E677D20706174685C6E202A2F5C6E6578706F72742066756E6374696F6E2067657443697263';
wwv_flow_imp.g_varchar2_table(2312) := '6C655061746828736861706529207B5C6E5C6E2020766172206378203D2073686170652E78202B2073686170652E7769647468202F20322C5C6E2020202020206379203D2073686170652E79202B2073686170652E686569676874202F20322C5C6E2020';
wwv_flow_imp.g_varchar2_table(2313) := '20202020726164697573203D2073686170652E7769647468202F20323B5C6E5C6E202076617220636972636C6550617468203D205B5C6E202020205B20274D272C2063782C206379205D2C5C6E202020205B20276D272C20302C202D726164697573205D';
wwv_flow_imp.g_varchar2_table(2314) := '2C5C6E202020205B202761272C207261646975732C207261646975732C20302C20312C20312C20302C2032202A20726164697573205D2C5C6E202020205B202761272C207261646975732C207261646975732C20302C20312C20312C20302C202D32202A';
wwv_flow_imp.g_varchar2_table(2315) := '20726164697573205D2C5C6E202020205B20277A27205D5C6E20205D3B5C6E5C6E202072657475726E20636F6D706F6E656E7473546F5061746828636972636C6550617468293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B53686170654C';
wwv_flow_imp.g_varchar2_table(2316) := '696B657D2073686170655C6E202A2040706172616D207B6E756D6265727D205B626F726465725261646975735D5C6E202A5C6E202A204072657475726E207B737472696E677D20706174685C6E202A2F5C6E6578706F72742066756E6374696F6E206765';
wwv_flow_imp.g_varchar2_table(2317) := '74526F756E6452656374506174682873686170652C20626F7264657252616469757329207B5C6E5C6E20207661722078203D2073686170652E782C5C6E20202020202079203D2073686170652E792C5C6E2020202020207769647468203D207368617065';
wwv_flow_imp.g_varchar2_table(2318) := '2E77696474682C5C6E202020202020686569676874203D2073686170652E6865696768743B5C6E5C6E202076617220726F756E645265637450617468203D205B5C6E202020205B20274D272C2078202B20626F726465725261646975732C2079205D2C5C';
wwv_flow_imp.g_varchar2_table(2319) := '6E202020205B20276C272C207769647468202D20626F72646572526164697573202A20322C2030205D2C5C6E202020205B202761272C20626F726465725261646975732C20626F726465725261646975732C20302C20302C20312C20626F726465725261';
wwv_flow_imp.g_varchar2_table(2320) := '646975732C20626F72646572526164697573205D2C5C6E202020205B20276C272C20302C20686569676874202D20626F72646572526164697573202A2032205D2C5C6E202020205B202761272C20626F726465725261646975732C20626F726465725261';
wwv_flow_imp.g_varchar2_table(2321) := '646975732C20302C20302C20312C202D626F726465725261646975732C20626F72646572526164697573205D2C5C6E202020205B20276C272C20626F72646572526164697573202A2032202D2077696474682C2030205D2C5C6E202020205B202761272C';
wwv_flow_imp.g_varchar2_table(2322) := '20626F726465725261646975732C20626F726465725261646975732C20302C20302C20312C202D626F726465725261646975732C202D626F72646572526164697573205D2C5C6E202020205B20276C272C20302C20626F72646572526164697573202A20';
wwv_flow_imp.g_varchar2_table(2323) := '32202D20686569676874205D2C5C6E202020205B202761272C20626F726465725261646975732C20626F726465725261646975732C20302C20302C20312C20626F726465725261646975732C202D626F72646572526164697573205D2C5C6E202020205B';
wwv_flow_imp.g_varchar2_table(2324) := '20277A27205D5C6E20205D3B5C6E5C6E202072657475726E20636F6D706F6E656E7473546F5061746828726F756E645265637450617468293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B53686170654C696B657D2073686170655C6E202A';
wwv_flow_imp.g_varchar2_table(2325) := '5C6E202A204072657475726E207B737472696E677D20706174685C6E202A2F5C6E6578706F72742066756E6374696F6E206765744469616D6F6E645061746828736861706529207B5C6E5C6E2020766172207769647468203D2073686170652E77696474';
wwv_flow_imp.g_varchar2_table(2326) := '682C5C6E202020202020686569676874203D2073686170652E6865696768742C5C6E20202020202078203D2073686170652E782C5C6E20202020202079203D2073686170652E792C5C6E20202020202068616C665769647468203D207769647468202F20';
wwv_flow_imp.g_varchar2_table(2327) := '322C5C6E20202020202068616C66486569676874203D20686569676874202F20323B5C6E5C6E2020766172206469616D6F6E6450617468203D205B5C6E202020205B20274D272C2078202B2068616C6657696474682C2079205D2C5C6E202020205B2027';
wwv_flow_imp.g_varchar2_table(2328) := '6C272C2068616C6657696474682C2068616C66486569676874205D2C5C6E202020205B20276C272C202D68616C6657696474682C2068616C66486569676874205D2C5C6E202020205B20276C272C202D68616C6657696474682C202D68616C6648656967';
wwv_flow_imp.g_varchar2_table(2329) := '6874205D2C5C6E202020205B20277A27205D5C6E20205D3B5C6E5C6E202072657475726E20636F6D706F6E656E7473546F50617468286469616D6F6E6450617468293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B53686170654C696B657D';
wwv_flow_imp.g_varchar2_table(2330) := '2073686170655C6E202A5C6E202A204072657475726E207B737472696E677D20706174685C6E202A2F5C6E6578706F72742066756E6374696F6E20676574526563745061746828736861706529207B5C6E20207661722078203D2073686170652E782C5C';
wwv_flow_imp.g_varchar2_table(2331) := '6E20202020202079203D2073686170652E792C5C6E2020202020207769647468203D2073686170652E77696474682C5C6E202020202020686569676874203D2073686170652E6865696768743B5C6E5C6E2020766172207265637450617468203D205B5C';
wwv_flow_imp.g_varchar2_table(2332) := '6E202020205B20274D272C20782C2079205D2C5C6E202020205B20276C272C2077696474682C2030205D2C5C6E202020205B20276C272C20302C20686569676874205D2C5C6E202020205B20276C272C202D77696474682C2030205D2C5C6E202020205B';
wwv_flow_imp.g_varchar2_table(2333) := '20277A27205D5C6E20205D3B5C6E5C6E202072657475726E20636F6D706F6E656E7473546F50617468287265637450617468293B5C6E7D5C6E5C6E2F2A2A5C6E202A2047657420776964746820616E64206865696768742066726F6D20656C656D656E74';
wwv_flow_imp.g_varchar2_table(2334) := '206F72206F76657272696465732E5C6E202A5C6E202A2040706172616D207B44696D656E73696F6E737C526563747C53686170654C696B657D20626F756E64735C6E202A2040706172616D207B4F626A6563747D206F76657272696465735C6E202A5C6E';
wwv_flow_imp.g_varchar2_table(2335) := '202A204072657475726E73207B44696D656E73696F6E737D5C6E202A2F5C6E6578706F72742066756E6374696F6E20676574426F756E647328626F756E64732C206F7665727269646573203D207B7D29207B5C6E202072657475726E207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(2336) := '77696474683A20676574576964746828626F756E64732C206F7665727269646573292C5C6E202020206865696768743A2067657448656967687428626F756E64732C206F7665727269646573295C6E20207D3B5C6E7D5C6E5C6E2F2A2A5C6E202A204765';
wwv_flow_imp.g_varchar2_table(2337) := '742077696474682066726F6D20656C656D656E74206F72206F76657272696465732E5C6E202A5C6E202A2040706172616D207B44696D656E73696F6E737C526563747C53686170654C696B657D20626F756E64735C6E202A2040706172616D207B4F626A';
wwv_flow_imp.g_varchar2_table(2338) := '6563747D206F76657272696465735C6E202A5C6E202A204072657475726E73207B6E756D6265727D5C6E202A2F5C6E6578706F72742066756E6374696F6E20676574576964746828626F756E64732C206F7665727269646573203D207B7D29207B5C6E20';
wwv_flow_imp.g_varchar2_table(2339) := '2072657475726E20686173286F76657272696465732C202777696474682729203F206F76657272696465732E7769647468203A20626F756E64732E77696474683B5C6E7D5C6E5C6E2F2A2A5C6E202A20476574206865696768742066726F6D20656C656D';
wwv_flow_imp.g_varchar2_table(2340) := '656E74206F72206F76657272696465732E5C6E202A5C6E202A2040706172616D207B44696D656E73696F6E737C526563747C53686170654C696B657D20626F756E64735C6E202A2040706172616D207B4F626A6563747D206F76657272696465735C6E20';
wwv_flow_imp.g_varchar2_table(2341) := '2A5C6E202A204072657475726E73207B6E756D6265727D5C6E202A2F5C6E6578706F72742066756E6374696F6E2067657448656967687428626F756E64732C206F7665727269646573203D207B7D29207B5C6E202072657475726E20686173286F766572';
wwv_flow_imp.g_varchar2_table(2342) := '72696465732C20276865696768742729203F206F76657272696465732E686569676874203A20626F756E64732E6865696768743B5C6E7D222C22696D706F727420696E6865726974732066726F6D2027696E6865726974732D62726F77736572273B5C6E';
wwv_flow_imp.g_varchar2_table(2343) := '5C6E696D706F7274207B5C6E202061737369676E2C5C6E2020666F72456163682C5C6E202069734F626A6563745C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274204261736552656E64657265722066726F6D20276469616772';
wwv_flow_imp.g_varchar2_table(2344) := '616D2D6A732F6C69622F647261772F4261736552656E6465726572273B5C6E5C6E696D706F7274207B5C6E20206973457870616E6465642C5C6E20206973486F72697A6F6E74616C2C5C6E202069734576656E7453756250726F636573735C6E7D206672';
wwv_flow_imp.g_varchar2_table(2345) := '6F6D20272E2E2F7574696C2F44695574696C273B5C6E5C6E696D706F7274207B5C6E20206765744C6162656C5C6E7D2066726F6D20272E2E2F7574696C2F4C6162656C5574696C273B5C6E5C6E696D706F7274207B5C6E202069735C6E7D2066726F6D20';
wwv_flow_imp.g_varchar2_table(2346) := '272E2E2F7574696C2F4D6F64656C5574696C273B5C6E5C6E696D706F7274207B5C6E20206372656174654C696E655C6E7D2066726F6D20276469616772616D2D6A732F6C69622F7574696C2F52656E6465725574696C273B5C6E5C6E696D706F7274207B';
wwv_flow_imp.g_varchar2_table(2347) := '5C6E2020697354797065644576656E742C5C6E202069735468726F774576656E742C5C6E20206973436F6C6C656374696F6E2C5C6E2020676574426F756E64732C5C6E202067657444692C5C6E202067657453656D616E7469632C5C6E20206765744369';
wwv_flow_imp.g_varchar2_table(2348) := '72636C65506174682C5C6E2020676574526F756E6452656374506174682C5C6E20206765744469616D6F6E64506174682C5C6E202067657452656374506174682C5C6E202067657446696C6C436F6C6F722C5C6E20206765745374726F6B65436F6C6F72';
wwv_flow_imp.g_varchar2_table(2349) := '2C5C6E20206765744C6162656C436F6C6F722C5C6E20206765744865696768742C5C6E202067657457696474685C6E7D2066726F6D20272E2F42706D6E52656E6465725574696C273B5C6E5C6E696D706F7274207B5C6E2020717565727920617320646F';
wwv_flow_imp.g_varchar2_table(2350) := '6D51756572795C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E696D706F7274207B5C6E2020617070656E6420617320737667417070656E642C5C6E20206174747220617320737667417474722C5C6E2020637265617465206173207376674372';
wwv_flow_imp.g_varchar2_table(2351) := '656174652C5C6E2020636C617373657320617320737667436C61737365735C6E7D2066726F6D202774696E792D737667273B5C6E5C6E696D706F7274207B5C6E2020726F746174652C5C6E20207472616E73666F726D2C5C6E20207472616E736C617465';
wwv_flow_imp.g_varchar2_table(2352) := '5C6E7D2066726F6D20276469616772616D2D6A732F6C69622F7574696C2F5376675472616E73666F726D5574696C273B5C6E5C6E696D706F7274204964732066726F6D2027696473273B5C6E5C6E696D706F7274207B20626C61636B207D2066726F6D20';
wwv_flow_imp.g_varchar2_table(2353) := '272E2F42706D6E52656E6465725574696C273B5C6E5C6E766172206D61726B6572496473203D206E65772049647328293B5C6E5C6E76617220454C454D454E545F4C4142454C5F44495354414E4345203D2031302C5C6E20202020494E4E45525F4F5554';
wwv_flow_imp.g_varchar2_table(2354) := '45525F44495354203D20332C5C6E202020205041525449434950414E545F5354524F4B455F5749445448203D20312E352C5C6E202020205441534B5F424F524445525F524144495553203D2031303B5C6E5C6E7661722044454641554C545F4F50414349';
wwv_flow_imp.g_varchar2_table(2355) := '5459203D20302E39352C5C6E2020202046554C4C5F4F504143495459203D20312C5C6E202020204C4F575F4F504143495459203D20302E32353B5C6E5C6E2F2A2A5C6E202A204074797065646566207B205061727469616C3C7B5C6E202A202020646566';
wwv_flow_imp.g_varchar2_table(2356) := '61756C7446696C6C436F6C6F723A20737472696E672C5C6E202A20202064656661756C745374726F6B65436F6C6F723A20737472696E672C5C6E202A20202064656661756C744C6162656C436F6C6F723A20737472696E675C6E202A207D3E207D204270';
wwv_flow_imp.g_varchar2_table(2357) := '6D6E52656E6465726572436F6E6669675C6E202A5C6E202A204074797065646566207B205061727469616C3C7B5C6E202A20202066696C6C3A20737472696E672C5C6E202A2020207374726F6B653A20737472696E672C5C6E202A20202077696474683A';
wwv_flow_imp.g_varchar2_table(2358) := '20737472696E672C5C6E202A2020206865696768743A20737472696E675C6E202A207D3E207D2041747472735C6E202A2F5C6E5C6E2F2A2A5C6E202A204074797065646566207B20696D706F727428272E2E2F6D6F64656C2F547970657327292E456C65';
wwv_flow_imp.g_varchar2_table(2359) := '6D656E74207D20456C656D656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A20412072656E646572657220666F722042504D4E20656C656D656E74735C6E202A5C6E202A2040706172616D207B42706D6E52656E6465726572436F6E6669677D20636F6E66';
wwv_flow_imp.g_varchar2_table(2360) := '69675C6E202A2040706172616D207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C747D206576656E744275735C6E202A2040706172616D207B696D706F727428276469616772616D2D';
wwv_flow_imp.g_varchar2_table(2361) := '6A732F6C69622F647261772F5374796C657327292E64656661756C747D207374796C65735C6E202A2040706172616D207B696D706F727428272E2F506174684D617027292E64656661756C747D20706174684D61705C6E202A2040706172616D207B696D';
wwv_flow_imp.g_varchar2_table(2362) := '706F727428276469616772616D2D6A732F6C69622F636F72652F43616E76617327292E64656661756C747D2063616E7661735C6E202A2040706172616D207B696D706F727428272E2F5465787452656E646572657227292E64656661756C747D20746578';
wwv_flow_imp.g_varchar2_table(2363) := '7452656E64657265725C6E202A2040706172616D207B6E756D6265727D205B7072696F726974795D5C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E2042706D6E52656E6465726572285C6E20202020636F6E6669672C206576';
wwv_flow_imp.g_varchar2_table(2364) := '656E744275732C207374796C65732C20706174684D61702C5C6E2020202063616E7661732C207465787452656E64657265722C207072696F7269747929207B5C6E5C6E20204261736552656E64657265722E63616C6C28746869732C206576656E744275';
wwv_flow_imp.g_varchar2_table(2365) := '732C207072696F72697479293B5C6E5C6E20207661722064656661756C7446696C6C436F6C6F72203D20636F6E66696720262620636F6E6669672E64656661756C7446696C6C436F6C6F722C5C6E20202020202064656661756C745374726F6B65436F6C';
wwv_flow_imp.g_varchar2_table(2366) := '6F72203D20636F6E66696720262620636F6E6669672E64656661756C745374726F6B65436F6C6F722C5C6E20202020202064656661756C744C6162656C436F6C6F72203D20636F6E66696720262620636F6E6669672E64656661756C744C6162656C436F';
wwv_flow_imp.g_varchar2_table(2367) := '6C6F723B5C6E5C6E202066756E6374696F6E2073686170655374796C6528617474727329207B5C6E2020202072657475726E207374796C65732E636F6D707574655374796C652861747472732C207B5C6E2020202020207374726F6B654C696E65636170';
wwv_flow_imp.g_varchar2_table(2368) := '3A2027726F756E64272C5C6E2020202020207374726F6B654C696E656A6F696E3A2027726F756E64272C5C6E2020202020207374726F6B653A20626C61636B2C5C6E2020202020207374726F6B6557696474683A20322C5C6E20202020202066696C6C3A';
wwv_flow_imp.g_varchar2_table(2369) := '20277768697465275C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374696F6E206C696E655374796C6528617474727329207B5C6E2020202072657475726E207374796C65732E636F6D707574655374796C652861747472732C205B20276E6F';
wwv_flow_imp.g_varchar2_table(2370) := '2D66696C6C27205D2C207B5C6E2020202020207374726F6B654C696E656361703A2027726F756E64272C5C6E2020202020207374726F6B654C696E656A6F696E3A2027726F756E64272C5C6E2020202020207374726F6B653A20626C61636B2C5C6E2020';
wwv_flow_imp.g_varchar2_table(2371) := '202020207374726F6B6557696474683A20325C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374696F6E206164644D61726B65722869642C206F7074696F6E7329207B5C6E20202020766172207B5C6E202020202020726566203D207B20783A';
wwv_flow_imp.g_varchar2_table(2372) := '20302C20793A2030207D2C5C6E2020202020207363616C65203D20312C5C6E202020202020656C656D656E742C5C6E202020202020706172656E74476678203D2063616E7661732E5F7376675C6E202020207D203D206F7074696F6E733B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(2373) := '2020766172206D61726B6572203D2073766743726561746528276D61726B6572272C207B5C6E20202020202069643A2069642C5C6E20202020202076696577426F783A2027302030203230203230272C5C6E202020202020726566583A207265662E782C';
wwv_flow_imp.g_varchar2_table(2374) := '5C6E202020202020726566593A207265662E792C5C6E2020202020206D61726B657257696474683A203230202A207363616C652C5C6E2020202020206D61726B65724865696768743A203230202A207363616C652C5C6E2020202020206F7269656E743A';
wwv_flow_imp.g_varchar2_table(2375) := '20276175746F275C6E202020207D293B5C6E5C6E20202020737667417070656E64286D61726B65722C20656C656D656E74293B5C6E5C6E202020207661722064656673203D20646F6D517565727928273A73636F7065203E2064656673272C2070617265';
wwv_flow_imp.g_varchar2_table(2376) := '6E74476678293B5C6E5C6E2020202069662028216465667329207B5C6E20202020202064656673203D2073766743726561746528276465667327293B5C6E5C6E202020202020737667417070656E6428706172656E744766782C2064656673293B5C6E20';
wwv_flow_imp.g_varchar2_table(2377) := '2020207D5C6E5C6E20202020737667417070656E6428646566732C206D61726B6572293B5C6E20207D5C6E5C6E202066756E6374696F6E206D61726B657228706172656E744766782C20747970652C2066696C6C2C207374726F6B6529207B5C6E5C6E5C';
wwv_flow_imp.g_varchar2_table(2378) := '6E20202020766172206964203D206D61726B65724964732E6E657874507265666978656428276D61726B65722D27293B5C6E5C6E202020206372656174654D61726B657228706172656E744766782C2069642C20747970652C2066696C6C2C207374726F';
wwv_flow_imp.g_varchar2_table(2379) := '6B65293B5C6E5C6E2020202072657475726E202775726C282327202B206964202B202729273B5C6E20207D5C6E5C6E202066756E6374696F6E206372656174654D61726B657228706172656E744766782C2069642C20747970652C2066696C6C2C207374';
wwv_flow_imp.g_varchar2_table(2380) := '726F6B6529207B5C6E5C6E202020206966202874797065203D3D3D202773657175656E6365666C6F772D656E642729207B5C6E2020202020207661722073657175656E6365666C6F77456E64203D20737667437265617465282770617468272C207B5C6E';
wwv_flow_imp.g_varchar2_table(2381) := '2020202020202020643A20274D20312035204C203131203130204C2031203135205A272C5C6E20202020202020202E2E2E73686170655374796C65287B5C6E2020202020202020202066696C6C3A207374726F6B652C5C6E202020202020202020207374';
wwv_flow_imp.g_varchar2_table(2382) := '726F6B653A207374726F6B652C5C6E202020202020202020207374726F6B6557696474683A20315C6E20202020202020207D295C6E2020202020207D293B5C6E5C6E2020202020206164644D61726B65722869642C207B5C6E2020202020202020656C65';
wwv_flow_imp.g_varchar2_table(2383) := '6D656E743A2073657175656E6365666C6F77456E642C5C6E20202020202020207265663A207B20783A2031312C20793A203130207D2C5C6E20202020202020207363616C653A20302E352C5C6E2020202020202020706172656E744766785C6E20202020';
wwv_flow_imp.g_varchar2_table(2384) := '20207D293B5C6E202020207D5C6E5C6E202020206966202874797065203D3D3D20276D657373616765666C6F772D73746172742729207B5C6E202020202020766172206D657373616765666C6F775374617274203D207376674372656174652827636972';
wwv_flow_imp.g_varchar2_table(2385) := '636C65272C207B5C6E202020202020202063783A20362C5C6E202020202020202063793A20362C5C6E2020202020202020723A20332E352C5C6E20202020202020202E2E2E73686170655374796C65287B5C6E2020202020202020202066696C6C2C5C6E';
wwv_flow_imp.g_varchar2_table(2386) := '202020202020202020207374726F6B653A207374726F6B652C5C6E202020202020202020207374726F6B6557696474683A20312C5C6E5C6E202020202020202020202F2F2066697820666F7220736166617269202F206368726F6D65202F206669726566';
wwv_flow_imp.g_varchar2_table(2387) := '6F7820627567206E6F7420636F72726563746C795C6E202020202020202020202F2F20726573657474696E67207374726F6B6520646173682061727261795C6E202020202020202020207374726F6B654461736861727261793A205B2031303030302C20';
wwv_flow_imp.g_varchar2_table(2388) := '31205D5C6E20202020202020207D295C6E2020202020207D293B5C6E5C6E2020202020206164644D61726B65722869642C207B5C6E2020202020202020656C656D656E743A206D657373616765666C6F7753746172742C5C6E2020202020202020726566';
wwv_flow_imp.g_varchar2_table(2389) := '3A207B20783A20362C20793A2036207D2C5C6E2020202020202020706172656E744766785C6E2020202020207D293B5C6E202020207D5C6E5C6E202020206966202874797065203D3D3D20276D657373616765666C6F772D656E642729207B5C6E202020';
wwv_flow_imp.g_varchar2_table(2390) := '202020766172206D657373616765666C6F77456E64203D20737667437265617465282770617468272C207B5C6E2020202020202020643A20276D20312035206C2030202D33206C20372033206C202D372033207A272C5C6E20202020202020202E2E2E73';
wwv_flow_imp.g_varchar2_table(2391) := '686170655374796C65287B5C6E2020202020202020202066696C6C2C5C6E202020202020202020207374726F6B653A207374726F6B652C5C6E202020202020202020207374726F6B6557696474683A20312C5C6E5C6E202020202020202020202F2F2066';
wwv_flow_imp.g_varchar2_table(2392) := '697820666F7220736166617269202F206368726F6D65202F2066697265666F7820627567206E6F7420636F72726563746C795C6E202020202020202020202F2F20726573657474696E67207374726F6B6520646173682061727261795C6E202020202020';
wwv_flow_imp.g_varchar2_table(2393) := '202020207374726F6B654461736861727261793A205B2031303030302C2031205D5C6E20202020202020207D295C6E2020202020207D293B5C6E5C6E2020202020206164644D61726B65722869642C207B5C6E2020202020202020656C656D656E743A20';
wwv_flow_imp.g_varchar2_table(2394) := '6D657373616765666C6F77456E642C5C6E20202020202020207265663A207B20783A20382E352C20793A2035207D2C5C6E2020202020202020706172656E744766785C6E2020202020207D293B5C6E202020207D5C6E5C6E202020206966202874797065';
wwv_flow_imp.g_varchar2_table(2395) := '203D3D3D20276173736F63696174696F6E2D73746172742729207B5C6E202020202020766172206173736F63696174696F6E5374617274203D20737667437265617465282770617468272C207B5C6E2020202020202020643A20274D2031312035204C20';
wwv_flow_imp.g_varchar2_table(2396) := '31203130204C203131203135272C5C6E20202020202020202E2E2E6C696E655374796C65287B5C6E2020202020202020202066696C6C3A20276E6F6E65272C5C6E202020202020202020207374726F6B652C5C6E202020202020202020207374726F6B65';
wwv_flow_imp.g_varchar2_table(2397) := '57696474683A20312E352C5C6E5C6E202020202020202020202F2F2066697820666F7220736166617269202F206368726F6D65202F2066697265666F7820627567206E6F7420636F72726563746C795C6E202020202020202020202F2F20726573657474';
wwv_flow_imp.g_varchar2_table(2398) := '696E67207374726F6B6520646173682061727261795C6E202020202020202020207374726F6B654461736861727261793A205B2031303030302C2031205D5C6E20202020202020207D295C6E2020202020207D293B5C6E5C6E2020202020206164644D61';
wwv_flow_imp.g_varchar2_table(2399) := '726B65722869642C207B5C6E2020202020202020656C656D656E743A206173736F63696174696F6E53746172742C5C6E20202020202020207265663A207B20783A20312C20793A203130207D2C5C6E20202020202020207363616C653A20302E352C5C6E';
wwv_flow_imp.g_varchar2_table(2400) := '2020202020202020706172656E744766785C6E2020202020207D293B5C6E202020207D5C6E5C6E202020206966202874797065203D3D3D20276173736F63696174696F6E2D656E642729207B5C6E202020202020766172206173736F63696174696F6E45';
wwv_flow_imp.g_varchar2_table(2401) := '6E64203D20737667437265617465282770617468272C207B5C6E2020202020202020643A20274D20312035204C203131203130204C2031203135272C5C6E20202020202020202E2E2E6C696E655374796C65287B5C6E2020202020202020202066696C6C';
wwv_flow_imp.g_varchar2_table(2402) := '3A20276E6F6E65272C5C6E202020202020202020207374726F6B652C5C6E202020202020202020207374726F6B6557696474683A20312E352C5C6E5C6E202020202020202020202F2F2066697820666F7220736166617269202F206368726F6D65202F20';
wwv_flow_imp.g_varchar2_table(2403) := '66697265666F7820627567206E6F7420636F72726563746C795C6E202020202020202020202F2F20726573657474696E67207374726F6B6520646173682061727261795C6E202020202020202020207374726F6B654461736861727261793A205B203130';
wwv_flow_imp.g_varchar2_table(2404) := '3030302C2031205D5C6E20202020202020207D295C6E2020202020207D293B5C6E5C6E2020202020206164644D61726B65722869642C207B5C6E2020202020202020656C656D656E743A206173736F63696174696F6E456E642C5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(2405) := '7265663A207B20783A2031312C20793A203130207D2C5C6E20202020202020207363616C653A20302E352C5C6E2020202020202020706172656E744766785C6E2020202020207D293B5C6E202020207D5C6E5C6E202020206966202874797065203D3D3D';
wwv_flow_imp.g_varchar2_table(2406) := '2027636F6E646974696F6E616C2D666C6F772D6D61726B65722729207B5C6E20202020202076617220636F6E646974696F6E616C466C6F774D61726B6572203D20737667437265617465282770617468272C207B5C6E2020202020202020643A20274D20';
wwv_flow_imp.g_varchar2_table(2407) := '30203130204C20382036204C203136203130204C2038203134205A272C5C6E20202020202020202E2E2E73686170655374796C65287B5C6E2020202020202020202066696C6C2C5C6E202020202020202020207374726F6B653A207374726F6B655C6E20';
wwv_flow_imp.g_varchar2_table(2408) := '202020202020207D295C6E2020202020207D293B5C6E5C6E2020202020206164644D61726B65722869642C207B5C6E2020202020202020656C656D656E743A20636F6E646974696F6E616C466C6F774D61726B65722C5C6E20202020202020207265663A';
wwv_flow_imp.g_varchar2_table(2409) := '207B20783A202D312C20793A203130207D2C5C6E20202020202020207363616C653A20302E352C5C6E2020202020202020706172656E744766785C6E2020202020207D293B5C6E202020207D5C6E5C6E202020206966202874797065203D3D3D2027636F';
wwv_flow_imp.g_varchar2_table(2410) := '6E646974696F6E616C2D64656661756C742D666C6F772D6D61726B65722729207B5C6E2020202020207661722064656661756C74466C6F774D61726B6572203D20737667437265617465282770617468272C207B5C6E2020202020202020643A20274D20';
wwv_flow_imp.g_varchar2_table(2411) := '362034204C203130203136272C5C6E20202020202020202E2E2E73686170655374796C65287B5C6E202020202020202020207374726F6B653A207374726F6B652C5C6E2020202020202020202066696C6C3A20276E6F6E65275C6E20202020202020207D';
wwv_flow_imp.g_varchar2_table(2412) := '295C6E2020202020207D293B5C6E5C6E2020202020206164644D61726B65722869642C207B5C6E2020202020202020656C656D656E743A2064656661756C74466C6F774D61726B65722C5C6E20202020202020207265663A207B20783A20302C20793A20';
wwv_flow_imp.g_varchar2_table(2413) := '3130207D2C5C6E20202020202020207363616C653A20302E352C5C6E2020202020202020706172656E744766785C6E2020202020207D293B5C6E202020207D5C6E20207D5C6E5C6E202066756E6374696F6E2064726177436972636C6528706172656E74';
wwv_flow_imp.g_varchar2_table(2414) := '4766782C2077696474682C206865696768742C206F66667365742C206174747273203D207B7D29207B5C6E5C6E202020206966202869734F626A656374286F66667365742929207B5C6E2020202020206174747273203D206F66667365743B5C6E202020';
wwv_flow_imp.g_varchar2_table(2415) := '2020206F6666736574203D20303B5C6E202020207D5C6E5C6E202020206F6666736574203D206F6666736574207C7C20303B5C6E5C6E202020206174747273203D2073686170655374796C65286174747273293B5C6E5C6E20202020766172206378203D';
wwv_flow_imp.g_varchar2_table(2416) := '207769647468202F20322C5C6E20202020202020206379203D20686569676874202F20323B5C6E5C6E2020202076617220636972636C65203D207376674372656174652827636972636C65272C207B5C6E20202020202063783A2063782C5C6E20202020';
wwv_flow_imp.g_varchar2_table(2417) := '202063793A2063792C5C6E202020202020723A204D6174682E726F756E6428287769647468202B2068656967687429202F2034202D206F6666736574292C5C6E2020202020202E2E2E61747472735C6E202020207D293B5C6E5C6E202020207376674170';
wwv_flow_imp.g_varchar2_table(2418) := '70656E6428706172656E744766782C20636972636C65293B5C6E5C6E2020202072657475726E20636972636C653B5C6E20207D5C6E5C6E202066756E6374696F6E20647261775265637428706172656E744766782C2077696474682C206865696768742C';
wwv_flow_imp.g_varchar2_table(2419) := '20722C206F66667365742C20617474727329207B5C6E5C6E202020206966202869734F626A656374286F66667365742929207B5C6E2020202020206174747273203D206F66667365743B5C6E2020202020206F6666736574203D20303B5C6E202020207D';
wwv_flow_imp.g_varchar2_table(2420) := '5C6E5C6E202020206F6666736574203D206F6666736574207C7C20303B5C6E5C6E202020206174747273203D2073686170655374796C65286174747273293B5C6E5C6E202020207661722072656374203D20737667437265617465282772656374272C20';
wwv_flow_imp.g_varchar2_table(2421) := '7B5C6E202020202020783A206F66667365742C5C6E202020202020793A206F66667365742C5C6E20202020202077696474683A207769647468202D206F6666736574202A20322C5C6E2020202020206865696768743A20686569676874202D206F666673';
wwv_flow_imp.g_varchar2_table(2422) := '6574202A20322C5C6E20202020202072783A20722C5C6E20202020202072793A20722C5C6E2020202020202E2E2E61747472735C6E202020207D293B5C6E5C6E20202020737667417070656E6428706172656E744766782C2072656374293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(2423) := '20202072657475726E20726563743B5C6E20207D5C6E5C6E202066756E6374696F6E20647261774469616D6F6E6428706172656E744766782C2077696474682C206865696768742C20617474727329207B5C6E5C6E2020202076617220785F32203D2077';
wwv_flow_imp.g_varchar2_table(2424) := '69647468202F20323B5C6E2020202076617220795F32203D20686569676874202F20323B5C6E5C6E2020202076617220706F696E7473203D205B5C6E2020202020207B20783A20785F322C20793A2030207D2C5C6E2020202020207B20783A2077696474';
wwv_flow_imp.g_varchar2_table(2425) := '682C20793A20795F32207D2C5C6E2020202020207B20783A20785F322C20793A20686569676874207D2C5C6E2020202020207B20783A20302C20793A20795F32207D5C6E202020205D3B5C6E5C6E2020202076617220706F696E7473537472696E67203D';
wwv_flow_imp.g_varchar2_table(2426) := '20706F696E74732E6D61702866756E6374696F6E28706F696E7429207B5C6E20202020202072657475726E20706F696E742E78202B20272C27202B20706F696E742E793B5C6E202020207D292E6A6F696E28272027293B5C6E5C6E202020206174747273';
wwv_flow_imp.g_varchar2_table(2427) := '203D2073686170655374796C65286174747273293B5C6E5C6E2020202076617220706F6C79676F6E203D207376674372656174652827706F6C79676F6E272C207B5C6E2020202020202E2E2E61747472732C5C6E202020202020706F696E74733A20706F';
wwv_flow_imp.g_varchar2_table(2428) := '696E7473537472696E675C6E202020207D293B5C6E5C6E20202020737667417070656E6428706172656E744766782C20706F6C79676F6E293B5C6E5C6E2020202072657475726E20706F6C79676F6E3B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A';
wwv_flow_imp.g_varchar2_table(2429) := '2040706172616D207B535647456C656D656E747D20706172656E744766785C6E2020202A2040706172616D207B506F696E745B5D7D20776179706F696E74735C6E2020202A2040706172616D207B616E797D2061747472735C6E2020202A204070617261';
wwv_flow_imp.g_varchar2_table(2430) := '6D207B6E756D6265727D205B7261646975735D5C6E2020202A5C6E2020202A204072657475726E207B535647456C656D656E747D5C6E2020202A2F5C6E202066756E6374696F6E20647261774C696E6528706172656E744766782C20776179706F696E74';
wwv_flow_imp.g_varchar2_table(2431) := '732C2061747472732C2072616469757329207B5C6E202020206174747273203D206C696E655374796C65286174747273293B5C6E5C6E20202020766172206C696E65203D206372656174654C696E6528776179706F696E74732C2061747472732C207261';
wwv_flow_imp.g_varchar2_table(2432) := '64697573293B5C6E5C6E20202020737667417070656E6428706172656E744766782C206C696E65293B5C6E5C6E2020202072657475726E206C696E653B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A2040706172616D207B535647456C656D656E74';
wwv_flow_imp.g_varchar2_table(2433) := '7D20706172656E744766785C6E2020202A2040706172616D207B506F696E745B5D7D20776179706F696E74735C6E2020202A2040706172616D207B616E797D2061747472735C6E2020202A5C6E2020202A204072657475726E207B535647456C656D656E';
wwv_flow_imp.g_varchar2_table(2434) := '747D5C6E2020202A2F5C6E202066756E6374696F6E2064726177436F6E6E656374696F6E5365676D656E747328706172656E744766782C20776179706F696E74732C20617474727329207B5C6E2020202072657475726E20647261774C696E6528706172';
wwv_flow_imp.g_varchar2_table(2435) := '656E744766782C20776179706F696E74732C2061747472732C2035293B5C6E20207D5C6E5C6E202066756E6374696F6E20647261775061746828706172656E744766782C20642C20617474727329207B5C6E202020206174747273203D206C696E655374';
wwv_flow_imp.g_varchar2_table(2436) := '796C65286174747273293B5C6E5C6E202020207661722070617468203D20737667437265617465282770617468272C207B5C6E2020202020202E2E2E61747472732C5C6E202020202020645C6E202020207D293B5C6E5C6E20202020737667417070656E';
wwv_flow_imp.g_varchar2_table(2437) := '6428706172656E744766782C2070617468293B5C6E5C6E2020202072657475726E20706174683B5C6E20207D5C6E5C6E202066756E6374696F6E20647261774D61726B657228747970652C20706172656E744766782C20706174682C2061747472732920';
wwv_flow_imp.g_varchar2_table(2438) := '7B5C6E2020202072657475726E20647261775061746828706172656E744766782C20706174682C2061737369676E287B2027646174612D6D61726B6572273A2074797065207D2C20617474727329293B5C6E20207D5C6E5C6E202066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(2439) := '72656E6465726572287479706529207B5C6E2020202072657475726E2068616E646C6572735B747970655D3B5C6E20207D5C6E5C6E202066756E6374696F6E206173287479706529207B5C6E2020202072657475726E2066756E6374696F6E2870617265';
wwv_flow_imp.g_varchar2_table(2440) := '6E744766782C20656C656D656E742C20617474727329207B5C6E20202020202072657475726E2072656E646572657228747970652928706172656E744766782C20656C656D656E742C206174747273293B5C6E202020207D3B5C6E20207D5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(2441) := '766172206576656E7449636F6E52656E646572657273203D207B5C6E202020202762706D6E3A4D6573736167654576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D20';
wwv_flow_imp.g_varchar2_table(2442) := '7B7D2C2069735468726F77696E6729207B5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F4D455353414745272C207B5C6E2020202020202020785363616C6546616374';
wwv_flow_imp.g_varchar2_table(2443) := '6F723A20302E392C5C6E2020202020202020795363616C65466163746F723A20302E392C5C6E2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768';
wwv_flow_imp.g_varchar2_table(2444) := '743A20656C656D656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E3233352C5C6E202020202020202020206D793A20302E3331355C6E20202020202020207D5C6E2020202020';
wwv_flow_imp.g_varchar2_table(2445) := '207D293B5C6E5C6E2020202020207661722066696C6C203D2069735468726F77696E675C6E20202020202020203F206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E737472';
wwv_flow_imp.g_varchar2_table(2446) := '6F6B65295C6E20202020202020203A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B5C6E5C6E202020202020766172207374726F6B65203D2069735468726F77696E';
wwv_flow_imp.g_varchar2_table(2447) := '675C6E20202020202020203F2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C295C6E20202020202020203A206765745374726F6B65436F6C6F7228656C656D656E742C20';
wwv_flow_imp.g_varchar2_table(2448) := '64656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65293B5C6E5C6E202020202020766172206D65737361676550617468203D20647261775061746828706172656E744766782C2070617468446174612C207B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(2449) := '20202066696C6C2C5C6E20202020202020207374726F6B652C5C6E20202020202020207374726F6B6557696474683A20315C6E2020202020207D293B5C6E5C6E20202020202072657475726E206D657373616765506174683B5C6E202020207D2C5C6E20';
wwv_flow_imp.g_varchar2_table(2450) := '2020202762706D6E3A54696D65724576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E20202020202076617220636972636C65203D206472617743';
wwv_flow_imp.g_varchar2_table(2451) := '6972636C6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20302E32202A20656C656D656E742E6865696768742C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228';
wwv_flow_imp.g_varchar2_table(2452) := '656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C';
wwv_flow_imp.g_varchar2_table(2453) := '2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20325C6E2020202020207D293B5C6E5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556';
wwv_flow_imp.g_varchar2_table(2454) := '454E545F54494D45525F5748272C207B5C6E2020202020202020785363616C65466163746F723A20302E37352C5C6E2020202020202020795363616C65466163746F723A20302E37352C5C6E2020202020202020636F6E7461696E657257696474683A20';
wwv_flow_imp.g_varchar2_table(2455) := '656C656D656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E352C5C6E20';
wwv_flow_imp.g_varchar2_table(2456) := '2020202020202020206D793A20302E355C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E202020202020647261775061746828706172656E744766782C2070617468446174612C207B5C6E20202020202020207374726F6B653A20676574';
wwv_flow_imp.g_varchar2_table(2457) := '5374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20325C6E2020202020207D293B5C6E5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2458) := '666F7220287661722069203D20303B2069203C2031323B20692B2B29207B5C6E2020202020202020766172206C696E655061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F54494D45525F4C494E45272C';
wwv_flow_imp.g_varchar2_table(2459) := '207B5C6E20202020202020202020785363616C65466163746F723A20302E37352C5C6E20202020202020202020795363616C65466163746F723A20302E37352C5C6E20202020202020202020636F6E7461696E657257696474683A20656C656D656E742E';
wwv_flow_imp.g_varchar2_table(2460) := '77696474682C5C6E20202020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C5C6E20202020202020202020706F736974696F6E3A207B5C6E2020202020202020202020206D783A20302E352C5C6E202020';
wwv_flow_imp.g_varchar2_table(2461) := '2020202020202020206D793A20302E355C6E202020202020202020207D5C6E20202020202020207D293B5C6E5C6E2020202020202020766172207769647468203D20656C656D656E742E7769647468202F20322C5C6E2020202020202020202020206865';
wwv_flow_imp.g_varchar2_table(2462) := '69676874203D20656C656D656E742E686569676874202F20323B5C6E5C6E2020202020202020647261775061746828706172656E744766782C206C696E6550617468446174612C207B5C6E202020202020202020207374726F6B6557696474683A20312C';
wwv_flow_imp.g_varchar2_table(2463) := '5C6E202020202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E202020202020202020207472616E73666F726D3A';
wwv_flow_imp.g_varchar2_table(2464) := '2027726F746174652827202B202869202A20333029202B20272C27202B20686569676874202B20272C27202B207769647468202B202729275C6E20202020202020207D293B5C6E2020202020207D5C6E5C6E20202020202072657475726E20636972636C';
wwv_flow_imp.g_varchar2_table(2465) := '653B5C6E202020207D2C5C6E202020202762706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D207B7D2C2069735468726F77696E6729';
wwv_flow_imp.g_varchar2_table(2466) := '207B5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F455343414C4154494F4E272C207B5C6E2020202020202020785363616C65466163746F723A20312C5C6E20202020';
wwv_flow_imp.g_varchar2_table(2467) := '20202020795363616C65466163746F723A20312C5C6E2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768743A206576656E742E6865696768742C5C6E';
wwv_flow_imp.g_varchar2_table(2468) := '2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E352C5C6E202020202020202020206D793A20302E325C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E2020202020207661722066696C6C203D';
wwv_flow_imp.g_varchar2_table(2469) := '2069735468726F77696E675C6E20202020202020203F206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E20202020202020203A2067657446696C6C436F6C';
wwv_flow_imp.g_varchar2_table(2470) := '6F72286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B5C6E5C6E20202020202072657475726E20647261775061746828706172656E744766782C2070617468446174612C207B5C6E20202020202020206669';
wwv_flow_imp.g_varchar2_table(2471) := '6C6C2C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20';
wwv_flow_imp.g_varchar2_table(2472) := '315C6E2020202020207D293B5C6E202020207D2C5C6E202020202762706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D207B7D2920';
wwv_flow_imp.g_varchar2_table(2473) := '7B5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F434F4E444954494F4E414C272C207B5C6E2020202020202020785363616C65466163746F723A20312C5C6E20202020';
wwv_flow_imp.g_varchar2_table(2474) := '20202020795363616C65466163746F723A20312C5C6E2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768743A206576656E742E6865696768742C5C6E';
wwv_flow_imp.g_varchar2_table(2475) := '2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E352C5C6E202020202020202020206D793A20302E3232325C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E20202020202072657475726E2064';
wwv_flow_imp.g_varchar2_table(2476) := '7261775061746828706172656E744766782C2070617468446174612C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F72286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E2020';
wwv_flow_imp.g_varchar2_table(2477) := '2020202020207374726F6B653A206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20315C6E20202020';
wwv_flow_imp.g_varchar2_table(2478) := '20207D293B5C6E202020207D2C5C6E202020202762706D6E3A4C696E6B4576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D207B7D2C2069735468726F77696E6729207B5C';
wwv_flow_imp.g_varchar2_table(2479) := '6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F4C494E4B272C207B5C6E2020202020202020785363616C65466163746F723A20312C5C6E2020202020202020795363616C';
wwv_flow_imp.g_varchar2_table(2480) := '65466163746F723A20312C5C6E2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768743A206576656E742E6865696768742C5C6E202020202020202070';
wwv_flow_imp.g_varchar2_table(2481) := '6F736974696F6E3A207B5C6E202020202020202020206D783A20302E35372C5C6E202020202020202020206D793A20302E3236335C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E2020202020207661722066696C6C203D206973546872';
wwv_flow_imp.g_varchar2_table(2482) := '6F77696E675C6E20202020202020203F206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E20202020202020203A2067657446696C6C436F6C6F7228657665';
wwv_flow_imp.g_varchar2_table(2483) := '6E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B5C6E5C6E20202020202072657475726E20647261775061746828706172656E744766782C2070617468446174612C207B5C6E202020202020202066696C6C2C5C6E20';
wwv_flow_imp.g_varchar2_table(2484) := '202020202020207374726F6B653A206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20315C6E202020';
wwv_flow_imp.g_varchar2_table(2485) := '2020207D293B5C6E202020207D2C5C6E202020202762706D6E3A4572726F724576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D207B7D2C2069735468726F77696E672920';
wwv_flow_imp.g_varchar2_table(2486) := '7B5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F4552524F52272C207B5C6E2020202020202020785363616C65466163746F723A20312E312C5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(2487) := '795363616C65466163746F723A20312E312C5C6E2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768743A206576656E742E6865696768742C5C6E2020';
wwv_flow_imp.g_varchar2_table(2488) := '202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E322C5C6E202020202020202020206D793A20302E3732325C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E2020202020207661722066696C6C203D';
wwv_flow_imp.g_varchar2_table(2489) := '2069735468726F77696E675C6E20202020202020203F206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E20202020202020203A2067657446696C6C436F6C';
wwv_flow_imp.g_varchar2_table(2490) := '6F72286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B5C6E5C6E20202020202072657475726E20647261775061746828706172656E744766782C2070617468446174612C207B5C6E20202020202020206669';
wwv_flow_imp.g_varchar2_table(2491) := '6C6C2C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20';
wwv_flow_imp.g_varchar2_table(2492) := '315C6E2020202020207D293B5C6E202020207D2C5C6E202020202762706D6E3A43616E63656C4576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D207B7D2C206973546872';
wwv_flow_imp.g_varchar2_table(2493) := '6F77696E6729207B5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F43414E43454C5F3435272C207B5C6E2020202020202020785363616C65466163746F723A20312E30';
wwv_flow_imp.g_varchar2_table(2494) := '2C5C6E2020202020202020795363616C65466163746F723A20312E302C5C6E2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768743A206576656E742E';
wwv_flow_imp.g_varchar2_table(2495) := '6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E3633382C5C6E202020202020202020206D793A202D302E3035355C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(2496) := '202020207661722066696C6C203D2069735468726F77696E67203F206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B6529203A20276E6F6E65273B5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(2497) := '2020207661722070617468203D20647261775061746828706172656E744766782C2070617468446174612C207B5C6E202020202020202066696C6C2C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F72286576656E742C20';
wwv_flow_imp.g_varchar2_table(2498) := '64656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20315C6E2020202020207D293B5C6E5C6E202020202020726F7461746528706174682C203435293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(2499) := '20202020202072657475726E20706174683B5C6E202020207D2C5C6E202020202762706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D';
wwv_flow_imp.g_varchar2_table(2500) := '207B7D2C2069735468726F77696E6729207B5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F434F4D50454E534154494F4E272C207B5C6E202020202020202078536361';
wwv_flow_imp.g_varchar2_table(2501) := '6C65466163746F723A20312C5C6E2020202020202020795363616C65466163746F723A20312C5C6E2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768';
wwv_flow_imp.g_varchar2_table(2502) := '743A206576656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E32322C5C6E202020202020202020206D793A20302E355C6E20202020202020207D5C6E2020202020207D293B5C';
wwv_flow_imp.g_varchar2_table(2503) := '6E5C6E2020202020207661722066696C6C203D2069735468726F77696E675C6E20202020202020203F206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E20';
wwv_flow_imp.g_varchar2_table(2504) := '202020202020203A2067657446696C6C436F6C6F72286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B5C6E5C6E20202020202072657475726E20647261775061746828706172656E744766782C2070617468';
wwv_flow_imp.g_varchar2_table(2505) := '446174612C207B5C6E202020202020202066696C6C2C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E2020';
wwv_flow_imp.g_varchar2_table(2506) := '2020202020207374726F6B6557696474683A20315C6E2020202020207D293B5C6E202020207D2C5C6E202020202762706D6E3A5369676E616C4576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E74';
wwv_flow_imp.g_varchar2_table(2507) := '2C206174747273203D207B7D2C2069735468726F77696E6729207B5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F5349474E414C272C207B5C6E202020202020202078';
wwv_flow_imp.g_varchar2_table(2508) := '5363616C65466163746F723A20302E392C5C6E2020202020202020795363616C65466163746F723A20302E392C5C6E2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C5C6E2020202020202020636F6E7461696E';
wwv_flow_imp.g_varchar2_table(2509) := '65724865696768743A206576656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E352C5C6E202020202020202020206D793A20302E325C6E20202020202020207D5C6E20202020';
wwv_flow_imp.g_varchar2_table(2510) := '20207D293B5C6E5C6E2020202020207661722066696C6C203D2069735468726F77696E675C6E20202020202020203F206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F';
wwv_flow_imp.g_varchar2_table(2511) := '6B65295C6E20202020202020203A2067657446696C6C436F6C6F72286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B5C6E5C6E20202020202072657475726E20647261775061746828706172656E74476678';
wwv_flow_imp.g_varchar2_table(2512) := '2C2070617468446174612C207B5C6E20202020202020207374726F6B6557696474683A20312C5C6E202020202020202066696C6C2C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F72286576656E742C2064656661756C74';
wwv_flow_imp.g_varchar2_table(2513) := '5374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E2020202020207D293B5C6E202020207D2C5C6E202020202762706D6E3A4D756C7469706C654576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766';
wwv_flow_imp.g_varchar2_table(2514) := '782C206576656E742C206174747273203D207B7D2C2069735468726F77696E6729207B5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061746828274556454E545F4D554C5449504C45272C207B5C';
wwv_flow_imp.g_varchar2_table(2515) := '6E2020202020202020785363616C65466163746F723A20312E312C5C6E2020202020202020795363616C65466163746F723A20312E312C5C6E2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(2516) := '202020636F6E7461696E65724865696768743A206576656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E3232322C5C6E202020202020202020206D793A20302E33365C6E2020';
wwv_flow_imp.g_varchar2_table(2517) := '2020202020207D5C6E2020202020207D293B5C6E5C6E2020202020207661722066696C6C203D2069735468726F77696E675C6E20202020202020203F206765745374726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F';
wwv_flow_imp.g_varchar2_table(2518) := '722C2061747472732E7374726F6B65295C6E20202020202020203A2067657446696C6C436F6C6F72286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C293B5C6E5C6E20202020202072657475726E206472617750';
wwv_flow_imp.g_varchar2_table(2519) := '61746828706172656E744766782C2070617468446174612C207B5C6E202020202020202066696C6C2C5C6E20202020202020207374726F6B6557696474683A20315C6E2020202020207D293B5C6E202020207D2C5C6E202020202762706D6E3A50617261';
wwv_flow_imp.g_varchar2_table(2520) := '6C6C656C4D756C7469706C654576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C206576656E742C206174747273203D207B7D29207B5C6E202020202020766172207061746844617461203D20706174684D6170';
wwv_flow_imp.g_varchar2_table(2521) := '2E6765745363616C65645061746828274556454E545F504152414C4C454C5F4D554C5449504C45272C207B5C6E2020202020202020785363616C65466163746F723A20312E322C5C6E2020202020202020795363616C65466163746F723A20312E322C5C';
wwv_flow_imp.g_varchar2_table(2522) := '6E2020202020202020636F6E7461696E657257696474683A206576656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768743A206576656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E';
wwv_flow_imp.g_varchar2_table(2523) := '202020202020202020206D783A20302E3435382C5C6E202020202020202020206D793A20302E3139345C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E20202020202072657475726E20647261775061746828706172656E744766782C20';
wwv_flow_imp.g_varchar2_table(2524) := '70617468446174612C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F72286576656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374';
wwv_flow_imp.g_varchar2_table(2525) := '726F6B65436F6C6F72286576656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20315C6E2020202020207D293B5C6E202020207D2C5C6E20202020';
wwv_flow_imp.g_varchar2_table(2526) := '2762706D6E3A5465726D696E6174654576656E74446566696E6974696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E20202020202076617220636972636C65203D2064726177';
wwv_flow_imp.g_varchar2_table(2527) := '436972636C6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20382C207B5C6E202020202020202066696C6C3A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C74';
wwv_flow_imp.g_varchar2_table(2528) := '5374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B';
wwv_flow_imp.g_varchar2_table(2529) := '65292C5C6E20202020202020207374726F6B6557696474683A20345C6E2020202020207D293B5C6E5C6E20202020202072657475726E20636972636C653B5C6E202020207D5C6E20207D3B5C6E5C6E202066756E6374696F6E2072656E6465724576656E';
wwv_flow_imp.g_varchar2_table(2530) := '7449636F6E28656C656D656E742C20706172656E744766782C206174747273203D207B7D29207B5C6E202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74292C5C6E202020202020202069735468726F77696E';
wwv_flow_imp.g_varchar2_table(2531) := '67203D2069735468726F774576656E742873656D616E746963293B5C6E5C6E202020206966202873656D616E7469632E67657428276576656E74446566696E6974696F6E7327292026262073656D616E7469632E67657428276576656E74446566696E69';
wwv_flow_imp.g_varchar2_table(2532) := '74696F6E7327292E6C656E677468203E203129207B5C6E2020202020206966202873656D616E7469632E6765742827706172616C6C656C4D756C7469706C65272929207B5C6E202020202020202072657475726E206576656E7449636F6E52656E646572';
wwv_flow_imp.g_varchar2_table(2533) := '6572735B202762706D6E3A506172616C6C656C4D756C7469706C654576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B5C6E2020202020207D5C6E20202020';
wwv_flow_imp.g_varchar2_table(2534) := '2020656C7365207B5C6E202020202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A4D756C7469706C654576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C206174';
wwv_flow_imp.g_varchar2_table(2535) := '7472732C2069735468726F77696E67293B5C6E2020202020207D5C6E202020207D5C6E5C6E2020202069662028697354797065644576656E742873656D616E7469632C202762706D6E3A4D6573736167654576656E74446566696E6974696F6E27292920';
wwv_flow_imp.g_varchar2_table(2536) := '7B5C6E20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A4D6573736167654576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C206973546872';
wwv_flow_imp.g_varchar2_table(2537) := '6F77696E67293B5C6E202020207D5C6E5C6E2020202069662028697354797065644576656E742873656D616E7469632C202762706D6E3A54696D65724576656E74446566696E6974696F6E272929207B5C6E20202020202072657475726E206576656E74';
wwv_flow_imp.g_varchar2_table(2538) := '49636F6E52656E6465726572735B202762706D6E3A54696D65724576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B5C6E202020207D5C6E5C6E2020202069';
wwv_flow_imp.g_varchar2_table(2539) := '662028697354797065644576656E742873656D616E7469632C202762706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E272929207B5C6E20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762';
wwv_flow_imp.g_varchar2_table(2540) := '706D6E3A436F6E646974696F6E616C4576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B5C6E202020207D5C6E5C6E20202020696620286973547970656445';
wwv_flow_imp.g_varchar2_table(2541) := '76656E742873656D616E7469632C202762706D6E3A5369676E616C4576656E74446566696E6974696F6E272929207B5C6E20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A5369676E616C4576656E7444';
wwv_flow_imp.g_varchar2_table(2542) := '6566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B5C6E202020207D5C6E5C6E2020202069662028697354797065644576656E742873656D616E7469632C202762706D6E3A';
wwv_flow_imp.g_varchar2_table(2543) := '457363616C6174696F6E4576656E74446566696E6974696F6E272929207B5C6E20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E27205D28';
wwv_flow_imp.g_varchar2_table(2544) := '706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B5C6E202020207D5C6E5C6E2020202069662028697354797065644576656E742873656D616E7469632C202762706D6E3A4C696E6B4576656E7444656669';
wwv_flow_imp.g_varchar2_table(2545) := '6E6974696F6E272929207B5C6E20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A4C696E6B4576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C206174747273';
wwv_flow_imp.g_varchar2_table(2546) := '2C2069735468726F77696E67293B5C6E202020207D5C6E5C6E2020202069662028697354797065644576656E742873656D616E7469632C202762706D6E3A4572726F724576656E74446566696E6974696F6E272929207B5C6E2020202020207265747572';
wwv_flow_imp.g_varchar2_table(2547) := '6E206576656E7449636F6E52656E6465726572735B202762706D6E3A4572726F724576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B5C6E202020207D5C6E';
wwv_flow_imp.g_varchar2_table(2548) := '5C6E2020202069662028697354797065644576656E742873656D616E7469632C202762706D6E3A43616E63656C4576656E74446566696E6974696F6E272929207B5C6E20202020202072657475726E206576656E7449636F6E52656E6465726572735B20';
wwv_flow_imp.g_varchar2_table(2549) := '2762706D6E3A43616E63656C4576656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B5C6E202020207D5C6E5C6E2020202069662028697354797065644576656E';
wwv_flow_imp.g_varchar2_table(2550) := '742873656D616E7469632C202762706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E272929207B5C6E20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A436F6D70656E7361746545';
wwv_flow_imp.g_varchar2_table(2551) := '76656E74446566696E6974696F6E27205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B5C6E202020207D5C6E5C6E2020202069662028697354797065644576656E742873656D616E7469632C2027';
wwv_flow_imp.g_varchar2_table(2552) := '62706D6E3A5465726D696E6174654576656E74446566696E6974696F6E272929207B5C6E20202020202072657475726E206576656E7449636F6E52656E6465726572735B202762706D6E3A5465726D696E6174654576656E74446566696E6974696F6E27';
wwv_flow_imp.g_varchar2_table(2553) := '205D28706172656E744766782C20656C656D656E742C2061747472732C2069735468726F77696E67293B5C6E202020207D5C6E5C6E2020202072657475726E206E756C6C3B5C6E20207D5C6E5C6E2020766172207461736B4D61726B657252656E646572';
wwv_flow_imp.g_varchar2_table(2554) := '657273203D207B5C6E20202020275061727469636970616E744D756C7469706C69636974794D61726B6572273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E20202020202076617220';
wwv_flow_imp.g_varchar2_table(2555) := '7769647468203D20676574576964746828656C656D656E742C206174747273292C5C6E20202020202020202020686569676874203D2067657448656967687428656C656D656E742C206174747273293B5C6E5C6E202020202020766172206D61726B6572';
wwv_flow_imp.g_varchar2_table(2556) := '50617468203D20706174684D61702E6765745363616C65645061746828274D41524B45525F504152414C4C454C272C207B5C6E2020202020202020785363616C65466163746F723A20312C5C6E2020202020202020795363616C65466163746F723A2031';
wwv_flow_imp.g_varchar2_table(2557) := '2C5C6E2020202020202020636F6E7461696E657257696474683A2077696474682C5C6E2020202020202020636F6E7461696E65724865696768743A206865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E20202020202020202020';
wwv_flow_imp.g_varchar2_table(2558) := '6D783A2028287769647468202F2032202D203629202F207769647468292C5C6E202020202020202020206D793A2028686569676874202D20313529202F206865696768745C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2559) := '647261774D61726B657228277061727469636970616E742D6D756C7469706C6963697479272C20706172656E744766782C206D61726B6572506174682C207B5C6E20202020202020207374726F6B6557696474683A20322C5C6E20202020202020206669';
wwv_flow_imp.g_varchar2_table(2560) := '6C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C206465';
wwv_flow_imp.g_varchar2_table(2561) := '6661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E2020202020207D293B5C6E202020207D2C5C6E202020202753756250726F636573734D61726B6572273A2066756E6374696F6E28706172656E744766782C20656C656D';
wwv_flow_imp.g_varchar2_table(2562) := '656E742C206174747273203D207B7D29207B5C6E202020202020766172206D61726B657252656374203D20647261775265637428706172656E744766782C2031342C2031342C20302C207B5C6E20202020202020207374726F6B6557696474683A20312C';
wwv_flow_imp.g_varchar2_table(2563) := '5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F72';
wwv_flow_imp.g_varchar2_table(2564) := '28656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E2020202020207D293B5C6E5C6E2020202020207472616E736C617465286D61726B6572526563742C20656C656D656E742E776964746820';
wwv_flow_imp.g_varchar2_table(2565) := '2F2032202D20372E352C20656C656D656E742E686569676874202D203230293B5C6E5C6E202020202020766172206D61726B657250617468203D20706174684D61702E6765745363616C65645061746828274D41524B45525F5355425F50524F43455353';
wwv_flow_imp.g_varchar2_table(2566) := '272C207B5C6E2020202020202020785363616C65466163746F723A20312E352C5C6E2020202020202020795363616C65466163746F723A20312E352C5C6E2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C';
wwv_flow_imp.g_varchar2_table(2567) := '5C6E2020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A2028656C656D656E742E7769647468202F2032202D20';
wwv_flow_imp.g_varchar2_table(2568) := '372E3529202F20656C656D656E742E77696474682C5C6E202020202020202020206D793A2028656C656D656E742E686569676874202D20323029202F20656C656D656E742E6865696768745C6E20202020202020207D5C6E2020202020207D293B5C6E5C';
wwv_flow_imp.g_varchar2_table(2569) := '6E202020202020647261774D61726B657228277375622D70726F63657373272C20706172656E744766782C206D61726B6572506174682C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C206465666175';
wwv_flow_imp.g_varchar2_table(2570) := '6C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B6529';
wwv_flow_imp.g_varchar2_table(2571) := '5C6E2020202020207D293B5C6E202020207D2C5C6E2020202027506172616C6C656C4D61726B6572273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C20617474727329207B5C6E202020202020766172207769647468203D20';
wwv_flow_imp.g_varchar2_table(2572) := '676574576964746828656C656D656E742C206174747273292C5C6E20202020202020202020686569676874203D2067657448656967687428656C656D656E742C206174747273293B5C6E5C6E202020202020766172206D61726B657250617468203D2070';
wwv_flow_imp.g_varchar2_table(2573) := '6174684D61702E6765745363616C65645061746828274D41524B45525F504152414C4C454C272C207B5C6E2020202020202020785363616C65466163746F723A20312C5C6E2020202020202020795363616C65466163746F723A20312C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(2574) := '202020636F6E7461696E657257696474683A2077696474682C5C6E2020202020202020636F6E7461696E65724865696768743A206865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A2028287769';
wwv_flow_imp.g_varchar2_table(2575) := '647468202F2032202B2061747472732E706172616C6C656C29202F207769647468292C5C6E202020202020202020206D793A2028686569676874202D20323029202F206865696768745C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(2576) := '2020202020647261774D61726B65722827706172616C6C656C272C20706172656E744766782C206D61726B6572506174682C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C';
wwv_flow_imp.g_varchar2_table(2577) := '6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E202020';
wwv_flow_imp.g_varchar2_table(2578) := '2020207D293B5C6E202020207D2C5C6E202020202753657175656E7469616C4D61726B6572273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C20617474727329207B5C6E202020202020766172206D61726B65725061746820';
wwv_flow_imp.g_varchar2_table(2579) := '3D20706174684D61702E6765745363616C65645061746828274D41524B45525F53455155454E5449414C272C207B5C6E2020202020202020785363616C65466163746F723A20312C5C6E2020202020202020795363616C65466163746F723A20312C5C6E';
wwv_flow_imp.g_varchar2_table(2580) := '2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A20';
wwv_flow_imp.g_varchar2_table(2581) := '7B5C6E202020202020202020206D783A202828656C656D656E742E7769647468202F2032202B2061747472732E73657129202F20656C656D656E742E7769647468292C5C6E202020202020202020206D793A2028656C656D656E742E686569676874202D';
wwv_flow_imp.g_varchar2_table(2582) := '20313929202F20656C656D656E742E6865696768745C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E202020202020647261774D61726B6572282773657175656E7469616C272C20706172656E744766782C206D61726B6572506174682C';
wwv_flow_imp.g_varchar2_table(2583) := '207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C';
wwv_flow_imp.g_varchar2_table(2584) := '6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E2020202020207D293B5C6E202020207D2C5C6E2020202027436F6D70656E736174696F6E4D61726B6572273A2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(2585) := '28706172656E744766782C20656C656D656E742C20617474727329207B5C6E202020202020766172206D61726B65724D617468203D20706174684D61702E6765745363616C65645061746828274D41524B45525F434F4D50454E534154494F4E272C207B';
wwv_flow_imp.g_varchar2_table(2586) := '5C6E2020202020202020785363616C65466163746F723A20312C5C6E2020202020202020795363616C65466163746F723A20312C5C6E2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2587) := '2020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A202828656C656D656E742E7769647468202F2032202B2061747472732E63';
wwv_flow_imp.g_varchar2_table(2588) := '6F6D70656E736174696F6E29202F20656C656D656E742E7769647468292C5C6E202020202020202020206D793A2028656C656D656E742E686569676874202D20313329202F20656C656D656E742E6865696768745C6E20202020202020207D5C6E202020';
wwv_flow_imp.g_varchar2_table(2589) := '2020207D293B5C6E5C6E202020202020647261774D61726B65722827636F6D70656E736174696F6E272C20706172656E744766782C206D61726B65724D6174682C207B5C6E20202020202020207374726F6B6557696474683A20312C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2590) := '202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E74';
wwv_flow_imp.g_varchar2_table(2591) := '2C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E2020202020207D293B5C6E202020207D2C5C6E20202020274C6F6F704D61726B6572273A2066756E6374696F6E28706172656E744766782C20656C656D656E';
wwv_flow_imp.g_varchar2_table(2592) := '742C20617474727329207B5C6E202020202020766172207769647468203D20676574576964746828656C656D656E742C206174747273292C5C6E20202020202020202020686569676874203D2067657448656967687428656C656D656E742C2061747472';
wwv_flow_imp.g_varchar2_table(2593) := '73293B5C6E5C6E202020202020766172206D61726B657250617468203D20706174684D61702E6765745363616C65645061746828274D41524B45525F4C4F4F50272C207B5C6E2020202020202020785363616C65466163746F723A20312C5C6E20202020';
wwv_flow_imp.g_varchar2_table(2594) := '20202020795363616C65466163746F723A20312C5C6E2020202020202020636F6E7461696E657257696474683A2077696474682C5C6E2020202020202020636F6E7461696E65724865696768743A206865696768742C5C6E2020202020202020706F7369';
wwv_flow_imp.g_varchar2_table(2595) := '74696F6E3A207B5C6E202020202020202020206D783A2028287769647468202F2032202B2061747472732E6C6F6F7029202F207769647468292C5C6E202020202020202020206D793A2028686569676874202D203729202F206865696768745C6E202020';
wwv_flow_imp.g_varchar2_table(2596) := '20202020207D5C6E2020202020207D293B5C6E5C6E202020202020647261774D61726B657228276C6F6F70272C20706172656E744766782C206D61726B6572506174682C207B5C6E20202020202020207374726F6B6557696474683A20312E352C5C6E20';
wwv_flow_imp.g_varchar2_table(2597) := '2020202020202066696C6C3A20276E6F6E65272C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E2020';
wwv_flow_imp.g_varchar2_table(2598) := '2020202020207374726F6B654D697465726C696D69743A20302E355C6E2020202020207D293B5C6E202020207D2C5C6E20202020274164686F634D61726B6572273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C2061747472';
wwv_flow_imp.g_varchar2_table(2599) := '7329207B5C6E202020202020766172207769647468203D20676574576964746828656C656D656E742C206174747273292C5C6E20202020202020202020686569676874203D2067657448656967687428656C656D656E742C206174747273293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(2600) := '202020202020766172206D61726B657250617468203D20706174684D61702E6765745363616C65645061746828274D41524B45525F4144484F43272C207B5C6E2020202020202020785363616C65466163746F723A20312C5C6E20202020202020207953';
wwv_flow_imp.g_varchar2_table(2601) := '63616C65466163746F723A20312C5C6E2020202020202020636F6E7461696E657257696474683A2077696474682C5C6E2020202020202020636F6E7461696E65724865696768743A206865696768742C5C6E2020202020202020706F736974696F6E3A20';
wwv_flow_imp.g_varchar2_table(2602) := '7B5C6E202020202020202020206D783A2028287769647468202F2032202B2061747472732E6164686F6329202F207769647468292C5C6E202020202020202020206D793A2028686569676874202D20313529202F206865696768745C6E20202020202020';
wwv_flow_imp.g_varchar2_table(2603) := '207D5C6E2020202020207D293B5C6E5C6E202020202020647261774D61726B657228276164686F63272C20706172656E744766782C206D61726B6572506174682C207B5C6E20202020202020207374726F6B6557696474683A20312C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2604) := '202066696C6C3A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F722865';
wwv_flow_imp.g_varchar2_table(2605) := '6C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E2020202020207D293B5C6E202020207D5C6E20207D3B5C6E5C6E202066756E6374696F6E2072656E6465725461736B4D61726B657228747970';
wwv_flow_imp.g_varchar2_table(2606) := '652C20706172656E744766782C20656C656D656E742C20617474727329207B5C6E202020207461736B4D61726B657252656E6465726572735B2074797065205D28706172656E744766782C20656C656D656E742C206174747273293B5C6E20207D5C6E5C';
wwv_flow_imp.g_varchar2_table(2607) := '6E202066756E6374696F6E2072656E6465725461736B4D61726B65727328706172656E744766782C20656C656D656E742C207461736B4D61726B6572732C206174747273203D207B7D29207B5C6E202020206174747273203D207B5C6E20202020202066';
wwv_flow_imp.g_varchar2_table(2608) := '696C6C3A2061747472732E66696C6C2C5C6E2020202020207374726F6B653A2061747472732E7374726F6B652C5C6E20202020202077696474683A20676574576964746828656C656D656E742C206174747273292C5C6E2020202020206865696768743A';
wwv_flow_imp.g_varchar2_table(2609) := '2067657448656967687428656C656D656E742C206174747273295C6E202020207D3B5C6E5C6E202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74293B5C6E5C6E202020207661722073756270726F63657373';
wwv_flow_imp.g_varchar2_table(2610) := '203D207461736B4D61726B657273202626207461736B4D61726B6572732E696E636C75646573282753756250726F636573734D61726B657227293B5C6E5C6E202020206966202873756270726F6365737329207B5C6E2020202020206174747273203D20';
wwv_flow_imp.g_varchar2_table(2611) := '7B5C6E20202020202020202E2E2E61747472732C5C6E20202020202020207365713A202D32312C5C6E2020202020202020706172616C6C656C3A202D32322C5C6E2020202020202020636F6D70656E736174696F6E3A202D34322C5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(2612) := '206C6F6F703A202D31382C5C6E20202020202020206164686F633A2031305C6E2020202020207D3B5C6E202020207D20656C7365207B5C6E2020202020206174747273203D207B5C6E20202020202020202E2E2E61747472732C5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(2613) := '7365713A202D352C5C6E2020202020202020706172616C6C656C3A202D362C5C6E2020202020202020636F6D70656E736174696F6E3A202D32372C5C6E20202020202020206C6F6F703A20302C5C6E20202020202020206164686F633A2031305C6E2020';
wwv_flow_imp.g_varchar2_table(2614) := '202020207D3B5C6E202020207D5C6E5C6E20202020666F7245616368287461736B4D61726B6572732C2066756E6374696F6E286D61726B657229207B5C6E20202020202072656E6465725461736B4D61726B6572286D61726B65722C20706172656E7447';
wwv_flow_imp.g_varchar2_table(2615) := '66782C20656C656D656E742C206174747273293B5C6E202020207D293B5C6E5C6E202020206966202873656D616E7469632E67657428276973466F72436F6D70656E736174696F6E272929207B5C6E20202020202072656E6465725461736B4D61726B65';
wwv_flow_imp.g_varchar2_table(2616) := '722827436F6D70656E736174696F6E4D61726B6572272C20706172656E744766782C20656C656D656E742C206174747273293B5C6E202020207D5C6E5C6E202020206966202869732873656D616E7469632C202762706D6E3A4164486F6353756250726F';
wwv_flow_imp.g_varchar2_table(2617) := '63657373272929207B5C6E20202020202072656E6465725461736B4D61726B657228274164686F634D61726B6572272C20706172656E744766782C20656C656D656E742C206174747273293B5C6E202020207D5C6E5C6E20202020766172206C6F6F7043';
wwv_flow_imp.g_varchar2_table(2618) := '6861726163746572697374696373203D2073656D616E7469632E67657428276C6F6F7043686172616374657269737469637327292C5C6E2020202020202020697353657175656E7469616C203D206C6F6F70436861726163746572697374696373202626';
wwv_flow_imp.g_varchar2_table(2619) := '206C6F6F704368617261637465726973746963732E6765742827697353657175656E7469616C27293B5C6E5C6E20202020696620286C6F6F7043686172616374657269737469637329207B5C6E5C6E20202020202069662028697353657175656E746961';
wwv_flow_imp.g_varchar2_table(2620) := '6C203D3D3D20756E646566696E656429207B5C6E202020202020202072656E6465725461736B4D61726B657228274C6F6F704D61726B6572272C20706172656E744766782C20656C656D656E742C206174747273293B5C6E2020202020207D5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(2621) := '202020202069662028697353657175656E7469616C203D3D3D2066616C736529207B5C6E202020202020202072656E6465725461736B4D61726B65722827506172616C6C656C4D61726B6572272C20706172656E744766782C20656C656D656E742C2061';
wwv_flow_imp.g_varchar2_table(2622) := '74747273293B5C6E2020202020207D5C6E5C6E20202020202069662028697353657175656E7469616C203D3D3D207472756529207B5C6E202020202020202072656E6465725461736B4D61726B6572282753657175656E7469616C4D61726B6572272C20';
wwv_flow_imp.g_varchar2_table(2623) := '706172656E744766782C20656C656D656E742C206174747273293B5C6E2020202020207D5C6E202020207D5C6E20207D5C6E5C6E202066756E6374696F6E2072656E6465724C6162656C28706172656E744766782C206C6162656C2C206174747273203D';
wwv_flow_imp.g_varchar2_table(2624) := '207B7D29207B5C6E202020206174747273203D2061737369676E287B5C6E20202020202073697A653A207B5C6E202020202020202077696474683A203130305C6E2020202020207D5C6E202020207D2C206174747273293B5C6E5C6E2020202076617220';
wwv_flow_imp.g_varchar2_table(2625) := '74657874203D207465787452656E64657265722E63726561746554657874286C6162656C207C7C2027272C206174747273293B5C6E5C6E20202020737667436C61737365732874657874292E6164642827646A732D6C6162656C27293B5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(2626) := '20737667417070656E6428706172656E744766782C2074657874293B5C6E5C6E2020202072657475726E20746578743B5C6E20207D5C6E5C6E202066756E6374696F6E2072656E646572456D6265646465644C6162656C28706172656E744766782C2065';
wwv_flow_imp.g_varchar2_table(2627) := '6C656D656E742C20616C69676E2C206174747273203D207B7D29207B5C6E202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74293B5C6E5C6E2020202076617220626F78203D20676574426F756E6473287B5C';
wwv_flow_imp.g_varchar2_table(2628) := '6E202020202020783A20656C656D656E742E782C5C6E202020202020793A20656C656D656E742E792C5C6E20202020202077696474683A20656C656D656E742E77696474682C5C6E2020202020206865696768743A20656C656D656E742E686569676874';
wwv_flow_imp.g_varchar2_table(2629) := '5C6E202020207D2C206174747273293B5C6E5C6E2020202072657475726E2072656E6465724C6162656C28706172656E744766782C2073656D616E7469632E6E616D652C207B5C6E202020202020616C69676E2C5C6E202020202020626F782C5C6E2020';
wwv_flow_imp.g_varchar2_table(2630) := '2020202070616464696E673A20372C5C6E2020202020207374796C653A207B5C6E202020202020202066696C6C3A206765744C6162656C436F6C6F7228656C656D656E742C2064656661756C744C6162656C436F6C6F722C2064656661756C745374726F';
wwv_flow_imp.g_varchar2_table(2631) := '6B65436F6C6F722C2061747472732E7374726F6B65295C6E2020202020207D5C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374696F6E2072656E64657245787465726E616C4C6162656C28706172656E744766782C20656C656D656E742C20';
wwv_flow_imp.g_varchar2_table(2632) := '6174747273203D207B7D29207B5C6E2020202076617220626F78203D207B5C6E20202020202077696474683A2039302C5C6E2020202020206865696768743A2033302C5C6E202020202020783A20656C656D656E742E7769647468202F2032202B20656C';
wwv_flow_imp.g_varchar2_table(2633) := '656D656E742E782C5C6E202020202020793A20656C656D656E742E686569676874202F2032202B20656C656D656E742E795C6E202020207D3B5C6E5C6E2020202072657475726E2072656E6465724C6162656C28706172656E744766782C206765744C61';
wwv_flow_imp.g_varchar2_table(2634) := '62656C28656C656D656E74292C207B5C6E202020202020626F783A20626F782C5C6E202020202020666974426F783A20747275652C5C6E2020202020207374796C653A2061737369676E285C6E20202020202020207B7D2C5C6E20202020202020207465';
wwv_flow_imp.g_varchar2_table(2635) := '787452656E64657265722E67657445787465726E616C5374796C6528292C5C6E20202020202020207B5C6E2020202020202020202066696C6C3A206765744C6162656C436F6C6F7228656C656D656E742C2064656661756C744C6162656C436F6C6F722C';
wwv_flow_imp.g_varchar2_table(2636) := '2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E20202020202020207D5C6E202020202020295C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374696F6E2072656E6465724C616E654C6162656C2870';
wwv_flow_imp.g_varchar2_table(2637) := '6172656E744766782C20746578742C20656C656D656E742C206174747273203D207B7D29207B5C6E20202020766172206973486F72697A6F6E74616C4C616E65203D206973486F72697A6F6E74616C28656C656D656E74293B5C6E5C6E20202020766172';
wwv_flow_imp.g_varchar2_table(2638) := '2074657874426F78203D2072656E6465724C6162656C28706172656E744766782C20746578742C207B5C6E202020202020626F783A207B5C6E20202020202020206865696768743A2033302C5C6E202020202020202077696474683A206973486F72697A';
wwv_flow_imp.g_varchar2_table(2639) := '6F6E74616C4C616E65203F2067657448656967687428656C656D656E742C20617474727329203A20676574576964746828656C656D656E742C206174747273292C5C6E2020202020207D2C5C6E202020202020616C69676E3A202763656E7465722D6D69';
wwv_flow_imp.g_varchar2_table(2640) := '64646C65272C5C6E2020202020207374796C653A207B5C6E202020202020202066696C6C3A206765744C6162656C436F6C6F7228656C656D656E742C2064656661756C744C6162656C436F6C6F722C2064656661756C745374726F6B65436F6C6F722C20';
wwv_flow_imp.g_varchar2_table(2641) := '61747472732E7374726F6B65295C6E2020202020207D5C6E202020207D293B5C6E5C6E20202020696620286973486F72697A6F6E74616C4C616E6529207B5C6E20202020202076617220746F70203D202D31202A2067657448656967687428656C656D65';
wwv_flow_imp.g_varchar2_table(2642) := '6E742C206174747273293B5C6E2020202020207472616E73666F726D2874657874426F782C20302C202D746F702C20323730293B5C6E202020207D5C6E20207D5C6E5C6E202066756E6374696F6E2072656E646572416374697669747928706172656E74';
wwv_flow_imp.g_varchar2_table(2643) := '4766782C20656C656D656E742C206174747273203D207B7D29207B5C6E20202020766172207B5C6E20202020202077696474682C5C6E2020202020206865696768745C6E202020207D203D20676574426F756E647328656C656D656E742C206174747273';
wwv_flow_imp.g_varchar2_table(2644) := '293B5C6E5C6E2020202072657475726E20647261775265637428706172656E744766782C2077696474682C206865696768742C205441534B5F424F524445525F5241444955532C207B5C6E2020202020202E2E2E61747472732C5C6E2020202020206669';
wwv_flow_imp.g_varchar2_table(2645) := '6C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202066696C6C4F7061636974793A2044454641554C545F4F5041434954592C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(2646) := '207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374696F6E2072656E6465';
wwv_flow_imp.g_varchar2_table(2647) := '724173736F63696174696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74293B5C6E5C6E2020202076617220';
wwv_flow_imp.g_varchar2_table(2648) := '66696C6C203D2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B65203D206765745374726F6B65436F6C6F7228656C656D656E74';
wwv_flow_imp.g_varchar2_table(2649) := '2C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65293B5C6E5C6E202020206966202873656D616E7469632E67657428276173736F63696174696F6E446972656374696F6E2729203D3D3D20274F6E6527207C7C5C6E20';
wwv_flow_imp.g_varchar2_table(2650) := '2020202020202073656D616E7469632E67657428276173736F63696174696F6E446972656374696F6E2729203D3D3D2027426F74682729207B5C6E20202020202061747472732E6D61726B6572456E64203D206D61726B657228706172656E744766782C';
wwv_flow_imp.g_varchar2_table(2651) := '20276173736F63696174696F6E2D656E64272C2066696C6C2C207374726F6B65293B5C6E202020207D5C6E5C6E202020206966202873656D616E7469632E67657428276173736F63696174696F6E446972656374696F6E2729203D3D3D2027426F746827';
wwv_flow_imp.g_varchar2_table(2652) := '29207B5C6E20202020202061747472732E6D61726B65725374617274203D206D61726B657228706172656E744766782C20276173736F63696174696F6E2D7374617274272C2066696C6C2C207374726F6B65293B5C6E202020207D5C6E5C6E2020202061';
wwv_flow_imp.g_varchar2_table(2653) := '74747273203D207069636B41747472732861747472732C205B5C6E202020202020276D61726B65725374617274272C5C6E202020202020276D61726B6572456E64275C6E202020205D293B5C6E5C6E2020202072657475726E2064726177436F6E6E6563';
wwv_flow_imp.g_varchar2_table(2654) := '74696F6E5365676D656E747328706172656E744766782C20656C656D656E742E776179706F696E74732C207B5C6E2020202020202E2E2E61747472732C5C6E2020202020207374726F6B652C5C6E2020202020207374726F6B654461736861727261793A';
wwv_flow_imp.g_varchar2_table(2655) := '2027302C2035275C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374696F6E2072656E646572446174614F626A65637428706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E202020207661722066696C6C';
wwv_flow_imp.g_varchar2_table(2656) := '203D2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B65203D206765745374726F6B65436F6C6F7228656C656D656E742C206465';
wwv_flow_imp.g_varchar2_table(2657) := '6661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65293B5C6E5C6E20202020766172207061746844617461203D20706174684D61702E6765745363616C6564506174682827444154415F4F424A4543545F50415448272C207B5C6E';
wwv_flow_imp.g_varchar2_table(2658) := '202020202020785363616C65466163746F723A20312C5C6E202020202020795363616C65466163746F723A20312C5C6E202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C5C6E202020202020636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(2659) := '724865696768743A20656C656D656E742E6865696768742C5C6E202020202020706F736974696F6E3A207B5C6E20202020202020206D783A20302E3437342C5C6E20202020202020206D793A20302E3239365C6E2020202020207D5C6E202020207D293B';
wwv_flow_imp.g_varchar2_table(2660) := '5C6E5C6E2020202076617220646174614F626A656374203D20647261775061746828706172656E744766782C2070617468446174612C207B5C6E20202020202066696C6C2C5C6E20202020202066696C6C4F7061636974793A2044454641554C545F4F50';
wwv_flow_imp.g_varchar2_table(2661) := '41434954592C5C6E2020202020207374726F6B655C6E202020207D293B5C6E5C6E202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74293B5C6E5C6E20202020696620286973436F6C6C656374696F6E287365';
wwv_flow_imp.g_varchar2_table(2662) := '6D616E7469632929207B5C6E20202020202076617220636F6C6C656374696F6E5061746844617461203D20706174684D61702E6765745363616C6564506174682827444154415F4F424A4543545F434F4C4C454354494F4E5F50415448272C207B5C6E20';
wwv_flow_imp.g_varchar2_table(2663) := '20202020202020785363616C65466163746F723A20312C5C6E2020202020202020795363616C65466163746F723A20312C5C6E2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C5C6E202020202020202063';
wwv_flow_imp.g_varchar2_table(2664) := '6F6E7461696E65724865696768743A20656C656D656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E33332C5C6E202020202020202020206D793A2028656C656D656E742E6865';
wwv_flow_imp.g_varchar2_table(2665) := '69676874202D20313829202F20656C656D656E742E6865696768745C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E202020202020647261775061746828706172656E744766782C20636F6C6C656374696F6E50617468446174612C207B';
wwv_flow_imp.g_varchar2_table(2666) := '5C6E20202020202020207374726F6B6557696474683A20322C5C6E202020202020202066696C6C2C5C6E20202020202020207374726F6B655C6E2020202020207D293B5C6E202020207D5C6E5C6E2020202072657475726E20646174614F626A6563743B';
wwv_flow_imp.g_varchar2_table(2667) := '5C6E20207D5C6E5C6E202066756E6374696F6E2072656E6465724576656E7428706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202072657475726E2064726177436972636C6528706172656E744766782C20';
wwv_flow_imp.g_varchar2_table(2668) := '656C656D656E742E77696474682C20656C656D656E742E6865696768742C207B5C6E20202020202066696C6C4F7061636974793A2044454641554C545F4F5041434954592C5C6E2020202020202E2E2E61747472732C5C6E20202020202066696C6C3A20';
wwv_flow_imp.g_varchar2_table(2669) := '67657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E2020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C7453';
wwv_flow_imp.g_varchar2_table(2670) := '74726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374696F6E2072656E6465724761746577617928706172656E744766782C20656C656D656E742C206174747273203D207B7D2920';
wwv_flow_imp.g_varchar2_table(2671) := '7B5C6E2020202072657475726E20647261774469616D6F6E6428706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C207B5C6E20202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D';
wwv_flow_imp.g_varchar2_table(2672) := '656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202066696C6C4F7061636974793A2044454641554C545F4F5041434954592C5C6E2020202020207374726F6B653A206765745374726F6B65436F6C';
wwv_flow_imp.g_varchar2_table(2673) := '6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374696F6E2072656E6465724C616E6528706172656E744766782C20656C656D';
wwv_flow_imp.g_varchar2_table(2674) := '656E742C206174747273203D207B7D29207B5C6E20202020766172206C616E65203D20647261775265637428706172656E744766782C20676574576964746828656C656D656E742C206174747273292C2067657448656967687428656C656D656E742C20';
wwv_flow_imp.g_varchar2_table(2675) := '6174747273292C20302C207B5C6E20202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202066696C6C4F7061636974793A2061';
wwv_flow_imp.g_varchar2_table(2676) := '747472732E66696C6C4F706163697479207C7C2044454641554C545F4F5041434954592C5C6E2020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472';
wwv_flow_imp.g_varchar2_table(2677) := '732E7374726F6B65292C5C6E2020202020207374726F6B6557696474683A20312E355C6E202020207D293B5C6E5C6E202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74293B5C6E5C6E202020206966202869';
wwv_flow_imp.g_varchar2_table(2678) := '732873656D616E7469632C202762706D6E3A4C616E65272929207B5C6E2020202020207661722074657874203D2073656D616E7469632E67657428276E616D6527293B5C6E5C6E20202020202072656E6465724C616E654C6162656C28706172656E7447';
wwv_flow_imp.g_varchar2_table(2679) := '66782C20746578742C20656C656D656E742C206174747273293B5C6E202020207D5C6E5C6E2020202072657475726E206C616E653B5C6E20207D5C6E5C6E202066756E6374696F6E2072656E64657253756250726F6365737328706172656E744766782C';
wwv_flow_imp.g_varchar2_table(2680) := '20656C656D656E742C206174747273203D207B7D29207B5C6E20202020766172206163746976697479203D2072656E646572416374697669747928706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E20202020696620286973';
wwv_flow_imp.g_varchar2_table(2681) := '4576656E7453756250726F6365737328656C656D656E742929207B5C6E202020202020737667417474722861637469766974792C207B5C6E20202020202020207374726F6B654461736861727261793A2027302C20352E35272C5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(2682) := '7374726F6B6557696474683A20322E355C6E2020202020207D293B5C6E202020207D5C6E5C6E2020202076617220657870616E646564203D206973457870616E64656428656C656D656E74293B5C6E5C6E2020202072656E646572456D6265646465644C';
wwv_flow_imp.g_varchar2_table(2683) := '6162656C28706172656E744766782C20656C656D656E742C20657870616E646564203F202763656E7465722D746F7027203A202763656E7465722D6D6964646C65272C206174747273293B5C6E5C6E2020202069662028657870616E64656429207B5C6E';
wwv_flow_imp.g_varchar2_table(2684) := '20202020202072656E6465725461736B4D61726B65727328706172656E744766782C20656C656D656E742C20756E646566696E65642C206174747273293B5C6E202020207D20656C7365207B5C6E20202020202072656E6465725461736B4D61726B6572';
wwv_flow_imp.g_varchar2_table(2685) := '7328706172656E744766782C20656C656D656E742C205B202753756250726F636573734D61726B657227205D2C206174747273293B5C6E202020207D5C6E5C6E2020202072657475726E2061637469766974793B5C6E20207D5C6E5C6E202066756E6374';
wwv_flow_imp.g_varchar2_table(2686) := '696F6E2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E20202020766172206163746976697479203D2072656E646572416374697669747928706172656E744766782C20656C656D65';
wwv_flow_imp.g_varchar2_table(2687) := '6E742C206174747273293B5C6E5C6E2020202072656E646572456D6265646465644C6162656C28706172656E744766782C20656C656D656E742C202763656E7465722D6D6964646C65272C206174747273293B5C6E5C6E2020202072656E646572546173';
wwv_flow_imp.g_varchar2_table(2688) := '6B4D61726B65727328706172656E744766782C20656C656D656E742C20756E646566696E65642C206174747273293B5C6E5C6E2020202072657475726E2061637469766974793B5C6E20207D5C6E5C6E20207661722068616E646C657273203D20746869';
wwv_flow_imp.g_varchar2_table(2689) := '732E68616E646C657273203D207B5C6E202020202762706D6E3A4164486F6353756250726F63657373273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E202020202020696620286973';
wwv_flow_imp.g_varchar2_table(2690) := '457870616E64656428656C656D656E742929207B5C6E20202020202020206174747273203D207069636B41747472732861747472732C205B5C6E202020202020202020202766696C6C272C5C6E20202020202020202020277374726F6B65272C5C6E2020';
wwv_flow_imp.g_varchar2_table(2691) := '2020202020202020277769647468272C5C6E2020202020202020202027686569676874275C6E20202020202020205D293B5C6E2020202020207D20656C7365207B5C6E20202020202020206174747273203D207069636B41747472732861747472732C20';
wwv_flow_imp.g_varchar2_table(2692) := '5B5C6E202020202020202020202766696C6C272C5C6E20202020202020202020277374726F6B65275C6E20202020202020205D293B5C6E2020202020207D5C6E5C6E20202020202072657475726E2072656E64657253756250726F636573732870617265';
wwv_flow_imp.g_varchar2_table(2693) := '6E744766782C20656C656D656E742C206174747273293B5C6E202020207D2C5C6E202020202762706D6E3A4173736F63696174696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C';
wwv_flow_imp.g_varchar2_table(2694) := '6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E20202020202072657475726E2072656E64';
wwv_flow_imp.g_varchar2_table(2695) := '65724173736F63696174696F6E28706172656E744766782C20656C656D656E742C206174747273293B5C6E202020207D2C5C6E202020202762706D6E3A426F756E646172794576656E74273A2066756E6374696F6E28706172656E744766782C20656C65';
wwv_flow_imp.g_varchar2_table(2696) := '6D656E742C206174747273203D207B7D29207B5C6E202020202020766172207B2072656E64657249636F6E203D2074727565207D203D2061747472733B5C6E5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20';
wwv_flow_imp.g_varchar2_table(2697) := '202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E2020202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74292C5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(2698) := '2063616E63656C4163746976697479203D2073656D616E7469632E676574282763616E63656C416374697669747927293B5C6E5C6E2020202020206174747273203D207B5C6E20202020202020207374726F6B6557696474683A20312E352C5C6E202020';
wwv_flow_imp.g_varchar2_table(2699) := '202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E202020202020202066696C6C4F7061636974793A2046554C4C5F4F5041434954592C5C';
wwv_flow_imp.g_varchar2_table(2700) := '6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E2020202020207D3B5C6E5C6E202020202020696620282163';
wwv_flow_imp.g_varchar2_table(2701) := '616E63656C416374697669747929207B5C6E202020202020202061747472732E7374726F6B65446173686172726179203D202736273B5C6E2020202020207D5C6E5C6E202020202020766172206576656E74203D2072656E6465724576656E7428706172';
wwv_flow_imp.g_varchar2_table(2702) := '656E744766782C20656C656D656E742C206174747273293B5C6E5C6E20202020202064726177436972636C6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20494E4E45525F4F555445525F44';
wwv_flow_imp.g_varchar2_table(2703) := '4953542C207B5C6E20202020202020202E2E2E61747472732C5C6E202020202020202066696C6C3A20276E6F6E65275C6E2020202020207D293B5C6E5C6E2020202020206966202872656E64657249636F6E29207B5C6E202020202020202072656E6465';
wwv_flow_imp.g_varchar2_table(2704) := '724576656E7449636F6E28656C656D656E742C20706172656E744766782C206174747273293B5C6E2020202020207D5C6E5C6E20202020202072657475726E206576656E743B5C6E202020207D2C5C6E202020202762706D6E3A427573696E6573735275';
wwv_flow_imp.g_varchar2_table(2705) := '6C655461736B273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C';
wwv_flow_imp.g_varchar2_table(2706) := '272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E202020202020766172207461736B203D2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2707) := '7661722068656164657244617461203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F425553494E4553535F52554C455F4D41494E272C207B5C6E2020202020202020616273706F733A207B5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(2708) := '202020783A20382C5C6E20202020202020202020793A20385C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E20202020202076617220627573696E65737350617468203D20647261775061746828706172656E744766782C206865616465';
wwv_flow_imp.g_varchar2_table(2709) := '7244617461293B5C6E5C6E2020202020207376674174747228627573696E657373506174682C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472';
wwv_flow_imp.g_varchar2_table(2710) := '732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B65';
wwv_flow_imp.g_varchar2_table(2711) := '57696474683A20315C6E2020202020207D293B5C6E5C6E202020202020766172206865616465725061746844617461203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F425553494E4553535F52554C455F484541';
wwv_flow_imp.g_varchar2_table(2712) := '444552272C207B5C6E2020202020202020616273706F733A207B5C6E20202020202020202020783A20382C5C6E20202020202020202020793A20385C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E20202020202076617220627573696E';
wwv_flow_imp.g_varchar2_table(2713) := '65737348656164657250617468203D20647261775061746828706172656E744766782C206865616465725061746844617461293B5C6E5C6E2020202020207376674174747228627573696E657373486561646572506174682C207B5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(2714) := '2066696C6C3A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C';
wwv_flow_imp.g_varchar2_table(2715) := '656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20315C6E2020202020207D293B5C6E5C6E20202020202072657475726E207461736B3B5C6E';
wwv_flow_imp.g_varchar2_table(2716) := '202020207D2C5C6E202020202762706D6E3A43616C6C4163746976697479273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B4174747273';
wwv_flow_imp.g_varchar2_table(2717) := '2861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E20202020202072657475726E2072656E64657253756250726F6365737328706172656E744766782C20';
wwv_flow_imp.g_varchar2_table(2718) := '656C656D656E742C207B5C6E20202020202020207374726F6B6557696474683A20352C5C6E20202020202020202E2E2E61747472735C6E2020202020207D293B5C6E202020207D2C5C6E202020202762706D6E3A436F6D706C657847617465776179273A';
wwv_flow_imp.g_varchar2_table(2719) := '2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E20202020';
wwv_flow_imp.g_varchar2_table(2720) := '20202020277374726F6B65275C6E2020202020205D293B5C6E5C6E2020202020207661722067617465776179203D2072656E6465724761746577617928706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E2020202020207661';
wwv_flow_imp.g_varchar2_table(2721) := '72207061746844617461203D20706174684D61702E6765745363616C6564506174682827474154455741595F434F4D504C4558272C207B5C6E2020202020202020785363616C65466163746F723A20302E352C5C6E2020202020202020795363616C6546';
wwv_flow_imp.g_varchar2_table(2722) := '6163746F723A302E352C5C6E2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2723) := '2020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E34362C5C6E202020202020202020206D793A20302E32365C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E202020202020647261775061746828706172656E';
wwv_flow_imp.g_varchar2_table(2724) := '744766782C2070617468446174612C207B5C6E202020202020202066696C6C3A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(2725) := '207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20315C6E2020202020207D';
wwv_flow_imp.g_varchar2_table(2726) := '293B5C6E5C6E20202020202072657475726E20676174657761793B5C6E202020207D2C5C6E202020202762706D6E3A44617461496E707574273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D2920';
wwv_flow_imp.g_varchar2_table(2727) := '7B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E202020202020766172206172726F77';
wwv_flow_imp.g_varchar2_table(2728) := '5061746844617461203D20706174684D61702E676574526177506174682827444154415F4152524F5727293B5C6E5C6E20202020202076617220646174614F626A656374203D2072656E646572446174614F626A65637428706172656E744766782C2065';
wwv_flow_imp.g_varchar2_table(2729) := '6C656D656E742C206174747273293B5C6E5C6E202020202020647261775061746828706172656E744766782C206172726F7750617468446174612C207B5C6E202020202020202066696C6C3A20276E6F6E65272C5C6E20202020202020207374726F6B65';
wwv_flow_imp.g_varchar2_table(2730) := '3A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20315C6E2020202020207D293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(2731) := '202020202072657475726E20646174614F626A6563743B5C6E202020207D2C5C6E202020202762706D6E3A44617461496E7075744173736F63696174696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273';
wwv_flow_imp.g_varchar2_table(2732) := '203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E2020202020207265';
wwv_flow_imp.g_varchar2_table(2733) := '7475726E2072656E6465724173736F63696174696F6E28706172656E744766782C20656C656D656E742C207B5C6E20202020202020202E2E2E61747472732C5C6E20202020202020206D61726B6572456E643A206D61726B657228706172656E74476678';
wwv_flow_imp.g_varchar2_table(2734) := '2C20276173736F63696174696F6E2D656E64272C2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C206765745374726F6B65436F6C6F7228656C656D656E742C206465';
wwv_flow_imp.g_varchar2_table(2735) := '6661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B6529295C6E2020202020207D293B5C6E202020207D2C5C6E202020202762706D6E3A446174614F626A656374273A2066756E6374696F6E28706172656E744766782C20656C656D';
wwv_flow_imp.g_varchar2_table(2736) := '656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E';
wwv_flow_imp.g_varchar2_table(2737) := '5C6E20202020202072657475726E2072656E646572446174614F626A65637428706172656E744766782C20656C656D656E742C206174747273293B5C6E202020207D2C5C6E202020202762706D6E3A446174614F626A6563745265666572656E6365273A';
wwv_flow_imp.g_varchar2_table(2738) := '206173282762706D6E3A446174614F626A65637427292C5C6E202020202762706D6E3A446174614F7574707574273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174';
wwv_flow_imp.g_varchar2_table(2739) := '747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E202020202020766172206172726F775061746844617461203D20';
wwv_flow_imp.g_varchar2_table(2740) := '706174684D61702E676574526177506174682827444154415F4152524F5727293B5C6E5C6E20202020202076617220646174614F626A656374203D2072656E646572446174614F626A65637428706172656E744766782C20656C656D656E742C20617474';
wwv_flow_imp.g_varchar2_table(2741) := '7273293B5C6E5C6E202020202020647261775061746828706172656E744766782C206172726F7750617468446174612C207B5C6E20202020202020207374726F6B6557696474683A20312C5C6E202020202020202066696C6C3A2067657446696C6C436F';
wwv_flow_imp.g_varchar2_table(2742) := '6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F';
wwv_flow_imp.g_varchar2_table(2743) := '6C6F722C2061747472732E7374726F6B65295C6E2020202020207D293B5C6E5C6E20202020202072657475726E20646174614F626A6563743B5C6E202020207D2C5C6E202020202762706D6E3A446174614F75747075744173736F63696174696F6E273A';
wwv_flow_imp.g_varchar2_table(2744) := '2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E20202020';
wwv_flow_imp.g_varchar2_table(2745) := '20202020277374726F6B65275C6E2020202020205D293B5C6E5C6E20202020202072657475726E2072656E6465724173736F63696174696F6E28706172656E744766782C20656C656D656E742C207B5C6E20202020202020202E2E2E61747472732C5C6E';
wwv_flow_imp.g_varchar2_table(2746) := '20202020202020206D61726B6572456E643A206D61726B657228706172656E744766782C20276173736F63696174696F6E2D656E64272C2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472';
wwv_flow_imp.g_varchar2_table(2747) := '732E66696C6C292C206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B6529295C6E2020202020207D293B5C6E202020207D2C5C6E202020202762706D6E3A4461';
wwv_flow_imp.g_varchar2_table(2748) := '746153746F72655265666572656E6365273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E202020';
wwv_flow_imp.g_varchar2_table(2749) := '20202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E202020202020766172206461746153746F726550617468203D20706174684D61702E6765745363616C6564506174682827444154415F53';
wwv_flow_imp.g_varchar2_table(2750) := '544F5245272C207B5C6E2020202020202020785363616C65466163746F723A20312C5C6E2020202020202020795363616C65466163746F723A20312C5C6E2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C';
wwv_flow_imp.g_varchar2_table(2751) := '5C6E2020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302C5C6E202020202020202020206D793A20302E31';
wwv_flow_imp.g_varchar2_table(2752) := '33335C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E20202020202072657475726E20647261775061746828706172656E744766782C206461746153746F7265506174682C207B5C6E202020202020202066696C6C3A2067657446696C6C';
wwv_flow_imp.g_varchar2_table(2753) := '436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E202020202020202066696C6C4F7061636974793A2044454641554C545F4F5041434954592C5C6E20202020202020207374726F6B65';
wwv_flow_imp.g_varchar2_table(2754) := '3A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20325C6E2020202020207D293B5C6E202020';
wwv_flow_imp.g_varchar2_table(2755) := '207D2C5C6E202020202762706D6E3A456E644576656E74273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E202020202020766172207B2072656E64657249636F6E203D207472756520';
wwv_flow_imp.g_varchar2_table(2756) := '7D203D2061747472733B5C6E5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(2757) := '2020766172206576656E74203D2072656E6465724576656E7428706172656E744766782C20656C656D656E742C207B5C6E20202020202020202E2E2E61747472732C5C6E20202020202020207374726F6B6557696474683A20345C6E2020202020207D29';
wwv_flow_imp.g_varchar2_table(2758) := '3B5C6E5C6E2020202020206966202872656E64657249636F6E29207B5C6E202020202020202072656E6465724576656E7449636F6E28656C656D656E742C20706172656E744766782C206174747273293B5C6E2020202020207D5C6E5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2759) := '72657475726E206576656E743B5C6E202020207D2C5C6E202020202762706D6E3A4576656E74426173656447617465776179273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E202020';
wwv_flow_imp.g_varchar2_table(2760) := '2020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E2020202020207661722073656D616E746963203D20';
wwv_flow_imp.g_varchar2_table(2761) := '67657453656D616E74696328656C656D656E74293B5C6E5C6E202020202020766172206469616D6F6E64203D2072656E6465724761746577617928706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E20202020202064726177';
wwv_flow_imp.g_varchar2_table(2762) := '436972636C6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20656C656D656E742E686569676874202A20302E32302C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F';
wwv_flow_imp.g_varchar2_table(2763) := '7228656C656D656E742C20276E6F6E65272C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E73';
wwv_flow_imp.g_varchar2_table(2764) := '74726F6B65292C5C6E20202020202020207374726F6B6557696474683A20315C6E2020202020207D293B5C6E5C6E2020202020207661722074797065203D2073656D616E7469632E67657428276576656E74476174657761795479706527292C5C6E2020';
wwv_flow_imp.g_varchar2_table(2765) := '2020202020202020696E7374616E7469617465203D20212173656D616E7469632E6765742827696E7374616E746961746527293B5C6E5C6E20202020202066756E6374696F6E20647261774576656E742829207B5C6E5C6E202020202020202076617220';
wwv_flow_imp.g_varchar2_table(2766) := '7061746844617461203D20706174684D61702E6765745363616C6564506174682827474154455741595F4556454E545F4241534544272C207B5C6E20202020202020202020785363616C65466163746F723A20302E31382C5C6E20202020202020202020';
wwv_flow_imp.g_varchar2_table(2767) := '795363616C65466163746F723A20302E31382C5C6E20202020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C5C6E20202020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865';
wwv_flow_imp.g_varchar2_table(2768) := '696768742C5C6E20202020202020202020706F736974696F6E3A207B5C6E2020202020202020202020206D783A20302E33362C5C6E2020202020202020202020206D793A20302E34345C6E202020202020202020207D5C6E20202020202020207D293B5C';
wwv_flow_imp.g_varchar2_table(2769) := '6E5C6E2020202020202020647261775061746828706172656E744766782C2070617468446174612C207B5C6E2020202020202020202066696C6C3A20276E6F6E65272C5C6E202020202020202020207374726F6B653A206765745374726F6B65436F6C6F';
wwv_flow_imp.g_varchar2_table(2770) := '7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E202020202020202020207374726F6B6557696474683A20325C6E20202020202020207D293B5C6E2020202020207D5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(2771) := '2020206966202874797065203D3D3D2027506172616C6C656C2729207B5C6E2020202020202020766172207061746844617461203D20706174684D61702E6765745363616C6564506174682827474154455741595F504152414C4C454C272C207B5C6E20';
wwv_flow_imp.g_varchar2_table(2772) := '202020202020202020785363616C65466163746F723A20302E342C5C6E20202020202020202020795363616C65466163746F723A20302E342C5C6E20202020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C5C';
wwv_flow_imp.g_varchar2_table(2773) := '6E20202020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C5C6E20202020202020202020706F736974696F6E3A207B5C6E2020202020202020202020206D783A20302E3437342C5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(2774) := '202020206D793A20302E3239365C6E202020202020202020207D5C6E20202020202020207D293B5C6E5C6E2020202020202020647261775061746828706172656E744766782C2070617468446174612C207B5C6E2020202020202020202066696C6C3A20';
wwv_flow_imp.g_varchar2_table(2775) := '276E6F6E65272C5C6E202020202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020202020737472';
wwv_flow_imp.g_varchar2_table(2776) := '6F6B6557696474683A20315C6E20202020202020207D293B5C6E2020202020207D20656C7365206966202874797065203D3D3D20274578636C75736976652729207B5C6E20202020202020206966202821696E7374616E746961746529207B5C6E202020';
wwv_flow_imp.g_varchar2_table(2777) := '2020202020202064726177436972636C6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20656C656D656E742E686569676874202A20302E32362C207B5C6E2020202020202020202020206669';
wwv_flow_imp.g_varchar2_table(2778) := '6C6C3A20276E6F6E65272C5C6E2020202020202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(2779) := '20202020207374726F6B6557696474683A20315C6E202020202020202020207D293B5C6E20202020202020207D5C6E5C6E2020202020202020647261774576656E7428293B5C6E2020202020207D5C6E5C6E5C6E20202020202072657475726E20646961';
wwv_flow_imp.g_varchar2_table(2780) := '6D6F6E643B5C6E202020207D2C5C6E202020202762706D6E3A4578636C757369766547617465776179273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E202020202020617474727320';
wwv_flow_imp.g_varchar2_table(2781) := '3D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E2020202020207661722067617465776179203D2072656E64657247617465';
wwv_flow_imp.g_varchar2_table(2782) := '77617928706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C6564506174682827474154455741595F4558434C5553495645272C207B';
wwv_flow_imp.g_varchar2_table(2783) := '5C6E2020202020202020785363616C65466163746F723A20302E342C5C6E2020202020202020795363616C65466163746F723A20302E342C5C6E2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C5C6E2020';
wwv_flow_imp.g_varchar2_table(2784) := '202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E33322C5C6E202020202020202020206D793A20302E335C';
wwv_flow_imp.g_varchar2_table(2785) := '6E20202020202020207D5C6E2020202020207D293B5C6E5C6E202020202020766172206469203D20676574446928656C656D656E74293B5C6E5C6E2020202020206966202864692E676574282769734D61726B657256697369626C65272929207B5C6E20';
wwv_flow_imp.g_varchar2_table(2786) := '20202020202020647261775061746828706172656E744766782C2070617468446174612C207B5C6E2020202020202020202066696C6C3A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C20';
wwv_flow_imp.g_varchar2_table(2787) := '61747472732E7374726F6B65292C5C6E202020202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2788) := '202020207374726F6B6557696474683A20315C6E20202020202020207D293B5C6E2020202020207D5C6E5C6E20202020202072657475726E20676174657761793B5C6E202020207D2C5C6E202020202762706D6E3A47617465776179273A2066756E6374';
wwv_flow_imp.g_varchar2_table(2789) := '696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E20202020202020202773';
wwv_flow_imp.g_varchar2_table(2790) := '74726F6B65275C6E2020202020205D293B5C6E5C6E20202020202072657475726E2072656E6465724761746577617928706172656E744766782C20656C656D656E742C206174747273293B5C6E202020207D2C5C6E202020202762706D6E3A47726F7570';
wwv_flow_imp.g_varchar2_table(2791) := '273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020';
wwv_flow_imp.g_varchar2_table(2792) := '202020202020277374726F6B65272C5C6E2020202020202020277769647468272C5C6E202020202020202027686569676874275C6E2020202020205D293B5C6E5C6E20202020202072657475726E20647261775265637428706172656E744766782C2065';
wwv_flow_imp.g_varchar2_table(2793) := '6C656D656E742E77696474682C20656C656D656E742E6865696768742C205441534B5F424F524445525F5241444955532C207B5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C74';
wwv_flow_imp.g_varchar2_table(2794) := '5374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20312E352C5C6E20202020202020207374726F6B654461736861727261793A202731302C20362C20302C2036272C5C6E202020';
wwv_flow_imp.g_varchar2_table(2795) := '202020202066696C6C3A20276E6F6E65272C5C6E2020202020202020706F696E7465724576656E74733A20276E6F6E65272C5C6E202020202020202077696474683A20676574576964746828656C656D656E742C206174747273292C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2796) := '20206865696768743A2067657448656967687428656C656D656E742C206174747273295C6E2020202020207D293B5C6E202020207D2C5C6E202020202762706D6E3A496E636C757369766547617465776179273A2066756E6374696F6E28706172656E74';
wwv_flow_imp.g_varchar2_table(2797) := '4766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020';
wwv_flow_imp.g_varchar2_table(2798) := '202020205D293B5C6E5C6E2020202020207661722067617465776179203D2072656E6465724761746577617928706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E20202020202064726177436972636C6528706172656E7447';
wwv_flow_imp.g_varchar2_table(2799) := '66782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20656C656D656E742E686569676874202A20302E32342C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C20646566';
wwv_flow_imp.g_varchar2_table(2800) := '61756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B';
wwv_flow_imp.g_varchar2_table(2801) := '65292C5C6E20202020202020207374726F6B6557696474683A20322E355C6E2020202020207D293B5C6E5C6E20202020202072657475726E20676174657761793B5C6E202020207D2C5C6E202020202762706D6E3A496E7465726D656469617465457665';
wwv_flow_imp.g_varchar2_table(2802) := '6E74273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E202020202020766172207B2072656E64657249636F6E203D2074727565207D203D2061747472733B5C6E5C6E20202020202061';
wwv_flow_imp.g_varchar2_table(2803) := '74747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E202020202020766172206F75746572203D2072656E64657245';
wwv_flow_imp.g_varchar2_table(2804) := '76656E7428706172656E744766782C20656C656D656E742C207B5C6E20202020202020202E2E2E61747472732C5C6E20202020202020207374726F6B6557696474683A20312E355C6E2020202020207D293B5C6E5C6E2020202020206472617743697263';
wwv_flow_imp.g_varchar2_table(2805) := '6C6528706172656E744766782C20656C656D656E742E77696474682C20656C656D656E742E6865696768742C20494E4E45525F4F555445525F444953542C207B5C6E202020202020202066696C6C3A20276E6F6E65272C5C6E2020202020202020737472';
wwv_flow_imp.g_varchar2_table(2806) := '6F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20312E355C6E2020202020207D293B';
wwv_flow_imp.g_varchar2_table(2807) := '5C6E5C6E2020202020206966202872656E64657249636F6E29207B5C6E202020202020202072656E6465724576656E7449636F6E28656C656D656E742C20706172656E744766782C206174747273293B5C6E2020202020207D5C6E5C6E20202020202072';
wwv_flow_imp.g_varchar2_table(2808) := '657475726E206F757465723B5C6E202020207D2C5C6E202020202762706D6E3A496E7465726D65646961746543617463684576656E74273A206173282762706D6E3A496E7465726D6564696174654576656E7427292C5C6E202020202762706D6E3A496E';
wwv_flow_imp.g_varchar2_table(2809) := '7465726D6564696174655468726F774576656E74273A206173282762706D6E3A496E7465726D6564696174654576656E7427292C5C6E202020202762706D6E3A4C616E65273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C20';
wwv_flow_imp.g_varchar2_table(2810) := '6174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65272C5C6E202020202020202027776964746827';
wwv_flow_imp.g_varchar2_table(2811) := '2C5C6E202020202020202027686569676874275C6E2020202020205D293B5C6E5C6E20202020202072657475726E2072656E6465724C616E6528706172656E744766782C20656C656D656E742C207B5C6E20202020202020202E2E2E61747472732C5C6E';
wwv_flow_imp.g_varchar2_table(2812) := '202020202020202066696C6C4F7061636974793A204C4F575F4F5041434954595C6E2020202020207D293B5C6E202020207D2C5C6E202020202762706D6E3A4D616E75616C5461736B273A2066756E6374696F6E28706172656E744766782C20656C656D';
wwv_flow_imp.g_varchar2_table(2813) := '656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E';
wwv_flow_imp.g_varchar2_table(2814) := '5C6E202020202020766172207461736B203D2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C656450';
wwv_flow_imp.g_varchar2_table(2815) := '61746828275441534B5F545950455F4D414E55414C272C207B5C6E2020202020202020616273706F733A207B5C6E20202020202020202020783A2031372C5C6E20202020202020202020793A2031355C6E20202020202020207D5C6E2020202020207D29';
wwv_flow_imp.g_varchar2_table(2816) := '3B5C6E5C6E202020202020647261775061746828706172656E744766782C2070617468446174612C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C206174';
wwv_flow_imp.g_varchar2_table(2817) := '7472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F';
wwv_flow_imp.g_varchar2_table(2818) := '6B6557696474683A20302E355C6E2020202020207D293B5C6E5C6E20202020202072657475726E207461736B3B5C6E202020207D2C5C6E202020202762706D6E3A4D657373616765466C6F77273A2066756E6374696F6E28706172656E744766782C2065';
wwv_flow_imp.g_varchar2_table(2819) := '6C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D29';
wwv_flow_imp.g_varchar2_table(2820) := '3B5C6E5C6E2020202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74292C5C6E202020202020202020206469203D20676574446928656C656D656E74293B5C6E5C6E2020202020207661722066696C6C203D20';
wwv_flow_imp.g_varchar2_table(2821) := '67657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E202020202020202020207374726F6B65203D206765745374726F6B65436F6C6F7228656C656D656E742C20646566';
wwv_flow_imp.g_varchar2_table(2822) := '61756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65293B5C6E5C6E2020202020207661722070617468203D2064726177436F6E6E656374696F6E5365676D656E747328706172656E744766782C20656C656D656E742E776179706F69';
wwv_flow_imp.g_varchar2_table(2823) := '6E74732C207B5C6E20202020202020206D61726B6572456E643A206D61726B657228706172656E744766782C20276D657373616765666C6F772D656E64272C2066696C6C2C207374726F6B65292C5C6E20202020202020206D61726B657253746172743A';
wwv_flow_imp.g_varchar2_table(2824) := '206D61726B657228706172656E744766782C20276D657373616765666C6F772D7374617274272C2066696C6C2C207374726F6B65292C5C6E20202020202020207374726F6B652C5C6E20202020202020207374726F6B654461736861727261793A202731';
wwv_flow_imp.g_varchar2_table(2825) := '302C203131272C5C6E20202020202020207374726F6B6557696474683A20312E355C6E2020202020207D293B5C6E5C6E2020202020206966202873656D616E7469632E67657428276D657373616765526566272929207B5C6E2020202020202020766172';
wwv_flow_imp.g_varchar2_table(2826) := '206D6964506F696E74203D20706174682E676574506F696E7441744C656E67746828706174682E676574546F74616C4C656E6774682829202F2032293B5C6E5C6E2020202020202020766172206D61726B65725061746844617461203D20706174684D61';
wwv_flow_imp.g_varchar2_table(2827) := '702E6765745363616C65645061746828274D4553534147455F464C4F575F4D41524B4552272C207B5C6E20202020202020202020616273706F733A207B5C6E202020202020202020202020783A206D6964506F696E742E782C5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(2828) := '202020793A206D6964506F696E742E795C6E202020202020202020207D5C6E20202020202020207D293B5C6E5C6E2020202020202020766172206D6573736167654174747273203D207B5C6E202020202020202020207374726F6B6557696474683A2031';
wwv_flow_imp.g_varchar2_table(2829) := '5C6E20202020202020207D3B5C6E5C6E20202020202020206966202864692E67657428276D65737361676556697369626C654B696E642729203D3D3D2027696E6974696174696E672729207B5C6E202020202020202020206D6573736167654174747273';
wwv_flow_imp.g_varchar2_table(2830) := '2E66696C6C203D2066696C6C3B5C6E202020202020202020206D65737361676541747472732E7374726F6B65203D207374726F6B653B5C6E20202020202020207D20656C7365207B5C6E202020202020202020206D65737361676541747472732E66696C';
wwv_flow_imp.g_varchar2_table(2831) := '6C203D207374726F6B653B5C6E202020202020202020206D65737361676541747472732E7374726F6B65203D2066696C6C3B5C6E20202020202020207D5C6E5C6E2020202020202020766172206D657373616765203D2064726177506174682870617265';
wwv_flow_imp.g_varchar2_table(2832) := '6E744766782C206D61726B657250617468446174612C206D6573736167654174747273293B5C6E5C6E2020202020202020766172206D657373616765526566203D2073656D616E7469632E67657428276D65737361676552656627292C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(2833) := '202020202020206E616D65203D206D6573736167655265662E67657428276E616D6527293B5C6E5C6E2020202020202020766172206C6162656C203D2072656E6465724C6162656C28706172656E744766782C206E616D652C207B5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(2834) := '202020616C69676E3A202763656E7465722D746F70272C5C6E20202020202020202020666974426F783A20747275652C5C6E202020202020202020207374796C653A207B5C6E20202020202020202020202066696C6C3A207374726F6B655C6E20202020';
wwv_flow_imp.g_varchar2_table(2835) := '2020202020207D5C6E20202020202020207D293B5C6E5C6E2020202020202020766172206D657373616765426F756E6473203D206D6573736167652E67657442426F7828292C5C6E2020202020202020202020206C6162656C426F756E6473203D206C61';
wwv_flow_imp.g_varchar2_table(2836) := '62656C2E67657442426F7828293B5C6E5C6E2020202020202020766172207472616E736C61746558203D206D6964506F696E742E78202D206C6162656C426F756E64732E7769647468202F20322C5C6E2020202020202020202020207472616E736C6174';
wwv_flow_imp.g_varchar2_table(2837) := '6559203D206D6964506F696E742E79202B206D657373616765426F756E64732E686569676874202F2032202B20454C454D454E545F4C4142454C5F44495354414E43453B5C6E5C6E20202020202020207472616E73666F726D286C6162656C2C20747261';
wwv_flow_imp.g_varchar2_table(2838) := '6E736C617465582C207472616E736C617465592C2030293B5C6E2020202020207D5C6E5C6E20202020202072657475726E20706174683B5C6E202020207D2C5C6E202020202762706D6E3A506172616C6C656C47617465776179273A2066756E6374696F';
wwv_flow_imp.g_varchar2_table(2839) := '6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E202020202020202027737472';
wwv_flow_imp.g_varchar2_table(2840) := '6F6B65275C6E2020202020205D293B5C6E5C6E202020202020766172206469616D6F6E64203D2072656E6465724761746577617928706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E20202020202076617220706174684461';
wwv_flow_imp.g_varchar2_table(2841) := '7461203D20706174684D61702E6765745363616C6564506174682827474154455741595F504152414C4C454C272C207B5C6E2020202020202020785363616C65466163746F723A20302E362C5C6E2020202020202020795363616C65466163746F723A20';
wwv_flow_imp.g_varchar2_table(2842) := '302E362C5C6E2020202020202020636F6E7461696E657257696474683A20656C656D656E742E77696474682C5C6E2020202020202020636F6E7461696E65724865696768743A20656C656D656E742E6865696768742C5C6E2020202020202020706F7369';
wwv_flow_imp.g_varchar2_table(2843) := '74696F6E3A207B5C6E202020202020202020206D783A20302E34362C5C6E202020202020202020206D793A20302E325C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E202020202020647261775061746828706172656E744766782C2070';
wwv_flow_imp.g_varchar2_table(2844) := '617468446174612C207B5C6E202020202020202066696C6C3A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B65';
wwv_flow_imp.g_varchar2_table(2845) := '3A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20315C6E2020202020207D293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(2846) := '202020202072657475726E206469616D6F6E643B5C6E202020207D2C5C6E202020202762706D6E3A5061727469636970616E74273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020';
wwv_flow_imp.g_varchar2_table(2847) := '202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65272C5C6E2020202020202020277769647468272C5C6E2020202020202020276865696768';
wwv_flow_imp.g_varchar2_table(2848) := '74275C6E2020202020205D293B5C6E5C6E202020202020766172207061727469636970616E74203D2072656E6465724C616E6528706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E20202020202076617220657870616E6465';
wwv_flow_imp.g_varchar2_table(2849) := '645061727469636970616E74203D206973457870616E64656428656C656D656E74293B5C6E20202020202076617220686F72697A6F6E74616C5061727469636970616E74203D206973486F72697A6F6E74616C28656C656D656E74293B5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(2850) := '2020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74292C5C6E202020202020202020206E616D65203D2073656D616E7469632E67657428276E616D6527293B5C6E5C6E20202020202069662028657870616E6465';
wwv_flow_imp.g_varchar2_table(2851) := '645061727469636970616E7429207B5C6E202020202020202076617220776179706F696E7473203D20686F72697A6F6E74616C5061727469636970616E74203F205B5C6E202020202020202020207B5C6E202020202020202020202020783A2033302C5C';
wwv_flow_imp.g_varchar2_table(2852) := '6E202020202020202020202020793A20305C6E202020202020202020207D2C5C6E202020202020202020207B5C6E202020202020202020202020783A2033302C5C6E202020202020202020202020793A2067657448656967687428656C656D656E742C20';
wwv_flow_imp.g_varchar2_table(2853) := '6174747273295C6E202020202020202020207D5C6E20202020202020205D203A205B5C6E202020202020202020207B5C6E202020202020202020202020783A20302C5C6E202020202020202020202020793A2033305C6E202020202020202020207D2C5C';
wwv_flow_imp.g_varchar2_table(2854) := '6E202020202020202020207B5C6E202020202020202020202020783A20676574576964746828656C656D656E742C206174747273292C5C6E202020202020202020202020793A2033305C6E202020202020202020207D5C6E20202020202020205D3B5C6E';
wwv_flow_imp.g_varchar2_table(2855) := '5C6E2020202020202020647261774C696E6528706172656E744766782C20776179706F696E74732C207B5C6E202020202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B6543';
wwv_flow_imp.g_varchar2_table(2856) := '6F6C6F722C2061747472732E7374726F6B65292C5C6E202020202020202020207374726F6B6557696474683A205041525449434950414E545F5354524F4B455F57494454485C6E20202020202020207D293B5C6E5C6E202020202020202072656E646572';
wwv_flow_imp.g_varchar2_table(2857) := '4C616E654C6162656C28706172656E744766782C206E616D652C20656C656D656E742C206174747273293B5C6E2020202020207D20656C7365207B5C6E202020202020202076617220626F756E6473203D20676574426F756E647328656C656D656E742C';
wwv_flow_imp.g_varchar2_table(2858) := '206174747273293B5C6E5C6E20202020202020206966202821686F72697A6F6E74616C5061727469636970616E7429207B5C6E20202020202020202020626F756E64732E686569676874203D20676574576964746828656C656D656E742C206174747273';
wwv_flow_imp.g_varchar2_table(2859) := '293B5C6E20202020202020202020626F756E64732E7769647468203D2067657448656967687428656C656D656E742C206174747273293B5C6E20202020202020207D5C6E5C6E20202020202020207661722074657874426F78203D2072656E6465724C61';
wwv_flow_imp.g_varchar2_table(2860) := '62656C28706172656E744766782C206E616D652C207B5C6E20202020202020202020626F783A20626F756E64732C5C6E20202020202020202020616C69676E3A202763656E7465722D6D6964646C65272C5C6E202020202020202020207374796C653A20';
wwv_flow_imp.g_varchar2_table(2861) := '7B5C6E20202020202020202020202066696C6C3A206765744C6162656C436F6C6F7228656C656D656E742C2064656661756C744C6162656C436F6C6F722C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E2020';
wwv_flow_imp.g_varchar2_table(2862) := '20202020202020207D5C6E20202020202020207D293B5C6E5C6E20202020202020206966202821686F72697A6F6E74616C5061727469636970616E7429207B5C6E2020202020202020202076617220746F70203D202D31202A2067657448656967687428';
wwv_flow_imp.g_varchar2_table(2863) := '656C656D656E742C206174747273293B5C6E202020202020202020207472616E73666F726D2874657874426F782C20302C202D746F702C20323730293B5C6E20202020202020207D5C6E2020202020207D5C6E5C6E2020202020206966202873656D616E';
wwv_flow_imp.g_varchar2_table(2864) := '7469632E67657428277061727469636970616E744D756C7469706C6963697479272929207B5C6E202020202020202072656E6465725461736B4D61726B657228275061727469636970616E744D756C7469706C69636974794D61726B6572272C20706172';
wwv_flow_imp.g_varchar2_table(2865) := '656E744766782C20656C656D656E742C206174747273293B5C6E2020202020207D5C6E5C6E20202020202072657475726E207061727469636970616E743B5C6E202020207D2C5C6E202020202762706D6E3A526563656976655461736B27203A2066756E';
wwv_flow_imp.g_varchar2_table(2866) := '6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(2867) := '277374726F6B65275C6E2020202020205D293B5C6E5C6E2020202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74293B5C6E5C6E202020202020766172207461736B203D2072656E6465725461736B28706172';
wwv_flow_imp.g_varchar2_table(2868) := '656E744766782C20656C656D656E742C206174747273293B5C6E5C6E2020202020207661722070617468446174613B5C6E5C6E2020202020206966202873656D616E7469632E6765742827696E7374616E7469617465272929207B5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(2869) := '2064726177436972636C6528706172656E744766782C2032382C2032382C203230202A20302E32322C207B5C6E2020202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C';
wwv_flow_imp.g_varchar2_table(2870) := '2061747472732E66696C6C292C5C6E202020202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(2871) := '2020207374726F6B6557696474683A20315C6E20202020202020207D293B5C6E5C6E20202020202020207061746844617461203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F494E5354414E54494154494E475F';
wwv_flow_imp.g_varchar2_table(2872) := '53454E44272C207B5C6E20202020202020202020616273706F733A207B5C6E202020202020202020202020783A20372E37372C5C6E202020202020202020202020793A20392E35325C6E202020202020202020207D5C6E20202020202020207D293B5C6E';
wwv_flow_imp.g_varchar2_table(2873) := '2020202020207D20656C7365207B5C6E20202020202020207061746844617461203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F53454E44272C207B5C6E20202020202020202020785363616C65466163746F72';
wwv_flow_imp.g_varchar2_table(2874) := '3A20302E392C5C6E20202020202020202020795363616C65466163746F723A20302E392C5C6E20202020202020202020636F6E7461696E657257696474683A2032312C5C6E20202020202020202020636F6E7461696E65724865696768743A2031342C5C';
wwv_flow_imp.g_varchar2_table(2875) := '6E20202020202020202020706F736974696F6E3A207B5C6E2020202020202020202020206D783A20302E332C5C6E2020202020202020202020206D793A20302E345C6E202020202020202020207D5C6E20202020202020207D293B5C6E2020202020207D';
wwv_flow_imp.g_varchar2_table(2876) := '5C6E5C6E202020202020647261775061746828706172656E744766782C2070617468446174612C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C20617474';
wwv_flow_imp.g_varchar2_table(2877) := '72732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B';
wwv_flow_imp.g_varchar2_table(2878) := '6557696474683A20315C6E2020202020207D293B5C6E5C6E20202020202072657475726E207461736B3B5C6E202020207D2C5C6E202020202762706D6E3A5363726970745461736B273A2066756E6374696F6E28706172656E744766782C20656C656D65';
wwv_flow_imp.g_varchar2_table(2879) := '6E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C';
wwv_flow_imp.g_varchar2_table(2880) := '6E202020202020766172207461736B203D2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C65645061';
wwv_flow_imp.g_varchar2_table(2881) := '746828275441534B5F545950455F534352495054272C207B5C6E2020202020202020616273706F733A207B5C6E20202020202020202020783A2031352C5C6E20202020202020202020793A2032305C6E20202020202020207D5C6E2020202020207D293B';
wwv_flow_imp.g_varchar2_table(2882) := '5C6E5C6E202020202020647261775061746828706172656E744766782C2070617468446174612C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C20617474';
wwv_flow_imp.g_varchar2_table(2883) := '72732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B';
wwv_flow_imp.g_varchar2_table(2884) := '6557696474683A20315C6E2020202020207D293B5C6E5C6E20202020202072657475726E207461736B3B5C6E202020207D2C5C6E202020202762706D6E3A53656E645461736B273A2066756E6374696F6E28706172656E744766782C20656C656D656E74';
wwv_flow_imp.g_varchar2_table(2885) := '2C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(2886) := '2020202020766172207461736B203D2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E202020202020766172207061746844617461203D20706174684D61702E6765745363616C656450617468';
wwv_flow_imp.g_varchar2_table(2887) := '28275441534B5F545950455F53454E44272C207B5C6E2020202020202020785363616C65466163746F723A20312C5C6E2020202020202020795363616C65466163746F723A20312C5C6E2020202020202020636F6E7461696E657257696474683A203231';
wwv_flow_imp.g_varchar2_table(2888) := '2C5C6E2020202020202020636F6E7461696E65724865696768743A2031342C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E3238352C5C6E202020202020202020206D793A20302E3335375C6E202020';
wwv_flow_imp.g_varchar2_table(2889) := '20202020207D5C6E2020202020207D293B5C6E5C6E202020202020647261775061746828706172656E744766782C2070617468446174612C207B5C6E202020202020202066696C6C3A206765745374726F6B65436F6C6F7228656C656D656E742C206465';
wwv_flow_imp.g_varchar2_table(2890) := '6661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B653A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C';
wwv_flow_imp.g_varchar2_table(2891) := '292C5C6E20202020202020207374726F6B6557696474683A20315C6E2020202020207D293B5C6E5C6E20202020202072657475726E207461736B3B5C6E202020207D2C5C6E202020202762706D6E3A53657175656E6365466C6F77273A2066756E637469';
wwv_flow_imp.g_varchar2_table(2892) := '6F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374';
wwv_flow_imp.g_varchar2_table(2893) := '726F6B65275C6E2020202020205D293B5C6E5C6E2020202020207661722066696C6C203D2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(2894) := '207374726F6B65203D206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65293B5C6E5C6E20202020202076617220636F6E6E656374696F6E203D206472617743';
wwv_flow_imp.g_varchar2_table(2895) := '6F6E6E656374696F6E5365676D656E747328706172656E744766782C20656C656D656E742E776179706F696E74732C207B5C6E20202020202020206D61726B6572456E643A206D61726B657228706172656E744766782C202773657175656E6365666C6F';
wwv_flow_imp.g_varchar2_table(2896) := '772D656E64272C2066696C6C2C207374726F6B65292C5C6E20202020202020207374726F6B655C6E2020202020207D293B5C6E5C6E2020202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(2897) := '2020202020766172207B20736F75726365207D203D20656C656D656E743B5C6E5C6E20202020202069662028736F7572636529207B5C6E202020202020202076617220736F7572636553656D616E746963203D2067657453656D616E74696328736F7572';
wwv_flow_imp.g_varchar2_table(2898) := '6365293B5C6E5C6E20202020202020202F2F20636F6E646974696F6E616C20666C6F77206D61726B65725C6E20202020202020206966202873656D616E7469632E6765742827636F6E646974696F6E45787072657373696F6E272920262620697328736F';
wwv_flow_imp.g_varchar2_table(2899) := '7572636553656D616E7469632C202762706D6E3A4163746976697479272929207B5C6E202020202020202020207376674174747228636F6E6E656374696F6E2C207B5C6E2020202020202020202020206D61726B657253746172743A206D61726B657228';
wwv_flow_imp.g_varchar2_table(2900) := '706172656E744766782C2027636F6E646974696F6E616C2D666C6F772D6D61726B6572272C2066696C6C2C207374726F6B65295C6E202020202020202020207D293B5C6E20202020202020207D5C6E5C6E20202020202020202F2F2064656661756C7420';
wwv_flow_imp.g_varchar2_table(2901) := '6D61726B65725C6E202020202020202069662028736F7572636553656D616E7469632E676574282764656661756C7427292026262028697328736F7572636553656D616E7469632C202762706D6E3A476174657761792729207C7C20697328736F757263';
wwv_flow_imp.g_varchar2_table(2902) := '6553656D616E7469632C202762706D6E3A41637469766974792729292026265C6E202020202020202020202020736F7572636553656D616E7469632E676574282764656661756C742729203D3D3D2073656D616E74696329207B5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(2903) := '20207376674174747228636F6E6E656374696F6E2C207B5C6E2020202020202020202020206D61726B657253746172743A206D61726B657228706172656E744766782C2027636F6E646974696F6E616C2D64656661756C742D666C6F772D6D61726B6572';
wwv_flow_imp.g_varchar2_table(2904) := '272C2066696C6C2C207374726F6B65295C6E202020202020202020207D293B5C6E20202020202020207D5C6E2020202020207D5C6E5C6E20202020202072657475726E20636F6E6E656374696F6E3B5C6E202020207D2C5C6E202020202762706D6E3A53';
wwv_flow_imp.g_varchar2_table(2905) := '6572766963655461736B273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E202020202020202027';
wwv_flow_imp.g_varchar2_table(2906) := '66696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E202020202020766172207461736B203D2072656E6465725461736B28706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(2907) := '2020202064726177436972636C6528706172656E744766782C2031302C2031302C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C';
wwv_flow_imp.g_varchar2_table(2908) := '6C292C5C6E20202020202020207374726F6B653A20276E6F6E65272C5C6E20202020202020207472616E73666F726D3A20277472616E736C61746528362C203629275C6E2020202020207D293B5C6E5C6E20202020202076617220706174684461746153';
wwv_flow_imp.g_varchar2_table(2909) := '65727669636531203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F53455256494345272C207B5C6E2020202020202020616273706F733A207B5C6E20202020202020202020783A2031322C5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(2910) := '202020793A2031385C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E202020202020647261775061746828706172656E744766782C20706174684461746153657276696365312C207B5C6E202020202020202066696C6C3A206765744669';
wwv_flow_imp.g_varchar2_table(2911) := '6C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F';
wwv_flow_imp.g_varchar2_table(2912) := '6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20315C6E2020202020207D293B5C6E5C6E20202020202064726177436972636C6528706172656E744766782C2031302C2031302C207B5C';
wwv_flow_imp.g_varchar2_table(2913) := '6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A20276E6F6E65272C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2914) := '20207472616E73666F726D3A20277472616E736C6174652831312C20313029275C6E2020202020207D293B5C6E5C6E2020202020207661722070617468446174615365727669636532203D20706174684D61702E6765745363616C656450617468282754';
wwv_flow_imp.g_varchar2_table(2915) := '41534B5F545950455F53455256494345272C207B5C6E2020202020202020616273706F733A207B5C6E20202020202020202020783A2031372C5C6E20202020202020202020793A2032325C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(2916) := '202020202020647261775061746828706172656E744766782C20706174684461746153657276696365322C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C';
wwv_flow_imp.g_varchar2_table(2917) := '2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E202020202020202073';
wwv_flow_imp.g_varchar2_table(2918) := '74726F6B6557696474683A20315C6E2020202020207D293B5C6E5C6E20202020202072657475726E207461736B3B5C6E202020207D2C5C6E202020202762706D6E3A53746172744576656E74273A2066756E6374696F6E28706172656E744766782C2065';
wwv_flow_imp.g_varchar2_table(2919) := '6C656D656E742C206174747273203D207B7D29207B5C6E202020202020766172207B2072656E64657249636F6E203D2074727565207D203D2061747472733B5C6E5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C';
wwv_flow_imp.g_varchar2_table(2920) := '6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E2020202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74293B5C6E5C6E2020202020';
wwv_flow_imp.g_varchar2_table(2921) := '20696620282173656D616E7469632E67657428276973496E74657272757074696E67272929207B5C6E20202020202020206174747273203D207B5C6E202020202020202020202E2E2E61747472732C5C6E202020202020202020207374726F6B65446173';
wwv_flow_imp.g_varchar2_table(2922) := '6861727261793A202736275C6E20202020202020207D3B5C6E2020202020207D5C6E5C6E202020202020766172206576656E74203D2072656E6465724576656E7428706172656E744766782C20656C656D656E742C206174747273293B5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(2923) := '2020206966202872656E64657249636F6E29207B5C6E202020202020202072656E6465724576656E7449636F6E28656C656D656E742C20706172656E744766782C206174747273293B5C6E2020202020207D5C6E5C6E20202020202072657475726E2065';
wwv_flow_imp.g_varchar2_table(2924) := '76656E743B5C6E202020207D2C5C6E202020202762706D6E3A53756250726F63657373273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E202020202020696620286973457870616E64';
wwv_flow_imp.g_varchar2_table(2925) := '656428656C656D656E742929207B5C6E20202020202020206174747273203D207069636B41747472732861747472732C205B5C6E202020202020202020202766696C6C272C5C6E20202020202020202020277374726F6B65272C5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(2926) := '2020277769647468272C5C6E2020202020202020202027686569676874275C6E20202020202020205D293B5C6E2020202020207D20656C7365207B5C6E20202020202020206174747273203D207069636B41747472732861747472732C205B5C6E202020';
wwv_flow_imp.g_varchar2_table(2927) := '202020202020202766696C6C272C5C6E20202020202020202020277374726F6B65275C6E20202020202020205D293B5C6E2020202020207D5C6E5C6E20202020202072657475726E2072656E64657253756250726F6365737328706172656E744766782C';
wwv_flow_imp.g_varchar2_table(2928) := '20656C656D656E742C206174747273293B5C6E202020207D2C5C6E202020202762706D6E3A5461736B273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E202020202020617474727320';
wwv_flow_imp.g_varchar2_table(2929) := '3D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E20202020202072657475726E2072656E6465725461736B28706172656E74';
wwv_flow_imp.g_varchar2_table(2930) := '4766782C20656C656D656E742C206174747273293B5C6E202020207D2C5C6E202020202762706D6E3A54657874416E6E6F746174696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B';
wwv_flow_imp.g_varchar2_table(2931) := '5C6E2020202020206174747273203D207069636B41747472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65272C5C6E2020202020202020277769647468272C5C6E20202020202020202768';
wwv_flow_imp.g_varchar2_table(2932) := '6569676874275C6E2020202020205D293B5C6E5C6E202020202020766172207B5C6E202020202020202077696474682C5C6E20202020202020206865696768745C6E2020202020207D203D20676574426F756E647328656C656D656E742C206174747273';
wwv_flow_imp.g_varchar2_table(2933) := '293B5C6E5C6E2020202020207661722074657874456C656D656E74203D20647261775265637428706172656E744766782C2077696474682C206865696768742C20302C20302C207B5C6E202020202020202066696C6C3A20276E6F6E65272C5C6E202020';
wwv_flow_imp.g_varchar2_table(2934) := '20202020207374726F6B653A20276E6F6E65275C6E2020202020207D293B5C6E5C6E20202020202076617220746578745061746844617461203D20706174684D61702E6765745363616C6564506174682827544558545F414E4E4F544154494F4E272C20';
wwv_flow_imp.g_varchar2_table(2935) := '7B5C6E2020202020202020785363616C65466163746F723A20312C5C6E2020202020202020795363616C65466163746F723A20312C5C6E2020202020202020636F6E7461696E657257696474683A2077696474682C5C6E2020202020202020636F6E7461';
wwv_flow_imp.g_varchar2_table(2936) := '696E65724865696768743A206865696768742C5C6E2020202020202020706F736974696F6E3A207B5C6E202020202020202020206D783A20302E302C5C6E202020202020202020206D793A20302E305C6E20202020202020207D5C6E2020202020207D29';
wwv_flow_imp.g_varchar2_table(2937) := '3B5C6E5C6E202020202020647261775061746828706172656E744766782C207465787450617468446174612C207B5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B';
wwv_flow_imp.g_varchar2_table(2938) := '65436F6C6F722C2061747472732E7374726F6B65295C6E2020202020207D293B5C6E5C6E2020202020207661722073656D616E746963203D2067657453656D616E74696328656C656D656E74292C5C6E2020202020202020202074657874203D2073656D';
wwv_flow_imp.g_varchar2_table(2939) := '616E7469632E6765742827746578742729207C7C2027273B5C6E5C6E20202020202072656E6465724C6162656C28706172656E744766782C20746578742C207B5C6E2020202020202020616C69676E3A20276C6566742D746F70272C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2940) := '2020626F783A20676574426F756E647328656C656D656E742C206174747273292C5C6E202020202020202070616464696E673A20372C5C6E20202020202020207374796C653A207B5C6E2020202020202020202066696C6C3A206765744C6162656C436F';
wwv_flow_imp.g_varchar2_table(2941) := '6C6F7228656C656D656E742C2064656661756C744C6162656C436F6C6F722C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65295C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E202020202020726574';
wwv_flow_imp.g_varchar2_table(2942) := '75726E2074657874456C656D656E743B5C6E202020207D2C5C6E202020202762706D6E3A5472616E73616374696F6E273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2943) := '696620286973457870616E64656428656C656D656E742929207B5C6E20202020202020206174747273203D207069636B41747472732861747472732C205B5C6E202020202020202020202766696C6C272C5C6E20202020202020202020277374726F6B65';
wwv_flow_imp.g_varchar2_table(2944) := '272C5C6E20202020202020202020277769647468272C5C6E2020202020202020202027686569676874275C6E20202020202020205D293B5C6E2020202020207D20656C7365207B5C6E20202020202020206174747273203D207069636B41747472732861';
wwv_flow_imp.g_varchar2_table(2945) := '747472732C205B5C6E202020202020202020202766696C6C272C5C6E20202020202020202020277374726F6B65275C6E20202020202020205D293B5C6E2020202020207D5C6E5C6E202020202020766172206F75746572203D2072656E64657253756250';
wwv_flow_imp.g_varchar2_table(2946) := '726F6365737328706172656E744766782C20656C656D656E742C207B5C6E20202020202020207374726F6B6557696474683A20312E352C5C6E20202020202020202E2E2E61747472735C6E2020202020207D293B5C6E5C6E20202020202076617220696E';
wwv_flow_imp.g_varchar2_table(2947) := '6E65724174747273203D207374796C65732E7374796C65285B20276E6F2D66696C6C272C20276E6F2D6576656E747327205D2C207B5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C206465666175';
wwv_flow_imp.g_varchar2_table(2948) := '6C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20312E355C6E2020202020207D293B5C6E5C6E20202020202076617220657870616E646564203D206973457870616E6465';
wwv_flow_imp.g_varchar2_table(2949) := '6428656C656D656E74293B5C6E5C6E2020202020206966202821657870616E64656429207B5C6E20202020202020206174747273203D207B7D3B5C6E2020202020207D5C6E5C6E2020202020206472617752656374285C6E202020202020202070617265';
wwv_flow_imp.g_varchar2_table(2950) := '6E744766782C5C6E2020202020202020676574576964746828656C656D656E742C206174747273292C5C6E202020202020202067657448656967687428656C656D656E742C206174747273292C5C6E20202020202020205441534B5F424F524445525F52';
wwv_flow_imp.g_varchar2_table(2951) := '4144495553202D20494E4E45525F4F555445525F444953542C5C6E2020202020202020494E4E45525F4F555445525F444953542C5C6E2020202020202020696E6E657241747472735C6E202020202020293B5C6E5C6E20202020202072657475726E206F';
wwv_flow_imp.g_varchar2_table(2952) := '757465723B5C6E202020207D2C5C6E202020202762706D6E3A557365725461736B273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020202020206174747273203D207069636B4174';
wwv_flow_imp.g_varchar2_table(2953) := '7472732861747472732C205B5C6E20202020202020202766696C6C272C5C6E2020202020202020277374726F6B65275C6E2020202020205D293B5C6E5C6E202020202020766172207461736B203D2072656E6465725461736B28706172656E744766782C';
wwv_flow_imp.g_varchar2_table(2954) := '20656C656D656E742C206174747273293B5C6E5C6E2020202020207661722078203D2031353B5C6E2020202020207661722079203D2031323B5C6E5C6E2020202020207661722070617468446174615573657231203D20706174684D61702E6765745363';
wwv_flow_imp.g_varchar2_table(2955) := '616C65645061746828275441534B5F545950455F555345525F31272C207B5C6E2020202020202020616273706F733A207B5C6E20202020202020202020783A20782C5C6E20202020202020202020793A20795C6E20202020202020207D5C6E2020202020';
wwv_flow_imp.g_varchar2_table(2956) := '207D293B5C6E5C6E202020202020647261775061746828706172656E744766782C20706174684461746155736572312C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C43';
wwv_flow_imp.g_varchar2_table(2957) := '6F6C6F722C2061747472732E66696C6C292C5C6E20202020202020207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020';
wwv_flow_imp.g_varchar2_table(2958) := '202020207374726F6B6557696474683A20302E355C6E2020202020207D293B5C6E5C6E2020202020207661722070617468446174615573657232203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F555345525F32';
wwv_flow_imp.g_varchar2_table(2959) := '272C207B5C6E2020202020202020616273706F733A207B5C6E20202020202020202020783A20782C5C6E20202020202020202020793A20795C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E202020202020647261775061746828706172';
wwv_flow_imp.g_varchar2_table(2960) := '656E744766782C20706174684461746155736572322C207B5C6E202020202020202066696C6C3A2067657446696C6C436F6C6F7228656C656D656E742C2064656661756C7446696C6C436F6C6F722C2061747472732E66696C6C292C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(2961) := '20207374726F6B653A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20302E355C6E20202020';
wwv_flow_imp.g_varchar2_table(2962) := '20207D293B5C6E5C6E2020202020207661722070617468446174615573657233203D20706174684D61702E6765745363616C65645061746828275441534B5F545950455F555345525F33272C207B5C6E2020202020202020616273706F733A207B5C6E20';
wwv_flow_imp.g_varchar2_table(2963) := '202020202020202020783A20782C5C6E20202020202020202020793A20795C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E202020202020647261775061746828706172656E744766782C20706174684461746155736572332C207B5C6E';
wwv_flow_imp.g_varchar2_table(2964) := '202020202020202066696C6C3A206765745374726F6B65436F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B653A206765745374726F6B6543';
wwv_flow_imp.g_varchar2_table(2965) := '6F6C6F7228656C656D656E742C2064656661756C745374726F6B65436F6C6F722C2061747472732E7374726F6B65292C5C6E20202020202020207374726F6B6557696474683A20302E355C6E2020202020207D293B5C6E5C6E2020202020207265747572';
wwv_flow_imp.g_varchar2_table(2966) := '6E207461736B3B5C6E202020207D2C5C6E20202020276C6162656C273A2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E20202020202072657475726E2072656E64657245787465726E61';
wwv_flow_imp.g_varchar2_table(2967) := '6C4C6162656C28706172656E744766782C20656C656D656E742C206174747273293B5C6E202020207D5C6E20207D3B5C6E5C6E20202F2F20657874656E73696F6E204150492C2075736520617420796F7572206F776E207269736B5C6E2020746869732E';
wwv_flow_imp.g_varchar2_table(2968) := '5F6472617750617468203D2064726177506174683B5C6E5C6E2020746869732E5F72656E6465726572203D2072656E64657265723B5C6E7D5C6E5C6E5C6E696E6865726974732842706D6E52656E64657265722C204261736552656E6465726572293B5C';
wwv_flow_imp.g_varchar2_table(2969) := '6E5C6E42706D6E52656E64657265722E24696E6A656374203D205B5C6E202027636F6E6669672E62706D6E52656E6465726572272C5C6E2020276576656E74427573272C5C6E2020277374796C6573272C5C6E202027706174684D6170272C5C6E202027';
wwv_flow_imp.g_varchar2_table(2970) := '63616E766173272C5C6E2020277465787452656E6465726572275C6E5D3B5C6E5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(2971) := '6E42706D6E52656E64657265722E70726F746F747970652E63616E52656E646572203D2066756E6374696F6E28656C656D656E7429207B5C6E202072657475726E20697328656C656D656E742C202762706D6E3A42617365456C656D656E7427293B5C6E';
wwv_flow_imp.g_varchar2_table(2972) := '7D3B5C6E5C6E2F2A2A5C6E202A204472617720736861706520696E746F20706172656E744766782E5C6E202A5C6E202A2040706172616D207B535647456C656D656E747D20706172656E744766785C6E202A2040706172616D207B456C656D656E747D20';
wwv_flow_imp.g_varchar2_table(2973) := '656C656D656E745C6E202A2040706172616D207B41747472737D205B61747472735D5C6E202A5C6E202A204072657475726E207B535647456C656D656E747D206D61696E4766785C6E202A2F5C6E42706D6E52656E64657265722E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(2974) := '2E647261775368617065203D2066756E6374696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020766172207B2074797065207D203D20656C656D656E743B5C6E5C6E20207661722068616E646C657220';
wwv_flow_imp.g_varchar2_table(2975) := '3D20746869732E5F72656E64657265722874797065293B5C6E5C6E202072657475726E2068616E646C657228706172656E744766782C20656C656D656E742C206174747273293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204472617720636F6E6E65637469';
wwv_flow_imp.g_varchar2_table(2976) := '6F6E20696E746F20706172656E744766782E5C6E202A5C6E202A2040706172616D207B535647456C656D656E747D20706172656E744766785C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A2040706172616D207B4174';
wwv_flow_imp.g_varchar2_table(2977) := '7472737D205B61747472735D5C6E202A5C6E202A204072657475726E207B535647456C656D656E747D206D61696E4766785C6E202A2F5C6E42706D6E52656E64657265722E70726F746F747970652E64726177436F6E6E656374696F6E203D2066756E63';
wwv_flow_imp.g_varchar2_table(2978) := '74696F6E28706172656E744766782C20656C656D656E742C206174747273203D207B7D29207B5C6E2020766172207B2074797065207D203D20656C656D656E743B5C6E5C6E20207661722068616E646C6572203D20746869732E5F72656E646572657228';
wwv_flow_imp.g_varchar2_table(2979) := '74797065293B5C6E5C6E202072657475726E2068616E646C657228706172656E744766782C20656C656D656E742C206174747273293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2047657420736861706520706174682E5C6E202A5C6E202A2040706172616D';
wwv_flow_imp.g_varchar2_table(2980) := '207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B737472696E677D20706174685C6E202A2F5C6E42706D6E52656E64657265722E70726F746F747970652E676574536861706550617468203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(2981) := '6E28656C656D656E7429207B5C6E202069662028697328656C656D656E742C202762706D6E3A4576656E74272929207B5C6E2020202072657475726E20676574436972636C655061746828656C656D656E74293B5C6E20207D5C6E5C6E20206966202869';
wwv_flow_imp.g_varchar2_table(2982) := '7328656C656D656E742C202762706D6E3A4163746976697479272929207B5C6E2020202072657475726E20676574526F756E64526563745061746828656C656D656E742C205441534B5F424F524445525F524144495553293B5C6E20207D5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(2983) := '69662028697328656C656D656E742C202762706D6E3A47617465776179272929207B5C6E2020202072657475726E206765744469616D6F6E645061746828656C656D656E74293B5C6E20207D5C6E5C6E202072657475726E206765745265637450617468';
wwv_flow_imp.g_varchar2_table(2984) := '28656C656D656E74293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A205069636B206174747269627574657320696620746865792065786973742E5C6E202A5C6E202A2040706172616D207B4F626A6563747D2061747472735C6E202A2040706172616D207B73';
wwv_flow_imp.g_varchar2_table(2985) := '7472696E675B5D7D206B6579735C6E202A5C6E202A204072657475726E73207B4F626A6563747D5C6E202A2F5C6E66756E6374696F6E207069636B41747472732861747472732C206B657973203D205B5D29207B5C6E202072657475726E206B6579732E';
wwv_flow_imp.g_varchar2_table(2986) := '72656475636528287069636B656441747472732C206B657929203D3E207B5C6E202020206966202861747472735B206B6579205D29207B5C6E2020202020207069636B656441747472735B206B6579205D203D2061747472735B206B6579205D3B5C6E20';
wwv_flow_imp.g_varchar2_table(2987) := '2020207D5C6E5C6E2020202072657475726E207069636B656441747472733B5C6E20207D2C207B7D293B5C6E7D222C222F2A2A5C6E202A204D617020636F6E7461696E696E6720535647207061746873206E65656465642062792042706D6E52656E6465';
wwv_flow_imp.g_varchar2_table(2988) := '7265725C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E20506174684D61702829207B5C6E5C6E20202F2A2A5C6E2020202A20436F6E7461696E732061206D6170206F66207061746820656C656D656E74735C6E2020202A5C6E';
wwv_flow_imp.g_varchar2_table(2989) := '2020202A203C68313E5061746820646566696E6974696F6E3C2F68313E5C6E2020202A204120706172616D65746572697A6564207061746820697320646566696E6564206C696B6520746869733A5C6E2020202A203C7072653E5C6E2020202A20274741';
wwv_flow_imp.g_varchar2_table(2990) := '54455741595F504152414C4C454C273A207B5C6E2020202A202020643A20276D207B6D787D2C7B6D797D207B652E78307D2C3020302C7B652E78317D207B652E78317D2C3020302C7B652E79307D202D7B652E78317D2C3020302C7B652E79317D202720';
wwv_flow_imp.g_varchar2_table(2991) := '2B5C6E20202020202020202020272D7B652E78307D2C3020302C2D7B652E79317D202D7B652E78317D2C3020302C2D7B652E79307D207B652E78317D2C30207A272C5C6E2020202A2020206865696768743A2031372E352C5C6E2020202A202020776964';
wwv_flow_imp.g_varchar2_table(2992) := '74683A202031372E352C5C6E2020202A202020686569676874456C656D656E74733A205B322E352C20372E355D2C5C6E2020202A2020207769647468456C656D656E74733A205B322E352C20372E355D5C6E2020202A207D5C6E2020202A203C2F707265';
wwv_flow_imp.g_varchar2_table(2993) := '3E5C6E2020202A203C703E4974277320696D706F7274616E7420746F2073706563696679206120636F7272656374203C623E68656967687420616E642077696474683C2F623E20666F7220746865207061746820617320746865207363616C696E675C6E';
wwv_flow_imp.g_varchar2_table(2994) := '2020202A206973206261736564206F6E2074686520726174696F206265747765656E20746865207370656369666965642068656967687420616E6420776964746820696E2074686973206F626A65637420616E64207468655C6E2020202A206865696768';
wwv_flow_imp.g_varchar2_table(2995) := '7420616E64207769647468207468617420697320736574206173207363616C652074617267657420284E6F746520782C7920636F6F7264696E617465732077696C6C206265207363616C656420776974685C6E2020202A20696E646976696475616C2072';
wwv_flow_imp.g_varchar2_table(2996) := '6174696F73292E3C2F703E5C6E2020202A203C703E54686520273C623E686569676874456C656D656E74733C2F623E2720616E6420273C623E7769647468456C656D656E74733C2F623E27206172726179206D75737420636F6E7461696E207468652076';
wwv_flow_imp.g_varchar2_table(2997) := '616C75657320746861742077696C6C206265207363616C65642E5C6E2020202A20546865207363616C696E67206973206261736564206F6E2074686520636F6D707574656420726174696F732E5C6E2020202A20436F6F7264696E61746573206F6E2074';
wwv_flow_imp.g_varchar2_table(2998) := '6865207920617869732073686F756C6420626520696E20746865203C623E686569676874456C656D656E743C2F623E27732061727261792C20746865792077696C6C206265207363616C6564207573696E675C6E2020202A2074686520636F6D70757465';
wwv_flow_imp.g_varchar2_table(2999) := '6420726174696F20636F656666696369656E742E5C6E2020202A20496E2074686520706172616D65746572697A6564207061746820746865207363616C65642076616C7565732063616E206265206163636573736564207468726F756768207468652027';
wwv_flow_imp.g_varchar2_table(3000) := '6527206F626A65637420696E207B7D20627261636B6574732E5C6E2020202A2020203C756C3E5C6E2020202A202020203C6C693E5468652076616C75657320666F7220746865207920617869732063616E20626520616363657373656420696E20746865';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(3001) := '207061746820737472696E67207573696E67207B652E79307D2C207B652E79317D2C202E2E2E2E3C2F6C693E5C6E2020202A202020203C6C693E5468652076616C75657320666F7220746865207820617869732063616E20626520616363657373656420';
wwv_flow_imp.g_varchar2_table(3002) := '696E20746865207061746820737472696E67207573696E67207B652E78307D2C207B652E78317D2C202E2E2E2E3C2F6C693E5C6E2020202A2020203C2F756C3E5C6E2020202A202020546865206E756D626572732078302C207831207265737065637469';
wwv_flow_imp.g_varchar2_table(3003) := '76656C792079302C2079312C202E2E2E206D617020746F2074686520636F72726573706F6E64696E6720617272617920696E6465782E5C6E2020202A203C2F703E5C6E2020202A2F5C6E2020746869732E706174684D6170203D207B5C6E202020202745';
wwv_flow_imp.g_varchar2_table(3004) := '56454E545F4D455353414745273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D206C20302C7B652E79317D206C207B652E78317D2C30206C20302C2D7B652E79317D207A206C207B652E78307D2C7B652E79307D206C207B652E78307D';
wwv_flow_imp.g_varchar2_table(3005) := '2C2D7B652E79307D272C5C6E2020202020206865696768743A2033362C5C6E20202020202077696474683A202033362C5C6E202020202020686569676874456C656D656E74733A205B20362C203134205D2C5C6E2020202020207769647468456C656D65';
wwv_flow_imp.g_varchar2_table(3006) := '6E74733A205B2031302E352C203231205D5C6E202020207D2C5C6E20202020274556454E545F5349474E414C273A207B5C6E202020202020643A20274D207B6D787D2C7B6D797D206C207B652E78307D2C7B652E79307D206C202D7B652E78317D2C3020';
wwv_flow_imp.g_varchar2_table(3007) := '5A272C5C6E2020202020206865696768743A2033362C5C6E20202020202077696474683A2033362C5C6E202020202020686569676874456C656D656E74733A205B203138205D2C5C6E2020202020207769647468456C656D656E74733A205B2031302C20';
wwv_flow_imp.g_varchar2_table(3008) := '3230205D5C6E202020207D2C5C6E20202020274556454E545F455343414C4154494F4E273A207B5C6E202020202020643A20274D207B6D787D2C7B6D797D206C207B652E78307D2C7B652E79307D206C202D7B652E78307D2C2D7B652E79317D206C202D';
wwv_flow_imp.g_varchar2_table(3009) := '7B652E78307D2C7B652E79317D205A272C5C6E2020202020206865696768743A2033362C5C6E20202020202077696474683A2033362C5C6E202020202020686569676874456C656D656E74733A205B2032302C2037205D2C5C6E20202020202077696474';
wwv_flow_imp.g_varchar2_table(3010) := '68456C656D656E74733A205B2038205D5C6E202020207D2C5C6E20202020274556454E545F434F4E444954494F4E414C273A207B5C6E202020202020643A20274D207B652E78307D2C7B652E79307D206C207B652E78317D2C30206C20302C7B652E7932';
wwv_flow_imp.g_varchar2_table(3011) := '7D206C202D7B652E78317D2C30205A2027202B5C6E202020202020202020274D207B652E78327D2C7B652E79337D206C207B652E78307D2C302027202B5C6E202020202020202020274D207B652E78327D2C7B652E79347D206C207B652E78307D2C3020';
wwv_flow_imp.g_varchar2_table(3012) := '27202B5C6E202020202020202020274D207B652E78327D2C7B652E79357D206C207B652E78307D2C302027202B5C6E202020202020202020274D207B652E78327D2C7B652E79367D206C207B652E78307D2C302027202B5C6E202020202020202020274D';
wwv_flow_imp.g_varchar2_table(3013) := '207B652E78327D2C7B652E79377D206C207B652E78307D2C302027202B5C6E202020202020202020274D207B652E78327D2C7B652E79387D206C207B652E78307D2C3020272C5C6E2020202020206865696768743A2033362C5C6E202020202020776964';
wwv_flow_imp.g_varchar2_table(3014) := '74683A202033362C5C6E202020202020686569676874456C656D656E74733A205B20382E352C2031342E352C2031382C2031312E352C2031342E352C2031372E352C2032302E352C2032332E352C2032362E35205D2C5C6E202020202020776964746845';
wwv_flow_imp.g_varchar2_table(3015) := '6C656D656E74733A20205B2031302E352C2031342E352C2031322E35205D5C6E202020207D2C5C6E20202020274556454E545F4C494E4B273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D20302C7B652E79307D202D7B652E78317D2C';
wwv_flow_imp.g_varchar2_table(3016) := '3020302C7B652E79317D207B652E78317D2C3020302C7B652E79307D207B652E78307D2C2D7B652E79327D202D7B652E78307D2C2D7B652E79327D207A272C5C6E2020202020206865696768743A2033362C5C6E20202020202077696474683A2033362C';
wwv_flow_imp.g_varchar2_table(3017) := '5C6E202020202020686569676874456C656D656E74733A205B20342E343337352C20362E37352C20372E38313235205D2C5C6E2020202020207769647468456C656D656E74733A205B20392E38343337352C2031332E35205D5C6E202020207D2C5C6E20';
wwv_flow_imp.g_varchar2_table(3018) := '202020274556454E545F4552524F52273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D207B652E78307D2C2D7B652E79307D207B652E78317D2C2D7B652E79317D207B652E78327D2C7B652E79327D207B652E78337D2C2D7B652E7933';
wwv_flow_imp.g_varchar2_table(3019) := '7D202D7B652E78347D2C7B652E79347D202D7B652E78357D2C2D7B652E79357D207A272C5C6E2020202020206865696768743A2033362C5C6E20202020202077696474683A2033362C5C6E202020202020686569676874456C656D656E74733A205B2030';
wwv_flow_imp.g_varchar2_table(3020) := '2E3032332C20382E3733372C20382E3135312C2031362E3536342C2031302E3539312C20382E373134205D2C5C6E2020202020207769647468456C656D656E74733A205B20302E3038352C20362E3637322C20362E39372C20342E3237332C20352E3333';
wwv_flow_imp.g_varchar2_table(3021) := '372C20362E363336205D5C6E202020207D2C5C6E20202020274556454E545F43414E43454C5F3435273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D202D7B652E78317D2C3020302C7B652E78307D207B652E78317D2C3020302C7B65';
wwv_flow_imp.g_varchar2_table(3022) := '2E79317D207B652E78307D2C302027202B5C6E202020202020202027302C2D7B652E79317D207B652E78317D2C3020302C2D7B652E79307D202D7B652E78317D2C3020302C2D7B652E79317D202D7B652E78307D2C30207A272C5C6E2020202020206865';
wwv_flow_imp.g_varchar2_table(3023) := '696768743A2033362C5C6E20202020202077696474683A2033362C5C6E202020202020686569676874456C656D656E74733A205B20342E37352C20382E35205D2C5C6E2020202020207769647468456C656D656E74733A205B20342E37352C20382E3520';
wwv_flow_imp.g_varchar2_table(3024) := '5D5C6E202020207D2C5C6E20202020274556454E545F434F4D50454E534154494F4E273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D207B652E78307D2C2D7B652E79307D20302C7B652E79317D207A206D207B652E78317D2C2D7B65';
wwv_flow_imp.g_varchar2_table(3025) := '2E79327D207B652E78327D2C2D7B652E79337D20302C7B652E79317D202D7B652E78327D2C2D7B652E79337D207A272C5C6E2020202020206865696768743A2033362C5C6E20202020202077696474683A2033362C5C6E20202020202068656967687445';
wwv_flow_imp.g_varchar2_table(3026) := '6C656D656E74733A205B20362E352C2031332C20302E342C20362E31205D2C5C6E2020202020207769647468456C656D656E74733A205B20392C20392E332C20382E37205D5C6E202020207D2C5C6E20202020274556454E545F54494D45525F5748273A';
wwv_flow_imp.g_varchar2_table(3027) := '207B5C6E202020202020643A20274D207B6D787D2C7B6D797D206C207B652E78307D2C2D7B652E79307D206D202D7B652E78307D2C7B652E79307D206C207B652E78317D2C7B652E79317D20272C5C6E2020202020206865696768743A2033362C5C6E20';
wwv_flow_imp.g_varchar2_table(3028) := '202020202077696474683A202033362C5C6E202020202020686569676874456C656D656E74733A205B2031302C2032205D2C5C6E2020202020207769647468456C656D656E74733A205B20332C2037205D5C6E202020207D2C5C6E20202020274556454E';
wwv_flow_imp.g_varchar2_table(3029) := '545F54494D45525F4C494E45273A207B5C6E202020202020643A2020274D207B6D787D2C7B6D797D2027202B5C6E20202020202020202020276D207B652E78307D2C7B652E79307D206C202D7B652E78317D2C7B652E79317D20272C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(3030) := '6865696768743A2033362C5C6E20202020202077696474683A202033362C5C6E202020202020686569676874456C656D656E74733A205B2031302C2033205D2C5C6E2020202020207769647468456C656D656E74733A205B20302C2030205D5C6E202020';
wwv_flow_imp.g_varchar2_table(3031) := '207D2C5C6E20202020274556454E545F4D554C5449504C45273A207B5C6E202020202020643A276D207B6D787D2C7B6D797D207B652E78317D2C2D7B652E79307D207B652E78317D2C7B652E79307D202D7B652E78307D2C7B652E79317D202D7B652E78';
wwv_flow_imp.g_varchar2_table(3032) := '327D2C30207A272C5C6E2020202020206865696768743A2033362C5C6E20202020202077696474683A202033362C5C6E202020202020686569676874456C656D656E74733A205B20362E32383039392C2031322E3536313939205D2C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(3033) := '7769647468456C656D656E74733A205B20332E313430352C20392E34323134392C2031322E3536313938205D5C6E202020207D2C5C6E20202020274556454E545F504152414C4C454C5F4D554C5449504C45273A207B5C6E202020202020643A276D207B';
wwv_flow_imp.g_varchar2_table(3034) := '6D787D2C7B6D797D207B652E78307D2C3020302C7B652E79317D207B652E78317D2C3020302C7B652E79307D202D7B652E78317D2C3020302C7B652E79317D2027202B5C6E2020202020202020272D7B652E78307D2C3020302C2D7B652E79317D202D7B';
wwv_flow_imp.g_varchar2_table(3035) := '652E78317D2C3020302C2D7B652E79307D207B652E78317D2C30207A272C5C6E2020202020206865696768743A2033362C5C6E20202020202077696474683A202033362C5C6E202020202020686569676874456C656D656E74733A205B20322E35363232';
wwv_flow_imp.g_varchar2_table(3036) := '382C20372E3638363833205D2C5C6E2020202020207769647468456C656D656E74733A205B20322E35363232382C20372E3638363833205D5C6E202020207D2C5C6E2020202027474154455741595F4558434C5553495645273A207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(3037) := '643A276D207B6D787D2C7B6D797D207B652E78307D2C7B652E79307D207B652E78317D2C7B652E79307D207B652E78327D2C30207B652E78347D2C7B652E79327D2027202B5C6E2020202020202020202020202020202020202020277B652E78347D2C7B';
wwv_flow_imp.g_varchar2_table(3038) := '652E79317D207B652E78327D2C30207B652E78317D2C7B652E79337D207B652E78307D2C7B652E79337D2027202B5C6E2020202020202020202020202020202020202020277B652E78337D2C30207B652E78357D2C7B652E79317D207B652E78357D2C7B';
wwv_flow_imp.g_varchar2_table(3039) := '652E79327D207B652E78337D2C30207A272C5C6E2020202020206865696768743A2031372E352C5C6E20202020202077696474683A202031372E352C5C6E202020202020686569676874456C656D656E74733A205B20382E352C20362E353331322C202D';
wwv_flow_imp.g_varchar2_table(3040) := '362E353331322C202D382E35205D2C5C6E2020202020207769647468456C656D656E74733A20205B20362E352C202D362E352C20332C202D332C20352C202D35205D5C6E202020207D2C5C6E2020202027474154455741595F504152414C4C454C273A20';
wwv_flow_imp.g_varchar2_table(3041) := '7B5C6E202020202020643A276D207B6D787D2C7B6D797D20302C7B652E79317D202D7B652E78317D2C3020302C7B652E79307D207B652E78317D2C3020302C7B652E79317D207B652E78307D2C302027202B5C6E202020202020202027302C2D7B652E79';
wwv_flow_imp.g_varchar2_table(3042) := '317D207B652E78317D2C3020302C2D7B652E79307D202D7B652E78317D2C3020302C2D7B652E79317D202D7B652E78307D2C30207A272C5C6E2020202020206865696768743A2033302C5C6E20202020202077696474683A202033302C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(3043) := '20686569676874456C656D656E74733A205B20352C2031322E35205D2C5C6E2020202020207769647468456C656D656E74733A205B20352C2031322E35205D5C6E202020207D2C5C6E2020202027474154455741595F4556454E545F4241534544273A20';
wwv_flow_imp.g_varchar2_table(3044) := '7B5C6E202020202020643A276D207B6D787D2C7B6D797D207B652E78307D2C7B652E79307D207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79327D207B652E78327D2C30207A272C5C6E2020202020206865696768743A2031312C5C6E20';
wwv_flow_imp.g_varchar2_table(3045) := '202020202077696474683A202031312C5C6E202020202020686569676874456C656D656E74733A205B202D362C20362C2031322C202D3132205D2C5C6E2020202020207769647468456C656D656E74733A205B20392C202D332C202D3132205D5C6E2020';
wwv_flow_imp.g_varchar2_table(3046) := '20207D2C5C6E2020202027474154455741595F434F4D504C4558273A207B5C6E202020202020643A276D207B6D787D2C7B6D797D20302C7B652E79307D202D7B652E78307D2C2D7B652E79317D202D7B652E78317D2C7B652E79327D207B652E78307D2C';
wwv_flow_imp.g_varchar2_table(3047) := '7B652E79317D202D7B652E78327D2C3020302C7B652E79337D2027202B5C6E2020202020202020277B652E78327D2C3020202D7B652E78307D2C7B652E79317D206C207B652E78317D2C7B652E79327D207B652E78307D2C2D7B652E79317D20302C7B65';
wwv_flow_imp.g_varchar2_table(3048) := '2E79307D207B652E78337D2C3020302C2D7B652E79307D207B652E78307D2C7B652E79317D2027202B5C6E2020202020202020277B652E78317D2C2D7B652E79327D202D7B652E78307D2C2D7B652E79317D207B652E78327D2C3020302C2D7B652E7933';
wwv_flow_imp.g_varchar2_table(3049) := '7D202D7B652E78327D2C30207B652E78307D2C2D7B652E79317D202D7B652E78317D2C2D7B652E79327D2027202B5C6E2020202020202020272D7B652E78307D2C7B652E79317D20302C2D7B652E79307D202D7B652E78337D2C30207A272C5C6E202020';
wwv_flow_imp.g_varchar2_table(3050) := '2020206865696768743A2031372E3132352C5C6E20202020202077696474683A202031372E3132352C5C6E202020202020686569676874456C656D656E74733A205B20342E3837352C20332E343337352C20322E3132352C2033205D2C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(3051) := '207769647468456C656D656E74733A205B20332E343337352C20322E3132352C20342E3837352C2033205D5C6E202020207D2C5C6E2020202027444154415F4F424A4543545F50415448273A207B5C6E202020202020643A276D20302C30207B652E7831';
wwv_flow_imp.g_varchar2_table(3052) := '7D2C30207B652E78307D2C7B652E79307D20302C7B652E79317D202D7B652E78327D2C3020302C2D7B652E79327D207B652E78317D2C3020302C7B652E79307D207B652E78307D2C30272C5C6E2020202020206865696768743A2036312C5C6E20202020';
wwv_flow_imp.g_varchar2_table(3053) := '202077696474683A202035312C5C6E202020202020686569676874456C656D656E74733A205B2031302C2035302C203630205D2C5C6E2020202020207769647468456C656D656E74733A205B2031302C2034302C2035302C203630205D5C6E202020207D';
wwv_flow_imp.g_varchar2_table(3054) := '2C5C6E2020202027444154415F4F424A4543545F434F4C4C454354494F4E5F50415448273A207B5C6E202020202020643A20276D7B6D787D2C7B6D797D206D20332C32206C20302C3130206D20332C2D3130206C20302C3130206D20332C2D3130206C20';
wwv_flow_imp.g_varchar2_table(3055) := '302C3130272C5C6E2020202020206865696768743A2031302C5C6E20202020202077696474683A2031302C5C6E202020202020686569676874456C656D656E74733A205B5D2C5C6E2020202020207769647468456C656D656E74733A205B5D5C6E202020';
wwv_flow_imp.g_varchar2_table(3056) := '207D2C5C6E2020202027444154415F4152524F57273A207B5C6E202020202020643A276D20352C3920392C3020302C2D3320352C35202D352C3520302C2D33202D392C30207A272C5C6E2020202020206865696768743A2036312C5C6E20202020202077';
wwv_flow_imp.g_varchar2_table(3057) := '696474683A202035312C5C6E202020202020686569676874456C656D656E74733A205B5D2C5C6E2020202020207769647468456C656D656E74733A205B5D5C6E202020207D2C5C6E2020202027444154415F53544F5245273A207B5C6E20202020202064';
wwv_flow_imp.g_varchar2_table(3058) := '3A276D20207B6D787D2C7B6D797D2027202B5C6E2020202020202020276C2020302C7B652E79327D2027202B5C6E2020202020202020276320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D20207B652E78327D2C302027202B5C';
wwv_flow_imp.g_varchar2_table(3059) := '6E2020202020202020276C2020302C2D7B652E79327D2027202B5C6E20202020202020202763202D7B652E78307D2C2D7B652E79317D202D7B652E78317D2C2D7B652E79317D202D7B652E78327D2C3027202B5C6E2020202020202020276320207B652E';
wwv_flow_imp.g_varchar2_table(3060) := '78307D2C7B652E79317D207B652E78317D2C7B652E79317D20207B652E78327D2C302027202B5C6E2020202020202020276D20202D7B652E78327D2C7B652E79307D27202B5C6E2020202020202020276320207B652E78307D2C7B652E79317D207B652E';
wwv_flow_imp.g_varchar2_table(3061) := '78317D2C7B652E79317D207B652E78327D2C3027202B5C6E2020202020202020276D20202D7B652E78327D2C7B652E79307D27202B5C6E2020202020202020276320207B652E78307D2C7B652E79317D207B652E78317D2C7B652E79317D20207B652E78';
wwv_flow_imp.g_varchar2_table(3062) := '327D2C30272C5C6E2020202020206865696768743A2036312C5C6E20202020202077696474683A202036312C5C6E202020202020686569676874456C656D656E74733A205B20372C2031302C203435205D2C5C6E2020202020207769647468456C656D65';
wwv_flow_imp.g_varchar2_table(3063) := '6E74733A20205B20322C2035382C203630205D5C6E202020207D2C5C6E2020202027544558545F414E4E4F544154494F4E273A207B5C6E202020202020643A20276D207B6D787D2C207B6D797D206D2031302C30206C202D31302C30206C20302C7B652E';
wwv_flow_imp.g_varchar2_table(3064) := '79307D206C2031302C30272C5C6E2020202020206865696768743A2033302C5C6E20202020202077696474683A2031302C5C6E202020202020686569676874456C656D656E74733A205B203330205D2C5C6E2020202020207769647468456C656D656E74';
wwv_flow_imp.g_varchar2_table(3065) := '733A205B203130205D5C6E202020207D2C5C6E20202020274D41524B45525F5355425F50524F43455353273A207B5C6E202020202020643A20276D7B6D787D2C7B6D797D206D20372C32206C20302C3130206D202D352C2D35206C2031302C30272C5C6E';
wwv_flow_imp.g_varchar2_table(3066) := '2020202020206865696768743A2031302C5C6E20202020202077696474683A2031302C5C6E202020202020686569676874456C656D656E74733A205B5D2C5C6E2020202020207769647468456C656D656E74733A205B5D5C6E202020207D2C5C6E202020';
wwv_flow_imp.g_varchar2_table(3067) := '20274D41524B45525F504152414C4C454C273A207B5C6E202020202020643A20276D7B6D787D2C7B6D797D206D20332C32206C20302C3130206D20332C2D3130206C20302C3130206D20332C2D3130206C20302C3130272C5C6E20202020202068656967';
wwv_flow_imp.g_varchar2_table(3068) := '68743A2031302C5C6E20202020202077696474683A2031302C5C6E202020202020686569676874456C656D656E74733A205B5D2C5C6E2020202020207769647468456C656D656E74733A205B5D5C6E202020207D2C5C6E20202020274D41524B45525F53';
wwv_flow_imp.g_varchar2_table(3069) := '455155454E5449414C273A207B5C6E202020202020643A20276D7B6D787D2C7B6D797D206D20302C33206C2031302C30206D202D31302C33206C2031302C30206D202D31302C33206C2031302C30272C5C6E2020202020206865696768743A2031302C5C';
wwv_flow_imp.g_varchar2_table(3070) := '6E20202020202077696474683A2031302C5C6E202020202020686569676874456C656D656E74733A205B5D2C5C6E2020202020207769647468456C656D656E74733A205B5D5C6E202020207D2C5C6E20202020274D41524B45525F434F4D50454E534154';
wwv_flow_imp.g_varchar2_table(3071) := '494F4E273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D20372C2D3520302C3130207A206D20372E312C2D302E3320362E392C2D342E3720302C3130202D362E392C2D342E37207A272C5C6E2020202020206865696768743A2031302C';
wwv_flow_imp.g_varchar2_table(3072) := '5C6E20202020202077696474683A2032312C5C6E202020202020686569676874456C656D656E74733A205B5D2C5C6E2020202020207769647468456C656D656E74733A205B5D5C6E202020207D2C5C6E20202020274D41524B45525F4C4F4F50273A207B';
wwv_flow_imp.g_varchar2_table(3073) := '5C6E202020202020643A20276D207B6D787D2C7B6D797D206320332E3532363937392C3020362E3338363136312C2D322E38323938353820362E3338363136312C2D362E33323036363120302C2D332E343930383036202D322E3835393138322C2D362E';
wwv_flow_imp.g_varchar2_table(3074) := '3332303636312027202B5C6E2020202020202020272D362E3338363136312C2D362E333230363631202D332E3532363937382C30202D362E33383631362C322E383239383535202D362E33383631362C362E33323036363120302C312E37343534303220';
wwv_flow_imp.g_varchar2_table(3075) := '27202B5C6E202020202020202027302E3731343739372C332E33323535363720312E3837303436332C342E34363933383120302E3537373833342C302E35373139303820312E3236353838352C312E30333437323820322E3032393931362C312E333534';
wwv_flow_imp.g_varchar2_table(3076) := '35372027202B5C6E2020202020202020276C202D302E3731383136332C2D332E393039373933206D20302E3731383136332C332E393039373933202D332E3838353231312C302E383032393032272C5C6E2020202020206865696768743A2031332E392C';
wwv_flow_imp.g_varchar2_table(3077) := '5C6E20202020202077696474683A2031332E372C5C6E202020202020686569676874456C656D656E74733A205B5D2C5C6E2020202020207769647468456C656D656E74733A205B5D5C6E202020207D2C5C6E20202020274D41524B45525F4144484F4327';
wwv_flow_imp.g_varchar2_table(3078) := '3A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D206D20302E38343436312C322E3634343131206320312E30353533332C2D312E323337383039393620322E36343333372C2D322E303738383220342E32393635332C2D312E3937393937';
wwv_flow_imp.g_varchar2_table(3079) := '39393620322E30353136332C302E303830352027202B5C6E202020202020202027332E38353537392C312E313538303320352E37363038322C312E373931303720312E30363338352C302E333431333939393620322E32343435342C302E313433382033';
wwv_flow_imp.g_varchar2_table(3080) := '2E31383735392C2D302E343337363720302E36313734332C2D302E33333634322027202B5C6E202020202020202027312E323737352C2D302E363430373820312E373534322C2D312E313735313120302C302E353630323320302C312E31323034362030';
wwv_flow_imp.g_varchar2_table(3081) := '2C312E36383037202D302E39383730362C302E3936323337393936202D322E32393739322C312E36323339333939362027202B5C6E2020202020202020272D332E363931382C312E3636313831393936202D312E32343435392C302E30393237202D322E';
wwv_flow_imp.g_varchar2_table(3082) := '34363637312C2D302E32343931202D332E35393530352C2D302E3734383132202D312E33353738392C2D302E35353936352027202B5C6E2020202020202020272D322E37353133332C2D312E3333343336393936202D342E32373032372C2D312E313831';
wwv_flow_imp.g_varchar2_table(3083) := '3231393936202D312E33373734312C302E3134363031202D322E34313834322C312E3133363835393936202D332E34343238382C312E3936373832393936207A272C5C6E2020202020206865696768743A20342C5C6E20202020202077696474683A2031';
wwv_flow_imp.g_varchar2_table(3084) := '352C5C6E202020202020686569676874456C656D656E74733A205B5D2C5C6E2020202020207769647468456C656D656E74733A205B5D5C6E202020207D2C5C6E20202020275441534B5F545950455F53454E44273A207B5C6E202020202020643A20276D';
wwv_flow_imp.g_varchar2_table(3085) := '207B6D787D2C7B6D797D206C20302C7B652E79317D206C207B652E78317D2C30206C20302C2D7B652E79317D207A206C207B652E78307D2C7B652E79307D206C207B652E78307D2C2D7B652E79307D272C5C6E2020202020206865696768743A2031342C';
wwv_flow_imp.g_varchar2_table(3086) := '5C6E20202020202077696474683A202032312C5C6E202020202020686569676874456C656D656E74733A205B20362C203134205D2C5C6E2020202020207769647468456C656D656E74733A205B2031302E352C203231205D5C6E202020207D2C5C6E2020';
wwv_flow_imp.g_varchar2_table(3087) := '2020275441534B5F545950455F534352495054273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D206320392E3936363535332C2D362E3237323736202D382E3030303932362C2D372E393139333220322E3936383936382C2D31342E39';
wwv_flow_imp.g_varchar2_table(3088) := '3338206C202D382E3830323732382C302027202B5C6E20202020202020202763202D31302E3936393839342C372E303138363820362E3939373538352C382E3636353234202D322E3936383936372C31342E393338207A2027202B5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(3089) := '20276D202D372C2D3132206C20352C302027202B5C6E2020202020202020276D202D342E352C33206C20342E352C302027202B5C6E2020202020202020276D202D332C33206C20352C3027202B5C6E2020202020202020276D202D342C33206C20352C30';
wwv_flow_imp.g_varchar2_table(3090) := '272C5C6E2020202020206865696768743A2031352C5C6E20202020202077696474683A202031322E362C5C6E202020202020686569676874456C656D656E74733A205B20362C203134205D2C5C6E2020202020207769647468456C656D656E74733A205B';
wwv_flow_imp.g_varchar2_table(3091) := '2031302E352C203231205D5C6E202020207D2C5C6E20202020275441534B5F545950455F555345525F31273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D206320302E3930392C2D302E38343520312E3539342C2D322E30343920312E';
wwv_flow_imp.g_varchar2_table(3092) := '3539342C2D332E33383520302C2D322E353534202D312E3830352C2D342E36323139393939392027202B5C6E2020202020202020272D342E3335372C2D342E3632313939393939202D322E35353139393939382C30202D342E32383739393939382C322E';
wwv_flow_imp.g_varchar2_table(3093) := '3036373939393939202D342E32383739393939382C342E363231393939393920302C312E3334382027202B5C6E202020202020202027302E3937342C322E35363220312E38393539393939382C332E343035202D302E35323839393939382C302E313837';
wwv_flow_imp.g_varchar2_table(3094) := '202D352E3636392C322E303937202D352E3739342C342E37353630303035207620362E3731382027202B5C6E202020202020202027682031372076202D362E373138206320302C2D322E32393830303035202D352E353237393939362C2D342E35393530';
wwv_flow_imp.g_varchar2_table(3095) := '303035202D362E303530393939362C2D342E37373630303035207A27202B5C6E2020202020202020276D202D382C36206C20302C352E35206D2031312C30206C20302C2D35275C6E202020207D2C5C6E20202020275441534B5F545950455F555345525F';
wwv_flow_imp.g_varchar2_table(3096) := '32273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D206D20322E3136322C312E303039206320302C322E34343730303035202D322E3135382C342E34333130303035202D342E3832312C342E343331303030352027202B5C6E20202020';
wwv_flow_imp.g_varchar2_table(3097) := '20202020272D322E36363439393939382C30202D342E3832322C2D312E393831202D342E3832322C2D342E3433313030303520275C6E202020207D2C5C6E20202020275441534B5F545950455F555345525F33273A207B5C6E202020202020643A20276D';
wwv_flow_imp.g_varchar2_table(3098) := '207B6D787D2C7B6D797D206D202D362E392C2D332E3830206320302C3020322E32353039393939382C2D322E33353820342E32373339393939382C2D312E31373720322E3032342C312E31383120342E3232312C312E3533372027202B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(3099) := '20202027342E3132342C302E393635202D302E3039382C2D302E3537202D302E3131372C2D332E3739303939393939202D342E3139312C2D342E3133353939393939202D332E35373439393939382C302E3030312027202B5C6E2020202020202020272D';
wwv_flow_imp.g_varchar2_table(3100) := '342E32303739393939382C332E3336363939393939202D342E32303639393939382C342E3334373939393939207A275C6E202020207D2C5C6E20202020275441534B5F545950455F4D414E55414C273A207B5C6E202020202020643A20276D207B6D787D';
wwv_flow_imp.g_varchar2_table(3101) := '2C7B6D797D206320302E3233342C2D302E303120352E3630342C302E30303820382E3032392C302E30303420302E3830382C3020312E3237312C2D302E31373220312E3431372C2D302E37353220302E3232372C2D302E3839382027202B5C6E20202020';
wwv_flow_imp.g_varchar2_table(3102) := '20202020272D302E3333342C2D312E333134202D312E3333382C2D312E333136202D322E3436372C2D302E3031202D372E3838362C2D302E303034202D382E3130382C2D302E303034202D302E3031342C2D302E30373920302E3031362C2D302E353333';
wwv_flow_imp.g_varchar2_table(3103) := '20302C2D302E36312027202B5C6E202020202020202027302E3139352C2D302E30343220382E3530372C302E30303620392E3631362C302E30303220302E3837372C2D302E30303720312E33352C2D302E34333820312E3335332C2D312E32303820302E';
wwv_flow_imp.g_varchar2_table(3104) := '3030332C2D302E373638202D302E3437392C2D312E30392027202B5C6E2020202020202020272D312E33352C2D312E303931202D322E3936382C2D302E303032202D392E3631392C2D302E303133202D392E3631392C2D302E3031332076202D302E3539';
wwv_flow_imp.g_varchar2_table(3105) := '31206320302C3020352E3035322C2D302E30313620372E3232352C2D302E3031362027202B5C6E202020202020202027302E3838382C2D302E30303220312E3335342C2D302E34313620312E3335312C2D312E313933202D302E3030362C2D302E373631';
wwv_flow_imp.g_varchar2_table(3106) := '202D302E3439322C2D312E313936202D312E3336312C2D312E313936202D332E3437332C2D302E3030352027202B5C6E2020202020202020272D31302E38362C2D302E303033202D31312E303832393939352C2D302E303033202D302E3032322C2D302E';
wwv_flow_imp.g_varchar2_table(3107) := '303437202D302E3034352C2D302E303934202D302E3036392C2D302E31333920302E333933393939352C2D302E3331392027202B5C6E202020202020202027322E303430393939352C2D312E36323620322E343134393939352C2D322E30313720302E34';
wwv_flow_imp.g_varchar2_table(3108) := '36392C2D302E3438373030303520302E3531392C2D312E3136353030303520302E3136322C2D312E36303430303035202D302E3431342C2D302E3531312027202B5C6E2020202020202020272D302E3937332C2D302E35202D312E34382C2D302E323336';
wwv_flow_imp.g_varchar2_table(3109) := '202D312E343630393939352C302E373634202D362E353939393939352C332E36343330303035202D372E373332393939352C342E32373130303035202D302E392C302E3439392027202B5C6E2020202020202020272D312E3531362C312E323533202D31';
wwv_flow_imp.g_varchar2_table(3110) := '2E3838322C322E3139202D302E33373030303030322C302E3935202D302E31372C322E3031202D302E3136362C322E39373920302E3030342C302E373138202D302E32373330303030322C312E3334352027202B5C6E2020202020202020272D302E3035';
wwv_flow_imp.g_varchar2_table(3111) := '352C322E30363320302E3632392C322E30383720322E3432352C332E33313220342E3835392C332E33313820342E363137393939352C302E30313420392E323337393939352C2D302E3133392031332E383536393939352C2D302E3135382027202B5C6E';
wwv_flow_imp.g_varchar2_table(3112) := '202020202020202027302E3735352C2D302E30303420312E3137312C2D302E33303120312E3138322C2D312E30333320302E3031322C2D302E373534202D302E3432332C2D302E393639202D312E3138332C2D302E393733202D312E3737382C2D302E30';
wwv_flow_imp.g_varchar2_table(3113) := '312027202B5C6E2020202020202020272D352E3832342C2D302E303034202D362E30342C2D302E303034203130652D342C2D302E30383420302E3030332C2D302E353836203130652D342C2D302E3637207A275C6E202020207D2C5C6E20202020275441';
wwv_flow_imp.g_varchar2_table(3114) := '534B5F545950455F494E5354414E54494154494E475F53454E44273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D206C20302C382E34206C2031322E362C30206C20302C2D382E34207A206C20362E332C332E36206C20362E332C2D33';
wwv_flow_imp.g_varchar2_table(3115) := '2E36275C6E202020207D2C5C6E20202020275441534B5F545950455F53455256494345273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D2076202D312E3731333335206320302E3335323332362C2D302E3037303520302E3730333933';
wwv_flow_imp.g_varchar2_table(3116) := '322C2D302E313738333820312E3034373632382C2D302E33323133332027202B5C6E202020202020202027302E3334343431362C2D302E313434363520302E3636353832322C2D302E333231333320302E3936363337372C2D302E3532313435206C2031';
wwv_flow_imp.g_varchar2_table(3117) := '2E31393433312C312E313830303520312E3536373438372C2D312E35373638382027202B5C6E2020202020202020272D312E3139353032382C2D312E3138303134206320302E3430333337362C2D302E363133393420302E3638333037392C2D312E3239';
wwv_flow_imp.g_varchar2_table(3118) := '39303820302E3832353434372C2D322E3031383234206C20312E3632323133332C2D302E30312027202B5C6E20202020202020202776202D322E32313936206C202D312E3633363531342C302E30312063202D302E30373333332C2D302E333531353320';
wwv_flow_imp.g_varchar2_table(3119) := '2D302E3137383331392C2D302E3730303234202D302E3332333536342C2D312E30343337322027202B5C6E2020202020202020272D302E3134353234342C2D302E3334343036202D302E3332313430372C2D302E36363434202D302E3532323733352C2D';
wwv_flow_imp.g_varchar2_table(3120) := '302E3936323137206C20312E3133313033352C2D312E3133363331202D312E3538333330352C2D312E35363239332027202B5C6E2020202020202020272D312E3132393539382C312E31333538392063202D302E3631343035322C2D302E343031303820';
wwv_flow_imp.g_varchar2_table(3121) := '2D312E3330323838332C2D302E3638303933202D322E3032323633332C2D302E3832323437206C20302E303039332C2D312E36313835322027202B5C6E20202020202020202768202D322E323431313733206C20302E303034322C312E36333132342063';
wwv_flow_imp.g_varchar2_table(3122) := '202D302E3335333736332C302E30373336202D302E3730353336392C302E3137393737202D312E3034393738352C302E3332333731202D302E3334343431352C302E31343433372027202B5C6E2020202020202020272D302E3636353130322C302E3332';
wwv_flow_imp.g_varchar2_table(3123) := '303932202D302E393633353030362C302E3532303436206C202D312E313639383632382C2D312E3135383233202D312E353636373639312C312E3537393220312E313638343236352C312E31353636392027202B5C6E20202020202020202763202D302E';
wwv_flow_imp.g_varchar2_table(3124) := '343032363537332C302E3631323833202D302E36383330382C312E3239373937202D302E383234373238372C322E3031373133206C202D312E363538383034312C302E303033207620322E32323137342027202B5C6E2020202020202020276C20312E36';
wwv_flow_imp.g_varchar2_table(3125) := '3732343634382C2D302E303036206320302E3037333332372C302E333530373720302E313739373539382C302E373032343320302E333234323835312C312E303434373220302E313435323432382C302E33343434382027202B5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(3126) := '27302E333231343036342C302E3636343420302E353232373333392C302E3936303636206C202D312E313939333433312C312E313937323320312E353834303235362C312E353630313120312E313936343636382C2D312E31393334382027202B5C6E20';
wwv_flow_imp.g_varchar2_table(3127) := '20202020202020276320302E363134303531372C302E343033343620312E333032383832372C302E363832333220322E303233333531372C302E3832333331206C20372E3139652D342C312E3639383932206820322E323236383438207A2027202B5C6E';
wwv_flow_imp.g_varchar2_table(3128) := '2020202020202020276D20302E3232313436322C2D332E393935372063202D312E3738383934382C302E37353032202D332E383537362C2D302E30393238202D342E363039373035352C2D312E3837343338202D302E373532313036352C2D312E373833';
wwv_flow_imp.g_varchar2_table(3129) := '32312027202B5C6E202020202020202027302E3039303539382C2D332E383436323720312E383830323634352C2D342E353936303420312E37383832332C2D302E373439333620332E3835363838312C302E3039323920342E3630383938372C312E3837';
wwv_flow_imp.g_varchar2_table(3130) := '3433372027202B5C6E202020202020202027302E3735323130362C312E3738313635202D302E303930362C332E3834363132202D312E3837393534362C342E3539363035207A275C6E202020207D2C5C6E20202020275441534B5F545950455F53455256';
wwv_flow_imp.g_varchar2_table(3131) := '4943455F46494C4C273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D2063202D312E3738383934382C302E37353032202D332E383537362C2D302E30393238202D342E363039373035352C2D312E3837343338202D302E373532313036';
wwv_flow_imp.g_varchar2_table(3132) := '352C2D312E37383332312027202B5C6E202020202020202027302E3039303539382C2D332E383436323720312E383830323634352C2D342E353936303420312E37383832332C2D302E373439333620332E3835363838312C302E3039323920342E363038';
wwv_flow_imp.g_varchar2_table(3133) := '3938372C312E38373433372027202B5C6E202020202020202027302E3735323130362C312E3738313635202D302E303930362C332E3834363132202D312E3837393534362C342E3539363035207A275C6E202020207D2C5C6E20202020275441534B5F54';
wwv_flow_imp.g_varchar2_table(3134) := '5950455F425553494E4553535F52554C455F484541444552273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D20302C342032302C3020302C2D34207A275C6E202020207D2C5C6E20202020275441534B5F545950455F425553494E4553';
wwv_flow_imp.g_varchar2_table(3135) := '535F52554C455F4D41494E273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D20302C31322032302C3020302C2D3132207A27202B5C6E2020202020202020276D20302C38206C2032302C302027202B5C6E2020202020202020276D202D';
wwv_flow_imp.g_varchar2_table(3136) := '31332C2D34206C20302C38275C6E202020207D2C5C6E20202020274D4553534147455F464C4F575F4D41524B4552273A207B5C6E202020202020643A20276D207B6D787D2C7B6D797D206D202D31302E35202C2D37206C20302C3134206C2032312C3020';
wwv_flow_imp.g_varchar2_table(3137) := '6C20302C2D3134207A206C2031302E352C36206C2031302E352C2D36275C6E202020207D5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A2052657475726E20726177207061746820666F722074686520676976656E2049442E5C6E2020202A5C6E20';
wwv_flow_imp.g_varchar2_table(3138) := '20202A2040706172616D207B737472696E677D207061746849645C6E2020202A5C6E2020202A204072657475726E207B737472696E677D2072617720706174685C6E2020202A2F5C6E2020746869732E67657452617750617468203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(3139) := '6E20676574526177506174682870617468496429207B5C6E2020202072657475726E20746869732E706174684D61705B7061746849645D2E643B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A205363616C657320746865207061746820746F2074';
wwv_flow_imp.g_varchar2_table(3140) := '686520676976656E2068656967687420616E642077696474682E5C6E2020202A203C68313E55736520636173653C2F68313E5C6E2020202A203C703E557365206361736520697320746F207363616C652074686520636F6E74656E74206F6620656C656D';
wwv_flow_imp.g_varchar2_table(3141) := '656E747320286576656E742C206761746577617973292062617365645C6E2020202A206F6E2074686520656C656D656E7420626F756E64696E6720626F7827732073697A652E5C6E2020202A203C2F703E5C6E2020202A203C68313E576879206E6F7420';
wwv_flow_imp.g_varchar2_table(3142) := '7472616E73666F726D3C2F68313E5C6E2020202A203C703E5363616C696E67206120706174682077697468207472616E73666F726D28292077696C6C20616C736F207363616C6520746865207374726F6B6520616E6420494520646F6573206E6F742073';
wwv_flow_imp.g_varchar2_table(3143) := '7570706F72745C6E2020202A20746865206F7074696F6E20276E6F6E2D7363616C696E672D7374726F6B652720746F2070726576656E7420746869732E5C6E2020202A20416C736F2074686572652061726520757365206361736573207768657265206F';
wwv_flow_imp.g_varchar2_table(3144) := '6E6C7920736F6D65207061727473206F66206120706174682073686F756C642062655C6E2020202A207363616C65642E3C2F703E5C6E2020202A5C6E2020202A2040706172616D207B737472696E677D2070617468496420546865204944206F66207468';
wwv_flow_imp.g_varchar2_table(3145) := '6520706174682E5C6E2020202A2040706172616D207B4F626A6563747D20706172616D203C703E5C6E2020202A2020204578616D706C6520706172616D206F626A656374207363616C657320746865207061746820746F203630252073697A65206F6620';
wwv_flow_imp.g_varchar2_table(3146) := '74686520636F6E7461696E65722028646174612E77696474682C20646174612E686569676874292E5C6E2020202A2020203C7072653E5C6E2020202A2020207B5C6E2020202A2020202020785363616C65466163746F723A20302E362C5C6E2020202A20';
wwv_flow_imp.g_varchar2_table(3147) := '20202020795363616C65466163746F723A302E362C5C6E2020202A2020202020636F6E7461696E657257696474683A20646174612E77696474682C5C6E2020202A2020202020636F6E7461696E65724865696768743A20646174612E6865696768742C5C';
wwv_flow_imp.g_varchar2_table(3148) := '6E2020202A2020202020706F736974696F6E3A207B5C6E2020202A202020202020206D783A20302E34362C5C6E2020202A202020202020206D793A20302E322C5C6E2020202A20202020207D5C6E2020202A2020207D5C6E2020202A2020203C2F707265';
wwv_flow_imp.g_varchar2_table(3149) := '3E5C6E2020202A2020203C756C3E5C6E2020202A202020203C6C693E746172676574706174687769647468203D20785363616C65466163746F72202A20636F6E7461696E657257696474683C2F6C693E5C6E2020202A202020203C6C693E746172676574';
wwv_flow_imp.g_varchar2_table(3150) := '70617468686569676874203D20795363616C65466163746F72202A20636F6E7461696E65724865696768743C2F6C693E5C6E2020202A202020203C6C693E506F736974696F6E206973207573656420746F2073657420746865207374617274696E672063';
wwv_flow_imp.g_varchar2_table(3151) := '6F6F7264696E617465206F662074686520706174682E204D20697320636F6D70757465643A5C6E202020202A202020203C756C3E5C6E202020202A2020202020203C6C693E706F736974696F6E2E78202A20636F6E7461696E657257696474683C2F6C69';
wwv_flow_imp.g_varchar2_table(3152) := '3E5C6E202020202A2020202020203C6C693E706F736974696F6E2E79202A20636F6E7461696E65724865696768743C2F6C693E5C6E202020202A202020203C2F756C3E5C6E202020202A2020202043656E746572206F662074686520636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(3153) := '72203C7072653E20706F736974696F6E3A207B5C6E2020202A202020202020206D783A20302E352C5C6E2020202A202020202020206D793A20302E352C5C6E2020202A20202020207D3C2F7072653E5C6E2020202A20202020205570706572206C656674';
wwv_flow_imp.g_varchar2_table(3154) := '20636F726E6572206F662074686520636F6E7461696E65725C6E2020202A20202020203C7072653E20706F736974696F6E3A207B5C6E2020202A202020202020206D783A20302E302C5C6E2020202A202020202020206D793A20302E302C5C6E2020202A';
wwv_flow_imp.g_varchar2_table(3155) := '20202020207D3C2F7072653E5C6E2020202A202020203C2F6C693E5C6E2020202A2020203C2F756C3E5C6E2020202A203C2F703E5C6E2020202A5C6E2020202A204072657475726E207B737472696E677D207363616C656420706174685C6E2020202A2F';
wwv_flow_imp.g_varchar2_table(3156) := '5C6E2020746869732E6765745363616C656450617468203D2066756E6374696F6E206765745363616C656450617468287061746849642C20706172616D29207B5C6E202020207661722072617750617468203D20746869732E706174684D61705B706174';
wwv_flow_imp.g_varchar2_table(3157) := '6849645D3B5C6E5C6E202020202F2F20706F736974696F6E696E675C6E202020202F2F20636F6D707574652074686520737461727420706F696E74206F662074686520706174685C6E20202020766172206D782C206D793B5C6E5C6E2020202069662028';
wwv_flow_imp.g_varchar2_table(3158) := '706172616D2E616273706F7329207B5C6E2020202020206D78203D20706172616D2E616273706F732E783B5C6E2020202020206D79203D20706172616D2E616273706F732E793B5C6E202020207D20656C7365207B5C6E2020202020206D78203D207061';
wwv_flow_imp.g_varchar2_table(3159) := '72616D2E636F6E7461696E65725769647468202A20706172616D2E706F736974696F6E2E6D783B5C6E2020202020206D79203D20706172616D2E636F6E7461696E6572486569676874202A20706172616D2E706F736974696F6E2E6D793B5C6E20202020';
wwv_flow_imp.g_varchar2_table(3160) := '7D5C6E5C6E2020202076617220636F6F7264696E61746573203D207B7D3B202F2F206D617020666F7220746865207363616C656420636F6F7264696E617465735C6E2020202069662028706172616D2E706F736974696F6E29207B5C6E5C6E2020202020';
wwv_flow_imp.g_varchar2_table(3161) := '202F2F20706174685C6E20202020202076617220686569676874526174696F203D2028706172616D2E636F6E7461696E6572486569676874202F20726177506174682E68656967687429202A20706172616D2E795363616C65466163746F723B5C6E2020';
wwv_flow_imp.g_varchar2_table(3162) := '20202020766172207769647468526174696F203D2028706172616D2E636F6E7461696E65725769647468202F20726177506174682E776964746829202A20706172616D2E785363616C65466163746F723B5C6E5C6E5C6E2020202020202F2F204170706C';
wwv_flow_imp.g_varchar2_table(3163) := '792068656967687420726174696F5C6E202020202020666F72202876617220686569676874496E646578203D20303B20686569676874496E646578203C20726177506174682E686569676874456C656D656E74732E6C656E6774683B2068656967687449';
wwv_flow_imp.g_varchar2_table(3164) := '6E6465782B2B29207B5C6E2020202020202020636F6F7264696E617465735B277927202B20686569676874496E6465785D203D20726177506174682E686569676874456C656D656E74735B686569676874496E6465785D202A2068656967687452617469';
wwv_flow_imp.g_varchar2_table(3165) := '6F3B5C6E2020202020207D5C6E5C6E2020202020202F2F204170706C7920776964746820726174696F5C6E202020202020666F722028766172207769647468496E646578203D20303B207769647468496E646578203C20726177506174682E7769647468';
wwv_flow_imp.g_varchar2_table(3166) := '456C656D656E74732E6C656E6774683B207769647468496E6465782B2B29207B5C6E2020202020202020636F6F7264696E617465735B277827202B207769647468496E6465785D203D20726177506174682E7769647468456C656D656E74735B77696474';
wwv_flow_imp.g_varchar2_table(3167) := '68496E6465785D202A207769647468526174696F3B5C6E2020202020207D5C6E202020207D5C6E5C6E202020202F2F204170706C792076616C756520746F2072617720706174685C6E202020207661722070617468203D20666F726D6174285C6E202020';
wwv_flow_imp.g_varchar2_table(3168) := '202020726177506174682E642C207B5C6E20202020202020206D783A206D782C5C6E20202020202020206D793A206D792C5C6E2020202020202020653A20636F6F7264696E617465735C6E2020202020207D5C6E20202020293B5C6E2020202072657475';
wwv_flow_imp.g_varchar2_table(3169) := '726E20706174683B5C6E20207D3B5C6E7D5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E2F2F20636F7069656420616E642061646A75737465642066726F6D2068747470733A2F2F676974687562';
wwv_flow_imp.g_varchar2_table(3170) := '2E636F6D2F61646F62652D776562706C6174666F726D2F536E61702E7376672F626C6F622F6D61737465722F7372632F7376672E6A735C6E76617220746F6B656E5265676578203D202F5C5C7B285B5E7B7D5D2B295C5C7D2F672C5C6E202020206F626A';
wwv_flow_imp.g_varchar2_table(3171) := '4E6F746174696F6E5265676578203D202F283F3A283F3A5E7C5C5C2E29282E2B3F29283F3D5C5C5B7C5C5C2E7C247C5C5C28297C5C5C5B28277C5C2229282E2B3F295C5C325C5C5D29285C5C285C5C29293F2F673B202F2F206D617463686573202E7878';
wwv_flow_imp.g_varchar2_table(3172) := '787878206F72205B5C2278787878785C225D20746F2072756E206F766572206F626A6563742070726F706572746965735C6E5C6E66756E6374696F6E207265706C6163657228616C6C2C206B65792C206F626A29207B5C6E202076617220726573203D20';
wwv_flow_imp.g_varchar2_table(3173) := '6F626A3B5C6E20206B65792E7265706C616365286F626A4E6F746174696F6E52656765782C2066756E6374696F6E28616C6C2C206E616D652C2071756F74652C2071756F7465644E616D652C20697346756E6329207B5C6E202020206E616D65203D206E';
wwv_flow_imp.g_varchar2_table(3174) := '616D65207C7C2071756F7465644E616D653B5C6E202020206966202872657329207B5C6E202020202020696620286E616D6520696E2072657329207B5C6E2020202020202020726573203D207265735B6E616D655D3B5C6E2020202020207D5C6E202020';
wwv_flow_imp.g_varchar2_table(3175) := '202020747970656F6620726573203D3D202766756E6374696F6E2720262620697346756E632026262028726573203D207265732829293B5C6E202020207D5C6E20207D293B5C6E2020726573203D2028726573203D3D206E756C6C207C7C20726573203D';
wwv_flow_imp.g_varchar2_table(3176) := '3D206F626A203F20616C6C203A2072657329202B2027273B5C6E5C6E202072657475726E207265733B5C6E7D5C6E5C6E66756E6374696F6E20666F726D6174287374722C206F626A29207B5C6E202072657475726E20537472696E6728737472292E7265';
wwv_flow_imp.g_varchar2_table(3177) := '706C61636528746F6B656E52656765782C2066756E6374696F6E28616C6C2C206B657929207B5C6E2020202072657475726E207265706C6163657228616C6C2C206B65792C206F626A293B5C6E20207D293B5C6E7D5C6E222C22696D706F7274207B2061';
wwv_flow_imp.g_varchar2_table(3178) := '737369676E207D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F727420546578745574696C2066726F6D20276469616772616D2D6A732F6C69622F7574696C2F54657874273B5C6E5C6E7661722044454641554C545F464F4E545F53495A';
wwv_flow_imp.g_varchar2_table(3179) := '45203D2031323B5C6E766172204C494E455F4845494748545F524154494F203D20312E323B5C6E5C6E766172204D494E5F544558545F414E4E4F544154494F4E5F484549474854203D2033303B5C6E5C6E2F2A2A5C6E202A204074797065646566207B20';
wwv_flow_imp.g_varchar2_table(3180) := '7B5C6E202A202020666F6E7446616D696C793A20737472696E673B5C6E202A202020666F6E7453697A653A206E756D6265723B5C6E202A202020666F6E745765696768743A20737472696E673B5C6E202A2020206C696E654865696768743A206E756D62';
wwv_flow_imp.g_varchar2_table(3181) := '65723B5C6E202A207D207D205465787452656E64657265725374796C655C6E202A5C6E202A204074797065646566207B207B5C6E202A20202064656661756C745374796C653F3A205061727469616C3C5465787452656E64657265725374796C653E3B5C';
wwv_flow_imp.g_varchar2_table(3182) := '6E202A20202065787465726E616C5374796C653F3A205061727469616C3C5465787452656E64657265725374796C653E3B5C6E202A207D207D205465787452656E6465726572436F6E6669675C6E202A5C6E202A204074797065646566207B20696D706F';
wwv_flow_imp.g_varchar2_table(3183) := '727428276469616772616D2D6A732F6C69622F7574696C2F5465787427292E546578744C61796F7574436F6E666967207D20546578744C61796F7574436F6E6669675C6E202A5C6E202A204074797065646566207B20696D706F72742827646961677261';
wwv_flow_imp.g_varchar2_table(3184) := '6D2D6A732F6C69622F7574696C2F547970657327292E52656374207D20526563745C6E202A2F5C6E5C6E5C6E2F2A2A5C6E202A2052656E64657273207465787420616E6420636F6D7075746573207465787420626F756E64696E6720626F7865732E5C6E';
wwv_flow_imp.g_varchar2_table(3185) := '202A5C6E202A2040706172616D207B5465787452656E6465726572436F6E6669677D205B636F6E6669675D5C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E205465787452656E646572657228636F6E66696729207B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(3186) := '20207661722064656661756C745374796C65203D2061737369676E287B5C6E20202020666F6E7446616D696C793A2027417269616C2C2073616E732D7365726966272C5C6E20202020666F6E7453697A653A2044454641554C545F464F4E545F53495A45';
wwv_flow_imp.g_varchar2_table(3187) := '2C5C6E20202020666F6E745765696768743A20276E6F726D616C272C5C6E202020206C696E654865696768743A204C494E455F4845494748545F524154494F5C6E20207D2C20636F6E66696720262620636F6E6669672E64656661756C745374796C6520';
wwv_flow_imp.g_varchar2_table(3188) := '7C7C207B7D293B5C6E5C6E202076617220666F6E7453697A65203D207061727365496E742864656661756C745374796C652E666F6E7453697A652C20313029202D20313B5C6E5C6E20207661722065787465726E616C5374796C65203D2061737369676E';
wwv_flow_imp.g_varchar2_table(3189) := '287B7D2C2064656661756C745374796C652C207B5C6E20202020666F6E7453697A653A20666F6E7453697A655C6E20207D2C20636F6E66696720262620636F6E6669672E65787465726E616C5374796C65207C7C207B7D293B5C6E5C6E20207661722074';
wwv_flow_imp.g_varchar2_table(3190) := '6578745574696C203D206E657720546578745574696C287B5C6E202020207374796C653A2064656661756C745374796C655C6E20207D293B5C6E5C6E20202F2A2A5C6E2020202A2047657420746865206E657720626F756E6473206F6620616E20657874';
wwv_flow_imp.g_varchar2_table(3191) := '65726E616C6C792072656E64657265642C5C6E2020202A206C61796F75746564206C6162656C2E5C6E2020202A5C6E2020202A2040706172616D207B526563747D20626F756E64735C6E2020202A2040706172616D207B737472696E677D20746578745C';
wwv_flow_imp.g_varchar2_table(3192) := '6E2020202A5C6E2020202A204072657475726E207B526563747D5C6E2020202A2F5C6E2020746869732E67657445787465726E616C4C6162656C426F756E6473203D2066756E6374696F6E28626F756E64732C207465787429207B5C6E5C6E2020202076';
wwv_flow_imp.g_varchar2_table(3193) := '6172206C61796F7574656444696D656E73696F6E73203D20746578745574696C2E67657444696D656E73696F6E7328746578742C207B5C6E202020202020626F783A207B5C6E202020202020202077696474683A2039302C5C6E20202020202020206865';
wwv_flow_imp.g_varchar2_table(3194) := '696768743A2033305C6E2020202020207D2C5C6E2020202020207374796C653A2065787465726E616C5374796C655C6E202020207D293B5C6E5C6E202020202F2F20726573697A65206C6162656C20736861706520746F20666974206C6162656C207465';
wwv_flow_imp.g_varchar2_table(3195) := '78745C6E2020202072657475726E207B5C6E202020202020783A204D6174682E726F756E6428626F756E64732E78202B20626F756E64732E7769647468202F2032202D206C61796F7574656444696D656E73696F6E732E7769647468202F2032292C5C6E';
wwv_flow_imp.g_varchar2_table(3196) := '202020202020793A204D6174682E726F756E6428626F756E64732E79292C5C6E20202020202077696474683A204D6174682E6365696C286C61796F7574656444696D656E73696F6E732E7769647468292C5C6E2020202020206865696768743A204D6174';
wwv_flow_imp.g_varchar2_table(3197) := '682E6365696C286C61796F7574656444696D656E73696F6E732E686569676874295C6E202020207D3B5C6E5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A2047657420746865206E657720626F756E6473206F66207465787420616E6E6F74617469';
wwv_flow_imp.g_varchar2_table(3198) := '6F6E2E5C6E2020202A5C6E2020202A2040706172616D207B526563747D20626F756E64735C6E2020202A2040706172616D207B737472696E677D20746578745C6E2020202A5C6E2020202A204072657475726E207B526563747D5C6E2020202A2F5C6E20';
wwv_flow_imp.g_varchar2_table(3199) := '20746869732E67657454657874416E6E6F746174696F6E426F756E6473203D2066756E6374696F6E28626F756E64732C207465787429207B5C6E5C6E20202020766172206C61796F7574656444696D656E73696F6E73203D20746578745574696C2E6765';
wwv_flow_imp.g_varchar2_table(3200) := '7444696D656E73696F6E7328746578742C207B5C6E202020202020626F783A20626F756E64732C5C6E2020202020207374796C653A2064656661756C745374796C652C5C6E202020202020616C69676E3A20276C6566742D746F70272C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(3201) := '2070616464696E673A20355C6E202020207D293B5C6E5C6E2020202072657475726E207B5C6E202020202020783A20626F756E64732E782C5C6E202020202020793A20626F756E64732E792C5C6E20202020202077696474683A20626F756E64732E7769';
wwv_flow_imp.g_varchar2_table(3202) := '6474682C5C6E2020202020206865696768743A204D6174682E6D6178284D494E5F544558545F414E4E4F544154494F4E5F4845494748542C204D6174682E726F756E64286C61796F7574656444696D656E73696F6E732E68656967687429295C6E202020';
wwv_flow_imp.g_varchar2_table(3203) := '207D3B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A204372656174652061206C61796F75746564207465787420656C656D656E742E5C6E2020202A5C6E2020202A2040706172616D207B737472696E677D20746578745C6E2020202A2040706172';
wwv_flow_imp.g_varchar2_table(3204) := '616D207B546578744C61796F7574436F6E6669677D205B6F7074696F6E735D5C6E2020202A5C6E2020202A204072657475726E207B535647456C656D656E747D2072656E646572656420746578745C6E2020202A2F5C6E2020746869732E637265617465';
wwv_flow_imp.g_varchar2_table(3205) := '54657874203D2066756E6374696F6E28746578742C206F7074696F6E7329207B5C6E2020202072657475726E20746578745574696C2E6372656174655465787428746578742C206F7074696F6E73207C7C207B7D293B5C6E20207D3B5C6E5C6E20202F2A';
wwv_flow_imp.g_varchar2_table(3206) := '2A5C6E2020202A204765742064656661756C742074657874207374796C652E5C6E2020202A2F5C6E2020746869732E67657444656661756C745374796C65203D2066756E6374696F6E2829207B5C6E2020202072657475726E2064656661756C74537479';
wwv_flow_imp.g_varchar2_table(3207) := '6C653B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A20476574207468652065787465726E616C2074657874207374796C652E5C6E2020202A2F5C6E2020746869732E67657445787465726E616C5374796C65203D2066756E6374696F6E2829207B';
wwv_flow_imp.g_varchar2_table(3208) := '5C6E2020202072657475726E2065787465726E616C5374796C653B5C6E20207D3B5C6E5C6E7D5C6E5C6E5465787452656E64657265722E24696E6A656374203D205B5C6E202027636F6E6669672E7465787452656E6465726572275C6E5D3B222C22696D';
wwv_flow_imp.g_varchar2_table(3209) := '706F72742042706D6E52656E64657265722066726F6D20272E2F42706D6E52656E6465726572273B5C6E696D706F7274205465787452656E64657265722066726F6D20272E2F5465787452656E6465726572273B5C6E5C6E696D706F727420506174684D';
wwv_flow_imp.g_varchar2_table(3210) := '61702066726F6D20272E2F506174684D6170273B5C6E5C6E6578706F72742064656661756C74207B5C6E20205F5F696E69745F5F3A205B202762706D6E52656E646572657227205D2C5C6E202062706D6E52656E64657265723A205B202774797065272C';
wwv_flow_imp.g_varchar2_table(3211) := '2042706D6E52656E6465726572205D2C5C6E20207465787452656E64657265723A205B202774797065272C205465787452656E6465726572205D2C5C6E2020706174684D61703A205B202774797065272C20506174684D6170205D5C6E7D3B5C6E222C22';
wwv_flow_imp.g_varchar2_table(3212) := '696D706F7274207B20646F6D6966792C20636C6173736573207D2066726F6D20276D696E2D646F6D273B5C6E696D706F7274207B2066696E64207D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B2065736361706548544D4C20';
wwv_flow_imp.g_varchar2_table(3213) := '7D2066726F6D20276469616772616D2D6A732F6C69622F7574696C2F4573636170655574696C273B5C6E696D706F7274207B20676574427573696E6573734F626A6563742C206973207D2066726F6D20272E2E2F2E2E2F7574696C2F4D6F64656C557469';
wwv_flow_imp.g_varchar2_table(3214) := '6C273B5C6E696D706F7274207B5C6E2020676574506C616E65496446726F6D53686170655C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F4472696C6C646F776E5574696C273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F7274';
wwv_flow_imp.g_varchar2_table(3215) := '28276469616772616D2D6A732F6C69622F636F72652F43616E76617327292E64656661756C747D2043616E7661735C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F456C656D656E7452656769';
wwv_flow_imp.g_varchar2_table(3216) := '7374727927292E64656661756C747D20456C656D656E7452656769737472795C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C747D204576656E7442';
wwv_flow_imp.g_varchar2_table(3217) := '75735C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E745C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F';
wwv_flow_imp.g_varchar2_table(3218) := '547970657327292E53686170657D2053686170655C6E202A2F5C6E5C6E766172204F50454E5F434C415353203D2027626A732D62726561646372756D62732D73686F776E273B5C6E5C6E5C6E2F2A2A5C6E202A2041646473206F7665726C617973207468';
wwv_flow_imp.g_varchar2_table(3219) := '617420616C6C6F7720737769746368696E6720706C616E6573206F6E20636F6C6C61707365642073756270726F6365737365732E5C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(3220) := '456C656D656E7452656769737472797D20656C656D656E7452656769737472795C6E202A2040706172616D207B43616E7661737D2063616E7661735C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E204472696C6C646F776E42';
wwv_flow_imp.g_varchar2_table(3221) := '726561646372756D6273286576656E744275732C20656C656D656E7452656769737472792C2063616E76617329207B5C6E20207661722062726561646372756D6273203D20646F6D69667928273C756C20636C6173733D5C22626A732D62726561646372';
wwv_flow_imp.g_varchar2_table(3222) := '756D62735C223E3C2F756C3E27293B5C6E202076617220636F6E7461696E6572203D2063616E7661732E676574436F6E7461696E657228293B5C6E202076617220636F6E7461696E6572436C6173736573203D20636C617373657328636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(3223) := '72293B5C6E2020636F6E7461696E65722E617070656E644368696C642862726561646372756D6273293B5C6E5C6E202076617220627573696E6573734F626A656374506172656E7473203D205B5D3B5C6E5C6E20202F2F20757064617465206272656164';
wwv_flow_imp.g_varchar2_table(3224) := '6372756D6273206966206E616D65206F72204944206F6620746865207072696D617279207368617065206368616E6765735C6E20206576656E744275732E6F6E2827656C656D656E742E6368616E676564272C2066756E6374696F6E286576656E742920';
wwv_flow_imp.g_varchar2_table(3225) := '7B5C6E20202020766172207368617065203D206576656E742E656C656D656E742C5C6E2020202020202020627573696E6573734F626A656374203D20676574427573696E6573734F626A656374287368617065293B5C6E5C6E2020202076617220697350';
wwv_flow_imp.g_varchar2_table(3226) := '726573656E74203D2066696E6428627573696E6573734F626A656374506172656E74732C2066756E6374696F6E28656C656D656E7429207B5C6E20202020202072657475726E20656C656D656E74203D3D3D20627573696E6573734F626A6563743B5C6E';
wwv_flow_imp.g_varchar2_table(3227) := '202020207D293B5C6E5C6E202020206966202821697350726573656E7429207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E2020202075706461746542726561646372756D627328293B5C6E20207D293B5C6E5C6E20202F2A2A5C6E';
wwv_flow_imp.g_varchar2_table(3228) := '2020202A20557064617465732074686520646973706C617965642062726561646372756D62732E204966206E6F20656C656D656E742069732070726F76696465642C206F6E6C79207468655C6E2020202A206C6162656C73206172652075706461746564';
wwv_flow_imp.g_varchar2_table(3229) := '2E5C6E2020202A5C6E2020202A2040706172616D207B456C656D656E747D205B656C656D656E745D5C6E2020202A2F5C6E202066756E6374696F6E2075706461746542726561646372756D627328656C656D656E7429207B5C6E2020202069662028656C';
wwv_flow_imp.g_varchar2_table(3230) := '656D656E7429207B5C6E202020202020627573696E6573734F626A656374506172656E7473203D20676574427573696E6573734F626A656374506172656E74436861696E28656C656D656E74293B5C6E202020207D5C6E5C6E2020202076617220706174';
wwv_flow_imp.g_varchar2_table(3231) := '68203D20627573696E6573734F626A656374506172656E74732E666C61744D61702866756E6374696F6E28706172656E7429207B5C6E20202020202076617220706172656E74506C616E65203D5C6E202020202020202063616E7661732E66696E64526F';
wwv_flow_imp.g_varchar2_table(3232) := '6F7428676574506C616E65496446726F6D536861706528706172656E742929207C7C5C6E202020202020202063616E7661732E66696E64526F6F7428706172656E742E6964293B5C6E5C6E2020202020202F2F207768656E2074686520726F6F74206973';
wwv_flow_imp.g_varchar2_table(3233) := '206120636F6C6C61626F726174696F6E2C207468652070726F6365737320646F6573206E6F74206861766520615C6E2020202020202F2F20636F72726573706F6E64696E6720656C656D656E7420696E2074686520656C656D656E74526567697374792E';
wwv_flow_imp.g_varchar2_table(3234) := '20496E73746561642C207765207365617263685C6E2020202020202F2F20666F722074686520636F72726573706F6E64696E67207061727469636970616E745C6E2020202020206966202821706172656E74506C616E6520262620697328706172656E74';
wwv_flow_imp.g_varchar2_table(3235) := '2C202762706D6E3A50726F63657373272929207B5C6E2020202020202020766172207061727469636970616E74203D20656C656D656E7452656769737472792E66696E642866756E6374696F6E28656C656D656E7429207B5C6E20202020202020202020';
wwv_flow_imp.g_varchar2_table(3236) := '76617220627573696E6573734F626A656374203D20676574427573696E6573734F626A65637428656C656D656E74293B5C6E5C6E2020202020202020202072657475726E20627573696E6573734F626A65637420262620627573696E6573734F626A6563';
wwv_flow_imp.g_varchar2_table(3237) := '742E676574282770726F636573735265662729203D3D3D20706172656E743B5C6E20202020202020207D293B5C6E5C6E2020202020202020706172656E74506C616E65203D207061727469636970616E742026262063616E7661732E66696E64526F6F74';
wwv_flow_imp.g_varchar2_table(3238) := '287061727469636970616E742E6964293B5C6E2020202020207D5C6E5C6E2020202020206966202821706172656E74506C616E6529207B5C6E202020202020202072657475726E205B5D3B5C6E2020202020207D5C6E5C6E202020202020766172207469';
wwv_flow_imp.g_varchar2_table(3239) := '746C65203D2065736361706548544D4C28706172656E742E6E616D65207C7C20706172656E742E6964293B5C6E202020202020766172206C696E6B203D20646F6D69667928273C6C693E3C7370616E20636C6173733D5C22626A732D6372756D625C223E';
wwv_flow_imp.g_varchar2_table(3240) := '3C61207469746C653D5C2227202B207469746C65202B20275C223E27202B207469746C65202B20273C2F613E3C2F7370616E3E3C2F6C693E27293B5C6E5C6E2020202020206C696E6B2E6164644576656E744C697374656E65722827636C69636B272C20';
wwv_flow_imp.g_varchar2_table(3241) := '66756E6374696F6E2829207B5C6E202020202020202063616E7661732E736574526F6F74456C656D656E7428706172656E74506C616E65293B5C6E2020202020207D293B5C6E5C6E20202020202072657475726E206C696E6B3B5C6E202020207D293B5C';
wwv_flow_imp.g_varchar2_table(3242) := '6E5C6E2020202062726561646372756D62732E696E6E657248544D4C203D2027273B5C6E5C6E202020202F2F2073686F772062726561646372756D627320616E64206578706F736520737461746520746F202E646A732D636F6E7461696E65725C6E2020';
wwv_flow_imp.g_varchar2_table(3243) := '20207661722076697369626C65203D20706174682E6C656E677468203E20313B5C6E5C6E20202020636F6E7461696E6572436C61737365732E746F67676C65284F50454E5F434C4153532C2076697369626C65293B5C6E5C6E20202020706174682E666F';
wwv_flow_imp.g_varchar2_table(3244) := '72456163682866756E6374696F6E28656C656D656E7429207B5C6E20202020202062726561646372756D62732E617070656E644368696C6428656C656D656E74293B5C6E202020207D293B5C6E20207D5C6E5C6E20206576656E744275732E6F6E282772';
wwv_flow_imp.g_varchar2_table(3245) := '6F6F742E736574272C2066756E6374696F6E286576656E7429207B5C6E2020202075706461746542726561646372756D6273286576656E742E656C656D656E74293B5C6E20207D293B5C6E5C6E7D5C6E5C6E4472696C6C646F776E42726561646372756D';
wwv_flow_imp.g_varchar2_table(3246) := '62732E24696E6A656374203D205B20276576656E74427573272C2027656C656D656E745265676973747279272C202763616E76617327205D3B5C6E5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F5C6E5C6E2F2A2A5C6E202A2052657475';
wwv_flow_imp.g_varchar2_table(3247) := '726E732074686520706172656E747320666F722074686520656C656D656E74207573696E672074686520627573696E657373206F626A65637420636861696E2C5C6E202A207374617274696E6720776974682074686520726F6F7420656C656D656E742E';
wwv_flow_imp.g_varchar2_table(3248) := '5C6E202A5C6E202A2040706172616D207B53686170657D206368696C645C6E202A5C6E202A204072657475726E207B53686170657D5C6E202A2F5C6E66756E6374696F6E20676574427573696E6573734F626A656374506172656E74436861696E286368';
wwv_flow_imp.g_varchar2_table(3249) := '696C6429207B5C6E202076617220627573696E6573734F626A656374203D20676574427573696E6573734F626A656374286368696C64293B5C6E5C6E202076617220706172656E7473203D205B5D3B5C6E5C6E2020666F72202876617220656C656D656E';
wwv_flow_imp.g_varchar2_table(3250) := '74203D20627573696E6573734F626A6563743B20656C656D656E743B20656C656D656E74203D20656C656D656E742E24706172656E7429207B5C6E2020202069662028697328656C656D656E742C202762706D6E3A53756250726F636573732729207C7C';
wwv_flow_imp.g_varchar2_table(3251) := '20697328656C656D656E742C202762706D6E3A50726F63657373272929207B5C6E202020202020706172656E74732E7075736828656C656D656E74293B5C6E202020207D5C6E20207D5C6E5C6E202072657475726E20706172656E74732E726576657273';
wwv_flow_imp.g_varchar2_table(3252) := '6528293B5C6E7D222C22696D706F7274207B206973207D2066726F6D20272E2E2F2E2E2F7574696C2F4D6F64656C5574696C273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72';
wwv_flow_imp.g_varchar2_table(3253) := '652F43616E76617327292E64656661756C747D2043616E7661735C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E20';
wwv_flow_imp.g_varchar2_table(3254) := '2A2F5C6E5C6E2F2A2A5C6E202A204D6F766520636F6C6C61707365642073756270726F63657373657320696E746F2076696577207768656E206472696C6C696E6720646F776E2E5C6E202A5C6E202A205A6F6F6D20616E64207363726F6C6C2061726520';
wwv_flow_imp.g_varchar2_table(3255) := '736176656420696E20612073657373696F6E2E5C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B43616E7661737D2063616E7661735C6E202A2F5C6E6578706F7274206465666175';
wwv_flow_imp.g_varchar2_table(3256) := '6C742066756E6374696F6E204472696C6C646F776E43656E746572696E67286576656E744275732C2063616E76617329207B5C6E5C6E20207661722063757272656E74526F6F74203D206E756C6C3B5C6E202076617220706F736974696F6E4D6170203D';
wwv_flow_imp.g_varchar2_table(3257) := '206E6577204D617028293B5C6E5C6E20206576656E744275732E6F6E2827726F6F742E736574272C2066756E6374696F6E286576656E7429207B5C6E20202020766172206E6577526F6F74203D206576656E742E656C656D656E743B5C6E202020207661';
wwv_flow_imp.g_varchar2_table(3258) := '722063757272656E7456696577626F78203D2063616E7661732E76696577626F7828293B5C6E202020207661722073746F72656456696577626F78203D20706F736974696F6E4D61702E676574286E6577526F6F74293B5C6E5C6E20202020706F736974';
wwv_flow_imp.g_varchar2_table(3259) := '696F6E4D61702E7365742863757272656E74526F6F742C207B5C6E202020202020783A2063757272656E7456696577626F782E782C5C6E202020202020793A2063757272656E7456696577626F782E792C5C6E2020202020207A6F6F6D3A206375727265';
wwv_flow_imp.g_varchar2_table(3260) := '6E7456696577626F782E7363616C655C6E202020207D293B5C6E5C6E2020202063757272656E74526F6F74203D206E6577526F6F743B5C6E5C6E202020202F2F204B6565702076696577626F78207768656E207265706C6163696E6720726F6F7420656C';
wwv_flow_imp.g_varchar2_table(3261) := '656D656E74735C6E2020202069662028216973286E6577526F6F742C202762706D6E3A53756250726F636573732729202626202173746F72656456696577626F7829207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E202020207374';
wwv_flow_imp.g_varchar2_table(3262) := '6F72656456696577626F78203D2073746F72656456696577626F78207C7C207B20783A20302C20793A20302C207A6F6F6D3A2031207D3B5C6E5C6E20202020766172206478203D202863757272656E7456696577626F782E78202D2073746F7265645669';
wwv_flow_imp.g_varchar2_table(3263) := '6577626F782E7829202A2063757272656E7456696577626F782E7363616C652C5C6E20202020202020206479203D202863757272656E7456696577626F782E79202D2073746F72656456696577626F782E7929202A2063757272656E7456696577626F78';
wwv_flow_imp.g_varchar2_table(3264) := '2E7363616C653B5C6E5C6E2020202069662028647820213D3D2030207C7C20647920213D3D203029207B5C6E20202020202063616E7661732E7363726F6C6C287B5C6E202020202020202064783A2064782C5C6E202020202020202064793A2064795C6E';
wwv_flow_imp.g_varchar2_table(3265) := '2020202020207D293B5C6E202020207D5C6E5C6E202020206966202873746F72656456696577626F782E7A6F6F6D20213D3D2063757272656E7456696577626F782E7363616C6529207B5C6E20202020202063616E7661732E7A6F6F6D2873746F726564';
wwv_flow_imp.g_varchar2_table(3266) := '56696577626F782E7A6F6F6D2C207B20783A20302C20793A2030207D293B5C6E202020207D5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E28276469616772616D2E636C656172272C2066756E6374696F6E2829207B5C6E20202020706F73';
wwv_flow_imp.g_varchar2_table(3267) := '6974696F6E4D61702E636C65617228293B5C6E2020202063757272656E74526F6F74203D206E756C6C3B5C6E20207D293B5C6E5C6E7D5C6E5C6E4472696C6C646F776E43656E746572696E672E24696E6A656374203D205B20276576656E74427573272C';
wwv_flow_imp.g_varchar2_table(3268) := '202763616E76617327205D3B5C6E5C6E5C6E2F2A2A5C6E202A20455335204D617020696D706C656D656E746174696F6E2E20576F726B732E5C6E202A2F5C6E66756E6374696F6E204D61702829207B5C6E5C6E2020746869732E5F656E7472696573203D';
wwv_flow_imp.g_varchar2_table(3269) := '205B5D3B5C6E5C6E2020746869732E736574203D2066756E6374696F6E286B65792C2076616C756529207B5C6E5C6E2020202076617220666F756E64203D2066616C73653B5C6E5C6E20202020666F722028766172206B20696E20746869732E5F656E74';
wwv_flow_imp.g_varchar2_table(3270) := '7269657329207B5C6E20202020202069662028746869732E5F656E74726965735B6B5D5B305D203D3D3D206B657929207B5C6E2020202020202020746869732E5F656E74726965735B6B5D5B315D203D2076616C75653B5C6E5C6E202020202020202066';
wwv_flow_imp.g_varchar2_table(3271) := '6F756E64203D20747275653B5C6E5C6E2020202020202020627265616B3B5C6E2020202020207D5C6E202020207D5C6E5C6E202020206966202821666F756E6429207B5C6E202020202020746869732E5F656E74726965732E70757368285B206B65792C';
wwv_flow_imp.g_varchar2_table(3272) := '2076616C7565205D293B5C6E202020207D5C6E20207D3B5C6E5C6E2020746869732E676574203D2066756E6374696F6E286B657929207B5C6E5C6E20202020666F722028766172206B20696E20746869732E5F656E747269657329207B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(3273) := '2069662028746869732E5F656E74726965735B6B5D5B305D203D3D3D206B657929207B5C6E202020202020202072657475726E20746869732E5F656E74726965735B6B5D5B315D3B5C6E2020202020207D5C6E202020207D5C6E5C6E2020202072657475';
wwv_flow_imp.g_varchar2_table(3274) := '726E206E756C6C3B5C6E20207D3B5C6E5C6E2020746869732E636C656172203D2066756E6374696F6E2829207B5C6E20202020746869732E5F656E74726965732E6C656E677468203D20303B5C6E20207D3B5C6E5C6E2020746869732E72656D6F766520';
wwv_flow_imp.g_varchar2_table(3275) := '3D2066756E6374696F6E286B657929207B5C6E5C6E2020202076617220696478203D202D313B5C6E5C6E20202020666F722028766172206B20696E20746869732E5F656E747269657329207B5C6E20202020202069662028746869732E5F656E74726965';
wwv_flow_imp.g_varchar2_table(3276) := '735B6B5D5B305D203D3D3D206B657929207B5C6E2020202020202020696478203D206B3B5C6E5C6E2020202020202020627265616B3B5C6E2020202020207D5C6E202020207D5C6E5C6E202020206966202869647820213D3D202D3129207B5C6E202020';
wwv_flow_imp.g_varchar2_table(3277) := '202020746869732E5F656E74726965732E73706C696365286964782C2031293B5C6E202020207D5C6E20207D3B5C6E7D222C22696D706F727420696E6865726974732066726F6D2027696E6865726974732D62726F77736572273B5C6E5C6E696D706F72';
wwv_flow_imp.g_varchar2_table(3278) := '7420436F6D6D616E64496E746572636570746F722066726F6D20276469616772616D2D6A732F6C69622F636F6D6D616E642F436F6D6D616E64496E746572636570746F72273B5C6E696D706F7274207B20676574427573696E6573734F626A6563742C20';
wwv_flow_imp.g_varchar2_table(3279) := '6973207D2066726F6D20272E2E2F2E2E2F7574696C2F4D6F64656C5574696C273B5C6E696D706F7274207B20636C61737365732C20646F6D696679207D2066726F6D20276D696E2D646F6D273B5C6E696D706F7274207B20676574506C616E6549644672';
wwv_flow_imp.g_varchar2_table(3280) := '6F6D5368617065207D2066726F6D20272E2E2F2E2E2F7574696C2F4472696C6C646F776E5574696C273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F43616E7661732729';
wwv_flow_imp.g_varchar2_table(3281) := '2E64656661756C747D2043616E7661735C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F456C656D656E74526567697374727927292E64656661756C747D20456C656D656E7452656769737472';
wwv_flow_imp.g_varchar2_table(3282) := '795C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A204074797065646566207B696D706F727428276469616772';
wwv_flow_imp.g_varchar2_table(3283) := '616D2D6A732F6C69622F66656174757265732F6F7665726C6179732F4F7665726C61797327292E64656661756C747D204F7665726C6179735C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F6931386E2F74';
wwv_flow_imp.g_varchar2_table(3284) := '72616E736C6174652F7472616E736C61746527292E64656661756C747D205472616E736C6174655C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D65';
wwv_flow_imp.g_varchar2_table(3285) := '6E745C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E506172656E747D20506172656E745C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327';
wwv_flow_imp.g_varchar2_table(3286) := '292E53686170657D2053686170655C6E202A2F5C6E5C6E766172204C4F575F5052494F52495459203D203235303B5C6E766172204152524F575F444F574E5F535647203D20273C73766720786D6C6E733D5C22687474703A2F2F7777772E77332E6F7267';
wwv_flow_imp.g_varchar2_table(3287) := '2F323030302F7376675C222077696474683D5C2232305C22206865696768743D5C2232305C222076696577426F783D5C223020302031362031365C223E3C706174682066696C6C2D72756C653D5C226576656E6F64645C2220643D5C224D342E38313830';
wwv_flow_imp.g_varchar2_table(3288) := '313934382C332E3530373335393331204C31302E343939363839342C392E31383936383934204C31302E352C34204C31322C34204C31322C3132204C342C3132204C342C31302E35204C392E363839363839342C31302E34393936383934204C332E3735';
wwv_flow_imp.g_varchar2_table(3289) := '3733353933312C342E35363830313934382043332E34363434363630392C342E323735313236323720332E34363434363630392C332E383030323532353320332E37353733353933312C332E35303733353933312043342E30353032353235332C332E32';
wwv_flow_imp.g_varchar2_table(3290) := '3134343636303920342E35323531323632372C332E323134343636303920342E38313830313934382C332E3530373335393331205A5C222F3E3C2F7376673E273B5C6E5C6E76617220454D5054595F4D41524B4552203D2027626A732D6472696C6C646F';
wwv_flow_imp.g_varchar2_table(3291) := '776E2D656D707479273B5C6E5C6E2F2A2A5C6E202A2040706172616D207B43616E7661737D2063616E7661735C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B456C656D656E745265676973';
wwv_flow_imp.g_varchar2_table(3292) := '7472797D20656C656D656E7452656769737472795C6E202A2040706172616D207B4F7665726C6179737D206F7665726C6179735C6E202A2040706172616D207B5472616E736C6174657D207472616E736C6174655C6E202A2F5C6E6578706F7274206465';
wwv_flow_imp.g_varchar2_table(3293) := '6661756C742066756E6374696F6E204472696C6C646F776E4F7665726C61794265686176696F72285C6E2020202063616E7661732C206576656E744275732C20656C656D656E7452656769737472792C206F7665726C6179732C207472616E736C617465';
wwv_flow_imp.g_varchar2_table(3294) := '5C6E29207B5C6E2020436F6D6D616E64496E746572636570746F722E63616C6C28746869732C206576656E74427573293B5C6E5C6E2020746869732E5F63616E766173203D2063616E7661733B5C6E2020746869732E5F6576656E74427573203D206576';
wwv_flow_imp.g_varchar2_table(3295) := '656E744275733B5C6E2020746869732E5F656C656D656E745265676973747279203D20656C656D656E7452656769737472793B5C6E2020746869732E5F6F7665726C617973203D206F7665726C6179733B5C6E2020746869732E5F7472616E736C617465';
wwv_flow_imp.g_varchar2_table(3296) := '203D207472616E736C6174653B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E2020746869732E6578656375746564282773686170652E746F67676C65436F6C6C61707365272C204C4F575F5052494F524954592C2066756E6374696F';
wwv_flow_imp.g_varchar2_table(3297) := '6E28636F6E7465787429207B5C6E20202020766172207368617065203D20636F6E746578742E73686170653B5C6E5C6E202020202F2F20416464206F7665726C617920746F2074686520636F6C6C61707365642073686170655C6E202020206966202873';
wwv_flow_imp.g_varchar2_table(3298) := '656C662E5F63616E4472696C6C446F776E2873686170652929207B5C6E20202020202073656C662E5F6164644F7665726C6179287368617065293B5C6E202020207D20656C7365207B5C6E20202020202073656C662E5F72656D6F76654F7665726C6179';
wwv_flow_imp.g_varchar2_table(3299) := '287368617065293B5C6E202020207D5C6E20207D2C2074727565293B5C6E5C6E5C6E2020746869732E7265766572746564282773686170652E746F67676C65436F6C6C61707365272C204C4F575F5052494F524954592C2066756E6374696F6E28636F6E';
wwv_flow_imp.g_varchar2_table(3300) := '7465787429207B5C6E20202020766172207368617065203D20636F6E746578742E73686170653B5C6E5C6E202020202F2F20416464206F7665726C617920746F2074686520636F6C6C61707365642073686170655C6E202020206966202873656C662E5F';
wwv_flow_imp.g_varchar2_table(3301) := '63616E4472696C6C446F776E2873686170652929207B5C6E20202020202073656C662E5F6164644F7665726C6179287368617065293B5C6E202020207D20656C7365207B5C6E20202020202073656C662E5F72656D6F76654F7665726C61792873686170';
wwv_flow_imp.g_varchar2_table(3302) := '65293B5C6E202020207D5C6E20207D2C2074727565293B5C6E5C6E5C6E2020746869732E6578656375746564285B202773686170652E637265617465272C202773686170652E6D6F7665272C202773686170652E64656C65746527205D2C204C4F575F50';
wwv_flow_imp.g_varchar2_table(3303) := '52494F524954592C5C6E2020202066756E6374696F6E28636F6E7465787429207B5C6E202020202020766172206F6C64506172656E74203D20636F6E746578742E6F6C64506172656E742C5C6E202020202020202020206E6577506172656E74203D2063';
wwv_flow_imp.g_varchar2_table(3304) := '6F6E746578742E6E6577506172656E74207C7C20636F6E746578742E706172656E742C5C6E202020202020202020207368617065203D20636F6E746578742E73686170653B5C6E5C6E2020202020202F2F20416464206F7665726C617920746F20746865';
wwv_flow_imp.g_varchar2_table(3305) := '20636F6C6C61707365642073686170655C6E2020202020206966202873656C662E5F63616E4472696C6C446F776E2873686170652929207B5C6E202020202020202073656C662E5F6164644F7665726C6179287368617065293B5C6E2020202020207D5C';
wwv_flow_imp.g_varchar2_table(3306) := '6E5C6E20202020202073656C662E5F7570646174654472696C6C646F776E4F7665726C6179286F6C64506172656E74293B5C6E20202020202073656C662E5F7570646174654472696C6C646F776E4F7665726C6179286E6577506172656E74293B5C6E20';
wwv_flow_imp.g_varchar2_table(3307) := '202020202073656C662E5F7570646174654472696C6C646F776E4F7665726C6179287368617065293B5C6E202020207D2C2074727565293B5C6E5C6E5C6E2020746869732E7265766572746564285B202773686170652E637265617465272C2027736861';
wwv_flow_imp.g_varchar2_table(3308) := '70652E6D6F7665272C202773686170652E64656C65746527205D2C204C4F575F5052494F524954592C5C6E2020202066756E6374696F6E28636F6E7465787429207B5C6E202020202020766172206F6C64506172656E74203D20636F6E746578742E6F6C';
wwv_flow_imp.g_varchar2_table(3309) := '64506172656E742C5C6E202020202020202020206E6577506172656E74203D20636F6E746578742E6E6577506172656E74207C7C20636F6E746578742E706172656E742C5C6E202020202020202020207368617065203D20636F6E746578742E73686170';
wwv_flow_imp.g_varchar2_table(3310) := '653B5C6E5C6E2020202020202F2F20416464206F7665726C617920746F2074686520636F6C6C61707365642073686170655C6E2020202020206966202873656C662E5F63616E4472696C6C446F776E2873686170652929207B5C6E202020202020202073';
wwv_flow_imp.g_varchar2_table(3311) := '656C662E5F6164644F7665726C6179287368617065293B5C6E2020202020207D5C6E5C6E20202020202073656C662E5F7570646174654472696C6C646F776E4F7665726C6179286F6C64506172656E74293B5C6E20202020202073656C662E5F75706461';
wwv_flow_imp.g_varchar2_table(3312) := '74654472696C6C646F776E4F7665726C6179286E6577506172656E74293B5C6E20202020202073656C662E5F7570646174654472696C6C646F776E4F7665726C6179287368617065293B5C6E202020207D2C2074727565293B5C6E5C6E5C6E2020657665';
wwv_flow_imp.g_varchar2_table(3313) := '6E744275732E6F6E2827696D706F72742E72656E6465722E636F6D706C657465272C2066756E6374696F6E2829207B5C6E20202020656C656D656E7452656769737472792E66696C7465722866756E6374696F6E286529207B5C6E202020202020726574';
wwv_flow_imp.g_varchar2_table(3314) := '75726E2073656C662E5F63616E4472696C6C446F776E2865293B5C6E202020207D292E6D61702866756E6374696F6E28656C29207B5C6E20202020202073656C662E5F6164644F7665726C617928656C293B5C6E202020207D293B5C6E20207D293B5C6E';
wwv_flow_imp.g_varchar2_table(3315) := '5C6E7D5C6E5C6E696E686572697473284472696C6C646F776E4F7665726C61794265686176696F722C20436F6D6D616E64496E746572636570746F72293B5C6E5C6E2F2A2A5C6E202A2040706172616D207B53686170657D2073686170655C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(3316) := '6E4472696C6C646F776E4F7665726C61794265686176696F722E70726F746F747970652E5F7570646174654472696C6C646F776E4F7665726C6179203D2066756E6374696F6E28736861706529207B5C6E20207661722063616E766173203D2074686973';
wwv_flow_imp.g_varchar2_table(3317) := '2E5F63616E7661733B5C6E5C6E20206966202821736861706529207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E202076617220726F6F74203D2063616E7661732E66696E64526F6F74287368617065293B5C6E5C6E202069662028726F6F74';
wwv_flow_imp.g_varchar2_table(3318) := '29207B5C6E20202020746869732E5F7570646174654F7665726C61795669736962696C69747928726F6F74293B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A2040';
wwv_flow_imp.g_varchar2_table(3319) := '72657475726E207B626F6F6C65616E7D5C6E202A2F5C6E4472696C6C646F776E4F7665726C61794265686176696F722E70726F746F747970652E5F63616E4472696C6C446F776E203D2066756E6374696F6E28656C656D656E7429207B5C6E2020766172';
wwv_flow_imp.g_varchar2_table(3320) := '2063616E766173203D20746869732E5F63616E7661733B5C6E5C6E202072657475726E20697328656C656D656E742C202762706D6E3A53756250726F6365737327292026262063616E7661732E66696E64526F6F7428676574506C616E65496446726F6D';
wwv_flow_imp.g_varchar2_table(3321) := '536861706528656C656D656E7429293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2055706461746520746865207669736962696C697479206F6620746865206472696C6C646F776E206F7665726C61792E2049662074686520706C616E6520686173206E6F20';
wwv_flow_imp.g_varchar2_table(3322) := '656C656D656E74732C5C6E202A20746865206472696C6C646F776E2077696C6C206F6E6C792062652073686F776E207768656E2074686520656C656D656E742069732073656C65637465642E5C6E202A5C6E202A2040706172616D207B506172656E747D';
wwv_flow_imp.g_varchar2_table(3323) := '20656C656D656E742054686520636F6C6C617073656420726F6F74206F722073686170652E5C6E202A2F5C6E4472696C6C646F776E4F7665726C61794265686176696F722E70726F746F747970652E5F7570646174654F7665726C61795669736962696C';
wwv_flow_imp.g_varchar2_table(3324) := '697479203D2066756E6374696F6E28656C656D656E7429207B5C6E2020766172206F7665726C617973203D20746869732E5F6F7665726C6179733B5C6E5C6E202076617220627573696E6573734F626A656374203D20676574427573696E6573734F626A';
wwv_flow_imp.g_varchar2_table(3325) := '65637428656C656D656E74293B5C6E5C6E2020766172206F7665726C6179203D206F7665726C6179732E676574287B20656C656D656E743A20627573696E6573734F626A6563742E69642C20747970653A20276472696C6C646F776E27207D295B305D3B';
wwv_flow_imp.g_varchar2_table(3326) := '5C6E5C6E202069662028216F7665726C617929207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E202076617220686173466C6F77456C656D656E7473203D20627573696E6573734F626A6563745C6E20202020262620627573696E6573734F62';
wwv_flow_imp.g_varchar2_table(3327) := '6A6563742E6765742827666C6F77456C656D656E747327295C6E20202020262620627573696E6573734F626A6563742E6765742827666C6F77456C656D656E747327292E6C656E6774683B5C6E5C6E2020636C6173736573286F7665726C61792E68746D';
wwv_flow_imp.g_varchar2_table(3328) := '6C292E746F67676C6528454D5054595F4D41524B45522C2021686173466C6F77456C656D656E7473293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204164642061206472696C6C646F776E20627574746F6E20746F2074686520676976656E20656C656D656E';
wwv_flow_imp.g_varchar2_table(3329) := '7420617373756D696E672074686520706C616E6520686173207468652073616D655C6E202A2049442061732074686520656C656D656E742E5C6E202A5C6E202A2040706172616D207B53686170657D20656C656D656E742054686520636F6C6C61707365';
wwv_flow_imp.g_varchar2_table(3330) := '642073686170652E5C6E202A2F5C6E4472696C6C646F776E4F7665726C61794265686176696F722E70726F746F747970652E5F6164644F7665726C6179203D2066756E6374696F6E28656C656D656E7429207B5C6E20207661722063616E766173203D20';
wwv_flow_imp.g_varchar2_table(3331) := '746869732E5F63616E7661732C5C6E2020202020206F7665726C617973203D20746869732E5F6F7665726C6179732C5C6E202020202020626F203D20676574427573696E6573734F626A65637428656C656D656E74293B5C6E5C6E202076617220657869';
wwv_flow_imp.g_varchar2_table(3332) := '7374696E674F7665726C617973203D206F7665726C6179732E676574287B20656C656D656E743A20656C656D656E742C20747970653A20276472696C6C646F776E27207D293B5C6E5C6E2020696620286578697374696E674F7665726C6179732E6C656E';
wwv_flow_imp.g_varchar2_table(3333) := '67746829207B5C6E20202020746869732E5F72656D6F76654F7665726C617928656C656D656E74293B5C6E20207D5C6E5C6E202076617220627574746F6E203D20646F6D69667928273C627574746F6E20747970653D5C22627574746F6E5C2220636C61';
wwv_flow_imp.g_varchar2_table(3334) := '73733D5C22626A732D6472696C6C646F776E5C223E27202B204152524F575F444F574E5F535647202B20273C2F627574746F6E3E27292C5C6E202020202020656C656D656E744E616D65203D20626F2E67657428276E616D652729207C7C20626F2E6765';
wwv_flow_imp.g_varchar2_table(3335) := '742827696427292C5C6E2020202020207469746C65203D20746869732E5F7472616E736C61746528274F70656E207B656C656D656E747D272C207B20656C656D656E743A20656C656D656E744E616D65207D293B5C6E2020627574746F6E2E7365744174';
wwv_flow_imp.g_varchar2_table(3336) := '7472696275746528277469746C65272C207469746C65293B5C6E5C6E2020627574746F6E2E6164644576656E744C697374656E65722827636C69636B272C2066756E6374696F6E2829207B5C6E2020202063616E7661732E736574526F6F74456C656D65';
wwv_flow_imp.g_varchar2_table(3337) := '6E742863616E7661732E66696E64526F6F7428676574506C616E65496446726F6D536861706528656C656D656E742929293B5C6E20207D293B5C6E5C6E20206F7665726C6179732E61646428656C656D656E742C20276472696C6C646F776E272C207B5C';
wwv_flow_imp.g_varchar2_table(3338) := '6E20202020706F736974696F6E3A207B5C6E202020202020626F74746F6D3A202D372C5C6E20202020202072696768743A202D385C6E202020207D2C5C6E2020202068746D6C3A20627574746F6E5C6E20207D293B5C6E5C6E2020746869732E5F757064';
wwv_flow_imp.g_varchar2_table(3339) := '6174654F7665726C61795669736962696C69747928656C656D656E74293B5C6E7D3B5C6E5C6E4472696C6C646F776E4F7665726C61794265686176696F722E70726F746F747970652E5F72656D6F76654F7665726C6179203D2066756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(3340) := '6C656D656E7429207B5C6E2020766172206F7665726C617973203D20746869732E5F6F7665726C6179733B5C6E5C6E20206F7665726C6179732E72656D6F7665287B5C6E20202020656C656D656E743A20656C656D656E742C5C6E20202020747970653A';
wwv_flow_imp.g_varchar2_table(3341) := '20276472696C6C646F776E275C6E20207D293B5C6E7D3B5C6E5C6E4472696C6C646F776E4F7665726C61794265686176696F722E24696E6A656374203D205B5C6E20202763616E766173272C5C6E2020276576656E74427573272C5C6E202027656C656D';
wwv_flow_imp.g_varchar2_table(3342) := '656E745265676973747279272C5C6E2020276F7665726C617973272C5C6E2020277472616E736C617465275C6E5D3B222C225C6E696D706F7274207B206173426F756E64732C2061735452424C207D2066726F6D20276469616772616D2D6A732F6C6962';
wwv_flow_imp.g_varchar2_table(3343) := '2F6C61796F75742F4C61796F75745574696C273B5C6E696D706F7274207B2069732C206973416E79207D2066726F6D20272E2E2F2E2E2F7574696C2F4D6F64656C5574696C273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428';
wwv_flow_imp.g_varchar2_table(3344) := '276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E4D6F64646C657D20';
wwv_flow_imp.g_varchar2_table(3345) := '4D6F64646C655C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E745C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F';
wwv_flow_imp.g_varchar2_table(3346) := '64656C2F547970657327292E53686170657D2053686170655C6E202A5C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F43616E76617327292E43616E766173506C616E657D2043616E76617350';
wwv_flow_imp.g_varchar2_table(3347) := '6C616E655C6E202A5C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F7574696C2F547970657327292E526563747D20526563745C6E202A2F5C6E5C6E7661722044454641554C545F504F534954494F4E203D';
wwv_flow_imp.g_varchar2_table(3348) := '207B5C6E2020783A203138302C5C6E2020793A203136305C6E7D3B5C6E5C6E2F2A2A5C6E202A20486F6F6B20696E746F2060696D706F72742E72656E6465722E73746172746020616E6420637265617465206E657720706C616E657320666F7220646961';
wwv_flow_imp.g_varchar2_table(3349) := '6772616D7320776974685C6E202A20636F6C6C61707365642073756270726F63657373657320616E6420616C6C20444920656C656D656E7473206F6E207468652073616D6520706C616E652E5C6E202A5C6E202A2040706172616D207B4576656E744275';
wwv_flow_imp.g_varchar2_table(3350) := '737D206576656E744275735C6E202A2040706172616D207B4D6F64646C657D206D6F64646C655C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E2053756270726F63657373436F6D7061746962696C697479286576656E744275';
wwv_flow_imp.g_varchar2_table(3351) := '732C206D6F64646C6529207B5C6E2020746869732E5F6576656E74427573203D206576656E744275733B5C6E2020746869732E5F6D6F64646C65203D206D6F64646C653B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E20206576656E';
wwv_flow_imp.g_varchar2_table(3352) := '744275732E6F6E2827696D706F72742E72656E6465722E7374617274272C20313530302C2066756E6374696F6E28652C20636F6E7465787429207B5C6E2020202073656C662E5F68616E646C65496D706F727428636F6E746578742E646566696E697469';
wwv_flow_imp.g_varchar2_table(3353) := '6F6E73293B5C6E20207D293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D20646566696E6974696F6E735C6E202A2F5C6E53756270726F63657373436F6D7061746962696C6974792E70726F746F747970';
wwv_flow_imp.g_varchar2_table(3354) := '652E5F68616E646C65496D706F7274203D2066756E6374696F6E28646566696E6974696F6E7329207B5C6E20206966202821646566696E6974696F6E732E6469616772616D7329207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020766172';
wwv_flow_imp.g_varchar2_table(3355) := '2073656C66203D20746869733B5C6E2020746869732E5F646566696E6974696F6E73203D20646566696E6974696F6E733B5C6E2020746869732E5F70726F63657373546F4469616772616D4D6170203D207B7D3B5C6E5C6E2020646566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(3356) := '732E6469616772616D732E666F72456163682866756E6374696F6E286469616772616D29207B5C6E2020202069662028216469616772616D2E706C616E65207C7C20216469616772616D2E706C616E652E62706D6E456C656D656E7429207B5C6E202020';
wwv_flow_imp.g_varchar2_table(3357) := '20202072657475726E3B5C6E202020207D5C6E5C6E2020202073656C662E5F70726F63657373546F4469616772616D4D61705B6469616772616D2E706C616E652E62706D6E456C656D656E742E69645D203D206469616772616D3B5C6E20207D293B5C6E';
wwv_flow_imp.g_varchar2_table(3358) := '5C6E2020766172206E65774469616772616D73203D20646566696E6974696F6E732E6469616772616D735C6E202020202E66696C746572286469616772616D203D3E206469616772616D2E706C616E65295C6E202020202E666C61744D61702864696167';
wwv_flow_imp.g_varchar2_table(3359) := '72616D203D3E2073656C662E5F6372656174654E65774469616772616D73286469616772616D2E706C616E6529293B5C6E5C6E20206E65774469616772616D732E666F72456163682866756E6374696F6E286469616772616D29207B5C6E202020207365';
wwv_flow_imp.g_varchar2_table(3360) := '6C662E5F6D6F7665506C616E65456C656D656E7473546F4F726967696E286469616772616D2E706C616E65293B5C6E20207D293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A204D6F76657320616C6C20444920656C656D656E74732066726F6D20636F6C';
wwv_flow_imp.g_varchar2_table(3361) := '6C61707365642073756270726F63657373657320746F2061206E657720706C616E652E5C6E202A5C6E202A2040706172616D207B43616E766173506C616E657D20706C616E655C6E202A5C6E202A204072657475726E207B4D6F64646C65456C656D656E';
wwv_flow_imp.g_varchar2_table(3362) := '745B5D7D206E6577206469616772616D73206372656174656420666F722074686520636F6C6C61707365642073756270726F6365737365735C6E202A2F5C6E53756270726F63657373436F6D7061746962696C6974792E70726F746F747970652E5F6372';
wwv_flow_imp.g_varchar2_table(3363) := '656174654E65774469616772616D73203D2066756E6374696F6E28706C616E6529207B5C6E20207661722073656C66203D20746869733B5C6E5C6E202076617220636F6C6C6170736564456C656D656E7473203D205B5D3B5C6E202076617220656C656D';
wwv_flow_imp.g_varchar2_table(3364) := '656E7473546F4D6F7665203D205B5D3B5C6E5C6E2020706C616E652E6765742827706C616E65456C656D656E7427292E666F72456163682866756E6374696F6E286469456C656D656E7429207B5C6E2020202076617220627573696E6573734F626A6563';
wwv_flow_imp.g_varchar2_table(3365) := '74203D206469456C656D656E742E62706D6E456C656D656E743B5C6E5C6E202020206966202821627573696E6573734F626A65637429207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E2020202076617220706172656E74203D2062';
wwv_flow_imp.g_varchar2_table(3366) := '7573696E6573734F626A6563742E24706172656E743B5C6E5C6E2020202069662028697328627573696E6573734F626A6563742C202762706D6E3A53756250726F63657373272920262620216469456C656D656E742E6973457870616E64656429207B5C';
wwv_flow_imp.g_varchar2_table(3367) := '6E202020202020636F6C6C6170736564456C656D656E74732E7075736828627573696E6573734F626A656374293B5C6E202020207D5C6E5C6E202020206966202873686F756C644D6F7665546F506C616E6528627573696E6573734F626A6563742C2070';
wwv_flow_imp.g_varchar2_table(3368) := '6C616E652929207B5C6E5C6E2020202020202F2F20646F6E2774206368616E676520746865206172726179207768696C652077652069746572617465206F7665722069745C6E202020202020656C656D656E7473546F4D6F76652E70757368287B206469';
wwv_flow_imp.g_varchar2_table(3369) := '456C656D656E743A206469456C656D656E742C20706172656E743A20706172656E74207D293B5C6E202020207D5C6E20207D293B5C6E5C6E2020766172206E65774469616772616D73203D205B5D3B5C6E5C6E20202F2F20637265617465206E65772070';
wwv_flow_imp.g_varchar2_table(3370) := '6C616E657320666F7220616C6C20636F6C6C61707365642073756270726F6365737365732C206576656E207768656E20746865792061726520656D7074795C6E2020636F6C6C6170736564456C656D656E74732E666F72456163682866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3371) := '28656C656D656E7429207B5C6E20202020696620282173656C662E5F70726F63657373546F4469616772616D4D61705B20656C656D656E742E6964205D29207B5C6E202020202020766172206469616772616D203D2073656C662E5F6372656174654469';
wwv_flow_imp.g_varchar2_table(3372) := '616772616D28656C656D656E74293B5C6E5C6E20202020202073656C662E5F70726F63657373546F4469616772616D4D61705B656C656D656E742E69645D203D206469616772616D3B5C6E5C6E2020202020206E65774469616772616D732E7075736828';
wwv_flow_imp.g_varchar2_table(3373) := '6469616772616D293B5C6E202020207D5C6E20207D293B5C6E5C6E2020656C656D656E7473546F4D6F76652E666F72456163682866756E6374696F6E28656C656D656E7429207B5C6E20202020766172206469456C656D656E74203D20656C656D656E74';
wwv_flow_imp.g_varchar2_table(3374) := '2E6469456C656D656E743B5C6E2020202076617220706172656E74203D20656C656D656E742E706172656E743B5C6E5C6E202020202F2F20706172656E7420697320657870616E6465642C20676574206E65617265737420636F6C6C6170736564207061';
wwv_flow_imp.g_varchar2_table(3375) := '72656E745C6E202020207768696C652028706172656E7420262620636F6C6C6170736564456C656D656E74732E696E6465784F6628706172656E7429203D3D3D202D3129207B5C6E202020202020706172656E74203D20706172656E742E24706172656E';
wwv_flow_imp.g_varchar2_table(3376) := '743B5C6E202020207D5C6E5C6E202020202F2F2066616C736520706F7369746976652C20616C6C20706172656E74732061726520657870616E6465645C6E202020206966202821706172656E7429207B5C6E20202020202072657475726E3B5C6E202020';
wwv_flow_imp.g_varchar2_table(3377) := '207D5C6E5C6E20202020766172206469616772616D203D2073656C662E5F70726F63657373546F4469616772616D4D61705B20706172656E742E6964205D3B5C6E5C6E2020202073656C662E5F6D6F7665546F4469506C616E65286469456C656D656E74';
wwv_flow_imp.g_varchar2_table(3378) := '2C206469616772616D2E706C616E65293B5C6E20207D293B5C6E5C6E202072657475726E206E65774469616772616D733B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B43616E766173506C616E657D20706C616E655C6E202A2F5C6E5375';
wwv_flow_imp.g_varchar2_table(3379) := '6270726F63657373436F6D7061746962696C6974792E70726F746F747970652E5F6D6F7665506C616E65456C656D656E7473546F4F726967696E203D2066756E6374696F6E28706C616E6529207B5C6E202076617220656C656D656E7473203D20706C61';
wwv_flow_imp.g_varchar2_table(3380) := '6E652E6765742827706C616E65456C656D656E7427293B5C6E5C6E20202F2F2067657420626F756E64696E6720626F78206F6620616C6C20656C656D656E74735C6E202076617220706C616E65426F756E6473203D20676574506C616E65426F756E6473';
wwv_flow_imp.g_varchar2_table(3381) := '28706C616E65293B5C6E5C6E2020766172206F6666736574203D207B5C6E20202020783A20706C616E65426F756E64732E78202D2044454641554C545F504F534954494F4E2E782C5C6E20202020793A20706C616E65426F756E64732E79202D20444546';
wwv_flow_imp.g_varchar2_table(3382) := '41554C545F504F534954494F4E2E795C6E20207D3B5C6E5C6E2020656C656D656E74732E666F72456163682866756E6374696F6E286469456C656D656E7429207B5C6E20202020696620286469456C656D656E742E776179706F696E7429207B5C6E2020';
wwv_flow_imp.g_varchar2_table(3383) := '202020206469456C656D656E742E776179706F696E742E666F72456163682866756E6374696F6E28776179706F696E7429207B5C6E2020202020202020776179706F696E742E78203D20776179706F696E742E78202D206F66667365742E783B5C6E2020';
wwv_flow_imp.g_varchar2_table(3384) := '202020202020776179706F696E742E79203D20776179706F696E742E79202D206F66667365742E793B5C6E2020202020207D293B5C6E202020207D20656C736520696620286469456C656D656E742E626F756E647329207B5C6E2020202020206469456C';
wwv_flow_imp.g_varchar2_table(3385) := '656D656E742E626F756E64732E78203D206469456C656D656E742E626F756E64732E78202D206F66667365742E783B5C6E2020202020206469456C656D656E742E626F756E64732E79203D206469456C656D656E742E626F756E64732E79202D206F6666';
wwv_flow_imp.g_varchar2_table(3386) := '7365742E793B5C6E202020207D5C6E20207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D206469456C656D656E745C6E202A2040706172616D207B43616E766173506C616E657D206E6577506C61';
wwv_flow_imp.g_varchar2_table(3387) := '6E655C6E202A2F5C6E53756270726F63657373436F6D7061746962696C6974792E70726F746F747970652E5F6D6F7665546F4469506C616E65203D2066756E6374696F6E286469456C656D656E742C206E6577506C616E6529207B5C6E20207661722063';
wwv_flow_imp.g_varchar2_table(3388) := '6F6E7461696E696E674469616772616D203D2066696E64526F6F744469616772616D286469456C656D656E74293B5C6E5C6E20202F2F2072656D6F76652044492066726F6D206F6C6420506C616E6520616E642061646420697420746F20746865206E65';
wwv_flow_imp.g_varchar2_table(3389) := '77206F6E655C6E202076617220706172656E74506C616E65456C656D656E74203D20636F6E7461696E696E674469616772616D2E706C616E652E6765742827706C616E65456C656D656E7427293B5C6E5C6E2020706172656E74506C616E65456C656D65';
wwv_flow_imp.g_varchar2_table(3390) := '6E742E73706C69636528706172656E74506C616E65456C656D656E742E696E6465784F66286469456C656D656E74292C2031293B5C6E5C6E20206E6577506C616E652E6765742827706C616E65456C656D656E7427292E70757368286469456C656D656E';
wwv_flow_imp.g_varchar2_table(3391) := '74293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D20627573696E6573734F626A6563745C6E202A5C6E202A204072657475726E207B4D6F64646C65456C656D656E747D5C6E202A2F5C6E5375627072';
wwv_flow_imp.g_varchar2_table(3392) := '6F63657373436F6D7061746962696C6974792E70726F746F747970652E5F6372656174654469616772616D203D2066756E6374696F6E28627573696E6573734F626A65637429207B5C6E202076617220706C616E65203D20746869732E5F6D6F64646C65';
wwv_flow_imp.g_varchar2_table(3393) := '2E637265617465282762706D6E64693A42504D4E506C616E65272C207B5C6E2020202062706D6E456C656D656E743A20627573696E6573734F626A6563745C6E20207D293B5C6E5C6E2020766172206469616772616D203D20746869732E5F6D6F64646C';
wwv_flow_imp.g_varchar2_table(3394) := '652E637265617465282762706D6E64693A42504D4E4469616772616D272C207B5C6E20202020706C616E653A20706C616E655C6E20207D293B5C6E5C6E2020706C616E652E24706172656E74203D206469616772616D3B5C6E5C6E2020706C616E652E62';
wwv_flow_imp.g_varchar2_table(3395) := '706D6E456C656D656E74203D20627573696E6573734F626A6563743B5C6E5C6E20206469616772616D2E24706172656E74203D20746869732E5F646566696E6974696F6E733B5C6E5C6E2020746869732E5F646566696E6974696F6E732E646961677261';
wwv_flow_imp.g_varchar2_table(3396) := '6D732E70757368286469616772616D293B5C6E5C6E202072657475726E206469616772616D3B5C6E7D3B5C6E5C6E53756270726F63657373436F6D7061746962696C6974792E24696E6A656374203D205B20276576656E74427573272C20276D6F64646C';
wwv_flow_imp.g_varchar2_table(3397) := '6527205D3B5C6E5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E2066696E64526F6F744469616772616D28656C656D656E7429207B5C6E202069662028697328656C656D656E742C202762706D6E64693A42';
wwv_flow_imp.g_varchar2_table(3398) := '504D4E4469616772616D272929207B5C6E2020202072657475726E20656C656D656E743B5C6E20207D20656C7365207B5C6E2020202072657475726E2066696E64526F6F744469616772616D28656C656D656E742E24706172656E74293B5C6E20207D5C';
wwv_flow_imp.g_varchar2_table(3399) := '6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B43616E766173506C616E657D20706C616E655C6E202A5C6E202A204072657475726E207B526563747D5C6E202A2F5C6E66756E6374696F6E20676574506C616E65426F756E647328706C616E6529';
wwv_flow_imp.g_varchar2_table(3400) := '207B5C6E202076617220706C616E655472626C203D207B5C6E20202020746F703A20496E66696E6974792C5C6E2020202072696768743A202D496E66696E6974792C5C6E20202020626F74746F6D3A202D496E66696E6974792C5C6E202020206C656674';
wwv_flow_imp.g_varchar2_table(3401) := '3A20496E66696E6974795C6E20207D3B5C6E5C6E2020706C616E652E706C616E65456C656D656E742E666F72456163682866756E6374696F6E28656C656D656E7429207B5C6E202020206966202821656C656D656E742E626F756E647329207B5C6E2020';
wwv_flow_imp.g_varchar2_table(3402) := '2020202072657475726E3B5C6E202020207D5C6E5C6E20202020766172207472626C203D2061735452424C28656C656D656E742E626F756E6473293B5C6E5C6E20202020706C616E655472626C2E746F70203D204D6174682E6D696E287472626C2E746F';
wwv_flow_imp.g_varchar2_table(3403) := '702C20706C616E655472626C2E746F70293B5C6E20202020706C616E655472626C2E6C656674203D204D6174682E6D696E287472626C2E6C6566742C20706C616E655472626C2E6C656674293B5C6E20207D293B5C6E5C6E202072657475726E20617342';
wwv_flow_imp.g_varchar2_table(3404) := '6F756E647328706C616E655472626C293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D20627573696E6573734F626A6563745C6E202A2040706172616D207B43616E766173506C616E657D20706C616E65';
wwv_flow_imp.g_varchar2_table(3405) := '5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E66756E6374696F6E2073686F756C644D6F7665546F506C616E6528627573696E6573734F626A6563742C20706C616E6529207B5C6E202076617220706172656E74203D';
wwv_flow_imp.g_varchar2_table(3406) := '20627573696E6573734F626A6563742E24706172656E743B5C6E5C6E20202F2F20646F6E2774206D6F766520656C656D656E747320746861742061726520616C7265616479206F6E2074686520706C616E655C6E20206966202821697328706172656E74';
wwv_flow_imp.g_varchar2_table(3407) := '2C202762706D6E3A53756250726F636573732729207C7C20706172656E74203D3D3D20706C616E652E62706D6E456C656D656E7429207B5C6E2020202072657475726E2066616C73653B5C6E20207D5C6E5C6E20202F2F20646174614173736F63696174';
wwv_flow_imp.g_varchar2_table(3408) := '696F6E7320617265206368696C6472656E206F66207468652073756270726F63657373206275742072656E6465726564206F6E2070726F63657373206C6576656C5C6E20202F2F2063662E2068747470733A2F2F6769746875622E636F6D2F62706D6E2D';
wwv_flow_imp.g_varchar2_table(3409) := '696F2F62706D6E2D6A732F6973737565732F313631395C6E2020696620286973416E7928627573696E6573734F626A6563742C205B202762706D6E3A44617461496E7075744173736F63696174696F6E272C202762706D6E3A446174614F757470757441';
wwv_flow_imp.g_varchar2_table(3410) := '73736F63696174696F6E27205D2929207B5C6E2020202072657475726E2066616C73653B5C6E20207D5C6E5C6E202072657475726E20747275653B5C6E7D5C6E222C22696D706F7274204F7665726C6179734D6F64756C652066726F6D20276469616772';
wwv_flow_imp.g_varchar2_table(3411) := '616D2D6A732F6C69622F66656174757265732F6F7665726C617973273B5C6E696D706F7274204368616E6765537570706F72744D6F64756C652066726F6D20276469616772616D2D6A732F6C69622F66656174757265732F6368616E67652D737570706F';
wwv_flow_imp.g_varchar2_table(3412) := '7274273B5C6E696D706F727420526F6F74456C656D656E74734D6F64756C652066726F6D20276469616772616D2D6A732F6C69622F66656174757265732F726F6F742D656C656D656E7473273B5C6E5C6E696D706F7274204472696C6C646F776E427265';
wwv_flow_imp.g_varchar2_table(3413) := '61646372756D62732066726F6D20272E2F4472696C6C646F776E42726561646372756D6273273B5C6E696D706F7274204472696C6C646F776E43656E746572696E672066726F6D20272E2F4472696C6C646F776E43656E746572696E67273B5C6E696D70';
wwv_flow_imp.g_varchar2_table(3414) := '6F72742053756270726F63657373436F6D7061746962696C6974792066726F6D20272E2F53756270726F63657373436F6D7061746962696C697479273B5C6E696D706F7274204472696C6C646F776E4F7665726C61794265686176696F722066726F6D20';
wwv_flow_imp.g_varchar2_table(3415) := '272E2F4472696C6C646F776E4F7665726C61794265686176696F72273B5C6E5C6E6578706F72742064656661756C74207B5C6E20205F5F646570656E64735F5F3A205B204F7665726C6179734D6F64756C652C204368616E6765537570706F72744D6F64';
wwv_flow_imp.g_varchar2_table(3416) := '756C652C20526F6F74456C656D656E74734D6F64756C65205D2C5C6E20205F5F696E69745F5F3A205B20276472696C6C646F776E42726561646372756D6273272C20276472696C6C646F776E4F7665726C61794265686176696F72272C20276472696C6C';
wwv_flow_imp.g_varchar2_table(3417) := '646F776E43656E746572696E67272C202773756270726F63657373436F6D7061746962696C69747927205D2C5C6E20206472696C6C646F776E42726561646372756D62733A205B202774797065272C204472696C6C646F776E42726561646372756D6273';
wwv_flow_imp.g_varchar2_table(3418) := '205D2C5C6E20206472696C6C646F776E43656E746572696E673A205B202774797065272C204472696C6C646F776E43656E746572696E67205D2C5C6E20206472696C6C646F776E4F7665726C61794265686176696F723A205B202774797065272C204472';
wwv_flow_imp.g_varchar2_table(3419) := '696C6C646F776E4F7665726C61794265686176696F72205D2C5C6E202073756270726F63657373436F6D7061746962696C6974793A205B202774797065272C2053756270726F63657373436F6D7061746962696C697479205D5C6E7D3B222C22696D706F';
wwv_flow_imp.g_varchar2_table(3420) := '7274207B2061737369676E207D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E20206174747220617320737667417474722C5C6E2020637265617465206173207376674372656174655C6E7D2066726F6D202774696E792D';
wwv_flow_imp.g_varchar2_table(3421) := '737667273B5C6E5C6E696D706F7274207B5C6E202069732C5C6E20206973416E795C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F4D6F64656C5574696C273B5C6E5C6E696D706F7274207B2069734C6162656C207D2066726F6D20272E2E2F2E2E2F';
wwv_flow_imp.g_varchar2_table(3422) := '7574696C2F4C6162656C5574696C273B5C6E5C6E696D706F7274207B5C6E2020444154415F4F424A4543545F5245464552454E43455F4F55544C494E455F504154482C5C6E2020444154415F53544F52455F5245464552454E43455F4F55544C494E455F';
wwv_flow_imp.g_varchar2_table(3423) := '504154482C5C6E2020444154415F4F424A4543545F5245464552454E43455F5354414E444152445F53495A452C5C6E2020444154415F53544F52455F5245464552454E43455F5354414E444152445F53495A452C5C6E2020637265617465506174685C6E';
wwv_flow_imp.g_varchar2_table(3424) := '7D2066726F6D20272E2F4F75746C696E655574696C273B5C6E5C6E636F6E73742044454641554C545F4F4646534554203D20353B5C6E5C6E2F2A2A5C6E202A2042504D4E2D7370656369666963206F75746C696E652070726F76696465722E5C6E202A5C';
wwv_flow_imp.g_varchar2_table(3425) := '6E202A2040696D706C656D656E7473207B426173654F75746C696E6550726F76696465727D5C6E202A5C6E202A2040706172616D207B4F75746C696E657D206F75746C696E655C6E202A2040706172616D207B5374796C65737D207374796C65735C6E20';
wwv_flow_imp.g_varchar2_table(3426) := '2A2F5C6E6578706F72742064656661756C742066756E6374696F6E204F75746C696E6550726F7669646572286F75746C696E652C207374796C657329207B5C6E5C6E2020746869732E5F7374796C6573203D207374796C65733B5C6E20206F75746C696E';
wwv_flow_imp.g_varchar2_table(3427) := '652E726567697374657250726F76696465722874686973293B5C6E7D5C6E5C6E4F75746C696E6550726F76696465722E24696E6A656374203D205B5C6E2020276F75746C696E65272C5C6E2020277374796C6573275C6E5D3B5C6E5C6E2F2A2A5C6E202A';
wwv_flow_imp.g_varchar2_table(3428) := '2052657475726E73206F75746C696E6520666F72206120676976656E20656C656D656E742E5C6E202A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B4F75746C696E657D5C6E202A';
wwv_flow_imp.g_varchar2_table(3429) := '2F5C6E4F75746C696E6550726F76696465722E70726F746F747970652E6765744F75746C696E65203D2066756E6374696F6E28656C656D656E7429207B5C6E5C6E2020636F6E7374204F55544C494E455F5354594C45203D20746869732E5F7374796C65';
wwv_flow_imp.g_varchar2_table(3430) := '732E636C732827646A732D6F75746C696E65272C205B20276E6F2D66696C6C27205D293B5C6E5C6E2020766172206F75746C696E653B5C6E5C6E20206966202869734C6162656C28656C656D656E742929207B5C6E2020202072657475726E3B5C6E2020';
wwv_flow_imp.g_varchar2_table(3431) := '7D5C6E5C6E202069662028697328656C656D656E742C202762706D6E3A47617465776179272929207B5C6E202020206F75746C696E65203D2073766743726561746528277265637427293B5C6E5C6E2020202061737369676E286F75746C696E652E7374';
wwv_flow_imp.g_varchar2_table(3432) := '796C652C207B5C6E202020202020277472616E73666F726D2D626F78273A202766696C6C2D626F78272C5C6E202020202020277472616E73666F726D273A2027726F7461746528343564656729272C5C6E202020202020277472616E73666F726D2D6F72';
wwv_flow_imp.g_varchar2_table(3433) := '6967696E273A202763656E746572275C6E202020207D293B5C6E5C6E2020202073766741747472286F75746C696E652C2061737369676E287B5C6E202020202020783A20322C5C6E202020202020793A20322C5C6E20202020202072783A20342C5C6E20';
wwv_flow_imp.g_varchar2_table(3434) := '202020202077696474683A20656C656D656E742E7769647468202D20342C5C6E2020202020206865696768743A20656C656D656E742E686569676874202D20342C5C6E202020207D2C204F55544C494E455F5354594C4529293B5C6E5C6E20207D20656C';
wwv_flow_imp.g_varchar2_table(3435) := '736520696620286973416E7928656C656D656E742C205B202762706D6E3A5461736B272C202762706D6E3A53756250726F63657373272C202762706D6E3A47726F7570272C202762706D6E3A43616C6C416374697669747927205D2929207B5C6E202020';
wwv_flow_imp.g_varchar2_table(3436) := '206F75746C696E65203D2073766743726561746528277265637427293B5C6E5C6E2020202073766741747472286F75746C696E652C2061737369676E287B5C6E202020202020783A202D44454641554C545F4F46465345542C5C6E202020202020793A20';
wwv_flow_imp.g_varchar2_table(3437) := '2D44454641554C545F4F46465345542C5C6E20202020202072783A2031342C5C6E20202020202077696474683A20656C656D656E742E7769647468202B2044454641554C545F4F4646534554202A20322C5C6E2020202020206865696768743A20656C65';
wwv_flow_imp.g_varchar2_table(3438) := '6D656E742E686569676874202B2044454641554C545F4F4646534554202A20325C6E202020207D2C204F55544C494E455F5354594C4529293B5C6E5C6E20207D20656C73652069662028697328656C656D656E742C202762706D6E3A456E644576656E74';
wwv_flow_imp.g_varchar2_table(3439) := '272929207B5C6E5C6E202020206F75746C696E65203D207376674372656174652827636972636C6527293B5C6E5C6E202020202F2F20457874726120317078206F6666736574206E65656465642064756520746F20696E63726561736564207374726F6B';
wwv_flow_imp.g_varchar2_table(3440) := '652D7769647468206F6620656E64206576656E745C6E202020202F2F207768696368206D616B657320697420626967676572207468616E206F74686572206576656E74732E5C6E5C6E2020202073766741747472286F75746C696E652C2061737369676E';
wwv_flow_imp.g_varchar2_table(3441) := '287B5C6E20202020202063783A20656C656D656E742E7769647468202F20322C5C6E20202020202063793A20656C656D656E742E686569676874202F20322C5C6E202020202020723A20656C656D656E742E7769647468202F2032202B2044454641554C';
wwv_flow_imp.g_varchar2_table(3442) := '545F4F4646534554202B20315C6E202020207D2C204F55544C494E455F5354594C4529293B5C6E5C6E20207D20656C73652069662028697328656C656D656E742C202762706D6E3A4576656E74272929207B5C6E202020206F75746C696E65203D207376';
wwv_flow_imp.g_varchar2_table(3443) := '674372656174652827636972636C6527293B5C6E5C6E2020202073766741747472286F75746C696E652C2061737369676E287B5C6E20202020202063783A20656C656D656E742E7769647468202F20322C5C6E20202020202063793A20656C656D656E74';
wwv_flow_imp.g_varchar2_table(3444) := '2E686569676874202F20322C5C6E202020202020723A20656C656D656E742E7769647468202F2032202B2044454641554C545F4F46465345545C6E202020207D2C204F55544C494E455F5354594C4529293B5C6E5C6E20207D20656C7365206966202869';
wwv_flow_imp.g_varchar2_table(3445) := '7328656C656D656E742C202762706D6E3A446174614F626A6563745265666572656E636527292026262069735374616E6461726453697A6528656C656D656E742C202762706D6E3A446174614F626A6563745265666572656E6365272929207B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(3446) := '202020206F75746C696E65203D2063726561746550617468285C6E202020202020444154415F4F424A4543545F5245464552454E43455F4F55544C494E455F504154482C5C6E2020202020207B20783A202D362C20793A202D36207D2C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(3447) := '204F55544C494E455F5354594C455C6E20202020293B5C6E5C6E20207D20656C73652069662028697328656C656D656E742C202762706D6E3A4461746153746F72655265666572656E636527292026262069735374616E6461726453697A6528656C656D';
wwv_flow_imp.g_varchar2_table(3448) := '656E742C202762706D6E3A4461746153746F72655265666572656E6365272929207B5C6E5C6E202020206F75746C696E65203D2063726561746550617468285C6E202020202020444154415F53544F52455F5245464552454E43455F4F55544C494E455F';
wwv_flow_imp.g_varchar2_table(3449) := '504154482C5C6E2020202020207B20783A202D362C20793A202D36207D2C5C6E2020202020204F55544C494E455F5354594C455C6E20202020293B5C6E20207D5C6E5C6E202072657475726E206F75746C696E653B5C6E7D3B5C6E5C6E2F2A2A5C6E202A';
wwv_flow_imp.g_varchar2_table(3450) := '205570646174657320746865206F75746C696E6520666F72206120676976656E20656C656D656E742E5C6E202A2052657475726E732074727565206966207468652075706461746520666F722074686520676976656E20656C656D656E74207761732068';
wwv_flow_imp.g_varchar2_table(3451) := '616E646C656420627920746869732070726F76696465722E5C6E202A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A2040706172616D207B4F75746C696E657D206F75746C696E655C6E202A204072657475726E7320';
wwv_flow_imp.g_varchar2_table(3452) := '7B626F6F6C65616E7D5C6E202A2F5C6E4F75746C696E6550726F76696465722E70726F746F747970652E7570646174654F75746C696E65203D2066756E6374696F6E28656C656D656E742C206F75746C696E6529207B5C6E5C6E20206966202869734C61';
wwv_flow_imp.g_varchar2_table(3453) := '62656C28656C656D656E742929207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020696620286973416E7928656C656D656E742C205B202762706D6E3A53756250726F63657373272C202762706D6E3A47726F757027205D2929207B5C6E5C';
wwv_flow_imp.g_varchar2_table(3454) := '6E2020202073766741747472286F75746C696E652C207B5C6E20202020202077696474683A20656C656D656E742E7769647468202B2044454641554C545F4F4646534554202A20322C5C6E2020202020206865696768743A20656C656D656E742E686569';
wwv_flow_imp.g_varchar2_table(3455) := '676874202B2044454641554C545F4F4646534554202A20325C6E202020207D293B5C6E5C6E2020202072657475726E20747275653B5C6E5C6E20207D20656C736520696620286973416E7928656C656D656E742C205B5C6E202020202762706D6E3A4576';
wwv_flow_imp.g_varchar2_table(3456) := '656E74272C5C6E202020202762706D6E3A47617465776179272C5C6E202020202762706D6E3A4461746153746F72655265666572656E6365272C5C6E202020202762706D6E3A446174614F626A6563745265666572656E6365275C6E20205D2929207B5C';
wwv_flow_imp.g_varchar2_table(3457) := '6E2020202072657475726E20747275653B5C6E20207D5C6E5C6E202072657475726E2066616C73653B5C6E7D3B5C6E5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E2069735374616E6461726453697A6528';
wwv_flow_imp.g_varchar2_table(3458) := '656C656D656E742C207479706529207B5C6E2020766172207374616E6461726453697A653B5C6E5C6E20206966202874797065203D3D3D202762706D6E3A446174614F626A6563745265666572656E63652729207B5C6E202020207374616E6461726453';
wwv_flow_imp.g_varchar2_table(3459) := '697A65203D20444154415F4F424A4543545F5245464552454E43455F5354414E444152445F53495A453B5C6E20207D20656C7365206966202874797065203D3D3D202762706D6E3A4461746153746F72655265666572656E63652729207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(3460) := '7374616E6461726453697A65203D20444154415F53544F52455F5245464552454E43455F5354414E444152445F53495A453B5C6E20207D5C6E5C6E202072657475726E20656C656D656E742E7769647468203D3D3D207374616E6461726453697A652E77';
wwv_flow_imp.g_varchar2_table(3461) := '696474685C6E20202020202020202020262620656C656D656E742E686569676874203D3D3D207374616E6461726453697A652E6865696768743B5C6E7D222C22696D706F7274207B5C6E2020637265617465206173207376674372656174655C6E7D2066';
wwv_flow_imp.g_varchar2_table(3462) := '726F6D202774696E792D737667273B5C6E5C6E6578706F727420636F6E737420444154415F4F424A4543545F5245464552454E43455F4F55544C494E455F50415448203D20274D34342E373634382031312E333236334C33362E3938393220322E363430';
wwv_flow_imp.g_varchar2_table(3463) := '37344333362E3034353120312E35383632382033342E3536353120302E3938383730382033332E3139303420302E39383837303848352E393836363743332E323236383820302E39383837303820302E39383936323420332E333438393220302E393839';
wwv_flow_imp.g_varchar2_table(3464) := '36323420362E32363033395635352E3032333543302E3938393632342035372E3933343920332E32323638382036302E3239353220352E39383636372036302E323935324834302E3936364334332E373235372036302E323935322034352E3936332035';
wwv_flow_imp.g_varchar2_table(3465) := '372E393334392034352E3936332035352E303233355631342E393435394334352E3936332031332E353939382034352E363430372031322E333034382034342E373634382031312E333236335A273B5C6E6578706F727420636F6E737420444154415F53';
wwv_flow_imp.g_varchar2_table(3466) := '544F52455F5245464552454E43455F4F55544C494E455F50415448203D20274D312E30333834352034382E3133343743312E30333834352034392E3335313120312E30373239352035302E37353820312E33383334322035322E30363443312E36393934';
wwv_flow_imp.g_varchar2_table(3467) := '392035332E3339333820322E33323432382035342E3731353420332E35363338332035352E3634323843362E30323533332035372E343834312031302E313136312035382E373638352031342E383231322035392E363036374331392E35373732203630';
wwv_flow_imp.g_varchar2_table(3468) := '2E343533382032352E313338382036302E383733382033302E363833312036302E383733384333362E323237362036302E383733382034312E373839312036302E343533382034362E3534352035392E363036374335312E323530342035382E37363837';
wwv_flow_imp.g_varchar2_table(3469) := '2035352E333431322035372E343834322035372E383032382035352E363432394335392E303432342035342E373135362035392E363637332035332E333933382035392E393833342035322E3036344336302E323933382035302E373537392036302E33';
wwv_flow_imp.g_varchar2_table(3470) := '3238352034392E3335312036302E333238352034382E313334345631332E383431354336302E333238352031322E363234392036302E323933382031312E3231382035392E3938333420392E39313137314335392E3636373320382E3538313934203539';
wwv_flow_imp.g_varchar2_table(3471) := '2E3034323320372E323630322035372E3830323720362E33333239344335352E33343120342E34393136382035312E3235303320332E32303732332034362E35343520322E33363931344334312E3738393120312E3532322033362E3232373620312E31';
wwv_flow_imp.g_varchar2_table(3472) := '303230342033302E3638333120312E31303230354332352E3133383820312E31303230362031392E3537373220312E35323230362031342E3832313320322E33363932334331302E3131363220332E323037333420362E303235343320342E3439313833';
wwv_flow_imp.g_varchar2_table(3473) := '20332E3536333920362E333333313443322E333234333320372E323630333820312E363939353120382E353832303620312E333833343320392E393131383143312E30373239352031312E3231373920312E30333834352031322E3632343720312E3033';
wwv_flow_imp.g_varchar2_table(3474) := '3834352031332E383431315634382E313334375A273B5C6E5C6E2F2A2A5C6E202A204074797065207B44696D656E73696F6E737D5C6E202A2F5C6E6578706F727420636F6E737420444154415F4F424A4543545F5245464552454E43455F5354414E4441';
wwv_flow_imp.g_varchar2_table(3475) := '52445F53495A45203D207B2077696474683A2033362C206865696768743A203530207D3B5C6E5C6E2F2A2A5C6E202A204074797065207B44696D656E73696F6E737D5C6E202A2F5C6E6578706F727420636F6E737420444154415F53544F52455F524546';
wwv_flow_imp.g_varchar2_table(3476) := '4552454E43455F5354414E444152445F53495A45203D207B2077696474683A2035302C206865696768743A203530207D3B5C6E5C6E2F2A2A5C6E202A204372656174652061207061746820656C656D656E74207769746820676976656E20617474726962';
wwv_flow_imp.g_varchar2_table(3477) := '757465732E5C6E202A2040706172616D207B737472696E677D20706174685C6E202A2040706172616D207B4F626A6563747D2061747472735C6E202A2040706172616D207B4F626A6563747D204F55544C494E455F5354594C455C6E202A204072657475';
wwv_flow_imp.g_varchar2_table(3478) := '726E207B535647456C656D656E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E206372656174655061746828706174682C2061747472732C204F55544C494E455F5354594C4529207B5C6E202072657475726E207376674372656174652827';
wwv_flow_imp.g_varchar2_table(3479) := '70617468272C207B5C6E20202020643A20706174682C5C6E202020207374726F6B6557696474683A20322C5C6E202020207472616E73666F726D3A20607472616E736C61746528247B61747472732E787D2C20247B61747472732E797D29602C5C6E2020';
wwv_flow_imp.g_varchar2_table(3480) := '20202E2E2E4F55544C494E455F5354594C455C6E20207D293B5C6E7D222C22696D706F7274204F756C696E652066726F6D20276469616772616D2D6A732F6C69622F66656174757265732F6F75746C696E65273B5C6E696D706F7274204F756C696E6550';
wwv_flow_imp.g_varchar2_table(3481) := '726F76696465722066726F6D20272E2F4F75746C696E6550726F7669646572273B5C6E5C6E6578706F72742064656661756C74207B5C6E20205F5F646570656E64735F5F3A205B5C6E202020204F756C696E655C6E20205D2C5C6E20205F5F696E69745F';
wwv_flow_imp.g_varchar2_table(3482) := '5F3A205B20276F75746C696E6550726F766964657227205D2C5C6E20206F75746C696E6550726F76696465723A205B202774797065272C204F756C696E6550726F7669646572205D5C6E7D3B5C6E222C22696D706F7274207B5C6E202061737369676E5C';
wwv_flow_imp.g_varchar2_table(3483) := '6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B206973207D2066726F6D20272E2E2F7574696C2F4D6F64656C5574696C273B5C6E5C6E696D706F7274207B5C6E202069734C6162656C45787465726E616C2C5C6E20206765';
wwv_flow_imp.g_varchar2_table(3484) := '7445787465726E616C4C6162656C426F756E64732C5C6E20206765744C6162656C5C6E7D2066726F6D20272E2E2F7574696C2F4C6162656C5574696C273B5C6E5C6E696D706F7274207B5C6E20206765744D69645C6E7D2066726F6D2027646961677261';
wwv_flow_imp.g_varchar2_table(3485) := '6D2D6A732F6C69622F6C61796F75742F4C61796F75745574696C273B5C6E5C6E696D706F7274207B5C6E20206973457870616E6465645C6E7D2066726F6D20272E2E2F7574696C2F44695574696C273B5C6E5C6E696D706F7274207B5C6E2020656C656D';
wwv_flow_imp.g_varchar2_table(3486) := '656E74546F537472696E675C6E7D2066726F6D20272E2F5574696C273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F43616E76617327292E64656661756C747D2043616E';
wwv_flow_imp.g_varchar2_table(3487) := '7661735C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F456C656D656E74526567697374727927292E64656661756C747D20456C656D656E7452656769737472795C6E202A2040747970656465';
wwv_flow_imp.g_varchar2_table(3488) := '66207B696D706F727428276469616772616D2D6A732F6C69622F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F66656174757265732F6D6F';
wwv_flow_imp.g_varchar2_table(3489) := '64656C696E672F456C656D656E74466163746F727927292E64656661756C747D20456C656D656E74466163746F72795C6E202A204074797065646566207B696D706F727428272E2E2F647261772F5465787452656E646572657227292E64656661756C74';
wwv_flow_imp.g_varchar2_table(3490) := '7D205465787452656E64657265725C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E745C6E202A204074797065646566207B696D706F727428272E2E2F';
wwv_flow_imp.g_varchar2_table(3491) := '6D6F64656C2F547970657327292E4C6162656C7D204C6162656C5C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E53686170657D2053686170655C6E202A204074797065646566207B696D706F727428';
wwv_flow_imp.g_varchar2_table(3492) := '272E2E2F6D6F64656C2F547970657327292E436F6E6E656374696F6E7D20436F6E6E656374696F6E5C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E526F6F747D20526F6F745C6E202A204074797065';
wwv_flow_imp.g_varchar2_table(3493) := '646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D207365';
wwv_flow_imp.g_varchar2_table(3494) := '6D616E7469635C6E202A2040706172616D207B4D6F64646C65456C656D656E747D2064695C6E202A2040706172616D207B4F626A6563747D205B61747472733D6E756C6C5D5C6E202A5C6E202A204072657475726E207B4F626A6563747D5C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(3495) := '6E66756E6374696F6E20656C656D656E74446174612873656D616E7469632C2064692C20617474727329207B5C6E202072657475726E2061737369676E287B5C6E2020202069643A2073656D616E7469632E69642C5C6E20202020747970653A2073656D';
wwv_flow_imp.g_varchar2_table(3496) := '616E7469632E24747970652C5C6E20202020627573696E6573734F626A6563743A2073656D616E7469632C5C6E2020202064693A2064695C6E20207D2C206174747273293B5C6E7D5C6E5C6E66756E6374696F6E20676574576179706F696E7473286469';
wwv_flow_imp.g_varchar2_table(3497) := '2C20736F757263652C2074617267657429207B5C6E5C6E202076617220776179706F696E7473203D2064692E776179706F696E743B5C6E5C6E20206966202821776179706F696E7473207C7C20776179706F696E74732E6C656E677468203C203229207B';
wwv_flow_imp.g_varchar2_table(3498) := '5C6E2020202072657475726E205B206765744D696428736F75726365292C206765744D69642874617267657429205D3B5C6E20207D5C6E5C6E202072657475726E20776179706F696E74732E6D61702866756E6374696F6E287029207B5C6E2020202072';
wwv_flow_imp.g_varchar2_table(3499) := '657475726E207B20783A20702E782C20793A20702E79207D3B5C6E20207D293B5C6E7D5C6E5C6E66756E6374696F6E206E6F74596574447261776E2873656D616E7469632C2072656653656D616E7469632C2070726F706572747929207B5C6E20207265';
wwv_flow_imp.g_varchar2_table(3500) := '7475726E206E6577204572726F72285C6E2020202060656C656D656E7420247B20656C656D656E74546F537472696E672872656653656D616E74696329207D207265666572656E63656420627920247B20656C656D656E74546F537472696E672873656D';
wwv_flow_imp.g_varchar2_table(3501) := '616E74696329207D23247B2070726F7065727479207D206E6F742079657420647261776E605C6E2020293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20416E20696D706F72746572207468617420616464732062706D6E20656C656D656E747320746F2074';
wwv_flow_imp.g_varchar2_table(3502) := '68652063616E7661735C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B43616E7661737D2063616E7661735C6E202A2040706172616D207B456C656D656E74466163746F72797D20';
wwv_flow_imp.g_varchar2_table(3503) := '656C656D656E74466163746F72795C6E202A2040706172616D207B456C656D656E7452656769737472797D20656C656D656E7452656769737472795C6E202A2040706172616D207B5465787452656E64657265727D207465787452656E64657265725C6E';
wwv_flow_imp.g_varchar2_table(3504) := '202A2F5C6E6578706F72742064656661756C742066756E6374696F6E2042706D6E496D706F72746572285C6E202020206576656E744275732C2063616E7661732C20656C656D656E74466163746F72792C5C6E20202020656C656D656E74526567697374';
wwv_flow_imp.g_varchar2_table(3505) := '72792C207465787452656E646572657229207B5C6E5C6E2020746869732E5F6576656E74427573203D206576656E744275733B5C6E2020746869732E5F63616E766173203D2063616E7661733B5C6E2020746869732E5F656C656D656E74466163746F72';
wwv_flow_imp.g_varchar2_table(3506) := '79203D20656C656D656E74466163746F72793B5C6E2020746869732E5F656C656D656E745265676973747279203D20656C656D656E7452656769737472793B5C6E2020746869732E5F7465787452656E6465726572203D207465787452656E6465726572';
wwv_flow_imp.g_varchar2_table(3507) := '3B5C6E7D5C6E5C6E42706D6E496D706F727465722E24696E6A656374203D205B5C6E2020276576656E74427573272C5C6E20202763616E766173272C5C6E202027656C656D656E74466163746F7279272C5C6E202027656C656D656E7452656769737472';
wwv_flow_imp.g_varchar2_table(3508) := '79272C5C6E2020277465787452656E6465726572275C6E5D3B5C6E5C6E5C6E2F2A2A5C6E202A2041646420612042504D4E20656C656D656E74202873656D616E7469632920746F207468652063616E766173206D616B696E672069742061206368696C64';
wwv_flow_imp.g_varchar2_table(3509) := '206F66207468655C6E202A20676976656E20706172656E742E5C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D2073656D616E7469635C6E202A2040706172616D207B4D6F64646C65456C656D656E747D2064695C6E202A20';
wwv_flow_imp.g_varchar2_table(3510) := '40706172616D207B53686170657D20706172656E74456C656D656E745C6E202A5C6E202A204072657475726E207B5368617065207C20526F6F74207C20436F6E6E656374696F6E7D5C6E202A2F5C6E42706D6E496D706F727465722E70726F746F747970';
wwv_flow_imp.g_varchar2_table(3511) := '652E616464203D2066756E6374696F6E2873656D616E7469632C2064692C20706172656E74456C656D656E7429207B5C6E202076617220656C656D656E742C5C6E20202020202068696464656E3B5C6E5C6E202076617220706172656E74496E6465783B';
wwv_flow_imp.g_varchar2_table(3512) := '5C6E5C6E20202F2F20524F4F5420454C454D454E545C6E20202F2F2068616E646C6520746865207370656369616C20636173652074686174207765206465616C207769746820615C6E20202F2F20696E76697369626C6520726F6F7420656C656D656E74';
wwv_flow_imp.g_varchar2_table(3513) := '202870726F636573732C2073756270726F63657373206F7220636F6C6C61626F726174696F6E295C6E20206966202869732864692C202762706D6E64693A42504D4E506C616E65272929207B5C6E5C6E20202020766172206174747273203D2069732873';
wwv_flow_imp.g_varchar2_table(3514) := '656D616E7469632C202762706D6E3A53756250726F6365737327295C6E2020202020203F207B2069643A2073656D616E7469632E6964202B20275F706C616E6527207D5C6E2020202020203A207B7D3B5C6E5C6E202020202F2F20616464206120766972';
wwv_flow_imp.g_varchar2_table(3515) := '7475616C20656C656D656E7420286E6F74206265696E6720647261776E295C6E20202020656C656D656E74203D20746869732E5F656C656D656E74466163746F72792E637265617465526F6F7428656C656D656E74446174612873656D616E7469632C20';
wwv_flow_imp.g_varchar2_table(3516) := '64692C20617474727329293B5C6E5C6E20202020746869732E5F63616E7661732E616464526F6F74456C656D656E7428656C656D656E74293B5C6E20207D5C6E5C6E20202F2F2053484150455C6E2020656C7365206966202869732864692C202762706D';
wwv_flow_imp.g_varchar2_table(3517) := '6E64693A42504D4E5368617065272929207B5C6E5C6E2020202076617220636F6C6C6170736564203D20216973457870616E6465642873656D616E7469632C206469292C5C6E202020202020202069734672616D65203D2069734672616D65456C656D65';
wwv_flow_imp.g_varchar2_table(3518) := '6E742873656D616E746963293B5C6E5C6E2020202068696464656E203D20706172656E74456C656D656E742026262028706172656E74456C656D656E742E68696464656E207C7C20706172656E74456C656D656E742E636F6C6C6170736564293B5C6E5C';
wwv_flow_imp.g_varchar2_table(3519) := '6E2020202076617220626F756E6473203D2064692E626F756E64733B5C6E5C6E20202020656C656D656E74203D20746869732E5F656C656D656E74466163746F72792E637265617465536861706528656C656D656E74446174612873656D616E7469632C';
wwv_flow_imp.g_varchar2_table(3520) := '2064692C207B5C6E202020202020636F6C6C61707365643A20636F6C6C61707365642C5C6E20202020202068696464656E3A2068696464656E2C5C6E202020202020783A204D6174682E726F756E6428626F756E64732E78292C5C6E202020202020793A';
wwv_flow_imp.g_varchar2_table(3521) := '204D6174682E726F756E6428626F756E64732E79292C5C6E20202020202077696474683A204D6174682E726F756E6428626F756E64732E7769647468292C5C6E2020202020206865696768743A204D6174682E726F756E6428626F756E64732E68656967';
wwv_flow_imp.g_varchar2_table(3522) := '6874292C5C6E20202020202069734672616D653A2069734672616D655C6E202020207D29293B5C6E5C6E202020206966202869732873656D616E7469632C202762706D6E3A426F756E646172794576656E74272929207B5C6E202020202020746869732E';
wwv_flow_imp.g_varchar2_table(3523) := '5F617474616368426F756E646172792873656D616E7469632C20656C656D656E74293B5C6E202020207D5C6E5C6E202020202F2F20696E73657274206C616E657320626568696E64206F7468657220666C6F77206E6F646573202863662E202337323729';
wwv_flow_imp.g_varchar2_table(3524) := '5C6E202020206966202869732873656D616E7469632C202762706D6E3A4C616E65272929207B5C6E202020202020706172656E74496E646578203D20303B5C6E202020207D5C6E5C6E202020206966202869732873656D616E7469632C202762706D6E3A';
wwv_flow_imp.g_varchar2_table(3525) := '4461746153746F72655265666572656E6365272929207B5C6E5C6E2020202020202F2F20636865636B207768657468657220646174612073746F726520697320696E73696465206F7572206F757473696465206F66206974732073656D616E7469632070';
wwv_flow_imp.g_varchar2_table(3526) := '6172656E745C6E20202020202069662028216973506F696E74496E7369646542426F7828706172656E74456C656D656E742C206765744D696428626F756E6473292929207B5C6E2020202020202020706172656E74456C656D656E74203D20746869732E';
wwv_flow_imp.g_varchar2_table(3527) := '5F63616E7661732E66696E64526F6F7428706172656E74456C656D656E74293B5C6E2020202020207D5C6E202020207D5C6E5C6E20202020746869732E5F63616E7661732E616464536861706528656C656D656E742C20706172656E74456C656D656E74';
wwv_flow_imp.g_varchar2_table(3528) := '2C20706172656E74496E646578293B5C6E20207D5C6E5C6E20202F2F20434F4E4E454354494F4E5C6E2020656C7365206966202869732864692C202762706D6E64693A42504D4E45646765272929207B5C6E5C6E2020202076617220736F75726365203D';
wwv_flow_imp.g_varchar2_table(3529) := '20746869732E5F676574536F757263652873656D616E746963292C5C6E2020202020202020746172676574203D20746869732E5F6765745461726765742873656D616E746963293B5C6E5C6E2020202068696464656E203D20706172656E74456C656D65';
wwv_flow_imp.g_varchar2_table(3530) := '6E742026262028706172656E74456C656D656E742E68696464656E207C7C20706172656E74456C656D656E742E636F6C6C6170736564293B5C6E5C6E20202020656C656D656E74203D20746869732E5F656C656D656E74466163746F72792E6372656174';
wwv_flow_imp.g_varchar2_table(3531) := '65436F6E6E656374696F6E28656C656D656E74446174612873656D616E7469632C2064692C207B5C6E20202020202068696464656E3A2068696464656E2C5C6E202020202020736F757263653A20736F757263652C5C6E2020202020207461726765743A';
wwv_flow_imp.g_varchar2_table(3532) := '207461726765742C5C6E202020202020776179706F696E74733A20676574576179706F696E74732864692C20736F757263652C20746172676574295C6E202020207D29293B5C6E5C6E202020206966202869732873656D616E7469632C202762706D6E3A';
wwv_flow_imp.g_varchar2_table(3533) := '446174614173736F63696174696F6E272929207B5C6E5C6E2020202020202F2F2072656E64657220616C77617973206F6E20746F703B207468697320656E737572657320446174614173736F63696174696F6E735C6E2020202020202F2F206172652072';
wwv_flow_imp.g_varchar2_table(3534) := '656E646572656420636F72726563746C79206163726F737320646966666572656E74205C226861636B735C222070656F706C655C6E2020202020202F2F206C6F766520746F206D6F64656C20737563682061732063726F7373207061727469636970616E';
wwv_flow_imp.g_varchar2_table(3535) := '74202F207375622070726F636573735C6E2020202020202F2F206173736F63696174696F6E735C6E202020202020706172656E74456C656D656E74203D20746869732E5F63616E7661732E66696E64526F6F7428706172656E74456C656D656E74293B5C';
wwv_flow_imp.g_varchar2_table(3536) := '6E202020207D5C6E5C6E20202020746869732E5F63616E7661732E616464436F6E6E656374696F6E28656C656D656E742C20706172656E74456C656D656E742C20706172656E74496E646578293B5C6E20207D20656C7365207B5C6E202020207468726F';
wwv_flow_imp.g_varchar2_table(3537) := '77206E6577204572726F72285C6E20202020202060756E6B6E6F776E20646920247B20656C656D656E74546F537472696E6728646929207D20666F7220656C656D656E7420247B20656C656D656E74546F537472696E672873656D616E74696329207D60';
wwv_flow_imp.g_varchar2_table(3538) := '5C6E20202020293B5C6E20207D5C6E5C6E20202F2F20286F7074696F6E616C29204C4142454C5C6E20206966202869734C6162656C45787465726E616C2873656D616E74696329202626206765744C6162656C28656C656D656E742929207B5C6E202020';
wwv_flow_imp.g_varchar2_table(3539) := '20746869732E6164644C6162656C2873656D616E7469632C2064692C20656C656D656E74293B5C6E20207D5C6E5C6E2020746869732E5F6576656E744275732E66697265282762706D6E456C656D656E742E6164646564272C207B20656C656D656E743A';
wwv_flow_imp.g_varchar2_table(3540) := '20656C656D656E74207D293B5C6E5C6E202072657475726E20656C656D656E743B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A20417474616368206120626F756E6461727920656C656D656E7420746F2074686520676976656E20686F73742E5C6E202A5C';
wwv_flow_imp.g_varchar2_table(3541) := '6E202A2040706172616D207B4D6F64646C65456C656D656E747D20626F756E6461727953656D616E7469635C6E202A2040706172616D207B53686170657D20626F756E64617279456C656D656E745C6E202A2F5C6E42706D6E496D706F727465722E7072';
wwv_flow_imp.g_varchar2_table(3542) := '6F746F747970652E5F617474616368426F756E64617279203D2066756E6374696F6E28626F756E6461727953656D616E7469632C20626F756E64617279456C656D656E7429207B5C6E202076617220686F737453656D616E746963203D20626F756E6461';
wwv_flow_imp.g_varchar2_table(3543) := '727953656D616E7469632E6174746163686564546F5265663B5C6E5C6E20206966202821686F737453656D616E74696329207B5C6E202020207468726F77206E6577204572726F72285C6E202020202020606D697373696E6720247B20656C656D656E74';
wwv_flow_imp.g_varchar2_table(3544) := '546F537472696E6728626F756E6461727953656D616E74696329207D236174746163686564546F526566605C6E20202020293B5C6E20207D5C6E5C6E202076617220686F7374203D20746869732E5F656C656D656E7452656769737472792E6765742868';
wwv_flow_imp.g_varchar2_table(3545) := '6F737453656D616E7469632E6964292C5C6E202020202020617474616368657273203D20686F737420262620686F73742E6174746163686572733B5C6E5C6E20206966202821686F737429207B5C6E202020207468726F77206E6F74596574447261776E';
wwv_flow_imp.g_varchar2_table(3546) := '28626F756E6461727953656D616E7469632C20686F737453656D616E7469632C20276174746163686564546F52656627293B5C6E20207D5C6E5C6E20202F2F207769726520656C656D656E742E686F7374203C3E20686F73742E6174746163686572735C';
wwv_flow_imp.g_varchar2_table(3547) := '6E2020626F756E64617279456C656D656E742E686F7374203D20686F73743B5C6E5C6E2020696620282161747461636865727329207B5C6E20202020686F73742E617474616368657273203D20617474616368657273203D205B5D3B5C6E20207D5C6E5C';
wwv_flow_imp.g_varchar2_table(3548) := '6E2020696620286174746163686572732E696E6465784F6628626F756E64617279456C656D656E7429203D3D3D202D3129207B5C6E202020206174746163686572732E7075736828626F756E64617279456C656D656E74293B5C6E20207D5C6E7D3B5C6E';
wwv_flow_imp.g_varchar2_table(3549) := '5C6E5C6E2F2A2A5C6E202A204164642061206C6162656C20746F206120676976656E20656C656D656E742E5C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D2073656D616E7469635C6E202A2040706172616D207B4D6F6464';
wwv_flow_imp.g_varchar2_table(3550) := '6C65456C656D656E747D2064695C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B4C6162656C7D5C6E202A2F5C6E42706D6E496D706F727465722E70726F746F747970652E6164644C';
wwv_flow_imp.g_varchar2_table(3551) := '6162656C203D2066756E6374696F6E2873656D616E7469632C2064692C20656C656D656E7429207B5C6E202076617220626F756E64732C5C6E202020202020746578742C5C6E2020202020206C6162656C3B5C6E5C6E2020626F756E6473203D20676574';
wwv_flow_imp.g_varchar2_table(3552) := '45787465726E616C4C6162656C426F756E64732864692C20656C656D656E74293B5C6E5C6E202074657874203D206765744C6162656C28656C656D656E74293B5C6E5C6E2020696620287465787429207B5C6E5C6E202020202F2F2067657420636F7272';
wwv_flow_imp.g_varchar2_table(3553) := '656374656420626F756E64732066726F6D2061637475616C206C61796F7574656420746578745C6E20202020626F756E6473203D20746869732E5F7465787452656E64657265722E67657445787465726E616C4C6162656C426F756E647328626F756E64';
wwv_flow_imp.g_varchar2_table(3554) := '732C2074657874293B5C6E20207D5C6E5C6E20206C6162656C203D20746869732E5F656C656D656E74466163746F72792E6372656174654C6162656C28656C656D656E74446174612873656D616E7469632C2064692C207B5C6E2020202069643A207365';
wwv_flow_imp.g_varchar2_table(3555) := '6D616E7469632E6964202B20275F6C6162656C272C5C6E202020206C6162656C5461726765743A20656C656D656E742C5C6E20202020747970653A20276C6162656C272C5C6E2020202068696464656E3A20656C656D656E742E68696464656E207C7C20';
wwv_flow_imp.g_varchar2_table(3556) := '216765744C6162656C28656C656D656E74292C5C6E20202020783A204D6174682E726F756E6428626F756E64732E78292C5C6E20202020793A204D6174682E726F756E6428626F756E64732E79292C5C6E2020202077696474683A204D6174682E726F75';
wwv_flow_imp.g_varchar2_table(3557) := '6E6428626F756E64732E7769647468292C5C6E202020206865696768743A204D6174682E726F756E6428626F756E64732E686569676874295C6E20207D29293B5C6E5C6E202072657475726E20746869732E5F63616E7661732E6164645368617065286C';
wwv_flow_imp.g_varchar2_table(3558) := '6162656C2C20656C656D656E742E706172656E74293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204765742074686520736F75726365206F7220746172676574206F662074686520676976656E20636F6E6E656374696F6E2E5C6E202A5C6E202A2040706172';
wwv_flow_imp.g_varchar2_table(3559) := '616D207B4D6F64646C65456C656D656E747D2073656D616E7469635C6E202A2040706172616D207B27736F7572636527207C2027746172676574277D20736964655C6E202A5C6E202A204072657475726E207B456C656D656E747D5C6E202A2F5C6E4270';
wwv_flow_imp.g_varchar2_table(3560) := '6D6E496D706F727465722E70726F746F747970652E5F676574436F6E6E6563746564456C656D656E74203D2066756E6374696F6E2873656D616E7469632C207369646529207B5C6E5C6E202076617220656C656D656E742C5C6E20202020202072656653';
wwv_flow_imp.g_varchar2_table(3561) := '656D616E7469632C5C6E20202020202074797065203D2073656D616E7469632E24747970653B5C6E5C6E202072656653656D616E746963203D2073656D616E7469635B73696465202B2027526566275D3B5C6E5C6E20202F2F2068616E646C65206D7973';
wwv_flow_imp.g_varchar2_table(3562) := '746572696F75732069734D616E7920446174614173736F63696174696F6E23736F757263655265665C6E20206966202873696465203D3D3D2027736F75726365272026262074797065203D3D3D202762706D6E3A44617461496E7075744173736F636961';
wwv_flow_imp.g_varchar2_table(3563) := '74696F6E2729207B5C6E2020202072656653656D616E746963203D2072656653656D616E7469632026262072656653656D616E7469635B305D3B5C6E20207D5C6E5C6E20202F2F2066697820736F75726365202F2074617267657420666F722044617461';
wwv_flow_imp.g_varchar2_table(3564) := '496E7075744173736F63696174696F6E202F20446174614F75747075744173736F63696174696F6E5C6E20206966202873696465203D3D3D2027736F75726365272026262074797065203D3D3D202762706D6E3A446174614F75747075744173736F6369';
wwv_flow_imp.g_varchar2_table(3565) := '6174696F6E27207C7C5C6E20202020202073696465203D3D3D2027746172676574272026262074797065203D3D3D202762706D6E3A44617461496E7075744173736F63696174696F6E2729207B5C6E5C6E2020202072656653656D616E746963203D2073';
wwv_flow_imp.g_varchar2_table(3566) := '656D616E7469632E24706172656E743B5C6E20207D5C6E5C6E2020656C656D656E74203D2072656653656D616E74696320262620746869732E5F676574456C656D656E742872656653656D616E746963293B5C6E5C6E202069662028656C656D656E7429';
wwv_flow_imp.g_varchar2_table(3567) := '207B5C6E2020202072657475726E20656C656D656E743B5C6E20207D5C6E5C6E20206966202872656653656D616E74696329207B5C6E202020207468726F77206E6F74596574447261776E2873656D616E7469632C2072656653656D616E7469632C2073';
wwv_flow_imp.g_varchar2_table(3568) := '696465202B202752656627293B5C6E20207D20656C7365207B5C6E202020207468726F77206E6577204572726F72285C6E20202020202060247B20656C656D656E74546F537472696E672873656D616E74696329207D23247B2073696465207D20526566';
wwv_flow_imp.g_varchar2_table(3569) := '206E6F7420737065636966696564605C6E20202020293B5C6E20207D5C6E7D3B5C6E5C6E42706D6E496D706F727465722E70726F746F747970652E5F676574536F75726365203D2066756E6374696F6E2873656D616E74696329207B5C6E202072657475';
wwv_flow_imp.g_varchar2_table(3570) := '726E20746869732E5F676574436F6E6E6563746564456C656D656E742873656D616E7469632C2027736F7572636527293B5C6E7D3B5C6E5C6E42706D6E496D706F727465722E70726F746F747970652E5F676574546172676574203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(3571) := '6E2873656D616E74696329207B5C6E202072657475726E20746869732E5F676574436F6E6E6563746564456C656D656E742873656D616E7469632C202774617267657427293B5C6E7D3B5C6E5C6E5C6E42706D6E496D706F727465722E70726F746F7479';
wwv_flow_imp.g_varchar2_table(3572) := '70652E5F676574456C656D656E74203D2066756E6374696F6E2873656D616E74696329207B5C6E202072657475726E20746869732E5F656C656D656E7452656769737472792E6765742873656D616E7469632E6964293B5C6E7D3B5C6E5C6E5C6E2F2F20';
wwv_flow_imp.g_varchar2_table(3573) := '68656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E206973506F696E74496E7369646542426F782862626F782C20706F696E7429207B5C6E20207661722078203D20706F696E742E782C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(3574) := '2079203D20706F696E742E793B5C6E5C6E202072657475726E2078203E3D2062626F782E782026265C6E2020202078203C3D2062626F782E78202B2062626F782E77696474682026265C6E2020202079203E3D2062626F782E792026265C6E2020202079';
wwv_flow_imp.g_varchar2_table(3575) := '203C3D2062626F782E79202B2062626F782E6865696768743B5C6E7D5C6E5C6E66756E6374696F6E2069734672616D65456C656D656E742873656D616E74696329207B5C6E202072657475726E2069732873656D616E7469632C202762706D6E3A47726F';
wwv_flow_imp.g_varchar2_table(3576) := '757027293B5C6E7D5C6E222C22696D706F7274207B5C6E202066696C7465722C5C6E202066696E642C5C6E2020666F72456163685C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E2020656C656D656E74546F537472';
wwv_flow_imp.g_varchar2_table(3577) := '696E675C6E7D2066726F6D20272E2F5574696C273B5C6E5C6E696D706F7274207B5C6E2020656E73757265436F6D70617444695265665C6E7D2066726F6D20272E2E2F7574696C2F436F6D7061746962696C6974795574696C273B5C6E5C6E2F2A2A5C6E';
wwv_flow_imp.g_varchar2_table(3578) := '202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A2052657475726E7320747275652069662061';
wwv_flow_imp.g_varchar2_table(3579) := '6E20656C656D656E74206973206F662074686520676976656E206D6574612D6D6F64656C20747970652E5C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D20656C656D656E745C6E202A2040706172616D207B737472696E67';
wwv_flow_imp.g_varchar2_table(3580) := '7D20747970655C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E66756E6374696F6E20697328656C656D656E742C207479706529207B5C6E202072657475726E20656C656D656E742E24696E7374616E63654F66287479';
wwv_flow_imp.g_varchar2_table(3581) := '7065293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2046696E642061207375697461626C6520646973706C61792063616E64696461746520666F7220646566696E6974696F6E732077686572652074686520444920646F6573206E6F745C6E202A20636F72';
wwv_flow_imp.g_varchar2_table(3582) := '726563746C792073706563696679206F6E652E5C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D20646566696E6974696F6E735C6E202A5C6E202A204072657475726E207B4D6F64646C65456C656D656E747D5C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(3583) := '6E66756E6374696F6E2066696E64446973706C617943616E64696461746528646566696E6974696F6E7329207B5C6E202072657475726E2066696E6428646566696E6974696F6E732E726F6F74456C656D656E74732C2066756E6374696F6E286529207B';
wwv_flow_imp.g_varchar2_table(3584) := '5C6E2020202072657475726E20697328652C202762706D6E3A50726F636573732729207C7C20697328652C202762706D6E3A436F6C6C61626F726174696F6E27293B5C6E20207D293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B5265636F';
wwv_flow_imp.g_varchar2_table(3585) := '72643C27656C656D656E7427207C2027726F6F7427207C20276572726F72272C2046756E6374696F6E3E7D2068616E646C65725C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E2042706D6E5472656557616C6B65722868616E';
wwv_flow_imp.g_varchar2_table(3586) := '646C657229207B5C6E5C6E20202F2F206C697374206F6620636F6E7461696E65727320616C72656164792077616C6B65645C6E20207661722068616E646C6564456C656D656E7473203D207B7D3B5C6E5C6E20202F2F206C697374206F6620656C656D65';
wwv_flow_imp.g_varchar2_table(3587) := '6E747320746F2068616E646C6520646566657272656420746F20656E737572655C6E20202F2F20707265726571756973697465732061726520647261776E5C6E2020766172206465666572726564203D205B5D3B5C6E5C6E20207661722064694D617020';
wwv_flow_imp.g_varchar2_table(3588) := '3D207B7D3B5C6E5C6E20202F2F2048656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E202066756E6374696F6E20636F6E7465787475616C28666E2C2063747829207B5C6E2020202072657475726E2066756E6374696F';
wwv_flow_imp.g_varchar2_table(3589) := '6E286529207B5C6E202020202020666E28652C20637478293B5C6E202020207D3B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C656428656C656D656E7429207B5C6E2020202068616E646C6564456C656D656E74735B656C656D656E74';
wwv_flow_imp.g_varchar2_table(3590) := '2E69645D203D20656C656D656E743B5C6E20207D5C6E5C6E202066756E6374696F6E20697348616E646C656428656C656D656E7429207B5C6E2020202072657475726E2068616E646C6564456C656D656E74735B656C656D656E742E69645D3B5C6E2020';
wwv_flow_imp.g_varchar2_table(3591) := '7D5C6E5C6E202066756E6374696F6E20766973697428656C656D656E742C2063747829207B5C6E5C6E2020202076617220676678203D20656C656D656E742E6766783B5C6E5C6E202020202F2F2061766F6964206D756C7469706C652072656E64657269';
wwv_flow_imp.g_varchar2_table(3592) := '6E67206F6620656C656D656E74735C6E202020206966202867667829207B5C6E2020202020207468726F77206E6577204572726F72285C6E202020202020202060616C72656164792072656E646572656420247B20656C656D656E74546F537472696E67';
wwv_flow_imp.g_varchar2_table(3593) := '28656C656D656E7429207D605C6E202020202020293B5C6E202020207D5C6E5C6E202020202F2F2063616C6C2068616E646C65725C6E2020202072657475726E2068616E646C65722E656C656D656E7428656C656D656E742C2064694D61705B656C656D';
wwv_flow_imp.g_varchar2_table(3594) := '656E742E69645D2C20637478293B5C6E20207D5C6E5C6E202066756E6374696F6E207669736974526F6F7428656C656D656E742C206469616772616D29207B5C6E2020202072657475726E2068616E646C65722E726F6F7428656C656D656E742C206469';
wwv_flow_imp.g_varchar2_table(3595) := '4D61705B656C656D656E742E69645D2C206469616772616D293B5C6E20207D5C6E5C6E202066756E6374696F6E2076697369744966446928656C656D656E742C2063747829207B5C6E5C6E20202020747279207B5C6E2020202020207661722067667820';
wwv_flow_imp.g_varchar2_table(3596) := '3D2064694D61705B656C656D656E742E69645D20262620766973697428656C656D656E742C20637478293B5C6E5C6E20202020202068616E646C656428656C656D656E74293B5C6E5C6E20202020202072657475726E206766783B5C6E202020207D2063';
wwv_flow_imp.g_varchar2_table(3597) := '6174636820286572726F7229207B5C6E2020202020206C6F674572726F72286572726F722E6D6573736167652C207B20656C656D656E742C206572726F72207D293B5C6E5C6E202020202020636F6E736F6C652E6572726F7228606661696C656420746F';
wwv_flow_imp.g_varchar2_table(3598) := '20696D706F727420247B20656C656D656E74546F537472696E6728656C656D656E7429207D602C206572726F72293B5C6E202020207D5C6E20207D5C6E5C6E202066756E6374696F6E206C6F674572726F72286D6573736167652C20636F6E7465787429';
wwv_flow_imp.g_varchar2_table(3599) := '207B5C6E2020202068616E646C65722E6572726F72286D6573736167652C20636F6E74657874293B5C6E20207D5C6E5C6E20202F2F2044492068616E646C696E67202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E2020766172207265';
wwv_flow_imp.g_varchar2_table(3600) := '6769737465724469203D20746869732E72656769737465724469203D2066756E6374696F6E207265676973746572446928646929207B5C6E202020207661722062706D6E456C656D656E74203D2064692E62706D6E456C656D656E743B5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(3601) := '206966202862706D6E456C656D656E7429207B5C6E2020202020206966202864694D61705B62706D6E456C656D656E742E69645D29207B5C6E20202020202020206C6F674572726F72285C6E20202020202020202020606D756C7469706C652044492065';
wwv_flow_imp.g_varchar2_table(3602) := '6C656D656E747320646566696E656420666F7220247B20656C656D656E74546F537472696E672862706D6E456C656D656E7429207D602C5C6E202020202020202020207B20656C656D656E743A2062706D6E456C656D656E74207D5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(3603) := '20293B5C6E2020202020207D20656C7365207B5C6E202020202020202064694D61705B62706D6E456C656D656E742E69645D203D2064693B5C6E5C6E2020202020202020656E73757265436F6D70617444695265662862706D6E456C656D656E74293B5C';
wwv_flow_imp.g_varchar2_table(3604) := '6E2020202020207D5C6E202020207D20656C7365207B5C6E2020202020206C6F674572726F72285C6E2020202020202020606E6F2062706D6E456C656D656E74207265666572656E63656420696E20247B20656C656D656E74546F537472696E67286469';
wwv_flow_imp.g_varchar2_table(3605) := '29207D602C5C6E20202020202020207B20656C656D656E743A206469207D5C6E202020202020293B5C6E202020207D5C6E20207D3B5C6E5C6E202066756E6374696F6E2068616E646C654469616772616D286469616772616D29207B5C6E202020206861';
wwv_flow_imp.g_varchar2_table(3606) := '6E646C65506C616E65286469616772616D2E706C616E65293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65506C616E6528706C616E6529207B5C6E202020207265676973746572446928706C616E65293B5C6E5C6E20202020666F72';
wwv_flow_imp.g_varchar2_table(3607) := '4561636828706C616E652E706C616E65456C656D656E742C2068616E646C65506C616E65456C656D656E74293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65506C616E65456C656D656E7428706C616E65456C656D656E7429207B5C';
wwv_flow_imp.g_varchar2_table(3608) := '6E202020207265676973746572446928706C616E65456C656D656E74293B5C6E20207D5C6E5C6E5C6E20202F2F2053656D616E7469632068616E646C696E67202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E20202F2A2A5C6E202020';
wwv_flow_imp.g_varchar2_table(3609) := '2A2048616E646C6520646566696E6974696F6E7320616E642072657475726E207468652072656E6465726564206469616772616D2028696620616E79292E5C6E2020202A5C6E2020202A2040706172616D207B4D6F64646C65456C656D656E747D206465';
wwv_flow_imp.g_varchar2_table(3610) := '66696E6974696F6E7320746F2077616C6B20616E6420696D706F72745C6E2020202A2040706172616D207B4D6F64646C65456C656D656E747D205B6469616772616D5D207370656369666963206469616772616D20746F20696D706F727420616E642064';
wwv_flow_imp.g_varchar2_table(3611) := '6973706C61795C6E2020202A5C6E2020202A20407468726F7773207B4572726F727D206966206E6F206469616772616D20746F20646973706C617920636F756C6420626520666F756E645C6E2020202A2F5C6E2020746869732E68616E646C6544656669';
wwv_flow_imp.g_varchar2_table(3612) := '6E6974696F6E73203D2066756E6374696F6E2068616E646C65446566696E6974696F6E7328646566696E6974696F6E732C206469616772616D29207B5C6E5C6E202020202F2F206D616B6520737572652077652077616C6B2074686520636F7272656374';
wwv_flow_imp.g_varchar2_table(3613) := '2062706D6E456C656D656E745C6E5C6E20202020766172206469616772616D73203D20646566696E6974696F6E732E6469616772616D733B5C6E5C6E20202020696620286469616772616D202626206469616772616D732E696E6465784F662864696167';
wwv_flow_imp.g_varchar2_table(3614) := '72616D29203D3D3D202D3129207B5C6E2020202020207468726F77206E6577204572726F7228276469616772616D206E6F742070617274206F66203C62706D6E3A446566696E6974696F6E73202F3E27293B5C6E202020207D5C6E5C6E20202020696620';
wwv_flow_imp.g_varchar2_table(3615) := '28216469616772616D202626206469616772616D73202626206469616772616D732E6C656E67746829207B5C6E2020202020206469616772616D203D206469616772616D735B305D3B5C6E202020207D5C6E5C6E202020202F2F206E6F20646961677261';
wwv_flow_imp.g_varchar2_table(3616) := '6D202D3E206E6F7468696E6720746F20696D706F72745C6E2020202069662028216469616772616D29207B5C6E2020202020207468726F77206E6577204572726F7228276E6F206469616772616D20746F20646973706C617927293B5C6E202020207D5C';
wwv_flow_imp.g_varchar2_table(3617) := '6E5C6E202020202F2F206C6F61642044492066726F6D2073656C6563746564206469616772616D206F6E6C795C6E2020202064694D6170203D207B7D3B5C6E2020202068616E646C654469616772616D286469616772616D293B5C6E5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(3618) := '76617220706C616E65203D206469616772616D2E706C616E653B5C6E5C6E202020206966202821706C616E6529207B5C6E2020202020207468726F77206E6577204572726F72285C6E2020202020202020606E6F20706C616E6520666F7220247B20656C';
wwv_flow_imp.g_varchar2_table(3619) := '656D656E74546F537472696E67286469616772616D29207D605C6E202020202020293B5C6E202020207D5C6E5C6E2020202076617220726F6F74456C656D656E74203D20706C616E652E62706D6E456C656D656E743B5C6E5C6E202020202F2F20656E73';
wwv_flow_imp.g_varchar2_table(3620) := '7572652077652064656661756C7420746F2061207375697461626C6520646973706C61792063616E646964617465202870726F63657373206F7220636F6C6C61626F726174696F6E292C5C6E202020202F2F206576656E206966206E6F6E206973207370';
wwv_flow_imp.g_varchar2_table(3621) := '6563696669656420696E2044495C6E202020206966202821726F6F74456C656D656E7429207B5C6E202020202020726F6F74456C656D656E74203D2066696E64446973706C617943616E64696461746528646566696E6974696F6E73293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(3622) := '202020206966202821726F6F74456C656D656E7429207B5C6E20202020202020207468726F77206E6577204572726F7228276E6F2070726F63657373206F7220636F6C6C61626F726174696F6E20746F20646973706C617927293B5C6E2020202020207D';
wwv_flow_imp.g_varchar2_table(3623) := '20656C7365207B5C6E5C6E20202020202020206C6F674572726F72285C6E2020202020202020202060636F7272656374696E67206D697373696E672062706D6E456C656D656E74206F6E20247B20656C656D656E74546F537472696E6728706C616E6529';
wwv_flow_imp.g_varchar2_table(3624) := '207D20746F20247B20656C656D656E74546F537472696E6728726F6F74456C656D656E7429207D605C6E2020202020202020293B5C6E5C6E20202020202020202F2F20636F7272656374204449206F6E2074686520666C795C6E2020202020202020706C';
wwv_flow_imp.g_varchar2_table(3625) := '616E652E62706D6E456C656D656E74203D20726F6F74456C656D656E743B5C6E20202020202020207265676973746572446928706C616E65293B5C6E2020202020207D5C6E202020207D5C6E5C6E5C6E2020202076617220637478203D20766973697452';
wwv_flow_imp.g_varchar2_table(3626) := '6F6F7428726F6F74456C656D656E742C20706C616E65293B5C6E5C6E2020202069662028697328726F6F74456C656D656E742C202762706D6E3A50726F636573732729207C7C20697328726F6F74456C656D656E742C202762706D6E3A53756250726F63';
wwv_flow_imp.g_varchar2_table(3627) := '657373272929207B5C6E20202020202068616E646C6550726F6365737328726F6F74456C656D656E742C20637478293B5C6E202020207D20656C73652069662028697328726F6F74456C656D656E742C202762706D6E3A436F6C6C61626F726174696F6E';
wwv_flow_imp.g_varchar2_table(3628) := '272929207B5C6E20202020202068616E646C65436F6C6C61626F726174696F6E28726F6F74456C656D656E742C20637478293B5C6E5C6E2020202020202F2F20666F7263652064726177696E67206F662065766572797468696E67206E6F742079657420';
wwv_flow_imp.g_varchar2_table(3629) := '647261776E20746861742069732070617274206F6620746865207461726765742044495C6E20202020202068616E646C65556E68616E646C656450726F63657373657328646566696E6974696F6E732E726F6F74456C656D656E74732C20637478293B5C';
wwv_flow_imp.g_varchar2_table(3630) := '6E202020207D20656C7365207B5C6E2020202020207468726F77206E6577204572726F72285C6E202020202020202060756E737570706F727465642062706D6E456C656D656E7420666F7220247B20656C656D656E74546F537472696E6728706C616E65';
wwv_flow_imp.g_varchar2_table(3631) := '29207D3A20247B20656C656D656E74546F537472696E6728726F6F74456C656D656E7429207D605C6E202020202020293B5C6E202020207D5C6E5C6E202020202F2F2068616E646C6520616C6C20646566657272656420656C656D656E74735C6E202020';
wwv_flow_imp.g_varchar2_table(3632) := '2068616E646C654465666572726564286465666572726564293B5C6E20207D3B5C6E5C6E20207661722068616E646C654465666572726564203D20746869732E68616E646C654465666572726564203D2066756E6374696F6E2068616E646C6544656665';
wwv_flow_imp.g_varchar2_table(3633) := '727265642829207B5C6E5C6E2020202076617220666E3B5C6E5C6E202020202F2F20647261696E20646566657272656420756E74696C20656D7074795C6E202020207768696C65202864656665727265642E6C656E67746829207B5C6E20202020202066';
wwv_flow_imp.g_varchar2_table(3634) := '6E203D2064656665727265642E736869667428293B5C6E5C6E202020202020666E28293B5C6E202020207D5C6E20207D3B5C6E5C6E202066756E6374696F6E2068616E646C6550726F636573732870726F636573732C20636F6E7465787429207B5C6E20';
wwv_flow_imp.g_varchar2_table(3635) := '20202068616E646C65466C6F77456C656D656E7473436F6E7461696E65722870726F636573732C20636F6E74657874293B5C6E2020202068616E646C65496F53706563696669636174696F6E2870726F636573732E696F53706563696669636174696F6E';
wwv_flow_imp.g_varchar2_table(3636) := '2C20636F6E74657874293B5C6E5C6E2020202068616E646C654172746966616374732870726F636573732E6172746966616374732C20636F6E74657874293B5C6E5C6E202020202F2F206C6F672070726F636573732068616E646C65645C6E2020202068';
wwv_flow_imp.g_varchar2_table(3637) := '616E646C65642870726F63657373293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65556E68616E646C656450726F63657373657328726F6F74456C656D656E74732C2063747829207B5C6E5C6E202020202F2F2077616C6B20746872';
wwv_flow_imp.g_varchar2_table(3638) := '6F75676820616C6C2070726F63657373657320746861742068617665206E6F7420796574206265656E20647261776E20616E642064726177207468656D5C6E202020202F2F206966207468657920636F6E7461696E206C616E6573207769746820444920';
wwv_flow_imp.g_varchar2_table(3639) := '696E666F726D6174696F6E2E5C6E202020202F2F20776520646F207468697320746F20706173732074686520667265652D666C6F6174696E67206C616E65207465737420636173657320696E20746865204D49574720746573742073756974655C6E2020';
wwv_flow_imp.g_varchar2_table(3640) := '20207661722070726F636573736573203D2066696C74657228726F6F74456C656D656E74732C2066756E6374696F6E286529207B5C6E20202020202072657475726E2021697348616E646C656428652920262620697328652C202762706D6E3A50726F63';
wwv_flow_imp.g_varchar2_table(3641) := '657373272920262620652E6C616E65536574733B5C6E202020207D293B5C6E5C6E2020202070726F6365737365732E666F724561636828636F6E7465787475616C2868616E646C6550726F636573732C2063747829293B5C6E20207D5C6E5C6E20206675';
wwv_flow_imp.g_varchar2_table(3642) := '6E6374696F6E2068616E646C654D657373616765466C6F77286D657373616765466C6F772C20636F6E7465787429207B5C6E20202020766973697449664469286D657373616765466C6F772C20636F6E74657874293B5C6E20207D5C6E5C6E202066756E';
wwv_flow_imp.g_varchar2_table(3643) := '6374696F6E2068616E646C654D657373616765466C6F7773286D657373616765466C6F77732C20636F6E7465787429207B5C6E20202020666F7245616368286D657373616765466C6F77732C20636F6E7465787475616C2868616E646C654D6573736167';
wwv_flow_imp.g_varchar2_table(3644) := '65466C6F772C20636F6E7465787429293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65446174614173736F63696174696F6E286173736F63696174696F6E2C20636F6E7465787429207B5C6E20202020766973697449664469286173';
wwv_flow_imp.g_varchar2_table(3645) := '736F63696174696F6E2C20636F6E74657874293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C6544617461496E7075742864617461496E7075742C20636F6E7465787429207B5C6E202020207669736974496644692864617461496E70';
wwv_flow_imp.g_varchar2_table(3646) := '75742C20636F6E74657874293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65446174614F757470757428646174614F75747075742C20636F6E7465787429207B5C6E2020202076697369744966446928646174614F75747075742C20';
wwv_flow_imp.g_varchar2_table(3647) := '636F6E74657874293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C6541727469666163742861727469666163742C20636F6E7465787429207B5C6E5C6E202020202F2F2062706D6E3A54657874416E6E6F746174696F6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(3648) := '2F2F2062706D6E3A47726F75705C6E202020202F2F2062706D6E3A4173736F63696174696F6E5C6E5C6E202020207669736974496644692861727469666163742C20636F6E74657874293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C';
wwv_flow_imp.g_varchar2_table(3649) := '65417274696661637473286172746966616374732C20636F6E7465787429207B5C6E5C6E20202020666F7245616368286172746966616374732C2066756E6374696F6E286529207B5C6E20202020202069662028697328652C202762706D6E3A4173736F';
wwv_flow_imp.g_varchar2_table(3650) := '63696174696F6E272929207B5C6E202020202020202064656665727265642E707573682866756E6374696F6E2829207B5C6E2020202020202020202068616E646C65417274696661637428652C20636F6E74657874293B5C6E20202020202020207D293B';
wwv_flow_imp.g_varchar2_table(3651) := '5C6E2020202020207D20656C7365207B5C6E202020202020202068616E646C65417274696661637428652C20636F6E74657874293B5C6E2020202020207D5C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65496F53';
wwv_flow_imp.g_varchar2_table(3652) := '706563696669636174696F6E28696F53706563696669636174696F6E2C20636F6E7465787429207B5C6E5C6E202020206966202821696F53706563696669636174696F6E29207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(3653) := '20666F724561636828696F53706563696669636174696F6E2E64617461496E707574732C20636F6E7465787475616C2868616E646C6544617461496E7075742C20636F6E7465787429293B5C6E20202020666F724561636828696F537065636966696361';
wwv_flow_imp.g_varchar2_table(3654) := '74696F6E2E646174614F7574707574732C20636F6E7465787475616C2868616E646C65446174614F75747075742C20636F6E7465787429293B5C6E20207D5C6E5C6E20207661722068616E646C6553756250726F63657373203D20746869732E68616E64';
wwv_flow_imp.g_varchar2_table(3655) := '6C6553756250726F63657373203D2066756E6374696F6E2068616E646C6553756250726F636573732873756250726F636573732C20636F6E7465787429207B5C6E2020202068616E646C65466C6F77456C656D656E7473436F6E7461696E657228737562';
wwv_flow_imp.g_varchar2_table(3656) := '50726F636573732C20636F6E74657874293B5C6E2020202068616E646C654172746966616374732873756250726F636573732E6172746966616374732C20636F6E74657874293B5C6E20207D3B5C6E5C6E202066756E6374696F6E2068616E646C65466C';
wwv_flow_imp.g_varchar2_table(3657) := '6F774E6F646528666C6F774E6F64652C20636F6E7465787429207B5C6E20202020766172206368696C64437478203D2076697369744966446928666C6F774E6F64652C20636F6E74657874293B5C6E5C6E2020202069662028697328666C6F774E6F6465';
wwv_flow_imp.g_varchar2_table(3658) := '2C202762706D6E3A53756250726F63657373272929207B5C6E20202020202068616E646C6553756250726F6365737328666C6F774E6F64652C206368696C64437478207C7C20636F6E74657874293B5C6E202020207D5C6E5C6E20202020696620286973';
wwv_flow_imp.g_varchar2_table(3659) := '28666C6F774E6F64652C202762706D6E3A4163746976697479272929207B5C6E20202020202068616E646C65496F53706563696669636174696F6E28666C6F774E6F64652E696F53706563696669636174696F6E2C20636F6E74657874293B5C6E202020';
wwv_flow_imp.g_varchar2_table(3660) := '207D5C6E5C6E202020202F2F2064656665722068616E646C696E67206F66206173736F63696174696F6E735C6E202020202F2F2061666665637465642074797065733A5C6E202020202F2F5C6E202020202F2F2020202A2062706D6E3A41637469766974';
wwv_flow_imp.g_varchar2_table(3661) := '795C6E202020202F2F2020202A2062706D6E3A5468726F774576656E745C6E202020202F2F2020202A2062706D6E3A43617463684576656E745C6E202020202F2F5C6E2020202064656665727265642E707573682866756E6374696F6E2829207B5C6E20';
wwv_flow_imp.g_varchar2_table(3662) := '2020202020666F724561636828666C6F774E6F64652E64617461496E7075744173736F63696174696F6E732C20636F6E7465787475616C2868616E646C65446174614173736F63696174696F6E2C20636F6E7465787429293B5C6E202020202020666F72';
wwv_flow_imp.g_varchar2_table(3663) := '4561636828666C6F774E6F64652E646174614F75747075744173736F63696174696F6E732C20636F6E7465787475616C2868616E646C65446174614173736F63696174696F6E2C20636F6E7465787429293B5C6E202020207D293B5C6E20207D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(3664) := '202066756E6374696F6E2068616E646C6553657175656E6365466C6F772873657175656E6365466C6F772C20636F6E7465787429207B5C6E202020207669736974496644692873657175656E6365466C6F772C20636F6E74657874293B5C6E20207D5C6E';
wwv_flow_imp.g_varchar2_table(3665) := '5C6E202066756E6374696F6E2068616E646C6544617461456C656D656E7428646174614F626A6563742C20636F6E7465787429207B5C6E2020202076697369744966446928646174614F626A6563742C20636F6E74657874293B5C6E20207D5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(3666) := '2066756E6374696F6E2068616E646C654C616E65286C616E652C20636F6E7465787429207B5C6E5C6E2020202064656665727265642E707573682866756E6374696F6E2829207B5C6E5C6E202020202020766172206E6577436F6E74657874203D207669';
wwv_flow_imp.g_varchar2_table(3667) := '73697449664469286C616E652C20636F6E74657874293B5C6E5C6E202020202020696620286C616E652E6368696C644C616E6553657429207B5C6E202020202020202068616E646C654C616E65536574286C616E652E6368696C644C616E655365742C20';
wwv_flow_imp.g_varchar2_table(3668) := '6E6577436F6E74657874207C7C20636F6E74657874293B5C6E2020202020207D5C6E5C6E20202020202077697265466C6F774E6F646552656673286C616E65293B5C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65';
wwv_flow_imp.g_varchar2_table(3669) := '4C616E65536574286C616E655365742C20636F6E7465787429207B5C6E20202020666F7245616368286C616E655365742E6C616E65732C20636F6E7465787475616C2868616E646C654C616E652C20636F6E7465787429293B5C6E20207D5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(3670) := '66756E6374696F6E2068616E646C654C616E6553657473286C616E65536574732C20636F6E7465787429207B5C6E20202020666F7245616368286C616E65536574732C20636F6E7465787475616C2868616E646C654C616E655365742C20636F6E746578';
wwv_flow_imp.g_varchar2_table(3671) := '7429293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65466C6F77456C656D656E7473436F6E7461696E657228636F6E7461696E65722C20636F6E7465787429207B5C6E2020202068616E646C65466C6F77456C656D656E747328636F';
wwv_flow_imp.g_varchar2_table(3672) := '6E7461696E65722E666C6F77456C656D656E74732C20636F6E74657874293B5C6E5C6E2020202069662028636F6E7461696E65722E6C616E655365747329207B5C6E20202020202068616E646C654C616E655365747328636F6E7461696E65722E6C616E';
wwv_flow_imp.g_varchar2_table(3673) := '65536574732C20636F6E74657874293B5C6E202020207D5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65466C6F77456C656D656E747328666C6F77456C656D656E74732C20636F6E7465787429207B5C6E20202020666F724561636828';
wwv_flow_imp.g_varchar2_table(3674) := '666C6F77456C656D656E74732C2066756E6374696F6E28666C6F77456C656D656E7429207B5C6E20202020202069662028697328666C6F77456C656D656E742C202762706D6E3A53657175656E6365466C6F77272929207B5C6E20202020202020206465';
wwv_flow_imp.g_varchar2_table(3675) := '6665727265642E707573682866756E6374696F6E2829207B5C6E2020202020202020202068616E646C6553657175656E6365466C6F7728666C6F77456C656D656E742C20636F6E74657874293B5C6E20202020202020207D293B5C6E2020202020207D20';
wwv_flow_imp.g_varchar2_table(3676) := '656C73652069662028697328666C6F77456C656D656E742C202762706D6E3A426F756E646172794576656E74272929207B5C6E202020202020202064656665727265642E756E73686966742866756E6374696F6E2829207B5C6E20202020202020202020';
wwv_flow_imp.g_varchar2_table(3677) := '68616E646C65466C6F774E6F646528666C6F77456C656D656E742C20636F6E74657874293B5C6E20202020202020207D293B5C6E2020202020207D20656C73652069662028697328666C6F77456C656D656E742C202762706D6E3A466C6F774E6F646527';
wwv_flow_imp.g_varchar2_table(3678) := '2929207B5C6E202020202020202068616E646C65466C6F774E6F646528666C6F77456C656D656E742C20636F6E74657874293B5C6E2020202020207D20656C73652069662028697328666C6F77456C656D656E742C202762706D6E3A446174614F626A65';
wwv_flow_imp.g_varchar2_table(3679) := '6374272929207B5C6E5C6E20202020202020202F2F20534B49502028617373756D6520636F7272656374207265666572656E63696E672076696120446174614F626A6563745265666572656E6365295C6E2020202020207D20656C736520696620286973';
wwv_flow_imp.g_varchar2_table(3680) := '28666C6F77456C656D656E742C202762706D6E3A4461746153746F72655265666572656E6365272929207B5C6E202020202020202068616E646C6544617461456C656D656E7428666C6F77456C656D656E742C20636F6E74657874293B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(3681) := '207D20656C73652069662028697328666C6F77456C656D656E742C202762706D6E3A446174614F626A6563745265666572656E6365272929207B5C6E202020202020202068616E646C6544617461456C656D656E7428666C6F77456C656D656E742C2063';
wwv_flow_imp.g_varchar2_table(3682) := '6F6E74657874293B5C6E2020202020207D20656C7365207B5C6E20202020202020206C6F674572726F72285C6E2020202020202020202060756E7265636F676E697A656420666C6F77456C656D656E7420247B20656C656D656E74546F537472696E6728';
wwv_flow_imp.g_varchar2_table(3683) := '666C6F77456C656D656E7429207D20696E20636F6E7465787420247B20656C656D656E74546F537472696E6728636F6E7465787420262620636F6E746578742E627573696E6573734F626A65637429207D602C5C6E202020202020202020207B5C6E2020';
wwv_flow_imp.g_varchar2_table(3684) := '20202020202020202020656C656D656E743A20666C6F77456C656D656E742C5C6E202020202020202020202020636F6E746578745C6E202020202020202020207D5C6E2020202020202020293B5C6E2020202020207D5C6E202020207D293B5C6E20207D';
wwv_flow_imp.g_varchar2_table(3685) := '5C6E5C6E202066756E6374696F6E2068616E646C655061727469636970616E74287061727469636970616E742C20636F6E7465787429207B5C6E20202020766172206E6577437478203D20766973697449664469287061727469636970616E742C20636F';
wwv_flow_imp.g_varchar2_table(3686) := '6E74657874293B5C6E5C6E202020207661722070726F63657373203D207061727469636970616E742E70726F636573735265663B5C6E202020206966202870726F6365737329207B5C6E20202020202068616E646C6550726F636573732870726F636573';
wwv_flow_imp.g_varchar2_table(3687) := '732C206E6577437478207C7C20636F6E74657874293B5C6E202020207D5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65436F6C6C61626F726174696F6E28636F6C6C61626F726174696F6E2C20636F6E7465787429207B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(3688) := '2020666F724561636828636F6C6C61626F726174696F6E2E7061727469636970616E74732C20636F6E7465787475616C2868616E646C655061727469636970616E742C20636F6E7465787429293B5C6E5C6E2020202068616E646C654172746966616374';
wwv_flow_imp.g_varchar2_table(3689) := '7328636F6C6C61626F726174696F6E2E6172746966616374732C20636F6E74657874293B5C6E5C6E202020202F2F2068616E646C65206D65737361676520666C6F7773206C617465737420696E207468652070726F636573735C6E202020206465666572';
wwv_flow_imp.g_varchar2_table(3690) := '7265642E707573682866756E6374696F6E2829207B5C6E20202020202068616E646C654D657373616765466C6F777328636F6C6C61626F726174696F6E2E6D657373616765466C6F77732C20636F6E74657874293B5C6E202020207D293B5C6E20207D5C';
wwv_flow_imp.g_varchar2_table(3691) := '6E5C6E5C6E202066756E6374696F6E2077697265466C6F774E6F646552656673286C616E6529207B5C6E5C6E202020202F2F207769726520746865207669727475616C20666C6F774E6F646552656673203C2D3E2072656C6174696F6E736869705C6E20';
wwv_flow_imp.g_varchar2_table(3692) := '202020666F7245616368286C616E652E666C6F774E6F64655265662C2066756E6374696F6E28666C6F774E6F646529207B5C6E202020202020766172206C616E6573203D20666C6F774E6F64652E67657428276C616E657327293B5C6E5C6E2020202020';
wwv_flow_imp.g_varchar2_table(3693) := '20696620286C616E657329207B5C6E20202020202020206C616E65732E70757368286C616E65293B5C6E2020202020207D5C6E202020207D293B5C6E20207D5C6E7D5C6E222C22696D706F7274207B5C6E202066696E642C5C6E2020666F72456163682C';
wwv_flow_imp.g_varchar2_table(3694) := '5C6E20206D61705C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F72742042706D6E5472656557616C6B65722066726F6D20272E2F42706D6E5472656557616C6B6572273B5C6E5C6E696D706F7274207B206973207D2066726F6D20';
wwv_flow_imp.g_varchar2_table(3695) := '272E2E2F7574696C2F4D6F64656C5574696C273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E745C6E20';
wwv_flow_imp.g_varchar2_table(3696) := '2A5C6E202A204074797065646566207B207B5C6E202A2020207761726E696E67733A20737472696E675B5D3B5C6E202A207D207D20496D706F727442504D4E4469616772616D526573756C745C6E202A5C6E202A204074797065646566207B496D706F72';
wwv_flow_imp.g_varchar2_table(3697) := '7442504D4E4469616772616D526573756C742026204572726F727D20496D706F727442504D4E4469616772616D4572726F725C6E202A2F5C6E5C6E2F2A2A5C6E202A20496D706F72742074686520646566696E6974696F6E7320696E746F206120646961';
wwv_flow_imp.g_varchar2_table(3698) := '6772616D2E5C6E202A5C6E202A204572726F727320616E64207761726E696E677320617265207265706F72746564207468726F75676820746865207370656369666965642063616C6C6261636B2E5C6E202A5C6E202A2040706172616D207B4D6F64646C';
wwv_flow_imp.g_varchar2_table(3699) := '65456C656D656E747D206469616772616D5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D20646566696E6974696F6E735C6E202A2040706172616D207B4D6F64646C65456C656D656E747D205B62706D6E4469616772616D5D205468';
wwv_flow_imp.g_varchar2_table(3700) := '65206469616772616D20746F2062652072656E646572656420286966206E6F745C6E202A2070726F76696465642C20746865206669727374206F6E652077696C6C2062652072656E6465726564292E5C6E202A5C6E202A204072657475726E207B50726F';
wwv_flow_imp.g_varchar2_table(3701) := '6D6973653C496D706F727442504D4E4469616772616D526573756C743E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E20696D706F727442706D6E4469616772616D286469616772616D2C20646566696E6974696F6E732C2062706D6E446961';
wwv_flow_imp.g_varchar2_table(3702) := '6772616D29207B5C6E5C6E202076617220696D706F727465722C5C6E2020202020206576656E744275732C5C6E20202020202063616E7661733B5C6E5C6E2020766172206572726F722C5C6E2020202020207761726E696E6773203D205B5D3B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(3703) := '20202F2A2A5C6E2020202A2057616C6B20746865206469616772616D2073656D616E746963616C6C792C20696D706F7274696E6720283D64726177696E67295C6E2020202A20616C6C20656C656D656E747320796F7520656E636F756E7465722E5C6E20';
wwv_flow_imp.g_varchar2_table(3704) := '20202A5C6E2020202A2040706172616D207B4D6F64646C65456C656D656E747D20646566696E6974696F6E735C6E2020202A2040706172616D207B4D6F64646C65456C656D656E747D2062706D6E4469616772616D5C6E2020202A2F5C6E202066756E63';
wwv_flow_imp.g_varchar2_table(3705) := '74696F6E2072656E64657228646566696E6974696F6E732C2062706D6E4469616772616D29207B5C6E5C6E202020207661722076697369746F72203D207B5C6E5C6E202020202020726F6F743A2066756E6374696F6E28656C656D656E742C2064692920';
wwv_flow_imp.g_varchar2_table(3706) := '7B5C6E202020202020202072657475726E20696D706F727465722E61646428656C656D656E742C206469293B5C6E2020202020207D2C5C6E5C6E202020202020656C656D656E743A2066756E6374696F6E28656C656D656E742C2064692C20706172656E';
wwv_flow_imp.g_varchar2_table(3707) := '74536861706529207B5C6E202020202020202072657475726E20696D706F727465722E61646428656C656D656E742C2064692C20706172656E745368617065293B5C6E2020202020207D2C5C6E5C6E2020202020206572726F723A2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3708) := '286D6573736167652C20636F6E7465787429207B5C6E20202020202020207761726E696E67732E70757368287B206D6573736167653A206D6573736167652C20636F6E746578743A20636F6E74657874207D293B5C6E2020202020207D5C6E202020207D';
wwv_flow_imp.g_varchar2_table(3709) := '3B5C6E5C6E202020207661722077616C6B6572203D206E65772042706D6E5472656557616C6B65722876697369746F72293B5C6E5C6E5C6E2020202062706D6E4469616772616D203D2062706D6E4469616772616D207C7C2028646566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(3710) := '732E6469616772616D7320262620646566696E6974696F6E732E6469616772616D735B305D293B5C6E5C6E20202020766172206469616772616D73546F496D706F7274203D206765744469616772616D73546F496D706F727428646566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(3711) := '732C2062706D6E4469616772616D293B5C6E5C6E2020202069662028216469616772616D73546F496D706F727429207B5C6E2020202020207468726F77206E6577204572726F7228276E6F206469616772616D20746F20646973706C617927293B5C6E20';
wwv_flow_imp.g_varchar2_table(3712) := '2020207D5C6E5C6E202020202F2F2074726176657273652042504D4E20322E3020646F63756D656E74206D6F64656C2C5C6E202020202F2F207374617274696E6720617420646566696E6974696F6E735C6E20202020666F724561636828646961677261';
wwv_flow_imp.g_varchar2_table(3713) := '6D73546F496D706F72742C2066756E6374696F6E286469616772616D29207B5C6E20202020202077616C6B65722E68616E646C65446566696E6974696F6E7328646566696E6974696F6E732C206469616772616D293B5C6E202020207D293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(3714) := '20202076617220726F6F744964203D2062706D6E4469616772616D2E706C616E652E62706D6E456C656D656E742E69643B5C6E5C6E202020202F2F20776520646F206E65656420746F206163636F756E7420666F7220646966666572656E742077617973';
wwv_flow_imp.g_varchar2_table(3715) := '2077652063726561746520726F6F7420656C656D656E74735C6E202020202F2F2065616368206E657374656420696D706F72746564203C726F6F743E20646F20686176652074686520605F706C616E6560207375666669782C207768696C655C6E202020';
wwv_flow_imp.g_varchar2_table(3716) := '202F2F2074686520726F6F74203C726F6F743E20697320666F756E6420756E6465722074686520627573696E657373206F626A6563742049445C6E2020202063616E7661732E736574526F6F74456C656D656E74285C6E20202020202063616E7661732E';
wwv_flow_imp.g_varchar2_table(3717) := '66696E64526F6F7428726F6F744964202B20275F706C616E652729207C7C2063616E7661732E66696E64526F6F7428726F6F744964295C6E20202020293B5C6E20207D5C6E5C6E202072657475726E206E65772050726F6D6973652866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3718) := '287265736F6C76652C2072656A65637429207B5C6E20202020747279207B5C6E202020202020696D706F72746572203D206469616772616D2E676574282762706D6E496D706F7274657227293B5C6E2020202020206576656E74427573203D2064696167';
wwv_flow_imp.g_varchar2_table(3719) := '72616D2E67657428276576656E7442757327293B5C6E20202020202063616E766173203D206469616772616D2E676574282763616E76617327293B5C6E5C6E2020202020206576656E744275732E666972652827696D706F72742E72656E6465722E7374';
wwv_flow_imp.g_varchar2_table(3720) := '617274272C207B20646566696E6974696F6E733A20646566696E6974696F6E73207D293B5C6E5C6E20202020202072656E64657228646566696E6974696F6E732C2062706D6E4469616772616D293B5C6E5C6E2020202020206576656E744275732E6669';
wwv_flow_imp.g_varchar2_table(3721) := '72652827696D706F72742E72656E6465722E636F6D706C657465272C207B5C6E20202020202020206572726F723A206572726F722C5C6E20202020202020207761726E696E67733A207761726E696E67735C6E2020202020207D293B5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(3722) := '202072657475726E207265736F6C7665287B207761726E696E67733A207761726E696E6773207D293B5C6E202020207D20636174636820286529207B5C6E5C6E202020202020652E7761726E696E6773203D207761726E696E67733B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(3723) := '72657475726E2072656A6563742865293B5C6E202020207D5C6E20207D293B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E7320616C6C206469616772616D7320696E207468652073616D6520686965726172636879206173207468652072657175';
wwv_flow_imp.g_varchar2_table(3724) := '6573746564206469616772616D2E5C6E202A20496E636C7564657320616C6C20706172656E7420616E64207375622070726F63657373206469616772616D732E5C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D2064656669';
wwv_flow_imp.g_varchar2_table(3725) := '6E6974696F6E735C6E202A2040706172616D207B4D6F64646C65456C656D656E747D2062706D6E4469616772616D5C6E202A5C6E202A204072657475726E207B4D6F64646C65456C656D656E745B5D7D5C6E202A2F5C6E66756E6374696F6E2067657444';
wwv_flow_imp.g_varchar2_table(3726) := '69616772616D73546F496D706F727428646566696E6974696F6E732C2062706D6E4469616772616D29207B5C6E2020696620282162706D6E4469616772616D207C7C202162706D6E4469616772616D2E706C616E6529207B5C6E2020202072657475726E';
wwv_flow_imp.g_varchar2_table(3727) := '3B5C6E20207D5C6E5C6E20207661722062706D6E456C656D656E74203D2062706D6E4469616772616D2E706C616E652E62706D6E456C656D656E742C5C6E202020202020726F6F74456C656D656E74203D2062706D6E456C656D656E743B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(3728) := '696620282169732862706D6E456C656D656E742C202762706D6E3A50726F636573732729202626202169732862706D6E456C656D656E742C202762706D6E3A436F6C6C61626F726174696F6E272929207B5C6E20202020726F6F74456C656D656E74203D';
wwv_flow_imp.g_varchar2_table(3729) := '2066696E64526F6F7450726F636573732862706D6E456C656D656E74293B5C6E20207D5C6E5C6E20202F2F20696E2063617365207468652070726F636573732069732070617274206F66206120636F6C6C61626F726174696F6E2C2074686520706C616E';
wwv_flow_imp.g_varchar2_table(3730) := '65207265666572656E636573207468655C6E20202F2F20636F6C6C61626F726174696F6E2C206E6F74207468652070726F636573735C6E202076617220636F6C6C61626F726174696F6E3B5C6E5C6E202069662028697328726F6F74456C656D656E742C';
wwv_flow_imp.g_varchar2_table(3731) := '202762706D6E3A436F6C6C61626F726174696F6E272929207B5C6E20202020636F6C6C61626F726174696F6E203D20726F6F74456C656D656E743B5C6E20207D20656C7365207B5C6E20202020636F6C6C61626F726174696F6E203D2066696E64286465';
wwv_flow_imp.g_varchar2_table(3732) := '66696E6974696F6E732E726F6F74456C656D656E74732C2066756E6374696F6E28656C656D656E7429207B5C6E2020202020206966202821697328656C656D656E742C202762706D6E3A436F6C6C61626F726174696F6E272929207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(3733) := '202072657475726E3B5C6E2020202020207D5C6E5C6E20202020202072657475726E2066696E6428656C656D656E742E7061727469636970616E74732C2066756E6374696F6E287061727469636970616E7429207B5C6E20202020202020207265747572';
wwv_flow_imp.g_varchar2_table(3734) := '6E207061727469636970616E742E70726F63657373526566203D3D3D20726F6F74456C656D656E743B5C6E2020202020207D293B5C6E202020207D293B5C6E20207D5C6E5C6E202076617220726F6F74456C656D656E7473203D205B20726F6F74456C65';
wwv_flow_imp.g_varchar2_table(3735) := '6D656E74205D3B5C6E5C6E20202F2F20616C6C20636F6C6C61626F726174696F6E2070726F6365737365732063616E20636F6E7461696E207375622D6469616772616D735C6E202069662028636F6C6C61626F726174696F6E29207B5C6E20202020726F';
wwv_flow_imp.g_varchar2_table(3736) := '6F74456C656D656E7473203D206D617028636F6C6C61626F726174696F6E2E7061727469636970616E74732C2066756E6374696F6E287061727469636970616E7429207B5C6E20202020202072657475726E207061727469636970616E742E70726F6365';
wwv_flow_imp.g_varchar2_table(3737) := '73735265663B5C6E202020207D293B5C6E5C6E20202020726F6F74456C656D656E74732E7075736828636F6C6C61626F726174696F6E293B5C6E20207D5C6E5C6E202076617220616C6C4368696C6472656E203D2073656C66416E64416C6C466C6F7745';
wwv_flow_imp.g_varchar2_table(3738) := '6C656D656E747328726F6F74456C656D656E7473293B5C6E5C6E20202F2F2069662077652068617665206D756C7469706C65206469616772616D73207265666572656E63696E67207468652073616D6520656C656D656E742C2077655C6E20202F2F2075';
wwv_flow_imp.g_varchar2_table(3739) := '73652074686520666972737420696E207468652066696C655C6E2020766172206469616772616D73546F496D706F7274203D205B2062706D6E4469616772616D205D3B5C6E20207661722068616E646C6564456C656D656E7473203D205B2062706D6E45';
wwv_flow_imp.g_varchar2_table(3740) := '6C656D656E74205D3B5C6E5C6E2020666F724561636828646566696E6974696F6E732E6469616772616D732C2066756E6374696F6E286469616772616D29207B5C6E5C6E2020202069662028216469616772616D2E706C616E6529207B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(3741) := '2072657475726E3B5C6E202020207D5C6E5C6E2020202076617220627573696E6573734F626A656374203D206469616772616D2E706C616E652E62706D6E456C656D656E743B5C6E5C6E20202020696620285C6E202020202020616C6C4368696C647265';
wwv_flow_imp.g_varchar2_table(3742) := '6E2E696E6465784F6628627573696E6573734F626A6563742920213D3D202D312026265C6E20202020202068616E646C6564456C656D656E74732E696E6465784F6628627573696E6573734F626A65637429203D3D3D202D315C6E2020202029207B5C6E';
wwv_flow_imp.g_varchar2_table(3743) := '2020202020206469616772616D73546F496D706F72742E70757368286469616772616D293B5C6E20202020202068616E646C6564456C656D656E74732E7075736828627573696E6573734F626A656374293B5C6E202020207D5C6E20207D293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(3744) := '5C6E202072657475726E206469616772616D73546F496D706F72743B5C6E7D5C6E5C6E66756E6374696F6E2073656C66416E64416C6C466C6F77456C656D656E747328656C656D656E747329207B5C6E202076617220726573756C74203D205B5D3B5C6E';
wwv_flow_imp.g_varchar2_table(3745) := '5C6E2020666F724561636828656C656D656E74732C2066756E6374696F6E28656C656D656E7429207B5C6E202020206966202821656C656D656E7429207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E20202020726573756C742E70';
wwv_flow_imp.g_varchar2_table(3746) := '75736828656C656D656E74293B5C6E5C6E20202020726573756C74203D20726573756C742E636F6E6361742873656C66416E64416C6C466C6F77456C656D656E747328656C656D656E742E666C6F77456C656D656E747329293B5C6E20207D293B5C6E5C';
wwv_flow_imp.g_varchar2_table(3747) := '6E202072657475726E20726573756C743B5C6E7D5C6E5C6E66756E6374696F6E2066696E64526F6F7450726F6365737328656C656D656E7429207B5C6E202076617220706172656E74203D20656C656D656E743B5C6E5C6E20207768696C652028706172';
wwv_flow_imp.g_varchar2_table(3748) := '656E7429207B5C6E2020202069662028697328706172656E742C202762706D6E3A50726F63657373272929207B5C6E20202020202072657475726E20706172656E743B5C6E202020207D5C6E5C6E20202020706172656E74203D20706172656E742E2470';
wwv_flow_imp.g_varchar2_table(3749) := '6172656E743B5C6E20207D5C6E7D5C6E222C226578706F72742066756E6374696F6E20656C656D656E74546F537472696E67286529207B5C6E202069662028216529207B5C6E2020202072657475726E20273C6E756C6C3E273B5C6E20207D5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(3750) := '2072657475726E20273C27202B20652E2474797065202B2028652E6964203F20272069643D5C2227202B20652E6964203A20272729202B20275C22202F3E273B5C6E7D222C22696D706F7274207472616E736C6174652066726F6D20276469616772616D';
wwv_flow_imp.g_varchar2_table(3751) := '2D6A732F6C69622F6931386E2F7472616E736C617465273B5C6E5C6E696D706F72742042706D6E496D706F727465722066726F6D20272E2F42706D6E496D706F72746572273B5C6E5C6E6578706F72742064656661756C74207B5C6E20205F5F64657065';
wwv_flow_imp.g_varchar2_table(3752) := '6E64735F5F3A205B5C6E202020207472616E736C6174655C6E20205D2C5C6E202062706D6E496D706F727465723A205B202774797065272C2042706D6E496D706F72746572205D5C6E7D3B222C22696D706F7274207B5C6E20206861735C6E7D2066726F';
wwv_flow_imp.g_varchar2_table(3753) := '6D20276D696E2D64617368273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E745C6E202A2F5C6E5C6E5C6E2F';
wwv_flow_imp.g_varchar2_table(3754) := '2F20544F444F286E696B6B75293A2072656D6F76652077697468206675747572652062706D6E2D6A732076657273696F6E5C6E5C6E7661722044495F4552524F525F4D455353414745203D2027547269656420746F206163636573732064692066726F6D';
wwv_flow_imp.g_varchar2_table(3755) := '2074686520627573696E6573734F626A6563742E2054686520646920697320617661696C61626C65207468726F75676820746865206469616772616D20656C656D656E74206F6E6C792E20466F72206D6F726520696E666F726D6174696F6E2C20736565';
wwv_flow_imp.g_varchar2_table(3756) := '2068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F62706D6E2D6A732F6973737565732F31343732273B5C6E5C6E2F2A2A5C6E202A2040707269766174655C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D';
wwv_flow_imp.g_varchar2_table(3757) := '20627573696E6573734F626A6563745C6E202A2F5C6E6578706F72742066756E6374696F6E20656E73757265436F6D706174446952656628627573696E6573734F626A65637429207B5C6E5C6E20202F2F2062706D6E456C656D656E742063616E206861';
wwv_flow_imp.g_varchar2_table(3758) := '7665206D756C7469706C6520696E646570656E64656E74204449735C6E2020696620282168617328627573696E6573734F626A6563742C20276469272929207B5C6E202020204F626A6563742E646566696E6550726F706572747928627573696E657373';
wwv_flow_imp.g_varchar2_table(3759) := '4F626A6563742C20276469272C207B5C6E202020202020656E756D657261626C653A2066616C73652C5C6E2020202020206765743A2066756E6374696F6E2829207B5C6E20202020202020207468726F77206E6577204572726F722844495F4552524F52';
wwv_flow_imp.g_varchar2_table(3760) := '5F4D455353414745293B5C6E2020202020207D5C6E202020207D293B5C6E20207D5C6E7D222C22696D706F7274207B5C6E202069732C5C6E2020676574427573696E6573734F626A6563742C5C6E202067657444695C6E7D2066726F6D20272E2F4D6F64';
wwv_flow_imp.g_varchar2_table(3761) := '656C5574696C273B5C6E5C6E696D706F7274207B5C6E2020736F6D655C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D65';
wwv_flow_imp.g_varchar2_table(3762) := '6E747D20456C656D656E745C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65456C656D656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A2040706172';
wwv_flow_imp.g_varchar2_table(3763) := '616D207B456C656D656E747D20656C656D656E745C6E202A2040706172616D207B4D6F64646C65456C656D656E747D205B64695D5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3764) := '206973457870616E64656428656C656D656E742C20646929207B5C6E5C6E202069662028697328656C656D656E742C202762706D6E3A43616C6C4163746976697479272929207B5C6E2020202072657475726E2066616C73653B5C6E20207D5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(3765) := '2069662028697328656C656D656E742C202762706D6E3A53756250726F63657373272929207B5C6E202020206469203D206469207C7C20676574446928656C656D656E74293B5C6E5C6E202020206966202864692026262069732864692C202762706D6E';
wwv_flow_imp.g_varchar2_table(3766) := '64693A42504D4E506C616E65272929207B5C6E20202020202072657475726E20747275653B5C6E202020207D5C6E5C6E2020202072657475726E20646920262620212164692E6973457870616E6465643B5C6E20207D5C6E5C6E20206966202869732865';
wwv_flow_imp.g_varchar2_table(3767) := '6C656D656E742C202762706D6E3A5061727469636970616E74272929207B5C6E2020202072657475726E202121676574427573696E6573734F626A65637428656C656D656E74292E70726F636573735265663B5C6E20207D5C6E5C6E202072657475726E';
wwv_flow_imp.g_varchar2_table(3768) := '20747275653B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E206973486F7269';
wwv_flow_imp.g_varchar2_table(3769) := '7A6F6E74616C28656C656D656E7429207B5C6E5C6E20206966202821697328656C656D656E742C202762706D6E3A5061727469636970616E7427292026262021697328656C656D656E742C202762706D6E3A4C616E65272929207B5C6E20202020726574';
wwv_flow_imp.g_varchar2_table(3770) := '75726E20756E646566696E65643B5C6E20207D5C6E5C6E2020766172206973486F72697A6F6E74616C203D20676574446928656C656D656E74292E6973486F72697A6F6E74616C3B5C6E5C6E2020696620286973486F72697A6F6E74616C203D3D3D2075';
wwv_flow_imp.g_varchar2_table(3771) := '6E646566696E656429207B5C6E2020202072657475726E20747275653B5C6E20207D5C6E5C6E202072657475726E206973486F72697A6F6E74616C3B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C';
wwv_flow_imp.g_varchar2_table(3772) := '6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E206973496E74657272757074696E6728656C656D656E7429207B5C6E202072657475726E20656C656D656E74202626206765744275';
wwv_flow_imp.g_varchar2_table(3773) := '73696E6573734F626A65637428656C656D656E74292E6973496E74657272757074696E6720213D3D2066616C73653B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475';
wwv_flow_imp.g_varchar2_table(3774) := '726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E2069734576656E7453756250726F6365737328656C656D656E7429207B5C6E202072657475726E20656C656D656E74202626202121676574427573696E6573734F62';
wwv_flow_imp.g_varchar2_table(3775) := '6A65637428656C656D656E74292E74726967676572656442794576656E743B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A2040706172616D207B737472696E677D206576656E7454797065';
wwv_flow_imp.g_varchar2_table(3776) := '5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E206861734576656E74446566696E6974696F6E28656C656D656E742C206576656E745479706529207B5C6E202076617220657665';
wwv_flow_imp.g_varchar2_table(3777) := '6E74446566696E6974696F6E73203D20676574427573696E6573734F626A65637428656C656D656E74292E6576656E74446566696E6974696F6E733B5C6E5C6E202072657475726E20736F6D65286576656E74446566696E6974696F6E732C2066756E63';
wwv_flow_imp.g_varchar2_table(3778) := '74696F6E286576656E7429207B5C6E2020202072657475726E206973286576656E742C206576656E7454797065293B5C6E20207D293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E20';
wwv_flow_imp.g_varchar2_table(3779) := '2A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E206861734572726F724576656E74446566696E6974696F6E28656C656D656E7429207B5C6E202072657475726E206861734576656E74446566696E';
wwv_flow_imp.g_varchar2_table(3780) := '6974696F6E28656C656D656E742C202762706D6E3A4572726F724576656E74446566696E6974696F6E27293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E20';
wwv_flow_imp.g_varchar2_table(3781) := '7B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E20686173457363616C6174696F6E4576656E74446566696E6974696F6E28656C656D656E7429207B5C6E202072657475726E206861734576656E74446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(3782) := '28656C656D656E742C202762706D6E3A457363616C6174696F6E4576656E74446566696E6974696F6E27293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E20';
wwv_flow_imp.g_varchar2_table(3783) := '7B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E20686173436F6D70656E736174654576656E74446566696E6974696F6E28656C656D656E7429207B5C6E202072657475726E206861734576656E74446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(3784) := '28656C656D656E742C202762706D6E3A436F6D70656E736174654576656E74446566696E6974696F6E27293B5C6E7D5C6E222C22696D706F7274207B2067657444692C206973207D2066726F6D20272E2F4D6F64656C5574696C273B5C6E5C6E2F2A2A5C';
wwv_flow_imp.g_varchar2_table(3785) := '6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E745C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C';
wwv_flow_imp.g_varchar2_table(3786) := '65456C656D656E747D204D6F64646C65456C656D656E745C6E202A2F5C6E5C6E6578706F72742076617220706C616E65537566666978203D20275F706C616E65273B5C6E5C6E2F2A2A5C6E202A20476574207072696D6172792073686170652049442066';
wwv_flow_imp.g_varchar2_table(3787) := '6F72206120706C616E652E5C6E202A5C6E202A2040706172616D20207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B737472696E677D5C6E202A2F5C6E6578706F7274206675';
wwv_flow_imp.g_varchar2_table(3788) := '6E6374696F6E206765745368617065496446726F6D506C616E6528656C656D656E7429207B5C6E2020766172206964203D20656C656D656E742E69643B5C6E5C6E202072657475726E2072656D6F7665506C616E65537566666978286964293B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(3789) := '6E5C6E2F2A2A5C6E202A2047657420706C616E6520494420666F722061207072696D6172792073686170652E5C6E202A5C6E202A2040706172616D20207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E745C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(3790) := '204072657475726E207B737472696E677D5C6E202A2F5C6E6578706F72742066756E6374696F6E20676574506C616E65496446726F6D536861706528656C656D656E7429207B5C6E2020766172206964203D20656C656D656E742E69643B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(3791) := '69662028697328656C656D656E742C202762706D6E3A53756250726F63657373272929207B5C6E2020202072657475726E20616464506C616E65537566666978286964293B5C6E20207D5C6E5C6E202072657475726E2069643B5C6E7D5C6E5C6E2F2A2A';
wwv_flow_imp.g_varchar2_table(3792) := '5C6E202A2047657420706C616E6520494420666F72207072696D6172792073686170652049442E5C6E202A5C6E202A2040706172616D207B737472696E677D2069645C6E202A5C6E202A204072657475726E207B737472696E677D5C6E202A2F5C6E6578';
wwv_flow_imp.g_varchar2_table(3793) := '706F72742066756E6374696F6E20746F506C616E65496428696429207B5C6E202072657475726E20616464506C616E65537566666978286964293B5C6E7D5C6E5C6E2F2A2A5C6E202A20436865636B2077657468657220656C656D656E7420697320706C';
wwv_flow_imp.g_varchar2_table(3794) := '616E652E5C6E202A5C6E202A2040706172616D20207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3795) := '206973506C616E6528656C656D656E7429207B5C6E2020766172206469203D20676574446928656C656D656E74293B5C6E5C6E202072657475726E2069732864692C202762706D6E64693A42504D4E506C616E6527293B5C6E7D5C6E5C6E66756E637469';
wwv_flow_imp.g_varchar2_table(3796) := '6F6E20616464506C616E6553756666697828696429207B5C6E202072657475726E206964202B20706C616E655375666669783B5C6E7D5C6E5C6E66756E6374696F6E2072656D6F7665506C616E6553756666697828696429207B5C6E202072657475726E';
wwv_flow_imp.g_varchar2_table(3797) := '2069642E7265706C616365286E65772052656745787028706C616E65537566666978202B20272427292C202727293B5C6E7D222C22696D706F7274207B5C6E202061737369676E5C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F72';
wwv_flow_imp.g_varchar2_table(3798) := '74207B206973207D2066726F6D20272E2F4D6F64656C5574696C273B5C6E5C6E696D706F7274207B2069734C6162656C207D2066726F6D20276469616772616D2D6A732F6C69622F7574696C2F4D6F64656C5574696C273B5C6E5C6E6578706F7274207B';
wwv_flow_imp.g_varchar2_table(3799) := '2069734C6162656C207D2066726F6D20276469616772616D2D6A732F6C69622F7574696C2F4D6F64656C5574696C273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F7574696C2F5479';
wwv_flow_imp.g_varchar2_table(3800) := '70657327292E506F696E747D20506F696E745C6E202A204074797065646566207B696D706F727428276469616772616D2D6A732F6C69622F7574696C2F547970657327292E526563747D20526563745C6E202A5C6E202A204074797065646566207B696D';
wwv_flow_imp.g_varchar2_table(3801) := '706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E745C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E747D204D6F64646C65';
wwv_flow_imp.g_varchar2_table(3802) := '456C656D656E745C6E202A2F5C6E5C6E6578706F7274207661722044454641554C545F4C4142454C5F53495A45203D207B5C6E202077696474683A2039302C5C6E20206865696768743A2032305C6E7D3B5C6E5C6E6578706F72742076617220464C4F57';
wwv_flow_imp.g_varchar2_table(3803) := '5F4C4142454C5F494E44454E54203D2031353B5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E20747275652069662074686520676976656E2073656D616E7469632068617320616E2065787465726E616C206C6162656C2E5C6E202A5C6E202A204070';
wwv_flow_imp.g_varchar2_table(3804) := '6172616D207B456C656D656E747D2073656D616E7469635C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E2069734C6162656C45787465726E616C2873656D616E74696329207B5C';
wwv_flow_imp.g_varchar2_table(3805) := '6E202072657475726E2069732873656D616E7469632C202762706D6E3A4576656E742729207C7C5C6E20202020202020202069732873656D616E7469632C202762706D6E3A476174657761792729207C7C5C6E20202020202020202069732873656D616E';
wwv_flow_imp.g_varchar2_table(3806) := '7469632C202762706D6E3A4461746153746F72655265666572656E63652729207C7C5C6E20202020202020202069732873656D616E7469632C202762706D6E3A446174614F626A6563745265666572656E63652729207C7C5C6E20202020202020202069';
wwv_flow_imp.g_varchar2_table(3807) := '732873656D616E7469632C202762706D6E3A44617461496E7075742729207C7C5C6E20202020202020202069732873656D616E7469632C202762706D6E3A446174614F75747075742729207C7C5C6E20202020202020202069732873656D616E7469632C';
wwv_flow_imp.g_varchar2_table(3808) := '202762706D6E3A53657175656E6365466C6F772729207C7C5C6E20202020202020202069732873656D616E7469632C202762706D6E3A4D657373616765466C6F772729207C7C5C6E20202020202020202069732873656D616E7469632C202762706D6E3A';
wwv_flow_imp.g_varchar2_table(3809) := '47726F757027293B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E20747275652069662074686520676976656E20656C656D656E742068617320616E2065787465726E616C206C6162656C2E5C6E202A5C6E202A2040706172616D207B456C656D65';
wwv_flow_imp.g_varchar2_table(3810) := '6E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E2068617345787465726E616C4C6162656C28656C656D656E7429207B5C6E202072657475726E206973';
wwv_flow_imp.g_varchar2_table(3811) := '4C6162656C28656C656D656E742E6C6162656C293B5C6E7D5C6E5C6E2F2A2A5C6E202A204765742074686520706F736974696F6E206F6620612073657175656E636520666C6F77206C6162656C2E5C6E202A5C6E202A2040706172616D20207B506F696E';
wwv_flow_imp.g_varchar2_table(3812) := '745B5D7D20776179706F696E74735C6E202A5C6E202A204072657475726E207B506F696E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E20676574466C6F774C6162656C506F736974696F6E28776179706F696E747329207B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(3813) := '2F2F206765742074686520776179706F696E7473206D69645C6E2020766172206D6964203D20776179706F696E74732E6C656E677468202F2032202D20313B5C6E5C6E2020766172206669727374203D20776179706F696E74735B4D6174682E666C6F6F';
wwv_flow_imp.g_varchar2_table(3814) := '72286D6964295D3B5C6E2020766172207365636F6E64203D20776179706F696E74735B4D6174682E6365696C286D6964202B20302E3031295D3B5C6E5C6E20202F2F2067657420706F736974696F6E5C6E202076617220706F736974696F6E203D206765';
wwv_flow_imp.g_varchar2_table(3815) := '74576179706F696E74734D696428776179706F696E7473293B5C6E5C6E20202F2F2063616C63756C61746520616E676C655C6E202076617220616E676C65203D204D6174682E6174616E28287365636F6E642E79202D2066697273742E7929202F202873';
wwv_flow_imp.g_varchar2_table(3816) := '65636F6E642E78202D2066697273742E7829293B5C6E5C6E20207661722078203D20706F736974696F6E2E782C5C6E20202020202079203D20706F736974696F6E2E793B5C6E5C6E2020696620284D6174682E61627328616E676C6529203C204D617468';
wwv_flow_imp.g_varchar2_table(3817) := '2E5049202F203229207B5C6E2020202079202D3D20464C4F575F4C4142454C5F494E44454E543B5C6E20207D20656C7365207B5C6E2020202078202B3D20464C4F575F4C4142454C5F494E44454E543B5C6E20207D5C6E5C6E202072657475726E207B20';
wwv_flow_imp.g_varchar2_table(3818) := '783A20782C20793A2079207D3B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2047657420746865206D6964646C65206F662061206E756D626572206F6620776179706F696E74732E5C6E202A5C6E202A2040706172616D20207B506F696E745B5D7D20776179';
wwv_flow_imp.g_varchar2_table(3819) := '706F696E74735C6E202A5C6E202A204072657475726E207B506F696E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E20676574576179706F696E74734D696428776179706F696E747329207B5C6E5C6E2020766172206D6964203D20776179';
wwv_flow_imp.g_varchar2_table(3820) := '706F696E74732E6C656E677468202F2032202D20313B5C6E5C6E2020766172206669727374203D20776179706F696E74735B4D6174682E666C6F6F72286D6964295D3B5C6E2020766172207365636F6E64203D20776179706F696E74735B4D6174682E63';
wwv_flow_imp.g_varchar2_table(3821) := '65696C286D6964202B20302E3031295D3B5C6E5C6E202072657475726E207B5C6E20202020783A2066697273742E78202B20287365636F6E642E78202D2066697273742E7829202F20322C5C6E20202020793A2066697273742E79202B20287365636F6E';
wwv_flow_imp.g_varchar2_table(3822) := '642E79202D2066697273742E7929202F20325C6E20207D3B5C6E7D5C6E5C6E2F2A2A5C6E202A2047657420746865206D6964646C65206F66207468652065787465726E616C206C6162656C206F6620616E20656C656D656E742E5C6E202A5C6E202A2040';
wwv_flow_imp.g_varchar2_table(3823) := '706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B506F696E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E2067657445787465726E616C4C6162656C4D696428656C656D656E7429207B';
wwv_flow_imp.g_varchar2_table(3824) := '5C6E5C6E202069662028656C656D656E742E776179706F696E747329207B5C6E2020202072657475726E20676574466C6F774C6162656C506F736974696F6E28656C656D656E742E776179706F696E7473293B5C6E20207D20656C736520696620286973';
wwv_flow_imp.g_varchar2_table(3825) := '28656C656D656E742C202762706D6E3A47726F7570272929207B5C6E2020202072657475726E207B5C6E202020202020783A20656C656D656E742E78202B20656C656D656E742E7769647468202F20322C5C6E202020202020793A20656C656D656E742E';
wwv_flow_imp.g_varchar2_table(3826) := '79202B2044454641554C545F4C4142454C5F53495A452E686569676874202F20325C6E202020207D3B5C6E20207D20656C7365207B5C6E2020202072657475726E207B5C6E202020202020783A20656C656D656E742E78202B20656C656D656E742E7769';
wwv_flow_imp.g_varchar2_table(3827) := '647468202F20322C5C6E202020202020793A20656C656D656E742E79202B20656C656D656E742E686569676874202B2044454641554C545F4C4142454C5F53495A452E686569676874202F20325C6E202020207D3B5C6E20207D5C6E7D5C6E5C6E5C6E2F';
wwv_flow_imp.g_varchar2_table(3828) := '2A2A5C6E202A2052657475726E2074686520626F756E6473206F6620616E20656C656D656E7473206C6162656C2C207061727365642066726F6D2074686520656C656D656E7473204449206F725C6E202A2067656E6572617465642066726F6D20697473';
wwv_flow_imp.g_varchar2_table(3829) := '20626F756E64732E5C6E202A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D2064695C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B526563747D5C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(3830) := '6E6578706F72742066756E6374696F6E2067657445787465726E616C4C6162656C426F756E64732864692C20656C656D656E7429207B5C6E5C6E2020766172206D69642C5C6E20202020202073697A652C5C6E202020202020626F756E64732C5C6E2020';
wwv_flow_imp.g_varchar2_table(3831) := '202020206C6162656C203D2064692E6C6162656C3B5C6E5C6E2020696620286C6162656C202626206C6162656C2E626F756E647329207B5C6E20202020626F756E6473203D206C6162656C2E626F756E64733B5C6E5C6E2020202073697A65203D207B5C';
wwv_flow_imp.g_varchar2_table(3832) := '6E20202020202077696474683A204D6174682E6D61782844454641554C545F4C4142454C5F53495A452E77696474682C20626F756E64732E7769647468292C5C6E2020202020206865696768743A20626F756E64732E6865696768745C6E202020207D3B';
wwv_flow_imp.g_varchar2_table(3833) := '5C6E5C6E202020206D6964203D207B5C6E202020202020783A20626F756E64732E78202B20626F756E64732E7769647468202F20322C5C6E202020202020793A20626F756E64732E79202B20626F756E64732E686569676874202F20325C6E202020207D';
wwv_flow_imp.g_varchar2_table(3834) := '3B5C6E20207D20656C7365207B5C6E5C6E202020206D6964203D2067657445787465726E616C4C6162656C4D696428656C656D656E74293B5C6E5C6E2020202073697A65203D2044454641554C545F4C4142454C5F53495A453B5C6E20207D5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(3835) := '2072657475726E2061737369676E287B5C6E20202020783A206D69642E78202D2073697A652E7769647468202F20322C5C6E20202020793A206D69642E79202D2073697A652E686569676874202F20325C6E20207D2C2073697A65293B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(3836) := '2F2A2A5C6E202A2040706172616D207B4D6F64646C65456C656D656E747D2073656D616E7469635C6E202A5C6E202A204072657475726E73207B737472696E677D5C6E202A2F5C6E66756E6374696F6E206765744C6162656C417474722873656D616E74';
wwv_flow_imp.g_varchar2_table(3837) := '696329207B5C6E2020696620285C6E2020202069732873656D616E7469632C202762706D6E3A466C6F77456C656D656E742729207C7C5C6E2020202069732873656D616E7469632C202762706D6E3A5061727469636970616E742729207C7C5C6E202020';
wwv_flow_imp.g_varchar2_table(3838) := '2069732873656D616E7469632C202762706D6E3A4C616E652729207C7C5C6E2020202069732873656D616E7469632C202762706D6E3A53657175656E6365466C6F772729207C7C5C6E2020202069732873656D616E7469632C202762706D6E3A4D657373';
wwv_flow_imp.g_varchar2_table(3839) := '616765466C6F772729207C7C5C6E2020202069732873656D616E7469632C202762706D6E3A44617461496E7075742729207C7C5C6E2020202069732873656D616E7469632C202762706D6E3A446174614F757470757427295C6E202029207B5C6E202020';
wwv_flow_imp.g_varchar2_table(3840) := '2072657475726E20276E616D65273B5C6E20207D5C6E5C6E20206966202869732873656D616E7469632C202762706D6E3A54657874416E6E6F746174696F6E272929207B5C6E2020202072657475726E202774657874273B5C6E20207D5C6E5C6E202069';
wwv_flow_imp.g_varchar2_table(3841) := '66202869732873656D616E7469632C202762706D6E3A47726F7570272929207B5C6E2020202072657475726E202763617465676F727956616C7565526566273B5C6E20207D5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B4D6F64646C65456C';
wwv_flow_imp.g_varchar2_table(3842) := '656D656E747D2073656D616E7469635C6E202A5C6E202A204072657475726E73207B737472696E677D5C6E202A2F5C6E66756E6374696F6E2067657443617465676F727956616C75652873656D616E74696329207B5C6E20207661722063617465676F72';
wwv_flow_imp.g_varchar2_table(3843) := '7956616C7565526566203D2073656D616E7469635B2763617465676F727956616C7565526566275D3B5C6E5C6E2020696620282163617465676F727956616C756552656629207B5C6E2020202072657475726E2027273B5C6E20207D5C6E5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(3844) := '72657475726E2063617465676F727956616C75655265662E76616C7565207C7C2027273B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B737472696E677D';
wwv_flow_imp.g_varchar2_table(3845) := '5C6E202A2F5C6E6578706F72742066756E6374696F6E206765744C6162656C28656C656D656E7429207B5C6E20207661722073656D616E746963203D20656C656D656E742E627573696E6573734F626A6563742C5C6E20202020202061747472203D2067';
wwv_flow_imp.g_varchar2_table(3846) := '65744C6162656C417474722873656D616E746963293B5C6E5C6E2020696620286174747229207B5C6E5C6E202020206966202861747472203D3D3D202763617465676F727956616C75655265662729207B5C6E5C6E20202020202072657475726E206765';
wwv_flow_imp.g_varchar2_table(3847) := '7443617465676F727956616C75652873656D616E746963293B5C6E202020207D5C6E5C6E2020202072657475726E2073656D616E7469635B617474725D207C7C2027273B5C6E20207D5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C';
wwv_flow_imp.g_varchar2_table(3848) := '656D656E747D20656C656D656E745C6E202A2040706172616D207B737472696E677D20746578745C6E202A5C6E202A204072657475726E207B456C656D656E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E207365744C6162656C28656C65';
wwv_flow_imp.g_varchar2_table(3849) := '6D656E742C207465787429207B5C6E20207661722073656D616E746963203D20656C656D656E742E627573696E6573734F626A6563742C5C6E20202020202061747472203D206765744C6162656C417474722873656D616E746963293B5C6E5C6E202069';
wwv_flow_imp.g_varchar2_table(3850) := '6620286174747229207B5C6E5C6E202020206966202861747472203D3D3D202763617465676F727956616C75655265662729207B5C6E20202020202073656D616E7469635B2763617465676F727956616C7565526566275D2E76616C7565203D20746578';
wwv_flow_imp.g_varchar2_table(3851) := '743B5C6E202020207D20656C7365207B5C6E20202020202073656D616E7469635B617474725D203D20746578743B5C6E202020207D5C6E5C6E20207D5C6E5C6E202072657475726E20656C656D656E743B5C6E7D5C6E222C22696D706F7274207B5C6E20';
wwv_flow_imp.g_varchar2_table(3852) := '20736F6D655C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B20696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E74207D20456C656D656E745C6E202A204074797065';
wwv_flow_imp.g_varchar2_table(3853) := '646566207B20696D706F727428272E2E2F6D6F64656C2F547970657327292E4D6F64646C65456C656D656E74207D204D6F64646C65456C656D656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A20497320616E20656C656D656E74206F6620746865206769';
wwv_flow_imp.g_varchar2_table(3854) := '76656E2042504D4E20747970653F5C6E202A5C6E202A2040706172616D20207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E745C6E202A2040706172616D20207B737472696E677D20747970655C6E202A5C6E202A20407265';
wwv_flow_imp.g_varchar2_table(3855) := '7475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E20697328656C656D656E742C207479706529207B5C6E202076617220626F203D20676574427573696E6573734F626A65637428656C656D656E74293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(3856) := '202072657475726E20626F2026262028747970656F6620626F2E24696E7374616E63654F66203D3D3D202766756E6374696F6E272920262620626F2E24696E7374616E63654F662874797065293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A205265747572';
wwv_flow_imp.g_varchar2_table(3857) := '6E207472756520696620656C656D656E742068617320616E79206F662074686520676976656E2074797065732E5C6E202A5C6E202A2040706172616D207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E745C6E202A20407061';
wwv_flow_imp.g_varchar2_table(3858) := '72616D207B737472696E675B5D7D2074797065735C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E206973416E7928656C656D656E742C20747970657329207B5C6E202072657475';
wwv_flow_imp.g_varchar2_table(3859) := '726E20736F6D652874797065732C2066756E6374696F6E287429207B5C6E2020202072657475726E20697328656C656D656E742C2074293B5C6E20207D293B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E2074686520627573696E657373206F62';
wwv_flow_imp.g_varchar2_table(3860) := '6A65637420666F72206120676976656E20656C656D656E742E5C6E202A5C6E202A2040706172616D207B456C656D656E747C4D6F64646C65456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B4D6F64646C65456C656D';
wwv_flow_imp.g_varchar2_table(3861) := '656E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E20676574427573696E6573734F626A65637428656C656D656E7429207B5C6E202072657475726E2028656C656D656E7420262620656C656D656E742E627573696E6573734F626A656374';
wwv_flow_imp.g_varchar2_table(3862) := '29207C7C20656C656D656E743B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E20746865206469206F626A65637420666F72206120676976656E20656C656D656E742E5C6E202A5C6E202A2040706172616D207B456C656D656E747D20656C656D65';
wwv_flow_imp.g_varchar2_table(3863) := '6E745C6E202A5C6E202A204072657475726E207B4D6F64646C65456C656D656E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E20676574446928656C656D656E7429207B5C6E202072657475726E20656C656D656E7420262620656C656D65';
wwv_flow_imp.g_varchar2_table(3864) := '6E742E64693B5C6E7D222C222F2A2A5C6E202A20546869732066696C65206D757374206E6F74206265206368616E676564206F722065786368616E6765642E5C6E202A5C6E202A204073656520687474703A2F2F62706D6E2E696F2F6C6963656E736520';
wwv_flow_imp.g_varchar2_table(3865) := '666F72206D6F726520696E666F726D6174696F6E2E5C6E202A2F5C6E5C6E696D706F7274207B5C6E202061737369676E5374796C652C5C6E2020646F6D6966792C5C6E202064656C656761746520617320646F6D44656C65676174652C5C6E2020717565';
wwv_flow_imp.g_varchar2_table(3866) := '727920617320646F6D51756572795C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E5C6E2F2F20696E6C696E6564202E2E2F2E2E2F7265736F75726365732F6C6F676F2E7376675C6E7661722042504D4E494F5F4C4F474F5F535647203D20273C';
wwv_flow_imp.g_varchar2_table(3867) := '73766720786D6C6E733D5C22687474703A2F2F7777772E77332E6F72672F323030302F7376675C222076696577426F783D5C223020302031342E303220352E35375C222077696474683D5C2235335C22206865696768743D5C2232315C223E3C70617468';
wwv_flow_imp.g_varchar2_table(3868) := '2066696C6C3D5C2263757272656E74436F6C6F725C2220643D5C224D312E38382E3932762E31346330202E34312D2E31332E36382D2E342E382E33332E31342E34362E34342E34362E3836762E33336330202E36312D2E33332E39352D2E39352E393548';
wwv_flow_imp.g_varchar2_table(3869) := '305630682E3935632E36352030202E39332E332E39332E39327A4D2E36332E353776312E3036682E3234632E32342030202E33382D2E312E33382D2E3433562E393863302D2E32382D2E312D2E342D2E33322D2E347A6D3020312E363376312E3232682E';
wwv_flow_imp.g_varchar2_table(3870) := '3336632E322030202E33322D2E312E33322D2E3339762D2E333563302D2E33372D2E31322D2E34382D2E342D2E3438482E36337A4D342E31382E3939762E35326330202E36342D2E33312E39382D2E39342E3938682D2E335634682D2E36325630682E39';
wwv_flow_imp.g_varchar2_table(3871) := '32632E36332030202E39342E33352E39342E39397A4D322E39342E353776312E3335682E33632E322030202E332D2E30392E332D2E3337762D2E3663302D2E32392D2E312D2E33382D2E332D2E3338682D2E337A6D322E383920322E32374C362E323520';
wwv_flow_imp.g_varchar2_table(3872) := '30682E38387634682D2E3656312E31324C362E3120332E3939682D2E366C2D2E34362D322E383276322E3832682D2E35355630682E38377A4D382E313420312E315634682D2E35365630682E37394C3920322E345630682E35367634682D2E36347A6D32';
wwv_flow_imp.g_varchar2_table(3873) := '2E343920322E3239762E36682D2E36762D2E367A4D31322E3132203163302D2E36332E33332D31202E39352D31202E36312030202E39352E33372E3935203176322E30346330202E36342D2E333420312D2E393520312D2E363220302D2E39352D2E3337';
wwv_flow_imp.g_varchar2_table(3874) := '2D2E39352D317A6D2E363220322E30386330202E32382E31332E33392E33332E3339732E33322D2E312E33322D2E34562E393863302D2E32392D2E31322D2E342D2E33322D2E34732D2E33332E31312D2E33332E347A5C222F3E3C706174682066696C6C';
wwv_flow_imp.g_varchar2_table(3875) := '3D5C2263757272656E74436F6C6F725C2220643D5C224D3020342E35336831342E303276312E303448307A4D31312E30382030682E3633762E3632682D2E36337A6D2E363320345631682D2E363376322E39387A5C222F3E3C2F7376673E273B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(3876) := '6578706F7274207661722042504D4E494F5F494D47203D2042504D4E494F5F4C4F474F5F5356473B5C6E5C6E6578706F727420766172204C4F474F5F5354594C4553203D207B5C6E2020766572746963616C416C69676E3A20276D6964646C65275C6E7D';
wwv_flow_imp.g_varchar2_table(3877) := '3B5C6E5C6E6578706F727420766172204C494E4B5F5354594C4553203D207B5C6E202027636F6C6F72273A202723343034303430275C6E7D3B5C6E5C6E766172204C49474854424F585F5354594C4553203D207B5C6E2020277A496E646578273A202731';
wwv_flow_imp.g_varchar2_table(3878) := '303031272C5C6E202027706F736974696F6E273A20276669786564272C5C6E202027746F70273A202730272C5C6E2020276C656674273A202730272C5C6E2020277269676874273A202730272C5C6E202027626F74746F6D273A202730275C6E7D3B5C6E';
wwv_flow_imp.g_varchar2_table(3879) := '5C6E766172204241434B44524F505F5354594C4553203D207B5C6E2020277769647468273A202731303025272C5C6E202027686569676874273A202731303025272C5C6E2020276261636B67726F756E64273A2027726762612834302C34302C34302C30';
wwv_flow_imp.g_varchar2_table(3880) := '2E3229275C6E7D3B5C6E5C6E766172204E4F544943455F5354594C4553203D207B5C6E202027706F736974696F6E273A20276162736F6C757465272C5C6E2020276C656674273A2027353025272C5C6E202027746F70273A2027343025272C5C6E202027';
wwv_flow_imp.g_varchar2_table(3881) := '7472616E73666F726D273A20277472616E736C617465282D35302529272C5C6E2020277769647468273A20273236307078272C5C6E20202770616464696E67273A202731307078272C5C6E2020276261636B67726F756E64273A20277768697465272C5C';
wwv_flow_imp.g_varchar2_table(3882) := '6E202027626F78536861646F77273A2027302031707820347078207267626128302C302C302C302E3329272C5C6E202027666F6E7446616D696C79273A202748656C7665746963612C20417269616C2C2073616E732D7365726966272C5C6E202027666F';
wwv_flow_imp.g_varchar2_table(3883) := '6E7453697A65273A202731347078272C5C6E202027646973706C6179273A2027666C6578272C5C6E2020276C696E65486569676874273A2027312E33275C6E7D3B5C6E5C6E766172204C49474854424F585F4D41524B5550203D5C6E2020273C64697620';
wwv_flow_imp.g_varchar2_table(3884) := '636C6173733D5C22626A732D706F77657265642D62792D6C69676874626F785C223E27202B5C6E20202020273C64697620636C6173733D5C226261636B64726F705C223E3C2F6469763E27202B5C6E20202020273C64697620636C6173733D5C226E6F74';
wwv_flow_imp.g_varchar2_table(3885) := '6963655C223E27202B5C6E202020202020273C6120687265663D5C2268747470733A2F2F62706D6E2E696F5C22207461726765743D5C225F626C616E6B5C222072656C3D5C226E6F6F70656E65725C2220636C6173733D5C226C696E6B5C223E27202B5C';
wwv_flow_imp.g_varchar2_table(3886) := '6E202020202020202042504D4E494F5F494D47202B5C6E202020202020273C2F613E27202B5C6E202020202020273C7370616E3E27202B5C6E2020202020202020275765622D626173656420746F6F6C696E6720666F722042504D4E2C20444D4E20616E';
wwv_flow_imp.g_varchar2_table(3887) := '6420666F726D732027202B5C6E202020202020202027706F7765726564206279203C6120687265663D5C2268747470733A2F2F62706D6E2E696F5C22207461726765743D5C225F626C616E6B5C222072656C3D5C226E6F6F70656E65725C223E62706D6E';
wwv_flow_imp.g_varchar2_table(3888) := '2E696F3C2F613E2E27202B5C6E202020202020273C2F7370616E3E27202B5C6E20202020273C2F6469763E27202B5C6E2020273C2F6469763E273B5C6E5C6E5C6E766172206C69676874626F783B5C6E5C6E66756E6374696F6E206372656174654C6967';
wwv_flow_imp.g_varchar2_table(3889) := '6874626F782829207B5C6E20206C69676874626F78203D20646F6D696679284C49474854424F585F4D41524B5550293B5C6E5C6E202061737369676E5374796C65286C69676874626F782C204C49474854424F585F5354594C4553293B5C6E2020617373';
wwv_flow_imp.g_varchar2_table(3890) := '69676E5374796C6528646F6D51756572792827737667272C206C69676874626F78292C204C4F474F5F5354594C4553293B5C6E202061737369676E5374796C6528646F6D517565727928272E6261636B64726F70272C206C69676874626F78292C204241';
wwv_flow_imp.g_varchar2_table(3891) := '434B44524F505F5354594C4553293B5C6E202061737369676E5374796C6528646F6D517565727928272E6E6F74696365272C206C69676874626F78292C204E4F544943455F5354594C4553293B5C6E202061737369676E5374796C6528646F6D51756572';
wwv_flow_imp.g_varchar2_table(3892) := '7928272E6C696E6B272C206C69676874626F78292C204C494E4B5F5354594C45532C207B5C6E20202020276D617267696E273A202731357078203230707820313570782031307078272C5C6E2020202027616C69676E53656C66273A202763656E746572';
wwv_flow_imp.g_varchar2_table(3893) := '275C6E20207D293B5C6E7D5C6E5C6E6578706F72742066756E6374696F6E206F70656E2829207B5C6E5C6E202069662028216C69676874626F7829207B5C6E202020206372656174654C69676874626F7828293B5C6E5C6E20202020646F6D44656C6567';
wwv_flow_imp.g_varchar2_table(3894) := '6174652E62696E64286C69676874626F782C20272E6261636B64726F70272C2027636C69636B272C2066756E6374696F6E286576656E7429207B5C6E202020202020646F63756D656E742E626F64792E72656D6F76654368696C64286C69676874626F78';
wwv_flow_imp.g_varchar2_table(3895) := '293B5C6E202020207D293B5C6E20207D5C6E5C6E2020646F63756D656E742E626F64792E617070656E644368696C64286C69676874626F78293B5C6E7D5C6E222C22696D706F7274207B20496E6A6563746F72207D2066726F6D202764696469273B5C6E';
wwv_flow_imp.g_varchar2_table(3896) := '5C6E696D706F727420436F72654D6F64756C652066726F6D20272E2F636F7265273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428276469646927292E496E6A656374696F6E436F6E746578747D20496E6A656374696F6E436F';
wwv_flow_imp.g_varchar2_table(3897) := '6E746578745C6E202A204074797065646566207B696D706F727428276469646927292E4C6F63616C734D61707D204C6F63616C734D61705C6E202A204074797065646566207B696D706F727428276469646927292E4D6F64756C654465636C6172617469';
wwv_flow_imp.g_varchar2_table(3898) := '6F6E7D204D6F64756C654465636C61726174696F6E5C6E202A5C6E202A204074797065646566207B207B5C6E202A2020206D6F64756C65733F3A204D6F64756C654465636C61726174696F6E5B5D3B5C6E202A207D2026205265636F72643C737472696E';
wwv_flow_imp.g_varchar2_table(3899) := '672C20616E793E207D204469616772616D4F7074696F6E735C6E202A2F5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C6E202A204074797065646566207B696D706F727428276469646927292E466163746F727946756E6374696F6E3C543E';
wwv_flow_imp.g_varchar2_table(3900) := '7D20466163746F727946756E6374696F6E5C6E202A2F5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C6E202A204074797065646566207B696D706F727428276469646927292E417272617946756E633C543E7D20417272617946756E635C6E';
wwv_flow_imp.g_varchar2_table(3901) := '202A2F5C6E5C6E2F2A2A5C6E202A20426F6F74737472617020616E20696E6A6563746F722066726F6D2061206C697374206F66206D6F64756C65732C20696E7374616E74696174696E672061206E756D626572206F662064656661756C7420636F6D706F';
wwv_flow_imp.g_varchar2_table(3902) := '6E656E74735C6E202A5C6E202A2040706172616D207B4D6F64756C654465636C61726174696F6E5B5D7D206D6F64756C65735C6E202A5C6E202A204072657475726E207B496E6A6563746F727D206120696E6A6563746F7220746F2075736520746F2061';
wwv_flow_imp.g_varchar2_table(3903) := '63636573732074686520636F6D706F6E656E74735C6E202A2F5C6E66756E6374696F6E20626F6F747374726170286D6F64756C657329207B5C6E202076617220696E6A6563746F72203D206E657720496E6A6563746F72286D6F64756C6573293B5C6E5C';
wwv_flow_imp.g_varchar2_table(3904) := '6E2020696E6A6563746F722E696E697428293B5C6E5C6E202072657475726E20696E6A6563746F723B5C6E7D5C6E5C6E2F2A2A5C6E202A204372656174657320616E20696E6A6563746F722066726F6D20706173736564206F7074696F6E732E5C6E202A';
wwv_flow_imp.g_varchar2_table(3905) := '5C6E202A204074656D706C61746520536572766963654D61705C6E202A2040706172616D207B4469616772616D4F7074696F6E737D205B6F7074696F6E735D5C6E202A5C6E202A204072657475726E207B496E6A6563746F723C536572766963654D6170';
wwv_flow_imp.g_varchar2_table(3906) := '3E7D5C6E202A2F5C6E66756E6374696F6E20637265617465496E6A6563746F72286F7074696F6E7329207B5C6E5C6E20206F7074696F6E73203D206F7074696F6E73207C7C207B7D3B5C6E5C6E20202F2A2A5C6E2020202A204074797065207B204D6F64';
wwv_flow_imp.g_varchar2_table(3907) := '756C654465636C61726174696F6E207D5C6E2020202A2F5C6E202076617220636F6E6669674D6F64756C65203D207B5C6E2020202027636F6E666967273A205B202776616C7565272C206F7074696F6E73205D5C6E20207D3B5C6E5C6E2020766172206D';
wwv_flow_imp.g_varchar2_table(3908) := '6F64756C6573203D205B20636F6E6669674D6F64756C652C20436F72654D6F64756C65205D2E636F6E636174286F7074696F6E732E6D6F64756C6573207C7C205B5D293B5C6E5C6E202072657475726E20626F6F747374726170286D6F64756C6573293B';
wwv_flow_imp.g_varchar2_table(3909) := '5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20546865206D61696E206469616772616D2D6A7320656E74727920706F696E74207468617420626F6F7473747261707320746865206469616772616D20776974682074686520676976656E5C6E202A20636F6E66';
wwv_flow_imp.g_varchar2_table(3910) := '696775726174696F6E2E5C6E202A5C6E202A20546F20726567697374657220657874656E73696F6E73207769746820746865206469616772616D2C2070617373207468656D2061732041727261793C4D6F64756C653E20746F2074686520636F6E737472';
wwv_flow_imp.g_varchar2_table(3911) := '7563746F722E5C6E202A5C6E202A2040636C6173735C6E202A2040636F6E7374727563746F725C6E202A204074656D706C617465205B536572766963654D61703D6E756C6C5D5C6E202A5C6E202A20406578616D706C65204372656174696E6720612070';
wwv_flow_imp.g_varchar2_table(3912) := '6C75672D696E2074686174206C6F6773207768656E65766572206120736861706520697320616464656420746F207468652063616E7661732E5C6E202A5C6E202A206060606A6176617363726970745C6E202A202F2F20706C75672D696E20696D706C65';
wwv_flow_imp.g_varchar2_table(3913) := '6D656E746174696F6E5C6E202A2066756E6374696F6E204D794C6F6767696E67506C7567696E286576656E7442757329207B5C6E202A2020206576656E744275732E6F6E282773686170652E6164646564272C2066756E6374696F6E286576656E742920';
wwv_flow_imp.g_varchar2_table(3914) := '7B5C6E202A2020202020636F6E736F6C652E6C6F672827736861706520272C206576656E742E73686170652C20272077617320616464656420746F20746865206469616772616D27293B5C6E202A2020207D293B5C6E202A207D5C6E202A5C6E202A202F';
wwv_flow_imp.g_varchar2_table(3915) := '2F206578706F7274206173206D6F64756C655C6E202A206578706F72742064656661756C74207B5C6E202A2020205F5F696E69745F5F3A205B20276D794C6F6767696E67506C7567696E27205D2C5C6E202A20202020206D794C6F6767696E67506C7567';
wwv_flow_imp.g_varchar2_table(3916) := '696E3A205B202774797065272C204D794C6F6767696E67506C7567696E205D5C6E202A207D3B5C6E202A206060605C6E202A5C6E202A205573652074686520706C75672D696E20696E2061204469616772616D20696E7374616E63653A5C6E202A5C6E20';
wwv_flow_imp.g_varchar2_table(3917) := '2A206060606A6176617363726970745C6E202A20696D706F7274204D794C6F6767696E674D6F64756C652066726F6D2027706174682D746F2D6D792D6C6F6767696E672D706C7567696E273B5C6E202A5C6E202A20766172206469616772616D203D206E';
wwv_flow_imp.g_varchar2_table(3918) := '6577204469616772616D287B5C6E202A2020206D6F64756C65733A205B5C6E202A20202020204D794C6F6767696E674D6F64756C655C6E202A2020205D5C6E202A207D293B5C6E202A5C6E202A206469616772616D2E696E766F6B65285B202763616E76';
wwv_flow_imp.g_varchar2_table(3919) := '6173272C2066756E6374696F6E2863616E76617329207B5C6E202A2020202F2F2061646420736861706520746F2064726177696E672063616E7661735C6E202A20202063616E7661732E6164645368617065287B20783A2031302C20793A203130207D29';
wwv_flow_imp.g_varchar2_table(3920) := '3B5C6E202A207D293B5C6E202A5C6E202A202F2F20277368617065202E2E2E2077617320616464656420746F20746865206469616772616D27206C6F6767656420746F20636F6E736F6C655C6E202A206060605C6E202A5C6E202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(3921) := '4469616772616D4F7074696F6E737D205B6F7074696F6E735D5C6E202A2040706172616D207B496E6A6563746F723C536572766963654D61703E7D205B696E6A6563746F725D20416E20286F7074696F6E616C2920696E6A6563746F7220746F20626F6F';
wwv_flow_imp.g_varchar2_table(3922) := '74737472617020746865206469616772616D20776974682E5C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E204469616772616D286F7074696F6E732C20696E6A6563746F7229207B5C6E5C6E20202F2A2A5C6E2020202A2040';
wwv_flow_imp.g_varchar2_table(3923) := '74797065207B496E6A6563746F723C536572766963654D61703E7D5C6E2020202A2F5C6E2020746869732E5F696E6A6563746F72203D20696E6A6563746F72207C7C20637265617465496E6A6563746F72286F7074696F6E73293B5C6E5C6E20202F2F20';
wwv_flow_imp.g_varchar2_table(3924) := '696E69745C6E5C6E20202F2A2A5C6E2020202A20416E206576656E7420696E6469636174696E67207468617420616C6C20706C75672D696E7320617265206C6F616465642E5C6E2020202A5C6E2020202A205573652074686973206576656E7420746F20';
wwv_flow_imp.g_varchar2_table(3925) := '66697265206F74686572206576656E747320746F20696E746572657374656420706C75672D696E735C6E2020202A5C6E2020202A20406D656D6265724F66204469616772616D5C6E2020202A5C6E2020202A20406576656E74206469616772616D2E696E';
wwv_flow_imp.g_varchar2_table(3926) := '69745C6E2020202A5C6E2020202A20406578616D706C655C6E2020202A5C6E2020202A206060606A6176617363726970745C6E2020202A206576656E744275732E6F6E28276469616772616D2E696E6974272C2066756E6374696F6E2829207B5C6E2020';
wwv_flow_imp.g_varchar2_table(3927) := '202A2020206576656E744275732E6669726528276D792D637573746F6D2D6576656E74272C207B20666F6F3A202742415227207D293B5C6E2020202A207D293B5C6E2020202A206060605C6E2020202A5C6E2020202A204074797065207B4F626A656374';
wwv_flow_imp.g_varchar2_table(3928) := '7D5C6E2020202A2F5C6E2020746869732E67657428276576656E7442757327292E6669726528276469616772616D2E696E697427293B5C6E7D5C6E5C6E2F2A2A5C6E202A20406F7665726C6F72645C6E202A5C6E202A205265736F6C7665732061206469';
wwv_flow_imp.g_varchar2_table(3929) := '616772616D20736572766963652E5C6E202A5C6E202A204074656D706C61746520545C6E202A5C6E202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865207365727669636520746F206765742E5C6E202A5C';
wwv_flow_imp.g_varchar2_table(3930) := '6E202A204072657475726E207B547D5C6E202A2F5C6E2F2A2A5C6E202A20406F7665726C6F72645C6E202A5C6E202A205265736F6C7665732061206469616772616D20736572766963652E5C6E202A5C6E202A204074656D706C61746520545C6E202A5C';
wwv_flow_imp.g_varchar2_table(3931) := '6E202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865207365727669636520746F206765742E5C6E202A2040706172616D207B747275657D207374726963742049662066616C73652C207265736F6C766520';
wwv_flow_imp.g_varchar2_table(3932) := '6D697373696E6720736572766963657320746F206E756C6C2E5C6E202A5C6E202A204072657475726E207B547D5C6E202A2F5C6E2F2A2A5C6E202A20406F7665726C6F72645C6E202A5C6E202A205265736F6C7665732061206469616772616D20736572';
wwv_flow_imp.g_varchar2_table(3933) := '766963652E5C6E202A5C6E202A204074656D706C61746520545C6E202A5C6E202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865207365727669636520746F206765742E5C6E202A2040706172616D207B62';
wwv_flow_imp.g_varchar2_table(3934) := '6F6F6C65616E7D207374726963742049662066616C73652C207265736F6C7665206D697373696E6720736572766963657320746F206E756C6C2E5C6E202A5C6E202A204072657475726E207B547C6E756C6C7D5C6E202A2F5C6E2F2A2A5C6E202A205265';
wwv_flow_imp.g_varchar2_table(3935) := '736F6C7665732061206469616772616D20736572766963652E5C6E202A5C6E202A204074656D706C617465207B6B65796F6620536572766963654D61707D204E616D655C6E202A5C6E202A2040706172616D207B4E616D657D206E616D6520546865206E';
wwv_flow_imp.g_varchar2_table(3936) := '616D65206F6620746865207365727669636520746F206765742E5C6E202A5C6E202A204072657475726E207B536572766963654D61705B4E616D655D7D5C6E202A2F5C6E4469616772616D2E70726F746F747970652E676574203D2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(3937) := '286E616D652C2073747269637429207B5C6E202072657475726E20746869732E5F696E6A6563746F722E676574286E616D652C20737472696374293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20406F7665726C6F72645C6E202A5C6E202A20496E766F6B65';
wwv_flow_imp.g_varchar2_table(3938) := '2074686520676976656E2066756E6374696F6E2C20696E6A656374696E6720646570656E64656E636965732E2052657475726E2074686520726573756C742E5C6E202A5C6E202A204074656D706C61746520545C6E202A5C6E202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(3939) := '466163746F727946756E6374696F6E3C543E7D2066756E635C6E202A2040706172616D207B496E6A656374696F6E436F6E746578747D205B636F6E746578745D5C6E202A2040706172616D207B4C6F63616C734D61707D205B6C6F63616C735D5C6E202A';
wwv_flow_imp.g_varchar2_table(3940) := '5C6E202A204072657475726E207B547D5C6E202A2F5C6E2F2A2A5C6E202A20496E766F6B652074686520676976656E2066756E6374696F6E2C20696E6A656374696E6720646570656E64656E636965732070726F766964656420696E5C6E202A20617272';
wwv_flow_imp.g_varchar2_table(3941) := '6179206E6F746174696F6E2E2052657475726E2074686520726573756C742E5C6E202A5C6E202A204074656D706C61746520545C6E202A5C6E202A2040706172616D207B417272617946756E633C543E7D2066756E632066756E6374696F6E20746F2062';
wwv_flow_imp.g_varchar2_table(3942) := '6520696E766F6B65645C6E202A2040706172616D207B496E6A656374696F6E436F6E746578747D205B636F6E746578745D20636F6E74657874206F662074686520696E766F636174696F6E5C6E202A2040706172616D207B4C6F63616C734D61707D205B';
wwv_flow_imp.g_varchar2_table(3943) := '6C6F63616C735D206C6F63616C732070726F76696465645C6E202A5C6E202A204072657475726E207B547D5C6E202A2F5C6E4469616772616D2E70726F746F747970652E696E766F6B65203D2066756E6374696F6E2866756E632C20636F6E746578742C';
wwv_flow_imp.g_varchar2_table(3944) := '206C6F63616C7329207B5C6E202072657475726E20746869732E5F696E6A6563746F722E696E766F6B652866756E632C20636F6E746578742C206C6F63616C73293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2044657374726F797320746865206469616772';
wwv_flow_imp.g_varchar2_table(3945) := '616D5C6E202A2F5C6E4469616772616D2E70726F746F747970652E64657374726F79203D2066756E6374696F6E2829207B5C6E2020746869732E67657428276576656E7442757327292E6669726528276469616772616D2E64657374726F7927293B5C6E';
wwv_flow_imp.g_varchar2_table(3946) := '7D3B5C6E5C6E2F2A2A5C6E202A20436C65617220746865206469616772616D2C2072656D6F76696E6720616C6C20636F6E74656E74732E5C6E202A2F5C6E4469616772616D2E70726F746F747970652E636C656172203D2066756E6374696F6E2829207B';
wwv_flow_imp.g_varchar2_table(3947) := '5C6E2020746869732E67657428276576656E7442757327292E6669726528276469616772616D2E636C65617227293B5C6E7D3B5C6E222C22696D706F7274207B5C6E2020666F72456163682C5C6E2020697346756E6374696F6E2C5C6E20206973417272';
wwv_flow_imp.g_varchar2_table(3948) := '61792C5C6E202069734E756D6265722C5C6E202069734F626A6563745C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F636F72652F547970657327292E456C656D656E';
wwv_flow_imp.g_varchar2_table(3949) := '744C696B657D20456C656D656E744C696B655C6E202A204074797065646566207B696D706F727428272E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A204074797065646566207B696D706F72742827';
wwv_flow_imp.g_varchar2_table(3950) := '2E2F436F6D6D616E64537461636B27292E436F6D6D616E64436F6E746578747D20436F6D6D616E64436F6E746578745C6E202A5C6E202A204074797065646566207B737472696E677C737472696E675B5D7D204576656E74735C6E202A20407479706564';
wwv_flow_imp.g_varchar2_table(3951) := '6566207B2028636F6E746578743A20436F6D6D616E64436F6E7465787429203D3E20456C656D656E744C696B655B5D207C20766F6964207D2048616E646C657246756E6374696F6E5C6E202A204074797065646566207B2028636F6E746578743A20436F';
wwv_flow_imp.g_varchar2_table(3952) := '6D6D616E64436F6E7465787429203D3E20766F6964207D20436F6D706F736548616E646C657246756E6374696F6E5C6E202A2F5C6E5C6E7661722044454641554C545F5052494F52495459203D20313030303B5C6E5C6E2F2A2A5C6E202A204120757469';
wwv_flow_imp.g_varchar2_table(3953) := '6C69747920746861742063616E206265207573656420746F20706C756720696E746F2074686520636F6D6D616E6420657865637574696F6E20666F725C6E202A20657874656E73696F6E20616E642F6F722076616C69646174696F6E2E5C6E202A5C6E20';
wwv_flow_imp.g_varchar2_table(3954) := '2A2040636C6173735C6E202A2040636F6E7374727563746F725C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206060606A6176617363726970745C6E202A20696D706F727420436F6D6D616E64496E746572636570746F722066726F6D20';
wwv_flow_imp.g_varchar2_table(3955) := '276469616772616D2D6A732F6C69622F636F6D6D616E642F436F6D6D616E64496E746572636570746F72273B5C6E202A5C6E202A20636C61737320436F6D6D616E644C6F6767657220657874656E647320436F6D6D616E64496E746572636570746F7220';
wwv_flow_imp.g_varchar2_table(3956) := '7B5C6E202A202020636F6E7374727563746F72286576656E7442757329207B5C6E202A20202020207375706572286576656E74427573293B5C6E202A5C6E202A202020746869732E70726545786563757465282773686170652E637265617465272C2028';
wwv_flow_imp.g_varchar2_table(3957) := '6576656E7429203D3E207B5C6E202A2020202020636F6E736F6C652E6C6F672827636F6D6D616E64537461636B2E73686170652D6372656174652E70726545786563757465272C206576656E74293B5C6E202A2020207D293B5C6E202A207D5C6E202A20';
wwv_flow_imp.g_varchar2_table(3958) := '6060605C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E20436F6D6D616E64496E746572636570746F72286576656E7442757329207B5C';
wwv_flow_imp.g_varchar2_table(3959) := '6E5C6E20202F2A2A5C6E2020202A204074797065207B4576656E744275737D5C6E2020202A2F5C6E2020746869732E5F6576656E74427573203D206576656E744275733B5C6E7D5C6E5C6E436F6D6D616E64496E746572636570746F722E24696E6A6563';
wwv_flow_imp.g_varchar2_table(3960) := '74203D205B20276576656E7442757327205D3B5C6E5C6E66756E6374696F6E20756E777261704576656E7428666E2C207468617429207B5C6E202072657475726E2066756E6374696F6E286576656E7429207B5C6E2020202072657475726E20666E2E63';
wwv_flow_imp.g_varchar2_table(3961) := '616C6C2874686174207C7C206E756C6C2C206576656E742E636F6E746578742C206576656E742E636F6D6D616E642C206576656E74293B5C6E20207D3B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20496E74657263657074206120636F6D6D616E64206475';
wwv_flow_imp.g_varchar2_table(3962) := '72696E67206F6E65206F6620746865207068617365732E5C6E202A5C6E202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570745C6E202A2040706172616D207B737472696E677D';
wwv_flow_imp.g_varchar2_table(3963) := '205B686F6F6B5D20706861736520746F20696E746572636570745C6E202A2040706172616D207B6E756D6265727D205B7072696F726974795D5C6E202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C6572';
wwv_flow_imp.g_varchar2_table(3964) := '46756E6374696F6E7D2068616E646C6572466E5C6E202A2040706172616D207B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065645C6E202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(3965) := '616E797D205B746861745D5C6E202A2F5C6E436F6D6D616E64496E746572636570746F722E70726F746F747970652E6F6E203D2066756E6374696F6E286576656E74732C20686F6F6B2C207072696F726974792C2068616E646C6572466E2C20756E7772';
wwv_flow_imp.g_varchar2_table(3966) := '61702C207468617429207B5C6E5C6E202069662028697346756E6374696F6E28686F6F6B29207C7C2069734E756D62657228686F6F6B2929207B5C6E2020202074686174203D20756E777261703B5C6E20202020756E77726170203D2068616E646C6572';
wwv_flow_imp.g_varchar2_table(3967) := '466E3B5C6E2020202068616E646C6572466E203D207072696F726974793B5C6E202020207072696F72697479203D20686F6F6B3B5C6E20202020686F6F6B203D206E756C6C3B5C6E20207D5C6E5C6E202069662028697346756E6374696F6E287072696F';
wwv_flow_imp.g_varchar2_table(3968) := '726974792929207B5C6E2020202074686174203D20756E777261703B5C6E20202020756E77726170203D2068616E646C6572466E3B5C6E2020202068616E646C6572466E203D207072696F726974793B5C6E202020207072696F72697479203D20444546';
wwv_flow_imp.g_varchar2_table(3969) := '41554C545F5052494F524954593B5C6E20207D5C6E5C6E20206966202869734F626A65637428756E777261702929207B5C6E2020202074686174203D20756E777261703B5C6E20202020756E77726170203D2066616C73653B5C6E20207D5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(3970) := '6966202821697346756E6374696F6E2868616E646C6572466E2929207B5C6E202020207468726F77206E6577204572726F72282768616E646C6572466E206D75737420626520612066756E6374696F6E27293B5C6E20207D5C6E5C6E2020696620282169';
wwv_flow_imp.g_varchar2_table(3971) := '734172726179286576656E74732929207B5C6E202020206576656E7473203D205B206576656E7473205D3B5C6E20207D5C6E5C6E2020766172206576656E74427573203D20746869732E5F6576656E744275733B5C6E5C6E2020666F7245616368286576';
wwv_flow_imp.g_varchar2_table(3972) := '656E74732C2066756E6374696F6E286576656E7429207B5C6E5C6E202020202F2F20636F6E63617420636F6D6D616E64537461636B282E6576656E74293F282E686F6F6B293F5C6E202020207661722066756C6C4576656E74203D205B2027636F6D6D61';
wwv_flow_imp.g_varchar2_table(3973) := '6E64537461636B272C206576656E742C20686F6F6B205D2E66696C7465722866756E6374696F6E286529207B2072657475726E20653B207D292E6A6F696E28272E27293B5C6E5C6E202020206576656E744275732E6F6E2866756C6C4576656E742C2070';
wwv_flow_imp.g_varchar2_table(3974) := '72696F726974792C20756E77726170203F20756E777261704576656E742868616E646C6572466E2C207468617429203A2068616E646C6572466E2C2074686174293B5C6E20207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204164642061203C63616E45';
wwv_flow_imp.g_varchar2_table(3975) := '7865637574653E207068617365206F6620636F6D6D616E6420696E746572636570746F722E5C6E202A5C6E202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570745C6E202A2040';
wwv_flow_imp.g_varchar2_table(3976) := '706172616D207B6E756D6265727D205B7072696F726974795D5C6E202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E5C6E202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(3977) := '626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065645C6E202A2040706172616D207B616E797D205B746861745D5C6E202A2F5C6E436F6D6D616E64496E7465726365';
wwv_flow_imp.g_varchar2_table(3978) := '70746F722E70726F746F747970652E63616E45786563757465203D20637265617465486F6F6B282763616E4578656375746527293B5C6E5C6E2F2A2A5C6E202A204164642061203C707265457865637574653E207068617365206F6620636F6D6D616E64';
wwv_flow_imp.g_varchar2_table(3979) := '20696E746572636570746F722E5C6E202A5C6E202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570745C6E202A2040706172616D207B6E756D6265727D205B7072696F72697479';
wwv_flow_imp.g_varchar2_table(3980) := '5D5C6E202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E5C6E202A2040706172616D207B626F6F6C65616E7D205B756E777261705D20776865746865';
wwv_flow_imp.g_varchar2_table(3981) := '7220746865206576656E742073686F756C6420626520756E777261707065645C6E202A2040706172616D207B616E797D205B746861745D5C6E202A2F5C6E436F6D6D616E64496E746572636570746F722E70726F746F747970652E707265457865637574';
wwv_flow_imp.g_varchar2_table(3982) := '65203D20637265617465486F6F6B28277072654578656375746527293B5C6E5C6E2F2A2A5C6E202A204164642061203C70726545786563757465643E207068617365206F6620636F6D6D616E6420696E746572636570746F722E5C6E202A5C6E202A2040';
wwv_flow_imp.g_varchar2_table(3983) := '706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570745C6E202A2040706172616D207B6E756D6265727D205B7072696F726974795D5C6E202A2040706172616D207B436F6D706F73654861';
wwv_flow_imp.g_varchar2_table(3984) := '6E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E5C6E202A2040706172616D207B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C642062652075';
wwv_flow_imp.g_varchar2_table(3985) := '6E777261707065645C6E202A2040706172616D207B616E797D205B746861745D5C6E202A2F5C6E436F6D6D616E64496E746572636570746F722E70726F746F747970652E7072654578656375746564203D20637265617465486F6F6B2827707265457865';
wwv_flow_imp.g_varchar2_table(3986) := '637574656427293B5C6E5C6E2F2A2A5C6E202A204164642061203C657865637574653E207068617365206F6620636F6D6D616E6420696E746572636570746F722E5C6E202A5C6E202A2040706172616D207B4576656E74737D205B6576656E74735D2063';
wwv_flow_imp.g_varchar2_table(3987) := '6F6D6D616E6428732920746F20696E746572636570745C6E202A2040706172616D207B6E756D6265727D205B7072696F726974795D5C6E202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E63';
wwv_flow_imp.g_varchar2_table(3988) := '74696F6E7D2068616E646C6572466E5C6E202A2040706172616D207B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065645C6E202A2040706172616D207B616E797D';
wwv_flow_imp.g_varchar2_table(3989) := '205B746861745D5C6E202A2F5C6E436F6D6D616E64496E746572636570746F722E70726F746F747970652E65786563757465203D20637265617465486F6F6B28276578656375746527293B5C6E5C6E2F2A2A5C6E202A204164642061203C657865637574';
wwv_flow_imp.g_varchar2_table(3990) := '65643E207068617365206F6620636F6D6D616E6420696E746572636570746F722E5C6E202A5C6E202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570745C6E202A204070617261';
wwv_flow_imp.g_varchar2_table(3991) := '6D207B6E756D6265727D205B7072696F726974795D5C6E202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E5C6E202A2040706172616D207B626F6F6C';
wwv_flow_imp.g_varchar2_table(3992) := '65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065645C6E202A2040706172616D207B616E797D205B746861745D5C6E202A2F5C6E436F6D6D616E64496E746572636570746F72';
wwv_flow_imp.g_varchar2_table(3993) := '2E70726F746F747970652E6578656375746564203D20637265617465486F6F6B2827657865637574656427293B5C6E5C6E2F2A2A5C6E202A204164642061203C706F7374457865637574653E207068617365206F6620636F6D6D616E6420696E74657263';
wwv_flow_imp.g_varchar2_table(3994) := '6570746F722E5C6E202A5C6E202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570745C6E202A2040706172616D207B6E756D6265727D205B7072696F726974795D5C6E202A2040';
wwv_flow_imp.g_varchar2_table(3995) := '706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E5C6E202A2040706172616D207B626F6F6C65616E7D205B756E777261705D2077686574686572207468652065';
wwv_flow_imp.g_varchar2_table(3996) := '76656E742073686F756C6420626520756E777261707065645C6E202A2040706172616D207B616E797D205B746861745D5C6E202A2F5C6E436F6D6D616E64496E746572636570746F722E70726F746F747970652E706F737445786563757465203D206372';
wwv_flow_imp.g_varchar2_table(3997) := '65617465486F6F6B2827706F73744578656375746527293B5C6E5C6E2F2A2A5C6E202A204164642061203C706F737445786563757465643E207068617365206F6620636F6D6D616E6420696E746572636570746F722E5C6E202A5C6E202A204070617261';
wwv_flow_imp.g_varchar2_table(3998) := '6D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570745C6E202A2040706172616D207B6E756D6265727D205B7072696F726974795D5C6E202A2040706172616D207B436F6D706F736548616E646C65';
wwv_flow_imp.g_varchar2_table(3999) := '7246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E5C6E202A2040706172616D207B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261';
wwv_flow_imp.g_varchar2_table(4000) := '707065645C6E202A2040706172616D207B616E797D205B746861745D5C6E202A2F5C6E436F6D6D616E64496E746572636570746F722E70726F746F747970652E706F73744578656375746564203D20637265617465486F6F6B2827706F73744578656375';
wwv_flow_imp.g_varchar2_table(4001) := '74656427293B5C6E5C6E2F2A2A5C6E202A204164642061203C7265766572743E207068617365206F6620636F6D6D616E6420696E746572636570746F722E5C6E202A5C6E202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D';
wwv_flow_imp.g_varchar2_table(4002) := '616E6428732920746F20696E746572636570745C6E202A2040706172616D207B6E756D6265727D205B7072696F726974795D5C6E202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F';
wwv_flow_imp.g_varchar2_table(4003) := '6E7D2068616E646C6572466E5C6E202A2040706172616D207B626F6F6C65616E7D205B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065645C6E202A2040706172616D207B616E797D205B74';
wwv_flow_imp.g_varchar2_table(4004) := '6861745D5C6E202A2F5C6E436F6D6D616E64496E746572636570746F722E70726F746F747970652E726576657274203D20637265617465486F6F6B282772657665727427293B5C6E5C6E2F2A2A5C6E202A204164642061203C72657665727465643E2070';
wwv_flow_imp.g_varchar2_table(4005) := '68617365206F6620636F6D6D616E6420696E746572636570746F722E5C6E202A5C6E202A2040706172616D207B4576656E74737D205B6576656E74735D20636F6D6D616E6428732920746F20696E746572636570745C6E202A2040706172616D207B6E75';
wwv_flow_imp.g_varchar2_table(4006) := '6D6265727D205B7072696F726974795D5C6E202A2040706172616D207B436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E5C6E202A2040706172616D207B626F6F6C65616E7D20';
wwv_flow_imp.g_varchar2_table(4007) := '5B756E777261705D207768657468657220746865206576656E742073686F756C6420626520756E777261707065645C6E202A2040706172616D207B616E797D205B746861745D5C6E202A2F5C6E436F6D6D616E64496E746572636570746F722E70726F74';
wwv_flow_imp.g_varchar2_table(4008) := '6F747970652E7265766572746564203D20637265617465486F6F6B2827726576657274656427293B5C6E5C6E2F2A5C6E202A204164642070726F746F74797065206D6574686F647320666F722065616368207068617365206F6620636F6D6D616E642065';
wwv_flow_imp.g_varchar2_table(4009) := '7865637574696F6E2028652E672E20657865637574652C5C6E202A20726576657274292E5C6E202A5C6E202A2040706172616D207B737472696E677D20686F6F6B5C6E202A5C6E202A204072657475726E207B20285C6E202A2020206576656E74733F3A';
wwv_flow_imp.g_varchar2_table(4010) := '204576656E74732C5C6E202A2020207072696F726974793F3A206E756D6265722C5C6E202A20202068616E646C6572466E3A20436F6D706F736548616E646C657246756E6374696F6E7C48616E646C657246756E6374696F6E2C5C6E202A202020756E77';
wwv_flow_imp.g_varchar2_table(4011) := '7261703F3A20626F6F6C65616E5C6E202A2029203D3E20616E79207D5C6E202A2F5C6E66756E6374696F6E20637265617465486F6F6B28686F6F6B29207B5C6E5C6E20202F2A2A5C6E2020202A204074686973207B436F6D6D616E64496E746572636570';
wwv_flow_imp.g_varchar2_table(4012) := '746F727D5C6E2020202A5C6E2020202A2040706172616D207B4576656E74737D205B6576656E74735D5C6E2020202A2040706172616D207B6E756D6265727D205B7072696F726974795D5C6E2020202A2040706172616D207B436F6D706F736548616E64';
wwv_flow_imp.g_varchar2_table(4013) := '6C657246756E6374696F6E7C48616E646C657246756E6374696F6E7D2068616E646C6572466E5C6E2020202A2040706172616D207B626F6F6C65616E7D205B756E777261705D5C6E2020202A2040706172616D207B616E797D205B746861745D5C6E2020';
wwv_flow_imp.g_varchar2_table(4014) := '202A2F5C6E2020636F6E737420686F6F6B466E203D2066756E6374696F6E286576656E74732C207072696F726974792C2068616E646C6572466E2C20756E777261702C207468617429207B5C6E5C6E2020202069662028697346756E6374696F6E286576';
wwv_flow_imp.g_varchar2_table(4015) := '656E747329207C7C2069734E756D626572286576656E74732929207B5C6E20202020202074686174203D20756E777261703B5C6E202020202020756E77726170203D2068616E646C6572466E3B5C6E20202020202068616E646C6572466E203D20707269';
wwv_flow_imp.g_varchar2_table(4016) := '6F726974793B5C6E2020202020207072696F72697479203D206576656E74733B5C6E2020202020206576656E7473203D206E756C6C3B5C6E202020207D5C6E5C6E20202020746869732E6F6E286576656E74732C20686F6F6B2C207072696F726974792C';
wwv_flow_imp.g_varchar2_table(4017) := '2068616E646C6572466E2C20756E777261702C2074686174293B5C6E20207D3B5C6E5C6E202072657475726E20686F6F6B466E3B5C6E7D5C6E222C22696D706F7274207B5C6E202069734E756D6265722C5C6E202061737369676E2C5C6E2020666F7245';
wwv_flow_imp.g_varchar2_table(4018) := '6163682C5C6E202065766572792C5C6E20206465626F756E63652C5C6E202062696E642C5C6E20207265647563652C5C6E202066696E645C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E202061737369676E537479';
wwv_flow_imp.g_varchar2_table(4019) := '6C655C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E696D706F7274207B5C6E202061646420617320636F6C6C656374696F6E4164642C5C6E202072656D6F766520617320636F6C6C656374696F6E52656D6F76655C6E7D2066726F6D20272E2E';
wwv_flow_imp.g_varchar2_table(4020) := '2F7574696C2F436F6C6C656374696F6E73273B5C6E5C6E696D706F7274207B5C6E2020676574547970652C5C6E202067657442426F7820617320676574426F756E64696E67426F785C6E7D2066726F6D20272E2E2F7574696C2F456C656D656E7473273B';
wwv_flow_imp.g_varchar2_table(4021) := '5C6E5C6E696D706F7274207B2061735452424C207D2066726F6D20272E2E2F6C61796F75742F4C61796F75745574696C273B5C6E5C6E696D706F7274207B5C6E2020617070656E6420617320737667417070656E642C5C6E202061747472206173207376';
wwv_flow_imp.g_varchar2_table(4022) := '67417474722C5C6E2020636C617373657320617320737667436C61737365732C5C6E2020637265617465206173207376674372656174652C5C6E20207472616E73666F726D206173207376675472616E73666F726D2C5C6E202072656D6F766520617320';
wwv_flow_imp.g_varchar2_table(4023) := '73766752656D6F76655C6E7D2066726F6D202774696E792D737667273B5C6E5C6E696D706F7274207B206372656174654D6174726978206173206372656174654D6174726978207D2066726F6D202774696E792D737667273B5C6E5C6E5C6E2F2A2A5C6E';
wwv_flow_imp.g_varchar2_table(4024) := '202A204074797065646566207B696D706F727428272E2F547970657327292E436F6E6E656374696F6E4C696B657D20436F6E6E656374696F6E4C696B655C6E202A204074797065646566207B696D706F727428272E2F547970657327292E526F6F744C69';
wwv_flow_imp.g_varchar2_table(4025) := '6B657D20526F6F744C696B655C6E202A204074797065646566207B696D706F727428272E2F547970657327292E506172656E744C696B65207D20506172656E744C696B655C6E202A204074797065646566207B696D706F727428272E2F54797065732729';
wwv_flow_imp.g_varchar2_table(4026) := '2E53686170654C696B657D2053686170654C696B655C6E202A5C6E202A204074797065646566207B207B5C6E202A202020636F6E7461696E65723F3A2048544D4C456C656D656E743B5C6E202A20202064656665725570646174653F3A20626F6F6C6561';
wwv_flow_imp.g_varchar2_table(4027) := '6E3B5C6E202A20202077696474683F3A206E756D6265723B5C6E202A2020206865696768743F3A206E756D6265723B5C6E202A207D207D2043616E766173436F6E6669675C6E202A204074797065646566207B207B5C6E202A20202067726F75703A2053';
wwv_flow_imp.g_varchar2_table(4028) := '5647456C656D656E743B5C6E202A202020696E6465783A206E756D6265723B5C6E202A20202076697369626C653A20626F6F6C65616E3B5C6E202A207D207D2043616E7661734C617965725C6E202A204074797065646566207B207B5C6E202A2020205B';
wwv_flow_imp.g_varchar2_table(4029) := '6B65793A20737472696E675D3A2043616E7661734C617965723B5C6E202A207D207D2043616E7661734C61796572735C6E202A204074797065646566207B207B5C6E202A202020726F6F74456C656D656E743A2053686170654C696B653B5C6E202A2020';
wwv_flow_imp.g_varchar2_table(4030) := '206C617965723A2043616E7661734C617965723B5C6E202A207D207D2043616E766173506C616E655C6E202A204074797065646566207B207B5C6E202A2020207363616C653A206E756D6265723B5C6E202A202020696E6E65723A20526563743B5C6E20';
wwv_flow_imp.g_varchar2_table(4031) := '2A2020206F757465723A2044696D656E73696F6E733B5C6E202A207D20262052656374207D2043616E76617356696577626F785C6E202A5C6E202A204074797065646566207B696D706F727428272E2F456C656D656E74526567697374727927292E6465';
wwv_flow_imp.g_varchar2_table(4032) := '6661756C747D20456C656D656E7452656769737472795C6E202A204074797065646566207B696D706F727428272E2F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A204074797065646566207B696D706F727428272E2F';
wwv_flow_imp.g_varchar2_table(4033) := '4772617068696373466163746F727927292E64656661756C747D204772617068696373466163746F72795C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E44696D656E73696F6E737D2044696D';
wwv_flow_imp.g_varchar2_table(4034) := '656E73696F6E735C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F696E745C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E526563';
wwv_flow_imp.g_varchar2_table(4035) := '747D20526563745C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E526563745452424C7D20526563745452424C5C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F5479706573';
wwv_flow_imp.g_varchar2_table(4036) := '27292E5363726F6C6C44656C74617D205363726F6C6C44656C74615C6E202A2F5C6E5C6E66756E6374696F6E20726F756E64286E756D6265722C207265736F6C7574696F6E29207B5C6E202072657475726E204D6174682E726F756E64286E756D626572';
wwv_flow_imp.g_varchar2_table(4037) := '202A207265736F6C7574696F6E29202F207265736F6C7574696F6E3B5C6E7D5C6E5C6E66756E6374696F6E20656E737572655078286E756D62657229207B5C6E202072657475726E2069734E756D626572286E756D62657229203F206E756D626572202B';
wwv_flow_imp.g_varchar2_table(4038) := '2027707827203A206E756D6265723B5C6E7D5C6E5C6E66756E6374696F6E2066696E64526F6F7428656C656D656E7429207B5C6E20207768696C652028656C656D656E742E706172656E7429207B5C6E20202020656C656D656E74203D20656C656D656E';
wwv_flow_imp.g_varchar2_table(4039) := '742E706172656E743B5C6E20207D5C6E5C6E202072657475726E20656C656D656E743B5C6E7D5C6E5C6E2F2A2A5C6E202A204372656174657320612048544D4C20636F6E7461696E657220656C656D656E7420666F7220612053564720656C656D656E74';
wwv_flow_imp.g_varchar2_table(4040) := '20776974685C6E202A2074686520676976656E20636F6E66696775726174696F6E5C6E202A5C6E202A2040706172616D207B43616E766173436F6E6669677D206F7074696F6E735C6E202A5C6E202A204072657475726E207B48544D4C456C656D656E74';
wwv_flow_imp.g_varchar2_table(4041) := '7D2074686520636F6E7461696E657220656C656D656E745C6E202A2F5C6E66756E6374696F6E20637265617465436F6E7461696E6572286F7074696F6E7329207B5C6E5C6E20206F7074696F6E73203D2061737369676E287B7D2C207B2077696474683A';
wwv_flow_imp.g_varchar2_table(4042) := '202731303025272C206865696768743A20273130302527207D2C206F7074696F6E73293B5C6E5C6E2020636F6E737420636F6E7461696E6572203D206F7074696F6E732E636F6E7461696E6572207C7C20646F63756D656E742E626F64793B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(4043) := '202F2F206372656174652061203C6469763E2061726F756E64207468652073766720656C656D656E7420776974682074686520726573706563746976652073697A655C6E20202F2F2074686973207761792077652063616E20616C776179732067657420';
wwv_flow_imp.g_varchar2_table(4044) := '74686520636F727265637420636F6E7461696E65722073697A655C6E20202F2F20287468697320697320696D706F737369626C6520666F72203C7376673E20656C656D656E747320617420746865206D6F6D656E74295C6E2020636F6E73742070617265';
wwv_flow_imp.g_varchar2_table(4045) := '6E74203D20646F63756D656E742E637265617465456C656D656E74282764697627293B5C6E2020706172656E742E7365744174747269627574652827636C617373272C2027646A732D636F6E7461696E657220646A732D706172656E7427293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(4046) := '202061737369676E5374796C6528706172656E742C207B5C6E20202020706F736974696F6E3A202772656C6174697665272C5C6E202020206F766572666C6F773A202768696464656E272C5C6E2020202077696474683A20656E737572655078286F7074';
wwv_flow_imp.g_varchar2_table(4047) := '696F6E732E7769647468292C5C6E202020206865696768743A20656E737572655078286F7074696F6E732E686569676874295C6E20207D293B5C6E5C6E2020636F6E7461696E65722E617070656E644368696C6428706172656E74293B5C6E5C6E202072';
wwv_flow_imp.g_varchar2_table(4048) := '657475726E20706172656E743B5C6E7D5C6E5C6E66756E6374696F6E2063726561746547726F757028706172656E742C20636C732C206368696C64496E64657829207B5C6E2020636F6E73742067726F7570203D2073766743726561746528276727293B';
wwv_flow_imp.g_varchar2_table(4049) := '5C6E2020737667436C61737365732867726F7570292E61646428636C73293B5C6E5C6E2020636F6E737420696E646578203D206368696C64496E64657820213D3D20756E646566696E6564203F206368696C64496E646578203A20706172656E742E6368';
wwv_flow_imp.g_varchar2_table(4050) := '696C644E6F6465732E6C656E677468202D20313B5C6E5C6E20202F2F206D75737420656E73757265207365636F6E6420617267756D656E74206973206E6F6465206F72205F6E756C6C5F5C6E20202F2F2063662E2068747470733A2F2F646576656C6F70';
wwv_flow_imp.g_varchar2_table(4051) := '65722E6D6F7A696C6C612E6F72672F656E2D55532F646F63732F5765622F4150492F4E6F64652F696E736572744265666F72655C6E2020706172656E742E696E736572744265666F72652867726F75702C20706172656E742E6368696C644E6F6465735B';
wwv_flow_imp.g_varchar2_table(4052) := '696E6465785D207C7C206E756C6C293B5C6E5C6E202072657475726E2067726F75703B5C6E7D5C6E5C6E636F6E737420424153455F4C41594552203D202762617365273B5C6E5C6E2F2F2072656E64657220706C616E6520636F6E74656E747320626568';
wwv_flow_imp.g_varchar2_table(4053) := '696E64207574696C697479206C61796572735C6E636F6E737420504C414E455F4C415945525F494E444558203D20303B5C6E636F6E7374205554494C4954595F4C415945525F494E444558203D20313B5C6E5C6E5C6E636F6E7374205245515549524544';
wwv_flow_imp.g_varchar2_table(4054) := '5F4D4F44454C5F4154545253203D207B5C6E202073686170653A205B202778272C202779272C20277769647468272C202768656967687427205D2C5C6E2020636F6E6E656374696F6E3A205B2027776179706F696E747327205D5C6E7D3B5C6E5C6E2F2A';
wwv_flow_imp.g_varchar2_table(4055) := '2A5C6E202A20546865206D61696E2064726177696E672063616E7661732E5C6E202A5C6E202A2040636C6173735C6E202A2040636F6E7374727563746F725C6E202A5C6E202A2040656D6974732043616E7661732363616E7661732E696E69745C6E202A';
wwv_flow_imp.g_varchar2_table(4056) := '5C6E202A2040706172616D207B43616E766173436F6E6669677C6E756C6C7D20636F6E6669675C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B4772617068696373466163746F72797D2067';
wwv_flow_imp.g_varchar2_table(4057) := '72617068696373466163746F72795C6E202A2040706172616D207B456C656D656E7452656769737472797D20656C656D656E7452656769737472795C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E2043616E76617328636F6E';
wwv_flow_imp.g_varchar2_table(4058) := '6669672C206576656E744275732C206772617068696373466163746F72792C20656C656D656E74526567697374727929207B5C6E2020746869732E5F6576656E74427573203D206576656E744275733B5C6E2020746869732E5F656C656D656E74526567';
wwv_flow_imp.g_varchar2_table(4059) := '6973747279203D20656C656D656E7452656769737472793B5C6E2020746869732E5F6772617068696373466163746F7279203D206772617068696373466163746F72793B5C6E5C6E20202F2A2A5C6E2020202A204074797065207B6E756D6265727D5C6E';
wwv_flow_imp.g_varchar2_table(4060) := '2020202A2F5C6E2020746869732E5F726F6F7473496478203D20303B5C6E5C6E20202F2A2A5C6E2020202A204074797065207B43616E7661734C61796572737D5C6E2020202A2F5C6E2020746869732E5F6C6179657273203D207B7D3B5C6E5C6E20202F';
wwv_flow_imp.g_varchar2_table(4061) := '2A2A5C6E2020202A204074797065207B43616E766173506C616E655B5D7D5C6E2020202A2F5C6E2020746869732E5F706C616E6573203D205B5D3B5C6E5C6E20202F2A2A5C6E2020202A204074797065207B526F6F744C696B657C6E756C6C7D5C6E2020';
wwv_flow_imp.g_varchar2_table(4062) := '202A2F5C6E2020746869732E5F726F6F74456C656D656E74203D206E756C6C3B5C6E5C6E2020746869732E5F696E697428636F6E666967207C7C207B7D293B5C6E7D5C6E5C6E43616E7661732E24696E6A656374203D205B5C6E202027636F6E6669672E';
wwv_flow_imp.g_varchar2_table(4063) := '63616E766173272C5C6E2020276576656E74427573272C5C6E2020276772617068696373466163746F7279272C5C6E202027656C656D656E745265676973747279275C6E5D3B5C6E5C6E2F2A2A5C6E202A20437265617465732061203C7376673E20656C';
wwv_flow_imp.g_varchar2_table(4064) := '656D656E742074686174206973207772617070656420696E746F2061203C6469763E2E5C6E202A2054686973207761792077652061726520616C776179732061626C6520746F20636F72726563746C7920666967757265206F7574207468652073697A65';
wwv_flow_imp.g_varchar2_table(4065) := '206F66207468652073766720656C656D656E745C6E202A206279207175657279696E672074686520706172656E74206E6F64652E5C6E5C6E202A20284974206973206E6F7420706F737369626C6520746F20676574207468652073697A65206F66206120';
wwv_flow_imp.g_varchar2_table(4066) := '73766720656C656D656E742063726F73732062726F77736572204020323031342D30342D3031295C6E5C6E202A203C64697620636C6173733D5C22646A732D636F6E7461696E65725C22207374796C653D5C2277696474683A207B646573697265642D77';
wwv_flow_imp.g_varchar2_table(4067) := '696474687D2C206865696768743A207B646573697265642D6865696768747D5C223E5C6E202A2020203C7376672077696474683D5C22313030255C22206865696768743D5C22313030255C223E5C6E202A202020202E2E2E5C6E202A2020203C2F737667';
wwv_flow_imp.g_varchar2_table(4068) := '3E5C6E202A203C2F6469763E5C6E202A5C6E202A2040706172616D207B43616E766173436F6E6669677D20636F6E6669675C6E202A2F5C6E43616E7661732E70726F746F747970652E5F696E6974203D2066756E6374696F6E28636F6E66696729207B5C';
wwv_flow_imp.g_varchar2_table(4069) := '6E5C6E2020636F6E7374206576656E74427573203D20746869732E5F6576656E744275733B5C6E5C6E20202F2F2068746D6C20636F6E7461696E65725C6E2020636F6E737420636F6E7461696E6572203D20746869732E5F636F6E7461696E6572203D20';
wwv_flow_imp.g_varchar2_table(4070) := '637265617465436F6E7461696E657228636F6E666967293B5C6E5C6E2020636F6E737420737667203D20746869732E5F737667203D20737667437265617465282773766727293B5C6E202073766741747472287376672C207B2077696474683A20273130';
wwv_flow_imp.g_varchar2_table(4071) := '3025272C206865696768743A20273130302527207D293B5C6E5C6E2020737667417070656E6428636F6E7461696E65722C20737667293B5C6E5C6E2020636F6E73742076696577706F7274203D20746869732E5F76696577706F7274203D206372656174';
wwv_flow_imp.g_varchar2_table(4072) := '6547726F7570287376672C202776696577706F727427293B5C6E5C6E20202F2F206465626F756E63652063616E7661732E76696577626F782E6368616E676564206576656E7473207768656E206465666572557064617465206973207365745C6E20202F';
wwv_flow_imp.g_varchar2_table(4073) := '2F20746F2068656C70207769746820706F74656E7469616C20706572666F726D616E6365206973737565735C6E202069662028636F6E6669672E646566657255706461746529207B5C6E20202020746869732E5F76696577626F784368616E676564203D';
wwv_flow_imp.g_varchar2_table(4074) := '206465626F756E63652862696E6428746869732E5F76696577626F784368616E6765642C2074686973292C20333030293B5C6E20207D5C6E5C6E20206576656E744275732E6F6E28276469616772616D2E696E6974272C202829203D3E207B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(4075) := '2020202F2A2A5C6E20202020202A20416E206576656E7420696E6469636174696E672074686174207468652063616E76617320697320726561647920746F20626520647261776E206F6E2E5C6E20202020202A5C6E20202020202A20406D656D6265724F';
wwv_flow_imp.g_varchar2_table(4076) := '662043616E7661735C6E20202020202A5C6E20202020202A20406576656E742063616E7661732E696E69745C6E20202020202A5C6E20202020202A204074797065207B4F626A6563747D5C6E20202020202A204070726F7065727479207B535647456C65';
wwv_flow_imp.g_varchar2_table(4077) := '6D656E747D207376672074686520637265617465642073766720656C656D656E745C6E20202020202A204070726F7065727479207B535647456C656D656E747D2076696577706F7274207468652064697265637420706172656E74206F66206469616772';
wwv_flow_imp.g_varchar2_table(4078) := '616D20656C656D656E747320616E64207368617065735C6E20202020202A2F5C6E202020206576656E744275732E66697265282763616E7661732E696E6974272C207B5C6E2020202020207376673A207376672C5C6E20202020202076696577706F7274';
wwv_flow_imp.g_varchar2_table(4079) := '3A2076696577706F72745C6E202020207D293B5C6E5C6E20207D293B5C6E5C6E20202F2F2072657365742076696577626F78206F6E207368617065206368616E67657320746F5C6E20202F2F207265636F6D70757465207468652076696577626F785C6E';
wwv_flow_imp.g_varchar2_table(4080) := '20206576656E744275732E6F6E285B5C6E202020202773686170652E6164646564272C5C6E2020202027636F6E6E656374696F6E2E6164646564272C5C6E202020202773686170652E72656D6F766564272C5C6E2020202027636F6E6E656374696F6E2E';
wwv_flow_imp.g_varchar2_table(4081) := '72656D6F766564272C5C6E2020202027656C656D656E74732E6368616E676564272C5C6E2020202027726F6F742E736574275C6E20205D2C202829203D3E207B5C6E2020202064656C65746520746869732E5F63616368656456696577626F783B5C6E20';
wwv_flow_imp.g_varchar2_table(4082) := '207D293B5C6E5C6E20206576656E744275732E6F6E28276469616772616D2E64657374726F79272C203530302C20746869732E5F64657374726F792C2074686973293B5C6E20206576656E744275732E6F6E28276469616772616D2E636C656172272C20';
wwv_flow_imp.g_varchar2_table(4083) := '3530302C20746869732E5F636C6561722C2074686973293B5C6E7D3B5C6E5C6E43616E7661732E70726F746F747970652E5F64657374726F79203D2066756E6374696F6E2829207B5C6E2020746869732E5F6576656E744275732E66697265282763616E';
wwv_flow_imp.g_varchar2_table(4084) := '7661732E64657374726F79272C207B5C6E202020207376673A20746869732E5F7376672C5C6E2020202076696577706F72743A20746869732E5F76696577706F72745C6E20207D293B5C6E5C6E2020636F6E737420706172656E74203D20746869732E5F';
wwv_flow_imp.g_varchar2_table(4085) := '636F6E7461696E65722E706172656E744E6F64653B5C6E5C6E202069662028706172656E7429207B5C6E20202020706172656E742E72656D6F76654368696C6428746869732E5F636F6E7461696E6572293B5C6E20207D5C6E5C6E202064656C65746520';
wwv_flow_imp.g_varchar2_table(4086) := '746869732E5F7376673B5C6E202064656C65746520746869732E5F636F6E7461696E65723B5C6E202064656C65746520746869732E5F6C61796572733B5C6E202064656C65746520746869732E5F706C616E65733B5C6E202064656C6574652074686973';
wwv_flow_imp.g_varchar2_table(4087) := '2E5F726F6F74456C656D656E743B5C6E202064656C65746520746869732E5F76696577706F72743B5C6E7D3B5C6E5C6E43616E7661732E70726F746F747970652E5F636C656172203D2066756E6374696F6E2829207B5C6E5C6E2020636F6E737420616C';
wwv_flow_imp.g_varchar2_table(4088) := '6C456C656D656E7473203D20746869732E5F656C656D656E7452656769737472792E676574416C6C28293B5C6E5C6E20202F2F2072656D6F766520616C6C20656C656D656E74735C6E2020616C6C456C656D656E74732E666F724561636828656C656D65';
wwv_flow_imp.g_varchar2_table(4089) := '6E74203D3E207B5C6E20202020636F6E73742074797065203D206765745479706528656C656D656E74293B5C6E5C6E202020206966202874797065203D3D3D2027726F6F742729207B5C6E202020202020746869732E72656D6F7665526F6F74456C656D';
wwv_flow_imp.g_varchar2_table(4090) := '656E7428656C656D656E74293B5C6E202020207D20656C7365207B5C6E202020202020746869732E5F72656D6F7665456C656D656E7428656C656D656E742C2074797065293B5C6E202020207D5C6E20207D293B5C6E5C6E20202F2F2072656D6F766520';
wwv_flow_imp.g_varchar2_table(4091) := '616C6C20706C616E65735C6E2020746869732E5F706C616E6573203D205B5D3B5C6E2020746869732E5F726F6F74456C656D656E74203D206E756C6C3B5C6E5C6E20202F2F20666F726365207265636F6D7075746174696F6E206F66207669657720626F';
wwv_flow_imp.g_varchar2_table(4092) := '785C6E202064656C65746520746869732E5F63616368656456696577626F783B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E73207468652064656661756C74206C61796572206F6E2077686963685C6E202A20616C6C20656C656D656E747320';
wwv_flow_imp.g_varchar2_table(4093) := '61726520647261776E2E5C6E202A5C6E202A204072657475726E207B535647456C656D656E747D20205468652053564720656C656D656E74206F6620746865206C617965722E5C6E202A2F5C6E43616E7661732E70726F746F747970652E676574446566';
wwv_flow_imp.g_varchar2_table(4094) := '61756C744C61796572203D2066756E6374696F6E2829207B5C6E202072657475726E20746869732E6765744C6179657228424153455F4C415945522C20504C414E455F4C415945525F494E444558293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475';
wwv_flow_imp.g_varchar2_table(4095) := '726E732061206C617965722074686174206973207573656420746F206472617720656C656D656E74735C6E202A206F7220616E6E6F746174696F6E73206F6E2069742E5C6E202A5C6E202A204E6F6E2D6578697374696E67206C61796572732072657472';
wwv_flow_imp.g_varchar2_table(4096) := '6965766564207468726F7567682074686973206D6574686F645C6E202A2077696C6C20626520637265617465642E20447572696E67206372656174696F6E2C20746865206F7074696F6E616C20696E6465785C6E202A206D617920626520757365642074';
wwv_flow_imp.g_varchar2_table(4097) := '6F20637265617465206C61796572732062656C6F77206F722061626F7665206578697374696E67206C61796572732E5C6E202A2041206C6179657220776974682061206365727461696E20696E64657820697320616C7761797320637265617465642061';
wwv_flow_imp.g_varchar2_table(4098) := '626F766520616C6C5C6E202A206578697374696E67206C61796572732077697468207468652073616D6520696E6465782E5C6E202A5C6E202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865206C61796572';
wwv_flow_imp.g_varchar2_table(4099) := '2E5C6E202A2040706172616D207B6E756D6265727D205B696E6465785D2054686520696E646578206F6620746865206C617965722E5C6E202A5C6E202A204072657475726E207B535647456C656D656E747D205468652053564720656C656D656E74206F';
wwv_flow_imp.g_varchar2_table(4100) := '6620746865206C617965722E5C6E202A2F5C6E43616E7661732E70726F746F747970652E6765744C61796572203D2066756E6374696F6E286E616D652C20696E64657829207B5C6E5C6E202069662028216E616D6529207B5C6E202020207468726F7720';
wwv_flow_imp.g_varchar2_table(4101) := '6E6577204572726F7228276D75737420737065636966792061206E616D6527293B5C6E20207D5C6E5C6E20206C6574206C61796572203D20746869732E5F6C61796572735B6E616D655D3B5C6E5C6E202069662028216C6179657229207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(4102) := '6C61796572203D20746869732E5F6C61796572735B6E616D655D203D20746869732E5F6372656174654C61796572286E616D652C20696E646578293B5C6E20207D5C6E5C6E20202F2F207468726F7720616E206572726F72206966206C61796572206372';
wwv_flow_imp.g_varchar2_table(4103) := '656174696F6E202F20726574726976616C2069735C6E20202F2F20726571756573746564206F6E20646966666572656E7420696E6465785C6E202069662028747970656F6620696E64657820213D3D2027756E646566696E656427202626206C61796572';
wwv_flow_imp.g_varchar2_table(4104) := '2E696E64657820213D3D20696E64657829207B5C6E202020207468726F77206E6577204572726F7228276C61796572203C27202B206E616D65202B20273E20616C7265616479206372656174656420617420696E646578203C27202B20696E646578202B';
wwv_flow_imp.g_varchar2_table(4105) := '20273E27293B5C6E20207D5C6E5C6E202072657475726E206C617965722E67726F75703B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20466F72206120676976656E20696E6465782C2072657475726E20746865206E756D626572206F66206C61796572732074';
wwv_flow_imp.g_varchar2_table(4106) := '686174206861766520612068696768657220696E64657820616E645C6E202A206172652076697369626C652E5C6E202A5C6E202A2054686973206973207573656420746F2064657465726D696E6520746865206E6F64652061206C617965722073686F75';
wwv_flow_imp.g_varchar2_table(4107) := '6C6420626520696E7365727465642061742E5C6E202A5C6E202A2040706172616D207B6E756D6265727D20696E6465785C6E202A5C6E202A204072657475726E207B6E756D6265727D5C6E202A2F5C6E43616E7661732E70726F746F747970652E5F6765';
wwv_flow_imp.g_varchar2_table(4108) := '744368696C64496E646578203D2066756E6374696F6E28696E64657829207B5C6E202072657475726E2072656475636528746869732E5F6C61796572732C2066756E6374696F6E286368696C64496E6465782C206C6179657229207B5C6E202020206966';
wwv_flow_imp.g_varchar2_table(4109) := '20286C617965722E76697369626C6520262620696E646578203E3D206C617965722E696E64657829207B5C6E2020202020206368696C64496E6465782B2B3B5C6E202020207D5C6E5C6E2020202072657475726E206368696C64496E6465783B5C6E2020';
wwv_flow_imp.g_varchar2_table(4110) := '7D2C2030293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2043726561746573206120676976656E206C6179657220616E642072657475726E732069742E5C6E202A5C6E202A2040706172616D207B737472696E677D206E616D655C6E202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(4111) := '7B6E756D6265727D205B696E6465783D305D5C6E202A5C6E202A204072657475726E207B43616E7661734C617965727D5C6E202A2F5C6E43616E7661732E70726F746F747970652E5F6372656174654C61796572203D2066756E6374696F6E286E616D65';
wwv_flow_imp.g_varchar2_table(4112) := '2C20696E64657829207B5C6E5C6E202069662028747970656F6620696E646578203D3D3D2027756E646566696E65642729207B5C6E20202020696E646578203D205554494C4954595F4C415945525F494E4445583B5C6E20207D5C6E5C6E2020636F6E73';
wwv_flow_imp.g_varchar2_table(4113) := '74206368696C64496E646578203D20746869732E5F6765744368696C64496E64657828696E646578293B5C6E5C6E202072657475726E207B5C6E2020202067726F75703A2063726561746547726F757028746869732E5F76696577706F72742C20276C61';
wwv_flow_imp.g_varchar2_table(4114) := '7965722D27202B206E616D652C206368696C64496E646578292C5C6E20202020696E6465783A20696E6465782C5C6E2020202076697369626C653A20747275655C6E20207D3B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2053686F777320612067697665';
wwv_flow_imp.g_varchar2_table(4115) := '6E206C617965722E5C6E202A5C6E202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865206C617965722E5C6E202A5C6E202A204072657475726E207B535647456C656D656E747D205468652053564720656C';
wwv_flow_imp.g_varchar2_table(4116) := '656D656E74206F6620746865206C617965722E5C6E202A2F5C6E43616E7661732E70726F746F747970652E73686F774C61796572203D2066756E6374696F6E286E616D6529207B5C6E5C6E202069662028216E616D6529207B5C6E202020207468726F77';
wwv_flow_imp.g_varchar2_table(4117) := '206E6577204572726F7228276D75737420737065636966792061206E616D6527293B5C6E20207D5C6E5C6E2020636F6E7374206C61796572203D20746869732E5F6C61796572735B6E616D655D3B5C6E5C6E202069662028216C6179657229207B5C6E20';
wwv_flow_imp.g_varchar2_table(4118) := '2020207468726F77206E6577204572726F7228276C61796572203C27202B206E616D65202B20273E20646F6573206E6F7420657869737427293B5C6E20207D5C6E5C6E2020636F6E73742076696577706F7274203D20746869732E5F76696577706F7274';
wwv_flow_imp.g_varchar2_table(4119) := '3B5C6E2020636F6E73742067726F7570203D206C617965722E67726F75703B5C6E2020636F6E737420696E646578203D206C617965722E696E6465783B5C6E5C6E2020696620286C617965722E76697369626C6529207B5C6E2020202072657475726E20';
wwv_flow_imp.g_varchar2_table(4120) := '67726F75703B5C6E20207D5C6E5C6E2020636F6E7374206368696C64496E646578203D20746869732E5F6765744368696C64496E64657828696E646578293B5C6E5C6E202076696577706F72742E696E736572744265666F72652867726F75702C207669';
wwv_flow_imp.g_varchar2_table(4121) := '6577706F72742E6368696C644E6F6465735B6368696C64496E6465785D207C7C206E756C6C293B5C6E5C6E20206C617965722E76697369626C65203D20747275653B5C6E5C6E202072657475726E2067726F75703B5C6E7D3B5C6E5C6E2F2A2A5C6E202A';
wwv_flow_imp.g_varchar2_table(4122) := '204869646573206120676976656E206C617965722E5C6E202A5C6E202A2040706172616D207B737472696E677D206E616D6520546865206E616D65206F6620746865206C617965722E5C6E202A5C6E202A204072657475726E207B535647456C656D656E';
wwv_flow_imp.g_varchar2_table(4123) := '747D205468652053564720656C656D656E74206F6620746865206C617965722E5C6E202A2F5C6E43616E7661732E70726F746F747970652E686964654C61796572203D2066756E6374696F6E286E616D6529207B5C6E5C6E202069662028216E616D6529';
wwv_flow_imp.g_varchar2_table(4124) := '207B5C6E202020207468726F77206E6577204572726F7228276D75737420737065636966792061206E616D6527293B5C6E20207D5C6E5C6E2020636F6E7374206C61796572203D20746869732E5F6C61796572735B6E616D655D3B5C6E5C6E2020696620';
wwv_flow_imp.g_varchar2_table(4125) := '28216C6179657229207B5C6E202020207468726F77206E6577204572726F7228276C61796572203C27202B206E616D65202B20273E20646F6573206E6F7420657869737427293B5C6E20207D5C6E5C6E2020636F6E73742067726F7570203D206C617965';
wwv_flow_imp.g_varchar2_table(4126) := '722E67726F75703B5C6E5C6E202069662028216C617965722E76697369626C6529207B5C6E2020202072657475726E2067726F75703B5C6E20207D5C6E5C6E202073766752656D6F76652867726F7570293B5C6E5C6E20206C617965722E76697369626C';
wwv_flow_imp.g_varchar2_table(4127) := '65203D2066616C73653B5C6E5C6E202072657475726E2067726F75703B5C6E7D3B5C6E5C6E5C6E43616E7661732E70726F746F747970652E5F72656D6F76654C61796572203D2066756E6374696F6E286E616D6529207B5C6E5C6E2020636F6E7374206C';
wwv_flow_imp.g_varchar2_table(4128) := '61796572203D20746869732E5F6C61796572735B6E616D655D3B5C6E5C6E2020696620286C6179657229207B5C6E2020202064656C65746520746869732E5F6C61796572735B6E616D655D3B5C6E5C6E2020202073766752656D6F7665286C617965722E';
wwv_flow_imp.g_varchar2_table(4129) := '67726F7570293B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E73207468652063757272656E746C7920616374697665206C617965722E2043616E206265206E756C6C2E5C6E202A5C6E202A204072657475726E207B43616E766173';
wwv_flow_imp.g_varchar2_table(4130) := '4C617965727C6E756C6C7D2054686520616374697665206C61796572206F6620606E756C6C602E5C6E202A2F5C6E43616E7661732E70726F746F747970652E6765744163746976654C61796572203D2066756E6374696F6E2829207B5C6E2020636F6E73';
wwv_flow_imp.g_varchar2_table(4131) := '7420706C616E65203D20746869732E5F66696E64506C616E65466F72526F6F7428746869732E676574526F6F74456C656D656E742829293B5C6E5C6E20206966202821706C616E6529207B5C6E2020202072657475726E206E756C6C3B5C6E20207D5C6E';
wwv_flow_imp.g_varchar2_table(4132) := '5C6E202072657475726E20706C616E652E6C617965723B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E732074686520706C616E6520776869636820636F6E7461696E732074686520676976656E20656C656D656E742E5C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(4133) := '2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E677D20656C656D656E742054686520656C656D656E74206F72206974732049442E5C6E202A5C6E202A204072657475726E207B526F6F744C696B657C75';
wwv_flow_imp.g_varchar2_table(4134) := '6E646566696E65647D2054686520726F6F74206F662074686520656C656D656E742E5C6E202A2F5C6E43616E7661732E70726F746F747970652E66696E64526F6F74203D2066756E6374696F6E28656C656D656E7429207B5C6E20206966202874797065';
wwv_flow_imp.g_varchar2_table(4135) := '6F6620656C656D656E74203D3D3D2027737472696E672729207B5C6E20202020656C656D656E74203D20746869732E5F656C656D656E7452656769737472792E67657428656C656D656E74293B5C6E20207D5C6E5C6E20206966202821656C656D656E74';
wwv_flow_imp.g_varchar2_table(4136) := '29207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020636F6E737420706C616E65203D20746869732E5F66696E64506C616E65466F72526F6F74285C6E2020202066696E64526F6F7428656C656D656E74295C6E202029207C7C207B7D3B5C';
wwv_flow_imp.g_varchar2_table(4137) := '6E5C6E202072657475726E20706C616E652E726F6F74456C656D656E743B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E2061206C697374206F6620616C6C20726F6F7420656C656D656E7473206F6E20746865206469616772616D2E5C6E202A';
wwv_flow_imp.g_varchar2_table(4138) := '5C6E202A204072657475726E207B28526F6F744C696B65295B5D7D20546865206C697374206F6620726F6F7420656C656D656E74732E5C6E202A2F5C6E43616E7661732E70726F746F747970652E676574526F6F74456C656D656E7473203D2066756E63';
wwv_flow_imp.g_varchar2_table(4139) := '74696F6E2829207B5C6E202072657475726E20746869732E5F706C616E65732E6D61702866756E6374696F6E28706C616E6529207B5C6E2020202072657475726E20706C616E652E726F6F74456C656D656E743B5C6E20207D293B5C6E7D3B5C6E5C6E43';
wwv_flow_imp.g_varchar2_table(4140) := '616E7661732E70726F746F747970652E5F66696E64506C616E65466F72526F6F74203D2066756E6374696F6E28726F6F74456C656D656E7429207B5C6E202072657475726E2066696E6428746869732E5F706C616E65732C2066756E6374696F6E28706C';
wwv_flow_imp.g_varchar2_table(4141) := '616E6529207B5C6E2020202072657475726E20706C616E652E726F6F74456C656D656E74203D3D3D20726F6F74456C656D656E743B5C6E20207D293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E73207468652068746D6C20656C656D65';
wwv_flow_imp.g_varchar2_table(4142) := '6E74207468617420656E636C6F736573207468655C6E202A2064726177696E672063616E7661732E5C6E202A5C6E202A204072657475726E207B48544D4C456C656D656E747D205468652048544D4C20656C656D656E74206F662074686520636F6E7461';
wwv_flow_imp.g_varchar2_table(4143) := '696E65722E5C6E202A2F5C6E43616E7661732E70726F746F747970652E676574436F6E7461696E6572203D2066756E6374696F6E2829207B5C6E202072657475726E20746869732E5F636F6E7461696E65723B5C6E7D3B5C6E5C6E5C6E2F2F206D61726B';
wwv_flow_imp.g_varchar2_table(4144) := '657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E43616E7661732E70726F746F747970652E5F7570646174654D61726B6572203D2066756E6374696F6E28656C656D656E742C206D61726B65722C2061646429207B5C6E20206C';
wwv_flow_imp.g_varchar2_table(4145) := '657420636F6E7461696E65723B5C6E5C6E20206966202821656C656D656E742E696429207B5C6E20202020656C656D656E74203D20746869732E5F656C656D656E7452656769737472792E67657428656C656D656E74293B5C6E20207D5C6E5C6E202065';
wwv_flow_imp.g_varchar2_table(4146) := '6C656D656E742E6D61726B657273203D20656C656D656E742E6D61726B657273207C7C206E65772053657428293B5C6E5C6E20202F2F207765206E65656420746F2061636365737320616C6C5C6E2020636F6E7461696E6572203D20746869732E5F656C';
wwv_flow_imp.g_varchar2_table(4147) := '656D656E7452656769737472792E5F656C656D656E74735B656C656D656E742E69645D3B5C6E5C6E20206966202821636F6E7461696E657229207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020666F7245616368285B20636F6E7461696E';
wwv_flow_imp.g_varchar2_table(4148) := '65722E6766782C20636F6E7461696E65722E7365636F6E64617279476678205D2C2066756E6374696F6E2867667829207B5C6E202020206966202867667829207B5C6E5C6E2020202020202F2F20696E766F6B652065697468657220616464436C617373';
wwv_flow_imp.g_varchar2_table(4149) := '206F722072656D6F7665436C617373206261736564206F6E206D6F64655C6E2020202020206966202861646429207B5C6E2020202020202020656C656D656E742E6D61726B6572732E616464286D61726B6572293B5C6E2020202020202020737667436C';
wwv_flow_imp.g_varchar2_table(4150) := '617373657328676678292E616464286D61726B6572293B5C6E2020202020207D20656C7365207B5C6E2020202020202020656C656D656E742E6D61726B6572732E64656C657465286D61726B6572293B5C6E2020202020202020737667436C6173736573';
wwv_flow_imp.g_varchar2_table(4151) := '28676678292E72656D6F7665286D61726B6572293B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E5C6E20202F2A2A5C6E2020202A20416E206576656E7420696E6469636174696E6720746861742061206D61726B657220686173206265';
wwv_flow_imp.g_varchar2_table(4152) := '656E207570646174656420666F7220616E20656C656D656E745C6E2020202A5C6E2020202A20406576656E7420656C656D656E742E6D61726B65722E7570646174655C6E2020202A204074797065207B4F626A6563747D5C6E2020202A204070726F7065';
wwv_flow_imp.g_varchar2_table(4153) := '727479207B456C656D656E747D20656C656D656E74207468652073686170655C6E2020202A204070726F7065727479207B535647456C656D656E747D20676678207468652067726170686963616C20726570726573656E746174696F6E206F6620746865';
wwv_flow_imp.g_varchar2_table(4154) := '2073686170655C6E2020202A204070726F7065727479207B737472696E677D206D61726B65725C6E2020202A204070726F7065727479207B626F6F6C65616E7D20616464207472756520696620746865206D61726B6572207761732061646465642C2066';
wwv_flow_imp.g_varchar2_table(4155) := '616C736520696620697420676F742072656D6F7665645C6E2020202A2F5C6E2020746869732E5F6576656E744275732E666972652827656C656D656E742E6D61726B65722E757064617465272C207B20656C656D656E743A20656C656D656E742C206766';
wwv_flow_imp.g_varchar2_table(4156) := '783A20636F6E7461696E65722E6766782C206D61726B65723A206D61726B65722C206164643A202121616464207D293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A20416464732061206D61726B657220746F20616E20656C656D656E7420286261736963';
wwv_flow_imp.g_varchar2_table(4157) := '616C6C7920612063737320636C617373292E5C6E202A5C6E202A2046697265732074686520656C656D656E742E6D61726B65722E757064617465206576656E742C206D616B696E6720697420706F737369626C6520746F5C6E202A20696E746567726174';
wwv_flow_imp.g_varchar2_table(4158) := '6520657874656E73696F6E20696E746F20746865206D61726B6572206C6966652D6379636C652C20746F6F2E5C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206060606A6176617363726970745C6E202A2063616E7661732E6164644D61';
wwv_flow_imp.g_varchar2_table(4159) := '726B65722827666F6F272C2027736F6D652D6D61726B657227293B5C6E202A5C6E202A20636F6E737420666F6F476678203D2063616E7661732E67657447726170686963732827666F6F27293B5C6E202A5C6E202A20666F6F4766783B202F2F203C6720';
wwv_flow_imp.g_varchar2_table(4160) := '636C6173733D5C222E2E2E20736F6D652D6D61726B65725C223E202E2E2E203C2F673E5C6E202A206060605C6E202A5C6E202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E677D20656C656D656E74';
wwv_flow_imp.g_varchar2_table(4161) := '2054686520656C656D656E74206F72206974732049442E5C6E202A2040706172616D207B737472696E677D206D61726B657220546865206D61726B65722E5C6E202A2F5C6E43616E7661732E70726F746F747970652E6164644D61726B6572203D206675';
wwv_flow_imp.g_varchar2_table(4162) := '6E6374696F6E28656C656D656E742C206D61726B657229207B5C6E2020746869732E5F7570646174654D61726B657228656C656D656E742C206D61726B65722C2074727565293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2052656D6F76652061206D61';
wwv_flow_imp.g_varchar2_table(4163) := '726B65722066726F6D20616E20656C656D656E742E5C6E202A5C6E202A2046697265732074686520656C656D656E742E6D61726B65722E757064617465206576656E742C206D616B696E6720697420706F737369626C6520746F5C6E202A20696E746567';
wwv_flow_imp.g_varchar2_table(4164) := '7261746520657874656E73696F6E20696E746F20746865206D61726B6572206C6966652D6379636C652C20746F6F2E5C6E202A5C6E202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E677D20656C65';
wwv_flow_imp.g_varchar2_table(4165) := '6D656E742054686520656C656D656E74206F72206974732049442E5C6E202A2040706172616D207B737472696E677D206D61726B657220546865206D61726B65722E5C6E202A2F5C6E43616E7661732E70726F746F747970652E72656D6F76654D61726B';
wwv_flow_imp.g_varchar2_table(4166) := '6572203D2066756E6374696F6E28656C656D656E742C206D61726B657229207B5C6E2020746869732E5F7570646174654D61726B657228656C656D656E742C206D61726B65722C2066616C7365293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20436865636B';
wwv_flow_imp.g_varchar2_table(4167) := '207768657468657220616E20656C656D656E7420686173206120676976656E206D61726B65722E5C6E202A5C6E202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E677D20656C656D656E7420546865';
wwv_flow_imp.g_varchar2_table(4168) := '20656C656D656E74206F72206974732049442E5C6E202A2040706172616D207B737472696E677D206D61726B657220546865206D61726B65722E5C6E202A2F5C6E43616E7661732E70726F746F747970652E6861734D61726B6572203D2066756E637469';
wwv_flow_imp.g_varchar2_table(4169) := '6F6E28656C656D656E742C206D61726B657229207B5C6E20206966202821656C656D656E742E696429207B5C6E20202020656C656D656E74203D20746869732E5F656C656D656E7452656769737472792E67657428656C656D656E74293B5C6E20207D5C';
wwv_flow_imp.g_varchar2_table(4170) := '6E5C6E20206966202821656C656D656E742E6D61726B65727329207B5C6E2020202072657475726E2066616C73653B5C6E20207D5C6E5C6E202072657475726E20656C656D656E742E6D61726B6572732E686173286D61726B6572293B5C6E7D3B5C6E5C';
wwv_flow_imp.g_varchar2_table(4171) := '6E2F2A2A5C6E202A20546F67676C65732061206D61726B6572206F6E20616E20656C656D656E742E5C6E202A5C6E202A2046697265732074686520656C656D656E742E6D61726B65722E757064617465206576656E742C206D616B696E6720697420706F';
wwv_flow_imp.g_varchar2_table(4172) := '737369626C6520746F5C6E202A20696E7465677261746520657874656E73696F6E20696E746F20746865206D61726B6572206C6966652D6379636C652C20746F6F2E5C6E202A5C6E202A2040706172616D207B53686170654C696B657C436F6E6E656374';
wwv_flow_imp.g_varchar2_table(4173) := '696F6E4C696B657C737472696E677D20656C656D656E742054686520656C656D656E74206F72206974732049442E5C6E202A2040706172616D207B737472696E677D206D61726B657220546865206D61726B65722E5C6E202A2F5C6E43616E7661732E70';
wwv_flow_imp.g_varchar2_table(4174) := '726F746F747970652E746F67676C654D61726B6572203D2066756E6374696F6E28656C656D656E742C206D61726B657229207B5C6E202069662028746869732E6861734D61726B657228656C656D656E742C206D61726B65722929207B5C6E2020202074';
wwv_flow_imp.g_varchar2_table(4175) := '6869732E72656D6F76654D61726B657228656C656D656E742C206D61726B6572293B5C6E20207D20656C7365207B5C6E20202020746869732E6164644D61726B657228656C656D656E742C206D61726B6572293B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A';
wwv_flow_imp.g_varchar2_table(4176) := '5C6E202A2052657475726E73207468652063757272656E7420726F6F7420656C656D656E742E5C6E202A5C6E202A20537570706F7274732074776F20646966666572656E74206D6F64657320666F722068616E646C696E6720726F6F7420656C656D656E';
wwv_flow_imp.g_varchar2_table(4177) := '74733A5C6E202A5C6E202A20312E206966206E6F20726F6F7420656C656D656E7420686173206265656E206164646564206265666F72652C20616E20696D706C6963697420726F6F742077696C6C2062652061646465645C6E202A20616E642072657475';
wwv_flow_imp.g_varchar2_table(4178) := '726E65642E2054686973206973207573656420696E206170706C69636174696F6E73207468617420646F6E27742072657175697265206578706C696369745C6E202A20726F6F7420656C656D656E74732E5C6E202A5C6E202A20322E207768656E20726F';
wwv_flow_imp.g_varchar2_table(4179) := '6F7420656C656D656E74732068617665206265656E206164646564206265666F72652063616C6C696E672060676574526F6F74456C656D656E74602C5C6E202A20726F6F7420656C656D656E74732063616E206265206E756C6C2E205468697320697320';
wwv_flow_imp.g_varchar2_table(4180) := '7573656420666F72206170706C69636174696F6E7320746861742077616E7420746F206D616E6167655C6E202A20726F6F7420656C656D656E7473207468656D73656C7665732E5C6E202A5C6E202A204072657475726E207B526F6F744C696B657D2054';
wwv_flow_imp.g_varchar2_table(4181) := '68652063757272656E7420726F6F7420656C656D656E742E5C6E202A2F5C6E43616E7661732E70726F746F747970652E676574526F6F74456C656D656E74203D2066756E6374696F6E2829207B5C6E2020636F6E737420726F6F74456C656D656E74203D';
wwv_flow_imp.g_varchar2_table(4182) := '20746869732E5F726F6F74456C656D656E743B5C6E5C6E20202F2F2063616E2072657475726E206E756C6C20696620726F6F7420656C656D656E7473206172652070726573656E7420627574206E6F6E652077617320736574207965745C6E2020696620';
wwv_flow_imp.g_varchar2_table(4183) := '28726F6F74456C656D656E74207C7C20746869732E5F706C616E65732E6C656E67746829207B5C6E2020202072657475726E20726F6F74456C656D656E743B5C6E20207D5C6E5C6E202072657475726E20746869732E736574526F6F74456C656D656E74';
wwv_flow_imp.g_varchar2_table(4184) := '28746869732E616464526F6F74456C656D656E74286E756C6C29293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2041646473206120676976656E20726F6F7420656C656D656E7420616E642072657475726E732069742E5C6E202A5C6E202A2040706172616D';
wwv_flow_imp.g_varchar2_table(4185) := '207B526F6F744C696B657D205B726F6F74456C656D656E745D2054686520726F6F7420656C656D656E7420746F2062652061646465642E5C6E202A5C6E202A204072657475726E207B526F6F744C696B657D2054686520616464656420726F6F7420656C';
wwv_flow_imp.g_varchar2_table(4186) := '656D656E74206F7220616E20696D706C6963697420726F6F7420656C656D656E742E5C6E202A2F5C6E43616E7661732E70726F746F747970652E616464526F6F74456C656D656E74203D2066756E6374696F6E28726F6F74456C656D656E7429207B5C6E';
wwv_flow_imp.g_varchar2_table(4187) := '2020636F6E737420696478203D20746869732E5F726F6F74734964782B2B3B5C6E5C6E20206966202821726F6F74456C656D656E7429207B5C6E20202020726F6F74456C656D656E74203D207B5C6E20202020202069643A20275F5F696D706C69636974';
wwv_flow_imp.g_varchar2_table(4188) := '726F6F745F27202B206964782C5C6E2020202020206368696C6472656E3A205B5D2C5C6E2020202020206973496D706C696369743A20747275655C6E202020207D3B5C6E20207D5C6E5C6E2020636F6E7374206C617965724E616D65203D20726F6F7445';
wwv_flow_imp.g_varchar2_table(4189) := '6C656D656E742E6C61796572203D2027726F6F742D27202B206964783B5C6E5C6E2020746869732E5F656E7375726556616C69642827726F6F74272C20726F6F74456C656D656E74293B5C6E5C6E2020636F6E7374206C61796572203D20746869732E67';
wwv_flow_imp.g_varchar2_table(4190) := '65744C61796572286C617965724E616D652C20504C414E455F4C415945525F494E444558293B5C6E5C6E2020746869732E686964654C61796572286C617965724E616D65293B5C6E5C6E2020746869732E5F616464526F6F7428726F6F74456C656D656E';
wwv_flow_imp.g_varchar2_table(4191) := '742C206C61796572293B5C6E5C6E2020746869732E5F706C616E65732E70757368287B5C6E20202020726F6F74456C656D656E743A20726F6F74456C656D656E742C5C6E202020206C617965723A206C617965725C6E20207D293B5C6E5C6E2020726574';
wwv_flow_imp.g_varchar2_table(4192) := '75726E20726F6F74456C656D656E743B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052656D6F766573206120676976656E20726F6F7420656C656D656E7420616E642072657475726E732069742E5C6E202A5C6E202A2040706172616D207B526F6F744C696B';
wwv_flow_imp.g_varchar2_table(4193) := '657C737472696E677D20726F6F74456C656D656E7420656C656D656E74206F7220656C656D656E742049445C6E202A5C6E202A204072657475726E207B526F6F744C696B657C756E646566696E65647D2072656D6F76656420656C656D656E745C6E202A';
wwv_flow_imp.g_varchar2_table(4194) := '2F5C6E43616E7661732E70726F746F747970652E72656D6F7665526F6F74456C656D656E74203D2066756E6374696F6E28726F6F74456C656D656E7429207B5C6E5C6E202069662028747970656F6620726F6F74456C656D656E74203D3D3D2027737472';
wwv_flow_imp.g_varchar2_table(4195) := '696E672729207B5C6E20202020726F6F74456C656D656E74203D20746869732E5F656C656D656E7452656769737472792E67657428726F6F74456C656D656E74293B5C6E20207D5C6E5C6E2020636F6E737420706C616E65203D20746869732E5F66696E';
wwv_flow_imp.g_varchar2_table(4196) := '64506C616E65466F72526F6F7428726F6F74456C656D656E74293B5C6E5C6E20206966202821706C616E6529207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E20202F2F20686F6F6B207570206C6966652D6379636C65206576656E74735C6E';
wwv_flow_imp.g_varchar2_table(4197) := '2020746869732E5F72656D6F7665526F6F7428726F6F74456C656D656E74293B5C6E5C6E20202F2F20636C65616E207570206C617965725C6E2020746869732E5F72656D6F76654C6179657228726F6F74456C656D656E742E6C61796572293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(4198) := '20202F2F20636C65616E20757020706C616E655C6E2020746869732E5F706C616E6573203D20746869732E5F706C616E65732E66696C7465722866756E6374696F6E28706C616E6529207B5C6E2020202072657475726E20706C616E652E726F6F74456C';
wwv_flow_imp.g_varchar2_table(4199) := '656D656E7420213D3D20726F6F74456C656D656E743B5C6E20207D293B5C6E5C6E20202F2F20636C65616E2075702061637469766520726F6F745C6E202069662028746869732E5F726F6F74456C656D656E74203D3D3D20726F6F74456C656D656E7429';
wwv_flow_imp.g_varchar2_table(4200) := '207B5C6E20202020746869732E5F726F6F74456C656D656E74203D206E756C6C3B5C6E20207D5C6E5C6E202072657475726E20726F6F74456C656D656E743B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2053657473206120676976656E20656C656D656E';
wwv_flow_imp.g_varchar2_table(4201) := '7420617320746865206E657720726F6F7420656C656D656E7420666F72207468652063616E7661735C6E202A20616E642072657475726E7320746865206E657720726F6F7420656C656D656E742E5C6E202A5C6E202A2040706172616D207B526F6F744C';
wwv_flow_imp.g_varchar2_table(4202) := '696B657D20726F6F74456C656D656E742054686520726F6F7420656C656D656E7420746F206265207365742E5C6E202A5C6E202A204072657475726E207B526F6F744C696B657D205468652073657420726F6F7420656C656D656E742E5C6E202A2F5C6E';
wwv_flow_imp.g_varchar2_table(4203) := '43616E7661732E70726F746F747970652E736574526F6F74456C656D656E74203D2066756E6374696F6E28726F6F74456C656D656E7429207B5C6E5C6E202069662028726F6F74456C656D656E74203D3D3D20746869732E5F726F6F74456C656D656E74';
wwv_flow_imp.g_varchar2_table(4204) := '29207B5C6E2020202072657475726E20726F6F74456C656D656E743B5C6E20207D5C6E5C6E20206C657420706C616E653B5C6E5C6E20206966202821726F6F74456C656D656E7429207B5C6E202020207468726F77206E6577204572726F722827726F6F';
wwv_flow_imp.g_varchar2_table(4205) := '74456C656D656E7420726571756972656427293B5C6E20207D5C6E5C6E2020706C616E65203D20746869732E5F66696E64506C616E65466F72526F6F7428726F6F74456C656D656E74293B5C6E5C6E20202F2F206769766520736574206164642073656D';
wwv_flow_imp.g_varchar2_table(4206) := '616E7469637320666F72206261636B776172647320636F6D7061746962696C6974795C6E20206966202821706C616E6529207B5C6E20202020726F6F74456C656D656E74203D20746869732E616464526F6F74456C656D656E7428726F6F74456C656D65';
wwv_flow_imp.g_varchar2_table(4207) := '6E74293B5C6E20207D5C6E5C6E2020746869732E5F736574526F6F7428726F6F74456C656D656E74293B5C6E5C6E202072657475726E20726F6F74456C656D656E743B5C6E7D3B5C6E5C6E5C6E43616E7661732E70726F746F747970652E5F72656D6F76';
wwv_flow_imp.g_varchar2_table(4208) := '65526F6F74203D2066756E6374696F6E28656C656D656E7429207B5C6E2020636F6E737420656C656D656E745265676973747279203D20746869732E5F656C656D656E7452656769737472792C5C6E20202020202020206576656E74427573203D207468';
wwv_flow_imp.g_varchar2_table(4209) := '69732E5F6576656E744275733B5C6E5C6E20202F2F2073696D756C61746520656C656D656E742072656D6F7665206576656E742073657175656E63655C6E20206576656E744275732E666972652827726F6F742E72656D6F7665272C207B20656C656D65';
wwv_flow_imp.g_varchar2_table(4210) := '6E743A20656C656D656E74207D293B5C6E20206576656E744275732E666972652827726F6F742E72656D6F766564272C207B20656C656D656E743A20656C656D656E74207D293B5C6E5C6E2020656C656D656E7452656769737472792E72656D6F766528';
wwv_flow_imp.g_varchar2_table(4211) := '656C656D656E74293B5C6E7D3B5C6E5C6E5C6E43616E7661732E70726F746F747970652E5F616464526F6F74203D2066756E6374696F6E28656C656D656E742C2067667829207B5C6E2020636F6E737420656C656D656E745265676973747279203D2074';
wwv_flow_imp.g_varchar2_table(4212) := '6869732E5F656C656D656E7452656769737472792C5C6E20202020202020206576656E74427573203D20746869732E5F6576656E744275733B5C6E5C6E20202F2F20726573656D626C6520656C656D656E7420616464206576656E742073657175656E63';
wwv_flow_imp.g_varchar2_table(4213) := '655C6E20206576656E744275732E666972652827726F6F742E616464272C207B20656C656D656E743A20656C656D656E74207D293B5C6E5C6E2020656C656D656E7452656769737472792E61646428656C656D656E742C20676678293B5C6E5C6E202065';
wwv_flow_imp.g_varchar2_table(4214) := '76656E744275732E666972652827726F6F742E6164646564272C207B20656C656D656E743A20656C656D656E742C206766783A20676678207D293B5C6E7D3B5C6E5C6E5C6E43616E7661732E70726F746F747970652E5F736574526F6F74203D2066756E';
wwv_flow_imp.g_varchar2_table(4215) := '6374696F6E28726F6F74456C656D656E742C206C6179657229207B5C6E5C6E2020636F6E73742063757272656E74526F6F74203D20746869732E5F726F6F74456C656D656E743B5C6E5C6E20206966202863757272656E74526F6F7429207B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(4216) := '2020202F2F20756E2D6173736F63696174652070726576696F757320726F6F7420656C656D656E74203C7376673E5C6E20202020746869732E5F656C656D656E7452656769737472792E75706461746547726170686963732863757272656E74526F6F74';
wwv_flow_imp.g_varchar2_table(4217) := '2C206E756C6C2C2074727565293B5C6E5C6E202020202F2F20686964652070726576696F7573206C617965725C6E20202020746869732E686964654C617965722863757272656E74526F6F742E6C61796572293B5C6E20207D5C6E5C6E20206966202872';
wwv_flow_imp.g_varchar2_table(4218) := '6F6F74456C656D656E7429207B5C6E5C6E2020202069662028216C6179657229207B5C6E2020202020206C61796572203D20746869732E5F66696E64506C616E65466F72526F6F7428726F6F74456C656D656E74292E6C617965723B5C6E202020207D5C';
wwv_flow_imp.g_varchar2_table(4219) := '6E5C6E202020202F2F206173736F636961746520656C656D656E742077697468203C7376673E5C6E20202020746869732E5F656C656D656E7452656769737472792E757064617465477261706869637328726F6F74456C656D656E742C20746869732E5F';
wwv_flow_imp.g_varchar2_table(4220) := '7376672C2074727565293B5C6E5C6E202020202F2F2073686F7720726F6F74206C617965725C6E20202020746869732E73686F774C6179657228726F6F74456C656D656E742E6C61796572293B5C6E20207D5C6E5C6E2020746869732E5F726F6F74456C';
wwv_flow_imp.g_varchar2_table(4221) := '656D656E74203D20726F6F74456C656D656E743B5C6E5C6E2020746869732E5F6576656E744275732E666972652827726F6F742E736574272C207B20656C656D656E743A20726F6F74456C656D656E74207D293B5C6E7D3B5C6E5C6E43616E7661732E70';
wwv_flow_imp.g_varchar2_table(4222) := '726F746F747970652E5F656E7375726556616C6964203D2066756E6374696F6E28747970652C20656C656D656E7429207B5C6E20206966202821656C656D656E742E696429207B5C6E202020207468726F77206E6577204572726F722827656C656D656E';
wwv_flow_imp.g_varchar2_table(4223) := '74206D757374206861766520616E20696427293B5C6E20207D5C6E5C6E202069662028746869732E5F656C656D656E7452656769737472792E67657428656C656D656E742E69642929207B5C6E202020207468726F77206E6577204572726F722827656C';
wwv_flow_imp.g_varchar2_table(4224) := '656D656E74203C27202B20656C656D656E742E6964202B20273E20616C72656164792065786973747327293B5C6E20207D5C6E5C6E2020636F6E73742072657175697265644174747273203D2052455155495245445F4D4F44454C5F41545452535B7479';
wwv_flow_imp.g_varchar2_table(4225) := '70655D3B5C6E5C6E2020636F6E73742076616C6964203D20657665727928726571756972656441747472732C2066756E6374696F6E286174747229207B5C6E2020202072657475726E20747970656F6620656C656D656E745B617474725D20213D3D2027';
wwv_flow_imp.g_varchar2_table(4226) := '756E646566696E6564273B5C6E20207D293B5C6E5C6E2020696620282176616C696429207B5C6E202020207468726F77206E6577204572726F72285C6E202020202020276D75737420737570706C79207B2027202B20726571756972656441747472732E';
wwv_flow_imp.g_varchar2_table(4227) := '6A6F696E28272C202729202B2027207D20776974682027202B2074797065293B5C6E20207D5C6E7D3B5C6E5C6E43616E7661732E70726F746F747970652E5F736574506172656E74203D2066756E6374696F6E28656C656D656E742C20706172656E742C';
wwv_flow_imp.g_varchar2_table(4228) := '20706172656E74496E64657829207B5C6E2020636F6C6C656374696F6E41646428706172656E742E6368696C6472656E2C20656C656D656E742C20706172656E74496E646578293B5C6E2020656C656D656E742E706172656E74203D20706172656E743B';
wwv_flow_imp.g_varchar2_table(4229) := '5C6E7D3B5C6E5C6E2F2A2A5C6E202A204164647320616E20656C656D656E7420746F207468652063616E7661732E5C6E202A5C6E202A20546869732077697265732074686520706172656E74203C2D3E206368696C642072656C6174696F6E7368697020';
wwv_flow_imp.g_varchar2_table(4230) := '6265747765656E2074686520656C656D656E7420616E645C6E202A2061206578706C696369746C792073706563696669656420706172656E74206F7220616E20696D706C6963697420726F6F7420656C656D656E742E5C6E202A5C6E202A20447572696E';
wwv_flow_imp.g_varchar2_table(4231) := '672061646420697420656D69747320746865206576656E74735C6E202A5C6E202A20202A203C7B747970657D2E6164643E2028656C656D656E742C20706172656E74295C6E202A20202A203C7B747970657D2E61646465643E2028656C656D656E742C20';
wwv_flow_imp.g_varchar2_table(4232) := '676678295C6E202A5C6E202A20457874656E73696F6E73206D617920686F6F6B20696E746F207468657365206576656E747320746F20706572666F726D207468656972206D616769632E5C6E202A5C6E202A2040706172616D207B737472696E677D2074';
wwv_flow_imp.g_varchar2_table(4233) := '7970655C6E202A2040706172616D207B436F6E6E656374696F6E4C696B657C53686170654C696B657D20656C656D656E745C6E202A2040706172616D207B53686170654C696B657D205B706172656E745D5C6E202A2040706172616D207B6E756D626572';
wwv_flow_imp.g_varchar2_table(4234) := '7D205B706172656E74496E6465785D5C6E202A5C6E202A204072657475726E207B436F6E6E656374696F6E4C696B657C53686170654C696B657D2054686520616464656420656C656D656E742E5C6E202A2F5C6E43616E7661732E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(4235) := '2E5F616464456C656D656E74203D2066756E6374696F6E28747970652C20656C656D656E742C20706172656E742C20706172656E74496E64657829207B5C6E5C6E2020706172656E74203D20706172656E74207C7C20746869732E676574526F6F74456C';
wwv_flow_imp.g_varchar2_table(4236) := '656D656E7428293B5C6E5C6E2020636F6E7374206576656E74427573203D20746869732E5F6576656E744275732C5C6E20202020202020206772617068696373466163746F7279203D20746869732E5F6772617068696373466163746F72793B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(4237) := '2020746869732E5F656E7375726556616C696428747970652C20656C656D656E74293B5C6E5C6E20206576656E744275732E666972652874797065202B20272E616464272C207B20656C656D656E743A20656C656D656E742C20706172656E743A207061';
wwv_flow_imp.g_varchar2_table(4238) := '72656E74207D293B5C6E5C6E2020746869732E5F736574506172656E7428656C656D656E742C20706172656E742C20706172656E74496E646578293B5C6E5C6E20202F2F206372656174652067726170686963735C6E2020636F6E737420676678203D20';
wwv_flow_imp.g_varchar2_table(4239) := '6772617068696373466163746F72792E63726561746528747970652C20656C656D656E742C20706172656E74496E646578293B5C6E5C6E2020746869732E5F656C656D656E7452656769737472792E61646428656C656D656E742C20676678293B5C6E5C';
wwv_flow_imp.g_varchar2_table(4240) := '6E20202F2F20757064617465206974732076697375616C5C6E20206772617068696373466163746F72792E75706461746528747970652C20656C656D656E742C20676678293B5C6E5C6E20206576656E744275732E666972652874797065202B20272E61';
wwv_flow_imp.g_varchar2_table(4241) := '64646564272C207B20656C656D656E743A20656C656D656E742C206766783A20676678207D293B5C6E5C6E202072657475726E20656C656D656E743B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2041646473206120736861706520746F207468652063616E76';
wwv_flow_imp.g_varchar2_table(4242) := '61732E5C6E202A5C6E202A2040706172616D207B53686170654C696B657D2073686170652054686520736861706520746F2062652061646465645C6E202A2040706172616D207B506172656E744C696B657D205B706172656E745D205468652073686170';
wwv_flow_imp.g_varchar2_table(4243) := '65277320706172656E742E5C6E202A2040706172616D207B6E756D6265727D205B706172656E74496E6465785D2054686520696E64657820617420776869636820746F206164642074686520736861706520746F2074686520706172656E742773206368';
wwv_flow_imp.g_varchar2_table(4244) := '696C6472656E2E5C6E202A5C6E202A204072657475726E207B53686170654C696B657D205468652061646465642073686170652E5C6E202A2F5C6E43616E7661732E70726F746F747970652E6164645368617065203D2066756E6374696F6E2873686170';
wwv_flow_imp.g_varchar2_table(4245) := '652C20706172656E742C20706172656E74496E64657829207B5C6E202072657475726E20746869732E5F616464456C656D656E7428277368617065272C2073686170652C20706172656E742C20706172656E74496E646578293B5C6E7D3B5C6E5C6E2F2A';
wwv_flow_imp.g_varchar2_table(4246) := '2A5C6E202A2041646473206120636F6E6E656374696F6E20746F207468652063616E7661732E5C6E202A5C6E202A2040706172616D207B436F6E6E656374696F6E4C696B657D20636F6E6E656374696F6E2054686520636F6E6E656374696F6E20746F20';
wwv_flow_imp.g_varchar2_table(4247) := '62652061646465642E5C6E202A2040706172616D207B506172656E744C696B657D205B706172656E745D2054686520636F6E6E656374696F6E277320706172656E742E5C6E202A2040706172616D207B6E756D6265727D205B706172656E74496E646578';
wwv_flow_imp.g_varchar2_table(4248) := '5D2054686520696E64657820617420776869636820746F206164642074686520636F6E6E656374696F6E20746F2074686520706172656E742773206368696C6472656E2E5C6E202A5C6E202A204072657475726E207B436F6E6E656374696F6E4C696B65';
wwv_flow_imp.g_varchar2_table(4249) := '7D2054686520616464656420636F6E6E656374696F6E2E5C6E202A2F5C6E43616E7661732E70726F746F747970652E616464436F6E6E656374696F6E203D2066756E6374696F6E28636F6E6E656374696F6E2C20706172656E742C20706172656E74496E';
wwv_flow_imp.g_varchar2_table(4250) := '64657829207B5C6E202072657475726E20746869732E5F616464456C656D656E742827636F6E6E656374696F6E272C20636F6E6E656374696F6E2C20706172656E742C20706172656E74496E646578293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2049';
wwv_flow_imp.g_varchar2_table(4251) := '6E7465726E616C2072656D6F766520656C656D656E745C6E202A2F5C6E43616E7661732E70726F746F747970652E5F72656D6F7665456C656D656E74203D2066756E6374696F6E28656C656D656E742C207479706529207B5C6E5C6E2020636F6E737420';
wwv_flow_imp.g_varchar2_table(4252) := '656C656D656E745265676973747279203D20746869732E5F656C656D656E7452656769737472792C5C6E20202020202020206772617068696373466163746F7279203D20746869732E5F6772617068696373466163746F72792C5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(4253) := '6576656E74427573203D20746869732E5F6576656E744275733B5C6E5C6E2020656C656D656E74203D20656C656D656E7452656769737472792E67657428656C656D656E742E6964207C7C20656C656D656E74293B5C6E5C6E20206966202821656C656D';
wwv_flow_imp.g_varchar2_table(4254) := '656E7429207B5C6E5C6E202020202F2F20656C656D656E74207761732072656D6F76656420616C72656164795C6E2020202072657475726E3B5C6E20207D5C6E5C6E20206576656E744275732E666972652874797065202B20272E72656D6F7665272C20';
wwv_flow_imp.g_varchar2_table(4255) := '7B20656C656D656E743A20656C656D656E74207D293B5C6E5C6E20206772617068696373466163746F72792E72656D6F766528656C656D656E74293B5C6E5C6E20202F2F20756E73657420706172656E74203C2D3E206368696C642072656C6174696F6E';
wwv_flow_imp.g_varchar2_table(4256) := '736869705C6E2020636F6C6C656374696F6E52656D6F766528656C656D656E742E706172656E7420262620656C656D656E742E706172656E742E6368696C6472656E2C20656C656D656E74293B5C6E2020656C656D656E742E706172656E74203D206E75';
wwv_flow_imp.g_varchar2_table(4257) := '6C6C3B5C6E5C6E20206576656E744275732E666972652874797065202B20272E72656D6F766564272C207B20656C656D656E743A20656C656D656E74207D293B5C6E5C6E2020656C656D656E7452656769737472792E72656D6F766528656C656D656E74';
wwv_flow_imp.g_varchar2_table(4258) := '293B5C6E5C6E202072657475726E20656C656D656E743B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2052656D6F76657320612073686170652066726F6D207468652063616E7661732E5C6E202A5C6E202A2040666972657320536861706552656D6F7665';
wwv_flow_imp.g_varchar2_table(4259) := '4576656E745C6E202A2040666972657320536861706552656D6F7665644576656E745C6E202A5C6E202A2040706172616D207B53686170654C696B657C737472696E677D20736861706520546865207368617065206F72206974732049442E5C6E202A5C';
wwv_flow_imp.g_varchar2_table(4260) := '6E202A204072657475726E207B53686170654C696B657D205468652072656D6F7665642073686170652E5C6E202A2F5C6E43616E7661732E70726F746F747970652E72656D6F76655368617065203D2066756E6374696F6E28736861706529207B5C6E5C';
wwv_flow_imp.g_varchar2_table(4261) := '6E20202F2A2A5C6E2020202A20416E206576656E7420696E6469636174696E67207468617420612073686170652069732061626F757420746F2062652072656D6F7665642066726F6D207468652063616E7661732E5C6E2020202A5C6E2020202A20406D';
wwv_flow_imp.g_varchar2_table(4262) := '656D6265724F662043616E7661735C6E2020202A5C6E2020202A20406576656E7420536861706552656D6F76654576656E745C6E2020202A204074797065207B4F626A6563747D5C6E2020202A204070726F7065727479207B53686170654C696B657D20';
wwv_flow_imp.g_varchar2_table(4263) := '656C656D656E74205468652073686170652E5C6E2020202A204070726F7065727479207B535647456C656D656E747D20676678205468652067726170686963616C20656C656D656E742E5C6E2020202A2F5C6E5C6E20202F2A2A5C6E2020202A20416E20';
wwv_flow_imp.g_varchar2_table(4264) := '6576656E7420696E6469636174696E672074686174206120736861706520686173206265656E2072656D6F7665642066726F6D207468652063616E7661732E5C6E2020202A5C6E2020202A20406D656D6265724F662043616E7661735C6E2020202A5C6E';
wwv_flow_imp.g_varchar2_table(4265) := '2020202A20406576656E7420536861706552656D6F7665644576656E745C6E2020202A204074797065207B4F626A6563747D5C6E2020202A204070726F7065727479207B53686170654C696B657D20656C656D656E74205468652073686170652E5C6E20';
wwv_flow_imp.g_varchar2_table(4266) := '20202A204070726F7065727479207B535647456C656D656E747D20676678205468652067726170686963616C20656C656D656E742E5C6E2020202A2F5C6E202072657475726E20746869732E5F72656D6F7665456C656D656E742873686170652C202773';
wwv_flow_imp.g_varchar2_table(4267) := '6861706527293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2052656D6F766573206120636F6E6E656374696F6E2066726F6D207468652063616E7661732E5C6E202A5C6E202A2040666972657320436F6E6E656374696F6E52656D6F76654576656E745C';
wwv_flow_imp.g_varchar2_table(4268) := '6E202A2040666972657320436F6E6E656374696F6E52656D6F7665644576656E745C6E202A5C6E202A2040706172616D207B436F6E6E656374696F6E4C696B657C737472696E677D20636F6E6E656374696F6E2054686520636F6E6E656374696F6E206F';
wwv_flow_imp.g_varchar2_table(4269) := '72206974732049442E5C6E202A5C6E202A204072657475726E207B436F6E6E656374696F6E4C696B657D205468652072656D6F76656420636F6E6E656374696F6E2E5C6E202A2F5C6E43616E7661732E70726F746F747970652E72656D6F7665436F6E6E';
wwv_flow_imp.g_varchar2_table(4270) := '656374696F6E203D2066756E6374696F6E28636F6E6E656374696F6E29207B5C6E5C6E20202F2A2A5C6E2020202A20416E206576656E7420696E6469636174696E672074686174206120636F6E6E656374696F6E2069732061626F757420746F20626520';
wwv_flow_imp.g_varchar2_table(4271) := '72656D6F7665642066726F6D207468652063616E7661732E5C6E2020202A5C6E2020202A20406D656D6265724F662043616E7661735C6E2020202A5C6E2020202A20406576656E7420436F6E6E656374696F6E52656D6F76654576656E745C6E2020202A';
wwv_flow_imp.g_varchar2_table(4272) := '204074797065207B4F626A6563747D5C6E2020202A204070726F7065727479207B436F6E6E656374696F6E4C696B657D20656C656D656E742054686520636F6E6E656374696F6E2E5C6E2020202A204070726F7065727479207B535647456C656D656E74';
wwv_flow_imp.g_varchar2_table(4273) := '7D20676678205468652067726170686963616C20656C656D656E742E5C6E2020202A2F5C6E5C6E20202F2A2A5C6E2020202A20416E206576656E7420696E6469636174696E672074686174206120636F6E6E656374696F6E20686173206265656E207265';
wwv_flow_imp.g_varchar2_table(4274) := '6D6F7665642066726F6D207468652063616E7661732E5C6E2020202A5C6E2020202A20406D656D6265724F662043616E7661735C6E2020202A5C6E2020202A20406576656E7420436F6E6E656374696F6E52656D6F7665644576656E745C6E2020202A20';
wwv_flow_imp.g_varchar2_table(4275) := '4074797065207B4F626A6563747D5C6E2020202A204070726F7065727479207B436F6E6E656374696F6E4C696B657D20656C656D656E742054686520636F6E6E656374696F6E2E5C6E2020202A204070726F7065727479207B535647456C656D656E747D';
wwv_flow_imp.g_varchar2_table(4276) := '20676678205468652067726170686963616C20656C656D656E742E5C6E2020202A2F5C6E202072657475726E20746869732E5F72656D6F7665456C656D656E7428636F6E6E656374696F6E2C2027636F6E6E656374696F6E27293B5C6E7D3B5C6E5C6E5C';
wwv_flow_imp.g_varchar2_table(4277) := '6E2F2A2A5C6E202A2052657475726E73207468652067726170686963616C20656C656D656E74206F6620616E20656C656D656E742E5C6E202A5C6E202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E';
wwv_flow_imp.g_varchar2_table(4278) := '677D20656C656D656E742054686520656C656D656E74206F72206974732049442E5C6E202A2040706172616D207B626F6F6C65616E7D205B7365636F6E646172793D66616C73655D205768657468657220746F2072657475726E20746865207365636F6E';
wwv_flow_imp.g_varchar2_table(4279) := '646172792067726170686963616C20656C656D656E742E5C6E202A5C6E202A204072657475726E207B535647456C656D656E747D205468652067726170686963616C20656C656D656E742E5C6E202A2F5C6E43616E7661732E70726F746F747970652E67';
wwv_flow_imp.g_varchar2_table(4280) := '65744772617068696373203D2066756E6374696F6E28656C656D656E742C207365636F6E6461727929207B5C6E202072657475726E20746869732E5F656C656D656E7452656769737472792E676574477261706869637328656C656D656E742C20736563';
wwv_flow_imp.g_varchar2_table(4281) := '6F6E64617279293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A20506572666F726D20612076696577626F782075706461746520766961206120676976656E206368616E67652066756E6374696F6E2E5C6E202A5C6E202A2040706172616D207B46756E63';
wwv_flow_imp.g_varchar2_table(4282) := '74696F6E7D206368616E6765466E5C6E202A2F5C6E43616E7661732E70726F746F747970652E5F6368616E676556696577626F78203D2066756E6374696F6E286368616E6765466E29207B5C6E5C6E20202F2F206E6F74696679206F7468657273206F66';
wwv_flow_imp.g_varchar2_table(4283) := '20746865207570636F6D696E672076696577626F78206368616E67655C6E2020746869732E5F6576656E744275732E66697265282763616E7661732E76696577626F782E6368616E67696E6727293B5C6E5C6E20202F2F20706572666F726D2061637475';
wwv_flow_imp.g_varchar2_table(4284) := '616C206368616E67655C6E20206368616E6765466E2E6170706C792874686973293B5C6E5C6E20202F2F20726573657420746865206361636865642076696577626F7820736F20746861745C6E20202F2F2061206E657720676574206F7065726174696F';
wwv_flow_imp.g_varchar2_table(4285) := '6E206F6E2076696577626F78206F72207A6F6F6D5C6E20202F2F20747269676765727320612076696577626F782072652D636F6D7075746174696F6E5C6E2020746869732E5F63616368656456696577626F78203D206E756C6C3B5C6E5C6E20202F2F20';
wwv_flow_imp.g_varchar2_table(4286) := '6E6F74696679206F7468657273206F6620746865206368616E67653B207468697320737465705C6E20202F2F206D6179206F72206D6179206E6F74206265206465626F756E6365645C6E2020746869732E5F76696577626F784368616E67656428293B5C';
wwv_flow_imp.g_varchar2_table(4287) := '6E7D3B5C6E5C6E43616E7661732E70726F746F747970652E5F76696577626F784368616E676564203D2066756E6374696F6E2829207B5C6E2020746869732E5F6576656E744275732E66697265282763616E7661732E76696577626F782E6368616E6765';
wwv_flow_imp.g_varchar2_table(4288) := '64272C207B2076696577626F783A20746869732E76696577626F782829207D293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2047657473206F72207365747320746865207669657720626F78206F66207468652063616E7661732C20692E652E20746865';
wwv_flow_imp.g_varchar2_table(4289) := '5C6E202A206172656120746861742069732063757272656E746C7920646973706C617965642E5C6E202A5C6E202A2054686520676574746572206D61792072657475726E2061206361636865642076696577626F78202869662069742069732063757272';
wwv_flow_imp.g_varchar2_table(4290) := '656E746C795C6E202A206368616E67696E67292E20546F20666F7263652061207265636F6D7075746174696F6E2C2070617373206066616C7365602061732074686520666972737420617267756D656E742E5C6E202A5C6E202A20406578616D706C655C';
wwv_flow_imp.g_varchar2_table(4291) := '6E202A5C6E202A206060606A6176617363726970745C6E202A2063616E7661732E76696577626F78287B20783A203130302C20793A203130302C2077696474683A203530302C206865696768743A20353030207D295C6E202A5C6E202A202F2F20736574';
wwv_flow_imp.g_varchar2_table(4292) := '73207468652076697369626C652061726561206F6620746865206469616772616D20746F20283130307C31303029202D3E20283630307C313030295C6E202A202F2F20616E6420616E64207363616C6573206974206163636F7264696E6720746F207468';
wwv_flow_imp.g_varchar2_table(4293) := '65206469616772616D2077696474685C6E202A5C6E202A20636F6E73742076696577626F78203D2063616E7661732E76696577626F7828293B202F2F2070617373206066616C73656020746F20666F726365207265636F6D707574696E67207468652062';
wwv_flow_imp.g_varchar2_table(4294) := '6F782E5C6E202A5C6E202A20636F6E736F6C652E6C6F672876696577626F78293B5C6E202A202F2F207B5C6E202A202F2F202020696E6E65723A2044696D656E73696F6E732C5C6E202A202F2F2020206F757465723A2044696D656E73696F6E732C5C6E';
wwv_flow_imp.g_varchar2_table(4295) := '202A202F2F2020207363616C652C5C6E202A202F2F202020782C20792C5C6E202A202F2F20202077696474682C206865696768745C6E202A202F2F207D5C6E202A5C6E202A202F2F206966207468652063757272656E74206469616772616D206973207A';
wwv_flow_imp.g_varchar2_table(4296) := '6F6F6D656420616E64207363726F6C6C65642C20796F75206D617920726573657420697420746F207468655C6E202A202F2F2064656661756C74207A6F6F6D207669612074686973206D6574686F642C20746F6F3A5C6E202A5C6E202A20636F6E737420';
wwv_flow_imp.g_varchar2_table(4297) := '7A6F6F6D6564416E645363726F6C6C656456696577626F78203D2063616E7661732E76696577626F7828293B5C6E202A5C6E202A2063616E7661732E76696577626F78287B5C6E202A202020783A20302C5C6E202A202020793A20302C5C6E202A202020';
wwv_flow_imp.g_varchar2_table(4298) := '77696474683A207A6F6F6D6564416E645363726F6C6C656456696577626F782E6F757465722E77696474682C5C6E202A2020206865696768743A207A6F6F6D6564416E645363726F6C6C656456696577626F782E6F757465722E6865696768745C6E202A';
wwv_flow_imp.g_varchar2_table(4299) := '207D293B5C6E202A206060605C6E202A5C6E202A2040706172616D207B526563747D205B626F785D205468652076696577626F7820746F206265207365742E5C6E202A5C6E202A204072657475726E207B43616E76617356696577626F787D2054686520';
wwv_flow_imp.g_varchar2_table(4300) := '7365742076696577626F782E5C6E202A2F5C6E43616E7661732E70726F746F747970652E76696577626F78203D2066756E6374696F6E28626F7829207B5C6E5C6E202069662028626F78203D3D3D20756E646566696E656420262620746869732E5F6361';
wwv_flow_imp.g_varchar2_table(4301) := '6368656456696577626F7829207B5C6E2020202072657475726E20746869732E5F63616368656456696577626F783B5C6E20207D5C6E5C6E2020636F6E73742076696577706F7274203D20746869732E5F76696577706F72742C5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(4302) := '6F75746572426F78203D20746869732E67657453697A6528293B5C6E20206C657420696E6E6572426F782C5C6E2020202020206D61747269782C5C6E2020202020206163746976654C617965722C5C6E2020202020207472616E73666F726D2C5C6E2020';
wwv_flow_imp.g_varchar2_table(4303) := '202020207363616C652C5C6E202020202020782C20793B5C6E5C6E20206966202821626F7829207B5C6E5C6E202020202F2F20636F6D707574652074686520696E6E657220626F78206261736564206F6E207468655C6E202020202F2F20646961677261';
wwv_flow_imp.g_varchar2_table(4304) := '6D7320616374697665206C617965722E205468697320616C6C6F777320757320746F206578636C7564655C6E202020202F2F2065787465726E616C20636F6D706F6E656E74732C2073756368206173206F7665726C6179735C6E5C6E2020202061637469';
wwv_flow_imp.g_varchar2_table(4305) := '76654C61796572203D20746869732E5F726F6F74456C656D656E74203F20746869732E6765744163746976654C617965722829203A206E756C6C3B5C6E20202020696E6E6572426F78203D206163746976654C61796572202626206163746976654C6179';
wwv_flow_imp.g_varchar2_table(4306) := '65722E67657442426F782829207C7C207B7D3B5C6E5C6E202020207472616E73666F726D203D207376675472616E73666F726D2876696577706F7274293B5C6E202020206D6174726978203D207472616E73666F726D203F207472616E73666F726D2E6D';
wwv_flow_imp.g_varchar2_table(4307) := '6174726978203A206372656174654D617472697828293B5C6E202020207363616C65203D20726F756E64286D61747269782E612C2031303030293B5C6E5C6E2020202078203D20726F756E64282D6D61747269782E65207C7C20302C2031303030293B5C';
wwv_flow_imp.g_varchar2_table(4308) := '6E2020202079203D20726F756E64282D6D61747269782E66207C7C20302C2031303030293B5C6E5C6E20202020626F78203D20746869732E5F63616368656456696577626F78203D207B5C6E202020202020783A2078203F2078202F207363616C65203A';
wwv_flow_imp.g_varchar2_table(4309) := '20302C5C6E202020202020793A2079203F2079202F207363616C65203A20302C5C6E20202020202077696474683A206F75746572426F782E7769647468202F207363616C652C5C6E2020202020206865696768743A206F75746572426F782E6865696768';
wwv_flow_imp.g_varchar2_table(4310) := '74202F207363616C652C5C6E2020202020207363616C653A207363616C652C5C6E202020202020696E6E65723A207B5C6E202020202020202077696474683A20696E6E6572426F782E7769647468207C7C20302C5C6E2020202020202020686569676874';
wwv_flow_imp.g_varchar2_table(4311) := '3A20696E6E6572426F782E686569676874207C7C20302C5C6E2020202020202020783A20696E6E6572426F782E78207C7C20302C5C6E2020202020202020793A20696E6E6572426F782E79207C7C20305C6E2020202020207D2C5C6E2020202020206F75';
wwv_flow_imp.g_varchar2_table(4312) := '7465723A206F75746572426F785C6E202020207D3B5C6E5C6E2020202072657475726E20626F783B5C6E20207D20656C7365207B5C6E5C6E20202020746869732E5F6368616E676556696577626F782866756E6374696F6E2829207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(4313) := '7363616C65203D204D6174682E6D696E286F75746572426F782E7769647468202F20626F782E77696474682C206F75746572426F782E686569676874202F20626F782E686569676874293B5C6E5C6E202020202020636F6E7374206D6174726978203D20';
wwv_flow_imp.g_varchar2_table(4314) := '746869732E5F7376672E6372656174655356474D617472697828295C6E20202020202020202E7363616C65287363616C65295C6E20202020202020202E7472616E736C617465282D626F782E782C202D626F782E79293B5C6E5C6E202020202020737667';
wwv_flow_imp.g_varchar2_table(4315) := '5472616E73666F726D2876696577706F72742C206D6174726978293B5C6E202020207D293B5C6E20207D5C6E5C6E202072657475726E20626F783B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2047657473206F72207365747320746865207363726F6C6C';
wwv_flow_imp.g_varchar2_table(4316) := '206F66207468652063616E7661732E5C6E202A5C6E202A2040706172616D207B5363726F6C6C44656C74617D205B64656C74615D20546865207363726F6C6C20746F206265207365742E5C6E202A5C6E202A204072657475726E207B506F696E747D5C6E';
wwv_flow_imp.g_varchar2_table(4317) := '202A2F5C6E43616E7661732E70726F746F747970652E7363726F6C6C203D2066756E6374696F6E2864656C746129207B5C6E5C6E2020636F6E7374206E6F6465203D20746869732E5F76696577706F72743B5C6E20206C6574206D6174726978203D206E';
wwv_flow_imp.g_varchar2_table(4318) := '6F64652E67657443544D28293B5C6E5C6E20206966202864656C746129207B5C6E20202020746869732E5F6368616E676556696577626F782866756E6374696F6E2829207B5C6E20202020202064656C7461203D2061737369676E287B2064783A20302C';
wwv_flow_imp.g_varchar2_table(4319) := '2064793A2030207D2C2064656C7461207C7C207B7D293B5C6E5C6E2020202020206D6174726978203D20746869732E5F7376672E6372656174655356474D617472697828292E7472616E736C6174652864656C74612E64782C2064656C74612E6479292E';
wwv_flow_imp.g_varchar2_table(4320) := '6D756C7469706C79286D6174726978293B5C6E5C6E20202020202073657443544D286E6F64652C206D6174726978293B5C6E202020207D293B5C6E20207D5C6E5C6E202072657475726E207B20783A206D61747269782E652C20793A206D61747269782E';
wwv_flow_imp.g_varchar2_table(4321) := '66207D3B5C6E7D3B5C6E5C6E2F2A2A5C6E202A205363726F6C6C73207468652076696577626F7820746F20636F6E7461696E2074686520676976656E20656C656D656E742E5C6E202A204F7074696F6E616C6C7920737065636966792061207061646469';
wwv_flow_imp.g_varchar2_table(4322) := '6E6720746F206265206170706C69656420746F207468652065646765732E5C6E202A5C6E202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657C737472696E677D20656C656D656E742054686520656C656D656E7420';
wwv_flow_imp.g_varchar2_table(4323) := '746F207363726F6C6C20746F206F72206974732049442E5C6E202A2040706172616D207B526563745452424C7C6E756D6265727D205B70616464696E673D3130305D205468652070616464696E6720746F206265206170706C6965642E2043616E20616C';
wwv_flow_imp.g_varchar2_table(4324) := '736F207370656369667920746F702C20626F74746F6D2C206C65667420616E642072696768742E5C6E202A2F5C6E43616E7661732E70726F746F747970652E7363726F6C6C546F456C656D656E74203D2066756E6374696F6E28656C656D656E742C2070';
wwv_flow_imp.g_varchar2_table(4325) := '616464696E6729207B5C6E20206C65742064656661756C7450616464696E67203D203130303B5C6E5C6E202069662028747970656F6620656C656D656E74203D3D3D2027737472696E672729207B5C6E20202020656C656D656E74203D20746869732E5F';
wwv_flow_imp.g_varchar2_table(4326) := '656C656D656E7452656769737472792E67657428656C656D656E74293B5C6E20207D5C6E5C6E20202F2F2073657420746F20636F727265637420726F6F74456C656D656E745C6E2020636F6E737420726F6F74456C656D656E74203D20746869732E6669';
wwv_flow_imp.g_varchar2_table(4327) := '6E64526F6F7428656C656D656E74293B5C6E5C6E202069662028726F6F74456C656D656E7420213D3D20746869732E676574526F6F74456C656D656E74282929207B5C6E20202020746869732E736574526F6F74456C656D656E7428726F6F74456C656D';
wwv_flow_imp.g_varchar2_table(4328) := '656E74293B5C6E20207D5C6E5C6E20202F2F20656C656D656E7420697320726F6F74456C656D656E742C20646F206E6F74206368616E67652076696577706F72745C6E202069662028726F6F74456C656D656E74203D3D3D20656C656D656E7429207B5C';
wwv_flow_imp.g_varchar2_table(4329) := '6E2020202072657475726E3B5C6E20207D5C6E5C6E2020696620282170616464696E6729207B5C6E2020202070616464696E67203D207B7D3B5C6E20207D5C6E202069662028747970656F662070616464696E67203D3D3D20276E756D6265722729207B';
wwv_flow_imp.g_varchar2_table(4330) := '5C6E2020202064656661756C7450616464696E67203D2070616464696E673B5C6E20207D5C6E5C6E202070616464696E67203D207B5C6E20202020746F703A2070616464696E672E746F70207C7C2064656661756C7450616464696E672C5C6E20202020';
wwv_flow_imp.g_varchar2_table(4331) := '72696768743A2070616464696E672E7269676874207C7C2064656661756C7450616464696E672C5C6E20202020626F74746F6D3A2070616464696E672E626F74746F6D207C7C2064656661756C7450616464696E672C5C6E202020206C6566743A207061';
wwv_flow_imp.g_varchar2_table(4332) := '6464696E672E6C656674207C7C2064656661756C7450616464696E675C6E20207D3B5C6E5C6E2020636F6E737420656C656D656E74426F756E6473203D20676574426F756E64696E67426F7828656C656D656E74292C5C6E2020202020202020656C656D';
wwv_flow_imp.g_varchar2_table(4333) := '656E745472626C203D2061735452424C28656C656D656E74426F756E6473292C5C6E202020202020202076696577626F78426F756E6473203D20746869732E76696577626F7828292C5C6E20202020202020207A6F6F6D203D20746869732E7A6F6F6D28';
wwv_flow_imp.g_varchar2_table(4334) := '293B5C6E20206C65742064782C2064793B5C6E5C6E20202F2F20736872696E6B2076696577626F78426F756E647320776974682070616464696E675C6E202076696577626F78426F756E64732E79202B3D2070616464696E672E746F70202F207A6F6F6D';
wwv_flow_imp.g_varchar2_table(4335) := '3B5C6E202076696577626F78426F756E64732E78202B3D2070616464696E672E6C656674202F207A6F6F6D3B5C6E202076696577626F78426F756E64732E7769647468202D3D202870616464696E672E7269676874202B2070616464696E672E6C656674';
wwv_flow_imp.g_varchar2_table(4336) := '29202F207A6F6F6D3B5C6E202076696577626F78426F756E64732E686569676874202D3D202870616464696E672E626F74746F6D202B2070616464696E672E746F7029202F207A6F6F6D3B5C6E5C6E2020636F6E73742076696577626F785472626C203D';
wwv_flow_imp.g_varchar2_table(4337) := '2061735452424C2876696577626F78426F756E6473293B5C6E5C6E2020636F6E73742063616E466974203D20656C656D656E74426F756E64732E7769647468203C2076696577626F78426F756E64732E776964746820262620656C656D656E74426F756E';
wwv_flow_imp.g_varchar2_table(4338) := '64732E686569676874203C2076696577626F78426F756E64732E6865696768743B5C6E5C6E2020696620282163616E46697429207B5C6E5C6E202020202F2F20746F702D6C656674207768656E20656C656D656E742063616E2774206669745C6E202020';
wwv_flow_imp.g_varchar2_table(4339) := '206478203D20656C656D656E74426F756E64732E78202D2076696577626F78426F756E64732E783B5C6E202020206479203D20656C656D656E74426F756E64732E79202D2076696577626F78426F756E64732E793B5C6E5C6E20207D20656C7365207B5C';
wwv_flow_imp.g_varchar2_table(4340) := '6E5C6E20202020636F6E737420645269676874203D204D6174682E6D617828302C20656C656D656E745472626C2E7269676874202D2076696577626F785472626C2E7269676874292C5C6E20202020202020202020644C656674203D204D6174682E6D69';
wwv_flow_imp.g_varchar2_table(4341) := '6E28302C20656C656D656E745472626C2E6C656674202D2076696577626F785472626C2E6C656674292C5C6E2020202020202020202064426F74746F6D203D204D6174682E6D617828302C20656C656D656E745472626C2E626F74746F6D202D20766965';
wwv_flow_imp.g_varchar2_table(4342) := '77626F785472626C2E626F74746F6D292C5C6E2020202020202020202064546F70203D204D6174682E6D696E28302C20656C656D656E745472626C2E746F70202D2076696577626F785472626C2E746F70293B5C6E5C6E202020206478203D2064526967';
wwv_flow_imp.g_varchar2_table(4343) := '6874207C7C20644C6566743B5C6E202020206479203D2064426F74746F6D207C7C2064546F703B5C6E5C6E20207D5C6E5C6E2020746869732E7363726F6C6C287B2064783A202D6478202A207A6F6F6D2C2064793A202D6479202A207A6F6F6D207D293B';
wwv_flow_imp.g_varchar2_table(4344) := '5C6E7D3B5C6E5C6E2F2A2A5C6E202A2047657473206F722073657473207468652063757272656E74207A6F6F6D206F66207468652063616E7661732C206F7074696F6E616C6C79207A6F6F6D696E6720746F207468655C6E202A20737065636966696564';
wwv_flow_imp.g_varchar2_table(4345) := '20706F736974696F6E2E5C6E202A5C6E202A2054686520676574746572206D61792072657475726E206120636163686564207A6F6F6D206C6576656C2E2043616C6C2069742077697468206066616C736560206173207468652066697273745C6E202A20';
wwv_flow_imp.g_varchar2_table(4346) := '617267756D656E7420746F20666F726365207265636F6D7075746174696F6E206F66207468652063757272656E74206C6576656C2E5C6E202A5C6E202A2040706172616D207B6E756D6265727C276669742D76696577706F7274277D205B6E6577536361';
wwv_flow_imp.g_varchar2_table(4347) := '6C655D20546865206E6577207A6F6F6D206C6576656C2C206569746865722061206E756D6265722C5C6E202A20692E652E20302E392C206F7220606669742D76696577706F72746020746F2061646A757374207468652073697A6520746F206669742074';
wwv_flow_imp.g_varchar2_table(4348) := '68652063757272656E742076696577706F72742E5C6E202A2040706172616D207B506F696E747D205B63656E7465725D20546865207265666572656E636520706F696E74207B20783A202E2E2E2C20793A202E2E2E7D20746F207A6F6F6D20746F2E5C6E';
wwv_flow_imp.g_varchar2_table(4349) := '202A5C6E202A204072657475726E207B6E756D6265727D2054686520736574207A6F6F6D206C6576656C2E5C6E202A2F5C6E43616E7661732E70726F746F747970652E7A6F6F6D203D2066756E6374696F6E286E65775363616C652C2063656E74657229';
wwv_flow_imp.g_varchar2_table(4350) := '207B5C6E5C6E202069662028216E65775363616C6529207B5C6E2020202072657475726E20746869732E76696577626F78286E65775363616C65292E7363616C653B5C6E20207D5C6E5C6E2020696620286E65775363616C65203D3D3D20276669742D76';
wwv_flow_imp.g_varchar2_table(4351) := '696577706F72742729207B5C6E2020202072657475726E20746869732E5F66697456696577706F72742863656E746572293B5C6E20207D5C6E5C6E20206C6574206F757465722C5C6E2020202020206D61747269783B5C6E5C6E2020746869732E5F6368';
wwv_flow_imp.g_varchar2_table(4352) := '616E676556696577626F782866756E6374696F6E2829207B5C6E5C6E2020202069662028747970656F662063656E74657220213D3D20276F626A6563742729207B5C6E2020202020206F75746572203D20746869732E76696577626F7828292E6F757465';
wwv_flow_imp.g_varchar2_table(4353) := '723B5C6E5C6E20202020202063656E746572203D207B5C6E2020202020202020783A206F757465722E7769647468202F20322C5C6E2020202020202020793A206F757465722E686569676874202F20325C6E2020202020207D3B5C6E202020207D5C6E5C';
wwv_flow_imp.g_varchar2_table(4354) := '6E202020206D6174726978203D20746869732E5F7365745A6F6F6D286E65775363616C652C2063656E746572293B5C6E20207D293B5C6E5C6E202072657475726E20726F756E64286D61747269782E612C2031303030293B5C6E7D3B5C6E5C6E66756E63';
wwv_flow_imp.g_varchar2_table(4355) := '74696F6E2073657443544D286E6F64652C206D29207B5C6E2020636F6E7374206D737472203D20276D61747269782827202B206D2E61202B20272C27202B206D2E62202B20272C27202B206D2E63202B20272C27202B206D2E64202B20272C27202B206D';
wwv_flow_imp.g_varchar2_table(4356) := '2E65202B20272C27202B206D2E66202B202729273B5C6E20206E6F64652E73657441747472696275746528277472616E73666F726D272C206D737472293B5C6E7D5C6E5C6E43616E7661732E70726F746F747970652E5F66697456696577706F7274203D';
wwv_flow_imp.g_varchar2_table(4357) := '2066756E6374696F6E2863656E74657229207B5C6E5C6E2020636F6E73742076626F78203D20746869732E76696577626F7828292C5C6E20202020202020206F75746572203D2076626F782E6F757465722C5C6E2020202020202020696E6E6572203D20';
wwv_flow_imp.g_varchar2_table(4358) := '76626F782E696E6E65723B5C6E20206C6574206E65775363616C652C5C6E2020202020206E657756696577626F783B5C6E5C6E20202F2F20646973706C61792074686520636F6D706C657465206469616772616D20776974686F7574207A6F6F6D696E67';
wwv_flow_imp.g_varchar2_table(4359) := '20696E2E5C6E20202F2F20696E7374656164206F662072656C79696E67206F6E20696E7465726E616C207A6F6F6D2C20776520706572666F726D20615C6E20202F2F2068617264207265736574206F6E207468652063616E7661732076696577626F7820';
wwv_flow_imp.g_varchar2_table(4360) := '746F207265616C697A6520746869735C6E20202F2F5C6E20202F2F206966206469616772616D20646F6573206E6F74206E65656420746F206265207A6F6F6D656420696E2C20776520666F6375732069742061726F756E645C6E20202F2F207468652064';
wwv_flow_imp.g_varchar2_table(4361) := '69616772616D206F726967696E20696E73746561645C6E5C6E202069662028696E6E65722E78203E3D20302026265C6E202020202020696E6E65722E79203E3D20302026265C6E202020202020696E6E65722E78202B20696E6E65722E7769647468203C';
wwv_flow_imp.g_varchar2_table(4362) := '3D206F757465722E77696474682026265C6E202020202020696E6E65722E79202B20696E6E65722E686569676874203C3D206F757465722E6865696768742026265C6E2020202020202163656E74657229207B5C6E5C6E202020206E657756696577626F';
wwv_flow_imp.g_varchar2_table(4363) := '78203D207B5C6E202020202020783A20302C5C6E202020202020793A20302C5C6E20202020202077696474683A204D6174682E6D617828696E6E65722E7769647468202B20696E6E65722E782C206F757465722E7769647468292C5C6E20202020202068';
wwv_flow_imp.g_varchar2_table(4364) := '65696768743A204D6174682E6D617828696E6E65722E686569676874202B20696E6E65722E792C206F757465722E686569676874295C6E202020207D3B5C6E20207D20656C7365207B5C6E5C6E202020206E65775363616C65203D204D6174682E6D696E';
wwv_flow_imp.g_varchar2_table(4365) := '28312C206F757465722E7769647468202F20696E6E65722E77696474682C206F757465722E686569676874202F20696E6E65722E686569676874293B5C6E202020206E657756696577626F78203D207B5C6E202020202020783A20696E6E65722E78202B';
wwv_flow_imp.g_varchar2_table(4366) := '202863656E746572203F20696E6E65722E7769647468202F2032202D206F757465722E7769647468202F206E65775363616C65202F2032203A2030292C5C6E202020202020793A20696E6E65722E79202B202863656E746572203F20696E6E65722E6865';
wwv_flow_imp.g_varchar2_table(4367) := '69676874202F2032202D206F757465722E686569676874202F206E65775363616C65202F2032203A2030292C5C6E20202020202077696474683A206F757465722E7769647468202F206E65775363616C652C5C6E2020202020206865696768743A206F75';
wwv_flow_imp.g_varchar2_table(4368) := '7465722E686569676874202F206E65775363616C655C6E202020207D3B5C6E20207D5C6E5C6E2020746869732E76696577626F78286E657756696577626F78293B5C6E5C6E202072657475726E20746869732E76696577626F782866616C7365292E7363';
wwv_flow_imp.g_varchar2_table(4369) := '616C653B5C6E7D3B5C6E5C6E5C6E43616E7661732E70726F746F747970652E5F7365745A6F6F6D203D2066756E6374696F6E287363616C652C2063656E74657229207B5C6E5C6E2020636F6E737420737667203D20746869732E5F7376672C5C6E202020';
wwv_flow_imp.g_varchar2_table(4370) := '202020202076696577706F7274203D20746869732E5F76696577706F72743B5C6E5C6E2020636F6E7374206D6174726978203D207376672E6372656174655356474D617472697828293B5C6E2020636F6E737420706F696E74203D207376672E63726561';
wwv_flow_imp.g_varchar2_table(4371) := '7465535647506F696E7428293B5C6E5C6E20206C65742063656E746572506F696E742C5C6E2020202020206F726967696E616C506F696E742C5C6E20202020202063757272656E744D61747269782C5C6E2020202020207363616C654D61747269782C5C';
wwv_flow_imp.g_varchar2_table(4372) := '6E2020202020206E65774D61747269783B5C6E5C6E202063757272656E744D6174726978203D2076696577706F72742E67657443544D28293B5C6E5C6E2020636F6E73742063757272656E745363616C65203D2063757272656E744D61747269782E613B';
wwv_flow_imp.g_varchar2_table(4373) := '5C6E5C6E20206966202863656E74657229207B5C6E2020202063656E746572506F696E74203D2061737369676E28706F696E742C2063656E746572293B5C6E5C6E202020202F2F20726576657274206170706C6965642076696577706F7274207472616E';
wwv_flow_imp.g_varchar2_table(4374) := '73666F726D6174696F6E735C6E202020206F726967696E616C506F696E74203D2063656E746572506F696E742E6D61747269785472616E73666F726D2863757272656E744D61747269782E696E76657273652829293B5C6E5C6E202020202F2F20637265';
wwv_flow_imp.g_varchar2_table(4375) := '617465207363616C65206D61747269785C6E202020207363616C654D6174726978203D206D61747269785C6E2020202020202E7472616E736C617465286F726967696E616C506F696E742E782C206F726967696E616C506F696E742E79295C6E20202020';
wwv_flow_imp.g_varchar2_table(4376) := '20202E7363616C652831202F2063757272656E745363616C65202A207363616C65295C6E2020202020202E7472616E736C617465282D6F726967696E616C506F696E742E782C202D6F726967696E616C506F696E742E79293B5C6E5C6E202020206E6577';
wwv_flow_imp.g_varchar2_table(4377) := '4D6174726978203D2063757272656E744D61747269782E6D756C7469706C79287363616C654D6174726978293B5C6E20207D20656C7365207B5C6E202020206E65774D6174726978203D206D61747269782E7363616C65287363616C65293B5C6E20207D';
wwv_flow_imp.g_varchar2_table(4378) := '5C6E5C6E202073657443544D28746869732E5F76696577706F72742C206E65774D6174726978293B5C6E5C6E202072657475726E206E65774D61747269783B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E73207468652073697A65206F66';
wwv_flow_imp.g_varchar2_table(4379) := '207468652063616E7661732E5C6E202A5C6E202A204072657475726E207B44696D656E73696F6E737D205468652073697A65206F66207468652063616E7661732E5C6E202A2F5C6E43616E7661732E70726F746F747970652E67657453697A65203D2066';
wwv_flow_imp.g_varchar2_table(4380) := '756E6374696F6E2829207B5C6E202072657475726E207B5C6E2020202077696474683A20746869732E5F636F6E7461696E65722E636C69656E7457696474682C5C6E202020206865696768743A20746869732E5F636F6E7461696E65722E636C69656E74';
wwv_flow_imp.g_varchar2_table(4381) := '4865696768745C6E20207D3B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E7320746865206162736F6C75746520626F756E64696E6720626F78206F6620616E20656C656D656E742E5C6E202A5C6E202A20546865206162736F6C75746520';
wwv_flow_imp.g_varchar2_table(4382) := '626F756E64696E6720626F78206D6179206265207573656420746F20646973706C6179206F7665726C61797320696E207468652063616C6C6572735C6E202A202862726F777365722920636F6F7264696E6174652073797374656D207261746865722074';
wwv_flow_imp.g_varchar2_table(4383) := '68616E20746865207A6F6F6D656420696E2F6F75742063616E76617320636F6F7264696E617465732E5C6E202A5C6E202A2040706172616D207B53686170654C696B657C436F6E6E656374696F6E4C696B657D20656C656D656E742054686520656C656D';
wwv_flow_imp.g_varchar2_table(4384) := '656E742E5C6E202A5C6E202A204072657475726E207B526563747D2054686520656C656D656E742773206162736F6C75746520626F756E64696E6720626F782E5C6E202A2F5C6E43616E7661732E70726F746F747970652E6765744162736F6C75746542';
wwv_flow_imp.g_varchar2_table(4385) := '426F78203D2066756E6374696F6E28656C656D656E7429207B5C6E2020636F6E73742076626F78203D20746869732E76696577626F7828293B5C6E20206C65742062626F783B5C6E5C6E20202F2F20636F6E6E656374696F6E5C6E20202F2F2075736520';
wwv_flow_imp.g_varchar2_table(4386) := '7376672062626F785C6E202069662028656C656D656E742E776179706F696E747329207B5C6E20202020636F6E737420676678203D20746869732E676574477261706869637328656C656D656E74293B5C6E5C6E2020202062626F78203D206766782E67';
wwv_flow_imp.g_varchar2_table(4387) := '657442426F7828293B5C6E20207D5C6E5C6E20202F2F207368617065735C6E20202F2F2075736520646174615C6E2020656C7365207B5C6E2020202062626F78203D20656C656D656E743B5C6E20207D5C6E5C6E2020636F6E73742078203D2062626F78';
wwv_flow_imp.g_varchar2_table(4388) := '2E78202A2076626F782E7363616C65202D2076626F782E78202A2076626F782E7363616C653B5C6E2020636F6E73742079203D2062626F782E79202A2076626F782E7363616C65202D2076626F782E79202A2076626F782E7363616C653B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(4389) := '636F6E7374207769647468203D2062626F782E7769647468202A2076626F782E7363616C653B5C6E2020636F6E737420686569676874203D2062626F782E686569676874202A2076626F782E7363616C653B5C6E5C6E202072657475726E207B5C6E2020';
wwv_flow_imp.g_varchar2_table(4390) := '2020783A20782C5C6E20202020793A20792C5C6E2020202077696474683A2077696474682C5C6E202020206865696768743A206865696768745C6E20207D3B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20466972657320616E206576656E7420736F206F7468';
wwv_flow_imp.g_varchar2_table(4391) := '6572206D6F64756C65732063616E20726561637420746F207468652063616E76617320726573697A696E672E5C6E202A2F5C6E43616E7661732E70726F746F747970652E726573697A6564203D2066756E6374696F6E2829207B5C6E5C6E20202F2F2066';
wwv_flow_imp.g_varchar2_table(4392) := '6F726365207265636F6D7075746174696F6E206F66207669657720626F785C6E202064656C65746520746869732E5F63616368656456696577626F783B5C6E5C6E2020746869732E5F6576656E744275732E66697265282763616E7661732E726573697A';
wwv_flow_imp.g_varchar2_table(4393) := '656427293B5C6E7D3B5C6E222C22696D706F7274207B5C6E20206372656174655C6E7D2066726F6D20272E2E2F6D6F64656C273B5C6E5C6E696D706F7274207B2061737369676E207D2066726F6D20276D696E2D64617368273B5C6E5C6E2F2A2A5C6E20';
wwv_flow_imp.g_varchar2_table(4394) := '2A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E745C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E436F6E6E656374';
wwv_flow_imp.g_varchar2_table(4395) := '696F6E7D20436F6E6E656374696F6E5C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E4C6162656C7D204C6162656C5C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F54';
wwv_flow_imp.g_varchar2_table(4396) := '7970657327292E526F6F747D20526F6F745C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E53686170657D2053686170655C6E202A2F5C6E5C6E2F2A2A5C6E202A204120666163746F727920666F7220';
wwv_flow_imp.g_varchar2_table(4397) := '6D6F64656C20656C656D656E74732E5C6E202A5C6E202A204074656D706C617465207B436F6E6E656374696F6E7D205B543D436F6E6E656374696F6E5D5C6E202A204074656D706C617465207B4C6162656C7D205B553D4C6162656C5D5C6E202A204074';
wwv_flow_imp.g_varchar2_table(4398) := '656D706C617465207B526F6F747D205B563D526F6F745D5C6E202A204074656D706C617465207B53686170657D205B573D53686170655D5C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E20456C656D656E74466163746F7279';
wwv_flow_imp.g_varchar2_table(4399) := '2829207B5C6E2020746869732E5F756964203D2031323B5C6E7D5C6E5C6E2F2A2A5C6E202A20437265617465206120726F6F7420656C656D656E742E5C6E202A5C6E202A2040706172616D207B5061727469616C3C526F6F743E7D205B61747472735D5C';
wwv_flow_imp.g_varchar2_table(4400) := '6E202A5C6E202A204072657475726E207B567D20546865206372656174656420726F6F7420656C656D656E742E5C6E202A2F5C6E456C656D656E74466163746F72792E70726F746F747970652E637265617465526F6F74203D2066756E6374696F6E2861';
wwv_flow_imp.g_varchar2_table(4401) := '7474727329207B5C6E202072657475726E20746869732E6372656174652827726F6F74272C206174747273293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204372656174652061206C6162656C2E5C6E202A5C6E202A2040706172616D207B5061727469616C';
wwv_flow_imp.g_varchar2_table(4402) := '3C4C6162656C3E7D205B61747472735D5C6E202A5C6E202A204072657475726E207B557D205468652063726561746564206C6162656C2E5C6E202A2F5C6E456C656D656E74466163746F72792E70726F746F747970652E6372656174654C6162656C203D';
wwv_flow_imp.g_varchar2_table(4403) := '2066756E6374696F6E28617474727329207B5C6E202072657475726E20746869732E63726561746528276C6162656C272C206174747273293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2043726561746520612073686170652E5C6E202A5C6E202A20407061';
wwv_flow_imp.g_varchar2_table(4404) := '72616D207B5061727469616C3C53686170653E7D205B61747472735D5C6E202A5C6E202A204072657475726E207B577D2054686520637265617465642073686170652E5C6E202A2F5C6E456C656D656E74466163746F72792E70726F746F747970652E63';
wwv_flow_imp.g_varchar2_table(4405) := '72656174655368617065203D2066756E6374696F6E28617474727329207B5C6E202072657475726E20746869732E63726561746528277368617065272C206174747273293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20437265617465206120636F6E6E6563';
wwv_flow_imp.g_varchar2_table(4406) := '74696F6E2E5C6E202A5C6E202A2040706172616D207B5061727469616C3C436F6E6E656374696F6E3E7D205B61747472735D5C6E202A5C6E202A204072657475726E207B547D20546865206372656174656420636F6E6E656374696F6E2E5C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(4407) := '6E456C656D656E74466163746F72792E70726F746F747970652E637265617465436F6E6E656374696F6E203D2066756E6374696F6E28617474727329207B5C6E202072657475726E20746869732E6372656174652827636F6E6E656374696F6E272C2061';
wwv_flow_imp.g_varchar2_table(4408) := '74747273293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20437265617465206120726F6F7420656C656D656E742E5C6E202A5C6E202A20406F7665726C6F72645C6E202A2040706172616D207B27726F6F74277D20747970655C6E202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(4409) := '5061727469616C3C526F6F743E7D205B61747472735D5C6E202A204072657475726E207B567D5C6E202A2F5C6E2F2A2A5C6E202A2043726561746520612073686170652E5C6E202A5C6E202A20406F7665726C6F72645C6E202A2040706172616D207B27';
wwv_flow_imp.g_varchar2_table(4410) := '7368617065277D20747970655C6E202A2040706172616D207B5061727469616C3C53686170653E7D205B61747472735D5C6E202A204072657475726E207B577D5C6E202A2F5C6E2F2A2A5C6E202A20437265617465206120636F6E6E656374696F6E2E5C';
wwv_flow_imp.g_varchar2_table(4411) := '6E202A5C6E202A20406F7665726C6F72645C6E202A2040706172616D207B27636F6E6E656374696F6E277D20747970655C6E202A2040706172616D207B5061727469616C3C436F6E6E656374696F6E3E7D205B61747472735D5C6E202A20407265747572';
wwv_flow_imp.g_varchar2_table(4412) := '6E207B547D5C6E202A2F5C6E2F2A2A5C6E202A204372656174652061206C6162656C2E5C6E202A5C6E202A2040706172616D207B276C6162656C277D20747970655C6E202A2040706172616D207B5061727469616C3C4C6162656C3E7D205B6174747273';
wwv_flow_imp.g_varchar2_table(4413) := '5D5C6E202A204072657475726E207B557D5C6E202A2F5C6E456C656D656E74466163746F72792E70726F746F747970652E637265617465203D2066756E6374696F6E28747970652C20617474727329207B5C6E5C6E20206174747273203D206173736967';
wwv_flow_imp.g_varchar2_table(4414) := '6E287B7D2C206174747273207C7C207B7D293B5C6E5C6E2020696620282161747472732E696429207B5C6E2020202061747472732E6964203D2074797065202B20275F27202B2028746869732E5F7569642B2B293B5C6E20207D5C6E5C6E202072657475';
wwv_flow_imp.g_varchar2_table(4415) := '726E2063726561746528747970652C206174747273293B5C6E7D3B222C2276617220454C454D454E545F4944203D2027646174612D656C656D656E742D6964273B5C6E5C6E696D706F7274207B20617474722061732073766741747472207D2066726F6D';
wwv_flow_imp.g_varchar2_table(4416) := '202774696E792D737667273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2F547970657327292E456C656D656E744C696B657D20456C656D656E744C696B655C6E202A5C6E202A204074797065646566207B696D706F72';
wwv_flow_imp.g_varchar2_table(4417) := '7428272E2F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A5C6E202A204074797065646566207B2028656C656D656E743A20456C656D656E744C696B652C206766783A20535647456C656D656E7429203D3E20626F6F6C';
wwv_flow_imp.g_varchar2_table(4418) := '65616E7C616E79207D20456C656D656E74526567697374727946696C74657243616C6C6261636B5C6E202A204074797065646566207B2028656C656D656E743A20456C656D656E744C696B652C206766783A20535647456C656D656E7429203D3E20616E';
wwv_flow_imp.g_varchar2_table(4419) := '79207D20456C656D656E745265676973747279466F724561636843616C6C6261636B5C6E202A2F5C6E5C6E2F2A2A5C6E202A20412072656769737472792074686174206B6565707320747261636B206F6620616C6C2073686170657320696E2074686520';
wwv_flow_imp.g_varchar2_table(4420) := '6469616772616D2E5C6E202A5C6E202A2040636C6173735C6E202A2040636F6E7374727563746F725C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2F5C6E6578706F72742064656661756C742066756E';
wwv_flow_imp.g_varchar2_table(4421) := '6374696F6E20456C656D656E745265676973747279286576656E7442757329207B5C6E5C6E20202F2A2A5C6E2020202A204074797065207B207B5C6E2020202A2020205B69643A20737472696E675D3A207B5C6E2020202A2020202020656C656D656E74';
wwv_flow_imp.g_varchar2_table(4422) := '3A20456C656D656E744C696B653B5C6E2020202A20202020206766783F3A20535647456C656D656E743B5C6E2020202A20202020207365636F6E646172794766783F3A20535647456C656D656E743B5C6E2020202A2020207D5C6E2020202A207D207D5C';
wwv_flow_imp.g_varchar2_table(4423) := '6E2020202A2F5C6E2020746869732E5F656C656D656E7473203D207B7D3B5C6E5C6E2020746869732E5F6576656E74427573203D206576656E744275733B5C6E7D5C6E5C6E456C656D656E7452656769737472792E24696E6A656374203D205B20276576';
wwv_flow_imp.g_varchar2_table(4424) := '656E7442757327205D3B5C6E5C6E2F2A2A5C6E202A2041646420616E20656C656D656E7420616E64206974732067726170686963616C20726570726573656E746174696F6E28732920746F207468652072656769737472792E5C6E202A5C6E202A204070';
wwv_flow_imp.g_varchar2_table(4425) := '6172616D207B456C656D656E744C696B657D20656C656D656E742054686520656C656D656E7420746F2062652061646465642E5C6E202A2040706172616D207B535647456C656D656E747D2067667820546865207072696D617279206772617068696361';
wwv_flow_imp.g_varchar2_table(4426) := '6C20726570726573656E746174696F6E2E5C6E202A2040706172616D207B535647456C656D656E747D205B7365636F6E646172794766785D20546865207365636F6E646172792067726170686963616C20726570726573656E746174696F6E2E5C6E202A';
wwv_flow_imp.g_varchar2_table(4427) := '2F5C6E456C656D656E7452656769737472792E70726F746F747970652E616464203D2066756E6374696F6E28656C656D656E742C206766782C207365636F6E6461727947667829207B5C6E5C6E2020766172206964203D20656C656D656E742E69643B5C';
wwv_flow_imp.g_varchar2_table(4428) := '6E5C6E2020746869732E5F76616C69646174654964286964293B5C6E5C6E20202F2F206173736F636961746520646F6D206E6F6465207769746820656C656D656E745C6E202073766741747472286766782C20454C454D454E545F49442C206964293B5C';
wwv_flow_imp.g_varchar2_table(4429) := '6E5C6E2020696620287365636F6E6461727947667829207B5C6E2020202073766741747472287365636F6E646172794766782C20454C454D454E545F49442C206964293B5C6E20207D5C6E5C6E2020746869732E5F656C656D656E74735B69645D203D20';
wwv_flow_imp.g_varchar2_table(4430) := '7B20656C656D656E743A20656C656D656E742C206766783A206766782C207365636F6E646172794766783A207365636F6E64617279476678207D3B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052656D6F766520616E20656C656D656E742066726F6D207468';
wwv_flow_imp.g_varchar2_table(4431) := '652072656769737472792E5C6E202A5C6E202A2040706172616D207B456C656D656E744C696B657C737472696E677D20656C656D656E745C6E202A2F5C6E456C656D656E7452656769737472792E70726F746F747970652E72656D6F7665203D2066756E';
wwv_flow_imp.g_varchar2_table(4432) := '6374696F6E28656C656D656E7429207B5C6E202076617220656C656D656E7473203D20746869732E5F656C656D656E74732C5C6E2020202020206964203D20656C656D656E742E6964207C7C20656C656D656E742C5C6E202020202020636F6E7461696E';
wwv_flow_imp.g_varchar2_table(4433) := '6572203D20696420262620656C656D656E74735B69645D3B5C6E5C6E202069662028636F6E7461696E657229207B5C6E5C6E202020202F2F20756E73657420656C656D656E74206964206F6E206766785C6E202020207376674174747228636F6E746169';
wwv_flow_imp.g_varchar2_table(4434) := '6E65722E6766782C20454C454D454E545F49442C202727293B5C6E5C6E2020202069662028636F6E7461696E65722E7365636F6E6461727947667829207B5C6E2020202020207376674174747228636F6E7461696E65722E7365636F6E64617279476678';
wwv_flow_imp.g_varchar2_table(4435) := '2C20454C454D454E545F49442C202727293B5C6E202020207D5C6E5C6E2020202064656C65746520656C656D656E74735B69645D3B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A2055706461746520616E20656C656D656E74732049442E5C6E202A';
wwv_flow_imp.g_varchar2_table(4436) := '5C6E202A2040706172616D207B456C656D656E744C696B657C737472696E677D20656C656D656E742054686520656C656D656E74206F72206974732049442E5C6E202A2040706172616D207B737472696E677D206E6577496420546865206E6577204944';
wwv_flow_imp.g_varchar2_table(4437) := '2E5C6E202A2F5C6E456C656D656E7452656769737472792E70726F746F747970652E7570646174654964203D2066756E6374696F6E28656C656D656E742C206E6577496429207B5C6E5C6E2020746869732E5F76616C69646174654964286E6577496429';
wwv_flow_imp.g_varchar2_table(4438) := '3B5C6E5C6E202069662028747970656F6620656C656D656E74203D3D3D2027737472696E672729207B5C6E20202020656C656D656E74203D20746869732E67657428656C656D656E74293B5C6E20207D5C6E5C6E2020746869732E5F6576656E74427573';
wwv_flow_imp.g_varchar2_table(4439) := '2E666972652827656C656D656E742E7570646174654964272C207B5C6E20202020656C656D656E743A20656C656D656E742C5C6E202020206E657749643A206E657749645C6E20207D293B5C6E5C6E202076617220676678203D20746869732E67657447';
wwv_flow_imp.g_varchar2_table(4440) := '7261706869637328656C656D656E74292C5C6E2020202020207365636F6E64617279476678203D20746869732E676574477261706869637328656C656D656E742C2074727565293B5C6E5C6E2020746869732E72656D6F766528656C656D656E74293B5C';
wwv_flow_imp.g_varchar2_table(4441) := '6E5C6E2020656C656D656E742E6964203D206E657749643B5C6E5C6E2020746869732E61646428656C656D656E742C206766782C207365636F6E64617279476678293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A205570646174652074686520677261706869';
wwv_flow_imp.g_varchar2_table(4442) := '63616C20726570726573656E746174696F6E206F6620616E20656C656D656E742E5C6E202A5C6E202A2040706172616D207B456C656D656E744C696B657C737472696E677D2066696C7465722054686520656C656D656E74206F72206974732049442E5C';
wwv_flow_imp.g_varchar2_table(4443) := '6E202A2040706172616D207B535647456C656D656E747D2067667820546865206E65772067726170686963616C20726570726573656E746174696F6E2E5C6E202A2040706172616D207B626F6F6C65616E7D205B7365636F6E646172793D66616C73655D';
wwv_flow_imp.g_varchar2_table(4444) := '205768657468657220746F2075706461746520746865207365636F6E646172792067726170686963616C20726570726573656E746174696F6E2E5C6E202A2F5C6E456C656D656E7452656769737472792E70726F746F747970652E757064617465477261';
wwv_flow_imp.g_varchar2_table(4445) := '7068696373203D2066756E6374696F6E2866696C7465722C206766782C207365636F6E6461727929207B5C6E2020766172206964203D2066696C7465722E6964207C7C2066696C7465723B5C6E5C6E202076617220636F6E7461696E6572203D20746869';
wwv_flow_imp.g_varchar2_table(4446) := '732E5F656C656D656E74735B69645D3B5C6E5C6E2020696620287365636F6E6461727929207B5C6E20202020636F6E7461696E65722E7365636F6E64617279476678203D206766783B5C6E20207D20656C7365207B5C6E20202020636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(4447) := '2E676678203D206766783B5C6E20207D5C6E5C6E20206966202867667829207B5C6E2020202073766741747472286766782C20454C454D454E545F49442C206964293B5C6E20207D5C6E5C6E202072657475726E206766783B5C6E7D3B5C6E5C6E2F2A2A';
wwv_flow_imp.g_varchar2_table(4448) := '5C6E202A204765742074686520656C656D656E7420776974682074686520676976656E204944206F722067726170686963616C20726570726573656E746174696F6E2E5C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206060606A617661';
wwv_flow_imp.g_varchar2_table(4449) := '7363726970745C6E202A20656C656D656E7452656769737472792E6765742827536F6D65456C656D656E7449645F3127293B5C6E202A5C6E202A20656C656D656E7452656769737472792E67657428676678293B5C6E202A206060605C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(4450) := '2040706172616D207B737472696E677C535647456C656D656E747D2066696C7465722054686520656C656D656E7473204944206F722067726170686963616C20726570726573656E746174696F6E2E5C6E202A5C6E202A204072657475726E207B456C65';
wwv_flow_imp.g_varchar2_table(4451) := '6D656E744C696B657C756E646566696E65647D2054686520656C656D656E742E5C6E202A2F5C6E456C656D656E7452656769737472792E70726F746F747970652E676574203D2066756E6374696F6E2866696C74657229207B5C6E20207661722069643B';
wwv_flow_imp.g_varchar2_table(4452) := '5C6E5C6E202069662028747970656F662066696C746572203D3D3D2027737472696E672729207B5C6E202020206964203D2066696C7465723B5C6E20207D20656C7365207B5C6E202020206964203D2066696C7465722026262073766741747472286669';
wwv_flow_imp.g_varchar2_table(4453) := '6C7465722C20454C454D454E545F4944293B5C6E20207D5C6E5C6E202076617220636F6E7461696E6572203D20746869732E5F656C656D656E74735B69645D3B5C6E202072657475726E20636F6E7461696E657220262620636F6E7461696E65722E656C';
wwv_flow_imp.g_varchar2_table(4454) := '656D656E743B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E20616C6C20656C656D656E74732074686174206D61746368206120676976656E2066696C7465722066756E6374696F6E2E5C6E202A5C6E202A2040706172616D207B456C656D656E';
wwv_flow_imp.g_varchar2_table(4455) := '74526567697374727946696C74657243616C6C6261636B7D20666E205468652066696C7465722066756E6374696F6E2E5C6E202A5C6E202A204072657475726E207B456C656D656E744C696B655B5D7D20546865206D61746368696E6720656C656D656E';
wwv_flow_imp.g_varchar2_table(4456) := '74732E5C6E202A2F5C6E456C656D656E7452656769737472792E70726F746F747970652E66696C746572203D2066756E6374696F6E28666E29207B5C6E5C6E20207661722066696C7465726564203D205B5D3B5C6E5C6E2020746869732E666F72456163';
wwv_flow_imp.g_varchar2_table(4457) := '682866756E6374696F6E28656C656D656E742C2067667829207B5C6E2020202069662028666E28656C656D656E742C206766782929207B5C6E20202020202066696C74657265642E7075736828656C656D656E74293B5C6E202020207D5C6E20207D293B';
wwv_flow_imp.g_varchar2_table(4458) := '5C6E5C6E202072657475726E2066696C74657265643B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E2074686520666972737420656C656D656E742074686174206D6174636865732074686520676976656E2066696C7465722066756E6374696F';
wwv_flow_imp.g_varchar2_table(4459) := '6E2E5C6E202A5C6E202A2040706172616D207B456C656D656E74526567697374727946696C74657243616C6C6261636B7D20666E205468652066696C7465722066756E6374696F6E2E5C6E202A5C6E202A204072657475726E207B456C656D656E744C69';
wwv_flow_imp.g_varchar2_table(4460) := '6B657C756E646566696E65647D20546865206D61746368696E6720656C656D656E742E5C6E202A2F5C6E456C656D656E7452656769737472792E70726F746F747970652E66696E64203D2066756E6374696F6E28666E29207B5C6E2020766172206D6170';
wwv_flow_imp.g_varchar2_table(4461) := '203D20746869732E5F656C656D656E74732C5C6E2020202020206B657973203D204F626A6563742E6B657973286D6170293B5C6E5C6E2020666F7220287661722069203D20303B2069203C206B6579732E6C656E6774683B20692B2B29207B5C6E202020';
wwv_flow_imp.g_varchar2_table(4462) := '20766172206964203D206B6579735B695D2C5C6E2020202020202020636F6E7461696E6572203D206D61705B69645D2C5C6E2020202020202020656C656D656E74203D20636F6E7461696E65722E656C656D656E742C5C6E202020202020202067667820';
wwv_flow_imp.g_varchar2_table(4463) := '3D20636F6E7461696E65722E6766783B5C6E5C6E2020202069662028666E28656C656D656E742C206766782929207B5C6E20202020202072657475726E20656C656D656E743B5C6E202020207D5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A204765';
wwv_flow_imp.g_varchar2_table(4464) := '7420616C6C20656C656D656E74732E5C6E202A5C6E202A204072657475726E207B456C656D656E744C696B655B5D7D20416C6C20656C656D656E74732E5C6E202A2F5C6E456C656D656E7452656769737472792E70726F746F747970652E676574416C6C';
wwv_flow_imp.g_varchar2_table(4465) := '203D2066756E6374696F6E2829207B5C6E202072657475726E20746869732E66696C7465722866756E6374696F6E286529207B2072657475726E20653B207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2045786563757465206120676976656E2066756E';
wwv_flow_imp.g_varchar2_table(4466) := '6374696F6E20666F72206561636820656C656D656E742E5C6E202A5C6E202A2040706172616D207B456C656D656E745265676973747279466F724561636843616C6C6261636B7D20666E205468652066756E6374696F6E20746F20657865637574652E5C';
wwv_flow_imp.g_varchar2_table(4467) := '6E202A2F5C6E456C656D656E7452656769737472792E70726F746F747970652E666F7245616368203D2066756E6374696F6E28666E29207B5C6E5C6E2020766172206D6170203D20746869732E5F656C656D656E74733B5C6E5C6E20204F626A6563742E';
wwv_flow_imp.g_varchar2_table(4468) := '6B657973286D6170292E666F72456163682866756E6374696F6E28696429207B5C6E2020202076617220636F6E7461696E6572203D206D61705B69645D2C5C6E2020202020202020656C656D656E74203D20636F6E7461696E65722E656C656D656E742C';
wwv_flow_imp.g_varchar2_table(4469) := '5C6E2020202020202020676678203D20636F6E7461696E65722E6766783B5C6E5C6E2020202072657475726E20666E28656C656D656E742C20676678293B5C6E20207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E207468652067726170';
wwv_flow_imp.g_varchar2_table(4470) := '686963616C20726570726573656E746174696F6E206F6620616E20656C656D656E742E5C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206060606A6176617363726970745C6E202A20656C656D656E7452656769737472792E6765744772';
wwv_flow_imp.g_varchar2_table(4471) := '6170686963732827536F6D65456C656D656E7449645F3127293B5C6E202A5C6E202A20656C656D656E7452656769737472792E676574477261706869637328726F6F74456C656D656E74293B202F2F203C67202E2E2E3E5C6E202A5C6E202A20656C656D';
wwv_flow_imp.g_varchar2_table(4472) := '656E7452656769737472792E676574477261706869637328726F6F74456C656D656E742C2074727565293B202F2F203C737667202E2E2E3E5C6E202A206060605C6E202A5C6E202A2040706172616D207B456C656D656E744C696B657C737472696E677D';
wwv_flow_imp.g_varchar2_table(4473) := '2066696C7465722054686520656C656D656E74206F72206974732049442E5C6E202A2040706172616D207B626F6F6C65616E7D205B7365636F6E646172793D66616C73655D205768657468657220746F2072657475726E20746865207365636F6E646172';
wwv_flow_imp.g_varchar2_table(4474) := '792067726170686963616C20726570726573656E746174696F6E2E5C6E202A5C6E202A204072657475726E207B535647456C656D656E747D205468652067726170686963616C20726570726573656E746174696F6E2E5C6E202A2F5C6E456C656D656E74';
wwv_flow_imp.g_varchar2_table(4475) := '52656769737472792E70726F746F747970652E6765744772617068696373203D2066756E6374696F6E2866696C7465722C207365636F6E6461727929207B5C6E2020766172206964203D2066696C7465722E6964207C7C2066696C7465723B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(4476) := '2076617220636F6E7461696E6572203D20746869732E5F656C656D656E74735B69645D3B5C6E202072657475726E20636F6E7461696E657220262620287365636F6E64617279203F20636F6E7461696E65722E7365636F6E64617279476678203A20636F';
wwv_flow_imp.g_varchar2_table(4477) := '6E7461696E65722E676678293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2056616C696461746520616E20494420616E64207468726F7720616E206572726F7220696620696E76616C69642E5C6E202A5C6E202A2040706172616D207B737472696E677D2069';
wwv_flow_imp.g_varchar2_table(4478) := '645C6E202A5C6E202A20407468726F7773207B4572726F727D204572726F7220696E6469636174696E6720746861742074686520494420697320696E76616C6964206F7220616C72656164792061737369676E65642E5C6E202A2F5C6E456C656D656E74';
wwv_flow_imp.g_varchar2_table(4479) := '52656769737472792E70726F746F747970652E5F76616C69646174654964203D2066756E6374696F6E28696429207B5C6E20206966202821696429207B5C6E202020207468726F77206E6577204572726F722827656C656D656E74206D75737420686176';
wwv_flow_imp.g_varchar2_table(4480) := '6520616E20696427293B5C6E20207D5C6E5C6E202069662028746869732E5F656C656D656E74735B69645D29207B5C6E202020207468726F77206E6577204572726F722827656C656D656E7420776974682069642027202B206964202B202720616C7265';
wwv_flow_imp.g_varchar2_table(4481) := '61647920616464656427293B5C6E20207D5C6E7D3B5C6E222C22696D706F7274207B5C6E2020697346756E6374696F6E2C5C6E2020697341727261792C5C6E202069734E756D6265722C5C6E202062696E642C5C6E202061737369676E5C6E7D2066726F';
wwv_flow_imp.g_varchar2_table(4482) := '6D20276D696E2D64617368273B5C6E5C6E76617220464E5F524546203D20275F5F666E273B5C6E5C6E7661722044454641554C545F5052494F52495459203D20313030303B5C6E5C6E76617220736C696365203D2041727261792E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(4483) := '2E736C6963653B5C6E5C6E2F2A2A5C6E202A204074797065646566207B207B5C6E202A20202073746F7050726F7061676174696F6E28293A20766F69643B5C6E202A20202070726576656E7444656661756C7428293A20766F69643B5C6E202A20202063';
wwv_flow_imp.g_varchar2_table(4484) := '616E63656C427562626C653A20626F6F6C65616E3B5C6E202A20202064656661756C7450726576656E7465643A20626F6F6C65616E3B5C6E202A20202072657475726E56616C75653A20616E793B5C6E202A207D207D204576656E745C6E202A2F5C6E5C';
wwv_flow_imp.g_varchar2_table(4485) := '6E2F2A2A5C6E202A204074656D706C61746520455C6E202A5C6E202A204074797065646566207B20286576656E743A20452026204576656E742C202E2E2E616E7929203D3E20616E79207D204576656E744275734576656E7443616C6C6261636B5C6E20';
wwv_flow_imp.g_varchar2_table(4486) := '2A2F5C6E5C6E2F2A2A5C6E202A204074797065646566207B207B5C6E202A20207072696F726974793A206E756D6265723B5C6E202A20206E6578743A204576656E744275734C697374656E6572207C206E756C6C3B5C6E202A202063616C6C6261636B3A';
wwv_flow_imp.g_varchar2_table(4487) := '204576656E744275734576656E7443616C6C6261636B3C616E793E3B5C6E202A207D207D204576656E744275734C697374656E65725C6E202A2F5C6E5C6E2F2A2A5C6E202A20412067656E6572616C20707572706F7365206576656E74206275732E5C6E';
wwv_flow_imp.g_varchar2_table(4488) := '202A5C6E202A205468697320636F6D706F6E656E74206973207573656420746F20636F6D6D756E6963617465206163726F73732061206469616772616D20696E7374616E63652E5C6E202A204F74686572207061727473206F662061206469616772616D';
wwv_flow_imp.g_varchar2_table(4489) := '2063616E2075736520697420746F206C697374656E20746F20616E642062726F616463617374206576656E74732E5C6E202A5C6E202A5C6E202A202323205265676973746572696E6720666F72204576656E74735C6E202A5C6E202A2054686520657665';
wwv_flow_imp.g_varchar2_table(4490) := '6E74206275732070726F766964657320746865207B406C696E6B204576656E74427573236F6E7D20616E64207B406C696E6B204576656E74427573236F6E63657D5C6E202A206D6574686F647320746F20726567697374657220666F72206576656E7473';
wwv_flow_imp.g_varchar2_table(4491) := '2E207B406C696E6B204576656E74427573236F66667D2063616E206265207573656420746F5C6E202A2072656D6F7665206576656E7420726567697374726174696F6E732E204C697374656E657273207265636569766520616E20696E7374616E636520';
wwv_flow_imp.g_varchar2_table(4492) := '6F66207B406C696E6B204576656E747D5C6E202A2061732074686520666972737420617267756D656E742E20497420616C6C6F7773207468656D20746F20686F6F6B20696E746F20746865206576656E7420657865637574696F6E2E5C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(4493) := '206060606A6176617363726970745C6E202A5C6E202A202F2F206C697374656E20666F72206576656E745C6E202A206576656E744275732E6F6E2827666F6F272C2066756E6374696F6E286576656E7429207B5C6E202A5C6E202A2020202F2F20616363';
wwv_flow_imp.g_varchar2_table(4494) := '657373206576656E7420747970655C6E202A2020206576656E742E747970653B202F2F2027666F6F275C6E202A5C6E202A2020202F2F2073746F702070726F7061676174696F6E20746F206F74686572206C697374656E6572735C6E202A202020657665';
wwv_flow_imp.g_varchar2_table(4495) := '6E742E73746F7050726F7061676174696F6E28293B5C6E202A5C6E202A2020202F2F2070726576656E74206576656E742064656661756C745C6E202A2020206576656E742E70726576656E7444656661756C7428293B5C6E202A207D293B5C6E202A5C6E';
wwv_flow_imp.g_varchar2_table(4496) := '202A202F2F206C697374656E20666F72206576656E74207769746820637573746F6D207061796C6F61645C6E202A206576656E744275732E6F6E2827626172272C2066756E6374696F6E286576656E742C207061796C6F616429207B5C6E202A20202063';
wwv_flow_imp.g_varchar2_table(4497) := '6F6E736F6C652E6C6F67287061796C6F6164293B5C6E202A207D293B5C6E202A5C6E202A202F2F206C697374656E20666F72206576656E742072657475726E696E672076616C75655C6E202A206576656E744275732E6F6E2827666F6F626172272C2066';
wwv_flow_imp.g_varchar2_table(4498) := '756E6374696F6E286576656E7429207B5C6E202A5C6E202A2020202F2F2073746F70206576656E742070726F7061676174696F6E202B2070726576656E742064656661756C745C6E202A20202072657475726E2066616C73653B5C6E202A5C6E202A2020';
wwv_flow_imp.g_varchar2_table(4499) := '202F2F2073746F70206576656E742070726F7061676174696F6E202B2072657475726E20637573746F6D20726573756C745C6E202A20202072657475726E207B5C6E202A2020202020636F6D706C65783A20276C697374656E696E6720726573756C7427';
wwv_flow_imp.g_varchar2_table(4500) := '5C6E202A2020207D3B5C6E202A207D293B5C6E202A5C6E202A5C6E202A202F2F206C697374656E207769746820637573746F6D207072696F72697479202864656661756C743D313030302C2068696768657220697320626574746572295C6E202A206576';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(4501) := '656E744275732E6F6E28277072696F72697479666F6F272C20313530302C2066756E6374696F6E286576656E7429207B5C6E202A202020636F6E736F6C652E6C6F672827696E766F6B65642066697273742127293B5C6E202A207D293B5C6E202A5C6E20';
wwv_flow_imp.g_varchar2_table(4502) := '2A5C6E202A202F2F206C697374656E20666F72206576656E7420616E6420706173732074686520636F6E746578742028607468697360295C6E202A206576656E744275732E6F6E2827666F6F626172272C2066756E6374696F6E286576656E7429207B5C';
wwv_flow_imp.g_varchar2_table(4503) := '6E202A202020746869732E666F6F28293B5C6E202A207D2C2074686973293B5C6E202A206060605C6E202A5C6E202A5C6E202A20232320456D697474696E67204576656E74735C6E202A5C6E202A204576656E74732063616E20626520656D6974746564';
wwv_flow_imp.g_varchar2_table(4504) := '2076696120746865206576656E7420627573207573696E67207B406C696E6B204576656E7442757323666972657D2E5C6E202A5C6E202A206060606A6176617363726970745C6E202A5C6E202A202F2F2066616C736520696E6469636174657320746861';
wwv_flow_imp.g_varchar2_table(4505) := '74207468652064656661756C7420616374696F6E5C6E202A202F2F207761732070726576656E746564206279206C697374656E6572735C6E202A20696620286576656E744275732E666972652827666F6F2729203D3D3D2066616C736529207B5C6E202A';
wwv_flow_imp.g_varchar2_table(4506) := '202020636F6E736F6C652E6C6F67282764656661756C7420686173206265656E2070726576656E7465642127293B5C6E202A207D3B5C6E202A5C6E202A5C6E202A202F2F20637573746F6D2061726773202B2072657475726E2076616C7565206C697374';
wwv_flow_imp.g_varchar2_table(4507) := '656E65725C6E202A206576656E744275732E6F6E282773756D272C2066756E6374696F6E286576656E742C20612C206229207B5C6E202A20202072657475726E2061202B20623B5C6E202A207D293B5C6E202A5C6E202A202F2F20796F752063616E2070';
wwv_flow_imp.g_varchar2_table(4508) := '61737320637573746F6D20617267756D656E7473202B20726574726965766520726573756C742076616C7565732E5C6E202A207661722073756D203D206576656E744275732E66697265282773756D272C20312C2032293B5C6E202A20636F6E736F6C65';
wwv_flow_imp.g_varchar2_table(4509) := '2E6C6F672873756D293B202F2F20335C6E202A206060605C6E202A5C6E202A204074656D706C617465205B4576656E744D61703D6E756C6C5D5C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E204576656E744275732829207B';
wwv_flow_imp.g_varchar2_table(4510) := '5C6E5C6E20202F2A2A5C6E2020202A204074797065207B205265636F72643C737472696E672C204576656E744275734C697374656E65723E207D5C6E2020202A2F5C6E2020746869732E5F6C697374656E657273203D207B7D3B5C6E5C6E20202F2F2063';
wwv_flow_imp.g_varchar2_table(4511) := '6C65616E7570206F6E2064657374726F79206F6E206C6F77657374207072696F7269747920746F20616C6C6F775C6E20202F2F206D6573736167652070617373696E6720756E74696C207468652062697474657220656E645C6E2020746869732E6F6E28';
wwv_flow_imp.g_varchar2_table(4512) := '276469616772616D2E64657374726F79272C20312C20746869732E5F64657374726F792C2074686973293B5C6E7D5C6E5C6E2F2A2A5C6E202A20406F7665726C6F72645C6E202A5C6E202A20526567697374657220616E206576656E74206C697374656E';
wwv_flow_imp.g_varchar2_table(4513) := '657220666F72206576656E747320776974682074686520676976656E206E616D652E5C6E202A5C6E202A205468652063616C6C6261636B2077696C6C20626520696E766F6B6564207769746820606576656E742C202E2E2E6164646974696F6E616C4172';
wwv_flow_imp.g_varchar2_table(4514) := '67756D656E7473605C6E202A20746861742068617665206265656E2070617373656420746F207B406C696E6B204576656E7442757323666972657D2E5C6E202A5C6E202A2052657475726E696E672066616C73652066726F6D2061206C697374656E6572';
wwv_flow_imp.g_varchar2_table(4515) := '2077696C6C2070726576656E7420746865206576656E74732064656661756C7420616374696F6E5C6E202A2028696620616E7920697320737065636966696564292E20546F2073746F7020616E206576656E742066726F6D206265696E672070726F6365';
wwv_flow_imp.g_varchar2_table(4516) := '73736564206675727468657220696E5C6E202A206F74686572206C697374656E6572732065786563757465207B406C696E6B204576656E742373746F7050726F7061676174696F6E7D2E5C6E202A5C6E202A2052657475726E696E6720616E797468696E';
wwv_flow_imp.g_varchar2_table(4517) := '67206275742060756E646566696E6564602066726F6D2061206C697374656E65722077696C6C2073746F7020746865206C697374656E65722070726F7061676174696F6E2E5C6E202A5C6E202A204074656D706C61746520545C6E202A5C6E202A204070';
wwv_flow_imp.g_varchar2_table(4518) := '6172616D207B737472696E677C737472696E675B5D7D206576656E747320746F2073756273637269626520746F5C6E202A2040706172616D207B6E756D6265727D205B7072696F726974793D313030305D206C697374656E207072696F726974795C6E20';
wwv_flow_imp.g_varchar2_table(4519) := '2A2040706172616D207B4576656E744275734576656E7443616C6C6261636B3C543E7D2063616C6C6261636B5C6E202A2040706172616D207B616E797D205B746861745D2063616C6C6261636B20636F6E746578745C6E202A2F5C6E2F2A2A5C6E202A20';
wwv_flow_imp.g_varchar2_table(4520) := '526567697374657220616E206576656E74206C697374656E657220666F72206576656E747320776974682074686520676976656E206E616D652E5C6E202A5C6E202A205468652063616C6C6261636B2077696C6C20626520696E766F6B65642077697468';
wwv_flow_imp.g_varchar2_table(4521) := '20606576656E742C202E2E2E6164646974696F6E616C417267756D656E7473605C6E202A20746861742068617665206265656E2070617373656420746F207B406C696E6B204576656E7442757323666972657D2E5C6E202A5C6E202A2052657475726E69';
wwv_flow_imp.g_varchar2_table(4522) := '6E672066616C73652066726F6D2061206C697374656E65722077696C6C2070726576656E7420746865206576656E74732064656661756C7420616374696F6E5C6E202A2028696620616E7920697320737065636966696564292E20546F2073746F702061';
wwv_flow_imp.g_varchar2_table(4523) := '6E206576656E742066726F6D206265696E672070726F636573736564206675727468657220696E5C6E202A206F74686572206C697374656E6572732065786563757465207B406C696E6B204576656E742373746F7050726F7061676174696F6E7D2E5C6E';
wwv_flow_imp.g_varchar2_table(4524) := '202A5C6E202A2052657475726E696E6720616E797468696E67206275742060756E646566696E6564602066726F6D2061206C697374656E65722077696C6C2073746F7020746865206C697374656E65722070726F7061676174696F6E2E5C6E202A5C6E20';
wwv_flow_imp.g_varchar2_table(4525) := '2A204074656D706C617465207B6B65796F66204576656E744D61707D204576656E744E616D655C6E202A5C6E202A2040706172616D207B4576656E744E616D657D206576656E747320746F2073756273637269626520746F5C6E202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(4526) := '7B6E756D6265727D205B7072696F726974793D313030305D206C697374656E207072696F726974795C6E202A2040706172616D207B4576656E744275734576656E7443616C6C6261636B3C4576656E744D61705B4576656E744E616D655D3E7D2063616C';
wwv_flow_imp.g_varchar2_table(4527) := '6C6261636B5C6E202A2040706172616D207B616E797D205B746861745D2063616C6C6261636B20636F6E746578745C6E202A2F5C6E4576656E744275732E70726F746F747970652E6F6E203D2066756E6374696F6E286576656E74732C207072696F7269';
wwv_flow_imp.g_varchar2_table(4528) := '74792C2063616C6C6261636B2C207468617429207B5C6E5C6E20206576656E7473203D2069734172726179286576656E747329203F206576656E7473203A205B206576656E7473205D3B5C6E5C6E202069662028697346756E6374696F6E287072696F72';
wwv_flow_imp.g_varchar2_table(4529) := '6974792929207B5C6E2020202074686174203D2063616C6C6261636B3B5C6E2020202063616C6C6261636B203D207072696F726974793B5C6E202020207072696F72697479203D2044454641554C545F5052494F524954593B5C6E20207D5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(4530) := '696620282169734E756D626572287072696F726974792929207B5C6E202020207468726F77206E6577204572726F7228277072696F72697479206D7573742062652061206E756D62657227293B5C6E20207D5C6E5C6E20207661722061637475616C4361';
wwv_flow_imp.g_varchar2_table(4531) := '6C6C6261636B203D2063616C6C6261636B3B5C6E5C6E2020696620287468617429207B5C6E2020202061637475616C43616C6C6261636B203D2062696E642863616C6C6261636B2C2074686174293B5C6E5C6E202020202F2F206D616B65207375726520';
wwv_flow_imp.g_varchar2_table(4532) := '77652072656D656D62657220616E64206172652061626C6520746F2072656D6F76655C6E202020202F2F20626F756E642063616C6C6261636B7320766961207B406C696E6B20236F66667D207573696E6720746865206F726967696E616C5C6E20202020';
wwv_flow_imp.g_varchar2_table(4533) := '2F2F2063616C6C6261636B5C6E2020202061637475616C43616C6C6261636B5B464E5F5245465D203D2063616C6C6261636B5B464E5F5245465D207C7C2063616C6C6261636B3B5C6E20207D5C6E5C6E20207661722073656C66203D20746869733B5C6E';
wwv_flow_imp.g_varchar2_table(4534) := '5C6E20206576656E74732E666F72456163682866756E6374696F6E286529207B5C6E2020202073656C662E5F6164644C697374656E657228652C207B5C6E2020202020207072696F726974793A207072696F726974792C5C6E20202020202063616C6C62';
wwv_flow_imp.g_varchar2_table(4535) := '61636B3A2061637475616C43616C6C6261636B2C5C6E2020202020206E6578743A206E756C6C5C6E202020207D293B5C6E20207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20406F7665726C6F72645C6E202A5C6E202A20526567697374657220616E20';
wwv_flow_imp.g_varchar2_table(4536) := '6576656E74206C697374656E657220746861742069732063616C6C6564206F6E6C79206F6E63652E5C6E202A5C6E202A204074656D706C61746520545C6E202A5C6E202A2040706172616D207B737472696E677C737472696E675B5D7D206576656E7473';
wwv_flow_imp.g_varchar2_table(4537) := '20746F2073756273637269626520746F5C6E202A2040706172616D207B6E756D6265727D205B7072696F726974793D313030305D20746865206C697374656E207072696F726974795C6E202A2040706172616D207B4576656E744275734576656E744361';
wwv_flow_imp.g_varchar2_table(4538) := '6C6C6261636B3C543E7D2063616C6C6261636B5C6E202A2040706172616D207B616E797D205B746861745D2063616C6C6261636B20636F6E746578745C6E202A2F5C6E2F2A2A5C6E202A20526567697374657220616E206576656E74206C697374656E65';
wwv_flow_imp.g_varchar2_table(4539) := '7220746861742069732063616C6C6564206F6E6C79206F6E63652E5C6E202A5C6E202A204074656D706C617465207B6B65796F66204576656E744D61707D204576656E744E616D655C6E202A5C6E202A2040706172616D207B4576656E744E616D657D20';
wwv_flow_imp.g_varchar2_table(4540) := '6576656E747320746F2073756273637269626520746F5C6E202A2040706172616D207B6E756D6265727D205B7072696F726974793D313030305D206C697374656E207072696F726974795C6E202A2040706172616D207B4576656E744275734576656E74';
wwv_flow_imp.g_varchar2_table(4541) := '43616C6C6261636B3C4576656E744D61705B4576656E744E616D655D3E7D2063616C6C6261636B5C6E202A2040706172616D207B616E797D205B746861745D2063616C6C6261636B20636F6E746578745C6E202A2F5C6E4576656E744275732E70726F74';
wwv_flow_imp.g_varchar2_table(4542) := '6F747970652E6F6E6365203D2066756E6374696F6E286576656E74732C207072696F726974792C2063616C6C6261636B2C207468617429207B5C6E20207661722073656C66203D20746869733B5C6E5C6E202069662028697346756E6374696F6E287072';
wwv_flow_imp.g_varchar2_table(4543) := '696F726974792929207B5C6E2020202074686174203D2063616C6C6261636B3B5C6E2020202063616C6C6261636B203D207072696F726974793B5C6E202020207072696F72697479203D2044454641554C545F5052494F524954593B5C6E20207D5C6E5C';
wwv_flow_imp.g_varchar2_table(4544) := '6E2020696620282169734E756D626572287072696F726974792929207B5C6E202020207468726F77206E6577204572726F7228277072696F72697479206D7573742062652061206E756D62657227293B5C6E20207D5C6E5C6E202066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(4545) := '7772617070656443616C6C6261636B2829207B5C6E202020207772617070656443616C6C6261636B2E5F5F6973546F6D62203D20747275653B5C6E5C6E2020202076617220726573756C74203D2063616C6C6261636B2E6170706C7928746861742C2061';
wwv_flow_imp.g_varchar2_table(4546) := '7267756D656E7473293B5C6E5C6E2020202073656C662E6F6666286576656E74732C207772617070656443616C6C6261636B293B5C6E5C6E2020202072657475726E20726573756C743B5C6E20207D5C6E5C6E20202F2F206D616B652073757265207765';
wwv_flow_imp.g_varchar2_table(4547) := '2072656D656D62657220616E64206172652061626C6520746F2072656D6F76655C6E20202F2F20626F756E642063616C6C6261636B7320766961207B406C696E6B20236F66667D207573696E6720746865206F726967696E616C5C6E20202F2F2063616C';
wwv_flow_imp.g_varchar2_table(4548) := '6C6261636B5C6E20207772617070656443616C6C6261636B5B464E5F5245465D203D2063616C6C6261636B3B5C6E5C6E2020746869732E6F6E286576656E74732C207072696F726974792C207772617070656443616C6C6261636B293B5C6E7D3B5C6E5C';
wwv_flow_imp.g_varchar2_table(4549) := '6E5C6E2F2A2A5C6E202A2052656D6F766573206576656E74206C697374656E657273206279206576656E7420616E642063616C6C6261636B2E5C6E202A5C6E202A204966206E6F2063616C6C6261636B20697320676976656E2C20616C6C206C69737465';
wwv_flow_imp.g_varchar2_table(4550) := '6E65727320666F72206120676976656E206576656E74206E616D6520617265206265696E672072656D6F7665642E5C6E202A5C6E202A2040706172616D207B737472696E677C737472696E675B5D7D206576656E74735C6E202A2040706172616D207B45';
wwv_flow_imp.g_varchar2_table(4551) := '76656E744275734576656E7443616C6C6261636B7D205B63616C6C6261636B5D5C6E202A2F5C6E4576656E744275732E70726F746F747970652E6F6666203D2066756E6374696F6E286576656E74732C2063616C6C6261636B29207B5C6E5C6E20206576';
wwv_flow_imp.g_varchar2_table(4552) := '656E7473203D2069734172726179286576656E747329203F206576656E7473203A205B206576656E7473205D3B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E20206576656E74732E666F72456163682866756E6374696F6E28657665';
wwv_flow_imp.g_varchar2_table(4553) := '6E7429207B5C6E2020202073656C662E5F72656D6F76654C697374656E6572286576656E742C2063616C6C6261636B293B5C6E20207D293B5C6E5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2043726561746520616E206576656E74207265636F676E697A';
wwv_flow_imp.g_varchar2_table(4554) := '656420626520746865206576656E74206275732E5C6E202A5C6E202A2040706172616D207B4F626A6563747D2064617461204576656E7420646174612E5C6E202A5C6E202A204072657475726E207B4576656E747D20416E206576656E74207468617420';
wwv_flow_imp.g_varchar2_table(4555) := '77696C6C206265207265636F676E697A656420627920746865206576656E74206275732E5C6E202A2F5C6E4576656E744275732E70726F746F747970652E6372656174654576656E74203D2066756E6374696F6E286461746129207B5C6E202076617220';
wwv_flow_imp.g_varchar2_table(4556) := '6576656E74203D206E657720496E7465726E616C4576656E7428293B5C6E5C6E20206576656E742E696E69742864617461293B5C6E5C6E202072657475726E206576656E743B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A20466972657320616E20657665';
wwv_flow_imp.g_varchar2_table(4557) := '6E742E5C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206060606A6176617363726970745C6E202A202F2F2066697265206576656E74206279206E616D655C6E202A206576656E74732E666972652827666F6F27293B5C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(4558) := '202F2F2066697265206576656E74206F626A6563742077697468206E657374656420747970655C6E202A20766172206576656E74203D207B20747970653A2027666F6F27207D3B5C6E202A206576656E74732E66697265286576656E74293B5C6E202A5C';
wwv_flow_imp.g_varchar2_table(4559) := '6E202A202F2F2066697265206576656E742077697468206578706C6963697420747970655C6E202A20766172206576656E74203D207B20783A2031302C20793A203230207D3B5C6E202A206576656E74732E666972652827656C656D656E742E6D6F7665';
wwv_flow_imp.g_varchar2_table(4560) := '64272C206576656E74293B5C6E202A5C6E202A202F2F2070617373206164646974696F6E616C20617267756D656E747320746F20746865206576656E745C6E202A206576656E74732E6F6E2827666F6F272C2066756E6374696F6E286576656E742C2062';
wwv_flow_imp.g_varchar2_table(4561) := '617229207B5C6E202A202020616C65727428626172293B5C6E202A207D293B5C6E202A5C6E202A206576656E74732E66697265287B20747970653A2027666F6F27207D2C20274920616D206261722127293B5C6E202A206060605C6E202A5C6E202A2040';
wwv_flow_imp.g_varchar2_table(4562) := '706172616D207B737472696E677D205B747970655D206576656E7420747970655C6E202A2040706172616D207B4F626A6563747D205B646174615D206576656E74206F72206576656E7420646174615C6E202A2040706172616D207B2E2E2E616E797D20';
wwv_flow_imp.g_varchar2_table(4563) := '5B617267735D206164646974696F6E616C20617267756D656E7473207468652063616C6C6261636B2077696C6C2062652063616C6C656420776974682E5C6E202A5C6E202A204072657475726E207B616E797D205468652072657475726E2076616C7565';
wwv_flow_imp.g_varchar2_table(4564) := '2E2057696C6C2062652073657420746F206066616C736560206966207468652064656661756C74207761732070726576656E7465642E5C6E202A2F5C6E4576656E744275732E70726F746F747970652E66697265203D2066756E6374696F6E2874797065';
wwv_flow_imp.g_varchar2_table(4565) := '2C206461746129207B5C6E2020766172206576656E742C5C6E20202020202066697273744C697374656E65722C5C6E20202020202072657475726E56616C75652C5C6E202020202020617267733B5C6E5C6E202061726773203D20736C6963652E63616C';
wwv_flow_imp.g_varchar2_table(4566) := '6C28617267756D656E7473293B5C6E5C6E202069662028747970656F662074797065203D3D3D20276F626A6563742729207B5C6E2020202064617461203D20747970653B5C6E2020202074797065203D20646174612E747970653B5C6E20207D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(4567) := '202069662028217479706529207B5C6E202020207468726F77206E6577204572726F7228276E6F206576656E7420747970652073706563696669656427293B5C6E20207D5C6E5C6E202066697273744C697374656E6572203D20746869732E5F6C697374';
wwv_flow_imp.g_varchar2_table(4568) := '656E6572735B747970655D3B5C6E5C6E2020696620282166697273744C697374656E657229207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E20202F2F207765206D616B652073757265207765206669726520696E7374616E636573206F6620';
wwv_flow_imp.g_varchar2_table(4569) := '6F757220686F6D65206D6164655C6E20202F2F206576656E747320686572652E2057652077726170207468656D206F6E6C79206F6E63652C2074686F7567685C6E2020696620286461746120696E7374616E63656F6620496E7465726E616C4576656E74';
wwv_flow_imp.g_varchar2_table(4570) := '29207B5C6E5C6E202020202F2F207765206172652066696E652C20776520616C72656164206861766520616E206576656E745C6E202020206576656E74203D20646174613B5C6E20207D20656C7365207B5C6E202020206576656E74203D20746869732E';
wwv_flow_imp.g_varchar2_table(4571) := '6372656174654576656E742864617461293B5C6E20207D5C6E5C6E20202F2F20656E73757265207765207061737320746865206576656E742061732074686520666972737420706172616D657465725C6E2020617267735B305D203D206576656E743B5C';
wwv_flow_imp.g_varchar2_table(4572) := '6E5C6E20202F2F206F726967696E616C206576656E7420747970652028696E20636173652077652064656C6567617465295C6E2020766172206F726967696E616C54797065203D206576656E742E747970653B5C6E5C6E20202F2F207570646174652065';
wwv_flow_imp.g_varchar2_table(4573) := '76656E742074797065206265666F72652064656C65676174696F6E5C6E2020696620287479706520213D3D206F726967696E616C5479706529207B5C6E202020206576656E742E74797065203D20747970653B5C6E20207D5C6E5C6E2020747279207B5C';
wwv_flow_imp.g_varchar2_table(4574) := '6E2020202072657475726E56616C7565203D20746869732E5F696E766F6B654C697374656E657273286576656E742C20617267732C2066697273744C697374656E6572293B5C6E20207D2066696E616C6C79207B5C6E5C6E202020202F2F207265736574';
wwv_flow_imp.g_varchar2_table(4575) := '206576656E7420747970652061667465722064656C65676174696F6E5C6E20202020696620287479706520213D3D206F726967696E616C5479706529207B5C6E2020202020206576656E742E74797065203D206F726967696E616C547970653B5C6E2020';
wwv_flow_imp.g_varchar2_table(4576) := '20207D5C6E20207D5C6E5C6E20202F2F20736574207468652072657475726E2076616C756520746F2066616C736520696620746865206576656E742064656661756C745C6E20202F2F20676F742070726576656E74656420616E64206E6F206F74686572';
wwv_flow_imp.g_varchar2_table(4577) := '2072657475726E2076616C7565206578697374735C6E20206966202872657475726E56616C7565203D3D3D20756E646566696E6564202626206576656E742E64656661756C7450726576656E74656429207B5C6E2020202072657475726E56616C756520';
wwv_flow_imp.g_varchar2_table(4578) := '3D2066616C73653B5C6E20207D5C6E5C6E202072657475726E2072657475726E56616C75653B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2048616E646C6520616E206572726F7220627920666972696E6720616E206576656E742E5C6E202A5C6E202A204070';
wwv_flow_imp.g_varchar2_table(4579) := '6172616D207B4572726F727D206572726F7220546865206572726F7220746F2062652068616E646C65642E5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D205768657468657220746865206572726F72207761732068616E646C65642E';
wwv_flow_imp.g_varchar2_table(4580) := '5C6E202A2F5C6E4576656E744275732E70726F746F747970652E68616E646C654572726F72203D2066756E6374696F6E286572726F7229207B5C6E202072657475726E20746869732E6669726528276572726F72272C207B206572726F723A206572726F';
wwv_flow_imp.g_varchar2_table(4581) := '72207D29203D3D3D2066616C73653B5C6E7D3B5C6E5C6E5C6E4576656E744275732E70726F746F747970652E5F64657374726F79203D2066756E6374696F6E2829207B5C6E2020746869732E5F6C697374656E657273203D207B7D3B5C6E7D3B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(4582) := '2F2A2A5C6E202A2040706172616D207B4576656E747D206576656E745C6E202A2040706172616D207B616E795B5D7D20617267735C6E202A2040706172616D207B4576656E744275734C697374656E65727D206C697374656E65725C6E202A5C6E202A20';
wwv_flow_imp.g_varchar2_table(4583) := '4072657475726E207B616E797D5C6E202A2F5C6E4576656E744275732E70726F746F747970652E5F696E766F6B654C697374656E657273203D2066756E6374696F6E286576656E742C20617267732C206C697374656E657229207B5C6E5C6E2020766172';
wwv_flow_imp.g_varchar2_table(4584) := '2072657475726E56616C75653B5C6E5C6E20207768696C6520286C697374656E657229207B5C6E5C6E202020202F2F2068616E646C652073746F707065642070726F7061676174696F6E5C6E20202020696620286576656E742E63616E63656C42756262';
wwv_flow_imp.g_varchar2_table(4585) := '6C6529207B5C6E202020202020627265616B3B5C6E202020207D5C6E5C6E2020202072657475726E56616C7565203D20746869732E5F696E766F6B654C697374656E6572286576656E742C20617267732C206C697374656E6572293B5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(4586) := '6C697374656E6572203D206C697374656E65722E6E6578743B5C6E20207D5C6E5C6E202072657475726E2072657475726E56616C75653B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B4576656E747D206576656E745C6E202A2040706172';
wwv_flow_imp.g_varchar2_table(4587) := '616D207B616E795B5D7D20617267735C6E202A2040706172616D207B4576656E744275734C697374656E65727D206C697374656E65725C6E202A5C6E202A204072657475726E207B616E797D5C6E202A2F5C6E4576656E744275732E70726F746F747970';
wwv_flow_imp.g_varchar2_table(4588) := '652E5F696E766F6B654C697374656E6572203D2066756E6374696F6E286576656E742C20617267732C206C697374656E657229207B5C6E5C6E20207661722072657475726E56616C75653B5C6E5C6E2020696620286C697374656E65722E63616C6C6261';
wwv_flow_imp.g_varchar2_table(4589) := '636B2E5F5F6973546F6D6229207B5C6E2020202072657475726E2072657475726E56616C75653B5C6E20207D5C6E5C6E2020747279207B5C6E5C6E202020202F2F2072657475726E696E672066616C73652070726576656E747320746865206465666175';
wwv_flow_imp.g_varchar2_table(4590) := '6C7420616374696F6E5C6E2020202072657475726E56616C7565203D20696E766F6B6546756E6374696F6E286C697374656E65722E63616C6C6261636B2C2061726773293B5C6E5C6E202020202F2F2073746F702070726F7061676174696F6E206F6E20';
wwv_flow_imp.g_varchar2_table(4591) := '72657475726E2076616C75655C6E202020206966202872657475726E56616C756520213D3D20756E646566696E656429207B5C6E2020202020206576656E742E72657475726E56616C7565203D2072657475726E56616C75653B5C6E2020202020206576';
wwv_flow_imp.g_varchar2_table(4592) := '656E742E73746F7050726F7061676174696F6E28293B5C6E202020207D5C6E5C6E202020202F2F2070726576656E742064656661756C74206F6E2072657475726E2066616C73655C6E202020206966202872657475726E56616C7565203D3D3D2066616C';
wwv_flow_imp.g_varchar2_table(4593) := '736529207B5C6E2020202020206576656E742E70726576656E7444656661756C7428293B5C6E202020207D5C6E20207D20636174636820286572726F7229207B5C6E202020206966202821746869732E68616E646C654572726F72286572726F72292920';
wwv_flow_imp.g_varchar2_table(4594) := '7B5C6E202020202020636F6E736F6C652E6572726F722827756E68616E646C6564206572726F7220696E206576656E74206C697374656E6572272C206572726F72293B5C6E5C6E2020202020207468726F77206572726F723B5C6E202020207D5C6E2020';
wwv_flow_imp.g_varchar2_table(4595) := '7D5C6E5C6E202072657475726E2072657475726E56616C75653B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20416464206E6577206C697374656E657220776974682061206365727461696E207072696F7269747920746F20746865206C6973745C6E202A206F';
wwv_flow_imp.g_varchar2_table(4596) := '66206C697374656E6572732028666F722074686520676976656E206576656E74292E5C6E202A5C6E202A205468652073656D616E74696373206F66206C697374656E657220726567697374726174696F6E202F206C697374656E65722065786563757469';
wwv_flow_imp.g_varchar2_table(4597) := '6F6E206172655C6E202A2066697273742072656769737465722C2066697273742073657276653A204E6577206C697374656E6572732077696C6C20616C7761797320626520696E7365727465645C6E202A206166746572206578697374696E67206C6973';
wwv_flow_imp.g_varchar2_table(4598) := '74656E6572732077697468207468652073616D65207072696F726974792E5C6E202A5C6E202A204578616D706C653A20496E73657274696E672074776F206C697374656E6572732077697468207072696F72697479203130303020616E6420313330305C';
wwv_flow_imp.g_varchar2_table(4599) := '6E202A5C6E202A202020202A206265666F72653A205B20313530302C20313530302C20313030302C2031303030205D5C6E202A202020202A2061667465723A205B20313530302C20313530302C20286E65773D31333030292C20313030302C2031303030';
wwv_flow_imp.g_varchar2_table(4600) := '2C20286E65773D3130303029205D5C6E202A5C6E202A2040706172616D207B737472696E677D206576656E745C6E202A2040706172616D207B4576656E744275734C697374656E65727D206E65774C697374656E65725C6E202A2F5C6E4576656E744275';
wwv_flow_imp.g_varchar2_table(4601) := '732E70726F746F747970652E5F6164644C697374656E6572203D2066756E6374696F6E286576656E742C206E65774C697374656E657229207B5C6E5C6E2020766172206C697374656E6572203D20746869732E5F6765744C697374656E65727328657665';
wwv_flow_imp.g_varchar2_table(4602) := '6E74292C5C6E20202020202070726576696F75734C697374656E65723B5C6E5C6E20202F2F206E6F207072696F72206C697374656E6572735C6E202069662028216C697374656E657229207B5C6E20202020746869732E5F7365744C697374656E657273';
wwv_flow_imp.g_varchar2_table(4603) := '286576656E742C206E65774C697374656E6572293B5C6E5C6E2020202072657475726E3B5C6E20207D5C6E5C6E20202F2F20656E73757265207765206F72646572206C697374656E657273206279207072696F726974792066726F6D5C6E20202F2F2030';
wwv_flow_imp.g_varchar2_table(4604) := '2028686967682920746F206E203E203020286C6F77295C6E20207768696C6520286C697374656E657229207B5C6E5C6E20202020696620286C697374656E65722E7072696F72697479203C206E65774C697374656E65722E7072696F7269747929207B5C';
wwv_flow_imp.g_varchar2_table(4605) := '6E5C6E2020202020206E65774C697374656E65722E6E657874203D206C697374656E65723B5C6E5C6E2020202020206966202870726576696F75734C697374656E657229207B5C6E202020202020202070726576696F75734C697374656E65722E6E6578';
wwv_flow_imp.g_varchar2_table(4606) := '74203D206E65774C697374656E65723B5C6E2020202020207D20656C7365207B5C6E2020202020202020746869732E5F7365744C697374656E657273286576656E742C206E65774C697374656E6572293B5C6E2020202020207D5C6E5C6E202020202020';
wwv_flow_imp.g_varchar2_table(4607) := '72657475726E3B5C6E202020207D5C6E5C6E2020202070726576696F75734C697374656E6572203D206C697374656E65723B5C6E202020206C697374656E6572203D206C697374656E65722E6E6578743B5C6E20207D5C6E5C6E20202F2F20616464206E';
wwv_flow_imp.g_varchar2_table(4608) := '6577206C697374656E657220746F206261636B5C6E202070726576696F75734C697374656E65722E6E657874203D206E65774C697374656E65723B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2040706172616D207B737472696E677D206E616D655C6E20';
wwv_flow_imp.g_varchar2_table(4609) := '2A5C6E202A204072657475726E207B4576656E744275734C697374656E65727D5C6E202A2F5C6E4576656E744275732E70726F746F747970652E5F6765744C697374656E657273203D2066756E6374696F6E286E616D6529207B5C6E202072657475726E';
wwv_flow_imp.g_varchar2_table(4610) := '20746869732E5F6C697374656E6572735B6E616D655D3B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B737472696E677D206E616D655C6E202A2040706172616D207B4576656E744275734C697374656E65727D206C697374656E65725C6E';
wwv_flow_imp.g_varchar2_table(4611) := '202A2F5C6E4576656E744275732E70726F746F747970652E5F7365744C697374656E657273203D2066756E6374696F6E286E616D652C206C697374656E657229207B5C6E2020746869732E5F6C697374656E6572735B6E616D655D203D206C697374656E';
wwv_flow_imp.g_varchar2_table(4612) := '65723B5C6E7D3B5C6E5C6E4576656E744275732E70726F746F747970652E5F72656D6F76654C697374656E6572203D2066756E6374696F6E286576656E742C2063616C6C6261636B29207B5C6E5C6E2020766172206C697374656E6572203D2074686973';
wwv_flow_imp.g_varchar2_table(4613) := '2E5F6765744C697374656E657273286576656E74292C5C6E2020202020206E6578744C697374656E65722C5C6E20202020202070726576696F75734C697374656E65722C5C6E2020202020206C697374656E657243616C6C6261636B3B5C6E5C6E202069';
wwv_flow_imp.g_varchar2_table(4614) := '6620282163616C6C6261636B29207B5C6E5C6E202020202F2F20636C656172206C697374656E6572735C6E20202020746869732E5F7365744C697374656E657273286576656E742C206E756C6C293B5C6E5C6E2020202072657475726E3B5C6E20207D5C';
wwv_flow_imp.g_varchar2_table(4615) := '6E5C6E20207768696C6520286C697374656E657229207B5C6E5C6E202020206E6578744C697374656E6572203D206C697374656E65722E6E6578743B5C6E5C6E202020206C697374656E657243616C6C6261636B203D206C697374656E65722E63616C6C';
wwv_flow_imp.g_varchar2_table(4616) := '6261636B3B5C6E5C6E20202020696620286C697374656E657243616C6C6261636B203D3D3D2063616C6C6261636B207C7C206C697374656E657243616C6C6261636B5B464E5F5245465D203D3D3D2063616C6C6261636B29207B5C6E2020202020206966';
wwv_flow_imp.g_varchar2_table(4617) := '202870726576696F75734C697374656E657229207B5C6E202020202020202070726576696F75734C697374656E65722E6E657874203D206E6578744C697374656E65723B5C6E2020202020207D20656C7365207B5C6E5C6E20202020202020202F2F206E';
wwv_flow_imp.g_varchar2_table(4618) := '6577206669727374206C697374656E65725C6E2020202020202020746869732E5F7365744C697374656E657273286576656E742C206E6578744C697374656E6572293B5C6E2020202020207D5C6E202020207D5C6E5C6E2020202070726576696F75734C';
wwv_flow_imp.g_varchar2_table(4619) := '697374656E6572203D206C697374656E65723B5C6E202020206C697374656E6572203D206E6578744C697374656E65723B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A2041206576656E74207468617420697320656D697474656420766961207468';
wwv_flow_imp.g_varchar2_table(4620) := '65206576656E74206275732E5C6E202A2F5C6E66756E6374696F6E20496E7465726E616C4576656E742829207B207D5C6E5C6E496E7465726E616C4576656E742E70726F746F747970652E73746F7050726F7061676174696F6E203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(4621) := '6E2829207B5C6E2020746869732E63616E63656C427562626C65203D20747275653B5C6E7D3B5C6E5C6E496E7465726E616C4576656E742E70726F746F747970652E70726576656E7444656661756C74203D2066756E6374696F6E2829207B5C6E202074';
wwv_flow_imp.g_varchar2_table(4622) := '6869732E64656661756C7450726576656E746564203D20747275653B5C6E7D3B5C6E5C6E496E7465726E616C4576656E742E70726F746F747970652E696E6974203D2066756E6374696F6E286461746129207B5C6E202061737369676E28746869732C20';
wwv_flow_imp.g_varchar2_table(4623) := '64617461207C7C207B7D293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A20496E766F6B652066756E6374696F6E2E20426520666173742E2E2E5C6E202A5C6E202A2040706172616D207B46756E6374696F6E7D20666E5C6E202A2040706172616D207B61';
wwv_flow_imp.g_varchar2_table(4624) := '6E795B5D7D20617267735C6E202A5C6E202A204072657475726E207B616E797D5C6E202A2F5C6E66756E6374696F6E20696E766F6B6546756E6374696F6E28666E2C206172677329207B5C6E202072657475726E20666E2E6170706C79286E756C6C2C20';
wwv_flow_imp.g_varchar2_table(4625) := '61726773293B5C6E7D5C6E222C22696D706F7274207B5C6E2020666F72456163682C5C6E20207265647563655C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E20206765744368696C6472656E2C5C6E202067657456';
wwv_flow_imp.g_varchar2_table(4626) := '697375616C5C6E7D2066726F6D20272E2E2F7574696C2F47726170686963735574696C273B5C6E5C6E696D706F7274207B207472616E736C617465207D2066726F6D20272E2E2F7574696C2F5376675472616E73666F726D5574696C273B5C6E5C6E696D';
wwv_flow_imp.g_varchar2_table(4627) := '706F7274207B20636C65617220617320646F6D436C656172207D2066726F6D20276D696E2D646F6D273B5C6E5C6E696D706F7274207B5C6E2020617070656E6420617320737667417070656E642C5C6E20206174747220617320737667417474722C5C6E';
wwv_flow_imp.g_varchar2_table(4628) := '2020636C617373657320617320737667436C61737365732C5C6E2020637265617465206173207376674372656174652C5C6E202072656D6F76652061732073766752656D6F76655C6E7D2066726F6D202774696E792D737667273B5C6E5C6E696D706F72';
wwv_flow_imp.g_varchar2_table(4629) := '74207B5C6E202069734672616D65456C656D656E745C6E7D2066726F6D20272E2E2F7574696C2F456C656D656E7473273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2F547970657327292E436F6E6E656374696F6E4C';
wwv_flow_imp.g_varchar2_table(4630) := '696B657D20436F6E6E656374696F6E4C696B655C6E202A204074797065646566207B696D706F727428272E2F547970657327292E456C656D656E744C696B657D20456C656D656E744C696B655C6E202A204074797065646566207B696D706F727428272E';
wwv_flow_imp.g_varchar2_table(4631) := '2F547970657327292E53686170654C696B657D2053686170654C696B655C6E202A5C6E202A204074797065646566207B696D706F727428272E2F456C656D656E74526567697374727927292E64656661756C747D20456C656D656E745265676973747279';
wwv_flow_imp.g_varchar2_table(4632) := '5C6E202A204074797065646566207B696D706F727428272E2F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A2F5C6E5C6E2F2A2A5C6E202A204120666163746F7279207468617420637265617465732067726170686963';
wwv_flow_imp.g_varchar2_table(4633) := '616C20656C656D656E74732E5C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B456C656D656E7452656769737472797D20656C656D656E7452656769737472795C6E202A2F5C6E65';
wwv_flow_imp.g_varchar2_table(4634) := '78706F72742064656661756C742066756E6374696F6E204772617068696373466163746F7279286576656E744275732C20656C656D656E74526567697374727929207B5C6E2020746869732E5F6576656E74427573203D206576656E744275733B5C6E20';
wwv_flow_imp.g_varchar2_table(4635) := '20746869732E5F656C656D656E745265676973747279203D20656C656D656E7452656769737472793B5C6E7D5C6E5C6E4772617068696373466163746F72792E24696E6A656374203D205B20276576656E7442757327202C2027656C656D656E74526567';
wwv_flow_imp.g_varchar2_table(4636) := '697374727927205D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B207B20706172656E743F3A20616E79207D207D20656C656D656E745C6E202A204072657475726E207B535647456C656D656E747D5C6E202A2F5C6E477261706869637346616374';
wwv_flow_imp.g_varchar2_table(4637) := '6F72792E70726F746F747970652E5F6765744368696C6472656E436F6E7461696E6572203D2066756E6374696F6E28656C656D656E7429207B5C6E5C6E202076617220676678203D20746869732E5F656C656D656E7452656769737472792E6765744772';
wwv_flow_imp.g_varchar2_table(4638) := '61706869637328656C656D656E74293B5C6E5C6E2020766172206368696C6472656E4766783B5C6E5C6E20202F2F20726F6F7420656C656D656E745C6E20206966202821656C656D656E742E706172656E7429207B5C6E202020206368696C6472656E47';
wwv_flow_imp.g_varchar2_table(4639) := '6678203D206766783B5C6E20207D20656C7365207B5C6E202020206368696C6472656E476678203D206765744368696C6472656E28676678293B5C6E2020202069662028216368696C6472656E47667829207B5C6E2020202020206368696C6472656E47';
wwv_flow_imp.g_varchar2_table(4640) := '6678203D2073766743726561746528276727293B5C6E202020202020737667436C6173736573286368696C6472656E476678292E6164642827646A732D6368696C6472656E27293B5C6E5C6E202020202020737667417070656E64286766782E70617265';
wwv_flow_imp.g_varchar2_table(4641) := '6E744E6F64652C206368696C6472656E476678293B5C6E202020207D5C6E20207D5C6E5C6E202072657475726E206368696C6472656E4766783B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20436C65617273207468652067726170686963616C207265707265';
wwv_flow_imp.g_varchar2_table(4642) := '73656E746174696F6E206F662074686520656C656D656E7420616E642072657475726E73207468655C6E202A20636C65617265642076697375616C2028746865203C6720636C6173733D5C22646A732D76697375616C5C22202F3E20656C656D656E7429';
wwv_flow_imp.g_varchar2_table(4643) := '2E5C6E202A2F5C6E4772617068696373466163746F72792E70726F746F747970652E5F636C656172203D2066756E6374696F6E2867667829207B5C6E20207661722076697375616C203D2067657456697375616C28676678293B5C6E5C6E2020646F6D43';
wwv_flow_imp.g_varchar2_table(4644) := '6C6561722876697375616C293B5C6E5C6E202072657475726E2076697375616C3B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204372656174657320612067667820636F6E7461696E657220666F722073686170657320616E6420636F6E6E656374696F6E735C';
wwv_flow_imp.g_varchar2_table(4645) := '6E202A5C6E202A20546865206C61796F757420697320617320666F6C6C6F77733A5C6E202A5C6E202A203C6720636C6173733D5C22646A732D67726F75705C223E5C6E202A5C6E202A2020203C212D2D2074686520676678202D2D3E5C6E202A2020203C';
wwv_flow_imp.g_varchar2_table(4646) := '6720636C6173733D5C22646A732D656C656D656E7420646A732D2873686170657C636F6E6E656374696F6E7C6672616D65295C223E5C6E202A20202020203C6720636C6173733D5C22646A732D76697375616C5C223E5C6E202A202020202020203C212D';
wwv_flow_imp.g_varchar2_table(4647) := '2D207468652072656E646572657220647261777320696E2068657265202D2D3E5C6E202A20202020203C2F673E5C6E202A5C6E202A20202020203C212D2D20657874656E73696F6E7320286F7665726C6179732C20636C69636B20626F782C202E2E2E29';
wwv_flow_imp.g_varchar2_table(4648) := '20676F657320686572655C6E202A2020203C2F673E5C6E202A5C6E202A2020203C212D2D2074686520676678206368696C64206E6F646573202D2D3E5C6E202A2020203C6720636C6173733D5C22646A732D6368696C6472656E5C223E3C2F673E5C6E20';
wwv_flow_imp.g_varchar2_table(4649) := '2A203C2F673E5C6E202A5C6E202A2040706172616D207B737472696E677D2074797065207468652074797065206F662074686520656C656D656E742C20692E652E207368617065207C20636F6E6E656374696F6E5C6E202A2040706172616D207B535647';
wwv_flow_imp.g_varchar2_table(4650) := '456C656D656E747D206368696C6472656E4766785C6E202A2040706172616D207B6E756D6265727D205B706172656E74496E6465785D20706F736974696F6E20746F2063726561746520636F6E7461696E657220696E20706172656E745C6E202A204070';
wwv_flow_imp.g_varchar2_table(4651) := '6172616D207B626F6F6C65616E7D205B69734672616D655D206973206672616D6520656C656D656E745C6E202A5C6E202A204072657475726E207B535647456C656D656E747D5C6E202A2F5C6E4772617068696373466163746F72792E70726F746F7479';
wwv_flow_imp.g_varchar2_table(4652) := '70652E5F637265617465436F6E7461696E6572203D2066756E6374696F6E285C6E20202020747970652C206368696C6472656E4766782C20706172656E74496E6465782C2069734672616D655C6E29207B5C6E2020766172206F75746572476678203D20';
wwv_flow_imp.g_varchar2_table(4653) := '73766743726561746528276727293B5C6E2020737667436C6173736573286F75746572476678292E6164642827646A732D67726F757027293B5C6E5C6E20202F2F20696E73657274206E6F646520617420706F736974696F6E5C6E202069662028747970';
wwv_flow_imp.g_varchar2_table(4654) := '656F6620706172656E74496E64657820213D3D2027756E646566696E65642729207B5C6E2020202070726570656E64546F286F757465724766782C206368696C6472656E4766782C206368696C6472656E4766782E6368696C644E6F6465735B70617265';
wwv_flow_imp.g_varchar2_table(4655) := '6E74496E6465785D293B5C6E20207D20656C7365207B5C6E20202020737667417070656E64286368696C6472656E4766782C206F75746572476678293B5C6E20207D5C6E5C6E202076617220676678203D2073766743726561746528276727293B5C6E20';
wwv_flow_imp.g_varchar2_table(4656) := '20737667436C617373657328676678292E6164642827646A732D656C656D656E7427293B5C6E2020737667436C617373657328676678292E6164642827646A732D27202B2074797065293B5C6E5C6E20206966202869734672616D6529207B5C6E202020';
wwv_flow_imp.g_varchar2_table(4657) := '20737667436C617373657328676678292E6164642827646A732D6672616D6527293B5C6E20207D5C6E5C6E2020737667417070656E64286F757465724766782C20676678293B5C6E5C6E20202F2F206372656174652076697375616C5C6E202076617220';
wwv_flow_imp.g_varchar2_table(4658) := '76697375616C203D2073766743726561746528276727293B5C6E2020737667436C61737365732876697375616C292E6164642827646A732D76697375616C27293B5C6E5C6E2020737667417070656E64286766782C2076697375616C293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(4659) := '72657475726E206766783B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2043726561746520612067726170686963616C20656C656D656E742E5C6E202A5C6E202A2040706172616D207B2027736861706527207C2027636F6E6E656374696F6E27207C20276C61';
wwv_flow_imp.g_varchar2_table(4660) := '62656C27207C2027726F6F7427207D2074797065205468652074797065206F662074686520656C656D656E742E5C6E202A2040706172616D207B456C656D656E744C696B657D20656C656D656E742054686520656C656D656E742E5C6E202A2040706172';
wwv_flow_imp.g_varchar2_table(4661) := '616D207B6E756D6265727D205B706172656E74496E6465785D2054686520696E64657820617420776869636820746F20616464207468652067726170686963616C20656C656D656E7420746F2069747320706172656E742773206368696C6472656E2E5C';
wwv_flow_imp.g_varchar2_table(4662) := '6E202A5C6E202A204072657475726E207B535647456C656D656E747D205468652067726170686963616C20656C656D656E742E5C6E202A2F5C6E4772617068696373466163746F72792E70726F746F747970652E637265617465203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(4663) := '6E28747970652C20656C656D656E742C20706172656E74496E64657829207B5C6E2020766172206368696C6472656E476678203D20746869732E5F6765744368696C6472656E436F6E7461696E657228656C656D656E742E706172656E74293B5C6E2020';
wwv_flow_imp.g_varchar2_table(4664) := '72657475726E20746869732E5F637265617465436F6E7461696E657228747970652C206368696C6472656E4766782C20706172656E74496E6465782C2069734672616D65456C656D656E7428656C656D656E7429293B5C6E7D3B5C6E5C6E2F2A2A5C6E20';
wwv_flow_imp.g_varchar2_table(4665) := '2A205570646174652074686520636F6E7461696E6D656E7473206F662074686520676976656E20656C656D656E74732E5C6E202A5C6E202A2040706172616D207B456C656D656E744C696B655B5D7D20656C656D656E74732054686520656C656D656E74';
wwv_flow_imp.g_varchar2_table(4666) := '732E5C6E202A2F5C6E4772617068696373466163746F72792E70726F746F747970652E757064617465436F6E7461696E6D656E7473203D2066756E6374696F6E28656C656D656E747329207B5C6E5C6E20207661722073656C66203D20746869732C5C6E';
wwv_flow_imp.g_varchar2_table(4667) := '202020202020656C656D656E745265676973747279203D20746869732E5F656C656D656E7452656769737472792C5C6E202020202020706172656E74733B5C6E5C6E2020706172656E7473203D2072656475636528656C656D656E74732C2066756E6374';
wwv_flow_imp.g_varchar2_table(4668) := '696F6E286D61702C206529207B5C6E5C6E2020202069662028652E706172656E7429207B5C6E2020202020206D61705B652E706172656E742E69645D203D20652E706172656E743B5C6E202020207D5C6E5C6E2020202072657475726E206D61703B5C6E';
wwv_flow_imp.g_varchar2_table(4669) := '20207D2C207B7D293B5C6E5C6E20202F2F2075706461746520616C6C20706172656E7473206F66206368616E67656420616E642072656F7267616E697A6564207468656972206368696C6472656E5C6E20202F2F20696E2074686520636F727265637420';
wwv_flow_imp.g_varchar2_table(4670) := '6F726465722028617320696E6469636174656420696E206F7572206D6F64656C295C6E2020666F724561636828706172656E74732C2066756E6374696F6E28706172656E7429207B5C6E5C6E20202020766172206368696C6472656E203D20706172656E';
wwv_flow_imp.g_varchar2_table(4671) := '742E6368696C6472656E3B5C6E5C6E2020202069662028216368696C6472656E29207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E20202020766172206368696C6472656E476678203D2073656C662E5F6765744368696C6472656E';
wwv_flow_imp.g_varchar2_table(4672) := '436F6E7461696E657228706172656E74293B5C6E5C6E20202020666F7245616368286368696C6472656E2E736C69636528292E7265766572736528292C2066756E6374696F6E286368696C6429207B5C6E202020202020766172206368696C6447667820';
wwv_flow_imp.g_varchar2_table(4673) := '3D20656C656D656E7452656769737472792E6765744772617068696373286368696C64293B5C6E5C6E20202020202070726570656E64546F286368696C644766782E706172656E744E6F64652C206368696C6472656E476678293B5C6E202020207D293B';
wwv_flow_imp.g_varchar2_table(4674) := '5C6E20207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204472617720612073686170652E5C6E202A5C6E202A2040706172616D207B535647456C656D656E747D2076697375616C205468652067726170686963616C20656C656D656E742E5C6E202A2040';
wwv_flow_imp.g_varchar2_table(4675) := '706172616D207B53686170654C696B657D20656C656D656E74205468652073686170652E5C6E202A2040706172616D207B4F626A6563747D206174747273204F7074696F6E616C20617474726962757465732E5C6E202A5C6E202A204072657475726E20';
wwv_flow_imp.g_varchar2_table(4676) := '7B535647456C656D656E747D5C6E202A2F5C6E4772617068696373466163746F72792E70726F746F747970652E647261775368617065203D2066756E6374696F6E2876697375616C2C20656C656D656E742C206174747273203D207B7D29207B5C6E2020';
wwv_flow_imp.g_varchar2_table(4677) := '766172206576656E74427573203D20746869732E5F6576656E744275733B5C6E5C6E202072657475726E206576656E744275732E66697265282772656E6465722E7368617065272C207B206766783A2076697375616C2C20656C656D656E742C20617474';
wwv_flow_imp.g_varchar2_table(4678) := '7273207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20476574207468652070617468206F6620612073686170652E5C6E202A5C6E202A2040706172616D207B53686170654C696B657D20656C656D656E74205468652073686170652E5C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(4679) := '204072657475726E207B737472696E677D205468652070617468206F66207468652073686170652E5C6E202A2F5C6E4772617068696373466163746F72792E70726F746F747970652E676574536861706550617468203D2066756E6374696F6E28656C65';
wwv_flow_imp.g_varchar2_table(4680) := '6D656E7429207B5C6E2020766172206576656E74427573203D20746869732E5F6576656E744275733B5C6E5C6E202072657475726E206576656E744275732E66697265282772656E6465722E676574536861706550617468272C20656C656D656E74293B';
wwv_flow_imp.g_varchar2_table(4681) := '5C6E7D3B5C6E5C6E2F2A2A5C6E202A2044726177206120636F6E6E656374696F6E2E5C6E202A5C6E202A2040706172616D207B535647456C656D656E747D2076697375616C205468652067726170686963616C20656C656D656E742E5C6E202A20407061';
wwv_flow_imp.g_varchar2_table(4682) := '72616D207B436F6E6E656374696F6E4C696B657D20656C656D656E742054686520636F6E6E656374696F6E2E5C6E202A2040706172616D207B4F626A6563747D206174747273204F7074696F6E616C20617474726962757465732E5C6E202A5C6E202A20';
wwv_flow_imp.g_varchar2_table(4683) := '4072657475726E207B535647456C656D656E747D5C6E202A2F5C6E4772617068696373466163746F72792E70726F746F747970652E64726177436F6E6E656374696F6E203D2066756E6374696F6E2876697375616C2C20656C656D656E742C2061747472';
wwv_flow_imp.g_varchar2_table(4684) := '73203D207B7D29207B5C6E2020766172206576656E74427573203D20746869732E5F6576656E744275733B5C6E5C6E202072657475726E206576656E744275732E66697265282772656E6465722E636F6E6E656374696F6E272C207B206766783A207669';
wwv_flow_imp.g_varchar2_table(4685) := '7375616C2C20656C656D656E742C206174747273207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20476574207468652070617468206F66206120636F6E6E656374696F6E2E5C6E202A5C6E202A2040706172616D207B436F6E6E656374696F6E4C696B65';
wwv_flow_imp.g_varchar2_table(4686) := '7D20636F6E6E656374696F6E2054686520636F6E6E656374696F6E2E5C6E202A5C6E202A204072657475726E207B737472696E677D205468652070617468206F662074686520636F6E6E656374696F6E2E5C6E202A2F5C6E477261706869637346616374';
wwv_flow_imp.g_varchar2_table(4687) := '6F72792E70726F746F747970652E676574436F6E6E656374696F6E50617468203D2066756E6374696F6E28636F6E6E656374696F6E29207B5C6E2020766172206576656E74427573203D20746869732E5F6576656E744275733B5C6E5C6E202072657475';
wwv_flow_imp.g_varchar2_table(4688) := '726E206576656E744275732E66697265282772656E6465722E676574436F6E6E656374696F6E50617468272C20636F6E6E656374696F6E293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2055706461746520616E20656C656D656E7473206772617068696361';
wwv_flow_imp.g_varchar2_table(4689) := '6C20726570726573656E746174696F6E2E5C6E202A5C6E202A2040706172616D207B277368617065277C27636F6E6E656374696F6E277D20747970655C6E202A2040706172616D207B456C656D656E744C696B657D20656C656D656E745C6E202A204070';
wwv_flow_imp.g_varchar2_table(4690) := '6172616D207B535647456C656D656E747D206766785C6E202A2F5C6E4772617068696373466163746F72792E70726F746F747970652E757064617465203D2066756E6374696F6E28747970652C20656C656D656E742C2067667829207B5C6E5C6E20202F';
wwv_flow_imp.g_varchar2_table(4691) := '2F20646F204E4F542075706461746520726F6F7420656C656D656E745C6E20206966202821656C656D656E742E706172656E7429207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E20207661722076697375616C203D20746869732E5F636C65';
wwv_flow_imp.g_varchar2_table(4692) := '617228676678293B5C6E5C6E20202F2F207265647261775C6E20206966202874797065203D3D3D202773686170652729207B5C6E20202020746869732E6472617753686170652876697375616C2C20656C656D656E74293B5C6E5C6E202020202F2F2075';
wwv_flow_imp.g_varchar2_table(4693) := '706461746520706F736974696F6E696E675C6E202020207472616E736C617465286766782C20656C656D656E742E782C20656C656D656E742E79293B5C6E20207D20656C7365206966202874797065203D3D3D2027636F6E6E656374696F6E2729207B5C';
wwv_flow_imp.g_varchar2_table(4694) := '6E20202020746869732E64726177436F6E6E656374696F6E2876697375616C2C20656C656D656E74293B5C6E20207D20656C7365207B5C6E202020207468726F77206E6577204572726F722827756E6B6E6F776E20747970653A2027202B207479706529';
wwv_flow_imp.g_varchar2_table(4695) := '3B5C6E20207D5C6E5C6E202069662028656C656D656E742E68696464656E29207B5C6E2020202073766741747472286766782C2027646973706C6179272C20276E6F6E6527293B5C6E20207D20656C7365207B5C6E202020207376674174747228676678';
wwv_flow_imp.g_varchar2_table(4696) := '2C2027646973706C6179272C2027626C6F636B27293B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052656D6F766520612067726170686963616C20656C656D656E742E5C6E202A5C6E202A2040706172616D207B456C656D656E744C696B657D20';
wwv_flow_imp.g_varchar2_table(4697) := '656C656D656E742054686520656C656D656E742E5C6E202A2F5C6E4772617068696373466163746F72792E70726F746F747970652E72656D6F7665203D2066756E6374696F6E28656C656D656E7429207B5C6E202076617220676678203D20746869732E';
wwv_flow_imp.g_varchar2_table(4698) := '5F656C656D656E7452656769737472792E676574477261706869637328656C656D656E74293B5C6E5C6E20202F2F2072656D6F76655C6E202073766752656D6F7665286766782E706172656E744E6F6465293B5C6E7D3B5C6E5C6E5C6E2F2F2068656C70';
wwv_flow_imp.g_varchar2_table(4699) := '657273202F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E2070726570656E64546F286E65774E6F64652C20706172656E744E6F64652C207369626C696E674E6F646529207B5C6E2020766172206E6F6465203D207369626C696E674E6F6465207C';
wwv_flow_imp.g_varchar2_table(4700) := '7C20706172656E744E6F64652E66697273744368696C643B5C6E5C6E20202F2F20646F206E6F742070726570656E64206E6F646520746F20697473656C6620746F2070726576656E742049452066726F6D206372617368696E675C6E20202F2F20687474';
wwv_flow_imp.g_varchar2_table(4701) := '70733A2F2F6769746875622E636F6D2F62706D6E2D696F2F62706D6E2D6A732F6973737565732F3734365C6E2020696620286E65774E6F6465203D3D3D206E6F646529207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020706172656E744E';
wwv_flow_imp.g_varchar2_table(4702) := '6F64652E696E736572744265666F7265286E65774E6F64652C206E6F6465293B5C6E7D5C6E222C22696D706F727420447261774D6F64756C652066726F6D20272E2E2F64726177273B5C6E5C6E696D706F72742043616E7661732066726F6D20272E2F43';
wwv_flow_imp.g_varchar2_table(4703) := '616E766173273B5C6E696D706F727420456C656D656E7452656769737472792066726F6D20272E2F456C656D656E745265676973747279273B5C6E696D706F727420456C656D656E74466163746F72792066726F6D20272E2F456C656D656E7446616374';
wwv_flow_imp.g_varchar2_table(4704) := '6F7279273B5C6E696D706F7274204576656E744275732066726F6D20272E2F4576656E74427573273B5C6E696D706F7274204772617068696373466163746F72792066726F6D20272E2F4772617068696373466163746F7279273B5C6E5C6E2F2A2A5C6E';
wwv_flow_imp.g_varchar2_table(4705) := '202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D5C6E202A2F5C6E6578706F72742064656661756C74207B5C6E20205F5F646570656E64735F5F3A205B20447261774D6F64756C65205D2C';
wwv_flow_imp.g_varchar2_table(4706) := '5C6E20205F5F696E69745F5F3A205B202763616E76617327205D2C5C6E202063616E7661733A205B202774797065272C2043616E766173205D2C5C6E2020656C656D656E7452656769737472793A205B202774797065272C20456C656D656E7452656769';
wwv_flow_imp.g_varchar2_table(4707) := '73747279205D2C5C6E2020656C656D656E74466163746F72793A205B202774797065272C20456C656D656E74466163746F7279205D2C5C6E20206576656E744275733A205B202774797065272C204576656E74427573205D2C5C6E202067726170686963';
wwv_flow_imp.g_varchar2_table(4708) := '73466163746F72793A205B202774797065272C204772617068696373466163746F7279205D5C6E7D3B222C227661722044454641554C545F52454E4445525F5052494F52495459203D20313030303B5C6E5C6E2F2A2A5C6E202A20407479706564656620';
wwv_flow_imp.g_varchar2_table(4709) := '7B696D706F727428272E2E2F636F72652F547970657327292E456C656D656E744C696B657D20456C656D656E745C6E202A204074797065646566207B696D706F727428272E2E2F636F72652F547970657327292E436F6E6E656374696F6E4C696B657D20';
wwv_flow_imp.g_varchar2_table(4710) := '436F6E6E656374696F6E5C6E202A204074797065646566207B696D706F727428272E2E2F636F72652F547970657327292E53686170654C696B657D2053686170655C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F636F72652F';
wwv_flow_imp.g_varchar2_table(4711) := '4576656E7442757327292E64656661756C747D204576656E744275735C6E202A2F5C6E5C6E2F2A2A5C6E202A20546865206261736520696D706C656D656E746174696F6E206F6620736861706520616E6420636F6E6E656374696F6E2072656E64657265';
wwv_flow_imp.g_varchar2_table(4712) := '72732E5C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B6E756D6265727D205B72656E6465725072696F726974793D313030305D5C6E202A2F5C6E6578706F72742064656661756C';
wwv_flow_imp.g_varchar2_table(4713) := '742066756E6374696F6E204261736552656E6465726572286576656E744275732C2072656E6465725072696F7269747929207B5C6E20207661722073656C66203D20746869733B5C6E5C6E202072656E6465725072696F72697479203D2072656E646572';
wwv_flow_imp.g_varchar2_table(4714) := '5072696F72697479207C7C2044454641554C545F52454E4445525F5052494F524954593B5C6E5C6E20206576656E744275732E6F6E285B202772656E6465722E7368617065272C202772656E6465722E636F6E6E656374696F6E27205D2C2072656E6465';
wwv_flow_imp.g_varchar2_table(4715) := '725072696F726974792C2066756E6374696F6E286576742C20636F6E7465787429207B5C6E202020207661722074797065203D206576742E747970652C5C6E2020202020202020656C656D656E74203D20636F6E746578742E656C656D656E742C5C6E20';
wwv_flow_imp.g_varchar2_table(4716) := '2020202020202076697375616C73203D20636F6E746578742E6766782C5C6E20202020202020206174747273203D20636F6E746578742E61747472733B5C6E5C6E202020206966202873656C662E63616E52656E64657228656C656D656E742929207B5C';
wwv_flow_imp.g_varchar2_table(4717) := '6E2020202020206966202874797065203D3D3D202772656E6465722E73686170652729207B5C6E202020202020202072657475726E2073656C662E6472617753686170652876697375616C732C20656C656D656E742C206174747273293B5C6E20202020';
wwv_flow_imp.g_varchar2_table(4718) := '20207D20656C7365207B5C6E202020202020202072657475726E2073656C662E64726177436F6E6E656374696F6E2876697375616C732C20656C656D656E742C206174747273293B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(4719) := '206576656E744275732E6F6E285B202772656E6465722E676574536861706550617468272C202772656E6465722E676574436F6E6E656374696F6E5061746827205D2C2072656E6465725072696F726974792C2066756E6374696F6E286576742C20656C';
wwv_flow_imp.g_varchar2_table(4720) := '656D656E7429207B5C6E202020206966202873656C662E63616E52656E64657228656C656D656E742929207B5C6E202020202020696620286576742E74797065203D3D3D202772656E6465722E6765745368617065506174682729207B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(4721) := '20202072657475726E2073656C662E67657453686170655061746828656C656D656E74293B5C6E2020202020207D20656C7365207B5C6E202020202020202072657475726E2073656C662E676574436F6E6E656374696F6E5061746828656C656D656E74';
wwv_flow_imp.g_varchar2_table(4722) := '293B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E7D5C6E5C6E2F2A2A5C6E202A20436865636B73207768657468657220616E20656C656D656E742063616E2062652072656E64657265642E5C6E202A5C6E202A2040706172616D207B45';
wwv_flow_imp.g_varchar2_table(4723) := '6C656D656E747D20656C656D656E742054686520656C656D656E7420746F2062652072656E64657265642E5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D20576865746865722074686520656C656D656E742063616E2062652072656E';
wwv_flow_imp.g_varchar2_table(4724) := '64657265642E5C6E202A2F5C6E4261736552656E64657265722E70726F746F747970652E63616E52656E646572203D2066756E6374696F6E28656C656D656E7429207B7D3B5C6E5C6E2F2A2A5C6E202A20447261777320612073686170652E5C6E202A5C';
wwv_flow_imp.g_varchar2_table(4725) := '6E202A2040706172616D207B535647456C656D656E747D2076697375616C73205468652053564720656C656D656E7420746F20647261772074686520736861706520696E746F2E5C6E202A2040706172616D207B53686170657D20736861706520546865';
wwv_flow_imp.g_varchar2_table(4726) := '20736861706520746F20626520647261776E2E5C6E202A5C6E202A204072657475726E207B535647456C656D656E747D205468652053564720656C656D656E74206F662074686520736861706520647261776E2E5C6E202A2F5C6E4261736552656E6465';
wwv_flow_imp.g_varchar2_table(4727) := '7265722E70726F746F747970652E647261775368617065203D2066756E6374696F6E2876697375616C732C20736861706529207B7D3B5C6E5C6E2F2A2A5C6E202A204472617773206120636F6E6E656374696F6E2E5C6E202A5C6E202A2040706172616D';
wwv_flow_imp.g_varchar2_table(4728) := '207B535647456C656D656E747D2076697375616C73205468652053564720656C656D656E7420746F20647261772074686520636F6E6E656374696F6E20696E746F2E5C6E202A2040706172616D207B436F6E6E656374696F6E7D20636F6E6E656374696F';
wwv_flow_imp.g_varchar2_table(4729) := '6E2054686520636F6E6E656374696F6E20746F20626520647261776E2E5C6E202A5C6E202A204072657475726E207B535647456C656D656E747D205468652053564720656C656D656E74206F662074686520636F6E6E656374696F6E20647261776E2E5C';
wwv_flow_imp.g_varchar2_table(4730) := '6E202A2F5C6E4261736552656E64657265722E70726F746F747970652E64726177436F6E6E656374696F6E203D2066756E6374696F6E2876697375616C732C20636F6E6E656374696F6E29207B7D3B5C6E5C6E2F2A2A5C6E202A20476574732074686520';
wwv_flow_imp.g_varchar2_table(4731) := '5356472070617468206F66207468652067726170686963616C20726570726573656E746174696F6E206F6620612073686170652E5C6E202A5C6E202A2040706172616D207B53686170657D207368617065205468652073686170652E5C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(4732) := '204072657475726E207B737472696E677D20546865205356472070617468206F66207468652073686170652E5C6E202A2F5C6E4261736552656E64657265722E70726F746F747970652E676574536861706550617468203D2066756E6374696F6E287368';
wwv_flow_imp.g_varchar2_table(4733) := '61706529207B7D3B5C6E5C6E2F2A2A5C6E202A204765747320746865205356472070617468206F66207468652067726170686963616C20726570726573656E746174696F6E206F66206120636F6E6E656374696F6E2E5C6E202A5C6E202A204070617261';
wwv_flow_imp.g_varchar2_table(4734) := '6D207B436F6E6E656374696F6E7D20636F6E6E656374696F6E2054686520636F6E6E656374696F6E2E5C6E202A5C6E202A204072657475726E207B737472696E677D20546865205356472070617468206F662074686520636F6E6E656374696F6E2E5C6E';
wwv_flow_imp.g_varchar2_table(4735) := '202A2F5C6E4261736552656E64657265722E70726F746F747970652E676574436F6E6E656374696F6E50617468203D2066756E6374696F6E28636F6E6E656374696F6E29207B7D3B5C6E222C22696D706F727420696E6865726974732066726F6D202769';
wwv_flow_imp.g_varchar2_table(4736) := '6E6865726974732D62726F77736572273B5C6E5C6E696D706F7274204261736552656E64657265722066726F6D20272E2F4261736552656E6465726572273B5C6E5C6E696D706F7274207B5C6E2020636F6D706F6E656E7473546F506174682C5C6E2020';
wwv_flow_imp.g_varchar2_table(4737) := '6372656174654C696E655C6E7D2066726F6D20272E2E2F7574696C2F52656E6465725574696C273B5C6E5C6E696D706F7274207B5C6E2020617070656E6420617320737667417070656E642C5C6E20206174747220617320737667417474722C5C6E2020';
wwv_flow_imp.g_varchar2_table(4738) := '637265617465206173207376674372656174655C6E7D2066726F6D202774696E792D737667273B5C6E5C6E696D706F7274207B2061737369676E207D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E202069734672616D65';
wwv_flow_imp.g_varchar2_table(4739) := '456C656D656E745C6E7D2066726F6D20272E2E2F7574696C2F456C656D656E7473273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275';
wwv_flow_imp.g_varchar2_table(4740) := '735C6E202A204074797065646566207B696D706F727428272E2F5374796C657327292E64656661756C747D205374796C65735C6E202A2F5C6E5C6E2F2F206170706C792064656661756C742072656E64657265722077697468206C6F7765737420706F73';
wwv_flow_imp.g_varchar2_table(4741) := '7369626C65207072696F726974795C6E2F2F20736F2074686174206974206F6E6C79206B69636B7320696E206966206E6F6F6E6520656C736520636F756C642072656E6465725C6E7661722044454641554C545F52454E4445525F5052494F5249545920';
wwv_flow_imp.g_varchar2_table(4742) := '3D20313B5C6E5C6E2F2A2A5C6E202A205468652064656661756C742072656E6465726572207573656420666F722073686170657320616E6420636F6E6E656374696F6E732E5C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E';
wwv_flow_imp.g_varchar2_table(4743) := '744275735C6E202A2040706172616D207B5374796C65737D207374796C65735C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E2044656661756C7452656E6465726572286576656E744275732C207374796C657329207B5C6E5C';
wwv_flow_imp.g_varchar2_table(4744) := '6E20204261736552656E64657265722E63616C6C28746869732C206576656E744275732C2044454641554C545F52454E4445525F5052494F52495459293B5C6E5C6E2020746869732E434F4E4E454354494F4E5F5354594C45203D207374796C65732E73';
wwv_flow_imp.g_varchar2_table(4745) := '74796C65285B20276E6F2D66696C6C27205D2C207B207374726F6B6557696474683A20352C207374726F6B653A20276675636873696127207D293B5C6E2020746869732E53484150455F5354594C45203D207374796C65732E7374796C65287B2066696C';
wwv_flow_imp.g_varchar2_table(4746) := '6C3A20277768697465272C207374726F6B653A202766756368736961272C207374726F6B6557696474683A2032207D293B5C6E2020746869732E4652414D455F5354594C45203D207374796C65732E7374796C65285B20276E6F2D66696C6C27205D2C20';
wwv_flow_imp.g_varchar2_table(4747) := '7B207374726F6B653A202766756368736961272C207374726F6B654461736861727261793A20342C207374726F6B6557696474683A2032207D293B5C6E7D5C6E5C6E696E6865726974732844656661756C7452656E64657265722C204261736552656E64';
wwv_flow_imp.g_varchar2_table(4748) := '65726572293B5C6E5C6E5C6E2F2A2A5C6E202A2040707269766174655C6E202A2F5C6E44656661756C7452656E64657265722E70726F746F747970652E63616E52656E646572203D2066756E6374696F6E2829207B5C6E202072657475726E2074727565';
wwv_flow_imp.g_varchar2_table(4749) := '3B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040707269766174655C6E202A2F5C6E44656661756C7452656E64657265722E70726F746F747970652E647261775368617065203D2066756E6374696F6E206472617753686170652876697375616C732C20656C';
wwv_flow_imp.g_varchar2_table(4750) := '656D656E742C20617474727329207B5C6E20207661722072656374203D2073766743726561746528277265637427293B5C6E5C6E20207376674174747228726563742C207B5C6E20202020783A20302C5C6E20202020793A20302C5C6E20202020776964';
wwv_flow_imp.g_varchar2_table(4751) := '74683A20656C656D656E742E7769647468207C7C20302C5C6E202020206865696768743A20656C656D656E742E686569676874207C7C20305C6E20207D293B5C6E5C6E20206966202869734672616D65456C656D656E7428656C656D656E742929207B5C';
wwv_flow_imp.g_varchar2_table(4752) := '6E202020207376674174747228726563742C2061737369676E287B7D2C20746869732E4652414D455F5354594C452C206174747273207C7C207B7D29293B5C6E20207D20656C7365207B5C6E202020207376674174747228726563742C2061737369676E';
wwv_flow_imp.g_varchar2_table(4753) := '287B7D2C20746869732E53484150455F5354594C452C206174747273207C7C207B7D29293B5C6E20207D5C6E5C6E2020737667417070656E642876697375616C732C2072656374293B5C6E5C6E202072657475726E20726563743B5C6E7D3B5C6E5C6E2F';
wwv_flow_imp.g_varchar2_table(4754) := '2A2A5C6E202A2040707269766174655C6E202A2F5C6E44656661756C7452656E64657265722E70726F746F747970652E64726177436F6E6E656374696F6E203D2066756E6374696F6E2064726177436F6E6E656374696F6E2876697375616C732C20636F';
wwv_flow_imp.g_varchar2_table(4755) := '6E6E656374696F6E2C20617474727329207B5C6E5C6E2020766172206C696E65203D206372656174654C696E6528636F6E6E656374696F6E2E776179706F696E74732C2061737369676E287B7D2C20746869732E434F4E4E454354494F4E5F5354594C45';
wwv_flow_imp.g_varchar2_table(4756) := '2C206174747273207C7C207B7D29293B5C6E2020737667417070656E642876697375616C732C206C696E65293B5C6E5C6E202072657475726E206C696E653B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040707269766174655C6E202A2F5C6E44656661756C';
wwv_flow_imp.g_varchar2_table(4757) := '7452656E64657265722E70726F746F747970652E676574536861706550617468203D2066756E6374696F6E2067657453686170655061746828736861706529207B5C6E5C6E20207661722078203D2073686170652E782C5C6E20202020202079203D2073';
wwv_flow_imp.g_varchar2_table(4758) := '686170652E792C5C6E2020202020207769647468203D2073686170652E77696474682C5C6E202020202020686569676874203D2073686170652E6865696768743B5C6E5C6E202076617220736861706550617468203D205B5C6E202020205B20274D272C';
wwv_flow_imp.g_varchar2_table(4759) := '20782C2079205D2C5C6E202020205B20276C272C2077696474682C2030205D2C5C6E202020205B20276C272C20302C20686569676874205D2C5C6E202020205B20276C272C202D77696474682C2030205D2C5C6E202020205B20277A27205D5C6E20205D';
wwv_flow_imp.g_varchar2_table(4760) := '3B5C6E5C6E202072657475726E20636F6D706F6E656E7473546F5061746828736861706550617468293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040707269766174655C6E202A2F5C6E44656661756C7452656E64657265722E70726F746F747970652E67';
wwv_flow_imp.g_varchar2_table(4761) := '6574436F6E6E656374696F6E50617468203D2066756E6374696F6E20676574436F6E6E656374696F6E5061746828636F6E6E656374696F6E29207B5C6E202076617220776179706F696E7473203D20636F6E6E656374696F6E2E776179706F696E74733B';
wwv_flow_imp.g_varchar2_table(4762) := '5C6E5C6E2020766172206964782C20706F696E742C20636F6E6E656374696F6E50617468203D205B5D3B5C6E5C6E2020666F722028696478203D20303B2028706F696E74203D20776179706F696E74735B6964785D293B206964782B2B29207B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(4763) := '202020202F2F2074616B6520696E76697369626C6520646F636B696E6720696E746F206163636F756E745C6E202020202F2F207768656E206372656174696E672074686520706174685C6E20202020706F696E74203D20706F696E742E6F726967696E61';
wwv_flow_imp.g_varchar2_table(4764) := '6C207C7C20706F696E743B5C6E5C6E20202020636F6E6E656374696F6E506174682E70757368285B20696478203D3D3D2030203F20274D27203A20274C272C20706F696E742E782C20706F696E742E79205D293B5C6E20207D5C6E5C6E20207265747572';
wwv_flow_imp.g_varchar2_table(4765) := '6E20636F6D706F6E656E7473546F5061746828636F6E6E656374696F6E50617468293B5C6E7D3B5C6E5C6E44656661756C7452656E64657265722E24696E6A656374203D205B20276576656E74427573272C20277374796C657327205D3B5C6E222C2269';
wwv_flow_imp.g_varchar2_table(4766) := '6D706F7274207B5C6E2020697341727261792C5C6E202061737369676E2C5C6E20207265647563655C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E5C6E2F2A2A5C6E202A204120636F6D706F6E656E742074686174206D616E616765732073';
wwv_flow_imp.g_varchar2_table(4767) := '68617065207374796C65735C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E205374796C65732829207B5C6E5C6E20207661722064656661756C74547261697473203D207B5C6E5C6E20202020276E6F2D66696C6C273A207B5C';
wwv_flow_imp.g_varchar2_table(4768) := '6E20202020202066696C6C3A20276E6F6E65275C6E202020207D2C5C6E20202020276E6F2D626F72646572273A207B5C6E2020202020207374726F6B654F7061636974793A20302E305C6E202020207D2C5C6E20202020276E6F2D6576656E7473273A20';
wwv_flow_imp.g_varchar2_table(4769) := '7B5C6E202020202020706F696E7465724576656E74733A20276E6F6E65275C6E202020207D5C6E20207D3B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E20202F2A2A5C6E2020202A204275696C64732061207374796C652064656669';
wwv_flow_imp.g_varchar2_table(4770) := '6E6974696F6E2066726F6D206120636C6173734E616D652C2061206C697374206F662074726169747320616E6420616E206F626A6563745C6E2020202A206F66206164646974696F6E616C20617474726962757465732E5C6E2020202A5C6E2020202A20';
wwv_flow_imp.g_varchar2_table(4771) := '40706172616D207B737472696E677D20636C6173734E616D655C6E2020202A2040706172616D207B737472696E675B5D7D205B7472616974735D5C6E2020202A2040706172616D207B4F626A6563747D205B6164646974696F6E616C41747472735D5C6E';
wwv_flow_imp.g_varchar2_table(4772) := '2020202A5C6E2020202A204072657475726E207B4F626A6563747D20746865207374796C6520646566696E6974696F6E5C6E2020202A2F5C6E2020746869732E636C73203D2066756E6374696F6E28636C6173734E616D652C207472616974732C206164';
wwv_flow_imp.g_varchar2_table(4773) := '646974696F6E616C417474727329207B5C6E20202020766172206174747273203D20746869732E7374796C65287472616974732C206164646974696F6E616C4174747273293B5C6E5C6E2020202072657475726E2061737369676E2861747472732C207B';
wwv_flow_imp.g_varchar2_table(4774) := '2027636C617373273A20636C6173734E616D65207D293B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A204275696C64732061207374796C6520646566696E6974696F6E2066726F6D2061206C697374206F662074726169747320616E6420616E20';
wwv_flow_imp.g_varchar2_table(4775) := '6F626A656374206F66206164646974696F6E616C5C6E2020202A20617474726962757465732E5C6E2020202A5C6E2020202A2040706172616D207B737472696E675B5D7D205B7472616974735D5C6E2020202A2040706172616D207B4F626A6563747D20';
wwv_flow_imp.g_varchar2_table(4776) := '6164646974696F6E616C41747472735C6E2020202A5C6E2020202A204072657475726E207B4F626A6563747D20746865207374796C6520646566696E6974696F6E5C6E2020202A2F5C6E2020746869732E7374796C65203D2066756E6374696F6E287472';
wwv_flow_imp.g_varchar2_table(4777) := '616974732C206164646974696F6E616C417474727329207B5C6E5C6E20202020696620282169734172726179287472616974732920262620216164646974696F6E616C417474727329207B5C6E2020202020206164646974696F6E616C4174747273203D';
wwv_flow_imp.g_varchar2_table(4778) := '207472616974733B5C6E202020202020747261697473203D205B5D3B5C6E202020207D5C6E5C6E20202020766172206174747273203D20726564756365287472616974732C2066756E6374696F6E2861747472732C207429207B5C6E2020202020207265';
wwv_flow_imp.g_varchar2_table(4779) := '7475726E2061737369676E2861747472732C2064656661756C745472616974735B745D207C7C207B7D293B5C6E202020207D2C207B7D293B5C6E5C6E2020202072657475726E206164646974696F6E616C4174747273203F2061737369676E2861747472';
wwv_flow_imp.g_varchar2_table(4780) := '732C206164646974696F6E616C417474727329203A2061747472733B5C6E20207D3B5C6E5C6E5C6E20202F2A2A5C6E2020202A20436F6D70757465732061207374796C6520646566696E6974696F6E2066726F6D2061206C697374206F66207472616974';
wwv_flow_imp.g_varchar2_table(4781) := '7320616E6420616E206F626A656374206F665C6E2020202A206164646974696F6E616C20617474726962757465732C207769746820637573746F6D207374796C6520646566696E6974696F6E206F626A6563742E5C6E2020202A5C6E2020202A20407061';
wwv_flow_imp.g_varchar2_table(4782) := '72616D207B4F626A6563747D20637573746F6D5C6E2020202A2040706172616D207B737472696E675B5D7D205B7472616974735D5C6E2020202A2040706172616D207B4F626A6563747D2064656661756C745374796C65735C6E2020202A5C6E2020202A';
wwv_flow_imp.g_varchar2_table(4783) := '204072657475726E207B4F626A6563747D20746865207374796C6520646566696E6974696F6E5C6E2020202A2F5C6E2020746869732E636F6D707574655374796C65203D2066756E6374696F6E28637573746F6D2C207472616974732C2064656661756C';
wwv_flow_imp.g_varchar2_table(4784) := '745374796C657329207B5C6E20202020696620282169734172726179287472616974732929207B5C6E20202020202064656661756C745374796C6573203D207472616974733B5C6E202020202020747261697473203D205B5D3B5C6E202020207D5C6E5C';
wwv_flow_imp.g_varchar2_table(4785) := '6E2020202072657475726E2073656C662E7374796C6528747261697473207C7C205B5D2C2061737369676E287B7D2C2064656661756C745374796C65732C20637573746F6D207C7C207B7D29293B5C6E20207D3B5C6E7D5C6E222C22696D706F72742044';
wwv_flow_imp.g_varchar2_table(4786) := '656661756C7452656E64657265722066726F6D20272E2F44656661756C7452656E6465726572273B5C6E696D706F7274205374796C65732066726F6D20272E2F5374796C6573273B5C6E5C6E2F2A2A5C6E202A204074797065207B20696D706F72742827';
wwv_flow_imp.g_varchar2_table(4787) := '6469646927292E4D6F64756C654465636C61726174696F6E207D5C6E202A2F5C6E6578706F72742064656661756C74207B5C6E20205F5F696E69745F5F3A205B202764656661756C7452656E646572657227205D2C5C6E202064656661756C7452656E64';
wwv_flow_imp.g_varchar2_table(4788) := '657265723A205B202774797065272C2044656661756C7452656E6465726572205D2C5C6E20207374796C65733A205B202774797065272C205374796C6573205D5C6E7D3B5C6E222C22696D706F7274207B5C6E2020676574547970652061732067657445';
wwv_flow_imp.g_varchar2_table(4789) := '6C656D656E74547970655C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F456C656D656E7473273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E64656661756C747D20';
wwv_flow_imp.g_varchar2_table(4790) := '43616E7661735C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F456C656D656E74526567697374727927292E64656661756C747D20456C656D656E7452656769737472795C6E202A204074797065646566207B696D70';
wwv_flow_imp.g_varchar2_table(4791) := '6F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4772617068696373466163746F727927292E64656661';
wwv_flow_imp.g_varchar2_table(4792) := '756C747D204772617068696373466163746F72795C6E202A2F5C6E5C6E2F2A2A5C6E202A2041646473206368616E676520737570706F727420746F20746865206469616772616D2C20696E636C7564696E675C6E202A5C6E202A203C756C3E5C6E202A20';
wwv_flow_imp.g_varchar2_table(4793) := '20203C6C693E726564726177696E672073686170657320616E6420636F6E6E656374696F6E73206F6E206368616E67653C2F6C693E5C6E202A203C2F756C3E5C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E';
wwv_flow_imp.g_varchar2_table(4794) := '202A2040706172616D207B43616E7661737D2063616E7661735C6E202A2040706172616D207B456C656D656E7452656769737472797D20656C656D656E7452656769737472795C6E202A2040706172616D207B4772617068696373466163746F72797D20';
wwv_flow_imp.g_varchar2_table(4795) := '6772617068696373466163746F72795C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E204368616E6765537570706F7274285C6E202020206576656E744275732C2063616E7661732C20656C656D656E7452656769737472792C';
wwv_flow_imp.g_varchar2_table(4796) := '5C6E202020206772617068696373466163746F727929207B5C6E5C6E5C6E20202F2F2072656472617720736861706573202F20636F6E6E656374696F6E73206F6E206368616E67655C6E5C6E20206576656E744275732E6F6E2827656C656D656E742E63';
wwv_flow_imp.g_varchar2_table(4797) := '68616E676564272C2066756E6374696F6E286576656E7429207B5C6E5C6E2020202076617220656C656D656E74203D206576656E742E656C656D656E743B5C6E5C6E202020202F2F20656C656D656E74206D696768742068617665206265656E2064656C';
wwv_flow_imp.g_varchar2_table(4798) := '6574656420616E64207265706C61636564206279206E657720656C656D656E7420776974682073616D652049445C6E202020202F2F207468757320636865636B20666F7220706172656E74206F6620656C656D656E742065786365707420666F7220726F';
wwv_flow_imp.g_varchar2_table(4799) := '6F7420656C656D656E745C6E2020202069662028656C656D656E742E706172656E74207C7C20656C656D656E74203D3D3D2063616E7661732E676574526F6F74456C656D656E74282929207B5C6E2020202020206576656E742E676678203D20656C656D';
wwv_flow_imp.g_varchar2_table(4800) := '656E7452656769737472792E676574477261706869637328656C656D656E74293B5C6E202020207D5C6E5C6E202020202F2F207368617065202B20676678206D61792068617665206265656E2064656C657465645C6E2020202069662028216576656E74';
wwv_flow_imp.g_varchar2_table(4801) := '2E67667829207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E202020206576656E744275732E6669726528676574456C656D656E745479706528656C656D656E7429202B20272E6368616E676564272C206576656E74293B5C6E2020';
wwv_flow_imp.g_varchar2_table(4802) := '7D293B5C6E5C6E20206576656E744275732E6F6E2827656C656D656E74732E6368616E676564272C2066756E6374696F6E286576656E7429207B5C6E5C6E2020202076617220656C656D656E7473203D206576656E742E656C656D656E74733B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(4803) := '20202020656C656D656E74732E666F72456163682866756E6374696F6E286529207B5C6E2020202020206576656E744275732E666972652827656C656D656E742E6368616E676564272C207B20656C656D656E743A2065207D293B5C6E202020207D293B';
wwv_flow_imp.g_varchar2_table(4804) := '5C6E5C6E202020206772617068696373466163746F72792E757064617465436F6E7461696E6D656E747328656C656D656E7473293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E282773686170652E6368616E676564272C2066756E6374';
wwv_flow_imp.g_varchar2_table(4805) := '696F6E286576656E7429207B5C6E202020206772617068696373466163746F72792E75706461746528277368617065272C206576656E742E656C656D656E742C206576656E742E676678293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E';
wwv_flow_imp.g_varchar2_table(4806) := '2827636F6E6E656374696F6E2E6368616E676564272C2066756E6374696F6E286576656E7429207B5C6E202020206772617068696373466163746F72792E7570646174652827636F6E6E656374696F6E272C206576656E742E656C656D656E742C206576';
wwv_flow_imp.g_varchar2_table(4807) := '656E742E676678293B5C6E20207D293B5C6E7D5C6E5C6E4368616E6765537570706F72742E24696E6A656374203D205B5C6E2020276576656E74427573272C5C6E20202763616E766173272C5C6E202027656C656D656E745265676973747279272C5C6E';
wwv_flow_imp.g_varchar2_table(4808) := '2020276772617068696373466163746F7279275C6E5D3B222C22696D706F7274204368616E6765537570706F72742066726F6D20272E2F4368616E6765537570706F7274273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065207B20696D706F72742827';
wwv_flow_imp.g_varchar2_table(4809) := '6469646927292E4D6F64756C654465636C61726174696F6E207D5C6E202A2F5C6E6578706F72742064656661756C74207B5C6E20205F5F696E69745F5F3A205B20276368616E6765537570706F727427205D2C5C6E20206368616E6765537570706F7274';
wwv_flow_imp.g_varchar2_table(4810) := '3A205B202774797065272C204368616E6765537570706F7274205D5C6E7D3B222C22696D706F7274207B5C6E2020666F72456163682C5C6E202061737369676E5C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E2020';
wwv_flow_imp.g_varchar2_table(4811) := '64656C656761746520617320646F6D44656C65676174652C5C6E2020717565727920617320646F6D51756572792C5C6E20207175657279416C6C20617320646F6D5175657279416C6C5C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E696D706F';
wwv_flow_imp.g_varchar2_table(4812) := '7274207B5C6E202069735072696D617279427574746F6E2C5C6E20206973417578696C69617279427574746F6E5C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F4D6F757365273B5C6E5C6E696D706F7274207B5C6E2020617070656E642061732073';
wwv_flow_imp.g_varchar2_table(4813) := '7667417070656E642C5C6E20206174747220617320737667417474722C5C6E2020637265617465206173207376674372656174652C5C6E202072656D6F76652061732073766752656D6F76655C6E7D2066726F6D202774696E792D737667273B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(4814) := '696D706F7274207B5C6E20206372656174654C696E652C5C6E20207570646174654C696E655C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F52656E6465725574696C273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F72742827';
wwv_flow_imp.g_varchar2_table(4815) := '2E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E745C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F456C656D656E74526567697374727927292E64656661756C747D';
wwv_flow_imp.g_varchar2_table(4816) := '20456C656D656E7452656769737472795C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A204074797065646566207B696D706F727428';
wwv_flow_imp.g_varchar2_table(4817) := '272E2E2F2E2E2F647261772F5374796C657327292E64656661756C747D205374796C65735C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F7574696C2F547970657327292E506F696E747D20506F696E745C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(4818) := '6E5C6E66756E6374696F6E20616C6C6F77416C6C286576656E7429207B2072657475726E20747275653B207D5C6E5C6E66756E6374696F6E20616C6C6F775072696D617279416E64417578696C69617279286576656E7429207B5C6E202072657475726E';
wwv_flow_imp.g_varchar2_table(4819) := '2069735072696D617279427574746F6E286576656E7429207C7C206973417578696C69617279427574746F6E286576656E74293B5C6E7D5C6E5C6E766172204C4F575F5052494F52495459203D203530303B5C6E5C6E5C6E2F2A2A5C6E202A204120706C';
wwv_flow_imp.g_varchar2_table(4820) := '7567696E20746861742070726F766964657320696E746572616374696F6E206576656E747320666F72206469616772616D20656C656D656E74732E5C6E202A5C6E202A20497420656D6974732074686520666F6C6C6F77696E67206576656E74733A5C6E';
wwv_flow_imp.g_varchar2_table(4821) := '202A5C6E202A2020202A20656C656D656E742E636C69636B5C6E202A2020202A20656C656D656E742E636F6E746578746D656E755C6E202A2020202A20656C656D656E742E64626C636C69636B5C6E202A2020202A20656C656D656E742E686F7665725C';
wwv_flow_imp.g_varchar2_table(4822) := '6E202A2020202A20656C656D656E742E6D6F757365646F776E5C6E202A2020202A20656C656D656E742E6D6F7573656D6F76655C6E202A2020202A20656C656D656E742E6D6F75736575705C6E202A2020202A20656C656D656E742E6F75745C6E202A5C';
wwv_flow_imp.g_varchar2_table(4823) := '6E202A2045616368206576656E742069732061207475706C65207B20656C656D656E742C206766782C206F726967696E616C4576656E74207D2E5C6E202A5C6E202A2043616E63656C696E6720746865206576656E7420766961204576656E7423707265';
wwv_flow_imp.g_varchar2_table(4824) := '76656E7444656661756C7428295C6E202A2070726576656E747320746865206F726967696E616C20444F4D206F7065726174696F6E2E5C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D';
wwv_flow_imp.g_varchar2_table(4825) := '207B456C656D656E7452656769737472797D20656C656D656E7452656769737472795C6E202A2040706172616D207B5374796C65737D207374796C65735C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E20496E746572616374';
wwv_flow_imp.g_varchar2_table(4826) := '696F6E4576656E7473286576656E744275732C20656C656D656E7452656769737472792C207374796C657329207B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E20202F2A2A5C6E2020202A204669726520616E20696E746572616374';
wwv_flow_imp.g_varchar2_table(4827) := '696F6E206576656E742E5C6E2020202A5C6E2020202A2040706172616D207B737472696E677D2074797065206C6F63616C206576656E74206E616D652C20652E672E20656C656D656E742E636C69636B2E5C6E2020202A2040706172616D207B4D6F7573';
wwv_flow_imp.g_varchar2_table(4828) := '654576656E747C546F7563684576656E747D206576656E74206E6174697665206576656E745C6E2020202A2040706172616D207B456C656D656E747D205B656C656D656E745D20746865206469616772616D20656C656D656E7420746F20656D69742074';
wwv_flow_imp.g_varchar2_table(4829) := '6865206576656E74206F6E3B5C6E2020202A202020202020202020202020202020202020202020202020202020202020202020202064656661756C747320746F20746865206576656E74207461726765745C6E2020202A2F5C6E202066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(4830) := '206669726528747970652C206576656E742C20656C656D656E7429207B5C6E5C6E2020202069662028697349676E6F72656428747970652C206576656E742929207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E2020202076617220';
wwv_flow_imp.g_varchar2_table(4831) := '7461726765742C206766782C2072657475726E56616C75653B5C6E5C6E202020206966202821656C656D656E7429207B5C6E202020202020746172676574203D206576656E742E64656C6567617465546172676574207C7C206576656E742E7461726765';
wwv_flow_imp.g_varchar2_table(4832) := '743B5C6E5C6E2020202020206966202874617267657429207B5C6E2020202020202020676678203D207461726765743B5C6E2020202020202020656C656D656E74203D20656C656D656E7452656769737472792E67657428676678293B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(4833) := '207D5C6E202020207D20656C7365207B5C6E202020202020676678203D20656C656D656E7452656769737472792E676574477261706869637328656C656D656E74293B5C6E202020207D5C6E5C6E202020206966202821676678207C7C2021656C656D65';
wwv_flow_imp.g_varchar2_table(4834) := '6E7429207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E2020202072657475726E56616C7565203D206576656E744275732E6669726528747970652C207B5C6E202020202020656C656D656E743A20656C656D656E742C5C6E202020';
wwv_flow_imp.g_varchar2_table(4835) := '2020206766783A206766782C5C6E2020202020206F726967696E616C4576656E743A206576656E745C6E202020207D293B5C6E5C6E202020206966202872657475726E56616C7565203D3D3D2066616C736529207B5C6E2020202020206576656E742E73';
wwv_flow_imp.g_varchar2_table(4836) := '746F7050726F7061676174696F6E28293B5C6E2020202020206576656E742E70726576656E7444656661756C7428293B5C6E202020207D5C6E20207D5C6E5C6E20202F2F20544F444F286E696B6B75293A20646F63756D656E7420746869735C6E202076';
wwv_flow_imp.g_varchar2_table(4837) := '61722068616E646C657273203D207B7D3B5C6E5C6E202066756E6374696F6E206D6F75736548616E646C6572286C6F63616C4576656E744E616D6529207B5C6E2020202072657475726E2068616E646C6572735B6C6F63616C4576656E744E616D655D3B';
wwv_flow_imp.g_varchar2_table(4838) := '5C6E20207D5C6E5C6E202066756E6374696F6E20697349676E6F726564286C6F63616C4576656E744E616D652C206576656E7429207B5C6E5C6E202020207661722066696C746572203D2069676E6F72656446696C746572735B6C6F63616C4576656E74';
wwv_flow_imp.g_varchar2_table(4839) := '4E616D655D207C7C2069735072696D617279427574746F6E3B5C6E5C6E202020202F2F206F6E6C79207265616374206F6E206C656674206D6F75736520627574746F6E20696E746572616374696F6E735C6E202020202F2F2065786365707420666F7220';
wwv_flow_imp.g_varchar2_table(4840) := '696E746572616374696F6E206576656E747320746861742061726520656E61626C65645C6E202020202F2F20666F7220736563756E64617279206D6F75736520627574746F6E5C6E2020202072657475726E202166696C746572286576656E74293B5C6E';
wwv_flow_imp.g_varchar2_table(4841) := '20207D5C6E5C6E20207661722062696E64696E6773203D207B5C6E20202020636C69636B3A2027656C656D656E742E636C69636B272C5C6E20202020636F6E746578746D656E753A2027656C656D656E742E636F6E746578746D656E75272C5C6E202020';
wwv_flow_imp.g_varchar2_table(4842) := '2064626C636C69636B3A2027656C656D656E742E64626C636C69636B272C5C6E202020206D6F757365646F776E3A2027656C656D656E742E6D6F757365646F776E272C5C6E202020206D6F7573656D6F76653A2027656C656D656E742E6D6F7573656D6F';
wwv_flow_imp.g_varchar2_table(4843) := '7665272C5C6E202020206D6F7573656F7665723A2027656C656D656E742E686F766572272C5C6E202020206D6F7573656F75743A2027656C656D656E742E6F7574272C5C6E202020206D6F75736575703A2027656C656D656E742E6D6F7573657570272C';
wwv_flow_imp.g_varchar2_table(4844) := '5C6E20207D3B5C6E5C6E20207661722069676E6F72656446696C74657273203D207B5C6E2020202027656C656D656E742E636F6E746578746D656E75273A20616C6C6F77416C6C2C5C6E2020202027656C656D656E742E6D6F757365646F776E273A2061';
wwv_flow_imp.g_varchar2_table(4845) := '6C6C6F775072696D617279416E64417578696C696172792C5C6E2020202027656C656D656E742E6D6F7573657570273A20616C6C6F775072696D617279416E64417578696C696172792C5C6E2020202027656C656D656E742E636C69636B273A20616C6C';
wwv_flow_imp.g_varchar2_table(4846) := '6F775072696D617279416E64417578696C696172792C5C6E2020202027656C656D656E742E64626C636C69636B273A20616C6C6F775072696D617279416E64417578696C696172795C6E20207D3B5C6E5C6E5C6E20202F2F206D616E75616C206576656E';
wwv_flow_imp.g_varchar2_table(4847) := '742074726967676572202F2F2F2F2F2F2F2F2F2F5C6E5C6E20202F2A2A5C6E2020202A205472696767657220616E20696E746572616374696F6E206576656E7420286261736564206F6E2061206E617469766520646F6D206576656E74295C6E2020202A';
wwv_flow_imp.g_varchar2_table(4848) := '206F6E2074686520746172676574207368617065206F7220636F6E6E656374696F6E2E5C6E2020202A5C6E2020202A2040706172616D207B737472696E677D206576656E744E616D6520746865206E616D65206F66207468652074726967676572656420';
wwv_flow_imp.g_varchar2_table(4849) := '444F4D206576656E745C6E2020202A2040706172616D207B4D6F7573654576656E747C546F7563684576656E747D206576656E745C6E2020202A2040706172616D207B456C656D656E747D20746172676574456C656D656E745C6E2020202A2F5C6E2020';
wwv_flow_imp.g_varchar2_table(4850) := '66756E6374696F6E20747269676765724D6F7573654576656E74286576656E744E616D652C206576656E742C20746172676574456C656D656E7429207B5C6E5C6E202020202F2F20692E652E20656C656D656E742E6D6F757365646F776E2E2E2E5C6E20';
wwv_flow_imp.g_varchar2_table(4851) := '202020766172206C6F63616C4576656E744E616D65203D2062696E64696E67735B6576656E744E616D655D3B5C6E5C6E2020202069662028216C6F63616C4576656E744E616D6529207B5C6E2020202020207468726F77206E6577204572726F72282775';
wwv_flow_imp.g_varchar2_table(4852) := '6E6D617070656420444F4D206576656E74206E616D65203C27202B206576656E744E616D65202B20273E27293B5C6E202020207D5C6E5C6E2020202072657475726E2066697265286C6F63616C4576656E744E616D652C206576656E742C207461726765';
wwv_flow_imp.g_varchar2_table(4853) := '74456C656D656E74293B5C6E20207D5C6E5C6E5C6E202076617220454C454D454E545F53454C4543544F52203D20277376672C202E646A732D656C656D656E74273B5C6E5C6E20202F2F206576656E742068616E646C696E67202F2F2F2F2F2F2F5C6E5C';
wwv_flow_imp.g_varchar2_table(4854) := '6E202066756E6374696F6E2072656769737465724576656E74286E6F64652C206576656E742C206C6F63616C4576656E742C2069676E6F72656446696C74657229207B5C6E5C6E202020207661722068616E646C6572203D2068616E646C6572735B6C6F';
wwv_flow_imp.g_varchar2_table(4855) := '63616C4576656E745D203D2066756E6374696F6E286576656E7429207B5C6E20202020202066697265286C6F63616C4576656E742C206576656E74293B5C6E202020207D3B5C6E5C6E202020206966202869676E6F72656446696C74657229207B5C6E20';
wwv_flow_imp.g_varchar2_table(4856) := '202020202069676E6F72656446696C746572735B6C6F63616C4576656E745D203D2069676E6F72656446696C7465723B5C6E202020207D5C6E5C6E2020202068616E646C65722E2464656C6567617465203D20646F6D44656C65676174652E62696E6428';
wwv_flow_imp.g_varchar2_table(4857) := '6E6F64652C20454C454D454E545F53454C4543544F522C206576656E742C2068616E646C6572293B5C6E20207D5C6E5C6E202066756E6374696F6E20756E72656769737465724576656E74286E6F64652C206576656E742C206C6F63616C4576656E7429';
wwv_flow_imp.g_varchar2_table(4858) := '207B5C6E5C6E202020207661722068616E646C6572203D206D6F75736548616E646C6572286C6F63616C4576656E74293B5C6E5C6E20202020696620282168616E646C657229207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(4859) := '2020646F6D44656C65676174652E756E62696E64286E6F64652C206576656E742C2068616E646C65722E2464656C6567617465293B5C6E20207D5C6E5C6E202066756E6374696F6E2072656769737465724576656E74732873766729207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(4860) := '666F72456163682862696E64696E67732C2066756E6374696F6E2876616C2C206B657929207B5C6E20202020202072656769737465724576656E74287376672C206B65792C2076616C293B5C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374';
wwv_flow_imp.g_varchar2_table(4861) := '696F6E20756E72656769737465724576656E74732873766729207B5C6E20202020666F72456163682862696E64696E67732C2066756E6374696F6E2876616C2C206B657929207B5C6E202020202020756E72656769737465724576656E74287376672C20';
wwv_flow_imp.g_varchar2_table(4862) := '6B65792C2076616C293B5C6E202020207D293B5C6E20207D5C6E5C6E20206576656E744275732E6F6E282763616E7661732E64657374726F79272C2066756E6374696F6E286576656E7429207B5C6E20202020756E72656769737465724576656E747328';
wwv_flow_imp.g_varchar2_table(4863) := '6576656E742E737667293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E282763616E7661732E696E6974272C2066756E6374696F6E286576656E7429207B5C6E2020202072656769737465724576656E7473286576656E742E737667293B';
wwv_flow_imp.g_varchar2_table(4864) := '5C6E20207D293B5C6E5C6E5C6E20202F2F2068697420626F78207570646174696E67202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E20206576656E744275732E6F6E285B202773686170652E6164646564272C2027636F6E6E656374696F6E2E6164';
wwv_flow_imp.g_varchar2_table(4865) := '64656427205D2C2066756E6374696F6E286576656E7429207B5C6E2020202076617220656C656D656E74203D206576656E742E656C656D656E742C5C6E2020202020202020676678203D206576656E742E6766783B5C6E5C6E202020206576656E744275';
wwv_flow_imp.g_varchar2_table(4866) := '732E666972652827696E746572616374696F6E4576656E74732E637265617465486974272C207B20656C656D656E743A20656C656D656E742C206766783A20676678207D293B5C6E20207D293B5C6E5C6E20202F2F2055706461746520646A732D686974';
wwv_flow_imp.g_varchar2_table(4867) := '206F6E206368616E67652E5C6E20202F2F2041206C6F77207072696F7274697479206973206E65636573736172792C206265636175736520646A732D686974206F66206C6162656C732068617320746F20626520757064617465645C6E20202F2F206166';
wwv_flow_imp.g_varchar2_table(4868) := '74657220746865206C6162656C20626F756E64732068617665206265656E207570646174656420696E207468652072656E64657265722E5C6E20206576656E744275732E6F6E285B5C6E202020202773686170652E6368616E676564272C5C6E20202020';
wwv_flow_imp.g_varchar2_table(4869) := '27636F6E6E656374696F6E2E6368616E676564275C6E20205D2C204C4F575F5052494F524954592C2066756E6374696F6E286576656E7429207B5C6E5C6E2020202076617220656C656D656E74203D206576656E742E656C656D656E742C5C6E20202020';
wwv_flow_imp.g_varchar2_table(4870) := '20202020676678203D206576656E742E6766783B5C6E5C6E202020206576656E744275732E666972652827696E746572616374696F6E4576656E74732E757064617465486974272C207B20656C656D656E743A20656C656D656E742C206766783A206766';
wwv_flow_imp.g_varchar2_table(4871) := '78207D293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E2827696E746572616374696F6E4576656E74732E637265617465486974272C204C4F575F5052494F524954592C2066756E6374696F6E286576656E7429207B5C6E202020207661';
wwv_flow_imp.g_varchar2_table(4872) := '7220656C656D656E74203D206576656E742E656C656D656E742C5C6E2020202020202020676678203D206576656E742E6766783B5C6E5C6E2020202073656C662E63726561746544656661756C7448697428656C656D656E742C20676678293B5C6E2020';
wwv_flow_imp.g_varchar2_table(4873) := '7D293B5C6E5C6E20206576656E744275732E6F6E2827696E746572616374696F6E4576656E74732E757064617465486974272C2066756E6374696F6E286576656E7429207B5C6E2020202076617220656C656D656E74203D206576656E742E656C656D65';
wwv_flow_imp.g_varchar2_table(4874) := '6E742C5C6E2020202020202020676678203D206576656E742E6766783B5C6E5C6E2020202073656C662E75706461746544656661756C7448697428656C656D656E742C20676678293B5C6E20207D293B5C6E5C6E5C6E20202F2F20686974207374796C65';
wwv_flow_imp.g_varchar2_table(4875) := '73202F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E2020766172205354524F4B455F4849545F5354594C45203D206372656174654869745374796C652827646A732D68697420646A732D6869742D7374726F6B6527293B5C6E5C6E202076617220434C49434B5F';
wwv_flow_imp.g_varchar2_table(4876) := '5354524F4B455F4849545F5354594C45203D206372656174654869745374796C652827646A732D68697420646A732D6869742D636C69636B2D7374726F6B6527293B5C6E5C6E202076617220414C4C5F4849545F5354594C45203D206372656174654869';
wwv_flow_imp.g_varchar2_table(4877) := '745374796C652827646A732D68697420646A732D6869742D616C6C27293B5C6E5C6E2020766172204E4F5F4D4F56455F4849545F5354594C45203D206372656174654869745374796C652827646A732D68697420646A732D6869742D6E6F2D6D6F766527';
wwv_flow_imp.g_varchar2_table(4878) := '293B5C6E5C6E2020766172204849545F5459504553203D207B5C6E2020202027616C6C273A20414C4C5F4849545F5354594C452C5C6E2020202027636C69636B2D7374726F6B65273A20434C49434B5F5354524F4B455F4849545F5354594C452C5C6E20';
wwv_flow_imp.g_varchar2_table(4879) := '202020277374726F6B65273A205354524F4B455F4849545F5354594C452C5C6E20202020276E6F2D6D6F7665273A204E4F5F4D4F56455F4849545F5354594C455C6E20207D3B5C6E5C6E202066756E6374696F6E206372656174654869745374796C6528';
wwv_flow_imp.g_varchar2_table(4880) := '636C6173734E616D65732C20617474727329207B5C6E5C6E202020206174747273203D2061737369676E287B5C6E2020202020207374726F6B653A20277768697465272C5C6E2020202020207374726F6B6557696474683A2031355C6E202020207D2C20';
wwv_flow_imp.g_varchar2_table(4881) := '6174747273207C7C207B7D293B5C6E5C6E2020202072657475726E207374796C65732E636C7328636C6173734E616D65732C205B20276E6F2D66696C6C272C20276E6F2D626F7264657227205D2C206174747273293B5C6E20207D5C6E5C6E5C6E20202F';
wwv_flow_imp.g_varchar2_table(4882) := '2F207374796C652068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E202066756E6374696F6E206170706C795374796C65286869742C207479706529207B5C6E5C6E20202020766172206174747273203D204849545F54595045535B74';
wwv_flow_imp.g_varchar2_table(4883) := '7970655D3B5C6E5C6E202020206966202821617474727329207B5C6E2020202020207468726F77206E6577204572726F722827696E76616C6964206869742074797065203C27202B2074797065202B20273E27293B5C6E202020207D5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(4884) := '73766741747472286869742C206174747273293B5C6E5C6E2020202072657475726E206869743B5C6E20207D5C6E5C6E202066756E6374696F6E20617070656E64486974286766782C2068697429207B5C6E20202020737667417070656E64286766782C';
wwv_flow_imp.g_varchar2_table(4885) := '20686974293B5C6E20207D5C6E5C6E5C6E20202F2F204150495C6E5C6E20202F2A2A5C6E2020202A2052656D6F76652068696E7473206F6E2074686520676976656E2067726170686963732E5C6E2020202A5C6E2020202A2040706172616D207B535647';
wwv_flow_imp.g_varchar2_table(4886) := '456C656D656E747D206766785C6E2020202A2F5C6E2020746869732E72656D6F766548697473203D2066756E6374696F6E2867667829207B5C6E202020207661722068697473203D20646F6D5175657279416C6C28272E646A732D686974272C20676678';
wwv_flow_imp.g_varchar2_table(4887) := '293B5C6E5C6E20202020666F724561636828686974732C2073766752656D6F7665293B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A204372656174652064656661756C742068697420666F722074686520676976656E20656C656D656E742E5C6E';
wwv_flow_imp.g_varchar2_table(4888) := '2020202A5C6E2020202A2040706172616D207B456C656D656E747D20656C656D656E745C6E2020202A2040706172616D207B535647456C656D656E747D206766785C6E2020202A5C6E2020202A204072657475726E207B535647456C656D656E747D2063';
wwv_flow_imp.g_varchar2_table(4889) := '726561746564206869745C6E2020202A2F5C6E2020746869732E63726561746544656661756C74486974203D2066756E6374696F6E28656C656D656E742C2067667829207B5C6E2020202076617220776179706F696E7473203D20656C656D656E742E77';
wwv_flow_imp.g_varchar2_table(4890) := '6179706F696E74732C5C6E202020202020202069734672616D65203D20656C656D656E742E69734672616D652C5C6E2020202020202020626F78547970653B5C6E5C6E2020202069662028776179706F696E747329207B5C6E2020202020207265747572';
wwv_flow_imp.g_varchar2_table(4891) := '6E20746869732E637265617465576179706F696E7473486974286766782C20776179706F696E7473293B5C6E202020207D20656C7365207B5C6E5C6E202020202020626F7854797065203D2069734672616D65203F20277374726F6B6527203A2027616C';
wwv_flow_imp.g_varchar2_table(4892) := '6C273B5C6E5C6E20202020202072657475726E20746869732E637265617465426F78486974286766782C20626F78547970652C207B5C6E202020202020202077696474683A20656C656D656E742E77696474682C5C6E2020202020202020686569676874';
wwv_flow_imp.g_varchar2_table(4893) := '3A20656C656D656E742E6865696768745C6E2020202020207D293B5C6E202020207D5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A20437265617465206869747320666F722074686520676976656E20776179706F696E74732E5C6E2020202A5C6E';
wwv_flow_imp.g_varchar2_table(4894) := '2020202A2040706172616D207B535647456C656D656E747D206766785C6E2020202A2040706172616D207B506F696E745B5D7D20776179706F696E74735C6E2020202A5C6E2020202A204072657475726E207B535647456C656D656E747D5C6E2020202A';
wwv_flow_imp.g_varchar2_table(4895) := '2F5C6E2020746869732E637265617465576179706F696E7473486974203D2066756E6374696F6E286766782C20776179706F696E747329207B5C6E5C6E2020202076617220686974203D206372656174654C696E6528776179706F696E7473293B5C6E5C';
wwv_flow_imp.g_varchar2_table(4896) := '6E202020206170706C795374796C65286869742C20277374726F6B6527293B5C6E5C6E20202020617070656E64486974286766782C20686974293B5C6E5C6E2020202072657475726E206869743B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A20';
wwv_flow_imp.g_varchar2_table(4897) := '437265617465206869747320666F72206120626F782E5C6E2020202A5C6E2020202A2040706172616D207B535647456C656D656E747D206766785C6E2020202A2040706172616D207B737472696E677D20747970655C6E2020202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(4898) := '4F626A6563747D2061747472735C6E2020202A5C6E2020202A204072657475726E207B535647456C656D656E747D5C6E2020202A2F5C6E2020746869732E637265617465426F78486974203D2066756E6374696F6E286766782C20747970652C20617474';
wwv_flow_imp.g_varchar2_table(4899) := '727329207B5C6E5C6E202020206174747273203D2061737369676E287B5C6E202020202020783A20302C5C6E202020202020793A20305C6E202020207D2C206174747273293B5C6E5C6E2020202076617220686974203D20737667437265617465282772';
wwv_flow_imp.g_varchar2_table(4900) := '65637427293B5C6E5C6E202020206170706C795374796C65286869742C2074797065293B5C6E5C6E2020202073766741747472286869742C206174747273293B5C6E5C6E20202020617070656E64486974286766782C20686974293B5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(4901) := '72657475726E206869743B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A205570646174652064656661756C7420686974206F662074686520656C656D656E742E5C6E2020202A5C6E2020202A2040706172616D207B456C656D656E747D20656C65';
wwv_flow_imp.g_varchar2_table(4902) := '6D656E745C6E2020202A2040706172616D207B535647456C656D656E747D206766785C6E2020202A5C6E2020202A204072657475726E207B535647456C656D656E747D2075706461746564206869745C6E2020202A2F5C6E2020746869732E7570646174';
wwv_flow_imp.g_varchar2_table(4903) := '6544656661756C74486974203D2066756E6374696F6E28656C656D656E742C2067667829207B5C6E5C6E2020202076617220686974203D20646F6D517565727928272E646A732D686974272C20676678293B5C6E5C6E2020202069662028216869742920';
wwv_flow_imp.g_varchar2_table(4904) := '7B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E2020202069662028656C656D656E742E776179706F696E747329207B5C6E2020202020207570646174654C696E65286869742C20656C656D656E742E776179706F696E7473293B5C6E';
wwv_flow_imp.g_varchar2_table(4905) := '202020207D20656C7365207B5C6E20202020202073766741747472286869742C207B5C6E202020202020202077696474683A20656C656D656E742E77696474682C5C6E20202020202020206865696768743A20656C656D656E742E6865696768745C6E20';
wwv_flow_imp.g_varchar2_table(4906) := '20202020207D293B5C6E202020207D5C6E5C6E2020202072657475726E206869743B5C6E20207D3B5C6E5C6E2020746869732E66697265203D20666972653B5C6E5C6E2020746869732E747269676765724D6F7573654576656E74203D20747269676765';
wwv_flow_imp.g_varchar2_table(4907) := '724D6F7573654576656E743B5C6E5C6E2020746869732E6D6F75736548616E646C6572203D206D6F75736548616E646C65723B5C6E5C6E2020746869732E72656769737465724576656E74203D2072656769737465724576656E743B5C6E202074686973';
wwv_flow_imp.g_varchar2_table(4908) := '2E756E72656769737465724576656E74203D20756E72656769737465724576656E743B5C6E7D5C6E5C6E5C6E496E746572616374696F6E4576656E74732E24696E6A656374203D205B5C6E2020276576656E74427573272C5C6E202027656C656D656E74';
wwv_flow_imp.g_varchar2_table(4909) := '5265676973747279272C5C6E2020277374796C6573275C6E5D3B5C6E5C6E5C6E2F2A2A5C6E202A20416E206576656E7420696E6469636174696E67207468617420746865206D6F75736520686F7665726564206F76657220616E20656C656D656E745C6E';
wwv_flow_imp.g_varchar2_table(4910) := '202A5C6E202A20406576656E7420656C656D656E742E686F7665725C6E202A5C6E202A204074797065207B4F626A6563747D5C6E202A204070726F7065727479207B456C656D656E747D20656C656D656E745C6E202A204070726F7065727479207B5356';
wwv_flow_imp.g_varchar2_table(4911) := '47456C656D656E747D206766785C6E202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A20416E206576656E7420696E6469636174696E67207468617420746865206D6F757365';
wwv_flow_imp.g_varchar2_table(4912) := '20686173206C65667420616E20656C656D656E745C6E202A5C6E202A20406576656E7420656C656D656E742E6F75745C6E202A5C6E202A204074797065207B4F626A6563747D5C6E202A204070726F7065727479207B456C656D656E747D20656C656D65';
wwv_flow_imp.g_varchar2_table(4913) := '6E745C6E202A204070726F7065727479207B535647456C656D656E747D206766785C6E202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A20416E206576656E7420696E646963';
wwv_flow_imp.g_varchar2_table(4914) := '6174696E67207468617420746865206D6F7573652068617320636C69636B656420616E20656C656D656E745C6E202A5C6E202A20406576656E7420656C656D656E742E636C69636B5C6E202A5C6E202A204074797065207B4F626A6563747D5C6E202A20';
wwv_flow_imp.g_varchar2_table(4915) := '4070726F7065727479207B456C656D656E747D20656C656D656E745C6E202A204070726F7065727479207B535647456C656D656E747D206766785C6E202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E745C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(4916) := '6E5C6E2F2A2A5C6E202A20416E206576656E7420696E6469636174696E67207468617420746865206D6F7573652068617320646F75626C6520636C69636B656420616E20656C656D656E745C6E202A5C6E202A20406576656E7420656C656D656E742E64';
wwv_flow_imp.g_varchar2_table(4917) := '626C636C69636B5C6E202A5C6E202A204074797065207B4F626A6563747D5C6E202A204070726F7065727479207B456C656D656E747D20656C656D656E745C6E202A204070726F7065727479207B535647456C656D656E747D206766785C6E202A204070';
wwv_flow_imp.g_varchar2_table(4918) := '726F7065727479207B4576656E747D206F726967696E616C4576656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A20416E206576656E7420696E6469636174696E67207468617420746865206D6F7573652068617320676F6E6520646F776E206F6E20616E';
wwv_flow_imp.g_varchar2_table(4919) := '20656C656D656E742E5C6E202A5C6E202A20406576656E7420656C656D656E742E6D6F757365646F776E5C6E202A5C6E202A204074797065207B4F626A6563747D5C6E202A204070726F7065727479207B456C656D656E747D20656C656D656E745C6E20';
wwv_flow_imp.g_varchar2_table(4920) := '2A204070726F7065727479207B535647456C656D656E747D206766785C6E202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A20416E206576656E7420696E6469636174696E67';
wwv_flow_imp.g_varchar2_table(4921) := '207468617420746865206D6F7573652068617320676F6E65207570206F6E20616E20656C656D656E742E5C6E202A5C6E202A20406576656E7420656C656D656E742E6D6F75736575705C6E202A5C6E202A204074797065207B4F626A6563747D5C6E202A';
wwv_flow_imp.g_varchar2_table(4922) := '204070726F7065727479207B456C656D656E747D20656C656D656E745C6E202A204070726F7065727479207B535647456C656D656E747D206766785C6E202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E745C6E202A2F';
wwv_flow_imp.g_varchar2_table(4923) := '5C6E5C6E2F2A2A5C6E202A20416E206576656E7420696E6469636174696E6720746861742074686520636F6E74657874206D656E7520616374696F6E206973207472696767657265645C6E202A20766961206D6F757365206F7220746F75636820636F6E';
wwv_flow_imp.g_varchar2_table(4924) := '74726F6C732E5C6E202A5C6E202A20406576656E7420656C656D656E742E636F6E746578746D656E755C6E202A5C6E202A204074797065207B4F626A6563747D5C6E202A204070726F7065727479207B456C656D656E747D20656C656D656E745C6E202A';
wwv_flow_imp.g_varchar2_table(4925) := '204070726F7065727479207B535647456C656D656E747D206766785C6E202A204070726F7065727479207B4576656E747D206F726967696E616C4576656E745C6E202A2F222C22696D706F727420496E746572616374696F6E4576656E74732066726F6D';
wwv_flow_imp.g_varchar2_table(4926) := '20272E2F496E746572616374696F6E4576656E7473273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D5C6E202A2F5C6E6578706F72742064656661756C74';
wwv_flow_imp.g_varchar2_table(4927) := '207B5C6E20205F5F696E69745F5F3A205B2027696E746572616374696F6E4576656E747327205D2C5C6E2020696E746572616374696F6E4576656E74733A205B202774797065272C20496E746572616374696F6E4576656E7473205D5C6E7D3B222C2269';
wwv_flow_imp.g_varchar2_table(4928) := '6D706F7274207B2067657442426F78207D2066726F6D20272E2E2F2E2E2F7574696C2F456C656D656E7473273B5C6E5C6E766172204C4F575F5052494F52495459203D203530303B5C6E5C6E696D706F7274207B5C6E2020617070656E64206173207376';
wwv_flow_imp.g_varchar2_table(4929) := '67417070656E642C5C6E20206174747220617320737667417474722C5C6E2020637265617465206173207376674372656174655C6E7D2066726F6D202774696E792D737667273B5C6E5C6E696D706F7274207B5C6E2020717565727920617320646F6D51';
wwv_flow_imp.g_varchar2_table(4930) := '756572795C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E696D706F7274207B5C6E202061737369676E2C5C6E2020666F72456163682C5C6E2020697346756E6374696F6E5C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E76617220';
wwv_flow_imp.g_varchar2_table(4931) := '44454641554C545F5052494F52495459203D20313030303B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E745C6E202A5C6E202A2040';
wwv_flow_imp.g_varchar2_table(4932) := '74797065646566207B696D706F727428272E2F4F75746C696E6550726F766964657227292E64656661756C747D204F75746C696E6550726F76696465725C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E74';
wwv_flow_imp.g_varchar2_table(4933) := '42757327292E64656661756C747D204576656E744275735C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F647261772F5374796C657327292E64656661756C747D205374796C65735C6E202A2F5C6E5C6E2F2A2A5C6E202A204063';
wwv_flow_imp.g_varchar2_table(4934) := '6C6173735C6E202A5C6E202A204120706C7567696E2074686174206164647320616E206F75746C696E6520746F2073686170657320616E6420636F6E6E656374696F6E732074686174206D61792062652061637469766174656420616E64207374796C65';
wwv_flow_imp.g_varchar2_table(4935) := '645C6E202A207669612043535320636C61737365732E5C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B5374796C65737D207374796C65735C6E202A2F5C6E6578706F7274206465';
wwv_flow_imp.g_varchar2_table(4936) := '6661756C742066756E6374696F6E204F75746C696E65286576656E744275732C207374796C657329207B5C6E5C6E2020746869732E5F6576656E74427573203D206576656E744275733B5C6E5C6E2020746869732E6F6666736574203D20353B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(4937) := '2020766172204F55544C494E455F5354594C45203D207374796C65732E636C732827646A732D6F75746C696E65272C205B20276E6F2D66696C6C27205D293B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E20202F2A2A5C6E2020202A';
wwv_flow_imp.g_varchar2_table(4938) := '2040706172616D207B535647456C656D656E747D206766785C6E2020202A5C6E2020202A204072657475726E207B535647456C656D656E747D206F75746C696E655C6E2020202A2F5C6E202066756E6374696F6E206372656174654F75746C696E652867';
wwv_flow_imp.g_varchar2_table(4939) := '667829207B5C6E20202020766172206F75746C696E65203D2073766743726561746528277265637427293B5C6E5C6E2020202073766741747472286F75746C696E652C2061737369676E287B5C6E202020202020783A20302C5C6E202020202020793A20';
wwv_flow_imp.g_varchar2_table(4940) := '302C5C6E20202020202072783A20342C5C6E20202020202077696474683A203130302C5C6E2020202020206865696768743A203130305C6E202020207D2C204F55544C494E455F5354594C4529293B5C6E5C6E2020202072657475726E206F75746C696E';
wwv_flow_imp.g_varchar2_table(4941) := '653B5C6E20207D5C6E5C6E20202F2F2041206C6F77207072696F7274697479206973206E65636573736172792C2062656361757365206F75746C696E6573206F66206C6162656C73206861766520746F20626520757064617465645C6E20202F2F206166';
wwv_flow_imp.g_varchar2_table(4942) := '74657220746865206C6162656C20626F756E64732068617665206265656E207570646174656420696E207468652072656E64657265722E5C6E20206576656E744275732E6F6E285B202773686170652E6164646564272C202773686170652E6368616E67';
wwv_flow_imp.g_varchar2_table(4943) := '656427205D2C204C4F575F5052494F524954592C2066756E6374696F6E286576656E7429207B5C6E2020202076617220656C656D656E74203D206576656E742E656C656D656E742C5C6E2020202020202020676678203D206576656E742E6766783B5C6E';
wwv_flow_imp.g_varchar2_table(4944) := '5C6E20202020766172206F75746C696E65203D20646F6D517565727928272E646A732D6F75746C696E65272C20676678293B5C6E5C6E2020202069662028216F75746C696E6529207B5C6E2020202020206F75746C696E65203D2073656C662E6765744F';
wwv_flow_imp.g_varchar2_table(4945) := '75746C696E6528656C656D656E7429207C7C206372656174654F75746C696E6528676678293B5C6E202020202020737667417070656E64286766782C206F75746C696E65293B5C6E202020207D5C6E5C6E2020202073656C662E75706461746553686170';
wwv_flow_imp.g_varchar2_table(4946) := '654F75746C696E65286F75746C696E652C20656C656D656E74293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E285B2027636F6E6E656374696F6E2E6164646564272C2027636F6E6E656374696F6E2E6368616E67656427205D2C206675';
wwv_flow_imp.g_varchar2_table(4947) := '6E6374696F6E286576656E7429207B5C6E2020202076617220656C656D656E74203D206576656E742E656C656D656E742C5C6E2020202020202020676678203D206576656E742E6766783B5C6E5C6E20202020766172206F75746C696E65203D20646F6D';
wwv_flow_imp.g_varchar2_table(4948) := '517565727928272E646A732D6F75746C696E65272C20676678293B5C6E5C6E2020202069662028216F75746C696E6529207B5C6E2020202020206F75746C696E65203D206372656174654F75746C696E6528676678293B5C6E2020202020207376674170';
wwv_flow_imp.g_varchar2_table(4949) := '70656E64286766782C206F75746C696E65293B5C6E202020207D5C6E5C6E2020202073656C662E757064617465436F6E6E656374696F6E4F75746C696E65286F75746C696E652C20656C656D656E74293B5C6E20207D293B5C6E7D5C6E5C6E5C6E2F2A2A';
wwv_flow_imp.g_varchar2_table(4950) := '5C6E202A205570646174657320746865206F75746C696E65206F6620612073686170652072657370656374696E67207468652064696D656E73696F6E206F66207468655C6E202A20656C656D656E7420616E6420616E206F75746C696E65206F66667365';
wwv_flow_imp.g_varchar2_table(4951) := '742E5C6E202A5C6E202A2040706172616D207B535647456C656D656E747D206F75746C696E655C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A2F5C6E4F75746C696E652E70726F746F747970652E7570646174655368';
wwv_flow_imp.g_varchar2_table(4952) := '6170654F75746C696E65203D2066756E6374696F6E286F75746C696E652C20656C656D656E7429207B5C6E5C6E20207661722075706461746564203D2066616C73653B5C6E20207661722070726F766964657273203D20746869732E5F67657450726F76';
wwv_flow_imp.g_varchar2_table(4953) := '696465727328293B5C6E5C6E20206966202870726F7669646572732E6C656E67746829207B5C6E20202020666F72456163682870726F7669646572732C2066756E6374696F6E2870726F766964657229207B5C6E20202020202075706461746564203D20';
wwv_flow_imp.g_varchar2_table(4954) := '75706461746564207C7C2070726F76696465722E7570646174654F75746C696E6528656C656D656E742C206F75746C696E65293B5C6E202020207D293B5C6E20207D5C6E5C6E202069662028217570646174656429207B5C6E2020202073766741747472';
wwv_flow_imp.g_varchar2_table(4955) := '286F75746C696E652C207B5C6E202020202020783A202D746869732E6F66667365742C5C6E202020202020793A202D746869732E6F66667365742C5C6E20202020202077696474683A20656C656D656E742E7769647468202B20746869732E6F66667365';
wwv_flow_imp.g_varchar2_table(4956) := '74202A20322C5C6E2020202020206865696768743A20656C656D656E742E686569676874202B20746869732E6F6666736574202A20325C6E202020207D293B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A205570646174657320746865206F75746C';
wwv_flow_imp.g_varchar2_table(4957) := '696E65206F66206120636F6E6E656374696F6E2072657370656374696E672074686520626F756E64696E6720626F78206F665C6E202A2074686520636F6E6E656374696F6E20616E6420616E206F75746C696E65206F66667365742E5C6E202A20526567';
wwv_flow_imp.g_varchar2_table(4958) := '697374657220616E206F75746C696E652070726F766964657220776974682074686520676976656E207072696F726974792E5C6E202A5C6E202A2040706172616D207B535647456C656D656E747D206F75746C696E655C6E202A2040706172616D207B45';
wwv_flow_imp.g_varchar2_table(4959) := '6C656D656E747D20636F6E6E656374696F6E5C6E202A2F5C6E4F75746C696E652E70726F746F747970652E757064617465436F6E6E656374696F6E4F75746C696E65203D2066756E6374696F6E286F75746C696E652C20636F6E6E656374696F6E29207B';
wwv_flow_imp.g_varchar2_table(4960) := '5C6E20207661722062626F78203D2067657442426F7828636F6E6E656374696F6E293B5C6E5C6E202073766741747472286F75746C696E652C207B5C6E20202020783A2062626F782E78202D20746869732E6F66667365742C5C6E20202020793A206262';
wwv_flow_imp.g_varchar2_table(4961) := '6F782E79202D20746869732E6F66667365742C5C6E2020202077696474683A2062626F782E7769647468202B20746869732E6F6666736574202A20322C5C6E202020206865696768743A2062626F782E686569676874202B20746869732E6F6666736574';
wwv_flow_imp.g_varchar2_table(4962) := '202A20325C6E20207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20526567697374657220616E206F75746C696E652070726F766964657220776974682074686520676976656E207072696F726974792E5C6E202A5C6E202A2040706172616D207B6E756D';
wwv_flow_imp.g_varchar2_table(4963) := '6265727D207072696F726974795C6E202A2040706172616D207B4F75746C696E6550726F76696465727D2070726F76696465725C6E202A2F5C6E4F75746C696E652E70726F746F747970652E726567697374657250726F7669646572203D2066756E6374';
wwv_flow_imp.g_varchar2_table(4964) := '696F6E287072696F726974792C2070726F766964657229207B5C6E2020696620282170726F766964657229207B5C6E2020202070726F7669646572203D207072696F726974793B5C6E202020207072696F72697479203D2044454641554C545F5052494F';
wwv_flow_imp.g_varchar2_table(4965) := '524954593B5C6E20207D5C6E5C6E2020746869732E5F6576656E744275732E6F6E28276F75746C696E652E67657450726F766964657273272C207072696F726974792C2066756E6374696F6E286576656E7429207B5C6E202020206576656E742E70726F';
wwv_flow_imp.g_varchar2_table(4966) := '7669646572732E707573682870726F7669646572293B5C6E20207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E73207468652072656769737465726564206F75746C696E652070726F7669646572732E5C6E202A5C6E202A204072657475';
wwv_flow_imp.g_varchar2_table(4967) := '726E73207B4F75746C696E6550726F76696465725B5D7D5C6E202A2F5C6E4F75746C696E652E70726F746F747970652E5F67657450726F766964657273203D2066756E6374696F6E2829207B5C6E2020766172206576656E74203D20746869732E5F6576';
wwv_flow_imp.g_varchar2_table(4968) := '656E744275732E6372656174654576656E74287B5C6E20202020747970653A20276F75746C696E652E67657450726F766964657273272C5C6E2020202070726F7669646572733A205B5D5C6E20207D293B5C6E5C6E2020746869732E5F6576656E744275';
wwv_flow_imp.g_varchar2_table(4969) := '732E66697265286576656E74293B5C6E5C6E202072657475726E206576656E742E70726F7669646572733B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E7320746865206F75746C696E6520666F7220616E20656C656D656E742E5C6E202A5C6E';
wwv_flow_imp.g_varchar2_table(4970) := '202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A2F5C6E4F75746C696E652E70726F746F747970652E6765744F75746C696E65203D2066756E6374696F6E28656C656D656E7429207B5C6E2020766172206F75746C696E653B';
wwv_flow_imp.g_varchar2_table(4971) := '5C6E20207661722070726F766964657273203D20746869732E5F67657450726F76696465727328293B5C6E5C6E2020666F72456163682870726F7669646572732C2066756E6374696F6E2870726F766964657229207B5C6E5C6E20202020696620282169';
wwv_flow_imp.g_varchar2_table(4972) := '7346756E6374696F6E2870726F76696465722E6765744F75746C696E652929207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E202020206F75746C696E65203D206F75746C696E65207C7C2070726F76696465722E6765744F75746C';
wwv_flow_imp.g_varchar2_table(4973) := '696E6528656C656D656E74293B5C6E20207D293B5C6E5C6E202072657475726E206F75746C696E653B5C6E7D3B5C6E5C6E4F75746C696E652E24696E6A656374203D205B20276576656E74427573272C20277374796C6573272C2027656C656D656E7452';
wwv_flow_imp.g_varchar2_table(4974) := '6567697374727927205D3B222C22696D706F7274204F75746C696E652066726F6D20272E2F4F75746C696E65273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E';
wwv_flow_imp.g_varchar2_table(4975) := '207D5C6E202A2F5C6E6578706F72742064656661756C74207B5C6E20205F5F696E69745F5F3A205B20276F75746C696E6527205D2C5C6E20206F75746C696E653A205B202774797065272C204F75746C696E65205D5C6E7D3B222C22696D706F7274207B';
wwv_flow_imp.g_varchar2_table(4976) := '5C6E2020697341727261792C5C6E20206973537472696E672C5C6E202069734F626A6563742C5C6E202061737369676E2C5C6E2020666F72456163682C5C6E202066696E642C5C6E202066696C7465722C5C6E20206D617463685061747465726E2C5C6E';
wwv_flow_imp.g_varchar2_table(4977) := '20206973446566696E65645C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E202061737369676E5374796C652C5C6E2020646F6D6966792C5C6E2020636C617373657320617320646F6D436C61737365732C5C6E2020';
wwv_flow_imp.g_varchar2_table(4978) := '6174747220617320646F6D417474722C5C6E202072656D6F766520617320646F6D52656D6F76652C5C6E2020636C65617220617320646F6D436C6561725C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E696D706F7274207B5C6E202067657442';
wwv_flow_imp.g_varchar2_table(4979) := '426F785C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F456C656D656E7473273B5C6E5C6E696D706F7274204964732066726F6D20272E2E2F2E2E2F7574696C2F496447656E657261746F72273B5C6E5C6E2F2F20646F63756D656E74207769646520';
wwv_flow_imp.g_varchar2_table(4980) := '756E69717565206F7665726C6179206964735C6E76617220696473203D206E65772049647328276F7627293B5C6E5C6E766172204C4F575F5052494F52495459203D203530303B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428';
wwv_flow_imp.g_varchar2_table(4981) := '272E2E2F2E2E2F636F72652F43616E76617327292E64656661756C747D2043616E7661735C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F456C656D656E74526567697374727927292E64656661756C747D20456C65';
wwv_flow_imp.g_varchar2_table(4982) := '6D656E7452656769737472795C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A5C6E202A204074797065646566207B696D706F727428';
wwv_flow_imp.g_varchar2_table(4983) := '272E2E2F2E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E745C6E202A5C6E202A204074797065646566207B207B5C6E202A2020206D696E5A6F6F6D3F3A206E756D6265722C5C6E202A2020206D61785A6F6F6D3F3A206E';
wwv_flow_imp.g_varchar2_table(4984) := '756D6265725C6E202A207D207D204F7665726C617973436F6E66696753686F775C6E202A5C6E202A204074797065646566207B207B5C6E202A2020206D696E3F3A206E756D6265722C5C6E202A2020206D61783F3A206E756D6265725C6E202A207D207D';
wwv_flow_imp.g_varchar2_table(4985) := '204F7665726C617973436F6E6669675363616C655C6E202A5C6E202A204074797065646566207B207B5C6E2A20202069643A20737472696E672C5C6E2A202020747970653A20737472696E67207C206E756C6C2C5C6E2A202020656C656D656E743A2045';
wwv_flow_imp.g_varchar2_table(4986) := '6C656D656E74207C20737472696E675C6E2A207D2026204F7665726C61794174747273207D204F7665726C61795C6E2A5C6E202A204074797065646566207B207B5C6E202A20202068746D6C3A2048544D4C456C656D656E74207C20737472696E672C5C';
wwv_flow_imp.g_varchar2_table(4987) := '6E202A202020706F736974696F6E3A207B5C6E202A2020202020746F703F3A206E756D6265722C5C6E202A202020202072696768743F3A206E756D6265722C5C6E202A2020202020626F74746F6D3F3A206E756D6265722C5C6E202A20202020206C6566';
wwv_flow_imp.g_varchar2_table(4988) := '743F3A206E756D6265725C6E202A2020207D5C6E202A207D2026204F7665726C617973436F6E66696744656661756C74207D204F7665726C617941747472735C6E202A5C6E202A204074797065646566207B207B5C6E202A20202068746D6C3A2048544D';
wwv_flow_imp.g_varchar2_table(4989) := '4C456C656D656E742C5C6E202A202020656C656D656E743A20456C656D656E742C5C6E202A2020206F7665726C6179733A204F7665726C61795B5D5C6E202A207D207D204F7665726C6179436F6E7461696E65725C6E202A5C6E202A2040747970656465';
wwv_flow_imp.g_varchar2_table(4990) := '66207B7B5C6E202A20202064656661756C74733F3A204F7665726C617973436F6E66696744656661756C745C6E202A207D7D204F7665726C617973436F6E6669675C6E202A5C6E202A204074797065646566207B207B5C6E202A202073686F773F3A204F';
wwv_flow_imp.g_varchar2_table(4991) := '7665726C617973436F6E66696753686F772C5C6E202A20207363616C653F3A204F7665726C617973436F6E6669675363616C65207C20626F6F6C65616E5C6E202A207D207D204F7665726C617973436F6E66696744656661756C745C6E202A5C6E202A20';
wwv_flow_imp.g_varchar2_table(4992) := '4074797065646566207B207B5C6E202A20202069643F3A20737472696E673B5C6E202A202020656C656D656E743F3A20456C656D656E74207C20737472696E673B5C6E202A202020747970653F3A20737472696E673B5C6E202A207D207C20737472696E';
wwv_flow_imp.g_varchar2_table(4993) := '67207D204F7665726C61797346696C7465725C6E202A2F5C6E5C6E2F2A2A5C6E202A20412073657276696365207468617420616C6C6F777320757365727320746F20617474616368206F7665726C61797320746F206469616772616D20656C656D656E74';
wwv_flow_imp.g_varchar2_table(4994) := '732E5C6E202A5C6E202A20546865206F7665726C617920736572766963652077696C6C2074616B652063617265206F66206F7665726C617920706F736974696F6E696E6720647572696E6720757064617465732E5C6E202A5C6E202A20406578616D706C';
wwv_flow_imp.g_varchar2_table(4995) := '655C6E202A5C6E202A206060606A6176617363726970745C6E202A202F2F2061646420612070696E6B206261646765206F6E2074686520746F70206C656674206F66207468652073686170655C6E202A5C6E202A206F7665726C6179732E61646428736F';
wwv_flow_imp.g_varchar2_table(4996) := '6D6553686170652C207B5C6E202A202020706F736974696F6E3A207B5C6E202A2020202020746F703A202D352C5C6E202A20202020206C6566743A202D355C6E202A2020207D2C5C6E202A20202068746D6C3A20273C646976207374796C653D5C227769';
wwv_flow_imp.g_varchar2_table(4997) := '6474683A20313070783B206261636B67726F756E643A20667563687369613B20636F6C6F723A2077686974653B5C223E303C2F6469763E275C6E202A207D293B5C6E202A5C6E202A202F2F206F7220616464207669612073686170652069645C6E202A5C';
wwv_flow_imp.g_varchar2_table(4998) := '6E202A206F7665726C6179732E6164642827736F6D652D656C656D656E742D6964272C207B5C6E202A202020706F736974696F6E3A207B5C6E202A2020202020746F703A202D352C5C6E202A20202020206C6566743A202D355C6E202A2020207D5C6E20';
wwv_flow_imp.g_varchar2_table(4999) := '2A20202068746D6C3A20273C646976207374796C653D5C2277696474683A20313070783B206261636B67726F756E643A20667563687369613B20636F6C6F723A2077686974653B5C223E303C2F6469763E275C6E202A207D293B5C6E202A5C6E202A202F';
wwv_flow_imp.g_varchar2_table(5000) := '2F206F72206164642077697468206F7074696F6E616C20747970655C6E202A5C6E202A206F7665726C6179732E61646428736F6D6553686170652C20276261646765272C207B5C6E202A202020706F736974696F6E3A207B5C6E202A2020202020746F70';
wwv_flow_imp.g_varchar2_table(5001) := '3A202D352C5C6E202A20202020206C6566743A202D355C6E202A2020207D5C6E202A20202068746D6C3A20273C646976207374796C653D5C2277696474683A20313070783B206261636B67726F756E643A20667563687369613B20636F6C6F723A207768';
wwv_flow_imp.g_varchar2_table(5002) := '6974653B5C223E303C2F6469763E275C6E202A207D293B5C6E202A206060605C6E202A5C6E202A206060606A6176617363726970745C6E202A202F2F2072656D6F766520616E206F7665726C61795C6E202A5C6E202A20766172206964203D206F766572';
wwv_flow_imp.g_varchar2_table(5003) := '6C6179732E616464282E2E2E293B5C6E202A206F7665726C6179732E72656D6F7665286964293B5C6E202A5C6E202A5C6E202A20596F75206D617920636F6E666967757265206F7665726C61792064656661756C747320647572696E6720746F6F6C2062';
wwv_flow_imp.g_varchar2_table(5004) := '792070726F766964696E6720612060636F6E66696760206D6F64756C655C6E202A207769746820606F7665726C6179732E64656661756C74736020617320616E20656E7472793A5C6E202A5C6E202A207B5C6E202A2020206F7665726C6179733A207B5C';
wwv_flow_imp.g_varchar2_table(5005) := '6E202A202020202064656661756C74733A207B5C6E202A2020202020202073686F773A207B5C6E202A2020202020202020206D696E5A6F6F6D3A20302E372C5C6E202A2020202020202020206D61785A6F6F6D3A20352E305C6E202A202020202020207D';
wwv_flow_imp.g_varchar2_table(5006) := '2C5C6E202A202020202020207363616C653A207B5C6E202A2020202020202020206D696E3A20315C6E202A202020202020207D5C6E202A20202020207D5C6E202A207D5C6E202A206060605C6E202A5C6E202A2040706172616D207B4F7665726C617973';
wwv_flow_imp.g_varchar2_table(5007) := '436F6E6669677D20636F6E6669675C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B43616E7661737D2063616E7661735C6E202A2040706172616D207B456C656D656E745265676973747279';
wwv_flow_imp.g_varchar2_table(5008) := '7D20656C656D656E7452656769737472795C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E204F7665726C61797328636F6E6669672C206576656E744275732C2063616E7661732C20656C656D656E7452656769737472792920';
wwv_flow_imp.g_varchar2_table(5009) := '7B5C6E2020746869732E5F6576656E74427573203D206576656E744275733B5C6E2020746869732E5F63616E766173203D2063616E7661733B5C6E2020746869732E5F656C656D656E745265676973747279203D20656C656D656E745265676973747279';
wwv_flow_imp.g_varchar2_table(5010) := '3B5C6E5C6E2020746869732E5F696473203D206964733B5C6E5C6E20202F2A2A5C6E2020202A204074797065207B4F7665726C617973436F6E66696744656661756C747D5C6E2020202A2F5C6E2020746869732E5F6F7665726C617944656661756C7473';
wwv_flow_imp.g_varchar2_table(5011) := '203D2061737369676E287B5C6E5C6E202020202F2F206E6F2073686F7720636F6E73747261696E74735C6E2020202073686F773A206E756C6C2C5C6E5C6E202020202F2F20616C77617973207363616C655C6E202020207363616C653A20747275655C6E';
wwv_flow_imp.g_varchar2_table(5012) := '20207D2C20636F6E66696720262620636F6E6669672E64656661756C7473293B5C6E5C6E20202F2A2A5C6E2020202A204074797065207B5265636F72643C737472696E672C204F7665726C61793E7D5C6E2020202A2F5C6E2020746869732E5F6F766572';
wwv_flow_imp.g_varchar2_table(5013) := '6C617973203D207B7D3B5C6E5C6E20202F2A2A5C6E2020202A204074797065207B4F7665726C6179436F6E7461696E65725B5D7D5C6E2020202A2F5C6E2020746869732E5F6F7665726C6179436F6E7461696E657273203D205B5D3B5C6E5C6E20202F2A';
wwv_flow_imp.g_varchar2_table(5014) := '2A5C6E2020202A204074797065207B48544D4C456C656D656E747D5C6E2020202A2F5C6E2020746869732E5F6F7665726C6179526F6F74203D20637265617465526F6F742863616E7661732E676574436F6E7461696E65722829293B5C6E5C6E20207468';
wwv_flow_imp.g_varchar2_table(5015) := '69732E5F696E697428293B5C6E7D5C6E5C6E5C6E4F7665726C6179732E24696E6A656374203D205B5C6E202027636F6E6669672E6F7665726C617973272C5C6E2020276576656E74427573272C5C6E20202763616E766173272C5C6E202027656C656D65';
wwv_flow_imp.g_varchar2_table(5016) := '6E745265676973747279275C6E5D3B5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E7320746865206F7665726C617920776974682074686520737065636966696564204944206F722061206C697374206F66206F7665726C6179735C6E202A20666F72';
wwv_flow_imp.g_varchar2_table(5017) := '20616E20656C656D656E742077697468206120676976656E20747970652E5C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206060606A6176617363726970745C6E202A202F2F2072657475726E207468652073696E676C65206F7665726C';
wwv_flow_imp.g_varchar2_table(5018) := '617920776974682074686520676976656E2049445C6E202A206F7665726C6179732E6765742827736F6D652D696427293B5C6E202A5C6E202A202F2F2072657475726E20616C6C206F7665726C61797320666F72207468652073686170655C6E202A206F';
wwv_flow_imp.g_varchar2_table(5019) := '7665726C6179732E676574287B20656C656D656E743A20736F6D655368617065207D293B5C6E202A5C6E202A202F2F2072657475726E20616C6C206F7665726C617973206F6E2073686170652077697468207479706520276261646765275C6E202A206F';
wwv_flow_imp.g_varchar2_table(5020) := '7665726C6179732E676574287B20656C656D656E743A20736F6D6553686170652C20747970653A2027626164676527207D293B5C6E202A5C6E202A202F2F2073686170652063616E20616C736F206265207370656369666965642061732049445C6E202A';
wwv_flow_imp.g_varchar2_table(5021) := '206F7665726C6179732E676574287B20656C656D656E743A2027656C656D656E742D6964272C20747970653A2027626164676527207D293B5C6E202A206060605C6E202A5C6E202A2040706172616D207B4F7665726C61797346696C7465727D20736561';
wwv_flow_imp.g_varchar2_table(5022) := '726368205468652066696C74657220746F206265207573656420746F2066696E6420746865206F7665726C61792873292E5C6E202A5C6E202A204072657475726E207B4F7665726C61797C4F7665726C61795B5D7D20546865206F7665726C6179287329';
wwv_flow_imp.g_varchar2_table(5023) := '2E5C6E202A2F5C6E4F7665726C6179732E70726F746F747970652E676574203D2066756E6374696F6E2873656172636829207B5C6E5C6E2020696620286973537472696E67287365617263682929207B5C6E20202020736561726368203D207B2069643A';
wwv_flow_imp.g_varchar2_table(5024) := '20736561726368207D3B5C6E20207D5C6E5C6E2020696620286973537472696E67287365617263682E656C656D656E742929207B5C6E202020207365617263682E656C656D656E74203D20746869732E5F656C656D656E7452656769737472792E676574';
wwv_flow_imp.g_varchar2_table(5025) := '287365617263682E656C656D656E74293B5C6E20207D5C6E5C6E2020696620287365617263682E656C656D656E7429207B5C6E2020202076617220636F6E7461696E6572203D20746869732E5F6765744F7665726C6179436F6E7461696E657228736561';
wwv_flow_imp.g_varchar2_table(5026) := '7263682E656C656D656E742C2074727565293B5C6E5C6E202020202F2F2072657475726E2061206C697374206F66206F7665726C617973207768656E20736561726368696E6720627920656C656D656E7420282B74797065295C6E202020206966202863';
wwv_flow_imp.g_varchar2_table(5027) := '6F6E7461696E657229207B5C6E20202020202072657475726E207365617263682E74797065203F2066696C74657228636F6E7461696E65722E6F7665726C6179732C206D617463685061747465726E287B20747970653A207365617263682E7479706520';
wwv_flow_imp.g_varchar2_table(5028) := '7D2929203A20636F6E7461696E65722E6F7665726C6179732E736C69636528293B5C6E202020207D20656C7365207B5C6E20202020202072657475726E205B5D3B5C6E202020207D5C6E20207D20656C736520696620287365617263682E747970652920';
wwv_flow_imp.g_varchar2_table(5029) := '7B5C6E2020202072657475726E2066696C74657228746869732E5F6F7665726C6179732C206D617463685061747465726E287B20747970653A207365617263682E74797065207D29293B5C6E20207D20656C7365207B5C6E5C6E202020202F2F20726574';
wwv_flow_imp.g_varchar2_table(5030) := '75726E2073696E676C6520656C656D656E74207768656E20736561726368696E672062792069645C6E2020202072657475726E207365617263682E6964203F20746869732E5F6F7665726C6179735B7365617263682E69645D203A206E756C6C3B5C6E20';
wwv_flow_imp.g_varchar2_table(5031) := '207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A204164647320616E2048544D4C206F7665726C617920746F20616E20656C656D656E742E5C6E202A5C6E202A2040706172616D207B456C656D656E747C737472696E677D20656C656D656E742054686520656C';
wwv_flow_imp.g_varchar2_table(5032) := '656D656E7420746F2061646420746865206F7665726C617920746F2E5C6E202A2040706172616D207B737472696E677D205B747970655D20416E206F7074696F6E616C207479706520746861742063616E206265207573656420746F2066696C7465722E';
wwv_flow_imp.g_varchar2_table(5033) := '5C6E202A2040706172616D207B4F7665726C617941747472737D206F7665726C617920546865206F7665726C61792E5C6E202A5C6E202A204072657475726E207B737472696E677D20546865206F7665726C6179277320494420746861742063616E2062';
wwv_flow_imp.g_varchar2_table(5034) := '65207573656420746F20676574206F722072656D6F76652069742E5C6E202A2F5C6E4F7665726C6179732E70726F746F747970652E616464203D2066756E6374696F6E28656C656D656E742C20747970652C206F7665726C617929207B5C6E5C6E202069';
wwv_flow_imp.g_varchar2_table(5035) := '66202869734F626A65637428747970652929207B5C6E202020206F7665726C6179203D20747970653B5C6E2020202074797065203D206E756C6C3B5C6E20207D5C6E5C6E20206966202821656C656D656E742E696429207B5C6E20202020656C656D656E';
wwv_flow_imp.g_varchar2_table(5036) := '74203D20746869732E5F656C656D656E7452656769737472792E67657428656C656D656E74293B5C6E20207D5C6E5C6E202069662028216F7665726C61792E706F736974696F6E29207B5C6E202020207468726F77206E6577204572726F7228276D7573';
wwv_flow_imp.g_varchar2_table(5037) := '74207370656369666979206F7665726C617920706F736974696F6E27293B5C6E20207D5C6E5C6E202069662028216F7665726C61792E68746D6C29207B5C6E202020207468726F77206E6577204572726F7228276D757374207370656369666979206F76';
wwv_flow_imp.g_varchar2_table(5038) := '65726C61792068746D6C27293B5C6E20207D5C6E5C6E20206966202821656C656D656E7429207B5C6E202020207468726F77206E6577204572726F722827696E76616C696420656C656D656E742073706563696669656427293B5C6E20207D5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(5039) := '20766172206964203D20746869732E5F6964732E6E65787428293B5C6E5C6E20206F7665726C6179203D2061737369676E287B7D2C20746869732E5F6F7665726C617944656661756C74732C206F7665726C61792C207B5C6E2020202069643A2069642C';
wwv_flow_imp.g_varchar2_table(5040) := '5C6E20202020747970653A20747970652C5C6E20202020656C656D656E743A20656C656D656E742C5C6E2020202068746D6C3A206F7665726C61792E68746D6C5C6E20207D293B5C6E5C6E2020746869732E5F6164644F7665726C6179286F7665726C61';
wwv_flow_imp.g_varchar2_table(5041) := '79293B5C6E5C6E202072657475726E2069643B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2052656D6F766520616E206F7665726C617920776974682074686520676976656E204944206F7220616C6C206F7665726C617973206D61746368696E67207468';
wwv_flow_imp.g_varchar2_table(5042) := '6520676976656E2066696C7465722E5C6E202A5C6E202A2040736565204F7665726C6179732367657420666F722066696C746572206F7074696F6E732E5C6E202A5C6E202A2040706172616D207B4F7665726C61797346696C7465727D2066696C746572';
wwv_flow_imp.g_varchar2_table(5043) := '205468652066696C74657220746F206265207573656420746F2066696E6420746865206F7665726C61792E5C6E202A2F5C6E4F7665726C6179732E70726F746F747970652E72656D6F7665203D2066756E6374696F6E2866696C74657229207B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5044) := '2020766172206F7665726C617973203D20746869732E6765742866696C74657229207C7C205B5D3B5C6E5C6E2020696620282169734172726179286F7665726C6179732929207B5C6E202020206F7665726C617973203D205B206F7665726C617973205D';
wwv_flow_imp.g_varchar2_table(5045) := '3B5C6E20207D5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E2020666F7245616368286F7665726C6179732C2066756E6374696F6E286F7665726C617929207B5C6E5C6E2020202076617220636F6E7461696E6572203D2073656C662E';
wwv_flow_imp.g_varchar2_table(5046) := '5F6765744F7665726C6179436F6E7461696E6572286F7665726C61792E656C656D656E742C2074727565293B5C6E5C6E20202020696620286F7665726C617929207B5C6E202020202020646F6D52656D6F7665286F7665726C61792E68746D6C293B5C6E';
wwv_flow_imp.g_varchar2_table(5047) := '202020202020646F6D52656D6F7665286F7665726C61792E68746D6C436F6E7461696E6572293B5C6E5C6E20202020202064656C657465206F7665726C61792E68746D6C436F6E7461696E65723B5C6E20202020202064656C657465206F7665726C6179';
wwv_flow_imp.g_varchar2_table(5048) := '2E656C656D656E743B5C6E5C6E20202020202064656C6574652073656C662E5F6F7665726C6179735B6F7665726C61792E69645D3B5C6E202020207D5C6E5C6E2020202069662028636F6E7461696E657229207B5C6E2020202020207661722069647820';
wwv_flow_imp.g_varchar2_table(5049) := '3D20636F6E7461696E65722E6F7665726C6179732E696E6465784F66286F7665726C6179293B5C6E2020202020206966202869647820213D3D202D3129207B5C6E2020202020202020636F6E7461696E65722E6F7665726C6179732E73706C6963652869';
wwv_flow_imp.g_varchar2_table(5050) := '64782C2031293B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E5C6E7D3B5C6E5C6E2F2A2A5C6E202A20436865636B732077686574686572206F7665726C617973206172652073686F776E2E5C6E202A5C6E202A204072657475726E207B';
wwv_flow_imp.g_varchar2_table(5051) := '626F6F6C65616E7D2057686574686572206F7665726C617973206172652073686F776E2E5C6E202A2F5C6E4F7665726C6179732E70726F746F747970652E697353686F776E203D2066756E6374696F6E2829207B5C6E202072657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(5052) := '5F6F7665726C6179526F6F742E7374796C652E646973706C617920213D3D20276E6F6E65273B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2053686F7720616C6C206F7665726C6179732E5C6E202A2F5C6E4F7665726C6179732E70726F746F747970652E7368';
wwv_flow_imp.g_varchar2_table(5053) := '6F77203D2066756E6374696F6E2829207B5C6E202073657456697369626C6528746869732E5F6F7665726C6179526F6F74293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204869646520616C6C206F7665726C6179732E5C6E202A2F5C6E4F7665726C617973';
wwv_flow_imp.g_varchar2_table(5054) := '2E70726F746F747970652E68696465203D2066756E6374696F6E2829207B5C6E202073657456697369626C6528746869732E5F6F7665726C6179526F6F742C2066616C7365293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052656D6F766520616C6C206F76';
wwv_flow_imp.g_varchar2_table(5055) := '65726C61797320616E6420746865697220636F6E7461696E65722E5C6E202A2F5C6E4F7665726C6179732E70726F746F747970652E636C656172203D2066756E6374696F6E2829207B5C6E2020746869732E5F6F7665726C617973203D207B7D3B5C6E5C';
wwv_flow_imp.g_varchar2_table(5056) := '6E2020746869732E5F6F7665726C6179436F6E7461696E657273203D205B5D3B5C6E5C6E2020646F6D436C65617228746869732E5F6F7665726C6179526F6F74293B5C6E7D3B5C6E5C6E4F7665726C6179732E70726F746F747970652E5F757064617465';
wwv_flow_imp.g_varchar2_table(5057) := '4F7665726C6179436F6E7461696E6572203D2066756E6374696F6E28636F6E7461696E657229207B5C6E202076617220656C656D656E74203D20636F6E7461696E65722E656C656D656E742C5C6E20202020202068746D6C203D20636F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(5058) := '2E68746D6C3B5C6E5C6E20202F2F2075706461746520636F6E7461696E6572206C6566742C746F70206163636F7264696E6720746F2074686520656C656D656E747320782C7920636F6F7264696E617465735C6E20202F2F207468697320656E73757265';
wwv_flow_imp.g_varchar2_table(5059) := '732077652063616E20617474616368206368696C6420656C656D656E74732072656C617469766520746F207468697320636F6E7461696E65725C6E5C6E20207661722078203D20656C656D656E742E782C5C6E20202020202079203D20656C656D656E74';
wwv_flow_imp.g_varchar2_table(5060) := '2E793B5C6E5C6E202069662028656C656D656E742E776179706F696E747329207B5C6E202020207661722062626F78203D2067657442426F7828656C656D656E74293B5C6E2020202078203D2062626F782E783B5C6E2020202079203D2062626F782E79';
wwv_flow_imp.g_varchar2_table(5061) := '3B5C6E20207D5C6E5C6E2020736574506F736974696F6E2868746D6C2C20782C2079293B5C6E5C6E2020646F6D4174747228636F6E7461696E65722E68746D6C2C2027646174612D636F6E7461696E65722D6964272C20656C656D656E742E6964293B5C';
wwv_flow_imp.g_varchar2_table(5062) := '6E7D3B5C6E5C6E5C6E4F7665726C6179732E70726F746F747970652E5F7570646174654F7665726C6179203D2066756E6374696F6E286F7665726C617929207B5C6E5C6E202076617220706F736974696F6E203D206F7665726C61792E706F736974696F';
wwv_flow_imp.g_varchar2_table(5063) := '6E2C5C6E20202020202068746D6C436F6E7461696E6572203D206F7665726C61792E68746D6C436F6E7461696E65722C5C6E202020202020656C656D656E74203D206F7665726C61792E656C656D656E743B5C6E5C6E20202F2F20757064617465206F76';
wwv_flow_imp.g_varchar2_table(5064) := '65726C61792068746D6C2072656C617469766520746F20736861706520626563617573655C6E20202F2F20697420697320616C726561647920706F736974696F6E6564206F6E2074686520656C656D656E745C6E5C6E20202F2F20757064617465207265';
wwv_flow_imp.g_varchar2_table(5065) := '6C61746976655C6E2020766172206C656674203D20706F736974696F6E2E6C6566742C5C6E202020202020746F70203D20706F736974696F6E2E746F703B5C6E5C6E202069662028706F736974696F6E2E726967687420213D3D20756E646566696E6564';
wwv_flow_imp.g_varchar2_table(5066) := '29207B5C6E5C6E202020207661722077696474683B5C6E5C6E2020202069662028656C656D656E742E776179706F696E747329207B5C6E2020202020207769647468203D2067657442426F7828656C656D656E74292E77696474683B5C6E202020207D20';
wwv_flow_imp.g_varchar2_table(5067) := '656C7365207B5C6E2020202020207769647468203D20656C656D656E742E77696474683B5C6E202020207D5C6E5C6E202020206C656674203D20706F736974696F6E2E7269676874202A202D31202B2077696474683B5C6E20207D5C6E5C6E2020696620';
wwv_flow_imp.g_varchar2_table(5068) := '28706F736974696F6E2E626F74746F6D20213D3D20756E646566696E656429207B5C6E5C6E20202020766172206865696768743B5C6E5C6E2020202069662028656C656D656E742E776179706F696E747329207B5C6E202020202020686569676874203D';
wwv_flow_imp.g_varchar2_table(5069) := '2067657442426F7828656C656D656E74292E6865696768743B5C6E202020207D20656C7365207B5C6E202020202020686569676874203D20656C656D656E742E6865696768743B5C6E202020207D5C6E5C6E20202020746F70203D20706F736974696F6E';
wwv_flow_imp.g_varchar2_table(5070) := '2E626F74746F6D202A202D31202B206865696768743B5C6E20207D5C6E5C6E2020736574506F736974696F6E2868746D6C436F6E7461696E65722C206C656674207C7C20302C20746F70207C7C2030293B5C6E2020746869732E5F7570646174654F7665';
wwv_flow_imp.g_varchar2_table(5071) := '726C61795669736962696C7479286F7665726C61792C20746869732E5F63616E7661732E76696577626F782829293B5C6E7D3B5C6E5C6E5C6E4F7665726C6179732E70726F746F747970652E5F6372656174654F7665726C6179436F6E7461696E657220';
wwv_flow_imp.g_varchar2_table(5072) := '3D2066756E6374696F6E28656C656D656E7429207B5C6E20207661722068746D6C203D20646F6D69667928273C64697620636C6173733D5C22646A732D6F7665726C6179735C22202F3E27293B5C6E202061737369676E5374796C652868746D6C2C207B';
wwv_flow_imp.g_varchar2_table(5073) := '20706F736974696F6E3A20276162736F6C75746527207D293B5C6E5C6E2020746869732E5F6F7665726C6179526F6F742E617070656E644368696C642868746D6C293B5C6E5C6E202076617220636F6E7461696E6572203D207B5C6E2020202068746D6C';
wwv_flow_imp.g_varchar2_table(5074) := '3A2068746D6C2C5C6E20202020656C656D656E743A20656C656D656E742C5C6E202020206F7665726C6179733A205B5D5C6E20207D3B5C6E5C6E2020746869732E5F7570646174654F7665726C6179436F6E7461696E657228636F6E7461696E6572293B';
wwv_flow_imp.g_varchar2_table(5075) := '5C6E5C6E2020746869732E5F6F7665726C6179436F6E7461696E6572732E7075736828636F6E7461696E6572293B5C6E5C6E202072657475726E20636F6E7461696E65723B5C6E7D3B5C6E5C6E5C6E4F7665726C6179732E70726F746F747970652E5F75';
wwv_flow_imp.g_varchar2_table(5076) := '7064617465526F6F74203D2066756E6374696F6E2876696577626F7829207B5C6E2020766172207363616C65203D2076696577626F782E7363616C65207C7C20313B5C6E5C6E2020766172206D6174726978203D20276D61747269782827202B5C6E2020';
wwv_flow_imp.g_varchar2_table(5077) := '5B5C6E202020207363616C652C5C6E20202020302C5C6E20202020302C5C6E202020207363616C652C5C6E202020202D31202A2076696577626F782E78202A207363616C652C5C6E202020202D31202A2076696577626F782E79202A207363616C655C6E';
wwv_flow_imp.g_varchar2_table(5078) := '20205D2E6A6F696E28272C2729202B5C6E20202729273B5C6E5C6E20207365745472616E73666F726D28746869732E5F6F7665726C6179526F6F742C206D6174726978293B5C6E7D3B5C6E5C6E5C6E4F7665726C6179732E70726F746F747970652E5F67';
wwv_flow_imp.g_varchar2_table(5079) := '65744F7665726C6179436F6E7461696E6572203D2066756E6374696F6E28656C656D656E742C2072617729207B5C6E202076617220636F6E7461696E6572203D2066696E6428746869732E5F6F7665726C6179436F6E7461696E6572732C2066756E6374';
wwv_flow_imp.g_varchar2_table(5080) := '696F6E286329207B5C6E2020202072657475726E20632E656C656D656E74203D3D3D20656C656D656E743B5C6E20207D293B5C6E5C6E5C6E20206966202821636F6E7461696E6572202626202172617729207B5C6E2020202072657475726E2074686973';
wwv_flow_imp.g_varchar2_table(5081) := '2E5F6372656174654F7665726C6179436F6E7461696E657228656C656D656E74293B5C6E20207D5C6E5C6E202072657475726E20636F6E7461696E65723B5C6E7D3B5C6E5C6E5C6E4F7665726C6179732E70726F746F747970652E5F6164644F7665726C';
wwv_flow_imp.g_varchar2_table(5082) := '6179203D2066756E6374696F6E286F7665726C617929207B5C6E5C6E2020766172206964203D206F7665726C61792E69642C5C6E202020202020656C656D656E74203D206F7665726C61792E656C656D656E742C5C6E20202020202068746D6C203D206F';
wwv_flow_imp.g_varchar2_table(5083) := '7665726C61792E68746D6C2C5C6E20202020202068746D6C436F6E7461696E65722C5C6E2020202020206F7665726C6179436F6E7461696E65723B5C6E5C6E20202F2F20756E77726170206A71756572792028666F722074686F73652077686F206E6565';
wwv_flow_imp.g_varchar2_table(5084) := '64206974295C6E20206966202868746D6C2E6765742026262068746D6C2E636F6E7374727563746F722E70726F746F747970652E6A717565727929207B5C6E2020202068746D6C203D2068746D6C2E6765742830293B5C6E20207D5C6E5C6E20202F2F20';
wwv_flow_imp.g_varchar2_table(5085) := '6372656174652070726F7065722068746D6C20656C656D656E74732066726F6D5C6E20202F2F206F7665726C61792048544D4C20737472696E67735C6E2020696620286973537472696E672868746D6C2929207B5C6E2020202068746D6C203D20646F6D';
wwv_flow_imp.g_varchar2_table(5086) := '6966792868746D6C293B5C6E20207D5C6E5C6E20206F7665726C6179436F6E7461696E6572203D20746869732E5F6765744F7665726C6179436F6E7461696E657228656C656D656E74293B5C6E5C6E202068746D6C436F6E7461696E6572203D20646F6D';
wwv_flow_imp.g_varchar2_table(5087) := '69667928273C64697620636C6173733D5C22646A732D6F7665726C61795C2220646174612D6F7665726C61792D69643D5C2227202B206964202B20275C223E27293B5C6E202061737369676E5374796C652868746D6C436F6E7461696E65722C207B2070';
wwv_flow_imp.g_varchar2_table(5088) := '6F736974696F6E3A20276162736F6C75746527207D293B5C6E5C6E202068746D6C436F6E7461696E65722E617070656E644368696C642868746D6C293B5C6E5C6E2020696620286F7665726C61792E7479706529207B5C6E20202020646F6D436C617373';
wwv_flow_imp.g_varchar2_table(5089) := '65732868746D6C436F6E7461696E6572292E6164642827646A732D6F7665726C61792D27202B206F7665726C61792E74797065293B5C6E20207D5C6E5C6E202076617220656C656D656E74526F6F74203D20746869732E5F63616E7661732E66696E6452';
wwv_flow_imp.g_varchar2_table(5090) := '6F6F7428656C656D656E74293B5C6E202076617220616374697665526F6F74203D20746869732E5F63616E7661732E676574526F6F74456C656D656E7428293B5C6E5C6E202073657456697369626C652868746D6C436F6E7461696E65722C20656C656D';
wwv_flow_imp.g_varchar2_table(5091) := '656E74526F6F74203D3D3D20616374697665526F6F74293B5C6E5C6E20206F7665726C61792E68746D6C436F6E7461696E6572203D2068746D6C436F6E7461696E65723B5C6E5C6E20206F7665726C6179436F6E7461696E65722E6F7665726C6179732E';
wwv_flow_imp.g_varchar2_table(5092) := '70757368286F7665726C6179293B5C6E20206F7665726C6179436F6E7461696E65722E68746D6C2E617070656E644368696C642868746D6C436F6E7461696E6572293B5C6E5C6E2020746869732E5F6F7665726C6179735B69645D203D206F7665726C61';
wwv_flow_imp.g_varchar2_table(5093) := '793B5C6E5C6E2020746869732E5F7570646174654F7665726C6179286F7665726C6179293B5C6E2020746869732E5F7570646174654F7665726C61795669736962696C7479286F7665726C61792C20746869732E5F63616E7661732E76696577626F7828';
wwv_flow_imp.g_varchar2_table(5094) := '29293B5C6E7D3B5C6E5C6E5C6E4F7665726C6179732E70726F746F747970652E5F7570646174654F7665726C61795669736962696C7479203D2066756E6374696F6E286F7665726C61792C2076696577626F7829207B5C6E20207661722073686F77203D';
wwv_flow_imp.g_varchar2_table(5095) := '206F7665726C61792E73686F772C5C6E202020202020726F6F74456C656D656E74203D20746869732E5F63616E7661732E66696E64526F6F74286F7665726C61792E656C656D656E74292C5C6E2020202020206D696E5A6F6F6D203D2073686F77202626';
wwv_flow_imp.g_varchar2_table(5096) := '2073686F772E6D696E5A6F6F6D2C5C6E2020202020206D61785A6F6F6D203D2073686F772026262073686F772E6D61785A6F6F6D2C5C6E20202020202068746D6C436F6E7461696E6572203D206F7665726C61792E68746D6C436F6E7461696E65722C5C';
wwv_flow_imp.g_varchar2_table(5097) := '6E202020202020616374697665526F6F74456C656D656E74203D20746869732E5F63616E7661732E676574526F6F74456C656D656E7428292C5C6E20202020202076697369626C65203D20747275653B5C6E5C6E202069662028726F6F74456C656D656E';
wwv_flow_imp.g_varchar2_table(5098) := '7420213D3D20616374697665526F6F74456C656D656E7429207B5C6E2020202076697369626C65203D2066616C73653B5C6E20207D20656C7365206966202873686F7729207B5C6E20202020696620285C6E202020202020286973446566696E6564286D';
wwv_flow_imp.g_varchar2_table(5099) := '696E5A6F6F6D29202626206D696E5A6F6F6D203E2076696577626F782E7363616C6529207C7C5C6E202020202020286973446566696E6564286D61785A6F6F6D29202626206D61785A6F6F6D203C2076696577626F782E7363616C65295C6E2020202029';
wwv_flow_imp.g_varchar2_table(5100) := '207B5C6E20202020202076697369626C65203D2066616C73653B5C6E202020207D5C6E20207D5C6E5C6E202073657456697369626C652868746D6C436F6E7461696E65722C2076697369626C65293B5C6E5C6E2020746869732E5F7570646174654F7665';
wwv_flow_imp.g_varchar2_table(5101) := '726C61795363616C65286F7665726C61792C2076696577626F78293B5C6E7D3B5C6E5C6E5C6E4F7665726C6179732E70726F746F747970652E5F7570646174654F7665726C61795363616C65203D2066756E6374696F6E286F7665726C61792C20766965';
wwv_flow_imp.g_varchar2_table(5102) := '77626F7829207B5C6E20207661722073686F756C645363616C65203D206F7665726C61792E7363616C652C5C6E2020202020206D696E5363616C652C5C6E2020202020206D61785363616C652C5C6E20202020202068746D6C436F6E7461696E6572203D';
wwv_flow_imp.g_varchar2_table(5103) := '206F7665726C61792E68746D6C436F6E7461696E65723B5C6E5C6E2020766172207363616C652C207472616E73666F726D203D2027273B5C6E5C6E20206966202873686F756C645363616C6520213D3D207472756529207B5C6E5C6E2020202069662028';
wwv_flow_imp.g_varchar2_table(5104) := '73686F756C645363616C65203D3D3D2066616C736529207B5C6E2020202020206D696E5363616C65203D20313B5C6E2020202020206D61785363616C65203D20313B5C6E202020207D20656C7365207B5C6E2020202020206D696E5363616C65203D2073';
wwv_flow_imp.g_varchar2_table(5105) := '686F756C645363616C652E6D696E3B5C6E2020202020206D61785363616C65203D2073686F756C645363616C652E6D61783B5C6E202020207D5C6E5C6E20202020696620286973446566696E6564286D696E5363616C65292026262076696577626F782E';
wwv_flow_imp.g_varchar2_table(5106) := '7363616C65203C206D696E5363616C6529207B5C6E2020202020207363616C65203D202831202F2076696577626F782E7363616C65207C7C203129202A206D696E5363616C653B5C6E202020207D5C6E5C6E20202020696620286973446566696E656428';
wwv_flow_imp.g_varchar2_table(5107) := '6D61785363616C65292026262076696577626F782E7363616C65203E206D61785363616C6529207B5C6E2020202020207363616C65203D202831202F2076696577626F782E7363616C65207C7C203129202A206D61785363616C653B5C6E202020207D5C';
wwv_flow_imp.g_varchar2_table(5108) := '6E20207D5C6E5C6E2020696620286973446566696E6564287363616C652929207B5C6E202020207472616E73666F726D203D20277363616C652827202B207363616C65202B20272C27202B207363616C65202B202729273B5C6E20207D5C6E5C6E202073';
wwv_flow_imp.g_varchar2_table(5109) := '65745472616E73666F726D2868746D6C436F6E7461696E65722C207472616E73666F726D293B5C6E7D3B5C6E5C6E5C6E4F7665726C6179732E70726F746F747970652E5F7570646174654F7665726C6179735669736962696C7479203D2066756E637469';
wwv_flow_imp.g_varchar2_table(5110) := '6F6E2876696577626F7829207B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E2020666F724561636828746869732E5F6F7665726C6179732C2066756E6374696F6E286F7665726C617929207B5C6E2020202073656C662E5F75706461';
wwv_flow_imp.g_varchar2_table(5111) := '74654F7665726C61795669736962696C7479286F7665726C61792C2076696577626F78293B5C6E20207D293B5C6E7D3B5C6E5C6E5C6E4F7665726C6179732E70726F746F747970652E5F696E6974203D2066756E6374696F6E2829207B5C6E5C6E202076';
wwv_flow_imp.g_varchar2_table(5112) := '6172206576656E74427573203D20746869732E5F6576656E744275733B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E5C6E20202F2F207363726F6C6C2F7A6F6F6D20696E746567726174696F6E5C6E5C6E202066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(5113) := '75706461746556696577626F782876696577626F7829207B5C6E2020202073656C662E5F757064617465526F6F742876696577626F78293B5C6E2020202073656C662E5F7570646174654F7665726C6179735669736962696C74792876696577626F7829';
wwv_flow_imp.g_varchar2_table(5114) := '3B5C6E5C6E2020202073656C662E73686F7728293B5C6E20207D5C6E5C6E20206576656E744275732E6F6E282763616E7661732E76696577626F782E6368616E67696E67272C2066756E6374696F6E286576656E7429207B5C6E2020202073656C662E68';
wwv_flow_imp.g_varchar2_table(5115) := '69646528293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E282763616E7661732E76696577626F782E6368616E676564272C2066756E6374696F6E286576656E7429207B5C6E2020202075706461746556696577626F78286576656E742E';
wwv_flow_imp.g_varchar2_table(5116) := '76696577626F78293B5C6E20207D293B5C6E5C6E5C6E20202F2F2072656D6F766520696E746567726174696F6E5C6E5C6E20206576656E744275732E6F6E285B202773686170652E72656D6F7665272C2027636F6E6E656374696F6E2E72656D6F766527';
wwv_flow_imp.g_varchar2_table(5117) := '205D2C2066756E6374696F6E286529207B5C6E2020202076617220656C656D656E74203D20652E656C656D656E743B5C6E20202020766172206F7665726C617973203D2073656C662E676574287B20656C656D656E743A20656C656D656E74207D293B5C';
wwv_flow_imp.g_varchar2_table(5118) := '6E5C6E20202020666F7245616368286F7665726C6179732C2066756E6374696F6E286F29207B5C6E20202020202073656C662E72656D6F7665286F2E6964293B5C6E202020207D293B5C6E5C6E2020202076617220636F6E7461696E6572203D2073656C';
wwv_flow_imp.g_varchar2_table(5119) := '662E5F6765744F7665726C6179436F6E7461696E657228656C656D656E74293B5C6E5C6E2020202069662028636F6E7461696E657229207B5C6E202020202020646F6D52656D6F766528636F6E7461696E65722E68746D6C293B5C6E2020202020207661';
wwv_flow_imp.g_varchar2_table(5120) := '722069203D2073656C662E5F6F7665726C6179436F6E7461696E6572732E696E6465784F6628636F6E7461696E6572293B5C6E202020202020696620286920213D3D202D3129207B5C6E202020202020202073656C662E5F6F7665726C6179436F6E7461';
wwv_flow_imp.g_varchar2_table(5121) := '696E6572732E73706C69636528692C2031293B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E5C6E5C6E20202F2F206D6F766520696E746567726174696F6E5C6E5C6E20206576656E744275732E6F6E2827656C656D656E742E6368616E';
wwv_flow_imp.g_varchar2_table(5122) := '676564272C204C4F575F5052494F524954592C2066756E6374696F6E286529207B5C6E2020202076617220656C656D656E74203D20652E656C656D656E743B5C6E5C6E2020202076617220636F6E7461696E6572203D2073656C662E5F6765744F766572';
wwv_flow_imp.g_varchar2_table(5123) := '6C6179436F6E7461696E657228656C656D656E742C2074727565293B5C6E5C6E2020202069662028636F6E7461696E657229207B5C6E202020202020666F724561636828636F6E7461696E65722E6F7665726C6179732C2066756E6374696F6E286F7665';
wwv_flow_imp.g_varchar2_table(5124) := '726C617929207B5C6E202020202020202073656C662E5F7570646174654F7665726C6179286F7665726C6179293B5C6E2020202020207D293B5C6E5C6E20202020202073656C662E5F7570646174654F7665726C6179436F6E7461696E657228636F6E74';
wwv_flow_imp.g_varchar2_table(5125) := '61696E6572293B5C6E202020207D5C6E20207D293B5C6E5C6E5C6E20202F2F206D61726B657220696E746567726174696F6E2C2073696D706C7920616464207468656D206F6E20746865206F7665726C61797320617320636C61737365732C20746F6F2E';
wwv_flow_imp.g_varchar2_table(5126) := '5C6E5C6E20206576656E744275732E6F6E2827656C656D656E742E6D61726B65722E757064617465272C2066756E6374696F6E286529207B5C6E2020202076617220636F6E7461696E6572203D2073656C662E5F6765744F7665726C6179436F6E746169';
wwv_flow_imp.g_varchar2_table(5127) := '6E657228652E656C656D656E742C2074727565293B5C6E2020202069662028636F6E7461696E657229207B5C6E202020202020646F6D436C617373657328636F6E7461696E65722E68746D6C295B652E616464203F202761646427203A202772656D6F76';
wwv_flow_imp.g_varchar2_table(5128) := '65275D28652E6D61726B6572293B5C6E202020207D5C6E20207D293B5C6E5C6E5C6E20206576656E744275732E6F6E2827726F6F742E736574272C2066756E6374696F6E2829207B5C6E2020202073656C662E5F7570646174654F7665726C6179735669';
wwv_flow_imp.g_varchar2_table(5129) := '736962696C74792873656C662E5F63616E7661732E76696577626F782829293B5C6E20207D293B5C6E5C6E20202F2F20636C656172206F7665726C6179732077697468206469616772616D5C6E5C6E20206576656E744275732E6F6E2827646961677261';
wwv_flow_imp.g_varchar2_table(5130) := '6D2E636C656172272C20746869732E636C6561722C2074686973293B5C6E7D3B5C6E5C6E5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E2063726561746552';
wwv_flow_imp.g_varchar2_table(5131) := '6F6F7428706172656E744E6F646529207B5C6E202076617220726F6F74203D20646F6D696679285C6E20202020273C64697620636C6173733D5C22646A732D6F7665726C61792D636F6E7461696E65725C22202F3E275C6E2020293B5C6E5C6E20206173';
wwv_flow_imp.g_varchar2_table(5132) := '7369676E5374796C6528726F6F742C207B5C6E20202020706F736974696F6E3A20276162736F6C757465272C5C6E2020202077696474683A20302C5C6E202020206865696768743A20305C6E20207D293B5C6E5C6E2020706172656E744E6F64652E696E';
wwv_flow_imp.g_varchar2_table(5133) := '736572744265666F726528726F6F742C20706172656E744E6F64652E66697273744368696C64293B5C6E5C6E202072657475726E20726F6F743B5C6E7D5C6E5C6E66756E6374696F6E20736574506F736974696F6E28656C2C20782C207929207B5C6E20';
wwv_flow_imp.g_varchar2_table(5134) := '2061737369676E5374796C6528656C2C207B206C6566743A2078202B20277078272C20746F703A2079202B2027707827207D293B5C6E7D5C6E5C6E2F2A2A5C6E202A2053657420656C656D656E742076697369626C655C6E202A5C6E202A204070617261';
wwv_flow_imp.g_varchar2_table(5135) := '6D207B444F4D456C656D656E747D20656C5C6E202A2040706172616D207B626F6F6C65616E7D205B76697369626C653D747275655D5C6E202A2F5C6E66756E6374696F6E2073657456697369626C6528656C2C2076697369626C6529207B5C6E2020656C';
wwv_flow_imp.g_varchar2_table(5136) := '2E7374796C652E646973706C6179203D2076697369626C65203D3D3D2066616C7365203F20276E6F6E6527203A2027273B5C6E7D5C6E5C6E66756E6374696F6E207365745472616E73666F726D28656C2C207472616E73666F726D29207B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5137) := '656C2E7374796C655B277472616E73666F726D2D6F726967696E275D203D2027746F70206C656674273B5C6E5C6E20205B2027272C20272D6D732D272C20272D7765626B69742D27205D2E666F72456163682866756E6374696F6E287072656669782920';
wwv_flow_imp.g_varchar2_table(5138) := '7B5C6E20202020656C2E7374796C655B707265666978202B20277472616E73666F726D275D203D207472616E73666F726D3B5C6E20207D293B5C6E7D222C22696D706F7274204F7665726C6179732066726F6D20272E2F4F7665726C617973273B5C6E5C';
wwv_flow_imp.g_varchar2_table(5139) := '6E5C6E2F2A2A5C6E202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D5C6E202A2F5C6E6578706F72742064656661756C74207B5C6E20205F5F696E69745F5F3A205B20276F7665726C6179';
wwv_flow_imp.g_varchar2_table(5140) := '7327205D2C5C6E20206F7665726C6179733A205B202774797065272C204F7665726C617973205D5C6E7D3B222C22696D706F7274207B5C6E2020697341727261792C5C6E2020697346756E6374696F6E2C5C6E2020666F72456163685C6E7D2066726F6D';
wwv_flow_imp.g_varchar2_table(5141) := '20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E2020646F6D6966792C5C6E2020717565727920617320646F6D51756572792C5C6E20206174747220617320646F6D417474722C5C6E2020636C65617220617320646F6D436C6561722C5C';
wwv_flow_imp.g_varchar2_table(5142) := '6E2020636C617373657320617320646F6D436C61737365732C5C6E20206D61746368657320617320646F6D4D6174636865732C5C6E202064656C656761746520617320646F6D44656C65676174652C5C6E20206576656E7420617320646F6D4576656E74';
wwv_flow_imp.g_varchar2_table(5143) := '5C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E696D706F7274207B5C6E20206573636170654353535C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F4573636170655574696C273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B69';
wwv_flow_imp.g_varchar2_table(5144) := '6D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E64656661756C747D2043616E7661735C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E';
wwv_flow_imp.g_varchar2_table(5145) := '744275735C6E202A5C6E202A204074797065646566207B696D706F727428272E2F50616C6574746550726F766964657227292E50616C65747465456E74726965737D2050616C65747465456E74726965735C6E202A204074797065646566207B696D706F';
wwv_flow_imp.g_varchar2_table(5146) := '727428272E2F50616C6574746550726F766964657227292E64656661756C747D2050616C6574746550726F76696465725C6E202A2F5C6E5C6E76617220544F47474C455F53454C4543544F52203D20272E646A732D70616C657474652D746F67676C6527';
wwv_flow_imp.g_varchar2_table(5147) := '2C5C6E20202020454E5452595F53454C4543544F52203D20272E656E747279272C5C6E20202020454C454D454E545F53454C4543544F52203D20544F47474C455F53454C4543544F52202B20272C2027202B20454E5452595F53454C4543544F523B5C6E';
wwv_flow_imp.g_varchar2_table(5148) := '5C6E7661722050414C455454455F505245464958203D2027646A732D70616C657474652D272C5C6E2020202050414C455454455F53484F574E5F434C53203D202773686F776E272C5C6E2020202050414C455454455F4F50454E5F434C53203D20276F70';
wwv_flow_imp.g_varchar2_table(5149) := '656E272C5C6E2020202050414C455454455F54574F5F434F4C554D4E5F434C53203D202774776F2D636F6C756D6E273B5C6E5C6E7661722044454641554C545F5052494F52495459203D20313030303B5C6E5C6E5C6E2F2A2A5C6E202A20412070616C65';
wwv_flow_imp.g_varchar2_table(5150) := '74746520636F6E7461696E696E67206D6F64656C696E6720656C656D656E74732E5C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B43616E7661737D2063616E7661735C6E202A2F';
wwv_flow_imp.g_varchar2_table(5151) := '5C6E6578706F72742064656661756C742066756E6374696F6E2050616C65747465286576656E744275732C2063616E76617329207B5C6E5C6E2020746869732E5F6576656E74427573203D206576656E744275733B5C6E2020746869732E5F63616E7661';
wwv_flow_imp.g_varchar2_table(5152) := '73203D2063616E7661733B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E20206576656E744275732E6F6E2827746F6F6C2D6D616E616765722E757064617465272C2066756E6374696F6E286576656E7429207B5C6E20202020766172';
wwv_flow_imp.g_varchar2_table(5153) := '20746F6F6C203D206576656E742E746F6F6C3B5C6E5C6E2020202073656C662E757064617465546F6F6C486967686C6967687428746F6F6C293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E28276931386E2E6368616E676564272C2066';
wwv_flow_imp.g_varchar2_table(5154) := '756E6374696F6E2829207B5C6E2020202073656C662E5F75706461746528293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E28276469616772616D2E696E6974272C2066756E6374696F6E2829207B5C6E5C6E2020202073656C662E5F64';
wwv_flow_imp.g_varchar2_table(5155) := '69616772616D496E697469616C697A6564203D20747275653B5C6E5C6E2020202073656C662E5F72656275696C6428293B5C6E20207D293B5C6E7D5C6E5C6E50616C657474652E24696E6A656374203D205B20276576656E74427573272C202763616E76';
wwv_flow_imp.g_varchar2_table(5156) := '617327205D3B5C6E5C6E2F2A2A5C6E202A20406F7665726C6F72645C6E202A5C6E202A20526567697374657220612070616C657474652070726F766964657220776974682064656661756C74207072696F726974792E205365655C6E202A207B406C696E';
wwv_flow_imp.g_varchar2_table(5157) := '6B2050616C6574746550726F76696465727D20666F72206578616D706C65732E5C6E202A5C6E202A2040706172616D207B50616C6574746550726F76696465727D2070726F76696465725C6E202A2F5C6E5C6E2F2A2A5C6E202A20526567697374657220';
wwv_flow_imp.g_varchar2_table(5158) := '612070616C657474652070726F766964657220776974682074686520676976656E207072696F726974792E205365655C6E202A207B406C696E6B2050616C6574746550726F76696465727D20666F72206578616D706C65732E5C6E202A5C6E202A204070';
wwv_flow_imp.g_varchar2_table(5159) := '6172616D207B6E756D6265727D207072696F726974795C6E202A2040706172616D207B50616C6574746550726F76696465727D2070726F76696465725C6E202A2F5C6E50616C657474652E70726F746F747970652E726567697374657250726F76696465';
wwv_flow_imp.g_varchar2_table(5160) := '72203D2066756E6374696F6E287072696F726974792C2070726F766964657229207B5C6E2020696620282170726F766964657229207B5C6E2020202070726F7669646572203D207072696F726974793B5C6E202020207072696F72697479203D20444546';
wwv_flow_imp.g_varchar2_table(5161) := '41554C545F5052494F524954593B5C6E20207D5C6E5C6E2020746869732E5F6576656E744275732E6F6E282770616C657474652E67657450726F766964657273272C207072696F726974792C2066756E6374696F6E286576656E7429207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(5162) := '6576656E742E70726F7669646572732E707573682870726F7669646572293B5C6E20207D293B5C6E5C6E2020746869732E5F72656275696C6428293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E73207468652070616C6574746520656E';
wwv_flow_imp.g_varchar2_table(5163) := '74726965732E5C6E202A5C6E202A204072657475726E207B50616C65747465456E74726965737D5C6E202A2F5C6E50616C657474652E70726F746F747970652E676574456E7472696573203D2066756E6374696F6E2829207B5C6E20207661722070726F';
wwv_flow_imp.g_varchar2_table(5164) := '766964657273203D20746869732E5F67657450726F76696465727328293B5C6E5C6E202072657475726E2070726F7669646572732E7265647563652861646450616C65747465456E74726965732C207B7D293B5C6E7D3B5C6E5C6E50616C657474652E70';
wwv_flow_imp.g_varchar2_table(5165) := '726F746F747970652E5F72656275696C64203D2066756E6374696F6E2829207B5C6E5C6E20206966202821746869732E5F6469616772616D496E697469616C697A656429207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020766172207072';
wwv_flow_imp.g_varchar2_table(5166) := '6F766964657273203D20746869732E5F67657450726F76696465727328293B5C6E5C6E2020696620282170726F7669646572732E6C656E67746829207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E20206966202821746869732E5F636F6E74';
wwv_flow_imp.g_varchar2_table(5167) := '61696E657229207B5C6E20202020746869732E5F696E697428293B5C6E20207D5C6E5C6E2020746869732E5F75706461746528293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20496E697469616C697A652070616C657474652E5C6E202A2F5C6E50616C6574';
wwv_flow_imp.g_varchar2_table(5168) := '74652E70726F746F747970652E5F696E6974203D2066756E6374696F6E2829207B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E2020766172206576656E74427573203D20746869732E5F6576656E744275733B5C6E5C6E2020766172';
wwv_flow_imp.g_varchar2_table(5169) := '20706172656E74436F6E7461696E6572203D20746869732E5F676574506172656E74436F6E7461696E657228293B5C6E5C6E202076617220636F6E7461696E6572203D20746869732E5F636F6E7461696E6572203D20646F6D6966792850616C65747465';
wwv_flow_imp.g_varchar2_table(5170) := '2E48544D4C5F4D41524B5550293B5C6E5C6E2020706172656E74436F6E7461696E65722E617070656E644368696C6428636F6E7461696E6572293B5C6E2020646F6D436C617373657328706172656E74436F6E7461696E6572292E6164642850414C4554';
wwv_flow_imp.g_varchar2_table(5171) := '54455F505245464958202B2050414C455454455F53484F574E5F434C53293B5C6E5C6E2020646F6D44656C65676174652E62696E6428636F6E7461696E65722C20454C454D454E545F53454C4543544F522C2027636C69636B272C2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(5172) := '286576656E7429207B5C6E5C6E2020202076617220746172676574203D206576656E742E64656C65676174655461726765743B5C6E5C6E2020202069662028646F6D4D617463686573287461726765742C20544F47474C455F53454C4543544F52292920';
wwv_flow_imp.g_varchar2_table(5173) := '7B5C6E20202020202072657475726E2073656C662E746F67676C6528293B5C6E202020207D5C6E5C6E2020202073656C662E747269676765722827636C69636B272C206576656E74293B5C6E20207D293B5C6E5C6E20202F2F2070726576656E74206472';
wwv_flow_imp.g_varchar2_table(5174) := '61672070726F7061676174696F6E5C6E2020646F6D4576656E742E62696E6428636F6E7461696E65722C20276D6F757365646F776E272C2066756E6374696F6E286576656E7429207B5C6E202020206576656E742E73746F7050726F7061676174696F6E';
wwv_flow_imp.g_varchar2_table(5175) := '28293B5C6E20207D293B5C6E5C6E20202F2F2070726576656E7420647261672070726F7061676174696F6E5C6E2020646F6D44656C65676174652E62696E6428636F6E7461696E65722C20454E5452595F53454C4543544F522C20276472616773746172';
wwv_flow_imp.g_varchar2_table(5176) := '74272C2066756E6374696F6E286576656E7429207B5C6E2020202073656C662E747269676765722827647261677374617274272C206576656E74293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E282763616E7661732E726573697A6564';
wwv_flow_imp.g_varchar2_table(5177) := '272C20746869732E5F6C61796F75744368616E6765642C2074686973293B5C6E5C6E20206576656E744275732E66697265282770616C657474652E637265617465272C207B5C6E20202020636F6E7461696E65723A20636F6E7461696E65725C6E20207D';
wwv_flow_imp.g_varchar2_table(5178) := '293B5C6E7D3B5C6E5C6E50616C657474652E70726F746F747970652E5F67657450726F766964657273203D2066756E6374696F6E28696429207B5C6E5C6E2020766172206576656E74203D20746869732E5F6576656E744275732E637265617465457665';
wwv_flow_imp.g_varchar2_table(5179) := '6E74287B5C6E20202020747970653A202770616C657474652E67657450726F766964657273272C5C6E2020202070726F7669646572733A205B5D5C6E20207D293B5C6E5C6E2020746869732E5F6576656E744275732E66697265286576656E74293B5C6E';
wwv_flow_imp.g_varchar2_table(5180) := '5C6E202072657475726E206576656E742E70726F7669646572733B5C6E7D3B5C6E5C6E2F2A2A5C6E202A205570646174652070616C657474652073746174652E5C6E202A5C6E202A2040706172616D207B207B5C6E202A2020206F70656E3F3A20626F6F';
wwv_flow_imp.g_varchar2_table(5181) := '6C65616E3B5C6E202A20202074776F436F6C756D6E3F3A20626F6F6C65616E3B5C6E202A207D207D205B73746174655D5C6E202A2F5C6E50616C657474652E70726F746F747970652E5F746F67676C655374617465203D2066756E6374696F6E28737461';
wwv_flow_imp.g_varchar2_table(5182) := '746529207B5C6E5C6E20207374617465203D207374617465207C7C207B7D3B5C6E5C6E202076617220706172656E74203D20746869732E5F676574506172656E74436F6E7461696E657228292C5C6E202020202020636F6E7461696E6572203D20746869';
wwv_flow_imp.g_varchar2_table(5183) := '732E5F636F6E7461696E65723B5C6E5C6E2020766172206576656E74427573203D20746869732E5F6576656E744275733B5C6E5C6E20207661722074776F436F6C756D6E3B5C6E5C6E202076617220636C73203D20646F6D436C617373657328636F6E74';
wwv_flow_imp.g_varchar2_table(5184) := '61696E6572292C5C6E202020202020706172656E74436C73203D20646F6D436C617373657328706172656E74293B5C6E5C6E2020696620282774776F436F6C756D6E2720696E20737461746529207B5C6E2020202074776F436F6C756D6E203D20737461';
wwv_flow_imp.g_varchar2_table(5185) := '74652E74776F436F6C756D6E3B5C6E20207D20656C7365207B5C6E2020202074776F436F6C756D6E203D20746869732E5F6E65656473436F6C6C6170736528706172656E742E636C69656E744865696768742C20746869732E5F656E7472696573207C7C';
wwv_flow_imp.g_varchar2_table(5186) := '207B7D293B5C6E20207D5C6E5C6E20202F2F20616C77617973207570646174652074776F20636F6C756D6E5C6E2020636C732E746F67676C652850414C455454455F54574F5F434F4C554D4E5F434C532C2074776F436F6C756D6E293B5C6E2020706172';
wwv_flow_imp.g_varchar2_table(5187) := '656E74436C732E746F67676C652850414C455454455F505245464958202B2050414C455454455F54574F5F434F4C554D4E5F434C532C2074776F436F6C756D6E293B5C6E5C6E202069662028276F70656E2720696E20737461746529207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(5188) := '636C732E746F67676C652850414C455454455F4F50454E5F434C532C2073746174652E6F70656E293B5C6E20202020706172656E74436C732E746F67676C652850414C455454455F505245464958202B2050414C455454455F4F50454E5F434C532C2073';
wwv_flow_imp.g_varchar2_table(5189) := '746174652E6F70656E293B5C6E20207D5C6E5C6E20206576656E744275732E66697265282770616C657474652E6368616E676564272C207B5C6E2020202074776F436F6C756D6E3A2074776F436F6C756D6E2C5C6E202020206F70656E3A20746869732E';
wwv_flow_imp.g_varchar2_table(5190) := '69734F70656E28295C6E20207D293B5C6E7D3B5C6E5C6E50616C657474652E70726F746F747970652E5F757064617465203D2066756E6374696F6E2829207B5C6E5C6E202076617220656E7472696573436F6E7461696E6572203D20646F6D5175657279';
wwv_flow_imp.g_varchar2_table(5191) := '28272E646A732D70616C657474652D656E7472696573272C20746869732E5F636F6E7461696E6572292C5C6E202020202020656E7472696573203D20746869732E5F656E7472696573203D20746869732E676574456E747269657328293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5192) := '646F6D436C65617228656E7472696573436F6E7461696E6572293B5C6E5C6E2020666F724561636828656E74726965732C2066756E6374696F6E28656E7472792C20696429207B5C6E5C6E202020207661722067726F7570696E67203D20656E7472792E';
wwv_flow_imp.g_varchar2_table(5193) := '67726F7570207C7C202764656661756C74273B5C6E5C6E2020202076617220636F6E7461696E6572203D20646F6D517565727928275B646174612D67726F75703D27202B206573636170654353532867726F7570696E6729202B20275D272C20656E7472';
wwv_flow_imp.g_varchar2_table(5194) := '696573436F6E7461696E6572293B5C6E202020206966202821636F6E7461696E657229207B5C6E202020202020636F6E7461696E6572203D20646F6D69667928273C64697620636C6173733D5C2267726F75705C223E3C2F6469763E27293B5C6E202020';
wwv_flow_imp.g_varchar2_table(5195) := '202020646F6D4174747228636F6E7461696E65722C2027646174612D67726F7570272C2067726F7570696E67293B5C6E5C6E202020202020656E7472696573436F6E7461696E65722E617070656E644368696C6428636F6E7461696E6572293B5C6E2020';
wwv_flow_imp.g_varchar2_table(5196) := '20207D5C6E5C6E202020207661722068746D6C203D20656E7472792E68746D6C207C7C20285C6E202020202020656E7472792E736570617261746F72203F5C6E2020202020202020273C687220636C6173733D5C22736570617261746F725C22202F3E27';
wwv_flow_imp.g_varchar2_table(5197) := '203A5C6E2020202020202020273C64697620636C6173733D5C22656E7472795C2220647261676761626C653D5C22747275655C223E3C2F6469763E27293B5C6E5C6E5C6E2020202076617220636F6E74726F6C203D20646F6D6966792868746D6C293B5C';
wwv_flow_imp.g_varchar2_table(5198) := '6E20202020636F6E7461696E65722E617070656E644368696C6428636F6E74726F6C293B5C6E5C6E202020206966202821656E7472792E736570617261746F7229207B5C6E202020202020646F6D4174747228636F6E74726F6C2C2027646174612D6163';
wwv_flow_imp.g_varchar2_table(5199) := '74696F6E272C206964293B5C6E5C6E20202020202069662028656E7472792E7469746C6529207B5C6E2020202020202020646F6D4174747228636F6E74726F6C2C20277469746C65272C20656E7472792E7469746C65293B5C6E2020202020207D5C6E5C';
wwv_flow_imp.g_varchar2_table(5200) := '6E20202020202069662028656E7472792E636C6173734E616D6529207B5C6E2020202020202020616464436C617373657328636F6E74726F6C2C20656E7472792E636C6173734E616D65293B5C6E2020202020207D5C6E5C6E2020202020206966202865';
wwv_flow_imp.g_varchar2_table(5201) := '6E7472792E696D61676555726C29207B5C6E202020202020202076617220696D616765203D20646F6D69667928273C696D673E27293B5C6E2020202020202020646F6D4174747228696D6167652C2027737263272C20656E7472792E696D61676555726C';
wwv_flow_imp.g_varchar2_table(5202) := '293B5C6E5C6E2020202020202020636F6E74726F6C2E617070656E644368696C6428696D616765293B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E5C6E20202F2F206F70656E206166746572207570646174655C6E2020746869732E6F';
wwv_flow_imp.g_varchar2_table(5203) := '70656E28293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A205472696767657220616E20616374696F6E20617661696C61626C65206F6E207468652070616C657474655C6E202A5C6E202A2040706172616D207B737472696E677D20616374696F6E5C6E20';
wwv_flow_imp.g_varchar2_table(5204) := '2A2040706172616D207B4576656E747D206576656E745C6E202A2040706172616D207B626F6F6C65616E7D205B6175746F41637469766174653D66616C73655D5C6E202A2F5C6E50616C657474652E70726F746F747970652E74726967676572203D2066';
wwv_flow_imp.g_varchar2_table(5205) := '756E6374696F6E28616374696F6E2C206576656E742C206175746F416374697661746529207B5C6E202076617220656E7472792C5C6E2020202020206F726967696E616C4576656E742C5C6E202020202020627574746F6E203D206576656E742E64656C';
wwv_flow_imp.g_varchar2_table(5206) := '6567617465546172676574207C7C206576656E742E7461726765743B5C6E5C6E20206966202821627574746F6E29207B5C6E2020202072657475726E206576656E742E70726576656E7444656661756C7428293B5C6E20207D5C6E5C6E2020656E747279';
wwv_flow_imp.g_varchar2_table(5207) := '203D20646F6D4174747228627574746F6E2C2027646174612D616374696F6E27293B5C6E20206F726967696E616C4576656E74203D206576656E742E6F726967696E616C4576656E74207C7C206576656E743B5C6E5C6E202072657475726E2074686973';
wwv_flow_imp.g_varchar2_table(5208) := '2E74726967676572456E74727928656E7472792C20616374696F6E2C206F726967696E616C4576656E742C206175746F4163746976617465293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B737472696E677D20656E74727949645C6E20';
wwv_flow_imp.g_varchar2_table(5209) := '2A2040706172616D207B737472696E677D20616374696F6E5C6E202A2040706172616D207B4576656E747D206576656E745C6E202A2040706172616D207B626F6F6C65616E7D205B6175746F41637469766174653D66616C73655D5C6E202A2F5C6E5061';
wwv_flow_imp.g_varchar2_table(5210) := '6C657474652E70726F746F747970652E74726967676572456E747279203D2066756E6374696F6E28656E74727949642C20616374696F6E2C206576656E742C206175746F416374697661746529207B5C6E202076617220656E7472696573203D20746869';
wwv_flow_imp.g_varchar2_table(5211) := '732E5F656E74726965732C5C6E202020202020656E7472792C5C6E20202020202068616E646C65723B5C6E5C6E2020656E747279203D20656E74726965735B656E74727949645D3B5C6E5C6E20202F2F207768656E207573657220636C69636B73206F6E';
wwv_flow_imp.g_varchar2_table(5212) := '207468652070616C6574746520616E64206E6F74206F6E20616E20616374696F6E5C6E20206966202821656E74727929207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E202068616E646C6572203D20656E7472792E616374696F6E3B5C6E5C';
wwv_flow_imp.g_varchar2_table(5213) := '6E202069662028746869732E5F6576656E744275732E66697265282770616C657474652E74726967676572272C207B20656E7472792C206576656E74207D29203D3D3D2066616C736529207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5214) := '2F2F2073696D706C6520616374696F6E20287669612063616C6C6261636B2066756E6374696F6E295C6E202069662028697346756E6374696F6E2868616E646C65722929207B5C6E2020202069662028616374696F6E203D3D3D2027636C69636B272920';
wwv_flow_imp.g_varchar2_table(5215) := '7B5C6E20202020202072657475726E2068616E646C6572286576656E742C206175746F4163746976617465293B5C6E202020207D5C6E20207D20656C7365207B5C6E202020206966202868616E646C65725B616374696F6E5D29207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(5216) := '72657475726E2068616E646C65725B616374696F6E5D286576656E742C206175746F4163746976617465293B5C6E202020207D5C6E20207D5C6E5C6E20202F2F2073696C656E6365206F7468657220616374696F6E735C6E20206576656E742E70726576';
wwv_flow_imp.g_varchar2_table(5217) := '656E7444656661756C7428293B5C6E7D3B5C6E5C6E50616C657474652E70726F746F747970652E5F6C61796F75744368616E676564203D2066756E6374696F6E2829207B5C6E2020746869732E5F746F67676C655374617465287B7D293B5C6E7D3B5C6E';
wwv_flow_imp.g_varchar2_table(5218) := '5C6E2F2A2A5C6E202A20446F207765206E65656420746F20636F6C6C6170736520746F2074776F20636F6C756D6E733F5C6E202A5C6E202A2040706172616D207B6E756D6265727D20617661696C61626C654865696768745C6E202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(5219) := '7B50616C65747465456E74726965737D20656E74726965735C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E50616C657474652E70726F746F747970652E5F6E65656473436F6C6C61707365203D2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(5220) := '28617661696C61626C654865696768742C20656E747269657329207B5C6E5C6E20202F2F20746F70206D617267696E202B20626F74746F6D20746F67676C65202B20626F74746F6D206D617267696E5C6E20202F2F20696D706C656D656E746F7273206D';
wwv_flow_imp.g_varchar2_table(5221) := '757374206F766572726964652074686973206D6574686F6420696620746865795C6E20202F2F206368616E6765207468652070616C65747465207374796C65735C6E2020766172206D617267696E203D203230202B203130202B2032303B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5222) := '76617220656E7472696573486569676874203D204F626A6563742E6B65797328656E7472696573292E6C656E677468202A2034363B5C6E5C6E202072657475726E20617661696C61626C65486569676874203C20656E7472696573486569676874202B20';
wwv_flow_imp.g_varchar2_table(5223) := '6D617267696E3B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20436C6F7365207468652070616C657474652E5C6E202A2F5C6E50616C657474652E70726F746F747970652E636C6F7365203D2066756E6374696F6E2829207B5C6E2020746869732E5F746F6767';
wwv_flow_imp.g_varchar2_table(5224) := '6C655374617465287B5C6E202020206F70656E3A2066616C73652C5C6E2020202074776F436F6C756D6E3A2066616C73655C6E20207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204F70656E207468652070616C657474652E5C6E202A2F5C6E50616C65';
wwv_flow_imp.g_varchar2_table(5225) := '7474652E70726F746F747970652E6F70656E203D2066756E6374696F6E2829207B5C6E2020746869732E5F746F67676C655374617465287B206F70656E3A2074727565207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20546F67676C6520746865207061';
wwv_flow_imp.g_varchar2_table(5226) := '6C657474652E5C6E202A2F5C6E50616C657474652E70726F746F747970652E746F67676C65203D2066756E6374696F6E2829207B5C6E202069662028746869732E69734F70656E282929207B5C6E20202020746869732E636C6F736528293B5C6E20207D';
wwv_flow_imp.g_varchar2_table(5227) := '20656C7365207B5C6E20202020746869732E6F70656E28293B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B737472696E677D20746F6F6C5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E50';
wwv_flow_imp.g_varchar2_table(5228) := '616C657474652E70726F746F747970652E6973416374697665546F6F6C203D2066756E6374696F6E28746F6F6C29207B5C6E202072657475726E20746F6F6C20262620746869732E5F616374697665546F6F6C203D3D3D20746F6F6C3B5C6E7D3B5C6E5C';
wwv_flow_imp.g_varchar2_table(5229) := '6E2F2A2A5C6E202A2040706172616D207B737472696E677D206E616D655C6E202A2F5C6E50616C657474652E70726F746F747970652E757064617465546F6F6C486967686C69676874203D2066756E6374696F6E286E616D6529207B5C6E202076617220';
wwv_flow_imp.g_varchar2_table(5230) := '656E7472696573436F6E7461696E65722C5C6E202020202020746F6F6C73436F6E7461696E65723B5C6E5C6E20206966202821746869732E5F746F6F6C73436F6E7461696E657229207B5C6E20202020656E7472696573436F6E7461696E6572203D2064';
wwv_flow_imp.g_varchar2_table(5231) := '6F6D517565727928272E646A732D70616C657474652D656E7472696573272C20746869732E5F636F6E7461696E6572293B5C6E5C6E20202020746869732E5F746F6F6C73436F6E7461696E6572203D20646F6D517565727928275B646174612D67726F75';
wwv_flow_imp.g_varchar2_table(5232) := '703D746F6F6C735D272C20656E7472696573436F6E7461696E6572293B5C6E20207D5C6E5C6E2020746F6F6C73436F6E7461696E6572203D20746869732E5F746F6F6C73436F6E7461696E65723B5C6E5C6E2020666F724561636828746F6F6C73436F6E';
wwv_flow_imp.g_varchar2_table(5233) := '7461696E65722E6368696C6472656E2C2066756E6374696F6E28746F6F6C29207B5C6E2020202076617220616374696F6E4E616D65203D20746F6F6C2E6765744174747269627574652827646174612D616374696F6E27293B5C6E5C6E20202020696620';
wwv_flow_imp.g_varchar2_table(5234) := '2821616374696F6E4E616D6529207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E2020202076617220746F6F6C436C6173736573203D20646F6D436C617373657328746F6F6C293B5C6E5C6E20202020616374696F6E4E616D65203D';
wwv_flow_imp.g_varchar2_table(5235) := '20616374696F6E4E616D652E7265706C61636528272D746F6F6C272C202727293B5C6E5C6E2020202069662028746F6F6C436C61737365732E636F6E7461696E732827656E747279272920262620616374696F6E4E616D65203D3D3D206E616D6529207B';
wwv_flow_imp.g_varchar2_table(5236) := '5C6E202020202020746F6F6C436C61737365732E6164642827686967686C6967687465642D656E74727927293B5C6E202020207D20656C7365207B5C6E202020202020746F6F6C436C61737365732E72656D6F76652827686967686C6967687465642D65';
wwv_flow_imp.g_varchar2_table(5237) := '6E74727927293B5C6E202020207D5C6E20207D293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E20607472756560206966207468652070616C65747465206973206F70656E65642E5C6E202A5C6E202A20406578616D706C655C6E202A5C';
wwv_flow_imp.g_varchar2_table(5238) := '6E202A206060606A6176617363726970745C6E202A2070616C657474652E6F70656E28293B5C6E202A5C6E202A206966202870616C657474652E69734F70656E282929207B5C6E202A2020202F2F207965732C20776520617265206F70656E5C6E202A20';
wwv_flow_imp.g_varchar2_table(5239) := '7D5C6E202A206060605C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E50616C657474652E70726F746F747970652E69734F70656E203D2066756E6374696F6E2829207B5C6E202072657475726E20646F6D436C617373';
wwv_flow_imp.g_varchar2_table(5240) := '657328746869732E5F636F6E7461696E6572292E6861732850414C455454455F4F50454E5F434C53293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2047657420706172656E7420656C656D656E74206F662070616C657474652E5C6E202A5C6E202A20407265';
wwv_flow_imp.g_varchar2_table(5241) := '7475726E207B48544D4C456C656D656E747D5C6E202A2F5C6E50616C657474652E70726F746F747970652E5F676574506172656E74436F6E7461696E6572203D2066756E6374696F6E2829207B5C6E202072657475726E20746869732E5F63616E766173';
wwv_flow_imp.g_varchar2_table(5242) := '2E676574436F6E7461696E657228293B5C6E7D3B5C6E5C6E5C6E2F2A206D61726B757020646566696E6974696F6E202A2F5C6E5C6E50616C657474652E48544D4C5F4D41524B5550203D5C6E2020273C64697620636C6173733D5C22646A732D70616C65';
wwv_flow_imp.g_varchar2_table(5243) := '7474655C223E27202B5C6E20202020273C64697620636C6173733D5C22646A732D70616C657474652D656E74726965735C223E3C2F6469763E27202B5C6E20202020273C64697620636C6173733D5C22646A732D70616C657474652D746F67676C655C22';
wwv_flow_imp.g_varchar2_table(5244) := '3E3C2F6469763E27202B5C6E2020273C2F6469763E273B5C6E5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E20616464436C617373657328656C656D656E742C20636C617373';
wwv_flow_imp.g_varchar2_table(5245) := '4E616D657329207B5C6E5C6E202076617220636C6173736573203D20646F6D436C617373657328656C656D656E74293B5C6E5C6E20207661722061637475616C436C6173734E616D6573203D206973417272617928636C6173734E616D657329203F2063';
wwv_flow_imp.g_varchar2_table(5246) := '6C6173734E616D6573203A20636C6173734E616D65732E73706C6974282F5C5C732B2F67293B5C6E202061637475616C436C6173734E616D65732E666F72456163682866756E6374696F6E28636C7329207B5C6E20202020636C61737365732E61646428';
wwv_flow_imp.g_varchar2_table(5247) := '636C73293B5C6E20207D293B5C6E7D5C6E5C6E66756E6374696F6E2061646450616C65747465456E747269657328656E74726965732C2070726F766964657229207B5C6E5C6E202076617220656E74726965734F7255706461746572203D2070726F7669';
wwv_flow_imp.g_varchar2_table(5248) := '6465722E67657450616C65747465456E747269657328293B5C6E5C6E202069662028697346756E6374696F6E28656E74726965734F72557064617465722929207B5C6E2020202072657475726E20656E74726965734F725570646174657228656E747269';
wwv_flow_imp.g_varchar2_table(5249) := '6573293B5C6E20207D5C6E5C6E2020666F724561636828656E74726965734F72557064617465722C2066756E6374696F6E28656E7472792C20696429207B5C6E20202020656E74726965735B69645D203D20656E7472793B5C6E20207D293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(5250) := '2072657475726E20656E74726965733B5C6E7D222C22696D706F72742050616C657474652066726F6D20272E2F50616C65747465273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065207B20696D706F727428276469646927292E4D6F64756C65446563';
wwv_flow_imp.g_varchar2_table(5251) := '6C61726174696F6E207D5C6E202A2F5C6E6578706F72742064656661756C74207B5C6E20205F5F696E69745F5F3A205B202770616C6574746527205D2C5C6E202070616C657474653A205B202774797065272C2050616C65747465205D5C6E7D3B5C6E22';
wwv_flow_imp.g_varchar2_table(5252) := '2C22696D706F727420696E6865726974732066726F6D2027696E6865726974732D62726F77736572273B5C6E5C6E696D706F727420436F6D6D616E64496E746572636570746F722066726F6D20272E2E2F2E2E2F636F6D6D616E642F436F6D6D616E6449';
wwv_flow_imp.g_varchar2_table(5253) := '6E746572636570746F72273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428276469646927292E496E6A6563746F727D20496E6A6563746F725C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F';
wwv_flow_imp.g_varchar2_table(5254) := '636F72652F43616E76617327292E64656661756C747D2043616E7661735C6E202A2F5C6E5C6E2F2A2A5C6E202A2041206D6F64656C696E67206265686176696F72207468617420656E7375726573207765207365742074686520636F727265637420726F';
wwv_flow_imp.g_varchar2_table(5255) := '6F7420656C656D656E745C6E202A20617320776520756E646F20616E64207265646F20636F6D6D616E64732E5C6E202A5C6E202A2040706172616D207B43616E7661737D2063616E7661735C6E202A2040706172616D207B496E6A6563746F727D20696E';
wwv_flow_imp.g_varchar2_table(5256) := '6A6563746F725C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E20526F6F74456C656D656E74734265686176696F722863616E7661732C20696E6A6563746F7229207B5C6E5C6E2020696E6A6563746F722E696E766F6B652843';
wwv_flow_imp.g_varchar2_table(5257) := '6F6D6D616E64496E746572636570746F722C2074686973293B5C6E5C6E2020746869732E65786563757465642866756E6374696F6E286576656E7429207B5C6E2020202076617220636F6E74657874203D206576656E742E636F6E746578743B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5258) := '2020202069662028636F6E746578742E726F6F74456C656D656E7429207B5C6E20202020202063616E7661732E736574526F6F74456C656D656E7428636F6E746578742E726F6F74456C656D656E74293B5C6E202020207D20656C7365207B5C6E202020';
wwv_flow_imp.g_varchar2_table(5259) := '202020636F6E746578742E726F6F74456C656D656E74203D2063616E7661732E676574526F6F74456C656D656E7428293B5C6E202020207D5C6E20207D293B5C6E5C6E2020746869732E7265766572742866756E6374696F6E286576656E7429207B5C6E';
wwv_flow_imp.g_varchar2_table(5260) := '2020202076617220636F6E74657874203D206576656E742E636F6E746578743B5C6E5C6E2020202069662028636F6E746578742E726F6F74456C656D656E7429207B5C6E20202020202063616E7661732E736574526F6F74456C656D656E7428636F6E74';
wwv_flow_imp.g_varchar2_table(5261) := '6578742E726F6F74456C656D656E74293B5C6E202020207D5C6E20207D293B5C6E7D5C6E5C6E696E68657269747328526F6F74456C656D656E74734265686176696F722C20436F6D6D616E64496E746572636570746F72293B5C6E5C6E526F6F74456C65';
wwv_flow_imp.g_varchar2_table(5262) := '6D656E74734265686176696F722E24696E6A656374203D205B202763616E766173272C2027696E6A6563746F7227205D3B222C22696D706F727420526F6F74456C656D656E74734265686176696F722066726F6D20272E2F526F6F74456C656D656E7473';
wwv_flow_imp.g_varchar2_table(5263) := '4265686176696F72273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D5C6E202A2F5C6E6578706F72742064656661756C74207B5C6E20205F5F696E69745F';
wwv_flow_imp.g_varchar2_table(5264) := '5F3A205B2027726F6F74456C656D656E74734265686176696F7227205D2C5C6E2020726F6F74456C656D656E74734265686176696F723A205B202774797065272C20526F6F74456C656D656E74734265686176696F72205D5C6E7D3B5C6E222C22696D70';
wwv_flow_imp.g_varchar2_table(5265) := '6F7274207B5C6E2020697341727261792C5C6E2020666F72456163685C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E6465';
wwv_flow_imp.g_varchar2_table(5266) := '6661756C747D2043616E7661735C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A2F5C6E5C6E2F2A2A5C6E202A204120736572766963';
wwv_flow_imp.g_varchar2_table(5267) := '652074686174206F6666657273207468652063757272656E742073656C656374696F6E20696E2061206469616772616D2E5C6E202A204F6666657273207468652061706920746F20636F6E74726F6C207468652073656C656374696F6E2C20746F6F2E5C';
wwv_flow_imp.g_varchar2_table(5268) := '6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B43616E7661737D2063616E7661735C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E2053656C656374696F';
wwv_flow_imp.g_varchar2_table(5269) := '6E286576656E744275732C2063616E76617329207B5C6E5C6E2020746869732E5F6576656E74427573203D206576656E744275733B5C6E2020746869732E5F63616E766173203D2063616E7661733B5C6E5C6E20202F2A2A5C6E2020202A204074797065';
wwv_flow_imp.g_varchar2_table(5270) := '207B4F626A6563745B5D7D5C6E2020202A2F5C6E2020746869732E5F73656C6563746564456C656D656E7473203D205B5D3B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E20206576656E744275732E6F6E285B202773686170652E72';
wwv_flow_imp.g_varchar2_table(5271) := '656D6F7665272C2027636F6E6E656374696F6E2E72656D6F766527205D2C2066756E6374696F6E286529207B5C6E2020202076617220656C656D656E74203D20652E656C656D656E743B5C6E2020202073656C662E646573656C65637428656C656D656E';
wwv_flow_imp.g_varchar2_table(5272) := '74293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E285B20276469616772616D2E636C656172272C2027726F6F742E73657427205D2C2066756E6374696F6E286529207B5C6E2020202073656C662E73656C656374286E756C6C293B5C6E';
wwv_flow_imp.g_varchar2_table(5273) := '20207D293B5C6E7D5C6E5C6E53656C656374696F6E2E24696E6A656374203D205B20276576656E74427573272C202763616E76617327205D3B5C6E5C6E2F2A2A5C6E202A20446573656C65637420616E20656C656D656E742E5C6E202A5C6E202A204070';
wwv_flow_imp.g_varchar2_table(5274) := '6172616D207B4F626A6563747D20656C656D656E742054686520656C656D656E7420746F20646573656C6563742E5C6E202A2F5C6E53656C656374696F6E2E70726F746F747970652E646573656C656374203D2066756E6374696F6E28656C656D656E74';
wwv_flow_imp.g_varchar2_table(5275) := '29207B5C6E20207661722073656C6563746564456C656D656E7473203D20746869732E5F73656C6563746564456C656D656E74733B5C6E5C6E202076617220696478203D2073656C6563746564456C656D656E74732E696E6465784F6628656C656D656E';
wwv_flow_imp.g_varchar2_table(5276) := '74293B5C6E5C6E20206966202869647820213D3D202D3129207B5C6E20202020766172206F6C6453656C656374696F6E203D2073656C6563746564456C656D656E74732E736C69636528293B5C6E5C6E2020202073656C6563746564456C656D656E7473';
wwv_flow_imp.g_varchar2_table(5277) := '2E73706C696365286964782C2031293B5C6E5C6E20202020746869732E5F6576656E744275732E66697265282773656C656374696F6E2E6368616E676564272C207B206F6C6453656C656374696F6E3A206F6C6453656C656374696F6E2C206E65775365';
wwv_flow_imp.g_varchar2_table(5278) := '6C656374696F6E3A2073656C6563746564456C656D656E7473207D293B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A20476574207468652073656C656374656420656C656D656E74732E5C6E202A5C6E202A204072657475726E207B4F626A656374';
wwv_flow_imp.g_varchar2_table(5279) := '5B5D7D205468652073656C656374656420656C656D656E74732E5C6E202A2F5C6E53656C656374696F6E2E70726F746F747970652E676574203D2066756E6374696F6E2829207B5C6E202072657475726E20746869732E5F73656C6563746564456C656D';
wwv_flow_imp.g_varchar2_table(5280) := '656E74733B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20436865636B207768657468657220616E20656C656D656E742069732073656C65637465642E5C6E202A5C6E202A2040706172616D207B4F626A6563747D20656C656D656E742054686520656C656D65';
wwv_flow_imp.g_varchar2_table(5281) := '6E742E5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D20576865746865722074686520656C656D656E742069732073656C65637465642E5C6E202A2F5C6E53656C656374696F6E2E70726F746F747970652E697353656C656374656420';
wwv_flow_imp.g_varchar2_table(5282) := '3D2066756E6374696F6E28656C656D656E7429207B5C6E202072657475726E20746869732E5F73656C6563746564456C656D656E74732E696E6465784F6628656C656D656E742920213D3D202D313B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2053656C';
wwv_flow_imp.g_varchar2_table(5283) := '656374206F6E65206F72206D616E7920656C656D656E74732E5C6E202A5C6E202A2040706172616D207B4F626A6563747C4F626A6563745B5D7D20656C656D656E74732054686520656C656D656E7428732920746F2073656C6563742E5C6E202A204070';
wwv_flow_imp.g_varchar2_table(5284) := '6172616D207B626F6F6C65616E7D205B6164645D205768657468657220746F206164642074686520656C656D656E7428732920746F207468652073656C656374656420656C656D656E74732E5C6E202A2044656661756C747320746F206066616C736560';
wwv_flow_imp.g_varchar2_table(5285) := '2E5C6E202A2F5C6E53656C656374696F6E2E70726F746F747970652E73656C656374203D2066756E6374696F6E28656C656D656E74732C2061646429207B5C6E20207661722073656C6563746564456C656D656E7473203D20746869732E5F73656C6563';
wwv_flow_imp.g_varchar2_table(5286) := '746564456C656D656E74732C5C6E2020202020206F6C6453656C656374696F6E203D2073656C6563746564456C656D656E74732E736C69636528293B5C6E5C6E202069662028216973417272617928656C656D656E74732929207B5C6E20202020656C65';
wwv_flow_imp.g_varchar2_table(5287) := '6D656E7473203D20656C656D656E7473203F205B20656C656D656E7473205D203A205B5D3B5C6E20207D5C6E5C6E20207661722063616E766173203D20746869732E5F63616E7661733B5C6E5C6E202076617220726F6F74456C656D656E74203D206361';
wwv_flow_imp.g_varchar2_table(5288) := '6E7661732E676574526F6F74456C656D656E7428293B5C6E5C6E2020656C656D656E7473203D20656C656D656E74732E66696C7465722866756E6374696F6E28656C656D656E7429207B5C6E2020202076617220656C656D656E74526F6F74203D206361';
wwv_flow_imp.g_varchar2_table(5289) := '6E7661732E66696E64526F6F7428656C656D656E74293B5C6E5C6E2020202072657475726E20726F6F74456C656D656E74203D3D3D20656C656D656E74526F6F743B5C6E20207D293B5C6E5C6E20202F2F2073656C656374696F6E206D61792062652063';
wwv_flow_imp.g_varchar2_table(5290) := '6C65617265642062792070617373696E6720616E20656D707479206172726179206F72206E756C6C5C6E20202F2F20746F20746865206D6574686F645C6E20206966202861646429207B5C6E20202020666F724561636828656C656D656E74732C206675';
wwv_flow_imp.g_varchar2_table(5291) := '6E6374696F6E28656C656D656E7429207B5C6E2020202020206966202873656C6563746564456C656D656E74732E696E6465784F6628656C656D656E742920213D3D202D3129207B5C6E5C6E20202020202020202F2F20616C72656164792073656C6563';
wwv_flow_imp.g_varchar2_table(5292) := '7465645C6E202020202020202072657475726E3B5C6E2020202020207D20656C7365207B5C6E202020202020202073656C6563746564456C656D656E74732E7075736828656C656D656E74293B5C6E2020202020207D5C6E202020207D293B5C6E20207D';
wwv_flow_imp.g_varchar2_table(5293) := '20656C7365207B5C6E20202020746869732E5F73656C6563746564456C656D656E7473203D2073656C6563746564456C656D656E7473203D20656C656D656E74732E736C69636528293B5C6E20207D5C6E5C6E2020746869732E5F6576656E744275732E';
wwv_flow_imp.g_varchar2_table(5294) := '66697265282773656C656374696F6E2E6368616E676564272C207B206F6C6453656C656374696F6E3A206F6C6453656C656374696F6E2C206E657753656C656374696F6E3A2073656C6563746564456C656D656E7473207D293B5C6E7D3B5C6E222C2269';
wwv_flow_imp.g_varchar2_table(5295) := '6D706F7274207B5C6E20206861735365636F6E646172794D6F6469666965722C5C6E202069735072696D617279427574746F6E5C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F4D6F757365273B5C6E5C6E696D706F7274207B5C6E202066696E642C';
wwv_flow_imp.g_varchar2_table(5296) := '5C6E2020697341727261795C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E64656661756C747D2043616E7661735C6E202A';
wwv_flow_imp.g_varchar2_table(5297) := '204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F456C656D656E74526567697374727927292E64656661756C747D20456C656D656E7452656769737472795C6E202A204074797065646566207B696D706F727428272E2E2F2E2E';
wwv_flow_imp.g_varchar2_table(5298) := '2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A204074797065646566207B696D706F727428272E2F53656C656374696F6E27292E64656661756C747D2053656C656374696F6E5C6E202A2F5C6E5C6E2F2A';
wwv_flow_imp.g_varchar2_table(5299) := '2A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B53656C656374696F6E7D2073656C656374696F6E5C6E202A2040706172616D207B43616E7661737D2063616E7661735C6E202A20407061';
wwv_flow_imp.g_varchar2_table(5300) := '72616D207B456C656D656E7452656769737472797D20656C656D656E7452656769737472795C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E2053656C656374696F6E4265686176696F72286576656E744275732C2073656C65';
wwv_flow_imp.g_varchar2_table(5301) := '6374696F6E2C2063616E7661732C20656C656D656E74526567697374727929207B5C6E5C6E20202F2F2053656C65637420656C656D656E7473206F6E206372656174655C6E20206576656E744275732E6F6E28276372656174652E656E64272C20353030';
wwv_flow_imp.g_varchar2_table(5302) := '2C2066756E6374696F6E286576656E7429207B5C6E2020202076617220636F6E74657874203D206576656E742E636F6E746578742C5C6E202020202020202063616E45786563757465203D20636F6E746578742E63616E457865637574652C5C6E202020';
wwv_flow_imp.g_varchar2_table(5303) := '2020202020656C656D656E7473203D20636F6E746578742E656C656D656E74732C5C6E202020202020202068696E7473203D20636F6E746578742E68696E7473207C7C207B7D2C5C6E20202020202020206175746F53656C656374203D2068696E74732E';
wwv_flow_imp.g_varchar2_table(5304) := '6175746F53656C6563743B5C6E5C6E202020206966202863616E4578656375746529207B5C6E202020202020696620286175746F53656C656374203D3D3D2066616C736529207B5C6E5C6E20202020202020202F2F2053656C656374206E6F20656C656D';
wwv_flow_imp.g_varchar2_table(5305) := '656E74735C6E202020202020202072657475726E3B5C6E2020202020207D5C6E5C6E2020202020206966202869734172726179286175746F53656C6563742929207B5C6E202020202020202073656C656374696F6E2E73656C656374286175746F53656C';
wwv_flow_imp.g_varchar2_table(5306) := '656374293B5C6E2020202020207D20656C7365207B5C6E5C6E20202020202020202F2F2053656C65637420616C6C20656C656D656E74732062792064656661756C745C6E202020202020202073656C656374696F6E2E73656C65637428656C656D656E74';
wwv_flow_imp.g_varchar2_table(5307) := '732E66696C74657228697353686F776E29293B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E5C6E20202F2F2053656C65637420636F6E6E656374696F6E2074617267657473206F6E20636F6E6E6563745C6E20206576656E744275732E';
wwv_flow_imp.g_varchar2_table(5308) := '6F6E2827636F6E6E6563742E656E64272C203530302C2066756E6374696F6E286576656E7429207B5C6E2020202076617220636F6E74657874203D206576656E742E636F6E746578742C5C6E2020202020202020636F6E6E656374696F6E203D20636F6E';
wwv_flow_imp.g_varchar2_table(5309) := '746578742E636F6E6E656374696F6E3B5C6E5C6E2020202069662028636F6E6E656374696F6E29207B5C6E20202020202073656C656374696F6E2E73656C65637428636F6E6E656374696F6E293B5C6E202020207D5C6E20207D293B5C6E5C6E20202F2F';
wwv_flow_imp.g_varchar2_table(5310) := '2053656C65637420736861706573206F6E206D6F76655C6E20206576656E744275732E6F6E282773686170652E6D6F76652E656E64272C203530302C2066756E6374696F6E286576656E7429207B5C6E202020207661722070726576696F757353656C65';
wwv_flow_imp.g_varchar2_table(5311) := '6374696F6E203D206576656E742E70726576696F757353656C656374696F6E207C7C205B5D3B5C6E5C6E20202020766172207368617065203D20656C656D656E7452656769737472792E676574286576656E742E636F6E746578742E73686170652E6964';
wwv_flow_imp.g_varchar2_table(5312) := '293B5C6E5C6E202020202F2F20416C776179732073656C656374206D61696E207368617065206F6E206D6F76655C6E2020202076617220697353656C6563746564203D2066696E642870726576696F757353656C656374696F6E2C2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(5313) := '2873656C6563746564536861706529207B5C6E20202020202072657475726E2073686170652E6964203D3D3D2073656C656374656453686170652E69643B5C6E202020207D293B5C6E5C6E202020206966202821697353656C656374656429207B5C6E20';
wwv_flow_imp.g_varchar2_table(5314) := '202020202073656C656374696F6E2E73656C656374287368617065293B5C6E202020207D5C6E20207D293B5C6E5C6E20202F2F2053656C65637420656C656D656E7473206F6E20636C69636B5C6E20206576656E744275732E6F6E2827656C656D656E74';
wwv_flow_imp.g_varchar2_table(5315) := '2E636C69636B272C2066756E6374696F6E286576656E7429207B5C6E5C6E20202020696620282169735072696D617279427574746F6E286576656E742929207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E2020202076617220656C';
wwv_flow_imp.g_varchar2_table(5316) := '656D656E74203D206576656E742E656C656D656E743B5C6E5C6E2020202069662028656C656D656E74203D3D3D2063616E7661732E676574526F6F74456C656D656E74282929207B5C6E202020202020656C656D656E74203D206E756C6C3B5C6E202020';
wwv_flow_imp.g_varchar2_table(5317) := '207D5C6E5C6E2020202076617220697353656C6563746564203D2073656C656374696F6E2E697353656C656374656428656C656D656E74292C5C6E202020202020202069734D756C746953656C656374203D2073656C656374696F6E2E67657428292E6C';
wwv_flow_imp.g_varchar2_table(5318) := '656E677468203E20313B5C6E5C6E202020202F2F2041646420746F2073656C656374696F6E20696620534849465420707265737365645C6E2020202076617220616464203D206861735365636F6E646172794D6F646966696572286576656E74293B5C6E';
wwv_flow_imp.g_varchar2_table(5319) := '5C6E2020202069662028697353656C65637465642026262069734D756C746953656C65637429207B5C6E2020202020206966202861646429207B5C6E5C6E20202020202020202F2F20446573656C65637420656C656D656E745C6E202020202020202072';
wwv_flow_imp.g_varchar2_table(5320) := '657475726E2073656C656374696F6E2E646573656C65637428656C656D656E74293B5C6E2020202020207D20656C7365207B5C6E5C6E20202020202020202F2F2053656C65637420656C656D656E74206F6E6C795C6E202020202020202072657475726E';
wwv_flow_imp.g_varchar2_table(5321) := '2073656C656374696F6E2E73656C65637428656C656D656E74293B5C6E2020202020207D5C6E202020207D20656C7365206966202821697353656C656374656429207B5C6E5C6E2020202020202F2F2053656C65637420656C656D656E745C6E20202020';
wwv_flow_imp.g_varchar2_table(5322) := '202073656C656374696F6E2E73656C65637428656C656D656E742C20616464293B5C6E202020207D20656C7365207B5C6E5C6E2020202020202F2F20446573656C65637420656C656D656E745C6E20202020202073656C656374696F6E2E646573656C65';
wwv_flow_imp.g_varchar2_table(5323) := '637428656C656D656E74293B5C6E202020207D5C6E20207D293B5C6E7D5C6E5C6E53656C656374696F6E4265686176696F722E24696E6A656374203D205B5C6E2020276576656E74427573272C5C6E20202773656C656374696F6E272C5C6E2020276361';
wwv_flow_imp.g_varchar2_table(5324) := '6E766173272C5C6E202027656C656D656E745265676973747279275C6E5D3B5C6E5C6E5C6E66756E6374696F6E20697353686F776E28656C656D656E7429207B5C6E202072657475726E2021656C656D656E742E68696464656E3B5C6E7D5C6E222C2269';
wwv_flow_imp.g_varchar2_table(5325) := '6D706F7274207B5C6E202061737369676E2C5C6E2020666F72456163685C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E2020617070656E6420617320737667417070656E642C5C6E20206174747220617320737667';
wwv_flow_imp.g_varchar2_table(5326) := '417474722C5C6E2020636C617373657320617320737667436C61737365732C5C6E2020636C65617220617320737667436C6561722C5C6E2020637265617465206173207376674372656174655C6E7D2066726F6D202774696E792D737667273B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5327) := '696D706F7274207B2067657442426F78207D2066726F6D20272E2E2F2E2E2F7574696C2F456C656D656E7473273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E64656661';
wwv_flow_imp.g_varchar2_table(5328) := '756C747D2043616E7661735C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A204074797065646566207B696D706F727428272E2F5365';
wwv_flow_imp.g_varchar2_table(5329) := '6C656374696F6E27292E64656661756C747D2053656C656374696F6E5C6E202A2F5C6E5C6E766172204D41524B45525F484F564552203D2027686F766572272C5C6E202020204D41524B45525F53454C4543544544203D202773656C6563746564273B5C';
wwv_flow_imp.g_varchar2_table(5330) := '6E5C6E7661722053454C454354494F4E5F4F55544C494E455F50414444494E47203D20363B5C6E5C6E5C6E2F2A2A5C6E202A204120706C7567696E2074686174206164647320612076697369626C652073656C656374696F6E20554920746F2073686170';
wwv_flow_imp.g_varchar2_table(5331) := '657320616E6420636F6E6E656374696F6E735C6E202A20627920617070656E64696E6720746865203C636F64653E686F7665723C2F636F64653E20616E64203C636F64653E73656C65637465643C2F636F64653E20636C617373657320746F207468656D';
wwv_flow_imp.g_varchar2_table(5332) := '2E5C6E202A5C6E202A2040636C6173735C6E202A5C6E202A204D616B657320656C656D656E74732073656C65637461626C652C20746F6F2E5C6E202A5C6E202A2040706172616D207B43616E7661737D2063616E7661735C6E202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(5333) := '4576656E744275737D206576656E744275735C6E202A2040706172616D207B53656C656374696F6E7D2073656C656374696F6E5C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E2053656C656374696F6E56697375616C732863';
wwv_flow_imp.g_varchar2_table(5334) := '616E7661732C206576656E744275732C2073656C656374696F6E29207B5C6E2020746869732E5F63616E766173203D2063616E7661733B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E2020746869732E5F6D756C746953656C656374';
wwv_flow_imp.g_varchar2_table(5335) := '696F6E426F78203D206E756C6C3B5C6E5C6E202066756E6374696F6E206164644D61726B657228652C20636C7329207B5C6E2020202063616E7661732E6164644D61726B657228652C20636C73293B5C6E20207D5C6E5C6E202066756E6374696F6E2072';
wwv_flow_imp.g_varchar2_table(5336) := '656D6F76654D61726B657228652C20636C7329207B5C6E2020202063616E7661732E72656D6F76654D61726B657228652C20636C73293B5C6E20207D5C6E5C6E20206576656E744275732E6F6E2827656C656D656E742E686F766572272C2066756E6374';
wwv_flow_imp.g_varchar2_table(5337) := '696F6E286576656E7429207B5C6E202020206164644D61726B6572286576656E742E656C656D656E742C204D41524B45525F484F564552293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E2827656C656D656E742E6F7574272C2066756E';
wwv_flow_imp.g_varchar2_table(5338) := '6374696F6E286576656E7429207B5C6E2020202072656D6F76654D61726B6572286576656E742E656C656D656E742C204D41524B45525F484F564552293B5C6E20207D293B5C6E5C6E20206576656E744275732E6F6E282773656C656374696F6E2E6368';
wwv_flow_imp.g_varchar2_table(5339) := '616E676564272C2066756E6374696F6E286576656E7429207B5C6E5C6E2020202066756E6374696F6E20646573656C656374287329207B5C6E20202020202072656D6F76654D61726B657228732C204D41524B45525F53454C4543544544293B5C6E2020';
wwv_flow_imp.g_varchar2_table(5340) := '20207D5C6E5C6E2020202066756E6374696F6E2073656C656374287329207B5C6E2020202020206164644D61726B657228732C204D41524B45525F53454C4543544544293B5C6E202020207D5C6E5C6E20202020766172206F6C6453656C656374696F6E';
wwv_flow_imp.g_varchar2_table(5341) := '203D206576656E742E6F6C6453656C656374696F6E2C5C6E20202020202020206E657753656C656374696F6E203D206576656E742E6E657753656C656374696F6E3B5C6E5C6E20202020666F7245616368286F6C6453656C656374696F6E2C2066756E63';
wwv_flow_imp.g_varchar2_table(5342) := '74696F6E286529207B5C6E202020202020696620286E657753656C656374696F6E2E696E6465784F66286529203D3D3D202D3129207B5C6E2020202020202020646573656C6563742865293B5C6E2020202020207D5C6E202020207D293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5343) := '2020666F7245616368286E657753656C656374696F6E2C2066756E6374696F6E286529207B5C6E202020202020696620286F6C6453656C656374696F6E2E696E6465784F66286529203D3D3D202D3129207B5C6E202020202020202073656C6563742865';
wwv_flow_imp.g_varchar2_table(5344) := '293B5C6E2020202020207D5C6E202020207D293B5C6E5C6E2020202073656C662E5F75706461746553656C656374696F6E4F75746C696E65286E657753656C656374696F6E293B5C6E20207D293B5C6E5C6E5C6E20206576656E744275732E6F6E282765';
wwv_flow_imp.g_varchar2_table(5345) := '6C656D656E742E6368616E676564272C2066756E6374696F6E286576656E7429207B5C6E202020206966202873656C656374696F6E2E697353656C6563746564286576656E742E656C656D656E742929207B5C6E20202020202073656C662E5F75706461';
wwv_flow_imp.g_varchar2_table(5346) := '746553656C656374696F6E4F75746C696E652873656C656374696F6E2E6765742829293B5C6E202020207D5C6E20207D293B5C6E7D5C6E5C6E53656C656374696F6E56697375616C732E24696E6A656374203D205B5C6E20202763616E766173272C5C6E';
wwv_flow_imp.g_varchar2_table(5347) := '2020276576656E74427573272C5C6E20202773656C656374696F6E275C6E5D3B5C6E5C6E53656C656374696F6E56697375616C732E70726F746F747970652E5F75706461746553656C656374696F6E4F75746C696E65203D2066756E6374696F6E287365';
wwv_flow_imp.g_varchar2_table(5348) := '6C656374696F6E29207B5C6E2020766172206C61796572203D20746869732E5F63616E7661732E6765744C61796572282773656C656374696F6E4F75746C696E6527293B5C6E5C6E2020737667436C656172286C61796572293B5C6E5C6E202076617220';
wwv_flow_imp.g_varchar2_table(5349) := '656E61626C6564203D2073656C656374696F6E2E6C656E677468203E20313B5C6E5C6E202076617220636F6E7461696E6572203D20746869732E5F63616E7661732E676574436F6E7461696E657228293B5C6E5C6E2020737667436C617373657328636F';
wwv_flow_imp.g_varchar2_table(5350) := '6E7461696E6572295B656E61626C6564203F202761646427203A202772656D6F7665275D2827646A732D6D756C74692D73656C65637427293B5C6E5C6E20206966202821656E61626C656429207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5351) := '20207661722062426F78203D2061646453656C656374696F6E4F75746C696E6550616464696E672867657442426F782873656C656374696F6E29293B5C6E5C6E20207661722072656374203D2073766743726561746528277265637427293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(5352) := '207376674174747228726563742C2061737369676E287B5C6E2020202072783A20335C6E20207D2C2062426F7829293B5C6E5C6E2020737667436C61737365732872656374292E6164642827646A732D73656C656374696F6E2D6F75746C696E6527293B';
wwv_flow_imp.g_varchar2_table(5353) := '5C6E5C6E2020737667417070656E64286C617965722C2072656374293B5C6E7D3B5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E2061646453656C656374696F6E4F75746C696E6550616464696E67286242';
wwv_flow_imp.g_varchar2_table(5354) := '6F7829207B5C6E202072657475726E207B5C6E20202020783A2062426F782E78202D2053454C454354494F4E5F4F55544C494E455F50414444494E472C5C6E20202020793A2062426F782E79202D2053454C454354494F4E5F4F55544C494E455F504144';
wwv_flow_imp.g_varchar2_table(5355) := '44494E472C5C6E2020202077696474683A2062426F782E7769647468202B2053454C454354494F4E5F4F55544C494E455F50414444494E47202A20322C5C6E202020206865696768743A2062426F782E686569676874202B2053454C454354494F4E5F4F';
wwv_flow_imp.g_varchar2_table(5356) := '55544C494E455F50414444494E47202A20325C6E20207D3B5C6E7D222C22696D706F727420496E746572616374696F6E4576656E74734D6F64756C652066726F6D20272E2E2F696E746572616374696F6E2D6576656E7473273B5C6E696D706F7274204F';
wwv_flow_imp.g_varchar2_table(5357) := '75746C696E654D6F64756C652066726F6D20272E2E2F6F75746C696E65273B5C6E5C6E696D706F72742053656C656374696F6E2066726F6D20272E2F53656C656374696F6E273B5C6E696D706F72742053656C656374696F6E56697375616C732066726F';
wwv_flow_imp.g_varchar2_table(5358) := '6D20272E2F53656C656374696F6E56697375616C73273B5C6E696D706F72742053656C656374696F6E4265686176696F722066726F6D20272E2F53656C656374696F6E4265686176696F72273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065207B2069';
wwv_flow_imp.g_varchar2_table(5359) := '6D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D5C6E202A2F5C6E6578706F72742064656661756C74207B5C6E20205F5F696E69745F5F3A205B202773656C656374696F6E56697375616C73272C202773656C65637469';
wwv_flow_imp.g_varchar2_table(5360) := '6F6E4265686176696F7227205D2C5C6E20205F5F646570656E64735F5F3A205B5C6E20202020496E746572616374696F6E4576656E74734D6F64756C652C5C6E202020204F75746C696E654D6F64756C655C6E20205D2C5C6E202073656C656374696F6E';
wwv_flow_imp.g_varchar2_table(5361) := '3A205B202774797065272C2053656C656374696F6E205D2C5C6E202073656C656374696F6E56697375616C733A205B202774797065272C2053656C656374696F6E56697375616C73205D2C5C6E202073656C656374696F6E4265686176696F723A205B20';
wwv_flow_imp.g_varchar2_table(5362) := '2774797065272C2053656C656374696F6E4265686176696F72205D5C6E7D3B5C6E222C22696D706F7274207472616E736C6174652066726F6D20272E2F7472616E736C617465273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065207B20696D706F7274';
wwv_flow_imp.g_varchar2_table(5363) := '28276469646927292E4D6F64756C654465636C61726174696F6E207D5C6E202A2F5C6E6578706F72742064656661756C74207B5C6E20207472616E736C6174653A205B202776616C7565272C207472616E736C617465205D5C6E7D3B222C222F2A2A5C6E';
wwv_flow_imp.g_varchar2_table(5364) := '202A204074797065646566207B207B5C6E202A2020205B6B65793A20737472696E675D3A20737472696E673B5C6E202A207D207D205472616E736C6174655265706C6163656D656E74735C6E202A2F5C6E5C6E2F2A2A5C6E202A20412073696D706C6520';
wwv_flow_imp.g_varchar2_table(5365) := '7472616E736C6174696F6E207374756220746F206265207573656420666F72206D756C74692D6C616E677561676520737570706F72745C6E202A20696E206469616772616D732E2043616E20626520656173696C79207265706C61636564207769746820';
wwv_flow_imp.g_varchar2_table(5366) := '61206D6F726520736F70686973746963617465645C6E202A20736F6C7574696F6E2E5C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206060606A6176617363726970745C6E202A202F2F2075736520697420696E7369646520616E792064';
wwv_flow_imp.g_varchar2_table(5367) := '69616772616D20636F6D706F6E656E7420627920696E6A656374696E6720607472616E736C617465602E5C6E202A5C6E202A2066756E6374696F6E204D7953657276696365287472616E736C61746529207B5C6E202A202020616C657274287472616E73';
wwv_flow_imp.g_varchar2_table(5368) := '6C617465282748454C4C4F207B796F757D272C207B20796F753A2027596F752127207D29293B5C6E202A207D5C6E202A206060605C6E202A5C6E202A2040706172616D207B737472696E677D2074656D706C61746520746F20696E746572706F6C617465';
wwv_flow_imp.g_varchar2_table(5369) := '5C6E202A2040706172616D207B5472616E736C6174655265706C6163656D656E74737D205B7265706C6163656D656E74735D2061206D617020776974682073756273746974757465735C6E202A5C6E202A204072657475726E207B737472696E677D2074';
wwv_flow_imp.g_varchar2_table(5370) := '6865207472616E736C6174656420737472696E675C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E207472616E736C6174652874656D706C6174652C207265706C6163656D656E747329207B5C6E5C6E20207265706C6163656D';
wwv_flow_imp.g_varchar2_table(5371) := '656E7473203D207265706C6163656D656E7473207C7C207B7D3B5C6E5C6E202072657475726E2074656D706C6174652E7265706C616365282F7B285B5E7D5D2B297D2F672C2066756E6374696F6E285F2C206B657929207B5C6E2020202072657475726E';
wwv_flow_imp.g_varchar2_table(5372) := '207265706C6163656D656E74735B6B65795D207C7C20277B27202B206B6579202B20277D273B5C6E20207D293B5C6E7D222C22696D706F7274207B5C6E202069734F626A6563742C5C6E2020736F727442795C6E7D2066726F6D20276D696E2D64617368';
wwv_flow_imp.g_varchar2_table(5373) := '273B5C6E5C6E696D706F7274207B5C6E2020706F696E7444697374616E63652C5C6E2020706F696E74734F6E4C696E655C6E7D2066726F6D20272E2E2F7574696C2F47656F6D65747279273B5C6E5C6E696D706F727420696E7465727365637450617468';
wwv_flow_imp.g_varchar2_table(5374) := '732066726F6D2027706174682D696E74657273656374696F6E273B5C6E5C6E696D706F7274207B206973436F6E6E656374696F6E207D2066726F6D20272E2E2F7574696C2F4D6F64656C5574696C273B5C6E5C6E2F2A2A5C6E202A204074797065646566';
wwv_flow_imp.g_varchar2_table(5375) := '207B696D706F727428272E2E2F636F72652F547970657327292E456C656D656E744C696B657D20456C656D656E745C6E202A204074797065646566207B696D706F727428272E2E2F636F72652F547970657327292E436F6E6E656374696F6E4C696B657D';
wwv_flow_imp.g_varchar2_table(5376) := '20436F6E6E656374696F6E5C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E446972656374696F6E5452424C7D20446972656374696F6E5452424C5C6E202A204074797065646566207B696D70';
wwv_flow_imp.g_varchar2_table(5377) := '6F727428272E2E2F7574696C2F547970657327292E496E74657273656374696F6E7D20496E74657273656374696F6E5C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F696E745C6E';
wwv_flow_imp.g_varchar2_table(5378) := '202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E526563747D20526563745C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E526563745452424C7D2052656374';
wwv_flow_imp.g_varchar2_table(5379) := '5452424C5C6E202A2F5C6E5C6E2F2A2A5C6E202A2040706172616D207B526563747D20626F756E64735C6E202A5C6E202A204072657475726E73207B526563747D5C6E202A2F5C6E6578706F72742066756E6374696F6E20726F756E64426F756E647328';
wwv_flow_imp.g_varchar2_table(5380) := '626F756E647329207B5C6E202072657475726E207B5C6E20202020783A204D6174682E726F756E6428626F756E64732E78292C5C6E20202020793A204D6174682E726F756E6428626F756E64732E79292C5C6E2020202077696474683A204D6174682E72';
wwv_flow_imp.g_varchar2_table(5381) := '6F756E6428626F756E64732E7769647468292C5C6E202020206865696768743A204D6174682E726F756E6428626F756E64732E686569676874295C6E20207D3B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B506F696E747D20706F696E745C';
wwv_flow_imp.g_varchar2_table(5382) := '6E202A5C6E202A204072657475726E73207B506F696E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E20726F756E64506F696E7428706F696E7429207B5C6E5C6E202072657475726E207B5C6E20202020783A204D6174682E726F756E6428';
wwv_flow_imp.g_varchar2_table(5383) := '706F696E742E78292C5C6E20202020793A204D6174682E726F756E6428706F696E742E79295C6E20207D3B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20436F6E766572742074686520676976656E20626F756E647320746F2061207B20746F702C206C6566';
wwv_flow_imp.g_varchar2_table(5384) := '742C20626F74746F6D2C207269676874207D2064657363726970746F722E5C6E202A5C6E202A2040706172616D207B506F696E747C526563747D20626F756E64735C6E202A5C6E202A204072657475726E207B526563745452424C7D5C6E202A2F5C6E65';
wwv_flow_imp.g_varchar2_table(5385) := '78706F72742066756E6374696F6E2061735452424C28626F756E647329207B5C6E202072657475726E207B5C6E20202020746F703A20626F756E64732E792C5C6E2020202072696768743A20626F756E64732E78202B2028626F756E64732E7769647468';
wwv_flow_imp.g_varchar2_table(5386) := '207C7C2030292C5C6E20202020626F74746F6D3A20626F756E64732E79202B2028626F756E64732E686569676874207C7C2030292C5C6E202020206C6566743A20626F756E64732E785C6E20207D3B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20436F6E76';
wwv_flow_imp.g_varchar2_table(5387) := '6572742061207B20746F702C206C6566742C20626F74746F6D2C207269676874207D20746F20616E206F626A6563747320626F756E64732E5C6E202A5C6E202A2040706172616D207B526563745452424C7D207472626C5C6E202A5C6E202A2040726574';
wwv_flow_imp.g_varchar2_table(5388) := '75726E207B526563747D5C6E202A2F5C6E6578706F72742066756E6374696F6E206173426F756E6473287472626C29207B5C6E202072657475726E207B5C6E20202020783A207472626C2E6C6566742C5C6E20202020793A207472626C2E746F702C5C6E';
wwv_flow_imp.g_varchar2_table(5389) := '2020202077696474683A207472626C2E7269676874202D207472626C2E6C6566742C5C6E202020206865696768743A207472626C2E626F74746F6D202D207472626C2E746F705C6E20207D3B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2047657420746865';
wwv_flow_imp.g_varchar2_table(5390) := '206D6964206F662074686520676976656E20626F756E6473206F7220706F696E742E5C6E202A5C6E202A2040706172616D207B506F696E747C526563747D20626F756E64735C6E202A5C6E202A204072657475726E207B506F696E747D5C6E202A2F5C6E';
wwv_flow_imp.g_varchar2_table(5391) := '6578706F72742066756E6374696F6E20676574426F756E64734D696428626F756E647329207B5C6E202072657475726E20726F756E64506F696E74287B5C6E20202020783A20626F756E64732E78202B2028626F756E64732E7769647468207C7C203029';
wwv_flow_imp.g_varchar2_table(5392) := '202F20322C5C6E20202020793A20626F756E64732E79202B2028626F756E64732E686569676874207C7C203029202F20325C6E20207D293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2047657420746865206D6964206F662074686520676976656E20436F';
wwv_flow_imp.g_varchar2_table(5393) := '6E6E656374696F6E2E5C6E202A5C6E202A2040706172616D207B436F6E6E656374696F6E7D20636F6E6E656374696F6E5C6E202A5C6E202A204072657475726E207B506F696E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E20676574436F';
wwv_flow_imp.g_varchar2_table(5394) := '6E6E656374696F6E4D696428636F6E6E656374696F6E29207B5C6E202076617220776179706F696E7473203D20636F6E6E656374696F6E2E776179706F696E74733B5C6E5C6E20202F2F2063616C63756C61746520746F74616C206C656E67746820616E';
wwv_flow_imp.g_varchar2_table(5395) := '64206C656E677468206F662065616368207365676D656E745C6E2020766172207061727473203D20776179706F696E74732E7265647563652866756E6374696F6E2870617274732C20706F696E742C20696E64657829207B5C6E5C6E2020202076617220';
wwv_flow_imp.g_varchar2_table(5396) := '6C617374506F696E74203D20776179706F696E74735B696E646578202D20315D3B5C6E5C6E20202020696620286C617374506F696E7429207B5C6E202020202020766172206C61737450617274203D2070617274735B70617274732E6C656E677468202D';
wwv_flow_imp.g_varchar2_table(5397) := '20315D3B5C6E5C6E2020202020207661722073746172744C656E677468203D206C61737450617274202626206C617374506172742E656E644C656E677468207C7C20303B5C6E202020202020766172206C656E677468203D2064697374616E6365286C61';
wwv_flow_imp.g_varchar2_table(5398) := '7374506F696E742C20706F696E74293B5C6E5C6E20202020202070617274732E70757368287B5C6E202020202020202073746172743A206C617374506F696E742C5C6E2020202020202020656E643A20706F696E742C5C6E202020202020202073746172';
wwv_flow_imp.g_varchar2_table(5399) := '744C656E6774683A2073746172744C656E6774682C5C6E2020202020202020656E644C656E6774683A2073746172744C656E677468202B206C656E6774682C5C6E20202020202020206C656E6774683A206C656E6774685C6E2020202020207D293B5C6E';
wwv_flow_imp.g_varchar2_table(5400) := '202020207D5C6E5C6E2020202072657475726E2070617274733B5C6E20207D2C205B5D293B5C6E5C6E202076617220746F74616C4C656E677468203D2070617274732E7265647563652866756E6374696F6E286C656E6774682C207061727429207B5C6E';
wwv_flow_imp.g_varchar2_table(5401) := '2020202072657475726E206C656E677468202B20706172742E6C656E6774683B5C6E20207D2C2030293B5C6E5C6E20202F2F2066696E6420776869636820736567656D656E7420636F6E7461696E73206D6964646C6520706F696E745C6E202076617220';
wwv_flow_imp.g_varchar2_table(5402) := '6D69644C656E677468203D20746F74616C4C656E677468202F20323B5C6E5C6E20207661722069203D20303B5C6E2020766172206D69645365676D656E74203D2070617274735B695D3B5C6E5C6E20207768696C6520286D69645365676D656E742E656E';
wwv_flow_imp.g_varchar2_table(5403) := '644C656E677468203C206D69644C656E67746829207B5C6E202020206D69645365676D656E74203D2070617274735B2B2B695D3B5C6E20207D5C6E5C6E20202F2F2063616C63756C6174652072656C617469766520706F736974696F6E206F6E206D6964';
wwv_flow_imp.g_varchar2_table(5404) := '207365676D656E745C6E2020766172207365676D656E7450726F6772657373203D20286D69644C656E677468202D206D69645365676D656E742E73746172744C656E67746829202F206D69645365676D656E742E6C656E6774683B5C6E5C6E2020766172';
wwv_flow_imp.g_varchar2_table(5405) := '206D6964506F696E74203D207B5C6E20202020783A206D69645365676D656E742E73746172742E78202B20286D69645365676D656E742E656E642E78202D206D69645365676D656E742E73746172742E7829202A207365676D656E7450726F6772657373';
wwv_flow_imp.g_varchar2_table(5406) := '2C5C6E20202020793A206D69645365676D656E742E73746172742E79202B20286D69645365676D656E742E656E642E79202D206D69645365676D656E742E73746172742E7929202A207365676D656E7450726F67726573735C6E20207D3B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5407) := '72657475726E206D6964506F696E743B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2047657420746865206D6964206F662074686520676976656E20456C656D656E742E5C6E202A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C';
wwv_flow_imp.g_varchar2_table(5408) := '6E202A5C6E202A204072657475726E207B506F696E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E206765744D696428656C656D656E7429207B5C6E2020696620286973436F6E6E656374696F6E28656C656D656E742929207B5C6E202020';
wwv_flow_imp.g_varchar2_table(5409) := '2072657475726E20676574436F6E6E656374696F6E4D696428656C656D656E74293B5C6E20207D5C6E5C6E202072657475726E20676574426F756E64734D696428656C656D656E74293B5C6E7D5C6E5C6E2F2F206F7269656E746174696F6E207574696C';
wwv_flow_imp.g_varchar2_table(5410) := '73202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E2F2A2A5C6E202A20476574206F7269656E746174696F6E206F662074686520676976656E2072656374616E676C652077697468207265737065637420746F5C6E202A207468652072';
wwv_flow_imp.g_varchar2_table(5411) := '65666572656E63652072656374616E676C652E5C6E202A5C6E202A20412070616464696E672028706F736974697665206F72206E6567617469766529206D61792062652070617373656420746F20696E666C75656E63655C6E202A20686F72697A6F6E74';
wwv_flow_imp.g_varchar2_table(5412) := '616C202F20766572746963616C206F7269656E746174696F6E20616E6420696E74657273656374696F6E2E5C6E202A5C6E202A2040706172616D207B526563747D20726563745C6E202A2040706172616D207B526563747D207265666572656E63655C6E';
wwv_flow_imp.g_varchar2_table(5413) := '202A2040706172616D207B506F696E747C6E756D6265727D2070616464696E675C6E202A5C6E202A204072657475726E207B446972656374696F6E5452424C7C496E74657273656374696F6E7D20746865206F7269656E746174696F6E3B206F6E65206F';
wwv_flow_imp.g_varchar2_table(5414) := '6620746F702C20746F702D6C6566742C206C6566742C202E2E2E2C20626F74746F6D2C207269676874206F7220696E746572736563742E5C6E202A2F5C6E6578706F72742066756E6374696F6E206765744F7269656E746174696F6E28726563742C2072';
wwv_flow_imp.g_varchar2_table(5415) := '65666572656E63652C2070616464696E6729207B5C6E5C6E202070616464696E67203D2070616464696E67207C7C20303B5C6E5C6E20202F2F206D616B6520737572652077652063616E2075736520616E206F626A6563742C20746F6F5C6E20202F2F20';
wwv_flow_imp.g_varchar2_table(5416) := '666F7220696E646976696475616C207B20782C2079207D2070616464696E675C6E2020696620282169734F626A6563742870616464696E672929207B5C6E2020202070616464696E67203D207B20783A2070616464696E672C20793A2070616464696E67';
wwv_flow_imp.g_varchar2_table(5417) := '207D3B5C6E20207D5C6E5C6E5C6E202076617220726563744F7269656E746174696F6E203D2061735452424C2872656374292C5C6E2020202020207265666572656E63654F7269656E746174696F6E203D2061735452424C287265666572656E6365293B';
wwv_flow_imp.g_varchar2_table(5418) := '5C6E5C6E202076617220746F70203D20726563744F7269656E746174696F6E2E626F74746F6D202B2070616464696E672E79203C3D207265666572656E63654F7269656E746174696F6E2E746F702C5C6E2020202020207269676874203D20726563744F';
wwv_flow_imp.g_varchar2_table(5419) := '7269656E746174696F6E2E6C656674202D2070616464696E672E78203E3D207265666572656E63654F7269656E746174696F6E2E72696768742C5C6E202020202020626F74746F6D203D20726563744F7269656E746174696F6E2E746F70202D20706164';
wwv_flow_imp.g_varchar2_table(5420) := '64696E672E79203E3D207265666572656E63654F7269656E746174696F6E2E626F74746F6D2C5C6E2020202020206C656674203D20726563744F7269656E746174696F6E2E7269676874202B2070616464696E672E78203C3D207265666572656E63654F';
wwv_flow_imp.g_varchar2_table(5421) := '7269656E746174696F6E2E6C6566743B5C6E5C6E202076617220766572746963616C203D20746F70203F2027746F7027203A2028626F74746F6D203F2027626F74746F6D27203A206E756C6C292C5C6E202020202020686F72697A6F6E74616C203D206C';
wwv_flow_imp.g_varchar2_table(5422) := '656674203F20276C65667427203A20287269676874203F2027726967687427203A206E756C6C293B5C6E5C6E202069662028686F72697A6F6E74616C20262620766572746963616C29207B5C6E2020202072657475726E20766572746963616C202B2027';
wwv_flow_imp.g_varchar2_table(5423) := '2D27202B20686F72697A6F6E74616C3B5C6E20207D20656C7365207B5C6E2020202072657475726E20686F72697A6F6E74616C207C7C20766572746963616C207C7C2027696E74657273656374273B5C6E20207D5C6E7D5C6E5C6E5C6E2F2F20696E7465';
wwv_flow_imp.g_varchar2_table(5424) := '7273656374696F6E207574696C73202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E2F2A2A5C6E202A2047657420696E74657273656374696F6E206265747765656E20616E20656C656D656E7420616E642061206C696E652070617468';
wwv_flow_imp.g_varchar2_table(5425) := '2E5C6E202A5C6E202A2040706172616D207B737472696E677D20656C656D656E74506174685C6E202A2040706172616D207B737472696E677D206C696E65506174685C6E202A2040706172616D207B626F6F6C65616E7D2063726F705374617274205768';
wwv_flow_imp.g_varchar2_table(5426) := '657468657220746F2063726F70207374617274206F7220656E642E5C6E202A5C6E202A204072657475726E207B506F696E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E20676574456C656D656E744C696E65496E74657273656374696F6E';
wwv_flow_imp.g_varchar2_table(5427) := '28656C656D656E74506174682C206C696E65506174682C2063726F70537461727429207B5C6E5C6E202076617220696E74657273656374696F6E73203D20676574496E74657273656374696F6E7328656C656D656E74506174682C206C696E6550617468';
wwv_flow_imp.g_varchar2_table(5428) := '293B5C6E5C6E20202F2F207265636F676E697A6520696E74657273656374696F6E735C6E20202F2F206F6E6C79206F6E65202D3E2063686F6F73655C6E20202F2F2074776F20636C6F736520746F676574686572202D3E2063686F6F7365206669727374';
wwv_flow_imp.g_varchar2_table(5429) := '5C6E20202F2F2074776F206F72206D6F72652064697374696E6374202D3E2070756C6C206F757420617070726F707269617465206F6E655C6E20202F2F206E6F6E65202D3E206F6B202866616C6C6261636B20746F20706F696E7420697473656C66295C';
wwv_flow_imp.g_varchar2_table(5430) := '6E202069662028696E74657273656374696F6E732E6C656E677468203D3D3D203129207B5C6E2020202072657475726E20726F756E64506F696E7428696E74657273656374696F6E735B305D293B5C6E20207D20656C73652069662028696E7465727365';
wwv_flow_imp.g_varchar2_table(5431) := '6374696F6E732E6C656E677468203D3D3D203220262620706F696E7444697374616E636528696E74657273656374696F6E735B305D2C20696E74657273656374696F6E735B315D29203C203129207B5C6E2020202072657475726E20726F756E64506F69';
wwv_flow_imp.g_varchar2_table(5432) := '6E7428696E74657273656374696F6E735B305D293B5C6E20207D20656C73652069662028696E74657273656374696F6E732E6C656E677468203E203129207B5C6E5C6E202020202F2F20736F727420627920696E74657273656374696F6E732062617365';
wwv_flow_imp.g_varchar2_table(5433) := '64206F6E20636F6E6E656374696F6E207365676D656E74202B5C6E202020202F2F2064697374616E63652066726F6D2073746172745C6E20202020696E74657273656374696F6E73203D20736F7274427928696E74657273656374696F6E732C2066756E';
wwv_flow_imp.g_varchar2_table(5434) := '6374696F6E286929207B5C6E2020202020207661722064697374616E6365203D204D6174682E666C6F6F7228692E7432202A2031303029207C7C20313B5C6E5C6E20202020202064697374616E6365203D20313030202D2064697374616E63653B5C6E5C';
wwv_flow_imp.g_varchar2_table(5435) := '6E20202020202064697374616E6365203D202864697374616E6365203C203130203F20273027203A20272729202B2064697374616E63653B5C6E5C6E2020202020202F2F20637265617465206120736F727420737472696E672074686174206D616B6573';
wwv_flow_imp.g_varchar2_table(5436) := '207375726520776520736F72745C6E2020202020202F2F206C696E65207365676D656E7420415343202B206C696E65207365676D656E7420706F736974696F6E20444553432028666F722063726F705374617274295C6E2020202020202F2F206C696E65';
wwv_flow_imp.g_varchar2_table(5437) := '207365676D656E7420415343202B206C696E65207365676D656E7420706F736974696F6E204153432028666F722063726F70456E64295C6E20202020202072657475726E20692E7365676D656E7432202B20272327202B2064697374616E63653B5C6E20';
wwv_flow_imp.g_varchar2_table(5438) := '2020207D293B5C6E5C6E2020202072657475726E20726F756E64506F696E7428696E74657273656374696F6E735B63726F705374617274203F2030203A20696E74657273656374696F6E732E6C656E677468202D20315D293B5C6E20207D5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5439) := '72657475726E206E756C6C3B5C6E7D5C6E5C6E5C6E6578706F72742066756E6374696F6E20676574496E74657273656374696F6E7328612C206229207B5C6E202072657475726E20696E74657273656374506174687328612C2062293B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5440) := '5C6E6578706F72742066756E6374696F6E2066696C746572526564756E64616E74576179706F696E747328776179706F696E747329207B5C6E5C6E20202F2F20616C74657220636F7079206F6620776179706F696E74732C206E6F74206F726967696E61';
wwv_flow_imp.g_varchar2_table(5441) := '6C5C6E2020776179706F696E7473203D20776179706F696E74732E736C69636528293B5C6E5C6E202076617220696478203D20302C5C6E202020202020706F696E742C5C6E20202020202070726576696F7573506F696E742C5C6E2020202020206E6578';
wwv_flow_imp.g_varchar2_table(5442) := '74506F696E743B5C6E5C6E20207768696C652028776179706F696E74735B6964785D29207B5C6E20202020706F696E74203D20776179706F696E74735B6964785D3B5C6E2020202070726576696F7573506F696E74203D20776179706F696E74735B6964';
wwv_flow_imp.g_varchar2_table(5443) := '78202D20315D3B5C6E202020206E657874506F696E74203D20776179706F696E74735B696478202B20315D3B5C6E5C6E2020202069662028706F696E7444697374616E636528706F696E742C206E657874506F696E7429203D3D3D2030207C7C5C6E2020';
wwv_flow_imp.g_varchar2_table(5444) := '202020202020706F696E74734F6E4C696E652870726576696F7573506F696E742C206E657874506F696E742C20706F696E742929207B5C6E5C6E2020202020202F2F2072656D6F766520706F696E742C206966206F7665726C617070696E672077697468';
wwv_flow_imp.g_varchar2_table(5445) := '207B6E657874506F696E747D5C6E2020202020202F2F206F72206F6E206C696E652077697468207B70726576696F7573506F696E747D202D3E207B706F696E747D202D3E207B6E657874506F696E747D5C6E202020202020776179706F696E74732E7370';
wwv_flow_imp.g_varchar2_table(5446) := '6C696365286964782C2031293B5C6E202020207D20656C7365207B5C6E2020202020206964782B2B3B5C6E202020207D5C6E20207D5C6E5C6E202072657475726E20776179706F696E74733B5C6E7D5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F';
wwv_flow_imp.g_varchar2_table(5447) := '2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E2064697374616E636528612C206229207B5C6E202072657475726E204D6174682E73717274284D6174682E706F7728612E78202D20622E782C203229202B204D6174682E706F7728';
wwv_flow_imp.g_varchar2_table(5448) := '612E79202D20622E792C203229293B5C6E7D222C22696D706F7274207B2061737369676E207D2066726F6D20276D696E2D64617368273B5C6E696D706F727420696E6865726974732066726F6D2027696E6865726974732D62726F77736572273B5C6E5C';
wwv_flow_imp.g_varchar2_table(5449) := '6E696D706F7274207B2052656673207D2066726F6D20276F626A6563742D72656673273B5C6E5C6E76617220706172656E7452656673203D206E65772052656673287B206E616D653A20276368696C6472656E272C20656E756D657261626C653A207472';
wwv_flow_imp.g_varchar2_table(5450) := '75652C20636F6C6C656374696F6E3A2074727565207D2C207B206E616D653A2027706172656E7427207D292C5C6E202020206C6162656C52656673203D206E65772052656673287B206E616D653A20276C6162656C73272C20656E756D657261626C653A';
wwv_flow_imp.g_varchar2_table(5451) := '20747275652C20636F6C6C656374696F6E3A2074727565207D2C207B206E616D653A20276C6162656C54617267657427207D292C5C6E20202020617474616368657252656673203D206E65772052656673287B206E616D653A2027617474616368657273';
wwv_flow_imp.g_varchar2_table(5452) := '272C20636F6C6C656374696F6E3A2074727565207D2C207B206E616D653A2027686F737427207D292C5C6E202020206F7574676F696E6752656673203D206E65772052656673287B206E616D653A20276F7574676F696E67272C20636F6C6C656374696F';
wwv_flow_imp.g_varchar2_table(5453) := '6E3A2074727565207D2C207B206E616D653A2027736F7572636527207D292C5C6E20202020696E636F6D696E6752656673203D206E65772052656673287B206E616D653A2027696E636F6D696E67272C20636F6C6C656374696F6E3A2074727565207D2C';
wwv_flow_imp.g_varchar2_table(5454) := '207B206E616D653A202774617267657427207D293B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2F547970657327292E456C656D656E747D20456C656D656E745C6E202A204074797065646566207B696D706F72742827';
wwv_flow_imp.g_varchar2_table(5455) := '2E2F547970657327292E53686170657D2053686170655C6E202A204074797065646566207B696D706F727428272E2F547970657327292E526F6F747D20526F6F745C6E202A204074797065646566207B696D706F727428272E2F547970657327292E4C61';
wwv_flow_imp.g_varchar2_table(5456) := '62656C7D204C6162656C5C6E202A204074797065646566207B696D706F727428272E2F547970657327292E436F6E6E656374696F6E7D20436F6E6E656374696F6E5C6E202A2F5C6E5C6E2F2A2A5C6E202A20546865206261736963206772617068696361';
wwv_flow_imp.g_varchar2_table(5457) := '6C20726570726573656E746174696F6E5C6E202A5C6E202A2040636C6173735C6E202A2040636F6E7374727563746F725C6E202A2F5C6E66756E6374696F6E20456C656D656E74496D706C2829207B5C6E5C6E20202F2A2A5C6E2020202A20546865206F';
wwv_flow_imp.g_varchar2_table(5458) := '626A6563742074686174206261636B73207570207468652073686170655C6E2020202A5C6E2020202A20406E616D6520456C656D656E7423627573696E6573734F626A6563745C6E2020202A204074797065204F626A6563745C6E2020202A2F5C6E2020';
wwv_flow_imp.g_varchar2_table(5459) := '4F626A6563742E646566696E6550726F706572747928746869732C2027627573696E6573734F626A656374272C207B5C6E202020207772697461626C653A20747275655C6E20207D293B5C6E5C6E5C6E20202F2A2A5C6E2020202A2053696E676C65206C';
wwv_flow_imp.g_varchar2_table(5460) := '6162656C20737570706F72742C2077696C6C206D617070656420746F206D756C7469206C6162656C2061727261795C6E2020202A5C6E2020202A20406E616D6520456C656D656E74236C6162656C5C6E2020202A204074797065204F626A6563745C6E20';
wwv_flow_imp.g_varchar2_table(5461) := '20202A2F5C6E20204F626A6563742E646566696E6550726F706572747928746869732C20276C6162656C272C207B5C6E202020206765743A2066756E6374696F6E2829207B5C6E20202020202072657475726E20746869732E6C6162656C735B305D3B5C';
wwv_flow_imp.g_varchar2_table(5462) := '6E202020207D2C5C6E202020207365743A2066756E6374696F6E286E65774C6162656C29207B5C6E5C6E202020202020766172206C6162656C203D20746869732E6C6162656C2C5C6E202020202020202020206C6162656C73203D20746869732E6C6162';
wwv_flow_imp.g_varchar2_table(5463) := '656C733B5C6E5C6E20202020202069662028216E65774C6162656C202626206C6162656C29207B5C6E20202020202020206C6162656C732E72656D6F7665286C6162656C293B5C6E2020202020207D20656C7365207B5C6E20202020202020206C616265';
wwv_flow_imp.g_varchar2_table(5464) := '6C732E616464286E65774C6162656C2C2030293B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E5C6E20202F2A2A5C6E2020202A2054686520706172656E742073686170655C6E2020202A5C6E2020202A20406E616D6520456C656D656E';
wwv_flow_imp.g_varchar2_table(5465) := '7423706172656E745C6E2020202A2040747970652053686170655C6E2020202A2F5C6E2020706172656E74526566732E62696E6428746869732C2027706172656E7427293B5C6E5C6E20202F2A2A5C6E2020202A20546865206C697374206F66206C6162';
wwv_flow_imp.g_varchar2_table(5466) := '656C735C6E2020202A5C6E2020202A20406E616D6520456C656D656E74236C6162656C735C6E2020202A204074797065204C6162656C5C6E2020202A2F5C6E20206C6162656C526566732E62696E6428746869732C20276C6162656C7327293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5467) := '20202F2A2A5C6E2020202A20546865206C697374206F66206F7574676F696E6720636F6E6E656374696F6E735C6E2020202A5C6E2020202A20406E616D6520456C656D656E74236F7574676F696E675C6E2020202A2040747970652041727261793C436F';
wwv_flow_imp.g_varchar2_table(5468) := '6E6E656374696F6E3E5C6E2020202A2F5C6E20206F7574676F696E67526566732E62696E6428746869732C20276F7574676F696E6727293B5C6E5C6E20202F2A2A5C6E2020202A20546865206C697374206F6620696E636F6D696E6720636F6E6E656374';
wwv_flow_imp.g_varchar2_table(5469) := '696F6E735C6E2020202A5C6E2020202A20406E616D6520456C656D656E7423696E636F6D696E675C6E2020202A2040747970652041727261793C436F6E6E656374696F6E3E5C6E2020202A2F5C6E2020696E636F6D696E67526566732E62696E64287468';
wwv_flow_imp.g_varchar2_table(5470) := '69732C2027696E636F6D696E6727293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20412067726170686963616C206F626A6563745C6E202A5C6E202A2040636C6173735C6E202A2040636F6E7374727563746F725C6E202A5C6E202A2040657874656E6473';
wwv_flow_imp.g_varchar2_table(5471) := '20456C656D656E74496D706C5C6E202A2F5C6E66756E6374696F6E205368617065496D706C2829207B5C6E2020456C656D656E74496D706C2E63616C6C2874686973293B5C6E5C6E20202F2A2A5C6E2020202A20496E64696361746573206672616D6520';
wwv_flow_imp.g_varchar2_table(5472) := '7368617065735C6E2020202A5C6E2020202A20406E616D65205368617065496D706C2369734672616D655C6E2020202A20407479706520626F6F6C65616E5C6E2020202A2F5C6E5C6E20202F2A2A5C6E2020202A20546865206C697374206F6620636869';
wwv_flow_imp.g_varchar2_table(5473) := '6C6472656E5C6E2020202A5C6E2020202A20406E616D65205368617065496D706C236368696C6472656E5C6E2020202A20407479706520456C656D656E745B5D5C6E2020202A2F5C6E2020706172656E74526566732E62696E6428746869732C20276368';
wwv_flow_imp.g_varchar2_table(5474) := '696C6472656E27293B5C6E5C6E20202F2A2A5C6E2020202A20406E616D65205368617065496D706C23686F73745C6E2020202A2040747970652053686170655C6E2020202A2F5C6E20206174746163686572526566732E62696E6428746869732C202768';
wwv_flow_imp.g_varchar2_table(5475) := '6F737427293B5C6E5C6E20202F2A2A5C6E2020202A20406E616D65205368617065496D706C236174746163686572735C6E2020202A2040747970652053686170655C6E2020202A2F5C6E20206174746163686572526566732E62696E6428746869732C20';
wwv_flow_imp.g_varchar2_table(5476) := '2761747461636865727327293B5C6E7D5C6E5C6E696E686572697473285368617065496D706C2C20456C656D656E74496D706C293B5C6E5C6E5C6E2F2A2A5C6E202A204120726F6F742067726170686963616C206F626A6563745C6E202A5C6E202A2040';
wwv_flow_imp.g_varchar2_table(5477) := '636C6173735C6E202A2040636F6E7374727563746F725C6E202A5C6E202A2040657874656E647320456C656D656E74496D706C5C6E202A2F5C6E66756E6374696F6E20526F6F74496D706C2829207B5C6E2020456C656D656E74496D706C2E63616C6C28';
wwv_flow_imp.g_varchar2_table(5478) := '74686973293B5C6E5C6E20202F2A2A5C6E2020202A20546865206C697374206F66206368696C6472656E5C6E2020202A5C6E2020202A20406E616D6520526F6F74496D706C236368696C6472656E5C6E2020202A20407479706520456C656D656E745B5D';
wwv_flow_imp.g_varchar2_table(5479) := '5C6E2020202A2F5C6E2020706172656E74526566732E62696E6428746869732C20276368696C6472656E27293B5C6E7D5C6E5C6E696E68657269747328526F6F74496D706C2C205368617065496D706C293B5C6E5C6E5C6E2F2A2A5C6E202A2041206C61';
wwv_flow_imp.g_varchar2_table(5480) := '62656C20666F7220616E20656C656D656E745C6E202A5C6E202A2040636C6173735C6E202A2040636F6E7374727563746F725C6E202A5C6E202A2040657874656E6473205368617065496D706C5C6E202A2F5C6E66756E6374696F6E204C6162656C496D';
wwv_flow_imp.g_varchar2_table(5481) := '706C2829207B5C6E20205368617065496D706C2E63616C6C2874686973293B5C6E5C6E20202F2A2A5C6E2020202A20546865206C6162656C656420656C656D656E745C6E2020202A5C6E2020202A20406E616D65204C6162656C496D706C236C6162656C';
wwv_flow_imp.g_varchar2_table(5482) := '5461726765745C6E2020202A20407479706520456C656D656E745C6E2020202A2F5C6E20206C6162656C526566732E62696E6428746869732C20276C6162656C54617267657427293B5C6E7D5C6E5C6E696E686572697473284C6162656C496D706C2C20';
wwv_flow_imp.g_varchar2_table(5483) := '5368617065496D706C293B5C6E5C6E5C6E2F2A2A5C6E202A204120636F6E6E656374696F6E206265747765656E2074776F20656C656D656E74735C6E202A5C6E202A2040636C6173735C6E202A2040636F6E7374727563746F725C6E202A5C6E202A2040';
wwv_flow_imp.g_varchar2_table(5484) := '657874656E647320456C656D656E74496D706C5C6E202A2F5C6E66756E6374696F6E20436F6E6E656374696F6E496D706C2829207B5C6E2020456C656D656E74496D706C2E63616C6C2874686973293B5C6E5C6E20202F2A2A5C6E2020202A2054686520';
wwv_flow_imp.g_varchar2_table(5485) := '656C656D656E74207468697320636F6E6E656374696F6E206F726967696E617465732066726F6D5C6E2020202A5C6E2020202A20406E616D6520436F6E6E656374696F6E496D706C23736F757263655C6E2020202A20407479706520456C656D656E745C';
wwv_flow_imp.g_varchar2_table(5486) := '6E2020202A2F5C6E20206F7574676F696E67526566732E62696E6428746869732C2027736F7572636527293B5C6E5C6E20202F2A2A5C6E2020202A2054686520656C656D656E74207468697320636F6E6E656374696F6E20706F696E747320746F5C6E20';
wwv_flow_imp.g_varchar2_table(5487) := '20202A5C6E2020202A20406E616D6520436F6E6E656374696F6E496D706C237461726765745C6E2020202A20407479706520456C656D656E745C6E2020202A2F5C6E2020696E636F6D696E67526566732E62696E6428746869732C202774617267657427';
wwv_flow_imp.g_varchar2_table(5488) := '293B5C6E7D5C6E5C6E696E68657269747328436F6E6E656374696F6E496D706C2C20456C656D656E74496D706C293B5C6E5C6E5C6E766172207479706573203D207B5C6E2020636F6E6E656374696F6E3A20436F6E6E656374696F6E496D706C2C5C6E20';
wwv_flow_imp.g_varchar2_table(5489) := '2073686170653A205368617065496D706C2C5C6E20206C6162656C3A204C6162656C496D706C2C5C6E2020726F6F743A20526F6F74496D706C5C6E7D3B5C6E5C6E2F2A2A5C6E202A2043726561746573206120726F6F7420656C656D656E742E5C6E202A';
wwv_flow_imp.g_varchar2_table(5490) := '5C6E202A20406F7665726C6F72645C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206060606A6176617363726970745C6E202A20696D706F7274202A206173204D6F64656C2066726F6D20276469616772616D2D6A732F6C69622F6D6F64';
wwv_flow_imp.g_varchar2_table(5491) := '656C273B5C6E202A5C6E202A20636F6E737420726F6F74203D204D6F64656C2E6372656174652827726F6F74272C207B5C6E202A202020783A203130302C5C6E202A202020793A203130302C5C6E202A20202077696474683A203130302C5C6E202A2020';
wwv_flow_imp.g_varchar2_table(5492) := '206865696768743A203130305C6E202A207D293B5C6E202A206060605C6E202A5C6E202A2040706172616D207B27726F6F74277D20747970655C6E202A2040706172616D207B616E797D205B61747472735D5C6E202A5C6E202A204072657475726E207B';
wwv_flow_imp.g_varchar2_table(5493) := '526F6F747D5C6E202A2F5C6E5C6E2F2A2A5C6E202A2043726561746573206120636F6E6E656374696F6E2E5C6E202A5C6E202A20406F7665726C6F72645C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206060606A617661736372697074';
wwv_flow_imp.g_varchar2_table(5494) := '5C6E202A20696D706F7274202A206173204D6F64656C2066726F6D20276469616772616D2D6A732F6C69622F6D6F64656C273B5C6E202A5C6E202A20636F6E737420636F6E6E656374696F6E203D204D6F64656C2E6372656174652827636F6E6E656374';
wwv_flow_imp.g_varchar2_table(5495) := '696F6E272C207B5C6E202A202020776179706F696E74733A205B5C6E202A20202020207B20783A203130302C20793A20313030207D2C5C6E202A20202020207B20783A203230302C20793A20313030207D5C6E202A2020205D5C6E202A207D293B5C6E20';
wwv_flow_imp.g_varchar2_table(5496) := '2A206060605C6E202A5C6E202A2040706172616D207B27636F6E6E656374696F6E277D20747970655C6E202A2040706172616D207B616E797D205B61747472735D5C6E202A5C6E202A204072657475726E207B436F6E6E656374696F6E7D5C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(5497) := '6E5C6E2F2A2A5C6E202A204372656174657320612073686170652E5C6E202A5C6E202A20406F7665726C6F72645C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206060606A6176617363726970745C6E202A20696D706F7274202A206173';
wwv_flow_imp.g_varchar2_table(5498) := '204D6F64656C2066726F6D20276469616772616D2D6A732F6C69622F6D6F64656C273B5C6E202A5C6E202A20636F6E7374207368617065203D204D6F64656C2E63726561746528277368617065272C207B5C6E202A202020783A203130302C5C6E202A20';
wwv_flow_imp.g_varchar2_table(5499) := '2020793A203130302C5C6E202A20202077696474683A203130302C5C6E202A2020206865696768743A203130305C6E202A207D293B5C6E202A206060605C6E202A5C6E202A2040706172616D207B277368617065277D20747970655C6E202A2040706172';
wwv_flow_imp.g_varchar2_table(5500) := '616D207B616E797D205B61747472735D5C6E202A5C6E202A204072657475726E207B53686170657D5C6E202A2F5C6E5C6E2F2A2A5C6E202A20437265617465732061206C6162656C2E5C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A2060';
wwv_flow_imp.g_varchar2_table(5501) := '60606A6176617363726970745C6E202A20696D706F7274202A206173204D6F64656C2066726F6D20276469616772616D2D6A732F6C69622F6D6F64656C273B5C6E202A5C6E202A20636F6E7374206C6162656C203D204D6F64656C2E6372656174652827';
wwv_flow_imp.g_varchar2_table(5502) := '6C6162656C272C207B5C6E202A202020783A203130302C5C6E202A202020793A203130302C5C6E202A20202077696474683A203130302C5C6E202A2020206865696768743A203130302C5C6E202A2020206C6162656C5461726765743A2073686170655C';
wwv_flow_imp.g_varchar2_table(5503) := '6E202A207D293B5C6E202A206060605C6E202A5C6E202A2040706172616D207B276C6162656C277D20747970655C6E202A2040706172616D207B4F626A6563747D205B61747472735D5C6E202A5C6E202A204072657475726E207B4C6162656C7D5C6E20';
wwv_flow_imp.g_varchar2_table(5504) := '2A2F5C6E6578706F72742066756E6374696F6E2063726561746528747970652C20617474727329207B5C6E20207661722054797065203D2074797065735B747970655D3B5C6E202069662028215479706529207B5C6E202020207468726F77206E657720';
wwv_flow_imp.g_varchar2_table(5505) := '4572726F722827756E6B6E6F776E20747970653A203C27202B2074797065202B20273E27293B5C6E20207D5C6E202072657475726E2061737369676E286E6577205479706528292C206174747273293B5C6E7D5C6E5C6E2F2A2A5C6E202A20436865636B';
wwv_flow_imp.g_varchar2_table(5506) := '73207768657468657220616E206F626A6563742069732061206D6F64656C20696E7374616E63652E5C6E202A5C6E202A2040706172616D207B616E797D206F626A5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578';
wwv_flow_imp.g_varchar2_table(5507) := '706F72742066756E6374696F6E2069734D6F64656C456C656D656E74286F626A29207B5C6E202072657475726E206F626A20696E7374616E63656F6620456C656D656E74496D706C3B5C6E7D222C22696D706F7274207B5C6E2020736574206173206375';
wwv_flow_imp.g_varchar2_table(5508) := '72736F725365742C5C6E2020756E73657420617320637572736F72556E7365745C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F437572736F72273B5C6E5C6E696D706F7274207B5C6E2020696E7374616C6C20617320696E7374616C6C436C69636B';
wwv_flow_imp.g_varchar2_table(5509) := '547261705C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F436C69636B54726170273B5C6E5C6E696D706F7274207B5C6E202064656C74612061732064656C7461506F735C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F506F736974696F6E5574';
wwv_flow_imp.g_varchar2_table(5510) := '696C273B5C6E5C6E696D706F7274207B5C6E20206576656E7420617320646F6D4576656E742C5C6E2020636C6F7365737420617320646F6D436C6F736573745C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E696D706F7274207B5C6E2020746F';
wwv_flow_imp.g_varchar2_table(5511) := '506F696E745C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F4576656E74273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E64656661756C747D2043616E7661735C6E';
wwv_flow_imp.g_varchar2_table(5512) := '202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A2F5C6E5C6E766172205448524553484F4C44203D2031353B5C6E5C6E5C6E2F2A2A5C6E20';
wwv_flow_imp.g_varchar2_table(5513) := '2A204D6F7665207468652063616E76617320766961206D6F7573652E5C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B43616E7661737D2063616E7661735C6E202A2F5C6E657870';
wwv_flow_imp.g_varchar2_table(5514) := '6F72742064656661756C742066756E6374696F6E204D6F766543616E766173286576656E744275732C2063616E76617329207B5C6E5C6E202076617220636F6E746578743B5C6E5C6E5C6E20202F2F206C697374656E20666F72206D6F7665206F6E2065';
wwv_flow_imp.g_varchar2_table(5515) := '6C656D656E74206D6F75736520646F776E3B5C6E20202F2F20616C6C6F77206F746865727320746F20686F6F6B20696E746F20746865206576656E74206265666F72652075732074686F7567685C6E20202F2F20286472616767696E67202F20656C656D';
wwv_flow_imp.g_varchar2_table(5516) := '656E74206D6F76696E672077696C6C20646F2074686973295C6E20206576656E744275732E6F6E2827656C656D656E742E6D6F757365646F776E272C203530302C2066756E6374696F6E286529207B5C6E2020202072657475726E2068616E646C655374';
wwv_flow_imp.g_varchar2_table(5517) := '61727428652E6F726967696E616C4576656E74293B5C6E20207D293B5C6E5C6E5C6E202066756E6374696F6E2068616E646C654D6F7665286576656E7429207B5C6E5C6E20202020766172207374617274203D20636F6E746578742E73746172742C5C6E';
wwv_flow_imp.g_varchar2_table(5518) := '2020202020202020627574746F6E203D20636F6E746578742E627574746F6E2C5C6E2020202020202020706F736974696F6E203D20746F506F696E74286576656E74292C5C6E202020202020202064656C7461203D2064656C7461506F7328706F736974';
wwv_flow_imp.g_varchar2_table(5519) := '696F6E2C207374617274293B5C6E5C6E202020206966202821636F6E746578742E6472616767696E67202626206C656E6774682864656C746129203E205448524553484F4C4429207B5C6E202020202020636F6E746578742E6472616767696E67203D20';
wwv_flow_imp.g_varchar2_table(5520) := '747275653B5C6E5C6E20202020202069662028627574746F6E203D3D3D203029207B5C6E2020202020202020696E7374616C6C436C69636B54726170286576656E74427573293B5C6E2020202020207D5C6E5C6E202020202020637572736F7253657428';
wwv_flow_imp.g_varchar2_table(5521) := '276772616227293B5C6E202020207D5C6E5C6E2020202069662028636F6E746578742E6472616767696E6729207B5C6E5C6E202020202020766172206C617374506F736974696F6E203D20636F6E746578742E6C617374207C7C20636F6E746578742E73';
wwv_flow_imp.g_varchar2_table(5522) := '746172743B5C6E5C6E20202020202064656C7461203D2064656C7461506F7328706F736974696F6E2C206C617374506F736974696F6E293B5C6E5C6E20202020202063616E7661732E7363726F6C6C287B5C6E202020202020202064783A2064656C7461';
wwv_flow_imp.g_varchar2_table(5523) := '2E782C5C6E202020202020202064793A2064656C74612E795C6E2020202020207D293B5C6E5C6E202020202020636F6E746578742E6C617374203D20706F736974696F6E3B5C6E202020207D5C6E5C6E202020202F2F2070726576656E742073656C6563';
wwv_flow_imp.g_varchar2_table(5524) := '745C6E202020206576656E742E70726576656E7444656661756C7428293B5C6E20207D5C6E5C6E5C6E202066756E6374696F6E2068616E646C65456E64286576656E7429207B5C6E20202020646F6D4576656E742E756E62696E6428646F63756D656E74';
wwv_flow_imp.g_varchar2_table(5525) := '2C20276D6F7573656D6F7665272C2068616E646C654D6F7665293B5C6E20202020646F6D4576656E742E756E62696E6428646F63756D656E742C20276D6F7573657570272C2068616E646C65456E64293B5C6E5C6E20202020636F6E74657874203D206E';
wwv_flow_imp.g_varchar2_table(5526) := '756C6C3B5C6E5C6E20202020637572736F72556E73657428293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C655374617274286576656E7429207B5C6E5C6E202020202F2F206576656E7420697320616C72656164792068616E646C65';
wwv_flow_imp.g_varchar2_table(5527) := '6420627920272E646A732D647261676761626C65275C6E2020202069662028646F6D436C6F73657374286576656E742E7461726765742C20272E646A732D647261676761626C65272929207B5C6E20202020202072657475726E3B5C6E202020207D5C6E';
wwv_flow_imp.g_varchar2_table(5528) := '5C6E2020202076617220627574746F6E203D206576656E742E627574746F6E3B5C6E5C6E202020202F2F2072656A656374207269676874206D6F75736520627574746F6E206F72206D6F646966696572206B65795C6E2020202069662028627574746F6E';
wwv_flow_imp.g_varchar2_table(5529) := '203E3D2032207C7C206576656E742E6374726C4B6579207C7C206576656E742E73686966744B6579207C7C206576656E742E616C744B657929207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E20202020636F6E74657874203D207B';
wwv_flow_imp.g_varchar2_table(5530) := '5C6E202020202020627574746F6E3A20627574746F6E2C5C6E20202020202073746172743A20746F506F696E74286576656E74295C6E202020207D3B5C6E5C6E20202020646F6D4576656E742E62696E6428646F63756D656E742C20276D6F7573656D6F';
wwv_flow_imp.g_varchar2_table(5531) := '7665272C2068616E646C654D6F7665293B5C6E20202020646F6D4576656E742E62696E6428646F63756D656E742C20276D6F7573657570272C2068616E646C65456E64293B5C6E5C6E202020202F2F2077652776652068616E646C656420746865206576';
wwv_flow_imp.g_varchar2_table(5532) := '656E745C6E2020202072657475726E20747275653B5C6E20207D5C6E5C6E2020746869732E6973416374697665203D2066756E6374696F6E2829207B5C6E2020202072657475726E202121636F6E746578743B5C6E20207D3B5C6E5C6E7D5C6E5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5533) := '4D6F766543616E7661732E24696E6A656374203D205B5C6E2020276576656E74427573272C5C6E20202763616E766173275C6E5D3B5C6E5C6E5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E206C656E6774682870';
wwv_flow_imp.g_varchar2_table(5534) := '6F696E7429207B5C6E202072657475726E204D6174682E73717274284D6174682E706F7728706F696E742E782C203229202B204D6174682E706F7728706F696E742E792C203229293B5C6E7D5C6E222C22696D706F7274204D6F766543616E7661732066';
wwv_flow_imp.g_varchar2_table(5535) := '726F6D20272E2F4D6F766543616E766173273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065207B20696D706F727428276469646927292E4D6F64756C654465636C61726174696F6E207D5C6E202A2F5C6E6578706F72742064656661756C74207B5C6E';
wwv_flow_imp.g_varchar2_table(5536) := '20205F5F696E69745F5F3A205B20276D6F766543616E76617327205D2C5C6E20206D6F766543616E7661733A205B202774797065272C204D6F766543616E766173205D5C6E7D3B222C22696D706F7274207B5C6E20206576656E7420617320646F6D4576';
wwv_flow_imp.g_varchar2_table(5537) := '656E742C5C6E2020636C6F7365737420617320646F6D436C6F736573745C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E696D706F7274207B5C6E20206765745374657053697A652C5C6E20206361705C6E7D2066726F6D20272E2F5A6F6F6D55';
wwv_flow_imp.g_varchar2_table(5538) := '74696C273B5C6E5C6E696D706F7274207B5C6E20206C6F6731305C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F4D617468273B5C6E5C6E696D706F7274207B5C6E202069734D61635C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F506C617466';
wwv_flow_imp.g_varchar2_table(5539) := '6F726D273B5C6E5C6E696D706F7274207B5C6E202062696E645C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F43616E76617327292E6465666175';
wwv_flow_imp.g_varchar2_table(5540) := '6C747D2043616E7661735C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A5C6E202A204074797065646566207B696D706F727428272E';
wwv_flow_imp.g_varchar2_table(5541) := '2E2F2E2E2F7574696C2F547970657327292E506F696E747D20506F696E745C6E202A204074797065646566207B696D706F727428272E2E2F2E2E2F7574696C2F547970657327292E5363726F6C6C44656C74617D205363726F6C6C44656C74615C6E202A';
wwv_flow_imp.g_varchar2_table(5542) := '2F5C6E5C6E766172207369676E203D204D6174682E7369676E207C7C2066756E6374696F6E286E29207B5C6E202072657475726E206E203E3D2030203F2031203A202D313B5C6E7D3B5C6E5C6E7661722052414E4745203D207B206D696E3A20302E322C';
wwv_flow_imp.g_varchar2_table(5543) := '206D61783A2034207D2C5C6E202020204E554D5F5354455053203D2031303B5C6E5C6E7661722044454C54415F5448524553484F4C44203D20302E313B5C6E5C6E7661722044454641554C545F5343414C45203D20302E37353B5C6E5C6E2F2A2A5C6E20';
wwv_flow_imp.g_varchar2_table(5544) := '2A20416E20696D706C656D656E746174696F6E206F66207A6F6F6D696E6720616E64207363726F6C6C696E672077697468696E207468655C6E202A207B406C696E6B2043616E7661737D2076696120746865206D6F75736520776865656C2E5C6E202A5C';
wwv_flow_imp.g_varchar2_table(5545) := '6E202A204D6F75736520776865656C207A6F6F6D696E67202F207363726F6C6C696E67206D61792062652064697361626C6564207573696E675C6E202A20746865207B406C696E6B20746F67676C6528656E61626C6564297D206D6574686F642E5C6E20';
wwv_flow_imp.g_varchar2_table(5546) := '2A5C6E202A2040706172616D207B4F626A6563747D205B636F6E6669675D5C6E202A2040706172616D207B626F6F6C65616E7D205B636F6E6669672E656E61626C65643D747275655D2064656661756C7420656E61626C65642073746174655C6E202A20';
wwv_flow_imp.g_varchar2_table(5547) := '40706172616D207B6E756D6265727D205B636F6E6669672E7363616C653D2E37355D207363726F6C6C2073656E7369766974795C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B43616E7661';
wwv_flow_imp.g_varchar2_table(5548) := '737D2063616E7661735C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E205A6F6F6D5363726F6C6C28636F6E6669672C206576656E744275732C2063616E76617329207B5C6E5C6E2020636F6E666967203D20636F6E66696720';
wwv_flow_imp.g_varchar2_table(5549) := '7C7C207B7D3B5C6E5C6E2020746869732E5F656E61626C6564203D2066616C73653B5C6E5C6E2020746869732E5F63616E766173203D2063616E7661733B5C6E2020746869732E5F636F6E7461696E6572203D2063616E7661732E5F636F6E7461696E65';
wwv_flow_imp.g_varchar2_table(5550) := '723B5C6E5C6E2020746869732E5F68616E646C65576865656C203D2062696E6428746869732E5F68616E646C65576865656C2C2074686973293B5C6E5C6E2020746869732E5F746F74616C44656C7461203D20303B5C6E2020746869732E5F7363616C65';
wwv_flow_imp.g_varchar2_table(5551) := '203D20636F6E6669672E7363616C65207C7C2044454641554C545F5343414C453B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E20206576656E744275732E6F6E282763616E7661732E696E6974272C2066756E6374696F6E28652920';
wwv_flow_imp.g_varchar2_table(5552) := '7B5C6E2020202073656C662E5F696E697428636F6E6669672E656E61626C656420213D3D2066616C7365293B5C6E20207D293B5C6E7D5C6E5C6E5A6F6F6D5363726F6C6C2E24696E6A656374203D205B5C6E202027636F6E6669672E7A6F6F6D5363726F';
wwv_flow_imp.g_varchar2_table(5553) := '6C6C272C5C6E2020276576656E74427573272C5C6E20202763616E766173275C6E5D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B5363726F6C6C44656C74617D2064656C74615C6E202A2F5C6E5A6F6F6D5363726F6C6C2E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(5554) := '2E7363726F6C6C203D2066756E6374696F6E207363726F6C6C2864656C746129207B5C6E2020746869732E5F63616E7661732E7363726F6C6C2864656C7461293B5C6E7D3B5C6E5C6E5C6E5A6F6F6D5363726F6C6C2E70726F746F747970652E72657365';
wwv_flow_imp.g_varchar2_table(5555) := '74203D2066756E6374696F6E2072657365742829207B5C6E2020746869732E5F63616E7661732E7A6F6F6D28276669742D76696577706F727427293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A205A6F6F6D20646570656E64696E67206F6E2064656C74612E';
wwv_flow_imp.g_varchar2_table(5556) := '5C6E202A5C6E202A2040706172616D207B6E756D6265727D2064656C74615C6E202A2040706172616D207B506F696E747D20706F736974696F6E5C6E202A2F5C6E5A6F6F6D5363726F6C6C2E70726F746F747970652E7A6F6F6D203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(5557) := '6E207A6F6F6D2864656C74612C20706F736974696F6E29207B5C6E5C6E20202F2F207A6F6F6D20776974682068616C662074686520737465702073697A65206F6620737465705A6F6F6D5C6E2020766172207374657053697A65203D2067657453746570';
wwv_flow_imp.g_varchar2_table(5558) := '53697A652852414E47452C204E554D5F5354455053202A2032293B5C6E5C6E20202F2F2061646420756E74696C207468726573686F6C6420726561636865645C6E2020746869732E5F746F74616C44656C7461202B3D2064656C74613B5C6E5C6E202069';
wwv_flow_imp.g_varchar2_table(5559) := '6620284D6174682E61627328746869732E5F746F74616C44656C746129203E2044454C54415F5448524553484F4C4429207B5C6E20202020746869732E5F7A6F6F6D2864656C74612C20706F736974696F6E2C207374657053697A65293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5560) := '20202F2F2072657365745C6E20202020746869732E5F746F74616C44656C7461203D20303B5C6E20207D5C6E7D3B5C6E5C6E5C6E5A6F6F6D5363726F6C6C2E70726F746F747970652E5F68616E646C65576865656C203D2066756E6374696F6E2068616E';
wwv_flow_imp.g_varchar2_table(5561) := '646C65576865656C286576656E7429207B5C6E5C6E20202F2F206576656E7420697320616C72656164792068616E646C656420627920272E646A732D7363726F6C6C61626C65275C6E202069662028646F6D436C6F73657374286576656E742E74617267';
wwv_flow_imp.g_varchar2_table(5562) := '65742C20272E646A732D7363726F6C6C61626C65272C20747275652929207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E202076617220656C656D656E74203D20746869732E5F636F6E7461696E65723B5C6E5C6E20206576656E742E707265';
wwv_flow_imp.g_varchar2_table(5563) := '76656E7444656661756C7428293B5C6E5C6E20202F2F2070696E636820746F207A6F6F6D206973206D617070656420746F20776865656C202B206374726C4B6579203D20747275655C6E20202F2F20696E206D6F6465726E2062726F7773657273202821';
wwv_flow_imp.g_varchar2_table(5564) := '295C6E5C6E20207661722069735A6F6F6D203D206576656E742E6374726C4B6579207C7C202869734D61632829202626206576656E742E6D6574614B6579293B5C6E5C6E2020766172206973486F72697A6F6E74616C5363726F6C6C203D206576656E74';
wwv_flow_imp.g_varchar2_table(5565) := '2E73686966744B65793B5C6E5C6E202076617220666163746F72203D202D31202A20746869732E5F7363616C652C5C6E20202020202064656C74613B5C6E5C6E20206966202869735A6F6F6D29207B5C6E20202020666163746F72202A3D206576656E74';
wwv_flow_imp.g_varchar2_table(5566) := '2E64656C74614D6F6465203D3D3D2030203F20302E303230203A20302E33323B5C6E20207D20656C7365207B5C6E20202020666163746F72202A3D206576656E742E64656C74614D6F6465203D3D3D2030203F20312E30203A2031362E303B5C6E20207D';
wwv_flow_imp.g_varchar2_table(5567) := '5C6E5C6E20206966202869735A6F6F6D29207B5C6E2020202076617220656C656D656E7452656374203D20656C656D656E742E676574426F756E64696E67436C69656E745265637428293B5C6E5C6E20202020766172206F6666736574203D207B5C6E20';
wwv_flow_imp.g_varchar2_table(5568) := '2020202020783A206576656E742E636C69656E7458202D20656C656D656E74526563742E6C6566742C5C6E202020202020793A206576656E742E636C69656E7459202D20656C656D656E74526563742E746F705C6E202020207D3B5C6E5C6E2020202064';
wwv_flow_imp.g_varchar2_table(5569) := '656C7461203D20285C6E2020202020204D6174682E73717274285C6E20202020202020204D6174682E706F77286576656E742E64656C7461592C203229202B5C6E20202020202020204D6174682E706F77286576656E742E64656C7461582C2032295C6E';
wwv_flow_imp.g_varchar2_table(5570) := '20202020202029202A207369676E286576656E742E64656C74615929202A20666163746F725C6E20202020293B5C6E5C6E202020202F2F207A6F6F6D20696E2072656C617469766520746F206469616772616D207B782C797D20636F6F7264696E617465';
wwv_flow_imp.g_varchar2_table(5571) := '735C6E20202020746869732E7A6F6F6D2864656C74612C206F6666736574293B5C6E20207D20656C7365207B5C6E5C6E20202020696620286973486F72697A6F6E74616C5363726F6C6C29207B5C6E20202020202064656C7461203D207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(5572) := '2020202064783A20666163746F72202A206576656E742E64656C7461592C5C6E202020202020202064793A20305C6E2020202020207D3B5C6E202020207D20656C7365207B5C6E20202020202064656C7461203D207B5C6E202020202020202064783A20';
wwv_flow_imp.g_varchar2_table(5573) := '666163746F72202A206576656E742E64656C7461582C5C6E202020202020202064793A20666163746F72202A206576656E742E64656C7461595C6E2020202020207D3B5C6E202020207D5C6E5C6E20202020746869732E7363726F6C6C2864656C746129';
wwv_flow_imp.g_varchar2_table(5574) := '3B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A205A6F6F6D207769746820666978656420737465702073697A652E5C6E202A5C6E202A2040706172616D207B6E756D6265727D2064656C7461205A6F6F6D2064656C746120283120666F72207A6F6F';
wwv_flow_imp.g_varchar2_table(5575) := '6D696E6720696E2C202D3120666F72207A6F6F6D696E67206F7574292E5C6E202A2040706172616D207B506F696E747D205B706F736974696F6E5D5C6E202A2F5C6E5A6F6F6D5363726F6C6C2E70726F746F747970652E737465705A6F6F6D203D206675';
wwv_flow_imp.g_varchar2_table(5576) := '6E6374696F6E20737465705A6F6F6D2864656C74612C20706F736974696F6E29207B5C6E5C6E2020766172207374657053697A65203D206765745374657053697A652852414E47452C204E554D5F5354455053293B5C6E5C6E2020746869732E5F7A6F6F';
wwv_flow_imp.g_varchar2_table(5577) := '6D2864656C74612C20706F736974696F6E2C207374657053697A65293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A205A6F6F6D20696E2F6F757420676976656E206120737465702073697A652E5C6E202A5C6E202A2040706172616D207B6E756D626572';
wwv_flow_imp.g_varchar2_table(5578) := '7D2064656C74615C6E202A2040706172616D207B506F696E747D205B706F736974696F6E5D5C6E202A2040706172616D207B6E756D6265727D207374657053697A655C6E202A2F5C6E5A6F6F6D5363726F6C6C2E70726F746F747970652E5F7A6F6F6D20';
wwv_flow_imp.g_varchar2_table(5579) := '3D2066756E6374696F6E2864656C74612C20706F736974696F6E2C207374657053697A6529207B5C6E20207661722063616E766173203D20746869732E5F63616E7661733B5C6E5C6E202076617220646972656374696F6E203D2064656C7461203E2030';
wwv_flow_imp.g_varchar2_table(5580) := '203F2031203A202D313B5C6E5C6E20207661722063757272656E744C696E6561725A6F6F6D4C6576656C203D206C6F6731302863616E7661732E7A6F6F6D2829293B5C6E5C6E20202F2F20736E617020746F20612070726F78696D617465207A6F6F6D20';
wwv_flow_imp.g_varchar2_table(5581) := '737465705C6E2020766172206E65774C696E6561725A6F6F6D4C6576656C203D204D6174682E726F756E642863757272656E744C696E6561725A6F6F6D4C6576656C202F207374657053697A6529202A207374657053697A653B5C6E5C6E20202F2F2069';
wwv_flow_imp.g_varchar2_table(5582) := '6E637265617365206F72206465637265617365206F6E65207A6F6F6D207374657020696E2074686520676976656E20646972656374696F6E5C6E20206E65774C696E6561725A6F6F6D4C6576656C202B3D207374657053697A65202A2064697265637469';
wwv_flow_imp.g_varchar2_table(5583) := '6F6E3B5C6E5C6E20202F2F2063616C63756C61746520746865206162736F6C757465206C6F6761726974686D6963207A6F6F6D206C6576656C206261736564206F6E20746865206C696E656172207A6F6F6D206C6576656C5C6E20202F2F2028652E672E';
wwv_flow_imp.g_varchar2_table(5584) := '203220666F7220616E206162736F6C757465207832207A6F6F6D295C6E2020766172206E65774C6F675A6F6F6D4C6576656C203D204D6174682E706F772831302C206E65774C696E6561725A6F6F6D4C6576656C293B5C6E5C6E202063616E7661732E7A';
wwv_flow_imp.g_varchar2_table(5585) := '6F6F6D286361702852414E47452C206E65774C6F675A6F6F6D4C6576656C292C20706F736974696F6E293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A20546F67676C6520746865207A6F6F6D207363726F6C6C206162696C69747920766961206D6F7573';
wwv_flow_imp.g_varchar2_table(5586) := '6520776865656C2E5C6E202A5C6E202A2040706172616D207B626F6F6C65616E7D205B6E6577456E61626C65645D206E657720656E61626C65642073746174655C6E202A2F5C6E5A6F6F6D5363726F6C6C2E70726F746F747970652E746F67676C65203D';
wwv_flow_imp.g_varchar2_table(5587) := '2066756E6374696F6E20746F67676C65286E6577456E61626C656429207B5C6E5C6E202076617220656C656D656E74203D20746869732E5F636F6E7461696E65723B5C6E20207661722068616E646C65576865656C203D20746869732E5F68616E646C65';
wwv_flow_imp.g_varchar2_table(5588) := '576865656C3B5C6E5C6E2020766172206F6C64456E61626C6564203D20746869732E5F656E61626C65643B5C6E5C6E202069662028747970656F66206E6577456E61626C6564203D3D3D2027756E646566696E65642729207B5C6E202020206E6577456E';
wwv_flow_imp.g_varchar2_table(5589) := '61626C6564203D20216F6C64456E61626C65643B5C6E20207D5C6E5C6E20202F2F206F6E6C79207265616374206F6E2061637475616C206368616E6765735C6E2020696620286F6C64456E61626C656420213D3D206E6577456E61626C656429207B5C6E';
wwv_flow_imp.g_varchar2_table(5590) := '5C6E202020202F2F20616464206F722072656D6F766520776865656C206C697374656E6572206261736564206F6E5C6E202020202F2F206368616E67656420656E61626C65642073746174655C6E20202020646F6D4576656E745B6E6577456E61626C65';
wwv_flow_imp.g_varchar2_table(5591) := '64203F202762696E6427203A2027756E62696E64275D28656C656D656E742C2027776865656C272C2068616E646C65576865656C2C2066616C7365293B5C6E20207D5C6E5C6E2020746869732E5F656E61626C6564203D206E6577456E61626C65643B5C';
wwv_flow_imp.g_varchar2_table(5592) := '6E5C6E202072657475726E206E6577456E61626C65643B5C6E7D3B5C6E5C6E5C6E5A6F6F6D5363726F6C6C2E70726F746F747970652E5F696E6974203D2066756E6374696F6E286E6577456E61626C656429207B5C6E2020746869732E746F67676C6528';
wwv_flow_imp.g_varchar2_table(5593) := '6E6577456E61626C6564293B5C6E7D3B5C6E222C22696D706F7274207B5C6E20206C6F6731305C6E7D2066726F6D20272E2E2F2E2E2F7574696C2F4D617468273B5C6E5C6E2F2A2A5C6E202A2047657420737465702073697A6520666F7220676976656E';
wwv_flow_imp.g_varchar2_table(5594) := '2072616E676520616E64206E756D626572206F662073746570732E5C6E202A5C6E202A2040706172616D207B4F626A6563747D2072616E67655C6E202A2040706172616D207B6E756D6265727D2072616E67652E6D696E5C6E202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(5595) := '6E756D6265727D2072616E67652E6D61785C6E202A2040706172616D207B6E756D6265727D2073746570735C6E202A2F5C6E6578706F72742066756E6374696F6E206765745374657053697A652872616E67652C20737465707329207B5C6E5C6E202076';
wwv_flow_imp.g_varchar2_table(5596) := '6172206D696E4C696E65617252616E6765203D206C6F6731302872616E67652E6D696E292C5C6E2020202020206D61784C696E65617252616E6765203D206C6F6731302872616E67652E6D6178293B5C6E5C6E2020766172206162736F6C7574654C696E';
wwv_flow_imp.g_varchar2_table(5597) := '65617252616E6765203D204D6174682E616273286D696E4C696E65617252616E676529202B204D6174682E616273286D61784C696E65617252616E6765293B5C6E5C6E202072657475726E206162736F6C7574654C696E65617252616E6765202F207374';
wwv_flow_imp.g_varchar2_table(5598) := '6570733B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B4F626A6563747D2072616E67655C6E202A2040706172616D207B6E756D6265727D2072616E67652E6D696E5C6E202A2040706172616D207B6E756D6265727D2072616E67652E6D6178';
wwv_flow_imp.g_varchar2_table(5599) := '5C6E202A2040706172616D207B6E756D6265727D207363616C655C6E202A2F5C6E6578706F72742066756E6374696F6E206361702872616E67652C207363616C6529207B5C6E202072657475726E204D6174682E6D61782872616E67652E6D696E2C204D';
wwv_flow_imp.g_varchar2_table(5600) := '6174682E6D696E2872616E67652E6D61782C207363616C6529293B5C6E7D5C6E222C22696D706F7274205A6F6F6D5363726F6C6C2066726F6D20272E2F5A6F6F6D5363726F6C6C273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065207B20696D706F72';
wwv_flow_imp.g_varchar2_table(5601) := '7428276469646927292E4D6F64756C654465636C61726174696F6E207D5C6E202A2F5C6E6578706F72742064656661756C74207B5C6E20205F5F696E69745F5F3A205B20277A6F6F6D5363726F6C6C27205D2C5C6E20207A6F6F6D5363726F6C6C3A205B';
wwv_flow_imp.g_varchar2_table(5602) := '202774797065272C205A6F6F6D5363726F6C6C205D5C6E7D3B222C222F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F636F72652F4576656E7442757327292E64656661756C747D204576656E744275735C6E202A2F5C6E5C6E76';
wwv_flow_imp.g_varchar2_table(5603) := '617220545241505F5052494F52495459203D20353030303B5C6E5C6E2F2A2A5C6E202A20496E7374616C6C73206120636C69636B207472617020746861742070726576656E747320612067686F737420636C69636B20666F6C6C6F77696E672061206472';
wwv_flow_imp.g_varchar2_table(5604) := '616767696E67206F7065726174696F6E2E5C6E202A5C6E202A2040706172616D207B4576656E744275737D206576656E744275735C6E202A2040706172616D207B737472696E677D205B6576656E744E616D653D27656C656D656E742E636C69636B275D';
wwv_flow_imp.g_varchar2_table(5605) := '5C6E202A5C6E202A204072657475726E207B2829203D3E20766F69647D20612066756E6374696F6E20746F20696D6D6564696174656C792072656D6F76652074686520696E7374616C6C656420747261702E5C6E202A2F5C6E6578706F72742066756E63';
wwv_flow_imp.g_varchar2_table(5606) := '74696F6E20696E7374616C6C286576656E744275732C206576656E744E616D6529207B5C6E5C6E20206576656E744E616D65203D206576656E744E616D65207C7C2027656C656D656E742E636C69636B273B5C6E5C6E202066756E6374696F6E20747261';
wwv_flow_imp.g_varchar2_table(5607) := '702829207B5C6E2020202072657475726E2066616C73653B5C6E20207D5C6E5C6E20206576656E744275732E6F6E6365286576656E744E616D652C20545241505F5052494F524954592C2074726170293B5C6E5C6E202072657475726E2066756E637469';
wwv_flow_imp.g_varchar2_table(5608) := '6F6E2829207B5C6E202020206576656E744275732E6F6666286576656E744E616D652C2074726170293B5C6E20207D3B5C6E7D222C222F2A2A5C6E202A204661696C736166652072656D6F766520616E20656C656D656E742066726F6D206120636F6C6C';
wwv_flow_imp.g_varchar2_table(5609) := '656374696F6E5C6E202A5C6E202A2040706172616D207B41727261793C4F626A6563743E7D205B636F6C6C656374696F6E5D5C6E202A2040706172616D207B4F626A6563747D205B656C656D656E745D5C6E202A5C6E202A204072657475726E207B6E75';
wwv_flow_imp.g_varchar2_table(5610) := '6D6265727D207468652070726576696F757320696E646578206F662074686520656C656D656E745C6E202A2F5C6E6578706F72742066756E6374696F6E2072656D6F766528636F6C6C656374696F6E2C20656C656D656E7429207B5C6E5C6E2020696620';
wwv_flow_imp.g_varchar2_table(5611) := '2821636F6C6C656374696F6E207C7C2021656C656D656E7429207B5C6E2020202072657475726E202D313B5C6E20207D5C6E5C6E202076617220696478203D20636F6C6C656374696F6E2E696E6465784F6628656C656D656E74293B5C6E5C6E20206966';
wwv_flow_imp.g_varchar2_table(5612) := '202869647820213D3D202D3129207B5C6E20202020636F6C6C656374696F6E2E73706C696365286964782C2031293B5C6E20207D5C6E5C6E202072657475726E206964783B5C6E7D5C6E5C6E2F2A2A5C6E202A204661696C20736176652061646420616E';
wwv_flow_imp.g_varchar2_table(5613) := '20656C656D656E7420746F2074686520676976656E20636F6E6E656374696F6E2C20656E737572696E675C6E202A20697420646F6573206E6F74207965742065786973742E5C6E202A5C6E202A2040706172616D207B41727261793C4F626A6563743E7D';
wwv_flow_imp.g_varchar2_table(5614) := '20636F6C6C656374696F6E5C6E202A2040706172616D207B4F626A6563747D20656C656D656E745C6E202A2040706172616D207B6E756D6265727D205B6964785D5C6E202A2F5C6E6578706F72742066756E6374696F6E2061646428636F6C6C65637469';
wwv_flow_imp.g_varchar2_table(5615) := '6F6E2C20656C656D656E742C2069647829207B5C6E5C6E20206966202821636F6C6C656374696F6E207C7C2021656C656D656E7429207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E202069662028747970656F662069647820213D3D20276E';
wwv_flow_imp.g_varchar2_table(5616) := '756D6265722729207B5C6E20202020696478203D202D313B5C6E20207D5C6E5C6E20207661722063757272656E74496478203D20636F6C6C656374696F6E2E696E6465784F6628656C656D656E74293B5C6E5C6E20206966202863757272656E74496478';
wwv_flow_imp.g_varchar2_table(5617) := '20213D3D202D3129207B5C6E5C6E202020206966202863757272656E74496478203D3D3D2069647829207B5C6E5C6E2020202020202F2F206E6F7468696E6720746F20646F2C20706F736974696F6E20686173206E6F74206368616E6765645C6E202020';
wwv_flow_imp.g_varchar2_table(5618) := '20202072657475726E3B5C6E202020207D20656C7365207B5C6E5C6E2020202020206966202869647820213D3D202D3129207B5C6E5C6E20202020202020202F2F2072656D6F76652066726F6D2063757272656E7420706F736974696F6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(5619) := '20202020636F6C6C656374696F6E2E73706C6963652863757272656E744964782C2031293B5C6E2020202020207D20656C7365207B5C6E5C6E20202020202020202F2F20616C72656164792065786973747320696E20636F6C6C656374696F6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5620) := '20202020202072657475726E3B5C6E2020202020207D5C6E202020207D5C6E20207D5C6E5C6E20206966202869647820213D3D202D3129207B5C6E5C6E202020202F2F20696E736572742061742073706563696669656420706F736974696F6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5621) := '2020636F6C6C656374696F6E2E73706C696365286964782C20302C20656C656D656E74293B5C6E20207D20656C7365207B5C6E5C6E202020202F2F207075736820746F20656E645C6E20202020636F6C6C656374696F6E2E7075736828656C656D656E74';
wwv_flow_imp.g_varchar2_table(5622) := '293B5C6E20207D5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A204661696C2073617665206765742074686520696E646578206F6620616E20656C656D656E7420696E206120636F6C6C656374696F6E2E5C6E202A5C6E202A2040706172616D207B4172726179';
wwv_flow_imp.g_varchar2_table(5623) := '3C4F626A6563743E7D20636F6C6C656374696F6E5C6E202A2040706172616D207B4F626A6563747D20656C656D656E745C6E202A5C6E202A204072657475726E207B6E756D6265727D2074686520696E646578206F72202D3120696620636F6C6C656374';
wwv_flow_imp.g_varchar2_table(5624) := '696F6E206F7220656C656D656E7420646F5C6E202A2020202020202020202020202020202020206E6F74206578697374206F722074686520656C656D656E74206973206E6F7420636F6E7461696E65642E5C6E202A2F5C6E6578706F72742066756E6374';
wwv_flow_imp.g_varchar2_table(5625) := '696F6E20696E6465784F6628636F6C6C656374696F6E2C20656C656D656E7429207B5C6E5C6E20206966202821636F6C6C656374696F6E207C7C2021656C656D656E7429207B5C6E2020202072657475726E202D313B5C6E20207D5C6E5C6E2020726574';
wwv_flow_imp.g_varchar2_table(5626) := '75726E20636F6C6C656374696F6E2E696E6465784F6628656C656D656E74293B5C6E7D5C6E222C22696D706F7274207B5C6E2020636C617373657320617320646F6D436C61737365735C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E76617220';
wwv_flow_imp.g_varchar2_table(5627) := '435552534F525F434C535F5041545445524E203D202F5E646A732D637572736F722D2E2A242F3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B737472696E677D206D6F64655C6E202A2F5C6E6578706F72742066756E6374696F6E20736574286D6F';
wwv_flow_imp.g_varchar2_table(5628) := '646529207B5C6E202076617220636C6173736573203D20646F6D436C617373657328646F63756D656E742E626F6479293B5C6E5C6E2020636C61737365732E72656D6F76654D61746368696E6728435552534F525F434C535F5041545445524E293B5C6E';
wwv_flow_imp.g_varchar2_table(5629) := '5C6E2020696620286D6F646529207B5C6E20202020636C61737365732E6164642827646A732D637572736F722D27202B206D6F6465293B5C6E20207D5C6E7D5C6E5C6E6578706F72742066756E6374696F6E20756E7365742829207B5C6E202073657428';
wwv_flow_imp.g_varchar2_table(5630) := '6E756C6C293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B737472696E677D206D6F64655C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E20686173286D6F64652920';
wwv_flow_imp.g_varchar2_table(5631) := '7B5C6E202076617220636C6173736573203D20646F6D436C617373657328646F63756D656E742E626F6479293B5C6E5C6E202072657475726E20636C61737365732E6861732827646A732D637572736F722D27202B206D6F6465293B5C6E7D5C6E222C22';
wwv_flow_imp.g_varchar2_table(5632) := '696D706F7274207B5C6E202061737369676E2C5C6E202066696C7465722C5C6E202066696E642C5C6E2020697341727261792C5C6E202069734E756D6265722C5C6E202069734F626A6563742C5C6E20206973556E646566696E65642C5C6E202067726F';
wwv_flow_imp.g_varchar2_table(5633) := '757042792C5C6E2020666F72456163685C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E436F6E6E656374696F6E7D20436F6E6E65';
wwv_flow_imp.g_varchar2_table(5634) := '6374696F6E5C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F547970657327292E456C656D656E747D20456C656D656E745C6E202A204074797065646566207B696D706F727428272E2E2F6D6F64656C2F54797065732729';
wwv_flow_imp.g_varchar2_table(5635) := '2E53686170657D2053686170655C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E526563747D20526563745C6E202A5C6E202A204074797065646566207B207B5C6E202A202020616C6C536861';
wwv_flow_imp.g_varchar2_table(5636) := '7065733A205265636F72643C737472696E672C2053686170653E2C5C6E202A202020616C6C436F6E6E656374696F6E733A205265636F72643C737472696E672C20436F6E6E656374696F6E3E2C5C6E202A202020746F704C6576656C3A205265636F7264';
wwv_flow_imp.g_varchar2_table(5637) := '3C737472696E672C20456C656D656E743E2C5C6E202A202020656E636C6F736564436F6E6E656374696F6E733A205265636F72643C737472696E672C20436F6E6E656374696F6E3E2C5C6E202A202020656E636C6F736564456C656D656E74733A205265';
wwv_flow_imp.g_varchar2_table(5638) := '636F72643C737472696E672C20456C656D656E743E5C6E202A207D207D20436C6F737572655C6E202A2F5C6E5C6E2F2A2A5C6E202A2047657420706172656E7420656C656D656E74732E5C6E202A5C6E202A2040706172616D207B456C656D656E745B5D';
wwv_flow_imp.g_varchar2_table(5639) := '7D20656C656D656E74735C6E202A5C6E202A204072657475726E207B456C656D656E745B5D7D5C6E202A2F5C6E6578706F72742066756E6374696F6E20676574506172656E747328656C656D656E747329207B5C6E5C6E20202F2F2066696E6420656C65';
wwv_flow_imp.g_varchar2_table(5640) := '6D656E7473207468617420617265206E6F74206368696C6472656E206F6620616E79206F7468657220656C656D656E74735C6E202072657475726E2066696C74657228656C656D656E74732C2066756E6374696F6E28656C656D656E7429207B5C6E2020';
wwv_flow_imp.g_varchar2_table(5641) := '202072657475726E202166696E6428656C656D656E74732C2066756E6374696F6E286529207B5C6E20202020202072657475726E206520213D3D20656C656D656E7420262620676574506172656E7428656C656D656E742C2065293B5C6E202020207D29';
wwv_flow_imp.g_varchar2_table(5642) := '3B5C6E20207D293B5C6E7D5C6E5C6E5C6E66756E6374696F6E20676574506172656E7428656C656D656E742C20706172656E7429207B5C6E20206966202821706172656E7429207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E202069662028';
wwv_flow_imp.g_varchar2_table(5643) := '656C656D656E74203D3D3D20706172656E7429207B5C6E2020202072657475726E20706172656E743B5C6E20207D5C6E5C6E20206966202821656C656D656E742E706172656E7429207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E20207265';
wwv_flow_imp.g_varchar2_table(5644) := '7475726E20676574506172656E7428656C656D656E742E706172656E742C20706172656E74293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A204164647320616E20656C656D656E7420746F206120636F6C6C656374696F6E20616E642072657475726E7320';
wwv_flow_imp.g_varchar2_table(5645) := '74727565206966207468655C6E202A20656C656D656E74207761732061646465642E5C6E202A5C6E202A2040706172616D207B4F626A6563745B5D7D20656C656D656E74735C6E202A2040706172616D207B4F626A6563747D20656C656D656E745C6E20';
wwv_flow_imp.g_varchar2_table(5646) := '2A2040706172616D207B626F6F6C65616E7D205B756E697175655D5C6E202A2F5C6E6578706F72742066756E6374696F6E2061646428656C656D656E74732C20656C656D656E742C20756E6971756529207B5C6E20207661722063616E416464203D2021';
wwv_flow_imp.g_varchar2_table(5647) := '756E69717565207C7C20656C656D656E74732E696E6465784F6628656C656D656E7429203D3D3D202D313B5C6E5C6E20206966202863616E41646429207B5C6E20202020656C656D656E74732E7075736828656C656D656E74293B5C6E20207D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5648) := '202072657475726E2063616E4164643B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2049746572617465206F766572206561636820656C656D656E7420696E206120636F6C6C656374696F6E2C2063616C6C696E6720746865206974657261746F722066756E';
wwv_flow_imp.g_varchar2_table(5649) := '6374696F6E2060666E605C6E202A20776974682028656C656D656E742C20696E6465782C20726563757273696F6E4465707468292E5C6E202A5C6E202A205265637572736520696E746F20616C6C20656C656D656E747320746861742061726520726574';
wwv_flow_imp.g_varchar2_table(5650) := '75726E65642062792060666E602E5C6E202A5C6E202A2040706172616D207B456C656D656E747C456C656D656E745B5D7D20656C656D656E74735C6E202A2040706172616D207B28656C656D656E743A20456C656D656E742C20696E6465783A206E756D';
wwv_flow_imp.g_varchar2_table(5651) := '6265722C2064657074683A206E756D62657229203D3E20456C656D656E745B5D207C20626F6F6C65616E207C20756E646566696E65647D20666E5C6E202A2040706172616D207B6E756D6265727D205B64657074685D206D6178696D756D207265637572';
wwv_flow_imp.g_varchar2_table(5652) := '73696F6E2064657074685C6E202A2F5C6E6578706F72742066756E6374696F6E2065616368456C656D656E7428656C656D656E74732C20666E2C20646570746829207B5C6E5C6E20206465707468203D206465707468207C7C20303B5C6E5C6E20206966';
wwv_flow_imp.g_varchar2_table(5653) := '2028216973417272617928656C656D656E74732929207B5C6E20202020656C656D656E7473203D205B20656C656D656E7473205D3B5C6E20207D5C6E5C6E2020666F724561636828656C656D656E74732C2066756E6374696F6E28732C206929207B5C6E';
wwv_flow_imp.g_varchar2_table(5654) := '202020207661722066696C746572203D20666E28732C20692C206465707468293B5C6E5C6E2020202069662028697341727261792866696C746572292026262066696C7465722E6C656E67746829207B5C6E20202020202065616368456C656D656E7428';
wwv_flow_imp.g_varchar2_table(5655) := '66696C7465722C20666E2C206465707468202B2031293B5C6E202020207D5C6E20207D293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20436F6C6C656374732073656C66202B206368696C6420656C656D656E747320757020746F206120676976656E2064';
wwv_flow_imp.g_varchar2_table(5656) := '657074682066726F6D2061206C697374206F6620656C656D656E74732E5C6E202A5C6E202A2040706172616D207B456C656D656E747C456C656D656E745B5D7D20656C656D656E74732074686520656C656D656E747320746F2073656C65637420746865';
wwv_flow_imp.g_varchar2_table(5657) := '206368696C6472656E2066726F6D5C6E202A2040706172616D207B626F6F6C65616E7D20756E69717565207768657468657220746F2072657475726E206120756E6971756520726573756C742073657420286E6F206475706C696361746573295C6E202A';
wwv_flow_imp.g_varchar2_table(5658) := '2040706172616D207B6E756D6265727D206D617844657074682074686520646570746820746F20736561726368207468726F756768206F72202D3120666F7220696E66696E6974655C6E202A5C6E202A204072657475726E207B456C656D656E745B5D7D';
wwv_flow_imp.g_varchar2_table(5659) := '20666F756E6420656C656D656E74735C6E202A2F5C6E6578706F72742066756E6374696F6E2073656C66416E644368696C6472656E28656C656D656E74732C20756E697175652C206D6178446570746829207B5C6E202076617220726573756C74203D20';
wwv_flow_imp.g_varchar2_table(5660) := '5B5D2C5C6E20202020202070726F6365737365644368696C6472656E203D205B5D3B5C6E5C6E202065616368456C656D656E7428656C656D656E74732C2066756E6374696F6E28656C656D656E742C20692C20646570746829207B5C6E20202020616464';
wwv_flow_imp.g_varchar2_table(5661) := '28726573756C742C20656C656D656E742C20756E69717565293B5C6E5C6E20202020766172206368696C6472656E203D20656C656D656E742E6368696C6472656E3B5C6E5C6E202020202F2F206D61782074726176657273616C206465707468206E6F74';
wwv_flow_imp.g_varchar2_table(5662) := '2072656163686564207965745C6E20202020696620286D61784465707468203D3D3D202D31207C7C206465707468203C206D6178446570746829207B5C6E5C6E2020202020202F2F206368696C6472656E206578697374202626206368696C6472656E20';
wwv_flow_imp.g_varchar2_table(5663) := '6E6F74207965742070726F6365737365645C6E202020202020696620286368696C6472656E202626206164642870726F6365737365644368696C6472656E2C206368696C6472656E2C20756E697175652929207B5C6E202020202020202072657475726E';
wwv_flow_imp.g_varchar2_table(5664) := '206368696C6472656E3B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E20726573756C743B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E2073656C66202B20646972656374206368696C6472656E20666F';
wwv_flow_imp.g_varchar2_table(5665) := '722061206E756D626572206F6620656C656D656E74735C6E202A5C6E202A2040706172616D207B456C656D656E745B5D7D20656C656D656E747320746F2071756572795C6E202A2040706172616D207B626F6F6C65616E7D205B616C6C6F774475706C69';
wwv_flow_imp.g_varchar2_table(5666) := '63617465735D20746F20616C6C6F77206475706C69636174657320696E2074686520726573756C74207365745C6E202A5C6E202A204072657475726E207B456C656D656E745B5D7D2074686520636F6C6C656374656420656C656D656E74735C6E202A2F';
wwv_flow_imp.g_varchar2_table(5667) := '5C6E6578706F72742066756E6374696F6E2073656C66416E644469726563744368696C6472656E28656C656D656E74732C20616C6C6F774475706C69636174657329207B5C6E202072657475726E2073656C66416E644368696C6472656E28656C656D65';
wwv_flow_imp.g_varchar2_table(5668) := '6E74732C2021616C6C6F774475706C6963617465732C2031293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E2073656C66202B20414C4C206368696C6472656E20666F722061206E756D626572206F6620656C656D656E74735C6E202A5C6E';
wwv_flow_imp.g_varchar2_table(5669) := '202A2040706172616D207B456C656D656E745B5D7D20656C656D656E747320746F2071756572795C6E202A2040706172616D207B626F6F6C65616E7D205B616C6C6F774475706C6963617465735D20746F20616C6C6F77206475706C6963617465732069';
wwv_flow_imp.g_varchar2_table(5670) := '6E2074686520726573756C74207365745C6E202A5C6E202A204072657475726E207B456C656D656E745B5D7D2074686520636F6C6C656374656420656C656D656E74735C6E202A2F5C6E6578706F72742066756E6374696F6E2073656C66416E64416C6C';
wwv_flow_imp.g_varchar2_table(5671) := '4368696C6472656E28656C656D656E74732C20616C6C6F774475706C69636174657329207B5C6E202072657475726E2073656C66416E644368696C6472656E28656C656D656E74732C2021616C6C6F774475706C6963617465732C202D31293B5C6E7D5C';
wwv_flow_imp.g_varchar2_table(5672) := '6E5C6E5C6E2F2A2A5C6E202A2047657473207468652074686520636C6F7375726520666F7220616C6C2073656C656374656420656C656D656E74732C5C6E202A20746865697220656E636C6F736564206368696C6472656E20616E6420636F6E6E656374';
wwv_flow_imp.g_varchar2_table(5673) := '696F6E732E5C6E202A5C6E202A2040706172616D207B456C656D656E745B5D7D20656C656D656E74735C6E202A2040706172616D207B626F6F6C65616E7D205B6973546F704C6576656C3D747275655D5C6E202A2040706172616D207B436C6F73757265';
wwv_flow_imp.g_varchar2_table(5674) := '7D205B636C6F737572655D5C6E202A5C6E202A204072657475726E207B436C6F737572657D206E6577436C6F737572655C6E202A2F5C6E6578706F72742066756E6374696F6E20676574436C6F7375726528656C656D656E74732C206973546F704C6576';
wwv_flow_imp.g_varchar2_table(5675) := '656C2C20636C6F7375726529207B5C6E5C6E2020696620286973556E646566696E6564286973546F704C6576656C2929207B5C6E202020206973546F704C6576656C203D20747275653B5C6E20207D5C6E5C6E20206966202869734F626A656374286973';
wwv_flow_imp.g_varchar2_table(5676) := '546F704C6576656C2929207B5C6E20202020636C6F73757265203D206973546F704C6576656C3B5C6E202020206973546F704C6576656C203D20747275653B5C6E20207D5C6E5C6E5C6E2020636C6F73757265203D20636C6F73757265207C7C207B7D3B';
wwv_flow_imp.g_varchar2_table(5677) := '5C6E5C6E202076617220616C6C536861706573203D20636F70794F626A65637428636C6F737572652E616C6C536861706573292C5C6E202020202020616C6C436F6E6E656374696F6E73203D20636F70794F626A65637428636C6F737572652E616C6C43';
wwv_flow_imp.g_varchar2_table(5678) := '6F6E6E656374696F6E73292C5C6E202020202020656E636C6F736564456C656D656E7473203D20636F70794F626A65637428636C6F737572652E656E636C6F736564456C656D656E7473292C5C6E202020202020656E636C6F736564436F6E6E65637469';
wwv_flow_imp.g_varchar2_table(5679) := '6F6E73203D20636F70794F626A65637428636C6F737572652E656E636C6F736564436F6E6E656374696F6E73293B5C6E5C6E202076617220746F704C6576656C203D20636F70794F626A656374285C6E20202020636C6F737572652E746F704C6576656C';
wwv_flow_imp.g_varchar2_table(5680) := '2C5C6E202020206973546F704C6576656C2026262067726F7570427928656C656D656E74732C2066756E6374696F6E286529207B2072657475726E20652E69643B207D295C6E2020293B5C6E5C6E5C6E202066756E6374696F6E2068616E646C65436F6E';
wwv_flow_imp.g_varchar2_table(5681) := '6E656374696F6E286329207B5C6E2020202069662028746F704C6576656C5B632E736F757263652E69645D20262620746F704C6576656C5B632E7461726765742E69645D29207B5C6E202020202020746F704C6576656C5B632E69645D203D205B206320';
wwv_flow_imp.g_varchar2_table(5682) := '5D3B5C6E202020207D5C6E5C6E202020202F2F206E6F7420656E636C6F7365642061732061206368696C642C20627574206D61796265206C6F676963616C6C795C6E202020202F2F2028636F6E6E656374696E672074776F206D6F76656420656C656D65';
wwv_flow_imp.g_varchar2_table(5683) := '6E74733F295C6E2020202069662028616C6C5368617065735B632E736F757263652E69645D20262620616C6C5368617065735B632E7461726765742E69645D29207B5C6E202020202020656E636C6F736564436F6E6E656374696F6E735B632E69645D20';
wwv_flow_imp.g_varchar2_table(5684) := '3D20656E636C6F736564456C656D656E74735B632E69645D203D20633B5C6E202020207D5C6E5C6E20202020616C6C436F6E6E656374696F6E735B632E69645D203D20633B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65456C656D65';
wwv_flow_imp.g_varchar2_table(5685) := '6E7428656C656D656E7429207B5C6E5C6E20202020656E636C6F736564456C656D656E74735B656C656D656E742E69645D203D20656C656D656E743B5C6E5C6E2020202069662028656C656D656E742E776179706F696E747329207B5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(5686) := '20202F2F2072656D656D62657220636F6E6E656374696F6E5C6E202020202020656E636C6F736564436F6E6E656374696F6E735B656C656D656E742E69645D203D20616C6C436F6E6E656374696F6E735B656C656D656E742E69645D203D20656C656D65';
wwv_flow_imp.g_varchar2_table(5687) := '6E743B5C6E202020207D20656C7365207B5C6E5C6E2020202020202F2F2072656D656D6265722073686170655C6E202020202020616C6C5368617065735B656C656D656E742E69645D203D20656C656D656E743B5C6E5C6E2020202020202F2F2072656D';
wwv_flow_imp.g_varchar2_table(5688) := '656D62657220616C6C20636F6E6E656374696F6E735C6E202020202020666F724561636828656C656D656E742E696E636F6D696E672C2068616E646C65436F6E6E656374696F6E293B5C6E5C6E202020202020666F724561636828656C656D656E742E6F';
wwv_flow_imp.g_varchar2_table(5689) := '7574676F696E672C2068616E646C65436F6E6E656374696F6E293B5C6E5C6E2020202020202F2F207265637572736520696E746F206368696C6472656E5C6E20202020202072657475726E20656C656D656E742E6368696C6472656E3B5C6E202020207D';
wwv_flow_imp.g_varchar2_table(5690) := '5C6E20207D5C6E5C6E202065616368456C656D656E7428656C656D656E74732C2068616E646C65456C656D656E74293B5C6E5C6E202072657475726E207B5C6E20202020616C6C5368617065733A20616C6C5368617065732C5C6E20202020616C6C436F';
wwv_flow_imp.g_varchar2_table(5691) := '6E6E656374696F6E733A20616C6C436F6E6E656374696F6E732C5C6E20202020746F704C6576656C3A20746F704C6576656C2C5C6E20202020656E636C6F736564436F6E6E656374696F6E733A20656E636C6F736564436F6E6E656374696F6E732C5C6E';
wwv_flow_imp.g_varchar2_table(5692) := '20202020656E636C6F736564456C656D656E74733A20656E636C6F736564456C656D656E74735C6E20207D3B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E732074686520737572726F756E64696E672062626F7820666F7220616C6C20656C656D';
wwv_flow_imp.g_varchar2_table(5693) := '656E747320696E5C6E202A20746865206172726179206F722074686520656C656D656E74207072696D69746976652E5C6E202A5C6E202A2040706172616D207B456C656D656E747C456C656D656E745B5D7D20656C656D656E74735C6E202A2040706172';
wwv_flow_imp.g_varchar2_table(5694) := '616D207B626F6F6C65616E7D205B73746F70526563757273696F6E3D66616C73655D5C6E202A5C6E202A204072657475726E207B526563747D5C6E202A2F5C6E6578706F72742066756E6374696F6E2067657442426F7828656C656D656E74732C207374';
wwv_flow_imp.g_varchar2_table(5695) := '6F70526563757273696F6E29207B5C6E5C6E202073746F70526563757273696F6E203D20212173746F70526563757273696F6E3B5C6E202069662028216973417272617928656C656D656E74732929207B5C6E20202020656C656D656E7473203D205B20';
wwv_flow_imp.g_varchar2_table(5696) := '656C656D656E7473205D3B5C6E20207D5C6E5C6E2020766172206D696E582C5C6E2020202020206D696E592C5C6E2020202020206D6178582C5C6E2020202020206D6178593B5C6E5C6E2020666F724561636828656C656D656E74732C2066756E637469';
wwv_flow_imp.g_varchar2_table(5697) := '6F6E28656C656D656E7429207B5C6E5C6E202020202F2F20496620656C656D656E74206973206120636F6E6E656374696F6E207468652062626F78206D75737420626520636F6D70757465642066697273745C6E202020207661722062626F78203D2065';
wwv_flow_imp.g_varchar2_table(5698) := '6C656D656E743B5C6E2020202069662028656C656D656E742E776179706F696E7473202626202173746F70526563757273696F6E29207B5C6E20202020202062626F78203D2067657442426F7828656C656D656E742E776179706F696E74732C20747275';
wwv_flow_imp.g_varchar2_table(5699) := '65293B5C6E202020207D5C6E5C6E202020207661722078203D2062626F782E782C5C6E202020202020202079203D2062626F782E792C5C6E2020202020202020686569676874203D2062626F782E686569676874207C7C20302C5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(5700) := '7769647468203D2062626F782E7769647468207C7C20303B5C6E5C6E202020206966202878203C206D696E58207C7C206D696E58203D3D3D20756E646566696E656429207B5C6E2020202020206D696E58203D20783B5C6E202020207D5C6E2020202069';
wwv_flow_imp.g_varchar2_table(5701) := '66202879203C206D696E59207C7C206D696E59203D3D3D20756E646566696E656429207B5C6E2020202020206D696E59203D20793B5C6E202020207D5C6E5C6E20202020696620282878202B20776964746829203E206D617858207C7C206D617858203D';
wwv_flow_imp.g_varchar2_table(5702) := '3D3D20756E646566696E656429207B5C6E2020202020206D617858203D2078202B2077696474683B5C6E202020207D5C6E20202020696620282879202B2068656967687429203E206D617859207C7C206D617859203D3D3D20756E646566696E65642920';
wwv_flow_imp.g_varchar2_table(5703) := '7B5C6E2020202020206D617859203D2079202B206865696768743B5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E207B5C6E20202020783A206D696E582C5C6E20202020793A206D696E592C5C6E202020206865696768743A206D6178';
wwv_flow_imp.g_varchar2_table(5704) := '59202D206D696E592C5C6E2020202077696474683A206D617858202D206D696E585C6E20207D3B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E7320616C6C20656C656D656E747320746861742061726520656E636C6F7365642066726F6D20';
wwv_flow_imp.g_varchar2_table(5705) := '74686520626F756E64696E6720626F782E5C6E202A5C6E202A2020202A2049662062626F782E2877696474687C68656967687429206973206E6F742073706563696669656420746865206D6574686F642072657475726E735C6E202A2020202020616C6C';
wwv_flow_imp.g_varchar2_table(5706) := '20656C656D656E7473207769746820656C656D656E742E782F79203E2062626F782E782F795C6E202A2020202A204966206F6E6C792062626F782E78206F722062626F782E79206973207370656369666965642C206D6574686F642072657475726E2061';
wwv_flow_imp.g_varchar2_table(5707) := '6C6C20656C656D656E747320776974685C6E202A2020202020652E78203E2062626F782E78206F7220652E79203E2062626F782E795C6E202A5C6E202A2040706172616D207B456C656D656E745B5D7D20656C656D656E7473204C697374206F6620456C';
wwv_flow_imp.g_varchar2_table(5708) := '656D656E747320746F20736561726368207468726F7567685C6E202A2040706172616D207B526563747D2062626F782074686520656E636C6F73696E672062626F782E5C6E202A5C6E202A204072657475726E207B456C656D656E745B5D7D20656E636C';
wwv_flow_imp.g_varchar2_table(5709) := '6F73656420656C656D656E74735C6E202A2F5C6E6578706F72742066756E6374696F6E20676574456E636C6F736564456C656D656E747328656C656D656E74732C2062626F7829207B5C6E5C6E20207661722066696C7465726564456C656D656E747320';
wwv_flow_imp.g_varchar2_table(5710) := '3D207B7D3B5C6E5C6E2020666F724561636828656C656D656E74732C2066756E6374696F6E28656C656D656E7429207B5C6E5C6E202020207661722065203D20656C656D656E743B5C6E5C6E2020202069662028652E776179706F696E747329207B5C6E';
wwv_flow_imp.g_varchar2_table(5711) := '20202020202065203D2067657442426F782865293B5C6E202020207D5C6E5C6E20202020696620282169734E756D6265722862626F782E79292026262028652E78203E2062626F782E782929207B5C6E20202020202066696C7465726564456C656D656E';
wwv_flow_imp.g_varchar2_table(5712) := '74735B656C656D656E742E69645D203D20656C656D656E743B5C6E202020207D5C6E20202020696620282169734E756D6265722862626F782E78292026262028652E79203E2062626F782E792929207B5C6E20202020202066696C7465726564456C656D';
wwv_flow_imp.g_varchar2_table(5713) := '656E74735B656C656D656E742E69645D203D20656C656D656E743B5C6E202020207D5C6E2020202069662028652E78203E2062626F782E7820262620652E79203E2062626F782E7929207B5C6E2020202020206966202869734E756D6265722862626F78';
wwv_flow_imp.g_varchar2_table(5714) := '2E7769647468292026262069734E756D6265722862626F782E686569676874292026265C6E20202020202020202020652E7769647468202B20652E78203C2062626F782E7769647468202B2062626F782E782026265C6E20202020202020202020652E68';
wwv_flow_imp.g_varchar2_table(5715) := '6569676874202B20652E79203C2062626F782E686569676874202B2062626F782E7929207B5C6E5C6E202020202020202066696C7465726564456C656D656E74735B656C656D656E742E69645D203D20656C656D656E743B5C6E2020202020207D20656C';
wwv_flow_imp.g_varchar2_table(5716) := '736520696620282169734E756D6265722862626F782E776964746829207C7C202169734E756D6265722862626F782E6865696768742929207B5C6E202020202020202066696C7465726564456C656D656E74735B656C656D656E742E69645D203D20656C';
wwv_flow_imp.g_varchar2_table(5717) := '656D656E743B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E2066696C7465726564456C656D656E74733B5C6E7D5C6E5C6E2F2A2A5C6E202A204765742074686520656C656D656E74277320747970655C6E202A';
wwv_flow_imp.g_varchar2_table(5718) := '5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B27636F6E6E656374696F6E27207C2027736861706527207C2027726F6F74277D5C6E202A2F5C6E6578706F72742066756E6374696F';
wwv_flow_imp.g_varchar2_table(5719) := '6E206765745479706528656C656D656E7429207B5C6E5C6E20206966202827776179706F696E74732720696E20656C656D656E7429207B5C6E2020202072657475726E2027636F6E6E656374696F6E273B5C6E20207D5C6E5C6E20206966202827782720';
wwv_flow_imp.g_varchar2_table(5720) := '696E20656C656D656E7429207B5C6E2020202072657475726E20277368617065273B5C6E20207D5C6E5C6E202072657475726E2027726F6F74273B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E';
wwv_flow_imp.g_varchar2_table(5721) := '202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E2069734672616D65456C656D656E7428656C656D656E7429207B5C6E202072657475726E20212128656C656D656E7420262620656C65';
wwv_flow_imp.g_varchar2_table(5722) := '6D656E742E69734672616D65293B5C6E7D5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E20636F70794F626A65637428737263312C207372633229207B';
wwv_flow_imp.g_varchar2_table(5723) := '5C6E202072657475726E2061737369676E287B7D2C2073726331207C7C207B7D2C2073726332207C7C207B7D293B5C6E7D5C6E222C222F2A2A5C6E202A2040706172616D207B737472696E677D207374725C6E202A5C6E202A204072657475726E207B73';
wwv_flow_imp.g_varchar2_table(5724) := '7472696E677D5C6E202A2F5C6E6578706F72742066756E6374696F6E206573636170654353532873747229207B5C6E202072657475726E204353532E65736361706528737472293B5C6E7D5C6E5C6E7661722048544D4C5F4553434150455F4D4150203D';
wwv_flow_imp.g_varchar2_table(5725) := '207B5C6E20202726273A202726616D703B272C5C6E2020273C273A2027266C743B272C5C6E2020273E273A20272667743B272C5C6E2020275C22273A20272671756F743B272C5C6E2020275C5C27273A2027262333393B275C6E7D3B5C6E5C6E2F2A2A5C';
wwv_flow_imp.g_varchar2_table(5726) := '6E202A2040706172616D207B737472696E677D207374725C6E202A5C6E202A204072657475726E207B737472696E677D5C6E202A2F5C6E6578706F72742066756E6374696F6E2065736361706548544D4C2873747229207B5C6E2020737472203D202727';
wwv_flow_imp.g_varchar2_table(5727) := '202B207374723B5C6E5C6E202072657475726E20737472202626207374722E7265706C616365282F5B263C3E5C22275D2F672C2066756E6374696F6E286D6174636829207B5C6E2020202072657475726E2048544D4C5F4553434150455F4D41505B6D61';
wwv_flow_imp.g_varchar2_table(5728) := '7463685D3B5C6E20207D293B5C6E7D5C6E222C222F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F696E745C6E202A2F5C6E5C6E66756E6374696F6E205F5F73746F705072';
wwv_flow_imp.g_varchar2_table(5729) := '6F7061676174696F6E286576656E7429207B5C6E202069662028216576656E74207C7C20747970656F66206576656E742E73746F7050726F7061676174696F6E20213D3D202766756E6374696F6E2729207B5C6E2020202072657475726E3B5C6E20207D';
wwv_flow_imp.g_varchar2_table(5730) := '5C6E5C6E20206576656E742E73746F7050726F7061676174696F6E28293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B696D706F727428272E2E2F636F72652F4576656E7442757327292E4576656E747D206576656E745C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(5731) := '204072657475726E207B4576656E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E206765744F726967696E616C286576656E7429207B5C6E202072657475726E206576656E742E6F726967696E616C4576656E74207C7C206576656E742E73';
wwv_flow_imp.g_varchar2_table(5732) := '72634576656E743B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B4576656E747C696D706F727428272E2E2F636F72652F4576656E7442757327292E4576656E747D206576656E745C6E202A2F5C6E6578706F72742066756E6374696F6E2073';
wwv_flow_imp.g_varchar2_table(5733) := '746F7050726F7061676174696F6E286576656E7429207B5C6E20205F5F73746F7050726F7061676174696F6E286576656E74293B5C6E20205F5F73746F7050726F7061676174696F6E286765744F726967696E616C286576656E7429293B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(5734) := '6E2F2A2A5C6E202A2040706172616D207B4576656E747D206576656E745C6E202A5C6E202A204072657475726E207B506F696E747C6E756C6C7D5C6E202A2F5C6E6578706F72742066756E6374696F6E20746F506F696E74286576656E7429207B5C6E5C';
wwv_flow_imp.g_varchar2_table(5735) := '6E2020696620286576656E742E706F696E74657273202626206576656E742E706F696E746572732E6C656E67746829207B5C6E202020206576656E74203D206576656E742E706F696E746572735B305D3B5C6E20207D5C6E5C6E2020696620286576656E';
wwv_flow_imp.g_varchar2_table(5736) := '742E746F7563686573202626206576656E742E746F75636865732E6C656E67746829207B5C6E202020206576656E74203D206576656E742E746F75636865735B305D3B5C6E20207D5C6E5C6E202072657475726E206576656E74203F207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(5737) := '783A206576656E742E636C69656E74582C5C6E20202020793A206576656E742E636C69656E74595C6E20207D203A206E756C6C3B5C6E7D222C22696D706F7274207B5C6E202065766572795C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E2F';
wwv_flow_imp.g_varchar2_table(5738) := '2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E417869737D20417869735C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F69';
wwv_flow_imp.g_varchar2_table(5739) := '6E745C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E526563747D20526563745C6E202A2F5C6E5C6E2F2A2A5C6E202A20436F6D7075746573207468652064697374616E6365206265747765656E207477';
wwv_flow_imp.g_varchar2_table(5740) := '6F20706F696E74732E5C6E202A5C6E202A2040706172616D207B506F696E747D20615C6E202A2040706172616D207B506F696E747D20625C6E202A5C6E202A204072657475726E207B6E756D6265727D205468652064697374616E636520626574776565';
wwv_flow_imp.g_varchar2_table(5741) := '6E207468652074776F20706F696E74732E5C6E202A2F5C6E6578706F72742066756E6374696F6E20706F696E7444697374616E636528612C206229207B5C6E2020696620282161207C7C20216229207B5C6E2020202072657475726E202D313B5C6E2020';
wwv_flow_imp.g_varchar2_table(5742) := '7D5C6E5C6E202072657475726E204D6174682E73717274285C6E202020204D6174682E706F7728612E78202D20622E782C203229202B5C6E202020204D6174682E706F7728612E79202D20622E792C2032295C6E2020293B5C6E7D5C6E5C6E5C6E2F2A2A';
wwv_flow_imp.g_varchar2_table(5743) := '5C6E202A2052657475726E7320747275652069662074686520706F696E742072206973206F6E20746865206C696E65206265747765656E207020616E6420712E5C6E202A5C6E202A2040706172616D207B506F696E747D20705C6E202A2040706172616D';
wwv_flow_imp.g_varchar2_table(5744) := '207B506F696E747D20715C6E202A2040706172616D207B506F696E747D20725C6E202A2040706172616D207B6E756D6265727D205B61636375726163793D355D20546865206163637572616379207769746820776869636820746F20636865636B20286C';
wwv_flow_imp.g_varchar2_table(5745) := '6F77657220697320626574746572292E5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E20706F696E74734F6E4C696E6528702C20712C20722C20616363757261637929207B5C6E';
wwv_flow_imp.g_varchar2_table(5746) := '5C6E202069662028747970656F66206163637572616379203D3D3D2027756E646566696E65642729207B5C6E202020206163637572616379203D20353B5C6E20207D5C6E5C6E2020696620282170207C7C202171207C7C20217229207B5C6E2020202072';
wwv_flow_imp.g_varchar2_table(5747) := '657475726E2066616C73653B5C6E20207D5C6E5C6E20207661722076616C203D2028712E78202D20702E7829202A2028722E79202D20702E7929202D2028712E79202D20702E7929202A2028722E78202D20702E78292C5C6E2020202020206469737420';
wwv_flow_imp.g_varchar2_table(5748) := '3D20706F696E7444697374616E636528702C2071293B5C6E5C6E20202F2F204073656520687474703A2F2F737461636B6F766572666C6F772E636F6D2F612F3930373439312F3431323139305C6E202072657475726E204D6174682E6162732876616C20';
wwv_flow_imp.g_varchar2_table(5749) := '2F206469737429203C3D2061636375726163793B5C6E7D5C6E5C6E5C6E76617220414C49474E45445F5448524553484F4C44203D20323B5C6E5C6E2F2A2A5C6E202A20436865636B20776865746865722074776F20706F696E74732061726520686F7269';
wwv_flow_imp.g_varchar2_table(5750) := '7A6F6E74616C6C79206F7220766572746963616C6C7920616C69676E65642E5C6E202A5C6E202A2040706172616D207B506F696E745B5D7C506F696E747D20615C6E202A2040706172616D207B506F696E747D205B625D5C6E202A5C6E202A2040726574';
wwv_flow_imp.g_varchar2_table(5751) := '75726E207B737472696E677C626F6F6C65616E7D20496620616E6420686F77207468652074776F20706F696E74732061726520616C69676E656420282768272C20277627206F72206066616C736560292E5C6E202A2F5C6E6578706F72742066756E6374';
wwv_flow_imp.g_varchar2_table(5752) := '696F6E20706F696E7473416C69676E656428612C206229207B5C6E202076617220706F696E7473203D2041727261792E66726F6D28617267756D656E7473292E666C617428293B5C6E5C6E2020636F6E737420617869734D6170203D207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(5753) := '2778273A202776272C5C6E202020202779273A202768275C6E20207D3B5C6E5C6E2020666F722028636F6E7374205B20617869732C206F7269656E746174696F6E205D206F66204F626A6563742E656E747269657328617869734D61702929207B5C6E20';
wwv_flow_imp.g_varchar2_table(5754) := '20202069662028706F696E7473416C69676E65644F6E4178697328617869732C20706F696E74732929207B5C6E20202020202072657475726E206F7269656E746174696F6E3B5C6E202020207D5C6E20207D5C6E5C6E202072657475726E2066616C7365';
wwv_flow_imp.g_varchar2_table(5755) := '3B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B417869737D20617869735C6E202A2040706172616D207B506F696E745B5D7D20706F696E74735C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72';
wwv_flow_imp.g_varchar2_table(5756) := '742066756E6374696F6E20706F696E7473416C69676E65644F6E4178697328617869732C20706F696E747329207B5C6E2020636F6E7374207265666572656E6365506F696E74203D20706F696E74735B305D3B5C6E5C6E202072657475726E2065766572';
wwv_flow_imp.g_varchar2_table(5757) := '7928706F696E74732C2066756E6374696F6E28706F696E7429207B5C6E2020202072657475726E204D6174682E616273287265666572656E6365506F696E745B617869735D202D20706F696E745B617869735D29203C3D20414C49474E45445F54485245';
wwv_flow_imp.g_varchar2_table(5758) := '53484F4C443B5C6E20207D293B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E7320747275652069662074686520706F696E74207020697320696E73696465207468652072656374616E676C6520726563745C6E202A5C6E202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(5759) := '7B506F696E747D20705C6E202A2040706172616D207B526563747D20726563745C6E202A2040706172616D207B6E756D6265727D20746F6C6572616E63655C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72';
wwv_flow_imp.g_varchar2_table(5760) := '742066756E6374696F6E20706F696E74496E5265637428702C20726563742C20746F6C6572616E636529207B5C6E2020746F6C6572616E6365203D20746F6C6572616E6365207C7C20303B5C6E5C6E202072657475726E20702E78203E20726563742E78';
wwv_flow_imp.g_varchar2_table(5761) := '202D20746F6C6572616E63652026265C6E202020202020202020702E79203E20726563742E79202D20746F6C6572616E63652026265C6E202020202020202020702E78203C20726563742E78202B20726563742E7769647468202B20746F6C6572616E63';
wwv_flow_imp.g_varchar2_table(5762) := '652026265C6E202020202020202020702E79203C20726563742E79202B20726563742E686569676874202B20746F6C6572616E63653B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E73206120706F696E7420696E20746865206D6964646C65206F';
wwv_flow_imp.g_varchar2_table(5763) := '6620706F696E7473207020616E6420715C6E202A5C6E202A2040706172616D207B506F696E747D20705C6E202A2040706172616D207B506F696E747D20715C6E202A5C6E202A204072657475726E207B506F696E747D20546865206D696420706F696E74';
wwv_flow_imp.g_varchar2_table(5764) := '206265747765656E207468652074776F20706F696E74732E5C6E202A2F5C6E6578706F72742066756E6374696F6E206765744D6964506F696E7428702C207129207B5C6E202072657475726E207B5C6E20202020783A204D6174682E726F756E6428702E';
wwv_flow_imp.g_varchar2_table(5765) := '78202B202828712E78202D20702E7829202F20322E3029292C5C6E20202020793A204D6174682E726F756E6428702E79202B202828712E79202D20702E7929202F20322E3029295C6E20207D3B5C6E7D5C6E222C222F2A2A5C6E202A205356477320666F';
wwv_flow_imp.g_varchar2_table(5766) := '7220656C656D656E7473206172652067656E65726174656420627920746865207B406C696E6B204772617068696373466163746F72797D2E5C6E202A5C6E202A2054686973207574696C69747920676976657320717569636B2061636365737320746F20';
wwv_flow_imp.g_varchar2_table(5767) := '74686520696D706F7274616E742073656D616E7469635C6E202A207061727473206F6620616E20656C656D656E742E5C6E202A2F5C6E5C6E2F2A2A5C6E202A2052657475726E73207468652076697375616C2070617274206F662061206469616772616D';
wwv_flow_imp.g_varchar2_table(5768) := '20656C656D656E742E5C6E202A5C6E202A2040706172616D207B535647456C656D656E747D206766785C6E202A5C6E202A204072657475726E207B535647456C656D656E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E2067657456697375';
wwv_flow_imp.g_varchar2_table(5769) := '616C2867667829207B5C6E202072657475726E206766782E6368696C644E6F6465735B305D3B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E7320746865206368696C6472656E20666F72206120676976656E206469616772616D20656C656D656E';
wwv_flow_imp.g_varchar2_table(5770) := '742E5C6E202A5C6E202A2040706172616D207B535647456C656D656E747D206766785C6E202A204072657475726E207B535647456C656D656E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E206765744368696C6472656E2867667829207B';
wwv_flow_imp.g_varchar2_table(5771) := '5C6E202072657475726E206766782E706172656E744E6F64652E6368696C644E6F6465735B315D3B5C6E7D222C222F2A2A5C6E202A205574696C20746861742070726F766964657320756E69717565204944732E5C6E202A5C6E202A2040636C6173735C';
wwv_flow_imp.g_varchar2_table(5772) := '6E202A2040636F6E7374727563746F725C6E202A5C6E202A20546865206964732063616E20626520637573746F6D697A656420766961206120676976656E2070726566697820616E6420636F6E7461696E20612072616E646F6D2076616C756520746F20';
wwv_flow_imp.g_varchar2_table(5773) := '61766F696420636F6C6C6973696F6E732E5C6E202A5C6E202A2040706172616D207B737472696E677D205B7072656669785D20612070726566697820746F2070726570656E6420746F2067656E657261746564206964732028666F722062657474657220';
wwv_flow_imp.g_varchar2_table(5774) := '726561646162696C697479295C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E20496447656E657261746F722870726566697829207B5C6E5C6E2020746869732E5F636F756E746572203D20303B5C6E2020746869732E5F7072';
wwv_flow_imp.g_varchar2_table(5775) := '65666978203D2028707265666978203F20707265666978202B20272D27203A20272729202B204D6174682E666C6F6F72284D6174682E72616E646F6D2829202A203130303030303030303029202B20272D273B5C6E7D5C6E5C6E2F2A2A5C6E202A205265';
wwv_flow_imp.g_varchar2_table(5776) := '7475726E732061206E65787420756E697175652049442E5C6E202A5C6E202A204072657475726E207B737472696E677D207468652069645C6E202A2F5C6E496447656E657261746F722E70726F746F747970652E6E657874203D2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(5777) := '29207B5C6E202072657475726E20746869732E5F707265666978202B20282B2B746869732E5F636F756E746572293B5C6E7D3B5C6E222C222F2A2A5C6E202A2047657420746865206C6F6761726974686D206F662078207769746820626173652031302E';
wwv_flow_imp.g_varchar2_table(5778) := '5C6E202A5C6E202A2040706172616D207B6E756D6265727D20785C6E202A2F5C6E6578706F72742066756E6374696F6E206C6F673130287829207B5C6E202072657475726E204D6174682E6C6F67287829202F204D6174682E6C6F67283130293B5C6E7D';
wwv_flow_imp.g_varchar2_table(5779) := '5C6E5C6E6578706F7274207B2064656C746120617320737562737472616374207D2066726F6D20272E2F506F736974696F6E5574696C273B5C6E222C22696D706F7274207B5C6E20206861732C5C6E202069734E696C2C5C6E202069734F626A6563745C';
wwv_flow_imp.g_varchar2_table(5780) := '6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E2F2A2A5C6E202A20436865636B73207768657468657220612076616C756520697320616E20696E7374616E6365206F6620436F6E6E656374696F6E2E5C6E202A5C6E202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(5781) := '616E797D2076616C75655C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E206973436F6E6E656374696F6E2876616C756529207B5C6E202072657475726E2069734F626A65637428';
wwv_flow_imp.g_varchar2_table(5782) := '76616C756529202626206861732876616C75652C2027776179706F696E747327293B5C6E7D5C6E5C6E2F2A2A5C6E202A20436865636B73207768657468657220612076616C756520697320616E20696E7374616E6365206F66204C6162656C2E5C6E202A';
wwv_flow_imp.g_varchar2_table(5783) := '5C6E202A2040706172616D207B616E797D2076616C75655C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E2069734C6162656C2876616C756529207B5C6E202072657475726E2069';
wwv_flow_imp.g_varchar2_table(5784) := '734F626A6563742876616C756529202626206861732876616C75652C20276C6162656C54617267657427293B5C6E7D5C6E5C6E2F2A2A5C6E202A20436865636B73207768657468657220612076616C756520697320616E20696E7374616E6365206F6620';
wwv_flow_imp.g_varchar2_table(5785) := '526F6F742E5C6E202A5C6E202A2040706172616D207B616E797D2076616C75655C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E206973526F6F742876616C756529207B5C6E2020';
wwv_flow_imp.g_varchar2_table(5786) := '72657475726E2069734F626A6563742876616C7565292026262069734E696C2876616C75652E706172656E74293B5C6E7D222C22696D706F7274207B5C6E20206765744F726967696E616C206173206765744F726967696E616C4576656E745C6E7D2066';
wwv_flow_imp.g_varchar2_table(5787) := '726F6D20272E2F4576656E74273B5C6E5C6E696D706F7274207B5C6E202069734D61635C6E7D2066726F6D20272E2F506C6174666F726D273B5C6E5C6E6578706F7274207B5C6E202069734D61635C6E7D2066726F6D20272E2F506C6174666F726D273B';
wwv_flow_imp.g_varchar2_table(5788) := '5C6E5C6E2F2A2A5C6E202A2040706172616D207B4D6F7573654576656E747D206576656E745C6E202A2040706172616D207B737472696E677D20627574746F6E5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E657870';
wwv_flow_imp.g_varchar2_table(5789) := '6F72742066756E6374696F6E206973427574746F6E286576656E742C20627574746F6E29207B5C6E202072657475726E20286765744F726967696E616C4576656E74286576656E7429207C7C206576656E74292E627574746F6E203D3D3D20627574746F';
wwv_flow_imp.g_varchar2_table(5790) := '6E3B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B4D6F7573654576656E747D206576656E745C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E2069735072696D617279';
wwv_flow_imp.g_varchar2_table(5791) := '427574746F6E286576656E7429207B5C6E5C6E20202F2F20627574746F6E203D3D3D2030202D3E206C65667420C3A16B61207072696D617279206D6F75736520627574746F6E5C6E202072657475726E206973427574746F6E286576656E742C2030293B';
wwv_flow_imp.g_varchar2_table(5792) := '5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B4D6F7573654576656E747D206576656E745C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E206973417578696C69617279';
wwv_flow_imp.g_varchar2_table(5793) := '427574746F6E286576656E7429207B5C6E5C6E20202F2F20627574746F6E203D3D3D2031202D3E20617578696C6961727920C3A16B6120776865656C20627574746F6E5C6E202072657475726E206973427574746F6E286576656E742C2031293B5C6E7D';
wwv_flow_imp.g_varchar2_table(5794) := '5C6E5C6E2F2A2A5C6E202A2040706172616D207B4D6F7573654576656E747D206576656E745C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E2069735365636F6E64617279427574';
wwv_flow_imp.g_varchar2_table(5795) := '746F6E286576656E7429207B5C6E5C6E20202F2F20627574746F6E203D3D3D2032202D3E20726967687420C3A16B61207365636F6E6461727920627574746F6E5C6E202072657475726E206973427574746F6E286576656E742C2032293B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(5796) := '6E2F2A2A5C6E202A2040706172616D207B4D6F7573654576656E747D206576656E745C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E206861735072696D6172794D6F6469666965';
wwv_flow_imp.g_varchar2_table(5797) := '72286576656E7429207B5C6E2020766172206F726967696E616C4576656E74203D206765744F726967696E616C4576656E74286576656E7429207C7C206576656E743B5C6E5C6E2020696620282169735072696D617279427574746F6E286576656E7429';
wwv_flow_imp.g_varchar2_table(5798) := '29207B5C6E2020202072657475726E2066616C73653B5C6E20207D5C6E5C6E20202F2F2055736520636D64206173207072696D617279206D6F646966696572206B657920666F72206D6163204F535C6E20206966202869734D6163282929207B5C6E2020';
wwv_flow_imp.g_varchar2_table(5799) := '202072657475726E206F726967696E616C4576656E742E6D6574614B65793B5C6E20207D20656C7365207B5C6E2020202072657475726E206F726967696E616C4576656E742E6374726C4B65793B5C6E20207D5C6E7D5C6E5C6E2F2A2A5C6E202A204070';
wwv_flow_imp.g_varchar2_table(5800) := '6172616D207B4D6F7573654576656E747D206576656E745C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E6578706F72742066756E6374696F6E206861735365636F6E646172794D6F646966696572286576656E742920';
wwv_flow_imp.g_varchar2_table(5801) := '7B5C6E2020766172206F726967696E616C4576656E74203D206765744F726967696E616C4576656E74286576656E7429207C7C206576656E743B5C6E5C6E202072657475726E2069735072696D617279427574746F6E286576656E7429202626206F7269';
wwv_flow_imp.g_varchar2_table(5802) := '67696E616C4576656E742E73686966744B65793B5C6E7D5C6E222C226578706F72742066756E6374696F6E2069734D61632829207B5C6E202072657475726E20282F6D61632F69292E74657374286E6176696761746F722E706C6174666F726D293B5C6E';
wwv_flow_imp.g_varchar2_table(5803) := '7D222C222F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F696E745C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E526563';
wwv_flow_imp.g_varchar2_table(5804) := '747D20526563745C6E202A2F5C6E5C6E2F2A2A5C6E202A2040706172616D207B526563747D20626F756E64735C6E202A204072657475726E207B506F696E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E2063656E74657228626F756E6473';
wwv_flow_imp.g_varchar2_table(5805) := '29207B5C6E202072657475726E207B5C6E20202020783A20626F756E64732E78202B2028626F756E64732E7769647468202F2032292C5C6E20202020793A20626F756E64732E79202B2028626F756E64732E686569676874202F2032295C6E20207D3B5C';
wwv_flow_imp.g_varchar2_table(5806) := '6E7D5C6E5C6E5C6E2F2A2A5C6E202A2040706172616D207B506F696E747D20615C6E202A2040706172616D207B506F696E747D20625C6E202A204072657475726E207B506F696E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E2064656C74';
wwv_flow_imp.g_varchar2_table(5807) := '6128612C206229207B5C6E202072657475726E207B5C6E20202020783A20612E78202D20622E782C5C6E20202020793A20612E79202D20622E795C6E20207D3B5C6E7D5C6E222C22696D706F7274207B5C6E202069734E756D6265725C6E7D2066726F6D';
wwv_flow_imp.g_varchar2_table(5808) := '20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E20206174747220617320737667417474722C5C6E2020637265617465206173207376674372656174655C6E7D2066726F6D202774696E792D737667273B5C6E5C6E5C6E2F2A2A5C6E202A';
wwv_flow_imp.g_varchar2_table(5809) := '204074797065646566207B28737472696E677C6E756D626572295B5D7D20436F6D706F6E656E745C6E202A5C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E506F696E747D20506F696E745C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(5810) := '6E5C6E2F2A2A5C6E202A2040706172616D207B436F6D706F6E656E745B5D207C20436F6D706F6E656E745B5D5B5D7D20656C656D656E74735C6E202A5C6E202A204072657475726E207B737472696E677D5C6E202A2F5C6E6578706F72742066756E6374';
wwv_flow_imp.g_varchar2_table(5811) := '696F6E20636F6D706F6E656E7473546F5061746828656C656D656E747329207B5C6E202072657475726E20656C656D656E74732E666C617428292E6A6F696E28272C27292E7265706C616365282F2C3F285B412D7A5D292C3F2F672C2027243127293B5C';
wwv_flow_imp.g_varchar2_table(5812) := '6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B506F696E745B5D7D20706F696E74735C6E202A5C6E202A204072657475726E207B737472696E677D5C6E202A2F5C6E6578706F72742066756E6374696F6E20746F535647506F696E747328706F69';
wwv_flow_imp.g_varchar2_table(5813) := '6E747329207B5C6E202076617220726573756C74203D2027273B5C6E5C6E2020666F7220287661722069203D20302C20703B202870203D20706F696E74735B695D293B20692B2B29207B5C6E20202020726573756C74202B3D20702E78202B20272C2720';
wwv_flow_imp.g_varchar2_table(5814) := '2B20702E79202B202720273B5C6E20207D5C6E5C6E202072657475726E20726573756C743B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B506F696E747D20706F696E745C6E202A5C6E202A204072657475726E207B436F6D706F6E656E745B';
wwv_flow_imp.g_varchar2_table(5815) := '5D7D5C6E202A2F5C6E66756E6374696F6E206D6F766528706F696E7429207B5C6E202072657475726E205B20274D272C20706F696E742E782C20706F696E742E79205D3B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B506F696E747D20706F';
wwv_flow_imp.g_varchar2_table(5816) := '696E745C6E202A5C6E202A204072657475726E207B436F6D706F6E656E745B5D7D5C6E202A2F5C6E66756E6374696F6E206C696E65546F28706F696E7429207B5C6E202072657475726E205B20274C272C20706F696E742E782C20706F696E742E79205D';
wwv_flow_imp.g_varchar2_table(5817) := '3B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B506F696E747D2070315C6E202A2040706172616D207B506F696E747D2070325C6E202A2040706172616D207B506F696E747D2070335C6E202A5C6E202A204072657475726E207B436F6D706F';
wwv_flow_imp.g_varchar2_table(5818) := '6E656E745B5D7D5C6E202A2F5C6E66756E6374696F6E206375727665546F2870312C2070322C20703329207B5C6E202072657475726E205B202743272C2070312E782C2070312E792C2070322E782C2070322E792C2070332E782C2070332E79205D3B5C';
wwv_flow_imp.g_varchar2_table(5819) := '6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B506F696E745B5D7D20776179706F696E74735C6E202A2040706172616D207B6E756D6265727D205B636F726E65725261646975735D5C6E202A204072657475726E207B436F6D706F6E656E745B5D';
wwv_flow_imp.g_varchar2_table(5820) := '5B5D7D5C6E202A2F5C6E66756E6374696F6E20647261775061746828776179706F696E74732C20636F726E657252616469757329207B5C6E2020636F6E737420706F696E74436F756E74203D20776179706F696E74732E6C656E6774683B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5821) := '636F6E73742070617468203D205B206D6F766528776179706F696E74735B305D29205D3B5C6E5C6E2020666F7220286C65742069203D20313B2069203C20706F696E74436F756E743B20692B2B29207B5C6E5C6E20202020636F6E737420706F696E7442';
wwv_flow_imp.g_varchar2_table(5822) := '65666F7265203D20776179706F696E74735B69202D20315D3B5C6E20202020636F6E737420706F696E74203D20776179706F696E74735B695D3B5C6E20202020636F6E737420706F696E744166746572203D20776179706F696E74735B69202B20315D3B';
wwv_flow_imp.g_varchar2_table(5823) := '5C6E5C6E202020206966202821706F696E744166746572207C7C2021636F726E657252616469757329207B5C6E202020202020706174682E70757368286C696E65546F28706F696E7429293B5C6E5C6E202020202020636F6E74696E75653B5C6E202020';
wwv_flow_imp.g_varchar2_table(5824) := '207D5C6E5C6E20202020636F6E737420656666656374697665526164697573203D204D6174682E6D696E285C6E202020202020636F726E65725261646975732C5C6E202020202020766563746F724C656E67746828706F696E742E78202D20706F696E74';
wwv_flow_imp.g_varchar2_table(5825) := '4265666F72652E782C20706F696E742E79202D20706F696E744265666F72652E79292C5C6E202020202020766563746F724C656E67746828706F696E7441667465722E78202D20706F696E742E782C20706F696E7441667465722E79202D20706F696E74';
wwv_flow_imp.g_varchar2_table(5826) := '2E79295C6E20202020293B5C6E5C6E20202020696620282165666665637469766552616469757329207B5C6E202020202020706174682E70757368286C696E65546F28706F696E7429293B5C6E5C6E202020202020636F6E74696E75653B5C6E20202020';
wwv_flow_imp.g_varchar2_table(5827) := '7D5C6E5C6E20202020636F6E7374206265666F7265506F696E74203D20676574506F696E7441744C656E67746828706F696E742C20706F696E744265666F72652C20656666656374697665526164697573293B5C6E20202020636F6E7374206265666F72';
wwv_flow_imp.g_varchar2_table(5828) := '65506F696E7432203D20676574506F696E7441744C656E67746828706F696E742C20706F696E744265666F72652C20656666656374697665526164697573202A202E35293B5C6E5C6E20202020636F6E7374206166746572506F696E74203D2067657450';
wwv_flow_imp.g_varchar2_table(5829) := '6F696E7441744C656E67746828706F696E742C20706F696E7441667465722C20656666656374697665526164697573293B5C6E20202020636F6E7374206166746572506F696E7432203D20676574506F696E7441744C656E67746828706F696E742C2070';
wwv_flow_imp.g_varchar2_table(5830) := '6F696E7441667465722C20656666656374697665526164697573202A202E35293B5C6E5C6E20202020706174682E70757368286C696E65546F286265666F7265506F696E7429293B5C6E20202020706174682E70757368286375727665546F286265666F';
wwv_flow_imp.g_varchar2_table(5831) := '7265506F696E74322C206166746572506F696E74322C206166746572506F696E7429293B5C6E20207D5C6E5C6E202072657475726E20706174683B5C6E7D5C6E5C6E66756E6374696F6E20676574506F696E7441744C656E6774682873746172742C2065';
wwv_flow_imp.g_varchar2_table(5832) := '6E642C206C656E67746829207B5C6E5C6E2020636F6E73742064656C746158203D20656E642E78202D2073746172742E783B5C6E2020636F6E73742064656C746159203D20656E642E79202D2073746172742E793B5C6E5C6E2020636F6E737420746F74';
wwv_flow_imp.g_varchar2_table(5833) := '616C4C656E677468203D20766563746F724C656E6774682864656C7461582C2064656C746159293B5C6E5C6E2020636F6E73742070657263656E74203D206C656E677468202F20746F74616C4C656E6774683B5C6E5C6E202072657475726E207B5C6E20';
wwv_flow_imp.g_varchar2_table(5834) := '202020783A2073746172742E78202B2064656C746158202A2070657263656E742C5C6E20202020793A2073746172742E79202B2064656C746159202A2070657263656E745C6E20207D3B5C6E7D5C6E5C6E66756E6374696F6E20766563746F724C656E67';
wwv_flow_imp.g_varchar2_table(5835) := '746828782C207929207B5C6E202072657475726E204D6174682E73717274284D6174682E706F7728782C203229202B204D6174682E706F7728792C203229293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B506F696E745B5D7D20706F696E';
wwv_flow_imp.g_varchar2_table(5836) := '74735C6E202A2040706172616D207B6E756D6265727C4F626A6563747D205B61747472735D5C6E202A2040706172616D207B6E756D6265727D205B7261646975735D5C6E202A5C6E202A204072657475726E207B535647456C656D656E747D5C6E202A2F';
wwv_flow_imp.g_varchar2_table(5837) := '5C6E6578706F72742066756E6374696F6E206372656174654C696E6528706F696E74732C2061747472732C2072616469757329207B5C6E5C6E20206966202869734E756D6265722861747472732929207B5C6E20202020726164697573203D2061747472';
wwv_flow_imp.g_varchar2_table(5838) := '733B5C6E202020206174747273203D206E756C6C3B5C6E20207D5C6E5C6E20206966202821617474727329207B5C6E202020206174747273203D207B7D3B5C6E20207D5C6E5C6E2020636F6E7374206C696E65203D207376674372656174652827706174';
wwv_flow_imp.g_varchar2_table(5839) := '68272C206174747273293B5C6E5C6E20206966202869734E756D626572287261646975732929207B5C6E202020206C696E652E646174617365742E636F726E6572526164697573203D20537472696E6728726164697573293B5C6E20207D5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(5840) := '72657475726E207570646174654C696E65286C696E652C20706F696E7473293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B535647456C656D656E747D206766785C6E202A2040706172616D207B506F696E745B5D7D20706F696E74735C6E';
wwv_flow_imp.g_varchar2_table(5841) := '202A5C6E202A204072657475726E207B535647456C656D656E747D5C6E202A2F5C6E6578706F72742066756E6374696F6E207570646174654C696E65286766782C20706F696E747329207B5C6E5C6E2020636F6E737420636F726E657252616469757320';
wwv_flow_imp.g_varchar2_table(5842) := '3D207061727365496E74286766782E646174617365742E636F726E65725261646975732C20313029207C7C20303B5C6E5C6E202073766741747472286766782C207B5C6E20202020643A20636F6D706F6E656E7473546F50617468286472617750617468';
wwv_flow_imp.g_varchar2_table(5843) := '28706F696E74732C20636F726E657252616469757329295C6E20207D293B5C6E5C6E202072657475726E206766783B5C6E7D5C6E222C22696D706F7274207B5C725C6E20207472616E73666F726D206173207376675472616E73666F726D2C5C725C6E20';
wwv_flow_imp.g_varchar2_table(5844) := '206372656174655472616E73666F726D5C725C6E7D2066726F6D202774696E792D737667273B5C725C6E5C725C6E5C725C6E2F2A2A5C725C6E202A2040706172616D207B535647456C656D656E747D206766785C725C6E202A2040706172616D207B6E75';
wwv_flow_imp.g_varchar2_table(5845) := '6D6265727D20785C725C6E202A2040706172616D207B6E756D6265727D20795C725C6E202A2040706172616D207B6E756D6265727D205B616E676C655D5C725C6E202A2040706172616D207B6E756D6265727D205B616D6F756E745D5C725C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(5846) := '725C6E6578706F72742066756E6374696F6E207472616E73666F726D286766782C20782C20792C20616E676C652C20616D6F756E7429207B5C725C6E2020766172207472616E736C617465203D206372656174655472616E73666F726D28293B5C725C6E';
wwv_flow_imp.g_varchar2_table(5847) := '20207472616E736C6174652E7365745472616E736C61746528782C2079293B5C725C6E5C725C6E202076617220726F74617465203D206372656174655472616E73666F726D28293B5C725C6E2020726F746174652E736574526F7461746528616E676C65';
wwv_flow_imp.g_varchar2_table(5848) := '207C7C20302C20302C2030293B5C725C6E5C725C6E2020766172207363616C65203D206372656174655472616E73666F726D28293B5C725C6E20207363616C652E7365745363616C6528616D6F756E74207C7C20312C20616D6F756E74207C7C2031293B';
wwv_flow_imp.g_varchar2_table(5849) := '5C725C6E5C725C6E20207376675472616E73666F726D286766782C205B207472616E736C6174652C20726F746174652C207363616C65205D293B5C725C6E7D5C725C6E5C725C6E5C725C6E2F2A2A5C725C6E202A2040706172616D207B535647456C656D';
wwv_flow_imp.g_varchar2_table(5850) := '656E747D206766785C725C6E202A2040706172616D207B6E756D6265727D20785C725C6E202A2040706172616D207B6E756D6265727D20795C725C6E202A2F5C725C6E6578706F72742066756E6374696F6E207472616E736C617465286766782C20782C';
wwv_flow_imp.g_varchar2_table(5851) := '207929207B5C725C6E2020766172207472616E736C617465203D206372656174655472616E73666F726D28293B5C725C6E20207472616E736C6174652E7365745472616E736C61746528782C2079293B5C725C6E5C725C6E20207376675472616E73666F';
wwv_flow_imp.g_varchar2_table(5852) := '726D286766782C207472616E736C617465293B5C725C6E7D5C725C6E5C725C6E5C725C6E2F2A2A5C725C6E202A2040706172616D207B535647456C656D656E747D206766785C725C6E202A2040706172616D207B6E756D6265727D20616E676C655C725C';
wwv_flow_imp.g_varchar2_table(5853) := '6E202A2F5C725C6E6578706F72742066756E6374696F6E20726F74617465286766782C20616E676C6529207B5C725C6E202076617220726F74617465203D206372656174655472616E73666F726D28293B5C725C6E2020726F746174652E736574526F74';
wwv_flow_imp.g_varchar2_table(5854) := '61746528616E676C652C20302C2030293B5C725C6E5C725C6E20207376675472616E73666F726D286766782C20726F74617465293B5C725C6E7D5C725C6E5C725C6E5C725C6E2F2A2A5C725C6E202A2040706172616D207B535647456C656D656E747D20';
wwv_flow_imp.g_varchar2_table(5855) := '6766785C725C6E202A2040706172616D207B6E756D6265727D20616D6F756E745C725C6E202A2F5C725C6E6578706F72742066756E6374696F6E207363616C65286766782C20616D6F756E7429207B5C725C6E2020766172207363616C65203D20637265';
wwv_flow_imp.g_varchar2_table(5856) := '6174655472616E73666F726D28293B5C725C6E20207363616C652E7365745363616C6528616D6F756E742C20616D6F756E74293B5C725C6E5C725C6E20207376675472616E73666F726D286766782C207363616C65293B5C725C6E7D5C725C6E222C2269';
wwv_flow_imp.g_varchar2_table(5857) := '6D706F7274207B5C6E202069734F626A6563742C5C6E202061737369676E2C5C6E2020666F72456163682C5C6E20207265647563655C6E7D2066726F6D20276D696E2D64617368273B5C6E5C6E696D706F7274207B5C6E2020617070656E642061732073';
wwv_flow_imp.g_varchar2_table(5858) := '7667417070656E642C5C6E20206174747220617320737667417474722C5C6E2020637265617465206173207376674372656174652C5C6E202072656D6F76652061732073766752656D6F76655C6E7D2066726F6D202774696E792D737667273B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5859) := '696D706F7274207B5C6E202061737369676E5374796C655C6E7D2066726F6D20276D696E2D646F6D273B5C6E5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2E2F7574696C2F547970657327292E44696D656E73696F6E73';
wwv_flow_imp.g_varchar2_table(5860) := '7D2044696D656E73696F6E735C6E202A5C6E202A204074797065646566207B207B5C6E202A202020746F703A206E756D6265723B5C6E202A2020206C6566743A206E756D6265723B5C6E202A20202072696768743A206E756D6265723B5C6E202A202020';
wwv_flow_imp.g_varchar2_table(5861) := '626F74746F6D3A206E756D6265723B5C6E202A207D207D2050616464696E675C6E202A5C6E202A204074797065646566207B206E756D626572207C205061727469616C3C50616464696E673E207D2050616464696E67436F6E6669675C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(5862) := '204074797065646566207B207B5C6E202A202020686F72697A6F6E74616C3A202763656E74657227207C20276C65667427207C20277269676874273B5C6E202A202020766572746963616C3A2027746F7027207C20276D6964646C65273B5C6E202A207D';
wwv_flow_imp.g_varchar2_table(5863) := '207D20416C69676E6D656E745C6E202A5C6E202A20204074797065646566207B202763656E7465722D6D6964646C6527207C202763656E7465722D746F7027207D20416C69676E6D656E74436F6E6669675C6E202A5C6E202A204074797065646566207B';
wwv_flow_imp.g_varchar2_table(5864) := '205061727469616C3C7B5C6E202A202020616C69676E3A20416C69676E6D656E74436F6E6669673B5C6E202A2020207374796C653A205265636F72643C737472696E672C206E756D626572207C20737472696E673E3B5C6E202A20202070616464696E67';
wwv_flow_imp.g_varchar2_table(5865) := '3A2050616464696E67436F6E6669673B5C6E202A207D3E207D204261736554657874436F6E6669675C6E202A5C6E202A204074797065646566207B204261736554657874436F6E6669672026205061727469616C3C7B5C6E202A20202073697A653A2044';
wwv_flow_imp.g_varchar2_table(5866) := '696D656E73696F6E733B5C6E202A207D3E207D2054657874436F6E6669675C6E202A5C6E202A204074797065646566207B204261736554657874436F6E6669672026205061727469616C3C7B5C6E202A202020626F783A2044696D656E73696F6E733B5C';
wwv_flow_imp.g_varchar2_table(5867) := '6E202A202020666974426F783A20626F6F6C65616E3B5C6E202A207D3E207D20546578744C61796F7574436F6E6669675C6E202A5C6E202A20204074797065646566207B2044696D656E73696F6E732026207B5C6E202A2020746578743A20737472696E';
wwv_flow_imp.g_varchar2_table(5868) := '673B5C6E202A207D207D204C696E6544657363726970746F725C6E202A2F5C6E5C6E7661722044454641554C545F424F585F50414444494E47203D20303B5C6E5C6E7661722044454641554C545F4C4142454C5F53495A45203D207B5C6E202077696474';
wwv_flow_imp.g_varchar2_table(5869) := '683A203135302C5C6E20206865696768743A2035305C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2040706172616D207B416C69676E6D656E74436F6E6669677D20616C69676E5C6E202A204072657475726E207B416C69676E6D656E747D5C6E202A2F5C6E';
wwv_flow_imp.g_varchar2_table(5870) := '66756E6374696F6E207061727365416C69676E28616C69676E29207B5C6E5C6E2020766172207061727473203D20616C69676E2E73706C697428272D27293B5C6E5C6E202072657475726E207B5C6E20202020686F72697A6F6E74616C3A207061727473';
wwv_flow_imp.g_varchar2_table(5871) := '5B305D207C7C202763656E746572272C5C6E20202020766572746963616C3A2070617274735B315D207C7C2027746F70275C6E20207D3B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B50616464696E67436F6E6669677D2070616464696E67';
wwv_flow_imp.g_varchar2_table(5872) := '5C6E202A5C6E202A204072657475726E207B50616464696E677D5C6E202A2F5C6E66756E6374696F6E20706172736550616464696E672870616464696E6729207B5C6E5C6E20206966202869734F626A6563742870616464696E672929207B5C6E202020';
wwv_flow_imp.g_varchar2_table(5873) := '2072657475726E2061737369676E287B20746F703A20302C206C6566743A20302C2072696768743A20302C20626F74746F6D3A2030207D2C2070616464696E67293B5C6E20207D20656C7365207B5C6E2020202072657475726E207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(5874) := '746F703A2070616464696E672C5C6E2020202020206C6566743A2070616464696E672C5C6E20202020202072696768743A2070616464696E672C5C6E202020202020626F74746F6D3A2070616464696E675C6E202020207D3B5C6E20207D5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(5875) := '6E2F2A2A5C6E202A2040706172616D207B737472696E677D20746578745C6E202A2040706172616D207B53564754657874456C656D656E747D2066616B65546578745C6E202A5C6E202A204072657475726E207B696D706F727428272E2E2F7574696C2F';
wwv_flow_imp.g_varchar2_table(5876) := '547970657327292E44696D656E73696F6E737D5C6E202A2F5C6E66756E6374696F6E206765745465787442426F7828746578742C2066616B655465787429207B5C6E5C6E202066616B65546578742E74657874436F6E74656E74203D20746578743B5C6E';
wwv_flow_imp.g_varchar2_table(5877) := '5C6E2020766172207465787442426F783B5C6E5C6E2020747279207B5C6E202020207661722062626F782C5C6E2020202020202020656D7074794C696E65203D2074657874203D3D3D2027273B5C6E5C6E202020202F2F206164642064756D6D79207465';
wwv_flow_imp.g_varchar2_table(5878) := '78742C207768656E206C696E6520697320656D70747920746F5C6E202020202F2F2064657465726D696E6520636F7272656374206865696768745C6E2020202066616B65546578742E74657874436F6E74656E74203D20656D7074794C696E65203F2027';
wwv_flow_imp.g_varchar2_table(5879) := '64756D6D7927203A20746578743B5C6E5C6E202020207465787442426F78203D2066616B65546578742E67657442426F7828293B5C6E5C6E202020202F2F2074616B6520746578742072656E646572696E672072656C6174656420686F72697A6F6E7461';
wwv_flow_imp.g_varchar2_table(5880) := '6C5C6E202020202F2F2070616464696E6720696E746F206163636F756E745C6E2020202062626F78203D207B5C6E20202020202077696474683A207465787442426F782E7769647468202B207465787442426F782E78202A20322C5C6E20202020202068';
wwv_flow_imp.g_varchar2_table(5881) := '65696768743A207465787442426F782E6865696768745C6E202020207D3B5C6E5C6E2020202069662028656D7074794C696E6529207B5C6E5C6E2020202020202F2F20636F72726563742077696474685C6E20202020202062626F782E7769647468203D';
wwv_flow_imp.g_varchar2_table(5882) := '20303B5C6E202020207D5C6E5C6E2020202072657475726E2062626F783B5C6E20207D20636174636820286529207B5C6E2020202072657475726E207B2077696474683A20302C206865696768743A2030207D3B5C6E20207D5C6E7D5C6E5C6E5C6E2F2A';
wwv_flow_imp.g_varchar2_table(5883) := '2A5C6E202A204C61796F757420746865206E657874206C696E6520616E642072657475726E20746865206C61796F7574656420656C656D656E742E5C6E202A5C6E202A20416C7465727320746865206C696E6573207061737365642E5C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(5884) := '2040706172616D207B737472696E675B5D7D206C696E65735C6E202A2040706172616D207B6E756D6265727D206D617857696474685C6E202A2040706172616D207B53564754657874456C656D656E747D2066616B65546578745C6E202A5C6E202A2040';
wwv_flow_imp.g_varchar2_table(5885) := '72657475726E207B4C696E6544657363726970746F727D20746865206C696E652064657363726970746F725C6E202A2F5C6E66756E6374696F6E206C61796F75744E657874286C696E65732C206D617857696474682C2066616B655465787429207B5C6E';
wwv_flow_imp.g_varchar2_table(5886) := '5C6E2020766172206F726967696E616C4C696E65203D206C696E65732E736869667428292C5C6E2020202020206669744C696E65203D206F726967696E616C4C696E653B5C6E5C6E2020766172207465787442426F783B5C6E5C6E2020666F7220283B3B';
wwv_flow_imp.g_varchar2_table(5887) := '29207B5C6E202020207465787442426F78203D206765745465787442426F78286669744C696E652C2066616B6554657874293B5C6E5C6E202020207465787442426F782E7769647468203D206669744C696E65203F207465787442426F782E7769647468';
wwv_flow_imp.g_varchar2_table(5888) := '203A20303B5C6E5C6E202020202F2F2074727920746F206669745C6E20202020696620286669744C696E65203D3D3D20272027207C7C206669744C696E65203D3D3D202727207C7C207465787442426F782E7769647468203C204D6174682E726F756E64';
wwv_flow_imp.g_varchar2_table(5889) := '286D6178576964746829207C7C206669744C696E652E6C656E677468203C203229207B5C6E20202020202072657475726E20666974286C696E65732C206669744C696E652C206F726967696E616C4C696E652C207465787442426F78293B5C6E20202020';
wwv_flow_imp.g_varchar2_table(5890) := '7D5C6E5C6E202020206669744C696E65203D2073686F7274656E4C696E65286669744C696E652C207465787442426F782E77696474682C206D61785769647468293B5C6E20207D5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B737472696E67';
wwv_flow_imp.g_varchar2_table(5891) := '5B5D7D206C696E65735C6E202A2040706172616D207B737472696E677D206669744C696E655C6E202A2040706172616D207B737472696E677D206F726967696E616C4C696E655C6E202A2040706172616D207B44696D656E73696F6E737D207465787442';
wwv_flow_imp.g_varchar2_table(5892) := '426F785C6E202A5C6E202A204072657475726E207B4C696E6544657363726970746F727D5C6E202A2F5C6E66756E6374696F6E20666974286C696E65732C206669744C696E652C206F726967696E616C4C696E652C207465787442426F7829207B5C6E20';
wwv_flow_imp.g_varchar2_table(5893) := '20696620286669744C696E652E6C656E677468203C206F726967696E616C4C696E652E6C656E67746829207B5C6E202020207661722072656D61696E646572203D206F726967696E616C4C696E652E736C696365286669744C696E652E6C656E67746829';
wwv_flow_imp.g_varchar2_table(5894) := '2E7472696D28293B5C6E5C6E202020206C696E65732E756E73686966742872656D61696E646572293B5C6E20207D5C6E5C6E202072657475726E207B5C6E2020202077696474683A207465787442426F782E77696474682C5C6E20202020686569676874';
wwv_flow_imp.g_varchar2_table(5895) := '3A207465787442426F782E6865696768742C5C6E20202020746578743A206669744C696E655C6E20207D3B5C6E7D5C6E5C6E76617220534F46545F425245414B203D20275C5C7530304144273B5C6E5C6E5C6E2F2A2A5C6E202A2053686F7274656E7320';
wwv_flow_imp.g_varchar2_table(5896) := '61206C696E65206261736564206F6E2073706163696E6720616E642068797068656E732E5C6E202A2052657475726E73207468652073686F7274656E656420726573756C74206F6E20737563636573732E5C6E202A5C6E202A2040706172616D207B7374';
wwv_flow_imp.g_varchar2_table(5897) := '72696E677D206C696E655C6E202A2040706172616D207B6E756D6265727D206D61784C656E67746820746865206D6178696D756D2063686172616374657273206F662074686520737472696E675C6E202A5C6E202A204072657475726E207B737472696E';
wwv_flow_imp.g_varchar2_table(5898) := '677D207468652073686F7274656E656420737472696E675C6E202A2F5C6E66756E6374696F6E2073656D616E74696353686F7274656E286C696E652C206D61784C656E67746829207B5C6E5C6E2020766172207061727473203D206C696E652E73706C69';
wwv_flow_imp.g_varchar2_table(5899) := '74282F285C5C737C2D7C5C5C7530304144292F67292C5C6E202020202020706172742C5C6E20202020202073686F7274656E65645061727473203D205B5D2C5C6E2020202020206C656E677468203D20303B5C6E5C6E20202F2F2074727920746F207368';
wwv_flow_imp.g_varchar2_table(5900) := '6F7274656E2076696120627265616B2063686172735C6E20206966202870617274732E6C656E677468203E203129207B5C6E5C6E202020207768696C6520282870617274203D2070617274732E736869667428292929207B5C6E20202020202069662028';
wwv_flow_imp.g_varchar2_table(5901) := '706172742E6C656E677468202B206C656E677468203C206D61784C656E67746829207B5C6E202020202020202073686F7274656E656450617274732E707573682870617274293B5C6E20202020202020206C656E677468202B3D20706172742E6C656E67';
wwv_flow_imp.g_varchar2_table(5902) := '74683B5C6E2020202020207D20656C7365207B5C6E5C6E20202020202020202F2F2072656D6F76652070726576696F757320706172742C20746F6F2069662068797068656E20646F6573206E6F742066697420616E796D6F72655C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(5903) := '6966202870617274203D3D3D20272D27207C7C2070617274203D3D3D20534F46545F425245414B29207B5C6E2020202020202020202073686F7274656E656450617274732E706F7028293B5C6E20202020202020207D5C6E5C6E20202020202020206272';
wwv_flow_imp.g_varchar2_table(5904) := '65616B3B5C6E2020202020207D5C6E202020207D5C6E20207D5C6E5C6E2020766172206C617374203D2073686F7274656E656450617274735B73686F7274656E656450617274732E6C656E677468202D20315D3B5C6E5C6E20202F2F207472616E736C61';
wwv_flow_imp.g_varchar2_table(5905) := '746520747261696C696E6720736F667420627265616B20746F2061637475616C2068797068656E5C6E2020696620286C617374202626206C617374203D3D3D20534F46545F425245414B29207B5C6E2020202073686F7274656E656450617274735B7368';
wwv_flow_imp.g_varchar2_table(5906) := '6F7274656E656450617274732E6C656E677468202D20315D203D20272D273B5C6E20207D5C6E5C6E202072657475726E2073686F7274656E656450617274732E6A6F696E282727293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2040706172616D207B7374';
wwv_flow_imp.g_varchar2_table(5907) := '72696E677D206C696E655C6E202A2040706172616D207B6E756D6265727D2077696474685C6E202A2040706172616D207B6E756D6265727D206D617857696474685C6E202A5C6E202A204072657475726E207B737472696E677D5C6E202A2F5C6E66756E';
wwv_flow_imp.g_varchar2_table(5908) := '6374696F6E2073686F7274656E4C696E65286C696E652C2077696474682C206D6178576964746829207B5C6E2020766172206C656E677468203D204D6174682E6D6178286C696E652E6C656E677468202A20286D61785769647468202F20776964746829';
wwv_flow_imp.g_varchar2_table(5909) := '2C2031293B5C6E5C6E20202F2F2074727920746F2073686F7274656E2073656D616E746963616C6C792028692E652E206261736564206F6E2073706163657320616E642068797068656E73295C6E20207661722073686F7274656E65644C696E65203D20';
wwv_flow_imp.g_varchar2_table(5910) := '73656D616E74696353686F7274656E286C696E652C206C656E677468293B5C6E5C6E2020696620282173686F7274656E65644C696E6529207B5C6E5C6E202020202F2F20666F7263652073686F7274656E2062792063757474696E6720746865206C6F6E';
wwv_flow_imp.g_varchar2_table(5911) := '6720776F72645C6E2020202073686F7274656E65644C696E65203D206C696E652E736C69636528302C204D6174682E6D6178284D6174682E726F756E64286C656E677468202D2031292C203129293B5C6E20207D5C6E5C6E202072657475726E2073686F';
wwv_flow_imp.g_varchar2_table(5912) := '7274656E65644C696E653B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A204072657475726E207B535647535647456C656D656E747D5C6E202A2F5C6E66756E6374696F6E2067657448656C7065725376672829207B5C6E20207661722068656C706572537667';
wwv_flow_imp.g_varchar2_table(5913) := '203D20646F63756D656E742E676574456C656D656E7442794964282768656C7065722D73766727293B5C6E5C6E2020696620282168656C70657253766729207B5C6E2020202068656C706572537667203D20737667437265617465282773766727293B5C';
wwv_flow_imp.g_varchar2_table(5914) := '6E5C6E20202020737667417474722868656C7065725376672C207B5C6E20202020202069643A202768656C7065722D737667275C6E202020207D293B5C6E5C6E2020202061737369676E5374796C652868656C7065725376672C207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(5915) := '7669736962696C6974793A202768696464656E272C5C6E202020202020706F736974696F6E3A20276669786564272C5C6E20202020202077696474683A20302C5C6E2020202020206865696768743A20305C6E202020207D293B5C6E5C6E20202020646F';
wwv_flow_imp.g_varchar2_table(5916) := '63756D656E742E626F64792E617070656E644368696C642868656C706572537667293B5C6E20207D5C6E5C6E202072657475726E2068656C7065725376673B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20437265617465732061206E6577206C6162656C20';
wwv_flow_imp.g_varchar2_table(5917) := '7574696C6974795C6E202A5C6E202A2040706172616D207B54657874436F6E6669677D205B636F6E6669675D5C6E202A2F5C6E6578706F72742064656661756C742066756E6374696F6E205465787428636F6E66696729207B5C6E5C6E2020746869732E';
wwv_flow_imp.g_varchar2_table(5918) := '5F636F6E666967203D2061737369676E287B7D2C207B5C6E2020202073697A653A2044454641554C545F4C4142454C5F53495A452C5C6E2020202070616464696E673A2044454641554C545F424F585F50414444494E472C5C6E202020207374796C653A';
wwv_flow_imp.g_varchar2_table(5919) := '207B7D2C5C6E20202020616C69676E3A202763656E7465722D746F70275C6E20207D2C20636F6E666967207C7C207B7D293B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E7320746865206C61796F75746564207465787420617320616E20535647';
wwv_flow_imp.g_varchar2_table(5920) := '20656C656D656E742E5C6E202A5C6E202A2040706172616D207B737472696E677D20746578745C6E202A2040706172616D207B546578744C61796F7574436F6E6669677D206F7074696F6E735C6E202A5C6E202A204072657475726E207B535647456C65';
wwv_flow_imp.g_varchar2_table(5921) := '6D656E747D5C6E202A2F5C6E546578742E70726F746F747970652E63726561746554657874203D2066756E6374696F6E28746578742C206F7074696F6E7329207B5C6E202072657475726E20746869732E6C61796F75745465787428746578742C206F70';
wwv_flow_imp.g_varchar2_table(5922) := '74696F6E73292E656C656D656E743B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E732061206C6162656C73206C61796F757465642064696D656E73696F6E732E5C6E202A5C6E202A2040706172616D207B737472696E677D207465787420746F';
wwv_flow_imp.g_varchar2_table(5923) := '206C61796F75745C6E202A2040706172616D207B546578744C61796F7574436F6E6669677D206F7074696F6E735C6E202A5C6E202A204072657475726E207B44696D656E73696F6E737D5C6E202A2F5C6E546578742E70726F746F747970652E67657444';
wwv_flow_imp.g_varchar2_table(5924) := '696D656E73696F6E73203D2066756E6374696F6E28746578742C206F7074696F6E7329207B5C6E202072657475726E20746869732E6C61796F75745465787428746578742C206F7074696F6E73292E64696D656E73696F6E733B5C6E7D3B5C6E5C6E2F2A';
wwv_flow_imp.g_varchar2_table(5925) := '2A5C6E202A204372656174657320616E642072657475726E732061206C6162656C20616E642069747320626F756E64696E6720626F782E5C6E202A5C6E202A2040706172616D207B737472696E677D207465787420746865207465787420746F2072656E';
wwv_flow_imp.g_varchar2_table(5926) := '646572206F6E20746865206C6162656C5C6E202A2040706172616D207B546578744C61796F7574436F6E6669677D206F7074696F6E735C6E202A5C6E202A204072657475726E207B207B5C6E202A202020656C656D656E743A20535647456C656D656E74';
wwv_flow_imp.g_varchar2_table(5927) := '2C5C6E202A20202064696D656E73696F6E733A2044696D656E73696F6E735C6E202A207D207D5C6E202A2F5C6E546578742E70726F746F747970652E6C61796F757454657874203D2066756E6374696F6E28746578742C206F7074696F6E7329207B5C6E';
wwv_flow_imp.g_varchar2_table(5928) := '202076617220626F78203D2061737369676E287B7D2C20746869732E5F636F6E6669672E73697A652C206F7074696F6E732E626F78292C5C6E2020202020207374796C65203D2061737369676E287B7D2C20746869732E5F636F6E6669672E7374796C65';
wwv_flow_imp.g_varchar2_table(5929) := '2C206F7074696F6E732E7374796C65292C5C6E202020202020616C69676E203D207061727365416C69676E286F7074696F6E732E616C69676E207C7C20746869732E5F636F6E6669672E616C69676E292C5C6E20202020202070616464696E67203D2070';
wwv_flow_imp.g_varchar2_table(5930) := '6172736550616464696E67286F7074696F6E732E70616464696E6720213D3D20756E646566696E6564203F206F7074696F6E732E70616464696E67203A20746869732E5F636F6E6669672E70616464696E67292C5C6E202020202020666974426F78203D';
wwv_flow_imp.g_varchar2_table(5931) := '206F7074696F6E732E666974426F78207C7C2066616C73653B5C6E5C6E2020766172206C696E65486569676874203D206765744C696E65486569676874287374796C65293B5C6E5C6E20202F2F2077652073706C69742074657874206279206C696E6573';
wwv_flow_imp.g_varchar2_table(5932) := '20616E64206E6F726D616C697A655C6E20202F2F207B736F667420627265616B7D202B207B6C696E6520627265616B7D203D3E207B206C696E6520627265616B207D5C6E2020766172206C696E6573203D20746578742E73706C6974282F5C5C75303041';
wwv_flow_imp.g_varchar2_table(5933) := '443F5C5C723F5C5C6E2F292C5C6E2020202020206C61796F75746564203D205B5D3B5C6E5C6E2020766172206D61785769647468203D20626F782E7769647468202D2070616464696E672E6C656674202D2070616464696E672E72696768743B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(5934) := '20202F2F20656E7375726520636F72726563742072656E646572696E6720627920617474616368696E672068656C7065722074657874206E6F646520746F20696E76697369626C65205356475C6E20207661722068656C70657254657874203D20737667';
wwv_flow_imp.g_varchar2_table(5935) := '43726561746528277465787427293B5C6E2020737667417474722868656C706572546578742C207B20783A20302C20793A2030207D293B5C6E2020737667417474722868656C706572546578742C207374796C65293B5C6E5C6E20207661722068656C70';
wwv_flow_imp.g_varchar2_table(5936) := '6572537667203D2067657448656C70657253766728293B5C6E5C6E2020737667417070656E642868656C7065725376672C2068656C70657254657874293B5C6E5C6E20207768696C6520286C696E65732E6C656E67746829207B5C6E202020206C61796F';
wwv_flow_imp.g_varchar2_table(5937) := '757465642E70757368286C61796F75744E657874286C696E65732C206D617857696474682C2068656C7065725465787429293B5C6E20207D5C6E5C6E202069662028616C69676E2E766572746963616C203D3D3D20276D6964646C652729207B5C6E2020';
wwv_flow_imp.g_varchar2_table(5938) := '202070616464696E672E746F70203D2070616464696E672E626F74746F6D203D20303B5C6E20207D5C6E5C6E202076617220746F74616C486569676874203D20726564756365286C61796F757465642C2066756E6374696F6E2873756D2C206C696E652C';
wwv_flow_imp.g_varchar2_table(5939) := '2069647829207B5C6E2020202072657475726E2073756D202B20286C696E65486569676874207C7C206C696E652E686569676874293B5C6E20207D2C203029202B2070616464696E672E746F70202B2070616464696E672E626F74746F6D3B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(5940) := '20766172206D61784C696E655769647468203D20726564756365286C61796F757465642C2066756E6374696F6E2873756D2C206C696E652C2069647829207B5C6E2020202072657475726E206C696E652E7769647468203E2073756D203F206C696E652E';
wwv_flow_imp.g_varchar2_table(5941) := '7769647468203A2073756D3B5C6E20207D2C2030293B5C6E5C6E20202F2F20746865207920706F736974696F6E206F6620746865206E657874206C696E655C6E20207661722079203D2070616464696E672E746F703B5C6E5C6E202069662028616C6967';
wwv_flow_imp.g_varchar2_table(5942) := '6E2E766572746963616C203D3D3D20276D6964646C652729207B5C6E2020202079202B3D2028626F782E686569676874202D20746F74616C48656967687429202F20323B5C6E20207D5C6E5C6E20202F2F206D61676963206E756D62657220696E697469';
wwv_flow_imp.g_varchar2_table(5943) := '616C206F66667365745C6E202079202D3D20286C696E65486569676874207C7C206C61796F757465645B305D2E68656967687429202F20343B5C6E5C6E5C6E20207661722074657874456C656D656E74203D207376674372656174652827746578742729';
wwv_flow_imp.g_varchar2_table(5944) := '3B5C6E5C6E2020737667417474722874657874456C656D656E742C207374796C65293B5C6E5C6E20202F2F206C61796F75742065616368206C696E652074616B696E6720696E746F206163636F756E74207468617420706172656E745C6E20202F2F2073';
wwv_flow_imp.g_varchar2_table(5945) := '68617065206D6967687420726573697A6520746F2066697420746578742073697A655C6E2020666F7245616368286C61796F757465642C2066756E6374696F6E286C696E6529207B5C6E5C6E2020202076617220783B5C6E5C6E2020202079202B3D2028';
wwv_flow_imp.g_varchar2_table(5946) := '6C696E65486569676874207C7C206C696E652E686569676874293B5C6E5C6E202020207377697463682028616C69676E2E686F72697A6F6E74616C29207B5C6E202020206361736520276C656674273A5C6E20202020202078203D2070616464696E672E';
wwv_flow_imp.g_varchar2_table(5947) := '6C6566743B5C6E202020202020627265616B3B5C6E5C6E202020206361736520277269676874273A5C6E20202020202078203D202828666974426F78203F206D61784C696E655769647468203A206D61785769647468295C6E20202020202020202D2070';
wwv_flow_imp.g_varchar2_table(5948) := '616464696E672E7269676874202D206C696E652E7769647468293B5C6E202020202020627265616B3B5C6E5C6E2020202064656661756C743A5C6E5C6E2020202020202F2F20616B612063656E7465725C6E20202020202078203D204D6174682E6D6178';
wwv_flow_imp.g_varchar2_table(5949) := '28282828666974426F78203F206D61784C696E655769647468203A206D61785769647468295C6E20202020202020202D206C696E652E776964746829202F2032202B2070616464696E672E6C656674292C2030293B5C6E202020207D5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(5950) := '76617220747370616E203D207376674372656174652827747370616E27293B5C6E202020207376674174747228747370616E2C207B20783A20782C20793A2079207D293B5C6E5C6E20202020747370616E2E74657874436F6E74656E74203D206C696E65';
wwv_flow_imp.g_varchar2_table(5951) := '2E746578743B5C6E5C6E20202020737667417070656E642874657874456C656D656E742C20747370616E293B5C6E20207D293B5C6E5C6E202073766752656D6F76652868656C70657254657874293B5C6E5C6E20207661722064696D656E73696F6E7320';
wwv_flow_imp.g_varchar2_table(5952) := '3D207B5C6E2020202077696474683A206D61784C696E6557696474682C5C6E202020206865696768743A20746F74616C4865696768745C6E20207D3B5C6E5C6E202072657475726E207B5C6E2020202064696D656E73696F6E733A2064696D656E73696F';
wwv_flow_imp.g_varchar2_table(5953) := '6E732C5C6E20202020656C656D656E743A2074657874456C656D656E745C6E20207D3B5C6E7D3B5C6E5C6E5C6E66756E6374696F6E206765744C696E65486569676874287374796C6529207B5C6E20206966202827666F6E7453697A652720696E207374';
wwv_flow_imp.g_varchar2_table(5954) := '796C6520262620276C696E654865696768742720696E207374796C6529207B5C6E2020202072657475726E207374796C652E6C696E65486569676874202A207061727365496E74287374796C652E666F6E7453697A652C203130293B5C6E20207D5C6E7D';
wwv_flow_imp.g_varchar2_table(5955) := '5C6E222C2266756E6374696F6E20637265617465436F6D6D6F6E6A734D6F64756C6528666E2C206D6F64756C6529207B5C6E5C7472657475726E206D6F64756C65203D207B206578706F7274733A207B7D207D2C20666E286D6F64756C652C206D6F6475';
wwv_flow_imp.g_varchar2_table(5956) := '6C652E6578706F727473292C206D6F64756C652E6578706F7274733B5C6E7D5C6E5C6E766172206861745F31203D20637265617465436F6D6D6F6E6A734D6F64756C652866756E6374696F6E20286D6F64756C6529207B5C6E76617220686174203D206D';
wwv_flow_imp.g_varchar2_table(5957) := '6F64756C652E6578706F727473203D2066756E6374696F6E2028626974732C206261736529207B5C6E20202020696620282162617365292062617365203D2031363B5C6E202020206966202862697473203D3D3D20756E646566696E6564292062697473';
wwv_flow_imp.g_varchar2_table(5958) := '203D203132383B5C6E202020206966202862697473203C3D2030292072657475726E202730273B5C6E202020205C6E2020202076617220646967697473203D204D6174682E6C6F67284D6174682E706F7728322C20626974732929202F204D6174682E6C';
wwv_flow_imp.g_varchar2_table(5959) := '6F672862617365293B5C6E20202020666F7220287661722069203D20323B20646967697473203D3D3D20496E66696E6974793B2069202A3D203229207B5C6E2020202020202020646967697473203D204D6174682E6C6F67284D6174682E706F7728322C';
wwv_flow_imp.g_varchar2_table(5960) := '2062697473202F20692929202F204D6174682E6C6F67286261736529202A20693B5C6E202020207D5C6E202020205C6E202020207661722072656D203D20646967697473202D204D6174682E666C6F6F7228646967697473293B5C6E202020205C6E2020';
wwv_flow_imp.g_varchar2_table(5961) := '202076617220726573203D2027273B5C6E202020205C6E20202020666F7220287661722069203D20303B2069203C204D6174682E666C6F6F7228646967697473293B20692B2B29207B5C6E20202020202020207661722078203D204D6174682E666C6F6F';
wwv_flow_imp.g_varchar2_table(5962) := '72284D6174682E72616E646F6D2829202A2062617365292E746F537472696E672862617365293B5C6E2020202020202020726573203D2078202B207265733B5C6E202020207D5C6E202020205C6E202020206966202872656D29207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(5963) := '20207661722062203D204D6174682E706F7728626173652C2072656D293B5C6E20202020202020207661722078203D204D6174682E666C6F6F72284D6174682E72616E646F6D2829202A2062292E746F537472696E672862617365293B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(5964) := '202020726573203D2078202B207265733B5C6E202020207D5C6E202020205C6E2020202076617220706172736564203D207061727365496E74287265732C2062617365293B5C6E202020206966202870617273656420213D3D20496E66696E6974792026';
wwv_flow_imp.g_varchar2_table(5965) := '2620706172736564203E3D204D6174682E706F7728322C20626974732929207B5C6E202020202020202072657475726E2068617428626974732C2062617365295C6E202020207D5C6E20202020656C73652072657475726E207265733B5C6E7D3B5C6E5C';
wwv_flow_imp.g_varchar2_table(5966) := '6E6861742E7261636B203D2066756E6374696F6E2028626974732C20626173652C20657870616E64427929207B5C6E2020202076617220666E203D2066756E6374696F6E20286461746129207B5C6E2020202020202020766172206974657273203D2030';
wwv_flow_imp.g_varchar2_table(5967) := '3B5C6E2020202020202020646F207B5C6E202020202020202020202020696620286974657273202B2B203E20313029207B5C6E2020202020202020202020202020202069662028657870616E644279292062697473202B3D20657870616E6442793B5C6E';
wwv_flow_imp.g_varchar2_table(5968) := '20202020202020202020202020202020656C7365207468726F77206E6577204572726F722827746F6F206D616E7920494420636F6C6C6973696F6E732C20757365206D6F7265206269747327295C6E2020202020202020202020207D5C6E202020202020';
wwv_flow_imp.g_varchar2_table(5969) := '2020202020205C6E202020202020202020202020766172206964203D2068617428626974732C2062617365293B5C6E20202020202020207D207768696C6520284F626A6563742E6861734F776E50726F70657274792E63616C6C28686174732C20696429';
wwv_flow_imp.g_varchar2_table(5970) := '293B5C6E20202020202020205C6E2020202020202020686174735B69645D203D20646174613B5C6E202020202020202072657475726E2069643B5C6E202020207D3B5C6E202020207661722068617473203D20666E2E68617473203D207B7D3B5C6E2020';
wwv_flow_imp.g_varchar2_table(5971) := '20205C6E20202020666E2E676574203D2066756E6374696F6E2028696429207B5C6E202020202020202072657475726E20666E2E686174735B69645D3B5C6E202020207D3B5C6E202020205C6E20202020666E2E736574203D2066756E6374696F6E2028';
wwv_flow_imp.g_varchar2_table(5972) := '69642C2076616C756529207B5C6E2020202020202020666E2E686174735B69645D203D2076616C75653B5C6E202020202020202072657475726E20666E3B5C6E202020207D3B5C6E202020205C6E20202020666E2E62697473203D2062697473207C7C20';
wwv_flow_imp.g_varchar2_table(5973) := '3132383B5C6E20202020666E2E62617365203D2062617365207C7C2031363B5C6E2020202072657475726E20666E3B5C6E7D3B5C6E7D293B5C6E5C6E2F2A2A5C6E202A204372656174652061206E65772069642067656E657261746F72202F2063616368';
wwv_flow_imp.g_varchar2_table(5974) := '6520696E7374616E63652E5C6E202A5C6E202A20596F75206D6179206F7074696F6E616C6C792070726F76696465206120736565642074686174206973207573656420696E7465726E616C6C792E5C6E202A5C6E202A2040706172616D207B536565647D';
wwv_flow_imp.g_varchar2_table(5975) := '20736565645C6E202A2F5C6E66756E6374696F6E20496473287365656429207B5C6E20206966202821287468697320696E7374616E63656F66204964732929207B5C6E2020202072657475726E206E6577204964732873656564293B5C6E20207D5C6E20';
wwv_flow_imp.g_varchar2_table(5976) := '2073656564203D2073656564207C7C205B3132382C2033362C20315D3B5C6E2020746869732E5F73656564203D20736565642E6C656E677468203F206861745F312E7261636B28736565645B305D2C20736565645B315D2C20736565645B325D29203A20';
wwv_flow_imp.g_varchar2_table(5977) := '736565643B5C6E7D5C6E5C6E2F2A2A5C6E202A2047656E65726174652061206E6578742069642E5C6E202A5C6E202A2040706172616D207B4F626A6563747D205B656C656D656E745D20656C656D656E7420746F2062696E642074686520696420746F5C';
wwv_flow_imp.g_varchar2_table(5978) := '6E202A5C6E202A204072657475726E207B537472696E677D2069645C6E202A2F5C6E4964732E70726F746F747970652E6E657874203D2066756E6374696F6E2028656C656D656E7429207B5C6E202072657475726E20746869732E5F7365656428656C65';
wwv_flow_imp.g_varchar2_table(5979) := '6D656E74207C7C2074727565293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2047656E65726174652061206E6578742069642077697468206120676976656E207072656669782E5C6E202A5C6E202A2040706172616D207B4F626A6563747D205B656C656D65';
wwv_flow_imp.g_varchar2_table(5980) := '6E745D20656C656D656E7420746F2062696E642074686520696420746F5C6E202A5C6E202A204072657475726E207B537472696E677D2069645C6E202A2F5C6E4964732E70726F746F747970652E6E6578745072656669786564203D2066756E6374696F';
wwv_flow_imp.g_varchar2_table(5981) := '6E20287072656669782C20656C656D656E7429207B5C6E20207661722069643B5C6E2020646F207B5C6E202020206964203D20707265666978202B20746869732E6E6578742874727565293B5C6E20207D207768696C652028746869732E61737369676E';
wwv_flow_imp.g_varchar2_table(5982) := '656428696429293B5C6E5C6E20202F2F20636C61696D207B7072656669787D7B72616E646F6D7D5C6E2020746869732E636C61696D2869642C20656C656D656E74293B5C6E5C6E20202F2F2072657475726E5C6E202072657475726E2069643B5C6E7D3B';
wwv_flow_imp.g_varchar2_table(5983) := '5C6E5C6E2F2A2A5C6E202A204D616E75616C6C7920636C61696D20616E206578697374696E672069642E5C6E202A5C6E202A2040706172616D207B537472696E677D2069645C6E202A2040706172616D207B537472696E677D205B656C656D656E745D20';
wwv_flow_imp.g_varchar2_table(5984) := '656C656D656E742074686520696420697320636C61696D65642062795C6E202A2F5C6E4964732E70726F746F747970652E636C61696D203D2066756E6374696F6E202869642C20656C656D656E7429207B5C6E2020746869732E5F736565642E73657428';
wwv_flow_imp.g_varchar2_table(5985) := '69642C20656C656D656E74207C7C2074727565293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E7320747275652069662074686520676976656E2069642068617320616C7265616479206265656E2061737369676E65642E5C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(5986) := '2040706172616D20207B537472696E677D2069645C6E202A204072657475726E207B426F6F6C65616E7D5C6E202A2F5C6E4964732E70726F746F747970652E61737369676E6564203D2066756E6374696F6E2028696429207B5C6E202072657475726E20';
wwv_flow_imp.g_varchar2_table(5987) := '746869732E5F736565642E67657428696429207C7C2066616C73653B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20556E636C61696D20616E2069642E5C6E202A5C6E202A2040706172616D20207B537472696E677D2069642074686520696420746F20756E63';
wwv_flow_imp.g_varchar2_table(5988) := '6C61696D5C6E202A2F5C6E4964732E70726F746F747970652E756E636C61696D203D2066756E6374696F6E2028696429207B5C6E202064656C65746520746869732E5F736565642E686174735B69645D3B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20436C65';
wwv_flow_imp.g_varchar2_table(5989) := '617220616C6C20636C61696D6564206964732E5C6E202A2F5C6E4964732E70726F746F747970652E636C656172203D2066756E6374696F6E202829207B5C6E20207661722068617473203D20746869732E5F736565642E686174732C5C6E202020206964';
wwv_flow_imp.g_varchar2_table(5990) := '3B5C6E2020666F722028696420696E206861747329207B5C6E20202020746869732E756E636C61696D286964293B5C6E20207D5C6E7D3B5C6E5C6E6578706F72742064656661756C74204964733B5C6E2F2F2320736F757263654D617070696E6755524C';
wwv_flow_imp.g_varchar2_table(5991) := '3D696E6465782E65736D2E6A732E6D61705C6E222C2266756E6374696F6E206528652C74297B74262628652E73757065725F3D742C652E70726F746F747970653D4F626A6563742E63726561746528742E70726F746F747970652C7B636F6E7374727563';
wwv_flow_imp.g_varchar2_table(5992) := '746F723A7B76616C75653A652C656E756D657261626C653A21312C7772697461626C653A21302C636F6E666967757261626C653A21307D7D29297D6578706F72747B652061732064656661756C747D3B5C6E2F2F2320736F757263654D617070696E6755';
wwv_flow_imp.g_varchar2_table(5993) := '524C3D696E6465782E65732E6A732E6D61705C6E222C2266756E6374696F6E205F6D657267654E616D65737061636573286E2C206D29207B5C6E20206D2E666F72456163682866756E6374696F6E20286529207B5C6E202020206520262620747970656F';
wwv_flow_imp.g_varchar2_table(5994) := '66206520213D3D2027737472696E6727202626202141727261792E69734172726179286529202626204F626A6563742E6B6579732865292E666F72456163682866756E6374696F6E20286B29207B5C6E202020202020696620286B20213D3D2027646566';
wwv_flow_imp.g_varchar2_table(5995) := '61756C74272026262021286B20696E206E2929207B5C6E20202020202020207661722064203D204F626A6563742E6765744F776E50726F706572747944657363726970746F7228652C206B293B5C6E20202020202020204F626A6563742E646566696E65';
wwv_flow_imp.g_varchar2_table(5996) := '50726F7065727479286E2C206B2C20642E676574203F2064203A207B5C6E20202020202020202020656E756D657261626C653A20747275652C5C6E202020202020202020206765743A2066756E6374696F6E202829207B2072657475726E20655B6B5D3B';
wwv_flow_imp.g_varchar2_table(5997) := '207D5C6E20202020202020207D293B5C6E2020202020207D5C6E202020207D293B5C6E20207D293B5C6E202072657475726E204F626A6563742E667265657A65286E293B5C6E7D5C6E5C6E2F2A2A5C6E202A20466C617474656E2061727261792C206F6E';
wwv_flow_imp.g_varchar2_table(5998) := '65206C6576656C20646565702E5C6E202A5C6E202A204074656D706C61746520545C6E202A5C6E202A2040706172616D207B545B5D5B5D207C20545B5D207C206E756C6C7D205B6172725D5C6E202A5C6E202A204072657475726E207B545B5D7D5C6E20';
wwv_flow_imp.g_varchar2_table(5999) := '2A2F5C6E5C6E636F6E7374206E6174697665546F537472696E67203D204F626A6563742E70726F746F747970652E746F537472696E673B5C6E636F6E7374206E61746976654861734F776E50726F7065727479203D204F626A6563742E70726F746F7479';
wwv_flow_imp.g_varchar2_table(6000) := '70652E6861734F776E50726F70657274793B5C6E5C6E66756E6374696F6E206973556E646566696E6564286F626A29207B5C6E202072657475726E206F626A203D3D3D20756E646566696E65643B5C6E7D5C6E5C6E66756E6374696F6E20697341727261';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(6001) := '79286F626A29207B5C6E202072657475726E206E6174697665546F537472696E672E63616C6C286F626A29203D3D3D20275B6F626A6563742041727261795D273B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E20747275652C2069662074617267';
wwv_flow_imp.g_varchar2_table(6002) := '6574206F776E7320612070726F706572747920776974682074686520676976656E206B65792E5C6E202A5C6E202A2040706172616D207B4F626A6563747D207461726765745C6E202A2040706172616D207B537472696E677D206B65795C6E202A5C6E20';
wwv_flow_imp.g_varchar2_table(6003) := '2A204072657475726E207B426F6F6C65616E7D5C6E202A2F5C6E66756E6374696F6E20686173287461726765742C206B657929207B5C6E202072657475726E206E61746976654861734F776E50726F70657274792E63616C6C287461726765742C206B65';
wwv_flow_imp.g_varchar2_table(6004) := '79293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2049746572617465206F76657220636F6C6C656374696F6E3B2072657475726E696E6720736F6D657468696E675C6E202A20286E6F6E2D756E646566696E6564292077696C6C2073746F70206974657261';
wwv_flow_imp.g_varchar2_table(6005) := '74696F6E2E5C6E202A5C6E202A204074656D706C61746520545C6E202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E5C6E202A2040706172616D207B2028286974656D3A20542C206964783A206E756D62657229';
wwv_flow_imp.g_varchar2_table(6006) := '203D3E2028626F6F6C65616E7C766F69642929207C2028286974656D3A20542C206B65793A20737472696E6729203D3E2028626F6F6C65616E7C766F69642929207D206974657261746F725C6E202A5C6E202A204072657475726E207B547D2072657475';
wwv_flow_imp.g_varchar2_table(6007) := '726E20726573756C7420746861742073746F707065642074686520697465726174696F6E5C6E202A2F5C6E66756E6374696F6E20666F724561636828636F6C6C656374696F6E2C206974657261746F7229207B5C6E5C6E20206C65742076616C2C5C6E20';
wwv_flow_imp.g_varchar2_table(6008) := '2020202020726573756C743B5C6E5C6E2020696620286973556E646566696E656428636F6C6C656374696F6E2929207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020636F6E737420636F6E766572744B6579203D20697341727261792863';
wwv_flow_imp.g_varchar2_table(6009) := '6F6C6C656374696F6E29203F20746F4E756D203A206964656E746974793B5C6E5C6E2020666F7220286C6574206B657920696E20636F6C6C656374696F6E29207B5C6E5C6E202020206966202868617328636F6C6C656374696F6E2C206B65792929207B';
wwv_flow_imp.g_varchar2_table(6010) := '5C6E20202020202076616C203D20636F6C6C656374696F6E5B6B65795D3B5C6E5C6E202020202020726573756C74203D206974657261746F722876616C2C20636F6E766572744B6579286B657929293B5C6E5C6E20202020202069662028726573756C74';
wwv_flow_imp.g_varchar2_table(6011) := '203D3D3D2066616C736529207B5C6E202020202020202072657475726E2076616C3B5C6E2020202020207D5C6E202020207D5C6E20207D5C6E7D5C6E5C6E5C6E66756E6374696F6E206964656E746974792861726729207B5C6E202072657475726E2061';
wwv_flow_imp.g_varchar2_table(6012) := '72673B5C6E7D5C6E5C6E66756E6374696F6E20746F4E756D2861726729207B5C6E202072657475726E204E756D62657228617267293B5C6E7D5C6E5C6E2F2A2A5C6E202A2041737369676E73207374796C65206174747269627574657320696E20612073';
wwv_flow_imp.g_varchar2_table(6013) := '74796C652D73726320636F6D706C69616E74207761792E5C6E202A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A2040706172616D207B2E2E2E4F626A6563747D207374796C65536F75726365735C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(6014) := '204072657475726E207B456C656D656E747D2074686520656C656D656E745C6E202A2F5C6E66756E6374696F6E2061737369676E28656C656D656E742C202E2E2E7374796C65536F757263657329207B5C6E2020636F6E737420746172676574203D2065';
wwv_flow_imp.g_varchar2_table(6015) := '6C656D656E742E7374796C653B5C6E5C6E2020666F7245616368287374796C65536F75726365732C2066756E6374696F6E287374796C6529207B5C6E2020202069662028217374796C6529207B5C6E20202020202072657475726E3B5C6E202020207D5C';
wwv_flow_imp.g_varchar2_table(6016) := '6E5C6E20202020666F7245616368287374796C652C2066756E6374696F6E2876616C75652C206B657929207B5C6E2020202020207461726765745B6B65795D203D2076616C75653B5C6E202020207D293B5C6E20207D293B5C6E5C6E202072657475726E';
wwv_flow_imp.g_varchar2_table(6017) := '20656C656D656E743B5C6E7D5C6E5C6E2F2A2A5C6E202A205365742061747472696275746520606E616D656020746F206076616C602C206F7220676574206174747220606E616D65602E5C6E202A5C6E202A2040706172616D207B456C656D656E747D20';
wwv_flow_imp.g_varchar2_table(6018) := '656C5C6E202A2040706172616D207B537472696E677D206E616D655C6E202A2040706172616D207B537472696E677D205B76616C5D5C6E202A2040617069207075626C69635C6E202A2F5C6E66756E6374696F6E206174747228656C2C206E616D652C20';
wwv_flow_imp.g_varchar2_table(6019) := '76616C29207B5C6E5C6E20202F2F206765745C6E202069662028617267756D656E74732E6C656E677468203D3D203229207B5C6E2020202072657475726E20656C2E676574417474726962757465286E616D65293B5C6E20207D5C6E5C6E20202F2F2072';
wwv_flow_imp.g_varchar2_table(6020) := '656D6F76655C6E20206966202876616C203D3D3D206E756C6C29207B5C6E2020202072657475726E20656C2E72656D6F7665417474726962757465286E616D65293B5C6E20207D5C6E5C6E20202F2F207365745C6E2020656C2E73657441747472696275';
wwv_flow_imp.g_varchar2_table(6021) := '7465286E616D652C2076616C293B5C6E5C6E202072657475726E20656C3B5C6E7D5C6E5C6E2F2A2A5C6E202A2054616B656E2066726F6D2068747470733A2F2F6769746875622E636F6D2F636F6D706F6E656E742F636C61737365735C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(6022) := '20576974686F75742074686520636F6D706F6E656E7420626974732E5C6E202A2F5C6E5C6E2F2A2A5C6E202A20746F537472696E67207265666572656E63652E5C6E202A2F5C6E5C6E636F6E737420746F537472696E67203D204F626A6563742E70726F';
wwv_flow_imp.g_varchar2_table(6023) := '746F747970652E746F537472696E673B5C6E5C6E2F2A2A5C6E202A20577261702060656C6020696E20612060436C6173734C697374602E5C6E202A5C6E202A2040706172616D207B456C656D656E747D20656C5C6E202A204072657475726E207B436C61';
wwv_flow_imp.g_varchar2_table(6024) := '73734C6973747D5C6E202A2040617069207075626C69635C6E202A2F5C6E5C6E66756E6374696F6E20636C617373657328656C29207B5C6E202072657475726E206E657720436C6173734C69737428656C293B5C6E7D5C6E5C6E2F2A2A5C6E202A20496E';
wwv_flow_imp.g_varchar2_table(6025) := '697469616C697A652061206E657720436C6173734C69737420666F722060656C602E5C6E202A5C6E202A2040706172616D207B456C656D656E747D20656C5C6E202A204061706920707269766174655C6E202A2F5C6E5C6E66756E6374696F6E20436C61';
wwv_flow_imp.g_varchar2_table(6026) := '73734C69737428656C29207B5C6E20206966202821656C207C7C2021656C2E6E6F64655479706529207B5C6E202020207468726F77206E6577204572726F7228274120444F4D20656C656D656E74207265666572656E6365206973207265717569726564';
wwv_flow_imp.g_varchar2_table(6027) := '27293B5C6E20207D5C6E2020746869732E656C203D20656C3B5C6E2020746869732E6C697374203D20656C2E636C6173734C6973743B5C6E7D5C6E5C6E2F2A2A5C6E202A2041646420636C61737320606E616D6560206966206E6F7420616C7265616479';
wwv_flow_imp.g_varchar2_table(6028) := '2070726573656E742E5C6E202A5C6E202A2040706172616D207B537472696E677D206E616D655C6E202A204072657475726E207B436C6173734C6973747D5C6E202A2040617069207075626C69635C6E202A2F5C6E5C6E436C6173734C6973742E70726F';
wwv_flow_imp.g_varchar2_table(6029) := '746F747970652E616464203D2066756E6374696F6E286E616D6529207B5C6E2020746869732E6C6973742E616464286E616D65293B5C6E202072657475726E20746869733B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052656D6F766520636C61737320606E';
wwv_flow_imp.g_varchar2_table(6030) := '616D6560207768656E2070726573656E742C206F725C6E202A2070617373206120726567756C61722065787072657373696F6E20746F2072656D6F76655C6E202A20616E79207768696368206D617463682E5C6E202A5C6E202A2040706172616D207B53';
wwv_flow_imp.g_varchar2_table(6031) := '7472696E677C5265674578707D206E616D655C6E202A204072657475726E207B436C6173734C6973747D5C6E202A2040617069207075626C69635C6E202A2F5C6E5C6E436C6173734C6973742E70726F746F747970652E72656D6F7665203D2066756E63';
wwv_flow_imp.g_varchar2_table(6032) := '74696F6E286E616D6529207B5C6E202069662028275B6F626A656374205265674578705D27203D3D20746F537472696E672E63616C6C286E616D652929207B5C6E2020202072657475726E20746869732E72656D6F76654D61746368696E67286E616D65';
wwv_flow_imp.g_varchar2_table(6033) := '293B5C6E20207D5C6E5C6E2020746869732E6C6973742E72656D6F7665286E616D65293B5C6E202072657475726E20746869733B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052656D6F766520616C6C20636C6173736573206D61746368696E672060726560';
wwv_flow_imp.g_varchar2_table(6034) := '2E5C6E202A5C6E202A2040706172616D207B5265674578707D2072655C6E202A204072657475726E207B436C6173734C6973747D5C6E202A204061706920707269766174655C6E202A2F5C6E5C6E436C6173734C6973742E70726F746F747970652E7265';
wwv_flow_imp.g_varchar2_table(6035) := '6D6F76654D61746368696E67203D2066756E6374696F6E28726529207B5C6E2020636F6E737420617272203D20746869732E617272617928293B5C6E2020666F7220286C65742069203D20303B2069203C206172722E6C656E6774683B20692B2B29207B';
wwv_flow_imp.g_varchar2_table(6036) := '5C6E202020206966202872652E74657374286172725B695D2929207B5C6E202020202020746869732E72656D6F7665286172725B695D293B5C6E202020207D5C6E20207D5C6E202072657475726E20746869733B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20';
wwv_flow_imp.g_varchar2_table(6037) := '546F67676C6520636C61737320606E616D65602C2063616E20666F726365207374617465207669612060666F726365602E5C6E202A5C6E202A20466F722062726F7773657273207468617420737570706F727420636C6173734C6973742C206275742064';
wwv_flow_imp.g_varchar2_table(6038) := '6F206E6F7420737570706F72742060666F72636560207965742C5C6E202A20746865206D697374616B652077696C6C20626520646574656374656420616E6420636F727265637465642E5C6E202A5C6E202A2040706172616D207B537472696E677D206E';
wwv_flow_imp.g_varchar2_table(6039) := '616D655C6E202A2040706172616D207B426F6F6C65616E7D20666F7263655C6E202A204072657475726E207B436C6173734C6973747D5C6E202A2040617069207075626C69635C6E202A2F5C6E5C6E436C6173734C6973742E70726F746F747970652E74';
wwv_flow_imp.g_varchar2_table(6040) := '6F67676C65203D2066756E6374696F6E286E616D652C20666F72636529207B5C6E20206966202827756E646566696E65642720213D3D20747970656F6620666F72636529207B5C6E2020202069662028666F72636520213D3D20746869732E6C6973742E';
wwv_flow_imp.g_varchar2_table(6041) := '746F67676C65286E616D652C20666F7263652929207B5C6E202020202020746869732E6C6973742E746F67676C65286E616D65293B202F2F20746F67676C6520616761696E20746F20636F72726563745C6E202020207D5C6E20207D20656C7365207B5C';
wwv_flow_imp.g_varchar2_table(6042) := '6E20202020746869732E6C6973742E746F67676C65286E616D65293B5C6E20207D5C6E202072657475726E20746869733B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E20616E206172726179206F6620636C61737365732E5C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(6043) := '204072657475726E207B41727261797D5C6E202A2040617069207075626C69635C6E202A2F5C6E5C6E436C6173734C6973742E70726F746F747970652E6172726179203D2066756E6374696F6E2829207B5C6E202072657475726E2041727261792E6672';
wwv_flow_imp.g_varchar2_table(6044) := '6F6D28746869732E6C697374293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20436865636B20696620636C61737320606E616D65602069732070726573656E742E5C6E202A5C6E202A2040706172616D207B537472696E677D206E616D655C6E202A20407265';
wwv_flow_imp.g_varchar2_table(6045) := '7475726E207B436C6173734C6973747D5C6E202A2040617069207075626C69635C6E202A2F5C6E5C6E436C6173734C6973742E70726F746F747970652E686173203D5C6E436C6173734C6973742E70726F746F747970652E636F6E7461696E73203D2066';
wwv_flow_imp.g_varchar2_table(6046) := '756E6374696F6E286E616D6529207B5C6E202072657475726E20746869732E6C6973742E636F6E7461696E73286E616D65293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20436C656172207574696C6974795C6E202A2F5C6E5C6E2F2A2A5C6E202A2052656D';
wwv_flow_imp.g_varchar2_table(6047) := '6F76657320616C6C206368696C6472656E2066726F6D2074686520676976656E20656C656D656E745C6E202A5C6E202A2040706172616D207B456C656D656E747D20656C656D656E745C6E202A5C6E202A204072657475726E207B456C656D656E747D20';
wwv_flow_imp.g_varchar2_table(6048) := '74686520656C656D656E742028666F7220636861696E696E67295C6E202A2F5C6E66756E6374696F6E20636C65617228656C656D656E7429207B5C6E2020766172206368696C643B5C6E5C6E20207768696C652028286368696C64203D20656C656D656E';
wwv_flow_imp.g_varchar2_table(6049) := '742E66697273744368696C642929207B5C6E20202020656C656D656E742E72656D6F76654368696C64286368696C64293B5C6E20207D5C6E5C6E202072657475726E20656C656D656E743B5C6E7D5C6E5C6E2F2A2A5C6E202A20436C6F736573745C6E20';
wwv_flow_imp.g_varchar2_table(6050) := '2A5C6E202A2040706172616D207B456C656D656E747D20656C5C6E202A2040706172616D207B737472696E677D2073656C6563746F725C6E202A2040706172616D207B626F6F6C65616E7D20636865636B596F757253656C6620286F7074696F6E616C29';
wwv_flow_imp.g_varchar2_table(6051) := '5C6E202A2F5C6E66756E6374696F6E20636C6F7365737428656C656D656E742C2073656C6563746F722C20636865636B596F757253656C6629207B5C6E20207661722061637475616C456C656D656E74203D20636865636B596F757253656C66203F2065';
wwv_flow_imp.g_varchar2_table(6052) := '6C656D656E74203A20656C656D656E742E706172656E744E6F64653B5C6E5C6E202072657475726E2061637475616C456C656D656E7420262620747970656F662061637475616C456C656D656E742E636C6F73657374203D3D3D202766756E6374696F6E';
wwv_flow_imp.g_varchar2_table(6053) := '272026262061637475616C456C656D656E742E636C6F736573742873656C6563746F7229207C7C206E756C6C3B5C6E7D5C6E5C6E76617220636F6D706F6E656E744576656E74203D207B7D3B5C6E5C6E7661722062696E6424312C20756E62696E642431';
wwv_flow_imp.g_varchar2_table(6054) := '2C207072656669783B5C6E5C6E66756E6374696F6E20646574656374202829207B5C6E202062696E642431203D2077696E646F772E6164644576656E744C697374656E6572203F20276164644576656E744C697374656E657227203A2027617474616368';
wwv_flow_imp.g_varchar2_table(6055) := '4576656E74273B5C6E2020756E62696E642431203D2077696E646F772E72656D6F76654576656E744C697374656E6572203F202772656D6F76654576656E744C697374656E657227203A20276465746163684576656E74273B5C6E202070726566697820';
wwv_flow_imp.g_varchar2_table(6056) := '3D2062696E64243120213D3D20276164644576656E744C697374656E657227203F20276F6E27203A2027273B5C6E7D5C6E5C6E2F2A2A5C6E202A2042696E642060656C60206576656E742060747970656020746F2060666E602E5C6E202A5C6E202A2040';
wwv_flow_imp.g_varchar2_table(6057) := '706172616D207B456C656D656E747D20656C5C6E202A2040706172616D207B537472696E677D20747970655C6E202A2040706172616D207B46756E6374696F6E7D20666E5C6E202A2040706172616D207B426F6F6C65616E7D20636170747572655C6E20';
wwv_flow_imp.g_varchar2_table(6058) := '2A204072657475726E207B46756E6374696F6E7D5C6E202A2040617069207075626C69635C6E202A2F5C6E5C6E7661722062696E645F31203D20636F6D706F6E656E744576656E742E62696E64203D2066756E6374696F6E28656C2C20747970652C2066';
wwv_flow_imp.g_varchar2_table(6059) := '6E2C2063617074757265297B5C6E2020696620282162696E642431292064657465637428293B5C6E2020656C5B62696E6424315D28707265666978202B20747970652C20666E2C2063617074757265207C7C2066616C7365293B5C6E202072657475726E';
wwv_flow_imp.g_varchar2_table(6060) := '20666E3B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20556E62696E642060656C60206576656E742060747970656027732063616C6C6261636B2060666E602E5C6E202A5C6E202A2040706172616D207B456C656D656E747D20656C5C6E202A2040706172616D';
wwv_flow_imp.g_varchar2_table(6061) := '207B537472696E677D20747970655C6E202A2040706172616D207B46756E6374696F6E7D20666E5C6E202A2040706172616D207B426F6F6C65616E7D20636170747572655C6E202A204072657475726E207B46756E6374696F6E7D5C6E202A2040617069';
wwv_flow_imp.g_varchar2_table(6062) := '207075626C69635C6E202A2F5C6E5C6E76617220756E62696E645F31203D20636F6D706F6E656E744576656E742E756E62696E64203D2066756E6374696F6E28656C2C20747970652C20666E2C2063617074757265297B5C6E20206966202821756E6269';
wwv_flow_imp.g_varchar2_table(6063) := '6E642431292064657465637428293B5C6E2020656C5B756E62696E6424315D28707265666978202B20747970652C20666E2C2063617074757265207C7C2066616C7365293B5C6E202072657475726E20666E3B5C6E7D3B5C6E5C6E766172206576656E74';
wwv_flow_imp.g_varchar2_table(6064) := '203D202F2A235F5F505552455F5F2A2F5F6D657267654E616D65737061636573287B5C6E20205F5F70726F746F5F5F3A206E756C6C2C5C6E202062696E643A2062696E645F312C5C6E2020756E62696E643A20756E62696E645F312C5C6E202027646566';
wwv_flow_imp.g_varchar2_table(6065) := '61756C74273A20636F6D706F6E656E744576656E745C6E7D2C205B636F6D706F6E656E744576656E745D293B5C6E5C6E2F2A2A5C6E202A204D6F64756C6520646570656E64656E636965732E5C6E202A2F5C6E5C6E2F2A2A5C6E202A2044656C65676174';
wwv_flow_imp.g_varchar2_table(6066) := '65206576656E742060747970656020746F206073656C6563746F72605C6E202A20616E6420696E766F6B652060666E286529602E20412063616C6C6261636B2066756E6374696F6E5C6E202A2069732072657475726E6564207768696368206D61792062';
wwv_flow_imp.g_varchar2_table(6067) := '652070617373656420746F20602E756E62696E642829602E5C6E202A5C6E202A2040706172616D207B456C656D656E747D20656C5C6E202A2040706172616D207B537472696E677D2073656C6563746F725C6E202A2040706172616D207B537472696E67';
wwv_flow_imp.g_varchar2_table(6068) := '7D20747970655C6E202A2040706172616D207B46756E6374696F6E7D20666E5C6E202A2040706172616D207B426F6F6C65616E7D20636170747572655C6E202A204072657475726E207B46756E6374696F6E7D5C6E202A2040617069207075626C69635C';
wwv_flow_imp.g_varchar2_table(6069) := '6E202A2F5C6E5C6E2F2F20536F6D65206576656E747320646F6E277420627562626C652C20736F2077652077616E7420746F2062696E6420746F20746865206361707475726520706861736520696E73746561645C6E2F2F207768656E2064656C656761';
wwv_flow_imp.g_varchar2_table(6070) := '74696E672E5C6E76617220666F726365436170747572654576656E7473203D205B2027666F637573272C2027626C757227205D3B5C6E5C6E66756E6374696F6E2062696E6428656C2C2073656C6563746F722C20747970652C20666E2C20636170747572';
wwv_flow_imp.g_varchar2_table(6071) := '6529207B5C6E202069662028666F726365436170747572654576656E74732E696E6465784F6628747970652920213D3D202D3129207B5C6E2020202063617074757265203D20747275653B5C6E20207D5C6E5C6E202072657475726E206576656E742E62';
wwv_flow_imp.g_varchar2_table(6072) := '696E6428656C2C20747970652C2066756E6374696F6E286529207B5C6E2020202076617220746172676574203D20652E746172676574207C7C20652E737263456C656D656E743B5C6E20202020652E64656C6567617465546172676574203D20636C6F73';
wwv_flow_imp.g_varchar2_table(6073) := '657374287461726765742C2073656C6563746F722C2074727565293B5C6E2020202069662028652E64656C656761746554617267657429207B5C6E202020202020666E2E63616C6C28656C2C2065293B5C6E202020207D5C6E20207D2C20636170747572';
wwv_flow_imp.g_varchar2_table(6074) := '65293B5C6E7D5C6E5C6E2F2A2A5C6E202A20556E62696E64206576656E742060747970656027732063616C6C6261636B2060666E602E5C6E202A5C6E202A2040706172616D207B456C656D656E747D20656C5C6E202A2040706172616D207B537472696E';
wwv_flow_imp.g_varchar2_table(6075) := '677D20747970655C6E202A2040706172616D207B46756E6374696F6E7D20666E5C6E202A2040706172616D207B426F6F6C65616E7D20636170747572655C6E202A2040617069207075626C69635C6E202A2F5C6E66756E6374696F6E20756E62696E6428';
wwv_flow_imp.g_varchar2_table(6076) := '656C2C20747970652C20666E2C206361707475726529207B5C6E202069662028666F726365436170747572654576656E74732E696E6465784F6628747970652920213D3D202D3129207B5C6E2020202063617074757265203D20747275653B5C6E20207D';
wwv_flow_imp.g_varchar2_table(6077) := '5C6E5C6E202072657475726E206576656E742E756E62696E6428656C2C20747970652C20666E2C2063617074757265293B5C6E7D5C6E5C6E7661722064656C6567617465203D207B5C6E202062696E642C5C6E2020756E62696E645C6E7D3B5C6E5C6E2F';
wwv_flow_imp.g_varchar2_table(6078) := '2A2A5C6E202A204578706F736520607061727365602E5C6E202A2F5C6E5C6E76617220646F6D696679203D2070617273653B5C6E5C6E2F2A2A5C6E202A20546573747320666F722062726F7773657220737570706F72742E5C6E202A2F5C6E5C6E766172';
wwv_flow_imp.g_varchar2_table(6079) := '20696E6E657248544D4C427567203D2066616C73653B5C6E76617220627567546573744469763B5C6E69662028747970656F6620646F63756D656E7420213D3D2027756E646566696E65642729207B5C6E202062756754657374446976203D20646F6375';
wwv_flow_imp.g_varchar2_table(6080) := '6D656E742E637265617465456C656D656E74282764697627293B5C6E20202F2F2053657475705C6E2020627567546573744469762E696E6E657248544D4C203D202720203C6C696E6B2F3E3C7461626C653E3C2F7461626C653E3C6120687265663D5C22';
wwv_flow_imp.g_varchar2_table(6081) := '2F615C223E613C2F613E3C696E70757420747970653D5C22636865636B626F785C222F3E273B5C6E20202F2F204D616B6520737572652074686174206C696E6B20656C656D656E7473206765742073657269616C697A656420636F72726563746C792062';
wwv_flow_imp.g_varchar2_table(6082) := '7920696E6E657248544D4C5C6E20202F2F20546869732072657175697265732061207772617070657220656C656D656E7420696E2049455C6E2020696E6E657248544D4C427567203D2021627567546573744469762E676574456C656D656E7473427954';
wwv_flow_imp.g_varchar2_table(6083) := '61674E616D6528276C696E6B27292E6C656E6774683B5C6E202062756754657374446976203D20756E646566696E65643B5C6E7D5C6E5C6E2F2A2A5C6E202A2057726170206D61702066726F6D206A71756572792E5C6E202A2F5C6E5C6E766172206D61';
wwv_flow_imp.g_varchar2_table(6084) := '70203D207B5C6E20206C6567656E643A205B312C20273C6669656C647365743E272C20273C2F6669656C647365743E275D2C5C6E202074723A205B322C20273C7461626C653E3C74626F64793E272C20273C2F74626F64793E3C2F7461626C653E275D2C';
wwv_flow_imp.g_varchar2_table(6085) := '5C6E2020636F6C3A205B322C20273C7461626C653E3C74626F64793E3C2F74626F64793E3C636F6C67726F75703E272C20273C2F636F6C67726F75703E3C2F7461626C653E275D2C5C6E20202F2F20666F72207363726970742F6C696E6B2F7374796C65';
wwv_flow_imp.g_varchar2_table(6086) := '207461677320746F20776F726B20696E204945362D382C20796F75206861766520746F20777261705C6E20202F2F20696E20612064697620776974682061206E6F6E2D776869746573706163652063686172616374657220696E2066726F6E742C206861';
wwv_flow_imp.g_varchar2_table(6087) := '215C6E20205F64656661756C743A20696E6E657248544D4C427567203F205B312C2027583C6469763E272C20273C2F6469763E275D203A205B302C2027272C2027275D5C6E7D3B5C6E5C6E6D61702E7464203D5C6E6D61702E7468203D205B332C20273C';
wwv_flow_imp.g_varchar2_table(6088) := '7461626C653E3C74626F64793E3C74723E272C20273C2F74723E3C2F74626F64793E3C2F7461626C653E275D3B5C6E5C6E6D61702E6F7074696F6E203D5C6E6D61702E6F707467726F7570203D205B312C20273C73656C656374206D756C7469706C653D';
wwv_flow_imp.g_varchar2_table(6089) := '5C226D756C7469706C655C223E272C20273C2F73656C6563743E275D3B5C6E5C6E6D61702E7468656164203D5C6E6D61702E74626F6479203D5C6E6D61702E636F6C67726F7570203D5C6E6D61702E63617074696F6E203D5C6E6D61702E74666F6F7420';
wwv_flow_imp.g_varchar2_table(6090) := '3D205B312C20273C7461626C653E272C20273C2F7461626C653E275D3B5C6E5C6E6D61702E706F6C796C696E65203D5C6E6D61702E656C6C69707365203D5C6E6D61702E706F6C79676F6E203D5C6E6D61702E636972636C65203D5C6E6D61702E746578';
wwv_flow_imp.g_varchar2_table(6091) := '74203D5C6E6D61702E6C696E65203D5C6E6D61702E70617468203D5C6E6D61702E72656374203D5C6E6D61702E67203D205B312C20273C73766720786D6C6E733D5C22687474703A2F2F7777772E77332E6F72672F323030302F7376675C222076657273';
wwv_flow_imp.g_varchar2_table(6092) := '696F6E3D5C22312E315C223E272C273C2F7376673E275D3B5C6E5C6E2F2A2A5C6E202A205061727365206068746D6C6020616E642072657475726E206120444F4D204E6F646520696E7374616E63652C20776869636820636F756C642062652061205465';
wwv_flow_imp.g_varchar2_table(6093) := '78744E6F64652C5C6E202A2048544D4C20444F4D204E6F6465206F6620736F6D65206B696E6420283C6469763E20666F72206578616D706C65292C206F72206120446F63756D656E74467261676D656E745C6E202A20696E7374616E63652C2064657065';
wwv_flow_imp.g_varchar2_table(6094) := '6E64696E67206F6E2074686520636F6E74656E7473206F6620746865206068746D6C6020737472696E672E5C6E202A5C6E202A2040706172616D207B537472696E677D2068746D6C202D2048544D4C20737472696E6720746F205C22646F6D6966795C22';
wwv_flow_imp.g_varchar2_table(6095) := '5C6E202A2040706172616D207B446F63756D656E747D20646F63202D205468652060646F63756D656E746020696E7374616E636520746F2063726561746520746865204E6F646520666F725C6E202A204072657475726E207B444F4D4E6F64657D207468';
wwv_flow_imp.g_varchar2_table(6096) := '6520546578744E6F64652C20444F4D204E6F64652C206F7220446F63756D656E74467261676D656E7420696E7374616E63655C6E202A204061706920707269766174655C6E202A2F5C6E5C6E66756E6374696F6E2070617273652868746D6C2C20646F63';
wwv_flow_imp.g_varchar2_table(6097) := '29207B5C6E20206966202827737472696E672720213D20747970656F662068746D6C29207468726F77206E657720547970654572726F722827537472696E6720657870656374656427293B5C6E5C6E20202F2F2064656661756C7420746F207468652067';
wwv_flow_imp.g_varchar2_table(6098) := '6C6F62616C2060646F63756D656E7460206F626A6563745C6E20206966202821646F632920646F63203D20646F63756D656E743B5C6E5C6E20202F2F20746167206E616D655C6E2020766172206D203D202F3C285B5C5C773A5D2B292F2E657865632868';
wwv_flow_imp.g_varchar2_table(6099) := '746D6C293B5C6E202069662028216D292072657475726E20646F632E637265617465546578744E6F64652868746D6C293B5C6E5C6E202068746D6C203D2068746D6C2E7265706C616365282F5E5C5C732B7C5C5C732B242F672C202727293B202F2F2052';
wwv_flow_imp.g_varchar2_table(6100) := '656D6F7665206C656164696E672F747261696C696E6720776869746573706163655C6E5C6E202076617220746167203D206D5B315D3B5C6E5C6E20202F2F20626F647920737570706F72745C6E202069662028746167203D3D2027626F64792729207B5C';
wwv_flow_imp.g_varchar2_table(6101) := '6E2020202076617220656C203D20646F632E637265617465456C656D656E74282768746D6C27293B5C6E20202020656C2E696E6E657248544D4C203D2068746D6C3B5C6E2020202072657475726E20656C2E72656D6F76654368696C6428656C2E6C6173';
wwv_flow_imp.g_varchar2_table(6102) := '744368696C64293B5C6E20207D5C6E5C6E20202F2F2077726170206D61705C6E20207661722077726170203D204F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C286D61702C2074616729203F206D61705B7461';
wwv_flow_imp.g_varchar2_table(6103) := '675D203A206D61702E5F64656661756C743B5C6E2020766172206465707468203D20777261705B305D3B5C6E202076617220707265666978203D20777261705B315D3B5C6E202076617220737566666978203D20777261705B325D3B5C6E202076617220';
wwv_flow_imp.g_varchar2_table(6104) := '656C203D20646F632E637265617465456C656D656E74282764697627293B5C6E2020656C2E696E6E657248544D4C203D20707265666978202B2068746D6C202B207375666669783B5C6E20207768696C65202864657074682D2D2920656C203D20656C2E';
wwv_flow_imp.g_varchar2_table(6105) := '6C6173744368696C643B5C6E5C6E20202F2F206F6E6520656C656D656E745C6E202069662028656C2E66697273744368696C64203D3D20656C2E6C6173744368696C6429207B5C6E2020202072657475726E20656C2E72656D6F76654368696C6428656C';
wwv_flow_imp.g_varchar2_table(6106) := '2E66697273744368696C64293B5C6E20207D5C6E5C6E20202F2F207365766572616C20656C656D656E74735C6E202076617220667261676D656E74203D20646F632E637265617465446F63756D656E74467261676D656E7428293B5C6E20207768696C65';
wwv_flow_imp.g_varchar2_table(6107) := '2028656C2E66697273744368696C6429207B5C6E20202020667261676D656E742E617070656E644368696C6428656C2E72656D6F76654368696C6428656C2E66697273744368696C6429293B5C6E20207D5C6E5C6E202072657475726E20667261676D65';
wwv_flow_imp.g_varchar2_table(6108) := '6E743B5C6E7D5C6E5C6E76617220646F6D6966792431203D20646F6D6966793B5C6E5C6E2F2A2A5C6E202A2040706172616D207B2048544D4C456C656D656E74207D20656C656D656E745C6E202A2040706172616D207B20537472696E67207D2073656C';
wwv_flow_imp.g_varchar2_table(6109) := '6563746F725C6E202A5C6E202A204072657475726E207B20626F6F6C65616E207D5C6E202A2F5C6E66756E6374696F6E206D61746368657328656C656D656E742C2073656C6563746F7229207B5C6E202072657475726E20656C656D656E742026262074';
wwv_flow_imp.g_varchar2_table(6110) := '7970656F6620656C656D656E742E6D617463686573203D3D3D202766756E6374696F6E2720262620656C656D656E742E6D6174636865732873656C6563746F7229207C7C2066616C73653B5C6E7D5C6E5C6E66756E6374696F6E2071756572792873656C';
wwv_flow_imp.g_varchar2_table(6111) := '6563746F722C20656C29207B5C6E2020656C203D20656C207C7C20646F63756D656E743B5C6E5C6E202072657475726E20656C2E717565727953656C6563746F722873656C6563746F72293B5C6E7D5C6E5C6E66756E6374696F6E20616C6C2873656C65';
wwv_flow_imp.g_varchar2_table(6112) := '63746F722C20656C29207B5C6E2020656C203D20656C207C7C20646F63756D656E743B5C6E5C6E202072657475726E20656C2E717565727953656C6563746F72416C6C2873656C6563746F72293B5C6E7D5C6E5C6E66756E6374696F6E2072656D6F7665';
wwv_flow_imp.g_varchar2_table(6113) := '28656C29207B5C6E2020656C2E706172656E744E6F646520262620656C2E706172656E744E6F64652E72656D6F76654368696C6428656C293B5C6E7D5C6E5C6E6578706F7274207B2061737369676E2061732061737369676E5374796C652C2061747472';
wwv_flow_imp.g_varchar2_table(6114) := '2C20636C61737365732C20636C6561722C20636C6F736573742C2064656C65676174652C20646F6D696679243120617320646F6D6966792C206576656E742C206D6174636865732C2071756572792C20616C6C206173207175657279416C6C2C2072656D';
wwv_flow_imp.g_varchar2_table(6115) := '6F7665207D3B5C6E2F2F2320736F757263654D617070696E6755524C3D696E6465782E65736D2E6A732E6D61705C6E222C227661722066726F6D43686172436F6465203D20537472696E672E66726F6D43686172436F64653B5C6E5C6E76617220686173';
wwv_flow_imp.g_varchar2_table(6116) := '4F776E50726F7065727479203D204F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B5C6E5C6E76617220454E544954595F5041545445524E203D202F2623285C5C642B293B7C262378285B302D39612D665D2B293B7C2628';
wwv_flow_imp.g_varchar2_table(6117) := '5C5C772B293B2F69673B5C6E5C6E76617220454E544954595F4D415050494E47203D207B5C6E202027616D70273A202726272C5C6E20202761706F73273A20275C5C27272C5C6E2020276774273A20273E272C5C6E2020276C74273A20273C272C5C6E20';
wwv_flow_imp.g_varchar2_table(6118) := '202771756F74273A20275C22275C6E7D3B5C6E5C6E2F2F206D6170205550504552434153452076617269616E7473206F6620737570706F72746564207370656369616C2063686172735C6E4F626A6563742E6B65797328454E544954595F4D415050494E';
wwv_flow_imp.g_varchar2_table(6119) := '47292E666F72456163682866756E6374696F6E286B29207B5C6E2020454E544954595F4D415050494E475B6B2E746F55707065724361736528295D203D20454E544954595F4D415050494E475B6B5D3B5C6E7D293B5C6E5C6E5C6E66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(6120) := '7265706C616365456E746974696573285F2C20642C20782C207A29207B5C6E5C6E20202F2F207265736572766564206E616D65732C20692E652E20266E6273703B5C6E2020696620287A29207B5C6E20202020696620286861734F776E50726F70657274';
wwv_flow_imp.g_varchar2_table(6121) := '792E63616C6C28454E544954595F4D415050494E472C207A2929207B5C6E20202020202072657475726E20454E544954595F4D415050494E475B7A5D3B5C6E202020207D20656C7365207B5C6E5C6E2020202020202F2F2066616C6C206261636B20746F';
wwv_flow_imp.g_varchar2_table(6122) := '206F726967696E616C2076616C75655C6E20202020202072657475726E20272627202B207A202B20273B273B5C6E202020207D5C6E20207D5C6E5C6E20202F2F20646563696D616C20656E636F64656420636861725C6E2020696620286429207B5C6E20';
wwv_flow_imp.g_varchar2_table(6123) := '20202072657475726E2066726F6D43686172436F64652864293B5C6E20207D5C6E5C6E20202F2F2068657820656E636F64656420636861725C6E202072657475726E2066726F6D43686172436F6465287061727365496E7428782C20313629293B5C6E7D';
wwv_flow_imp.g_varchar2_table(6124) := '5C6E5C6E5C6E2F2A2A5C6E202A204120626173696320656E74697479206465636F64657220746861742063616E206465636F64652061206D696E696D616C5C6E202A207375622D736574206F66207265736572766564206E616D6573202826616D703B29';
wwv_flow_imp.g_varchar2_table(6125) := '2061732077656C6C2061735C6E202A2068657820282623786161663B2920616E6420646563696D616C20282623313233313B2920656E636F64656420636861726163746572732E5C6E202A5C6E202A2040706172616D207B737472696E677D207374725C';
wwv_flow_imp.g_varchar2_table(6126) := '6E202A5C6E202A204072657475726E207B737472696E677D206465636F64656420737472696E675C6E202A2F5C6E66756E6374696F6E206465636F6465456E746974696573287329207B5C6E202069662028732E6C656E677468203E203320262620732E';
wwv_flow_imp.g_varchar2_table(6127) := '696E6465784F66282726272920213D3D202D3129207B5C6E2020202072657475726E20732E7265706C61636528454E544954595F5041545445524E2C207265706C616365456E746974696573293B5C6E20207D5C6E5C6E202072657475726E20733B5C6E';
wwv_flow_imp.g_varchar2_table(6128) := '7D5C6E5C6E766172205853495F555249203D2027687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D612D696E7374616E6365273B5C6E766172205853495F505245464958203D2027787369273B5C6E766172205853495F5459';
wwv_flow_imp.g_varchar2_table(6129) := '5045203D20277873693A74797065273B5C6E5C6E766172204E4F4E5F574849544553504143455F4F5554534944455F524F4F545F4E4F4445203D20276E6F6E2D77686974657370616365206F757473696465206F6620726F6F74206E6F6465273B5C6E5C';
wwv_flow_imp.g_varchar2_table(6130) := '6E66756E6374696F6E206572726F72286D736729207B5C6E202072657475726E206E6577204572726F72286D7367293B5C6E7D5C6E5C6E66756E6374696F6E206D697373696E674E616D657370616365466F725072656669782870726566697829207B5C';
wwv_flow_imp.g_varchar2_table(6131) := '6E202072657475726E20276D697373696E67206E616D65737061636520666F7220707265666978203C27202B20707265666978202B20273E273B5C6E7D5C6E5C6E66756E6374696F6E2067657474657228676574466E29207B5C6E202072657475726E20';
wwv_flow_imp.g_varchar2_table(6132) := '7B5C6E2020202027676574273A20676574466E2C5C6E2020202027656E756D657261626C65273A20747275655C6E20207D3B5C6E7D5C6E5C6E66756E6374696F6E20636C6F6E654E734D6174726978286E734D617472697829207B5C6E20207661722063';
wwv_flow_imp.g_varchar2_table(6133) := '6C6F6E65203D207B7D2C206B65793B5C6E2020666F7220286B657920696E206E734D617472697829207B5C6E20202020636C6F6E655B6B65795D203D206E734D61747269785B6B65795D3B5C6E20207D5C6E202072657475726E20636C6F6E653B5C6E7D';
wwv_flow_imp.g_varchar2_table(6134) := '5C6E5C6E66756E6374696F6E207572695072656669782870726566697829207B5C6E202072657475726E20707265666978202B202724757269273B5C6E7D5C6E5C6E66756E6374696F6E206275696C644E734D6174726978286E73557269546F50726566';
wwv_flow_imp.g_varchar2_table(6135) := '697829207B5C6E2020766172206E734D6174726978203D207B7D2C5C6E2020202020207572692C5C6E2020202020207072656669783B5C6E5C6E2020666F72202875726920696E206E73557269546F50726566697829207B5C6E20202020707265666978';
wwv_flow_imp.g_varchar2_table(6136) := '203D206E73557269546F5072656669785B7572695D3B5C6E202020206E734D61747269785B7072656669785D203D207072656669783B5C6E202020206E734D61747269785B75726950726566697828707265666978295D203D207572693B5C6E20207D5C';
wwv_flow_imp.g_varchar2_table(6137) := '6E5C6E202072657475726E206E734D61747269783B5C6E7D5C6E5C6E66756E6374696F6E206E6F6F70476574436F6E746578742829207B5C6E202072657475726E207B20276C696E65273A20302C2027636F6C756D6E273A2030207D3B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(6138) := '66756E6374696F6E207468726F7746756E632865727229207B5C6E20207468726F77206572723B5C6E7D5C6E5C6E2F2A2A5C6E202A20437265617465732061206E65772070617273657220776974682074686520676976656E206F7074696F6E732E5C6E';
wwv_flow_imp.g_varchar2_table(6139) := '202A5C6E202A2040636F6E7374727563746F725C6E202A5C6E202A2040706172616D20207B214F626A6563743C737472696E672C203F3E3D7D206F7074696F6E735C6E202A2F5C6E66756E6374696F6E20506172736572286F7074696F6E7329207B5C6E';
wwv_flow_imp.g_varchar2_table(6140) := '5C6E202069662028217468697329207B5C6E2020202072657475726E206E657720506172736572286F7074696F6E73293B5C6E20207D5C6E5C6E20207661722070726F7879203D206F7074696F6E73202626206F7074696F6E735B2770726F7879275D3B';
wwv_flow_imp.g_varchar2_table(6141) := '5C6E5C6E2020766172206F6E546578742C5C6E2020202020206F6E4F70656E5461672C5C6E2020202020206F6E436C6F73655461672C5C6E2020202020206F6E43444154412C5C6E2020202020206F6E4572726F72203D207468726F7746756E632C5C6E';
wwv_flow_imp.g_varchar2_table(6142) := '2020202020206F6E5761726E696E672C5C6E2020202020206F6E436F6D6D656E742C5C6E2020202020206F6E5175657374696F6E2C5C6E2020202020206F6E417474656E74696F6E3B5C6E5C6E202076617220676574436F6E74657874203D206E6F6F70';
wwv_flow_imp.g_varchar2_table(6143) := '476574436F6E746578743B5C6E5C6E20202F2A2A5C6E2020202A20446F207765206E65656420746F207061727365207468652063757272656E7420656C656D656E7473206174747269627574657320666F72206E616D657370616365733F5C6E2020202A';
wwv_flow_imp.g_varchar2_table(6144) := '5C6E2020202A204074797065207B626F6F6C65616E7D5C6E2020202A2F5C6E2020766172206D617962654E53203D2066616C73653B5C6E5C6E20202F2A2A5C6E2020202A20446F2077652070726F63657373206E616D6573706163657320617420616C6C';
wwv_flow_imp.g_varchar2_table(6145) := '3F5C6E2020202A5C6E2020202A204074797065207B626F6F6C65616E7D5C6E2020202A2F5C6E20207661722069734E616D657370616365203D2066616C73653B5C6E5C6E20202F2A2A5C6E2020202A2054686520636175676874206572726F7220726574';
wwv_flow_imp.g_varchar2_table(6146) := '75726E6564206F6E20706172736520656E645C6E2020202A5C6E2020202A204074797065207B4572726F727D5C6E2020202A2F5C6E20207661722072657475726E4572726F72203D206E756C6C3B5C6E5C6E20202F2A2A5C6E2020202A2053686F756C64';
wwv_flow_imp.g_varchar2_table(6147) := '2077652073746F702070617273696E673F5C6E2020202A5C6E2020202A204074797065207B626F6F6C65616E7D5C6E2020202A2F5C6E202076617220706172736553746F70203D2066616C73653B5C6E5C6E20202F2A2A5C6E2020202A2041206D617020';
wwv_flow_imp.g_varchar2_table(6148) := '6F66207B207572693A20707265666978207D207573656420627920746865207061727365722E5C6E2020202A5C6E2020202A2054686973206D61702077696C6C20656E737572652077652063616E206E6F726D616C697A65207072656669786573206475';
wwv_flow_imp.g_varchar2_table(6149) := '72696E672070726F63657373696E673B5C6E2020202A20666F722065616368207572692C206F6E6C79206F6E65207072656669782077696C6C206265206578706F73656420746F207468652068616E646C6572732E5C6E2020202A5C6E2020202A204074';
wwv_flow_imp.g_varchar2_table(6150) := '797065207B214F626A6563743C737472696E672C20737472696E673E7D7D5C6E2020202A2F5C6E2020766172206E73557269546F5072656669783B5C6E5C6E20202F2A2A5C6E2020202A2048616E646C65207061727365206572726F722E5C6E2020202A';
wwv_flow_imp.g_varchar2_table(6151) := '5C6E2020202A2040706172616D20207B737472696E677C4572726F727D206572725C6E2020202A2F5C6E202066756E6374696F6E2068616E646C654572726F722865727229207B5C6E2020202069662028212865727220696E7374616E63656F66204572';
wwv_flow_imp.g_varchar2_table(6152) := '726F722929207B5C6E202020202020657272203D206572726F7228657272293B5C6E202020207D5C6E5C6E2020202072657475726E4572726F72203D206572723B5C6E5C6E202020206F6E4572726F72286572722C20676574436F6E74657874293B5C6E';
wwv_flow_imp.g_varchar2_table(6153) := '20207D5C6E5C6E20202F2A2A5C6E2020202A2048616E646C65207061727365206572726F722E5C6E2020202A5C6E2020202A2040706172616D20207B737472696E677C4572726F727D206572725C6E2020202A2F5C6E202066756E6374696F6E2068616E';
wwv_flow_imp.g_varchar2_table(6154) := '646C655761726E696E672865727229207B5C6E5C6E2020202069662028216F6E5761726E696E6729207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E2020202069662028212865727220696E7374616E63656F66204572726F722929';
wwv_flow_imp.g_varchar2_table(6155) := '207B5C6E202020202020657272203D206572726F7228657272293B5C6E202020207D5C6E5C6E202020206F6E5761726E696E67286572722C20676574436F6E74657874293B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A2052656769737465722070';
wwv_flow_imp.g_varchar2_table(6156) := '61727365206C697374656E65722E5C6E2020202A5C6E2020202A2040706172616D20207B737472696E677D2020206E616D655C6E2020202A2040706172616D20207B46756E6374696F6E7D2063625C6E2020202A5C6E2020202A204072657475726E207B';
wwv_flow_imp.g_varchar2_table(6157) := '5061727365727D5C6E2020202A2F5C6E2020746869735B276F6E275D203D2066756E6374696F6E286E616D652C20636229207B5C6E5C6E2020202069662028747970656F6620636220213D3D202766756E6374696F6E2729207B5C6E2020202020207468';
wwv_flow_imp.g_varchar2_table(6158) := '726F77206572726F72282772657175697265642061726773203C6E616D652C2063623E27293B5C6E202020207D5C6E5C6E2020202073776974636820286E616D6529207B5C6E202020206361736520276F70656E546167273A206F6E4F70656E54616720';
wwv_flow_imp.g_varchar2_table(6159) := '3D2063623B20627265616B3B5C6E2020202063617365202774657874273A206F6E54657874203D2063623B20627265616B3B5C6E20202020636173652027636C6F7365546167273A206F6E436C6F7365546167203D2063623B20627265616B3B5C6E2020';
wwv_flow_imp.g_varchar2_table(6160) := '20206361736520276572726F72273A206F6E4572726F72203D2063623B20627265616B3B5C6E202020206361736520277761726E273A206F6E5761726E696E67203D2063623B20627265616B3B5C6E202020206361736520276364617461273A206F6E43';
wwv_flow_imp.g_varchar2_table(6161) := '44415441203D2063623B20627265616B3B5C6E20202020636173652027617474656E74696F6E273A206F6E417474656E74696F6E203D2063623B20627265616B3B202F2F203C215858585858207A7A7A7A3D5C22656565655C223E5C6E20202020636173';
wwv_flow_imp.g_varchar2_table(6162) := '6520277175657374696F6E273A206F6E5175657374696F6E203D2063623B20627265616B3B202F2F203C3F202E2E2E2E20203F3E5C6E20202020636173652027636F6D6D656E74273A206F6E436F6D6D656E74203D2063623B20627265616B3B5C6E2020';
wwv_flow_imp.g_varchar2_table(6163) := '202064656661756C743A5C6E2020202020207468726F77206572726F722827756E737570706F72746564206576656E743A2027202B206E616D65293B5C6E202020207D5C6E5C6E2020202072657475726E20746869733B5C6E20207D3B5C6E5C6E20202F';
wwv_flow_imp.g_varchar2_table(6164) := '2A2A5C6E2020202A2053657420746865206E616D65737061636520746F20707265666978206D617070696E672E5C6E2020202A5C6E2020202A20406578616D706C655C6E2020202A5C6E2020202A207061727365722E6E73287B5C6E2020202A20202027';
wwv_flow_imp.g_varchar2_table(6165) := '687474703A2F2F666F6F273A2027666F6F272C5C6E2020202A20202027687474703A2F2F626172273A2027626172275C6E2020202A207D293B5C6E2020202A5C6E2020202A2040706172616D20207B214F626A6563743C737472696E672C20737472696E';
wwv_flow_imp.g_varchar2_table(6166) := '673E7D206E734D61705C6E2020202A5C6E2020202A204072657475726E207B5061727365727D5C6E2020202A2F5C6E2020746869735B276E73275D203D2066756E6374696F6E286E734D617029207B5C6E5C6E2020202069662028747970656F66206E73';
wwv_flow_imp.g_varchar2_table(6167) := '4D6170203D3D3D2027756E646566696E65642729207B5C6E2020202020206E734D6170203D207B7D3B5C6E202020207D5C6E5C6E2020202069662028747970656F66206E734D617020213D3D20276F626A6563742729207B5C6E2020202020207468726F';
wwv_flow_imp.g_varchar2_table(6168) := '77206572726F72282772657175697265642061726773203C6E734D61703D7B7D3E27293B5C6E202020207D5C6E5C6E20202020766172205F6E73557269546F507265666978203D207B7D2C206B3B5C6E5C6E20202020666F7220286B20696E206E734D61';
wwv_flow_imp.g_varchar2_table(6169) := '7029207B5C6E2020202020205F6E73557269546F5072656669785B6B5D203D206E734D61705B6B5D3B5C6E202020207D5C6E5C6E202020202F2F20464F5243452064656661756C74206D617070696E6720666F7220736368656D6120696E7374616E6365';
wwv_flow_imp.g_varchar2_table(6170) := '5C6E202020205F6E73557269546F5072656669785B5853495F5552495D203D205853495F5052454649583B5C6E5C6E2020202069734E616D657370616365203D20747275653B5C6E202020206E73557269546F507265666978203D205F6E73557269546F';
wwv_flow_imp.g_varchar2_table(6171) := '5072656669783B5C6E5C6E2020202072657475726E20746869733B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A20506172736520786D6C20737472696E672E5C6E2020202A5C6E2020202A2040706172616D20207B737472696E677D20786D6C5C';
wwv_flow_imp.g_varchar2_table(6172) := '6E2020202A5C6E2020202A204072657475726E207B4572726F727D2072657475726E4572726F722C206966206E6F74207468726F776E5C6E2020202A2F5C6E2020746869735B277061727365275D203D2066756E6374696F6E28786D6C29207B5C6E2020';
wwv_flow_imp.g_varchar2_table(6173) := '202069662028747970656F6620786D6C20213D3D2027737472696E672729207B5C6E2020202020207468726F77206572726F72282772657175697265642061726773203C786D6C3D737472696E673E27293B5C6E202020207D5C6E5C6E20202020726574';
wwv_flow_imp.g_varchar2_table(6174) := '75726E4572726F72203D206E756C6C3B5C6E5C6E20202020706172736528786D6C293B5C6E5C6E20202020676574436F6E74657874203D206E6F6F70476574436F6E746578743B5C6E20202020706172736553746F70203D2066616C73653B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(6175) := '20202072657475726E2072657475726E4572726F723B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A2053746F702070617273696E672E5C6E2020202A2F5C6E2020746869735B2773746F70275D203D2066756E6374696F6E2829207B5C6E202020';
wwv_flow_imp.g_varchar2_table(6176) := '20706172736553746F70203D20747275653B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A20506172736520737472696E672C20696E766F6B696E6720636F6E66696775726564206C697374656E657273206F6E20656C656D656E742E5C6E202020';
wwv_flow_imp.g_varchar2_table(6177) := '2A5C6E2020202A2040706172616D20207B737472696E677D20786D6C5C6E2020202A2F5C6E202066756E6374696F6E20706172736528786D6C29207B5C6E20202020766172206E734D6174726978537461636B203D2069734E616D657370616365203F20';
wwv_flow_imp.g_varchar2_table(6178) := '5B5D203A206E756C6C2C5C6E20202020202020206E734D6174726978203D2069734E616D657370616365203F206275696C644E734D6174726978286E73557269546F50726566697829203A206E756C6C2C5C6E20202020202020205F6E734D6174726978';
wwv_flow_imp.g_varchar2_table(6179) := '2C5C6E20202020202020206E6F6465537461636B203D205B5D2C5C6E2020202020202020616E6F6E796D6F75734E73436F756E74203D20302C5C6E20202020202020207461675374617274203D2066616C73652C5C6E2020202020202020746167456E64';
wwv_flow_imp.g_varchar2_table(6180) := '203D2066616C73652C5C6E202020202020202069203D20302C206A203D20302C5C6E2020202020202020782C20792C20712C20772C20762C5C6E2020202020202020786D6C6E732C5C6E2020202020202020656C656D656E744E616D652C5C6E20202020';
wwv_flow_imp.g_varchar2_table(6181) := '202020205F656C656D656E744E616D652C5C6E2020202020202020656C656D656E7450726F78795C6E20202020202020203B5C6E5C6E20202020766172206174747273537472696E67203D2027272C5C6E20202020202020206174747273537461727420';
wwv_flow_imp.g_varchar2_table(6182) := '3D20302C5C6E20202020202020206361636865644174747273202F2F2066616C7365203D207061727365642077697468206572726F72732C206E756C6C203D206E656564732070617273696E675C6E20202020202020203B5C6E5C6E202020202F2A2A5C';
wwv_flow_imp.g_varchar2_table(6183) := '6E20202020202A2050617273652061747472696275746573206F6E2064656D616E6420616E642072657475726E73207468652070617273656420617474726962757465732E5C6E20202020202A5C6E20202020202A2052657475726E2073656D616E7469';
wwv_flow_imp.g_varchar2_table(6184) := '63733A20283129206066616C736560206F6E20617474726962757465207061727365206572726F722C5C6E20202020202A20283229206F626A6563742068617368206F6E206578747261637465642061747472732E5C6E20202020202A5C6E2020202020';
wwv_flow_imp.g_varchar2_table(6185) := '2A204072657475726E207B626F6F6C65616E7C4F626A6563747D5C6E20202020202A2F5C6E2020202066756E6374696F6E2067657441747472732829207B5C6E20202020202069662028636163686564417474727320213D3D206E756C6C29207B5C6E20';
wwv_flow_imp.g_varchar2_table(6186) := '2020202020202072657475726E2063616368656441747472733B5C6E2020202020207D5C6E5C6E202020202020766172206E735572692C5C6E202020202020202020206E735572695072656669782C5C6E202020202020202020206E734E616D652C5C6E';
wwv_flow_imp.g_varchar2_table(6187) := '2020202020202020202064656661756C74416C696173203D2069734E616D657370616365202626206E734D61747269785B27786D6C6E73275D2C5C6E20202020202020202020617474724C697374203D2069734E616D657370616365202626206D617962';
wwv_flow_imp.g_varchar2_table(6188) := '654E53203F205B5D203A206E756C6C2C5C6E2020202020202020202069203D20617474727353746172742C5C6E2020202020202020202073203D206174747273537472696E672C5C6E202020202020202020206C203D20732E6C656E6774682C5C6E2020';
wwv_flow_imp.g_varchar2_table(6189) := '20202020202020206861734E65774D61747269782C5C6E202020202020202020206E6577616C6961732C5C6E2020202020202020202076616C75652C5C6E20202020202020202020616C6961732C5C6E202020202020202020206E616D652C5C6E202020';
wwv_flow_imp.g_varchar2_table(6190) := '202020202020206174747273203D207B7D2C5C6E202020202020202020207365656E4174747273203D207B7D2C5C6E20202020202020202020736B6970417474722C5C6E20202020202020202020772C5C6E202020202020202020206A3B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(6191) := '202020207061727365417474723A5C6E202020202020666F7220283B2069203C206C3B20692B2B29207B5C6E2020202020202020736B697041747472203D2066616C73653B5C6E202020202020202077203D20732E63686172436F646541742869293B5C';
wwv_flow_imp.g_varchar2_table(6192) := '6E5C6E20202020202020206966202877203D3D3D203332207C7C202877203C2031342026262077203E20382929207B202F2F20574849544553504143453D7B205C5C665C5C6E5C5C725C5C745C5C767D5C6E20202020202020202020636F6E74696E7565';
wwv_flow_imp.g_varchar2_table(6193) := '3B5C6E20202020202020207D5C6E5C6E20202020202020202F2F207761697420666F72206E6F6E2077686974657370616365206368617261637465725C6E20202020202020206966202877203C203635207C7C2077203E20313232207C7C202877203E20';
wwv_flow_imp.g_varchar2_table(6194) := '39302026262077203C2039372929207B5C6E20202020202020202020696620287720213D3D203935202626207720213D3D20353829207B202F2F20636861722039355C225F5C222035385C223A5C225C6E20202020202020202020202068616E646C6557';
wwv_flow_imp.g_varchar2_table(6195) := '61726E696E672827696C6C6567616C206669727374206368617220617474726962757465206E616D6527293B5C6E202020202020202020202020736B697041747472203D20747275653B5C6E202020202020202020207D5C6E20202020202020207D5C6E';
wwv_flow_imp.g_varchar2_table(6196) := '5C6E20202020202020202F2F20706172736520617474726962757465206E616D655C6E2020202020202020666F7220286A203D2069202B20313B206A203C206C3B206A2B2B29207B5C6E2020202020202020202077203D20732E63686172436F64654174';
wwv_flow_imp.g_varchar2_table(6197) := '286A293B5C6E5C6E20202020202020202020696620285C6E20202020202020202020202077203E2039362026262077203C20313233207C7C5C6E20202020202020202020202077203E2036342026262077203C203931207C7C5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(6198) := '20202077203E2034372026262077203C203539207C7C5C6E20202020202020202020202077203D3D3D203436207C7C202F2F20272E275C6E20202020202020202020202077203D3D3D203435207C7C202F2F20272D275C6E202020202020202020202020';
wwv_flow_imp.g_varchar2_table(6199) := '77203D3D3D203935202F2F20275F275C6E2020202020202020202029207B5C6E202020202020202020202020636F6E74696E75653B5C6E202020202020202020207D5C6E5C6E202020202020202020202F2F20756E657870656374656420776869746573';
wwv_flow_imp.g_varchar2_table(6200) := '706163655C6E202020202020202020206966202877203D3D3D203332207C7C202877203C2031342026262077203E20382929207B202F2F20574849544553504143455C6E20202020202020202020202068616E646C655761726E696E6728276D69737369';
wwv_flow_imp.g_varchar2_table(6201) := '6E67206174747269627574652076616C756527293B5C6E20202020202020202020202069203D206A3B5C6E5C6E202020202020202020202020636F6E74696E7565207061727365417474723B5C6E202020202020202020207D5C6E5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(6202) := '2020202F2F206578706563746564205C223D5C225C6E202020202020202020206966202877203D3D3D20363129207B202F2F205C223D5C22203D3D2036315C6E202020202020202020202020627265616B3B5C6E202020202020202020207D5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(6203) := '20202020202020202068616E646C655761726E696E672827696C6C6567616C20617474726962757465206E616D65206368617227293B5C6E20202020202020202020736B697041747472203D20747275653B5C6E20202020202020207D5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(6204) := '20202020206E616D65203D20732E737562737472696E6728692C206A293B5C6E5C6E2020202020202020696620286E616D65203D3D3D2027786D6C6E733A786D6C6E732729207B5C6E2020202020202020202068616E646C655761726E696E672827696C';
wwv_flow_imp.g_varchar2_table(6205) := '6C6567616C206465636C61726174696F6E206F6620786D6C6E7327293B5C6E20202020202020202020736B697041747472203D20747275653B5C6E20202020202020207D5C6E5C6E202020202020202077203D20732E63686172436F64654174286A202B';
wwv_flow_imp.g_varchar2_table(6206) := '2031293B5C6E5C6E20202020202020206966202877203D3D3D20333429207B202F2F20275C22275C6E202020202020202020206A203D20732E696E6465784F6628275C22272C2069203D206A202B2032293B5C6E5C6E2020202020202020202069662028';
wwv_flow_imp.g_varchar2_table(6207) := '6A203D3D3D202D3129207B5C6E2020202020202020202020206A203D20732E696E6465784F6628275C5C27272C2069293B5C6E5C6E202020202020202020202020696620286A20213D3D202D3129207B5C6E202020202020202020202020202068616E64';
wwv_flow_imp.g_varchar2_table(6208) := '6C655761726E696E6728276174747269627574652076616C75652071756F7465206D6973736D6174636827293B5C6E2020202020202020202020202020736B697041747472203D20747275653B5C6E2020202020202020202020207D5C6E202020202020';
wwv_flow_imp.g_varchar2_table(6209) := '202020207D5C6E5C6E20202020202020207D20656C7365206966202877203D3D3D20333929207B202F2F205C22275C225C6E202020202020202020206A203D20732E696E6465784F6628275C5C27272C2069203D206A202B2032293B5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(6210) := '202020202020696620286A203D3D3D202D3129207B5C6E2020202020202020202020206A203D20732E696E6465784F6628275C22272C2069293B5C6E5C6E202020202020202020202020696620286A20213D3D202D3129207B5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(6211) := '202020202068616E646C655761726E696E6728276174747269627574652076616C75652071756F7465206D6973736D6174636827293B5C6E2020202020202020202020202020736B697041747472203D20747275653B5C6E202020202020202020202020';
wwv_flow_imp.g_varchar2_table(6212) := '7D5C6E202020202020202020207D5C6E5C6E20202020202020207D20656C7365207B5C6E2020202020202020202068616E646C655761726E696E6728276D697373696E67206174747269627574652076616C75652071756F74657327293B5C6E20202020';
wwv_flow_imp.g_varchar2_table(6213) := '202020202020736B697041747472203D20747275653B5C6E5C6E202020202020202020202F2F20736B697020746F206E6578742073706163655C6E20202020202020202020666F7220286A203D206A202B20313B206A203C206C3B206A2B2B29207B5C6E';
wwv_flow_imp.g_varchar2_table(6214) := '20202020202020202020202077203D20732E63686172436F64654174286A202B2031293B5C6E5C6E2020202020202020202020206966202877203D3D3D203332207C7C202877203C2031342026262077203E20382929207B202F2F205748495445535041';
wwv_flow_imp.g_varchar2_table(6215) := '43455C6E2020202020202020202020202020627265616B3B5C6E2020202020202020202020207D5C6E202020202020202020207D5C6E5C6E20202020202020207D5C6E5C6E2020202020202020696620286A203D3D3D202D3129207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(6216) := '2020202068616E646C655761726E696E6728276D697373696E6720636C6F73696E672071756F74657327293B5C6E5C6E202020202020202020206A203D206C3B5C6E20202020202020202020736B697041747472203D20747275653B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(6217) := '20207D5C6E5C6E20202020202020206966202821736B69704174747229207B5C6E2020202020202020202076616C7565203D20732E737562737472696E6728692C206A293B5C6E20202020202020207D5C6E5C6E202020202020202069203D206A3B5C6E';
wwv_flow_imp.g_varchar2_table(6218) := '5C6E20202020202020202F2F20656E7375726520535041434520666F6C6C6F7773206174747269627574655C6E20202020202020202F2F20736B697020696C6C6567616C20636F6E74656E74206F74686572776973655C6E20202020202020202F2F2065';
wwv_flow_imp.g_varchar2_table(6219) := '78616D706C6520613D5C22625C22635C6E2020202020202020666F7220283B206A202B2031203C206C3B206A2B2B29207B5C6E2020202020202020202077203D20732E63686172436F64654174286A202B2031293B5C6E5C6E2020202020202020202069';
wwv_flow_imp.g_varchar2_table(6220) := '66202877203D3D3D203332207C7C202877203C2031342026262077203E20382929207B202F2F20574849544553504143455C6E202020202020202020202020627265616B3B5C6E202020202020202020207D5C6E5C6E202020202020202020202F2F2046';
wwv_flow_imp.g_varchar2_table(6221) := '4952535420494C4C4547414C20434841525C6E202020202020202020206966202869203D3D3D206A29207B5C6E20202020202020202020202068616E646C655761726E696E672827696C6C6567616C206368617261637465722061667465722061747472';
wwv_flow_imp.g_varchar2_table(6222) := '696275746520656E6427293B5C6E202020202020202020202020736B697041747472203D20747275653B5C6E202020202020202020207D5C6E20202020202020207D5C6E5C6E20202020202020202F2F20616476616E636520637572736F7220746F206E';
wwv_flow_imp.g_varchar2_table(6223) := '657874206174747269627574655C6E202020202020202069203D206A202B20313B5C6E5C6E202020202020202069662028736B69704174747229207B5C6E20202020202020202020636F6E74696E7565207061727365417474723B5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(6224) := '207D5C6E5C6E20202020202020202F2F20636865636B206174747269627574652072652D6465636C61726174696F6E5C6E2020202020202020696620286E616D6520696E207365656E417474727329207B5C6E2020202020202020202068616E646C6557';
wwv_flow_imp.g_varchar2_table(6225) := '61726E696E672827617474726962757465203C27202B206E616D65202B20273E20616C726561647920646566696E656427293B5C6E20202020202020202020636F6E74696E75653B5C6E20202020202020207D5C6E5C6E20202020202020207365656E41';
wwv_flow_imp.g_varchar2_table(6226) := '747472735B6E616D655D203D20747275653B5C6E5C6E2020202020202020696620282169734E616D65737061636529207B5C6E2020202020202020202061747472735B6E616D655D203D2076616C75653B5C6E20202020202020202020636F6E74696E75';
wwv_flow_imp.g_varchar2_table(6227) := '653B5C6E20202020202020207D5C6E5C6E20202020202020202F2F2074727920746F2065787472616374206E616D65737061636520696E666F726D6174696F6E5C6E2020202020202020696620286D617962654E5329207B5C6E20202020202020202020';
wwv_flow_imp.g_varchar2_table(6228) := '6E6577616C696173203D20285C6E2020202020202020202020206E616D65203D3D3D2027786D6C6E73275C6E20202020202020202020202020203F2027786D6C6E73275C6E20202020202020202020202020203A20286E616D652E63686172436F646541';
wwv_flow_imp.g_varchar2_table(6229) := '74283029203D3D3D20313230202626206E616D652E73756273747228302C203629203D3D3D2027786D6C6E733A27295C6E202020202020202020202020202020203F206E616D652E7375627374722836295C6E202020202020202020202020202020203A';
wwv_flow_imp.g_varchar2_table(6230) := '206E756C6C5C6E20202020202020202020293B5C6E5C6E202020202020202020202F2F2068616E646C6520786D6C6E73283A616C696173292061737369676E6D656E745C6E20202020202020202020696620286E6577616C69617320213D3D206E756C6C';
wwv_flow_imp.g_varchar2_table(6231) := '29207B5C6E2020202020202020202020206E73557269203D206465636F6465456E7469746965732876616C7565293B5C6E2020202020202020202020206E73557269507265666978203D20757269507265666978286E6577616C696173293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(6232) := '2020202020202020202020616C696173203D206E73557269546F5072656669785B6E735572695D3B5C6E5C6E2020202020202020202020206966202821616C69617329207B5C6E5C6E20202020202020202020202020202F2F206E6F2070726566697820';
wwv_flow_imp.g_varchar2_table(6233) := '646566696E6564206F722070726566697820636F6C6C6973696F6E5C6E2020202020202020202020202020696620285C6E20202020202020202020202020202020286E6577616C696173203D3D3D2027786D6C6E732729207C7C5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(6234) := '2020202020202020286E7355726950726566697820696E206E734D6174726978202626206E734D61747269785B6E735572695072656669785D20213D3D206E73557269295C6E202020202020202020202020202029207B5C6E5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(6235) := '202020202020202F2F20616C6F636174652066726565206E73207072656669785C6E20202020202020202020202020202020646F207B5C6E202020202020202020202020202020202020616C696173203D20276E7327202B2028616E6F6E796D6F75734E';
wwv_flow_imp.g_varchar2_table(6236) := '73436F756E742B2B293B5C6E202020202020202020202020202020207D207768696C652028747970656F66206E734D61747269785B616C6961735D20213D3D2027756E646566696E656427293B5C6E20202020202020202020202020207D20656C736520';
wwv_flow_imp.g_varchar2_table(6237) := '7B5C6E20202020202020202020202020202020616C696173203D206E6577616C6961733B5C6E20202020202020202020202020207D5C6E5C6E20202020202020202020202020206E73557269546F5072656669785B6E735572695D203D20616C6961733B';
wwv_flow_imp.g_varchar2_table(6238) := '5C6E2020202020202020202020207D5C6E5C6E202020202020202020202020696620286E734D61747269785B6E6577616C6961735D20213D3D20616C69617329207B5C6E202020202020202020202020202069662028216861734E65774D617472697829';
wwv_flow_imp.g_varchar2_table(6239) := '207B5C6E202020202020202020202020202020206E734D6174726978203D20636C6F6E654E734D6174726978286E734D6174726978293B5C6E202020202020202020202020202020206861734E65774D6174726978203D20747275653B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(6240) := '2020202020202020207D5C6E5C6E20202020202020202020202020206E734D61747269785B6E6577616C6961735D203D20616C6961733B5C6E2020202020202020202020202020696620286E6577616C696173203D3D3D2027786D6C6E732729207B5C6E';
wwv_flow_imp.g_varchar2_table(6241) := '202020202020202020202020202020206E734D61747269785B75726950726566697828616C696173295D203D206E735572693B5C6E2020202020202020202020202020202064656661756C74416C696173203D20616C6961733B5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(6242) := '2020202020207D5C6E5C6E20202020202020202020202020206E734D61747269785B6E735572695072656669785D203D206E735572693B5C6E2020202020202020202020207D5C6E5C6E2020202020202020202020202F2F206578706F736520786D6C6E';
wwv_flow_imp.g_varchar2_table(6243) := '73283A617364293D5C222E2E2E5C2220696E20617474726962757465735C6E20202020202020202020202061747472735B6E616D655D203D2076616C75653B5C6E202020202020202020202020636F6E74696E75653B5C6E202020202020202020207D5C';
wwv_flow_imp.g_varchar2_table(6244) := '6E5C6E202020202020202020202F2F20636F6C6C656374206174747269627574657320756E74696C20616C6C206E616D6573706163655C6E202020202020202020202F2F206465636C61726174696F6E73206172652070726F6365737365645C6E202020';
wwv_flow_imp.g_varchar2_table(6245) := '20202020202020617474724C6973742E70757368286E616D652C2076616C7565293B5C6E20202020202020202020636F6E74696E75653B5C6E5C6E20202020202020207D202F2A2A20656E6420696620286D617962654E7329202A2F5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(6246) := '202020202F2F2068616E646C652061747472696275746573206F6E20656C656D656E7420776974686F75745C6E20202020202020202F2F206E616D657370616365206465636C61726174696F6E735C6E202020202020202077203D206E616D652E696E64';
wwv_flow_imp.g_varchar2_table(6247) := '65784F6628273A27293B5C6E20202020202020206966202877203D3D3D202D3129207B5C6E2020202020202020202061747472735B6E616D655D203D2076616C75653B5C6E20202020202020202020636F6E74696E75653B5C6E20202020202020207D5C';
wwv_flow_imp.g_varchar2_table(6248) := '6E5C6E20202020202020202F2F206E6F726D616C697A65206E7320617474726962757465206E616D655C6E20202020202020206966202821286E734E616D65203D206E734D61747269785B6E616D652E737562737472696E6728302C2077295D2929207B';
wwv_flow_imp.g_varchar2_table(6249) := '5C6E2020202020202020202068616E646C655761726E696E67286D697373696E674E616D657370616365466F72507265666978286E616D652E737562737472696E6728302C20772929293B5C6E20202020202020202020636F6E74696E75653B5C6E2020';
wwv_flow_imp.g_varchar2_table(6250) := '2020202020207D5C6E5C6E20202020202020206E616D65203D2064656661756C74416C696173203D3D3D206E734E616D655C6E202020202020202020203F206E616D652E7375627374722877202B2031295C6E202020202020202020203A206E734E616D';
wwv_flow_imp.g_varchar2_table(6251) := '65202B206E616D652E7375627374722877293B5C6E5C6E20202020202020202F2F20656E643A206E6F726D616C697A65206E7320617474726962757465206E616D655C6E5C6E20202020202020202F2F206E6F726D616C697A65207873693A7479706520';
wwv_flow_imp.g_varchar2_table(6252) := '6E73206174747269627574652076616C75655C6E2020202020202020696620286E616D65203D3D3D205853495F5459504529207B5C6E2020202020202020202077203D2076616C75652E696E6465784F6628273A27293B5C6E5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(6253) := '20696620287720213D3D202D3129207B5C6E2020202020202020202020206E734E616D65203D2076616C75652E737562737472696E6728302C2077293B5C6E5C6E2020202020202020202020202F2F2068616E646C652064656661756C74207072656669';
wwv_flow_imp.g_varchar2_table(6254) := '7865732C20692E652E2078733A537472696E6720677261636566756C6C795C6E2020202020202020202020206E734E616D65203D206E734D61747269785B6E734E616D655D207C7C206E734E616D653B5C6E20202020202020202020202076616C756520';
wwv_flow_imp.g_varchar2_table(6255) := '3D206E734E616D65202B2076616C75652E737562737472696E672877293B5C6E202020202020202020207D20656C7365207B5C6E20202020202020202020202076616C7565203D2064656661756C74416C696173202B20273A27202B2076616C75653B5C';
wwv_flow_imp.g_varchar2_table(6256) := '6E202020202020202020207D5C6E20202020202020207D5C6E5C6E20202020202020202F2F20656E643A206E6F726D616C697A65207873693A74797065206E73206174747269627574652076616C75655C6E5C6E202020202020202061747472735B6E61';
wwv_flow_imp.g_varchar2_table(6257) := '6D655D203D2076616C75653B5C6E2020202020207D5C6E5C6E5C6E2020202020202F2F2068616E646C652064656665727265642C20706F737369626C79206E616D6573706163656420617474726962757465735C6E202020202020696620286D61796265';
wwv_flow_imp.g_varchar2_table(6258) := '4E5329207B5C6E5C6E20202020202020202F2F206E6F726D616C697A6520636170747572656420617474726962757465735C6E2020202020202020666F72202869203D20302C206C203D20617474724C6973742E6C656E6774683B2069203C206C3B2069';
wwv_flow_imp.g_varchar2_table(6259) := '2B2B29207B5C6E5C6E202020202020202020206E616D65203D20617474724C6973745B692B2B5D3B5C6E2020202020202020202076616C7565203D20617474724C6973745B695D3B5C6E5C6E2020202020202020202077203D206E616D652E696E646578';
wwv_flow_imp.g_varchar2_table(6260) := '4F6628273A27293B5C6E5C6E20202020202020202020696620287720213D3D202D3129207B5C6E5C6E2020202020202020202020202F2F206E6F726D616C697A65206E7320617474726962757465206E616D655C6E202020202020202020202020696620';
wwv_flow_imp.g_varchar2_table(6261) := '2821286E734E616D65203D206E734D61747269785B6E616D652E737562737472696E6728302C2077295D2929207B5C6E202020202020202020202020202068616E646C655761726E696E67286D697373696E674E616D657370616365466F725072656669';
wwv_flow_imp.g_varchar2_table(6262) := '78286E616D652E737562737472696E6728302C20772929293B5C6E2020202020202020202020202020636F6E74696E75653B5C6E2020202020202020202020207D5C6E5C6E2020202020202020202020206E616D65203D2064656661756C74416C696173';
wwv_flow_imp.g_varchar2_table(6263) := '203D3D3D206E734E616D655C6E20202020202020202020202020203F206E616D652E7375627374722877202B2031295C6E20202020202020202020202020203A206E734E616D65202B206E616D652E7375627374722877293B5C6E5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(6264) := '20202020202F2F20656E643A206E6F726D616C697A65206E7320617474726962757465206E616D655C6E5C6E2020202020202020202020202F2F206E6F726D616C697A65207873693A74797065206E73206174747269627574652076616C75655C6E2020';
wwv_flow_imp.g_varchar2_table(6265) := '20202020202020202020696620286E616D65203D3D3D205853495F5459504529207B5C6E202020202020202020202020202077203D2076616C75652E696E6465784F6628273A27293B5C6E5C6E2020202020202020202020202020696620287720213D3D';
wwv_flow_imp.g_varchar2_table(6266) := '202D3129207B5C6E202020202020202020202020202020206E734E616D65203D2076616C75652E737562737472696E6728302C2077293B5C6E5C6E202020202020202020202020202020202F2F2068616E646C652064656661756C742070726566697865';
wwv_flow_imp.g_varchar2_table(6267) := '732C20692E652E2078733A537472696E6720677261636566756C6C795C6E202020202020202020202020202020206E734E616D65203D206E734D61747269785B6E734E616D655D207C7C206E734E616D653B5C6E20202020202020202020202020202020';
wwv_flow_imp.g_varchar2_table(6268) := '76616C7565203D206E734E616D65202B2076616C75652E737562737472696E672877293B5C6E20202020202020202020202020207D20656C7365207B5C6E2020202020202020202020202020202076616C7565203D2064656661756C74416C696173202B';
wwv_flow_imp.g_varchar2_table(6269) := '20273A27202B2076616C75653B5C6E20202020202020202020202020207D5C6E2020202020202020202020207D5C6E5C6E2020202020202020202020202F2F20656E643A206E6F726D616C697A65207873693A74797065206E7320617474726962757465';
wwv_flow_imp.g_varchar2_table(6270) := '2076616C75655C6E202020202020202020207D5C6E5C6E2020202020202020202061747472735B6E616D655D203D2076616C75653B5C6E20202020202020207D5C6E5C6E20202020202020202F2F20656E643A206E6F726D616C697A6520636170747572';
wwv_flow_imp.g_varchar2_table(6271) := '656420617474726962757465735C6E2020202020207D5C6E5C6E20202020202072657475726E206361636865644174747273203D2061747472733B5C6E202020207D5C6E5C6E202020202F2A2A5C6E20202020202A204578747261637420746865207061';
wwv_flow_imp.g_varchar2_table(6272) := '72736520636F6E74657874207B206C696E652C20636F6C756D6E2C2070617274207D5C6E20202020202A2066726F6D207468652063757272656E742070617273657220706F736974696F6E2E5C6E20202020202A5C6E20202020202A204072657475726E';
wwv_flow_imp.g_varchar2_table(6273) := '207B4F626A6563747D20706172736520636F6E746578745C6E20202020202A2F5C6E2020202066756E6374696F6E206765745061727365436F6E746578742829207B5C6E2020202020207661722073706C6974735265203D202F285C5C725C5C6E7C5C5C';
wwv_flow_imp.g_varchar2_table(6274) := '727C5C5C6E292F673B5C6E5C6E202020202020766172206C696E65203D20303B5C6E20202020202076617220636F6C756D6E203D20303B5C6E2020202020207661722073746172744F664C696E65203D20303B5C6E20202020202076617220656E644F66';
wwv_flow_imp.g_varchar2_table(6275) := '4C696E65203D206A3B5C6E202020202020766172206D617463683B5C6E20202020202076617220646174613B5C6E5C6E2020202020207768696C65202869203E3D2073746172744F664C696E6529207B5C6E5C6E20202020202020206D61746368203D20';
wwv_flow_imp.g_varchar2_table(6276) := '73706C69747352652E6578656328786D6C293B5C6E5C6E202020202020202069662028216D6174636829207B5C6E20202020202020202020627265616B3B5C6E20202020202020207D5C6E5C6E20202020202020202F2F20656E64206F66206C696E6520';
wwv_flow_imp.g_varchar2_table(6277) := '3D2028627265616B20696478202B20627265616B206368617273295C6E2020202020202020656E644F664C696E65203D206D617463685B305D2E6C656E677468202B206D617463682E696E6465783B5C6E5C6E202020202020202069662028656E644F66';
wwv_flow_imp.g_varchar2_table(6278) := '4C696E65203E206929207B5C6E20202020202020202020627265616B3B5C6E20202020202020207D5C6E5C6E20202020202020202F2F20616476616E636520746F206E657874206C696E655C6E20202020202020206C696E65202B3D20313B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(6279) := '2020202020202073746172744F664C696E65203D20656E644F664C696E653B5C6E2020202020207D5C6E5C6E2020202020202F2F20454F46206572726F72735C6E2020202020206966202869203D3D202D3129207B5C6E2020202020202020636F6C756D';
wwv_flow_imp.g_varchar2_table(6280) := '6E203D20656E644F664C696E653B5C6E202020202020202064617461203D20786D6C2E737562737472696E67286A293B5C6E2020202020207D20656C73655C6E5C6E2020202020202F2F207374617274206572726F72735C6E202020202020696620286A';
wwv_flow_imp.g_varchar2_table(6281) := '203D3D3D203029207B5C6E202020202020202064617461203D20786D6C2E737562737472696E67286A2C2069293B5C6E2020202020207D5C6E5C6E2020202020202F2F206F74686572206572726F72735C6E202020202020656C7365207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(6282) := '20202020636F6C756D6E203D2069202D2073746172744F664C696E653B5C6E202020202020202064617461203D20286A203D3D202D31203F20786D6C2E737562737472696E67286929203A20786D6C2E737562737472696E6728692C206A202B20312929';
wwv_flow_imp.g_varchar2_table(6283) := '3B5C6E2020202020207D5C6E5C6E20202020202072657475726E207B5C6E20202020202020202764617461273A20646174612C5C6E2020202020202020276C696E65273A206C696E652C5C6E202020202020202027636F6C756D6E273A20636F6C756D6E';
wwv_flow_imp.g_varchar2_table(6284) := '5C6E2020202020207D3B5C6E202020207D5C6E5C6E20202020676574436F6E74657874203D206765745061727365436F6E746578743B5C6E5C6E5C6E202020206966202870726F787929207B5C6E202020202020656C656D656E7450726F7879203D204F';
wwv_flow_imp.g_varchar2_table(6285) := '626A6563742E637265617465287B7D2C207B5C6E2020202020202020276E616D65273A206765747465722866756E6374696F6E2829207B5C6E2020202020202020202072657475726E20656C656D656E744E616D653B5C6E20202020202020207D292C5C';
wwv_flow_imp.g_varchar2_table(6286) := '6E2020202020202020276F726967696E616C4E616D65273A206765747465722866756E6374696F6E2829207B5C6E2020202020202020202072657475726E205F656C656D656E744E616D653B5C6E20202020202020207D292C5C6E202020202020202027';
wwv_flow_imp.g_varchar2_table(6287) := '6174747273273A20676574746572286765744174747273292C5C6E2020202020202020276E73273A206765747465722866756E6374696F6E2829207B5C6E2020202020202020202072657475726E206E734D61747269783B5C6E20202020202020207D29';
wwv_flow_imp.g_varchar2_table(6288) := '5C6E2020202020207D293B5C6E202020207D5C6E5C6E202020202F2F2061637475616C207061727365206C6F6769635C6E202020207768696C6520286A20213D3D202D3129207B5C6E5C6E20202020202069662028786D6C2E63686172436F6465417428';
wwv_flow_imp.g_varchar2_table(6289) := '6A29203D3D3D20363029207B202F2F205C223C5C225C6E202020202020202069203D206A3B5C6E2020202020207D20656C7365207B5C6E202020202020202069203D20786D6C2E696E6465784F6628273C272C206A293B5C6E2020202020207D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(6290) := '2020202020202F2F20706172736520656E645C6E2020202020206966202869203D3D3D202D3129207B5C6E2020202020202020696620286E6F6465537461636B2E6C656E67746829207B5C6E2020202020202020202072657475726E2068616E646C6545';
wwv_flow_imp.g_varchar2_table(6291) := '72726F722827756E657870656374656420656E64206F662066696C6527293B5C6E20202020202020207D5C6E5C6E2020202020202020696620286A203D3D3D203029207B5C6E2020202020202020202072657475726E2068616E646C654572726F722827';
wwv_flow_imp.g_varchar2_table(6292) := '6D697373696E672073746172742074616727293B5C6E20202020202020207D5C6E5C6E2020202020202020696620286A203C20786D6C2E6C656E67746829207B5C6E2020202020202020202069662028786D6C2E737562737472696E67286A292E747269';
wwv_flow_imp.g_varchar2_table(6293) := '6D282929207B5C6E20202020202020202020202068616E646C655761726E696E67284E4F4E5F574849544553504143455F4F5554534944455F524F4F545F4E4F4445293B5C6E202020202020202020207D5C6E20202020202020207D5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(6294) := '2020202072657475726E3B5C6E2020202020207D5C6E5C6E2020202020202F2F20706172736520746578745C6E202020202020696620286A20213D3D206929207B5C6E5C6E2020202020202020696620286E6F6465537461636B2E6C656E67746829207B';
wwv_flow_imp.g_varchar2_table(6295) := '5C6E20202020202020202020696620286F6E5465787429207B5C6E2020202020202020202020206F6E5465787428786D6C2E737562737472696E67286A2C2069292C206465636F6465456E7469746965732C20676574436F6E74657874293B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(6296) := '202020202020202020202069662028706172736553746F7029207B5C6E202020202020202020202020202072657475726E3B5C6E2020202020202020202020207D5C6E202020202020202020207D5C6E20202020202020207D20656C7365207B5C6E2020';
wwv_flow_imp.g_varchar2_table(6297) := '202020202020202069662028786D6C2E737562737472696E67286A2C2069292E7472696D282929207B5C6E20202020202020202020202068616E646C655761726E696E67284E4F4E5F574849544553504143455F4F5554534944455F524F4F545F4E4F44';
wwv_flow_imp.g_varchar2_table(6298) := '45293B5C6E5C6E20202020202020202020202069662028706172736553746F7029207B5C6E202020202020202020202020202072657475726E3B5C6E2020202020202020202020207D5C6E202020202020202020207D5C6E20202020202020207D5C6E20';
wwv_flow_imp.g_varchar2_table(6299) := '20202020207D5C6E5C6E20202020202077203D20786D6C2E63686172436F6465417428692B31293B5C6E5C6E2020202020202F2F20706172736520636F6D6D656E7473202B2043444154415C6E2020202020206966202877203D3D3D20333329207B202F';
wwv_flow_imp.g_varchar2_table(6300) := '2F205C22215C225C6E202020202020202071203D20786D6C2E63686172436F6465417428692B32293B5C6E5C6E20202020202020202F2F2043444154412073656374696F6E5C6E20202020202020206966202871203D3D3D20393120262620786D6C2E73';
wwv_flow_imp.g_varchar2_table(6301) := '75627374722869202B20332C203629203D3D3D202743444154415B2729207B202F2F203931203D3D205C225B5C225C6E202020202020202020206A203D20786D6C2E696E6465784F6628275D5D3E272C2069293B5C6E2020202020202020202069662028';
wwv_flow_imp.g_varchar2_table(6302) := '6A203D3D3D202D3129207B5C6E20202020202020202020202072657475726E2068616E646C654572726F722827756E636C6F73656420636461746127293B5C6E202020202020202020207D5C6E5C6E20202020202020202020696620286F6E4344415441';
wwv_flow_imp.g_varchar2_table(6303) := '29207B5C6E2020202020202020202020206F6E434441544128786D6C2E737562737472696E672869202B20392C206A292C20676574436F6E74657874293B5C6E20202020202020202020202069662028706172736553746F7029207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(6304) := '202020202020202072657475726E3B5C6E2020202020202020202020207D5C6E202020202020202020207D5C6E5C6E202020202020202020206A202B3D20333B5C6E20202020202020202020636F6E74696E75653B5C6E20202020202020207D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(6305) := '20202020202020202F2F20636F6D6D656E745C6E20202020202020206966202871203D3D3D20343520262620786D6C2E63686172436F646541742869202B203329203D3D3D20343529207B202F2F203435203D3D205C222D5C225C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(6306) := '20206A203D20786D6C2E696E6465784F6628272D2D3E272C2069293B5C6E20202020202020202020696620286A203D3D3D202D3129207B5C6E20202020202020202020202072657475726E2068616E646C654572726F722827756E636C6F73656420636F';
wwv_flow_imp.g_varchar2_table(6307) := '6D6D656E7427293B5C6E202020202020202020207D5C6E5C6E5C6E20202020202020202020696620286F6E436F6D6D656E7429207B5C6E2020202020202020202020206F6E436F6D6D656E7428786D6C2E737562737472696E672869202B20342C206A29';
wwv_flow_imp.g_varchar2_table(6308) := '2C206465636F6465456E7469746965732C20676574436F6E74657874293B5C6E20202020202020202020202069662028706172736553746F7029207B5C6E202020202020202020202020202072657475726E3B5C6E2020202020202020202020207D5C6E';
wwv_flow_imp.g_varchar2_table(6309) := '202020202020202020207D5C6E5C6E202020202020202020206A202B3D20333B5C6E20202020202020202020636F6E74696E75653B5C6E20202020202020207D5C6E2020202020207D5C6E5C6E2020202020202F2F207061727365207175657374696F6E';
wwv_flow_imp.g_varchar2_table(6310) := '203C3F202E2E2E203F3E5C6E2020202020206966202877203D3D3D20363329207B202F2F205C223F5C225C6E20202020202020206A203D20786D6C2E696E6465784F6628273F3E272C2069293B5C6E2020202020202020696620286A203D3D3D202D3129';
wwv_flow_imp.g_varchar2_table(6311) := '207B5C6E2020202020202020202072657475726E2068616E646C654572726F722827756E636C6F736564207175657374696F6E27293B5C6E20202020202020207D5C6E5C6E2020202020202020696620286F6E5175657374696F6E29207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(6312) := '2020202020206F6E5175657374696F6E28786D6C2E737562737472696E6728692C206A202B2032292C20676574436F6E74657874293B5C6E2020202020202020202069662028706172736553746F7029207B5C6E20202020202020202020202072657475';
wwv_flow_imp.g_varchar2_table(6313) := '726E3B5C6E202020202020202020207D5C6E20202020202020207D5C6E5C6E20202020202020206A202B3D20323B5C6E2020202020202020636F6E74696E75653B5C6E2020202020207D5C6E5C6E2020202020202F2F2066696E64206D61746368696E67';
wwv_flow_imp.g_varchar2_table(6314) := '20636C6F73696E672074616720666F7220617474656E74696F6E206F72207374616E6461726420746167735C6E2020202020202F2F20666F722074686174207765206D75737420736B6970207468726F756768206174747269627574652076616C756573';
wwv_flow_imp.g_varchar2_table(6315) := '5C6E2020202020202F2F2028656E636C6F73656420696E2073696E676C65206F7220646F75626C652071756F746573295C6E202020202020666F72202878203D2069202B20313B203B20782B2B29207B5C6E202020202020202076203D20786D6C2E6368';
wwv_flow_imp.g_varchar2_table(6316) := '6172436F646541742878293B5C6E20202020202020206966202869734E614E28762929207B5C6E202020202020202020206A203D202D313B5C6E2020202020202020202072657475726E2068616E646C654572726F722827756E636C6F73656420746167';
wwv_flow_imp.g_varchar2_table(6317) := '27293B5C6E20202020202020207D5C6E5C6E20202020202020202F2F205B31305D2041747456616C7565203A3A3D20275C222720285B5E3C265C225D207C205265666572656E6365292A20275C2227207C205C22275C2220285B5E3C26275D207C205265';
wwv_flow_imp.g_varchar2_table(6318) := '666572656E6365292A205C22275C225C6E20202020202020202F2F20736B697073207468652071756F74656420737472696E675C6E20202020202020202F2F2028646F75626C652071756F7465732920646F6573206E6F742061707065617220696E2061';
wwv_flow_imp.g_varchar2_table(6319) := '206C69746572616C20656E636C6F7365642062792028646F75626C652071756F746573295C6E20202020202020202F2F202873696E676C652071756F74652920646F6573206E6F742061707065617220696E2061206C69746572616C20656E636C6F7365';
wwv_flow_imp.g_varchar2_table(6320) := '64206279202873696E676C652071756F7465295C6E20202020202020206966202876203D3D3D20333429207B202F2F2020275C22275C6E2020202020202020202071203D20786D6C2E696E6465784F6628275C22272C2078202B2031293B5C6E20202020';
wwv_flow_imp.g_varchar2_table(6321) := '20202020202078203D207120213D3D202D31203F2071203A20783B5C6E20202020202020207D20656C7365206966202876203D3D3D20333929207B202F2F205C22275C225C6E2020202020202020202071203D20786D6C2E696E6465784F66285C22275C';
wwv_flow_imp.g_varchar2_table(6322) := '222C2078202B2031293B5C6E2020202020202020202078203D207120213D3D202D31203F2071203A20783B5C6E20202020202020207D20656C7365206966202876203D3D3D20363229207B202F2F20273E275C6E202020202020202020206A203D20783B';
wwv_flow_imp.g_varchar2_table(6323) := '5C6E20202020202020202020627265616B3B5C6E20202020202020207D5C6E2020202020207D5C6E5C6E5C6E2020202020202F2F20706172736520617474656E74696F6E203C21202E2E2E3E5C6E2020202020202F2F2070726576696F75736C7920636F';
wwv_flow_imp.g_varchar2_table(6324) := '6D6D656E7420616E64204344415441206861766520616C7265616479206265656E207061727365645C6E2020202020206966202877203D3D3D20333329207B202F2F205C22215C225C6E5C6E2020202020202020696620286F6E417474656E74696F6E29';
wwv_flow_imp.g_varchar2_table(6325) := '207B5C6E202020202020202020206F6E417474656E74696F6E28786D6C2E737562737472696E6728692C206A202B2031292C206465636F6465456E7469746965732C20676574436F6E74657874293B5C6E20202020202020202020696620287061727365';
wwv_flow_imp.g_varchar2_table(6326) := '53746F7029207B5C6E20202020202020202020202072657475726E3B5C6E202020202020202020207D5C6E20202020202020207D5C6E5C6E20202020202020206A202B3D20313B5C6E2020202020202020636F6E74696E75653B5C6E2020202020207D5C';
wwv_flow_imp.g_varchar2_table(6327) := '6E5C6E2020202020202F2F20646F6E27742070726F6365737320617474726962757465733B5C6E2020202020202F2F20746865726520617265206E6F6E655C6E2020202020206361636865644174747273203D207B7D3B5C6E5C6E2020202020202F2F20';
wwv_flow_imp.g_varchar2_table(6328) := '69662028786D6C2E63686172436F6465417428692B3129203D3D3D20343729207B202F2F203C2F2E2E2E5C6E2020202020206966202877203D3D3D20343729207B202F2F203C2F2E2E2E5C6E20202020202020207461675374617274203D2066616C7365';
wwv_flow_imp.g_varchar2_table(6329) := '3B5C6E2020202020202020746167456E64203D20747275653B5C6E5C6E202020202020202069662028216E6F6465537461636B2E6C656E67746829207B5C6E2020202020202020202072657475726E2068616E646C654572726F7228276D697373696E67';
wwv_flow_imp.g_varchar2_table(6330) := '206F70656E2074616727293B5C6E20202020202020207D5C6E5C6E20202020202020202F2F20766572696679206F70656E203C2D3E20636C6F736520746167206D617463685C6E202020202020202078203D20656C656D656E744E616D65203D206E6F64';
wwv_flow_imp.g_varchar2_table(6331) := '65537461636B2E706F7028293B5C6E202020202020202071203D2069202B2032202B20782E6C656E6774683B5C6E5C6E202020202020202069662028786D6C2E737562737472696E672869202B20322C20712920213D3D207829207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(6332) := '2020202072657475726E2068616E646C654572726F722827636C6F73696E6720746167206D69736D6174636827293B5C6E20202020202020207D5C6E5C6E20202020202020202F2F2076657269667920636861727320696E20636C6F7365207461675C6E';
wwv_flow_imp.g_varchar2_table(6333) := '2020202020202020666F7220283B2071203C206A3B20712B2B29207B5C6E2020202020202020202077203D20786D6C2E63686172436F646541742871293B5C6E5C6E202020202020202020206966202877203D3D3D203332207C7C202877203E20382026';
wwv_flow_imp.g_varchar2_table(6334) := '262077203C2031342929207B202F2F205C5C665C5C6E5C5C725C5C745C5C762073706163655C6E202020202020202020202020636F6E74696E75653B5C6E202020202020202020207D5C6E5C6E2020202020202020202072657475726E2068616E646C65';
wwv_flow_imp.g_varchar2_table(6335) := '4572726F722827636C6F73652074616727293B5C6E20202020202020207D5C6E5C6E2020202020207D20656C7365207B5C6E202020202020202069662028786D6C2E63686172436F64654174286A202D203129203D3D3D20343729207B202F2F202E2E2E';
wwv_flow_imp.g_varchar2_table(6336) := '2F3E5C6E2020202020202020202078203D20656C656D656E744E616D65203D20786D6C2E737562737472696E672869202B20312C206A202D2031293B5C6E5C6E202020202020202020207461675374617274203D20747275653B5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(6337) := '2020746167456E64203D20747275653B5C6E5C6E20202020202020207D20656C7365207B5C6E2020202020202020202078203D20656C656D656E744E616D65203D20786D6C2E737562737472696E672869202B20312C206A293B5C6E5C6E202020202020';
wwv_flow_imp.g_varchar2_table(6338) := '202020207461675374617274203D20747275653B5C6E20202020202020202020746167456E64203D2066616C73653B5C6E20202020202020207D5C6E5C6E202020202020202069662028212877203E2039362026262077203C20313233207C7C2077203E';
wwv_flow_imp.g_varchar2_table(6339) := '2036342026262077203C203931207C7C2077203D3D3D203935207C7C2077203D3D3D2035382929207B202F2F20636861722039355C225F5C222035385C223A5C225C6E2020202020202020202072657475726E2068616E646C654572726F722827696C6C';
wwv_flow_imp.g_varchar2_table(6340) := '6567616C2066697273742063686172206E6F64654E616D6527293B5C6E20202020202020207D5C6E5C6E2020202020202020666F72202871203D20312C2079203D20782E6C656E6774683B2071203C20793B20712B2B29207B5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(6341) := '2077203D20782E63686172436F646541742871293B5C6E5C6E202020202020202020206966202877203E2039362026262077203C20313233207C7C2077203E2036342026262077203C203931207C7C2077203E2034372026262077203C203539207C7C20';
wwv_flow_imp.g_varchar2_table(6342) := '77203D3D3D203435207C7C2077203D3D3D203935207C7C2077203D3D20343629207B5C6E202020202020202020202020636F6E74696E75653B5C6E202020202020202020207D5C6E5C6E202020202020202020206966202877203D3D3D203332207C7C20';
wwv_flow_imp.g_varchar2_table(6343) := '2877203C2031342026262077203E20382929207B202F2F205C5C665C5C6E5C5C725C5C745C5C762073706163655C6E202020202020202020202020656C656D656E744E616D65203D20782E737562737472696E6728302C2071293B5C6E5C6E2020202020';
wwv_flow_imp.g_varchar2_table(6344) := '202020202020202F2F206D617962652074686572652061726520617474726962757465735C6E2020202020202020202020206361636865644174747273203D206E756C6C3B5C6E202020202020202020202020627265616B3B5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(6345) := '207D5C6E5C6E2020202020202020202072657475726E2068616E646C654572726F722827696E76616C6964206E6F64654E616D6527293B5C6E20202020202020207D5C6E5C6E20202020202020206966202821746167456E6429207B5C6E202020202020';
wwv_flow_imp.g_varchar2_table(6346) := '202020206E6F6465537461636B2E7075736828656C656D656E744E616D65293B5C6E20202020202020207D5C6E2020202020207D5C6E5C6E2020202020206966202869734E616D65737061636529207B5C6E5C6E20202020202020205F6E734D61747269';
wwv_flow_imp.g_varchar2_table(6347) := '78203D206E734D61747269783B5C6E5C6E202020202020202069662028746167537461727429207B5C6E5C6E202020202020202020202F2F2072656D656D626572206F6C64206E616D6573706163655C6E202020202020202020202F2F20756E6C657373';
wwv_flow_imp.g_varchar2_table(6348) := '2077652772652073656C662D636C6F73696E675C6E202020202020202020206966202821746167456E6429207B5C6E2020202020202020202020206E734D6174726978537461636B2E70757368285F6E734D6174726978293B5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(6349) := '207D5C6E5C6E20202020202020202020696620286361636865644174747273203D3D3D206E756C6C29207B5C6E5C6E2020202020202020202020202F2F20717569636B20636865636B2C2077686574686572207468657265206D6179206265206E616D65';
wwv_flow_imp.g_varchar2_table(6350) := '73706163655C6E2020202020202020202020202F2F206465636C61726174696F6E73206F6E20746865206E6F64653B20696620746861742069732074686520636173655C6E2020202020202020202020202F2F207765206E65656420746F206561676572';
wwv_flow_imp.g_varchar2_table(6351) := '6C7920706172736520746865206E6F646520617474726962757465735C6E20202020202020202020202069662028286D617962654E53203D20782E696E6465784F662827786D6C6E73272C20712920213D3D202D312929207B5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(6352) := '202020202061747472735374617274203D20713B5C6E20202020202020202020202020206174747273537472696E67203D20783B5C6E5C6E2020202020202020202020202020676574417474727328293B5C6E5C6E20202020202020202020202020206D';
wwv_flow_imp.g_varchar2_table(6353) := '617962654E53203D2066616C73653B5C6E2020202020202020202020207D5C6E202020202020202020207D5C6E20202020202020207D5C6E5C6E20202020202020205F656C656D656E744E616D65203D20656C656D656E744E616D653B5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(6354) := '202020202077203D20656C656D656E744E616D652E696E6465784F6628273A27293B5C6E2020202020202020696620287720213D3D202D3129207B5C6E20202020202020202020786D6C6E73203D206E734D61747269785B656C656D656E744E616D652E';
wwv_flow_imp.g_varchar2_table(6355) := '737562737472696E6728302C2077295D3B5C6E5C6E202020202020202020202F2F2070726566697820676976656E3B206E616D657370616365206D7573742065786973745C6E202020202020202020206966202821786D6C6E7329207B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(6356) := '2020202020202072657475726E2068616E646C654572726F7228276D697373696E67206E616D657370616365206F6E203C27202B205F656C656D656E744E616D65202B20273E27293B5C6E202020202020202020207D5C6E5C6E20202020202020202020';
wwv_flow_imp.g_varchar2_table(6357) := '656C656D656E744E616D65203D20656C656D656E744E616D652E7375627374722877202B2031293B5C6E20202020202020207D20656C7365207B5C6E20202020202020202020786D6C6E73203D206E734D61747269785B27786D6C6E73275D3B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(6358) := '202020202020202020202F2F206966206E6F2064656661756C74206E616D65737061636520697320646566696E65642C5C6E202020202020202020202F2F207765276C6C20696D706F72742074686520656C656D656E7420617320616E6F6E796D6F7573';
wwv_flow_imp.g_varchar2_table(6359) := '2E5C6E202020202020202020202F2F5C6E202020202020202020202F2F20697420697320757020746F20757365727320746F20636F7272656374207468617420746F2074686520646F63756D656E7420646566696E65645C6E202020202020202020202F';
wwv_flow_imp.g_varchar2_table(6360) := '2F207461726765744E616D6573706163652C206F7220776861746576657220746865697220756E64657273616E64696E67206F66207468655C6E202020202020202020202F2F20584D4C2073706563206D616E64617465732E5C6E20202020202020207D';
wwv_flow_imp.g_varchar2_table(6361) := '5C6E5C6E20202020202020202F2F2061646A757374206E616D657370616365207072656669787320617320636F6E666967757265645C6E202020202020202069662028786D6C6E7329207B5C6E20202020202020202020656C656D656E744E616D65203D';
wwv_flow_imp.g_varchar2_table(6362) := '20786D6C6E73202B20273A27202B20656C656D656E744E616D653B5C6E20202020202020207D5C6E5C6E2020202020207D5C6E5C6E20202020202069662028746167537461727429207B5C6E202020202020202061747472735374617274203D20713B5C';
wwv_flow_imp.g_varchar2_table(6363) := '6E20202020202020206174747273537472696E67203D20783B5C6E5C6E2020202020202020696620286F6E4F70656E54616729207B5C6E202020202020202020206966202870726F787929207B5C6E2020202020202020202020206F6E4F70656E546167';
wwv_flow_imp.g_varchar2_table(6364) := '28656C656D656E7450726F78792C206465636F6465456E7469746965732C20746167456E642C20676574436F6E74657874293B5C6E202020202020202020207D20656C7365207B5C6E2020202020202020202020206F6E4F70656E54616728656C656D65';
wwv_flow_imp.g_varchar2_table(6365) := '6E744E616D652C2067657441747472732C206465636F6465456E7469746965732C20746167456E642C20676574436F6E74657874293B5C6E202020202020202020207D5C6E5C6E2020202020202020202069662028706172736553746F7029207B5C6E20';
wwv_flow_imp.g_varchar2_table(6366) := '202020202020202020202072657475726E3B5C6E202020202020202020207D5C6E20202020202020207D5C6E5C6E2020202020207D5C6E5C6E20202020202069662028746167456E6429207B5C6E5C6E2020202020202020696620286F6E436C6F736554';
wwv_flow_imp.g_varchar2_table(6367) := '616729207B5C6E202020202020202020206F6E436C6F73655461672870726F7879203F20656C656D656E7450726F7879203A20656C656D656E744E616D652C206465636F6465456E7469746965732C2074616753746172742C20676574436F6E74657874';
wwv_flow_imp.g_varchar2_table(6368) := '293B5C6E5C6E2020202020202020202069662028706172736553746F7029207B5C6E20202020202020202020202072657475726E3B5C6E202020202020202020207D5C6E20202020202020207D5C6E5C6E20202020202020202F2F20726573746F726520';
wwv_flow_imp.g_varchar2_table(6369) := '6F6C64206E616D6573706163655C6E20202020202020206966202869734E616D65737061636529207B5C6E202020202020202020206966202821746167537461727429207B5C6E2020202020202020202020206E734D6174726978203D206E734D617472';
wwv_flow_imp.g_varchar2_table(6370) := '6978537461636B2E706F7028293B5C6E202020202020202020207D20656C7365207B5C6E2020202020202020202020206E734D6174726978203D205F6E734D61747269783B5C6E202020202020202020207D5C6E20202020202020207D5C6E2020202020';
wwv_flow_imp.g_varchar2_table(6371) := '207D5C6E5C6E2020202020206A202B3D20313B5C6E202020207D5C6E20207D202F2A2A20656E64207061727365202A2F5C6E5C6E7D5C6E5C6E6578706F7274207B205061727365722C206465636F6465456E746974696573206173206465636F6465207D';
wwv_flow_imp.g_varchar2_table(6372) := '3B5C6E222C2266756E6374696F6E20656E73757265496D706F7274656428656C656D656E742C2074617267657429207B5C6E5C6E202069662028656C656D656E742E6F776E6572446F63756D656E7420213D3D207461726765742E6F776E6572446F6375';
wwv_flow_imp.g_varchar2_table(6373) := '6D656E7429207B5C6E20202020747279207B5C6E5C6E2020202020202F2F206D6179206661696C206F6E207765626B69745C6E20202020202072657475726E207461726765742E6F776E6572446F63756D656E742E696D706F72744E6F646528656C656D';
wwv_flow_imp.g_varchar2_table(6374) := '656E742C2074727565293B5C6E202020207D20636174636820286529207B5C6E5C6E2020202020202F2F2069676E6F72655C6E202020207D5C6E20207D5C6E5C6E202072657475726E20656C656D656E743B5C6E7D5C6E5C6E2F2A2A5C6E202A20617070';
wwv_flow_imp.g_varchar2_table(6375) := '656E64546F207574696C6974795C6E202A2F5C6E5C6E5C6E2F2A2A5C6E202A20417070656E642061206E6F646520746F20612074617267657420656C656D656E7420616E642072657475726E2074686520617070656E646564206E6F64652E5C6E202A5C';
wwv_flow_imp.g_varchar2_table(6376) := '6E202A2040706172616D20207B535647456C656D656E747D20656C656D656E745C6E202A2040706172616D20207B535647456C656D656E747D207461726765745C6E202A5C6E202A204072657475726E207B535647456C656D656E747D20746865206170';
wwv_flow_imp.g_varchar2_table(6377) := '70656E646564206E6F64655C6E202A2F5C6E66756E6374696F6E20617070656E64546F28656C656D656E742C2074617267657429207B5C6E202072657475726E207461726765742E617070656E644368696C6428656E73757265496D706F727465642865';
wwv_flow_imp.g_varchar2_table(6378) := '6C656D656E742C2074617267657429293B5C6E7D5C6E5C6E2F2A2A5C6E202A20617070656E64207574696C6974795C6E202A2F5C6E5C6E5C6E2F2A2A5C6E202A20417070656E642061206E6F646520746F20616E20656C656D656E745C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(6379) := '2040706172616D20207B535647456C656D656E747D20656C656D656E745C6E202A2040706172616D20207B535647456C656D656E747D206E6F64655C6E202A5C6E202A204072657475726E207B535647456C656D656E747D2074686520656C656D656E74';
wwv_flow_imp.g_varchar2_table(6380) := '5C6E202A2F5C6E66756E6374696F6E20617070656E64287461726765742C206E6F646529207B5C6E2020617070656E64546F286E6F64652C20746172676574293B5C6E202072657475726E207461726765743B5C6E7D5C6E5C6E2F2A2A5C6E202A206174';
wwv_flow_imp.g_varchar2_table(6381) := '74726962757465206163636573736F72207574696C6974795C6E202A2F5C6E5C6E766172204C454E4754485F41545452203D20323B5C6E5C6E766172204353535F50524F50455254494553203D207B5C6E202027616C69676E6D656E742D626173656C69';
wwv_flow_imp.g_varchar2_table(6382) := '6E65273A20312C5C6E202027626173656C696E652D7368696674273A20312C5C6E202027636C6970273A20312C5C6E202027636C69702D70617468273A20312C5C6E202027636C69702D72756C65273A20312C5C6E202027636F6C6F72273A20312C5C6E';
wwv_flow_imp.g_varchar2_table(6383) := '202027636F6C6F722D696E746572706F6C6174696F6E273A20312C5C6E202027636F6C6F722D696E746572706F6C6174696F6E2D66696C74657273273A20312C5C6E202027636F6C6F722D70726F66696C65273A20312C5C6E202027636F6C6F722D7265';
wwv_flow_imp.g_varchar2_table(6384) := '6E646572696E67273A20312C5C6E202027637572736F72273A20312C5C6E202027646972656374696F6E273A20312C5C6E202027646973706C6179273A20312C5C6E202027646F6D696E616E742D626173656C696E65273A20312C5C6E202027656E6162';
wwv_flow_imp.g_varchar2_table(6385) := '6C652D6261636B67726F756E64273A20312C5C6E20202766696C6C273A20312C5C6E20202766696C6C2D6F706163697479273A20312C5C6E20202766696C6C2D72756C65273A20312C5C6E20202766696C746572273A20312C5C6E202027666C6F6F642D';
wwv_flow_imp.g_varchar2_table(6386) := '636F6C6F72273A20312C5C6E202027666C6F6F642D6F706163697479273A20312C5C6E202027666F6E74273A20312C5C6E202027666F6E742D66616D696C79273A20312C5C6E202027666F6E742D73697A65273A204C454E4754485F415454522C5C6E20';
wwv_flow_imp.g_varchar2_table(6387) := '2027666F6E742D73697A652D61646A757374273A20312C5C6E202027666F6E742D73747265746368273A20312C5C6E202027666F6E742D7374796C65273A20312C5C6E202027666F6E742D76617269616E74273A20312C5C6E202027666F6E742D776569';
wwv_flow_imp.g_varchar2_table(6388) := '676874273A20312C5C6E202027676C7970682D6F7269656E746174696F6E2D686F72697A6F6E74616C273A20312C5C6E202027676C7970682D6F7269656E746174696F6E2D766572746963616C273A20312C5C6E202027696D6167652D72656E64657269';
wwv_flow_imp.g_varchar2_table(6389) := '6E67273A20312C5C6E2020276B65726E696E67273A20312C5C6E2020276C65747465722D73706163696E67273A20312C5C6E2020276C69676874696E672D636F6C6F72273A20312C5C6E2020276D61726B6572273A20312C5C6E2020276D61726B65722D';
wwv_flow_imp.g_varchar2_table(6390) := '656E64273A20312C5C6E2020276D61726B65722D6D6964273A20312C5C6E2020276D61726B65722D7374617274273A20312C5C6E2020276D61736B273A20312C5C6E2020276F706163697479273A20312C5C6E2020276F766572666C6F77273A20312C5C';
wwv_flow_imp.g_varchar2_table(6391) := '6E202027706F696E7465722D6576656E7473273A20312C5C6E20202773686170652D72656E646572696E67273A20312C5C6E20202773746F702D636F6C6F72273A20312C5C6E20202773746F702D6F706163697479273A20312C5C6E2020277374726F6B';
wwv_flow_imp.g_varchar2_table(6392) := '65273A20312C5C6E2020277374726F6B652D646173686172726179273A20312C5C6E2020277374726F6B652D646173686F6666736574273A20312C5C6E2020277374726F6B652D6C696E65636170273A20312C5C6E2020277374726F6B652D6C696E656A';
wwv_flow_imp.g_varchar2_table(6393) := '6F696E273A20312C5C6E2020277374726F6B652D6D697465726C696D6974273A20312C5C6E2020277374726F6B652D6F706163697479273A20312C5C6E2020277374726F6B652D7769647468273A204C454E4754485F415454522C5C6E20202774657874';
wwv_flow_imp.g_varchar2_table(6394) := '2D616E63686F72273A20312C5C6E202027746578742D6465636F726174696F6E273A20312C5C6E202027746578742D72656E646572696E67273A20312C5C6E202027756E69636F64652D62696469273A20312C5C6E2020277669736962696C697479273A';
wwv_flow_imp.g_varchar2_table(6395) := '20312C5C6E202027776F72642D73706163696E67273A20312C5C6E20202777726974696E672D6D6F6465273A20315C6E7D3B5C6E5C6E5C6E66756E6374696F6E20676574417474726962757465286E6F64652C206E616D6529207B5C6E20206966202843';
wwv_flow_imp.g_varchar2_table(6396) := '53535F50524F504552544945535B6E616D655D29207B5C6E2020202072657475726E206E6F64652E7374796C655B6E616D655D3B5C6E20207D20656C7365207B5C6E2020202072657475726E206E6F64652E6765744174747269627574654E53286E756C';
wwv_flow_imp.g_varchar2_table(6397) := '6C2C206E616D65293B5C6E20207D5C6E7D5C6E5C6E66756E6374696F6E20736574417474726962757465286E6F64652C206E616D652C2076616C756529207B5C6E20207661722068797068656E61746564203D206E616D652E7265706C616365282F285B';
wwv_flow_imp.g_varchar2_table(6398) := '612D7A5D29285B412D5A5D292F672C202724312D243227292E746F4C6F7765724361736528293B5C6E5C6E20207661722074797065203D204353535F50524F504552544945535B68797068656E617465645D3B5C6E5C6E2020696620287479706529207B';
wwv_flow_imp.g_varchar2_table(6399) := '5C6E5C6E202020202F2F20617070656E6420706978656C20756E69742C20756E6C6573732070726573656E745C6E202020206966202874797065203D3D3D204C454E4754485F4154545220262620747970656F662076616C7565203D3D3D20276E756D62';
wwv_flow_imp.g_varchar2_table(6400) := '65722729207B5C6E20202020202076616C7565203D20537472696E672876616C756529202B20277078273B5C6E202020207D5C6E5C6E202020206E6F64652E7374796C655B68797068656E617465645D203D2076616C75653B5C6E20207D20656C736520';
wwv_flow_imp.g_varchar2_table(6401) := '7B5C6E202020206E6F64652E7365744174747269627574654E53286E756C6C2C206E616D652C2076616C7565293B5C6E20207D5C6E7D5C6E5C6E66756E6374696F6E2073657441747472696275746573286E6F64652C20617474727329207B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(6402) := '20766172206E616D6573203D204F626A6563742E6B657973286174747273292C20692C206E616D653B5C6E5C6E2020666F72202869203D20302C206E616D653B20286E616D65203D206E616D65735B695D293B20692B2B29207B5C6E2020202073657441';
wwv_flow_imp.g_varchar2_table(6403) := '7474726962757465286E6F64652C206E616D652C2061747472735B6E616D655D293B5C6E20207D5C6E7D5C6E5C6E2F2A2A5C6E202A2047657473206F722073657473207261772061747472696275746573206F6E2061206E6F64652E5C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(6404) := '2040706172616D20207B535647456C656D656E747D206E6F64655C6E202A2040706172616D20207B4F626A6563747D205B61747472735D5C6E202A2040706172616D20207B537472696E677D205B6E616D655D5C6E202A2040706172616D20207B537472';
wwv_flow_imp.g_varchar2_table(6405) := '696E677D205B76616C75655D5C6E202A5C6E202A204072657475726E207B537472696E677D5C6E202A2F5C6E66756E6374696F6E2061747472286E6F64652C206E616D652C2076616C756529207B5C6E202069662028747970656F66206E616D65203D3D';
wwv_flow_imp.g_varchar2_table(6406) := '3D2027737472696E672729207B5C6E202020206966202876616C756520213D3D20756E646566696E656429207B5C6E202020202020736574417474726962757465286E6F64652C206E616D652C2076616C7565293B5C6E202020207D20656C7365207B5C';
wwv_flow_imp.g_varchar2_table(6407) := '6E20202020202072657475726E20676574417474726962757465286E6F64652C206E616D65293B5C6E202020207D5C6E20207D20656C7365207B5C6E2020202073657441747472696275746573286E6F64652C206E616D65293B5C6E20207D5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(6408) := '2072657475726E206E6F64653B5C6E7D5C6E5C6E2F2A2A5C725C6E202A2054616B656E2066726F6D2068747470733A2F2F6769746875622E636F6D2F636F6D706F6E656E742F636C61737365735C725C6E202A5C725C6E202A20576974686F7574207468';
wwv_flow_imp.g_varchar2_table(6409) := '6520636F6D706F6E656E7420626974732E5C725C6E202A2F5C725C6E5C725C6E2F2A2A5C725C6E202A20746F537472696E67207265666572656E63652E5C725C6E202A2F5C725C6E5C725C6E636F6E737420746F537472696E67203D204F626A6563742E';
wwv_flow_imp.g_varchar2_table(6410) := '70726F746F747970652E746F537472696E673B5C725C6E5C725C6E2F2A2A5C725C6E20202A20577261702060656C6020696E20612060436C6173734C697374602E5C725C6E20202A5C725C6E20202A2040706172616D207B456C656D656E747D20656C5C';
wwv_flow_imp.g_varchar2_table(6411) := '725C6E20202A204072657475726E207B436C6173734C6973747D5C725C6E20202A2040617069207075626C69635C725C6E20202A2F5C725C6E5C725C6E66756E6374696F6E20636C617373657328656C29207B5C725C6E202072657475726E206E657720';
wwv_flow_imp.g_varchar2_table(6412) := '436C6173734C69737428656C293B5C725C6E7D5C725C6E5C725C6E66756E6374696F6E20436C6173734C69737428656C29207B5C725C6E20206966202821656C207C7C2021656C2E6E6F64655479706529207B5C725C6E202020207468726F77206E6577';
wwv_flow_imp.g_varchar2_table(6413) := '204572726F7228274120444F4D20656C656D656E74207265666572656E636520697320726571756972656427293B5C725C6E20207D5C725C6E2020746869732E656C203D20656C3B5C725C6E2020746869732E6C697374203D20656C2E636C6173734C69';
wwv_flow_imp.g_varchar2_table(6414) := '73743B5C725C6E7D5C725C6E5C725C6E2F2A2A5C725C6E20202A2041646420636C61737320606E616D6560206966206E6F7420616C72656164792070726573656E742E5C725C6E20202A5C725C6E20202A2040706172616D207B537472696E677D206E61';
wwv_flow_imp.g_varchar2_table(6415) := '6D655C725C6E20202A204072657475726E207B436C6173734C6973747D5C725C6E20202A2040617069207075626C69635C725C6E20202A2F5C725C6E5C725C6E436C6173734C6973742E70726F746F747970652E616464203D2066756E6374696F6E286E';
wwv_flow_imp.g_varchar2_table(6416) := '616D6529207B5C725C6E2020746869732E6C6973742E616464286E616D65293B5C725C6E202072657475726E20746869733B5C725C6E7D3B5C725C6E5C725C6E2F2A2A5C725C6E20202A2052656D6F766520636C61737320606E616D6560207768656E20';
wwv_flow_imp.g_varchar2_table(6417) := '70726573656E742C206F725C725C6E20202A2070617373206120726567756C61722065787072657373696F6E20746F2072656D6F76655C725C6E20202A20616E79207768696368206D617463682E5C725C6E20202A5C725C6E20202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(6418) := '7B537472696E677C5265674578707D206E616D655C725C6E20202A204072657475726E207B436C6173734C6973747D5C725C6E20202A2040617069207075626C69635C725C6E20202A2F5C725C6E5C725C6E436C6173734C6973742E70726F746F747970';
wwv_flow_imp.g_varchar2_table(6419) := '652E72656D6F7665203D2066756E6374696F6E286E616D6529207B5C725C6E202069662028275B6F626A656374205265674578705D27203D3D20746F537472696E672E63616C6C286E616D652929207B5C725C6E2020202072657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(6420) := '72656D6F76654D61746368696E67286E616D65293B5C725C6E20207D5C725C6E5C725C6E2020746869732E6C6973742E72656D6F7665286E616D65293B5C725C6E202072657475726E20746869733B5C725C6E7D3B5C725C6E5C725C6E2F2A2A5C725C6E';
wwv_flow_imp.g_varchar2_table(6421) := '20202A2052656D6F766520616C6C20636C6173736573206D61746368696E6720607265602E5C725C6E20202A5C725C6E20202A2040706172616D207B5265674578707D2072655C725C6E20202A204072657475726E207B436C6173734C6973747D5C725C';
wwv_flow_imp.g_varchar2_table(6422) := '6E20202A204061706920707269766174655C725C6E20202A2F5C725C6E5C725C6E436C6173734C6973742E70726F746F747970652E72656D6F76654D61746368696E67203D2066756E6374696F6E28726529207B5C725C6E2020636F6E73742061727220';
wwv_flow_imp.g_varchar2_table(6423) := '3D20746869732E617272617928293B5C725C6E2020666F7220286C65742069203D20303B2069203C206172722E6C656E6774683B20692B2B29207B5C725C6E202020206966202872652E74657374286172725B695D2929207B5C725C6E20202020202074';
wwv_flow_imp.g_varchar2_table(6424) := '6869732E72656D6F7665286172725B695D293B5C725C6E202020207D5C725C6E20207D5C725C6E202072657475726E20746869733B5C725C6E7D3B5C725C6E5C725C6E2F2A2A5C725C6E20202A20546F67676C6520636C61737320606E616D65602C2063';
wwv_flow_imp.g_varchar2_table(6425) := '616E20666F726365207374617465207669612060666F726365602E5C725C6E20202A5C725C6E20202A20466F722062726F7773657273207468617420737570706F727420636C6173734C6973742C2062757420646F206E6F7420737570706F7274206066';
wwv_flow_imp.g_varchar2_table(6426) := '6F72636560207965742C5C725C6E20202A20746865206D697374616B652077696C6C20626520646574656374656420616E6420636F727265637465642E5C725C6E20202A5C725C6E20202A2040706172616D207B537472696E677D206E616D655C725C6E';
wwv_flow_imp.g_varchar2_table(6427) := '20202A2040706172616D207B426F6F6C65616E7D20666F7263655C725C6E20202A204072657475726E207B436C6173734C6973747D5C725C6E20202A2040617069207075626C69635C725C6E20202A2F5C725C6E5C725C6E436C6173734C6973742E7072';
wwv_flow_imp.g_varchar2_table(6428) := '6F746F747970652E746F67676C65203D2066756E6374696F6E286E616D652C20666F72636529207B5C725C6E20206966202827756E646566696E65642720213D3D20747970656F6620666F72636529207B5C725C6E2020202069662028666F7263652021';
wwv_flow_imp.g_varchar2_table(6429) := '3D3D20746869732E6C6973742E746F67676C65286E616D652C20666F7263652929207B5C725C6E202020202020746869732E6C6973742E746F67676C65286E616D65293B202F2F20746F67676C6520616761696E20746F20636F72726563745C725C6E20';
wwv_flow_imp.g_varchar2_table(6430) := '2020207D5C725C6E20207D20656C7365207B5C725C6E20202020746869732E6C6973742E746F67676C65286E616D65293B5C725C6E20207D5C725C6E202072657475726E20746869733B5C725C6E7D3B5C725C6E5C725C6E2F2A2A5C725C6E20202A2052';
wwv_flow_imp.g_varchar2_table(6431) := '657475726E20616E206172726179206F6620636C61737365732E5C725C6E20202A5C725C6E20202A204072657475726E207B41727261797D5C725C6E20202A2040617069207075626C69635C725C6E20202A2F5C725C6E5C725C6E436C6173734C697374';
wwv_flow_imp.g_varchar2_table(6432) := '2E70726F746F747970652E6172726179203D2066756E6374696F6E2829207B5C725C6E202072657475726E2041727261792E66726F6D28746869732E6C697374293B5C725C6E7D3B5C725C6E5C725C6E2F2A2A5C725C6E20202A20436865636B20696620';
wwv_flow_imp.g_varchar2_table(6433) := '636C61737320606E616D65602069732070726573656E742E5C725C6E20202A5C725C6E20202A2040706172616D207B537472696E677D206E616D655C725C6E20202A204072657475726E207B436C6173734C6973747D5C725C6E20202A20406170692070';
wwv_flow_imp.g_varchar2_table(6434) := '75626C69635C725C6E20202A2F5C725C6E5C725C6E436C6173734C6973742E70726F746F747970652E686173203D5C725C6E20436C6173734C6973742E70726F746F747970652E636F6E7461696E73203D2066756E6374696F6E286E616D6529207B5C72';
wwv_flow_imp.g_varchar2_table(6435) := '5C6E20202072657475726E20746869732E6C6973742E636F6E7461696E73286E616D65293B5C725C6E207D3B5C6E5C6E2F2A2A5C6E202A20436C656172207574696C6974795C6E202A2F5C6E5C6E2F2A2A5C6E202A2052656D6F76657320616C6C206368';
wwv_flow_imp.g_varchar2_table(6436) := '696C6472656E2066726F6D2074686520676976656E20656C656D656E745C6E202A5C6E202A2040706172616D20207B535647456C656D656E747D20656C656D656E745C6E202A204072657475726E207B456C656D656E747D2074686520656C656D656E74';
wwv_flow_imp.g_varchar2_table(6437) := '2028666F7220636861696E696E67295C6E202A2F5C6E66756E6374696F6E20636C65617228656C656D656E7429207B5C6E2020766172206368696C643B5C6E5C6E20207768696C652028286368696C64203D20656C656D656E742E66697273744368696C';
wwv_flow_imp.g_varchar2_table(6438) := '642929207B5C6E20202020656C656D656E742E72656D6F76654368696C64286368696C64293B5C6E20207D5C6E5C6E202072657475726E20656C656D656E743B5C6E7D5C6E5C6E66756E6374696F6E20636C6F6E6528656C656D656E7429207B5C6E2020';
wwv_flow_imp.g_varchar2_table(6439) := '72657475726E20656C656D656E742E636C6F6E654E6F64652874727565293B5C6E7D5C6E5C6E766172206E73203D207B5C6E20207376673A2027687474703A2F2F7777772E77332E6F72672F323030302F737667275C6E7D3B5C6E5C6E2F2A2A5C6E202A';
wwv_flow_imp.g_varchar2_table(6440) := '20444F4D2070617273696E67207574696C6974795C6E202A2F5C6E5C6E5C6E766172205356475F5354415254203D20273C73766720786D6C6E733D5C2227202B206E732E737667202B20275C22273B5C6E5C6E66756E6374696F6E207061727365287376';
wwv_flow_imp.g_varchar2_table(6441) := '6729207B5C6E5C6E202076617220756E77726170203D2066616C73653B5C6E5C6E20202F2F20656E7375726520776520696D706F727420612076616C69642073766720646F63756D656E745C6E2020696620287376672E737562737472696E6728302C20';
wwv_flow_imp.g_varchar2_table(6442) := '3429203D3D3D20273C7376672729207B5C6E20202020696620287376672E696E6465784F66286E732E73766729203D3D3D202D3129207B5C6E202020202020737667203D205356475F5354415254202B207376672E737562737472696E672834293B5C6E';
wwv_flow_imp.g_varchar2_table(6443) := '202020207D5C6E20207D20656C7365207B5C6E5C6E202020202F2F206E616D657370616365207376675C6E20202020737667203D205356475F5354415254202B20273E27202B20737667202B20273C2F7376673E273B5C6E20202020756E77726170203D';
wwv_flow_imp.g_varchar2_table(6444) := '20747275653B5C6E20207D5C6E5C6E202076617220706172736564203D207061727365446F63756D656E7428737667293B5C6E5C6E20206966202821756E7772617029207B5C6E2020202072657475726E207061727365643B5C6E20207D5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(6445) := '76617220667261676D656E74203D20646F63756D656E742E637265617465446F63756D656E74467261676D656E7428293B5C6E5C6E202076617220706172656E74203D207061727365642E66697273744368696C643B5C6E5C6E20207768696C65202870';
wwv_flow_imp.g_varchar2_table(6446) := '6172656E742E66697273744368696C6429207B5C6E20202020667261676D656E742E617070656E644368696C6428706172656E742E66697273744368696C64293B5C6E20207D5C6E5C6E202072657475726E20667261676D656E743B5C6E7D5C6E5C6E66';
wwv_flow_imp.g_varchar2_table(6447) := '756E6374696F6E207061727365446F63756D656E742873766729207B5C6E5C6E2020766172207061727365723B5C6E5C6E20202F2F2070617273655C6E2020706172736572203D206E657720444F4D50617273657228293B5C6E20207061727365722E61';
wwv_flow_imp.g_varchar2_table(6448) := '73796E63203D2066616C73653B5C6E5C6E202072657475726E207061727365722E706172736546726F6D537472696E67287376672C2027746578742F786D6C27293B5C6E7D5C6E5C6E2F2A2A5C6E202A20437265617465207574696C69747920666F7220';
wwv_flow_imp.g_varchar2_table(6449) := '53564720656C656D656E74735C6E202A2F5C6E5C6E5C6E5C6E2F2A2A5C6E202A20437265617465206120737065636966696320747970652066726F6D206E616D65206F7220535647206D61726B75702E5C6E202A5C6E202A2040706172616D207B537472';
wwv_flow_imp.g_varchar2_table(6450) := '696E677D206E616D6520746865206E616D65206F72206D61726B7570206F662074686520656C656D656E745C6E202A2040706172616D207B4F626A6563747D205B61747472735D206174747269627574657320746F20736574206F6E2074686520656C65';
wwv_flow_imp.g_varchar2_table(6451) := '6D656E745C6E202A5C6E202A204072657475726E73207B535647456C656D656E747D5C6E202A2F5C6E66756E6374696F6E20637265617465286E616D652C20617474727329207B5C6E202076617220656C656D656E743B5C6E5C6E20206E616D65203D20';
wwv_flow_imp.g_varchar2_table(6452) := '6E616D652E7472696D28293B5C6E5C6E2020696620286E616D652E636861724174283029203D3D3D20273C2729207B5C6E20202020656C656D656E74203D207061727365286E616D65292E66697273744368696C643B5C6E20202020656C656D656E7420';
wwv_flow_imp.g_varchar2_table(6453) := '3D20646F63756D656E742E696D706F72744E6F646528656C656D656E742C2074727565293B5C6E20207D20656C7365207B5C6E20202020656C656D656E74203D20646F63756D656E742E637265617465456C656D656E744E53286E732E7376672C206E61';
wwv_flow_imp.g_varchar2_table(6454) := '6D65293B5C6E20207D5C6E5C6E202069662028617474727329207B5C6E202020206174747228656C656D656E742C206174747273293B5C6E20207D5C6E5C6E202072657475726E20656C656D656E743B5C6E7D5C6E5C6E2F2A2A5C6E202A204576656E74';
wwv_flow_imp.g_varchar2_table(6455) := '732068616E646C696E67207574696C6974795C6E202A2F5C6E5C6E66756E6374696F6E206F6E286E6F64652C206576656E742C206C697374656E65722C207573654361707475726529207B5C6E20206E6F64652E6164644576656E744C697374656E6572';
wwv_flow_imp.g_varchar2_table(6456) := '286576656E742C206C697374656E65722C2075736543617074757265293B5C6E7D5C6E5C6E66756E6374696F6E206F6666286E6F64652C206576656E742C206C697374656E65722C207573654361707475726529207B5C6E20206E6F64652E72656D6F76';
wwv_flow_imp.g_varchar2_table(6457) := '654576656E744C697374656E6572286576656E742C206C697374656E65722C2075736543617074757265293B5C6E7D5C6E5C6E2F2A2A5C6E202A2047656F6D657472792068656C706572735C6E202A2F5C6E5C6E5C6E2F2F2066616B65206E6F64652075';
wwv_flow_imp.g_varchar2_table(6458) := '73656420746F20696E7374616E7469617465207376672067656F6D6574727920656C656D656E74735C6E766172206E6F6465203D206E756C6C3B5C6E5C6E66756E6374696F6E206765744E6F64652829207B5C6E2020696620286E6F6465203D3D3D206E';
wwv_flow_imp.g_varchar2_table(6459) := '756C6C29207B5C6E202020206E6F6465203D20637265617465282773766727293B5C6E20207D5C6E5C6E202072657475726E206E6F64653B5C6E7D5C6E5C6E66756E6374696F6E20657874656E64286F626A6563742C2070726F707329207B5C6E202076';
wwv_flow_imp.g_varchar2_table(6460) := '617220692C206B2C206B657973203D204F626A6563742E6B6579732870726F7073293B5C6E5C6E2020666F72202869203D20303B20286B203D206B6579735B695D293B20692B2B29207B5C6E202020206F626A6563745B6B5D203D2070726F70735B6B5D';
wwv_flow_imp.g_varchar2_table(6461) := '3B5C6E20207D5C6E5C6E202072657475726E206F626A6563743B5C6E7D5C6E5C6E5C6E66756E6374696F6E20637265617465506F696E7428782C207929207B5C6E202076617220706F696E74203D206765744E6F646528292E637265617465535647506F';
wwv_flow_imp.g_varchar2_table(6462) := '696E7428293B5C6E5C6E20207377697463682028617267756D656E74732E6C656E67746829207B5C6E20206361736520303A5C6E2020202072657475726E20706F696E743B5C6E20206361736520323A5C6E2020202078203D207B5C6E20202020202078';
wwv_flow_imp.g_varchar2_table(6463) := '3A20782C5C6E202020202020793A20795C6E202020207D3B5C6E20202020627265616B3B5C6E20207D5C6E5C6E202072657475726E20657874656E6428706F696E742C2078293B5C6E7D5C6E5C6E2F2A2A5C6E202A20437265617465206D617472697820';
wwv_flow_imp.g_varchar2_table(6464) := '76696120617267732E5C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206372656174654D6174726978287B20613A20312C20623A2031207D293B5C6E202A206372656174654D617472697828293B5C6E202A206372656174654D61747269';
wwv_flow_imp.g_varchar2_table(6465) := '7828312C20322C20302C20302C2033302C203230293B5C6E202A5C6E202A204072657475726E207B5356474D61747269787D5C6E202A2F5C6E66756E6374696F6E206372656174654D617472697828612C20622C20632C20642C20652C206629207B5C6E';
wwv_flow_imp.g_varchar2_table(6466) := '2020766172206D6174726978203D206765744E6F646528292E6372656174655356474D617472697828293B5C6E5C6E20207377697463682028617267756D656E74732E6C656E67746829207B5C6E20206361736520303A5C6E2020202072657475726E20';
wwv_flow_imp.g_varchar2_table(6467) := '6D61747269783B5C6E20206361736520313A5C6E2020202072657475726E20657874656E64286D61747269782C2061293B5C6E20206361736520363A5C6E2020202072657475726E20657874656E64286D61747269782C207B5C6E202020202020613A20';
wwv_flow_imp.g_varchar2_table(6468) := '612C5C6E202020202020623A20622C5C6E202020202020633A20632C5C6E202020202020643A20642C5C6E202020202020653A20652C5C6E202020202020663A20665C6E202020207D293B5C6E20207D5C6E7D5C6E5C6E66756E6374696F6E2063726561';
wwv_flow_imp.g_varchar2_table(6469) := '74655472616E73666F726D286D617472697829207B5C6E2020696620286D617472697829207B5C6E2020202072657475726E206765744E6F646528292E6372656174655356475472616E73666F726D46726F6D4D6174726978286D6174726978293B5C6E';
wwv_flow_imp.g_varchar2_table(6470) := '20207D20656C7365207B5C6E2020202072657475726E206765744E6F646528292E6372656174655356475472616E73666F726D28293B5C6E20207D5C6E7D5C6E5C6E2F2A2A5C6E202A2053657269616C697A6174696F6E207574696C5C6E202A2F5C6E5C';
wwv_flow_imp.g_varchar2_table(6471) := '6E76617220544558545F454E544954494553203D202F285B263C3E5D7B317D292F673B5C6E76617220415454525F454E544954494553203D202F285B5C5C6E5C5C725C225D7B317D292F673B5C6E5C6E76617220454E544954595F5245504C4143454D45';
wwv_flow_imp.g_varchar2_table(6472) := '4E54203D207B5C6E20202726273A202726616D703B272C5C6E2020273C273A2027266C743B272C5C6E2020273E273A20272667743B272C5C6E2020275C22273A20275C5C27275C6E7D3B5C6E5C6E66756E6374696F6E20657363617065287374722C2070';
wwv_flow_imp.g_varchar2_table(6473) := '61747465726E29207B5C6E5C6E202066756E6374696F6E207265706C616365466E286D617463682C20656E7469747929207B5C6E2020202072657475726E20454E544954595F5245504C4143454D454E545B656E746974795D207C7C20656E746974793B';
wwv_flow_imp.g_varchar2_table(6474) := '5C6E20207D5C6E5C6E202072657475726E207374722E7265706C616365287061747465726E2C207265706C616365466E293B5C6E7D5C6E5C6E66756E6374696F6E2073657269616C697A65286E6F64652C206F757470757429207B5C6E5C6E2020766172';
wwv_flow_imp.g_varchar2_table(6475) := '20692C206C656E2C20617474724D61702C20617474724E6F64652C206368696C644E6F6465733B5C6E5C6E202073776974636820286E6F64652E6E6F64655479706529207B5C6E5C6E20202F2F20544558545C6E20206361736520333A5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(6476) := '202F2F207265706C616365207370656369616C20584D4C20636861726163746572735C6E202020206F75747075742E7075736828657363617065286E6F64652E74657874436F6E74656E742C20544558545F454E54495449455329293B5C6E2020202062';
wwv_flow_imp.g_varchar2_table(6477) := '7265616B3B5C6E5C6E20202F2F20454C454D454E545C6E20206361736520313A5C6E202020206F75747075742E7075736828273C272C206E6F64652E7461674E616D65293B5C6E5C6E20202020696620286E6F64652E6861734174747269627574657328';
wwv_flow_imp.g_varchar2_table(6478) := '2929207B5C6E202020202020617474724D6170203D206E6F64652E617474726962757465733B5C6E202020202020666F72202869203D20302C206C656E203D20617474724D61702E6C656E6774683B2069203C206C656E3B202B2B6929207B5C6E202020';
wwv_flow_imp.g_varchar2_table(6479) := '2020202020617474724E6F6465203D20617474724D61702E6974656D2869293B5C6E20202020202020206F75747075742E70757368282720272C20617474724E6F64652E6E616D652C20273D5C22272C2065736361706528617474724E6F64652E76616C';
wwv_flow_imp.g_varchar2_table(6480) := '75652C20415454525F454E544954494553292C20275C2227293B5C6E2020202020207D5C6E202020207D5C6E5C6E20202020696620286E6F64652E6861734368696C644E6F646573282929207B5C6E2020202020206F75747075742E7075736828273E27';
wwv_flow_imp.g_varchar2_table(6481) := '293B5C6E2020202020206368696C644E6F646573203D206E6F64652E6368696C644E6F6465733B5C6E202020202020666F72202869203D20302C206C656E203D206368696C644E6F6465732E6C656E6774683B2069203C206C656E3B202B2B6929207B5C';
wwv_flow_imp.g_varchar2_table(6482) := '6E202020202020202073657269616C697A65286368696C644E6F6465732E6974656D2869292C206F7574707574293B5C6E2020202020207D5C6E2020202020206F75747075742E7075736828273C2F272C206E6F64652E7461674E616D652C20273E2729';
wwv_flow_imp.g_varchar2_table(6483) := '3B5C6E202020207D20656C7365207B5C6E2020202020206F75747075742E7075736828272F3E27293B5C6E202020207D5C6E20202020627265616B3B5C6E5C6E20202F2F20434F4D4D454E545C6E20206361736520383A5C6E202020206F75747075742E';
wwv_flow_imp.g_varchar2_table(6484) := '7075736828273C212D2D272C20657363617065286E6F64652E6E6F646556616C75652C20544558545F454E544954494553292C20272D2D3E27293B5C6E20202020627265616B3B5C6E5C6E20202F2F2043444154415C6E20206361736520343A5C6E2020';
wwv_flow_imp.g_varchar2_table(6485) := '20206F75747075742E7075736828273C215B43444154415B272C206E6F64652E6E6F646556616C75652C20275D5D3E27293B5C6E20202020627265616B3B5C6E5C6E202064656661756C743A5C6E202020207468726F77206E6577204572726F72282775';
wwv_flow_imp.g_varchar2_table(6486) := '6E61626C6520746F2068616E646C65206E6F64652027202B206E6F64652E6E6F646554797065293B5C6E20207D5C6E5C6E202072657475726E206F75747075743B5C6E7D5C6E5C6E2F2A2A5C6E202A20696E6E657248544D4C206C696B652066756E6374';
wwv_flow_imp.g_varchar2_table(6487) := '696F6E616C69747920666F722053564720656C656D656E74732E5C6E202A206261736564206F6E20696E6E6572535647202868747470733A2F2F636F64652E676F6F676C652E636F6D2F702F696E6E6572737667295C6E202A2F5C6E5C6E5C6E5C6E6675';
wwv_flow_imp.g_varchar2_table(6488) := '6E6374696F6E2073657428656C656D656E742C2073766729207B5C6E5C6E202076617220706172736564203D20706172736528737667293B5C6E5C6E20202F2F20636C65617220656C656D656E7420636F6E74656E74735C6E2020636C65617228656C65';
wwv_flow_imp.g_varchar2_table(6489) := '6D656E74293B5C6E5C6E2020696620282173766729207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E202069662028216973467261676D656E74287061727365642929207B5C6E5C6E202020202F2F2065787472616374203C7376673E206672';
wwv_flow_imp.g_varchar2_table(6490) := '6F6D2070617273656420646F63756D656E745C6E20202020706172736564203D207061727365642E646F63756D656E74456C656D656E743B5C6E20207D5C6E5C6E2020766172206E6F646573203D20736C696365287061727365642E6368696C644E6F64';
wwv_flow_imp.g_varchar2_table(6491) := '6573293B5C6E5C6E20202F2F20696D706F7274202B20617070656E642065616368206E6F64655C6E2020666F7220287661722069203D20303B2069203C206E6F6465732E6C656E6774683B20692B2B29207B5C6E20202020617070656E64546F286E6F64';
wwv_flow_imp.g_varchar2_table(6492) := '65735B695D2C20656C656D656E74293B5C6E20207D5C6E5C6E7D5C6E5C6E66756E6374696F6E2067657428656C656D656E7429207B5C6E2020766172206368696C64203D20656C656D656E742E66697273744368696C642C5C6E2020202020206F757470';
wwv_flow_imp.g_varchar2_table(6493) := '7574203D205B5D3B5C6E5C6E20207768696C6520286368696C6429207B5C6E2020202073657269616C697A65286368696C642C206F7574707574293B5C6E202020206368696C64203D206368696C642E6E6578745369626C696E673B5C6E20207D5C6E5C';
wwv_flow_imp.g_varchar2_table(6494) := '6E202072657475726E206F75747075742E6A6F696E282727293B5C6E7D5C6E5C6E66756E6374696F6E206973467261676D656E74286E6F646529207B5C6E202072657475726E206E6F64652E6E6F64654E616D65203D3D3D202723646F63756D656E742D';
wwv_flow_imp.g_varchar2_table(6495) := '667261676D656E74273B5C6E7D5C6E5C6E66756E6374696F6E20696E6E657253564728656C656D656E742C2073766729207B5C6E5C6E20206966202873766720213D3D20756E646566696E656429207B5C6E5C6E20202020747279207B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(6496) := '2073657428656C656D656E742C20737667293B5C6E202020207D20636174636820286529207B5C6E2020202020207468726F77206E6577204572726F7228276572726F722070617273696E67205356473A2027202B20652E6D657373616765293B5C6E20';
wwv_flow_imp.g_varchar2_table(6497) := '2020207D5C6E5C6E2020202072657475726E20656C656D656E743B5C6E20207D20656C7365207B5C6E2020202072657475726E2067657428656C656D656E74293B5C6E20207D5C6E7D5C6E5C6E5C6E66756E6374696F6E20736C6963652861727229207B';
wwv_flow_imp.g_varchar2_table(6498) := '5C6E202072657475726E2041727261792E70726F746F747970652E736C6963652E63616C6C28617272293B5C6E7D5C6E5C6E2F2A2A5C6E202A2053656C656374696F6E207574696C69746965735C6E202A2F5C6E5C6E66756E6374696F6E2073656C6563';
wwv_flow_imp.g_varchar2_table(6499) := '74286E6F64652C2073656C6563746F7229207B5C6E202072657475726E206E6F64652E717565727953656C6563746F722873656C6563746F72293B5C6E7D5C6E5C6E66756E6374696F6E2073656C656374416C6C286E6F64652C2073656C6563746F7229';
wwv_flow_imp.g_varchar2_table(6500) := '207B5C6E2020766172206E6F646573203D206E6F64652E717565727953656C6563746F72416C6C2873656C6563746F72293B5C6E5C6E202072657475726E205B5D2E6D61702E63616C6C286E6F6465732C2066756E6374696F6E28656C656D656E742920';
wwv_flow_imp.g_varchar2_table(6501) := '7B5C6E2020202072657475726E20656C656D656E743B5C6E20207D293B5C6E7D5C6E5C6E2F2A2A5C6E202A2070726570656E64546F207574696C6974795C6E202A2F5C6E5C6E5C6E2F2A2A5C6E202A2050726570656E642061206E6F646520746F206120';
wwv_flow_imp.g_varchar2_table(6502) := '74617267657420656C656D656E7420616E642072657475726E207468652070726570656E646564206E6F64652E5C6E202A5C6E202A2040706172616D20207B535647456C656D656E747D206E6F64655C6E202A2040706172616D20207B535647456C656D';
wwv_flow_imp.g_varchar2_table(6503) := '656E747D207461726765745C6E202A5C6E202A204072657475726E207B535647456C656D656E747D207468652070726570656E646564206E6F64655C6E202A2F5C6E66756E6374696F6E2070726570656E64546F286E6F64652C2074617267657429207B';
wwv_flow_imp.g_varchar2_table(6504) := '5C6E202072657475726E207461726765742E696E736572744265666F726528656E73757265496D706F72746564286E6F64652C20746172676574292C207461726765742E66697273744368696C64207C7C206E756C6C293B5C6E7D5C6E5C6E2F2A2A5C6E';
wwv_flow_imp.g_varchar2_table(6505) := '202A2070726570656E64207574696C6974795C6E202A2F5C6E5C6E5C6E2F2A2A5C6E202A2050726570656E642061206E6F646520746F20612074617267657420656C656D656E745C6E202A5C6E202A2040706172616D20207B535647456C656D656E747D';
wwv_flow_imp.g_varchar2_table(6506) := '207461726765745C6E202A2040706172616D20207B535647456C656D656E747D206E6F64655C6E202A5C6E202A204072657475726E207B535647456C656D656E747D207468652074617267657420656C656D656E745C6E202A2F5C6E66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(6507) := '2070726570656E64287461726765742C206E6F646529207B5C6E202070726570656E64546F286E6F64652C20746172676574293B5C6E202072657475726E207461726765743B5C6E7D5C6E5C6E66756E6374696F6E2072656D6F766528656C656D656E74';
wwv_flow_imp.g_varchar2_table(6508) := '29207B5C6E202076617220706172656E74203D20656C656D656E742E706172656E744E6F64653B5C6E5C6E202069662028706172656E7429207B5C6E20202020706172656E742E72656D6F76654368696C6428656C656D656E74293B5C6E20207D5C6E5C';
wwv_flow_imp.g_varchar2_table(6509) := '6E202072657475726E20656C656D656E743B5C6E7D5C6E5C6E2F2A2A5C6E202A205265706C616365207574696C6974795C6E202A2F5C6E5C6E5C6E66756E6374696F6E207265706C61636528656C656D656E742C207265706C6163656D656E7429207B5C';
wwv_flow_imp.g_varchar2_table(6510) := '6E2020656C656D656E742E706172656E744E6F64652E7265706C6163654368696C6428656E73757265496D706F72746564287265706C6163656D656E742C20656C656D656E74292C20656C656D656E74293B5C6E202072657475726E207265706C616365';
wwv_flow_imp.g_varchar2_table(6511) := '6D656E743B5C6E7D5C6E5C6E2F2A2A5C6E202A207472616E73666F726D206163636573736F72207574696C6974795C6E202A2F5C6E5C6E66756E6374696F6E20777261704D6174726978287472616E73666F726D4C6973742C207472616E73666F726D29';
wwv_flow_imp.g_varchar2_table(6512) := '207B5C6E2020696620287472616E73666F726D20696E7374616E63656F66205356474D617472697829207B5C6E2020202072657475726E207472616E73666F726D4C6973742E6372656174655356475472616E73666F726D46726F6D4D61747269782874';
wwv_flow_imp.g_varchar2_table(6513) := '72616E73666F726D293B5C6E20207D5C6E5C6E202072657475726E207472616E73666F726D3B5C6E7D5C6E5C6E5C6E66756E6374696F6E207365745472616E73666F726D73287472616E73666F726D4C6973742C207472616E73666F726D7329207B5C6E';
wwv_flow_imp.g_varchar2_table(6514) := '202076617220692C20743B5C6E5C6E20207472616E73666F726D4C6973742E636C65617228293B5C6E5C6E2020666F72202869203D20303B202874203D207472616E73666F726D735B695D293B20692B2B29207B5C6E202020207472616E73666F726D4C';
wwv_flow_imp.g_varchar2_table(6515) := '6973742E617070656E644974656D28777261704D6174726978287472616E73666F726D4C6973742C207429293B5C6E20207D5C6E7D5C6E5C6E2F2A2A5C6E202A20476574206F722073657420746865207472616E73666F726D73206F6E20746865206769';
wwv_flow_imp.g_varchar2_table(6516) := '76656E206E6F64652E5C6E202A5C6E202A2040706172616D207B535647456C656D656E747D206E6F64655C6E202A2040706172616D20207B5356475472616E73666F726D7C5356474D61747269787C41727261793C5356475472616E73666F726D7C5356';
wwv_flow_imp.g_varchar2_table(6517) := '474D61747269783E7D205B7472616E73666F726D735D5C6E202A5C6E202A204072657475726E207B5356475472616E73666F726D7D2074686520636F6E736F6C696461746564207472616E73666F726D5C6E202A2F5C6E66756E6374696F6E207472616E';
wwv_flow_imp.g_varchar2_table(6518) := '73666F726D286E6F64652C207472616E73666F726D7329207B5C6E2020766172207472616E73666F726D4C697374203D206E6F64652E7472616E73666F726D2E6261736556616C3B5C6E5C6E2020696620287472616E73666F726D7329207B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(6519) := '202020696620282141727261792E69734172726179287472616E73666F726D732929207B5C6E2020202020207472616E73666F726D73203D205B207472616E73666F726D73205D3B5C6E202020207D5C6E5C6E202020207365745472616E73666F726D73';
wwv_flow_imp.g_varchar2_table(6520) := '287472616E73666F726D4C6973742C207472616E73666F726D73293B5C6E20207D5C6E5C6E202072657475726E207472616E73666F726D4C6973742E636F6E736F6C696461746528293B5C6E7D5C6E5C6E6578706F7274207B20617070656E642C206170';
wwv_flow_imp.g_varchar2_table(6521) := '70656E64546F2C20617474722C20636C61737365732C20636C6561722C20636C6F6E652C206372656174652C206372656174654D61747269782C20637265617465506F696E742C206372656174655472616E73666F726D2C20696E6E65725356472C206F';
wwv_flow_imp.g_varchar2_table(6522) := '66662C206F6E2C2070726570656E642C2070726570656E64546F2C2072656D6F76652C207265706C6163652C2073656C6563742C2073656C656374416C6C2C207472616E73666F726D207D3B5C6E222C22696D706F7274207B206973537472696E672C20';
wwv_flow_imp.g_varchar2_table(6523) := '61737369676E207D2066726F6D20276D696E2D64617368273B5C6E696D706F7274207B204D6F64646C65207D2066726F6D20276D6F64646C65273B5C6E696D706F7274207B205265616465722C20577269746572207D2066726F6D20276D6F64646C652D';
wwv_flow_imp.g_varchar2_table(6524) := '786D6C273B5C6E5C6E2F2A2A5C6E202A20412073756220636C617373206F66207B406C696E6B204D6F64646C657D207769746820737570706F727420666F7220696D706F727420616E64206578706F7274206F662042504D4E20322E3020786D6C206669';
wwv_flow_imp.g_varchar2_table(6525) := '6C65732E5C6E202A5C6E202A2040636C6173732042706D6E4D6F64646C655C6E202A2040657874656E6473204D6F64646C655C6E202A5C6E202A2040706172616D207B4F626A6563747C41727261797D207061636B6167657320746F2075736520666F72';
wwv_flow_imp.g_varchar2_table(6526) := '20696E7374616E74696174696E6720746865206D6F64656C5C6E202A2040706172616D207B4F626A6563747D205B6F7074696F6E735D206164646974696F6E616C206F7074696F6E7320746F2070617373206F7665725C6E202A2F5C6E66756E6374696F';
wwv_flow_imp.g_varchar2_table(6527) := '6E2042706D6E4D6F64646C65287061636B616765732C206F7074696F6E7329207B5C6E20204D6F64646C652E63616C6C28746869732C207061636B616765732C206F7074696F6E73293B5C6E7D5C6E5C6E42706D6E4D6F64646C652E70726F746F747970';
wwv_flow_imp.g_varchar2_table(6528) := '65203D204F626A6563742E637265617465284D6F64646C652E70726F746F74797065293B5C6E5C6E2F2A2A5C6E202A205468652066726F6D584D4C20726573756C742E5C6E202A5C6E202A204074797065646566207B4F626A6563747D20506172736552';
wwv_flow_imp.g_varchar2_table(6529) := '6573756C745C6E202A5C6E202A204070726F7065727479207B4D6F64646C65456C656D656E747D20726F6F74456C656D656E745C6E202A204070726F7065727479207B41727261793C4F626A6563743E7D207265666572656E6365735C6E202A20407072';
wwv_flow_imp.g_varchar2_table(6530) := '6F7065727479207B41727261793C4572726F723E7D207761726E696E67735C6E202A204070726F7065727479207B4F626A6563747D20656C656D656E747342794964202D2061206D617070696E6720636F6E7461696E696E672065616368204944202D3E';
wwv_flow_imp.g_varchar2_table(6531) := '204D6F64646C65456C656D656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A205468652066726F6D584D4C206572726F722E5C6E202A5C6E202A204074797065646566207B4572726F727D2050617273654572726F725C6E202A5C6E202A204070726F7065';
wwv_flow_imp.g_varchar2_table(6532) := '727479207B41727261793C4572726F723E7D207761726E696E67735C6E202A2F5C6E5C6E2F2A2A5C6E202A20496E7374616E74696174657320612042504D4E206D6F64656C20747265652066726F6D206120676976656E20786D6C20737472696E672E5C';
wwv_flow_imp.g_varchar2_table(6533) := '6E202A5C6E202A2040706172616D207B537472696E677D202020786D6C5374725C6E202A2040706172616D207B537472696E677D2020205B747970654E616D653D2762706D6E3A446566696E6974696F6E73275D206E616D65206F662074686520726F6F';
wwv_flow_imp.g_varchar2_table(6534) := '7420656C656D656E745C6E202A2040706172616D207B4F626A6563747D2020205B6F7074696F6E735D20206F7074696F6E7320746F207061737320746F2074686520756E6465726C79696E67207265616465725C6E202A5C6E202A204072657475726E73';
wwv_flow_imp.g_varchar2_table(6535) := '207B50726F6D6973653C5061727365526573756C742C2050617273654572726F723E7D5C6E202A2F5C6E42706D6E4D6F64646C652E70726F746F747970652E66726F6D584D4C203D2066756E6374696F6E28786D6C5374722C20747970654E616D652C20';
wwv_flow_imp.g_varchar2_table(6536) := '6F7074696F6E7329207B5C6E5C6E202069662028216973537472696E6728747970654E616D652929207B5C6E202020206F7074696F6E73203D20747970654E616D653B5C6E20202020747970654E616D65203D202762706D6E3A446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(6537) := '73273B5C6E20207D5C6E5C6E202076617220726561646572203D206E6577205265616465722861737369676E287B206D6F64656C3A20746869732C206C61783A2074727565207D2C206F7074696F6E7329293B5C6E202076617220726F6F7448616E646C';
wwv_flow_imp.g_varchar2_table(6538) := '6572203D207265616465722E68616E646C657228747970654E616D65293B5C6E5C6E202072657475726E207265616465722E66726F6D584D4C28786D6C5374722C20726F6F7448616E646C6572293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A20546865';
wwv_flow_imp.g_varchar2_table(6539) := '20746F584D4C20726573756C742E5C6E202A5C6E202A204074797065646566207B4F626A6563747D2053657269616C697A6174696F6E526573756C745C6E202A5C6E202A204070726F7065727479207B537472696E677D20786D6C5C6E202A2F5C6E5C6E';
wwv_flow_imp.g_varchar2_table(6540) := '2F2A2A5C6E202A2053657269616C697A657320612042504D4E20322E30206F626A656374207472656520746F20584D4C2E5C6E202A5C6E202A2040706172616D207B537472696E677D202020656C656D656E742020202074686520726F6F7420656C656D';
wwv_flow_imp.g_varchar2_table(6541) := '656E742C207479706963616C6C7920616E20696E7374616E6365206F66206062706D6E3A446566696E6974696F6E73605C6E202A2040706172616D207B4F626A6563747D2020205B6F7074696F6E735D2020746F207061737320746F2074686520756E64';
wwv_flow_imp.g_varchar2_table(6542) := '65726C79696E67207772697465725C6E202A5C6E202A204072657475726E73207B50726F6D6973653C53657269616C697A6174696F6E526573756C742C204572726F723E7D5C6E202A2F5C6E42706D6E4D6F64646C652E70726F746F747970652E746F58';
wwv_flow_imp.g_varchar2_table(6543) := '4D4C203D2066756E6374696F6E28656C656D656E742C206F7074696F6E7329207B5C6E5C6E202076617220777269746572203D206E657720577269746572286F7074696F6E73293B5C6E5C6E202072657475726E206E65772050726F6D6973652866756E';
wwv_flow_imp.g_varchar2_table(6544) := '6374696F6E287265736F6C76652C2072656A65637429207B5C6E20202020747279207B5C6E20202020202076617220726573756C74203D207772697465722E746F584D4C28656C656D656E74293B5C6E5C6E20202020202072657475726E207265736F6C';
wwv_flow_imp.g_varchar2_table(6545) := '7665287B5C6E2020202020202020786D6C3A20726573756C745C6E2020202020207D293B5C6E202020207D206361746368202865727229207B5C6E20202020202072657475726E2072656A65637428657272293B5C6E202020207D5C6E20207D293B5C6E';
wwv_flow_imp.g_varchar2_table(6546) := '7D3B5C6E5C6E766172206E616D652435203D205C2242504D4E32305C223B5C6E766172207572692435203D205C22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F4D4F44454C5C223B5C6E766172207072';
wwv_flow_imp.g_varchar2_table(6547) := '656669782435203D205C2262706D6E5C223B5C6E766172206173736F63696174696F6E732435203D205B5C6E5D3B5C6E7661722074797065732435203D205B5C6E5C747B5C6E5C745C746E616D653A205C22496E746572666163655C222C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6548) := '7375706572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C';
wwv_flow_imp.g_varchar2_table(6549) := '745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F7065726174696F6E735C222C5C6E5C74';
wwv_flow_imp.g_varchar2_table(6550) := '5C745C745C74747970653A205C224F7065726174696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696D706C656D656E746174696F6E52';
wwv_flow_imp.g_varchar2_table(6551) := '65665C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224F70657261';
wwv_flow_imp.g_varchar2_table(6552) := '74696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A';
wwv_flow_imp.g_varchar2_table(6553) := '205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E4D65';
wwv_flow_imp.g_varchar2_table(6554) := '73736167655265665C222C5C6E5C745C745C745C74747970653A205C224D6573736167655C222C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A';
wwv_flow_imp.g_varchar2_table(6555) := '205C226F75744D6573736167655265665C222C5C6E5C745C745C745C74747970653A205C224D6573736167655C222C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6556) := '745C746E616D653A205C226572726F725265665C222C5C6E5C745C745C745C74747970653A205C224572726F725C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E';
wwv_flow_imp.g_varchar2_table(6557) := '5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696D706C656D656E746174696F6E5265665C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C2253747269';
wwv_flow_imp.g_varchar2_table(6558) := '6E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22456E64506F696E745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D656E745C225C6E';
wwv_flow_imp.g_varchar2_table(6559) := '5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224175646974696E675C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C74';
wwv_flow_imp.g_varchar2_table(6560) := '7B5C6E5C745C746E616D653A205C22476C6F62616C5461736B5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2243616C6C61626C65456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A20';
wwv_flow_imp.g_varchar2_table(6561) := '5B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227265736F75726365735C222C5C6E5C745C745C745C74747970653A205C225265736F75726365526F6C655C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C';
wwv_flow_imp.g_varchar2_table(6562) := '745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224D6F6E69746F72696E675C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D5C6E';
wwv_flow_imp.g_varchar2_table(6563) := '5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22506572666F726D65725C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C225265736F75726365526F6C655C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C74';
wwv_flow_imp.g_varchar2_table(6564) := '5C746E616D653A205C2250726F636573735C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22466C6F77456C656D656E7473436F6E7461696E65725C222C5C6E5C745C745C745C2243616C6C61626C65456C656D656E745C22';
wwv_flow_imp.g_varchar2_table(6565) := '5C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2270726F63657373547970655C222C5C6E5C745C745C745C74747970653A205C2250726F63657373547970655C222C';
wwv_flow_imp.g_varchar2_table(6566) := '5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973436C6F7365645C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6567) := '745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226175646974696E675C222C5C6E5C745C745C745C74747970653A205C224175646974696E675C225C6E5C74';
wwv_flow_imp.g_varchar2_table(6568) := '5C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D6F6E69746F72696E675C222C5C6E5C745C745C745C74747970653A205C224D6F6E69746F72696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6569) := '745C745C746E616D653A205C2270726F706572746965735C222C5C6E5C745C745C745C74747970653A205C2250726F70657274795C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C74';
wwv_flow_imp.g_varchar2_table(6570) := '5C745C745C746E616D653A205C226C616E65536574735C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C747265706C616365733A205C22466C6F77456C656D656E7473436F6E7461696E6572236C616E6553657473';
wwv_flow_imp.g_varchar2_table(6571) := '5C222C5C6E5C745C745C745C74747970653A205C224C616E655365745C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22666C6F77456C656D656E74735C222C5C6E5C745C745C745C7469734D616E793A20';
wwv_flow_imp.g_varchar2_table(6572) := '747275652C5C6E5C745C745C745C747265706C616365733A205C22466C6F77456C656D656E7473436F6E7461696E657223666C6F77456C656D656E74735C222C5C6E5C745C745C745C74747970653A205C22466C6F77456C656D656E745C225C6E5C745C';
wwv_flow_imp.g_varchar2_table(6573) := '745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226172746966616374735C222C5C6E5C745C745C745C74747970653A205C2241727469666163745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C';
wwv_flow_imp.g_varchar2_table(6574) := '745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227265736F75726365735C222C5C6E5C745C745C745C74747970653A205C225265736F75726365526F6C655C222C5C6E5C745C745C745C7469734D616E793A20747275655C';
wwv_flow_imp.g_varchar2_table(6575) := '6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F7272656C6174696F6E537562736372697074696F6E735C222C5C6E5C745C745C745C74747970653A205C22436F7272656C6174696F6E5375627363726970';
wwv_flow_imp.g_varchar2_table(6576) := '74696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22737570706F7274735C222C5C6E5C745C745C745C74747970653A205C2250726F6365';
wwv_flow_imp.g_varchar2_table(6577) := '73735C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22646566696E697469';
wwv_flow_imp.g_varchar2_table(6578) := '6F6E616C436F6C6C61626F726174696F6E5265665C222C5C6E5C745C745C745C74747970653A205C22436F6C6C61626F726174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63';
wwv_flow_imp.g_varchar2_table(6579) := '653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22697345786563757461626C655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22';
wwv_flow_imp.g_varchar2_table(6580) := '426F6F6C65616E5C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224C616E655365745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E74';
wwv_flow_imp.g_varchar2_table(6581) := '5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C616E65735C222C5C6E5C745C745C745C74747970653A205C224C616E655C222C5C6E5C745C745C745C7469';
wwv_flow_imp.g_varchar2_table(6582) := '734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C2253747269';
wwv_flow_imp.g_varchar2_table(6583) := '6E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224C616E655C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6584) := '5D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C2253747269';
wwv_flow_imp.g_varchar2_table(6585) := '6E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22706172746974696F6E456C656D656E745265665C222C5C6E5C745C745C745C74747970653A205C2242617365456C656D656E745C222C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6586) := '745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22706172746974696F6E456C656D656E745C22';
wwv_flow_imp.g_varchar2_table(6587) := '2C5C6E5C745C745C745C74747970653A205C2242617365456C656D656E745C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22666C6F774E6F64655265665C222C5C6E5C745C745C745C74747970653A205C';
wwv_flow_imp.g_varchar2_table(6588) := '22466C6F774E6F64655C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2263';
wwv_flow_imp.g_varchar2_table(6589) := '68696C644C616E655365745C222C5C6E5C745C745C745C74747970653A205C224C616E655365745C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6590) := '745C747D5C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22476C6F62616C4D616E75616C5461736B5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22476C6F62616C54';
wwv_flow_imp.g_varchar2_table(6591) := '61736B5C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224D616E75616C5461736B5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C225461736B5C225C6E5C745C745D5C6E5C747D2C5C6E';
wwv_flow_imp.g_varchar2_table(6592) := '5C747B5C6E5C745C746E616D653A205C22557365725461736B5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C225461736B5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C';
wwv_flow_imp.g_varchar2_table(6593) := '6E5C745C745C745C746E616D653A205C2272656E646572696E67735C222C5C6E5C745C745C745C74747970653A205C2252656E646572696E675C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6594) := '7B5C6E5C745C745C745C746E616D653A205C22696D706C656D656E746174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6595) := '5D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2252656E646572696E675C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E';
wwv_flow_imp.g_varchar2_table(6596) := '5C745C746E616D653A205C2248756D616E506572666F726D65725C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22506572666F726D65725C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C';
wwv_flow_imp.g_varchar2_table(6597) := '22506F74656E7469616C4F776E65725C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2248756D616E506572666F726D65725C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22476C6F6261';
wwv_flow_imp.g_varchar2_table(6598) := '6C557365725461736B5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22476C6F62616C5461736B5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E';
wwv_flow_imp.g_varchar2_table(6599) := '616D653A205C22696D706C656D656E746174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6600) := '5C746E616D653A205C2272656E646572696E67735C222C5C6E5C745C745C745C74747970653A205C2252656E646572696E675C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C';
wwv_flow_imp.g_varchar2_table(6601) := '747B5C6E5C745C746E616D653A205C22476174657761795C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22466C6F774E6F64655C225C6E5C745C745D2C5C6E5C74';
wwv_flow_imp.g_varchar2_table(6602) := '5C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2267617465776179446972656374696F6E5C222C5C6E5C745C745C745C74747970653A205C2247617465776179446972656374696F6E5C222C5C6E';
wwv_flow_imp.g_varchar2_table(6603) := '5C745C745C745C745C2264656661756C745C223A205C22556E7370656369666965645C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22';
wwv_flow_imp.g_varchar2_table(6604) := '4576656E744261736564476174657761795C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22476174657761795C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6605) := '5C745C746E616D653A205C22696E7374616E74696174655C222C5C6E5C745C745C745C745C2264656661756C745C223A2066616C73652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C';
wwv_flow_imp.g_varchar2_table(6606) := '65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226576656E7447617465776179547970655C222C5C6E5C745C745C745C74747970653A205C224576656E7442617365644761746577617954797065';
wwv_flow_imp.g_varchar2_table(6607) := '5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C745C2264656661756C745C223A205C224578636C75736976655C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A';
wwv_flow_imp.g_varchar2_table(6608) := '205C22436F6D706C6578476174657761795C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22476174657761795C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6609) := '5C745C746E616D653A205C2261637469766174696F6E436F6E646974696F6E5C222C5C6E5C745C745C745C74747970653A205C2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C69';
wwv_flow_imp.g_varchar2_table(6610) := '7A653A205C227873693A747970655C225C6E5C745C745C745C747D5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2264656661756C745C222C5C6E5C745C745C745C74747970653A205C2253657175656E6365';
wwv_flow_imp.g_varchar2_table(6611) := '466C6F775C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224578';
wwv_flow_imp.g_varchar2_table(6612) := '636C7573697665476174657761795C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22476174657761795C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(6613) := '746E616D653A205C2264656661756C745C222C5C6E5C745C745C745C74747970653A205C2253657175656E6365466C6F775C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A207472';
wwv_flow_imp.g_varchar2_table(6614) := '75655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22496E636C7573697665476174657761795C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22476174657761795C22';
wwv_flow_imp.g_varchar2_table(6615) := '5C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2264656661756C745C222C5C6E5C745C745C745C74747970653A205C2253657175656E6365466C6F775C222C5C6E5C';
wwv_flow_imp.g_varchar2_table(6616) := '745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22506172616C6C656C47617465';
wwv_flow_imp.g_varchar2_table(6617) := '7761795C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22476174657761795C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22526F6F74456C656D656E745C222C5C6E5C745C7469734162';
wwv_flow_imp.g_varchar2_table(6618) := '7374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2252656C6174696F6E736869705C';
wwv_flow_imp.g_varchar2_table(6619) := '222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227479';
wwv_flow_imp.g_varchar2_table(6620) := '70655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22646972656374696F6E';
wwv_flow_imp.g_varchar2_table(6621) := '5C222C5C6E5C745C745C745C74747970653A205C2252656C6174696F6E73686970446972656374696F6E5C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D65';
wwv_flow_imp.g_varchar2_table(6622) := '3A205C22736F757263655C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275652C5C6E5C745C745C745C74747970653A205C22456C656D656E745C225C6E5C745C745C747D';
wwv_flow_imp.g_varchar2_table(6623) := '2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227461726765745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275652C5C6E5C745C745C745C747479';
wwv_flow_imp.g_varchar2_table(6624) := '70653A205C22456C656D656E745C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2242617365456C656D656E745C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C7470';
wwv_flow_imp.g_varchar2_table(6625) := '726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2269645C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C222C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6626) := '5C745C74697349643A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22646F63756D656E746174696F6E5C222C5C6E5C745C745C745C74747970653A205C22446F63756D656E746174696F6E5C22';
wwv_flow_imp.g_varchar2_table(6627) := '2C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22657874656E73696F6E446566696E6974696F6E735C222C5C6E5C745C745C745C74747970653A205C';
wwv_flow_imp.g_varchar2_table(6628) := '22457874656E73696F6E446566696E6974696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6629) := '5C746E616D653A205C22657874656E73696F6E456C656D656E74735C222C5C6E5C745C745C745C74747970653A205C22457874656E73696F6E456C656D656E74735C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6630) := '6E616D653A205C22457874656E73696F6E5C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D757374556E6465727374616E645C222C5C6E5C745C745C745C745C226465666175';
wwv_flow_imp.g_varchar2_table(6631) := '6C745C223A2066616C73652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2264';
wwv_flow_imp.g_varchar2_table(6632) := '6566696E6974696F6E5C222C5C6E5C745C745C745C74747970653A205C22457874656E73696F6E446566696E6974696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A207472';
wwv_flow_imp.g_varchar2_table(6633) := '75655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22457874656E73696F6E446566696E6974696F6E5C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6634) := '745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D65';
wwv_flow_imp.g_varchar2_table(6635) := '3A205C22657874656E73696F6E417474726962757465446566696E6974696F6E735C222C5C6E5C745C745C745C74747970653A205C22457874656E73696F6E417474726962757465446566696E6974696F6E5C222C5C6E5C745C745C745C7469734D616E';
wwv_flow_imp.g_varchar2_table(6636) := '793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22457874656E73696F6E417474726962757465446566696E6974696F6E5C222C5C6E5C745C7470726F706572746965733A205B5C6E';
wwv_flow_imp.g_varchar2_table(6637) := '5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B';
wwv_flow_imp.g_varchar2_table(6638) := '5C6E5C745C745C745C746E616D653A205C22747970655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6639) := '745C746E616D653A205C2269735265666572656E63655C222C5C6E5C745C745C745C745C2264656661756C745C223A2066616C73652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65';
wwv_flow_imp.g_varchar2_table(6640) := '616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22657874656E73696F6E446566696E6974696F6E5C222C5C6E5C745C745C745C74747970653A205C22457874656E73696F6E446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(6641) := '5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22457874656E73';
wwv_flow_imp.g_varchar2_table(6642) := '696F6E456C656D656E74735C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2276616C75655265665C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6643) := '5C745C7469735265666572656E63653A20747275652C5C6E5C745C745C745C74747970653A205C22456C656D656E745C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2276616C7565735C222C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6644) := '745C745C74747970653A205C22456C656D656E745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22657874656E73696F6E417474726962757465';
wwv_flow_imp.g_varchar2_table(6645) := '446566696E6974696F6E5C222C5C6E5C745C745C745C74747970653A205C22457874656E73696F6E417474726962757465446566696E6974696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C746973526566';
wwv_flow_imp.g_varchar2_table(6646) := '6572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22446F63756D656E746174696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224261';
wwv_flow_imp.g_varchar2_table(6647) := '7365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22746578745C222C5C6E5C745C745C745C74747970653A205C22537472696E675C222C5C';
wwv_flow_imp.g_varchar2_table(6648) := '6E5C745C745C745C746973426F64793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2274657874466F726D61745C222C5C6E5C745C745C745C745C2264656661756C745C223A205C2274657874';
wwv_flow_imp.g_varchar2_table(6649) := '2F706C61696E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2245';
wwv_flow_imp.g_varchar2_table(6650) := '76656E745C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22466C6F774E6F64655C222C5C6E5C745C745C745C22496E746572616374696F6E4E6F64655C225C6E5C';
wwv_flow_imp.g_varchar2_table(6651) := '745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2270726F706572746965735C222C5C6E5C745C745C745C74747970653A205C2250726F70657274795C222C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6652) := '745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22496E7465726D65646961746543617463684576656E745C222C5C6E5C745C747375706572436C6173733A205B';
wwv_flow_imp.g_varchar2_table(6653) := '5C6E5C745C745C745C2243617463684576656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22496E7465726D6564696174655468726F774576656E745C222C5C6E5C745C747375706572436C6173733A205B5C6E';
wwv_flow_imp.g_varchar2_table(6654) := '5C745C745C745C225468726F774576656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22456E644576656E745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C225468726F77457665';
wwv_flow_imp.g_varchar2_table(6655) := '6E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2253746172744576656E745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2243617463684576656E745C225C6E5C745C745D2C5C6E';
wwv_flow_imp.g_varchar2_table(6656) := '5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973496E74657272757074696E675C222C5C6E5C745C745C745C745C2264656661756C745C223A20747275652C5C6E5C745C745C745C7469';
wwv_flow_imp.g_varchar2_table(6657) := '73417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225468726F774576656E745C222C5C6E5C745C7469';
wwv_flow_imp.g_varchar2_table(6658) := '7341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224576656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E61';
wwv_flow_imp.g_varchar2_table(6659) := '6D653A205C2264617461496E707574735C222C5C6E5C745C745C745C74747970653A205C2244617461496E7075745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(6660) := '6E616D653A205C2264617461496E7075744173736F63696174696F6E735C222C5C6E5C745C745C745C74747970653A205C2244617461496E7075744173736F63696174696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C';
wwv_flow_imp.g_varchar2_table(6661) := '745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E7075745365745C222C5C6E5C745C745C745C74747970653A205C22496E7075745365745C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(6662) := '6E616D653A205C226576656E74446566696E6974696F6E735C222C5C6E5C745C745C745C74747970653A205C224576656E74446566696E6974696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6663) := '745C747B5C6E5C745C745C745C746E616D653A205C226576656E74446566696E6974696F6E5265665C222C5C6E5C745C745C745C74747970653A205C224576656E74446566696E6974696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275';
wwv_flow_imp.g_varchar2_table(6664) := '652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2243617463684576656E745C222C5C6E5C745C74697341627374726163743A';
wwv_flow_imp.g_varchar2_table(6665) := '20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224576656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2270617261';
wwv_flow_imp.g_varchar2_table(6666) := '6C6C656C4D756C7469706C655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C222C5C6E5C745C745C745C745C2264656661756C745C223A2066616C73655C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6667) := '5C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22646174614F7574707574735C222C5C6E5C745C745C745C74747970653A205C22446174614F75747075745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E';
wwv_flow_imp.g_varchar2_table(6668) := '5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22646174614F75747075744173736F63696174696F6E735C222C5C6E5C745C745C745C74747970653A205C22446174614F75747075744173736F63696174696F6E5C';
wwv_flow_imp.g_varchar2_table(6669) := '222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F75747075745365745C222C5C6E5C745C745C745C74747970653A205C224F7574707574536574';
wwv_flow_imp.g_varchar2_table(6670) := '5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226576656E74446566696E6974696F6E735C222C5C6E5C745C745C745C74747970653A205C224576656E74446566696E6974696F6E5C222C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6671) := '5C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226576656E74446566696E6974696F6E5265665C222C5C6E5C745C745C745C74747970653A205C224576656E74446566';
wwv_flow_imp.g_varchar2_table(6672) := '696E6974696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C';
wwv_flow_imp.g_varchar2_table(6673) := '22426F756E646172794576656E745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2243617463684576656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6674) := '5C745C746E616D653A205C2263616E63656C41637469766974795C222C5C6E5C745C745C745C745C2264656661756C745C223A20747275652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F';
wwv_flow_imp.g_varchar2_table(6675) := '6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226174746163686564546F5265665C222C5C6E5C745C745C745C74747970653A205C2241637469766974795C222C5C6E5C745C745C745C7469';
wwv_flow_imp.g_varchar2_table(6676) := '73417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224576656E74446566696E6974696F6E5C222C5C6E';
wwv_flow_imp.g_varchar2_table(6677) := '5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2243616E6365';
wwv_flow_imp.g_varchar2_table(6678) := '6C4576656E74446566696E6974696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224576656E74446566696E6974696F6E5C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22457272';
wwv_flow_imp.g_varchar2_table(6679) := '6F724576656E74446566696E6974696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224576656E74446566696E6974696F6E5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6680) := '747B5C6E5C745C745C745C746E616D653A205C226572726F725265665C222C5C6E5C745C745C745C74747970653A205C224572726F725C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63';
wwv_flow_imp.g_varchar2_table(6681) := '653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225465726D696E6174654576656E74446566696E6974696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6682) := '5C745C224576656E74446566696E6974696F6E5C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22457363616C6174696F6E4576656E74446566696E6974696F6E5C222C5C6E5C745C747375706572436C6173733A205B';
wwv_flow_imp.g_varchar2_table(6683) := '5C6E5C745C745C745C224576656E74446566696E6974696F6E5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22657363616C6174696F6E5265665C222C5C6E5C';
wwv_flow_imp.g_varchar2_table(6684) := '745C745C745C74747970653A205C22457363616C6174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C';
wwv_flow_imp.g_varchar2_table(6685) := '5C6E5C747B5C6E5C745C746E616D653A205C22457363616C6174696F6E5C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227374727563747572655265665C222C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6686) := '745C74747970653A205C224974656D446566696E6974696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C';
wwv_flow_imp.g_varchar2_table(6687) := '745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(6688) := '6E616D653A205C22657363616C6174696F6E436F64655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D2C5C6E5C745C74737570';
wwv_flow_imp.g_varchar2_table(6689) := '6572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F6D70656E736174654576656E74446566696E6974696F6E5C222C5C6E5C745C7473';
wwv_flow_imp.g_varchar2_table(6690) := '75706572436C6173733A205B5C6E5C745C745C745C224576656E74446566696E6974696F6E5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2277616974466F72';
wwv_flow_imp.g_varchar2_table(6691) := '436F6D706C6574696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C222C5C6E5C745C745C745C745C2264656661756C745C223A20747275655C6E5C745C745C747D';
wwv_flow_imp.g_varchar2_table(6692) := '2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2261637469766974795265665C222C5C6E5C745C745C745C74747970653A205C2241637469766974795C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6693) := '5C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2254696D65724576656E74446566696E6974696F6E5C222C5C6E5C745C747375706572436C6173';
wwv_flow_imp.g_varchar2_table(6694) := '733A205B5C6E5C745C745C745C224576656E74446566696E6974696F6E5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2274696D65446174655C222C5C6E5C74';
wwv_flow_imp.g_varchar2_table(6695) := '5C745C745C74747970653A205C2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C745C745C745C747D5C6E5C745C745C747D2C5C';
wwv_flow_imp.g_varchar2_table(6696) := '6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2274696D654379636C655C222C5C6E5C745C745C745C74747970653A205C2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C74736572';
wwv_flow_imp.g_varchar2_table(6697) := '69616C697A653A205C227873693A747970655C225C6E5C745C745C745C747D5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2274696D654475726174696F6E5C222C5C6E5C745C745C745C74747970653A205C';
wwv_flow_imp.g_varchar2_table(6698) := '2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C745C745C745C747D5C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E';
wwv_flow_imp.g_varchar2_table(6699) := '5C747B5C6E5C745C746E616D653A205C224C696E6B4576656E74446566696E6974696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224576656E74446566696E6974696F6E5C225C6E5C745C745D2C5C6E5C745C7470';
wwv_flow_imp.g_varchar2_table(6700) := '726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C';
wwv_flow_imp.g_varchar2_table(6701) := '745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227461726765745C222C5C6E5C745C745C745C74747970653A205C224C696E6B4576656E74446566696E6974696F6E5C222C5C6E5C745C745C745C7469735265666572656E';
wwv_flow_imp.g_varchar2_table(6702) := '63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22736F757263655C222C5C6E5C745C745C745C74747970653A205C224C696E6B4576656E74446566696E6974696F6E5C222C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6703) := '5C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224D6573736167654576656E74446566';
wwv_flow_imp.g_varchar2_table(6704) := '696E6974696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224576656E74446566696E6974696F6E5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6705) := '5C746E616D653A205C226D6573736167655265665C222C5C6E5C745C745C745C74747970653A205C224D6573736167655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275';
wwv_flow_imp.g_varchar2_table(6706) := '655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F7065726174696F6E5265665C222C5C6E5C745C745C745C74747970653A205C224F7065726174696F6E5C222C5C6E5C745C745C745C746973417474723A';
wwv_flow_imp.g_varchar2_table(6707) := '20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F6E646974696F6E616C4576656E74446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(6708) := '5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224576656E74446566696E6974696F6E5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A';
wwv_flow_imp.g_varchar2_table(6709) := '205C22636F6E646974696F6E5C222C5C6E5C745C745C745C74747970653A205C2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C';
wwv_flow_imp.g_varchar2_table(6710) := '745C745C745C747D5C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225369676E616C4576656E74446566696E6974696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6711) := '5C224576656E74446566696E6974696F6E5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227369676E616C5265665C222C5C6E5C745C745C745C74747970653A';
wwv_flow_imp.g_varchar2_table(6712) := '205C225369676E616C5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A';
wwv_flow_imp.g_varchar2_table(6713) := '205C225369676E616C5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(6714) := '6E616D653A205C227374727563747572655265665C222C5C6E5C745C745C745C74747970653A205C224974656D446566696E6974696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E';
wwv_flow_imp.g_varchar2_table(6715) := '63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C';
wwv_flow_imp.g_varchar2_table(6716) := '225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22496D706C696369745468726F774576656E745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C225468726F77457665';
wwv_flow_imp.g_varchar2_table(6717) := '6E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224461746153746174655C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E';
wwv_flow_imp.g_varchar2_table(6718) := '5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C22';
wwv_flow_imp.g_varchar2_table(6719) := '5C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224974656D4177617265456C656D656E745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E74';
wwv_flow_imp.g_varchar2_table(6720) := '5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226974656D5375626A6563745265665C222C5C6E5C745C745C745C74747970653A205C224974656D446566696E';
wwv_flow_imp.g_varchar2_table(6721) := '6974696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226461746153';
wwv_flow_imp.g_varchar2_table(6722) := '746174655C222C5C6E5C745C745C745C74747970653A205C224461746153746174655C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22446174614173736F63696174696F6E5C222C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6723) := '747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22736F75726365526566';
wwv_flow_imp.g_varchar2_table(6724) := '5C222C5C6E5C745C745C745C74747970653A205C224974656D4177617265456C656D656E745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C';
wwv_flow_imp.g_varchar2_table(6725) := '5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227461726765745265665C222C5C6E5C745C745C745C74747970653A205C224974656D4177617265456C656D656E745C222C5C6E5C745C745C745C7469735265666572656E63653A2074';
wwv_flow_imp.g_varchar2_table(6726) := '7275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227472616E73666F726D6174696F6E5C222C5C6E5C745C745C745C74747970653A205C22466F726D616C45787072657373696F6E5C222C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6727) := '5C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C2270726F70657274795C225C6E5C745C745C745C747D5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2261737369676E6D';
wwv_flow_imp.g_varchar2_table(6728) := '656E745C222C5C6E5C745C745C745C74747970653A205C2241737369676E6D656E745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22';
wwv_flow_imp.g_varchar2_table(6729) := '44617461496E7075745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224974656D4177617265456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6730) := '745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E61';
wwv_flow_imp.g_varchar2_table(6731) := '6D653A205C226973436F6C6C656374696F6E5C222C5C6E5C745C745C745C745C2264656661756C745C223A2066616C73652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C22';
wwv_flow_imp.g_varchar2_table(6732) := '5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E7075745365745265665C222C5C6E5C745C745C745C74747970653A205C22496E7075745365745C222C5C6E5C745C745C745C7469734D616E793A207472';
wwv_flow_imp.g_varchar2_table(6733) := '75652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E7075745365';
wwv_flow_imp.g_varchar2_table(6734) := '74576974684F7074696F6E616C5C222C5C6E5C745C745C745C74747970653A205C22496E7075745365745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6735) := '5C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E707574536574576974685768696C65457865637574696E675C222C5C6E5C745C745C745C74747970';
wwv_flow_imp.g_varchar2_table(6736) := '653A205C22496E7075745365745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6737) := '7D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22446174614F75747075745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224974656D4177617265456C656D656E745C225C6E5C745C745D';
wwv_flow_imp.g_varchar2_table(6738) := '2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E';
wwv_flow_imp.g_varchar2_table(6739) := '675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973436F6C6C656374696F6E5C222C5C6E5C745C745C745C745C2264656661756C745C223A2066616C73652C5C6E5C745C745C745C74697341747472';
wwv_flow_imp.g_varchar2_table(6740) := '3A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F75747075745365745265665C222C5C6E5C745C745C745C7474797065';
wwv_flow_imp.g_varchar2_table(6741) := '3A205C224F75747075745365745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6742) := '7D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F7574707574536574576974684F7074696F6E616C5C222C5C6E5C745C745C745C74747970653A205C224F75747075745365745C222C5C6E5C745C745C745C7469734D616E793A';
wwv_flow_imp.g_varchar2_table(6743) := '20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F757470';
wwv_flow_imp.g_varchar2_table(6744) := '7574536574576974685768696C65457865637574696E675C222C5C6E5C745C745C745C74747970653A205C224F75747075745365745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20';
wwv_flow_imp.g_varchar2_table(6745) := '747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22496E7075745365745C222C5C6E5C745C747375706572436C617373';
wwv_flow_imp.g_varchar2_table(6746) := '3A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C74697341';
wwv_flow_imp.g_varchar2_table(6747) := '7474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2264617461496E707574526566735C222C5C6E5C745C745C745C7474';
wwv_flow_imp.g_varchar2_table(6748) := '7970653A205C2244617461496E7075745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E61';
wwv_flow_imp.g_varchar2_table(6749) := '6D653A205C226F7074696F6E616C496E707574526566735C222C5C6E5C745C745C745C74747970653A205C2244617461496E7075745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E6365';
wwv_flow_imp.g_varchar2_table(6750) := '3A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227768696C65457865637574696E67496E707574526566735C222C5C6E5C745C745C745C74747970653A205C2244617461496E7075745C222C5C';
wwv_flow_imp.g_varchar2_table(6751) := '6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F7574707574536574526566735C';
wwv_flow_imp.g_varchar2_table(6752) := '222C5C6E5C745C745C745C74747970653A205C224F75747075745365745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E';
wwv_flow_imp.g_varchar2_table(6753) := '5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224F75747075745365745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965';
wwv_flow_imp.g_varchar2_table(6754) := '733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22646174614F7574707574526566735C222C5C6E5C745C745C745C74747970653A205C22446174614F75747075745C222C5C6E5C745C745C745C7469734D616E793A20747275';
wwv_flow_imp.g_varchar2_table(6755) := '652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C74';
wwv_flow_imp.g_varchar2_table(6756) := '5C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E707574536574526566735C222C5C6E5C745C745C745C74747970653A205C22496E707574536574';
wwv_flow_imp.g_varchar2_table(6757) := '5C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F7074696F6E616C4F75';
wwv_flow_imp.g_varchar2_table(6758) := '74707574526566735C222C5C6E5C745C745C745C74747970653A205C22446174614F75747075745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6759) := '7D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227768696C65457865637574696E674F7574707574526566735C222C5C6E5C745C745C745C74747970653A205C22446174614F75747075745C222C5C6E5C745C745C745C7469734D';
wwv_flow_imp.g_varchar2_table(6760) := '616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2250726F70657274795C222C5C6E5C745C747375706572';
wwv_flow_imp.g_varchar2_table(6761) := '436C6173733A205B5C6E5C745C745C745C224974656D4177617265456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C';
wwv_flow_imp.g_varchar2_table(6762) := '745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2244617461496E7075744173736F';
wwv_flow_imp.g_varchar2_table(6763) := '63696174696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22446174614173736F63696174696F6E5C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22446174614F75747075744173';
wwv_flow_imp.g_varchar2_table(6764) := '736F63696174696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22446174614173736F63696174696F6E5C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22496E7075744F75747075';
wwv_flow_imp.g_varchar2_table(6765) := '7453706563696669636174696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6766) := '745C745C746E616D653A205C2264617461496E707574735C222C5C6E5C745C745C745C74747970653A205C2244617461496E7075745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C';
wwv_flow_imp.g_varchar2_table(6767) := '745C745C745C746E616D653A205C22646174614F7574707574735C222C5C6E5C745C745C745C74747970653A205C22446174614F75747075745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6768) := '7B5C6E5C745C745C745C746E616D653A205C22696E707574536574735C222C5C6E5C745C745C745C74747970653A205C22496E7075745365745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6769) := '7B5C6E5C745C745C745C746E616D653A205C226F7574707574536574735C222C5C6E5C745C745C745C74747970653A205C224F75747075745365745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D';
wwv_flow_imp.g_varchar2_table(6770) := '5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22446174614F626A6563745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22466C6F77456C656D656E745C222C5C6E5C745C745C745C224974656D4177617265';
wwv_flow_imp.g_varchar2_table(6771) := '456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973436F6C6C656374696F6E5C222C5C6E5C745C745C745C745C2264656661756C745C223A';
wwv_flow_imp.g_varchar2_table(6772) := '2066616C73652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22496E';
wwv_flow_imp.g_varchar2_table(6773) := '7075744F757470757442696E64696E675C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E707574446174615265665C222C5C6E5C745C745C745C74747970653A205C22496E';
wwv_flow_imp.g_varchar2_table(6774) := '7075745365745C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F757470';
wwv_flow_imp.g_varchar2_table(6775) := '7574446174615265665C222C5C6E5C745C745C745C74747970653A205C224F75747075745365745C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6776) := '7D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F7065726174696F6E5265665C222C5C6E5C745C745C745C74747970653A205C224F7065726174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C';
wwv_flow_imp.g_varchar2_table(6777) := '745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2241737369676E6D656E745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C';
wwv_flow_imp.g_varchar2_table(6778) := '745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2266726F6D5C222C5C6E5C745C745C745C74747970653A205C2245';
wwv_flow_imp.g_varchar2_table(6779) := '787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C745C745C745C747D5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6780) := '745C746E616D653A205C22746F5C222C5C6E5C745C745C745C74747970653A205C2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E';
wwv_flow_imp.g_varchar2_table(6781) := '5C745C745C745C747D5C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224461746153746F72655C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D65';
wwv_flow_imp.g_varchar2_table(6782) := '6E745C222C5C6E5C745C745C745C224974656D4177617265456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6783) := '5C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2263617061636974795C222C5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(6784) := '746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22496E74656765725C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973556E6C696D697465645C222C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6785) := '5C745C2264656661756C745C223A20747275652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C';
wwv_flow_imp.g_varchar2_table(6786) := '745C746E616D653A205C224461746153746F72655265666572656E63655C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224974656D4177617265456C656D656E745C222C5C6E5C745C745C745C22466C6F77456C656D656E';
wwv_flow_imp.g_varchar2_table(6787) := '745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226461746153746F72655265665C222C5C6E5C745C745C745C74747970653A205C224461746153746F72655C';
wwv_flow_imp.g_varchar2_table(6788) := '222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22446174614F626A';
wwv_flow_imp.g_varchar2_table(6789) := '6563745265666572656E63655C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224974656D4177617265456C656D656E745C222C5C6E5C745C745C745C22466C6F77456C656D656E745C225C6E5C745C745D2C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6790) := '70726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22646174614F626A6563745265665C222C5C6E5C745C745C745C74747970653A205C22446174614F626A6563745C222C5C6E5C745C745C745C74697341';
wwv_flow_imp.g_varchar2_table(6791) := '7474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F6E766572736174696F6E4C696E6B5C222C5C6E5C';
wwv_flow_imp.g_varchar2_table(6792) := '745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22736F7572636552';
wwv_flow_imp.g_varchar2_table(6793) := '65665C222C5C6E5C745C745C745C74747970653A205C22496E746572616374696F6E4E6F64655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D';
wwv_flow_imp.g_varchar2_table(6794) := '2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227461726765745265665C222C5C6E5C745C745C745C74747970653A205C22496E746572616374696F6E4E6F64655C222C5C6E5C745C745C745C746973417474723A20747275652C5C';
wwv_flow_imp.g_varchar2_table(6795) := '6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6796) := '745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F6E766572736174696F6E4173736F63696174696F6E5C222C5C6E5C745C747375706572436C61';
wwv_flow_imp.g_varchar2_table(6797) := '73733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E6E6572436F6E766572736174696F6E4E';
wwv_flow_imp.g_varchar2_table(6798) := '6F64655265665C222C5C6E5C745C745C745C74747970653A205C22436F6E766572736174696F6E4E6F64655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C74';
wwv_flow_imp.g_varchar2_table(6799) := '5C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F75746572436F6E766572736174696F6E4E6F64655265665C222C5C6E5C745C745C745C74747970653A205C22436F6E766572736174696F6E4E6F64655C222C5C6E5C';
wwv_flow_imp.g_varchar2_table(6800) := '745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2243616C6C436F6E7665727361';
wwv_flow_imp.g_varchar2_table(6801) := '74696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22436F6E766572736174696F6E4E6F64655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(6802) := '6E616D653A205C2263616C6C6564436F6C6C61626F726174696F6E5265665C222C5C6E5C745C745C745C74747970653A205C22436F6C6C61626F726174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(6803) := '69735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227061727469636970616E744173736F63696174696F6E735C222C5C6E5C745C745C745C74747970653A205C225061';
wwv_flow_imp.g_varchar2_table(6804) := '727469636970616E744173736F63696174696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F6E766572736174696F6E5C22';
wwv_flow_imp.g_varchar2_table(6805) := '2C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22436F6E766572736174696F6E4E6F64655C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22537562436F6E766572736174696F6E5C222C5C6E';
wwv_flow_imp.g_varchar2_table(6806) := '5C745C747375706572436C6173733A205B5C6E5C745C745C745C22436F6E766572736174696F6E4E6F64655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2263';
wwv_flow_imp.g_varchar2_table(6807) := '6F6E766572736174696F6E4E6F6465735C222C5C6E5C745C745C745C74747970653A205C22436F6E766572736174696F6E4E6F64655C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C';
wwv_flow_imp.g_varchar2_table(6808) := '5C6E5C747B5C6E5C745C746E616D653A205C22436F6E766572736174696F6E4E6F64655C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22496E746572616374696F';
wwv_flow_imp.g_varchar2_table(6809) := '6E4E6F64655C222C5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6810) := '5C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227061727469636970616E745265665C222C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6811) := '745C745C74747970653A205C225061727469636970616E745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C74';
wwv_flow_imp.g_varchar2_table(6812) := '5C745C745C746E616D653A205C226D657373616765466C6F77526566735C222C5C6E5C745C745C745C74747970653A205C224D657373616765466C6F775C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C74697352';
wwv_flow_imp.g_varchar2_table(6813) := '65666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F7272656C6174696F6E4B6579735C222C5C6E5C745C745C745C74747970653A205C22436F7272656C6174696F6E4B65';
wwv_flow_imp.g_varchar2_table(6814) := '795C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22476C6F62616C436F6E766572736174696F6E5C222C5C6E5C745C74737570657243';
wwv_flow_imp.g_varchar2_table(6815) := '6C6173733A205B5C6E5C745C745C745C22436F6C6C61626F726174696F6E5C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22506172746E6572456E746974795C222C5C6E5C745C747375706572436C6173733A205B5C';
wwv_flow_imp.g_varchar2_table(6816) := '6E5C745C745C745C22526F6F74456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A';
wwv_flow_imp.g_varchar2_table(6817) := '20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227061727469636970616E745265665C222C5C6E5C745C745C745C7474797065';
wwv_flow_imp.g_varchar2_table(6818) := '3A205C225061727469636970616E745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6819) := '746E616D653A205C22506172746E6572526F6C655C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6820) := '7B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6821) := '5C745C746E616D653A205C227061727469636970616E745265665C222C5C6E5C745C745C745C74747970653A205C225061727469636970616E745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C74697352656665';
wwv_flow_imp.g_varchar2_table(6822) := '72656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F7272656C6174696F6E50726F70657274795C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6823) := '745C22526F6F74456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F7272656C6174696F6E50726F706572747952657472696576616C4578';
wwv_flow_imp.g_varchar2_table(6824) := '7072657373696F6E5C222C5C6E5C745C745C745C74747970653A205C22436F7272656C6174696F6E50726F706572747952657472696576616C45787072657373696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6825) := '7D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6826) := '745C747B5C6E5C745C745C745C746E616D653A205C22747970655C222C5C6E5C745C745C745C74747970653A205C224974656D446566696E6974696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74697352';
wwv_flow_imp.g_varchar2_table(6827) := '65666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224572726F725C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D';
wwv_flow_imp.g_varchar2_table(6828) := '656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227374727563747572655265665C222C5C6E5C745C745C745C74747970653A205C224974656D44656669';
wwv_flow_imp.g_varchar2_table(6829) := '6E6974696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D65';
wwv_flow_imp.g_varchar2_table(6830) := '5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226572726F72436F64655C22';
wwv_flow_imp.g_varchar2_table(6831) := '2C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F7272656C617469';
wwv_flow_imp.g_varchar2_table(6832) := '6F6E4B65795C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D65';
wwv_flow_imp.g_varchar2_table(6833) := '3A205C22636F7272656C6174696F6E50726F70657274795265665C222C5C6E5C745C745C745C74747970653A205C22436F7272656C6174696F6E50726F70657274795C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6834) := '5C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7474797065';
wwv_flow_imp.g_varchar2_table(6835) := '3A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2245787072657373696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224261736545';
wwv_flow_imp.g_varchar2_table(6836) := '6C656D656E745C225C6E5C745C745D2C5C6E5C745C74697341627374726163743A2066616C73652C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22626F64795C222C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6837) := '745C746973426F64793A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22466F726D616C45787072657373696F6E5C';
wwv_flow_imp.g_varchar2_table(6838) := '222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2245787072657373696F6E5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C616E';
wwv_flow_imp.g_varchar2_table(6839) := '67756167655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226576616C7561';
wwv_flow_imp.g_varchar2_table(6840) := '746573546F547970655265665C222C5C6E5C745C745C745C74747970653A205C224974656D446566696E6974696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A2074727565';
wwv_flow_imp.g_varchar2_table(6841) := '5C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224D6573736167655C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D656E745C225C6E5C745C745D';
wwv_flow_imp.g_varchar2_table(6842) := '2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E';
wwv_flow_imp.g_varchar2_table(6843) := '675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226974656D5265665C222C5C6E5C745C745C745C74747970653A205C224974656D446566696E6974696F6E5C222C5C6E5C745C745C745C746973417474';
wwv_flow_imp.g_varchar2_table(6844) := '723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224974656D446566696E6974696F6E5C222C5C6E5C745C7473';
wwv_flow_imp.g_varchar2_table(6845) := '75706572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226974656D4B696E645C222C';
wwv_flow_imp.g_varchar2_table(6846) := '5C6E5C745C745C745C74747970653A205C224974656D4B696E645C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22737472756374757265526566';
wwv_flow_imp.g_varchar2_table(6847) := '5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973436F6C6C656374696F';
wwv_flow_imp.g_varchar2_table(6848) := '6E5C222C5C6E5C745C745C745C745C2264656661756C745C223A2066616C73652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6849) := '747B5C6E5C745C745C745C746E616D653A205C22696D706F72745C222C5C6E5C745C745C745C74747970653A205C22496D706F72745C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E6365';
wwv_flow_imp.g_varchar2_table(6850) := '3A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22466C6F77456C656D656E745C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C617373';
wwv_flow_imp.g_varchar2_table(6851) := '3A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C74697341';
wwv_flow_imp.g_varchar2_table(6852) := '7474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226175646974696E675C222C5C6E5C745C745C745C74747970653A20';
wwv_flow_imp.g_varchar2_table(6853) := '5C224175646974696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D6F6E69746F72696E675C222C5C6E5C745C745C745C74747970653A205C224D6F6E69746F72696E675C225C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6854) := '7D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2263617465676F727956616C75655265665C222C5C6E5C745C745C745C74747970653A205C2243617465676F727956616C75655C222C5C6E5C745C745C745C7469734D616E793A20';
wwv_flow_imp.g_varchar2_table(6855) := '747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2253657175656E6365466C6F775C222C5C6E5C745C74737570657243';
wwv_flow_imp.g_varchar2_table(6856) := '6C6173733A205B5C6E5C745C745C745C22466C6F77456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973496D6D6564696174655C222C5C6E';
wwv_flow_imp.g_varchar2_table(6857) := '5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F6E646974696F6E457870726573';
wwv_flow_imp.g_varchar2_table(6858) := '73696F6E5C222C5C6E5C745C745C745C74747970653A205C2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C745C745C745C747D';
wwv_flow_imp.g_varchar2_table(6859) := '5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22736F757263655265665C222C5C6E5C745C745C745C74747970653A205C22466C6F774E6F64655C222C5C6E5C745C745C745C746973417474723A2074727565';
wwv_flow_imp.g_varchar2_table(6860) := '2C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227461726765745265665C222C5C6E5C745C745C745C74747970653A205C22466C6F774E';
wwv_flow_imp.g_varchar2_table(6861) := '6F64655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22466C6F';
wwv_flow_imp.g_varchar2_table(6862) := '77456C656D656E7473436F6E7461696E65725C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6863) := '70726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C616E65536574735C222C5C6E5C745C745C745C74747970653A205C224C616E655365745C222C5C6E5C745C745C745C7469734D616E793A20747275';
wwv_flow_imp.g_varchar2_table(6864) := '655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22666C6F77456C656D656E74735C222C5C6E5C745C745C745C74747970653A205C22466C6F77456C656D656E745C222C5C6E5C745C745C745C7469734D616E';
wwv_flow_imp.g_varchar2_table(6865) := '793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2243616C6C61626C65456C656D656E745C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572';
wwv_flow_imp.g_varchar2_table(6866) := '436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6867) := '5C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696F53706563696669636174696F6E5C222C5C6E5C74';
wwv_flow_imp.g_varchar2_table(6868) := '5C745C745C74747970653A205C22496E7075744F757470757453706563696669636174696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C2270726F70657274795C225C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6869) := '5C747D5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22737570706F72746564496E746572666163655265665C222C5C6E5C745C745C745C74747970653A205C22496E746572666163655C222C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6870) := '5C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696F42696E64696E675C222C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6871) := '745C74747970653A205C22496E7075744F757470757442696E64696E675C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C2270726F70';
wwv_flow_imp.g_varchar2_table(6872) := '657274795C225C6E5C745C745C745C747D5C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22466C6F774E6F64655C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375';
wwv_flow_imp.g_varchar2_table(6873) := '706572436C6173733A205B5C6E5C745C745C745C22466C6F77456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E636F6D696E675C222C5C';
wwv_flow_imp.g_varchar2_table(6874) := '6E5C745C745C745C74747970653A205C2253657175656E6365466C6F775C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6875) := '7B5C6E5C745C745C745C746E616D653A205C226F7574676F696E675C222C5C6E5C745C745C745C74747970653A205C2253657175656E6365466C6F775C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265';
wwv_flow_imp.g_varchar2_table(6876) := '666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C616E65735C222C5C6E5C745C745C745C74747970653A205C224C616E655C222C5C6E5C745C745C745C7469734D616E793A';
wwv_flow_imp.g_varchar2_table(6877) := '20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22';
wwv_flow_imp.g_varchar2_table(6878) := '436F7272656C6174696F6E50726F706572747952657472696576616C45787072657373696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F';
wwv_flow_imp.g_varchar2_table(6879) := '706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D657373616765506174685C222C5C6E5C745C745C745C74747970653A205C22466F726D616C45787072657373696F6E5C225C6E5C745C745C747D2C5C6E5C';
wwv_flow_imp.g_varchar2_table(6880) := '745C745C747B5C6E5C745C745C745C746E616D653A205C226D6573736167655265665C222C5C6E5C745C745C745C74747970653A205C224D6573736167655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C746973';
wwv_flow_imp.g_varchar2_table(6881) := '5265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F7272656C6174696F6E50726F706572747942696E64696E675C222C5C6E5C745C747375706572436C6173';
wwv_flow_imp.g_varchar2_table(6882) := '733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2264617461506174685C222C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6883) := '5C74747970653A205C22466F726D616C45787072657373696F6E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F7272656C6174696F6E50726F70657274795265665C222C5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(6884) := '747970653A205C22436F7272656C6174696F6E50726F70657274795C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C74';
wwv_flow_imp.g_varchar2_table(6885) := '7D2C5C6E5C747B5C6E5C745C746E616D653A205C225265736F757263655C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A20';
wwv_flow_imp.g_varchar2_table(6886) := '5B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6887) := '5C747B5C6E5C745C745C745C746E616D653A205C227265736F75726365506172616D65746572735C222C5C6E5C745C745C745C74747970653A205C225265736F75726365506172616D657465725C222C5C6E5C745C745C745C7469734D616E793A207472';
wwv_flow_imp.g_varchar2_table(6888) := '75655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225265736F75726365506172616D657465725C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D';
wwv_flow_imp.g_varchar2_table(6889) := '656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7474';
wwv_flow_imp.g_varchar2_table(6890) := '7970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22697352657175697265645C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C747479';
wwv_flow_imp.g_varchar2_table(6891) := '70653A205C22426F6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22747970655C222C5C6E5C745C745C745C74747970653A205C224974656D446566696E6974696F6E5C222C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6892) := '5C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F7272656C6174696F6E53756273';
wwv_flow_imp.g_varchar2_table(6893) := '6372697074696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E';
wwv_flow_imp.g_varchar2_table(6894) := '616D653A205C22636F7272656C6174696F6E4B65795265665C222C5C6E5C745C745C745C74747970653A205C22436F7272656C6174696F6E4B65795C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C746973526566';
wwv_flow_imp.g_varchar2_table(6895) := '6572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F7272656C6174696F6E50726F706572747942696E64696E675C222C5C6E5C745C745C745C74747970653A205C22436F7272';
wwv_flow_imp.g_varchar2_table(6896) := '656C6174696F6E50726F706572747942696E64696E675C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224D657373616765466C6F775C';
wwv_flow_imp.g_varchar2_table(6897) := '222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E61';
wwv_flow_imp.g_varchar2_table(6898) := '6D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22736F75726365526566';
wwv_flow_imp.g_varchar2_table(6899) := '5C222C5C6E5C745C745C745C74747970653A205C22496E746572616374696F6E4E6F64655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C';
wwv_flow_imp.g_varchar2_table(6900) := '6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227461726765745265665C222C5C6E5C745C745C745C74747970653A205C22496E746572616374696F6E4E6F64655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C';
wwv_flow_imp.g_varchar2_table(6901) := '745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D6573736167655265665C222C5C6E5C745C745C745C74747970653A205C224D6573736167655C';
wwv_flow_imp.g_varchar2_table(6902) := '222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224D657373616765';
wwv_flow_imp.g_varchar2_table(6903) := '466C6F774173736F63696174696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C74';
wwv_flow_imp.g_varchar2_table(6904) := '5C745C745C746E616D653A205C22696E6E65724D657373616765466C6F775265665C222C5C6E5C745C745C745C74747970653A205C224D657373616765466C6F775C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(6905) := '7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F757465724D657373616765466C6F775265665C222C5C6E5C745C745C745C74747970653A205C224D65737361';
wwv_flow_imp.g_varchar2_table(6906) := '6765466C6F775C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22';
wwv_flow_imp.g_varchar2_table(6907) := '496E746572616374696F6E4E6F64655C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E636F6D696E67436F6E7665';
wwv_flow_imp.g_varchar2_table(6908) := '72736174696F6E4C696E6B735C222C5C6E5C745C745C745C74747970653A205C22436F6E766572736174696F6E4C696E6B5C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735669727475616C3A2074727565';
wwv_flow_imp.g_varchar2_table(6909) := '2C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F7574676F696E67436F6E766572736174696F6E4C696E6B735C222C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6910) := '745C74747970653A205C22436F6E766572736174696F6E4C696E6B5C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E6365';
wwv_flow_imp.g_varchar2_table(6911) := '3A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225061727469636970616E745C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22496E746572616374696F';
wwv_flow_imp.g_varchar2_table(6912) := '6E4E6F64655C222C5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6913) := '5C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E746572666163655265665C222C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6914) := '745C74747970653A205C22496E746572666163655C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6915) := '5C746E616D653A205C227061727469636970616E744D756C7469706C69636974795C222C5C6E5C745C745C745C74747970653A205C225061727469636970616E744D756C7469706C69636974795C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E';
wwv_flow_imp.g_varchar2_table(6916) := '5C745C745C745C746E616D653A205C22656E64506F696E74526566735C222C5C6E5C745C745C745C74747970653A205C22456E64506F696E745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572';
wwv_flow_imp.g_varchar2_table(6917) := '656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2270726F636573735265665C222C5C6E5C745C745C745C74747970653A205C2250726F636573735C222C5C6E5C745C745C745C746973';
wwv_flow_imp.g_varchar2_table(6918) := '417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225061727469636970616E744173736F63696174696F';
wwv_flow_imp.g_varchar2_table(6919) := '6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22';
wwv_flow_imp.g_varchar2_table(6920) := '696E6E65725061727469636970616E745265665C222C5C6E5C745C745C745C74747970653A205C225061727469636970616E745C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20';
wwv_flow_imp.g_varchar2_table(6921) := '747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F757465725061727469636970616E745265665C222C5C6E5C745C745C745C74747970653A205C225061727469636970616E745C222C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6922) := '745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225061727469636970616E744D756C';
wwv_flow_imp.g_varchar2_table(6923) := '7469706C69636974795C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D696E696D756D5C222C5C6E5C745C745C745C745C2264656661756C745C223A20302C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6924) := '745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22496E74656765725C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D6178696D756D5C222C5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(6925) := '5C2264656661756C745C223A20312C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22496E74656765725C225C6E5C745C745C747D5C6E5C745C745D2C5C6E5C745C747375706572436C6173733A20';
wwv_flow_imp.g_varchar2_table(6926) := '5B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F6C6C61626F726174696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(6927) := '22526F6F74456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E';
wwv_flow_imp.g_varchar2_table(6928) := '5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973436C6F7365645C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6929) := '745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227061727469636970616E74735C222C5C6E5C745C745C745C74747970653A205C225061727469636970';
wwv_flow_imp.g_varchar2_table(6930) := '616E745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D657373616765466C6F77735C222C5C6E5C745C745C745C74747970653A205C224D65';
wwv_flow_imp.g_varchar2_table(6931) := '7373616765466C6F775C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226172746966616374735C222C5C6E5C745C745C745C74747970653A205C';
wwv_flow_imp.g_varchar2_table(6932) := '2241727469666163745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F6E766572736174696F6E735C222C5C6E5C745C745C745C74747970';
wwv_flow_imp.g_varchar2_table(6933) := '653A205C22436F6E766572736174696F6E4E6F64655C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F6E766572736174696F6E4173736F63';
wwv_flow_imp.g_varchar2_table(6934) := '696174696F6E735C222C5C6E5C745C745C745C74747970653A205C22436F6E766572736174696F6E4173736F63696174696F6E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227061727469636970616E';
wwv_flow_imp.g_varchar2_table(6935) := '744173736F63696174696F6E735C222C5C6E5C745C745C745C74747970653A205C225061727469636970616E744173736F63696174696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B';
wwv_flow_imp.g_varchar2_table(6936) := '5C6E5C745C745C745C746E616D653A205C226D657373616765466C6F774173736F63696174696F6E735C222C5C6E5C745C745C745C74747970653A205C224D657373616765466C6F774173736F63696174696F6E5C222C5C6E5C745C745C745C7469734D';
wwv_flow_imp.g_varchar2_table(6937) := '616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F7272656C6174696F6E4B6579735C222C5C6E5C745C745C745C74747970653A205C22436F7272656C6174696F6E4B65795C222C5C';
wwv_flow_imp.g_varchar2_table(6938) := '6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2263686F72656F6772617068795265665C222C5C6E5C745C745C745C74747970653A205C2243686F72656F';
wwv_flow_imp.g_varchar2_table(6939) := '6772617068795C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F6E76';
wwv_flow_imp.g_varchar2_table(6940) := '6572736174696F6E4C696E6B735C222C5C6E5C745C745C745C74747970653A205C22436F6E766572736174696F6E4C696E6B5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C';
wwv_flow_imp.g_varchar2_table(6941) := '747B5C6E5C745C746E616D653A205C2243686F72656F67726170687941637469766974795C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22466C6F774E6F64655C';
wwv_flow_imp.g_varchar2_table(6942) := '225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227061727469636970616E745265665C222C5C6E5C745C745C745C74747970653A205C225061727469636970616E';
wwv_flow_imp.g_varchar2_table(6943) := '745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E6974696174696E';
wwv_flow_imp.g_varchar2_table(6944) := '675061727469636970616E745265665C222C5C6E5C745C745C745C74747970653A205C225061727469636970616E745C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A2074727565';
wwv_flow_imp.g_varchar2_table(6945) := '5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F7272656C6174696F6E4B6579735C222C5C6E5C745C745C745C74747970653A205C22436F7272656C6174696F6E4B65795C222C5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(6946) := '69734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C6F6F70547970655C222C5C6E5C745C745C745C74747970653A205C2243686F72656F6772617068794C6F6F70547970655C22';
wwv_flow_imp.g_varchar2_table(6947) := '2C5C6E5C745C745C745C745C2264656661756C745C223A205C224E6F6E655C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2243616C6C';
wwv_flow_imp.g_varchar2_table(6948) := '43686F72656F6772617068795C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2243686F72656F67726170687941637469766974795C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6949) := '747B5C6E5C745C745C745C746E616D653A205C2263616C6C656443686F72656F6772617068795265665C222C5C6E5C745C745C745C74747970653A205C2243686F72656F6772617068795C222C5C6E5C745C745C745C746973417474723A20747275652C';
wwv_flow_imp.g_varchar2_table(6950) := '5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227061727469636970616E744173736F63696174696F6E735C222C5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(6951) := '747970653A205C225061727469636970616E744173736F63696174696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2253756243';
wwv_flow_imp.g_varchar2_table(6952) := '686F72656F6772617068795C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2243686F72656F67726170687941637469766974795C222C5C6E5C745C745C745C22466C6F77456C656D656E7473436F6E7461696E65725C225C';
wwv_flow_imp.g_varchar2_table(6953) := '6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226172746966616374735C222C5C6E5C745C745C745C74747970653A205C2241727469666163745C222C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6954) := '5C745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2243686F72656F6772617068795461736B5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6955) := '745C745C2243686F72656F67726170687941637469766974795C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D657373616765466C6F775265665C222C5C6E';
wwv_flow_imp.g_varchar2_table(6956) := '5C745C745C745C74747970653A205C224D657373616765466C6F775C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C74';
wwv_flow_imp.g_varchar2_table(6957) := '7D2C5C6E5C747B5C6E5C745C746E616D653A205C2243686F72656F6772617068795C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22436F6C6C61626F726174696F6E5C222C5C6E5C745C745C745C22466C6F77456C656D65';
wwv_flow_imp.g_varchar2_table(6958) := '6E7473436F6E7461696E65725C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22476C6F62616C43686F72656F6772617068795461736B5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22';
wwv_flow_imp.g_varchar2_table(6959) := '43686F72656F6772617068795C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E6974696174696E675061727469636970616E745265665C222C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6960) := '745C745C74747970653A205C225061727469636970616E745C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C';
wwv_flow_imp.g_varchar2_table(6961) := '6E5C747B5C6E5C745C746E616D653A205C2254657874416E6E6F746174696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2241727469666163745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A20';
wwv_flow_imp.g_varchar2_table(6962) := '5B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22746578745C222C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227465';
wwv_flow_imp.g_varchar2_table(6963) := '7874466F726D61745C222C5C6E5C745C745C745C745C2264656661756C745C223A205C22746578742F706C61696E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E';
wwv_flow_imp.g_varchar2_table(6964) := '5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2247726F75705C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2241727469666163745C225C6E5C745C745D2C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6965) := '70726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2263617465676F727956616C75655265665C222C5C6E5C745C745C745C74747970653A205C2243617465676F727956616C75655C222C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6966) := '745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224173736F63696174696F6E5C222C5C6E';
wwv_flow_imp.g_varchar2_table(6967) := '5C745C747375706572436C6173733A205B5C6E5C745C745C745C2241727469666163745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226173736F6369617469';
wwv_flow_imp.g_varchar2_table(6968) := '6F6E446972656374696F6E5C222C5C6E5C745C745C745C74747970653A205C224173736F63696174696F6E446972656374696F6E5C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C74';
wwv_flow_imp.g_varchar2_table(6969) := '5C745C745C746E616D653A205C22736F757263655265665C222C5C6E5C745C745C745C74747970653A205C2242617365456C656D656E745C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E';
wwv_flow_imp.g_varchar2_table(6970) := '63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227461726765745265665C222C5C6E5C745C745C745C74747970653A205C2242617365456C656D656E745C222C5C6E5C745C745C745C7469';
wwv_flow_imp.g_varchar2_table(6971) := '73417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2243617465676F72795C222C5C6E5C745C74737570';
wwv_flow_imp.g_varchar2_table(6972) := '6572436C6173733A205B5C6E5C745C745C745C22526F6F74456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2263617465676F727956616C7565';
wwv_flow_imp.g_varchar2_table(6973) := '5C222C5C6E5C745C745C745C74747970653A205C2243617465676F727956616C75655C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D65';
wwv_flow_imp.g_varchar2_table(6974) := '5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2241727469666163';
wwv_flow_imp.g_varchar2_table(6975) := '745C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C';
wwv_flow_imp.g_varchar2_table(6976) := '2243617465676F727956616C75655C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(6977) := '745C745C746E616D653A205C2263617465676F72697A6564466C6F77456C656D656E74735C222C5C6E5C745C745C745C74747970653A205C22466C6F77456C656D656E745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(6978) := '5C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2276616C75655C222C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6979) := '5C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2241637469766974795C222C5C6E5C745C7469';
wwv_flow_imp.g_varchar2_table(6980) := '7341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22466C6F774E6F64655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(6981) := '746E616D653A205C226973466F72436F6D70656E736174696F6E5C222C5C6E5C745C745C745C745C2264656661756C745C223A2066616C73652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C2242';
wwv_flow_imp.g_varchar2_table(6982) := '6F6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2264656661756C745C222C5C6E5C745C745C745C74747970653A205C2253657175656E6365466C6F775C222C5C6E5C745C745C745C746973';
wwv_flow_imp.g_varchar2_table(6983) := '417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696F53706563696669636174696F6E5C222C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6984) := '745C74747970653A205C22496E7075744F757470757453706563696669636174696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C2270726F70657274795C225C6E5C745C745C745C747D';
wwv_flow_imp.g_varchar2_table(6985) := '5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22626F756E646172794576656E74526566735C222C5C6E5C745C745C745C74747970653A205C22426F756E646172794576656E745C222C5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(6986) := '7469734D616E793A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2270726F706572746965735C222C5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(6987) := '74747970653A205C2250726F70657274795C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2264617461496E7075744173736F63696174696F6E73';
wwv_flow_imp.g_varchar2_table(6988) := '5C222C5C6E5C745C745C745C74747970653A205C2244617461496E7075744173736F63696174696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A';
wwv_flow_imp.g_varchar2_table(6989) := '205C22646174614F75747075744173736F63696174696F6E735C222C5C6E5C745C745C745C74747970653A205C22446174614F75747075744173736F63696174696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(6990) := '7D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2273746172745175616E746974795C222C5C6E5C745C745C745C745C2264656661756C745C223A20312C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(6991) := '745C74747970653A205C22496E74656765725C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227265736F75726365735C222C5C6E5C745C745C745C74747970653A205C225265736F75726365526F6C655C';
wwv_flow_imp.g_varchar2_table(6992) := '222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F6D706C6574696F6E5175616E746974795C222C5C6E5C745C745C745C745C2264656661756C';
wwv_flow_imp.g_varchar2_table(6993) := '745C223A20312C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22496E74656765725C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C6F6F704368';
wwv_flow_imp.g_varchar2_table(6994) := '617261637465726973746963735C222C5C6E5C745C745C745C74747970653A205C224C6F6F704368617261637465726973746963735C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2253657276';
wwv_flow_imp.g_varchar2_table(6995) := '6963655461736B5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C225461736B5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2269';
wwv_flow_imp.g_varchar2_table(6996) := '6D706C656D656E746174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A20';
wwv_flow_imp.g_varchar2_table(6997) := '5C226F7065726174696F6E5265665C222C5C6E5C745C745C745C74747970653A205C224F7065726174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C';
wwv_flow_imp.g_varchar2_table(6998) := '745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2253756250726F636573735C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2241637469766974795C222C5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(6999) := '22466C6F77456C656D656E7473436F6E7461696E65725C222C5C6E5C745C745C745C22496E746572616374696F6E4E6F64655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E61';
wwv_flow_imp.g_varchar2_table(7000) := '6D653A205C2274726967676572656442794576656E745C222C5C6E5C745C745C745C745C2264656661756C745C223A2066616C73652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65';
wwv_flow_imp.g_varchar2_table(7001) := '616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226172746966616374735C222C5C6E5C745C745C745C74747970653A205C2241727469666163745C222C5C6E5C745C745C745C7469734D616E793A20';
wwv_flow_imp.g_varchar2_table(7002) := '747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224C6F6F704368617261637465726973746963735C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C7473757065';
wwv_flow_imp.g_varchar2_table(7003) := '72436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224D756C7469496E7374616E63654C6F6F704368617261637465726973746963735C222C5C';
wwv_flow_imp.g_varchar2_table(7004) := '6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224C6F6F704368617261637465726973746963735C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A';
wwv_flow_imp.g_varchar2_table(7005) := '205C22697353657175656E7469616C5C222C5C6E5C745C745C745C745C2264656661756C745C223A2066616C73652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C';
wwv_flow_imp.g_varchar2_table(7006) := '745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226265686176696F725C222C5C6E5C745C745C745C74747970653A205C224D756C7469496E7374616E63654265686176696F725C222C5C6E5C745C745C745C745C2264';
wwv_flow_imp.g_varchar2_table(7007) := '656661756C745C223A205C22416C6C5C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C6F6F7043617264696E616C6974795C222C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(7008) := '745C745C74747970653A205C2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C745C745C745C747D5C6E5C745C745C747D2C5C6E';
wwv_flow_imp.g_varchar2_table(7009) := '5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C6F6F7044617461496E7075745265665C222C5C6E5C745C745C745C74747970653A205C224974656D4177617265456C656D656E745C222C5C6E5C745C745C745C7469735265666572656E';
wwv_flow_imp.g_varchar2_table(7010) := '63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C6F6F70446174614F75747075745265665C222C5C6E5C745C745C745C74747970653A205C224974656D4177617265456C656D656E745C';
wwv_flow_imp.g_varchar2_table(7011) := '222C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E707574446174614974656D5C222C5C6E5C745C745C745C74747970653A205C22';
wwv_flow_imp.g_varchar2_table(7012) := '44617461496E7075745C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C2270726F70657274795C225C6E5C745C745C745C747D5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(7013) := '745C746E616D653A205C226F7574707574446174614974656D5C222C5C6E5C745C745C745C74747970653A205C22446174614F75747075745C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C22';
wwv_flow_imp.g_varchar2_table(7014) := '70726F70657274795C225C6E5C745C745C745C747D5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F6D706C65784265686176696F72446566696E6974696F6E5C222C5C6E5C745C745C745C7474797065';
wwv_flow_imp.g_varchar2_table(7015) := '3A205C22436F6D706C65784265686176696F72446566696E6974696F6E5C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F6D706C6574696F';
wwv_flow_imp.g_varchar2_table(7016) := '6E436F6E646974696F6E5C222C5C6E5C745C745C745C74747970653A205C2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C745C';
wwv_flow_imp.g_varchar2_table(7017) := '745C745C747D5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F6E654265686176696F724576656E745265665C222C5C6E5C745C745C745C74747970653A205C224576656E74446566696E6974696F6E5C22';
wwv_flow_imp.g_varchar2_table(7018) := '2C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E6F6E654265686176696F72';
wwv_flow_imp.g_varchar2_table(7019) := '4576656E745265665C222C5C6E5C745C745C745C74747970653A205C224576656E74446566696E6974696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C';
wwv_flow_imp.g_varchar2_table(7020) := '745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225374616E646172644C6F6F704368617261637465726973746963735C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224C6F6F';
wwv_flow_imp.g_varchar2_table(7021) := '704368617261637465726973746963735C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22746573744265666F72655C222C5C6E5C745C745C745C745C22646566';
wwv_flow_imp.g_varchar2_table(7022) := '61756C745C223A2066616C73652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C';
wwv_flow_imp.g_varchar2_table(7023) := '226C6F6F70436F6E646974696F6E5C222C5C6E5C745C745C745C74747970653A205C2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C';
wwv_flow_imp.g_varchar2_table(7024) := '6E5C745C745C745C747D5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C6F6F704D6178696D756D5C222C5C6E5C745C745C745C74747970653A205C22496E74656765725C222C5C6E5C745C745C745C7469';
wwv_flow_imp.g_varchar2_table(7025) := '73417474723A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2243616C6C41637469766974795C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2241637469';
wwv_flow_imp.g_varchar2_table(7026) := '766974795C222C5C6E5C745C745C745C22496E746572616374696F6E4E6F64655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2263616C6C6564456C656D656E';
wwv_flow_imp.g_varchar2_table(7027) := '745C222C5C6E5C745C745C745C74747970653A205C22537472696E675C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225461736B5C22';
wwv_flow_imp.g_varchar2_table(7028) := '2C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2241637469766974795C222C5C6E5C745C745C745C22496E746572616374696F6E4E6F64655C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22';
wwv_flow_imp.g_varchar2_table(7029) := '53656E645461736B5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C225461736B5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22';
wwv_flow_imp.g_varchar2_table(7030) := '696D706C656D656E746174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A';
wwv_flow_imp.g_varchar2_table(7031) := '205C226F7065726174696F6E5265665C222C5C6E5C745C745C745C74747970653A205C224F7065726174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E';
wwv_flow_imp.g_varchar2_table(7032) := '5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D6573736167655265665C222C5C6E5C745C745C745C74747970653A205C224D6573736167655C222C5C6E5C745C745C745C746973417474723A20747275652C5C';
wwv_flow_imp.g_varchar2_table(7033) := '6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22526563656976655461736B5C222C5C6E5C745C747375706572436C6173733A205B';
wwv_flow_imp.g_varchar2_table(7034) := '5C6E5C745C745C745C225461736B5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696D706C656D656E746174696F6E5C222C5C6E5C745C745C745C74697341';
wwv_flow_imp.g_varchar2_table(7035) := '7474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E7374616E74696174655C222C5C6E5C745C745C745C745C2264';
wwv_flow_imp.g_varchar2_table(7036) := '656661756C745C223A2066616C73652C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A';
wwv_flow_imp.g_varchar2_table(7037) := '205C226F7065726174696F6E5265665C222C5C6E5C745C745C745C74747970653A205C224F7065726174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E';
wwv_flow_imp.g_varchar2_table(7038) := '5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D6573736167655265665C222C5C6E5C745C745C745C74747970653A205C224D6573736167655C222C5C6E5C745C745C745C746973417474723A20747275652C5C';
wwv_flow_imp.g_varchar2_table(7039) := '6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225363726970745461736B5C222C5C6E5C745C747375706572436C6173733A205B5C';
wwv_flow_imp.g_varchar2_table(7040) := '6E5C745C745C745C225461736B5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22736372697074466F726D61745C222C5C6E5C745C745C745C74697341747472';
wwv_flow_imp.g_varchar2_table(7041) := '3A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227363726970745C222C5C6E5C745C745C745C74747970653A205C22537472';
wwv_flow_imp.g_varchar2_table(7042) := '696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22427573696E65737352756C655461736B5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C225461736B5C22';
wwv_flow_imp.g_varchar2_table(7043) := '5C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696D706C656D656E746174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(7044) := '5C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224164486F6353756250726F636573735C222C5C6E5C745C747375706572436C6173733A205B5C6E';
wwv_flow_imp.g_varchar2_table(7045) := '5C745C745C745C2253756250726F636573735C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F6D706C6574696F6E436F6E646974696F6E5C222C5C6E5C74';
wwv_flow_imp.g_varchar2_table(7046) := '5C745C745C74747970653A205C2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C745C745C745C747D5C6E5C745C745C747D2C5C';
wwv_flow_imp.g_varchar2_table(7047) := '6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F72646572696E675C222C5C6E5C745C745C745C74747970653A205C224164486F634F72646572696E675C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(7048) := '747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2263616E63656C52656D61696E696E67496E7374616E6365735C222C5C6E5C745C745C745C745C2264656661756C745C223A20747275652C5C6E5C745C745C745C746973417474';
wwv_flow_imp.g_varchar2_table(7049) := '723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225472616E73616374696F6E5C222C5C6E5C745C7473757065';
wwv_flow_imp.g_varchar2_table(7050) := '72436C6173733A205B5C6E5C745C745C745C2253756250726F636573735C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2270726F746F636F6C5C222C5C6E5C74';
wwv_flow_imp.g_varchar2_table(7051) := '5C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D6574686F645C222C5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(7052) := '746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22476C6F62616C5363726970745461736B5C222C';
wwv_flow_imp.g_varchar2_table(7053) := '5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22476C6F62616C5461736B5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227363726970';
wwv_flow_imp.g_varchar2_table(7054) := '744C616E67756167655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227363';
wwv_flow_imp.g_varchar2_table(7055) := '726970745C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22476C6F';
wwv_flow_imp.g_varchar2_table(7056) := '62616C427573696E65737352756C655461736B5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22476C6F62616C5461736B5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C';
wwv_flow_imp.g_varchar2_table(7057) := '6E5C745C745C745C746E616D653A205C22696D706C656D656E746174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C';
wwv_flow_imp.g_varchar2_table(7058) := '6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F6D706C65784265686176696F72446566696E6974696F6E5C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C74';
wwv_flow_imp.g_varchar2_table(7059) := '5D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F6E646974696F6E5C222C5C6E5C745C745C745C74747970653A205C22466F726D616C45787072657373696F6E5C225C6E5C74';
wwv_flow_imp.g_varchar2_table(7060) := '5C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226576656E745C222C5C6E5C745C745C745C74747970653A205C22496D706C696369745468726F774576656E745C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D';
wwv_flow_imp.g_varchar2_table(7061) := '2C5C6E5C747B5C6E5C745C746E616D653A205C225265736F75726365526F6C655C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965';
wwv_flow_imp.g_varchar2_table(7062) := '733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227265736F757263655265665C222C5C6E5C745C745C745C74747970653A205C225265736F757263655C222C5C6E5C745C745C745C7469735265666572656E63653A20747275';
wwv_flow_imp.g_varchar2_table(7063) := '655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227265736F75726365506172616D6574657242696E64696E67735C222C5C6E5C745C745C745C74747970653A205C225265736F75726365506172616D657465';
wwv_flow_imp.g_varchar2_table(7064) := '7242696E64696E675C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227265736F7572636541737369676E6D656E7445787072657373696F6E5C22';
wwv_flow_imp.g_varchar2_table(7065) := '2C5C6E5C745C745C745C74747970653A205C225265736F7572636541737369676E6D656E7445787072657373696F6E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(7066) := '745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225265736F75726365506172616D65746572';
wwv_flow_imp.g_varchar2_table(7067) := '42696E64696E675C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2265787072657373696F6E5C222C5C6E5C745C745C745C74747970653A205C2245787072657373696F6E5C222C';
wwv_flow_imp.g_varchar2_table(7068) := '5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C745C745C745C747D5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2270';
wwv_flow_imp.g_varchar2_table(7069) := '6172616D657465725265665C222C5C6E5C745C745C745C74747970653A205C225265736F75726365506172616D657465725C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A207472';
wwv_flow_imp.g_varchar2_table(7070) := '75655C6E5C745C745C747D5C6E5C745C745D2C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225265736F757263';
wwv_flow_imp.g_varchar2_table(7071) := '6541737369676E6D656E7445787072657373696F6E5C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2265787072657373696F6E5C222C5C6E5C745C745C745C74747970653A205C';
wwv_flow_imp.g_varchar2_table(7072) := '2245787072657373696F6E5C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C745C745C745C747D5C6E5C745C745C747D5C6E5C745C745D2C5C6E5C745C7473';
wwv_flow_imp.g_varchar2_table(7073) := '75706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22496D706F72745C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(7074) := '745C747B5C6E5C745C745C745C746E616D653A205C22696D706F7274547970655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(7075) := '5C747B5C6E5C745C745C745C746E616D653A205C226C6F636174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B';
wwv_flow_imp.g_varchar2_table(7076) := '5C6E5C745C745C745C746E616D653A205C226E616D6573706163655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D';
wwv_flow_imp.g_varchar2_table(7077) := '2C5C6E5C747B5C6E5C745C746E616D653A205C22446566696E6974696F6E735C222C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2242617365456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F70657274696573';
wwv_flow_imp.g_varchar2_table(7078) := '3A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C74';
wwv_flow_imp.g_varchar2_table(7079) := '5C745C747B5C6E5C745C745C745C746E616D653A205C227461726765744E616D6573706163655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C';
wwv_flow_imp.g_varchar2_table(7080) := '5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2265787072657373696F6E4C616E67756167655C222C5C6E5C745C745C745C745C2264656661756C745C223A205C22687474703A2F2F7777772E77332E6F72672F313939392F58506174';
wwv_flow_imp.g_varchar2_table(7081) := '685C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22747970654C616E677561';
wwv_flow_imp.g_varchar2_table(7082) := '67655C222C5C6E5C745C745C745C745C2264656661756C745C223A205C22687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D615C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C747479';
wwv_flow_imp.g_varchar2_table(7083) := '70653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696D706F7274735C222C5C6E5C745C745C745C74747970653A205C22496D706F72745C222C5C6E5C745C745C745C746973';
wwv_flow_imp.g_varchar2_table(7084) := '4D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22657874656E73696F6E735C222C5C6E5C745C745C745C74747970653A205C22457874656E73696F6E5C222C5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(7085) := '69734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22726F6F74456C656D656E74735C222C5C6E5C745C745C745C74747970653A205C22526F6F74456C656D656E745C222C5C6E5C74';
wwv_flow_imp.g_varchar2_table(7086) := '5C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226469616772616D735C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7474';
wwv_flow_imp.g_varchar2_table(7087) := '7970653A205C2262706D6E64693A42504D4E4469616772616D5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226578706F727465725C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E';
wwv_flow_imp.g_varchar2_table(7088) := '5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2272656C6174696F6E73686970735C222C5C6E5C745C745C745C74747970653A205C2252656C6174';
wwv_flow_imp.g_varchar2_table(7089) := '696F6E736869705C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226578706F7274657256657273696F6E5C222C5C6E5C745C745C745C74697341';
wwv_flow_imp.g_varchar2_table(7090) := '7474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D5C6E5D3B5C6E76617220656E756D65726174696F6E732433203D205B5C6E5C747B5C6E5C745C746E616D65';
wwv_flow_imp.g_varchar2_table(7091) := '3A205C2250726F63657373547970655C222C5C6E5C745C746C69746572616C56616C7565733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C224E6F6E655C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(7092) := '5C746E616D653A205C225075626C69635C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22507269766174655C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D';
wwv_flow_imp.g_varchar2_table(7093) := '653A205C2247617465776179446972656374696F6E5C222C5C6E5C745C746C69746572616C56616C7565733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22556E7370656369666965645C225C6E5C745C745C747D2C5C6E5C74';
wwv_flow_imp.g_varchar2_table(7094) := '5C745C747B5C6E5C745C745C745C746E616D653A205C22436F6E76657267696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22446976657267696E675C225C6E5C745C745C747D2C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(7095) := '747B5C6E5C745C745C745C746E616D653A205C224D697865645C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224576656E74426173656447617465776179547970655C222C5C6E5C745C746C69';
wwv_flow_imp.g_varchar2_table(7096) := '746572616C56616C7565733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22506172616C6C656C5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C224578636C75736976655C225C';
wwv_flow_imp.g_varchar2_table(7097) := '6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2252656C6174696F6E73686970446972656374696F6E5C222C5C6E5C745C746C69746572616C56616C7565733A205B5C6E5C745C745C747B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(7098) := '745C745C746E616D653A205C224E6F6E655C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22466F72776172645C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A20';
wwv_flow_imp.g_varchar2_table(7099) := '5C224261636B776172645C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22426F74685C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224974656D';
wwv_flow_imp.g_varchar2_table(7100) := '4B696E645C222C5C6E5C745C746C69746572616C56616C7565733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22506879736963616C5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A';
wwv_flow_imp.g_varchar2_table(7101) := '205C22496E666F726D6174696F6E5C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2243686F72656F6772617068794C6F6F70547970655C222C5C6E5C745C746C69746572616C56616C7565733A';
wwv_flow_imp.g_varchar2_table(7102) := '205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C224E6F6E655C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C225374616E646172645C225C6E5C745C745C747D2C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(7103) := '7B5C6E5C745C745C745C746E616D653A205C224D756C7469496E7374616E636553657175656E7469616C5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C224D756C7469496E7374616E6365506172616C6C';
wwv_flow_imp.g_varchar2_table(7104) := '656C5C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224173736F63696174696F6E446972656374696F6E5C222C5C6E5C745C746C69746572616C56616C7565733A205B5C6E5C745C745C747B5C';
wwv_flow_imp.g_varchar2_table(7105) := '6E5C745C745C745C746E616D653A205C224E6F6E655C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C224F6E655C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A20';
wwv_flow_imp.g_varchar2_table(7106) := '5C22426F74685C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224D756C7469496E7374616E63654265686176696F725C222C5C6E5C745C746C69746572616C56616C7565733A205B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(7107) := '745C747B5C6E5C745C745C745C746E616D653A205C224E6F6E655C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C224F6E655C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E';
wwv_flow_imp.g_varchar2_table(7108) := '616D653A205C22416C6C5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22436F6D706C65785C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2241';
wwv_flow_imp.g_varchar2_table(7109) := '64486F634F72646572696E675C222C5C6E5C745C746C69746572616C56616C7565733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22506172616C6C656C5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(7110) := '745C746E616D653A205C2253657175656E7469616C5C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D5C6E5D3B5C6E76617220786D6C2431203D207B5C6E5C74746167416C6961733A205C226C6F776572436173655C222C5C6E5C747479706550';
wwv_flow_imp.g_varchar2_table(7111) := '72656669783A205C22745C225C6E7D3B5C6E7661722042706D6E5061636B616765203D207B5C6E5C746E616D653A206E616D6524352C5C6E5C747572693A2075726924352C5C6E5C747072656669783A2070726566697824352C5C6E5C746173736F6369';
wwv_flow_imp.g_varchar2_table(7112) := '6174696F6E733A206173736F63696174696F6E7324352C5C6E5C7474797065733A20747970657324352C5C6E5C74656E756D65726174696F6E733A20656E756D65726174696F6E7324332C5C6E5C74786D6C3A20786D6C24315C6E7D3B5C6E5C6E766172';
wwv_flow_imp.g_varchar2_table(7113) := '206E616D652434203D205C2242504D4E44495C223B5C6E766172207572692434203D205C22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F32303130303532342F44495C223B5C6E766172207072656669782434203D205C2262';
wwv_flow_imp.g_varchar2_table(7114) := '706D6E64695C223B5C6E7661722074797065732434203D205B5C6E5C747B5C6E5C745C746E616D653A205C2242504D4E4469616772616D5C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D65';
wwv_flow_imp.g_varchar2_table(7115) := '3A205C22706C616E655C222C5C6E5C745C745C745C74747970653A205C2242504D4E506C616E655C222C5C6E5C745C745C745C747265646566696E65733A205C2264693A4469616772616D23726F6F74456C656D656E745C225C6E5C745C745C747D2C5C';
wwv_flow_imp.g_varchar2_table(7116) := '6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C6162656C5374796C655C222C5C6E5C745C745C745C74747970653A205C2242504D4E4C6162656C5374796C655C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C74';
wwv_flow_imp.g_varchar2_table(7117) := '5C745C747D5C6E5C745C745D2C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2264693A4469616772616D5C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2242504D4E506C616E655C222C5C6E';
wwv_flow_imp.g_varchar2_table(7118) := '5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2262706D6E456C656D656E745C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E';
wwv_flow_imp.g_varchar2_table(7119) := '63653A20747275652C5C6E5C745C745C745C74747970653A205C2262706D6E3A42617365456C656D656E745C222C5C6E5C745C745C745C747265646566696E65733A205C2264693A4469616772616D456C656D656E74236D6F64656C456C656D656E745C';
wwv_flow_imp.g_varchar2_table(7120) := '225C6E5C745C745C747D5C6E5C745C745D2C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2264693A506C616E655C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2242504D4E53686170655C22';
wwv_flow_imp.g_varchar2_table(7121) := '2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2262706D6E456C656D656E745C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74697352656665';
wwv_flow_imp.g_varchar2_table(7122) := '72656E63653A20747275652C5C6E5C745C745C745C74747970653A205C2262706D6E3A42617365456C656D656E745C222C5C6E5C745C745C745C747265646566696E65733A205C2264693A4469616772616D456C656D656E74236D6F64656C456C656D65';
wwv_flow_imp.g_varchar2_table(7123) := '6E745C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973486F72697A6F6E74616C5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F';
wwv_flow_imp.g_varchar2_table(7124) := '6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973457870616E6465645C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F';
wwv_flow_imp.g_varchar2_table(7125) := '6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2269734D61726B657256697369626C655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A20';
wwv_flow_imp.g_varchar2_table(7126) := '5C22426F6F6C65616E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226C6162656C5C222C5C6E5C745C745C745C74747970653A205C2242504D4E4C6162656C5C225C6E5C745C745C747D2C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(7127) := '745C747B5C6E5C745C745C745C746E616D653A205C2269734D65737361676556697369626C655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C225C6E5C745C745C747D';
wwv_flow_imp.g_varchar2_table(7128) := '2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227061727469636970616E7442616E644B696E645C222C5C6E5C745C745C745C74747970653A205C225061727469636970616E7442616E644B696E645C222C5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(7129) := '6973417474723A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2263686F72656F677261706879416374697669747953686170655C222C5C6E5C745C745C745C74747970653A205C2242504D4E53';
wwv_flow_imp.g_varchar2_table(7130) := '686170655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D5C6E5C745C745D2C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(7131) := '745C2264693A4C6162656C656453686170655C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2242504D4E456467655C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(7132) := '746E616D653A205C226C6162656C5C222C5C6E5C745C745C745C74747970653A205C2242504D4E4C6162656C5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2262706D6E456C656D656E745C222C5C6E5C';
wwv_flow_imp.g_varchar2_table(7133) := '745C745C745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275652C5C6E5C745C745C745C74747970653A205C2262706D6E3A42617365456C656D656E745C222C5C6E5C745C745C745C747265646566';
wwv_flow_imp.g_varchar2_table(7134) := '696E65733A205C2264693A4469616772616D456C656D656E74236D6F64656C456C656D656E745C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22736F75726365456C656D656E745C222C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(7135) := '745C746973417474723A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275652C5C6E5C745C745C745C74747970653A205C2264693A4469616772616D456C656D656E745C222C5C6E5C745C745C745C747265646566696E65';
wwv_flow_imp.g_varchar2_table(7136) := '733A205C2264693A4564676523736F757263655C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22746172676574456C656D656E745C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C';
wwv_flow_imp.g_varchar2_table(7137) := '745C745C745C7469735265666572656E63653A20747275652C5C6E5C745C745C745C74747970653A205C2264693A4469616772616D456C656D656E745C222C5C6E5C745C745C745C747265646566696E65733A205C2264693A4564676523746172676574';
wwv_flow_imp.g_varchar2_table(7138) := '5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D65737361676556697369626C654B696E645C222C5C6E5C745C745C745C74747970653A205C224D65737361676556697369626C654B696E645C222C5C';
wwv_flow_imp.g_varchar2_table(7139) := '6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C745C2264656661756C745C223A205C22696E6974696174696E675C225C6E5C745C745C747D5C6E5C745C745D2C5C6E5C745C747375706572436C6173733A205B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(7140) := '745C745C2264693A4C6162656C6564456467655C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2242504D4E4C6162656C5C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(7141) := '745C746E616D653A205C226C6162656C5374796C655C222C5C6E5C745C745C745C74747970653A205C2242504D4E4C6162656C5374796C655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C746973526566657265';
wwv_flow_imp.g_varchar2_table(7142) := '6E63653A20747275652C5C6E5C745C745C745C747265646566696E65733A205C2264693A4469616772616D456C656D656E74237374796C655C225C6E5C745C745C747D5C6E5C745C745D2C5C6E5C745C747375706572436C6173733A205B5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(7143) := '5C745C2264693A4C6162656C5C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2242504D4E4C6162656C5374796C655C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(7144) := '746E616D653A205C22666F6E745C222C5C6E5C745C745C745C74747970653A205C2264633A466F6E745C225C6E5C745C745C747D5C6E5C745C745D2C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C2264693A5374796C655C225C';
wwv_flow_imp.g_varchar2_table(7145) := '6E5C745C745D5C6E5C747D5C6E5D3B5C6E76617220656E756D65726174696F6E732432203D205B5C6E5C747B5C6E5C745C746E616D653A205C225061727469636970616E7442616E644B696E645C222C5C6E5C745C746C69746572616C56616C7565733A';
wwv_flow_imp.g_varchar2_table(7146) := '205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22746F705F696E6974696174696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D6964646C655F696E6974696174696E675C';
wwv_flow_imp.g_varchar2_table(7147) := '225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22626F74746F6D5F696E6974696174696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22746F705F6E6F';
wwv_flow_imp.g_varchar2_table(7148) := '6E5F696E6974696174696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D6964646C655F6E6F6E5F696E6974696174696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(7149) := '745C746E616D653A205C22626F74746F6D5F6E6F6E5F696E6974696174696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224D65737361676556697369626C654B696E645C222C5C6E5C74';
wwv_flow_imp.g_varchar2_table(7150) := '5C746C69746572616C56616C7565733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22696E6974696174696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E6F6E5F696E';
wwv_flow_imp.g_varchar2_table(7151) := '6974696174696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D5C6E5D3B5C6E766172206173736F63696174696F6E732434203D205B5C6E5D3B5C6E7661722042706D6E44695061636B616765203D207B5C6E5C746E616D653A206E616D65';
wwv_flow_imp.g_varchar2_table(7152) := '24342C5C6E5C747572693A2075726924342C5C6E5C747072656669783A2070726566697824342C5C6E5C7474797065733A20747970657324342C5C6E5C74656E756D65726174696F6E733A20656E756D65726174696F6E7324322C5C6E5C746173736F63';
wwv_flow_imp.g_varchar2_table(7153) := '696174696F6E733A206173736F63696174696F6E7324345C6E7D3B5C6E5C6E766172206E616D652433203D205C2244435C223B5C6E766172207572692433203D205C22687474703A2F2F7777772E6F6D672E6F72672F737065632F44442F323031303035';
wwv_flow_imp.g_varchar2_table(7154) := '32342F44435C223B5C6E766172207072656669782433203D205C2264635C223B5C6E7661722074797065732433203D205B5C6E5C747B5C6E5C745C746E616D653A205C22426F6F6C65616E5C225C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A20';
wwv_flow_imp.g_varchar2_table(7155) := '5C22496E74656765725C225C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225265616C5C225C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22537472696E675C225C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22';
wwv_flow_imp.g_varchar2_table(7156) := '466F6E745C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C74747970653A205C22537472696E675C222C5C6E5C745C745C745C74697341';
wwv_flow_imp.g_varchar2_table(7157) := '7474723A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2273697A655C222C5C6E5C745C745C745C74747970653A205C225265616C5C222C5C6E5C745C745C745C746973417474723A2074727565';
wwv_flow_imp.g_varchar2_table(7158) := '5C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973426F6C645C222C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C74';
wwv_flow_imp.g_varchar2_table(7159) := '5C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2269734974616C69635C222C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C74';
wwv_flow_imp.g_varchar2_table(7160) := '5C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973556E6465726C696E655C222C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C';
wwv_flow_imp.g_varchar2_table(7161) := '745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226973537472696B655468726F7567685C222C5C6E5C745C745C745C74747970653A205C22426F6F6C65616E5C222C5C6E5C745C745C745C746973417474723A2074727565';
wwv_flow_imp.g_varchar2_table(7162) := '5C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22506F696E745C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22785C222C5C';
wwv_flow_imp.g_varchar2_table(7163) := '6E5C745C745C745C74747970653A205C225265616C5C222C5C6E5C745C745C745C745C2264656661756C745C223A205C22305C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C74';
wwv_flow_imp.g_varchar2_table(7164) := '5C745C746E616D653A205C22795C222C5C6E5C745C745C745C74747970653A205C225265616C5C222C5C6E5C745C745C745C745C2264656661756C745C223A205C22305C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(7165) := '7D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22426F756E64735C222C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22785C222C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(7166) := '5C74747970653A205C225265616C5C222C5C6E5C745C745C745C745C2264656661756C745C223A205C22305C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D';
wwv_flow_imp.g_varchar2_table(7167) := '653A205C22795C222C5C6E5C745C745C745C74747970653A205C225265616C5C222C5C6E5C745C745C745C745C2264656661756C745C223A205C22305C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D2C5C6E5C745C';
wwv_flow_imp.g_varchar2_table(7168) := '745C747B5C6E5C745C745C745C746E616D653A205C2277696474685C222C5C6E5C745C745C745C74747970653A205C225265616C5C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C74';
wwv_flow_imp.g_varchar2_table(7169) := '5C745C745C746E616D653A205C226865696768745C222C5C6E5C745C745C745C74747970653A205C225265616C5C222C5C6E5C745C745C745C746973417474723A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D5C6E5D3B5C6E766172';
wwv_flow_imp.g_varchar2_table(7170) := '206173736F63696174696F6E732433203D205B5C6E5D3B5C6E7661722044635061636B616765203D207B5C6E5C746E616D653A206E616D6524332C5C6E5C747572693A2075726924332C5C6E5C747072656669783A2070726566697824332C5C6E5C7474';
wwv_flow_imp.g_varchar2_table(7171) := '797065733A20747970657324332C5C6E5C746173736F63696174696F6E733A206173736F63696174696F6E7324335C6E7D3B5C6E5C6E766172206E616D652432203D205C2244495C223B5C6E766172207572692432203D205C22687474703A2F2F777777';
wwv_flow_imp.g_varchar2_table(7172) := '2E6F6D672E6F72672F737065632F44442F32303130303532342F44495C223B5C6E766172207072656669782432203D205C2264695C223B5C6E7661722074797065732432203D205B5C6E5C747B5C6E5C745C746E616D653A205C224469616772616D456C';
wwv_flow_imp.g_varchar2_table(7173) := '656D656E745C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2269645C222C5C6E5C745C745C745C746973417474723A20';
wwv_flow_imp.g_varchar2_table(7174) := '747275652C5C6E5C745C745C745C74697349643A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22657874656E73696F6E5C22';
wwv_flow_imp.g_varchar2_table(7175) := '2C5C6E5C745C745C745C74747970653A205C22457874656E73696F6E5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F776E696E674469616772616D5C222C5C6E5C745C745C745C74747970653A205C';
wwv_flow_imp.g_varchar2_table(7176) := '224469616772616D5C222C5C6E5C745C745C745C746973526561644F6E6C793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D';
wwv_flow_imp.g_varchar2_table(7177) := '2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F776E696E67456C656D656E745C222C5C6E5C745C745C745C74747970653A205C224469616772616D456C656D656E745C222C5C6E5C745C745C745C746973526561644F6E6C793A';
wwv_flow_imp.g_varchar2_table(7178) := '20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226D6F6465';
wwv_flow_imp.g_varchar2_table(7179) := '6C456C656D656E745C222C5C6E5C745C745C745C746973526561644F6E6C793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275652C5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(7180) := '5C74747970653A205C22456C656D656E745C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227374796C655C222C5C6E5C745C745C745C74747970653A205C225374796C655C222C5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(7181) := '6973526561644F6E6C793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E';
wwv_flow_imp.g_varchar2_table(7182) := '616D653A205C226F776E6564456C656D656E745C222C5C6E5C745C745C745C74747970653A205C224469616772616D456C656D656E745C222C5C6E5C745C745C745C746973526561644F6E6C793A20747275652C5C6E5C745C745C745C7469734D616E79';
wwv_flow_imp.g_varchar2_table(7183) := '3A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224E6F64655C222C5C6E5C745C74697341627374726163743A207472';
wwv_flow_imp.g_varchar2_table(7184) := '75652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224469616772616D456C656D656E745C225C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22456467655C222C5C6E5C745C7469734162737472';
wwv_flow_imp.g_varchar2_table(7185) := '6163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224469616772616D456C656D656E745C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(7186) := '746E616D653A205C22736F757263655C222C5C6E5C745C745C745C74747970653A205C224469616772616D456C656D656E745C222C5C6E5C745C745C745C746973526561644F6E6C793A20747275652C5C6E5C745C745C745C7469735669727475616C3A';
wwv_flow_imp.g_varchar2_table(7187) := '20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227461726765745C222C5C6E5C745C745C745C74747970653A205C22446961';
wwv_flow_imp.g_varchar2_table(7188) := '6772616D456C656D656E745C222C5C6E5C745C745C745C746973526561644F6E6C793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275652C5C6E5C745C745C745C7469735265666572656E63653A20747275655C6E5C745C74';
wwv_flow_imp.g_varchar2_table(7189) := '5C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22776179706F696E745C222C5C6E5C745C745C745C746973556E697175653A2066616C73652C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(7190) := '74747970653A205C2264633A506F696E745C222C5C6E5C745C745C745C74786D6C3A207B5C6E5C745C745C745C745C7473657269616C697A653A205C227873693A747970655C225C6E5C745C745C745C747D5C6E5C745C745C747D5C6E5C745C745D5C6E';
wwv_flow_imp.g_varchar2_table(7191) := '5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224469616772616D5C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A20';
wwv_flow_imp.g_varchar2_table(7192) := '5C2269645C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74697349643A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C74';
wwv_flow_imp.g_varchar2_table(7193) := '5C745C745C746E616D653A205C22726F6F74456C656D656E745C222C5C6E5C745C745C745C74747970653A205C224469616772616D456C656D656E745C222C5C6E5C745C745C745C746973526561644F6E6C793A20747275652C5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(7194) := '69735669727475616C3A20747275655C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226E616D655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22';
wwv_flow_imp.g_varchar2_table(7195) := '537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22646F63756D656E746174696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A20';
wwv_flow_imp.g_varchar2_table(7196) := '5C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C227265736F6C7574696F6E5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C';
wwv_flow_imp.g_varchar2_table(7197) := '225265616C5C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F776E65645374796C655C222C5C6E5C745C745C745C74747970653A205C225374796C655C222C5C6E5C745C745C745C746973526561644F';
wwv_flow_imp.g_varchar2_table(7198) := '6E6C793A20747275652C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C2253';
wwv_flow_imp.g_varchar2_table(7199) := '686170655C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224E6F64655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C74';
wwv_flow_imp.g_varchar2_table(7200) := '7B5C6E5C745C745C745C746E616D653A205C22626F756E64735C222C5C6E5C745C745C745C74747970653A205C2264633A426F756E64735C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22506C';
wwv_flow_imp.g_varchar2_table(7201) := '616E655C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224E6F64655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B';
wwv_flow_imp.g_varchar2_table(7202) := '5C6E5C745C745C745C746E616D653A205C22706C616E65456C656D656E745C222C5C6E5C745C745C745C74747970653A205C224469616772616D456C656D656E745C222C5C6E5C745C745C745C7473756273657474656450726F70657274793A205C2244';
wwv_flow_imp.g_varchar2_table(7203) := '69616772616D456C656D656E742D6F776E6564456C656D656E745C222C5C6E5C745C745C745C7469734D616E793A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224C6162656C656445';
wwv_flow_imp.g_varchar2_table(7204) := '6467655C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C22456467655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B';
wwv_flow_imp.g_varchar2_table(7205) := '5C6E5C745C745C745C746E616D653A205C226F776E65644C6162656C5C222C5C6E5C745C745C745C74747970653A205C224C6162656C5C222C5C6E5C745C745C745C746973526561644F6E6C793A20747275652C5C6E5C745C745C745C74737562736574';
wwv_flow_imp.g_varchar2_table(7206) := '74656450726F70657274793A205C224469616772616D456C656D656E742D6F776E6564456C656D656E745C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275655C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(7207) := '747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224C6162656C656453686170655C222C5C6E5C745C74697341627374726163743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C';
wwv_flow_imp.g_varchar2_table(7208) := '2253686170655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C226F776E65644C6162656C5C222C5C6E5C745C745C745C74747970653A205C224C6162656C5C22';
wwv_flow_imp.g_varchar2_table(7209) := '2C5C6E5C745C745C745C746973526561644F6E6C793A20747275652C5C6E5C745C745C745C7473756273657474656450726F70657274793A205C224469616772616D456C656D656E742D6F776E6564456C656D656E745C222C5C6E5C745C745C745C7469';
wwv_flow_imp.g_varchar2_table(7210) := '734D616E793A20747275652C5C6E5C745C745C745C7469735669727475616C3A20747275655C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C224C6162656C5C222C5C6E5C745C746973416273747261';
wwv_flow_imp.g_varchar2_table(7211) := '63743A20747275652C5C6E5C745C747375706572436C6173733A205B5C6E5C745C745C745C224E6F64655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22626F';
wwv_flow_imp.g_varchar2_table(7212) := '756E64735C222C5C6E5C745C745C745C74747970653A205C2264633A426F756E64735C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C225374796C655C222C5C6E5C745C74697341627374726163';
wwv_flow_imp.g_varchar2_table(7213) := '743A20747275652C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2269645C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74697349643A207472';
wwv_flow_imp.g_varchar2_table(7214) := '75652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22457874656E73696F6E5C222C5C6E5C745C7470726F706572746965733A20';
wwv_flow_imp.g_varchar2_table(7215) := '5B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C2276616C7565735C222C5C6E5C745C745C745C7469734D616E793A20747275652C5C6E5C745C745C745C74747970653A205C22456C656D656E745C225C6E5C745C745C747D5C6E5C74';
wwv_flow_imp.g_varchar2_table(7216) := '5C745D5C6E5C747D5C6E5D3B5C6E766172206173736F63696174696F6E732432203D205B5C6E5D3B5C6E76617220786D6C203D207B5C6E5C74746167416C6961733A205C226C6F776572436173655C225C6E7D3B5C6E7661722044695061636B61676520';
wwv_flow_imp.g_varchar2_table(7217) := '3D207B5C6E5C746E616D653A206E616D6524322C5C6E5C747572693A2075726924322C5C6E5C747072656669783A2070726566697824322C5C6E5C7474797065733A20747970657324322C5C6E5C746173736F63696174696F6E733A206173736F636961';
wwv_flow_imp.g_varchar2_table(7218) := '74696F6E7324322C5C6E5C74786D6C3A20786D6C5C6E7D3B5C6E5C6E766172206E616D652431203D205C2262706D6E2E696F20636F6C6F727320666F722042504D4E5C223B5C6E766172207572692431203D205C22687474703A2F2F62706D6E2E696F2F';
wwv_flow_imp.g_varchar2_table(7219) := '736368656D612F62706D6E2F62696F636F6C6F722F312E305C223B5C6E766172207072656669782431203D205C2262696F635C223B5C6E7661722074797065732431203D205B5C6E5C747B5C6E5C745C746E616D653A205C22436F6C6F72656453686170';
wwv_flow_imp.g_varchar2_table(7220) := '655C222C5C6E5C745C745C22657874656E64735C223A205B5C6E5C745C745C745C2262706D6E64693A42504D4E53686170655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E61';
wwv_flow_imp.g_varchar2_table(7221) := '6D653A205C227374726F6B655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C';
wwv_flow_imp.g_varchar2_table(7222) := '2266696C6C5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F';
wwv_flow_imp.g_varchar2_table(7223) := '6C6F726564456467655C222C5C6E5C745C745C22657874656E64735C223A205B5C6E5C745C745C745C2262706D6E64693A42504D4E456467655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C';
wwv_flow_imp.g_varchar2_table(7224) := '745C745C746E616D653A205C227374726F6B655C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C74';
wwv_flow_imp.g_varchar2_table(7225) := '6E616D653A205C2266696C6C5C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D5C6E5D3B5C6E76617220656E756D65';
wwv_flow_imp.g_varchar2_table(7226) := '726174696F6E732431203D205B5C6E5D3B5C6E766172206173736F63696174696F6E732431203D205B5C6E5D3B5C6E7661722042696F635061636B616765203D207B5C6E5C746E616D653A206E616D6524312C5C6E5C747572693A2075726924312C5C6E';
wwv_flow_imp.g_varchar2_table(7227) := '5C747072656669783A2070726566697824312C5C6E5C7474797065733A20747970657324312C5C6E5C74656E756D65726174696F6E733A20656E756D65726174696F6E7324312C5C6E5C746173736F63696174696F6E733A206173736F63696174696F6E';
wwv_flow_imp.g_varchar2_table(7228) := '7324315C6E7D3B5C6E5C6E766172206E616D65203D205C2242504D4E20696E20436F6C6F725C223B5C6E76617220757269203D205C22687474703A2F2F7777772E6F6D672E6F72672F737065632F42504D4E2F6E6F6E2D6E6F726D61746976652F636F6C';
wwv_flow_imp.g_varchar2_table(7229) := '6F722F312E305C223B5C6E76617220707265666978203D205C22636F6C6F725C223B5C6E766172207479706573203D205B5C6E5C747B5C6E5C745C746E616D653A205C22436F6C6F7265644C6162656C5C222C5C6E5C745C745C22657874656E64735C22';
wwv_flow_imp.g_varchar2_table(7230) := '3A205B5C6E5C745C745C745C2262706D6E64693A42504D4E4C6162656C5C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22636F6C6F725C222C5C6E5C745C745C';
wwv_flow_imp.g_varchar2_table(7231) := '745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C745C746E616D653A205C22436F6C6F72656453686170655C222C5C6E';
wwv_flow_imp.g_varchar2_table(7232) := '5C745C745C22657874656E64735C223A205B5C6E5C745C745C745C2262706D6E64693A42504D4E53686170655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E5C745C745C747B5C6E5C745C745C745C746E616D653A205C22';
wwv_flow_imp.g_varchar2_table(7233) := '6261636B67726F756E642D636F6C6F725C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D2C5C6E5C745C745C747B5C6E5C745C745C745C746E616D';
wwv_flow_imp.g_varchar2_table(7234) := '653A205C22626F726465722D636F6C6F725C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E5C745C745D5C6E5C747D2C5C6E5C747B5C6E5C74';
wwv_flow_imp.g_varchar2_table(7235) := '5C746E616D653A205C22436F6C6F726564456467655C222C5C6E5C745C745C22657874656E64735C223A205B5C6E5C745C745C745C2262706D6E64693A42504D4E456467655C225C6E5C745C745D2C5C6E5C745C7470726F706572746965733A205B5C6E';
wwv_flow_imp.g_varchar2_table(7236) := '5C745C745C747B5C6E5C745C745C745C746E616D653A205C22626F726465722D636F6C6F725C222C5C6E5C745C745C745C746973417474723A20747275652C5C6E5C745C745C745C74747970653A205C22537472696E675C225C6E5C745C745C747D5C6E';
wwv_flow_imp.g_varchar2_table(7237) := '5C745C745D5C6E5C747D5C6E5D3B5C6E76617220656E756D65726174696F6E73203D205B5C6E5D3B5C6E766172206173736F63696174696F6E73203D205B5C6E5D3B5C6E7661722042706D6E496E436F6C6F725061636B616765203D207B5C6E5C746E61';
wwv_flow_imp.g_varchar2_table(7238) := '6D653A206E616D652C5C6E5C747572693A207572692C5C6E5C747072656669783A207072656669782C5C6E5C7474797065733A2074797065732C5C6E5C74656E756D65726174696F6E733A20656E756D65726174696F6E732C5C6E5C746173736F636961';
wwv_flow_imp.g_varchar2_table(7239) := '74696F6E733A206173736F63696174696F6E735C6E7D3B5C6E5C6E766172207061636B61676573203D207B5C6E202062706D6E3A2042706D6E5061636B6167652C5C6E202062706D6E64693A2042706D6E44695061636B6167652C5C6E202064633A2044';
wwv_flow_imp.g_varchar2_table(7240) := '635061636B6167652C5C6E202064693A2044695061636B6167652C5C6E202062696F633A2042696F635061636B6167652C5C6E2020636F6C6F723A2042706D6E496E436F6C6F725061636B6167655C6E7D3B5C6E5C6E66756E6374696F6E2073696D706C';
wwv_flow_imp.g_varchar2_table(7241) := '65286164646974696F6E616C5061636B616765732C206F7074696F6E7329207B5C6E202076617220706B73203D2061737369676E287B7D2C207061636B616765732C206164646974696F6E616C5061636B61676573293B5C6E5C6E202072657475726E20';
wwv_flow_imp.g_varchar2_table(7242) := '6E65772042706D6E4D6F64646C6528706B732C206F7074696F6E73293B5C6E7D5C6E5C6E6578706F7274207B2073696D706C652061732064656661756C74207D3B5C6E222C22636F6E737420434C4153535F5041545445524E203D202F5E636C6173735B';
wwv_flow_imp.g_varchar2_table(7243) := '207B5D2F3B5C6E5C6E5C6E2F2A2A5C6E202A2040706172616D207B66756E6374696F6E7D20666E5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E66756E6374696F6E206973436C61737328666E29207B5C6E20207265';
wwv_flow_imp.g_varchar2_table(7244) := '7475726E20434C4153535F5041545445524E2E7465737428666E2E746F537472696E672829293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B616E797D206F626A5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A';
wwv_flow_imp.g_varchar2_table(7245) := '2F5C6E66756E6374696F6E2069734172726179286F626A29207B5C6E202072657475726E2041727261792E69734172726179286F626A293B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B616E797D206F626A5C6E202A2040706172616D207B';
wwv_flow_imp.g_varchar2_table(7246) := '737472696E677D2070726F705C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E66756E6374696F6E206861734F776E50726F70286F626A2C2070726F7029207B5C6E202072657475726E204F626A6563742E70726F746F';
wwv_flow_imp.g_varchar2_table(7247) := '747970652E6861734F776E50726F70657274792E63616C6C286F626A2C2070726F70293B5C6E7D5C6E5C6E2F2A2A5C6E202A204074797065646566207B696D706F727428272E2F696E6465782E6A7327292E496E6A656374416E6E6F7461746564207D20';
wwv_flow_imp.g_varchar2_table(7248) := '496E6A656374416E6E6F74617465645C6E202A2F5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C6E202A5C6E202A2040706172616D73207B5B2E2E2E737472696E675B5D2C20545D207C202E2E2E737472696E675B5D2C20547D2061726773';
wwv_flow_imp.g_varchar2_table(7249) := '5C6E202A5C6E202A204072657475726E207B54202620496E6A656374416E6E6F74617465647D5C6E202A2F5C6E66756E6374696F6E20616E6E6F74617465282E2E2E6172677329207B5C6E5C6E202069662028617267732E6C656E677468203D3D3D2031';
wwv_flow_imp.g_varchar2_table(7250) := '202626206973417272617928617267735B305D2929207B5C6E2020202061726773203D20617267735B305D3B5C6E20207D5C6E5C6E202061726773203D205B202E2E2E61726773205D3B5C6E5C6E2020636F6E737420666E203D20617267732E706F7028';
wwv_flow_imp.g_varchar2_table(7251) := '293B5C6E5C6E2020666E2E24696E6A656374203D20617267733B5C6E5C6E202072657475726E20666E3B5C6E7D5C6E5C6E5C6E2F2F2043757272656E74206C696D69746174696F6E733A5C6E2F2F202D2063616E27742070757420696E746F205C226675';
wwv_flow_imp.g_varchar2_table(7252) := '6E6374696F6E206172675C2220636F6D6D656E74735C6E2F2F2066756E6374696F6E202F2A20286E6F20706172656E746865736973206C696B65207468697329202A2F2028297B7D5C6E2F2F2066756E6374696F6E2061626328202F2A20787820286E6F';
wwv_flow_imp.g_varchar2_table(7253) := '20706172656E746865736973206C696B65207468697329202A2F20612C206229207B7D5C6E2F2F5C6E2F2F204A757374207075742074686520636F6D6D656E74206265666F72652066756E6374696F6E206F7220696E736964653A5C6E2F2F202F2A2028';
wwv_flow_imp.g_varchar2_table(7254) := '2828746869732069732066696E65292929202A2F2066756E6374696F6E28612C206229207B7D5C6E2F2F2066756E6374696F6E20616263286129207B202F2A20282828746869732069732066696E65292929202A2F7D5C6E2F2F5C6E2F2F202D2063616E';
wwv_flow_imp.g_varchar2_table(7255) := '27742072656C6961626C79206175746F2D616E6E6F7461746520636F6E7374727563746F723B207765276C6C206D61746368207468655C6E2F2F20666972737420636F6E7374727563746F72282E2E2E29207061747465726E20666F756E642077686963';
wwv_flow_imp.g_varchar2_table(7256) := '68206D617920626520746865206F6E655C6E2F2F206F662061206E657374656420636C6173732C20746F6F2E5C6E5C6E636F6E737420434F4E5354525543544F525F41524753203D202F636F6E7374727563746F725C5C732A5B5E285D2A5C5C285C5C73';
wwv_flow_imp.g_varchar2_table(7257) := '2A285B5E295D2A295C5C292F6D3B5C6E636F6E737420464E5F41524753203D202F5E283F3A6173796E635C5C732B293F283F3A66756E6374696F6E5C5C732A5B5E285D2A293F283F3A5C5C285C5C732A285B5E295D2A295C5C297C285C5C772B29292F6D';
wwv_flow_imp.g_varchar2_table(7258) := '3B5C6E636F6E737420464E5F415247203D202F5C5C2F5C5C2A285B5E2A5D2A295C5C2A5C5C2F2F6D3B5C6E5C6E2F2A2A5C6E202A2040706172616D207B756E6B6E6F776E7D20666E5C6E202A5C6E202A204072657475726E207B737472696E675B5D7D5C';
wwv_flow_imp.g_varchar2_table(7259) := '6E202A2F5C6E66756E6374696F6E207061727365416E6E6F746174696F6E7328666E29207B5C6E5C6E202069662028747970656F6620666E20213D3D202766756E6374696F6E2729207B5C6E202020207468726F77206E6577204572726F72286043616E';
wwv_flow_imp.g_varchar2_table(7260) := '6E6F7420616E6E6F74617465205C22247B666E7D5C222E20457870656374656420612066756E6374696F6E2160293B5C6E20207D5C6E5C6E2020636F6E7374206D61746368203D20666E2E746F537472696E6728292E6D61746368286973436C61737328';
wwv_flow_imp.g_varchar2_table(7261) := '666E29203F20434F4E5354525543544F525F41524753203A20464E5F41524753293B5C6E5C6E20202F2F206D617920706172736520636C61737320776974686F757420636F6E7374727563746F725C6E202069662028216D6174636829207B5C6E202020';
wwv_flow_imp.g_varchar2_table(7262) := '2072657475726E205B5D3B5C6E20207D5C6E5C6E2020636F6E73742061726773203D206D617463685B315D207C7C206D617463685B325D3B5C6E5C6E202072657475726E206172677320262620617267732E73706C697428272C27292E6D617028617267';
wwv_flow_imp.g_varchar2_table(7263) := '203D3E207B5C6E20202020636F6E7374206172674D61746368203D206172672E6D6174636828464E5F415247293B5C6E2020202072657475726E20286172674D61746368202626206172674D617463685B315D207C7C20617267292E7472696D28293B5C';
wwv_flow_imp.g_varchar2_table(7264) := '6E20207D29207C7C205B5D3B5C6E7D5C6E5C6E2F2A2A5C6E202A204074797065646566207B20696D706F727428272E2F696E6465782E6A7327292E4D6F64756C654465636C61726174696F6E207D204D6F64756C654465636C61726174696F6E5C6E202A';
wwv_flow_imp.g_varchar2_table(7265) := '204074797065646566207B20696D706F727428272E2F696E6465782E6A7327292E4D6F64756C65446566696E6974696F6E207D204D6F64756C65446566696E6974696F6E5C6E202A204074797065646566207B20696D706F727428272E2F696E6465782E';
wwv_flow_imp.g_varchar2_table(7266) := '6A7327292E496E6A6563746F72436F6E74657874207D20496E6A6563746F72436F6E746578745C6E202A5C6E202A204074797065646566207B20696D706F727428272E2F696E6465782E6A7327292E54797065644465636C61726174696F6E3C616E792C';
wwv_flow_imp.g_varchar2_table(7267) := '20616E793E207D2054797065644465636C61726174696F6E5C6E202A2F5C6E5C6E2F2A2A5C6E202A204372656174652061206E657720696E6A6563746F7220776974682074686520676976656E206D6F64756C65732E5C6E202A5C6E202A204070617261';
wwv_flow_imp.g_varchar2_table(7268) := '6D207B4D6F64756C65446566696E6974696F6E5B5D7D206D6F64756C65735C6E202A2040706172616D207B496E6A6563746F72436F6E746578747D205B5F706172656E745D5C6E202A2F5C6E66756E6374696F6E20496E6A6563746F72286D6F64756C65';
wwv_flow_imp.g_varchar2_table(7269) := '732C205F706172656E7429207B5C6E5C6E2020636F6E737420706172656E74203D205F706172656E74207C7C202F2A2A20407479706520496E6A6563746F72436F6E74657874202A2F20287B5C6E202020206765743A2066756E6374696F6E286E616D65';
wwv_flow_imp.g_varchar2_table(7270) := '2C2073747269637429207B5C6E20202020202063757272656E746C795265736F6C76696E672E70757368286E616D65293B5C6E5C6E20202020202069662028737472696374203D3D3D2066616C736529207B5C6E202020202020202072657475726E206E';
wwv_flow_imp.g_varchar2_table(7271) := '756C6C3B5C6E2020202020207D20656C7365207B5C6E20202020202020207468726F77206572726F7228604E6F2070726F766964657220666F72205C22247B206E616D65207D5C222160293B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C';
wwv_flow_imp.g_varchar2_table(7272) := '6E5C6E2020636F6E73742063757272656E746C795265736F6C76696E67203D205B5D3B5C6E2020636F6E73742070726F766964657273203D20746869732E5F70726F766964657273203D204F626A6563742E63726561746528706172656E742E5F70726F';
wwv_flow_imp.g_varchar2_table(7273) := '766964657273207C7C206E756C6C293B5C6E2020636F6E737420696E7374616E636573203D20746869732E5F696E7374616E636573203D204F626A6563742E637265617465286E756C6C293B5C6E5C6E2020636F6E73742073656C66203D20696E737461';
wwv_flow_imp.g_varchar2_table(7274) := '6E6365732E696E6A6563746F72203D20746869733B5C6E5C6E2020636F6E7374206572726F72203D2066756E6374696F6E286D736729207B5C6E20202020636F6E737420737461636B203D2063757272656E746C795265736F6C76696E672E6A6F696E28';
wwv_flow_imp.g_varchar2_table(7275) := '27202D3E2027293B5C6E2020202063757272656E746C795265736F6C76696E672E6C656E677468203D20303B5C6E2020202072657475726E206E6577204572726F7228737461636B203F2060247B206D7367207D20285265736F6C76696E673A20247B20';
wwv_flow_imp.g_varchar2_table(7276) := '737461636B207D2960203A206D7367293B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A2052657475726E2061206E616D656420736572766963652E5C6E2020202A5C6E2020202A2040706172616D207B737472696E677D206E616D655C6E202020';
wwv_flow_imp.g_varchar2_table(7277) := '2A2040706172616D207B626F6F6C65616E7D205B7374726963743D747275655D2069662066616C73652C207265736F6C7665206D697373696E6720736572766963657320746F206E756C6C5C6E2020202A5C6E2020202A204072657475726E207B616E79';
wwv_flow_imp.g_varchar2_table(7278) := '7D5C6E2020202A2F5C6E202066756E6374696F6E20676574286E616D652C2073747269637429207B5C6E20202020696620282170726F7669646572735B6E616D655D202626206E616D652E696E636C7564657328272E272929207B5C6E5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7279) := '20636F6E7374207061727473203D206E616D652E73706C697428272E27293B5C6E2020202020206C6574207069766F74203D20676574282F2A2A204074797065207B20737472696E67207D202A2F202870617274732E7368696674282929293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(7280) := '2020202020207768696C65202870617274732E6C656E67746829207B5C6E20202020202020207069766F74203D207069766F745B2F2A2A204074797065207B20737472696E67207D202A2F202870617274732E73686966742829295D3B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7281) := '207D5C6E5C6E20202020202072657475726E207069766F743B5C6E202020207D5C6E5C6E20202020696620286861734F776E50726F7028696E7374616E6365732C206E616D652929207B5C6E20202020202072657475726E20696E7374616E6365735B6E';
wwv_flow_imp.g_varchar2_table(7282) := '616D655D3B5C6E202020207D5C6E5C6E20202020696620286861734F776E50726F702870726F7669646572732C206E616D652929207B5C6E2020202020206966202863757272656E746C795265736F6C76696E672E696E6465784F66286E616D65292021';
wwv_flow_imp.g_varchar2_table(7283) := '3D3D202D3129207B5C6E202020202020202063757272656E746C795265736F6C76696E672E70757368286E616D65293B5C6E20202020202020207468726F77206572726F72282743616E6E6F74207265736F6C76652063697263756C617220646570656E';
wwv_flow_imp.g_varchar2_table(7284) := '64656E63792127293B5C6E2020202020207D5C6E5C6E20202020202063757272656E746C795265736F6C76696E672E70757368286E616D65293B5C6E202020202020696E7374616E6365735B6E616D655D203D2070726F7669646572735B6E616D655D5B';
wwv_flow_imp.g_varchar2_table(7285) := '305D2870726F7669646572735B6E616D655D5B315D293B5C6E20202020202063757272656E746C795265736F6C76696E672E706F7028293B5C6E5C6E20202020202072657475726E20696E7374616E6365735B6E616D655D3B5C6E202020207D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(7286) := '2020202072657475726E20706172656E742E676574286E616D652C20737472696374293B5C6E20207D5C6E5C6E202066756E6374696F6E20666E44656628666E2C206C6F63616C7329207B5C6E5C6E2020202069662028747970656F66206C6F63616C73';
wwv_flow_imp.g_varchar2_table(7287) := '203D3D3D2027756E646566696E65642729207B5C6E2020202020206C6F63616C73203D207B7D3B5C6E202020207D5C6E5C6E2020202069662028747970656F6620666E20213D3D202766756E6374696F6E2729207B5C6E20202020202069662028697341';
wwv_flow_imp.g_varchar2_table(7288) := '7272617928666E2929207B5C6E2020202020202020666E203D20616E6E6F7461746528666E2E736C6963652829293B5C6E2020202020207D20656C7365207B5C6E20202020202020207468726F77206572726F72286043616E6E6F7420696E766F6B6520';
wwv_flow_imp.g_varchar2_table(7289) := '5C22247B20666E207D5C222E20457870656374656420612066756E6374696F6E2160293B5C6E2020202020207D5C6E202020207D5C6E5C6E202020202F2A2A5C6E20202020202A204074797065207B737472696E675B5D7D5C6E20202020202A2F5C6E20';
wwv_flow_imp.g_varchar2_table(7290) := '202020636F6E737420696E6A656374203D20666E2E24696E6A656374207C7C207061727365416E6E6F746174696F6E7328666E293B5C6E20202020636F6E737420646570656E64656E63696573203D20696E6A6563742E6D617028646570203D3E207B5C';
wwv_flow_imp.g_varchar2_table(7291) := '6E202020202020696620286861734F776E50726F70286C6F63616C732C206465702929207B5C6E202020202020202072657475726E206C6F63616C735B6465705D3B5C6E2020202020207D20656C7365207B5C6E202020202020202072657475726E2067';
wwv_flow_imp.g_varchar2_table(7292) := '657428646570293B5C6E2020202020207D5C6E202020207D293B5C6E5C6E2020202072657475726E207B5C6E202020202020666E3A20666E2C5C6E202020202020646570656E64656E636965735C6E202020207D3B5C6E20207D5C6E5C6E20202F2A2A5C';
wwv_flow_imp.g_varchar2_table(7293) := '6E2020202A20496E7374616E74696174652074686520676976656E20747970652C20696E6A656374696E6720646570656E64656E636965732E5C6E2020202A5C6E2020202A204074656D706C61746520545C6E2020202A5C6E2020202A2040706172616D';
wwv_flow_imp.g_varchar2_table(7294) := '207B2046756E6374696F6E207C205B2E2E2E737472696E675B5D2C2046756E6374696F6E205D7D20747970655C6E2020202A5C6E2020202A204072657475726E20545C6E2020202A2F5C6E202066756E6374696F6E20696E7374616E7469617465287479';
wwv_flow_imp.g_varchar2_table(7295) := '706529207B5C6E20202020636F6E7374207B5C6E202020202020666E2C5C6E202020202020646570656E64656E636965735C6E202020207D203D20666E4465662874797065293B5C6E5C6E202020202F2F20696E7374616E746961746520766172206172';
wwv_flow_imp.g_varchar2_table(7296) := '677320636F6E7374727563746F725C6E20202020636F6E737420436F6E7374727563746F72203D2046756E6374696F6E2E70726F746F747970652E62696E642E63616C6C28666E2C206E756C6C2C202E2E2E646570656E64656E63696573293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(7297) := '2020202072657475726E206E657720436F6E7374727563746F7228293B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A20496E766F6B652074686520676976656E2066756E6374696F6E2C20696E6A656374696E6720646570656E64656E636965732E';
wwv_flow_imp.g_varchar2_table(7298) := '2052657475726E2074686520726573756C742E5C6E2020202A5C6E2020202A204074656D706C61746520545C6E2020202A5C6E2020202A2040706172616D207B2046756E6374696F6E207C205B2E2E2E737472696E675B5D2C2046756E6374696F6E205D';
wwv_flow_imp.g_varchar2_table(7299) := '7D2066756E635C6E2020202A2040706172616D207B204F626A656374207D205B636F6E746578745D5C6E2020202A2040706172616D207B204F626A656374207D205B6C6F63616C735D5C6E2020202A5C6E2020202A204072657475726E207B547D20696E';
wwv_flow_imp.g_varchar2_table(7300) := '766F636174696F6E20726573756C745C6E2020202A2F5C6E202066756E6374696F6E20696E766F6B652866756E632C20636F6E746578742C206C6F63616C7329207B5C6E20202020636F6E7374207B5C6E202020202020666E2C5C6E2020202020206465';
wwv_flow_imp.g_varchar2_table(7301) := '70656E64656E636965735C6E202020207D203D20666E4465662866756E632C206C6F63616C73293B5C6E5C6E2020202072657475726E20666E2E6170706C7928636F6E746578742C20646570656E64656E63696573293B5C6E20207D5C6E5C6E20202F2A';
wwv_flow_imp.g_varchar2_table(7302) := '2A5C6E2020202A2040706172616D207B496E6A6563746F727D206368696C64496E6A6563746F725C6E2020202A5C6E2020202A204072657475726E207B46756E6374696F6E7D5C6E2020202A2F5C6E202066756E6374696F6E2063726561746550726976';
wwv_flow_imp.g_varchar2_table(7303) := '617465496E6A6563746F72466163746F7279286368696C64496E6A6563746F7229207B5C6E2020202072657475726E20616E6E6F74617465286B6579203D3E206368696C64496E6A6563746F722E676574286B657929293B5C6E20207D5C6E5C6E20202F';
wwv_flow_imp.g_varchar2_table(7304) := '2A2A5C6E2020202A2040706172616D207B4D6F64756C65446566696E6974696F6E5B5D7D206D6F64756C65735C6E2020202A2040706172616D207B737472696E675B5D7D205B666F7263654E6577496E7374616E6365735D5C6E2020202A5C6E2020202A';
wwv_flow_imp.g_varchar2_table(7305) := '204072657475726E207B496E6A6563746F727D5C6E2020202A2F5C6E202066756E6374696F6E206372656174654368696C64286D6F64756C65732C20666F7263654E6577496E7374616E63657329207B5C6E2020202069662028666F7263654E6577496E';
wwv_flow_imp.g_varchar2_table(7306) := '7374616E63657320262620666F7263654E6577496E7374616E6365732E6C656E67746829207B5C6E202020202020636F6E73742066726F6D506172656E744D6F64756C65203D204F626A6563742E637265617465286E756C6C293B5C6E20202020202063';
wwv_flow_imp.g_varchar2_table(7307) := '6F6E7374206D61746368656453636F706573203D204F626A6563742E637265617465286E756C6C293B5C6E5C6E202020202020636F6E73742070726976617465496E6A6563746F72734361636865203D205B5D3B5C6E202020202020636F6E7374207072';
wwv_flow_imp.g_varchar2_table(7308) := '69766174654368696C64496E6A6563746F7273203D205B5D3B5C6E202020202020636F6E737420707269766174654368696C64466163746F72696573203D205B5D3B5C6E5C6E2020202020206C65742070726F76696465723B5C6E2020202020206C6574';
wwv_flow_imp.g_varchar2_table(7309) := '2063616368654964783B5C6E2020202020206C657420707269766174654368696C64496E6A6563746F723B5C6E2020202020206C657420707269766174654368696C64496E6A6563746F72466163746F72793B5C6E5C6E202020202020666F7220286C65';
wwv_flow_imp.g_varchar2_table(7310) := '74206E616D6520696E2070726F76696465727329207B5C6E202020202020202070726F7669646572203D2070726F7669646572735B6E616D655D3B5C6E5C6E202020202020202069662028666F7263654E6577496E7374616E6365732E696E6465784F66';
wwv_flow_imp.g_varchar2_table(7311) := '286E616D652920213D3D202D3129207B5C6E202020202020202020206966202870726F76696465725B325D203D3D3D2027707269766174652729207B5C6E2020202020202020202020206361636865496478203D2070726976617465496E6A6563746F72';
wwv_flow_imp.g_varchar2_table(7312) := '7343616368652E696E6465784F662870726F76696465725B335D293B5C6E202020202020202020202020696620286361636865496478203D3D3D202D3129207B5C6E2020202020202020202020202020707269766174654368696C64496E6A6563746F72';
wwv_flow_imp.g_varchar2_table(7313) := '203D2070726F76696465725B335D2E6372656174654368696C64285B5D2C20666F7263654E6577496E7374616E636573293B5C6E2020202020202020202020202020707269766174654368696C64496E6A6563746F72466163746F7279203D2063726561';
wwv_flow_imp.g_varchar2_table(7314) := '746550726976617465496E6A6563746F72466163746F727928707269766174654368696C64496E6A6563746F72293B5C6E202020202020202020202020202070726976617465496E6A6563746F727343616368652E707573682870726F76696465725B33';
wwv_flow_imp.g_varchar2_table(7315) := '5D293B5C6E2020202020202020202020202020707269766174654368696C64496E6A6563746F72732E7075736828707269766174654368696C64496E6A6563746F72293B5C6E2020202020202020202020202020707269766174654368696C6446616374';
wwv_flow_imp.g_varchar2_table(7316) := '6F726965732E7075736828707269766174654368696C64496E6A6563746F72466163746F7279293B5C6E202020202020202020202020202066726F6D506172656E744D6F64756C655B6E616D655D203D205B20707269766174654368696C64496E6A6563';
wwv_flow_imp.g_varchar2_table(7317) := '746F72466163746F72792C206E616D652C202770726976617465272C20707269766174654368696C64496E6A6563746F72205D3B5C6E2020202020202020202020207D20656C7365207B5C6E202020202020202020202020202066726F6D506172656E74';
wwv_flow_imp.g_varchar2_table(7318) := '4D6F64756C655B6E616D655D203D205B20707269766174654368696C64466163746F726965735B63616368654964785D2C206E616D652C202770726976617465272C20707269766174654368696C64496E6A6563746F72735B63616368654964785D205D';
wwv_flow_imp.g_varchar2_table(7319) := '3B5C6E2020202020202020202020207D5C6E202020202020202020207D20656C7365207B5C6E20202020202020202020202066726F6D506172656E744D6F64756C655B6E616D655D203D205B2070726F76696465725B325D2C2070726F76696465725B31';
wwv_flow_imp.g_varchar2_table(7320) := '5D205D3B5C6E202020202020202020207D5C6E202020202020202020206D61746368656453636F7065735B6E616D655D203D20747275653B5C6E20202020202020207D5C6E5C6E2020202020202020696620282870726F76696465725B325D203D3D3D20';
wwv_flow_imp.g_varchar2_table(7321) := '27666163746F727927207C7C2070726F76696465725B325D203D3D3D20277479706527292026262070726F76696465725B315D2E2473636F706529207B5C6E202020202020202020202F2A206A7368696E74202D57303833202A2F5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(7322) := '202020666F7263654E6577496E7374616E6365732E666F72456163682873636F7065203D3E207B5C6E2020202020202020202020206966202870726F76696465725B315D2E2473636F70652E696E6465784F662873636F70652920213D3D202D3129207B';
wwv_flow_imp.g_varchar2_table(7323) := '5C6E202020202020202020202020202066726F6D506172656E744D6F64756C655B6E616D655D203D205B2070726F76696465725B325D2C2070726F76696465725B315D205D3B5C6E20202020202020202020202020206D61746368656453636F7065735B';
wwv_flow_imp.g_varchar2_table(7324) := '73636F70655D203D20747275653B5C6E2020202020202020202020207D5C6E202020202020202020207D293B5C6E20202020202020207D5C6E2020202020207D5C6E5C6E202020202020666F7263654E6577496E7374616E6365732E666F724561636828';
wwv_flow_imp.g_varchar2_table(7325) := '73636F7065203D3E207B5C6E202020202020202069662028216D61746368656453636F7065735B73636F70655D29207B5C6E202020202020202020207468726F77206E6577204572726F7228274E6F2070726F766964657220666F72205C2227202B2073';
wwv_flow_imp.g_varchar2_table(7326) := '636F7065202B20275C222E2043616E6E6F74207573652070726F76696465722066726F6D2074686520706172656E742127293B5C6E20202020202020207D5C6E2020202020207D293B5C6E5C6E2020202020206D6F64756C65732E756E73686966742866';
wwv_flow_imp.g_varchar2_table(7327) := '726F6D506172656E744D6F64756C65293B5C6E202020207D5C6E5C6E2020202072657475726E206E657720496E6A6563746F72286D6F64756C65732C2073656C66293B5C6E20207D5C6E5C6E2020636F6E737420666163746F72794D6170203D207B5C6E';
wwv_flow_imp.g_varchar2_table(7328) := '20202020666163746F72793A20696E766F6B652C5C6E20202020747970653A20696E7374616E74696174652C5C6E2020202076616C75653A2066756E6374696F6E2876616C756529207B5C6E20202020202072657475726E2076616C75653B5C6E202020';
wwv_flow_imp.g_varchar2_table(7329) := '207D5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A2040706172616D207B4D6F64756C65446566696E6974696F6E7D206D6F64756C65446566696E6974696F6E5C6E2020202A2040706172616D207B496E6A6563746F727D20696E6A6563746F725C';
wwv_flow_imp.g_varchar2_table(7330) := '6E2020202A2F5C6E202066756E6374696F6E20637265617465496E697469616C697A6572286D6F64756C65446566696E6974696F6E2C20696E6A6563746F7229207B5C6E5C6E20202020636F6E737420696E697469616C697A657273203D206D6F64756C';
wwv_flow_imp.g_varchar2_table(7331) := '65446566696E6974696F6E2E5F5F696E69745F5F207C7C205B5D3B5C6E5C6E2020202072657475726E2066756E6374696F6E2829207B5C6E202020202020696E697469616C697A6572732E666F724561636828696E697469616C697A6572203D3E207B5C';
wwv_flow_imp.g_varchar2_table(7332) := '6E5C6E20202020202020202F2F2065616765726C79207265736F6C766520636F6D706F6E656E742028666E206F7220737472696E67295C6E202020202020202069662028747970656F6620696E697469616C697A6572203D3D3D2027737472696E672729';
wwv_flow_imp.g_varchar2_table(7333) := '207B5C6E20202020202020202020696E6A6563746F722E67657428696E697469616C697A6572293B5C6E20202020202020207D20656C7365207B5C6E20202020202020202020696E6A6563746F722E696E766F6B6528696E697469616C697A6572293B5C';
wwv_flow_imp.g_varchar2_table(7334) := '6E20202020202020207D5C6E2020202020207D293B5C6E202020207D3B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A2040706172616D207B4D6F64756C65446566696E6974696F6E7D206D6F64756C65446566696E6974696F6E5C6E2020202A2F5C';
wwv_flow_imp.g_varchar2_table(7335) := '6E202066756E6374696F6E206C6F61644D6F64756C65286D6F64756C65446566696E6974696F6E29207B5C6E5C6E20202020636F6E7374206D6F64756C654578706F727473203D206D6F64756C65446566696E6974696F6E2E5F5F6578706F7274735F5F';
wwv_flow_imp.g_varchar2_table(7336) := '3B5C6E5C6E202020202F2F2070726976617465206D6F64756C655C6E20202020696620286D6F64756C654578706F72747329207B5C6E202020202020636F6E7374206E65737465644D6F64756C6573203D206D6F64756C65446566696E6974696F6E2E5F';
wwv_flow_imp.g_varchar2_table(7337) := '5F6D6F64756C65735F5F3B5C6E5C6E202020202020636F6E737420636C6F6E65644D6F64756C65203D204F626A6563742E6B657973286D6F64756C65446566696E6974696F6E292E7265647563652828636C6F6E65644D6F64756C652C206B657929203D';
wwv_flow_imp.g_varchar2_table(7338) := '3E207B5C6E5C6E2020202020202020696620286B657920213D3D20275F5F6578706F7274735F5F27202626206B657920213D3D20275F5F6D6F64756C65735F5F27202626206B657920213D3D20275F5F696E69745F5F27202626206B657920213D3D2027';
wwv_flow_imp.g_varchar2_table(7339) := '5F5F646570656E64735F5F2729207B5C6E20202020202020202020636C6F6E65644D6F64756C655B6B65795D203D206D6F64756C65446566696E6974696F6E5B6B65795D3B5C6E20202020202020207D5C6E5C6E202020202020202072657475726E2063';
wwv_flow_imp.g_varchar2_table(7340) := '6C6F6E65644D6F64756C653B5C6E2020202020207D2C204F626A6563742E637265617465286E756C6C29293B5C6E5C6E202020202020636F6E7374206368696C644D6F64756C6573203D20286E65737465644D6F64756C6573207C7C205B5D292E636F6E';
wwv_flow_imp.g_varchar2_table(7341) := '63617428636C6F6E65644D6F64756C65293B5C6E5C6E202020202020636F6E73742070726976617465496E6A6563746F72203D206372656174654368696C64286368696C644D6F64756C6573293B5C6E202020202020636F6E73742067657446726F6D50';
wwv_flow_imp.g_varchar2_table(7342) := '726976617465496E6A6563746F72203D20616E6E6F746174652866756E6374696F6E286B657929207B5C6E202020202020202072657475726E2070726976617465496E6A6563746F722E676574286B6579293B5C6E2020202020207D293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(7343) := '202020206D6F64756C654578706F7274732E666F72456163682866756E6374696F6E286B657929207B5C6E202020202020202070726F7669646572735B6B65795D203D205B2067657446726F6D50726976617465496E6A6563746F722C206B65792C2027';
wwv_flow_imp.g_varchar2_table(7344) := '70726976617465272C2070726976617465496E6A6563746F72205D3B5C6E2020202020207D293B5C6E5C6E2020202020202F2F20656E73757265206368696C6420696E6A6563746F7220696E697469616C697A65735C6E202020202020636F6E73742069';
wwv_flow_imp.g_varchar2_table(7345) := '6E697469616C697A657273203D20286D6F64756C65446566696E6974696F6E2E5F5F696E69745F5F207C7C205B5D292E736C69636528293B5C6E5C6E202020202020696E697469616C697A6572732E756E73686966742866756E6374696F6E2829207B5C';
wwv_flow_imp.g_varchar2_table(7346) := '6E202020202020202070726976617465496E6A6563746F722E696E697428293B5C6E2020202020207D293B5C6E5C6E2020202020206D6F64756C65446566696E6974696F6E203D204F626A6563742E61737369676E287B7D2C206D6F64756C6544656669';
wwv_flow_imp.g_varchar2_table(7347) := '6E6974696F6E2C207B5C6E20202020202020205F5F696E69745F5F3A20696E697469616C697A6572735C6E2020202020207D293B5C6E5C6E20202020202072657475726E20637265617465496E697469616C697A6572286D6F64756C65446566696E6974';
wwv_flow_imp.g_varchar2_table(7348) := '696F6E2C2070726976617465496E6A6563746F72293B5C6E202020207D5C6E5C6E202020202F2F206E6F726D616C206D6F64756C655C6E202020204F626A6563742E6B657973286D6F64756C65446566696E6974696F6E292E666F72456163682866756E';
wwv_flow_imp.g_varchar2_table(7349) := '6374696F6E286B657929207B5C6E5C6E202020202020696620286B6579203D3D3D20275F5F696E69745F5F27207C7C206B6579203D3D3D20275F5F646570656E64735F5F2729207B5C6E202020202020202072657475726E3B5C6E2020202020207D5C6E';
wwv_flow_imp.g_varchar2_table(7350) := '5C6E202020202020636F6E737420747970654465636C61726174696F6E203D202F2A2A204074797065207B2054797065644465636C61726174696F6E207D202A2F20285C6E20202020202020206D6F64756C65446566696E6974696F6E5B6B65795D5C6E';
wwv_flow_imp.g_varchar2_table(7351) := '202020202020293B5C6E5C6E20202020202069662028747970654465636C61726174696F6E5B325D203D3D3D2027707269766174652729207B5C6E202020202020202070726F7669646572735B6B65795D203D20747970654465636C61726174696F6E3B';
wwv_flow_imp.g_varchar2_table(7352) := '5C6E202020202020202072657475726E3B5C6E2020202020207D5C6E5C6E202020202020636F6E73742074797065203D20747970654465636C61726174696F6E5B305D3B5C6E202020202020636F6E73742076616C7565203D20747970654465636C6172';
wwv_flow_imp.g_varchar2_table(7353) := '6174696F6E5B315D3B5C6E5C6E20202020202070726F7669646572735B6B65795D203D205B20666163746F72794D61705B747970655D2C206172726179556E7772617028747970652C2076616C7565292C2074797065205D3B5C6E202020207D293B5C6E';
wwv_flow_imp.g_varchar2_table(7354) := '5C6E2020202072657475726E20637265617465496E697469616C697A6572286D6F64756C65446566696E6974696F6E2C2073656C66293B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A2040706172616D207B4D6F64756C65446566696E6974696F6E';
wwv_flow_imp.g_varchar2_table(7355) := '5B5D7D206D6F64756C65446566696E6974696F6E735C6E2020202A2040706172616D207B4D6F64756C65446566696E6974696F6E7D206D6F64756C65446566696E6974696F6E5C6E2020202A5C6E2020202A204072657475726E207B4D6F64756C654465';
wwv_flow_imp.g_varchar2_table(7356) := '66696E6974696F6E5B5D7D5C6E2020202A2F5C6E202066756E6374696F6E207265736F6C7665446570656E64656E63696573286D6F64756C65446566696E6974696F6E732C206D6F64756C65446566696E6974696F6E29207B5C6E5C6E20202020696620';
wwv_flow_imp.g_varchar2_table(7357) := '286D6F64756C65446566696E6974696F6E732E696E6465784F66286D6F64756C65446566696E6974696F6E2920213D3D202D3129207B5C6E20202020202072657475726E206D6F64756C65446566696E6974696F6E733B5C6E202020207D5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(7358) := '20206D6F64756C65446566696E6974696F6E73203D20286D6F64756C65446566696E6974696F6E2E5F5F646570656E64735F5F207C7C205B5D292E726564756365287265736F6C7665446570656E64656E636965732C206D6F64756C65446566696E6974';
wwv_flow_imp.g_varchar2_table(7359) := '696F6E73293B5C6E5C6E20202020696620286D6F64756C65446566696E6974696F6E732E696E6465784F66286D6F64756C65446566696E6974696F6E2920213D3D202D3129207B5C6E20202020202072657475726E206D6F64756C65446566696E697469';
wwv_flow_imp.g_varchar2_table(7360) := '6F6E733B5C6E202020207D5C6E5C6E2020202072657475726E206D6F64756C65446566696E6974696F6E732E636F6E636174286D6F64756C65446566696E6974696F6E293B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A2040706172616D207B4D6F';
wwv_flow_imp.g_varchar2_table(7361) := '64756C65446566696E6974696F6E5B5D7D206D6F64756C65446566696E6974696F6E735C6E2020202A5C6E2020202A204072657475726E207B202829203D3E20766F6964207D20696E697469616C697A6572466E5C6E2020202A2F5C6E202066756E6374';
wwv_flow_imp.g_varchar2_table(7362) := '696F6E20626F6F747374726170286D6F64756C65446566696E6974696F6E7329207B5C6E5C6E20202020636F6E737420696E697469616C697A657273203D206D6F64756C65446566696E6974696F6E735C6E2020202020202E726564756365287265736F';
wwv_flow_imp.g_varchar2_table(7363) := '6C7665446570656E64656E636965732C205B5D295C6E2020202020202E6D6170286C6F61644D6F64756C65293B5C6E5C6E202020206C657420696E697469616C697A6564203D2066616C73653B5C6E5C6E2020202072657475726E2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(7364) := '2829207B5C6E5C6E20202020202069662028696E697469616C697A656429207B5C6E202020202020202072657475726E3B5C6E2020202020207D5C6E5C6E202020202020696E697469616C697A6564203D20747275653B5C6E5C6E202020202020696E69';
wwv_flow_imp.g_varchar2_table(7365) := '7469616C697A6572732E666F724561636828696E697469616C697A6572203D3E20696E697469616C697A65722829293B5C6E202020207D3B5C6E20207D5C6E5C6E20202F2F207075626C6963204150495C6E2020746869732E676574203D206765743B5C';
wwv_flow_imp.g_varchar2_table(7366) := '6E2020746869732E696E766F6B65203D20696E766F6B653B5C6E2020746869732E696E7374616E7469617465203D20696E7374616E74696174653B5C6E2020746869732E6372656174654368696C64203D206372656174654368696C643B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(7367) := '2F2F2073657475705C6E2020746869732E696E6974203D20626F6F747374726170286D6F64756C6573293B5C6E7D5C6E5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E206172726179556E7772';
wwv_flow_imp.g_varchar2_table(7368) := '617028747970652C2076616C756529207B5C6E2020696620287479706520213D3D202776616C75652720262620697341727261792876616C75652929207B5C6E2020202076616C7565203D20616E6E6F746174652876616C75652E736C6963652829293B';
wwv_flow_imp.g_varchar2_table(7369) := '5C6E20207D5C6E5C6E202072657475726E2076616C75653B5C6E7D5C6E5C6E6578706F7274207B20496E6A6563746F722C20616E6E6F746174652C207061727365416E6E6F746174696F6E73207D3B5C6E2F2F2320736F757263654D617070696E675552';
wwv_flow_imp.g_varchar2_table(7370) := '4C3D696E6465782E6A732E6D61705C6E222C222F2A2A5C6E202A20466C617474656E2061727261792C206F6E65206C6576656C20646565702E5C6E202A5C6E202A204074656D706C61746520545C6E202A5C6E202A2040706172616D207B545B5D5B5D20';
wwv_flow_imp.g_varchar2_table(7371) := '7C20545B5D207C206E756C6C7D205B6172725D5C6E202A5C6E202A204072657475726E207B545B5D7D5C6E202A2F5C6E66756E6374696F6E20666C617474656E2861727229207B5C6E202072657475726E2041727261792E70726F746F747970652E636F';
wwv_flow_imp.g_varchar2_table(7372) := '6E6361742E6170706C79285B5D2C20617272293B5C6E7D5C6E5C6E636F6E7374206E6174697665546F537472696E67203D204F626A6563742E70726F746F747970652E746F537472696E673B5C6E636F6E7374206E61746976654861734F776E50726F70';
wwv_flow_imp.g_varchar2_table(7373) := '65727479203D204F626A6563742E70726F746F747970652E6861734F776E50726F70657274793B5C6E5C6E66756E6374696F6E206973556E646566696E6564286F626A29207B5C6E202072657475726E206F626A203D3D3D20756E646566696E65643B5C';
wwv_flow_imp.g_varchar2_table(7374) := '6E7D5C6E5C6E66756E6374696F6E206973446566696E6564286F626A29207B5C6E202072657475726E206F626A20213D3D20756E646566696E65643B5C6E7D5C6E5C6E66756E6374696F6E2069734E696C286F626A29207B5C6E202072657475726E206F';
wwv_flow_imp.g_varchar2_table(7375) := '626A203D3D206E756C6C3B5C6E7D5C6E5C6E66756E6374696F6E2069734172726179286F626A29207B5C6E202072657475726E206E6174697665546F537472696E672E63616C6C286F626A29203D3D3D20275B6F626A6563742041727261795D273B5C6E';
wwv_flow_imp.g_varchar2_table(7376) := '7D5C6E5C6E66756E6374696F6E2069734F626A656374286F626A29207B5C6E202072657475726E206E6174697665546F537472696E672E63616C6C286F626A29203D3D3D20275B6F626A656374204F626A6563745D273B5C6E7D5C6E5C6E66756E637469';
wwv_flow_imp.g_varchar2_table(7377) := '6F6E2069734E756D626572286F626A29207B5C6E202072657475726E206E6174697665546F537472696E672E63616C6C286F626A29203D3D3D20275B6F626A656374204E756D6265725D273B5C6E7D5C6E5C6E2F2A2A5C6E202A2040706172616D207B61';
wwv_flow_imp.g_varchar2_table(7378) := '6E797D206F626A5C6E202A5C6E202A204072657475726E207B626F6F6C65616E7D5C6E202A2F5C6E66756E6374696F6E20697346756E6374696F6E286F626A29207B5C6E2020636F6E737420746167203D206E6174697665546F537472696E672E63616C';
wwv_flow_imp.g_varchar2_table(7379) := '6C286F626A293B5C6E5C6E202072657475726E20285C6E20202020746167203D3D3D20275B6F626A6563742046756E6374696F6E5D27207C7C5C6E20202020746167203D3D3D20275B6F626A656374204173796E6346756E6374696F6E5D27207C7C5C6E';
wwv_flow_imp.g_varchar2_table(7380) := '20202020746167203D3D3D20275B6F626A6563742047656E657261746F7246756E6374696F6E5D27207C7C5C6E20202020746167203D3D3D20275B6F626A656374204173796E6347656E657261746F7246756E6374696F6E5D27207C7C5C6E2020202074';
wwv_flow_imp.g_varchar2_table(7381) := '6167203D3D3D20275B6F626A6563742050726F78795D275C6E2020293B5C6E7D5C6E5C6E66756E6374696F6E206973537472696E67286F626A29207B5C6E202072657475726E206E6174697665546F537472696E672E63616C6C286F626A29203D3D3D20';
wwv_flow_imp.g_varchar2_table(7382) := '275B6F626A65637420537472696E675D273B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20456E7375726520636F6C6C656374696F6E20697320616E2061727261792E5C6E202A5C6E202A2040706172616D207B4F626A6563747D206F626A5C6E202A2F5C6E';
wwv_flow_imp.g_varchar2_table(7383) := '66756E6374696F6E20656E737572654172726179286F626A29207B5C6E5C6E20206966202869734172726179286F626A2929207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E20207468726F77206E6577204572726F7228276D757374207375';
wwv_flow_imp.g_varchar2_table(7384) := '70706C7920617272617927293B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E20747275652C20696620746172676574206F776E7320612070726F706572747920776974682074686520676976656E206B65792E5C6E202A5C6E202A204070617261';
wwv_flow_imp.g_varchar2_table(7385) := '6D207B4F626A6563747D207461726765745C6E202A2040706172616D207B537472696E677D206B65795C6E202A5C6E202A204072657475726E207B426F6F6C65616E7D5C6E202A2F5C6E66756E6374696F6E20686173287461726765742C206B65792920';
wwv_flow_imp.g_varchar2_table(7386) := '7B5C6E202072657475726E206E61746976654861734F776E50726F70657274792E63616C6C287461726765742C206B6579293B5C6E7D5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C6E202A204074797065646566207B20285C6E202A2020';
wwv_flow_imp.g_varchar2_table(7387) := '202828653A205429203D3E20626F6F6C65616E29207C5C6E202A2020202828653A20542C206964783A206E756D62657229203D3E20626F6F6C65616E29207C5C6E202A2020202828653A20542C206B65793A20737472696E6729203D3E20626F6F6C6561';
wwv_flow_imp.g_varchar2_table(7388) := '6E29207C5C6E202A202020737472696E67207C5C6E202A2020206E756D6265725C6E202A2029207D204D6174636865725C6E202A2F5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C6E202A204074656D706C61746520555C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(7389) := '204074797065646566207B20285C6E202A2020202828653A205429203D3E205529207C20737472696E67207C206E756D6265725C6E202A2029207D20457874726163746F725C6E202A2F5C6E5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C';
wwv_flow_imp.g_varchar2_table(7390) := '6E202A204074797065646566207B202876616C3A20542C206B65793A20616E7929203D3E20626F6F6C65616E207D204D61746368466E5C6E202A2F5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C6E202A204074797065646566207B20545B';
wwv_flow_imp.g_varchar2_table(7391) := '5D207D204172726179436F6C6C656374696F6E5C6E202A2F5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C6E202A204074797065646566207B207B205B6B65793A20737472696E675D3A2054207D207D20537472696E674B657956616C7565';
wwv_flow_imp.g_varchar2_table(7392) := '436F6C6C656374696F6E5C6E202A2F5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C6E202A204074797065646566207B207B205B6B65793A206E756D6265725D3A2054207D207D204E756D6265724B657956616C7565436F6C6C656374696F';
wwv_flow_imp.g_varchar2_table(7393) := '6E5C6E202A2F5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C6E202A204074797065646566207B20537472696E674B657956616C7565436F6C6C656374696F6E3C543E207C204E756D6265724B657956616C7565436F6C6C656374696F6E3C';
wwv_flow_imp.g_varchar2_table(7394) := '543E207D204B657956616C7565436F6C6C656374696F6E5C6E202A2F5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C6E202A204074797065646566207B204B657956616C7565436F6C6C656374696F6E3C543E207C204172726179436F6C6C';
wwv_flow_imp.g_varchar2_table(7395) := '656374696F6E3C543E207D20436F6C6C656374696F6E5C6E202A2F5C6E5C6E2F2A2A5C6E202A2046696E6420656C656D656E7420696E20636F6C6C656374696F6E2E5C6E202A5C6E202A204074656D706C61746520545C6E202A2040706172616D207B43';
wwv_flow_imp.g_varchar2_table(7396) := '6F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E5C6E202A2040706172616D207B4D6174636865723C543E7D206D6174636865725C6E202A5C6E202A204072657475726E207B4F626A6563747D5C6E202A2F5C6E66756E6374696F6E2066696E';
wwv_flow_imp.g_varchar2_table(7397) := '6428636F6C6C656374696F6E2C206D61746368657229207B5C6E5C6E2020636F6E7374206D61746368466E203D20746F4D617463686572286D617463686572293B5C6E5C6E20206C6574206D617463683B5C6E5C6E2020666F724561636828636F6C6C65';
wwv_flow_imp.g_varchar2_table(7398) := '6374696F6E2C2066756E6374696F6E2876616C2C206B657929207B5C6E20202020696620286D61746368466E2876616C2C206B65792929207B5C6E2020202020206D61746368203D2076616C3B5C6E5C6E20202020202072657475726E2066616C73653B';
wwv_flow_imp.g_varchar2_table(7399) := '5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E206D617463683B5C6E5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2046696E6420656C656D656E7420696E64657820696E20636F6C6C656374696F6E2E5C6E202A5C6E202A204074656D706C';
wwv_flow_imp.g_varchar2_table(7400) := '61746520545C6E202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E5C6E202A2040706172616D207B4D6174636865723C543E7D206D6174636865725C6E202A5C6E202A204072657475726E207B6E756D6265727D';
wwv_flow_imp.g_varchar2_table(7401) := '5C6E202A2F5C6E66756E6374696F6E2066696E64496E64657828636F6C6C656374696F6E2C206D61746368657229207B5C6E5C6E2020636F6E7374206D61746368466E203D20746F4D617463686572286D617463686572293B5C6E5C6E20206C65742069';
wwv_flow_imp.g_varchar2_table(7402) := '6478203D206973417272617928636F6C6C656374696F6E29203F202D31203A20756E646566696E65643B5C6E5C6E2020666F724561636828636F6C6C656374696F6E2C2066756E6374696F6E2876616C2C206B657929207B5C6E20202020696620286D61';
wwv_flow_imp.g_varchar2_table(7403) := '746368466E2876616C2C206B65792929207B5C6E202020202020696478203D206B65793B5C6E5C6E20202020202072657475726E2066616C73653B5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E206964783B5C6E7D5C6E5C6E5C6E2F';
wwv_flow_imp.g_varchar2_table(7404) := '2A2A5C6E202A2046696C74657220656C656D656E747320696E20636F6C6C656374696F6E2E5C6E202A5C6E202A204074656D706C61746520545C6E202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E5C6E202A20';
wwv_flow_imp.g_varchar2_table(7405) := '40706172616D207B4D6174636865723C543E7D206D6174636865725C6E202A5C6E202A204072657475726E207B545B5D7D20726573756C745C6E202A2F5C6E66756E6374696F6E2066696C74657228636F6C6C656374696F6E2C206D6174636865722920';
wwv_flow_imp.g_varchar2_table(7406) := '7B5C6E5C6E2020636F6E7374206D61746368466E203D20746F4D617463686572286D617463686572293B5C6E5C6E20206C657420726573756C74203D205B5D3B5C6E5C6E2020666F724561636828636F6C6C656374696F6E2C2066756E6374696F6E2876';
wwv_flow_imp.g_varchar2_table(7407) := '616C2C206B657929207B5C6E20202020696620286D61746368466E2876616C2C206B65792929207B5C6E202020202020726573756C742E707573682876616C293B5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E20726573756C743B5C';
wwv_flow_imp.g_varchar2_table(7408) := '6E7D5C6E5C6E5C6E2F2A2A5C6E202A2049746572617465206F76657220636F6C6C656374696F6E3B2072657475726E696E6720736F6D657468696E675C6E202A20286E6F6E2D756E646566696E6564292077696C6C2073746F7020697465726174696F6E';
wwv_flow_imp.g_varchar2_table(7409) := '2E5C6E202A5C6E202A204074656D706C61746520545C6E202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E5C6E202A2040706172616D207B2028286974656D3A20542C206964783A206E756D62657229203D3E20';
wwv_flow_imp.g_varchar2_table(7410) := '28626F6F6C65616E7C766F69642929207C2028286974656D3A20542C206B65793A20737472696E6729203D3E2028626F6F6C65616E7C766F69642929207D206974657261746F725C6E202A5C6E202A204072657475726E207B547D2072657475726E2072';
wwv_flow_imp.g_varchar2_table(7411) := '6573756C7420746861742073746F707065642074686520697465726174696F6E5C6E202A2F5C6E66756E6374696F6E20666F724561636828636F6C6C656374696F6E2C206974657261746F7229207B5C6E5C6E20206C65742076616C2C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7412) := '20726573756C743B5C6E5C6E2020696620286973556E646566696E656428636F6C6C656374696F6E2929207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020636F6E737420636F6E766572744B6579203D206973417272617928636F6C6C65';
wwv_flow_imp.g_varchar2_table(7413) := '6374696F6E29203F20746F4E756D203A206964656E746974793B5C6E5C6E2020666F7220286C6574206B657920696E20636F6C6C656374696F6E29207B5C6E5C6E202020206966202868617328636F6C6C656374696F6E2C206B65792929207B5C6E2020';
wwv_flow_imp.g_varchar2_table(7414) := '2020202076616C203D20636F6C6C656374696F6E5B6B65795D3B5C6E5C6E202020202020726573756C74203D206974657261746F722876616C2C20636F6E766572744B6579286B657929293B5C6E5C6E20202020202069662028726573756C74203D3D3D';
wwv_flow_imp.g_varchar2_table(7415) := '2066616C736529207B5C6E202020202020202072657475726E2076616C3B5C6E2020202020207D5C6E202020207D5C6E20207D5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E20636F6C6C656374696F6E20776974686F757420656C656D656E742E';
wwv_flow_imp.g_varchar2_table(7416) := '5C6E202A5C6E202A204074656D706C61746520545C6E202A2040706172616D207B4172726179436F6C6C656374696F6E3C543E7D206172725C6E202A2040706172616D207B4D6174636865723C543E7D206D6174636865725C6E202A5C6E202A20407265';
wwv_flow_imp.g_varchar2_table(7417) := '7475726E207B545B5D7D5C6E202A2F5C6E66756E6374696F6E20776974686F7574286172722C206D61746368657229207B5C6E5C6E2020696620286973556E646566696E6564286172722929207B5C6E2020202072657475726E205B5D3B5C6E20207D5C';
wwv_flow_imp.g_varchar2_table(7418) := '6E5C6E2020656E73757265417272617928617272293B5C6E5C6E2020636F6E7374206D61746368466E203D20746F4D617463686572286D617463686572293B5C6E5C6E202072657475726E206172722E66696C7465722866756E6374696F6E28656C2C20';
wwv_flow_imp.g_varchar2_table(7419) := '69647829207B5C6E2020202072657475726E20216D61746368466E28656C2C20696478293B5C6E20207D293B5C6E5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2052656475636520636F6C6C656374696F6E2C2072657475726E696E6720612073696E676C65';
wwv_flow_imp.g_varchar2_table(7420) := '20726573756C742E5C6E202A5C6E202A204074656D706C61746520545C6E202A204074656D706C61746520565C6E202A5C6E202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E5C6E202A2040706172616D207B28';
wwv_flow_imp.g_varchar2_table(7421) := '726573756C743A20562C20656E7472793A20542C20696E6465783A20616E7929203D3E20567D206974657261746F725C6E202A2040706172616D207B567D20726573756C745C6E202A5C6E202A204072657475726E207B567D20726573756C7420726574';
wwv_flow_imp.g_varchar2_table(7422) := '75726E65642066726F6D206C617374206974657261746F725C6E202A2F5C6E66756E6374696F6E2072656475636528636F6C6C656374696F6E2C206974657261746F722C20726573756C7429207B5C6E5C6E2020666F724561636828636F6C6C65637469';
wwv_flow_imp.g_varchar2_table(7423) := '6F6E2C2066756E6374696F6E2876616C75652C2069647829207B5C6E20202020726573756C74203D206974657261746F7228726573756C742C2076616C75652C20696478293B5C6E20207D293B5C6E5C6E202072657475726E20726573756C743B5C6E7D';
wwv_flow_imp.g_varchar2_table(7424) := '5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E207472756520696620657665727920656C656D656E7420696E2074686520636F6C6C656374696F6E5C6E202A206D617463686573207468652063726974657269612E5C6E202A5C6E202A204070617261';
wwv_flow_imp.g_varchar2_table(7425) := '6D20207B4F626A6563747C41727261797D20636F6C6C656374696F6E5C6E202A2040706172616D20207B46756E6374696F6E7D206D6174636865725C6E202A5C6E202A204072657475726E207B426F6F6C65616E7D5C6E202A2F5C6E66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(7426) := '20657665727928636F6C6C656374696F6E2C206D61746368657229207B5C6E5C6E202072657475726E20212172656475636528636F6C6C656374696F6E2C2066756E6374696F6E286D6174636865732C2076616C2C206B657929207B5C6E202020207265';
wwv_flow_imp.g_varchar2_table(7427) := '7475726E206D617463686573202626206D6174636865722876616C2C206B6579293B5C6E20207D2C2074727565293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E207472756520696620736F6D6520656C656D656E747320696E2074686520';
wwv_flow_imp.g_varchar2_table(7428) := '636F6C6C656374696F6E5C6E202A206D61746368207468652063726974657269612E5C6E202A5C6E202A2040706172616D20207B4F626A6563747C41727261797D20636F6C6C656374696F6E5C6E202A2040706172616D20207B46756E6374696F6E7D20';
wwv_flow_imp.g_varchar2_table(7429) := '6D6174636865725C6E202A5C6E202A204072657475726E207B426F6F6C65616E7D5C6E202A2F5C6E66756E6374696F6E20736F6D6528636F6C6C656374696F6E2C206D61746368657229207B5C6E5C6E202072657475726E20212166696E6428636F6C6C';
wwv_flow_imp.g_varchar2_table(7430) := '656374696F6E2C206D617463686572293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A205472616E73666F726D206120636F6C6C656374696F6E20696E746F20616E6F7468657220636F6C6C656374696F6E5C6E202A20627920706970696E67206561636820';
wwv_flow_imp.g_varchar2_table(7431) := '6D656D626572207468726F7567682074686520676976656E20666E2E5C6E202A5C6E202A2040706172616D20207B4F626A6563747C41727261797D202020636F6C6C656374696F6E5C6E202A2040706172616D20207B46756E6374696F6E7D20666E5C6E';
wwv_flow_imp.g_varchar2_table(7432) := '202A5C6E202A204072657475726E207B41727261797D207472616E73666F726D656420636F6C6C656374696F6E5C6E202A2F5C6E66756E6374696F6E206D617028636F6C6C656374696F6E2C20666E29207B5C6E5C6E20206C657420726573756C74203D';
wwv_flow_imp.g_varchar2_table(7433) := '205B5D3B5C6E5C6E2020666F724561636828636F6C6C656374696F6E2C2066756E6374696F6E2876616C2C206B657929207B5C6E20202020726573756C742E7075736828666E2876616C2C206B657929293B5C6E20207D293B5C6E5C6E20207265747572';
wwv_flow_imp.g_varchar2_table(7434) := '6E20726573756C743B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A204765742074686520636F6C6C656374696F6E73206B6579732E5C6E202A5C6E202A2040706172616D20207B4F626A6563747C41727261797D20636F6C6C656374696F6E5C6E202A5C6E20';
wwv_flow_imp.g_varchar2_table(7435) := '2A204072657475726E207B41727261797D5C6E202A2F5C6E66756E6374696F6E206B65797328636F6C6C656374696F6E29207B5C6E202072657475726E20636F6C6C656374696F6E202626204F626A6563742E6B65797328636F6C6C656374696F6E2920';
wwv_flow_imp.g_varchar2_table(7436) := '7C7C205B5D3B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2053686F727468616E6420666F7220606B657973286F292E6C656E677468602E5C6E202A5C6E202A2040706172616D20207B4F626A6563747C41727261797D20636F6C6C656374696F6E5C6E202A';
wwv_flow_imp.g_varchar2_table(7437) := '5C6E202A204072657475726E207B4E756D6265727D5C6E202A2F5C6E66756E6374696F6E2073697A6528636F6C6C656374696F6E29207B5C6E202072657475726E206B65797328636F6C6C656374696F6E292E6C656E6774683B5C6E7D5C6E5C6E5C6E2F';
wwv_flow_imp.g_varchar2_table(7438) := '2A2A5C6E202A20476574207468652076616C75657320696E2074686520636F6C6C656374696F6E2E5C6E202A5C6E202A2040706172616D20207B4F626A6563747C41727261797D20636F6C6C656374696F6E5C6E202A5C6E202A204072657475726E207B';
wwv_flow_imp.g_varchar2_table(7439) := '41727261797D5C6E202A2F5C6E66756E6374696F6E2076616C75657328636F6C6C656374696F6E29207B5C6E202072657475726E206D617028636F6C6C656374696F6E2C202876616C29203D3E2076616C293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20';
wwv_flow_imp.g_varchar2_table(7440) := '47726F757020636F6C6C656374696F6E206D656D62657273206279206174747269627574652E5C6E202A5C6E202A2040706172616D207B4F626A6563747C41727261797D20636F6C6C656374696F6E5C6E202A2040706172616D207B457874726163746F';
wwv_flow_imp.g_varchar2_table(7441) := '727D20657874726163746F725C6E202A5C6E202A204072657475726E207B4F626A6563747D206D61702077697468207B206174747256616C7565203D3E205B20612C20622C2063205D207D5C6E202A2F5C6E66756E6374696F6E2067726F757042792863';
wwv_flow_imp.g_varchar2_table(7442) := '6F6C6C656374696F6E2C20657874726163746F722C2067726F75706564203D207B7D29207B5C6E5C6E2020657874726163746F72203D20746F457874726163746F7228657874726163746F72293B5C6E5C6E2020666F724561636828636F6C6C65637469';
wwv_flow_imp.g_varchar2_table(7443) := '6F6E2C2066756E6374696F6E2876616C29207B5C6E202020206C6574206469736372696D696E61746F72203D20657874726163746F722876616C29207C7C20275F273B5C6E5C6E202020206C65742067726F7570203D2067726F757065645B6469736372';
wwv_flow_imp.g_varchar2_table(7444) := '696D696E61746F725D3B5C6E5C6E20202020696620282167726F757029207B5C6E20202020202067726F7570203D2067726F757065645B6469736372696D696E61746F725D203D205B5D3B5C6E202020207D5C6E5C6E2020202067726F75702E70757368';
wwv_flow_imp.g_varchar2_table(7445) := '2876616C293B5C6E20207D293B5C6E5C6E202072657475726E2067726F757065643B5C6E7D5C6E5C6E5C6E66756E6374696F6E20756E69717565427928657874726163746F722C202E2E2E636F6C6C656374696F6E7329207B5C6E5C6E20206578747261';
wwv_flow_imp.g_varchar2_table(7446) := '63746F72203D20746F457874726163746F7228657874726163746F72293B5C6E5C6E20206C65742067726F75706564203D207B7D3B5C6E5C6E2020666F724561636828636F6C6C656374696F6E732C20286329203D3E2067726F7570427928632C206578';
wwv_flow_imp.g_varchar2_table(7447) := '74726163746F722C2067726F7570656429293B5C6E5C6E20206C657420726573756C74203D206D61702867726F757065642C2066756E6374696F6E2876616C2C206B657929207B5C6E2020202072657475726E2076616C5B305D3B5C6E20207D293B5C6E';
wwv_flow_imp.g_varchar2_table(7448) := '5C6E202072657475726E20726573756C743B5C6E7D5C6E5C6E5C6E636F6E737420756E696F6E4279203D20756E6971756542793B5C6E5C6E5C6E5C6E2F2A2A5C6E202A20536F727420636F6C6C656374696F6E2062792063726974657269612E5C6E202A';
wwv_flow_imp.g_varchar2_table(7449) := '5C6E202A204074656D706C61746520545C6E202A5C6E202A2040706172616D207B436F6C6C656374696F6E3C543E7D20636F6C6C656374696F6E5C6E202A2040706172616D207B457874726163746F723C542C206E756D626572207C20737472696E673E';
wwv_flow_imp.g_varchar2_table(7450) := '7D20657874726163746F725C6E202A5C6E202A204072657475726E207B41727261797D5C6E202A2F5C6E66756E6374696F6E20736F7274427928636F6C6C656374696F6E2C20657874726163746F7229207B5C6E5C6E2020657874726163746F72203D20';
wwv_flow_imp.g_varchar2_table(7451) := '746F457874726163746F7228657874726163746F72293B5C6E5C6E20206C657420736F72746564203D205B5D3B5C6E5C6E2020666F724561636828636F6C6C656374696F6E2C2066756E6374696F6E2876616C75652C206B657929207B5C6E202020206C';
wwv_flow_imp.g_varchar2_table(7452) := '65742064697363203D20657874726163746F722876616C75652C206B6579293B5C6E5C6E202020206C657420656E747279203D207B5C6E202020202020643A20646973632C5C6E202020202020763A2076616C75655C6E202020207D3B5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(7453) := '20666F72202876617220696478203D20303B20696478203C20736F727465642E6C656E6774683B206964782B2B29207B5C6E2020202020206C6574207B2064207D203D20736F727465645B6964785D3B5C6E5C6E2020202020206966202864697363203C';
wwv_flow_imp.g_varchar2_table(7454) := '206429207B5C6E2020202020202020736F727465642E73706C696365286964782C20302C20656E747279293B5C6E202020202020202072657475726E3B5C6E2020202020207D5C6E202020207D5C6E5C6E202020202F2F206E6F7420696E736572746564';
wwv_flow_imp.g_varchar2_table(7455) := '2C20617070656E64202821295C6E20202020736F727465642E7075736828656E747279293B5C6E20207D293B5C6E5C6E202072657475726E206D617028736F727465642C20286529203D3E20652E76293B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A204372';
wwv_flow_imp.g_varchar2_table(7456) := '6561746520616E206F626A656374207061747465726E206D6174636865722E5C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A206060606A6176617363726970745C6E202A20636F6E7374206D617463686572203D206D6174636850617474';
wwv_flow_imp.g_varchar2_table(7457) := '65726E287B2069643A2031207D293B5C6E202A5C6E202A206C657420656C656D656E74203D2066696E6428656C656D656E74732C206D617463686572293B5C6E202A206060605C6E202A5C6E202A204074656D706C61746520545C6E202A5C6E202A2040';
wwv_flow_imp.g_varchar2_table(7458) := '706172616D207B547D207061747465726E5C6E202A5C6E202A204072657475726E207B2028656C3A20616E7929203D3E2020626F6F6C65616E207D206D617463686572466E5C6E202A2F5C6E66756E6374696F6E206D617463685061747465726E287061';
wwv_flow_imp.g_varchar2_table(7459) := '747465726E29207B5C6E5C6E202072657475726E2066756E6374696F6E28656C29207B5C6E5C6E2020202072657475726E206576657279287061747465726E2C2066756E6374696F6E2876616C2C206B657929207B5C6E20202020202072657475726E20';
wwv_flow_imp.g_varchar2_table(7460) := '656C5B6B65795D203D3D3D2076616C3B5C6E202020207D293B5C6E5C6E20207D3B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2040706172616D207B737472696E67207C202828653A20616E7929203D3E20616E7929207D20657874726163746F725C6E202A';
wwv_flow_imp.g_varchar2_table(7461) := '5C6E202A204072657475726E207B2028653A20616E7929203D3E20616E79207D5C6E202A2F5C6E66756E6374696F6E20746F457874726163746F7228657874726163746F7229207B5C6E5C6E20202F2A2A5C6E2020202A2040736174697366696573207B';
wwv_flow_imp.g_varchar2_table(7462) := '2028653A20616E7929203D3E20616E79207D5C6E2020202A2F5C6E202072657475726E20697346756E6374696F6E28657874726163746F7229203F20657874726163746F72203A20286529203D3E207B5C6E5C6E202020202F2F204074732D69676E6F72';
wwv_flow_imp.g_varchar2_table(7463) := '653A206A75737420776F726B735C6E2020202072657475726E20655B657874726163746F725D3B5C6E20207D3B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A204074656D706C61746520545C6E202A2040706172616D207B4D6174636865723C543E7D206D61';
wwv_flow_imp.g_varchar2_table(7464) := '74636865725C6E202A5C6E202A204072657475726E207B4D61746368466E3C543E7D5C6E202A2F5C6E66756E6374696F6E20746F4D617463686572286D61746368657229207B5C6E202072657475726E20697346756E6374696F6E286D61746368657229';
wwv_flow_imp.g_varchar2_table(7465) := '203F206D617463686572203A20286529203D3E207B5C6E2020202072657475726E2065203D3D3D206D6174636865723B5C6E20207D3B5C6E7D5C6E5C6E5C6E66756E6374696F6E206964656E746974792861726729207B5C6E202072657475726E206172';
wwv_flow_imp.g_varchar2_table(7466) := '673B5C6E7D5C6E5C6E66756E6374696F6E20746F4E756D2861726729207B5C6E202072657475726E204E756D62657228617267293B5C6E7D5C6E5C6E2F2A20676C6F62616C2073657454696D656F757420636C65617254696D656F7574202A2F5C6E5C6E';
wwv_flow_imp.g_varchar2_table(7467) := '2F2A2A5C6E202A204074797065646566207B207B5C6E202A202020282E2E2E617267733A20616E795B5D293A20616E793B5C6E202A202020666C7573683A202829203D3E20766F69643B5C6E202A20202063616E63656C3A202829203D3E20766F69643B';
wwv_flow_imp.g_varchar2_table(7468) := '5C6E202A207D207D204465626F756E63656446756E6374696F6E5C6E202A2F5C6E5C6E2F2A2A5C6E202A204465626F756E636520666E2C2063616C6C696E67206974206F6E6C79206F6E63652069662074686520676976656E2074696D655C6E202A2065';
wwv_flow_imp.g_varchar2_table(7469) := '6C6170736564206265747765656E2063616C6C732E5C6E202A5C6E202A204C6F646173682D7374796C65207468652066756E6374696F6E206578706F736573206D6574686F647320746F206023636C656172605C6E202A20616E64206023666C75736860';
wwv_flow_imp.g_varchar2_table(7470) := '20746F20636F6E74726F6C20696E7465726E616C206265686176696F722E5C6E202A5C6E202A2040706172616D20207B46756E6374696F6E7D20666E5C6E202A2040706172616D20207B4E756D6265727D2074696D656F75745C6E202A5C6E202A204072';
wwv_flow_imp.g_varchar2_table(7471) := '657475726E207B4465626F756E63656446756E6374696F6E7D206465626F756E6365642066756E6374696F6E5C6E202A2F5C6E66756E6374696F6E206465626F756E636528666E2C2074696D656F757429207B5C6E5C6E20206C65742074696D65723B5C';
wwv_flow_imp.g_varchar2_table(7472) := '6E5C6E20206C6574206C617374417267733B5C6E20206C6574206C617374546869733B5C6E5C6E20206C6574206C6173744E6F773B5C6E5C6E202066756E6374696F6E206669726528666F72636529207B5C6E5C6E202020206C6574206E6F77203D2044';
wwv_flow_imp.g_varchar2_table(7473) := '6174652E6E6F7728293B5C6E5C6E202020206C6574207363686564756C656444696666203D20666F726365203F2030203A20286C6173744E6F77202B2074696D656F757429202D206E6F773B5C6E5C6E20202020696620287363686564756C6564446966';
wwv_flow_imp.g_varchar2_table(7474) := '66203E203029207B5C6E20202020202072657475726E207363686564756C65287363686564756C656444696666293B5C6E202020207D5C6E5C6E20202020666E2E6170706C79286C617374546869732C206C61737441726773293B5C6E5C6E2020202063';
wwv_flow_imp.g_varchar2_table(7475) := '6C65617228293B5C6E20207D5C6E5C6E202066756E6374696F6E207363686564756C652874696D656F757429207B5C6E2020202074696D6572203D2073657454696D656F757428666972652C2074696D656F7574293B5C6E20207D5C6E5C6E202066756E';
wwv_flow_imp.g_varchar2_table(7476) := '6374696F6E20636C6561722829207B5C6E202020206966202874696D657229207B5C6E202020202020636C65617254696D656F75742874696D6572293B5C6E202020207D5C6E5C6E2020202074696D6572203D206C6173744E6F77203D206C6173744172';
wwv_flow_imp.g_varchar2_table(7477) := '6773203D206C61737454686973203D20756E646566696E65643B5C6E20207D5C6E5C6E202066756E6374696F6E20666C7573682829207B5C6E202020206966202874696D657229207B5C6E202020202020666972652874727565293B5C6E202020207D5C';
wwv_flow_imp.g_varchar2_table(7478) := '6E5C6E20202020636C65617228293B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A204074797065207B204465626F756E63656446756E6374696F6E207D5C6E2020202A2F5C6E202066756E6374696F6E2063616C6C6261636B282E2E2E6172677329';
wwv_flow_imp.g_varchar2_table(7479) := '207B5C6E202020206C6173744E6F77203D20446174652E6E6F7728293B5C6E5C6E202020206C61737441726773203D20617267733B5C6E202020206C61737454686973203D20746869733B5C6E5C6E202020202F2F20656E7375726520616E2065786563';
wwv_flow_imp.g_varchar2_table(7480) := '7574696F6E206973207363686564756C65645C6E20202020696620282174696D657229207B5C6E2020202020207363686564756C652874696D656F7574293B5C6E202020207D5C6E20207D5C6E5C6E202063616C6C6261636B2E666C757368203D20666C';
wwv_flow_imp.g_varchar2_table(7481) := '7573683B5C6E202063616C6C6261636B2E63616E63656C203D20636C6561723B5C6E5C6E202072657475726E2063616C6C6261636B3B5C6E7D5C6E5C6E2F2A2A5C6E202A205468726F74746C6520666E2C2063616C6C696E67206174206D6F7374206F6E';
wwv_flow_imp.g_varchar2_table(7482) := '63655C6E202A20696E2074686520676976656E20696E74657276616C2E5C6E202A5C6E202A2040706172616D20207B46756E6374696F6E7D20666E5C6E202A2040706172616D20207B4E756D6265727D20696E74657276616C5C6E202A5C6E202A204072';
wwv_flow_imp.g_varchar2_table(7483) := '657475726E207B46756E6374696F6E7D207468726F74746C65642066756E6374696F6E5C6E202A2F5C6E66756E6374696F6E207468726F74746C6528666E2C20696E74657276616C29207B5C6E20206C6574207468726F74746C696E67203D2066616C73';
wwv_flow_imp.g_varchar2_table(7484) := '653B5C6E5C6E202072657475726E2066756E6374696F6E282E2E2E6172677329207B5C6E5C6E20202020696620287468726F74746C696E6729207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E20202020666E282E2E2E6172677329';
wwv_flow_imp.g_varchar2_table(7485) := '3B5C6E202020207468726F74746C696E67203D20747275653B5C6E5C6E2020202073657454696D656F7574282829203D3E207B5C6E2020202020207468726F74746C696E67203D2066616C73653B5C6E202020207D2C20696E74657276616C293B5C6E20';
wwv_flow_imp.g_varchar2_table(7486) := '207D3B5C6E7D5C6E5C6E2F2A2A5C6E202A2042696E642066756E6374696F6E20616761696E737420746172676574203C746869733E2E5C6E202A5C6E202A2040706172616D20207B46756E6374696F6E7D20666E5C6E202A2040706172616D20207B4F62';
wwv_flow_imp.g_varchar2_table(7487) := '6A6563747D2020207461726765745C6E202A5C6E202A204072657475726E207B46756E6374696F6E7D20626F756E642066756E6374696F6E5C6E202A2F5C6E66756E6374696F6E2062696E6428666E2C2074617267657429207B5C6E202072657475726E';
wwv_flow_imp.g_varchar2_table(7488) := '20666E2E62696E6428746172676574293B5C6E7D5C6E5C6E2F2A2A5C6E202A20436F6E76656E69656E6365207772617070657220666F7220604F626A6563742E61737369676E602E5C6E202A5C6E202A2040706172616D207B4F626A6563747D20746172';
wwv_flow_imp.g_varchar2_table(7489) := '6765745C6E202A2040706172616D207B2E2E2E4F626A6563747D206F74686572735C6E202A5C6E202A204072657475726E207B4F626A6563747D20746865207461726765745C6E202A2F5C6E66756E6374696F6E2061737369676E287461726765742C20';
wwv_flow_imp.g_varchar2_table(7490) := '2E2E2E6F746865727329207B5C6E202072657475726E204F626A6563742E61737369676E287461726765742C202E2E2E6F7468657273293B5C6E7D5C6E5C6E2F2A2A5C6E202A20536574732061206E65737465642070726F7065727479206F6620612067';
wwv_flow_imp.g_varchar2_table(7491) := '6976656E206F626A65637420746F20746865207370656369666965642076616C75652E5C6E202A5C6E202A2054686973206D75746174657320746865206F626A65637420616E642072657475726E732069742E5C6E202A5C6E202A204074656D706C6174';
wwv_flow_imp.g_varchar2_table(7492) := '6520545C6E202A5C6E202A2040706172616D207B547D207461726765742054686520746172676574206F662074686520736574206F7065726174696F6E2E5C6E202A2040706172616D207B28737472696E677C6E756D626572295B5D7D20706174682054';
wwv_flow_imp.g_varchar2_table(7493) := '6865207061746820746F20746865206E65737465642076616C75652E5C6E202A2040706172616D207B616E797D2076616C7565205468652076616C756520746F207365742E5C6E202A5C6E202A204072657475726E207B547D5C6E202A2F5C6E66756E63';
wwv_flow_imp.g_varchar2_table(7494) := '74696F6E20736574287461726765742C20706174682C2076616C756529207B5C6E5C6E20206C65742063757272656E74546172676574203D207461726765743B5C6E5C6E2020666F724561636828706174682C2066756E6374696F6E286B65792C206964';
wwv_flow_imp.g_varchar2_table(7495) := '7829207B5C6E5C6E2020202069662028747970656F66206B657920213D3D20276E756D6265722720262620747970656F66206B657920213D3D2027737472696E672729207B5C6E2020202020207468726F77206E6577204572726F722827696C6C656761';
wwv_flow_imp.g_varchar2_table(7496) := '6C206B657920747970653A2027202B20747970656F66206B6579202B20272E204B65792073686F756C64206265206F662074797065206E756D626572206F7220737472696E672E27293B5C6E202020207D5C6E5C6E20202020696620286B6579203D3D3D';
wwv_flow_imp.g_varchar2_table(7497) := '2027636F6E7374727563746F722729207B5C6E2020202020207468726F77206E6577204572726F722827696C6C6567616C206B65793A20636F6E7374727563746F7227293B5C6E202020207D5C6E5C6E20202020696620286B6579203D3D3D20275F5F70';
wwv_flow_imp.g_varchar2_table(7498) := '726F746F5F5F2729207B5C6E2020202020207468726F77206E6577204572726F722827696C6C6567616C206B65793A205F5F70726F746F5F5F27293B5C6E202020207D5C6E5C6E202020206C6574206E6578744B6579203D20706174685B696478202B20';
wwv_flow_imp.g_varchar2_table(7499) := '315D3B5C6E202020206C6574206E657874546172676574203D2063757272656E745461726765745B6B65795D3B5C6E5C6E20202020696620286973446566696E6564286E6578744B6579292026262069734E696C286E6578745461726765742929207B5C';
wwv_flow_imp.g_varchar2_table(7500) := '6E2020202020206E657874546172676574203D2063757272656E745461726765745B6B65795D203D2069734E614E282B6E6578744B657929203F207B7D203A205B5D3B5C6E202020207D5C6E5C6E20202020696620286973556E646566696E6564286E65';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(7501) := '78744B65792929207B5C6E202020202020696620286973556E646566696E65642876616C75652929207B5C6E202020202020202064656C6574652063757272656E745461726765745B6B65795D3B5C6E2020202020207D20656C7365207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(7502) := '2020202063757272656E745461726765745B6B65795D203D2076616C75653B5C6E2020202020207D5C6E202020207D20656C7365207B5C6E20202020202063757272656E74546172676574203D206E6578745461726765743B5C6E202020207D5C6E2020';
wwv_flow_imp.g_varchar2_table(7503) := '7D293B5C6E5C6E202072657475726E207461726765743B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20476574732061206E65737465642070726F7065727479206F66206120676976656E206F626A6563742E5C6E202A5C6E202A2040706172616D207B4F62';
wwv_flow_imp.g_varchar2_table(7504) := '6A6563747D207461726765742054686520746172676574206F662074686520676574206F7065726174696F6E2E5C6E202A2040706172616D207B28737472696E677C6E756D626572295B5D7D207061746820546865207061746820746F20746865206E65';
wwv_flow_imp.g_varchar2_table(7505) := '737465642076616C75652E5C6E202A2040706172616D207B616E797D205B64656661756C7456616C75655D205468652076616C756520746F2072657475726E206966206E6F2076616C7565206578697374732E5C6E202A5C6E202A204072657475726E20';
wwv_flow_imp.g_varchar2_table(7506) := '7B616E797D5C6E202A2F5C6E66756E6374696F6E20676574287461726765742C20706174682C2064656661756C7456616C756529207B5C6E5C6E20206C65742063757272656E74546172676574203D207461726765743B5C6E5C6E2020666F7245616368';
wwv_flow_imp.g_varchar2_table(7507) := '28706174682C2066756E6374696F6E286B657929207B5C6E5C6E202020202F2F20616363657373696E67206E696C2070726F7065727479207969656C6473203C756E646566696E65643E5C6E202020206966202869734E696C2863757272656E74546172';
wwv_flow_imp.g_varchar2_table(7508) := '6765742929207B5C6E20202020202063757272656E74546172676574203D20756E646566696E65643B5C6E5C6E20202020202072657475726E2066616C73653B5C6E202020207D5C6E5C6E2020202063757272656E74546172676574203D206375727265';
wwv_flow_imp.g_varchar2_table(7509) := '6E745461726765745B6B65795D3B5C6E20207D293B5C6E5C6E202072657475726E206973556E646566696E65642863757272656E7454617267657429203F2064656661756C7456616C7565203A2063757272656E745461726765743B5C6E7D5C6E5C6E2F';
wwv_flow_imp.g_varchar2_table(7510) := '2A2A5C6E202A205069636B2070726F706572746965732066726F6D2074686520676976656E207461726765742E5C6E202A5C6E202A204074656D706C61746520545C6E202A204074656D706C617465207B616E795B5D7D20565C6E202A5C6E202A204070';
wwv_flow_imp.g_varchar2_table(7511) := '6172616D207B547D207461726765745C6E202A2040706172616D207B567D2070726F706572746965735C6E202A5C6E202A204072657475726E205069636B3C542C20563E5C6E202A2F5C6E66756E6374696F6E207069636B287461726765742C2070726F';
wwv_flow_imp.g_varchar2_table(7512) := '7065727469657329207B5C6E5C6E20206C657420726573756C74203D207B7D3B5C6E5C6E20206C6574206F626A203D204F626A65637428746172676574293B5C6E5C6E2020666F72456163682870726F706572746965732C2066756E6374696F6E287072';
wwv_flow_imp.g_varchar2_table(7513) := '6F7029207B5C6E5C6E202020206966202870726F7020696E206F626A29207B5C6E202020202020726573756C745B70726F705D203D207461726765745B70726F705D3B5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E20726573756C74';
wwv_flow_imp.g_varchar2_table(7514) := '3B5C6E7D5C6E5C6E2F2A2A5C6E202A205069636B20616C6C207461726765742070726F706572746965732C206578636C7564696E672074686520676976656E206F6E65732E5C6E202A5C6E202A204074656D706C61746520545C6E202A204074656D706C';
wwv_flow_imp.g_varchar2_table(7515) := '617465207B616E795B5D7D20565C6E202A5C6E202A2040706172616D207B547D207461726765745C6E202A2040706172616D207B567D2070726F706572746965735C6E202A5C6E202A204072657475726E207B4F6D69743C542C20563E7D207461726765';
wwv_flow_imp.g_varchar2_table(7516) := '745C6E202A2F5C6E66756E6374696F6E206F6D6974287461726765742C2070726F7065727469657329207B5C6E5C6E20206C657420726573756C74203D207B7D3B5C6E5C6E20206C6574206F626A203D204F626A65637428746172676574293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(7517) := '2020666F7245616368286F626A2C2066756E6374696F6E2870726F702C206B657929207B5C6E5C6E202020206966202870726F706572746965732E696E6465784F66286B657929203D3D3D202D3129207B5C6E202020202020726573756C745B6B65795D';
wwv_flow_imp.g_varchar2_table(7518) := '203D2070726F703B5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E20726573756C743B5C6E7D5C6E5C6E2F2A2A5C6E202A205265637572736976656C79206D6572676520602E2E2E736F75726365736020696E746F20676976656E2074';
wwv_flow_imp.g_varchar2_table(7519) := '61726765742E5C6E202A5C6E202A20446F657320737570706F7274206D657267696E67206F626A656374733B20646F6573206E6F7420737570706F7274206D657267696E67206172726179732E5C6E202A5C6E202A2040706172616D207B4F626A656374';
wwv_flow_imp.g_varchar2_table(7520) := '7D207461726765745C6E202A2040706172616D207B2E2E2E4F626A6563747D20736F75726365735C6E202A5C6E202A204072657475726E207B4F626A6563747D20746865207461726765745C6E202A2F5C6E66756E6374696F6E206D6572676528746172';
wwv_flow_imp.g_varchar2_table(7521) := '6765742C202E2E2E736F757263657329207B5C6E5C6E20206966202821736F75726365732E6C656E67746829207B5C6E2020202072657475726E207461726765743B5C6E20207D5C6E5C6E2020666F724561636828736F75726365732C2066756E637469';
wwv_flow_imp.g_varchar2_table(7522) := '6F6E28736F7572636529207B5C6E5C6E202020202F2F20736B6970206E6F6E2D6F626A20736F75726365732C20692E652E206E756C6C5C6E202020206966202821736F75726365207C7C202169734F626A65637428736F757263652929207B5C6E202020';
wwv_flow_imp.g_varchar2_table(7523) := '20202072657475726E3B5C6E202020207D5C6E5C6E20202020666F724561636828736F757263652C2066756E6374696F6E28736F7572636556616C2C206B657929207B5C6E5C6E202020202020696620286B6579203D3D3D20275F5F70726F746F5F5F27';
wwv_flow_imp.g_varchar2_table(7524) := '29207B5C6E202020202020202072657475726E3B5C6E2020202020207D5C6E5C6E2020202020206C65742074617267657456616C203D207461726765745B6B65795D3B5C6E5C6E2020202020206966202869734F626A65637428736F7572636556616C29';
wwv_flow_imp.g_varchar2_table(7525) := '29207B5C6E5C6E2020202020202020696620282169734F626A6563742874617267657456616C2929207B5C6E5C6E202020202020202020202F2F206F76657272696465207461726765745B6B65795D2077697468206F626A6563745C6E20202020202020';
wwv_flow_imp.g_varchar2_table(7526) := '20202074617267657456616C203D207B7D3B5C6E20202020202020207D5C6E5C6E20202020202020207461726765745B6B65795D203D206D657267652874617267657456616C2C20736F7572636556616C293B5C6E2020202020207D20656C7365207B5C';
wwv_flow_imp.g_varchar2_table(7527) := '6E20202020202020207461726765745B6B65795D203D20736F7572636556616C3B5C6E2020202020207D5C6E5C6E202020207D293B5C6E20207D293B5C6E5C6E202072657475726E207461726765743B5C6E7D5C6E5C6E6578706F7274207B2061737369';
wwv_flow_imp.g_varchar2_table(7528) := '676E2C2062696E642C206465626F756E63652C20656E7375726541727261792C2065766572792C2066696C7465722C2066696E642C2066696E64496E6465782C20666C617474656E2C20666F72456163682C206765742C2067726F757042792C20686173';
wwv_flow_imp.g_varchar2_table(7529) := '2C20697341727261792C206973446566696E65642C20697346756E6374696F6E2C2069734E696C2C2069734E756D6265722C2069734F626A6563742C206973537472696E672C206973556E646566696E65642C206B6579732C206D61702C206D61746368';
wwv_flow_imp.g_varchar2_table(7530) := '5061747465726E2C206D657267652C206F6D69742C207069636B2C207265647563652C207365742C2073697A652C20736F6D652C20736F727442792C207468726F74746C652C20756E696F6E42792C20756E6971756542792C2076616C7565732C207769';
wwv_flow_imp.g_varchar2_table(7531) := '74686F7574207D3B5C6E222C22696D706F7274207B20666F72456163682C2061737369676E2C2066696E642C206973537472696E672C2066696E64496E6465782C2066696C7465722C20686173207D2066726F6D20276D696E2D64617368273B5C6E696D';
wwv_flow_imp.g_varchar2_table(7532) := '706F7274207B20506172736572207D2066726F6D2027736178656E273B5C6E696D706F7274207B20636F65726365547970652C2070617273654E616D654E532C20697353696D706C65547970652C204D6F64646C65207D2066726F6D20276D6F64646C65';
wwv_flow_imp.g_varchar2_table(7533) := '273B5C6E5C6E66756E6374696F6E206861734C6F77657243617365416C69617328706B6729207B5C6E202072657475726E20706B672E786D6C20262620706B672E786D6C2E746167416C696173203D3D3D20276C6F77657243617365273B5C6E7D5C6E5C';
wwv_flow_imp.g_varchar2_table(7534) := '6E7661722044454641554C545F4E535F4D4150203D207B5C6E202027787369273A2027687474703A2F2F7777772E77332E6F72672F323030312F584D4C536368656D612D696E7374616E6365272C5C6E202027786D6C273A2027687474703A2F2F777777';
wwv_flow_imp.g_varchar2_table(7535) := '2E77332E6F72672F584D4C2F313939382F6E616D657370616365275C6E7D3B5C6E5C6E766172205853495F54595045203D20277873693A74797065273B5C6E5C6E66756E6374696F6E2073657269616C697A65466F726D617428656C656D656E7429207B';
wwv_flow_imp.g_varchar2_table(7536) := '5C6E202072657475726E20656C656D656E742E786D6C20262620656C656D656E742E786D6C2E73657269616C697A653B5C6E7D5C6E5C6E66756E6374696F6E2073657269616C697A6541735479706528656C656D656E7429207B5C6E202072657475726E';
wwv_flow_imp.g_varchar2_table(7537) := '2073657269616C697A65466F726D617428656C656D656E7429203D3D3D205853495F545950453B5C6E7D5C6E5C6E66756E6374696F6E2073657269616C697A65417350726F706572747928656C656D656E7429207B5C6E202072657475726E2073657269';
wwv_flow_imp.g_varchar2_table(7538) := '616C697A65466F726D617428656C656D656E7429203D3D3D202770726F7065727479273B5C6E7D5C6E5C6E66756E6374696F6E206361706974616C697A652873747229207B5C6E202072657475726E207374722E6368617241742830292E746F55707065';
wwv_flow_imp.g_varchar2_table(7539) := '72436173652829202B207374722E736C6963652831293B5C6E7D5C6E5C6E66756E6374696F6E20616C696173546F4E616D6528616C6961734E732C20706B6729207B5C6E5C6E202069662028216861734C6F77657243617365416C69617328706B672929';
wwv_flow_imp.g_varchar2_table(7540) := '207B5C6E2020202072657475726E20616C6961734E732E6E616D653B5C6E20207D5C6E5C6E202072657475726E20616C6961734E732E707265666978202B20273A27202B206361706974616C697A6528616C6961734E732E6C6F63616C4E616D65293B5C';
wwv_flow_imp.g_varchar2_table(7541) := '6E7D5C6E5C6E66756E6374696F6E207072656669786564546F4E616D65286E616D654E732C20706B6729207B5C6E5C6E2020766172206E616D65203D206E616D654E732E6E616D652C5C6E2020202020206C6F63616C4E616D65203D206E616D654E732E';
wwv_flow_imp.g_varchar2_table(7542) := '6C6F63616C4E616D653B5C6E5C6E20207661722074797065507265666978203D20706B672E786D6C20262620706B672E786D6C2E747970655072656669783B5C6E5C6E20206966202874797065507265666978202626206C6F63616C4E616D652E696E64';
wwv_flow_imp.g_varchar2_table(7543) := '65784F66287479706550726566697829203D3D3D203029207B5C6E2020202072657475726E206E616D654E732E707265666978202B20273A27202B206C6F63616C4E616D652E736C69636528747970655072656669782E6C656E677468293B5C6E20207D';
wwv_flow_imp.g_varchar2_table(7544) := '20656C7365207B5C6E2020202072657475726E206E616D653B5C6E20207D5C6E7D5C6E5C6E66756E6374696F6E206E6F726D616C697A65587369547970654E616D65286E616D652C206D6F64656C29207B5C6E5C6E2020766172206E616D654E73203D20';
wwv_flow_imp.g_varchar2_table(7545) := '70617273654E616D654E53286E616D65293B5C6E202076617220706B67203D206D6F64656C2E6765745061636B616765286E616D654E732E707265666978293B5C6E5C6E202072657475726E207072656669786564546F4E616D65286E616D654E732C20';
wwv_flow_imp.g_varchar2_table(7546) := '706B67293B5C6E7D5C6E5C6E66756E6374696F6E206572726F72286D65737361676529207B5C6E202072657475726E206E6577204572726F72286D657373616765293B5C6E7D5C6E5C6E2F2A2A5C6E202A2047657420746865206D6F64646C6520646573';
wwv_flow_imp.g_varchar2_table(7547) := '63726970746F7220666F72206120676976656E20696E7374616E6365206F7220747970652E5C6E202A5C6E202A2040706172616D20207B4D6F64646C65456C656D656E747C46756E6374696F6E7D20656C656D656E745C6E202A5C6E202A204072657475';
wwv_flow_imp.g_varchar2_table(7548) := '726E207B4F626A6563747D20746865206D6F64646C652064657363726970746F725C6E202A2F5C6E66756E6374696F6E206765744D6F64646C6544657363726970746F7228656C656D656E7429207B5C6E202072657475726E20656C656D656E742E2464';
wwv_flow_imp.g_varchar2_table(7549) := '657363726970746F723B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A204120706172736520636F6E746578742E5C6E202A5C6E202A2040636C6173735C6E202A5C6E202A2040706172616D207B4F626A6563747D206F7074696F6E735C6E202A204070617261';
wwv_flow_imp.g_varchar2_table(7550) := '6D207B456C656D656E7448616E646C65727D206F7074696F6E732E726F6F7448616E646C65722074686520726F6F742068616E646C657220666F722070617273696E67206120646F63756D656E745C6E202A2040706172616D207B626F6F6C65616E7D20';
wwv_flow_imp.g_varchar2_table(7551) := '5B6F7074696F6E732E6C61783D66616C73655D2077686574686572206F72206E6F7420746F2069676E6F726520696E76616C696420656C656D656E74735C6E202A2F5C6E66756E6374696F6E20436F6E74657874286F7074696F6E7329207B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(7552) := '202F2A2A5C6E2020202A204070726F7065727479207B456C656D656E7448616E646C65727D20726F6F7448616E646C65725C6E2020202A2F5C6E5C6E20202F2A2A5C6E2020202A204070726F7065727479207B426F6F6C65616E7D206C61785C6E202020';
wwv_flow_imp.g_varchar2_table(7553) := '2A2F5C6E5C6E202061737369676E28746869732C206F7074696F6E73293B5C6E5C6E2020746869732E656C656D656E747342794964203D207B7D3B5C6E2020746869732E7265666572656E636573203D205B5D3B5C6E2020746869732E7761726E696E67';
wwv_flow_imp.g_varchar2_table(7554) := '73203D205B5D3B5C6E5C6E20202F2A2A5C6E2020202A2041646420616E20756E7265736F6C766564207265666572656E63652E5C6E2020202A5C6E2020202A2040706172616D207B4F626A6563747D207265666572656E63655C6E2020202A2F5C6E2020';
wwv_flow_imp.g_varchar2_table(7555) := '746869732E6164645265666572656E6365203D2066756E6374696F6E287265666572656E636529207B5C6E20202020746869732E7265666572656E6365732E70757368287265666572656E6365293B5C6E20207D3B5C6E5C6E20202F2A2A5C6E2020202A';
wwv_flow_imp.g_varchar2_table(7556) := '2041646420612070726F63657373656420656C656D656E742E5C6E2020202A5C6E2020202A2040706172616D207B4D6F64646C65456C656D656E747D20656C656D656E745C6E2020202A2F5C6E2020746869732E616464456C656D656E74203D2066756E';
wwv_flow_imp.g_varchar2_table(7557) := '6374696F6E28656C656D656E7429207B5C6E5C6E202020206966202821656C656D656E7429207B5C6E2020202020207468726F77206572726F722827657870656374656420656C656D656E7427293B5C6E202020207D5C6E5C6E2020202076617220656C';
wwv_flow_imp.g_varchar2_table(7558) := '656D656E747342794964203D20746869732E656C656D656E7473427949643B5C6E5C6E202020207661722064657363726970746F72203D206765744D6F64646C6544657363726970746F7228656C656D656E74293B5C6E5C6E2020202076617220696450';
wwv_flow_imp.g_varchar2_table(7559) := '726F7065727479203D2064657363726970746F722E696450726F70657274792C5C6E202020202020202069643B5C6E5C6E2020202069662028696450726F706572747929207B5C6E2020202020206964203D20656C656D656E742E67657428696450726F';
wwv_flow_imp.g_varchar2_table(7560) := '70657274792E6E616D65293B5C6E5C6E20202020202069662028696429207B5C6E5C6E20202020202020202F2F20666F7220514E616D652076616C69646174696F6E2061732070657220687474703A2F2F7777772E77332E6F72672F54522F5245432D78';
wwv_flow_imp.g_varchar2_table(7561) := '6D6C2F234E542D4E616D65436861725C6E202020202020202069662028212F5E285B612D7A5D5B5C5C772D2E5D2A3A293F5B612D7A5F5D5B5C5C772D2E5D2A242F692E746573742869642929207B5C6E202020202020202020207468726F77206E657720';
wwv_flow_imp.g_varchar2_table(7562) := '4572726F722827696C6C6567616C204944203C27202B206964202B20273E27293B5C6E20202020202020207D5C6E5C6E202020202020202069662028656C656D656E7473427949645B69645D29207B5C6E202020202020202020207468726F7720657272';
wwv_flow_imp.g_varchar2_table(7563) := '6F7228276475706C6963617465204944203C27202B206964202B20273E27293B5C6E20202020202020207D5C6E5C6E2020202020202020656C656D656E7473427949645B69645D203D20656C656D656E743B5C6E2020202020207D5C6E202020207D5C6E';
wwv_flow_imp.g_varchar2_table(7564) := '20207D3B5C6E5C6E20202F2A2A5C6E2020202A2041646420616E20696D706F7274207761726E696E672E5C6E2020202A5C6E2020202A2040706172616D207B4F626A6563747D207761726E696E675C6E2020202A2040706172616D207B537472696E677D';
wwv_flow_imp.g_varchar2_table(7565) := '207761726E696E672E6D6573736167655C6E2020202A2040706172616D207B4572726F727D205B7761726E696E672E6572726F725D5C6E2020202A2F5C6E2020746869732E6164645761726E696E67203D2066756E6374696F6E287761726E696E672920';
wwv_flow_imp.g_varchar2_table(7566) := '7B5C6E20202020746869732E7761726E696E67732E70757368287761726E696E67293B5C6E20207D3B5C6E7D5C6E5C6E66756E6374696F6E204261736548616E646C65722829207B7D5C6E5C6E4261736548616E646C65722E70726F746F747970652E68';
wwv_flow_imp.g_varchar2_table(7567) := '616E646C65456E64203D2066756E6374696F6E2829207B7D3B5C6E4261736548616E646C65722E70726F746F747970652E68616E646C6554657874203D2066756E6374696F6E2829207B7D3B5C6E4261736548616E646C65722E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(7568) := '68616E646C654E6F6465203D2066756E6374696F6E2829207B7D3B5C6E5C6E5C6E2F2A2A5C6E202A20412073696D706C652070617373207468726F7567682068616E646C6572207468617420646F6573206E6F7468696E672065786365707420666F725C';
wwv_flow_imp.g_varchar2_table(7569) := '6E202A2069676E6F72696E6720616C6C20696E7075742069742072656365697665732E5C6E202A5C6E202A2054686973206973207573656420746F2069676E6F726520756E6B6E6F776E20656C656D656E747320616E645C6E202A206174747269627574';
wwv_flow_imp.g_varchar2_table(7570) := '65732E5C6E202A2F5C6E66756E6374696F6E204E6F6F7048616E646C65722829207B207D5C6E5C6E4E6F6F7048616E646C65722E70726F746F74797065203D204F626A6563742E637265617465284261736548616E646C65722E70726F746F7479706529';
wwv_flow_imp.g_varchar2_table(7571) := '3B5C6E5C6E4E6F6F7048616E646C65722E70726F746F747970652E68616E646C654E6F6465203D2066756E6374696F6E2829207B5C6E202072657475726E20746869733B5C6E7D3B5C6E5C6E66756E6374696F6E20426F647948616E646C65722829207B';
wwv_flow_imp.g_varchar2_table(7572) := '7D5C6E5C6E426F647948616E646C65722E70726F746F74797065203D204F626A6563742E637265617465284261736548616E646C65722E70726F746F74797065293B5C6E5C6E426F647948616E646C65722E70726F746F747970652E68616E646C655465';
wwv_flow_imp.g_varchar2_table(7573) := '7874203D2066756E6374696F6E287465787429207B5C6E2020746869732E626F6479203D2028746869732E626F6479207C7C20272729202B20746578743B5C6E7D3B5C6E5C6E66756E6374696F6E205265666572656E636548616E646C65722870726F70';
wwv_flow_imp.g_varchar2_table(7574) := '657274792C20636F6E7465787429207B5C6E2020746869732E70726F7065727479203D2070726F70657274793B5C6E2020746869732E636F6E74657874203D20636F6E746578743B5C6E7D5C6E5C6E5265666572656E636548616E646C65722E70726F74';
wwv_flow_imp.g_varchar2_table(7575) := '6F74797065203D204F626A6563742E63726561746528426F647948616E646C65722E70726F746F74797065293B5C6E5C6E5265666572656E636548616E646C65722E70726F746F747970652E68616E646C654E6F6465203D2066756E6374696F6E286E6F';
wwv_flow_imp.g_varchar2_table(7576) := '646529207B5C6E5C6E202069662028746869732E656C656D656E7429207B5C6E202020207468726F77206572726F7228276578706563746564206E6F20737562206E6F64657327293B5C6E20207D20656C7365207B5C6E20202020746869732E656C656D';
wwv_flow_imp.g_varchar2_table(7577) := '656E74203D20746869732E6372656174655265666572656E6365286E6F6465293B5C6E20207D5C6E5C6E202072657475726E20746869733B5C6E7D3B5C6E5C6E5265666572656E636548616E646C65722E70726F746F747970652E68616E646C65456E64';
wwv_flow_imp.g_varchar2_table(7578) := '203D2066756E6374696F6E2829207B5C6E2020746869732E656C656D656E742E6964203D20746869732E626F64793B5C6E7D3B5C6E5C6E5265666572656E636548616E646C65722E70726F746F747970652E6372656174655265666572656E6365203D20';
wwv_flow_imp.g_varchar2_table(7579) := '66756E6374696F6E286E6F646529207B5C6E202072657475726E207B5C6E2020202070726F70657274793A20746869732E70726F70657274792E6E732E6E616D652C5C6E2020202069643A2027275C6E20207D3B5C6E7D3B5C6E5C6E66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(7580) := '2056616C756548616E646C65722870726F7065727479446573632C20656C656D656E7429207B5C6E2020746869732E656C656D656E74203D20656C656D656E743B5C6E2020746869732E70726F706572747944657363203D2070726F7065727479446573';
wwv_flow_imp.g_varchar2_table(7581) := '633B5C6E7D5C6E5C6E56616C756548616E646C65722E70726F746F74797065203D204F626A6563742E63726561746528426F647948616E646C65722E70726F746F74797065293B5C6E5C6E56616C756548616E646C65722E70726F746F747970652E6861';
wwv_flow_imp.g_varchar2_table(7582) := '6E646C65456E64203D2066756E6374696F6E2829207B5C6E5C6E20207661722076616C7565203D20746869732E626F6479207C7C2027272C5C6E202020202020656C656D656E74203D20746869732E656C656D656E742C5C6E20202020202070726F7065';
wwv_flow_imp.g_varchar2_table(7583) := '72747944657363203D20746869732E70726F7065727479446573633B5C6E5C6E202076616C7565203D20636F65726365547970652870726F7065727479446573632E747970652C2076616C7565293B5C6E5C6E20206966202870726F7065727479446573';
wwv_flow_imp.g_varchar2_table(7584) := '632E69734D616E7929207B5C6E20202020656C656D656E742E6765742870726F7065727479446573632E6E616D65292E707573682876616C7565293B5C6E20207D20656C7365207B5C6E20202020656C656D656E742E7365742870726F70657274794465';
wwv_flow_imp.g_varchar2_table(7585) := '73632E6E616D652C2076616C7565293B5C6E20207D5C6E7D3B5C6E5C6E5C6E66756E6374696F6E2042617365456C656D656E7448616E646C65722829207B7D5C6E5C6E42617365456C656D656E7448616E646C65722E70726F746F74797065203D204F62';
wwv_flow_imp.g_varchar2_table(7586) := '6A6563742E63726561746528426F647948616E646C65722E70726F746F74797065293B5C6E5C6E42617365456C656D656E7448616E646C65722E70726F746F747970652E68616E646C654E6F6465203D2066756E6374696F6E286E6F646529207B5C6E20';
wwv_flow_imp.g_varchar2_table(7587) := '2076617220706172736572203D20746869732C5C6E202020202020656C656D656E74203D20746869732E656C656D656E743B5C6E5C6E20206966202821656C656D656E7429207B5C6E20202020656C656D656E74203D20746869732E656C656D656E7420';
wwv_flow_imp.g_varchar2_table(7588) := '3D20746869732E637265617465456C656D656E74286E6F6465293B5C6E5C6E20202020746869732E636F6E746578742E616464456C656D656E7428656C656D656E74293B5C6E20207D20656C7365207B5C6E20202020706172736572203D20746869732E';
wwv_flow_imp.g_varchar2_table(7589) := '68616E646C654368696C64286E6F6465293B5C6E20207D5C6E5C6E202072657475726E207061727365723B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2040636C617373205265616465722E456C656D656E7448616E646C65725C6E202A5C6E202A2F5C6E6675';
wwv_flow_imp.g_varchar2_table(7590) := '6E6374696F6E20456C656D656E7448616E646C6572286D6F64656C2C20747970654E616D652C20636F6E7465787429207B5C6E2020746869732E6D6F64656C203D206D6F64656C3B5C6E2020746869732E74797065203D206D6F64656C2E676574547970';
wwv_flow_imp.g_varchar2_table(7591) := '6528747970654E616D65293B5C6E2020746869732E636F6E74657874203D20636F6E746578743B5C6E7D5C6E5C6E456C656D656E7448616E646C65722E70726F746F74797065203D204F626A6563742E6372656174652842617365456C656D656E744861';
wwv_flow_imp.g_varchar2_table(7592) := '6E646C65722E70726F746F74797065293B5C6E5C6E456C656D656E7448616E646C65722E70726F746F747970652E6164645265666572656E6365203D2066756E6374696F6E287265666572656E636529207B5C6E2020746869732E636F6E746578742E61';
wwv_flow_imp.g_varchar2_table(7593) := '64645265666572656E6365287265666572656E6365293B5C6E7D3B5C6E5C6E456C656D656E7448616E646C65722E70726F746F747970652E68616E646C6554657874203D2066756E6374696F6E287465787429207B5C6E5C6E202076617220656C656D65';
wwv_flow_imp.g_varchar2_table(7594) := '6E74203D20746869732E656C656D656E742C5C6E20202020202064657363726970746F72203D206765744D6F64646C6544657363726970746F7228656C656D656E74292C5C6E202020202020626F647950726F7065727479203D2064657363726970746F';
wwv_flow_imp.g_varchar2_table(7595) := '722E626F647950726F70657274793B5C6E5C6E20206966202821626F647950726F706572747929207B5C6E202020207468726F77206572726F722827756E657870656374656420626F64792074657874203C27202B2074657874202B20273E27293B5C6E';
wwv_flow_imp.g_varchar2_table(7596) := '20207D5C6E5C6E2020426F647948616E646C65722E70726F746F747970652E68616E646C65546578742E63616C6C28746869732C2074657874293B5C6E7D3B5C6E5C6E456C656D656E7448616E646C65722E70726F746F747970652E68616E646C65456E';
wwv_flow_imp.g_varchar2_table(7597) := '64203D2066756E6374696F6E2829207B5C6E5C6E20207661722076616C7565203D20746869732E626F64792C5C6E202020202020656C656D656E74203D20746869732E656C656D656E742C5C6E20202020202064657363726970746F72203D206765744D';
wwv_flow_imp.g_varchar2_table(7598) := '6F64646C6544657363726970746F7228656C656D656E74292C5C6E202020202020626F647950726F7065727479203D2064657363726970746F722E626F647950726F70657274793B5C6E5C6E202069662028626F647950726F7065727479202626207661';
wwv_flow_imp.g_varchar2_table(7599) := '6C756520213D3D20756E646566696E656429207B5C6E2020202076616C7565203D20636F657263655479706528626F647950726F70657274792E747970652C2076616C7565293B5C6E20202020656C656D656E742E73657428626F647950726F70657274';
wwv_flow_imp.g_varchar2_table(7600) := '792E6E616D652C2076616C7565293B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A2043726561746520616E20696E7374616E6365206F6620746865206D6F64656C2066726F6D2074686520676976656E206E6F64652E5C6E202A5C6E202A20407061';
wwv_flow_imp.g_varchar2_table(7601) := '72616D20207B456C656D656E747D206E6F64652074686520786D6C206E6F64655C6E202A2F5C6E456C656D656E7448616E646C65722E70726F746F747970652E637265617465456C656D656E74203D2066756E6374696F6E286E6F646529207B5C6E2020';
wwv_flow_imp.g_varchar2_table(7602) := '7661722061747472696275746573203D206E6F64652E617474726962757465732C5C6E20202020202054797065203D20746869732E747970652C5C6E20202020202064657363726970746F72203D206765744D6F64646C6544657363726970746F722854';
wwv_flow_imp.g_varchar2_table(7603) := '797065292C5C6E202020202020636F6E74657874203D20746869732E636F6E746578742C5C6E202020202020696E7374616E6365203D206E65772054797065287B7D292C5C6E2020202020206D6F64656C203D20746869732E6D6F64656C2C5C6E202020';
wwv_flow_imp.g_varchar2_table(7604) := '20202070726F704E616D654E733B5C6E5C6E2020666F724561636828617474726962757465732C2066756E6374696F6E2876616C75652C206E616D6529207B5C6E5C6E202020207661722070726F70203D2064657363726970746F722E70726F70657274';
wwv_flow_imp.g_varchar2_table(7605) := '69657342794E616D655B6E616D655D2C5C6E202020202020202076616C7565733B5C6E5C6E202020206966202870726F702026262070726F702E69735265666572656E636529207B5C6E5C6E202020202020696620282170726F702E69734D616E792920';
wwv_flow_imp.g_varchar2_table(7606) := '7B5C6E2020202020202020636F6E746578742E6164645265666572656E6365287B5C6E20202020202020202020656C656D656E743A20696E7374616E63652C5C6E2020202020202020202070726F70657274793A2070726F702E6E732E6E616D652C5C6E';
wwv_flow_imp.g_varchar2_table(7607) := '2020202020202020202069643A2076616C75655C6E20202020202020207D293B5C6E2020202020207D20656C7365207B5C6E5C6E20202020202020202F2F204944524546533A207061727365207265666572656E63657320617320776869746573706163';
wwv_flow_imp.g_varchar2_table(7608) := '652D736570617261746564206C6973745C6E202020202020202076616C756573203D2076616C75652E73706C697428272027293B5C6E5C6E2020202020202020666F72456163682876616C7565732C2066756E6374696F6E287629207B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7609) := '2020202020636F6E746578742E6164645265666572656E6365287B5C6E202020202020202020202020656C656D656E743A20696E7374616E63652C5C6E20202020202020202020202070726F70657274793A2070726F702E6E732E6E616D652C5C6E2020';
wwv_flow_imp.g_varchar2_table(7610) := '2020202020202020202069643A20765C6E202020202020202020207D293B5C6E20202020202020207D293B5C6E2020202020207D5C6E5C6E202020207D20656C7365207B5C6E2020202020206966202870726F7029207B5C6E202020202020202076616C';
wwv_flow_imp.g_varchar2_table(7611) := '7565203D20636F65726365547970652870726F702E747970652C2076616C7565293B5C6E2020202020207D20656C73655C6E202020202020696620286E616D6520213D3D2027786D6C6E732729207B5C6E202020202020202070726F704E616D654E7320';
wwv_flow_imp.g_varchar2_table(7612) := '3D2070617273654E616D654E53286E616D652C2064657363726970746F722E6E732E707265666978293B5C6E5C6E20202020202020202F2F20636865636B20776865746865722061747472696275746520697320646566696E656420696E20612077656C';
wwv_flow_imp.g_varchar2_table(7613) := '6C2D6B6E6F776E206E616D6573706163655C6E20202020202020202F2F206966207468617420697320746865206361736520776520656D69742061207761726E696E6720746F20696E64696361746520706F74656E7469616C206D69737573655C6E2020';
wwv_flow_imp.g_varchar2_table(7614) := '202020202020696620286D6F64656C2E6765745061636B6167652870726F704E616D654E732E7072656669782929207B5C6E5C6E20202020202020202020636F6E746578742E6164645761726E696E67287B5C6E2020202020202020202020206D657373';
wwv_flow_imp.g_varchar2_table(7615) := '6167653A2027756E6B6E6F776E20617474726962757465203C27202B206E616D65202B20273E272C5C6E202020202020202020202020656C656D656E743A20696E7374616E63652C5C6E20202020202020202020202070726F70657274793A206E616D65';
wwv_flow_imp.g_varchar2_table(7616) := '2C5C6E20202020202020202020202076616C75653A2076616C75655C6E202020202020202020207D293B5C6E20202020202020207D5C6E2020202020207D5C6E5C6E202020202020696E7374616E63652E736574286E616D652C2076616C7565293B5C6E';
wwv_flow_imp.g_varchar2_table(7617) := '202020207D5C6E20207D293B5C6E5C6E202072657475726E20696E7374616E63653B5C6E7D3B5C6E5C6E456C656D656E7448616E646C65722E70726F746F747970652E67657450726F7065727479466F724E6F6465203D2066756E6374696F6E286E6F64';
wwv_flow_imp.g_varchar2_table(7618) := '6529207B5C6E5C6E2020766172206E616D65203D206E6F64652E6E616D653B5C6E2020766172206E616D654E73203D2070617273654E616D654E53286E616D65293B5C6E5C6E20207661722074797065203D20746869732E747970652C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7619) := '206D6F64656C203D20746869732E6D6F64656C2C5C6E20202020202064657363726970746F72203D206765744D6F64646C6544657363726970746F722874797065293B5C6E5C6E20207661722070726F70657274794E616D65203D206E616D654E732E6E';
wwv_flow_imp.g_varchar2_table(7620) := '616D652C5C6E20202020202070726F7065727479203D2064657363726970746F722E70726F7065727469657342794E616D655B70726F70657274794E616D655D2C5C6E202020202020656C656D656E74547970654E616D652C5C6E202020202020656C65';
wwv_flow_imp.g_varchar2_table(7621) := '6D656E74547970653B5C6E5C6E20202F2F2073656172636820666F722070726F70657274696573206279206E616D652066697273745C6E5C6E20206966202870726F7065727479202626202170726F70657274792E69734174747229207B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(7622) := '20206966202873657269616C697A654173547970652870726F70657274792929207B5C6E202020202020656C656D656E74547970654E616D65203D206E6F64652E617474726962757465735B5853495F545950455D3B5C6E5C6E2020202020202F2F2078';
wwv_flow_imp.g_varchar2_table(7623) := '73692074797065206973206F7074696F6E616C2C20696620697420646F6573206E6F7420657869737473207468655C6E2020202020202F2F2064656661756C74207479706520697320617373756D65645C6E20202020202069662028656C656D656E7454';
wwv_flow_imp.g_varchar2_table(7624) := '7970654E616D6529207B5C6E5C6E20202020202020202F2F2074616B6520706F737369626C6520747970652070726566697865732066726F6D20584D4C5C6E20202020202020202F2F20696E746F206163636F756E742C20692E652E3A207873693A7479';
wwv_flow_imp.g_varchar2_table(7625) := '70653D5C22747B41637475616C547970657D5C225C6E2020202020202020656C656D656E74547970654E616D65203D206E6F726D616C697A65587369547970654E616D6528656C656D656E74547970654E616D652C206D6F64656C293B5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(7626) := '2020202020656C656D656E7454797065203D206D6F64656C2E6765745479706528656C656D656E74547970654E616D65293B5C6E5C6E202020202020202072657475726E2061737369676E287B7D2C2070726F70657274792C207B5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(7627) := '202020656666656374697665547970653A206765744D6F64646C6544657363726970746F7228656C656D656E7454797065292E6E616D655C6E20202020202020207D293B5C6E2020202020207D5C6E202020207D5C6E5C6E202020202F2F207365617263';
wwv_flow_imp.g_varchar2_table(7628) := '6820666F722070726F70657274696573206279206E616D652066697273745C6E2020202072657475726E2070726F70657274793B5C6E20207D5C6E5C6E202076617220706B67203D206D6F64656C2E6765745061636B616765286E616D654E732E707265';
wwv_flow_imp.g_varchar2_table(7629) := '666978293B5C6E5C6E202069662028706B6729207B5C6E20202020656C656D656E74547970654E616D65203D20616C696173546F4E616D65286E616D654E732C20706B67293B5C6E20202020656C656D656E7454797065203D206D6F64656C2E67657454';
wwv_flow_imp.g_varchar2_table(7630) := '79706528656C656D656E74547970654E616D65293B5C6E5C6E202020202F2F2073656172636820666F7220636F6C6C656374696F6E206D656D62657273206C617465725C6E2020202070726F7065727479203D2066696E642864657363726970746F722E';
wwv_flow_imp.g_varchar2_table(7631) := '70726F706572746965732C2066756E6374696F6E287029207B5C6E20202020202072657475726E2021702E69735669727475616C2026262021702E69735265666572656E63652026262021702E697341747472696275746520262620656C656D656E7454';
wwv_flow_imp.g_varchar2_table(7632) := '7970652E6861735479706528702E74797065293B5C6E202020207D293B5C6E5C6E202020206966202870726F706572747929207B5C6E20202020202072657475726E2061737369676E287B7D2C2070726F70657274792C207B5C6E202020202020202065';
wwv_flow_imp.g_varchar2_table(7633) := '6666656374697665547970653A206765744D6F64646C6544657363726970746F7228656C656D656E7454797065292E6E616D655C6E2020202020207D293B5C6E202020207D5C6E20207D20656C7365207B5C6E5C6E202020202F2F20706172736520756E';
wwv_flow_imp.g_varchar2_table(7634) := '6B6E6F776E20656C656D656E7420286D6179626520657874656E73696F6E295C6E2020202070726F7065727479203D2066696E642864657363726970746F722E70726F706572746965732C2066756E6374696F6E287029207B5C6E202020202020726574';
wwv_flow_imp.g_varchar2_table(7635) := '75726E2021702E69735265666572656E63652026262021702E697341747472696275746520262620702E74797065203D3D3D2027456C656D656E74273B5C6E202020207D293B5C6E5C6E202020206966202870726F706572747929207B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7636) := '2072657475726E2070726F70657274793B5C6E202020207D5C6E20207D5C6E5C6E20207468726F77206572726F722827756E7265636F676E697A656420656C656D656E74203C27202B206E616D654E732E6E616D65202B20273E27293B5C6E7D3B5C6E5C';
wwv_flow_imp.g_varchar2_table(7637) := '6E456C656D656E7448616E646C65722E70726F746F747970652E746F537472696E67203D2066756E6374696F6E2829207B5C6E202072657475726E2027456C656D656E7444657363726970746F725B27202B206765744D6F64646C654465736372697074';
wwv_flow_imp.g_varchar2_table(7638) := '6F7228746869732E74797065292E6E616D65202B20275D273B5C6E7D3B5C6E5C6E456C656D656E7448616E646C65722E70726F746F747970652E76616C756548616E646C6572203D2066756E6374696F6E2870726F7065727479446573632C20656C656D';
wwv_flow_imp.g_varchar2_table(7639) := '656E7429207B5C6E202072657475726E206E65772056616C756548616E646C65722870726F7065727479446573632C20656C656D656E74293B5C6E7D3B5C6E5C6E456C656D656E7448616E646C65722E70726F746F747970652E7265666572656E636548';
wwv_flow_imp.g_varchar2_table(7640) := '616E646C6572203D2066756E6374696F6E2870726F70657274794465736329207B5C6E202072657475726E206E6577205265666572656E636548616E646C65722870726F7065727479446573632C20746869732E636F6E74657874293B5C6E7D3B5C6E5C';
wwv_flow_imp.g_varchar2_table(7641) := '6E456C656D656E7448616E646C65722E70726F746F747970652E68616E646C6572203D2066756E6374696F6E287479706529207B5C6E20206966202874797065203D3D3D2027456C656D656E742729207B5C6E2020202072657475726E206E6577204765';
wwv_flow_imp.g_varchar2_table(7642) := '6E65726963456C656D656E7448616E646C657228746869732E6D6F64656C2C20747970652C20746869732E636F6E74657874293B5C6E20207D20656C7365207B5C6E2020202072657475726E206E657720456C656D656E7448616E646C65722874686973';
wwv_flow_imp.g_varchar2_table(7643) := '2E6D6F64656C2C20747970652C20746869732E636F6E74657874293B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A2048616E646C6520746865206368696C6420656C656D656E742070617273696E675C6E202A5C6E202A2040706172616D20207B45';
wwv_flow_imp.g_varchar2_table(7644) := '6C656D656E747D206E6F64652074686520786D6C206E6F64655C6E202A2F5C6E456C656D656E7448616E646C65722E70726F746F747970652E68616E646C654368696C64203D2066756E6374696F6E286E6F646529207B5C6E20207661722070726F7065';
wwv_flow_imp.g_varchar2_table(7645) := '727479446573632C20747970652C20656C656D656E742C206368696C6448616E646C65723B5C6E5C6E202070726F706572747944657363203D20746869732E67657450726F7065727479466F724E6F6465286E6F6465293B5C6E2020656C656D656E7420';
wwv_flow_imp.g_varchar2_table(7646) := '3D20746869732E656C656D656E743B5C6E5C6E202074797065203D2070726F7065727479446573632E65666665637469766554797065207C7C2070726F7065727479446573632E747970653B5C6E5C6E202069662028697353696D706C65547970652874';
wwv_flow_imp.g_varchar2_table(7647) := '7970652929207B5C6E2020202072657475726E20746869732E76616C756548616E646C65722870726F7065727479446573632C20656C656D656E74293B5C6E20207D5C6E5C6E20206966202870726F7065727479446573632E69735265666572656E6365';
wwv_flow_imp.g_varchar2_table(7648) := '29207B5C6E202020206368696C6448616E646C6572203D20746869732E7265666572656E636548616E646C65722870726F706572747944657363292E68616E646C654E6F6465286E6F6465293B5C6E20207D20656C7365207B5C6E202020206368696C64';
wwv_flow_imp.g_varchar2_table(7649) := '48616E646C6572203D20746869732E68616E646C65722874797065292E68616E646C654E6F6465286E6F6465293B5C6E20207D5C6E5C6E2020766172206E6577456C656D656E74203D206368696C6448616E646C65722E656C656D656E743B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(7650) := '202F2F206368696C642068616E646C6573206D61792064656369646520746F20736B697020656C656D656E74735C6E20202F2F206279206E6F742072657475726E696E6720616E797468696E675C6E2020696620286E6577456C656D656E7420213D3D20';
wwv_flow_imp.g_varchar2_table(7651) := '756E646566696E656429207B5C6E5C6E202020206966202870726F7065727479446573632E69734D616E7929207B5C6E202020202020656C656D656E742E6765742870726F7065727479446573632E6E616D65292E70757368286E6577456C656D656E74';
wwv_flow_imp.g_varchar2_table(7652) := '293B5C6E202020207D20656C7365207B5C6E202020202020656C656D656E742E7365742870726F7065727479446573632E6E616D652C206E6577456C656D656E74293B5C6E202020207D5C6E5C6E202020206966202870726F7065727479446573632E69';
wwv_flow_imp.g_varchar2_table(7653) := '735265666572656E636529207B5C6E20202020202061737369676E286E6577456C656D656E742C207B5C6E2020202020202020656C656D656E743A20656C656D656E745C6E2020202020207D293B5C6E5C6E202020202020746869732E636F6E74657874';
wwv_flow_imp.g_varchar2_table(7654) := '2E6164645265666572656E6365286E6577456C656D656E74293B5C6E202020207D20656C7365207B5C6E5C6E2020202020202F2F2065737461626C697368206368696C64202D3E20706172656E742072656C6174696F6E736869705C6E2020202020206E';
wwv_flow_imp.g_varchar2_table(7655) := '6577456C656D656E742E24706172656E74203D20656C656D656E743B5C6E202020207D5C6E20207D5C6E5C6E202072657475726E206368696C6448616E646C65723B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20416E20656C656D656E742068616E646C6572';
wwv_flow_imp.g_varchar2_table(7656) := '207468617420706572666F726D73207370656369616C2076616C69646174696F6E5C6E202A20746F20656E7375726520746865206E6F6465206974206765747320696E697469616C697A65642077697468206D6174636865735C6E202A20746865206861';
wwv_flow_imp.g_varchar2_table(7657) := '6E646C657273207479706520286E616D6573706163652077697365292E5C6E202A5C6E202A2040706172616D207B4D6F64646C657D206D6F64656C5C6E202A2040706172616D207B537472696E677D20747970654E616D655C6E202A2040706172616D20';
wwv_flow_imp.g_varchar2_table(7658) := '7B436F6E746578747D20636F6E746578745C6E202A2F5C6E66756E6374696F6E20526F6F74456C656D656E7448616E646C6572286D6F64656C2C20747970654E616D652C20636F6E7465787429207B5C6E2020456C656D656E7448616E646C65722E6361';
wwv_flow_imp.g_varchar2_table(7659) := '6C6C28746869732C206D6F64656C2C20747970654E616D652C20636F6E74657874293B5C6E7D5C6E5C6E526F6F74456C656D656E7448616E646C65722E70726F746F74797065203D204F626A6563742E63726561746528456C656D656E7448616E646C65';
wwv_flow_imp.g_varchar2_table(7660) := '722E70726F746F74797065293B5C6E5C6E526F6F74456C656D656E7448616E646C65722E70726F746F747970652E637265617465456C656D656E74203D2066756E6374696F6E286E6F646529207B5C6E5C6E2020766172206E616D65203D206E6F64652E';
wwv_flow_imp.g_varchar2_table(7661) := '6E616D652C5C6E2020202020206E616D654E73203D2070617273654E616D654E53286E616D65292C5C6E2020202020206D6F64656C203D20746869732E6D6F64656C2C5C6E20202020202074797065203D20746869732E747970652C5C6E202020202020';
wwv_flow_imp.g_varchar2_table(7662) := '706B67203D206D6F64656C2E6765745061636B616765286E616D654E732E707265666978292C5C6E202020202020747970654E616D65203D20706B6720262620616C696173546F4E616D65286E616D654E732C20706B6729207C7C206E616D653B5C6E5C';
wwv_flow_imp.g_varchar2_table(7663) := '6E20202F2F207665726966792074686520636F7272656374206E616D6573706163652069662077652070617273655C6E20202F2F2074686520666972737420656C656D656E7420696E207468652068616E646C657220747265655C6E20202F2F5C6E2020';
wwv_flow_imp.g_varchar2_table(7664) := '2F2F207468697320656E737572657320776520646F6E2774206D697374616B656E6C7920696D706F72742077726F6E67206E616D65737061636520656C656D656E74735C6E20206966202821747970652E6861735479706528747970654E616D65292920';
wwv_flow_imp.g_varchar2_table(7665) := '7B5C6E202020207468726F77206572726F722827756E657870656374656420656C656D656E74203C27202B206E6F64652E6F726967696E616C4E616D65202B20273E27293B5C6E20207D5C6E5C6E202072657475726E20456C656D656E7448616E646C65';
wwv_flow_imp.g_varchar2_table(7666) := '722E70726F746F747970652E637265617465456C656D656E742E63616C6C28746869732C206E6F6465293B5C6E7D3B5C6E5C6E5C6E66756E6374696F6E2047656E65726963456C656D656E7448616E646C6572286D6F64656C2C20747970654E616D652C';
wwv_flow_imp.g_varchar2_table(7667) := '20636F6E7465787429207B5C6E2020746869732E6D6F64656C203D206D6F64656C3B5C6E2020746869732E636F6E74657874203D20636F6E746578743B5C6E7D5C6E5C6E47656E65726963456C656D656E7448616E646C65722E70726F746F7479706520';
wwv_flow_imp.g_varchar2_table(7668) := '3D204F626A6563742E6372656174652842617365456C656D656E7448616E646C65722E70726F746F74797065293B5C6E5C6E47656E65726963456C656D656E7448616E646C65722E70726F746F747970652E637265617465456C656D656E74203D206675';
wwv_flow_imp.g_varchar2_table(7669) := '6E6374696F6E286E6F646529207B5C6E5C6E2020766172206E616D65203D206E6F64652E6E616D652C5C6E2020202020206E73203D2070617273654E616D654E53286E616D65292C5C6E202020202020707265666978203D206E732E7072656669782C5C';
wwv_flow_imp.g_varchar2_table(7670) := '6E202020202020757269203D206E6F64652E6E735B707265666978202B202724757269275D2C5C6E20202020202061747472696275746573203D206E6F64652E617474726962757465733B5C6E5C6E202072657475726E20746869732E6D6F64656C2E63';
wwv_flow_imp.g_varchar2_table(7671) := '7265617465416E79286E616D652C207572692C2061747472696275746573293B5C6E7D3B5C6E5C6E47656E65726963456C656D656E7448616E646C65722E70726F746F747970652E68616E646C654368696C64203D2066756E6374696F6E286E6F646529';
wwv_flow_imp.g_varchar2_table(7672) := '207B5C6E5C6E20207661722068616E646C6572203D206E65772047656E65726963456C656D656E7448616E646C657228746869732E6D6F64656C2C2027456C656D656E74272C20746869732E636F6E74657874292E68616E646C654E6F6465286E6F6465';
wwv_flow_imp.g_varchar2_table(7673) := '292C5C6E202020202020656C656D656E74203D20746869732E656C656D656E743B5C6E5C6E2020766172206E6577456C656D656E74203D2068616E646C65722E656C656D656E742C5C6E2020202020206368696C6472656E3B5C6E5C6E2020696620286E';
wwv_flow_imp.g_varchar2_table(7674) := '6577456C656D656E7420213D3D20756E646566696E656429207B5C6E202020206368696C6472656E203D20656C656D656E742E246368696C6472656E203D20656C656D656E742E246368696C6472656E207C7C205B5D3B5C6E202020206368696C647265';
wwv_flow_imp.g_varchar2_table(7675) := '6E2E70757368286E6577456C656D656E74293B5C6E5C6E202020202F2F2065737461626C697368206368696C64202D3E20706172656E742072656C6174696F6E736869705C6E202020206E6577456C656D656E742E24706172656E74203D20656C656D65';
wwv_flow_imp.g_varchar2_table(7676) := '6E743B5C6E20207D5C6E5C6E202072657475726E2068616E646C65723B5C6E7D3B5C6E5C6E47656E65726963456C656D656E7448616E646C65722E70726F746F747970652E68616E646C65456E64203D2066756E6374696F6E2829207B5C6E2020696620';
wwv_flow_imp.g_varchar2_table(7677) := '28746869732E626F647929207B5C6E20202020746869732E656C656D656E742E24626F6479203D20746869732E626F64793B5C6E20207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A20412072656164657220666F722061206D6574612D6D6F64656C5C6E202A';
wwv_flow_imp.g_varchar2_table(7678) := '5C6E202A2040706172616D207B4F626A6563747D206F7074696F6E735C6E202A2040706172616D207B4D6F64656C7D206F7074696F6E732E6D6F64656C207573656420746F207265616420786D6C2066696C65735C6E202A2040706172616D207B426F6F';
wwv_flow_imp.g_varchar2_table(7679) := '6C65616E7D206F7074696F6E732E6C6178207768657468657220746F206D616B65207061727365206572726F7273207761726E696E67735C6E202A2F5C6E66756E6374696F6E20526561646572286F7074696F6E7329207B5C6E5C6E2020696620286F70';
wwv_flow_imp.g_varchar2_table(7680) := '74696F6E7320696E7374616E63656F66204D6F64646C6529207B5C6E202020206F7074696F6E73203D207B5C6E2020202020206D6F64656C3A206F7074696F6E735C6E202020207D3B5C6E20207D5C6E5C6E202061737369676E28746869732C207B206C';
wwv_flow_imp.g_varchar2_table(7681) := '61783A2066616C7365207D2C206F7074696F6E73293B5C6E7D5C6E5C6E2F2A2A5C6E202A205468652066726F6D584D4C20726573756C742E5C6E202A5C6E202A204074797065646566207B4F626A6563747D205061727365526573756C745C6E202A5C6E';
wwv_flow_imp.g_varchar2_table(7682) := '202A204070726F7065727479207B4D6F64646C65456C656D656E747D20726F6F74456C656D656E745C6E202A204070726F7065727479207B41727261793C4F626A6563743E7D207265666572656E6365735C6E202A204070726F7065727479207B417272';
wwv_flow_imp.g_varchar2_table(7683) := '61793C4572726F723E7D207761726E696E67735C6E202A204070726F7065727479207B4F626A6563747D20656C656D656E747342794964202D2061206D617070696E6720636F6E7461696E696E672065616368204944202D3E204D6F64646C65456C656D';
wwv_flow_imp.g_varchar2_table(7684) := '656E745C6E202A2F5C6E5C6E2F2A2A5C6E202A205468652066726F6D584D4C20726573756C742E5C6E202A5C6E202A204074797065646566207B4572726F727D2050617273654572726F725C6E202A5C6E202A204070726F7065727479207B4172726179';
wwv_flow_imp.g_varchar2_table(7685) := '3C4572726F723E7D207761726E696E67735C6E202A2F5C6E5C6E2F2A2A5C6E202A2050617273652074686520676976656E20584D4C20696E746F2061206D6F64646C6520646F63756D656E7420747265652E5C6E202A5C6E202A2040706172616D207B53';
wwv_flow_imp.g_varchar2_table(7686) := '7472696E677D20786D6C5C6E202A2040706172616D207B456C656D656E7448616E646C65727C4F626A6563747D206F7074696F6E73206F7220726F6F7448616E646C65725C6E202A5C6E202A204072657475726E73207B50726F6D6973653C5061727365';
wwv_flow_imp.g_varchar2_table(7687) := '526573756C742C2050617273654572726F723E7D5C6E202A2F5C6E5265616465722E70726F746F747970652E66726F6D584D4C203D2066756E6374696F6E28786D6C2C206F7074696F6E732C20646F6E6529207B5C6E5C6E202076617220726F6F744861';
wwv_flow_imp.g_varchar2_table(7688) := '6E646C6572203D206F7074696F6E732E726F6F7448616E646C65723B5C6E5C6E2020696620286F7074696F6E7320696E7374616E63656F6620456C656D656E7448616E646C657229207B5C6E5C6E202020202F2F20726F6F742068616E646C6572207061';
wwv_flow_imp.g_varchar2_table(7689) := '73736564207669612028786D6C2C207B20726F6F7448616E646C65723A20456C656D656E7448616E646C6572207D2C202E2E2E295C6E20202020726F6F7448616E646C6572203D206F7074696F6E733B5C6E202020206F7074696F6E73203D207B7D3B5C';
wwv_flow_imp.g_varchar2_table(7690) := '6E20207D20656C7365207B5C6E2020202069662028747970656F66206F7074696F6E73203D3D3D2027737472696E672729207B5C6E5C6E2020202020202F2F20726F6F7448616E646C657220706173736564207669612028786D6C2C2027736F6D655374';
wwv_flow_imp.g_varchar2_table(7691) := '72696E67272C202E2E2E295C6E202020202020726F6F7448616E646C6572203D20746869732E68616E646C6572286F7074696F6E73293B5C6E2020202020206F7074696F6E73203D207B7D3B5C6E202020207D20656C73652069662028747970656F6620';
wwv_flow_imp.g_varchar2_table(7692) := '726F6F7448616E646C6572203D3D3D2027737472696E672729207B5C6E5C6E2020202020202F2F20726F6F7448616E646C657220706173736564207669612028786D6C2C207B20726F6F7448616E646C65723A2027736F6D65537472696E6727207D2C20';
wwv_flow_imp.g_varchar2_table(7693) := '2E2E2E295C6E202020202020726F6F7448616E646C6572203D20746869732E68616E646C657228726F6F7448616E646C6572293B5C6E202020207D5C6E20207D5C6E5C6E2020766172206D6F64656C203D20746869732E6D6F64656C2C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7694) := '206C6178203D20746869732E6C61783B5C6E5C6E202076617220636F6E74657874203D206E657720436F6E746578742861737369676E287B7D2C206F7074696F6E732C207B20726F6F7448616E646C65723A20726F6F7448616E646C6572207D29292C5C';
wwv_flow_imp.g_varchar2_table(7695) := '6E202020202020706172736572203D206E657720506172736572287B2070726F78793A2074727565207D292C5C6E202020202020737461636B203D20637265617465537461636B28293B5C6E5C6E2020726F6F7448616E646C65722E636F6E7465787420';
wwv_flow_imp.g_varchar2_table(7696) := '3D20636F6E746578743B5C6E5C6E20202F2F207075736820726F6F742068616E646C65725C6E2020737461636B2E7075736828726F6F7448616E646C6572293B5C6E5C6E5C6E20202F2A2A5C6E2020202A2048616E646C65206572726F722E5C6E202020';
wwv_flow_imp.g_varchar2_table(7697) := '2A5C6E2020202A2040706172616D20207B4572726F727D206572725C6E2020202A2040706172616D20207B46756E6374696F6E7D20676574436F6E746578745C6E2020202A2040706172616D20207B626F6F6C65616E7D206C61785C6E2020202A5C6E20';
wwv_flow_imp.g_varchar2_table(7698) := '20202A204072657475726E207B626F6F6C65616E7D20747275652069662068616E646C65645C6E2020202A2F5C6E202066756E6374696F6E2068616E646C654572726F72286572722C20676574436F6E746578742C206C617829207B5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(7699) := '76617220637478203D20676574436F6E7465787428293B5C6E5C6E20202020766172206C696E65203D206374782E6C696E652C5C6E2020202020202020636F6C756D6E203D206374782E636F6C756D6E2C5C6E202020202020202064617461203D206374';
wwv_flow_imp.g_varchar2_table(7700) := '782E646174613B5C6E5C6E202020202F2F2077652072656365697665207468652066756C6C20636F6E74657874206461746120686572652C5C6E202020202F2F20666F7220656C656D656E7473207472696D20646F776E2074686520696E666F726D6174';
wwv_flow_imp.g_varchar2_table(7701) := '696F6E5C6E202020202F2F20746F2074686520746167206E616D652C206F6E6C795C6E2020202069662028646174612E636861724174283029203D3D3D20273C2720262620646174612E696E6465784F66282720272920213D3D202D3129207B5C6E2020';
wwv_flow_imp.g_varchar2_table(7702) := '2020202064617461203D20646174612E736C69636528302C20646174612E696E6465784F66282720272929202B20273E273B5C6E202020207D5C6E5C6E20202020766172206D657373616765203D5C6E20202020202027756E7061727361626C6520636F';
wwv_flow_imp.g_varchar2_table(7703) := '6E74656E742027202B202864617461203F2064617461202B20272027203A20272729202B202764657465637465645C5C6E5C5C7427202B5C6E2020202020202020276C696E653A2027202B206C696E65202B20275C5C6E5C5C7427202B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7704) := '20202027636F6C756D6E3A2027202B20636F6C756D6E202B20275C5C6E5C5C7427202B5C6E2020202020202020276E6573746564206572726F723A2027202B206572722E6D6573736167653B5C6E5C6E20202020696620286C617829207B5C6E20202020';
wwv_flow_imp.g_varchar2_table(7705) := '2020636F6E746578742E6164645761726E696E67287B5C6E20202020202020206D6573736167653A206D6573736167652C5C6E20202020202020206572726F723A206572725C6E2020202020207D293B5C6E5C6E20202020202072657475726E20747275';
wwv_flow_imp.g_varchar2_table(7706) := '653B5C6E202020207D20656C7365207B5C6E2020202020207468726F77206572726F72286D657373616765293B5C6E202020207D5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C655761726E696E67286572722C20676574436F6E746578';
wwv_flow_imp.g_varchar2_table(7707) := '7429207B5C6E5C6E202020202F2F206A757374206C696B652068616E646C696E67206572726F727320696E203C6C61783D747275653E206D6F64655C6E2020202072657475726E2068616E646C654572726F72286572722C20676574436F6E746578742C';
wwv_flow_imp.g_varchar2_table(7708) := '2074727565293B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A205265736F6C766520636F6C6C6563746564207265666572656E636573206F6E20706172736520656E642E5C6E2020202A2F5C6E202066756E6374696F6E207265736F6C7665526566';
wwv_flow_imp.g_varchar2_table(7709) := '6572656E6365732829207B5C6E5C6E2020202076617220656C656D656E747342794964203D20636F6E746578742E656C656D656E7473427949643B5C6E20202020766172207265666572656E636573203D20636F6E746578742E7265666572656E636573';
wwv_flow_imp.g_varchar2_table(7710) := '3B5C6E5C6E2020202076617220692C20723B5C6E5C6E20202020666F72202869203D20303B202872203D207265666572656E6365735B695D293B20692B2B29207B5C6E20202020202076617220656C656D656E74203D20722E656C656D656E743B5C6E20';
wwv_flow_imp.g_varchar2_table(7711) := '2020202020766172207265666572656E6365203D20656C656D656E7473427949645B722E69645D3B5C6E2020202020207661722070726F7065727479203D206765744D6F64646C6544657363726970746F7228656C656D656E74292E70726F7065727469';
wwv_flow_imp.g_varchar2_table(7712) := '657342794E616D655B722E70726F70657274795D3B5C6E5C6E20202020202069662028217265666572656E636529207B5C6E2020202020202020636F6E746578742E6164645761726E696E67287B5C6E202020202020202020206D6573736167653A2027';
wwv_flow_imp.g_varchar2_table(7713) := '756E7265736F6C766564207265666572656E6365203C27202B20722E6964202B20273E272C5C6E20202020202020202020656C656D656E743A20722E656C656D656E742C5C6E2020202020202020202070726F70657274793A20722E70726F7065727479';
wwv_flow_imp.g_varchar2_table(7714) := '2C5C6E2020202020202020202076616C75653A20722E69645C6E20202020202020207D293B5C6E2020202020207D5C6E5C6E2020202020206966202870726F70657274792E69734D616E7929207B5C6E202020202020202076617220636F6C6C65637469';
wwv_flow_imp.g_varchar2_table(7715) := '6F6E203D20656C656D656E742E6765742870726F70657274792E6E616D65292C5C6E202020202020202020202020696478203D20636F6C6C656374696F6E2E696E6465784F662872293B5C6E5C6E20202020202020202F2F207765207265706C61636520';
wwv_flow_imp.g_varchar2_table(7716) := '616E206578697374696E6720706C61636520686F6C646572202869647820213D202D3129206F725C6E20202020202020202F2F20617070656E6420746F2074686520636F6C6C656374696F6E20696E73746561645C6E2020202020202020696620286964';
wwv_flow_imp.g_varchar2_table(7717) := '78203D3D3D202D3129207B5C6E20202020202020202020696478203D20636F6C6C656374696F6E2E6C656E6774683B5C6E20202020202020207D5C6E5C6E202020202020202069662028217265666572656E636529207B5C6E5C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(7718) := '202F2F2072656D6F766520756E7265736F6C7661626C65207265666572656E63655C6E20202020202020202020636F6C6C656374696F6E2E73706C696365286964782C2031293B5C6E20202020202020207D20656C7365207B5C6E5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(7719) := '2020202F2F20616464206F7220757064617465207265666572656E636520696E20636F6C6C656374696F6E5C6E20202020202020202020636F6C6C656374696F6E5B6964785D203D207265666572656E63653B5C6E20202020202020207D5C6E20202020';
wwv_flow_imp.g_varchar2_table(7720) := '20207D20656C7365207B5C6E2020202020202020656C656D656E742E7365742870726F70657274792E6E616D652C207265666572656E6365293B5C6E2020202020207D5C6E202020207D5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C65';
wwv_flow_imp.g_varchar2_table(7721) := '436C6F73652829207B5C6E20202020737461636B2E706F7028292E68616E646C65456E6428293B5C6E20207D5C6E5C6E202076617220505245414D424C455F53544152545F5041545445524E203D202F5E3C5C5C3F786D6C202F693B5C6E5C6E20207661';
wwv_flow_imp.g_varchar2_table(7722) := '7220454E434F44494E475F5041545445524E203D202F20656E636F64696E673D5C22285B5E5C225D2B295C222F693B5C6E5C6E2020766172205554465F385F5041545445524E203D202F5E7574662D38242F693B5C6E5C6E202066756E6374696F6E2068';
wwv_flow_imp.g_varchar2_table(7723) := '616E646C655175657374696F6E287175657374696F6E29207B5C6E5C6E202020206966202821505245414D424C455F53544152545F5041545445524E2E74657374287175657374696F6E2929207B5C6E20202020202072657475726E3B5C6E202020207D';
wwv_flow_imp.g_varchar2_table(7724) := '5C6E5C6E20202020766172206D61746368203D20454E434F44494E475F5041545445524E2E65786563287175657374696F6E293B5C6E2020202076617220656E636F64696E67203D206D61746368202626206D617463685B315D3B5C6E5C6E2020202069';
wwv_flow_imp.g_varchar2_table(7725) := '66202821656E636F64696E67207C7C205554465F385F5041545445524E2E7465737428656E636F64696E672929207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E20202020636F6E746578742E6164645761726E696E67287B5C6E20';
wwv_flow_imp.g_varchar2_table(7726) := '20202020206D6573736167653A5C6E202020202020202027756E737570706F7274656420646F63756D656E7420656E636F64696E67203C27202B20656E636F64696E67202B20273E2C2027202B5C6E20202020202020202766616C6C696E67206261636B';
wwv_flow_imp.g_varchar2_table(7727) := '20746F205554462D38275C6E202020207D293B5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C654F70656E286E6F64652C20676574436F6E7465787429207B5C6E202020207661722068616E646C6572203D20737461636B2E7065656B28';
wwv_flow_imp.g_varchar2_table(7728) := '293B5C6E5C6E20202020747279207B5C6E202020202020737461636B2E707573682868616E646C65722E68616E646C654E6F6465286E6F646529293B5C6E202020207D206361746368202865727229207B5C6E5C6E2020202020206966202868616E646C';
wwv_flow_imp.g_varchar2_table(7729) := '654572726F72286572722C20676574436F6E746578742C206C61782929207B5C6E2020202020202020737461636B2E70757368286E6577204E6F6F7048616E646C65722829293B5C6E2020202020207D5C6E202020207D5C6E20207D5C6E5C6E20206675';
wwv_flow_imp.g_varchar2_table(7730) := '6E6374696F6E2068616E646C65434461746128746578742C20676574436F6E7465787429207B5C6E5C6E20202020747279207B5C6E202020202020737461636B2E7065656B28292E68616E646C65546578742874657874293B5C6E202020207D20636174';
wwv_flow_imp.g_varchar2_table(7731) := '6368202865727229207B5C6E20202020202068616E646C655761726E696E67286572722C20676574436F6E74657874293B5C6E202020207D5C6E20207D5C6E5C6E202066756E6374696F6E2068616E646C655465787428746578742C20676574436F6E74';
wwv_flow_imp.g_varchar2_table(7732) := '65787429207B5C6E5C6E202020202F2F2073747269702077686974657370616365206F6E6C79206E6F6465732C20692E652E206265666F72655C6E202020202F2F203C2143444154415B202E2E2E205D3E2073656374696F6E7320616E6420696E206265';
wwv_flow_imp.g_varchar2_table(7733) := '747765656E20746167735C6E5C6E202020206966202821746578742E7472696D282929207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E2020202068616E646C65434461746128746578742C20676574436F6E74657874293B5C6E20';
wwv_flow_imp.g_varchar2_table(7734) := '207D5C6E5C6E2020766172207572694D6170203D206D6F64656C2E6765745061636B6167657328292E7265647563652866756E6374696F6E287572694D61702C207029207B5C6E202020207572694D61705B702E7572695D203D20702E7072656669783B';
wwv_flow_imp.g_varchar2_table(7735) := '5C6E5C6E2020202072657475726E207572694D61703B5C6E20207D2C207B5C6E2020202027687474703A2F2F7777772E77332E6F72672F584D4C2F313939382F6E616D657370616365273A2027786D6C27202F2F206164642064656661756C7420786D6C';
wwv_flow_imp.g_varchar2_table(7736) := '206E735C6E20207D293B5C6E20207061727365725C6E202020202E6E73287572694D6170295C6E202020202E6F6E28276F70656E546167272C2066756E6374696F6E286F626A2C206465636F64655374722C2073656C66436C6F73696E672C2067657443';
wwv_flow_imp.g_varchar2_table(7737) := '6F6E7465787429207B5C6E5C6E2020202020202F2F20677261636566756C6C792068616E646C6520756E7061727361626C652061747472696275746573202861747472733D66616C7365295C6E202020202020766172206174747273203D206F626A2E61';
wwv_flow_imp.g_varchar2_table(7738) := '74747273207C7C207B7D3B5C6E5C6E202020202020766172206465636F6465644174747273203D204F626A6563742E6B657973286174747273292E7265647563652866756E6374696F6E28642C206B657929207B5C6E2020202020202020766172207661';
wwv_flow_imp.g_varchar2_table(7739) := '6C7565203D206465636F64655374722861747472735B6B65795D293B5C6E5C6E2020202020202020645B6B65795D203D2076616C75653B5C6E5C6E202020202020202072657475726E20643B5C6E2020202020207D2C207B7D293B5C6E5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7740) := '20766172206E6F6465203D207B5C6E20202020202020206E616D653A206F626A2E6E616D652C5C6E20202020202020206F726967696E616C4E616D653A206F626A2E6F726967696E616C4E616D652C5C6E2020202020202020617474726962757465733A';
wwv_flow_imp.g_varchar2_table(7741) := '206465636F64656441747472732C5C6E20202020202020206E733A206F626A2E6E735C6E2020202020207D3B5C6E5C6E20202020202068616E646C654F70656E286E6F64652C20676574436F6E74657874293B5C6E202020207D295C6E202020202E6F6E';
wwv_flow_imp.g_varchar2_table(7742) := '28277175657374696F6E272C2068616E646C655175657374696F6E295C6E202020202E6F6E2827636C6F7365546167272C2068616E646C65436C6F7365295C6E202020202E6F6E28276364617461272C2068616E646C654344617461295C6E202020202E';
wwv_flow_imp.g_varchar2_table(7743) := '6F6E282774657874272C2066756E6374696F6E28746578742C206465636F6465456E7469746965732C20676574436F6E7465787429207B5C6E20202020202068616E646C6554657874286465636F6465456E7469746965732874657874292C2067657443';
wwv_flow_imp.g_varchar2_table(7744) := '6F6E74657874293B5C6E202020207D295C6E202020202E6F6E28276572726F72272C2068616E646C654572726F72295C6E202020202E6F6E28277761726E272C2068616E646C655761726E696E67293B5C6E5C6E20202F2F206173796E6320584D4C2070';
wwv_flow_imp.g_varchar2_table(7745) := '617273696E6720746F206D616B6520737572652074686520657865637574696F6E20656E7669726F6E6D656E745C6E20202F2F20286E6F6465206F722062726F77657229206973206B65707420726573706F6E7369766520616E64207468617420636572';
wwv_flow_imp.g_varchar2_table(7746) := '7461696E206F7074696D697A6174696F6E5C6E20202F2F20737472617465676965732063616E206B69636B20696E2E5C6E202072657475726E206E65772050726F6D6973652866756E6374696F6E287265736F6C76652C2072656A65637429207B5C6E5C';
wwv_flow_imp.g_varchar2_table(7747) := '6E20202020766172206572723B5C6E5C6E20202020747279207B5C6E2020202020207061727365722E706172736528786D6C293B5C6E5C6E2020202020207265736F6C76655265666572656E63657328293B5C6E202020207D2063617463682028652920';
wwv_flow_imp.g_varchar2_table(7748) := '7B5C6E202020202020657272203D20653B5C6E202020207D5C6E5C6E2020202076617220726F6F74456C656D656E74203D20726F6F7448616E646C65722E656C656D656E743B5C6E5C6E2020202069662028216572722026262021726F6F74456C656D65';
wwv_flow_imp.g_varchar2_table(7749) := '6E7429207B5C6E202020202020657272203D206572726F7228276661696C656420746F20706172736520646F63756D656E74206173203C27202B20726F6F7448616E646C65722E747970652E2464657363726970746F722E6E616D65202B20273E27293B';
wwv_flow_imp.g_varchar2_table(7750) := '5C6E202020207D5C6E5C6E20202020766172207761726E696E6773203D20636F6E746578742E7761726E696E67733B5C6E20202020766172207265666572656E636573203D20636F6E746578742E7265666572656E6365733B5C6E202020207661722065';
wwv_flow_imp.g_varchar2_table(7751) := '6C656D656E747342794964203D20636F6E746578742E656C656D656E7473427949643B5C6E5C6E202020206966202865727229207B5C6E2020202020206572722E7761726E696E6773203D207761726E696E67733B5C6E5C6E2020202020207265747572';
wwv_flow_imp.g_varchar2_table(7752) := '6E2072656A65637428657272293B5C6E202020207D20656C7365207B5C6E20202020202072657475726E207265736F6C7665287B5C6E2020202020202020726F6F74456C656D656E743A20726F6F74456C656D656E742C5C6E2020202020202020656C65';
wwv_flow_imp.g_varchar2_table(7753) := '6D656E7473427949643A20656C656D656E7473427949642C5C6E20202020202020207265666572656E6365733A207265666572656E6365732C5C6E20202020202020207761726E696E67733A207761726E696E67735C6E2020202020207D293B5C6E2020';
wwv_flow_imp.g_varchar2_table(7754) := '20207D5C6E20207D293B5C6E7D3B5C6E5C6E5265616465722E70726F746F747970652E68616E646C6572203D2066756E6374696F6E286E616D6529207B5C6E202072657475726E206E657720526F6F74456C656D656E7448616E646C657228746869732E';
wwv_flow_imp.g_varchar2_table(7755) := '6D6F64656C2C206E616D65293B5C6E7D3B5C6E5C6E5C6E2F2F2068656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E20637265617465537461636B2829207B5C6E20207661722073746163';
wwv_flow_imp.g_varchar2_table(7756) := '6B203D205B5D3B5C6E5C6E20204F626A6563742E646566696E6550726F706572747928737461636B2C20277065656B272C207B5C6E2020202076616C75653A2066756E6374696F6E2829207B5C6E20202020202072657475726E20746869735B74686973';
wwv_flow_imp.g_varchar2_table(7757) := '2E6C656E677468202D20315D3B5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E20737461636B3B5C6E7D5C6E5C6E76617220584D4C5F505245414D424C45203D20273C3F786D6C2076657273696F6E3D5C22312E305C2220656E636F64';
wwv_flow_imp.g_varchar2_table(7758) := '696E673D5C225554462D385C223F3E5C5C6E273B5C6E5C6E766172204553434150455F415454525F4348415253203D202F3C7C3E7C277C5C227C267C5C5C6E5C5C727C5C5C6E2F673B5C6E766172204553434150455F4348415253203D202F3C7C3E7C26';
wwv_flow_imp.g_varchar2_table(7759) := '2F673B5C6E5C6E5C6E66756E6374696F6E204E616D6573706163657328706172656E7429207B5C6E5C6E2020766172207072656669784D6170203D207B7D3B5C6E2020766172207572694D6170203D207B7D3B5C6E20207661722075736564203D207B7D';
wwv_flow_imp.g_varchar2_table(7760) := '3B5C6E5C6E20207661722077656C6C6B6E6F776E203D205B5D3B5C6E202076617220637573746F6D203D205B5D3B5C6E5C6E20202F2F204150495C6E5C6E2020746869732E6279557269203D2066756E6374696F6E2875726929207B5C6E202020207265';
wwv_flow_imp.g_varchar2_table(7761) := '7475726E207572694D61705B7572695D207C7C20285C6E202020202020706172656E7420262620706172656E742E627955726928757269295C6E20202020293B5C6E20207D3B5C6E5C6E2020746869732E616464203D2066756E6374696F6E286E732C20';
wwv_flow_imp.g_varchar2_table(7762) := '697357656C6C6B6E6F776E29207B5C6E5C6E202020207572694D61705B6E732E7572695D203D206E733B5C6E5C6E2020202069662028697357656C6C6B6E6F776E29207B5C6E20202020202077656C6C6B6E6F776E2E70757368286E73293B5C6E202020';
wwv_flow_imp.g_varchar2_table(7763) := '207D20656C7365207B5C6E202020202020637573746F6D2E70757368286E73293B5C6E202020207D5C6E5C6E20202020746869732E6D6170507265666978286E732E7072656669782C206E732E757269293B5C6E20207D3B5C6E5C6E2020746869732E75';
wwv_flow_imp.g_varchar2_table(7764) := '72694279507265666978203D2066756E6374696F6E2870726566697829207B5C6E2020202072657475726E207072656669784D61705B707265666978207C7C2027786D6C6E73275D3B5C6E20207D3B5C6E5C6E2020746869732E6D617050726566697820';
wwv_flow_imp.g_varchar2_table(7765) := '3D2066756E6374696F6E287072656669782C2075726929207B5C6E202020207072656669784D61705B707265666978207C7C2027786D6C6E73275D203D207572693B5C6E20207D3B5C6E5C6E2020746869732E6765744E534B6579203D2066756E637469';
wwv_flow_imp.g_varchar2_table(7766) := '6F6E286E7329207B5C6E2020202072657475726E20286E732E70726566697820213D3D20756E646566696E656429203F20286E732E757269202B20277C27202B206E732E70726566697829203A206E732E7572693B5C6E20207D3B5C6E5C6E2020746869';
wwv_flow_imp.g_varchar2_table(7767) := '732E6C6F6755736564203D2066756E6374696F6E286E7329207B5C6E5C6E2020202076617220757269203D206E732E7572693B5C6E20202020766172206E734B6579203D20746869732E6765744E534B6579286E73293B5C6E5C6E20202020757365645B';
wwv_flow_imp.g_varchar2_table(7768) := '6E734B65795D203D20746869732E627955726928757269293B5C6E5C6E202020202F2F20496E666F726D20706172656E74207265637572736976656C792061626F757420746865207573616765206F662074686973204E535C6E20202020696620287061';
wwv_flow_imp.g_varchar2_table(7769) := '72656E7429207B5C6E202020202020706172656E742E6C6F6755736564286E73293B5C6E202020207D5C6E20207D3B5C6E5C6E2020746869732E67657455736564203D2066756E6374696F6E286E7329207B5C6E5C6E2020202066756E6374696F6E2069';
wwv_flow_imp.g_varchar2_table(7770) := '7355736564286E7329207B5C6E202020202020766172206E734B6579203D2073656C662E6765744E534B6579286E73293B5C6E5C6E20202020202072657475726E20757365645B6E734B65795D3B5C6E202020207D5C6E5C6E202020207661722073656C';
wwv_flow_imp.g_varchar2_table(7771) := '66203D20746869733B5C6E5C6E2020202076617220616C6C4E73203D205B5D2E636F6E6361742877656C6C6B6E6F776E2C20637573746F6D293B5C6E5C6E2020202072657475726E20616C6C4E732E66696C74657228697355736564293B5C6E20207D3B';
wwv_flow_imp.g_varchar2_table(7772) := '5C6E5C6E7D5C6E5C6E66756E6374696F6E206C6F77657228737472696E6729207B5C6E202072657475726E20737472696E672E6368617241742830292E746F4C6F776572436173652829202B20737472696E672E736C6963652831293B5C6E7D5C6E5C6E';
wwv_flow_imp.g_varchar2_table(7773) := '66756E6374696F6E206E616D65546F416C696173286E616D652C20706B6729207B5C6E2020696620286861734C6F77657243617365416C69617328706B672929207B5C6E2020202072657475726E206C6F776572286E616D65293B5C6E20207D20656C73';
wwv_flow_imp.g_varchar2_table(7774) := '65207B5C6E2020202072657475726E206E616D653B5C6E20207D5C6E7D5C6E5C6E66756E6374696F6E20696E6865726974732863746F722C20737570657243746F7229207B5C6E202063746F722E73757065725F203D20737570657243746F723B5C6E20';
wwv_flow_imp.g_varchar2_table(7775) := '2063746F722E70726F746F74797065203D204F626A6563742E63726561746528737570657243746F722E70726F746F747970652C207B5C6E20202020636F6E7374727563746F723A207B5C6E20202020202076616C75653A2063746F722C5C6E20202020';
wwv_flow_imp.g_varchar2_table(7776) := '2020656E756D657261626C653A2066616C73652C5C6E2020202020207772697461626C653A20747275652C5C6E202020202020636F6E666967757261626C653A20747275655C6E202020207D5C6E20207D293B5C6E7D5C6E5C6E66756E6374696F6E206E';
wwv_flow_imp.g_varchar2_table(7777) := '734E616D65286E7329207B5C6E2020696620286973537472696E67286E732929207B5C6E2020202072657475726E206E733B5C6E20207D20656C7365207B5C6E2020202072657475726E20286E732E707265666978203F206E732E707265666978202B20';
wwv_flow_imp.g_varchar2_table(7778) := '273A27203A20272729202B206E732E6C6F63616C4E616D653B5C6E20207D5C6E7D5C6E5C6E66756E6374696F6E206765744E734174747273286E616D6573706163657329207B5C6E5C6E202072657475726E206E616D657370616365732E676574557365';
wwv_flow_imp.g_varchar2_table(7779) := '6428292E66696C7465722866756E6374696F6E286E7329207B5C6E5C6E202020202F2F20646F206E6F742073657269616C697A65206275696C7420696E203C786D6C3E206E616D6573706163655C6E2020202072657475726E206E732E70726566697820';
wwv_flow_imp.g_varchar2_table(7780) := '213D3D2027786D6C273B5C6E20207D292E6D61702866756E6374696F6E286E7329207B5C6E20202020766172206E616D65203D2027786D6C6E7327202B20286E732E707265666978203F20273A27202B206E732E707265666978203A202727293B5C6E20';
wwv_flow_imp.g_varchar2_table(7781) := '20202072657475726E207B206E616D653A206E616D652C2076616C75653A206E732E757269207D3B5C6E20207D293B5C6E5C6E7D5C6E5C6E66756E6374696F6E20676574456C656D656E744E73286E732C2064657363726970746F7229207B5C6E202069';
wwv_flow_imp.g_varchar2_table(7782) := '66202864657363726970746F722E697347656E6572696329207B5C6E2020202072657475726E2061737369676E287B206C6F63616C4E616D653A2064657363726970746F722E6E732E6C6F63616C4E616D65207D2C206E73293B5C6E20207D20656C7365';
wwv_flow_imp.g_varchar2_table(7783) := '207B5C6E2020202072657475726E2061737369676E287B206C6F63616C4E616D653A206E616D65546F416C6961732864657363726970746F722E6E732E6C6F63616C4E616D652C2064657363726970746F722E24706B6729207D2C206E73293B5C6E2020';
wwv_flow_imp.g_varchar2_table(7784) := '7D5C6E7D5C6E5C6E66756E6374696F6E2067657450726F70657274794E73286E732C2064657363726970746F7229207B5C6E202072657475726E2061737369676E287B206C6F63616C4E616D653A2064657363726970746F722E6E732E6C6F63616C4E61';
wwv_flow_imp.g_varchar2_table(7785) := '6D65207D2C206E73293B5C6E7D5C6E5C6E66756E6374696F6E2067657453657269616C697A61626C6550726F7065727469657328656C656D656E7429207B5C6E20207661722064657363726970746F72203D20656C656D656E742E246465736372697074';
wwv_flow_imp.g_varchar2_table(7786) := '6F723B5C6E5C6E202072657475726E2066696C7465722864657363726970746F722E70726F706572746965732C2066756E6374696F6E287029207B5C6E20202020766172206E616D65203D20702E6E616D653B5C6E5C6E2020202069662028702E697356';
wwv_flow_imp.g_varchar2_table(7787) := '69727475616C29207B5C6E20202020202072657475726E2066616C73653B5C6E202020207D5C6E5C6E202020202F2F20646F206E6F742073657269616C697A652064656661756C74735C6E20202020696620282168617328656C656D656E742C206E616D';
wwv_flow_imp.g_varchar2_table(7788) := '652929207B5C6E20202020202072657475726E2066616C73653B5C6E202020207D5C6E5C6E202020207661722076616C7565203D20656C656D656E745B6E616D655D3B5C6E5C6E202020202F2F20646F206E6F742073657269616C697A65206465666175';
wwv_flow_imp.g_varchar2_table(7789) := '6C7420657175616C735C6E202020206966202876616C7565203D3D3D20702E64656661756C7429207B5C6E20202020202072657475726E2066616C73653B5C6E202020207D5C6E5C6E202020202F2F20646F206E6F742073657269616C697A65206E756C';
wwv_flow_imp.g_varchar2_table(7790) := '6C2070726F706572746965735C6E202020206966202876616C7565203D3D3D206E756C6C29207B5C6E20202020202072657475726E2066616C73653B5C6E202020207D5C6E5C6E2020202072657475726E20702E69734D616E79203F2076616C75652E6C';
wwv_flow_imp.g_varchar2_table(7791) := '656E677468203A20747275653B5C6E20207D293B5C6E7D5C6E5C6E766172204553434150455F415454525F4D4150203D207B5C6E2020275C5C6E273A2027233130272C5C6E2020275C5C6E5C5C72273A2027233130272C5C6E2020275C22273A20272333';
wwv_flow_imp.g_varchar2_table(7792) := '34272C5C6E2020275C5C27273A2027233339272C5C6E2020273C273A2027233630272C5C6E2020273E273A2027233632272C5C6E20202726273A2027233338275C6E7D3B5C6E5C6E766172204553434150455F4D4150203D207B5C6E2020273C273A2027';
wwv_flow_imp.g_varchar2_table(7793) := '6C74272C5C6E2020273E273A20276774272C5C6E20202726273A2027616D70275C6E7D3B5C6E5C6E66756E6374696F6E20657363617065287374722C20636861725061747465726E2C207265706C6163654D617029207B5C6E5C6E20202F2F20656E7375';
wwv_flow_imp.g_varchar2_table(7794) := '7265207765206172652068616E646C696E6720737472696E677320686572655C6E2020737472203D206973537472696E672873747229203F20737472203A202727202B207374723B5C6E5C6E202072657475726E207374722E7265706C61636528636861';
wwv_flow_imp.g_varchar2_table(7795) := '725061747465726E2C2066756E6374696F6E287329207B5C6E2020202072657475726E20272627202B207265706C6163654D61705B735D202B20273B273B5C6E20207D293B5C6E7D5C6E5C6E2F2A2A5C6E202A20457363617065206120737472696E6720';
wwv_flow_imp.g_varchar2_table(7796) := '61747472696275746520746F206E6F7420636F6E7461696E20616E79206261642076616C75657320286C696E6520627265616B732C20275C22272C202E2E2E295C6E202A5C6E202A2040706172616D207B537472696E677D207374722074686520737472';
wwv_flow_imp.g_varchar2_table(7797) := '696E6720746F206573636170655C6E202A204072657475726E207B537472696E677D20746865206573636170656420737472696E675C6E202A2F5C6E66756E6374696F6E20657363617065417474722873747229207B5C6E202072657475726E20657363';
wwv_flow_imp.g_varchar2_table(7798) := '617065287374722C204553434150455F415454525F43484152532C204553434150455F415454525F4D4150293B5C6E7D5C6E5C6E66756E6374696F6E20657363617065426F64792873747229207B5C6E202072657475726E20657363617065287374722C';
wwv_flow_imp.g_varchar2_table(7799) := '204553434150455F43484152532C204553434150455F4D4150293B5C6E7D5C6E5C6E66756E6374696F6E2066696C746572417474726962757465732870726F707329207B5C6E202072657475726E2066696C7465722870726F70732C2066756E6374696F';
wwv_flow_imp.g_varchar2_table(7800) := '6E287029207B2072657475726E20702E6973417474723B207D293B5C6E7D5C6E5C6E66756E6374696F6E2066696C746572436F6E7461696E65642870726F707329207B5C6E202072657475726E2066696C7465722870726F70732C2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(7801) := '287029207B2072657475726E2021702E6973417474723B207D293B5C6E7D5C6E5C6E5C6E66756E6374696F6E205265666572656E636553657269616C697A6572287461674E616D6529207B5C6E2020746869732E7461674E616D65203D207461674E616D';
wwv_flow_imp.g_varchar2_table(7802) := '653B5C6E7D5C6E5C6E5265666572656E636553657269616C697A65722E70726F746F747970652E6275696C64203D2066756E6374696F6E28656C656D656E7429207B5C6E2020746869732E656C656D656E74203D20656C656D656E743B5C6E2020726574';
wwv_flow_imp.g_varchar2_table(7803) := '75726E20746869733B5C6E7D3B5C6E5C6E5265666572656E636553657269616C697A65722E70726F746F747970652E73657269616C697A65546F203D2066756E6374696F6E2877726974657229207B5C6E20207772697465725C6E202020202E61707065';
wwv_flow_imp.g_varchar2_table(7804) := '6E64496E64656E7428295C6E202020202E617070656E6428273C27202B20746869732E7461674E616D65202B20273E27202B20746869732E656C656D656E742E6964202B20273C2F27202B20746869732E7461674E616D65202B20273E27295C6E202020';
wwv_flow_imp.g_varchar2_table(7805) := '202E617070656E644E65774C696E6528293B5C6E7D3B5C6E5C6E66756E6374696F6E20426F647953657269616C697A65722829207B7D5C6E5C6E426F647953657269616C697A65722E70726F746F747970652E73657269616C697A6556616C7565203D5C';
wwv_flow_imp.g_varchar2_table(7806) := '6E426F647953657269616C697A65722E70726F746F747970652E73657269616C697A65546F203D2066756E6374696F6E2877726974657229207B5C6E20207772697465722E617070656E64285C6E20202020746869732E6573636170655C6E2020202020';
wwv_flow_imp.g_varchar2_table(7807) := '203F20657363617065426F647928746869732E76616C7565295C6E2020202020203A20746869732E76616C75655C6E2020293B5C6E7D3B5C6E5C6E426F647953657269616C697A65722E70726F746F747970652E6275696C64203D2066756E6374696F6E';
wwv_flow_imp.g_varchar2_table(7808) := '2870726F702C2076616C756529207B5C6E2020746869732E76616C7565203D2076616C75653B5C6E5C6E20206966202870726F702E74797065203D3D3D2027537472696E67272026262076616C75652E736561726368284553434150455F434841525329';
wwv_flow_imp.g_varchar2_table(7809) := '20213D3D202D3129207B5C6E20202020746869732E657363617065203D20747275653B5C6E20207D5C6E5C6E202072657475726E20746869733B5C6E7D3B5C6E5C6E66756E6374696F6E2056616C756553657269616C697A6572287461674E616D652920';
wwv_flow_imp.g_varchar2_table(7810) := '7B5C6E2020746869732E7461674E616D65203D207461674E616D653B5C6E7D5C6E5C6E696E6865726974732856616C756553657269616C697A65722C20426F647953657269616C697A6572293B5C6E5C6E56616C756553657269616C697A65722E70726F';
wwv_flow_imp.g_varchar2_table(7811) := '746F747970652E73657269616C697A65546F203D2066756E6374696F6E2877726974657229207B5C6E5C6E20207772697465725C6E202020202E617070656E64496E64656E7428295C6E202020202E617070656E6428273C27202B20746869732E746167';
wwv_flow_imp.g_varchar2_table(7812) := '4E616D65202B20273E27293B5C6E5C6E2020746869732E73657269616C697A6556616C756528777269746572293B5C6E5C6E20207772697465725C6E202020202E617070656E6428273C2F27202B20746869732E7461674E616D65202B20273E27295C6E';
wwv_flow_imp.g_varchar2_table(7813) := '202020202E617070656E644E65774C696E6528293B5C6E7D3B5C6E5C6E66756E6374696F6E20456C656D656E7453657269616C697A657228706172656E742C2070726F706572747944657363726970746F7229207B5C6E2020746869732E626F6479203D';
wwv_flow_imp.g_varchar2_table(7814) := '205B5D3B5C6E2020746869732E6174747273203D205B5D3B5C6E5C6E2020746869732E706172656E74203D20706172656E743B5C6E2020746869732E70726F706572747944657363726970746F72203D2070726F706572747944657363726970746F723B';
wwv_flow_imp.g_varchar2_table(7815) := '5C6E7D5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E6275696C64203D2066756E6374696F6E28656C656D656E7429207B5C6E2020746869732E656C656D656E74203D20656C656D656E743B5C6E5C6E20207661722065';
wwv_flow_imp.g_varchar2_table(7816) := '6C656D656E7444657363726970746F72203D20656C656D656E742E2464657363726970746F722C5C6E20202020202070726F706572747944657363726970746F72203D20746869732E70726F706572747944657363726970746F723B5C6E5C6E20207661';
wwv_flow_imp.g_varchar2_table(7817) := '72206F7468657241747472732C5C6E20202020202070726F706572746965733B5C6E5C6E202076617220697347656E65726963203D20656C656D656E7444657363726970746F722E697347656E657269633B5C6E5C6E202069662028697347656E657269';
wwv_flow_imp.g_varchar2_table(7818) := '6329207B5C6E202020206F746865724174747273203D20746869732E706172736547656E6572696328656C656D656E74293B5C6E20207D20656C7365207B5C6E202020206F746865724174747273203D20746869732E70617273654E7341747472696275';
wwv_flow_imp.g_varchar2_table(7819) := '74657328656C656D656E74293B5C6E20207D5C6E5C6E20206966202870726F706572747944657363726970746F7229207B5C6E20202020746869732E6E73203D20746869732E6E7350726F70657274795461674E616D652870726F706572747944657363';
wwv_flow_imp.g_varchar2_table(7820) := '726970746F72293B5C6E20207D20656C7365207B5C6E20202020746869732E6E73203D20746869732E6E735461674E616D6528656C656D656E7444657363726970746F72293B5C6E20207D5C6E5C6E20202F2F20636F6D7075746520746167206E616D65';
wwv_flow_imp.g_varchar2_table(7821) := '5C6E2020746869732E7461674E616D65203D20746869732E6164645461674E616D6528746869732E6E73293B5C6E5C6E20206966202821697347656E6572696329207B5C6E2020202070726F70657274696573203D2067657453657269616C697A61626C';
wwv_flow_imp.g_varchar2_table(7822) := '6550726F7065727469657328656C656D656E74293B5C6E5C6E20202020746869732E7061727365417474726962757465732866696C746572417474726962757465732870726F7065727469657329293B5C6E20202020746869732E7061727365436F6E74';
wwv_flow_imp.g_varchar2_table(7823) := '61696E6D656E74732866696C746572436F6E7461696E65642870726F7065727469657329293B5C6E20207D5C6E5C6E2020746869732E706172736547656E657269634174747269627574657328656C656D656E742C206F746865724174747273293B5C6E';
wwv_flow_imp.g_varchar2_table(7824) := '5C6E202072657475726E20746869733B5C6E7D3B5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E6E735461674E616D65203D2066756E6374696F6E2864657363726970746F7229207B5C6E202076617220656666656374';
wwv_flow_imp.g_varchar2_table(7825) := '6976654E73203D20746869732E6C6F674E616D657370616365557365642864657363726970746F722E6E73293B5C6E202072657475726E20676574456C656D656E744E73286566666563746976654E732C2064657363726970746F72293B5C6E7D3B5C6E';
wwv_flow_imp.g_varchar2_table(7826) := '5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E6E7350726F70657274795461674E616D65203D2066756E6374696F6E2864657363726970746F7229207B5C6E2020766172206566666563746976654E73203D20746869732E6C';
wwv_flow_imp.g_varchar2_table(7827) := '6F674E616D657370616365557365642864657363726970746F722E6E73293B5C6E202072657475726E2067657450726F70657274794E73286566666563746976654E732C2064657363726970746F72293B5C6E7D3B5C6E5C6E456C656D656E7453657269';
wwv_flow_imp.g_varchar2_table(7828) := '616C697A65722E70726F746F747970652E69734C6F63616C4E73203D2066756E6374696F6E286E7329207B5C6E202072657475726E206E732E757269203D3D3D20746869732E6E732E7572693B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2047657420746865';
wwv_flow_imp.g_varchar2_table(7829) := '2061637475616C206E7320617474726962757465206E616D6520666F722074686520676976656E20656C656D656E742E5C6E202A5C6E202A2040706172616D207B4F626A6563747D20656C656D656E745C6E202A2040706172616D207B426F6F6C65616E';
wwv_flow_imp.g_varchar2_table(7830) := '7D205B656C656D656E742E696E686572697465643D66616C73655D5C6E202A5C6E202A204072657475726E207B4F626A6563747D206E734E616D655C6E202A2F5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E6E7341747472';
wwv_flow_imp.g_varchar2_table(7831) := '69627574654E616D65203D2066756E6374696F6E28656C656D656E7429207B5C6E5C6E2020766172206E733B5C6E5C6E2020696620286973537472696E6728656C656D656E742929207B5C6E202020206E73203D2070617273654E616D654E5328656C65';
wwv_flow_imp.g_varchar2_table(7832) := '6D656E74293B5C6E20207D20656C7365207B5C6E202020206E73203D20656C656D656E742E6E733B5C6E20207D5C6E5C6E20202F2F2072657475726E206A757374206C6F63616C206E616D6520666F7220696E6865726974656420617474726962757465';
wwv_flow_imp.g_varchar2_table(7833) := '735C6E202069662028656C656D656E742E696E6865726974656429207B5C6E2020202072657475726E207B206C6F63616C4E616D653A206E732E6C6F63616C4E616D65207D3B5C6E20207D5C6E5C6E20202F2F207061727365202B206C6F672065666665';
wwv_flow_imp.g_varchar2_table(7834) := '6374697665206E735C6E2020766172206566666563746976654E73203D20746869732E6C6F674E616D65737061636555736564286E73293B5C6E5C6E20202F2F204C4F472041435455414C206E616D657370616365207573655C6E2020746869732E6765';
wwv_flow_imp.g_varchar2_table(7835) := '744E616D6573706163657328292E6C6F6755736564286566666563746976654E73293B5C6E5C6E20202F2F207374726970207072656669782069662073616D65206E616D657370616365206C696B6520706172656E745C6E202069662028746869732E69';
wwv_flow_imp.g_varchar2_table(7836) := '734C6F63616C4E73286566666563746976654E732929207B5C6E2020202072657475726E207B206C6F63616C4E616D653A206E732E6C6F63616C4E616D65207D3B5C6E20207D20656C7365207B5C6E2020202072657475726E2061737369676E287B206C';
wwv_flow_imp.g_varchar2_table(7837) := '6F63616C4E616D653A206E732E6C6F63616C4E616D65207D2C206566666563746976654E73293B5C6E20207D5C6E7D3B5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E706172736547656E65726963203D2066756E6374';
wwv_flow_imp.g_varchar2_table(7838) := '696F6E28656C656D656E7429207B5C6E5C6E20207661722073656C66203D20746869732C5C6E202020202020626F6479203D20746869732E626F64793B5C6E5C6E20207661722061747472696275746573203D205B5D3B5C6E5C6E2020666F7245616368';
wwv_flow_imp.g_varchar2_table(7839) := '28656C656D656E742C2066756E6374696F6E2876616C2C206B657929207B5C6E5C6E20202020766172206E6F6E4E73417474723B5C6E5C6E20202020696620286B6579203D3D3D202724626F64792729207B5C6E202020202020626F64792E7075736828';
wwv_flow_imp.g_varchar2_table(7840) := '6E657720426F647953657269616C697A657228292E6275696C64287B20747970653A2027537472696E6727207D2C2076616C29293B5C6E202020207D20656C73655C6E20202020696620286B6579203D3D3D2027246368696C6472656E2729207B5C6E20';
wwv_flow_imp.g_varchar2_table(7841) := '2020202020666F72456163682876616C2C2066756E6374696F6E286368696C6429207B5C6E2020202020202020626F64792E70757368286E657720456C656D656E7453657269616C697A65722873656C66292E6275696C64286368696C6429293B5C6E20';
wwv_flow_imp.g_varchar2_table(7842) := '20202020207D293B5C6E202020207D20656C73655C6E20202020696620286B65792E696E6465784F66282724272920213D3D203029207B5C6E2020202020206E6F6E4E7341747472203D2073656C662E70617273654E7341747472696275746528656C65';
wwv_flow_imp.g_varchar2_table(7843) := '6D656E742C206B65792C2076616C293B5C6E5C6E202020202020696620286E6F6E4E734174747229207B5C6E2020202020202020617474726962757465732E70757368287B206E616D653A206B65792C2076616C75653A2076616C207D293B5C6E202020';
wwv_flow_imp.g_varchar2_table(7844) := '2020207D5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E20617474726962757465733B5C6E7D3B5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E70617273654E73417474726962757465203D2066756E';
wwv_flow_imp.g_varchar2_table(7845) := '6374696F6E28656C656D656E742C206E616D652C2076616C756529207B5C6E2020766172206D6F64656C203D20656C656D656E742E246D6F64656C3B5C6E5C6E2020766172206E616D654E73203D2070617273654E616D654E53286E616D65293B5C6E5C';
wwv_flow_imp.g_varchar2_table(7846) := '6E2020766172206E733B5C6E5C6E20202F2F20706172736520786D6C6E733A666F6F3D5C22687474703A2F2F666F6F2E6261725C225C6E2020696620286E616D654E732E707265666978203D3D3D2027786D6C6E732729207B5C6E202020206E73203D20';
wwv_flow_imp.g_varchar2_table(7847) := '7B207072656669783A206E616D654E732E6C6F63616C4E616D652C207572693A2076616C7565207D3B5C6E20207D5C6E5C6E20202F2F20706172736520786D6C6E733D5C22687474703A2F2F666F6F2E6261725C225C6E202069662028216E616D654E73';
wwv_flow_imp.g_varchar2_table(7848) := '2E707265666978202626206E616D654E732E6C6F63616C4E616D65203D3D3D2027786D6C6E732729207B5C6E202020206E73203D207B207572693A2076616C7565207D3B5C6E20207D5C6E5C6E202069662028216E7329207B5C6E202020207265747572';
wwv_flow_imp.g_varchar2_table(7849) := '6E207B5C6E2020202020206E616D653A206E616D652C5C6E20202020202076616C75653A2076616C75655C6E202020207D3B5C6E20207D5C6E5C6E2020696620286D6F64656C202626206D6F64656C2E6765745061636B6167652876616C75652929207B';
wwv_flow_imp.g_varchar2_table(7850) := '5C6E5C6E202020202F2F2072656769737465722077656C6C206B6E6F776E206E616D6573706163655C6E20202020746869732E6C6F674E616D657370616365286E732C20747275652C2074727565293B5C6E20207D20656C7365207B5C6E5C6E20202020';
wwv_flow_imp.g_varchar2_table(7851) := '2F2F206C6F6720637573746F6D206E616D657370616365206469726563746C7920617320757365645C6E202020207661722061637475616C4E73203D20746869732E6C6F674E616D65737061636555736564286E732C2074727565293B5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(7852) := '20746869732E6765744E616D6573706163657328292E6C6F67557365642861637475616C4E73293B5C6E20207D5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A205061727365206E616D6573706163657320616E642072657475726E2061206C697374206F66';
wwv_flow_imp.g_varchar2_table(7853) := '206C656674206F7665722067656E6572696320617474726962757465735C6E202A5C6E202A2040706172616D20207B4F626A6563747D20656C656D656E745C6E202A204072657475726E207B41727261793C4F626A6563743E7D5C6E202A2F5C6E456C65';
wwv_flow_imp.g_varchar2_table(7854) := '6D656E7453657269616C697A65722E70726F746F747970652E70617273654E7341747472696275746573203D2066756E6374696F6E28656C656D656E742C20617474727329207B5C6E20207661722073656C66203D20746869733B5C6E5C6E2020766172';
wwv_flow_imp.g_varchar2_table(7855) := '2067656E657269634174747273203D20656C656D656E742E2461747472733B5C6E5C6E20207661722061747472696275746573203D205B5D3B5C6E5C6E20202F2F207061727365206E616D65737061636520617474726962757465732066697273745C6E';
wwv_flow_imp.g_varchar2_table(7856) := '20202F2F20616E64206C6F67207468656D2E2070757368206E6F6E206E616D657370616365206174747269627574657320746F2061206C6973745C6E20202F2F20616E642070726F63657373207468656D206C617465725C6E2020666F72456163682867';
wwv_flow_imp.g_varchar2_table(7857) := '656E6572696341747472732C2066756E6374696F6E2876616C75652C206E616D6529207B5C6E5C6E20202020766172206E6F6E4E7341747472203D2073656C662E70617273654E7341747472696275746528656C656D656E742C206E616D652C2076616C';
wwv_flow_imp.g_varchar2_table(7858) := '7565293B5C6E5C6E20202020696620286E6F6E4E734174747229207B5C6E202020202020617474726962757465732E70757368286E6F6E4E7341747472293B5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E2061747472696275746573';
wwv_flow_imp.g_varchar2_table(7859) := '3B5C6E7D3B5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E706172736547656E6572696341747472696275746573203D2066756E6374696F6E28656C656D656E742C206174747269627574657329207B5C6E5C6E202076';
wwv_flow_imp.g_varchar2_table(7860) := '61722073656C66203D20746869733B5C6E5C6E2020666F724561636828617474726962757465732C2066756E6374696F6E286174747229207B5C6E5C6E202020202F2F20646F206E6F742073657269616C697A65207873693A7479706520617474726962';
wwv_flow_imp.g_varchar2_table(7861) := '7574655C6E202020202F2F20697420697320736574206D616E75616C6C79206261736564206F6E207468652061637475616C20696D706C656D656E746174696F6E20747970655C6E2020202069662028617474722E6E616D65203D3D3D205853495F5459';
wwv_flow_imp.g_varchar2_table(7862) := '504529207B5C6E20202020202072657475726E3B5C6E202020207D5C6E5C6E20202020747279207B5C6E20202020202073656C662E6164644174747269627574652873656C662E6E734174747269627574654E616D6528617474722E6E616D65292C2061';
wwv_flow_imp.g_varchar2_table(7863) := '7474722E76616C7565293B5C6E202020207D20636174636820286529207B5C6E2020202020202F2A20676C6F62616C20636F6E736F6C65202A2F5C6E5C6E202020202020636F6E736F6C652E7761726E285C6E2020202020202020276D697373696E6720';
wwv_flow_imp.g_varchar2_table(7864) := '6E616D65737061636520696E666F726D6174696F6E20666F7220272C5C6E2020202020202020617474722E6E616D652C20273D272C20617474722E76616C75652C20276F6E272C20656C656D656E742C5C6E202020202020202065293B5C6E202020207D';
wwv_flow_imp.g_varchar2_table(7865) := '5C6E20207D293B5C6E7D3B5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E7061727365436F6E7461696E6D656E7473203D2066756E6374696F6E2870726F7065727469657329207B5C6E5C6E20207661722073656C6620';
wwv_flow_imp.g_varchar2_table(7866) := '3D20746869732C5C6E202020202020626F6479203D20746869732E626F64792C5C6E202020202020656C656D656E74203D20746869732E656C656D656E743B5C6E5C6E2020666F72456163682870726F706572746965732C2066756E6374696F6E287029';
wwv_flow_imp.g_varchar2_table(7867) := '207B5C6E202020207661722076616C7565203D20656C656D656E742E67657428702E6E616D65292C5C6E202020202020202069735265666572656E6365203D20702E69735265666572656E63652C5C6E202020202020202069734D616E79203D20702E69';
wwv_flow_imp.g_varchar2_table(7868) := '734D616E793B5C6E5C6E20202020696620282169734D616E7929207B5C6E20202020202076616C7565203D205B2076616C7565205D3B5C6E202020207D5C6E5C6E2020202069662028702E6973426F647929207B5C6E202020202020626F64792E707573';
wwv_flow_imp.g_varchar2_table(7869) := '68286E657720426F647953657269616C697A657228292E6275696C6428702C2076616C75655B305D29293B5C6E202020207D20656C73655C6E2020202069662028697353696D706C655479706528702E747970652929207B5C6E202020202020666F7245';
wwv_flow_imp.g_varchar2_table(7870) := '6163682876616C75652C2066756E6374696F6E287629207B5C6E2020202020202020626F64792E70757368286E65772056616C756553657269616C697A65722873656C662E6164645461674E616D652873656C662E6E7350726F70657274795461674E61';
wwv_flow_imp.g_varchar2_table(7871) := '6D6528702929292E6275696C6428702C207629293B5C6E2020202020207D293B5C6E202020207D20656C73655C6E202020206966202869735265666572656E636529207B5C6E202020202020666F72456163682876616C75652C2066756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(7872) := '7629207B5C6E2020202020202020626F64792E70757368286E6577205265666572656E636553657269616C697A65722873656C662E6164645461674E616D652873656C662E6E7350726F70657274795461674E616D6528702929292E6275696C64287629';
wwv_flow_imp.g_varchar2_table(7873) := '293B5C6E2020202020207D293B5C6E202020207D20656C7365207B5C6E5C6E2020202020202F2F20616C6C6F772073657269616C697A6174696F6E2076696120747970655C6E2020202020202F2F20726174686572207468616E20656C656D656E74206E';
wwv_flow_imp.g_varchar2_table(7874) := '616D655C6E20202020202076617220617354797065203D2073657269616C697A654173547970652870292C5C6E20202020202020202020617350726F7065727479203D2073657269616C697A65417350726F70657274792870293B5C6E5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7875) := '20666F72456163682876616C75652C2066756E6374696F6E287629207B5C6E20202020202020207661722073657269616C697A65723B5C6E5C6E20202020202020206966202861735479706529207B5C6E2020202020202020202073657269616C697A65';
wwv_flow_imp.g_varchar2_table(7876) := '72203D206E6577205479706553657269616C697A65722873656C662C2070293B5C6E20202020202020207D20656C73655C6E202020202020202069662028617350726F706572747929207B5C6E2020202020202020202073657269616C697A6572203D20';
wwv_flow_imp.g_varchar2_table(7877) := '6E657720456C656D656E7453657269616C697A65722873656C662C2070293B5C6E20202020202020207D20656C7365207B5C6E2020202020202020202073657269616C697A6572203D206E657720456C656D656E7453657269616C697A65722873656C66';
wwv_flow_imp.g_varchar2_table(7878) := '293B5C6E20202020202020207D5C6E5C6E2020202020202020626F64792E707573682873657269616C697A65722E6275696C64287629293B5C6E2020202020207D293B5C6E202020207D5C6E20207D293B5C6E7D3B5C6E5C6E456C656D656E7453657269';
wwv_flow_imp.g_varchar2_table(7879) := '616C697A65722E70726F746F747970652E6765744E616D65737061636573203D2066756E6374696F6E286C6F63616C29207B5C6E5C6E2020766172206E616D65737061636573203D20746869732E6E616D657370616365732C5C6E202020202020706172';
wwv_flow_imp.g_varchar2_table(7880) := '656E74203D20746869732E706172656E742C5C6E202020202020706172656E744E616D657370616365733B5C6E5C6E202069662028216E616D6573706163657329207B5C6E20202020706172656E744E616D65737061636573203D20706172656E742026';
wwv_flow_imp.g_varchar2_table(7881) := '2620706172656E742E6765744E616D6573706163657328293B5C6E5C6E20202020696620286C6F63616C207C7C2021706172656E744E616D6573706163657329207B5C6E202020202020746869732E6E616D65737061636573203D206E616D6573706163';
wwv_flow_imp.g_varchar2_table(7882) := '6573203D206E6577204E616D6573706163657328706172656E744E616D65737061636573293B5C6E202020207D20656C7365207B5C6E2020202020206E616D65737061636573203D20706172656E744E616D657370616365733B5C6E202020207D5C6E20';
wwv_flow_imp.g_varchar2_table(7883) := '207D5C6E5C6E202072657475726E206E616D657370616365733B5C6E7D3B5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E6C6F674E616D657370616365203D2066756E6374696F6E286E732C2077656C6C6B6E6F776E2C';
wwv_flow_imp.g_varchar2_table(7884) := '206C6F63616C29207B5C6E2020766172206E616D65737061636573203D20746869732E6765744E616D65737061636573286C6F63616C293B5C6E5C6E2020766172206E73557269203D206E732E7572692C5C6E2020202020206E73507265666978203D20';
wwv_flow_imp.g_varchar2_table(7885) := '6E732E7072656669783B5C6E5C6E2020766172206578697374696E67203D206E616D657370616365732E6279557269286E73557269293B5C6E5C6E202069662028216578697374696E67207C7C206C6F63616C29207B5C6E202020206E616D6573706163';
wwv_flow_imp.g_varchar2_table(7886) := '65732E616464286E732C2077656C6C6B6E6F776E293B5C6E20207D5C6E5C6E20206E616D657370616365732E6D6170507265666978286E735072656669782C206E73557269293B5C6E5C6E202072657475726E206E733B5C6E7D3B5C6E5C6E456C656D65';
wwv_flow_imp.g_varchar2_table(7887) := '6E7453657269616C697A65722E70726F746F747970652E6C6F674E616D65737061636555736564203D2066756E6374696F6E286E732C206C6F63616C29207B5C6E202076617220656C656D656E74203D20746869732E656C656D656E742C5C6E20202020';
wwv_flow_imp.g_varchar2_table(7888) := '20206D6F64656C203D20656C656D656E742E246D6F64656C2C5C6E2020202020206E616D65737061636573203D20746869732E6765744E616D65737061636573286C6F63616C293B5C6E5C6E20202F2F206E73206D61792062655C6E20202F2F5C6E2020';
wwv_flow_imp.g_varchar2_table(7889) := '2F2F2020202A20707265666978206F6E6C795C6E20202F2F2020202A207072656669783A7572695C6E20202F2F2020202A206C6F63616C4E616D65206F6E6C795C6E5C6E202076617220707265666978203D206E732E7072656669782C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7890) := '20757269203D206E732E7572692C5C6E2020202020206E65775072656669782C206964782C5C6E20202020202077656C6C6B6E6F776E5572693B5C6E5C6E20202F2F2068616E646C6520616E6F6E796D6F7573206E616D657370616365732028656C656D';
wwv_flow_imp.g_varchar2_table(7891) := '656E74466F726D3D756E7175616C6966696564292C2063662E202332335C6E20206966202821707265666978202626202175726929207B5C6E2020202072657475726E207B206C6F63616C4E616D653A206E732E6C6F63616C4E616D65207D3B5C6E2020';
wwv_flow_imp.g_varchar2_table(7892) := '7D5C6E5C6E202077656C6C6B6E6F776E557269203D2044454641554C545F4E535F4D41505B7072656669785D207C7C206D6F64656C20262620286D6F64656C2E6765745061636B6167652870726566697829207C7C207B7D292E7572693B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(7893) := '757269203D20757269207C7C2077656C6C6B6E6F776E557269207C7C206E616D657370616365732E757269427950726566697828707265666978293B5C6E5C6E2020696620282175726929207B5C6E202020207468726F77206E6577204572726F722827';
wwv_flow_imp.g_varchar2_table(7894) := '6E6F206E616D6573706163652075726920676976656E20666F7220707265666978203C27202B20707265666978202B20273E27293B5C6E20207D5C6E5C6E20206E73203D206E616D657370616365732E627955726928757269293B5C6E5C6E2020696620';
wwv_flow_imp.g_varchar2_table(7895) := '28216E7329207B5C6E202020206E6577507265666978203D207072656669783B5C6E20202020696478203D20313B5C6E5C6E202020202F2F2066696E642061207072656669782074686174206973206E6F74206D6170706564207965745C6E2020202077';
wwv_flow_imp.g_varchar2_table(7896) := '68696C6520286E616D657370616365732E7572694279507265666978286E65775072656669782929207B5C6E2020202020206E6577507265666978203D20707265666978202B20275F27202B206964782B2B3B5C6E202020207D5C6E5C6E202020206E73';
wwv_flow_imp.g_varchar2_table(7897) := '203D20746869732E6C6F674E616D657370616365287B207072656669783A206E65775072656669782C207572693A20757269207D2C2077656C6C6B6E6F776E557269203D3D3D20757269293B5C6E20207D5C6E5C6E20206966202870726566697829207B';
wwv_flow_imp.g_varchar2_table(7898) := '5C6E202020206E616D657370616365732E6D6170507265666978287072656669782C20757269293B5C6E20207D5C6E5C6E202072657475726E206E733B5C6E7D3B5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E706172';
wwv_flow_imp.g_varchar2_table(7899) := '736541747472696275746573203D2066756E6374696F6E2870726F7065727469657329207B5C6E20207661722073656C66203D20746869732C5C6E202020202020656C656D656E74203D20746869732E656C656D656E743B5C6E5C6E2020666F72456163';
wwv_flow_imp.g_varchar2_table(7900) := '682870726F706572746965732C2066756E6374696F6E287029207B5C6E5C6E202020207661722076616C7565203D20656C656D656E742E67657428702E6E616D65293B5C6E5C6E2020202069662028702E69735265666572656E636529207B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(7901) := '20202020206966202821702E69734D616E7929207B5C6E202020202020202076616C7565203D2076616C75652E69643B5C6E2020202020207D5C6E202020202020656C7365207B5C6E20202020202020207661722076616C756573203D205B5D3B5C6E20';
wwv_flow_imp.g_varchar2_table(7902) := '20202020202020666F72456163682876616C75652C2066756E6374696F6E287629207B5C6E2020202020202020202076616C7565732E7075736828762E6964293B5C6E20202020202020207D293B5C6E5C6E20202020202020202F2F2049445245465320';
wwv_flow_imp.g_varchar2_table(7903) := '6973206120776869746573706163652D736570617261746564206C697374206F66207265666572656E6365732E5C6E202020202020202076616C7565203D2076616C7565732E6A6F696E28272027293B5C6E2020202020207D5C6E5C6E202020207D5C6E';
wwv_flow_imp.g_varchar2_table(7904) := '5C6E2020202073656C662E6164644174747269627574652873656C662E6E734174747269627574654E616D652870292C2076616C7565293B5C6E20207D293B5C6E7D3B5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E61';
wwv_flow_imp.g_varchar2_table(7905) := '64645461674E616D65203D2066756E6374696F6E286E735461674E616D6529207B5C6E20207661722061637475616C4E73203D20746869732E6C6F674E616D65737061636555736564286E735461674E616D65293B5C6E5C6E2020746869732E6765744E';
wwv_flow_imp.g_varchar2_table(7906) := '616D6573706163657328292E6C6F67557365642861637475616C4E73293B5C6E5C6E202072657475726E206E734E616D65286E735461674E616D65293B5C6E7D3B5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E616464';
wwv_flow_imp.g_varchar2_table(7907) := '417474726962757465203D2066756E6374696F6E286E616D652C2076616C756529207B5C6E2020766172206174747273203D20746869732E61747472733B5C6E5C6E2020696620286973537472696E672876616C75652929207B5C6E2020202076616C75';
wwv_flow_imp.g_varchar2_table(7908) := '65203D20657363617065417474722876616C7565293B5C6E20207D5C6E5C6E20202F2F2064652D6475706C696361746520617474726962757465735C6E20202F2F2068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F6D6F64646C652D';
wwv_flow_imp.g_varchar2_table(7909) := '786D6C2F6973737565732F36365C6E202076617220696478203D2066696E64496E6465782861747472732C2066756E6374696F6E28656C656D656E7429207B5C6E2020202072657475726E20285C6E202020202020656C656D656E742E6E616D652E6C6F';
wwv_flow_imp.g_varchar2_table(7910) := '63616C4E616D65203D3D3D206E616D652E6C6F63616C4E616D652026265C6E202020202020656C656D656E742E6E616D652E757269203D3D3D206E616D652E7572692026265C6E202020202020656C656D656E742E6E616D652E707265666978203D3D3D';
wwv_flow_imp.g_varchar2_table(7911) := '206E616D652E7072656669785C6E20202020293B5C6E20207D293B5C6E5C6E20207661722061747472203D207B206E616D653A206E616D652C2076616C75653A2076616C7565207D3B5C6E5C6E20206966202869647820213D3D202D3129207B5C6E2020';
wwv_flow_imp.g_varchar2_table(7912) := '202061747472732E73706C696365286964782C20312C2061747472293B5C6E20207D20656C7365207B5C6E2020202061747472732E707573682861747472293B5C6E20207D5C6E7D3B5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F';
wwv_flow_imp.g_varchar2_table(7913) := '747970652E73657269616C697A6541747472696275746573203D2066756E6374696F6E2877726974657229207B5C6E2020766172206174747273203D20746869732E61747472732C5C6E2020202020206E616D65737061636573203D20746869732E6E61';
wwv_flow_imp.g_varchar2_table(7914) := '6D657370616365733B5C6E5C6E2020696620286E616D6573706163657329207B5C6E202020206174747273203D206765744E734174747273286E616D65737061636573292E636F6E636174286174747273293B5C6E20207D5C6E5C6E2020666F72456163';
wwv_flow_imp.g_varchar2_table(7915) := '682861747472732C2066756E6374696F6E286129207B5C6E202020207772697465725C6E2020202020202E617070656E6428272027295C6E2020202020202E617070656E64286E734E616D6528612E6E616D6529292E617070656E6428273D5C2227292E';
wwv_flow_imp.g_varchar2_table(7916) := '617070656E6428612E76616C7565292E617070656E6428275C2227293B5C6E20207D293B5C6E7D3B5C6E5C6E456C656D656E7453657269616C697A65722E70726F746F747970652E73657269616C697A65546F203D2066756E6374696F6E287772697465';
wwv_flow_imp.g_varchar2_table(7917) := '7229207B5C6E2020766172206669727374426F6479203D20746869732E626F64795B305D2C5C6E202020202020696E64656E74203D206669727374426F6479202626206669727374426F64792E636F6E7374727563746F7220213D3D20426F6479536572';
wwv_flow_imp.g_varchar2_table(7918) := '69616C697A65723B5C6E5C6E20207772697465725C6E202020202E617070656E64496E64656E7428295C6E202020202E617070656E6428273C27202B20746869732E7461674E616D65293B5C6E5C6E2020746869732E73657269616C697A654174747269';
wwv_flow_imp.g_varchar2_table(7919) := '627574657328777269746572293B5C6E5C6E20207772697465722E617070656E64286669727374426F6479203F20273E27203A2027202F3E27293B5C6E5C6E2020696620286669727374426F647929207B5C6E5C6E2020202069662028696E64656E7429';
wwv_flow_imp.g_varchar2_table(7920) := '207B5C6E2020202020207772697465725C6E20202020202020202E617070656E644E65774C696E6528295C6E20202020202020202E696E64656E7428293B5C6E202020207D5C6E5C6E20202020666F724561636828746869732E626F64792C2066756E63';
wwv_flow_imp.g_varchar2_table(7921) := '74696F6E286229207B5C6E202020202020622E73657269616C697A65546F28777269746572293B5C6E202020207D293B5C6E5C6E2020202069662028696E64656E7429207B5C6E2020202020207772697465725C6E20202020202020202E756E696E6465';
wwv_flow_imp.g_varchar2_table(7922) := '6E7428295C6E20202020202020202E617070656E64496E64656E7428293B5C6E202020207D5C6E5C6E202020207772697465722E617070656E6428273C2F27202B20746869732E7461674E616D65202B20273E27293B5C6E20207D5C6E5C6E2020777269';
wwv_flow_imp.g_varchar2_table(7923) := '7465722E617070656E644E65774C696E6528293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20412073657269616C697A657220666F7220747970657320746861742068616E646C65732073657269616C697A6174696F6E206F6620646174612074797065735C';
wwv_flow_imp.g_varchar2_table(7924) := '6E202A2F5C6E66756E6374696F6E205479706553657269616C697A657228706172656E742C2070726F706572747944657363726970746F7229207B5C6E2020456C656D656E7453657269616C697A65722E63616C6C28746869732C20706172656E742C20';
wwv_flow_imp.g_varchar2_table(7925) := '70726F706572747944657363726970746F72293B5C6E7D5C6E5C6E696E686572697473285479706553657269616C697A65722C20456C656D656E7453657269616C697A6572293B5C6E5C6E5479706553657269616C697A65722E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(7926) := '70617273654E7341747472696275746573203D2066756E6374696F6E28656C656D656E7429207B5C6E5C6E20202F2F2065787472616374656420617474726962757465735C6E20207661722061747472696275746573203D20456C656D656E7453657269';
wwv_flow_imp.g_varchar2_table(7927) := '616C697A65722E70726F746F747970652E70617273654E73417474726962757465732E63616C6C28746869732C20656C656D656E74293B5C6E5C6E20207661722064657363726970746F72203D20656C656D656E742E2464657363726970746F723B5C6E';
wwv_flow_imp.g_varchar2_table(7928) := '5C6E20202F2F206F6E6C792073657269616C697A65207873693A74797065206966206E65636573736172795C6E20206966202864657363726970746F722E6E616D65203D3D3D20746869732E70726F706572747944657363726970746F722E7479706529';
wwv_flow_imp.g_varchar2_table(7929) := '207B5C6E2020202072657475726E20617474726962757465733B5C6E20207D5C6E5C6E202076617220747970654E73203D20746869732E747970654E73203D20746869732E6E735461674E616D652864657363726970746F72293B5C6E2020746869732E';
wwv_flow_imp.g_varchar2_table(7930) := '6765744E616D6573706163657328292E6C6F675573656428746869732E747970654E73293B5C6E5C6E20202F2F20616464207873693A747970652061747472696275746520746F20726570726573656E742074686520656C656D656E74735C6E20202F2F';
wwv_flow_imp.g_varchar2_table(7931) := '2061637475616C20747970655C6E5C6E202076617220706B67203D20656C656D656E742E246D6F64656C2E6765745061636B61676528747970654E732E757269292C5C6E20202020202074797065507265666978203D2028706B672E786D6C2026262070';
wwv_flow_imp.g_varchar2_table(7932) := '6B672E786D6C2E7479706550726566697829207C7C2027273B5C6E5C6E2020746869732E616464417474726962757465285C6E20202020746869732E6E734174747269627574654E616D65285853495F54595045292C5C6E2020202028747970654E732E';
wwv_flow_imp.g_varchar2_table(7933) := '707265666978203F20747970654E732E707265666978202B20273A27203A20272729202B2074797065507265666978202B2064657363726970746F722E6E732E6C6F63616C4E616D655C6E2020293B5C6E5C6E202072657475726E206174747269627574';
wwv_flow_imp.g_varchar2_table(7934) := '65733B5C6E7D3B5C6E5C6E5479706553657269616C697A65722E70726F746F747970652E69734C6F63616C4E73203D2066756E6374696F6E286E7329207B5C6E202072657475726E206E732E757269203D3D3D2028746869732E747970654E73207C7C20';
wwv_flow_imp.g_varchar2_table(7935) := '746869732E6E73292E7572693B5C6E7D3B5C6E5C6E66756E6374696F6E20536176696E675772697465722829207B5C6E2020746869732E76616C7565203D2027273B5C6E5C6E2020746869732E7772697465203D2066756E6374696F6E2873747229207B';
wwv_flow_imp.g_varchar2_table(7936) := '5C6E20202020746869732E76616C7565202B3D207374723B5C6E20207D3B5C6E7D5C6E5C6E66756E6374696F6E20466F726D6174696E67577269746572286F75742C20666F726D617429207B5C6E5C6E202076617220696E64656E74203D205B20272720';
wwv_flow_imp.g_varchar2_table(7937) := '5D3B5C6E5C6E2020746869732E617070656E64203D2066756E6374696F6E2873747229207B5C6E202020206F75742E777269746528737472293B5C6E5C6E2020202072657475726E20746869733B5C6E20207D3B5C6E5C6E2020746869732E617070656E';
wwv_flow_imp.g_varchar2_table(7938) := '644E65774C696E65203D2066756E6374696F6E2829207B5C6E2020202069662028666F726D617429207B5C6E2020202020206F75742E777269746528275C5C6E27293B5C6E202020207D5C6E5C6E2020202072657475726E20746869733B5C6E20207D3B';
wwv_flow_imp.g_varchar2_table(7939) := '5C6E5C6E2020746869732E617070656E64496E64656E74203D2066756E6374696F6E2829207B5C6E2020202069662028666F726D617429207B5C6E2020202020206F75742E777269746528696E64656E742E6A6F696E282720202729293B5C6E20202020';
wwv_flow_imp.g_varchar2_table(7940) := '7D5C6E5C6E2020202072657475726E20746869733B5C6E20207D3B5C6E5C6E2020746869732E696E64656E74203D2066756E6374696F6E2829207B5C6E20202020696E64656E742E70757368282727293B5C6E2020202072657475726E20746869733B5C';
wwv_flow_imp.g_varchar2_table(7941) := '6E20207D3B5C6E5C6E2020746869732E756E696E64656E74203D2066756E6374696F6E2829207B5C6E20202020696E64656E742E706F7028293B5C6E2020202072657475726E20746869733B5C6E20207D3B5C6E7D5C6E5C6E2F2A2A5C6E202A20412077';
wwv_flow_imp.g_varchar2_table(7942) := '726974657220666F72206D6574612D6D6F64656C206261636B656420646F63756D656E742074726565735C6E202A5C6E202A2040706172616D207B4F626A6563747D206F7074696F6E73206F7574707574206F7074696F6E7320746F207061737320696E';
wwv_flow_imp.g_varchar2_table(7943) := '746F20746865207772697465725C6E202A2F5C6E66756E6374696F6E20577269746572286F7074696F6E7329207B5C6E5C6E20206F7074696F6E73203D2061737369676E287B20666F726D61743A2066616C73652C20707265616D626C653A2074727565';
wwv_flow_imp.g_varchar2_table(7944) := '207D2C206F7074696F6E73207C7C207B7D293B5C6E5C6E202066756E6374696F6E20746F584D4C28747265652C2077726974657229207B5C6E2020202076617220696E7465726E616C577269746572203D20777269746572207C7C206E65772053617669';
wwv_flow_imp.g_varchar2_table(7945) := '6E6757726974657228293B5C6E2020202076617220666F726D6174696E67577269746572203D206E657720466F726D6174696E6757726974657228696E7465726E616C5772697465722C206F7074696F6E732E666F726D6174293B5C6E5C6E2020202069';
wwv_flow_imp.g_varchar2_table(7946) := '6620286F7074696F6E732E707265616D626C6529207B5C6E202020202020666F726D6174696E675772697465722E617070656E6428584D4C5F505245414D424C45293B5C6E202020207D5C6E5C6E202020206E657720456C656D656E7453657269616C69';
wwv_flow_imp.g_varchar2_table(7947) := '7A657228292E6275696C642874726565292E73657269616C697A65546F28666F726D6174696E67577269746572293B5C6E5C6E20202020696620282177726974657229207B5C6E20202020202072657475726E20696E7465726E616C5772697465722E76';
wwv_flow_imp.g_varchar2_table(7948) := '616C75653B5C6E202020207D5C6E20207D5C6E5C6E202072657475726E207B5C6E20202020746F584D4C3A20746F584D4C5C6E20207D3B5C6E7D5C6E5C6E6578706F7274207B205265616465722C20577269746572207D3B5C6E2F2F2320736F75726365';
wwv_flow_imp.g_varchar2_table(7949) := '4D617070696E6755524C3D696E6465782E65736D2E6A732E6D61705C6E222C22696D706F7274207B20666F72456163682C2062696E642C207069636B2C2061737369676E2C206973537472696E672C2069734F626A6563742C20736574207D2066726F6D';
wwv_flow_imp.g_varchar2_table(7950) := '20276D696E2D64617368273B5C6E5C6E2F2A2A5C6E202A204D6F64646C65206261736520656C656D656E742E5C6E202A2F5C6E66756E6374696F6E20426173652829207B207D5C6E5C6E426173652E70726F746F747970652E676574203D2066756E6374';
wwv_flow_imp.g_varchar2_table(7951) := '696F6E286E616D6529207B5C6E202072657475726E20746869732E246D6F64656C2E70726F706572746965732E67657428746869732C206E616D65293B5C6E7D3B5C6E5C6E426173652E70726F746F747970652E736574203D2066756E6374696F6E286E';
wwv_flow_imp.g_varchar2_table(7952) := '616D652C2076616C756529207B5C6E2020746869732E246D6F64656C2E70726F706572746965732E73657428746869732C206E616D652C2076616C7565293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2041206D6F64656C20656C656D656E7420666163746F';
wwv_flow_imp.g_varchar2_table(7953) := '72792E5C6E202A5C6E202A2040706172616D207B4D6F64646C657D206D6F64656C5C6E202A2040706172616D207B50726F706572746965737D2070726F706572746965735C6E202A2F5C6E66756E6374696F6E20466163746F7279286D6F64656C2C2070';
wwv_flow_imp.g_varchar2_table(7954) := '726F7065727469657329207B5C6E2020746869732E6D6F64656C203D206D6F64656C3B5C6E2020746869732E70726F70657274696573203D2070726F706572746965733B5C6E7D5C6E5C6E5C6E466163746F72792E70726F746F747970652E6372656174';
wwv_flow_imp.g_varchar2_table(7955) := '6554797065203D2066756E6374696F6E2864657363726970746F7229207B5C6E5C6E2020766172206D6F64656C203D20746869732E6D6F64656C3B5C6E5C6E20207661722070726F7073203D20746869732E70726F706572746965732C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(7956) := '2070726F746F74797065203D204F626A6563742E63726561746528426173652E70726F746F74797065293B5C6E5C6E20202F2F20696E697469616C697A652064656661756C742076616C7565735C6E2020666F72456163682864657363726970746F722E';
wwv_flow_imp.g_varchar2_table(7957) := '70726F706572746965732C2066756E6374696F6E287029207B5C6E202020206966202821702E69734D616E7920262620702E64656661756C7420213D3D20756E646566696E656429207B5C6E20202020202070726F746F747970655B702E6E616D655D20';
wwv_flow_imp.g_varchar2_table(7958) := '3D20702E64656661756C743B5C6E202020207D5C6E20207D293B5C6E5C6E202070726F70732E646566696E654D6F64656C2870726F746F747970652C206D6F64656C293B5C6E202070726F70732E646566696E6544657363726970746F722870726F746F';
wwv_flow_imp.g_varchar2_table(7959) := '747970652C2064657363726970746F72293B5C6E5C6E2020766172206E616D65203D2064657363726970746F722E6E732E6E616D653B5C6E5C6E20202F2A2A5C6E2020202A20546865206E6577207479706520636F6E7374727563746F725C6E2020202A';
wwv_flow_imp.g_varchar2_table(7960) := '2F5C6E202066756E6374696F6E204D6F64646C65456C656D656E7428617474727329207B5C6E2020202070726F70732E646566696E6528746869732C20272474797065272C207B2076616C75653A206E616D652C20656E756D657261626C653A20747275';
wwv_flow_imp.g_varchar2_table(7961) := '65207D293B5C6E2020202070726F70732E646566696E6528746869732C2027246174747273272C207B2076616C75653A207B7D207D293B5C6E2020202070726F70732E646566696E6528746869732C202724706172656E74272C207B207772697461626C';
wwv_flow_imp.g_varchar2_table(7962) := '653A2074727565207D293B5C6E5C6E20202020666F72456163682861747472732C2062696E642866756E6374696F6E2876616C2C206B657929207B5C6E202020202020746869732E736574286B65792C2076616C293B5C6E202020207D2C207468697329';
wwv_flow_imp.g_varchar2_table(7963) := '293B5C6E20207D5C6E5C6E20204D6F64646C65456C656D656E742E70726F746F74797065203D2070726F746F747970653B5C6E5C6E20204D6F64646C65456C656D656E742E68617354797065203D2070726F746F747970652E24696E7374616E63654F66';
wwv_flow_imp.g_varchar2_table(7964) := '203D20746869732E6D6F64656C2E686173547970653B5C6E5C6E20202F2F20737461746963206C696E6B735C6E202070726F70732E646566696E654D6F64656C284D6F64646C65456C656D656E742C206D6F64656C293B5C6E202070726F70732E646566';
wwv_flow_imp.g_varchar2_table(7965) := '696E6544657363726970746F72284D6F64646C65456C656D656E742C2064657363726970746F72293B5C6E5C6E202072657475726E204D6F64646C65456C656D656E743B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204275696C742D696E206D6F64646C6520';
wwv_flow_imp.g_varchar2_table(7966) := '74797065735C6E202A2F5C6E766172204255494C54494E53203D207B5C6E2020537472696E673A20747275652C5C6E2020426F6F6C65616E3A20747275652C5C6E2020496E74656765723A20747275652C5C6E20205265616C3A20747275652C5C6E2020';
wwv_flow_imp.g_varchar2_table(7967) := '456C656D656E743A20747275655C6E7D3B5C6E5C6E2F2A2A5C6E202A20436F6E7665727465727320666F72206275696C7420696E2074797065732066726F6D20737472696E6720726570726573656E746174696F6E735C6E202A2F5C6E76617220545950';
wwv_flow_imp.g_varchar2_table(7968) := '455F434F4E56455254455253203D207B5C6E2020537472696E673A2066756E6374696F6E287329207B2072657475726E20733B207D2C5C6E2020426F6F6C65616E3A2066756E6374696F6E287329207B2072657475726E2073203D3D3D20277472756527';
wwv_flow_imp.g_varchar2_table(7969) := '3B207D2C5C6E2020496E74656765723A2066756E6374696F6E287329207B2072657475726E207061727365496E7428732C203130293B207D2C5C6E20205265616C3A2066756E6374696F6E287329207B2072657475726E207061727365466C6F61742873';
wwv_flow_imp.g_varchar2_table(7970) := '293B207D5C6E7D3B5C6E5C6E2F2A2A5C6E202A20436F6E766572742061207479706520746F20697473207265616C20726570726573656E746174696F6E5C6E202A2F5C6E66756E6374696F6E20636F657263655479706528747970652C2076616C756529';
wwv_flow_imp.g_varchar2_table(7971) := '207B5C6E5C6E202076617220636F6E766572746572203D20545950455F434F4E564552544552535B747970655D3B5C6E5C6E202069662028636F6E76657274657229207B5C6E2020202072657475726E20636F6E7665727465722876616C7565293B5C6E';
wwv_flow_imp.g_varchar2_table(7972) := '20207D20656C7365207B5C6E2020202072657475726E2076616C75653B5C6E20207D5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E20776865746865722074686520676976656E2074797065206973206275696C742D696E5C6E202A2F5C6E66756E';
wwv_flow_imp.g_varchar2_table(7973) := '6374696F6E2069734275696C74496E287479706529207B5C6E202072657475726E2021214255494C54494E535B747970655D3B5C6E7D5C6E5C6E2F2A2A5C6E202A2052657475726E20776865746865722074686520676976656E20747970652069732073';
wwv_flow_imp.g_varchar2_table(7974) := '696D706C655C6E202A2F5C6E66756E6374696F6E20697353696D706C65287479706529207B5C6E202072657475726E202121545950455F434F4E564552544552535B747970655D3B5C6E7D5C6E5C6E2F2A2A5C6E202A205061727365732061206E616D65';
wwv_flow_imp.g_varchar2_table(7975) := '73706163656420617474726962757465206E616D65206F662074686520666F726D20286E733A296C6F63616C4E616D6520746F20616E206F626A6563742C5C6E202A20676976656E20612064656661756C742070726566697820746F20617373756D6520';
wwv_flow_imp.g_varchar2_table(7976) := '696E2063617365206E6F206578706C69636974206E616D65737061636520697320676976656E2E5C6E202A5C6E202A2040706172616D207B537472696E677D206E616D655C6E202A2040706172616D207B537472696E677D205B64656661756C74507265';
wwv_flow_imp.g_varchar2_table(7977) := '6669785D207468652064656661756C742070726566697820746F2074616B652C206966206E6F6E652069732070726573656E742E5C6E202A5C6E202A204072657475726E207B4F626A6563747D2074686520706172736564206E616D655C6E202A2F5C6E';
wwv_flow_imp.g_varchar2_table(7978) := '66756E6374696F6E2070617273654E616D65286E616D652C2064656661756C7450726566697829207B5C6E2020766172207061727473203D206E616D652E73706C6974282F3A2F292C5C6E2020202020206C6F63616C4E616D652C207072656669783B5C';
wwv_flow_imp.g_varchar2_table(7979) := '6E5C6E20202F2F206E6F207072656669782028692E652E206F6E6C79206C6F63616C206E616D65295C6E20206966202870617274732E6C656E677468203D3D3D203129207B5C6E202020206C6F63616C4E616D65203D206E616D653B5C6E202020207072';
wwv_flow_imp.g_varchar2_table(7980) := '65666978203D2064656661756C745072656669783B5C6E20207D20656C73655C6E5C6E20202F2F20707265666978202B206C6F63616C206E616D655C6E20206966202870617274732E6C656E677468203D3D3D203229207B5C6E202020206C6F63616C4E';
wwv_flow_imp.g_varchar2_table(7981) := '616D65203D2070617274735B315D3B5C6E20202020707265666978203D2070617274735B305D3B5C6E20207D20656C7365207B5C6E202020207468726F77206E6577204572726F7228276578706563746564203C7072656669783A6C6F63616C4E616D65';
wwv_flow_imp.g_varchar2_table(7982) := '3E206F72203C6C6F63616C4E616D653E2C20676F742027202B206E616D65293B5C6E20207D5C6E5C6E20206E616D65203D2028707265666978203F20707265666978202B20273A27203A20272729202B206C6F63616C4E616D653B5C6E5C6E2020726574';
wwv_flow_imp.g_varchar2_table(7983) := '75726E207B5C6E202020206E616D653A206E616D652C5C6E202020207072656669783A207072656669782C5C6E202020206C6F63616C4E616D653A206C6F63616C4E616D655C6E20207D3B5C6E7D5C6E5C6E2F2A2A5C6E202A2041207574696C69747920';
wwv_flow_imp.g_varchar2_table(7984) := '746F206275696C6420656C656D656E742064657363726970746F72732E5C6E202A2F5C6E66756E6374696F6E2044657363726970746F724275696C646572286E616D654E7329207B5C6E2020746869732E6E73203D206E616D654E733B5C6E2020746869';
wwv_flow_imp.g_varchar2_table(7985) := '732E6E616D65203D206E616D654E732E6E616D653B5C6E2020746869732E616C6C5479706573203D205B5D3B5C6E2020746869732E616C6C547970657342794E616D65203D207B7D3B5C6E2020746869732E70726F70657274696573203D205B5D3B5C6E';
wwv_flow_imp.g_varchar2_table(7986) := '2020746869732E70726F7065727469657342794E616D65203D207B7D3B5C6E7D5C6E5C6E5C6E44657363726970746F724275696C6465722E70726F746F747970652E6275696C64203D2066756E6374696F6E2829207B5C6E202072657475726E20706963';
wwv_flow_imp.g_varchar2_table(7987) := '6B28746869732C205B5C6E20202020276E73272C5C6E20202020276E616D65272C5C6E2020202027616C6C5479706573272C5C6E2020202027616C6C547970657342794E616D65272C5C6E202020202770726F70657274696573272C5C6E202020202770';
wwv_flow_imp.g_varchar2_table(7988) := '726F7065727469657342794E616D65272C5C6E2020202027626F647950726F7065727479272C5C6E2020202027696450726F7065727479275C6E20205D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A204164642070726F706572747920617420676976656E';
wwv_flow_imp.g_varchar2_table(7989) := '20696E6465782E5C6E202A5C6E202A2040706172616D207B4F626A6563747D20705C6E202A2040706172616D207B4E756D6265727D205B6964785D5C6E202A2040706172616D207B426F6F6C65616E7D205B76616C69646174653D747275655D5C6E202A';
wwv_flow_imp.g_varchar2_table(7990) := '2F5C6E44657363726970746F724275696C6465722E70726F746F747970652E61646450726F7065727479203D2066756E6374696F6E28702C206964782C2076616C696461746529207B5C6E5C6E202069662028747970656F6620696478203D3D3D202762';
wwv_flow_imp.g_varchar2_table(7991) := '6F6F6C65616E2729207B5C6E2020202076616C6964617465203D206964783B5C6E20202020696478203D20756E646566696E65643B5C6E20207D5C6E5C6E2020746869732E6164644E616D656450726F706572747928702C2076616C696461746520213D';
wwv_flow_imp.g_varchar2_table(7992) := '3D2066616C7365293B5C6E5C6E20207661722070726F70657274696573203D20746869732E70726F706572746965733B5C6E5C6E20206966202869647820213D3D20756E646566696E656429207B5C6E2020202070726F706572746965732E73706C6963';
wwv_flow_imp.g_varchar2_table(7993) := '65286964782C20302C2070293B5C6E20207D20656C7365207B5C6E2020202070726F706572746965732E707573682870293B5C6E20207D5C6E7D3B5C6E5C6E5C6E44657363726970746F724275696C6465722E70726F746F747970652E7265706C616365';
wwv_flow_imp.g_varchar2_table(7994) := '50726F7065727479203D2066756E6374696F6E286F6C6450726F70657274792C206E657750726F70657274792C207265706C61636529207B5C6E2020766172206F6C644E616D654E73203D206F6C6450726F70657274792E6E733B5C6E5C6E2020766172';
wwv_flow_imp.g_varchar2_table(7995) := '2070726F7073203D20746869732E70726F706572746965732C5C6E20202020202070726F7065727469657342794E616D65203D20746869732E70726F7065727469657342794E616D652C5C6E20202020202072656E616D65203D206F6C6450726F706572';
wwv_flow_imp.g_varchar2_table(7996) := '74792E6E616D6520213D3D206E657750726F70657274792E6E616D653B5C6E5C6E2020696620286F6C6450726F70657274792E6973496429207B5C6E2020202069662028216E657750726F70657274792E6973496429207B5C6E2020202020207468726F';
wwv_flow_imp.g_varchar2_table(7997) := '77206E6577204572726F72285C6E20202020202020202770726F7065727479203C27202B206E657750726F70657274792E6E732E6E616D65202B20273E206D7573742062652069642070726F70657274792027202B5C6E202020202020202027746F2072';
wwv_flow_imp.g_varchar2_table(7998) := '6566696E65203C27202B206F6C6450726F70657274792E6E732E6E616D65202B20273E27293B5C6E202020207D5C6E5C6E20202020746869732E736574496450726F7065727479286E657750726F70657274792C2066616C7365293B5C6E20207D5C6E5C';
wwv_flow_imp.g_varchar2_table(7999) := '6E2020696620286F6C6450726F70657274792E6973426F647929207B5C6E5C6E2020202069662028216E657750726F70657274792E6973426F647929207B5C6E2020202020207468726F77206E6577204572726F72285C6E20202020202020202770726F';
wwv_flow_imp.g_varchar2_table(8000) := '7065727479203C27202B206E657750726F70657274792E6E732E6E616D65202B20273E206D75737420626520626F64792070726F70657274792027202B5C6E202020202020202027746F20726566696E65203C27202B206F6C6450726F70657274792E6E';
wwv_flow_imp.g_varchar2_table(8001) := '732E6E616D65202B20273E27293B5C6E202020207D5C6E5C6E202020202F2F20544F444F3A20436865636B20636F6D7061746962696C6974795C6E20202020746869732E736574426F647950726F7065727479286E657750726F70657274792C2066616C';
wwv_flow_imp.g_varchar2_table(8002) := '7365293B5C6E20207D5C6E5C6E20202F2F2076616C6964617465206578697374656E636520616E6420676574206C6F636174696F6E206F66206F6C642070726F70657274795C6E202076617220696478203D2070726F70732E696E6465784F66286F6C64';
wwv_flow_imp.g_varchar2_table(8003) := '50726F7065727479293B5C6E202069662028696478203D3D3D202D3129207B5C6E202020207468726F77206E6577204572726F72282770726F7065727479203C27202B206F6C644E616D654E732E6E616D65202B20273E206E6F7420666F756E6420696E';
wwv_flow_imp.g_varchar2_table(8004) := '2070726F7065727479206C69737427293B5C6E20207D5C6E5C6E20202F2F2072656D6F7665206F6C642070726F70657274795C6E202070726F70732E73706C696365286964782C2031293B5C6E5C6E20202F2F207265706C6163696E6720746865206E61';
wwv_flow_imp.g_varchar2_table(8005) := '6D65642070726F706572747920697320696E74656E74696F6E616C5C6E20202F2F5C6E20202F2F20202A2076616C6964617465206F6E6C7920696620746869732069732061205C2272656E616D655C22206F7065726174696F6E5C6E20202F2F20202A20';
wwv_flow_imp.g_varchar2_table(8006) := '61646420617420737065636966696320696E64657820756E6C657373207765205C227265706C6163655C225C6E20202F2F5C6E2020746869732E61646450726F7065727479286E657750726F70657274792C207265706C616365203F20756E646566696E';
wwv_flow_imp.g_varchar2_table(8007) := '6564203A206964782C2072656E616D65293B5C6E5C6E20202F2F206D616B65206E65772070726F706572747920617661696C61626C6520756E646572206F6C64206E616D655C6E202070726F7065727469657342794E616D655B6F6C644E616D654E732E';
wwv_flow_imp.g_varchar2_table(8008) := '6E616D655D203D2070726F7065727469657342794E616D655B6F6C644E616D654E732E6C6F63616C4E616D655D203D206E657750726F70657274793B5C6E7D3B5C6E5C6E5C6E44657363726970746F724275696C6465722E70726F746F747970652E7265';
wwv_flow_imp.g_varchar2_table(8009) := '646566696E6550726F7065727479203D2066756E6374696F6E28702C2074617267657450726F70657274794E616D652C207265706C61636529207B5C6E5C6E2020766172206E73507265666978203D20702E6E732E7072656669783B5C6E202076617220';
wwv_flow_imp.g_varchar2_table(8010) := '7061727473203D2074617267657450726F70657274794E616D652E73706C697428272327293B5C6E5C6E2020766172206E616D65203D2070617273654E616D652870617274735B305D2C206E73507265666978293B5C6E202076617220617474724E616D';
wwv_flow_imp.g_varchar2_table(8011) := '65203D2070617273654E616D652870617274735B315D2C206E616D652E707265666978292E6E616D653B5C6E5C6E2020766172207265646566696E656450726F7065727479203D20746869732E70726F7065727469657342794E616D655B617474724E61';
wwv_flow_imp.g_varchar2_table(8012) := '6D655D3B5C6E202069662028217265646566696E656450726F706572747929207B5C6E202020207468726F77206E6577204572726F722827726566696E65642070726F7065727479203C27202B20617474724E616D65202B20273E206E6F7420666F756E';
wwv_flow_imp.g_varchar2_table(8013) := '6427293B5C6E20207D20656C7365207B5C6E20202020746869732E7265706C61636550726F7065727479287265646566696E656450726F70657274792C20702C207265706C616365293B5C6E20207D5C6E5C6E202064656C65746520702E726564656669';
wwv_flow_imp.g_varchar2_table(8014) := '6E65733B5C6E7D3B5C6E5C6E44657363726970746F724275696C6465722E70726F746F747970652E6164644E616D656450726F7065727479203D2066756E6374696F6E28702C2076616C696461746529207B5C6E2020766172206E73203D20702E6E732C';
wwv_flow_imp.g_varchar2_table(8015) := '5C6E20202020202070726F707342794E616D65203D20746869732E70726F7065727469657342794E616D653B5C6E5C6E20206966202876616C696461746529207B5C6E20202020746869732E6173736572744E6F74446566696E656428702C206E732E6E';
wwv_flow_imp.g_varchar2_table(8016) := '616D65293B5C6E20202020746869732E6173736572744E6F74446566696E656428702C206E732E6C6F63616C4E616D65293B5C6E20207D5C6E5C6E202070726F707342794E616D655B6E732E6E616D655D203D2070726F707342794E616D655B6E732E6C';
wwv_flow_imp.g_varchar2_table(8017) := '6F63616C4E616D655D203D20703B5C6E7D3B5C6E5C6E44657363726970746F724275696C6465722E70726F746F747970652E72656D6F76654E616D656450726F7065727479203D2066756E6374696F6E287029207B5C6E2020766172206E73203D20702E';
wwv_flow_imp.g_varchar2_table(8018) := '6E732C5C6E20202020202070726F707342794E616D65203D20746869732E70726F7065727469657342794E616D653B5C6E5C6E202064656C6574652070726F707342794E616D655B6E732E6E616D655D3B5C6E202064656C6574652070726F707342794E';
wwv_flow_imp.g_varchar2_table(8019) := '616D655B6E732E6C6F63616C4E616D655D3B5C6E7D3B5C6E5C6E44657363726970746F724275696C6465722E70726F746F747970652E736574426F647950726F7065727479203D2066756E6374696F6E28702C2076616C696461746529207B5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(8020) := '206966202876616C696461746520262620746869732E626F647950726F706572747929207B5C6E202020207468726F77206E6577204572726F72285C6E20202020202027626F64792070726F706572747920646566696E6564206D756C7469706C652074';
wwv_flow_imp.g_varchar2_table(8021) := '696D65732027202B5C6E20202020202027283C27202B20746869732E626F647950726F70657274792E6E732E6E616D65202B20273E2C203C27202B20702E6E732E6E616D65202B20273E2927293B5C6E20207D5C6E5C6E2020746869732E626F64795072';
wwv_flow_imp.g_varchar2_table(8022) := '6F7065727479203D20703B5C6E7D3B5C6E5C6E44657363726970746F724275696C6465722E70726F746F747970652E736574496450726F7065727479203D2066756E6374696F6E28702C2076616C696461746529207B5C6E5C6E20206966202876616C69';
wwv_flow_imp.g_varchar2_table(8023) := '6461746520262620746869732E696450726F706572747929207B5C6E202020207468726F77206E6577204572726F72285C6E2020202020202769642070726F706572747920646566696E6564206D756C7469706C652074696D65732027202B5C6E202020';
wwv_flow_imp.g_varchar2_table(8024) := '20202027283C27202B20746869732E696450726F70657274792E6E732E6E616D65202B20273E2C203C27202B20702E6E732E6E616D65202B20273E2927293B5C6E20207D5C6E5C6E2020746869732E696450726F7065727479203D20703B5C6E7D3B5C6E';
wwv_flow_imp.g_varchar2_table(8025) := '5C6E44657363726970746F724275696C6465722E70726F746F747970652E6173736572744E6F745472616974203D2066756E6374696F6E287479706544657363726970746F7229207B5C6E5C6E2020636F6E7374205F657874656E6473203D2074797065';
wwv_flow_imp.g_varchar2_table(8026) := '44657363726970746F722E657874656E6473207C7C205B5D3B5C6E5C6E2020696620285F657874656E64732E6C656E67746829207B5C6E202020207468726F77206E6577204572726F72285C6E2020202020206063616E6E6F7420637265617465203C24';
wwv_flow_imp.g_varchar2_table(8027) := '7B207479706544657363726970746F722E6E616D65207D3E20657874656E64696E67203C247B207479706544657363726970746F722E657874656E6473207D3E605C6E20202020293B5C6E20207D5C6E7D3B5C6E5C6E44657363726970746F724275696C';
wwv_flow_imp.g_varchar2_table(8028) := '6465722E70726F746F747970652E6173736572744E6F74446566696E6564203D2066756E6374696F6E28702C206E616D6529207B5C6E20207661722070726F70657274794E616D65203D20702E6E616D652C5C6E202020202020646566696E656450726F';
wwv_flow_imp.g_varchar2_table(8029) := '7065727479203D20746869732E70726F7065727469657342794E616D655B70726F70657274794E616D655D3B5C6E5C6E202069662028646566696E656450726F706572747929207B5C6E202020207468726F77206E6577204572726F72285C6E20202020';
wwv_flow_imp.g_varchar2_table(8030) := '20202770726F7065727479203C27202B2070726F70657274794E616D65202B20273E20616C726561647920646566696E65643B2027202B5C6E202020202020276F76657272696465206F66203C27202B20646566696E656450726F70657274792E646566';
wwv_flow_imp.g_varchar2_table(8031) := '696E656442792E6E732E6E616D65202B20272327202B20646566696E656450726F70657274792E6E732E6E616D65202B20273E2062792027202B5C6E202020202020273C27202B20702E646566696E656442792E6E732E6E616D65202B20272327202B20';
wwv_flow_imp.g_varchar2_table(8032) := '702E6E732E6E616D65202B20273E206E6F7420616C6C6F77656420776974686F7574207265646566696E657327293B5C6E20207D5C6E7D3B5C6E5C6E44657363726970746F724275696C6465722E70726F746F747970652E68617350726F706572747920';
wwv_flow_imp.g_varchar2_table(8033) := '3D2066756E6374696F6E286E616D6529207B5C6E202072657475726E20746869732E70726F7065727469657342794E616D655B6E616D655D3B5C6E7D3B5C6E5C6E44657363726970746F724275696C6465722E70726F746F747970652E61646454726169';
wwv_flow_imp.g_varchar2_table(8034) := '74203D2066756E6374696F6E28742C20696E6865726974656429207B5C6E5C6E202069662028696E6865726974656429207B5C6E20202020746869732E6173736572744E6F7454726169742874293B5C6E20207D5C6E5C6E202076617220747970657342';
wwv_flow_imp.g_varchar2_table(8035) := '794E616D65203D20746869732E616C6C547970657342794E616D652C5C6E2020202020207479706573203D20746869732E616C6C54797065733B5C6E5C6E202076617220747970654E616D65203D20742E6E616D653B5C6E5C6E20206966202874797065';
wwv_flow_imp.g_varchar2_table(8036) := '4E616D6520696E20747970657342794E616D6529207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020666F724561636828742E70726F706572746965732C2062696E642866756E6374696F6E287029207B5C6E5C6E202020202F2F20636C6F';
wwv_flow_imp.g_varchar2_table(8037) := '6E652070726F706572747920746F20616C6C6F7720657874656E73696F6E735C6E2020202070203D2061737369676E287B7D2C20702C207B5C6E2020202020206E616D653A20702E6E732E6C6F63616C4E616D652C5C6E202020202020696E6865726974';
wwv_flow_imp.g_varchar2_table(8038) := '65643A20696E686572697465645C6E202020207D293B5C6E5C6E202020204F626A6563742E646566696E6550726F706572747928702C2027646566696E65644279272C207B5C6E20202020202076616C75653A20745C6E202020207D293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(8039) := '2020766172207265706C61636573203D20702E7265706C616365732C5C6E20202020202020207265646566696E6573203D20702E7265646566696E65733B5C6E5C6E202020202F2F20616464207265706C6163652F7265646566696E6520737570706F72';
wwv_flow_imp.g_varchar2_table(8040) := '745C6E20202020696620287265706C61636573207C7C207265646566696E657329207B5C6E202020202020746869732E7265646566696E6550726F706572747928702C207265706C61636573207C7C207265646566696E65732C207265706C6163657329';
wwv_flow_imp.g_varchar2_table(8041) := '3B5C6E202020207D20656C7365207B5C6E20202020202069662028702E6973426F647929207B5C6E2020202020202020746869732E736574426F647950726F70657274792870293B5C6E2020202020207D5C6E20202020202069662028702E6973496429';
wwv_flow_imp.g_varchar2_table(8042) := '207B5C6E2020202020202020746869732E736574496450726F70657274792870293B5C6E2020202020207D5C6E202020202020746869732E61646450726F70657274792870293B5C6E202020207D5C6E20207D2C207468697329293B5C6E5C6E20207479';
wwv_flow_imp.g_varchar2_table(8043) := '7065732E707573682874293B5C6E2020747970657342794E616D655B747970654E616D655D203D20743B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2041207265676973747279206F66204D6F64646C65207061636B616765732E5C6E202A5C6E202A20407061';
wwv_flow_imp.g_varchar2_table(8044) := '72616D207B41727261793C5061636B6167653E7D207061636B616765735C6E202A2040706172616D207B50726F706572746965737D2070726F706572746965735C6E202A2F5C6E66756E6374696F6E205265676973747279287061636B616765732C2070';
wwv_flow_imp.g_varchar2_table(8045) := '726F7065727469657329207B5C6E2020746869732E7061636B6167654D6170203D207B7D3B5C6E2020746869732E747970654D6170203D207B7D3B5C6E5C6E2020746869732E7061636B61676573203D205B5D3B5C6E5C6E2020746869732E70726F7065';
wwv_flow_imp.g_varchar2_table(8046) := '7274696573203D2070726F706572746965733B5C6E5C6E2020666F7245616368287061636B616765732C2062696E6428746869732E72656769737465725061636B6167652C207468697329293B5C6E7D5C6E5C6E5C6E52656769737472792E70726F746F';
wwv_flow_imp.g_varchar2_table(8047) := '747970652E6765745061636B616765203D2066756E6374696F6E287572694F7250726566697829207B5C6E202072657475726E20746869732E7061636B6167654D61705B7572694F725072656669785D3B5C6E7D3B5C6E5C6E52656769737472792E7072';
wwv_flow_imp.g_varchar2_table(8048) := '6F746F747970652E6765745061636B61676573203D2066756E6374696F6E2829207B5C6E202072657475726E20746869732E7061636B616765733B5C6E7D3B5C6E5C6E5C6E52656769737472792E70726F746F747970652E72656769737465725061636B';
wwv_flow_imp.g_varchar2_table(8049) := '616765203D2066756E6374696F6E28706B6729207B5C6E5C6E20202F2F20636F7079207061636B6167655C6E2020706B67203D2061737369676E287B7D2C20706B67293B5C6E5C6E202076617220706B674D6170203D20746869732E7061636B6167654D';
wwv_flow_imp.g_varchar2_table(8050) := '61703B5C6E5C6E2020656E73757265417661696C61626C6528706B674D61702C20706B672C202770726566697827293B5C6E2020656E73757265417661696C61626C6528706B674D61702C20706B672C202775726927293B5C6E5C6E20202F2F20726567';
wwv_flow_imp.g_varchar2_table(8051) := '69737465722074797065735C6E2020666F724561636828706B672E74797065732C2062696E642866756E6374696F6E2864657363726970746F7229207B5C6E20202020746869732E7265676973746572547970652864657363726970746F722C20706B67';
wwv_flow_imp.g_varchar2_table(8052) := '293B5C6E20207D2C207468697329293B5C6E5C6E2020706B674D61705B706B672E7572695D203D20706B674D61705B706B672E7072656669785D203D20706B673B5C6E2020746869732E7061636B616765732E7075736828706B67293B5C6E7D3B5C6E5C';
wwv_flow_imp.g_varchar2_table(8053) := '6E5C6E2F2A2A5C6E202A205265676973746572206120747970652066726F6D2061207370656369666963207061636B61676520776974682075735C6E202A2F5C6E52656769737472792E70726F746F747970652E726567697374657254797065203D2066';
wwv_flow_imp.g_varchar2_table(8054) := '756E6374696F6E28747970652C20706B6729207B5C6E5C6E202074797065203D2061737369676E287B7D2C20747970652C207B5C6E202020207375706572436C6173733A2028747970652E7375706572436C617373207C7C205B5D292E736C6963652829';
wwv_flow_imp.g_varchar2_table(8055) := '2C5C6E20202020657874656E64733A2028747970652E657874656E6473207C7C205B5D292E736C69636528292C5C6E2020202070726F706572746965733A2028747970652E70726F70657274696573207C7C205B5D292E736C69636528292C5C6E202020';
wwv_flow_imp.g_varchar2_table(8056) := '206D6574613A2061737369676E2828747970652E6D657461207C7C207B7D29295C6E20207D293B5C6E5C6E2020766172206E73203D2070617273654E616D6528747970652E6E616D652C20706B672E707265666978292C5C6E2020202020206E616D6520';
wwv_flow_imp.g_varchar2_table(8057) := '3D206E732E6E616D652C5C6E20202020202070726F7065727469657342794E616D65203D207B7D3B5C6E5C6E20202F2F2070617273652070726F706572746965735C6E2020666F724561636828747970652E70726F706572746965732C2062696E642866';
wwv_flow_imp.g_varchar2_table(8058) := '756E6374696F6E287029207B5C6E5C6E202020202F2F206E616D6573706163652070726F7065727479206E616D65735C6E202020207661722070726F70657274794E73203D2070617273654E616D6528702E6E616D652C206E732E707265666978292C5C';
wwv_flow_imp.g_varchar2_table(8059) := '6E202020202020202070726F70657274794E616D65203D2070726F70657274794E732E6E616D653B5C6E5C6E202020202F2F206E616D6573706163652070726F70657274792074797065735C6E20202020696620282169734275696C74496E28702E7479';
wwv_flow_imp.g_varchar2_table(8060) := '70652929207B5C6E202020202020702E74797065203D2070617273654E616D6528702E747970652C2070726F70657274794E732E707265666978292E6E616D653B5C6E202020207D5C6E5C6E2020202061737369676E28702C207B5C6E2020202020206E';
wwv_flow_imp.g_varchar2_table(8061) := '733A2070726F70657274794E732C5C6E2020202020206E616D653A2070726F70657274794E616D655C6E202020207D293B5C6E5C6E2020202070726F7065727469657342794E616D655B70726F70657274794E616D655D203D20703B5C6E20207D2C2074';
wwv_flow_imp.g_varchar2_table(8062) := '68697329293B5C6E5C6E20202F2F20757064617465206E73202B206E616D655C6E202061737369676E28747970652C207B5C6E202020206E733A206E732C5C6E202020206E616D653A206E616D652C5C6E2020202070726F7065727469657342794E616D';
wwv_flow_imp.g_varchar2_table(8063) := '653A2070726F7065727469657342794E616D655C6E20207D293B5C6E5C6E2020666F724561636828747970652E657874656E64732C2062696E642866756E6374696F6E28657874656E64734E616D6529207B5C6E2020202076617220657874656E64734E';
wwv_flow_imp.g_varchar2_table(8064) := '616D654E73203D2070617273654E616D6528657874656E64734E616D652C206E732E707265666978293B5C6E5C6E2020202076617220657874656E646564203D20746869732E747970654D61705B657874656E64734E616D654E732E6E616D655D3B5C6E';
wwv_flow_imp.g_varchar2_table(8065) := '5C6E20202020657874656E6465642E747261697473203D20657874656E6465642E747261697473207C7C205B5D3B5C6E20202020657874656E6465642E7472616974732E70757368286E616D65293B5C6E20207D2C207468697329293B5C6E5C6E20202F';
wwv_flow_imp.g_varchar2_table(8066) := '2F206C696E6B20746F207061636B6167655C6E2020746869732E646566696E655061636B61676528747970652C20706B67293B5C6E5C6E20202F2F2072656769737465725C6E2020746869732E747970654D61705B6E616D655D203D20747970653B5C6E';
wwv_flow_imp.g_varchar2_table(8067) := '7D3B5C6E5C6E5C6E2F2A2A5C6E202A205472617665727365207468652074797065206869657261726368792066726F6D20626F74746F6D20746F20746F702C5C6E202A2063616C6C696E67206974657261746F7220776974682028747970652C20696E68';
wwv_flow_imp.g_varchar2_table(8068) := '6572697465642920666F7220616C6C20656C656D656E747320696E5C6E202A2074686520696E6865726974616E636520636861696E2E5C6E202A5C6E202A2040706172616D207B4F626A6563747D206E734E616D655C6E202A2040706172616D207B4675';
wwv_flow_imp.g_varchar2_table(8069) := '6E6374696F6E7D206974657261746F725C6E202A2040706172616D207B426F6F6C65616E7D205B74726169743D66616C73655D5C6E202A2F5C6E52656769737472792E70726F746F747970652E6D61705479706573203D2066756E6374696F6E286E734E';
wwv_flow_imp.g_varchar2_table(8070) := '616D652C206974657261746F722C20747261697429207B5C6E5C6E20207661722074797065203D2069734275696C74496E286E734E616D652E6E616D6529203F207B206E616D653A206E734E616D652E6E616D65207D203A20746869732E747970654D61';
wwv_flow_imp.g_varchar2_table(8071) := '705B6E734E616D652E6E616D655D3B5C6E5C6E20207661722073656C66203D20746869733B5C6E5C6E20202F2A2A5C6E2020202A205472617665727365207468652073656C65637465642073757065722074797065206F722074726169745C6E2020202A';
wwv_flow_imp.g_varchar2_table(8072) := '5C6E2020202A2040706172616D207B537472696E677D20636C735C6E2020202A2040706172616D207B426F6F6C65616E7D205B74726169743D66616C73655D5C6E2020202A2F5C6E202066756E6374696F6E20747261766572736528636C732C20747261';
wwv_flow_imp.g_varchar2_table(8073) := '697429207B5C6E2020202076617220706172656E744E73203D2070617273654E616D6528636C732C2069734275696C74496E28636C7329203F202727203A206E734E616D652E707265666978293B5C6E2020202073656C662E6D61705479706573287061';
wwv_flow_imp.g_varchar2_table(8074) := '72656E744E732C206974657261746F722C207472616974293B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A205472617665727365207468652073656C65637465642074726169742E5C6E2020202A5C6E2020202A2040706172616D207B537472696E';
wwv_flow_imp.g_varchar2_table(8075) := '677D20636C735C6E2020202A2F5C6E202066756E6374696F6E207472617665727365547261697428636C7329207B5C6E2020202072657475726E20747261766572736528636C732C2074727565293B5C6E20207D5C6E5C6E20202F2A2A5C6E2020202A20';
wwv_flow_imp.g_varchar2_table(8076) := '5472617665727365207468652073656C656374656420737570657220747970655C6E2020202A5C6E2020202A2040706172616D207B537472696E677D20636C735C6E2020202A2F5C6E202066756E6374696F6E207472617665727365537570657228636C';
wwv_flow_imp.g_varchar2_table(8077) := '7329207B5C6E2020202072657475726E20747261766572736528636C732C2066616C7365293B5C6E20207D5C6E5C6E202069662028217479706529207B5C6E202020207468726F77206E6577204572726F722827756E6B6E6F776E2074797065203C2720';
wwv_flow_imp.g_varchar2_table(8078) := '2B206E734E616D652E6E616D65202B20273E27293B5C6E20207D5C6E5C6E2020666F724561636828747970652E7375706572436C6173732C207472616974203F2074726176657273655472616974203A2074726176657273655375706572293B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(8079) := '20202F2F2063616C6C206974657261746F7220776974682028747970652C20696E686572697465643D217472616974295C6E20206974657261746F7228747970652C20217472616974293B5C6E5C6E2020666F724561636828747970652E747261697473';
wwv_flow_imp.g_varchar2_table(8080) := '2C2074726176657273655472616974293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A2052657475726E7320746865206566666563746976652064657363726970746F7220666F72206120747970652E5C6E202A5C6E202A2040706172616D20207B537472';
wwv_flow_imp.g_varchar2_table(8081) := '696E677D207479706520746865206E616D65737061636564206E616D6520286E733A6C6F63616C4E616D6529206F662074686520747970655C6E202A5C6E202A204072657475726E207B44657363726970746F727D2074686520726573756C74696E6720';
wwv_flow_imp.g_varchar2_table(8082) := '6566666563746976652064657363726970746F725C6E202A2F5C6E52656769737472792E70726F746F747970652E67657445666665637469766544657363726970746F72203D2066756E6374696F6E286E616D6529207B5C6E5C6E2020766172206E734E';
wwv_flow_imp.g_varchar2_table(8083) := '616D65203D2070617273654E616D65286E616D65293B5C6E5C6E2020766172206275696C646572203D206E65772044657363726970746F724275696C646572286E734E616D65293B5C6E5C6E2020746869732E6D61705479706573286E734E616D652C20';
wwv_flow_imp.g_varchar2_table(8084) := '66756E6374696F6E28747970652C20696E6865726974656429207B5C6E202020206275696C6465722E616464547261697428747970652C20696E68657269746564293B5C6E20207D293B5C6E5C6E20207661722064657363726970746F72203D20627569';
wwv_flow_imp.g_varchar2_table(8085) := '6C6465722E6275696C6428293B5C6E5C6E20202F2F20646566696E65207061636B616765206C696E6B5C6E2020746869732E646566696E655061636B6167652864657363726970746F722C2064657363726970746F722E616C6C54797065735B64657363';
wwv_flow_imp.g_varchar2_table(8086) := '726970746F722E616C6C54797065732E6C656E677468202D20315D2E24706B67293B5C6E5C6E202072657475726E2064657363726970746F723B5C6E7D3B5C6E5C6E5C6E52656769737472792E70726F746F747970652E646566696E655061636B616765';
wwv_flow_imp.g_varchar2_table(8087) := '203D2066756E6374696F6E287461726765742C20706B6729207B5C6E2020746869732E70726F706572746965732E646566696E65287461726765742C202724706B67272C207B2076616C75653A20706B67207D293B5C6E7D3B5C6E5C6E5C6E5C6E2F2F20';
wwv_flow_imp.g_varchar2_table(8088) := '68656C70657273202F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E66756E6374696F6E20656E73757265417661696C61626C65287061636B6167654D61702C20706B672C206964656E7469666965724B657929207B5C6E';
wwv_flow_imp.g_varchar2_table(8089) := '5C6E20207661722076616C7565203D20706B675B6964656E7469666965724B65795D3B5C6E5C6E20206966202876616C756520696E207061636B6167654D617029207B5C6E202020207468726F77206E6577204572726F7228277061636B616765207769';
wwv_flow_imp.g_varchar2_table(8090) := '74682027202B206964656E7469666965724B6579202B2027203C27202B2076616C7565202B20273E20616C726561647920646566696E656427293B5C6E20207D5C6E7D5C6E5C6E2F2A2A5C6E202A2041207574696C697479207468617420676574732061';
wwv_flow_imp.g_varchar2_table(8091) := '6E6420736574732070726F70657274696573206F66206D6F64656C20656C656D656E74732E5C6E202A5C6E202A2040706172616D207B4D6F64656C7D206D6F64656C5C6E202A2F5C6E66756E6374696F6E2050726F70657274696573286D6F64656C2920';
wwv_flow_imp.g_varchar2_table(8092) := '7B5C6E2020746869732E6D6F64656C203D206D6F64656C3B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A20536574732061206E616D65642070726F7065727479206F6E207468652074617267657420656C656D656E742E5C6E202A204966207468652076616C';
wwv_flow_imp.g_varchar2_table(8093) := '756520697320756E646566696E65642C207468652070726F706572747920676574732064656C657465642E5C6E202A5C6E202A2040706172616D207B4F626A6563747D207461726765745C6E202A2040706172616D207B537472696E677D206E616D655C';
wwv_flow_imp.g_varchar2_table(8094) := '6E202A2040706172616D207B4F626A6563747D2076616C75655C6E202A2F5C6E50726F706572746965732E70726F746F747970652E736574203D2066756E6374696F6E287461726765742C206E616D652C2076616C756529207B5C6E5C6E202069662028';
wwv_flow_imp.g_varchar2_table(8095) := '216973537472696E67286E616D6529207C7C20216E616D652E6C656E67746829207B5C6E202020207468726F77206E657720547970654572726F72282770726F7065727479206E616D65206D7573742062652061206E6F6E2D656D70747920737472696E';
wwv_flow_imp.g_varchar2_table(8096) := '6727293B5C6E20207D5C6E5C6E20207661722070726F7065727479203D20746869732E67657450726F7065727479287461726765742C206E616D65293B5C6E5C6E20207661722070726F70657274794E616D65203D2070726F7065727479202626207072';
wwv_flow_imp.g_varchar2_table(8097) := '6F70657274792E6E616D653B5C6E5C6E2020696620286973556E646566696E65642876616C75652929207B5C6E5C6E202020202F2F20756E736574207468652070726F70657274792C20696620746865207370656369666965642076616C756520697320';
wwv_flow_imp.g_varchar2_table(8098) := '756E646566696E65643B5C6E202020202F2F2064656C6574652066726F6D202461747472732028666F7220657874656E73696F6E7329206F72207468652074617267657420697473656C665C6E202020206966202870726F706572747929207B5C6E2020';
wwv_flow_imp.g_varchar2_table(8099) := '2020202064656C657465207461726765745B70726F70657274794E616D655D3B5C6E202020207D20656C7365207B5C6E20202020202064656C657465207461726765742E2461747472735B7374726970476C6F62616C286E616D65295D3B5C6E20202020';
wwv_flow_imp.g_varchar2_table(8100) := '7D5C6E20207D20656C7365207B5C6E5C6E202020202F2F20736574207468652070726F70657274792C20646566696E696E672077656C6C20646566696E65642070726F70657274696573206F6E2074686520666C795C6E202020202F2F206F722073696D';
wwv_flow_imp.g_varchar2_table(8101) := '706C79207570646174696E67207468656D20696E207461726765742E2461747472732028666F7220657874656E73696F6E73295C6E202020206966202870726F706572747929207B5C6E2020202020206966202870726F70657274794E616D6520696E20';
wwv_flow_imp.g_varchar2_table(8102) := '74617267657429207B5C6E20202020202020207461726765745B70726F70657274794E616D655D203D2076616C75653B5C6E2020202020207D20656C7365207B5C6E2020202020202020646566696E6550726F7065727479287461726765742C2070726F';
wwv_flow_imp.g_varchar2_table(8103) := '70657274792C2076616C7565293B5C6E2020202020207D5C6E202020207D20656C7365207B5C6E2020202020207461726765742E2461747472735B7374726970476C6F62616C286E616D65295D203D2076616C75653B5C6E202020207D5C6E20207D5C6E';
wwv_flow_imp.g_varchar2_table(8104) := '7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E7320746865206E616D65642070726F7065727479206F662074686520676976656E20656C656D656E745C6E202A5C6E202A2040706172616D20207B4F626A6563747D207461726765745C6E202A204070';
wwv_flow_imp.g_varchar2_table(8105) := '6172616D20207B537472696E677D206E616D655C6E202A5C6E202A204072657475726E207B4F626A6563747D5C6E202A2F5C6E50726F706572746965732E70726F746F747970652E676574203D2066756E6374696F6E287461726765742C206E616D6529';
wwv_flow_imp.g_varchar2_table(8106) := '207B5C6E5C6E20207661722070726F7065727479203D20746869732E67657450726F7065727479287461726765742C206E616D65293B5C6E5C6E2020696620282170726F706572747929207B5C6E2020202072657475726E207461726765742E24617474';
wwv_flow_imp.g_varchar2_table(8107) := '72735B7374726970476C6F62616C286E616D65295D3B5C6E20207D5C6E5C6E20207661722070726F70657274794E616D65203D2070726F70657274792E6E616D653B5C6E5C6E20202F2F20636865636B2069662061636365737320746F20636F6C6C6563';
wwv_flow_imp.g_varchar2_table(8108) := '74696F6E2070726F706572747920616E64206C617A696C7920696E697469616C697A652069745C6E202069662028217461726765745B70726F70657274794E616D655D2026262070726F70657274792E69734D616E7929207B5C6E20202020646566696E';
wwv_flow_imp.g_varchar2_table(8109) := '6550726F7065727479287461726765742C2070726F70657274792C205B5D293B5C6E20207D5C6E5C6E202072657475726E207461726765745B70726F70657274794E616D655D3B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A20446566696E652061207072';
wwv_flow_imp.g_varchar2_table(8110) := '6F7065727479206F6E207468652074617267657420656C656D656E745C6E202A5C6E202A2040706172616D20207B4F626A6563747D207461726765745C6E202A2040706172616D20207B537472696E677D206E616D655C6E202A2040706172616D20207B';
wwv_flow_imp.g_varchar2_table(8111) := '4F626A6563747D206F7074696F6E735C6E202A2F5C6E50726F706572746965732E70726F746F747970652E646566696E65203D2066756E6374696F6E287461726765742C206E616D652C206F7074696F6E7329207B5C6E5C6E202069662028216F707469';
wwv_flow_imp.g_varchar2_table(8112) := '6F6E732E7772697461626C6529207B5C6E5C6E202020207661722076616C7565203D206F7074696F6E732E76616C75653B5C6E5C6E202020202F2F20757365206765747465727320666F7220726561642D6F6E6C79207661726961626C657320746F2073';
wwv_flow_imp.g_varchar2_table(8113) := '7570706F7274204553362070726F786965735C6E202020202F2F2063662E2068747470733A2F2F6769746875622E636F6D2F62706D6E2D696F2F696E7465726E616C2D646F63732F6973737565732F3338365C6E202020206F7074696F6E73203D206173';
wwv_flow_imp.g_varchar2_table(8114) := '7369676E287B7D2C206F7074696F6E732C207B5C6E2020202020206765743A2066756E6374696F6E2829207B2072657475726E2076616C75653B207D5C6E202020207D293B5C6E5C6E2020202064656C657465206F7074696F6E732E76616C75653B5C6E';
wwv_flow_imp.g_varchar2_table(8115) := '20207D5C6E5C6E20204F626A6563742E646566696E6550726F7065727479287461726765742C206E616D652C206F7074696F6E73293B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A20446566696E65207468652064657363726970746F7220666F7220616E';
wwv_flow_imp.g_varchar2_table(8116) := '20656C656D656E745C6E202A2F5C6E50726F706572746965732E70726F746F747970652E646566696E6544657363726970746F72203D2066756E6374696F6E287461726765742C2064657363726970746F7229207B5C6E2020746869732E646566696E65';
wwv_flow_imp.g_varchar2_table(8117) := '287461726765742C20272464657363726970746F72272C207B2076616C75653A2064657363726970746F72207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20446566696E6520746865206D6F64656C20666F7220616E20656C656D656E745C6E202A2F5C';
wwv_flow_imp.g_varchar2_table(8118) := '6E50726F706572746965732E70726F746F747970652E646566696E654D6F64656C203D2066756E6374696F6E287461726765742C206D6F64656C29207B5C6E2020746869732E646566696E65287461726765742C2027246D6F64656C272C207B2076616C';
wwv_flow_imp.g_varchar2_table(8119) := '75653A206D6F64656C207D293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E2070726F706572747920776974682074686520676976656E206E616D65206F6E2074686520656C656D656E742E5C6E202A5C6E202A2040706172616D207B616E79';
wwv_flow_imp.g_varchar2_table(8120) := '7D207461726765745C6E202A2040706172616D207B737472696E677D206E616D655C6E202A5C6E202A204072657475726E207B6F626A656374207C206E756C6C7D2070726F70657274795C6E202A2F5C6E50726F706572746965732E70726F746F747970';
wwv_flow_imp.g_varchar2_table(8121) := '652E67657450726F7065727479203D2066756E6374696F6E287461726765742C206E616D6529207B5C6E5C6E2020766172206D6F64656C203D20746869732E6D6F64656C3B5C6E5C6E20207661722070726F7065727479203D206D6F64656C2E67657450';
wwv_flow_imp.g_varchar2_table(8122) := '726F706572747944657363726970746F72287461726765742C206E616D65293B5C6E5C6E20206966202870726F706572747929207B5C6E2020202072657475726E2070726F70657274793B5C6E20207D5C6E5C6E2020696620286E616D652E696E636C75';
wwv_flow_imp.g_varchar2_table(8123) := '64657328273A272929207B5C6E2020202072657475726E206E756C6C3B5C6E20207D5C6E5C6E2020636F6E737420737472696374203D206D6F64656C2E636F6E6669672E7374726963743B5C6E5C6E202069662028747970656F66207374726963742021';
wwv_flow_imp.g_varchar2_table(8124) := '3D3D2027756E646566696E65642729207B5C6E20202020636F6E7374206572726F72203D206E657720547970654572726F722860756E6B6E6F776E2070726F7065727479203C247B206E616D65207D3E206F6E203C247B207461726765742E2474797065';
wwv_flow_imp.g_varchar2_table(8125) := '207D3E60293B5C6E5C6E202020206966202873747269637429207B5C6E2020202020207468726F77206572726F723B5C6E202020207D20656C7365207B5C6E5C6E2020202020202F2F2065736C696E742D64697361626C652D6E6578742D6C696E65206E';
wwv_flow_imp.g_varchar2_table(8126) := '6F2D756E6465665C6E202020202020747970656F6620636F6E736F6C6520213D3D2027756E646566696E65642720262620636F6E736F6C652E7761726E286572726F72293B5C6E202020207D5C6E20207D5C6E5C6E202072657475726E206E756C6C3B5C';
wwv_flow_imp.g_varchar2_table(8127) := '6E7D3B5C6E5C6E66756E6374696F6E206973556E646566696E65642876616C29207B5C6E202072657475726E20747970656F662076616C203D3D3D2027756E646566696E6564273B5C6E7D5C6E5C6E66756E6374696F6E20646566696E6550726F706572';
wwv_flow_imp.g_varchar2_table(8128) := '7479287461726765742C2070726F70657274792C2076616C756529207B5C6E20204F626A6563742E646566696E6550726F7065727479287461726765742C2070726F70657274792E6E616D652C207B5C6E20202020656E756D657261626C653A20217072';
wwv_flow_imp.g_varchar2_table(8129) := '6F70657274792E69735265666572656E63652C5C6E202020207772697461626C653A20747275652C5C6E2020202076616C75653A2076616C75652C5C6E20202020636F6E666967757261626C653A20747275655C6E20207D293B5C6E7D5C6E5C6E66756E';
wwv_flow_imp.g_varchar2_table(8130) := '6374696F6E207374726970476C6F62616C286E616D6529207B5C6E202072657475726E206E616D652E7265706C616365282F5E3A2F2C202727293B5C6E7D5C6E5C6E2F2F204D6F64646C6520696D706C656D656E746174696F6E202F2F2F2F2F2F2F2F2F';
wwv_flow_imp.g_varchar2_table(8131) := '2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F2F5C6E5C6E2F2A2A5C6E202A2040636C617373204D6F64646C655C6E202A5C6E202A2041206D6F64656C20746861742063616E20626520757365642074';
wwv_flow_imp.g_varchar2_table(8132) := '6F2063726561746520656C656D656E7473206F66206120737065636966696320747970652E5C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A20766172204D6F64646C65203D207265717569726528276D6F64646C6527293B5C6E202A5C6E';
wwv_flow_imp.g_varchar2_table(8133) := '202A2076617220706B67203D207B5C6E202A2020206E616D653A20276D797061636B616765272C5C6E202A2020207072656669783A20276D79272C5C6E202A20202074797065733A205B5C6E202A20202020207B206E616D653A2027526F6F7427207D5C';
wwv_flow_imp.g_varchar2_table(8134) := '6E202A2020205D5C6E202A207D3B5C6E202A5C6E202A20766172206D6F64646C65203D206E6577204D6F64646C65285B706B675D293B5C6E202A5C6E202A2040706172616D207B41727261793C5061636B6167653E7D207061636B616765732074686520';
wwv_flow_imp.g_varchar2_table(8135) := '7061636B6167657320746F20636F6E7461696E5C6E202A5C6E202A2040706172616D207B207B207374726963743F3A20626F6F6C65616E207D207D205B636F6E6669675D206D6F64646C6520636F6E66696775726174696F6E5C6E202A2F5C6E66756E63';
wwv_flow_imp.g_varchar2_table(8136) := '74696F6E204D6F64646C65287061636B616765732C20636F6E666967203D207B7D29207B5C6E5C6E2020746869732E70726F70657274696573203D206E65772050726F706572746965732874686973293B5C6E5C6E2020746869732E666163746F727920';
wwv_flow_imp.g_varchar2_table(8137) := '3D206E657720466163746F727928746869732C20746869732E70726F70657274696573293B5C6E2020746869732E7265676973747279203D206E6577205265676973747279287061636B616765732C20746869732E70726F70657274696573293B5C6E5C';
wwv_flow_imp.g_varchar2_table(8138) := '6E2020746869732E747970654361636865203D207B7D3B5C6E5C6E2020746869732E636F6E666967203D20636F6E6669673B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2043726561746520616E20696E7374616E6365206F66207468652073706563696669';
wwv_flow_imp.g_varchar2_table(8139) := '656420747970652E5C6E202A5C6E202A20406D6574686F64204D6F64646C65236372656174655C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A2076617220666F6F203D206D6F64646C652E63726561746528276D793A466F6F27293B5C6E';
wwv_flow_imp.g_varchar2_table(8140) := '202A2076617220626172203D206D6F64646C652E63726561746528276D793A426172272C207B2069643A20274241525F3127207D293B5C6E202A5C6E202A2040706172616D20207B537472696E677C4F626A6563747D2064657363726970746F72207468';
wwv_flow_imp.g_varchar2_table(8141) := '6520747970652064657363726970746F72206F72206E616D65206B6E6F7720746F20746865206D6F64656C5C6E202A2040706172616D20207B4F626A6563747D20617474727320202061206E756D626572206F66206174747269627574657320746F2069';
wwv_flow_imp.g_varchar2_table(8142) := '6E697469616C697A6520746865206D6F64656C20696E7374616E636520776974685C6E202A204072657475726E207B4F626A6563747D2020202020202020206D6F64656C20696E7374616E63655C6E202A2F5C6E4D6F64646C652E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(8143) := '2E637265617465203D2066756E6374696F6E2864657363726970746F722C20617474727329207B5C6E20207661722054797065203D20746869732E676574547970652864657363726970746F72293B5C6E5C6E202069662028215479706529207B5C6E20';
wwv_flow_imp.g_varchar2_table(8144) := '2020207468726F77206E6577204572726F722827756E6B6E6F776E2074797065203C27202B2064657363726970746F72202B20273E27293B5C6E20207D5C6E5C6E202072657475726E206E65772054797065286174747273293B5C6E7D3B5C6E5C6E5C6E';
wwv_flow_imp.g_varchar2_table(8145) := '2F2A2A5C6E202A2052657475726E7320746865207479706520726570726573656E74696E67206120676976656E2064657363726970746F725C6E202A5C6E202A20406D6574686F64204D6F64646C6523676574547970655C6E202A5C6E202A2040657861';
wwv_flow_imp.g_varchar2_table(8146) := '6D706C655C6E202A5C6E202A2076617220466F6F203D206D6F64646C652E6765745479706528276D793A466F6F27293B5C6E202A2076617220666F6F203D206E657720466F6F287B2027696427203A2027464F4F5F3127207D293B5C6E202A5C6E202A20';
wwv_flow_imp.g_varchar2_table(8147) := '40706172616D20207B537472696E677C4F626A6563747D2064657363726970746F722074686520747970652064657363726970746F72206F72206E616D65206B6E6F7720746F20746865206D6F64656C5C6E202A204072657475726E207B4F626A656374';
wwv_flow_imp.g_varchar2_table(8148) := '7D202020202020202020746865207479706520726570726573656E74696E67207468652064657363726970746F725C6E202A2F5C6E4D6F64646C652E70726F746F747970652E67657454797065203D2066756E6374696F6E2864657363726970746F7229';
wwv_flow_imp.g_varchar2_table(8149) := '207B5C6E5C6E2020766172206361636865203D20746869732E7479706543616368653B5C6E5C6E2020766172206E616D65203D206973537472696E672864657363726970746F7229203F2064657363726970746F72203A2064657363726970746F722E6E';
wwv_flow_imp.g_varchar2_table(8150) := '732E6E616D653B5C6E5C6E20207661722074797065203D2063616368655B6E616D655D3B5C6E5C6E202069662028217479706529207B5C6E2020202064657363726970746F72203D20746869732E72656769737472792E67657445666665637469766544';
wwv_flow_imp.g_varchar2_table(8151) := '657363726970746F72286E616D65293B5C6E2020202074797065203D2063616368655B6E616D655D203D20746869732E666163746F72792E637265617465547970652864657363726970746F72293B5C6E20207D5C6E5C6E202072657475726E20747970';
wwv_flow_imp.g_varchar2_table(8152) := '653B5C6E7D3B5C6E5C6E5C6E2F2A2A5C6E202A204372656174657320616E20616E792D656C656D656E74207479706520746F20626520757365642077697468696E206D6F64656C20696E7374616E6365732E5C6E202A5C6E202A20546869732063616E20';
wwv_flow_imp.g_varchar2_table(8153) := '6265207573656420746F2063726561746520637573746F6D20656C656D656E74732074686174206C6965206F75747369646520746865206D6574612D6D6F64656C2E5C6E202A20546865206372656174656420656C656D656E7420636F6E7461696E7320';
wwv_flow_imp.g_varchar2_table(8154) := '616C6C20746865206D6574612D6461746120726571756972656420746F2073657269616C697A652069745C6E202A2061732070617274206F66206D6574612D6D6F64656C20656C656D656E74732E5C6E202A5C6E202A20406D6574686F64204D6F64646C';
wwv_flow_imp.g_varchar2_table(8155) := '6523637265617465416E795C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A2076617220666F6F203D206D6F64646C652E637265617465416E79282776656E646F723A466F6F272C2027687474703A2F2F76656E646F72272C207B5C6E202A';
wwv_flow_imp.g_varchar2_table(8156) := '20202076616C75653A2027626172275C6E202A207D293B5C6E202A5C6E202A2076617220636F6E7461696E6572203D206D6F64646C652E63726561746528276D793A436F6E7461696E6572272C2027687474703A2F2F6D79272C207B5C6E202A20202061';
wwv_flow_imp.g_varchar2_table(8157) := '6E793A205B20666F6F205D5C6E202A207D293B5C6E202A5C6E202A202F2F20676F20616865616420616E642073657269616C697A65207468652073747566665C6E202A5C6E202A5C6E202A2040706172616D20207B537472696E677D206E616D65202074';
wwv_flow_imp.g_varchar2_table(8158) := '6865206E616D65206F662074686520656C656D656E745C6E202A2040706172616D20207B537472696E677D206E7355726920746865206E616D65737061636520757269206F662074686520656C656D656E745C6E202A2040706172616D20207B4F626A65';
wwv_flow_imp.g_varchar2_table(8159) := '63747D205B70726F706572746965735D2061206D6170206F662070726F7065727469657320746F20696E697469616C697A652074686520696E7374616E636520776974685C6E202A204072657475726E207B4F626A6563747D2074686520616E79207479';
wwv_flow_imp.g_varchar2_table(8160) := '706520696E7374616E63655C6E202A2F5C6E4D6F64646C652E70726F746F747970652E637265617465416E79203D2066756E6374696F6E286E616D652C206E735572692C2070726F7065727469657329207B5C6E5C6E2020766172206E616D654E73203D';
wwv_flow_imp.g_varchar2_table(8161) := '2070617273654E616D65286E616D65293B5C6E5C6E202076617220656C656D656E74203D207B5C6E2020202024747970653A206E616D652C5C6E2020202024696E7374616E63654F663A2066756E6374696F6E287479706529207B5C6E20202020202072';
wwv_flow_imp.g_varchar2_table(8162) := '657475726E2074797065203D3D3D20746869732E24747970653B5C6E202020207D2C5C6E202020206765743A2066756E6374696F6E286B657929207B5C6E20202020202072657475726E20746869735B6B65795D3B5C6E202020207D2C5C6E2020202073';
wwv_flow_imp.g_varchar2_table(8163) := '65743A2066756E6374696F6E286B65792C2076616C756529207B5C6E20202020202073657428746869732C205B206B6579205D2C2076616C7565293B5C6E202020207D5C6E20207D3B5C6E5C6E20207661722064657363726970746F72203D207B5C6E20';
wwv_flow_imp.g_varchar2_table(8164) := '2020206E616D653A206E616D652C5C6E20202020697347656E657269633A20747275652C5C6E202020206E733A207B5C6E2020202020207072656669783A206E616D654E732E7072656669782C5C6E2020202020206C6F63616C4E616D653A206E616D65';
wwv_flow_imp.g_varchar2_table(8165) := '4E732E6C6F63616C4E616D652C5C6E2020202020207572693A206E735572695C6E202020207D5C6E20207D3B5C6E5C6E2020746869732E70726F706572746965732E646566696E6544657363726970746F7228656C656D656E742C206465736372697074';
wwv_flow_imp.g_varchar2_table(8166) := '6F72293B5C6E2020746869732E70726F706572746965732E646566696E654D6F64656C28656C656D656E742C2074686973293B5C6E2020746869732E70726F706572746965732E646566696E6528656C656D656E742C2027676574272C207B20656E756D';
wwv_flow_imp.g_varchar2_table(8167) := '657261626C653A2066616C73652C207772697461626C653A2074727565207D293B5C6E2020746869732E70726F706572746965732E646566696E6528656C656D656E742C2027736574272C207B20656E756D657261626C653A2066616C73652C20777269';
wwv_flow_imp.g_varchar2_table(8168) := '7461626C653A2074727565207D293B5C6E2020746869732E70726F706572746965732E646566696E6528656C656D656E742C202724706172656E74272C207B20656E756D657261626C653A2066616C73652C207772697461626C653A2074727565207D29';
wwv_flow_imp.g_varchar2_table(8169) := '3B5C6E2020746869732E70726F706572746965732E646566696E6528656C656D656E742C202724696E7374616E63654F66272C207B20656E756D657261626C653A2066616C73652C207772697461626C653A2074727565207D293B5C6E5C6E2020666F72';
wwv_flow_imp.g_varchar2_table(8170) := '456163682870726F706572746965732C2066756E6374696F6E28612C206B657929207B5C6E202020206966202869734F626A65637428612920262620612E76616C756520213D3D20756E646566696E656429207B5C6E202020202020656C656D656E745B';
wwv_flow_imp.g_varchar2_table(8171) := '612E6E616D655D203D20612E76616C75653B5C6E202020207D20656C7365207B5C6E202020202020656C656D656E745B6B65795D203D20613B5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E20656C656D656E743B5C6E7D3B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(8172) := '2F2A2A5C6E202A2052657475726E7320612072656769737465726564207061636B61676520627920757269206F72207072656669785C6E202A5C6E202A204072657475726E207B4F626A6563747D20746865207061636B6167655C6E202A2F5C6E4D6F64';
wwv_flow_imp.g_varchar2_table(8173) := '646C652E70726F746F747970652E6765745061636B616765203D2066756E6374696F6E287572694F7250726566697829207B5C6E202072657475726E20746869732E72656769737472792E6765745061636B616765287572694F72507265666978293B5C';
wwv_flow_imp.g_varchar2_table(8174) := '6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E73206120736E617073686F74206F6620616C6C206B6E6F776E207061636B616765735C6E202A5C6E202A204072657475726E207B4F626A6563747D20746865207061636B6167655C6E202A2F5C6E4D';
wwv_flow_imp.g_varchar2_table(8175) := '6F64646C652E70726F746F747970652E6765745061636B61676573203D2066756E6374696F6E2829207B5C6E202072657475726E20746869732E72656769737472792E6765745061636B6167657328293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A20526574';
wwv_flow_imp.g_varchar2_table(8176) := '75726E73207468652064657363726970746F7220666F7220616E20656C656D656E745C6E202A2F5C6E4D6F64646C652E70726F746F747970652E676574456C656D656E7444657363726970746F72203D2066756E6374696F6E28656C656D656E7429207B';
wwv_flow_imp.g_varchar2_table(8177) := '5C6E202072657475726E20656C656D656E742E2464657363726970746F723B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E7320747275652069662074686520676976656E2064657363726970746F72206F7220696E7374616E63655C6E202A20';
wwv_flow_imp.g_varchar2_table(8178) := '726570726573656E74732074686520676976656E20747970652E5C6E202A5C6E202A204D6179206265206170706C69656420746F20746869732C20696620656C656D656E74206973206F6D69747465642E5C6E202A2F5C6E4D6F64646C652E70726F746F';
wwv_flow_imp.g_varchar2_table(8179) := '747970652E68617354797065203D2066756E6374696F6E28656C656D656E742C207479706529207B5C6E20206966202874797065203D3D3D20756E646566696E656429207B5C6E2020202074797065203D20656C656D656E743B5C6E20202020656C656D';
wwv_flow_imp.g_varchar2_table(8180) := '656E74203D20746869733B5C6E20207D5C6E5C6E20207661722064657363726970746F72203D20656C656D656E742E246D6F64656C2E676574456C656D656E7444657363726970746F7228656C656D656E74293B5C6E5C6E202072657475726E20287479';
wwv_flow_imp.g_varchar2_table(8181) := '706520696E2064657363726970746F722E616C6C547970657342794E616D65293B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E73207468652064657363726970746F72206F6620616E20656C656D656E7473206E616D65642070726F70657274';
wwv_flow_imp.g_varchar2_table(8182) := '795C6E202A2F5C6E4D6F64646C652E70726F746F747970652E67657450726F706572747944657363726970746F72203D2066756E6374696F6E28656C656D656E742C2070726F706572747929207B5C6E202072657475726E20746869732E676574456C65';
wwv_flow_imp.g_varchar2_table(8183) := '6D656E7444657363726970746F7228656C656D656E74292E70726F7065727469657342794E616D655B70726F70657274795D3B5C6E7D3B5C6E5C6E2F2A2A5C6E202A2052657475726E732061206D6170706564207479706527732064657363726970746F';
wwv_flow_imp.g_varchar2_table(8184) := '725C6E202A2F5C6E4D6F64646C652E70726F746F747970652E6765745479706544657363726970746F72203D2066756E6374696F6E287479706529207B5C6E202072657475726E20746869732E72656769737472792E747970654D61705B747970655D3B';
wwv_flow_imp.g_varchar2_table(8185) := '5C6E7D3B5C6E5C6E6578706F7274207B204D6F64646C652C20636F65726365547970652C2069734275696C74496E2061732069734275696C74496E547970652C20697353696D706C6520617320697353696D706C65547970652C2070617273654E616D65';
wwv_flow_imp.g_varchar2_table(8186) := '2061732070617273654E616D654E53207D3B5C6E2F2F2320736F757263654D617070696E6755524C3D696E6465782E65736D2E6A732E6D61705C6E222C222F2A2A5C6E202A20457874656E6473206120636F6C6C656374696F6E2077697468207B406C69';
wwv_flow_imp.g_varchar2_table(8187) := '6E6B20526566737D206177617265206D6574686F64735C6E202A5C6E202A2040706172616D207B41727261793C4F626A6563743E7D20636F6C6C656374696F6E5C6E202A2040706172616D207B526566737D207265667320696E7374616E63655C6E202A';
wwv_flow_imp.g_varchar2_table(8188) := '2040706172616D207B4F626A6563747D2070726F706572747920726570726573656E7465642062792074686520636F6C6C656374696F6E5C6E202A2040706172616D207B4F626A6563747D20746172676574206F626A6563742074686520636F6C6C6563';
wwv_flow_imp.g_varchar2_table(8189) := '74696F6E20697320617474616368656420746F5C6E202A5C6E202A204072657475726E207B52656673436F6C6C656374696F6E3C4F626A6563743E7D2074686520657874656E6465642061727261795C6E202A2F5C6E66756E6374696F6E20657874656E';
wwv_flow_imp.g_varchar2_table(8190) := '6428636F6C6C656374696F6E2C20726566732C2070726F70657274792C2074617267657429207B5C6E202076617220696E766572736550726F7065727479203D2070726F70657274792E696E76657273653B5C6E5C6E20202F2A2A5C6E2020202A205265';
wwv_flow_imp.g_varchar2_table(8191) := '6D6F7665732074686520676976656E20656C656D656E742066726F6D2074686520617272617920616E642072657475726E732069742E5C6E2020202A5C6E2020202A20406D6574686F642052656673436F6C6C656374696F6E2372656D6F76655C6E2020';
wwv_flow_imp.g_varchar2_table(8192) := '202A5C6E2020202A2040706172616D207B4F626A6563747D20656C656D656E742074686520656C656D656E7420746F2072656D6F76655C6E2020202A2F5C6E20204F626A6563742E646566696E6550726F706572747928636F6C6C656374696F6E2C2027';
wwv_flow_imp.g_varchar2_table(8193) := '72656D6F7665272C207B5C6E2020202076616C75653A2066756E6374696F6E2028656C656D656E7429207B5C6E20202020202076617220696478203D20746869732E696E6465784F6628656C656D656E74293B5C6E202020202020696620286964782021';
wwv_flow_imp.g_varchar2_table(8194) := '3D3D202D3129207B5C6E2020202020202020746869732E73706C696365286964782C2031293B5C6E5C6E20202020202020202F2F20756E73657420696E76657273655C6E2020202020202020726566732E756E73657428656C656D656E742C20696E7665';
wwv_flow_imp.g_varchar2_table(8195) := '72736550726F70657274792C20746172676574293B5C6E2020202020207D5C6E20202020202072657475726E20656C656D656E743B5C6E202020207D5C6E20207D293B5C6E5C6E20202F2A2A5C6E2020202A2052657475726E7320747275652069662074';
wwv_flow_imp.g_varchar2_table(8196) := '686520636F6C6C656374696F6E20636F6E7461696E732074686520676976656E20656C656D656E745C6E2020202A5C6E2020202A20406D6574686F642052656673436F6C6C656374696F6E23636F6E7461696E735C6E2020202A5C6E2020202A20407061';
wwv_flow_imp.g_varchar2_table(8197) := '72616D207B4F626A6563747D20656C656D656E742074686520656C656D656E7420746F20636865636B20666F725C6E2020202A2F5C6E20204F626A6563742E646566696E6550726F706572747928636F6C6C656374696F6E2C2027636F6E7461696E7327';
wwv_flow_imp.g_varchar2_table(8198) := '2C207B5C6E2020202076616C75653A2066756E6374696F6E2028656C656D656E7429207B5C6E20202020202072657475726E20746869732E696E6465784F6628656C656D656E742920213D3D202D313B5C6E202020207D5C6E20207D293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(8199) := '2F2A2A5C6E2020202A204164647320616E20656C656D656E7420746F207468652061727261792C20756E6C6573732069742065786973747320616C726561647920287365742073656D616E74696373292E5C6E2020202A5C6E2020202A20406D6574686F';
wwv_flow_imp.g_varchar2_table(8200) := '642052656673436F6C6C656374696F6E236164645C6E2020202A5C6E2020202A2040706172616D207B4F626A6563747D20656C656D656E742074686520656C656D656E7420746F206164645C6E2020202A2040706172616D207B4E756D6265727D206F70';
wwv_flow_imp.g_varchar2_table(8201) := '74696F6E616C20696E64657820746F2061646420656C656D656E7420746F5C6E2020202A202020202020202020202020202020202028706F737369626C79206D6F76696E67206F7468657220656C656D656E74732061726F756E64295C6E2020202A2F5C';
wwv_flow_imp.g_varchar2_table(8202) := '6E20204F626A6563742E646566696E6550726F706572747928636F6C6C656374696F6E2C2027616464272C207B5C6E2020202076616C75653A2066756E6374696F6E2028656C656D656E742C2069647829207B5C6E202020202020766172206375727265';
wwv_flow_imp.g_varchar2_table(8203) := '6E74496478203D20746869732E696E6465784F6628656C656D656E74293B5C6E20202020202069662028747970656F6620696478203D3D3D2027756E646566696E65642729207B5C6E20202020202020206966202863757272656E7449647820213D3D20';
wwv_flow_imp.g_varchar2_table(8204) := '2D3129207B5C6E202020202020202020202F2F20656C656D656E7420616C726561647920696E20636F6C6C656374696F6E202821295C6E2020202020202020202072657475726E3B5C6E20202020202020207D5C6E5C6E20202020202020202F2F206164';
wwv_flow_imp.g_varchar2_table(8205) := '6420746F20656E64206F662061727261792C206173206E6F20696478206973207370656369666965645C6E2020202020202020696478203D20746869732E6C656E6774683B5C6E2020202020207D5C6E5C6E2020202020202F2F2068616E646C6520616C';
wwv_flow_imp.g_varchar2_table(8206) := '726561647920696E20636F6C6C656374696F6E5C6E2020202020206966202863757272656E7449647820213D3D202D3129207B5C6E20202020202020202F2F2072656D6F766520656C656D656E742066726F6D2063757272656E744964785C6E20202020';
wwv_flow_imp.g_varchar2_table(8207) := '20202020746869732E73706C6963652863757272656E744964782C2031293B5C6E2020202020207D5C6E5C6E2020202020202F2F2061646420656C656D656E74206174206964785C6E202020202020746869732E73706C696365286964782C20302C2065';
wwv_flow_imp.g_varchar2_table(8208) := '6C656D656E74293B5C6E2020202020206966202863757272656E74496478203D3D3D202D3129207B5C6E20202020202020202F2F2073657420696E76657273652C20756E6C65737320656C656D656E74207761735C6E20202020202020202F2F20696E20';
wwv_flow_imp.g_varchar2_table(8209) := '636F6C6C656374696F6E20616C72656164795C6E2020202020202020726566732E73657428656C656D656E742C20696E766572736550726F70657274792C20746172676574293B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(8210) := '2F2F20612073696D706C65206D61726B65722C206964656E74696679696E67207468697320656C656D656E745C6E20202F2F206173206265696E672061207265667320636F6C6C656374696F6E5C6E20204F626A6563742E646566696E6550726F706572';
wwv_flow_imp.g_varchar2_table(8211) := '747928636F6C6C656374696F6E2C20275F5F726566735F636F6C6C656374696F6E272C207B5C6E2020202076616C75653A20747275655C6E20207D293B5C6E202072657475726E20636F6C6C656374696F6E3B5C6E7D5C6E5C6E2F2A2A5C6E202A204368';
wwv_flow_imp.g_varchar2_table(8212) := '65636B73206966206120676976656E20636F6C6C656374696F6E20697320657874656E6465645C6E202A5C6E202A2040706172616D207B41727261793C4F626A6563743E7D20636F6C6C656374696F6E5C6E202A5C6E202A204072657475726E207B626F';
wwv_flow_imp.g_varchar2_table(8213) := '6F6C65616E7D5C6E202A2F5C6E66756E6374696F6E206973457874656E64656428636F6C6C656374696F6E29207B5C6E202072657475726E20636F6C6C656374696F6E2E5F5F726566735F636F6C6C656374696F6E203D3D3D20747275653B5C6E7D5C6E';
wwv_flow_imp.g_varchar2_table(8214) := '5C6E76617220636F6C6C656374696F6E203D207B5C6E20205F5F70726F746F5F5F3A206E756C6C2C5C6E2020657874656E643A20657874656E642C5C6E20206973457874656E6465643A206973457874656E6465645C6E7D3B5C6E5C6E66756E6374696F';
wwv_flow_imp.g_varchar2_table(8215) := '6E206861734F776E50726F706572747928652C2070726F706572747929207B5C6E202072657475726E204F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28652C2070726F70657274792E6E616D65207C7C2070';
wwv_flow_imp.g_varchar2_table(8216) := '726F7065727479293B5C6E7D5C6E66756E6374696F6E20646566696E65436F6C6C656374696F6E50726F7065727479287265662C2070726F70657274792C2074617267657429207B5C6E202076617220636F6C6C656374696F6E203D20657874656E6428';
wwv_flow_imp.g_varchar2_table(8217) := '7461726765745B70726F70657274792E6E616D655D207C7C205B5D2C207265662C2070726F70657274792C20746172676574293B5C6E20204F626A6563742E646566696E6550726F7065727479287461726765742C2070726F70657274792E6E616D652C';
wwv_flow_imp.g_varchar2_table(8218) := '207B5C6E20202020656E756D657261626C653A2070726F70657274792E656E756D657261626C652C5C6E2020202076616C75653A20636F6C6C656374696F6E5C6E20207D293B5C6E202069662028636F6C6C656374696F6E2E6C656E67746829207B5C6E';
wwv_flow_imp.g_varchar2_table(8219) := '20202020636F6C6C656374696F6E2E666F72456163682866756E6374696F6E20286F29207B5C6E2020202020207265662E736574286F2C2070726F70657274792E696E76657273652C20746172676574293B5C6E202020207D293B5C6E20207D5C6E7D5C';
wwv_flow_imp.g_varchar2_table(8220) := '6E66756E6374696F6E20646566696E6550726F7065727479287265662C2070726F70657274792C2074617267657429207B5C6E202076617220696E766572736550726F7065727479203D2070726F70657274792E696E76657273653B5C6E202076617220';
wwv_flow_imp.g_varchar2_table(8221) := '5F76616C7565203D207461726765745B70726F70657274792E6E616D655D3B5C6E20204F626A6563742E646566696E6550726F7065727479287461726765742C2070726F70657274792E6E616D652C207B5C6E20202020636F6E666967757261626C653A';
wwv_flow_imp.g_varchar2_table(8222) := '2070726F70657274792E636F6E666967757261626C652C5C6E20202020656E756D657261626C653A2070726F70657274792E656E756D657261626C652C5C6E202020206765743A2066756E6374696F6E202829207B5C6E20202020202072657475726E20';
wwv_flow_imp.g_varchar2_table(8223) := '5F76616C75653B5C6E202020207D2C5C6E202020207365743A2066756E6374696F6E202876616C756529207B5C6E2020202020202F2F2072657475726E20696620776520616C726561647920706572666F726D656420616C6C206368616E6765735C6E20';
wwv_flow_imp.g_varchar2_table(8224) := '20202020206966202876616C7565203D3D3D205F76616C756529207B5C6E202020202020202072657475726E3B5C6E2020202020207D5C6E202020202020766172206F6C64203D205F76616C75653B5C6E5C6E2020202020202F2F2074656D706F726172';
wwv_flow_imp.g_varchar2_table(8225) := '7920736574206E756C6C5C6E2020202020205F76616C7565203D206E756C6C3B5C6E202020202020696620286F6C6429207B5C6E20202020202020207265662E756E736574286F6C642C20696E766572736550726F70657274792C20746172676574293B';
wwv_flow_imp.g_varchar2_table(8226) := '5C6E2020202020207D5C6E5C6E2020202020202F2F20736574206E65772076616C75655C6E2020202020205F76616C7565203D2076616C75653B5C6E5C6E2020202020202F2F2073657420696E76657273652076616C75655C6E2020202020207265662E';
wwv_flow_imp.g_varchar2_table(8227) := '736574285F76616C75652C20696E766572736550726F70657274792C20746172676574293B5C6E202020207D5C6E20207D293B5C6E7D5C6E5C6E2F2A2A5C6E202A20437265617465732061206E6577207265666572656E636573206F626A656374206465';
wwv_flow_imp.g_varchar2_table(8228) := '66696E696E672074776F20696E766572736C792072656C617465645C6E202A206174747269627574652064657363726970746F7273206120616E6420622E5C6E202A5C6E202A203C703E5C6E202A2020205768656E20626F756E6420746F20616E206F62';
wwv_flow_imp.g_varchar2_table(8229) := '6A656374207573696E67207B406C696E6B20526566732362696E647D20746865207265666572656E6365735C6E202A2020206765742061637469766174656420616E6420656E7375726520746861742061646420616E642072656D6F7665206F70657261';
wwv_flow_imp.g_varchar2_table(8230) := '74696F6E7320617265206170706C6965645C6E202A202020726576657273656C792C20746F6F2E5C6E202A203C2F703E5C6E202A5C6E202A203C703E5C6E202A202020466F72206174747269627574657320726570726573656E74656420617320636F6C';
wwv_flow_imp.g_varchar2_table(8231) := '6C656374696F6E73207B406C696E6B20526566737D2070726F7669646573207468655C6E202A2020207B406C696E6B2052656673436F6C6C656374696F6E236164647D2C207B406C696E6B2052656673436F6C6C656374696F6E2372656D6F76657D2061';
wwv_flow_imp.g_varchar2_table(8232) := '6E64207B406C696E6B2052656673436F6C6C656374696F6E23636F6E7461696E737D20657874656E73696F6E735C6E202A20202074686174206D757374206265207573656420746F2070726F7065726C7920686F6F6B20696E746F2074686520696E7665';
wwv_flow_imp.g_varchar2_table(8233) := '727365206368616E6765206D656368616E69736D2E5C6E202A203C2F703E5C6E202A5C6E202A2040636C61737320526566735C6E202A5C6E202A2040636C6173736465736320412062692D646972656374696F6E616C207265666572656E636520626574';
wwv_flow_imp.g_varchar2_table(8234) := '7765656E2074776F20617474726962757465732E5C6E202A5C6E202A2040706172616D207B526566732E41747472696275746544657363726970746F727D20612070726F70657274792064657363726970746F725C6E202A2040706172616D207B526566';
wwv_flow_imp.g_varchar2_table(8235) := '732E41747472696275746544657363726970746F727D20622070726F70657274792064657363726970746F725C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A207661722072656673203D2052656673287B206E616D653A2027776865656C';
wwv_flow_imp.g_varchar2_table(8236) := '73272C20636F6C6C656374696F6E3A20747275652C20656E756D657261626C653A2074727565207D2C207B206E616D653A202763617227207D293B5C6E202A5C6E202A2076617220636172203D207B206E616D653A2027746F796F746127207D3B5C6E20';
wwv_flow_imp.g_varchar2_table(8237) := '2A2076617220776865656C73203D205B7B20706F733A202766726F6E742D6C65667427207D2C207B20706F733A202766726F6E742D726967687427207D5D3B5C6E202A5C6E202A20726566732E62696E64286361722C2027776865656C7327293B5C6E20';
wwv_flow_imp.g_varchar2_table(8238) := '2A5C6E202A206361722E776865656C73202F2F205B5D5C6E202A206361722E776865656C732E61646428776865656C735B305D293B5C6E202A206361722E776865656C732E61646428776865656C735B315D293B5C6E202A5C6E202A206361722E776865';
wwv_flow_imp.g_varchar2_table(8239) := '656C73202F2F205B7B20706F733A202766726F6E742D6C65667427207D2C207B20706F733A202766726F6E742D726967687427207D5D5C6E202A5C6E202A20776865656C735B305D2E636172202F2F207B206E616D653A2027746F796F746127207D3B5C';
wwv_flow_imp.g_varchar2_table(8240) := '6E202A206361722E776865656C732E72656D6F766528776865656C735B305D293B5C6E202A5C6E202A20776865656C735B305D2E636172202F2F20756E646566696E65645C6E202A2F5C6E66756E6374696F6E205265667328612C206229207B5C6E2020';
wwv_flow_imp.g_varchar2_table(8241) := '6966202821287468697320696E7374616E63656F6620526566732929207B5C6E2020202072657475726E206E6577205265667328612C2062293B5C6E20207D5C6E5C6E20202F2F206C696E6B5C6E2020612E696E7665727365203D20623B5C6E2020622E';
wwv_flow_imp.g_varchar2_table(8242) := '696E7665727365203D20613B5C6E2020746869732E70726F7073203D207B7D3B5C6E2020746869732E70726F70735B612E6E616D655D203D20613B5C6E2020746869732E70726F70735B622E6E616D655D203D20623B5C6E7D5C6E5C6E2F2A2A5C6E202A';
wwv_flow_imp.g_varchar2_table(8243) := '2042696E6473206F6E652073696465206F6620612062692D646972656374696F6E616C207265666572656E636520746F20615C6E202A20746172676574206F626A6563742E5C6E202A5C6E202A20406D656D6265724F6620526566735C6E202A5C6E202A';
wwv_flow_imp.g_varchar2_table(8244) := '2040706172616D20207B4F626A6563747D207461726765745C6E202A2040706172616D20207B537472696E677D2070726F70657274795C6E202A2F5C6E526566732E70726F746F747970652E62696E64203D2066756E6374696F6E20287461726765742C';
wwv_flow_imp.g_varchar2_table(8245) := '2070726F706572747929207B5C6E202069662028747970656F662070726F7065727479203D3D3D2027737472696E672729207B5C6E202020206966202821746869732E70726F70735B70726F70657274795D29207B5C6E2020202020207468726F77206E';
wwv_flow_imp.g_varchar2_table(8246) := '6577204572726F7228276E6F2070726F7065727479203C27202B2070726F7065727479202B20273E20696E2072656627293B5C6E202020207D5C6E2020202070726F7065727479203D20746869732E70726F70735B70726F70657274795D3B5C6E20207D';
wwv_flow_imp.g_varchar2_table(8247) := '5C6E20206966202870726F70657274792E636F6C6C656374696F6E29207B5C6E20202020646566696E65436F6C6C656374696F6E50726F706572747928746869732C2070726F70657274792C20746172676574293B5C6E20207D20656C7365207B5C6E20';
wwv_flow_imp.g_varchar2_table(8248) := '202020646566696E6550726F706572747928746869732C2070726F70657274792C20746172676574293B5C6E20207D5C6E7D3B5C6E526566732E70726F746F747970652E656E7375726552656673436F6C6C656374696F6E203D2066756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(8249) := '287461726765742C2070726F706572747929207B5C6E202076617220636F6C6C656374696F6E203D207461726765745B70726F70657274792E6E616D655D3B5C6E202069662028216973457874656E64656428636F6C6C656374696F6E2929207B5C6E20';
wwv_flow_imp.g_varchar2_table(8250) := '202020646566696E65436F6C6C656374696F6E50726F706572747928746869732C2070726F70657274792C20746172676574293B5C6E20207D5C6E202072657475726E20636F6C6C656374696F6E3B5C6E7D3B5C6E526566732E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(8251) := '656E73757265426F756E64203D2066756E6374696F6E20287461726765742C2070726F706572747929207B5C6E202069662028216861734F776E50726F7065727479287461726765742C2070726F70657274792929207B5C6E20202020746869732E6269';
wwv_flow_imp.g_varchar2_table(8252) := '6E64287461726765742C2070726F7065727479293B5C6E20207D5C6E7D3B5C6E526566732E70726F746F747970652E756E736574203D2066756E6374696F6E20287461726765742C2070726F70657274792C2076616C756529207B5C6E20206966202874';
wwv_flow_imp.g_varchar2_table(8253) := '617267657429207B5C6E20202020746869732E656E73757265426F756E64287461726765742C2070726F7065727479293B5C6E202020206966202870726F70657274792E636F6C6C656374696F6E29207B5C6E202020202020746869732E656E73757265';
wwv_flow_imp.g_varchar2_table(8254) := '52656673436F6C6C656374696F6E287461726765742C2070726F7065727479292E72656D6F76652876616C7565293B5C6E202020207D20656C7365207B5C6E2020202020207461726765745B70726F70657274792E6E616D655D203D20756E646566696E';
wwv_flow_imp.g_varchar2_table(8255) := '65643B5C6E202020207D5C6E20207D5C6E7D3B5C6E526566732E70726F746F747970652E736574203D2066756E6374696F6E20287461726765742C2070726F70657274792C2076616C756529207B5C6E20206966202874617267657429207B5C6E202020';
wwv_flow_imp.g_varchar2_table(8256) := '20746869732E656E73757265426F756E64287461726765742C2070726F7065727479293B5C6E202020206966202870726F70657274792E636F6C6C656374696F6E29207B5C6E202020202020746869732E656E7375726552656673436F6C6C656374696F';
wwv_flow_imp.g_varchar2_table(8257) := '6E287461726765742C2070726F7065727479292E6164642876616C7565293B5C6E202020207D20656C7365207B5C6E2020202020207461726765745B70726F70657274792E6E616D655D203D2076616C75653B5C6E202020207D5C6E20207D5C6E7D3B5C';
wwv_flow_imp.g_varchar2_table(8258) := '6E5C6E2F2A2A5C6E202A20416E206174747269627574652064657363726970746F7220746F2062652075736564207370656369667920616E2061747472696275746520696E2061207B406C696E6B20526566737D20696E7374616E63655C6E202A5C6E20';
wwv_flow_imp.g_varchar2_table(8259) := '2A204074797065646566207B4F626A6563747D20526566732E41747472696275746544657363726970746F725C6E202A204070726F7065727479207B537472696E677D206E616D655C6E202A204070726F7065727479207B626F6F6C65616E7D205B636F';
wwv_flow_imp.g_varchar2_table(8260) := '6C6C656374696F6E3D66616C73655D5C6E202A204070726F7065727479207B626F6F6C65616E7D205B656E756D657261626C653D66616C73655D5C6E202A2F5C6E5C6E6578706F7274207B20636F6C6C656374696F6E20617320436F6C6C656374696F6E';
wwv_flow_imp.g_varchar2_table(8261) := '2C2052656673207D3B5C6E222C222F2A2A5C6E202A20546869732066696C6520636F6E7461696E7320736F7572636520636F646520616461707465642066726F6D20536E61702E73766720286C6963656E736564204170616368652D322E30292E5C6E20';
wwv_flow_imp.g_varchar2_table(8262) := '2A5C6E202A20407365652068747470733A2F2F6769746875622E636F6D2F61646F62652D776562706C6174666F726D2F536E61702E7376672F626C6F622F6D61737465722F7372632F706174682E6A735C6E202A2F5C6E5C6E2F2A2065736C696E74206E';
wwv_flow_imp.g_varchar2_table(8263) := '6F2D66616C6C7468726F7567683A205C226F66665C22202A2F5C6E5C6E76617220703273203D202F2C3F285B612D7A5D292C3F2F67692C5C6E20202020746F466C6F6174203D207061727365466C6F61742C5C6E202020206D617468203D204D6174682C';
wwv_flow_imp.g_varchar2_table(8264) := '5C6E202020205049203D206D6174682E50492C5C6E202020206D6D696E203D206D6174682E6D696E2C5C6E202020206D6D6178203D206D6174682E6D61782C5C6E20202020706F77203D206D6174682E706F772C5C6E20202020616273203D206D617468';
wwv_flow_imp.g_varchar2_table(8265) := '2E6162732C5C6E2020202070617468436F6D6D616E64203D202F285B612D7A5D295B5C5C732C5D2A28282D3F5C5C642A5C5C2E3F5C5C642A283F3A655B2D2B5D3F5C5C642B293F5B5C5C735D2A2C3F5B5C5C735D2A292B292F69672C5C6E202020207061';
wwv_flow_imp.g_varchar2_table(8266) := '746856616C756573203D202F282D3F5C5C642A5C5C2E3F5C5C642A283F3A655B2D2B5D3F5C5C642B293F295B5C5C735D2A2C3F5B5C5C735D2A2F69673B5C6E5C6E7661722069734172726179203D2041727261792E69734172726179207C7C2066756E63';
wwv_flow_imp.g_varchar2_table(8267) := '74696F6E286F29207B2072657475726E206F20696E7374616E63656F662041727261793B207D3B5C6E5C6E66756E6374696F6E2068617350726F7065727479286F626A2C2070726F706572747929207B5C6E202072657475726E204F626A6563742E7072';
wwv_flow_imp.g_varchar2_table(8268) := '6F746F747970652E6861734F776E50726F70657274792E63616C6C286F626A2C2070726F7065727479293B5C6E7D5C6E5C6E66756E6374696F6E20636C6F6E65286F626A29207B5C6E5C6E202069662028747970656F66206F626A203D3D202766756E63';
wwv_flow_imp.g_varchar2_table(8269) := '74696F6E27207C7C204F626A656374286F626A2920213D3D206F626A29207B5C6E2020202072657475726E206F626A3B5C6E20207D5C6E5C6E202076617220726573203D206E6577206F626A2E636F6E7374727563746F723B5C6E5C6E2020666F722028';
wwv_flow_imp.g_varchar2_table(8270) := '766172206B657920696E206F626A29207B5C6E202020206966202868617350726F7065727479286F626A2C206B65792929207B5C6E2020202020207265735B6B65795D203D20636C6F6E65286F626A5B6B65795D293B5C6E202020207D5C6E20207D5C6E';
wwv_flow_imp.g_varchar2_table(8271) := '5C6E202072657475726E207265733B5C6E7D5C6E5C6E66756E6374696F6E207265707573682861727261792C206974656D29207B5C6E2020666F7220287661722069203D20302C206969203D2061727261792E6C656E6774683B2069203C2069693B2069';
wwv_flow_imp.g_varchar2_table(8272) := '2B2B29206966202861727261795B695D203D3D3D206974656D29207B5C6E2020202072657475726E2061727261792E707573682861727261792E73706C69636528692C2031295B305D293B5C6E20207D5C6E7D5C6E5C6E66756E6374696F6E2063616368';
wwv_flow_imp.g_varchar2_table(8273) := '6572286629207B5C6E5C6E202066756E6374696F6E206E6577662829207B5C6E5C6E2020202076617220617267203D2041727261792E70726F746F747970652E736C6963652E63616C6C28617267756D656E74732C2030292C5C6E202020202020202061';
wwv_flow_imp.g_varchar2_table(8274) := '726773203D206172672E6A6F696E28275C5C753234303027292C5C6E20202020202020206361636865203D206E6577662E6361636865203D206E6577662E6361636865207C7C207B7D2C5C6E2020202020202020636F756E74203D206E6577662E636F75';
wwv_flow_imp.g_varchar2_table(8275) := '6E74203D206E6577662E636F756E74207C7C205B5D3B5C6E5C6E202020206966202868617350726F70657274792863616368652C20617267732929207B5C6E20202020202072657075736828636F756E742C2061726773293B5C6E202020202020726574';
wwv_flow_imp.g_varchar2_table(8276) := '75726E2063616368655B617267735D3B5C6E202020207D5C6E5C6E20202020636F756E742E6C656E677468203E3D203165332026262064656C6574652063616368655B636F756E742E736869667428295D3B5C6E20202020636F756E742E707573682861';
wwv_flow_imp.g_varchar2_table(8277) := '726773293B5C6E2020202063616368655B617267735D203D2066282E2E2E617267756D656E7473293B5C6E5C6E2020202072657475726E2063616368655B617267735D3B5C6E20207D5C6E202072657475726E206E6577663B5C6E7D5C6E5C6E66756E63';
wwv_flow_imp.g_varchar2_table(8278) := '74696F6E20706172736550617468537472696E672870617468537472696E6729207B5C6E5C6E2020696620282170617468537472696E6729207B5C6E2020202072657475726E206E756C6C3B5C6E20207D5C6E5C6E202076617220707468203D20706174';
wwv_flow_imp.g_varchar2_table(8279) := '68732870617468537472696E67293B5C6E5C6E2020696620287074682E61727229207B5C6E2020202072657475726E20636C6F6E65287074682E617272293B5C6E20207D5C6E5C6E202076617220706172616D436F756E7473203D207B20613A20372C20';
wwv_flow_imp.g_varchar2_table(8280) := '633A20362C20683A20312C206C3A20322C206D3A20322C20713A20342C20733A20342C20743A20322C20763A20312C207A3A2030207D2C5C6E20202020202064617461203D205B5D3B5C6E5C6E202069662028697341727261792870617468537472696E';
wwv_flow_imp.g_varchar2_table(8281) := '672920262620697341727261792870617468537472696E675B305D2929207B202F2F20726F75676820617373756D7074696F6E5C6E2020202064617461203D20636C6F6E652870617468537472696E67293B5C6E20207D5C6E5C6E202069662028216461';
wwv_flow_imp.g_varchar2_table(8282) := '74612E6C656E67746829207B5C6E5C6E20202020537472696E672870617468537472696E67292E7265706C6163652870617468436F6D6D616E642C2066756E6374696F6E28612C20622C206329207B5C6E20202020202076617220706172616D73203D20';
wwv_flow_imp.g_varchar2_table(8283) := '5B5D2C5C6E202020202020202020206E616D65203D20622E746F4C6F7765724361736528293B5C6E5C6E202020202020632E7265706C616365287061746856616C7565732C2066756E6374696F6E28612C206229207B5C6E202020202020202062202626';
wwv_flow_imp.g_varchar2_table(8284) := '20706172616D732E70757368282B62293B5C6E2020202020207D293B5C6E5C6E202020202020696620286E616D65203D3D20276D2720262620706172616D732E6C656E677468203E203229207B5C6E2020202020202020646174612E70757368285B2062';
wwv_flow_imp.g_varchar2_table(8285) := '2C202E2E2E706172616D732E73706C69636528302C203229205D293B5C6E20202020202020206E616D65203D20276C273B5C6E202020202020202062203D2062203D3D20276D27203F20276C27203A20274C273B5C6E2020202020207D5C6E5C6E202020';
wwv_flow_imp.g_varchar2_table(8286) := '2020207768696C652028706172616D732E6C656E677468203E3D20706172616D436F756E74735B6E616D655D29207B5C6E2020202020202020646174612E70757368285B20622C202E2E2E706172616D732E73706C69636528302C20706172616D436F75';
wwv_flow_imp.g_varchar2_table(8287) := '6E74735B6E616D655D29205D293B5C6E20202020202020206966202821706172616D436F756E74735B6E616D655D29207B5C6E20202020202020202020627265616B3B5C6E20202020202020207D5C6E2020202020207D5C6E202020207D293B5C6E2020';
wwv_flow_imp.g_varchar2_table(8288) := '7D5C6E5C6E2020646174612E746F537472696E67203D2070617468732E746F537472696E673B5C6E20207074682E617272203D20636C6F6E652864617461293B5C6E5C6E202072657475726E20646174613B5C6E7D5C6E5C6E66756E6374696F6E207061';
wwv_flow_imp.g_varchar2_table(8289) := '74687328707329207B5C6E20207661722070203D2070617468732E7073203D2070617468732E7073207C7C207B7D3B5C6E5C6E202069662028705B70735D29207B5C6E20202020705B70735D2E736C656570203D203130303B5C6E20207D20656C736520';
wwv_flow_imp.g_varchar2_table(8290) := '7B5C6E20202020705B70735D203D207B5C6E202020202020736C6565703A203130305C6E202020207D3B5C6E20207D5C6E5C6E202073657454696D656F75742866756E6374696F6E2829207B5C6E20202020666F722028766172206B657920696E207029';
wwv_flow_imp.g_varchar2_table(8291) := '207B5C6E2020202020206966202868617350726F706572747928702C206B657929202626206B657920213D20707329207B5C6E2020202020202020705B6B65795D2E736C6565702D2D3B5C6E202020202020202021705B6B65795D2E736C656570202626';
wwv_flow_imp.g_varchar2_table(8292) := '2064656C65746520705B6B65795D3B5C6E2020202020207D5C6E202020207D5C6E20207D293B5C6E5C6E202072657475726E20705B70735D3B5C6E7D5C6E5C6E66756E6374696F6E207265637442426F7828782C20792C2077696474682C206865696768';
wwv_flow_imp.g_varchar2_table(8293) := '7429207B5C6E5C6E202069662028617267756D656E74732E6C656E677468203D3D3D203129207B5C6E2020202079203D20782E793B5C6E202020207769647468203D20782E77696474683B5C6E20202020686569676874203D20782E6865696768743B5C';
wwv_flow_imp.g_varchar2_table(8294) := '6E2020202078203D20782E783B5C6E20207D5C6E5C6E202072657475726E207B5C6E20202020783A20782C5C6E20202020793A20792C5C6E2020202077696474683A2077696474682C5C6E202020206865696768743A206865696768742C5C6E20202020';
wwv_flow_imp.g_varchar2_table(8295) := '78323A2078202B2077696474682C5C6E2020202079323A2079202B206865696768745C6E20207D3B5C6E7D5C6E5C6E66756E6374696F6E2070617468546F537472696E672829207B5C6E202072657475726E20746869732E6A6F696E28272C27292E7265';
wwv_flow_imp.g_varchar2_table(8296) := '706C616365287032732C2027243127293B5C6E7D5C6E5C6E66756E6374696F6E2070617468436C6F6E652870617468417272617929207B5C6E202076617220726573203D20636C6F6E6528706174684172726179293B5C6E20207265732E746F53747269';
wwv_flow_imp.g_varchar2_table(8297) := '6E67203D2070617468546F537472696E673B5C6E202072657475726E207265733B5C6E7D5C6E5C6E66756E6374696F6E2066696E64446F747341745365676D656E74287031782C207031792C206331782C206331792C206332782C206332792C20703278';
wwv_flow_imp.g_varchar2_table(8298) := '2C207032792C207429207B5C6E2020766172207431203D2031202D20742C5C6E202020202020743133203D20706F772874312C2033292C5C6E202020202020743132203D20706F772874312C2032292C5C6E2020202020207432203D2074202A20742C5C';
wwv_flow_imp.g_varchar2_table(8299) := '6E2020202020207433203D207432202A20742C5C6E20202020202078203D20743133202A20703178202B20743132202A2033202A2074202A20633178202B207431202A2033202A2074202A2074202A20633278202B207433202A207032782C5C6E202020';
wwv_flow_imp.g_varchar2_table(8300) := '20202079203D20743133202A20703179202B20743132202A2033202A2074202A20633179202B207431202A2033202A2074202A2074202A20633279202B207433202A207032793B5C6E5C6E202072657475726E207B5C6E20202020783A20666978457272';
wwv_flow_imp.g_varchar2_table(8301) := '6F722878292C5C6E20202020793A206669784572726F722879295C6E20207D3B5C6E7D5C6E5C6E66756E6374696F6E2062657A69657242426F7828706F696E747329207B5C6E5C6E20207661722062626F78203D20637572766542426F78282E2E2E706F';
wwv_flow_imp.g_varchar2_table(8302) := '696E7473293B5C6E5C6E202072657475726E207265637442426F78285C6E2020202062626F782E78302C5C6E2020202062626F782E79302C5C6E2020202062626F782E7831202D2062626F782E78302C5C6E2020202062626F782E7931202D2062626F78';
wwv_flow_imp.g_varchar2_table(8303) := '2E79305C6E2020293B5C6E7D5C6E5C6E66756E6374696F6E206973506F696E74496E7369646542426F782862626F782C20782C207929207B5C6E202072657475726E2078203E3D2062626F782E782026265C6E2020202078203C3D2062626F782E78202B';
wwv_flow_imp.g_varchar2_table(8304) := '2062626F782E77696474682026265C6E2020202079203E3D2062626F782E792026265C6E2020202079203C3D2062626F782E79202B2062626F782E6865696768743B5C6E7D5C6E5C6E66756E6374696F6E20697342426F78496E74657273656374286262';
wwv_flow_imp.g_varchar2_table(8305) := '6F78312C2062626F783229207B5C6E202062626F7831203D207265637442426F782862626F7831293B5C6E202062626F7832203D207265637442426F782862626F7832293B5C6E202072657475726E206973506F696E74496E7369646542426F78286262';
wwv_flow_imp.g_varchar2_table(8306) := '6F78322C2062626F78312E782C2062626F78312E79295C6E202020207C7C206973506F696E74496E7369646542426F782862626F78322C2062626F78312E78322C2062626F78312E79295C6E202020207C7C206973506F696E74496E7369646542426F78';
wwv_flow_imp.g_varchar2_table(8307) := '2862626F78322C2062626F78312E782C2062626F78312E7932295C6E202020207C7C206973506F696E74496E7369646542426F782862626F78322C2062626F78312E78322C2062626F78312E7932295C6E202020207C7C206973506F696E74496E736964';
wwv_flow_imp.g_varchar2_table(8308) := '6542426F782862626F78312C2062626F78322E782C2062626F78322E79295C6E202020207C7C206973506F696E74496E7369646542426F782862626F78312C2062626F78322E78322C2062626F78322E79295C6E202020207C7C206973506F696E74496E';
wwv_flow_imp.g_varchar2_table(8309) := '7369646542426F782862626F78312C2062626F78322E782C2062626F78322E7932295C6E202020207C7C206973506F696E74496E7369646542426F782862626F78312C2062626F78322E78322C2062626F78322E7932295C6E202020207C7C202862626F';
wwv_flow_imp.g_varchar2_table(8310) := '78312E78203C2062626F78322E78322026262062626F78312E78203E2062626F78322E785C6E20202020202020207C7C2062626F78322E78203C2062626F78312E78322026262062626F78322E78203E2062626F78312E78295C6E202020202626202862';
wwv_flow_imp.g_varchar2_table(8311) := '626F78312E79203C2062626F78322E79322026262062626F78312E79203E2062626F78322E795C6E20202020202020207C7C2062626F78322E79203C2062626F78312E79322026262062626F78322E79203E2062626F78312E79293B5C6E7D5C6E5C6E66';
wwv_flow_imp.g_varchar2_table(8312) := '756E6374696F6E20626173653328742C2070312C2070322C2070332C20703429207B5C6E2020766172207431203D202D33202A207031202B2039202A207032202D2039202A207033202B2033202A2070342C5C6E2020202020207432203D2074202A2074';
wwv_flow_imp.g_varchar2_table(8313) := '31202B2036202A207031202D203132202A207032202B2036202A2070333B5C6E202072657475726E2074202A207432202D2033202A207031202B2033202A2070323B5C6E7D5C6E5C6E66756E6374696F6E2062657A6C656E2878312C2079312C2078322C';
wwv_flow_imp.g_varchar2_table(8314) := '2079322C2078332C2079332C2078342C2079342C207A29207B5C6E5C6E2020696620287A203D3D206E756C6C29207B5C6E202020207A203D20313B5C6E20207D5C6E5C6E20207A203D207A203E2031203F2031203A207A203C2030203F2030203A207A3B';
wwv_flow_imp.g_varchar2_table(8315) := '5C6E5C6E2020766172207A32203D207A202F20322C5C6E2020202020206E203D2031322C5C6E2020202020205476616C756573203D205B202D2E313235322C2E313235322C2D2E333637382C2E333637382C2D2E353837332C2E353837332C2D2E373639';
wwv_flow_imp.g_varchar2_table(8316) := '392C2E373639392C2D2E393034312C2E393034312C2D2E393831362C2E39383136205D2C5C6E2020202020204376616C756573203D205B20302E323439312C302E323439312C302E323333352C302E323333352C302E323033322C302E323033322C302E';
wwv_flow_imp.g_varchar2_table(8317) := '313630312C302E313630312C302E313036392C302E313036392C302E303437322C302E30343732205D2C5C6E20202020202073756D203D20303B5C6E5C6E2020666F7220287661722069203D20303B2069203C206E3B20692B2B29207B5C6E2020202076';
wwv_flow_imp.g_varchar2_table(8318) := '6172206374203D207A32202A205476616C7565735B695D202B207A322C5C6E20202020202020207862617365203D2062617365332863742C2078312C2078322C2078332C207834292C5C6E20202020202020207962617365203D2062617365332863742C';
wwv_flow_imp.g_varchar2_table(8319) := '2079312C2079322C2079332C207934292C5C6E2020202020202020636F6D62203D207862617365202A207862617365202B207962617365202A2079626173653B5C6E5C6E2020202073756D202B3D204376616C7565735B695D202A206D6174682E737172';
wwv_flow_imp.g_varchar2_table(8320) := '7428636F6D62293B5C6E20207D5C6E5C6E202072657475726E207A32202A2073756D3B5C6E7D5C6E5C6E5C6E66756E6374696F6E20696E746572736563744C696E65732878312C2079312C2078322C2079322C2078332C2079332C2078342C2079342920';
wwv_flow_imp.g_varchar2_table(8321) := '7B5C6E5C6E2020696620285C6E202020206D6D61782878312C20783229203C206D6D696E2878332C20783429207C7C5C6E2020202020206D6D696E2878312C20783229203E206D6D61782878332C20783429207C7C5C6E2020202020206D6D6178287931';
wwv_flow_imp.g_varchar2_table(8322) := '2C20793229203C206D6D696E2879332C20793429207C7C5C6E2020202020206D6D696E2879312C20793229203E206D6D61782879332C207934295C6E202029207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020766172206E78203D202878';
wwv_flow_imp.g_varchar2_table(8323) := '31202A207932202D207931202A20783229202A20287833202D20783429202D20287831202D20783229202A20287833202A207934202D207933202A207834292C5C6E2020202020206E79203D20287831202A207932202D207931202A20783229202A2028';
wwv_flow_imp.g_varchar2_table(8324) := '7933202D20793429202D20287931202D20793229202A20287833202A207934202D207933202A207834292C5C6E20202020202064656E6F6D696E61746F72203D20287831202D20783229202A20287933202D20793429202D20287931202D20793229202A';
wwv_flow_imp.g_varchar2_table(8325) := '20287833202D207834293B5C6E5C6E2020696620282164656E6F6D696E61746F7229207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E2020766172207078203D206669784572726F72286E78202F2064656E6F6D696E61746F72292C5C6E2020';
wwv_flow_imp.g_varchar2_table(8326) := '202020207079203D206669784572726F72286E79202F2064656E6F6D696E61746F72292C5C6E202020202020707832203D202B70782E746F46697865642832292C5C6E202020202020707932203D202B70792E746F46697865642832293B5C6E5C6E2020';
wwv_flow_imp.g_varchar2_table(8327) := '696620285C6E20202020707832203C202B6D6D696E2878312C207832292E746F4669786564283229207C7C5C6E202020202020707832203E202B6D6D61782878312C207832292E746F4669786564283229207C7C5C6E202020202020707832203C202B6D';
wwv_flow_imp.g_varchar2_table(8328) := '6D696E2878332C207834292E746F4669786564283229207C7C5C6E202020202020707832203E202B6D6D61782878332C207834292E746F4669786564283229207C7C5C6E202020202020707932203C202B6D6D696E2879312C207932292E746F46697865';
wwv_flow_imp.g_varchar2_table(8329) := '64283229207C7C5C6E202020202020707932203E202B6D6D61782879312C207932292E746F4669786564283229207C7C5C6E202020202020707932203C202B6D6D696E2879332C207934292E746F4669786564283229207C7C5C6E202020202020707932';
wwv_flow_imp.g_varchar2_table(8330) := '203E202B6D6D61782879332C207934292E746F46697865642832295C6E202029207B5C6E2020202072657475726E3B5C6E20207D5C6E5C6E202072657475726E207B20783A2070782C20793A207079207D3B5C6E7D5C6E5C6E66756E6374696F6E206669';
wwv_flow_imp.g_varchar2_table(8331) := '784572726F72286E756D62657229207B5C6E202072657475726E204D6174682E726F756E64286E756D626572202A2031303030303030303030303029202F203130303030303030303030303B5C6E7D5C6E5C6E66756E6374696F6E2066696E6442657A69';
wwv_flow_imp.g_varchar2_table(8332) := '6572496E74657273656374696F6E732862657A312C2062657A322C206A757374436F756E7429207B5C6E20207661722062626F7831203D2062657A69657242426F782862657A31292C5C6E20202020202062626F7832203D2062657A69657242426F7828';
wwv_flow_imp.g_varchar2_table(8333) := '62657A32293B5C6E5C6E20206966202821697342426F78496E746572736563742862626F78312C2062626F78322929207B5C6E2020202072657475726E206A757374436F756E74203F2030203A205B5D3B5C6E20207D5C6E5C6E20202F2F20417320616E';
wwv_flow_imp.g_varchar2_table(8334) := '206F7074696D697A6174696F6E2C206C696E65732077696C6C2068617665206F6E6C792031207365676D656E745C6E5C6E2020766172206C31203D2062657A6C656E282E2E2E62657A31292C5C6E2020202020206C32203D2062657A6C656E282E2E2E62';
wwv_flow_imp.g_varchar2_table(8335) := '657A32292C5C6E2020202020206E31203D2069734C696E652862657A3129203F2031203A207E7E286C31202F203529207C7C20312C5C6E2020202020206E32203D2069734C696E652862657A3229203F2031203A207E7E286C32202F203529207C7C2031';
wwv_flow_imp.g_varchar2_table(8336) := '2C5C6E202020202020646F747331203D205B5D2C5C6E202020202020646F747332203D205B5D2C5C6E2020202020207879203D207B7D2C5C6E202020202020726573203D206A757374436F756E74203F2030203A205B5D3B5C6E5C6E2020666F72202876';
wwv_flow_imp.g_varchar2_table(8337) := '61722069203D20303B2069203C206E31202B20313B20692B2B29207B5C6E202020207661722070203D2066696E64446F747341745365676D656E74282E2E2E62657A312C2069202F206E31293B5C6E20202020646F7473312E70757368287B20783A2070';
wwv_flow_imp.g_varchar2_table(8338) := '2E782C20793A20702E792C20743A2069202F206E31207D293B5C6E20207D5C6E5C6E2020666F72202869203D20303B2069203C206E32202B20313B20692B2B29207B5C6E2020202070203D2066696E64446F747341745365676D656E74282E2E2E62657A';
wwv_flow_imp.g_varchar2_table(8339) := '322C2069202F206E32293B5C6E20202020646F7473322E70757368287B20783A20702E782C20793A20702E792C20743A2069202F206E32207D293B5C6E20207D5C6E5C6E2020666F72202869203D20303B2069203C206E313B20692B2B29207B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(8340) := '20202020666F722028766172206A203D20303B206A203C206E323B206A2B2B29207B5C6E202020202020766172206469203D20646F7473315B695D2C5C6E20202020202020202020646931203D20646F7473315B69202B20315D2C5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(8341) := '202020646A203D20646F7473325B6A5D2C5C6E20202020202020202020646A31203D20646F7473325B6A202B20315D2C5C6E202020202020202020206369203D20616273286469312E78202D2064692E7829203C202E3031203F20277927203A20277827';
wwv_flow_imp.g_varchar2_table(8342) := '2C5C6E20202020202020202020636A203D2061627328646A312E78202D20646A2E7829203C202E3031203F20277927203A202778272C5C6E202020202020202020206973203D20696E746572736563744C696E65732864692E782C2064692E792C206469';
wwv_flow_imp.g_varchar2_table(8343) := '312E782C206469312E792C20646A2E782C20646A2E792C20646A312E782C20646A312E79292C5C6E202020202020202020206B65793B5C6E5C6E20202020202069662028697329207B5C6E20202020202020206B6579203D2069732E782E746F46697865';
wwv_flow_imp.g_varchar2_table(8344) := '64283929202B20272327202B2069732E792E746F46697865642839293B5C6E5C6E20202020202020206966202878795B6B65795D29207B5C6E20202020202020202020636F6E74696E75653B5C6E20202020202020207D5C6E5C6E202020202020202078';
wwv_flow_imp.g_varchar2_table(8345) := '795B6B65795D203D20747275653B5C6E5C6E2020202020202020766172207431203D2064692E74202B20616273282869735B63695D202D2064695B63695D29202F20286469315B63695D202D2064695B63695D2929202A20286469312E74202D2064692E';
wwv_flow_imp.g_varchar2_table(8346) := '74292C5C6E2020202020202020202020207432203D20646A2E74202B20616273282869735B636A5D202D20646A5B636A5D29202F2028646A315B636A5D202D20646A5B636A5D2929202A2028646A312E74202D20646A2E74293B5C6E5C6E202020202020';
wwv_flow_imp.g_varchar2_table(8347) := '2020696620287431203E3D2030202626207431203C3D2031202626207432203E3D2030202626207432203C3D203129207B5C6E5C6E20202020202020202020696620286A757374436F756E7429207B5C6E2020202020202020202020207265732B2B3B5C';
wwv_flow_imp.g_varchar2_table(8348) := '6E202020202020202020207D20656C7365207B5C6E2020202020202020202020207265732E70757368287B5C6E2020202020202020202020202020783A2069732E782C5C6E2020202020202020202020202020793A2069732E792C5C6E20202020202020';
wwv_flow_imp.g_varchar2_table(8349) := '2020202020202074313A2074312C5C6E202020202020202020202020202074323A2074325C6E2020202020202020202020207D293B5C6E202020202020202020207D5C6E20202020202020207D5C6E2020202020207D5C6E202020207D5C6E20207D5C6E';
wwv_flow_imp.g_varchar2_table(8350) := '5C6E202072657475726E207265733B5C6E7D5C6E5C6E5C6E2F2A2A5C6E202A2046696E64206F7220636F756E74732074686520696E74657273656374696F6E73206265747765656E2074776F205356472070617468732E5C6E202A5C6E202A2052657475';
wwv_flow_imp.g_varchar2_table(8351) := '726E732061206E756D62657220696E20636F756E74696E67206D6F646520616E642061206C697374206F6620696E74657273656374696F6E73206F74686572776973652E5C6E202A5C6E202A20412073696E676C6520696E74657273656374696F6E2065';
wwv_flow_imp.g_varchar2_table(8352) := '6E74727920636F6E7461696E732074686520696E74657273656374696F6E20636F6F7264696E617465732028782C2079295C6E202A2061732077656C6C206173206164646974696F6E616C20696E666F726D6174696F6E20726567617264696E67207468';
wwv_flow_imp.g_varchar2_table(8353) := '6520696E74657273656374696E67207365676D656E74735C6E202A206F6E2065616368207061746820287365676D656E74312C207365676D656E74322920616E64207468652072656C6174697665206C6F636174696F6E206F66207468655C6E202A2069';
wwv_flow_imp.g_varchar2_table(8354) := '6E74657273656374696F6E206F6E207468657365207365676D656E7473202874312C207432292E5C6E202A5C6E202A205468652070617468206D617920626520616E20535647207061746820737472696E67206F722061206C697374206F662070617468';
wwv_flow_imp.g_varchar2_table(8355) := '20636F6D706F6E656E74735C6E202A207375636820617320605B205B20274D272C20302C203130205D2C205B20274C272C2032302C2030205D205D602E5C6E202A5C6E202A20406578616D706C655C6E202A5C6E202A2076617220696E74657273656374';
wwv_flow_imp.g_varchar2_table(8356) := '696F6E73203D2066696E6450617468496E74657273656374696F6E73285C6E202A202020274D302C304C3130302C313030272C5C6E202A2020205B205B20274D272C20302C20313030205D2C205B20274C272C203130302C2030205D205D5C6E202A2029';
wwv_flow_imp.g_varchar2_table(8357) := '3B5C6E202A5C6E202A202F2F20696E74657273656374696F6E73203D205B5C6E202A202F2F2020207B20783A2035302C20793A2035302C207365676D656E74313A20312C207365676D656E74323A20312C2074313A20302E352C2074323A20302E35207D';
wwv_flow_imp.g_varchar2_table(8358) := '5C6E202A202F2F205D5C6E202A5C6E202A2040706172616D207B537472696E677C41727261793C506174684465663E7D2070617468315C6E202A2040706172616D207B537472696E677C41727261793C506174684465663E7D2070617468325C6E202A20';
wwv_flow_imp.g_varchar2_table(8359) := '40706172616D207B426F6F6C65616E7D205B6A757374436F756E743D66616C73655D5C6E202A5C6E202A204072657475726E207B41727261793C496E74657273656374696F6E3E7C4E756D6265727D5C6E202A2F5C6E6578706F72742064656661756C74';
wwv_flow_imp.g_varchar2_table(8360) := '2066756E6374696F6E2066696E6450617468496E74657273656374696F6E732870617468312C2070617468322C206A757374436F756E7429207B5C6E20207061746831203D2070617468546F4375727665287061746831293B5C6E20207061746832203D';
wwv_flow_imp.g_varchar2_table(8361) := '2070617468546F4375727665287061746832293B5C6E5C6E20207661722078312C2079312C2078322C2079322C2078316D2C2079316D2C2078326D2C2079326D2C2062657A312C2062657A322C5C6E202020202020726573203D206A757374436F756E74';
wwv_flow_imp.g_varchar2_table(8362) := '203F2030203A205B5D3B5C6E5C6E2020666F7220287661722069203D20302C206969203D2070617468312E6C656E6774683B2069203C2069693B20692B2B29207B5C6E20202020766172207069203D2070617468315B695D3B5C6E5C6E20202020696620';
wwv_flow_imp.g_varchar2_table(8363) := '2870695B305D203D3D20274D2729207B5C6E2020202020207831203D2078316D203D2070695B315D3B5C6E2020202020207931203D2079316D203D2070695B325D3B5C6E202020207D20656C7365207B5C6E5C6E2020202020206966202870695B305D20';
wwv_flow_imp.g_varchar2_table(8364) := '3D3D2027432729207B5C6E202020202020202062657A31203D205B2078312C2079312C202E2E2E70692E736C696365283129205D3B5C6E20202020202020207831203D2062657A315B365D3B5C6E20202020202020207931203D2062657A315B375D3B5C';
wwv_flow_imp.g_varchar2_table(8365) := '6E2020202020207D20656C7365207B5C6E202020202020202062657A31203D205B2078312C2079312C2078312C2079312C2078316D2C2079316D2C2078316D2C2079316D205D3B5C6E20202020202020207831203D2078316D3B5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(8366) := '7931203D2079316D3B5C6E2020202020207D5C6E5C6E202020202020666F722028766172206A203D20302C206A6A203D2070617468322E6C656E6774683B206A203C206A6A3B206A2B2B29207B5C6E202020202020202076617220706A203D2070617468';
wwv_flow_imp.g_varchar2_table(8367) := '325B6A5D3B5C6E5C6E202020202020202069662028706A5B305D203D3D20274D2729207B5C6E202020202020202020207832203D2078326D203D20706A5B315D3B5C6E202020202020202020207932203D2079326D203D20706A5B325D3B5C6E20202020';
wwv_flow_imp.g_varchar2_table(8368) := '202020207D20656C7365207B5C6E5C6E2020202020202020202069662028706A5B305D203D3D2027432729207B5C6E20202020202020202020202062657A32203D205B2078322C2079322C202E2E2E706A2E736C696365283129205D3B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(8369) := '202020202020207832203D2062657A325B365D3B5C6E2020202020202020202020207932203D2062657A325B375D3B5C6E202020202020202020207D20656C7365207B5C6E20202020202020202020202062657A32203D205B2078322C2079322C207832';
wwv_flow_imp.g_varchar2_table(8370) := '2C2079322C2078326D2C2079326D2C2078326D2C2079326D205D3B5C6E2020202020202020202020207832203D2078326D3B5C6E2020202020202020202020207932203D2079326D3B5C6E202020202020202020207D5C6E5C6E20202020202020202020';
wwv_flow_imp.g_varchar2_table(8371) := '76617220696E7472203D2066696E6442657A696572496E74657273656374696F6E732862657A312C2062657A322C206A757374436F756E74293B5C6E5C6E20202020202020202020696620286A757374436F756E7429207B5C6E20202020202020202020';
wwv_flow_imp.g_varchar2_table(8372) := '2020726573202B3D20696E74723B5C6E202020202020202020207D20656C7365207B5C6E5C6E202020202020202020202020666F722028766172206B203D20302C206B6B203D20696E74722E6C656E6774683B206B203C206B6B3B206B2B2B29207B5C6E';
wwv_flow_imp.g_varchar2_table(8373) := '2020202020202020202020202020696E74725B6B5D2E7365676D656E7431203D20693B5C6E2020202020202020202020202020696E74725B6B5D2E7365676D656E7432203D206A3B5C6E2020202020202020202020202020696E74725B6B5D2E62657A31';
wwv_flow_imp.g_varchar2_table(8374) := '203D2062657A313B5C6E2020202020202020202020202020696E74725B6B5D2E62657A32203D2062657A323B5C6E2020202020202020202020207D5C6E5C6E202020202020202020202020726573203D207265732E636F6E63617428696E7472293B5C6E';
wwv_flow_imp.g_varchar2_table(8375) := '202020202020202020207D5C6E20202020202020207D5C6E2020202020207D5C6E202020207D5C6E20207D5C6E5C6E202072657475726E207265733B5C6E7D5C6E5C6E5C6E66756E6374696F6E2070617468546F4162736F6C7574652870617468417272';
wwv_flow_imp.g_varchar2_table(8376) := '617929207B5C6E202076617220707468203D20706174687328706174684172726179293B5C6E5C6E2020696620287074682E61627329207B5C6E2020202072657475726E2070617468436C6F6E65287074682E616273293B5C6E20207D5C6E5C6E202069';
wwv_flow_imp.g_varchar2_table(8377) := '66202821697341727261792870617468417272617929207C7C20216973417272617928706174684172726179202626207061746841727261795B305D2929207B202F2F20726F75676820617373756D7074696F6E5C6E2020202070617468417272617920';
wwv_flow_imp.g_varchar2_table(8378) := '3D20706172736550617468537472696E6728706174684172726179293B5C6E20207D5C6E5C6E20206966202821706174684172726179207C7C20217061746841727261792E6C656E67746829207B5C6E2020202072657475726E205B205B20274D272C20';
wwv_flow_imp.g_varchar2_table(8379) := '302C2030205D205D3B5C6E20207D5C6E5C6E202076617220726573203D205B5D2C5C6E20202020202078203D20302C5C6E20202020202079203D20302C5C6E2020202020206D78203D20302C5C6E2020202020206D79203D20302C5C6E20202020202073';
wwv_flow_imp.g_varchar2_table(8380) := '74617274203D20302C5C6E2020202020207061303B5C6E5C6E2020696620287061746841727261795B305D5B305D203D3D20274D2729207B5C6E2020202078203D202B7061746841727261795B305D5B315D3B5C6E2020202079203D202B706174684172';
wwv_flow_imp.g_varchar2_table(8381) := '7261795B305D5B325D3B5C6E202020206D78203D20783B5C6E202020206D79203D20793B5C6E2020202073746172742B2B3B5C6E202020207265735B305D203D205B20274D272C20782C2079205D3B5C6E20207D5C6E5C6E2020666F7220287661722072';
wwv_flow_imp.g_varchar2_table(8382) := '2C2070612C2069203D2073746172742C206969203D207061746841727261792E6C656E6774683B2069203C2069693B20692B2B29207B5C6E202020207265732E707573682872203D205B5D293B5C6E202020207061203D207061746841727261795B695D';
wwv_flow_imp.g_varchar2_table(8383) := '3B5C6E20202020706130203D2070615B305D3B5C6E5C6E202020206966202870613020213D207061302E746F557070657243617365282929207B5C6E202020202020725B305D203D207061302E746F55707065724361736528293B5C6E5C6E2020202020';
wwv_flow_imp.g_varchar2_table(8384) := '207377697463682028725B305D29207B5C6E20202020202063617365202741273A5C6E2020202020202020725B315D203D2070615B315D3B5C6E2020202020202020725B325D203D2070615B325D3B5C6E2020202020202020725B335D203D2070615B33';
wwv_flow_imp.g_varchar2_table(8385) := '5D3B5C6E2020202020202020725B345D203D2070615B345D3B5C6E2020202020202020725B355D203D2070615B355D3B5C6E2020202020202020725B365D203D202B70615B365D202B20783B5C6E2020202020202020725B375D203D202B70615B375D20';
wwv_flow_imp.g_varchar2_table(8386) := '2B20793B5C6E2020202020202020627265616B3B5C6E20202020202063617365202756273A5C6E2020202020202020725B315D203D202B70615B315D202B20793B5C6E2020202020202020627265616B3B5C6E20202020202063617365202748273A5C6E';
wwv_flow_imp.g_varchar2_table(8387) := '2020202020202020725B315D203D202B70615B315D202B20783B5C6E2020202020202020627265616B3B5C6E2020202020206361736520274D273A5C6E20202020202020206D78203D202B70615B315D202B20783B5C6E20202020202020206D79203D20';
wwv_flow_imp.g_varchar2_table(8388) := '2B70615B325D202B20793B5C6E20202020202064656661756C743A5C6E2020202020202020666F722028766172206A203D20312C206A6A203D2070612E6C656E6774683B206A203C206A6A3B206A2B2B29207B5C6E20202020202020202020725B6A5D20';
wwv_flow_imp.g_varchar2_table(8389) := '3D202B70615B6A5D202B2028286A2025203229203F2078203A2079293B5C6E20202020202020207D5C6E2020202020207D5C6E202020207D20656C7365207B5C6E202020202020666F722028766172206B203D20302C206B6B203D2070612E6C656E6774';
wwv_flow_imp.g_varchar2_table(8390) := '683B206B203C206B6B3B206B2B2B29207B5C6E2020202020202020725B6B5D203D2070615B6B5D3B5C6E2020202020207D5C6E202020207D5C6E20202020706130203D207061302E746F55707065724361736528293B5C6E5C6E20202020737769746368';
wwv_flow_imp.g_varchar2_table(8391) := '2028725B305D29207B5C6E202020206361736520275A273A5C6E20202020202078203D202B6D783B5C6E20202020202079203D202B6D793B5C6E202020202020627265616B3B5C6E2020202063617365202748273A5C6E20202020202078203D20725B31';
wwv_flow_imp.g_varchar2_table(8392) := '5D3B5C6E202020202020627265616B3B5C6E2020202063617365202756273A5C6E20202020202079203D20725B315D3B5C6E202020202020627265616B3B5C6E202020206361736520274D273A5C6E2020202020206D78203D20725B722E6C656E677468';
wwv_flow_imp.g_varchar2_table(8393) := '202D20325D3B5C6E2020202020206D79203D20725B722E6C656E677468202D20315D3B5C6E2020202064656661756C743A5C6E20202020202078203D20725B722E6C656E677468202D20325D3B5C6E20202020202079203D20725B722E6C656E67746820';
wwv_flow_imp.g_varchar2_table(8394) := '2D20315D3B5C6E202020207D5C6E20207D5C6E5C6E20207265732E746F537472696E67203D2070617468546F537472696E673B5C6E20207074682E616273203D2070617468436C6F6E6528726573293B5C6E5C6E202072657475726E207265733B5C6E7D';
wwv_flow_imp.g_varchar2_table(8395) := '5C6E5C6E66756E6374696F6E2069734C696E652862657A29207B5C6E202072657475726E20285C6E2020202062657A5B305D203D3D3D2062657A5B325D2026265C6E2020202062657A5B315D203D3D3D2062657A5B335D2026265C6E2020202062657A5B';
wwv_flow_imp.g_varchar2_table(8396) := '345D203D3D3D2062657A5B365D2026265C6E2020202062657A5B355D203D3D3D2062657A5B375D5C6E2020293B5C6E7D5C6E5C6E66756E6374696F6E206C696E65546F43757276652878312C2079312C2078322C20793229207B5C6E202072657475726E';
wwv_flow_imp.g_varchar2_table(8397) := '205B5C6E2020202078312C2079312C2078322C5C6E2020202079322C2078322C2079325C6E20205D3B5C6E7D5C6E5C6E66756E6374696F6E207175626963546F43757276652878312C2079312C2061782C2061792C2078322C20793229207B5C6E202076';
wwv_flow_imp.g_varchar2_table(8398) := '6172205F3133203D2031202F20332C5C6E2020202020205F3233203D2032202F20333B5C6E5C6E202072657475726E205B5C6E202020205F3133202A207831202B205F3233202A2061782C5C6E202020205F3133202A207931202B205F3233202A206179';
wwv_flow_imp.g_varchar2_table(8399) := '2C5C6E202020205F3133202A207832202B205F3233202A2061782C5C6E202020205F3133202A207932202B205F3233202A2061792C5C6E2020202078322C5C6E2020202079325C6E20205D3B5C6E7D5C6E5C6E66756E6374696F6E20617263546F437572';
wwv_flow_imp.g_varchar2_table(8400) := '76652878312C2079312C2072782C2072792C20616E676C652C206C617267655F6172635F666C61672C2073776565705F666C61672C2078322C2079322C2072656375727369766529207B5C6E5C6E20202F2F20666F72206D6F726520696E666F726D6174';
wwv_flow_imp.g_varchar2_table(8401) := '696F6E206F662077686572652074686973206D6174682063616D652066726F6D2076697369743A5C6E20202F2F20687474703A2F2F7777772E77332E6F72672F54522F53564731312F696D706C6E6F74652E68746D6C23417263496D706C656D656E7461';
wwv_flow_imp.g_varchar2_table(8402) := '74696F6E4E6F7465735C6E2020766172205F313230203D205049202A20313230202F203138302C5C6E202020202020726164203D205049202F20313830202A20282B616E676C65207C7C2030292C5C6E202020202020726573203D205B5D2C5C6E202020';
wwv_flow_imp.g_varchar2_table(8403) := '20202078792C5C6E202020202020726F74617465203D206361636865722866756E6374696F6E28782C20792C2072616429207B5C6E20202020202020207661722058203D2078202A206D6174682E636F732872616429202D2079202A206D6174682E7369';
wwv_flow_imp.g_varchar2_table(8404) := '6E28726164292C5C6E20202020202020202020202059203D2078202A206D6174682E73696E2872616429202B2079202A206D6174682E636F7328726164293B5C6E5C6E202020202020202072657475726E207B20783A20582C20793A2059207D3B5C6E20';
wwv_flow_imp.g_varchar2_table(8405) := '20202020207D293B5C6E5C6E2020696620282172656375727369766529207B5C6E202020207879203D20726F746174652878312C2079312C202D726164293B5C6E202020207831203D2078792E783B5C6E202020207931203D2078792E793B5C6E202020';
wwv_flow_imp.g_varchar2_table(8406) := '207879203D20726F746174652878322C2079322C202D726164293B5C6E202020207832203D2078792E783B5C6E202020207932203D2078792E793B5C6E5C6E202020207661722078203D20287831202D20783229202F20322C5C6E202020202020202079';
wwv_flow_imp.g_varchar2_table(8407) := '203D20287931202D20793229202F20323B5C6E5C6E202020207661722068203D202878202A207829202F20287278202A20727829202B202879202A207929202F20287279202A207279293B5C6E5C6E202020206966202868203E203129207B5C6E202020';
wwv_flow_imp.g_varchar2_table(8408) := '20202068203D206D6174682E737172742868293B5C6E2020202020207278203D2068202A2072783B5C6E2020202020207279203D2068202A2072793B5C6E202020207D5C6E5C6E2020202076617220727832203D207278202A2072782C5C6E2020202020';
wwv_flow_imp.g_varchar2_table(8409) := '202020727932203D207279202A2072792C5C6E20202020202020206B203D20286C617267655F6172635F666C6167203D3D2073776565705F666C6167203F202D31203A203129202A5C6E2020202020202020202020206D6174682E737172742861627328';
wwv_flow_imp.g_varchar2_table(8410) := '28727832202A20727932202D20727832202A2079202A2079202D20727932202A2078202A207829202F2028727832202A2079202A2079202B20727932202A2078202A20782929292C5C6E20202020202020206378203D206B202A207278202A2079202F20';
wwv_flow_imp.g_varchar2_table(8411) := '7279202B20287831202B20783229202F20322C5C6E20202020202020206379203D206B202A202D7279202A2078202F207278202B20287931202B20793229202F20322C5C6E20202020202020206631203D206D6174682E6173696E2828287931202D2063';
wwv_flow_imp.g_varchar2_table(8412) := '7929202F207279292E746F4669786564283929292C5C6E20202020202020206632203D206D6174682E6173696E2828287932202D20637929202F207279292E746F4669786564283929293B5C6E5C6E202020206631203D207831203C206378203F205049';
wwv_flow_imp.g_varchar2_table(8413) := '202D206631203A2066313B5C6E202020206632203D207832203C206378203F205049202D206632203A2066323B5C6E202020206631203C203020262620286631203D205049202A2032202B206631293B5C6E202020206632203C20302026262028663220';
wwv_flow_imp.g_varchar2_table(8414) := '3D205049202A2032202B206632293B5C6E5C6E202020206966202873776565705F666C6167202626206631203E20663229207B5C6E2020202020206631203D206631202D205049202A20323B5C6E202020207D5C6E20202020696620282173776565705F';
wwv_flow_imp.g_varchar2_table(8415) := '666C6167202626206632203E20663129207B5C6E2020202020206632203D206632202D205049202A20323B5C6E202020207D5C6E20207D20656C7365207B5C6E202020206631203D207265637572736976655B305D3B5C6E202020206632203D20726563';
wwv_flow_imp.g_varchar2_table(8416) := '7572736976655B315D3B5C6E202020206378203D207265637572736976655B325D3B5C6E202020206379203D207265637572736976655B335D3B5C6E20207D5C6E5C6E2020766172206466203D206632202D2066313B5C6E5C6E20206966202861627328';
wwv_flow_imp.g_varchar2_table(8417) := '646629203E205F31323029207B5C6E202020207661722066326F6C64203D2066322C5C6E202020202020202078326F6C64203D2078322C5C6E202020202020202079326F6C64203D2079323B5C6E5C6E202020206632203D206631202B205F313230202A';
wwv_flow_imp.g_varchar2_table(8418) := '202873776565705F666C6167202626206632203E206631203F2031203A202D31293B5C6E202020207832203D206378202B207278202A206D6174682E636F73286632293B5C6E202020207932203D206379202B207279202A206D6174682E73696E286632';
wwv_flow_imp.g_varchar2_table(8419) := '293B5C6E20202020726573203D20617263546F43757276652878322C2079322C2072782C2072792C20616E676C652C20302C2073776565705F666C61672C2078326F6C642C2079326F6C642C205B2066322C2066326F6C642C2063782C206379205D293B';
wwv_flow_imp.g_varchar2_table(8420) := '5C6E20207D5C6E5C6E20206466203D206632202D2066313B5C6E5C6E2020766172206331203D206D6174682E636F73286631292C5C6E2020202020207331203D206D6174682E73696E286631292C5C6E2020202020206332203D206D6174682E636F7328';
wwv_flow_imp.g_varchar2_table(8421) := '6632292C5C6E2020202020207332203D206D6174682E73696E286632292C5C6E20202020202074203D206D6174682E74616E286466202F2034292C5C6E2020202020206878203D2034202F2033202A207278202A20742C5C6E2020202020206879203D20';
wwv_flow_imp.g_varchar2_table(8422) := '34202F2033202A207279202A20742C5C6E2020202020206D31203D205B2078312C207931205D2C5C6E2020202020206D32203D205B207831202B206878202A2073312C207931202D206879202A206331205D2C5C6E2020202020206D33203D205B207832';
wwv_flow_imp.g_varchar2_table(8423) := '202B206878202A2073322C207932202D206879202A206332205D2C5C6E2020202020206D34203D205B2078322C207932205D3B5C6E5C6E20206D325B305D203D2032202A206D315B305D202D206D325B305D3B5C6E20206D325B315D203D2032202A206D';
wwv_flow_imp.g_varchar2_table(8424) := '315B315D202D206D325B315D3B5C6E5C6E20206966202872656375727369766529207B5C6E2020202072657475726E205B206D322C206D332C206D34205D2E636F6E63617428726573293B5C6E20207D20656C7365207B5C6E20202020726573203D205B';
wwv_flow_imp.g_varchar2_table(8425) := '206D322C206D332C206D34205D2E636F6E63617428726573292E6A6F696E28292E73706C697428272C27293B5C6E20202020766172206E6577726573203D205B5D3B5C6E5C6E20202020666F7220287661722069203D20302C206969203D207265732E6C';
wwv_flow_imp.g_varchar2_table(8426) := '656E6774683B2069203C2069693B20692B2B29207B5C6E2020202020206E65777265735B695D203D206920252032203F20726F74617465287265735B69202D20315D2C207265735B695D2C20726164292E79203A20726F74617465287265735B695D2C20';
wwv_flow_imp.g_varchar2_table(8427) := '7265735B69202B20315D2C20726164292E783B5C6E202020207D5C6E5C6E2020202072657475726E206E65777265733B5C6E20207D5C6E7D5C6E5C6E2F2F2052657475726E7320626F756E64696E6720626F78206F662063756269632062657A69657220';
wwv_flow_imp.g_varchar2_table(8428) := '63757276652E5C6E2F2F20536F757263653A20687474703A2F2F626C6F672E6861636B6572732D636166652E6E65742F323030392F30362F686F772D746F2D63616C63756C6174652D62657A6965722D6375727665732D626F756E64696E672E68746D6C';
wwv_flow_imp.g_varchar2_table(8429) := '5C6E2F2F204F726967696E616C2076657273696F6E3A204E495348494F204869726F6B617A755C6E2F2F204D6F64696669636174696F6E733A2068747470733A2F2F6769746875622E636F6D2F74696D6F32323334355C6E66756E6374696F6E20637572';
wwv_flow_imp.g_varchar2_table(8430) := '766542426F782878302C2079302C2078312C2079312C2078322C2079322C2078332C20793329207B5C6E2020766172207476616C756573203D205B5D2C5C6E202020202020626F756E6473203D205B205B5D2C205B5D205D2C5C6E202020202020612C20';
wwv_flow_imp.g_varchar2_table(8431) := '622C20632C20742C2074312C2074322C20623261632C2073717274623261633B5C6E5C6E2020666F7220287661722069203D20303B2069203C20323B202B2B6929207B5C6E5C6E202020206966202869203D3D203029207B5C6E20202020202062203D20';
wwv_flow_imp.g_varchar2_table(8432) := '36202A207830202D203132202A207831202B2036202A2078323B5C6E20202020202061203D202D33202A207830202B2039202A207831202D2039202A207832202B2033202A2078333B5C6E20202020202063203D2033202A207831202D2033202A207830';
wwv_flow_imp.g_varchar2_table(8433) := '3B5C6E202020207D20656C7365207B5C6E20202020202062203D2036202A207930202D203132202A207931202B2036202A2079323B5C6E20202020202061203D202D33202A207930202B2039202A207931202D2039202A207932202B2033202A2079333B';
wwv_flow_imp.g_varchar2_table(8434) := '5C6E20202020202063203D2033202A207931202D2033202A2079303B5C6E202020207D5C6E5C6E2020202069662028616273286129203C2031652D313229207B5C6E5C6E20202020202069662028616273286229203C2031652D313229207B5C6E202020';
wwv_flow_imp.g_varchar2_table(8435) := '2020202020636F6E74696E75653B5C6E2020202020207D5C6E5C6E20202020202074203D202D63202F20623B5C6E5C6E2020202020206966202830203C20742026262074203C203129207B5C6E20202020202020207476616C7565732E70757368287429';
wwv_flow_imp.g_varchar2_table(8436) := '3B5C6E2020202020207D5C6E5C6E202020202020636F6E74696E75653B5C6E202020207D5C6E5C6E2020202062326163203D2062202A2062202D2034202A2063202A20613B5C6E202020207371727462326163203D206D6174682E737172742862326163';
wwv_flow_imp.g_varchar2_table(8437) := '293B5C6E5C6E202020206966202862326163203C203029207B5C6E202020202020636F6E74696E75653B5C6E202020207D5C6E5C6E202020207431203D20282D62202B20737172746232616329202F202832202A2061293B5C6E5C6E2020202069662028';
wwv_flow_imp.g_varchar2_table(8438) := '30203C207431202626207431203C203129207B5C6E2020202020207476616C7565732E70757368287431293B5C6E202020207D5C6E5C6E202020207432203D20282D62202D20737172746232616329202F202832202A2061293B5C6E5C6E202020206966';
wwv_flow_imp.g_varchar2_table(8439) := '202830203C207432202626207432203C203129207B5C6E2020202020207476616C7565732E70757368287432293B5C6E202020207D5C6E20207D5C6E5C6E2020766172206A203D207476616C7565732E6C656E6774682C5C6E2020202020206A6C656E20';
wwv_flow_imp.g_varchar2_table(8440) := '3D206A2C5C6E2020202020206D743B5C6E5C6E20207768696C6520286A2D2D29207B5C6E2020202074203D207476616C7565735B6A5D3B5C6E202020206D74203D2031202D20743B5C6E20202020626F756E64735B305D5B6A5D203D20286D74202A206D';
wwv_flow_imp.g_varchar2_table(8441) := '74202A206D74202A20783029202B202833202A206D74202A206D74202A2074202A20783129202B202833202A206D74202A2074202A2074202A20783229202B202874202A2074202A2074202A207833293B5C6E20202020626F756E64735B315D5B6A5D20';
wwv_flow_imp.g_varchar2_table(8442) := '3D20286D74202A206D74202A206D74202A20793029202B202833202A206D74202A206D74202A2074202A20793129202B202833202A206D74202A2074202A2074202A20793229202B202874202A2074202A2074202A207933293B5C6E20207D5C6E5C6E20';
wwv_flow_imp.g_varchar2_table(8443) := '20626F756E64735B305D5B6A6C656E5D203D2078303B5C6E2020626F756E64735B315D5B6A6C656E5D203D2079303B5C6E2020626F756E64735B305D5B6A6C656E202B20315D203D2078333B5C6E2020626F756E64735B315D5B6A6C656E202B20315D20';
wwv_flow_imp.g_varchar2_table(8444) := '3D2079333B5C6E2020626F756E64735B305D2E6C656E677468203D20626F756E64735B315D2E6C656E677468203D206A6C656E202B20323B5C6E5C6E202072657475726E207B5C6E2020202078303A206D6D696E282E2E2E626F756E64735B305D292C5C';
wwv_flow_imp.g_varchar2_table(8445) := '6E2020202079303A206D6D696E282E2E2E626F756E64735B315D292C5C6E2020202078313A206D6D6178282E2E2E626F756E64735B305D292C5C6E2020202079313A206D6D6178282E2E2E626F756E64735B315D295C6E20207D3B5C6E7D5C6E5C6E6675';
wwv_flow_imp.g_varchar2_table(8446) := '6E6374696F6E2070617468546F4375727665287061746829207B5C6E5C6E202076617220707468203D2070617468732870617468293B5C6E5C6E20202F2F2072657475726E206361636865642063757276652C206966206578697374696E675C6E202069';
wwv_flow_imp.g_varchar2_table(8447) := '6620287074682E637572766529207B5C6E2020202072657475726E2070617468436C6F6E65287074682E6375727665293B5C6E20207D5C6E5C6E20207661722063757276656450617468203D2070617468546F4162736F6C7574652870617468292C5C6E';
wwv_flow_imp.g_varchar2_table(8448) := '2020202020206174747273203D207B20783A20302C20793A20302C2062783A20302C2062793A20302C20583A20302C20593A20302C2071783A206E756C6C2C2071793A206E756C6C207D2C5C6E20202020202070726F6365737350617468203D2066756E';
wwv_flow_imp.g_varchar2_table(8449) := '6374696F6E28706174682C20642C2070617468436F6D6D616E6429207B5C6E2020202020202020766172206E782C206E793B5C6E5C6E202020202020202069662028217061746829207B5C6E2020202020202020202072657475726E205B202743272C20';
wwv_flow_imp.g_varchar2_table(8450) := '642E782C20642E792C20642E782C20642E792C20642E782C20642E79205D3B5C6E20202020202020207D5C6E5C6E20202020202020202128706174685B305D20696E207B20543A20312C20513A2031207D292026262028642E7178203D20642E7179203D';
wwv_flow_imp.g_varchar2_table(8451) := '206E756C6C293B5C6E5C6E20202020202020207377697463682028706174685B305D29207B5C6E20202020202020206361736520274D273A5C6E20202020202020202020642E58203D20706174685B315D3B5C6E20202020202020202020642E59203D20';
wwv_flow_imp.g_varchar2_table(8452) := '706174685B325D3B5C6E20202020202020202020627265616B3B5C6E202020202020202063617365202741273A5C6E2020202020202020202070617468203D205B202743272C202E2E2E617263546F437572766528642E782C20642E792C202E2E2E7061';
wwv_flow_imp.g_varchar2_table(8453) := '74682E736C69636528312929205D3B5C6E20202020202020202020627265616B3B5C6E202020202020202063617365202753273A5C6E202020202020202020206966202870617468436F6D6D616E64203D3D20274327207C7C2070617468436F6D6D616E';
wwv_flow_imp.g_varchar2_table(8454) := '64203D3D2027532729207B5C6E5C6E2020202020202020202020202F2F20496E202753272063617365207765206861766520746F2074616B6520696E746F206163636F756E742C206966207468652070726576696F757320636F6D6D616E642069732043';
wwv_flow_imp.g_varchar2_table(8455) := '2F532E5C6E2020202020202020202020206E78203D20642E78202A2032202D20642E62783B5C6E5C6E2020202020202020202020202F2F20416E64207265666C656374207468652070726576696F75735C6E2020202020202020202020206E79203D2064';
wwv_flow_imp.g_varchar2_table(8456) := '2E79202A2032202D20642E62793B5C6E5C6E2020202020202020202020202F2F20636F6D6D616E64277320636F6E74726F6C20706F696E742072656C617469766520746F207468652063757272656E7420706F696E742E5C6E202020202020202020207D';
wwv_flow_imp.g_varchar2_table(8457) := '5C6E20202020202020202020656C7365207B5C6E5C6E2020202020202020202020202F2F206F7220736F6D6520656C7365206F72206E6F7468696E675C6E2020202020202020202020206E78203D20642E783B5C6E2020202020202020202020206E7920';
wwv_flow_imp.g_varchar2_table(8458) := '3D20642E793B5C6E202020202020202020207D5C6E2020202020202020202070617468203D205B202743272C206E782C206E792C202E2E2E706174682E736C696365283129205D3B5C6E20202020202020202020627265616B3B5C6E2020202020202020';
wwv_flow_imp.g_varchar2_table(8459) := '63617365202754273A5C6E202020202020202020206966202870617468436F6D6D616E64203D3D20275127207C7C2070617468436F6D6D616E64203D3D2027542729207B5C6E5C6E2020202020202020202020202F2F20496E2027542720636173652077';
wwv_flow_imp.g_varchar2_table(8460) := '65206861766520746F2074616B6520696E746F206163636F756E742C206966207468652070726576696F757320636F6D6D616E6420697320512F542E5C6E202020202020202020202020642E7178203D20642E78202A2032202D20642E71783B5C6E5C6E';
wwv_flow_imp.g_varchar2_table(8461) := '2020202020202020202020202F2F20416E64206D616B652061207265666C656374696F6E2073696D696C61725C6E202020202020202020202020642E7179203D20642E79202A2032202D20642E71793B5C6E5C6E2020202020202020202020202F2F2074';
wwv_flow_imp.g_varchar2_table(8462) := '6F2063617365202753272E5C6E202020202020202020207D5C6E20202020202020202020656C7365207B5C6E5C6E2020202020202020202020202F2F206F7220736F6D657468696E6720656C7365206F72206E6F7468696E675C6E202020202020202020';
wwv_flow_imp.g_varchar2_table(8463) := '202020642E7178203D20642E783B5C6E202020202020202020202020642E7179203D20642E793B5C6E202020202020202020207D5C6E2020202020202020202070617468203D205B202743272C202E2E2E7175626963546F437572766528642E782C2064';
wwv_flow_imp.g_varchar2_table(8464) := '2E792C20642E71782C20642E71792C20706174685B315D2C20706174685B325D29205D3B5C6E20202020202020202020627265616B3B5C6E202020202020202063617365202751273A5C6E20202020202020202020642E7178203D20706174685B315D3B';
wwv_flow_imp.g_varchar2_table(8465) := '5C6E20202020202020202020642E7179203D20706174685B325D3B5C6E2020202020202020202070617468203D205B202743272C202E2E2E7175626963546F437572766528642E782C20642E792C20706174685B315D2C20706174685B325D2C20706174';
wwv_flow_imp.g_varchar2_table(8466) := '685B335D2C20706174685B345D29205D3B5C6E20202020202020202020627265616B3B5C6E20202020202020206361736520274C273A5C6E2020202020202020202070617468203D205B202743272C202E2E2E6C696E65546F437572766528642E782C20';
wwv_flow_imp.g_varchar2_table(8467) := '642E792C20706174685B315D2C20706174685B325D29205D3B5C6E20202020202020202020627265616B3B5C6E202020202020202063617365202748273A5C6E2020202020202020202070617468203D205B202743272C202E2E2E6C696E65546F437572';
wwv_flow_imp.g_varchar2_table(8468) := '766528642E782C20642E792C20706174685B315D2C20642E7929205D3B5C6E20202020202020202020627265616B3B5C6E202020202020202063617365202756273A5C6E2020202020202020202070617468203D205B202743272C202E2E2E6C696E6554';
wwv_flow_imp.g_varchar2_table(8469) := '6F437572766528642E782C20642E792C20642E782C20706174685B315D29205D3B5C6E20202020202020202020627265616B3B5C6E20202020202020206361736520275A273A5C6E2020202020202020202070617468203D205B202743272C202E2E2E6C';
wwv_flow_imp.g_varchar2_table(8470) := '696E65546F437572766528642E782C20642E792C20642E582C20642E5929205D3B5C6E20202020202020202020627265616B3B5C6E20202020202020207D5C6E5C6E202020202020202072657475726E20706174683B5C6E2020202020207D2C5C6E5C6E';
wwv_flow_imp.g_varchar2_table(8471) := '202020202020666978417263203D2066756E6374696F6E2870702C206929207B5C6E5C6E20202020202020206966202870705B695D2E6C656E677468203E203729207B5C6E2020202020202020202070705B695D2E736869667428293B5C6E2020202020';
wwv_flow_imp.g_varchar2_table(8472) := '2020202020766172207069203D2070705B695D3B5C6E5C6E202020202020202020207768696C65202870692E6C656E67746829207B5C6E20202020202020202020202070617468436F6D6D616E64735B695D203D202741273B202F2F2069662063726561';
wwv_flow_imp.g_varchar2_table(8473) := '746564206D756C7469706C6520433A732C207468656972206F726967696E616C207365672069732073617665645C6E20202020202020202020202070702E73706C69636528692B2B2C20302C205B202743272C202E2E2E70692E73706C69636528302C20';
wwv_flow_imp.g_varchar2_table(8474) := '3629205D293B5C6E202020202020202020207D5C6E5C6E2020202020202020202070702E73706C69636528692C2031293B5C6E202020202020202020206969203D20637572766564506174682E6C656E6774683B5C6E20202020202020207D5C6E202020';
wwv_flow_imp.g_varchar2_table(8475) := '2020207D2C5C6E5C6E20202020202070617468436F6D6D616E6473203D205B5D2C202F2F207061746820636F6D6D616E6473206F66206F726967696E616C207061746820705C6E202020202020706669727374203D2027272C202F2F2074656D706F7261';
wwv_flow_imp.g_varchar2_table(8476) := '727920686F6C64657220666F72206F726967696E616C207061746820636F6D6D616E645C6E20202020202070617468436F6D6D616E64203D2027273B202F2F20686F6C64657220666F722070726576696F7573207061746820636F6D6D616E64206F6620';
wwv_flow_imp.g_varchar2_table(8477) := '6F726967696E616C20706174685C6E5C6E2020666F7220287661722069203D20302C206969203D20637572766564506174682E6C656E6774683B2069203C2069693B20692B2B29207B5C6E20202020637572766564506174685B695D2026262028706669';
wwv_flow_imp.g_varchar2_table(8478) := '727374203D20637572766564506174685B695D5B305D293B202F2F20736176652063757272656E74207061746820636F6D6D616E645C6E5C6E202020206966202870666972737420213D2027432729202F2F2043206973206E6F74207361766564207965';
wwv_flow_imp.g_varchar2_table(8479) := '742C2062656361757365206974206D617920626520726573756C74206F6620636F6E76657273696F6E5C6E202020207B5C6E20202020202070617468436F6D6D616E64735B695D203D207066697273743B202F2F20536176652063757272656E74207061';
wwv_flow_imp.g_varchar2_table(8480) := '746820636F6D6D616E645C6E20202020202069202626202870617468436F6D6D616E64203D2070617468436F6D6D616E64735B69202D20315D293B202F2F204765742070726576696F7573207061746820636F6D6D616E642070617468436F6D6D616E64';
wwv_flow_imp.g_varchar2_table(8481) := '5C6E202020207D5C6E20202020637572766564506174685B695D203D2070726F636573735061746828637572766564506174685B695D2C2061747472732C2070617468436F6D6D616E64293B202F2F2050726576696F7573207061746820636F6D6D616E';
wwv_flow_imp.g_varchar2_table(8482) := '6420697320696E70757474656420746F2070726F63657373506174685C6E5C6E202020206966202870617468436F6D6D616E64735B695D20213D2027412720262620706669727374203D3D20274327292070617468436F6D6D616E64735B695D203D2027';
wwv_flow_imp.g_varchar2_table(8483) := '43273B202F2F204120697320746865206F6E6C7920636F6D6D616E645C6E202020202F2F207768696368206D61792070726F64756365206D756C7469706C6520433A735C6E202020202F2F20736F207765206861766520746F206D616B65207375726520';
wwv_flow_imp.g_varchar2_table(8484) := '74686174204320697320616C736F204320696E206F726967696E616C20706174685C6E5C6E2020202066697841726328637572766564506174682C2069293B202F2F20666978417263206164647320616C736F2074686520726967687420616D6F756E74';
wwv_flow_imp.g_varchar2_table(8485) := '206F6620413A7320746F2070617468436F6D6D616E64735C6E5C6E2020202076617220736567203D20637572766564506174685B695D2C5C6E20202020202020207365676C656E203D207365672E6C656E6774683B5C6E5C6E2020202061747472732E78';
wwv_flow_imp.g_varchar2_table(8486) := '203D207365675B7365676C656E202D20325D3B5C6E2020202061747472732E79203D207365675B7365676C656E202D20315D3B5C6E2020202061747472732E6278203D20746F466C6F6174287365675B7365676C656E202D20345D29207C7C2061747472';
wwv_flow_imp.g_varchar2_table(8487) := '732E783B5C6E2020202061747472732E6279203D20746F466C6F6174287365675B7365676C656E202D20335D29207C7C2061747472732E793B5C6E20207D5C6E5C6E20202F2F2063616368652063757276655C6E20207074682E6375727665203D207061';
wwv_flow_imp.g_varchar2_table(8488) := '7468436C6F6E652863757276656450617468293B5C6E5C6E202072657475726E20637572766564506174683B5C6E7D222C222F2F20546865206D6F64756C652063616368655C6E766172205F5F7765627061636B5F6D6F64756C655F63616368655F5F20';
wwv_flow_imp.g_varchar2_table(8489) := '3D207B7D3B5C6E5C6E2F2F2054686520726571756972652066756E6374696F6E5C6E66756E6374696F6E205F5F7765627061636B5F726571756972655F5F286D6F64756C65496429207B5C6E5C742F2F20436865636B206966206D6F64756C6520697320';
wwv_flow_imp.g_varchar2_table(8490) := '696E2063616368655C6E5C74766172206361636865644D6F64756C65203D205F5F7765627061636B5F6D6F64756C655F63616368655F5F5B6D6F64756C6549645D3B5C6E5C74696620286361636865644D6F64756C6520213D3D20756E646566696E6564';
wwv_flow_imp.g_varchar2_table(8491) := '29207B5C6E5C745C7472657475726E206361636865644D6F64756C652E6578706F7274733B5C6E5C747D5C6E5C742F2F204372656174652061206E6577206D6F64756C652028616E642070757420697420696E746F20746865206361636865295C6E5C74';
wwv_flow_imp.g_varchar2_table(8492) := '766172206D6F64756C65203D205F5F7765627061636B5F6D6F64756C655F63616368655F5F5B6D6F64756C6549645D203D207B5C6E5C745C742F2F206E6F206D6F64756C652E6964206E65656465645C6E5C745C742F2F206E6F206D6F64756C652E6C6F';
wwv_flow_imp.g_varchar2_table(8493) := '61646564206E65656465645C6E5C745C746578706F7274733A207B7D5C6E5C747D3B5C6E5C6E5C742F2F204578656375746520746865206D6F64756C652066756E6374696F6E5C6E5C745F5F7765627061636B5F6D6F64756C65735F5F5B6D6F64756C65';
wwv_flow_imp.g_varchar2_table(8494) := '49645D286D6F64756C652C206D6F64756C652E6578706F7274732C205F5F7765627061636B5F726571756972655F5F293B5C6E5C6E5C742F2F2052657475726E20746865206578706F727473206F6620746865206D6F64756C655C6E5C7472657475726E';
wwv_flow_imp.g_varchar2_table(8495) := '206D6F64756C652E6578706F7274733B5C6E7D5C6E5C6E222C222F2F20646566696E65206765747465722066756E6374696F6E7320666F72206861726D6F6E79206578706F7274735C6E5F5F7765627061636B5F726571756972655F5F2E64203D202865';
wwv_flow_imp.g_varchar2_table(8496) := '78706F7274732C20646566696E6974696F6E29203D3E207B5C6E5C74666F7228766172206B657920696E20646566696E6974696F6E29207B5C6E5C745C746966285F5F7765627061636B5F726571756972655F5F2E6F28646566696E6974696F6E2C206B';
wwv_flow_imp.g_varchar2_table(8497) := '65792920262620215F5F7765627061636B5F726571756972655F5F2E6F286578706F7274732C206B65792929207B5C6E5C745C745C744F626A6563742E646566696E6550726F7065727479286578706F7274732C206B65792C207B20656E756D65726162';
wwv_flow_imp.g_varchar2_table(8498) := '6C653A20747275652C206765743A20646566696E6974696F6E5B6B65795D207D293B5C6E5C745C747D5C6E5C747D5C6E7D3B222C225F5F7765627061636B5F726571756972655F5F2E6F203D20286F626A2C2070726F7029203D3E20284F626A6563742E';
wwv_flow_imp.g_varchar2_table(8499) := '70726F746F747970652E6861734F776E50726F70657274792E63616C6C286F626A2C2070726F702929222C222F2F20646566696E65205F5F65734D6F64756C65206F6E206578706F7274735C6E5F5F7765627061636B5F726571756972655F5F2E72203D';
wwv_flow_imp.g_varchar2_table(8500) := '20286578706F72747329203D3E207B5C6E5C74696628747970656F662053796D626F6C20213D3D2027756E646566696E6564272026262053796D626F6C2E746F537472696E6754616729207B5C6E5C745C744F626A6563742E646566696E6550726F7065';
wwv_flow_imp.g_varchar2_table(8501) := '727479286578706F7274732C2053796D626F6C2E746F537472696E675461672C207B2076616C75653A20274D6F64756C6527207D293B5C6E5C747D5C6E5C744F626A6563742E646566696E6550726F7065727479286578706F7274732C20275F5F65734D';
wwv_flow_imp.g_varchar2_table(8502) := '6F64756C65272C207B2076616C75653A2074727565207D293B5C6E7D3B222C22696D706F7274205669657765722066726F6D202762706D6E2D6A732F6C69622F566965776572273B5C725C6E5C725C6E696D706F7274204D6F766543616E7661734D6F64';
wwv_flow_imp.g_varchar2_table(8503) := '756C652066726F6D20276469616772616D2D6A732F6C69622F6E617669676174696F6E2F6D6F766563616E766173273B5C725C6E696D706F7274205A6F6F6D5363726F6C6C4D6F64756C652066726F6D20276469616772616D2D6A732F6C69622F6E6176';
wwv_flow_imp.g_varchar2_table(8504) := '69676174696F6E2F7A6F6F6D7363726F6C6C273B5C725C6E696D706F727420637573746F6D50616C6574746550726F76696465724D6F64756C652066726F6D20272E2F6C69622F76696577657250616C65747465273B5C725C6E696D706F72742063616C';
wwv_flow_imp.g_varchar2_table(8505) := '6C41637469766974794D6F64756C652066726F6D20272E2F6D6F64756C65732F63616C6C41637469766974794D6F64756C65273B5C725C6E696D706F7274206472696C6C646F776E43656E746572696E672066726F6D20272E2F6D6F64756C65732F6472';
wwv_flow_imp.g_varchar2_table(8506) := '696C6C646F776E43656E746572696E67273B5C725C6E696D706F7274207374796C654D6F64756C652066726F6D20272E2F6D6F64756C65732F7374796C654D6F64756C65273B5C725C6E696D706F7274206D756C7469496E7374616E63654D6F64756C65';
wwv_flow_imp.g_varchar2_table(8507) := '2066726F6D20272E2F6D6F64756C65732F6D756C7469496E7374616E63654D6F64756C65273B5C725C6E696D706F727420757365725461736B4D6F64756C652066726F6D20272E2F6D6F64756C65732F757365725461736B4D6F64756C652F273B5C725C';
wwv_flow_imp.g_varchar2_table(8508) := '6E5C725C6E7661722062706D6E566965776572203D207B5C725C6E20205669657765723A205669657765722C5C725C6E2020637573746F6D4D6F64756C65733A207B5C725C6E202020204D6F766543616E7661734D6F64756C652C5C725C6E202020205A';
wwv_flow_imp.g_varchar2_table(8509) := '6F6F6D5363726F6C6C4D6F64756C652C5C725C6E202020206472696C6C646F776E43656E746572696E672C5C725C6E2020202063616C6C41637469766974794D6F64756C652C5C725C6E202020206D756C7469496E7374616E63654D6F64756C652C5C72';
wwv_flow_imp.g_varchar2_table(8510) := '5C6E202020207374796C654D6F64756C652C5C725C6E20202020637573746F6D50616C6574746550726F76696465724D6F64756C652C5C725C6E20202020757365725461736B4D6F64756C655C725C6E20207D2C5C725C6E7D3B5C725C6E5C725C6E6578';
wwv_flow_imp.g_varchar2_table(8511) := '706F72742064656661756C742062706D6E5669657765723B5C725C6E225D2C226E616D6573223A5B5D2C22736F75726365526F6F74223A22227D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(14527109245955689)
,p_plugin_id=>wwv_flow_imp.id(52333599725331007516)
,p_file_name=>'js/flows4apex.viewer.js.map'
,p_mime_type=>'application/octet-stream'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_imp_shared.create_user_interface(
 p_id=>wwv_flow_imp.id(34556021658496761)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>42
,p_home_url=>'f?p=&APP_ID.:5:&SESSION.'
,p_login_url=>'f?p=&APP_ID.:LOGIN:&APP_SESSION.::&DEBUG.:::'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>0
,p_navigation_list_id=>wwv_flow_imp.id(34416398515496650)
,p_navigation_list_position=>'SIDE'
,p_navigation_list_template_id=>wwv_flow_imp.id(34519500245496723)
,p_nav_list_template_options=>'#DEFAULT#:js-defaultCollapsed:js-navCollapsed--hidden:t-TreeNav--styleA'
,p_css_file_urls=>'#APP_IMAGES#app-icon.css?version=#APP_VERSION#'
,p_nav_bar_type=>'LIST'
,p_nav_bar_list_id=>wwv_flow_imp.id(34555717686496760)
,p_nav_bar_list_template_id=>wwv_flow_imp.id(34522355271496725)
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_imp_page.create_page(
 p_id=>0
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Global Page - Desktop'
,p_step_title=>'Global Page - Desktop'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'D'
,p_page_component_map=>'14'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240926080605'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9158939430894635)
,p_name=>'New'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9159011961894636)
,p_event_id=>wwv_flow_imp.id(9158939430894635)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$(''#t_TreeNav_2 .a-TreeView-toggle'').click();'
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_imp_page.create_page(
 p_id=>2
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Status View'
,p_alias=>'STATUS-VIEW'
,p_page_mode=>'MODAL'
,p_step_title=>'Process Status'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(34419794295496671)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'1200'
,p_page_component_map=>'17'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241007064057'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8032365793873109)
,p_plug_name=>'Flow Viewer'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--noUI:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'FLOW_INSTANCE_DETAILS_VW'
,p_query_where=>'PRCS_ID = :P2_PRCS_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION'
,p_ajax_items_to_submit=>'P2_PRCS_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'DGRM_CONTENT'
,p_attribute_02=>'ALL_CURRENT'
,p_attribute_03=>'PRDG_ID'
,p_attribute_04=>'ALL_COMPLETED'
,p_attribute_05=>'PRDG_PRDG_ID'
,p_attribute_06=>'ALL_ERRORS'
,p_attribute_07=>'CALLING_OBJT'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_attribute_11=>'N'
,p_attribute_12=>'BREADCRUMB'
,p_attribute_13=>'DRILLDOWN_ALLOWED'
,p_attribute_14=>'Y'
,p_attribute_15=>'N'
,p_attribute_16=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8032446152873110)
,p_name=>'P2_PRCS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8032365793873109)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6584855390341613)
,p_name=>'New'
,p_event_sequence=>10
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'document;'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6584954711341614)
,p_event_id=>wwv_flow_imp.id(6584855390341613)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8032365793873109)
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_imp_page.create_page(
 p_id=>3
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'My Tasks'
,p_alias=>'MY-TASKS'
,p_step_title=>'My Tasks'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-FS-search{',
'    border: none;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'22'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241007165152'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5071898521333605)
,p_plug_name=>'My Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34445609432496688)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with qry_simpleform as',
'(',
'    select *',
'    from flow_objects objt, json_table( objt.objt_attributes',
'        , ''$''',
'            columns',
'            task_type varchar2(4000) path ''$.taskType''',
'        ) jt',
'    where',
'        task_type = ''apexSimpleForm''',
'), qry_tasks as',
'(',
'      select distinct',
'           manager,',
'           amct.app_id,',
'           amct.task_id,',
'           amct.task_def_id,',
'           amct.task_def_name,',
'           amct.task_def_static_id,',
'           subject,',
'           case when qs.task_type is not null then qs.task_type',
'                when amct.task_type is not null then amct.task_type',
'                else null',
'           end as task_type,',
'           details_app_id,',
'           details_app_name,',
'           details_link_target,',
'           due_on,',
'           due_in_hours,',
'           due_in,',
'           due_code,',
'           priority,',
'           priority_level,',
'           initiator,',
'           initiator_lower,',
'           actual_owner,',
'           actual_owner_lower,',
'           state_code,',
'           state,',
'           is_completed,',
'           outcome_code,',
'           outcome,',
'           badge_css_classes,',
'           badge_text,',
'           created_ago_hours,',
'           created_ago,',
'           created_by,',
'           created_on,',
'           to_char(created_on, ''DD.MM.YYYY HH:MI:SS'') as created_on_html,',
'           last_updated_by,',
'           last_updated_on,',
'           coalesce(amct.process_id,to_number(tapa.param_value)) as process_id,',
'           subflow_id,',
'           step_key,',
'           objt_id,',
'           inst_id,',
'           case when inst_id is not null then 1 else 0 end as instance_found,',
'           case when ftpl_id is null then ''u-hidden'' else '''' end as template_found',
'      from flow_apex_my_combined_task_list_vw amct',
'      left join apex_task_parameters          tapa      on tapa.task_id = amct.task_id and param_static_id = ''PROCESS_ID''',
'      left join flow_subflows_vw              sbfl      on sbfl.sbfl_id = amct.subflow_id',
'      left join qry_simpleform                qs        on qs.objt_dgrm_id = sbfl.sbfl_dgrm_id and qs.objt_bpmn_id = sbfl.sbfl_current',
'      left join form_started_processes_vw     form_proc on form_proc.prcs_id = coalesce(amct.process_id,to_number(tapa.param_value))',
'      left join form_instances                form_inst on form_inst.inst_id = to_number(form_proc.prcs_business_ref default -1 on conversion error)',
'      left join form_templates                ftpl      on ftpl.ftpl_id = form_inst.inst_ftpl_id',
')',
'select',
'    *',
'from',
'    qry_tasks',
'where',
'    instance_found != 0',
'order by created_on desc'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_no_data_found=>'No Tasks'
,p_show_total_row_count=>false
);
wwv_flow_imp_page.create_card(
 p_id=>wwv_flow_imp.id(5158106652844813)
,p_region_id=>wwv_flow_imp.id(5071898521333605)
,p_layout_type=>'ROW'
,p_title_adv_formatting=>false
,p_title_column_name=>'SUBJECT'
,p_sub_title_adv_formatting=>true
,p_sub_title_html_expr=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<small role="group" aria-label="Task Details">',
'    <strong>&TASK_DEF_NAME!HTML.</strong>',
'    <!-- <strong>&MANAGER!HTML.</strong> -->',
'    <!-- <strong>&TASK_DEF_STATIC_ID!HTML.</strong> -->',
'{if INITIATOR/}',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated by &INITIATOR_LOWER!HTML.',
'    <span role="separator" aria-label="&middot;"> &middot; </span> Initiated on &CREATED_ON_HTML!HTML. ',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case DUE_CODE/}',
'        {when OVERDUE/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span><strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_HOUR/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Due &DUE_IN.</strong>',
'        {when NEXT_24_HOURS/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">Due &DUE_IN.</span>',
'        {otherwise/}',
'            {if DUE_IN/}<span role="separator" aria-label="&middot;"> &middot; </span> <span>Due &DUE_IN.</span>{endif/}',
'    {endcase/}',
'{endif/}',
'{if !IS_COMPLETED/}',
'    {case PRIORITY/}',
'        {when 1/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <strong class="u-danger-text">Urgent</strong>',
'        {when 2/}',
'            <span role="separator" aria-label="&middot;"> &middot; </span> <span class="u-danger-text">High priority</span>',
'    {endcase/}',
'{endif/}',
'</small>'))
,p_body_adv_formatting=>false
,p_second_body_adv_formatting=>false
,p_media_adv_formatting=>false
,p_pk1_column_name=>'TASK_ID'
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(5158437278844816)
,p_card_id=>wwv_flow_imp.id(5158106652844813)
,p_action_type=>'TITLE'
,p_display_sequence=>10
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'&DETAILS_LINK_TARGET.'
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(5158593165844817)
,p_card_id=>wwv_flow_imp.id(5158106652844813)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>30
,p_label=>'Approve'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#'
,p_link_attributes=>'data-id="&TASK_ID."'
,p_button_display_type=>'TEXT_WITH_ICON'
,p_icon_css_classes=>'fa-check-square u-success-text'
,p_action_css_classes=>'approve'
,p_is_hot=>false
,p_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_condition_expr1=>'TASK_TYPE'
,p_condition_expr2=>'APPROVAL'
,p_exec_cond_for_each_row=>true
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(5158668291844818)
,p_card_id=>wwv_flow_imp.id(5158106652844813)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>40
,p_label=>'Reject'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#'
,p_link_attributes=>'data-id="&TASK_ID."'
,p_button_display_type=>'TEXT_WITH_ICON'
,p_icon_css_classes=>'fa-times u-danger-text'
,p_action_css_classes=>'reject'
,p_is_hot=>false
,p_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_condition_expr1=>'TASK_TYPE'
,p_condition_expr2=>'APPROVAL'
,p_exec_cond_for_each_row=>true
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(9009456880822506)
,p_card_id=>wwv_flow_imp.id(5158106652844813)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>50
,p_label=>'Process Status'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::P9_PRCS_ID:&PROCESS_ID.'
,p_button_display_type=>'TEXT_WITH_ICON'
,p_icon_css_classes=>'fa-workflow'
,p_is_hot=>false
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(9324428074381401)
,p_card_id=>wwv_flow_imp.id(5158106652844813)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>60
,p_label=>'Initial Submitted Form'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.::P4_INSTANCE_ID:&INST_ID.'
,p_button_display_type=>'TEXT'
,p_action_css_classes=>'&TEMPLATE_FOUND.'
,p_is_hot=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5158278735844814)
,p_plug_name=>'Search'
,p_region_template_options=>'#DEFAULT#:t-BreadcrumbRegion--useBreadcrumbTitle'
,p_plug_template=>wwv_flow_imp.id(34480263758496702)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(5071898521333605)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_06=>'N'
,p_attribute_09=>'N'
,p_attribute_12=>'10000'
,p_attribute_13=>'Y'
,p_attribute_15=>'10'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5158370682844815)
,p_name=>'P3_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5158278735844814)
,p_prompt=>'Search'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_chart=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5159244503844824)
,p_name=>'P3_TASK_ID'
,p_item_sequence=>10
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5158899416844820)
,p_name=>'Approve'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'a.approve'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5159054585844822)
,p_event_id=>wwv_flow_imp.id(5158899416844820)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3_TASK_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.triggeringElement.dataset.id'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5159302583844825)
,p_event_id=>wwv_flow_imp.id(5158899416844820)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_approval.approve_task (',
'    p_task_id   => :P3_TASK_ID,',
'    p_autoclaim => true );',
'                '))
,p_attribute_02=>'P3_TASK_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5159483408844826)
,p_event_id=>wwv_flow_imp.id(5158899416844820)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.showPageSuccess(''Task approved'');'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5159514245844827)
,p_event_id=>wwv_flow_imp.id(5158899416844820)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5071898521333605)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5159697987844828)
,p_name=>'Reject'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'a.reject'
,p_bind_type=>'live'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5159713373844829)
,p_event_id=>wwv_flow_imp.id(5159697987844828)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3_TASK_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.triggeringElement.dataset.id'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5159822199844830)
,p_event_id=>wwv_flow_imp.id(5159697987844828)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_approval.reject_task (',
'    p_task_id   => :P3_TASK_ID,',
'    p_autoclaim => true );',
'                '))
,p_attribute_02=>'P3_TASK_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5159946459844831)
,p_event_id=>wwv_flow_imp.id(5159697987844828)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.showPageSuccess(''Task rejected'');'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5160065660844832)
,p_event_id=>wwv_flow_imp.id(5159697987844828)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5071898521333605)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5311227041293126)
,p_name=>'Close Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'window'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5311313073293127)
,p_event_id=>wwv_flow_imp.id(5311227041293126)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5071898521333605)
);
end;
/
prompt --application/pages/page_00004
begin
wwv_flow_imp_page.create_page(
 p_id=>4
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Initial Submitted Form'
,p_alias=>'INITIAL-SUBMITTED-FORM'
,p_page_mode=>'MODAL'
,p_step_title=>'Initial Submitted Form'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'17'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241007125235'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(36897888297510421)
,p_plug_name=>'Form'
,p_region_template_options=>'#DEFAULT#:t-Region--removeHeader js-removeLandmark:t-Region--noUI:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(36898047888510423)
,p_plug_name=>'Form Data'
,p_parent_plug_id=>wwv_flow_imp.id(36897888297510421)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_JSON_REGION.UWESIMON.SELFHOST.E'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_read_only_when_type=>'ALWAYS'
,p_attribute_01=>'250'
,p_attribute_02=>'SQL-Query'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select fdta_template_content',
'from form_data',
'where fdta_inst_id = :P4_INSTANCE_ID',
'and fdta_task_bpmn_id is null'))
,p_attribute_05=>'3'
,p_attribute_06=>'N'
,p_attribute_07=>'Y'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_attribute_10=>'P4_JSON_CONTENT'
,p_attribute_11=>'floating'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36898132491510424)
,p_name=>'P4_JSON_CONTENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(36897888297510421)
,p_prompt=>'Json Content'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(34532284141496730)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36900199777510444)
,p_name=>'P4_INSTANCE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(36897888297510421)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(36991382673218907)
,p_computation_sequence=>20
,p_computation_item=>'P4_JSON_CONTENT'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select fdta_content',
'from form_data',
'where fdta_inst_id = :P4_INSTANCE_ID',
'and fdta_task_bpmn_id is null'))
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_imp_page.create_page(
 p_id=>5
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Running Processes'
,p_alias=>'RUNNING-PROCESSES'
,p_step_title=>'Running Processes'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.ffa-color--running{',
'    background-color: #6aad42!important;',
'    color: white !important;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This starter app will let you start and walkthrough a process for which you have access to. All user tasks across all apps in the workspace currently assigned to you can be found on the page "My Tasks".</p>',
'<p>If a process is to be started after submitting a form, please first assign the process with the initial form on page "Process Trigger" in the administration section.</p>',
'<p>This app comes with a simple process called "Order" so feel free to start this process and explore under the covers to see how it works!</p>'))
,p_page_component_map=>'13'
,p_last_updated_by=>'NIELSDEBR@GMAIL.COM'
,p_last_upd_yyyymmddhh24miss=>'20241008055831'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2216309692731729)
,p_plug_name=>'Filters'
,p_region_template_options=>'#DEFAULT#:t-Region--removeHeader js-removeLandmark:t-Region--noUI:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source_type=>'NATIVE_SMART_FILTERS'
,p_filtered_region_id=>wwv_flow_imp.id(36991578426218909)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_02=>'N'
,p_attribute_03=>'10000'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4740154648149545)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:t-ButtonRegion--slimPadding:margin-bottom-none'
,p_plug_template=>wwv_flow_imp.id(34443487668496687)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16055272093177001)
,p_plug_name=>'About this app'
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34453825801496693)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15830407130423621)
,p_plug_name=>'Help Text'
,p_parent_plug_id=>wwv_flow_imp.id(16055272093177001)
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34438790691496680)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_HELP_TEXT'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(36991578426218909)
,p_plug_name=>'Running Processes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34445609432496688)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select inst_id',
'     , inst_ftpl_id',
'     , ftpl_sfte_id',
'     , prcs_id',
'     , prcs_status',
'     , dgrm_name',
'     , fdta_id',
'     , prcs_name',
'     , to_char(prcs_init_ts, ''DD.MM.YYYY HH:MI:SS'') as prcs_init_ts',
'     , prcs_init_ts as prcs_init_ts_order_by',
'     , prcs_init_by',
'     , case when fdta_id is null then ''u-hidden'' end as visual_class_init_form',
'  from form_p0005_vw',
'  left join apex_appl_acl_users a',
'    on a.application_id = :APP_ID',
'   and upper(a.USER_NAME) = :APP_USER',
' where prcs_init_by = :APP_USER',
'   and prcs_status != ''terminated''',
' order by prcs_init_ts desc',
';'))
,p_query_order_by_type=>'ITEM'
,p_query_order_by=>'{"orderBys":[{"key":"PRCS_INIT_TS_ORDER_BY","expr":"prcs_init_ts_order_by desc"}],"itemName":"P5_ORDER_BY"}'
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows=>20
,p_plug_query_num_rows_type=>'SET'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_show_total_row_count=>true
);
wwv_flow_imp_page.create_card(
 p_id=>wwv_flow_imp.id(36992758570218921)
,p_region_id=>wwv_flow_imp.id(36991578426218909)
,p_layout_type=>'GRID'
,p_grid_column_count=>3
,p_title_adv_formatting=>false
,p_title_column_name=>'PRCS_NAME'
,p_sub_title_adv_formatting=>true
,p_sub_title_html_expr=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--<h4 class="a-CardView-subTitle ">Current user status: &SBFL_CURRENT_NAME.  </h4>-->',
'<h4 class="a-CardView-subTitle ">Created on: <span style = "text-transform: lowercase" >&PRCS_INIT_TS.</span> </h4>',
'<h4 class="a-CardView-subTitle ">Created by: <span style = "text-transform: lowercase" >&PRCS_INIT_BY.</span></h4>'))
,p_body_adv_formatting=>false
,p_second_body_adv_formatting=>false
,p_badge_column_name=>'PRCS_STATUS'
,p_badge_css_classes=>'ffa-color--&PRCS_STATUS.'
,p_media_adv_formatting=>false
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(36992826302218922)
,p_card_id=>wwv_flow_imp.id(36992758570218921)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>10
,p_label=>'Process Status'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::P2_PRCS_ID:&PRCS_ID.'
,p_button_display_type=>'TEXT_WITH_ICON'
,p_icon_css_classes=>'fa-workflow'
,p_is_hot=>false
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(36992963232218923)
,p_card_id=>wwv_flow_imp.id(36992758570218921)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>20
,p_label=>'Initial Submitted Form'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.::P4_INSTANCE_ID:&INST_ID.'
,p_button_display_type=>'TEXT'
,p_action_css_classes=>'&VISUAL_CLASS_INIT_FORM.'
,p_is_hot=>false
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4740249830149546)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4740154648149545)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Start Process'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:8::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2216487994731730)
,p_name=>'P5_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2216309692731729)
,p_prompt=>'Search'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'ROW'
,p_attribute_04=>'N'
,p_fc_show_chart=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2218403494731750)
,p_name=>'P5_ORDER_BY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(36991578426218909)
,p_item_display_point=>'ORDER_BY_ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7608586552875042)
,p_name=>'P5_CANCELED_PROCESS_ID'
,p_item_sequence=>10
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4914151214314002)
,p_computation_sequence=>20
,p_computation_item=>'P5_ORDER_BY'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'PRCS_INIT_TS_ORDER_BY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6584542446341610)
,p_name=>'Refresh'
,p_event_sequence=>20
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'document;'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6584659259341611)
,p_event_id=>wwv_flow_imp.id(6584542446341610)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(36991578426218909)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8837791648406442)
,p_name=>'New'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(36991578426218909)
,p_bind_type=>'bind'
,p_bind_event_type=>'NATIVE_CARDS|REGION TYPE|tablemodelviewpagechange'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8837964400406444)
,p_event_id=>wwv_flow_imp.id(8837791648406442)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for(var i = 0; i < $(''.btn-delete'').length;i++)',
'{',
'  $(''.btn-delete'')[i].temp_href = $(''.btn-delete'')[i].href;',
'  $(''.btn-delete'')[i].href = ''#'';',
'}',
'',
'',
'$(''.btn-delete'').on( "click", function() {',
'  var url = this.temp_href;',
'  apex.message.confirm( "This will terminate the process. Are you sure?", function( okPressed ) {',
'      if( okPressed ) {',
'          apex.navigation.redirect(url);',
'      }',
'  }, {',
'      title: "Warning!",',
'      style: "danger",',
'      iconClasses: "fa fa-trash fa-2x",',
'      cancelLabel: "No",',
'      confirmLabel: "I''m sure"',
'  } );',
'} );'))
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_imp_page.create_page(
 p_id=>6
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Task Details'
,p_page_mode=>'MODAL'
,p_step_title=>'Task Details'
,p_allow_duplicate_submissions=>'N'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(4547911793880930)
,p_page_template_options=>'#DEFAULT#:js-dialog-class-t-Drawer--pullOutEnd'
,p_protection_level=>'C'
,p_page_component_map=>'23'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20240927060830'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8911307231161783)
,p_plug_name=>'Subject'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34445609432496688)
,p_plug_display_sequence=>50
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'select *',
'  from table ( apex_approval.get_tasks (',
'                   p_context => ''SINGLE_TASK'',',
'                   p_task_id => :P6_TASK_ID ) )',
'            '))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_show_total_row_count=>false
);
wwv_flow_imp_page.create_card(
 p_id=>wwv_flow_imp.id(8911724284161784)
,p_region_id=>wwv_flow_imp.id(8911307231161783)
,p_layout_type=>'ROW'
,p_title_adv_formatting=>false
,p_title_column_name=>'SUBJECT'
,p_sub_title_adv_formatting=>true
,p_body_adv_formatting=>false
,p_second_body_adv_formatting=>false
,p_badge_column_name=>'BADGE_TEXT'
,p_badge_css_classes=>'&BADGE_CSS_CLASSES.'
,p_media_adv_formatting=>false
,p_pk1_column_name=>'TASK_ID'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(8912269147161785)
,p_name=>'Overview'
,p_template=>wwv_flow_imp.id(34470894408496699)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:t-AVPList--leftAligned:t-Report--hideNoPagination'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'select task_def_name        as type,',
'       created_on           as initiated,',
'       initiator_lower      as initiator,',
'       actual_owner_lower   as owner,',
'       priority_level       as priority',
'  from table ( apex_approval.get_tasks (',
'                   p_context => ''SINGLE_TASK'',',
'                   p_task_id => :P6_TASK_ID ) )',
'            '))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(34491737799496709)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8912642839161785)
,p_query_column_id=>1
,p_column_alias=>'TYPE'
,p_column_display_sequence=>10
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8913025856161786)
,p_query_column_id=>2
,p_column_alias=>'INITIATED'
,p_column_display_sequence=>20
,p_column_heading=>'Initiated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8913488838161786)
,p_query_column_id=>3
,p_column_alias=>'INITIATOR'
,p_column_display_sequence=>30
,p_column_heading=>'Initiator'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8913870496161786)
,p_query_column_id=>4
,p_column_alias=>'OWNER'
,p_column_display_sequence=>40
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8914213044161786)
,p_query_column_id=>5
,p_column_alias=>'PRIORITY'
,p_column_display_sequence=>50
,p_column_heading=>'Priority'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8914603377161787)
,p_plug_name=>'Edit Task'
,p_region_template_options=>'#DEFAULT#:t-ButtonRegion--noPadding:t-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(34443487668496687)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8916264688161788)
,p_plug_name=>'Delegate'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-nosize'
,p_plug_template=>wwv_flow_imp.id(34463394363496697)
,p_plug_display_sequence=>80
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex_approval.is_allowed (',
'    p_task_id   => :P6_TASK_ID,',
'    p_operation => apex_approval.c_task_op_delegate )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8917832216161789)
,p_plug_name=>'Priority'
,p_region_template_options=>'#DEFAULT#:js-dialog-autoheight:js-dialog-nosize'
,p_plug_template=>wwv_flow_imp.id(34463394363496697)
,p_plug_display_sequence=>90
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex_approval.is_allowed (',
'    p_task_id   => :P6_TASK_ID,',
'    p_operation => apex_approval.c_task_op_set_priority )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(8919402372161790)
,p_name=>'Details'
,p_template=>wwv_flow_imp.id(34459258426496695)
,p_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3:t-ContentBlock--lightBG:margin-top-md'
,p_component_template_options=>'#DEFAULT#:t-AVPList--leftAligned:t-Report--hideNoPagination'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'select param_label,',
'       param_value',
'  from apex_task_parameters',
' where task_id = :P6_TASK_ID',
'   and is_visible = ''Y'';',
'            '))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(34489733747496708)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8919810698161790)
,p_query_column_id=>1
,p_column_alias=>'PARAM_LABEL'
,p_column_display_sequence=>10
,p_column_heading=>'Param Label'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8920234725161791)
,p_query_column_id=>2
,p_column_alias=>'PARAM_VALUE'
,p_column_display_sequence=>20
,p_column_heading=>'Param Value'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(8920627874161791)
,p_name=>'Comments'
,p_template=>wwv_flow_imp.id(34459258426496695)
,p_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:t-ContentBlock--h3'
,p_component_template_options=>'#DEFAULT#:t-Comments--chat:t-Report--hideNoPagination'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'select apex_string.get_initials(created_by) as user_icon,',
'       ''u-color-''||ora_hash(created_by,45)  as icon_modifier,',
'       lower(created_by)                    as user_name, /*SEC:CASE--OK*/',
'       text                                 as comment_text,',
'       created_on                           as comment_date,',
'       null                                 as comment_modifiers,',
'       null                                 as actions,',
'       null                                 as attribute_1,',
'       null                                 as attribute_2,',
'       null                                 as attribute_3,',
'       null                                 as attribute_4',
'  from apex_task_comments',
' where task_id = :P6_TASK_ID',
'            '))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(34499723622496712)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8921061767161791)
,p_query_column_id=>1
,p_column_alias=>'USER_ICON'
,p_column_display_sequence=>10
,p_column_heading=>'User Icon'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8921444479161791)
,p_query_column_id=>2
,p_column_alias=>'ICON_MODIFIER'
,p_column_display_sequence=>20
,p_column_heading=>'Icon Modifier'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8921813205161791)
,p_query_column_id=>3
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>30
,p_column_heading=>'User Name'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8922227796161791)
,p_query_column_id=>4
,p_column_alias=>'COMMENT_TEXT'
,p_column_display_sequence=>40
,p_column_heading=>'Comment Text'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8922639775161791)
,p_query_column_id=>5
,p_column_alias=>'COMMENT_DATE'
,p_column_display_sequence=>50
,p_column_heading=>'Comment Date'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8923027842161791)
,p_query_column_id=>6
,p_column_alias=>'COMMENT_MODIFIERS'
,p_column_display_sequence=>60
,p_column_heading=>'Comment Modifiers'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8923483374161791)
,p_query_column_id=>7
,p_column_alias=>'ACTIONS'
,p_column_display_sequence=>70
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8923801077161792)
,p_query_column_id=>8
,p_column_alias=>'ATTRIBUTE_1'
,p_column_display_sequence=>80
,p_column_heading=>'Attribute 1'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8924297752161792)
,p_query_column_id=>9
,p_column_alias=>'ATTRIBUTE_2'
,p_column_display_sequence=>90
,p_column_heading=>'Attribute 2'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8924629417161792)
,p_query_column_id=>10
,p_column_alias=>'ATTRIBUTE_3'
,p_column_display_sequence=>100
,p_column_heading=>'Attribute 3'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8925077326161792)
,p_query_column_id=>11
,p_column_alias=>'ATTRIBUTE_4'
,p_column_display_sequence=>110
,p_column_heading=>'Attribute 4'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(8926289072161792)
,p_name=>'History'
,p_template=>wwv_flow_imp.id(34453825801496693)
,p_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:js-useLocalStorage:t-Region--noPadding:is-collapsed:t-Region--scrollBody'
,p_component_template_options=>'#DEFAULT#:t-Report--stretch:t-Report--staticRowColors:t-Report--rowHighlight:t-Report--inline:t-Report--hideNoPagination'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'select event_type,',
'       event_timestamp,',
'       event_creator_lower,',
'       display_msg',
'  from table ( apex_approval.get_task_history (',
'                   p_task_id => :P6_TASK_ID ) )',
'            '))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(34497185132496711)
,p_query_num_rows=>20
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_LEFT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8926636500161793)
,p_query_column_id=>1
,p_column_alias=>'EVENT_TYPE'
,p_column_display_sequence=>10
,p_column_heading=>'Event'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8927033331161793)
,p_query_column_id=>2
,p_column_alias=>'EVENT_TIMESTAMP'
,p_column_display_sequence=>20
,p_column_heading=>'Time '
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8927410594161793)
,p_query_column_id=>3
,p_column_alias=>'EVENT_CREATOR_LOWER'
,p_column_display_sequence=>30
,p_column_heading=>'User'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8927823958161793)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_MSG'
,p_column_display_sequence=>40
,p_column_heading=>'Message'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8928284015161793)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:t-ButtonRegion--stickToBottom:t-ButtonRegion--slimPadding:margin-bottom-none'
,p_plug_template=>wwv_flow_imp.id(34443487668496687)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8925880310161792)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8920627874161791)
,p_button_name=>'ADD_COMMENT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_image_alt=>'Add Comment'
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8917057825161789)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8916264688161788)
,p_button_name=>'CANCEL_DELEGATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8918624247161790)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8917832216161789)
,p_button_name=>'CANCEL_SET_PRIORITY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8928663895161793)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8928284015161793)
,p_button_name=>'BACK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_image_alt=>'Back'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8929084973161793)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8928284015161793)
,p_button_name=>'CLAIM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Claim Task'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex_approval.is_allowed (',
'    p_task_id   => :P6_TASK_ID,',
'    p_operation => apex_approval.c_task_op_claim )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8929422604161793)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(8928284015161793)
,p_button_name=>'REJECT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--danger:t-Button--link:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(34533432746496733)
,p_button_image_alt=>'Reject'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex_approval.is_allowed (',
'    p_task_id   => :P6_TASK_ID,',
'    p_operation => apex_approval.c_task_op_reject )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'fa-times-circle-o'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8929868796161794)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(8928284015161793)
,p_button_name=>'APPROVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--success:t-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(34533432746496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Approve'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex_approval.is_allowed (',
'    p_task_id   => :P6_TASK_ID,',
'    p_operation => apex_approval.c_task_op_approve )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'fa-check'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8917465398161789)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8916264688161788)
,p_button_name=>'DELEGATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delegate'
,p_button_position=>'EDIT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8919056376161790)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8917832216161789)
,p_button_name=>'SET_PRIORITY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set Priority'
,p_button_position=>'EDIT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8915071306161787)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8914603377161787)
,p_button_name=>'RELEASE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_image_alt=>'Release'
,p_button_position=>'PREVIOUS'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex_approval.is_allowed (',
'    p_task_id   => :P6_TASK_ID,',
'    p_operation => apex_approval.c_task_op_release )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8915427572161787)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8914603377161787)
,p_button_name=>'DELEGATE_DIALOG'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_image_alt=>'Delegate'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex_approval.is_allowed (',
'    p_task_id   => :P6_TASK_ID,',
'    p_operation => apex_approval.c_task_op_delegate )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8915826063161788)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(8914603377161787)
,p_button_name=>'PRIORITY_DIALOG'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_image_alt=>'Priority'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex_approval.is_allowed (',
'    p_task_id   => :P6_TASK_ID,',
'    p_operation => apex_approval.c_task_op_set_priority )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9009542469822507)
,p_branch_action=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(8928663895161793)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9009625486822508)
,p_branch_action=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(8929868796161794)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9009779731822509)
,p_branch_action=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(8929422604161793)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8910570328161782)
,p_name=>'P6_TASK_ID'
,p_item_sequence=>10
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8910948937161783)
,p_name=>'P6_SUCCESS_MESSAGE'
,p_item_sequence=>40
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8916616722161789)
,p_name=>'P6_NEW_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8916264688161788)
,p_prompt=>'New Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov_language=>'PLSQL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'select disp,',
'       val',
'  from table ( apex_approval.get_task_delegates ( p_task_id => :P6_TASK_ID ) )',
'            '))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(34532284141496730)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_protection_level=>'S'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8918250385161790)
,p_name=>'P6_NEW_PRIORITY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8917832216161789)
,p_prompt=>'New Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov_language=>'PLSQL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'select disp,',
'       val',
'  from table ( apex_approval.get_task_priorities ( p_task_id => :P6_TASK_ID ) )',
'            '))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(34532284141496730)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_protection_level=>'S'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8925499254161792)
,p_name=>'P6_COMMENT_TEXT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8920627874161791)
,p_prompt=>'Comment'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(34532284141496730)
,p_item_template_options=>'#DEFAULT#:t-Form-fieldContainer--stretchInputs'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8930238453161794)
,p_name=>'Delegate'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8915427572161787)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8930668095161794)
,p_event_id=>wwv_flow_imp.id(8930238453161794)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8916264688161788)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8931157418161795)
,p_name=>'Cancel Delegate'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8917057825161789)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8931590811161795)
,p_event_id=>wwv_flow_imp.id(8931157418161795)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8916264688161788)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8932045609161795)
,p_name=>'Set Priority'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8915826063161788)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8932416477161795)
,p_event_id=>wwv_flow_imp.id(8932045609161795)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8917832216161789)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8932966357161795)
,p_name=>'Cancel Set Priority'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8918624247161790)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8933344135161795)
,p_event_id=>wwv_flow_imp.id(8932966357161795)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8917832216161789)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8933879218161795)
,p_name=>'Add Comment'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8925880310161792)
,p_condition_element=>'P6_COMMENT_TEXT'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8934240968161795)
,p_event_id=>wwv_flow_imp.id(8933879218161795)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'apex_approval.add_task_comment(',
'    p_task_id => :P6_TASK_ID,',
'    p_text    => :P6_COMMENT_TEXT);',
'            '))
,p_attribute_02=>'P6_COMMENT_TEXT'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8934741852161796)
,p_event_id=>wwv_flow_imp.id(8933879218161795)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8920627874161791)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8935229974161796)
,p_event_id=>wwv_flow_imp.id(8933879218161795)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6_COMMENT_TEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8935791019161796)
,p_event_id=>wwv_flow_imp.id(8933879218161795)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6_COMMENT_TEXT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8937137105161796)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_MANAGE_TASK'
,p_process_name=>'Claim'
,p_attribute_01=>'CLAIM_TASK'
,p_attribute_02=>'P6_TASK_ID'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8929084973161793)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8937569707161797)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_MANAGE_TASK'
,p_process_name=>'Approve'
,p_attribute_01=>'APPROVE_TASK'
,p_attribute_02=>'P6_TASK_ID'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8929868796161794)
,p_process_success_message=>'Task approved'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8937959834161797)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_MANAGE_TASK'
,p_process_name=>'Reject'
,p_attribute_01=>'REJECT_TASK'
,p_attribute_02=>'P6_TASK_ID'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8929422604161793)
,p_process_success_message=>'Task rejected'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8938318409161797)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_MANAGE_TASK'
,p_process_name=>'Release'
,p_attribute_01=>'RELEASE_TASK'
,p_attribute_02=>'P6_TASK_ID'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8915071306161787)
,p_process_success_message=>'Task released - can now be claimed by others'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8938791647161797)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_MANAGE_TASK'
,p_process_name=>'Delegate'
,p_attribute_01=>'DELEGATE_TASK'
,p_attribute_02=>'P6_TASK_ID'
,p_attribute_04=>'P6_NEW_OWNER'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8917465398161789)
,p_process_success_message=>'Task delegated to &P6_NEW_OWNER.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8939114130161797)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_MANAGE_TASK'
,p_process_name=>'Set Priority'
,p_attribute_01=>'SET_TASK_PRIORITY'
,p_attribute_02=>'P6_TASK_ID'
,p_attribute_05=>'P6_NEW_PRIORITY'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8919056376161790)
,p_process_success_message=>'Task priority set to &P6_NEW_PRIORITY.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8939508739161797)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Success Message'
,p_process_sql_clob=>':P6_SUCCESS_MESSAGE := apex_application.g_print_success_message;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'&P6_SUCCESS_MESSAGE.'
);
end;
/
prompt --application/pages/page_00007
begin
wwv_flow_imp_page.create_page(
 p_id=>7
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'APEX Simple Form'
,p_alias=>'APEX-SIMPLE-FORM'
,p_page_mode=>'MODAL'
,p_step_title=>'&P7_TITLE.'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_javascript_code_onload=>'apex.util.getTopApex().jQuery(''.ui-dialog-content'').dialog(''option'', ''title'', ''&P7_TITLE.'');'
,p_step_template=>wwv_flow_imp.id(34419794295496671)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_chained=>'N'
,p_protection_level=>'C'
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241007125148'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6915808412063186)
,p_plug_name=>'Form'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>90
,p_plug_source_type=>'PLUGIN_JSON_REGION.UWESIMON.SELFHOST.E'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'250'
,p_attribute_02=>'SQL-Query'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte_content',
'from flow_simple_form_templates',
'where sfte_id = :P7_FTPL_SFTE_ID'))
,p_attribute_05=>'3'
,p_attribute_06=>'N'
,p_attribute_07=>'Y'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_attribute_10=>'P7_CONTENT'
,p_attribute_11=>'floating'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(36761313174598350)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:t-ButtonRegion--slimPadding:margin-bottom-none'
,p_plug_template=>wwv_flow_imp.id(34443487668496687)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2184327211913685)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(36761313174598350)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2185136147913685)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(36761313174598350)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9325500426381412)
,p_branch_name=>'Go To Page 3'
,p_branch_action=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2185136147913685)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P7_OPEN_FROM'
,p_branch_condition_text=>'3'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2215837514731724)
,p_name=>'P7_INST_ID'
,p_item_sequence=>30
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5767339368608205)
,p_name=>'P7_FTPL_SFTE_ID'
,p_item_sequence=>40
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5767620652608208)
,p_name=>'P7_CONTENT'
,p_item_sequence=>80
,p_prompt=>'Content'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(34532284141496730)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5768006601608212)
,p_name=>'P7_FDTA_ID'
,p_item_sequence=>60
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5768377241608215)
,p_name=>'FORM_TEMPLATE_ITEM'
,p_item_sequence=>20
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6978082423365540)
,p_name=>'P7_TITLE'
,p_item_sequence=>70
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9325856236381415)
,p_name=>'P7_OPEN_FROM'
,p_item_sequence=>10
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6978136029365541)
,p_computation_sequence=>10
,p_computation_item=>'P7_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select task_def_name',
'  from flow_apex_my_combined_task_list_vw',
' where process_id = :PROCESS_ID',
'   and subflow_id = :SUBFLOW_ID',
'   and step_key = :STEP_KEY'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(9325950656381416)
,p_computation_sequence=>10
,p_computation_item=>'P7_OPEN_FROM'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id',
'from (select page_id',
'from apex_workspace_activity_log',
'where application_id = :app_id and apex_user = :app_user and apex_session_id = :app_session and page_id <> :app_page_id order by seconds_ago)',
'where rownum = 1'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6587222744341637)
,p_computation_sequence=>20
,p_computation_item=>'P7_INST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_number(prcs_business_ref default -1 on conversion error)',
'from flow_instances_vw',
'where prcs_id = :PROCESS_ID'))
,p_compute_when=>'PROCESS_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5768427130608216)
,p_computation_sequence=>30
,p_computation_item=>'P7_FTPL_SFTE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte_id',
'from flow_simple_form_templates',
'where sfte_static_id = :FORM_TEMPLATE_ITEM'))
,p_compute_when=>'FORM_TEMPLATE_ITEM'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2214345828731709)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2184327211913685)
,p_bind_type=>'bind'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2214462002731710)
,p_event_id=>wwv_flow_imp.id(2214345828731709)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2215689832731722)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Form Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_prcs_name flow_processes.prcs_name%type;',
'',
'    l_objt_name    flow_objects.objt_name%type;',
'    l_objt_bpmn_id flow_objects.objt_bpmn_id%type;',
'  ',
'    l_sfte_name      flow_simple_form_templates.sfte_name%type;',
'    l_sfte_static_id flow_simple_form_templates.sfte_static_id%type;',
'    l_sfte_content   flow_simple_form_templates.sfte_content%type;',
'begin',
'    select prcs_name',
'      into l_prcs_name',
'      from flow_processes',
'     where prcs_id = :PROCESS_ID;',
'',
'    select objt.objt_name',
'         , objt.objt_bpmn_id',
'      into l_objt_name',
'         , l_objt_bpmn_id',
'      from flow_objects objt',
'      join flow_subflows_vw sbfl',
'        on sbfl.sbfl_dgrm_id = objt.objt_dgrm_id',
'       and sbfl.sbfl_current = objt.objt_bpmn_id',
'     where sbfl.sbfl_prcs_id = :PROCESS_ID and sbfl.sbfl_id = :SUBFLOW_ID;',
'',
'    select sfte_name',
'         , sfte_static_id',
'         , sfte_content',
'      into l_sfte_name',
'         , l_sfte_static_id',
'         , l_sfte_content',
'      from flow_simple_form_templates',
'     where sfte_id = :P7_FTPL_SFTE_ID;',
'',
'    insert into form_data(',
'        fdta_inst_id',
'      , fdta_content',
'      , fdta_process_name',
'      , fdta_task_name',
'      , fdta_task_bpmn_id',
'      , fdta_template_name',
'      , fdta_template_static_id',
'      , fdta_template_content',
'      , fdta_created_by',
'    )',
'    values(',
'        :P7_INST_ID',
'      , :P7_CONTENT',
'      , l_prcs_name',
'      , l_objt_name',
'      , l_objt_bpmn_id',
'      , l_sfte_name',
'      , l_sfte_static_id',
'      , l_sfte_content',
'      , :APP_USER',
'    )',
'    returning fdta_id into :P7_FDTA_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2185136147913685)
,p_process_success_message=>'Form was saved sucessfully.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2215745931731723)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P7_CONTENT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P7_CONTENT := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2185136147913685)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5768163781608213)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'PLUGIN_COM.FLOWS4APEX.MANAGE_STEP.PROCESS'
,p_process_name=>'Complete Step'
,p_attribute_01=>'item'
,p_attribute_02=>'PROCESS_ID'
,p_attribute_03=>'SUBFLOW_ID'
,p_attribute_05=>'complete'
,p_attribute_06=>'N'
,p_attribute_09=>'N'
,p_attribute_12=>'STEP_KEY'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2185136147913685)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9324997834381406)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2185136147913685)
,p_process_when=>'P7_OPEN_FROM'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'9'
,p_process_success_message=>'Form was saved sucessfully'
);
end;
/
prompt --application/pages/page_00008
begin
wwv_flow_imp_page.create_page(
 p_id=>8
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Starting Process'
,p_alias=>'STARTING-PROCESS'
,p_step_title=>'Starting Process'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#P8_TEMPLATE_NAME{',
'    pointer-events: none;',
'    -webkit-user-select: none;',
'    -moz-user-select: none;',
'    -ms-user-select: none;',
'    user-select: none;',
'}',
'',
'#starting-process .t-Region-buttons-left {',
'    padding-inline-start: 0;',
'    padding-block-end: 0;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241007163203'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7170961763038227)
,p_plug_name=>'Starting Process'
,p_region_name=>'starting-process'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--noUI:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7024833458938247)
,p_plug_name=>'Process Preview'
,p_parent_plug_id=>wwv_flow_imp.id(7170961763038227)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>120
,p_query_type=>'TABLE'
,p_query_table=>'FORM_P0008_VW'
,p_query_where=>'dgrm_id = :P8_DGRM_ID'
,p_include_rowid_column=>false
,p_plug_source_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION'
,p_ajax_items_to_submit=>'P8_DGRM_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P8_DGRM_ID'
,p_attribute_01=>'DGRM_CONTENT'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_attribute_11=>'N'
,p_attribute_14=>'N'
,p_attribute_15=>'N'
,p_attribute_16=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9159320872894639)
,p_plug_name=>'Initial Form'
,p_parent_plug_id=>wwv_flow_imp.id(7170961763038227)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>110
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P8_TEMPLATE_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16209360123764844)
,p_plug_name=>'Form'
,p_parent_plug_id=>wwv_flow_imp.id(9159320872894639)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>20
,p_plug_source_type=>'PLUGIN_JSON_REGION.UWESIMON.SELFHOST.E'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'250'
,p_attribute_02=>'SQL-Query'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte_content',
'from flow_simple_form_templates',
'where sfte_id = :P8_TEMPLATE_ID'))
,p_attribute_05=>'3'
,p_attribute_06=>'N'
,p_attribute_07=>'Y'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_attribute_10=>'P8_CONTENT'
,p_attribute_11=>'floating'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9325312096381410)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:t-ButtonRegion--slimPadding'
,p_plug_template=>wwv_flow_imp.id(34443487668496687)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7170881118038226)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(9325312096381410)
,p_button_name=>'START_PROCESS'
,p_button_static_id=>'START_PROCESS_BTN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Start Process'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7171909935038237)
,p_branch_name=>'Go To Page 5'
,p_branch_action=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(7170881118038226)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6975788186365517)
,p_name=>'P8_DGRM_VERSION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(7170961763038227)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6976711368365527)
,p_name=>'P8_FDTA_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(7170961763038227)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7024546053938244)
,p_name=>'P8_DGRM_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(7170961763038227)
,p_prompt=>'Diagram'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FORM_STARTABLE_DIAGRAMS_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dgrm_id',
'     , dgrm_name || '' ('' || dgrm_version || '' - '' || dgrm_status || '')'' as display_value',
'  from flow_startable_diagrams_vw',
' where (',
'            (',
'                potential_starting_users is null',
'                or',
'                (',
'                    potential_starting_users is not null',
'                    and',
'                    lower(:APP_USER) member of apex_string.split(lower(potential_starting_users),'':'')',
'                )',
'            )',
'            and',
'            (',
'                potential_starting_groups is null',
'                or',
'                (',
'                    potential_starting_groups is not null',
'                    and',
'                    exists',
'                    (',
'                        select 1 ',
'                          from apex_string.split(lower(potential_starting_groups),'':'') sg',
'                             , apex_appl_acl_users au ',
'                         where lower(au.USER_NAME) = lower(:APP_USER) ',
'                           and sg.column_value member of apex_string.split(lower(au.role_names),'','')',
'                    )',
'                )',
'            )',
'            and',
'            (',
'                excluded_starting_users is null',
'                or',
'                (',
'                    excluded_starting_users is not null',
'                    and',
'                    lower(:APP_USER) not member of apex_string.split(lower(excluded_starting_users),'':'')',
'                )',
'            )',
'       )',
' order by dgrm_name asc, dgrm_version asc'))
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(34532284141496730)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7169456916038212)
,p_name=>'P8_TEMPLATE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(7170961763038227)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7171312828038231)
,p_name=>'P8_PRCS_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(7170961763038227)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7171599317038233)
,p_name=>'P8_DGRM_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(7170961763038227)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7172197582038239)
,p_name=>'P8_FTPL_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(7170961763038227)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9158638189894632)
,p_name=>'P8_INST_ID'
,p_item_sequence=>20
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9159206308894638)
,p_name=>'P8_CONTENT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(9159320872894639)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(7173270057038250)
,p_computation_sequence=>10
,p_computation_item=>'P8_FTPL_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ftpl_id',
'  from form_templates',
' where (',
'            ftpl_dgrm_version is not null',
'            and',
'            (ftpl_dgrm_name, ftpl_dgrm_version) = (select dgrm_name, dgrm_version from flow_startable_diagrams_vw where dgrm_id = :P8_DGRM_ID)',
'       )',
'    or (',
'            ftpl_dgrm_version is null',
'            and',
'            ftpl_dgrm_name = (select dgrm_name from flow_startable_diagrams_vw where dgrm_id = :P8_DGRM_ID)',
'       )'))
,p_compute_when=>'P8_DGRM_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(7172942131038247)
,p_computation_sequence=>20
,p_computation_item=>'P8_TEMPLATE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ftpl_sfte_id',
'  from form_templates',
' where ftpl_id = :P8_FTPL_ID'))
,p_compute_when=>'P8_DGRM_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(7173078994038248)
,p_computation_sequence=>30
,p_computation_item=>'P8_DGRM_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dgrm_name',
'from flow_diagrams_vw',
'where dgrm_id = :P8_DGRM_ID'))
,p_compute_when=>'P8_DGRM_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6976030352365520)
,p_computation_sequence=>40
,p_computation_item=>'P8_DGRM_VERSION'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dgrm_version',
'from flow_diagrams_vw',
'where dgrm_id = :P8_DGRM_ID'))
,p_compute_when=>'P8_DGRM_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9067827082393901)
,p_validation_name=>'P8_DGRM_ID is not null'
,p_validation_sequence=>10
,p_validation=>':P8_DGRM_ID is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Startable Process muss not be empty'
,p_always_execute=>'Y'
,p_when_button_pressed=>wwv_flow_imp.id(7170881118038226)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6976188791365521)
,p_name=>'P8_DGRM_ID selected'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P8_DGRM_ID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6978546232365545)
,p_event_id=>wwv_flow_imp.id(6976188791365521)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'&P8_DGRM_ID.'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9159450516894640)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Form Instance'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    insert into form_instances(inst_ftpl_id)',
'    values(:P8_FTPL_ID) returning inst_id into :P8_INST_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7170881118038226)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7201894238211823)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'PLUGIN_COM.FLOWS4APEX.MANAGE_INSTANCE.PROCESS'
,p_process_name=>'Create and Start Flows Process'
,p_attribute_01=>'create_and_start'
,p_attribute_02=>'&P8_DGRM_NAME. - &APP_USER.'
,p_attribute_03=>'item'
,p_attribute_04=>'P8_DGRM_NAME,P8_DGRM_VERSION'
,p_attribute_07=>'name_and_version'
,p_attribute_08=>'P8_INST_ID'
,p_attribute_09=>'P8_PRCS_ID'
,p_attribute_10=>'json'
,p_attribute_11=>wwv_flow_string.join(wwv_flow_t_varchar2(
'[',
'	{',
'		"name": "STARTED_FROM",',
'		"type": "varchar2",',
'		"value": "Simple Process Starter"',
'	}',
']'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7170881118038226)
,p_process_success_message=>'Process is started successfully.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9159506911894641)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Form Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_prcs_name flow_processes.prcs_name%type;',
'',
'    l_sfte_name      flow_simple_form_templates.sfte_name%type;',
'    l_sfte_static_id flow_simple_form_templates.sfte_static_id%type;',
'    l_sfte_content   flow_simple_form_templates.sfte_content%type;',
'begin',
'    select prcs_name',
'      into l_prcs_name',
'      from flow_processes',
'     where prcs_id = :P8_PRCS_ID;',
'',
'    select sfte_name',
'         , sfte_static_id',
'         , sfte_content',
'      into l_sfte_name',
'         , l_sfte_static_id',
'         , l_sfte_content',
'      from flow_simple_form_templates',
'     where sfte_id = :P8_TEMPLATE_ID;',
'',
'    insert into form_data(',
'        fdta_inst_id',
'      , fdta_content',
'      , fdta_process_name',
'      , fdta_template_name',
'      , fdta_template_static_id',
'      , fdta_template_content',
'      , fdta_created_by',
'    )',
'    values(',
'        :P8_INST_ID',
'      , :P8_CONTENT',
'      , l_prcs_name',
'      , l_sfte_name',
'      , l_sfte_static_id',
'      , l_sfte_content',
'      , :APP_USER',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7170881118038226)
,p_process_when=>'P8_TEMPLATE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_imp_page.create_page(
 p_id=>9
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Task Status View'
,p_alias=>'TASK-STATUS-VIEW'
,p_page_mode=>'MODAL'
,p_step_title=>'Process Status'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(34419794295496671)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'1200'
,p_page_component_map=>'17'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241007064248'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17153327938580183)
,p_plug_name=>'Flow Viewer'
,p_region_template_options=>'#DEFAULT#:t-Region--noPadding:t-Region--removeHeader js-removeLandmark:t-Region--noUI:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PRCS_ID,',
'       PRCS_NAME,',
'       PRDG_ID,',
'       PRDG_PRDG_ID,',
'       DIAGRAM_LEVEL,',
'       CALLING_DGRM,',
'       CALLING_OBJT,',
'       BREADCRUMB,',
'       DRILLDOWN_ALLOWED,',
'       DGRM_ID,',
'       DGRM_NAME,',
'       DGRM_VERSION,',
'       DGRM_STATUS,',
'       DGRM_CATEGORY,',
'       DGRM_CONTENT,',
'       ALL_COMPLETED,',
'       LAST_COMPLETED,',
'       ALL_CURRENT,',
'       ALL_ERRORS,',
'       PRCS_BUSINESS_REF,',
'       USER_TASK_URLS',
'  from FLOW_INSTANCE_DETAILS_VW',
' where PRCS_ID = :P9_PRCS_ID'))
,p_plug_source_type=>'PLUGIN_COM.FLOWS4APEX.VIEWER.REGION'
,p_ajax_items_to_submit=>'P9_PRCS_ID'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'DGRM_CONTENT'
,p_attribute_02=>'ALL_CURRENT'
,p_attribute_03=>'PRDG_ID'
,p_attribute_04=>'ALL_COMPLETED'
,p_attribute_05=>'PRDG_PRDG_ID'
,p_attribute_06=>'ALL_ERRORS'
,p_attribute_07=>'CALLING_OBJT'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_attribute_11=>'N'
,p_attribute_12=>'BREADCRUMB'
,p_attribute_13=>'DRILLDOWN_ALLOWED'
,p_attribute_14=>'Y'
,p_attribute_15=>'N'
,p_attribute_16=>'Y'
,p_attribute_18=>'USER_TASK_URLS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9121546339707081)
,p_name=>'P9_PRCS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17153327938580183)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9121995188707087)
,p_name=>'New'
,p_event_sequence=>10
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'document;'
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9122467150707088)
,p_event_id=>wwv_flow_imp.id(9121995188707087)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(17153327938580183)
);
end;
/
prompt --application/pages/page_00010
begin
wwv_flow_imp_page.create_page(
 p_id=>10
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Form Data'
,p_alias=>'FORMDATA'
,p_step_title=>'Form Data'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'All form data is stored as JSON in a single table. You can customize und run the following query to get the data you need for further processing.',
'<pre><code>',
'select tab.*',
'from   form_data fdta ,',
'       json_table ( fdta.fdta_content , ',
'         ''$'' ',
'         columns ( ',
'             street varchar2(100) path ''$.Address.Street'' ',
'             , city varchar2(100) path ''$.Address.City'' ',
'         ) ) tab',
'</code></pre>'))
,p_page_component_map=>'21'
,p_last_updated_by=>'C##DAMTHOR'
,p_last_upd_yyyymmddhh24miss=>'20241002073654'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7248665708691616)
,p_plug_name=>'Form Data Extraction'
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34453825801496693)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7248593227691615)
,p_plug_name=>'Form Data Extraction'
,p_parent_plug_id=>wwv_flow_imp.id(7248665708691616)
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34438790691496680)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_HELP_TEXT'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34586048953684671)
,p_plug_name=>'Form Data'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34468943637496698)
,p_plug_display_sequence=>30
,p_query_type=>'TABLE'
,p_query_table=>'FORM_P0010_VW'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Form Data'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5769899787608230)
,p_name=>'FDTA_INST_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FDTA_INST_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Business Reference'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6586718040341632)
,p_name=>'FDTA_TASK_BPMN_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FDTA_TASK_BPMN_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Task bpmn ID'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6586826002341633)
,p_name=>'FDTA_TEMPLATE_STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FDTA_TEMPLATE_STATIC_ID'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Template Static ID'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6587386728341638)
,p_name=>'FDTA_TASK_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FDTA_TASK_NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Task Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>800
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6976822996365528)
,p_name=>'FDTA_CREATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FDTA_CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Created By'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(7024014745938239)
,p_name=>'FDTA_TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FDTA_TEMPLATE_NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Template Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>600
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(36295566219583337)
,p_name=>'FDTA_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FDTA_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>30
,p_value_alignment=>'CENTER'
,p_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::P11_FDTA_ID:&FDTA_ID.'
,p_link_text=>'<img src="#IMAGE_PREFIX#app_ui/img/icons/apex-edit-view.png" class="apex-edit-view" alt="">'
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(36295859014583340)
,p_name=>'FDTA_CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FDTA_CREATED_ON'
,p_data_type=>'TIMESTAMP'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Created on'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>120
,p_value_alignment=>'CENTER'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_format_mask=>'DD-MON-YYYY HH24:MI'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(36295902926583341)
,p_name=>'FDTA_CONTENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FDTA_CONTENT'
,p_data_type=>'CLOB'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Content'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>32767
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(36991040284218904)
,p_name=>'FDTA_PROCESS_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FDTA_PROCESS_NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Process Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>600
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(36295467731583336)
,p_internal_uid=>36295467731583336
,p_is_editable=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(36307898519726553)
,p_interactive_grid_id=>wwv_flow_imp.id(36295467731583336)
,p_static_id=>'363079'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(36308023792726554)
,p_report_id=>wwv_flow_imp.id(36307898519726553)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6569258025307998)
,p_view_id=>wwv_flow_imp.id(36308023792726554)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(5769899787608230)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>142
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6826044690802719)
,p_view_id=>wwv_flow_imp.id(36308023792726554)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(6586718040341632)
,p_is_visible=>false
,p_is_frozen=>false
,p_width=>170
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6827033044802720)
,p_view_id=>wwv_flow_imp.id(36308023792726554)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(6586826002341633)
,p_is_visible=>false
,p_is_frozen=>false
,p_width=>153
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6839305871910058)
,p_view_id=>wwv_flow_imp.id(36308023792726554)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(6587386728341638)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>167
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7126055213226074)
,p_view_id=>wwv_flow_imp.id(36308023792726554)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(7024014745938239)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>165
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11474921660815235)
,p_view_id=>wwv_flow_imp.id(36308023792726554)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(6976822996365528)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>119.6
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(36308576383726560)
,p_view_id=>wwv_flow_imp.id(36308023792726554)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(36295566219583337)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>51
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(36311214777726569)
,p_view_id=>wwv_flow_imp.id(36308023792726554)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(36295859014583340)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>147
,p_sort_order=>1
,p_sort_direction=>'DESC'
,p_sort_nulls=>'FIRST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(36312166816726571)
,p_view_id=>wwv_flow_imp.id(36308023792726554)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(36295902926583341)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>613.8000015258789
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(37000301592239006)
,p_view_id=>wwv_flow_imp.id(36308023792726554)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(36991040284218904)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>266
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(34588541041684676)
,p_name=>'Edit Report - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(34586048953684671)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(34589040735684677)
,p_event_id=>wwv_flow_imp.id(34588541041684676)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(34586048953684671)
);
end;
/
prompt --application/pages/page_00011
begin
wwv_flow_imp_page.create_page(
 p_id=>11
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Form Data'
,p_alias=>'FORM-DATA'
,p_page_mode=>'MODAL'
,p_step_title=>'Form Data'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(34419794295496671)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'17'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241002145416'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4735909868149503)
,p_plug_name=>'Form'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>40
,p_plug_source_type=>'PLUGIN_JSON_REGION.UWESIMON.SELFHOST.E'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_read_only_when_type=>'ALWAYS'
,p_attribute_01=>'250'
,p_attribute_02=>'1'
,p_attribute_03=>'&P11_FDTA_TEMPLATE_CONTENT.'
,p_attribute_05=>'3'
,p_attribute_06=>'N'
,p_attribute_07=>'Y'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_attribute_10=>'P11_FDTA_CONTENT'
,p_attribute_11=>'floating'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34577621528684660)
,p_plug_name=>'Form Data'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34442442131496686)
,p_plug_display_sequence=>50
,p_query_type=>'TABLE'
,p_query_table=>'FORM_P0011_VW'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7249879479691628)
,p_name=>'P11_FDTA_TEMPLATE_CONTENT'
,p_source_data_type=>'CLOB'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(34577621528684660)
,p_item_source_plug_id=>wwv_flow_imp.id(34577621528684660)
,p_source=>'FDTA_TEMPLATE_CONTENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34577905189684661)
,p_name=>'P11_FDTA_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_is_query_only=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(34577621528684660)
,p_item_source_plug_id=>wwv_flow_imp.id(34577621528684660)
,p_source=>'FDTA_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34579589023684665)
,p_name=>'P11_FDTA_CONTENT'
,p_source_data_type=>'CLOB'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(34577621528684660)
,p_item_source_plug_id=>wwv_flow_imp.id(34577621528684660)
,p_source=>'FDTA_CONTENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34584691135684670)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(34577621528684660)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Form Data'
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_imp_page.create_page(
 p_id=>20
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Process Trigger'
,p_alias=>'PROCESS-TRIGGER'
,p_step_title=>'Process Trigger'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_help_text=>'Many processes are started by submitting a form. Here you can specify which form triggers the process.'
,p_page_component_map=>'21'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241001140335'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4736786414149511)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:t-ButtonRegion--slimPadding:margin-bottom-none'
,p_plug_template=>wwv_flow_imp.id(34443487668496687)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7248728927691617)
,p_plug_name=>'About this page'
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34453825801496693)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7248971633691619)
,p_plug_name=>'New'
,p_parent_plug_id=>wwv_flow_imp.id(7248728927691617)
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34438790691496680)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_HELP_TEXT'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34634087056930602)
,p_plug_name=>'Form Templates'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34468943637496698)
,p_plug_display_sequence=>20
,p_query_type=>'TABLE'
,p_query_table=>'FORM_P0020_VW'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IG'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Form Templates'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5768816920608220)
,p_name=>'EDIT'
,p_source_type=>'NONE'
,p_item_type=>'NATIVE_HTML_EXPRESSION'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>10
,p_value_alignment=>'CENTER'
,p_attribute_01=>'<span class="fa fa-edit" aria-hidden="true"></span>'
,p_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.::P21_FTPL_ID:&FTPL_ID.'
,p_use_as_row_header=>false
,p_enable_hide=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5770549074608237)
,p_name=>'FTPL_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FTPL_ID'
,p_data_type=>'NUMBER'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5770609866608238)
,p_name=>'SFTE_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SFTE_NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Simple Form'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>true
,p_max_length=>600
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5770711432608239)
,p_name=>'SFTE_STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SFTE_STATIC_ID'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Template Static ID'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>true
,p_max_length=>600
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5770816744608240)
,p_name=>'SFTE_CONTENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SFTE_CONTENT'
,p_data_type=>'CLOB'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Content'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>32767
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6974932111365509)
,p_name=>'FTPL_DGRM_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FTPL_DGRM_NAME'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Diagram Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>20
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>true
,p_max_length=>150
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6975011745365510)
,p_name=>'FTPL_DGRM_VERSION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FTPL_DGRM_VERSION'
,p_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Diagram Version'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>30
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>10
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(5312779710293141)
,p_internal_uid=>5312779710293141
,p_is_editable=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>true
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(5752426860273795)
,p_interactive_grid_id=>wwv_flow_imp.id(5312779710293141)
,p_static_id=>'57525'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(5752660803273795)
,p_report_id=>wwv_flow_imp.id(5752426860273795)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5826714242532158)
,p_view_id=>wwv_flow_imp.id(5752660803273795)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(5768816920608220)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>79
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6573513737329987)
,p_view_id=>wwv_flow_imp.id(5752660803273795)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(5770549074608237)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6574477163329989)
,p_view_id=>wwv_flow_imp.id(5752660803273795)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(5770609866608238)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>428
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6575356195329990)
,p_view_id=>wwv_flow_imp.id(5752660803273795)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(5770711432608239)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6576227350329991)
,p_view_id=>wwv_flow_imp.id(5752660803273795)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(5770816744608240)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11384942561579633)
,p_view_id=>wwv_flow_imp.id(5752660803273795)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(6974932111365509)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>567
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11385859004579634)
,p_view_id=>wwv_flow_imp.id(5752660803273795)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(6975011745365510)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>402.6
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34636546209930605)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4736786414149511)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'TOP'
,p_button_alignment=>'LEFT'
,p_button_redirect_url=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:21'
);
end;
/
prompt --application/pages/page_00021
begin
wwv_flow_imp_page.create_page(
 p_id=>21
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Template'
,p_alias=>'TEMPLATE'
,p_page_mode=>'MODAL'
,p_step_title=>'Template'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.apex_disabled',
'{',
'    opacity: unset !important;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'70%'
,p_protection_level=>'C'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page allows you to define which processes can be initiated using a specific inital form template.</p>',
'<p>Creating a new template must be done in the Flows for APEX application.</p>'))
,p_page_component_map=>'16'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241002161626'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4736653462149510)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:t-ButtonRegion--slimPadding:margin-bottom-none'
,p_plug_template=>wwv_flow_imp.id(34443487668496687)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6977676341365536)
,p_plug_name=>'Preview'
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7023208560938231)
,p_plug_name=>'Preview'
,p_parent_plug_id=>wwv_flow_imp.id(6977676341365536)
,p_region_template_options=>'#DEFAULT#:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34470894408496699)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_JSON_REGION.UWESIMON.SELFHOST.E'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_read_only_when_type=>'ALWAYS'
,p_attribute_01=>'250'
,p_attribute_02=>'SQL-Query'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sfte_content',
'from flow_simple_form_templates ',
'where sfte_id = :P21_SFTE_ID'))
,p_attribute_05=>'3'
,p_attribute_06=>'N'
,p_attribute_07=>'Y'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_attribute_10=>'P21_PREVIEW_CONTENT'
,p_attribute_11=>'floating'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7249009338691620)
,p_plug_name=>'About this page'
,p_region_template_options=>'#DEFAULT#:is-collapsed:t-Region--scrollBody'
,p_plug_template=>wwv_flow_imp.id(34453825801496693)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7024144375938240)
,p_plug_name=>'Help Text'
,p_parent_plug_id=>wwv_flow_imp.id(7249009338691620)
,p_region_template_options=>'#DEFAULT#:t-Alert--horizontal:t-Alert--defaultIcons:t-Alert--info:t-Alert--removeHeading js-removeLandmark'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34438790691496680)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_HELP_TEXT'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34628103539930594)
,p_plug_name=>'Template'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34442442131496686)
,p_plug_display_sequence=>50
,p_query_type=>'TABLE'
,p_query_table=>'FORM_P0021_VW'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34630615539930598)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4736653462149510)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34632205155930600)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(4736653462149510)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'P21_FTPL_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5313365091293147)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(4736653462149510)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'CREATE'
,p_button_condition=>'P21_FTPL_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7249935251691629)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4736653462149510)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:t-Button--danger'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'P21_FTPL_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34632558498930600)
,p_branch_name=>'Go To Page 20'
,p_branch_action=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''SAVE'' ',
'or',
':REQUEST = ''DELETE''',
'or',
':REQUEST = ''CREATE'''))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5312164539293135)
,p_name=>'P21_FTPL_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(34628103539930594)
,p_item_source_plug_id=>wwv_flow_imp.id(34628103539930594)
,p_source=>'FTPL_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5312403470293138)
,p_name=>'P21_SFTE_ID'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(34628103539930594)
,p_item_source_plug_id=>wwv_flow_imp.id(34628103539930594)
,p_prompt=>'Initial Form Template'
,p_source=>'SFTE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FORM_TEMPLATES_LOV'
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(34532592841496730)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6974760230365507)
,p_name=>'P21_FTPL_DGRM_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(34628103539930594)
,p_item_source_plug_id=>wwv_flow_imp.id(34628103539930594)
,p_prompt=>'Diagram Name'
,p_source=>'FTPL_DGRM_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dgrm_name as d',
'     , dgrm_name',
' from flow_startable_diagrams_vw'))
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(34532592841496730)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6974848199365508)
,p_name=>'P21_FTPL_DGRM_VERSION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(34628103539930594)
,p_item_source_plug_id=>wwv_flow_imp.id(34628103539930594)
,p_prompt=>'Diagram Version'
,p_source=>'FTPL_DGRM_VERSION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dgrm_version as d',
'     , dgrm_version',
' from flow_startable_diagrams_vw',
'where dgrm_name = :P21_FTPL_DGRM_NAME'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P21_FTPL_DGRM_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(34532284141496730)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_inline_help_text=>'Leave empty to use the same template for all diagram versions.'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7023325405938232)
,p_name=>'P21_PREVIEW_CONTENT'
,p_item_sequence=>60
,p_prompt=>'Preview Content'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(34532284141496730)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6976985756365529)
,p_name=>'P21_SFTE changed'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P21_SFTE_ID'
,p_condition_element=>'P21_SFTE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6977975302365539)
,p_event_id=>wwv_flow_imp.id(6976985756365529)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6977676341365536)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6977019705365530)
,p_event_id=>wwv_flow_imp.id(6976985756365529)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(7023208560938231)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6977827909365538)
,p_event_id=>wwv_flow_imp.id(6976985756365529)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6977676341365536)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6977223851365532)
,p_name=>'Hide Preview'
,p_event_sequence=>20
,p_condition_element=>'P21_SFTE_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6977790693365537)
,p_event_id=>wwv_flow_imp.id(6977223851365532)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6977676341365536)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34633447975930601)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create form Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    insert into form_templates(ftpl_sfte_id,ftpl_dgrm_name,ftpl_dgrm_version)',
'    values(:P21_SFTE_ID,:P21_FTPL_DGRM_NAME,:P21_FTPL_DGRM_VERSION);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(34632205155930600)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5313471981293148)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save form Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    update form_templates',
'       set ftpl_sfte_id      = :P21_SFTE_ID',
'         , ftpl_dgrm_name    = :P21_FTPL_DGRM_NAME',
'         , ftpl_dgrm_version = :P21_FTPL_DGRM_VERSION',
'     where ftpl_id = :P21_FTPL_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5313365091293147)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7250052015691630)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Form Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from form_templates',
'where ftpl_id = :P21_FTPL_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7249935251691629)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34633015183930601)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(34628103539930594)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Template'
);
end;
/
prompt --application/pages/page_09999
begin
wwv_flow_imp_page.create_page(
 p_id=>9999
,p_user_interface_id=>wwv_flow_imp.id(34556021658496761)
,p_name=>'Login Page'
,p_alias=>'LOGIN'
,p_step_title=>'Form Builder - Sign In'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(34421292387496672)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_page_component_map=>'12'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_upd_yyyymmddhh24miss=>'20241007061637'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34560118419496800)
,p_plug_name=>'Flows for APEX <br> Simple Process Starter'
,p_icon_css_classes=>'app-icon'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(34469502279496699)
,p_plug_display_sequence=>10
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34564802315496811)
,p_plug_name=>'Language Selector'
,p_parent_plug_id=>wwv_flow_imp.id(34560118419496800)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(34442442131496686)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'apex_lang.emit_language_selector_list;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34562994138496809)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(34560118419496800)
,p_button_name=>'LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(34533308970496733)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Sign In'
,p_button_position=>'NEXT'
,p_button_alignment=>'LEFT'
,p_grid_new_row=>'Y'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34560599115496802)
,p_name=>'P9999_USERNAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(34560118419496800)
,p_prompt=>'Username'
,p_placeholder=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>100
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(34531916603496729)
,p_item_icon_css_classes=>'fa-user'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34560980270496804)
,p_name=>'P9999_PASSWORD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(34560118419496800)
,p_prompt=>'Password'
,p_placeholder=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>40
,p_cMaxlength=>100
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(34531916603496729)
,p_item_icon_css_classes=>'fa-key'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34562099220496807)
,p_name=>'P9999_REMEMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(34560118419496800)
,p_prompt=>'Remember username'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'LOGIN_REMEMBER_USERNAME'
,p_lov=>'.'||wwv_flow_imp.id(34561202579496804)||'.'
,p_label_alignment=>'RIGHT'
,p_display_when=>'apex_authentication.persistent_cookies_enabled'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(34531916603496729)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If you select this checkbox, the application will save your username in a persistent browser cookie named "LOGIN_USERNAME_COOKIE".',
'When you go to the login page the next time,',
'the username field will be automatically populated with this value.',
'</p>',
'<p>',
'If you deselect this checkbox and your username is already saved in the cookie,',
'the application will overwrite it with an empty value.',
'You can also use your browser''s developer tools to completely remove the cookie.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34563772387496810)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.send_login_username_cookie (',
'    p_username => lower(:P9999_USERNAME),',
'    p_consent  => :P9999_REMEMBER = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34563316912496810)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.login(',
'    p_username => :P9999_USERNAME,',
'    p_password => :P9999_PASSWORD );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34564501327496811)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Page(s) Cache'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34564141984496810)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P9999_USERNAME := apex_authentication.get_login_username_cookie;',
':P9999_REMEMBER := case when :P9999_USERNAME is not null then ''Y'' end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/deployment/definition
begin
wwv_flow_imp_shared.create_install(
 p_id=>wwv_flow_imp.id(34615163631713876)
,p_deinstall_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'drop view form_p0005_vw;',
'drop view form_p0008_vw;',
'drop view form_p0010_vw;',
'drop view form_p0011_vw;',
'drop view form_p0020_vw;',
'drop view form_p0021_vw;',
'drop view form_templates_lov;',
'drop view form_started_processes_vw;',
'',
'drop table form_data cascade constraints;',
'drop table form_templates cascade constraints;',
'drop table form_instances cascade constraints;',
'',
'delete from flow_simple_form_templates',
'where sfte_static_id = ''order'';',
'',
'delete from flow_simple_form_templates',
'where sfte_static_id = ''process_order'';',
'',
'delete from flow_processes where prcs_dgrm_id in (select dgrm.dgrm_id from flow_diagrams dgrm where dgrm.dgrm_name = ''Order'');',
'',
'delete from flow_diagrams',
'where dgrm_name = ''Order'';',
''))
,p_required_free_kb=>100
,p_required_sys_privs=>'CREATE PROCEDURE:CREATE TABLE:CREATE TRIGGER:CREATE VIEW'
);
end;
/
prompt --application/deployment/install/install_init_table
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(6925649078094445)
,p_install_id=>wwv_flow_imp.id(34615163631713876)
,p_name=>'Init Table'
,p_sequence=>10
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'CREATE TABLE "FORM_TEMPLATES" ',
'(',
'    "FTPL_ID" NUMBER(*,0) GENERATED BY DEFAULT ON NULL AS IDENTITY MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE  NOKEEP  NOSCALE  NOT NULL ENABLE, ',
'	"FTPL_SFTE_ID" NUMBER NOT NULL ENABLE, ',
'	"FTPL_DGRM_NAME" VARCHAR2(150) NOT NULL ENABLE, ',
'	"FTPL_DGRM_VERSION" VARCHAR2(10)',
');',
'',
'CREATE UNIQUE INDEX "FORM_FTPL_IDX1" ON "FORM_TEMPLATES" ("FTPL_ID");',
'',
'ALTER TABLE "FORM_TEMPLATES" ADD CONSTRAINT "FORM_FTPL_PK" PRIMARY KEY ("FTPL_ID")',
'USING INDEX "FORM_FTPL_IDX1" ENABLE;',
'',
'ALTER TABLE "FORM_TEMPLATES" ADD CONSTRAINT "FORM_TEMPLATES_CON" FOREIGN KEY ("FTPL_SFTE_ID")',
'REFERENCES "FLOW_SIMPLE_FORM_TEMPLATES" ("SFTE_ID") ENABLE;',
'',
'',
'',
'CREATE TABLE "FORM_INSTANCES" ',
'(',
'    "INST_ID" NUMBER GENERATED BY DEFAULT ON NULL AS IDENTITY MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE  NOKEEP  NOSCALE  NOT NULL ENABLE, ',
'	"INST_FTPL_ID" NUMBER, ',
'	"INST_CREATED_ON" TIMESTAMP (6) DEFAULT systimestamp NOT NULL ENABLE',
');',
'',
'CREATE UNIQUE INDEX "FORM_INST_IDX1" ON "FORM_INSTANCES" ("INST_ID");',
'',
'ALTER TABLE "FORM_INSTANCES" ADD CONSTRAINT "FORM_INST_PK" PRIMARY KEY ("INST_ID")',
'USING INDEX "FORM_INST_IDX1" ENABLE;',
'',
'ALTER TABLE "FORM_INSTANCES" ADD CONSTRAINT "FORM_INSTANCES_FK" FOREIGN KEY ("INST_FTPL_ID")',
'REFERENCES "FORM_TEMPLATES" ("FTPL_ID") ON DELETE SET NULL ENABLE;',
'',
'',
'',
'CREATE TABLE "FORM_DATA"',
'(',
'    "FDTA_ID" NUMBER(*,0) GENERATED BY DEFAULT ON NULL AS IDENTITY MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE  NOKEEP  NOSCALE  NOT NULL ENABLE, ',
'	"FDTA_INST_ID" NUMBER(*,0) NOT NULL ENABLE, ',
'	"FDTA_CONTENT" CLOB NOT NULL ENABLE,',
'    "FDTA_PROCESS_NAME" VARCHAR2(150) NOT NULL ENABLE,',
'    "FDTA_TASK_NAME" VARCHAR2(200),',
'	"FDTA_TASK_BPMN_ID" VARCHAR2(50),',
'    "FDTA_TEMPLATE_NAME" VARCHAR2(150) NOT NULL ENABLE,',
'    "FDTA_TEMPLATE_STATIC_ID" VARCHAR2(150) NOT NULL ENABLE,',
'	"FDTA_TEMPLATE_CONTENT" CLOB NOT NULL ENABLE,',
'	"FDTA_CREATED_ON" TIMESTAMP (6) DEFAULT systimestamp NOT NULL ENABLE,',
'    "FDTA_CREATED_BY" VARCHAR2(255) NOT NULL ENABLE,',
'	CONSTRAINT "FORM_FDTA_CK" CHECK ("FDTA_CONTENT" IS JSON(STRICT)) ENABLE',
');',
'',
'CREATE UNIQUE INDEX "FORM_FDTA_IDX1" ON "FORM_DATA" ("FDTA_ID");',
'',
'ALTER TABLE "FORM_DATA" ADD CONSTRAINT "FORM_FDTA_PK" PRIMARY KEY ("FDTA_ID")',
'USING INDEX "FORM_FDTA_IDX1" ENABLE;',
'',
'ALTER TABLE "FORM_DATA" ADD CONSTRAINT "FORM_DATA_FK" FOREIGN KEY ("FDTA_INST_ID")',
'REFERENCES "FORM_INSTANCES" ("INST_ID") ENABLE;',
''))
);
wwv_flow_imp_shared.create_install_object(
 p_id=>wwv_flow_imp.id(6925756200094446)
,p_script_id=>wwv_flow_imp.id(6925649078094445)
,p_object_owner=>'#OWNER#'
,p_object_type=>'TABLE'
,p_object_name=>'FORM_DATA'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_updated_on=>to_date('20240911093449','YYYYMMDDHH24MISS')
,p_created_by=>'XUANBACH.LE@HYAND.COM'
,p_created_on=>to_date('20240911093449','YYYYMMDDHH24MISS')
);
wwv_flow_imp_shared.create_install_object(
 p_id=>wwv_flow_imp.id(6925970919094446)
,p_script_id=>wwv_flow_imp.id(6925649078094445)
,p_object_owner=>'#OWNER#'
,p_object_type=>'TABLE'
,p_object_name=>'FORM_INSTANCES'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_updated_on=>to_date('20240911093449','YYYYMMDDHH24MISS')
,p_created_by=>'XUANBACH.LE@HYAND.COM'
,p_created_on=>to_date('20240911093449','YYYYMMDDHH24MISS')
);
wwv_flow_imp_shared.create_install_object(
 p_id=>wwv_flow_imp.id(6926162634094446)
,p_script_id=>wwv_flow_imp.id(6925649078094445)
,p_object_owner=>'#OWNER#'
,p_object_type=>'TABLE'
,p_object_name=>'FORM_TEMPLATES'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_updated_on=>to_date('20240911093449','YYYYMMDDHH24MISS')
,p_created_by=>'XUANBACH.LE@HYAND.COM'
,p_created_on=>to_date('20240911093449','YYYYMMDDHH24MISS')
);
end;
/
prompt --application/deployment/install/install_init_view
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(6926503704097297)
,p_install_id=>wwv_flow_imp.id(34615163631713876)
,p_name=>'Init View'
,p_sequence=>20
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'CREATE OR REPLACE FORCE EDITIONABLE VIEW "FORM_STARTED_PROCESSES_VW" ("PRCS_ID", "PRCS_NAME", "DGRM_ID", "DGRM_NAME", "DGRM_VERSION", "DGRM_STATUS", "PRCS_PRIORITY", "DGRM_CATEGORY", "PRCS_STATUS", "PRCS_INIT_TS", "PRCS_INIT_BY", "PRCS_START_TS", "PR'
||'CS_DUE_ON", "PRCS_COMPLETE_TS", "PRCS_LAST_UPDATE", "PRCS_LAST_UPDATE_BY", "PRCS_BUSINESS_REF") AS ',
'  select flow_inst.prcs_id',
'        ,flow_inst.prcs_name',
'        ,flow_inst.dgrm_id',
'        ,flow_inst.dgrm_name',
'        ,flow_inst.dgrm_version',
'        ,flow_inst.dgrm_status',
'        ,flow_inst.prcs_priority',
'        ,flow_inst.dgrm_category',
'        ,flow_inst.prcs_status',
'        ,flow_inst.prcs_init_ts',
'        ,flow_inst.prcs_init_by',
'        ,flow_inst.prcs_start_ts',
'        ,flow_inst.prcs_due_on',
'        ,flow_inst.prcs_complete_ts',
'        ,flow_inst.prcs_last_update',
'        ,flow_inst.prcs_last_update_by',
'        ,flow_inst.prcs_business_ref',
'    from flow_instances_vw flow_inst',
'    join flow_instance_variables_vw flow_vars',
'      on flow_inst.prcs_id = flow_vars.prov_prcs_id',
'   where prov_var_name = ''STARTED_FROM''',
'     and prov_var_vc2 = ''Simple Process Starter''',
';',
'',
'CREATE OR REPLACE FORCE EDITIONABLE VIEW "FORM_TEMPLATES_LOV" ("SFTE_ID", "SFTE_NAME", "SFTE_CONTENT") AS ',
'  select sfte_id',
'        ,sfte_name',
'        ,sfte_content',
'  from flow_simple_form_templates',
'with read only',
';',
'',
'CREATE OR REPLACE FORCE EDITIONABLE VIEW "FORM_P0005_VW" ("INST_ID", "INST_FTPL_ID", "FTPL_SFTE_ID", "FTPL_CONTENT", "PRCS_ID", "PRCS_STATUS", "DGRM_NAME", "PRCS_NAME", "FDTA_ID", "PRCS_INIT_TS", "PRCS_INIT_BY") AS ',
'  select form_inst.inst_id',
'        ,form_inst.inst_ftpl_id',
'        ,ft.ftpl_sfte_id',
'        ,sfte.sfte_content as ftpl_content',
'        ,form_proc.prcs_id',
'        ,form_proc.prcs_status ',
'        ,form_proc.dgrm_name',
'        ,form_proc.prcs_name',
'        ,fdta.fdta_id',
'        ,form_proc.prcs_init_ts',
'        ,form_proc.prcs_init_by',
'  from form_instances form_inst',
'  left join form_started_processes_vw form_proc on form_inst.inst_id      = to_number(form_proc.prcs_business_ref default -1 on conversion error)',
'  left join form_data          fdta             on form_inst.inst_id      = fdta.fdta_inst_id and fdta_task_bpmn_id is null',
'  left join form_templates ft                   on form_inst.inst_ftpl_id = ft.ftpl_id',
'  left join flow_simple_form_templates sfte     on ft.ftpl_sfte_id        = sfte.sfte_id',
';',
'',
'CREATE OR REPLACE FORCE EDITIONABLE VIEW "FORM_P0008_VW" ("DGRM_ID", "DGRM_CONTENT") AS ',
'  select dgrm.dgrm_id',
'        ,dgrm.dgrm_content',
'  from flow_diagrams dgrm',
'with read only',
';',
'',
'CREATE OR REPLACE FORCE EDITIONABLE VIEW "FORM_P0010_VW" ("FDTA_ID", "FDTA_INST_ID", "FDTA_CONTENT", "FDTA_PROCESS_NAME", "FDTA_TASK_NAME", "FDTA_TASK_BPMN_ID", "FDTA_TEMPLATE_NAME", "FDTA_TEMPLATE_STATIC_ID", "FDTA_CREATED_ON", "FDTA_CREATED_BY") AS'
||' ',
'  select fdta_id',
'        ,fdta_inst_id',
'        ,fdta_content',
'        ,fdta_process_name',
'        ,fdta_task_name',
'        ,fdta_task_bpmn_id',
'        ,fdta_template_name',
'        ,fdta_template_static_id',
'        ,fdta_created_on',
'        ,fdta_created_by',
'  from form_data',
';',
'',
'CREATE OR REPLACE FORCE EDITIONABLE VIEW "FORM_P0011_VW" ("FDTA_ID", "FDTA_CONTENT", "FDTA_TEMPLATE_CONTENT") AS ',
'  select fdta.fdta_id',
'        ,fdta.fdta_content',
'        ,fdta.fdta_template_content',
'  from form_data fdta',
';',
'',
'CREATE OR REPLACE FORCE EDITIONABLE VIEW "FORM_P0020_VW" ("FTPL_ID", "FTPL_DGRM_NAME", "FTPL_DGRM_VERSION", "SFTE_NAME", "SFTE_STATIC_ID", "SFTE_CONTENT") AS ',
'  select ft.ftpl_id',
'      ,ft.ftpl_dgrm_name',
'      ,ft.ftpl_dgrm_version',
'      ,sfte.sfte_name',
'      ,sfte.sfte_static_id',
'      ,sfte.sfte_content',
'  from form_templates ft',
'  join flow_simple_form_templates sfte on sfte.sfte_id = ft.ftpl_sfte_id',
'with read only',
';',
'',
'CREATE OR REPLACE FORCE EDITIONABLE VIEW "FORM_P0021_VW" ("FTPL_ID", "FTPL_DGRM_NAME", "FTPL_DGRM_VERSION", "SFTE_ID", "SFTE_CONTENT") AS ',
'  select ft.ftpl_id',
'        ,ft.ftpl_dgrm_name',
'        ,ft.ftpl_dgrm_version',
'        ,sfte_id',
'        ,sfte.sfte_content',
'  from form_templates ft',
'  join flow_simple_form_templates sfte on sfte.sfte_id = ft.ftpl_sfte_id',
'with read only',
';'))
);
wwv_flow_imp_shared.create_install_object(
 p_id=>wwv_flow_imp.id(6926643082097297)
,p_script_id=>wwv_flow_imp.id(6926503704097297)
,p_object_owner=>'#OWNER#'
,p_object_type=>'VIEW'
,p_object_name=>'FORM_P0005_VW'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_updated_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
,p_created_by=>'XUANBACH.LE@HYAND.COM'
,p_created_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
);
wwv_flow_imp_shared.create_install_object(
 p_id=>wwv_flow_imp.id(7331263634591766)
,p_script_id=>wwv_flow_imp.id(6926503704097297)
,p_object_owner=>'#OWNER#'
,p_object_type=>'VIEW'
,p_object_name=>'FORM_P0008_VW'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_updated_on=>to_date('20240918093742','YYYYMMDDHH24MISS')
,p_created_by=>'XUANBACH.LE@HYAND.COM'
,p_created_on=>to_date('20240918093742','YYYYMMDDHH24MISS')
);
wwv_flow_imp_shared.create_install_object(
 p_id=>wwv_flow_imp.id(6926805298097297)
,p_script_id=>wwv_flow_imp.id(6926503704097297)
,p_object_owner=>'#OWNER#'
,p_object_type=>'VIEW'
,p_object_name=>'FORM_P0010_VW'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_updated_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
,p_created_by=>'XUANBACH.LE@HYAND.COM'
,p_created_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
);
wwv_flow_imp_shared.create_install_object(
 p_id=>wwv_flow_imp.id(6927058853097297)
,p_script_id=>wwv_flow_imp.id(6926503704097297)
,p_object_owner=>'#OWNER#'
,p_object_type=>'VIEW'
,p_object_name=>'FORM_P0011_VW'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_updated_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
,p_created_by=>'XUANBACH.LE@HYAND.COM'
,p_created_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
);
wwv_flow_imp_shared.create_install_object(
 p_id=>wwv_flow_imp.id(6927234824097297)
,p_script_id=>wwv_flow_imp.id(6926503704097297)
,p_object_owner=>'#OWNER#'
,p_object_type=>'VIEW'
,p_object_name=>'FORM_P0020_VW'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_updated_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
,p_created_by=>'XUANBACH.LE@HYAND.COM'
,p_created_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
);
wwv_flow_imp_shared.create_install_object(
 p_id=>wwv_flow_imp.id(6927406651097297)
,p_script_id=>wwv_flow_imp.id(6926503704097297)
,p_object_owner=>'#OWNER#'
,p_object_type=>'VIEW'
,p_object_name=>'FORM_P0021_VW'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_updated_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
,p_created_by=>'XUANBACH.LE@HYAND.COM'
,p_created_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
);
wwv_flow_imp_shared.create_install_object(
 p_id=>wwv_flow_imp.id(6927827588097297)
,p_script_id=>wwv_flow_imp.id(6926503704097297)
,p_object_owner=>'#OWNER#'
,p_object_type=>'VIEW'
,p_object_name=>'FORM_TEMPLATES_LOV'
,p_last_updated_by=>'XUANBACH.LE@HYAND.COM'
,p_last_updated_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
,p_created_by=>'XUANBACH.LE@HYAND.COM'
,p_created_on=>to_date('20240911093517','YYYYMMDDHH24MISS')
);
wwv_flow_imp_shared.create_install_object(
 p_id=>wwv_flow_imp.id(15812850058366126)
,p_script_id=>wwv_flow_imp.id(6926503704097297)
,p_object_owner=>'#OWNER#'
,p_object_type=>'VIEW'
,p_object_name=>'FORM_STARTED_PROCESSES_VW'
,p_last_updated_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_last_updated_on=>to_date('20241007165326','YYYYMMDDHH24MISS')
,p_created_by=>'DENNIS.AMTHOR@HYAND.COM'
,p_created_on=>to_date('20241007165326','YYYYMMDDHH24MISS')
);
end;
/
prompt --application/deployment/install/install_init_bpmn
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(7387315020334343)
,p_install_id=>wwv_flow_imp.id(34615163631713876)
,p_name=>'Init BPMN'
,p_sequence=>30
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_dgrm_content clob;',
'begin',
'  l_dgrm_content := apex_string.join_clob(',
'    apex_t_varchar2(',
'      q''[<?xml version="1.0" encoding="UTF-8"?>]''',
'      ,q''[<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" xmlns:apex="https://flowsforapex.org" xmlns:dc="http://'
||'www.omg.org/spec/DD/20100524/DC" xmlns:di="http://www.omg.org/spec/DD/20100524/DI" id="Definitions_1wzb475" targetNamespace="http://bpmn.io/schema/b" exporter="Flows for APEX" exporterVersion="24.1.0">]''',
'      ,q''[  <bpmn:process id="Process_fd38np1r" isExecutable="false" apex:isStartable="true" apex:manualInput="false">]''',
'      ,q''[    <bpmn:startEvent id="Event_1xpz2xs" name="Submitted Order">]''',
'      ,q''[      <bpmn:outgoing>Flow_1ag2t99</bpmn:outgoing>]''',
'      ,q''[    </bpmn:startEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1ag2t99" sourceRef="Event_1xpz2xs" targetRef="Activity_0a0bkqs" />]''',
'      ,q''[    <bpmn:userTask id="Activity_0a0bkqs" name="Process Order" apex:type="apexSimpleForm" apex:manualInput="false">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:apexSimpleForm>]''',
'      ,q''[          <apex:applicationId>]'' || apex_application.g_flow_id || q''[</apex:applicationId>]''',
'      ,q''[          <apex:pageId>7</apex:pageId>]''',
'      ,q''[          <apex:pageItems>]''',
'      ,q''[            <apex:pageItem>]''',
'      ,q''[              <apex:itemName>PROCESS_ID</apex:itemName>]''',
'      ,q''[              <apex:itemValue>&amp;F4A$PROCESS_ID.</apex:itemValue>]''',
'      ,q''[            </apex:pageItem>]''',
'      ,q''[            <apex:pageItem>]''',
'      ,q''[              <apex:itemName>SUBFLOW_ID</apex:itemName>]''',
'      ,q''[              <apex:itemValue>&amp;F4A$SUBFLOW_ID.</apex:itemValue>]''',
'      ,q''[            </apex:pageItem>]''',
'      ,q''[            <apex:pageItem>]''',
'      ,q''[              <apex:itemName>STEP_KEY</apex:itemName>]''',
'      ,q''[              <apex:itemValue>&amp;F4A$STEP_KEY.</apex:itemValue>]''',
'      ,q''[            </apex:pageItem>]''',
'      ,q''[          </apex:pageItems>]''',
'      ,q''[          <apex:formTemplateItem>FORM_TEMPLATE_ITEM</apex:formTemplateItem>]''',
'      ,q''[          <apex:formTemplateId>process_order</apex:formTemplateId>]''',
'      ,q''[        </apex:apexSimpleForm>]''',
'      ,q''[        <apex:potentialGroups>]''',
'      ,q''[          <apex:expressionType>static</apex:expressionType>]''',
'      ,q''[          <apex:expression>ADMIN</apex:expression>]''',
'      ,q''[        </apex:potentialGroups>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1ag2t99</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_1fjuv49</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_1fjuv49" sourceRef="Activity_0a0bkqs" targetRef="Activity_1724tq8" apex:sequence="10" />]''',
'      ,q''[    <bpmn:endEvent id="Event_1r8d6u0" name="Order processed">]''',
'      ,q''[      <bpmn:incoming>Flow_095lm91</bpmn:incoming>]''',
'      ,q''[    </bpmn:endEvent>]''',
'      ,q''[    <bpmn:sequenceFlow id="Flow_095lm91" sourceRef="Activity_1724tq8" targetRef="Event_1r8d6u0" apex:sequence="10" />]''',
'      ,q''[    <bpmn:userTask id="Activity_1724tq8" name="Order Review" apex:type="apexApproval" apex:manualInput="true">]''',
'      ,q''[      <bpmn:extensionElements>]''',
'      ,q''[        <apex:apexApproval>]''',
'      ,q''[          <apex:applicationId>]'' || apex_application.g_flow_id || q''[</apex:applicationId>]''',
'      ,q''[          <apex:taskStaticId>APPROVAL</apex:taskStaticId>]''',
'      ,q''[          <apex:businessRef>&amp;F4A$BUSINESS_REF.</apex:businessRef>]''',
'      ,q''[          <apex:parameters>]''',
'      ,q''[            <apex:parameter>]''',
'      ,q''[              <apex:parStaticId>PROCESS_ID</apex:parStaticId>]''',
'      ,q''[              <apex:parDataType>String</apex:parDataType>]''',
'      ,q''[              <apex:parValue>&amp;F4A$PROCESS_ID.</apex:parValue>]''',
'      ,q''[            </apex:parameter>]''',
'      ,q''[          </apex:parameters>]''',
'      ,q''[          <apex:resultVariable>ORDER_REVIEW</apex:resultVariable>]''',
'      ,q''[        </apex:apexApproval>]''',
'      ,q''[      </bpmn:extensionElements>]''',
'      ,q''[      <bpmn:incoming>Flow_1fjuv49</bpmn:incoming>]''',
'      ,q''[      <bpmn:outgoing>Flow_095lm91</bpmn:outgoing>]''',
'      ,q''[    </bpmn:userTask>]''',
'      ,q''[  </bpmn:process>]''',
'      ,q''[  <bpmndi:BPMNDiagram id="BPMNDiagram_1">]''',
'      ,q''[    <bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_fd38np1r">]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1xpz2xs_di" bpmnElement="Event_1xpz2xs">]''',
'      ,q''[        <dc:Bounds x="222" y="182" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="200" y="225" width="81" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_18eqpj7_di" bpmnElement="Activity_0a0bkqs">]''',
'      ,q''[        <dc:Bounds x="310" y="160" width="100" height="80" />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Event_1r8d6u0_di" bpmnElement="Event_1r8d6u0">]''',
'      ,q''[        <dc:Bounds x="722" y="182" width="36" height="36" />]''',
'      ,q''[        <bpmndi:BPMNLabel>]''',
'      ,q''[          <dc:Bounds x="698" y="158" width="83" height="14" />]''',
'      ,q''[        </bpmndi:BPMNLabel>]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNShape id="Activity_09tpq3z_di" bpmnElement="Activity_1724tq8">]''',
'      ,q''[        <dc:Bounds x="500" y="160" width="100" height="80" />]''',
'      ,q''[        <bpmndi:BPMNLabel />]''',
'      ,q''[      </bpmndi:BPMNShape>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1ag2t99_di" bpmnElement="Flow_1ag2t99">]''',
'      ,q''[        <di:waypoint x="258" y="200" />]''',
'      ,q''[        <di:waypoint x="310" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_1fjuv49_di" bpmnElement="Flow_1fjuv49">]''',
'      ,q''[        <di:waypoint x="410" y="200" />]''',
'      ,q''[        <di:waypoint x="500" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[      <bpmndi:BPMNEdge id="Flow_095lm91_di" bpmnElement="Flow_095lm91">]''',
'      ,q''[        <di:waypoint x="600" y="200" />]''',
'      ,q''[        <di:waypoint x="722" y="200" />]''',
'      ,q''[      </bpmndi:BPMNEdge>]''',
'      ,q''[    </bpmndi:BPMNPlane>]''',
'      ,q''[  </bpmndi:BPMNDiagram>]''',
'      ,q''[</bpmn:definitions>]''',
'      ,q''[]''',
'  ));',
'  flow_diagram.upload_and_parse(',
'    pi_dgrm_name => ''Order'',',
'    pi_dgrm_version => ''0'',',
'    pi_dgrm_category => ''Simple Process Starter'',',
'    pi_dgrm_content => l_dgrm_content',
');',
'end;',
'/'))
);
end;
/
prompt --application/deployment/install/install_init_template
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(7388276668500921)
,p_install_id=>wwv_flow_imp.id(34615163631713876)
,p_name=>'Init Template'
,p_sequence=>40
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sfte_content clob;',
'begin',
'  l_sfte_content := ''{',
'     "type":"object",',
'     "required":[',
'        "Product"',
'     ],',
'     "properties":{',
'        "Product":{',
'           "type":"string",',
'           "apex":{',
'              "label":"Product",',
'              "colSpan":"6"',
'           }',
'        },',
'        "Address":{',
'           "$ref":"#/$defs/Address_1"',
'        }',
'     },',
'     "$defs":{',
'        "Address_1":{',
'           "type":"object",',
'           "required":[',
'              "Name",',
'              "Street",',
'              "ZipCode",',
'              "City",',
'              "Country"',
'           ],',
'           "properties":{',
'              "Name":{',
'                 "type":"string",',
'                 "apex":{',
'                    "label":"Name",',
'                    "colSpan":"6"',
'                 }',
'              },',
'              "Street":{',
'                 "type":"string",',
'                 "apex":{',
'                    "label":"Street",',
'                    "colSpan":"6"',
'                 }',
'              },',
'              "ZipCode":{',
'                 "type":"string",',
'                 "apex":{',
'                    "label":"ZIP code",',
'                    "colSpan":"6"',
'                 }',
'              },',
'              "City":{',
'                 "type":"string",',
'                 "apex":{',
'                    "label":"City",',
'                    "colSpan":"6"',
'                 }',
'              },',
'              "Country":{',
'                 "type":"string",',
'                 "apex":{',
'                    "label":"Country",',
'                    "colSpan":"6"',
'                 }',
'              }',
'           }',
'        }',
'     }',
'  }'';',
'  ',
'  insert into flow_simple_form_templates (sfte_name, sfte_static_id, sfte_content)',
'  values (''Order'',''order'',l_sfte_content);',
'',
'  l_sfte_content := ''{',
'     "type": "object",',
'     "required": [',
'       "Cost Center"',
'     ],',
'     "properties": {',
'         "Cost Center": {',
'          "$ref": "#/$defs/Cost_Center"',
'         }',
'     },',
'     "$defs": {',
'       "Cost_Center":{',
'         "type": "object",',
'         "required": [',
'           "Cost Center"',
'         ],',
'         "properties": {',
'           "Cost Center": {',
'             "type": "string",',
'             "apex": {',
'               "label": "Cost Center",',
'               "colSpan": "6"',
'             }',
'           }',
'         }',
'       }',
'     }',
'  }'';',
'',
'  insert into flow_simple_form_templates (sfte_name, sfte_static_id, sfte_content)',
'  values (''Process Order'',''process_order'',l_sfte_content);',
'end;',
'/'))
);
end;
/
prompt --application/deployment/install/install_init_form
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(10547081448787449)
,p_install_id=>wwv_flow_imp.id(34615163631713876)
,p_name=>'Init Form'
,p_sequence=>50
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_sfte_id flow_simple_form_templates.sfte_id%type;',
'begin',
'',
'  select sfte_id',
'    into l_sfte_id',
'    from flow_simple_form_templates',
'   where 1 = 1',
'     and sfte_static_id = ''order'';',
'',
'  insert into form_templates(ftpl_dgrm_name, ftpl_dgrm_version, ftpl_sfte_id)',
'  values(''Order'',0,l_sfte_id);',
'',
'end;'))
);
end;
/
prompt --application/deployment/install/install_set_role
begin
wwv_flow_imp_shared.create_install_script(
 p_id=>wwv_flow_imp.id(15790280370269418)
,p_install_id=>wwv_flow_imp.id(34615163631713876)
,p_name=>'Set Role'
,p_sequence=>60
,p_script_type=>'INSTALL'
,p_script_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN',
'    APEX_ACL.REPLACE_USER_ROLES',
'    ( p_application_id  => apex_application.g_flow_id',
'    , p_user_name       => apex_application.g_user',
'    , p_role_static_ids => apex_t_varchar2(''ADMIN'')',
'    );',
'END;'))
);
end;
/
prompt --application/deployment/checks
begin
wwv_flow_imp_shared.create_install_check(
 p_id=>wwv_flow_imp.id(6631575124517238)
,p_install_id=>wwv_flow_imp.id(34615163631713876)
,p_name=>'Check Version of Flows for APEX  24.1'
,p_sequence=>10
,p_check_type=>'FUNCTION_BODY'
,p_check_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'  l_check_success          boolean:= false;',
'  l_flows_found            number;',
'  l_flows_actual_version   varchar2(10 char);',
'  c_flows_required_version varchar2(10 char) := ''24.1'';',
'',
'begin',
'  -- check if package exists',
'  select count(*)',
'    into l_flows_found ',
'    from user_procedures uprc',
'   where uprc.object_name = ''FLOW_CONSTANTS_PKG''',
'     and uprc.procedure_name is null',
'       ;',
'',
'  if l_flows_found = 1',
'  then',
'    -- check if correct version is installed',
'    execute immediate ''begin :version := substr(flow_constants_pkg.gc_version, 1, 4); end;'' using out l_flows_actual_version;',
' ',
'    if l_flows_actual_version = c_flows_required_version',
'    then',
'      l_check_success := true;',
'    else',
'      l_check_success := false;',
'    end if;',
'',
'  else',
'    l_check_success := false;',
'  end if;',
'',
'  return l_check_success;',
'',
'exception',
'  when others',
'  then',
'    return l_check_success;',
'end;'))
,p_check_condition2=>'PLSQL'
,p_failure_message=>'This application does not support this version of Flow for APEX'
);
end;
/
prompt --application/deployment/buildoptions
begin
null;
end;
/
prompt --application/end_environment
begin
wwv_flow_imp.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
